(set-info :smt-lib-version 2.6)
(set-logic LRA)
(set-info :source |
Generated by: Eryk Kopczynski  erykk@mimuw.edu.pl
Generated on: 20160927
Generator: LOIS, http://www.mimuw.edu.pl/~erykk/lois/
Application: LOIS is a C++ library allowing iterating through certain infinite sets, in finite time. The resulting language has an intuitive semantics, corresponding to execution of infinitely many threads in parallel. This allows to merge the power of abstract mathematical constructions into imperative programming. Infinite sets are internally represented using first order formulas over some underlying logical structure. To effectively handle such sets, we use and implement SMT solvers for various first order theories. LOIS has applications in education, and in verification of infinite state systems. This is a technical documentation of LOIS, describing how to write programs using it. 
Target solver: CVC4, z3
Additional information: At the time when LOIS was presented at the SMT 2016 workshop, the SMT solvers we checked were much worse than the internal solver in LOIS, they failed on many queries. Today we have checked the newest nightly build of CVC4, and its performance is only slightly lower than internal. The newest Z3 from the GitHub repository is apparently still unable to solve some queries, though.
|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")
(define-fun min ((a Real) (b Real)) Real (ite (<= a b) a b))
(define-fun max ((a Real) (b Real)) Real (ite (>= a b) a b))
(push 1)
  (declare-const ?b Real)
  (push 1)
    (declare-const ?a Real)
    (push 1)
      (declare-const ?c Real)
      (push 1)
        (assert
          (and (and (> ?a ?b)
              (> ?c ?a)
              )
            (> ?b ?c)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (or (or (>= ?b ?a)
              (>= ?a ?c)
              )
            (>= ?c ?b)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (> ?a ?b)
            (> ?c ?a)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (or (>= ?b ?a)
            (>= ?a ?c)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (> ?a ?c)
            (> ?b ?a)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (or (>= ?c ?a)
            (>= ?a ?b)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (> ?b ?a)
            (> ?c ?b)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (or (>= ?a ?b)
            (>= ?b ?c)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (> ?b ?c)
            (> ?a ?b)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (or (>= ?c ?b)
            (>= ?b ?a)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (> ?c ?b)
            (> ?a ?c)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (or (>= ?b ?c)
            (>= ?c ?a)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (> ?c ?a)
            (> ?b ?c)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (or (>= ?a ?c)
            (>= ?c ?b)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (assert
            (and (>= ?b ?a)
              (>= ?b ?c)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (assert
            (and (>= ?a ?b)
              (>= ?a ?c)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (assert
            (and (>= ?c ?b)
              (>= ?c ?a)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (and (>= ?b ?a)
            (>= ?b ?c)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (>= ?a ?b)
            (>= ?a ?c)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (>= ?c ?b)
            (>= ?c ?a)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (>= ?b ?a)
            (>= ?b ?c)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (>= ?a ?b)
            (>= ?a ?c)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (>= ?c ?b)
            (>= ?c ?a)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?d Real)
        (push 1)
          (assert
            (and (and (>= ?d ?b)
                (>= ?d ?a)
                )
              (>= ?d ?c)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?e Real)
        (assert
          (and (and (>= ?e ?b)
              (>= ?e ?a)
              )
            (>= ?e ?c)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?f Real)
        (assert
          (and (and (>= ?f ?b)
              (>= ?f ?a)
              )
            (>= ?f ?c)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?g Real)
          (assert
            (and (and (>= ?g ?b)
                (>= ?g ?a)
                )
              (>= ?g ?c)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (forall ((?g Real) )(or (or (or (> ?b ?g)
                    (> ?a ?g)
                    )
                  (> ?c ?g)
                  )
                (>= ?g ?f)
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?h Real)
        (assert
          (and (forall ((?g Real) )(or (or (or (> ?b ?g)
                    (> ?a ?g)
                    )
                  (> ?c ?g)
                  )
                (>= ?g ?h)
                )
              )
            (and (and (>= ?h ?b)
                (>= ?h ?a)
                )
              (>= ?h ?c)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?i Real)
        (assert
          (and (forall ((?g Real) )(or (or (or (> ?b ?g)
                    (> ?a ?g)
                    )
                  (> ?c ?g)
                  )
                (>= ?g ?i)
                )
              )
            (and (and (>= ?i ?b)
                (>= ?i ?a)
                )
              (>= ?i ?c)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?j Real)
        (assert
          (and (forall ((?g Real) )(or (or (or (> ?b ?g)
                    (> ?a ?g)
                    )
                  (> ?c ?g)
                  )
                (>= ?g ?j)
                )
              )
            (and (and (>= ?j ?b)
                (>= ?j ?a)
                )
              (>= ?j ?c)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?k Real)
        (assert
          (and (forall ((?g Real) )(or (or (or (> ?b ?g)
                    (> ?a ?g)
                    )
                  (> ?c ?g)
                  )
                (>= ?g ?k)
                )
              )
            (and (and (>= ?k ?b)
                (>= ?k ?a)
                )
              (>= ?k ?c)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?l Real)
            (assert
              (and (forall ((?g Real) )(or (or (or (> ?b ?g)
                        (> ?a ?g)
                        )
                      (> ?c ?g)
                      )
                    (>= ?g ?l)
                    )
                  )
                (and (and (>= ?l ?b)
                    (>= ?l ?a)
                    )
                  (>= ?l ?c)
                  )
                )
              )
(set-info :status unknown)
            (check-sat)
            (push 1)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (assert
                (not (= ?l ?k))
                )
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (and (>= ?b ?a)
            (>= ?b ?c)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (>= ?a ?b)
            (>= ?a ?c)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (>= ?c ?b)
            (>= ?c ?a)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?m Real)
        (assert
          (and (forall ((?g Real) )(or (or (or (> ?b ?g)
                    (> ?a ?g)
                    )
                  (> ?c ?g)
                  )
                (>= ?g ?m)
                )
              )
            (and (and (>= ?m ?b)
                (>= ?m ?a)
                )
              (>= ?m ?c)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (>= ?b ?a)
            (>= ?b ?c)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?n Real)
          (assert
            (and (forall ((?g Real) )(or (or (or (> ?b ?g)
                      (> ?a ?g)
                      )
                    (> ?c ?g)
                    )
                  (>= ?g ?n)
                  )
                )
              (and (and (>= ?n ?b)
                  (>= ?n ?a)
                  )
                (>= ?n ?c)
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (and (>= ?a ?b)
            (>= ?a ?c)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?o Real)
          (assert
            (and (forall ((?g Real) )(or (or (or (> ?b ?g)
                      (> ?a ?g)
                      )
                    (> ?c ?g)
                    )
                  (>= ?g ?o)
                  )
                )
              (and (and (>= ?o ?b)
                  (>= ?o ?a)
                  )
                (>= ?o ?c)
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (and (>= ?c ?b)
            (>= ?c ?a)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?p Real)
          (assert
            (and (forall ((?g Real) )(or (or (or (> ?b ?g)
                      (> ?a ?g)
                      )
                    (> ?c ?g)
                    )
                  (>= ?g ?p)
                  )
                )
              (and (and (>= ?p ?b)
                  (>= ?p ?a)
                  )
                (>= ?p ?c)
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?q Real)
        (assert
          (and (forall ((?g Real) )(or (or (or (> ?b ?g)
                    (> ?a ?g)
                    )
                  (> ?c ?g)
                  )
                (>= ?g ?q)
                )
              )
            (and (and (>= ?q ?b)
                (>= ?q ?a)
                )
              (>= ?q ?c)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (assert
            (and (>= ?b ?a)
              (>= ?b ?c)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (and (>= ?a ?b)
              (>= ?a ?c)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (and (>= ?c ?b)
              (>= ?c ?a)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (and (forall ((?q Real) )(or (or (exists ((?g Real) )(and (and (and (>= ?g ?b)
                          (>= ?g ?a)
                          )
                        (>= ?g ?c)
                        )
                      (> ?q ?g)
                      )
                    )
                  (or (or (> ?b ?q)
                      (> ?a ?q)
                      )
                    (> ?c ?q)
                    )
                  )
                (or (or (and (and (>= ?b ?a)
                        (>= ?b ?c)
                        )
                      (= ?q ?b)
                      )
                    (and (and (>= ?a ?b)
                        (>= ?a ?c)
                        )
                      (= ?q ?a)
                      )
                    )
                  (and (and (>= ?c ?b)
                      (>= ?c ?a)
                      )
                    (= ?q ?c)
                    )
                  )
                )
              )
            (and (and (or (or (> ?a ?b)
                    (> ?c ?b)
                    )
                  (and (forall ((?g Real) )(or (or (or (> ?b ?g)
                            (> ?a ?g)
                            )
                          (> ?c ?g)
                          )
                        (>= ?g ?b)
                        )
                      )
                    (and (>= ?b ?a)
                      (>= ?b ?c)
                      )
                    )
                  )
                (or (or (> ?b ?a)
                    (> ?c ?a)
                    )
                  (and (forall ((?g Real) )(or (or (or (> ?b ?g)
                            (> ?a ?g)
                            )
                          (> ?c ?g)
                          )
                        (>= ?g ?a)
                        )
                      )
                    (and (>= ?a ?b)
                      (>= ?a ?c)
                      )
                    )
                  )
                )
              (or (or (> ?b ?c)
                  (> ?a ?c)
                  )
                (and (forall ((?g Real) )(or (or (or (> ?b ?g)
                          (> ?a ?g)
                          )
                        (> ?c ?g)
                        )
                      (>= ?g ?c)
                      )
                    )
                  (and (>= ?c ?b)
                    (>= ?c ?a)
                    )
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (or (exists ((?q Real) )(and (and (forall ((?g Real) )(or (or (or (> ?b ?g)
                          (> ?a ?g)
                          )
                        (> ?c ?g)
                        )
                      (>= ?g ?q)
                      )
                    )
                  (and (and (>= ?q ?b)
                      (>= ?q ?a)
                      )
                    (>= ?q ?c)
                    )
                  )
                (and (and (or (or (> ?a ?b)
                        (> ?c ?b)
                        )
                      (not (= ?q ?b))
                      )
                    (or (or (> ?b ?a)
                        (> ?c ?a)
                        )
                      (not (= ?q ?a))
                      )
                    )
                  (or (or (> ?b ?c)
                      (> ?a ?c)
                      )
                    (not (= ?q ?c))
                    )
                  )
                )
              )
            (or (or (and (and (>= ?b ?a)
                    (>= ?b ?c)
                    )
                  (or (exists ((?g Real) )(and (and (and (>= ?g ?b)
                            (>= ?g ?a)
                            )
                          (>= ?g ?c)
                          )
                        (> ?b ?g)
                        )
                      )
                    (or (> ?a ?b)
                      (> ?c ?b)
                      )
                    )
                  )
                (and (and (>= ?a ?b)
                    (>= ?a ?c)
                    )
                  (or (exists ((?g Real) )(and (and (and (>= ?g ?b)
                            (>= ?g ?a)
                            )
                          (>= ?g ?c)
                          )
                        (> ?a ?g)
                        )
                      )
                    (or (> ?b ?a)
                      (> ?c ?a)
                      )
                    )
                  )
                )
              (and (and (>= ?c ?b)
                  (>= ?c ?a)
                  )
                (or (exists ((?g Real) )(and (and (and (>= ?g ?b)
                          (>= ?g ?a)
                          )
                        (>= ?g ?c)
                        )
                      (> ?c ?g)
                      )
                    )
                  (or (> ?b ?c)
                    (> ?a ?c)
                    )
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?r Real)
  (push 1)
    (declare-const ?s Real)
    (push 1)
      (assert
        (> ?s ?r)
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?t Real)
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (and (>= ?t ?r)
              (>= ?t ?s)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?u Real)
        (assert
          (and (>= ?u ?r)
            (>= ?u ?s)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?v Real)
        (assert
          (and (>= ?v ?r)
            (>= ?v ?s)
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?w Real)
          (assert
            (and (>= ?w ?r)
              (>= ?w ?s)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (forall ((?w Real) )(or (or (> ?r ?w)
                  (> ?s ?w)
                  )
                (>= ?w ?v)
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?x Real)
        (assert
          (and (forall ((?w Real) )(or (or (> ?r ?w)
                  (> ?s ?w)
                  )
                (>= ?w ?x)
                )
              )
            (and (>= ?x ?r)
              (>= ?x ?s)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?y Real)
        (assert
          (and (forall ((?w Real) )(or (or (> ?r ?w)
                  (> ?s ?w)
                  )
                (>= ?w ?y)
                )
              )
            (and (>= ?y ?r)
              (>= ?y ?s)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?z Real)
        (assert
          (and (forall ((?w Real) )(or (or (> ?r ?w)
                  (> ?s ?w)
                  )
                (>= ?w ?z)
                )
              )
            (and (>= ?z ?r)
              (>= ?z ?s)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aa Real)
        (assert
          (and (forall ((?w Real) )(or (or (> ?r ?w)
                  (> ?s ?w)
                  )
                (>= ?w ?aa)
                )
              )
            (and (>= ?aa ?r)
              (>= ?aa ?s)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?ab Real)
            (assert
              (and (forall ((?w Real) )(or (or (> ?r ?w)
                      (> ?s ?w)
                      )
                    (>= ?w ?ab)
                    )
                  )
                (and (>= ?ab ?r)
                  (>= ?ab ?s)
                  )
                )
              )
(set-info :status unknown)
            (check-sat)
            (push 1)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (assert
                (not (= ?ab ?aa))
                )
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ac Real)
  (push 1)
    (declare-const ?ad Real)
    (push 1)
      (assert
        (> ?ad ?ac)
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?ae Real)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (assert
            (and (> ?ae ?ac)
              (> ?ad ?ae)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?af Real)
        (assert
          (and (> ?af ?ac)
            (> ?ad ?af)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ag Real)
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?ah Real)
          (assert
            (and (> ?ah ?ac)
              (> ?ad ?ah)
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (forall ((?ah Real) )(or (or (>= ?ac ?ah)
                  (>= ?ah ?ad)
                  )
                (>= ?ag ?ah)
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?ai Real)
        (assert
          (forall ((?ah Real) )(or (or (>= ?ac ?ah)
                (>= ?ah ?ad)
                )
              (>= ?ai ?ah)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aj Real)
        (assert
          (forall ((?ah Real) )(or (or (>= ?ac ?ah)
                (>= ?ah ?ad)
                )
              (>= ?aj ?ah)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?ak Real)
          (assert
            (forall ((?ah Real) )(or (or (>= ?ac ?ah)
                  (>= ?ah ?ad)
                  )
                (>= ?ak ?ah)
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (forall ((?ak Real) )(or (exists ((?ah Real) )(and (and (> ?ah ?ac)
                      (> ?ad ?ah)
                      )
                    (> ?ah ?ak)
                    )
                  )
                (>= ?ak ?aj)
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?al Real)
        (assert
          (and (forall ((?ak Real) )(or (exists ((?ah Real) )(and (and (> ?ah ?ac)
                      (> ?ad ?ah)
                      )
                    (> ?ah ?ak)
                    )
                  )
                (>= ?ak ?al)
                )
              )
            (forall ((?ah Real) )(or (or (>= ?ac ?ah)
                  (>= ?ah ?ad)
                  )
                (>= ?al ?ah)
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?am Real)
        (assert
          (and (forall ((?ak Real) )(or (exists ((?ah Real) )(and (and (> ?ah ?ac)
                      (> ?ad ?ah)
                      )
                    (> ?ah ?ak)
                    )
                  )
                (>= ?ak ?am)
                )
              )
            (forall ((?ah Real) )(or (or (>= ?ac ?ah)
                  (>= ?ah ?ad)
                  )
                (>= ?am ?ah)
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?an Real)
        (assert
          (and (forall ((?ak Real) )(or (exists ((?ah Real) )(and (and (> ?ah ?ac)
                      (> ?ad ?ah)
                      )
                    (> ?ah ?ak)
                    )
                  )
                (>= ?ak ?an)
                )
              )
            (forall ((?ah Real) )(or (or (>= ?ac ?ah)
                  (>= ?ah ?ad)
                  )
                (>= ?an ?ah)
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ao Real)
        (assert
          (and (forall ((?ak Real) )(or (exists ((?ah Real) )(and (and (> ?ah ?ac)
                      (> ?ad ?ah)
                      )
                    (> ?ah ?ak)
                    )
                  )
                (>= ?ak ?ao)
                )
              )
            (forall ((?ah Real) )(or (or (>= ?ac ?ah)
                  (>= ?ah ?ad)
                  )
                (>= ?ao ?ah)
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?ap Real)
            (assert
              (and (forall ((?ak Real) )(or (exists ((?ah Real) )(and (and (> ?ah ?ac)
                          (> ?ad ?ah)
                          )
                        (> ?ah ?ak)
                        )
                      )
                    (>= ?ak ?ap)
                    )
                  )
                (forall ((?ah Real) )(or (or (>= ?ac ?ah)
                      (>= ?ah ?ad)
                      )
                    (>= ?ap ?ah)
                    )
                  )
                )
              )
(set-info :status unknown)
            (check-sat)
            (push 1)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (assert
                (not (= ?ap ?ao))
                )
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aq Real)
  (push 1)
    (assert
      (forall ((?ar Real) )(>= ?aq ?ar)
        )
      )
(set-info :status unknown)
    (check-sat)
    (exit)

