(set-info :smt-lib-version 2.6)
(set-logic LRA)
(set-info :source |
Generated by: Eryk Kopczynski  erykk@mimuw.edu.pl
Generated on: 20160927
Generator: LOIS, http://www.mimuw.edu.pl/~erykk/lois/
Application: LOIS is a C++ library allowing iterating through certain infinite sets, in finite time. The resulting language has an intuitive semantics, corresponding to execution of infinitely many threads in parallel. This allows to merge the power of abstract mathematical constructions into imperative programming. Infinite sets are internally represented using first order formulas over some underlying logical structure. To effectively handle such sets, we use and implement SMT solvers for various first order theories. LOIS has applications in education, and in verification of infinite state systems. This is a technical documentation of LOIS, describing how to write programs using it. 
Target solver: CVC4, z3
Additional information: At the time when LOIS was presented at the SMT 2016 workshop, the SMT solvers we checked were much worse than the internal solver in LOIS, they failed on many queries. Today we have checked the newest nightly build of CVC4, and its performance is only slightly lower than internal. The newest Z3 from the GitHub repository is apparently still unable to solve some queries, though.
|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")
(define-fun min ((a Real) (b Real)) Real (ite (<= a b) a b))
(define-fun max ((a Real) (b Real)) Real (ite (>= a b) a b))
(push 1)
  (declare-const ?av Real)
  (push 1)
    (declare-const ?aw Real)
    (push 1)
      (assert
        (not (= ?av ?aw))
        )
      (push 1)
        (push 1)
          (declare-const ?ax Real)
          (declare-const ?ay Real)
          (declare-const ?az Real)
          (assert
            (not (= ?ax ?az))
            )
          (push 1)
            (assert
              (and (= ?az ?av)
                (= ?ay ?aw)
                )
              )
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?ba Real)
        (assert
          (not (= ?ba ?av))
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bb Real)
          (assert
            (not (= ?bb ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (exists ((?ba Real) )(and (not (= ?ba ?av))
              (or (not (= ?aw ?av))
                (not (= ?ba ?aw))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (assert
            (forall ((?ba Real) )(or (= ?ba ?av)
                (and (= ?aw ?av)
                  (= ?ba ?aw)
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (exists ((?ba Real) )(and (not (= ?ba ?av))
                (or (not (= ?aw ?av))
                  (not (= ?ba ?aw))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (exists ((?ba Real) )(and (not (= ?ba ?av))
              (or (not (= ?aw ?av))
                (not (= ?ba ?aw))
                )
              )
            )
          )
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bc Real)
          (assert
            (not (= ?bc ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bd Real)
          (declare-const ?be Real)
          (declare-const ?bf Real)
          (assert
            (not (= ?bd ?bf))
            )
(set-info :status unknown)
          (check-sat)
          (push 1)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?bg Real)
            (assert
              (not (= ?bg ?av))
              )
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (assert
              (or (and (= ?bf ?av)
                  (= ?be ?aw)
                  )
                (and (not (= ?be ?av))
                  (= ?bf ?aw)
                  )
                )
              )
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bh Real)
          (assert
            (not (= ?bh ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bi Real)
        (assert
          (not (= ?bi ?av))
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bj Real)
          (assert
            (not (= ?bj ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bk Real)
        (declare-const ?bl Real)
        (assert
          (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                  (= ?bl ?aw)
                  )
                (and (not (= ?bl ?av))
                  (= ?bf ?aw)
                  )
                )
              (not (= ?bk ?bf))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bm Real)
          (assert
            (not (= ?bm ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bn Real)
          (assert
            (not (= ?bn ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bo Real)
          (declare-const ?bp Real)
          (assert
            (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                    (= ?bp ?aw)
                    )
                  (and (not (= ?bp ?av))
                    (= ?bf ?aw)
                    )
                  )
                (not (= ?bo ?bf))
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bq Real)
        (assert
          (not (= ?bq ?av))
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?br Real)
          (assert
            (not (= ?br ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bs Real)
          (declare-const ?bt Real)
          (assert
            (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                    (= ?bt ?aw)
                    )
                  (and (not (= ?bt ?av))
                    (= ?bf ?aw)
                    )
                  )
                (not (= ?bs ?bf))
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (exists ((?bk Real) (?bl Real) )(and (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                      (= ?bl ?aw)
                      )
                    (and (not (= ?bl ?av))
                      (= ?bf ?aw)
                      )
                    )
                  (not (= ?bk ?bf))
                  )
                )
              (and (or (not (= ?bl ?av))
                  (not (= ?bk ?aw))
                  )
                (or (= ?bk ?av)
                  (not (= ?bl ?aw))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (assert
            (forall ((?bk Real) (?bl Real) )(or (forall ((?bf Real) )(or (and (or (not (= ?bf ?av))
                        (not (= ?bl ?aw))
                        )
                      (or (= ?bl ?av)
                        (not (= ?bf ?aw))
                        )
                      )
                    (= ?bk ?bf)
                    )
                  )
                (or (and (= ?bl ?av)
                    (= ?bk ?aw)
                    )
                  (and (not (= ?bk ?av))
                    (= ?bl ?aw)
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (exists ((?bk Real) (?bl Real) )(and (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                        (= ?bl ?aw)
                        )
                      (and (not (= ?bl ?av))
                        (= ?bf ?aw)
                        )
                      )
                    (not (= ?bk ?bf))
                    )
                  )
                (and (or (not (= ?bl ?av))
                    (not (= ?bk ?aw))
                    )
                  (or (= ?bk ?av)
                    (not (= ?bl ?aw))
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?bu Real)
        (assert
          (not (= ?bu ?av))
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (assert
            (forall ((?bk Real) (?bl Real) )(or (forall ((?bf Real) )(or (and (or (not (= ?bf ?av))
                        (not (= ?bl ?aw))
                        )
                      (or (= ?bl ?av)
                        (not (= ?bf ?aw))
                        )
                      )
                    (= ?bk ?bf)
                    )
                  )
                (or (and (= ?bl ?av)
                    (= ?bk ?aw)
                    )
                  (and (not (= ?bk ?av))
                    (= ?bl ?aw)
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (exists ((?bk Real) (?bl Real) )(and (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                        (= ?bl ?aw)
                        )
                      (and (not (= ?bl ?av))
                        (= ?bf ?aw)
                        )
                      )
                    (not (= ?bk ?bf))
                    )
                  )
                (and (or (not (= ?bl ?av))
                    (not (= ?bk ?aw))
                    )
                  (or (= ?bk ?av)
                    (not (= ?bl ?aw))
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (exists ((?bk Real) (?bl Real) )(and (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                      (= ?bl ?aw)
                      )
                    (and (not (= ?bl ?av))
                      (= ?bf ?aw)
                      )
                    )
                  (not (= ?bk ?bf))
                  )
                )
              (and (or (not (= ?bl ?av))
                  (not (= ?bk ?aw))
                  )
                (or (= ?bk ?av)
                  (not (= ?bl ?aw))
                  )
                )
              )
            )
          )
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bv Real)
          (assert
            (not (= ?bv ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?bw Real)
          (declare-const ?bx Real)
          (assert
            (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                    (= ?bx ?aw)
                    )
                  (and (not (= ?bx ?av))
                    (= ?bf ?aw)
                    )
                  )
                (not (= ?bw ?bf))
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?by Real)
          (declare-const ?bz Real)
          (declare-const ?ca Real)
          (assert
            (not (= ?by ?ca))
            )
(set-info :status unknown)
          (check-sat)
          (push 1)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?cb Real)
            (assert
              (not (= ?cb ?av))
              )
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?cc Real)
            (declare-const ?cd Real)
            (assert
              (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                      (= ?cd ?aw)
                      )
                    (and (not (= ?cd ?av))
                      (= ?bf ?aw)
                      )
                    )
                  (not (= ?cc ?bf))
                  )
                )
              )
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (assert
              (or (or (and (= ?ca ?av)
                    (= ?bz ?aw)
                    )
                  (and (not (= ?bz ?av))
                    (= ?ca ?aw)
                    )
                  )
                (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                        (= ?ca ?aw)
                        )
                      (and (not (= ?ca ?av))
                        (= ?bf ?aw)
                        )
                      )
                    (not (= ?bz ?bf))
                    )
                  )
                )
              )
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?ce Real)
          (assert
            (not (= ?ce ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?cf Real)
          (declare-const ?cg Real)
          (assert
            (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                    (= ?cg ?aw)
                    )
                  (and (not (= ?cg ?av))
                    (= ?bf ?aw)
                    )
                  )
                (not (= ?cf ?bf))
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?ch Real)
        (assert
          (not (= ?ch ?av))
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?ci Real)
          (assert
            (not (= ?ci ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?cj Real)
          (declare-const ?ck Real)
          (assert
            (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                    (= ?ck ?aw)
                    )
                  (and (not (= ?ck ?av))
                    (= ?bf ?aw)
                    )
                  )
                (not (= ?cj ?bf))
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?cl Real)
        (declare-const ?cm Real)
        (assert
          (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                  (= ?cm ?aw)
                  )
                (and (not (= ?cm ?av))
                  (= ?bf ?aw)
                  )
                )
              (not (= ?cl ?bf))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?cn Real)
          (assert
            (not (= ?cn ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?co Real)
          (declare-const ?cp Real)
          (assert
            (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                    (= ?cp ?aw)
                    )
                  (and (not (= ?cp ?av))
                    (= ?bf ?aw)
                    )
                  )
                (not (= ?co ?bf))
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?cq Real)
        (declare-const ?cr Real)
        (push 1)
          (declare-const ?cs Real)
          (assert
            (not (= ?cs ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?ct Real)
          (declare-const ?cu Real)
          (assert
            (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                    (= ?cu ?aw)
                    )
                  (and (not (= ?cu ?av))
                    (= ?bf ?aw)
                    )
                  )
                (not (= ?ct ?bf))
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?cv Real)
          (assert
            (not (= ?cv ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?cw Real)
          (declare-const ?cx Real)
          (assert
            (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                    (= ?cx ?aw)
                    )
                  (and (not (= ?cx ?av))
                    (= ?bf ?aw)
                    )
                  )
                (not (= ?cw ?bf))
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?cy Real)
        (assert
          (not (= ?cy ?av))
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?cz Real)
          (assert
            (not (= ?cz ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?da Real)
          (declare-const ?db Real)
          (assert
            (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                    (= ?db ?aw)
                    )
                  (and (not (= ?db ?av))
                    (= ?bf ?aw)
                    )
                  )
                (not (= ?da ?bf))
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?dc Real)
          (declare-const ?dd Real)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?de Real)
        (declare-const ?df Real)
        (assert
          (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                  (= ?df ?aw)
                  )
                (and (not (= ?df ?av))
                  (= ?bf ?aw)
                  )
                )
              (not (= ?de ?bf))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?dg Real)
          (assert
            (not (= ?dg ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?dh Real)
          (declare-const ?di Real)
          (assert
            (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                    (= ?di ?aw)
                    )
                  (and (not (= ?di ?av))
                    (= ?bf ?aw)
                    )
                  )
                (not (= ?dh ?bf))
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?dj Real)
          (declare-const ?dk Real)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (or (exists ((?cl Real) (?cm Real) )(and (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                        (= ?cm ?aw)
                        )
                      (and (not (= ?cm ?av))
                        (= ?bf ?aw)
                        )
                      )
                    (not (= ?cl ?bf))
                    )
                  )
                (and (and (or (not (= ?cm ?av))
                      (not (= ?cl ?aw))
                      )
                    (or (= ?cl ?av)
                      (not (= ?cm ?aw))
                      )
                    )
                  (forall ((?bf Real) )(or (and (or (not (= ?bf ?av))
                          (not (= ?cm ?aw))
                          )
                        (or (= ?cm ?av)
                          (not (= ?bf ?aw))
                          )
                        )
                      (= ?cl ?bf)
                      )
                    )
                  )
                )
              )
            (exists ((?cq Real) (?cr Real) )(and (and (or (not (= ?cr ?av))
                    (not (= ?cq ?aw))
                    )
                  (or (= ?cq ?av)
                    (not (= ?cr ?aw))
                    )
                  )
                (forall ((?bf Real) )(or (and (or (not (= ?bf ?av))
                        (not (= ?cr ?aw))
                        )
                      (or (= ?cr ?av)
                        (not (= ?bf ?aw))
                        )
                      )
                    (= ?cq ?bf)
                    )
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (assert
            (and (forall ((?cl Real) (?cm Real) )(or (forall ((?bf Real) )(or (and (or (not (= ?bf ?av))
                          (not (= ?cm ?aw))
                          )
                        (or (= ?cm ?av)
                          (not (= ?bf ?aw))
                          )
                        )
                      (= ?cl ?bf)
                      )
                    )
                  (or (or (and (= ?cm ?av)
                        (= ?cl ?aw)
                        )
                      (and (not (= ?cl ?av))
                        (= ?cm ?aw)
                        )
                      )
                    (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                            (= ?cm ?aw)
                            )
                          (and (not (= ?cm ?av))
                            (= ?bf ?aw)
                            )
                          )
                        (not (= ?cl ?bf))
                        )
                      )
                    )
                  )
                )
              (forall ((?cq Real) (?cr Real) )(or (or (and (= ?cr ?av)
                      (= ?cq ?aw)
                      )
                    (and (not (= ?cq ?av))
                      (= ?cr ?aw)
                      )
                    )
                  (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                          (= ?cr ?aw)
                          )
                        (and (not (= ?cr ?av))
                          (= ?bf ?aw)
                          )
                        )
                      (not (= ?cq ?bf))
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (or (exists ((?cl Real) (?cm Real) )(and (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                          (= ?cm ?aw)
                          )
                        (and (not (= ?cm ?av))
                          (= ?bf ?aw)
                          )
                        )
                      (not (= ?cl ?bf))
                      )
                    )
                  (and (and (or (not (= ?cm ?av))
                        (not (= ?cl ?aw))
                        )
                      (or (= ?cl ?av)
                        (not (= ?cm ?aw))
                        )
                      )
                    (forall ((?bf Real) )(or (and (or (not (= ?bf ?av))
                            (not (= ?cm ?aw))
                            )
                          (or (= ?cm ?av)
                            (not (= ?bf ?aw))
                            )
                          )
                        (= ?cl ?bf)
                        )
                      )
                    )
                  )
                )
              (exists ((?cq Real) (?cr Real) )(and (and (or (not (= ?cr ?av))
                      (not (= ?cq ?aw))
                      )
                    (or (= ?cq ?av)
                      (not (= ?cr ?aw))
                      )
                    )
                  (forall ((?bf Real) )(or (and (or (not (= ?bf ?av))
                          (not (= ?cr ?aw))
                          )
                        (or (= ?cr ?av)
                          (not (= ?bf ?aw))
                          )
                        )
                      (= ?cq ?bf)
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?dl Real)
        (assert
          (not (= ?dl ?av))
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (assert
            (and (forall ((?cl Real) (?cm Real) )(or (forall ((?bf Real) )(or (and (or (not (= ?bf ?av))
                          (not (= ?cm ?aw))
                          )
                        (or (= ?cm ?av)
                          (not (= ?bf ?aw))
                          )
                        )
                      (= ?cl ?bf)
                      )
                    )
                  (or (or (and (= ?cm ?av)
                        (= ?cl ?aw)
                        )
                      (and (not (= ?cl ?av))
                        (= ?cm ?aw)
                        )
                      )
                    (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                            (= ?cm ?aw)
                            )
                          (and (not (= ?cm ?av))
                            (= ?bf ?aw)
                            )
                          )
                        (not (= ?cl ?bf))
                        )
                      )
                    )
                  )
                )
              (forall ((?cq Real) (?cr Real) )(or (or (and (= ?cr ?av)
                      (= ?cq ?aw)
                      )
                    (and (not (= ?cq ?av))
                      (= ?cr ?aw)
                      )
                    )
                  (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                          (= ?cr ?aw)
                          )
                        (and (not (= ?cr ?av))
                          (= ?bf ?aw)
                          )
                        )
                      (not (= ?cq ?bf))
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (or (exists ((?cl Real) (?cm Real) )(and (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                          (= ?cm ?aw)
                          )
                        (and (not (= ?cm ?av))
                          (= ?bf ?aw)
                          )
                        )
                      (not (= ?cl ?bf))
                      )
                    )
                  (and (and (or (not (= ?cm ?av))
                        (not (= ?cl ?aw))
                        )
                      (or (= ?cl ?av)
                        (not (= ?cm ?aw))
                        )
                      )
                    (forall ((?bf Real) )(or (and (or (not (= ?bf ?av))
                            (not (= ?cm ?aw))
                            )
                          (or (= ?cm ?av)
                            (not (= ?bf ?aw))
                            )
                          )
                        (= ?cl ?bf)
                        )
                      )
                    )
                  )
                )
              (exists ((?cq Real) (?cr Real) )(and (and (or (not (= ?cr ?av))
                      (not (= ?cq ?aw))
                      )
                    (or (= ?cq ?av)
                      (not (= ?cr ?aw))
                      )
                    )
                  (forall ((?bf Real) )(or (and (or (not (= ?bf ?av))
                          (not (= ?cr ?aw))
                          )
                        (or (= ?cr ?av)
                          (not (= ?bf ?aw))
                          )
                        )
                      (= ?cq ?bf)
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?dm Real)
        (declare-const ?dn Real)
        (assert
          (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                  (= ?dn ?aw)
                  )
                (and (not (= ?dn ?av))
                  (= ?bf ?aw)
                  )
                )
              (not (= ?dm ?bf))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (assert
            (and (forall ((?cl Real) (?cm Real) )(or (forall ((?bf Real) )(or (and (or (not (= ?bf ?av))
                          (not (= ?cm ?aw))
                          )
                        (or (= ?cm ?av)
                          (not (= ?bf ?aw))
                          )
                        )
                      (= ?cl ?bf)
                      )
                    )
                  (or (or (and (= ?cm ?av)
                        (= ?cl ?aw)
                        )
                      (and (not (= ?cl ?av))
                        (= ?cm ?aw)
                        )
                      )
                    (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                            (= ?cm ?aw)
                            )
                          (and (not (= ?cm ?av))
                            (= ?bf ?aw)
                            )
                          )
                        (not (= ?cl ?bf))
                        )
                      )
                    )
                  )
                )
              (forall ((?cq Real) (?cr Real) )(or (or (and (= ?cr ?av)
                      (= ?cq ?aw)
                      )
                    (and (not (= ?cq ?av))
                      (= ?cr ?aw)
                      )
                    )
                  (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                          (= ?cr ?aw)
                          )
                        (and (not (= ?cr ?av))
                          (= ?bf ?aw)
                          )
                        )
                      (not (= ?cq ?bf))
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (assert
            (or (exists ((?cl Real) (?cm Real) )(and (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                          (= ?cm ?aw)
                          )
                        (and (not (= ?cm ?av))
                          (= ?bf ?aw)
                          )
                        )
                      (not (= ?cl ?bf))
                      )
                    )
                  (and (and (or (not (= ?cm ?av))
                        (not (= ?cl ?aw))
                        )
                      (or (= ?cl ?av)
                        (not (= ?cm ?aw))
                        )
                      )
                    (forall ((?bf Real) )(or (and (or (not (= ?bf ?av))
                            (not (= ?cm ?aw))
                            )
                          (or (= ?cm ?av)
                            (not (= ?bf ?aw))
                            )
                          )
                        (= ?cl ?bf)
                        )
                      )
                    )
                  )
                )
              (exists ((?cq Real) (?cr Real) )(and (and (or (not (= ?cr ?av))
                      (not (= ?cq ?aw))
                      )
                    (or (= ?cq ?av)
                      (not (= ?cr ?aw))
                      )
                    )
                  (forall ((?bf Real) )(or (and (or (not (= ?bf ?av))
                          (not (= ?cr ?aw))
                          )
                        (or (= ?cr ?av)
                          (not (= ?bf ?aw))
                          )
                        )
                      (= ?cq ?bf)
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (assert
          (or (exists ((?cl Real) (?cm Real) )(and (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                        (= ?cm ?aw)
                        )
                      (and (not (= ?cm ?av))
                        (= ?bf ?aw)
                        )
                      )
                    (not (= ?cl ?bf))
                    )
                  )
                (and (and (or (not (= ?cm ?av))
                      (not (= ?cl ?aw))
                      )
                    (or (= ?cl ?av)
                      (not (= ?cm ?aw))
                      )
                    )
                  (forall ((?bf Real) )(or (and (or (not (= ?bf ?av))
                          (not (= ?cm ?aw))
                          )
                        (or (= ?cm ?av)
                          (not (= ?bf ?aw))
                          )
                        )
                      (= ?cl ?bf)
                      )
                    )
                  )
                )
              )
            (exists ((?cq Real) (?cr Real) )(and (and (or (not (= ?cr ?av))
                    (not (= ?cq ?aw))
                    )
                  (or (= ?cq ?av)
                    (not (= ?cr ?aw))
                    )
                  )
                (forall ((?bf Real) )(or (and (or (not (= ?bf ?av))
                        (not (= ?cr ?aw))
                        )
                      (or (= ?cr ?av)
                        (not (= ?bf ?aw))
                        )
                      )
                    (= ?cq ?bf)
                    )
                  )
                )
              )
            )
          )
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?do Real)
          (assert
            (not (= ?do ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?dp Real)
          (declare-const ?dq Real)
          (assert
            (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                    (= ?dq ?aw)
                    )
                  (and (not (= ?dq ?av))
                    (= ?bf ?aw)
                    )
                  )
                (not (= ?dp ?bf))
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?dr Real)
          (declare-const ?ds Real)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?dt Real)
          (declare-const ?du Real)
          (declare-const ?dv Real)
          (assert
            (not (= ?dt ?dv))
            )
(set-info :status unknown)
          (check-sat)
          (push 1)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?dw Real)
            (assert
              (not (= ?dw ?av))
              )
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?dx Real)
            (declare-const ?dy Real)
            (assert
              (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                      (= ?dy ?aw)
                      )
                    (and (not (= ?dy ?av))
                      (= ?bf ?aw)
                      )
                    )
                  (not (= ?dx ?bf))
                  )
                )
              )
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
            (declare-const ?dz Real)
            (declare-const ?ea Real)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (push 1)
(set-info :status unknown)
            (check-sat)
            (pop 1)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?eb Real)
          (assert
            (not (= ?eb ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?ec Real)
          (declare-const ?ed Real)
          (assert
            (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                    (= ?ed ?aw)
                    )
                  (and (not (= ?ed ?av))
                    (= ?bf ?aw)
                    )
                  )
                (not (= ?ec ?bf))
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?ee Real)
        (assert
          (not (= ?ee ?av))
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?ef Real)
          (assert
            (not (= ?ef ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?eg Real)
          (declare-const ?eh Real)
          (assert
            (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                    (= ?eh ?aw)
                    )
                  (and (not (= ?eh ?av))
                    (= ?bf ?aw)
                    )
                  )
                (not (= ?eg ?bf))
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?ei Real)
          (declare-const ?ej Real)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?ek Real)
        (declare-const ?el Real)
        (assert
          (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                  (= ?el ?aw)
                  )
                (and (not (= ?el ?av))
                  (= ?bf ?aw)
                  )
                )
              (not (= ?ek ?bf))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?em Real)
          (assert
            (not (= ?em ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?en Real)
          (declare-const ?eo Real)
          (assert
            (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                    (= ?eo ?aw)
                    )
                  (and (not (= ?eo ?av))
                    (= ?bf ?aw)
                    )
                  )
                (not (= ?en ?bf))
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?ep Real)
          (declare-const ?eq Real)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?er Real)
        (declare-const ?es Real)
        (push 1)
          (declare-const ?et Real)
          (assert
            (not (= ?et ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?eu Real)
          (declare-const ?ev Real)
          (assert
            (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                    (= ?ev ?aw)
                    )
                  (and (not (= ?ev ?av))
                    (= ?bf ?aw)
                    )
                  )
                (not (= ?eu ?bf))
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?ew Real)
        (declare-const ?ex Real)
        (push 1)
          (declare-const ?ey Real)
          (assert
            (not (= ?ey ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?ez Real)
          (declare-const ?fa Real)
          (assert
            (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                    (= ?fa ?aw)
                    )
                  (and (not (= ?fa ?av))
                    (= ?bf ?aw)
                    )
                  )
                (not (= ?ez ?bf))
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?fb Real)
          (assert
            (not (= ?fb ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?fc Real)
          (declare-const ?fd Real)
          (assert
            (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                    (= ?fd ?aw)
                    )
                  (and (not (= ?fd ?av))
                    (= ?bf ?aw)
                    )
                  )
                (not (= ?fc ?bf))
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?fe Real)
        (assert
          (not (= ?fe ?av))
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?ff Real)
          (assert
            (not (= ?ff ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?fg Real)
          (declare-const ?fh Real)
          (assert
            (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                    (= ?fh ?aw)
                    )
                  (and (not (= ?fh ?av))
                    (= ?bf ?aw)
                    )
                  )
                (not (= ?fg ?bf))
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?fi Real)
          (declare-const ?fj Real)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?fk Real)
          (declare-const ?fl Real)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?fm Real)
        (declare-const ?fn Real)
        (assert
          (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                  (= ?fn ?aw)
                  )
                (and (not (= ?fn ?av))
                  (= ?bf ?aw)
                  )
                )
              (not (= ?fm ?bf))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?fo Real)
          (assert
            (not (= ?fo ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?fp Real)
          (declare-const ?fq Real)
          (assert
            (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                    (= ?fq ?aw)
                    )
                  (and (not (= ?fq ?av))
                    (= ?bf ?aw)
                    )
                  )
                (not (= ?fp ?bf))
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?fr Real)
          (declare-const ?fs Real)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?ft Real)
          (declare-const ?fu Real)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?fv Real)
        (declare-const ?fw Real)
        (push 1)
          (declare-const ?fx Real)
          (assert
            (not (= ?fx ?av))
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (push 1)
          (declare-const ?fy Real)
          (declare-const ?fz Real)
          (assert
            (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                    (= ?fz ?aw)
                    )
                  (and (not (= ?fz ?av))
                    (= ?bf ?aw)
                    )
                  )
                (not (= ?fy ?bf))
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (push 1)
        (declare-const ?ga Real)
        (assert
          (not (= ?ga ?av))
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?gb Real)
        (declare-const ?gc Real)
        (assert
          (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                  (= ?gc ?aw)
                  )
                (and (not (= ?gc ?av))
                  (= ?bf ?aw)
                  )
                )
              (not (= ?gb ?bf))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?gd Real)
        (assert
          (not (= ?gd ?av))
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ge Real)
        (declare-const ?gf Real)
        (assert
          (exists ((?bf Real) )(and (or (and (= ?bf ?av)
                  (= ?gf ?aw)
                  )
                (and (not (= ?gf ?av))
                  (= ?bf ?aw)
                  )
                )
              (not (= ?ge ?bf))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (exit)

