(set-info :smt-lib-version 2.6)
(set-logic LRA)
(set-info :source |
Generated by: Eryk Kopczynski  erykk@mimuw.edu.pl
Generated on: 20160927
Generator: LOIS, http://www.mimuw.edu.pl/~erykk/lois/
Application: LOIS is a C++ library allowing iterating through certain infinite sets, in finite time. The resulting language has an intuitive semantics, corresponding to execution of infinitely many threads in parallel. This allows to merge the power of abstract mathematical constructions into imperative programming. Infinite sets are internally represented using first order formulas over some underlying logical structure. To effectively handle such sets, we use and implement SMT solvers for various first order theories. LOIS has applications in education, and in verification of infinite state systems. This is a technical documentation of LOIS, describing how to write programs using it. 
Target solver: CVC4, z3
Additional information: At the time when LOIS was presented at the SMT 2016 workshop, the SMT solvers we checked were much worse than the internal solver in LOIS, they failed on many queries. Today we have checked the newest nightly build of CVC4, and its performance is only slightly lower than internal. The newest Z3 from the GitHub repository is apparently still unable to solve some queries, though.
|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")
(define-fun min ((a Real) (b Real)) Real (ite (<= a b) a b))
(define-fun max ((a Real) (b Real)) Real (ite (>= a b) a b))
(push 1)
  (declare-const ?gg Real)
  (push 1)
    (declare-const ?gh Real)
    (push 1)
      (declare-const ?gi Real)
      (push 1)
        (assert
          (or (or (= ?gg ?gh)
              (= ?gg ?gi)
              )
            (= ?gh ?gi)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?gj Real)
  (declare-const ?gk Real)
  (declare-const ?gl Real)
  (assert
    (or (or (= ?gl ?gk)
        (= ?gl ?gj)
        )
      (= ?gk ?gj)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?gm Real)
    (declare-const ?gn Real)
    (declare-const ?go Real)
    (assert
      (or (or (= ?go ?gn)
          (= ?go ?gm)
          )
        (= ?gn ?gm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?gp Real)
  (push 1)
    (declare-const ?gq Real)
    (declare-const ?gr Real)
    (declare-const ?gs Real)
    (assert
      (or (or (= ?gs ?gr)
          (= ?gs ?gq)
          )
        (= ?gr ?gq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?gt Real)
  (declare-const ?gu Real)
  (push 1)
    (declare-const ?gv Real)
    (declare-const ?gw Real)
    (declare-const ?gx Real)
    (assert
      (or (or (= ?gx ?gw)
          (= ?gx ?gv)
          )
        (= ?gw ?gv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?gy Real)
  (declare-const ?gz Real)
  (declare-const ?ha Real)
  (push 1)
    (declare-const ?hb Real)
    (declare-const ?hc Real)
    (declare-const ?hd Real)
    (assert
      (or (or (= ?hd ?hc)
          (= ?hd ?hb)
          )
        (= ?hc ?hb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (assert
      (and (and (not (= ?ha ?gz))
          (not (= ?ha ?gy))
          )
        (not (= ?gz ?gy))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?he Real)
    (declare-const ?hf Real)
    (declare-const ?hg Real)
    (assert
      (or (or (= ?hg ?hf)
          (= ?hg ?he)
          )
        (= ?hf ?he)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?hh Real)
  (declare-const ?hi Real)
  (declare-const ?hj Real)
  (assert
    (and (and (not (= ?hj ?hi))
        (not (= ?hj ?hh))
        )
      (not (= ?hi ?hh))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?hk Real)
    (declare-const ?hl Real)
    (declare-const ?hm Real)
    (assert
      (or (or (= ?hm ?hl)
          (= ?hm ?hk)
          )
        (= ?hl ?hk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?hn Real)
  (push 1)
    (declare-const ?ho Real)
    (declare-const ?hp Real)
    (declare-const ?hq Real)
    (assert
      (or (or (= ?hq ?hp)
          (= ?hq ?ho)
          )
        (= ?hp ?ho)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?hr Real)
  (declare-const ?hs Real)
  (push 1)
    (declare-const ?ht Real)
    (declare-const ?hu Real)
    (declare-const ?hv Real)
    (assert
      (or (or (= ?hv ?hu)
          (= ?hv ?ht)
          )
        (= ?hu ?ht)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?hw Real)
  (declare-const ?hx Real)
  (declare-const ?hy Real)
  (assert
    (and (and (not (= ?hy ?hx))
        (not (= ?hy ?hw))
        )
      (not (= ?hx ?hw))
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?hz Real)
    (declare-const ?ia Real)
    (declare-const ?ib Real)
    (assert
      (or (or (= ?ib ?ia)
          (= ?ib ?hz)
          )
        (= ?ia ?hz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?ic Real)
    (declare-const ?id Real)
    (declare-const ?ie Real)
    (assert
      (or (or (= ?ie ?id)
          (= ?ie ?ic)
          )
        (= ?id ?ic)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?if Real)
  (declare-const ?ig Real)
  (declare-const ?ih Real)
  (assert
    (or (or (= ?ih ?ig)
        (= ?ih ?if)
        )
      (= ?ig ?if)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?ii Real)
  (declare-const ?ij Real)
  (declare-const ?ik Real)
  (declare-const ?il Real)
  (assert
    (or (or (= ?ik ?ij)
        (= ?ik ?ii)
        )
      (= ?ij ?ii)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?im Real)
  (declare-const ?in Real)
  (declare-const ?io Real)
  (declare-const ?ip Real)
  (declare-const ?iq Real)
  (assert
    (or (or (= ?io ?in)
        (= ?io ?im)
        )
      (= ?in ?im)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?ir Real)
  (declare-const ?is Real)
  (declare-const ?it Real)
  (declare-const ?iu Real)
  (declare-const ?iv Real)
  (declare-const ?iw Real)
  (assert
    (and (or (or (= ?it ?is)
          (= ?it ?ir)
          )
        (= ?is ?ir)
        )
      (and (and (not (= ?iw ?iv))
          (not (= ?iw ?iu))
          )
        (not (= ?iv ?iu))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?ix Real)
  (declare-const ?iy Real)
  (declare-const ?iz Real)
  (assert
    (or (or (= ?iz ?iy)
        (= ?iz ?ix)
        )
      (= ?iy ?ix)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?ja Real)
    (declare-const ?jb Real)
    (declare-const ?jc Real)
    (assert
      (or (or (= ?jc ?jb)
          (= ?jc ?ja)
          )
        (= ?jb ?ja)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?jd Real)
  (push 1)
    (declare-const ?je Real)
    (declare-const ?jf Real)
    (declare-const ?jg Real)
    (assert
      (or (or (= ?jg ?jf)
          (= ?jg ?je)
          )
        (= ?jf ?je)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?jh Real)
  (declare-const ?ji Real)
  (push 1)
    (declare-const ?jj Real)
    (declare-const ?jk Real)
    (declare-const ?jl Real)
    (assert
      (or (or (= ?jl ?jk)
          (= ?jl ?jj)
          )
        (= ?jk ?jj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?jm Real)
  (declare-const ?jn Real)
  (declare-const ?jo Real)
  (push 1)
    (declare-const ?jp Real)
    (declare-const ?jq Real)
    (declare-const ?jr Real)
    (assert
      (or (or (= ?jr ?jq)
          (= ?jr ?jp)
          )
        (= ?jq ?jp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (assert
      (and (and (not (= ?jo ?jn))
          (not (= ?jo ?jm))
          )
        (not (= ?jn ?jm))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?js Real)
    (declare-const ?jt Real)
    (declare-const ?ju Real)
    (assert
      (or (or (= ?ju ?jt)
          (= ?ju ?js)
          )
        (= ?jt ?js)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?jv Real)
  (declare-const ?jw Real)
  (declare-const ?jx Real)
  (assert
    (and (and (not (= ?jx ?jw))
        (not (= ?jx ?jv))
        )
      (not (= ?jw ?jv))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?jy Real)
  (declare-const ?jz Real)
  (declare-const ?ka Real)
  (assert
    (or (or (= ?ka ?jz)
        (= ?ka ?jy)
        )
      (= ?jz ?jy)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kc Real)
    (declare-const ?kd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ke Real)
    (declare-const ?kf Real)
    (declare-const ?kg Real)
    (assert
      (and (and (not (= ?kg ?kf))
          (not (= ?kg ?ke))
          )
        (not (= ?kf ?ke))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?kh Real)
  (declare-const ?ki Real)
  (declare-const ?kj Real)
  (assert
    (or (or (= ?kj ?ki)
        (= ?kj ?kh)
        )
      (= ?ki ?kh)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?kk Real)
  (declare-const ?kl Real)
  (declare-const ?km Real)
  (declare-const ?kn Real)
  (assert
    (or (or (= ?kn ?km)
        (= ?kn ?kl)
        )
      (= ?km ?kl)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?ko Real)
  (declare-const ?kp Real)
  (declare-const ?kq Real)
  (declare-const ?kr Real)
  (declare-const ?ks Real)
  (assert
    (or (or (= ?ks ?kr)
        (= ?ks ?kq)
        )
      (= ?kr ?kq)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?kt Real)
  (declare-const ?ku Real)
  (declare-const ?kv Real)
  (declare-const ?kw Real)
  (declare-const ?kx Real)
  (declare-const ?ky Real)
  (assert
    (and (and (and (not (= ?kv ?ku))
          (not (= ?kv ?kt))
          )
        (not (= ?ku ?kt))
        )
      (or (or (= ?ky ?kx)
          (= ?ky ?kw)
          )
        (= ?kx ?kw)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?kz Real)
  (declare-const ?la Real)
  (declare-const ?lb Real)
  (assert
    (or (or (= ?lb ?la)
        (= ?lb ?kz)
        )
      (= ?la ?kz)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?lc Real)
  (declare-const ?ld Real)
  (declare-const ?le Real)
  (assert
    (or (or (= ?le ?ld)
        (= ?le ?lc)
        )
      (= ?ld ?lc)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?lf Real)
  (declare-const ?lg Real)
  (declare-const ?lh Real)
  (declare-const ?li Real)
  (assert
    (or (or (= ?li ?lh)
        (= ?li ?lg)
        )
      (= ?lh ?lg)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?lj Real)
  (declare-const ?lk Real)
  (declare-const ?ll Real)
  (declare-const ?lm Real)
  (declare-const ?ln Real)
  (assert
    (or (or (= ?ln ?lm)
        (= ?ln ?ll)
        )
      (= ?lm ?ll)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?lo Real)
  (declare-const ?lp Real)
  (declare-const ?lq Real)
  (declare-const ?lr Real)
  (declare-const ?ls Real)
  (declare-const ?lt Real)
  (assert
    (and (and (and (not (= ?lq ?lp))
          (not (= ?lq ?lo))
          )
        (not (= ?lp ?lo))
        )
      (or (or (= ?lt ?ls)
          (= ?lt ?lr)
          )
        (= ?ls ?lr)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?lu Real)
  (declare-const ?lv Real)
  (declare-const ?lw Real)
  (assert
    (or (or (= ?lw ?lv)
        (= ?lw ?lu)
        )
      (= ?lv ?lu)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?lx Real)
  (declare-const ?ly Real)
  (declare-const ?lz Real)
  (assert
    (or (or (= ?lz ?ly)
        (= ?lz ?lx)
        )
      (= ?ly ?lx)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?ma Real)
  (declare-const ?mb Real)
  (declare-const ?mc Real)
  (declare-const ?md Real)
  (assert
    (or (or (= ?mc ?mb)
        (= ?mc ?ma)
        )
      (= ?mb ?ma)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?me Real)
  (declare-const ?mf Real)
  (declare-const ?mg Real)
  (declare-const ?mh Real)
  (declare-const ?mi Real)
  (assert
    (or (or (= ?mg ?mf)
        (= ?mg ?me)
        )
      (= ?mf ?me)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?mj Real)
  (declare-const ?mk Real)
  (declare-const ?ml Real)
  (declare-const ?mm Real)
  (declare-const ?mn Real)
  (declare-const ?mo Real)
  (assert
    (and (or (or (= ?ml ?mk)
          (= ?ml ?mj)
          )
        (= ?mk ?mj)
        )
      (and (and (not (= ?mo ?mn))
          (not (= ?mo ?mm))
          )
        (not (= ?mn ?mm))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?mp Real)
  (declare-const ?mq Real)
  (declare-const ?mr Real)
  (assert
    (or (or (= ?mr ?mq)
        (= ?mr ?mp)
        )
      (= ?mq ?mp)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?ms Real)
  (declare-const ?mt Real)
  (declare-const ?mu Real)
  (assert
    (or (or (= ?mu ?mt)
        (= ?mu ?ms)
        )
      (= ?mt ?ms)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?mv Real)
  (declare-const ?mw Real)
  (declare-const ?mx Real)
  (declare-const ?my Real)
  (assert
    (or (or (= ?my ?mx)
        (= ?my ?mw)
        )
      (= ?mx ?mw)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?mz Real)
  (declare-const ?na Real)
  (declare-const ?nb Real)
  (declare-const ?nc Real)
  (declare-const ?nd Real)
  (assert
    (or (or (= ?nd ?nc)
        (= ?nd ?nb)
        )
      (= ?nc ?nb)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?ne Real)
  (declare-const ?nf Real)
  (declare-const ?ng Real)
  (declare-const ?nh Real)
  (declare-const ?ni Real)
  (declare-const ?nj Real)
  (assert
    (and (and (and (not (= ?ng ?nf))
          (not (= ?ng ?ne))
          )
        (not (= ?nf ?ne))
        )
      (or (or (= ?nj ?ni)
          (= ?nj ?nh)
          )
        (= ?ni ?nh)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?nk Real)
  (declare-const ?nl Real)
  (declare-const ?nm Real)
  (assert
    (or (or (= ?nm ?nl)
        (= ?nm ?nk)
        )
      (= ?nl ?nk)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?nn Real)
  (declare-const ?no Real)
  (declare-const ?np Real)
  (assert
    (or (or (= ?np ?no)
        (= ?np ?nn)
        )
      (= ?no ?nn)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?nq Real)
  (declare-const ?nr Real)
  (declare-const ?ns Real)
  (declare-const ?nt Real)
  (assert
    (or (or (= ?ns ?nr)
        (= ?ns ?nq)
        )
      (= ?nr ?nq)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?nu Real)
  (declare-const ?nv Real)
  (declare-const ?nw Real)
  (declare-const ?nx Real)
  (declare-const ?ny Real)
  (assert
    (or (or (= ?nw ?nv)
        (= ?nw ?nu)
        )
      (= ?nv ?nu)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?nz Real)
  (declare-const ?oa Real)
  (declare-const ?ob Real)
  (declare-const ?oc Real)
  (declare-const ?od Real)
  (declare-const ?oe Real)
  (assert
    (and (or (or (= ?ob ?oa)
          (= ?ob ?nz)
          )
        (= ?oa ?nz)
        )
      (and (and (not (= ?oe ?od))
          (not (= ?oe ?oc))
          )
        (not (= ?od ?oc))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?of Real)
  (declare-const ?og Real)
  (declare-const ?oh Real)
  (assert
    (or (or (= ?oh ?og)
        (= ?oh ?of)
        )
      (= ?og ?of)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?oi Real)
  (declare-const ?oj Real)
  (declare-const ?ok Real)
  (assert
    (or (or (= ?ok ?oj)
        (= ?ok ?oi)
        )
      (= ?oj ?oi)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?ol Real)
  (declare-const ?om Real)
  (declare-const ?on Real)
  (declare-const ?oo Real)
  (assert
    (or (or (= ?oo ?on)
        (= ?oo ?om)
        )
      (= ?on ?om)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?op Real)
  (declare-const ?oq Real)
  (declare-const ?or Real)
  (declare-const ?os Real)
  (declare-const ?ot Real)
  (assert
    (or (or (= ?ot ?os)
        (= ?ot ?or)
        )
      (= ?os ?or)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?ou Real)
  (declare-const ?ov Real)
  (declare-const ?ow Real)
  (declare-const ?ox Real)
  (declare-const ?oy Real)
  (declare-const ?oz Real)
  (assert
    (and (and (and (not (= ?ow ?ov))
          (not (= ?ow ?ou))
          )
        (not (= ?ov ?ou))
        )
      (or (or (= ?oz ?oy)
          (= ?oz ?ox)
          )
        (= ?oy ?ox)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?pa Real)
  (declare-const ?pb Real)
  (declare-const ?pc Real)
  (assert
    (or (or (= ?pc ?pb)
        (= ?pc ?pa)
        )
      (= ?pb ?pa)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?pd Real)
  (declare-const ?pe Real)
  (declare-const ?pf Real)
  (assert
    (or (or (= ?pf ?pe)
        (= ?pf ?pd)
        )
      (= ?pe ?pd)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?pg Real)
  (declare-const ?ph Real)
  (declare-const ?pi Real)
  (declare-const ?pj Real)
  (assert
    (or (or (= ?pi ?ph)
        (= ?pi ?pg)
        )
      (= ?ph ?pg)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?pk Real)
  (declare-const ?pl Real)
  (declare-const ?pm Real)
  (declare-const ?pn Real)
  (declare-const ?po Real)
  (assert
    (or (or (= ?pm ?pl)
        (= ?pm ?pk)
        )
      (= ?pl ?pk)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?pp Real)
  (declare-const ?pq Real)
  (declare-const ?pr Real)
  (declare-const ?ps Real)
  (declare-const ?pt Real)
  (declare-const ?pu Real)
  (assert
    (and (or (or (= ?pr ?pq)
          (= ?pr ?pp)
          )
        (= ?pq ?pp)
        )
      (and (and (not (= ?pu ?pt))
          (not (= ?pu ?ps))
          )
        (not (= ?pt ?ps))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?pv Real)
  (declare-const ?pw Real)
  (declare-const ?px Real)
  (assert
    (or (or (= ?px ?pw)
        (= ?px ?pv)
        )
      (= ?pw ?pv)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?py Real)
  (declare-const ?pz Real)
  (declare-const ?qa Real)
  (assert
    (or (or (= ?qa ?pz)
        (= ?qa ?py)
        )
      (= ?pz ?py)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?qb Real)
  (declare-const ?qc Real)
  (declare-const ?qd Real)
  (declare-const ?qe Real)
  (assert
    (or (or (= ?qe ?qd)
        (= ?qe ?qc)
        )
      (= ?qd ?qc)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?qf Real)
  (declare-const ?qg Real)
  (declare-const ?qh Real)
  (declare-const ?qi Real)
  (declare-const ?qj Real)
  (assert
    (or (or (= ?qj ?qi)
        (= ?qj ?qh)
        )
      (= ?qi ?qh)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?qk Real)
  (declare-const ?ql Real)
  (declare-const ?qm Real)
  (declare-const ?qn Real)
  (declare-const ?qo Real)
  (declare-const ?qp Real)
  (assert
    (and (and (and (not (= ?qm ?ql))
          (not (= ?qm ?qk))
          )
        (not (= ?ql ?qk))
        )
      (or (or (= ?qp ?qo)
          (= ?qp ?qn)
          )
        (= ?qo ?qn)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?qq Real)
  (declare-const ?qr Real)
  (declare-const ?qs Real)
  (assert
    (or (or (= ?qs ?qr)
        (= ?qs ?qq)
        )
      (= ?qr ?qq)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?qt Real)
  (declare-const ?qu Real)
  (declare-const ?qv Real)
  (assert
    (or (or (= ?qv ?qu)
        (= ?qv ?qt)
        )
      (= ?qu ?qt)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?qw Real)
  (declare-const ?qx Real)
  (declare-const ?qy Real)
  (declare-const ?qz Real)
  (assert
    (or (or (= ?qy ?qx)
        (= ?qy ?qw)
        )
      (= ?qx ?qw)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?ra Real)
  (declare-const ?rb Real)
  (declare-const ?rc Real)
  (declare-const ?rd Real)
  (declare-const ?re Real)
  (assert
    (or (or (= ?rc ?rb)
        (= ?rc ?ra)
        )
      (= ?rb ?ra)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?rf Real)
  (declare-const ?rg Real)
  (declare-const ?rh Real)
  (declare-const ?ri Real)
  (declare-const ?rj Real)
  (declare-const ?rk Real)
  (assert
    (and (or (or (= ?rh ?rg)
          (= ?rh ?rf)
          )
        (= ?rg ?rf)
        )
      (and (and (not (= ?rk ?rj))
          (not (= ?rk ?ri))
          )
        (not (= ?rj ?ri))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?rl Real)
  (declare-const ?rm Real)
  (declare-const ?rn Real)
  (assert
    (or (or (= ?rn ?rm)
        (= ?rn ?rl)
        )
      (= ?rm ?rl)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?ro Real)
  (declare-const ?rp Real)
  (declare-const ?rq Real)
  (assert
    (or (or (= ?rq ?rp)
        (= ?rq ?ro)
        )
      (= ?rp ?ro)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?rr Real)
  (declare-const ?rs Real)
  (declare-const ?rt Real)
  (declare-const ?ru Real)
  (assert
    (or (or (= ?ru ?rt)
        (= ?ru ?rs)
        )
      (= ?rt ?rs)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?rv Real)
  (declare-const ?rw Real)
  (declare-const ?rx Real)
  (declare-const ?ry Real)
  (declare-const ?rz Real)
  (assert
    (or (or (= ?rz ?ry)
        (= ?rz ?rx)
        )
      (= ?ry ?rx)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?sa Real)
  (declare-const ?sb Real)
  (declare-const ?sc Real)
  (declare-const ?sd Real)
  (declare-const ?se Real)
  (declare-const ?sf Real)
  (assert
    (and (and (and (not (= ?sc ?sb))
          (not (= ?sc ?sa))
          )
        (not (= ?sb ?sa))
        )
      (or (or (= ?sf ?se)
          (= ?sf ?sd)
          )
        (= ?se ?sd)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?sg Real)
  (declare-const ?sh Real)
  (declare-const ?si Real)
  (assert
    (or (or (= ?si ?sh)
        (= ?si ?sg)
        )
      (= ?sh ?sg)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?sj Real)
  (declare-const ?sk Real)
  (declare-const ?sl Real)
  (assert
    (or (or (= ?sl ?sk)
        (= ?sl ?sj)
        )
      (= ?sk ?sj)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?sm Real)
  (declare-const ?sn Real)
  (declare-const ?so Real)
  (declare-const ?sp Real)
  (assert
    (or (or (= ?so ?sn)
        (= ?so ?sm)
        )
      (= ?sn ?sm)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?sq Real)
  (declare-const ?sr Real)
  (declare-const ?ss Real)
  (declare-const ?st Real)
  (declare-const ?su Real)
  (assert
    (or (or (= ?ss ?sr)
        (= ?ss ?sq)
        )
      (= ?sr ?sq)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?sv Real)
  (declare-const ?sw Real)
  (declare-const ?sx Real)
  (declare-const ?sy Real)
  (declare-const ?sz Real)
  (declare-const ?ta Real)
  (assert
    (and (or (or (= ?sx ?sw)
          (= ?sx ?sv)
          )
        (= ?sw ?sv)
        )
      (and (and (not (= ?ta ?sz))
          (not (= ?ta ?sy))
          )
        (not (= ?sz ?sy))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?tb Real)
  (declare-const ?tc Real)
  (declare-const ?td Real)
  (assert
    (or (or (= ?td ?tc)
        (= ?td ?tb)
        )
      (= ?tc ?tb)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?te Real)
  (declare-const ?tf Real)
  (declare-const ?tg Real)
  (assert
    (or (or (= ?tg ?tf)
        (= ?tg ?te)
        )
      (= ?tf ?te)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?th Real)
  (declare-const ?ti Real)
  (declare-const ?tj Real)
  (declare-const ?tk Real)
  (assert
    (or (or (= ?tk ?tj)
        (= ?tk ?ti)
        )
      (= ?tj ?ti)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?tl Real)
  (declare-const ?tm Real)
  (declare-const ?tn Real)
  (declare-const ?to Real)
  (declare-const ?tp Real)
  (assert
    (or (or (= ?tp ?to)
        (= ?tp ?tn)
        )
      (= ?to ?tn)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?tq Real)
  (declare-const ?tr Real)
  (declare-const ?ts Real)
  (declare-const ?tt Real)
  (declare-const ?tu Real)
  (declare-const ?tv Real)
  (assert
    (and (and (and (not (= ?ts ?tr))
          (not (= ?ts ?tq))
          )
        (not (= ?tr ?tq))
        )
      (or (or (= ?tv ?tu)
          (= ?tv ?tt)
          )
        (= ?tu ?tt)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?tw Real)
  (declare-const ?tx Real)
  (declare-const ?ty Real)
  (assert
    (or (or (= ?ty ?tx)
        (= ?ty ?tw)
        )
      (= ?tx ?tw)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?tz Real)
  (declare-const ?ua Real)
  (declare-const ?ub Real)
  (assert
    (or (or (= ?ub ?ua)
        (= ?ub ?tz)
        )
      (= ?ua ?tz)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?uc Real)
  (declare-const ?ud Real)
  (declare-const ?ue Real)
  (declare-const ?uf Real)
  (assert
    (or (or (= ?ue ?ud)
        (= ?ue ?uc)
        )
      (= ?ud ?uc)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?ug Real)
  (declare-const ?uh Real)
  (declare-const ?ui Real)
  (declare-const ?uj Real)
  (declare-const ?uk Real)
  (assert
    (or (or (= ?ui ?uh)
        (= ?ui ?ug)
        )
      (= ?uh ?ug)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?ul Real)
  (declare-const ?um Real)
  (declare-const ?un Real)
  (declare-const ?uo Real)
  (declare-const ?up Real)
  (declare-const ?uq Real)
  (assert
    (and (or (or (= ?un ?um)
          (= ?un ?ul)
          )
        (= ?um ?ul)
        )
      (and (and (not (= ?uq ?up))
          (not (= ?uq ?uo))
          )
        (not (= ?up ?uo))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?ur Real)
  (declare-const ?us Real)
  (declare-const ?ut Real)
  (assert
    (or (or (= ?ut ?us)
        (= ?ut ?ur)
        )
      (= ?us ?ur)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (assert
    (or (or (or (or (or (or (or (or (or (exists ((?tf Real) (?te Real) )(or (= ?tf ?te)
                          (exists ((?tg Real) )(or (= ?tg ?tf)
                              (= ?tg ?te)
                              )
                            )
                          )
                        )
                      (exists ((?tj Real) (?ti Real) )(or (= ?tj ?ti)
                          (exists ((?tk Real) )(or (= ?tk ?tj)
                              (= ?tk ?ti)
                              )
                            )
                          )
                        )
                      )
                    (exists ((?to Real) (?tn Real) )(or (= ?to ?tn)
                        (exists ((?tp Real) )(or (= ?tp ?to)
                            (= ?tp ?tn)
                            )
                          )
                        )
                      )
                    )
                  (and (exists ((?tu Real) (?tv Real) )(or (= ?tv ?tu)
                        (exists ((?tt Real) )(or (= ?tv ?tt)
                            (= ?tu ?tt)
                            )
                          )
                        )
                      )
                    (exists ((?tq Real) (?tr Real) )(and (not (= ?tr ?tq))
                        (exists ((?ts Real) )(and (not (= ?ts ?tr))
                            (not (= ?ts ?tq))
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?tx Real) (?tw Real) )(or (= ?tx ?tw)
                    (exists ((?ty Real) )(or (= ?ty ?tx)
                        (= ?ty ?tw)
                        )
                      )
                    )
                  )
                )
              (exists ((?ua Real) (?tz Real) )(or (= ?ua ?tz)
                  (exists ((?ub Real) )(or (= ?ub ?ua)
                      (= ?ub ?tz)
                      )
                    )
                  )
                )
              )
            (exists ((?ud Real) (?uc Real) )(or (= ?ud ?uc)
                (exists ((?ue Real) )(or (= ?ue ?ud)
                    (= ?ue ?uc)
                    )
                  )
                )
              )
            )
          (exists ((?uh Real) (?ug Real) )(or (= ?uh ?ug)
              (exists ((?ui Real) )(or (= ?ui ?uh)
                  (= ?ui ?ug)
                  )
                )
              )
            )
          )
        (and (exists ((?up Real) (?uo Real) )(and (not (= ?up ?uo))
              (exists ((?uq Real) )(and (not (= ?uq ?up))
                  (not (= ?uq ?uo))
                  )
                )
              )
            )
          (exists ((?um Real) (?ul Real) )(or (= ?um ?ul)
              (exists ((?un Real) )(or (= ?un ?um)
                  (= ?un ?ul)
                  )
                )
              )
            )
          )
        )
      (exists ((?us Real) (?ur Real) )(or (= ?us ?ur)
          (exists ((?ut Real) )(or (= ?ut ?us)
              (= ?ut ?ur)
              )
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?uu Real)
    (declare-const ?uv Real)
    (declare-const ?uw Real)
    (assert
      (or (or (= ?uw ?uv)
          (= ?uw ?uu)
          )
        (= ?uv ?uu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ux Real)
    (declare-const ?uy Real)
    (declare-const ?uz Real)
    (declare-const ?va Real)
    (assert
      (or (or (= ?va ?uz)
          (= ?va ?uy)
          )
        (= ?uz ?uy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vb Real)
    (declare-const ?vc Real)
    (declare-const ?vd Real)
    (declare-const ?ve Real)
    (declare-const ?vf Real)
    (assert
      (or (or (= ?vf ?ve)
          (= ?vf ?vd)
          )
        (= ?ve ?vd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vg Real)
    (declare-const ?vh Real)
    (declare-const ?vi Real)
    (declare-const ?vj Real)
    (declare-const ?vk Real)
    (declare-const ?vl Real)
    (assert
      (and (and (and (not (= ?vi ?vh))
            (not (= ?vi ?vg))
            )
          (not (= ?vh ?vg))
          )
        (or (or (= ?vl ?vk)
            (= ?vl ?vj)
            )
          (= ?vk ?vj)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vm Real)
    (declare-const ?vn Real)
    (declare-const ?vo Real)
    (assert
      (or (or (= ?vo ?vn)
          (= ?vo ?vm)
          )
        (= ?vn ?vm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vp Real)
    (declare-const ?vq Real)
    (declare-const ?vr Real)
    (assert
      (or (or (= ?vr ?vq)
          (= ?vr ?vp)
          )
        (= ?vq ?vp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vs Real)
    (declare-const ?vt Real)
    (declare-const ?vu Real)
    (declare-const ?vv Real)
    (assert
      (or (or (= ?vu ?vt)
          (= ?vu ?vs)
          )
        (= ?vt ?vs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vw Real)
    (declare-const ?vx Real)
    (declare-const ?vy Real)
    (declare-const ?vz Real)
    (declare-const ?wa Real)
    (assert
      (or (or (= ?vy ?vx)
          (= ?vy ?vw)
          )
        (= ?vx ?vw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wb Real)
    (declare-const ?wc Real)
    (declare-const ?wd Real)
    (declare-const ?we Real)
    (declare-const ?wf Real)
    (declare-const ?wg Real)
    (assert
      (and (or (or (= ?wd ?wc)
            (= ?wd ?wb)
            )
          (= ?wc ?wb)
          )
        (and (and (not (= ?wg ?wf))
            (not (= ?wg ?we))
            )
          (not (= ?wf ?we))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wh Real)
    (declare-const ?wi Real)
    (declare-const ?wj Real)
    (assert
      (or (or (= ?wj ?wi)
          (= ?wj ?wh)
          )
        (= ?wi ?wh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wk Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?wl Real)
      (declare-const ?wm Real)
      (declare-const ?wn Real)
      (assert
        (or (or (= ?wn ?wm)
            (= ?wn ?wl)
            )
          (= ?wm ?wl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?wo Real)
      (declare-const ?wp Real)
      (declare-const ?wq Real)
      (declare-const ?wr Real)
      (assert
        (or (or (= ?wr ?wq)
            (= ?wr ?wp)
            )
          (= ?wq ?wp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ws Real)
      (declare-const ?wt Real)
      (declare-const ?wu Real)
      (declare-const ?wv Real)
      (declare-const ?ww Real)
      (assert
        (or (or (= ?ww ?wv)
            (= ?ww ?wu)
            )
          (= ?wv ?wu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?wx Real)
      (declare-const ?wy Real)
      (declare-const ?wz Real)
      (declare-const ?xa Real)
      (declare-const ?xb Real)
      (declare-const ?xc Real)
      (assert
        (and (and (and (not (= ?wz ?wy))
              (not (= ?wz ?wx))
              )
            (not (= ?wy ?wx))
            )
          (or (or (= ?xc ?xb)
              (= ?xc ?xa)
              )
            (= ?xb ?xa)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?xd Real)
      (declare-const ?xe Real)
      (declare-const ?xf Real)
      (assert
        (or (or (= ?xf ?xe)
            (= ?xf ?xd)
            )
          (= ?xe ?xd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?xg Real)
      (declare-const ?xh Real)
      (declare-const ?xi Real)
      (assert
        (or (or (= ?xi ?xh)
            (= ?xi ?xg)
            )
          (= ?xh ?xg)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?xj Real)
      (declare-const ?xk Real)
      (declare-const ?xl Real)
      (declare-const ?xm Real)
      (assert
        (or (or (= ?xl ?xk)
            (= ?xl ?xj)
            )
          (= ?xk ?xj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?xn Real)
      (declare-const ?xo Real)
      (declare-const ?xp Real)
      (declare-const ?xq Real)
      (declare-const ?xr Real)
      (assert
        (or (or (= ?xp ?xo)
            (= ?xp ?xn)
            )
          (= ?xo ?xn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?xs Real)
      (declare-const ?xt Real)
      (declare-const ?xu Real)
      (declare-const ?xv Real)
      (declare-const ?xw Real)
      (declare-const ?xx Real)
      (assert
        (and (or (or (= ?xu ?xt)
              (= ?xu ?xs)
              )
            (= ?xt ?xs)
            )
          (and (and (not (= ?xx ?xw))
              (not (= ?xx ?xv))
              )
            (not (= ?xw ?xv))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?xy Real)
      (declare-const ?xz Real)
      (declare-const ?ya Real)
      (assert
        (or (or (= ?ya ?xz)
            (= ?ya ?xy)
            )
          (= ?xz ?xy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?yb Real)
    (declare-const ?yc Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?yd Real)
      (declare-const ?ye Real)
      (declare-const ?yf Real)
      (assert
        (or (or (= ?yf ?ye)
            (= ?yf ?yd)
            )
          (= ?ye ?yd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yg Real)
      (declare-const ?yh Real)
      (declare-const ?yi Real)
      (declare-const ?yj Real)
      (assert
        (or (or (= ?yj ?yi)
            (= ?yj ?yh)
            )
          (= ?yi ?yh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yk Real)
      (declare-const ?yl Real)
      (declare-const ?ym Real)
      (declare-const ?yn Real)
      (declare-const ?yo Real)
      (assert
        (or (or (= ?yo ?yn)
            (= ?yo ?ym)
            )
          (= ?yn ?ym)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yp Real)
      (declare-const ?yq Real)
      (declare-const ?yr Real)
      (declare-const ?ys Real)
      (declare-const ?yt Real)
      (declare-const ?yu Real)
      (assert
        (and (and (and (not (= ?yr ?yq))
              (not (= ?yr ?yp))
              )
            (not (= ?yq ?yp))
            )
          (or (or (= ?yu ?yt)
              (= ?yu ?ys)
              )
            (= ?yt ?ys)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yv Real)
      (declare-const ?yw Real)
      (declare-const ?yx Real)
      (assert
        (or (or (= ?yx ?yw)
            (= ?yx ?yv)
            )
          (= ?yw ?yv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yy Real)
      (declare-const ?yz Real)
      (declare-const ?za Real)
      (assert
        (or (or (= ?za ?yz)
            (= ?za ?yy)
            )
          (= ?yz ?yy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zb Real)
      (declare-const ?zc Real)
      (declare-const ?zd Real)
      (declare-const ?ze Real)
      (assert
        (or (or (= ?zd ?zc)
            (= ?zd ?zb)
            )
          (= ?zc ?zb)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zf Real)
      (declare-const ?zg Real)
      (declare-const ?zh Real)
      (declare-const ?zi Real)
      (declare-const ?zj Real)
      (assert
        (or (or (= ?zh ?zg)
            (= ?zh ?zf)
            )
          (= ?zg ?zf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zk Real)
      (declare-const ?zl Real)
      (declare-const ?zm Real)
      (declare-const ?zn Real)
      (declare-const ?zo Real)
      (declare-const ?zp Real)
      (assert
        (and (or (or (= ?zm ?zl)
              (= ?zm ?zk)
              )
            (= ?zl ?zk)
            )
          (and (and (not (= ?zp ?zo))
              (not (= ?zp ?zn))
              )
            (not (= ?zo ?zn))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zq Real)
      (declare-const ?zr Real)
      (declare-const ?zs Real)
      (assert
        (or (or (= ?zs ?zr)
            (= ?zs ?zq)
            )
          (= ?zr ?zq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?zt Real)
    (declare-const ?zu Real)
    (declare-const ?zv Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?zw Real)
      (declare-const ?zx Real)
      (declare-const ?zy Real)
      (assert
        (or (or (= ?zy ?zx)
            (= ?zy ?zw)
            )
          (= ?zx ?zw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zz Real)
      (declare-const ?aaa Real)
      (declare-const ?aab Real)
      (declare-const ?aac Real)
      (assert
        (or (or (= ?aac ?aab)
            (= ?aac ?aaa)
            )
          (= ?aab ?aaa)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aad Real)
      (declare-const ?aae Real)
      (declare-const ?aaf Real)
      (declare-const ?aag Real)
      (declare-const ?aah Real)
      (assert
        (or (or (= ?aah ?aag)
            (= ?aah ?aaf)
            )
          (= ?aag ?aaf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aai Real)
      (declare-const ?aaj Real)
      (declare-const ?aak Real)
      (declare-const ?aal Real)
      (declare-const ?aam Real)
      (declare-const ?aan Real)
      (assert
        (and (and (and (not (= ?aak ?aaj))
              (not (= ?aak ?aai))
              )
            (not (= ?aaj ?aai))
            )
          (or (or (= ?aan ?aam)
              (= ?aan ?aal)
              )
            (= ?aam ?aal)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aao Real)
      (declare-const ?aap Real)
      (declare-const ?aaq Real)
      (assert
        (or (or (= ?aaq ?aap)
            (= ?aaq ?aao)
            )
          (= ?aap ?aao)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aar Real)
      (declare-const ?aas Real)
      (declare-const ?aat Real)
      (assert
        (or (or (= ?aat ?aas)
            (= ?aat ?aar)
            )
          (= ?aas ?aar)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aau Real)
      (declare-const ?aav Real)
      (declare-const ?aaw Real)
      (declare-const ?aax Real)
      (assert
        (or (or (= ?aaw ?aav)
            (= ?aaw ?aau)
            )
          (= ?aav ?aau)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aay Real)
      (declare-const ?aaz Real)
      (declare-const ?aba Real)
      (declare-const ?abb Real)
      (declare-const ?abc Real)
      (assert
        (or (or (= ?aba ?aaz)
            (= ?aba ?aay)
            )
          (= ?aaz ?aay)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?abd Real)
      (declare-const ?abe Real)
      (declare-const ?abf Real)
      (declare-const ?abg Real)
      (declare-const ?abh Real)
      (declare-const ?abi Real)
      (assert
        (and (or (or (= ?abf ?abe)
              (= ?abf ?abd)
              )
            (= ?abe ?abd)
            )
          (and (and (not (= ?abi ?abh))
              (not (= ?abi ?abg))
              )
            (not (= ?abh ?abg))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?abj Real)
      (declare-const ?abk Real)
      (declare-const ?abl Real)
      (assert
        (or (or (= ?abl ?abk)
            (= ?abl ?abj)
            )
          (= ?abk ?abj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (= ?zv ?zu)
            (= ?zv ?zt)
            )
          (= ?zu ?zt)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?abm Real)
    (declare-const ?abn Real)
    (declare-const ?abo Real)
    (declare-const ?abp Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?abq Real)
      (declare-const ?abr Real)
      (declare-const ?abs Real)
      (assert
        (or (or (= ?abs ?abr)
            (= ?abs ?abq)
            )
          (= ?abr ?abq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?abt Real)
      (declare-const ?abu Real)
      (declare-const ?abv Real)
      (declare-const ?abw Real)
      (assert
        (or (or (= ?abw ?abv)
            (= ?abw ?abu)
            )
          (= ?abv ?abu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?abx Real)
      (declare-const ?aby Real)
      (declare-const ?abz Real)
      (declare-const ?aca Real)
      (declare-const ?acb Real)
      (assert
        (or (or (= ?acb ?aca)
            (= ?acb ?abz)
            )
          (= ?aca ?abz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?acc Real)
      (declare-const ?acd Real)
      (declare-const ?ace Real)
      (declare-const ?acf Real)
      (declare-const ?acg Real)
      (declare-const ?ach Real)
      (assert
        (and (and (and (not (= ?ace ?acd))
              (not (= ?ace ?acc))
              )
            (not (= ?acd ?acc))
            )
          (or (or (= ?ach ?acg)
              (= ?ach ?acf)
              )
            (= ?acg ?acf)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aci Real)
      (declare-const ?acj Real)
      (declare-const ?ack Real)
      (assert
        (or (or (= ?ack ?acj)
            (= ?ack ?aci)
            )
          (= ?acj ?aci)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?acl Real)
      (declare-const ?acm Real)
      (declare-const ?acn Real)
      (assert
        (or (or (= ?acn ?acm)
            (= ?acn ?acl)
            )
          (= ?acm ?acl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aco Real)
      (declare-const ?acp Real)
      (declare-const ?acq Real)
      (declare-const ?acr Real)
      (assert
        (or (or (= ?acq ?acp)
            (= ?acq ?aco)
            )
          (= ?acp ?aco)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?acs Real)
      (declare-const ?act Real)
      (declare-const ?acu Real)
      (declare-const ?acv Real)
      (declare-const ?acw Real)
      (assert
        (or (or (= ?acu ?act)
            (= ?acu ?acs)
            )
          (= ?act ?acs)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?acx Real)
      (declare-const ?acy Real)
      (declare-const ?acz Real)
      (declare-const ?ada Real)
      (declare-const ?adb Real)
      (declare-const ?adc Real)
      (assert
        (and (or (or (= ?acz ?acy)
              (= ?acz ?acx)
              )
            (= ?acy ?acx)
            )
          (and (and (not (= ?adc ?adb))
              (not (= ?adc ?ada))
              )
            (not (= ?adb ?ada))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?add Real)
      (declare-const ?ade Real)
      (declare-const ?adf Real)
      (assert
        (or (or (= ?adf ?ade)
            (= ?adf ?add)
            )
          (= ?ade ?add)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?adg Real)
      (declare-const ?adh Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?adi Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?adj Real)
      (declare-const ?adk Real)
      (declare-const ?adl Real)
      (assert
        (or (or (= ?adl ?adk)
            (= ?adl ?adj)
            )
          (= ?adk ?adj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?adm Real)
      (declare-const ?adn Real)
      (declare-const ?ado Real)
      (declare-const ?adp Real)
      (assert
        (or (or (= ?adp ?ado)
            (= ?adp ?adn)
            )
          (= ?ado ?adn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?adq Real)
      (declare-const ?adr Real)
      (declare-const ?ads Real)
      (declare-const ?adt Real)
      (declare-const ?adu Real)
      (assert
        (or (or (= ?adu ?adt)
            (= ?adu ?ads)
            )
          (= ?adt ?ads)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?adv Real)
      (declare-const ?adw Real)
      (declare-const ?adx Real)
      (declare-const ?ady Real)
      (declare-const ?adz Real)
      (declare-const ?aea Real)
      (assert
        (and (and (and (not (= ?adx ?adw))
              (not (= ?adx ?adv))
              )
            (not (= ?adw ?adv))
            )
          (or (or (= ?aea ?adz)
              (= ?aea ?ady)
              )
            (= ?adz ?ady)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aeb Real)
      (declare-const ?aec Real)
      (declare-const ?aed Real)
      (assert
        (or (or (= ?aed ?aec)
            (= ?aed ?aeb)
            )
          (= ?aec ?aeb)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aee Real)
      (declare-const ?aef Real)
      (declare-const ?aeg Real)
      (assert
        (or (or (= ?aeg ?aef)
            (= ?aeg ?aee)
            )
          (= ?aef ?aee)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aeh Real)
      (declare-const ?aei Real)
      (declare-const ?aej Real)
      (declare-const ?aek Real)
      (assert
        (or (or (= ?aej ?aei)
            (= ?aej ?aeh)
            )
          (= ?aei ?aeh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ael Real)
      (declare-const ?aem Real)
      (declare-const ?aen Real)
      (declare-const ?aeo Real)
      (declare-const ?aep Real)
      (assert
        (or (or (= ?aen ?aem)
            (= ?aen ?ael)
            )
          (= ?aem ?ael)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aeq Real)
      (declare-const ?aer Real)
      (declare-const ?aes Real)
      (declare-const ?aet Real)
      (declare-const ?aeu Real)
      (declare-const ?aev Real)
      (assert
        (and (or (or (= ?aes ?aer)
              (= ?aes ?aeq)
              )
            (= ?aer ?aeq)
            )
          (and (and (not (= ?aev ?aeu))
              (not (= ?aev ?aet))
              )
            (not (= ?aeu ?aet))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aew Real)
      (declare-const ?aex Real)
      (declare-const ?aey Real)
      (assert
        (or (or (= ?aey ?aex)
            (= ?aey ?aew)
            )
          (= ?aex ?aew)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aez Real)
      (declare-const ?afa Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?afb Real)
    (declare-const ?afc Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?afd Real)
      (declare-const ?afe Real)
      (declare-const ?aff Real)
      (assert
        (or (or (= ?aff ?afe)
            (= ?aff ?afd)
            )
          (= ?afe ?afd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?afg Real)
      (declare-const ?afh Real)
      (declare-const ?afi Real)
      (declare-const ?afj Real)
      (assert
        (or (or (= ?afj ?afi)
            (= ?afj ?afh)
            )
          (= ?afi ?afh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?afk Real)
      (declare-const ?afl Real)
      (declare-const ?afm Real)
      (declare-const ?afn Real)
      (declare-const ?afo Real)
      (assert
        (or (or (= ?afo ?afn)
            (= ?afo ?afm)
            )
          (= ?afn ?afm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?afp Real)
      (declare-const ?afq Real)
      (declare-const ?afr Real)
      (declare-const ?afs Real)
      (declare-const ?aft Real)
      (declare-const ?afu Real)
      (assert
        (and (and (and (not (= ?afr ?afq))
              (not (= ?afr ?afp))
              )
            (not (= ?afq ?afp))
            )
          (or (or (= ?afu ?aft)
              (= ?afu ?afs)
              )
            (= ?aft ?afs)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?afv Real)
      (declare-const ?afw Real)
      (declare-const ?afx Real)
      (assert
        (or (or (= ?afx ?afw)
            (= ?afx ?afv)
            )
          (= ?afw ?afv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?afy Real)
      (declare-const ?afz Real)
      (declare-const ?aga Real)
      (assert
        (or (or (= ?aga ?afz)
            (= ?aga ?afy)
            )
          (= ?afz ?afy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?agb Real)
      (declare-const ?agc Real)
      (declare-const ?agd Real)
      (declare-const ?age Real)
      (assert
        (or (or (= ?agd ?agc)
            (= ?agd ?agb)
            )
          (= ?agc ?agb)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?agf Real)
      (declare-const ?agg Real)
      (declare-const ?agh Real)
      (declare-const ?agi Real)
      (declare-const ?agj Real)
      (assert
        (or (or (= ?agh ?agg)
            (= ?agh ?agf)
            )
          (= ?agg ?agf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?agk Real)
      (declare-const ?agl Real)
      (declare-const ?agm Real)
      (declare-const ?agn Real)
      (declare-const ?ago Real)
      (declare-const ?agp Real)
      (assert
        (and (or (or (= ?agm ?agl)
              (= ?agm ?agk)
              )
            (= ?agl ?agk)
            )
          (and (and (not (= ?agp ?ago))
              (not (= ?agp ?agn))
              )
            (not (= ?ago ?agn))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?agq Real)
      (declare-const ?agr Real)
      (declare-const ?ags Real)
      (assert
        (or (or (= ?ags ?agr)
            (= ?ags ?agq)
            )
          (= ?agr ?agq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?agt Real)
      (declare-const ?agu Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?agv Real)
    (declare-const ?agw Real)
    (declare-const ?agx Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?agy Real)
      (declare-const ?agz Real)
      (declare-const ?aha Real)
      (assert
        (or (or (= ?aha ?agz)
            (= ?aha ?agy)
            )
          (= ?agz ?agy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ahb Real)
      (declare-const ?ahc Real)
      (declare-const ?ahd Real)
      (declare-const ?ahe Real)
      (assert
        (or (or (= ?ahe ?ahd)
            (= ?ahe ?ahc)
            )
          (= ?ahd ?ahc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ahf Real)
      (declare-const ?ahg Real)
      (declare-const ?ahh Real)
      (declare-const ?ahi Real)
      (declare-const ?ahj Real)
      (assert
        (or (or (= ?ahj ?ahi)
            (= ?ahj ?ahh)
            )
          (= ?ahi ?ahh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ahk Real)
      (declare-const ?ahl Real)
      (declare-const ?ahm Real)
      (declare-const ?ahn Real)
      (declare-const ?aho Real)
      (declare-const ?ahp Real)
      (assert
        (and (and (and (not (= ?ahm ?ahl))
              (not (= ?ahm ?ahk))
              )
            (not (= ?ahl ?ahk))
            )
          (or (or (= ?ahp ?aho)
              (= ?ahp ?ahn)
              )
            (= ?aho ?ahn)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ahq Real)
      (declare-const ?ahr Real)
      (declare-const ?ahs Real)
      (assert
        (or (or (= ?ahs ?ahr)
            (= ?ahs ?ahq)
            )
          (= ?ahr ?ahq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aht Real)
      (declare-const ?ahu Real)
      (declare-const ?ahv Real)
      (assert
        (or (or (= ?ahv ?ahu)
            (= ?ahv ?aht)
            )
          (= ?ahu ?aht)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ahw Real)
      (declare-const ?ahx Real)
      (declare-const ?ahy Real)
      (declare-const ?ahz Real)
      (assert
        (or (or (= ?ahy ?ahx)
            (= ?ahy ?ahw)
            )
          (= ?ahx ?ahw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aia Real)
      (declare-const ?aib Real)
      (declare-const ?aic Real)
      (declare-const ?aid Real)
      (declare-const ?aie Real)
      (assert
        (or (or (= ?aic ?aib)
            (= ?aic ?aia)
            )
          (= ?aib ?aia)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aif Real)
      (declare-const ?aig Real)
      (declare-const ?aih Real)
      (declare-const ?aii Real)
      (declare-const ?aij Real)
      (declare-const ?aik Real)
      (assert
        (and (or (or (= ?aih ?aig)
              (= ?aih ?aif)
              )
            (= ?aig ?aif)
            )
          (and (and (not (= ?aik ?aij))
              (not (= ?aik ?aii))
              )
            (not (= ?aij ?aii))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ail Real)
      (declare-const ?aim Real)
      (declare-const ?ain Real)
      (assert
        (or (or (= ?ain ?aim)
            (= ?ain ?ail)
            )
          (= ?aim ?ail)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aio Real)
      (declare-const ?aip Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?aiq Real)
    (declare-const ?air Real)
    (declare-const ?ais Real)
    (declare-const ?ait Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?aiu Real)
      (declare-const ?aiv Real)
      (declare-const ?aiw Real)
      (assert
        (or (or (= ?aiw ?aiv)
            (= ?aiw ?aiu)
            )
          (= ?aiv ?aiu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aix Real)
      (declare-const ?aiy Real)
      (declare-const ?aiz Real)
      (declare-const ?aja Real)
      (assert
        (or (or (= ?aja ?aiz)
            (= ?aja ?aiy)
            )
          (= ?aiz ?aiy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ajb Real)
      (declare-const ?ajc Real)
      (declare-const ?ajd Real)
      (declare-const ?aje Real)
      (declare-const ?ajf Real)
      (assert
        (or (or (= ?ajf ?aje)
            (= ?ajf ?ajd)
            )
          (= ?aje ?ajd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ajg Real)
      (declare-const ?ajh Real)
      (declare-const ?aji Real)
      (declare-const ?ajj Real)
      (declare-const ?ajk Real)
      (declare-const ?ajl Real)
      (assert
        (and (and (and (not (= ?aji ?ajh))
              (not (= ?aji ?ajg))
              )
            (not (= ?ajh ?ajg))
            )
          (or (or (= ?ajl ?ajk)
              (= ?ajl ?ajj)
              )
            (= ?ajk ?ajj)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ajm Real)
      (declare-const ?ajn Real)
      (declare-const ?ajo Real)
      (assert
        (or (or (= ?ajo ?ajn)
            (= ?ajo ?ajm)
            )
          (= ?ajn ?ajm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ajp Real)
      (declare-const ?ajq Real)
      (declare-const ?ajr Real)
      (assert
        (or (or (= ?ajr ?ajq)
            (= ?ajr ?ajp)
            )
          (= ?ajq ?ajp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ajs Real)
      (declare-const ?ajt Real)
      (declare-const ?aju Real)
      (declare-const ?ajv Real)
      (assert
        (or (or (= ?aju ?ajt)
            (= ?aju ?ajs)
            )
          (= ?ajt ?ajs)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ajw Real)
      (declare-const ?ajx Real)
      (declare-const ?ajy Real)
      (declare-const ?ajz Real)
      (declare-const ?aka Real)
      (assert
        (or (or (= ?ajy ?ajx)
            (= ?ajy ?ajw)
            )
          (= ?ajx ?ajw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?akb Real)
      (declare-const ?akc Real)
      (declare-const ?akd Real)
      (declare-const ?ake Real)
      (declare-const ?akf Real)
      (declare-const ?akg Real)
      (assert
        (and (or (or (= ?akd ?akc)
              (= ?akd ?akb)
              )
            (= ?akc ?akb)
            )
          (and (and (not (= ?akg ?akf))
              (not (= ?akg ?ake))
              )
            (not (= ?akf ?ake))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?akh Real)
      (declare-const ?aki Real)
      (declare-const ?akj Real)
      (assert
        (or (or (= ?akj ?aki)
            (= ?akj ?akh)
            )
          (= ?aki ?akh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?akk Real)
      (declare-const ?akl Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (= ?ais ?air)
            (= ?ais ?aiq)
            )
          (= ?air ?aiq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?akm Real)
    (declare-const ?akn Real)
    (declare-const ?ako Real)
    (declare-const ?akp Real)
    (declare-const ?akq Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?akr Real)
      (declare-const ?aks Real)
      (declare-const ?akt Real)
      (assert
        (or (or (= ?akt ?aks)
            (= ?akt ?akr)
            )
          (= ?aks ?akr)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aku Real)
      (declare-const ?akv Real)
      (declare-const ?akw Real)
      (declare-const ?akx Real)
      (assert
        (or (or (= ?akx ?akw)
            (= ?akx ?akv)
            )
          (= ?akw ?akv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aky Real)
      (declare-const ?akz Real)
      (declare-const ?ala Real)
      (declare-const ?alb Real)
      (declare-const ?alc Real)
      (assert
        (or (or (= ?alc ?alb)
            (= ?alc ?ala)
            )
          (= ?alb ?ala)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ald Real)
      (declare-const ?ale Real)
      (declare-const ?alf Real)
      (declare-const ?alg Real)
      (declare-const ?alh Real)
      (declare-const ?ali Real)
      (assert
        (and (and (and (not (= ?alf ?ale))
              (not (= ?alf ?ald))
              )
            (not (= ?ale ?ald))
            )
          (or (or (= ?ali ?alh)
              (= ?ali ?alg)
              )
            (= ?alh ?alg)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?alj Real)
      (declare-const ?alk Real)
      (declare-const ?all Real)
      (assert
        (or (or (= ?all ?alk)
            (= ?all ?alj)
            )
          (= ?alk ?alj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?alm Real)
      (declare-const ?aln Real)
      (declare-const ?alo Real)
      (assert
        (or (or (= ?alo ?aln)
            (= ?alo ?alm)
            )
          (= ?aln ?alm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?alp Real)
      (declare-const ?alq Real)
      (declare-const ?alr Real)
      (declare-const ?als Real)
      (assert
        (or (or (= ?alr ?alq)
            (= ?alr ?alp)
            )
          (= ?alq ?alp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?alt Real)
      (declare-const ?alu Real)
      (declare-const ?alv Real)
      (declare-const ?alw Real)
      (declare-const ?alx Real)
      (assert
        (or (or (= ?alv ?alu)
            (= ?alv ?alt)
            )
          (= ?alu ?alt)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aly Real)
      (declare-const ?alz Real)
      (declare-const ?ama Real)
      (declare-const ?amb Real)
      (declare-const ?amc Real)
      (declare-const ?amd Real)
      (assert
        (and (or (or (= ?ama ?alz)
              (= ?ama ?aly)
              )
            (= ?alz ?aly)
            )
          (and (and (not (= ?amd ?amc))
              (not (= ?amd ?amb))
              )
            (not (= ?amc ?amb))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ame Real)
      (declare-const ?amf Real)
      (declare-const ?amg Real)
      (assert
        (or (or (= ?amg ?amf)
            (= ?amg ?ame)
            )
          (= ?amf ?ame)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?amh Real)
      (declare-const ?ami Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?amj Real)
      (declare-const ?amk Real)
      (declare-const ?aml Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?amm Real)
    (declare-const ?amn Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?amo Real)
      (declare-const ?amp Real)
      (declare-const ?amq Real)
      (assert
        (or (or (= ?amq ?amp)
            (= ?amq ?amo)
            )
          (= ?amp ?amo)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?amr Real)
      (declare-const ?ams Real)
      (declare-const ?amt Real)
      (declare-const ?amu Real)
      (assert
        (or (or (= ?amu ?amt)
            (= ?amu ?ams)
            )
          (= ?amt ?ams)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?amv Real)
      (declare-const ?amw Real)
      (declare-const ?amx Real)
      (declare-const ?amy Real)
      (declare-const ?amz Real)
      (assert
        (or (or (= ?amz ?amy)
            (= ?amz ?amx)
            )
          (= ?amy ?amx)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ana Real)
      (declare-const ?anb Real)
      (declare-const ?anc Real)
      (declare-const ?and Real)
      (declare-const ?ane Real)
      (declare-const ?anf Real)
      (assert
        (and (and (and (not (= ?anc ?anb))
              (not (= ?anc ?ana))
              )
            (not (= ?anb ?ana))
            )
          (or (or (= ?anf ?ane)
              (= ?anf ?and)
              )
            (= ?ane ?and)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ang Real)
      (declare-const ?anh Real)
      (declare-const ?ani Real)
      (assert
        (or (or (= ?ani ?anh)
            (= ?ani ?ang)
            )
          (= ?anh ?ang)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?anj Real)
      (declare-const ?ank Real)
      (declare-const ?anl Real)
      (assert
        (or (or (= ?anl ?ank)
            (= ?anl ?anj)
            )
          (= ?ank ?anj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?anm Real)
      (declare-const ?ann Real)
      (declare-const ?ano Real)
      (declare-const ?anp Real)
      (assert
        (or (or (= ?ano ?ann)
            (= ?ano ?anm)
            )
          (= ?ann ?anm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?anq Real)
      (declare-const ?anr Real)
      (declare-const ?ans Real)
      (declare-const ?ant Real)
      (declare-const ?anu Real)
      (assert
        (or (or (= ?ans ?anr)
            (= ?ans ?anq)
            )
          (= ?anr ?anq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?anv Real)
      (declare-const ?anw Real)
      (declare-const ?anx Real)
      (declare-const ?any Real)
      (declare-const ?anz Real)
      (declare-const ?aoa Real)
      (assert
        (and (or (or (= ?anx ?anw)
              (= ?anx ?anv)
              )
            (= ?anw ?anv)
            )
          (and (and (not (= ?aoa ?anz))
              (not (= ?aoa ?any))
              )
            (not (= ?anz ?any))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aob Real)
      (declare-const ?aoc Real)
      (declare-const ?aod Real)
      (assert
        (or (or (= ?aod ?aoc)
            (= ?aod ?aob)
            )
          (= ?aoc ?aob)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aoe Real)
      (declare-const ?aof Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aog Real)
      (declare-const ?aoh Real)
      (declare-const ?aoi Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?aoj Real)
    (declare-const ?aok Real)
    (declare-const ?aol Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?aom Real)
      (declare-const ?aon Real)
      (declare-const ?aoo Real)
      (assert
        (or (or (= ?aoo ?aon)
            (= ?aoo ?aom)
            )
          (= ?aon ?aom)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aop Real)
      (declare-const ?aoq Real)
      (declare-const ?aor Real)
      (declare-const ?aos Real)
      (assert
        (or (or (= ?aos ?aor)
            (= ?aos ?aoq)
            )
          (= ?aor ?aoq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aot Real)
      (declare-const ?aou Real)
      (declare-const ?aov Real)
      (declare-const ?aow Real)
      (declare-const ?aox Real)
      (assert
        (or (or (= ?aox ?aow)
            (= ?aox ?aov)
            )
          (= ?aow ?aov)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aoy Real)
      (declare-const ?aoz Real)
      (declare-const ?apa Real)
      (declare-const ?apb Real)
      (declare-const ?apc Real)
      (declare-const ?apd Real)
      (assert
        (and (and (and (not (= ?apa ?aoz))
              (not (= ?apa ?aoy))
              )
            (not (= ?aoz ?aoy))
            )
          (or (or (= ?apd ?apc)
              (= ?apd ?apb)
              )
            (= ?apc ?apb)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ape Real)
      (declare-const ?apf Real)
      (declare-const ?apg Real)
      (assert
        (or (or (= ?apg ?apf)
            (= ?apg ?ape)
            )
          (= ?apf ?ape)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aph Real)
      (declare-const ?api Real)
      (declare-const ?apj Real)
      (assert
        (or (or (= ?apj ?api)
            (= ?apj ?aph)
            )
          (= ?api ?aph)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?apk Real)
      (declare-const ?apl Real)
      (declare-const ?apm Real)
      (declare-const ?apn Real)
      (assert
        (or (or (= ?apm ?apl)
            (= ?apm ?apk)
            )
          (= ?apl ?apk)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?apo Real)
      (declare-const ?app Real)
      (declare-const ?apq Real)
      (declare-const ?apr Real)
      (declare-const ?aps Real)
      (assert
        (or (or (= ?apq ?app)
            (= ?apq ?apo)
            )
          (= ?app ?apo)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?apt Real)
      (declare-const ?apu Real)
      (declare-const ?apv Real)
      (declare-const ?apw Real)
      (declare-const ?apx Real)
      (declare-const ?apy Real)
      (assert
        (and (or (or (= ?apv ?apu)
              (= ?apv ?apt)
              )
            (= ?apu ?apt)
            )
          (and (and (not (= ?apy ?apx))
              (not (= ?apy ?apw))
              )
            (not (= ?apx ?apw))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?apz Real)
      (declare-const ?aqa Real)
      (declare-const ?aqb Real)
      (assert
        (or (or (= ?aqb ?aqa)
            (= ?aqb ?apz)
            )
          (= ?aqa ?apz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aqc Real)
      (declare-const ?aqd Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aqe Real)
      (declare-const ?aqf Real)
      (declare-const ?aqg Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (= ?aol ?aok)
            (= ?aol ?aoj)
            )
          (= ?aok ?aoj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?aqh Real)
    (declare-const ?aqi Real)
    (declare-const ?aqj Real)
    (declare-const ?aqk Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?aql Real)
      (declare-const ?aqm Real)
      (declare-const ?aqn Real)
      (assert
        (or (or (= ?aqn ?aqm)
            (= ?aqn ?aql)
            )
          (= ?aqm ?aql)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aqo Real)
      (declare-const ?aqp Real)
      (declare-const ?aqq Real)
      (declare-const ?aqr Real)
      (assert
        (or (or (= ?aqr ?aqq)
            (= ?aqr ?aqp)
            )
          (= ?aqq ?aqp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aqs Real)
      (declare-const ?aqt Real)
      (declare-const ?aqu Real)
      (declare-const ?aqv Real)
      (declare-const ?aqw Real)
      (assert
        (or (or (= ?aqw ?aqv)
            (= ?aqw ?aqu)
            )
          (= ?aqv ?aqu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aqx Real)
      (declare-const ?aqy Real)
      (declare-const ?aqz Real)
      (declare-const ?ara Real)
      (declare-const ?arb Real)
      (declare-const ?arc Real)
      (assert
        (and (and (and (not (= ?aqz ?aqy))
              (not (= ?aqz ?aqx))
              )
            (not (= ?aqy ?aqx))
            )
          (or (or (= ?arc ?arb)
              (= ?arc ?ara)
              )
            (= ?arb ?ara)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ard Real)
      (declare-const ?are Real)
      (declare-const ?arf Real)
      (assert
        (or (or (= ?arf ?are)
            (= ?arf ?ard)
            )
          (= ?are ?ard)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?arg Real)
      (declare-const ?arh Real)
      (declare-const ?ari Real)
      (assert
        (or (or (= ?ari ?arh)
            (= ?ari ?arg)
            )
          (= ?arh ?arg)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?arj Real)
      (declare-const ?ark Real)
      (declare-const ?arl Real)
      (declare-const ?arm Real)
      (assert
        (or (or (= ?arl ?ark)
            (= ?arl ?arj)
            )
          (= ?ark ?arj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?arn Real)
      (declare-const ?aro Real)
      (declare-const ?arp Real)
      (declare-const ?arq Real)
      (declare-const ?arr Real)
      (assert
        (or (or (= ?arp ?aro)
            (= ?arp ?arn)
            )
          (= ?aro ?arn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ars Real)
      (declare-const ?art Real)
      (declare-const ?aru Real)
      (declare-const ?arv Real)
      (declare-const ?arw Real)
      (declare-const ?arx Real)
      (assert
        (and (or (or (= ?aru ?art)
              (= ?aru ?ars)
              )
            (= ?art ?ars)
            )
          (and (and (not (= ?arx ?arw))
              (not (= ?arx ?arv))
              )
            (not (= ?arw ?arv))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ary Real)
      (declare-const ?arz Real)
      (declare-const ?asa Real)
      (assert
        (or (or (= ?asa ?arz)
            (= ?asa ?ary)
            )
          (= ?arz ?ary)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?asb Real)
      (declare-const ?asc Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?asd Real)
      (declare-const ?ase Real)
      (declare-const ?asf Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?asg Real)
      (declare-const ?ash Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (= ?aqk ?aqj)
            (= ?aqk ?aqh)
            )
          (= ?aqj ?aqh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?asi Real)
    (declare-const ?asj Real)
    (declare-const ?ask Real)
    (declare-const ?asl Real)
    (declare-const ?asm Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?asn Real)
      (declare-const ?aso Real)
      (declare-const ?asp Real)
      (assert
        (or (or (= ?asp ?aso)
            (= ?asp ?asn)
            )
          (= ?aso ?asn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?asq Real)
      (declare-const ?asr Real)
      (declare-const ?ass Real)
      (declare-const ?ast Real)
      (assert
        (or (or (= ?ast ?ass)
            (= ?ast ?asr)
            )
          (= ?ass ?asr)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?asu Real)
      (declare-const ?asv Real)
      (declare-const ?asw Real)
      (declare-const ?asx Real)
      (declare-const ?asy Real)
      (assert
        (or (or (= ?asy ?asx)
            (= ?asy ?asw)
            )
          (= ?asx ?asw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?asz Real)
      (declare-const ?ata Real)
      (declare-const ?atb Real)
      (declare-const ?atc Real)
      (declare-const ?atd Real)
      (declare-const ?ate Real)
      (assert
        (and (and (and (not (= ?atb ?ata))
              (not (= ?atb ?asz))
              )
            (not (= ?ata ?asz))
            )
          (or (or (= ?ate ?atd)
              (= ?ate ?atc)
              )
            (= ?atd ?atc)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atf Real)
      (declare-const ?atg Real)
      (declare-const ?ath Real)
      (assert
        (or (or (= ?ath ?atg)
            (= ?ath ?atf)
            )
          (= ?atg ?atf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ati Real)
      (declare-const ?atj Real)
      (declare-const ?atk Real)
      (assert
        (or (or (= ?atk ?atj)
            (= ?atk ?ati)
            )
          (= ?atj ?ati)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atl Real)
      (declare-const ?atm Real)
      (declare-const ?atn Real)
      (declare-const ?ato Real)
      (assert
        (or (or (= ?atn ?atm)
            (= ?atn ?atl)
            )
          (= ?atm ?atl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atp Real)
      (declare-const ?atq Real)
      (declare-const ?atr Real)
      (declare-const ?ats Real)
      (declare-const ?att Real)
      (assert
        (or (or (= ?atr ?atq)
            (= ?atr ?atp)
            )
          (= ?atq ?atp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atu Real)
      (declare-const ?atv Real)
      (declare-const ?atw Real)
      (declare-const ?atx Real)
      (declare-const ?aty Real)
      (declare-const ?atz Real)
      (assert
        (and (or (or (= ?atw ?atv)
              (= ?atw ?atu)
              )
            (= ?atv ?atu)
            )
          (and (and (not (= ?atz ?aty))
              (not (= ?atz ?atx))
              )
            (not (= ?aty ?atx))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aua Real)
      (declare-const ?aub Real)
      (declare-const ?auc Real)
      (assert
        (or (or (= ?auc ?aub)
            (= ?auc ?aua)
            )
          (= ?aub ?aua)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aud Real)
      (declare-const ?aue Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?auf Real)
      (declare-const ?aug Real)
      (declare-const ?auh Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aui Real)
      (declare-const ?auj Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?auk Real)
      (declare-const ?aul Real)
      (declare-const ?aum Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (and (and (and (not (= ?ask ?asj))
                (not (= ?ask ?asi))
                )
              (not (= ?asj ?asi))
              )
            (or (or (= ?asm ?asl)
                (= ?asm ?asi)
                )
              (= ?asl ?asi)
              )
            )
          (and (or (or (= ?ask ?asj)
                (= ?ask ?asi)
                )
              (= ?asj ?asi)
              )
            (and (and (not (= ?asm ?asl))
                (not (= ?asm ?asi))
                )
              (not (= ?asl ?asi))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?aun Real)
    (declare-const ?auo Real)
    (declare-const ?aup Real)
    (declare-const ?auq Real)
    (declare-const ?aur Real)
    (declare-const ?aus Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?aut Real)
      (declare-const ?auu Real)
      (declare-const ?auv Real)
      (assert
        (or (or (= ?auv ?auu)
            (= ?auv ?aut)
            )
          (= ?auu ?aut)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?auw Real)
      (declare-const ?aux Real)
      (declare-const ?auy Real)
      (declare-const ?auz Real)
      (assert
        (or (or (= ?auz ?auy)
            (= ?auz ?aux)
            )
          (= ?auy ?aux)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ava Real)
      (declare-const ?avb Real)
      (declare-const ?avc Real)
      (declare-const ?avd Real)
      (declare-const ?ave Real)
      (assert
        (or (or (= ?ave ?avd)
            (= ?ave ?avc)
            )
          (= ?avd ?avc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?avf Real)
      (declare-const ?avg Real)
      (declare-const ?avh Real)
      (declare-const ?avi Real)
      (declare-const ?avj Real)
      (declare-const ?avk Real)
      (assert
        (and (and (and (not (= ?avh ?avg))
              (not (= ?avh ?avf))
              )
            (not (= ?avg ?avf))
            )
          (or (or (= ?avk ?avj)
              (= ?avk ?avi)
              )
            (= ?avj ?avi)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?avl Real)
      (declare-const ?avm Real)
      (declare-const ?avn Real)
      (assert
        (or (or (= ?avn ?avm)
            (= ?avn ?avl)
            )
          (= ?avm ?avl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?avo Real)
      (declare-const ?avp Real)
      (declare-const ?avq Real)
      (assert
        (or (or (= ?avq ?avp)
            (= ?avq ?avo)
            )
          (= ?avp ?avo)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?avr Real)
      (declare-const ?avs Real)
      (declare-const ?avt Real)
      (declare-const ?avu Real)
      (assert
        (or (or (= ?avt ?avs)
            (= ?avt ?avr)
            )
          (= ?avs ?avr)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?avv Real)
      (declare-const ?avw Real)
      (declare-const ?avx Real)
      (declare-const ?avy Real)
      (declare-const ?avz Real)
      (assert
        (or (or (= ?avx ?avw)
            (= ?avx ?avv)
            )
          (= ?avw ?avv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?awa Real)
      (declare-const ?awb Real)
      (declare-const ?awc Real)
      (declare-const ?awd Real)
      (declare-const ?awe Real)
      (declare-const ?awf Real)
      (assert
        (and (or (or (= ?awc ?awb)
              (= ?awc ?awa)
              )
            (= ?awb ?awa)
            )
          (and (and (not (= ?awf ?awe))
              (not (= ?awf ?awd))
              )
            (not (= ?awe ?awd))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?awg Real)
      (declare-const ?awh Real)
      (declare-const ?awi Real)
      (assert
        (or (or (= ?awi ?awh)
            (= ?awi ?awg)
            )
          (= ?awh ?awg)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?awj Real)
      (declare-const ?awk Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?awl Real)
      (declare-const ?awm Real)
      (declare-const ?awn Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?awo Real)
      (declare-const ?awp Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?awq Real)
      (declare-const ?awr Real)
      (declare-const ?aws Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?awt Real)
      (declare-const ?awu Real)
      (declare-const ?awv Real)
      (declare-const ?aww Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?awu ?awt))
                  (not (= ?awu ?asi))
                  )
                (not (= ?awt ?asi))
                )
              (or (or (= ?aww ?awv)
                  (= ?aww ?asi)
                  )
                (= ?awv ?asi)
                )
              )
            (and (or (or (= ?awu ?awt)
                  (= ?awu ?asi)
                  )
                (= ?awt ?asi)
                )
              (and (and (not (= ?aww ?awv))
                  (not (= ?aww ?asi))
                  )
                (not (= ?awv ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (= ?aus ?aur)
            (= ?aus ?aun)
            )
          (= ?aur ?aun)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?awx Real)
    (declare-const ?awy Real)
    (declare-const ?awz Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?axa Real)
      (declare-const ?axb Real)
      (declare-const ?axc Real)
      (assert
        (or (or (= ?axc ?axb)
            (= ?axc ?axa)
            )
          (= ?axb ?axa)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?axd Real)
      (declare-const ?axe Real)
      (declare-const ?axf Real)
      (declare-const ?axg Real)
      (assert
        (or (or (= ?axg ?axf)
            (= ?axg ?axe)
            )
          (= ?axf ?axe)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?axh Real)
      (declare-const ?axi Real)
      (declare-const ?axj Real)
      (declare-const ?axk Real)
      (declare-const ?axl Real)
      (assert
        (or (or (= ?axl ?axk)
            (= ?axl ?axj)
            )
          (= ?axk ?axj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?axm Real)
      (declare-const ?axn Real)
      (declare-const ?axo Real)
      (declare-const ?axp Real)
      (declare-const ?axq Real)
      (declare-const ?axr Real)
      (assert
        (and (and (and (not (= ?axo ?axn))
              (not (= ?axo ?axm))
              )
            (not (= ?axn ?axm))
            )
          (or (or (= ?axr ?axq)
              (= ?axr ?axp)
              )
            (= ?axq ?axp)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?axs Real)
      (declare-const ?axt Real)
      (declare-const ?axu Real)
      (assert
        (or (or (= ?axu ?axt)
            (= ?axu ?axs)
            )
          (= ?axt ?axs)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?axv Real)
      (declare-const ?axw Real)
      (declare-const ?axx Real)
      (assert
        (or (or (= ?axx ?axw)
            (= ?axx ?axv)
            )
          (= ?axw ?axv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?axy Real)
      (declare-const ?axz Real)
      (declare-const ?aya Real)
      (declare-const ?ayb Real)
      (assert
        (or (or (= ?aya ?axz)
            (= ?aya ?axy)
            )
          (= ?axz ?axy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ayc Real)
      (declare-const ?ayd Real)
      (declare-const ?aye Real)
      (declare-const ?ayf Real)
      (declare-const ?ayg Real)
      (assert
        (or (or (= ?aye ?ayd)
            (= ?aye ?ayc)
            )
          (= ?ayd ?ayc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ayh Real)
      (declare-const ?ayi Real)
      (declare-const ?ayj Real)
      (declare-const ?ayk Real)
      (declare-const ?ayl Real)
      (declare-const ?aym Real)
      (assert
        (and (or (or (= ?ayj ?ayi)
              (= ?ayj ?ayh)
              )
            (= ?ayi ?ayh)
            )
          (and (and (not (= ?aym ?ayl))
              (not (= ?aym ?ayk))
              )
            (not (= ?ayl ?ayk))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ayn Real)
      (declare-const ?ayo Real)
      (declare-const ?ayp Real)
      (assert
        (or (or (= ?ayp ?ayo)
            (= ?ayp ?ayn)
            )
          (= ?ayo ?ayn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ayq Real)
      (declare-const ?ayr Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ays Real)
      (declare-const ?ayt Real)
      (declare-const ?ayu Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ayv Real)
      (declare-const ?ayw Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ayx Real)
      (declare-const ?ayy Real)
      (declare-const ?ayz Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aza Real)
      (declare-const ?azb Real)
      (declare-const ?azc Real)
      (declare-const ?azd Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?azb ?aza))
                  (not (= ?azb ?asi))
                  )
                (not (= ?aza ?asi))
                )
              (or (or (= ?azd ?azc)
                  (= ?azd ?asi)
                  )
                (= ?azc ?asi)
                )
              )
            (and (or (or (= ?azb ?aza)
                  (= ?azb ?asi)
                  )
                (= ?aza ?asi)
                )
              (and (and (not (= ?azd ?azc))
                  (not (= ?azd ?asi))
                  )
                (not (= ?azc ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aze Real)
      (declare-const ?azf Real)
      (declare-const ?azg Real)
      (declare-const ?azh Real)
      (declare-const ?azi Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (= ?awz ?awy)
            (= ?awz ?awx)
            )
          (= ?awy ?awx)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?azj Real)
    (declare-const ?azk Real)
    (declare-const ?azl Real)
    (declare-const ?azm Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?azn Real)
      (declare-const ?azo Real)
      (declare-const ?azp Real)
      (assert
        (or (or (= ?azp ?azo)
            (= ?azp ?azn)
            )
          (= ?azo ?azn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azq Real)
      (declare-const ?azr Real)
      (declare-const ?azs Real)
      (declare-const ?azt Real)
      (assert
        (or (or (= ?azt ?azs)
            (= ?azt ?azr)
            )
          (= ?azs ?azr)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azu Real)
      (declare-const ?azv Real)
      (declare-const ?azw Real)
      (declare-const ?azx Real)
      (declare-const ?azy Real)
      (assert
        (or (or (= ?azy ?azx)
            (= ?azy ?azw)
            )
          (= ?azx ?azw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azz Real)
      (declare-const ?baa Real)
      (declare-const ?bab Real)
      (declare-const ?bac Real)
      (declare-const ?bad Real)
      (declare-const ?bae Real)
      (assert
        (and (and (and (not (= ?bab ?baa))
              (not (= ?bab ?azz))
              )
            (not (= ?baa ?azz))
            )
          (or (or (= ?bae ?bad)
              (= ?bae ?bac)
              )
            (= ?bad ?bac)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baf Real)
      (declare-const ?bag Real)
      (declare-const ?bah Real)
      (assert
        (or (or (= ?bah ?bag)
            (= ?bah ?baf)
            )
          (= ?bag ?baf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bai Real)
      (declare-const ?baj Real)
      (declare-const ?bak Real)
      (assert
        (or (or (= ?bak ?baj)
            (= ?bak ?bai)
            )
          (= ?baj ?bai)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bal Real)
      (declare-const ?bam Real)
      (declare-const ?ban Real)
      (declare-const ?bao Real)
      (assert
        (or (or (= ?ban ?bam)
            (= ?ban ?bal)
            )
          (= ?bam ?bal)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bap Real)
      (declare-const ?baq Real)
      (declare-const ?bar Real)
      (declare-const ?bas Real)
      (declare-const ?bat Real)
      (assert
        (or (or (= ?bar ?baq)
            (= ?bar ?bap)
            )
          (= ?baq ?bap)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bau Real)
      (declare-const ?bav Real)
      (declare-const ?baw Real)
      (declare-const ?bax Real)
      (declare-const ?bay Real)
      (declare-const ?baz Real)
      (assert
        (and (or (or (= ?baw ?bav)
              (= ?baw ?bau)
              )
            (= ?bav ?bau)
            )
          (and (and (not (= ?baz ?bay))
              (not (= ?baz ?bax))
              )
            (not (= ?bay ?bax))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bba Real)
      (declare-const ?bbb Real)
      (declare-const ?bbc Real)
      (assert
        (or (or (= ?bbc ?bbb)
            (= ?bbc ?bba)
            )
          (= ?bbb ?bba)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbd Real)
      (declare-const ?bbe Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbf Real)
      (declare-const ?bbg Real)
      (declare-const ?bbh Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbi Real)
      (declare-const ?bbj Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbk Real)
      (declare-const ?bbl Real)
      (declare-const ?bbm Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbn Real)
      (declare-const ?bbo Real)
      (declare-const ?bbp Real)
      (declare-const ?bbq Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?bbo ?bbn))
                  (not (= ?bbo ?asi))
                  )
                (not (= ?bbn ?asi))
                )
              (or (or (= ?bbq ?bbp)
                  (= ?bbq ?asi)
                  )
                (= ?bbp ?asi)
                )
              )
            (and (or (or (= ?bbo ?bbn)
                  (= ?bbo ?asi)
                  )
                (= ?bbn ?asi)
                )
              (and (and (not (= ?bbq ?bbp))
                  (not (= ?bbq ?asi))
                  )
                (not (= ?bbp ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbr Real)
      (declare-const ?bbs Real)
      (declare-const ?bbt Real)
      (declare-const ?bbu Real)
      (declare-const ?bbv Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbw Real)
      (declare-const ?bbx Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bby Real)
    (declare-const ?bbz Real)
    (declare-const ?bca Real)
    (declare-const ?bcb Real)
    (declare-const ?bcc Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?bcd Real)
      (declare-const ?bce Real)
      (declare-const ?bcf Real)
      (assert
        (or (or (= ?bcf ?bce)
            (= ?bcf ?bcd)
            )
          (= ?bce ?bcd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bcg Real)
      (declare-const ?bch Real)
      (declare-const ?bci Real)
      (declare-const ?bcj Real)
      (assert
        (or (or (= ?bcj ?bci)
            (= ?bcj ?bch)
            )
          (= ?bci ?bch)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bck Real)
      (declare-const ?bcl Real)
      (declare-const ?bcm Real)
      (declare-const ?bcn Real)
      (declare-const ?bco Real)
      (assert
        (or (or (= ?bco ?bcn)
            (= ?bco ?bcm)
            )
          (= ?bcn ?bcm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bcp Real)
      (declare-const ?bcq Real)
      (declare-const ?bcr Real)
      (declare-const ?bcs Real)
      (declare-const ?bct Real)
      (declare-const ?bcu Real)
      (assert
        (and (and (and (not (= ?bcr ?bcq))
              (not (= ?bcr ?bcp))
              )
            (not (= ?bcq ?bcp))
            )
          (or (or (= ?bcu ?bct)
              (= ?bcu ?bcs)
              )
            (= ?bct ?bcs)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bcv Real)
      (declare-const ?bcw Real)
      (declare-const ?bcx Real)
      (assert
        (or (or (= ?bcx ?bcw)
            (= ?bcx ?bcv)
            )
          (= ?bcw ?bcv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bcy Real)
      (declare-const ?bcz Real)
      (declare-const ?bda Real)
      (assert
        (or (or (= ?bda ?bcz)
            (= ?bda ?bcy)
            )
          (= ?bcz ?bcy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bdb Real)
      (declare-const ?bdc Real)
      (declare-const ?bdd Real)
      (declare-const ?bde Real)
      (assert
        (or (or (= ?bdd ?bdc)
            (= ?bdd ?bdb)
            )
          (= ?bdc ?bdb)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bdf Real)
      (declare-const ?bdg Real)
      (declare-const ?bdh Real)
      (declare-const ?bdi Real)
      (declare-const ?bdj Real)
      (assert
        (or (or (= ?bdh ?bdg)
            (= ?bdh ?bdf)
            )
          (= ?bdg ?bdf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bdk Real)
      (declare-const ?bdl Real)
      (declare-const ?bdm Real)
      (declare-const ?bdn Real)
      (declare-const ?bdo Real)
      (declare-const ?bdp Real)
      (assert
        (and (or (or (= ?bdm ?bdl)
              (= ?bdm ?bdk)
              )
            (= ?bdl ?bdk)
            )
          (and (and (not (= ?bdp ?bdo))
              (not (= ?bdp ?bdn))
              )
            (not (= ?bdo ?bdn))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bdq Real)
      (declare-const ?bdr Real)
      (declare-const ?bds Real)
      (assert
        (or (or (= ?bds ?bdr)
            (= ?bds ?bdq)
            )
          (= ?bdr ?bdq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bdt Real)
      (declare-const ?bdu Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bdv Real)
      (declare-const ?bdw Real)
      (declare-const ?bdx Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bdy Real)
      (declare-const ?bdz Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bea Real)
      (declare-const ?beb Real)
      (declare-const ?bec Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bed Real)
      (declare-const ?bee Real)
      (declare-const ?bef Real)
      (declare-const ?beg Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?bee ?bed))
                  (not (= ?bee ?asi))
                  )
                (not (= ?bed ?asi))
                )
              (or (or (= ?beg ?bef)
                  (= ?beg ?asi)
                  )
                (= ?bef ?asi)
                )
              )
            (and (or (or (= ?bee ?bed)
                  (= ?bee ?asi)
                  )
                (= ?bed ?asi)
                )
              (and (and (not (= ?beg ?bef))
                  (not (= ?beg ?asi))
                  )
                (not (= ?bef ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?beh Real)
      (declare-const ?bei Real)
      (declare-const ?bej Real)
      (declare-const ?bek Real)
      (declare-const ?bel Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bem Real)
      (declare-const ?ben Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?beo Real)
    (declare-const ?bep Real)
    (declare-const ?beq Real)
    (declare-const ?ber Real)
    (declare-const ?bes Real)
    (declare-const ?bet Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?beu Real)
      (declare-const ?bev Real)
      (declare-const ?bew Real)
      (assert
        (or (or (= ?bew ?bev)
            (= ?bew ?beu)
            )
          (= ?bev ?beu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bex Real)
      (declare-const ?bey Real)
      (declare-const ?bez Real)
      (declare-const ?bfa Real)
      (assert
        (or (or (= ?bfa ?bez)
            (= ?bfa ?bey)
            )
          (= ?bez ?bey)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfb Real)
      (declare-const ?bfc Real)
      (declare-const ?bfd Real)
      (declare-const ?bfe Real)
      (declare-const ?bff Real)
      (assert
        (or (or (= ?bff ?bfe)
            (= ?bff ?bfd)
            )
          (= ?bfe ?bfd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfg Real)
      (declare-const ?bfh Real)
      (declare-const ?bfi Real)
      (declare-const ?bfj Real)
      (declare-const ?bfk Real)
      (declare-const ?bfl Real)
      (assert
        (and (and (and (not (= ?bfi ?bfh))
              (not (= ?bfi ?bfg))
              )
            (not (= ?bfh ?bfg))
            )
          (or (or (= ?bfl ?bfk)
              (= ?bfl ?bfj)
              )
            (= ?bfk ?bfj)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfm Real)
      (declare-const ?bfn Real)
      (declare-const ?bfo Real)
      (assert
        (or (or (= ?bfo ?bfn)
            (= ?bfo ?bfm)
            )
          (= ?bfn ?bfm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfp Real)
      (declare-const ?bfq Real)
      (declare-const ?bfr Real)
      (assert
        (or (or (= ?bfr ?bfq)
            (= ?bfr ?bfp)
            )
          (= ?bfq ?bfp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfs Real)
      (declare-const ?bft Real)
      (declare-const ?bfu Real)
      (declare-const ?bfv Real)
      (assert
        (or (or (= ?bfu ?bft)
            (= ?bfu ?bfs)
            )
          (= ?bft ?bfs)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfw Real)
      (declare-const ?bfx Real)
      (declare-const ?bfy Real)
      (declare-const ?bfz Real)
      (declare-const ?bga Real)
      (assert
        (or (or (= ?bfy ?bfx)
            (= ?bfy ?bfw)
            )
          (= ?bfx ?bfw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bgb Real)
      (declare-const ?bgc Real)
      (declare-const ?bgd Real)
      (declare-const ?bge Real)
      (declare-const ?bgf Real)
      (declare-const ?bgg Real)
      (assert
        (and (or (or (= ?bgd ?bgc)
              (= ?bgd ?bgb)
              )
            (= ?bgc ?bgb)
            )
          (and (and (not (= ?bgg ?bgf))
              (not (= ?bgg ?bge))
              )
            (not (= ?bgf ?bge))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bgh Real)
      (declare-const ?bgi Real)
      (declare-const ?bgj Real)
      (assert
        (or (or (= ?bgj ?bgi)
            (= ?bgj ?bgh)
            )
          (= ?bgi ?bgh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bgk Real)
      (declare-const ?bgl Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bgm Real)
      (declare-const ?bgn Real)
      (declare-const ?bgo Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bgp Real)
      (declare-const ?bgq Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bgr Real)
      (declare-const ?bgs Real)
      (declare-const ?bgt Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bgu Real)
      (declare-const ?bgv Real)
      (declare-const ?bgw Real)
      (declare-const ?bgx Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?bgv ?bgu))
                  (not (= ?bgv ?asi))
                  )
                (not (= ?bgu ?asi))
                )
              (or (or (= ?bgx ?bgw)
                  (= ?bgx ?asi)
                  )
                (= ?bgw ?asi)
                )
              )
            (and (or (or (= ?bgv ?bgu)
                  (= ?bgv ?asi)
                  )
                (= ?bgu ?asi)
                )
              (and (and (not (= ?bgx ?bgw))
                  (not (= ?bgx ?asi))
                  )
                (not (= ?bgw ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bgy Real)
      (declare-const ?bgz Real)
      (declare-const ?bha Real)
      (declare-const ?bhb Real)
      (declare-const ?bhc Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhd Real)
      (declare-const ?bhe Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (= ?beq ?bep)
            (= ?beq ?beo)
            )
          (= ?bep ?beo)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bhf Real)
    (declare-const ?bhg Real)
    (declare-const ?bhh Real)
    (declare-const ?bhi Real)
    (declare-const ?bhj Real)
    (declare-const ?bhk Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?bhl Real)
      (declare-const ?bhm Real)
      (declare-const ?bhn Real)
      (assert
        (or (or (= ?bhn ?bhm)
            (= ?bhn ?bhl)
            )
          (= ?bhm ?bhl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bho Real)
      (declare-const ?bhp Real)
      (declare-const ?bhq Real)
      (declare-const ?bhr Real)
      (assert
        (or (or (= ?bhr ?bhq)
            (= ?bhr ?bhp)
            )
          (= ?bhq ?bhp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhs Real)
      (declare-const ?bht Real)
      (declare-const ?bhu Real)
      (declare-const ?bhv Real)
      (declare-const ?bhw Real)
      (assert
        (or (or (= ?bhw ?bhv)
            (= ?bhw ?bhu)
            )
          (= ?bhv ?bhu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhx Real)
      (declare-const ?bhy Real)
      (declare-const ?bhz Real)
      (declare-const ?bia Real)
      (declare-const ?bib Real)
      (declare-const ?bic Real)
      (assert
        (and (and (and (not (= ?bhz ?bhy))
              (not (= ?bhz ?bhx))
              )
            (not (= ?bhy ?bhx))
            )
          (or (or (= ?bic ?bib)
              (= ?bic ?bia)
              )
            (= ?bib ?bia)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bid Real)
      (declare-const ?bie Real)
      (declare-const ?bif Real)
      (assert
        (or (or (= ?bif ?bie)
            (= ?bif ?bid)
            )
          (= ?bie ?bid)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?big Real)
      (declare-const ?bih Real)
      (declare-const ?bii Real)
      (assert
        (or (or (= ?bii ?bih)
            (= ?bii ?big)
            )
          (= ?bih ?big)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bij Real)
      (declare-const ?bik Real)
      (declare-const ?bil Real)
      (declare-const ?bim Real)
      (assert
        (or (or (= ?bil ?bik)
            (= ?bil ?bij)
            )
          (= ?bik ?bij)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bin Real)
      (declare-const ?bio Real)
      (declare-const ?bip Real)
      (declare-const ?biq Real)
      (declare-const ?bir Real)
      (assert
        (or (or (= ?bip ?bio)
            (= ?bip ?bin)
            )
          (= ?bio ?bin)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bis Real)
      (declare-const ?bit Real)
      (declare-const ?biu Real)
      (declare-const ?biv Real)
      (declare-const ?biw Real)
      (declare-const ?bix Real)
      (assert
        (and (or (or (= ?biu ?bit)
              (= ?biu ?bis)
              )
            (= ?bit ?bis)
            )
          (and (and (not (= ?bix ?biw))
              (not (= ?bix ?biv))
              )
            (not (= ?biw ?biv))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?biy Real)
      (declare-const ?biz Real)
      (declare-const ?bja Real)
      (assert
        (or (or (= ?bja ?biz)
            (= ?bja ?biy)
            )
          (= ?biz ?biy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjb Real)
      (declare-const ?bjc Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjd Real)
      (declare-const ?bje Real)
      (declare-const ?bjf Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjg Real)
      (declare-const ?bjh Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bji Real)
      (declare-const ?bjj Real)
      (declare-const ?bjk Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjl Real)
      (declare-const ?bjm Real)
      (declare-const ?bjn Real)
      (declare-const ?bjo Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?bjm ?bjl))
                  (not (= ?bjm ?asi))
                  )
                (not (= ?bjl ?asi))
                )
              (or (or (= ?bjo ?bjn)
                  (= ?bjo ?asi)
                  )
                (= ?bjn ?asi)
                )
              )
            (and (or (or (= ?bjm ?bjl)
                  (= ?bjm ?asi)
                  )
                (= ?bjl ?asi)
                )
              (and (and (not (= ?bjo ?bjn))
                  (not (= ?bjo ?asi))
                  )
                (not (= ?bjn ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjp Real)
      (declare-const ?bjq Real)
      (declare-const ?bjr Real)
      (declare-const ?bjs Real)
      (declare-const ?bjt Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bju Real)
      (declare-const ?bjv Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjw Real)
      (declare-const ?bjx Real)
      (declare-const ?bjy Real)
      (declare-const ?bjz Real)
      (declare-const ?bka Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bkb Real)
    (declare-const ?bkc Real)
    (declare-const ?bkd Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?bke Real)
      (declare-const ?bkf Real)
      (declare-const ?bkg Real)
      (assert
        (or (or (= ?bkg ?bkf)
            (= ?bkg ?bke)
            )
          (= ?bkf ?bke)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkh Real)
      (declare-const ?bki Real)
      (declare-const ?bkj Real)
      (declare-const ?bkk Real)
      (assert
        (or (or (= ?bkk ?bkj)
            (= ?bkk ?bki)
            )
          (= ?bkj ?bki)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkl Real)
      (declare-const ?bkm Real)
      (declare-const ?bkn Real)
      (declare-const ?bko Real)
      (declare-const ?bkp Real)
      (assert
        (or (or (= ?bkp ?bko)
            (= ?bkp ?bkn)
            )
          (= ?bko ?bkn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkq Real)
      (declare-const ?bkr Real)
      (declare-const ?bks Real)
      (declare-const ?bkt Real)
      (declare-const ?bku Real)
      (declare-const ?bkv Real)
      (assert
        (and (and (and (not (= ?bks ?bkr))
              (not (= ?bks ?bkq))
              )
            (not (= ?bkr ?bkq))
            )
          (or (or (= ?bkv ?bku)
              (= ?bkv ?bkt)
              )
            (= ?bku ?bkt)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkw Real)
      (declare-const ?bkx Real)
      (declare-const ?bky Real)
      (assert
        (or (or (= ?bky ?bkx)
            (= ?bky ?bkw)
            )
          (= ?bkx ?bkw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkz Real)
      (declare-const ?bla Real)
      (declare-const ?blb Real)
      (assert
        (or (or (= ?blb ?bla)
            (= ?blb ?bkz)
            )
          (= ?bla ?bkz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?blc Real)
      (declare-const ?bld Real)
      (declare-const ?ble Real)
      (declare-const ?blf Real)
      (assert
        (or (or (= ?ble ?bld)
            (= ?ble ?blc)
            )
          (= ?bld ?blc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?blg Real)
      (declare-const ?blh Real)
      (declare-const ?bli Real)
      (declare-const ?blj Real)
      (declare-const ?blk Real)
      (assert
        (or (or (= ?bli ?blh)
            (= ?bli ?blg)
            )
          (= ?blh ?blg)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bll Real)
      (declare-const ?blm Real)
      (declare-const ?bln Real)
      (declare-const ?blo Real)
      (declare-const ?blp Real)
      (declare-const ?blq Real)
      (assert
        (and (or (or (= ?bln ?blm)
              (= ?bln ?bll)
              )
            (= ?blm ?bll)
            )
          (and (and (not (= ?blq ?blp))
              (not (= ?blq ?blo))
              )
            (not (= ?blp ?blo))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?blr Real)
      (declare-const ?bls Real)
      (declare-const ?blt Real)
      (assert
        (or (or (= ?blt ?bls)
            (= ?blt ?blr)
            )
          (= ?bls ?blr)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?blu Real)
      (declare-const ?blv Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?blw Real)
      (declare-const ?blx Real)
      (declare-const ?bly Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?blz Real)
      (declare-const ?bma Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bmb Real)
      (declare-const ?bmc Real)
      (declare-const ?bmd Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bme Real)
      (declare-const ?bmf Real)
      (declare-const ?bmg Real)
      (declare-const ?bmh Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?bmf ?bme))
                  (not (= ?bmf ?asi))
                  )
                (not (= ?bme ?asi))
                )
              (or (or (= ?bmh ?bmg)
                  (= ?bmh ?asi)
                  )
                (= ?bmg ?asi)
                )
              )
            (and (or (or (= ?bmf ?bme)
                  (= ?bmf ?asi)
                  )
                (= ?bme ?asi)
                )
              (and (and (not (= ?bmh ?bmg))
                  (not (= ?bmh ?asi))
                  )
                (not (= ?bmg ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bmi Real)
      (declare-const ?bmj Real)
      (declare-const ?bmk Real)
      (declare-const ?bml Real)
      (declare-const ?bmm Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bmn Real)
      (declare-const ?bmo Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bmp Real)
      (declare-const ?bmq Real)
      (declare-const ?bmr Real)
      (declare-const ?bms Real)
      (declare-const ?bmt Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bmu Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?bmv Real)
      (declare-const ?bmw Real)
      (declare-const ?bmx Real)
      (assert
        (or (or (= ?bmx ?bmw)
            (= ?bmx ?bmv)
            )
          (= ?bmw ?bmv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bmy Real)
      (declare-const ?bmz Real)
      (declare-const ?bna Real)
      (declare-const ?bnb Real)
      (assert
        (or (or (= ?bnb ?bna)
            (= ?bnb ?bmz)
            )
          (= ?bna ?bmz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bnc Real)
      (declare-const ?bnd Real)
      (declare-const ?bne Real)
      (declare-const ?bnf Real)
      (declare-const ?bng Real)
      (assert
        (or (or (= ?bng ?bnf)
            (= ?bng ?bne)
            )
          (= ?bnf ?bne)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bnh Real)
      (declare-const ?bni Real)
      (declare-const ?bnj Real)
      (declare-const ?bnk Real)
      (declare-const ?bnl Real)
      (declare-const ?bnm Real)
      (assert
        (and (and (and (not (= ?bnj ?bni))
              (not (= ?bnj ?bnh))
              )
            (not (= ?bni ?bnh))
            )
          (or (or (= ?bnm ?bnl)
              (= ?bnm ?bnk)
              )
            (= ?bnl ?bnk)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bnn Real)
      (declare-const ?bno Real)
      (declare-const ?bnp Real)
      (assert
        (or (or (= ?bnp ?bno)
            (= ?bnp ?bnn)
            )
          (= ?bno ?bnn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bnq Real)
      (declare-const ?bnr Real)
      (declare-const ?bns Real)
      (assert
        (or (or (= ?bns ?bnr)
            (= ?bns ?bnq)
            )
          (= ?bnr ?bnq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bnt Real)
      (declare-const ?bnu Real)
      (declare-const ?bnv Real)
      (declare-const ?bnw Real)
      (assert
        (or (or (= ?bnv ?bnu)
            (= ?bnv ?bnt)
            )
          (= ?bnu ?bnt)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bnx Real)
      (declare-const ?bny Real)
      (declare-const ?bnz Real)
      (declare-const ?boa Real)
      (declare-const ?bob Real)
      (assert
        (or (or (= ?bnz ?bny)
            (= ?bnz ?bnx)
            )
          (= ?bny ?bnx)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?boc Real)
      (declare-const ?bod Real)
      (declare-const ?boe Real)
      (declare-const ?bof Real)
      (declare-const ?bog Real)
      (declare-const ?boh Real)
      (assert
        (and (or (or (= ?boe ?bod)
              (= ?boe ?boc)
              )
            (= ?bod ?boc)
            )
          (and (and (not (= ?boh ?bog))
              (not (= ?boh ?bof))
              )
            (not (= ?bog ?bof))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?boi Real)
      (declare-const ?boj Real)
      (declare-const ?bok Real)
      (assert
        (or (or (= ?bok ?boj)
            (= ?bok ?boi)
            )
          (= ?boj ?boi)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bol Real)
      (declare-const ?bom Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bon Real)
      (declare-const ?boo Real)
      (declare-const ?bop Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?boq Real)
      (declare-const ?bor Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bos Real)
      (declare-const ?bot Real)
      (declare-const ?bou Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bov Real)
      (declare-const ?bow Real)
      (declare-const ?box Real)
      (declare-const ?boy Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?bow ?bov))
                  (not (= ?bow ?asi))
                  )
                (not (= ?bov ?asi))
                )
              (or (or (= ?boy ?box)
                  (= ?boy ?asi)
                  )
                (= ?box ?asi)
                )
              )
            (and (or (or (= ?bow ?bov)
                  (= ?bow ?asi)
                  )
                (= ?bov ?asi)
                )
              (and (and (not (= ?boy ?box))
                  (not (= ?boy ?asi))
                  )
                (not (= ?box ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?boz Real)
      (declare-const ?bpa Real)
      (declare-const ?bpb Real)
      (declare-const ?bpc Real)
      (declare-const ?bpd Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bpe Real)
      (declare-const ?bpf Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bpg Real)
      (declare-const ?bph Real)
      (declare-const ?bpi Real)
      (declare-const ?bpj Real)
      (declare-const ?bpk Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bpl Real)
    (declare-const ?bpm Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?bpn Real)
      (declare-const ?bpo Real)
      (declare-const ?bpp Real)
      (assert
        (or (or (= ?bpp ?bpo)
            (= ?bpp ?bpn)
            )
          (= ?bpo ?bpn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bpq Real)
      (declare-const ?bpr Real)
      (declare-const ?bps Real)
      (declare-const ?bpt Real)
      (assert
        (or (or (= ?bpt ?bps)
            (= ?bpt ?bpr)
            )
          (= ?bps ?bpr)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bpu Real)
      (declare-const ?bpv Real)
      (declare-const ?bpw Real)
      (declare-const ?bpx Real)
      (declare-const ?bpy Real)
      (assert
        (or (or (= ?bpy ?bpx)
            (= ?bpy ?bpw)
            )
          (= ?bpx ?bpw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bpz Real)
      (declare-const ?bqa Real)
      (declare-const ?bqb Real)
      (declare-const ?bqc Real)
      (declare-const ?bqd Real)
      (declare-const ?bqe Real)
      (assert
        (and (and (and (not (= ?bqb ?bqa))
              (not (= ?bqb ?bpz))
              )
            (not (= ?bqa ?bpz))
            )
          (or (or (= ?bqe ?bqd)
              (= ?bqe ?bqc)
              )
            (= ?bqd ?bqc)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bqf Real)
      (declare-const ?bqg Real)
      (declare-const ?bqh Real)
      (assert
        (or (or (= ?bqh ?bqg)
            (= ?bqh ?bqf)
            )
          (= ?bqg ?bqf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bqi Real)
      (declare-const ?bqj Real)
      (declare-const ?bqk Real)
      (assert
        (or (or (= ?bqk ?bqj)
            (= ?bqk ?bqi)
            )
          (= ?bqj ?bqi)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bql Real)
      (declare-const ?bqm Real)
      (declare-const ?bqn Real)
      (declare-const ?bqo Real)
      (assert
        (or (or (= ?bqn ?bqm)
            (= ?bqn ?bql)
            )
          (= ?bqm ?bql)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bqp Real)
      (declare-const ?bqq Real)
      (declare-const ?bqr Real)
      (declare-const ?bqs Real)
      (declare-const ?bqt Real)
      (assert
        (or (or (= ?bqr ?bqq)
            (= ?bqr ?bqp)
            )
          (= ?bqq ?bqp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bqu Real)
      (declare-const ?bqv Real)
      (declare-const ?bqw Real)
      (declare-const ?bqx Real)
      (declare-const ?bqy Real)
      (declare-const ?bqz Real)
      (assert
        (and (or (or (= ?bqw ?bqv)
              (= ?bqw ?bqu)
              )
            (= ?bqv ?bqu)
            )
          (and (and (not (= ?bqz ?bqy))
              (not (= ?bqz ?bqx))
              )
            (not (= ?bqy ?bqx))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bra Real)
      (declare-const ?brb Real)
      (declare-const ?brc Real)
      (assert
        (or (or (= ?brc ?brb)
            (= ?brc ?bra)
            )
          (= ?brb ?bra)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?brd Real)
      (declare-const ?bre Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?brf Real)
      (declare-const ?brg Real)
      (declare-const ?brh Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bri Real)
      (declare-const ?brj Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?brk Real)
      (declare-const ?brl Real)
      (declare-const ?brm Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?brn Real)
      (declare-const ?bro Real)
      (declare-const ?brp Real)
      (declare-const ?brq Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?bro ?brn))
                  (not (= ?bro ?asi))
                  )
                (not (= ?brn ?asi))
                )
              (or (or (= ?brq ?brp)
                  (= ?brq ?asi)
                  )
                (= ?brp ?asi)
                )
              )
            (and (or (or (= ?bro ?brn)
                  (= ?bro ?asi)
                  )
                (= ?brn ?asi)
                )
              (and (and (not (= ?brq ?brp))
                  (not (= ?brq ?asi))
                  )
                (not (= ?brp ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?brr Real)
      (declare-const ?brs Real)
      (declare-const ?brt Real)
      (declare-const ?bru Real)
      (declare-const ?brv Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?brw Real)
      (declare-const ?brx Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bry Real)
      (declare-const ?brz Real)
      (declare-const ?bsa Real)
      (declare-const ?bsb Real)
      (declare-const ?bsc Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bsd Real)
    (declare-const ?bse Real)
    (declare-const ?bsf Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?bsg Real)
      (declare-const ?bsh Real)
      (declare-const ?bsi Real)
      (assert
        (or (or (= ?bsi ?bsh)
            (= ?bsi ?bsg)
            )
          (= ?bsh ?bsg)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bsj Real)
      (declare-const ?bsk Real)
      (declare-const ?bsl Real)
      (declare-const ?bsm Real)
      (assert
        (or (or (= ?bsm ?bsl)
            (= ?bsm ?bsk)
            )
          (= ?bsl ?bsk)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bsn Real)
      (declare-const ?bso Real)
      (declare-const ?bsp Real)
      (declare-const ?bsq Real)
      (declare-const ?bsr Real)
      (assert
        (or (or (= ?bsr ?bsq)
            (= ?bsr ?bsp)
            )
          (= ?bsq ?bsp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bss Real)
      (declare-const ?bst Real)
      (declare-const ?bsu Real)
      (declare-const ?bsv Real)
      (declare-const ?bsw Real)
      (declare-const ?bsx Real)
      (assert
        (and (and (and (not (= ?bsu ?bst))
              (not (= ?bsu ?bss))
              )
            (not (= ?bst ?bss))
            )
          (or (or (= ?bsx ?bsw)
              (= ?bsx ?bsv)
              )
            (= ?bsw ?bsv)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bsy Real)
      (declare-const ?bsz Real)
      (declare-const ?bta Real)
      (assert
        (or (or (= ?bta ?bsz)
            (= ?bta ?bsy)
            )
          (= ?bsz ?bsy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?btb Real)
      (declare-const ?btc Real)
      (declare-const ?btd Real)
      (assert
        (or (or (= ?btd ?btc)
            (= ?btd ?btb)
            )
          (= ?btc ?btb)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bte Real)
      (declare-const ?btf Real)
      (declare-const ?btg Real)
      (declare-const ?bth Real)
      (assert
        (or (or (= ?btg ?btf)
            (= ?btg ?bte)
            )
          (= ?btf ?bte)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bti Real)
      (declare-const ?btj Real)
      (declare-const ?btk Real)
      (declare-const ?btl Real)
      (declare-const ?btm Real)
      (assert
        (or (or (= ?btk ?btj)
            (= ?btk ?bti)
            )
          (= ?btj ?bti)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?btn Real)
      (declare-const ?bto Real)
      (declare-const ?btp Real)
      (declare-const ?btq Real)
      (declare-const ?btr Real)
      (declare-const ?bts Real)
      (assert
        (and (or (or (= ?btp ?bto)
              (= ?btp ?btn)
              )
            (= ?bto ?btn)
            )
          (and (and (not (= ?bts ?btr))
              (not (= ?bts ?btq))
              )
            (not (= ?btr ?btq))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?btt Real)
      (declare-const ?btu Real)
      (declare-const ?btv Real)
      (assert
        (or (or (= ?btv ?btu)
            (= ?btv ?btt)
            )
          (= ?btu ?btt)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?btw Real)
      (declare-const ?btx Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bty Real)
      (declare-const ?btz Real)
      (declare-const ?bua Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bub Real)
      (declare-const ?buc Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bud Real)
      (declare-const ?bue Real)
      (declare-const ?buf Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bug Real)
      (declare-const ?buh Real)
      (declare-const ?bui Real)
      (declare-const ?buj Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?buh ?bug))
                  (not (= ?buh ?asi))
                  )
                (not (= ?bug ?asi))
                )
              (or (or (= ?buj ?bui)
                  (= ?buj ?asi)
                  )
                (= ?bui ?asi)
                )
              )
            (and (or (or (= ?buh ?bug)
                  (= ?buh ?asi)
                  )
                (= ?bug ?asi)
                )
              (and (and (not (= ?buj ?bui))
                  (not (= ?buj ?asi))
                  )
                (not (= ?bui ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?buk Real)
      (declare-const ?bul Real)
      (declare-const ?bum Real)
      (declare-const ?bun Real)
      (declare-const ?buo Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bup Real)
      (declare-const ?buq Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bur Real)
      (declare-const ?bus Real)
      (declare-const ?but Real)
      (declare-const ?buu Real)
      (declare-const ?buv Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (= ?bsf ?bse)
            (= ?bsf ?bsd)
            )
          (= ?bse ?bsd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?buw Real)
    (declare-const ?bux Real)
    (declare-const ?buy Real)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?buz Real)
      (declare-const ?bva Real)
      (declare-const ?bvb Real)
      (assert
        (or (or (= ?bvb ?bva)
            (= ?bvb ?buz)
            )
          (= ?bva ?buz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bvc Real)
      (declare-const ?bvd Real)
      (declare-const ?bve Real)
      (declare-const ?bvf Real)
      (assert
        (or (or (= ?bvf ?bve)
            (= ?bvf ?bvd)
            )
          (= ?bve ?bvd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bvg Real)
      (declare-const ?bvh Real)
      (declare-const ?bvi Real)
      (declare-const ?bvj Real)
      (declare-const ?bvk Real)
      (assert
        (or (or (= ?bvk ?bvj)
            (= ?bvk ?bvi)
            )
          (= ?bvj ?bvi)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bvl Real)
      (declare-const ?bvm Real)
      (declare-const ?bvn Real)
      (declare-const ?bvo Real)
      (declare-const ?bvp Real)
      (declare-const ?bvq Real)
      (assert
        (and (and (and (not (= ?bvn ?bvm))
              (not (= ?bvn ?bvl))
              )
            (not (= ?bvm ?bvl))
            )
          (or (or (= ?bvq ?bvp)
              (= ?bvq ?bvo)
              )
            (= ?bvp ?bvo)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bvr Real)
      (declare-const ?bvs Real)
      (declare-const ?bvt Real)
      (assert
        (or (or (= ?bvt ?bvs)
            (= ?bvt ?bvr)
            )
          (= ?bvs ?bvr)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bvu Real)
      (declare-const ?bvv Real)
      (declare-const ?bvw Real)
      (assert
        (or (or (= ?bvw ?bvv)
            (= ?bvw ?bvu)
            )
          (= ?bvv ?bvu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bvx Real)
      (declare-const ?bvy Real)
      (declare-const ?bvz Real)
      (declare-const ?bwa Real)
      (assert
        (or (or (= ?bvz ?bvy)
            (= ?bvz ?bvx)
            )
          (= ?bvy ?bvx)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bwb Real)
      (declare-const ?bwc Real)
      (declare-const ?bwd Real)
      (declare-const ?bwe Real)
      (declare-const ?bwf Real)
      (assert
        (or (or (= ?bwd ?bwc)
            (= ?bwd ?bwb)
            )
          (= ?bwc ?bwb)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bwg Real)
      (declare-const ?bwh Real)
      (declare-const ?bwi Real)
      (declare-const ?bwj Real)
      (declare-const ?bwk Real)
      (declare-const ?bwl Real)
      (assert
        (and (or (or (= ?bwi ?bwh)
              (= ?bwi ?bwg)
              )
            (= ?bwh ?bwg)
            )
          (and (and (not (= ?bwl ?bwk))
              (not (= ?bwl ?bwj))
              )
            (not (= ?bwk ?bwj))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bwm Real)
      (declare-const ?bwn Real)
      (declare-const ?bwo Real)
      (assert
        (or (or (= ?bwo ?bwn)
            (= ?bwo ?bwm)
            )
          (= ?bwn ?bwm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bwp Real)
      (declare-const ?bwq Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bwr Real)
      (declare-const ?bws Real)
      (declare-const ?bwt Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bwu Real)
      (declare-const ?bwv Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bww Real)
      (declare-const ?bwx Real)
      (declare-const ?bwy Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bwz Real)
      (declare-const ?bxa Real)
      (declare-const ?bxb Real)
      (declare-const ?bxc Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?bxa ?bwz))
                  (not (= ?bxa ?asi))
                  )
                (not (= ?bwz ?asi))
                )
              (or (or (= ?bxc ?bxb)
                  (= ?bxc ?asi)
                  )
                (= ?bxb ?asi)
                )
              )
            (and (or (or (= ?bxa ?bwz)
                  (= ?bxa ?asi)
                  )
                (= ?bwz ?asi)
                )
              (and (and (not (= ?bxc ?bxb))
                  (not (= ?bxc ?asi))
                  )
                (not (= ?bxb ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bxd Real)
      (declare-const ?bxe Real)
      (declare-const ?bxf Real)
      (declare-const ?bxg Real)
      (declare-const ?bxh Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bxi Real)
      (declare-const ?bxj Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bxk Real)
      (declare-const ?bxl Real)
      (declare-const ?bxm Real)
      (declare-const ?bxn Real)
      (declare-const ?bxo Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bxp Real)
      (declare-const ?bxq Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?bxr Real)
      (declare-const ?bxs Real)
      (declare-const ?bxt Real)
      (assert
        (or (or (= ?bxt ?bxs)
            (= ?bxt ?bxr)
            )
          (= ?bxs ?bxr)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bxu Real)
      (declare-const ?bxv Real)
      (declare-const ?bxw Real)
      (declare-const ?bxx Real)
      (assert
        (or (or (= ?bxx ?bxw)
            (= ?bxx ?bxv)
            )
          (= ?bxw ?bxv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bxy Real)
      (declare-const ?bxz Real)
      (declare-const ?bya Real)
      (declare-const ?byb Real)
      (declare-const ?byc Real)
      (assert
        (or (or (= ?byc ?byb)
            (= ?byc ?bya)
            )
          (= ?byb ?bya)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?byd Real)
      (declare-const ?bye Real)
      (declare-const ?byf Real)
      (declare-const ?byg Real)
      (declare-const ?byh Real)
      (declare-const ?byi Real)
      (assert
        (and (and (and (not (= ?byf ?bye))
              (not (= ?byf ?byd))
              )
            (not (= ?bye ?byd))
            )
          (or (or (= ?byi ?byh)
              (= ?byi ?byg)
              )
            (= ?byh ?byg)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?byj Real)
      (declare-const ?byk Real)
      (declare-const ?byl Real)
      (assert
        (or (or (= ?byl ?byk)
            (= ?byl ?byj)
            )
          (= ?byk ?byj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bym Real)
      (declare-const ?byn Real)
      (declare-const ?byo Real)
      (assert
        (or (or (= ?byo ?byn)
            (= ?byo ?bym)
            )
          (= ?byn ?bym)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?byp Real)
      (declare-const ?byq Real)
      (declare-const ?byr Real)
      (declare-const ?bys Real)
      (assert
        (or (or (= ?byr ?byq)
            (= ?byr ?byp)
            )
          (= ?byq ?byp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?byt Real)
      (declare-const ?byu Real)
      (declare-const ?byv Real)
      (declare-const ?byw Real)
      (declare-const ?byx Real)
      (assert
        (or (or (= ?byv ?byu)
            (= ?byv ?byt)
            )
          (= ?byu ?byt)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?byy Real)
      (declare-const ?byz Real)
      (declare-const ?bza Real)
      (declare-const ?bzb Real)
      (declare-const ?bzc Real)
      (declare-const ?bzd Real)
      (assert
        (and (or (or (= ?bza ?byz)
              (= ?bza ?byy)
              )
            (= ?byz ?byy)
            )
          (and (and (not (= ?bzd ?bzc))
              (not (= ?bzd ?bzb))
              )
            (not (= ?bzc ?bzb))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bze Real)
      (declare-const ?bzf Real)
      (declare-const ?bzg Real)
      (assert
        (or (or (= ?bzg ?bzf)
            (= ?bzg ?bze)
            )
          (= ?bzf ?bze)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bzh Real)
      (declare-const ?bzi Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bzj Real)
      (declare-const ?bzk Real)
      (declare-const ?bzl Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bzm Real)
      (declare-const ?bzn Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bzo Real)
      (declare-const ?bzp Real)
      (declare-const ?bzq Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bzr Real)
      (declare-const ?bzs Real)
      (declare-const ?bzt Real)
      (declare-const ?bzu Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?bzs ?bzr))
                  (not (= ?bzs ?asi))
                  )
                (not (= ?bzr ?asi))
                )
              (or (or (= ?bzu ?bzt)
                  (= ?bzu ?asi)
                  )
                (= ?bzt ?asi)
                )
              )
            (and (or (or (= ?bzs ?bzr)
                  (= ?bzs ?asi)
                  )
                (= ?bzr ?asi)
                )
              (and (and (not (= ?bzu ?bzt))
                  (not (= ?bzu ?asi))
                  )
                (not (= ?bzt ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bzv Real)
      (declare-const ?bzw Real)
      (declare-const ?bzx Real)
      (declare-const ?bzy Real)
      (declare-const ?bzz Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?caa Real)
      (declare-const ?cab Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?cac Real)
      (declare-const ?cad Real)
      (declare-const ?cae Real)
      (declare-const ?caf Real)
      (declare-const ?cag Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?cah Real)
      (declare-const ?cai Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?caj Real)
  (declare-const ?cak Real)
  (declare-const ?cal Real)
  (assert
    (or (or (= ?cal ?cak)
        (= ?cal ?caj)
        )
      (= ?cak ?caj)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?cam Real)
    (declare-const ?can Real)
    (declare-const ?cao Real)
    (assert
      (or (or (= ?cao ?can)
          (= ?cao ?cam)
          )
        (= ?can ?cam)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cap Real)
    (declare-const ?caq Real)
    (declare-const ?car Real)
    (declare-const ?cas Real)
    (assert
      (or (or (= ?cas ?car)
          (= ?cas ?caq)
          )
        (= ?car ?caq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cat Real)
    (declare-const ?cau Real)
    (declare-const ?cav Real)
    (declare-const ?caw Real)
    (declare-const ?cax Real)
    (assert
      (or (or (= ?cax ?caw)
          (= ?cax ?cav)
          )
        (= ?caw ?cav)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cay Real)
    (declare-const ?caz Real)
    (declare-const ?cba Real)
    (declare-const ?cbb Real)
    (declare-const ?cbc Real)
    (declare-const ?cbd Real)
    (assert
      (and (and (and (not (= ?cba ?caz))
            (not (= ?cba ?cay))
            )
          (not (= ?caz ?cay))
          )
        (or (or (= ?cbd ?cbc)
            (= ?cbd ?cbb)
            )
          (= ?cbc ?cbb)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cbe Real)
    (declare-const ?cbf Real)
    (declare-const ?cbg Real)
    (assert
      (or (or (= ?cbg ?cbf)
          (= ?cbg ?cbe)
          )
        (= ?cbf ?cbe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cbh Real)
    (declare-const ?cbi Real)
    (declare-const ?cbj Real)
    (assert
      (or (or (= ?cbj ?cbi)
          (= ?cbj ?cbh)
          )
        (= ?cbi ?cbh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cbk Real)
    (declare-const ?cbl Real)
    (declare-const ?cbm Real)
    (declare-const ?cbn Real)
    (assert
      (or (or (= ?cbm ?cbl)
          (= ?cbm ?cbk)
          )
        (= ?cbl ?cbk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cbo Real)
    (declare-const ?cbp Real)
    (declare-const ?cbq Real)
    (declare-const ?cbr Real)
    (declare-const ?cbs Real)
    (assert
      (or (or (= ?cbq ?cbp)
          (= ?cbq ?cbo)
          )
        (= ?cbp ?cbo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cbt Real)
    (declare-const ?cbu Real)
    (declare-const ?cbv Real)
    (declare-const ?cbw Real)
    (declare-const ?cbx Real)
    (declare-const ?cby Real)
    (assert
      (and (or (or (= ?cbv ?cbu)
            (= ?cbv ?cbt)
            )
          (= ?cbu ?cbt)
          )
        (and (and (not (= ?cby ?cbx))
            (not (= ?cby ?cbw))
            )
          (not (= ?cbx ?cbw))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cbz Real)
    (declare-const ?cca Real)
    (declare-const ?ccb Real)
    (assert
      (or (or (= ?ccb ?cca)
          (= ?ccb ?cbz)
          )
        (= ?cca ?cbz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ccc Real)
  (declare-const ?ccd Real)
  (declare-const ?cce Real)
  (declare-const ?ccf Real)
  (assert
    (or (or (= ?ccf ?cce)
        (= ?ccf ?ccd)
        )
      (= ?cce ?ccd)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?ccg Real)
    (declare-const ?cch Real)
    (declare-const ?cci Real)
    (assert
      (or (or (= ?cci ?cch)
          (= ?cci ?ccg)
          )
        (= ?cch ?ccg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ccj Real)
    (declare-const ?cck Real)
    (declare-const ?ccl Real)
    (declare-const ?ccm Real)
    (assert
      (or (or (= ?ccm ?ccl)
          (= ?ccm ?cck)
          )
        (= ?ccl ?cck)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ccn Real)
    (declare-const ?cco Real)
    (declare-const ?ccp Real)
    (declare-const ?ccq Real)
    (declare-const ?ccr Real)
    (assert
      (or (or (= ?ccr ?ccq)
          (= ?ccr ?ccp)
          )
        (= ?ccq ?ccp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ccs Real)
    (declare-const ?cct Real)
    (declare-const ?ccu Real)
    (declare-const ?ccv Real)
    (declare-const ?ccw Real)
    (declare-const ?ccx Real)
    (assert
      (and (and (and (not (= ?ccu ?cct))
            (not (= ?ccu ?ccs))
            )
          (not (= ?cct ?ccs))
          )
        (or (or (= ?ccx ?ccw)
            (= ?ccx ?ccv)
            )
          (= ?ccw ?ccv)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ccy Real)
    (declare-const ?ccz Real)
    (declare-const ?cda Real)
    (assert
      (or (or (= ?cda ?ccz)
          (= ?cda ?ccy)
          )
        (= ?ccz ?ccy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cdb Real)
    (declare-const ?cdc Real)
    (declare-const ?cdd Real)
    (assert
      (or (or (= ?cdd ?cdc)
          (= ?cdd ?cdb)
          )
        (= ?cdc ?cdb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cde Real)
    (declare-const ?cdf Real)
    (declare-const ?cdg Real)
    (declare-const ?cdh Real)
    (assert
      (or (or (= ?cdg ?cdf)
          (= ?cdg ?cde)
          )
        (= ?cdf ?cde)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cdi Real)
    (declare-const ?cdj Real)
    (declare-const ?cdk Real)
    (declare-const ?cdl Real)
    (declare-const ?cdm Real)
    (assert
      (or (or (= ?cdk ?cdj)
          (= ?cdk ?cdi)
          )
        (= ?cdj ?cdi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cdn Real)
    (declare-const ?cdo Real)
    (declare-const ?cdp Real)
    (declare-const ?cdq Real)
    (declare-const ?cdr Real)
    (declare-const ?cds Real)
    (assert
      (and (or (or (= ?cdp ?cdo)
            (= ?cdp ?cdn)
            )
          (= ?cdo ?cdn)
          )
        (and (and (not (= ?cds ?cdr))
            (not (= ?cds ?cdq))
            )
          (not (= ?cdr ?cdq))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cdt Real)
    (declare-const ?cdu Real)
    (declare-const ?cdv Real)
    (assert
      (or (or (= ?cdv ?cdu)
          (= ?cdv ?cdt)
          )
        (= ?cdu ?cdt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?cdw Real)
  (declare-const ?cdx Real)
  (declare-const ?cdy Real)
  (declare-const ?cdz Real)
  (declare-const ?cea Real)
  (assert
    (or (or (= ?cea ?cdz)
        (= ?cea ?cdy)
        )
      (= ?cdz ?cdy)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?ceb Real)
    (declare-const ?cec Real)
    (declare-const ?ced Real)
    (assert
      (or (or (= ?ced ?cec)
          (= ?ced ?ceb)
          )
        (= ?cec ?ceb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cee Real)
    (declare-const ?cef Real)
    (declare-const ?ceg Real)
    (declare-const ?ceh Real)
    (assert
      (or (or (= ?ceh ?ceg)
          (= ?ceh ?cef)
          )
        (= ?ceg ?cef)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cei Real)
    (declare-const ?cej Real)
    (declare-const ?cek Real)
    (declare-const ?cel Real)
    (declare-const ?cem Real)
    (assert
      (or (or (= ?cem ?cel)
          (= ?cem ?cek)
          )
        (= ?cel ?cek)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cen Real)
    (declare-const ?ceo Real)
    (declare-const ?cep Real)
    (declare-const ?ceq Real)
    (declare-const ?cer Real)
    (declare-const ?ces Real)
    (assert
      (and (and (and (not (= ?cep ?ceo))
            (not (= ?cep ?cen))
            )
          (not (= ?ceo ?cen))
          )
        (or (or (= ?ces ?cer)
            (= ?ces ?ceq)
            )
          (= ?cer ?ceq)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cet Real)
    (declare-const ?ceu Real)
    (declare-const ?cev Real)
    (assert
      (or (or (= ?cev ?ceu)
          (= ?cev ?cet)
          )
        (= ?ceu ?cet)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cew Real)
    (declare-const ?cex Real)
    (declare-const ?cey Real)
    (assert
      (or (or (= ?cey ?cex)
          (= ?cey ?cew)
          )
        (= ?cex ?cew)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cez Real)
    (declare-const ?cfa Real)
    (declare-const ?cfb Real)
    (declare-const ?cfc Real)
    (assert
      (or (or (= ?cfb ?cfa)
          (= ?cfb ?cez)
          )
        (= ?cfa ?cez)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cfd Real)
    (declare-const ?cfe Real)
    (declare-const ?cff Real)
    (declare-const ?cfg Real)
    (declare-const ?cfh Real)
    (assert
      (or (or (= ?cff ?cfe)
          (= ?cff ?cfd)
          )
        (= ?cfe ?cfd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cfi Real)
    (declare-const ?cfj Real)
    (declare-const ?cfk Real)
    (declare-const ?cfl Real)
    (declare-const ?cfm Real)
    (declare-const ?cfn Real)
    (assert
      (and (or (or (= ?cfk ?cfj)
            (= ?cfk ?cfi)
            )
          (= ?cfj ?cfi)
          )
        (and (and (not (= ?cfn ?cfm))
            (not (= ?cfn ?cfl))
            )
          (not (= ?cfm ?cfl))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cfo Real)
    (declare-const ?cfp Real)
    (declare-const ?cfq Real)
    (assert
      (or (or (= ?cfq ?cfp)
          (= ?cfq ?cfo)
          )
        (= ?cfp ?cfo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?cfr Real)
  (declare-const ?cfs Real)
  (declare-const ?cft Real)
  (declare-const ?cfu Real)
  (declare-const ?cfv Real)
  (declare-const ?cfw Real)
  (assert
    (and (and (and (not (= ?cft ?cfs))
          (not (= ?cft ?cfr))
          )
        (not (= ?cfs ?cfr))
        )
      (or (or (= ?cfw ?cfv)
          (= ?cfw ?cfu)
          )
        (= ?cfv ?cfu)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?cfx Real)
    (declare-const ?cfy Real)
    (declare-const ?cfz Real)
    (assert
      (or (or (= ?cfz ?cfy)
          (= ?cfz ?cfx)
          )
        (= ?cfy ?cfx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cga Real)
    (declare-const ?cgb Real)
    (declare-const ?cgc Real)
    (declare-const ?cgd Real)
    (assert
      (or (or (= ?cgd ?cgc)
          (= ?cgd ?cgb)
          )
        (= ?cgc ?cgb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cge Real)
    (declare-const ?cgf Real)
    (declare-const ?cgg Real)
    (declare-const ?cgh Real)
    (declare-const ?cgi Real)
    (assert
      (or (or (= ?cgi ?cgh)
          (= ?cgi ?cgg)
          )
        (= ?cgh ?cgg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cgj Real)
    (declare-const ?cgk Real)
    (declare-const ?cgl Real)
    (declare-const ?cgm Real)
    (declare-const ?cgn Real)
    (declare-const ?cgo Real)
    (assert
      (and (and (and (not (= ?cgl ?cgk))
            (not (= ?cgl ?cgj))
            )
          (not (= ?cgk ?cgj))
          )
        (or (or (= ?cgo ?cgn)
            (= ?cgo ?cgm)
            )
          (= ?cgn ?cgm)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cgp Real)
    (declare-const ?cgq Real)
    (declare-const ?cgr Real)
    (assert
      (or (or (= ?cgr ?cgq)
          (= ?cgr ?cgp)
          )
        (= ?cgq ?cgp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cgs Real)
    (declare-const ?cgt Real)
    (declare-const ?cgu Real)
    (assert
      (or (or (= ?cgu ?cgt)
          (= ?cgu ?cgs)
          )
        (= ?cgt ?cgs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cgv Real)
    (declare-const ?cgw Real)
    (declare-const ?cgx Real)
    (declare-const ?cgy Real)
    (assert
      (or (or (= ?cgx ?cgw)
          (= ?cgx ?cgv)
          )
        (= ?cgw ?cgv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cgz Real)
    (declare-const ?cha Real)
    (declare-const ?chb Real)
    (declare-const ?chc Real)
    (declare-const ?chd Real)
    (assert
      (or (or (= ?chb ?cha)
          (= ?chb ?cgz)
          )
        (= ?cha ?cgz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?che Real)
    (declare-const ?chf Real)
    (declare-const ?chg Real)
    (declare-const ?chh Real)
    (declare-const ?chi Real)
    (declare-const ?chj Real)
    (assert
      (and (or (or (= ?chg ?chf)
            (= ?chg ?che)
            )
          (= ?chf ?che)
          )
        (and (and (not (= ?chj ?chi))
            (not (= ?chj ?chh))
            )
          (not (= ?chi ?chh))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?chk Real)
    (declare-const ?chl Real)
    (declare-const ?chm Real)
    (assert
      (or (or (= ?chm ?chl)
          (= ?chm ?chk)
          )
        (= ?chl ?chk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?chn Real)
  (declare-const ?cho Real)
  (declare-const ?chp Real)
  (assert
    (or (or (= ?chp ?cho)
        (= ?chp ?chn)
        )
      (= ?cho ?chn)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?chq Real)
    (declare-const ?chr Real)
    (declare-const ?chs Real)
    (assert
      (or (or (= ?chs ?chr)
          (= ?chs ?chq)
          )
        (= ?chr ?chq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cht Real)
    (declare-const ?chu Real)
    (declare-const ?chv Real)
    (declare-const ?chw Real)
    (assert
      (or (or (= ?chw ?chv)
          (= ?chw ?chu)
          )
        (= ?chv ?chu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?chx Real)
    (declare-const ?chy Real)
    (declare-const ?chz Real)
    (declare-const ?cia Real)
    (declare-const ?cib Real)
    (assert
      (or (or (= ?cib ?cia)
          (= ?cib ?chz)
          )
        (= ?cia ?chz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cic Real)
    (declare-const ?cid Real)
    (declare-const ?cie Real)
    (declare-const ?cif Real)
    (declare-const ?cig Real)
    (declare-const ?cih Real)
    (assert
      (and (and (and (not (= ?cie ?cid))
            (not (= ?cie ?cic))
            )
          (not (= ?cid ?cic))
          )
        (or (or (= ?cih ?cig)
            (= ?cih ?cif)
            )
          (= ?cig ?cif)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cii Real)
    (declare-const ?cij Real)
    (declare-const ?cik Real)
    (assert
      (or (or (= ?cik ?cij)
          (= ?cik ?cii)
          )
        (= ?cij ?cii)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cil Real)
    (declare-const ?cim Real)
    (declare-const ?cin Real)
    (assert
      (or (or (= ?cin ?cim)
          (= ?cin ?cil)
          )
        (= ?cim ?cil)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cio Real)
    (declare-const ?cip Real)
    (declare-const ?ciq Real)
    (declare-const ?cir Real)
    (assert
      (or (or (= ?ciq ?cip)
          (= ?ciq ?cio)
          )
        (= ?cip ?cio)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cis Real)
    (declare-const ?cit Real)
    (declare-const ?ciu Real)
    (declare-const ?civ Real)
    (declare-const ?ciw Real)
    (assert
      (or (or (= ?ciu ?cit)
          (= ?ciu ?cis)
          )
        (= ?cit ?cis)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cix Real)
    (declare-const ?ciy Real)
    (declare-const ?ciz Real)
    (declare-const ?cja Real)
    (declare-const ?cjb Real)
    (declare-const ?cjc Real)
    (assert
      (and (or (or (= ?ciz ?ciy)
            (= ?ciz ?cix)
            )
          (= ?ciy ?cix)
          )
        (and (and (not (= ?cjc ?cjb))
            (not (= ?cjc ?cja))
            )
          (not (= ?cjb ?cja))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cjd Real)
    (declare-const ?cje Real)
    (declare-const ?cjf Real)
    (assert
      (or (or (= ?cjf ?cje)
          (= ?cjf ?cjd)
          )
        (= ?cje ?cjd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?cjg Real)
  (declare-const ?cjh Real)
  (declare-const ?cji Real)
  (assert
    (or (or (= ?cji ?cjh)
        (= ?cji ?cjg)
        )
      (= ?cjh ?cjg)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?cjj Real)
    (declare-const ?cjk Real)
    (declare-const ?cjl Real)
    (assert
      (or (or (= ?cjl ?cjk)
          (= ?cjl ?cjj)
          )
        (= ?cjk ?cjj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cjm Real)
    (declare-const ?cjn Real)
    (declare-const ?cjo Real)
    (declare-const ?cjp Real)
    (assert
      (or (or (= ?cjp ?cjo)
          (= ?cjp ?cjn)
          )
        (= ?cjo ?cjn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cjq Real)
    (declare-const ?cjr Real)
    (declare-const ?cjs Real)
    (declare-const ?cjt Real)
    (declare-const ?cju Real)
    (assert
      (or (or (= ?cju ?cjt)
          (= ?cju ?cjs)
          )
        (= ?cjt ?cjs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cjv Real)
    (declare-const ?cjw Real)
    (declare-const ?cjx Real)
    (declare-const ?cjy Real)
    (declare-const ?cjz Real)
    (declare-const ?cka Real)
    (assert
      (and (and (and (not (= ?cjx ?cjw))
            (not (= ?cjx ?cjv))
            )
          (not (= ?cjw ?cjv))
          )
        (or (or (= ?cka ?cjz)
            (= ?cka ?cjy)
            )
          (= ?cjz ?cjy)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ckb Real)
    (declare-const ?ckc Real)
    (declare-const ?ckd Real)
    (assert
      (or (or (= ?ckd ?ckc)
          (= ?ckd ?ckb)
          )
        (= ?ckc ?ckb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cke Real)
    (declare-const ?ckf Real)
    (declare-const ?ckg Real)
    (assert
      (or (or (= ?ckg ?ckf)
          (= ?ckg ?cke)
          )
        (= ?ckf ?cke)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ckh Real)
    (declare-const ?cki Real)
    (declare-const ?ckj Real)
    (declare-const ?ckk Real)
    (assert
      (or (or (= ?ckj ?cki)
          (= ?ckj ?ckh)
          )
        (= ?cki ?ckh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ckl Real)
    (declare-const ?ckm Real)
    (declare-const ?ckn Real)
    (declare-const ?cko Real)
    (declare-const ?ckp Real)
    (assert
      (or (or (= ?ckn ?ckm)
          (= ?ckn ?ckl)
          )
        (= ?ckm ?ckl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ckq Real)
    (declare-const ?ckr Real)
    (declare-const ?cks Real)
    (declare-const ?ckt Real)
    (declare-const ?cku Real)
    (declare-const ?ckv Real)
    (assert
      (and (or (or (= ?cks ?ckr)
            (= ?cks ?ckq)
            )
          (= ?ckr ?ckq)
          )
        (and (and (not (= ?ckv ?cku))
            (not (= ?ckv ?ckt))
            )
          (not (= ?cku ?ckt))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ckw Real)
    (declare-const ?ckx Real)
    (declare-const ?cky Real)
    (assert
      (or (or (= ?cky ?ckx)
          (= ?cky ?ckw)
          )
        (= ?ckx ?ckw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ckz Real)
  (declare-const ?cla Real)
  (declare-const ?clb Real)
  (declare-const ?clc Real)
  (assert
    (or (or (= ?clb ?cla)
        (= ?clb ?ckz)
        )
      (= ?cla ?ckz)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?cld Real)
    (declare-const ?cle Real)
    (declare-const ?clf Real)
    (assert
      (or (or (= ?clf ?cle)
          (= ?clf ?cld)
          )
        (= ?cle ?cld)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?clg Real)
    (declare-const ?clh Real)
    (declare-const ?cli Real)
    (declare-const ?clj Real)
    (assert
      (or (or (= ?clj ?cli)
          (= ?clj ?clh)
          )
        (= ?cli ?clh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?clk Real)
    (declare-const ?cll Real)
    (declare-const ?clm Real)
    (declare-const ?cln Real)
    (declare-const ?clo Real)
    (assert
      (or (or (= ?clo ?cln)
          (= ?clo ?clm)
          )
        (= ?cln ?clm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?clp Real)
    (declare-const ?clq Real)
    (declare-const ?clr Real)
    (declare-const ?cls Real)
    (declare-const ?clt Real)
    (declare-const ?clu Real)
    (assert
      (and (and (and (not (= ?clr ?clq))
            (not (= ?clr ?clp))
            )
          (not (= ?clq ?clp))
          )
        (or (or (= ?clu ?clt)
            (= ?clu ?cls)
            )
          (= ?clt ?cls)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?clv Real)
    (declare-const ?clw Real)
    (declare-const ?clx Real)
    (assert
      (or (or (= ?clx ?clw)
          (= ?clx ?clv)
          )
        (= ?clw ?clv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cly Real)
    (declare-const ?clz Real)
    (declare-const ?cma Real)
    (assert
      (or (or (= ?cma ?clz)
          (= ?cma ?cly)
          )
        (= ?clz ?cly)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cmb Real)
    (declare-const ?cmc Real)
    (declare-const ?cmd Real)
    (declare-const ?cme Real)
    (assert
      (or (or (= ?cmd ?cmc)
          (= ?cmd ?cmb)
          )
        (= ?cmc ?cmb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cmf Real)
    (declare-const ?cmg Real)
    (declare-const ?cmh Real)
    (declare-const ?cmi Real)
    (declare-const ?cmj Real)
    (assert
      (or (or (= ?cmh ?cmg)
          (= ?cmh ?cmf)
          )
        (= ?cmg ?cmf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cmk Real)
    (declare-const ?cml Real)
    (declare-const ?cmm Real)
    (declare-const ?cmn Real)
    (declare-const ?cmo Real)
    (declare-const ?cmp Real)
    (assert
      (and (or (or (= ?cmm ?cml)
            (= ?cmm ?cmk)
            )
          (= ?cml ?cmk)
          )
        (and (and (not (= ?cmp ?cmo))
            (not (= ?cmp ?cmn))
            )
          (not (= ?cmo ?cmn))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cmq Real)
    (declare-const ?cmr Real)
    (declare-const ?cms Real)
    (assert
      (or (or (= ?cms ?cmr)
          (= ?cms ?cmq)
          )
        (= ?cmr ?cmq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?cmt Real)
  (declare-const ?cmu Real)
  (declare-const ?cmv Real)
  (declare-const ?cmw Real)
  (declare-const ?cmx Real)
  (assert
    (or (or (= ?cmv ?cmu)
        (= ?cmv ?cmt)
        )
      (= ?cmu ?cmt)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?cmy Real)
    (declare-const ?cmz Real)
    (declare-const ?cna Real)
    (assert
      (or (or (= ?cna ?cmz)
          (= ?cna ?cmy)
          )
        (= ?cmz ?cmy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cnb Real)
    (declare-const ?cnc Real)
    (declare-const ?cnd Real)
    (declare-const ?cne Real)
    (assert
      (or (or (= ?cne ?cnd)
          (= ?cne ?cnc)
          )
        (= ?cnd ?cnc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cnf Real)
    (declare-const ?cng Real)
    (declare-const ?cnh Real)
    (declare-const ?cni Real)
    (declare-const ?cnj Real)
    (assert
      (or (or (= ?cnj ?cni)
          (= ?cnj ?cnh)
          )
        (= ?cni ?cnh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cnk Real)
    (declare-const ?cnl Real)
    (declare-const ?cnm Real)
    (declare-const ?cnn Real)
    (declare-const ?cno Real)
    (declare-const ?cnp Real)
    (assert
      (and (and (and (not (= ?cnm ?cnl))
            (not (= ?cnm ?cnk))
            )
          (not (= ?cnl ?cnk))
          )
        (or (or (= ?cnp ?cno)
            (= ?cnp ?cnn)
            )
          (= ?cno ?cnn)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cnq Real)
    (declare-const ?cnr Real)
    (declare-const ?cns Real)
    (assert
      (or (or (= ?cns ?cnr)
          (= ?cns ?cnq)
          )
        (= ?cnr ?cnq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cnt Real)
    (declare-const ?cnu Real)
    (declare-const ?cnv Real)
    (assert
      (or (or (= ?cnv ?cnu)
          (= ?cnv ?cnt)
          )
        (= ?cnu ?cnt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cnw Real)
    (declare-const ?cnx Real)
    (declare-const ?cny Real)
    (declare-const ?cnz Real)
    (assert
      (or (or (= ?cny ?cnx)
          (= ?cny ?cnw)
          )
        (= ?cnx ?cnw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?coa Real)
    (declare-const ?cob Real)
    (declare-const ?coc Real)
    (declare-const ?cod Real)
    (declare-const ?coe Real)
    (assert
      (or (or (= ?coc ?cob)
          (= ?coc ?coa)
          )
        (= ?cob ?coa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cof Real)
    (declare-const ?cog Real)
    (declare-const ?coh Real)
    (declare-const ?coi Real)
    (declare-const ?coj Real)
    (declare-const ?cok Real)
    (assert
      (and (or (or (= ?coh ?cog)
            (= ?coh ?cof)
            )
          (= ?cog ?cof)
          )
        (and (and (not (= ?cok ?coj))
            (not (= ?cok ?coi))
            )
          (not (= ?coj ?coi))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?col Real)
    (declare-const ?com Real)
    (declare-const ?con Real)
    (assert
      (or (or (= ?con ?com)
          (= ?con ?col)
          )
        (= ?com ?col)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?coo Real)
  (declare-const ?cop Real)
  (declare-const ?coq Real)
  (declare-const ?cor Real)
  (declare-const ?cos Real)
  (declare-const ?cot Real)
  (assert
    (and (or (or (= ?coq ?cop)
          (= ?coq ?coo)
          )
        (= ?cop ?coo)
        )
      (and (and (not (= ?cot ?cos))
          (not (= ?cot ?cor))
          )
        (not (= ?cos ?cor))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?cou Real)
    (declare-const ?cov Real)
    (declare-const ?cow Real)
    (assert
      (or (or (= ?cow ?cov)
          (= ?cow ?cou)
          )
        (= ?cov ?cou)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cox Real)
    (declare-const ?coy Real)
    (declare-const ?coz Real)
    (declare-const ?cpa Real)
    (assert
      (or (or (= ?cpa ?coz)
          (= ?cpa ?coy)
          )
        (= ?coz ?coy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cpb Real)
    (declare-const ?cpc Real)
    (declare-const ?cpd Real)
    (declare-const ?cpe Real)
    (declare-const ?cpf Real)
    (assert
      (or (or (= ?cpf ?cpe)
          (= ?cpf ?cpd)
          )
        (= ?cpe ?cpd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cpg Real)
    (declare-const ?cph Real)
    (declare-const ?cpi Real)
    (declare-const ?cpj Real)
    (declare-const ?cpk Real)
    (declare-const ?cpl Real)
    (assert
      (and (and (and (not (= ?cpi ?cph))
            (not (= ?cpi ?cpg))
            )
          (not (= ?cph ?cpg))
          )
        (or (or (= ?cpl ?cpk)
            (= ?cpl ?cpj)
            )
          (= ?cpk ?cpj)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cpm Real)
    (declare-const ?cpn Real)
    (declare-const ?cpo Real)
    (assert
      (or (or (= ?cpo ?cpn)
          (= ?cpo ?cpm)
          )
        (= ?cpn ?cpm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cpp Real)
    (declare-const ?cpq Real)
    (declare-const ?cpr Real)
    (assert
      (or (or (= ?cpr ?cpq)
          (= ?cpr ?cpp)
          )
        (= ?cpq ?cpp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cps Real)
    (declare-const ?cpt Real)
    (declare-const ?cpu Real)
    (declare-const ?cpv Real)
    (assert
      (or (or (= ?cpu ?cpt)
          (= ?cpu ?cps)
          )
        (= ?cpt ?cps)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cpw Real)
    (declare-const ?cpx Real)
    (declare-const ?cpy Real)
    (declare-const ?cpz Real)
    (declare-const ?cqa Real)
    (assert
      (or (or (= ?cpy ?cpx)
          (= ?cpy ?cpw)
          )
        (= ?cpx ?cpw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cqb Real)
    (declare-const ?cqc Real)
    (declare-const ?cqd Real)
    (declare-const ?cqe Real)
    (declare-const ?cqf Real)
    (declare-const ?cqg Real)
    (assert
      (and (or (or (= ?cqd ?cqc)
            (= ?cqd ?cqb)
            )
          (= ?cqc ?cqb)
          )
        (and (and (not (= ?cqg ?cqf))
            (not (= ?cqg ?cqe))
            )
          (not (= ?cqf ?cqe))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cqh Real)
    (declare-const ?cqi Real)
    (declare-const ?cqj Real)
    (assert
      (or (or (= ?cqj ?cqi)
          (= ?cqj ?cqh)
          )
        (= ?cqi ?cqh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?cqk Real)
  (declare-const ?cql Real)
  (declare-const ?cqm Real)
  (assert
    (or (or (= ?cqm ?cql)
        (= ?cqm ?cqk)
        )
      (= ?cql ?cqk)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?cqn Real)
    (declare-const ?cqo Real)
    (declare-const ?cqp Real)
    (assert
      (or (or (= ?cqp ?cqo)
          (= ?cqp ?cqn)
          )
        (= ?cqo ?cqn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cqq Real)
    (declare-const ?cqr Real)
    (declare-const ?cqs Real)
    (declare-const ?cqt Real)
    (assert
      (or (or (= ?cqt ?cqs)
          (= ?cqt ?cqr)
          )
        (= ?cqs ?cqr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cqu Real)
    (declare-const ?cqv Real)
    (declare-const ?cqw Real)
    (declare-const ?cqx Real)
    (declare-const ?cqy Real)
    (assert
      (or (or (= ?cqy ?cqx)
          (= ?cqy ?cqw)
          )
        (= ?cqx ?cqw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cqz Real)
    (declare-const ?cra Real)
    (declare-const ?crb Real)
    (declare-const ?crc Real)
    (declare-const ?crd Real)
    (declare-const ?cre Real)
    (assert
      (and (and (and (not (= ?crb ?cra))
            (not (= ?crb ?cqz))
            )
          (not (= ?cra ?cqz))
          )
        (or (or (= ?cre ?crd)
            (= ?cre ?crc)
            )
          (= ?crd ?crc)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?crf Real)
    (declare-const ?crg Real)
    (declare-const ?crh Real)
    (assert
      (or (or (= ?crh ?crg)
          (= ?crh ?crf)
          )
        (= ?crg ?crf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cri Real)
    (declare-const ?crj Real)
    (declare-const ?crk Real)
    (assert
      (or (or (= ?crk ?crj)
          (= ?crk ?cri)
          )
        (= ?crj ?cri)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?crl Real)
    (declare-const ?crm Real)
    (declare-const ?crn Real)
    (declare-const ?cro Real)
    (assert
      (or (or (= ?crn ?crm)
          (= ?crn ?crl)
          )
        (= ?crm ?crl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?crp Real)
    (declare-const ?crq Real)
    (declare-const ?crr Real)
    (declare-const ?crs Real)
    (declare-const ?crt Real)
    (assert
      (or (or (= ?crr ?crq)
          (= ?crr ?crp)
          )
        (= ?crq ?crp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cru Real)
    (declare-const ?crv Real)
    (declare-const ?crw Real)
    (declare-const ?crx Real)
    (declare-const ?cry Real)
    (declare-const ?crz Real)
    (assert
      (and (or (or (= ?crw ?crv)
            (= ?crw ?cru)
            )
          (= ?crv ?cru)
          )
        (and (and (not (= ?crz ?cry))
            (not (= ?crz ?crx))
            )
          (not (= ?cry ?crx))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?csa Real)
    (declare-const ?csb Real)
    (declare-const ?csc Real)
    (assert
      (or (or (= ?csc ?csb)
          (= ?csc ?csa)
          )
        (= ?csb ?csa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?csd Real)
  (declare-const ?cse Real)
  (push 1)
    (declare-const ?csf Real)
    (declare-const ?csg Real)
    (declare-const ?csh Real)
    (assert
      (or (or (= ?csh ?csg)
          (= ?csh ?csf)
          )
        (= ?csg ?csf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?csi Real)
    (declare-const ?csj Real)
    (declare-const ?csk Real)
    (declare-const ?csl Real)
    (assert
      (or (or (= ?csl ?csk)
          (= ?csl ?csj)
          )
        (= ?csk ?csj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?csm Real)
    (declare-const ?csn Real)
    (declare-const ?cso Real)
    (declare-const ?csp Real)
    (declare-const ?csq Real)
    (assert
      (or (or (= ?csq ?csp)
          (= ?csq ?cso)
          )
        (= ?csp ?cso)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?csr Real)
    (declare-const ?css Real)
    (declare-const ?cst Real)
    (declare-const ?csu Real)
    (declare-const ?csv Real)
    (declare-const ?csw Real)
    (assert
      (and (and (and (not (= ?cst ?css))
            (not (= ?cst ?csr))
            )
          (not (= ?css ?csr))
          )
        (or (or (= ?csw ?csv)
            (= ?csw ?csu)
            )
          (= ?csv ?csu)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?csx Real)
    (declare-const ?csy Real)
    (declare-const ?csz Real)
    (assert
      (or (or (= ?csz ?csy)
          (= ?csz ?csx)
          )
        (= ?csy ?csx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cta Real)
    (declare-const ?ctb Real)
    (declare-const ?ctc Real)
    (assert
      (or (or (= ?ctc ?ctb)
          (= ?ctc ?cta)
          )
        (= ?ctb ?cta)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ctd Real)
    (declare-const ?cte Real)
    (declare-const ?ctf Real)
    (declare-const ?ctg Real)
    (assert
      (or (or (= ?ctf ?cte)
          (= ?ctf ?ctd)
          )
        (= ?cte ?ctd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cth Real)
    (declare-const ?cti Real)
    (declare-const ?ctj Real)
    (declare-const ?ctk Real)
    (declare-const ?ctl Real)
    (assert
      (or (or (= ?ctj ?cti)
          (= ?ctj ?cth)
          )
        (= ?cti ?cth)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ctm Real)
    (declare-const ?ctn Real)
    (declare-const ?cto Real)
    (declare-const ?ctp Real)
    (declare-const ?ctq Real)
    (declare-const ?ctr Real)
    (assert
      (and (or (or (= ?cto ?ctn)
            (= ?cto ?ctm)
            )
          (= ?ctn ?ctm)
          )
        (and (and (not (= ?ctr ?ctq))
            (not (= ?ctr ?ctp))
            )
          (not (= ?ctq ?ctp))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cts Real)
    (declare-const ?ctt Real)
    (declare-const ?ctu Real)
    (assert
      (or (or (= ?ctu ?ctt)
          (= ?ctu ?cts)
          )
        (= ?ctt ?cts)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ctv Real)
  (declare-const ?ctw Real)
  (declare-const ?ctx Real)
  (push 1)
    (declare-const ?cty Real)
    (declare-const ?ctz Real)
    (declare-const ?cua Real)
    (assert
      (or (or (= ?cua ?ctz)
          (= ?cua ?cty)
          )
        (= ?ctz ?cty)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cub Real)
    (declare-const ?cuc Real)
    (declare-const ?cud Real)
    (declare-const ?cue Real)
    (assert
      (or (or (= ?cue ?cud)
          (= ?cue ?cuc)
          )
        (= ?cud ?cuc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cuf Real)
    (declare-const ?cug Real)
    (declare-const ?cuh Real)
    (declare-const ?cui Real)
    (declare-const ?cuj Real)
    (assert
      (or (or (= ?cuj ?cui)
          (= ?cuj ?cuh)
          )
        (= ?cui ?cuh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cuk Real)
    (declare-const ?cul Real)
    (declare-const ?cum Real)
    (declare-const ?cun Real)
    (declare-const ?cuo Real)
    (declare-const ?cup Real)
    (assert
      (and (and (and (not (= ?cum ?cul))
            (not (= ?cum ?cuk))
            )
          (not (= ?cul ?cuk))
          )
        (or (or (= ?cup ?cuo)
            (= ?cup ?cun)
            )
          (= ?cuo ?cun)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cuq Real)
    (declare-const ?cur Real)
    (declare-const ?cus Real)
    (assert
      (or (or (= ?cus ?cur)
          (= ?cus ?cuq)
          )
        (= ?cur ?cuq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cut Real)
    (declare-const ?cuu Real)
    (declare-const ?cuv Real)
    (assert
      (or (or (= ?cuv ?cuu)
          (= ?cuv ?cut)
          )
        (= ?cuu ?cut)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cuw Real)
    (declare-const ?cux Real)
    (declare-const ?cuy Real)
    (declare-const ?cuz Real)
    (assert
      (or (or (= ?cuy ?cux)
          (= ?cuy ?cuw)
          )
        (= ?cux ?cuw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cva Real)
    (declare-const ?cvb Real)
    (declare-const ?cvc Real)
    (declare-const ?cvd Real)
    (declare-const ?cve Real)
    (assert
      (or (or (= ?cvc ?cvb)
          (= ?cvc ?cva)
          )
        (= ?cvb ?cva)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cvf Real)
    (declare-const ?cvg Real)
    (declare-const ?cvh Real)
    (declare-const ?cvi Real)
    (declare-const ?cvj Real)
    (declare-const ?cvk Real)
    (assert
      (and (or (or (= ?cvh ?cvg)
            (= ?cvh ?cvf)
            )
          (= ?cvg ?cvf)
          )
        (and (and (not (= ?cvk ?cvj))
            (not (= ?cvk ?cvi))
            )
          (not (= ?cvj ?cvi))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cvl Real)
    (declare-const ?cvm Real)
    (declare-const ?cvn Real)
    (assert
      (or (or (= ?cvn ?cvm)
          (= ?cvn ?cvl)
          )
        (= ?cvm ?cvl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?cvo Real)
  (declare-const ?cvp Real)
  (push 1)
    (declare-const ?cvq Real)
    (declare-const ?cvr Real)
    (declare-const ?cvs Real)
    (assert
      (or (or (= ?cvs ?cvr)
          (= ?cvs ?cvq)
          )
        (= ?cvr ?cvq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cvt Real)
    (declare-const ?cvu Real)
    (declare-const ?cvv Real)
    (declare-const ?cvw Real)
    (assert
      (or (or (= ?cvw ?cvv)
          (= ?cvw ?cvu)
          )
        (= ?cvv ?cvu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cvx Real)
    (declare-const ?cvy Real)
    (declare-const ?cvz Real)
    (declare-const ?cwa Real)
    (declare-const ?cwb Real)
    (assert
      (or (or (= ?cwb ?cwa)
          (= ?cwb ?cvz)
          )
        (= ?cwa ?cvz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cwc Real)
    (declare-const ?cwd Real)
    (declare-const ?cwe Real)
    (declare-const ?cwf Real)
    (declare-const ?cwg Real)
    (declare-const ?cwh Real)
    (assert
      (and (and (and (not (= ?cwe ?cwd))
            (not (= ?cwe ?cwc))
            )
          (not (= ?cwd ?cwc))
          )
        (or (or (= ?cwh ?cwg)
            (= ?cwh ?cwf)
            )
          (= ?cwg ?cwf)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cwi Real)
    (declare-const ?cwj Real)
    (declare-const ?cwk Real)
    (assert
      (or (or (= ?cwk ?cwj)
          (= ?cwk ?cwi)
          )
        (= ?cwj ?cwi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cwl Real)
    (declare-const ?cwm Real)
    (declare-const ?cwn Real)
    (assert
      (or (or (= ?cwn ?cwm)
          (= ?cwn ?cwl)
          )
        (= ?cwm ?cwl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cwo Real)
    (declare-const ?cwp Real)
    (declare-const ?cwq Real)
    (declare-const ?cwr Real)
    (assert
      (or (or (= ?cwq ?cwp)
          (= ?cwq ?cwo)
          )
        (= ?cwp ?cwo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cws Real)
    (declare-const ?cwt Real)
    (declare-const ?cwu Real)
    (declare-const ?cwv Real)
    (declare-const ?cww Real)
    (assert
      (or (or (= ?cwu ?cwt)
          (= ?cwu ?cws)
          )
        (= ?cwt ?cws)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cwx Real)
    (declare-const ?cwy Real)
    (declare-const ?cwz Real)
    (declare-const ?cxa Real)
    (declare-const ?cxb Real)
    (declare-const ?cxc Real)
    (assert
      (and (or (or (= ?cwz ?cwy)
            (= ?cwz ?cwx)
            )
          (= ?cwy ?cwx)
          )
        (and (and (not (= ?cxc ?cxb))
            (not (= ?cxc ?cxa))
            )
          (not (= ?cxb ?cxa))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cxd Real)
    (declare-const ?cxe Real)
    (declare-const ?cxf Real)
    (assert
      (or (or (= ?cxf ?cxe)
          (= ?cxf ?cxd)
          )
        (= ?cxe ?cxd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?cxg Real)
  (declare-const ?cxh Real)
  (declare-const ?cxi Real)
  (push 1)
    (declare-const ?cxj Real)
    (declare-const ?cxk Real)
    (declare-const ?cxl Real)
    (assert
      (or (or (= ?cxl ?cxk)
          (= ?cxl ?cxj)
          )
        (= ?cxk ?cxj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cxm Real)
    (declare-const ?cxn Real)
    (declare-const ?cxo Real)
    (declare-const ?cxp Real)
    (assert
      (or (or (= ?cxp ?cxo)
          (= ?cxp ?cxn)
          )
        (= ?cxo ?cxn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cxq Real)
    (declare-const ?cxr Real)
    (declare-const ?cxs Real)
    (declare-const ?cxt Real)
    (declare-const ?cxu Real)
    (assert
      (or (or (= ?cxu ?cxt)
          (= ?cxu ?cxs)
          )
        (= ?cxt ?cxs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cxv Real)
    (declare-const ?cxw Real)
    (declare-const ?cxx Real)
    (declare-const ?cxy Real)
    (declare-const ?cxz Real)
    (declare-const ?cya Real)
    (assert
      (and (and (and (not (= ?cxx ?cxw))
            (not (= ?cxx ?cxv))
            )
          (not (= ?cxw ?cxv))
          )
        (or (or (= ?cya ?cxz)
            (= ?cya ?cxy)
            )
          (= ?cxz ?cxy)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cyb Real)
    (declare-const ?cyc Real)
    (declare-const ?cyd Real)
    (assert
      (or (or (= ?cyd ?cyc)
          (= ?cyd ?cyb)
          )
        (= ?cyc ?cyb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cye Real)
    (declare-const ?cyf Real)
    (declare-const ?cyg Real)
    (assert
      (or (or (= ?cyg ?cyf)
          (= ?cyg ?cye)
          )
        (= ?cyf ?cye)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cyh Real)
    (declare-const ?cyi Real)
    (declare-const ?cyj Real)
    (declare-const ?cyk Real)
    (assert
      (or (or (= ?cyj ?cyi)
          (= ?cyj ?cyh)
          )
        (= ?cyi ?cyh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cyl Real)
    (declare-const ?cym Real)
    (declare-const ?cyn Real)
    (declare-const ?cyo Real)
    (declare-const ?cyp Real)
    (assert
      (or (or (= ?cyn ?cym)
          (= ?cyn ?cyl)
          )
        (= ?cym ?cyl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cyq Real)
    (declare-const ?cyr Real)
    (declare-const ?cys Real)
    (declare-const ?cyt Real)
    (declare-const ?cyu Real)
    (declare-const ?cyv Real)
    (assert
      (and (or (or (= ?cys ?cyr)
            (= ?cys ?cyq)
            )
          (= ?cyr ?cyq)
          )
        (and (and (not (= ?cyv ?cyu))
            (not (= ?cyv ?cyt))
            )
          (not (= ?cyu ?cyt))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?cyw Real)
    (declare-const ?cyx Real)
    (declare-const ?cyy Real)
    (assert
      (or (or (= ?cyy ?cyx)
          (= ?cyy ?cyw)
          )
        (= ?cyx ?cyw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?cyz Real)
  (declare-const ?cza Real)
  (declare-const ?czb Real)
  (declare-const ?czc Real)
  (assert
    (exists ((?asi Real) )(or (and (and (and (not (= ?cza ?cyz))
              (not (= ?cza ?asi))
              )
            (not (= ?cyz ?asi))
            )
          (or (or (= ?czc ?czb)
              (= ?czc ?asi)
              )
            (= ?czb ?asi)
            )
          )
        (and (or (or (= ?cza ?cyz)
              (= ?cza ?asi)
              )
            (= ?cyz ?asi)
            )
          (and (and (not (= ?czc ?czb))
              (not (= ?czc ?asi))
              )
            (not (= ?czb ?asi))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?czd Real)
    (declare-const ?cze Real)
    (declare-const ?czf Real)
    (assert
      (or (or (= ?czf ?cze)
          (= ?czf ?czd)
          )
        (= ?cze ?czd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?czg Real)
    (declare-const ?czh Real)
    (declare-const ?czi Real)
    (declare-const ?czj Real)
    (assert
      (or (or (= ?czj ?czi)
          (= ?czj ?czh)
          )
        (= ?czi ?czh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?czk Real)
    (declare-const ?czl Real)
    (declare-const ?czm Real)
    (declare-const ?czn Real)
    (declare-const ?czo Real)
    (assert
      (or (or (= ?czo ?czn)
          (= ?czo ?czm)
          )
        (= ?czn ?czm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?czp Real)
    (declare-const ?czq Real)
    (declare-const ?czr Real)
    (declare-const ?czs Real)
    (declare-const ?czt Real)
    (declare-const ?czu Real)
    (assert
      (and (and (and (not (= ?czr ?czq))
            (not (= ?czr ?czp))
            )
          (not (= ?czq ?czp))
          )
        (or (or (= ?czu ?czt)
            (= ?czu ?czs)
            )
          (= ?czt ?czs)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?czv Real)
    (declare-const ?czw Real)
    (declare-const ?czx Real)
    (assert
      (or (or (= ?czx ?czw)
          (= ?czx ?czv)
          )
        (= ?czw ?czv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?czy Real)
    (declare-const ?czz Real)
    (declare-const ?daa Real)
    (assert
      (or (or (= ?daa ?czz)
          (= ?daa ?czy)
          )
        (= ?czz ?czy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dab Real)
    (declare-const ?dac Real)
    (declare-const ?dad Real)
    (declare-const ?dae Real)
    (assert
      (or (or (= ?dad ?dac)
          (= ?dad ?dab)
          )
        (= ?dac ?dab)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?daf Real)
    (declare-const ?dag Real)
    (declare-const ?dah Real)
    (declare-const ?dai Real)
    (declare-const ?daj Real)
    (assert
      (or (or (= ?dah ?dag)
          (= ?dah ?daf)
          )
        (= ?dag ?daf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dak Real)
    (declare-const ?dal Real)
    (declare-const ?dam Real)
    (declare-const ?dan Real)
    (declare-const ?dao Real)
    (declare-const ?dap Real)
    (assert
      (and (or (or (= ?dam ?dal)
            (= ?dam ?dak)
            )
          (= ?dal ?dak)
          )
        (and (and (not (= ?dap ?dao))
            (not (= ?dap ?dan))
            )
          (not (= ?dao ?dan))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?daq Real)
    (declare-const ?dar Real)
    (declare-const ?das Real)
    (assert
      (or (or (= ?das ?dar)
          (= ?das ?daq)
          )
        (= ?dar ?daq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?dat Real)
  (declare-const ?dau Real)
  (declare-const ?dav Real)
  (declare-const ?daw Real)
  (declare-const ?dax Real)
  (push 1)
    (declare-const ?day Real)
    (declare-const ?daz Real)
    (declare-const ?dba Real)
    (assert
      (or (or (= ?dba ?daz)
          (= ?dba ?day)
          )
        (= ?daz ?day)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dbb Real)
    (declare-const ?dbc Real)
    (declare-const ?dbd Real)
    (declare-const ?dbe Real)
    (assert
      (or (or (= ?dbe ?dbd)
          (= ?dbe ?dbc)
          )
        (= ?dbd ?dbc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dbf Real)
    (declare-const ?dbg Real)
    (declare-const ?dbh Real)
    (declare-const ?dbi Real)
    (declare-const ?dbj Real)
    (assert
      (or (or (= ?dbj ?dbi)
          (= ?dbj ?dbh)
          )
        (= ?dbi ?dbh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dbk Real)
    (declare-const ?dbl Real)
    (declare-const ?dbm Real)
    (declare-const ?dbn Real)
    (declare-const ?dbo Real)
    (declare-const ?dbp Real)
    (assert
      (and (and (and (not (= ?dbm ?dbl))
            (not (= ?dbm ?dbk))
            )
          (not (= ?dbl ?dbk))
          )
        (or (or (= ?dbp ?dbo)
            (= ?dbp ?dbn)
            )
          (= ?dbo ?dbn)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dbq Real)
    (declare-const ?dbr Real)
    (declare-const ?dbs Real)
    (assert
      (or (or (= ?dbs ?dbr)
          (= ?dbs ?dbq)
          )
        (= ?dbr ?dbq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dbt Real)
    (declare-const ?dbu Real)
    (declare-const ?dbv Real)
    (assert
      (or (or (= ?dbv ?dbu)
          (= ?dbv ?dbt)
          )
        (= ?dbu ?dbt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dbw Real)
    (declare-const ?dbx Real)
    (declare-const ?dby Real)
    (declare-const ?dbz Real)
    (assert
      (or (or (= ?dby ?dbx)
          (= ?dby ?dbw)
          )
        (= ?dbx ?dbw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dca Real)
    (declare-const ?dcb Real)
    (declare-const ?dcc Real)
    (declare-const ?dcd Real)
    (declare-const ?dce Real)
    (assert
      (or (or (= ?dcc ?dcb)
          (= ?dcc ?dca)
          )
        (= ?dcb ?dca)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dcf Real)
    (declare-const ?dcg Real)
    (declare-const ?dch Real)
    (declare-const ?dci Real)
    (declare-const ?dcj Real)
    (declare-const ?dck Real)
    (assert
      (and (or (or (= ?dch ?dcg)
            (= ?dch ?dcf)
            )
          (= ?dcg ?dcf)
          )
        (and (and (not (= ?dck ?dcj))
            (not (= ?dck ?dci))
            )
          (not (= ?dcj ?dci))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dcl Real)
    (declare-const ?dcm Real)
    (declare-const ?dcn Real)
    (assert
      (or (or (= ?dcn ?dcm)
          (= ?dcn ?dcl)
          )
        (= ?dcm ?dcl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?dco Real)
  (declare-const ?dcp Real)
  (push 1)
    (declare-const ?dcq Real)
    (declare-const ?dcr Real)
    (declare-const ?dcs Real)
    (assert
      (or (or (= ?dcs ?dcr)
          (= ?dcs ?dcq)
          )
        (= ?dcr ?dcq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dct Real)
    (declare-const ?dcu Real)
    (declare-const ?dcv Real)
    (declare-const ?dcw Real)
    (assert
      (or (or (= ?dcw ?dcv)
          (= ?dcw ?dcu)
          )
        (= ?dcv ?dcu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dcx Real)
    (declare-const ?dcy Real)
    (declare-const ?dcz Real)
    (declare-const ?dda Real)
    (declare-const ?ddb Real)
    (assert
      (or (or (= ?ddb ?dda)
          (= ?ddb ?dcz)
          )
        (= ?dda ?dcz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ddc Real)
    (declare-const ?ddd Real)
    (declare-const ?dde Real)
    (declare-const ?ddf Real)
    (declare-const ?ddg Real)
    (declare-const ?ddh Real)
    (assert
      (and (and (and (not (= ?dde ?ddd))
            (not (= ?dde ?ddc))
            )
          (not (= ?ddd ?ddc))
          )
        (or (or (= ?ddh ?ddg)
            (= ?ddh ?ddf)
            )
          (= ?ddg ?ddf)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ddi Real)
    (declare-const ?ddj Real)
    (declare-const ?ddk Real)
    (assert
      (or (or (= ?ddk ?ddj)
          (= ?ddk ?ddi)
          )
        (= ?ddj ?ddi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ddl Real)
    (declare-const ?ddm Real)
    (declare-const ?ddn Real)
    (assert
      (or (or (= ?ddn ?ddm)
          (= ?ddn ?ddl)
          )
        (= ?ddm ?ddl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ddo Real)
    (declare-const ?ddp Real)
    (declare-const ?ddq Real)
    (declare-const ?ddr Real)
    (assert
      (or (or (= ?ddq ?ddp)
          (= ?ddq ?ddo)
          )
        (= ?ddp ?ddo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dds Real)
    (declare-const ?ddt Real)
    (declare-const ?ddu Real)
    (declare-const ?ddv Real)
    (declare-const ?ddw Real)
    (assert
      (or (or (= ?ddu ?ddt)
          (= ?ddu ?dds)
          )
        (= ?ddt ?dds)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ddx Real)
    (declare-const ?ddy Real)
    (declare-const ?ddz Real)
    (declare-const ?dea Real)
    (declare-const ?deb Real)
    (declare-const ?dec Real)
    (assert
      (and (or (or (= ?ddz ?ddy)
            (= ?ddz ?ddx)
            )
          (= ?ddy ?ddx)
          )
        (and (and (not (= ?dec ?deb))
            (not (= ?dec ?dea))
            )
          (not (= ?deb ?dea))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ded Real)
    (declare-const ?dee Real)
    (declare-const ?def Real)
    (assert
      (or (or (= ?def ?dee)
          (= ?def ?ded)
          )
        (= ?dee ?ded)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?deg Real)
  (declare-const ?deh Real)
  (declare-const ?dei Real)
  (declare-const ?dej Real)
  (declare-const ?dek Real)
  (push 1)
    (declare-const ?del Real)
    (declare-const ?dem Real)
    (declare-const ?den Real)
    (assert
      (or (or (= ?den ?dem)
          (= ?den ?del)
          )
        (= ?dem ?del)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?deo Real)
    (declare-const ?dep Real)
    (declare-const ?deq Real)
    (declare-const ?der Real)
    (assert
      (or (or (= ?der ?deq)
          (= ?der ?dep)
          )
        (= ?deq ?dep)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?des Real)
    (declare-const ?det Real)
    (declare-const ?deu Real)
    (declare-const ?dev Real)
    (declare-const ?dew Real)
    (assert
      (or (or (= ?dew ?dev)
          (= ?dew ?deu)
          )
        (= ?dev ?deu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dex Real)
    (declare-const ?dey Real)
    (declare-const ?dez Real)
    (declare-const ?dfa Real)
    (declare-const ?dfb Real)
    (declare-const ?dfc Real)
    (assert
      (and (and (and (not (= ?dez ?dey))
            (not (= ?dez ?dex))
            )
          (not (= ?dey ?dex))
          )
        (or (or (= ?dfc ?dfb)
            (= ?dfc ?dfa)
            )
          (= ?dfb ?dfa)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dfd Real)
    (declare-const ?dfe Real)
    (declare-const ?dff Real)
    (assert
      (or (or (= ?dff ?dfe)
          (= ?dff ?dfd)
          )
        (= ?dfe ?dfd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dfg Real)
    (declare-const ?dfh Real)
    (declare-const ?dfi Real)
    (assert
      (or (or (= ?dfi ?dfh)
          (= ?dfi ?dfg)
          )
        (= ?dfh ?dfg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dfj Real)
    (declare-const ?dfk Real)
    (declare-const ?dfl Real)
    (declare-const ?dfm Real)
    (assert
      (or (or (= ?dfl ?dfk)
          (= ?dfl ?dfj)
          )
        (= ?dfk ?dfj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dfn Real)
    (declare-const ?dfo Real)
    (declare-const ?dfp Real)
    (declare-const ?dfq Real)
    (declare-const ?dfr Real)
    (assert
      (or (or (= ?dfp ?dfo)
          (= ?dfp ?dfn)
          )
        (= ?dfo ?dfn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dfs Real)
    (declare-const ?dft Real)
    (declare-const ?dfu Real)
    (declare-const ?dfv Real)
    (declare-const ?dfw Real)
    (declare-const ?dfx Real)
    (assert
      (and (or (or (= ?dfu ?dft)
            (= ?dfu ?dfs)
            )
          (= ?dft ?dfs)
          )
        (and (and (not (= ?dfx ?dfw))
            (not (= ?dfx ?dfv))
            )
          (not (= ?dfw ?dfv))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dfy Real)
    (declare-const ?dfz Real)
    (declare-const ?dga Real)
    (assert
      (or (or (= ?dga ?dfz)
          (= ?dga ?dfy)
          )
        (= ?dfz ?dfy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?dgb Real)
  (declare-const ?dgc Real)
  (push 1)
    (declare-const ?dgd Real)
    (declare-const ?dge Real)
    (declare-const ?dgf Real)
    (assert
      (or (or (= ?dgf ?dge)
          (= ?dgf ?dgd)
          )
        (= ?dge ?dgd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dgg Real)
    (declare-const ?dgh Real)
    (declare-const ?dgi Real)
    (declare-const ?dgj Real)
    (assert
      (or (or (= ?dgj ?dgi)
          (= ?dgj ?dgh)
          )
        (= ?dgi ?dgh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dgk Real)
    (declare-const ?dgl Real)
    (declare-const ?dgm Real)
    (declare-const ?dgn Real)
    (declare-const ?dgo Real)
    (assert
      (or (or (= ?dgo ?dgn)
          (= ?dgo ?dgm)
          )
        (= ?dgn ?dgm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dgp Real)
    (declare-const ?dgq Real)
    (declare-const ?dgr Real)
    (declare-const ?dgs Real)
    (declare-const ?dgt Real)
    (declare-const ?dgu Real)
    (assert
      (and (and (and (not (= ?dgr ?dgq))
            (not (= ?dgr ?dgp))
            )
          (not (= ?dgq ?dgp))
          )
        (or (or (= ?dgu ?dgt)
            (= ?dgu ?dgs)
            )
          (= ?dgt ?dgs)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dgv Real)
    (declare-const ?dgw Real)
    (declare-const ?dgx Real)
    (assert
      (or (or (= ?dgx ?dgw)
          (= ?dgx ?dgv)
          )
        (= ?dgw ?dgv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dgy Real)
    (declare-const ?dgz Real)
    (declare-const ?dha Real)
    (assert
      (or (or (= ?dha ?dgz)
          (= ?dha ?dgy)
          )
        (= ?dgz ?dgy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dhb Real)
    (declare-const ?dhc Real)
    (declare-const ?dhd Real)
    (declare-const ?dhe Real)
    (assert
      (or (or (= ?dhd ?dhc)
          (= ?dhd ?dhb)
          )
        (= ?dhc ?dhb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dhf Real)
    (declare-const ?dhg Real)
    (declare-const ?dhh Real)
    (declare-const ?dhi Real)
    (declare-const ?dhj Real)
    (assert
      (or (or (= ?dhh ?dhg)
          (= ?dhh ?dhf)
          )
        (= ?dhg ?dhf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dhk Real)
    (declare-const ?dhl Real)
    (declare-const ?dhm Real)
    (declare-const ?dhn Real)
    (declare-const ?dho Real)
    (declare-const ?dhp Real)
    (assert
      (and (or (or (= ?dhm ?dhl)
            (= ?dhm ?dhk)
            )
          (= ?dhl ?dhk)
          )
        (and (and (not (= ?dhp ?dho))
            (not (= ?dhp ?dhn))
            )
          (not (= ?dho ?dhn))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dhq Real)
    (declare-const ?dhr Real)
    (declare-const ?dhs Real)
    (assert
      (or (or (= ?dhs ?dhr)
          (= ?dhs ?dhq)
          )
        (= ?dhr ?dhq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?dht Real)
  (declare-const ?dhu Real)
  (declare-const ?dhv Real)
  (assert
    (or (or (= ?dhv ?dhu)
        (= ?dhv ?dht)
        )
      (= ?dhu ?dht)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?dhw Real)
    (declare-const ?dhx Real)
    (declare-const ?dhy Real)
    (assert
      (or (or (= ?dhy ?dhx)
          (= ?dhy ?dhw)
          )
        (= ?dhx ?dhw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dhz Real)
    (declare-const ?dia Real)
    (declare-const ?dib Real)
    (declare-const ?dic Real)
    (assert
      (or (or (= ?dic ?dib)
          (= ?dic ?dia)
          )
        (= ?dib ?dia)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?did Real)
    (declare-const ?die Real)
    (declare-const ?dif Real)
    (declare-const ?dig Real)
    (declare-const ?dih Real)
    (assert
      (or (or (= ?dih ?dig)
          (= ?dih ?dif)
          )
        (= ?dig ?dif)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dii Real)
    (declare-const ?dij Real)
    (declare-const ?dik Real)
    (declare-const ?dil Real)
    (declare-const ?dim Real)
    (declare-const ?din Real)
    (assert
      (and (and (and (not (= ?dik ?dij))
            (not (= ?dik ?dii))
            )
          (not (= ?dij ?dii))
          )
        (or (or (= ?din ?dim)
            (= ?din ?dil)
            )
          (= ?dim ?dil)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dio Real)
    (declare-const ?dip Real)
    (declare-const ?diq Real)
    (assert
      (or (or (= ?diq ?dip)
          (= ?diq ?dio)
          )
        (= ?dip ?dio)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dir Real)
    (declare-const ?dis Real)
    (declare-const ?dit Real)
    (assert
      (or (or (= ?dit ?dis)
          (= ?dit ?dir)
          )
        (= ?dis ?dir)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?diu Real)
    (declare-const ?div Real)
    (declare-const ?diw Real)
    (declare-const ?dix Real)
    (assert
      (or (or (= ?diw ?div)
          (= ?diw ?diu)
          )
        (= ?div ?diu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?diy Real)
    (declare-const ?diz Real)
    (declare-const ?dja Real)
    (declare-const ?djb Real)
    (declare-const ?djc Real)
    (assert
      (or (or (= ?dja ?diz)
          (= ?dja ?diy)
          )
        (= ?diz ?diy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?djd Real)
    (declare-const ?dje Real)
    (declare-const ?djf Real)
    (declare-const ?djg Real)
    (declare-const ?djh Real)
    (declare-const ?dji Real)
    (assert
      (and (or (or (= ?djf ?dje)
            (= ?djf ?djd)
            )
          (= ?dje ?djd)
          )
        (and (and (not (= ?dji ?djh))
            (not (= ?dji ?djg))
            )
          (not (= ?djh ?djg))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?djj Real)
    (declare-const ?djk Real)
    (declare-const ?djl Real)
    (assert
      (or (or (= ?djl ?djk)
          (= ?djl ?djj)
          )
        (= ?djk ?djj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?djm Real)
    (declare-const ?djn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?djo Real)
    (declare-const ?djp Real)
    (declare-const ?djq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?djr Real)
    (declare-const ?djs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?djt Real)
    (declare-const ?dju Real)
    (declare-const ?djv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?djw Real)
    (declare-const ?djx Real)
    (declare-const ?djy Real)
    (declare-const ?djz Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?djx ?djw))
                (not (= ?djx ?asi))
                )
              (not (= ?djw ?asi))
              )
            (or (or (= ?djz ?djy)
                (= ?djz ?asi)
                )
              (= ?djy ?asi)
              )
            )
          (and (or (or (= ?djx ?djw)
                (= ?djx ?asi)
                )
              (= ?djw ?asi)
              )
            (and (and (not (= ?djz ?djy))
                (not (= ?djz ?asi))
                )
              (not (= ?djy ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dka Real)
    (declare-const ?dkb Real)
    (declare-const ?dkc Real)
    (declare-const ?dkd Real)
    (declare-const ?dke Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dkf Real)
    (declare-const ?dkg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dkh Real)
    (declare-const ?dki Real)
    (declare-const ?dkj Real)
    (declare-const ?dkk Real)
    (declare-const ?dkl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dkm Real)
    (declare-const ?dkn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?dko Real)
  (declare-const ?dkp Real)
  (declare-const ?dkq Real)
  (declare-const ?dkr Real)
  (assert
    (or (or (= ?dkr ?dkq)
        (= ?dkr ?dkp)
        )
      (= ?dkq ?dkp)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?dks Real)
    (declare-const ?dkt Real)
    (declare-const ?dku Real)
    (assert
      (or (or (= ?dku ?dkt)
          (= ?dku ?dks)
          )
        (= ?dkt ?dks)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dkv Real)
    (declare-const ?dkw Real)
    (declare-const ?dkx Real)
    (declare-const ?dky Real)
    (assert
      (or (or (= ?dky ?dkx)
          (= ?dky ?dkw)
          )
        (= ?dkx ?dkw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dkz Real)
    (declare-const ?dla Real)
    (declare-const ?dlb Real)
    (declare-const ?dlc Real)
    (declare-const ?dld Real)
    (assert
      (or (or (= ?dld ?dlc)
          (= ?dld ?dlb)
          )
        (= ?dlc ?dlb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dle Real)
    (declare-const ?dlf Real)
    (declare-const ?dlg Real)
    (declare-const ?dlh Real)
    (declare-const ?dli Real)
    (declare-const ?dlj Real)
    (assert
      (and (and (and (not (= ?dlg ?dlf))
            (not (= ?dlg ?dle))
            )
          (not (= ?dlf ?dle))
          )
        (or (or (= ?dlj ?dli)
            (= ?dlj ?dlh)
            )
          (= ?dli ?dlh)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dlk Real)
    (declare-const ?dll Real)
    (declare-const ?dlm Real)
    (assert
      (or (or (= ?dlm ?dll)
          (= ?dlm ?dlk)
          )
        (= ?dll ?dlk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dln Real)
    (declare-const ?dlo Real)
    (declare-const ?dlp Real)
    (assert
      (or (or (= ?dlp ?dlo)
          (= ?dlp ?dln)
          )
        (= ?dlo ?dln)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dlq Real)
    (declare-const ?dlr Real)
    (declare-const ?dls Real)
    (declare-const ?dlt Real)
    (assert
      (or (or (= ?dls ?dlr)
          (= ?dls ?dlq)
          )
        (= ?dlr ?dlq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dlu Real)
    (declare-const ?dlv Real)
    (declare-const ?dlw Real)
    (declare-const ?dlx Real)
    (declare-const ?dly Real)
    (assert
      (or (or (= ?dlw ?dlv)
          (= ?dlw ?dlu)
          )
        (= ?dlv ?dlu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dlz Real)
    (declare-const ?dma Real)
    (declare-const ?dmb Real)
    (declare-const ?dmc Real)
    (declare-const ?dmd Real)
    (declare-const ?dme Real)
    (assert
      (and (or (or (= ?dmb ?dma)
            (= ?dmb ?dlz)
            )
          (= ?dma ?dlz)
          )
        (and (and (not (= ?dme ?dmd))
            (not (= ?dme ?dmc))
            )
          (not (= ?dmd ?dmc))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dmf Real)
    (declare-const ?dmg Real)
    (declare-const ?dmh Real)
    (assert
      (or (or (= ?dmh ?dmg)
          (= ?dmh ?dmf)
          )
        (= ?dmg ?dmf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dmi Real)
    (declare-const ?dmj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dmk Real)
    (declare-const ?dml Real)
    (declare-const ?dmm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dmn Real)
    (declare-const ?dmo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dmp Real)
    (declare-const ?dmq Real)
    (declare-const ?dmr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dms Real)
    (declare-const ?dmt Real)
    (declare-const ?dmu Real)
    (declare-const ?dmv Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?dmt ?dms))
                (not (= ?dmt ?asi))
                )
              (not (= ?dms ?asi))
              )
            (or (or (= ?dmv ?dmu)
                (= ?dmv ?asi)
                )
              (= ?dmu ?asi)
              )
            )
          (and (or (or (= ?dmt ?dms)
                (= ?dmt ?asi)
                )
              (= ?dms ?asi)
              )
            (and (and (not (= ?dmv ?dmu))
                (not (= ?dmv ?asi))
                )
              (not (= ?dmu ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dmw Real)
    (declare-const ?dmx Real)
    (declare-const ?dmy Real)
    (declare-const ?dmz Real)
    (declare-const ?dna Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dnb Real)
    (declare-const ?dnc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dnd Real)
    (declare-const ?dne Real)
    (declare-const ?dnf Real)
    (declare-const ?dng Real)
    (declare-const ?dnh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dni Real)
    (declare-const ?dnj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?dnk Real)
  (declare-const ?dnl Real)
  (declare-const ?dnm Real)
  (declare-const ?dnn Real)
  (declare-const ?dno Real)
  (assert
    (or (or (= ?dno ?dnn)
        (= ?dno ?dnm)
        )
      (= ?dnn ?dnm)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?dnp Real)
    (declare-const ?dnq Real)
    (declare-const ?dnr Real)
    (assert
      (or (or (= ?dnr ?dnq)
          (= ?dnr ?dnp)
          )
        (= ?dnq ?dnp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dns Real)
    (declare-const ?dnt Real)
    (declare-const ?dnu Real)
    (declare-const ?dnv Real)
    (assert
      (or (or (= ?dnv ?dnu)
          (= ?dnv ?dnt)
          )
        (= ?dnu ?dnt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dnw Real)
    (declare-const ?dnx Real)
    (declare-const ?dny Real)
    (declare-const ?dnz Real)
    (declare-const ?doa Real)
    (assert
      (or (or (= ?doa ?dnz)
          (= ?doa ?dny)
          )
        (= ?dnz ?dny)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dob Real)
    (declare-const ?doc Real)
    (declare-const ?dod Real)
    (declare-const ?doe Real)
    (declare-const ?dof Real)
    (declare-const ?dog Real)
    (assert
      (and (and (and (not (= ?dod ?doc))
            (not (= ?dod ?dob))
            )
          (not (= ?doc ?dob))
          )
        (or (or (= ?dog ?dof)
            (= ?dog ?doe)
            )
          (= ?dof ?doe)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?doh Real)
    (declare-const ?doi Real)
    (declare-const ?doj Real)
    (assert
      (or (or (= ?doj ?doi)
          (= ?doj ?doh)
          )
        (= ?doi ?doh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dok Real)
    (declare-const ?dol Real)
    (declare-const ?dom Real)
    (assert
      (or (or (= ?dom ?dol)
          (= ?dom ?dok)
          )
        (= ?dol ?dok)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?don Real)
    (declare-const ?doo Real)
    (declare-const ?dop Real)
    (declare-const ?doq Real)
    (assert
      (or (or (= ?dop ?doo)
          (= ?dop ?don)
          )
        (= ?doo ?don)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dor Real)
    (declare-const ?dos Real)
    (declare-const ?dot Real)
    (declare-const ?dou Real)
    (declare-const ?dov Real)
    (assert
      (or (or (= ?dot ?dos)
          (= ?dot ?dor)
          )
        (= ?dos ?dor)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dow Real)
    (declare-const ?dox Real)
    (declare-const ?doy Real)
    (declare-const ?doz Real)
    (declare-const ?dpa Real)
    (declare-const ?dpb Real)
    (assert
      (and (or (or (= ?doy ?dox)
            (= ?doy ?dow)
            )
          (= ?dox ?dow)
          )
        (and (and (not (= ?dpb ?dpa))
            (not (= ?dpb ?doz))
            )
          (not (= ?dpa ?doz))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dpc Real)
    (declare-const ?dpd Real)
    (declare-const ?dpe Real)
    (assert
      (or (or (= ?dpe ?dpd)
          (= ?dpe ?dpc)
          )
        (= ?dpd ?dpc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dpf Real)
    (declare-const ?dpg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dph Real)
    (declare-const ?dpi Real)
    (declare-const ?dpj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dpk Real)
    (declare-const ?dpl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dpm Real)
    (declare-const ?dpn Real)
    (declare-const ?dpo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dpp Real)
    (declare-const ?dpq Real)
    (declare-const ?dpr Real)
    (declare-const ?dps Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?dpq ?dpp))
                (not (= ?dpq ?asi))
                )
              (not (= ?dpp ?asi))
              )
            (or (or (= ?dps ?dpr)
                (= ?dps ?asi)
                )
              (= ?dpr ?asi)
              )
            )
          (and (or (or (= ?dpq ?dpp)
                (= ?dpq ?asi)
                )
              (= ?dpp ?asi)
              )
            (and (and (not (= ?dps ?dpr))
                (not (= ?dps ?asi))
                )
              (not (= ?dpr ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dpt Real)
    (declare-const ?dpu Real)
    (declare-const ?dpv Real)
    (declare-const ?dpw Real)
    (declare-const ?dpx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dpy Real)
    (declare-const ?dpz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dqa Real)
    (declare-const ?dqb Real)
    (declare-const ?dqc Real)
    (declare-const ?dqd Real)
    (declare-const ?dqe Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dqf Real)
    (declare-const ?dqg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?dqh Real)
  (declare-const ?dqi Real)
  (declare-const ?dqj Real)
  (declare-const ?dqk Real)
  (declare-const ?dql Real)
  (declare-const ?dqm Real)
  (assert
    (and (and (and (not (= ?dqj ?dqi))
          (not (= ?dqj ?dqh))
          )
        (not (= ?dqi ?dqh))
        )
      (or (or (= ?dqm ?dql)
          (= ?dqm ?dqk)
          )
        (= ?dql ?dqk)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?dqn Real)
    (declare-const ?dqo Real)
    (declare-const ?dqp Real)
    (assert
      (or (or (= ?dqp ?dqo)
          (= ?dqp ?dqn)
          )
        (= ?dqo ?dqn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dqq Real)
    (declare-const ?dqr Real)
    (declare-const ?dqs Real)
    (declare-const ?dqt Real)
    (assert
      (or (or (= ?dqt ?dqs)
          (= ?dqt ?dqr)
          )
        (= ?dqs ?dqr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dqu Real)
    (declare-const ?dqv Real)
    (declare-const ?dqw Real)
    (declare-const ?dqx Real)
    (declare-const ?dqy Real)
    (assert
      (or (or (= ?dqy ?dqx)
          (= ?dqy ?dqw)
          )
        (= ?dqx ?dqw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dqz Real)
    (declare-const ?dra Real)
    (declare-const ?drb Real)
    (declare-const ?drc Real)
    (declare-const ?drd Real)
    (declare-const ?dre Real)
    (assert
      (and (and (and (not (= ?drb ?dra))
            (not (= ?drb ?dqz))
            )
          (not (= ?dra ?dqz))
          )
        (or (or (= ?dre ?drd)
            (= ?dre ?drc)
            )
          (= ?drd ?drc)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?drf Real)
    (declare-const ?drg Real)
    (declare-const ?drh Real)
    (assert
      (or (or (= ?drh ?drg)
          (= ?drh ?drf)
          )
        (= ?drg ?drf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dri Real)
    (declare-const ?drj Real)
    (declare-const ?drk Real)
    (assert
      (or (or (= ?drk ?drj)
          (= ?drk ?dri)
          )
        (= ?drj ?dri)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?drl Real)
    (declare-const ?drm Real)
    (declare-const ?drn Real)
    (declare-const ?dro Real)
    (assert
      (or (or (= ?drn ?drm)
          (= ?drn ?drl)
          )
        (= ?drm ?drl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?drp Real)
    (declare-const ?drq Real)
    (declare-const ?drr Real)
    (declare-const ?drs Real)
    (declare-const ?drt Real)
    (assert
      (or (or (= ?drr ?drq)
          (= ?drr ?drp)
          )
        (= ?drq ?drp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dru Real)
    (declare-const ?drv Real)
    (declare-const ?drw Real)
    (declare-const ?drx Real)
    (declare-const ?dry Real)
    (declare-const ?drz Real)
    (assert
      (and (or (or (= ?drw ?drv)
            (= ?drw ?dru)
            )
          (= ?drv ?dru)
          )
        (and (and (not (= ?drz ?dry))
            (not (= ?drz ?drx))
            )
          (not (= ?dry ?drx))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dsa Real)
    (declare-const ?dsb Real)
    (declare-const ?dsc Real)
    (assert
      (or (or (= ?dsc ?dsb)
          (= ?dsc ?dsa)
          )
        (= ?dsb ?dsa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dsd Real)
    (declare-const ?dse Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dsf Real)
    (declare-const ?dsg Real)
    (declare-const ?dsh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dsi Real)
    (declare-const ?dsj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dsk Real)
    (declare-const ?dsl Real)
    (declare-const ?dsm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dsn Real)
    (declare-const ?dso Real)
    (declare-const ?dsp Real)
    (declare-const ?dsq Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?dso ?dsn))
                (not (= ?dso ?asi))
                )
              (not (= ?dsn ?asi))
              )
            (or (or (= ?dsq ?dsp)
                (= ?dsq ?asi)
                )
              (= ?dsp ?asi)
              )
            )
          (and (or (or (= ?dso ?dsn)
                (= ?dso ?asi)
                )
              (= ?dsn ?asi)
              )
            (and (and (not (= ?dsq ?dsp))
                (not (= ?dsq ?asi))
                )
              (not (= ?dsp ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dsr Real)
    (declare-const ?dss Real)
    (declare-const ?dst Real)
    (declare-const ?dsu Real)
    (declare-const ?dsv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dsw Real)
    (declare-const ?dsx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dsy Real)
    (declare-const ?dsz Real)
    (declare-const ?dta Real)
    (declare-const ?dtb Real)
    (declare-const ?dtc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dtd Real)
    (declare-const ?dte Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?dtf Real)
  (declare-const ?dtg Real)
  (declare-const ?dth Real)
  (assert
    (or (or (= ?dth ?dtg)
        (= ?dth ?dtf)
        )
      (= ?dtg ?dtf)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?dti Real)
    (declare-const ?dtj Real)
    (declare-const ?dtk Real)
    (assert
      (or (or (= ?dtk ?dtj)
          (= ?dtk ?dti)
          )
        (= ?dtj ?dti)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dtl Real)
    (declare-const ?dtm Real)
    (declare-const ?dtn Real)
    (declare-const ?dto Real)
    (assert
      (or (or (= ?dto ?dtn)
          (= ?dto ?dtm)
          )
        (= ?dtn ?dtm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dtp Real)
    (declare-const ?dtq Real)
    (declare-const ?dtr Real)
    (declare-const ?dts Real)
    (declare-const ?dtt Real)
    (assert
      (or (or (= ?dtt ?dts)
          (= ?dtt ?dtr)
          )
        (= ?dts ?dtr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dtu Real)
    (declare-const ?dtv Real)
    (declare-const ?dtw Real)
    (declare-const ?dtx Real)
    (declare-const ?dty Real)
    (declare-const ?dtz Real)
    (assert
      (and (and (and (not (= ?dtw ?dtv))
            (not (= ?dtw ?dtu))
            )
          (not (= ?dtv ?dtu))
          )
        (or (or (= ?dtz ?dty)
            (= ?dtz ?dtx)
            )
          (= ?dty ?dtx)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dua Real)
    (declare-const ?dub Real)
    (declare-const ?duc Real)
    (assert
      (or (or (= ?duc ?dub)
          (= ?duc ?dua)
          )
        (= ?dub ?dua)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dud Real)
    (declare-const ?due Real)
    (declare-const ?duf Real)
    (assert
      (or (or (= ?duf ?due)
          (= ?duf ?dud)
          )
        (= ?due ?dud)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dug Real)
    (declare-const ?duh Real)
    (declare-const ?dui Real)
    (declare-const ?duj Real)
    (assert
      (or (or (= ?dui ?duh)
          (= ?dui ?dug)
          )
        (= ?duh ?dug)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?duk Real)
    (declare-const ?dul Real)
    (declare-const ?dum Real)
    (declare-const ?dun Real)
    (declare-const ?duo Real)
    (assert
      (or (or (= ?dum ?dul)
          (= ?dum ?duk)
          )
        (= ?dul ?duk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dup Real)
    (declare-const ?duq Real)
    (declare-const ?dur Real)
    (declare-const ?dus Real)
    (declare-const ?dut Real)
    (declare-const ?duu Real)
    (assert
      (and (or (or (= ?dur ?duq)
            (= ?dur ?dup)
            )
          (= ?duq ?dup)
          )
        (and (and (not (= ?duu ?dut))
            (not (= ?duu ?dus))
            )
          (not (= ?dut ?dus))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?duv Real)
    (declare-const ?duw Real)
    (declare-const ?dux Real)
    (assert
      (or (or (= ?dux ?duw)
          (= ?dux ?duv)
          )
        (= ?duw ?duv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?duy Real)
    (declare-const ?duz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dva Real)
    (declare-const ?dvb Real)
    (declare-const ?dvc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dvd Real)
    (declare-const ?dve Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dvf Real)
    (declare-const ?dvg Real)
    (declare-const ?dvh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dvi Real)
    (declare-const ?dvj Real)
    (declare-const ?dvk Real)
    (declare-const ?dvl Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?dvj ?dvi))
                (not (= ?dvj ?asi))
                )
              (not (= ?dvi ?asi))
              )
            (or (or (= ?dvl ?dvk)
                (= ?dvl ?asi)
                )
              (= ?dvk ?asi)
              )
            )
          (and (or (or (= ?dvj ?dvi)
                (= ?dvj ?asi)
                )
              (= ?dvi ?asi)
              )
            (and (and (not (= ?dvl ?dvk))
                (not (= ?dvl ?asi))
                )
              (not (= ?dvk ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dvm Real)
    (declare-const ?dvn Real)
    (declare-const ?dvo Real)
    (declare-const ?dvp Real)
    (declare-const ?dvq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dvr Real)
    (declare-const ?dvs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dvt Real)
    (declare-const ?dvu Real)
    (declare-const ?dvv Real)
    (declare-const ?dvw Real)
    (declare-const ?dvx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dvy Real)
    (declare-const ?dvz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?dwa Real)
  (declare-const ?dwb Real)
  (declare-const ?dwc Real)
  (assert
    (or (or (= ?dwc ?dwb)
        (= ?dwc ?dwa)
        )
      (= ?dwb ?dwa)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?dwd Real)
    (declare-const ?dwe Real)
    (declare-const ?dwf Real)
    (assert
      (or (or (= ?dwf ?dwe)
          (= ?dwf ?dwd)
          )
        (= ?dwe ?dwd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dwg Real)
    (declare-const ?dwh Real)
    (declare-const ?dwi Real)
    (declare-const ?dwj Real)
    (assert
      (or (or (= ?dwj ?dwi)
          (= ?dwj ?dwh)
          )
        (= ?dwi ?dwh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dwk Real)
    (declare-const ?dwl Real)
    (declare-const ?dwm Real)
    (declare-const ?dwn Real)
    (declare-const ?dwo Real)
    (assert
      (or (or (= ?dwo ?dwn)
          (= ?dwo ?dwm)
          )
        (= ?dwn ?dwm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dwp Real)
    (declare-const ?dwq Real)
    (declare-const ?dwr Real)
    (declare-const ?dws Real)
    (declare-const ?dwt Real)
    (declare-const ?dwu Real)
    (assert
      (and (and (and (not (= ?dwr ?dwq))
            (not (= ?dwr ?dwp))
            )
          (not (= ?dwq ?dwp))
          )
        (or (or (= ?dwu ?dwt)
            (= ?dwu ?dws)
            )
          (= ?dwt ?dws)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dwv Real)
    (declare-const ?dww Real)
    (declare-const ?dwx Real)
    (assert
      (or (or (= ?dwx ?dww)
          (= ?dwx ?dwv)
          )
        (= ?dww ?dwv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dwy Real)
    (declare-const ?dwz Real)
    (declare-const ?dxa Real)
    (assert
      (or (or (= ?dxa ?dwz)
          (= ?dxa ?dwy)
          )
        (= ?dwz ?dwy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dxb Real)
    (declare-const ?dxc Real)
    (declare-const ?dxd Real)
    (declare-const ?dxe Real)
    (assert
      (or (or (= ?dxd ?dxc)
          (= ?dxd ?dxb)
          )
        (= ?dxc ?dxb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dxf Real)
    (declare-const ?dxg Real)
    (declare-const ?dxh Real)
    (declare-const ?dxi Real)
    (declare-const ?dxj Real)
    (assert
      (or (or (= ?dxh ?dxg)
          (= ?dxh ?dxf)
          )
        (= ?dxg ?dxf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dxk Real)
    (declare-const ?dxl Real)
    (declare-const ?dxm Real)
    (declare-const ?dxn Real)
    (declare-const ?dxo Real)
    (declare-const ?dxp Real)
    (assert
      (and (or (or (= ?dxm ?dxl)
            (= ?dxm ?dxk)
            )
          (= ?dxl ?dxk)
          )
        (and (and (not (= ?dxp ?dxo))
            (not (= ?dxp ?dxn))
            )
          (not (= ?dxo ?dxn))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dxq Real)
    (declare-const ?dxr Real)
    (declare-const ?dxs Real)
    (assert
      (or (or (= ?dxs ?dxr)
          (= ?dxs ?dxq)
          )
        (= ?dxr ?dxq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dxt Real)
    (declare-const ?dxu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dxv Real)
    (declare-const ?dxw Real)
    (declare-const ?dxx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dxy Real)
    (declare-const ?dxz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dya Real)
    (declare-const ?dyb Real)
    (declare-const ?dyc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dyd Real)
    (declare-const ?dye Real)
    (declare-const ?dyf Real)
    (declare-const ?dyg Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?dye ?dyd))
                (not (= ?dye ?asi))
                )
              (not (= ?dyd ?asi))
              )
            (or (or (= ?dyg ?dyf)
                (= ?dyg ?asi)
                )
              (= ?dyf ?asi)
              )
            )
          (and (or (or (= ?dye ?dyd)
                (= ?dye ?asi)
                )
              (= ?dyd ?asi)
              )
            (and (and (not (= ?dyg ?dyf))
                (not (= ?dyg ?asi))
                )
              (not (= ?dyf ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dyh Real)
    (declare-const ?dyi Real)
    (declare-const ?dyj Real)
    (declare-const ?dyk Real)
    (declare-const ?dyl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dym Real)
    (declare-const ?dyn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dyo Real)
    (declare-const ?dyp Real)
    (declare-const ?dyq Real)
    (declare-const ?dyr Real)
    (declare-const ?dys Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dyt Real)
    (declare-const ?dyu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?dyv Real)
  (declare-const ?dyw Real)
  (declare-const ?dyx Real)
  (declare-const ?dyy Real)
  (assert
    (or (or (= ?dyx ?dyw)
        (= ?dyx ?dyv)
        )
      (= ?dyw ?dyv)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?dyz Real)
    (declare-const ?dza Real)
    (declare-const ?dzb Real)
    (assert
      (or (or (= ?dzb ?dza)
          (= ?dzb ?dyz)
          )
        (= ?dza ?dyz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dzc Real)
    (declare-const ?dzd Real)
    (declare-const ?dze Real)
    (declare-const ?dzf Real)
    (assert
      (or (or (= ?dzf ?dze)
          (= ?dzf ?dzd)
          )
        (= ?dze ?dzd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dzg Real)
    (declare-const ?dzh Real)
    (declare-const ?dzi Real)
    (declare-const ?dzj Real)
    (declare-const ?dzk Real)
    (assert
      (or (or (= ?dzk ?dzj)
          (= ?dzk ?dzi)
          )
        (= ?dzj ?dzi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dzl Real)
    (declare-const ?dzm Real)
    (declare-const ?dzn Real)
    (declare-const ?dzo Real)
    (declare-const ?dzp Real)
    (declare-const ?dzq Real)
    (assert
      (and (and (and (not (= ?dzn ?dzm))
            (not (= ?dzn ?dzl))
            )
          (not (= ?dzm ?dzl))
          )
        (or (or (= ?dzq ?dzp)
            (= ?dzq ?dzo)
            )
          (= ?dzp ?dzo)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dzr Real)
    (declare-const ?dzs Real)
    (declare-const ?dzt Real)
    (assert
      (or (or (= ?dzt ?dzs)
          (= ?dzt ?dzr)
          )
        (= ?dzs ?dzr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dzu Real)
    (declare-const ?dzv Real)
    (declare-const ?dzw Real)
    (assert
      (or (or (= ?dzw ?dzv)
          (= ?dzw ?dzu)
          )
        (= ?dzv ?dzu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?dzx Real)
    (declare-const ?dzy Real)
    (declare-const ?dzz Real)
    (declare-const ?eaa Real)
    (assert
      (or (or (= ?dzz ?dzy)
          (= ?dzz ?dzx)
          )
        (= ?dzy ?dzx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?eab Real)
    (declare-const ?eac Real)
    (declare-const ?ead Real)
    (declare-const ?eae Real)
    (declare-const ?eaf Real)
    (assert
      (or (or (= ?ead ?eac)
          (= ?ead ?eab)
          )
        (= ?eac ?eab)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?eag Real)
    (declare-const ?eah Real)
    (declare-const ?eai Real)
    (declare-const ?eaj Real)
    (declare-const ?eak Real)
    (declare-const ?eal Real)
    (assert
      (and (or (or (= ?eai ?eah)
            (= ?eai ?eag)
            )
          (= ?eah ?eag)
          )
        (and (and (not (= ?eal ?eak))
            (not (= ?eal ?eaj))
            )
          (not (= ?eak ?eaj))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?eam Real)
    (declare-const ?ean Real)
    (declare-const ?eao Real)
    (assert
      (or (or (= ?eao ?ean)
          (= ?eao ?eam)
          )
        (= ?ean ?eam)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?eap Real)
    (declare-const ?eaq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ear Real)
    (declare-const ?eas Real)
    (declare-const ?eat Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?eau Real)
    (declare-const ?eav Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?eaw Real)
    (declare-const ?eax Real)
    (declare-const ?eay Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?eaz Real)
    (declare-const ?eba Real)
    (declare-const ?ebb Real)
    (declare-const ?ebc Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?eba ?eaz))
                (not (= ?eba ?asi))
                )
              (not (= ?eaz ?asi))
              )
            (or (or (= ?ebc ?ebb)
                (= ?ebc ?asi)
                )
              (= ?ebb ?asi)
              )
            )
          (and (or (or (= ?eba ?eaz)
                (= ?eba ?asi)
                )
              (= ?eaz ?asi)
              )
            (and (and (not (= ?ebc ?ebb))
                (not (= ?ebc ?asi))
                )
              (not (= ?ebb ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ebd Real)
    (declare-const ?ebe Real)
    (declare-const ?ebf Real)
    (declare-const ?ebg Real)
    (declare-const ?ebh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ebi Real)
    (declare-const ?ebj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ebk Real)
    (declare-const ?ebl Real)
    (declare-const ?ebm Real)
    (declare-const ?ebn Real)
    (declare-const ?ebo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ebp Real)
    (declare-const ?ebq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ebr Real)
  (declare-const ?ebs Real)
  (declare-const ?ebt Real)
  (declare-const ?ebu Real)
  (declare-const ?ebv Real)
  (assert
    (or (or (= ?ebt ?ebs)
        (= ?ebt ?ebr)
        )
      (= ?ebs ?ebr)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?ebw Real)
    (declare-const ?ebx Real)
    (declare-const ?eby Real)
    (assert
      (or (or (= ?eby ?ebx)
          (= ?eby ?ebw)
          )
        (= ?ebx ?ebw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ebz Real)
    (declare-const ?eca Real)
    (declare-const ?ecb Real)
    (declare-const ?ecc Real)
    (assert
      (or (or (= ?ecc ?ecb)
          (= ?ecc ?eca)
          )
        (= ?ecb ?eca)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ecd Real)
    (declare-const ?ece Real)
    (declare-const ?ecf Real)
    (declare-const ?ecg Real)
    (declare-const ?ech Real)
    (assert
      (or (or (= ?ech ?ecg)
          (= ?ech ?ecf)
          )
        (= ?ecg ?ecf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?eci Real)
    (declare-const ?ecj Real)
    (declare-const ?eck Real)
    (declare-const ?ecl Real)
    (declare-const ?ecm Real)
    (declare-const ?ecn Real)
    (assert
      (and (and (and (not (= ?eck ?ecj))
            (not (= ?eck ?eci))
            )
          (not (= ?ecj ?eci))
          )
        (or (or (= ?ecn ?ecm)
            (= ?ecn ?ecl)
            )
          (= ?ecm ?ecl)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?eco Real)
    (declare-const ?ecp Real)
    (declare-const ?ecq Real)
    (assert
      (or (or (= ?ecq ?ecp)
          (= ?ecq ?eco)
          )
        (= ?ecp ?eco)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ecr Real)
    (declare-const ?ecs Real)
    (declare-const ?ect Real)
    (assert
      (or (or (= ?ect ?ecs)
          (= ?ect ?ecr)
          )
        (= ?ecs ?ecr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ecu Real)
    (declare-const ?ecv Real)
    (declare-const ?ecw Real)
    (declare-const ?ecx Real)
    (assert
      (or (or (= ?ecw ?ecv)
          (= ?ecw ?ecu)
          )
        (= ?ecv ?ecu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ecy Real)
    (declare-const ?ecz Real)
    (declare-const ?eda Real)
    (declare-const ?edb Real)
    (declare-const ?edc Real)
    (assert
      (or (or (= ?eda ?ecz)
          (= ?eda ?ecy)
          )
        (= ?ecz ?ecy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?edd Real)
    (declare-const ?ede Real)
    (declare-const ?edf Real)
    (declare-const ?edg Real)
    (declare-const ?edh Real)
    (declare-const ?edi Real)
    (assert
      (and (or (or (= ?edf ?ede)
            (= ?edf ?edd)
            )
          (= ?ede ?edd)
          )
        (and (and (not (= ?edi ?edh))
            (not (= ?edi ?edg))
            )
          (not (= ?edh ?edg))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?edj Real)
    (declare-const ?edk Real)
    (declare-const ?edl Real)
    (assert
      (or (or (= ?edl ?edk)
          (= ?edl ?edj)
          )
        (= ?edk ?edj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?edm Real)
    (declare-const ?edn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?edo Real)
    (declare-const ?edp Real)
    (declare-const ?edq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?edr Real)
    (declare-const ?eds Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?edt Real)
    (declare-const ?edu Real)
    (declare-const ?edv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?edw Real)
    (declare-const ?edx Real)
    (declare-const ?edy Real)
    (declare-const ?edz Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?edx ?edw))
                (not (= ?edx ?asi))
                )
              (not (= ?edw ?asi))
              )
            (or (or (= ?edz ?edy)
                (= ?edz ?asi)
                )
              (= ?edy ?asi)
              )
            )
          (and (or (or (= ?edx ?edw)
                (= ?edx ?asi)
                )
              (= ?edw ?asi)
              )
            (and (and (not (= ?edz ?edy))
                (not (= ?edz ?asi))
                )
              (not (= ?edy ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?eea Real)
    (declare-const ?eeb Real)
    (declare-const ?eec Real)
    (declare-const ?eed Real)
    (declare-const ?eee Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?eef Real)
    (declare-const ?eeg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?eeh Real)
    (declare-const ?eei Real)
    (declare-const ?eej Real)
    (declare-const ?eek Real)
    (declare-const ?eel Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?eem Real)
    (declare-const ?een Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?eeo Real)
  (declare-const ?eep Real)
  (declare-const ?eeq Real)
  (declare-const ?eer Real)
  (declare-const ?ees Real)
  (declare-const ?eet Real)
  (assert
    (and (or (or (= ?eeq ?eep)
          (= ?eeq ?eeo)
          )
        (= ?eep ?eeo)
        )
      (and (and (not (= ?eet ?ees))
          (not (= ?eet ?eer))
          )
        (not (= ?ees ?eer))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?eeu Real)
    (declare-const ?eev Real)
    (declare-const ?eew Real)
    (assert
      (or (or (= ?eew ?eev)
          (= ?eew ?eeu)
          )
        (= ?eev ?eeu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?eex Real)
    (declare-const ?eey Real)
    (declare-const ?eez Real)
    (declare-const ?efa Real)
    (assert
      (or (or (= ?efa ?eez)
          (= ?efa ?eey)
          )
        (= ?eez ?eey)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?efb Real)
    (declare-const ?efc Real)
    (declare-const ?efd Real)
    (declare-const ?efe Real)
    (declare-const ?eff Real)
    (assert
      (or (or (= ?eff ?efe)
          (= ?eff ?efd)
          )
        (= ?efe ?efd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?efg Real)
    (declare-const ?efh Real)
    (declare-const ?efi Real)
    (declare-const ?efj Real)
    (declare-const ?efk Real)
    (declare-const ?efl Real)
    (assert
      (and (and (and (not (= ?efi ?efh))
            (not (= ?efi ?efg))
            )
          (not (= ?efh ?efg))
          )
        (or (or (= ?efl ?efk)
            (= ?efl ?efj)
            )
          (= ?efk ?efj)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?efm Real)
    (declare-const ?efn Real)
    (declare-const ?efo Real)
    (assert
      (or (or (= ?efo ?efn)
          (= ?efo ?efm)
          )
        (= ?efn ?efm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?efp Real)
    (declare-const ?efq Real)
    (declare-const ?efr Real)
    (assert
      (or (or (= ?efr ?efq)
          (= ?efr ?efp)
          )
        (= ?efq ?efp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?efs Real)
    (declare-const ?eft Real)
    (declare-const ?efu Real)
    (declare-const ?efv Real)
    (assert
      (or (or (= ?efu ?eft)
          (= ?efu ?efs)
          )
        (= ?eft ?efs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?efw Real)
    (declare-const ?efx Real)
    (declare-const ?efy Real)
    (declare-const ?efz Real)
    (declare-const ?ega Real)
    (assert
      (or (or (= ?efy ?efx)
          (= ?efy ?efw)
          )
        (= ?efx ?efw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?egb Real)
    (declare-const ?egc Real)
    (declare-const ?egd Real)
    (declare-const ?ege Real)
    (declare-const ?egf Real)
    (declare-const ?egg Real)
    (assert
      (and (or (or (= ?egd ?egc)
            (= ?egd ?egb)
            )
          (= ?egc ?egb)
          )
        (and (and (not (= ?egg ?egf))
            (not (= ?egg ?ege))
            )
          (not (= ?egf ?ege))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?egh Real)
    (declare-const ?egi Real)
    (declare-const ?egj Real)
    (assert
      (or (or (= ?egj ?egi)
          (= ?egj ?egh)
          )
        (= ?egi ?egh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?egk Real)
    (declare-const ?egl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?egm Real)
    (declare-const ?egn Real)
    (declare-const ?ego Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?egp Real)
    (declare-const ?egq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?egr Real)
    (declare-const ?egs Real)
    (declare-const ?egt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?egu Real)
    (declare-const ?egv Real)
    (declare-const ?egw Real)
    (declare-const ?egx Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?egv ?egu))
                (not (= ?egv ?asi))
                )
              (not (= ?egu ?asi))
              )
            (or (or (= ?egx ?egw)
                (= ?egx ?asi)
                )
              (= ?egw ?asi)
              )
            )
          (and (or (or (= ?egv ?egu)
                (= ?egv ?asi)
                )
              (= ?egu ?asi)
              )
            (and (and (not (= ?egx ?egw))
                (not (= ?egx ?asi))
                )
              (not (= ?egw ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?egy Real)
    (declare-const ?egz Real)
    (declare-const ?eha Real)
    (declare-const ?ehb Real)
    (declare-const ?ehc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ehd Real)
    (declare-const ?ehe Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ehf Real)
    (declare-const ?ehg Real)
    (declare-const ?ehh Real)
    (declare-const ?ehi Real)
    (declare-const ?ehj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ehk Real)
    (declare-const ?ehl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ehm Real)
  (declare-const ?ehn Real)
  (declare-const ?eho Real)
  (assert
    (or (or (= ?eho ?ehn)
        (= ?eho ?ehm)
        )
      (= ?ehn ?ehm)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?ehp Real)
    (declare-const ?ehq Real)
    (declare-const ?ehr Real)
    (assert
      (or (or (= ?ehr ?ehq)
          (= ?ehr ?ehp)
          )
        (= ?ehq ?ehp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ehs Real)
    (declare-const ?eht Real)
    (declare-const ?ehu Real)
    (declare-const ?ehv Real)
    (assert
      (or (or (= ?ehv ?ehu)
          (= ?ehv ?eht)
          )
        (= ?ehu ?eht)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ehw Real)
    (declare-const ?ehx Real)
    (declare-const ?ehy Real)
    (declare-const ?ehz Real)
    (declare-const ?eia Real)
    (assert
      (or (or (= ?eia ?ehz)
          (= ?eia ?ehy)
          )
        (= ?ehz ?ehy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?eib Real)
    (declare-const ?eic Real)
    (declare-const ?eid Real)
    (declare-const ?eie Real)
    (declare-const ?eif Real)
    (declare-const ?eig Real)
    (assert
      (and (and (and (not (= ?eid ?eic))
            (not (= ?eid ?eib))
            )
          (not (= ?eic ?eib))
          )
        (or (or (= ?eig ?eif)
            (= ?eig ?eie)
            )
          (= ?eif ?eie)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?eih Real)
    (declare-const ?eii Real)
    (declare-const ?eij Real)
    (assert
      (or (or (= ?eij ?eii)
          (= ?eij ?eih)
          )
        (= ?eii ?eih)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?eik Real)
    (declare-const ?eil Real)
    (declare-const ?eim Real)
    (assert
      (or (or (= ?eim ?eil)
          (= ?eim ?eik)
          )
        (= ?eil ?eik)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ein Real)
    (declare-const ?eio Real)
    (declare-const ?eip Real)
    (declare-const ?eiq Real)
    (assert
      (or (or (= ?eip ?eio)
          (= ?eip ?ein)
          )
        (= ?eio ?ein)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?eir Real)
    (declare-const ?eis Real)
    (declare-const ?eit Real)
    (declare-const ?eiu Real)
    (declare-const ?eiv Real)
    (assert
      (or (or (= ?eit ?eis)
          (= ?eit ?eir)
          )
        (= ?eis ?eir)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?eiw Real)
    (declare-const ?eix Real)
    (declare-const ?eiy Real)
    (declare-const ?eiz Real)
    (declare-const ?eja Real)
    (declare-const ?ejb Real)
    (assert
      (and (or (or (= ?eiy ?eix)
            (= ?eiy ?eiw)
            )
          (= ?eix ?eiw)
          )
        (and (and (not (= ?ejb ?eja))
            (not (= ?ejb ?eiz))
            )
          (not (= ?eja ?eiz))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ejc Real)
    (declare-const ?ejd Real)
    (declare-const ?eje Real)
    (assert
      (or (or (= ?eje ?ejd)
          (= ?eje ?ejc)
          )
        (= ?ejd ?ejc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ejf Real)
    (declare-const ?ejg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ejh Real)
    (declare-const ?eji Real)
    (declare-const ?ejj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ejk Real)
    (declare-const ?ejl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ejm Real)
    (declare-const ?ejn Real)
    (declare-const ?ejo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ejp Real)
    (declare-const ?ejq Real)
    (declare-const ?ejr Real)
    (declare-const ?ejs Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ejq ?ejp))
                (not (= ?ejq ?asi))
                )
              (not (= ?ejp ?asi))
              )
            (or (or (= ?ejs ?ejr)
                (= ?ejs ?asi)
                )
              (= ?ejr ?asi)
              )
            )
          (and (or (or (= ?ejq ?ejp)
                (= ?ejq ?asi)
                )
              (= ?ejp ?asi)
              )
            (and (and (not (= ?ejs ?ejr))
                (not (= ?ejs ?asi))
                )
              (not (= ?ejr ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ejt Real)
    (declare-const ?eju Real)
    (declare-const ?ejv Real)
    (declare-const ?ejw Real)
    (declare-const ?ejx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ejy Real)
    (declare-const ?ejz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?eka Real)
    (declare-const ?ekb Real)
    (declare-const ?ekc Real)
    (declare-const ?ekd Real)
    (declare-const ?eke Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ekf Real)
    (declare-const ?ekg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ekh Real)
  (declare-const ?eki Real)
  (declare-const ?ekj Real)
  (assert
    (or (or (= ?ekj ?eki)
        (= ?ekj ?ekh)
        )
      (= ?eki ?ekh)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ekk Real)
  (declare-const ?ekl Real)
  (declare-const ?ekm Real)
  (declare-const ?ekn Real)
  (assert
    (or (or (= ?ekn ?ekm)
        (= ?ekn ?ekl)
        )
      (= ?ekm ?ekl)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?eko Real)
  (declare-const ?ekp Real)
  (declare-const ?ekq Real)
  (declare-const ?ekr Real)
  (declare-const ?eks Real)
  (assert
    (or (or (= ?eks ?ekr)
        (= ?eks ?ekq)
        )
      (= ?ekr ?ekq)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ekt Real)
  (declare-const ?eku Real)
  (declare-const ?ekv Real)
  (declare-const ?ekw Real)
  (declare-const ?ekx Real)
  (declare-const ?eky Real)
  (assert
    (and (and (and (not (= ?ekv ?eku))
          (not (= ?ekv ?ekt))
          )
        (not (= ?eku ?ekt))
        )
      (or (or (= ?eky ?ekx)
          (= ?eky ?ekw)
          )
        (= ?ekx ?ekw)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ekz Real)
  (declare-const ?ela Real)
  (declare-const ?elb Real)
  (assert
    (or (or (= ?elb ?ela)
        (= ?elb ?ekz)
        )
      (= ?ela ?ekz)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?elc Real)
  (declare-const ?eld Real)
  (declare-const ?ele Real)
  (assert
    (or (or (= ?ele ?eld)
        (= ?ele ?elc)
        )
      (= ?eld ?elc)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?elf Real)
  (declare-const ?elg Real)
  (declare-const ?elh Real)
  (declare-const ?eli Real)
  (assert
    (or (or (= ?elh ?elg)
        (= ?elh ?elf)
        )
      (= ?elg ?elf)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?elj Real)
  (declare-const ?elk Real)
  (declare-const ?ell Real)
  (declare-const ?elm Real)
  (declare-const ?eln Real)
  (assert
    (or (or (= ?ell ?elk)
        (= ?ell ?elj)
        )
      (= ?elk ?elj)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?elo Real)
  (declare-const ?elp Real)
  (declare-const ?elq Real)
  (declare-const ?elr Real)
  (declare-const ?els Real)
  (declare-const ?elt Real)
  (assert
    (and (or (or (= ?elq ?elp)
          (= ?elq ?elo)
          )
        (= ?elp ?elo)
        )
      (and (and (not (= ?elt ?els))
          (not (= ?elt ?elr))
          )
        (not (= ?els ?elr))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?elu Real)
  (declare-const ?elv Real)
  (declare-const ?elw Real)
  (assert
    (or (or (= ?elw ?elv)
        (= ?elw ?elu)
        )
      (= ?elv ?elu)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?elx Real)
    (declare-const ?ely Real)
    (declare-const ?elz Real)
    (assert
      (or (or (= ?elz ?ely)
          (= ?elz ?elx)
          )
        (= ?ely ?elx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ema Real)
    (declare-const ?emb Real)
    (declare-const ?emc Real)
    (declare-const ?emd Real)
    (assert
      (or (or (= ?emd ?emc)
          (= ?emd ?emb)
          )
        (= ?emc ?emb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?eme Real)
    (declare-const ?emf Real)
    (declare-const ?emg Real)
    (declare-const ?emh Real)
    (declare-const ?emi Real)
    (assert
      (or (or (= ?emi ?emh)
          (= ?emi ?emg)
          )
        (= ?emh ?emg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?emj Real)
    (declare-const ?emk Real)
    (declare-const ?eml Real)
    (declare-const ?emm Real)
    (declare-const ?emn Real)
    (declare-const ?emo Real)
    (assert
      (and (and (and (not (= ?eml ?emk))
            (not (= ?eml ?emj))
            )
          (not (= ?emk ?emj))
          )
        (or (or (= ?emo ?emn)
            (= ?emo ?emm)
            )
          (= ?emn ?emm)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?emp Real)
    (declare-const ?emq Real)
    (declare-const ?emr Real)
    (assert
      (or (or (= ?emr ?emq)
          (= ?emr ?emp)
          )
        (= ?emq ?emp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ems Real)
    (declare-const ?emt Real)
    (declare-const ?emu Real)
    (assert
      (or (or (= ?emu ?emt)
          (= ?emu ?ems)
          )
        (= ?emt ?ems)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?emv Real)
    (declare-const ?emw Real)
    (declare-const ?emx Real)
    (declare-const ?emy Real)
    (assert
      (or (or (= ?emx ?emw)
          (= ?emx ?emv)
          )
        (= ?emw ?emv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?emz Real)
    (declare-const ?ena Real)
    (declare-const ?enb Real)
    (declare-const ?enc Real)
    (declare-const ?end Real)
    (assert
      (or (or (= ?enb ?ena)
          (= ?enb ?emz)
          )
        (= ?ena ?emz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ene Real)
    (declare-const ?enf Real)
    (declare-const ?eng Real)
    (declare-const ?enh Real)
    (declare-const ?eni Real)
    (declare-const ?enj Real)
    (assert
      (and (or (or (= ?eng ?enf)
            (= ?eng ?ene)
            )
          (= ?enf ?ene)
          )
        (and (and (not (= ?enj ?eni))
            (not (= ?enj ?enh))
            )
          (not (= ?eni ?enh))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?enk Real)
    (declare-const ?enl Real)
    (declare-const ?enm Real)
    (assert
      (or (or (= ?enm ?enl)
          (= ?enm ?enk)
          )
        (= ?enl ?enk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?enn Real)
    (declare-const ?eno Real)
    (declare-const ?enp Real)
    (declare-const ?enq Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?eno ?enn))
                (not (= ?eno ?asi))
                )
              (not (= ?enn ?asi))
              )
            (or (or (= ?enq ?enp)
                (= ?enq ?asi)
                )
              (= ?enp ?asi)
              )
            )
          (and (or (or (= ?eno ?enn)
                (= ?eno ?asi)
                )
              (= ?enn ?asi)
              )
            (and (and (not (= ?enq ?enp))
                (not (= ?enq ?asi))
                )
              (not (= ?enp ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?enr Real)
    (push 1)
      (declare-const ?ens Real)
      (declare-const ?ent Real)
      (declare-const ?enu Real)
      (assert
        (or (or (= ?enu ?ent)
            (= ?enu ?ens)
            )
          (= ?ent ?ens)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?env Real)
      (declare-const ?enw Real)
      (declare-const ?enx Real)
      (declare-const ?eny Real)
      (assert
        (or (or (= ?eny ?enx)
            (= ?eny ?enw)
            )
          (= ?enx ?enw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?enz Real)
      (declare-const ?eoa Real)
      (declare-const ?eob Real)
      (declare-const ?eoc Real)
      (declare-const ?eod Real)
      (assert
        (or (or (= ?eod ?eoc)
            (= ?eod ?eob)
            )
          (= ?eoc ?eob)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?eoe Real)
      (declare-const ?eof Real)
      (declare-const ?eog Real)
      (declare-const ?eoh Real)
      (declare-const ?eoi Real)
      (declare-const ?eoj Real)
      (assert
        (and (and (and (not (= ?eog ?eof))
              (not (= ?eog ?eoe))
              )
            (not (= ?eof ?eoe))
            )
          (or (or (= ?eoj ?eoi)
              (= ?eoj ?eoh)
              )
            (= ?eoi ?eoh)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?eok Real)
      (declare-const ?eol Real)
      (declare-const ?eom Real)
      (assert
        (or (or (= ?eom ?eol)
            (= ?eom ?eok)
            )
          (= ?eol ?eok)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?eon Real)
      (declare-const ?eoo Real)
      (declare-const ?eop Real)
      (assert
        (or (or (= ?eop ?eoo)
            (= ?eop ?eon)
            )
          (= ?eoo ?eon)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?eoq Real)
      (declare-const ?eor Real)
      (declare-const ?eos Real)
      (declare-const ?eot Real)
      (assert
        (or (or (= ?eos ?eor)
            (= ?eos ?eoq)
            )
          (= ?eor ?eoq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?eou Real)
      (declare-const ?eov Real)
      (declare-const ?eow Real)
      (declare-const ?eox Real)
      (declare-const ?eoy Real)
      (assert
        (or (or (= ?eow ?eov)
            (= ?eow ?eou)
            )
          (= ?eov ?eou)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?eoz Real)
      (declare-const ?epa Real)
      (declare-const ?epb Real)
      (declare-const ?epc Real)
      (declare-const ?epd Real)
      (declare-const ?epe Real)
      (assert
        (and (or (or (= ?epb ?epa)
              (= ?epb ?eoz)
              )
            (= ?epa ?eoz)
            )
          (and (and (not (= ?epe ?epd))
              (not (= ?epe ?epc))
              )
            (not (= ?epd ?epc))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?epf Real)
      (declare-const ?epg Real)
      (declare-const ?eph Real)
      (assert
        (or (or (= ?eph ?epg)
            (= ?eph ?epf)
            )
          (= ?epg ?epf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?epi Real)
      (declare-const ?epj Real)
      (declare-const ?epk Real)
      (declare-const ?epl Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?epj ?epi))
                  (not (= ?epj ?asi))
                  )
                (not (= ?epi ?asi))
                )
              (or (or (= ?epl ?epk)
                  (= ?epl ?asi)
                  )
                (= ?epk ?asi)
                )
              )
            (and (or (or (= ?epj ?epi)
                  (= ?epj ?asi)
                  )
                (= ?epi ?asi)
                )
              (and (and (not (= ?epl ?epk))
                  (not (= ?epl ?asi))
                  )
                (not (= ?epk ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?epm Real)
    (declare-const ?epn Real)
    (push 1)
      (declare-const ?epo Real)
      (declare-const ?epp Real)
      (declare-const ?epq Real)
      (assert
        (or (or (= ?epq ?epp)
            (= ?epq ?epo)
            )
          (= ?epp ?epo)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?epr Real)
      (declare-const ?eps Real)
      (declare-const ?ept Real)
      (declare-const ?epu Real)
      (assert
        (or (or (= ?epu ?ept)
            (= ?epu ?eps)
            )
          (= ?ept ?eps)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?epv Real)
      (declare-const ?epw Real)
      (declare-const ?epx Real)
      (declare-const ?epy Real)
      (declare-const ?epz Real)
      (assert
        (or (or (= ?epz ?epy)
            (= ?epz ?epx)
            )
          (= ?epy ?epx)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?eqa Real)
      (declare-const ?eqb Real)
      (declare-const ?eqc Real)
      (declare-const ?eqd Real)
      (declare-const ?eqe Real)
      (declare-const ?eqf Real)
      (assert
        (and (and (and (not (= ?eqc ?eqb))
              (not (= ?eqc ?eqa))
              )
            (not (= ?eqb ?eqa))
            )
          (or (or (= ?eqf ?eqe)
              (= ?eqf ?eqd)
              )
            (= ?eqe ?eqd)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?eqg Real)
      (declare-const ?eqh Real)
      (declare-const ?eqi Real)
      (assert
        (or (or (= ?eqi ?eqh)
            (= ?eqi ?eqg)
            )
          (= ?eqh ?eqg)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?eqj Real)
      (declare-const ?eqk Real)
      (declare-const ?eql Real)
      (assert
        (or (or (= ?eql ?eqk)
            (= ?eql ?eqj)
            )
          (= ?eqk ?eqj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?eqm Real)
      (declare-const ?eqn Real)
      (declare-const ?eqo Real)
      (declare-const ?eqp Real)
      (assert
        (or (or (= ?eqo ?eqn)
            (= ?eqo ?eqm)
            )
          (= ?eqn ?eqm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?eqq Real)
      (declare-const ?eqr Real)
      (declare-const ?eqs Real)
      (declare-const ?eqt Real)
      (declare-const ?equ Real)
      (assert
        (or (or (= ?eqs ?eqr)
            (= ?eqs ?eqq)
            )
          (= ?eqr ?eqq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?eqv Real)
      (declare-const ?eqw Real)
      (declare-const ?eqx Real)
      (declare-const ?eqy Real)
      (declare-const ?eqz Real)
      (declare-const ?era Real)
      (assert
        (and (or (or (= ?eqx ?eqw)
              (= ?eqx ?eqv)
              )
            (= ?eqw ?eqv)
            )
          (and (and (not (= ?era ?eqz))
              (not (= ?era ?eqy))
              )
            (not (= ?eqz ?eqy))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?erb Real)
      (declare-const ?erc Real)
      (declare-const ?erd Real)
      (assert
        (or (or (= ?erd ?erc)
            (= ?erd ?erb)
            )
          (= ?erc ?erb)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ere Real)
      (declare-const ?erf Real)
      (declare-const ?erg Real)
      (declare-const ?erh Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?erf ?ere))
                  (not (= ?erf ?asi))
                  )
                (not (= ?ere ?asi))
                )
              (or (or (= ?erh ?erg)
                  (= ?erh ?asi)
                  )
                (= ?erg ?asi)
                )
              )
            (and (or (or (= ?erf ?ere)
                  (= ?erf ?asi)
                  )
                (= ?ere ?asi)
                )
              (and (and (not (= ?erh ?erg))
                  (not (= ?erh ?asi))
                  )
                (not (= ?erg ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?eri Real)
    (declare-const ?erj Real)
    (declare-const ?erk Real)
    (push 1)
      (declare-const ?erl Real)
      (declare-const ?erm Real)
      (declare-const ?ern Real)
      (assert
        (or (or (= ?ern ?erm)
            (= ?ern ?erl)
            )
          (= ?erm ?erl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ero Real)
      (declare-const ?erp Real)
      (declare-const ?erq Real)
      (declare-const ?err Real)
      (assert
        (or (or (= ?err ?erq)
            (= ?err ?erp)
            )
          (= ?erq ?erp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ers Real)
      (declare-const ?ert Real)
      (declare-const ?eru Real)
      (declare-const ?erv Real)
      (declare-const ?erw Real)
      (assert
        (or (or (= ?erw ?erv)
            (= ?erw ?eru)
            )
          (= ?erv ?eru)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?erx Real)
      (declare-const ?ery Real)
      (declare-const ?erz Real)
      (declare-const ?esa Real)
      (declare-const ?esb Real)
      (declare-const ?esc Real)
      (assert
        (and (and (and (not (= ?erz ?ery))
              (not (= ?erz ?erx))
              )
            (not (= ?ery ?erx))
            )
          (or (or (= ?esc ?esb)
              (= ?esc ?esa)
              )
            (= ?esb ?esa)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?esd Real)
      (declare-const ?ese Real)
      (declare-const ?esf Real)
      (assert
        (or (or (= ?esf ?ese)
            (= ?esf ?esd)
            )
          (= ?ese ?esd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?esg Real)
      (declare-const ?esh Real)
      (declare-const ?esi Real)
      (assert
        (or (or (= ?esi ?esh)
            (= ?esi ?esg)
            )
          (= ?esh ?esg)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?esj Real)
      (declare-const ?esk Real)
      (declare-const ?esl Real)
      (declare-const ?esm Real)
      (assert
        (or (or (= ?esl ?esk)
            (= ?esl ?esj)
            )
          (= ?esk ?esj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?esn Real)
      (declare-const ?eso Real)
      (declare-const ?esp Real)
      (declare-const ?esq Real)
      (declare-const ?esr Real)
      (assert
        (or (or (= ?esp ?eso)
            (= ?esp ?esn)
            )
          (= ?eso ?esn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ess Real)
      (declare-const ?est Real)
      (declare-const ?esu Real)
      (declare-const ?esv Real)
      (declare-const ?esw Real)
      (declare-const ?esx Real)
      (assert
        (and (or (or (= ?esu ?est)
              (= ?esu ?ess)
              )
            (= ?est ?ess)
            )
          (and (and (not (= ?esx ?esw))
              (not (= ?esx ?esv))
              )
            (not (= ?esw ?esv))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?esy Real)
      (declare-const ?esz Real)
      (declare-const ?eta Real)
      (assert
        (or (or (= ?eta ?esz)
            (= ?eta ?esy)
            )
          (= ?esz ?esy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?etb Real)
      (declare-const ?etc Real)
      (declare-const ?etd Real)
      (declare-const ?ete Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?etc ?etb))
                  (not (= ?etc ?asi))
                  )
                (not (= ?etb ?asi))
                )
              (or (or (= ?ete ?etd)
                  (= ?ete ?asi)
                  )
                (= ?etd ?asi)
                )
              )
            (and (or (or (= ?etc ?etb)
                  (= ?etc ?asi)
                  )
                (= ?etb ?asi)
                )
              (and (and (not (= ?ete ?etd))
                  (not (= ?ete ?asi))
                  )
                (not (= ?etd ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (= ?erk ?erj)
            (= ?erk ?eri)
            )
          (= ?erj ?eri)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?etf Real)
    (declare-const ?etg Real)
    (declare-const ?eth Real)
    (declare-const ?eti Real)
    (push 1)
      (declare-const ?etj Real)
      (declare-const ?etk Real)
      (declare-const ?etl Real)
      (assert
        (or (or (= ?etl ?etk)
            (= ?etl ?etj)
            )
          (= ?etk ?etj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?etm Real)
      (declare-const ?etn Real)
      (declare-const ?eto Real)
      (declare-const ?etp Real)
      (assert
        (or (or (= ?etp ?eto)
            (= ?etp ?etn)
            )
          (= ?eto ?etn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?etq Real)
      (declare-const ?etr Real)
      (declare-const ?ets Real)
      (declare-const ?ett Real)
      (declare-const ?etu Real)
      (assert
        (or (or (= ?etu ?ett)
            (= ?etu ?ets)
            )
          (= ?ett ?ets)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?etv Real)
      (declare-const ?etw Real)
      (declare-const ?etx Real)
      (declare-const ?ety Real)
      (declare-const ?etz Real)
      (declare-const ?eua Real)
      (assert
        (and (and (and (not (= ?etx ?etw))
              (not (= ?etx ?etv))
              )
            (not (= ?etw ?etv))
            )
          (or (or (= ?eua ?etz)
              (= ?eua ?ety)
              )
            (= ?etz ?ety)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?eub Real)
      (declare-const ?euc Real)
      (declare-const ?eud Real)
      (assert
        (or (or (= ?eud ?euc)
            (= ?eud ?eub)
            )
          (= ?euc ?eub)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?eue Real)
      (declare-const ?euf Real)
      (declare-const ?eug Real)
      (assert
        (or (or (= ?eug ?euf)
            (= ?eug ?eue)
            )
          (= ?euf ?eue)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?euh Real)
      (declare-const ?eui Real)
      (declare-const ?euj Real)
      (declare-const ?euk Real)
      (assert
        (or (or (= ?euj ?eui)
            (= ?euj ?euh)
            )
          (= ?eui ?euh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?eul Real)
      (declare-const ?eum Real)
      (declare-const ?eun Real)
      (declare-const ?euo Real)
      (declare-const ?eup Real)
      (assert
        (or (or (= ?eun ?eum)
            (= ?eun ?eul)
            )
          (= ?eum ?eul)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?euq Real)
      (declare-const ?eur Real)
      (declare-const ?eus Real)
      (declare-const ?eut Real)
      (declare-const ?euu Real)
      (declare-const ?euv Real)
      (assert
        (and (or (or (= ?eus ?eur)
              (= ?eus ?euq)
              )
            (= ?eur ?euq)
            )
          (and (and (not (= ?euv ?euu))
              (not (= ?euv ?eut))
              )
            (not (= ?euu ?eut))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?euw Real)
      (declare-const ?eux Real)
      (declare-const ?euy Real)
      (assert
        (or (or (= ?euy ?eux)
            (= ?euy ?euw)
            )
          (= ?eux ?euw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?euz Real)
      (declare-const ?eva Real)
      (declare-const ?evb Real)
      (declare-const ?evc Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?eva ?euz))
                  (not (= ?eva ?asi))
                  )
                (not (= ?euz ?asi))
                )
              (or (or (= ?evc ?evb)
                  (= ?evc ?asi)
                  )
                (= ?evb ?asi)
                )
              )
            (and (or (or (= ?eva ?euz)
                  (= ?eva ?asi)
                  )
                (= ?euz ?asi)
                )
              (and (and (not (= ?evc ?evb))
                  (not (= ?evc ?asi))
                  )
                (not (= ?evb ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?evd Real)
    (push 1)
      (declare-const ?eve Real)
      (declare-const ?evf Real)
      (declare-const ?evg Real)
      (assert
        (or (or (= ?evg ?evf)
            (= ?evg ?eve)
            )
          (= ?evf ?eve)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?evh Real)
      (declare-const ?evi Real)
      (declare-const ?evj Real)
      (declare-const ?evk Real)
      (assert
        (or (or (= ?evk ?evj)
            (= ?evk ?evi)
            )
          (= ?evj ?evi)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?evl Real)
      (declare-const ?evm Real)
      (declare-const ?evn Real)
      (declare-const ?evo Real)
      (declare-const ?evp Real)
      (assert
        (or (or (= ?evp ?evo)
            (= ?evp ?evn)
            )
          (= ?evo ?evn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?evq Real)
      (declare-const ?evr Real)
      (declare-const ?evs Real)
      (declare-const ?evt Real)
      (declare-const ?evu Real)
      (declare-const ?evv Real)
      (assert
        (and (and (and (not (= ?evs ?evr))
              (not (= ?evs ?evq))
              )
            (not (= ?evr ?evq))
            )
          (or (or (= ?evv ?evu)
              (= ?evv ?evt)
              )
            (= ?evu ?evt)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?evw Real)
      (declare-const ?evx Real)
      (declare-const ?evy Real)
      (assert
        (or (or (= ?evy ?evx)
            (= ?evy ?evw)
            )
          (= ?evx ?evw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?evz Real)
      (declare-const ?ewa Real)
      (declare-const ?ewb Real)
      (assert
        (or (or (= ?ewb ?ewa)
            (= ?ewb ?evz)
            )
          (= ?ewa ?evz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ewc Real)
      (declare-const ?ewd Real)
      (declare-const ?ewe Real)
      (declare-const ?ewf Real)
      (assert
        (or (or (= ?ewe ?ewd)
            (= ?ewe ?ewc)
            )
          (= ?ewd ?ewc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ewg Real)
      (declare-const ?ewh Real)
      (declare-const ?ewi Real)
      (declare-const ?ewj Real)
      (declare-const ?ewk Real)
      (assert
        (or (or (= ?ewi ?ewh)
            (= ?ewi ?ewg)
            )
          (= ?ewh ?ewg)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ewl Real)
      (declare-const ?ewm Real)
      (declare-const ?ewn Real)
      (declare-const ?ewo Real)
      (declare-const ?ewp Real)
      (declare-const ?ewq Real)
      (assert
        (and (or (or (= ?ewn ?ewm)
              (= ?ewn ?ewl)
              )
            (= ?ewm ?ewl)
            )
          (and (and (not (= ?ewq ?ewp))
              (not (= ?ewq ?ewo))
              )
            (not (= ?ewp ?ewo))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ewr Real)
      (declare-const ?ews Real)
      (declare-const ?ewt Real)
      (assert
        (or (or (= ?ewt ?ews)
            (= ?ewt ?ewr)
            )
          (= ?ews ?ewr)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ewu Real)
      (declare-const ?ewv Real)
      (declare-const ?eww Real)
      (declare-const ?ewx Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?ewv ?ewu))
                  (not (= ?ewv ?asi))
                  )
                (not (= ?ewu ?asi))
                )
              (or (or (= ?ewx ?eww)
                  (= ?ewx ?asi)
                  )
                (= ?eww ?asi)
                )
              )
            (and (or (or (= ?ewv ?ewu)
                  (= ?ewv ?asi)
                  )
                (= ?ewu ?asi)
                )
              (and (and (not (= ?ewx ?eww))
                  (not (= ?ewx ?asi))
                  )
                (not (= ?eww ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?ewy Real)
    (declare-const ?ewz Real)
    (push 1)
      (declare-const ?exa Real)
      (declare-const ?exb Real)
      (declare-const ?exc Real)
      (assert
        (or (or (= ?exc ?exb)
            (= ?exc ?exa)
            )
          (= ?exb ?exa)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?exd Real)
      (declare-const ?exe Real)
      (declare-const ?exf Real)
      (declare-const ?exg Real)
      (assert
        (or (or (= ?exg ?exf)
            (= ?exg ?exe)
            )
          (= ?exf ?exe)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?exh Real)
      (declare-const ?exi Real)
      (declare-const ?exj Real)
      (declare-const ?exk Real)
      (declare-const ?exl Real)
      (assert
        (or (or (= ?exl ?exk)
            (= ?exl ?exj)
            )
          (= ?exk ?exj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?exm Real)
      (declare-const ?exn Real)
      (declare-const ?exo Real)
      (declare-const ?exp Real)
      (declare-const ?exq Real)
      (declare-const ?exr Real)
      (assert
        (and (and (and (not (= ?exo ?exn))
              (not (= ?exo ?exm))
              )
            (not (= ?exn ?exm))
            )
          (or (or (= ?exr ?exq)
              (= ?exr ?exp)
              )
            (= ?exq ?exp)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?exs Real)
      (declare-const ?ext Real)
      (declare-const ?exu Real)
      (assert
        (or (or (= ?exu ?ext)
            (= ?exu ?exs)
            )
          (= ?ext ?exs)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?exv Real)
      (declare-const ?exw Real)
      (declare-const ?exx Real)
      (assert
        (or (or (= ?exx ?exw)
            (= ?exx ?exv)
            )
          (= ?exw ?exv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?exy Real)
      (declare-const ?exz Real)
      (declare-const ?eya Real)
      (declare-const ?eyb Real)
      (assert
        (or (or (= ?eya ?exz)
            (= ?eya ?exy)
            )
          (= ?exz ?exy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?eyc Real)
      (declare-const ?eyd Real)
      (declare-const ?eye Real)
      (declare-const ?eyf Real)
      (declare-const ?eyg Real)
      (assert
        (or (or (= ?eye ?eyd)
            (= ?eye ?eyc)
            )
          (= ?eyd ?eyc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?eyh Real)
      (declare-const ?eyi Real)
      (declare-const ?eyj Real)
      (declare-const ?eyk Real)
      (declare-const ?eyl Real)
      (declare-const ?eym Real)
      (assert
        (and (or (or (= ?eyj ?eyi)
              (= ?eyj ?eyh)
              )
            (= ?eyi ?eyh)
            )
          (and (and (not (= ?eym ?eyl))
              (not (= ?eym ?eyk))
              )
            (not (= ?eyl ?eyk))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?eyn Real)
      (declare-const ?eyo Real)
      (declare-const ?eyp Real)
      (assert
        (or (or (= ?eyp ?eyo)
            (= ?eyp ?eyn)
            )
          (= ?eyo ?eyn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?eyq Real)
      (declare-const ?eyr Real)
      (declare-const ?eys Real)
      (declare-const ?eyt Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?eyr ?eyq))
                  (not (= ?eyr ?asi))
                  )
                (not (= ?eyq ?asi))
                )
              (or (or (= ?eyt ?eys)
                  (= ?eyt ?asi)
                  )
                (= ?eys ?asi)
                )
              )
            (and (or (or (= ?eyr ?eyq)
                  (= ?eyr ?asi)
                  )
                (= ?eyq ?asi)
                )
              (and (and (not (= ?eyt ?eys))
                  (not (= ?eyt ?asi))
                  )
                (not (= ?eys ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?eyu Real)
    (declare-const ?eyv Real)
    (declare-const ?eyw Real)
    (push 1)
      (declare-const ?eyx Real)
      (declare-const ?eyy Real)
      (declare-const ?eyz Real)
      (assert
        (or (or (= ?eyz ?eyy)
            (= ?eyz ?eyx)
            )
          (= ?eyy ?eyx)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?eza Real)
      (declare-const ?ezb Real)
      (declare-const ?ezc Real)
      (declare-const ?ezd Real)
      (assert
        (or (or (= ?ezd ?ezc)
            (= ?ezd ?ezb)
            )
          (= ?ezc ?ezb)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?eze Real)
      (declare-const ?ezf Real)
      (declare-const ?ezg Real)
      (declare-const ?ezh Real)
      (declare-const ?ezi Real)
      (assert
        (or (or (= ?ezi ?ezh)
            (= ?ezi ?ezg)
            )
          (= ?ezh ?ezg)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ezj Real)
      (declare-const ?ezk Real)
      (declare-const ?ezl Real)
      (declare-const ?ezm Real)
      (declare-const ?ezn Real)
      (declare-const ?ezo Real)
      (assert
        (and (and (and (not (= ?ezl ?ezk))
              (not (= ?ezl ?ezj))
              )
            (not (= ?ezk ?ezj))
            )
          (or (or (= ?ezo ?ezn)
              (= ?ezo ?ezm)
              )
            (= ?ezn ?ezm)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ezp Real)
      (declare-const ?ezq Real)
      (declare-const ?ezr Real)
      (assert
        (or (or (= ?ezr ?ezq)
            (= ?ezr ?ezp)
            )
          (= ?ezq ?ezp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ezs Real)
      (declare-const ?ezt Real)
      (declare-const ?ezu Real)
      (assert
        (or (or (= ?ezu ?ezt)
            (= ?ezu ?ezs)
            )
          (= ?ezt ?ezs)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ezv Real)
      (declare-const ?ezw Real)
      (declare-const ?ezx Real)
      (declare-const ?ezy Real)
      (assert
        (or (or (= ?ezx ?ezw)
            (= ?ezx ?ezv)
            )
          (= ?ezw ?ezv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ezz Real)
      (declare-const ?faa Real)
      (declare-const ?fab Real)
      (declare-const ?fac Real)
      (declare-const ?fad Real)
      (assert
        (or (or (= ?fab ?faa)
            (= ?fab ?ezz)
            )
          (= ?faa ?ezz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fae Real)
      (declare-const ?faf Real)
      (declare-const ?fag Real)
      (declare-const ?fah Real)
      (declare-const ?fai Real)
      (declare-const ?faj Real)
      (assert
        (and (or (or (= ?fag ?faf)
              (= ?fag ?fae)
              )
            (= ?faf ?fae)
            )
          (and (and (not (= ?faj ?fai))
              (not (= ?faj ?fah))
              )
            (not (= ?fai ?fah))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fak Real)
      (declare-const ?fal Real)
      (declare-const ?fam Real)
      (assert
        (or (or (= ?fam ?fal)
            (= ?fam ?fak)
            )
          (= ?fal ?fak)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fan Real)
      (declare-const ?fao Real)
      (declare-const ?fap Real)
      (declare-const ?faq Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?fao ?fan))
                  (not (= ?fao ?asi))
                  )
                (not (= ?fan ?asi))
                )
              (or (or (= ?faq ?fap)
                  (= ?faq ?asi)
                  )
                (= ?fap ?asi)
                )
              )
            (and (or (or (= ?fao ?fan)
                  (= ?fao ?asi)
                  )
                (= ?fan ?asi)
                )
              (and (and (not (= ?faq ?fap))
                  (not (= ?faq ?asi))
                  )
                (not (= ?fap ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?eyv ?eyu))
                  (not (= ?eyv ?asi))
                  )
                (not (= ?eyu ?asi))
                )
              (or (or (= ?eyw ?eyu)
                  (= ?eyw ?asi)
                  )
                (= ?eyu ?asi)
                )
              )
            (and (or (or (= ?eyv ?eyu)
                  (= ?eyv ?asi)
                  )
                (= ?eyu ?asi)
                )
              (and (and (not (= ?eyw ?eyu))
                  (not (= ?eyw ?asi))
                  )
                (not (= ?eyu ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?far Real)
    (declare-const ?fas Real)
    (declare-const ?fat Real)
    (declare-const ?fau Real)
    (push 1)
      (declare-const ?fav Real)
      (declare-const ?faw Real)
      (declare-const ?fax Real)
      (assert
        (or (or (= ?fax ?faw)
            (= ?fax ?fav)
            )
          (= ?faw ?fav)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fay Real)
      (declare-const ?faz Real)
      (declare-const ?fba Real)
      (declare-const ?fbb Real)
      (assert
        (or (or (= ?fbb ?fba)
            (= ?fbb ?faz)
            )
          (= ?fba ?faz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fbc Real)
      (declare-const ?fbd Real)
      (declare-const ?fbe Real)
      (declare-const ?fbf Real)
      (declare-const ?fbg Real)
      (assert
        (or (or (= ?fbg ?fbf)
            (= ?fbg ?fbe)
            )
          (= ?fbf ?fbe)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fbh Real)
      (declare-const ?fbi Real)
      (declare-const ?fbj Real)
      (declare-const ?fbk Real)
      (declare-const ?fbl Real)
      (declare-const ?fbm Real)
      (assert
        (and (and (and (not (= ?fbj ?fbi))
              (not (= ?fbj ?fbh))
              )
            (not (= ?fbi ?fbh))
            )
          (or (or (= ?fbm ?fbl)
              (= ?fbm ?fbk)
              )
            (= ?fbl ?fbk)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fbn Real)
      (declare-const ?fbo Real)
      (declare-const ?fbp Real)
      (assert
        (or (or (= ?fbp ?fbo)
            (= ?fbp ?fbn)
            )
          (= ?fbo ?fbn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fbq Real)
      (declare-const ?fbr Real)
      (declare-const ?fbs Real)
      (assert
        (or (or (= ?fbs ?fbr)
            (= ?fbs ?fbq)
            )
          (= ?fbr ?fbq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fbt Real)
      (declare-const ?fbu Real)
      (declare-const ?fbv Real)
      (declare-const ?fbw Real)
      (assert
        (or (or (= ?fbv ?fbu)
            (= ?fbv ?fbt)
            )
          (= ?fbu ?fbt)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fbx Real)
      (declare-const ?fby Real)
      (declare-const ?fbz Real)
      (declare-const ?fca Real)
      (declare-const ?fcb Real)
      (assert
        (or (or (= ?fbz ?fby)
            (= ?fbz ?fbx)
            )
          (= ?fby ?fbx)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fcc Real)
      (declare-const ?fcd Real)
      (declare-const ?fce Real)
      (declare-const ?fcf Real)
      (declare-const ?fcg Real)
      (declare-const ?fch Real)
      (assert
        (and (or (or (= ?fce ?fcd)
              (= ?fce ?fcc)
              )
            (= ?fcd ?fcc)
            )
          (and (and (not (= ?fch ?fcg))
              (not (= ?fch ?fcf))
              )
            (not (= ?fcg ?fcf))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fci Real)
      (declare-const ?fcj Real)
      (declare-const ?fck Real)
      (assert
        (or (or (= ?fck ?fcj)
            (= ?fck ?fci)
            )
          (= ?fcj ?fci)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fcl Real)
      (declare-const ?fcm Real)
      (declare-const ?fcn Real)
      (declare-const ?fco Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?fcm ?fcl))
                  (not (= ?fcm ?asi))
                  )
                (not (= ?fcl ?asi))
                )
              (or (or (= ?fco ?fcn)
                  (= ?fco ?asi)
                  )
                (= ?fcn ?asi)
                )
              )
            (and (or (or (= ?fcm ?fcl)
                  (= ?fcm ?asi)
                  )
                (= ?fcl ?asi)
                )
              (and (and (not (= ?fco ?fcn))
                  (not (= ?fco ?asi))
                  )
                (not (= ?fcn ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?fcp Real)
    (declare-const ?fcq Real)
    (declare-const ?fcr Real)
    (declare-const ?fcs Real)
    (declare-const ?fct Real)
    (push 1)
      (declare-const ?fcu Real)
      (declare-const ?fcv Real)
      (declare-const ?fcw Real)
      (assert
        (or (or (= ?fcw ?fcv)
            (= ?fcw ?fcu)
            )
          (= ?fcv ?fcu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fcx Real)
      (declare-const ?fcy Real)
      (declare-const ?fcz Real)
      (declare-const ?fda Real)
      (assert
        (or (or (= ?fda ?fcz)
            (= ?fda ?fcy)
            )
          (= ?fcz ?fcy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fdb Real)
      (declare-const ?fdc Real)
      (declare-const ?fdd Real)
      (declare-const ?fde Real)
      (declare-const ?fdf Real)
      (assert
        (or (or (= ?fdf ?fde)
            (= ?fdf ?fdd)
            )
          (= ?fde ?fdd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fdg Real)
      (declare-const ?fdh Real)
      (declare-const ?fdi Real)
      (declare-const ?fdj Real)
      (declare-const ?fdk Real)
      (declare-const ?fdl Real)
      (assert
        (and (and (and (not (= ?fdi ?fdh))
              (not (= ?fdi ?fdg))
              )
            (not (= ?fdh ?fdg))
            )
          (or (or (= ?fdl ?fdk)
              (= ?fdl ?fdj)
              )
            (= ?fdk ?fdj)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fdm Real)
      (declare-const ?fdn Real)
      (declare-const ?fdo Real)
      (assert
        (or (or (= ?fdo ?fdn)
            (= ?fdo ?fdm)
            )
          (= ?fdn ?fdm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fdp Real)
      (declare-const ?fdq Real)
      (declare-const ?fdr Real)
      (assert
        (or (or (= ?fdr ?fdq)
            (= ?fdr ?fdp)
            )
          (= ?fdq ?fdp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fds Real)
      (declare-const ?fdt Real)
      (declare-const ?fdu Real)
      (declare-const ?fdv Real)
      (assert
        (or (or (= ?fdu ?fdt)
            (= ?fdu ?fds)
            )
          (= ?fdt ?fds)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fdw Real)
      (declare-const ?fdx Real)
      (declare-const ?fdy Real)
      (declare-const ?fdz Real)
      (declare-const ?fea Real)
      (assert
        (or (or (= ?fdy ?fdx)
            (= ?fdy ?fdw)
            )
          (= ?fdx ?fdw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?feb Real)
      (declare-const ?fec Real)
      (declare-const ?fed Real)
      (declare-const ?fee Real)
      (declare-const ?fef Real)
      (declare-const ?feg Real)
      (assert
        (and (or (or (= ?fed ?fec)
              (= ?fed ?feb)
              )
            (= ?fec ?feb)
            )
          (and (and (not (= ?feg ?fef))
              (not (= ?feg ?fee))
              )
            (not (= ?fef ?fee))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?feh Real)
      (declare-const ?fei Real)
      (declare-const ?fej Real)
      (assert
        (or (or (= ?fej ?fei)
            (= ?fej ?feh)
            )
          (= ?fei ?feh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fek Real)
      (declare-const ?fel Real)
      (declare-const ?fem Real)
      (declare-const ?fen Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?fel ?fek))
                  (not (= ?fel ?asi))
                  )
                (not (= ?fek ?asi))
                )
              (or (or (= ?fen ?fem)
                  (= ?fen ?asi)
                  )
                (= ?fem ?asi)
                )
              )
            (and (or (or (= ?fel ?fek)
                  (= ?fel ?asi)
                  )
                (= ?fek ?asi)
                )
              (and (and (not (= ?fen ?fem))
                  (not (= ?fen ?asi))
                  )
                (not (= ?fem ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?feo Real)
    (declare-const ?fep Real)
    (push 1)
      (declare-const ?feq Real)
      (declare-const ?fer Real)
      (declare-const ?fes Real)
      (assert
        (or (or (= ?fes ?fer)
            (= ?fes ?feq)
            )
          (= ?fer ?feq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fet Real)
      (declare-const ?feu Real)
      (declare-const ?fev Real)
      (declare-const ?few Real)
      (assert
        (or (or (= ?few ?fev)
            (= ?few ?feu)
            )
          (= ?fev ?feu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fex Real)
      (declare-const ?fey Real)
      (declare-const ?fez Real)
      (declare-const ?ffa Real)
      (declare-const ?ffb Real)
      (assert
        (or (or (= ?ffb ?ffa)
            (= ?ffb ?fez)
            )
          (= ?ffa ?fez)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ffc Real)
      (declare-const ?ffd Real)
      (declare-const ?ffe Real)
      (declare-const ?fff Real)
      (declare-const ?ffg Real)
      (declare-const ?ffh Real)
      (assert
        (and (and (and (not (= ?ffe ?ffd))
              (not (= ?ffe ?ffc))
              )
            (not (= ?ffd ?ffc))
            )
          (or (or (= ?ffh ?ffg)
              (= ?ffh ?fff)
              )
            (= ?ffg ?fff)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ffi Real)
      (declare-const ?ffj Real)
      (declare-const ?ffk Real)
      (assert
        (or (or (= ?ffk ?ffj)
            (= ?ffk ?ffi)
            )
          (= ?ffj ?ffi)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ffl Real)
      (declare-const ?ffm Real)
      (declare-const ?ffn Real)
      (assert
        (or (or (= ?ffn ?ffm)
            (= ?ffn ?ffl)
            )
          (= ?ffm ?ffl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ffo Real)
      (declare-const ?ffp Real)
      (declare-const ?ffq Real)
      (declare-const ?ffr Real)
      (assert
        (or (or (= ?ffq ?ffp)
            (= ?ffq ?ffo)
            )
          (= ?ffp ?ffo)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ffs Real)
      (declare-const ?fft Real)
      (declare-const ?ffu Real)
      (declare-const ?ffv Real)
      (declare-const ?ffw Real)
      (assert
        (or (or (= ?ffu ?fft)
            (= ?ffu ?ffs)
            )
          (= ?fft ?ffs)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ffx Real)
      (declare-const ?ffy Real)
      (declare-const ?ffz Real)
      (declare-const ?fga Real)
      (declare-const ?fgb Real)
      (declare-const ?fgc Real)
      (assert
        (and (or (or (= ?ffz ?ffy)
              (= ?ffz ?ffx)
              )
            (= ?ffy ?ffx)
            )
          (and (and (not (= ?fgc ?fgb))
              (not (= ?fgc ?fga))
              )
            (not (= ?fgb ?fga))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fgd Real)
      (declare-const ?fge Real)
      (declare-const ?fgf Real)
      (assert
        (or (or (= ?fgf ?fge)
            (= ?fgf ?fgd)
            )
          (= ?fge ?fgd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fgg Real)
      (declare-const ?fgh Real)
      (declare-const ?fgi Real)
      (declare-const ?fgj Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?fgh ?fgg))
                  (not (= ?fgh ?asi))
                  )
                (not (= ?fgg ?asi))
                )
              (or (or (= ?fgj ?fgi)
                  (= ?fgj ?asi)
                  )
                (= ?fgi ?asi)
                )
              )
            (and (or (or (= ?fgh ?fgg)
                  (= ?fgh ?asi)
                  )
                (= ?fgg ?asi)
                )
              (and (and (not (= ?fgj ?fgi))
                  (not (= ?fgj ?asi))
                  )
                (not (= ?fgi ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?fgk Real)
    (declare-const ?fgl Real)
    (declare-const ?fgm Real)
    (push 1)
      (declare-const ?fgn Real)
      (declare-const ?fgo Real)
      (declare-const ?fgp Real)
      (assert
        (or (or (= ?fgp ?fgo)
            (= ?fgp ?fgn)
            )
          (= ?fgo ?fgn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fgq Real)
      (declare-const ?fgr Real)
      (declare-const ?fgs Real)
      (declare-const ?fgt Real)
      (assert
        (or (or (= ?fgt ?fgs)
            (= ?fgt ?fgr)
            )
          (= ?fgs ?fgr)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fgu Real)
      (declare-const ?fgv Real)
      (declare-const ?fgw Real)
      (declare-const ?fgx Real)
      (declare-const ?fgy Real)
      (assert
        (or (or (= ?fgy ?fgx)
            (= ?fgy ?fgw)
            )
          (= ?fgx ?fgw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fgz Real)
      (declare-const ?fha Real)
      (declare-const ?fhb Real)
      (declare-const ?fhc Real)
      (declare-const ?fhd Real)
      (declare-const ?fhe Real)
      (assert
        (and (and (and (not (= ?fhb ?fha))
              (not (= ?fhb ?fgz))
              )
            (not (= ?fha ?fgz))
            )
          (or (or (= ?fhe ?fhd)
              (= ?fhe ?fhc)
              )
            (= ?fhd ?fhc)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fhf Real)
      (declare-const ?fhg Real)
      (declare-const ?fhh Real)
      (assert
        (or (or (= ?fhh ?fhg)
            (= ?fhh ?fhf)
            )
          (= ?fhg ?fhf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fhi Real)
      (declare-const ?fhj Real)
      (declare-const ?fhk Real)
      (assert
        (or (or (= ?fhk ?fhj)
            (= ?fhk ?fhi)
            )
          (= ?fhj ?fhi)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fhl Real)
      (declare-const ?fhm Real)
      (declare-const ?fhn Real)
      (declare-const ?fho Real)
      (assert
        (or (or (= ?fhn ?fhm)
            (= ?fhn ?fhl)
            )
          (= ?fhm ?fhl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fhp Real)
      (declare-const ?fhq Real)
      (declare-const ?fhr Real)
      (declare-const ?fhs Real)
      (declare-const ?fht Real)
      (assert
        (or (or (= ?fhr ?fhq)
            (= ?fhr ?fhp)
            )
          (= ?fhq ?fhp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fhu Real)
      (declare-const ?fhv Real)
      (declare-const ?fhw Real)
      (declare-const ?fhx Real)
      (declare-const ?fhy Real)
      (declare-const ?fhz Real)
      (assert
        (and (or (or (= ?fhw ?fhv)
              (= ?fhw ?fhu)
              )
            (= ?fhv ?fhu)
            )
          (and (and (not (= ?fhz ?fhy))
              (not (= ?fhz ?fhx))
              )
            (not (= ?fhy ?fhx))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fia Real)
      (declare-const ?fib Real)
      (declare-const ?fic Real)
      (assert
        (or (or (= ?fic ?fib)
            (= ?fic ?fia)
            )
          (= ?fib ?fia)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fid Real)
      (declare-const ?fie Real)
      (declare-const ?fif Real)
      (declare-const ?fig Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?fie ?fid))
                  (not (= ?fie ?asi))
                  )
                (not (= ?fid ?asi))
                )
              (or (or (= ?fig ?fif)
                  (= ?fig ?asi)
                  )
                (= ?fif ?asi)
                )
              )
            (and (or (or (= ?fie ?fid)
                  (= ?fie ?asi)
                  )
                (= ?fid ?asi)
                )
              (and (and (not (= ?fig ?fif))
                  (not (= ?fig ?asi))
                  )
                (not (= ?fif ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (= ?fgm ?fgl)
            (= ?fgm ?fgk)
            )
          (= ?fgl ?fgk)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?fih Real)
    (declare-const ?fii Real)
    (declare-const ?fij Real)
    (declare-const ?fik Real)
    (push 1)
      (declare-const ?fil Real)
      (declare-const ?fim Real)
      (declare-const ?fin Real)
      (assert
        (or (or (= ?fin ?fim)
            (= ?fin ?fil)
            )
          (= ?fim ?fil)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fio Real)
      (declare-const ?fip Real)
      (declare-const ?fiq Real)
      (declare-const ?fir Real)
      (assert
        (or (or (= ?fir ?fiq)
            (= ?fir ?fip)
            )
          (= ?fiq ?fip)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fis Real)
      (declare-const ?fit Real)
      (declare-const ?fiu Real)
      (declare-const ?fiv Real)
      (declare-const ?fiw Real)
      (assert
        (or (or (= ?fiw ?fiv)
            (= ?fiw ?fiu)
            )
          (= ?fiv ?fiu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fix Real)
      (declare-const ?fiy Real)
      (declare-const ?fiz Real)
      (declare-const ?fja Real)
      (declare-const ?fjb Real)
      (declare-const ?fjc Real)
      (assert
        (and (and (and (not (= ?fiz ?fiy))
              (not (= ?fiz ?fix))
              )
            (not (= ?fiy ?fix))
            )
          (or (or (= ?fjc ?fjb)
              (= ?fjc ?fja)
              )
            (= ?fjb ?fja)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fjd Real)
      (declare-const ?fje Real)
      (declare-const ?fjf Real)
      (assert
        (or (or (= ?fjf ?fje)
            (= ?fjf ?fjd)
            )
          (= ?fje ?fjd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fjg Real)
      (declare-const ?fjh Real)
      (declare-const ?fji Real)
      (assert
        (or (or (= ?fji ?fjh)
            (= ?fji ?fjg)
            )
          (= ?fjh ?fjg)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fjj Real)
      (declare-const ?fjk Real)
      (declare-const ?fjl Real)
      (declare-const ?fjm Real)
      (assert
        (or (or (= ?fjl ?fjk)
            (= ?fjl ?fjj)
            )
          (= ?fjk ?fjj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fjn Real)
      (declare-const ?fjo Real)
      (declare-const ?fjp Real)
      (declare-const ?fjq Real)
      (declare-const ?fjr Real)
      (assert
        (or (or (= ?fjp ?fjo)
            (= ?fjp ?fjn)
            )
          (= ?fjo ?fjn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fjs Real)
      (declare-const ?fjt Real)
      (declare-const ?fju Real)
      (declare-const ?fjv Real)
      (declare-const ?fjw Real)
      (declare-const ?fjx Real)
      (assert
        (and (or (or (= ?fju ?fjt)
              (= ?fju ?fjs)
              )
            (= ?fjt ?fjs)
            )
          (and (and (not (= ?fjx ?fjw))
              (not (= ?fjx ?fjv))
              )
            (not (= ?fjw ?fjv))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fjy Real)
      (declare-const ?fjz Real)
      (declare-const ?fka Real)
      (assert
        (or (or (= ?fka ?fjz)
            (= ?fka ?fjy)
            )
          (= ?fjz ?fjy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fkb Real)
      (declare-const ?fkc Real)
      (declare-const ?fkd Real)
      (declare-const ?fke Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?fkc ?fkb))
                  (not (= ?fkc ?asi))
                  )
                (not (= ?fkb ?asi))
                )
              (or (or (= ?fke ?fkd)
                  (= ?fke ?asi)
                  )
                (= ?fkd ?asi)
                )
              )
            (and (or (or (= ?fkc ?fkb)
                  (= ?fkc ?asi)
                  )
                (= ?fkb ?asi)
                )
              (and (and (not (= ?fke ?fkd))
                  (not (= ?fke ?asi))
                  )
                (not (= ?fkd ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?fkf Real)
    (declare-const ?fkg Real)
    (declare-const ?fkh Real)
    (declare-const ?fki Real)
    (declare-const ?fkj Real)
    (push 1)
      (declare-const ?fkk Real)
      (declare-const ?fkl Real)
      (declare-const ?fkm Real)
      (assert
        (or (or (= ?fkm ?fkl)
            (= ?fkm ?fkk)
            )
          (= ?fkl ?fkk)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fkn Real)
      (declare-const ?fko Real)
      (declare-const ?fkp Real)
      (declare-const ?fkq Real)
      (assert
        (or (or (= ?fkq ?fkp)
            (= ?fkq ?fko)
            )
          (= ?fkp ?fko)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fkr Real)
      (declare-const ?fks Real)
      (declare-const ?fkt Real)
      (declare-const ?fku Real)
      (declare-const ?fkv Real)
      (assert
        (or (or (= ?fkv ?fku)
            (= ?fkv ?fkt)
            )
          (= ?fku ?fkt)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fkw Real)
      (declare-const ?fkx Real)
      (declare-const ?fky Real)
      (declare-const ?fkz Real)
      (declare-const ?fla Real)
      (declare-const ?flb Real)
      (assert
        (and (and (and (not (= ?fky ?fkx))
              (not (= ?fky ?fkw))
              )
            (not (= ?fkx ?fkw))
            )
          (or (or (= ?flb ?fla)
              (= ?flb ?fkz)
              )
            (= ?fla ?fkz)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?flc Real)
      (declare-const ?fld Real)
      (declare-const ?fle Real)
      (assert
        (or (or (= ?fle ?fld)
            (= ?fle ?flc)
            )
          (= ?fld ?flc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?flf Real)
      (declare-const ?flg Real)
      (declare-const ?flh Real)
      (assert
        (or (or (= ?flh ?flg)
            (= ?flh ?flf)
            )
          (= ?flg ?flf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fli Real)
      (declare-const ?flj Real)
      (declare-const ?flk Real)
      (declare-const ?fll Real)
      (assert
        (or (or (= ?flk ?flj)
            (= ?flk ?fli)
            )
          (= ?flj ?fli)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?flm Real)
      (declare-const ?fln Real)
      (declare-const ?flo Real)
      (declare-const ?flp Real)
      (declare-const ?flq Real)
      (assert
        (or (or (= ?flo ?fln)
            (= ?flo ?flm)
            )
          (= ?fln ?flm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?flr Real)
      (declare-const ?fls Real)
      (declare-const ?flt Real)
      (declare-const ?flu Real)
      (declare-const ?flv Real)
      (declare-const ?flw Real)
      (assert
        (and (or (or (= ?flt ?fls)
              (= ?flt ?flr)
              )
            (= ?fls ?flr)
            )
          (and (and (not (= ?flw ?flv))
              (not (= ?flw ?flu))
              )
            (not (= ?flv ?flu))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?flx Real)
      (declare-const ?fly Real)
      (declare-const ?flz Real)
      (assert
        (or (or (= ?flz ?fly)
            (= ?flz ?flx)
            )
          (= ?fly ?flx)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fma Real)
      (declare-const ?fmb Real)
      (declare-const ?fmc Real)
      (declare-const ?fmd Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?fmb ?fma))
                  (not (= ?fmb ?asi))
                  )
                (not (= ?fma ?asi))
                )
              (or (or (= ?fmd ?fmc)
                  (= ?fmd ?asi)
                  )
                (= ?fmc ?asi)
                )
              )
            (and (or (or (= ?fmb ?fma)
                  (= ?fmb ?asi)
                  )
                (= ?fma ?asi)
                )
              (and (and (not (= ?fmd ?fmc))
                  (not (= ?fmd ?asi))
                  )
                (not (= ?fmc ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (and (and (and (not (= ?fkh ?fkg))
                (not (= ?fkh ?fkf))
                )
              (not (= ?fkg ?fkf))
              )
            (or (or (= ?fkj ?fki)
                (= ?fkj ?fkf)
                )
              (= ?fki ?fkf)
              )
            )
          (and (or (or (= ?fkh ?fkg)
                (= ?fkh ?fkf)
                )
              (= ?fkg ?fkf)
              )
            (and (and (not (= ?fkj ?fki))
                (not (= ?fkj ?fkf))
                )
              (not (= ?fki ?fkf))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?fme Real)
    (declare-const ?fmf Real)
    (declare-const ?fmg Real)
    (declare-const ?fmh Real)
    (declare-const ?fmi Real)
    (declare-const ?fmj Real)
    (push 1)
      (declare-const ?fmk Real)
      (declare-const ?fml Real)
      (declare-const ?fmm Real)
      (assert
        (or (or (= ?fmm ?fml)
            (= ?fmm ?fmk)
            )
          (= ?fml ?fmk)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fmn Real)
      (declare-const ?fmo Real)
      (declare-const ?fmp Real)
      (declare-const ?fmq Real)
      (assert
        (or (or (= ?fmq ?fmp)
            (= ?fmq ?fmo)
            )
          (= ?fmp ?fmo)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fmr Real)
      (declare-const ?fms Real)
      (declare-const ?fmt Real)
      (declare-const ?fmu Real)
      (declare-const ?fmv Real)
      (assert
        (or (or (= ?fmv ?fmu)
            (= ?fmv ?fmt)
            )
          (= ?fmu ?fmt)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fmw Real)
      (declare-const ?fmx Real)
      (declare-const ?fmy Real)
      (declare-const ?fmz Real)
      (declare-const ?fna Real)
      (declare-const ?fnb Real)
      (assert
        (and (and (and (not (= ?fmy ?fmx))
              (not (= ?fmy ?fmw))
              )
            (not (= ?fmx ?fmw))
            )
          (or (or (= ?fnb ?fna)
              (= ?fnb ?fmz)
              )
            (= ?fna ?fmz)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fnc Real)
      (declare-const ?fnd Real)
      (declare-const ?fne Real)
      (assert
        (or (or (= ?fne ?fnd)
            (= ?fne ?fnc)
            )
          (= ?fnd ?fnc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fnf Real)
      (declare-const ?fng Real)
      (declare-const ?fnh Real)
      (assert
        (or (or (= ?fnh ?fng)
            (= ?fnh ?fnf)
            )
          (= ?fng ?fnf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fni Real)
      (declare-const ?fnj Real)
      (declare-const ?fnk Real)
      (declare-const ?fnl Real)
      (assert
        (or (or (= ?fnk ?fnj)
            (= ?fnk ?fni)
            )
          (= ?fnj ?fni)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fnm Real)
      (declare-const ?fnn Real)
      (declare-const ?fno Real)
      (declare-const ?fnp Real)
      (declare-const ?fnq Real)
      (assert
        (or (or (= ?fno ?fnn)
            (= ?fno ?fnm)
            )
          (= ?fnn ?fnm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fnr Real)
      (declare-const ?fns Real)
      (declare-const ?fnt Real)
      (declare-const ?fnu Real)
      (declare-const ?fnv Real)
      (declare-const ?fnw Real)
      (assert
        (and (or (or (= ?fnt ?fns)
              (= ?fnt ?fnr)
              )
            (= ?fns ?fnr)
            )
          (and (and (not (= ?fnw ?fnv))
              (not (= ?fnw ?fnu))
              )
            (not (= ?fnv ?fnu))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fnx Real)
      (declare-const ?fny Real)
      (declare-const ?fnz Real)
      (assert
        (or (or (= ?fnz ?fny)
            (= ?fnz ?fnx)
            )
          (= ?fny ?fnx)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?foa Real)
      (declare-const ?fob Real)
      (declare-const ?foc Real)
      (declare-const ?fod Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?fob ?foa))
                  (not (= ?fob ?asi))
                  )
                (not (= ?foa ?asi))
                )
              (or (or (= ?fod ?foc)
                  (= ?fod ?asi)
                  )
                (= ?foc ?asi)
                )
              )
            (and (or (or (= ?fob ?foa)
                  (= ?fob ?asi)
                  )
                (= ?foa ?asi)
                )
              (and (and (not (= ?fod ?foc))
                  (not (= ?fod ?asi))
                  )
                (not (= ?foc ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?foe Real)
      (declare-const ?fof Real)
      (declare-const ?fog Real)
      (declare-const ?foh Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?fof ?foe))
                  (not (= ?fof ?fkf))
                  )
                (not (= ?foe ?fkf))
                )
              (or (or (= ?foh ?fog)
                  (= ?foh ?fkf)
                  )
                (= ?fog ?fkf)
                )
              )
            (and (or (or (= ?fof ?foe)
                  (= ?fof ?fkf)
                  )
                (= ?foe ?fkf)
                )
              (and (and (not (= ?foh ?fog))
                  (not (= ?foh ?fkf))
                  )
                (not (= ?fog ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (= ?fmj ?fmi)
            (= ?fmj ?fme)
            )
          (= ?fmi ?fme)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?foi Real)
    (declare-const ?foj Real)
    (declare-const ?fok Real)
    (push 1)
      (declare-const ?fol Real)
      (declare-const ?fom Real)
      (declare-const ?fon Real)
      (assert
        (or (or (= ?fon ?fom)
            (= ?fon ?fol)
            )
          (= ?fom ?fol)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?foo Real)
      (declare-const ?fop Real)
      (declare-const ?foq Real)
      (declare-const ?for Real)
      (assert
        (or (or (= ?for ?foq)
            (= ?for ?fop)
            )
          (= ?foq ?fop)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fos Real)
      (declare-const ?fot Real)
      (declare-const ?fou Real)
      (declare-const ?fov Real)
      (declare-const ?fow Real)
      (assert
        (or (or (= ?fow ?fov)
            (= ?fow ?fou)
            )
          (= ?fov ?fou)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fox Real)
      (declare-const ?foy Real)
      (declare-const ?foz Real)
      (declare-const ?fpa Real)
      (declare-const ?fpb Real)
      (declare-const ?fpc Real)
      (assert
        (and (and (and (not (= ?foz ?foy))
              (not (= ?foz ?fox))
              )
            (not (= ?foy ?fox))
            )
          (or (or (= ?fpc ?fpb)
              (= ?fpc ?fpa)
              )
            (= ?fpb ?fpa)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fpd Real)
      (declare-const ?fpe Real)
      (declare-const ?fpf Real)
      (assert
        (or (or (= ?fpf ?fpe)
            (= ?fpf ?fpd)
            )
          (= ?fpe ?fpd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fpg Real)
      (declare-const ?fph Real)
      (declare-const ?fpi Real)
      (assert
        (or (or (= ?fpi ?fph)
            (= ?fpi ?fpg)
            )
          (= ?fph ?fpg)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fpj Real)
      (declare-const ?fpk Real)
      (declare-const ?fpl Real)
      (declare-const ?fpm Real)
      (assert
        (or (or (= ?fpl ?fpk)
            (= ?fpl ?fpj)
            )
          (= ?fpk ?fpj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fpn Real)
      (declare-const ?fpo Real)
      (declare-const ?fpp Real)
      (declare-const ?fpq Real)
      (declare-const ?fpr Real)
      (assert
        (or (or (= ?fpp ?fpo)
            (= ?fpp ?fpn)
            )
          (= ?fpo ?fpn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fps Real)
      (declare-const ?fpt Real)
      (declare-const ?fpu Real)
      (declare-const ?fpv Real)
      (declare-const ?fpw Real)
      (declare-const ?fpx Real)
      (assert
        (and (or (or (= ?fpu ?fpt)
              (= ?fpu ?fps)
              )
            (= ?fpt ?fps)
            )
          (and (and (not (= ?fpx ?fpw))
              (not (= ?fpx ?fpv))
              )
            (not (= ?fpw ?fpv))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fpy Real)
      (declare-const ?fpz Real)
      (declare-const ?fqa Real)
      (assert
        (or (or (= ?fqa ?fpz)
            (= ?fqa ?fpy)
            )
          (= ?fpz ?fpy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fqb Real)
      (declare-const ?fqc Real)
      (declare-const ?fqd Real)
      (declare-const ?fqe Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?fqc ?fqb))
                  (not (= ?fqc ?asi))
                  )
                (not (= ?fqb ?asi))
                )
              (or (or (= ?fqe ?fqd)
                  (= ?fqe ?asi)
                  )
                (= ?fqd ?asi)
                )
              )
            (and (or (or (= ?fqc ?fqb)
                  (= ?fqc ?asi)
                  )
                (= ?fqb ?asi)
                )
              (and (and (not (= ?fqe ?fqd))
                  (not (= ?fqe ?asi))
                  )
                (not (= ?fqd ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fqf Real)
      (declare-const ?fqg Real)
      (declare-const ?fqh Real)
      (declare-const ?fqi Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?fqg ?fqf))
                  (not (= ?fqg ?fkf))
                  )
                (not (= ?fqf ?fkf))
                )
              (or (or (= ?fqi ?fqh)
                  (= ?fqi ?fkf)
                  )
                (= ?fqh ?fkf)
                )
              )
            (and (or (or (= ?fqg ?fqf)
                  (= ?fqg ?fkf)
                  )
                (= ?fqf ?fkf)
                )
              (and (and (not (= ?fqi ?fqh))
                  (not (= ?fqi ?fkf))
                  )
                (not (= ?fqh ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (= ?fok ?foj)
            (= ?fok ?foi)
            )
          (= ?foj ?foi)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?fqj Real)
    (declare-const ?fqk Real)
    (declare-const ?fql Real)
    (declare-const ?fqm Real)
    (push 1)
      (declare-const ?fqn Real)
      (declare-const ?fqo Real)
      (declare-const ?fqp Real)
      (assert
        (or (or (= ?fqp ?fqo)
            (= ?fqp ?fqn)
            )
          (= ?fqo ?fqn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fqq Real)
      (declare-const ?fqr Real)
      (declare-const ?fqs Real)
      (declare-const ?fqt Real)
      (assert
        (or (or (= ?fqt ?fqs)
            (= ?fqt ?fqr)
            )
          (= ?fqs ?fqr)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fqu Real)
      (declare-const ?fqv Real)
      (declare-const ?fqw Real)
      (declare-const ?fqx Real)
      (declare-const ?fqy Real)
      (assert
        (or (or (= ?fqy ?fqx)
            (= ?fqy ?fqw)
            )
          (= ?fqx ?fqw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fqz Real)
      (declare-const ?fra Real)
      (declare-const ?frb Real)
      (declare-const ?frc Real)
      (declare-const ?frd Real)
      (declare-const ?fre Real)
      (assert
        (and (and (and (not (= ?frb ?fra))
              (not (= ?frb ?fqz))
              )
            (not (= ?fra ?fqz))
            )
          (or (or (= ?fre ?frd)
              (= ?fre ?frc)
              )
            (= ?frd ?frc)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?frf Real)
      (declare-const ?frg Real)
      (declare-const ?frh Real)
      (assert
        (or (or (= ?frh ?frg)
            (= ?frh ?frf)
            )
          (= ?frg ?frf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fri Real)
      (declare-const ?frj Real)
      (declare-const ?frk Real)
      (assert
        (or (or (= ?frk ?frj)
            (= ?frk ?fri)
            )
          (= ?frj ?fri)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?frl Real)
      (declare-const ?frm Real)
      (declare-const ?frn Real)
      (declare-const ?fro Real)
      (assert
        (or (or (= ?frn ?frm)
            (= ?frn ?frl)
            )
          (= ?frm ?frl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?frp Real)
      (declare-const ?frq Real)
      (declare-const ?frr Real)
      (declare-const ?frs Real)
      (declare-const ?frt Real)
      (assert
        (or (or (= ?frr ?frq)
            (= ?frr ?frp)
            )
          (= ?frq ?frp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fru Real)
      (declare-const ?frv Real)
      (declare-const ?frw Real)
      (declare-const ?frx Real)
      (declare-const ?fry Real)
      (declare-const ?frz Real)
      (assert
        (and (or (or (= ?frw ?frv)
              (= ?frw ?fru)
              )
            (= ?frv ?fru)
            )
          (and (and (not (= ?frz ?fry))
              (not (= ?frz ?frx))
              )
            (not (= ?fry ?frx))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fsa Real)
      (declare-const ?fsb Real)
      (declare-const ?fsc Real)
      (assert
        (or (or (= ?fsc ?fsb)
            (= ?fsc ?fsa)
            )
          (= ?fsb ?fsa)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fsd Real)
      (declare-const ?fse Real)
      (declare-const ?fsf Real)
      (declare-const ?fsg Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?fse ?fsd))
                  (not (= ?fse ?asi))
                  )
                (not (= ?fsd ?asi))
                )
              (or (or (= ?fsg ?fsf)
                  (= ?fsg ?asi)
                  )
                (= ?fsf ?asi)
                )
              )
            (and (or (or (= ?fse ?fsd)
                  (= ?fse ?asi)
                  )
                (= ?fsd ?asi)
                )
              (and (and (not (= ?fsg ?fsf))
                  (not (= ?fsg ?asi))
                  )
                (not (= ?fsf ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fsh Real)
      (declare-const ?fsi Real)
      (declare-const ?fsj Real)
      (declare-const ?fsk Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?fsi ?fsh))
                  (not (= ?fsi ?fkf))
                  )
                (not (= ?fsh ?fkf))
                )
              (or (or (= ?fsk ?fsj)
                  (= ?fsk ?fkf)
                  )
                (= ?fsj ?fkf)
                )
              )
            (and (or (or (= ?fsi ?fsh)
                  (= ?fsi ?fkf)
                  )
                (= ?fsh ?fkf)
                )
              (and (and (not (= ?fsk ?fsj))
                  (not (= ?fsk ?fkf))
                  )
                (not (= ?fsj ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?fsl Real)
    (declare-const ?fsm Real)
    (declare-const ?fsn Real)
    (declare-const ?fso Real)
    (declare-const ?fsp Real)
    (push 1)
      (declare-const ?fsq Real)
      (declare-const ?fsr Real)
      (declare-const ?fss Real)
      (assert
        (or (or (= ?fss ?fsr)
            (= ?fss ?fsq)
            )
          (= ?fsr ?fsq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fst Real)
      (declare-const ?fsu Real)
      (declare-const ?fsv Real)
      (declare-const ?fsw Real)
      (assert
        (or (or (= ?fsw ?fsv)
            (= ?fsw ?fsu)
            )
          (= ?fsv ?fsu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fsx Real)
      (declare-const ?fsy Real)
      (declare-const ?fsz Real)
      (declare-const ?fta Real)
      (declare-const ?ftb Real)
      (assert
        (or (or (= ?ftb ?fta)
            (= ?ftb ?fsz)
            )
          (= ?fta ?fsz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ftc Real)
      (declare-const ?ftd Real)
      (declare-const ?fte Real)
      (declare-const ?ftf Real)
      (declare-const ?ftg Real)
      (declare-const ?fth Real)
      (assert
        (and (and (and (not (= ?fte ?ftd))
              (not (= ?fte ?ftc))
              )
            (not (= ?ftd ?ftc))
            )
          (or (or (= ?fth ?ftg)
              (= ?fth ?ftf)
              )
            (= ?ftg ?ftf)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fti Real)
      (declare-const ?ftj Real)
      (declare-const ?ftk Real)
      (assert
        (or (or (= ?ftk ?ftj)
            (= ?ftk ?fti)
            )
          (= ?ftj ?fti)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ftl Real)
      (declare-const ?ftm Real)
      (declare-const ?ftn Real)
      (assert
        (or (or (= ?ftn ?ftm)
            (= ?ftn ?ftl)
            )
          (= ?ftm ?ftl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fto Real)
      (declare-const ?ftp Real)
      (declare-const ?ftq Real)
      (declare-const ?ftr Real)
      (assert
        (or (or (= ?ftq ?ftp)
            (= ?ftq ?fto)
            )
          (= ?ftp ?fto)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fts Real)
      (declare-const ?ftt Real)
      (declare-const ?ftu Real)
      (declare-const ?ftv Real)
      (declare-const ?ftw Real)
      (assert
        (or (or (= ?ftu ?ftt)
            (= ?ftu ?fts)
            )
          (= ?ftt ?fts)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ftx Real)
      (declare-const ?fty Real)
      (declare-const ?ftz Real)
      (declare-const ?fua Real)
      (declare-const ?fub Real)
      (declare-const ?fuc Real)
      (assert
        (and (or (or (= ?ftz ?fty)
              (= ?ftz ?ftx)
              )
            (= ?fty ?ftx)
            )
          (and (and (not (= ?fuc ?fub))
              (not (= ?fuc ?fua))
              )
            (not (= ?fub ?fua))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fud Real)
      (declare-const ?fue Real)
      (declare-const ?fuf Real)
      (assert
        (or (or (= ?fuf ?fue)
            (= ?fuf ?fud)
            )
          (= ?fue ?fud)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fug Real)
      (declare-const ?fuh Real)
      (declare-const ?fui Real)
      (declare-const ?fuj Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?fuh ?fug))
                  (not (= ?fuh ?asi))
                  )
                (not (= ?fug ?asi))
                )
              (or (or (= ?fuj ?fui)
                  (= ?fuj ?asi)
                  )
                (= ?fui ?asi)
                )
              )
            (and (or (or (= ?fuh ?fug)
                  (= ?fuh ?asi)
                  )
                (= ?fug ?asi)
                )
              (and (and (not (= ?fuj ?fui))
                  (not (= ?fuj ?asi))
                  )
                (not (= ?fui ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fuk Real)
      (declare-const ?ful Real)
      (declare-const ?fum Real)
      (declare-const ?fun Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?ful ?fuk))
                  (not (= ?ful ?fkf))
                  )
                (not (= ?fuk ?fkf))
                )
              (or (or (= ?fun ?fum)
                  (= ?fun ?fkf)
                  )
                (= ?fum ?fkf)
                )
              )
            (and (or (or (= ?ful ?fuk)
                  (= ?ful ?fkf)
                  )
                (= ?fuk ?fkf)
                )
              (and (and (not (= ?fun ?fum))
                  (not (= ?fun ?fkf))
                  )
                (not (= ?fum ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?fuo Real)
    (declare-const ?fup Real)
    (declare-const ?fuq Real)
    (declare-const ?fur Real)
    (declare-const ?fus Real)
    (declare-const ?fut Real)
    (push 1)
      (declare-const ?fuu Real)
      (declare-const ?fuv Real)
      (declare-const ?fuw Real)
      (assert
        (or (or (= ?fuw ?fuv)
            (= ?fuw ?fuu)
            )
          (= ?fuv ?fuu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fux Real)
      (declare-const ?fuy Real)
      (declare-const ?fuz Real)
      (declare-const ?fva Real)
      (assert
        (or (or (= ?fva ?fuz)
            (= ?fva ?fuy)
            )
          (= ?fuz ?fuy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fvb Real)
      (declare-const ?fvc Real)
      (declare-const ?fvd Real)
      (declare-const ?fve Real)
      (declare-const ?fvf Real)
      (assert
        (or (or (= ?fvf ?fve)
            (= ?fvf ?fvd)
            )
          (= ?fve ?fvd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fvg Real)
      (declare-const ?fvh Real)
      (declare-const ?fvi Real)
      (declare-const ?fvj Real)
      (declare-const ?fvk Real)
      (declare-const ?fvl Real)
      (assert
        (and (and (and (not (= ?fvi ?fvh))
              (not (= ?fvi ?fvg))
              )
            (not (= ?fvh ?fvg))
            )
          (or (or (= ?fvl ?fvk)
              (= ?fvl ?fvj)
              )
            (= ?fvk ?fvj)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fvm Real)
      (declare-const ?fvn Real)
      (declare-const ?fvo Real)
      (assert
        (or (or (= ?fvo ?fvn)
            (= ?fvo ?fvm)
            )
          (= ?fvn ?fvm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fvp Real)
      (declare-const ?fvq Real)
      (declare-const ?fvr Real)
      (assert
        (or (or (= ?fvr ?fvq)
            (= ?fvr ?fvp)
            )
          (= ?fvq ?fvp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fvs Real)
      (declare-const ?fvt Real)
      (declare-const ?fvu Real)
      (declare-const ?fvv Real)
      (assert
        (or (or (= ?fvu ?fvt)
            (= ?fvu ?fvs)
            )
          (= ?fvt ?fvs)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fvw Real)
      (declare-const ?fvx Real)
      (declare-const ?fvy Real)
      (declare-const ?fvz Real)
      (declare-const ?fwa Real)
      (assert
        (or (or (= ?fvy ?fvx)
            (= ?fvy ?fvw)
            )
          (= ?fvx ?fvw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fwb Real)
      (declare-const ?fwc Real)
      (declare-const ?fwd Real)
      (declare-const ?fwe Real)
      (declare-const ?fwf Real)
      (declare-const ?fwg Real)
      (assert
        (and (or (or (= ?fwd ?fwc)
              (= ?fwd ?fwb)
              )
            (= ?fwc ?fwb)
            )
          (and (and (not (= ?fwg ?fwf))
              (not (= ?fwg ?fwe))
              )
            (not (= ?fwf ?fwe))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fwh Real)
      (declare-const ?fwi Real)
      (declare-const ?fwj Real)
      (assert
        (or (or (= ?fwj ?fwi)
            (= ?fwj ?fwh)
            )
          (= ?fwi ?fwh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fwk Real)
      (declare-const ?fwl Real)
      (declare-const ?fwm Real)
      (declare-const ?fwn Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?fwl ?fwk))
                  (not (= ?fwl ?asi))
                  )
                (not (= ?fwk ?asi))
                )
              (or (or (= ?fwn ?fwm)
                  (= ?fwn ?asi)
                  )
                (= ?fwm ?asi)
                )
              )
            (and (or (or (= ?fwl ?fwk)
                  (= ?fwl ?asi)
                  )
                (= ?fwk ?asi)
                )
              (and (and (not (= ?fwn ?fwm))
                  (not (= ?fwn ?asi))
                  )
                (not (= ?fwm ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fwo Real)
      (declare-const ?fwp Real)
      (declare-const ?fwq Real)
      (declare-const ?fwr Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?fwp ?fwo))
                  (not (= ?fwp ?fkf))
                  )
                (not (= ?fwo ?fkf))
                )
              (or (or (= ?fwr ?fwq)
                  (= ?fwr ?fkf)
                  )
                (= ?fwq ?fkf)
                )
              )
            (and (or (or (= ?fwp ?fwo)
                  (= ?fwp ?fkf)
                  )
                (= ?fwo ?fkf)
                )
              (and (and (not (= ?fwr ?fwq))
                  (not (= ?fwr ?fkf))
                  )
                (not (= ?fwq ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (= ?fuq ?fup)
            (= ?fuq ?fuo)
            )
          (= ?fup ?fuo)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?fws Real)
    (declare-const ?fwt Real)
    (declare-const ?fwu Real)
    (declare-const ?fwv Real)
    (declare-const ?fww Real)
    (declare-const ?fwx Real)
    (push 1)
      (declare-const ?fwy Real)
      (declare-const ?fwz Real)
      (declare-const ?fxa Real)
      (assert
        (or (or (= ?fxa ?fwz)
            (= ?fxa ?fwy)
            )
          (= ?fwz ?fwy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fxb Real)
      (declare-const ?fxc Real)
      (declare-const ?fxd Real)
      (declare-const ?fxe Real)
      (assert
        (or (or (= ?fxe ?fxd)
            (= ?fxe ?fxc)
            )
          (= ?fxd ?fxc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fxf Real)
      (declare-const ?fxg Real)
      (declare-const ?fxh Real)
      (declare-const ?fxi Real)
      (declare-const ?fxj Real)
      (assert
        (or (or (= ?fxj ?fxi)
            (= ?fxj ?fxh)
            )
          (= ?fxi ?fxh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fxk Real)
      (declare-const ?fxl Real)
      (declare-const ?fxm Real)
      (declare-const ?fxn Real)
      (declare-const ?fxo Real)
      (declare-const ?fxp Real)
      (assert
        (and (and (and (not (= ?fxm ?fxl))
              (not (= ?fxm ?fxk))
              )
            (not (= ?fxl ?fxk))
            )
          (or (or (= ?fxp ?fxo)
              (= ?fxp ?fxn)
              )
            (= ?fxo ?fxn)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fxq Real)
      (declare-const ?fxr Real)
      (declare-const ?fxs Real)
      (assert
        (or (or (= ?fxs ?fxr)
            (= ?fxs ?fxq)
            )
          (= ?fxr ?fxq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fxt Real)
      (declare-const ?fxu Real)
      (declare-const ?fxv Real)
      (assert
        (or (or (= ?fxv ?fxu)
            (= ?fxv ?fxt)
            )
          (= ?fxu ?fxt)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fxw Real)
      (declare-const ?fxx Real)
      (declare-const ?fxy Real)
      (declare-const ?fxz Real)
      (assert
        (or (or (= ?fxy ?fxx)
            (= ?fxy ?fxw)
            )
          (= ?fxx ?fxw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fya Real)
      (declare-const ?fyb Real)
      (declare-const ?fyc Real)
      (declare-const ?fyd Real)
      (declare-const ?fye Real)
      (assert
        (or (or (= ?fyc ?fyb)
            (= ?fyc ?fya)
            )
          (= ?fyb ?fya)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fyf Real)
      (declare-const ?fyg Real)
      (declare-const ?fyh Real)
      (declare-const ?fyi Real)
      (declare-const ?fyj Real)
      (declare-const ?fyk Real)
      (assert
        (and (or (or (= ?fyh ?fyg)
              (= ?fyh ?fyf)
              )
            (= ?fyg ?fyf)
            )
          (and (and (not (= ?fyk ?fyj))
              (not (= ?fyk ?fyi))
              )
            (not (= ?fyj ?fyi))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fyl Real)
      (declare-const ?fym Real)
      (declare-const ?fyn Real)
      (assert
        (or (or (= ?fyn ?fym)
            (= ?fyn ?fyl)
            )
          (= ?fym ?fyl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fyo Real)
      (declare-const ?fyp Real)
      (declare-const ?fyq Real)
      (declare-const ?fyr Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?fyp ?fyo))
                  (not (= ?fyp ?asi))
                  )
                (not (= ?fyo ?asi))
                )
              (or (or (= ?fyr ?fyq)
                  (= ?fyr ?asi)
                  )
                (= ?fyq ?asi)
                )
              )
            (and (or (or (= ?fyp ?fyo)
                  (= ?fyp ?asi)
                  )
                (= ?fyo ?asi)
                )
              (and (and (not (= ?fyr ?fyq))
                  (not (= ?fyr ?asi))
                  )
                (not (= ?fyq ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fys Real)
      (declare-const ?fyt Real)
      (declare-const ?fyu Real)
      (declare-const ?fyv Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?fyt ?fys))
                  (not (= ?fyt ?fkf))
                  )
                (not (= ?fys ?fkf))
                )
              (or (or (= ?fyv ?fyu)
                  (= ?fyv ?fkf)
                  )
                (= ?fyu ?fkf)
                )
              )
            (and (or (or (= ?fyt ?fys)
                  (= ?fyt ?fkf)
                  )
                (= ?fys ?fkf)
                )
              (and (and (not (= ?fyv ?fyu))
                  (not (= ?fyv ?fkf))
                  )
                (not (= ?fyu ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?fyw Real)
    (declare-const ?fyx Real)
    (declare-const ?fyy Real)
    (push 1)
      (declare-const ?fyz Real)
      (declare-const ?fza Real)
      (declare-const ?fzb Real)
      (assert
        (or (or (= ?fzb ?fza)
            (= ?fzb ?fyz)
            )
          (= ?fza ?fyz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fzc Real)
      (declare-const ?fzd Real)
      (declare-const ?fze Real)
      (declare-const ?fzf Real)
      (assert
        (or (or (= ?fzf ?fze)
            (= ?fzf ?fzd)
            )
          (= ?fze ?fzd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fzg Real)
      (declare-const ?fzh Real)
      (declare-const ?fzi Real)
      (declare-const ?fzj Real)
      (declare-const ?fzk Real)
      (assert
        (or (or (= ?fzk ?fzj)
            (= ?fzk ?fzi)
            )
          (= ?fzj ?fzi)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fzl Real)
      (declare-const ?fzm Real)
      (declare-const ?fzn Real)
      (declare-const ?fzo Real)
      (declare-const ?fzp Real)
      (declare-const ?fzq Real)
      (assert
        (and (and (and (not (= ?fzn ?fzm))
              (not (= ?fzn ?fzl))
              )
            (not (= ?fzm ?fzl))
            )
          (or (or (= ?fzq ?fzp)
              (= ?fzq ?fzo)
              )
            (= ?fzp ?fzo)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fzr Real)
      (declare-const ?fzs Real)
      (declare-const ?fzt Real)
      (assert
        (or (or (= ?fzt ?fzs)
            (= ?fzt ?fzr)
            )
          (= ?fzs ?fzr)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fzu Real)
      (declare-const ?fzv Real)
      (declare-const ?fzw Real)
      (assert
        (or (or (= ?fzw ?fzv)
            (= ?fzw ?fzu)
            )
          (= ?fzv ?fzu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?fzx Real)
      (declare-const ?fzy Real)
      (declare-const ?fzz Real)
      (declare-const ?gaa Real)
      (assert
        (or (or (= ?fzz ?fzy)
            (= ?fzz ?fzx)
            )
          (= ?fzy ?fzx)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gab Real)
      (declare-const ?gac Real)
      (declare-const ?gad Real)
      (declare-const ?gae Real)
      (declare-const ?gaf Real)
      (assert
        (or (or (= ?gad ?gac)
            (= ?gad ?gab)
            )
          (= ?gac ?gab)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gag Real)
      (declare-const ?gah Real)
      (declare-const ?gai Real)
      (declare-const ?gaj Real)
      (declare-const ?gak Real)
      (declare-const ?gal Real)
      (assert
        (and (or (or (= ?gai ?gah)
              (= ?gai ?gag)
              )
            (= ?gah ?gag)
            )
          (and (and (not (= ?gal ?gak))
              (not (= ?gal ?gaj))
              )
            (not (= ?gak ?gaj))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gam Real)
      (declare-const ?gan Real)
      (declare-const ?gao Real)
      (assert
        (or (or (= ?gao ?gan)
            (= ?gao ?gam)
            )
          (= ?gan ?gam)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gap Real)
      (declare-const ?gaq Real)
      (declare-const ?gar Real)
      (declare-const ?gas Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?gaq ?gap))
                  (not (= ?gaq ?asi))
                  )
                (not (= ?gap ?asi))
                )
              (or (or (= ?gas ?gar)
                  (= ?gas ?asi)
                  )
                (= ?gar ?asi)
                )
              )
            (and (or (or (= ?gaq ?gap)
                  (= ?gaq ?asi)
                  )
                (= ?gap ?asi)
                )
              (and (and (not (= ?gas ?gar))
                  (not (= ?gas ?asi))
                  )
                (not (= ?gar ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gat Real)
      (declare-const ?gau Real)
      (declare-const ?gav Real)
      (declare-const ?gaw Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?gau ?gat))
                  (not (= ?gau ?fkf))
                  )
                (not (= ?gat ?fkf))
                )
              (or (or (= ?gaw ?gav)
                  (= ?gaw ?fkf)
                  )
                (= ?gav ?fkf)
                )
              )
            (and (or (or (= ?gau ?gat)
                  (= ?gau ?fkf)
                  )
                (= ?gat ?fkf)
                )
              (and (and (not (= ?gaw ?gav))
                  (not (= ?gaw ?fkf))
                  )
                (not (= ?gav ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?gax Real)
    (push 1)
      (declare-const ?gay Real)
      (declare-const ?gaz Real)
      (declare-const ?gba Real)
      (assert
        (or (or (= ?gba ?gaz)
            (= ?gba ?gay)
            )
          (= ?gaz ?gay)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gbb Real)
      (declare-const ?gbc Real)
      (declare-const ?gbd Real)
      (declare-const ?gbe Real)
      (assert
        (or (or (= ?gbe ?gbd)
            (= ?gbe ?gbc)
            )
          (= ?gbd ?gbc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gbf Real)
      (declare-const ?gbg Real)
      (declare-const ?gbh Real)
      (declare-const ?gbi Real)
      (declare-const ?gbj Real)
      (assert
        (or (or (= ?gbj ?gbi)
            (= ?gbj ?gbh)
            )
          (= ?gbi ?gbh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gbk Real)
      (declare-const ?gbl Real)
      (declare-const ?gbm Real)
      (declare-const ?gbn Real)
      (declare-const ?gbo Real)
      (declare-const ?gbp Real)
      (assert
        (and (and (and (not (= ?gbm ?gbl))
              (not (= ?gbm ?gbk))
              )
            (not (= ?gbl ?gbk))
            )
          (or (or (= ?gbp ?gbo)
              (= ?gbp ?gbn)
              )
            (= ?gbo ?gbn)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gbq Real)
      (declare-const ?gbr Real)
      (declare-const ?gbs Real)
      (assert
        (or (or (= ?gbs ?gbr)
            (= ?gbs ?gbq)
            )
          (= ?gbr ?gbq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gbt Real)
      (declare-const ?gbu Real)
      (declare-const ?gbv Real)
      (assert
        (or (or (= ?gbv ?gbu)
            (= ?gbv ?gbt)
            )
          (= ?gbu ?gbt)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gbw Real)
      (declare-const ?gbx Real)
      (declare-const ?gby Real)
      (declare-const ?gbz Real)
      (assert
        (or (or (= ?gby ?gbx)
            (= ?gby ?gbw)
            )
          (= ?gbx ?gbw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gca Real)
      (declare-const ?gcb Real)
      (declare-const ?gcc Real)
      (declare-const ?gcd Real)
      (declare-const ?gce Real)
      (assert
        (or (or (= ?gcc ?gcb)
            (= ?gcc ?gca)
            )
          (= ?gcb ?gca)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gcf Real)
      (declare-const ?gcg Real)
      (declare-const ?gch Real)
      (declare-const ?gci Real)
      (declare-const ?gcj Real)
      (declare-const ?gck Real)
      (assert
        (and (or (or (= ?gch ?gcg)
              (= ?gch ?gcf)
              )
            (= ?gcg ?gcf)
            )
          (and (and (not (= ?gck ?gcj))
              (not (= ?gck ?gci))
              )
            (not (= ?gcj ?gci))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gcl Real)
      (declare-const ?gcm Real)
      (declare-const ?gcn Real)
      (assert
        (or (or (= ?gcn ?gcm)
            (= ?gcn ?gcl)
            )
          (= ?gcm ?gcl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gco Real)
      (declare-const ?gcp Real)
      (declare-const ?gcq Real)
      (declare-const ?gcr Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?gcp ?gco))
                  (not (= ?gcp ?asi))
                  )
                (not (= ?gco ?asi))
                )
              (or (or (= ?gcr ?gcq)
                  (= ?gcr ?asi)
                  )
                (= ?gcq ?asi)
                )
              )
            (and (or (or (= ?gcp ?gco)
                  (= ?gcp ?asi)
                  )
                (= ?gco ?asi)
                )
              (and (and (not (= ?gcr ?gcq))
                  (not (= ?gcr ?asi))
                  )
                (not (= ?gcq ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gcs Real)
      (declare-const ?gct Real)
      (declare-const ?gcu Real)
      (declare-const ?gcv Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?gct ?gcs))
                  (not (= ?gct ?fkf))
                  )
                (not (= ?gcs ?fkf))
                )
              (or (or (= ?gcv ?gcu)
                  (= ?gcv ?fkf)
                  )
                (= ?gcu ?fkf)
                )
              )
            (and (or (or (= ?gct ?gcs)
                  (= ?gct ?fkf)
                  )
                (= ?gcs ?fkf)
                )
              (and (and (not (= ?gcv ?gcu))
                  (not (= ?gcv ?fkf))
                  )
                (not (= ?gcu ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?gcw Real)
    (declare-const ?gcx Real)
    (push 1)
      (declare-const ?gcy Real)
      (declare-const ?gcz Real)
      (declare-const ?gda Real)
      (assert
        (or (or (= ?gda ?gcz)
            (= ?gda ?gcy)
            )
          (= ?gcz ?gcy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gdb Real)
      (declare-const ?gdc Real)
      (declare-const ?gdd Real)
      (declare-const ?gde Real)
      (assert
        (or (or (= ?gde ?gdd)
            (= ?gde ?gdc)
            )
          (= ?gdd ?gdc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gdf Real)
      (declare-const ?gdg Real)
      (declare-const ?gdh Real)
      (declare-const ?gdi Real)
      (declare-const ?gdj Real)
      (assert
        (or (or (= ?gdj ?gdi)
            (= ?gdj ?gdh)
            )
          (= ?gdi ?gdh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gdk Real)
      (declare-const ?gdl Real)
      (declare-const ?gdm Real)
      (declare-const ?gdn Real)
      (declare-const ?gdo Real)
      (declare-const ?gdp Real)
      (assert
        (and (and (and (not (= ?gdm ?gdl))
              (not (= ?gdm ?gdk))
              )
            (not (= ?gdl ?gdk))
            )
          (or (or (= ?gdp ?gdo)
              (= ?gdp ?gdn)
              )
            (= ?gdo ?gdn)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gdq Real)
      (declare-const ?gdr Real)
      (declare-const ?gds Real)
      (assert
        (or (or (= ?gds ?gdr)
            (= ?gds ?gdq)
            )
          (= ?gdr ?gdq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gdt Real)
      (declare-const ?gdu Real)
      (declare-const ?gdv Real)
      (assert
        (or (or (= ?gdv ?gdu)
            (= ?gdv ?gdt)
            )
          (= ?gdu ?gdt)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gdw Real)
      (declare-const ?gdx Real)
      (declare-const ?gdy Real)
      (declare-const ?gdz Real)
      (assert
        (or (or (= ?gdy ?gdx)
            (= ?gdy ?gdw)
            )
          (= ?gdx ?gdw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gea Real)
      (declare-const ?geb Real)
      (declare-const ?gec Real)
      (declare-const ?ged Real)
      (declare-const ?gee Real)
      (assert
        (or (or (= ?gec ?geb)
            (= ?gec ?gea)
            )
          (= ?geb ?gea)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gef Real)
      (declare-const ?geg Real)
      (declare-const ?geh Real)
      (declare-const ?gei Real)
      (declare-const ?gej Real)
      (declare-const ?gek Real)
      (assert
        (and (or (or (= ?geh ?geg)
              (= ?geh ?gef)
              )
            (= ?geg ?gef)
            )
          (and (and (not (= ?gek ?gej))
              (not (= ?gek ?gei))
              )
            (not (= ?gej ?gei))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gel Real)
      (declare-const ?gem Real)
      (declare-const ?gen Real)
      (assert
        (or (or (= ?gen ?gem)
            (= ?gen ?gel)
            )
          (= ?gem ?gel)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?geo Real)
      (declare-const ?gep Real)
      (declare-const ?geq Real)
      (declare-const ?ger Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?gep ?geo))
                  (not (= ?gep ?asi))
                  )
                (not (= ?geo ?asi))
                )
              (or (or (= ?ger ?geq)
                  (= ?ger ?asi)
                  )
                (= ?geq ?asi)
                )
              )
            (and (or (or (= ?gep ?geo)
                  (= ?gep ?asi)
                  )
                (= ?geo ?asi)
                )
              (and (and (not (= ?ger ?geq))
                  (not (= ?ger ?asi))
                  )
                (not (= ?geq ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ges Real)
      (declare-const ?get Real)
      (declare-const ?geu Real)
      (declare-const ?gev Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?get ?ges))
                  (not (= ?get ?fkf))
                  )
                (not (= ?ges ?fkf))
                )
              (or (or (= ?gev ?geu)
                  (= ?gev ?fkf)
                  )
                (= ?geu ?fkf)
                )
              )
            (and (or (or (= ?get ?ges)
                  (= ?get ?fkf)
                  )
                (= ?ges ?fkf)
                )
              (and (and (not (= ?gev ?geu))
                  (not (= ?gev ?fkf))
                  )
                (not (= ?geu ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?gew Real)
    (declare-const ?gex Real)
    (declare-const ?gey Real)
    (push 1)
      (declare-const ?gez Real)
      (declare-const ?gfa Real)
      (declare-const ?gfb Real)
      (assert
        (or (or (= ?gfb ?gfa)
            (= ?gfb ?gez)
            )
          (= ?gfa ?gez)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gfc Real)
      (declare-const ?gfd Real)
      (declare-const ?gfe Real)
      (declare-const ?gff Real)
      (assert
        (or (or (= ?gff ?gfe)
            (= ?gff ?gfd)
            )
          (= ?gfe ?gfd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gfg Real)
      (declare-const ?gfh Real)
      (declare-const ?gfi Real)
      (declare-const ?gfj Real)
      (declare-const ?gfk Real)
      (assert
        (or (or (= ?gfk ?gfj)
            (= ?gfk ?gfi)
            )
          (= ?gfj ?gfi)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gfl Real)
      (declare-const ?gfm Real)
      (declare-const ?gfn Real)
      (declare-const ?gfo Real)
      (declare-const ?gfp Real)
      (declare-const ?gfq Real)
      (assert
        (and (and (and (not (= ?gfn ?gfm))
              (not (= ?gfn ?gfl))
              )
            (not (= ?gfm ?gfl))
            )
          (or (or (= ?gfq ?gfp)
              (= ?gfq ?gfo)
              )
            (= ?gfp ?gfo)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gfr Real)
      (declare-const ?gfs Real)
      (declare-const ?gft Real)
      (assert
        (or (or (= ?gft ?gfs)
            (= ?gft ?gfr)
            )
          (= ?gfs ?gfr)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gfu Real)
      (declare-const ?gfv Real)
      (declare-const ?gfw Real)
      (assert
        (or (or (= ?gfw ?gfv)
            (= ?gfw ?gfu)
            )
          (= ?gfv ?gfu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gfx Real)
      (declare-const ?gfy Real)
      (declare-const ?gfz Real)
      (declare-const ?gga Real)
      (assert
        (or (or (= ?gfz ?gfy)
            (= ?gfz ?gfx)
            )
          (= ?gfy ?gfx)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ggb Real)
      (declare-const ?ggc Real)
      (declare-const ?ggd Real)
      (declare-const ?gge Real)
      (declare-const ?ggf Real)
      (assert
        (or (or (= ?ggd ?ggc)
            (= ?ggd ?ggb)
            )
          (= ?ggc ?ggb)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ggg Real)
      (declare-const ?ggh Real)
      (declare-const ?ggi Real)
      (declare-const ?ggj Real)
      (declare-const ?ggk Real)
      (declare-const ?ggl Real)
      (assert
        (and (or (or (= ?ggi ?ggh)
              (= ?ggi ?ggg)
              )
            (= ?ggh ?ggg)
            )
          (and (and (not (= ?ggl ?ggk))
              (not (= ?ggl ?ggj))
              )
            (not (= ?ggk ?ggj))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ggm Real)
      (declare-const ?ggn Real)
      (declare-const ?ggo Real)
      (assert
        (or (or (= ?ggo ?ggn)
            (= ?ggo ?ggm)
            )
          (= ?ggn ?ggm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ggp Real)
      (declare-const ?ggq Real)
      (declare-const ?ggr Real)
      (declare-const ?ggs Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?ggq ?ggp))
                  (not (= ?ggq ?asi))
                  )
                (not (= ?ggp ?asi))
                )
              (or (or (= ?ggs ?ggr)
                  (= ?ggs ?asi)
                  )
                (= ?ggr ?asi)
                )
              )
            (and (or (or (= ?ggq ?ggp)
                  (= ?ggq ?asi)
                  )
                (= ?ggp ?asi)
                )
              (and (and (not (= ?ggs ?ggr))
                  (not (= ?ggs ?asi))
                  )
                (not (= ?ggr ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ggt Real)
      (declare-const ?ggu Real)
      (declare-const ?ggv Real)
      (declare-const ?ggw Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?ggu ?ggt))
                  (not (= ?ggu ?fkf))
                  )
                (not (= ?ggt ?fkf))
                )
              (or (or (= ?ggw ?ggv)
                  (= ?ggw ?fkf)
                  )
                (= ?ggv ?fkf)
                )
              )
            (and (or (or (= ?ggu ?ggt)
                  (= ?ggu ?fkf)
                  )
                (= ?ggt ?fkf)
                )
              (and (and (not (= ?ggw ?ggv))
                  (not (= ?ggw ?fkf))
                  )
                (not (= ?ggv ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (= ?gey ?gex)
            (= ?gey ?gew)
            )
          (= ?gex ?gew)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?ggx Real)
    (declare-const ?ggy Real)
    (declare-const ?ggz Real)
    (push 1)
      (declare-const ?gha Real)
      (declare-const ?ghb Real)
      (declare-const ?ghc Real)
      (assert
        (or (or (= ?ghc ?ghb)
            (= ?ghc ?gha)
            )
          (= ?ghb ?gha)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ghd Real)
      (declare-const ?ghe Real)
      (declare-const ?ghf Real)
      (declare-const ?ghg Real)
      (assert
        (or (or (= ?ghg ?ghf)
            (= ?ghg ?ghe)
            )
          (= ?ghf ?ghe)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ghh Real)
      (declare-const ?ghi Real)
      (declare-const ?ghj Real)
      (declare-const ?ghk Real)
      (declare-const ?ghl Real)
      (assert
        (or (or (= ?ghl ?ghk)
            (= ?ghl ?ghj)
            )
          (= ?ghk ?ghj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ghm Real)
      (declare-const ?ghn Real)
      (declare-const ?gho Real)
      (declare-const ?ghp Real)
      (declare-const ?ghq Real)
      (declare-const ?ghr Real)
      (assert
        (and (and (and (not (= ?gho ?ghn))
              (not (= ?gho ?ghm))
              )
            (not (= ?ghn ?ghm))
            )
          (or (or (= ?ghr ?ghq)
              (= ?ghr ?ghp)
              )
            (= ?ghq ?ghp)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ghs Real)
      (declare-const ?ght Real)
      (declare-const ?ghu Real)
      (assert
        (or (or (= ?ghu ?ght)
            (= ?ghu ?ghs)
            )
          (= ?ght ?ghs)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ghv Real)
      (declare-const ?ghw Real)
      (declare-const ?ghx Real)
      (assert
        (or (or (= ?ghx ?ghw)
            (= ?ghx ?ghv)
            )
          (= ?ghw ?ghv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ghy Real)
      (declare-const ?ghz Real)
      (declare-const ?gia Real)
      (declare-const ?gib Real)
      (assert
        (or (or (= ?gia ?ghz)
            (= ?gia ?ghy)
            )
          (= ?ghz ?ghy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gic Real)
      (declare-const ?gid Real)
      (declare-const ?gie Real)
      (declare-const ?gif Real)
      (declare-const ?gig Real)
      (assert
        (or (or (= ?gie ?gid)
            (= ?gie ?gic)
            )
          (= ?gid ?gic)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gih Real)
      (declare-const ?gii Real)
      (declare-const ?gij Real)
      (declare-const ?gik Real)
      (declare-const ?gil Real)
      (declare-const ?gim Real)
      (assert
        (and (or (or (= ?gij ?gii)
              (= ?gij ?gih)
              )
            (= ?gii ?gih)
            )
          (and (and (not (= ?gim ?gil))
              (not (= ?gim ?gik))
              )
            (not (= ?gil ?gik))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gin Real)
      (declare-const ?gio Real)
      (declare-const ?gip Real)
      (assert
        (or (or (= ?gip ?gio)
            (= ?gip ?gin)
            )
          (= ?gio ?gin)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?giq Real)
      (declare-const ?gir Real)
      (declare-const ?gis Real)
      (declare-const ?git Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?gir ?giq))
                  (not (= ?gir ?asi))
                  )
                (not (= ?giq ?asi))
                )
              (or (or (= ?git ?gis)
                  (= ?git ?asi)
                  )
                (= ?gis ?asi)
                )
              )
            (and (or (or (= ?gir ?giq)
                  (= ?gir ?asi)
                  )
                (= ?giq ?asi)
                )
              (and (and (not (= ?git ?gis))
                  (not (= ?git ?asi))
                  )
                (not (= ?gis ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?giu Real)
      (declare-const ?giv Real)
      (declare-const ?giw Real)
      (declare-const ?gix Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?giv ?giu))
                  (not (= ?giv ?fkf))
                  )
                (not (= ?giu ?fkf))
                )
              (or (or (= ?gix ?giw)
                  (= ?gix ?fkf)
                  )
                (= ?giw ?fkf)
                )
              )
            (and (or (or (= ?giv ?giu)
                  (= ?giv ?fkf)
                  )
                (= ?giu ?fkf)
                )
              (and (and (not (= ?gix ?giw))
                  (not (= ?gix ?fkf))
                  )
                (not (= ?giw ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?giy Real)
      (declare-const ?giz Real)
      (declare-const ?gja Real)
      (assert
        (or (or (= ?gja ?giz)
            (= ?gja ?giy)
            )
          (= ?giz ?giy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gjb Real)
      (declare-const ?gjc Real)
      (declare-const ?gjd Real)
      (declare-const ?gje Real)
      (assert
        (or (or (= ?gje ?gjd)
            (= ?gje ?gjc)
            )
          (= ?gjd ?gjc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gjf Real)
      (declare-const ?gjg Real)
      (declare-const ?gjh Real)
      (declare-const ?gji Real)
      (declare-const ?gjj Real)
      (assert
        (or (or (= ?gjj ?gji)
            (= ?gjj ?gjh)
            )
          (= ?gji ?gjh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gjk Real)
      (declare-const ?gjl Real)
      (declare-const ?gjm Real)
      (declare-const ?gjn Real)
      (declare-const ?gjo Real)
      (declare-const ?gjp Real)
      (assert
        (and (and (and (not (= ?gjm ?gjl))
              (not (= ?gjm ?gjk))
              )
            (not (= ?gjl ?gjk))
            )
          (or (or (= ?gjp ?gjo)
              (= ?gjp ?gjn)
              )
            (= ?gjo ?gjn)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gjq Real)
      (declare-const ?gjr Real)
      (declare-const ?gjs Real)
      (assert
        (or (or (= ?gjs ?gjr)
            (= ?gjs ?gjq)
            )
          (= ?gjr ?gjq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gjt Real)
      (declare-const ?gju Real)
      (declare-const ?gjv Real)
      (assert
        (or (or (= ?gjv ?gju)
            (= ?gjv ?gjt)
            )
          (= ?gju ?gjt)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gjw Real)
      (declare-const ?gjx Real)
      (declare-const ?gjy Real)
      (declare-const ?gjz Real)
      (assert
        (or (or (= ?gjy ?gjx)
            (= ?gjy ?gjw)
            )
          (= ?gjx ?gjw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gka Real)
      (declare-const ?gkb Real)
      (declare-const ?gkc Real)
      (declare-const ?gkd Real)
      (declare-const ?gke Real)
      (assert
        (or (or (= ?gkc ?gkb)
            (= ?gkc ?gka)
            )
          (= ?gkb ?gka)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gkf Real)
      (declare-const ?gkg Real)
      (declare-const ?gkh Real)
      (declare-const ?gki Real)
      (declare-const ?gkj Real)
      (declare-const ?gkk Real)
      (assert
        (and (or (or (= ?gkh ?gkg)
              (= ?gkh ?gkf)
              )
            (= ?gkg ?gkf)
            )
          (and (and (not (= ?gkk ?gkj))
              (not (= ?gkk ?gki))
              )
            (not (= ?gkj ?gki))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gkl Real)
      (declare-const ?gkm Real)
      (declare-const ?gkn Real)
      (assert
        (or (or (= ?gkn ?gkm)
            (= ?gkn ?gkl)
            )
          (= ?gkm ?gkl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gko Real)
      (declare-const ?gkp Real)
      (declare-const ?gkq Real)
      (declare-const ?gkr Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?gkp ?gko))
                  (not (= ?gkp ?asi))
                  )
                (not (= ?gko ?asi))
                )
              (or (or (= ?gkr ?gkq)
                  (= ?gkr ?asi)
                  )
                (= ?gkq ?asi)
                )
              )
            (and (or (or (= ?gkp ?gko)
                  (= ?gkp ?asi)
                  )
                (= ?gko ?asi)
                )
              (and (and (not (= ?gkr ?gkq))
                  (not (= ?gkr ?asi))
                  )
                (not (= ?gkq ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?gks Real)
      (declare-const ?gkt Real)
      (declare-const ?gku Real)
      (declare-const ?gkv Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?gkt ?gks))
                  (not (= ?gkt ?fkf))
                  )
                (not (= ?gks ?fkf))
                )
              (or (or (= ?gkv ?gku)
                  (= ?gkv ?fkf)
                  )
                (= ?gku ?fkf)
                )
              )
            (and (or (or (= ?gkt ?gks)
                  (= ?gkt ?fkf)
                  )
                (= ?gks ?fkf)
                )
              (and (and (not (= ?gkv ?gku))
                  (not (= ?gkv ?fkf))
                  )
                (not (= ?gku ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?gkw Real)
  (declare-const ?gkx Real)
  (declare-const ?gky Real)
  (assert
    (or (or (= ?gky ?gkx)
        (= ?gky ?gkw)
        )
      (= ?gkx ?gkw)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?gkz Real)
    (declare-const ?gla Real)
    (declare-const ?glb Real)
    (assert
      (or (or (= ?glb ?gla)
          (= ?glb ?gkz)
          )
        (= ?gla ?gkz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?glc Real)
    (declare-const ?gld Real)
    (declare-const ?gle Real)
    (declare-const ?glf Real)
    (assert
      (or (or (= ?glf ?gle)
          (= ?glf ?gld)
          )
        (= ?gle ?gld)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?glg Real)
    (declare-const ?glh Real)
    (declare-const ?gli Real)
    (declare-const ?glj Real)
    (declare-const ?glk Real)
    (assert
      (or (or (= ?glk ?glj)
          (= ?glk ?gli)
          )
        (= ?glj ?gli)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gll Real)
    (declare-const ?glm Real)
    (declare-const ?gln Real)
    (declare-const ?glo Real)
    (declare-const ?glp Real)
    (declare-const ?glq Real)
    (assert
      (and (and (and (not (= ?gln ?glm))
            (not (= ?gln ?gll))
            )
          (not (= ?glm ?gll))
          )
        (or (or (= ?glq ?glp)
            (= ?glq ?glo)
            )
          (= ?glp ?glo)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?glr Real)
    (declare-const ?gls Real)
    (declare-const ?glt Real)
    (assert
      (or (or (= ?glt ?gls)
          (= ?glt ?glr)
          )
        (= ?gls ?glr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?glu Real)
    (declare-const ?glv Real)
    (declare-const ?glw Real)
    (assert
      (or (or (= ?glw ?glv)
          (= ?glw ?glu)
          )
        (= ?glv ?glu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?glx Real)
    (declare-const ?gly Real)
    (declare-const ?glz Real)
    (declare-const ?gma Real)
    (assert
      (or (or (= ?glz ?gly)
          (= ?glz ?glx)
          )
        (= ?gly ?glx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gmb Real)
    (declare-const ?gmc Real)
    (declare-const ?gmd Real)
    (declare-const ?gme Real)
    (declare-const ?gmf Real)
    (assert
      (or (or (= ?gmd ?gmc)
          (= ?gmd ?gmb)
          )
        (= ?gmc ?gmb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gmg Real)
    (declare-const ?gmh Real)
    (declare-const ?gmi Real)
    (declare-const ?gmj Real)
    (declare-const ?gmk Real)
    (declare-const ?gml Real)
    (assert
      (and (or (or (= ?gmi ?gmh)
            (= ?gmi ?gmg)
            )
          (= ?gmh ?gmg)
          )
        (and (and (not (= ?gml ?gmk))
            (not (= ?gml ?gmj))
            )
          (not (= ?gmk ?gmj))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gmm Real)
    (declare-const ?gmn Real)
    (declare-const ?gmo Real)
    (assert
      (or (or (= ?gmo ?gmn)
          (= ?gmo ?gmm)
          )
        (= ?gmn ?gmm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gmp Real)
    (declare-const ?gmq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gmr Real)
    (declare-const ?gms Real)
    (declare-const ?gmt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gmu Real)
    (declare-const ?gmv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gmw Real)
    (declare-const ?gmx Real)
    (declare-const ?gmy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gmz Real)
    (declare-const ?gna Real)
    (declare-const ?gnb Real)
    (declare-const ?gnc Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?gna ?gmz))
                (not (= ?gna ?asi))
                )
              (not (= ?gmz ?asi))
              )
            (or (or (= ?gnc ?gnb)
                (= ?gnc ?asi)
                )
              (= ?gnb ?asi)
              )
            )
          (and (or (or (= ?gna ?gmz)
                (= ?gna ?asi)
                )
              (= ?gmz ?asi)
              )
            (and (and (not (= ?gnc ?gnb))
                (not (= ?gnc ?asi))
                )
              (not (= ?gnb ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gnd Real)
    (declare-const ?gne Real)
    (declare-const ?gnf Real)
    (declare-const ?gng Real)
    (declare-const ?gnh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gni Real)
    (declare-const ?gnj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gnk Real)
    (declare-const ?gnl Real)
    (declare-const ?gnm Real)
    (declare-const ?gnn Real)
    (declare-const ?gno Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gnp Real)
    (declare-const ?gnq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?gnr Real)
  (declare-const ?gns Real)
  (declare-const ?gnt Real)
  (declare-const ?gnu Real)
  (assert
    (or (or (= ?gnu ?gnt)
        (= ?gnu ?gns)
        )
      (= ?gnt ?gns)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?gnv Real)
    (declare-const ?gnw Real)
    (declare-const ?gnx Real)
    (assert
      (or (or (= ?gnx ?gnw)
          (= ?gnx ?gnv)
          )
        (= ?gnw ?gnv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gny Real)
    (declare-const ?gnz Real)
    (declare-const ?goa Real)
    (declare-const ?gob Real)
    (assert
      (or (or (= ?gob ?goa)
          (= ?gob ?gnz)
          )
        (= ?goa ?gnz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?goc Real)
    (declare-const ?god Real)
    (declare-const ?goe Real)
    (declare-const ?gof Real)
    (declare-const ?gog Real)
    (assert
      (or (or (= ?gog ?gof)
          (= ?gog ?goe)
          )
        (= ?gof ?goe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?goh Real)
    (declare-const ?goi Real)
    (declare-const ?goj Real)
    (declare-const ?gok Real)
    (declare-const ?gol Real)
    (declare-const ?gom Real)
    (assert
      (and (and (and (not (= ?goj ?goi))
            (not (= ?goj ?goh))
            )
          (not (= ?goi ?goh))
          )
        (or (or (= ?gom ?gol)
            (= ?gom ?gok)
            )
          (= ?gol ?gok)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gon Real)
    (declare-const ?goo Real)
    (declare-const ?gop Real)
    (assert
      (or (or (= ?gop ?goo)
          (= ?gop ?gon)
          )
        (= ?goo ?gon)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?goq Real)
    (declare-const ?gor Real)
    (declare-const ?gos Real)
    (assert
      (or (or (= ?gos ?gor)
          (= ?gos ?goq)
          )
        (= ?gor ?goq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?got Real)
    (declare-const ?gou Real)
    (declare-const ?gov Real)
    (declare-const ?gow Real)
    (assert
      (or (or (= ?gov ?gou)
          (= ?gov ?got)
          )
        (= ?gou ?got)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gox Real)
    (declare-const ?goy Real)
    (declare-const ?goz Real)
    (declare-const ?gpa Real)
    (declare-const ?gpb Real)
    (assert
      (or (or (= ?goz ?goy)
          (= ?goz ?gox)
          )
        (= ?goy ?gox)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gpc Real)
    (declare-const ?gpd Real)
    (declare-const ?gpe Real)
    (declare-const ?gpf Real)
    (declare-const ?gpg Real)
    (declare-const ?gph Real)
    (assert
      (and (or (or (= ?gpe ?gpd)
            (= ?gpe ?gpc)
            )
          (= ?gpd ?gpc)
          )
        (and (and (not (= ?gph ?gpg))
            (not (= ?gph ?gpf))
            )
          (not (= ?gpg ?gpf))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gpi Real)
    (declare-const ?gpj Real)
    (declare-const ?gpk Real)
    (assert
      (or (or (= ?gpk ?gpj)
          (= ?gpk ?gpi)
          )
        (= ?gpj ?gpi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gpl Real)
    (declare-const ?gpm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gpn Real)
    (declare-const ?gpo Real)
    (declare-const ?gpp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gpq Real)
    (declare-const ?gpr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gps Real)
    (declare-const ?gpt Real)
    (declare-const ?gpu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gpv Real)
    (declare-const ?gpw Real)
    (declare-const ?gpx Real)
    (declare-const ?gpy Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?gpw ?gpv))
                (not (= ?gpw ?asi))
                )
              (not (= ?gpv ?asi))
              )
            (or (or (= ?gpy ?gpx)
                (= ?gpy ?asi)
                )
              (= ?gpx ?asi)
              )
            )
          (and (or (or (= ?gpw ?gpv)
                (= ?gpw ?asi)
                )
              (= ?gpv ?asi)
              )
            (and (and (not (= ?gpy ?gpx))
                (not (= ?gpy ?asi))
                )
              (not (= ?gpx ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gpz Real)
    (declare-const ?gqa Real)
    (declare-const ?gqb Real)
    (declare-const ?gqc Real)
    (declare-const ?gqd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gqe Real)
    (declare-const ?gqf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gqg Real)
    (declare-const ?gqh Real)
    (declare-const ?gqi Real)
    (declare-const ?gqj Real)
    (declare-const ?gqk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gql Real)
    (declare-const ?gqm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?gqn Real)
  (declare-const ?gqo Real)
  (declare-const ?gqp Real)
  (declare-const ?gqq Real)
  (declare-const ?gqr Real)
  (assert
    (or (or (= ?gqr ?gqq)
        (= ?gqr ?gqp)
        )
      (= ?gqq ?gqp)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?gqs Real)
    (declare-const ?gqt Real)
    (declare-const ?gqu Real)
    (assert
      (or (or (= ?gqu ?gqt)
          (= ?gqu ?gqs)
          )
        (= ?gqt ?gqs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gqv Real)
    (declare-const ?gqw Real)
    (declare-const ?gqx Real)
    (declare-const ?gqy Real)
    (assert
      (or (or (= ?gqy ?gqx)
          (= ?gqy ?gqw)
          )
        (= ?gqx ?gqw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gqz Real)
    (declare-const ?gra Real)
    (declare-const ?grb Real)
    (declare-const ?grc Real)
    (declare-const ?grd Real)
    (assert
      (or (or (= ?grd ?grc)
          (= ?grd ?grb)
          )
        (= ?grc ?grb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gre Real)
    (declare-const ?grf Real)
    (declare-const ?grg Real)
    (declare-const ?grh Real)
    (declare-const ?gri Real)
    (declare-const ?grj Real)
    (assert
      (and (and (and (not (= ?grg ?grf))
            (not (= ?grg ?gre))
            )
          (not (= ?grf ?gre))
          )
        (or (or (= ?grj ?gri)
            (= ?grj ?grh)
            )
          (= ?gri ?grh)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?grk Real)
    (declare-const ?grl Real)
    (declare-const ?grm Real)
    (assert
      (or (or (= ?grm ?grl)
          (= ?grm ?grk)
          )
        (= ?grl ?grk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?grn Real)
    (declare-const ?gro Real)
    (declare-const ?grp Real)
    (assert
      (or (or (= ?grp ?gro)
          (= ?grp ?grn)
          )
        (= ?gro ?grn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?grq Real)
    (declare-const ?grr Real)
    (declare-const ?grs Real)
    (declare-const ?grt Real)
    (assert
      (or (or (= ?grs ?grr)
          (= ?grs ?grq)
          )
        (= ?grr ?grq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gru Real)
    (declare-const ?grv Real)
    (declare-const ?grw Real)
    (declare-const ?grx Real)
    (declare-const ?gry Real)
    (assert
      (or (or (= ?grw ?grv)
          (= ?grw ?gru)
          )
        (= ?grv ?gru)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?grz Real)
    (declare-const ?gsa Real)
    (declare-const ?gsb Real)
    (declare-const ?gsc Real)
    (declare-const ?gsd Real)
    (declare-const ?gse Real)
    (assert
      (and (or (or (= ?gsb ?gsa)
            (= ?gsb ?grz)
            )
          (= ?gsa ?grz)
          )
        (and (and (not (= ?gse ?gsd))
            (not (= ?gse ?gsc))
            )
          (not (= ?gsd ?gsc))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gsf Real)
    (declare-const ?gsg Real)
    (declare-const ?gsh Real)
    (assert
      (or (or (= ?gsh ?gsg)
          (= ?gsh ?gsf)
          )
        (= ?gsg ?gsf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gsi Real)
    (declare-const ?gsj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gsk Real)
    (declare-const ?gsl Real)
    (declare-const ?gsm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gsn Real)
    (declare-const ?gso Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gsp Real)
    (declare-const ?gsq Real)
    (declare-const ?gsr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gss Real)
    (declare-const ?gst Real)
    (declare-const ?gsu Real)
    (declare-const ?gsv Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?gst ?gss))
                (not (= ?gst ?asi))
                )
              (not (= ?gss ?asi))
              )
            (or (or (= ?gsv ?gsu)
                (= ?gsv ?asi)
                )
              (= ?gsu ?asi)
              )
            )
          (and (or (or (= ?gst ?gss)
                (= ?gst ?asi)
                )
              (= ?gss ?asi)
              )
            (and (and (not (= ?gsv ?gsu))
                (not (= ?gsv ?asi))
                )
              (not (= ?gsu ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gsw Real)
    (declare-const ?gsx Real)
    (declare-const ?gsy Real)
    (declare-const ?gsz Real)
    (declare-const ?gta Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gtb Real)
    (declare-const ?gtc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gtd Real)
    (declare-const ?gte Real)
    (declare-const ?gtf Real)
    (declare-const ?gtg Real)
    (declare-const ?gth Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gti Real)
    (declare-const ?gtj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?gtk Real)
  (declare-const ?gtl Real)
  (declare-const ?gtm Real)
  (declare-const ?gtn Real)
  (declare-const ?gto Real)
  (declare-const ?gtp Real)
  (assert
    (and (and (and (not (= ?gtm ?gtl))
          (not (= ?gtm ?gtk))
          )
        (not (= ?gtl ?gtk))
        )
      (or (or (= ?gtp ?gto)
          (= ?gtp ?gtn)
          )
        (= ?gto ?gtn)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?gtq Real)
    (declare-const ?gtr Real)
    (declare-const ?gts Real)
    (assert
      (or (or (= ?gts ?gtr)
          (= ?gts ?gtq)
          )
        (= ?gtr ?gtq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gtt Real)
    (declare-const ?gtu Real)
    (declare-const ?gtv Real)
    (declare-const ?gtw Real)
    (assert
      (or (or (= ?gtw ?gtv)
          (= ?gtw ?gtu)
          )
        (= ?gtv ?gtu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gtx Real)
    (declare-const ?gty Real)
    (declare-const ?gtz Real)
    (declare-const ?gua Real)
    (declare-const ?gub Real)
    (assert
      (or (or (= ?gub ?gua)
          (= ?gub ?gtz)
          )
        (= ?gua ?gtz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?guc Real)
    (declare-const ?gud Real)
    (declare-const ?gue Real)
    (declare-const ?guf Real)
    (declare-const ?gug Real)
    (declare-const ?guh Real)
    (assert
      (and (and (and (not (= ?gue ?gud))
            (not (= ?gue ?guc))
            )
          (not (= ?gud ?guc))
          )
        (or (or (= ?guh ?gug)
            (= ?guh ?guf)
            )
          (= ?gug ?guf)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gui Real)
    (declare-const ?guj Real)
    (declare-const ?guk Real)
    (assert
      (or (or (= ?guk ?guj)
          (= ?guk ?gui)
          )
        (= ?guj ?gui)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gul Real)
    (declare-const ?gum Real)
    (declare-const ?gun Real)
    (assert
      (or (or (= ?gun ?gum)
          (= ?gun ?gul)
          )
        (= ?gum ?gul)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?guo Real)
    (declare-const ?gup Real)
    (declare-const ?guq Real)
    (declare-const ?gur Real)
    (assert
      (or (or (= ?guq ?gup)
          (= ?guq ?guo)
          )
        (= ?gup ?guo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gus Real)
    (declare-const ?gut Real)
    (declare-const ?guu Real)
    (declare-const ?guv Real)
    (declare-const ?guw Real)
    (assert
      (or (or (= ?guu ?gut)
          (= ?guu ?gus)
          )
        (= ?gut ?gus)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gux Real)
    (declare-const ?guy Real)
    (declare-const ?guz Real)
    (declare-const ?gva Real)
    (declare-const ?gvb Real)
    (declare-const ?gvc Real)
    (assert
      (and (or (or (= ?guz ?guy)
            (= ?guz ?gux)
            )
          (= ?guy ?gux)
          )
        (and (and (not (= ?gvc ?gvb))
            (not (= ?gvc ?gva))
            )
          (not (= ?gvb ?gva))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gvd Real)
    (declare-const ?gve Real)
    (declare-const ?gvf Real)
    (assert
      (or (or (= ?gvf ?gve)
          (= ?gvf ?gvd)
          )
        (= ?gve ?gvd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gvg Real)
    (declare-const ?gvh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gvi Real)
    (declare-const ?gvj Real)
    (declare-const ?gvk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gvl Real)
    (declare-const ?gvm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gvn Real)
    (declare-const ?gvo Real)
    (declare-const ?gvp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gvq Real)
    (declare-const ?gvr Real)
    (declare-const ?gvs Real)
    (declare-const ?gvt Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?gvr ?gvq))
                (not (= ?gvr ?asi))
                )
              (not (= ?gvq ?asi))
              )
            (or (or (= ?gvt ?gvs)
                (= ?gvt ?asi)
                )
              (= ?gvs ?asi)
              )
            )
          (and (or (or (= ?gvr ?gvq)
                (= ?gvr ?asi)
                )
              (= ?gvq ?asi)
              )
            (and (and (not (= ?gvt ?gvs))
                (not (= ?gvt ?asi))
                )
              (not (= ?gvs ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gvu Real)
    (declare-const ?gvv Real)
    (declare-const ?gvw Real)
    (declare-const ?gvx Real)
    (declare-const ?gvy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gvz Real)
    (declare-const ?gwa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gwb Real)
    (declare-const ?gwc Real)
    (declare-const ?gwd Real)
    (declare-const ?gwe Real)
    (declare-const ?gwf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gwg Real)
    (declare-const ?gwh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?gwi Real)
  (declare-const ?gwj Real)
  (declare-const ?gwk Real)
  (assert
    (or (or (= ?gwk ?gwj)
        (= ?gwk ?gwi)
        )
      (= ?gwj ?gwi)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?gwl Real)
    (declare-const ?gwm Real)
    (declare-const ?gwn Real)
    (assert
      (or (or (= ?gwn ?gwm)
          (= ?gwn ?gwl)
          )
        (= ?gwm ?gwl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gwo Real)
    (declare-const ?gwp Real)
    (declare-const ?gwq Real)
    (declare-const ?gwr Real)
    (assert
      (or (or (= ?gwr ?gwq)
          (= ?gwr ?gwp)
          )
        (= ?gwq ?gwp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gws Real)
    (declare-const ?gwt Real)
    (declare-const ?gwu Real)
    (declare-const ?gwv Real)
    (declare-const ?gww Real)
    (assert
      (or (or (= ?gww ?gwv)
          (= ?gww ?gwu)
          )
        (= ?gwv ?gwu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gwx Real)
    (declare-const ?gwy Real)
    (declare-const ?gwz Real)
    (declare-const ?gxa Real)
    (declare-const ?gxb Real)
    (declare-const ?gxc Real)
    (assert
      (and (and (and (not (= ?gwz ?gwy))
            (not (= ?gwz ?gwx))
            )
          (not (= ?gwy ?gwx))
          )
        (or (or (= ?gxc ?gxb)
            (= ?gxc ?gxa)
            )
          (= ?gxb ?gxa)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gxd Real)
    (declare-const ?gxe Real)
    (declare-const ?gxf Real)
    (assert
      (or (or (= ?gxf ?gxe)
          (= ?gxf ?gxd)
          )
        (= ?gxe ?gxd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gxg Real)
    (declare-const ?gxh Real)
    (declare-const ?gxi Real)
    (assert
      (or (or (= ?gxi ?gxh)
          (= ?gxi ?gxg)
          )
        (= ?gxh ?gxg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gxj Real)
    (declare-const ?gxk Real)
    (declare-const ?gxl Real)
    (declare-const ?gxm Real)
    (assert
      (or (or (= ?gxl ?gxk)
          (= ?gxl ?gxj)
          )
        (= ?gxk ?gxj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gxn Real)
    (declare-const ?gxo Real)
    (declare-const ?gxp Real)
    (declare-const ?gxq Real)
    (declare-const ?gxr Real)
    (assert
      (or (or (= ?gxp ?gxo)
          (= ?gxp ?gxn)
          )
        (= ?gxo ?gxn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gxs Real)
    (declare-const ?gxt Real)
    (declare-const ?gxu Real)
    (declare-const ?gxv Real)
    (declare-const ?gxw Real)
    (declare-const ?gxx Real)
    (assert
      (and (or (or (= ?gxu ?gxt)
            (= ?gxu ?gxs)
            )
          (= ?gxt ?gxs)
          )
        (and (and (not (= ?gxx ?gxw))
            (not (= ?gxx ?gxv))
            )
          (not (= ?gxw ?gxv))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gxy Real)
    (declare-const ?gxz Real)
    (declare-const ?gya Real)
    (assert
      (or (or (= ?gya ?gxz)
          (= ?gya ?gxy)
          )
        (= ?gxz ?gxy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gyb Real)
    (declare-const ?gyc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gyd Real)
    (declare-const ?gye Real)
    (declare-const ?gyf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gyg Real)
    (declare-const ?gyh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gyi Real)
    (declare-const ?gyj Real)
    (declare-const ?gyk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gyl Real)
    (declare-const ?gym Real)
    (declare-const ?gyn Real)
    (declare-const ?gyo Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?gym ?gyl))
                (not (= ?gym ?asi))
                )
              (not (= ?gyl ?asi))
              )
            (or (or (= ?gyo ?gyn)
                (= ?gyo ?asi)
                )
              (= ?gyn ?asi)
              )
            )
          (and (or (or (= ?gym ?gyl)
                (= ?gym ?asi)
                )
              (= ?gyl ?asi)
              )
            (and (and (not (= ?gyo ?gyn))
                (not (= ?gyo ?asi))
                )
              (not (= ?gyn ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gyp Real)
    (declare-const ?gyq Real)
    (declare-const ?gyr Real)
    (declare-const ?gys Real)
    (declare-const ?gyt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gyu Real)
    (declare-const ?gyv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gyw Real)
    (declare-const ?gyx Real)
    (declare-const ?gyy Real)
    (declare-const ?gyz Real)
    (declare-const ?gza Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gzb Real)
    (declare-const ?gzc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?gzd Real)
  (declare-const ?gze Real)
  (declare-const ?gzf Real)
  (assert
    (or (or (= ?gzf ?gze)
        (= ?gzf ?gzd)
        )
      (= ?gze ?gzd)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?gzg Real)
    (declare-const ?gzh Real)
    (declare-const ?gzi Real)
    (assert
      (or (or (= ?gzi ?gzh)
          (= ?gzi ?gzg)
          )
        (= ?gzh ?gzg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gzj Real)
    (declare-const ?gzk Real)
    (declare-const ?gzl Real)
    (declare-const ?gzm Real)
    (assert
      (or (or (= ?gzm ?gzl)
          (= ?gzm ?gzk)
          )
        (= ?gzl ?gzk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gzn Real)
    (declare-const ?gzo Real)
    (declare-const ?gzp Real)
    (declare-const ?gzq Real)
    (declare-const ?gzr Real)
    (assert
      (or (or (= ?gzr ?gzq)
          (= ?gzr ?gzp)
          )
        (= ?gzq ?gzp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gzs Real)
    (declare-const ?gzt Real)
    (declare-const ?gzu Real)
    (declare-const ?gzv Real)
    (declare-const ?gzw Real)
    (declare-const ?gzx Real)
    (assert
      (and (and (and (not (= ?gzu ?gzt))
            (not (= ?gzu ?gzs))
            )
          (not (= ?gzt ?gzs))
          )
        (or (or (= ?gzx ?gzw)
            (= ?gzx ?gzv)
            )
          (= ?gzw ?gzv)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?gzy Real)
    (declare-const ?gzz Real)
    (declare-const ?haa Real)
    (assert
      (or (or (= ?haa ?gzz)
          (= ?haa ?gzy)
          )
        (= ?gzz ?gzy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hab Real)
    (declare-const ?hac Real)
    (declare-const ?had Real)
    (assert
      (or (or (= ?had ?hac)
          (= ?had ?hab)
          )
        (= ?hac ?hab)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hae Real)
    (declare-const ?haf Real)
    (declare-const ?hag Real)
    (declare-const ?hah Real)
    (assert
      (or (or (= ?hag ?haf)
          (= ?hag ?hae)
          )
        (= ?haf ?hae)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hai Real)
    (declare-const ?haj Real)
    (declare-const ?hak Real)
    (declare-const ?hal Real)
    (declare-const ?ham Real)
    (assert
      (or (or (= ?hak ?haj)
          (= ?hak ?hai)
          )
        (= ?haj ?hai)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?han Real)
    (declare-const ?hao Real)
    (declare-const ?hap Real)
    (declare-const ?haq Real)
    (declare-const ?har Real)
    (declare-const ?has Real)
    (assert
      (and (or (or (= ?hap ?hao)
            (= ?hap ?han)
            )
          (= ?hao ?han)
          )
        (and (and (not (= ?has ?har))
            (not (= ?has ?haq))
            )
          (not (= ?har ?haq))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hat Real)
    (declare-const ?hau Real)
    (declare-const ?hav Real)
    (assert
      (or (or (= ?hav ?hau)
          (= ?hav ?hat)
          )
        (= ?hau ?hat)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?haw Real)
    (declare-const ?hax Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hay Real)
    (declare-const ?haz Real)
    (declare-const ?hba Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hbb Real)
    (declare-const ?hbc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hbd Real)
    (declare-const ?hbe Real)
    (declare-const ?hbf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hbg Real)
    (declare-const ?hbh Real)
    (declare-const ?hbi Real)
    (declare-const ?hbj Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?hbh ?hbg))
                (not (= ?hbh ?asi))
                )
              (not (= ?hbg ?asi))
              )
            (or (or (= ?hbj ?hbi)
                (= ?hbj ?asi)
                )
              (= ?hbi ?asi)
              )
            )
          (and (or (or (= ?hbh ?hbg)
                (= ?hbh ?asi)
                )
              (= ?hbg ?asi)
              )
            (and (and (not (= ?hbj ?hbi))
                (not (= ?hbj ?asi))
                )
              (not (= ?hbi ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hbk Real)
    (declare-const ?hbl Real)
    (declare-const ?hbm Real)
    (declare-const ?hbn Real)
    (declare-const ?hbo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hbp Real)
    (declare-const ?hbq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hbr Real)
    (declare-const ?hbs Real)
    (declare-const ?hbt Real)
    (declare-const ?hbu Real)
    (declare-const ?hbv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hbw Real)
    (declare-const ?hbx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?hby Real)
  (declare-const ?hbz Real)
  (declare-const ?hca Real)
  (declare-const ?hcb Real)
  (assert
    (or (or (= ?hca ?hbz)
        (= ?hca ?hby)
        )
      (= ?hbz ?hby)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?hcc Real)
    (declare-const ?hcd Real)
    (declare-const ?hce Real)
    (assert
      (or (or (= ?hce ?hcd)
          (= ?hce ?hcc)
          )
        (= ?hcd ?hcc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hcf Real)
    (declare-const ?hcg Real)
    (declare-const ?hch Real)
    (declare-const ?hci Real)
    (assert
      (or (or (= ?hci ?hch)
          (= ?hci ?hcg)
          )
        (= ?hch ?hcg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hcj Real)
    (declare-const ?hck Real)
    (declare-const ?hcl Real)
    (declare-const ?hcm Real)
    (declare-const ?hcn Real)
    (assert
      (or (or (= ?hcn ?hcm)
          (= ?hcn ?hcl)
          )
        (= ?hcm ?hcl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hco Real)
    (declare-const ?hcp Real)
    (declare-const ?hcq Real)
    (declare-const ?hcr Real)
    (declare-const ?hcs Real)
    (declare-const ?hct Real)
    (assert
      (and (and (and (not (= ?hcq ?hcp))
            (not (= ?hcq ?hco))
            )
          (not (= ?hcp ?hco))
          )
        (or (or (= ?hct ?hcs)
            (= ?hct ?hcr)
            )
          (= ?hcs ?hcr)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hcu Real)
    (declare-const ?hcv Real)
    (declare-const ?hcw Real)
    (assert
      (or (or (= ?hcw ?hcv)
          (= ?hcw ?hcu)
          )
        (= ?hcv ?hcu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hcx Real)
    (declare-const ?hcy Real)
    (declare-const ?hcz Real)
    (assert
      (or (or (= ?hcz ?hcy)
          (= ?hcz ?hcx)
          )
        (= ?hcy ?hcx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hda Real)
    (declare-const ?hdb Real)
    (declare-const ?hdc Real)
    (declare-const ?hdd Real)
    (assert
      (or (or (= ?hdc ?hdb)
          (= ?hdc ?hda)
          )
        (= ?hdb ?hda)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hde Real)
    (declare-const ?hdf Real)
    (declare-const ?hdg Real)
    (declare-const ?hdh Real)
    (declare-const ?hdi Real)
    (assert
      (or (or (= ?hdg ?hdf)
          (= ?hdg ?hde)
          )
        (= ?hdf ?hde)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hdj Real)
    (declare-const ?hdk Real)
    (declare-const ?hdl Real)
    (declare-const ?hdm Real)
    (declare-const ?hdn Real)
    (declare-const ?hdo Real)
    (assert
      (and (or (or (= ?hdl ?hdk)
            (= ?hdl ?hdj)
            )
          (= ?hdk ?hdj)
          )
        (and (and (not (= ?hdo ?hdn))
            (not (= ?hdo ?hdm))
            )
          (not (= ?hdn ?hdm))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hdp Real)
    (declare-const ?hdq Real)
    (declare-const ?hdr Real)
    (assert
      (or (or (= ?hdr ?hdq)
          (= ?hdr ?hdp)
          )
        (= ?hdq ?hdp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hds Real)
    (declare-const ?hdt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hdu Real)
    (declare-const ?hdv Real)
    (declare-const ?hdw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hdx Real)
    (declare-const ?hdy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hdz Real)
    (declare-const ?hea Real)
    (declare-const ?heb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hec Real)
    (declare-const ?hed Real)
    (declare-const ?hee Real)
    (declare-const ?hef Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?hed ?hec))
                (not (= ?hed ?asi))
                )
              (not (= ?hec ?asi))
              )
            (or (or (= ?hef ?hee)
                (= ?hef ?asi)
                )
              (= ?hee ?asi)
              )
            )
          (and (or (or (= ?hed ?hec)
                (= ?hed ?asi)
                )
              (= ?hec ?asi)
              )
            (and (and (not (= ?hef ?hee))
                (not (= ?hef ?asi))
                )
              (not (= ?hee ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?heg Real)
    (declare-const ?heh Real)
    (declare-const ?hei Real)
    (declare-const ?hej Real)
    (declare-const ?hek Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hel Real)
    (declare-const ?hem Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hen Real)
    (declare-const ?heo Real)
    (declare-const ?hep Real)
    (declare-const ?heq Real)
    (declare-const ?her Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hes Real)
    (declare-const ?het Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?heu Real)
  (declare-const ?hev Real)
  (declare-const ?hew Real)
  (declare-const ?hex Real)
  (declare-const ?hey Real)
  (assert
    (or (or (= ?hew ?hev)
        (= ?hew ?heu)
        )
      (= ?hev ?heu)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?hez Real)
    (declare-const ?hfa Real)
    (declare-const ?hfb Real)
    (assert
      (or (or (= ?hfb ?hfa)
          (= ?hfb ?hez)
          )
        (= ?hfa ?hez)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hfc Real)
    (declare-const ?hfd Real)
    (declare-const ?hfe Real)
    (declare-const ?hff Real)
    (assert
      (or (or (= ?hff ?hfe)
          (= ?hff ?hfd)
          )
        (= ?hfe ?hfd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hfg Real)
    (declare-const ?hfh Real)
    (declare-const ?hfi Real)
    (declare-const ?hfj Real)
    (declare-const ?hfk Real)
    (assert
      (or (or (= ?hfk ?hfj)
          (= ?hfk ?hfi)
          )
        (= ?hfj ?hfi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hfl Real)
    (declare-const ?hfm Real)
    (declare-const ?hfn Real)
    (declare-const ?hfo Real)
    (declare-const ?hfp Real)
    (declare-const ?hfq Real)
    (assert
      (and (and (and (not (= ?hfn ?hfm))
            (not (= ?hfn ?hfl))
            )
          (not (= ?hfm ?hfl))
          )
        (or (or (= ?hfq ?hfp)
            (= ?hfq ?hfo)
            )
          (= ?hfp ?hfo)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hfr Real)
    (declare-const ?hfs Real)
    (declare-const ?hft Real)
    (assert
      (or (or (= ?hft ?hfs)
          (= ?hft ?hfr)
          )
        (= ?hfs ?hfr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hfu Real)
    (declare-const ?hfv Real)
    (declare-const ?hfw Real)
    (assert
      (or (or (= ?hfw ?hfv)
          (= ?hfw ?hfu)
          )
        (= ?hfv ?hfu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hfx Real)
    (declare-const ?hfy Real)
    (declare-const ?hfz Real)
    (declare-const ?hga Real)
    (assert
      (or (or (= ?hfz ?hfy)
          (= ?hfz ?hfx)
          )
        (= ?hfy ?hfx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hgb Real)
    (declare-const ?hgc Real)
    (declare-const ?hgd Real)
    (declare-const ?hge Real)
    (declare-const ?hgf Real)
    (assert
      (or (or (= ?hgd ?hgc)
          (= ?hgd ?hgb)
          )
        (= ?hgc ?hgb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hgg Real)
    (declare-const ?hgh Real)
    (declare-const ?hgi Real)
    (declare-const ?hgj Real)
    (declare-const ?hgk Real)
    (declare-const ?hgl Real)
    (assert
      (and (or (or (= ?hgi ?hgh)
            (= ?hgi ?hgg)
            )
          (= ?hgh ?hgg)
          )
        (and (and (not (= ?hgl ?hgk))
            (not (= ?hgl ?hgj))
            )
          (not (= ?hgk ?hgj))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hgm Real)
    (declare-const ?hgn Real)
    (declare-const ?hgo Real)
    (assert
      (or (or (= ?hgo ?hgn)
          (= ?hgo ?hgm)
          )
        (= ?hgn ?hgm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hgp Real)
    (declare-const ?hgq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hgr Real)
    (declare-const ?hgs Real)
    (declare-const ?hgt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hgu Real)
    (declare-const ?hgv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hgw Real)
    (declare-const ?hgx Real)
    (declare-const ?hgy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hgz Real)
    (declare-const ?hha Real)
    (declare-const ?hhb Real)
    (declare-const ?hhc Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?hha ?hgz))
                (not (= ?hha ?asi))
                )
              (not (= ?hgz ?asi))
              )
            (or (or (= ?hhc ?hhb)
                (= ?hhc ?asi)
                )
              (= ?hhb ?asi)
              )
            )
          (and (or (or (= ?hha ?hgz)
                (= ?hha ?asi)
                )
              (= ?hgz ?asi)
              )
            (and (and (not (= ?hhc ?hhb))
                (not (= ?hhc ?asi))
                )
              (not (= ?hhb ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hhd Real)
    (declare-const ?hhe Real)
    (declare-const ?hhf Real)
    (declare-const ?hhg Real)
    (declare-const ?hhh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hhi Real)
    (declare-const ?hhj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hhk Real)
    (declare-const ?hhl Real)
    (declare-const ?hhm Real)
    (declare-const ?hhn Real)
    (declare-const ?hho Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hhp Real)
    (declare-const ?hhq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?hhr Real)
  (declare-const ?hhs Real)
  (declare-const ?hht Real)
  (declare-const ?hhu Real)
  (declare-const ?hhv Real)
  (declare-const ?hhw Real)
  (assert
    (and (or (or (= ?hht ?hhs)
          (= ?hht ?hhr)
          )
        (= ?hhs ?hhr)
        )
      (and (and (not (= ?hhw ?hhv))
          (not (= ?hhw ?hhu))
          )
        (not (= ?hhv ?hhu))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?hhx Real)
    (declare-const ?hhy Real)
    (declare-const ?hhz Real)
    (assert
      (or (or (= ?hhz ?hhy)
          (= ?hhz ?hhx)
          )
        (= ?hhy ?hhx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hia Real)
    (declare-const ?hib Real)
    (declare-const ?hic Real)
    (declare-const ?hid Real)
    (assert
      (or (or (= ?hid ?hic)
          (= ?hid ?hib)
          )
        (= ?hic ?hib)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hie Real)
    (declare-const ?hif Real)
    (declare-const ?hig Real)
    (declare-const ?hih Real)
    (declare-const ?hii Real)
    (assert
      (or (or (= ?hii ?hih)
          (= ?hii ?hig)
          )
        (= ?hih ?hig)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hij Real)
    (declare-const ?hik Real)
    (declare-const ?hil Real)
    (declare-const ?him Real)
    (declare-const ?hin Real)
    (declare-const ?hio Real)
    (assert
      (and (and (and (not (= ?hil ?hik))
            (not (= ?hil ?hij))
            )
          (not (= ?hik ?hij))
          )
        (or (or (= ?hio ?hin)
            (= ?hio ?him)
            )
          (= ?hin ?him)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hip Real)
    (declare-const ?hiq Real)
    (declare-const ?hir Real)
    (assert
      (or (or (= ?hir ?hiq)
          (= ?hir ?hip)
          )
        (= ?hiq ?hip)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?his Real)
    (declare-const ?hit Real)
    (declare-const ?hiu Real)
    (assert
      (or (or (= ?hiu ?hit)
          (= ?hiu ?his)
          )
        (= ?hit ?his)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hiv Real)
    (declare-const ?hiw Real)
    (declare-const ?hix Real)
    (declare-const ?hiy Real)
    (assert
      (or (or (= ?hix ?hiw)
          (= ?hix ?hiv)
          )
        (= ?hiw ?hiv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hiz Real)
    (declare-const ?hja Real)
    (declare-const ?hjb Real)
    (declare-const ?hjc Real)
    (declare-const ?hjd Real)
    (assert
      (or (or (= ?hjb ?hja)
          (= ?hjb ?hiz)
          )
        (= ?hja ?hiz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hje Real)
    (declare-const ?hjf Real)
    (declare-const ?hjg Real)
    (declare-const ?hjh Real)
    (declare-const ?hji Real)
    (declare-const ?hjj Real)
    (assert
      (and (or (or (= ?hjg ?hjf)
            (= ?hjg ?hje)
            )
          (= ?hjf ?hje)
          )
        (and (and (not (= ?hjj ?hji))
            (not (= ?hjj ?hjh))
            )
          (not (= ?hji ?hjh))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hjk Real)
    (declare-const ?hjl Real)
    (declare-const ?hjm Real)
    (assert
      (or (or (= ?hjm ?hjl)
          (= ?hjm ?hjk)
          )
        (= ?hjl ?hjk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hjn Real)
    (declare-const ?hjo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hjp Real)
    (declare-const ?hjq Real)
    (declare-const ?hjr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hjs Real)
    (declare-const ?hjt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hju Real)
    (declare-const ?hjv Real)
    (declare-const ?hjw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hjx Real)
    (declare-const ?hjy Real)
    (declare-const ?hjz Real)
    (declare-const ?hka Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?hjy ?hjx))
                (not (= ?hjy ?asi))
                )
              (not (= ?hjx ?asi))
              )
            (or (or (= ?hka ?hjz)
                (= ?hka ?asi)
                )
              (= ?hjz ?asi)
              )
            )
          (and (or (or (= ?hjy ?hjx)
                (= ?hjy ?asi)
                )
              (= ?hjx ?asi)
              )
            (and (and (not (= ?hka ?hjz))
                (not (= ?hka ?asi))
                )
              (not (= ?hjz ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hkb Real)
    (declare-const ?hkc Real)
    (declare-const ?hkd Real)
    (declare-const ?hke Real)
    (declare-const ?hkf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hkg Real)
    (declare-const ?hkh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hki Real)
    (declare-const ?hkj Real)
    (declare-const ?hkk Real)
    (declare-const ?hkl Real)
    (declare-const ?hkm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hkn Real)
    (declare-const ?hko Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?hkp Real)
  (declare-const ?hkq Real)
  (declare-const ?hkr Real)
  (assert
    (or (or (= ?hkr ?hkq)
        (= ?hkr ?hkp)
        )
      (= ?hkq ?hkp)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?hks Real)
    (declare-const ?hkt Real)
    (declare-const ?hku Real)
    (assert
      (or (or (= ?hku ?hkt)
          (= ?hku ?hks)
          )
        (= ?hkt ?hks)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hkv Real)
    (declare-const ?hkw Real)
    (declare-const ?hkx Real)
    (declare-const ?hky Real)
    (assert
      (or (or (= ?hky ?hkx)
          (= ?hky ?hkw)
          )
        (= ?hkx ?hkw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hkz Real)
    (declare-const ?hla Real)
    (declare-const ?hlb Real)
    (declare-const ?hlc Real)
    (declare-const ?hld Real)
    (assert
      (or (or (= ?hld ?hlc)
          (= ?hld ?hlb)
          )
        (= ?hlc ?hlb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hle Real)
    (declare-const ?hlf Real)
    (declare-const ?hlg Real)
    (declare-const ?hlh Real)
    (declare-const ?hli Real)
    (declare-const ?hlj Real)
    (assert
      (and (and (and (not (= ?hlg ?hlf))
            (not (= ?hlg ?hle))
            )
          (not (= ?hlf ?hle))
          )
        (or (or (= ?hlj ?hli)
            (= ?hlj ?hlh)
            )
          (= ?hli ?hlh)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hlk Real)
    (declare-const ?hll Real)
    (declare-const ?hlm Real)
    (assert
      (or (or (= ?hlm ?hll)
          (= ?hlm ?hlk)
          )
        (= ?hll ?hlk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hln Real)
    (declare-const ?hlo Real)
    (declare-const ?hlp Real)
    (assert
      (or (or (= ?hlp ?hlo)
          (= ?hlp ?hln)
          )
        (= ?hlo ?hln)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hlq Real)
    (declare-const ?hlr Real)
    (declare-const ?hls Real)
    (declare-const ?hlt Real)
    (assert
      (or (or (= ?hls ?hlr)
          (= ?hls ?hlq)
          )
        (= ?hlr ?hlq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hlu Real)
    (declare-const ?hlv Real)
    (declare-const ?hlw Real)
    (declare-const ?hlx Real)
    (declare-const ?hly Real)
    (assert
      (or (or (= ?hlw ?hlv)
          (= ?hlw ?hlu)
          )
        (= ?hlv ?hlu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hlz Real)
    (declare-const ?hma Real)
    (declare-const ?hmb Real)
    (declare-const ?hmc Real)
    (declare-const ?hmd Real)
    (declare-const ?hme Real)
    (assert
      (and (or (or (= ?hmb ?hma)
            (= ?hmb ?hlz)
            )
          (= ?hma ?hlz)
          )
        (and (and (not (= ?hme ?hmd))
            (not (= ?hme ?hmc))
            )
          (not (= ?hmd ?hmc))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hmf Real)
    (declare-const ?hmg Real)
    (declare-const ?hmh Real)
    (assert
      (or (or (= ?hmh ?hmg)
          (= ?hmh ?hmf)
          )
        (= ?hmg ?hmf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hmi Real)
    (declare-const ?hmj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hmk Real)
    (declare-const ?hml Real)
    (declare-const ?hmm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hmn Real)
    (declare-const ?hmo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hmp Real)
    (declare-const ?hmq Real)
    (declare-const ?hmr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hms Real)
    (declare-const ?hmt Real)
    (declare-const ?hmu Real)
    (declare-const ?hmv Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?hmt ?hms))
                (not (= ?hmt ?asi))
                )
              (not (= ?hms ?asi))
              )
            (or (or (= ?hmv ?hmu)
                (= ?hmv ?asi)
                )
              (= ?hmu ?asi)
              )
            )
          (and (or (or (= ?hmt ?hms)
                (= ?hmt ?asi)
                )
              (= ?hms ?asi)
              )
            (and (and (not (= ?hmv ?hmu))
                (not (= ?hmv ?asi))
                )
              (not (= ?hmu ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hmw Real)
    (declare-const ?hmx Real)
    (declare-const ?hmy Real)
    (declare-const ?hmz Real)
    (declare-const ?hna Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hnb Real)
    (declare-const ?hnc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hnd Real)
    (declare-const ?hne Real)
    (declare-const ?hnf Real)
    (declare-const ?hng Real)
    (declare-const ?hnh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hni Real)
    (declare-const ?hnj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?hnk Real)
  (declare-const ?hnl Real)
  (push 1)
    (declare-const ?hnm Real)
    (declare-const ?hnn Real)
    (declare-const ?hno Real)
    (assert
      (or (or (= ?hno ?hnn)
          (= ?hno ?hnm)
          )
        (= ?hnn ?hnm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hnp Real)
    (declare-const ?hnq Real)
    (declare-const ?hnr Real)
    (declare-const ?hns Real)
    (assert
      (or (or (= ?hns ?hnr)
          (= ?hns ?hnq)
          )
        (= ?hnr ?hnq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hnt Real)
    (declare-const ?hnu Real)
    (declare-const ?hnv Real)
    (declare-const ?hnw Real)
    (declare-const ?hnx Real)
    (assert
      (or (or (= ?hnx ?hnw)
          (= ?hnx ?hnv)
          )
        (= ?hnw ?hnv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hny Real)
    (declare-const ?hnz Real)
    (declare-const ?hoa Real)
    (declare-const ?hob Real)
    (declare-const ?hoc Real)
    (declare-const ?hod Real)
    (assert
      (and (and (and (not (= ?hoa ?hnz))
            (not (= ?hoa ?hny))
            )
          (not (= ?hnz ?hny))
          )
        (or (or (= ?hod ?hoc)
            (= ?hod ?hob)
            )
          (= ?hoc ?hob)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hoe Real)
    (declare-const ?hof Real)
    (declare-const ?hog Real)
    (assert
      (or (or (= ?hog ?hof)
          (= ?hog ?hoe)
          )
        (= ?hof ?hoe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hoh Real)
    (declare-const ?hoi Real)
    (declare-const ?hoj Real)
    (assert
      (or (or (= ?hoj ?hoi)
          (= ?hoj ?hoh)
          )
        (= ?hoi ?hoh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hok Real)
    (declare-const ?hol Real)
    (declare-const ?hom Real)
    (declare-const ?hon Real)
    (assert
      (or (or (= ?hom ?hol)
          (= ?hom ?hok)
          )
        (= ?hol ?hok)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hoo Real)
    (declare-const ?hop Real)
    (declare-const ?hoq Real)
    (declare-const ?hor Real)
    (declare-const ?hos Real)
    (assert
      (or (or (= ?hoq ?hop)
          (= ?hoq ?hoo)
          )
        (= ?hop ?hoo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hot Real)
    (declare-const ?hou Real)
    (declare-const ?hov Real)
    (declare-const ?how Real)
    (declare-const ?hox Real)
    (declare-const ?hoy Real)
    (assert
      (and (or (or (= ?hov ?hou)
            (= ?hov ?hot)
            )
          (= ?hou ?hot)
          )
        (and (and (not (= ?hoy ?hox))
            (not (= ?hoy ?how))
            )
          (not (= ?hox ?how))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hoz Real)
    (declare-const ?hpa Real)
    (declare-const ?hpb Real)
    (assert
      (or (or (= ?hpb ?hpa)
          (= ?hpb ?hoz)
          )
        (= ?hpa ?hoz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hpc Real)
    (declare-const ?hpd Real)
    (declare-const ?hpe Real)
    (declare-const ?hpf Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?hpd ?hpc))
                (not (= ?hpd ?asi))
                )
              (not (= ?hpc ?asi))
              )
            (or (or (= ?hpf ?hpe)
                (= ?hpf ?asi)
                )
              (= ?hpe ?asi)
              )
            )
          (and (or (or (= ?hpd ?hpc)
                (= ?hpd ?asi)
                )
              (= ?hpc ?asi)
              )
            (and (and (not (= ?hpf ?hpe))
                (not (= ?hpf ?asi))
                )
              (not (= ?hpe ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?hpg Real)
  (declare-const ?hph Real)
  (declare-const ?hpi Real)
  (push 1)
    (declare-const ?hpj Real)
    (declare-const ?hpk Real)
    (declare-const ?hpl Real)
    (assert
      (or (or (= ?hpl ?hpk)
          (= ?hpl ?hpj)
          )
        (= ?hpk ?hpj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hpm Real)
    (declare-const ?hpn Real)
    (declare-const ?hpo Real)
    (declare-const ?hpp Real)
    (assert
      (or (or (= ?hpp ?hpo)
          (= ?hpp ?hpn)
          )
        (= ?hpo ?hpn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hpq Real)
    (declare-const ?hpr Real)
    (declare-const ?hps Real)
    (declare-const ?hpt Real)
    (declare-const ?hpu Real)
    (assert
      (or (or (= ?hpu ?hpt)
          (= ?hpu ?hps)
          )
        (= ?hpt ?hps)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hpv Real)
    (declare-const ?hpw Real)
    (declare-const ?hpx Real)
    (declare-const ?hpy Real)
    (declare-const ?hpz Real)
    (declare-const ?hqa Real)
    (assert
      (and (and (and (not (= ?hpx ?hpw))
            (not (= ?hpx ?hpv))
            )
          (not (= ?hpw ?hpv))
          )
        (or (or (= ?hqa ?hpz)
            (= ?hqa ?hpy)
            )
          (= ?hpz ?hpy)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hqb Real)
    (declare-const ?hqc Real)
    (declare-const ?hqd Real)
    (assert
      (or (or (= ?hqd ?hqc)
          (= ?hqd ?hqb)
          )
        (= ?hqc ?hqb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hqe Real)
    (declare-const ?hqf Real)
    (declare-const ?hqg Real)
    (assert
      (or (or (= ?hqg ?hqf)
          (= ?hqg ?hqe)
          )
        (= ?hqf ?hqe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hqh Real)
    (declare-const ?hqi Real)
    (declare-const ?hqj Real)
    (declare-const ?hqk Real)
    (assert
      (or (or (= ?hqj ?hqi)
          (= ?hqj ?hqh)
          )
        (= ?hqi ?hqh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hql Real)
    (declare-const ?hqm Real)
    (declare-const ?hqn Real)
    (declare-const ?hqo Real)
    (declare-const ?hqp Real)
    (assert
      (or (or (= ?hqn ?hqm)
          (= ?hqn ?hql)
          )
        (= ?hqm ?hql)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hqq Real)
    (declare-const ?hqr Real)
    (declare-const ?hqs Real)
    (declare-const ?hqt Real)
    (declare-const ?hqu Real)
    (declare-const ?hqv Real)
    (assert
      (and (or (or (= ?hqs ?hqr)
            (= ?hqs ?hqq)
            )
          (= ?hqr ?hqq)
          )
        (and (and (not (= ?hqv ?hqu))
            (not (= ?hqv ?hqt))
            )
          (not (= ?hqu ?hqt))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hqw Real)
    (declare-const ?hqx Real)
    (declare-const ?hqy Real)
    (assert
      (or (or (= ?hqy ?hqx)
          (= ?hqy ?hqw)
          )
        (= ?hqx ?hqw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hqz Real)
    (declare-const ?hra Real)
    (declare-const ?hrb Real)
    (declare-const ?hrc Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?hra ?hqz))
                (not (= ?hra ?asi))
                )
              (not (= ?hqz ?asi))
              )
            (or (or (= ?hrc ?hrb)
                (= ?hrc ?asi)
                )
              (= ?hrb ?asi)
              )
            )
          (and (or (or (= ?hra ?hqz)
                (= ?hra ?asi)
                )
              (= ?hqz ?asi)
              )
            (and (and (not (= ?hrc ?hrb))
                (not (= ?hrc ?asi))
                )
              (not (= ?hrb ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?hrd Real)
  (declare-const ?hre Real)
  (push 1)
    (declare-const ?hrf Real)
    (declare-const ?hrg Real)
    (declare-const ?hrh Real)
    (assert
      (or (or (= ?hrh ?hrg)
          (= ?hrh ?hrf)
          )
        (= ?hrg ?hrf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hri Real)
    (declare-const ?hrj Real)
    (declare-const ?hrk Real)
    (declare-const ?hrl Real)
    (assert
      (or (or (= ?hrl ?hrk)
          (= ?hrl ?hrj)
          )
        (= ?hrk ?hrj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hrm Real)
    (declare-const ?hrn Real)
    (declare-const ?hro Real)
    (declare-const ?hrp Real)
    (declare-const ?hrq Real)
    (assert
      (or (or (= ?hrq ?hrp)
          (= ?hrq ?hro)
          )
        (= ?hrp ?hro)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hrr Real)
    (declare-const ?hrs Real)
    (declare-const ?hrt Real)
    (declare-const ?hru Real)
    (declare-const ?hrv Real)
    (declare-const ?hrw Real)
    (assert
      (and (and (and (not (= ?hrt ?hrs))
            (not (= ?hrt ?hrr))
            )
          (not (= ?hrs ?hrr))
          )
        (or (or (= ?hrw ?hrv)
            (= ?hrw ?hru)
            )
          (= ?hrv ?hru)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hrx Real)
    (declare-const ?hry Real)
    (declare-const ?hrz Real)
    (assert
      (or (or (= ?hrz ?hry)
          (= ?hrz ?hrx)
          )
        (= ?hry ?hrx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hsa Real)
    (declare-const ?hsb Real)
    (declare-const ?hsc Real)
    (assert
      (or (or (= ?hsc ?hsb)
          (= ?hsc ?hsa)
          )
        (= ?hsb ?hsa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hsd Real)
    (declare-const ?hse Real)
    (declare-const ?hsf Real)
    (declare-const ?hsg Real)
    (assert
      (or (or (= ?hsf ?hse)
          (= ?hsf ?hsd)
          )
        (= ?hse ?hsd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hsh Real)
    (declare-const ?hsi Real)
    (declare-const ?hsj Real)
    (declare-const ?hsk Real)
    (declare-const ?hsl Real)
    (assert
      (or (or (= ?hsj ?hsi)
          (= ?hsj ?hsh)
          )
        (= ?hsi ?hsh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hsm Real)
    (declare-const ?hsn Real)
    (declare-const ?hso Real)
    (declare-const ?hsp Real)
    (declare-const ?hsq Real)
    (declare-const ?hsr Real)
    (assert
      (and (or (or (= ?hso ?hsn)
            (= ?hso ?hsm)
            )
          (= ?hsn ?hsm)
          )
        (and (and (not (= ?hsr ?hsq))
            (not (= ?hsr ?hsp))
            )
          (not (= ?hsq ?hsp))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hss Real)
    (declare-const ?hst Real)
    (declare-const ?hsu Real)
    (assert
      (or (or (= ?hsu ?hst)
          (= ?hsu ?hss)
          )
        (= ?hst ?hss)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hsv Real)
    (declare-const ?hsw Real)
    (declare-const ?hsx Real)
    (declare-const ?hsy Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?hsw ?hsv))
                (not (= ?hsw ?asi))
                )
              (not (= ?hsv ?asi))
              )
            (or (or (= ?hsy ?hsx)
                (= ?hsy ?asi)
                )
              (= ?hsx ?asi)
              )
            )
          (and (or (or (= ?hsw ?hsv)
                (= ?hsw ?asi)
                )
              (= ?hsv ?asi)
              )
            (and (and (not (= ?hsy ?hsx))
                (not (= ?hsy ?asi))
                )
              (not (= ?hsx ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?hsz Real)
  (declare-const ?hta Real)
  (declare-const ?htb Real)
  (push 1)
    (declare-const ?htc Real)
    (declare-const ?htd Real)
    (declare-const ?hte Real)
    (assert
      (or (or (= ?hte ?htd)
          (= ?hte ?htc)
          )
        (= ?htd ?htc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?htf Real)
    (declare-const ?htg Real)
    (declare-const ?hth Real)
    (declare-const ?hti Real)
    (assert
      (or (or (= ?hti ?hth)
          (= ?hti ?htg)
          )
        (= ?hth ?htg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?htj Real)
    (declare-const ?htk Real)
    (declare-const ?htl Real)
    (declare-const ?htm Real)
    (declare-const ?htn Real)
    (assert
      (or (or (= ?htn ?htm)
          (= ?htn ?htl)
          )
        (= ?htm ?htl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hto Real)
    (declare-const ?htp Real)
    (declare-const ?htq Real)
    (declare-const ?htr Real)
    (declare-const ?hts Real)
    (declare-const ?htt Real)
    (assert
      (and (and (and (not (= ?htq ?htp))
            (not (= ?htq ?hto))
            )
          (not (= ?htp ?hto))
          )
        (or (or (= ?htt ?hts)
            (= ?htt ?htr)
            )
          (= ?hts ?htr)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?htu Real)
    (declare-const ?htv Real)
    (declare-const ?htw Real)
    (assert
      (or (or (= ?htw ?htv)
          (= ?htw ?htu)
          )
        (= ?htv ?htu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?htx Real)
    (declare-const ?hty Real)
    (declare-const ?htz Real)
    (assert
      (or (or (= ?htz ?hty)
          (= ?htz ?htx)
          )
        (= ?hty ?htx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hua Real)
    (declare-const ?hub Real)
    (declare-const ?huc Real)
    (declare-const ?hud Real)
    (assert
      (or (or (= ?huc ?hub)
          (= ?huc ?hua)
          )
        (= ?hub ?hua)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hue Real)
    (declare-const ?huf Real)
    (declare-const ?hug Real)
    (declare-const ?huh Real)
    (declare-const ?hui Real)
    (assert
      (or (or (= ?hug ?huf)
          (= ?hug ?hue)
          )
        (= ?huf ?hue)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?huj Real)
    (declare-const ?huk Real)
    (declare-const ?hul Real)
    (declare-const ?hum Real)
    (declare-const ?hun Real)
    (declare-const ?huo Real)
    (assert
      (and (or (or (= ?hul ?huk)
            (= ?hul ?huj)
            )
          (= ?huk ?huj)
          )
        (and (and (not (= ?huo ?hun))
            (not (= ?huo ?hum))
            )
          (not (= ?hun ?hum))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hup Real)
    (declare-const ?huq Real)
    (declare-const ?hur Real)
    (assert
      (or (or (= ?hur ?huq)
          (= ?hur ?hup)
          )
        (= ?huq ?hup)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hus Real)
    (declare-const ?hut Real)
    (declare-const ?huu Real)
    (declare-const ?huv Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?hut ?hus))
                (not (= ?hut ?asi))
                )
              (not (= ?hus ?asi))
              )
            (or (or (= ?huv ?huu)
                (= ?huv ?asi)
                )
              (= ?huu ?asi)
              )
            )
          (and (or (or (= ?hut ?hus)
                (= ?hut ?asi)
                )
              (= ?hus ?asi)
              )
            (and (and (not (= ?huv ?huu))
                (not (= ?huv ?asi))
                )
              (not (= ?huu ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?huw Real)
  (declare-const ?hux Real)
  (declare-const ?huy Real)
  (declare-const ?huz Real)
  (assert
    (exists ((?asi Real) )(or (and (and (and (not (= ?hux ?huw))
              (not (= ?hux ?asi))
              )
            (not (= ?huw ?asi))
            )
          (or (or (= ?huz ?huy)
              (= ?huz ?asi)
              )
            (= ?huy ?asi)
            )
          )
        (and (or (or (= ?hux ?huw)
              (= ?hux ?asi)
              )
            (= ?huw ?asi)
            )
          (and (and (not (= ?huz ?huy))
              (not (= ?huz ?asi))
              )
            (not (= ?huy ?asi))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?hva Real)
    (declare-const ?hvb Real)
    (declare-const ?hvc Real)
    (assert
      (or (or (= ?hvc ?hvb)
          (= ?hvc ?hva)
          )
        (= ?hvb ?hva)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hvd Real)
    (declare-const ?hve Real)
    (declare-const ?hvf Real)
    (declare-const ?hvg Real)
    (assert
      (or (or (= ?hvg ?hvf)
          (= ?hvg ?hve)
          )
        (= ?hvf ?hve)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hvh Real)
    (declare-const ?hvi Real)
    (declare-const ?hvj Real)
    (declare-const ?hvk Real)
    (declare-const ?hvl Real)
    (assert
      (or (or (= ?hvl ?hvk)
          (= ?hvl ?hvj)
          )
        (= ?hvk ?hvj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hvm Real)
    (declare-const ?hvn Real)
    (declare-const ?hvo Real)
    (declare-const ?hvp Real)
    (declare-const ?hvq Real)
    (declare-const ?hvr Real)
    (assert
      (and (and (and (not (= ?hvo ?hvn))
            (not (= ?hvo ?hvm))
            )
          (not (= ?hvn ?hvm))
          )
        (or (or (= ?hvr ?hvq)
            (= ?hvr ?hvp)
            )
          (= ?hvq ?hvp)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hvs Real)
    (declare-const ?hvt Real)
    (declare-const ?hvu Real)
    (assert
      (or (or (= ?hvu ?hvt)
          (= ?hvu ?hvs)
          )
        (= ?hvt ?hvs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hvv Real)
    (declare-const ?hvw Real)
    (declare-const ?hvx Real)
    (assert
      (or (or (= ?hvx ?hvw)
          (= ?hvx ?hvv)
          )
        (= ?hvw ?hvv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hvy Real)
    (declare-const ?hvz Real)
    (declare-const ?hwa Real)
    (declare-const ?hwb Real)
    (assert
      (or (or (= ?hwa ?hvz)
          (= ?hwa ?hvy)
          )
        (= ?hvz ?hvy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hwc Real)
    (declare-const ?hwd Real)
    (declare-const ?hwe Real)
    (declare-const ?hwf Real)
    (declare-const ?hwg Real)
    (assert
      (or (or (= ?hwe ?hwd)
          (= ?hwe ?hwc)
          )
        (= ?hwd ?hwc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hwh Real)
    (declare-const ?hwi Real)
    (declare-const ?hwj Real)
    (declare-const ?hwk Real)
    (declare-const ?hwl Real)
    (declare-const ?hwm Real)
    (assert
      (and (or (or (= ?hwj ?hwi)
            (= ?hwj ?hwh)
            )
          (= ?hwi ?hwh)
          )
        (and (and (not (= ?hwm ?hwl))
            (not (= ?hwm ?hwk))
            )
          (not (= ?hwl ?hwk))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hwn Real)
    (declare-const ?hwo Real)
    (declare-const ?hwp Real)
    (assert
      (or (or (= ?hwp ?hwo)
          (= ?hwp ?hwn)
          )
        (= ?hwo ?hwn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hwq Real)
    (declare-const ?hwr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hws Real)
    (declare-const ?hwt Real)
    (declare-const ?hwu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hwv Real)
    (declare-const ?hww Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hwx Real)
    (declare-const ?hwy Real)
    (declare-const ?hwz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hxa Real)
    (declare-const ?hxb Real)
    (declare-const ?hxc Real)
    (declare-const ?hxd Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?hxb ?hxa))
                (not (= ?hxb ?asi))
                )
              (not (= ?hxa ?asi))
              )
            (or (or (= ?hxd ?hxc)
                (= ?hxd ?asi)
                )
              (= ?hxc ?asi)
              )
            )
          (and (or (or (= ?hxb ?hxa)
                (= ?hxb ?asi)
                )
              (= ?hxa ?asi)
              )
            (and (and (not (= ?hxd ?hxc))
                (not (= ?hxd ?asi))
                )
              (not (= ?hxc ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hxe Real)
    (declare-const ?hxf Real)
    (declare-const ?hxg Real)
    (declare-const ?hxh Real)
    (declare-const ?hxi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hxj Real)
    (declare-const ?hxk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hxl Real)
    (declare-const ?hxm Real)
    (declare-const ?hxn Real)
    (declare-const ?hxo Real)
    (declare-const ?hxp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hxq Real)
    (declare-const ?hxr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?hxs Real)
  (declare-const ?hxt Real)
  (declare-const ?hxu Real)
  (declare-const ?hxv Real)
  (declare-const ?hxw Real)
  (push 1)
    (declare-const ?hxx Real)
    (declare-const ?hxy Real)
    (declare-const ?hxz Real)
    (assert
      (or (or (= ?hxz ?hxy)
          (= ?hxz ?hxx)
          )
        (= ?hxy ?hxx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hya Real)
    (declare-const ?hyb Real)
    (declare-const ?hyc Real)
    (declare-const ?hyd Real)
    (assert
      (or (or (= ?hyd ?hyc)
          (= ?hyd ?hyb)
          )
        (= ?hyc ?hyb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hye Real)
    (declare-const ?hyf Real)
    (declare-const ?hyg Real)
    (declare-const ?hyh Real)
    (declare-const ?hyi Real)
    (assert
      (or (or (= ?hyi ?hyh)
          (= ?hyi ?hyg)
          )
        (= ?hyh ?hyg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hyj Real)
    (declare-const ?hyk Real)
    (declare-const ?hyl Real)
    (declare-const ?hym Real)
    (declare-const ?hyn Real)
    (declare-const ?hyo Real)
    (assert
      (and (and (and (not (= ?hyl ?hyk))
            (not (= ?hyl ?hyj))
            )
          (not (= ?hyk ?hyj))
          )
        (or (or (= ?hyo ?hyn)
            (= ?hyo ?hym)
            )
          (= ?hyn ?hym)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hyp Real)
    (declare-const ?hyq Real)
    (declare-const ?hyr Real)
    (assert
      (or (or (= ?hyr ?hyq)
          (= ?hyr ?hyp)
          )
        (= ?hyq ?hyp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hys Real)
    (declare-const ?hyt Real)
    (declare-const ?hyu Real)
    (assert
      (or (or (= ?hyu ?hyt)
          (= ?hyu ?hys)
          )
        (= ?hyt ?hys)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hyv Real)
    (declare-const ?hyw Real)
    (declare-const ?hyx Real)
    (declare-const ?hyy Real)
    (assert
      (or (or (= ?hyx ?hyw)
          (= ?hyx ?hyv)
          )
        (= ?hyw ?hyv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hyz Real)
    (declare-const ?hza Real)
    (declare-const ?hzb Real)
    (declare-const ?hzc Real)
    (declare-const ?hzd Real)
    (assert
      (or (or (= ?hzb ?hza)
          (= ?hzb ?hyz)
          )
        (= ?hza ?hyz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hze Real)
    (declare-const ?hzf Real)
    (declare-const ?hzg Real)
    (declare-const ?hzh Real)
    (declare-const ?hzi Real)
    (declare-const ?hzj Real)
    (assert
      (and (or (or (= ?hzg ?hzf)
            (= ?hzg ?hze)
            )
          (= ?hzf ?hze)
          )
        (and (and (not (= ?hzj ?hzi))
            (not (= ?hzj ?hzh))
            )
          (not (= ?hzi ?hzh))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hzk Real)
    (declare-const ?hzl Real)
    (declare-const ?hzm Real)
    (assert
      (or (or (= ?hzm ?hzl)
          (= ?hzm ?hzk)
          )
        (= ?hzl ?hzk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hzn Real)
    (declare-const ?hzo Real)
    (declare-const ?hzp Real)
    (declare-const ?hzq Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?hzo ?hzn))
                (not (= ?hzo ?asi))
                )
              (not (= ?hzn ?asi))
              )
            (or (or (= ?hzq ?hzp)
                (= ?hzq ?asi)
                )
              (= ?hzp ?asi)
              )
            )
          (and (or (or (= ?hzo ?hzn)
                (= ?hzo ?asi)
                )
              (= ?hzn ?asi)
              )
            (and (and (not (= ?hzq ?hzp))
                (not (= ?hzq ?asi))
                )
              (not (= ?hzp ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?hzr Real)
  (declare-const ?hzs Real)
  (push 1)
    (declare-const ?hzt Real)
    (declare-const ?hzu Real)
    (declare-const ?hzv Real)
    (assert
      (or (or (= ?hzv ?hzu)
          (= ?hzv ?hzt)
          )
        (= ?hzu ?hzt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?hzw Real)
    (declare-const ?hzx Real)
    (declare-const ?hzy Real)
    (declare-const ?hzz Real)
    (assert
      (or (or (= ?hzz ?hzy)
          (= ?hzz ?hzx)
          )
        (= ?hzy ?hzx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iaa Real)
    (declare-const ?iab Real)
    (declare-const ?iac Real)
    (declare-const ?iad Real)
    (declare-const ?iae Real)
    (assert
      (or (or (= ?iae ?iad)
          (= ?iae ?iac)
          )
        (= ?iad ?iac)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iaf Real)
    (declare-const ?iag Real)
    (declare-const ?iah Real)
    (declare-const ?iai Real)
    (declare-const ?iaj Real)
    (declare-const ?iak Real)
    (assert
      (and (and (and (not (= ?iah ?iag))
            (not (= ?iah ?iaf))
            )
          (not (= ?iag ?iaf))
          )
        (or (or (= ?iak ?iaj)
            (= ?iak ?iai)
            )
          (= ?iaj ?iai)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ial Real)
    (declare-const ?iam Real)
    (declare-const ?ian Real)
    (assert
      (or (or (= ?ian ?iam)
          (= ?ian ?ial)
          )
        (= ?iam ?ial)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iao Real)
    (declare-const ?iap Real)
    (declare-const ?iaq Real)
    (assert
      (or (or (= ?iaq ?iap)
          (= ?iaq ?iao)
          )
        (= ?iap ?iao)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iar Real)
    (declare-const ?ias Real)
    (declare-const ?iat Real)
    (declare-const ?iau Real)
    (assert
      (or (or (= ?iat ?ias)
          (= ?iat ?iar)
          )
        (= ?ias ?iar)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iav Real)
    (declare-const ?iaw Real)
    (declare-const ?iax Real)
    (declare-const ?iay Real)
    (declare-const ?iaz Real)
    (assert
      (or (or (= ?iax ?iaw)
          (= ?iax ?iav)
          )
        (= ?iaw ?iav)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iba Real)
    (declare-const ?ibb Real)
    (declare-const ?ibc Real)
    (declare-const ?ibd Real)
    (declare-const ?ibe Real)
    (declare-const ?ibf Real)
    (assert
      (and (or (or (= ?ibc ?ibb)
            (= ?ibc ?iba)
            )
          (= ?ibb ?iba)
          )
        (and (and (not (= ?ibf ?ibe))
            (not (= ?ibf ?ibd))
            )
          (not (= ?ibe ?ibd))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ibg Real)
    (declare-const ?ibh Real)
    (declare-const ?ibi Real)
    (assert
      (or (or (= ?ibi ?ibh)
          (= ?ibi ?ibg)
          )
        (= ?ibh ?ibg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ibj Real)
    (declare-const ?ibk Real)
    (declare-const ?ibl Real)
    (declare-const ?ibm Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ibk ?ibj))
                (not (= ?ibk ?asi))
                )
              (not (= ?ibj ?asi))
              )
            (or (or (= ?ibm ?ibl)
                (= ?ibm ?asi)
                )
              (= ?ibl ?asi)
              )
            )
          (and (or (or (= ?ibk ?ibj)
                (= ?ibk ?asi)
                )
              (= ?ibj ?asi)
              )
            (and (and (not (= ?ibm ?ibl))
                (not (= ?ibm ?asi))
                )
              (not (= ?ibl ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ibn Real)
  (declare-const ?ibo Real)
  (declare-const ?ibp Real)
  (declare-const ?ibq Real)
  (declare-const ?ibr Real)
  (push 1)
    (declare-const ?ibs Real)
    (declare-const ?ibt Real)
    (declare-const ?ibu Real)
    (assert
      (or (or (= ?ibu ?ibt)
          (= ?ibu ?ibs)
          )
        (= ?ibt ?ibs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ibv Real)
    (declare-const ?ibw Real)
    (declare-const ?ibx Real)
    (declare-const ?iby Real)
    (assert
      (or (or (= ?iby ?ibx)
          (= ?iby ?ibw)
          )
        (= ?ibx ?ibw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ibz Real)
    (declare-const ?ica Real)
    (declare-const ?icb Real)
    (declare-const ?icc Real)
    (declare-const ?icd Real)
    (assert
      (or (or (= ?icd ?icc)
          (= ?icd ?icb)
          )
        (= ?icc ?icb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ice Real)
    (declare-const ?icf Real)
    (declare-const ?icg Real)
    (declare-const ?ich Real)
    (declare-const ?ici Real)
    (declare-const ?icj Real)
    (assert
      (and (and (and (not (= ?icg ?icf))
            (not (= ?icg ?ice))
            )
          (not (= ?icf ?ice))
          )
        (or (or (= ?icj ?ici)
            (= ?icj ?ich)
            )
          (= ?ici ?ich)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ick Real)
    (declare-const ?icl Real)
    (declare-const ?icm Real)
    (assert
      (or (or (= ?icm ?icl)
          (= ?icm ?ick)
          )
        (= ?icl ?ick)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?icn Real)
    (declare-const ?ico Real)
    (declare-const ?icp Real)
    (assert
      (or (or (= ?icp ?ico)
          (= ?icp ?icn)
          )
        (= ?ico ?icn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?icq Real)
    (declare-const ?icr Real)
    (declare-const ?ics Real)
    (declare-const ?ict Real)
    (assert
      (or (or (= ?ics ?icr)
          (= ?ics ?icq)
          )
        (= ?icr ?icq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?icu Real)
    (declare-const ?icv Real)
    (declare-const ?icw Real)
    (declare-const ?icx Real)
    (declare-const ?icy Real)
    (assert
      (or (or (= ?icw ?icv)
          (= ?icw ?icu)
          )
        (= ?icv ?icu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?icz Real)
    (declare-const ?ida Real)
    (declare-const ?idb Real)
    (declare-const ?idc Real)
    (declare-const ?idd Real)
    (declare-const ?ide Real)
    (assert
      (and (or (or (= ?idb ?ida)
            (= ?idb ?icz)
            )
          (= ?ida ?icz)
          )
        (and (and (not (= ?ide ?idd))
            (not (= ?ide ?idc))
            )
          (not (= ?idd ?idc))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?idf Real)
    (declare-const ?idg Real)
    (declare-const ?idh Real)
    (assert
      (or (or (= ?idh ?idg)
          (= ?idh ?idf)
          )
        (= ?idg ?idf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?idi Real)
    (declare-const ?idj Real)
    (declare-const ?idk Real)
    (declare-const ?idl Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?idj ?idi))
                (not (= ?idj ?asi))
                )
              (not (= ?idi ?asi))
              )
            (or (or (= ?idl ?idk)
                (= ?idl ?asi)
                )
              (= ?idk ?asi)
              )
            )
          (and (or (or (= ?idj ?idi)
                (= ?idj ?asi)
                )
              (= ?idi ?asi)
              )
            (and (and (not (= ?idl ?idk))
                (not (= ?idl ?asi))
                )
              (not (= ?idk ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?idm Real)
  (declare-const ?idn Real)
  (push 1)
    (declare-const ?ido Real)
    (declare-const ?idp Real)
    (declare-const ?idq Real)
    (assert
      (or (or (= ?idq ?idp)
          (= ?idq ?ido)
          )
        (= ?idp ?ido)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?idr Real)
    (declare-const ?ids Real)
    (declare-const ?idt Real)
    (declare-const ?idu Real)
    (assert
      (or (or (= ?idu ?idt)
          (= ?idu ?ids)
          )
        (= ?idt ?ids)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?idv Real)
    (declare-const ?idw Real)
    (declare-const ?idx Real)
    (declare-const ?idy Real)
    (declare-const ?idz Real)
    (assert
      (or (or (= ?idz ?idy)
          (= ?idz ?idx)
          )
        (= ?idy ?idx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iea Real)
    (declare-const ?ieb Real)
    (declare-const ?iec Real)
    (declare-const ?ied Real)
    (declare-const ?iee Real)
    (declare-const ?ief Real)
    (assert
      (and (and (and (not (= ?iec ?ieb))
            (not (= ?iec ?iea))
            )
          (not (= ?ieb ?iea))
          )
        (or (or (= ?ief ?iee)
            (= ?ief ?ied)
            )
          (= ?iee ?ied)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ieg Real)
    (declare-const ?ieh Real)
    (declare-const ?iei Real)
    (assert
      (or (or (= ?iei ?ieh)
          (= ?iei ?ieg)
          )
        (= ?ieh ?ieg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iej Real)
    (declare-const ?iek Real)
    (declare-const ?iel Real)
    (assert
      (or (or (= ?iel ?iek)
          (= ?iel ?iej)
          )
        (= ?iek ?iej)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iem Real)
    (declare-const ?ien Real)
    (declare-const ?ieo Real)
    (declare-const ?iep Real)
    (assert
      (or (or (= ?ieo ?ien)
          (= ?ieo ?iem)
          )
        (= ?ien ?iem)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ieq Real)
    (declare-const ?ier Real)
    (declare-const ?ies Real)
    (declare-const ?iet Real)
    (declare-const ?ieu Real)
    (assert
      (or (or (= ?ies ?ier)
          (= ?ies ?ieq)
          )
        (= ?ier ?ieq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iev Real)
    (declare-const ?iew Real)
    (declare-const ?iex Real)
    (declare-const ?iey Real)
    (declare-const ?iez Real)
    (declare-const ?ifa Real)
    (assert
      (and (or (or (= ?iex ?iew)
            (= ?iex ?iev)
            )
          (= ?iew ?iev)
          )
        (and (and (not (= ?ifa ?iez))
            (not (= ?ifa ?iey))
            )
          (not (= ?iez ?iey))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ifb Real)
    (declare-const ?ifc Real)
    (declare-const ?ifd Real)
    (assert
      (or (or (= ?ifd ?ifc)
          (= ?ifd ?ifb)
          )
        (= ?ifc ?ifb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ife Real)
    (declare-const ?iff Real)
    (declare-const ?ifg Real)
    (declare-const ?ifh Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?iff ?ife))
                (not (= ?iff ?asi))
                )
              (not (= ?ife ?asi))
              )
            (or (or (= ?ifh ?ifg)
                (= ?ifh ?asi)
                )
              (= ?ifg ?asi)
              )
            )
          (and (or (or (= ?iff ?ife)
                (= ?iff ?asi)
                )
              (= ?ife ?asi)
              )
            (and (and (not (= ?ifh ?ifg))
                (not (= ?ifh ?asi))
                )
              (not (= ?ifg ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ifi Real)
  (push 1)
    (declare-const ?ifj Real)
    (declare-const ?ifk Real)
    (declare-const ?ifl Real)
    (assert
      (or (or (= ?ifl ?ifk)
          (= ?ifl ?ifj)
          )
        (= ?ifk ?ifj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ifm Real)
    (declare-const ?ifn Real)
    (declare-const ?ifo Real)
    (declare-const ?ifp Real)
    (assert
      (or (or (= ?ifp ?ifo)
          (= ?ifp ?ifn)
          )
        (= ?ifo ?ifn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ifq Real)
    (declare-const ?ifr Real)
    (declare-const ?ifs Real)
    (declare-const ?ift Real)
    (declare-const ?ifu Real)
    (assert
      (or (or (= ?ifu ?ift)
          (= ?ifu ?ifs)
          )
        (= ?ift ?ifs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ifv Real)
    (declare-const ?ifw Real)
    (declare-const ?ifx Real)
    (declare-const ?ify Real)
    (declare-const ?ifz Real)
    (declare-const ?iga Real)
    (assert
      (and (and (and (not (= ?ifx ?ifw))
            (not (= ?ifx ?ifv))
            )
          (not (= ?ifw ?ifv))
          )
        (or (or (= ?iga ?ifz)
            (= ?iga ?ify)
            )
          (= ?ifz ?ify)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?igb Real)
    (declare-const ?igc Real)
    (declare-const ?igd Real)
    (assert
      (or (or (= ?igd ?igc)
          (= ?igd ?igb)
          )
        (= ?igc ?igb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ige Real)
    (declare-const ?igf Real)
    (declare-const ?igg Real)
    (assert
      (or (or (= ?igg ?igf)
          (= ?igg ?ige)
          )
        (= ?igf ?ige)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?igh Real)
    (declare-const ?igi Real)
    (declare-const ?igj Real)
    (declare-const ?igk Real)
    (assert
      (or (or (= ?igj ?igi)
          (= ?igj ?igh)
          )
        (= ?igi ?igh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?igl Real)
    (declare-const ?igm Real)
    (declare-const ?ign Real)
    (declare-const ?igo Real)
    (declare-const ?igp Real)
    (assert
      (or (or (= ?ign ?igm)
          (= ?ign ?igl)
          )
        (= ?igm ?igl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?igq Real)
    (declare-const ?igr Real)
    (declare-const ?igs Real)
    (declare-const ?igt Real)
    (declare-const ?igu Real)
    (declare-const ?igv Real)
    (assert
      (and (or (or (= ?igs ?igr)
            (= ?igs ?igq)
            )
          (= ?igr ?igq)
          )
        (and (and (not (= ?igv ?igu))
            (not (= ?igv ?igt))
            )
          (not (= ?igu ?igt))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?igw Real)
    (declare-const ?igx Real)
    (declare-const ?igy Real)
    (assert
      (or (or (= ?igy ?igx)
          (= ?igy ?igw)
          )
        (= ?igx ?igw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?igz Real)
    (declare-const ?iha Real)
    (declare-const ?ihb Real)
    (declare-const ?ihc Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?iha ?igz))
                (not (= ?iha ?asi))
                )
              (not (= ?igz ?asi))
              )
            (or (or (= ?ihc ?ihb)
                (= ?ihc ?asi)
                )
              (= ?ihb ?asi)
              )
            )
          (and (or (or (= ?iha ?igz)
                (= ?iha ?asi)
                )
              (= ?igz ?asi)
              )
            (and (and (not (= ?ihc ?ihb))
                (not (= ?ihc ?asi))
                )
              (not (= ?ihb ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ihd Real)
  (declare-const ?ihe Real)
  (push 1)
    (declare-const ?ihf Real)
    (declare-const ?ihg Real)
    (declare-const ?ihh Real)
    (assert
      (or (or (= ?ihh ?ihg)
          (= ?ihh ?ihf)
          )
        (= ?ihg ?ihf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ihi Real)
    (declare-const ?ihj Real)
    (declare-const ?ihk Real)
    (declare-const ?ihl Real)
    (assert
      (or (or (= ?ihl ?ihk)
          (= ?ihl ?ihj)
          )
        (= ?ihk ?ihj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ihm Real)
    (declare-const ?ihn Real)
    (declare-const ?iho Real)
    (declare-const ?ihp Real)
    (declare-const ?ihq Real)
    (assert
      (or (or (= ?ihq ?ihp)
          (= ?ihq ?iho)
          )
        (= ?ihp ?iho)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ihr Real)
    (declare-const ?ihs Real)
    (declare-const ?iht Real)
    (declare-const ?ihu Real)
    (declare-const ?ihv Real)
    (declare-const ?ihw Real)
    (assert
      (and (and (and (not (= ?iht ?ihs))
            (not (= ?iht ?ihr))
            )
          (not (= ?ihs ?ihr))
          )
        (or (or (= ?ihw ?ihv)
            (= ?ihw ?ihu)
            )
          (= ?ihv ?ihu)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ihx Real)
    (declare-const ?ihy Real)
    (declare-const ?ihz Real)
    (assert
      (or (or (= ?ihz ?ihy)
          (= ?ihz ?ihx)
          )
        (= ?ihy ?ihx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iia Real)
    (declare-const ?iib Real)
    (declare-const ?iic Real)
    (assert
      (or (or (= ?iic ?iib)
          (= ?iic ?iia)
          )
        (= ?iib ?iia)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iid Real)
    (declare-const ?iie Real)
    (declare-const ?iif Real)
    (declare-const ?iig Real)
    (assert
      (or (or (= ?iif ?iie)
          (= ?iif ?iid)
          )
        (= ?iie ?iid)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iih Real)
    (declare-const ?iii Real)
    (declare-const ?iij Real)
    (declare-const ?iik Real)
    (declare-const ?iil Real)
    (assert
      (or (or (= ?iij ?iii)
          (= ?iij ?iih)
          )
        (= ?iii ?iih)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iim Real)
    (declare-const ?iin Real)
    (declare-const ?iio Real)
    (declare-const ?iip Real)
    (declare-const ?iiq Real)
    (declare-const ?iir Real)
    (assert
      (and (or (or (= ?iio ?iin)
            (= ?iio ?iim)
            )
          (= ?iin ?iim)
          )
        (and (and (not (= ?iir ?iiq))
            (not (= ?iir ?iip))
            )
          (not (= ?iiq ?iip))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iis Real)
    (declare-const ?iit Real)
    (declare-const ?iiu Real)
    (assert
      (or (or (= ?iiu ?iit)
          (= ?iiu ?iis)
          )
        (= ?iit ?iis)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iiv Real)
    (declare-const ?iiw Real)
    (declare-const ?iix Real)
    (declare-const ?iiy Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?iiw ?iiv))
                (not (= ?iiw ?asi))
                )
              (not (= ?iiv ?asi))
              )
            (or (or (= ?iiy ?iix)
                (= ?iiy ?asi)
                )
              (= ?iix ?asi)
              )
            )
          (and (or (or (= ?iiw ?iiv)
                (= ?iiw ?asi)
                )
              (= ?iiv ?asi)
              )
            (and (and (not (= ?iiy ?iix))
                (not (= ?iiy ?asi))
                )
              (not (= ?iix ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?iiz Real)
  (push 1)
    (declare-const ?ija Real)
    (declare-const ?ijb Real)
    (declare-const ?ijc Real)
    (assert
      (or (or (= ?ijc ?ijb)
          (= ?ijc ?ija)
          )
        (= ?ijb ?ija)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ijd Real)
    (declare-const ?ije Real)
    (declare-const ?ijf Real)
    (declare-const ?ijg Real)
    (assert
      (or (or (= ?ijg ?ijf)
          (= ?ijg ?ije)
          )
        (= ?ijf ?ije)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ijh Real)
    (declare-const ?iji Real)
    (declare-const ?ijj Real)
    (declare-const ?ijk Real)
    (declare-const ?ijl Real)
    (assert
      (or (or (= ?ijl ?ijk)
          (= ?ijl ?ijj)
          )
        (= ?ijk ?ijj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ijm Real)
    (declare-const ?ijn Real)
    (declare-const ?ijo Real)
    (declare-const ?ijp Real)
    (declare-const ?ijq Real)
    (declare-const ?ijr Real)
    (assert
      (and (and (and (not (= ?ijo ?ijn))
            (not (= ?ijo ?ijm))
            )
          (not (= ?ijn ?ijm))
          )
        (or (or (= ?ijr ?ijq)
            (= ?ijr ?ijp)
            )
          (= ?ijq ?ijp)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ijs Real)
    (declare-const ?ijt Real)
    (declare-const ?iju Real)
    (assert
      (or (or (= ?iju ?ijt)
          (= ?iju ?ijs)
          )
        (= ?ijt ?ijs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ijv Real)
    (declare-const ?ijw Real)
    (declare-const ?ijx Real)
    (assert
      (or (or (= ?ijx ?ijw)
          (= ?ijx ?ijv)
          )
        (= ?ijw ?ijv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ijy Real)
    (declare-const ?ijz Real)
    (declare-const ?ika Real)
    (declare-const ?ikb Real)
    (assert
      (or (or (= ?ika ?ijz)
          (= ?ika ?ijy)
          )
        (= ?ijz ?ijy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ikc Real)
    (declare-const ?ikd Real)
    (declare-const ?ike Real)
    (declare-const ?ikf Real)
    (declare-const ?ikg Real)
    (assert
      (or (or (= ?ike ?ikd)
          (= ?ike ?ikc)
          )
        (= ?ikd ?ikc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ikh Real)
    (declare-const ?iki Real)
    (declare-const ?ikj Real)
    (declare-const ?ikk Real)
    (declare-const ?ikl Real)
    (declare-const ?ikm Real)
    (assert
      (and (or (or (= ?ikj ?iki)
            (= ?ikj ?ikh)
            )
          (= ?iki ?ikh)
          )
        (and (and (not (= ?ikm ?ikl))
            (not (= ?ikm ?ikk))
            )
          (not (= ?ikl ?ikk))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ikn Real)
    (declare-const ?iko Real)
    (declare-const ?ikp Real)
    (assert
      (or (or (= ?ikp ?iko)
          (= ?ikp ?ikn)
          )
        (= ?iko ?ikn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ikq Real)
    (declare-const ?ikr Real)
    (declare-const ?iks Real)
    (declare-const ?ikt Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ikr ?ikq))
                (not (= ?ikr ?asi))
                )
              (not (= ?ikq ?asi))
              )
            (or (or (= ?ikt ?iks)
                (= ?ikt ?asi)
                )
              (= ?iks ?asi)
              )
            )
          (and (or (or (= ?ikr ?ikq)
                (= ?ikr ?asi)
                )
              (= ?ikq ?asi)
              )
            (and (and (not (= ?ikt ?iks))
                (not (= ?ikt ?asi))
                )
              (not (= ?iks ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?iku Real)
  (declare-const ?ikv Real)
  (assert
    (not (= ?iku ?ikv))
    )
  (push 1)
    (declare-const ?ikw Real)
    (declare-const ?ikx Real)
    (declare-const ?iky Real)
    (assert
      (or (or (= ?iky ?ikx)
          (= ?iky ?ikw)
          )
        (= ?ikx ?ikw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ikz Real)
    (declare-const ?ila Real)
    (declare-const ?ilb Real)
    (declare-const ?ilc Real)
    (assert
      (or (or (= ?ilc ?ilb)
          (= ?ilc ?ila)
          )
        (= ?ilb ?ila)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ild Real)
    (declare-const ?ile Real)
    (declare-const ?ilf Real)
    (declare-const ?ilg Real)
    (declare-const ?ilh Real)
    (assert
      (or (or (= ?ilh ?ilg)
          (= ?ilh ?ilf)
          )
        (= ?ilg ?ilf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ili Real)
    (declare-const ?ilj Real)
    (declare-const ?ilk Real)
    (declare-const ?ill Real)
    (declare-const ?ilm Real)
    (declare-const ?iln Real)
    (assert
      (and (and (and (not (= ?ilk ?ilj))
            (not (= ?ilk ?ili))
            )
          (not (= ?ilj ?ili))
          )
        (or (or (= ?iln ?ilm)
            (= ?iln ?ill)
            )
          (= ?ilm ?ill)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ilo Real)
    (declare-const ?ilp Real)
    (declare-const ?ilq Real)
    (assert
      (or (or (= ?ilq ?ilp)
          (= ?ilq ?ilo)
          )
        (= ?ilp ?ilo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ilr Real)
    (declare-const ?ils Real)
    (declare-const ?ilt Real)
    (assert
      (or (or (= ?ilt ?ils)
          (= ?ilt ?ilr)
          )
        (= ?ils ?ilr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ilu Real)
    (declare-const ?ilv Real)
    (declare-const ?ilw Real)
    (declare-const ?ilx Real)
    (assert
      (or (or (= ?ilw ?ilv)
          (= ?ilw ?ilu)
          )
        (= ?ilv ?ilu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ily Real)
    (declare-const ?ilz Real)
    (declare-const ?ima Real)
    (declare-const ?imb Real)
    (declare-const ?imc Real)
    (assert
      (or (or (= ?ima ?ilz)
          (= ?ima ?ily)
          )
        (= ?ilz ?ily)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?imd Real)
    (declare-const ?ime Real)
    (declare-const ?imf Real)
    (declare-const ?img Real)
    (declare-const ?imh Real)
    (declare-const ?imi Real)
    (assert
      (and (or (or (= ?imf ?ime)
            (= ?imf ?imd)
            )
          (= ?ime ?imd)
          )
        (and (and (not (= ?imi ?imh))
            (not (= ?imi ?img))
            )
          (not (= ?imh ?img))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?imj Real)
    (declare-const ?imk Real)
    (declare-const ?iml Real)
    (assert
      (or (or (= ?iml ?imk)
          (= ?iml ?imj)
          )
        (= ?imk ?imj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?imm Real)
    (declare-const ?imn Real)
    (declare-const ?imo Real)
    (declare-const ?imp Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?imn ?imm))
                (not (= ?imn ?asi))
                )
              (not (= ?imm ?asi))
              )
            (or (or (= ?imp ?imo)
                (= ?imp ?asi)
                )
              (= ?imo ?asi)
              )
            )
          (and (or (or (= ?imn ?imm)
                (= ?imn ?asi)
                )
              (= ?imm ?asi)
              )
            (and (and (not (= ?imp ?imo))
                (not (= ?imp ?asi))
                )
              (not (= ?imo ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?imq Real)
  (declare-const ?imr Real)
  (declare-const ?ims Real)
  (push 1)
    (declare-const ?imt Real)
    (declare-const ?imu Real)
    (declare-const ?imv Real)
    (assert
      (or (or (= ?imv ?imu)
          (= ?imv ?imt)
          )
        (= ?imu ?imt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?imw Real)
    (declare-const ?imx Real)
    (declare-const ?imy Real)
    (declare-const ?imz Real)
    (assert
      (or (or (= ?imz ?imy)
          (= ?imz ?imx)
          )
        (= ?imy ?imx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ina Real)
    (declare-const ?inb Real)
    (declare-const ?inc Real)
    (declare-const ?ind Real)
    (declare-const ?ine Real)
    (assert
      (or (or (= ?ine ?ind)
          (= ?ine ?inc)
          )
        (= ?ind ?inc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?inf Real)
    (declare-const ?ing Real)
    (declare-const ?inh Real)
    (declare-const ?ini Real)
    (declare-const ?inj Real)
    (declare-const ?ink Real)
    (assert
      (and (and (and (not (= ?inh ?ing))
            (not (= ?inh ?inf))
            )
          (not (= ?ing ?inf))
          )
        (or (or (= ?ink ?inj)
            (= ?ink ?ini)
            )
          (= ?inj ?ini)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?inl Real)
    (declare-const ?inm Real)
    (declare-const ?inn Real)
    (assert
      (or (or (= ?inn ?inm)
          (= ?inn ?inl)
          )
        (= ?inm ?inl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ino Real)
    (declare-const ?inp Real)
    (declare-const ?inq Real)
    (assert
      (or (or (= ?inq ?inp)
          (= ?inq ?ino)
          )
        (= ?inp ?ino)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?inr Real)
    (declare-const ?ins Real)
    (declare-const ?int Real)
    (declare-const ?inu Real)
    (assert
      (or (or (= ?int ?ins)
          (= ?int ?inr)
          )
        (= ?ins ?inr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?inv Real)
    (declare-const ?inw Real)
    (declare-const ?inx Real)
    (declare-const ?iny Real)
    (declare-const ?inz Real)
    (assert
      (or (or (= ?inx ?inw)
          (= ?inx ?inv)
          )
        (= ?inw ?inv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ioa Real)
    (declare-const ?iob Real)
    (declare-const ?ioc Real)
    (declare-const ?iod Real)
    (declare-const ?ioe Real)
    (declare-const ?iof Real)
    (assert
      (and (or (or (= ?ioc ?iob)
            (= ?ioc ?ioa)
            )
          (= ?iob ?ioa)
          )
        (and (and (not (= ?iof ?ioe))
            (not (= ?iof ?iod))
            )
          (not (= ?ioe ?iod))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iog Real)
    (declare-const ?ioh Real)
    (declare-const ?ioi Real)
    (assert
      (or (or (= ?ioi ?ioh)
          (= ?ioi ?iog)
          )
        (= ?ioh ?iog)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ioj Real)
    (declare-const ?iok Real)
    (declare-const ?iol Real)
    (declare-const ?iom Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?iok ?ioj))
                (not (= ?iok ?asi))
                )
              (not (= ?ioj ?asi))
              )
            (or (or (= ?iom ?iol)
                (= ?iom ?asi)
                )
              (= ?iol ?asi)
              )
            )
          (and (or (or (= ?iok ?ioj)
                (= ?iok ?asi)
                )
              (= ?ioj ?asi)
              )
            (and (and (not (= ?iom ?iol))
                (not (= ?iom ?asi))
                )
              (not (= ?iol ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ion Real)
  (declare-const ?ioo Real)
  (declare-const ?iop Real)
  (declare-const ?ioq Real)
  (push 1)
    (declare-const ?ior Real)
    (declare-const ?ios Real)
    (declare-const ?iot Real)
    (assert
      (or (or (= ?iot ?ios)
          (= ?iot ?ior)
          )
        (= ?ios ?ior)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iou Real)
    (declare-const ?iov Real)
    (declare-const ?iow Real)
    (declare-const ?iox Real)
    (assert
      (or (or (= ?iox ?iow)
          (= ?iox ?iov)
          )
        (= ?iow ?iov)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ioy Real)
    (declare-const ?ioz Real)
    (declare-const ?ipa Real)
    (declare-const ?ipb Real)
    (declare-const ?ipc Real)
    (assert
      (or (or (= ?ipc ?ipb)
          (= ?ipc ?ipa)
          )
        (= ?ipb ?ipa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ipd Real)
    (declare-const ?ipe Real)
    (declare-const ?ipf Real)
    (declare-const ?ipg Real)
    (declare-const ?iph Real)
    (declare-const ?ipi Real)
    (assert
      (and (and (and (not (= ?ipf ?ipe))
            (not (= ?ipf ?ipd))
            )
          (not (= ?ipe ?ipd))
          )
        (or (or (= ?ipi ?iph)
            (= ?ipi ?ipg)
            )
          (= ?iph ?ipg)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ipj Real)
    (declare-const ?ipk Real)
    (declare-const ?ipl Real)
    (assert
      (or (or (= ?ipl ?ipk)
          (= ?ipl ?ipj)
          )
        (= ?ipk ?ipj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ipm Real)
    (declare-const ?ipn Real)
    (declare-const ?ipo Real)
    (assert
      (or (or (= ?ipo ?ipn)
          (= ?ipo ?ipm)
          )
        (= ?ipn ?ipm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ipp Real)
    (declare-const ?ipq Real)
    (declare-const ?ipr Real)
    (declare-const ?ips Real)
    (assert
      (or (or (= ?ipr ?ipq)
          (= ?ipr ?ipp)
          )
        (= ?ipq ?ipp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ipt Real)
    (declare-const ?ipu Real)
    (declare-const ?ipv Real)
    (declare-const ?ipw Real)
    (declare-const ?ipx Real)
    (assert
      (or (or (= ?ipv ?ipu)
          (= ?ipv ?ipt)
          )
        (= ?ipu ?ipt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ipy Real)
    (declare-const ?ipz Real)
    (declare-const ?iqa Real)
    (declare-const ?iqb Real)
    (declare-const ?iqc Real)
    (declare-const ?iqd Real)
    (assert
      (and (or (or (= ?iqa ?ipz)
            (= ?iqa ?ipy)
            )
          (= ?ipz ?ipy)
          )
        (and (and (not (= ?iqd ?iqc))
            (not (= ?iqd ?iqb))
            )
          (not (= ?iqc ?iqb))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iqe Real)
    (declare-const ?iqf Real)
    (declare-const ?iqg Real)
    (assert
      (or (or (= ?iqg ?iqf)
          (= ?iqg ?iqe)
          )
        (= ?iqf ?iqe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iqh Real)
    (declare-const ?iqi Real)
    (declare-const ?iqj Real)
    (declare-const ?iqk Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?iqi ?iqh))
                (not (= ?iqi ?asi))
                )
              (not (= ?iqh ?asi))
              )
            (or (or (= ?iqk ?iqj)
                (= ?iqk ?asi)
                )
              (= ?iqj ?asi)
              )
            )
          (and (or (or (= ?iqi ?iqh)
                (= ?iqi ?asi)
                )
              (= ?iqh ?asi)
              )
            (and (and (not (= ?iqk ?iqj))
                (not (= ?iqk ?asi))
                )
              (not (= ?iqj ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?iql Real)
  (push 1)
    (declare-const ?iqm Real)
    (declare-const ?iqn Real)
    (declare-const ?iqo Real)
    (assert
      (or (or (= ?iqo ?iqn)
          (= ?iqo ?iqm)
          )
        (= ?iqn ?iqm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iqp Real)
    (declare-const ?iqq Real)
    (declare-const ?iqr Real)
    (declare-const ?iqs Real)
    (assert
      (or (or (= ?iqs ?iqr)
          (= ?iqs ?iqq)
          )
        (= ?iqr ?iqq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iqt Real)
    (declare-const ?iqu Real)
    (declare-const ?iqv Real)
    (declare-const ?iqw Real)
    (declare-const ?iqx Real)
    (assert
      (or (or (= ?iqx ?iqw)
          (= ?iqx ?iqv)
          )
        (= ?iqw ?iqv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iqy Real)
    (declare-const ?iqz Real)
    (declare-const ?ira Real)
    (declare-const ?irb Real)
    (declare-const ?irc Real)
    (declare-const ?ird Real)
    (assert
      (and (and (and (not (= ?ira ?iqz))
            (not (= ?ira ?iqy))
            )
          (not (= ?iqz ?iqy))
          )
        (or (or (= ?ird ?irc)
            (= ?ird ?irb)
            )
          (= ?irc ?irb)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ire Real)
    (declare-const ?irf Real)
    (declare-const ?irg Real)
    (assert
      (or (or (= ?irg ?irf)
          (= ?irg ?ire)
          )
        (= ?irf ?ire)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?irh Real)
    (declare-const ?iri Real)
    (declare-const ?irj Real)
    (assert
      (or (or (= ?irj ?iri)
          (= ?irj ?irh)
          )
        (= ?iri ?irh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?irk Real)
    (declare-const ?irl Real)
    (declare-const ?irm Real)
    (declare-const ?irn Real)
    (assert
      (or (or (= ?irm ?irl)
          (= ?irm ?irk)
          )
        (= ?irl ?irk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iro Real)
    (declare-const ?irp Real)
    (declare-const ?irq Real)
    (declare-const ?irr Real)
    (declare-const ?irs Real)
    (assert
      (or (or (= ?irq ?irp)
          (= ?irq ?iro)
          )
        (= ?irp ?iro)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?irt Real)
    (declare-const ?iru Real)
    (declare-const ?irv Real)
    (declare-const ?irw Real)
    (declare-const ?irx Real)
    (declare-const ?iry Real)
    (assert
      (and (or (or (= ?irv ?iru)
            (= ?irv ?irt)
            )
          (= ?iru ?irt)
          )
        (and (and (not (= ?iry ?irx))
            (not (= ?iry ?irw))
            )
          (not (= ?irx ?irw))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?irz Real)
    (declare-const ?isa Real)
    (declare-const ?isb Real)
    (assert
      (or (or (= ?isb ?isa)
          (= ?isb ?irz)
          )
        (= ?isa ?irz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?isc Real)
    (declare-const ?isd Real)
    (declare-const ?ise Real)
    (declare-const ?isf Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?isd ?isc))
                (not (= ?isd ?asi))
                )
              (not (= ?isc ?asi))
              )
            (or (or (= ?isf ?ise)
                (= ?isf ?asi)
                )
              (= ?ise ?asi)
              )
            )
          (and (or (or (= ?isd ?isc)
                (= ?isd ?asi)
                )
              (= ?isc ?asi)
              )
            (and (and (not (= ?isf ?ise))
                (not (= ?isf ?asi))
                )
              (not (= ?ise ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?isg Real)
  (declare-const ?ish Real)
  (push 1)
    (declare-const ?isi Real)
    (declare-const ?isj Real)
    (declare-const ?isk Real)
    (assert
      (or (or (= ?isk ?isj)
          (= ?isk ?isi)
          )
        (= ?isj ?isi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?isl Real)
    (declare-const ?ism Real)
    (declare-const ?isn Real)
    (declare-const ?iso Real)
    (assert
      (or (or (= ?iso ?isn)
          (= ?iso ?ism)
          )
        (= ?isn ?ism)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?isp Real)
    (declare-const ?isq Real)
    (declare-const ?isr Real)
    (declare-const ?iss Real)
    (declare-const ?ist Real)
    (assert
      (or (or (= ?ist ?iss)
          (= ?ist ?isr)
          )
        (= ?iss ?isr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?isu Real)
    (declare-const ?isv Real)
    (declare-const ?isw Real)
    (declare-const ?isx Real)
    (declare-const ?isy Real)
    (declare-const ?isz Real)
    (assert
      (and (and (and (not (= ?isw ?isv))
            (not (= ?isw ?isu))
            )
          (not (= ?isv ?isu))
          )
        (or (or (= ?isz ?isy)
            (= ?isz ?isx)
            )
          (= ?isy ?isx)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ita Real)
    (declare-const ?itb Real)
    (declare-const ?itc Real)
    (assert
      (or (or (= ?itc ?itb)
          (= ?itc ?ita)
          )
        (= ?itb ?ita)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?itd Real)
    (declare-const ?ite Real)
    (declare-const ?itf Real)
    (assert
      (or (or (= ?itf ?ite)
          (= ?itf ?itd)
          )
        (= ?ite ?itd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?itg Real)
    (declare-const ?ith Real)
    (declare-const ?iti Real)
    (declare-const ?itj Real)
    (assert
      (or (or (= ?iti ?ith)
          (= ?iti ?itg)
          )
        (= ?ith ?itg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?itk Real)
    (declare-const ?itl Real)
    (declare-const ?itm Real)
    (declare-const ?itn Real)
    (declare-const ?ito Real)
    (assert
      (or (or (= ?itm ?itl)
          (= ?itm ?itk)
          )
        (= ?itl ?itk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?itp Real)
    (declare-const ?itq Real)
    (declare-const ?itr Real)
    (declare-const ?its Real)
    (declare-const ?itt Real)
    (declare-const ?itu Real)
    (assert
      (and (or (or (= ?itr ?itq)
            (= ?itr ?itp)
            )
          (= ?itq ?itp)
          )
        (and (and (not (= ?itu ?itt))
            (not (= ?itu ?its))
            )
          (not (= ?itt ?its))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?itv Real)
    (declare-const ?itw Real)
    (declare-const ?itx Real)
    (assert
      (or (or (= ?itx ?itw)
          (= ?itx ?itv)
          )
        (= ?itw ?itv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ity Real)
    (declare-const ?itz Real)
    (declare-const ?iua Real)
    (declare-const ?iub Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?itz ?ity))
                (not (= ?itz ?asi))
                )
              (not (= ?ity ?asi))
              )
            (or (or (= ?iub ?iua)
                (= ?iub ?asi)
                )
              (= ?iua ?asi)
              )
            )
          (and (or (or (= ?itz ?ity)
                (= ?itz ?asi)
                )
              (= ?ity ?asi)
              )
            (and (and (not (= ?iub ?iua))
                (not (= ?iub ?asi))
                )
              (not (= ?iua ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?iuc Real)
  (declare-const ?iud Real)
  (declare-const ?iue Real)
  (push 1)
    (declare-const ?iuf Real)
    (declare-const ?iug Real)
    (declare-const ?iuh Real)
    (assert
      (or (or (= ?iuh ?iug)
          (= ?iuh ?iuf)
          )
        (= ?iug ?iuf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iui Real)
    (declare-const ?iuj Real)
    (declare-const ?iuk Real)
    (declare-const ?iul Real)
    (assert
      (or (or (= ?iul ?iuk)
          (= ?iul ?iuj)
          )
        (= ?iuk ?iuj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ium Real)
    (declare-const ?iun Real)
    (declare-const ?iuo Real)
    (declare-const ?iup Real)
    (declare-const ?iuq Real)
    (assert
      (or (or (= ?iuq ?iup)
          (= ?iuq ?iuo)
          )
        (= ?iup ?iuo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iur Real)
    (declare-const ?ius Real)
    (declare-const ?iut Real)
    (declare-const ?iuu Real)
    (declare-const ?iuv Real)
    (declare-const ?iuw Real)
    (assert
      (and (and (and (not (= ?iut ?ius))
            (not (= ?iut ?iur))
            )
          (not (= ?ius ?iur))
          )
        (or (or (= ?iuw ?iuv)
            (= ?iuw ?iuu)
            )
          (= ?iuv ?iuu)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iux Real)
    (declare-const ?iuy Real)
    (declare-const ?iuz Real)
    (assert
      (or (or (= ?iuz ?iuy)
          (= ?iuz ?iux)
          )
        (= ?iuy ?iux)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iva Real)
    (declare-const ?ivb Real)
    (declare-const ?ivc Real)
    (assert
      (or (or (= ?ivc ?ivb)
          (= ?ivc ?iva)
          )
        (= ?ivb ?iva)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ivd Real)
    (declare-const ?ive Real)
    (declare-const ?ivf Real)
    (declare-const ?ivg Real)
    (assert
      (or (or (= ?ivf ?ive)
          (= ?ivf ?ivd)
          )
        (= ?ive ?ivd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ivh Real)
    (declare-const ?ivi Real)
    (declare-const ?ivj Real)
    (declare-const ?ivk Real)
    (declare-const ?ivl Real)
    (assert
      (or (or (= ?ivj ?ivi)
          (= ?ivj ?ivh)
          )
        (= ?ivi ?ivh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ivm Real)
    (declare-const ?ivn Real)
    (declare-const ?ivo Real)
    (declare-const ?ivp Real)
    (declare-const ?ivq Real)
    (declare-const ?ivr Real)
    (assert
      (and (or (or (= ?ivo ?ivn)
            (= ?ivo ?ivm)
            )
          (= ?ivn ?ivm)
          )
        (and (and (not (= ?ivr ?ivq))
            (not (= ?ivr ?ivp))
            )
          (not (= ?ivq ?ivp))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ivs Real)
    (declare-const ?ivt Real)
    (declare-const ?ivu Real)
    (assert
      (or (or (= ?ivu ?ivt)
          (= ?ivu ?ivs)
          )
        (= ?ivt ?ivs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ivv Real)
    (declare-const ?ivw Real)
    (declare-const ?ivx Real)
    (declare-const ?ivy Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ivw ?ivv))
                (not (= ?ivw ?asi))
                )
              (not (= ?ivv ?asi))
              )
            (or (or (= ?ivy ?ivx)
                (= ?ivy ?asi)
                )
              (= ?ivx ?asi)
              )
            )
          (and (or (or (= ?ivw ?ivv)
                (= ?ivw ?asi)
                )
              (= ?ivv ?asi)
              )
            (and (and (not (= ?ivy ?ivx))
                (not (= ?ivy ?asi))
                )
              (not (= ?ivx ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ivz Real)
  (declare-const ?iwa Real)
  (declare-const ?iwb Real)
  (declare-const ?iwc Real)
  (assert
    (exists ((?fkf Real) )(or (and (and (and (not (= ?iwa ?ivz))
              (not (= ?iwa ?fkf))
              )
            (not (= ?ivz ?fkf))
            )
          (or (or (= ?iwc ?iwb)
              (= ?iwc ?fkf)
              )
            (= ?iwb ?fkf)
            )
          )
        (and (or (or (= ?iwa ?ivz)
              (= ?iwa ?fkf)
              )
            (= ?ivz ?fkf)
            )
          (and (and (not (= ?iwc ?iwb))
              (not (= ?iwc ?fkf))
              )
            (not (= ?iwb ?fkf))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?iwd Real)
    (declare-const ?iwe Real)
    (declare-const ?iwf Real)
    (assert
      (or (or (= ?iwf ?iwe)
          (= ?iwf ?iwd)
          )
        (= ?iwe ?iwd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iwg Real)
    (declare-const ?iwh Real)
    (declare-const ?iwi Real)
    (declare-const ?iwj Real)
    (assert
      (or (or (= ?iwj ?iwi)
          (= ?iwj ?iwh)
          )
        (= ?iwi ?iwh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iwk Real)
    (declare-const ?iwl Real)
    (declare-const ?iwm Real)
    (declare-const ?iwn Real)
    (declare-const ?iwo Real)
    (assert
      (or (or (= ?iwo ?iwn)
          (= ?iwo ?iwm)
          )
        (= ?iwn ?iwm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iwp Real)
    (declare-const ?iwq Real)
    (declare-const ?iwr Real)
    (declare-const ?iws Real)
    (declare-const ?iwt Real)
    (declare-const ?iwu Real)
    (assert
      (and (and (and (not (= ?iwr ?iwq))
            (not (= ?iwr ?iwp))
            )
          (not (= ?iwq ?iwp))
          )
        (or (or (= ?iwu ?iwt)
            (= ?iwu ?iws)
            )
          (= ?iwt ?iws)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iwv Real)
    (declare-const ?iww Real)
    (declare-const ?iwx Real)
    (assert
      (or (or (= ?iwx ?iww)
          (= ?iwx ?iwv)
          )
        (= ?iww ?iwv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iwy Real)
    (declare-const ?iwz Real)
    (declare-const ?ixa Real)
    (assert
      (or (or (= ?ixa ?iwz)
          (= ?ixa ?iwy)
          )
        (= ?iwz ?iwy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ixb Real)
    (declare-const ?ixc Real)
    (declare-const ?ixd Real)
    (declare-const ?ixe Real)
    (assert
      (or (or (= ?ixd ?ixc)
          (= ?ixd ?ixb)
          )
        (= ?ixc ?ixb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ixf Real)
    (declare-const ?ixg Real)
    (declare-const ?ixh Real)
    (declare-const ?ixi Real)
    (declare-const ?ixj Real)
    (assert
      (or (or (= ?ixh ?ixg)
          (= ?ixh ?ixf)
          )
        (= ?ixg ?ixf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ixk Real)
    (declare-const ?ixl Real)
    (declare-const ?ixm Real)
    (declare-const ?ixn Real)
    (declare-const ?ixo Real)
    (declare-const ?ixp Real)
    (assert
      (and (or (or (= ?ixm ?ixl)
            (= ?ixm ?ixk)
            )
          (= ?ixl ?ixk)
          )
        (and (and (not (= ?ixp ?ixo))
            (not (= ?ixp ?ixn))
            )
          (not (= ?ixo ?ixn))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ixq Real)
    (declare-const ?ixr Real)
    (declare-const ?ixs Real)
    (assert
      (or (or (= ?ixs ?ixr)
          (= ?ixs ?ixq)
          )
        (= ?ixr ?ixq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ixt Real)
    (declare-const ?ixu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ixv Real)
    (declare-const ?ixw Real)
    (declare-const ?ixx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ixy Real)
    (declare-const ?ixz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iya Real)
    (declare-const ?iyb Real)
    (declare-const ?iyc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iyd Real)
    (declare-const ?iye Real)
    (declare-const ?iyf Real)
    (declare-const ?iyg Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?iye ?iyd))
                (not (= ?iye ?asi))
                )
              (not (= ?iyd ?asi))
              )
            (or (or (= ?iyg ?iyf)
                (= ?iyg ?asi)
                )
              (= ?iyf ?asi)
              )
            )
          (and (or (or (= ?iye ?iyd)
                (= ?iye ?asi)
                )
              (= ?iyd ?asi)
              )
            (and (and (not (= ?iyg ?iyf))
                (not (= ?iyg ?asi))
                )
              (not (= ?iyf ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iyh Real)
    (declare-const ?iyi Real)
    (declare-const ?iyj Real)
    (declare-const ?iyk Real)
    (declare-const ?iyl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iym Real)
    (declare-const ?iyn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iyo Real)
    (declare-const ?iyp Real)
    (declare-const ?iyq Real)
    (declare-const ?iyr Real)
    (declare-const ?iys Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?iyt Real)
    (declare-const ?iyu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?iyv Real)
  (declare-const ?iyw Real)
  (declare-const ?iyx Real)
  (declare-const ?iyy Real)
  (declare-const ?iyz Real)
  (push 1)
    (declare-const ?iza Real)
    (declare-const ?izb Real)
    (declare-const ?izc Real)
    (assert
      (or (or (= ?izc ?izb)
          (= ?izc ?iza)
          )
        (= ?izb ?iza)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?izd Real)
    (declare-const ?ize Real)
    (declare-const ?izf Real)
    (declare-const ?izg Real)
    (assert
      (or (or (= ?izg ?izf)
          (= ?izg ?ize)
          )
        (= ?izf ?ize)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?izh Real)
    (declare-const ?izi Real)
    (declare-const ?izj Real)
    (declare-const ?izk Real)
    (declare-const ?izl Real)
    (assert
      (or (or (= ?izl ?izk)
          (= ?izl ?izj)
          )
        (= ?izk ?izj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?izm Real)
    (declare-const ?izn Real)
    (declare-const ?izo Real)
    (declare-const ?izp Real)
    (declare-const ?izq Real)
    (declare-const ?izr Real)
    (assert
      (and (and (and (not (= ?izo ?izn))
            (not (= ?izo ?izm))
            )
          (not (= ?izn ?izm))
          )
        (or (or (= ?izr ?izq)
            (= ?izr ?izp)
            )
          (= ?izq ?izp)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?izs Real)
    (declare-const ?izt Real)
    (declare-const ?izu Real)
    (assert
      (or (or (= ?izu ?izt)
          (= ?izu ?izs)
          )
        (= ?izt ?izs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?izv Real)
    (declare-const ?izw Real)
    (declare-const ?izx Real)
    (assert
      (or (or (= ?izx ?izw)
          (= ?izx ?izv)
          )
        (= ?izw ?izv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?izy Real)
    (declare-const ?izz Real)
    (declare-const ?jaa Real)
    (declare-const ?jab Real)
    (assert
      (or (or (= ?jaa ?izz)
          (= ?jaa ?izy)
          )
        (= ?izz ?izy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jac Real)
    (declare-const ?jad Real)
    (declare-const ?jae Real)
    (declare-const ?jaf Real)
    (declare-const ?jag Real)
    (assert
      (or (or (= ?jae ?jad)
          (= ?jae ?jac)
          )
        (= ?jad ?jac)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jah Real)
    (declare-const ?jai Real)
    (declare-const ?jaj Real)
    (declare-const ?jak Real)
    (declare-const ?jal Real)
    (declare-const ?jam Real)
    (assert
      (and (or (or (= ?jaj ?jai)
            (= ?jaj ?jah)
            )
          (= ?jai ?jah)
          )
        (and (and (not (= ?jam ?jal))
            (not (= ?jam ?jak))
            )
          (not (= ?jal ?jak))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jan Real)
    (declare-const ?jao Real)
    (declare-const ?jap Real)
    (assert
      (or (or (= ?jap ?jao)
          (= ?jap ?jan)
          )
        (= ?jao ?jan)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jaq Real)
    (declare-const ?jar Real)
    (declare-const ?jas Real)
    (declare-const ?jat Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?jar ?jaq))
                (not (= ?jar ?asi))
                )
              (not (= ?jaq ?asi))
              )
            (or (or (= ?jat ?jas)
                (= ?jat ?asi)
                )
              (= ?jas ?asi)
              )
            )
          (and (or (or (= ?jar ?jaq)
                (= ?jar ?asi)
                )
              (= ?jaq ?asi)
              )
            (and (and (not (= ?jat ?jas))
                (not (= ?jat ?asi))
                )
              (not (= ?jas ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?jau Real)
  (declare-const ?jav Real)
  (push 1)
    (declare-const ?jaw Real)
    (declare-const ?jax Real)
    (declare-const ?jay Real)
    (assert
      (or (or (= ?jay ?jax)
          (= ?jay ?jaw)
          )
        (= ?jax ?jaw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jaz Real)
    (declare-const ?jba Real)
    (declare-const ?jbb Real)
    (declare-const ?jbc Real)
    (assert
      (or (or (= ?jbc ?jbb)
          (= ?jbc ?jba)
          )
        (= ?jbb ?jba)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jbd Real)
    (declare-const ?jbe Real)
    (declare-const ?jbf Real)
    (declare-const ?jbg Real)
    (declare-const ?jbh Real)
    (assert
      (or (or (= ?jbh ?jbg)
          (= ?jbh ?jbf)
          )
        (= ?jbg ?jbf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jbi Real)
    (declare-const ?jbj Real)
    (declare-const ?jbk Real)
    (declare-const ?jbl Real)
    (declare-const ?jbm Real)
    (declare-const ?jbn Real)
    (assert
      (and (and (and (not (= ?jbk ?jbj))
            (not (= ?jbk ?jbi))
            )
          (not (= ?jbj ?jbi))
          )
        (or (or (= ?jbn ?jbm)
            (= ?jbn ?jbl)
            )
          (= ?jbm ?jbl)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jbo Real)
    (declare-const ?jbp Real)
    (declare-const ?jbq Real)
    (assert
      (or (or (= ?jbq ?jbp)
          (= ?jbq ?jbo)
          )
        (= ?jbp ?jbo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jbr Real)
    (declare-const ?jbs Real)
    (declare-const ?jbt Real)
    (assert
      (or (or (= ?jbt ?jbs)
          (= ?jbt ?jbr)
          )
        (= ?jbs ?jbr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jbu Real)
    (declare-const ?jbv Real)
    (declare-const ?jbw Real)
    (declare-const ?jbx Real)
    (assert
      (or (or (= ?jbw ?jbv)
          (= ?jbw ?jbu)
          )
        (= ?jbv ?jbu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jby Real)
    (declare-const ?jbz Real)
    (declare-const ?jca Real)
    (declare-const ?jcb Real)
    (declare-const ?jcc Real)
    (assert
      (or (or (= ?jca ?jbz)
          (= ?jca ?jby)
          )
        (= ?jbz ?jby)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jcd Real)
    (declare-const ?jce Real)
    (declare-const ?jcf Real)
    (declare-const ?jcg Real)
    (declare-const ?jch Real)
    (declare-const ?jci Real)
    (assert
      (and (or (or (= ?jcf ?jce)
            (= ?jcf ?jcd)
            )
          (= ?jce ?jcd)
          )
        (and (and (not (= ?jci ?jch))
            (not (= ?jci ?jcg))
            )
          (not (= ?jch ?jcg))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jcj Real)
    (declare-const ?jck Real)
    (declare-const ?jcl Real)
    (assert
      (or (or (= ?jcl ?jck)
          (= ?jcl ?jcj)
          )
        (= ?jck ?jcj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jcm Real)
    (declare-const ?jcn Real)
    (declare-const ?jco Real)
    (declare-const ?jcp Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?jcn ?jcm))
                (not (= ?jcn ?asi))
                )
              (not (= ?jcm ?asi))
              )
            (or (or (= ?jcp ?jco)
                (= ?jcp ?asi)
                )
              (= ?jco ?asi)
              )
            )
          (and (or (or (= ?jcn ?jcm)
                (= ?jcn ?asi)
                )
              (= ?jcm ?asi)
              )
            (and (and (not (= ?jcp ?jco))
                (not (= ?jcp ?asi))
                )
              (not (= ?jco ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?jcq Real)
  (declare-const ?jcr Real)
  (declare-const ?jcs Real)
  (declare-const ?jct Real)
  (push 1)
    (declare-const ?jcu Real)
    (declare-const ?jcv Real)
    (declare-const ?jcw Real)
    (assert
      (or (or (= ?jcw ?jcv)
          (= ?jcw ?jcu)
          )
        (= ?jcv ?jcu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jcx Real)
    (declare-const ?jcy Real)
    (declare-const ?jcz Real)
    (declare-const ?jda Real)
    (assert
      (or (or (= ?jda ?jcz)
          (= ?jda ?jcy)
          )
        (= ?jcz ?jcy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jdb Real)
    (declare-const ?jdc Real)
    (declare-const ?jdd Real)
    (declare-const ?jde Real)
    (declare-const ?jdf Real)
    (assert
      (or (or (= ?jdf ?jde)
          (= ?jdf ?jdd)
          )
        (= ?jde ?jdd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jdg Real)
    (declare-const ?jdh Real)
    (declare-const ?jdi Real)
    (declare-const ?jdj Real)
    (declare-const ?jdk Real)
    (declare-const ?jdl Real)
    (assert
      (and (and (and (not (= ?jdi ?jdh))
            (not (= ?jdi ?jdg))
            )
          (not (= ?jdh ?jdg))
          )
        (or (or (= ?jdl ?jdk)
            (= ?jdl ?jdj)
            )
          (= ?jdk ?jdj)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jdm Real)
    (declare-const ?jdn Real)
    (declare-const ?jdo Real)
    (assert
      (or (or (= ?jdo ?jdn)
          (= ?jdo ?jdm)
          )
        (= ?jdn ?jdm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jdp Real)
    (declare-const ?jdq Real)
    (declare-const ?jdr Real)
    (assert
      (or (or (= ?jdr ?jdq)
          (= ?jdr ?jdp)
          )
        (= ?jdq ?jdp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jds Real)
    (declare-const ?jdt Real)
    (declare-const ?jdu Real)
    (declare-const ?jdv Real)
    (assert
      (or (or (= ?jdu ?jdt)
          (= ?jdu ?jds)
          )
        (= ?jdt ?jds)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jdw Real)
    (declare-const ?jdx Real)
    (declare-const ?jdy Real)
    (declare-const ?jdz Real)
    (declare-const ?jea Real)
    (assert
      (or (or (= ?jdy ?jdx)
          (= ?jdy ?jdw)
          )
        (= ?jdx ?jdw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jeb Real)
    (declare-const ?jec Real)
    (declare-const ?jed Real)
    (declare-const ?jee Real)
    (declare-const ?jef Real)
    (declare-const ?jeg Real)
    (assert
      (and (or (or (= ?jed ?jec)
            (= ?jed ?jeb)
            )
          (= ?jec ?jeb)
          )
        (and (and (not (= ?jeg ?jef))
            (not (= ?jeg ?jee))
            )
          (not (= ?jef ?jee))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jeh Real)
    (declare-const ?jei Real)
    (declare-const ?jej Real)
    (assert
      (or (or (= ?jej ?jei)
          (= ?jej ?jeh)
          )
        (= ?jei ?jeh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jek Real)
    (declare-const ?jel Real)
    (declare-const ?jem Real)
    (declare-const ?jen Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?jel ?jek))
                (not (= ?jel ?asi))
                )
              (not (= ?jek ?asi))
              )
            (or (or (= ?jen ?jem)
                (= ?jen ?asi)
                )
              (= ?jem ?asi)
              )
            )
          (and (or (or (= ?jel ?jek)
                (= ?jel ?asi)
                )
              (= ?jek ?asi)
              )
            (and (and (not (= ?jen ?jem))
                (not (= ?jen ?asi))
                )
              (not (= ?jem ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?jeo Real)
  (declare-const ?jep Real)
  (declare-const ?jeq Real)
  (declare-const ?jer Real)
  (declare-const ?jes Real)
  (push 1)
    (declare-const ?jet Real)
    (declare-const ?jeu Real)
    (declare-const ?jev Real)
    (assert
      (or (or (= ?jev ?jeu)
          (= ?jev ?jet)
          )
        (= ?jeu ?jet)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jew Real)
    (declare-const ?jex Real)
    (declare-const ?jey Real)
    (declare-const ?jez Real)
    (assert
      (or (or (= ?jez ?jey)
          (= ?jez ?jex)
          )
        (= ?jey ?jex)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jfa Real)
    (declare-const ?jfb Real)
    (declare-const ?jfc Real)
    (declare-const ?jfd Real)
    (declare-const ?jfe Real)
    (assert
      (or (or (= ?jfe ?jfd)
          (= ?jfe ?jfc)
          )
        (= ?jfd ?jfc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jff Real)
    (declare-const ?jfg Real)
    (declare-const ?jfh Real)
    (declare-const ?jfi Real)
    (declare-const ?jfj Real)
    (declare-const ?jfk Real)
    (assert
      (and (and (and (not (= ?jfh ?jfg))
            (not (= ?jfh ?jff))
            )
          (not (= ?jfg ?jff))
          )
        (or (or (= ?jfk ?jfj)
            (= ?jfk ?jfi)
            )
          (= ?jfj ?jfi)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jfl Real)
    (declare-const ?jfm Real)
    (declare-const ?jfn Real)
    (assert
      (or (or (= ?jfn ?jfm)
          (= ?jfn ?jfl)
          )
        (= ?jfm ?jfl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jfo Real)
    (declare-const ?jfp Real)
    (declare-const ?jfq Real)
    (assert
      (or (or (= ?jfq ?jfp)
          (= ?jfq ?jfo)
          )
        (= ?jfp ?jfo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jfr Real)
    (declare-const ?jfs Real)
    (declare-const ?jft Real)
    (declare-const ?jfu Real)
    (assert
      (or (or (= ?jft ?jfs)
          (= ?jft ?jfr)
          )
        (= ?jfs ?jfr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jfv Real)
    (declare-const ?jfw Real)
    (declare-const ?jfx Real)
    (declare-const ?jfy Real)
    (declare-const ?jfz Real)
    (assert
      (or (or (= ?jfx ?jfw)
          (= ?jfx ?jfv)
          )
        (= ?jfw ?jfv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jga Real)
    (declare-const ?jgb Real)
    (declare-const ?jgc Real)
    (declare-const ?jgd Real)
    (declare-const ?jge Real)
    (declare-const ?jgf Real)
    (assert
      (and (or (or (= ?jgc ?jgb)
            (= ?jgc ?jga)
            )
          (= ?jgb ?jga)
          )
        (and (and (not (= ?jgf ?jge))
            (not (= ?jgf ?jgd))
            )
          (not (= ?jge ?jgd))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jgg Real)
    (declare-const ?jgh Real)
    (declare-const ?jgi Real)
    (assert
      (or (or (= ?jgi ?jgh)
          (= ?jgi ?jgg)
          )
        (= ?jgh ?jgg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jgj Real)
    (declare-const ?jgk Real)
    (declare-const ?jgl Real)
    (declare-const ?jgm Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?jgk ?jgj))
                (not (= ?jgk ?asi))
                )
              (not (= ?jgj ?asi))
              )
            (or (or (= ?jgm ?jgl)
                (= ?jgm ?asi)
                )
              (= ?jgl ?asi)
              )
            )
          (and (or (or (= ?jgk ?jgj)
                (= ?jgk ?asi)
                )
              (= ?jgj ?asi)
              )
            (and (and (not (= ?jgm ?jgl))
                (not (= ?jgm ?asi))
                )
              (not (= ?jgl ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?jgn Real)
  (push 1)
    (declare-const ?jgo Real)
    (declare-const ?jgp Real)
    (declare-const ?jgq Real)
    (assert
      (or (or (= ?jgq ?jgp)
          (= ?jgq ?jgo)
          )
        (= ?jgp ?jgo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jgr Real)
    (declare-const ?jgs Real)
    (declare-const ?jgt Real)
    (declare-const ?jgu Real)
    (assert
      (or (or (= ?jgu ?jgt)
          (= ?jgu ?jgs)
          )
        (= ?jgt ?jgs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jgv Real)
    (declare-const ?jgw Real)
    (declare-const ?jgx Real)
    (declare-const ?jgy Real)
    (declare-const ?jgz Real)
    (assert
      (or (or (= ?jgz ?jgy)
          (= ?jgz ?jgx)
          )
        (= ?jgy ?jgx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jha Real)
    (declare-const ?jhb Real)
    (declare-const ?jhc Real)
    (declare-const ?jhd Real)
    (declare-const ?jhe Real)
    (declare-const ?jhf Real)
    (assert
      (and (and (and (not (= ?jhc ?jhb))
            (not (= ?jhc ?jha))
            )
          (not (= ?jhb ?jha))
          )
        (or (or (= ?jhf ?jhe)
            (= ?jhf ?jhd)
            )
          (= ?jhe ?jhd)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jhg Real)
    (declare-const ?jhh Real)
    (declare-const ?jhi Real)
    (assert
      (or (or (= ?jhi ?jhh)
          (= ?jhi ?jhg)
          )
        (= ?jhh ?jhg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jhj Real)
    (declare-const ?jhk Real)
    (declare-const ?jhl Real)
    (assert
      (or (or (= ?jhl ?jhk)
          (= ?jhl ?jhj)
          )
        (= ?jhk ?jhj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jhm Real)
    (declare-const ?jhn Real)
    (declare-const ?jho Real)
    (declare-const ?jhp Real)
    (assert
      (or (or (= ?jho ?jhn)
          (= ?jho ?jhm)
          )
        (= ?jhn ?jhm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jhq Real)
    (declare-const ?jhr Real)
    (declare-const ?jhs Real)
    (declare-const ?jht Real)
    (declare-const ?jhu Real)
    (assert
      (or (or (= ?jhs ?jhr)
          (= ?jhs ?jhq)
          )
        (= ?jhr ?jhq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jhv Real)
    (declare-const ?jhw Real)
    (declare-const ?jhx Real)
    (declare-const ?jhy Real)
    (declare-const ?jhz Real)
    (declare-const ?jia Real)
    (assert
      (and (or (or (= ?jhx ?jhw)
            (= ?jhx ?jhv)
            )
          (= ?jhw ?jhv)
          )
        (and (and (not (= ?jia ?jhz))
            (not (= ?jia ?jhy))
            )
          (not (= ?jhz ?jhy))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jib Real)
    (declare-const ?jic Real)
    (declare-const ?jid Real)
    (assert
      (or (or (= ?jid ?jic)
          (= ?jid ?jib)
          )
        (= ?jic ?jib)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jie Real)
    (declare-const ?jif Real)
    (declare-const ?jig Real)
    (declare-const ?jih Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?jif ?jie))
                (not (= ?jif ?asi))
                )
              (not (= ?jie ?asi))
              )
            (or (or (= ?jih ?jig)
                (= ?jih ?asi)
                )
              (= ?jig ?asi)
              )
            )
          (and (or (or (= ?jif ?jie)
                (= ?jif ?asi)
                )
              (= ?jie ?asi)
              )
            (and (and (not (= ?jih ?jig))
                (not (= ?jih ?asi))
                )
              (not (= ?jig ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?jii Real)
  (declare-const ?jij Real)
  (push 1)
    (declare-const ?jik Real)
    (declare-const ?jil Real)
    (declare-const ?jim Real)
    (assert
      (or (or (= ?jim ?jil)
          (= ?jim ?jik)
          )
        (= ?jil ?jik)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jin Real)
    (declare-const ?jio Real)
    (declare-const ?jip Real)
    (declare-const ?jiq Real)
    (assert
      (or (or (= ?jiq ?jip)
          (= ?jiq ?jio)
          )
        (= ?jip ?jio)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jir Real)
    (declare-const ?jis Real)
    (declare-const ?jit Real)
    (declare-const ?jiu Real)
    (declare-const ?jiv Real)
    (assert
      (or (or (= ?jiv ?jiu)
          (= ?jiv ?jit)
          )
        (= ?jiu ?jit)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jiw Real)
    (declare-const ?jix Real)
    (declare-const ?jiy Real)
    (declare-const ?jiz Real)
    (declare-const ?jja Real)
    (declare-const ?jjb Real)
    (assert
      (and (and (and (not (= ?jiy ?jix))
            (not (= ?jiy ?jiw))
            )
          (not (= ?jix ?jiw))
          )
        (or (or (= ?jjb ?jja)
            (= ?jjb ?jiz)
            )
          (= ?jja ?jiz)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jjc Real)
    (declare-const ?jjd Real)
    (declare-const ?jje Real)
    (assert
      (or (or (= ?jje ?jjd)
          (= ?jje ?jjc)
          )
        (= ?jjd ?jjc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jjf Real)
    (declare-const ?jjg Real)
    (declare-const ?jjh Real)
    (assert
      (or (or (= ?jjh ?jjg)
          (= ?jjh ?jjf)
          )
        (= ?jjg ?jjf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jji Real)
    (declare-const ?jjj Real)
    (declare-const ?jjk Real)
    (declare-const ?jjl Real)
    (assert
      (or (or (= ?jjk ?jjj)
          (= ?jjk ?jji)
          )
        (= ?jjj ?jji)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jjm Real)
    (declare-const ?jjn Real)
    (declare-const ?jjo Real)
    (declare-const ?jjp Real)
    (declare-const ?jjq Real)
    (assert
      (or (or (= ?jjo ?jjn)
          (= ?jjo ?jjm)
          )
        (= ?jjn ?jjm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jjr Real)
    (declare-const ?jjs Real)
    (declare-const ?jjt Real)
    (declare-const ?jju Real)
    (declare-const ?jjv Real)
    (declare-const ?jjw Real)
    (assert
      (and (or (or (= ?jjt ?jjs)
            (= ?jjt ?jjr)
            )
          (= ?jjs ?jjr)
          )
        (and (and (not (= ?jjw ?jjv))
            (not (= ?jjw ?jju))
            )
          (not (= ?jjv ?jju))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jjx Real)
    (declare-const ?jjy Real)
    (declare-const ?jjz Real)
    (assert
      (or (or (= ?jjz ?jjy)
          (= ?jjz ?jjx)
          )
        (= ?jjy ?jjx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jka Real)
    (declare-const ?jkb Real)
    (declare-const ?jkc Real)
    (declare-const ?jkd Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?jkb ?jka))
                (not (= ?jkb ?asi))
                )
              (not (= ?jka ?asi))
              )
            (or (or (= ?jkd ?jkc)
                (= ?jkd ?asi)
                )
              (= ?jkc ?asi)
              )
            )
          (and (or (or (= ?jkb ?jka)
                (= ?jkb ?asi)
                )
              (= ?jka ?asi)
              )
            (and (and (not (= ?jkd ?jkc))
                (not (= ?jkd ?asi))
                )
              (not (= ?jkc ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?jke Real)
  (declare-const ?jkf Real)
  (declare-const ?jkg Real)
  (assert
    (or (or (= ?jkg ?jkf)
        (= ?jkg ?jke)
        )
      (= ?jkf ?jke)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?jkh Real)
    (declare-const ?jki Real)
    (declare-const ?jkj Real)
    (assert
      (or (or (= ?jkj ?jki)
          (= ?jkj ?jkh)
          )
        (= ?jki ?jkh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jkk Real)
    (declare-const ?jkl Real)
    (declare-const ?jkm Real)
    (declare-const ?jkn Real)
    (assert
      (or (or (= ?jkn ?jkm)
          (= ?jkn ?jkl)
          )
        (= ?jkm ?jkl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jko Real)
    (declare-const ?jkp Real)
    (declare-const ?jkq Real)
    (declare-const ?jkr Real)
    (declare-const ?jks Real)
    (assert
      (or (or (= ?jks ?jkr)
          (= ?jks ?jkq)
          )
        (= ?jkr ?jkq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jkt Real)
    (declare-const ?jku Real)
    (declare-const ?jkv Real)
    (declare-const ?jkw Real)
    (declare-const ?jkx Real)
    (declare-const ?jky Real)
    (assert
      (and (and (and (not (= ?jkv ?jku))
            (not (= ?jkv ?jkt))
            )
          (not (= ?jku ?jkt))
          )
        (or (or (= ?jky ?jkx)
            (= ?jky ?jkw)
            )
          (= ?jkx ?jkw)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jkz Real)
    (declare-const ?jla Real)
    (declare-const ?jlb Real)
    (assert
      (or (or (= ?jlb ?jla)
          (= ?jlb ?jkz)
          )
        (= ?jla ?jkz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jlc Real)
    (declare-const ?jld Real)
    (declare-const ?jle Real)
    (assert
      (or (or (= ?jle ?jld)
          (= ?jle ?jlc)
          )
        (= ?jld ?jlc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jlf Real)
    (declare-const ?jlg Real)
    (declare-const ?jlh Real)
    (declare-const ?jli Real)
    (assert
      (or (or (= ?jlh ?jlg)
          (= ?jlh ?jlf)
          )
        (= ?jlg ?jlf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jlj Real)
    (declare-const ?jlk Real)
    (declare-const ?jll Real)
    (declare-const ?jlm Real)
    (declare-const ?jln Real)
    (assert
      (or (or (= ?jll ?jlk)
          (= ?jll ?jlj)
          )
        (= ?jlk ?jlj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jlo Real)
    (declare-const ?jlp Real)
    (declare-const ?jlq Real)
    (declare-const ?jlr Real)
    (declare-const ?jls Real)
    (declare-const ?jlt Real)
    (assert
      (and (or (or (= ?jlq ?jlp)
            (= ?jlq ?jlo)
            )
          (= ?jlp ?jlo)
          )
        (and (and (not (= ?jlt ?jls))
            (not (= ?jlt ?jlr))
            )
          (not (= ?jls ?jlr))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jlu Real)
    (declare-const ?jlv Real)
    (declare-const ?jlw Real)
    (assert
      (or (or (= ?jlw ?jlv)
          (= ?jlw ?jlu)
          )
        (= ?jlv ?jlu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jlx Real)
    (declare-const ?jly Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jlz Real)
    (declare-const ?jma Real)
    (declare-const ?jmb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jmc Real)
    (declare-const ?jmd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jme Real)
    (declare-const ?jmf Real)
    (declare-const ?jmg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jmh Real)
    (declare-const ?jmi Real)
    (declare-const ?jmj Real)
    (declare-const ?jmk Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?jmi ?jmh))
                (not (= ?jmi ?asi))
                )
              (not (= ?jmh ?asi))
              )
            (or (or (= ?jmk ?jmj)
                (= ?jmk ?asi)
                )
              (= ?jmj ?asi)
              )
            )
          (and (or (or (= ?jmi ?jmh)
                (= ?jmi ?asi)
                )
              (= ?jmh ?asi)
              )
            (and (and (not (= ?jmk ?jmj))
                (not (= ?jmk ?asi))
                )
              (not (= ?jmj ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jml Real)
    (declare-const ?jmm Real)
    (declare-const ?jmn Real)
    (declare-const ?jmo Real)
    (declare-const ?jmp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jmq Real)
    (declare-const ?jmr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jms Real)
    (declare-const ?jmt Real)
    (declare-const ?jmu Real)
    (declare-const ?jmv Real)
    (declare-const ?jmw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jmx Real)
    (declare-const ?jmy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jmz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jna Real)
    (declare-const ?jnb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jnc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jnd Real)
    (declare-const ?jne Real)
    (assert
      (not (= ?jnd ?jne))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jnf Real)
    (declare-const ?jng Real)
    (declare-const ?jnh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jni Real)
    (declare-const ?jnj Real)
    (declare-const ?jnk Real)
    (declare-const ?jnl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jnm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jnn Real)
    (declare-const ?jno Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jnp Real)
    (declare-const ?jnq Real)
    (declare-const ?jnr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jns Real)
    (declare-const ?jnt Real)
    (declare-const ?jnu Real)
    (declare-const ?jnv Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?jnt ?jns))
                (not (= ?jnt ?fkf))
                )
              (not (= ?jns ?fkf))
              )
            (or (or (= ?jnv ?jnu)
                (= ?jnv ?fkf)
                )
              (= ?jnu ?fkf)
              )
            )
          (and (or (or (= ?jnt ?jns)
                (= ?jnt ?fkf)
                )
              (= ?jns ?fkf)
              )
            (and (and (not (= ?jnv ?jnu))
                (not (= ?jnv ?fkf))
                )
              (not (= ?jnu ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jnw Real)
    (declare-const ?jnx Real)
    (declare-const ?jny Real)
    (declare-const ?jnz Real)
    (declare-const ?joa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?job Real)
    (declare-const ?joc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jod Real)
    (declare-const ?joe Real)
    (declare-const ?jof Real)
    (declare-const ?jog Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?joh Real)
    (declare-const ?joi Real)
    (declare-const ?joj Real)
    (declare-const ?jok Real)
    (declare-const ?jol Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jom Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jon Real)
    (declare-const ?joo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?jop Real)
  (declare-const ?joq Real)
  (declare-const ?jor Real)
  (declare-const ?jos Real)
  (assert
    (or (or (= ?jos ?jor)
        (= ?jos ?joq)
        )
      (= ?jor ?joq)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?jot Real)
    (declare-const ?jou Real)
    (declare-const ?jov Real)
    (assert
      (or (or (= ?jov ?jou)
          (= ?jov ?jot)
          )
        (= ?jou ?jot)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jow Real)
    (declare-const ?jox Real)
    (declare-const ?joy Real)
    (declare-const ?joz Real)
    (assert
      (or (or (= ?joz ?joy)
          (= ?joz ?jox)
          )
        (= ?joy ?jox)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jpa Real)
    (declare-const ?jpb Real)
    (declare-const ?jpc Real)
    (declare-const ?jpd Real)
    (declare-const ?jpe Real)
    (assert
      (or (or (= ?jpe ?jpd)
          (= ?jpe ?jpc)
          )
        (= ?jpd ?jpc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jpf Real)
    (declare-const ?jpg Real)
    (declare-const ?jph Real)
    (declare-const ?jpi Real)
    (declare-const ?jpj Real)
    (declare-const ?jpk Real)
    (assert
      (and (and (and (not (= ?jph ?jpg))
            (not (= ?jph ?jpf))
            )
          (not (= ?jpg ?jpf))
          )
        (or (or (= ?jpk ?jpj)
            (= ?jpk ?jpi)
            )
          (= ?jpj ?jpi)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jpl Real)
    (declare-const ?jpm Real)
    (declare-const ?jpn Real)
    (assert
      (or (or (= ?jpn ?jpm)
          (= ?jpn ?jpl)
          )
        (= ?jpm ?jpl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jpo Real)
    (declare-const ?jpp Real)
    (declare-const ?jpq Real)
    (assert
      (or (or (= ?jpq ?jpp)
          (= ?jpq ?jpo)
          )
        (= ?jpp ?jpo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jpr Real)
    (declare-const ?jps Real)
    (declare-const ?jpt Real)
    (declare-const ?jpu Real)
    (assert
      (or (or (= ?jpt ?jps)
          (= ?jpt ?jpr)
          )
        (= ?jps ?jpr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jpv Real)
    (declare-const ?jpw Real)
    (declare-const ?jpx Real)
    (declare-const ?jpy Real)
    (declare-const ?jpz Real)
    (assert
      (or (or (= ?jpx ?jpw)
          (= ?jpx ?jpv)
          )
        (= ?jpw ?jpv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jqa Real)
    (declare-const ?jqb Real)
    (declare-const ?jqc Real)
    (declare-const ?jqd Real)
    (declare-const ?jqe Real)
    (declare-const ?jqf Real)
    (assert
      (and (or (or (= ?jqc ?jqb)
            (= ?jqc ?jqa)
            )
          (= ?jqb ?jqa)
          )
        (and (and (not (= ?jqf ?jqe))
            (not (= ?jqf ?jqd))
            )
          (not (= ?jqe ?jqd))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jqg Real)
    (declare-const ?jqh Real)
    (declare-const ?jqi Real)
    (assert
      (or (or (= ?jqi ?jqh)
          (= ?jqi ?jqg)
          )
        (= ?jqh ?jqg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jqj Real)
    (declare-const ?jqk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jql Real)
    (declare-const ?jqm Real)
    (declare-const ?jqn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jqo Real)
    (declare-const ?jqp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jqq Real)
    (declare-const ?jqr Real)
    (declare-const ?jqs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jqt Real)
    (declare-const ?jqu Real)
    (declare-const ?jqv Real)
    (declare-const ?jqw Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?jqu ?jqt))
                (not (= ?jqu ?asi))
                )
              (not (= ?jqt ?asi))
              )
            (or (or (= ?jqw ?jqv)
                (= ?jqw ?asi)
                )
              (= ?jqv ?asi)
              )
            )
          (and (or (or (= ?jqu ?jqt)
                (= ?jqu ?asi)
                )
              (= ?jqt ?asi)
              )
            (and (and (not (= ?jqw ?jqv))
                (not (= ?jqw ?asi))
                )
              (not (= ?jqv ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jqx Real)
    (declare-const ?jqy Real)
    (declare-const ?jqz Real)
    (declare-const ?jra Real)
    (declare-const ?jrb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jrc Real)
    (declare-const ?jrd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jre Real)
    (declare-const ?jrf Real)
    (declare-const ?jrg Real)
    (declare-const ?jrh Real)
    (declare-const ?jri Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jrj Real)
    (declare-const ?jrk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jrl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jrm Real)
    (declare-const ?jrn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jro Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jrp Real)
    (declare-const ?jrq Real)
    (assert
      (not (= ?jrp ?jrq))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jrr Real)
    (declare-const ?jrs Real)
    (declare-const ?jrt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jru Real)
    (declare-const ?jrv Real)
    (declare-const ?jrw Real)
    (declare-const ?jrx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jry Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jrz Real)
    (declare-const ?jsa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jsb Real)
    (declare-const ?jsc Real)
    (declare-const ?jsd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jse Real)
    (declare-const ?jsf Real)
    (declare-const ?jsg Real)
    (declare-const ?jsh Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?jsf ?jse))
                (not (= ?jsf ?fkf))
                )
              (not (= ?jse ?fkf))
              )
            (or (or (= ?jsh ?jsg)
                (= ?jsh ?fkf)
                )
              (= ?jsg ?fkf)
              )
            )
          (and (or (or (= ?jsf ?jse)
                (= ?jsf ?fkf)
                )
              (= ?jse ?fkf)
              )
            (and (and (not (= ?jsh ?jsg))
                (not (= ?jsh ?fkf))
                )
              (not (= ?jsg ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jsi Real)
    (declare-const ?jsj Real)
    (declare-const ?jsk Real)
    (declare-const ?jsl Real)
    (declare-const ?jsm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jsn Real)
    (declare-const ?jso Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jsp Real)
    (declare-const ?jsq Real)
    (declare-const ?jsr Real)
    (declare-const ?jss Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jst Real)
    (declare-const ?jsu Real)
    (declare-const ?jsv Real)
    (declare-const ?jsw Real)
    (declare-const ?jsx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jsy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jsz Real)
    (declare-const ?jta Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?jtb Real)
  (declare-const ?jtc Real)
  (declare-const ?jtd Real)
  (declare-const ?jte Real)
  (declare-const ?jtf Real)
  (assert
    (or (or (= ?jtf ?jte)
        (= ?jtf ?jtd)
        )
      (= ?jte ?jtd)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?jtg Real)
    (declare-const ?jth Real)
    (declare-const ?jti Real)
    (assert
      (or (or (= ?jti ?jth)
          (= ?jti ?jtg)
          )
        (= ?jth ?jtg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jtj Real)
    (declare-const ?jtk Real)
    (declare-const ?jtl Real)
    (declare-const ?jtm Real)
    (assert
      (or (or (= ?jtm ?jtl)
          (= ?jtm ?jtk)
          )
        (= ?jtl ?jtk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jtn Real)
    (declare-const ?jto Real)
    (declare-const ?jtp Real)
    (declare-const ?jtq Real)
    (declare-const ?jtr Real)
    (assert
      (or (or (= ?jtr ?jtq)
          (= ?jtr ?jtp)
          )
        (= ?jtq ?jtp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jts Real)
    (declare-const ?jtt Real)
    (declare-const ?jtu Real)
    (declare-const ?jtv Real)
    (declare-const ?jtw Real)
    (declare-const ?jtx Real)
    (assert
      (and (and (and (not (= ?jtu ?jtt))
            (not (= ?jtu ?jts))
            )
          (not (= ?jtt ?jts))
          )
        (or (or (= ?jtx ?jtw)
            (= ?jtx ?jtv)
            )
          (= ?jtw ?jtv)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jty Real)
    (declare-const ?jtz Real)
    (declare-const ?jua Real)
    (assert
      (or (or (= ?jua ?jtz)
          (= ?jua ?jty)
          )
        (= ?jtz ?jty)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jub Real)
    (declare-const ?juc Real)
    (declare-const ?jud Real)
    (assert
      (or (or (= ?jud ?juc)
          (= ?jud ?jub)
          )
        (= ?juc ?jub)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jue Real)
    (declare-const ?juf Real)
    (declare-const ?jug Real)
    (declare-const ?juh Real)
    (assert
      (or (or (= ?jug ?juf)
          (= ?jug ?jue)
          )
        (= ?juf ?jue)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jui Real)
    (declare-const ?juj Real)
    (declare-const ?juk Real)
    (declare-const ?jul Real)
    (declare-const ?jum Real)
    (assert
      (or (or (= ?juk ?juj)
          (= ?juk ?jui)
          )
        (= ?juj ?jui)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jun Real)
    (declare-const ?juo Real)
    (declare-const ?jup Real)
    (declare-const ?juq Real)
    (declare-const ?jur Real)
    (declare-const ?jus Real)
    (assert
      (and (or (or (= ?jup ?juo)
            (= ?jup ?jun)
            )
          (= ?juo ?jun)
          )
        (and (and (not (= ?jus ?jur))
            (not (= ?jus ?juq))
            )
          (not (= ?jur ?juq))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jut Real)
    (declare-const ?juu Real)
    (declare-const ?juv Real)
    (assert
      (or (or (= ?juv ?juu)
          (= ?juv ?jut)
          )
        (= ?juu ?jut)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?juw Real)
    (declare-const ?jux Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?juy Real)
    (declare-const ?juz Real)
    (declare-const ?jva Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jvb Real)
    (declare-const ?jvc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jvd Real)
    (declare-const ?jve Real)
    (declare-const ?jvf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jvg Real)
    (declare-const ?jvh Real)
    (declare-const ?jvi Real)
    (declare-const ?jvj Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?jvh ?jvg))
                (not (= ?jvh ?asi))
                )
              (not (= ?jvg ?asi))
              )
            (or (or (= ?jvj ?jvi)
                (= ?jvj ?asi)
                )
              (= ?jvi ?asi)
              )
            )
          (and (or (or (= ?jvh ?jvg)
                (= ?jvh ?asi)
                )
              (= ?jvg ?asi)
              )
            (and (and (not (= ?jvj ?jvi))
                (not (= ?jvj ?asi))
                )
              (not (= ?jvi ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jvk Real)
    (declare-const ?jvl Real)
    (declare-const ?jvm Real)
    (declare-const ?jvn Real)
    (declare-const ?jvo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jvp Real)
    (declare-const ?jvq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jvr Real)
    (declare-const ?jvs Real)
    (declare-const ?jvt Real)
    (declare-const ?jvu Real)
    (declare-const ?jvv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jvw Real)
    (declare-const ?jvx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jvy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jvz Real)
    (declare-const ?jwa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jwb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jwc Real)
    (declare-const ?jwd Real)
    (assert
      (not (= ?jwc ?jwd))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jwe Real)
    (declare-const ?jwf Real)
    (declare-const ?jwg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jwh Real)
    (declare-const ?jwi Real)
    (declare-const ?jwj Real)
    (declare-const ?jwk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jwl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jwm Real)
    (declare-const ?jwn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jwo Real)
    (declare-const ?jwp Real)
    (declare-const ?jwq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jwr Real)
    (declare-const ?jws Real)
    (declare-const ?jwt Real)
    (declare-const ?jwu Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?jws ?jwr))
                (not (= ?jws ?fkf))
                )
              (not (= ?jwr ?fkf))
              )
            (or (or (= ?jwu ?jwt)
                (= ?jwu ?fkf)
                )
              (= ?jwt ?fkf)
              )
            )
          (and (or (or (= ?jws ?jwr)
                (= ?jws ?fkf)
                )
              (= ?jwr ?fkf)
              )
            (and (and (not (= ?jwu ?jwt))
                (not (= ?jwu ?fkf))
                )
              (not (= ?jwt ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jwv Real)
    (declare-const ?jww Real)
    (declare-const ?jwx Real)
    (declare-const ?jwy Real)
    (declare-const ?jwz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jxa Real)
    (declare-const ?jxb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jxc Real)
    (declare-const ?jxd Real)
    (declare-const ?jxe Real)
    (declare-const ?jxf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jxg Real)
    (declare-const ?jxh Real)
    (declare-const ?jxi Real)
    (declare-const ?jxj Real)
    (declare-const ?jxk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jxl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jxm Real)
    (declare-const ?jxn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?jxo Real)
  (declare-const ?jxp Real)
  (declare-const ?jxq Real)
  (declare-const ?jxr Real)
  (declare-const ?jxs Real)
  (declare-const ?jxt Real)
  (assert
    (and (and (and (not (= ?jxq ?jxp))
          (not (= ?jxq ?jxo))
          )
        (not (= ?jxp ?jxo))
        )
      (or (or (= ?jxt ?jxs)
          (= ?jxt ?jxr)
          )
        (= ?jxs ?jxr)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?jxu Real)
    (declare-const ?jxv Real)
    (declare-const ?jxw Real)
    (assert
      (or (or (= ?jxw ?jxv)
          (= ?jxw ?jxu)
          )
        (= ?jxv ?jxu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jxx Real)
    (declare-const ?jxy Real)
    (declare-const ?jxz Real)
    (declare-const ?jya Real)
    (assert
      (or (or (= ?jya ?jxz)
          (= ?jya ?jxy)
          )
        (= ?jxz ?jxy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jyb Real)
    (declare-const ?jyc Real)
    (declare-const ?jyd Real)
    (declare-const ?jye Real)
    (declare-const ?jyf Real)
    (assert
      (or (or (= ?jyf ?jye)
          (= ?jyf ?jyd)
          )
        (= ?jye ?jyd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jyg Real)
    (declare-const ?jyh Real)
    (declare-const ?jyi Real)
    (declare-const ?jyj Real)
    (declare-const ?jyk Real)
    (declare-const ?jyl Real)
    (assert
      (and (and (and (not (= ?jyi ?jyh))
            (not (= ?jyi ?jyg))
            )
          (not (= ?jyh ?jyg))
          )
        (or (or (= ?jyl ?jyk)
            (= ?jyl ?jyj)
            )
          (= ?jyk ?jyj)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jym Real)
    (declare-const ?jyn Real)
    (declare-const ?jyo Real)
    (assert
      (or (or (= ?jyo ?jyn)
          (= ?jyo ?jym)
          )
        (= ?jyn ?jym)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jyp Real)
    (declare-const ?jyq Real)
    (declare-const ?jyr Real)
    (assert
      (or (or (= ?jyr ?jyq)
          (= ?jyr ?jyp)
          )
        (= ?jyq ?jyp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jys Real)
    (declare-const ?jyt Real)
    (declare-const ?jyu Real)
    (declare-const ?jyv Real)
    (assert
      (or (or (= ?jyu ?jyt)
          (= ?jyu ?jys)
          )
        (= ?jyt ?jys)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jyw Real)
    (declare-const ?jyx Real)
    (declare-const ?jyy Real)
    (declare-const ?jyz Real)
    (declare-const ?jza Real)
    (assert
      (or (or (= ?jyy ?jyx)
          (= ?jyy ?jyw)
          )
        (= ?jyx ?jyw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jzb Real)
    (declare-const ?jzc Real)
    (declare-const ?jzd Real)
    (declare-const ?jze Real)
    (declare-const ?jzf Real)
    (declare-const ?jzg Real)
    (assert
      (and (or (or (= ?jzd ?jzc)
            (= ?jzd ?jzb)
            )
          (= ?jzc ?jzb)
          )
        (and (and (not (= ?jzg ?jzf))
            (not (= ?jzg ?jze))
            )
          (not (= ?jzf ?jze))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jzh Real)
    (declare-const ?jzi Real)
    (declare-const ?jzj Real)
    (assert
      (or (or (= ?jzj ?jzi)
          (= ?jzj ?jzh)
          )
        (= ?jzi ?jzh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jzk Real)
    (declare-const ?jzl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jzm Real)
    (declare-const ?jzn Real)
    (declare-const ?jzo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jzp Real)
    (declare-const ?jzq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jzr Real)
    (declare-const ?jzs Real)
    (declare-const ?jzt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jzu Real)
    (declare-const ?jzv Real)
    (declare-const ?jzw Real)
    (declare-const ?jzx Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?jzv ?jzu))
                (not (= ?jzv ?asi))
                )
              (not (= ?jzu ?asi))
              )
            (or (or (= ?jzx ?jzw)
                (= ?jzx ?asi)
                )
              (= ?jzw ?asi)
              )
            )
          (and (or (or (= ?jzv ?jzu)
                (= ?jzv ?asi)
                )
              (= ?jzu ?asi)
              )
            (and (and (not (= ?jzx ?jzw))
                (not (= ?jzx ?asi))
                )
              (not (= ?jzw ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?jzy Real)
    (declare-const ?jzz Real)
    (declare-const ?kaa Real)
    (declare-const ?kab Real)
    (declare-const ?kac Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kad Real)
    (declare-const ?kae Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kaf Real)
    (declare-const ?kag Real)
    (declare-const ?kah Real)
    (declare-const ?kai Real)
    (declare-const ?kaj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kak Real)
    (declare-const ?kal Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kam Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kan Real)
    (declare-const ?kao Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kap Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kaq Real)
    (declare-const ?kar Real)
    (assert
      (not (= ?kaq ?kar))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kas Real)
    (declare-const ?kat Real)
    (declare-const ?kau Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kav Real)
    (declare-const ?kaw Real)
    (declare-const ?kax Real)
    (declare-const ?kay Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kaz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kba Real)
    (declare-const ?kbb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kbc Real)
    (declare-const ?kbd Real)
    (declare-const ?kbe Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kbf Real)
    (declare-const ?kbg Real)
    (declare-const ?kbh Real)
    (declare-const ?kbi Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?kbg ?kbf))
                (not (= ?kbg ?fkf))
                )
              (not (= ?kbf ?fkf))
              )
            (or (or (= ?kbi ?kbh)
                (= ?kbi ?fkf)
                )
              (= ?kbh ?fkf)
              )
            )
          (and (or (or (= ?kbg ?kbf)
                (= ?kbg ?fkf)
                )
              (= ?kbf ?fkf)
              )
            (and (and (not (= ?kbi ?kbh))
                (not (= ?kbi ?fkf))
                )
              (not (= ?kbh ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kbj Real)
    (declare-const ?kbk Real)
    (declare-const ?kbl Real)
    (declare-const ?kbm Real)
    (declare-const ?kbn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kbo Real)
    (declare-const ?kbp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kbq Real)
    (declare-const ?kbr Real)
    (declare-const ?kbs Real)
    (declare-const ?kbt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kbu Real)
    (declare-const ?kbv Real)
    (declare-const ?kbw Real)
    (declare-const ?kbx Real)
    (declare-const ?kby Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kbz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kca Real)
    (declare-const ?kcb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?kcc Real)
  (declare-const ?kcd Real)
  (declare-const ?kce Real)
  (assert
    (or (or (= ?kce ?kcd)
        (= ?kce ?kcc)
        )
      (= ?kcd ?kcc)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?kcf Real)
    (declare-const ?kcg Real)
    (declare-const ?kch Real)
    (assert
      (or (or (= ?kch ?kcg)
          (= ?kch ?kcf)
          )
        (= ?kcg ?kcf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kci Real)
    (declare-const ?kcj Real)
    (declare-const ?kck Real)
    (declare-const ?kcl Real)
    (assert
      (or (or (= ?kcl ?kck)
          (= ?kcl ?kcj)
          )
        (= ?kck ?kcj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kcm Real)
    (declare-const ?kcn Real)
    (declare-const ?kco Real)
    (declare-const ?kcp Real)
    (declare-const ?kcq Real)
    (assert
      (or (or (= ?kcq ?kcp)
          (= ?kcq ?kco)
          )
        (= ?kcp ?kco)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kcr Real)
    (declare-const ?kcs Real)
    (declare-const ?kct Real)
    (declare-const ?kcu Real)
    (declare-const ?kcv Real)
    (declare-const ?kcw Real)
    (assert
      (and (and (and (not (= ?kct ?kcs))
            (not (= ?kct ?kcr))
            )
          (not (= ?kcs ?kcr))
          )
        (or (or (= ?kcw ?kcv)
            (= ?kcw ?kcu)
            )
          (= ?kcv ?kcu)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kcx Real)
    (declare-const ?kcy Real)
    (declare-const ?kcz Real)
    (assert
      (or (or (= ?kcz ?kcy)
          (= ?kcz ?kcx)
          )
        (= ?kcy ?kcx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kda Real)
    (declare-const ?kdb Real)
    (declare-const ?kdc Real)
    (assert
      (or (or (= ?kdc ?kdb)
          (= ?kdc ?kda)
          )
        (= ?kdb ?kda)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kdd Real)
    (declare-const ?kde Real)
    (declare-const ?kdf Real)
    (declare-const ?kdg Real)
    (assert
      (or (or (= ?kdf ?kde)
          (= ?kdf ?kdd)
          )
        (= ?kde ?kdd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kdh Real)
    (declare-const ?kdi Real)
    (declare-const ?kdj Real)
    (declare-const ?kdk Real)
    (declare-const ?kdl Real)
    (assert
      (or (or (= ?kdj ?kdi)
          (= ?kdj ?kdh)
          )
        (= ?kdi ?kdh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kdm Real)
    (declare-const ?kdn Real)
    (declare-const ?kdo Real)
    (declare-const ?kdp Real)
    (declare-const ?kdq Real)
    (declare-const ?kdr Real)
    (assert
      (and (or (or (= ?kdo ?kdn)
            (= ?kdo ?kdm)
            )
          (= ?kdn ?kdm)
          )
        (and (and (not (= ?kdr ?kdq))
            (not (= ?kdr ?kdp))
            )
          (not (= ?kdq ?kdp))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kds Real)
    (declare-const ?kdt Real)
    (declare-const ?kdu Real)
    (assert
      (or (or (= ?kdu ?kdt)
          (= ?kdu ?kds)
          )
        (= ?kdt ?kds)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kdv Real)
    (declare-const ?kdw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kdx Real)
    (declare-const ?kdy Real)
    (declare-const ?kdz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kea Real)
    (declare-const ?keb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kec Real)
    (declare-const ?ked Real)
    (declare-const ?kee Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kef Real)
    (declare-const ?keg Real)
    (declare-const ?keh Real)
    (declare-const ?kei Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?keg ?kef))
                (not (= ?keg ?asi))
                )
              (not (= ?kef ?asi))
              )
            (or (or (= ?kei ?keh)
                (= ?kei ?asi)
                )
              (= ?keh ?asi)
              )
            )
          (and (or (or (= ?keg ?kef)
                (= ?keg ?asi)
                )
              (= ?kef ?asi)
              )
            (and (and (not (= ?kei ?keh))
                (not (= ?kei ?asi))
                )
              (not (= ?keh ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kej Real)
    (declare-const ?kek Real)
    (declare-const ?kel Real)
    (declare-const ?kem Real)
    (declare-const ?ken Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?keo Real)
    (declare-const ?kep Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?keq Real)
    (declare-const ?ker Real)
    (declare-const ?kes Real)
    (declare-const ?ket Real)
    (declare-const ?keu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kev Real)
    (declare-const ?kew Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kex Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?key Real)
    (declare-const ?kez Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kfa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kfb Real)
    (declare-const ?kfc Real)
    (assert
      (not (= ?kfb ?kfc))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kfd Real)
    (declare-const ?kfe Real)
    (declare-const ?kff Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kfg Real)
    (declare-const ?kfh Real)
    (declare-const ?kfi Real)
    (declare-const ?kfj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kfk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kfl Real)
    (declare-const ?kfm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kfn Real)
    (declare-const ?kfo Real)
    (declare-const ?kfp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kfq Real)
    (declare-const ?kfr Real)
    (declare-const ?kfs Real)
    (declare-const ?kft Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?kfr ?kfq))
                (not (= ?kfr ?fkf))
                )
              (not (= ?kfq ?fkf))
              )
            (or (or (= ?kft ?kfs)
                (= ?kft ?fkf)
                )
              (= ?kfs ?fkf)
              )
            )
          (and (or (or (= ?kfr ?kfq)
                (= ?kfr ?fkf)
                )
              (= ?kfq ?fkf)
              )
            (and (and (not (= ?kft ?kfs))
                (not (= ?kft ?fkf))
                )
              (not (= ?kfs ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kfu Real)
    (declare-const ?kfv Real)
    (declare-const ?kfw Real)
    (declare-const ?kfx Real)
    (declare-const ?kfy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kfz Real)
    (declare-const ?kga Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kgb Real)
    (declare-const ?kgc Real)
    (declare-const ?kgd Real)
    (declare-const ?kge Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kgf Real)
    (declare-const ?kgg Real)
    (declare-const ?kgh Real)
    (declare-const ?kgi Real)
    (declare-const ?kgj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kgk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kgl Real)
    (declare-const ?kgm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?kgn Real)
  (declare-const ?kgo Real)
  (declare-const ?kgp Real)
  (assert
    (or (or (= ?kgp ?kgo)
        (= ?kgp ?kgn)
        )
      (= ?kgo ?kgn)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?kgq Real)
    (declare-const ?kgr Real)
    (declare-const ?kgs Real)
    (assert
      (or (or (= ?kgs ?kgr)
          (= ?kgs ?kgq)
          )
        (= ?kgr ?kgq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kgt Real)
    (declare-const ?kgu Real)
    (declare-const ?kgv Real)
    (declare-const ?kgw Real)
    (assert
      (or (or (= ?kgw ?kgv)
          (= ?kgw ?kgu)
          )
        (= ?kgv ?kgu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kgx Real)
    (declare-const ?kgy Real)
    (declare-const ?kgz Real)
    (declare-const ?kha Real)
    (declare-const ?khb Real)
    (assert
      (or (or (= ?khb ?kha)
          (= ?khb ?kgz)
          )
        (= ?kha ?kgz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?khc Real)
    (declare-const ?khd Real)
    (declare-const ?khe Real)
    (declare-const ?khf Real)
    (declare-const ?khg Real)
    (declare-const ?khh Real)
    (assert
      (and (and (and (not (= ?khe ?khd))
            (not (= ?khe ?khc))
            )
          (not (= ?khd ?khc))
          )
        (or (or (= ?khh ?khg)
            (= ?khh ?khf)
            )
          (= ?khg ?khf)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?khi Real)
    (declare-const ?khj Real)
    (declare-const ?khk Real)
    (assert
      (or (or (= ?khk ?khj)
          (= ?khk ?khi)
          )
        (= ?khj ?khi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?khl Real)
    (declare-const ?khm Real)
    (declare-const ?khn Real)
    (assert
      (or (or (= ?khn ?khm)
          (= ?khn ?khl)
          )
        (= ?khm ?khl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kho Real)
    (declare-const ?khp Real)
    (declare-const ?khq Real)
    (declare-const ?khr Real)
    (assert
      (or (or (= ?khq ?khp)
          (= ?khq ?kho)
          )
        (= ?khp ?kho)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?khs Real)
    (declare-const ?kht Real)
    (declare-const ?khu Real)
    (declare-const ?khv Real)
    (declare-const ?khw Real)
    (assert
      (or (or (= ?khu ?kht)
          (= ?khu ?khs)
          )
        (= ?kht ?khs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?khx Real)
    (declare-const ?khy Real)
    (declare-const ?khz Real)
    (declare-const ?kia Real)
    (declare-const ?kib Real)
    (declare-const ?kic Real)
    (assert
      (and (or (or (= ?khz ?khy)
            (= ?khz ?khx)
            )
          (= ?khy ?khx)
          )
        (and (and (not (= ?kic ?kib))
            (not (= ?kic ?kia))
            )
          (not (= ?kib ?kia))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kid Real)
    (declare-const ?kie Real)
    (declare-const ?kif Real)
    (assert
      (or (or (= ?kif ?kie)
          (= ?kif ?kid)
          )
        (= ?kie ?kid)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kig Real)
    (declare-const ?kih Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kii Real)
    (declare-const ?kij Real)
    (declare-const ?kik Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kil Real)
    (declare-const ?kim Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kin Real)
    (declare-const ?kio Real)
    (declare-const ?kip Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kiq Real)
    (declare-const ?kir Real)
    (declare-const ?kis Real)
    (declare-const ?kit Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?kir ?kiq))
                (not (= ?kir ?asi))
                )
              (not (= ?kiq ?asi))
              )
            (or (or (= ?kit ?kis)
                (= ?kit ?asi)
                )
              (= ?kis ?asi)
              )
            )
          (and (or (or (= ?kir ?kiq)
                (= ?kir ?asi)
                )
              (= ?kiq ?asi)
              )
            (and (and (not (= ?kit ?kis))
                (not (= ?kit ?asi))
                )
              (not (= ?kis ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kiu Real)
    (declare-const ?kiv Real)
    (declare-const ?kiw Real)
    (declare-const ?kix Real)
    (declare-const ?kiy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kiz Real)
    (declare-const ?kja Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kjb Real)
    (declare-const ?kjc Real)
    (declare-const ?kjd Real)
    (declare-const ?kje Real)
    (declare-const ?kjf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kjg Real)
    (declare-const ?kjh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kji Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kjj Real)
    (declare-const ?kjk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kjl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kjm Real)
    (declare-const ?kjn Real)
    (assert
      (not (= ?kjm ?kjn))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kjo Real)
    (declare-const ?kjp Real)
    (declare-const ?kjq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kjr Real)
    (declare-const ?kjs Real)
    (declare-const ?kjt Real)
    (declare-const ?kju Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kjv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kjw Real)
    (declare-const ?kjx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kjy Real)
    (declare-const ?kjz Real)
    (declare-const ?kka Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kkb Real)
    (declare-const ?kkc Real)
    (declare-const ?kkd Real)
    (declare-const ?kke Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?kkc ?kkb))
                (not (= ?kkc ?fkf))
                )
              (not (= ?kkb ?fkf))
              )
            (or (or (= ?kke ?kkd)
                (= ?kke ?fkf)
                )
              (= ?kkd ?fkf)
              )
            )
          (and (or (or (= ?kkc ?kkb)
                (= ?kkc ?fkf)
                )
              (= ?kkb ?fkf)
              )
            (and (and (not (= ?kke ?kkd))
                (not (= ?kke ?fkf))
                )
              (not (= ?kkd ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kkf Real)
    (declare-const ?kkg Real)
    (declare-const ?kkh Real)
    (declare-const ?kki Real)
    (declare-const ?kkj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kkk Real)
    (declare-const ?kkl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kkm Real)
    (declare-const ?kkn Real)
    (declare-const ?kko Real)
    (declare-const ?kkp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kkq Real)
    (declare-const ?kkr Real)
    (declare-const ?kks Real)
    (declare-const ?kkt Real)
    (declare-const ?kku Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kkv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kkw Real)
    (declare-const ?kkx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?kky Real)
  (declare-const ?kkz Real)
  (declare-const ?kla Real)
  (declare-const ?klb Real)
  (assert
    (or (or (= ?kla ?kkz)
        (= ?kla ?kky)
        )
      (= ?kkz ?kky)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?klc Real)
    (declare-const ?kld Real)
    (declare-const ?kle Real)
    (assert
      (or (or (= ?kle ?kld)
          (= ?kle ?klc)
          )
        (= ?kld ?klc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?klf Real)
    (declare-const ?klg Real)
    (declare-const ?klh Real)
    (declare-const ?kli Real)
    (assert
      (or (or (= ?kli ?klh)
          (= ?kli ?klg)
          )
        (= ?klh ?klg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?klj Real)
    (declare-const ?klk Real)
    (declare-const ?kll Real)
    (declare-const ?klm Real)
    (declare-const ?kln Real)
    (assert
      (or (or (= ?kln ?klm)
          (= ?kln ?kll)
          )
        (= ?klm ?kll)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?klo Real)
    (declare-const ?klp Real)
    (declare-const ?klq Real)
    (declare-const ?klr Real)
    (declare-const ?kls Real)
    (declare-const ?klt Real)
    (assert
      (and (and (and (not (= ?klq ?klp))
            (not (= ?klq ?klo))
            )
          (not (= ?klp ?klo))
          )
        (or (or (= ?klt ?kls)
            (= ?klt ?klr)
            )
          (= ?kls ?klr)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?klu Real)
    (declare-const ?klv Real)
    (declare-const ?klw Real)
    (assert
      (or (or (= ?klw ?klv)
          (= ?klw ?klu)
          )
        (= ?klv ?klu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?klx Real)
    (declare-const ?kly Real)
    (declare-const ?klz Real)
    (assert
      (or (or (= ?klz ?kly)
          (= ?klz ?klx)
          )
        (= ?kly ?klx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kma Real)
    (declare-const ?kmb Real)
    (declare-const ?kmc Real)
    (declare-const ?kmd Real)
    (assert
      (or (or (= ?kmc ?kmb)
          (= ?kmc ?kma)
          )
        (= ?kmb ?kma)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kme Real)
    (declare-const ?kmf Real)
    (declare-const ?kmg Real)
    (declare-const ?kmh Real)
    (declare-const ?kmi Real)
    (assert
      (or (or (= ?kmg ?kmf)
          (= ?kmg ?kme)
          )
        (= ?kmf ?kme)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kmj Real)
    (declare-const ?kmk Real)
    (declare-const ?kml Real)
    (declare-const ?kmm Real)
    (declare-const ?kmn Real)
    (declare-const ?kmo Real)
    (assert
      (and (or (or (= ?kml ?kmk)
            (= ?kml ?kmj)
            )
          (= ?kmk ?kmj)
          )
        (and (and (not (= ?kmo ?kmn))
            (not (= ?kmo ?kmm))
            )
          (not (= ?kmn ?kmm))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kmp Real)
    (declare-const ?kmq Real)
    (declare-const ?kmr Real)
    (assert
      (or (or (= ?kmr ?kmq)
          (= ?kmr ?kmp)
          )
        (= ?kmq ?kmp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kms Real)
    (declare-const ?kmt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kmu Real)
    (declare-const ?kmv Real)
    (declare-const ?kmw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kmx Real)
    (declare-const ?kmy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kmz Real)
    (declare-const ?kna Real)
    (declare-const ?knb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?knc Real)
    (declare-const ?knd Real)
    (declare-const ?kne Real)
    (declare-const ?knf Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?knd ?knc))
                (not (= ?knd ?asi))
                )
              (not (= ?knc ?asi))
              )
            (or (or (= ?knf ?kne)
                (= ?knf ?asi)
                )
              (= ?kne ?asi)
              )
            )
          (and (or (or (= ?knd ?knc)
                (= ?knd ?asi)
                )
              (= ?knc ?asi)
              )
            (and (and (not (= ?knf ?kne))
                (not (= ?knf ?asi))
                )
              (not (= ?kne ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kng Real)
    (declare-const ?knh Real)
    (declare-const ?kni Real)
    (declare-const ?knj Real)
    (declare-const ?knk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?knl Real)
    (declare-const ?knm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?knn Real)
    (declare-const ?kno Real)
    (declare-const ?knp Real)
    (declare-const ?knq Real)
    (declare-const ?knr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kns Real)
    (declare-const ?knt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?knu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?knv Real)
    (declare-const ?knw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?knx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kny Real)
    (declare-const ?knz Real)
    (assert
      (not (= ?kny ?knz))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?koa Real)
    (declare-const ?kob Real)
    (declare-const ?koc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kod Real)
    (declare-const ?koe Real)
    (declare-const ?kof Real)
    (declare-const ?kog Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?koh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?koi Real)
    (declare-const ?koj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kok Real)
    (declare-const ?kol Real)
    (declare-const ?kom Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kon Real)
    (declare-const ?koo Real)
    (declare-const ?kop Real)
    (declare-const ?koq Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?koo ?kon))
                (not (= ?koo ?fkf))
                )
              (not (= ?kon ?fkf))
              )
            (or (or (= ?koq ?kop)
                (= ?koq ?fkf)
                )
              (= ?kop ?fkf)
              )
            )
          (and (or (or (= ?koo ?kon)
                (= ?koo ?fkf)
                )
              (= ?kon ?fkf)
              )
            (and (and (not (= ?koq ?kop))
                (not (= ?koq ?fkf))
                )
              (not (= ?kop ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kor Real)
    (declare-const ?kos Real)
    (declare-const ?kot Real)
    (declare-const ?kou Real)
    (declare-const ?kov Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kow Real)
    (declare-const ?kox Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?koy Real)
    (declare-const ?koz Real)
    (declare-const ?kpa Real)
    (declare-const ?kpb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kpc Real)
    (declare-const ?kpd Real)
    (declare-const ?kpe Real)
    (declare-const ?kpf Real)
    (declare-const ?kpg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kph Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kpi Real)
    (declare-const ?kpj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?kpk Real)
  (declare-const ?kpl Real)
  (declare-const ?kpm Real)
  (declare-const ?kpn Real)
  (declare-const ?kpo Real)
  (assert
    (or (or (= ?kpm ?kpl)
        (= ?kpm ?kpk)
        )
      (= ?kpl ?kpk)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?kpp Real)
    (declare-const ?kpq Real)
    (declare-const ?kpr Real)
    (assert
      (or (or (= ?kpr ?kpq)
          (= ?kpr ?kpp)
          )
        (= ?kpq ?kpp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kps Real)
    (declare-const ?kpt Real)
    (declare-const ?kpu Real)
    (declare-const ?kpv Real)
    (assert
      (or (or (= ?kpv ?kpu)
          (= ?kpv ?kpt)
          )
        (= ?kpu ?kpt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kpw Real)
    (declare-const ?kpx Real)
    (declare-const ?kpy Real)
    (declare-const ?kpz Real)
    (declare-const ?kqa Real)
    (assert
      (or (or (= ?kqa ?kpz)
          (= ?kqa ?kpy)
          )
        (= ?kpz ?kpy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kqb Real)
    (declare-const ?kqc Real)
    (declare-const ?kqd Real)
    (declare-const ?kqe Real)
    (declare-const ?kqf Real)
    (declare-const ?kqg Real)
    (assert
      (and (and (and (not (= ?kqd ?kqc))
            (not (= ?kqd ?kqb))
            )
          (not (= ?kqc ?kqb))
          )
        (or (or (= ?kqg ?kqf)
            (= ?kqg ?kqe)
            )
          (= ?kqf ?kqe)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kqh Real)
    (declare-const ?kqi Real)
    (declare-const ?kqj Real)
    (assert
      (or (or (= ?kqj ?kqi)
          (= ?kqj ?kqh)
          )
        (= ?kqi ?kqh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kqk Real)
    (declare-const ?kql Real)
    (declare-const ?kqm Real)
    (assert
      (or (or (= ?kqm ?kql)
          (= ?kqm ?kqk)
          )
        (= ?kql ?kqk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kqn Real)
    (declare-const ?kqo Real)
    (declare-const ?kqp Real)
    (declare-const ?kqq Real)
    (assert
      (or (or (= ?kqp ?kqo)
          (= ?kqp ?kqn)
          )
        (= ?kqo ?kqn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kqr Real)
    (declare-const ?kqs Real)
    (declare-const ?kqt Real)
    (declare-const ?kqu Real)
    (declare-const ?kqv Real)
    (assert
      (or (or (= ?kqt ?kqs)
          (= ?kqt ?kqr)
          )
        (= ?kqs ?kqr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kqw Real)
    (declare-const ?kqx Real)
    (declare-const ?kqy Real)
    (declare-const ?kqz Real)
    (declare-const ?kra Real)
    (declare-const ?krb Real)
    (assert
      (and (or (or (= ?kqy ?kqx)
            (= ?kqy ?kqw)
            )
          (= ?kqx ?kqw)
          )
        (and (and (not (= ?krb ?kra))
            (not (= ?krb ?kqz))
            )
          (not (= ?kra ?kqz))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?krc Real)
    (declare-const ?krd Real)
    (declare-const ?kre Real)
    (assert
      (or (or (= ?kre ?krd)
          (= ?kre ?krc)
          )
        (= ?krd ?krc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?krf Real)
    (declare-const ?krg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?krh Real)
    (declare-const ?kri Real)
    (declare-const ?krj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?krk Real)
    (declare-const ?krl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?krm Real)
    (declare-const ?krn Real)
    (declare-const ?kro Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?krp Real)
    (declare-const ?krq Real)
    (declare-const ?krr Real)
    (declare-const ?krs Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?krq ?krp))
                (not (= ?krq ?asi))
                )
              (not (= ?krp ?asi))
              )
            (or (or (= ?krs ?krr)
                (= ?krs ?asi)
                )
              (= ?krr ?asi)
              )
            )
          (and (or (or (= ?krq ?krp)
                (= ?krq ?asi)
                )
              (= ?krp ?asi)
              )
            (and (and (not (= ?krs ?krr))
                (not (= ?krs ?asi))
                )
              (not (= ?krr ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?krt Real)
    (declare-const ?kru Real)
    (declare-const ?krv Real)
    (declare-const ?krw Real)
    (declare-const ?krx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kry Real)
    (declare-const ?krz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ksa Real)
    (declare-const ?ksb Real)
    (declare-const ?ksc Real)
    (declare-const ?ksd Real)
    (declare-const ?kse Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ksf Real)
    (declare-const ?ksg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ksh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ksi Real)
    (declare-const ?ksj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ksk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ksl Real)
    (declare-const ?ksm Real)
    (assert
      (not (= ?ksl ?ksm))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ksn Real)
    (declare-const ?kso Real)
    (declare-const ?ksp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ksq Real)
    (declare-const ?ksr Real)
    (declare-const ?kss Real)
    (declare-const ?kst Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ksu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ksv Real)
    (declare-const ?ksw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ksx Real)
    (declare-const ?ksy Real)
    (declare-const ?ksz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kta Real)
    (declare-const ?ktb Real)
    (declare-const ?ktc Real)
    (declare-const ?ktd Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ktb ?kta))
                (not (= ?ktb ?fkf))
                )
              (not (= ?kta ?fkf))
              )
            (or (or (= ?ktd ?ktc)
                (= ?ktd ?fkf)
                )
              (= ?ktc ?fkf)
              )
            )
          (and (or (or (= ?ktb ?kta)
                (= ?ktb ?fkf)
                )
              (= ?kta ?fkf)
              )
            (and (and (not (= ?ktd ?ktc))
                (not (= ?ktd ?fkf))
                )
              (not (= ?ktc ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kte Real)
    (declare-const ?ktf Real)
    (declare-const ?ktg Real)
    (declare-const ?kth Real)
    (declare-const ?kti Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ktj Real)
    (declare-const ?ktk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ktl Real)
    (declare-const ?ktm Real)
    (declare-const ?ktn Real)
    (declare-const ?kto Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ktp Real)
    (declare-const ?ktq Real)
    (declare-const ?ktr Real)
    (declare-const ?kts Real)
    (declare-const ?ktt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ktu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ktv Real)
    (declare-const ?ktw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ktx Real)
  (declare-const ?kty Real)
  (declare-const ?ktz Real)
  (declare-const ?kua Real)
  (declare-const ?kub Real)
  (declare-const ?kuc Real)
  (assert
    (and (or (or (= ?ktz ?kty)
          (= ?ktz ?ktx)
          )
        (= ?kty ?ktx)
        )
      (and (and (not (= ?kuc ?kub))
          (not (= ?kuc ?kua))
          )
        (not (= ?kub ?kua))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?kud Real)
    (declare-const ?kue Real)
    (declare-const ?kuf Real)
    (assert
      (or (or (= ?kuf ?kue)
          (= ?kuf ?kud)
          )
        (= ?kue ?kud)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kug Real)
    (declare-const ?kuh Real)
    (declare-const ?kui Real)
    (declare-const ?kuj Real)
    (assert
      (or (or (= ?kuj ?kui)
          (= ?kuj ?kuh)
          )
        (= ?kui ?kuh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kuk Real)
    (declare-const ?kul Real)
    (declare-const ?kum Real)
    (declare-const ?kun Real)
    (declare-const ?kuo Real)
    (assert
      (or (or (= ?kuo ?kun)
          (= ?kuo ?kum)
          )
        (= ?kun ?kum)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kup Real)
    (declare-const ?kuq Real)
    (declare-const ?kur Real)
    (declare-const ?kus Real)
    (declare-const ?kut Real)
    (declare-const ?kuu Real)
    (assert
      (and (and (and (not (= ?kur ?kuq))
            (not (= ?kur ?kup))
            )
          (not (= ?kuq ?kup))
          )
        (or (or (= ?kuu ?kut)
            (= ?kuu ?kus)
            )
          (= ?kut ?kus)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kuv Real)
    (declare-const ?kuw Real)
    (declare-const ?kux Real)
    (assert
      (or (or (= ?kux ?kuw)
          (= ?kux ?kuv)
          )
        (= ?kuw ?kuv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kuy Real)
    (declare-const ?kuz Real)
    (declare-const ?kva Real)
    (assert
      (or (or (= ?kva ?kuz)
          (= ?kva ?kuy)
          )
        (= ?kuz ?kuy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kvb Real)
    (declare-const ?kvc Real)
    (declare-const ?kvd Real)
    (declare-const ?kve Real)
    (assert
      (or (or (= ?kvd ?kvc)
          (= ?kvd ?kvb)
          )
        (= ?kvc ?kvb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kvf Real)
    (declare-const ?kvg Real)
    (declare-const ?kvh Real)
    (declare-const ?kvi Real)
    (declare-const ?kvj Real)
    (assert
      (or (or (= ?kvh ?kvg)
          (= ?kvh ?kvf)
          )
        (= ?kvg ?kvf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kvk Real)
    (declare-const ?kvl Real)
    (declare-const ?kvm Real)
    (declare-const ?kvn Real)
    (declare-const ?kvo Real)
    (declare-const ?kvp Real)
    (assert
      (and (or (or (= ?kvm ?kvl)
            (= ?kvm ?kvk)
            )
          (= ?kvl ?kvk)
          )
        (and (and (not (= ?kvp ?kvo))
            (not (= ?kvp ?kvn))
            )
          (not (= ?kvo ?kvn))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kvq Real)
    (declare-const ?kvr Real)
    (declare-const ?kvs Real)
    (assert
      (or (or (= ?kvs ?kvr)
          (= ?kvs ?kvq)
          )
        (= ?kvr ?kvq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kvt Real)
    (declare-const ?kvu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kvv Real)
    (declare-const ?kvw Real)
    (declare-const ?kvx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kvy Real)
    (declare-const ?kvz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kwa Real)
    (declare-const ?kwb Real)
    (declare-const ?kwc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kwd Real)
    (declare-const ?kwe Real)
    (declare-const ?kwf Real)
    (declare-const ?kwg Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?kwe ?kwd))
                (not (= ?kwe ?asi))
                )
              (not (= ?kwd ?asi))
              )
            (or (or (= ?kwg ?kwf)
                (= ?kwg ?asi)
                )
              (= ?kwf ?asi)
              )
            )
          (and (or (or (= ?kwe ?kwd)
                (= ?kwe ?asi)
                )
              (= ?kwd ?asi)
              )
            (and (and (not (= ?kwg ?kwf))
                (not (= ?kwg ?asi))
                )
              (not (= ?kwf ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kwh Real)
    (declare-const ?kwi Real)
    (declare-const ?kwj Real)
    (declare-const ?kwk Real)
    (declare-const ?kwl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kwm Real)
    (declare-const ?kwn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kwo Real)
    (declare-const ?kwp Real)
    (declare-const ?kwq Real)
    (declare-const ?kwr Real)
    (declare-const ?kws Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kwt Real)
    (declare-const ?kwu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kwv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kww Real)
    (declare-const ?kwx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kwy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kwz Real)
    (declare-const ?kxa Real)
    (assert
      (not (= ?kwz ?kxa))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kxb Real)
    (declare-const ?kxc Real)
    (declare-const ?kxd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kxe Real)
    (declare-const ?kxf Real)
    (declare-const ?kxg Real)
    (declare-const ?kxh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kxi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kxj Real)
    (declare-const ?kxk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kxl Real)
    (declare-const ?kxm Real)
    (declare-const ?kxn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kxo Real)
    (declare-const ?kxp Real)
    (declare-const ?kxq Real)
    (declare-const ?kxr Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?kxp ?kxo))
                (not (= ?kxp ?fkf))
                )
              (not (= ?kxo ?fkf))
              )
            (or (or (= ?kxr ?kxq)
                (= ?kxr ?fkf)
                )
              (= ?kxq ?fkf)
              )
            )
          (and (or (or (= ?kxp ?kxo)
                (= ?kxp ?fkf)
                )
              (= ?kxo ?fkf)
              )
            (and (and (not (= ?kxr ?kxq))
                (not (= ?kxr ?fkf))
                )
              (not (= ?kxq ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kxs Real)
    (declare-const ?kxt Real)
    (declare-const ?kxu Real)
    (declare-const ?kxv Real)
    (declare-const ?kxw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kxx Real)
    (declare-const ?kxy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kxz Real)
    (declare-const ?kya Real)
    (declare-const ?kyb Real)
    (declare-const ?kyc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kyd Real)
    (declare-const ?kye Real)
    (declare-const ?kyf Real)
    (declare-const ?kyg Real)
    (declare-const ?kyh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kyi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kyj Real)
    (declare-const ?kyk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?kyl Real)
  (declare-const ?kym Real)
  (declare-const ?kyn Real)
  (assert
    (or (or (= ?kyn ?kym)
        (= ?kyn ?kyl)
        )
      (= ?kym ?kyl)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?kyo Real)
    (declare-const ?kyp Real)
    (declare-const ?kyq Real)
    (assert
      (or (or (= ?kyq ?kyp)
          (= ?kyq ?kyo)
          )
        (= ?kyp ?kyo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kyr Real)
    (declare-const ?kys Real)
    (declare-const ?kyt Real)
    (declare-const ?kyu Real)
    (assert
      (or (or (= ?kyu ?kyt)
          (= ?kyu ?kys)
          )
        (= ?kyt ?kys)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kyv Real)
    (declare-const ?kyw Real)
    (declare-const ?kyx Real)
    (declare-const ?kyy Real)
    (declare-const ?kyz Real)
    (assert
      (or (or (= ?kyz ?kyy)
          (= ?kyz ?kyx)
          )
        (= ?kyy ?kyx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kza Real)
    (declare-const ?kzb Real)
    (declare-const ?kzc Real)
    (declare-const ?kzd Real)
    (declare-const ?kze Real)
    (declare-const ?kzf Real)
    (assert
      (and (and (and (not (= ?kzc ?kzb))
            (not (= ?kzc ?kza))
            )
          (not (= ?kzb ?kza))
          )
        (or (or (= ?kzf ?kze)
            (= ?kzf ?kzd)
            )
          (= ?kze ?kzd)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kzg Real)
    (declare-const ?kzh Real)
    (declare-const ?kzi Real)
    (assert
      (or (or (= ?kzi ?kzh)
          (= ?kzi ?kzg)
          )
        (= ?kzh ?kzg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kzj Real)
    (declare-const ?kzk Real)
    (declare-const ?kzl Real)
    (assert
      (or (or (= ?kzl ?kzk)
          (= ?kzl ?kzj)
          )
        (= ?kzk ?kzj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kzm Real)
    (declare-const ?kzn Real)
    (declare-const ?kzo Real)
    (declare-const ?kzp Real)
    (assert
      (or (or (= ?kzo ?kzn)
          (= ?kzo ?kzm)
          )
        (= ?kzn ?kzm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kzq Real)
    (declare-const ?kzr Real)
    (declare-const ?kzs Real)
    (declare-const ?kzt Real)
    (declare-const ?kzu Real)
    (assert
      (or (or (= ?kzs ?kzr)
          (= ?kzs ?kzq)
          )
        (= ?kzr ?kzq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?kzv Real)
    (declare-const ?kzw Real)
    (declare-const ?kzx Real)
    (declare-const ?kzy Real)
    (declare-const ?kzz Real)
    (declare-const ?laa Real)
    (assert
      (and (or (or (= ?kzx ?kzw)
            (= ?kzx ?kzv)
            )
          (= ?kzw ?kzv)
          )
        (and (and (not (= ?laa ?kzz))
            (not (= ?laa ?kzy))
            )
          (not (= ?kzz ?kzy))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lab Real)
    (declare-const ?lac Real)
    (declare-const ?lad Real)
    (assert
      (or (or (= ?lad ?lac)
          (= ?lad ?lab)
          )
        (= ?lac ?lab)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lae Real)
    (declare-const ?laf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lag Real)
    (declare-const ?lah Real)
    (declare-const ?lai Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?laj Real)
    (declare-const ?lak Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lal Real)
    (declare-const ?lam Real)
    (declare-const ?lan Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lao Real)
    (declare-const ?lap Real)
    (declare-const ?laq Real)
    (declare-const ?lar Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?lap ?lao))
                (not (= ?lap ?asi))
                )
              (not (= ?lao ?asi))
              )
            (or (or (= ?lar ?laq)
                (= ?lar ?asi)
                )
              (= ?laq ?asi)
              )
            )
          (and (or (or (= ?lap ?lao)
                (= ?lap ?asi)
                )
              (= ?lao ?asi)
              )
            (and (and (not (= ?lar ?laq))
                (not (= ?lar ?asi))
                )
              (not (= ?laq ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?las Real)
    (declare-const ?lat Real)
    (declare-const ?lau Real)
    (declare-const ?lav Real)
    (declare-const ?law Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lax Real)
    (declare-const ?lay Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?laz Real)
    (declare-const ?lba Real)
    (declare-const ?lbb Real)
    (declare-const ?lbc Real)
    (declare-const ?lbd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lbe Real)
    (declare-const ?lbf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lbg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lbh Real)
    (declare-const ?lbi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lbj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lbk Real)
    (declare-const ?lbl Real)
    (assert
      (not (= ?lbk ?lbl))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lbm Real)
    (declare-const ?lbn Real)
    (declare-const ?lbo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lbp Real)
    (declare-const ?lbq Real)
    (declare-const ?lbr Real)
    (declare-const ?lbs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lbt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lbu Real)
    (declare-const ?lbv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lbw Real)
    (declare-const ?lbx Real)
    (declare-const ?lby Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lbz Real)
    (declare-const ?lca Real)
    (declare-const ?lcb Real)
    (declare-const ?lcc Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?lca ?lbz))
                (not (= ?lca ?fkf))
                )
              (not (= ?lbz ?fkf))
              )
            (or (or (= ?lcc ?lcb)
                (= ?lcc ?fkf)
                )
              (= ?lcb ?fkf)
              )
            )
          (and (or (or (= ?lca ?lbz)
                (= ?lca ?fkf)
                )
              (= ?lbz ?fkf)
              )
            (and (and (not (= ?lcc ?lcb))
                (not (= ?lcc ?fkf))
                )
              (not (= ?lcb ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lcd Real)
    (declare-const ?lce Real)
    (declare-const ?lcf Real)
    (declare-const ?lcg Real)
    (declare-const ?lch Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lci Real)
    (declare-const ?lcj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lck Real)
    (declare-const ?lcl Real)
    (declare-const ?lcm Real)
    (declare-const ?lcn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lco Real)
    (declare-const ?lcp Real)
    (declare-const ?lcq Real)
    (declare-const ?lcr Real)
    (declare-const ?lcs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lct Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lcu Real)
    (declare-const ?lcv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?lcw Real)
  (declare-const ?lcx Real)
  (push 1)
    (declare-const ?lcy Real)
    (declare-const ?lcz Real)
    (declare-const ?lda Real)
    (assert
      (or (or (= ?lda ?lcz)
          (= ?lda ?lcy)
          )
        (= ?lcz ?lcy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ldb Real)
    (declare-const ?ldc Real)
    (declare-const ?ldd Real)
    (declare-const ?lde Real)
    (assert
      (or (or (= ?lde ?ldd)
          (= ?lde ?ldc)
          )
        (= ?ldd ?ldc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ldf Real)
    (declare-const ?ldg Real)
    (declare-const ?ldh Real)
    (declare-const ?ldi Real)
    (declare-const ?ldj Real)
    (assert
      (or (or (= ?ldj ?ldi)
          (= ?ldj ?ldh)
          )
        (= ?ldi ?ldh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ldk Real)
    (declare-const ?ldl Real)
    (declare-const ?ldm Real)
    (declare-const ?ldn Real)
    (declare-const ?ldo Real)
    (declare-const ?ldp Real)
    (assert
      (and (and (and (not (= ?ldm ?ldl))
            (not (= ?ldm ?ldk))
            )
          (not (= ?ldl ?ldk))
          )
        (or (or (= ?ldp ?ldo)
            (= ?ldp ?ldn)
            )
          (= ?ldo ?ldn)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ldq Real)
    (declare-const ?ldr Real)
    (declare-const ?lds Real)
    (assert
      (or (or (= ?lds ?ldr)
          (= ?lds ?ldq)
          )
        (= ?ldr ?ldq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ldt Real)
    (declare-const ?ldu Real)
    (declare-const ?ldv Real)
    (assert
      (or (or (= ?ldv ?ldu)
          (= ?ldv ?ldt)
          )
        (= ?ldu ?ldt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ldw Real)
    (declare-const ?ldx Real)
    (declare-const ?ldy Real)
    (declare-const ?ldz Real)
    (assert
      (or (or (= ?ldy ?ldx)
          (= ?ldy ?ldw)
          )
        (= ?ldx ?ldw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lea Real)
    (declare-const ?leb Real)
    (declare-const ?lec Real)
    (declare-const ?led Real)
    (declare-const ?lee Real)
    (assert
      (or (or (= ?lec ?leb)
          (= ?lec ?lea)
          )
        (= ?leb ?lea)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lef Real)
    (declare-const ?leg Real)
    (declare-const ?leh Real)
    (declare-const ?lei Real)
    (declare-const ?lej Real)
    (declare-const ?lek Real)
    (assert
      (and (or (or (= ?leh ?leg)
            (= ?leh ?lef)
            )
          (= ?leg ?lef)
          )
        (and (and (not (= ?lek ?lej))
            (not (= ?lek ?lei))
            )
          (not (= ?lej ?lei))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lel Real)
    (declare-const ?lem Real)
    (declare-const ?len Real)
    (assert
      (or (or (= ?len ?lem)
          (= ?len ?lel)
          )
        (= ?lem ?lel)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?leo Real)
    (declare-const ?lep Real)
    (declare-const ?leq Real)
    (declare-const ?ler Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?lep ?leo))
                (not (= ?lep ?asi))
                )
              (not (= ?leo ?asi))
              )
            (or (or (= ?ler ?leq)
                (= ?ler ?asi)
                )
              (= ?leq ?asi)
              )
            )
          (and (or (or (= ?lep ?leo)
                (= ?lep ?asi)
                )
              (= ?leo ?asi)
              )
            (and (and (not (= ?ler ?leq))
                (not (= ?ler ?asi))
                )
              (not (= ?leq ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?les Real)
    (declare-const ?let Real)
    (declare-const ?leu Real)
    (declare-const ?lev Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?let ?les))
                (not (= ?let ?fkf))
                )
              (not (= ?les ?fkf))
              )
            (or (or (= ?lev ?leu)
                (= ?lev ?fkf)
                )
              (= ?leu ?fkf)
              )
            )
          (and (or (or (= ?let ?les)
                (= ?let ?fkf)
                )
              (= ?les ?fkf)
              )
            (and (and (not (= ?lev ?leu))
                (not (= ?lev ?fkf))
                )
              (not (= ?leu ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?lew Real)
  (declare-const ?lex Real)
  (declare-const ?ley Real)
  (push 1)
    (declare-const ?lez Real)
    (declare-const ?lfa Real)
    (declare-const ?lfb Real)
    (assert
      (or (or (= ?lfb ?lfa)
          (= ?lfb ?lez)
          )
        (= ?lfa ?lez)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lfc Real)
    (declare-const ?lfd Real)
    (declare-const ?lfe Real)
    (declare-const ?lff Real)
    (assert
      (or (or (= ?lff ?lfe)
          (= ?lff ?lfd)
          )
        (= ?lfe ?lfd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lfg Real)
    (declare-const ?lfh Real)
    (declare-const ?lfi Real)
    (declare-const ?lfj Real)
    (declare-const ?lfk Real)
    (assert
      (or (or (= ?lfk ?lfj)
          (= ?lfk ?lfi)
          )
        (= ?lfj ?lfi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lfl Real)
    (declare-const ?lfm Real)
    (declare-const ?lfn Real)
    (declare-const ?lfo Real)
    (declare-const ?lfp Real)
    (declare-const ?lfq Real)
    (assert
      (and (and (and (not (= ?lfn ?lfm))
            (not (= ?lfn ?lfl))
            )
          (not (= ?lfm ?lfl))
          )
        (or (or (= ?lfq ?lfp)
            (= ?lfq ?lfo)
            )
          (= ?lfp ?lfo)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lfr Real)
    (declare-const ?lfs Real)
    (declare-const ?lft Real)
    (assert
      (or (or (= ?lft ?lfs)
          (= ?lft ?lfr)
          )
        (= ?lfs ?lfr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lfu Real)
    (declare-const ?lfv Real)
    (declare-const ?lfw Real)
    (assert
      (or (or (= ?lfw ?lfv)
          (= ?lfw ?lfu)
          )
        (= ?lfv ?lfu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lfx Real)
    (declare-const ?lfy Real)
    (declare-const ?lfz Real)
    (declare-const ?lga Real)
    (assert
      (or (or (= ?lfz ?lfy)
          (= ?lfz ?lfx)
          )
        (= ?lfy ?lfx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lgb Real)
    (declare-const ?lgc Real)
    (declare-const ?lgd Real)
    (declare-const ?lge Real)
    (declare-const ?lgf Real)
    (assert
      (or (or (= ?lgd ?lgc)
          (= ?lgd ?lgb)
          )
        (= ?lgc ?lgb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lgg Real)
    (declare-const ?lgh Real)
    (declare-const ?lgi Real)
    (declare-const ?lgj Real)
    (declare-const ?lgk Real)
    (declare-const ?lgl Real)
    (assert
      (and (or (or (= ?lgi ?lgh)
            (= ?lgi ?lgg)
            )
          (= ?lgh ?lgg)
          )
        (and (and (not (= ?lgl ?lgk))
            (not (= ?lgl ?lgj))
            )
          (not (= ?lgk ?lgj))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lgm Real)
    (declare-const ?lgn Real)
    (declare-const ?lgo Real)
    (assert
      (or (or (= ?lgo ?lgn)
          (= ?lgo ?lgm)
          )
        (= ?lgn ?lgm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lgp Real)
    (declare-const ?lgq Real)
    (declare-const ?lgr Real)
    (declare-const ?lgs Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?lgq ?lgp))
                (not (= ?lgq ?asi))
                )
              (not (= ?lgp ?asi))
              )
            (or (or (= ?lgs ?lgr)
                (= ?lgs ?asi)
                )
              (= ?lgr ?asi)
              )
            )
          (and (or (or (= ?lgq ?lgp)
                (= ?lgq ?asi)
                )
              (= ?lgp ?asi)
              )
            (and (and (not (= ?lgs ?lgr))
                (not (= ?lgs ?asi))
                )
              (not (= ?lgr ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lgt Real)
    (declare-const ?lgu Real)
    (declare-const ?lgv Real)
    (declare-const ?lgw Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?lgu ?lgt))
                (not (= ?lgu ?fkf))
                )
              (not (= ?lgt ?fkf))
              )
            (or (or (= ?lgw ?lgv)
                (= ?lgw ?fkf)
                )
              (= ?lgv ?fkf)
              )
            )
          (and (or (or (= ?lgu ?lgt)
                (= ?lgu ?fkf)
                )
              (= ?lgt ?fkf)
              )
            (and (and (not (= ?lgw ?lgv))
                (not (= ?lgw ?fkf))
                )
              (not (= ?lgv ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?lgx Real)
  (declare-const ?lgy Real)
  (push 1)
    (declare-const ?lgz Real)
    (declare-const ?lha Real)
    (declare-const ?lhb Real)
    (assert
      (or (or (= ?lhb ?lha)
          (= ?lhb ?lgz)
          )
        (= ?lha ?lgz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lhc Real)
    (declare-const ?lhd Real)
    (declare-const ?lhe Real)
    (declare-const ?lhf Real)
    (assert
      (or (or (= ?lhf ?lhe)
          (= ?lhf ?lhd)
          )
        (= ?lhe ?lhd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lhg Real)
    (declare-const ?lhh Real)
    (declare-const ?lhi Real)
    (declare-const ?lhj Real)
    (declare-const ?lhk Real)
    (assert
      (or (or (= ?lhk ?lhj)
          (= ?lhk ?lhi)
          )
        (= ?lhj ?lhi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lhl Real)
    (declare-const ?lhm Real)
    (declare-const ?lhn Real)
    (declare-const ?lho Real)
    (declare-const ?lhp Real)
    (declare-const ?lhq Real)
    (assert
      (and (and (and (not (= ?lhn ?lhm))
            (not (= ?lhn ?lhl))
            )
          (not (= ?lhm ?lhl))
          )
        (or (or (= ?lhq ?lhp)
            (= ?lhq ?lho)
            )
          (= ?lhp ?lho)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lhr Real)
    (declare-const ?lhs Real)
    (declare-const ?lht Real)
    (assert
      (or (or (= ?lht ?lhs)
          (= ?lht ?lhr)
          )
        (= ?lhs ?lhr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lhu Real)
    (declare-const ?lhv Real)
    (declare-const ?lhw Real)
    (assert
      (or (or (= ?lhw ?lhv)
          (= ?lhw ?lhu)
          )
        (= ?lhv ?lhu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lhx Real)
    (declare-const ?lhy Real)
    (declare-const ?lhz Real)
    (declare-const ?lia Real)
    (assert
      (or (or (= ?lhz ?lhy)
          (= ?lhz ?lhx)
          )
        (= ?lhy ?lhx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lib Real)
    (declare-const ?lic Real)
    (declare-const ?lid Real)
    (declare-const ?lie Real)
    (declare-const ?lif Real)
    (assert
      (or (or (= ?lid ?lic)
          (= ?lid ?lib)
          )
        (= ?lic ?lib)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lig Real)
    (declare-const ?lih Real)
    (declare-const ?lii Real)
    (declare-const ?lij Real)
    (declare-const ?lik Real)
    (declare-const ?lil Real)
    (assert
      (and (or (or (= ?lii ?lih)
            (= ?lii ?lig)
            )
          (= ?lih ?lig)
          )
        (and (and (not (= ?lil ?lik))
            (not (= ?lil ?lij))
            )
          (not (= ?lik ?lij))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lim Real)
    (declare-const ?lin Real)
    (declare-const ?lio Real)
    (assert
      (or (or (= ?lio ?lin)
          (= ?lio ?lim)
          )
        (= ?lin ?lim)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lip Real)
    (declare-const ?liq Real)
    (declare-const ?lir Real)
    (declare-const ?lis Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?liq ?lip))
                (not (= ?liq ?asi))
                )
              (not (= ?lip ?asi))
              )
            (or (or (= ?lis ?lir)
                (= ?lis ?asi)
                )
              (= ?lir ?asi)
              )
            )
          (and (or (or (= ?liq ?lip)
                (= ?liq ?asi)
                )
              (= ?lip ?asi)
              )
            (and (and (not (= ?lis ?lir))
                (not (= ?lis ?asi))
                )
              (not (= ?lir ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lit Real)
    (declare-const ?liu Real)
    (declare-const ?liv Real)
    (declare-const ?liw Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?liu ?lit))
                (not (= ?liu ?fkf))
                )
              (not (= ?lit ?fkf))
              )
            (or (or (= ?liw ?liv)
                (= ?liw ?fkf)
                )
              (= ?liv ?fkf)
              )
            )
          (and (or (or (= ?liu ?lit)
                (= ?liu ?fkf)
                )
              (= ?lit ?fkf)
              )
            (and (and (not (= ?liw ?liv))
                (not (= ?liw ?fkf))
                )
              (not (= ?liv ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?lix Real)
  (declare-const ?liy Real)
  (declare-const ?liz Real)
  (push 1)
    (declare-const ?lja Real)
    (declare-const ?ljb Real)
    (declare-const ?ljc Real)
    (assert
      (or (or (= ?ljc ?ljb)
          (= ?ljc ?lja)
          )
        (= ?ljb ?lja)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ljd Real)
    (declare-const ?lje Real)
    (declare-const ?ljf Real)
    (declare-const ?ljg Real)
    (assert
      (or (or (= ?ljg ?ljf)
          (= ?ljg ?lje)
          )
        (= ?ljf ?lje)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ljh Real)
    (declare-const ?lji Real)
    (declare-const ?ljj Real)
    (declare-const ?ljk Real)
    (declare-const ?ljl Real)
    (assert
      (or (or (= ?ljl ?ljk)
          (= ?ljl ?ljj)
          )
        (= ?ljk ?ljj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ljm Real)
    (declare-const ?ljn Real)
    (declare-const ?ljo Real)
    (declare-const ?ljp Real)
    (declare-const ?ljq Real)
    (declare-const ?ljr Real)
    (assert
      (and (and (and (not (= ?ljo ?ljn))
            (not (= ?ljo ?ljm))
            )
          (not (= ?ljn ?ljm))
          )
        (or (or (= ?ljr ?ljq)
            (= ?ljr ?ljp)
            )
          (= ?ljq ?ljp)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ljs Real)
    (declare-const ?ljt Real)
    (declare-const ?lju Real)
    (assert
      (or (or (= ?lju ?ljt)
          (= ?lju ?ljs)
          )
        (= ?ljt ?ljs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ljv Real)
    (declare-const ?ljw Real)
    (declare-const ?ljx Real)
    (assert
      (or (or (= ?ljx ?ljw)
          (= ?ljx ?ljv)
          )
        (= ?ljw ?ljv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ljy Real)
    (declare-const ?ljz Real)
    (declare-const ?lka Real)
    (declare-const ?lkb Real)
    (assert
      (or (or (= ?lka ?ljz)
          (= ?lka ?ljy)
          )
        (= ?ljz ?ljy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lkc Real)
    (declare-const ?lkd Real)
    (declare-const ?lke Real)
    (declare-const ?lkf Real)
    (declare-const ?lkg Real)
    (assert
      (or (or (= ?lke ?lkd)
          (= ?lke ?lkc)
          )
        (= ?lkd ?lkc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lkh Real)
    (declare-const ?lki Real)
    (declare-const ?lkj Real)
    (declare-const ?lkk Real)
    (declare-const ?lkl Real)
    (declare-const ?lkm Real)
    (assert
      (and (or (or (= ?lkj ?lki)
            (= ?lkj ?lkh)
            )
          (= ?lki ?lkh)
          )
        (and (and (not (= ?lkm ?lkl))
            (not (= ?lkm ?lkk))
            )
          (not (= ?lkl ?lkk))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lkn Real)
    (declare-const ?lko Real)
    (declare-const ?lkp Real)
    (assert
      (or (or (= ?lkp ?lko)
          (= ?lkp ?lkn)
          )
        (= ?lko ?lkn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lkq Real)
    (declare-const ?lkr Real)
    (declare-const ?lks Real)
    (declare-const ?lkt Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?lkr ?lkq))
                (not (= ?lkr ?asi))
                )
              (not (= ?lkq ?asi))
              )
            (or (or (= ?lkt ?lks)
                (= ?lkt ?asi)
                )
              (= ?lks ?asi)
              )
            )
          (and (or (or (= ?lkr ?lkq)
                (= ?lkr ?asi)
                )
              (= ?lkq ?asi)
              )
            (and (and (not (= ?lkt ?lks))
                (not (= ?lkt ?asi))
                )
              (not (= ?lks ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lku Real)
    (declare-const ?lkv Real)
    (declare-const ?lkw Real)
    (declare-const ?lkx Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?lkv ?lku))
                (not (= ?lkv ?fkf))
                )
              (not (= ?lku ?fkf))
              )
            (or (or (= ?lkx ?lkw)
                (= ?lkx ?fkf)
                )
              (= ?lkw ?fkf)
              )
            )
          (and (or (or (= ?lkv ?lku)
                (= ?lkv ?fkf)
                )
              (= ?lku ?fkf)
              )
            (and (and (not (= ?lkx ?lkw))
                (not (= ?lkx ?fkf))
                )
              (not (= ?lkw ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?lky Real)
  (declare-const ?lkz Real)
  (declare-const ?lla Real)
  (declare-const ?llb Real)
  (assert
    (exists ((?asi Real) )(or (and (and (and (not (= ?lkz ?lky))
              (not (= ?lkz ?asi))
              )
            (not (= ?lky ?asi))
            )
          (or (or (= ?llb ?lla)
              (= ?llb ?asi)
              )
            (= ?lla ?asi)
            )
          )
        (and (or (or (= ?lkz ?lky)
              (= ?lkz ?asi)
              )
            (= ?lky ?asi)
            )
          (and (and (not (= ?llb ?lla))
              (not (= ?llb ?asi))
              )
            (not (= ?lla ?asi))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?llc Real)
    (declare-const ?lld Real)
    (declare-const ?lle Real)
    (assert
      (or (or (= ?lle ?lld)
          (= ?lle ?llc)
          )
        (= ?lld ?llc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?llf Real)
    (declare-const ?llg Real)
    (declare-const ?llh Real)
    (declare-const ?lli Real)
    (assert
      (or (or (= ?lli ?llh)
          (= ?lli ?llg)
          )
        (= ?llh ?llg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?llj Real)
    (declare-const ?llk Real)
    (declare-const ?lll Real)
    (declare-const ?llm Real)
    (declare-const ?lln Real)
    (assert
      (or (or (= ?lln ?llm)
          (= ?lln ?lll)
          )
        (= ?llm ?lll)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?llo Real)
    (declare-const ?llp Real)
    (declare-const ?llq Real)
    (declare-const ?llr Real)
    (declare-const ?lls Real)
    (declare-const ?llt Real)
    (assert
      (and (and (and (not (= ?llq ?llp))
            (not (= ?llq ?llo))
            )
          (not (= ?llp ?llo))
          )
        (or (or (= ?llt ?lls)
            (= ?llt ?llr)
            )
          (= ?lls ?llr)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?llu Real)
    (declare-const ?llv Real)
    (declare-const ?llw Real)
    (assert
      (or (or (= ?llw ?llv)
          (= ?llw ?llu)
          )
        (= ?llv ?llu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?llx Real)
    (declare-const ?lly Real)
    (declare-const ?llz Real)
    (assert
      (or (or (= ?llz ?lly)
          (= ?llz ?llx)
          )
        (= ?lly ?llx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lma Real)
    (declare-const ?lmb Real)
    (declare-const ?lmc Real)
    (declare-const ?lmd Real)
    (assert
      (or (or (= ?lmc ?lmb)
          (= ?lmc ?lma)
          )
        (= ?lmb ?lma)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lme Real)
    (declare-const ?lmf Real)
    (declare-const ?lmg Real)
    (declare-const ?lmh Real)
    (declare-const ?lmi Real)
    (assert
      (or (or (= ?lmg ?lmf)
          (= ?lmg ?lme)
          )
        (= ?lmf ?lme)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lmj Real)
    (declare-const ?lmk Real)
    (declare-const ?lml Real)
    (declare-const ?lmm Real)
    (declare-const ?lmn Real)
    (declare-const ?lmo Real)
    (assert
      (and (or (or (= ?lml ?lmk)
            (= ?lml ?lmj)
            )
          (= ?lmk ?lmj)
          )
        (and (and (not (= ?lmo ?lmn))
            (not (= ?lmo ?lmm))
            )
          (not (= ?lmn ?lmm))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lmp Real)
    (declare-const ?lmq Real)
    (declare-const ?lmr Real)
    (assert
      (or (or (= ?lmr ?lmq)
          (= ?lmr ?lmp)
          )
        (= ?lmq ?lmp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lms Real)
    (declare-const ?lmt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lmu Real)
    (declare-const ?lmv Real)
    (declare-const ?lmw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lmx Real)
    (declare-const ?lmy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lmz Real)
    (declare-const ?lna Real)
    (declare-const ?lnb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lnc Real)
    (declare-const ?lnd Real)
    (declare-const ?lne Real)
    (declare-const ?lnf Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?lnd ?lnc))
                (not (= ?lnd ?asi))
                )
              (not (= ?lnc ?asi))
              )
            (or (or (= ?lnf ?lne)
                (= ?lnf ?asi)
                )
              (= ?lne ?asi)
              )
            )
          (and (or (or (= ?lnd ?lnc)
                (= ?lnd ?asi)
                )
              (= ?lnc ?asi)
              )
            (and (and (not (= ?lnf ?lne))
                (not (= ?lnf ?asi))
                )
              (not (= ?lne ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lng Real)
    (declare-const ?lnh Real)
    (declare-const ?lni Real)
    (declare-const ?lnj Real)
    (declare-const ?lnk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lnl Real)
    (declare-const ?lnm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lnn Real)
    (declare-const ?lno Real)
    (declare-const ?lnp Real)
    (declare-const ?lnq Real)
    (declare-const ?lnr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lns Real)
    (declare-const ?lnt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lnu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lnv Real)
    (declare-const ?lnw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lnx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lny Real)
    (declare-const ?lnz Real)
    (assert
      (not (= ?lny ?lnz))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?loa Real)
    (declare-const ?lob Real)
    (declare-const ?loc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lod Real)
    (declare-const ?loe Real)
    (declare-const ?lof Real)
    (declare-const ?log Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?loh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?loi Real)
    (declare-const ?loj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lok Real)
    (declare-const ?lol Real)
    (declare-const ?lom Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lon Real)
    (declare-const ?loo Real)
    (declare-const ?lop Real)
    (declare-const ?loq Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?loo ?lon))
                (not (= ?loo ?fkf))
                )
              (not (= ?lon ?fkf))
              )
            (or (or (= ?loq ?lop)
                (= ?loq ?fkf)
                )
              (= ?lop ?fkf)
              )
            )
          (and (or (or (= ?loo ?lon)
                (= ?loo ?fkf)
                )
              (= ?lon ?fkf)
              )
            (and (and (not (= ?loq ?lop))
                (not (= ?loq ?fkf))
                )
              (not (= ?lop ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lor Real)
    (declare-const ?los Real)
    (declare-const ?lot Real)
    (declare-const ?lou Real)
    (declare-const ?lov Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?low Real)
    (declare-const ?lox Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?loy Real)
    (declare-const ?loz Real)
    (declare-const ?lpa Real)
    (declare-const ?lpb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lpc Real)
    (declare-const ?lpd Real)
    (declare-const ?lpe Real)
    (declare-const ?lpf Real)
    (declare-const ?lpg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lph Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lpi Real)
    (declare-const ?lpj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?lpk Real)
  (declare-const ?lpl Real)
  (declare-const ?lpm Real)
  (declare-const ?lpn Real)
  (declare-const ?lpo Real)
  (push 1)
    (declare-const ?lpp Real)
    (declare-const ?lpq Real)
    (declare-const ?lpr Real)
    (assert
      (or (or (= ?lpr ?lpq)
          (= ?lpr ?lpp)
          )
        (= ?lpq ?lpp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lps Real)
    (declare-const ?lpt Real)
    (declare-const ?lpu Real)
    (declare-const ?lpv Real)
    (assert
      (or (or (= ?lpv ?lpu)
          (= ?lpv ?lpt)
          )
        (= ?lpu ?lpt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lpw Real)
    (declare-const ?lpx Real)
    (declare-const ?lpy Real)
    (declare-const ?lpz Real)
    (declare-const ?lqa Real)
    (assert
      (or (or (= ?lqa ?lpz)
          (= ?lqa ?lpy)
          )
        (= ?lpz ?lpy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lqb Real)
    (declare-const ?lqc Real)
    (declare-const ?lqd Real)
    (declare-const ?lqe Real)
    (declare-const ?lqf Real)
    (declare-const ?lqg Real)
    (assert
      (and (and (and (not (= ?lqd ?lqc))
            (not (= ?lqd ?lqb))
            )
          (not (= ?lqc ?lqb))
          )
        (or (or (= ?lqg ?lqf)
            (= ?lqg ?lqe)
            )
          (= ?lqf ?lqe)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lqh Real)
    (declare-const ?lqi Real)
    (declare-const ?lqj Real)
    (assert
      (or (or (= ?lqj ?lqi)
          (= ?lqj ?lqh)
          )
        (= ?lqi ?lqh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lqk Real)
    (declare-const ?lql Real)
    (declare-const ?lqm Real)
    (assert
      (or (or (= ?lqm ?lql)
          (= ?lqm ?lqk)
          )
        (= ?lql ?lqk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lqn Real)
    (declare-const ?lqo Real)
    (declare-const ?lqp Real)
    (declare-const ?lqq Real)
    (assert
      (or (or (= ?lqp ?lqo)
          (= ?lqp ?lqn)
          )
        (= ?lqo ?lqn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lqr Real)
    (declare-const ?lqs Real)
    (declare-const ?lqt Real)
    (declare-const ?lqu Real)
    (declare-const ?lqv Real)
    (assert
      (or (or (= ?lqt ?lqs)
          (= ?lqt ?lqr)
          )
        (= ?lqs ?lqr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lqw Real)
    (declare-const ?lqx Real)
    (declare-const ?lqy Real)
    (declare-const ?lqz Real)
    (declare-const ?lra Real)
    (declare-const ?lrb Real)
    (assert
      (and (or (or (= ?lqy ?lqx)
            (= ?lqy ?lqw)
            )
          (= ?lqx ?lqw)
          )
        (and (and (not (= ?lrb ?lra))
            (not (= ?lrb ?lqz))
            )
          (not (= ?lra ?lqz))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lrc Real)
    (declare-const ?lrd Real)
    (declare-const ?lre Real)
    (assert
      (or (or (= ?lre ?lrd)
          (= ?lre ?lrc)
          )
        (= ?lrd ?lrc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lrf Real)
    (declare-const ?lrg Real)
    (declare-const ?lrh Real)
    (declare-const ?lri Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?lrg ?lrf))
                (not (= ?lrg ?asi))
                )
              (not (= ?lrf ?asi))
              )
            (or (or (= ?lri ?lrh)
                (= ?lri ?asi)
                )
              (= ?lrh ?asi)
              )
            )
          (and (or (or (= ?lrg ?lrf)
                (= ?lrg ?asi)
                )
              (= ?lrf ?asi)
              )
            (and (and (not (= ?lri ?lrh))
                (not (= ?lri ?asi))
                )
              (not (= ?lrh ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lrj Real)
    (declare-const ?lrk Real)
    (declare-const ?lrl Real)
    (declare-const ?lrm Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?lrk ?lrj))
                (not (= ?lrk ?fkf))
                )
              (not (= ?lrj ?fkf))
              )
            (or (or (= ?lrm ?lrl)
                (= ?lrm ?fkf)
                )
              (= ?lrl ?fkf)
              )
            )
          (and (or (or (= ?lrk ?lrj)
                (= ?lrk ?fkf)
                )
              (= ?lrj ?fkf)
              )
            (and (and (not (= ?lrm ?lrl))
                (not (= ?lrm ?fkf))
                )
              (not (= ?lrl ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?lrn Real)
  (declare-const ?lro Real)
  (push 1)
    (declare-const ?lrp Real)
    (declare-const ?lrq Real)
    (declare-const ?lrr Real)
    (assert
      (or (or (= ?lrr ?lrq)
          (= ?lrr ?lrp)
          )
        (= ?lrq ?lrp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lrs Real)
    (declare-const ?lrt Real)
    (declare-const ?lru Real)
    (declare-const ?lrv Real)
    (assert
      (or (or (= ?lrv ?lru)
          (= ?lrv ?lrt)
          )
        (= ?lru ?lrt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lrw Real)
    (declare-const ?lrx Real)
    (declare-const ?lry Real)
    (declare-const ?lrz Real)
    (declare-const ?lsa Real)
    (assert
      (or (or (= ?lsa ?lrz)
          (= ?lsa ?lry)
          )
        (= ?lrz ?lry)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lsb Real)
    (declare-const ?lsc Real)
    (declare-const ?lsd Real)
    (declare-const ?lse Real)
    (declare-const ?lsf Real)
    (declare-const ?lsg Real)
    (assert
      (and (and (and (not (= ?lsd ?lsc))
            (not (= ?lsd ?lsb))
            )
          (not (= ?lsc ?lsb))
          )
        (or (or (= ?lsg ?lsf)
            (= ?lsg ?lse)
            )
          (= ?lsf ?lse)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lsh Real)
    (declare-const ?lsi Real)
    (declare-const ?lsj Real)
    (assert
      (or (or (= ?lsj ?lsi)
          (= ?lsj ?lsh)
          )
        (= ?lsi ?lsh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lsk Real)
    (declare-const ?lsl Real)
    (declare-const ?lsm Real)
    (assert
      (or (or (= ?lsm ?lsl)
          (= ?lsm ?lsk)
          )
        (= ?lsl ?lsk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lsn Real)
    (declare-const ?lso Real)
    (declare-const ?lsp Real)
    (declare-const ?lsq Real)
    (assert
      (or (or (= ?lsp ?lso)
          (= ?lsp ?lsn)
          )
        (= ?lso ?lsn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lsr Real)
    (declare-const ?lss Real)
    (declare-const ?lst Real)
    (declare-const ?lsu Real)
    (declare-const ?lsv Real)
    (assert
      (or (or (= ?lst ?lss)
          (= ?lst ?lsr)
          )
        (= ?lss ?lsr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lsw Real)
    (declare-const ?lsx Real)
    (declare-const ?lsy Real)
    (declare-const ?lsz Real)
    (declare-const ?lta Real)
    (declare-const ?ltb Real)
    (assert
      (and (or (or (= ?lsy ?lsx)
            (= ?lsy ?lsw)
            )
          (= ?lsx ?lsw)
          )
        (and (and (not (= ?ltb ?lta))
            (not (= ?ltb ?lsz))
            )
          (not (= ?lta ?lsz))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ltc Real)
    (declare-const ?ltd Real)
    (declare-const ?lte Real)
    (assert
      (or (or (= ?lte ?ltd)
          (= ?lte ?ltc)
          )
        (= ?ltd ?ltc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ltf Real)
    (declare-const ?ltg Real)
    (declare-const ?lth Real)
    (declare-const ?lti Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ltg ?ltf))
                (not (= ?ltg ?asi))
                )
              (not (= ?ltf ?asi))
              )
            (or (or (= ?lti ?lth)
                (= ?lti ?asi)
                )
              (= ?lth ?asi)
              )
            )
          (and (or (or (= ?ltg ?ltf)
                (= ?ltg ?asi)
                )
              (= ?ltf ?asi)
              )
            (and (and (not (= ?lti ?lth))
                (not (= ?lti ?asi))
                )
              (not (= ?lth ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ltj Real)
    (declare-const ?ltk Real)
    (declare-const ?ltl Real)
    (declare-const ?ltm Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ltk ?ltj))
                (not (= ?ltk ?fkf))
                )
              (not (= ?ltj ?fkf))
              )
            (or (or (= ?ltm ?ltl)
                (= ?ltm ?fkf)
                )
              (= ?ltl ?fkf)
              )
            )
          (and (or (or (= ?ltk ?ltj)
                (= ?ltk ?fkf)
                )
              (= ?ltj ?fkf)
              )
            (and (and (not (= ?ltm ?ltl))
                (not (= ?ltm ?fkf))
                )
              (not (= ?ltl ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ltn Real)
  (declare-const ?lto Real)
  (declare-const ?ltp Real)
  (declare-const ?ltq Real)
  (declare-const ?ltr Real)
  (push 1)
    (declare-const ?lts Real)
    (declare-const ?ltt Real)
    (declare-const ?ltu Real)
    (assert
      (or (or (= ?ltu ?ltt)
          (= ?ltu ?lts)
          )
        (= ?ltt ?lts)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ltv Real)
    (declare-const ?ltw Real)
    (declare-const ?ltx Real)
    (declare-const ?lty Real)
    (assert
      (or (or (= ?lty ?ltx)
          (= ?lty ?ltw)
          )
        (= ?ltx ?ltw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ltz Real)
    (declare-const ?lua Real)
    (declare-const ?lub Real)
    (declare-const ?luc Real)
    (declare-const ?lud Real)
    (assert
      (or (or (= ?lud ?luc)
          (= ?lud ?lub)
          )
        (= ?luc ?lub)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lue Real)
    (declare-const ?luf Real)
    (declare-const ?lug Real)
    (declare-const ?luh Real)
    (declare-const ?lui Real)
    (declare-const ?luj Real)
    (assert
      (and (and (and (not (= ?lug ?luf))
            (not (= ?lug ?lue))
            )
          (not (= ?luf ?lue))
          )
        (or (or (= ?luj ?lui)
            (= ?luj ?luh)
            )
          (= ?lui ?luh)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?luk Real)
    (declare-const ?lul Real)
    (declare-const ?lum Real)
    (assert
      (or (or (= ?lum ?lul)
          (= ?lum ?luk)
          )
        (= ?lul ?luk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lun Real)
    (declare-const ?luo Real)
    (declare-const ?lup Real)
    (assert
      (or (or (= ?lup ?luo)
          (= ?lup ?lun)
          )
        (= ?luo ?lun)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?luq Real)
    (declare-const ?lur Real)
    (declare-const ?lus Real)
    (declare-const ?lut Real)
    (assert
      (or (or (= ?lus ?lur)
          (= ?lus ?luq)
          )
        (= ?lur ?luq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?luu Real)
    (declare-const ?luv Real)
    (declare-const ?luw Real)
    (declare-const ?lux Real)
    (declare-const ?luy Real)
    (assert
      (or (or (= ?luw ?luv)
          (= ?luw ?luu)
          )
        (= ?luv ?luu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?luz Real)
    (declare-const ?lva Real)
    (declare-const ?lvb Real)
    (declare-const ?lvc Real)
    (declare-const ?lvd Real)
    (declare-const ?lve Real)
    (assert
      (and (or (or (= ?lvb ?lva)
            (= ?lvb ?luz)
            )
          (= ?lva ?luz)
          )
        (and (and (not (= ?lve ?lvd))
            (not (= ?lve ?lvc))
            )
          (not (= ?lvd ?lvc))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lvf Real)
    (declare-const ?lvg Real)
    (declare-const ?lvh Real)
    (assert
      (or (or (= ?lvh ?lvg)
          (= ?lvh ?lvf)
          )
        (= ?lvg ?lvf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lvi Real)
    (declare-const ?lvj Real)
    (declare-const ?lvk Real)
    (declare-const ?lvl Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?lvj ?lvi))
                (not (= ?lvj ?asi))
                )
              (not (= ?lvi ?asi))
              )
            (or (or (= ?lvl ?lvk)
                (= ?lvl ?asi)
                )
              (= ?lvk ?asi)
              )
            )
          (and (or (or (= ?lvj ?lvi)
                (= ?lvj ?asi)
                )
              (= ?lvi ?asi)
              )
            (and (and (not (= ?lvl ?lvk))
                (not (= ?lvl ?asi))
                )
              (not (= ?lvk ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lvm Real)
    (declare-const ?lvn Real)
    (declare-const ?lvo Real)
    (declare-const ?lvp Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?lvn ?lvm))
                (not (= ?lvn ?fkf))
                )
              (not (= ?lvm ?fkf))
              )
            (or (or (= ?lvp ?lvo)
                (= ?lvp ?fkf)
                )
              (= ?lvo ?fkf)
              )
            )
          (and (or (or (= ?lvn ?lvm)
                (= ?lvn ?fkf)
                )
              (= ?lvm ?fkf)
              )
            (and (and (not (= ?lvp ?lvo))
                (not (= ?lvp ?fkf))
                )
              (not (= ?lvo ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?lvq Real)
  (declare-const ?lvr Real)
  (push 1)
    (declare-const ?lvs Real)
    (declare-const ?lvt Real)
    (declare-const ?lvu Real)
    (assert
      (or (or (= ?lvu ?lvt)
          (= ?lvu ?lvs)
          )
        (= ?lvt ?lvs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lvv Real)
    (declare-const ?lvw Real)
    (declare-const ?lvx Real)
    (declare-const ?lvy Real)
    (assert
      (or (or (= ?lvy ?lvx)
          (= ?lvy ?lvw)
          )
        (= ?lvx ?lvw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lvz Real)
    (declare-const ?lwa Real)
    (declare-const ?lwb Real)
    (declare-const ?lwc Real)
    (declare-const ?lwd Real)
    (assert
      (or (or (= ?lwd ?lwc)
          (= ?lwd ?lwb)
          )
        (= ?lwc ?lwb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lwe Real)
    (declare-const ?lwf Real)
    (declare-const ?lwg Real)
    (declare-const ?lwh Real)
    (declare-const ?lwi Real)
    (declare-const ?lwj Real)
    (assert
      (and (and (and (not (= ?lwg ?lwf))
            (not (= ?lwg ?lwe))
            )
          (not (= ?lwf ?lwe))
          )
        (or (or (= ?lwj ?lwi)
            (= ?lwj ?lwh)
            )
          (= ?lwi ?lwh)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lwk Real)
    (declare-const ?lwl Real)
    (declare-const ?lwm Real)
    (assert
      (or (or (= ?lwm ?lwl)
          (= ?lwm ?lwk)
          )
        (= ?lwl ?lwk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lwn Real)
    (declare-const ?lwo Real)
    (declare-const ?lwp Real)
    (assert
      (or (or (= ?lwp ?lwo)
          (= ?lwp ?lwn)
          )
        (= ?lwo ?lwn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lwq Real)
    (declare-const ?lwr Real)
    (declare-const ?lws Real)
    (declare-const ?lwt Real)
    (assert
      (or (or (= ?lws ?lwr)
          (= ?lws ?lwq)
          )
        (= ?lwr ?lwq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lwu Real)
    (declare-const ?lwv Real)
    (declare-const ?lww Real)
    (declare-const ?lwx Real)
    (declare-const ?lwy Real)
    (assert
      (or (or (= ?lww ?lwv)
          (= ?lww ?lwu)
          )
        (= ?lwv ?lwu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lwz Real)
    (declare-const ?lxa Real)
    (declare-const ?lxb Real)
    (declare-const ?lxc Real)
    (declare-const ?lxd Real)
    (declare-const ?lxe Real)
    (assert
      (and (or (or (= ?lxb ?lxa)
            (= ?lxb ?lwz)
            )
          (= ?lxa ?lwz)
          )
        (and (and (not (= ?lxe ?lxd))
            (not (= ?lxe ?lxc))
            )
          (not (= ?lxd ?lxc))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lxf Real)
    (declare-const ?lxg Real)
    (declare-const ?lxh Real)
    (assert
      (or (or (= ?lxh ?lxg)
          (= ?lxh ?lxf)
          )
        (= ?lxg ?lxf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lxi Real)
    (declare-const ?lxj Real)
    (declare-const ?lxk Real)
    (declare-const ?lxl Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?lxj ?lxi))
                (not (= ?lxj ?asi))
                )
              (not (= ?lxi ?asi))
              )
            (or (or (= ?lxl ?lxk)
                (= ?lxl ?asi)
                )
              (= ?lxk ?asi)
              )
            )
          (and (or (or (= ?lxj ?lxi)
                (= ?lxj ?asi)
                )
              (= ?lxi ?asi)
              )
            (and (and (not (= ?lxl ?lxk))
                (not (= ?lxl ?asi))
                )
              (not (= ?lxk ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lxm Real)
    (declare-const ?lxn Real)
    (declare-const ?lxo Real)
    (declare-const ?lxp Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?lxn ?lxm))
                (not (= ?lxn ?fkf))
                )
              (not (= ?lxm ?fkf))
              )
            (or (or (= ?lxp ?lxo)
                (= ?lxp ?fkf)
                )
              (= ?lxo ?fkf)
              )
            )
          (and (or (or (= ?lxn ?lxm)
                (= ?lxn ?fkf)
                )
              (= ?lxm ?fkf)
              )
            (and (and (not (= ?lxp ?lxo))
                (not (= ?lxp ?fkf))
                )
              (not (= ?lxo ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?lxq Real)
  (declare-const ?lxr Real)
  (declare-const ?lxs Real)
  (assert
    (or (or (= ?lxs ?lxr)
        (= ?lxs ?lxq)
        )
      (= ?lxr ?lxq)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?lxt Real)
  (declare-const ?lxu Real)
  (declare-const ?lxv Real)
  (declare-const ?lxw Real)
  (assert
    (or (or (= ?lxw ?lxv)
        (= ?lxw ?lxu)
        )
      (= ?lxv ?lxu)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?lxx Real)
  (declare-const ?lxy Real)
  (declare-const ?lxz Real)
  (declare-const ?lya Real)
  (declare-const ?lyb Real)
  (assert
    (or (or (= ?lyb ?lya)
        (= ?lyb ?lxz)
        )
      (= ?lya ?lxz)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?lyc Real)
  (declare-const ?lyd Real)
  (declare-const ?lye Real)
  (declare-const ?lyf Real)
  (declare-const ?lyg Real)
  (declare-const ?lyh Real)
  (assert
    (and (and (and (not (= ?lye ?lyd))
          (not (= ?lye ?lyc))
          )
        (not (= ?lyd ?lyc))
        )
      (or (or (= ?lyh ?lyg)
          (= ?lyh ?lyf)
          )
        (= ?lyg ?lyf)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?lyi Real)
  (declare-const ?lyj Real)
  (declare-const ?lyk Real)
  (assert
    (or (or (= ?lyk ?lyj)
        (= ?lyk ?lyi)
        )
      (= ?lyj ?lyi)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?lyl Real)
  (declare-const ?lym Real)
  (declare-const ?lyn Real)
  (assert
    (or (or (= ?lyn ?lym)
        (= ?lyn ?lyl)
        )
      (= ?lym ?lyl)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?lyo Real)
  (declare-const ?lyp Real)
  (declare-const ?lyq Real)
  (declare-const ?lyr Real)
  (assert
    (or (or (= ?lyq ?lyp)
        (= ?lyq ?lyo)
        )
      (= ?lyp ?lyo)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?lys Real)
  (declare-const ?lyt Real)
  (declare-const ?lyu Real)
  (declare-const ?lyv Real)
  (declare-const ?lyw Real)
  (assert
    (or (or (= ?lyu ?lyt)
        (= ?lyu ?lys)
        )
      (= ?lyt ?lys)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?lyx Real)
  (declare-const ?lyy Real)
  (declare-const ?lyz Real)
  (declare-const ?lza Real)
  (declare-const ?lzb Real)
  (declare-const ?lzc Real)
  (assert
    (and (or (or (= ?lyz ?lyy)
          (= ?lyz ?lyx)
          )
        (= ?lyy ?lyx)
        )
      (and (and (not (= ?lzc ?lzb))
          (not (= ?lzc ?lza))
          )
        (not (= ?lzb ?lza))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?lzd Real)
  (declare-const ?lze Real)
  (declare-const ?lzf Real)
  (assert
    (or (or (= ?lzf ?lze)
        (= ?lzf ?lzd)
        )
      (= ?lze ?lzd)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?lzg Real)
  (declare-const ?lzh Real)
  (declare-const ?lzi Real)
  (declare-const ?lzj Real)
  (assert
    (exists ((?asi Real) )(or (and (and (and (not (= ?lzh ?lzg))
              (not (= ?lzh ?asi))
              )
            (not (= ?lzg ?asi))
            )
          (or (or (= ?lzj ?lzi)
              (= ?lzj ?asi)
              )
            (= ?lzi ?asi)
            )
          )
        (and (or (or (= ?lzh ?lzg)
              (= ?lzh ?asi)
              )
            (= ?lzg ?asi)
            )
          (and (and (not (= ?lzj ?lzi))
              (not (= ?lzj ?asi))
              )
            (not (= ?lzi ?asi))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?lzk Real)
    (declare-const ?lzl Real)
    (declare-const ?lzm Real)
    (assert
      (or (or (= ?lzm ?lzl)
          (= ?lzm ?lzk)
          )
        (= ?lzl ?lzk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lzn Real)
    (declare-const ?lzo Real)
    (declare-const ?lzp Real)
    (declare-const ?lzq Real)
    (assert
      (or (or (= ?lzq ?lzp)
          (= ?lzq ?lzo)
          )
        (= ?lzp ?lzo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lzr Real)
    (declare-const ?lzs Real)
    (declare-const ?lzt Real)
    (declare-const ?lzu Real)
    (declare-const ?lzv Real)
    (assert
      (or (or (= ?lzv ?lzu)
          (= ?lzv ?lzt)
          )
        (= ?lzu ?lzt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?lzw Real)
    (declare-const ?lzx Real)
    (declare-const ?lzy Real)
    (declare-const ?lzz Real)
    (declare-const ?maa Real)
    (declare-const ?mab Real)
    (assert
      (and (and (and (not (= ?lzy ?lzx))
            (not (= ?lzy ?lzw))
            )
          (not (= ?lzx ?lzw))
          )
        (or (or (= ?mab ?maa)
            (= ?mab ?lzz)
            )
          (= ?maa ?lzz)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?mac Real)
    (declare-const ?mad Real)
    (declare-const ?mae Real)
    (assert
      (or (or (= ?mae ?mad)
          (= ?mae ?mac)
          )
        (= ?mad ?mac)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?maf Real)
    (declare-const ?mag Real)
    (declare-const ?mah Real)
    (assert
      (or (or (= ?mah ?mag)
          (= ?mah ?maf)
          )
        (= ?mag ?maf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?mai Real)
    (declare-const ?maj Real)
    (declare-const ?mak Real)
    (declare-const ?mal Real)
    (assert
      (or (or (= ?mak ?maj)
          (= ?mak ?mai)
          )
        (= ?maj ?mai)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?mam Real)
    (declare-const ?man Real)
    (declare-const ?mao Real)
    (declare-const ?map Real)
    (declare-const ?maq Real)
    (assert
      (or (or (= ?mao ?man)
          (= ?mao ?mam)
          )
        (= ?man ?mam)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?mar Real)
    (declare-const ?mas Real)
    (declare-const ?mat Real)
    (declare-const ?mau Real)
    (declare-const ?mav Real)
    (declare-const ?maw Real)
    (assert
      (and (or (or (= ?mat ?mas)
            (= ?mat ?mar)
            )
          (= ?mas ?mar)
          )
        (and (and (not (= ?maw ?mav))
            (not (= ?maw ?mau))
            )
          (not (= ?mav ?mau))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?max Real)
    (declare-const ?may Real)
    (declare-const ?maz Real)
    (assert
      (or (or (= ?maz ?may)
          (= ?maz ?max)
          )
        (= ?may ?max)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?mba Real)
    (declare-const ?mbb Real)
    (declare-const ?mbc Real)
    (declare-const ?mbd Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?mbb ?mba))
                (not (= ?mbb ?asi))
                )
              (not (= ?mba ?asi))
              )
            (or (or (= ?mbd ?mbc)
                (= ?mbd ?asi)
                )
              (= ?mbc ?asi)
              )
            )
          (and (or (or (= ?mbb ?mba)
                (= ?mbb ?asi)
                )
              (= ?mba ?asi)
              )
            (and (and (not (= ?mbd ?mbc))
                (not (= ?mbd ?asi))
                )
              (not (= ?mbc ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?mbe Real)
    (declare-const ?mbf Real)
    (declare-const ?mbg Real)
    (declare-const ?mbh Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?mbf ?mbe))
                (not (= ?mbf ?fkf))
                )
              (not (= ?mbe ?fkf))
              )
            (or (or (= ?mbh ?mbg)
                (= ?mbh ?fkf)
                )
              (= ?mbg ?fkf)
              )
            )
          (and (or (or (= ?mbf ?mbe)
                (= ?mbf ?fkf)
                )
              (= ?mbe ?fkf)
              )
            (and (and (not (= ?mbh ?mbg))
                (not (= ?mbh ?fkf))
                )
              (not (= ?mbg ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?mbi Real)
    (push 1)
      (declare-const ?mbj Real)
      (declare-const ?mbk Real)
      (declare-const ?mbl Real)
      (assert
        (or (or (= ?mbl ?mbk)
            (= ?mbl ?mbj)
            )
          (= ?mbk ?mbj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mbm Real)
      (declare-const ?mbn Real)
      (declare-const ?mbo Real)
      (declare-const ?mbp Real)
      (assert
        (or (or (= ?mbp ?mbo)
            (= ?mbp ?mbn)
            )
          (= ?mbo ?mbn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mbq Real)
      (declare-const ?mbr Real)
      (declare-const ?mbs Real)
      (declare-const ?mbt Real)
      (declare-const ?mbu Real)
      (assert
        (or (or (= ?mbu ?mbt)
            (= ?mbu ?mbs)
            )
          (= ?mbt ?mbs)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mbv Real)
      (declare-const ?mbw Real)
      (declare-const ?mbx Real)
      (declare-const ?mby Real)
      (declare-const ?mbz Real)
      (declare-const ?mca Real)
      (assert
        (and (and (and (not (= ?mbx ?mbw))
              (not (= ?mbx ?mbv))
              )
            (not (= ?mbw ?mbv))
            )
          (or (or (= ?mca ?mbz)
              (= ?mca ?mby)
              )
            (= ?mbz ?mby)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mcb Real)
      (declare-const ?mcc Real)
      (declare-const ?mcd Real)
      (assert
        (or (or (= ?mcd ?mcc)
            (= ?mcd ?mcb)
            )
          (= ?mcc ?mcb)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mce Real)
      (declare-const ?mcf Real)
      (declare-const ?mcg Real)
      (assert
        (or (or (= ?mcg ?mcf)
            (= ?mcg ?mce)
            )
          (= ?mcf ?mce)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mch Real)
      (declare-const ?mci Real)
      (declare-const ?mcj Real)
      (declare-const ?mck Real)
      (assert
        (or (or (= ?mcj ?mci)
            (= ?mcj ?mch)
            )
          (= ?mci ?mch)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mcl Real)
      (declare-const ?mcm Real)
      (declare-const ?mcn Real)
      (declare-const ?mco Real)
      (declare-const ?mcp Real)
      (assert
        (or (or (= ?mcn ?mcm)
            (= ?mcn ?mcl)
            )
          (= ?mcm ?mcl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mcq Real)
      (declare-const ?mcr Real)
      (declare-const ?mcs Real)
      (declare-const ?mct Real)
      (declare-const ?mcu Real)
      (declare-const ?mcv Real)
      (assert
        (and (or (or (= ?mcs ?mcr)
              (= ?mcs ?mcq)
              )
            (= ?mcr ?mcq)
            )
          (and (and (not (= ?mcv ?mcu))
              (not (= ?mcv ?mct))
              )
            (not (= ?mcu ?mct))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mcw Real)
      (declare-const ?mcx Real)
      (declare-const ?mcy Real)
      (assert
        (or (or (= ?mcy ?mcx)
            (= ?mcy ?mcw)
            )
          (= ?mcx ?mcw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mcz Real)
      (declare-const ?mda Real)
      (declare-const ?mdb Real)
      (declare-const ?mdc Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?mda ?mcz))
                  (not (= ?mda ?asi))
                  )
                (not (= ?mcz ?asi))
                )
              (or (or (= ?mdc ?mdb)
                  (= ?mdc ?asi)
                  )
                (= ?mdb ?asi)
                )
              )
            (and (or (or (= ?mda ?mcz)
                  (= ?mda ?asi)
                  )
                (= ?mcz ?asi)
                )
              (and (and (not (= ?mdc ?mdb))
                  (not (= ?mdc ?asi))
                  )
                (not (= ?mdb ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mdd Real)
      (declare-const ?mde Real)
      (declare-const ?mdf Real)
      (declare-const ?mdg Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?mde ?mdd))
                  (not (= ?mde ?fkf))
                  )
                (not (= ?mdd ?fkf))
                )
              (or (or (= ?mdg ?mdf)
                  (= ?mdg ?fkf)
                  )
                (= ?mdf ?fkf)
                )
              )
            (and (or (or (= ?mde ?mdd)
                  (= ?mde ?fkf)
                  )
                (= ?mdd ?fkf)
                )
              (and (and (not (= ?mdg ?mdf))
                  (not (= ?mdg ?fkf))
                  )
                (not (= ?mdf ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?mdh Real)
    (declare-const ?mdi Real)
    (push 1)
      (declare-const ?mdj Real)
      (declare-const ?mdk Real)
      (declare-const ?mdl Real)
      (assert
        (or (or (= ?mdl ?mdk)
            (= ?mdl ?mdj)
            )
          (= ?mdk ?mdj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mdm Real)
      (declare-const ?mdn Real)
      (declare-const ?mdo Real)
      (declare-const ?mdp Real)
      (assert
        (or (or (= ?mdp ?mdo)
            (= ?mdp ?mdn)
            )
          (= ?mdo ?mdn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mdq Real)
      (declare-const ?mdr Real)
      (declare-const ?mds Real)
      (declare-const ?mdt Real)
      (declare-const ?mdu Real)
      (assert
        (or (or (= ?mdu ?mdt)
            (= ?mdu ?mds)
            )
          (= ?mdt ?mds)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mdv Real)
      (declare-const ?mdw Real)
      (declare-const ?mdx Real)
      (declare-const ?mdy Real)
      (declare-const ?mdz Real)
      (declare-const ?mea Real)
      (assert
        (and (and (and (not (= ?mdx ?mdw))
              (not (= ?mdx ?mdv))
              )
            (not (= ?mdw ?mdv))
            )
          (or (or (= ?mea ?mdz)
              (= ?mea ?mdy)
              )
            (= ?mdz ?mdy)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?meb Real)
      (declare-const ?mec Real)
      (declare-const ?med Real)
      (assert
        (or (or (= ?med ?mec)
            (= ?med ?meb)
            )
          (= ?mec ?meb)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mee Real)
      (declare-const ?mef Real)
      (declare-const ?meg Real)
      (assert
        (or (or (= ?meg ?mef)
            (= ?meg ?mee)
            )
          (= ?mef ?mee)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?meh Real)
      (declare-const ?mei Real)
      (declare-const ?mej Real)
      (declare-const ?mek Real)
      (assert
        (or (or (= ?mej ?mei)
            (= ?mej ?meh)
            )
          (= ?mei ?meh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mel Real)
      (declare-const ?mem Real)
      (declare-const ?men Real)
      (declare-const ?meo Real)
      (declare-const ?mep Real)
      (assert
        (or (or (= ?men ?mem)
            (= ?men ?mel)
            )
          (= ?mem ?mel)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?meq Real)
      (declare-const ?mer Real)
      (declare-const ?mes Real)
      (declare-const ?met Real)
      (declare-const ?meu Real)
      (declare-const ?mev Real)
      (assert
        (and (or (or (= ?mes ?mer)
              (= ?mes ?meq)
              )
            (= ?mer ?meq)
            )
          (and (and (not (= ?mev ?meu))
              (not (= ?mev ?met))
              )
            (not (= ?meu ?met))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mew Real)
      (declare-const ?mex Real)
      (declare-const ?mey Real)
      (assert
        (or (or (= ?mey ?mex)
            (= ?mey ?mew)
            )
          (= ?mex ?mew)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mez Real)
      (declare-const ?mfa Real)
      (declare-const ?mfb Real)
      (declare-const ?mfc Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?mfa ?mez))
                  (not (= ?mfa ?asi))
                  )
                (not (= ?mez ?asi))
                )
              (or (or (= ?mfc ?mfb)
                  (= ?mfc ?asi)
                  )
                (= ?mfb ?asi)
                )
              )
            (and (or (or (= ?mfa ?mez)
                  (= ?mfa ?asi)
                  )
                (= ?mez ?asi)
                )
              (and (and (not (= ?mfc ?mfb))
                  (not (= ?mfc ?asi))
                  )
                (not (= ?mfb ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mfd Real)
      (declare-const ?mfe Real)
      (declare-const ?mff Real)
      (declare-const ?mfg Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?mfe ?mfd))
                  (not (= ?mfe ?fkf))
                  )
                (not (= ?mfd ?fkf))
                )
              (or (or (= ?mfg ?mff)
                  (= ?mfg ?fkf)
                  )
                (= ?mff ?fkf)
                )
              )
            (and (or (or (= ?mfe ?mfd)
                  (= ?mfe ?fkf)
                  )
                (= ?mfd ?fkf)
                )
              (and (and (not (= ?mfg ?mff))
                  (not (= ?mfg ?fkf))
                  )
                (not (= ?mff ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?mfh Real)
    (declare-const ?mfi Real)
    (declare-const ?mfj Real)
    (push 1)
      (declare-const ?mfk Real)
      (declare-const ?mfl Real)
      (declare-const ?mfm Real)
      (assert
        (or (or (= ?mfm ?mfl)
            (= ?mfm ?mfk)
            )
          (= ?mfl ?mfk)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mfn Real)
      (declare-const ?mfo Real)
      (declare-const ?mfp Real)
      (declare-const ?mfq Real)
      (assert
        (or (or (= ?mfq ?mfp)
            (= ?mfq ?mfo)
            )
          (= ?mfp ?mfo)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mfr Real)
      (declare-const ?mfs Real)
      (declare-const ?mft Real)
      (declare-const ?mfu Real)
      (declare-const ?mfv Real)
      (assert
        (or (or (= ?mfv ?mfu)
            (= ?mfv ?mft)
            )
          (= ?mfu ?mft)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mfw Real)
      (declare-const ?mfx Real)
      (declare-const ?mfy Real)
      (declare-const ?mfz Real)
      (declare-const ?mga Real)
      (declare-const ?mgb Real)
      (assert
        (and (and (and (not (= ?mfy ?mfx))
              (not (= ?mfy ?mfw))
              )
            (not (= ?mfx ?mfw))
            )
          (or (or (= ?mgb ?mga)
              (= ?mgb ?mfz)
              )
            (= ?mga ?mfz)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mgc Real)
      (declare-const ?mgd Real)
      (declare-const ?mge Real)
      (assert
        (or (or (= ?mge ?mgd)
            (= ?mge ?mgc)
            )
          (= ?mgd ?mgc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mgf Real)
      (declare-const ?mgg Real)
      (declare-const ?mgh Real)
      (assert
        (or (or (= ?mgh ?mgg)
            (= ?mgh ?mgf)
            )
          (= ?mgg ?mgf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mgi Real)
      (declare-const ?mgj Real)
      (declare-const ?mgk Real)
      (declare-const ?mgl Real)
      (assert
        (or (or (= ?mgk ?mgj)
            (= ?mgk ?mgi)
            )
          (= ?mgj ?mgi)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mgm Real)
      (declare-const ?mgn Real)
      (declare-const ?mgo Real)
      (declare-const ?mgp Real)
      (declare-const ?mgq Real)
      (assert
        (or (or (= ?mgo ?mgn)
            (= ?mgo ?mgm)
            )
          (= ?mgn ?mgm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mgr Real)
      (declare-const ?mgs Real)
      (declare-const ?mgt Real)
      (declare-const ?mgu Real)
      (declare-const ?mgv Real)
      (declare-const ?mgw Real)
      (assert
        (and (or (or (= ?mgt ?mgs)
              (= ?mgt ?mgr)
              )
            (= ?mgs ?mgr)
            )
          (and (and (not (= ?mgw ?mgv))
              (not (= ?mgw ?mgu))
              )
            (not (= ?mgv ?mgu))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mgx Real)
      (declare-const ?mgy Real)
      (declare-const ?mgz Real)
      (assert
        (or (or (= ?mgz ?mgy)
            (= ?mgz ?mgx)
            )
          (= ?mgy ?mgx)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mha Real)
      (declare-const ?mhb Real)
      (declare-const ?mhc Real)
      (declare-const ?mhd Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?mhb ?mha))
                  (not (= ?mhb ?asi))
                  )
                (not (= ?mha ?asi))
                )
              (or (or (= ?mhd ?mhc)
                  (= ?mhd ?asi)
                  )
                (= ?mhc ?asi)
                )
              )
            (and (or (or (= ?mhb ?mha)
                  (= ?mhb ?asi)
                  )
                (= ?mha ?asi)
                )
              (and (and (not (= ?mhd ?mhc))
                  (not (= ?mhd ?asi))
                  )
                (not (= ?mhc ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mhe Real)
      (declare-const ?mhf Real)
      (declare-const ?mhg Real)
      (declare-const ?mhh Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?mhf ?mhe))
                  (not (= ?mhf ?fkf))
                  )
                (not (= ?mhe ?fkf))
                )
              (or (or (= ?mhh ?mhg)
                  (= ?mhh ?fkf)
                  )
                (= ?mhg ?fkf)
                )
              )
            (and (or (or (= ?mhf ?mhe)
                  (= ?mhf ?fkf)
                  )
                (= ?mhe ?fkf)
                )
              (and (and (not (= ?mhh ?mhg))
                  (not (= ?mhh ?fkf))
                  )
                (not (= ?mhg ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?mhi Real)
    (declare-const ?mhj Real)
    (declare-const ?mhk Real)
    (declare-const ?mhl Real)
    (push 1)
      (declare-const ?mhm Real)
      (declare-const ?mhn Real)
      (declare-const ?mho Real)
      (assert
        (or (or (= ?mho ?mhn)
            (= ?mho ?mhm)
            )
          (= ?mhn ?mhm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mhp Real)
      (declare-const ?mhq Real)
      (declare-const ?mhr Real)
      (declare-const ?mhs Real)
      (assert
        (or (or (= ?mhs ?mhr)
            (= ?mhs ?mhq)
            )
          (= ?mhr ?mhq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mht Real)
      (declare-const ?mhu Real)
      (declare-const ?mhv Real)
      (declare-const ?mhw Real)
      (declare-const ?mhx Real)
      (assert
        (or (or (= ?mhx ?mhw)
            (= ?mhx ?mhv)
            )
          (= ?mhw ?mhv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mhy Real)
      (declare-const ?mhz Real)
      (declare-const ?mia Real)
      (declare-const ?mib Real)
      (declare-const ?mic Real)
      (declare-const ?mid Real)
      (assert
        (and (and (and (not (= ?mia ?mhz))
              (not (= ?mia ?mhy))
              )
            (not (= ?mhz ?mhy))
            )
          (or (or (= ?mid ?mic)
              (= ?mid ?mib)
              )
            (= ?mic ?mib)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mie Real)
      (declare-const ?mif Real)
      (declare-const ?mig Real)
      (assert
        (or (or (= ?mig ?mif)
            (= ?mig ?mie)
            )
          (= ?mif ?mie)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mih Real)
      (declare-const ?mii Real)
      (declare-const ?mij Real)
      (assert
        (or (or (= ?mij ?mii)
            (= ?mij ?mih)
            )
          (= ?mii ?mih)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mik Real)
      (declare-const ?mil Real)
      (declare-const ?mim Real)
      (declare-const ?min Real)
      (assert
        (or (or (= ?mim ?mil)
            (= ?mim ?mik)
            )
          (= ?mil ?mik)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mio Real)
      (declare-const ?mip Real)
      (declare-const ?miq Real)
      (declare-const ?mir Real)
      (declare-const ?mis Real)
      (assert
        (or (or (= ?miq ?mip)
            (= ?miq ?mio)
            )
          (= ?mip ?mio)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mit Real)
      (declare-const ?miu Real)
      (declare-const ?miv Real)
      (declare-const ?miw Real)
      (declare-const ?mix Real)
      (declare-const ?miy Real)
      (assert
        (and (or (or (= ?miv ?miu)
              (= ?miv ?mit)
              )
            (= ?miu ?mit)
            )
          (and (and (not (= ?miy ?mix))
              (not (= ?miy ?miw))
              )
            (not (= ?mix ?miw))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?miz Real)
      (declare-const ?mja Real)
      (declare-const ?mjb Real)
      (assert
        (or (or (= ?mjb ?mja)
            (= ?mjb ?miz)
            )
          (= ?mja ?miz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mjc Real)
      (declare-const ?mjd Real)
      (declare-const ?mje Real)
      (declare-const ?mjf Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?mjd ?mjc))
                  (not (= ?mjd ?asi))
                  )
                (not (= ?mjc ?asi))
                )
              (or (or (= ?mjf ?mje)
                  (= ?mjf ?asi)
                  )
                (= ?mje ?asi)
                )
              )
            (and (or (or (= ?mjd ?mjc)
                  (= ?mjd ?asi)
                  )
                (= ?mjc ?asi)
                )
              (and (and (not (= ?mjf ?mje))
                  (not (= ?mjf ?asi))
                  )
                (not (= ?mje ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mjg Real)
      (declare-const ?mjh Real)
      (declare-const ?mji Real)
      (declare-const ?mjj Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?mjh ?mjg))
                  (not (= ?mjh ?fkf))
                  )
                (not (= ?mjg ?fkf))
                )
              (or (or (= ?mjj ?mji)
                  (= ?mjj ?fkf)
                  )
                (= ?mji ?fkf)
                )
              )
            (and (or (or (= ?mjh ?mjg)
                  (= ?mjh ?fkf)
                  )
                (= ?mjg ?fkf)
                )
              (and (and (not (= ?mjj ?mji))
                  (not (= ?mjj ?fkf))
                  )
                (not (= ?mji ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?mjk Real)
    (push 1)
      (declare-const ?mjl Real)
      (declare-const ?mjm Real)
      (declare-const ?mjn Real)
      (assert
        (or (or (= ?mjn ?mjm)
            (= ?mjn ?mjl)
            )
          (= ?mjm ?mjl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mjo Real)
      (declare-const ?mjp Real)
      (declare-const ?mjq Real)
      (declare-const ?mjr Real)
      (assert
        (or (or (= ?mjr ?mjq)
            (= ?mjr ?mjp)
            )
          (= ?mjq ?mjp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mjs Real)
      (declare-const ?mjt Real)
      (declare-const ?mju Real)
      (declare-const ?mjv Real)
      (declare-const ?mjw Real)
      (assert
        (or (or (= ?mjw ?mjv)
            (= ?mjw ?mju)
            )
          (= ?mjv ?mju)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mjx Real)
      (declare-const ?mjy Real)
      (declare-const ?mjz Real)
      (declare-const ?mka Real)
      (declare-const ?mkb Real)
      (declare-const ?mkc Real)
      (assert
        (and (and (and (not (= ?mjz ?mjy))
              (not (= ?mjz ?mjx))
              )
            (not (= ?mjy ?mjx))
            )
          (or (or (= ?mkc ?mkb)
              (= ?mkc ?mka)
              )
            (= ?mkb ?mka)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mkd Real)
      (declare-const ?mke Real)
      (declare-const ?mkf Real)
      (assert
        (or (or (= ?mkf ?mke)
            (= ?mkf ?mkd)
            )
          (= ?mke ?mkd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mkg Real)
      (declare-const ?mkh Real)
      (declare-const ?mki Real)
      (assert
        (or (or (= ?mki ?mkh)
            (= ?mki ?mkg)
            )
          (= ?mkh ?mkg)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mkj Real)
      (declare-const ?mkk Real)
      (declare-const ?mkl Real)
      (declare-const ?mkm Real)
      (assert
        (or (or (= ?mkl ?mkk)
            (= ?mkl ?mkj)
            )
          (= ?mkk ?mkj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mkn Real)
      (declare-const ?mko Real)
      (declare-const ?mkp Real)
      (declare-const ?mkq Real)
      (declare-const ?mkr Real)
      (assert
        (or (or (= ?mkp ?mko)
            (= ?mkp ?mkn)
            )
          (= ?mko ?mkn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mks Real)
      (declare-const ?mkt Real)
      (declare-const ?mku Real)
      (declare-const ?mkv Real)
      (declare-const ?mkw Real)
      (declare-const ?mkx Real)
      (assert
        (and (or (or (= ?mku ?mkt)
              (= ?mku ?mks)
              )
            (= ?mkt ?mks)
            )
          (and (and (not (= ?mkx ?mkw))
              (not (= ?mkx ?mkv))
              )
            (not (= ?mkw ?mkv))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mky Real)
      (declare-const ?mkz Real)
      (declare-const ?mla Real)
      (assert
        (or (or (= ?mla ?mkz)
            (= ?mla ?mky)
            )
          (= ?mkz ?mky)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mlb Real)
      (declare-const ?mlc Real)
      (declare-const ?mld Real)
      (declare-const ?mle Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?mlc ?mlb))
                  (not (= ?mlc ?asi))
                  )
                (not (= ?mlb ?asi))
                )
              (or (or (= ?mle ?mld)
                  (= ?mle ?asi)
                  )
                (= ?mld ?asi)
                )
              )
            (and (or (or (= ?mlc ?mlb)
                  (= ?mlc ?asi)
                  )
                (= ?mlb ?asi)
                )
              (and (and (not (= ?mle ?mld))
                  (not (= ?mle ?asi))
                  )
                (not (= ?mld ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mlf Real)
      (declare-const ?mlg Real)
      (declare-const ?mlh Real)
      (declare-const ?mli Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?mlg ?mlf))
                  (not (= ?mlg ?fkf))
                  )
                (not (= ?mlf ?fkf))
                )
              (or (or (= ?mli ?mlh)
                  (= ?mli ?fkf)
                  )
                (= ?mlh ?fkf)
                )
              )
            (and (or (or (= ?mlg ?mlf)
                  (= ?mlg ?fkf)
                  )
                (= ?mlf ?fkf)
                )
              (and (and (not (= ?mli ?mlh))
                  (not (= ?mli ?fkf))
                  )
                (not (= ?mlh ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?mlj Real)
    (declare-const ?mlk Real)
    (push 1)
      (declare-const ?mll Real)
      (declare-const ?mlm Real)
      (declare-const ?mln Real)
      (assert
        (or (or (= ?mln ?mlm)
            (= ?mln ?mll)
            )
          (= ?mlm ?mll)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mlo Real)
      (declare-const ?mlp Real)
      (declare-const ?mlq Real)
      (declare-const ?mlr Real)
      (assert
        (or (or (= ?mlr ?mlq)
            (= ?mlr ?mlp)
            )
          (= ?mlq ?mlp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mls Real)
      (declare-const ?mlt Real)
      (declare-const ?mlu Real)
      (declare-const ?mlv Real)
      (declare-const ?mlw Real)
      (assert
        (or (or (= ?mlw ?mlv)
            (= ?mlw ?mlu)
            )
          (= ?mlv ?mlu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mlx Real)
      (declare-const ?mly Real)
      (declare-const ?mlz Real)
      (declare-const ?mma Real)
      (declare-const ?mmb Real)
      (declare-const ?mmc Real)
      (assert
        (and (and (and (not (= ?mlz ?mly))
              (not (= ?mlz ?mlx))
              )
            (not (= ?mly ?mlx))
            )
          (or (or (= ?mmc ?mmb)
              (= ?mmc ?mma)
              )
            (= ?mmb ?mma)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mmd Real)
      (declare-const ?mme Real)
      (declare-const ?mmf Real)
      (assert
        (or (or (= ?mmf ?mme)
            (= ?mmf ?mmd)
            )
          (= ?mme ?mmd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mmg Real)
      (declare-const ?mmh Real)
      (declare-const ?mmi Real)
      (assert
        (or (or (= ?mmi ?mmh)
            (= ?mmi ?mmg)
            )
          (= ?mmh ?mmg)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mmj Real)
      (declare-const ?mmk Real)
      (declare-const ?mml Real)
      (declare-const ?mmm Real)
      (assert
        (or (or (= ?mml ?mmk)
            (= ?mml ?mmj)
            )
          (= ?mmk ?mmj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mmn Real)
      (declare-const ?mmo Real)
      (declare-const ?mmp Real)
      (declare-const ?mmq Real)
      (declare-const ?mmr Real)
      (assert
        (or (or (= ?mmp ?mmo)
            (= ?mmp ?mmn)
            )
          (= ?mmo ?mmn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mms Real)
      (declare-const ?mmt Real)
      (declare-const ?mmu Real)
      (declare-const ?mmv Real)
      (declare-const ?mmw Real)
      (declare-const ?mmx Real)
      (assert
        (and (or (or (= ?mmu ?mmt)
              (= ?mmu ?mms)
              )
            (= ?mmt ?mms)
            )
          (and (and (not (= ?mmx ?mmw))
              (not (= ?mmx ?mmv))
              )
            (not (= ?mmw ?mmv))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mmy Real)
      (declare-const ?mmz Real)
      (declare-const ?mna Real)
      (assert
        (or (or (= ?mna ?mmz)
            (= ?mna ?mmy)
            )
          (= ?mmz ?mmy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mnb Real)
      (declare-const ?mnc Real)
      (declare-const ?mnd Real)
      (declare-const ?mne Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?mnc ?mnb))
                  (not (= ?mnc ?asi))
                  )
                (not (= ?mnb ?asi))
                )
              (or (or (= ?mne ?mnd)
                  (= ?mne ?asi)
                  )
                (= ?mnd ?asi)
                )
              )
            (and (or (or (= ?mnc ?mnb)
                  (= ?mnc ?asi)
                  )
                (= ?mnb ?asi)
                )
              (and (and (not (= ?mne ?mnd))
                  (not (= ?mne ?asi))
                  )
                (not (= ?mnd ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mnf Real)
      (declare-const ?mng Real)
      (declare-const ?mnh Real)
      (declare-const ?mni Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?mng ?mnf))
                  (not (= ?mng ?fkf))
                  )
                (not (= ?mnf ?fkf))
                )
              (or (or (= ?mni ?mnh)
                  (= ?mni ?fkf)
                  )
                (= ?mnh ?fkf)
                )
              )
            (and (or (or (= ?mng ?mnf)
                  (= ?mng ?fkf)
                  )
                (= ?mnf ?fkf)
                )
              (and (and (not (= ?mni ?mnh))
                  (not (= ?mni ?fkf))
                  )
                (not (= ?mnh ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?mnj Real)
    (declare-const ?mnk Real)
    (declare-const ?mnl Real)
    (push 1)
      (declare-const ?mnm Real)
      (declare-const ?mnn Real)
      (declare-const ?mno Real)
      (assert
        (or (or (= ?mno ?mnn)
            (= ?mno ?mnm)
            )
          (= ?mnn ?mnm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mnp Real)
      (declare-const ?mnq Real)
      (declare-const ?mnr Real)
      (declare-const ?mns Real)
      (assert
        (or (or (= ?mns ?mnr)
            (= ?mns ?mnq)
            )
          (= ?mnr ?mnq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mnt Real)
      (declare-const ?mnu Real)
      (declare-const ?mnv Real)
      (declare-const ?mnw Real)
      (declare-const ?mnx Real)
      (assert
        (or (or (= ?mnx ?mnw)
            (= ?mnx ?mnv)
            )
          (= ?mnw ?mnv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mny Real)
      (declare-const ?mnz Real)
      (declare-const ?moa Real)
      (declare-const ?mob Real)
      (declare-const ?moc Real)
      (declare-const ?mod Real)
      (assert
        (and (and (and (not (= ?moa ?mnz))
              (not (= ?moa ?mny))
              )
            (not (= ?mnz ?mny))
            )
          (or (or (= ?mod ?moc)
              (= ?mod ?mob)
              )
            (= ?moc ?mob)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?moe Real)
      (declare-const ?mof Real)
      (declare-const ?mog Real)
      (assert
        (or (or (= ?mog ?mof)
            (= ?mog ?moe)
            )
          (= ?mof ?moe)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?moh Real)
      (declare-const ?moi Real)
      (declare-const ?moj Real)
      (assert
        (or (or (= ?moj ?moi)
            (= ?moj ?moh)
            )
          (= ?moi ?moh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mok Real)
      (declare-const ?mol Real)
      (declare-const ?mom Real)
      (declare-const ?mon Real)
      (assert
        (or (or (= ?mom ?mol)
            (= ?mom ?mok)
            )
          (= ?mol ?mok)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?moo Real)
      (declare-const ?mop Real)
      (declare-const ?moq Real)
      (declare-const ?mor Real)
      (declare-const ?mos Real)
      (assert
        (or (or (= ?moq ?mop)
            (= ?moq ?moo)
            )
          (= ?mop ?moo)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mot Real)
      (declare-const ?mou Real)
      (declare-const ?mov Real)
      (declare-const ?mow Real)
      (declare-const ?mox Real)
      (declare-const ?moy Real)
      (assert
        (and (or (or (= ?mov ?mou)
              (= ?mov ?mot)
              )
            (= ?mou ?mot)
            )
          (and (and (not (= ?moy ?mox))
              (not (= ?moy ?mow))
              )
            (not (= ?mox ?mow))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?moz Real)
      (declare-const ?mpa Real)
      (declare-const ?mpb Real)
      (assert
        (or (or (= ?mpb ?mpa)
            (= ?mpb ?moz)
            )
          (= ?mpa ?moz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mpc Real)
      (declare-const ?mpd Real)
      (declare-const ?mpe Real)
      (declare-const ?mpf Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?mpd ?mpc))
                  (not (= ?mpd ?asi))
                  )
                (not (= ?mpc ?asi))
                )
              (or (or (= ?mpf ?mpe)
                  (= ?mpf ?asi)
                  )
                (= ?mpe ?asi)
                )
              )
            (and (or (or (= ?mpd ?mpc)
                  (= ?mpd ?asi)
                  )
                (= ?mpc ?asi)
                )
              (and (and (not (= ?mpf ?mpe))
                  (not (= ?mpf ?asi))
                  )
                (not (= ?mpe ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mpg Real)
      (declare-const ?mph Real)
      (declare-const ?mpi Real)
      (declare-const ?mpj Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?mph ?mpg))
                  (not (= ?mph ?fkf))
                  )
                (not (= ?mpg ?fkf))
                )
              (or (or (= ?mpj ?mpi)
                  (= ?mpj ?fkf)
                  )
                (= ?mpi ?fkf)
                )
              )
            (and (or (or (= ?mph ?mpg)
                  (= ?mph ?fkf)
                  )
                (= ?mpg ?fkf)
                )
              (and (and (not (= ?mpj ?mpi))
                  (not (= ?mpj ?fkf))
                  )
                (not (= ?mpi ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (exists ((?asi Real) )(or (and (and (and (not (= ?mnk ?mnj))
                    (not (= ?mnk ?asi))
                    )
                  (not (= ?mnj ?asi))
                  )
                (or (or (= ?mnl ?mnj)
                    (= ?mnl ?asi)
                    )
                  (= ?mnj ?asi)
                  )
                )
              (and (or (or (= ?mnk ?mnj)
                    (= ?mnk ?asi)
                    )
                  (= ?mnj ?asi)
                  )
                (and (and (not (= ?mnl ?mnj))
                    (not (= ?mnl ?asi))
                    )
                  (not (= ?mnj ?asi))
                  )
                )
              )
            )
          (exists ((?fkf Real) )(or (and (and (and (not (= ?mnk ?mnj))
                    (not (= ?mnk ?fkf))
                    )
                  (not (= ?mnj ?fkf))
                  )
                (or (or (= ?mnl ?mnj)
                    (= ?mnl ?fkf)
                    )
                  (= ?mnj ?fkf)
                  )
                )
              (and (or (or (= ?mnk ?mnj)
                    (= ?mnk ?fkf)
                    )
                  (= ?mnj ?fkf)
                  )
                (and (and (not (= ?mnl ?mnj))
                    (not (= ?mnl ?fkf))
                    )
                  (not (= ?mnj ?fkf))
                  )
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?mpk Real)
    (declare-const ?mpl Real)
    (declare-const ?mpm Real)
    (declare-const ?mpn Real)
    (push 1)
      (declare-const ?mpo Real)
      (declare-const ?mpp Real)
      (declare-const ?mpq Real)
      (assert
        (or (or (= ?mpq ?mpp)
            (= ?mpq ?mpo)
            )
          (= ?mpp ?mpo)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mpr Real)
      (declare-const ?mps Real)
      (declare-const ?mpt Real)
      (declare-const ?mpu Real)
      (assert
        (or (or (= ?mpu ?mpt)
            (= ?mpu ?mps)
            )
          (= ?mpt ?mps)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mpv Real)
      (declare-const ?mpw Real)
      (declare-const ?mpx Real)
      (declare-const ?mpy Real)
      (declare-const ?mpz Real)
      (assert
        (or (or (= ?mpz ?mpy)
            (= ?mpz ?mpx)
            )
          (= ?mpy ?mpx)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mqa Real)
      (declare-const ?mqb Real)
      (declare-const ?mqc Real)
      (declare-const ?mqd Real)
      (declare-const ?mqe Real)
      (declare-const ?mqf Real)
      (assert
        (and (and (and (not (= ?mqc ?mqb))
              (not (= ?mqc ?mqa))
              )
            (not (= ?mqb ?mqa))
            )
          (or (or (= ?mqf ?mqe)
              (= ?mqf ?mqd)
              )
            (= ?mqe ?mqd)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mqg Real)
      (declare-const ?mqh Real)
      (declare-const ?mqi Real)
      (assert
        (or (or (= ?mqi ?mqh)
            (= ?mqi ?mqg)
            )
          (= ?mqh ?mqg)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mqj Real)
      (declare-const ?mqk Real)
      (declare-const ?mql Real)
      (assert
        (or (or (= ?mql ?mqk)
            (= ?mql ?mqj)
            )
          (= ?mqk ?mqj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mqm Real)
      (declare-const ?mqn Real)
      (declare-const ?mqo Real)
      (declare-const ?mqp Real)
      (assert
        (or (or (= ?mqo ?mqn)
            (= ?mqo ?mqm)
            )
          (= ?mqn ?mqm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mqq Real)
      (declare-const ?mqr Real)
      (declare-const ?mqs Real)
      (declare-const ?mqt Real)
      (declare-const ?mqu Real)
      (assert
        (or (or (= ?mqs ?mqr)
            (= ?mqs ?mqq)
            )
          (= ?mqr ?mqq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mqv Real)
      (declare-const ?mqw Real)
      (declare-const ?mqx Real)
      (declare-const ?mqy Real)
      (declare-const ?mqz Real)
      (declare-const ?mra Real)
      (assert
        (and (or (or (= ?mqx ?mqw)
              (= ?mqx ?mqv)
              )
            (= ?mqw ?mqv)
            )
          (and (and (not (= ?mra ?mqz))
              (not (= ?mra ?mqy))
              )
            (not (= ?mqz ?mqy))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mrb Real)
      (declare-const ?mrc Real)
      (declare-const ?mrd Real)
      (assert
        (or (or (= ?mrd ?mrc)
            (= ?mrd ?mrb)
            )
          (= ?mrc ?mrb)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mre Real)
      (declare-const ?mrf Real)
      (declare-const ?mrg Real)
      (declare-const ?mrh Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?mrf ?mre))
                  (not (= ?mrf ?asi))
                  )
                (not (= ?mre ?asi))
                )
              (or (or (= ?mrh ?mrg)
                  (= ?mrh ?asi)
                  )
                (= ?mrg ?asi)
                )
              )
            (and (or (or (= ?mrf ?mre)
                  (= ?mrf ?asi)
                  )
                (= ?mre ?asi)
                )
              (and (and (not (= ?mrh ?mrg))
                  (not (= ?mrh ?asi))
                  )
                (not (= ?mrg ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mri Real)
      (declare-const ?mrj Real)
      (declare-const ?mrk Real)
      (declare-const ?mrl Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?mrj ?mri))
                  (not (= ?mrj ?fkf))
                  )
                (not (= ?mri ?fkf))
                )
              (or (or (= ?mrl ?mrk)
                  (= ?mrl ?fkf)
                  )
                (= ?mrk ?fkf)
                )
              )
            (and (or (or (= ?mrj ?mri)
                  (= ?mrj ?fkf)
                  )
                (= ?mri ?fkf)
                )
              (and (and (not (= ?mrl ?mrk))
                  (not (= ?mrl ?fkf))
                  )
                (not (= ?mrk ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?mrm Real)
    (declare-const ?mrn Real)
    (declare-const ?mro Real)
    (declare-const ?mrp Real)
    (declare-const ?mrq Real)
    (push 1)
      (declare-const ?mrr Real)
      (declare-const ?mrs Real)
      (declare-const ?mrt Real)
      (assert
        (or (or (= ?mrt ?mrs)
            (= ?mrt ?mrr)
            )
          (= ?mrs ?mrr)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mru Real)
      (declare-const ?mrv Real)
      (declare-const ?mrw Real)
      (declare-const ?mrx Real)
      (assert
        (or (or (= ?mrx ?mrw)
            (= ?mrx ?mrv)
            )
          (= ?mrw ?mrv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mry Real)
      (declare-const ?mrz Real)
      (declare-const ?msa Real)
      (declare-const ?msb Real)
      (declare-const ?msc Real)
      (assert
        (or (or (= ?msc ?msb)
            (= ?msc ?msa)
            )
          (= ?msb ?msa)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?msd Real)
      (declare-const ?mse Real)
      (declare-const ?msf Real)
      (declare-const ?msg Real)
      (declare-const ?msh Real)
      (declare-const ?msi Real)
      (assert
        (and (and (and (not (= ?msf ?mse))
              (not (= ?msf ?msd))
              )
            (not (= ?mse ?msd))
            )
          (or (or (= ?msi ?msh)
              (= ?msi ?msg)
              )
            (= ?msh ?msg)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?msj Real)
      (declare-const ?msk Real)
      (declare-const ?msl Real)
      (assert
        (or (or (= ?msl ?msk)
            (= ?msl ?msj)
            )
          (= ?msk ?msj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?msm Real)
      (declare-const ?msn Real)
      (declare-const ?mso Real)
      (assert
        (or (or (= ?mso ?msn)
            (= ?mso ?msm)
            )
          (= ?msn ?msm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?msp Real)
      (declare-const ?msq Real)
      (declare-const ?msr Real)
      (declare-const ?mss Real)
      (assert
        (or (or (= ?msr ?msq)
            (= ?msr ?msp)
            )
          (= ?msq ?msp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mst Real)
      (declare-const ?msu Real)
      (declare-const ?msv Real)
      (declare-const ?msw Real)
      (declare-const ?msx Real)
      (assert
        (or (or (= ?msv ?msu)
            (= ?msv ?mst)
            )
          (= ?msu ?mst)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?msy Real)
      (declare-const ?msz Real)
      (declare-const ?mta Real)
      (declare-const ?mtb Real)
      (declare-const ?mtc Real)
      (declare-const ?mtd Real)
      (assert
        (and (or (or (= ?mta ?msz)
              (= ?mta ?msy)
              )
            (= ?msz ?msy)
            )
          (and (and (not (= ?mtd ?mtc))
              (not (= ?mtd ?mtb))
              )
            (not (= ?mtc ?mtb))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mte Real)
      (declare-const ?mtf Real)
      (declare-const ?mtg Real)
      (assert
        (or (or (= ?mtg ?mtf)
            (= ?mtg ?mte)
            )
          (= ?mtf ?mte)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mth Real)
      (declare-const ?mti Real)
      (declare-const ?mtj Real)
      (declare-const ?mtk Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?mti ?mth))
                  (not (= ?mti ?asi))
                  )
                (not (= ?mth ?asi))
                )
              (or (or (= ?mtk ?mtj)
                  (= ?mtk ?asi)
                  )
                (= ?mtj ?asi)
                )
              )
            (and (or (or (= ?mti ?mth)
                  (= ?mti ?asi)
                  )
                (= ?mth ?asi)
                )
              (and (and (not (= ?mtk ?mtj))
                  (not (= ?mtk ?asi))
                  )
                (not (= ?mtj ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mtl Real)
      (declare-const ?mtm Real)
      (declare-const ?mtn Real)
      (declare-const ?mto Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?mtm ?mtl))
                  (not (= ?mtm ?fkf))
                  )
                (not (= ?mtl ?fkf))
                )
              (or (or (= ?mto ?mtn)
                  (= ?mto ?fkf)
                  )
                (= ?mtn ?fkf)
                )
              )
            (and (or (or (= ?mtm ?mtl)
                  (= ?mtm ?fkf)
                  )
                (= ?mtl ?fkf)
                )
              (and (and (not (= ?mto ?mtn))
                  (not (= ?mto ?fkf))
                  )
                (not (= ?mtn ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?mtp Real)
    (declare-const ?mtq Real)
    (push 1)
      (declare-const ?mtr Real)
      (declare-const ?mts Real)
      (declare-const ?mtt Real)
      (assert
        (or (or (= ?mtt ?mts)
            (= ?mtt ?mtr)
            )
          (= ?mts ?mtr)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mtu Real)
      (declare-const ?mtv Real)
      (declare-const ?mtw Real)
      (declare-const ?mtx Real)
      (assert
        (or (or (= ?mtx ?mtw)
            (= ?mtx ?mtv)
            )
          (= ?mtw ?mtv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mty Real)
      (declare-const ?mtz Real)
      (declare-const ?mua Real)
      (declare-const ?mub Real)
      (declare-const ?muc Real)
      (assert
        (or (or (= ?muc ?mub)
            (= ?muc ?mua)
            )
          (= ?mub ?mua)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mud Real)
      (declare-const ?mue Real)
      (declare-const ?muf Real)
      (declare-const ?mug Real)
      (declare-const ?muh Real)
      (declare-const ?mui Real)
      (assert
        (and (and (and (not (= ?muf ?mue))
              (not (= ?muf ?mud))
              )
            (not (= ?mue ?mud))
            )
          (or (or (= ?mui ?muh)
              (= ?mui ?mug)
              )
            (= ?muh ?mug)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?muj Real)
      (declare-const ?muk Real)
      (declare-const ?mul Real)
      (assert
        (or (or (= ?mul ?muk)
            (= ?mul ?muj)
            )
          (= ?muk ?muj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mum Real)
      (declare-const ?mun Real)
      (declare-const ?muo Real)
      (assert
        (or (or (= ?muo ?mun)
            (= ?muo ?mum)
            )
          (= ?mun ?mum)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mup Real)
      (declare-const ?muq Real)
      (declare-const ?mur Real)
      (declare-const ?mus Real)
      (assert
        (or (or (= ?mur ?muq)
            (= ?mur ?mup)
            )
          (= ?muq ?mup)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mut Real)
      (declare-const ?muu Real)
      (declare-const ?muv Real)
      (declare-const ?muw Real)
      (declare-const ?mux Real)
      (assert
        (or (or (= ?muv ?muu)
            (= ?muv ?mut)
            )
          (= ?muu ?mut)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?muy Real)
      (declare-const ?muz Real)
      (declare-const ?mva Real)
      (declare-const ?mvb Real)
      (declare-const ?mvc Real)
      (declare-const ?mvd Real)
      (assert
        (and (or (or (= ?mva ?muz)
              (= ?mva ?muy)
              )
            (= ?muz ?muy)
            )
          (and (and (not (= ?mvd ?mvc))
              (not (= ?mvd ?mvb))
              )
            (not (= ?mvc ?mvb))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mve Real)
      (declare-const ?mvf Real)
      (declare-const ?mvg Real)
      (assert
        (or (or (= ?mvg ?mvf)
            (= ?mvg ?mve)
            )
          (= ?mvf ?mve)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mvh Real)
      (declare-const ?mvi Real)
      (declare-const ?mvj Real)
      (declare-const ?mvk Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?mvi ?mvh))
                  (not (= ?mvi ?asi))
                  )
                (not (= ?mvh ?asi))
                )
              (or (or (= ?mvk ?mvj)
                  (= ?mvk ?asi)
                  )
                (= ?mvj ?asi)
                )
              )
            (and (or (or (= ?mvi ?mvh)
                  (= ?mvi ?asi)
                  )
                (= ?mvh ?asi)
                )
              (and (and (not (= ?mvk ?mvj))
                  (not (= ?mvk ?asi))
                  )
                (not (= ?mvj ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mvl Real)
      (declare-const ?mvm Real)
      (declare-const ?mvn Real)
      (declare-const ?mvo Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?mvm ?mvl))
                  (not (= ?mvm ?fkf))
                  )
                (not (= ?mvl ?fkf))
                )
              (or (or (= ?mvo ?mvn)
                  (= ?mvo ?fkf)
                  )
                (= ?mvn ?fkf)
                )
              )
            (and (or (or (= ?mvm ?mvl)
                  (= ?mvm ?fkf)
                  )
                (= ?mvl ?fkf)
                )
              (and (and (not (= ?mvo ?mvn))
                  (not (= ?mvo ?fkf))
                  )
                (not (= ?mvn ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?mvp Real)
    (declare-const ?mvq Real)
    (declare-const ?mvr Real)
    (push 1)
      (declare-const ?mvs Real)
      (declare-const ?mvt Real)
      (declare-const ?mvu Real)
      (assert
        (or (or (= ?mvu ?mvt)
            (= ?mvu ?mvs)
            )
          (= ?mvt ?mvs)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mvv Real)
      (declare-const ?mvw Real)
      (declare-const ?mvx Real)
      (declare-const ?mvy Real)
      (assert
        (or (or (= ?mvy ?mvx)
            (= ?mvy ?mvw)
            )
          (= ?mvx ?mvw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mvz Real)
      (declare-const ?mwa Real)
      (declare-const ?mwb Real)
      (declare-const ?mwc Real)
      (declare-const ?mwd Real)
      (assert
        (or (or (= ?mwd ?mwc)
            (= ?mwd ?mwb)
            )
          (= ?mwc ?mwb)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mwe Real)
      (declare-const ?mwf Real)
      (declare-const ?mwg Real)
      (declare-const ?mwh Real)
      (declare-const ?mwi Real)
      (declare-const ?mwj Real)
      (assert
        (and (and (and (not (= ?mwg ?mwf))
              (not (= ?mwg ?mwe))
              )
            (not (= ?mwf ?mwe))
            )
          (or (or (= ?mwj ?mwi)
              (= ?mwj ?mwh)
              )
            (= ?mwi ?mwh)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mwk Real)
      (declare-const ?mwl Real)
      (declare-const ?mwm Real)
      (assert
        (or (or (= ?mwm ?mwl)
            (= ?mwm ?mwk)
            )
          (= ?mwl ?mwk)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mwn Real)
      (declare-const ?mwo Real)
      (declare-const ?mwp Real)
      (assert
        (or (or (= ?mwp ?mwo)
            (= ?mwp ?mwn)
            )
          (= ?mwo ?mwn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mwq Real)
      (declare-const ?mwr Real)
      (declare-const ?mws Real)
      (declare-const ?mwt Real)
      (assert
        (or (or (= ?mws ?mwr)
            (= ?mws ?mwq)
            )
          (= ?mwr ?mwq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mwu Real)
      (declare-const ?mwv Real)
      (declare-const ?mww Real)
      (declare-const ?mwx Real)
      (declare-const ?mwy Real)
      (assert
        (or (or (= ?mww ?mwv)
            (= ?mww ?mwu)
            )
          (= ?mwv ?mwu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mwz Real)
      (declare-const ?mxa Real)
      (declare-const ?mxb Real)
      (declare-const ?mxc Real)
      (declare-const ?mxd Real)
      (declare-const ?mxe Real)
      (assert
        (and (or (or (= ?mxb ?mxa)
              (= ?mxb ?mwz)
              )
            (= ?mxa ?mwz)
            )
          (and (and (not (= ?mxe ?mxd))
              (not (= ?mxe ?mxc))
              )
            (not (= ?mxd ?mxc))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mxf Real)
      (declare-const ?mxg Real)
      (declare-const ?mxh Real)
      (assert
        (or (or (= ?mxh ?mxg)
            (= ?mxh ?mxf)
            )
          (= ?mxg ?mxf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mxi Real)
      (declare-const ?mxj Real)
      (declare-const ?mxk Real)
      (declare-const ?mxl Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?mxj ?mxi))
                  (not (= ?mxj ?asi))
                  )
                (not (= ?mxi ?asi))
                )
              (or (or (= ?mxl ?mxk)
                  (= ?mxl ?asi)
                  )
                (= ?mxk ?asi)
                )
              )
            (and (or (or (= ?mxj ?mxi)
                  (= ?mxj ?asi)
                  )
                (= ?mxi ?asi)
                )
              (and (and (not (= ?mxl ?mxk))
                  (not (= ?mxl ?asi))
                  )
                (not (= ?mxk ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mxm Real)
      (declare-const ?mxn Real)
      (declare-const ?mxo Real)
      (declare-const ?mxp Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?mxn ?mxm))
                  (not (= ?mxn ?fkf))
                  )
                (not (= ?mxm ?fkf))
                )
              (or (or (= ?mxp ?mxo)
                  (= ?mxp ?fkf)
                  )
                (= ?mxo ?fkf)
                )
              )
            (and (or (or (= ?mxn ?mxm)
                  (= ?mxn ?fkf)
                  )
                (= ?mxm ?fkf)
                )
              (and (and (not (= ?mxp ?mxo))
                  (not (= ?mxp ?fkf))
                  )
                (not (= ?mxo ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?mxq Real)
    (declare-const ?mxr Real)
    (declare-const ?mxs Real)
    (declare-const ?mxt Real)
    (push 1)
      (declare-const ?mxu Real)
      (declare-const ?mxv Real)
      (declare-const ?mxw Real)
      (assert
        (or (or (= ?mxw ?mxv)
            (= ?mxw ?mxu)
            )
          (= ?mxv ?mxu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mxx Real)
      (declare-const ?mxy Real)
      (declare-const ?mxz Real)
      (declare-const ?mya Real)
      (assert
        (or (or (= ?mya ?mxz)
            (= ?mya ?mxy)
            )
          (= ?mxz ?mxy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?myb Real)
      (declare-const ?myc Real)
      (declare-const ?myd Real)
      (declare-const ?mye Real)
      (declare-const ?myf Real)
      (assert
        (or (or (= ?myf ?mye)
            (= ?myf ?myd)
            )
          (= ?mye ?myd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?myg Real)
      (declare-const ?myh Real)
      (declare-const ?myi Real)
      (declare-const ?myj Real)
      (declare-const ?myk Real)
      (declare-const ?myl Real)
      (assert
        (and (and (and (not (= ?myi ?myh))
              (not (= ?myi ?myg))
              )
            (not (= ?myh ?myg))
            )
          (or (or (= ?myl ?myk)
              (= ?myl ?myj)
              )
            (= ?myk ?myj)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mym Real)
      (declare-const ?myn Real)
      (declare-const ?myo Real)
      (assert
        (or (or (= ?myo ?myn)
            (= ?myo ?mym)
            )
          (= ?myn ?mym)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?myp Real)
      (declare-const ?myq Real)
      (declare-const ?myr Real)
      (assert
        (or (or (= ?myr ?myq)
            (= ?myr ?myp)
            )
          (= ?myq ?myp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mys Real)
      (declare-const ?myt Real)
      (declare-const ?myu Real)
      (declare-const ?myv Real)
      (assert
        (or (or (= ?myu ?myt)
            (= ?myu ?mys)
            )
          (= ?myt ?mys)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?myw Real)
      (declare-const ?myx Real)
      (declare-const ?myy Real)
      (declare-const ?myz Real)
      (declare-const ?mza Real)
      (assert
        (or (or (= ?myy ?myx)
            (= ?myy ?myw)
            )
          (= ?myx ?myw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mzb Real)
      (declare-const ?mzc Real)
      (declare-const ?mzd Real)
      (declare-const ?mze Real)
      (declare-const ?mzf Real)
      (declare-const ?mzg Real)
      (assert
        (and (or (or (= ?mzd ?mzc)
              (= ?mzd ?mzb)
              )
            (= ?mzc ?mzb)
            )
          (and (and (not (= ?mzg ?mzf))
              (not (= ?mzg ?mze))
              )
            (not (= ?mzf ?mze))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mzh Real)
      (declare-const ?mzi Real)
      (declare-const ?mzj Real)
      (assert
        (or (or (= ?mzj ?mzi)
            (= ?mzj ?mzh)
            )
          (= ?mzi ?mzh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mzk Real)
      (declare-const ?mzl Real)
      (declare-const ?mzm Real)
      (declare-const ?mzn Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?mzl ?mzk))
                  (not (= ?mzl ?asi))
                  )
                (not (= ?mzk ?asi))
                )
              (or (or (= ?mzn ?mzm)
                  (= ?mzn ?asi)
                  )
                (= ?mzm ?asi)
                )
              )
            (and (or (or (= ?mzl ?mzk)
                  (= ?mzl ?asi)
                  )
                (= ?mzk ?asi)
                )
              (and (and (not (= ?mzn ?mzm))
                  (not (= ?mzn ?asi))
                  )
                (not (= ?mzm ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?mzo Real)
      (declare-const ?mzp Real)
      (declare-const ?mzq Real)
      (declare-const ?mzr Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?mzp ?mzo))
                  (not (= ?mzp ?fkf))
                  )
                (not (= ?mzo ?fkf))
                )
              (or (or (= ?mzr ?mzq)
                  (= ?mzr ?fkf)
                  )
                (= ?mzq ?fkf)
                )
              )
            (and (or (or (= ?mzp ?mzo)
                  (= ?mzp ?fkf)
                  )
                (= ?mzo ?fkf)
                )
              (and (and (not (= ?mzr ?mzq))
                  (not (= ?mzr ?fkf))
                  )
                (not (= ?mzq ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?mzs Real)
    (declare-const ?mzt Real)
    (declare-const ?mzu Real)
    (declare-const ?mzv Real)
    (declare-const ?mzw Real)
    (push 1)
      (declare-const ?mzx Real)
      (declare-const ?mzy Real)
      (declare-const ?mzz Real)
      (assert
        (or (or (= ?mzz ?mzy)
            (= ?mzz ?mzx)
            )
          (= ?mzy ?mzx)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?naa Real)
      (declare-const ?nab Real)
      (declare-const ?nac Real)
      (declare-const ?nad Real)
      (assert
        (or (or (= ?nad ?nac)
            (= ?nad ?nab)
            )
          (= ?nac ?nab)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nae Real)
      (declare-const ?naf Real)
      (declare-const ?nag Real)
      (declare-const ?nah Real)
      (declare-const ?nai Real)
      (assert
        (or (or (= ?nai ?nah)
            (= ?nai ?nag)
            )
          (= ?nah ?nag)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?naj Real)
      (declare-const ?nak Real)
      (declare-const ?nal Real)
      (declare-const ?nam Real)
      (declare-const ?nan Real)
      (declare-const ?nao Real)
      (assert
        (and (and (and (not (= ?nal ?nak))
              (not (= ?nal ?naj))
              )
            (not (= ?nak ?naj))
            )
          (or (or (= ?nao ?nan)
              (= ?nao ?nam)
              )
            (= ?nan ?nam)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nap Real)
      (declare-const ?naq Real)
      (declare-const ?nar Real)
      (assert
        (or (or (= ?nar ?naq)
            (= ?nar ?nap)
            )
          (= ?naq ?nap)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nas Real)
      (declare-const ?nat Real)
      (declare-const ?nau Real)
      (assert
        (or (or (= ?nau ?nat)
            (= ?nau ?nas)
            )
          (= ?nat ?nas)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nav Real)
      (declare-const ?naw Real)
      (declare-const ?nax Real)
      (declare-const ?nay Real)
      (assert
        (or (or (= ?nax ?naw)
            (= ?nax ?nav)
            )
          (= ?naw ?nav)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?naz Real)
      (declare-const ?nba Real)
      (declare-const ?nbb Real)
      (declare-const ?nbc Real)
      (declare-const ?nbd Real)
      (assert
        (or (or (= ?nbb ?nba)
            (= ?nbb ?naz)
            )
          (= ?nba ?naz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nbe Real)
      (declare-const ?nbf Real)
      (declare-const ?nbg Real)
      (declare-const ?nbh Real)
      (declare-const ?nbi Real)
      (declare-const ?nbj Real)
      (assert
        (and (or (or (= ?nbg ?nbf)
              (= ?nbg ?nbe)
              )
            (= ?nbf ?nbe)
            )
          (and (and (not (= ?nbj ?nbi))
              (not (= ?nbj ?nbh))
              )
            (not (= ?nbi ?nbh))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nbk Real)
      (declare-const ?nbl Real)
      (declare-const ?nbm Real)
      (assert
        (or (or (= ?nbm ?nbl)
            (= ?nbm ?nbk)
            )
          (= ?nbl ?nbk)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nbn Real)
      (declare-const ?nbo Real)
      (declare-const ?nbp Real)
      (declare-const ?nbq Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?nbo ?nbn))
                  (not (= ?nbo ?asi))
                  )
                (not (= ?nbn ?asi))
                )
              (or (or (= ?nbq ?nbp)
                  (= ?nbq ?asi)
                  )
                (= ?nbp ?asi)
                )
              )
            (and (or (or (= ?nbo ?nbn)
                  (= ?nbo ?asi)
                  )
                (= ?nbn ?asi)
                )
              (and (and (not (= ?nbq ?nbp))
                  (not (= ?nbq ?asi))
                  )
                (not (= ?nbp ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nbr Real)
      (declare-const ?nbs Real)
      (declare-const ?nbt Real)
      (declare-const ?nbu Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?nbs ?nbr))
                  (not (= ?nbs ?fkf))
                  )
                (not (= ?nbr ?fkf))
                )
              (or (or (= ?nbu ?nbt)
                  (= ?nbu ?fkf)
                  )
                (= ?nbt ?fkf)
                )
              )
            (and (or (or (= ?nbs ?nbr)
                  (= ?nbs ?fkf)
                  )
                (= ?nbr ?fkf)
                )
              (and (and (not (= ?nbu ?nbt))
                  (not (= ?nbu ?fkf))
                  )
                (not (= ?nbt ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (and (and (and (not (= ?mzu ?mzt))
                (not (= ?mzu ?mzs))
                )
              (not (= ?mzt ?mzs))
              )
            (or (or (= ?mzw ?mzv)
                (= ?mzw ?mzs)
                )
              (= ?mzv ?mzs)
              )
            )
          (and (or (or (= ?mzu ?mzt)
                (= ?mzu ?mzs)
                )
              (= ?mzt ?mzs)
              )
            (and (and (not (= ?mzw ?mzv))
                (not (= ?mzw ?mzs))
                )
              (not (= ?mzv ?mzs))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?nbv Real)
    (declare-const ?nbw Real)
    (declare-const ?nbx Real)
    (declare-const ?nby Real)
    (declare-const ?nbz Real)
    (declare-const ?nca Real)
    (push 1)
      (declare-const ?ncb Real)
      (declare-const ?ncc Real)
      (declare-const ?ncd Real)
      (assert
        (or (or (= ?ncd ?ncc)
            (= ?ncd ?ncb)
            )
          (= ?ncc ?ncb)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nce Real)
      (declare-const ?ncf Real)
      (declare-const ?ncg Real)
      (declare-const ?nch Real)
      (assert
        (or (or (= ?nch ?ncg)
            (= ?nch ?ncf)
            )
          (= ?ncg ?ncf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nci Real)
      (declare-const ?ncj Real)
      (declare-const ?nck Real)
      (declare-const ?ncl Real)
      (declare-const ?ncm Real)
      (assert
        (or (or (= ?ncm ?ncl)
            (= ?ncm ?nck)
            )
          (= ?ncl ?nck)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ncn Real)
      (declare-const ?nco Real)
      (declare-const ?ncp Real)
      (declare-const ?ncq Real)
      (declare-const ?ncr Real)
      (declare-const ?ncs Real)
      (assert
        (and (and (and (not (= ?ncp ?nco))
              (not (= ?ncp ?ncn))
              )
            (not (= ?nco ?ncn))
            )
          (or (or (= ?ncs ?ncr)
              (= ?ncs ?ncq)
              )
            (= ?ncr ?ncq)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nct Real)
      (declare-const ?ncu Real)
      (declare-const ?ncv Real)
      (assert
        (or (or (= ?ncv ?ncu)
            (= ?ncv ?nct)
            )
          (= ?ncu ?nct)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ncw Real)
      (declare-const ?ncx Real)
      (declare-const ?ncy Real)
      (assert
        (or (or (= ?ncy ?ncx)
            (= ?ncy ?ncw)
            )
          (= ?ncx ?ncw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ncz Real)
      (declare-const ?nda Real)
      (declare-const ?ndb Real)
      (declare-const ?ndc Real)
      (assert
        (or (or (= ?ndb ?nda)
            (= ?ndb ?ncz)
            )
          (= ?nda ?ncz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ndd Real)
      (declare-const ?nde Real)
      (declare-const ?ndf Real)
      (declare-const ?ndg Real)
      (declare-const ?ndh Real)
      (assert
        (or (or (= ?ndf ?nde)
            (= ?ndf ?ndd)
            )
          (= ?nde ?ndd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ndi Real)
      (declare-const ?ndj Real)
      (declare-const ?ndk Real)
      (declare-const ?ndl Real)
      (declare-const ?ndm Real)
      (declare-const ?ndn Real)
      (assert
        (and (or (or (= ?ndk ?ndj)
              (= ?ndk ?ndi)
              )
            (= ?ndj ?ndi)
            )
          (and (and (not (= ?ndn ?ndm))
              (not (= ?ndn ?ndl))
              )
            (not (= ?ndm ?ndl))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ndo Real)
      (declare-const ?ndp Real)
      (declare-const ?ndq Real)
      (assert
        (or (or (= ?ndq ?ndp)
            (= ?ndq ?ndo)
            )
          (= ?ndp ?ndo)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ndr Real)
      (declare-const ?nds Real)
      (declare-const ?ndt Real)
      (declare-const ?ndu Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?nds ?ndr))
                  (not (= ?nds ?asi))
                  )
                (not (= ?ndr ?asi))
                )
              (or (or (= ?ndu ?ndt)
                  (= ?ndu ?asi)
                  )
                (= ?ndt ?asi)
                )
              )
            (and (or (or (= ?nds ?ndr)
                  (= ?nds ?asi)
                  )
                (= ?ndr ?asi)
                )
              (and (and (not (= ?ndu ?ndt))
                  (not (= ?ndu ?asi))
                  )
                (not (= ?ndt ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ndv Real)
      (declare-const ?ndw Real)
      (declare-const ?ndx Real)
      (declare-const ?ndy Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?ndw ?ndv))
                  (not (= ?ndw ?fkf))
                  )
                (not (= ?ndv ?fkf))
                )
              (or (or (= ?ndy ?ndx)
                  (= ?ndy ?fkf)
                  )
                (= ?ndx ?fkf)
                )
              )
            (and (or (or (= ?ndw ?ndv)
                  (= ?ndw ?fkf)
                  )
                (= ?ndv ?fkf)
                )
              (and (and (not (= ?ndy ?ndx))
                  (not (= ?ndy ?fkf))
                  )
                (not (= ?ndx ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ndz Real)
      (declare-const ?nea Real)
      (declare-const ?neb Real)
      (declare-const ?nec Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?nea ?ndz))
                  (not (= ?nea ?mzs))
                  )
                (not (= ?ndz ?mzs))
                )
              (or (or (= ?nec ?neb)
                  (= ?nec ?mzs)
                  )
                (= ?neb ?mzs)
                )
              )
            (and (or (or (= ?nea ?ndz)
                  (= ?nea ?mzs)
                  )
                (= ?ndz ?mzs)
                )
              (and (and (not (= ?nec ?neb))
                  (not (= ?nec ?mzs))
                  )
                (not (= ?neb ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (= ?nca ?nbz)
            (= ?nca ?nbv)
            )
          (= ?nbz ?nbv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?ned Real)
    (declare-const ?nee Real)
    (declare-const ?nef Real)
    (push 1)
      (declare-const ?neg Real)
      (declare-const ?neh Real)
      (declare-const ?nei Real)
      (assert
        (or (or (= ?nei ?neh)
            (= ?nei ?neg)
            )
          (= ?neh ?neg)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nej Real)
      (declare-const ?nek Real)
      (declare-const ?nel Real)
      (declare-const ?nem Real)
      (assert
        (or (or (= ?nem ?nel)
            (= ?nem ?nek)
            )
          (= ?nel ?nek)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nen Real)
      (declare-const ?neo Real)
      (declare-const ?nep Real)
      (declare-const ?neq Real)
      (declare-const ?ner Real)
      (assert
        (or (or (= ?ner ?neq)
            (= ?ner ?nep)
            )
          (= ?neq ?nep)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nes Real)
      (declare-const ?net Real)
      (declare-const ?neu Real)
      (declare-const ?nev Real)
      (declare-const ?new Real)
      (declare-const ?nex Real)
      (assert
        (and (and (and (not (= ?neu ?net))
              (not (= ?neu ?nes))
              )
            (not (= ?net ?nes))
            )
          (or (or (= ?nex ?new)
              (= ?nex ?nev)
              )
            (= ?new ?nev)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ney Real)
      (declare-const ?nez Real)
      (declare-const ?nfa Real)
      (assert
        (or (or (= ?nfa ?nez)
            (= ?nfa ?ney)
            )
          (= ?nez ?ney)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nfb Real)
      (declare-const ?nfc Real)
      (declare-const ?nfd Real)
      (assert
        (or (or (= ?nfd ?nfc)
            (= ?nfd ?nfb)
            )
          (= ?nfc ?nfb)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nfe Real)
      (declare-const ?nff Real)
      (declare-const ?nfg Real)
      (declare-const ?nfh Real)
      (assert
        (or (or (= ?nfg ?nff)
            (= ?nfg ?nfe)
            )
          (= ?nff ?nfe)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nfi Real)
      (declare-const ?nfj Real)
      (declare-const ?nfk Real)
      (declare-const ?nfl Real)
      (declare-const ?nfm Real)
      (assert
        (or (or (= ?nfk ?nfj)
            (= ?nfk ?nfi)
            )
          (= ?nfj ?nfi)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nfn Real)
      (declare-const ?nfo Real)
      (declare-const ?nfp Real)
      (declare-const ?nfq Real)
      (declare-const ?nfr Real)
      (declare-const ?nfs Real)
      (assert
        (and (or (or (= ?nfp ?nfo)
              (= ?nfp ?nfn)
              )
            (= ?nfo ?nfn)
            )
          (and (and (not (= ?nfs ?nfr))
              (not (= ?nfs ?nfq))
              )
            (not (= ?nfr ?nfq))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nft Real)
      (declare-const ?nfu Real)
      (declare-const ?nfv Real)
      (assert
        (or (or (= ?nfv ?nfu)
            (= ?nfv ?nft)
            )
          (= ?nfu ?nft)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nfw Real)
      (declare-const ?nfx Real)
      (declare-const ?nfy Real)
      (declare-const ?nfz Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?nfx ?nfw))
                  (not (= ?nfx ?asi))
                  )
                (not (= ?nfw ?asi))
                )
              (or (or (= ?nfz ?nfy)
                  (= ?nfz ?asi)
                  )
                (= ?nfy ?asi)
                )
              )
            (and (or (or (= ?nfx ?nfw)
                  (= ?nfx ?asi)
                  )
                (= ?nfw ?asi)
                )
              (and (and (not (= ?nfz ?nfy))
                  (not (= ?nfz ?asi))
                  )
                (not (= ?nfy ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nga Real)
      (declare-const ?ngb Real)
      (declare-const ?ngc Real)
      (declare-const ?ngd Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?ngb ?nga))
                  (not (= ?ngb ?fkf))
                  )
                (not (= ?nga ?fkf))
                )
              (or (or (= ?ngd ?ngc)
                  (= ?ngd ?fkf)
                  )
                (= ?ngc ?fkf)
                )
              )
            (and (or (or (= ?ngb ?nga)
                  (= ?ngb ?fkf)
                  )
                (= ?nga ?fkf)
                )
              (and (and (not (= ?ngd ?ngc))
                  (not (= ?ngd ?fkf))
                  )
                (not (= ?ngc ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nge Real)
      (declare-const ?ngf Real)
      (declare-const ?ngg Real)
      (declare-const ?ngh Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?ngf ?nge))
                  (not (= ?ngf ?mzs))
                  )
                (not (= ?nge ?mzs))
                )
              (or (or (= ?ngh ?ngg)
                  (= ?ngh ?mzs)
                  )
                (= ?ngg ?mzs)
                )
              )
            (and (or (or (= ?ngf ?nge)
                  (= ?ngf ?mzs)
                  )
                (= ?nge ?mzs)
                )
              (and (and (not (= ?ngh ?ngg))
                  (not (= ?ngh ?mzs))
                  )
                (not (= ?ngg ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (= ?nef ?nee)
            (= ?nef ?ned)
            )
          (= ?nee ?ned)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?ngi Real)
    (declare-const ?ngj Real)
    (declare-const ?ngk Real)
    (declare-const ?ngl Real)
    (push 1)
      (declare-const ?ngm Real)
      (declare-const ?ngn Real)
      (declare-const ?ngo Real)
      (assert
        (or (or (= ?ngo ?ngn)
            (= ?ngo ?ngm)
            )
          (= ?ngn ?ngm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ngp Real)
      (declare-const ?ngq Real)
      (declare-const ?ngr Real)
      (declare-const ?ngs Real)
      (assert
        (or (or (= ?ngs ?ngr)
            (= ?ngs ?ngq)
            )
          (= ?ngr ?ngq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ngt Real)
      (declare-const ?ngu Real)
      (declare-const ?ngv Real)
      (declare-const ?ngw Real)
      (declare-const ?ngx Real)
      (assert
        (or (or (= ?ngx ?ngw)
            (= ?ngx ?ngv)
            )
          (= ?ngw ?ngv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ngy Real)
      (declare-const ?ngz Real)
      (declare-const ?nha Real)
      (declare-const ?nhb Real)
      (declare-const ?nhc Real)
      (declare-const ?nhd Real)
      (assert
        (and (and (and (not (= ?nha ?ngz))
              (not (= ?nha ?ngy))
              )
            (not (= ?ngz ?ngy))
            )
          (or (or (= ?nhd ?nhc)
              (= ?nhd ?nhb)
              )
            (= ?nhc ?nhb)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nhe Real)
      (declare-const ?nhf Real)
      (declare-const ?nhg Real)
      (assert
        (or (or (= ?nhg ?nhf)
            (= ?nhg ?nhe)
            )
          (= ?nhf ?nhe)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nhh Real)
      (declare-const ?nhi Real)
      (declare-const ?nhj Real)
      (assert
        (or (or (= ?nhj ?nhi)
            (= ?nhj ?nhh)
            )
          (= ?nhi ?nhh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nhk Real)
      (declare-const ?nhl Real)
      (declare-const ?nhm Real)
      (declare-const ?nhn Real)
      (assert
        (or (or (= ?nhm ?nhl)
            (= ?nhm ?nhk)
            )
          (= ?nhl ?nhk)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nho Real)
      (declare-const ?nhp Real)
      (declare-const ?nhq Real)
      (declare-const ?nhr Real)
      (declare-const ?nhs Real)
      (assert
        (or (or (= ?nhq ?nhp)
            (= ?nhq ?nho)
            )
          (= ?nhp ?nho)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nht Real)
      (declare-const ?nhu Real)
      (declare-const ?nhv Real)
      (declare-const ?nhw Real)
      (declare-const ?nhx Real)
      (declare-const ?nhy Real)
      (assert
        (and (or (or (= ?nhv ?nhu)
              (= ?nhv ?nht)
              )
            (= ?nhu ?nht)
            )
          (and (and (not (= ?nhy ?nhx))
              (not (= ?nhy ?nhw))
              )
            (not (= ?nhx ?nhw))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nhz Real)
      (declare-const ?nia Real)
      (declare-const ?nib Real)
      (assert
        (or (or (= ?nib ?nia)
            (= ?nib ?nhz)
            )
          (= ?nia ?nhz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nic Real)
      (declare-const ?nid Real)
      (declare-const ?nie Real)
      (declare-const ?nif Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?nid ?nic))
                  (not (= ?nid ?asi))
                  )
                (not (= ?nic ?asi))
                )
              (or (or (= ?nif ?nie)
                  (= ?nif ?asi)
                  )
                (= ?nie ?asi)
                )
              )
            (and (or (or (= ?nid ?nic)
                  (= ?nid ?asi)
                  )
                (= ?nic ?asi)
                )
              (and (and (not (= ?nif ?nie))
                  (not (= ?nif ?asi))
                  )
                (not (= ?nie ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nig Real)
      (declare-const ?nih Real)
      (declare-const ?nii Real)
      (declare-const ?nij Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?nih ?nig))
                  (not (= ?nih ?fkf))
                  )
                (not (= ?nig ?fkf))
                )
              (or (or (= ?nij ?nii)
                  (= ?nij ?fkf)
                  )
                (= ?nii ?fkf)
                )
              )
            (and (or (or (= ?nih ?nig)
                  (= ?nih ?fkf)
                  )
                (= ?nig ?fkf)
                )
              (and (and (not (= ?nij ?nii))
                  (not (= ?nij ?fkf))
                  )
                (not (= ?nii ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nik Real)
      (declare-const ?nil Real)
      (declare-const ?nim Real)
      (declare-const ?nin Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?nil ?nik))
                  (not (= ?nil ?mzs))
                  )
                (not (= ?nik ?mzs))
                )
              (or (or (= ?nin ?nim)
                  (= ?nin ?mzs)
                  )
                (= ?nim ?mzs)
                )
              )
            (and (or (or (= ?nil ?nik)
                  (= ?nil ?mzs)
                  )
                (= ?nik ?mzs)
                )
              (and (and (not (= ?nin ?nim))
                  (not (= ?nin ?mzs))
                  )
                (not (= ?nim ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?nio Real)
    (declare-const ?nip Real)
    (declare-const ?niq Real)
    (declare-const ?nir Real)
    (declare-const ?nis Real)
    (push 1)
      (declare-const ?nit Real)
      (declare-const ?niu Real)
      (declare-const ?niv Real)
      (assert
        (or (or (= ?niv ?niu)
            (= ?niv ?nit)
            )
          (= ?niu ?nit)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?niw Real)
      (declare-const ?nix Real)
      (declare-const ?niy Real)
      (declare-const ?niz Real)
      (assert
        (or (or (= ?niz ?niy)
            (= ?niz ?nix)
            )
          (= ?niy ?nix)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nja Real)
      (declare-const ?njb Real)
      (declare-const ?njc Real)
      (declare-const ?njd Real)
      (declare-const ?nje Real)
      (assert
        (or (or (= ?nje ?njd)
            (= ?nje ?njc)
            )
          (= ?njd ?njc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?njf Real)
      (declare-const ?njg Real)
      (declare-const ?njh Real)
      (declare-const ?nji Real)
      (declare-const ?njj Real)
      (declare-const ?njk Real)
      (assert
        (and (and (and (not (= ?njh ?njg))
              (not (= ?njh ?njf))
              )
            (not (= ?njg ?njf))
            )
          (or (or (= ?njk ?njj)
              (= ?njk ?nji)
              )
            (= ?njj ?nji)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?njl Real)
      (declare-const ?njm Real)
      (declare-const ?njn Real)
      (assert
        (or (or (= ?njn ?njm)
            (= ?njn ?njl)
            )
          (= ?njm ?njl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?njo Real)
      (declare-const ?njp Real)
      (declare-const ?njq Real)
      (assert
        (or (or (= ?njq ?njp)
            (= ?njq ?njo)
            )
          (= ?njp ?njo)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?njr Real)
      (declare-const ?njs Real)
      (declare-const ?njt Real)
      (declare-const ?nju Real)
      (assert
        (or (or (= ?njt ?njs)
            (= ?njt ?njr)
            )
          (= ?njs ?njr)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?njv Real)
      (declare-const ?njw Real)
      (declare-const ?njx Real)
      (declare-const ?njy Real)
      (declare-const ?njz Real)
      (assert
        (or (or (= ?njx ?njw)
            (= ?njx ?njv)
            )
          (= ?njw ?njv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nka Real)
      (declare-const ?nkb Real)
      (declare-const ?nkc Real)
      (declare-const ?nkd Real)
      (declare-const ?nke Real)
      (declare-const ?nkf Real)
      (assert
        (and (or (or (= ?nkc ?nkb)
              (= ?nkc ?nka)
              )
            (= ?nkb ?nka)
            )
          (and (and (not (= ?nkf ?nke))
              (not (= ?nkf ?nkd))
              )
            (not (= ?nke ?nkd))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nkg Real)
      (declare-const ?nkh Real)
      (declare-const ?nki Real)
      (assert
        (or (or (= ?nki ?nkh)
            (= ?nki ?nkg)
            )
          (= ?nkh ?nkg)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nkj Real)
      (declare-const ?nkk Real)
      (declare-const ?nkl Real)
      (declare-const ?nkm Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?nkk ?nkj))
                  (not (= ?nkk ?asi))
                  )
                (not (= ?nkj ?asi))
                )
              (or (or (= ?nkm ?nkl)
                  (= ?nkm ?asi)
                  )
                (= ?nkl ?asi)
                )
              )
            (and (or (or (= ?nkk ?nkj)
                  (= ?nkk ?asi)
                  )
                (= ?nkj ?asi)
                )
              (and (and (not (= ?nkm ?nkl))
                  (not (= ?nkm ?asi))
                  )
                (not (= ?nkl ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nkn Real)
      (declare-const ?nko Real)
      (declare-const ?nkp Real)
      (declare-const ?nkq Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?nko ?nkn))
                  (not (= ?nko ?fkf))
                  )
                (not (= ?nkn ?fkf))
                )
              (or (or (= ?nkq ?nkp)
                  (= ?nkq ?fkf)
                  )
                (= ?nkp ?fkf)
                )
              )
            (and (or (or (= ?nko ?nkn)
                  (= ?nko ?fkf)
                  )
                (= ?nkn ?fkf)
                )
              (and (and (not (= ?nkq ?nkp))
                  (not (= ?nkq ?fkf))
                  )
                (not (= ?nkp ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nkr Real)
      (declare-const ?nks Real)
      (declare-const ?nkt Real)
      (declare-const ?nku Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?nks ?nkr))
                  (not (= ?nks ?mzs))
                  )
                (not (= ?nkr ?mzs))
                )
              (or (or (= ?nku ?nkt)
                  (= ?nku ?mzs)
                  )
                (= ?nkt ?mzs)
                )
              )
            (and (or (or (= ?nks ?nkr)
                  (= ?nks ?mzs)
                  )
                (= ?nkr ?mzs)
                )
              (and (and (not (= ?nku ?nkt))
                  (not (= ?nku ?mzs))
                  )
                (not (= ?nkt ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?nkv Real)
    (declare-const ?nkw Real)
    (declare-const ?nkx Real)
    (declare-const ?nky Real)
    (declare-const ?nkz Real)
    (declare-const ?nla Real)
    (push 1)
      (declare-const ?nlb Real)
      (declare-const ?nlc Real)
      (declare-const ?nld Real)
      (assert
        (or (or (= ?nld ?nlc)
            (= ?nld ?nlb)
            )
          (= ?nlc ?nlb)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nle Real)
      (declare-const ?nlf Real)
      (declare-const ?nlg Real)
      (declare-const ?nlh Real)
      (assert
        (or (or (= ?nlh ?nlg)
            (= ?nlh ?nlf)
            )
          (= ?nlg ?nlf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nli Real)
      (declare-const ?nlj Real)
      (declare-const ?nlk Real)
      (declare-const ?nll Real)
      (declare-const ?nlm Real)
      (assert
        (or (or (= ?nlm ?nll)
            (= ?nlm ?nlk)
            )
          (= ?nll ?nlk)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nln Real)
      (declare-const ?nlo Real)
      (declare-const ?nlp Real)
      (declare-const ?nlq Real)
      (declare-const ?nlr Real)
      (declare-const ?nls Real)
      (assert
        (and (and (and (not (= ?nlp ?nlo))
              (not (= ?nlp ?nln))
              )
            (not (= ?nlo ?nln))
            )
          (or (or (= ?nls ?nlr)
              (= ?nls ?nlq)
              )
            (= ?nlr ?nlq)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nlt Real)
      (declare-const ?nlu Real)
      (declare-const ?nlv Real)
      (assert
        (or (or (= ?nlv ?nlu)
            (= ?nlv ?nlt)
            )
          (= ?nlu ?nlt)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nlw Real)
      (declare-const ?nlx Real)
      (declare-const ?nly Real)
      (assert
        (or (or (= ?nly ?nlx)
            (= ?nly ?nlw)
            )
          (= ?nlx ?nlw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nlz Real)
      (declare-const ?nma Real)
      (declare-const ?nmb Real)
      (declare-const ?nmc Real)
      (assert
        (or (or (= ?nmb ?nma)
            (= ?nmb ?nlz)
            )
          (= ?nma ?nlz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nmd Real)
      (declare-const ?nme Real)
      (declare-const ?nmf Real)
      (declare-const ?nmg Real)
      (declare-const ?nmh Real)
      (assert
        (or (or (= ?nmf ?nme)
            (= ?nmf ?nmd)
            )
          (= ?nme ?nmd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nmi Real)
      (declare-const ?nmj Real)
      (declare-const ?nmk Real)
      (declare-const ?nml Real)
      (declare-const ?nmm Real)
      (declare-const ?nmn Real)
      (assert
        (and (or (or (= ?nmk ?nmj)
              (= ?nmk ?nmi)
              )
            (= ?nmj ?nmi)
            )
          (and (and (not (= ?nmn ?nmm))
              (not (= ?nmn ?nml))
              )
            (not (= ?nmm ?nml))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nmo Real)
      (declare-const ?nmp Real)
      (declare-const ?nmq Real)
      (assert
        (or (or (= ?nmq ?nmp)
            (= ?nmq ?nmo)
            )
          (= ?nmp ?nmo)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nmr Real)
      (declare-const ?nms Real)
      (declare-const ?nmt Real)
      (declare-const ?nmu Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?nms ?nmr))
                  (not (= ?nms ?asi))
                  )
                (not (= ?nmr ?asi))
                )
              (or (or (= ?nmu ?nmt)
                  (= ?nmu ?asi)
                  )
                (= ?nmt ?asi)
                )
              )
            (and (or (or (= ?nms ?nmr)
                  (= ?nms ?asi)
                  )
                (= ?nmr ?asi)
                )
              (and (and (not (= ?nmu ?nmt))
                  (not (= ?nmu ?asi))
                  )
                (not (= ?nmt ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nmv Real)
      (declare-const ?nmw Real)
      (declare-const ?nmx Real)
      (declare-const ?nmy Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?nmw ?nmv))
                  (not (= ?nmw ?fkf))
                  )
                (not (= ?nmv ?fkf))
                )
              (or (or (= ?nmy ?nmx)
                  (= ?nmy ?fkf)
                  )
                (= ?nmx ?fkf)
                )
              )
            (and (or (or (= ?nmw ?nmv)
                  (= ?nmw ?fkf)
                  )
                (= ?nmv ?fkf)
                )
              (and (and (not (= ?nmy ?nmx))
                  (not (= ?nmy ?fkf))
                  )
                (not (= ?nmx ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nmz Real)
      (declare-const ?nna Real)
      (declare-const ?nnb Real)
      (declare-const ?nnc Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?nna ?nmz))
                  (not (= ?nna ?mzs))
                  )
                (not (= ?nmz ?mzs))
                )
              (or (or (= ?nnc ?nnb)
                  (= ?nnc ?mzs)
                  )
                (= ?nnb ?mzs)
                )
              )
            (and (or (or (= ?nna ?nmz)
                  (= ?nna ?mzs)
                  )
                (= ?nmz ?mzs)
                )
              (and (and (not (= ?nnc ?nnb))
                  (not (= ?nnc ?mzs))
                  )
                (not (= ?nnb ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (= ?nkx ?nkw)
            (= ?nkx ?nkv)
            )
          (= ?nkw ?nkv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?nnd Real)
    (declare-const ?nne Real)
    (declare-const ?nnf Real)
    (declare-const ?nng Real)
    (declare-const ?nnh Real)
    (declare-const ?nni Real)
    (push 1)
      (declare-const ?nnj Real)
      (declare-const ?nnk Real)
      (declare-const ?nnl Real)
      (assert
        (or (or (= ?nnl ?nnk)
            (= ?nnl ?nnj)
            )
          (= ?nnk ?nnj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nnm Real)
      (declare-const ?nnn Real)
      (declare-const ?nno Real)
      (declare-const ?nnp Real)
      (assert
        (or (or (= ?nnp ?nno)
            (= ?nnp ?nnn)
            )
          (= ?nno ?nnn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nnq Real)
      (declare-const ?nnr Real)
      (declare-const ?nns Real)
      (declare-const ?nnt Real)
      (declare-const ?nnu Real)
      (assert
        (or (or (= ?nnu ?nnt)
            (= ?nnu ?nns)
            )
          (= ?nnt ?nns)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nnv Real)
      (declare-const ?nnw Real)
      (declare-const ?nnx Real)
      (declare-const ?nny Real)
      (declare-const ?nnz Real)
      (declare-const ?noa Real)
      (assert
        (and (and (and (not (= ?nnx ?nnw))
              (not (= ?nnx ?nnv))
              )
            (not (= ?nnw ?nnv))
            )
          (or (or (= ?noa ?nnz)
              (= ?noa ?nny)
              )
            (= ?nnz ?nny)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nob Real)
      (declare-const ?noc Real)
      (declare-const ?nod Real)
      (assert
        (or (or (= ?nod ?noc)
            (= ?nod ?nob)
            )
          (= ?noc ?nob)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?noe Real)
      (declare-const ?nof Real)
      (declare-const ?nog Real)
      (assert
        (or (or (= ?nog ?nof)
            (= ?nog ?noe)
            )
          (= ?nof ?noe)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?noh Real)
      (declare-const ?noi Real)
      (declare-const ?noj Real)
      (declare-const ?nok Real)
      (assert
        (or (or (= ?noj ?noi)
            (= ?noj ?noh)
            )
          (= ?noi ?noh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nol Real)
      (declare-const ?nom Real)
      (declare-const ?non Real)
      (declare-const ?noo Real)
      (declare-const ?nop Real)
      (assert
        (or (or (= ?non ?nom)
            (= ?non ?nol)
            )
          (= ?nom ?nol)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?noq Real)
      (declare-const ?nor Real)
      (declare-const ?nos Real)
      (declare-const ?not Real)
      (declare-const ?nou Real)
      (declare-const ?nov Real)
      (assert
        (and (or (or (= ?nos ?nor)
              (= ?nos ?noq)
              )
            (= ?nor ?noq)
            )
          (and (and (not (= ?nov ?nou))
              (not (= ?nov ?not))
              )
            (not (= ?nou ?not))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?now Real)
      (declare-const ?nox Real)
      (declare-const ?noy Real)
      (assert
        (or (or (= ?noy ?nox)
            (= ?noy ?now)
            )
          (= ?nox ?now)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?noz Real)
      (declare-const ?npa Real)
      (declare-const ?npb Real)
      (declare-const ?npc Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?npa ?noz))
                  (not (= ?npa ?asi))
                  )
                (not (= ?noz ?asi))
                )
              (or (or (= ?npc ?npb)
                  (= ?npc ?asi)
                  )
                (= ?npb ?asi)
                )
              )
            (and (or (or (= ?npa ?noz)
                  (= ?npa ?asi)
                  )
                (= ?noz ?asi)
                )
              (and (and (not (= ?npc ?npb))
                  (not (= ?npc ?asi))
                  )
                (not (= ?npb ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?npd Real)
      (declare-const ?npe Real)
      (declare-const ?npf Real)
      (declare-const ?npg Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?npe ?npd))
                  (not (= ?npe ?fkf))
                  )
                (not (= ?npd ?fkf))
                )
              (or (or (= ?npg ?npf)
                  (= ?npg ?fkf)
                  )
                (= ?npf ?fkf)
                )
              )
            (and (or (or (= ?npe ?npd)
                  (= ?npe ?fkf)
                  )
                (= ?npd ?fkf)
                )
              (and (and (not (= ?npg ?npf))
                  (not (= ?npg ?fkf))
                  )
                (not (= ?npf ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nph Real)
      (declare-const ?npi Real)
      (declare-const ?npj Real)
      (declare-const ?npk Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?npi ?nph))
                  (not (= ?npi ?mzs))
                  )
                (not (= ?nph ?mzs))
                )
              (or (or (= ?npk ?npj)
                  (= ?npk ?mzs)
                  )
                (= ?npj ?mzs)
                )
              )
            (and (or (or (= ?npi ?nph)
                  (= ?npi ?mzs)
                  )
                (= ?nph ?mzs)
                )
              (and (and (not (= ?npk ?npj))
                  (not (= ?npk ?mzs))
                  )
                (not (= ?npj ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?npl Real)
    (declare-const ?npm Real)
    (declare-const ?npn Real)
    (push 1)
      (declare-const ?npo Real)
      (declare-const ?npp Real)
      (declare-const ?npq Real)
      (assert
        (or (or (= ?npq ?npp)
            (= ?npq ?npo)
            )
          (= ?npp ?npo)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?npr Real)
      (declare-const ?nps Real)
      (declare-const ?npt Real)
      (declare-const ?npu Real)
      (assert
        (or (or (= ?npu ?npt)
            (= ?npu ?nps)
            )
          (= ?npt ?nps)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?npv Real)
      (declare-const ?npw Real)
      (declare-const ?npx Real)
      (declare-const ?npy Real)
      (declare-const ?npz Real)
      (assert
        (or (or (= ?npz ?npy)
            (= ?npz ?npx)
            )
          (= ?npy ?npx)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nqa Real)
      (declare-const ?nqb Real)
      (declare-const ?nqc Real)
      (declare-const ?nqd Real)
      (declare-const ?nqe Real)
      (declare-const ?nqf Real)
      (assert
        (and (and (and (not (= ?nqc ?nqb))
              (not (= ?nqc ?nqa))
              )
            (not (= ?nqb ?nqa))
            )
          (or (or (= ?nqf ?nqe)
              (= ?nqf ?nqd)
              )
            (= ?nqe ?nqd)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nqg Real)
      (declare-const ?nqh Real)
      (declare-const ?nqi Real)
      (assert
        (or (or (= ?nqi ?nqh)
            (= ?nqi ?nqg)
            )
          (= ?nqh ?nqg)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nqj Real)
      (declare-const ?nqk Real)
      (declare-const ?nql Real)
      (assert
        (or (or (= ?nql ?nqk)
            (= ?nql ?nqj)
            )
          (= ?nqk ?nqj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nqm Real)
      (declare-const ?nqn Real)
      (declare-const ?nqo Real)
      (declare-const ?nqp Real)
      (assert
        (or (or (= ?nqo ?nqn)
            (= ?nqo ?nqm)
            )
          (= ?nqn ?nqm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nqq Real)
      (declare-const ?nqr Real)
      (declare-const ?nqs Real)
      (declare-const ?nqt Real)
      (declare-const ?nqu Real)
      (assert
        (or (or (= ?nqs ?nqr)
            (= ?nqs ?nqq)
            )
          (= ?nqr ?nqq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nqv Real)
      (declare-const ?nqw Real)
      (declare-const ?nqx Real)
      (declare-const ?nqy Real)
      (declare-const ?nqz Real)
      (declare-const ?nra Real)
      (assert
        (and (or (or (= ?nqx ?nqw)
              (= ?nqx ?nqv)
              )
            (= ?nqw ?nqv)
            )
          (and (and (not (= ?nra ?nqz))
              (not (= ?nra ?nqy))
              )
            (not (= ?nqz ?nqy))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nrb Real)
      (declare-const ?nrc Real)
      (declare-const ?nrd Real)
      (assert
        (or (or (= ?nrd ?nrc)
            (= ?nrd ?nrb)
            )
          (= ?nrc ?nrb)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nre Real)
      (declare-const ?nrf Real)
      (declare-const ?nrg Real)
      (declare-const ?nrh Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?nrf ?nre))
                  (not (= ?nrf ?asi))
                  )
                (not (= ?nre ?asi))
                )
              (or (or (= ?nrh ?nrg)
                  (= ?nrh ?asi)
                  )
                (= ?nrg ?asi)
                )
              )
            (and (or (or (= ?nrf ?nre)
                  (= ?nrf ?asi)
                  )
                (= ?nre ?asi)
                )
              (and (and (not (= ?nrh ?nrg))
                  (not (= ?nrh ?asi))
                  )
                (not (= ?nrg ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nri Real)
      (declare-const ?nrj Real)
      (declare-const ?nrk Real)
      (declare-const ?nrl Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?nrj ?nri))
                  (not (= ?nrj ?fkf))
                  )
                (not (= ?nri ?fkf))
                )
              (or (or (= ?nrl ?nrk)
                  (= ?nrl ?fkf)
                  )
                (= ?nrk ?fkf)
                )
              )
            (and (or (or (= ?nrj ?nri)
                  (= ?nrj ?fkf)
                  )
                (= ?nri ?fkf)
                )
              (and (and (not (= ?nrl ?nrk))
                  (not (= ?nrl ?fkf))
                  )
                (not (= ?nrk ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nrm Real)
      (declare-const ?nrn Real)
      (declare-const ?nro Real)
      (declare-const ?nrp Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?nrn ?nrm))
                  (not (= ?nrn ?mzs))
                  )
                (not (= ?nrm ?mzs))
                )
              (or (or (= ?nrp ?nro)
                  (= ?nrp ?mzs)
                  )
                (= ?nro ?mzs)
                )
              )
            (and (or (or (= ?nrn ?nrm)
                  (= ?nrn ?mzs)
                  )
                (= ?nrm ?mzs)
                )
              (and (and (not (= ?nrp ?nro))
                  (not (= ?nrp ?mzs))
                  )
                (not (= ?nro ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?nrq Real)
    (push 1)
      (declare-const ?nrr Real)
      (declare-const ?nrs Real)
      (declare-const ?nrt Real)
      (assert
        (or (or (= ?nrt ?nrs)
            (= ?nrt ?nrr)
            )
          (= ?nrs ?nrr)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nru Real)
      (declare-const ?nrv Real)
      (declare-const ?nrw Real)
      (declare-const ?nrx Real)
      (assert
        (or (or (= ?nrx ?nrw)
            (= ?nrx ?nrv)
            )
          (= ?nrw ?nrv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nry Real)
      (declare-const ?nrz Real)
      (declare-const ?nsa Real)
      (declare-const ?nsb Real)
      (declare-const ?nsc Real)
      (assert
        (or (or (= ?nsc ?nsb)
            (= ?nsc ?nsa)
            )
          (= ?nsb ?nsa)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nsd Real)
      (declare-const ?nse Real)
      (declare-const ?nsf Real)
      (declare-const ?nsg Real)
      (declare-const ?nsh Real)
      (declare-const ?nsi Real)
      (assert
        (and (and (and (not (= ?nsf ?nse))
              (not (= ?nsf ?nsd))
              )
            (not (= ?nse ?nsd))
            )
          (or (or (= ?nsi ?nsh)
              (= ?nsi ?nsg)
              )
            (= ?nsh ?nsg)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nsj Real)
      (declare-const ?nsk Real)
      (declare-const ?nsl Real)
      (assert
        (or (or (= ?nsl ?nsk)
            (= ?nsl ?nsj)
            )
          (= ?nsk ?nsj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nsm Real)
      (declare-const ?nsn Real)
      (declare-const ?nso Real)
      (assert
        (or (or (= ?nso ?nsn)
            (= ?nso ?nsm)
            )
          (= ?nsn ?nsm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nsp Real)
      (declare-const ?nsq Real)
      (declare-const ?nsr Real)
      (declare-const ?nss Real)
      (assert
        (or (or (= ?nsr ?nsq)
            (= ?nsr ?nsp)
            )
          (= ?nsq ?nsp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nst Real)
      (declare-const ?nsu Real)
      (declare-const ?nsv Real)
      (declare-const ?nsw Real)
      (declare-const ?nsx Real)
      (assert
        (or (or (= ?nsv ?nsu)
            (= ?nsv ?nst)
            )
          (= ?nsu ?nst)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nsy Real)
      (declare-const ?nsz Real)
      (declare-const ?nta Real)
      (declare-const ?ntb Real)
      (declare-const ?ntc Real)
      (declare-const ?ntd Real)
      (assert
        (and (or (or (= ?nta ?nsz)
              (= ?nta ?nsy)
              )
            (= ?nsz ?nsy)
            )
          (and (and (not (= ?ntd ?ntc))
              (not (= ?ntd ?ntb))
              )
            (not (= ?ntc ?ntb))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nte Real)
      (declare-const ?ntf Real)
      (declare-const ?ntg Real)
      (assert
        (or (or (= ?ntg ?ntf)
            (= ?ntg ?nte)
            )
          (= ?ntf ?nte)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nth Real)
      (declare-const ?nti Real)
      (declare-const ?ntj Real)
      (declare-const ?ntk Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?nti ?nth))
                  (not (= ?nti ?asi))
                  )
                (not (= ?nth ?asi))
                )
              (or (or (= ?ntk ?ntj)
                  (= ?ntk ?asi)
                  )
                (= ?ntj ?asi)
                )
              )
            (and (or (or (= ?nti ?nth)
                  (= ?nti ?asi)
                  )
                (= ?nth ?asi)
                )
              (and (and (not (= ?ntk ?ntj))
                  (not (= ?ntk ?asi))
                  )
                (not (= ?ntj ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ntl Real)
      (declare-const ?ntm Real)
      (declare-const ?ntn Real)
      (declare-const ?nto Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?ntm ?ntl))
                  (not (= ?ntm ?fkf))
                  )
                (not (= ?ntl ?fkf))
                )
              (or (or (= ?nto ?ntn)
                  (= ?nto ?fkf)
                  )
                (= ?ntn ?fkf)
                )
              )
            (and (or (or (= ?ntm ?ntl)
                  (= ?ntm ?fkf)
                  )
                (= ?ntl ?fkf)
                )
              (and (and (not (= ?nto ?ntn))
                  (not (= ?nto ?fkf))
                  )
                (not (= ?ntn ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ntp Real)
      (declare-const ?ntq Real)
      (declare-const ?ntr Real)
      (declare-const ?nts Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?ntq ?ntp))
                  (not (= ?ntq ?mzs))
                  )
                (not (= ?ntp ?mzs))
                )
              (or (or (= ?nts ?ntr)
                  (= ?nts ?mzs)
                  )
                (= ?ntr ?mzs)
                )
              )
            (and (or (or (= ?ntq ?ntp)
                  (= ?ntq ?mzs)
                  )
                (= ?ntp ?mzs)
                )
              (and (and (not (= ?nts ?ntr))
                  (not (= ?nts ?mzs))
                  )
                (not (= ?ntr ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?ntt Real)
    (declare-const ?ntu Real)
    (push 1)
      (declare-const ?ntv Real)
      (declare-const ?ntw Real)
      (declare-const ?ntx Real)
      (assert
        (or (or (= ?ntx ?ntw)
            (= ?ntx ?ntv)
            )
          (= ?ntw ?ntv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nty Real)
      (declare-const ?ntz Real)
      (declare-const ?nua Real)
      (declare-const ?nub Real)
      (assert
        (or (or (= ?nub ?nua)
            (= ?nub ?ntz)
            )
          (= ?nua ?ntz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nuc Real)
      (declare-const ?nud Real)
      (declare-const ?nue Real)
      (declare-const ?nuf Real)
      (declare-const ?nug Real)
      (assert
        (or (or (= ?nug ?nuf)
            (= ?nug ?nue)
            )
          (= ?nuf ?nue)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nuh Real)
      (declare-const ?nui Real)
      (declare-const ?nuj Real)
      (declare-const ?nuk Real)
      (declare-const ?nul Real)
      (declare-const ?num Real)
      (assert
        (and (and (and (not (= ?nuj ?nui))
              (not (= ?nuj ?nuh))
              )
            (not (= ?nui ?nuh))
            )
          (or (or (= ?num ?nul)
              (= ?num ?nuk)
              )
            (= ?nul ?nuk)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nun Real)
      (declare-const ?nuo Real)
      (declare-const ?nup Real)
      (assert
        (or (or (= ?nup ?nuo)
            (= ?nup ?nun)
            )
          (= ?nuo ?nun)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nuq Real)
      (declare-const ?nur Real)
      (declare-const ?nus Real)
      (assert
        (or (or (= ?nus ?nur)
            (= ?nus ?nuq)
            )
          (= ?nur ?nuq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nut Real)
      (declare-const ?nuu Real)
      (declare-const ?nuv Real)
      (declare-const ?nuw Real)
      (assert
        (or (or (= ?nuv ?nuu)
            (= ?nuv ?nut)
            )
          (= ?nuu ?nut)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nux Real)
      (declare-const ?nuy Real)
      (declare-const ?nuz Real)
      (declare-const ?nva Real)
      (declare-const ?nvb Real)
      (assert
        (or (or (= ?nuz ?nuy)
            (= ?nuz ?nux)
            )
          (= ?nuy ?nux)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nvc Real)
      (declare-const ?nvd Real)
      (declare-const ?nve Real)
      (declare-const ?nvf Real)
      (declare-const ?nvg Real)
      (declare-const ?nvh Real)
      (assert
        (and (or (or (= ?nve ?nvd)
              (= ?nve ?nvc)
              )
            (= ?nvd ?nvc)
            )
          (and (and (not (= ?nvh ?nvg))
              (not (= ?nvh ?nvf))
              )
            (not (= ?nvg ?nvf))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nvi Real)
      (declare-const ?nvj Real)
      (declare-const ?nvk Real)
      (assert
        (or (or (= ?nvk ?nvj)
            (= ?nvk ?nvi)
            )
          (= ?nvj ?nvi)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nvl Real)
      (declare-const ?nvm Real)
      (declare-const ?nvn Real)
      (declare-const ?nvo Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?nvm ?nvl))
                  (not (= ?nvm ?asi))
                  )
                (not (= ?nvl ?asi))
                )
              (or (or (= ?nvo ?nvn)
                  (= ?nvo ?asi)
                  )
                (= ?nvn ?asi)
                )
              )
            (and (or (or (= ?nvm ?nvl)
                  (= ?nvm ?asi)
                  )
                (= ?nvl ?asi)
                )
              (and (and (not (= ?nvo ?nvn))
                  (not (= ?nvo ?asi))
                  )
                (not (= ?nvn ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nvp Real)
      (declare-const ?nvq Real)
      (declare-const ?nvr Real)
      (declare-const ?nvs Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?nvq ?nvp))
                  (not (= ?nvq ?fkf))
                  )
                (not (= ?nvp ?fkf))
                )
              (or (or (= ?nvs ?nvr)
                  (= ?nvs ?fkf)
                  )
                (= ?nvr ?fkf)
                )
              )
            (and (or (or (= ?nvq ?nvp)
                  (= ?nvq ?fkf)
                  )
                (= ?nvp ?fkf)
                )
              (and (and (not (= ?nvs ?nvr))
                  (not (= ?nvs ?fkf))
                  )
                (not (= ?nvr ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nvt Real)
      (declare-const ?nvu Real)
      (declare-const ?nvv Real)
      (declare-const ?nvw Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?nvu ?nvt))
                  (not (= ?nvu ?mzs))
                  )
                (not (= ?nvt ?mzs))
                )
              (or (or (= ?nvw ?nvv)
                  (= ?nvw ?mzs)
                  )
                (= ?nvv ?mzs)
                )
              )
            (and (or (or (= ?nvu ?nvt)
                  (= ?nvu ?mzs)
                  )
                (= ?nvt ?mzs)
                )
              (and (and (not (= ?nvw ?nvv))
                  (not (= ?nvw ?mzs))
                  )
                (not (= ?nvv ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?nvx Real)
    (declare-const ?nvy Real)
    (declare-const ?nvz Real)
    (push 1)
      (declare-const ?nwa Real)
      (declare-const ?nwb Real)
      (declare-const ?nwc Real)
      (assert
        (or (or (= ?nwc ?nwb)
            (= ?nwc ?nwa)
            )
          (= ?nwb ?nwa)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nwd Real)
      (declare-const ?nwe Real)
      (declare-const ?nwf Real)
      (declare-const ?nwg Real)
      (assert
        (or (or (= ?nwg ?nwf)
            (= ?nwg ?nwe)
            )
          (= ?nwf ?nwe)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nwh Real)
      (declare-const ?nwi Real)
      (declare-const ?nwj Real)
      (declare-const ?nwk Real)
      (declare-const ?nwl Real)
      (assert
        (or (or (= ?nwl ?nwk)
            (= ?nwl ?nwj)
            )
          (= ?nwk ?nwj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nwm Real)
      (declare-const ?nwn Real)
      (declare-const ?nwo Real)
      (declare-const ?nwp Real)
      (declare-const ?nwq Real)
      (declare-const ?nwr Real)
      (assert
        (and (and (and (not (= ?nwo ?nwn))
              (not (= ?nwo ?nwm))
              )
            (not (= ?nwn ?nwm))
            )
          (or (or (= ?nwr ?nwq)
              (= ?nwr ?nwp)
              )
            (= ?nwq ?nwp)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nws Real)
      (declare-const ?nwt Real)
      (declare-const ?nwu Real)
      (assert
        (or (or (= ?nwu ?nwt)
            (= ?nwu ?nws)
            )
          (= ?nwt ?nws)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nwv Real)
      (declare-const ?nww Real)
      (declare-const ?nwx Real)
      (assert
        (or (or (= ?nwx ?nww)
            (= ?nwx ?nwv)
            )
          (= ?nww ?nwv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nwy Real)
      (declare-const ?nwz Real)
      (declare-const ?nxa Real)
      (declare-const ?nxb Real)
      (assert
        (or (or (= ?nxa ?nwz)
            (= ?nxa ?nwy)
            )
          (= ?nwz ?nwy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nxc Real)
      (declare-const ?nxd Real)
      (declare-const ?nxe Real)
      (declare-const ?nxf Real)
      (declare-const ?nxg Real)
      (assert
        (or (or (= ?nxe ?nxd)
            (= ?nxe ?nxc)
            )
          (= ?nxd ?nxc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nxh Real)
      (declare-const ?nxi Real)
      (declare-const ?nxj Real)
      (declare-const ?nxk Real)
      (declare-const ?nxl Real)
      (declare-const ?nxm Real)
      (assert
        (and (or (or (= ?nxj ?nxi)
              (= ?nxj ?nxh)
              )
            (= ?nxi ?nxh)
            )
          (and (and (not (= ?nxm ?nxl))
              (not (= ?nxm ?nxk))
              )
            (not (= ?nxl ?nxk))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nxn Real)
      (declare-const ?nxo Real)
      (declare-const ?nxp Real)
      (assert
        (or (or (= ?nxp ?nxo)
            (= ?nxp ?nxn)
            )
          (= ?nxo ?nxn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nxq Real)
      (declare-const ?nxr Real)
      (declare-const ?nxs Real)
      (declare-const ?nxt Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?nxr ?nxq))
                  (not (= ?nxr ?asi))
                  )
                (not (= ?nxq ?asi))
                )
              (or (or (= ?nxt ?nxs)
                  (= ?nxt ?asi)
                  )
                (= ?nxs ?asi)
                )
              )
            (and (or (or (= ?nxr ?nxq)
                  (= ?nxr ?asi)
                  )
                (= ?nxq ?asi)
                )
              (and (and (not (= ?nxt ?nxs))
                  (not (= ?nxt ?asi))
                  )
                (not (= ?nxs ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nxu Real)
      (declare-const ?nxv Real)
      (declare-const ?nxw Real)
      (declare-const ?nxx Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?nxv ?nxu))
                  (not (= ?nxv ?fkf))
                  )
                (not (= ?nxu ?fkf))
                )
              (or (or (= ?nxx ?nxw)
                  (= ?nxx ?fkf)
                  )
                (= ?nxw ?fkf)
                )
              )
            (and (or (or (= ?nxv ?nxu)
                  (= ?nxv ?fkf)
                  )
                (= ?nxu ?fkf)
                )
              (and (and (not (= ?nxx ?nxw))
                  (not (= ?nxx ?fkf))
                  )
                (not (= ?nxw ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nxy Real)
      (declare-const ?nxz Real)
      (declare-const ?nya Real)
      (declare-const ?nyb Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?nxz ?nxy))
                  (not (= ?nxz ?mzs))
                  )
                (not (= ?nxy ?mzs))
                )
              (or (or (= ?nyb ?nya)
                  (= ?nyb ?mzs)
                  )
                (= ?nya ?mzs)
                )
              )
            (and (or (or (= ?nxz ?nxy)
                  (= ?nxz ?mzs)
                  )
                (= ?nxy ?mzs)
                )
              (and (and (not (= ?nyb ?nya))
                  (not (= ?nyb ?mzs))
                  )
                (not (= ?nya ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (= ?nvz ?nvy)
            (= ?nvz ?nvx)
            )
          (= ?nvy ?nvx)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?nyc Real)
    (declare-const ?nyd Real)
    (declare-const ?nye Real)
    (push 1)
      (declare-const ?nyf Real)
      (declare-const ?nyg Real)
      (declare-const ?nyh Real)
      (assert
        (or (or (= ?nyh ?nyg)
            (= ?nyh ?nyf)
            )
          (= ?nyg ?nyf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nyi Real)
      (declare-const ?nyj Real)
      (declare-const ?nyk Real)
      (declare-const ?nyl Real)
      (assert
        (or (or (= ?nyl ?nyk)
            (= ?nyl ?nyj)
            )
          (= ?nyk ?nyj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nym Real)
      (declare-const ?nyn Real)
      (declare-const ?nyo Real)
      (declare-const ?nyp Real)
      (declare-const ?nyq Real)
      (assert
        (or (or (= ?nyq ?nyp)
            (= ?nyq ?nyo)
            )
          (= ?nyp ?nyo)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nyr Real)
      (declare-const ?nys Real)
      (declare-const ?nyt Real)
      (declare-const ?nyu Real)
      (declare-const ?nyv Real)
      (declare-const ?nyw Real)
      (assert
        (and (and (and (not (= ?nyt ?nys))
              (not (= ?nyt ?nyr))
              )
            (not (= ?nys ?nyr))
            )
          (or (or (= ?nyw ?nyv)
              (= ?nyw ?nyu)
              )
            (= ?nyv ?nyu)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nyx Real)
      (declare-const ?nyy Real)
      (declare-const ?nyz Real)
      (assert
        (or (or (= ?nyz ?nyy)
            (= ?nyz ?nyx)
            )
          (= ?nyy ?nyx)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nza Real)
      (declare-const ?nzb Real)
      (declare-const ?nzc Real)
      (assert
        (or (or (= ?nzc ?nzb)
            (= ?nzc ?nza)
            )
          (= ?nzb ?nza)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nzd Real)
      (declare-const ?nze Real)
      (declare-const ?nzf Real)
      (declare-const ?nzg Real)
      (assert
        (or (or (= ?nzf ?nze)
            (= ?nzf ?nzd)
            )
          (= ?nze ?nzd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nzh Real)
      (declare-const ?nzi Real)
      (declare-const ?nzj Real)
      (declare-const ?nzk Real)
      (declare-const ?nzl Real)
      (assert
        (or (or (= ?nzj ?nzi)
            (= ?nzj ?nzh)
            )
          (= ?nzi ?nzh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nzm Real)
      (declare-const ?nzn Real)
      (declare-const ?nzo Real)
      (declare-const ?nzp Real)
      (declare-const ?nzq Real)
      (declare-const ?nzr Real)
      (assert
        (and (or (or (= ?nzo ?nzn)
              (= ?nzo ?nzm)
              )
            (= ?nzn ?nzm)
            )
          (and (and (not (= ?nzr ?nzq))
              (not (= ?nzr ?nzp))
              )
            (not (= ?nzq ?nzp))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nzs Real)
      (declare-const ?nzt Real)
      (declare-const ?nzu Real)
      (assert
        (or (or (= ?nzu ?nzt)
            (= ?nzu ?nzs)
            )
          (= ?nzt ?nzs)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nzv Real)
      (declare-const ?nzw Real)
      (declare-const ?nzx Real)
      (declare-const ?nzy Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?nzw ?nzv))
                  (not (= ?nzw ?asi))
                  )
                (not (= ?nzv ?asi))
                )
              (or (or (= ?nzy ?nzx)
                  (= ?nzy ?asi)
                  )
                (= ?nzx ?asi)
                )
              )
            (and (or (or (= ?nzw ?nzv)
                  (= ?nzw ?asi)
                  )
                (= ?nzv ?asi)
                )
              (and (and (not (= ?nzy ?nzx))
                  (not (= ?nzy ?asi))
                  )
                (not (= ?nzx ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?nzz Real)
      (declare-const ?oaa Real)
      (declare-const ?oab Real)
      (declare-const ?oac Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?oaa ?nzz))
                  (not (= ?oaa ?fkf))
                  )
                (not (= ?nzz ?fkf))
                )
              (or (or (= ?oac ?oab)
                  (= ?oac ?fkf)
                  )
                (= ?oab ?fkf)
                )
              )
            (and (or (or (= ?oaa ?nzz)
                  (= ?oaa ?fkf)
                  )
                (= ?nzz ?fkf)
                )
              (and (and (not (= ?oac ?oab))
                  (not (= ?oac ?fkf))
                  )
                (not (= ?oab ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?oad Real)
      (declare-const ?oae Real)
      (declare-const ?oaf Real)
      (declare-const ?oag Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?oae ?oad))
                  (not (= ?oae ?mzs))
                  )
                (not (= ?oad ?mzs))
                )
              (or (or (= ?oag ?oaf)
                  (= ?oag ?mzs)
                  )
                (= ?oaf ?mzs)
                )
              )
            (and (or (or (= ?oae ?oad)
                  (= ?oae ?mzs)
                  )
                (= ?oad ?mzs)
                )
              (and (and (not (= ?oag ?oaf))
                  (not (= ?oag ?mzs))
                  )
                (not (= ?oaf ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?oah Real)
      (declare-const ?oai Real)
      (declare-const ?oaj Real)
      (assert
        (or (or (= ?oaj ?oai)
            (= ?oaj ?oah)
            )
          (= ?oai ?oah)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?oak Real)
      (declare-const ?oal Real)
      (declare-const ?oam Real)
      (declare-const ?oan Real)
      (assert
        (or (or (= ?oan ?oam)
            (= ?oan ?oal)
            )
          (= ?oam ?oal)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?oao Real)
      (declare-const ?oap Real)
      (declare-const ?oaq Real)
      (declare-const ?oar Real)
      (declare-const ?oas Real)
      (assert
        (or (or (= ?oas ?oar)
            (= ?oas ?oaq)
            )
          (= ?oar ?oaq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?oat Real)
      (declare-const ?oau Real)
      (declare-const ?oav Real)
      (declare-const ?oaw Real)
      (declare-const ?oax Real)
      (declare-const ?oay Real)
      (assert
        (and (and (and (not (= ?oav ?oau))
              (not (= ?oav ?oat))
              )
            (not (= ?oau ?oat))
            )
          (or (or (= ?oay ?oax)
              (= ?oay ?oaw)
              )
            (= ?oax ?oaw)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?oaz Real)
      (declare-const ?oba Real)
      (declare-const ?obb Real)
      (assert
        (or (or (= ?obb ?oba)
            (= ?obb ?oaz)
            )
          (= ?oba ?oaz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?obc Real)
      (declare-const ?obd Real)
      (declare-const ?obe Real)
      (assert
        (or (or (= ?obe ?obd)
            (= ?obe ?obc)
            )
          (= ?obd ?obc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?obf Real)
      (declare-const ?obg Real)
      (declare-const ?obh Real)
      (declare-const ?obi Real)
      (assert
        (or (or (= ?obh ?obg)
            (= ?obh ?obf)
            )
          (= ?obg ?obf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?obj Real)
      (declare-const ?obk Real)
      (declare-const ?obl Real)
      (declare-const ?obm Real)
      (declare-const ?obn Real)
      (assert
        (or (or (= ?obl ?obk)
            (= ?obl ?obj)
            )
          (= ?obk ?obj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?obo Real)
      (declare-const ?obp Real)
      (declare-const ?obq Real)
      (declare-const ?obr Real)
      (declare-const ?obs Real)
      (declare-const ?obt Real)
      (assert
        (and (or (or (= ?obq ?obp)
              (= ?obq ?obo)
              )
            (= ?obp ?obo)
            )
          (and (and (not (= ?obt ?obs))
              (not (= ?obt ?obr))
              )
            (not (= ?obs ?obr))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?obu Real)
      (declare-const ?obv Real)
      (declare-const ?obw Real)
      (assert
        (or (or (= ?obw ?obv)
            (= ?obw ?obu)
            )
          (= ?obv ?obu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?obx Real)
      (declare-const ?oby Real)
      (declare-const ?obz Real)
      (declare-const ?oca Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?oby ?obx))
                  (not (= ?oby ?asi))
                  )
                (not (= ?obx ?asi))
                )
              (or (or (= ?oca ?obz)
                  (= ?oca ?asi)
                  )
                (= ?obz ?asi)
                )
              )
            (and (or (or (= ?oby ?obx)
                  (= ?oby ?asi)
                  )
                (= ?obx ?asi)
                )
              (and (and (not (= ?oca ?obz))
                  (not (= ?oca ?asi))
                  )
                (not (= ?obz ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ocb Real)
      (declare-const ?occ Real)
      (declare-const ?ocd Real)
      (declare-const ?oce Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?occ ?ocb))
                  (not (= ?occ ?fkf))
                  )
                (not (= ?ocb ?fkf))
                )
              (or (or (= ?oce ?ocd)
                  (= ?oce ?fkf)
                  )
                (= ?ocd ?fkf)
                )
              )
            (and (or (or (= ?occ ?ocb)
                  (= ?occ ?fkf)
                  )
                (= ?ocb ?fkf)
                )
              (and (and (not (= ?oce ?ocd))
                  (not (= ?oce ?fkf))
                  )
                (not (= ?ocd ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ocf Real)
      (declare-const ?ocg Real)
      (declare-const ?och Real)
      (declare-const ?oci Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?ocg ?ocf))
                  (not (= ?ocg ?mzs))
                  )
                (not (= ?ocf ?mzs))
                )
              (or (or (= ?oci ?och)
                  (= ?oci ?mzs)
                  )
                (= ?och ?mzs)
                )
              )
            (and (or (or (= ?ocg ?ocf)
                  (= ?ocg ?mzs)
                  )
                (= ?ocf ?mzs)
                )
              (and (and (not (= ?oci ?och))
                  (not (= ?oci ?mzs))
                  )
                (not (= ?och ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ocj Real)
  (declare-const ?ock Real)
  (declare-const ?ocl Real)
  (assert
    (or (or (= ?ocl ?ock)
        (= ?ocl ?ocj)
        )
      (= ?ock ?ocj)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?ocm Real)
    (declare-const ?ocn Real)
    (declare-const ?oco Real)
    (assert
      (or (or (= ?oco ?ocn)
          (= ?oco ?ocm)
          )
        (= ?ocn ?ocm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ocp Real)
    (declare-const ?ocq Real)
    (declare-const ?ocr Real)
    (declare-const ?ocs Real)
    (assert
      (or (or (= ?ocs ?ocr)
          (= ?ocs ?ocq)
          )
        (= ?ocr ?ocq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oct Real)
    (declare-const ?ocu Real)
    (declare-const ?ocv Real)
    (declare-const ?ocw Real)
    (declare-const ?ocx Real)
    (assert
      (or (or (= ?ocx ?ocw)
          (= ?ocx ?ocv)
          )
        (= ?ocw ?ocv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ocy Real)
    (declare-const ?ocz Real)
    (declare-const ?oda Real)
    (declare-const ?odb Real)
    (declare-const ?odc Real)
    (declare-const ?odd Real)
    (assert
      (and (and (and (not (= ?oda ?ocz))
            (not (= ?oda ?ocy))
            )
          (not (= ?ocz ?ocy))
          )
        (or (or (= ?odd ?odc)
            (= ?odd ?odb)
            )
          (= ?odc ?odb)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ode Real)
    (declare-const ?odf Real)
    (declare-const ?odg Real)
    (assert
      (or (or (= ?odg ?odf)
          (= ?odg ?ode)
          )
        (= ?odf ?ode)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?odh Real)
    (declare-const ?odi Real)
    (declare-const ?odj Real)
    (assert
      (or (or (= ?odj ?odi)
          (= ?odj ?odh)
          )
        (= ?odi ?odh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?odk Real)
    (declare-const ?odl Real)
    (declare-const ?odm Real)
    (declare-const ?odn Real)
    (assert
      (or (or (= ?odm ?odl)
          (= ?odm ?odk)
          )
        (= ?odl ?odk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?odo Real)
    (declare-const ?odp Real)
    (declare-const ?odq Real)
    (declare-const ?odr Real)
    (declare-const ?ods Real)
    (assert
      (or (or (= ?odq ?odp)
          (= ?odq ?odo)
          )
        (= ?odp ?odo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?odt Real)
    (declare-const ?odu Real)
    (declare-const ?odv Real)
    (declare-const ?odw Real)
    (declare-const ?odx Real)
    (declare-const ?ody Real)
    (assert
      (and (or (or (= ?odv ?odu)
            (= ?odv ?odt)
            )
          (= ?odu ?odt)
          )
        (and (and (not (= ?ody ?odx))
            (not (= ?ody ?odw))
            )
          (not (= ?odx ?odw))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?odz Real)
    (declare-const ?oea Real)
    (declare-const ?oeb Real)
    (assert
      (or (or (= ?oeb ?oea)
          (= ?oeb ?odz)
          )
        (= ?oea ?odz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oec Real)
    (declare-const ?oed Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oee Real)
    (declare-const ?oef Real)
    (declare-const ?oeg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oeh Real)
    (declare-const ?oei Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oej Real)
    (declare-const ?oek Real)
    (declare-const ?oel Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oem Real)
    (declare-const ?oen Real)
    (declare-const ?oeo Real)
    (declare-const ?oep Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?oen ?oem))
                (not (= ?oen ?asi))
                )
              (not (= ?oem ?asi))
              )
            (or (or (= ?oep ?oeo)
                (= ?oep ?asi)
                )
              (= ?oeo ?asi)
              )
            )
          (and (or (or (= ?oen ?oem)
                (= ?oen ?asi)
                )
              (= ?oem ?asi)
              )
            (and (and (not (= ?oep ?oeo))
                (not (= ?oep ?asi))
                )
              (not (= ?oeo ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oeq Real)
    (declare-const ?oer Real)
    (declare-const ?oes Real)
    (declare-const ?oet Real)
    (declare-const ?oeu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oev Real)
    (declare-const ?oew Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oex Real)
    (declare-const ?oey Real)
    (declare-const ?oez Real)
    (declare-const ?ofa Real)
    (declare-const ?ofb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ofc Real)
    (declare-const ?ofd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ofe Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?off Real)
    (declare-const ?ofg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ofh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ofi Real)
    (declare-const ?ofj Real)
    (assert
      (not (= ?ofi ?ofj))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ofk Real)
    (declare-const ?ofl Real)
    (declare-const ?ofm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ofn Real)
    (declare-const ?ofo Real)
    (declare-const ?ofp Real)
    (declare-const ?ofq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ofr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ofs Real)
    (declare-const ?oft Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ofu Real)
    (declare-const ?ofv Real)
    (declare-const ?ofw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ofx Real)
    (declare-const ?ofy Real)
    (declare-const ?ofz Real)
    (declare-const ?oga Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ofy ?ofx))
                (not (= ?ofy ?fkf))
                )
              (not (= ?ofx ?fkf))
              )
            (or (or (= ?oga ?ofz)
                (= ?oga ?fkf)
                )
              (= ?ofz ?fkf)
              )
            )
          (and (or (or (= ?ofy ?ofx)
                (= ?ofy ?fkf)
                )
              (= ?ofx ?fkf)
              )
            (and (and (not (= ?oga ?ofz))
                (not (= ?oga ?fkf))
                )
              (not (= ?ofz ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ogb Real)
    (declare-const ?ogc Real)
    (declare-const ?ogd Real)
    (declare-const ?oge Real)
    (declare-const ?ogf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ogg Real)
    (declare-const ?ogh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ogi Real)
    (declare-const ?ogj Real)
    (declare-const ?ogk Real)
    (declare-const ?ogl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ogm Real)
    (declare-const ?ogn Real)
    (declare-const ?ogo Real)
    (declare-const ?ogp Real)
    (declare-const ?ogq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ogr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ogs Real)
    (declare-const ?ogt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ogu Real)
  (declare-const ?ogv Real)
  (declare-const ?ogw Real)
  (declare-const ?ogx Real)
  (assert
    (or (or (= ?ogx ?ogw)
        (= ?ogx ?ogv)
        )
      (= ?ogw ?ogv)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?ogy Real)
    (declare-const ?ogz Real)
    (declare-const ?oha Real)
    (assert
      (or (or (= ?oha ?ogz)
          (= ?oha ?ogy)
          )
        (= ?ogz ?ogy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ohb Real)
    (declare-const ?ohc Real)
    (declare-const ?ohd Real)
    (declare-const ?ohe Real)
    (assert
      (or (or (= ?ohe ?ohd)
          (= ?ohe ?ohc)
          )
        (= ?ohd ?ohc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ohf Real)
    (declare-const ?ohg Real)
    (declare-const ?ohh Real)
    (declare-const ?ohi Real)
    (declare-const ?ohj Real)
    (assert
      (or (or (= ?ohj ?ohi)
          (= ?ohj ?ohh)
          )
        (= ?ohi ?ohh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ohk Real)
    (declare-const ?ohl Real)
    (declare-const ?ohm Real)
    (declare-const ?ohn Real)
    (declare-const ?oho Real)
    (declare-const ?ohp Real)
    (assert
      (and (and (and (not (= ?ohm ?ohl))
            (not (= ?ohm ?ohk))
            )
          (not (= ?ohl ?ohk))
          )
        (or (or (= ?ohp ?oho)
            (= ?ohp ?ohn)
            )
          (= ?oho ?ohn)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ohq Real)
    (declare-const ?ohr Real)
    (declare-const ?ohs Real)
    (assert
      (or (or (= ?ohs ?ohr)
          (= ?ohs ?ohq)
          )
        (= ?ohr ?ohq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oht Real)
    (declare-const ?ohu Real)
    (declare-const ?ohv Real)
    (assert
      (or (or (= ?ohv ?ohu)
          (= ?ohv ?oht)
          )
        (= ?ohu ?oht)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ohw Real)
    (declare-const ?ohx Real)
    (declare-const ?ohy Real)
    (declare-const ?ohz Real)
    (assert
      (or (or (= ?ohy ?ohx)
          (= ?ohy ?ohw)
          )
        (= ?ohx ?ohw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oia Real)
    (declare-const ?oib Real)
    (declare-const ?oic Real)
    (declare-const ?oid Real)
    (declare-const ?oie Real)
    (assert
      (or (or (= ?oic ?oib)
          (= ?oic ?oia)
          )
        (= ?oib ?oia)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oif Real)
    (declare-const ?oig Real)
    (declare-const ?oih Real)
    (declare-const ?oii Real)
    (declare-const ?oij Real)
    (declare-const ?oik Real)
    (assert
      (and (or (or (= ?oih ?oig)
            (= ?oih ?oif)
            )
          (= ?oig ?oif)
          )
        (and (and (not (= ?oik ?oij))
            (not (= ?oik ?oii))
            )
          (not (= ?oij ?oii))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oil Real)
    (declare-const ?oim Real)
    (declare-const ?oin Real)
    (assert
      (or (or (= ?oin ?oim)
          (= ?oin ?oil)
          )
        (= ?oim ?oil)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oio Real)
    (declare-const ?oip Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oiq Real)
    (declare-const ?oir Real)
    (declare-const ?ois Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oit Real)
    (declare-const ?oiu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oiv Real)
    (declare-const ?oiw Real)
    (declare-const ?oix Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oiy Real)
    (declare-const ?oiz Real)
    (declare-const ?oja Real)
    (declare-const ?ojb Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?oiz ?oiy))
                (not (= ?oiz ?asi))
                )
              (not (= ?oiy ?asi))
              )
            (or (or (= ?ojb ?oja)
                (= ?ojb ?asi)
                )
              (= ?oja ?asi)
              )
            )
          (and (or (or (= ?oiz ?oiy)
                (= ?oiz ?asi)
                )
              (= ?oiy ?asi)
              )
            (and (and (not (= ?ojb ?oja))
                (not (= ?ojb ?asi))
                )
              (not (= ?oja ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ojc Real)
    (declare-const ?ojd Real)
    (declare-const ?oje Real)
    (declare-const ?ojf Real)
    (declare-const ?ojg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ojh Real)
    (declare-const ?oji Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ojj Real)
    (declare-const ?ojk Real)
    (declare-const ?ojl Real)
    (declare-const ?ojm Real)
    (declare-const ?ojn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ojo Real)
    (declare-const ?ojp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ojq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ojr Real)
    (declare-const ?ojs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ojt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oju Real)
    (declare-const ?ojv Real)
    (assert
      (not (= ?oju ?ojv))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ojw Real)
    (declare-const ?ojx Real)
    (declare-const ?ojy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ojz Real)
    (declare-const ?oka Real)
    (declare-const ?okb Real)
    (declare-const ?okc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?okd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oke Real)
    (declare-const ?okf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?okg Real)
    (declare-const ?okh Real)
    (declare-const ?oki Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?okj Real)
    (declare-const ?okk Real)
    (declare-const ?okl Real)
    (declare-const ?okm Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?okk ?okj))
                (not (= ?okk ?fkf))
                )
              (not (= ?okj ?fkf))
              )
            (or (or (= ?okm ?okl)
                (= ?okm ?fkf)
                )
              (= ?okl ?fkf)
              )
            )
          (and (or (or (= ?okk ?okj)
                (= ?okk ?fkf)
                )
              (= ?okj ?fkf)
              )
            (and (and (not (= ?okm ?okl))
                (not (= ?okm ?fkf))
                )
              (not (= ?okl ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?okn Real)
    (declare-const ?oko Real)
    (declare-const ?okp Real)
    (declare-const ?okq Real)
    (declare-const ?okr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oks Real)
    (declare-const ?okt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oku Real)
    (declare-const ?okv Real)
    (declare-const ?okw Real)
    (declare-const ?okx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oky Real)
    (declare-const ?okz Real)
    (declare-const ?ola Real)
    (declare-const ?olb Real)
    (declare-const ?olc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?old Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ole Real)
    (declare-const ?olf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?olg Real)
  (declare-const ?olh Real)
  (declare-const ?oli Real)
  (declare-const ?olj Real)
  (declare-const ?olk Real)
  (assert
    (or (or (= ?olk ?olj)
        (= ?olk ?oli)
        )
      (= ?olj ?oli)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?oll Real)
    (declare-const ?olm Real)
    (declare-const ?oln Real)
    (assert
      (or (or (= ?oln ?olm)
          (= ?oln ?oll)
          )
        (= ?olm ?oll)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?olo Real)
    (declare-const ?olp Real)
    (declare-const ?olq Real)
    (declare-const ?olr Real)
    (assert
      (or (or (= ?olr ?olq)
          (= ?olr ?olp)
          )
        (= ?olq ?olp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ols Real)
    (declare-const ?olt Real)
    (declare-const ?olu Real)
    (declare-const ?olv Real)
    (declare-const ?olw Real)
    (assert
      (or (or (= ?olw ?olv)
          (= ?olw ?olu)
          )
        (= ?olv ?olu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?olx Real)
    (declare-const ?oly Real)
    (declare-const ?olz Real)
    (declare-const ?oma Real)
    (declare-const ?omb Real)
    (declare-const ?omc Real)
    (assert
      (and (and (and (not (= ?olz ?oly))
            (not (= ?olz ?olx))
            )
          (not (= ?oly ?olx))
          )
        (or (or (= ?omc ?omb)
            (= ?omc ?oma)
            )
          (= ?omb ?oma)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?omd Real)
    (declare-const ?ome Real)
    (declare-const ?omf Real)
    (assert
      (or (or (= ?omf ?ome)
          (= ?omf ?omd)
          )
        (= ?ome ?omd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?omg Real)
    (declare-const ?omh Real)
    (declare-const ?omi Real)
    (assert
      (or (or (= ?omi ?omh)
          (= ?omi ?omg)
          )
        (= ?omh ?omg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?omj Real)
    (declare-const ?omk Real)
    (declare-const ?oml Real)
    (declare-const ?omm Real)
    (assert
      (or (or (= ?oml ?omk)
          (= ?oml ?omj)
          )
        (= ?omk ?omj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?omn Real)
    (declare-const ?omo Real)
    (declare-const ?omp Real)
    (declare-const ?omq Real)
    (declare-const ?omr Real)
    (assert
      (or (or (= ?omp ?omo)
          (= ?omp ?omn)
          )
        (= ?omo ?omn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oms Real)
    (declare-const ?omt Real)
    (declare-const ?omu Real)
    (declare-const ?omv Real)
    (declare-const ?omw Real)
    (declare-const ?omx Real)
    (assert
      (and (or (or (= ?omu ?omt)
            (= ?omu ?oms)
            )
          (= ?omt ?oms)
          )
        (and (and (not (= ?omx ?omw))
            (not (= ?omx ?omv))
            )
          (not (= ?omw ?omv))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?omy Real)
    (declare-const ?omz Real)
    (declare-const ?ona Real)
    (assert
      (or (or (= ?ona ?omz)
          (= ?ona ?omy)
          )
        (= ?omz ?omy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?onb Real)
    (declare-const ?onc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ond Real)
    (declare-const ?one Real)
    (declare-const ?onf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ong Real)
    (declare-const ?onh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oni Real)
    (declare-const ?onj Real)
    (declare-const ?onk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?onl Real)
    (declare-const ?onm Real)
    (declare-const ?onn Real)
    (declare-const ?ono Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?onm ?onl))
                (not (= ?onm ?asi))
                )
              (not (= ?onl ?asi))
              )
            (or (or (= ?ono ?onn)
                (= ?ono ?asi)
                )
              (= ?onn ?asi)
              )
            )
          (and (or (or (= ?onm ?onl)
                (= ?onm ?asi)
                )
              (= ?onl ?asi)
              )
            (and (and (not (= ?ono ?onn))
                (not (= ?ono ?asi))
                )
              (not (= ?onn ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?onp Real)
    (declare-const ?onq Real)
    (declare-const ?onr Real)
    (declare-const ?ons Real)
    (declare-const ?ont Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?onu Real)
    (declare-const ?onv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?onw Real)
    (declare-const ?onx Real)
    (declare-const ?ony Real)
    (declare-const ?onz Real)
    (declare-const ?ooa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oob Real)
    (declare-const ?ooc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ood Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ooe Real)
    (declare-const ?oof Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oog Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ooh Real)
    (declare-const ?ooi Real)
    (assert
      (not (= ?ooh ?ooi))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ooj Real)
    (declare-const ?ook Real)
    (declare-const ?ool Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oom Real)
    (declare-const ?oon Real)
    (declare-const ?ooo Real)
    (declare-const ?oop Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ooq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oor Real)
    (declare-const ?oos Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oot Real)
    (declare-const ?oou Real)
    (declare-const ?oov Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oow Real)
    (declare-const ?oox Real)
    (declare-const ?ooy Real)
    (declare-const ?ooz Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?oox ?oow))
                (not (= ?oox ?fkf))
                )
              (not (= ?oow ?fkf))
              )
            (or (or (= ?ooz ?ooy)
                (= ?ooz ?fkf)
                )
              (= ?ooy ?fkf)
              )
            )
          (and (or (or (= ?oox ?oow)
                (= ?oox ?fkf)
                )
              (= ?oow ?fkf)
              )
            (and (and (not (= ?ooz ?ooy))
                (not (= ?ooz ?fkf))
                )
              (not (= ?ooy ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?opa Real)
    (declare-const ?opb Real)
    (declare-const ?opc Real)
    (declare-const ?opd Real)
    (declare-const ?ope Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?opf Real)
    (declare-const ?opg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oph Real)
    (declare-const ?opi Real)
    (declare-const ?opj Real)
    (declare-const ?opk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?opl Real)
    (declare-const ?opm Real)
    (declare-const ?opn Real)
    (declare-const ?opo Real)
    (declare-const ?opp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?opq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?opr Real)
    (declare-const ?ops Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?opt Real)
  (declare-const ?opu Real)
  (declare-const ?opv Real)
  (declare-const ?opw Real)
  (declare-const ?opx Real)
  (declare-const ?opy Real)
  (assert
    (and (and (and (not (= ?opv ?opu))
          (not (= ?opv ?opt))
          )
        (not (= ?opu ?opt))
        )
      (or (or (= ?opy ?opx)
          (= ?opy ?opw)
          )
        (= ?opx ?opw)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?opz Real)
    (declare-const ?oqa Real)
    (declare-const ?oqb Real)
    (assert
      (or (or (= ?oqb ?oqa)
          (= ?oqb ?opz)
          )
        (= ?oqa ?opz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oqc Real)
    (declare-const ?oqd Real)
    (declare-const ?oqe Real)
    (declare-const ?oqf Real)
    (assert
      (or (or (= ?oqf ?oqe)
          (= ?oqf ?oqd)
          )
        (= ?oqe ?oqd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oqg Real)
    (declare-const ?oqh Real)
    (declare-const ?oqi Real)
    (declare-const ?oqj Real)
    (declare-const ?oqk Real)
    (assert
      (or (or (= ?oqk ?oqj)
          (= ?oqk ?oqi)
          )
        (= ?oqj ?oqi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oql Real)
    (declare-const ?oqm Real)
    (declare-const ?oqn Real)
    (declare-const ?oqo Real)
    (declare-const ?oqp Real)
    (declare-const ?oqq Real)
    (assert
      (and (and (and (not (= ?oqn ?oqm))
            (not (= ?oqn ?oql))
            )
          (not (= ?oqm ?oql))
          )
        (or (or (= ?oqq ?oqp)
            (= ?oqq ?oqo)
            )
          (= ?oqp ?oqo)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oqr Real)
    (declare-const ?oqs Real)
    (declare-const ?oqt Real)
    (assert
      (or (or (= ?oqt ?oqs)
          (= ?oqt ?oqr)
          )
        (= ?oqs ?oqr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oqu Real)
    (declare-const ?oqv Real)
    (declare-const ?oqw Real)
    (assert
      (or (or (= ?oqw ?oqv)
          (= ?oqw ?oqu)
          )
        (= ?oqv ?oqu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oqx Real)
    (declare-const ?oqy Real)
    (declare-const ?oqz Real)
    (declare-const ?ora Real)
    (assert
      (or (or (= ?oqz ?oqy)
          (= ?oqz ?oqx)
          )
        (= ?oqy ?oqx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?orb Real)
    (declare-const ?orc Real)
    (declare-const ?ord Real)
    (declare-const ?ore Real)
    (declare-const ?orf Real)
    (assert
      (or (or (= ?ord ?orc)
          (= ?ord ?orb)
          )
        (= ?orc ?orb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?org Real)
    (declare-const ?orh Real)
    (declare-const ?ori Real)
    (declare-const ?orj Real)
    (declare-const ?ork Real)
    (declare-const ?orl Real)
    (assert
      (and (or (or (= ?ori ?orh)
            (= ?ori ?org)
            )
          (= ?orh ?org)
          )
        (and (and (not (= ?orl ?ork))
            (not (= ?orl ?orj))
            )
          (not (= ?ork ?orj))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?orm Real)
    (declare-const ?orn Real)
    (declare-const ?oro Real)
    (assert
      (or (or (= ?oro ?orn)
          (= ?oro ?orm)
          )
        (= ?orn ?orm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?orp Real)
    (declare-const ?orq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?orr Real)
    (declare-const ?ors Real)
    (declare-const ?ort Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oru Real)
    (declare-const ?orv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?orw Real)
    (declare-const ?orx Real)
    (declare-const ?ory Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?orz Real)
    (declare-const ?osa Real)
    (declare-const ?osb Real)
    (declare-const ?osc Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?osa ?orz))
                (not (= ?osa ?asi))
                )
              (not (= ?orz ?asi))
              )
            (or (or (= ?osc ?osb)
                (= ?osc ?asi)
                )
              (= ?osb ?asi)
              )
            )
          (and (or (or (= ?osa ?orz)
                (= ?osa ?asi)
                )
              (= ?orz ?asi)
              )
            (and (and (not (= ?osc ?osb))
                (not (= ?osc ?asi))
                )
              (not (= ?osb ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?osd Real)
    (declare-const ?ose Real)
    (declare-const ?osf Real)
    (declare-const ?osg Real)
    (declare-const ?osh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?osi Real)
    (declare-const ?osj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?osk Real)
    (declare-const ?osl Real)
    (declare-const ?osm Real)
    (declare-const ?osn Real)
    (declare-const ?oso Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?osp Real)
    (declare-const ?osq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?osr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oss Real)
    (declare-const ?ost Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?osu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?osv Real)
    (declare-const ?osw Real)
    (assert
      (not (= ?osv ?osw))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?osx Real)
    (declare-const ?osy Real)
    (declare-const ?osz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ota Real)
    (declare-const ?otb Real)
    (declare-const ?otc Real)
    (declare-const ?otd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ote Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?otf Real)
    (declare-const ?otg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oth Real)
    (declare-const ?oti Real)
    (declare-const ?otj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?otk Real)
    (declare-const ?otl Real)
    (declare-const ?otm Real)
    (declare-const ?otn Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?otl ?otk))
                (not (= ?otl ?fkf))
                )
              (not (= ?otk ?fkf))
              )
            (or (or (= ?otn ?otm)
                (= ?otn ?fkf)
                )
              (= ?otm ?fkf)
              )
            )
          (and (or (or (= ?otl ?otk)
                (= ?otl ?fkf)
                )
              (= ?otk ?fkf)
              )
            (and (and (not (= ?otn ?otm))
                (not (= ?otn ?fkf))
                )
              (not (= ?otm ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oto Real)
    (declare-const ?otp Real)
    (declare-const ?otq Real)
    (declare-const ?otr Real)
    (declare-const ?ots Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ott Real)
    (declare-const ?otu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?otv Real)
    (declare-const ?otw Real)
    (declare-const ?otx Real)
    (declare-const ?oty Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?otz Real)
    (declare-const ?oua Real)
    (declare-const ?oub Real)
    (declare-const ?ouc Real)
    (declare-const ?oud Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oue Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ouf Real)
    (declare-const ?oug Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ouh Real)
  (declare-const ?oui Real)
  (declare-const ?ouj Real)
  (assert
    (or (or (= ?ouj ?oui)
        (= ?ouj ?ouh)
        )
      (= ?oui ?ouh)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?ouk Real)
    (declare-const ?oul Real)
    (declare-const ?oum Real)
    (assert
      (or (or (= ?oum ?oul)
          (= ?oum ?ouk)
          )
        (= ?oul ?ouk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oun Real)
    (declare-const ?ouo Real)
    (declare-const ?oup Real)
    (declare-const ?ouq Real)
    (assert
      (or (or (= ?ouq ?oup)
          (= ?ouq ?ouo)
          )
        (= ?oup ?ouo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?our Real)
    (declare-const ?ous Real)
    (declare-const ?out Real)
    (declare-const ?ouu Real)
    (declare-const ?ouv Real)
    (assert
      (or (or (= ?ouv ?ouu)
          (= ?ouv ?out)
          )
        (= ?ouu ?out)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ouw Real)
    (declare-const ?oux Real)
    (declare-const ?ouy Real)
    (declare-const ?ouz Real)
    (declare-const ?ova Real)
    (declare-const ?ovb Real)
    (assert
      (and (and (and (not (= ?ouy ?oux))
            (not (= ?ouy ?ouw))
            )
          (not (= ?oux ?ouw))
          )
        (or (or (= ?ovb ?ova)
            (= ?ovb ?ouz)
            )
          (= ?ova ?ouz)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ovc Real)
    (declare-const ?ovd Real)
    (declare-const ?ove Real)
    (assert
      (or (or (= ?ove ?ovd)
          (= ?ove ?ovc)
          )
        (= ?ovd ?ovc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ovf Real)
    (declare-const ?ovg Real)
    (declare-const ?ovh Real)
    (assert
      (or (or (= ?ovh ?ovg)
          (= ?ovh ?ovf)
          )
        (= ?ovg ?ovf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ovi Real)
    (declare-const ?ovj Real)
    (declare-const ?ovk Real)
    (declare-const ?ovl Real)
    (assert
      (or (or (= ?ovk ?ovj)
          (= ?ovk ?ovi)
          )
        (= ?ovj ?ovi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ovm Real)
    (declare-const ?ovn Real)
    (declare-const ?ovo Real)
    (declare-const ?ovp Real)
    (declare-const ?ovq Real)
    (assert
      (or (or (= ?ovo ?ovn)
          (= ?ovo ?ovm)
          )
        (= ?ovn ?ovm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ovr Real)
    (declare-const ?ovs Real)
    (declare-const ?ovt Real)
    (declare-const ?ovu Real)
    (declare-const ?ovv Real)
    (declare-const ?ovw Real)
    (assert
      (and (or (or (= ?ovt ?ovs)
            (= ?ovt ?ovr)
            )
          (= ?ovs ?ovr)
          )
        (and (and (not (= ?ovw ?ovv))
            (not (= ?ovw ?ovu))
            )
          (not (= ?ovv ?ovu))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ovx Real)
    (declare-const ?ovy Real)
    (declare-const ?ovz Real)
    (assert
      (or (or (= ?ovz ?ovy)
          (= ?ovz ?ovx)
          )
        (= ?ovy ?ovx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?owa Real)
    (declare-const ?owb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?owc Real)
    (declare-const ?owd Real)
    (declare-const ?owe Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?owf Real)
    (declare-const ?owg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?owh Real)
    (declare-const ?owi Real)
    (declare-const ?owj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?owk Real)
    (declare-const ?owl Real)
    (declare-const ?owm Real)
    (declare-const ?own Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?owl ?owk))
                (not (= ?owl ?asi))
                )
              (not (= ?owk ?asi))
              )
            (or (or (= ?own ?owm)
                (= ?own ?asi)
                )
              (= ?owm ?asi)
              )
            )
          (and (or (or (= ?owl ?owk)
                (= ?owl ?asi)
                )
              (= ?owk ?asi)
              )
            (and (and (not (= ?own ?owm))
                (not (= ?own ?asi))
                )
              (not (= ?owm ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?owo Real)
    (declare-const ?owp Real)
    (declare-const ?owq Real)
    (declare-const ?owr Real)
    (declare-const ?ows Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?owt Real)
    (declare-const ?owu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?owv Real)
    (declare-const ?oww Real)
    (declare-const ?owx Real)
    (declare-const ?owy Real)
    (declare-const ?owz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oxa Real)
    (declare-const ?oxb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oxc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oxd Real)
    (declare-const ?oxe Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oxf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oxg Real)
    (declare-const ?oxh Real)
    (assert
      (not (= ?oxg ?oxh))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oxi Real)
    (declare-const ?oxj Real)
    (declare-const ?oxk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oxl Real)
    (declare-const ?oxm Real)
    (declare-const ?oxn Real)
    (declare-const ?oxo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oxp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oxq Real)
    (declare-const ?oxr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oxs Real)
    (declare-const ?oxt Real)
    (declare-const ?oxu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oxv Real)
    (declare-const ?oxw Real)
    (declare-const ?oxx Real)
    (declare-const ?oxy Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?oxw ?oxv))
                (not (= ?oxw ?fkf))
                )
              (not (= ?oxv ?fkf))
              )
            (or (or (= ?oxy ?oxx)
                (= ?oxy ?fkf)
                )
              (= ?oxx ?fkf)
              )
            )
          (and (or (or (= ?oxw ?oxv)
                (= ?oxw ?fkf)
                )
              (= ?oxv ?fkf)
              )
            (and (and (not (= ?oxy ?oxx))
                (not (= ?oxy ?fkf))
                )
              (not (= ?oxx ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oxz Real)
    (declare-const ?oya Real)
    (declare-const ?oyb Real)
    (declare-const ?oyc Real)
    (declare-const ?oyd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oye Real)
    (declare-const ?oyf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oyg Real)
    (declare-const ?oyh Real)
    (declare-const ?oyi Real)
    (declare-const ?oyj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oyk Real)
    (declare-const ?oyl Real)
    (declare-const ?oym Real)
    (declare-const ?oyn Real)
    (declare-const ?oyo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oyp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oyq Real)
    (declare-const ?oyr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?oys Real)
  (declare-const ?oyt Real)
  (declare-const ?oyu Real)
  (assert
    (or (or (= ?oyu ?oyt)
        (= ?oyu ?oys)
        )
      (= ?oyt ?oys)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?oyv Real)
    (declare-const ?oyw Real)
    (declare-const ?oyx Real)
    (assert
      (or (or (= ?oyx ?oyw)
          (= ?oyx ?oyv)
          )
        (= ?oyw ?oyv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?oyy Real)
    (declare-const ?oyz Real)
    (declare-const ?oza Real)
    (declare-const ?ozb Real)
    (assert
      (or (or (= ?ozb ?oza)
          (= ?ozb ?oyz)
          )
        (= ?oza ?oyz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ozc Real)
    (declare-const ?ozd Real)
    (declare-const ?oze Real)
    (declare-const ?ozf Real)
    (declare-const ?ozg Real)
    (assert
      (or (or (= ?ozg ?ozf)
          (= ?ozg ?oze)
          )
        (= ?ozf ?oze)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ozh Real)
    (declare-const ?ozi Real)
    (declare-const ?ozj Real)
    (declare-const ?ozk Real)
    (declare-const ?ozl Real)
    (declare-const ?ozm Real)
    (assert
      (and (and (and (not (= ?ozj ?ozi))
            (not (= ?ozj ?ozh))
            )
          (not (= ?ozi ?ozh))
          )
        (or (or (= ?ozm ?ozl)
            (= ?ozm ?ozk)
            )
          (= ?ozl ?ozk)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ozn Real)
    (declare-const ?ozo Real)
    (declare-const ?ozp Real)
    (assert
      (or (or (= ?ozp ?ozo)
          (= ?ozp ?ozn)
          )
        (= ?ozo ?ozn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ozq Real)
    (declare-const ?ozr Real)
    (declare-const ?ozs Real)
    (assert
      (or (or (= ?ozs ?ozr)
          (= ?ozs ?ozq)
          )
        (= ?ozr ?ozq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ozt Real)
    (declare-const ?ozu Real)
    (declare-const ?ozv Real)
    (declare-const ?ozw Real)
    (assert
      (or (or (= ?ozv ?ozu)
          (= ?ozv ?ozt)
          )
        (= ?ozu ?ozt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ozx Real)
    (declare-const ?ozy Real)
    (declare-const ?ozz Real)
    (declare-const ?paa Real)
    (declare-const ?pab Real)
    (assert
      (or (or (= ?ozz ?ozy)
          (= ?ozz ?ozx)
          )
        (= ?ozy ?ozx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pac Real)
    (declare-const ?pad Real)
    (declare-const ?pae Real)
    (declare-const ?paf Real)
    (declare-const ?pag Real)
    (declare-const ?pah Real)
    (assert
      (and (or (or (= ?pae ?pad)
            (= ?pae ?pac)
            )
          (= ?pad ?pac)
          )
        (and (and (not (= ?pah ?pag))
            (not (= ?pah ?paf))
            )
          (not (= ?pag ?paf))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pai Real)
    (declare-const ?paj Real)
    (declare-const ?pak Real)
    (assert
      (or (or (= ?pak ?paj)
          (= ?pak ?pai)
          )
        (= ?paj ?pai)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pal Real)
    (declare-const ?pam Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pan Real)
    (declare-const ?pao Real)
    (declare-const ?pap Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?paq Real)
    (declare-const ?par Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pas Real)
    (declare-const ?pat Real)
    (declare-const ?pau Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pav Real)
    (declare-const ?paw Real)
    (declare-const ?pax Real)
    (declare-const ?pay Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?paw ?pav))
                (not (= ?paw ?asi))
                )
              (not (= ?pav ?asi))
              )
            (or (or (= ?pay ?pax)
                (= ?pay ?asi)
                )
              (= ?pax ?asi)
              )
            )
          (and (or (or (= ?paw ?pav)
                (= ?paw ?asi)
                )
              (= ?pav ?asi)
              )
            (and (and (not (= ?pay ?pax))
                (not (= ?pay ?asi))
                )
              (not (= ?pax ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?paz Real)
    (declare-const ?pba Real)
    (declare-const ?pbb Real)
    (declare-const ?pbc Real)
    (declare-const ?pbd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pbe Real)
    (declare-const ?pbf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pbg Real)
    (declare-const ?pbh Real)
    (declare-const ?pbi Real)
    (declare-const ?pbj Real)
    (declare-const ?pbk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pbl Real)
    (declare-const ?pbm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pbn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pbo Real)
    (declare-const ?pbp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pbq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pbr Real)
    (declare-const ?pbs Real)
    (assert
      (not (= ?pbr ?pbs))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pbt Real)
    (declare-const ?pbu Real)
    (declare-const ?pbv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pbw Real)
    (declare-const ?pbx Real)
    (declare-const ?pby Real)
    (declare-const ?pbz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pca Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pcb Real)
    (declare-const ?pcc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pcd Real)
    (declare-const ?pce Real)
    (declare-const ?pcf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pcg Real)
    (declare-const ?pch Real)
    (declare-const ?pci Real)
    (declare-const ?pcj Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?pch ?pcg))
                (not (= ?pch ?fkf))
                )
              (not (= ?pcg ?fkf))
              )
            (or (or (= ?pcj ?pci)
                (= ?pcj ?fkf)
                )
              (= ?pci ?fkf)
              )
            )
          (and (or (or (= ?pch ?pcg)
                (= ?pch ?fkf)
                )
              (= ?pcg ?fkf)
              )
            (and (and (not (= ?pcj ?pci))
                (not (= ?pcj ?fkf))
                )
              (not (= ?pci ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pck Real)
    (declare-const ?pcl Real)
    (declare-const ?pcm Real)
    (declare-const ?pcn Real)
    (declare-const ?pco Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pcp Real)
    (declare-const ?pcq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pcr Real)
    (declare-const ?pcs Real)
    (declare-const ?pct Real)
    (declare-const ?pcu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pcv Real)
    (declare-const ?pcw Real)
    (declare-const ?pcx Real)
    (declare-const ?pcy Real)
    (declare-const ?pcz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pda Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pdb Real)
    (declare-const ?pdc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?pdd Real)
  (declare-const ?pde Real)
  (declare-const ?pdf Real)
  (declare-const ?pdg Real)
  (assert
    (or (or (= ?pdf ?pde)
        (= ?pdf ?pdd)
        )
      (= ?pde ?pdd)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?pdh Real)
    (declare-const ?pdi Real)
    (declare-const ?pdj Real)
    (assert
      (or (or (= ?pdj ?pdi)
          (= ?pdj ?pdh)
          )
        (= ?pdi ?pdh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pdk Real)
    (declare-const ?pdl Real)
    (declare-const ?pdm Real)
    (declare-const ?pdn Real)
    (assert
      (or (or (= ?pdn ?pdm)
          (= ?pdn ?pdl)
          )
        (= ?pdm ?pdl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pdo Real)
    (declare-const ?pdp Real)
    (declare-const ?pdq Real)
    (declare-const ?pdr Real)
    (declare-const ?pds Real)
    (assert
      (or (or (= ?pds ?pdr)
          (= ?pds ?pdq)
          )
        (= ?pdr ?pdq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pdt Real)
    (declare-const ?pdu Real)
    (declare-const ?pdv Real)
    (declare-const ?pdw Real)
    (declare-const ?pdx Real)
    (declare-const ?pdy Real)
    (assert
      (and (and (and (not (= ?pdv ?pdu))
            (not (= ?pdv ?pdt))
            )
          (not (= ?pdu ?pdt))
          )
        (or (or (= ?pdy ?pdx)
            (= ?pdy ?pdw)
            )
          (= ?pdx ?pdw)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pdz Real)
    (declare-const ?pea Real)
    (declare-const ?peb Real)
    (assert
      (or (or (= ?peb ?pea)
          (= ?peb ?pdz)
          )
        (= ?pea ?pdz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pec Real)
    (declare-const ?ped Real)
    (declare-const ?pee Real)
    (assert
      (or (or (= ?pee ?ped)
          (= ?pee ?pec)
          )
        (= ?ped ?pec)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pef Real)
    (declare-const ?peg Real)
    (declare-const ?peh Real)
    (declare-const ?pei Real)
    (assert
      (or (or (= ?peh ?peg)
          (= ?peh ?pef)
          )
        (= ?peg ?pef)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pej Real)
    (declare-const ?pek Real)
    (declare-const ?pel Real)
    (declare-const ?pem Real)
    (declare-const ?pen Real)
    (assert
      (or (or (= ?pel ?pek)
          (= ?pel ?pej)
          )
        (= ?pek ?pej)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?peo Real)
    (declare-const ?pep Real)
    (declare-const ?peq Real)
    (declare-const ?per Real)
    (declare-const ?pes Real)
    (declare-const ?pet Real)
    (assert
      (and (or (or (= ?peq ?pep)
            (= ?peq ?peo)
            )
          (= ?pep ?peo)
          )
        (and (and (not (= ?pet ?pes))
            (not (= ?pet ?per))
            )
          (not (= ?pes ?per))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?peu Real)
    (declare-const ?pev Real)
    (declare-const ?pew Real)
    (assert
      (or (or (= ?pew ?pev)
          (= ?pew ?peu)
          )
        (= ?pev ?peu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pex Real)
    (declare-const ?pey Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pez Real)
    (declare-const ?pfa Real)
    (declare-const ?pfb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pfc Real)
    (declare-const ?pfd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pfe Real)
    (declare-const ?pff Real)
    (declare-const ?pfg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pfh Real)
    (declare-const ?pfi Real)
    (declare-const ?pfj Real)
    (declare-const ?pfk Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?pfi ?pfh))
                (not (= ?pfi ?asi))
                )
              (not (= ?pfh ?asi))
              )
            (or (or (= ?pfk ?pfj)
                (= ?pfk ?asi)
                )
              (= ?pfj ?asi)
              )
            )
          (and (or (or (= ?pfi ?pfh)
                (= ?pfi ?asi)
                )
              (= ?pfh ?asi)
              )
            (and (and (not (= ?pfk ?pfj))
                (not (= ?pfk ?asi))
                )
              (not (= ?pfj ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pfl Real)
    (declare-const ?pfm Real)
    (declare-const ?pfn Real)
    (declare-const ?pfo Real)
    (declare-const ?pfp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pfq Real)
    (declare-const ?pfr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pfs Real)
    (declare-const ?pft Real)
    (declare-const ?pfu Real)
    (declare-const ?pfv Real)
    (declare-const ?pfw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pfx Real)
    (declare-const ?pfy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pfz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pga Real)
    (declare-const ?pgb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pgc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pgd Real)
    (declare-const ?pge Real)
    (assert
      (not (= ?pgd ?pge))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pgf Real)
    (declare-const ?pgg Real)
    (declare-const ?pgh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pgi Real)
    (declare-const ?pgj Real)
    (declare-const ?pgk Real)
    (declare-const ?pgl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pgm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pgn Real)
    (declare-const ?pgo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pgp Real)
    (declare-const ?pgq Real)
    (declare-const ?pgr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pgs Real)
    (declare-const ?pgt Real)
    (declare-const ?pgu Real)
    (declare-const ?pgv Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?pgt ?pgs))
                (not (= ?pgt ?fkf))
                )
              (not (= ?pgs ?fkf))
              )
            (or (or (= ?pgv ?pgu)
                (= ?pgv ?fkf)
                )
              (= ?pgu ?fkf)
              )
            )
          (and (or (or (= ?pgt ?pgs)
                (= ?pgt ?fkf)
                )
              (= ?pgs ?fkf)
              )
            (and (and (not (= ?pgv ?pgu))
                (not (= ?pgv ?fkf))
                )
              (not (= ?pgu ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pgw Real)
    (declare-const ?pgx Real)
    (declare-const ?pgy Real)
    (declare-const ?pgz Real)
    (declare-const ?pha Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?phb Real)
    (declare-const ?phc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?phd Real)
    (declare-const ?phe Real)
    (declare-const ?phf Real)
    (declare-const ?phg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?phh Real)
    (declare-const ?phi Real)
    (declare-const ?phj Real)
    (declare-const ?phk Real)
    (declare-const ?phl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?phm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?phn Real)
    (declare-const ?pho Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?php Real)
  (declare-const ?phq Real)
  (declare-const ?phr Real)
  (declare-const ?phs Real)
  (declare-const ?pht Real)
  (assert
    (or (or (= ?phr ?phq)
        (= ?phr ?php)
        )
      (= ?phq ?php)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?phu Real)
    (declare-const ?phv Real)
    (declare-const ?phw Real)
    (assert
      (or (or (= ?phw ?phv)
          (= ?phw ?phu)
          )
        (= ?phv ?phu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?phx Real)
    (declare-const ?phy Real)
    (declare-const ?phz Real)
    (declare-const ?pia Real)
    (assert
      (or (or (= ?pia ?phz)
          (= ?pia ?phy)
          )
        (= ?phz ?phy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pib Real)
    (declare-const ?pic Real)
    (declare-const ?pid Real)
    (declare-const ?pie Real)
    (declare-const ?pif Real)
    (assert
      (or (or (= ?pif ?pie)
          (= ?pif ?pid)
          )
        (= ?pie ?pid)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pig Real)
    (declare-const ?pih Real)
    (declare-const ?pii Real)
    (declare-const ?pij Real)
    (declare-const ?pik Real)
    (declare-const ?pil Real)
    (assert
      (and (and (and (not (= ?pii ?pih))
            (not (= ?pii ?pig))
            )
          (not (= ?pih ?pig))
          )
        (or (or (= ?pil ?pik)
            (= ?pil ?pij)
            )
          (= ?pik ?pij)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pim Real)
    (declare-const ?pin Real)
    (declare-const ?pio Real)
    (assert
      (or (or (= ?pio ?pin)
          (= ?pio ?pim)
          )
        (= ?pin ?pim)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pip Real)
    (declare-const ?piq Real)
    (declare-const ?pir Real)
    (assert
      (or (or (= ?pir ?piq)
          (= ?pir ?pip)
          )
        (= ?piq ?pip)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pis Real)
    (declare-const ?pit Real)
    (declare-const ?piu Real)
    (declare-const ?piv Real)
    (assert
      (or (or (= ?piu ?pit)
          (= ?piu ?pis)
          )
        (= ?pit ?pis)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?piw Real)
    (declare-const ?pix Real)
    (declare-const ?piy Real)
    (declare-const ?piz Real)
    (declare-const ?pja Real)
    (assert
      (or (or (= ?piy ?pix)
          (= ?piy ?piw)
          )
        (= ?pix ?piw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pjb Real)
    (declare-const ?pjc Real)
    (declare-const ?pjd Real)
    (declare-const ?pje Real)
    (declare-const ?pjf Real)
    (declare-const ?pjg Real)
    (assert
      (and (or (or (= ?pjd ?pjc)
            (= ?pjd ?pjb)
            )
          (= ?pjc ?pjb)
          )
        (and (and (not (= ?pjg ?pjf))
            (not (= ?pjg ?pje))
            )
          (not (= ?pjf ?pje))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pjh Real)
    (declare-const ?pji Real)
    (declare-const ?pjj Real)
    (assert
      (or (or (= ?pjj ?pji)
          (= ?pjj ?pjh)
          )
        (= ?pji ?pjh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pjk Real)
    (declare-const ?pjl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pjm Real)
    (declare-const ?pjn Real)
    (declare-const ?pjo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pjp Real)
    (declare-const ?pjq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pjr Real)
    (declare-const ?pjs Real)
    (declare-const ?pjt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pju Real)
    (declare-const ?pjv Real)
    (declare-const ?pjw Real)
    (declare-const ?pjx Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?pjv ?pju))
                (not (= ?pjv ?asi))
                )
              (not (= ?pju ?asi))
              )
            (or (or (= ?pjx ?pjw)
                (= ?pjx ?asi)
                )
              (= ?pjw ?asi)
              )
            )
          (and (or (or (= ?pjv ?pju)
                (= ?pjv ?asi)
                )
              (= ?pju ?asi)
              )
            (and (and (not (= ?pjx ?pjw))
                (not (= ?pjx ?asi))
                )
              (not (= ?pjw ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pjy Real)
    (declare-const ?pjz Real)
    (declare-const ?pka Real)
    (declare-const ?pkb Real)
    (declare-const ?pkc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pkd Real)
    (declare-const ?pke Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pkf Real)
    (declare-const ?pkg Real)
    (declare-const ?pkh Real)
    (declare-const ?pki Real)
    (declare-const ?pkj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pkk Real)
    (declare-const ?pkl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pkm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pkn Real)
    (declare-const ?pko Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pkp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pkq Real)
    (declare-const ?pkr Real)
    (assert
      (not (= ?pkq ?pkr))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pks Real)
    (declare-const ?pkt Real)
    (declare-const ?pku Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pkv Real)
    (declare-const ?pkw Real)
    (declare-const ?pkx Real)
    (declare-const ?pky Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pkz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pla Real)
    (declare-const ?plb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?plc Real)
    (declare-const ?pld Real)
    (declare-const ?ple Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?plf Real)
    (declare-const ?plg Real)
    (declare-const ?plh Real)
    (declare-const ?pli Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?plg ?plf))
                (not (= ?plg ?fkf))
                )
              (not (= ?plf ?fkf))
              )
            (or (or (= ?pli ?plh)
                (= ?pli ?fkf)
                )
              (= ?plh ?fkf)
              )
            )
          (and (or (or (= ?plg ?plf)
                (= ?plg ?fkf)
                )
              (= ?plf ?fkf)
              )
            (and (and (not (= ?pli ?plh))
                (not (= ?pli ?fkf))
                )
              (not (= ?plh ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?plj Real)
    (declare-const ?plk Real)
    (declare-const ?pll Real)
    (declare-const ?plm Real)
    (declare-const ?pln Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?plo Real)
    (declare-const ?plp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?plq Real)
    (declare-const ?plr Real)
    (declare-const ?pls Real)
    (declare-const ?plt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?plu Real)
    (declare-const ?plv Real)
    (declare-const ?plw Real)
    (declare-const ?plx Real)
    (declare-const ?ply Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?plz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pma Real)
    (declare-const ?pmb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?pmc Real)
  (declare-const ?pmd Real)
  (declare-const ?pme Real)
  (declare-const ?pmf Real)
  (declare-const ?pmg Real)
  (declare-const ?pmh Real)
  (assert
    (and (or (or (= ?pme ?pmd)
          (= ?pme ?pmc)
          )
        (= ?pmd ?pmc)
        )
      (and (and (not (= ?pmh ?pmg))
          (not (= ?pmh ?pmf))
          )
        (not (= ?pmg ?pmf))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?pmi Real)
    (declare-const ?pmj Real)
    (declare-const ?pmk Real)
    (assert
      (or (or (= ?pmk ?pmj)
          (= ?pmk ?pmi)
          )
        (= ?pmj ?pmi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pml Real)
    (declare-const ?pmm Real)
    (declare-const ?pmn Real)
    (declare-const ?pmo Real)
    (assert
      (or (or (= ?pmo ?pmn)
          (= ?pmo ?pmm)
          )
        (= ?pmn ?pmm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pmp Real)
    (declare-const ?pmq Real)
    (declare-const ?pmr Real)
    (declare-const ?pms Real)
    (declare-const ?pmt Real)
    (assert
      (or (or (= ?pmt ?pms)
          (= ?pmt ?pmr)
          )
        (= ?pms ?pmr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pmu Real)
    (declare-const ?pmv Real)
    (declare-const ?pmw Real)
    (declare-const ?pmx Real)
    (declare-const ?pmy Real)
    (declare-const ?pmz Real)
    (assert
      (and (and (and (not (= ?pmw ?pmv))
            (not (= ?pmw ?pmu))
            )
          (not (= ?pmv ?pmu))
          )
        (or (or (= ?pmz ?pmy)
            (= ?pmz ?pmx)
            )
          (= ?pmy ?pmx)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pna Real)
    (declare-const ?pnb Real)
    (declare-const ?pnc Real)
    (assert
      (or (or (= ?pnc ?pnb)
          (= ?pnc ?pna)
          )
        (= ?pnb ?pna)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pnd Real)
    (declare-const ?pne Real)
    (declare-const ?pnf Real)
    (assert
      (or (or (= ?pnf ?pne)
          (= ?pnf ?pnd)
          )
        (= ?pne ?pnd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?png Real)
    (declare-const ?pnh Real)
    (declare-const ?pni Real)
    (declare-const ?pnj Real)
    (assert
      (or (or (= ?pni ?pnh)
          (= ?pni ?png)
          )
        (= ?pnh ?png)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pnk Real)
    (declare-const ?pnl Real)
    (declare-const ?pnm Real)
    (declare-const ?pnn Real)
    (declare-const ?pno Real)
    (assert
      (or (or (= ?pnm ?pnl)
          (= ?pnm ?pnk)
          )
        (= ?pnl ?pnk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pnp Real)
    (declare-const ?pnq Real)
    (declare-const ?pnr Real)
    (declare-const ?pns Real)
    (declare-const ?pnt Real)
    (declare-const ?pnu Real)
    (assert
      (and (or (or (= ?pnr ?pnq)
            (= ?pnr ?pnp)
            )
          (= ?pnq ?pnp)
          )
        (and (and (not (= ?pnu ?pnt))
            (not (= ?pnu ?pns))
            )
          (not (= ?pnt ?pns))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pnv Real)
    (declare-const ?pnw Real)
    (declare-const ?pnx Real)
    (assert
      (or (or (= ?pnx ?pnw)
          (= ?pnx ?pnv)
          )
        (= ?pnw ?pnv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pny Real)
    (declare-const ?pnz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?poa Real)
    (declare-const ?pob Real)
    (declare-const ?poc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pod Real)
    (declare-const ?poe Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pof Real)
    (declare-const ?pog Real)
    (declare-const ?poh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?poi Real)
    (declare-const ?poj Real)
    (declare-const ?pok Real)
    (declare-const ?pol Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?poj ?poi))
                (not (= ?poj ?asi))
                )
              (not (= ?poi ?asi))
              )
            (or (or (= ?pol ?pok)
                (= ?pol ?asi)
                )
              (= ?pok ?asi)
              )
            )
          (and (or (or (= ?poj ?poi)
                (= ?poj ?asi)
                )
              (= ?poi ?asi)
              )
            (and (and (not (= ?pol ?pok))
                (not (= ?pol ?asi))
                )
              (not (= ?pok ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pom Real)
    (declare-const ?pon Real)
    (declare-const ?poo Real)
    (declare-const ?pop Real)
    (declare-const ?poq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?por Real)
    (declare-const ?pos Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pot Real)
    (declare-const ?pou Real)
    (declare-const ?pov Real)
    (declare-const ?pow Real)
    (declare-const ?pox Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?poy Real)
    (declare-const ?poz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ppa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ppb Real)
    (declare-const ?ppc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ppd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ppe Real)
    (declare-const ?ppf Real)
    (assert
      (not (= ?ppe ?ppf))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ppg Real)
    (declare-const ?pph Real)
    (declare-const ?ppi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ppj Real)
    (declare-const ?ppk Real)
    (declare-const ?ppl Real)
    (declare-const ?ppm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ppn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ppo Real)
    (declare-const ?ppp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ppq Real)
    (declare-const ?ppr Real)
    (declare-const ?pps Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ppt Real)
    (declare-const ?ppu Real)
    (declare-const ?ppv Real)
    (declare-const ?ppw Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ppu ?ppt))
                (not (= ?ppu ?fkf))
                )
              (not (= ?ppt ?fkf))
              )
            (or (or (= ?ppw ?ppv)
                (= ?ppw ?fkf)
                )
              (= ?ppv ?fkf)
              )
            )
          (and (or (or (= ?ppu ?ppt)
                (= ?ppu ?fkf)
                )
              (= ?ppt ?fkf)
              )
            (and (and (not (= ?ppw ?ppv))
                (not (= ?ppw ?fkf))
                )
              (not (= ?ppv ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ppx Real)
    (declare-const ?ppy Real)
    (declare-const ?ppz Real)
    (declare-const ?pqa Real)
    (declare-const ?pqb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pqc Real)
    (declare-const ?pqd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pqe Real)
    (declare-const ?pqf Real)
    (declare-const ?pqg Real)
    (declare-const ?pqh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pqi Real)
    (declare-const ?pqj Real)
    (declare-const ?pqk Real)
    (declare-const ?pql Real)
    (declare-const ?pqm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pqn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pqo Real)
    (declare-const ?pqp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?pqq Real)
  (declare-const ?pqr Real)
  (declare-const ?pqs Real)
  (assert
    (or (or (= ?pqs ?pqr)
        (= ?pqs ?pqq)
        )
      (= ?pqr ?pqq)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?pqt Real)
    (declare-const ?pqu Real)
    (declare-const ?pqv Real)
    (assert
      (or (or (= ?pqv ?pqu)
          (= ?pqv ?pqt)
          )
        (= ?pqu ?pqt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pqw Real)
    (declare-const ?pqx Real)
    (declare-const ?pqy Real)
    (declare-const ?pqz Real)
    (assert
      (or (or (= ?pqz ?pqy)
          (= ?pqz ?pqx)
          )
        (= ?pqy ?pqx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pra Real)
    (declare-const ?prb Real)
    (declare-const ?prc Real)
    (declare-const ?prd Real)
    (declare-const ?pre Real)
    (assert
      (or (or (= ?pre ?prd)
          (= ?pre ?prc)
          )
        (= ?prd ?prc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?prf Real)
    (declare-const ?prg Real)
    (declare-const ?prh Real)
    (declare-const ?pri Real)
    (declare-const ?prj Real)
    (declare-const ?prk Real)
    (assert
      (and (and (and (not (= ?prh ?prg))
            (not (= ?prh ?prf))
            )
          (not (= ?prg ?prf))
          )
        (or (or (= ?prk ?prj)
            (= ?prk ?pri)
            )
          (= ?prj ?pri)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?prl Real)
    (declare-const ?prm Real)
    (declare-const ?prn Real)
    (assert
      (or (or (= ?prn ?prm)
          (= ?prn ?prl)
          )
        (= ?prm ?prl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pro Real)
    (declare-const ?prp Real)
    (declare-const ?prq Real)
    (assert
      (or (or (= ?prq ?prp)
          (= ?prq ?pro)
          )
        (= ?prp ?pro)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?prr Real)
    (declare-const ?prs Real)
    (declare-const ?prt Real)
    (declare-const ?pru Real)
    (assert
      (or (or (= ?prt ?prs)
          (= ?prt ?prr)
          )
        (= ?prs ?prr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?prv Real)
    (declare-const ?prw Real)
    (declare-const ?prx Real)
    (declare-const ?pry Real)
    (declare-const ?prz Real)
    (assert
      (or (or (= ?prx ?prw)
          (= ?prx ?prv)
          )
        (= ?prw ?prv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?psa Real)
    (declare-const ?psb Real)
    (declare-const ?psc Real)
    (declare-const ?psd Real)
    (declare-const ?pse Real)
    (declare-const ?psf Real)
    (assert
      (and (or (or (= ?psc ?psb)
            (= ?psc ?psa)
            )
          (= ?psb ?psa)
          )
        (and (and (not (= ?psf ?pse))
            (not (= ?psf ?psd))
            )
          (not (= ?pse ?psd))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?psg Real)
    (declare-const ?psh Real)
    (declare-const ?psi Real)
    (assert
      (or (or (= ?psi ?psh)
          (= ?psi ?psg)
          )
        (= ?psh ?psg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?psj Real)
    (declare-const ?psk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?psl Real)
    (declare-const ?psm Real)
    (declare-const ?psn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pso Real)
    (declare-const ?psp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?psq Real)
    (declare-const ?psr Real)
    (declare-const ?pss Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pst Real)
    (declare-const ?psu Real)
    (declare-const ?psv Real)
    (declare-const ?psw Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?psu ?pst))
                (not (= ?psu ?asi))
                )
              (not (= ?pst ?asi))
              )
            (or (or (= ?psw ?psv)
                (= ?psw ?asi)
                )
              (= ?psv ?asi)
              )
            )
          (and (or (or (= ?psu ?pst)
                (= ?psu ?asi)
                )
              (= ?pst ?asi)
              )
            (and (and (not (= ?psw ?psv))
                (not (= ?psw ?asi))
                )
              (not (= ?psv ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?psx Real)
    (declare-const ?psy Real)
    (declare-const ?psz Real)
    (declare-const ?pta Real)
    (declare-const ?ptb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ptc Real)
    (declare-const ?ptd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pte Real)
    (declare-const ?ptf Real)
    (declare-const ?ptg Real)
    (declare-const ?pth Real)
    (declare-const ?pti Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ptj Real)
    (declare-const ?ptk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ptl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ptm Real)
    (declare-const ?ptn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pto Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ptp Real)
    (declare-const ?ptq Real)
    (assert
      (not (= ?ptp ?ptq))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ptr Real)
    (declare-const ?pts Real)
    (declare-const ?ptt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ptu Real)
    (declare-const ?ptv Real)
    (declare-const ?ptw Real)
    (declare-const ?ptx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pty Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ptz Real)
    (declare-const ?pua Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pub Real)
    (declare-const ?puc Real)
    (declare-const ?pud Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pue Real)
    (declare-const ?puf Real)
    (declare-const ?pug Real)
    (declare-const ?puh Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?puf ?pue))
                (not (= ?puf ?fkf))
                )
              (not (= ?pue ?fkf))
              )
            (or (or (= ?puh ?pug)
                (= ?puh ?fkf)
                )
              (= ?pug ?fkf)
              )
            )
          (and (or (or (= ?puf ?pue)
                (= ?puf ?fkf)
                )
              (= ?pue ?fkf)
              )
            (and (and (not (= ?puh ?pug))
                (not (= ?puh ?fkf))
                )
              (not (= ?pug ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pui Real)
    (declare-const ?puj Real)
    (declare-const ?puk Real)
    (declare-const ?pul Real)
    (declare-const ?pum Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pun Real)
    (declare-const ?puo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pup Real)
    (declare-const ?puq Real)
    (declare-const ?pur Real)
    (declare-const ?pus Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?put Real)
    (declare-const ?puu Real)
    (declare-const ?puv Real)
    (declare-const ?puw Real)
    (declare-const ?pux Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?puy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?puz Real)
    (declare-const ?pva Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?pvb Real)
  (declare-const ?pvc Real)
  (push 1)
    (declare-const ?pvd Real)
    (declare-const ?pve Real)
    (declare-const ?pvf Real)
    (assert
      (or (or (= ?pvf ?pve)
          (= ?pvf ?pvd)
          )
        (= ?pve ?pvd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pvg Real)
    (declare-const ?pvh Real)
    (declare-const ?pvi Real)
    (declare-const ?pvj Real)
    (assert
      (or (or (= ?pvj ?pvi)
          (= ?pvj ?pvh)
          )
        (= ?pvi ?pvh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pvk Real)
    (declare-const ?pvl Real)
    (declare-const ?pvm Real)
    (declare-const ?pvn Real)
    (declare-const ?pvo Real)
    (assert
      (or (or (= ?pvo ?pvn)
          (= ?pvo ?pvm)
          )
        (= ?pvn ?pvm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pvp Real)
    (declare-const ?pvq Real)
    (declare-const ?pvr Real)
    (declare-const ?pvs Real)
    (declare-const ?pvt Real)
    (declare-const ?pvu Real)
    (assert
      (and (and (and (not (= ?pvr ?pvq))
            (not (= ?pvr ?pvp))
            )
          (not (= ?pvq ?pvp))
          )
        (or (or (= ?pvu ?pvt)
            (= ?pvu ?pvs)
            )
          (= ?pvt ?pvs)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pvv Real)
    (declare-const ?pvw Real)
    (declare-const ?pvx Real)
    (assert
      (or (or (= ?pvx ?pvw)
          (= ?pvx ?pvv)
          )
        (= ?pvw ?pvv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pvy Real)
    (declare-const ?pvz Real)
    (declare-const ?pwa Real)
    (assert
      (or (or (= ?pwa ?pvz)
          (= ?pwa ?pvy)
          )
        (= ?pvz ?pvy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pwb Real)
    (declare-const ?pwc Real)
    (declare-const ?pwd Real)
    (declare-const ?pwe Real)
    (assert
      (or (or (= ?pwd ?pwc)
          (= ?pwd ?pwb)
          )
        (= ?pwc ?pwb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pwf Real)
    (declare-const ?pwg Real)
    (declare-const ?pwh Real)
    (declare-const ?pwi Real)
    (declare-const ?pwj Real)
    (assert
      (or (or (= ?pwh ?pwg)
          (= ?pwh ?pwf)
          )
        (= ?pwg ?pwf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pwk Real)
    (declare-const ?pwl Real)
    (declare-const ?pwm Real)
    (declare-const ?pwn Real)
    (declare-const ?pwo Real)
    (declare-const ?pwp Real)
    (assert
      (and (or (or (= ?pwm ?pwl)
            (= ?pwm ?pwk)
            )
          (= ?pwl ?pwk)
          )
        (and (and (not (= ?pwp ?pwo))
            (not (= ?pwp ?pwn))
            )
          (not (= ?pwo ?pwn))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pwq Real)
    (declare-const ?pwr Real)
    (declare-const ?pws Real)
    (assert
      (or (or (= ?pws ?pwr)
          (= ?pws ?pwq)
          )
        (= ?pwr ?pwq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pwt Real)
    (declare-const ?pwu Real)
    (declare-const ?pwv Real)
    (declare-const ?pww Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?pwu ?pwt))
                (not (= ?pwu ?asi))
                )
              (not (= ?pwt ?asi))
              )
            (or (or (= ?pww ?pwv)
                (= ?pww ?asi)
                )
              (= ?pwv ?asi)
              )
            )
          (and (or (or (= ?pwu ?pwt)
                (= ?pwu ?asi)
                )
              (= ?pwt ?asi)
              )
            (and (and (not (= ?pww ?pwv))
                (not (= ?pww ?asi))
                )
              (not (= ?pwv ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pwx Real)
    (declare-const ?pwy Real)
    (declare-const ?pwz Real)
    (declare-const ?pxa Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?pwy ?pwx))
                (not (= ?pwy ?fkf))
                )
              (not (= ?pwx ?fkf))
              )
            (or (or (= ?pxa ?pwz)
                (= ?pxa ?fkf)
                )
              (= ?pwz ?fkf)
              )
            )
          (and (or (or (= ?pwy ?pwx)
                (= ?pwy ?fkf)
                )
              (= ?pwx ?fkf)
              )
            (and (and (not (= ?pxa ?pwz))
                (not (= ?pxa ?fkf))
                )
              (not (= ?pwz ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?pxb Real)
  (declare-const ?pxc Real)
  (declare-const ?pxd Real)
  (push 1)
    (declare-const ?pxe Real)
    (declare-const ?pxf Real)
    (declare-const ?pxg Real)
    (assert
      (or (or (= ?pxg ?pxf)
          (= ?pxg ?pxe)
          )
        (= ?pxf ?pxe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pxh Real)
    (declare-const ?pxi Real)
    (declare-const ?pxj Real)
    (declare-const ?pxk Real)
    (assert
      (or (or (= ?pxk ?pxj)
          (= ?pxk ?pxi)
          )
        (= ?pxj ?pxi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pxl Real)
    (declare-const ?pxm Real)
    (declare-const ?pxn Real)
    (declare-const ?pxo Real)
    (declare-const ?pxp Real)
    (assert
      (or (or (= ?pxp ?pxo)
          (= ?pxp ?pxn)
          )
        (= ?pxo ?pxn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pxq Real)
    (declare-const ?pxr Real)
    (declare-const ?pxs Real)
    (declare-const ?pxt Real)
    (declare-const ?pxu Real)
    (declare-const ?pxv Real)
    (assert
      (and (and (and (not (= ?pxs ?pxr))
            (not (= ?pxs ?pxq))
            )
          (not (= ?pxr ?pxq))
          )
        (or (or (= ?pxv ?pxu)
            (= ?pxv ?pxt)
            )
          (= ?pxu ?pxt)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pxw Real)
    (declare-const ?pxx Real)
    (declare-const ?pxy Real)
    (assert
      (or (or (= ?pxy ?pxx)
          (= ?pxy ?pxw)
          )
        (= ?pxx ?pxw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pxz Real)
    (declare-const ?pya Real)
    (declare-const ?pyb Real)
    (assert
      (or (or (= ?pyb ?pya)
          (= ?pyb ?pxz)
          )
        (= ?pya ?pxz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pyc Real)
    (declare-const ?pyd Real)
    (declare-const ?pye Real)
    (declare-const ?pyf Real)
    (assert
      (or (or (= ?pye ?pyd)
          (= ?pye ?pyc)
          )
        (= ?pyd ?pyc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pyg Real)
    (declare-const ?pyh Real)
    (declare-const ?pyi Real)
    (declare-const ?pyj Real)
    (declare-const ?pyk Real)
    (assert
      (or (or (= ?pyi ?pyh)
          (= ?pyi ?pyg)
          )
        (= ?pyh ?pyg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pyl Real)
    (declare-const ?pym Real)
    (declare-const ?pyn Real)
    (declare-const ?pyo Real)
    (declare-const ?pyp Real)
    (declare-const ?pyq Real)
    (assert
      (and (or (or (= ?pyn ?pym)
            (= ?pyn ?pyl)
            )
          (= ?pym ?pyl)
          )
        (and (and (not (= ?pyq ?pyp))
            (not (= ?pyq ?pyo))
            )
          (not (= ?pyp ?pyo))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pyr Real)
    (declare-const ?pys Real)
    (declare-const ?pyt Real)
    (assert
      (or (or (= ?pyt ?pys)
          (= ?pyt ?pyr)
          )
        (= ?pys ?pyr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pyu Real)
    (declare-const ?pyv Real)
    (declare-const ?pyw Real)
    (declare-const ?pyx Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?pyv ?pyu))
                (not (= ?pyv ?asi))
                )
              (not (= ?pyu ?asi))
              )
            (or (or (= ?pyx ?pyw)
                (= ?pyx ?asi)
                )
              (= ?pyw ?asi)
              )
            )
          (and (or (or (= ?pyv ?pyu)
                (= ?pyv ?asi)
                )
              (= ?pyu ?asi)
              )
            (and (and (not (= ?pyx ?pyw))
                (not (= ?pyx ?asi))
                )
              (not (= ?pyw ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pyy Real)
    (declare-const ?pyz Real)
    (declare-const ?pza Real)
    (declare-const ?pzb Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?pyz ?pyy))
                (not (= ?pyz ?fkf))
                )
              (not (= ?pyy ?fkf))
              )
            (or (or (= ?pzb ?pza)
                (= ?pzb ?fkf)
                )
              (= ?pza ?fkf)
              )
            )
          (and (or (or (= ?pyz ?pyy)
                (= ?pyz ?fkf)
                )
              (= ?pyy ?fkf)
              )
            (and (and (not (= ?pzb ?pza))
                (not (= ?pzb ?fkf))
                )
              (not (= ?pza ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?pzc Real)
  (declare-const ?pzd Real)
  (push 1)
    (declare-const ?pze Real)
    (declare-const ?pzf Real)
    (declare-const ?pzg Real)
    (assert
      (or (or (= ?pzg ?pzf)
          (= ?pzg ?pze)
          )
        (= ?pzf ?pze)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pzh Real)
    (declare-const ?pzi Real)
    (declare-const ?pzj Real)
    (declare-const ?pzk Real)
    (assert
      (or (or (= ?pzk ?pzj)
          (= ?pzk ?pzi)
          )
        (= ?pzj ?pzi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pzl Real)
    (declare-const ?pzm Real)
    (declare-const ?pzn Real)
    (declare-const ?pzo Real)
    (declare-const ?pzp Real)
    (assert
      (or (or (= ?pzp ?pzo)
          (= ?pzp ?pzn)
          )
        (= ?pzo ?pzn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pzq Real)
    (declare-const ?pzr Real)
    (declare-const ?pzs Real)
    (declare-const ?pzt Real)
    (declare-const ?pzu Real)
    (declare-const ?pzv Real)
    (assert
      (and (and (and (not (= ?pzs ?pzr))
            (not (= ?pzs ?pzq))
            )
          (not (= ?pzr ?pzq))
          )
        (or (or (= ?pzv ?pzu)
            (= ?pzv ?pzt)
            )
          (= ?pzu ?pzt)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pzw Real)
    (declare-const ?pzx Real)
    (declare-const ?pzy Real)
    (assert
      (or (or (= ?pzy ?pzx)
          (= ?pzy ?pzw)
          )
        (= ?pzx ?pzw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?pzz Real)
    (declare-const ?qaa Real)
    (declare-const ?qab Real)
    (assert
      (or (or (= ?qab ?qaa)
          (= ?qab ?pzz)
          )
        (= ?qaa ?pzz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qac Real)
    (declare-const ?qad Real)
    (declare-const ?qae Real)
    (declare-const ?qaf Real)
    (assert
      (or (or (= ?qae ?qad)
          (= ?qae ?qac)
          )
        (= ?qad ?qac)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qag Real)
    (declare-const ?qah Real)
    (declare-const ?qai Real)
    (declare-const ?qaj Real)
    (declare-const ?qak Real)
    (assert
      (or (or (= ?qai ?qah)
          (= ?qai ?qag)
          )
        (= ?qah ?qag)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qal Real)
    (declare-const ?qam Real)
    (declare-const ?qan Real)
    (declare-const ?qao Real)
    (declare-const ?qap Real)
    (declare-const ?qaq Real)
    (assert
      (and (or (or (= ?qan ?qam)
            (= ?qan ?qal)
            )
          (= ?qam ?qal)
          )
        (and (and (not (= ?qaq ?qap))
            (not (= ?qaq ?qao))
            )
          (not (= ?qap ?qao))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qar Real)
    (declare-const ?qas Real)
    (declare-const ?qat Real)
    (assert
      (or (or (= ?qat ?qas)
          (= ?qat ?qar)
          )
        (= ?qas ?qar)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qau Real)
    (declare-const ?qav Real)
    (declare-const ?qaw Real)
    (declare-const ?qax Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?qav ?qau))
                (not (= ?qav ?asi))
                )
              (not (= ?qau ?asi))
              )
            (or (or (= ?qax ?qaw)
                (= ?qax ?asi)
                )
              (= ?qaw ?asi)
              )
            )
          (and (or (or (= ?qav ?qau)
                (= ?qav ?asi)
                )
              (= ?qau ?asi)
              )
            (and (and (not (= ?qax ?qaw))
                (not (= ?qax ?asi))
                )
              (not (= ?qaw ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qay Real)
    (declare-const ?qaz Real)
    (declare-const ?qba Real)
    (declare-const ?qbb Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?qaz ?qay))
                (not (= ?qaz ?fkf))
                )
              (not (= ?qay ?fkf))
              )
            (or (or (= ?qbb ?qba)
                (= ?qbb ?fkf)
                )
              (= ?qba ?fkf)
              )
            )
          (and (or (or (= ?qaz ?qay)
                (= ?qaz ?fkf)
                )
              (= ?qay ?fkf)
              )
            (and (and (not (= ?qbb ?qba))
                (not (= ?qbb ?fkf))
                )
              (not (= ?qba ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?qbc Real)
  (declare-const ?qbd Real)
  (declare-const ?qbe Real)
  (push 1)
    (declare-const ?qbf Real)
    (declare-const ?qbg Real)
    (declare-const ?qbh Real)
    (assert
      (or (or (= ?qbh ?qbg)
          (= ?qbh ?qbf)
          )
        (= ?qbg ?qbf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qbi Real)
    (declare-const ?qbj Real)
    (declare-const ?qbk Real)
    (declare-const ?qbl Real)
    (assert
      (or (or (= ?qbl ?qbk)
          (= ?qbl ?qbj)
          )
        (= ?qbk ?qbj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qbm Real)
    (declare-const ?qbn Real)
    (declare-const ?qbo Real)
    (declare-const ?qbp Real)
    (declare-const ?qbq Real)
    (assert
      (or (or (= ?qbq ?qbp)
          (= ?qbq ?qbo)
          )
        (= ?qbp ?qbo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qbr Real)
    (declare-const ?qbs Real)
    (declare-const ?qbt Real)
    (declare-const ?qbu Real)
    (declare-const ?qbv Real)
    (declare-const ?qbw Real)
    (assert
      (and (and (and (not (= ?qbt ?qbs))
            (not (= ?qbt ?qbr))
            )
          (not (= ?qbs ?qbr))
          )
        (or (or (= ?qbw ?qbv)
            (= ?qbw ?qbu)
            )
          (= ?qbv ?qbu)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qbx Real)
    (declare-const ?qby Real)
    (declare-const ?qbz Real)
    (assert
      (or (or (= ?qbz ?qby)
          (= ?qbz ?qbx)
          )
        (= ?qby ?qbx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qca Real)
    (declare-const ?qcb Real)
    (declare-const ?qcc Real)
    (assert
      (or (or (= ?qcc ?qcb)
          (= ?qcc ?qca)
          )
        (= ?qcb ?qca)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qcd Real)
    (declare-const ?qce Real)
    (declare-const ?qcf Real)
    (declare-const ?qcg Real)
    (assert
      (or (or (= ?qcf ?qce)
          (= ?qcf ?qcd)
          )
        (= ?qce ?qcd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qch Real)
    (declare-const ?qci Real)
    (declare-const ?qcj Real)
    (declare-const ?qck Real)
    (declare-const ?qcl Real)
    (assert
      (or (or (= ?qcj ?qci)
          (= ?qcj ?qch)
          )
        (= ?qci ?qch)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qcm Real)
    (declare-const ?qcn Real)
    (declare-const ?qco Real)
    (declare-const ?qcp Real)
    (declare-const ?qcq Real)
    (declare-const ?qcr Real)
    (assert
      (and (or (or (= ?qco ?qcn)
            (= ?qco ?qcm)
            )
          (= ?qcn ?qcm)
          )
        (and (and (not (= ?qcr ?qcq))
            (not (= ?qcr ?qcp))
            )
          (not (= ?qcq ?qcp))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qcs Real)
    (declare-const ?qct Real)
    (declare-const ?qcu Real)
    (assert
      (or (or (= ?qcu ?qct)
          (= ?qcu ?qcs)
          )
        (= ?qct ?qcs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qcv Real)
    (declare-const ?qcw Real)
    (declare-const ?qcx Real)
    (declare-const ?qcy Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?qcw ?qcv))
                (not (= ?qcw ?asi))
                )
              (not (= ?qcv ?asi))
              )
            (or (or (= ?qcy ?qcx)
                (= ?qcy ?asi)
                )
              (= ?qcx ?asi)
              )
            )
          (and (or (or (= ?qcw ?qcv)
                (= ?qcw ?asi)
                )
              (= ?qcv ?asi)
              )
            (and (and (not (= ?qcy ?qcx))
                (not (= ?qcy ?asi))
                )
              (not (= ?qcx ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qcz Real)
    (declare-const ?qda Real)
    (declare-const ?qdb Real)
    (declare-const ?qdc Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?qda ?qcz))
                (not (= ?qda ?fkf))
                )
              (not (= ?qcz ?fkf))
              )
            (or (or (= ?qdc ?qdb)
                (= ?qdc ?fkf)
                )
              (= ?qdb ?fkf)
              )
            )
          (and (or (or (= ?qda ?qcz)
                (= ?qda ?fkf)
                )
              (= ?qcz ?fkf)
              )
            (and (and (not (= ?qdc ?qdb))
                (not (= ?qdc ?fkf))
                )
              (not (= ?qdb ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?qdd Real)
  (declare-const ?qde Real)
  (declare-const ?qdf Real)
  (declare-const ?qdg Real)
  (assert
    (exists ((?asi Real) )(or (and (and (and (not (= ?qde ?qdd))
              (not (= ?qde ?asi))
              )
            (not (= ?qdd ?asi))
            )
          (or (or (= ?qdg ?qdf)
              (= ?qdg ?asi)
              )
            (= ?qdf ?asi)
            )
          )
        (and (or (or (= ?qde ?qdd)
              (= ?qde ?asi)
              )
            (= ?qdd ?asi)
            )
          (and (and (not (= ?qdg ?qdf))
              (not (= ?qdg ?asi))
              )
            (not (= ?qdf ?asi))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?qdh Real)
    (declare-const ?qdi Real)
    (declare-const ?qdj Real)
    (assert
      (or (or (= ?qdj ?qdi)
          (= ?qdj ?qdh)
          )
        (= ?qdi ?qdh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qdk Real)
    (declare-const ?qdl Real)
    (declare-const ?qdm Real)
    (declare-const ?qdn Real)
    (assert
      (or (or (= ?qdn ?qdm)
          (= ?qdn ?qdl)
          )
        (= ?qdm ?qdl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qdo Real)
    (declare-const ?qdp Real)
    (declare-const ?qdq Real)
    (declare-const ?qdr Real)
    (declare-const ?qds Real)
    (assert
      (or (or (= ?qds ?qdr)
          (= ?qds ?qdq)
          )
        (= ?qdr ?qdq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qdt Real)
    (declare-const ?qdu Real)
    (declare-const ?qdv Real)
    (declare-const ?qdw Real)
    (declare-const ?qdx Real)
    (declare-const ?qdy Real)
    (assert
      (and (and (and (not (= ?qdv ?qdu))
            (not (= ?qdv ?qdt))
            )
          (not (= ?qdu ?qdt))
          )
        (or (or (= ?qdy ?qdx)
            (= ?qdy ?qdw)
            )
          (= ?qdx ?qdw)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qdz Real)
    (declare-const ?qea Real)
    (declare-const ?qeb Real)
    (assert
      (or (or (= ?qeb ?qea)
          (= ?qeb ?qdz)
          )
        (= ?qea ?qdz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qec Real)
    (declare-const ?qed Real)
    (declare-const ?qee Real)
    (assert
      (or (or (= ?qee ?qed)
          (= ?qee ?qec)
          )
        (= ?qed ?qec)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qef Real)
    (declare-const ?qeg Real)
    (declare-const ?qeh Real)
    (declare-const ?qei Real)
    (assert
      (or (or (= ?qeh ?qeg)
          (= ?qeh ?qef)
          )
        (= ?qeg ?qef)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qej Real)
    (declare-const ?qek Real)
    (declare-const ?qel Real)
    (declare-const ?qem Real)
    (declare-const ?qen Real)
    (assert
      (or (or (= ?qel ?qek)
          (= ?qel ?qej)
          )
        (= ?qek ?qej)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qeo Real)
    (declare-const ?qep Real)
    (declare-const ?qeq Real)
    (declare-const ?qer Real)
    (declare-const ?qes Real)
    (declare-const ?qet Real)
    (assert
      (and (or (or (= ?qeq ?qep)
            (= ?qeq ?qeo)
            )
          (= ?qep ?qeo)
          )
        (and (and (not (= ?qet ?qes))
            (not (= ?qet ?qer))
            )
          (not (= ?qes ?qer))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qeu Real)
    (declare-const ?qev Real)
    (declare-const ?qew Real)
    (assert
      (or (or (= ?qew ?qev)
          (= ?qew ?qeu)
          )
        (= ?qev ?qeu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qex Real)
    (declare-const ?qey Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qez Real)
    (declare-const ?qfa Real)
    (declare-const ?qfb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qfc Real)
    (declare-const ?qfd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qfe Real)
    (declare-const ?qff Real)
    (declare-const ?qfg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qfh Real)
    (declare-const ?qfi Real)
    (declare-const ?qfj Real)
    (declare-const ?qfk Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?qfi ?qfh))
                (not (= ?qfi ?asi))
                )
              (not (= ?qfh ?asi))
              )
            (or (or (= ?qfk ?qfj)
                (= ?qfk ?asi)
                )
              (= ?qfj ?asi)
              )
            )
          (and (or (or (= ?qfi ?qfh)
                (= ?qfi ?asi)
                )
              (= ?qfh ?asi)
              )
            (and (and (not (= ?qfk ?qfj))
                (not (= ?qfk ?asi))
                )
              (not (= ?qfj ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qfl Real)
    (declare-const ?qfm Real)
    (declare-const ?qfn Real)
    (declare-const ?qfo Real)
    (declare-const ?qfp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qfq Real)
    (declare-const ?qfr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qfs Real)
    (declare-const ?qft Real)
    (declare-const ?qfu Real)
    (declare-const ?qfv Real)
    (declare-const ?qfw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qfx Real)
    (declare-const ?qfy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qfz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qga Real)
    (declare-const ?qgb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qgc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qgd Real)
    (declare-const ?qge Real)
    (assert
      (not (= ?qgd ?qge))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qgf Real)
    (declare-const ?qgg Real)
    (declare-const ?qgh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qgi Real)
    (declare-const ?qgj Real)
    (declare-const ?qgk Real)
    (declare-const ?qgl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qgm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qgn Real)
    (declare-const ?qgo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qgp Real)
    (declare-const ?qgq Real)
    (declare-const ?qgr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qgs Real)
    (declare-const ?qgt Real)
    (declare-const ?qgu Real)
    (declare-const ?qgv Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?qgt ?qgs))
                (not (= ?qgt ?fkf))
                )
              (not (= ?qgs ?fkf))
              )
            (or (or (= ?qgv ?qgu)
                (= ?qgv ?fkf)
                )
              (= ?qgu ?fkf)
              )
            )
          (and (or (or (= ?qgt ?qgs)
                (= ?qgt ?fkf)
                )
              (= ?qgs ?fkf)
              )
            (and (and (not (= ?qgv ?qgu))
                (not (= ?qgv ?fkf))
                )
              (not (= ?qgu ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qgw Real)
    (declare-const ?qgx Real)
    (declare-const ?qgy Real)
    (declare-const ?qgz Real)
    (declare-const ?qha Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qhb Real)
    (declare-const ?qhc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qhd Real)
    (declare-const ?qhe Real)
    (declare-const ?qhf Real)
    (declare-const ?qhg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qhh Real)
    (declare-const ?qhi Real)
    (declare-const ?qhj Real)
    (declare-const ?qhk Real)
    (declare-const ?qhl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qhm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qhn Real)
    (declare-const ?qho Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?qhp Real)
  (declare-const ?qhq Real)
  (declare-const ?qhr Real)
  (declare-const ?qhs Real)
  (declare-const ?qht Real)
  (push 1)
    (declare-const ?qhu Real)
    (declare-const ?qhv Real)
    (declare-const ?qhw Real)
    (assert
      (or (or (= ?qhw ?qhv)
          (= ?qhw ?qhu)
          )
        (= ?qhv ?qhu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qhx Real)
    (declare-const ?qhy Real)
    (declare-const ?qhz Real)
    (declare-const ?qia Real)
    (assert
      (or (or (= ?qia ?qhz)
          (= ?qia ?qhy)
          )
        (= ?qhz ?qhy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qib Real)
    (declare-const ?qic Real)
    (declare-const ?qid Real)
    (declare-const ?qie Real)
    (declare-const ?qif Real)
    (assert
      (or (or (= ?qif ?qie)
          (= ?qif ?qid)
          )
        (= ?qie ?qid)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qig Real)
    (declare-const ?qih Real)
    (declare-const ?qii Real)
    (declare-const ?qij Real)
    (declare-const ?qik Real)
    (declare-const ?qil Real)
    (assert
      (and (and (and (not (= ?qii ?qih))
            (not (= ?qii ?qig))
            )
          (not (= ?qih ?qig))
          )
        (or (or (= ?qil ?qik)
            (= ?qil ?qij)
            )
          (= ?qik ?qij)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qim Real)
    (declare-const ?qin Real)
    (declare-const ?qio Real)
    (assert
      (or (or (= ?qio ?qin)
          (= ?qio ?qim)
          )
        (= ?qin ?qim)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qip Real)
    (declare-const ?qiq Real)
    (declare-const ?qir Real)
    (assert
      (or (or (= ?qir ?qiq)
          (= ?qir ?qip)
          )
        (= ?qiq ?qip)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qis Real)
    (declare-const ?qit Real)
    (declare-const ?qiu Real)
    (declare-const ?qiv Real)
    (assert
      (or (or (= ?qiu ?qit)
          (= ?qiu ?qis)
          )
        (= ?qit ?qis)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qiw Real)
    (declare-const ?qix Real)
    (declare-const ?qiy Real)
    (declare-const ?qiz Real)
    (declare-const ?qja Real)
    (assert
      (or (or (= ?qiy ?qix)
          (= ?qiy ?qiw)
          )
        (= ?qix ?qiw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qjb Real)
    (declare-const ?qjc Real)
    (declare-const ?qjd Real)
    (declare-const ?qje Real)
    (declare-const ?qjf Real)
    (declare-const ?qjg Real)
    (assert
      (and (or (or (= ?qjd ?qjc)
            (= ?qjd ?qjb)
            )
          (= ?qjc ?qjb)
          )
        (and (and (not (= ?qjg ?qjf))
            (not (= ?qjg ?qje))
            )
          (not (= ?qjf ?qje))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qjh Real)
    (declare-const ?qji Real)
    (declare-const ?qjj Real)
    (assert
      (or (or (= ?qjj ?qji)
          (= ?qjj ?qjh)
          )
        (= ?qji ?qjh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qjk Real)
    (declare-const ?qjl Real)
    (declare-const ?qjm Real)
    (declare-const ?qjn Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?qjl ?qjk))
                (not (= ?qjl ?asi))
                )
              (not (= ?qjk ?asi))
              )
            (or (or (= ?qjn ?qjm)
                (= ?qjn ?asi)
                )
              (= ?qjm ?asi)
              )
            )
          (and (or (or (= ?qjl ?qjk)
                (= ?qjl ?asi)
                )
              (= ?qjk ?asi)
              )
            (and (and (not (= ?qjn ?qjm))
                (not (= ?qjn ?asi))
                )
              (not (= ?qjm ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qjo Real)
    (declare-const ?qjp Real)
    (declare-const ?qjq Real)
    (declare-const ?qjr Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?qjp ?qjo))
                (not (= ?qjp ?fkf))
                )
              (not (= ?qjo ?fkf))
              )
            (or (or (= ?qjr ?qjq)
                (= ?qjr ?fkf)
                )
              (= ?qjq ?fkf)
              )
            )
          (and (or (or (= ?qjp ?qjo)
                (= ?qjp ?fkf)
                )
              (= ?qjo ?fkf)
              )
            (and (and (not (= ?qjr ?qjq))
                (not (= ?qjr ?fkf))
                )
              (not (= ?qjq ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?qjs Real)
  (declare-const ?qjt Real)
  (push 1)
    (declare-const ?qju Real)
    (declare-const ?qjv Real)
    (declare-const ?qjw Real)
    (assert
      (or (or (= ?qjw ?qjv)
          (= ?qjw ?qju)
          )
        (= ?qjv ?qju)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qjx Real)
    (declare-const ?qjy Real)
    (declare-const ?qjz Real)
    (declare-const ?qka Real)
    (assert
      (or (or (= ?qka ?qjz)
          (= ?qka ?qjy)
          )
        (= ?qjz ?qjy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qkb Real)
    (declare-const ?qkc Real)
    (declare-const ?qkd Real)
    (declare-const ?qke Real)
    (declare-const ?qkf Real)
    (assert
      (or (or (= ?qkf ?qke)
          (= ?qkf ?qkd)
          )
        (= ?qke ?qkd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qkg Real)
    (declare-const ?qkh Real)
    (declare-const ?qki Real)
    (declare-const ?qkj Real)
    (declare-const ?qkk Real)
    (declare-const ?qkl Real)
    (assert
      (and (and (and (not (= ?qki ?qkh))
            (not (= ?qki ?qkg))
            )
          (not (= ?qkh ?qkg))
          )
        (or (or (= ?qkl ?qkk)
            (= ?qkl ?qkj)
            )
          (= ?qkk ?qkj)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qkm Real)
    (declare-const ?qkn Real)
    (declare-const ?qko Real)
    (assert
      (or (or (= ?qko ?qkn)
          (= ?qko ?qkm)
          )
        (= ?qkn ?qkm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qkp Real)
    (declare-const ?qkq Real)
    (declare-const ?qkr Real)
    (assert
      (or (or (= ?qkr ?qkq)
          (= ?qkr ?qkp)
          )
        (= ?qkq ?qkp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qks Real)
    (declare-const ?qkt Real)
    (declare-const ?qku Real)
    (declare-const ?qkv Real)
    (assert
      (or (or (= ?qku ?qkt)
          (= ?qku ?qks)
          )
        (= ?qkt ?qks)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qkw Real)
    (declare-const ?qkx Real)
    (declare-const ?qky Real)
    (declare-const ?qkz Real)
    (declare-const ?qla Real)
    (assert
      (or (or (= ?qky ?qkx)
          (= ?qky ?qkw)
          )
        (= ?qkx ?qkw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qlb Real)
    (declare-const ?qlc Real)
    (declare-const ?qld Real)
    (declare-const ?qle Real)
    (declare-const ?qlf Real)
    (declare-const ?qlg Real)
    (assert
      (and (or (or (= ?qld ?qlc)
            (= ?qld ?qlb)
            )
          (= ?qlc ?qlb)
          )
        (and (and (not (= ?qlg ?qlf))
            (not (= ?qlg ?qle))
            )
          (not (= ?qlf ?qle))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qlh Real)
    (declare-const ?qli Real)
    (declare-const ?qlj Real)
    (assert
      (or (or (= ?qlj ?qli)
          (= ?qlj ?qlh)
          )
        (= ?qli ?qlh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qlk Real)
    (declare-const ?qll Real)
    (declare-const ?qlm Real)
    (declare-const ?qln Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?qll ?qlk))
                (not (= ?qll ?asi))
                )
              (not (= ?qlk ?asi))
              )
            (or (or (= ?qln ?qlm)
                (= ?qln ?asi)
                )
              (= ?qlm ?asi)
              )
            )
          (and (or (or (= ?qll ?qlk)
                (= ?qll ?asi)
                )
              (= ?qlk ?asi)
              )
            (and (and (not (= ?qln ?qlm))
                (not (= ?qln ?asi))
                )
              (not (= ?qlm ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qlo Real)
    (declare-const ?qlp Real)
    (declare-const ?qlq Real)
    (declare-const ?qlr Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?qlp ?qlo))
                (not (= ?qlp ?fkf))
                )
              (not (= ?qlo ?fkf))
              )
            (or (or (= ?qlr ?qlq)
                (= ?qlr ?fkf)
                )
              (= ?qlq ?fkf)
              )
            )
          (and (or (or (= ?qlp ?qlo)
                (= ?qlp ?fkf)
                )
              (= ?qlo ?fkf)
              )
            (and (and (not (= ?qlr ?qlq))
                (not (= ?qlr ?fkf))
                )
              (not (= ?qlq ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?qls Real)
  (declare-const ?qlt Real)
  (declare-const ?qlu Real)
  (declare-const ?qlv Real)
  (declare-const ?qlw Real)
  (push 1)
    (declare-const ?qlx Real)
    (declare-const ?qly Real)
    (declare-const ?qlz Real)
    (assert
      (or (or (= ?qlz ?qly)
          (= ?qlz ?qlx)
          )
        (= ?qly ?qlx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qma Real)
    (declare-const ?qmb Real)
    (declare-const ?qmc Real)
    (declare-const ?qmd Real)
    (assert
      (or (or (= ?qmd ?qmc)
          (= ?qmd ?qmb)
          )
        (= ?qmc ?qmb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qme Real)
    (declare-const ?qmf Real)
    (declare-const ?qmg Real)
    (declare-const ?qmh Real)
    (declare-const ?qmi Real)
    (assert
      (or (or (= ?qmi ?qmh)
          (= ?qmi ?qmg)
          )
        (= ?qmh ?qmg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qmj Real)
    (declare-const ?qmk Real)
    (declare-const ?qml Real)
    (declare-const ?qmm Real)
    (declare-const ?qmn Real)
    (declare-const ?qmo Real)
    (assert
      (and (and (and (not (= ?qml ?qmk))
            (not (= ?qml ?qmj))
            )
          (not (= ?qmk ?qmj))
          )
        (or (or (= ?qmo ?qmn)
            (= ?qmo ?qmm)
            )
          (= ?qmn ?qmm)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qmp Real)
    (declare-const ?qmq Real)
    (declare-const ?qmr Real)
    (assert
      (or (or (= ?qmr ?qmq)
          (= ?qmr ?qmp)
          )
        (= ?qmq ?qmp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qms Real)
    (declare-const ?qmt Real)
    (declare-const ?qmu Real)
    (assert
      (or (or (= ?qmu ?qmt)
          (= ?qmu ?qms)
          )
        (= ?qmt ?qms)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qmv Real)
    (declare-const ?qmw Real)
    (declare-const ?qmx Real)
    (declare-const ?qmy Real)
    (assert
      (or (or (= ?qmx ?qmw)
          (= ?qmx ?qmv)
          )
        (= ?qmw ?qmv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qmz Real)
    (declare-const ?qna Real)
    (declare-const ?qnb Real)
    (declare-const ?qnc Real)
    (declare-const ?qnd Real)
    (assert
      (or (or (= ?qnb ?qna)
          (= ?qnb ?qmz)
          )
        (= ?qna ?qmz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qne Real)
    (declare-const ?qnf Real)
    (declare-const ?qng Real)
    (declare-const ?qnh Real)
    (declare-const ?qni Real)
    (declare-const ?qnj Real)
    (assert
      (and (or (or (= ?qng ?qnf)
            (= ?qng ?qne)
            )
          (= ?qnf ?qne)
          )
        (and (and (not (= ?qnj ?qni))
            (not (= ?qnj ?qnh))
            )
          (not (= ?qni ?qnh))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qnk Real)
    (declare-const ?qnl Real)
    (declare-const ?qnm Real)
    (assert
      (or (or (= ?qnm ?qnl)
          (= ?qnm ?qnk)
          )
        (= ?qnl ?qnk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qnn Real)
    (declare-const ?qno Real)
    (declare-const ?qnp Real)
    (declare-const ?qnq Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?qno ?qnn))
                (not (= ?qno ?asi))
                )
              (not (= ?qnn ?asi))
              )
            (or (or (= ?qnq ?qnp)
                (= ?qnq ?asi)
                )
              (= ?qnp ?asi)
              )
            )
          (and (or (or (= ?qno ?qnn)
                (= ?qno ?asi)
                )
              (= ?qnn ?asi)
              )
            (and (and (not (= ?qnq ?qnp))
                (not (= ?qnq ?asi))
                )
              (not (= ?qnp ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qnr Real)
    (declare-const ?qns Real)
    (declare-const ?qnt Real)
    (declare-const ?qnu Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?qns ?qnr))
                (not (= ?qns ?fkf))
                )
              (not (= ?qnr ?fkf))
              )
            (or (or (= ?qnu ?qnt)
                (= ?qnu ?fkf)
                )
              (= ?qnt ?fkf)
              )
            )
          (and (or (or (= ?qns ?qnr)
                (= ?qns ?fkf)
                )
              (= ?qnr ?fkf)
              )
            (and (and (not (= ?qnu ?qnt))
                (not (= ?qnu ?fkf))
                )
              (not (= ?qnt ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?qnv Real)
  (declare-const ?qnw Real)
  (push 1)
    (declare-const ?qnx Real)
    (declare-const ?qny Real)
    (declare-const ?qnz Real)
    (assert
      (or (or (= ?qnz ?qny)
          (= ?qnz ?qnx)
          )
        (= ?qny ?qnx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qoa Real)
    (declare-const ?qob Real)
    (declare-const ?qoc Real)
    (declare-const ?qod Real)
    (assert
      (or (or (= ?qod ?qoc)
          (= ?qod ?qob)
          )
        (= ?qoc ?qob)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qoe Real)
    (declare-const ?qof Real)
    (declare-const ?qog Real)
    (declare-const ?qoh Real)
    (declare-const ?qoi Real)
    (assert
      (or (or (= ?qoi ?qoh)
          (= ?qoi ?qog)
          )
        (= ?qoh ?qog)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qoj Real)
    (declare-const ?qok Real)
    (declare-const ?qol Real)
    (declare-const ?qom Real)
    (declare-const ?qon Real)
    (declare-const ?qoo Real)
    (assert
      (and (and (and (not (= ?qol ?qok))
            (not (= ?qol ?qoj))
            )
          (not (= ?qok ?qoj))
          )
        (or (or (= ?qoo ?qon)
            (= ?qoo ?qom)
            )
          (= ?qon ?qom)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qop Real)
    (declare-const ?qoq Real)
    (declare-const ?qor Real)
    (assert
      (or (or (= ?qor ?qoq)
          (= ?qor ?qop)
          )
        (= ?qoq ?qop)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qos Real)
    (declare-const ?qot Real)
    (declare-const ?qou Real)
    (assert
      (or (or (= ?qou ?qot)
          (= ?qou ?qos)
          )
        (= ?qot ?qos)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qov Real)
    (declare-const ?qow Real)
    (declare-const ?qox Real)
    (declare-const ?qoy Real)
    (assert
      (or (or (= ?qox ?qow)
          (= ?qox ?qov)
          )
        (= ?qow ?qov)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qoz Real)
    (declare-const ?qpa Real)
    (declare-const ?qpb Real)
    (declare-const ?qpc Real)
    (declare-const ?qpd Real)
    (assert
      (or (or (= ?qpb ?qpa)
          (= ?qpb ?qoz)
          )
        (= ?qpa ?qoz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qpe Real)
    (declare-const ?qpf Real)
    (declare-const ?qpg Real)
    (declare-const ?qph Real)
    (declare-const ?qpi Real)
    (declare-const ?qpj Real)
    (assert
      (and (or (or (= ?qpg ?qpf)
            (= ?qpg ?qpe)
            )
          (= ?qpf ?qpe)
          )
        (and (and (not (= ?qpj ?qpi))
            (not (= ?qpj ?qph))
            )
          (not (= ?qpi ?qph))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qpk Real)
    (declare-const ?qpl Real)
    (declare-const ?qpm Real)
    (assert
      (or (or (= ?qpm ?qpl)
          (= ?qpm ?qpk)
          )
        (= ?qpl ?qpk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qpn Real)
    (declare-const ?qpo Real)
    (declare-const ?qpp Real)
    (declare-const ?qpq Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?qpo ?qpn))
                (not (= ?qpo ?asi))
                )
              (not (= ?qpn ?asi))
              )
            (or (or (= ?qpq ?qpp)
                (= ?qpq ?asi)
                )
              (= ?qpp ?asi)
              )
            )
          (and (or (or (= ?qpo ?qpn)
                (= ?qpo ?asi)
                )
              (= ?qpn ?asi)
              )
            (and (and (not (= ?qpq ?qpp))
                (not (= ?qpq ?asi))
                )
              (not (= ?qpp ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qpr Real)
    (declare-const ?qps Real)
    (declare-const ?qpt Real)
    (declare-const ?qpu Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?qps ?qpr))
                (not (= ?qps ?fkf))
                )
              (not (= ?qpr ?fkf))
              )
            (or (or (= ?qpu ?qpt)
                (= ?qpu ?fkf)
                )
              (= ?qpt ?fkf)
              )
            )
          (and (or (or (= ?qps ?qpr)
                (= ?qps ?fkf)
                )
              (= ?qpr ?fkf)
              )
            (and (and (not (= ?qpu ?qpt))
                (not (= ?qpu ?fkf))
                )
              (not (= ?qpt ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?qpv Real)
  (push 1)
    (declare-const ?qpw Real)
    (declare-const ?qpx Real)
    (declare-const ?qpy Real)
    (assert
      (or (or (= ?qpy ?qpx)
          (= ?qpy ?qpw)
          )
        (= ?qpx ?qpw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qpz Real)
    (declare-const ?qqa Real)
    (declare-const ?qqb Real)
    (declare-const ?qqc Real)
    (assert
      (or (or (= ?qqc ?qqb)
          (= ?qqc ?qqa)
          )
        (= ?qqb ?qqa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qqd Real)
    (declare-const ?qqe Real)
    (declare-const ?qqf Real)
    (declare-const ?qqg Real)
    (declare-const ?qqh Real)
    (assert
      (or (or (= ?qqh ?qqg)
          (= ?qqh ?qqf)
          )
        (= ?qqg ?qqf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qqi Real)
    (declare-const ?qqj Real)
    (declare-const ?qqk Real)
    (declare-const ?qql Real)
    (declare-const ?qqm Real)
    (declare-const ?qqn Real)
    (assert
      (and (and (and (not (= ?qqk ?qqj))
            (not (= ?qqk ?qqi))
            )
          (not (= ?qqj ?qqi))
          )
        (or (or (= ?qqn ?qqm)
            (= ?qqn ?qql)
            )
          (= ?qqm ?qql)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qqo Real)
    (declare-const ?qqp Real)
    (declare-const ?qqq Real)
    (assert
      (or (or (= ?qqq ?qqp)
          (= ?qqq ?qqo)
          )
        (= ?qqp ?qqo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qqr Real)
    (declare-const ?qqs Real)
    (declare-const ?qqt Real)
    (assert
      (or (or (= ?qqt ?qqs)
          (= ?qqt ?qqr)
          )
        (= ?qqs ?qqr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qqu Real)
    (declare-const ?qqv Real)
    (declare-const ?qqw Real)
    (declare-const ?qqx Real)
    (assert
      (or (or (= ?qqw ?qqv)
          (= ?qqw ?qqu)
          )
        (= ?qqv ?qqu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qqy Real)
    (declare-const ?qqz Real)
    (declare-const ?qra Real)
    (declare-const ?qrb Real)
    (declare-const ?qrc Real)
    (assert
      (or (or (= ?qra ?qqz)
          (= ?qra ?qqy)
          )
        (= ?qqz ?qqy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qrd Real)
    (declare-const ?qre Real)
    (declare-const ?qrf Real)
    (declare-const ?qrg Real)
    (declare-const ?qrh Real)
    (declare-const ?qri Real)
    (assert
      (and (or (or (= ?qrf ?qre)
            (= ?qrf ?qrd)
            )
          (= ?qre ?qrd)
          )
        (and (and (not (= ?qri ?qrh))
            (not (= ?qri ?qrg))
            )
          (not (= ?qrh ?qrg))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qrj Real)
    (declare-const ?qrk Real)
    (declare-const ?qrl Real)
    (assert
      (or (or (= ?qrl ?qrk)
          (= ?qrl ?qrj)
          )
        (= ?qrk ?qrj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qrm Real)
    (declare-const ?qrn Real)
    (declare-const ?qro Real)
    (declare-const ?qrp Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?qrn ?qrm))
                (not (= ?qrn ?asi))
                )
              (not (= ?qrm ?asi))
              )
            (or (or (= ?qrp ?qro)
                (= ?qrp ?asi)
                )
              (= ?qro ?asi)
              )
            )
          (and (or (or (= ?qrn ?qrm)
                (= ?qrn ?asi)
                )
              (= ?qrm ?asi)
              )
            (and (and (not (= ?qrp ?qro))
                (not (= ?qrp ?asi))
                )
              (not (= ?qro ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qrq Real)
    (declare-const ?qrr Real)
    (declare-const ?qrs Real)
    (declare-const ?qrt Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?qrr ?qrq))
                (not (= ?qrr ?fkf))
                )
              (not (= ?qrq ?fkf))
              )
            (or (or (= ?qrt ?qrs)
                (= ?qrt ?fkf)
                )
              (= ?qrs ?fkf)
              )
            )
          (and (or (or (= ?qrr ?qrq)
                (= ?qrr ?fkf)
                )
              (= ?qrq ?fkf)
              )
            (and (and (not (= ?qrt ?qrs))
                (not (= ?qrt ?fkf))
                )
              (not (= ?qrs ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?qru Real)
  (declare-const ?qrv Real)
  (push 1)
    (declare-const ?qrw Real)
    (declare-const ?qrx Real)
    (declare-const ?qry Real)
    (assert
      (or (or (= ?qry ?qrx)
          (= ?qry ?qrw)
          )
        (= ?qrx ?qrw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qrz Real)
    (declare-const ?qsa Real)
    (declare-const ?qsb Real)
    (declare-const ?qsc Real)
    (assert
      (or (or (= ?qsc ?qsb)
          (= ?qsc ?qsa)
          )
        (= ?qsb ?qsa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qsd Real)
    (declare-const ?qse Real)
    (declare-const ?qsf Real)
    (declare-const ?qsg Real)
    (declare-const ?qsh Real)
    (assert
      (or (or (= ?qsh ?qsg)
          (= ?qsh ?qsf)
          )
        (= ?qsg ?qsf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qsi Real)
    (declare-const ?qsj Real)
    (declare-const ?qsk Real)
    (declare-const ?qsl Real)
    (declare-const ?qsm Real)
    (declare-const ?qsn Real)
    (assert
      (and (and (and (not (= ?qsk ?qsj))
            (not (= ?qsk ?qsi))
            )
          (not (= ?qsj ?qsi))
          )
        (or (or (= ?qsn ?qsm)
            (= ?qsn ?qsl)
            )
          (= ?qsm ?qsl)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qso Real)
    (declare-const ?qsp Real)
    (declare-const ?qsq Real)
    (assert
      (or (or (= ?qsq ?qsp)
          (= ?qsq ?qso)
          )
        (= ?qsp ?qso)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qsr Real)
    (declare-const ?qss Real)
    (declare-const ?qst Real)
    (assert
      (or (or (= ?qst ?qss)
          (= ?qst ?qsr)
          )
        (= ?qss ?qsr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qsu Real)
    (declare-const ?qsv Real)
    (declare-const ?qsw Real)
    (declare-const ?qsx Real)
    (assert
      (or (or (= ?qsw ?qsv)
          (= ?qsw ?qsu)
          )
        (= ?qsv ?qsu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qsy Real)
    (declare-const ?qsz Real)
    (declare-const ?qta Real)
    (declare-const ?qtb Real)
    (declare-const ?qtc Real)
    (assert
      (or (or (= ?qta ?qsz)
          (= ?qta ?qsy)
          )
        (= ?qsz ?qsy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qtd Real)
    (declare-const ?qte Real)
    (declare-const ?qtf Real)
    (declare-const ?qtg Real)
    (declare-const ?qth Real)
    (declare-const ?qti Real)
    (assert
      (and (or (or (= ?qtf ?qte)
            (= ?qtf ?qtd)
            )
          (= ?qte ?qtd)
          )
        (and (and (not (= ?qti ?qth))
            (not (= ?qti ?qtg))
            )
          (not (= ?qth ?qtg))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qtj Real)
    (declare-const ?qtk Real)
    (declare-const ?qtl Real)
    (assert
      (or (or (= ?qtl ?qtk)
          (= ?qtl ?qtj)
          )
        (= ?qtk ?qtj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qtm Real)
    (declare-const ?qtn Real)
    (declare-const ?qto Real)
    (declare-const ?qtp Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?qtn ?qtm))
                (not (= ?qtn ?asi))
                )
              (not (= ?qtm ?asi))
              )
            (or (or (= ?qtp ?qto)
                (= ?qtp ?asi)
                )
              (= ?qto ?asi)
              )
            )
          (and (or (or (= ?qtn ?qtm)
                (= ?qtn ?asi)
                )
              (= ?qtm ?asi)
              )
            (and (and (not (= ?qtp ?qto))
                (not (= ?qtp ?asi))
                )
              (not (= ?qto ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qtq Real)
    (declare-const ?qtr Real)
    (declare-const ?qts Real)
    (declare-const ?qtt Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?qtr ?qtq))
                (not (= ?qtr ?fkf))
                )
              (not (= ?qtq ?fkf))
              )
            (or (or (= ?qtt ?qts)
                (= ?qtt ?fkf)
                )
              (= ?qts ?fkf)
              )
            )
          (and (or (or (= ?qtr ?qtq)
                (= ?qtr ?fkf)
                )
              (= ?qtq ?fkf)
              )
            (and (and (not (= ?qtt ?qts))
                (not (= ?qtt ?fkf))
                )
              (not (= ?qts ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?qtu Real)
  (push 1)
    (declare-const ?qtv Real)
    (declare-const ?qtw Real)
    (declare-const ?qtx Real)
    (assert
      (or (or (= ?qtx ?qtw)
          (= ?qtx ?qtv)
          )
        (= ?qtw ?qtv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qty Real)
    (declare-const ?qtz Real)
    (declare-const ?qua Real)
    (declare-const ?qub Real)
    (assert
      (or (or (= ?qub ?qua)
          (= ?qub ?qtz)
          )
        (= ?qua ?qtz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?quc Real)
    (declare-const ?qud Real)
    (declare-const ?que Real)
    (declare-const ?quf Real)
    (declare-const ?qug Real)
    (assert
      (or (or (= ?qug ?quf)
          (= ?qug ?que)
          )
        (= ?quf ?que)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?quh Real)
    (declare-const ?qui Real)
    (declare-const ?quj Real)
    (declare-const ?quk Real)
    (declare-const ?qul Real)
    (declare-const ?qum Real)
    (assert
      (and (and (and (not (= ?quj ?qui))
            (not (= ?quj ?quh))
            )
          (not (= ?qui ?quh))
          )
        (or (or (= ?qum ?qul)
            (= ?qum ?quk)
            )
          (= ?qul ?quk)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qun Real)
    (declare-const ?quo Real)
    (declare-const ?qup Real)
    (assert
      (or (or (= ?qup ?quo)
          (= ?qup ?qun)
          )
        (= ?quo ?qun)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?quq Real)
    (declare-const ?qur Real)
    (declare-const ?qus Real)
    (assert
      (or (or (= ?qus ?qur)
          (= ?qus ?quq)
          )
        (= ?qur ?quq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qut Real)
    (declare-const ?quu Real)
    (declare-const ?quv Real)
    (declare-const ?quw Real)
    (assert
      (or (or (= ?quv ?quu)
          (= ?quv ?qut)
          )
        (= ?quu ?qut)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qux Real)
    (declare-const ?quy Real)
    (declare-const ?quz Real)
    (declare-const ?qva Real)
    (declare-const ?qvb Real)
    (assert
      (or (or (= ?quz ?quy)
          (= ?quz ?qux)
          )
        (= ?quy ?qux)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qvc Real)
    (declare-const ?qvd Real)
    (declare-const ?qve Real)
    (declare-const ?qvf Real)
    (declare-const ?qvg Real)
    (declare-const ?qvh Real)
    (assert
      (and (or (or (= ?qve ?qvd)
            (= ?qve ?qvc)
            )
          (= ?qvd ?qvc)
          )
        (and (and (not (= ?qvh ?qvg))
            (not (= ?qvh ?qvf))
            )
          (not (= ?qvg ?qvf))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qvi Real)
    (declare-const ?qvj Real)
    (declare-const ?qvk Real)
    (assert
      (or (or (= ?qvk ?qvj)
          (= ?qvk ?qvi)
          )
        (= ?qvj ?qvi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qvl Real)
    (declare-const ?qvm Real)
    (declare-const ?qvn Real)
    (declare-const ?qvo Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?qvm ?qvl))
                (not (= ?qvm ?asi))
                )
              (not (= ?qvl ?asi))
              )
            (or (or (= ?qvo ?qvn)
                (= ?qvo ?asi)
                )
              (= ?qvn ?asi)
              )
            )
          (and (or (or (= ?qvm ?qvl)
                (= ?qvm ?asi)
                )
              (= ?qvl ?asi)
              )
            (and (and (not (= ?qvo ?qvn))
                (not (= ?qvo ?asi))
                )
              (not (= ?qvn ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qvp Real)
    (declare-const ?qvq Real)
    (declare-const ?qvr Real)
    (declare-const ?qvs Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?qvq ?qvp))
                (not (= ?qvq ?fkf))
                )
              (not (= ?qvp ?fkf))
              )
            (or (or (= ?qvs ?qvr)
                (= ?qvs ?fkf)
                )
              (= ?qvr ?fkf)
              )
            )
          (and (or (or (= ?qvq ?qvp)
                (= ?qvq ?fkf)
                )
              (= ?qvp ?fkf)
              )
            (and (and (not (= ?qvs ?qvr))
                (not (= ?qvs ?fkf))
                )
              (not (= ?qvr ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?qvt Real)
  (declare-const ?qvu Real)
  (assert
    (not (= ?qvt ?qvu))
    )
  (push 1)
    (declare-const ?qvv Real)
    (declare-const ?qvw Real)
    (declare-const ?qvx Real)
    (assert
      (or (or (= ?qvx ?qvw)
          (= ?qvx ?qvv)
          )
        (= ?qvw ?qvv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qvy Real)
    (declare-const ?qvz Real)
    (declare-const ?qwa Real)
    (declare-const ?qwb Real)
    (assert
      (or (or (= ?qwb ?qwa)
          (= ?qwb ?qvz)
          )
        (= ?qwa ?qvz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qwc Real)
    (declare-const ?qwd Real)
    (declare-const ?qwe Real)
    (declare-const ?qwf Real)
    (declare-const ?qwg Real)
    (assert
      (or (or (= ?qwg ?qwf)
          (= ?qwg ?qwe)
          )
        (= ?qwf ?qwe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qwh Real)
    (declare-const ?qwi Real)
    (declare-const ?qwj Real)
    (declare-const ?qwk Real)
    (declare-const ?qwl Real)
    (declare-const ?qwm Real)
    (assert
      (and (and (and (not (= ?qwj ?qwi))
            (not (= ?qwj ?qwh))
            )
          (not (= ?qwi ?qwh))
          )
        (or (or (= ?qwm ?qwl)
            (= ?qwm ?qwk)
            )
          (= ?qwl ?qwk)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qwn Real)
    (declare-const ?qwo Real)
    (declare-const ?qwp Real)
    (assert
      (or (or (= ?qwp ?qwo)
          (= ?qwp ?qwn)
          )
        (= ?qwo ?qwn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qwq Real)
    (declare-const ?qwr Real)
    (declare-const ?qws Real)
    (assert
      (or (or (= ?qws ?qwr)
          (= ?qws ?qwq)
          )
        (= ?qwr ?qwq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qwt Real)
    (declare-const ?qwu Real)
    (declare-const ?qwv Real)
    (declare-const ?qww Real)
    (assert
      (or (or (= ?qwv ?qwu)
          (= ?qwv ?qwt)
          )
        (= ?qwu ?qwt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qwx Real)
    (declare-const ?qwy Real)
    (declare-const ?qwz Real)
    (declare-const ?qxa Real)
    (declare-const ?qxb Real)
    (assert
      (or (or (= ?qwz ?qwy)
          (= ?qwz ?qwx)
          )
        (= ?qwy ?qwx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qxc Real)
    (declare-const ?qxd Real)
    (declare-const ?qxe Real)
    (declare-const ?qxf Real)
    (declare-const ?qxg Real)
    (declare-const ?qxh Real)
    (assert
      (and (or (or (= ?qxe ?qxd)
            (= ?qxe ?qxc)
            )
          (= ?qxd ?qxc)
          )
        (and (and (not (= ?qxh ?qxg))
            (not (= ?qxh ?qxf))
            )
          (not (= ?qxg ?qxf))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qxi Real)
    (declare-const ?qxj Real)
    (declare-const ?qxk Real)
    (assert
      (or (or (= ?qxk ?qxj)
          (= ?qxk ?qxi)
          )
        (= ?qxj ?qxi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qxl Real)
    (declare-const ?qxm Real)
    (declare-const ?qxn Real)
    (declare-const ?qxo Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?qxm ?qxl))
                (not (= ?qxm ?asi))
                )
              (not (= ?qxl ?asi))
              )
            (or (or (= ?qxo ?qxn)
                (= ?qxo ?asi)
                )
              (= ?qxn ?asi)
              )
            )
          (and (or (or (= ?qxm ?qxl)
                (= ?qxm ?asi)
                )
              (= ?qxl ?asi)
              )
            (and (and (not (= ?qxo ?qxn))
                (not (= ?qxo ?asi))
                )
              (not (= ?qxn ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qxp Real)
    (declare-const ?qxq Real)
    (declare-const ?qxr Real)
    (declare-const ?qxs Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?qxq ?qxp))
                (not (= ?qxq ?fkf))
                )
              (not (= ?qxp ?fkf))
              )
            (or (or (= ?qxs ?qxr)
                (= ?qxs ?fkf)
                )
              (= ?qxr ?fkf)
              )
            )
          (and (or (or (= ?qxq ?qxp)
                (= ?qxq ?fkf)
                )
              (= ?qxp ?fkf)
              )
            (and (and (not (= ?qxs ?qxr))
                (not (= ?qxs ?fkf))
                )
              (not (= ?qxr ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?qxt Real)
  (declare-const ?qxu Real)
  (declare-const ?qxv Real)
  (push 1)
    (declare-const ?qxw Real)
    (declare-const ?qxx Real)
    (declare-const ?qxy Real)
    (assert
      (or (or (= ?qxy ?qxx)
          (= ?qxy ?qxw)
          )
        (= ?qxx ?qxw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qxz Real)
    (declare-const ?qya Real)
    (declare-const ?qyb Real)
    (declare-const ?qyc Real)
    (assert
      (or (or (= ?qyc ?qyb)
          (= ?qyc ?qya)
          )
        (= ?qyb ?qya)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qyd Real)
    (declare-const ?qye Real)
    (declare-const ?qyf Real)
    (declare-const ?qyg Real)
    (declare-const ?qyh Real)
    (assert
      (or (or (= ?qyh ?qyg)
          (= ?qyh ?qyf)
          )
        (= ?qyg ?qyf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qyi Real)
    (declare-const ?qyj Real)
    (declare-const ?qyk Real)
    (declare-const ?qyl Real)
    (declare-const ?qym Real)
    (declare-const ?qyn Real)
    (assert
      (and (and (and (not (= ?qyk ?qyj))
            (not (= ?qyk ?qyi))
            )
          (not (= ?qyj ?qyi))
          )
        (or (or (= ?qyn ?qym)
            (= ?qyn ?qyl)
            )
          (= ?qym ?qyl)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qyo Real)
    (declare-const ?qyp Real)
    (declare-const ?qyq Real)
    (assert
      (or (or (= ?qyq ?qyp)
          (= ?qyq ?qyo)
          )
        (= ?qyp ?qyo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qyr Real)
    (declare-const ?qys Real)
    (declare-const ?qyt Real)
    (assert
      (or (or (= ?qyt ?qys)
          (= ?qyt ?qyr)
          )
        (= ?qys ?qyr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qyu Real)
    (declare-const ?qyv Real)
    (declare-const ?qyw Real)
    (declare-const ?qyx Real)
    (assert
      (or (or (= ?qyw ?qyv)
          (= ?qyw ?qyu)
          )
        (= ?qyv ?qyu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qyy Real)
    (declare-const ?qyz Real)
    (declare-const ?qza Real)
    (declare-const ?qzb Real)
    (declare-const ?qzc Real)
    (assert
      (or (or (= ?qza ?qyz)
          (= ?qza ?qyy)
          )
        (= ?qyz ?qyy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qzd Real)
    (declare-const ?qze Real)
    (declare-const ?qzf Real)
    (declare-const ?qzg Real)
    (declare-const ?qzh Real)
    (declare-const ?qzi Real)
    (assert
      (and (or (or (= ?qzf ?qze)
            (= ?qzf ?qzd)
            )
          (= ?qze ?qzd)
          )
        (and (and (not (= ?qzi ?qzh))
            (not (= ?qzi ?qzg))
            )
          (not (= ?qzh ?qzg))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qzj Real)
    (declare-const ?qzk Real)
    (declare-const ?qzl Real)
    (assert
      (or (or (= ?qzl ?qzk)
          (= ?qzl ?qzj)
          )
        (= ?qzk ?qzj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qzm Real)
    (declare-const ?qzn Real)
    (declare-const ?qzo Real)
    (declare-const ?qzp Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?qzn ?qzm))
                (not (= ?qzn ?asi))
                )
              (not (= ?qzm ?asi))
              )
            (or (or (= ?qzp ?qzo)
                (= ?qzp ?asi)
                )
              (= ?qzo ?asi)
              )
            )
          (and (or (or (= ?qzn ?qzm)
                (= ?qzn ?asi)
                )
              (= ?qzm ?asi)
              )
            (and (and (not (= ?qzp ?qzo))
                (not (= ?qzp ?asi))
                )
              (not (= ?qzo ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?qzq Real)
    (declare-const ?qzr Real)
    (declare-const ?qzs Real)
    (declare-const ?qzt Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?qzr ?qzq))
                (not (= ?qzr ?fkf))
                )
              (not (= ?qzq ?fkf))
              )
            (or (or (= ?qzt ?qzs)
                (= ?qzt ?fkf)
                )
              (= ?qzs ?fkf)
              )
            )
          (and (or (or (= ?qzr ?qzq)
                (= ?qzr ?fkf)
                )
              (= ?qzq ?fkf)
              )
            (and (and (not (= ?qzt ?qzs))
                (not (= ?qzt ?fkf))
                )
              (not (= ?qzs ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?qzu Real)
  (declare-const ?qzv Real)
  (declare-const ?qzw Real)
  (declare-const ?qzx Real)
  (push 1)
    (declare-const ?qzy Real)
    (declare-const ?qzz Real)
    (declare-const ?raa Real)
    (assert
      (or (or (= ?raa ?qzz)
          (= ?raa ?qzy)
          )
        (= ?qzz ?qzy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rab Real)
    (declare-const ?rac Real)
    (declare-const ?rad Real)
    (declare-const ?rae Real)
    (assert
      (or (or (= ?rae ?rad)
          (= ?rae ?rac)
          )
        (= ?rad ?rac)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?raf Real)
    (declare-const ?rag Real)
    (declare-const ?rah Real)
    (declare-const ?rai Real)
    (declare-const ?raj Real)
    (assert
      (or (or (= ?raj ?rai)
          (= ?raj ?rah)
          )
        (= ?rai ?rah)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rak Real)
    (declare-const ?ral Real)
    (declare-const ?ram Real)
    (declare-const ?ran Real)
    (declare-const ?rao Real)
    (declare-const ?rap Real)
    (assert
      (and (and (and (not (= ?ram ?ral))
            (not (= ?ram ?rak))
            )
          (not (= ?ral ?rak))
          )
        (or (or (= ?rap ?rao)
            (= ?rap ?ran)
            )
          (= ?rao ?ran)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?raq Real)
    (declare-const ?rar Real)
    (declare-const ?ras Real)
    (assert
      (or (or (= ?ras ?rar)
          (= ?ras ?raq)
          )
        (= ?rar ?raq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rat Real)
    (declare-const ?rau Real)
    (declare-const ?rav Real)
    (assert
      (or (or (= ?rav ?rau)
          (= ?rav ?rat)
          )
        (= ?rau ?rat)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?raw Real)
    (declare-const ?rax Real)
    (declare-const ?ray Real)
    (declare-const ?raz Real)
    (assert
      (or (or (= ?ray ?rax)
          (= ?ray ?raw)
          )
        (= ?rax ?raw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rba Real)
    (declare-const ?rbb Real)
    (declare-const ?rbc Real)
    (declare-const ?rbd Real)
    (declare-const ?rbe Real)
    (assert
      (or (or (= ?rbc ?rbb)
          (= ?rbc ?rba)
          )
        (= ?rbb ?rba)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rbf Real)
    (declare-const ?rbg Real)
    (declare-const ?rbh Real)
    (declare-const ?rbi Real)
    (declare-const ?rbj Real)
    (declare-const ?rbk Real)
    (assert
      (and (or (or (= ?rbh ?rbg)
            (= ?rbh ?rbf)
            )
          (= ?rbg ?rbf)
          )
        (and (and (not (= ?rbk ?rbj))
            (not (= ?rbk ?rbi))
            )
          (not (= ?rbj ?rbi))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rbl Real)
    (declare-const ?rbm Real)
    (declare-const ?rbn Real)
    (assert
      (or (or (= ?rbn ?rbm)
          (= ?rbn ?rbl)
          )
        (= ?rbm ?rbl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rbo Real)
    (declare-const ?rbp Real)
    (declare-const ?rbq Real)
    (declare-const ?rbr Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?rbp ?rbo))
                (not (= ?rbp ?asi))
                )
              (not (= ?rbo ?asi))
              )
            (or (or (= ?rbr ?rbq)
                (= ?rbr ?asi)
                )
              (= ?rbq ?asi)
              )
            )
          (and (or (or (= ?rbp ?rbo)
                (= ?rbp ?asi)
                )
              (= ?rbo ?asi)
              )
            (and (and (not (= ?rbr ?rbq))
                (not (= ?rbr ?asi))
                )
              (not (= ?rbq ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rbs Real)
    (declare-const ?rbt Real)
    (declare-const ?rbu Real)
    (declare-const ?rbv Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?rbt ?rbs))
                (not (= ?rbt ?fkf))
                )
              (not (= ?rbs ?fkf))
              )
            (or (or (= ?rbv ?rbu)
                (= ?rbv ?fkf)
                )
              (= ?rbu ?fkf)
              )
            )
          (and (or (or (= ?rbt ?rbs)
                (= ?rbt ?fkf)
                )
              (= ?rbs ?fkf)
              )
            (and (and (not (= ?rbv ?rbu))
                (not (= ?rbv ?fkf))
                )
              (not (= ?rbu ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?rbw Real)
  (push 1)
    (declare-const ?rbx Real)
    (declare-const ?rby Real)
    (declare-const ?rbz Real)
    (assert
      (or (or (= ?rbz ?rby)
          (= ?rbz ?rbx)
          )
        (= ?rby ?rbx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rca Real)
    (declare-const ?rcb Real)
    (declare-const ?rcc Real)
    (declare-const ?rcd Real)
    (assert
      (or (or (= ?rcd ?rcc)
          (= ?rcd ?rcb)
          )
        (= ?rcc ?rcb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rce Real)
    (declare-const ?rcf Real)
    (declare-const ?rcg Real)
    (declare-const ?rch Real)
    (declare-const ?rci Real)
    (assert
      (or (or (= ?rci ?rch)
          (= ?rci ?rcg)
          )
        (= ?rch ?rcg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rcj Real)
    (declare-const ?rck Real)
    (declare-const ?rcl Real)
    (declare-const ?rcm Real)
    (declare-const ?rcn Real)
    (declare-const ?rco Real)
    (assert
      (and (and (and (not (= ?rcl ?rck))
            (not (= ?rcl ?rcj))
            )
          (not (= ?rck ?rcj))
          )
        (or (or (= ?rco ?rcn)
            (= ?rco ?rcm)
            )
          (= ?rcn ?rcm)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rcp Real)
    (declare-const ?rcq Real)
    (declare-const ?rcr Real)
    (assert
      (or (or (= ?rcr ?rcq)
          (= ?rcr ?rcp)
          )
        (= ?rcq ?rcp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rcs Real)
    (declare-const ?rct Real)
    (declare-const ?rcu Real)
    (assert
      (or (or (= ?rcu ?rct)
          (= ?rcu ?rcs)
          )
        (= ?rct ?rcs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rcv Real)
    (declare-const ?rcw Real)
    (declare-const ?rcx Real)
    (declare-const ?rcy Real)
    (assert
      (or (or (= ?rcx ?rcw)
          (= ?rcx ?rcv)
          )
        (= ?rcw ?rcv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rcz Real)
    (declare-const ?rda Real)
    (declare-const ?rdb Real)
    (declare-const ?rdc Real)
    (declare-const ?rdd Real)
    (assert
      (or (or (= ?rdb ?rda)
          (= ?rdb ?rcz)
          )
        (= ?rda ?rcz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rde Real)
    (declare-const ?rdf Real)
    (declare-const ?rdg Real)
    (declare-const ?rdh Real)
    (declare-const ?rdi Real)
    (declare-const ?rdj Real)
    (assert
      (and (or (or (= ?rdg ?rdf)
            (= ?rdg ?rde)
            )
          (= ?rdf ?rde)
          )
        (and (and (not (= ?rdj ?rdi))
            (not (= ?rdj ?rdh))
            )
          (not (= ?rdi ?rdh))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rdk Real)
    (declare-const ?rdl Real)
    (declare-const ?rdm Real)
    (assert
      (or (or (= ?rdm ?rdl)
          (= ?rdm ?rdk)
          )
        (= ?rdl ?rdk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rdn Real)
    (declare-const ?rdo Real)
    (declare-const ?rdp Real)
    (declare-const ?rdq Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?rdo ?rdn))
                (not (= ?rdo ?asi))
                )
              (not (= ?rdn ?asi))
              )
            (or (or (= ?rdq ?rdp)
                (= ?rdq ?asi)
                )
              (= ?rdp ?asi)
              )
            )
          (and (or (or (= ?rdo ?rdn)
                (= ?rdo ?asi)
                )
              (= ?rdn ?asi)
              )
            (and (and (not (= ?rdq ?rdp))
                (not (= ?rdq ?asi))
                )
              (not (= ?rdp ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rdr Real)
    (declare-const ?rds Real)
    (declare-const ?rdt Real)
    (declare-const ?rdu Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?rds ?rdr))
                (not (= ?rds ?fkf))
                )
              (not (= ?rdr ?fkf))
              )
            (or (or (= ?rdu ?rdt)
                (= ?rdu ?fkf)
                )
              (= ?rdt ?fkf)
              )
            )
          (and (or (or (= ?rds ?rdr)
                (= ?rds ?fkf)
                )
              (= ?rdr ?fkf)
              )
            (and (and (not (= ?rdu ?rdt))
                (not (= ?rdu ?fkf))
                )
              (not (= ?rdt ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?rdv Real)
  (declare-const ?rdw Real)
  (push 1)
    (declare-const ?rdx Real)
    (declare-const ?rdy Real)
    (declare-const ?rdz Real)
    (assert
      (or (or (= ?rdz ?rdy)
          (= ?rdz ?rdx)
          )
        (= ?rdy ?rdx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rea Real)
    (declare-const ?reb Real)
    (declare-const ?rec Real)
    (declare-const ?red Real)
    (assert
      (or (or (= ?red ?rec)
          (= ?red ?reb)
          )
        (= ?rec ?reb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ree Real)
    (declare-const ?ref Real)
    (declare-const ?reg Real)
    (declare-const ?reh Real)
    (declare-const ?rei Real)
    (assert
      (or (or (= ?rei ?reh)
          (= ?rei ?reg)
          )
        (= ?reh ?reg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rej Real)
    (declare-const ?rek Real)
    (declare-const ?rel Real)
    (declare-const ?rem Real)
    (declare-const ?ren Real)
    (declare-const ?reo Real)
    (assert
      (and (and (and (not (= ?rel ?rek))
            (not (= ?rel ?rej))
            )
          (not (= ?rek ?rej))
          )
        (or (or (= ?reo ?ren)
            (= ?reo ?rem)
            )
          (= ?ren ?rem)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rep Real)
    (declare-const ?req Real)
    (declare-const ?rer Real)
    (assert
      (or (or (= ?rer ?req)
          (= ?rer ?rep)
          )
        (= ?req ?rep)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?res Real)
    (declare-const ?ret Real)
    (declare-const ?reu Real)
    (assert
      (or (or (= ?reu ?ret)
          (= ?reu ?res)
          )
        (= ?ret ?res)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rev Real)
    (declare-const ?rew Real)
    (declare-const ?rex Real)
    (declare-const ?rey Real)
    (assert
      (or (or (= ?rex ?rew)
          (= ?rex ?rev)
          )
        (= ?rew ?rev)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rez Real)
    (declare-const ?rfa Real)
    (declare-const ?rfb Real)
    (declare-const ?rfc Real)
    (declare-const ?rfd Real)
    (assert
      (or (or (= ?rfb ?rfa)
          (= ?rfb ?rez)
          )
        (= ?rfa ?rez)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rfe Real)
    (declare-const ?rff Real)
    (declare-const ?rfg Real)
    (declare-const ?rfh Real)
    (declare-const ?rfi Real)
    (declare-const ?rfj Real)
    (assert
      (and (or (or (= ?rfg ?rff)
            (= ?rfg ?rfe)
            )
          (= ?rff ?rfe)
          )
        (and (and (not (= ?rfj ?rfi))
            (not (= ?rfj ?rfh))
            )
          (not (= ?rfi ?rfh))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rfk Real)
    (declare-const ?rfl Real)
    (declare-const ?rfm Real)
    (assert
      (or (or (= ?rfm ?rfl)
          (= ?rfm ?rfk)
          )
        (= ?rfl ?rfk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rfn Real)
    (declare-const ?rfo Real)
    (declare-const ?rfp Real)
    (declare-const ?rfq Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?rfo ?rfn))
                (not (= ?rfo ?asi))
                )
              (not (= ?rfn ?asi))
              )
            (or (or (= ?rfq ?rfp)
                (= ?rfq ?asi)
                )
              (= ?rfp ?asi)
              )
            )
          (and (or (or (= ?rfo ?rfn)
                (= ?rfo ?asi)
                )
              (= ?rfn ?asi)
              )
            (and (and (not (= ?rfq ?rfp))
                (not (= ?rfq ?asi))
                )
              (not (= ?rfp ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rfr Real)
    (declare-const ?rfs Real)
    (declare-const ?rft Real)
    (declare-const ?rfu Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?rfs ?rfr))
                (not (= ?rfs ?fkf))
                )
              (not (= ?rfr ?fkf))
              )
            (or (or (= ?rfu ?rft)
                (= ?rfu ?fkf)
                )
              (= ?rft ?fkf)
              )
            )
          (and (or (or (= ?rfs ?rfr)
                (= ?rfs ?fkf)
                )
              (= ?rfr ?fkf)
              )
            (and (and (not (= ?rfu ?rft))
                (not (= ?rfu ?fkf))
                )
              (not (= ?rft ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?rfv Real)
  (declare-const ?rfw Real)
  (declare-const ?rfx Real)
  (push 1)
    (declare-const ?rfy Real)
    (declare-const ?rfz Real)
    (declare-const ?rga Real)
    (assert
      (or (or (= ?rga ?rfz)
          (= ?rga ?rfy)
          )
        (= ?rfz ?rfy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rgb Real)
    (declare-const ?rgc Real)
    (declare-const ?rgd Real)
    (declare-const ?rge Real)
    (assert
      (or (or (= ?rge ?rgd)
          (= ?rge ?rgc)
          )
        (= ?rgd ?rgc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rgf Real)
    (declare-const ?rgg Real)
    (declare-const ?rgh Real)
    (declare-const ?rgi Real)
    (declare-const ?rgj Real)
    (assert
      (or (or (= ?rgj ?rgi)
          (= ?rgj ?rgh)
          )
        (= ?rgi ?rgh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rgk Real)
    (declare-const ?rgl Real)
    (declare-const ?rgm Real)
    (declare-const ?rgn Real)
    (declare-const ?rgo Real)
    (declare-const ?rgp Real)
    (assert
      (and (and (and (not (= ?rgm ?rgl))
            (not (= ?rgm ?rgk))
            )
          (not (= ?rgl ?rgk))
          )
        (or (or (= ?rgp ?rgo)
            (= ?rgp ?rgn)
            )
          (= ?rgo ?rgn)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rgq Real)
    (declare-const ?rgr Real)
    (declare-const ?rgs Real)
    (assert
      (or (or (= ?rgs ?rgr)
          (= ?rgs ?rgq)
          )
        (= ?rgr ?rgq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rgt Real)
    (declare-const ?rgu Real)
    (declare-const ?rgv Real)
    (assert
      (or (or (= ?rgv ?rgu)
          (= ?rgv ?rgt)
          )
        (= ?rgu ?rgt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rgw Real)
    (declare-const ?rgx Real)
    (declare-const ?rgy Real)
    (declare-const ?rgz Real)
    (assert
      (or (or (= ?rgy ?rgx)
          (= ?rgy ?rgw)
          )
        (= ?rgx ?rgw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rha Real)
    (declare-const ?rhb Real)
    (declare-const ?rhc Real)
    (declare-const ?rhd Real)
    (declare-const ?rhe Real)
    (assert
      (or (or (= ?rhc ?rhb)
          (= ?rhc ?rha)
          )
        (= ?rhb ?rha)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rhf Real)
    (declare-const ?rhg Real)
    (declare-const ?rhh Real)
    (declare-const ?rhi Real)
    (declare-const ?rhj Real)
    (declare-const ?rhk Real)
    (assert
      (and (or (or (= ?rhh ?rhg)
            (= ?rhh ?rhf)
            )
          (= ?rhg ?rhf)
          )
        (and (and (not (= ?rhk ?rhj))
            (not (= ?rhk ?rhi))
            )
          (not (= ?rhj ?rhi))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rhl Real)
    (declare-const ?rhm Real)
    (declare-const ?rhn Real)
    (assert
      (or (or (= ?rhn ?rhm)
          (= ?rhn ?rhl)
          )
        (= ?rhm ?rhl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rho Real)
    (declare-const ?rhp Real)
    (declare-const ?rhq Real)
    (declare-const ?rhr Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?rhp ?rho))
                (not (= ?rhp ?asi))
                )
              (not (= ?rho ?asi))
              )
            (or (or (= ?rhr ?rhq)
                (= ?rhr ?asi)
                )
              (= ?rhq ?asi)
              )
            )
          (and (or (or (= ?rhp ?rho)
                (= ?rhp ?asi)
                )
              (= ?rho ?asi)
              )
            (and (and (not (= ?rhr ?rhq))
                (not (= ?rhr ?asi))
                )
              (not (= ?rhq ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rhs Real)
    (declare-const ?rht Real)
    (declare-const ?rhu Real)
    (declare-const ?rhv Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?rht ?rhs))
                (not (= ?rht ?fkf))
                )
              (not (= ?rhs ?fkf))
              )
            (or (or (= ?rhv ?rhu)
                (= ?rhv ?fkf)
                )
              (= ?rhu ?fkf)
              )
            )
          (and (or (or (= ?rht ?rhs)
                (= ?rht ?fkf)
                )
              (= ?rhs ?fkf)
              )
            (and (and (not (= ?rhv ?rhu))
                (not (= ?rhv ?fkf))
                )
              (not (= ?rhu ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?rhw Real)
  (declare-const ?rhx Real)
  (declare-const ?rhy Real)
  (declare-const ?rhz Real)
  (assert
    (exists ((?fkf Real) )(or (and (and (and (not (= ?rhx ?rhw))
              (not (= ?rhx ?fkf))
              )
            (not (= ?rhw ?fkf))
            )
          (or (or (= ?rhz ?rhy)
              (= ?rhz ?fkf)
              )
            (= ?rhy ?fkf)
            )
          )
        (and (or (or (= ?rhx ?rhw)
              (= ?rhx ?fkf)
              )
            (= ?rhw ?fkf)
            )
          (and (and (not (= ?rhz ?rhy))
              (not (= ?rhz ?fkf))
              )
            (not (= ?rhy ?fkf))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?ria Real)
    (declare-const ?rib Real)
    (declare-const ?ric Real)
    (assert
      (or (or (= ?ric ?rib)
          (= ?ric ?ria)
          )
        (= ?rib ?ria)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rid Real)
    (declare-const ?rie Real)
    (declare-const ?rif Real)
    (declare-const ?rig Real)
    (assert
      (or (or (= ?rig ?rif)
          (= ?rig ?rie)
          )
        (= ?rif ?rie)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rih Real)
    (declare-const ?rii Real)
    (declare-const ?rij Real)
    (declare-const ?rik Real)
    (declare-const ?ril Real)
    (assert
      (or (or (= ?ril ?rik)
          (= ?ril ?rij)
          )
        (= ?rik ?rij)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rim Real)
    (declare-const ?rin Real)
    (declare-const ?rio Real)
    (declare-const ?rip Real)
    (declare-const ?riq Real)
    (declare-const ?rir Real)
    (assert
      (and (and (and (not (= ?rio ?rin))
            (not (= ?rio ?rim))
            )
          (not (= ?rin ?rim))
          )
        (or (or (= ?rir ?riq)
            (= ?rir ?rip)
            )
          (= ?riq ?rip)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ris Real)
    (declare-const ?rit Real)
    (declare-const ?riu Real)
    (assert
      (or (or (= ?riu ?rit)
          (= ?riu ?ris)
          )
        (= ?rit ?ris)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?riv Real)
    (declare-const ?riw Real)
    (declare-const ?rix Real)
    (assert
      (or (or (= ?rix ?riw)
          (= ?rix ?riv)
          )
        (= ?riw ?riv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?riy Real)
    (declare-const ?riz Real)
    (declare-const ?rja Real)
    (declare-const ?rjb Real)
    (assert
      (or (or (= ?rja ?riz)
          (= ?rja ?riy)
          )
        (= ?riz ?riy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rjc Real)
    (declare-const ?rjd Real)
    (declare-const ?rje Real)
    (declare-const ?rjf Real)
    (declare-const ?rjg Real)
    (assert
      (or (or (= ?rje ?rjd)
          (= ?rje ?rjc)
          )
        (= ?rjd ?rjc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rjh Real)
    (declare-const ?rji Real)
    (declare-const ?rjj Real)
    (declare-const ?rjk Real)
    (declare-const ?rjl Real)
    (declare-const ?rjm Real)
    (assert
      (and (or (or (= ?rjj ?rji)
            (= ?rjj ?rjh)
            )
          (= ?rji ?rjh)
          )
        (and (and (not (= ?rjm ?rjl))
            (not (= ?rjm ?rjk))
            )
          (not (= ?rjl ?rjk))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rjn Real)
    (declare-const ?rjo Real)
    (declare-const ?rjp Real)
    (assert
      (or (or (= ?rjp ?rjo)
          (= ?rjp ?rjn)
          )
        (= ?rjo ?rjn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rjq Real)
    (declare-const ?rjr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rjs Real)
    (declare-const ?rjt Real)
    (declare-const ?rju Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rjv Real)
    (declare-const ?rjw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rjx Real)
    (declare-const ?rjy Real)
    (declare-const ?rjz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rka Real)
    (declare-const ?rkb Real)
    (declare-const ?rkc Real)
    (declare-const ?rkd Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?rkb ?rka))
                (not (= ?rkb ?asi))
                )
              (not (= ?rka ?asi))
              )
            (or (or (= ?rkd ?rkc)
                (= ?rkd ?asi)
                )
              (= ?rkc ?asi)
              )
            )
          (and (or (or (= ?rkb ?rka)
                (= ?rkb ?asi)
                )
              (= ?rka ?asi)
              )
            (and (and (not (= ?rkd ?rkc))
                (not (= ?rkd ?asi))
                )
              (not (= ?rkc ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rke Real)
    (declare-const ?rkf Real)
    (declare-const ?rkg Real)
    (declare-const ?rkh Real)
    (declare-const ?rki Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rkj Real)
    (declare-const ?rkk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rkl Real)
    (declare-const ?rkm Real)
    (declare-const ?rkn Real)
    (declare-const ?rko Real)
    (declare-const ?rkp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rkq Real)
    (declare-const ?rkr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rks Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rkt Real)
    (declare-const ?rku Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rkv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rkw Real)
    (declare-const ?rkx Real)
    (assert
      (not (= ?rkw ?rkx))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rky Real)
    (declare-const ?rkz Real)
    (declare-const ?rla Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rlb Real)
    (declare-const ?rlc Real)
    (declare-const ?rld Real)
    (declare-const ?rle Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rlf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rlg Real)
    (declare-const ?rlh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rli Real)
    (declare-const ?rlj Real)
    (declare-const ?rlk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rll Real)
    (declare-const ?rlm Real)
    (declare-const ?rln Real)
    (declare-const ?rlo Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?rlm ?rll))
                (not (= ?rlm ?fkf))
                )
              (not (= ?rll ?fkf))
              )
            (or (or (= ?rlo ?rln)
                (= ?rlo ?fkf)
                )
              (= ?rln ?fkf)
              )
            )
          (and (or (or (= ?rlm ?rll)
                (= ?rlm ?fkf)
                )
              (= ?rll ?fkf)
              )
            (and (and (not (= ?rlo ?rln))
                (not (= ?rlo ?fkf))
                )
              (not (= ?rln ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rlp Real)
    (declare-const ?rlq Real)
    (declare-const ?rlr Real)
    (declare-const ?rls Real)
    (declare-const ?rlt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rlu Real)
    (declare-const ?rlv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rlw Real)
    (declare-const ?rlx Real)
    (declare-const ?rly Real)
    (declare-const ?rlz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rma Real)
    (declare-const ?rmb Real)
    (declare-const ?rmc Real)
    (declare-const ?rmd Real)
    (declare-const ?rme Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rmf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rmg Real)
    (declare-const ?rmh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?rmi Real)
  (declare-const ?rmj Real)
  (declare-const ?rmk Real)
  (declare-const ?rml Real)
  (declare-const ?rmm Real)
  (push 1)
    (declare-const ?rmn Real)
    (declare-const ?rmo Real)
    (declare-const ?rmp Real)
    (assert
      (or (or (= ?rmp ?rmo)
          (= ?rmp ?rmn)
          )
        (= ?rmo ?rmn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rmq Real)
    (declare-const ?rmr Real)
    (declare-const ?rms Real)
    (declare-const ?rmt Real)
    (assert
      (or (or (= ?rmt ?rms)
          (= ?rmt ?rmr)
          )
        (= ?rms ?rmr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rmu Real)
    (declare-const ?rmv Real)
    (declare-const ?rmw Real)
    (declare-const ?rmx Real)
    (declare-const ?rmy Real)
    (assert
      (or (or (= ?rmy ?rmx)
          (= ?rmy ?rmw)
          )
        (= ?rmx ?rmw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rmz Real)
    (declare-const ?rna Real)
    (declare-const ?rnb Real)
    (declare-const ?rnc Real)
    (declare-const ?rnd Real)
    (declare-const ?rne Real)
    (assert
      (and (and (and (not (= ?rnb ?rna))
            (not (= ?rnb ?rmz))
            )
          (not (= ?rna ?rmz))
          )
        (or (or (= ?rne ?rnd)
            (= ?rne ?rnc)
            )
          (= ?rnd ?rnc)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rnf Real)
    (declare-const ?rng Real)
    (declare-const ?rnh Real)
    (assert
      (or (or (= ?rnh ?rng)
          (= ?rnh ?rnf)
          )
        (= ?rng ?rnf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rni Real)
    (declare-const ?rnj Real)
    (declare-const ?rnk Real)
    (assert
      (or (or (= ?rnk ?rnj)
          (= ?rnk ?rni)
          )
        (= ?rnj ?rni)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rnl Real)
    (declare-const ?rnm Real)
    (declare-const ?rnn Real)
    (declare-const ?rno Real)
    (assert
      (or (or (= ?rnn ?rnm)
          (= ?rnn ?rnl)
          )
        (= ?rnm ?rnl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rnp Real)
    (declare-const ?rnq Real)
    (declare-const ?rnr Real)
    (declare-const ?rns Real)
    (declare-const ?rnt Real)
    (assert
      (or (or (= ?rnr ?rnq)
          (= ?rnr ?rnp)
          )
        (= ?rnq ?rnp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rnu Real)
    (declare-const ?rnv Real)
    (declare-const ?rnw Real)
    (declare-const ?rnx Real)
    (declare-const ?rny Real)
    (declare-const ?rnz Real)
    (assert
      (and (or (or (= ?rnw ?rnv)
            (= ?rnw ?rnu)
            )
          (= ?rnv ?rnu)
          )
        (and (and (not (= ?rnz ?rny))
            (not (= ?rnz ?rnx))
            )
          (not (= ?rny ?rnx))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?roa Real)
    (declare-const ?rob Real)
    (declare-const ?roc Real)
    (assert
      (or (or (= ?roc ?rob)
          (= ?roc ?roa)
          )
        (= ?rob ?roa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rod Real)
    (declare-const ?roe Real)
    (declare-const ?rof Real)
    (declare-const ?rog Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?roe ?rod))
                (not (= ?roe ?asi))
                )
              (not (= ?rod ?asi))
              )
            (or (or (= ?rog ?rof)
                (= ?rog ?asi)
                )
              (= ?rof ?asi)
              )
            )
          (and (or (or (= ?roe ?rod)
                (= ?roe ?asi)
                )
              (= ?rod ?asi)
              )
            (and (and (not (= ?rog ?rof))
                (not (= ?rog ?asi))
                )
              (not (= ?rof ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?roh Real)
    (declare-const ?roi Real)
    (declare-const ?roj Real)
    (declare-const ?rok Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?roi ?roh))
                (not (= ?roi ?fkf))
                )
              (not (= ?roh ?fkf))
              )
            (or (or (= ?rok ?roj)
                (= ?rok ?fkf)
                )
              (= ?roj ?fkf)
              )
            )
          (and (or (or (= ?roi ?roh)
                (= ?roi ?fkf)
                )
              (= ?roh ?fkf)
              )
            (and (and (not (= ?rok ?roj))
                (not (= ?rok ?fkf))
                )
              (not (= ?roj ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?rol Real)
  (declare-const ?rom Real)
  (push 1)
    (declare-const ?ron Real)
    (declare-const ?roo Real)
    (declare-const ?rop Real)
    (assert
      (or (or (= ?rop ?roo)
          (= ?rop ?ron)
          )
        (= ?roo ?ron)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?roq Real)
    (declare-const ?ror Real)
    (declare-const ?ros Real)
    (declare-const ?rot Real)
    (assert
      (or (or (= ?rot ?ros)
          (= ?rot ?ror)
          )
        (= ?ros ?ror)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rou Real)
    (declare-const ?rov Real)
    (declare-const ?row Real)
    (declare-const ?rox Real)
    (declare-const ?roy Real)
    (assert
      (or (or (= ?roy ?rox)
          (= ?roy ?row)
          )
        (= ?rox ?row)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?roz Real)
    (declare-const ?rpa Real)
    (declare-const ?rpb Real)
    (declare-const ?rpc Real)
    (declare-const ?rpd Real)
    (declare-const ?rpe Real)
    (assert
      (and (and (and (not (= ?rpb ?rpa))
            (not (= ?rpb ?roz))
            )
          (not (= ?rpa ?roz))
          )
        (or (or (= ?rpe ?rpd)
            (= ?rpe ?rpc)
            )
          (= ?rpd ?rpc)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rpf Real)
    (declare-const ?rpg Real)
    (declare-const ?rph Real)
    (assert
      (or (or (= ?rph ?rpg)
          (= ?rph ?rpf)
          )
        (= ?rpg ?rpf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rpi Real)
    (declare-const ?rpj Real)
    (declare-const ?rpk Real)
    (assert
      (or (or (= ?rpk ?rpj)
          (= ?rpk ?rpi)
          )
        (= ?rpj ?rpi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rpl Real)
    (declare-const ?rpm Real)
    (declare-const ?rpn Real)
    (declare-const ?rpo Real)
    (assert
      (or (or (= ?rpn ?rpm)
          (= ?rpn ?rpl)
          )
        (= ?rpm ?rpl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rpp Real)
    (declare-const ?rpq Real)
    (declare-const ?rpr Real)
    (declare-const ?rps Real)
    (declare-const ?rpt Real)
    (assert
      (or (or (= ?rpr ?rpq)
          (= ?rpr ?rpp)
          )
        (= ?rpq ?rpp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rpu Real)
    (declare-const ?rpv Real)
    (declare-const ?rpw Real)
    (declare-const ?rpx Real)
    (declare-const ?rpy Real)
    (declare-const ?rpz Real)
    (assert
      (and (or (or (= ?rpw ?rpv)
            (= ?rpw ?rpu)
            )
          (= ?rpv ?rpu)
          )
        (and (and (not (= ?rpz ?rpy))
            (not (= ?rpz ?rpx))
            )
          (not (= ?rpy ?rpx))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rqa Real)
    (declare-const ?rqb Real)
    (declare-const ?rqc Real)
    (assert
      (or (or (= ?rqc ?rqb)
          (= ?rqc ?rqa)
          )
        (= ?rqb ?rqa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rqd Real)
    (declare-const ?rqe Real)
    (declare-const ?rqf Real)
    (declare-const ?rqg Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?rqe ?rqd))
                (not (= ?rqe ?asi))
                )
              (not (= ?rqd ?asi))
              )
            (or (or (= ?rqg ?rqf)
                (= ?rqg ?asi)
                )
              (= ?rqf ?asi)
              )
            )
          (and (or (or (= ?rqe ?rqd)
                (= ?rqe ?asi)
                )
              (= ?rqd ?asi)
              )
            (and (and (not (= ?rqg ?rqf))
                (not (= ?rqg ?asi))
                )
              (not (= ?rqf ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rqh Real)
    (declare-const ?rqi Real)
    (declare-const ?rqj Real)
    (declare-const ?rqk Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?rqi ?rqh))
                (not (= ?rqi ?fkf))
                )
              (not (= ?rqh ?fkf))
              )
            (or (or (= ?rqk ?rqj)
                (= ?rqk ?fkf)
                )
              (= ?rqj ?fkf)
              )
            )
          (and (or (or (= ?rqi ?rqh)
                (= ?rqi ?fkf)
                )
              (= ?rqh ?fkf)
              )
            (and (and (not (= ?rqk ?rqj))
                (not (= ?rqk ?fkf))
                )
              (not (= ?rqj ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?rql Real)
  (declare-const ?rqm Real)
  (declare-const ?rqn Real)
  (declare-const ?rqo Real)
  (push 1)
    (declare-const ?rqp Real)
    (declare-const ?rqq Real)
    (declare-const ?rqr Real)
    (assert
      (or (or (= ?rqr ?rqq)
          (= ?rqr ?rqp)
          )
        (= ?rqq ?rqp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rqs Real)
    (declare-const ?rqt Real)
    (declare-const ?rqu Real)
    (declare-const ?rqv Real)
    (assert
      (or (or (= ?rqv ?rqu)
          (= ?rqv ?rqt)
          )
        (= ?rqu ?rqt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rqw Real)
    (declare-const ?rqx Real)
    (declare-const ?rqy Real)
    (declare-const ?rqz Real)
    (declare-const ?rra Real)
    (assert
      (or (or (= ?rra ?rqz)
          (= ?rra ?rqy)
          )
        (= ?rqz ?rqy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rrb Real)
    (declare-const ?rrc Real)
    (declare-const ?rrd Real)
    (declare-const ?rre Real)
    (declare-const ?rrf Real)
    (declare-const ?rrg Real)
    (assert
      (and (and (and (not (= ?rrd ?rrc))
            (not (= ?rrd ?rrb))
            )
          (not (= ?rrc ?rrb))
          )
        (or (or (= ?rrg ?rrf)
            (= ?rrg ?rre)
            )
          (= ?rrf ?rre)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rrh Real)
    (declare-const ?rri Real)
    (declare-const ?rrj Real)
    (assert
      (or (or (= ?rrj ?rri)
          (= ?rrj ?rrh)
          )
        (= ?rri ?rrh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rrk Real)
    (declare-const ?rrl Real)
    (declare-const ?rrm Real)
    (assert
      (or (or (= ?rrm ?rrl)
          (= ?rrm ?rrk)
          )
        (= ?rrl ?rrk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rrn Real)
    (declare-const ?rro Real)
    (declare-const ?rrp Real)
    (declare-const ?rrq Real)
    (assert
      (or (or (= ?rrp ?rro)
          (= ?rrp ?rrn)
          )
        (= ?rro ?rrn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rrr Real)
    (declare-const ?rrs Real)
    (declare-const ?rrt Real)
    (declare-const ?rru Real)
    (declare-const ?rrv Real)
    (assert
      (or (or (= ?rrt ?rrs)
          (= ?rrt ?rrr)
          )
        (= ?rrs ?rrr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rrw Real)
    (declare-const ?rrx Real)
    (declare-const ?rry Real)
    (declare-const ?rrz Real)
    (declare-const ?rsa Real)
    (declare-const ?rsb Real)
    (assert
      (and (or (or (= ?rry ?rrx)
            (= ?rry ?rrw)
            )
          (= ?rrx ?rrw)
          )
        (and (and (not (= ?rsb ?rsa))
            (not (= ?rsb ?rrz))
            )
          (not (= ?rsa ?rrz))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rsc Real)
    (declare-const ?rsd Real)
    (declare-const ?rse Real)
    (assert
      (or (or (= ?rse ?rsd)
          (= ?rse ?rsc)
          )
        (= ?rsd ?rsc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rsf Real)
    (declare-const ?rsg Real)
    (declare-const ?rsh Real)
    (declare-const ?rsi Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?rsg ?rsf))
                (not (= ?rsg ?asi))
                )
              (not (= ?rsf ?asi))
              )
            (or (or (= ?rsi ?rsh)
                (= ?rsi ?asi)
                )
              (= ?rsh ?asi)
              )
            )
          (and (or (or (= ?rsg ?rsf)
                (= ?rsg ?asi)
                )
              (= ?rsf ?asi)
              )
            (and (and (not (= ?rsi ?rsh))
                (not (= ?rsi ?asi))
                )
              (not (= ?rsh ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rsj Real)
    (declare-const ?rsk Real)
    (declare-const ?rsl Real)
    (declare-const ?rsm Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?rsk ?rsj))
                (not (= ?rsk ?fkf))
                )
              (not (= ?rsj ?fkf))
              )
            (or (or (= ?rsm ?rsl)
                (= ?rsm ?fkf)
                )
              (= ?rsl ?fkf)
              )
            )
          (and (or (or (= ?rsk ?rsj)
                (= ?rsk ?fkf)
                )
              (= ?rsj ?fkf)
              )
            (and (and (not (= ?rsm ?rsl))
                (not (= ?rsm ?fkf))
                )
              (not (= ?rsl ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?rsn Real)
  (declare-const ?rso Real)
  (declare-const ?rsp Real)
  (declare-const ?rsq Real)
  (declare-const ?rsr Real)
  (push 1)
    (declare-const ?rss Real)
    (declare-const ?rst Real)
    (declare-const ?rsu Real)
    (assert
      (or (or (= ?rsu ?rst)
          (= ?rsu ?rss)
          )
        (= ?rst ?rss)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rsv Real)
    (declare-const ?rsw Real)
    (declare-const ?rsx Real)
    (declare-const ?rsy Real)
    (assert
      (or (or (= ?rsy ?rsx)
          (= ?rsy ?rsw)
          )
        (= ?rsx ?rsw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rsz Real)
    (declare-const ?rta Real)
    (declare-const ?rtb Real)
    (declare-const ?rtc Real)
    (declare-const ?rtd Real)
    (assert
      (or (or (= ?rtd ?rtc)
          (= ?rtd ?rtb)
          )
        (= ?rtc ?rtb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rte Real)
    (declare-const ?rtf Real)
    (declare-const ?rtg Real)
    (declare-const ?rth Real)
    (declare-const ?rti Real)
    (declare-const ?rtj Real)
    (assert
      (and (and (and (not (= ?rtg ?rtf))
            (not (= ?rtg ?rte))
            )
          (not (= ?rtf ?rte))
          )
        (or (or (= ?rtj ?rti)
            (= ?rtj ?rth)
            )
          (= ?rti ?rth)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rtk Real)
    (declare-const ?rtl Real)
    (declare-const ?rtm Real)
    (assert
      (or (or (= ?rtm ?rtl)
          (= ?rtm ?rtk)
          )
        (= ?rtl ?rtk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rtn Real)
    (declare-const ?rto Real)
    (declare-const ?rtp Real)
    (assert
      (or (or (= ?rtp ?rto)
          (= ?rtp ?rtn)
          )
        (= ?rto ?rtn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rtq Real)
    (declare-const ?rtr Real)
    (declare-const ?rts Real)
    (declare-const ?rtt Real)
    (assert
      (or (or (= ?rts ?rtr)
          (= ?rts ?rtq)
          )
        (= ?rtr ?rtq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rtu Real)
    (declare-const ?rtv Real)
    (declare-const ?rtw Real)
    (declare-const ?rtx Real)
    (declare-const ?rty Real)
    (assert
      (or (or (= ?rtw ?rtv)
          (= ?rtw ?rtu)
          )
        (= ?rtv ?rtu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rtz Real)
    (declare-const ?rua Real)
    (declare-const ?rub Real)
    (declare-const ?ruc Real)
    (declare-const ?rud Real)
    (declare-const ?rue Real)
    (assert
      (and (or (or (= ?rub ?rua)
            (= ?rub ?rtz)
            )
          (= ?rua ?rtz)
          )
        (and (and (not (= ?rue ?rud))
            (not (= ?rue ?ruc))
            )
          (not (= ?rud ?ruc))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ruf Real)
    (declare-const ?rug Real)
    (declare-const ?ruh Real)
    (assert
      (or (or (= ?ruh ?rug)
          (= ?ruh ?ruf)
          )
        (= ?rug ?ruf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rui Real)
    (declare-const ?ruj Real)
    (declare-const ?ruk Real)
    (declare-const ?rul Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ruj ?rui))
                (not (= ?ruj ?asi))
                )
              (not (= ?rui ?asi))
              )
            (or (or (= ?rul ?ruk)
                (= ?rul ?asi)
                )
              (= ?ruk ?asi)
              )
            )
          (and (or (or (= ?ruj ?rui)
                (= ?ruj ?asi)
                )
              (= ?rui ?asi)
              )
            (and (and (not (= ?rul ?ruk))
                (not (= ?rul ?asi))
                )
              (not (= ?ruk ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rum Real)
    (declare-const ?run Real)
    (declare-const ?ruo Real)
    (declare-const ?rup Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?run ?rum))
                (not (= ?run ?fkf))
                )
              (not (= ?rum ?fkf))
              )
            (or (or (= ?rup ?ruo)
                (= ?rup ?fkf)
                )
              (= ?ruo ?fkf)
              )
            )
          (and (or (or (= ?run ?rum)
                (= ?run ?fkf)
                )
              (= ?rum ?fkf)
              )
            (and (and (not (= ?rup ?ruo))
                (not (= ?rup ?fkf))
                )
              (not (= ?ruo ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ruq Real)
  (push 1)
    (declare-const ?rur Real)
    (declare-const ?rus Real)
    (declare-const ?rut Real)
    (assert
      (or (or (= ?rut ?rus)
          (= ?rut ?rur)
          )
        (= ?rus ?rur)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ruu Real)
    (declare-const ?ruv Real)
    (declare-const ?ruw Real)
    (declare-const ?rux Real)
    (assert
      (or (or (= ?rux ?ruw)
          (= ?rux ?ruv)
          )
        (= ?ruw ?ruv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ruy Real)
    (declare-const ?ruz Real)
    (declare-const ?rva Real)
    (declare-const ?rvb Real)
    (declare-const ?rvc Real)
    (assert
      (or (or (= ?rvc ?rvb)
          (= ?rvc ?rva)
          )
        (= ?rvb ?rva)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rvd Real)
    (declare-const ?rve Real)
    (declare-const ?rvf Real)
    (declare-const ?rvg Real)
    (declare-const ?rvh Real)
    (declare-const ?rvi Real)
    (assert
      (and (and (and (not (= ?rvf ?rve))
            (not (= ?rvf ?rvd))
            )
          (not (= ?rve ?rvd))
          )
        (or (or (= ?rvi ?rvh)
            (= ?rvi ?rvg)
            )
          (= ?rvh ?rvg)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rvj Real)
    (declare-const ?rvk Real)
    (declare-const ?rvl Real)
    (assert
      (or (or (= ?rvl ?rvk)
          (= ?rvl ?rvj)
          )
        (= ?rvk ?rvj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rvm Real)
    (declare-const ?rvn Real)
    (declare-const ?rvo Real)
    (assert
      (or (or (= ?rvo ?rvn)
          (= ?rvo ?rvm)
          )
        (= ?rvn ?rvm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rvp Real)
    (declare-const ?rvq Real)
    (declare-const ?rvr Real)
    (declare-const ?rvs Real)
    (assert
      (or (or (= ?rvr ?rvq)
          (= ?rvr ?rvp)
          )
        (= ?rvq ?rvp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rvt Real)
    (declare-const ?rvu Real)
    (declare-const ?rvv Real)
    (declare-const ?rvw Real)
    (declare-const ?rvx Real)
    (assert
      (or (or (= ?rvv ?rvu)
          (= ?rvv ?rvt)
          )
        (= ?rvu ?rvt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rvy Real)
    (declare-const ?rvz Real)
    (declare-const ?rwa Real)
    (declare-const ?rwb Real)
    (declare-const ?rwc Real)
    (declare-const ?rwd Real)
    (assert
      (and (or (or (= ?rwa ?rvz)
            (= ?rwa ?rvy)
            )
          (= ?rvz ?rvy)
          )
        (and (and (not (= ?rwd ?rwc))
            (not (= ?rwd ?rwb))
            )
          (not (= ?rwc ?rwb))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rwe Real)
    (declare-const ?rwf Real)
    (declare-const ?rwg Real)
    (assert
      (or (or (= ?rwg ?rwf)
          (= ?rwg ?rwe)
          )
        (= ?rwf ?rwe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rwh Real)
    (declare-const ?rwi Real)
    (declare-const ?rwj Real)
    (declare-const ?rwk Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?rwi ?rwh))
                (not (= ?rwi ?asi))
                )
              (not (= ?rwh ?asi))
              )
            (or (or (= ?rwk ?rwj)
                (= ?rwk ?asi)
                )
              (= ?rwj ?asi)
              )
            )
          (and (or (or (= ?rwi ?rwh)
                (= ?rwi ?asi)
                )
              (= ?rwh ?asi)
              )
            (and (and (not (= ?rwk ?rwj))
                (not (= ?rwk ?asi))
                )
              (not (= ?rwj ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rwl Real)
    (declare-const ?rwm Real)
    (declare-const ?rwn Real)
    (declare-const ?rwo Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?rwm ?rwl))
                (not (= ?rwm ?fkf))
                )
              (not (= ?rwl ?fkf))
              )
            (or (or (= ?rwo ?rwn)
                (= ?rwo ?fkf)
                )
              (= ?rwn ?fkf)
              )
            )
          (and (or (or (= ?rwm ?rwl)
                (= ?rwm ?fkf)
                )
              (= ?rwl ?fkf)
              )
            (and (and (not (= ?rwo ?rwn))
                (not (= ?rwo ?fkf))
                )
              (not (= ?rwn ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?rwp Real)
  (declare-const ?rwq Real)
  (push 1)
    (declare-const ?rwr Real)
    (declare-const ?rws Real)
    (declare-const ?rwt Real)
    (assert
      (or (or (= ?rwt ?rws)
          (= ?rwt ?rwr)
          )
        (= ?rws ?rwr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rwu Real)
    (declare-const ?rwv Real)
    (declare-const ?rww Real)
    (declare-const ?rwx Real)
    (assert
      (or (or (= ?rwx ?rww)
          (= ?rwx ?rwv)
          )
        (= ?rww ?rwv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rwy Real)
    (declare-const ?rwz Real)
    (declare-const ?rxa Real)
    (declare-const ?rxb Real)
    (declare-const ?rxc Real)
    (assert
      (or (or (= ?rxc ?rxb)
          (= ?rxc ?rxa)
          )
        (= ?rxb ?rxa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rxd Real)
    (declare-const ?rxe Real)
    (declare-const ?rxf Real)
    (declare-const ?rxg Real)
    (declare-const ?rxh Real)
    (declare-const ?rxi Real)
    (assert
      (and (and (and (not (= ?rxf ?rxe))
            (not (= ?rxf ?rxd))
            )
          (not (= ?rxe ?rxd))
          )
        (or (or (= ?rxi ?rxh)
            (= ?rxi ?rxg)
            )
          (= ?rxh ?rxg)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rxj Real)
    (declare-const ?rxk Real)
    (declare-const ?rxl Real)
    (assert
      (or (or (= ?rxl ?rxk)
          (= ?rxl ?rxj)
          )
        (= ?rxk ?rxj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rxm Real)
    (declare-const ?rxn Real)
    (declare-const ?rxo Real)
    (assert
      (or (or (= ?rxo ?rxn)
          (= ?rxo ?rxm)
          )
        (= ?rxn ?rxm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rxp Real)
    (declare-const ?rxq Real)
    (declare-const ?rxr Real)
    (declare-const ?rxs Real)
    (assert
      (or (or (= ?rxr ?rxq)
          (= ?rxr ?rxp)
          )
        (= ?rxq ?rxp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rxt Real)
    (declare-const ?rxu Real)
    (declare-const ?rxv Real)
    (declare-const ?rxw Real)
    (declare-const ?rxx Real)
    (assert
      (or (or (= ?rxv ?rxu)
          (= ?rxv ?rxt)
          )
        (= ?rxu ?rxt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rxy Real)
    (declare-const ?rxz Real)
    (declare-const ?rya Real)
    (declare-const ?ryb Real)
    (declare-const ?ryc Real)
    (declare-const ?ryd Real)
    (assert
      (and (or (or (= ?rya ?rxz)
            (= ?rya ?rxy)
            )
          (= ?rxz ?rxy)
          )
        (and (and (not (= ?ryd ?ryc))
            (not (= ?ryd ?ryb))
            )
          (not (= ?ryc ?ryb))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rye Real)
    (declare-const ?ryf Real)
    (declare-const ?ryg Real)
    (assert
      (or (or (= ?ryg ?ryf)
          (= ?ryg ?rye)
          )
        (= ?ryf ?rye)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ryh Real)
    (declare-const ?ryi Real)
    (declare-const ?ryj Real)
    (declare-const ?ryk Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ryi ?ryh))
                (not (= ?ryi ?asi))
                )
              (not (= ?ryh ?asi))
              )
            (or (or (= ?ryk ?ryj)
                (= ?ryk ?asi)
                )
              (= ?ryj ?asi)
              )
            )
          (and (or (or (= ?ryi ?ryh)
                (= ?ryi ?asi)
                )
              (= ?ryh ?asi)
              )
            (and (and (not (= ?ryk ?ryj))
                (not (= ?ryk ?asi))
                )
              (not (= ?ryj ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ryl Real)
    (declare-const ?rym Real)
    (declare-const ?ryn Real)
    (declare-const ?ryo Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?rym ?ryl))
                (not (= ?rym ?fkf))
                )
              (not (= ?ryl ?fkf))
              )
            (or (or (= ?ryo ?ryn)
                (= ?ryo ?fkf)
                )
              (= ?ryn ?fkf)
              )
            )
          (and (or (or (= ?rym ?ryl)
                (= ?rym ?fkf)
                )
              (= ?ryl ?fkf)
              )
            (and (and (not (= ?ryo ?ryn))
                (not (= ?ryo ?fkf))
                )
              (not (= ?ryn ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ryp Real)
  (push 1)
    (declare-const ?ryq Real)
    (declare-const ?ryr Real)
    (declare-const ?rys Real)
    (assert
      (or (or (= ?rys ?ryr)
          (= ?rys ?ryq)
          )
        (= ?ryr ?ryq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ryt Real)
    (declare-const ?ryu Real)
    (declare-const ?ryv Real)
    (declare-const ?ryw Real)
    (assert
      (or (or (= ?ryw ?ryv)
          (= ?ryw ?ryu)
          )
        (= ?ryv ?ryu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ryx Real)
    (declare-const ?ryy Real)
    (declare-const ?ryz Real)
    (declare-const ?rza Real)
    (declare-const ?rzb Real)
    (assert
      (or (or (= ?rzb ?rza)
          (= ?rzb ?ryz)
          )
        (= ?rza ?ryz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rzc Real)
    (declare-const ?rzd Real)
    (declare-const ?rze Real)
    (declare-const ?rzf Real)
    (declare-const ?rzg Real)
    (declare-const ?rzh Real)
    (assert
      (and (and (and (not (= ?rze ?rzd))
            (not (= ?rze ?rzc))
            )
          (not (= ?rzd ?rzc))
          )
        (or (or (= ?rzh ?rzg)
            (= ?rzh ?rzf)
            )
          (= ?rzg ?rzf)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rzi Real)
    (declare-const ?rzj Real)
    (declare-const ?rzk Real)
    (assert
      (or (or (= ?rzk ?rzj)
          (= ?rzk ?rzi)
          )
        (= ?rzj ?rzi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rzl Real)
    (declare-const ?rzm Real)
    (declare-const ?rzn Real)
    (assert
      (or (or (= ?rzn ?rzm)
          (= ?rzn ?rzl)
          )
        (= ?rzm ?rzl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rzo Real)
    (declare-const ?rzp Real)
    (declare-const ?rzq Real)
    (declare-const ?rzr Real)
    (assert
      (or (or (= ?rzq ?rzp)
          (= ?rzq ?rzo)
          )
        (= ?rzp ?rzo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rzs Real)
    (declare-const ?rzt Real)
    (declare-const ?rzu Real)
    (declare-const ?rzv Real)
    (declare-const ?rzw Real)
    (assert
      (or (or (= ?rzu ?rzt)
          (= ?rzu ?rzs)
          )
        (= ?rzt ?rzs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?rzx Real)
    (declare-const ?rzy Real)
    (declare-const ?rzz Real)
    (declare-const ?saa Real)
    (declare-const ?sab Real)
    (declare-const ?sac Real)
    (assert
      (and (or (or (= ?rzz ?rzy)
            (= ?rzz ?rzx)
            )
          (= ?rzy ?rzx)
          )
        (and (and (not (= ?sac ?sab))
            (not (= ?sac ?saa))
            )
          (not (= ?sab ?saa))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sad Real)
    (declare-const ?sae Real)
    (declare-const ?saf Real)
    (assert
      (or (or (= ?saf ?sae)
          (= ?saf ?sad)
          )
        (= ?sae ?sad)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sag Real)
    (declare-const ?sah Real)
    (declare-const ?sai Real)
    (declare-const ?saj Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?sah ?sag))
                (not (= ?sah ?asi))
                )
              (not (= ?sag ?asi))
              )
            (or (or (= ?saj ?sai)
                (= ?saj ?asi)
                )
              (= ?sai ?asi)
              )
            )
          (and (or (or (= ?sah ?sag)
                (= ?sah ?asi)
                )
              (= ?sag ?asi)
              )
            (and (and (not (= ?saj ?sai))
                (not (= ?saj ?asi))
                )
              (not (= ?sai ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sak Real)
    (declare-const ?sal Real)
    (declare-const ?sam Real)
    (declare-const ?san Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?sal ?sak))
                (not (= ?sal ?fkf))
                )
              (not (= ?sak ?fkf))
              )
            (or (or (= ?san ?sam)
                (= ?san ?fkf)
                )
              (= ?sam ?fkf)
              )
            )
          (and (or (or (= ?sal ?sak)
                (= ?sal ?fkf)
                )
              (= ?sak ?fkf)
              )
            (and (and (not (= ?san ?sam))
                (not (= ?san ?fkf))
                )
              (not (= ?sam ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?sao Real)
  (declare-const ?sap Real)
  (push 1)
    (declare-const ?saq Real)
    (declare-const ?sar Real)
    (declare-const ?sas Real)
    (assert
      (or (or (= ?sas ?sar)
          (= ?sas ?saq)
          )
        (= ?sar ?saq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sat Real)
    (declare-const ?sau Real)
    (declare-const ?sav Real)
    (declare-const ?saw Real)
    (assert
      (or (or (= ?saw ?sav)
          (= ?saw ?sau)
          )
        (= ?sav ?sau)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sax Real)
    (declare-const ?say Real)
    (declare-const ?saz Real)
    (declare-const ?sba Real)
    (declare-const ?sbb Real)
    (assert
      (or (or (= ?sbb ?sba)
          (= ?sbb ?saz)
          )
        (= ?sba ?saz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sbc Real)
    (declare-const ?sbd Real)
    (declare-const ?sbe Real)
    (declare-const ?sbf Real)
    (declare-const ?sbg Real)
    (declare-const ?sbh Real)
    (assert
      (and (and (and (not (= ?sbe ?sbd))
            (not (= ?sbe ?sbc))
            )
          (not (= ?sbd ?sbc))
          )
        (or (or (= ?sbh ?sbg)
            (= ?sbh ?sbf)
            )
          (= ?sbg ?sbf)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sbi Real)
    (declare-const ?sbj Real)
    (declare-const ?sbk Real)
    (assert
      (or (or (= ?sbk ?sbj)
          (= ?sbk ?sbi)
          )
        (= ?sbj ?sbi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sbl Real)
    (declare-const ?sbm Real)
    (declare-const ?sbn Real)
    (assert
      (or (or (= ?sbn ?sbm)
          (= ?sbn ?sbl)
          )
        (= ?sbm ?sbl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sbo Real)
    (declare-const ?sbp Real)
    (declare-const ?sbq Real)
    (declare-const ?sbr Real)
    (assert
      (or (or (= ?sbq ?sbp)
          (= ?sbq ?sbo)
          )
        (= ?sbp ?sbo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sbs Real)
    (declare-const ?sbt Real)
    (declare-const ?sbu Real)
    (declare-const ?sbv Real)
    (declare-const ?sbw Real)
    (assert
      (or (or (= ?sbu ?sbt)
          (= ?sbu ?sbs)
          )
        (= ?sbt ?sbs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sbx Real)
    (declare-const ?sby Real)
    (declare-const ?sbz Real)
    (declare-const ?sca Real)
    (declare-const ?scb Real)
    (declare-const ?scc Real)
    (assert
      (and (or (or (= ?sbz ?sby)
            (= ?sbz ?sbx)
            )
          (= ?sby ?sbx)
          )
        (and (and (not (= ?scc ?scb))
            (not (= ?scc ?sca))
            )
          (not (= ?scb ?sca))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?scd Real)
    (declare-const ?sce Real)
    (declare-const ?scf Real)
    (assert
      (or (or (= ?scf ?sce)
          (= ?scf ?scd)
          )
        (= ?sce ?scd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?scg Real)
    (declare-const ?sch Real)
    (declare-const ?sci Real)
    (declare-const ?scj Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?sch ?scg))
                (not (= ?sch ?asi))
                )
              (not (= ?scg ?asi))
              )
            (or (or (= ?scj ?sci)
                (= ?scj ?asi)
                )
              (= ?sci ?asi)
              )
            )
          (and (or (or (= ?sch ?scg)
                (= ?sch ?asi)
                )
              (= ?scg ?asi)
              )
            (and (and (not (= ?scj ?sci))
                (not (= ?scj ?asi))
                )
              (not (= ?sci ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sck Real)
    (declare-const ?scl Real)
    (declare-const ?scm Real)
    (declare-const ?scn Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?scl ?sck))
                (not (= ?scl ?fkf))
                )
              (not (= ?sck ?fkf))
              )
            (or (or (= ?scn ?scm)
                (= ?scn ?fkf)
                )
              (= ?scm ?fkf)
              )
            )
          (and (or (or (= ?scl ?sck)
                (= ?scl ?fkf)
                )
              (= ?sck ?fkf)
              )
            (and (and (not (= ?scn ?scm))
                (not (= ?scn ?fkf))
                )
              (not (= ?scm ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?sco Real)
  (declare-const ?scp Real)
  (declare-const ?scq Real)
  (push 1)
    (declare-const ?scr Real)
    (declare-const ?scs Real)
    (declare-const ?sct Real)
    (assert
      (or (or (= ?sct ?scs)
          (= ?sct ?scr)
          )
        (= ?scs ?scr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?scu Real)
    (declare-const ?scv Real)
    (declare-const ?scw Real)
    (declare-const ?scx Real)
    (assert
      (or (or (= ?scx ?scw)
          (= ?scx ?scv)
          )
        (= ?scw ?scv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?scy Real)
    (declare-const ?scz Real)
    (declare-const ?sda Real)
    (declare-const ?sdb Real)
    (declare-const ?sdc Real)
    (assert
      (or (or (= ?sdc ?sdb)
          (= ?sdc ?sda)
          )
        (= ?sdb ?sda)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sdd Real)
    (declare-const ?sde Real)
    (declare-const ?sdf Real)
    (declare-const ?sdg Real)
    (declare-const ?sdh Real)
    (declare-const ?sdi Real)
    (assert
      (and (and (and (not (= ?sdf ?sde))
            (not (= ?sdf ?sdd))
            )
          (not (= ?sde ?sdd))
          )
        (or (or (= ?sdi ?sdh)
            (= ?sdi ?sdg)
            )
          (= ?sdh ?sdg)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sdj Real)
    (declare-const ?sdk Real)
    (declare-const ?sdl Real)
    (assert
      (or (or (= ?sdl ?sdk)
          (= ?sdl ?sdj)
          )
        (= ?sdk ?sdj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sdm Real)
    (declare-const ?sdn Real)
    (declare-const ?sdo Real)
    (assert
      (or (or (= ?sdo ?sdn)
          (= ?sdo ?sdm)
          )
        (= ?sdn ?sdm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sdp Real)
    (declare-const ?sdq Real)
    (declare-const ?sdr Real)
    (declare-const ?sds Real)
    (assert
      (or (or (= ?sdr ?sdq)
          (= ?sdr ?sdp)
          )
        (= ?sdq ?sdp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sdt Real)
    (declare-const ?sdu Real)
    (declare-const ?sdv Real)
    (declare-const ?sdw Real)
    (declare-const ?sdx Real)
    (assert
      (or (or (= ?sdv ?sdu)
          (= ?sdv ?sdt)
          )
        (= ?sdu ?sdt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sdy Real)
    (declare-const ?sdz Real)
    (declare-const ?sea Real)
    (declare-const ?seb Real)
    (declare-const ?sec Real)
    (declare-const ?sed Real)
    (assert
      (and (or (or (= ?sea ?sdz)
            (= ?sea ?sdy)
            )
          (= ?sdz ?sdy)
          )
        (and (and (not (= ?sed ?sec))
            (not (= ?sed ?seb))
            )
          (not (= ?sec ?seb))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?see Real)
    (declare-const ?sef Real)
    (declare-const ?seg Real)
    (assert
      (or (or (= ?seg ?sef)
          (= ?seg ?see)
          )
        (= ?sef ?see)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?seh Real)
    (declare-const ?sei Real)
    (declare-const ?sej Real)
    (declare-const ?sek Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?sei ?seh))
                (not (= ?sei ?asi))
                )
              (not (= ?seh ?asi))
              )
            (or (or (= ?sek ?sej)
                (= ?sek ?asi)
                )
              (= ?sej ?asi)
              )
            )
          (and (or (or (= ?sei ?seh)
                (= ?sei ?asi)
                )
              (= ?seh ?asi)
              )
            (and (and (not (= ?sek ?sej))
                (not (= ?sek ?asi))
                )
              (not (= ?sej ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sel Real)
    (declare-const ?sem Real)
    (declare-const ?sen Real)
    (declare-const ?seo Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?sem ?sel))
                (not (= ?sem ?fkf))
                )
              (not (= ?sel ?fkf))
              )
            (or (or (= ?seo ?sen)
                (= ?seo ?fkf)
                )
              (= ?sen ?fkf)
              )
            )
          (and (or (or (= ?sem ?sel)
                (= ?sem ?fkf)
                )
              (= ?sel ?fkf)
              )
            (and (and (not (= ?seo ?sen))
                (not (= ?seo ?fkf))
                )
              (not (= ?sen ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?sep Real)
    (declare-const ?seq Real)
    (declare-const ?ser Real)
    (assert
      (or (or (= ?ser ?seq)
          (= ?ser ?sep)
          )
        (= ?seq ?sep)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ses Real)
    (declare-const ?set Real)
    (declare-const ?seu Real)
    (declare-const ?sev Real)
    (assert
      (or (or (= ?sev ?seu)
          (= ?sev ?set)
          )
        (= ?seu ?set)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sew Real)
    (declare-const ?sex Real)
    (declare-const ?sey Real)
    (declare-const ?sez Real)
    (declare-const ?sfa Real)
    (assert
      (or (or (= ?sfa ?sez)
          (= ?sfa ?sey)
          )
        (= ?sez ?sey)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sfb Real)
    (declare-const ?sfc Real)
    (declare-const ?sfd Real)
    (declare-const ?sfe Real)
    (declare-const ?sff Real)
    (declare-const ?sfg Real)
    (assert
      (and (and (and (not (= ?sfd ?sfc))
            (not (= ?sfd ?sfb))
            )
          (not (= ?sfc ?sfb))
          )
        (or (or (= ?sfg ?sff)
            (= ?sfg ?sfe)
            )
          (= ?sff ?sfe)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sfh Real)
    (declare-const ?sfi Real)
    (declare-const ?sfj Real)
    (assert
      (or (or (= ?sfj ?sfi)
          (= ?sfj ?sfh)
          )
        (= ?sfi ?sfh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sfk Real)
    (declare-const ?sfl Real)
    (declare-const ?sfm Real)
    (assert
      (or (or (= ?sfm ?sfl)
          (= ?sfm ?sfk)
          )
        (= ?sfl ?sfk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sfn Real)
    (declare-const ?sfo Real)
    (declare-const ?sfp Real)
    (declare-const ?sfq Real)
    (assert
      (or (or (= ?sfp ?sfo)
          (= ?sfp ?sfn)
          )
        (= ?sfo ?sfn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sfr Real)
    (declare-const ?sfs Real)
    (declare-const ?sft Real)
    (declare-const ?sfu Real)
    (declare-const ?sfv Real)
    (assert
      (or (or (= ?sft ?sfs)
          (= ?sft ?sfr)
          )
        (= ?sfs ?sfr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sfw Real)
    (declare-const ?sfx Real)
    (declare-const ?sfy Real)
    (declare-const ?sfz Real)
    (declare-const ?sga Real)
    (declare-const ?sgb Real)
    (assert
      (and (or (or (= ?sfy ?sfx)
            (= ?sfy ?sfw)
            )
          (= ?sfx ?sfw)
          )
        (and (and (not (= ?sgb ?sga))
            (not (= ?sgb ?sfz))
            )
          (not (= ?sga ?sfz))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sgc Real)
    (declare-const ?sgd Real)
    (declare-const ?sge Real)
    (assert
      (or (or (= ?sge ?sgd)
          (= ?sge ?sgc)
          )
        (= ?sgd ?sgc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sgf Real)
    (declare-const ?sgg Real)
    (declare-const ?sgh Real)
    (declare-const ?sgi Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?sgg ?sgf))
                (not (= ?sgg ?asi))
                )
              (not (= ?sgf ?asi))
              )
            (or (or (= ?sgi ?sgh)
                (= ?sgi ?asi)
                )
              (= ?sgh ?asi)
              )
            )
          (and (or (or (= ?sgg ?sgf)
                (= ?sgg ?asi)
                )
              (= ?sgf ?asi)
              )
            (and (and (not (= ?sgi ?sgh))
                (not (= ?sgi ?asi))
                )
              (not (= ?sgh ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sgj Real)
    (declare-const ?sgk Real)
    (declare-const ?sgl Real)
    (declare-const ?sgm Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?sgk ?sgj))
                (not (= ?sgk ?fkf))
                )
              (not (= ?sgj ?fkf))
              )
            (or (or (= ?sgm ?sgl)
                (= ?sgm ?fkf)
                )
              (= ?sgl ?fkf)
              )
            )
          (and (or (or (= ?sgk ?sgj)
                (= ?sgk ?fkf)
                )
              (= ?sgj ?fkf)
              )
            (and (and (not (= ?sgm ?sgl))
                (not (= ?sgm ?fkf))
                )
              (not (= ?sgl ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?sgn Real)
  (push 1)
    (declare-const ?sgo Real)
    (declare-const ?sgp Real)
    (declare-const ?sgq Real)
    (assert
      (or (or (= ?sgq ?sgp)
          (= ?sgq ?sgo)
          )
        (= ?sgp ?sgo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sgr Real)
    (declare-const ?sgs Real)
    (declare-const ?sgt Real)
    (declare-const ?sgu Real)
    (assert
      (or (or (= ?sgu ?sgt)
          (= ?sgu ?sgs)
          )
        (= ?sgt ?sgs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sgv Real)
    (declare-const ?sgw Real)
    (declare-const ?sgx Real)
    (declare-const ?sgy Real)
    (declare-const ?sgz Real)
    (assert
      (or (or (= ?sgz ?sgy)
          (= ?sgz ?sgx)
          )
        (= ?sgy ?sgx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sha Real)
    (declare-const ?shb Real)
    (declare-const ?shc Real)
    (declare-const ?shd Real)
    (declare-const ?she Real)
    (declare-const ?shf Real)
    (assert
      (and (and (and (not (= ?shc ?shb))
            (not (= ?shc ?sha))
            )
          (not (= ?shb ?sha))
          )
        (or (or (= ?shf ?she)
            (= ?shf ?shd)
            )
          (= ?she ?shd)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?shg Real)
    (declare-const ?shh Real)
    (declare-const ?shi Real)
    (assert
      (or (or (= ?shi ?shh)
          (= ?shi ?shg)
          )
        (= ?shh ?shg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?shj Real)
    (declare-const ?shk Real)
    (declare-const ?shl Real)
    (assert
      (or (or (= ?shl ?shk)
          (= ?shl ?shj)
          )
        (= ?shk ?shj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?shm Real)
    (declare-const ?shn Real)
    (declare-const ?sho Real)
    (declare-const ?shp Real)
    (assert
      (or (or (= ?sho ?shn)
          (= ?sho ?shm)
          )
        (= ?shn ?shm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?shq Real)
    (declare-const ?shr Real)
    (declare-const ?shs Real)
    (declare-const ?sht Real)
    (declare-const ?shu Real)
    (assert
      (or (or (= ?shs ?shr)
          (= ?shs ?shq)
          )
        (= ?shr ?shq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?shv Real)
    (declare-const ?shw Real)
    (declare-const ?shx Real)
    (declare-const ?shy Real)
    (declare-const ?shz Real)
    (declare-const ?sia Real)
    (assert
      (and (or (or (= ?shx ?shw)
            (= ?shx ?shv)
            )
          (= ?shw ?shv)
          )
        (and (and (not (= ?sia ?shz))
            (not (= ?sia ?shy))
            )
          (not (= ?shz ?shy))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sib Real)
    (declare-const ?sic Real)
    (declare-const ?sid Real)
    (assert
      (or (or (= ?sid ?sic)
          (= ?sid ?sib)
          )
        (= ?sic ?sib)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sie Real)
    (declare-const ?sif Real)
    (declare-const ?sig Real)
    (declare-const ?sih Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?sif ?sie))
                (not (= ?sif ?asi))
                )
              (not (= ?sie ?asi))
              )
            (or (or (= ?sih ?sig)
                (= ?sih ?asi)
                )
              (= ?sig ?asi)
              )
            )
          (and (or (or (= ?sif ?sie)
                (= ?sif ?asi)
                )
              (= ?sie ?asi)
              )
            (and (and (not (= ?sih ?sig))
                (not (= ?sih ?asi))
                )
              (not (= ?sig ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sii Real)
    (declare-const ?sij Real)
    (declare-const ?sik Real)
    (declare-const ?sil Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?sij ?sii))
                (not (= ?sij ?fkf))
                )
              (not (= ?sii ?fkf))
              )
            (or (or (= ?sil ?sik)
                (= ?sil ?fkf)
                )
              (= ?sik ?fkf)
              )
            )
          (and (or (or (= ?sij ?sii)
                (= ?sij ?fkf)
                )
              (= ?sii ?fkf)
              )
            (and (and (not (= ?sil ?sik))
                (not (= ?sil ?fkf))
                )
              (not (= ?sik ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?sim Real)
  (declare-const ?sin Real)
  (assert
    (not (= ?sim ?sin))
    )
  (push 1)
    (declare-const ?sio Real)
    (declare-const ?sip Real)
    (declare-const ?siq Real)
    (assert
      (or (or (= ?siq ?sip)
          (= ?siq ?sio)
          )
        (= ?sip ?sio)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sir Real)
    (declare-const ?sis Real)
    (declare-const ?sit Real)
    (declare-const ?siu Real)
    (assert
      (or (or (= ?siu ?sit)
          (= ?siu ?sis)
          )
        (= ?sit ?sis)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?siv Real)
    (declare-const ?siw Real)
    (declare-const ?six Real)
    (declare-const ?siy Real)
    (declare-const ?siz Real)
    (assert
      (or (or (= ?siz ?siy)
          (= ?siz ?six)
          )
        (= ?siy ?six)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sja Real)
    (declare-const ?sjb Real)
    (declare-const ?sjc Real)
    (declare-const ?sjd Real)
    (declare-const ?sje Real)
    (declare-const ?sjf Real)
    (assert
      (and (and (and (not (= ?sjc ?sjb))
            (not (= ?sjc ?sja))
            )
          (not (= ?sjb ?sja))
          )
        (or (or (= ?sjf ?sje)
            (= ?sjf ?sjd)
            )
          (= ?sje ?sjd)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sjg Real)
    (declare-const ?sjh Real)
    (declare-const ?sji Real)
    (assert
      (or (or (= ?sji ?sjh)
          (= ?sji ?sjg)
          )
        (= ?sjh ?sjg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sjj Real)
    (declare-const ?sjk Real)
    (declare-const ?sjl Real)
    (assert
      (or (or (= ?sjl ?sjk)
          (= ?sjl ?sjj)
          )
        (= ?sjk ?sjj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sjm Real)
    (declare-const ?sjn Real)
    (declare-const ?sjo Real)
    (declare-const ?sjp Real)
    (assert
      (or (or (= ?sjo ?sjn)
          (= ?sjo ?sjm)
          )
        (= ?sjn ?sjm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sjq Real)
    (declare-const ?sjr Real)
    (declare-const ?sjs Real)
    (declare-const ?sjt Real)
    (declare-const ?sju Real)
    (assert
      (or (or (= ?sjs ?sjr)
          (= ?sjs ?sjq)
          )
        (= ?sjr ?sjq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sjv Real)
    (declare-const ?sjw Real)
    (declare-const ?sjx Real)
    (declare-const ?sjy Real)
    (declare-const ?sjz Real)
    (declare-const ?ska Real)
    (assert
      (and (or (or (= ?sjx ?sjw)
            (= ?sjx ?sjv)
            )
          (= ?sjw ?sjv)
          )
        (and (and (not (= ?ska ?sjz))
            (not (= ?ska ?sjy))
            )
          (not (= ?sjz ?sjy))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?skb Real)
    (declare-const ?skc Real)
    (declare-const ?skd Real)
    (assert
      (or (or (= ?skd ?skc)
          (= ?skd ?skb)
          )
        (= ?skc ?skb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ske Real)
    (declare-const ?skf Real)
    (declare-const ?skg Real)
    (declare-const ?skh Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?skf ?ske))
                (not (= ?skf ?asi))
                )
              (not (= ?ske ?asi))
              )
            (or (or (= ?skh ?skg)
                (= ?skh ?asi)
                )
              (= ?skg ?asi)
              )
            )
          (and (or (or (= ?skf ?ske)
                (= ?skf ?asi)
                )
              (= ?ske ?asi)
              )
            (and (and (not (= ?skh ?skg))
                (not (= ?skh ?asi))
                )
              (not (= ?skg ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ski Real)
    (declare-const ?skj Real)
    (declare-const ?skk Real)
    (declare-const ?skl Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?skj ?ski))
                (not (= ?skj ?fkf))
                )
              (not (= ?ski ?fkf))
              )
            (or (or (= ?skl ?skk)
                (= ?skl ?fkf)
                )
              (= ?skk ?fkf)
              )
            )
          (and (or (or (= ?skj ?ski)
                (= ?skj ?fkf)
                )
              (= ?ski ?fkf)
              )
            (and (and (not (= ?skl ?skk))
                (not (= ?skl ?fkf))
                )
              (not (= ?skk ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?skm Real)
  (declare-const ?skn Real)
  (declare-const ?sko Real)
  (push 1)
    (declare-const ?skp Real)
    (declare-const ?skq Real)
    (declare-const ?skr Real)
    (assert
      (or (or (= ?skr ?skq)
          (= ?skr ?skp)
          )
        (= ?skq ?skp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sks Real)
    (declare-const ?skt Real)
    (declare-const ?sku Real)
    (declare-const ?skv Real)
    (assert
      (or (or (= ?skv ?sku)
          (= ?skv ?skt)
          )
        (= ?sku ?skt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?skw Real)
    (declare-const ?skx Real)
    (declare-const ?sky Real)
    (declare-const ?skz Real)
    (declare-const ?sla Real)
    (assert
      (or (or (= ?sla ?skz)
          (= ?sla ?sky)
          )
        (= ?skz ?sky)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?slb Real)
    (declare-const ?slc Real)
    (declare-const ?sld Real)
    (declare-const ?sle Real)
    (declare-const ?slf Real)
    (declare-const ?slg Real)
    (assert
      (and (and (and (not (= ?sld ?slc))
            (not (= ?sld ?slb))
            )
          (not (= ?slc ?slb))
          )
        (or (or (= ?slg ?slf)
            (= ?slg ?sle)
            )
          (= ?slf ?sle)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?slh Real)
    (declare-const ?sli Real)
    (declare-const ?slj Real)
    (assert
      (or (or (= ?slj ?sli)
          (= ?slj ?slh)
          )
        (= ?sli ?slh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?slk Real)
    (declare-const ?sll Real)
    (declare-const ?slm Real)
    (assert
      (or (or (= ?slm ?sll)
          (= ?slm ?slk)
          )
        (= ?sll ?slk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sln Real)
    (declare-const ?slo Real)
    (declare-const ?slp Real)
    (declare-const ?slq Real)
    (assert
      (or (or (= ?slp ?slo)
          (= ?slp ?sln)
          )
        (= ?slo ?sln)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?slr Real)
    (declare-const ?sls Real)
    (declare-const ?slt Real)
    (declare-const ?slu Real)
    (declare-const ?slv Real)
    (assert
      (or (or (= ?slt ?sls)
          (= ?slt ?slr)
          )
        (= ?sls ?slr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?slw Real)
    (declare-const ?slx Real)
    (declare-const ?sly Real)
    (declare-const ?slz Real)
    (declare-const ?sma Real)
    (declare-const ?smb Real)
    (assert
      (and (or (or (= ?sly ?slx)
            (= ?sly ?slw)
            )
          (= ?slx ?slw)
          )
        (and (and (not (= ?smb ?sma))
            (not (= ?smb ?slz))
            )
          (not (= ?sma ?slz))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?smc Real)
    (declare-const ?smd Real)
    (declare-const ?sme Real)
    (assert
      (or (or (= ?sme ?smd)
          (= ?sme ?smc)
          )
        (= ?smd ?smc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?smf Real)
    (declare-const ?smg Real)
    (declare-const ?smh Real)
    (declare-const ?smi Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?smg ?smf))
                (not (= ?smg ?asi))
                )
              (not (= ?smf ?asi))
              )
            (or (or (= ?smi ?smh)
                (= ?smi ?asi)
                )
              (= ?smh ?asi)
              )
            )
          (and (or (or (= ?smg ?smf)
                (= ?smg ?asi)
                )
              (= ?smf ?asi)
              )
            (and (and (not (= ?smi ?smh))
                (not (= ?smi ?asi))
                )
              (not (= ?smh ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?smj Real)
    (declare-const ?smk Real)
    (declare-const ?sml Real)
    (declare-const ?smm Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?smk ?smj))
                (not (= ?smk ?fkf))
                )
              (not (= ?smj ?fkf))
              )
            (or (or (= ?smm ?sml)
                (= ?smm ?fkf)
                )
              (= ?sml ?fkf)
              )
            )
          (and (or (or (= ?smk ?smj)
                (= ?smk ?fkf)
                )
              (= ?smj ?fkf)
              )
            (and (and (not (= ?smm ?sml))
                (not (= ?smm ?fkf))
                )
              (not (= ?sml ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?smn Real)
  (declare-const ?smo Real)
  (declare-const ?smp Real)
  (declare-const ?smq Real)
  (push 1)
    (declare-const ?smr Real)
    (declare-const ?sms Real)
    (declare-const ?smt Real)
    (assert
      (or (or (= ?smt ?sms)
          (= ?smt ?smr)
          )
        (= ?sms ?smr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?smu Real)
    (declare-const ?smv Real)
    (declare-const ?smw Real)
    (declare-const ?smx Real)
    (assert
      (or (or (= ?smx ?smw)
          (= ?smx ?smv)
          )
        (= ?smw ?smv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?smy Real)
    (declare-const ?smz Real)
    (declare-const ?sna Real)
    (declare-const ?snb Real)
    (declare-const ?snc Real)
    (assert
      (or (or (= ?snc ?snb)
          (= ?snc ?sna)
          )
        (= ?snb ?sna)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?snd Real)
    (declare-const ?sne Real)
    (declare-const ?snf Real)
    (declare-const ?sng Real)
    (declare-const ?snh Real)
    (declare-const ?sni Real)
    (assert
      (and (and (and (not (= ?snf ?sne))
            (not (= ?snf ?snd))
            )
          (not (= ?sne ?snd))
          )
        (or (or (= ?sni ?snh)
            (= ?sni ?sng)
            )
          (= ?snh ?sng)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?snj Real)
    (declare-const ?snk Real)
    (declare-const ?snl Real)
    (assert
      (or (or (= ?snl ?snk)
          (= ?snl ?snj)
          )
        (= ?snk ?snj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?snm Real)
    (declare-const ?snn Real)
    (declare-const ?sno Real)
    (assert
      (or (or (= ?sno ?snn)
          (= ?sno ?snm)
          )
        (= ?snn ?snm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?snp Real)
    (declare-const ?snq Real)
    (declare-const ?snr Real)
    (declare-const ?sns Real)
    (assert
      (or (or (= ?snr ?snq)
          (= ?snr ?snp)
          )
        (= ?snq ?snp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?snt Real)
    (declare-const ?snu Real)
    (declare-const ?snv Real)
    (declare-const ?snw Real)
    (declare-const ?snx Real)
    (assert
      (or (or (= ?snv ?snu)
          (= ?snv ?snt)
          )
        (= ?snu ?snt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sny Real)
    (declare-const ?snz Real)
    (declare-const ?soa Real)
    (declare-const ?sob Real)
    (declare-const ?soc Real)
    (declare-const ?sod Real)
    (assert
      (and (or (or (= ?soa ?snz)
            (= ?soa ?sny)
            )
          (= ?snz ?sny)
          )
        (and (and (not (= ?sod ?soc))
            (not (= ?sod ?sob))
            )
          (not (= ?soc ?sob))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?soe Real)
    (declare-const ?sof Real)
    (declare-const ?sog Real)
    (assert
      (or (or (= ?sog ?sof)
          (= ?sog ?soe)
          )
        (= ?sof ?soe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?soh Real)
    (declare-const ?soi Real)
    (declare-const ?soj Real)
    (declare-const ?sok Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?soi ?soh))
                (not (= ?soi ?asi))
                )
              (not (= ?soh ?asi))
              )
            (or (or (= ?sok ?soj)
                (= ?sok ?asi)
                )
              (= ?soj ?asi)
              )
            )
          (and (or (or (= ?soi ?soh)
                (= ?soi ?asi)
                )
              (= ?soh ?asi)
              )
            (and (and (not (= ?sok ?soj))
                (not (= ?sok ?asi))
                )
              (not (= ?soj ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sol Real)
    (declare-const ?som Real)
    (declare-const ?son Real)
    (declare-const ?soo Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?som ?sol))
                (not (= ?som ?fkf))
                )
              (not (= ?sol ?fkf))
              )
            (or (or (= ?soo ?son)
                (= ?soo ?fkf)
                )
              (= ?son ?fkf)
              )
            )
          (and (or (or (= ?som ?sol)
                (= ?som ?fkf)
                )
              (= ?sol ?fkf)
              )
            (and (and (not (= ?soo ?son))
                (not (= ?soo ?fkf))
                )
              (not (= ?son ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?sop Real)
  (push 1)
    (declare-const ?soq Real)
    (declare-const ?sor Real)
    (declare-const ?sos Real)
    (assert
      (or (or (= ?sos ?sor)
          (= ?sos ?soq)
          )
        (= ?sor ?soq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sot Real)
    (declare-const ?sou Real)
    (declare-const ?sov Real)
    (declare-const ?sow Real)
    (assert
      (or (or (= ?sow ?sov)
          (= ?sow ?sou)
          )
        (= ?sov ?sou)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sox Real)
    (declare-const ?soy Real)
    (declare-const ?soz Real)
    (declare-const ?spa Real)
    (declare-const ?spb Real)
    (assert
      (or (or (= ?spb ?spa)
          (= ?spb ?soz)
          )
        (= ?spa ?soz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?spc Real)
    (declare-const ?spd Real)
    (declare-const ?spe Real)
    (declare-const ?spf Real)
    (declare-const ?spg Real)
    (declare-const ?sph Real)
    (assert
      (and (and (and (not (= ?spe ?spd))
            (not (= ?spe ?spc))
            )
          (not (= ?spd ?spc))
          )
        (or (or (= ?sph ?spg)
            (= ?sph ?spf)
            )
          (= ?spg ?spf)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?spi Real)
    (declare-const ?spj Real)
    (declare-const ?spk Real)
    (assert
      (or (or (= ?spk ?spj)
          (= ?spk ?spi)
          )
        (= ?spj ?spi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?spl Real)
    (declare-const ?spm Real)
    (declare-const ?spn Real)
    (assert
      (or (or (= ?spn ?spm)
          (= ?spn ?spl)
          )
        (= ?spm ?spl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?spo Real)
    (declare-const ?spp Real)
    (declare-const ?spq Real)
    (declare-const ?spr Real)
    (assert
      (or (or (= ?spq ?spp)
          (= ?spq ?spo)
          )
        (= ?spp ?spo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sps Real)
    (declare-const ?spt Real)
    (declare-const ?spu Real)
    (declare-const ?spv Real)
    (declare-const ?spw Real)
    (assert
      (or (or (= ?spu ?spt)
          (= ?spu ?sps)
          )
        (= ?spt ?sps)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?spx Real)
    (declare-const ?spy Real)
    (declare-const ?spz Real)
    (declare-const ?sqa Real)
    (declare-const ?sqb Real)
    (declare-const ?sqc Real)
    (assert
      (and (or (or (= ?spz ?spy)
            (= ?spz ?spx)
            )
          (= ?spy ?spx)
          )
        (and (and (not (= ?sqc ?sqb))
            (not (= ?sqc ?sqa))
            )
          (not (= ?sqb ?sqa))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sqd Real)
    (declare-const ?sqe Real)
    (declare-const ?sqf Real)
    (assert
      (or (or (= ?sqf ?sqe)
          (= ?sqf ?sqd)
          )
        (= ?sqe ?sqd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sqg Real)
    (declare-const ?sqh Real)
    (declare-const ?sqi Real)
    (declare-const ?sqj Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?sqh ?sqg))
                (not (= ?sqh ?asi))
                )
              (not (= ?sqg ?asi))
              )
            (or (or (= ?sqj ?sqi)
                (= ?sqj ?asi)
                )
              (= ?sqi ?asi)
              )
            )
          (and (or (or (= ?sqh ?sqg)
                (= ?sqh ?asi)
                )
              (= ?sqg ?asi)
              )
            (and (and (not (= ?sqj ?sqi))
                (not (= ?sqj ?asi))
                )
              (not (= ?sqi ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sqk Real)
    (declare-const ?sql Real)
    (declare-const ?sqm Real)
    (declare-const ?sqn Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?sql ?sqk))
                (not (= ?sql ?fkf))
                )
              (not (= ?sqk ?fkf))
              )
            (or (or (= ?sqn ?sqm)
                (= ?sqn ?fkf)
                )
              (= ?sqm ?fkf)
              )
            )
          (and (or (or (= ?sql ?sqk)
                (= ?sql ?fkf)
                )
              (= ?sqk ?fkf)
              )
            (and (and (not (= ?sqn ?sqm))
                (not (= ?sqn ?fkf))
                )
              (not (= ?sqm ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?sqo Real)
  (declare-const ?sqp Real)
  (push 1)
    (declare-const ?sqq Real)
    (declare-const ?sqr Real)
    (declare-const ?sqs Real)
    (assert
      (or (or (= ?sqs ?sqr)
          (= ?sqs ?sqq)
          )
        (= ?sqr ?sqq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sqt Real)
    (declare-const ?squ Real)
    (declare-const ?sqv Real)
    (declare-const ?sqw Real)
    (assert
      (or (or (= ?sqw ?sqv)
          (= ?sqw ?squ)
          )
        (= ?sqv ?squ)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sqx Real)
    (declare-const ?sqy Real)
    (declare-const ?sqz Real)
    (declare-const ?sra Real)
    (declare-const ?srb Real)
    (assert
      (or (or (= ?srb ?sra)
          (= ?srb ?sqz)
          )
        (= ?sra ?sqz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?src Real)
    (declare-const ?srd Real)
    (declare-const ?sre Real)
    (declare-const ?srf Real)
    (declare-const ?srg Real)
    (declare-const ?srh Real)
    (assert
      (and (and (and (not (= ?sre ?srd))
            (not (= ?sre ?src))
            )
          (not (= ?srd ?src))
          )
        (or (or (= ?srh ?srg)
            (= ?srh ?srf)
            )
          (= ?srg ?srf)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sri Real)
    (declare-const ?srj Real)
    (declare-const ?srk Real)
    (assert
      (or (or (= ?srk ?srj)
          (= ?srk ?sri)
          )
        (= ?srj ?sri)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?srl Real)
    (declare-const ?srm Real)
    (declare-const ?srn Real)
    (assert
      (or (or (= ?srn ?srm)
          (= ?srn ?srl)
          )
        (= ?srm ?srl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sro Real)
    (declare-const ?srp Real)
    (declare-const ?srq Real)
    (declare-const ?srr Real)
    (assert
      (or (or (= ?srq ?srp)
          (= ?srq ?sro)
          )
        (= ?srp ?sro)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?srs Real)
    (declare-const ?srt Real)
    (declare-const ?sru Real)
    (declare-const ?srv Real)
    (declare-const ?srw Real)
    (assert
      (or (or (= ?sru ?srt)
          (= ?sru ?srs)
          )
        (= ?srt ?srs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?srx Real)
    (declare-const ?sry Real)
    (declare-const ?srz Real)
    (declare-const ?ssa Real)
    (declare-const ?ssb Real)
    (declare-const ?ssc Real)
    (assert
      (and (or (or (= ?srz ?sry)
            (= ?srz ?srx)
            )
          (= ?sry ?srx)
          )
        (and (and (not (= ?ssc ?ssb))
            (not (= ?ssc ?ssa))
            )
          (not (= ?ssb ?ssa))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ssd Real)
    (declare-const ?sse Real)
    (declare-const ?ssf Real)
    (assert
      (or (or (= ?ssf ?sse)
          (= ?ssf ?ssd)
          )
        (= ?sse ?ssd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ssg Real)
    (declare-const ?ssh Real)
    (declare-const ?ssi Real)
    (declare-const ?ssj Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ssh ?ssg))
                (not (= ?ssh ?asi))
                )
              (not (= ?ssg ?asi))
              )
            (or (or (= ?ssj ?ssi)
                (= ?ssj ?asi)
                )
              (= ?ssi ?asi)
              )
            )
          (and (or (or (= ?ssh ?ssg)
                (= ?ssh ?asi)
                )
              (= ?ssg ?asi)
              )
            (and (and (not (= ?ssj ?ssi))
                (not (= ?ssj ?asi))
                )
              (not (= ?ssi ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ssk Real)
    (declare-const ?ssl Real)
    (declare-const ?ssm Real)
    (declare-const ?ssn Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ssl ?ssk))
                (not (= ?ssl ?fkf))
                )
              (not (= ?ssk ?fkf))
              )
            (or (or (= ?ssn ?ssm)
                (= ?ssn ?fkf)
                )
              (= ?ssm ?fkf)
              )
            )
          (and (or (or (= ?ssl ?ssk)
                (= ?ssl ?fkf)
                )
              (= ?ssk ?fkf)
              )
            (and (and (not (= ?ssn ?ssm))
                (not (= ?ssn ?fkf))
                )
              (not (= ?ssm ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?sso Real)
  (declare-const ?ssp Real)
  (declare-const ?ssq Real)
  (push 1)
    (declare-const ?ssr Real)
    (declare-const ?sss Real)
    (declare-const ?sst Real)
    (assert
      (or (or (= ?sst ?sss)
          (= ?sst ?ssr)
          )
        (= ?sss ?ssr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ssu Real)
    (declare-const ?ssv Real)
    (declare-const ?ssw Real)
    (declare-const ?ssx Real)
    (assert
      (or (or (= ?ssx ?ssw)
          (= ?ssx ?ssv)
          )
        (= ?ssw ?ssv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ssy Real)
    (declare-const ?ssz Real)
    (declare-const ?sta Real)
    (declare-const ?stb Real)
    (declare-const ?stc Real)
    (assert
      (or (or (= ?stc ?stb)
          (= ?stc ?sta)
          )
        (= ?stb ?sta)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?std Real)
    (declare-const ?ste Real)
    (declare-const ?stf Real)
    (declare-const ?stg Real)
    (declare-const ?sth Real)
    (declare-const ?sti Real)
    (assert
      (and (and (and (not (= ?stf ?ste))
            (not (= ?stf ?std))
            )
          (not (= ?ste ?std))
          )
        (or (or (= ?sti ?sth)
            (= ?sti ?stg)
            )
          (= ?sth ?stg)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?stj Real)
    (declare-const ?stk Real)
    (declare-const ?stl Real)
    (assert
      (or (or (= ?stl ?stk)
          (= ?stl ?stj)
          )
        (= ?stk ?stj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?stm Real)
    (declare-const ?stn Real)
    (declare-const ?sto Real)
    (assert
      (or (or (= ?sto ?stn)
          (= ?sto ?stm)
          )
        (= ?stn ?stm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?stp Real)
    (declare-const ?stq Real)
    (declare-const ?str Real)
    (declare-const ?sts Real)
    (assert
      (or (or (= ?str ?stq)
          (= ?str ?stp)
          )
        (= ?stq ?stp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?stt Real)
    (declare-const ?stu Real)
    (declare-const ?stv Real)
    (declare-const ?stw Real)
    (declare-const ?stx Real)
    (assert
      (or (or (= ?stv ?stu)
          (= ?stv ?stt)
          )
        (= ?stu ?stt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sty Real)
    (declare-const ?stz Real)
    (declare-const ?sua Real)
    (declare-const ?sub Real)
    (declare-const ?suc Real)
    (declare-const ?sud Real)
    (assert
      (and (or (or (= ?sua ?stz)
            (= ?sua ?sty)
            )
          (= ?stz ?sty)
          )
        (and (and (not (= ?sud ?suc))
            (not (= ?sud ?sub))
            )
          (not (= ?suc ?sub))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sue Real)
    (declare-const ?suf Real)
    (declare-const ?sug Real)
    (assert
      (or (or (= ?sug ?suf)
          (= ?sug ?sue)
          )
        (= ?suf ?sue)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?suh Real)
    (declare-const ?sui Real)
    (declare-const ?suj Real)
    (declare-const ?suk Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?sui ?suh))
                (not (= ?sui ?asi))
                )
              (not (= ?suh ?asi))
              )
            (or (or (= ?suk ?suj)
                (= ?suk ?asi)
                )
              (= ?suj ?asi)
              )
            )
          (and (or (or (= ?sui ?suh)
                (= ?sui ?asi)
                )
              (= ?suh ?asi)
              )
            (and (and (not (= ?suk ?suj))
                (not (= ?suk ?asi))
                )
              (not (= ?suj ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sul Real)
    (declare-const ?sum Real)
    (declare-const ?sun Real)
    (declare-const ?suo Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?sum ?sul))
                (not (= ?sum ?fkf))
                )
              (not (= ?sul ?fkf))
              )
            (or (or (= ?suo ?sun)
                (= ?suo ?fkf)
                )
              (= ?sun ?fkf)
              )
            )
          (and (or (or (= ?sum ?sul)
                (= ?sum ?fkf)
                )
              (= ?sul ?fkf)
              )
            (and (and (not (= ?suo ?sun))
                (not (= ?suo ?fkf))
                )
              (not (= ?sun ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?sup Real)
  (declare-const ?suq Real)
  (declare-const ?sur Real)
  (declare-const ?sus Real)
  (assert
    (exists ((?mzs Real) )(or (and (and (and (not (= ?suq ?sup))
              (not (= ?suq ?mzs))
              )
            (not (= ?sup ?mzs))
            )
          (or (or (= ?sus ?sur)
              (= ?sus ?mzs)
              )
            (= ?sur ?mzs)
            )
          )
        (and (or (or (= ?suq ?sup)
              (= ?suq ?mzs)
              )
            (= ?sup ?mzs)
            )
          (and (and (not (= ?sus ?sur))
              (not (= ?sus ?mzs))
              )
            (not (= ?sur ?mzs))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?sut Real)
    (declare-const ?suu Real)
    (declare-const ?suv Real)
    (assert
      (or (or (= ?suv ?suu)
          (= ?suv ?sut)
          )
        (= ?suu ?sut)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?suw Real)
    (declare-const ?sux Real)
    (declare-const ?suy Real)
    (declare-const ?suz Real)
    (assert
      (or (or (= ?suz ?suy)
          (= ?suz ?sux)
          )
        (= ?suy ?sux)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sva Real)
    (declare-const ?svb Real)
    (declare-const ?svc Real)
    (declare-const ?svd Real)
    (declare-const ?sve Real)
    (assert
      (or (or (= ?sve ?svd)
          (= ?sve ?svc)
          )
        (= ?svd ?svc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?svf Real)
    (declare-const ?svg Real)
    (declare-const ?svh Real)
    (declare-const ?svi Real)
    (declare-const ?svj Real)
    (declare-const ?svk Real)
    (assert
      (and (and (and (not (= ?svh ?svg))
            (not (= ?svh ?svf))
            )
          (not (= ?svg ?svf))
          )
        (or (or (= ?svk ?svj)
            (= ?svk ?svi)
            )
          (= ?svj ?svi)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?svl Real)
    (declare-const ?svm Real)
    (declare-const ?svn Real)
    (assert
      (or (or (= ?svn ?svm)
          (= ?svn ?svl)
          )
        (= ?svm ?svl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?svo Real)
    (declare-const ?svp Real)
    (declare-const ?svq Real)
    (assert
      (or (or (= ?svq ?svp)
          (= ?svq ?svo)
          )
        (= ?svp ?svo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?svr Real)
    (declare-const ?svs Real)
    (declare-const ?svt Real)
    (declare-const ?svu Real)
    (assert
      (or (or (= ?svt ?svs)
          (= ?svt ?svr)
          )
        (= ?svs ?svr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?svv Real)
    (declare-const ?svw Real)
    (declare-const ?svx Real)
    (declare-const ?svy Real)
    (declare-const ?svz Real)
    (assert
      (or (or (= ?svx ?svw)
          (= ?svx ?svv)
          )
        (= ?svw ?svv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?swa Real)
    (declare-const ?swb Real)
    (declare-const ?swc Real)
    (declare-const ?swd Real)
    (declare-const ?swe Real)
    (declare-const ?swf Real)
    (assert
      (and (or (or (= ?swc ?swb)
            (= ?swc ?swa)
            )
          (= ?swb ?swa)
          )
        (and (and (not (= ?swf ?swe))
            (not (= ?swf ?swd))
            )
          (not (= ?swe ?swd))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?swg Real)
    (declare-const ?swh Real)
    (declare-const ?swi Real)
    (assert
      (or (or (= ?swi ?swh)
          (= ?swi ?swg)
          )
        (= ?swh ?swg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?swj Real)
    (declare-const ?swk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?swl Real)
    (declare-const ?swm Real)
    (declare-const ?swn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?swo Real)
    (declare-const ?swp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?swq Real)
    (declare-const ?swr Real)
    (declare-const ?sws Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?swt Real)
    (declare-const ?swu Real)
    (declare-const ?swv Real)
    (declare-const ?sww Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?swu ?swt))
                (not (= ?swu ?asi))
                )
              (not (= ?swt ?asi))
              )
            (or (or (= ?sww ?swv)
                (= ?sww ?asi)
                )
              (= ?swv ?asi)
              )
            )
          (and (or (or (= ?swu ?swt)
                (= ?swu ?asi)
                )
              (= ?swt ?asi)
              )
            (and (and (not (= ?sww ?swv))
                (not (= ?sww ?asi))
                )
              (not (= ?swv ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?swx Real)
    (declare-const ?swy Real)
    (declare-const ?swz Real)
    (declare-const ?sxa Real)
    (declare-const ?sxb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sxc Real)
    (declare-const ?sxd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sxe Real)
    (declare-const ?sxf Real)
    (declare-const ?sxg Real)
    (declare-const ?sxh Real)
    (declare-const ?sxi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sxj Real)
    (declare-const ?sxk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sxl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sxm Real)
    (declare-const ?sxn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sxo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sxp Real)
    (declare-const ?sxq Real)
    (assert
      (not (= ?sxp ?sxq))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sxr Real)
    (declare-const ?sxs Real)
    (declare-const ?sxt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sxu Real)
    (declare-const ?sxv Real)
    (declare-const ?sxw Real)
    (declare-const ?sxx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sxy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sxz Real)
    (declare-const ?sya Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?syb Real)
    (declare-const ?syc Real)
    (declare-const ?syd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?sye Real)
    (declare-const ?syf Real)
    (declare-const ?syg Real)
    (declare-const ?syh Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?syf ?sye))
                (not (= ?syf ?fkf))
                )
              (not (= ?sye ?fkf))
              )
            (or (or (= ?syh ?syg)
                (= ?syh ?fkf)
                )
              (= ?syg ?fkf)
              )
            )
          (and (or (or (= ?syf ?sye)
                (= ?syf ?fkf)
                )
              (= ?sye ?fkf)
              )
            (and (and (not (= ?syh ?syg))
                (not (= ?syh ?fkf))
                )
              (not (= ?syg ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?syi Real)
    (declare-const ?syj Real)
    (declare-const ?syk Real)
    (declare-const ?syl Real)
    (declare-const ?sym Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?syn Real)
    (declare-const ?syo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?syp Real)
    (declare-const ?syq Real)
    (declare-const ?syr Real)
    (declare-const ?sys Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?syt Real)
    (declare-const ?syu Real)
    (declare-const ?syv Real)
    (declare-const ?syw Real)
    (declare-const ?syx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?syy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?syz Real)
    (declare-const ?sza Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?szb Real)
  (declare-const ?szc Real)
  (declare-const ?szd Real)
  (declare-const ?sze Real)
  (declare-const ?szf Real)
  (push 1)
    (declare-const ?szg Real)
    (declare-const ?szh Real)
    (declare-const ?szi Real)
    (assert
      (or (or (= ?szi ?szh)
          (= ?szi ?szg)
          )
        (= ?szh ?szg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?szj Real)
    (declare-const ?szk Real)
    (declare-const ?szl Real)
    (declare-const ?szm Real)
    (assert
      (or (or (= ?szm ?szl)
          (= ?szm ?szk)
          )
        (= ?szl ?szk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?szn Real)
    (declare-const ?szo Real)
    (declare-const ?szp Real)
    (declare-const ?szq Real)
    (declare-const ?szr Real)
    (assert
      (or (or (= ?szr ?szq)
          (= ?szr ?szp)
          )
        (= ?szq ?szp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?szs Real)
    (declare-const ?szt Real)
    (declare-const ?szu Real)
    (declare-const ?szv Real)
    (declare-const ?szw Real)
    (declare-const ?szx Real)
    (assert
      (and (and (and (not (= ?szu ?szt))
            (not (= ?szu ?szs))
            )
          (not (= ?szt ?szs))
          )
        (or (or (= ?szx ?szw)
            (= ?szx ?szv)
            )
          (= ?szw ?szv)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?szy Real)
    (declare-const ?szz Real)
    (declare-const ?taa Real)
    (assert
      (or (or (= ?taa ?szz)
          (= ?taa ?szy)
          )
        (= ?szz ?szy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tab Real)
    (declare-const ?tac Real)
    (declare-const ?tad Real)
    (assert
      (or (or (= ?tad ?tac)
          (= ?tad ?tab)
          )
        (= ?tac ?tab)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tae Real)
    (declare-const ?taf Real)
    (declare-const ?tag Real)
    (declare-const ?tah Real)
    (assert
      (or (or (= ?tag ?taf)
          (= ?tag ?tae)
          )
        (= ?taf ?tae)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tai Real)
    (declare-const ?taj Real)
    (declare-const ?tak Real)
    (declare-const ?tal Real)
    (declare-const ?tam Real)
    (assert
      (or (or (= ?tak ?taj)
          (= ?tak ?tai)
          )
        (= ?taj ?tai)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tan Real)
    (declare-const ?tao Real)
    (declare-const ?tap Real)
    (declare-const ?taq Real)
    (declare-const ?tar Real)
    (declare-const ?tas Real)
    (assert
      (and (or (or (= ?tap ?tao)
            (= ?tap ?tan)
            )
          (= ?tao ?tan)
          )
        (and (and (not (= ?tas ?tar))
            (not (= ?tas ?taq))
            )
          (not (= ?tar ?taq))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tat Real)
    (declare-const ?tau Real)
    (declare-const ?tav Real)
    (assert
      (or (or (= ?tav ?tau)
          (= ?tav ?tat)
          )
        (= ?tau ?tat)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?taw Real)
    (declare-const ?tax Real)
    (declare-const ?tay Real)
    (declare-const ?taz Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?tax ?taw))
                (not (= ?tax ?asi))
                )
              (not (= ?taw ?asi))
              )
            (or (or (= ?taz ?tay)
                (= ?taz ?asi)
                )
              (= ?tay ?asi)
              )
            )
          (and (or (or (= ?tax ?taw)
                (= ?tax ?asi)
                )
              (= ?taw ?asi)
              )
            (and (and (not (= ?taz ?tay))
                (not (= ?taz ?asi))
                )
              (not (= ?tay ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tba Real)
    (declare-const ?tbb Real)
    (declare-const ?tbc Real)
    (declare-const ?tbd Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?tbb ?tba))
                (not (= ?tbb ?fkf))
                )
              (not (= ?tba ?fkf))
              )
            (or (or (= ?tbd ?tbc)
                (= ?tbd ?fkf)
                )
              (= ?tbc ?fkf)
              )
            )
          (and (or (or (= ?tbb ?tba)
                (= ?tbb ?fkf)
                )
              (= ?tba ?fkf)
              )
            (and (and (not (= ?tbd ?tbc))
                (not (= ?tbd ?fkf))
                )
              (not (= ?tbc ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?tbe Real)
  (declare-const ?tbf Real)
  (push 1)
    (declare-const ?tbg Real)
    (declare-const ?tbh Real)
    (declare-const ?tbi Real)
    (assert
      (or (or (= ?tbi ?tbh)
          (= ?tbi ?tbg)
          )
        (= ?tbh ?tbg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tbj Real)
    (declare-const ?tbk Real)
    (declare-const ?tbl Real)
    (declare-const ?tbm Real)
    (assert
      (or (or (= ?tbm ?tbl)
          (= ?tbm ?tbk)
          )
        (= ?tbl ?tbk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tbn Real)
    (declare-const ?tbo Real)
    (declare-const ?tbp Real)
    (declare-const ?tbq Real)
    (declare-const ?tbr Real)
    (assert
      (or (or (= ?tbr ?tbq)
          (= ?tbr ?tbp)
          )
        (= ?tbq ?tbp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tbs Real)
    (declare-const ?tbt Real)
    (declare-const ?tbu Real)
    (declare-const ?tbv Real)
    (declare-const ?tbw Real)
    (declare-const ?tbx Real)
    (assert
      (and (and (and (not (= ?tbu ?tbt))
            (not (= ?tbu ?tbs))
            )
          (not (= ?tbt ?tbs))
          )
        (or (or (= ?tbx ?tbw)
            (= ?tbx ?tbv)
            )
          (= ?tbw ?tbv)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tby Real)
    (declare-const ?tbz Real)
    (declare-const ?tca Real)
    (assert
      (or (or (= ?tca ?tbz)
          (= ?tca ?tby)
          )
        (= ?tbz ?tby)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tcb Real)
    (declare-const ?tcc Real)
    (declare-const ?tcd Real)
    (assert
      (or (or (= ?tcd ?tcc)
          (= ?tcd ?tcb)
          )
        (= ?tcc ?tcb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tce Real)
    (declare-const ?tcf Real)
    (declare-const ?tcg Real)
    (declare-const ?tch Real)
    (assert
      (or (or (= ?tcg ?tcf)
          (= ?tcg ?tce)
          )
        (= ?tcf ?tce)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tci Real)
    (declare-const ?tcj Real)
    (declare-const ?tck Real)
    (declare-const ?tcl Real)
    (declare-const ?tcm Real)
    (assert
      (or (or (= ?tck ?tcj)
          (= ?tck ?tci)
          )
        (= ?tcj ?tci)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tcn Real)
    (declare-const ?tco Real)
    (declare-const ?tcp Real)
    (declare-const ?tcq Real)
    (declare-const ?tcr Real)
    (declare-const ?tcs Real)
    (assert
      (and (or (or (= ?tcp ?tco)
            (= ?tcp ?tcn)
            )
          (= ?tco ?tcn)
          )
        (and (and (not (= ?tcs ?tcr))
            (not (= ?tcs ?tcq))
            )
          (not (= ?tcr ?tcq))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tct Real)
    (declare-const ?tcu Real)
    (declare-const ?tcv Real)
    (assert
      (or (or (= ?tcv ?tcu)
          (= ?tcv ?tct)
          )
        (= ?tcu ?tct)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tcw Real)
    (declare-const ?tcx Real)
    (declare-const ?tcy Real)
    (declare-const ?tcz Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?tcx ?tcw))
                (not (= ?tcx ?asi))
                )
              (not (= ?tcw ?asi))
              )
            (or (or (= ?tcz ?tcy)
                (= ?tcz ?asi)
                )
              (= ?tcy ?asi)
              )
            )
          (and (or (or (= ?tcx ?tcw)
                (= ?tcx ?asi)
                )
              (= ?tcw ?asi)
              )
            (and (and (not (= ?tcz ?tcy))
                (not (= ?tcz ?asi))
                )
              (not (= ?tcy ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tda Real)
    (declare-const ?tdb Real)
    (declare-const ?tdc Real)
    (declare-const ?tdd Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?tdb ?tda))
                (not (= ?tdb ?fkf))
                )
              (not (= ?tda ?fkf))
              )
            (or (or (= ?tdd ?tdc)
                (= ?tdd ?fkf)
                )
              (= ?tdc ?fkf)
              )
            )
          (and (or (or (= ?tdb ?tda)
                (= ?tdb ?fkf)
                )
              (= ?tda ?fkf)
              )
            (and (and (not (= ?tdd ?tdc))
                (not (= ?tdd ?fkf))
                )
              (not (= ?tdc ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?tde Real)
  (declare-const ?tdf Real)
  (declare-const ?tdg Real)
  (push 1)
    (declare-const ?tdh Real)
    (declare-const ?tdi Real)
    (declare-const ?tdj Real)
    (assert
      (or (or (= ?tdj ?tdi)
          (= ?tdj ?tdh)
          )
        (= ?tdi ?tdh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tdk Real)
    (declare-const ?tdl Real)
    (declare-const ?tdm Real)
    (declare-const ?tdn Real)
    (assert
      (or (or (= ?tdn ?tdm)
          (= ?tdn ?tdl)
          )
        (= ?tdm ?tdl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tdo Real)
    (declare-const ?tdp Real)
    (declare-const ?tdq Real)
    (declare-const ?tdr Real)
    (declare-const ?tds Real)
    (assert
      (or (or (= ?tds ?tdr)
          (= ?tds ?tdq)
          )
        (= ?tdr ?tdq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tdt Real)
    (declare-const ?tdu Real)
    (declare-const ?tdv Real)
    (declare-const ?tdw Real)
    (declare-const ?tdx Real)
    (declare-const ?tdy Real)
    (assert
      (and (and (and (not (= ?tdv ?tdu))
            (not (= ?tdv ?tdt))
            )
          (not (= ?tdu ?tdt))
          )
        (or (or (= ?tdy ?tdx)
            (= ?tdy ?tdw)
            )
          (= ?tdx ?tdw)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tdz Real)
    (declare-const ?tea Real)
    (declare-const ?teb Real)
    (assert
      (or (or (= ?teb ?tea)
          (= ?teb ?tdz)
          )
        (= ?tea ?tdz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tec Real)
    (declare-const ?ted Real)
    (declare-const ?tee Real)
    (assert
      (or (or (= ?tee ?ted)
          (= ?tee ?tec)
          )
        (= ?ted ?tec)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tef Real)
    (declare-const ?teg Real)
    (declare-const ?teh Real)
    (declare-const ?tei Real)
    (assert
      (or (or (= ?teh ?teg)
          (= ?teh ?tef)
          )
        (= ?teg ?tef)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tej Real)
    (declare-const ?tek Real)
    (declare-const ?tel Real)
    (declare-const ?tem Real)
    (declare-const ?ten Real)
    (assert
      (or (or (= ?tel ?tek)
          (= ?tel ?tej)
          )
        (= ?tek ?tej)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?teo Real)
    (declare-const ?tep Real)
    (declare-const ?teq Real)
    (declare-const ?ter Real)
    (declare-const ?tes Real)
    (declare-const ?tet Real)
    (assert
      (and (or (or (= ?teq ?tep)
            (= ?teq ?teo)
            )
          (= ?tep ?teo)
          )
        (and (and (not (= ?tet ?tes))
            (not (= ?tet ?ter))
            )
          (not (= ?tes ?ter))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?teu Real)
    (declare-const ?tev Real)
    (declare-const ?tew Real)
    (assert
      (or (or (= ?tew ?tev)
          (= ?tew ?teu)
          )
        (= ?tev ?teu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tex Real)
    (declare-const ?tey Real)
    (declare-const ?tez Real)
    (declare-const ?tfa Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?tey ?tex))
                (not (= ?tey ?asi))
                )
              (not (= ?tex ?asi))
              )
            (or (or (= ?tfa ?tez)
                (= ?tfa ?asi)
                )
              (= ?tez ?asi)
              )
            )
          (and (or (or (= ?tey ?tex)
                (= ?tey ?asi)
                )
              (= ?tex ?asi)
              )
            (and (and (not (= ?tfa ?tez))
                (not (= ?tfa ?asi))
                )
              (not (= ?tez ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tfb Real)
    (declare-const ?tfc Real)
    (declare-const ?tfd Real)
    (declare-const ?tfe Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?tfc ?tfb))
                (not (= ?tfc ?fkf))
                )
              (not (= ?tfb ?fkf))
              )
            (or (or (= ?tfe ?tfd)
                (= ?tfe ?fkf)
                )
              (= ?tfd ?fkf)
              )
            )
          (and (or (or (= ?tfc ?tfb)
                (= ?tfc ?fkf)
                )
              (= ?tfb ?fkf)
              )
            (and (and (not (= ?tfe ?tfd))
                (not (= ?tfe ?fkf))
                )
              (not (= ?tfd ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?tff Real)
  (declare-const ?tfg Real)
  (declare-const ?tfh Real)
  (declare-const ?tfi Real)
  (push 1)
    (declare-const ?tfj Real)
    (declare-const ?tfk Real)
    (declare-const ?tfl Real)
    (assert
      (or (or (= ?tfl ?tfk)
          (= ?tfl ?tfj)
          )
        (= ?tfk ?tfj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tfm Real)
    (declare-const ?tfn Real)
    (declare-const ?tfo Real)
    (declare-const ?tfp Real)
    (assert
      (or (or (= ?tfp ?tfo)
          (= ?tfp ?tfn)
          )
        (= ?tfo ?tfn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tfq Real)
    (declare-const ?tfr Real)
    (declare-const ?tfs Real)
    (declare-const ?tft Real)
    (declare-const ?tfu Real)
    (assert
      (or (or (= ?tfu ?tft)
          (= ?tfu ?tfs)
          )
        (= ?tft ?tfs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tfv Real)
    (declare-const ?tfw Real)
    (declare-const ?tfx Real)
    (declare-const ?tfy Real)
    (declare-const ?tfz Real)
    (declare-const ?tga Real)
    (assert
      (and (and (and (not (= ?tfx ?tfw))
            (not (= ?tfx ?tfv))
            )
          (not (= ?tfw ?tfv))
          )
        (or (or (= ?tga ?tfz)
            (= ?tga ?tfy)
            )
          (= ?tfz ?tfy)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tgb Real)
    (declare-const ?tgc Real)
    (declare-const ?tgd Real)
    (assert
      (or (or (= ?tgd ?tgc)
          (= ?tgd ?tgb)
          )
        (= ?tgc ?tgb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tge Real)
    (declare-const ?tgf Real)
    (declare-const ?tgg Real)
    (assert
      (or (or (= ?tgg ?tgf)
          (= ?tgg ?tge)
          )
        (= ?tgf ?tge)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tgh Real)
    (declare-const ?tgi Real)
    (declare-const ?tgj Real)
    (declare-const ?tgk Real)
    (assert
      (or (or (= ?tgj ?tgi)
          (= ?tgj ?tgh)
          )
        (= ?tgi ?tgh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tgl Real)
    (declare-const ?tgm Real)
    (declare-const ?tgn Real)
    (declare-const ?tgo Real)
    (declare-const ?tgp Real)
    (assert
      (or (or (= ?tgn ?tgm)
          (= ?tgn ?tgl)
          )
        (= ?tgm ?tgl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tgq Real)
    (declare-const ?tgr Real)
    (declare-const ?tgs Real)
    (declare-const ?tgt Real)
    (declare-const ?tgu Real)
    (declare-const ?tgv Real)
    (assert
      (and (or (or (= ?tgs ?tgr)
            (= ?tgs ?tgq)
            )
          (= ?tgr ?tgq)
          )
        (and (and (not (= ?tgv ?tgu))
            (not (= ?tgv ?tgt))
            )
          (not (= ?tgu ?tgt))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tgw Real)
    (declare-const ?tgx Real)
    (declare-const ?tgy Real)
    (assert
      (or (or (= ?tgy ?tgx)
          (= ?tgy ?tgw)
          )
        (= ?tgx ?tgw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tgz Real)
    (declare-const ?tha Real)
    (declare-const ?thb Real)
    (declare-const ?thc Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?tha ?tgz))
                (not (= ?tha ?asi))
                )
              (not (= ?tgz ?asi))
              )
            (or (or (= ?thc ?thb)
                (= ?thc ?asi)
                )
              (= ?thb ?asi)
              )
            )
          (and (or (or (= ?tha ?tgz)
                (= ?tha ?asi)
                )
              (= ?tgz ?asi)
              )
            (and (and (not (= ?thc ?thb))
                (not (= ?thc ?asi))
                )
              (not (= ?thb ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?thd Real)
    (declare-const ?the Real)
    (declare-const ?thf Real)
    (declare-const ?thg Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?the ?thd))
                (not (= ?the ?fkf))
                )
              (not (= ?thd ?fkf))
              )
            (or (or (= ?thg ?thf)
                (= ?thg ?fkf)
                )
              (= ?thf ?fkf)
              )
            )
          (and (or (or (= ?the ?thd)
                (= ?the ?fkf)
                )
              (= ?thd ?fkf)
              )
            (and (and (not (= ?thg ?thf))
                (not (= ?thg ?fkf))
                )
              (not (= ?thf ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?thh Real)
  (declare-const ?thi Real)
  (declare-const ?thj Real)
  (declare-const ?thk Real)
  (declare-const ?thl Real)
  (push 1)
    (declare-const ?thm Real)
    (declare-const ?thn Real)
    (declare-const ?tho Real)
    (assert
      (or (or (= ?tho ?thn)
          (= ?tho ?thm)
          )
        (= ?thn ?thm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?thp Real)
    (declare-const ?thq Real)
    (declare-const ?thr Real)
    (declare-const ?ths Real)
    (assert
      (or (or (= ?ths ?thr)
          (= ?ths ?thq)
          )
        (= ?thr ?thq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tht Real)
    (declare-const ?thu Real)
    (declare-const ?thv Real)
    (declare-const ?thw Real)
    (declare-const ?thx Real)
    (assert
      (or (or (= ?thx ?thw)
          (= ?thx ?thv)
          )
        (= ?thw ?thv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?thy Real)
    (declare-const ?thz Real)
    (declare-const ?tia Real)
    (declare-const ?tib Real)
    (declare-const ?tic Real)
    (declare-const ?tid Real)
    (assert
      (and (and (and (not (= ?tia ?thz))
            (not (= ?tia ?thy))
            )
          (not (= ?thz ?thy))
          )
        (or (or (= ?tid ?tic)
            (= ?tid ?tib)
            )
          (= ?tic ?tib)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tie Real)
    (declare-const ?tif Real)
    (declare-const ?tig Real)
    (assert
      (or (or (= ?tig ?tif)
          (= ?tig ?tie)
          )
        (= ?tif ?tie)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tih Real)
    (declare-const ?tii Real)
    (declare-const ?tij Real)
    (assert
      (or (or (= ?tij ?tii)
          (= ?tij ?tih)
          )
        (= ?tii ?tih)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tik Real)
    (declare-const ?til Real)
    (declare-const ?tim Real)
    (declare-const ?tin Real)
    (assert
      (or (or (= ?tim ?til)
          (= ?tim ?tik)
          )
        (= ?til ?tik)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tio Real)
    (declare-const ?tip Real)
    (declare-const ?tiq Real)
    (declare-const ?tir Real)
    (declare-const ?tis Real)
    (assert
      (or (or (= ?tiq ?tip)
          (= ?tiq ?tio)
          )
        (= ?tip ?tio)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tit Real)
    (declare-const ?tiu Real)
    (declare-const ?tiv Real)
    (declare-const ?tiw Real)
    (declare-const ?tix Real)
    (declare-const ?tiy Real)
    (assert
      (and (or (or (= ?tiv ?tiu)
            (= ?tiv ?tit)
            )
          (= ?tiu ?tit)
          )
        (and (and (not (= ?tiy ?tix))
            (not (= ?tiy ?tiw))
            )
          (not (= ?tix ?tiw))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tiz Real)
    (declare-const ?tja Real)
    (declare-const ?tjb Real)
    (assert
      (or (or (= ?tjb ?tja)
          (= ?tjb ?tiz)
          )
        (= ?tja ?tiz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tjc Real)
    (declare-const ?tjd Real)
    (declare-const ?tje Real)
    (declare-const ?tjf Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?tjd ?tjc))
                (not (= ?tjd ?asi))
                )
              (not (= ?tjc ?asi))
              )
            (or (or (= ?tjf ?tje)
                (= ?tjf ?asi)
                )
              (= ?tje ?asi)
              )
            )
          (and (or (or (= ?tjd ?tjc)
                (= ?tjd ?asi)
                )
              (= ?tjc ?asi)
              )
            (and (and (not (= ?tjf ?tje))
                (not (= ?tjf ?asi))
                )
              (not (= ?tje ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tjg Real)
    (declare-const ?tjh Real)
    (declare-const ?tji Real)
    (declare-const ?tjj Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?tjh ?tjg))
                (not (= ?tjh ?fkf))
                )
              (not (= ?tjg ?fkf))
              )
            (or (or (= ?tjj ?tji)
                (= ?tjj ?fkf)
                )
              (= ?tji ?fkf)
              )
            )
          (and (or (or (= ?tjh ?tjg)
                (= ?tjh ?fkf)
                )
              (= ?tjg ?fkf)
              )
            (and (and (not (= ?tjj ?tji))
                (not (= ?tjj ?fkf))
                )
              (not (= ?tji ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?tjk Real)
    (declare-const ?tjl Real)
    (declare-const ?tjm Real)
    (assert
      (or (or (= ?tjm ?tjl)
          (= ?tjm ?tjk)
          )
        (= ?tjl ?tjk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tjn Real)
    (declare-const ?tjo Real)
    (declare-const ?tjp Real)
    (declare-const ?tjq Real)
    (assert
      (or (or (= ?tjq ?tjp)
          (= ?tjq ?tjo)
          )
        (= ?tjp ?tjo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tjr Real)
    (declare-const ?tjs Real)
    (declare-const ?tjt Real)
    (declare-const ?tju Real)
    (declare-const ?tjv Real)
    (assert
      (or (or (= ?tjv ?tju)
          (= ?tjv ?tjt)
          )
        (= ?tju ?tjt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tjw Real)
    (declare-const ?tjx Real)
    (declare-const ?tjy Real)
    (declare-const ?tjz Real)
    (declare-const ?tka Real)
    (declare-const ?tkb Real)
    (assert
      (and (and (and (not (= ?tjy ?tjx))
            (not (= ?tjy ?tjw))
            )
          (not (= ?tjx ?tjw))
          )
        (or (or (= ?tkb ?tka)
            (= ?tkb ?tjz)
            )
          (= ?tka ?tjz)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tkc Real)
    (declare-const ?tkd Real)
    (declare-const ?tke Real)
    (assert
      (or (or (= ?tke ?tkd)
          (= ?tke ?tkc)
          )
        (= ?tkd ?tkc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tkf Real)
    (declare-const ?tkg Real)
    (declare-const ?tkh Real)
    (assert
      (or (or (= ?tkh ?tkg)
          (= ?tkh ?tkf)
          )
        (= ?tkg ?tkf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tki Real)
    (declare-const ?tkj Real)
    (declare-const ?tkk Real)
    (declare-const ?tkl Real)
    (assert
      (or (or (= ?tkk ?tkj)
          (= ?tkk ?tki)
          )
        (= ?tkj ?tki)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tkm Real)
    (declare-const ?tkn Real)
    (declare-const ?tko Real)
    (declare-const ?tkp Real)
    (declare-const ?tkq Real)
    (assert
      (or (or (= ?tko ?tkn)
          (= ?tko ?tkm)
          )
        (= ?tkn ?tkm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tkr Real)
    (declare-const ?tks Real)
    (declare-const ?tkt Real)
    (declare-const ?tku Real)
    (declare-const ?tkv Real)
    (declare-const ?tkw Real)
    (assert
      (and (or (or (= ?tkt ?tks)
            (= ?tkt ?tkr)
            )
          (= ?tks ?tkr)
          )
        (and (and (not (= ?tkw ?tkv))
            (not (= ?tkw ?tku))
            )
          (not (= ?tkv ?tku))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tkx Real)
    (declare-const ?tky Real)
    (declare-const ?tkz Real)
    (assert
      (or (or (= ?tkz ?tky)
          (= ?tkz ?tkx)
          )
        (= ?tky ?tkx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tla Real)
    (declare-const ?tlb Real)
    (declare-const ?tlc Real)
    (declare-const ?tld Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?tlb ?tla))
                (not (= ?tlb ?asi))
                )
              (not (= ?tla ?asi))
              )
            (or (or (= ?tld ?tlc)
                (= ?tld ?asi)
                )
              (= ?tlc ?asi)
              )
            )
          (and (or (or (= ?tlb ?tla)
                (= ?tlb ?asi)
                )
              (= ?tla ?asi)
              )
            (and (and (not (= ?tld ?tlc))
                (not (= ?tld ?asi))
                )
              (not (= ?tlc ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tle Real)
    (declare-const ?tlf Real)
    (declare-const ?tlg Real)
    (declare-const ?tlh Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?tlf ?tle))
                (not (= ?tlf ?fkf))
                )
              (not (= ?tle ?fkf))
              )
            (or (or (= ?tlh ?tlg)
                (= ?tlh ?fkf)
                )
              (= ?tlg ?fkf)
              )
            )
          (and (or (or (= ?tlf ?tle)
                (= ?tlf ?fkf)
                )
              (= ?tle ?fkf)
              )
            (and (and (not (= ?tlh ?tlg))
                (not (= ?tlh ?fkf))
                )
              (not (= ?tlg ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?tli Real)
  (push 1)
    (declare-const ?tlj Real)
    (declare-const ?tlk Real)
    (declare-const ?tll Real)
    (assert
      (or (or (= ?tll ?tlk)
          (= ?tll ?tlj)
          )
        (= ?tlk ?tlj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tlm Real)
    (declare-const ?tln Real)
    (declare-const ?tlo Real)
    (declare-const ?tlp Real)
    (assert
      (or (or (= ?tlp ?tlo)
          (= ?tlp ?tln)
          )
        (= ?tlo ?tln)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tlq Real)
    (declare-const ?tlr Real)
    (declare-const ?tls Real)
    (declare-const ?tlt Real)
    (declare-const ?tlu Real)
    (assert
      (or (or (= ?tlu ?tlt)
          (= ?tlu ?tls)
          )
        (= ?tlt ?tls)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tlv Real)
    (declare-const ?tlw Real)
    (declare-const ?tlx Real)
    (declare-const ?tly Real)
    (declare-const ?tlz Real)
    (declare-const ?tma Real)
    (assert
      (and (and (and (not (= ?tlx ?tlw))
            (not (= ?tlx ?tlv))
            )
          (not (= ?tlw ?tlv))
          )
        (or (or (= ?tma ?tlz)
            (= ?tma ?tly)
            )
          (= ?tlz ?tly)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tmb Real)
    (declare-const ?tmc Real)
    (declare-const ?tmd Real)
    (assert
      (or (or (= ?tmd ?tmc)
          (= ?tmd ?tmb)
          )
        (= ?tmc ?tmb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tme Real)
    (declare-const ?tmf Real)
    (declare-const ?tmg Real)
    (assert
      (or (or (= ?tmg ?tmf)
          (= ?tmg ?tme)
          )
        (= ?tmf ?tme)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tmh Real)
    (declare-const ?tmi Real)
    (declare-const ?tmj Real)
    (declare-const ?tmk Real)
    (assert
      (or (or (= ?tmj ?tmi)
          (= ?tmj ?tmh)
          )
        (= ?tmi ?tmh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tml Real)
    (declare-const ?tmm Real)
    (declare-const ?tmn Real)
    (declare-const ?tmo Real)
    (declare-const ?tmp Real)
    (assert
      (or (or (= ?tmn ?tmm)
          (= ?tmn ?tml)
          )
        (= ?tmm ?tml)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tmq Real)
    (declare-const ?tmr Real)
    (declare-const ?tms Real)
    (declare-const ?tmt Real)
    (declare-const ?tmu Real)
    (declare-const ?tmv Real)
    (assert
      (and (or (or (= ?tms ?tmr)
            (= ?tms ?tmq)
            )
          (= ?tmr ?tmq)
          )
        (and (and (not (= ?tmv ?tmu))
            (not (= ?tmv ?tmt))
            )
          (not (= ?tmu ?tmt))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tmw Real)
    (declare-const ?tmx Real)
    (declare-const ?tmy Real)
    (assert
      (or (or (= ?tmy ?tmx)
          (= ?tmy ?tmw)
          )
        (= ?tmx ?tmw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tmz Real)
    (declare-const ?tna Real)
    (declare-const ?tnb Real)
    (declare-const ?tnc Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?tna ?tmz))
                (not (= ?tna ?asi))
                )
              (not (= ?tmz ?asi))
              )
            (or (or (= ?tnc ?tnb)
                (= ?tnc ?asi)
                )
              (= ?tnb ?asi)
              )
            )
          (and (or (or (= ?tna ?tmz)
                (= ?tna ?asi)
                )
              (= ?tmz ?asi)
              )
            (and (and (not (= ?tnc ?tnb))
                (not (= ?tnc ?asi))
                )
              (not (= ?tnb ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tnd Real)
    (declare-const ?tne Real)
    (declare-const ?tnf Real)
    (declare-const ?tng Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?tne ?tnd))
                (not (= ?tne ?fkf))
                )
              (not (= ?tnd ?fkf))
              )
            (or (or (= ?tng ?tnf)
                (= ?tng ?fkf)
                )
              (= ?tnf ?fkf)
              )
            )
          (and (or (or (= ?tne ?tnd)
                (= ?tne ?fkf)
                )
              (= ?tnd ?fkf)
              )
            (and (and (not (= ?tng ?tnf))
                (not (= ?tng ?fkf))
                )
              (not (= ?tnf ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?tnh Real)
  (declare-const ?tni Real)
  (push 1)
    (declare-const ?tnj Real)
    (declare-const ?tnk Real)
    (declare-const ?tnl Real)
    (assert
      (or (or (= ?tnl ?tnk)
          (= ?tnl ?tnj)
          )
        (= ?tnk ?tnj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tnm Real)
    (declare-const ?tnn Real)
    (declare-const ?tno Real)
    (declare-const ?tnp Real)
    (assert
      (or (or (= ?tnp ?tno)
          (= ?tnp ?tnn)
          )
        (= ?tno ?tnn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tnq Real)
    (declare-const ?tnr Real)
    (declare-const ?tns Real)
    (declare-const ?tnt Real)
    (declare-const ?tnu Real)
    (assert
      (or (or (= ?tnu ?tnt)
          (= ?tnu ?tns)
          )
        (= ?tnt ?tns)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tnv Real)
    (declare-const ?tnw Real)
    (declare-const ?tnx Real)
    (declare-const ?tny Real)
    (declare-const ?tnz Real)
    (declare-const ?toa Real)
    (assert
      (and (and (and (not (= ?tnx ?tnw))
            (not (= ?tnx ?tnv))
            )
          (not (= ?tnw ?tnv))
          )
        (or (or (= ?toa ?tnz)
            (= ?toa ?tny)
            )
          (= ?tnz ?tny)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tob Real)
    (declare-const ?toc Real)
    (declare-const ?tod Real)
    (assert
      (or (or (= ?tod ?toc)
          (= ?tod ?tob)
          )
        (= ?toc ?tob)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?toe Real)
    (declare-const ?tof Real)
    (declare-const ?tog Real)
    (assert
      (or (or (= ?tog ?tof)
          (= ?tog ?toe)
          )
        (= ?tof ?toe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?toh Real)
    (declare-const ?toi Real)
    (declare-const ?toj Real)
    (declare-const ?tok Real)
    (assert
      (or (or (= ?toj ?toi)
          (= ?toj ?toh)
          )
        (= ?toi ?toh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tol Real)
    (declare-const ?tom Real)
    (declare-const ?ton Real)
    (declare-const ?too Real)
    (declare-const ?top Real)
    (assert
      (or (or (= ?ton ?tom)
          (= ?ton ?tol)
          )
        (= ?tom ?tol)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?toq Real)
    (declare-const ?tor Real)
    (declare-const ?tos Real)
    (declare-const ?tot Real)
    (declare-const ?tou Real)
    (declare-const ?tov Real)
    (assert
      (and (or (or (= ?tos ?tor)
            (= ?tos ?toq)
            )
          (= ?tor ?toq)
          )
        (and (and (not (= ?tov ?tou))
            (not (= ?tov ?tot))
            )
          (not (= ?tou ?tot))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tow Real)
    (declare-const ?tox Real)
    (declare-const ?toy Real)
    (assert
      (or (or (= ?toy ?tox)
          (= ?toy ?tow)
          )
        (= ?tox ?tow)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?toz Real)
    (declare-const ?tpa Real)
    (declare-const ?tpb Real)
    (declare-const ?tpc Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?tpa ?toz))
                (not (= ?tpa ?asi))
                )
              (not (= ?toz ?asi))
              )
            (or (or (= ?tpc ?tpb)
                (= ?tpc ?asi)
                )
              (= ?tpb ?asi)
              )
            )
          (and (or (or (= ?tpa ?toz)
                (= ?tpa ?asi)
                )
              (= ?toz ?asi)
              )
            (and (and (not (= ?tpc ?tpb))
                (not (= ?tpc ?asi))
                )
              (not (= ?tpb ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tpd Real)
    (declare-const ?tpe Real)
    (declare-const ?tpf Real)
    (declare-const ?tpg Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?tpe ?tpd))
                (not (= ?tpe ?fkf))
                )
              (not (= ?tpd ?fkf))
              )
            (or (or (= ?tpg ?tpf)
                (= ?tpg ?fkf)
                )
              (= ?tpf ?fkf)
              )
            )
          (and (or (or (= ?tpe ?tpd)
                (= ?tpe ?fkf)
                )
              (= ?tpd ?fkf)
              )
            (and (and (not (= ?tpg ?tpf))
                (not (= ?tpg ?fkf))
                )
              (not (= ?tpf ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?tph Real)
  (declare-const ?tpi Real)
  (declare-const ?tpj Real)
  (assert
    (or (or (= ?tpj ?tpi)
        (= ?tpj ?tph)
        )
      (= ?tpi ?tph)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?tpk Real)
    (declare-const ?tpl Real)
    (declare-const ?tpm Real)
    (assert
      (or (or (= ?tpm ?tpl)
          (= ?tpm ?tpk)
          )
        (= ?tpl ?tpk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tpn Real)
    (declare-const ?tpo Real)
    (declare-const ?tpp Real)
    (declare-const ?tpq Real)
    (assert
      (or (or (= ?tpq ?tpp)
          (= ?tpq ?tpo)
          )
        (= ?tpp ?tpo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tpr Real)
    (declare-const ?tps Real)
    (declare-const ?tpt Real)
    (declare-const ?tpu Real)
    (declare-const ?tpv Real)
    (assert
      (or (or (= ?tpv ?tpu)
          (= ?tpv ?tpt)
          )
        (= ?tpu ?tpt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tpw Real)
    (declare-const ?tpx Real)
    (declare-const ?tpy Real)
    (declare-const ?tpz Real)
    (declare-const ?tqa Real)
    (declare-const ?tqb Real)
    (assert
      (and (and (and (not (= ?tpy ?tpx))
            (not (= ?tpy ?tpw))
            )
          (not (= ?tpx ?tpw))
          )
        (or (or (= ?tqb ?tqa)
            (= ?tqb ?tpz)
            )
          (= ?tqa ?tpz)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tqc Real)
    (declare-const ?tqd Real)
    (declare-const ?tqe Real)
    (assert
      (or (or (= ?tqe ?tqd)
          (= ?tqe ?tqc)
          )
        (= ?tqd ?tqc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tqf Real)
    (declare-const ?tqg Real)
    (declare-const ?tqh Real)
    (assert
      (or (or (= ?tqh ?tqg)
          (= ?tqh ?tqf)
          )
        (= ?tqg ?tqf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tqi Real)
    (declare-const ?tqj Real)
    (declare-const ?tqk Real)
    (declare-const ?tql Real)
    (assert
      (or (or (= ?tqk ?tqj)
          (= ?tqk ?tqi)
          )
        (= ?tqj ?tqi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tqm Real)
    (declare-const ?tqn Real)
    (declare-const ?tqo Real)
    (declare-const ?tqp Real)
    (declare-const ?tqq Real)
    (assert
      (or (or (= ?tqo ?tqn)
          (= ?tqo ?tqm)
          )
        (= ?tqn ?tqm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tqr Real)
    (declare-const ?tqs Real)
    (declare-const ?tqt Real)
    (declare-const ?tqu Real)
    (declare-const ?tqv Real)
    (declare-const ?tqw Real)
    (assert
      (and (or (or (= ?tqt ?tqs)
            (= ?tqt ?tqr)
            )
          (= ?tqs ?tqr)
          )
        (and (and (not (= ?tqw ?tqv))
            (not (= ?tqw ?tqu))
            )
          (not (= ?tqv ?tqu))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tqx Real)
    (declare-const ?tqy Real)
    (declare-const ?tqz Real)
    (assert
      (or (or (= ?tqz ?tqy)
          (= ?tqz ?tqx)
          )
        (= ?tqy ?tqx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tra Real)
    (declare-const ?trb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?trc Real)
    (declare-const ?trd Real)
    (declare-const ?tre Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?trf Real)
    (declare-const ?trg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?trh Real)
    (declare-const ?tri Real)
    (declare-const ?trj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?trk Real)
    (declare-const ?trl Real)
    (declare-const ?trm Real)
    (declare-const ?trn Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?trl ?trk))
                (not (= ?trl ?asi))
                )
              (not (= ?trk ?asi))
              )
            (or (or (= ?trn ?trm)
                (= ?trn ?asi)
                )
              (= ?trm ?asi)
              )
            )
          (and (or (or (= ?trl ?trk)
                (= ?trl ?asi)
                )
              (= ?trk ?asi)
              )
            (and (and (not (= ?trn ?trm))
                (not (= ?trn ?asi))
                )
              (not (= ?trm ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tro Real)
    (declare-const ?trp Real)
    (declare-const ?trq Real)
    (declare-const ?trr Real)
    (declare-const ?trs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?trt Real)
    (declare-const ?tru Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?trv Real)
    (declare-const ?trw Real)
    (declare-const ?trx Real)
    (declare-const ?try Real)
    (declare-const ?trz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tsa Real)
    (declare-const ?tsb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tsc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tsd Real)
    (declare-const ?tse Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tsf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tsg Real)
    (declare-const ?tsh Real)
    (assert
      (not (= ?tsg ?tsh))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tsi Real)
    (declare-const ?tsj Real)
    (declare-const ?tsk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tsl Real)
    (declare-const ?tsm Real)
    (declare-const ?tsn Real)
    (declare-const ?tso Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tsp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tsq Real)
    (declare-const ?tsr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tss Real)
    (declare-const ?tst Real)
    (declare-const ?tsu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tsv Real)
    (declare-const ?tsw Real)
    (declare-const ?tsx Real)
    (declare-const ?tsy Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?tsw ?tsv))
                (not (= ?tsw ?fkf))
                )
              (not (= ?tsv ?fkf))
              )
            (or (or (= ?tsy ?tsx)
                (= ?tsy ?fkf)
                )
              (= ?tsx ?fkf)
              )
            )
          (and (or (or (= ?tsw ?tsv)
                (= ?tsw ?fkf)
                )
              (= ?tsv ?fkf)
              )
            (and (and (not (= ?tsy ?tsx))
                (not (= ?tsy ?fkf))
                )
              (not (= ?tsx ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tsz Real)
    (declare-const ?tta Real)
    (declare-const ?ttb Real)
    (declare-const ?ttc Real)
    (declare-const ?ttd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tte Real)
    (declare-const ?ttf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ttg Real)
    (declare-const ?tth Real)
    (declare-const ?tti Real)
    (declare-const ?ttj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ttk Real)
    (declare-const ?ttl Real)
    (declare-const ?ttm Real)
    (declare-const ?ttn Real)
    (declare-const ?tto Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ttp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ttq Real)
    (declare-const ?ttr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tts Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ttt Real)
    (declare-const ?ttu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ttv Real)
    (declare-const ?ttw Real)
    (declare-const ?ttx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tty Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ttz Real)
    (declare-const ?tua Real)
    (assert
      (not (= ?ttz ?tua))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tub Real)
    (declare-const ?tuc Real)
    (declare-const ?tud Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tue Real)
    (declare-const ?tuf Real)
    (declare-const ?tug Real)
    (declare-const ?tuh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tui Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tuj Real)
    (declare-const ?tuk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tul Real)
    (declare-const ?tum Real)
    (declare-const ?tun Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tuo Real)
    (declare-const ?tup Real)
    (declare-const ?tuq Real)
    (declare-const ?tur Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?tup ?tuo))
                (not (= ?tup ?mzs))
                )
              (not (= ?tuo ?mzs))
              )
            (or (or (= ?tur ?tuq)
                (= ?tur ?mzs)
                )
              (= ?tuq ?mzs)
              )
            )
          (and (or (or (= ?tup ?tuo)
                (= ?tup ?mzs)
                )
              (= ?tuo ?mzs)
              )
            (and (and (not (= ?tur ?tuq))
                (not (= ?tur ?mzs))
                )
              (not (= ?tuq ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tus Real)
    (declare-const ?tut Real)
    (declare-const ?tuu Real)
    (declare-const ?tuv Real)
    (declare-const ?tuw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tux Real)
    (declare-const ?tuy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tuz Real)
    (declare-const ?tva Real)
    (declare-const ?tvb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tvc Real)
    (declare-const ?tvd Real)
    (declare-const ?tve Real)
    (declare-const ?tvf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tvg Real)
    (declare-const ?tvh Real)
    (declare-const ?tvi Real)
    (declare-const ?tvj Real)
    (declare-const ?tvk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tvl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tvm Real)
    (declare-const ?tvn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?tvo Real)
  (declare-const ?tvp Real)
  (declare-const ?tvq Real)
  (declare-const ?tvr Real)
  (assert
    (or (or (= ?tvr ?tvq)
        (= ?tvr ?tvp)
        )
      (= ?tvq ?tvp)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?tvs Real)
    (declare-const ?tvt Real)
    (declare-const ?tvu Real)
    (assert
      (or (or (= ?tvu ?tvt)
          (= ?tvu ?tvs)
          )
        (= ?tvt ?tvs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tvv Real)
    (declare-const ?tvw Real)
    (declare-const ?tvx Real)
    (declare-const ?tvy Real)
    (assert
      (or (or (= ?tvy ?tvx)
          (= ?tvy ?tvw)
          )
        (= ?tvx ?tvw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tvz Real)
    (declare-const ?twa Real)
    (declare-const ?twb Real)
    (declare-const ?twc Real)
    (declare-const ?twd Real)
    (assert
      (or (or (= ?twd ?twc)
          (= ?twd ?twb)
          )
        (= ?twc ?twb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?twe Real)
    (declare-const ?twf Real)
    (declare-const ?twg Real)
    (declare-const ?twh Real)
    (declare-const ?twi Real)
    (declare-const ?twj Real)
    (assert
      (and (and (and (not (= ?twg ?twf))
            (not (= ?twg ?twe))
            )
          (not (= ?twf ?twe))
          )
        (or (or (= ?twj ?twi)
            (= ?twj ?twh)
            )
          (= ?twi ?twh)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?twk Real)
    (declare-const ?twl Real)
    (declare-const ?twm Real)
    (assert
      (or (or (= ?twm ?twl)
          (= ?twm ?twk)
          )
        (= ?twl ?twk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?twn Real)
    (declare-const ?two Real)
    (declare-const ?twp Real)
    (assert
      (or (or (= ?twp ?two)
          (= ?twp ?twn)
          )
        (= ?two ?twn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?twq Real)
    (declare-const ?twr Real)
    (declare-const ?tws Real)
    (declare-const ?twt Real)
    (assert
      (or (or (= ?tws ?twr)
          (= ?tws ?twq)
          )
        (= ?twr ?twq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?twu Real)
    (declare-const ?twv Real)
    (declare-const ?tww Real)
    (declare-const ?twx Real)
    (declare-const ?twy Real)
    (assert
      (or (or (= ?tww ?twv)
          (= ?tww ?twu)
          )
        (= ?twv ?twu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?twz Real)
    (declare-const ?txa Real)
    (declare-const ?txb Real)
    (declare-const ?txc Real)
    (declare-const ?txd Real)
    (declare-const ?txe Real)
    (assert
      (and (or (or (= ?txb ?txa)
            (= ?txb ?twz)
            )
          (= ?txa ?twz)
          )
        (and (and (not (= ?txe ?txd))
            (not (= ?txe ?txc))
            )
          (not (= ?txd ?txc))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?txf Real)
    (declare-const ?txg Real)
    (declare-const ?txh Real)
    (assert
      (or (or (= ?txh ?txg)
          (= ?txh ?txf)
          )
        (= ?txg ?txf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?txi Real)
    (declare-const ?txj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?txk Real)
    (declare-const ?txl Real)
    (declare-const ?txm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?txn Real)
    (declare-const ?txo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?txp Real)
    (declare-const ?txq Real)
    (declare-const ?txr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?txs Real)
    (declare-const ?txt Real)
    (declare-const ?txu Real)
    (declare-const ?txv Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?txt ?txs))
                (not (= ?txt ?asi))
                )
              (not (= ?txs ?asi))
              )
            (or (or (= ?txv ?txu)
                (= ?txv ?asi)
                )
              (= ?txu ?asi)
              )
            )
          (and (or (or (= ?txt ?txs)
                (= ?txt ?asi)
                )
              (= ?txs ?asi)
              )
            (and (and (not (= ?txv ?txu))
                (not (= ?txv ?asi))
                )
              (not (= ?txu ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?txw Real)
    (declare-const ?txx Real)
    (declare-const ?txy Real)
    (declare-const ?txz Real)
    (declare-const ?tya Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tyb Real)
    (declare-const ?tyc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tyd Real)
    (declare-const ?tye Real)
    (declare-const ?tyf Real)
    (declare-const ?tyg Real)
    (declare-const ?tyh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tyi Real)
    (declare-const ?tyj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tyk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tyl Real)
    (declare-const ?tym Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tyn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tyo Real)
    (declare-const ?typ Real)
    (assert
      (not (= ?tyo ?typ))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tyq Real)
    (declare-const ?tyr Real)
    (declare-const ?tys Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tyt Real)
    (declare-const ?tyu Real)
    (declare-const ?tyv Real)
    (declare-const ?tyw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tyx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tyy Real)
    (declare-const ?tyz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tza Real)
    (declare-const ?tzb Real)
    (declare-const ?tzc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tzd Real)
    (declare-const ?tze Real)
    (declare-const ?tzf Real)
    (declare-const ?tzg Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?tze ?tzd))
                (not (= ?tze ?fkf))
                )
              (not (= ?tzd ?fkf))
              )
            (or (or (= ?tzg ?tzf)
                (= ?tzg ?fkf)
                )
              (= ?tzf ?fkf)
              )
            )
          (and (or (or (= ?tze ?tzd)
                (= ?tze ?fkf)
                )
              (= ?tzd ?fkf)
              )
            (and (and (not (= ?tzg ?tzf))
                (not (= ?tzg ?fkf))
                )
              (not (= ?tzf ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tzh Real)
    (declare-const ?tzi Real)
    (declare-const ?tzj Real)
    (declare-const ?tzk Real)
    (declare-const ?tzl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tzm Real)
    (declare-const ?tzn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tzo Real)
    (declare-const ?tzp Real)
    (declare-const ?tzq Real)
    (declare-const ?tzr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tzs Real)
    (declare-const ?tzt Real)
    (declare-const ?tzu Real)
    (declare-const ?tzv Real)
    (declare-const ?tzw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tzx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?tzy Real)
    (declare-const ?tzz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uaa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uab Real)
    (declare-const ?uac Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uad Real)
    (declare-const ?uae Real)
    (declare-const ?uaf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uag Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uah Real)
    (declare-const ?uai Real)
    (assert
      (not (= ?uah ?uai))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uaj Real)
    (declare-const ?uak Real)
    (declare-const ?ual Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uam Real)
    (declare-const ?uan Real)
    (declare-const ?uao Real)
    (declare-const ?uap Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uaq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uar Real)
    (declare-const ?uas Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uat Real)
    (declare-const ?uau Real)
    (declare-const ?uav Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uaw Real)
    (declare-const ?uax Real)
    (declare-const ?uay Real)
    (declare-const ?uaz Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?uax ?uaw))
                (not (= ?uax ?mzs))
                )
              (not (= ?uaw ?mzs))
              )
            (or (or (= ?uaz ?uay)
                (= ?uaz ?mzs)
                )
              (= ?uay ?mzs)
              )
            )
          (and (or (or (= ?uax ?uaw)
                (= ?uax ?mzs)
                )
              (= ?uaw ?mzs)
              )
            (and (and (not (= ?uaz ?uay))
                (not (= ?uaz ?mzs))
                )
              (not (= ?uay ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uba Real)
    (declare-const ?ubb Real)
    (declare-const ?ubc Real)
    (declare-const ?ubd Real)
    (declare-const ?ube Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ubf Real)
    (declare-const ?ubg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ubh Real)
    (declare-const ?ubi Real)
    (declare-const ?ubj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ubk Real)
    (declare-const ?ubl Real)
    (declare-const ?ubm Real)
    (declare-const ?ubn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ubo Real)
    (declare-const ?ubp Real)
    (declare-const ?ubq Real)
    (declare-const ?ubr Real)
    (declare-const ?ubs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ubt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ubu Real)
    (declare-const ?ubv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ubw Real)
  (declare-const ?ubx Real)
  (declare-const ?uby Real)
  (declare-const ?ubz Real)
  (declare-const ?uca Real)
  (assert
    (or (or (= ?uca ?ubz)
        (= ?uca ?uby)
        )
      (= ?ubz ?uby)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?ucb Real)
    (declare-const ?ucc Real)
    (declare-const ?ucd Real)
    (assert
      (or (or (= ?ucd ?ucc)
          (= ?ucd ?ucb)
          )
        (= ?ucc ?ucb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uce Real)
    (declare-const ?ucf Real)
    (declare-const ?ucg Real)
    (declare-const ?uch Real)
    (assert
      (or (or (= ?uch ?ucg)
          (= ?uch ?ucf)
          )
        (= ?ucg ?ucf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uci Real)
    (declare-const ?ucj Real)
    (declare-const ?uck Real)
    (declare-const ?ucl Real)
    (declare-const ?ucm Real)
    (assert
      (or (or (= ?ucm ?ucl)
          (= ?ucm ?uck)
          )
        (= ?ucl ?uck)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ucn Real)
    (declare-const ?uco Real)
    (declare-const ?ucp Real)
    (declare-const ?ucq Real)
    (declare-const ?ucr Real)
    (declare-const ?ucs Real)
    (assert
      (and (and (and (not (= ?ucp ?uco))
            (not (= ?ucp ?ucn))
            )
          (not (= ?uco ?ucn))
          )
        (or (or (= ?ucs ?ucr)
            (= ?ucs ?ucq)
            )
          (= ?ucr ?ucq)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uct Real)
    (declare-const ?ucu Real)
    (declare-const ?ucv Real)
    (assert
      (or (or (= ?ucv ?ucu)
          (= ?ucv ?uct)
          )
        (= ?ucu ?uct)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ucw Real)
    (declare-const ?ucx Real)
    (declare-const ?ucy Real)
    (assert
      (or (or (= ?ucy ?ucx)
          (= ?ucy ?ucw)
          )
        (= ?ucx ?ucw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ucz Real)
    (declare-const ?uda Real)
    (declare-const ?udb Real)
    (declare-const ?udc Real)
    (assert
      (or (or (= ?udb ?uda)
          (= ?udb ?ucz)
          )
        (= ?uda ?ucz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?udd Real)
    (declare-const ?ude Real)
    (declare-const ?udf Real)
    (declare-const ?udg Real)
    (declare-const ?udh Real)
    (assert
      (or (or (= ?udf ?ude)
          (= ?udf ?udd)
          )
        (= ?ude ?udd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?udi Real)
    (declare-const ?udj Real)
    (declare-const ?udk Real)
    (declare-const ?udl Real)
    (declare-const ?udm Real)
    (declare-const ?udn Real)
    (assert
      (and (or (or (= ?udk ?udj)
            (= ?udk ?udi)
            )
          (= ?udj ?udi)
          )
        (and (and (not (= ?udn ?udm))
            (not (= ?udn ?udl))
            )
          (not (= ?udm ?udl))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?udo Real)
    (declare-const ?udp Real)
    (declare-const ?udq Real)
    (assert
      (or (or (= ?udq ?udp)
          (= ?udq ?udo)
          )
        (= ?udp ?udo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?udr Real)
    (declare-const ?uds Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?udt Real)
    (declare-const ?udu Real)
    (declare-const ?udv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?udw Real)
    (declare-const ?udx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?udy Real)
    (declare-const ?udz Real)
    (declare-const ?uea Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ueb Real)
    (declare-const ?uec Real)
    (declare-const ?ued Real)
    (declare-const ?uee Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?uec ?ueb))
                (not (= ?uec ?asi))
                )
              (not (= ?ueb ?asi))
              )
            (or (or (= ?uee ?ued)
                (= ?uee ?asi)
                )
              (= ?ued ?asi)
              )
            )
          (and (or (or (= ?uec ?ueb)
                (= ?uec ?asi)
                )
              (= ?ueb ?asi)
              )
            (and (and (not (= ?uee ?ued))
                (not (= ?uee ?asi))
                )
              (not (= ?ued ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uef Real)
    (declare-const ?ueg Real)
    (declare-const ?ueh Real)
    (declare-const ?uei Real)
    (declare-const ?uej Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uek Real)
    (declare-const ?uel Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uem Real)
    (declare-const ?uen Real)
    (declare-const ?ueo Real)
    (declare-const ?uep Real)
    (declare-const ?ueq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uer Real)
    (declare-const ?ues Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uet Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ueu Real)
    (declare-const ?uev Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uew Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uex Real)
    (declare-const ?uey Real)
    (assert
      (not (= ?uex ?uey))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uez Real)
    (declare-const ?ufa Real)
    (declare-const ?ufb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ufc Real)
    (declare-const ?ufd Real)
    (declare-const ?ufe Real)
    (declare-const ?uff Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ufg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ufh Real)
    (declare-const ?ufi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ufj Real)
    (declare-const ?ufk Real)
    (declare-const ?ufl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ufm Real)
    (declare-const ?ufn Real)
    (declare-const ?ufo Real)
    (declare-const ?ufp Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ufn ?ufm))
                (not (= ?ufn ?fkf))
                )
              (not (= ?ufm ?fkf))
              )
            (or (or (= ?ufp ?ufo)
                (= ?ufp ?fkf)
                )
              (= ?ufo ?fkf)
              )
            )
          (and (or (or (= ?ufn ?ufm)
                (= ?ufn ?fkf)
                )
              (= ?ufm ?fkf)
              )
            (and (and (not (= ?ufp ?ufo))
                (not (= ?ufp ?fkf))
                )
              (not (= ?ufo ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ufq Real)
    (declare-const ?ufr Real)
    (declare-const ?ufs Real)
    (declare-const ?uft Real)
    (declare-const ?ufu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ufv Real)
    (declare-const ?ufw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ufx Real)
    (declare-const ?ufy Real)
    (declare-const ?ufz Real)
    (declare-const ?uga Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ugb Real)
    (declare-const ?ugc Real)
    (declare-const ?ugd Real)
    (declare-const ?uge Real)
    (declare-const ?ugf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ugg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ugh Real)
    (declare-const ?ugi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ugj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ugk Real)
    (declare-const ?ugl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ugm Real)
    (declare-const ?ugn Real)
    (declare-const ?ugo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ugp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ugq Real)
    (declare-const ?ugr Real)
    (assert
      (not (= ?ugq ?ugr))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ugs Real)
    (declare-const ?ugt Real)
    (declare-const ?ugu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ugv Real)
    (declare-const ?ugw Real)
    (declare-const ?ugx Real)
    (declare-const ?ugy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ugz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uha Real)
    (declare-const ?uhb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uhc Real)
    (declare-const ?uhd Real)
    (declare-const ?uhe Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uhf Real)
    (declare-const ?uhg Real)
    (declare-const ?uhh Real)
    (declare-const ?uhi Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?uhg ?uhf))
                (not (= ?uhg ?mzs))
                )
              (not (= ?uhf ?mzs))
              )
            (or (or (= ?uhi ?uhh)
                (= ?uhi ?mzs)
                )
              (= ?uhh ?mzs)
              )
            )
          (and (or (or (= ?uhg ?uhf)
                (= ?uhg ?mzs)
                )
              (= ?uhf ?mzs)
              )
            (and (and (not (= ?uhi ?uhh))
                (not (= ?uhi ?mzs))
                )
              (not (= ?uhh ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uhj Real)
    (declare-const ?uhk Real)
    (declare-const ?uhl Real)
    (declare-const ?uhm Real)
    (declare-const ?uhn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uho Real)
    (declare-const ?uhp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uhq Real)
    (declare-const ?uhr Real)
    (declare-const ?uhs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uht Real)
    (declare-const ?uhu Real)
    (declare-const ?uhv Real)
    (declare-const ?uhw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uhx Real)
    (declare-const ?uhy Real)
    (declare-const ?uhz Real)
    (declare-const ?uia Real)
    (declare-const ?uib Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uic Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uid Real)
    (declare-const ?uie Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?uif Real)
  (declare-const ?uig Real)
  (declare-const ?uih Real)
  (declare-const ?uii Real)
  (declare-const ?uij Real)
  (declare-const ?uik Real)
  (assert
    (and (and (and (not (= ?uih ?uig))
          (not (= ?uih ?uif))
          )
        (not (= ?uig ?uif))
        )
      (or (or (= ?uik ?uij)
          (= ?uik ?uii)
          )
        (= ?uij ?uii)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?uil Real)
    (declare-const ?uim Real)
    (declare-const ?uin Real)
    (assert
      (or (or (= ?uin ?uim)
          (= ?uin ?uil)
          )
        (= ?uim ?uil)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uio Real)
    (declare-const ?uip Real)
    (declare-const ?uiq Real)
    (declare-const ?uir Real)
    (assert
      (or (or (= ?uir ?uiq)
          (= ?uir ?uip)
          )
        (= ?uiq ?uip)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uis Real)
    (declare-const ?uit Real)
    (declare-const ?uiu Real)
    (declare-const ?uiv Real)
    (declare-const ?uiw Real)
    (assert
      (or (or (= ?uiw ?uiv)
          (= ?uiw ?uiu)
          )
        (= ?uiv ?uiu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uix Real)
    (declare-const ?uiy Real)
    (declare-const ?uiz Real)
    (declare-const ?uja Real)
    (declare-const ?ujb Real)
    (declare-const ?ujc Real)
    (assert
      (and (and (and (not (= ?uiz ?uiy))
            (not (= ?uiz ?uix))
            )
          (not (= ?uiy ?uix))
          )
        (or (or (= ?ujc ?ujb)
            (= ?ujc ?uja)
            )
          (= ?ujb ?uja)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ujd Real)
    (declare-const ?uje Real)
    (declare-const ?ujf Real)
    (assert
      (or (or (= ?ujf ?uje)
          (= ?ujf ?ujd)
          )
        (= ?uje ?ujd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ujg Real)
    (declare-const ?ujh Real)
    (declare-const ?uji Real)
    (assert
      (or (or (= ?uji ?ujh)
          (= ?uji ?ujg)
          )
        (= ?ujh ?ujg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ujj Real)
    (declare-const ?ujk Real)
    (declare-const ?ujl Real)
    (declare-const ?ujm Real)
    (assert
      (or (or (= ?ujl ?ujk)
          (= ?ujl ?ujj)
          )
        (= ?ujk ?ujj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ujn Real)
    (declare-const ?ujo Real)
    (declare-const ?ujp Real)
    (declare-const ?ujq Real)
    (declare-const ?ujr Real)
    (assert
      (or (or (= ?ujp ?ujo)
          (= ?ujp ?ujn)
          )
        (= ?ujo ?ujn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ujs Real)
    (declare-const ?ujt Real)
    (declare-const ?uju Real)
    (declare-const ?ujv Real)
    (declare-const ?ujw Real)
    (declare-const ?ujx Real)
    (assert
      (and (or (or (= ?uju ?ujt)
            (= ?uju ?ujs)
            )
          (= ?ujt ?ujs)
          )
        (and (and (not (= ?ujx ?ujw))
            (not (= ?ujx ?ujv))
            )
          (not (= ?ujw ?ujv))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ujy Real)
    (declare-const ?ujz Real)
    (declare-const ?uka Real)
    (assert
      (or (or (= ?uka ?ujz)
          (= ?uka ?ujy)
          )
        (= ?ujz ?ujy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ukb Real)
    (declare-const ?ukc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ukd Real)
    (declare-const ?uke Real)
    (declare-const ?ukf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ukg Real)
    (declare-const ?ukh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uki Real)
    (declare-const ?ukj Real)
    (declare-const ?ukk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ukl Real)
    (declare-const ?ukm Real)
    (declare-const ?ukn Real)
    (declare-const ?uko Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ukm ?ukl))
                (not (= ?ukm ?asi))
                )
              (not (= ?ukl ?asi))
              )
            (or (or (= ?uko ?ukn)
                (= ?uko ?asi)
                )
              (= ?ukn ?asi)
              )
            )
          (and (or (or (= ?ukm ?ukl)
                (= ?ukm ?asi)
                )
              (= ?ukl ?asi)
              )
            (and (and (not (= ?uko ?ukn))
                (not (= ?uko ?asi))
                )
              (not (= ?ukn ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ukp Real)
    (declare-const ?ukq Real)
    (declare-const ?ukr Real)
    (declare-const ?uks Real)
    (declare-const ?ukt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uku Real)
    (declare-const ?ukv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ukw Real)
    (declare-const ?ukx Real)
    (declare-const ?uky Real)
    (declare-const ?ukz Real)
    (declare-const ?ula Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ulb Real)
    (declare-const ?ulc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uld Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ule Real)
    (declare-const ?ulf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ulg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ulh Real)
    (declare-const ?uli Real)
    (assert
      (not (= ?ulh ?uli))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ulj Real)
    (declare-const ?ulk Real)
    (declare-const ?ull Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ulm Real)
    (declare-const ?uln Real)
    (declare-const ?ulo Real)
    (declare-const ?ulp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ulq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ulr Real)
    (declare-const ?uls Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ult Real)
    (declare-const ?ulu Real)
    (declare-const ?ulv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ulw Real)
    (declare-const ?ulx Real)
    (declare-const ?uly Real)
    (declare-const ?ulz Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ulx ?ulw))
                (not (= ?ulx ?fkf))
                )
              (not (= ?ulw ?fkf))
              )
            (or (or (= ?ulz ?uly)
                (= ?ulz ?fkf)
                )
              (= ?uly ?fkf)
              )
            )
          (and (or (or (= ?ulx ?ulw)
                (= ?ulx ?fkf)
                )
              (= ?ulw ?fkf)
              )
            (and (and (not (= ?ulz ?uly))
                (not (= ?ulz ?fkf))
                )
              (not (= ?uly ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uma Real)
    (declare-const ?umb Real)
    (declare-const ?umc Real)
    (declare-const ?umd Real)
    (declare-const ?ume Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?umf Real)
    (declare-const ?umg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?umh Real)
    (declare-const ?umi Real)
    (declare-const ?umj Real)
    (declare-const ?umk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uml Real)
    (declare-const ?umm Real)
    (declare-const ?umn Real)
    (declare-const ?umo Real)
    (declare-const ?ump Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?umq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?umr Real)
    (declare-const ?ums Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?umt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?umu Real)
    (declare-const ?umv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?umw Real)
    (declare-const ?umx Real)
    (declare-const ?umy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?umz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?una Real)
    (declare-const ?unb Real)
    (assert
      (not (= ?una ?unb))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?unc Real)
    (declare-const ?und Real)
    (declare-const ?une Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?unf Real)
    (declare-const ?ung Real)
    (declare-const ?unh Real)
    (declare-const ?uni Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?unj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?unk Real)
    (declare-const ?unl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?unm Real)
    (declare-const ?unn Real)
    (declare-const ?uno Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?unp Real)
    (declare-const ?unq Real)
    (declare-const ?unr Real)
    (declare-const ?uns Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?unq ?unp))
                (not (= ?unq ?mzs))
                )
              (not (= ?unp ?mzs))
              )
            (or (or (= ?uns ?unr)
                (= ?uns ?mzs)
                )
              (= ?unr ?mzs)
              )
            )
          (and (or (or (= ?unq ?unp)
                (= ?unq ?mzs)
                )
              (= ?unp ?mzs)
              )
            (and (and (not (= ?uns ?unr))
                (not (= ?uns ?mzs))
                )
              (not (= ?unr ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?unt Real)
    (declare-const ?unu Real)
    (declare-const ?unv Real)
    (declare-const ?unw Real)
    (declare-const ?unx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uny Real)
    (declare-const ?unz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uoa Real)
    (declare-const ?uob Real)
    (declare-const ?uoc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uod Real)
    (declare-const ?uoe Real)
    (declare-const ?uof Real)
    (declare-const ?uog Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uoh Real)
    (declare-const ?uoi Real)
    (declare-const ?uoj Real)
    (declare-const ?uok Real)
    (declare-const ?uol Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uom Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uon Real)
    (declare-const ?uoo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?uop Real)
  (declare-const ?uoq Real)
  (declare-const ?uor Real)
  (assert
    (or (or (= ?uor ?uoq)
        (= ?uor ?uop)
        )
      (= ?uoq ?uop)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?uos Real)
    (declare-const ?uot Real)
    (declare-const ?uou Real)
    (assert
      (or (or (= ?uou ?uot)
          (= ?uou ?uos)
          )
        (= ?uot ?uos)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uov Real)
    (declare-const ?uow Real)
    (declare-const ?uox Real)
    (declare-const ?uoy Real)
    (assert
      (or (or (= ?uoy ?uox)
          (= ?uoy ?uow)
          )
        (= ?uox ?uow)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uoz Real)
    (declare-const ?upa Real)
    (declare-const ?upb Real)
    (declare-const ?upc Real)
    (declare-const ?upd Real)
    (assert
      (or (or (= ?upd ?upc)
          (= ?upd ?upb)
          )
        (= ?upc ?upb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?upe Real)
    (declare-const ?upf Real)
    (declare-const ?upg Real)
    (declare-const ?uph Real)
    (declare-const ?upi Real)
    (declare-const ?upj Real)
    (assert
      (and (and (and (not (= ?upg ?upf))
            (not (= ?upg ?upe))
            )
          (not (= ?upf ?upe))
          )
        (or (or (= ?upj ?upi)
            (= ?upj ?uph)
            )
          (= ?upi ?uph)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?upk Real)
    (declare-const ?upl Real)
    (declare-const ?upm Real)
    (assert
      (or (or (= ?upm ?upl)
          (= ?upm ?upk)
          )
        (= ?upl ?upk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?upn Real)
    (declare-const ?upo Real)
    (declare-const ?upp Real)
    (assert
      (or (or (= ?upp ?upo)
          (= ?upp ?upn)
          )
        (= ?upo ?upn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?upq Real)
    (declare-const ?upr Real)
    (declare-const ?ups Real)
    (declare-const ?upt Real)
    (assert
      (or (or (= ?ups ?upr)
          (= ?ups ?upq)
          )
        (= ?upr ?upq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?upu Real)
    (declare-const ?upv Real)
    (declare-const ?upw Real)
    (declare-const ?upx Real)
    (declare-const ?upy Real)
    (assert
      (or (or (= ?upw ?upv)
          (= ?upw ?upu)
          )
        (= ?upv ?upu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?upz Real)
    (declare-const ?uqa Real)
    (declare-const ?uqb Real)
    (declare-const ?uqc Real)
    (declare-const ?uqd Real)
    (declare-const ?uqe Real)
    (assert
      (and (or (or (= ?uqb ?uqa)
            (= ?uqb ?upz)
            )
          (= ?uqa ?upz)
          )
        (and (and (not (= ?uqe ?uqd))
            (not (= ?uqe ?uqc))
            )
          (not (= ?uqd ?uqc))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uqf Real)
    (declare-const ?uqg Real)
    (declare-const ?uqh Real)
    (assert
      (or (or (= ?uqh ?uqg)
          (= ?uqh ?uqf)
          )
        (= ?uqg ?uqf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uqi Real)
    (declare-const ?uqj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uqk Real)
    (declare-const ?uql Real)
    (declare-const ?uqm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uqn Real)
    (declare-const ?uqo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uqp Real)
    (declare-const ?uqq Real)
    (declare-const ?uqr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uqs Real)
    (declare-const ?uqt Real)
    (declare-const ?uqu Real)
    (declare-const ?uqv Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?uqt ?uqs))
                (not (= ?uqt ?asi))
                )
              (not (= ?uqs ?asi))
              )
            (or (or (= ?uqv ?uqu)
                (= ?uqv ?asi)
                )
              (= ?uqu ?asi)
              )
            )
          (and (or (or (= ?uqt ?uqs)
                (= ?uqt ?asi)
                )
              (= ?uqs ?asi)
              )
            (and (and (not (= ?uqv ?uqu))
                (not (= ?uqv ?asi))
                )
              (not (= ?uqu ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uqw Real)
    (declare-const ?uqx Real)
    (declare-const ?uqy Real)
    (declare-const ?uqz Real)
    (declare-const ?ura Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?urb Real)
    (declare-const ?urc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?urd Real)
    (declare-const ?ure Real)
    (declare-const ?urf Real)
    (declare-const ?urg Real)
    (declare-const ?urh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uri Real)
    (declare-const ?urj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?urk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?url Real)
    (declare-const ?urm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?urn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uro Real)
    (declare-const ?urp Real)
    (assert
      (not (= ?uro ?urp))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?urq Real)
    (declare-const ?urr Real)
    (declare-const ?urs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?urt Real)
    (declare-const ?uru Real)
    (declare-const ?urv Real)
    (declare-const ?urw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?urx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ury Real)
    (declare-const ?urz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?usa Real)
    (declare-const ?usb Real)
    (declare-const ?usc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?usd Real)
    (declare-const ?use Real)
    (declare-const ?usf Real)
    (declare-const ?usg Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?use ?usd))
                (not (= ?use ?fkf))
                )
              (not (= ?usd ?fkf))
              )
            (or (or (= ?usg ?usf)
                (= ?usg ?fkf)
                )
              (= ?usf ?fkf)
              )
            )
          (and (or (or (= ?use ?usd)
                (= ?use ?fkf)
                )
              (= ?usd ?fkf)
              )
            (and (and (not (= ?usg ?usf))
                (not (= ?usg ?fkf))
                )
              (not (= ?usf ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ush Real)
    (declare-const ?usi Real)
    (declare-const ?usj Real)
    (declare-const ?usk Real)
    (declare-const ?usl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?usm Real)
    (declare-const ?usn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uso Real)
    (declare-const ?usp Real)
    (declare-const ?usq Real)
    (declare-const ?usr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uss Real)
    (declare-const ?ust Real)
    (declare-const ?usu Real)
    (declare-const ?usv Real)
    (declare-const ?usw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?usx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?usy Real)
    (declare-const ?usz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uta Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?utb Real)
    (declare-const ?utc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?utd Real)
    (declare-const ?ute Real)
    (declare-const ?utf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?utg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uth Real)
    (declare-const ?uti Real)
    (assert
      (not (= ?uth ?uti))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?utj Real)
    (declare-const ?utk Real)
    (declare-const ?utl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?utm Real)
    (declare-const ?utn Real)
    (declare-const ?uto Real)
    (declare-const ?utp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?utq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?utr Real)
    (declare-const ?uts Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?utt Real)
    (declare-const ?utu Real)
    (declare-const ?utv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?utw Real)
    (declare-const ?utx Real)
    (declare-const ?uty Real)
    (declare-const ?utz Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?utx ?utw))
                (not (= ?utx ?mzs))
                )
              (not (= ?utw ?mzs))
              )
            (or (or (= ?utz ?uty)
                (= ?utz ?mzs)
                )
              (= ?uty ?mzs)
              )
            )
          (and (or (or (= ?utx ?utw)
                (= ?utx ?mzs)
                )
              (= ?utw ?mzs)
              )
            (and (and (not (= ?utz ?uty))
                (not (= ?utz ?mzs))
                )
              (not (= ?uty ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uua Real)
    (declare-const ?uub Real)
    (declare-const ?uuc Real)
    (declare-const ?uud Real)
    (declare-const ?uue Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uuf Real)
    (declare-const ?uug Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uuh Real)
    (declare-const ?uui Real)
    (declare-const ?uuj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uuk Real)
    (declare-const ?uul Real)
    (declare-const ?uum Real)
    (declare-const ?uun Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uuo Real)
    (declare-const ?uup Real)
    (declare-const ?uuq Real)
    (declare-const ?uur Real)
    (declare-const ?uus Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uut Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uuu Real)
    (declare-const ?uuv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?uuw Real)
  (declare-const ?uux Real)
  (declare-const ?uuy Real)
  (assert
    (or (or (= ?uuy ?uux)
        (= ?uuy ?uuw)
        )
      (= ?uux ?uuw)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?uuz Real)
    (declare-const ?uva Real)
    (declare-const ?uvb Real)
    (assert
      (or (or (= ?uvb ?uva)
          (= ?uvb ?uuz)
          )
        (= ?uva ?uuz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uvc Real)
    (declare-const ?uvd Real)
    (declare-const ?uve Real)
    (declare-const ?uvf Real)
    (assert
      (or (or (= ?uvf ?uve)
          (= ?uvf ?uvd)
          )
        (= ?uve ?uvd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uvg Real)
    (declare-const ?uvh Real)
    (declare-const ?uvi Real)
    (declare-const ?uvj Real)
    (declare-const ?uvk Real)
    (assert
      (or (or (= ?uvk ?uvj)
          (= ?uvk ?uvi)
          )
        (= ?uvj ?uvi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uvl Real)
    (declare-const ?uvm Real)
    (declare-const ?uvn Real)
    (declare-const ?uvo Real)
    (declare-const ?uvp Real)
    (declare-const ?uvq Real)
    (assert
      (and (and (and (not (= ?uvn ?uvm))
            (not (= ?uvn ?uvl))
            )
          (not (= ?uvm ?uvl))
          )
        (or (or (= ?uvq ?uvp)
            (= ?uvq ?uvo)
            )
          (= ?uvp ?uvo)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uvr Real)
    (declare-const ?uvs Real)
    (declare-const ?uvt Real)
    (assert
      (or (or (= ?uvt ?uvs)
          (= ?uvt ?uvr)
          )
        (= ?uvs ?uvr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uvu Real)
    (declare-const ?uvv Real)
    (declare-const ?uvw Real)
    (assert
      (or (or (= ?uvw ?uvv)
          (= ?uvw ?uvu)
          )
        (= ?uvv ?uvu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uvx Real)
    (declare-const ?uvy Real)
    (declare-const ?uvz Real)
    (declare-const ?uwa Real)
    (assert
      (or (or (= ?uvz ?uvy)
          (= ?uvz ?uvx)
          )
        (= ?uvy ?uvx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uwb Real)
    (declare-const ?uwc Real)
    (declare-const ?uwd Real)
    (declare-const ?uwe Real)
    (declare-const ?uwf Real)
    (assert
      (or (or (= ?uwd ?uwc)
          (= ?uwd ?uwb)
          )
        (= ?uwc ?uwb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uwg Real)
    (declare-const ?uwh Real)
    (declare-const ?uwi Real)
    (declare-const ?uwj Real)
    (declare-const ?uwk Real)
    (declare-const ?uwl Real)
    (assert
      (and (or (or (= ?uwi ?uwh)
            (= ?uwi ?uwg)
            )
          (= ?uwh ?uwg)
          )
        (and (and (not (= ?uwl ?uwk))
            (not (= ?uwl ?uwj))
            )
          (not (= ?uwk ?uwj))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uwm Real)
    (declare-const ?uwn Real)
    (declare-const ?uwo Real)
    (assert
      (or (or (= ?uwo ?uwn)
          (= ?uwo ?uwm)
          )
        (= ?uwn ?uwm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uwp Real)
    (declare-const ?uwq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uwr Real)
    (declare-const ?uws Real)
    (declare-const ?uwt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uwu Real)
    (declare-const ?uwv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uww Real)
    (declare-const ?uwx Real)
    (declare-const ?uwy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uwz Real)
    (declare-const ?uxa Real)
    (declare-const ?uxb Real)
    (declare-const ?uxc Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?uxa ?uwz))
                (not (= ?uxa ?asi))
                )
              (not (= ?uwz ?asi))
              )
            (or (or (= ?uxc ?uxb)
                (= ?uxc ?asi)
                )
              (= ?uxb ?asi)
              )
            )
          (and (or (or (= ?uxa ?uwz)
                (= ?uxa ?asi)
                )
              (= ?uwz ?asi)
              )
            (and (and (not (= ?uxc ?uxb))
                (not (= ?uxc ?asi))
                )
              (not (= ?uxb ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uxd Real)
    (declare-const ?uxe Real)
    (declare-const ?uxf Real)
    (declare-const ?uxg Real)
    (declare-const ?uxh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uxi Real)
    (declare-const ?uxj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uxk Real)
    (declare-const ?uxl Real)
    (declare-const ?uxm Real)
    (declare-const ?uxn Real)
    (declare-const ?uxo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uxp Real)
    (declare-const ?uxq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uxr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uxs Real)
    (declare-const ?uxt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uxu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uxv Real)
    (declare-const ?uxw Real)
    (assert
      (not (= ?uxv ?uxw))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uxx Real)
    (declare-const ?uxy Real)
    (declare-const ?uxz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uya Real)
    (declare-const ?uyb Real)
    (declare-const ?uyc Real)
    (declare-const ?uyd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uye Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uyf Real)
    (declare-const ?uyg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uyh Real)
    (declare-const ?uyi Real)
    (declare-const ?uyj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uyk Real)
    (declare-const ?uyl Real)
    (declare-const ?uym Real)
    (declare-const ?uyn Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?uyl ?uyk))
                (not (= ?uyl ?fkf))
                )
              (not (= ?uyk ?fkf))
              )
            (or (or (= ?uyn ?uym)
                (= ?uyn ?fkf)
                )
              (= ?uym ?fkf)
              )
            )
          (and (or (or (= ?uyl ?uyk)
                (= ?uyl ?fkf)
                )
              (= ?uyk ?fkf)
              )
            (and (and (not (= ?uyn ?uym))
                (not (= ?uyn ?fkf))
                )
              (not (= ?uym ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uyo Real)
    (declare-const ?uyp Real)
    (declare-const ?uyq Real)
    (declare-const ?uyr Real)
    (declare-const ?uys Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uyt Real)
    (declare-const ?uyu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uyv Real)
    (declare-const ?uyw Real)
    (declare-const ?uyx Real)
    (declare-const ?uyy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uyz Real)
    (declare-const ?uza Real)
    (declare-const ?uzb Real)
    (declare-const ?uzc Real)
    (declare-const ?uzd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uze Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uzf Real)
    (declare-const ?uzg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uzh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uzi Real)
    (declare-const ?uzj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uzk Real)
    (declare-const ?uzl Real)
    (declare-const ?uzm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uzn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uzo Real)
    (declare-const ?uzp Real)
    (assert
      (not (= ?uzo ?uzp))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uzq Real)
    (declare-const ?uzr Real)
    (declare-const ?uzs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uzt Real)
    (declare-const ?uzu Real)
    (declare-const ?uzv Real)
    (declare-const ?uzw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uzx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?uzy Real)
    (declare-const ?uzz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vaa Real)
    (declare-const ?vab Real)
    (declare-const ?vac Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vad Real)
    (declare-const ?vae Real)
    (declare-const ?vaf Real)
    (declare-const ?vag Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?vae ?vad))
                (not (= ?vae ?mzs))
                )
              (not (= ?vad ?mzs))
              )
            (or (or (= ?vag ?vaf)
                (= ?vag ?mzs)
                )
              (= ?vaf ?mzs)
              )
            )
          (and (or (or (= ?vae ?vad)
                (= ?vae ?mzs)
                )
              (= ?vad ?mzs)
              )
            (and (and (not (= ?vag ?vaf))
                (not (= ?vag ?mzs))
                )
              (not (= ?vaf ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vah Real)
    (declare-const ?vai Real)
    (declare-const ?vaj Real)
    (declare-const ?vak Real)
    (declare-const ?val Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vam Real)
    (declare-const ?van Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vao Real)
    (declare-const ?vap Real)
    (declare-const ?vaq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?var Real)
    (declare-const ?vas Real)
    (declare-const ?vat Real)
    (declare-const ?vau Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vav Real)
    (declare-const ?vaw Real)
    (declare-const ?vax Real)
    (declare-const ?vay Real)
    (declare-const ?vaz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vba Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vbb Real)
    (declare-const ?vbc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?vbd Real)
  (declare-const ?vbe Real)
  (declare-const ?vbf Real)
  (declare-const ?vbg Real)
  (assert
    (or (or (= ?vbf ?vbe)
        (= ?vbf ?vbd)
        )
      (= ?vbe ?vbd)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?vbh Real)
    (declare-const ?vbi Real)
    (declare-const ?vbj Real)
    (assert
      (or (or (= ?vbj ?vbi)
          (= ?vbj ?vbh)
          )
        (= ?vbi ?vbh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vbk Real)
    (declare-const ?vbl Real)
    (declare-const ?vbm Real)
    (declare-const ?vbn Real)
    (assert
      (or (or (= ?vbn ?vbm)
          (= ?vbn ?vbl)
          )
        (= ?vbm ?vbl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vbo Real)
    (declare-const ?vbp Real)
    (declare-const ?vbq Real)
    (declare-const ?vbr Real)
    (declare-const ?vbs Real)
    (assert
      (or (or (= ?vbs ?vbr)
          (= ?vbs ?vbq)
          )
        (= ?vbr ?vbq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vbt Real)
    (declare-const ?vbu Real)
    (declare-const ?vbv Real)
    (declare-const ?vbw Real)
    (declare-const ?vbx Real)
    (declare-const ?vby Real)
    (assert
      (and (and (and (not (= ?vbv ?vbu))
            (not (= ?vbv ?vbt))
            )
          (not (= ?vbu ?vbt))
          )
        (or (or (= ?vby ?vbx)
            (= ?vby ?vbw)
            )
          (= ?vbx ?vbw)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vbz Real)
    (declare-const ?vca Real)
    (declare-const ?vcb Real)
    (assert
      (or (or (= ?vcb ?vca)
          (= ?vcb ?vbz)
          )
        (= ?vca ?vbz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vcc Real)
    (declare-const ?vcd Real)
    (declare-const ?vce Real)
    (assert
      (or (or (= ?vce ?vcd)
          (= ?vce ?vcc)
          )
        (= ?vcd ?vcc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vcf Real)
    (declare-const ?vcg Real)
    (declare-const ?vch Real)
    (declare-const ?vci Real)
    (assert
      (or (or (= ?vch ?vcg)
          (= ?vch ?vcf)
          )
        (= ?vcg ?vcf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vcj Real)
    (declare-const ?vck Real)
    (declare-const ?vcl Real)
    (declare-const ?vcm Real)
    (declare-const ?vcn Real)
    (assert
      (or (or (= ?vcl ?vck)
          (= ?vcl ?vcj)
          )
        (= ?vck ?vcj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vco Real)
    (declare-const ?vcp Real)
    (declare-const ?vcq Real)
    (declare-const ?vcr Real)
    (declare-const ?vcs Real)
    (declare-const ?vct Real)
    (assert
      (and (or (or (= ?vcq ?vcp)
            (= ?vcq ?vco)
            )
          (= ?vcp ?vco)
          )
        (and (and (not (= ?vct ?vcs))
            (not (= ?vct ?vcr))
            )
          (not (= ?vcs ?vcr))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vcu Real)
    (declare-const ?vcv Real)
    (declare-const ?vcw Real)
    (assert
      (or (or (= ?vcw ?vcv)
          (= ?vcw ?vcu)
          )
        (= ?vcv ?vcu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vcx Real)
    (declare-const ?vcy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vcz Real)
    (declare-const ?vda Real)
    (declare-const ?vdb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vdc Real)
    (declare-const ?vdd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vde Real)
    (declare-const ?vdf Real)
    (declare-const ?vdg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vdh Real)
    (declare-const ?vdi Real)
    (declare-const ?vdj Real)
    (declare-const ?vdk Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?vdi ?vdh))
                (not (= ?vdi ?asi))
                )
              (not (= ?vdh ?asi))
              )
            (or (or (= ?vdk ?vdj)
                (= ?vdk ?asi)
                )
              (= ?vdj ?asi)
              )
            )
          (and (or (or (= ?vdi ?vdh)
                (= ?vdi ?asi)
                )
              (= ?vdh ?asi)
              )
            (and (and (not (= ?vdk ?vdj))
                (not (= ?vdk ?asi))
                )
              (not (= ?vdj ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vdl Real)
    (declare-const ?vdm Real)
    (declare-const ?vdn Real)
    (declare-const ?vdo Real)
    (declare-const ?vdp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vdq Real)
    (declare-const ?vdr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vds Real)
    (declare-const ?vdt Real)
    (declare-const ?vdu Real)
    (declare-const ?vdv Real)
    (declare-const ?vdw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vdx Real)
    (declare-const ?vdy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vdz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vea Real)
    (declare-const ?veb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vec Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ved Real)
    (declare-const ?vee Real)
    (assert
      (not (= ?ved ?vee))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vef Real)
    (declare-const ?veg Real)
    (declare-const ?veh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vei Real)
    (declare-const ?vej Real)
    (declare-const ?vek Real)
    (declare-const ?vel Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vem Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ven Real)
    (declare-const ?veo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vep Real)
    (declare-const ?veq Real)
    (declare-const ?ver Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ves Real)
    (declare-const ?vet Real)
    (declare-const ?veu Real)
    (declare-const ?vev Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?vet ?ves))
                (not (= ?vet ?fkf))
                )
              (not (= ?ves ?fkf))
              )
            (or (or (= ?vev ?veu)
                (= ?vev ?fkf)
                )
              (= ?veu ?fkf)
              )
            )
          (and (or (or (= ?vet ?ves)
                (= ?vet ?fkf)
                )
              (= ?ves ?fkf)
              )
            (and (and (not (= ?vev ?veu))
                (not (= ?vev ?fkf))
                )
              (not (= ?veu ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vew Real)
    (declare-const ?vex Real)
    (declare-const ?vey Real)
    (declare-const ?vez Real)
    (declare-const ?vfa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vfb Real)
    (declare-const ?vfc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vfd Real)
    (declare-const ?vfe Real)
    (declare-const ?vff Real)
    (declare-const ?vfg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vfh Real)
    (declare-const ?vfi Real)
    (declare-const ?vfj Real)
    (declare-const ?vfk Real)
    (declare-const ?vfl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vfm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vfn Real)
    (declare-const ?vfo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vfp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vfq Real)
    (declare-const ?vfr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vfs Real)
    (declare-const ?vft Real)
    (declare-const ?vfu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vfv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vfw Real)
    (declare-const ?vfx Real)
    (assert
      (not (= ?vfw ?vfx))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vfy Real)
    (declare-const ?vfz Real)
    (declare-const ?vga Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vgb Real)
    (declare-const ?vgc Real)
    (declare-const ?vgd Real)
    (declare-const ?vge Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vgf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vgg Real)
    (declare-const ?vgh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vgi Real)
    (declare-const ?vgj Real)
    (declare-const ?vgk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vgl Real)
    (declare-const ?vgm Real)
    (declare-const ?vgn Real)
    (declare-const ?vgo Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?vgm ?vgl))
                (not (= ?vgm ?mzs))
                )
              (not (= ?vgl ?mzs))
              )
            (or (or (= ?vgo ?vgn)
                (= ?vgo ?mzs)
                )
              (= ?vgn ?mzs)
              )
            )
          (and (or (or (= ?vgm ?vgl)
                (= ?vgm ?mzs)
                )
              (= ?vgl ?mzs)
              )
            (and (and (not (= ?vgo ?vgn))
                (not (= ?vgo ?mzs))
                )
              (not (= ?vgn ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vgp Real)
    (declare-const ?vgq Real)
    (declare-const ?vgr Real)
    (declare-const ?vgs Real)
    (declare-const ?vgt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vgu Real)
    (declare-const ?vgv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vgw Real)
    (declare-const ?vgx Real)
    (declare-const ?vgy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vgz Real)
    (declare-const ?vha Real)
    (declare-const ?vhb Real)
    (declare-const ?vhc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vhd Real)
    (declare-const ?vhe Real)
    (declare-const ?vhf Real)
    (declare-const ?vhg Real)
    (declare-const ?vhh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vhi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vhj Real)
    (declare-const ?vhk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?vhl Real)
  (declare-const ?vhm Real)
  (declare-const ?vhn Real)
  (declare-const ?vho Real)
  (declare-const ?vhp Real)
  (assert
    (or (or (= ?vhn ?vhm)
        (= ?vhn ?vhl)
        )
      (= ?vhm ?vhl)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?vhq Real)
    (declare-const ?vhr Real)
    (declare-const ?vhs Real)
    (assert
      (or (or (= ?vhs ?vhr)
          (= ?vhs ?vhq)
          )
        (= ?vhr ?vhq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vht Real)
    (declare-const ?vhu Real)
    (declare-const ?vhv Real)
    (declare-const ?vhw Real)
    (assert
      (or (or (= ?vhw ?vhv)
          (= ?vhw ?vhu)
          )
        (= ?vhv ?vhu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vhx Real)
    (declare-const ?vhy Real)
    (declare-const ?vhz Real)
    (declare-const ?via Real)
    (declare-const ?vib Real)
    (assert
      (or (or (= ?vib ?via)
          (= ?vib ?vhz)
          )
        (= ?via ?vhz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vic Real)
    (declare-const ?vid Real)
    (declare-const ?vie Real)
    (declare-const ?vif Real)
    (declare-const ?vig Real)
    (declare-const ?vih Real)
    (assert
      (and (and (and (not (= ?vie ?vid))
            (not (= ?vie ?vic))
            )
          (not (= ?vid ?vic))
          )
        (or (or (= ?vih ?vig)
            (= ?vih ?vif)
            )
          (= ?vig ?vif)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vii Real)
    (declare-const ?vij Real)
    (declare-const ?vik Real)
    (assert
      (or (or (= ?vik ?vij)
          (= ?vik ?vii)
          )
        (= ?vij ?vii)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vil Real)
    (declare-const ?vim Real)
    (declare-const ?vin Real)
    (assert
      (or (or (= ?vin ?vim)
          (= ?vin ?vil)
          )
        (= ?vim ?vil)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vio Real)
    (declare-const ?vip Real)
    (declare-const ?viq Real)
    (declare-const ?vir Real)
    (assert
      (or (or (= ?viq ?vip)
          (= ?viq ?vio)
          )
        (= ?vip ?vio)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vis Real)
    (declare-const ?vit Real)
    (declare-const ?viu Real)
    (declare-const ?viv Real)
    (declare-const ?viw Real)
    (assert
      (or (or (= ?viu ?vit)
          (= ?viu ?vis)
          )
        (= ?vit ?vis)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vix Real)
    (declare-const ?viy Real)
    (declare-const ?viz Real)
    (declare-const ?vja Real)
    (declare-const ?vjb Real)
    (declare-const ?vjc Real)
    (assert
      (and (or (or (= ?viz ?viy)
            (= ?viz ?vix)
            )
          (= ?viy ?vix)
          )
        (and (and (not (= ?vjc ?vjb))
            (not (= ?vjc ?vja))
            )
          (not (= ?vjb ?vja))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vjd Real)
    (declare-const ?vje Real)
    (declare-const ?vjf Real)
    (assert
      (or (or (= ?vjf ?vje)
          (= ?vjf ?vjd)
          )
        (= ?vje ?vjd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vjg Real)
    (declare-const ?vjh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vji Real)
    (declare-const ?vjj Real)
    (declare-const ?vjk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vjl Real)
    (declare-const ?vjm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vjn Real)
    (declare-const ?vjo Real)
    (declare-const ?vjp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vjq Real)
    (declare-const ?vjr Real)
    (declare-const ?vjs Real)
    (declare-const ?vjt Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?vjr ?vjq))
                (not (= ?vjr ?asi))
                )
              (not (= ?vjq ?asi))
              )
            (or (or (= ?vjt ?vjs)
                (= ?vjt ?asi)
                )
              (= ?vjs ?asi)
              )
            )
          (and (or (or (= ?vjr ?vjq)
                (= ?vjr ?asi)
                )
              (= ?vjq ?asi)
              )
            (and (and (not (= ?vjt ?vjs))
                (not (= ?vjt ?asi))
                )
              (not (= ?vjs ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vju Real)
    (declare-const ?vjv Real)
    (declare-const ?vjw Real)
    (declare-const ?vjx Real)
    (declare-const ?vjy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vjz Real)
    (declare-const ?vka Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vkb Real)
    (declare-const ?vkc Real)
    (declare-const ?vkd Real)
    (declare-const ?vke Real)
    (declare-const ?vkf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vkg Real)
    (declare-const ?vkh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vki Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vkj Real)
    (declare-const ?vkk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vkl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vkm Real)
    (declare-const ?vkn Real)
    (assert
      (not (= ?vkm ?vkn))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vko Real)
    (declare-const ?vkp Real)
    (declare-const ?vkq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vkr Real)
    (declare-const ?vks Real)
    (declare-const ?vkt Real)
    (declare-const ?vku Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vkv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vkw Real)
    (declare-const ?vkx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vky Real)
    (declare-const ?vkz Real)
    (declare-const ?vla Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vlb Real)
    (declare-const ?vlc Real)
    (declare-const ?vld Real)
    (declare-const ?vle Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?vlc ?vlb))
                (not (= ?vlc ?fkf))
                )
              (not (= ?vlb ?fkf))
              )
            (or (or (= ?vle ?vld)
                (= ?vle ?fkf)
                )
              (= ?vld ?fkf)
              )
            )
          (and (or (or (= ?vlc ?vlb)
                (= ?vlc ?fkf)
                )
              (= ?vlb ?fkf)
              )
            (and (and (not (= ?vle ?vld))
                (not (= ?vle ?fkf))
                )
              (not (= ?vld ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vlf Real)
    (declare-const ?vlg Real)
    (declare-const ?vlh Real)
    (declare-const ?vli Real)
    (declare-const ?vlj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vlk Real)
    (declare-const ?vll Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vlm Real)
    (declare-const ?vln Real)
    (declare-const ?vlo Real)
    (declare-const ?vlp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vlq Real)
    (declare-const ?vlr Real)
    (declare-const ?vls Real)
    (declare-const ?vlt Real)
    (declare-const ?vlu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vlv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vlw Real)
    (declare-const ?vlx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vly Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vlz Real)
    (declare-const ?vma Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vmb Real)
    (declare-const ?vmc Real)
    (declare-const ?vmd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vme Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vmf Real)
    (declare-const ?vmg Real)
    (assert
      (not (= ?vmf ?vmg))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vmh Real)
    (declare-const ?vmi Real)
    (declare-const ?vmj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vmk Real)
    (declare-const ?vml Real)
    (declare-const ?vmm Real)
    (declare-const ?vmn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vmo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vmp Real)
    (declare-const ?vmq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vmr Real)
    (declare-const ?vms Real)
    (declare-const ?vmt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vmu Real)
    (declare-const ?vmv Real)
    (declare-const ?vmw Real)
    (declare-const ?vmx Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?vmv ?vmu))
                (not (= ?vmv ?mzs))
                )
              (not (= ?vmu ?mzs))
              )
            (or (or (= ?vmx ?vmw)
                (= ?vmx ?mzs)
                )
              (= ?vmw ?mzs)
              )
            )
          (and (or (or (= ?vmv ?vmu)
                (= ?vmv ?mzs)
                )
              (= ?vmu ?mzs)
              )
            (and (and (not (= ?vmx ?vmw))
                (not (= ?vmx ?mzs))
                )
              (not (= ?vmw ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vmy Real)
    (declare-const ?vmz Real)
    (declare-const ?vna Real)
    (declare-const ?vnb Real)
    (declare-const ?vnc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vnd Real)
    (declare-const ?vne Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vnf Real)
    (declare-const ?vng Real)
    (declare-const ?vnh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vni Real)
    (declare-const ?vnj Real)
    (declare-const ?vnk Real)
    (declare-const ?vnl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vnm Real)
    (declare-const ?vnn Real)
    (declare-const ?vno Real)
    (declare-const ?vnp Real)
    (declare-const ?vnq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vnr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vns Real)
    (declare-const ?vnt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?vnu Real)
  (declare-const ?vnv Real)
  (declare-const ?vnw Real)
  (declare-const ?vnx Real)
  (declare-const ?vny Real)
  (declare-const ?vnz Real)
  (assert
    (and (or (or (= ?vnw ?vnv)
          (= ?vnw ?vnu)
          )
        (= ?vnv ?vnu)
        )
      (and (and (not (= ?vnz ?vny))
          (not (= ?vnz ?vnx))
          )
        (not (= ?vny ?vnx))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?voa Real)
    (declare-const ?vob Real)
    (declare-const ?voc Real)
    (assert
      (or (or (= ?voc ?vob)
          (= ?voc ?voa)
          )
        (= ?vob ?voa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vod Real)
    (declare-const ?voe Real)
    (declare-const ?vof Real)
    (declare-const ?vog Real)
    (assert
      (or (or (= ?vog ?vof)
          (= ?vog ?voe)
          )
        (= ?vof ?voe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?voh Real)
    (declare-const ?voi Real)
    (declare-const ?voj Real)
    (declare-const ?vok Real)
    (declare-const ?vol Real)
    (assert
      (or (or (= ?vol ?vok)
          (= ?vol ?voj)
          )
        (= ?vok ?voj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vom Real)
    (declare-const ?von Real)
    (declare-const ?voo Real)
    (declare-const ?vop Real)
    (declare-const ?voq Real)
    (declare-const ?vor Real)
    (assert
      (and (and (and (not (= ?voo ?von))
            (not (= ?voo ?vom))
            )
          (not (= ?von ?vom))
          )
        (or (or (= ?vor ?voq)
            (= ?vor ?vop)
            )
          (= ?voq ?vop)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vos Real)
    (declare-const ?vot Real)
    (declare-const ?vou Real)
    (assert
      (or (or (= ?vou ?vot)
          (= ?vou ?vos)
          )
        (= ?vot ?vos)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vov Real)
    (declare-const ?vow Real)
    (declare-const ?vox Real)
    (assert
      (or (or (= ?vox ?vow)
          (= ?vox ?vov)
          )
        (= ?vow ?vov)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?voy Real)
    (declare-const ?voz Real)
    (declare-const ?vpa Real)
    (declare-const ?vpb Real)
    (assert
      (or (or (= ?vpa ?voz)
          (= ?vpa ?voy)
          )
        (= ?voz ?voy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vpc Real)
    (declare-const ?vpd Real)
    (declare-const ?vpe Real)
    (declare-const ?vpf Real)
    (declare-const ?vpg Real)
    (assert
      (or (or (= ?vpe ?vpd)
          (= ?vpe ?vpc)
          )
        (= ?vpd ?vpc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vph Real)
    (declare-const ?vpi Real)
    (declare-const ?vpj Real)
    (declare-const ?vpk Real)
    (declare-const ?vpl Real)
    (declare-const ?vpm Real)
    (assert
      (and (or (or (= ?vpj ?vpi)
            (= ?vpj ?vph)
            )
          (= ?vpi ?vph)
          )
        (and (and (not (= ?vpm ?vpl))
            (not (= ?vpm ?vpk))
            )
          (not (= ?vpl ?vpk))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vpn Real)
    (declare-const ?vpo Real)
    (declare-const ?vpp Real)
    (assert
      (or (or (= ?vpp ?vpo)
          (= ?vpp ?vpn)
          )
        (= ?vpo ?vpn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vpq Real)
    (declare-const ?vpr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vps Real)
    (declare-const ?vpt Real)
    (declare-const ?vpu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vpv Real)
    (declare-const ?vpw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vpx Real)
    (declare-const ?vpy Real)
    (declare-const ?vpz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vqa Real)
    (declare-const ?vqb Real)
    (declare-const ?vqc Real)
    (declare-const ?vqd Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?vqb ?vqa))
                (not (= ?vqb ?asi))
                )
              (not (= ?vqa ?asi))
              )
            (or (or (= ?vqd ?vqc)
                (= ?vqd ?asi)
                )
              (= ?vqc ?asi)
              )
            )
          (and (or (or (= ?vqb ?vqa)
                (= ?vqb ?asi)
                )
              (= ?vqa ?asi)
              )
            (and (and (not (= ?vqd ?vqc))
                (not (= ?vqd ?asi))
                )
              (not (= ?vqc ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vqe Real)
    (declare-const ?vqf Real)
    (declare-const ?vqg Real)
    (declare-const ?vqh Real)
    (declare-const ?vqi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vqj Real)
    (declare-const ?vqk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vql Real)
    (declare-const ?vqm Real)
    (declare-const ?vqn Real)
    (declare-const ?vqo Real)
    (declare-const ?vqp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vqq Real)
    (declare-const ?vqr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vqs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vqt Real)
    (declare-const ?vqu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vqv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vqw Real)
    (declare-const ?vqx Real)
    (assert
      (not (= ?vqw ?vqx))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vqy Real)
    (declare-const ?vqz Real)
    (declare-const ?vra Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vrb Real)
    (declare-const ?vrc Real)
    (declare-const ?vrd Real)
    (declare-const ?vre Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vrf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vrg Real)
    (declare-const ?vrh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vri Real)
    (declare-const ?vrj Real)
    (declare-const ?vrk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vrl Real)
    (declare-const ?vrm Real)
    (declare-const ?vrn Real)
    (declare-const ?vro Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?vrm ?vrl))
                (not (= ?vrm ?fkf))
                )
              (not (= ?vrl ?fkf))
              )
            (or (or (= ?vro ?vrn)
                (= ?vro ?fkf)
                )
              (= ?vrn ?fkf)
              )
            )
          (and (or (or (= ?vrm ?vrl)
                (= ?vrm ?fkf)
                )
              (= ?vrl ?fkf)
              )
            (and (and (not (= ?vro ?vrn))
                (not (= ?vro ?fkf))
                )
              (not (= ?vrn ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vrp Real)
    (declare-const ?vrq Real)
    (declare-const ?vrr Real)
    (declare-const ?vrs Real)
    (declare-const ?vrt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vru Real)
    (declare-const ?vrv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vrw Real)
    (declare-const ?vrx Real)
    (declare-const ?vry Real)
    (declare-const ?vrz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vsa Real)
    (declare-const ?vsb Real)
    (declare-const ?vsc Real)
    (declare-const ?vsd Real)
    (declare-const ?vse Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vsf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vsg Real)
    (declare-const ?vsh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vsi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vsj Real)
    (declare-const ?vsk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vsl Real)
    (declare-const ?vsm Real)
    (declare-const ?vsn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vso Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vsp Real)
    (declare-const ?vsq Real)
    (assert
      (not (= ?vsp ?vsq))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vsr Real)
    (declare-const ?vss Real)
    (declare-const ?vst Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vsu Real)
    (declare-const ?vsv Real)
    (declare-const ?vsw Real)
    (declare-const ?vsx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vsy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vsz Real)
    (declare-const ?vta Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vtb Real)
    (declare-const ?vtc Real)
    (declare-const ?vtd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vte Real)
    (declare-const ?vtf Real)
    (declare-const ?vtg Real)
    (declare-const ?vth Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?vtf ?vte))
                (not (= ?vtf ?mzs))
                )
              (not (= ?vte ?mzs))
              )
            (or (or (= ?vth ?vtg)
                (= ?vth ?mzs)
                )
              (= ?vtg ?mzs)
              )
            )
          (and (or (or (= ?vtf ?vte)
                (= ?vtf ?mzs)
                )
              (= ?vte ?mzs)
              )
            (and (and (not (= ?vth ?vtg))
                (not (= ?vth ?mzs))
                )
              (not (= ?vtg ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vti Real)
    (declare-const ?vtj Real)
    (declare-const ?vtk Real)
    (declare-const ?vtl Real)
    (declare-const ?vtm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vtn Real)
    (declare-const ?vto Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vtp Real)
    (declare-const ?vtq Real)
    (declare-const ?vtr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vts Real)
    (declare-const ?vtt Real)
    (declare-const ?vtu Real)
    (declare-const ?vtv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vtw Real)
    (declare-const ?vtx Real)
    (declare-const ?vty Real)
    (declare-const ?vtz Real)
    (declare-const ?vua Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vub Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vuc Real)
    (declare-const ?vud Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?vue Real)
  (declare-const ?vuf Real)
  (declare-const ?vug Real)
  (assert
    (or (or (= ?vug ?vuf)
        (= ?vug ?vue)
        )
      (= ?vuf ?vue)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?vuh Real)
    (declare-const ?vui Real)
    (declare-const ?vuj Real)
    (assert
      (or (or (= ?vuj ?vui)
          (= ?vuj ?vuh)
          )
        (= ?vui ?vuh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vuk Real)
    (declare-const ?vul Real)
    (declare-const ?vum Real)
    (declare-const ?vun Real)
    (assert
      (or (or (= ?vun ?vum)
          (= ?vun ?vul)
          )
        (= ?vum ?vul)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vuo Real)
    (declare-const ?vup Real)
    (declare-const ?vuq Real)
    (declare-const ?vur Real)
    (declare-const ?vus Real)
    (assert
      (or (or (= ?vus ?vur)
          (= ?vus ?vuq)
          )
        (= ?vur ?vuq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vut Real)
    (declare-const ?vuu Real)
    (declare-const ?vuv Real)
    (declare-const ?vuw Real)
    (declare-const ?vux Real)
    (declare-const ?vuy Real)
    (assert
      (and (and (and (not (= ?vuv ?vuu))
            (not (= ?vuv ?vut))
            )
          (not (= ?vuu ?vut))
          )
        (or (or (= ?vuy ?vux)
            (= ?vuy ?vuw)
            )
          (= ?vux ?vuw)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vuz Real)
    (declare-const ?vva Real)
    (declare-const ?vvb Real)
    (assert
      (or (or (= ?vvb ?vva)
          (= ?vvb ?vuz)
          )
        (= ?vva ?vuz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vvc Real)
    (declare-const ?vvd Real)
    (declare-const ?vve Real)
    (assert
      (or (or (= ?vve ?vvd)
          (= ?vve ?vvc)
          )
        (= ?vvd ?vvc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vvf Real)
    (declare-const ?vvg Real)
    (declare-const ?vvh Real)
    (declare-const ?vvi Real)
    (assert
      (or (or (= ?vvh ?vvg)
          (= ?vvh ?vvf)
          )
        (= ?vvg ?vvf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vvj Real)
    (declare-const ?vvk Real)
    (declare-const ?vvl Real)
    (declare-const ?vvm Real)
    (declare-const ?vvn Real)
    (assert
      (or (or (= ?vvl ?vvk)
          (= ?vvl ?vvj)
          )
        (= ?vvk ?vvj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vvo Real)
    (declare-const ?vvp Real)
    (declare-const ?vvq Real)
    (declare-const ?vvr Real)
    (declare-const ?vvs Real)
    (declare-const ?vvt Real)
    (assert
      (and (or (or (= ?vvq ?vvp)
            (= ?vvq ?vvo)
            )
          (= ?vvp ?vvo)
          )
        (and (and (not (= ?vvt ?vvs))
            (not (= ?vvt ?vvr))
            )
          (not (= ?vvs ?vvr))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vvu Real)
    (declare-const ?vvv Real)
    (declare-const ?vvw Real)
    (assert
      (or (or (= ?vvw ?vvv)
          (= ?vvw ?vvu)
          )
        (= ?vvv ?vvu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vvx Real)
    (declare-const ?vvy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vvz Real)
    (declare-const ?vwa Real)
    (declare-const ?vwb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vwc Real)
    (declare-const ?vwd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vwe Real)
    (declare-const ?vwf Real)
    (declare-const ?vwg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vwh Real)
    (declare-const ?vwi Real)
    (declare-const ?vwj Real)
    (declare-const ?vwk Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?vwi ?vwh))
                (not (= ?vwi ?asi))
                )
              (not (= ?vwh ?asi))
              )
            (or (or (= ?vwk ?vwj)
                (= ?vwk ?asi)
                )
              (= ?vwj ?asi)
              )
            )
          (and (or (or (= ?vwi ?vwh)
                (= ?vwi ?asi)
                )
              (= ?vwh ?asi)
              )
            (and (and (not (= ?vwk ?vwj))
                (not (= ?vwk ?asi))
                )
              (not (= ?vwj ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vwl Real)
    (declare-const ?vwm Real)
    (declare-const ?vwn Real)
    (declare-const ?vwo Real)
    (declare-const ?vwp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vwq Real)
    (declare-const ?vwr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vws Real)
    (declare-const ?vwt Real)
    (declare-const ?vwu Real)
    (declare-const ?vwv Real)
    (declare-const ?vww Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vwx Real)
    (declare-const ?vwy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vwz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vxa Real)
    (declare-const ?vxb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vxc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vxd Real)
    (declare-const ?vxe Real)
    (assert
      (not (= ?vxd ?vxe))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vxf Real)
    (declare-const ?vxg Real)
    (declare-const ?vxh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vxi Real)
    (declare-const ?vxj Real)
    (declare-const ?vxk Real)
    (declare-const ?vxl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vxm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vxn Real)
    (declare-const ?vxo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vxp Real)
    (declare-const ?vxq Real)
    (declare-const ?vxr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vxs Real)
    (declare-const ?vxt Real)
    (declare-const ?vxu Real)
    (declare-const ?vxv Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?vxt ?vxs))
                (not (= ?vxt ?fkf))
                )
              (not (= ?vxs ?fkf))
              )
            (or (or (= ?vxv ?vxu)
                (= ?vxv ?fkf)
                )
              (= ?vxu ?fkf)
              )
            )
          (and (or (or (= ?vxt ?vxs)
                (= ?vxt ?fkf)
                )
              (= ?vxs ?fkf)
              )
            (and (and (not (= ?vxv ?vxu))
                (not (= ?vxv ?fkf))
                )
              (not (= ?vxu ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vxw Real)
    (declare-const ?vxx Real)
    (declare-const ?vxy Real)
    (declare-const ?vxz Real)
    (declare-const ?vya Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vyb Real)
    (declare-const ?vyc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vyd Real)
    (declare-const ?vye Real)
    (declare-const ?vyf Real)
    (declare-const ?vyg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vyh Real)
    (declare-const ?vyi Real)
    (declare-const ?vyj Real)
    (declare-const ?vyk Real)
    (declare-const ?vyl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vym Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vyn Real)
    (declare-const ?vyo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vyp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vyq Real)
    (declare-const ?vyr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vys Real)
    (declare-const ?vyt Real)
    (declare-const ?vyu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vyv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vyw Real)
    (declare-const ?vyx Real)
    (assert
      (not (= ?vyw ?vyx))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vyy Real)
    (declare-const ?vyz Real)
    (declare-const ?vza Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vzb Real)
    (declare-const ?vzc Real)
    (declare-const ?vzd Real)
    (declare-const ?vze Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vzf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vzg Real)
    (declare-const ?vzh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vzi Real)
    (declare-const ?vzj Real)
    (declare-const ?vzk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vzl Real)
    (declare-const ?vzm Real)
    (declare-const ?vzn Real)
    (declare-const ?vzo Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?vzm ?vzl))
                (not (= ?vzm ?mzs))
                )
              (not (= ?vzl ?mzs))
              )
            (or (or (= ?vzo ?vzn)
                (= ?vzo ?mzs)
                )
              (= ?vzn ?mzs)
              )
            )
          (and (or (or (= ?vzm ?vzl)
                (= ?vzm ?mzs)
                )
              (= ?vzl ?mzs)
              )
            (and (and (not (= ?vzo ?vzn))
                (not (= ?vzo ?mzs))
                )
              (not (= ?vzn ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vzp Real)
    (declare-const ?vzq Real)
    (declare-const ?vzr Real)
    (declare-const ?vzs Real)
    (declare-const ?vzt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vzu Real)
    (declare-const ?vzv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vzw Real)
    (declare-const ?vzx Real)
    (declare-const ?vzy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?vzz Real)
    (declare-const ?waa Real)
    (declare-const ?wab Real)
    (declare-const ?wac Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wad Real)
    (declare-const ?wae Real)
    (declare-const ?waf Real)
    (declare-const ?wag Real)
    (declare-const ?wah Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wai Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?waj Real)
    (declare-const ?wak Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?wal Real)
  (declare-const ?wam Real)
  (push 1)
    (declare-const ?wan Real)
    (declare-const ?wao Real)
    (declare-const ?wap Real)
    (assert
      (or (or (= ?wap ?wao)
          (= ?wap ?wan)
          )
        (= ?wao ?wan)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?waq Real)
    (declare-const ?war Real)
    (declare-const ?was Real)
    (declare-const ?wat Real)
    (assert
      (or (or (= ?wat ?was)
          (= ?wat ?war)
          )
        (= ?was ?war)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wau Real)
    (declare-const ?wav Real)
    (declare-const ?waw Real)
    (declare-const ?wax Real)
    (declare-const ?way Real)
    (assert
      (or (or (= ?way ?wax)
          (= ?way ?waw)
          )
        (= ?wax ?waw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?waz Real)
    (declare-const ?wba Real)
    (declare-const ?wbb Real)
    (declare-const ?wbc Real)
    (declare-const ?wbd Real)
    (declare-const ?wbe Real)
    (assert
      (and (and (and (not (= ?wbb ?wba))
            (not (= ?wbb ?waz))
            )
          (not (= ?wba ?waz))
          )
        (or (or (= ?wbe ?wbd)
            (= ?wbe ?wbc)
            )
          (= ?wbd ?wbc)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wbf Real)
    (declare-const ?wbg Real)
    (declare-const ?wbh Real)
    (assert
      (or (or (= ?wbh ?wbg)
          (= ?wbh ?wbf)
          )
        (= ?wbg ?wbf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wbi Real)
    (declare-const ?wbj Real)
    (declare-const ?wbk Real)
    (assert
      (or (or (= ?wbk ?wbj)
          (= ?wbk ?wbi)
          )
        (= ?wbj ?wbi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wbl Real)
    (declare-const ?wbm Real)
    (declare-const ?wbn Real)
    (declare-const ?wbo Real)
    (assert
      (or (or (= ?wbn ?wbm)
          (= ?wbn ?wbl)
          )
        (= ?wbm ?wbl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wbp Real)
    (declare-const ?wbq Real)
    (declare-const ?wbr Real)
    (declare-const ?wbs Real)
    (declare-const ?wbt Real)
    (assert
      (or (or (= ?wbr ?wbq)
          (= ?wbr ?wbp)
          )
        (= ?wbq ?wbp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wbu Real)
    (declare-const ?wbv Real)
    (declare-const ?wbw Real)
    (declare-const ?wbx Real)
    (declare-const ?wby Real)
    (declare-const ?wbz Real)
    (assert
      (and (or (or (= ?wbw ?wbv)
            (= ?wbw ?wbu)
            )
          (= ?wbv ?wbu)
          )
        (and (and (not (= ?wbz ?wby))
            (not (= ?wbz ?wbx))
            )
          (not (= ?wby ?wbx))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wca Real)
    (declare-const ?wcb Real)
    (declare-const ?wcc Real)
    (assert
      (or (or (= ?wcc ?wcb)
          (= ?wcc ?wca)
          )
        (= ?wcb ?wca)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wcd Real)
    (declare-const ?wce Real)
    (declare-const ?wcf Real)
    (declare-const ?wcg Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?wce ?wcd))
                (not (= ?wce ?asi))
                )
              (not (= ?wcd ?asi))
              )
            (or (or (= ?wcg ?wcf)
                (= ?wcg ?asi)
                )
              (= ?wcf ?asi)
              )
            )
          (and (or (or (= ?wce ?wcd)
                (= ?wce ?asi)
                )
              (= ?wcd ?asi)
              )
            (and (and (not (= ?wcg ?wcf))
                (not (= ?wcg ?asi))
                )
              (not (= ?wcf ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wch Real)
    (declare-const ?wci Real)
    (declare-const ?wcj Real)
    (declare-const ?wck Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?wci ?wch))
                (not (= ?wci ?fkf))
                )
              (not (= ?wch ?fkf))
              )
            (or (or (= ?wck ?wcj)
                (= ?wck ?fkf)
                )
              (= ?wcj ?fkf)
              )
            )
          (and (or (or (= ?wci ?wch)
                (= ?wci ?fkf)
                )
              (= ?wch ?fkf)
              )
            (and (and (not (= ?wck ?wcj))
                (not (= ?wck ?fkf))
                )
              (not (= ?wcj ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wcl Real)
    (declare-const ?wcm Real)
    (declare-const ?wcn Real)
    (declare-const ?wco Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?wcm ?wcl))
                (not (= ?wcm ?mzs))
                )
              (not (= ?wcl ?mzs))
              )
            (or (or (= ?wco ?wcn)
                (= ?wco ?mzs)
                )
              (= ?wcn ?mzs)
              )
            )
          (and (or (or (= ?wcm ?wcl)
                (= ?wcm ?mzs)
                )
              (= ?wcl ?mzs)
              )
            (and (and (not (= ?wco ?wcn))
                (not (= ?wco ?mzs))
                )
              (not (= ?wcn ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?wcp Real)
  (declare-const ?wcq Real)
  (declare-const ?wcr Real)
  (push 1)
    (declare-const ?wcs Real)
    (declare-const ?wct Real)
    (declare-const ?wcu Real)
    (assert
      (or (or (= ?wcu ?wct)
          (= ?wcu ?wcs)
          )
        (= ?wct ?wcs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wcv Real)
    (declare-const ?wcw Real)
    (declare-const ?wcx Real)
    (declare-const ?wcy Real)
    (assert
      (or (or (= ?wcy ?wcx)
          (= ?wcy ?wcw)
          )
        (= ?wcx ?wcw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wcz Real)
    (declare-const ?wda Real)
    (declare-const ?wdb Real)
    (declare-const ?wdc Real)
    (declare-const ?wdd Real)
    (assert
      (or (or (= ?wdd ?wdc)
          (= ?wdd ?wdb)
          )
        (= ?wdc ?wdb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wde Real)
    (declare-const ?wdf Real)
    (declare-const ?wdg Real)
    (declare-const ?wdh Real)
    (declare-const ?wdi Real)
    (declare-const ?wdj Real)
    (assert
      (and (and (and (not (= ?wdg ?wdf))
            (not (= ?wdg ?wde))
            )
          (not (= ?wdf ?wde))
          )
        (or (or (= ?wdj ?wdi)
            (= ?wdj ?wdh)
            )
          (= ?wdi ?wdh)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wdk Real)
    (declare-const ?wdl Real)
    (declare-const ?wdm Real)
    (assert
      (or (or (= ?wdm ?wdl)
          (= ?wdm ?wdk)
          )
        (= ?wdl ?wdk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wdn Real)
    (declare-const ?wdo Real)
    (declare-const ?wdp Real)
    (assert
      (or (or (= ?wdp ?wdo)
          (= ?wdp ?wdn)
          )
        (= ?wdo ?wdn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wdq Real)
    (declare-const ?wdr Real)
    (declare-const ?wds Real)
    (declare-const ?wdt Real)
    (assert
      (or (or (= ?wds ?wdr)
          (= ?wds ?wdq)
          )
        (= ?wdr ?wdq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wdu Real)
    (declare-const ?wdv Real)
    (declare-const ?wdw Real)
    (declare-const ?wdx Real)
    (declare-const ?wdy Real)
    (assert
      (or (or (= ?wdw ?wdv)
          (= ?wdw ?wdu)
          )
        (= ?wdv ?wdu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wdz Real)
    (declare-const ?wea Real)
    (declare-const ?web Real)
    (declare-const ?wec Real)
    (declare-const ?wed Real)
    (declare-const ?wee Real)
    (assert
      (and (or (or (= ?web ?wea)
            (= ?web ?wdz)
            )
          (= ?wea ?wdz)
          )
        (and (and (not (= ?wee ?wed))
            (not (= ?wee ?wec))
            )
          (not (= ?wed ?wec))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wef Real)
    (declare-const ?weg Real)
    (declare-const ?weh Real)
    (assert
      (or (or (= ?weh ?weg)
          (= ?weh ?wef)
          )
        (= ?weg ?wef)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wei Real)
    (declare-const ?wej Real)
    (declare-const ?wek Real)
    (declare-const ?wel Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?wej ?wei))
                (not (= ?wej ?asi))
                )
              (not (= ?wei ?asi))
              )
            (or (or (= ?wel ?wek)
                (= ?wel ?asi)
                )
              (= ?wek ?asi)
              )
            )
          (and (or (or (= ?wej ?wei)
                (= ?wej ?asi)
                )
              (= ?wei ?asi)
              )
            (and (and (not (= ?wel ?wek))
                (not (= ?wel ?asi))
                )
              (not (= ?wek ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wem Real)
    (declare-const ?wen Real)
    (declare-const ?weo Real)
    (declare-const ?wep Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?wen ?wem))
                (not (= ?wen ?fkf))
                )
              (not (= ?wem ?fkf))
              )
            (or (or (= ?wep ?weo)
                (= ?wep ?fkf)
                )
              (= ?weo ?fkf)
              )
            )
          (and (or (or (= ?wen ?wem)
                (= ?wen ?fkf)
                )
              (= ?wem ?fkf)
              )
            (and (and (not (= ?wep ?weo))
                (not (= ?wep ?fkf))
                )
              (not (= ?weo ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?weq Real)
    (declare-const ?wer Real)
    (declare-const ?wes Real)
    (declare-const ?wet Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?wer ?weq))
                (not (= ?wer ?mzs))
                )
              (not (= ?weq ?mzs))
              )
            (or (or (= ?wet ?wes)
                (= ?wet ?mzs)
                )
              (= ?wes ?mzs)
              )
            )
          (and (or (or (= ?wer ?weq)
                (= ?wer ?mzs)
                )
              (= ?weq ?mzs)
              )
            (and (and (not (= ?wet ?wes))
                (not (= ?wet ?mzs))
                )
              (not (= ?wes ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?weu Real)
  (declare-const ?wev Real)
  (push 1)
    (declare-const ?wew Real)
    (declare-const ?wex Real)
    (declare-const ?wey Real)
    (assert
      (or (or (= ?wey ?wex)
          (= ?wey ?wew)
          )
        (= ?wex ?wew)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wez Real)
    (declare-const ?wfa Real)
    (declare-const ?wfb Real)
    (declare-const ?wfc Real)
    (assert
      (or (or (= ?wfc ?wfb)
          (= ?wfc ?wfa)
          )
        (= ?wfb ?wfa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wfd Real)
    (declare-const ?wfe Real)
    (declare-const ?wff Real)
    (declare-const ?wfg Real)
    (declare-const ?wfh Real)
    (assert
      (or (or (= ?wfh ?wfg)
          (= ?wfh ?wff)
          )
        (= ?wfg ?wff)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wfi Real)
    (declare-const ?wfj Real)
    (declare-const ?wfk Real)
    (declare-const ?wfl Real)
    (declare-const ?wfm Real)
    (declare-const ?wfn Real)
    (assert
      (and (and (and (not (= ?wfk ?wfj))
            (not (= ?wfk ?wfi))
            )
          (not (= ?wfj ?wfi))
          )
        (or (or (= ?wfn ?wfm)
            (= ?wfn ?wfl)
            )
          (= ?wfm ?wfl)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wfo Real)
    (declare-const ?wfp Real)
    (declare-const ?wfq Real)
    (assert
      (or (or (= ?wfq ?wfp)
          (= ?wfq ?wfo)
          )
        (= ?wfp ?wfo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wfr Real)
    (declare-const ?wfs Real)
    (declare-const ?wft Real)
    (assert
      (or (or (= ?wft ?wfs)
          (= ?wft ?wfr)
          )
        (= ?wfs ?wfr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wfu Real)
    (declare-const ?wfv Real)
    (declare-const ?wfw Real)
    (declare-const ?wfx Real)
    (assert
      (or (or (= ?wfw ?wfv)
          (= ?wfw ?wfu)
          )
        (= ?wfv ?wfu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wfy Real)
    (declare-const ?wfz Real)
    (declare-const ?wga Real)
    (declare-const ?wgb Real)
    (declare-const ?wgc Real)
    (assert
      (or (or (= ?wga ?wfz)
          (= ?wga ?wfy)
          )
        (= ?wfz ?wfy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wgd Real)
    (declare-const ?wge Real)
    (declare-const ?wgf Real)
    (declare-const ?wgg Real)
    (declare-const ?wgh Real)
    (declare-const ?wgi Real)
    (assert
      (and (or (or (= ?wgf ?wge)
            (= ?wgf ?wgd)
            )
          (= ?wge ?wgd)
          )
        (and (and (not (= ?wgi ?wgh))
            (not (= ?wgi ?wgg))
            )
          (not (= ?wgh ?wgg))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wgj Real)
    (declare-const ?wgk Real)
    (declare-const ?wgl Real)
    (assert
      (or (or (= ?wgl ?wgk)
          (= ?wgl ?wgj)
          )
        (= ?wgk ?wgj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wgm Real)
    (declare-const ?wgn Real)
    (declare-const ?wgo Real)
    (declare-const ?wgp Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?wgn ?wgm))
                (not (= ?wgn ?asi))
                )
              (not (= ?wgm ?asi))
              )
            (or (or (= ?wgp ?wgo)
                (= ?wgp ?asi)
                )
              (= ?wgo ?asi)
              )
            )
          (and (or (or (= ?wgn ?wgm)
                (= ?wgn ?asi)
                )
              (= ?wgm ?asi)
              )
            (and (and (not (= ?wgp ?wgo))
                (not (= ?wgp ?asi))
                )
              (not (= ?wgo ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wgq Real)
    (declare-const ?wgr Real)
    (declare-const ?wgs Real)
    (declare-const ?wgt Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?wgr ?wgq))
                (not (= ?wgr ?fkf))
                )
              (not (= ?wgq ?fkf))
              )
            (or (or (= ?wgt ?wgs)
                (= ?wgt ?fkf)
                )
              (= ?wgs ?fkf)
              )
            )
          (and (or (or (= ?wgr ?wgq)
                (= ?wgr ?fkf)
                )
              (= ?wgq ?fkf)
              )
            (and (and (not (= ?wgt ?wgs))
                (not (= ?wgt ?fkf))
                )
              (not (= ?wgs ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wgu Real)
    (declare-const ?wgv Real)
    (declare-const ?wgw Real)
    (declare-const ?wgx Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?wgv ?wgu))
                (not (= ?wgv ?mzs))
                )
              (not (= ?wgu ?mzs))
              )
            (or (or (= ?wgx ?wgw)
                (= ?wgx ?mzs)
                )
              (= ?wgw ?mzs)
              )
            )
          (and (or (or (= ?wgv ?wgu)
                (= ?wgv ?mzs)
                )
              (= ?wgu ?mzs)
              )
            (and (and (not (= ?wgx ?wgw))
                (not (= ?wgx ?mzs))
                )
              (not (= ?wgw ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?wgy Real)
  (declare-const ?wgz Real)
  (declare-const ?wha Real)
  (push 1)
    (declare-const ?whb Real)
    (declare-const ?whc Real)
    (declare-const ?whd Real)
    (assert
      (or (or (= ?whd ?whc)
          (= ?whd ?whb)
          )
        (= ?whc ?whb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?whe Real)
    (declare-const ?whf Real)
    (declare-const ?whg Real)
    (declare-const ?whh Real)
    (assert
      (or (or (= ?whh ?whg)
          (= ?whh ?whf)
          )
        (= ?whg ?whf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?whi Real)
    (declare-const ?whj Real)
    (declare-const ?whk Real)
    (declare-const ?whl Real)
    (declare-const ?whm Real)
    (assert
      (or (or (= ?whm ?whl)
          (= ?whm ?whk)
          )
        (= ?whl ?whk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?whn Real)
    (declare-const ?who Real)
    (declare-const ?whp Real)
    (declare-const ?whq Real)
    (declare-const ?whr Real)
    (declare-const ?whs Real)
    (assert
      (and (and (and (not (= ?whp ?who))
            (not (= ?whp ?whn))
            )
          (not (= ?who ?whn))
          )
        (or (or (= ?whs ?whr)
            (= ?whs ?whq)
            )
          (= ?whr ?whq)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wht Real)
    (declare-const ?whu Real)
    (declare-const ?whv Real)
    (assert
      (or (or (= ?whv ?whu)
          (= ?whv ?wht)
          )
        (= ?whu ?wht)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?whw Real)
    (declare-const ?whx Real)
    (declare-const ?why Real)
    (assert
      (or (or (= ?why ?whx)
          (= ?why ?whw)
          )
        (= ?whx ?whw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?whz Real)
    (declare-const ?wia Real)
    (declare-const ?wib Real)
    (declare-const ?wic Real)
    (assert
      (or (or (= ?wib ?wia)
          (= ?wib ?whz)
          )
        (= ?wia ?whz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wid Real)
    (declare-const ?wie Real)
    (declare-const ?wif Real)
    (declare-const ?wig Real)
    (declare-const ?wih Real)
    (assert
      (or (or (= ?wif ?wie)
          (= ?wif ?wid)
          )
        (= ?wie ?wid)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wii Real)
    (declare-const ?wij Real)
    (declare-const ?wik Real)
    (declare-const ?wil Real)
    (declare-const ?wim Real)
    (declare-const ?win Real)
    (assert
      (and (or (or (= ?wik ?wij)
            (= ?wik ?wii)
            )
          (= ?wij ?wii)
          )
        (and (and (not (= ?win ?wim))
            (not (= ?win ?wil))
            )
          (not (= ?wim ?wil))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wio Real)
    (declare-const ?wip Real)
    (declare-const ?wiq Real)
    (assert
      (or (or (= ?wiq ?wip)
          (= ?wiq ?wio)
          )
        (= ?wip ?wio)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wir Real)
    (declare-const ?wis Real)
    (declare-const ?wit Real)
    (declare-const ?wiu Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?wis ?wir))
                (not (= ?wis ?asi))
                )
              (not (= ?wir ?asi))
              )
            (or (or (= ?wiu ?wit)
                (= ?wiu ?asi)
                )
              (= ?wit ?asi)
              )
            )
          (and (or (or (= ?wis ?wir)
                (= ?wis ?asi)
                )
              (= ?wir ?asi)
              )
            (and (and (not (= ?wiu ?wit))
                (not (= ?wiu ?asi))
                )
              (not (= ?wit ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wiv Real)
    (declare-const ?wiw Real)
    (declare-const ?wix Real)
    (declare-const ?wiy Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?wiw ?wiv))
                (not (= ?wiw ?fkf))
                )
              (not (= ?wiv ?fkf))
              )
            (or (or (= ?wiy ?wix)
                (= ?wiy ?fkf)
                )
              (= ?wix ?fkf)
              )
            )
          (and (or (or (= ?wiw ?wiv)
                (= ?wiw ?fkf)
                )
              (= ?wiv ?fkf)
              )
            (and (and (not (= ?wiy ?wix))
                (not (= ?wiy ?fkf))
                )
              (not (= ?wix ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wiz Real)
    (declare-const ?wja Real)
    (declare-const ?wjb Real)
    (declare-const ?wjc Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?wja ?wiz))
                (not (= ?wja ?mzs))
                )
              (not (= ?wiz ?mzs))
              )
            (or (or (= ?wjc ?wjb)
                (= ?wjc ?mzs)
                )
              (= ?wjb ?mzs)
              )
            )
          (and (or (or (= ?wja ?wiz)
                (= ?wja ?mzs)
                )
              (= ?wiz ?mzs)
              )
            (and (and (not (= ?wjc ?wjb))
                (not (= ?wjc ?mzs))
                )
              (not (= ?wjb ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?wjd Real)
  (declare-const ?wje Real)
  (declare-const ?wjf Real)
  (declare-const ?wjg Real)
  (assert
    (exists ((?asi Real) )(or (and (and (and (not (= ?wje ?wjd))
              (not (= ?wje ?asi))
              )
            (not (= ?wjd ?asi))
            )
          (or (or (= ?wjg ?wjf)
              (= ?wjg ?asi)
              )
            (= ?wjf ?asi)
            )
          )
        (and (or (or (= ?wje ?wjd)
              (= ?wje ?asi)
              )
            (= ?wjd ?asi)
            )
          (and (and (not (= ?wjg ?wjf))
              (not (= ?wjg ?asi))
              )
            (not (= ?wjf ?asi))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?wjh Real)
    (declare-const ?wji Real)
    (declare-const ?wjj Real)
    (assert
      (or (or (= ?wjj ?wji)
          (= ?wjj ?wjh)
          )
        (= ?wji ?wjh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wjk Real)
    (declare-const ?wjl Real)
    (declare-const ?wjm Real)
    (declare-const ?wjn Real)
    (assert
      (or (or (= ?wjn ?wjm)
          (= ?wjn ?wjl)
          )
        (= ?wjm ?wjl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wjo Real)
    (declare-const ?wjp Real)
    (declare-const ?wjq Real)
    (declare-const ?wjr Real)
    (declare-const ?wjs Real)
    (assert
      (or (or (= ?wjs ?wjr)
          (= ?wjs ?wjq)
          )
        (= ?wjr ?wjq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wjt Real)
    (declare-const ?wju Real)
    (declare-const ?wjv Real)
    (declare-const ?wjw Real)
    (declare-const ?wjx Real)
    (declare-const ?wjy Real)
    (assert
      (and (and (and (not (= ?wjv ?wju))
            (not (= ?wjv ?wjt))
            )
          (not (= ?wju ?wjt))
          )
        (or (or (= ?wjy ?wjx)
            (= ?wjy ?wjw)
            )
          (= ?wjx ?wjw)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wjz Real)
    (declare-const ?wka Real)
    (declare-const ?wkb Real)
    (assert
      (or (or (= ?wkb ?wka)
          (= ?wkb ?wjz)
          )
        (= ?wka ?wjz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wkc Real)
    (declare-const ?wkd Real)
    (declare-const ?wke Real)
    (assert
      (or (or (= ?wke ?wkd)
          (= ?wke ?wkc)
          )
        (= ?wkd ?wkc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wkf Real)
    (declare-const ?wkg Real)
    (declare-const ?wkh Real)
    (declare-const ?wki Real)
    (assert
      (or (or (= ?wkh ?wkg)
          (= ?wkh ?wkf)
          )
        (= ?wkg ?wkf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wkj Real)
    (declare-const ?wkk Real)
    (declare-const ?wkl Real)
    (declare-const ?wkm Real)
    (declare-const ?wkn Real)
    (assert
      (or (or (= ?wkl ?wkk)
          (= ?wkl ?wkj)
          )
        (= ?wkk ?wkj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wko Real)
    (declare-const ?wkp Real)
    (declare-const ?wkq Real)
    (declare-const ?wkr Real)
    (declare-const ?wks Real)
    (declare-const ?wkt Real)
    (assert
      (and (or (or (= ?wkq ?wkp)
            (= ?wkq ?wko)
            )
          (= ?wkp ?wko)
          )
        (and (and (not (= ?wkt ?wks))
            (not (= ?wkt ?wkr))
            )
          (not (= ?wks ?wkr))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wku Real)
    (declare-const ?wkv Real)
    (declare-const ?wkw Real)
    (assert
      (or (or (= ?wkw ?wkv)
          (= ?wkw ?wku)
          )
        (= ?wkv ?wku)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wkx Real)
    (declare-const ?wky Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wkz Real)
    (declare-const ?wla Real)
    (declare-const ?wlb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wlc Real)
    (declare-const ?wld Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wle Real)
    (declare-const ?wlf Real)
    (declare-const ?wlg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wlh Real)
    (declare-const ?wli Real)
    (declare-const ?wlj Real)
    (declare-const ?wlk Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?wli ?wlh))
                (not (= ?wli ?asi))
                )
              (not (= ?wlh ?asi))
              )
            (or (or (= ?wlk ?wlj)
                (= ?wlk ?asi)
                )
              (= ?wlj ?asi)
              )
            )
          (and (or (or (= ?wli ?wlh)
                (= ?wli ?asi)
                )
              (= ?wlh ?asi)
              )
            (and (and (not (= ?wlk ?wlj))
                (not (= ?wlk ?asi))
                )
              (not (= ?wlj ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wll Real)
    (declare-const ?wlm Real)
    (declare-const ?wln Real)
    (declare-const ?wlo Real)
    (declare-const ?wlp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wlq Real)
    (declare-const ?wlr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wls Real)
    (declare-const ?wlt Real)
    (declare-const ?wlu Real)
    (declare-const ?wlv Real)
    (declare-const ?wlw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wlx Real)
    (declare-const ?wly Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wlz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wma Real)
    (declare-const ?wmb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wmc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wmd Real)
    (declare-const ?wme Real)
    (assert
      (not (= ?wmd ?wme))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wmf Real)
    (declare-const ?wmg Real)
    (declare-const ?wmh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wmi Real)
    (declare-const ?wmj Real)
    (declare-const ?wmk Real)
    (declare-const ?wml Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wmm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wmn Real)
    (declare-const ?wmo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wmp Real)
    (declare-const ?wmq Real)
    (declare-const ?wmr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wms Real)
    (declare-const ?wmt Real)
    (declare-const ?wmu Real)
    (declare-const ?wmv Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?wmt ?wms))
                (not (= ?wmt ?fkf))
                )
              (not (= ?wms ?fkf))
              )
            (or (or (= ?wmv ?wmu)
                (= ?wmv ?fkf)
                )
              (= ?wmu ?fkf)
              )
            )
          (and (or (or (= ?wmt ?wms)
                (= ?wmt ?fkf)
                )
              (= ?wms ?fkf)
              )
            (and (and (not (= ?wmv ?wmu))
                (not (= ?wmv ?fkf))
                )
              (not (= ?wmu ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wmw Real)
    (declare-const ?wmx Real)
    (declare-const ?wmy Real)
    (declare-const ?wmz Real)
    (declare-const ?wna Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wnb Real)
    (declare-const ?wnc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wnd Real)
    (declare-const ?wne Real)
    (declare-const ?wnf Real)
    (declare-const ?wng Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wnh Real)
    (declare-const ?wni Real)
    (declare-const ?wnj Real)
    (declare-const ?wnk Real)
    (declare-const ?wnl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wnm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wnn Real)
    (declare-const ?wno Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wnp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wnq Real)
    (declare-const ?wnr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wns Real)
    (declare-const ?wnt Real)
    (declare-const ?wnu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wnv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wnw Real)
    (declare-const ?wnx Real)
    (assert
      (not (= ?wnw ?wnx))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wny Real)
    (declare-const ?wnz Real)
    (declare-const ?woa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wob Real)
    (declare-const ?woc Real)
    (declare-const ?wod Real)
    (declare-const ?woe Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wof Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wog Real)
    (declare-const ?woh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?woi Real)
    (declare-const ?woj Real)
    (declare-const ?wok Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wol Real)
    (declare-const ?wom Real)
    (declare-const ?won Real)
    (declare-const ?woo Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?wom ?wol))
                (not (= ?wom ?mzs))
                )
              (not (= ?wol ?mzs))
              )
            (or (or (= ?woo ?won)
                (= ?woo ?mzs)
                )
              (= ?won ?mzs)
              )
            )
          (and (or (or (= ?wom ?wol)
                (= ?wom ?mzs)
                )
              (= ?wol ?mzs)
              )
            (and (and (not (= ?woo ?won))
                (not (= ?woo ?mzs))
                )
              (not (= ?won ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wop Real)
    (declare-const ?woq Real)
    (declare-const ?wor Real)
    (declare-const ?wos Real)
    (declare-const ?wot Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wou Real)
    (declare-const ?wov Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wow Real)
    (declare-const ?wox Real)
    (declare-const ?woy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?woz Real)
    (declare-const ?wpa Real)
    (declare-const ?wpb Real)
    (declare-const ?wpc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wpd Real)
    (declare-const ?wpe Real)
    (declare-const ?wpf Real)
    (declare-const ?wpg Real)
    (declare-const ?wph Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wpi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wpj Real)
    (declare-const ?wpk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?wpl Real)
  (declare-const ?wpm Real)
  (declare-const ?wpn Real)
  (declare-const ?wpo Real)
  (declare-const ?wpp Real)
  (push 1)
    (declare-const ?wpq Real)
    (declare-const ?wpr Real)
    (declare-const ?wps Real)
    (assert
      (or (or (= ?wps ?wpr)
          (= ?wps ?wpq)
          )
        (= ?wpr ?wpq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wpt Real)
    (declare-const ?wpu Real)
    (declare-const ?wpv Real)
    (declare-const ?wpw Real)
    (assert
      (or (or (= ?wpw ?wpv)
          (= ?wpw ?wpu)
          )
        (= ?wpv ?wpu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wpx Real)
    (declare-const ?wpy Real)
    (declare-const ?wpz Real)
    (declare-const ?wqa Real)
    (declare-const ?wqb Real)
    (assert
      (or (or (= ?wqb ?wqa)
          (= ?wqb ?wpz)
          )
        (= ?wqa ?wpz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wqc Real)
    (declare-const ?wqd Real)
    (declare-const ?wqe Real)
    (declare-const ?wqf Real)
    (declare-const ?wqg Real)
    (declare-const ?wqh Real)
    (assert
      (and (and (and (not (= ?wqe ?wqd))
            (not (= ?wqe ?wqc))
            )
          (not (= ?wqd ?wqc))
          )
        (or (or (= ?wqh ?wqg)
            (= ?wqh ?wqf)
            )
          (= ?wqg ?wqf)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wqi Real)
    (declare-const ?wqj Real)
    (declare-const ?wqk Real)
    (assert
      (or (or (= ?wqk ?wqj)
          (= ?wqk ?wqi)
          )
        (= ?wqj ?wqi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wql Real)
    (declare-const ?wqm Real)
    (declare-const ?wqn Real)
    (assert
      (or (or (= ?wqn ?wqm)
          (= ?wqn ?wql)
          )
        (= ?wqm ?wql)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wqo Real)
    (declare-const ?wqp Real)
    (declare-const ?wqq Real)
    (declare-const ?wqr Real)
    (assert
      (or (or (= ?wqq ?wqp)
          (= ?wqq ?wqo)
          )
        (= ?wqp ?wqo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wqs Real)
    (declare-const ?wqt Real)
    (declare-const ?wqu Real)
    (declare-const ?wqv Real)
    (declare-const ?wqw Real)
    (assert
      (or (or (= ?wqu ?wqt)
          (= ?wqu ?wqs)
          )
        (= ?wqt ?wqs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wqx Real)
    (declare-const ?wqy Real)
    (declare-const ?wqz Real)
    (declare-const ?wra Real)
    (declare-const ?wrb Real)
    (declare-const ?wrc Real)
    (assert
      (and (or (or (= ?wqz ?wqy)
            (= ?wqz ?wqx)
            )
          (= ?wqy ?wqx)
          )
        (and (and (not (= ?wrc ?wrb))
            (not (= ?wrc ?wra))
            )
          (not (= ?wrb ?wra))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wrd Real)
    (declare-const ?wre Real)
    (declare-const ?wrf Real)
    (assert
      (or (or (= ?wrf ?wre)
          (= ?wrf ?wrd)
          )
        (= ?wre ?wrd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wrg Real)
    (declare-const ?wrh Real)
    (declare-const ?wri Real)
    (declare-const ?wrj Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?wrh ?wrg))
                (not (= ?wrh ?asi))
                )
              (not (= ?wrg ?asi))
              )
            (or (or (= ?wrj ?wri)
                (= ?wrj ?asi)
                )
              (= ?wri ?asi)
              )
            )
          (and (or (or (= ?wrh ?wrg)
                (= ?wrh ?asi)
                )
              (= ?wrg ?asi)
              )
            (and (and (not (= ?wrj ?wri))
                (not (= ?wrj ?asi))
                )
              (not (= ?wri ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wrk Real)
    (declare-const ?wrl Real)
    (declare-const ?wrm Real)
    (declare-const ?wrn Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?wrl ?wrk))
                (not (= ?wrl ?fkf))
                )
              (not (= ?wrk ?fkf))
              )
            (or (or (= ?wrn ?wrm)
                (= ?wrn ?fkf)
                )
              (= ?wrm ?fkf)
              )
            )
          (and (or (or (= ?wrl ?wrk)
                (= ?wrl ?fkf)
                )
              (= ?wrk ?fkf)
              )
            (and (and (not (= ?wrn ?wrm))
                (not (= ?wrn ?fkf))
                )
              (not (= ?wrm ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wro Real)
    (declare-const ?wrp Real)
    (declare-const ?wrq Real)
    (declare-const ?wrr Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?wrp ?wro))
                (not (= ?wrp ?mzs))
                )
              (not (= ?wro ?mzs))
              )
            (or (or (= ?wrr ?wrq)
                (= ?wrr ?mzs)
                )
              (= ?wrq ?mzs)
              )
            )
          (and (or (or (= ?wrp ?wro)
                (= ?wrp ?mzs)
                )
              (= ?wro ?mzs)
              )
            (and (and (not (= ?wrr ?wrq))
                (not (= ?wrr ?mzs))
                )
              (not (= ?wrq ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?wrs Real)
  (declare-const ?wrt Real)
  (push 1)
    (declare-const ?wru Real)
    (declare-const ?wrv Real)
    (declare-const ?wrw Real)
    (assert
      (or (or (= ?wrw ?wrv)
          (= ?wrw ?wru)
          )
        (= ?wrv ?wru)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wrx Real)
    (declare-const ?wry Real)
    (declare-const ?wrz Real)
    (declare-const ?wsa Real)
    (assert
      (or (or (= ?wsa ?wrz)
          (= ?wsa ?wry)
          )
        (= ?wrz ?wry)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wsb Real)
    (declare-const ?wsc Real)
    (declare-const ?wsd Real)
    (declare-const ?wse Real)
    (declare-const ?wsf Real)
    (assert
      (or (or (= ?wsf ?wse)
          (= ?wsf ?wsd)
          )
        (= ?wse ?wsd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wsg Real)
    (declare-const ?wsh Real)
    (declare-const ?wsi Real)
    (declare-const ?wsj Real)
    (declare-const ?wsk Real)
    (declare-const ?wsl Real)
    (assert
      (and (and (and (not (= ?wsi ?wsh))
            (not (= ?wsi ?wsg))
            )
          (not (= ?wsh ?wsg))
          )
        (or (or (= ?wsl ?wsk)
            (= ?wsl ?wsj)
            )
          (= ?wsk ?wsj)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wsm Real)
    (declare-const ?wsn Real)
    (declare-const ?wso Real)
    (assert
      (or (or (= ?wso ?wsn)
          (= ?wso ?wsm)
          )
        (= ?wsn ?wsm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wsp Real)
    (declare-const ?wsq Real)
    (declare-const ?wsr Real)
    (assert
      (or (or (= ?wsr ?wsq)
          (= ?wsr ?wsp)
          )
        (= ?wsq ?wsp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wss Real)
    (declare-const ?wst Real)
    (declare-const ?wsu Real)
    (declare-const ?wsv Real)
    (assert
      (or (or (= ?wsu ?wst)
          (= ?wsu ?wss)
          )
        (= ?wst ?wss)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wsw Real)
    (declare-const ?wsx Real)
    (declare-const ?wsy Real)
    (declare-const ?wsz Real)
    (declare-const ?wta Real)
    (assert
      (or (or (= ?wsy ?wsx)
          (= ?wsy ?wsw)
          )
        (= ?wsx ?wsw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wtb Real)
    (declare-const ?wtc Real)
    (declare-const ?wtd Real)
    (declare-const ?wte Real)
    (declare-const ?wtf Real)
    (declare-const ?wtg Real)
    (assert
      (and (or (or (= ?wtd ?wtc)
            (= ?wtd ?wtb)
            )
          (= ?wtc ?wtb)
          )
        (and (and (not (= ?wtg ?wtf))
            (not (= ?wtg ?wte))
            )
          (not (= ?wtf ?wte))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wth Real)
    (declare-const ?wti Real)
    (declare-const ?wtj Real)
    (assert
      (or (or (= ?wtj ?wti)
          (= ?wtj ?wth)
          )
        (= ?wti ?wth)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wtk Real)
    (declare-const ?wtl Real)
    (declare-const ?wtm Real)
    (declare-const ?wtn Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?wtl ?wtk))
                (not (= ?wtl ?asi))
                )
              (not (= ?wtk ?asi))
              )
            (or (or (= ?wtn ?wtm)
                (= ?wtn ?asi)
                )
              (= ?wtm ?asi)
              )
            )
          (and (or (or (= ?wtl ?wtk)
                (= ?wtl ?asi)
                )
              (= ?wtk ?asi)
              )
            (and (and (not (= ?wtn ?wtm))
                (not (= ?wtn ?asi))
                )
              (not (= ?wtm ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wto Real)
    (declare-const ?wtp Real)
    (declare-const ?wtq Real)
    (declare-const ?wtr Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?wtp ?wto))
                (not (= ?wtp ?fkf))
                )
              (not (= ?wto ?fkf))
              )
            (or (or (= ?wtr ?wtq)
                (= ?wtr ?fkf)
                )
              (= ?wtq ?fkf)
              )
            )
          (and (or (or (= ?wtp ?wto)
                (= ?wtp ?fkf)
                )
              (= ?wto ?fkf)
              )
            (and (and (not (= ?wtr ?wtq))
                (not (= ?wtr ?fkf))
                )
              (not (= ?wtq ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wts Real)
    (declare-const ?wtt Real)
    (declare-const ?wtu Real)
    (declare-const ?wtv Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?wtt ?wts))
                (not (= ?wtt ?mzs))
                )
              (not (= ?wts ?mzs))
              )
            (or (or (= ?wtv ?wtu)
                (= ?wtv ?mzs)
                )
              (= ?wtu ?mzs)
              )
            )
          (and (or (or (= ?wtt ?wts)
                (= ?wtt ?mzs)
                )
              (= ?wts ?mzs)
              )
            (and (and (not (= ?wtv ?wtu))
                (not (= ?wtv ?mzs))
                )
              (not (= ?wtu ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?wtw Real)
  (declare-const ?wtx Real)
  (declare-const ?wty Real)
  (declare-const ?wtz Real)
  (declare-const ?wua Real)
  (push 1)
    (declare-const ?wub Real)
    (declare-const ?wuc Real)
    (declare-const ?wud Real)
    (assert
      (or (or (= ?wud ?wuc)
          (= ?wud ?wub)
          )
        (= ?wuc ?wub)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wue Real)
    (declare-const ?wuf Real)
    (declare-const ?wug Real)
    (declare-const ?wuh Real)
    (assert
      (or (or (= ?wuh ?wug)
          (= ?wuh ?wuf)
          )
        (= ?wug ?wuf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wui Real)
    (declare-const ?wuj Real)
    (declare-const ?wuk Real)
    (declare-const ?wul Real)
    (declare-const ?wum Real)
    (assert
      (or (or (= ?wum ?wul)
          (= ?wum ?wuk)
          )
        (= ?wul ?wuk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wun Real)
    (declare-const ?wuo Real)
    (declare-const ?wup Real)
    (declare-const ?wuq Real)
    (declare-const ?wur Real)
    (declare-const ?wus Real)
    (assert
      (and (and (and (not (= ?wup ?wuo))
            (not (= ?wup ?wun))
            )
          (not (= ?wuo ?wun))
          )
        (or (or (= ?wus ?wur)
            (= ?wus ?wuq)
            )
          (= ?wur ?wuq)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wut Real)
    (declare-const ?wuu Real)
    (declare-const ?wuv Real)
    (assert
      (or (or (= ?wuv ?wuu)
          (= ?wuv ?wut)
          )
        (= ?wuu ?wut)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wuw Real)
    (declare-const ?wux Real)
    (declare-const ?wuy Real)
    (assert
      (or (or (= ?wuy ?wux)
          (= ?wuy ?wuw)
          )
        (= ?wux ?wuw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wuz Real)
    (declare-const ?wva Real)
    (declare-const ?wvb Real)
    (declare-const ?wvc Real)
    (assert
      (or (or (= ?wvb ?wva)
          (= ?wvb ?wuz)
          )
        (= ?wva ?wuz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wvd Real)
    (declare-const ?wve Real)
    (declare-const ?wvf Real)
    (declare-const ?wvg Real)
    (declare-const ?wvh Real)
    (assert
      (or (or (= ?wvf ?wve)
          (= ?wvf ?wvd)
          )
        (= ?wve ?wvd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wvi Real)
    (declare-const ?wvj Real)
    (declare-const ?wvk Real)
    (declare-const ?wvl Real)
    (declare-const ?wvm Real)
    (declare-const ?wvn Real)
    (assert
      (and (or (or (= ?wvk ?wvj)
            (= ?wvk ?wvi)
            )
          (= ?wvj ?wvi)
          )
        (and (and (not (= ?wvn ?wvm))
            (not (= ?wvn ?wvl))
            )
          (not (= ?wvm ?wvl))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wvo Real)
    (declare-const ?wvp Real)
    (declare-const ?wvq Real)
    (assert
      (or (or (= ?wvq ?wvp)
          (= ?wvq ?wvo)
          )
        (= ?wvp ?wvo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wvr Real)
    (declare-const ?wvs Real)
    (declare-const ?wvt Real)
    (declare-const ?wvu Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?wvs ?wvr))
                (not (= ?wvs ?asi))
                )
              (not (= ?wvr ?asi))
              )
            (or (or (= ?wvu ?wvt)
                (= ?wvu ?asi)
                )
              (= ?wvt ?asi)
              )
            )
          (and (or (or (= ?wvs ?wvr)
                (= ?wvs ?asi)
                )
              (= ?wvr ?asi)
              )
            (and (and (not (= ?wvu ?wvt))
                (not (= ?wvu ?asi))
                )
              (not (= ?wvt ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wvv Real)
    (declare-const ?wvw Real)
    (declare-const ?wvx Real)
    (declare-const ?wvy Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?wvw ?wvv))
                (not (= ?wvw ?fkf))
                )
              (not (= ?wvv ?fkf))
              )
            (or (or (= ?wvy ?wvx)
                (= ?wvy ?fkf)
                )
              (= ?wvx ?fkf)
              )
            )
          (and (or (or (= ?wvw ?wvv)
                (= ?wvw ?fkf)
                )
              (= ?wvv ?fkf)
              )
            (and (and (not (= ?wvy ?wvx))
                (not (= ?wvy ?fkf))
                )
              (not (= ?wvx ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wvz Real)
    (declare-const ?wwa Real)
    (declare-const ?wwb Real)
    (declare-const ?wwc Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?wwa ?wvz))
                (not (= ?wwa ?mzs))
                )
              (not (= ?wvz ?mzs))
              )
            (or (or (= ?wwc ?wwb)
                (= ?wwc ?mzs)
                )
              (= ?wwb ?mzs)
              )
            )
          (and (or (or (= ?wwa ?wvz)
                (= ?wwa ?mzs)
                )
              (= ?wvz ?mzs)
              )
            (and (and (not (= ?wwc ?wwb))
                (not (= ?wwc ?mzs))
                )
              (not (= ?wwb ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?wwd Real)
  (declare-const ?wwe Real)
  (push 1)
    (declare-const ?wwf Real)
    (declare-const ?wwg Real)
    (declare-const ?wwh Real)
    (assert
      (or (or (= ?wwh ?wwg)
          (= ?wwh ?wwf)
          )
        (= ?wwg ?wwf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wwi Real)
    (declare-const ?wwj Real)
    (declare-const ?wwk Real)
    (declare-const ?wwl Real)
    (assert
      (or (or (= ?wwl ?wwk)
          (= ?wwl ?wwj)
          )
        (= ?wwk ?wwj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wwm Real)
    (declare-const ?wwn Real)
    (declare-const ?wwo Real)
    (declare-const ?wwp Real)
    (declare-const ?wwq Real)
    (assert
      (or (or (= ?wwq ?wwp)
          (= ?wwq ?wwo)
          )
        (= ?wwp ?wwo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wwr Real)
    (declare-const ?wws Real)
    (declare-const ?wwt Real)
    (declare-const ?wwu Real)
    (declare-const ?wwv Real)
    (declare-const ?www Real)
    (assert
      (and (and (and (not (= ?wwt ?wws))
            (not (= ?wwt ?wwr))
            )
          (not (= ?wws ?wwr))
          )
        (or (or (= ?www ?wwv)
            (= ?www ?wwu)
            )
          (= ?wwv ?wwu)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wwx Real)
    (declare-const ?wwy Real)
    (declare-const ?wwz Real)
    (assert
      (or (or (= ?wwz ?wwy)
          (= ?wwz ?wwx)
          )
        (= ?wwy ?wwx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wxa Real)
    (declare-const ?wxb Real)
    (declare-const ?wxc Real)
    (assert
      (or (or (= ?wxc ?wxb)
          (= ?wxc ?wxa)
          )
        (= ?wxb ?wxa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wxd Real)
    (declare-const ?wxe Real)
    (declare-const ?wxf Real)
    (declare-const ?wxg Real)
    (assert
      (or (or (= ?wxf ?wxe)
          (= ?wxf ?wxd)
          )
        (= ?wxe ?wxd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wxh Real)
    (declare-const ?wxi Real)
    (declare-const ?wxj Real)
    (declare-const ?wxk Real)
    (declare-const ?wxl Real)
    (assert
      (or (or (= ?wxj ?wxi)
          (= ?wxj ?wxh)
          )
        (= ?wxi ?wxh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wxm Real)
    (declare-const ?wxn Real)
    (declare-const ?wxo Real)
    (declare-const ?wxp Real)
    (declare-const ?wxq Real)
    (declare-const ?wxr Real)
    (assert
      (and (or (or (= ?wxo ?wxn)
            (= ?wxo ?wxm)
            )
          (= ?wxn ?wxm)
          )
        (and (and (not (= ?wxr ?wxq))
            (not (= ?wxr ?wxp))
            )
          (not (= ?wxq ?wxp))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wxs Real)
    (declare-const ?wxt Real)
    (declare-const ?wxu Real)
    (assert
      (or (or (= ?wxu ?wxt)
          (= ?wxu ?wxs)
          )
        (= ?wxt ?wxs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wxv Real)
    (declare-const ?wxw Real)
    (declare-const ?wxx Real)
    (declare-const ?wxy Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?wxw ?wxv))
                (not (= ?wxw ?asi))
                )
              (not (= ?wxv ?asi))
              )
            (or (or (= ?wxy ?wxx)
                (= ?wxy ?asi)
                )
              (= ?wxx ?asi)
              )
            )
          (and (or (or (= ?wxw ?wxv)
                (= ?wxw ?asi)
                )
              (= ?wxv ?asi)
              )
            (and (and (not (= ?wxy ?wxx))
                (not (= ?wxy ?asi))
                )
              (not (= ?wxx ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wxz Real)
    (declare-const ?wya Real)
    (declare-const ?wyb Real)
    (declare-const ?wyc Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?wya ?wxz))
                (not (= ?wya ?fkf))
                )
              (not (= ?wxz ?fkf))
              )
            (or (or (= ?wyc ?wyb)
                (= ?wyc ?fkf)
                )
              (= ?wyb ?fkf)
              )
            )
          (and (or (or (= ?wya ?wxz)
                (= ?wya ?fkf)
                )
              (= ?wxz ?fkf)
              )
            (and (and (not (= ?wyc ?wyb))
                (not (= ?wyc ?fkf))
                )
              (not (= ?wyb ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wyd Real)
    (declare-const ?wye Real)
    (declare-const ?wyf Real)
    (declare-const ?wyg Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?wye ?wyd))
                (not (= ?wye ?mzs))
                )
              (not (= ?wyd ?mzs))
              )
            (or (or (= ?wyg ?wyf)
                (= ?wyg ?mzs)
                )
              (= ?wyf ?mzs)
              )
            )
          (and (or (or (= ?wye ?wyd)
                (= ?wye ?mzs)
                )
              (= ?wyd ?mzs)
              )
            (and (and (not (= ?wyg ?wyf))
                (not (= ?wyg ?mzs))
                )
              (not (= ?wyf ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?wyh Real)
  (push 1)
    (declare-const ?wyi Real)
    (declare-const ?wyj Real)
    (declare-const ?wyk Real)
    (assert
      (or (or (= ?wyk ?wyj)
          (= ?wyk ?wyi)
          )
        (= ?wyj ?wyi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wyl Real)
    (declare-const ?wym Real)
    (declare-const ?wyn Real)
    (declare-const ?wyo Real)
    (assert
      (or (or (= ?wyo ?wyn)
          (= ?wyo ?wym)
          )
        (= ?wyn ?wym)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wyp Real)
    (declare-const ?wyq Real)
    (declare-const ?wyr Real)
    (declare-const ?wys Real)
    (declare-const ?wyt Real)
    (assert
      (or (or (= ?wyt ?wys)
          (= ?wyt ?wyr)
          )
        (= ?wys ?wyr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wyu Real)
    (declare-const ?wyv Real)
    (declare-const ?wyw Real)
    (declare-const ?wyx Real)
    (declare-const ?wyy Real)
    (declare-const ?wyz Real)
    (assert
      (and (and (and (not (= ?wyw ?wyv))
            (not (= ?wyw ?wyu))
            )
          (not (= ?wyv ?wyu))
          )
        (or (or (= ?wyz ?wyy)
            (= ?wyz ?wyx)
            )
          (= ?wyy ?wyx)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wza Real)
    (declare-const ?wzb Real)
    (declare-const ?wzc Real)
    (assert
      (or (or (= ?wzc ?wzb)
          (= ?wzc ?wza)
          )
        (= ?wzb ?wza)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wzd Real)
    (declare-const ?wze Real)
    (declare-const ?wzf Real)
    (assert
      (or (or (= ?wzf ?wze)
          (= ?wzf ?wzd)
          )
        (= ?wze ?wzd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wzg Real)
    (declare-const ?wzh Real)
    (declare-const ?wzi Real)
    (declare-const ?wzj Real)
    (assert
      (or (or (= ?wzi ?wzh)
          (= ?wzi ?wzg)
          )
        (= ?wzh ?wzg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wzk Real)
    (declare-const ?wzl Real)
    (declare-const ?wzm Real)
    (declare-const ?wzn Real)
    (declare-const ?wzo Real)
    (assert
      (or (or (= ?wzm ?wzl)
          (= ?wzm ?wzk)
          )
        (= ?wzl ?wzk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wzp Real)
    (declare-const ?wzq Real)
    (declare-const ?wzr Real)
    (declare-const ?wzs Real)
    (declare-const ?wzt Real)
    (declare-const ?wzu Real)
    (assert
      (and (or (or (= ?wzr ?wzq)
            (= ?wzr ?wzp)
            )
          (= ?wzq ?wzp)
          )
        (and (and (not (= ?wzu ?wzt))
            (not (= ?wzu ?wzs))
            )
          (not (= ?wzt ?wzs))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wzv Real)
    (declare-const ?wzw Real)
    (declare-const ?wzx Real)
    (assert
      (or (or (= ?wzx ?wzw)
          (= ?wzx ?wzv)
          )
        (= ?wzw ?wzv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?wzy Real)
    (declare-const ?wzz Real)
    (declare-const ?xaa Real)
    (declare-const ?xab Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?wzz ?wzy))
                (not (= ?wzz ?asi))
                )
              (not (= ?wzy ?asi))
              )
            (or (or (= ?xab ?xaa)
                (= ?xab ?asi)
                )
              (= ?xaa ?asi)
              )
            )
          (and (or (or (= ?wzz ?wzy)
                (= ?wzz ?asi)
                )
              (= ?wzy ?asi)
              )
            (and (and (not (= ?xab ?xaa))
                (not (= ?xab ?asi))
                )
              (not (= ?xaa ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xac Real)
    (declare-const ?xad Real)
    (declare-const ?xae Real)
    (declare-const ?xaf Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?xad ?xac))
                (not (= ?xad ?fkf))
                )
              (not (= ?xac ?fkf))
              )
            (or (or (= ?xaf ?xae)
                (= ?xaf ?fkf)
                )
              (= ?xae ?fkf)
              )
            )
          (and (or (or (= ?xad ?xac)
                (= ?xad ?fkf)
                )
              (= ?xac ?fkf)
              )
            (and (and (not (= ?xaf ?xae))
                (not (= ?xaf ?fkf))
                )
              (not (= ?xae ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xag Real)
    (declare-const ?xah Real)
    (declare-const ?xai Real)
    (declare-const ?xaj Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?xah ?xag))
                (not (= ?xah ?mzs))
                )
              (not (= ?xag ?mzs))
              )
            (or (or (= ?xaj ?xai)
                (= ?xaj ?mzs)
                )
              (= ?xai ?mzs)
              )
            )
          (and (or (or (= ?xah ?xag)
                (= ?xah ?mzs)
                )
              (= ?xag ?mzs)
              )
            (and (and (not (= ?xaj ?xai))
                (not (= ?xaj ?mzs))
                )
              (not (= ?xai ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?xak Real)
  (declare-const ?xal Real)
  (push 1)
    (declare-const ?xam Real)
    (declare-const ?xan Real)
    (declare-const ?xao Real)
    (assert
      (or (or (= ?xao ?xan)
          (= ?xao ?xam)
          )
        (= ?xan ?xam)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xap Real)
    (declare-const ?xaq Real)
    (declare-const ?xar Real)
    (declare-const ?xas Real)
    (assert
      (or (or (= ?xas ?xar)
          (= ?xas ?xaq)
          )
        (= ?xar ?xaq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xat Real)
    (declare-const ?xau Real)
    (declare-const ?xav Real)
    (declare-const ?xaw Real)
    (declare-const ?xax Real)
    (assert
      (or (or (= ?xax ?xaw)
          (= ?xax ?xav)
          )
        (= ?xaw ?xav)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xay Real)
    (declare-const ?xaz Real)
    (declare-const ?xba Real)
    (declare-const ?xbb Real)
    (declare-const ?xbc Real)
    (declare-const ?xbd Real)
    (assert
      (and (and (and (not (= ?xba ?xaz))
            (not (= ?xba ?xay))
            )
          (not (= ?xaz ?xay))
          )
        (or (or (= ?xbd ?xbc)
            (= ?xbd ?xbb)
            )
          (= ?xbc ?xbb)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xbe Real)
    (declare-const ?xbf Real)
    (declare-const ?xbg Real)
    (assert
      (or (or (= ?xbg ?xbf)
          (= ?xbg ?xbe)
          )
        (= ?xbf ?xbe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xbh Real)
    (declare-const ?xbi Real)
    (declare-const ?xbj Real)
    (assert
      (or (or (= ?xbj ?xbi)
          (= ?xbj ?xbh)
          )
        (= ?xbi ?xbh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xbk Real)
    (declare-const ?xbl Real)
    (declare-const ?xbm Real)
    (declare-const ?xbn Real)
    (assert
      (or (or (= ?xbm ?xbl)
          (= ?xbm ?xbk)
          )
        (= ?xbl ?xbk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xbo Real)
    (declare-const ?xbp Real)
    (declare-const ?xbq Real)
    (declare-const ?xbr Real)
    (declare-const ?xbs Real)
    (assert
      (or (or (= ?xbq ?xbp)
          (= ?xbq ?xbo)
          )
        (= ?xbp ?xbo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xbt Real)
    (declare-const ?xbu Real)
    (declare-const ?xbv Real)
    (declare-const ?xbw Real)
    (declare-const ?xbx Real)
    (declare-const ?xby Real)
    (assert
      (and (or (or (= ?xbv ?xbu)
            (= ?xbv ?xbt)
            )
          (= ?xbu ?xbt)
          )
        (and (and (not (= ?xby ?xbx))
            (not (= ?xby ?xbw))
            )
          (not (= ?xbx ?xbw))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xbz Real)
    (declare-const ?xca Real)
    (declare-const ?xcb Real)
    (assert
      (or (or (= ?xcb ?xca)
          (= ?xcb ?xbz)
          )
        (= ?xca ?xbz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xcc Real)
    (declare-const ?xcd Real)
    (declare-const ?xce Real)
    (declare-const ?xcf Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?xcd ?xcc))
                (not (= ?xcd ?asi))
                )
              (not (= ?xcc ?asi))
              )
            (or (or (= ?xcf ?xce)
                (= ?xcf ?asi)
                )
              (= ?xce ?asi)
              )
            )
          (and (or (or (= ?xcd ?xcc)
                (= ?xcd ?asi)
                )
              (= ?xcc ?asi)
              )
            (and (and (not (= ?xcf ?xce))
                (not (= ?xcf ?asi))
                )
              (not (= ?xce ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xcg Real)
    (declare-const ?xch Real)
    (declare-const ?xci Real)
    (declare-const ?xcj Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?xch ?xcg))
                (not (= ?xch ?fkf))
                )
              (not (= ?xcg ?fkf))
              )
            (or (or (= ?xcj ?xci)
                (= ?xcj ?fkf)
                )
              (= ?xci ?fkf)
              )
            )
          (and (or (or (= ?xch ?xcg)
                (= ?xch ?fkf)
                )
              (= ?xcg ?fkf)
              )
            (and (and (not (= ?xcj ?xci))
                (not (= ?xcj ?fkf))
                )
              (not (= ?xci ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xck Real)
    (declare-const ?xcl Real)
    (declare-const ?xcm Real)
    (declare-const ?xcn Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?xcl ?xck))
                (not (= ?xcl ?mzs))
                )
              (not (= ?xck ?mzs))
              )
            (or (or (= ?xcn ?xcm)
                (= ?xcn ?mzs)
                )
              (= ?xcm ?mzs)
              )
            )
          (and (or (or (= ?xcl ?xck)
                (= ?xcl ?mzs)
                )
              (= ?xck ?mzs)
              )
            (and (and (not (= ?xcn ?xcm))
                (not (= ?xcn ?mzs))
                )
              (not (= ?xcm ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?xco Real)
  (push 1)
    (declare-const ?xcp Real)
    (declare-const ?xcq Real)
    (declare-const ?xcr Real)
    (assert
      (or (or (= ?xcr ?xcq)
          (= ?xcr ?xcp)
          )
        (= ?xcq ?xcp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xcs Real)
    (declare-const ?xct Real)
    (declare-const ?xcu Real)
    (declare-const ?xcv Real)
    (assert
      (or (or (= ?xcv ?xcu)
          (= ?xcv ?xct)
          )
        (= ?xcu ?xct)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xcw Real)
    (declare-const ?xcx Real)
    (declare-const ?xcy Real)
    (declare-const ?xcz Real)
    (declare-const ?xda Real)
    (assert
      (or (or (= ?xda ?xcz)
          (= ?xda ?xcy)
          )
        (= ?xcz ?xcy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xdb Real)
    (declare-const ?xdc Real)
    (declare-const ?xdd Real)
    (declare-const ?xde Real)
    (declare-const ?xdf Real)
    (declare-const ?xdg Real)
    (assert
      (and (and (and (not (= ?xdd ?xdc))
            (not (= ?xdd ?xdb))
            )
          (not (= ?xdc ?xdb))
          )
        (or (or (= ?xdg ?xdf)
            (= ?xdg ?xde)
            )
          (= ?xdf ?xde)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xdh Real)
    (declare-const ?xdi Real)
    (declare-const ?xdj Real)
    (assert
      (or (or (= ?xdj ?xdi)
          (= ?xdj ?xdh)
          )
        (= ?xdi ?xdh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xdk Real)
    (declare-const ?xdl Real)
    (declare-const ?xdm Real)
    (assert
      (or (or (= ?xdm ?xdl)
          (= ?xdm ?xdk)
          )
        (= ?xdl ?xdk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xdn Real)
    (declare-const ?xdo Real)
    (declare-const ?xdp Real)
    (declare-const ?xdq Real)
    (assert
      (or (or (= ?xdp ?xdo)
          (= ?xdp ?xdn)
          )
        (= ?xdo ?xdn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xdr Real)
    (declare-const ?xds Real)
    (declare-const ?xdt Real)
    (declare-const ?xdu Real)
    (declare-const ?xdv Real)
    (assert
      (or (or (= ?xdt ?xds)
          (= ?xdt ?xdr)
          )
        (= ?xds ?xdr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xdw Real)
    (declare-const ?xdx Real)
    (declare-const ?xdy Real)
    (declare-const ?xdz Real)
    (declare-const ?xea Real)
    (declare-const ?xeb Real)
    (assert
      (and (or (or (= ?xdy ?xdx)
            (= ?xdy ?xdw)
            )
          (= ?xdx ?xdw)
          )
        (and (and (not (= ?xeb ?xea))
            (not (= ?xeb ?xdz))
            )
          (not (= ?xea ?xdz))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xec Real)
    (declare-const ?xed Real)
    (declare-const ?xee Real)
    (assert
      (or (or (= ?xee ?xed)
          (= ?xee ?xec)
          )
        (= ?xed ?xec)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xef Real)
    (declare-const ?xeg Real)
    (declare-const ?xeh Real)
    (declare-const ?xei Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?xeg ?xef))
                (not (= ?xeg ?asi))
                )
              (not (= ?xef ?asi))
              )
            (or (or (= ?xei ?xeh)
                (= ?xei ?asi)
                )
              (= ?xeh ?asi)
              )
            )
          (and (or (or (= ?xeg ?xef)
                (= ?xeg ?asi)
                )
              (= ?xef ?asi)
              )
            (and (and (not (= ?xei ?xeh))
                (not (= ?xei ?asi))
                )
              (not (= ?xeh ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xej Real)
    (declare-const ?xek Real)
    (declare-const ?xel Real)
    (declare-const ?xem Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?xek ?xej))
                (not (= ?xek ?fkf))
                )
              (not (= ?xej ?fkf))
              )
            (or (or (= ?xem ?xel)
                (= ?xem ?fkf)
                )
              (= ?xel ?fkf)
              )
            )
          (and (or (or (= ?xek ?xej)
                (= ?xek ?fkf)
                )
              (= ?xej ?fkf)
              )
            (and (and (not (= ?xem ?xel))
                (not (= ?xem ?fkf))
                )
              (not (= ?xel ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xen Real)
    (declare-const ?xeo Real)
    (declare-const ?xep Real)
    (declare-const ?xeq Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?xeo ?xen))
                (not (= ?xeo ?mzs))
                )
              (not (= ?xen ?mzs))
              )
            (or (or (= ?xeq ?xep)
                (= ?xeq ?mzs)
                )
              (= ?xep ?mzs)
              )
            )
          (and (or (or (= ?xeo ?xen)
                (= ?xeo ?mzs)
                )
              (= ?xen ?mzs)
              )
            (and (and (not (= ?xeq ?xep))
                (not (= ?xeq ?mzs))
                )
              (not (= ?xep ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?xer Real)
  (declare-const ?xes Real)
  (assert
    (not (= ?xer ?xes))
    )
  (push 1)
    (declare-const ?xet Real)
    (declare-const ?xeu Real)
    (declare-const ?xev Real)
    (assert
      (or (or (= ?xev ?xeu)
          (= ?xev ?xet)
          )
        (= ?xeu ?xet)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xew Real)
    (declare-const ?xex Real)
    (declare-const ?xey Real)
    (declare-const ?xez Real)
    (assert
      (or (or (= ?xez ?xey)
          (= ?xez ?xex)
          )
        (= ?xey ?xex)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xfa Real)
    (declare-const ?xfb Real)
    (declare-const ?xfc Real)
    (declare-const ?xfd Real)
    (declare-const ?xfe Real)
    (assert
      (or (or (= ?xfe ?xfd)
          (= ?xfe ?xfc)
          )
        (= ?xfd ?xfc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xff Real)
    (declare-const ?xfg Real)
    (declare-const ?xfh Real)
    (declare-const ?xfi Real)
    (declare-const ?xfj Real)
    (declare-const ?xfk Real)
    (assert
      (and (and (and (not (= ?xfh ?xfg))
            (not (= ?xfh ?xff))
            )
          (not (= ?xfg ?xff))
          )
        (or (or (= ?xfk ?xfj)
            (= ?xfk ?xfi)
            )
          (= ?xfj ?xfi)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xfl Real)
    (declare-const ?xfm Real)
    (declare-const ?xfn Real)
    (assert
      (or (or (= ?xfn ?xfm)
          (= ?xfn ?xfl)
          )
        (= ?xfm ?xfl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xfo Real)
    (declare-const ?xfp Real)
    (declare-const ?xfq Real)
    (assert
      (or (or (= ?xfq ?xfp)
          (= ?xfq ?xfo)
          )
        (= ?xfp ?xfo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xfr Real)
    (declare-const ?xfs Real)
    (declare-const ?xft Real)
    (declare-const ?xfu Real)
    (assert
      (or (or (= ?xft ?xfs)
          (= ?xft ?xfr)
          )
        (= ?xfs ?xfr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xfv Real)
    (declare-const ?xfw Real)
    (declare-const ?xfx Real)
    (declare-const ?xfy Real)
    (declare-const ?xfz Real)
    (assert
      (or (or (= ?xfx ?xfw)
          (= ?xfx ?xfv)
          )
        (= ?xfw ?xfv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xga Real)
    (declare-const ?xgb Real)
    (declare-const ?xgc Real)
    (declare-const ?xgd Real)
    (declare-const ?xge Real)
    (declare-const ?xgf Real)
    (assert
      (and (or (or (= ?xgc ?xgb)
            (= ?xgc ?xga)
            )
          (= ?xgb ?xga)
          )
        (and (and (not (= ?xgf ?xge))
            (not (= ?xgf ?xgd))
            )
          (not (= ?xge ?xgd))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xgg Real)
    (declare-const ?xgh Real)
    (declare-const ?xgi Real)
    (assert
      (or (or (= ?xgi ?xgh)
          (= ?xgi ?xgg)
          )
        (= ?xgh ?xgg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xgj Real)
    (declare-const ?xgk Real)
    (declare-const ?xgl Real)
    (declare-const ?xgm Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?xgk ?xgj))
                (not (= ?xgk ?asi))
                )
              (not (= ?xgj ?asi))
              )
            (or (or (= ?xgm ?xgl)
                (= ?xgm ?asi)
                )
              (= ?xgl ?asi)
              )
            )
          (and (or (or (= ?xgk ?xgj)
                (= ?xgk ?asi)
                )
              (= ?xgj ?asi)
              )
            (and (and (not (= ?xgm ?xgl))
                (not (= ?xgm ?asi))
                )
              (not (= ?xgl ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xgn Real)
    (declare-const ?xgo Real)
    (declare-const ?xgp Real)
    (declare-const ?xgq Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?xgo ?xgn))
                (not (= ?xgo ?fkf))
                )
              (not (= ?xgn ?fkf))
              )
            (or (or (= ?xgq ?xgp)
                (= ?xgq ?fkf)
                )
              (= ?xgp ?fkf)
              )
            )
          (and (or (or (= ?xgo ?xgn)
                (= ?xgo ?fkf)
                )
              (= ?xgn ?fkf)
              )
            (and (and (not (= ?xgq ?xgp))
                (not (= ?xgq ?fkf))
                )
              (not (= ?xgp ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xgr Real)
    (declare-const ?xgs Real)
    (declare-const ?xgt Real)
    (declare-const ?xgu Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?xgs ?xgr))
                (not (= ?xgs ?mzs))
                )
              (not (= ?xgr ?mzs))
              )
            (or (or (= ?xgu ?xgt)
                (= ?xgu ?mzs)
                )
              (= ?xgt ?mzs)
              )
            )
          (and (or (or (= ?xgs ?xgr)
                (= ?xgs ?mzs)
                )
              (= ?xgr ?mzs)
              )
            (and (and (not (= ?xgu ?xgt))
                (not (= ?xgu ?mzs))
                )
              (not (= ?xgt ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?xgv Real)
  (declare-const ?xgw Real)
  (declare-const ?xgx Real)
  (push 1)
    (declare-const ?xgy Real)
    (declare-const ?xgz Real)
    (declare-const ?xha Real)
    (assert
      (or (or (= ?xha ?xgz)
          (= ?xha ?xgy)
          )
        (= ?xgz ?xgy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xhb Real)
    (declare-const ?xhc Real)
    (declare-const ?xhd Real)
    (declare-const ?xhe Real)
    (assert
      (or (or (= ?xhe ?xhd)
          (= ?xhe ?xhc)
          )
        (= ?xhd ?xhc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xhf Real)
    (declare-const ?xhg Real)
    (declare-const ?xhh Real)
    (declare-const ?xhi Real)
    (declare-const ?xhj Real)
    (assert
      (or (or (= ?xhj ?xhi)
          (= ?xhj ?xhh)
          )
        (= ?xhi ?xhh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xhk Real)
    (declare-const ?xhl Real)
    (declare-const ?xhm Real)
    (declare-const ?xhn Real)
    (declare-const ?xho Real)
    (declare-const ?xhp Real)
    (assert
      (and (and (and (not (= ?xhm ?xhl))
            (not (= ?xhm ?xhk))
            )
          (not (= ?xhl ?xhk))
          )
        (or (or (= ?xhp ?xho)
            (= ?xhp ?xhn)
            )
          (= ?xho ?xhn)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xhq Real)
    (declare-const ?xhr Real)
    (declare-const ?xhs Real)
    (assert
      (or (or (= ?xhs ?xhr)
          (= ?xhs ?xhq)
          )
        (= ?xhr ?xhq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xht Real)
    (declare-const ?xhu Real)
    (declare-const ?xhv Real)
    (assert
      (or (or (= ?xhv ?xhu)
          (= ?xhv ?xht)
          )
        (= ?xhu ?xht)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xhw Real)
    (declare-const ?xhx Real)
    (declare-const ?xhy Real)
    (declare-const ?xhz Real)
    (assert
      (or (or (= ?xhy ?xhx)
          (= ?xhy ?xhw)
          )
        (= ?xhx ?xhw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xia Real)
    (declare-const ?xib Real)
    (declare-const ?xic Real)
    (declare-const ?xid Real)
    (declare-const ?xie Real)
    (assert
      (or (or (= ?xic ?xib)
          (= ?xic ?xia)
          )
        (= ?xib ?xia)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xif Real)
    (declare-const ?xig Real)
    (declare-const ?xih Real)
    (declare-const ?xii Real)
    (declare-const ?xij Real)
    (declare-const ?xik Real)
    (assert
      (and (or (or (= ?xih ?xig)
            (= ?xih ?xif)
            )
          (= ?xig ?xif)
          )
        (and (and (not (= ?xik ?xij))
            (not (= ?xik ?xii))
            )
          (not (= ?xij ?xii))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xil Real)
    (declare-const ?xim Real)
    (declare-const ?xin Real)
    (assert
      (or (or (= ?xin ?xim)
          (= ?xin ?xil)
          )
        (= ?xim ?xil)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xio Real)
    (declare-const ?xip Real)
    (declare-const ?xiq Real)
    (declare-const ?xir Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?xip ?xio))
                (not (= ?xip ?asi))
                )
              (not (= ?xio ?asi))
              )
            (or (or (= ?xir ?xiq)
                (= ?xir ?asi)
                )
              (= ?xiq ?asi)
              )
            )
          (and (or (or (= ?xip ?xio)
                (= ?xip ?asi)
                )
              (= ?xio ?asi)
              )
            (and (and (not (= ?xir ?xiq))
                (not (= ?xir ?asi))
                )
              (not (= ?xiq ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xis Real)
    (declare-const ?xit Real)
    (declare-const ?xiu Real)
    (declare-const ?xiv Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?xit ?xis))
                (not (= ?xit ?fkf))
                )
              (not (= ?xis ?fkf))
              )
            (or (or (= ?xiv ?xiu)
                (= ?xiv ?fkf)
                )
              (= ?xiu ?fkf)
              )
            )
          (and (or (or (= ?xit ?xis)
                (= ?xit ?fkf)
                )
              (= ?xis ?fkf)
              )
            (and (and (not (= ?xiv ?xiu))
                (not (= ?xiv ?fkf))
                )
              (not (= ?xiu ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xiw Real)
    (declare-const ?xix Real)
    (declare-const ?xiy Real)
    (declare-const ?xiz Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?xix ?xiw))
                (not (= ?xix ?mzs))
                )
              (not (= ?xiw ?mzs))
              )
            (or (or (= ?xiz ?xiy)
                (= ?xiz ?mzs)
                )
              (= ?xiy ?mzs)
              )
            )
          (and (or (or (= ?xix ?xiw)
                (= ?xix ?mzs)
                )
              (= ?xiw ?mzs)
              )
            (and (and (not (= ?xiz ?xiy))
                (not (= ?xiz ?mzs))
                )
              (not (= ?xiy ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?xja Real)
  (declare-const ?xjb Real)
  (declare-const ?xjc Real)
  (declare-const ?xjd Real)
  (push 1)
    (declare-const ?xje Real)
    (declare-const ?xjf Real)
    (declare-const ?xjg Real)
    (assert
      (or (or (= ?xjg ?xjf)
          (= ?xjg ?xje)
          )
        (= ?xjf ?xje)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xjh Real)
    (declare-const ?xji Real)
    (declare-const ?xjj Real)
    (declare-const ?xjk Real)
    (assert
      (or (or (= ?xjk ?xjj)
          (= ?xjk ?xji)
          )
        (= ?xjj ?xji)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xjl Real)
    (declare-const ?xjm Real)
    (declare-const ?xjn Real)
    (declare-const ?xjo Real)
    (declare-const ?xjp Real)
    (assert
      (or (or (= ?xjp ?xjo)
          (= ?xjp ?xjn)
          )
        (= ?xjo ?xjn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xjq Real)
    (declare-const ?xjr Real)
    (declare-const ?xjs Real)
    (declare-const ?xjt Real)
    (declare-const ?xju Real)
    (declare-const ?xjv Real)
    (assert
      (and (and (and (not (= ?xjs ?xjr))
            (not (= ?xjs ?xjq))
            )
          (not (= ?xjr ?xjq))
          )
        (or (or (= ?xjv ?xju)
            (= ?xjv ?xjt)
            )
          (= ?xju ?xjt)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xjw Real)
    (declare-const ?xjx Real)
    (declare-const ?xjy Real)
    (assert
      (or (or (= ?xjy ?xjx)
          (= ?xjy ?xjw)
          )
        (= ?xjx ?xjw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xjz Real)
    (declare-const ?xka Real)
    (declare-const ?xkb Real)
    (assert
      (or (or (= ?xkb ?xka)
          (= ?xkb ?xjz)
          )
        (= ?xka ?xjz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xkc Real)
    (declare-const ?xkd Real)
    (declare-const ?xke Real)
    (declare-const ?xkf Real)
    (assert
      (or (or (= ?xke ?xkd)
          (= ?xke ?xkc)
          )
        (= ?xkd ?xkc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xkg Real)
    (declare-const ?xkh Real)
    (declare-const ?xki Real)
    (declare-const ?xkj Real)
    (declare-const ?xkk Real)
    (assert
      (or (or (= ?xki ?xkh)
          (= ?xki ?xkg)
          )
        (= ?xkh ?xkg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xkl Real)
    (declare-const ?xkm Real)
    (declare-const ?xkn Real)
    (declare-const ?xko Real)
    (declare-const ?xkp Real)
    (declare-const ?xkq Real)
    (assert
      (and (or (or (= ?xkn ?xkm)
            (= ?xkn ?xkl)
            )
          (= ?xkm ?xkl)
          )
        (and (and (not (= ?xkq ?xkp))
            (not (= ?xkq ?xko))
            )
          (not (= ?xkp ?xko))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xkr Real)
    (declare-const ?xks Real)
    (declare-const ?xkt Real)
    (assert
      (or (or (= ?xkt ?xks)
          (= ?xkt ?xkr)
          )
        (= ?xks ?xkr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xku Real)
    (declare-const ?xkv Real)
    (declare-const ?xkw Real)
    (declare-const ?xkx Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?xkv ?xku))
                (not (= ?xkv ?asi))
                )
              (not (= ?xku ?asi))
              )
            (or (or (= ?xkx ?xkw)
                (= ?xkx ?asi)
                )
              (= ?xkw ?asi)
              )
            )
          (and (or (or (= ?xkv ?xku)
                (= ?xkv ?asi)
                )
              (= ?xku ?asi)
              )
            (and (and (not (= ?xkx ?xkw))
                (not (= ?xkx ?asi))
                )
              (not (= ?xkw ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xky Real)
    (declare-const ?xkz Real)
    (declare-const ?xla Real)
    (declare-const ?xlb Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?xkz ?xky))
                (not (= ?xkz ?fkf))
                )
              (not (= ?xky ?fkf))
              )
            (or (or (= ?xlb ?xla)
                (= ?xlb ?fkf)
                )
              (= ?xla ?fkf)
              )
            )
          (and (or (or (= ?xkz ?xky)
                (= ?xkz ?fkf)
                )
              (= ?xky ?fkf)
              )
            (and (and (not (= ?xlb ?xla))
                (not (= ?xlb ?fkf))
                )
              (not (= ?xla ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xlc Real)
    (declare-const ?xld Real)
    (declare-const ?xle Real)
    (declare-const ?xlf Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?xld ?xlc))
                (not (= ?xld ?mzs))
                )
              (not (= ?xlc ?mzs))
              )
            (or (or (= ?xlf ?xle)
                (= ?xlf ?mzs)
                )
              (= ?xle ?mzs)
              )
            )
          (and (or (or (= ?xld ?xlc)
                (= ?xld ?mzs)
                )
              (= ?xlc ?mzs)
              )
            (and (and (not (= ?xlf ?xle))
                (not (= ?xlf ?mzs))
                )
              (not (= ?xle ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?xlg Real)
  (push 1)
    (declare-const ?xlh Real)
    (declare-const ?xli Real)
    (declare-const ?xlj Real)
    (assert
      (or (or (= ?xlj ?xli)
          (= ?xlj ?xlh)
          )
        (= ?xli ?xlh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xlk Real)
    (declare-const ?xll Real)
    (declare-const ?xlm Real)
    (declare-const ?xln Real)
    (assert
      (or (or (= ?xln ?xlm)
          (= ?xln ?xll)
          )
        (= ?xlm ?xll)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xlo Real)
    (declare-const ?xlp Real)
    (declare-const ?xlq Real)
    (declare-const ?xlr Real)
    (declare-const ?xls Real)
    (assert
      (or (or (= ?xls ?xlr)
          (= ?xls ?xlq)
          )
        (= ?xlr ?xlq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xlt Real)
    (declare-const ?xlu Real)
    (declare-const ?xlv Real)
    (declare-const ?xlw Real)
    (declare-const ?xlx Real)
    (declare-const ?xly Real)
    (assert
      (and (and (and (not (= ?xlv ?xlu))
            (not (= ?xlv ?xlt))
            )
          (not (= ?xlu ?xlt))
          )
        (or (or (= ?xly ?xlx)
            (= ?xly ?xlw)
            )
          (= ?xlx ?xlw)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xlz Real)
    (declare-const ?xma Real)
    (declare-const ?xmb Real)
    (assert
      (or (or (= ?xmb ?xma)
          (= ?xmb ?xlz)
          )
        (= ?xma ?xlz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xmc Real)
    (declare-const ?xmd Real)
    (declare-const ?xme Real)
    (assert
      (or (or (= ?xme ?xmd)
          (= ?xme ?xmc)
          )
        (= ?xmd ?xmc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xmf Real)
    (declare-const ?xmg Real)
    (declare-const ?xmh Real)
    (declare-const ?xmi Real)
    (assert
      (or (or (= ?xmh ?xmg)
          (= ?xmh ?xmf)
          )
        (= ?xmg ?xmf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xmj Real)
    (declare-const ?xmk Real)
    (declare-const ?xml Real)
    (declare-const ?xmm Real)
    (declare-const ?xmn Real)
    (assert
      (or (or (= ?xml ?xmk)
          (= ?xml ?xmj)
          )
        (= ?xmk ?xmj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xmo Real)
    (declare-const ?xmp Real)
    (declare-const ?xmq Real)
    (declare-const ?xmr Real)
    (declare-const ?xms Real)
    (declare-const ?xmt Real)
    (assert
      (and (or (or (= ?xmq ?xmp)
            (= ?xmq ?xmo)
            )
          (= ?xmp ?xmo)
          )
        (and (and (not (= ?xmt ?xms))
            (not (= ?xmt ?xmr))
            )
          (not (= ?xms ?xmr))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xmu Real)
    (declare-const ?xmv Real)
    (declare-const ?xmw Real)
    (assert
      (or (or (= ?xmw ?xmv)
          (= ?xmw ?xmu)
          )
        (= ?xmv ?xmu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xmx Real)
    (declare-const ?xmy Real)
    (declare-const ?xmz Real)
    (declare-const ?xna Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?xmy ?xmx))
                (not (= ?xmy ?asi))
                )
              (not (= ?xmx ?asi))
              )
            (or (or (= ?xna ?xmz)
                (= ?xna ?asi)
                )
              (= ?xmz ?asi)
              )
            )
          (and (or (or (= ?xmy ?xmx)
                (= ?xmy ?asi)
                )
              (= ?xmx ?asi)
              )
            (and (and (not (= ?xna ?xmz))
                (not (= ?xna ?asi))
                )
              (not (= ?xmz ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xnb Real)
    (declare-const ?xnc Real)
    (declare-const ?xnd Real)
    (declare-const ?xne Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?xnc ?xnb))
                (not (= ?xnc ?fkf))
                )
              (not (= ?xnb ?fkf))
              )
            (or (or (= ?xne ?xnd)
                (= ?xne ?fkf)
                )
              (= ?xnd ?fkf)
              )
            )
          (and (or (or (= ?xnc ?xnb)
                (= ?xnc ?fkf)
                )
              (= ?xnb ?fkf)
              )
            (and (and (not (= ?xne ?xnd))
                (not (= ?xne ?fkf))
                )
              (not (= ?xnd ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xnf Real)
    (declare-const ?xng Real)
    (declare-const ?xnh Real)
    (declare-const ?xni Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?xng ?xnf))
                (not (= ?xng ?mzs))
                )
              (not (= ?xnf ?mzs))
              )
            (or (or (= ?xni ?xnh)
                (= ?xni ?mzs)
                )
              (= ?xnh ?mzs)
              )
            )
          (and (or (or (= ?xng ?xnf)
                (= ?xng ?mzs)
                )
              (= ?xnf ?mzs)
              )
            (and (and (not (= ?xni ?xnh))
                (not (= ?xni ?mzs))
                )
              (not (= ?xnh ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?xnj Real)
  (declare-const ?xnk Real)
  (push 1)
    (declare-const ?xnl Real)
    (declare-const ?xnm Real)
    (declare-const ?xnn Real)
    (assert
      (or (or (= ?xnn ?xnm)
          (= ?xnn ?xnl)
          )
        (= ?xnm ?xnl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xno Real)
    (declare-const ?xnp Real)
    (declare-const ?xnq Real)
    (declare-const ?xnr Real)
    (assert
      (or (or (= ?xnr ?xnq)
          (= ?xnr ?xnp)
          )
        (= ?xnq ?xnp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xns Real)
    (declare-const ?xnt Real)
    (declare-const ?xnu Real)
    (declare-const ?xnv Real)
    (declare-const ?xnw Real)
    (assert
      (or (or (= ?xnw ?xnv)
          (= ?xnw ?xnu)
          )
        (= ?xnv ?xnu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xnx Real)
    (declare-const ?xny Real)
    (declare-const ?xnz Real)
    (declare-const ?xoa Real)
    (declare-const ?xob Real)
    (declare-const ?xoc Real)
    (assert
      (and (and (and (not (= ?xnz ?xny))
            (not (= ?xnz ?xnx))
            )
          (not (= ?xny ?xnx))
          )
        (or (or (= ?xoc ?xob)
            (= ?xoc ?xoa)
            )
          (= ?xob ?xoa)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xod Real)
    (declare-const ?xoe Real)
    (declare-const ?xof Real)
    (assert
      (or (or (= ?xof ?xoe)
          (= ?xof ?xod)
          )
        (= ?xoe ?xod)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xog Real)
    (declare-const ?xoh Real)
    (declare-const ?xoi Real)
    (assert
      (or (or (= ?xoi ?xoh)
          (= ?xoi ?xog)
          )
        (= ?xoh ?xog)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xoj Real)
    (declare-const ?xok Real)
    (declare-const ?xol Real)
    (declare-const ?xom Real)
    (assert
      (or (or (= ?xol ?xok)
          (= ?xol ?xoj)
          )
        (= ?xok ?xoj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xon Real)
    (declare-const ?xoo Real)
    (declare-const ?xop Real)
    (declare-const ?xoq Real)
    (declare-const ?xor Real)
    (assert
      (or (or (= ?xop ?xoo)
          (= ?xop ?xon)
          )
        (= ?xoo ?xon)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xos Real)
    (declare-const ?xot Real)
    (declare-const ?xou Real)
    (declare-const ?xov Real)
    (declare-const ?xow Real)
    (declare-const ?xox Real)
    (assert
      (and (or (or (= ?xou ?xot)
            (= ?xou ?xos)
            )
          (= ?xot ?xos)
          )
        (and (and (not (= ?xox ?xow))
            (not (= ?xox ?xov))
            )
          (not (= ?xow ?xov))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xoy Real)
    (declare-const ?xoz Real)
    (declare-const ?xpa Real)
    (assert
      (or (or (= ?xpa ?xoz)
          (= ?xpa ?xoy)
          )
        (= ?xoz ?xoy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xpb Real)
    (declare-const ?xpc Real)
    (declare-const ?xpd Real)
    (declare-const ?xpe Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?xpc ?xpb))
                (not (= ?xpc ?asi))
                )
              (not (= ?xpb ?asi))
              )
            (or (or (= ?xpe ?xpd)
                (= ?xpe ?asi)
                )
              (= ?xpd ?asi)
              )
            )
          (and (or (or (= ?xpc ?xpb)
                (= ?xpc ?asi)
                )
              (= ?xpb ?asi)
              )
            (and (and (not (= ?xpe ?xpd))
                (not (= ?xpe ?asi))
                )
              (not (= ?xpd ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xpf Real)
    (declare-const ?xpg Real)
    (declare-const ?xph Real)
    (declare-const ?xpi Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?xpg ?xpf))
                (not (= ?xpg ?fkf))
                )
              (not (= ?xpf ?fkf))
              )
            (or (or (= ?xpi ?xph)
                (= ?xpi ?fkf)
                )
              (= ?xph ?fkf)
              )
            )
          (and (or (or (= ?xpg ?xpf)
                (= ?xpg ?fkf)
                )
              (= ?xpf ?fkf)
              )
            (and (and (not (= ?xpi ?xph))
                (not (= ?xpi ?fkf))
                )
              (not (= ?xph ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xpj Real)
    (declare-const ?xpk Real)
    (declare-const ?xpl Real)
    (declare-const ?xpm Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?xpk ?xpj))
                (not (= ?xpk ?mzs))
                )
              (not (= ?xpj ?mzs))
              )
            (or (or (= ?xpm ?xpl)
                (= ?xpm ?mzs)
                )
              (= ?xpl ?mzs)
              )
            )
          (and (or (or (= ?xpk ?xpj)
                (= ?xpk ?mzs)
                )
              (= ?xpj ?mzs)
              )
            (and (and (not (= ?xpm ?xpl))
                (not (= ?xpm ?mzs))
                )
              (not (= ?xpl ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?xpn Real)
  (declare-const ?xpo Real)
  (declare-const ?xpp Real)
  (push 1)
    (declare-const ?xpq Real)
    (declare-const ?xpr Real)
    (declare-const ?xps Real)
    (assert
      (or (or (= ?xps ?xpr)
          (= ?xps ?xpq)
          )
        (= ?xpr ?xpq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xpt Real)
    (declare-const ?xpu Real)
    (declare-const ?xpv Real)
    (declare-const ?xpw Real)
    (assert
      (or (or (= ?xpw ?xpv)
          (= ?xpw ?xpu)
          )
        (= ?xpv ?xpu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xpx Real)
    (declare-const ?xpy Real)
    (declare-const ?xpz Real)
    (declare-const ?xqa Real)
    (declare-const ?xqb Real)
    (assert
      (or (or (= ?xqb ?xqa)
          (= ?xqb ?xpz)
          )
        (= ?xqa ?xpz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xqc Real)
    (declare-const ?xqd Real)
    (declare-const ?xqe Real)
    (declare-const ?xqf Real)
    (declare-const ?xqg Real)
    (declare-const ?xqh Real)
    (assert
      (and (and (and (not (= ?xqe ?xqd))
            (not (= ?xqe ?xqc))
            )
          (not (= ?xqd ?xqc))
          )
        (or (or (= ?xqh ?xqg)
            (= ?xqh ?xqf)
            )
          (= ?xqg ?xqf)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xqi Real)
    (declare-const ?xqj Real)
    (declare-const ?xqk Real)
    (assert
      (or (or (= ?xqk ?xqj)
          (= ?xqk ?xqi)
          )
        (= ?xqj ?xqi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xql Real)
    (declare-const ?xqm Real)
    (declare-const ?xqn Real)
    (assert
      (or (or (= ?xqn ?xqm)
          (= ?xqn ?xql)
          )
        (= ?xqm ?xql)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xqo Real)
    (declare-const ?xqp Real)
    (declare-const ?xqq Real)
    (declare-const ?xqr Real)
    (assert
      (or (or (= ?xqq ?xqp)
          (= ?xqq ?xqo)
          )
        (= ?xqp ?xqo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xqs Real)
    (declare-const ?xqt Real)
    (declare-const ?xqu Real)
    (declare-const ?xqv Real)
    (declare-const ?xqw Real)
    (assert
      (or (or (= ?xqu ?xqt)
          (= ?xqu ?xqs)
          )
        (= ?xqt ?xqs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xqx Real)
    (declare-const ?xqy Real)
    (declare-const ?xqz Real)
    (declare-const ?xra Real)
    (declare-const ?xrb Real)
    (declare-const ?xrc Real)
    (assert
      (and (or (or (= ?xqz ?xqy)
            (= ?xqz ?xqx)
            )
          (= ?xqy ?xqx)
          )
        (and (and (not (= ?xrc ?xrb))
            (not (= ?xrc ?xra))
            )
          (not (= ?xrb ?xra))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xrd Real)
    (declare-const ?xre Real)
    (declare-const ?xrf Real)
    (assert
      (or (or (= ?xrf ?xre)
          (= ?xrf ?xrd)
          )
        (= ?xre ?xrd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xrg Real)
    (declare-const ?xrh Real)
    (declare-const ?xri Real)
    (declare-const ?xrj Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?xrh ?xrg))
                (not (= ?xrh ?asi))
                )
              (not (= ?xrg ?asi))
              )
            (or (or (= ?xrj ?xri)
                (= ?xrj ?asi)
                )
              (= ?xri ?asi)
              )
            )
          (and (or (or (= ?xrh ?xrg)
                (= ?xrh ?asi)
                )
              (= ?xrg ?asi)
              )
            (and (and (not (= ?xrj ?xri))
                (not (= ?xrj ?asi))
                )
              (not (= ?xri ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xrk Real)
    (declare-const ?xrl Real)
    (declare-const ?xrm Real)
    (declare-const ?xrn Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?xrl ?xrk))
                (not (= ?xrl ?fkf))
                )
              (not (= ?xrk ?fkf))
              )
            (or (or (= ?xrn ?xrm)
                (= ?xrn ?fkf)
                )
              (= ?xrm ?fkf)
              )
            )
          (and (or (or (= ?xrl ?xrk)
                (= ?xrl ?fkf)
                )
              (= ?xrk ?fkf)
              )
            (and (and (not (= ?xrn ?xrm))
                (not (= ?xrn ?fkf))
                )
              (not (= ?xrm ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xro Real)
    (declare-const ?xrp Real)
    (declare-const ?xrq Real)
    (declare-const ?xrr Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?xrp ?xro))
                (not (= ?xrp ?mzs))
                )
              (not (= ?xro ?mzs))
              )
            (or (or (= ?xrr ?xrq)
                (= ?xrr ?mzs)
                )
              (= ?xrq ?mzs)
              )
            )
          (and (or (or (= ?xrp ?xro)
                (= ?xrp ?mzs)
                )
              (= ?xro ?mzs)
              )
            (and (and (not (= ?xrr ?xrq))
                (not (= ?xrr ?mzs))
                )
              (not (= ?xrq ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?xrs Real)
  (declare-const ?xrt Real)
  (declare-const ?xru Real)
  (declare-const ?xrv Real)
  (assert
    (exists ((?fkf Real) )(or (and (and (and (not (= ?xrt ?xrs))
              (not (= ?xrt ?fkf))
              )
            (not (= ?xrs ?fkf))
            )
          (or (or (= ?xrv ?xru)
              (= ?xrv ?fkf)
              )
            (= ?xru ?fkf)
            )
          )
        (and (or (or (= ?xrt ?xrs)
              (= ?xrt ?fkf)
              )
            (= ?xrs ?fkf)
            )
          (and (and (not (= ?xrv ?xru))
              (not (= ?xrv ?fkf))
              )
            (not (= ?xru ?fkf))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?xrw Real)
    (declare-const ?xrx Real)
    (declare-const ?xry Real)
    (assert
      (or (or (= ?xry ?xrx)
          (= ?xry ?xrw)
          )
        (= ?xrx ?xrw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xrz Real)
    (declare-const ?xsa Real)
    (declare-const ?xsb Real)
    (declare-const ?xsc Real)
    (assert
      (or (or (= ?xsc ?xsb)
          (= ?xsc ?xsa)
          )
        (= ?xsb ?xsa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xsd Real)
    (declare-const ?xse Real)
    (declare-const ?xsf Real)
    (declare-const ?xsg Real)
    (declare-const ?xsh Real)
    (assert
      (or (or (= ?xsh ?xsg)
          (= ?xsh ?xsf)
          )
        (= ?xsg ?xsf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xsi Real)
    (declare-const ?xsj Real)
    (declare-const ?xsk Real)
    (declare-const ?xsl Real)
    (declare-const ?xsm Real)
    (declare-const ?xsn Real)
    (assert
      (and (and (and (not (= ?xsk ?xsj))
            (not (= ?xsk ?xsi))
            )
          (not (= ?xsj ?xsi))
          )
        (or (or (= ?xsn ?xsm)
            (= ?xsn ?xsl)
            )
          (= ?xsm ?xsl)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xso Real)
    (declare-const ?xsp Real)
    (declare-const ?xsq Real)
    (assert
      (or (or (= ?xsq ?xsp)
          (= ?xsq ?xso)
          )
        (= ?xsp ?xso)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xsr Real)
    (declare-const ?xss Real)
    (declare-const ?xst Real)
    (assert
      (or (or (= ?xst ?xss)
          (= ?xst ?xsr)
          )
        (= ?xss ?xsr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xsu Real)
    (declare-const ?xsv Real)
    (declare-const ?xsw Real)
    (declare-const ?xsx Real)
    (assert
      (or (or (= ?xsw ?xsv)
          (= ?xsw ?xsu)
          )
        (= ?xsv ?xsu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xsy Real)
    (declare-const ?xsz Real)
    (declare-const ?xta Real)
    (declare-const ?xtb Real)
    (declare-const ?xtc Real)
    (assert
      (or (or (= ?xta ?xsz)
          (= ?xta ?xsy)
          )
        (= ?xsz ?xsy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xtd Real)
    (declare-const ?xte Real)
    (declare-const ?xtf Real)
    (declare-const ?xtg Real)
    (declare-const ?xth Real)
    (declare-const ?xti Real)
    (assert
      (and (or (or (= ?xtf ?xte)
            (= ?xtf ?xtd)
            )
          (= ?xte ?xtd)
          )
        (and (and (not (= ?xti ?xth))
            (not (= ?xti ?xtg))
            )
          (not (= ?xth ?xtg))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xtj Real)
    (declare-const ?xtk Real)
    (declare-const ?xtl Real)
    (assert
      (or (or (= ?xtl ?xtk)
          (= ?xtl ?xtj)
          )
        (= ?xtk ?xtj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xtm Real)
    (declare-const ?xtn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xto Real)
    (declare-const ?xtp Real)
    (declare-const ?xtq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xtr Real)
    (declare-const ?xts Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xtt Real)
    (declare-const ?xtu Real)
    (declare-const ?xtv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xtw Real)
    (declare-const ?xtx Real)
    (declare-const ?xty Real)
    (declare-const ?xtz Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?xtx ?xtw))
                (not (= ?xtx ?asi))
                )
              (not (= ?xtw ?asi))
              )
            (or (or (= ?xtz ?xty)
                (= ?xtz ?asi)
                )
              (= ?xty ?asi)
              )
            )
          (and (or (or (= ?xtx ?xtw)
                (= ?xtx ?asi)
                )
              (= ?xtw ?asi)
              )
            (and (and (not (= ?xtz ?xty))
                (not (= ?xtz ?asi))
                )
              (not (= ?xty ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xua Real)
    (declare-const ?xub Real)
    (declare-const ?xuc Real)
    (declare-const ?xud Real)
    (declare-const ?xue Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xuf Real)
    (declare-const ?xug Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xuh Real)
    (declare-const ?xui Real)
    (declare-const ?xuj Real)
    (declare-const ?xuk Real)
    (declare-const ?xul Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xum Real)
    (declare-const ?xun Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xuo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xup Real)
    (declare-const ?xuq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xur Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xus Real)
    (declare-const ?xut Real)
    (assert
      (not (= ?xus ?xut))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xuu Real)
    (declare-const ?xuv Real)
    (declare-const ?xuw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xux Real)
    (declare-const ?xuy Real)
    (declare-const ?xuz Real)
    (declare-const ?xva Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xvb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xvc Real)
    (declare-const ?xvd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xve Real)
    (declare-const ?xvf Real)
    (declare-const ?xvg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xvh Real)
    (declare-const ?xvi Real)
    (declare-const ?xvj Real)
    (declare-const ?xvk Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?xvi ?xvh))
                (not (= ?xvi ?fkf))
                )
              (not (= ?xvh ?fkf))
              )
            (or (or (= ?xvk ?xvj)
                (= ?xvk ?fkf)
                )
              (= ?xvj ?fkf)
              )
            )
          (and (or (or (= ?xvi ?xvh)
                (= ?xvi ?fkf)
                )
              (= ?xvh ?fkf)
              )
            (and (and (not (= ?xvk ?xvj))
                (not (= ?xvk ?fkf))
                )
              (not (= ?xvj ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xvl Real)
    (declare-const ?xvm Real)
    (declare-const ?xvn Real)
    (declare-const ?xvo Real)
    (declare-const ?xvp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xvq Real)
    (declare-const ?xvr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xvs Real)
    (declare-const ?xvt Real)
    (declare-const ?xvu Real)
    (declare-const ?xvv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xvw Real)
    (declare-const ?xvx Real)
    (declare-const ?xvy Real)
    (declare-const ?xvz Real)
    (declare-const ?xwa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xwb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xwc Real)
    (declare-const ?xwd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xwe Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xwf Real)
    (declare-const ?xwg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xwh Real)
    (declare-const ?xwi Real)
    (declare-const ?xwj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xwk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xwl Real)
    (declare-const ?xwm Real)
    (assert
      (not (= ?xwl ?xwm))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xwn Real)
    (declare-const ?xwo Real)
    (declare-const ?xwp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xwq Real)
    (declare-const ?xwr Real)
    (declare-const ?xws Real)
    (declare-const ?xwt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xwu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xwv Real)
    (declare-const ?xww Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xwx Real)
    (declare-const ?xwy Real)
    (declare-const ?xwz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xxa Real)
    (declare-const ?xxb Real)
    (declare-const ?xxc Real)
    (declare-const ?xxd Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?xxb ?xxa))
                (not (= ?xxb ?mzs))
                )
              (not (= ?xxa ?mzs))
              )
            (or (or (= ?xxd ?xxc)
                (= ?xxd ?mzs)
                )
              (= ?xxc ?mzs)
              )
            )
          (and (or (or (= ?xxb ?xxa)
                (= ?xxb ?mzs)
                )
              (= ?xxa ?mzs)
              )
            (and (and (not (= ?xxd ?xxc))
                (not (= ?xxd ?mzs))
                )
              (not (= ?xxc ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xxe Real)
    (declare-const ?xxf Real)
    (declare-const ?xxg Real)
    (declare-const ?xxh Real)
    (declare-const ?xxi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xxj Real)
    (declare-const ?xxk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xxl Real)
    (declare-const ?xxm Real)
    (declare-const ?xxn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xxo Real)
    (declare-const ?xxp Real)
    (declare-const ?xxq Real)
    (declare-const ?xxr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xxs Real)
    (declare-const ?xxt Real)
    (declare-const ?xxu Real)
    (declare-const ?xxv Real)
    (declare-const ?xxw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xxx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xxy Real)
    (declare-const ?xxz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?xya Real)
  (declare-const ?xyb Real)
  (declare-const ?xyc Real)
  (declare-const ?xyd Real)
  (declare-const ?xye Real)
  (push 1)
    (declare-const ?xyf Real)
    (declare-const ?xyg Real)
    (declare-const ?xyh Real)
    (assert
      (or (or (= ?xyh ?xyg)
          (= ?xyh ?xyf)
          )
        (= ?xyg ?xyf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xyi Real)
    (declare-const ?xyj Real)
    (declare-const ?xyk Real)
    (declare-const ?xyl Real)
    (assert
      (or (or (= ?xyl ?xyk)
          (= ?xyl ?xyj)
          )
        (= ?xyk ?xyj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xym Real)
    (declare-const ?xyn Real)
    (declare-const ?xyo Real)
    (declare-const ?xyp Real)
    (declare-const ?xyq Real)
    (assert
      (or (or (= ?xyq ?xyp)
          (= ?xyq ?xyo)
          )
        (= ?xyp ?xyo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xyr Real)
    (declare-const ?xys Real)
    (declare-const ?xyt Real)
    (declare-const ?xyu Real)
    (declare-const ?xyv Real)
    (declare-const ?xyw Real)
    (assert
      (and (and (and (not (= ?xyt ?xys))
            (not (= ?xyt ?xyr))
            )
          (not (= ?xys ?xyr))
          )
        (or (or (= ?xyw ?xyv)
            (= ?xyw ?xyu)
            )
          (= ?xyv ?xyu)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xyx Real)
    (declare-const ?xyy Real)
    (declare-const ?xyz Real)
    (assert
      (or (or (= ?xyz ?xyy)
          (= ?xyz ?xyx)
          )
        (= ?xyy ?xyx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xza Real)
    (declare-const ?xzb Real)
    (declare-const ?xzc Real)
    (assert
      (or (or (= ?xzc ?xzb)
          (= ?xzc ?xza)
          )
        (= ?xzb ?xza)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xzd Real)
    (declare-const ?xze Real)
    (declare-const ?xzf Real)
    (declare-const ?xzg Real)
    (assert
      (or (or (= ?xzf ?xze)
          (= ?xzf ?xzd)
          )
        (= ?xze ?xzd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xzh Real)
    (declare-const ?xzi Real)
    (declare-const ?xzj Real)
    (declare-const ?xzk Real)
    (declare-const ?xzl Real)
    (assert
      (or (or (= ?xzj ?xzi)
          (= ?xzj ?xzh)
          )
        (= ?xzi ?xzh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xzm Real)
    (declare-const ?xzn Real)
    (declare-const ?xzo Real)
    (declare-const ?xzp Real)
    (declare-const ?xzq Real)
    (declare-const ?xzr Real)
    (assert
      (and (or (or (= ?xzo ?xzn)
            (= ?xzo ?xzm)
            )
          (= ?xzn ?xzm)
          )
        (and (and (not (= ?xzr ?xzq))
            (not (= ?xzr ?xzp))
            )
          (not (= ?xzq ?xzp))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xzs Real)
    (declare-const ?xzt Real)
    (declare-const ?xzu Real)
    (assert
      (or (or (= ?xzu ?xzt)
          (= ?xzu ?xzs)
          )
        (= ?xzt ?xzs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xzv Real)
    (declare-const ?xzw Real)
    (declare-const ?xzx Real)
    (declare-const ?xzy Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?xzw ?xzv))
                (not (= ?xzw ?asi))
                )
              (not (= ?xzv ?asi))
              )
            (or (or (= ?xzy ?xzx)
                (= ?xzy ?asi)
                )
              (= ?xzx ?asi)
              )
            )
          (and (or (or (= ?xzw ?xzv)
                (= ?xzw ?asi)
                )
              (= ?xzv ?asi)
              )
            (and (and (not (= ?xzy ?xzx))
                (not (= ?xzy ?asi))
                )
              (not (= ?xzx ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?xzz Real)
    (declare-const ?yaa Real)
    (declare-const ?yab Real)
    (declare-const ?yac Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?yaa ?xzz))
                (not (= ?yaa ?fkf))
                )
              (not (= ?xzz ?fkf))
              )
            (or (or (= ?yac ?yab)
                (= ?yac ?fkf)
                )
              (= ?yab ?fkf)
              )
            )
          (and (or (or (= ?yaa ?xzz)
                (= ?yaa ?fkf)
                )
              (= ?xzz ?fkf)
              )
            (and (and (not (= ?yac ?yab))
                (not (= ?yac ?fkf))
                )
              (not (= ?yab ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yad Real)
    (declare-const ?yae Real)
    (declare-const ?yaf Real)
    (declare-const ?yag Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?yae ?yad))
                (not (= ?yae ?mzs))
                )
              (not (= ?yad ?mzs))
              )
            (or (or (= ?yag ?yaf)
                (= ?yag ?mzs)
                )
              (= ?yaf ?mzs)
              )
            )
          (and (or (or (= ?yae ?yad)
                (= ?yae ?mzs)
                )
              (= ?yad ?mzs)
              )
            (and (and (not (= ?yag ?yaf))
                (not (= ?yag ?mzs))
                )
              (not (= ?yaf ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?yah Real)
  (declare-const ?yai Real)
  (push 1)
    (declare-const ?yaj Real)
    (declare-const ?yak Real)
    (declare-const ?yal Real)
    (assert
      (or (or (= ?yal ?yak)
          (= ?yal ?yaj)
          )
        (= ?yak ?yaj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yam Real)
    (declare-const ?yan Real)
    (declare-const ?yao Real)
    (declare-const ?yap Real)
    (assert
      (or (or (= ?yap ?yao)
          (= ?yap ?yan)
          )
        (= ?yao ?yan)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yaq Real)
    (declare-const ?yar Real)
    (declare-const ?yas Real)
    (declare-const ?yat Real)
    (declare-const ?yau Real)
    (assert
      (or (or (= ?yau ?yat)
          (= ?yau ?yas)
          )
        (= ?yat ?yas)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yav Real)
    (declare-const ?yaw Real)
    (declare-const ?yax Real)
    (declare-const ?yay Real)
    (declare-const ?yaz Real)
    (declare-const ?yba Real)
    (assert
      (and (and (and (not (= ?yax ?yaw))
            (not (= ?yax ?yav))
            )
          (not (= ?yaw ?yav))
          )
        (or (or (= ?yba ?yaz)
            (= ?yba ?yay)
            )
          (= ?yaz ?yay)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ybb Real)
    (declare-const ?ybc Real)
    (declare-const ?ybd Real)
    (assert
      (or (or (= ?ybd ?ybc)
          (= ?ybd ?ybb)
          )
        (= ?ybc ?ybb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ybe Real)
    (declare-const ?ybf Real)
    (declare-const ?ybg Real)
    (assert
      (or (or (= ?ybg ?ybf)
          (= ?ybg ?ybe)
          )
        (= ?ybf ?ybe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ybh Real)
    (declare-const ?ybi Real)
    (declare-const ?ybj Real)
    (declare-const ?ybk Real)
    (assert
      (or (or (= ?ybj ?ybi)
          (= ?ybj ?ybh)
          )
        (= ?ybi ?ybh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ybl Real)
    (declare-const ?ybm Real)
    (declare-const ?ybn Real)
    (declare-const ?ybo Real)
    (declare-const ?ybp Real)
    (assert
      (or (or (= ?ybn ?ybm)
          (= ?ybn ?ybl)
          )
        (= ?ybm ?ybl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ybq Real)
    (declare-const ?ybr Real)
    (declare-const ?ybs Real)
    (declare-const ?ybt Real)
    (declare-const ?ybu Real)
    (declare-const ?ybv Real)
    (assert
      (and (or (or (= ?ybs ?ybr)
            (= ?ybs ?ybq)
            )
          (= ?ybr ?ybq)
          )
        (and (and (not (= ?ybv ?ybu))
            (not (= ?ybv ?ybt))
            )
          (not (= ?ybu ?ybt))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ybw Real)
    (declare-const ?ybx Real)
    (declare-const ?yby Real)
    (assert
      (or (or (= ?yby ?ybx)
          (= ?yby ?ybw)
          )
        (= ?ybx ?ybw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ybz Real)
    (declare-const ?yca Real)
    (declare-const ?ycb Real)
    (declare-const ?ycc Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?yca ?ybz))
                (not (= ?yca ?asi))
                )
              (not (= ?ybz ?asi))
              )
            (or (or (= ?ycc ?ycb)
                (= ?ycc ?asi)
                )
              (= ?ycb ?asi)
              )
            )
          (and (or (or (= ?yca ?ybz)
                (= ?yca ?asi)
                )
              (= ?ybz ?asi)
              )
            (and (and (not (= ?ycc ?ycb))
                (not (= ?ycc ?asi))
                )
              (not (= ?ycb ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ycd Real)
    (declare-const ?yce Real)
    (declare-const ?ycf Real)
    (declare-const ?ycg Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?yce ?ycd))
                (not (= ?yce ?fkf))
                )
              (not (= ?ycd ?fkf))
              )
            (or (or (= ?ycg ?ycf)
                (= ?ycg ?fkf)
                )
              (= ?ycf ?fkf)
              )
            )
          (and (or (or (= ?yce ?ycd)
                (= ?yce ?fkf)
                )
              (= ?ycd ?fkf)
              )
            (and (and (not (= ?ycg ?ycf))
                (not (= ?ycg ?fkf))
                )
              (not (= ?ycf ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ych Real)
    (declare-const ?yci Real)
    (declare-const ?ycj Real)
    (declare-const ?yck Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?yci ?ych))
                (not (= ?yci ?mzs))
                )
              (not (= ?ych ?mzs))
              )
            (or (or (= ?yck ?ycj)
                (= ?yck ?mzs)
                )
              (= ?ycj ?mzs)
              )
            )
          (and (or (or (= ?yci ?ych)
                (= ?yci ?mzs)
                )
              (= ?ych ?mzs)
              )
            (and (and (not (= ?yck ?ycj))
                (not (= ?yck ?mzs))
                )
              (not (= ?ycj ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ycl Real)
  (declare-const ?ycm Real)
  (declare-const ?ycn Real)
  (declare-const ?yco Real)
  (push 1)
    (declare-const ?ycp Real)
    (declare-const ?ycq Real)
    (declare-const ?ycr Real)
    (assert
      (or (or (= ?ycr ?ycq)
          (= ?ycr ?ycp)
          )
        (= ?ycq ?ycp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ycs Real)
    (declare-const ?yct Real)
    (declare-const ?ycu Real)
    (declare-const ?ycv Real)
    (assert
      (or (or (= ?ycv ?ycu)
          (= ?ycv ?yct)
          )
        (= ?ycu ?yct)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ycw Real)
    (declare-const ?ycx Real)
    (declare-const ?ycy Real)
    (declare-const ?ycz Real)
    (declare-const ?yda Real)
    (assert
      (or (or (= ?yda ?ycz)
          (= ?yda ?ycy)
          )
        (= ?ycz ?ycy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ydb Real)
    (declare-const ?ydc Real)
    (declare-const ?ydd Real)
    (declare-const ?yde Real)
    (declare-const ?ydf Real)
    (declare-const ?ydg Real)
    (assert
      (and (and (and (not (= ?ydd ?ydc))
            (not (= ?ydd ?ydb))
            )
          (not (= ?ydc ?ydb))
          )
        (or (or (= ?ydg ?ydf)
            (= ?ydg ?yde)
            )
          (= ?ydf ?yde)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ydh Real)
    (declare-const ?ydi Real)
    (declare-const ?ydj Real)
    (assert
      (or (or (= ?ydj ?ydi)
          (= ?ydj ?ydh)
          )
        (= ?ydi ?ydh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ydk Real)
    (declare-const ?ydl Real)
    (declare-const ?ydm Real)
    (assert
      (or (or (= ?ydm ?ydl)
          (= ?ydm ?ydk)
          )
        (= ?ydl ?ydk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ydn Real)
    (declare-const ?ydo Real)
    (declare-const ?ydp Real)
    (declare-const ?ydq Real)
    (assert
      (or (or (= ?ydp ?ydo)
          (= ?ydp ?ydn)
          )
        (= ?ydo ?ydn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ydr Real)
    (declare-const ?yds Real)
    (declare-const ?ydt Real)
    (declare-const ?ydu Real)
    (declare-const ?ydv Real)
    (assert
      (or (or (= ?ydt ?yds)
          (= ?ydt ?ydr)
          )
        (= ?yds ?ydr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ydw Real)
    (declare-const ?ydx Real)
    (declare-const ?ydy Real)
    (declare-const ?ydz Real)
    (declare-const ?yea Real)
    (declare-const ?yeb Real)
    (assert
      (and (or (or (= ?ydy ?ydx)
            (= ?ydy ?ydw)
            )
          (= ?ydx ?ydw)
          )
        (and (and (not (= ?yeb ?yea))
            (not (= ?yeb ?ydz))
            )
          (not (= ?yea ?ydz))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yec Real)
    (declare-const ?yed Real)
    (declare-const ?yee Real)
    (assert
      (or (or (= ?yee ?yed)
          (= ?yee ?yec)
          )
        (= ?yed ?yec)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yef Real)
    (declare-const ?yeg Real)
    (declare-const ?yeh Real)
    (declare-const ?yei Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?yeg ?yef))
                (not (= ?yeg ?asi))
                )
              (not (= ?yef ?asi))
              )
            (or (or (= ?yei ?yeh)
                (= ?yei ?asi)
                )
              (= ?yeh ?asi)
              )
            )
          (and (or (or (= ?yeg ?yef)
                (= ?yeg ?asi)
                )
              (= ?yef ?asi)
              )
            (and (and (not (= ?yei ?yeh))
                (not (= ?yei ?asi))
                )
              (not (= ?yeh ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yej Real)
    (declare-const ?yek Real)
    (declare-const ?yel Real)
    (declare-const ?yem Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?yek ?yej))
                (not (= ?yek ?fkf))
                )
              (not (= ?yej ?fkf))
              )
            (or (or (= ?yem ?yel)
                (= ?yem ?fkf)
                )
              (= ?yel ?fkf)
              )
            )
          (and (or (or (= ?yek ?yej)
                (= ?yek ?fkf)
                )
              (= ?yej ?fkf)
              )
            (and (and (not (= ?yem ?yel))
                (not (= ?yem ?fkf))
                )
              (not (= ?yel ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yen Real)
    (declare-const ?yeo Real)
    (declare-const ?yep Real)
    (declare-const ?yeq Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?yeo ?yen))
                (not (= ?yeo ?mzs))
                )
              (not (= ?yen ?mzs))
              )
            (or (or (= ?yeq ?yep)
                (= ?yeq ?mzs)
                )
              (= ?yep ?mzs)
              )
            )
          (and (or (or (= ?yeo ?yen)
                (= ?yeo ?mzs)
                )
              (= ?yen ?mzs)
              )
            (and (and (not (= ?yeq ?yep))
                (not (= ?yeq ?mzs))
                )
              (not (= ?yep ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?yer Real)
  (declare-const ?yes Real)
  (declare-const ?yet Real)
  (declare-const ?yeu Real)
  (declare-const ?yev Real)
  (push 1)
    (declare-const ?yew Real)
    (declare-const ?yex Real)
    (declare-const ?yey Real)
    (assert
      (or (or (= ?yey ?yex)
          (= ?yey ?yew)
          )
        (= ?yex ?yew)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yez Real)
    (declare-const ?yfa Real)
    (declare-const ?yfb Real)
    (declare-const ?yfc Real)
    (assert
      (or (or (= ?yfc ?yfb)
          (= ?yfc ?yfa)
          )
        (= ?yfb ?yfa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yfd Real)
    (declare-const ?yfe Real)
    (declare-const ?yff Real)
    (declare-const ?yfg Real)
    (declare-const ?yfh Real)
    (assert
      (or (or (= ?yfh ?yfg)
          (= ?yfh ?yff)
          )
        (= ?yfg ?yff)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yfi Real)
    (declare-const ?yfj Real)
    (declare-const ?yfk Real)
    (declare-const ?yfl Real)
    (declare-const ?yfm Real)
    (declare-const ?yfn Real)
    (assert
      (and (and (and (not (= ?yfk ?yfj))
            (not (= ?yfk ?yfi))
            )
          (not (= ?yfj ?yfi))
          )
        (or (or (= ?yfn ?yfm)
            (= ?yfn ?yfl)
            )
          (= ?yfm ?yfl)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yfo Real)
    (declare-const ?yfp Real)
    (declare-const ?yfq Real)
    (assert
      (or (or (= ?yfq ?yfp)
          (= ?yfq ?yfo)
          )
        (= ?yfp ?yfo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yfr Real)
    (declare-const ?yfs Real)
    (declare-const ?yft Real)
    (assert
      (or (or (= ?yft ?yfs)
          (= ?yft ?yfr)
          )
        (= ?yfs ?yfr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yfu Real)
    (declare-const ?yfv Real)
    (declare-const ?yfw Real)
    (declare-const ?yfx Real)
    (assert
      (or (or (= ?yfw ?yfv)
          (= ?yfw ?yfu)
          )
        (= ?yfv ?yfu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yfy Real)
    (declare-const ?yfz Real)
    (declare-const ?yga Real)
    (declare-const ?ygb Real)
    (declare-const ?ygc Real)
    (assert
      (or (or (= ?yga ?yfz)
          (= ?yga ?yfy)
          )
        (= ?yfz ?yfy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ygd Real)
    (declare-const ?yge Real)
    (declare-const ?ygf Real)
    (declare-const ?ygg Real)
    (declare-const ?ygh Real)
    (declare-const ?ygi Real)
    (assert
      (and (or (or (= ?ygf ?yge)
            (= ?ygf ?ygd)
            )
          (= ?yge ?ygd)
          )
        (and (and (not (= ?ygi ?ygh))
            (not (= ?ygi ?ygg))
            )
          (not (= ?ygh ?ygg))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ygj Real)
    (declare-const ?ygk Real)
    (declare-const ?ygl Real)
    (assert
      (or (or (= ?ygl ?ygk)
          (= ?ygl ?ygj)
          )
        (= ?ygk ?ygj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ygm Real)
    (declare-const ?ygn Real)
    (declare-const ?ygo Real)
    (declare-const ?ygp Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ygn ?ygm))
                (not (= ?ygn ?asi))
                )
              (not (= ?ygm ?asi))
              )
            (or (or (= ?ygp ?ygo)
                (= ?ygp ?asi)
                )
              (= ?ygo ?asi)
              )
            )
          (and (or (or (= ?ygn ?ygm)
                (= ?ygn ?asi)
                )
              (= ?ygm ?asi)
              )
            (and (and (not (= ?ygp ?ygo))
                (not (= ?ygp ?asi))
                )
              (not (= ?ygo ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ygq Real)
    (declare-const ?ygr Real)
    (declare-const ?ygs Real)
    (declare-const ?ygt Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ygr ?ygq))
                (not (= ?ygr ?fkf))
                )
              (not (= ?ygq ?fkf))
              )
            (or (or (= ?ygt ?ygs)
                (= ?ygt ?fkf)
                )
              (= ?ygs ?fkf)
              )
            )
          (and (or (or (= ?ygr ?ygq)
                (= ?ygr ?fkf)
                )
              (= ?ygq ?fkf)
              )
            (and (and (not (= ?ygt ?ygs))
                (not (= ?ygt ?fkf))
                )
              (not (= ?ygs ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ygu Real)
    (declare-const ?ygv Real)
    (declare-const ?ygw Real)
    (declare-const ?ygx Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ygv ?ygu))
                (not (= ?ygv ?mzs))
                )
              (not (= ?ygu ?mzs))
              )
            (or (or (= ?ygx ?ygw)
                (= ?ygx ?mzs)
                )
              (= ?ygw ?mzs)
              )
            )
          (and (or (or (= ?ygv ?ygu)
                (= ?ygv ?mzs)
                )
              (= ?ygu ?mzs)
              )
            (and (and (not (= ?ygx ?ygw))
                (not (= ?ygx ?mzs))
                )
              (not (= ?ygw ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ygy Real)
  (push 1)
    (declare-const ?ygz Real)
    (declare-const ?yha Real)
    (declare-const ?yhb Real)
    (assert
      (or (or (= ?yhb ?yha)
          (= ?yhb ?ygz)
          )
        (= ?yha ?ygz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yhc Real)
    (declare-const ?yhd Real)
    (declare-const ?yhe Real)
    (declare-const ?yhf Real)
    (assert
      (or (or (= ?yhf ?yhe)
          (= ?yhf ?yhd)
          )
        (= ?yhe ?yhd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yhg Real)
    (declare-const ?yhh Real)
    (declare-const ?yhi Real)
    (declare-const ?yhj Real)
    (declare-const ?yhk Real)
    (assert
      (or (or (= ?yhk ?yhj)
          (= ?yhk ?yhi)
          )
        (= ?yhj ?yhi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yhl Real)
    (declare-const ?yhm Real)
    (declare-const ?yhn Real)
    (declare-const ?yho Real)
    (declare-const ?yhp Real)
    (declare-const ?yhq Real)
    (assert
      (and (and (and (not (= ?yhn ?yhm))
            (not (= ?yhn ?yhl))
            )
          (not (= ?yhm ?yhl))
          )
        (or (or (= ?yhq ?yhp)
            (= ?yhq ?yho)
            )
          (= ?yhp ?yho)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yhr Real)
    (declare-const ?yhs Real)
    (declare-const ?yht Real)
    (assert
      (or (or (= ?yht ?yhs)
          (= ?yht ?yhr)
          )
        (= ?yhs ?yhr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yhu Real)
    (declare-const ?yhv Real)
    (declare-const ?yhw Real)
    (assert
      (or (or (= ?yhw ?yhv)
          (= ?yhw ?yhu)
          )
        (= ?yhv ?yhu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yhx Real)
    (declare-const ?yhy Real)
    (declare-const ?yhz Real)
    (declare-const ?yia Real)
    (assert
      (or (or (= ?yhz ?yhy)
          (= ?yhz ?yhx)
          )
        (= ?yhy ?yhx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yib Real)
    (declare-const ?yic Real)
    (declare-const ?yid Real)
    (declare-const ?yie Real)
    (declare-const ?yif Real)
    (assert
      (or (or (= ?yid ?yic)
          (= ?yid ?yib)
          )
        (= ?yic ?yib)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yig Real)
    (declare-const ?yih Real)
    (declare-const ?yii Real)
    (declare-const ?yij Real)
    (declare-const ?yik Real)
    (declare-const ?yil Real)
    (assert
      (and (or (or (= ?yii ?yih)
            (= ?yii ?yig)
            )
          (= ?yih ?yig)
          )
        (and (and (not (= ?yil ?yik))
            (not (= ?yil ?yij))
            )
          (not (= ?yik ?yij))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yim Real)
    (declare-const ?yin Real)
    (declare-const ?yio Real)
    (assert
      (or (or (= ?yio ?yin)
          (= ?yio ?yim)
          )
        (= ?yin ?yim)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yip Real)
    (declare-const ?yiq Real)
    (declare-const ?yir Real)
    (declare-const ?yis Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?yiq ?yip))
                (not (= ?yiq ?asi))
                )
              (not (= ?yip ?asi))
              )
            (or (or (= ?yis ?yir)
                (= ?yis ?asi)
                )
              (= ?yir ?asi)
              )
            )
          (and (or (or (= ?yiq ?yip)
                (= ?yiq ?asi)
                )
              (= ?yip ?asi)
              )
            (and (and (not (= ?yis ?yir))
                (not (= ?yis ?asi))
                )
              (not (= ?yir ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yit Real)
    (declare-const ?yiu Real)
    (declare-const ?yiv Real)
    (declare-const ?yiw Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?yiu ?yit))
                (not (= ?yiu ?fkf))
                )
              (not (= ?yit ?fkf))
              )
            (or (or (= ?yiw ?yiv)
                (= ?yiw ?fkf)
                )
              (= ?yiv ?fkf)
              )
            )
          (and (or (or (= ?yiu ?yit)
                (= ?yiu ?fkf)
                )
              (= ?yit ?fkf)
              )
            (and (and (not (= ?yiw ?yiv))
                (not (= ?yiw ?fkf))
                )
              (not (= ?yiv ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yix Real)
    (declare-const ?yiy Real)
    (declare-const ?yiz Real)
    (declare-const ?yja Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?yiy ?yix))
                (not (= ?yiy ?mzs))
                )
              (not (= ?yix ?mzs))
              )
            (or (or (= ?yja ?yiz)
                (= ?yja ?mzs)
                )
              (= ?yiz ?mzs)
              )
            )
          (and (or (or (= ?yiy ?yix)
                (= ?yiy ?mzs)
                )
              (= ?yix ?mzs)
              )
            (and (and (not (= ?yja ?yiz))
                (not (= ?yja ?mzs))
                )
              (not (= ?yiz ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?yjb Real)
  (declare-const ?yjc Real)
  (push 1)
    (declare-const ?yjd Real)
    (declare-const ?yje Real)
    (declare-const ?yjf Real)
    (assert
      (or (or (= ?yjf ?yje)
          (= ?yjf ?yjd)
          )
        (= ?yje ?yjd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yjg Real)
    (declare-const ?yjh Real)
    (declare-const ?yji Real)
    (declare-const ?yjj Real)
    (assert
      (or (or (= ?yjj ?yji)
          (= ?yjj ?yjh)
          )
        (= ?yji ?yjh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yjk Real)
    (declare-const ?yjl Real)
    (declare-const ?yjm Real)
    (declare-const ?yjn Real)
    (declare-const ?yjo Real)
    (assert
      (or (or (= ?yjo ?yjn)
          (= ?yjo ?yjm)
          )
        (= ?yjn ?yjm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yjp Real)
    (declare-const ?yjq Real)
    (declare-const ?yjr Real)
    (declare-const ?yjs Real)
    (declare-const ?yjt Real)
    (declare-const ?yju Real)
    (assert
      (and (and (and (not (= ?yjr ?yjq))
            (not (= ?yjr ?yjp))
            )
          (not (= ?yjq ?yjp))
          )
        (or (or (= ?yju ?yjt)
            (= ?yju ?yjs)
            )
          (= ?yjt ?yjs)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yjv Real)
    (declare-const ?yjw Real)
    (declare-const ?yjx Real)
    (assert
      (or (or (= ?yjx ?yjw)
          (= ?yjx ?yjv)
          )
        (= ?yjw ?yjv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yjy Real)
    (declare-const ?yjz Real)
    (declare-const ?yka Real)
    (assert
      (or (or (= ?yka ?yjz)
          (= ?yka ?yjy)
          )
        (= ?yjz ?yjy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ykb Real)
    (declare-const ?ykc Real)
    (declare-const ?ykd Real)
    (declare-const ?yke Real)
    (assert
      (or (or (= ?ykd ?ykc)
          (= ?ykd ?ykb)
          )
        (= ?ykc ?ykb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ykf Real)
    (declare-const ?ykg Real)
    (declare-const ?ykh Real)
    (declare-const ?yki Real)
    (declare-const ?ykj Real)
    (assert
      (or (or (= ?ykh ?ykg)
          (= ?ykh ?ykf)
          )
        (= ?ykg ?ykf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ykk Real)
    (declare-const ?ykl Real)
    (declare-const ?ykm Real)
    (declare-const ?ykn Real)
    (declare-const ?yko Real)
    (declare-const ?ykp Real)
    (assert
      (and (or (or (= ?ykm ?ykl)
            (= ?ykm ?ykk)
            )
          (= ?ykl ?ykk)
          )
        (and (and (not (= ?ykp ?yko))
            (not (= ?ykp ?ykn))
            )
          (not (= ?yko ?ykn))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ykq Real)
    (declare-const ?ykr Real)
    (declare-const ?yks Real)
    (assert
      (or (or (= ?yks ?ykr)
          (= ?yks ?ykq)
          )
        (= ?ykr ?ykq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ykt Real)
    (declare-const ?yku Real)
    (declare-const ?ykv Real)
    (declare-const ?ykw Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?yku ?ykt))
                (not (= ?yku ?asi))
                )
              (not (= ?ykt ?asi))
              )
            (or (or (= ?ykw ?ykv)
                (= ?ykw ?asi)
                )
              (= ?ykv ?asi)
              )
            )
          (and (or (or (= ?yku ?ykt)
                (= ?yku ?asi)
                )
              (= ?ykt ?asi)
              )
            (and (and (not (= ?ykw ?ykv))
                (not (= ?ykw ?asi))
                )
              (not (= ?ykv ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ykx Real)
    (declare-const ?yky Real)
    (declare-const ?ykz Real)
    (declare-const ?yla Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?yky ?ykx))
                (not (= ?yky ?fkf))
                )
              (not (= ?ykx ?fkf))
              )
            (or (or (= ?yla ?ykz)
                (= ?yla ?fkf)
                )
              (= ?ykz ?fkf)
              )
            )
          (and (or (or (= ?yky ?ykx)
                (= ?yky ?fkf)
                )
              (= ?ykx ?fkf)
              )
            (and (and (not (= ?yla ?ykz))
                (not (= ?yla ?fkf))
                )
              (not (= ?ykz ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ylb Real)
    (declare-const ?ylc Real)
    (declare-const ?yld Real)
    (declare-const ?yle Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ylc ?ylb))
                (not (= ?ylc ?mzs))
                )
              (not (= ?ylb ?mzs))
              )
            (or (or (= ?yle ?yld)
                (= ?yle ?mzs)
                )
              (= ?yld ?mzs)
              )
            )
          (and (or (or (= ?ylc ?ylb)
                (= ?ylc ?mzs)
                )
              (= ?ylb ?mzs)
              )
            (and (and (not (= ?yle ?yld))
                (not (= ?yle ?mzs))
                )
              (not (= ?yld ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ylf Real)
  (declare-const ?ylg Real)
  (declare-const ?ylh Real)
  (assert
    (or (or (= ?ylh ?ylg)
        (= ?ylh ?ylf)
        )
      (= ?ylg ?ylf)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?yli Real)
  (declare-const ?ylj Real)
  (declare-const ?ylk Real)
  (declare-const ?yll Real)
  (assert
    (or (or (= ?yll ?ylk)
        (= ?yll ?ylj)
        )
      (= ?ylk ?ylj)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ylm Real)
  (declare-const ?yln Real)
  (declare-const ?ylo Real)
  (declare-const ?ylp Real)
  (declare-const ?ylq Real)
  (assert
    (or (or (= ?ylq ?ylp)
        (= ?ylq ?ylo)
        )
      (= ?ylp ?ylo)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ylr Real)
  (declare-const ?yls Real)
  (declare-const ?ylt Real)
  (declare-const ?ylu Real)
  (declare-const ?ylv Real)
  (declare-const ?ylw Real)
  (assert
    (and (and (and (not (= ?ylt ?yls))
          (not (= ?ylt ?ylr))
          )
        (not (= ?yls ?ylr))
        )
      (or (or (= ?ylw ?ylv)
          (= ?ylw ?ylu)
          )
        (= ?ylv ?ylu)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ylx Real)
  (declare-const ?yly Real)
  (declare-const ?ylz Real)
  (assert
    (or (or (= ?ylz ?yly)
        (= ?ylz ?ylx)
        )
      (= ?yly ?ylx)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?yma Real)
  (declare-const ?ymb Real)
  (declare-const ?ymc Real)
  (assert
    (or (or (= ?ymc ?ymb)
        (= ?ymc ?yma)
        )
      (= ?ymb ?yma)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ymd Real)
  (declare-const ?yme Real)
  (declare-const ?ymf Real)
  (declare-const ?ymg Real)
  (assert
    (or (or (= ?ymf ?yme)
        (= ?ymf ?ymd)
        )
      (= ?yme ?ymd)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ymh Real)
  (declare-const ?ymi Real)
  (declare-const ?ymj Real)
  (declare-const ?ymk Real)
  (declare-const ?yml Real)
  (assert
    (or (or (= ?ymj ?ymi)
        (= ?ymj ?ymh)
        )
      (= ?ymi ?ymh)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ymm Real)
  (declare-const ?ymn Real)
  (declare-const ?ymo Real)
  (declare-const ?ymp Real)
  (declare-const ?ymq Real)
  (declare-const ?ymr Real)
  (assert
    (and (or (or (= ?ymo ?ymn)
          (= ?ymo ?ymm)
          )
        (= ?ymn ?ymm)
        )
      (and (and (not (= ?ymr ?ymq))
          (not (= ?ymr ?ymp))
          )
        (not (= ?ymq ?ymp))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?yms Real)
  (declare-const ?ymt Real)
  (declare-const ?ymu Real)
  (assert
    (or (or (= ?ymu ?ymt)
        (= ?ymu ?yms)
        )
      (= ?ymt ?yms)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ymv Real)
  (declare-const ?ymw Real)
  (declare-const ?ymx Real)
  (declare-const ?ymy Real)
  (assert
    (exists ((?asi Real) )(or (and (and (and (not (= ?ymw ?ymv))
              (not (= ?ymw ?asi))
              )
            (not (= ?ymv ?asi))
            )
          (or (or (= ?ymy ?ymx)
              (= ?ymy ?asi)
              )
            (= ?ymx ?asi)
            )
          )
        (and (or (or (= ?ymw ?ymv)
              (= ?ymw ?asi)
              )
            (= ?ymv ?asi)
            )
          (and (and (not (= ?ymy ?ymx))
              (not (= ?ymy ?asi))
              )
            (not (= ?ymx ?asi))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ymz Real)
  (declare-const ?yna Real)
  (declare-const ?ynb Real)
  (declare-const ?ync Real)
  (assert
    (exists ((?fkf Real) )(or (and (and (and (not (= ?yna ?ymz))
              (not (= ?yna ?fkf))
              )
            (not (= ?ymz ?fkf))
            )
          (or (or (= ?ync ?ynb)
              (= ?ync ?fkf)
              )
            (= ?ynb ?fkf)
            )
          )
        (and (or (or (= ?yna ?ymz)
              (= ?yna ?fkf)
              )
            (= ?ymz ?fkf)
            )
          (and (and (not (= ?ync ?ynb))
              (not (= ?ync ?fkf))
              )
            (not (= ?ynb ?fkf))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?ynd Real)
    (declare-const ?yne Real)
    (declare-const ?ynf Real)
    (assert
      (or (or (= ?ynf ?yne)
          (= ?ynf ?ynd)
          )
        (= ?yne ?ynd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yng Real)
    (declare-const ?ynh Real)
    (declare-const ?yni Real)
    (declare-const ?ynj Real)
    (assert
      (or (or (= ?ynj ?yni)
          (= ?ynj ?ynh)
          )
        (= ?yni ?ynh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ynk Real)
    (declare-const ?ynl Real)
    (declare-const ?ynm Real)
    (declare-const ?ynn Real)
    (declare-const ?yno Real)
    (assert
      (or (or (= ?yno ?ynn)
          (= ?yno ?ynm)
          )
        (= ?ynn ?ynm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ynp Real)
    (declare-const ?ynq Real)
    (declare-const ?ynr Real)
    (declare-const ?yns Real)
    (declare-const ?ynt Real)
    (declare-const ?ynu Real)
    (assert
      (and (and (and (not (= ?ynr ?ynq))
            (not (= ?ynr ?ynp))
            )
          (not (= ?ynq ?ynp))
          )
        (or (or (= ?ynu ?ynt)
            (= ?ynu ?yns)
            )
          (= ?ynt ?yns)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ynv Real)
    (declare-const ?ynw Real)
    (declare-const ?ynx Real)
    (assert
      (or (or (= ?ynx ?ynw)
          (= ?ynx ?ynv)
          )
        (= ?ynw ?ynv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yny Real)
    (declare-const ?ynz Real)
    (declare-const ?yoa Real)
    (assert
      (or (or (= ?yoa ?ynz)
          (= ?yoa ?yny)
          )
        (= ?ynz ?yny)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yob Real)
    (declare-const ?yoc Real)
    (declare-const ?yod Real)
    (declare-const ?yoe Real)
    (assert
      (or (or (= ?yod ?yoc)
          (= ?yod ?yob)
          )
        (= ?yoc ?yob)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yof Real)
    (declare-const ?yog Real)
    (declare-const ?yoh Real)
    (declare-const ?yoi Real)
    (declare-const ?yoj Real)
    (assert
      (or (or (= ?yoh ?yog)
          (= ?yoh ?yof)
          )
        (= ?yog ?yof)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yok Real)
    (declare-const ?yol Real)
    (declare-const ?yom Real)
    (declare-const ?yon Real)
    (declare-const ?yoo Real)
    (declare-const ?yop Real)
    (assert
      (and (or (or (= ?yom ?yol)
            (= ?yom ?yok)
            )
          (= ?yol ?yok)
          )
        (and (and (not (= ?yop ?yoo))
            (not (= ?yop ?yon))
            )
          (not (= ?yoo ?yon))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yoq Real)
    (declare-const ?yor Real)
    (declare-const ?yos Real)
    (assert
      (or (or (= ?yos ?yor)
          (= ?yos ?yoq)
          )
        (= ?yor ?yoq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yot Real)
    (declare-const ?you Real)
    (declare-const ?yov Real)
    (declare-const ?yow Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?you ?yot))
                (not (= ?you ?asi))
                )
              (not (= ?yot ?asi))
              )
            (or (or (= ?yow ?yov)
                (= ?yow ?asi)
                )
              (= ?yov ?asi)
              )
            )
          (and (or (or (= ?you ?yot)
                (= ?you ?asi)
                )
              (= ?yot ?asi)
              )
            (and (and (not (= ?yow ?yov))
                (not (= ?yow ?asi))
                )
              (not (= ?yov ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?yox Real)
    (declare-const ?yoy Real)
    (declare-const ?yoz Real)
    (declare-const ?ypa Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?yoy ?yox))
                (not (= ?yoy ?fkf))
                )
              (not (= ?yox ?fkf))
              )
            (or (or (= ?ypa ?yoz)
                (= ?ypa ?fkf)
                )
              (= ?yoz ?fkf)
              )
            )
          (and (or (or (= ?yoy ?yox)
                (= ?yoy ?fkf)
                )
              (= ?yox ?fkf)
              )
            (and (and (not (= ?ypa ?yoz))
                (not (= ?ypa ?fkf))
                )
              (not (= ?yoz ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ypb Real)
    (declare-const ?ypc Real)
    (declare-const ?ypd Real)
    (declare-const ?ype Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ypc ?ypb))
                (not (= ?ypc ?mzs))
                )
              (not (= ?ypb ?mzs))
              )
            (or (or (= ?ype ?ypd)
                (= ?ype ?mzs)
                )
              (= ?ypd ?mzs)
              )
            )
          (and (or (or (= ?ypc ?ypb)
                (= ?ypc ?mzs)
                )
              (= ?ypb ?mzs)
              )
            (and (and (not (= ?ype ?ypd))
                (not (= ?ype ?mzs))
                )
              (not (= ?ypd ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ypf Real)
    (push 1)
      (declare-const ?ypg Real)
      (declare-const ?yph Real)
      (declare-const ?ypi Real)
      (assert
        (or (or (= ?ypi ?yph)
            (= ?ypi ?ypg)
            )
          (= ?yph ?ypg)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ypj Real)
      (declare-const ?ypk Real)
      (declare-const ?ypl Real)
      (declare-const ?ypm Real)
      (assert
        (or (or (= ?ypm ?ypl)
            (= ?ypm ?ypk)
            )
          (= ?ypl ?ypk)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ypn Real)
      (declare-const ?ypo Real)
      (declare-const ?ypp Real)
      (declare-const ?ypq Real)
      (declare-const ?ypr Real)
      (assert
        (or (or (= ?ypr ?ypq)
            (= ?ypr ?ypp)
            )
          (= ?ypq ?ypp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yps Real)
      (declare-const ?ypt Real)
      (declare-const ?ypu Real)
      (declare-const ?ypv Real)
      (declare-const ?ypw Real)
      (declare-const ?ypx Real)
      (assert
        (and (and (and (not (= ?ypu ?ypt))
              (not (= ?ypu ?yps))
              )
            (not (= ?ypt ?yps))
            )
          (or (or (= ?ypx ?ypw)
              (= ?ypx ?ypv)
              )
            (= ?ypw ?ypv)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ypy Real)
      (declare-const ?ypz Real)
      (declare-const ?yqa Real)
      (assert
        (or (or (= ?yqa ?ypz)
            (= ?yqa ?ypy)
            )
          (= ?ypz ?ypy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yqb Real)
      (declare-const ?yqc Real)
      (declare-const ?yqd Real)
      (assert
        (or (or (= ?yqd ?yqc)
            (= ?yqd ?yqb)
            )
          (= ?yqc ?yqb)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yqe Real)
      (declare-const ?yqf Real)
      (declare-const ?yqg Real)
      (declare-const ?yqh Real)
      (assert
        (or (or (= ?yqg ?yqf)
            (= ?yqg ?yqe)
            )
          (= ?yqf ?yqe)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yqi Real)
      (declare-const ?yqj Real)
      (declare-const ?yqk Real)
      (declare-const ?yql Real)
      (declare-const ?yqm Real)
      (assert
        (or (or (= ?yqk ?yqj)
            (= ?yqk ?yqi)
            )
          (= ?yqj ?yqi)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yqn Real)
      (declare-const ?yqo Real)
      (declare-const ?yqp Real)
      (declare-const ?yqq Real)
      (declare-const ?yqr Real)
      (declare-const ?yqs Real)
      (assert
        (and (or (or (= ?yqp ?yqo)
              (= ?yqp ?yqn)
              )
            (= ?yqo ?yqn)
            )
          (and (and (not (= ?yqs ?yqr))
              (not (= ?yqs ?yqq))
              )
            (not (= ?yqr ?yqq))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yqt Real)
      (declare-const ?yqu Real)
      (declare-const ?yqv Real)
      (assert
        (or (or (= ?yqv ?yqu)
            (= ?yqv ?yqt)
            )
          (= ?yqu ?yqt)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yqw Real)
      (declare-const ?yqx Real)
      (declare-const ?yqy Real)
      (declare-const ?yqz Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?yqx ?yqw))
                  (not (= ?yqx ?asi))
                  )
                (not (= ?yqw ?asi))
                )
              (or (or (= ?yqz ?yqy)
                  (= ?yqz ?asi)
                  )
                (= ?yqy ?asi)
                )
              )
            (and (or (or (= ?yqx ?yqw)
                  (= ?yqx ?asi)
                  )
                (= ?yqw ?asi)
                )
              (and (and (not (= ?yqz ?yqy))
                  (not (= ?yqz ?asi))
                  )
                (not (= ?yqy ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yra Real)
      (declare-const ?yrb Real)
      (declare-const ?yrc Real)
      (declare-const ?yrd Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?yrb ?yra))
                  (not (= ?yrb ?fkf))
                  )
                (not (= ?yra ?fkf))
                )
              (or (or (= ?yrd ?yrc)
                  (= ?yrd ?fkf)
                  )
                (= ?yrc ?fkf)
                )
              )
            (and (or (or (= ?yrb ?yra)
                  (= ?yrb ?fkf)
                  )
                (= ?yra ?fkf)
                )
              (and (and (not (= ?yrd ?yrc))
                  (not (= ?yrd ?fkf))
                  )
                (not (= ?yrc ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yre Real)
      (declare-const ?yrf Real)
      (declare-const ?yrg Real)
      (declare-const ?yrh Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?yrf ?yre))
                  (not (= ?yrf ?mzs))
                  )
                (not (= ?yre ?mzs))
                )
              (or (or (= ?yrh ?yrg)
                  (= ?yrh ?mzs)
                  )
                (= ?yrg ?mzs)
                )
              )
            (and (or (or (= ?yrf ?yre)
                  (= ?yrf ?mzs)
                  )
                (= ?yre ?mzs)
                )
              (and (and (not (= ?yrh ?yrg))
                  (not (= ?yrh ?mzs))
                  )
                (not (= ?yrg ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?yri Real)
    (declare-const ?yrj Real)
    (push 1)
      (declare-const ?yrk Real)
      (declare-const ?yrl Real)
      (declare-const ?yrm Real)
      (assert
        (or (or (= ?yrm ?yrl)
            (= ?yrm ?yrk)
            )
          (= ?yrl ?yrk)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yrn Real)
      (declare-const ?yro Real)
      (declare-const ?yrp Real)
      (declare-const ?yrq Real)
      (assert
        (or (or (= ?yrq ?yrp)
            (= ?yrq ?yro)
            )
          (= ?yrp ?yro)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yrr Real)
      (declare-const ?yrs Real)
      (declare-const ?yrt Real)
      (declare-const ?yru Real)
      (declare-const ?yrv Real)
      (assert
        (or (or (= ?yrv ?yru)
            (= ?yrv ?yrt)
            )
          (= ?yru ?yrt)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yrw Real)
      (declare-const ?yrx Real)
      (declare-const ?yry Real)
      (declare-const ?yrz Real)
      (declare-const ?ysa Real)
      (declare-const ?ysb Real)
      (assert
        (and (and (and (not (= ?yry ?yrx))
              (not (= ?yry ?yrw))
              )
            (not (= ?yrx ?yrw))
            )
          (or (or (= ?ysb ?ysa)
              (= ?ysb ?yrz)
              )
            (= ?ysa ?yrz)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ysc Real)
      (declare-const ?ysd Real)
      (declare-const ?yse Real)
      (assert
        (or (or (= ?yse ?ysd)
            (= ?yse ?ysc)
            )
          (= ?ysd ?ysc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ysf Real)
      (declare-const ?ysg Real)
      (declare-const ?ysh Real)
      (assert
        (or (or (= ?ysh ?ysg)
            (= ?ysh ?ysf)
            )
          (= ?ysg ?ysf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ysi Real)
      (declare-const ?ysj Real)
      (declare-const ?ysk Real)
      (declare-const ?ysl Real)
      (assert
        (or (or (= ?ysk ?ysj)
            (= ?ysk ?ysi)
            )
          (= ?ysj ?ysi)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ysm Real)
      (declare-const ?ysn Real)
      (declare-const ?yso Real)
      (declare-const ?ysp Real)
      (declare-const ?ysq Real)
      (assert
        (or (or (= ?yso ?ysn)
            (= ?yso ?ysm)
            )
          (= ?ysn ?ysm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ysr Real)
      (declare-const ?yss Real)
      (declare-const ?yst Real)
      (declare-const ?ysu Real)
      (declare-const ?ysv Real)
      (declare-const ?ysw Real)
      (assert
        (and (or (or (= ?yst ?yss)
              (= ?yst ?ysr)
              )
            (= ?yss ?ysr)
            )
          (and (and (not (= ?ysw ?ysv))
              (not (= ?ysw ?ysu))
              )
            (not (= ?ysv ?ysu))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ysx Real)
      (declare-const ?ysy Real)
      (declare-const ?ysz Real)
      (assert
        (or (or (= ?ysz ?ysy)
            (= ?ysz ?ysx)
            )
          (= ?ysy ?ysx)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yta Real)
      (declare-const ?ytb Real)
      (declare-const ?ytc Real)
      (declare-const ?ytd Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?ytb ?yta))
                  (not (= ?ytb ?asi))
                  )
                (not (= ?yta ?asi))
                )
              (or (or (= ?ytd ?ytc)
                  (= ?ytd ?asi)
                  )
                (= ?ytc ?asi)
                )
              )
            (and (or (or (= ?ytb ?yta)
                  (= ?ytb ?asi)
                  )
                (= ?yta ?asi)
                )
              (and (and (not (= ?ytd ?ytc))
                  (not (= ?ytd ?asi))
                  )
                (not (= ?ytc ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yte Real)
      (declare-const ?ytf Real)
      (declare-const ?ytg Real)
      (declare-const ?yth Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?ytf ?yte))
                  (not (= ?ytf ?fkf))
                  )
                (not (= ?yte ?fkf))
                )
              (or (or (= ?yth ?ytg)
                  (= ?yth ?fkf)
                  )
                (= ?ytg ?fkf)
                )
              )
            (and (or (or (= ?ytf ?yte)
                  (= ?ytf ?fkf)
                  )
                (= ?yte ?fkf)
                )
              (and (and (not (= ?yth ?ytg))
                  (not (= ?yth ?fkf))
                  )
                (not (= ?ytg ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yti Real)
      (declare-const ?ytj Real)
      (declare-const ?ytk Real)
      (declare-const ?ytl Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?ytj ?yti))
                  (not (= ?ytj ?mzs))
                  )
                (not (= ?yti ?mzs))
                )
              (or (or (= ?ytl ?ytk)
                  (= ?ytl ?mzs)
                  )
                (= ?ytk ?mzs)
                )
              )
            (and (or (or (= ?ytj ?yti)
                  (= ?ytj ?mzs)
                  )
                (= ?yti ?mzs)
                )
              (and (and (not (= ?ytl ?ytk))
                  (not (= ?ytl ?mzs))
                  )
                (not (= ?ytk ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?ytm Real)
    (declare-const ?ytn Real)
    (declare-const ?yto Real)
    (push 1)
      (declare-const ?ytp Real)
      (declare-const ?ytq Real)
      (declare-const ?ytr Real)
      (assert
        (or (or (= ?ytr ?ytq)
            (= ?ytr ?ytp)
            )
          (= ?ytq ?ytp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yts Real)
      (declare-const ?ytt Real)
      (declare-const ?ytu Real)
      (declare-const ?ytv Real)
      (assert
        (or (or (= ?ytv ?ytu)
            (= ?ytv ?ytt)
            )
          (= ?ytu ?ytt)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ytw Real)
      (declare-const ?ytx Real)
      (declare-const ?yty Real)
      (declare-const ?ytz Real)
      (declare-const ?yua Real)
      (assert
        (or (or (= ?yua ?ytz)
            (= ?yua ?yty)
            )
          (= ?ytz ?yty)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yub Real)
      (declare-const ?yuc Real)
      (declare-const ?yud Real)
      (declare-const ?yue Real)
      (declare-const ?yuf Real)
      (declare-const ?yug Real)
      (assert
        (and (and (and (not (= ?yud ?yuc))
              (not (= ?yud ?yub))
              )
            (not (= ?yuc ?yub))
            )
          (or (or (= ?yug ?yuf)
              (= ?yug ?yue)
              )
            (= ?yuf ?yue)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yuh Real)
      (declare-const ?yui Real)
      (declare-const ?yuj Real)
      (assert
        (or (or (= ?yuj ?yui)
            (= ?yuj ?yuh)
            )
          (= ?yui ?yuh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yuk Real)
      (declare-const ?yul Real)
      (declare-const ?yum Real)
      (assert
        (or (or (= ?yum ?yul)
            (= ?yum ?yuk)
            )
          (= ?yul ?yuk)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yun Real)
      (declare-const ?yuo Real)
      (declare-const ?yup Real)
      (declare-const ?yuq Real)
      (assert
        (or (or (= ?yup ?yuo)
            (= ?yup ?yun)
            )
          (= ?yuo ?yun)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yur Real)
      (declare-const ?yus Real)
      (declare-const ?yut Real)
      (declare-const ?yuu Real)
      (declare-const ?yuv Real)
      (assert
        (or (or (= ?yut ?yus)
            (= ?yut ?yur)
            )
          (= ?yus ?yur)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yuw Real)
      (declare-const ?yux Real)
      (declare-const ?yuy Real)
      (declare-const ?yuz Real)
      (declare-const ?yva Real)
      (declare-const ?yvb Real)
      (assert
        (and (or (or (= ?yuy ?yux)
              (= ?yuy ?yuw)
              )
            (= ?yux ?yuw)
            )
          (and (and (not (= ?yvb ?yva))
              (not (= ?yvb ?yuz))
              )
            (not (= ?yva ?yuz))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yvc Real)
      (declare-const ?yvd Real)
      (declare-const ?yve Real)
      (assert
        (or (or (= ?yve ?yvd)
            (= ?yve ?yvc)
            )
          (= ?yvd ?yvc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yvf Real)
      (declare-const ?yvg Real)
      (declare-const ?yvh Real)
      (declare-const ?yvi Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?yvg ?yvf))
                  (not (= ?yvg ?asi))
                  )
                (not (= ?yvf ?asi))
                )
              (or (or (= ?yvi ?yvh)
                  (= ?yvi ?asi)
                  )
                (= ?yvh ?asi)
                )
              )
            (and (or (or (= ?yvg ?yvf)
                  (= ?yvg ?asi)
                  )
                (= ?yvf ?asi)
                )
              (and (and (not (= ?yvi ?yvh))
                  (not (= ?yvi ?asi))
                  )
                (not (= ?yvh ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yvj Real)
      (declare-const ?yvk Real)
      (declare-const ?yvl Real)
      (declare-const ?yvm Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?yvk ?yvj))
                  (not (= ?yvk ?fkf))
                  )
                (not (= ?yvj ?fkf))
                )
              (or (or (= ?yvm ?yvl)
                  (= ?yvm ?fkf)
                  )
                (= ?yvl ?fkf)
                )
              )
            (and (or (or (= ?yvk ?yvj)
                  (= ?yvk ?fkf)
                  )
                (= ?yvj ?fkf)
                )
              (and (and (not (= ?yvm ?yvl))
                  (not (= ?yvm ?fkf))
                  )
                (not (= ?yvl ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yvn Real)
      (declare-const ?yvo Real)
      (declare-const ?yvp Real)
      (declare-const ?yvq Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?yvo ?yvn))
                  (not (= ?yvo ?mzs))
                  )
                (not (= ?yvn ?mzs))
                )
              (or (or (= ?yvq ?yvp)
                  (= ?yvq ?mzs)
                  )
                (= ?yvp ?mzs)
                )
              )
            (and (or (or (= ?yvo ?yvn)
                  (= ?yvo ?mzs)
                  )
                (= ?yvn ?mzs)
                )
              (and (and (not (= ?yvq ?yvp))
                  (not (= ?yvq ?mzs))
                  )
                (not (= ?yvp ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?yvr Real)
    (declare-const ?yvs Real)
    (declare-const ?yvt Real)
    (declare-const ?yvu Real)
    (push 1)
      (declare-const ?yvv Real)
      (declare-const ?yvw Real)
      (declare-const ?yvx Real)
      (assert
        (or (or (= ?yvx ?yvw)
            (= ?yvx ?yvv)
            )
          (= ?yvw ?yvv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yvy Real)
      (declare-const ?yvz Real)
      (declare-const ?ywa Real)
      (declare-const ?ywb Real)
      (assert
        (or (or (= ?ywb ?ywa)
            (= ?ywb ?yvz)
            )
          (= ?ywa ?yvz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ywc Real)
      (declare-const ?ywd Real)
      (declare-const ?ywe Real)
      (declare-const ?ywf Real)
      (declare-const ?ywg Real)
      (assert
        (or (or (= ?ywg ?ywf)
            (= ?ywg ?ywe)
            )
          (= ?ywf ?ywe)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ywh Real)
      (declare-const ?ywi Real)
      (declare-const ?ywj Real)
      (declare-const ?ywk Real)
      (declare-const ?ywl Real)
      (declare-const ?ywm Real)
      (assert
        (and (and (and (not (= ?ywj ?ywi))
              (not (= ?ywj ?ywh))
              )
            (not (= ?ywi ?ywh))
            )
          (or (or (= ?ywm ?ywl)
              (= ?ywm ?ywk)
              )
            (= ?ywl ?ywk)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ywn Real)
      (declare-const ?ywo Real)
      (declare-const ?ywp Real)
      (assert
        (or (or (= ?ywp ?ywo)
            (= ?ywp ?ywn)
            )
          (= ?ywo ?ywn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ywq Real)
      (declare-const ?ywr Real)
      (declare-const ?yws Real)
      (assert
        (or (or (= ?yws ?ywr)
            (= ?yws ?ywq)
            )
          (= ?ywr ?ywq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ywt Real)
      (declare-const ?ywu Real)
      (declare-const ?ywv Real)
      (declare-const ?yww Real)
      (assert
        (or (or (= ?ywv ?ywu)
            (= ?ywv ?ywt)
            )
          (= ?ywu ?ywt)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ywx Real)
      (declare-const ?ywy Real)
      (declare-const ?ywz Real)
      (declare-const ?yxa Real)
      (declare-const ?yxb Real)
      (assert
        (or (or (= ?ywz ?ywy)
            (= ?ywz ?ywx)
            )
          (= ?ywy ?ywx)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yxc Real)
      (declare-const ?yxd Real)
      (declare-const ?yxe Real)
      (declare-const ?yxf Real)
      (declare-const ?yxg Real)
      (declare-const ?yxh Real)
      (assert
        (and (or (or (= ?yxe ?yxd)
              (= ?yxe ?yxc)
              )
            (= ?yxd ?yxc)
            )
          (and (and (not (= ?yxh ?yxg))
              (not (= ?yxh ?yxf))
              )
            (not (= ?yxg ?yxf))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yxi Real)
      (declare-const ?yxj Real)
      (declare-const ?yxk Real)
      (assert
        (or (or (= ?yxk ?yxj)
            (= ?yxk ?yxi)
            )
          (= ?yxj ?yxi)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yxl Real)
      (declare-const ?yxm Real)
      (declare-const ?yxn Real)
      (declare-const ?yxo Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?yxm ?yxl))
                  (not (= ?yxm ?asi))
                  )
                (not (= ?yxl ?asi))
                )
              (or (or (= ?yxo ?yxn)
                  (= ?yxo ?asi)
                  )
                (= ?yxn ?asi)
                )
              )
            (and (or (or (= ?yxm ?yxl)
                  (= ?yxm ?asi)
                  )
                (= ?yxl ?asi)
                )
              (and (and (not (= ?yxo ?yxn))
                  (not (= ?yxo ?asi))
                  )
                (not (= ?yxn ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yxp Real)
      (declare-const ?yxq Real)
      (declare-const ?yxr Real)
      (declare-const ?yxs Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?yxq ?yxp))
                  (not (= ?yxq ?fkf))
                  )
                (not (= ?yxp ?fkf))
                )
              (or (or (= ?yxs ?yxr)
                  (= ?yxs ?fkf)
                  )
                (= ?yxr ?fkf)
                )
              )
            (and (or (or (= ?yxq ?yxp)
                  (= ?yxq ?fkf)
                  )
                (= ?yxp ?fkf)
                )
              (and (and (not (= ?yxs ?yxr))
                  (not (= ?yxs ?fkf))
                  )
                (not (= ?yxr ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yxt Real)
      (declare-const ?yxu Real)
      (declare-const ?yxv Real)
      (declare-const ?yxw Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?yxu ?yxt))
                  (not (= ?yxu ?mzs))
                  )
                (not (= ?yxt ?mzs))
                )
              (or (or (= ?yxw ?yxv)
                  (= ?yxw ?mzs)
                  )
                (= ?yxv ?mzs)
                )
              )
            (and (or (or (= ?yxu ?yxt)
                  (= ?yxu ?mzs)
                  )
                (= ?yxt ?mzs)
                )
              (and (and (not (= ?yxw ?yxv))
                  (not (= ?yxw ?mzs))
                  )
                (not (= ?yxv ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?yxx Real)
    (push 1)
      (declare-const ?yxy Real)
      (declare-const ?yxz Real)
      (declare-const ?yya Real)
      (assert
        (or (or (= ?yya ?yxz)
            (= ?yya ?yxy)
            )
          (= ?yxz ?yxy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yyb Real)
      (declare-const ?yyc Real)
      (declare-const ?yyd Real)
      (declare-const ?yye Real)
      (assert
        (or (or (= ?yye ?yyd)
            (= ?yye ?yyc)
            )
          (= ?yyd ?yyc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yyf Real)
      (declare-const ?yyg Real)
      (declare-const ?yyh Real)
      (declare-const ?yyi Real)
      (declare-const ?yyj Real)
      (assert
        (or (or (= ?yyj ?yyi)
            (= ?yyj ?yyh)
            )
          (= ?yyi ?yyh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yyk Real)
      (declare-const ?yyl Real)
      (declare-const ?yym Real)
      (declare-const ?yyn Real)
      (declare-const ?yyo Real)
      (declare-const ?yyp Real)
      (assert
        (and (and (and (not (= ?yym ?yyl))
              (not (= ?yym ?yyk))
              )
            (not (= ?yyl ?yyk))
            )
          (or (or (= ?yyp ?yyo)
              (= ?yyp ?yyn)
              )
            (= ?yyo ?yyn)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yyq Real)
      (declare-const ?yyr Real)
      (declare-const ?yys Real)
      (assert
        (or (or (= ?yys ?yyr)
            (= ?yys ?yyq)
            )
          (= ?yyr ?yyq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yyt Real)
      (declare-const ?yyu Real)
      (declare-const ?yyv Real)
      (assert
        (or (or (= ?yyv ?yyu)
            (= ?yyv ?yyt)
            )
          (= ?yyu ?yyt)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yyw Real)
      (declare-const ?yyx Real)
      (declare-const ?yyy Real)
      (declare-const ?yyz Real)
      (assert
        (or (or (= ?yyy ?yyx)
            (= ?yyy ?yyw)
            )
          (= ?yyx ?yyw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yza Real)
      (declare-const ?yzb Real)
      (declare-const ?yzc Real)
      (declare-const ?yzd Real)
      (declare-const ?yze Real)
      (assert
        (or (or (= ?yzc ?yzb)
            (= ?yzc ?yza)
            )
          (= ?yzb ?yza)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yzf Real)
      (declare-const ?yzg Real)
      (declare-const ?yzh Real)
      (declare-const ?yzi Real)
      (declare-const ?yzj Real)
      (declare-const ?yzk Real)
      (assert
        (and (or (or (= ?yzh ?yzg)
              (= ?yzh ?yzf)
              )
            (= ?yzg ?yzf)
            )
          (and (and (not (= ?yzk ?yzj))
              (not (= ?yzk ?yzi))
              )
            (not (= ?yzj ?yzi))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yzl Real)
      (declare-const ?yzm Real)
      (declare-const ?yzn Real)
      (assert
        (or (or (= ?yzn ?yzm)
            (= ?yzn ?yzl)
            )
          (= ?yzm ?yzl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yzo Real)
      (declare-const ?yzp Real)
      (declare-const ?yzq Real)
      (declare-const ?yzr Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?yzp ?yzo))
                  (not (= ?yzp ?asi))
                  )
                (not (= ?yzo ?asi))
                )
              (or (or (= ?yzr ?yzq)
                  (= ?yzr ?asi)
                  )
                (= ?yzq ?asi)
                )
              )
            (and (or (or (= ?yzp ?yzo)
                  (= ?yzp ?asi)
                  )
                (= ?yzo ?asi)
                )
              (and (and (not (= ?yzr ?yzq))
                  (not (= ?yzr ?asi))
                  )
                (not (= ?yzq ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yzs Real)
      (declare-const ?yzt Real)
      (declare-const ?yzu Real)
      (declare-const ?yzv Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?yzt ?yzs))
                  (not (= ?yzt ?fkf))
                  )
                (not (= ?yzs ?fkf))
                )
              (or (or (= ?yzv ?yzu)
                  (= ?yzv ?fkf)
                  )
                (= ?yzu ?fkf)
                )
              )
            (and (or (or (= ?yzt ?yzs)
                  (= ?yzt ?fkf)
                  )
                (= ?yzs ?fkf)
                )
              (and (and (not (= ?yzv ?yzu))
                  (not (= ?yzv ?fkf))
                  )
                (not (= ?yzu ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?yzw Real)
      (declare-const ?yzx Real)
      (declare-const ?yzy Real)
      (declare-const ?yzz Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?yzx ?yzw))
                  (not (= ?yzx ?mzs))
                  )
                (not (= ?yzw ?mzs))
                )
              (or (or (= ?yzz ?yzy)
                  (= ?yzz ?mzs)
                  )
                (= ?yzy ?mzs)
                )
              )
            (and (or (or (= ?yzx ?yzw)
                  (= ?yzx ?mzs)
                  )
                (= ?yzw ?mzs)
                )
              (and (and (not (= ?yzz ?yzy))
                  (not (= ?yzz ?mzs))
                  )
                (not (= ?yzy ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?zaa Real)
    (declare-const ?zab Real)
    (push 1)
      (declare-const ?zac Real)
      (declare-const ?zad Real)
      (declare-const ?zae Real)
      (assert
        (or (or (= ?zae ?zad)
            (= ?zae ?zac)
            )
          (= ?zad ?zac)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zaf Real)
      (declare-const ?zag Real)
      (declare-const ?zah Real)
      (declare-const ?zai Real)
      (assert
        (or (or (= ?zai ?zah)
            (= ?zai ?zag)
            )
          (= ?zah ?zag)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zaj Real)
      (declare-const ?zak Real)
      (declare-const ?zal Real)
      (declare-const ?zam Real)
      (declare-const ?zan Real)
      (assert
        (or (or (= ?zan ?zam)
            (= ?zan ?zal)
            )
          (= ?zam ?zal)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zao Real)
      (declare-const ?zap Real)
      (declare-const ?zaq Real)
      (declare-const ?zar Real)
      (declare-const ?zas Real)
      (declare-const ?zat Real)
      (assert
        (and (and (and (not (= ?zaq ?zap))
              (not (= ?zaq ?zao))
              )
            (not (= ?zap ?zao))
            )
          (or (or (= ?zat ?zas)
              (= ?zat ?zar)
              )
            (= ?zas ?zar)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zau Real)
      (declare-const ?zav Real)
      (declare-const ?zaw Real)
      (assert
        (or (or (= ?zaw ?zav)
            (= ?zaw ?zau)
            )
          (= ?zav ?zau)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zax Real)
      (declare-const ?zay Real)
      (declare-const ?zaz Real)
      (assert
        (or (or (= ?zaz ?zay)
            (= ?zaz ?zax)
            )
          (= ?zay ?zax)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zba Real)
      (declare-const ?zbb Real)
      (declare-const ?zbc Real)
      (declare-const ?zbd Real)
      (assert
        (or (or (= ?zbc ?zbb)
            (= ?zbc ?zba)
            )
          (= ?zbb ?zba)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zbe Real)
      (declare-const ?zbf Real)
      (declare-const ?zbg Real)
      (declare-const ?zbh Real)
      (declare-const ?zbi Real)
      (assert
        (or (or (= ?zbg ?zbf)
            (= ?zbg ?zbe)
            )
          (= ?zbf ?zbe)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zbj Real)
      (declare-const ?zbk Real)
      (declare-const ?zbl Real)
      (declare-const ?zbm Real)
      (declare-const ?zbn Real)
      (declare-const ?zbo Real)
      (assert
        (and (or (or (= ?zbl ?zbk)
              (= ?zbl ?zbj)
              )
            (= ?zbk ?zbj)
            )
          (and (and (not (= ?zbo ?zbn))
              (not (= ?zbo ?zbm))
              )
            (not (= ?zbn ?zbm))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zbp Real)
      (declare-const ?zbq Real)
      (declare-const ?zbr Real)
      (assert
        (or (or (= ?zbr ?zbq)
            (= ?zbr ?zbp)
            )
          (= ?zbq ?zbp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zbs Real)
      (declare-const ?zbt Real)
      (declare-const ?zbu Real)
      (declare-const ?zbv Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?zbt ?zbs))
                  (not (= ?zbt ?asi))
                  )
                (not (= ?zbs ?asi))
                )
              (or (or (= ?zbv ?zbu)
                  (= ?zbv ?asi)
                  )
                (= ?zbu ?asi)
                )
              )
            (and (or (or (= ?zbt ?zbs)
                  (= ?zbt ?asi)
                  )
                (= ?zbs ?asi)
                )
              (and (and (not (= ?zbv ?zbu))
                  (not (= ?zbv ?asi))
                  )
                (not (= ?zbu ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zbw Real)
      (declare-const ?zbx Real)
      (declare-const ?zby Real)
      (declare-const ?zbz Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?zbx ?zbw))
                  (not (= ?zbx ?fkf))
                  )
                (not (= ?zbw ?fkf))
                )
              (or (or (= ?zbz ?zby)
                  (= ?zbz ?fkf)
                  )
                (= ?zby ?fkf)
                )
              )
            (and (or (or (= ?zbx ?zbw)
                  (= ?zbx ?fkf)
                  )
                (= ?zbw ?fkf)
                )
              (and (and (not (= ?zbz ?zby))
                  (not (= ?zbz ?fkf))
                  )
                (not (= ?zby ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zca Real)
      (declare-const ?zcb Real)
      (declare-const ?zcc Real)
      (declare-const ?zcd Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?zcb ?zca))
                  (not (= ?zcb ?mzs))
                  )
                (not (= ?zca ?mzs))
                )
              (or (or (= ?zcd ?zcc)
                  (= ?zcd ?mzs)
                  )
                (= ?zcc ?mzs)
                )
              )
            (and (or (or (= ?zcb ?zca)
                  (= ?zcb ?mzs)
                  )
                (= ?zca ?mzs)
                )
              (and (and (not (= ?zcd ?zcc))
                  (not (= ?zcd ?mzs))
                  )
                (not (= ?zcc ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?zce Real)
    (declare-const ?zcf Real)
    (declare-const ?zcg Real)
    (push 1)
      (declare-const ?zch Real)
      (declare-const ?zci Real)
      (declare-const ?zcj Real)
      (assert
        (or (or (= ?zcj ?zci)
            (= ?zcj ?zch)
            )
          (= ?zci ?zch)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zck Real)
      (declare-const ?zcl Real)
      (declare-const ?zcm Real)
      (declare-const ?zcn Real)
      (assert
        (or (or (= ?zcn ?zcm)
            (= ?zcn ?zcl)
            )
          (= ?zcm ?zcl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zco Real)
      (declare-const ?zcp Real)
      (declare-const ?zcq Real)
      (declare-const ?zcr Real)
      (declare-const ?zcs Real)
      (assert
        (or (or (= ?zcs ?zcr)
            (= ?zcs ?zcq)
            )
          (= ?zcr ?zcq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zct Real)
      (declare-const ?zcu Real)
      (declare-const ?zcv Real)
      (declare-const ?zcw Real)
      (declare-const ?zcx Real)
      (declare-const ?zcy Real)
      (assert
        (and (and (and (not (= ?zcv ?zcu))
              (not (= ?zcv ?zct))
              )
            (not (= ?zcu ?zct))
            )
          (or (or (= ?zcy ?zcx)
              (= ?zcy ?zcw)
              )
            (= ?zcx ?zcw)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zcz Real)
      (declare-const ?zda Real)
      (declare-const ?zdb Real)
      (assert
        (or (or (= ?zdb ?zda)
            (= ?zdb ?zcz)
            )
          (= ?zda ?zcz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zdc Real)
      (declare-const ?zdd Real)
      (declare-const ?zde Real)
      (assert
        (or (or (= ?zde ?zdd)
            (= ?zde ?zdc)
            )
          (= ?zdd ?zdc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zdf Real)
      (declare-const ?zdg Real)
      (declare-const ?zdh Real)
      (declare-const ?zdi Real)
      (assert
        (or (or (= ?zdh ?zdg)
            (= ?zdh ?zdf)
            )
          (= ?zdg ?zdf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zdj Real)
      (declare-const ?zdk Real)
      (declare-const ?zdl Real)
      (declare-const ?zdm Real)
      (declare-const ?zdn Real)
      (assert
        (or (or (= ?zdl ?zdk)
            (= ?zdl ?zdj)
            )
          (= ?zdk ?zdj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zdo Real)
      (declare-const ?zdp Real)
      (declare-const ?zdq Real)
      (declare-const ?zdr Real)
      (declare-const ?zds Real)
      (declare-const ?zdt Real)
      (assert
        (and (or (or (= ?zdq ?zdp)
              (= ?zdq ?zdo)
              )
            (= ?zdp ?zdo)
            )
          (and (and (not (= ?zdt ?zds))
              (not (= ?zdt ?zdr))
              )
            (not (= ?zds ?zdr))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zdu Real)
      (declare-const ?zdv Real)
      (declare-const ?zdw Real)
      (assert
        (or (or (= ?zdw ?zdv)
            (= ?zdw ?zdu)
            )
          (= ?zdv ?zdu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zdx Real)
      (declare-const ?zdy Real)
      (declare-const ?zdz Real)
      (declare-const ?zea Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?zdy ?zdx))
                  (not (= ?zdy ?asi))
                  )
                (not (= ?zdx ?asi))
                )
              (or (or (= ?zea ?zdz)
                  (= ?zea ?asi)
                  )
                (= ?zdz ?asi)
                )
              )
            (and (or (or (= ?zdy ?zdx)
                  (= ?zdy ?asi)
                  )
                (= ?zdx ?asi)
                )
              (and (and (not (= ?zea ?zdz))
                  (not (= ?zea ?asi))
                  )
                (not (= ?zdz ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zeb Real)
      (declare-const ?zec Real)
      (declare-const ?zed Real)
      (declare-const ?zee Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?zec ?zeb))
                  (not (= ?zec ?fkf))
                  )
                (not (= ?zeb ?fkf))
                )
              (or (or (= ?zee ?zed)
                  (= ?zee ?fkf)
                  )
                (= ?zed ?fkf)
                )
              )
            (and (or (or (= ?zec ?zeb)
                  (= ?zec ?fkf)
                  )
                (= ?zeb ?fkf)
                )
              (and (and (not (= ?zee ?zed))
                  (not (= ?zee ?fkf))
                  )
                (not (= ?zed ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zef Real)
      (declare-const ?zeg Real)
      (declare-const ?zeh Real)
      (declare-const ?zei Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?zeg ?zef))
                  (not (= ?zeg ?mzs))
                  )
                (not (= ?zef ?mzs))
                )
              (or (or (= ?zei ?zeh)
                  (= ?zei ?mzs)
                  )
                (= ?zeh ?mzs)
                )
              )
            (and (or (or (= ?zeg ?zef)
                  (= ?zeg ?mzs)
                  )
                (= ?zef ?mzs)
                )
              (and (and (not (= ?zei ?zeh))
                  (not (= ?zei ?mzs))
                  )
                (not (= ?zeh ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (exists ((?asi Real) )(or (and (and (and (not (= ?zcf ?zce))
                      (not (= ?zcf ?asi))
                      )
                    (not (= ?zce ?asi))
                    )
                  (or (or (= ?zcg ?zce)
                      (= ?zcg ?asi)
                      )
                    (= ?zce ?asi)
                    )
                  )
                (and (or (or (= ?zcf ?zce)
                      (= ?zcf ?asi)
                      )
                    (= ?zce ?asi)
                    )
                  (and (and (not (= ?zcg ?zce))
                      (not (= ?zcg ?asi))
                      )
                    (not (= ?zce ?asi))
                    )
                  )
                )
              )
            (exists ((?fkf Real) )(or (and (and (and (not (= ?zcf ?zce))
                      (not (= ?zcf ?fkf))
                      )
                    (not (= ?zce ?fkf))
                    )
                  (or (or (= ?zcg ?zce)
                      (= ?zcg ?fkf)
                      )
                    (= ?zce ?fkf)
                    )
                  )
                (and (or (or (= ?zcf ?zce)
                      (= ?zcf ?fkf)
                      )
                    (= ?zce ?fkf)
                    )
                  (and (and (not (= ?zcg ?zce))
                      (not (= ?zcg ?fkf))
                      )
                    (not (= ?zce ?fkf))
                    )
                  )
                )
              )
            )
          (exists ((?mzs Real) )(or (and (and (and (not (= ?zcf ?zce))
                    (not (= ?zcf ?mzs))
                    )
                  (not (= ?zce ?mzs))
                  )
                (or (or (= ?zcg ?zce)
                    (= ?zcg ?mzs)
                    )
                  (= ?zce ?mzs)
                  )
                )
              (and (or (or (= ?zcf ?zce)
                    (= ?zcf ?mzs)
                    )
                  (= ?zce ?mzs)
                  )
                (and (and (not (= ?zcg ?zce))
                    (not (= ?zcg ?mzs))
                    )
                  (not (= ?zce ?mzs))
                  )
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?zej Real)
    (declare-const ?zek Real)
    (declare-const ?zel Real)
    (declare-const ?zem Real)
    (push 1)
      (declare-const ?zen Real)
      (declare-const ?zeo Real)
      (declare-const ?zep Real)
      (assert
        (or (or (= ?zep ?zeo)
            (= ?zep ?zen)
            )
          (= ?zeo ?zen)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zeq Real)
      (declare-const ?zer Real)
      (declare-const ?zes Real)
      (declare-const ?zet Real)
      (assert
        (or (or (= ?zet ?zes)
            (= ?zet ?zer)
            )
          (= ?zes ?zer)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zeu Real)
      (declare-const ?zev Real)
      (declare-const ?zew Real)
      (declare-const ?zex Real)
      (declare-const ?zey Real)
      (assert
        (or (or (= ?zey ?zex)
            (= ?zey ?zew)
            )
          (= ?zex ?zew)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zez Real)
      (declare-const ?zfa Real)
      (declare-const ?zfb Real)
      (declare-const ?zfc Real)
      (declare-const ?zfd Real)
      (declare-const ?zfe Real)
      (assert
        (and (and (and (not (= ?zfb ?zfa))
              (not (= ?zfb ?zez))
              )
            (not (= ?zfa ?zez))
            )
          (or (or (= ?zfe ?zfd)
              (= ?zfe ?zfc)
              )
            (= ?zfd ?zfc)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zff Real)
      (declare-const ?zfg Real)
      (declare-const ?zfh Real)
      (assert
        (or (or (= ?zfh ?zfg)
            (= ?zfh ?zff)
            )
          (= ?zfg ?zff)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zfi Real)
      (declare-const ?zfj Real)
      (declare-const ?zfk Real)
      (assert
        (or (or (= ?zfk ?zfj)
            (= ?zfk ?zfi)
            )
          (= ?zfj ?zfi)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zfl Real)
      (declare-const ?zfm Real)
      (declare-const ?zfn Real)
      (declare-const ?zfo Real)
      (assert
        (or (or (= ?zfn ?zfm)
            (= ?zfn ?zfl)
            )
          (= ?zfm ?zfl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zfp Real)
      (declare-const ?zfq Real)
      (declare-const ?zfr Real)
      (declare-const ?zfs Real)
      (declare-const ?zft Real)
      (assert
        (or (or (= ?zfr ?zfq)
            (= ?zfr ?zfp)
            )
          (= ?zfq ?zfp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zfu Real)
      (declare-const ?zfv Real)
      (declare-const ?zfw Real)
      (declare-const ?zfx Real)
      (declare-const ?zfy Real)
      (declare-const ?zfz Real)
      (assert
        (and (or (or (= ?zfw ?zfv)
              (= ?zfw ?zfu)
              )
            (= ?zfv ?zfu)
            )
          (and (and (not (= ?zfz ?zfy))
              (not (= ?zfz ?zfx))
              )
            (not (= ?zfy ?zfx))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zga Real)
      (declare-const ?zgb Real)
      (declare-const ?zgc Real)
      (assert
        (or (or (= ?zgc ?zgb)
            (= ?zgc ?zga)
            )
          (= ?zgb ?zga)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zgd Real)
      (declare-const ?zge Real)
      (declare-const ?zgf Real)
      (declare-const ?zgg Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?zge ?zgd))
                  (not (= ?zge ?asi))
                  )
                (not (= ?zgd ?asi))
                )
              (or (or (= ?zgg ?zgf)
                  (= ?zgg ?asi)
                  )
                (= ?zgf ?asi)
                )
              )
            (and (or (or (= ?zge ?zgd)
                  (= ?zge ?asi)
                  )
                (= ?zgd ?asi)
                )
              (and (and (not (= ?zgg ?zgf))
                  (not (= ?zgg ?asi))
                  )
                (not (= ?zgf ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zgh Real)
      (declare-const ?zgi Real)
      (declare-const ?zgj Real)
      (declare-const ?zgk Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?zgi ?zgh))
                  (not (= ?zgi ?fkf))
                  )
                (not (= ?zgh ?fkf))
                )
              (or (or (= ?zgk ?zgj)
                  (= ?zgk ?fkf)
                  )
                (= ?zgj ?fkf)
                )
              )
            (and (or (or (= ?zgi ?zgh)
                  (= ?zgi ?fkf)
                  )
                (= ?zgh ?fkf)
                )
              (and (and (not (= ?zgk ?zgj))
                  (not (= ?zgk ?fkf))
                  )
                (not (= ?zgj ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zgl Real)
      (declare-const ?zgm Real)
      (declare-const ?zgn Real)
      (declare-const ?zgo Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?zgm ?zgl))
                  (not (= ?zgm ?mzs))
                  )
                (not (= ?zgl ?mzs))
                )
              (or (or (= ?zgo ?zgn)
                  (= ?zgo ?mzs)
                  )
                (= ?zgn ?mzs)
                )
              )
            (and (or (or (= ?zgm ?zgl)
                  (= ?zgm ?mzs)
                  )
                (= ?zgl ?mzs)
                )
              (and (and (not (= ?zgo ?zgn))
                  (not (= ?zgo ?mzs))
                  )
                (not (= ?zgn ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?zgp Real)
    (declare-const ?zgq Real)
    (declare-const ?zgr Real)
    (declare-const ?zgs Real)
    (declare-const ?zgt Real)
    (push 1)
      (declare-const ?zgu Real)
      (declare-const ?zgv Real)
      (declare-const ?zgw Real)
      (assert
        (or (or (= ?zgw ?zgv)
            (= ?zgw ?zgu)
            )
          (= ?zgv ?zgu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zgx Real)
      (declare-const ?zgy Real)
      (declare-const ?zgz Real)
      (declare-const ?zha Real)
      (assert
        (or (or (= ?zha ?zgz)
            (= ?zha ?zgy)
            )
          (= ?zgz ?zgy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zhb Real)
      (declare-const ?zhc Real)
      (declare-const ?zhd Real)
      (declare-const ?zhe Real)
      (declare-const ?zhf Real)
      (assert
        (or (or (= ?zhf ?zhe)
            (= ?zhf ?zhd)
            )
          (= ?zhe ?zhd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zhg Real)
      (declare-const ?zhh Real)
      (declare-const ?zhi Real)
      (declare-const ?zhj Real)
      (declare-const ?zhk Real)
      (declare-const ?zhl Real)
      (assert
        (and (and (and (not (= ?zhi ?zhh))
              (not (= ?zhi ?zhg))
              )
            (not (= ?zhh ?zhg))
            )
          (or (or (= ?zhl ?zhk)
              (= ?zhl ?zhj)
              )
            (= ?zhk ?zhj)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zhm Real)
      (declare-const ?zhn Real)
      (declare-const ?zho Real)
      (assert
        (or (or (= ?zho ?zhn)
            (= ?zho ?zhm)
            )
          (= ?zhn ?zhm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zhp Real)
      (declare-const ?zhq Real)
      (declare-const ?zhr Real)
      (assert
        (or (or (= ?zhr ?zhq)
            (= ?zhr ?zhp)
            )
          (= ?zhq ?zhp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zhs Real)
      (declare-const ?zht Real)
      (declare-const ?zhu Real)
      (declare-const ?zhv Real)
      (assert
        (or (or (= ?zhu ?zht)
            (= ?zhu ?zhs)
            )
          (= ?zht ?zhs)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zhw Real)
      (declare-const ?zhx Real)
      (declare-const ?zhy Real)
      (declare-const ?zhz Real)
      (declare-const ?zia Real)
      (assert
        (or (or (= ?zhy ?zhx)
            (= ?zhy ?zhw)
            )
          (= ?zhx ?zhw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zib Real)
      (declare-const ?zic Real)
      (declare-const ?zid Real)
      (declare-const ?zie Real)
      (declare-const ?zif Real)
      (declare-const ?zig Real)
      (assert
        (and (or (or (= ?zid ?zic)
              (= ?zid ?zib)
              )
            (= ?zic ?zib)
            )
          (and (and (not (= ?zig ?zif))
              (not (= ?zig ?zie))
              )
            (not (= ?zif ?zie))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zih Real)
      (declare-const ?zii Real)
      (declare-const ?zij Real)
      (assert
        (or (or (= ?zij ?zii)
            (= ?zij ?zih)
            )
          (= ?zii ?zih)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zik Real)
      (declare-const ?zil Real)
      (declare-const ?zim Real)
      (declare-const ?zin Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?zil ?zik))
                  (not (= ?zil ?asi))
                  )
                (not (= ?zik ?asi))
                )
              (or (or (= ?zin ?zim)
                  (= ?zin ?asi)
                  )
                (= ?zim ?asi)
                )
              )
            (and (or (or (= ?zil ?zik)
                  (= ?zil ?asi)
                  )
                (= ?zik ?asi)
                )
              (and (and (not (= ?zin ?zim))
                  (not (= ?zin ?asi))
                  )
                (not (= ?zim ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zio Real)
      (declare-const ?zip Real)
      (declare-const ?ziq Real)
      (declare-const ?zir Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?zip ?zio))
                  (not (= ?zip ?fkf))
                  )
                (not (= ?zio ?fkf))
                )
              (or (or (= ?zir ?ziq)
                  (= ?zir ?fkf)
                  )
                (= ?ziq ?fkf)
                )
              )
            (and (or (or (= ?zip ?zio)
                  (= ?zip ?fkf)
                  )
                (= ?zio ?fkf)
                )
              (and (and (not (= ?zir ?ziq))
                  (not (= ?zir ?fkf))
                  )
                (not (= ?ziq ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zis Real)
      (declare-const ?zit Real)
      (declare-const ?ziu Real)
      (declare-const ?ziv Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?zit ?zis))
                  (not (= ?zit ?mzs))
                  )
                (not (= ?zis ?mzs))
                )
              (or (or (= ?ziv ?ziu)
                  (= ?ziv ?mzs)
                  )
                (= ?ziu ?mzs)
                )
              )
            (and (or (or (= ?zit ?zis)
                  (= ?zit ?mzs)
                  )
                (= ?zis ?mzs)
                )
              (and (and (not (= ?ziv ?ziu))
                  (not (= ?ziv ?mzs))
                  )
                (not (= ?ziu ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?ziw Real)
    (declare-const ?zix Real)
    (push 1)
      (declare-const ?ziy Real)
      (declare-const ?ziz Real)
      (declare-const ?zja Real)
      (assert
        (or (or (= ?zja ?ziz)
            (= ?zja ?ziy)
            )
          (= ?ziz ?ziy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zjb Real)
      (declare-const ?zjc Real)
      (declare-const ?zjd Real)
      (declare-const ?zje Real)
      (assert
        (or (or (= ?zje ?zjd)
            (= ?zje ?zjc)
            )
          (= ?zjd ?zjc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zjf Real)
      (declare-const ?zjg Real)
      (declare-const ?zjh Real)
      (declare-const ?zji Real)
      (declare-const ?zjj Real)
      (assert
        (or (or (= ?zjj ?zji)
            (= ?zjj ?zjh)
            )
          (= ?zji ?zjh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zjk Real)
      (declare-const ?zjl Real)
      (declare-const ?zjm Real)
      (declare-const ?zjn Real)
      (declare-const ?zjo Real)
      (declare-const ?zjp Real)
      (assert
        (and (and (and (not (= ?zjm ?zjl))
              (not (= ?zjm ?zjk))
              )
            (not (= ?zjl ?zjk))
            )
          (or (or (= ?zjp ?zjo)
              (= ?zjp ?zjn)
              )
            (= ?zjo ?zjn)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zjq Real)
      (declare-const ?zjr Real)
      (declare-const ?zjs Real)
      (assert
        (or (or (= ?zjs ?zjr)
            (= ?zjs ?zjq)
            )
          (= ?zjr ?zjq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zjt Real)
      (declare-const ?zju Real)
      (declare-const ?zjv Real)
      (assert
        (or (or (= ?zjv ?zju)
            (= ?zjv ?zjt)
            )
          (= ?zju ?zjt)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zjw Real)
      (declare-const ?zjx Real)
      (declare-const ?zjy Real)
      (declare-const ?zjz Real)
      (assert
        (or (or (= ?zjy ?zjx)
            (= ?zjy ?zjw)
            )
          (= ?zjx ?zjw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zka Real)
      (declare-const ?zkb Real)
      (declare-const ?zkc Real)
      (declare-const ?zkd Real)
      (declare-const ?zke Real)
      (assert
        (or (or (= ?zkc ?zkb)
            (= ?zkc ?zka)
            )
          (= ?zkb ?zka)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zkf Real)
      (declare-const ?zkg Real)
      (declare-const ?zkh Real)
      (declare-const ?zki Real)
      (declare-const ?zkj Real)
      (declare-const ?zkk Real)
      (assert
        (and (or (or (= ?zkh ?zkg)
              (= ?zkh ?zkf)
              )
            (= ?zkg ?zkf)
            )
          (and (and (not (= ?zkk ?zkj))
              (not (= ?zkk ?zki))
              )
            (not (= ?zkj ?zki))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zkl Real)
      (declare-const ?zkm Real)
      (declare-const ?zkn Real)
      (assert
        (or (or (= ?zkn ?zkm)
            (= ?zkn ?zkl)
            )
          (= ?zkm ?zkl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zko Real)
      (declare-const ?zkp Real)
      (declare-const ?zkq Real)
      (declare-const ?zkr Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?zkp ?zko))
                  (not (= ?zkp ?asi))
                  )
                (not (= ?zko ?asi))
                )
              (or (or (= ?zkr ?zkq)
                  (= ?zkr ?asi)
                  )
                (= ?zkq ?asi)
                )
              )
            (and (or (or (= ?zkp ?zko)
                  (= ?zkp ?asi)
                  )
                (= ?zko ?asi)
                )
              (and (and (not (= ?zkr ?zkq))
                  (not (= ?zkr ?asi))
                  )
                (not (= ?zkq ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zks Real)
      (declare-const ?zkt Real)
      (declare-const ?zku Real)
      (declare-const ?zkv Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?zkt ?zks))
                  (not (= ?zkt ?fkf))
                  )
                (not (= ?zks ?fkf))
                )
              (or (or (= ?zkv ?zku)
                  (= ?zkv ?fkf)
                  )
                (= ?zku ?fkf)
                )
              )
            (and (or (or (= ?zkt ?zks)
                  (= ?zkt ?fkf)
                  )
                (= ?zks ?fkf)
                )
              (and (and (not (= ?zkv ?zku))
                  (not (= ?zkv ?fkf))
                  )
                (not (= ?zku ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zkw Real)
      (declare-const ?zkx Real)
      (declare-const ?zky Real)
      (declare-const ?zkz Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?zkx ?zkw))
                  (not (= ?zkx ?mzs))
                  )
                (not (= ?zkw ?mzs))
                )
              (or (or (= ?zkz ?zky)
                  (= ?zkz ?mzs)
                  )
                (= ?zky ?mzs)
                )
              )
            (and (or (or (= ?zkx ?zkw)
                  (= ?zkx ?mzs)
                  )
                (= ?zkw ?mzs)
                )
              (and (and (not (= ?zkz ?zky))
                  (not (= ?zkz ?mzs))
                  )
                (not (= ?zky ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?zla Real)
    (declare-const ?zlb Real)
    (declare-const ?zlc Real)
    (push 1)
      (declare-const ?zld Real)
      (declare-const ?zle Real)
      (declare-const ?zlf Real)
      (assert
        (or (or (= ?zlf ?zle)
            (= ?zlf ?zld)
            )
          (= ?zle ?zld)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zlg Real)
      (declare-const ?zlh Real)
      (declare-const ?zli Real)
      (declare-const ?zlj Real)
      (assert
        (or (or (= ?zlj ?zli)
            (= ?zlj ?zlh)
            )
          (= ?zli ?zlh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zlk Real)
      (declare-const ?zll Real)
      (declare-const ?zlm Real)
      (declare-const ?zln Real)
      (declare-const ?zlo Real)
      (assert
        (or (or (= ?zlo ?zln)
            (= ?zlo ?zlm)
            )
          (= ?zln ?zlm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zlp Real)
      (declare-const ?zlq Real)
      (declare-const ?zlr Real)
      (declare-const ?zls Real)
      (declare-const ?zlt Real)
      (declare-const ?zlu Real)
      (assert
        (and (and (and (not (= ?zlr ?zlq))
              (not (= ?zlr ?zlp))
              )
            (not (= ?zlq ?zlp))
            )
          (or (or (= ?zlu ?zlt)
              (= ?zlu ?zls)
              )
            (= ?zlt ?zls)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zlv Real)
      (declare-const ?zlw Real)
      (declare-const ?zlx Real)
      (assert
        (or (or (= ?zlx ?zlw)
            (= ?zlx ?zlv)
            )
          (= ?zlw ?zlv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zly Real)
      (declare-const ?zlz Real)
      (declare-const ?zma Real)
      (assert
        (or (or (= ?zma ?zlz)
            (= ?zma ?zly)
            )
          (= ?zlz ?zly)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zmb Real)
      (declare-const ?zmc Real)
      (declare-const ?zmd Real)
      (declare-const ?zme Real)
      (assert
        (or (or (= ?zmd ?zmc)
            (= ?zmd ?zmb)
            )
          (= ?zmc ?zmb)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zmf Real)
      (declare-const ?zmg Real)
      (declare-const ?zmh Real)
      (declare-const ?zmi Real)
      (declare-const ?zmj Real)
      (assert
        (or (or (= ?zmh ?zmg)
            (= ?zmh ?zmf)
            )
          (= ?zmg ?zmf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zmk Real)
      (declare-const ?zml Real)
      (declare-const ?zmm Real)
      (declare-const ?zmn Real)
      (declare-const ?zmo Real)
      (declare-const ?zmp Real)
      (assert
        (and (or (or (= ?zmm ?zml)
              (= ?zmm ?zmk)
              )
            (= ?zml ?zmk)
            )
          (and (and (not (= ?zmp ?zmo))
              (not (= ?zmp ?zmn))
              )
            (not (= ?zmo ?zmn))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zmq Real)
      (declare-const ?zmr Real)
      (declare-const ?zms Real)
      (assert
        (or (or (= ?zms ?zmr)
            (= ?zms ?zmq)
            )
          (= ?zmr ?zmq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zmt Real)
      (declare-const ?zmu Real)
      (declare-const ?zmv Real)
      (declare-const ?zmw Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?zmu ?zmt))
                  (not (= ?zmu ?asi))
                  )
                (not (= ?zmt ?asi))
                )
              (or (or (= ?zmw ?zmv)
                  (= ?zmw ?asi)
                  )
                (= ?zmv ?asi)
                )
              )
            (and (or (or (= ?zmu ?zmt)
                  (= ?zmu ?asi)
                  )
                (= ?zmt ?asi)
                )
              (and (and (not (= ?zmw ?zmv))
                  (not (= ?zmw ?asi))
                  )
                (not (= ?zmv ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zmx Real)
      (declare-const ?zmy Real)
      (declare-const ?zmz Real)
      (declare-const ?zna Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?zmy ?zmx))
                  (not (= ?zmy ?fkf))
                  )
                (not (= ?zmx ?fkf))
                )
              (or (or (= ?zna ?zmz)
                  (= ?zna ?fkf)
                  )
                (= ?zmz ?fkf)
                )
              )
            (and (or (or (= ?zmy ?zmx)
                  (= ?zmy ?fkf)
                  )
                (= ?zmx ?fkf)
                )
              (and (and (not (= ?zna ?zmz))
                  (not (= ?zna ?fkf))
                  )
                (not (= ?zmz ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?znb Real)
      (declare-const ?znc Real)
      (declare-const ?znd Real)
      (declare-const ?zne Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?znc ?znb))
                  (not (= ?znc ?mzs))
                  )
                (not (= ?znb ?mzs))
                )
              (or (or (= ?zne ?znd)
                  (= ?zne ?mzs)
                  )
                (= ?znd ?mzs)
                )
              )
            (and (or (or (= ?znc ?znb)
                  (= ?znc ?mzs)
                  )
                (= ?znb ?mzs)
                )
              (and (and (not (= ?zne ?znd))
                  (not (= ?zne ?mzs))
                  )
                (not (= ?znd ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?znf Real)
    (declare-const ?zng Real)
    (declare-const ?znh Real)
    (declare-const ?zni Real)
    (push 1)
      (declare-const ?znj Real)
      (declare-const ?znk Real)
      (declare-const ?znl Real)
      (assert
        (or (or (= ?znl ?znk)
            (= ?znl ?znj)
            )
          (= ?znk ?znj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?znm Real)
      (declare-const ?znn Real)
      (declare-const ?zno Real)
      (declare-const ?znp Real)
      (assert
        (or (or (= ?znp ?zno)
            (= ?znp ?znn)
            )
          (= ?zno ?znn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?znq Real)
      (declare-const ?znr Real)
      (declare-const ?zns Real)
      (declare-const ?znt Real)
      (declare-const ?znu Real)
      (assert
        (or (or (= ?znu ?znt)
            (= ?znu ?zns)
            )
          (= ?znt ?zns)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?znv Real)
      (declare-const ?znw Real)
      (declare-const ?znx Real)
      (declare-const ?zny Real)
      (declare-const ?znz Real)
      (declare-const ?zoa Real)
      (assert
        (and (and (and (not (= ?znx ?znw))
              (not (= ?znx ?znv))
              )
            (not (= ?znw ?znv))
            )
          (or (or (= ?zoa ?znz)
              (= ?zoa ?zny)
              )
            (= ?znz ?zny)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zob Real)
      (declare-const ?zoc Real)
      (declare-const ?zod Real)
      (assert
        (or (or (= ?zod ?zoc)
            (= ?zod ?zob)
            )
          (= ?zoc ?zob)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zoe Real)
      (declare-const ?zof Real)
      (declare-const ?zog Real)
      (assert
        (or (or (= ?zog ?zof)
            (= ?zog ?zoe)
            )
          (= ?zof ?zoe)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zoh Real)
      (declare-const ?zoi Real)
      (declare-const ?zoj Real)
      (declare-const ?zok Real)
      (assert
        (or (or (= ?zoj ?zoi)
            (= ?zoj ?zoh)
            )
          (= ?zoi ?zoh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zol Real)
      (declare-const ?zom Real)
      (declare-const ?zon Real)
      (declare-const ?zoo Real)
      (declare-const ?zop Real)
      (assert
        (or (or (= ?zon ?zom)
            (= ?zon ?zol)
            )
          (= ?zom ?zol)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zoq Real)
      (declare-const ?zor Real)
      (declare-const ?zos Real)
      (declare-const ?zot Real)
      (declare-const ?zou Real)
      (declare-const ?zov Real)
      (assert
        (and (or (or (= ?zos ?zor)
              (= ?zos ?zoq)
              )
            (= ?zor ?zoq)
            )
          (and (and (not (= ?zov ?zou))
              (not (= ?zov ?zot))
              )
            (not (= ?zou ?zot))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zow Real)
      (declare-const ?zox Real)
      (declare-const ?zoy Real)
      (assert
        (or (or (= ?zoy ?zox)
            (= ?zoy ?zow)
            )
          (= ?zox ?zow)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zoz Real)
      (declare-const ?zpa Real)
      (declare-const ?zpb Real)
      (declare-const ?zpc Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?zpa ?zoz))
                  (not (= ?zpa ?asi))
                  )
                (not (= ?zoz ?asi))
                )
              (or (or (= ?zpc ?zpb)
                  (= ?zpc ?asi)
                  )
                (= ?zpb ?asi)
                )
              )
            (and (or (or (= ?zpa ?zoz)
                  (= ?zpa ?asi)
                  )
                (= ?zoz ?asi)
                )
              (and (and (not (= ?zpc ?zpb))
                  (not (= ?zpc ?asi))
                  )
                (not (= ?zpb ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zpd Real)
      (declare-const ?zpe Real)
      (declare-const ?zpf Real)
      (declare-const ?zpg Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?zpe ?zpd))
                  (not (= ?zpe ?fkf))
                  )
                (not (= ?zpd ?fkf))
                )
              (or (or (= ?zpg ?zpf)
                  (= ?zpg ?fkf)
                  )
                (= ?zpf ?fkf)
                )
              )
            (and (or (or (= ?zpe ?zpd)
                  (= ?zpe ?fkf)
                  )
                (= ?zpd ?fkf)
                )
              (and (and (not (= ?zpg ?zpf))
                  (not (= ?zpg ?fkf))
                  )
                (not (= ?zpf ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zph Real)
      (declare-const ?zpi Real)
      (declare-const ?zpj Real)
      (declare-const ?zpk Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?zpi ?zph))
                  (not (= ?zpi ?mzs))
                  )
                (not (= ?zph ?mzs))
                )
              (or (or (= ?zpk ?zpj)
                  (= ?zpk ?mzs)
                  )
                (= ?zpj ?mzs)
                )
              )
            (and (or (or (= ?zpi ?zph)
                  (= ?zpi ?mzs)
                  )
                (= ?zph ?mzs)
                )
              (and (and (not (= ?zpk ?zpj))
                  (not (= ?zpk ?mzs))
                  )
                (not (= ?zpj ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?zpl Real)
    (declare-const ?zpm Real)
    (declare-const ?zpn Real)
    (declare-const ?zpo Real)
    (declare-const ?zpp Real)
    (push 1)
      (declare-const ?zpq Real)
      (declare-const ?zpr Real)
      (declare-const ?zps Real)
      (assert
        (or (or (= ?zps ?zpr)
            (= ?zps ?zpq)
            )
          (= ?zpr ?zpq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zpt Real)
      (declare-const ?zpu Real)
      (declare-const ?zpv Real)
      (declare-const ?zpw Real)
      (assert
        (or (or (= ?zpw ?zpv)
            (= ?zpw ?zpu)
            )
          (= ?zpv ?zpu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zpx Real)
      (declare-const ?zpy Real)
      (declare-const ?zpz Real)
      (declare-const ?zqa Real)
      (declare-const ?zqb Real)
      (assert
        (or (or (= ?zqb ?zqa)
            (= ?zqb ?zpz)
            )
          (= ?zqa ?zpz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zqc Real)
      (declare-const ?zqd Real)
      (declare-const ?zqe Real)
      (declare-const ?zqf Real)
      (declare-const ?zqg Real)
      (declare-const ?zqh Real)
      (assert
        (and (and (and (not (= ?zqe ?zqd))
              (not (= ?zqe ?zqc))
              )
            (not (= ?zqd ?zqc))
            )
          (or (or (= ?zqh ?zqg)
              (= ?zqh ?zqf)
              )
            (= ?zqg ?zqf)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zqi Real)
      (declare-const ?zqj Real)
      (declare-const ?zqk Real)
      (assert
        (or (or (= ?zqk ?zqj)
            (= ?zqk ?zqi)
            )
          (= ?zqj ?zqi)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zql Real)
      (declare-const ?zqm Real)
      (declare-const ?zqn Real)
      (assert
        (or (or (= ?zqn ?zqm)
            (= ?zqn ?zql)
            )
          (= ?zqm ?zql)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zqo Real)
      (declare-const ?zqp Real)
      (declare-const ?zqq Real)
      (declare-const ?zqr Real)
      (assert
        (or (or (= ?zqq ?zqp)
            (= ?zqq ?zqo)
            )
          (= ?zqp ?zqo)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zqs Real)
      (declare-const ?zqt Real)
      (declare-const ?zqu Real)
      (declare-const ?zqv Real)
      (declare-const ?zqw Real)
      (assert
        (or (or (= ?zqu ?zqt)
            (= ?zqu ?zqs)
            )
          (= ?zqt ?zqs)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zqx Real)
      (declare-const ?zqy Real)
      (declare-const ?zqz Real)
      (declare-const ?zra Real)
      (declare-const ?zrb Real)
      (declare-const ?zrc Real)
      (assert
        (and (or (or (= ?zqz ?zqy)
              (= ?zqz ?zqx)
              )
            (= ?zqy ?zqx)
            )
          (and (and (not (= ?zrc ?zrb))
              (not (= ?zrc ?zra))
              )
            (not (= ?zrb ?zra))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zrd Real)
      (declare-const ?zre Real)
      (declare-const ?zrf Real)
      (assert
        (or (or (= ?zrf ?zre)
            (= ?zrf ?zrd)
            )
          (= ?zre ?zrd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zrg Real)
      (declare-const ?zrh Real)
      (declare-const ?zri Real)
      (declare-const ?zrj Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?zrh ?zrg))
                  (not (= ?zrh ?asi))
                  )
                (not (= ?zrg ?asi))
                )
              (or (or (= ?zrj ?zri)
                  (= ?zrj ?asi)
                  )
                (= ?zri ?asi)
                )
              )
            (and (or (or (= ?zrh ?zrg)
                  (= ?zrh ?asi)
                  )
                (= ?zrg ?asi)
                )
              (and (and (not (= ?zrj ?zri))
                  (not (= ?zrj ?asi))
                  )
                (not (= ?zri ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zrk Real)
      (declare-const ?zrl Real)
      (declare-const ?zrm Real)
      (declare-const ?zrn Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?zrl ?zrk))
                  (not (= ?zrl ?fkf))
                  )
                (not (= ?zrk ?fkf))
                )
              (or (or (= ?zrn ?zrm)
                  (= ?zrn ?fkf)
                  )
                (= ?zrm ?fkf)
                )
              )
            (and (or (or (= ?zrl ?zrk)
                  (= ?zrl ?fkf)
                  )
                (= ?zrk ?fkf)
                )
              (and (and (not (= ?zrn ?zrm))
                  (not (= ?zrn ?fkf))
                  )
                (not (= ?zrm ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zro Real)
      (declare-const ?zrp Real)
      (declare-const ?zrq Real)
      (declare-const ?zrr Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?zrp ?zro))
                  (not (= ?zrp ?mzs))
                  )
                (not (= ?zro ?mzs))
                )
              (or (or (= ?zrr ?zrq)
                  (= ?zrr ?mzs)
                  )
                (= ?zrq ?mzs)
                )
              )
            (and (or (or (= ?zrp ?zro)
                  (= ?zrp ?mzs)
                  )
                (= ?zro ?mzs)
                )
              (and (and (not (= ?zrr ?zrq))
                  (not (= ?zrr ?mzs))
                  )
                (not (= ?zrq ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (and (and (and (not (= ?zpn ?zpm))
                (not (= ?zpn ?zpl))
                )
              (not (= ?zpm ?zpl))
              )
            (or (or (= ?zpp ?zpo)
                (= ?zpp ?zpl)
                )
              (= ?zpo ?zpl)
              )
            )
          (and (or (or (= ?zpn ?zpm)
                (= ?zpn ?zpl)
                )
              (= ?zpm ?zpl)
              )
            (and (and (not (= ?zpp ?zpo))
                (not (= ?zpp ?zpl))
                )
              (not (= ?zpo ?zpl))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?zrs Real)
    (declare-const ?zrt Real)
    (declare-const ?zru Real)
    (declare-const ?zrv Real)
    (declare-const ?zrw Real)
    (declare-const ?zrx Real)
    (push 1)
      (declare-const ?zry Real)
      (declare-const ?zrz Real)
      (declare-const ?zsa Real)
      (assert
        (or (or (= ?zsa ?zrz)
            (= ?zsa ?zry)
            )
          (= ?zrz ?zry)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zsb Real)
      (declare-const ?zsc Real)
      (declare-const ?zsd Real)
      (declare-const ?zse Real)
      (assert
        (or (or (= ?zse ?zsd)
            (= ?zse ?zsc)
            )
          (= ?zsd ?zsc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zsf Real)
      (declare-const ?zsg Real)
      (declare-const ?zsh Real)
      (declare-const ?zsi Real)
      (declare-const ?zsj Real)
      (assert
        (or (or (= ?zsj ?zsi)
            (= ?zsj ?zsh)
            )
          (= ?zsi ?zsh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zsk Real)
      (declare-const ?zsl Real)
      (declare-const ?zsm Real)
      (declare-const ?zsn Real)
      (declare-const ?zso Real)
      (declare-const ?zsp Real)
      (assert
        (and (and (and (not (= ?zsm ?zsl))
              (not (= ?zsm ?zsk))
              )
            (not (= ?zsl ?zsk))
            )
          (or (or (= ?zsp ?zso)
              (= ?zsp ?zsn)
              )
            (= ?zso ?zsn)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zsq Real)
      (declare-const ?zsr Real)
      (declare-const ?zss Real)
      (assert
        (or (or (= ?zss ?zsr)
            (= ?zss ?zsq)
            )
          (= ?zsr ?zsq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zst Real)
      (declare-const ?zsu Real)
      (declare-const ?zsv Real)
      (assert
        (or (or (= ?zsv ?zsu)
            (= ?zsv ?zst)
            )
          (= ?zsu ?zst)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zsw Real)
      (declare-const ?zsx Real)
      (declare-const ?zsy Real)
      (declare-const ?zsz Real)
      (assert
        (or (or (= ?zsy ?zsx)
            (= ?zsy ?zsw)
            )
          (= ?zsx ?zsw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zta Real)
      (declare-const ?ztb Real)
      (declare-const ?ztc Real)
      (declare-const ?ztd Real)
      (declare-const ?zte Real)
      (assert
        (or (or (= ?ztc ?ztb)
            (= ?ztc ?zta)
            )
          (= ?ztb ?zta)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ztf Real)
      (declare-const ?ztg Real)
      (declare-const ?zth Real)
      (declare-const ?zti Real)
      (declare-const ?ztj Real)
      (declare-const ?ztk Real)
      (assert
        (and (or (or (= ?zth ?ztg)
              (= ?zth ?ztf)
              )
            (= ?ztg ?ztf)
            )
          (and (and (not (= ?ztk ?ztj))
              (not (= ?ztk ?zti))
              )
            (not (= ?ztj ?zti))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ztl Real)
      (declare-const ?ztm Real)
      (declare-const ?ztn Real)
      (assert
        (or (or (= ?ztn ?ztm)
            (= ?ztn ?ztl)
            )
          (= ?ztm ?ztl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zto Real)
      (declare-const ?ztp Real)
      (declare-const ?ztq Real)
      (declare-const ?ztr Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?ztp ?zto))
                  (not (= ?ztp ?asi))
                  )
                (not (= ?zto ?asi))
                )
              (or (or (= ?ztr ?ztq)
                  (= ?ztr ?asi)
                  )
                (= ?ztq ?asi)
                )
              )
            (and (or (or (= ?ztp ?zto)
                  (= ?ztp ?asi)
                  )
                (= ?zto ?asi)
                )
              (and (and (not (= ?ztr ?ztq))
                  (not (= ?ztr ?asi))
                  )
                (not (= ?ztq ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zts Real)
      (declare-const ?ztt Real)
      (declare-const ?ztu Real)
      (declare-const ?ztv Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?ztt ?zts))
                  (not (= ?ztt ?fkf))
                  )
                (not (= ?zts ?fkf))
                )
              (or (or (= ?ztv ?ztu)
                  (= ?ztv ?fkf)
                  )
                (= ?ztu ?fkf)
                )
              )
            (and (or (or (= ?ztt ?zts)
                  (= ?ztt ?fkf)
                  )
                (= ?zts ?fkf)
                )
              (and (and (not (= ?ztv ?ztu))
                  (not (= ?ztv ?fkf))
                  )
                (not (= ?ztu ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?ztw Real)
      (declare-const ?ztx Real)
      (declare-const ?zty Real)
      (declare-const ?ztz Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?ztx ?ztw))
                  (not (= ?ztx ?mzs))
                  )
                (not (= ?ztw ?mzs))
                )
              (or (or (= ?ztz ?zty)
                  (= ?ztz ?mzs)
                  )
                (= ?zty ?mzs)
                )
              )
            (and (or (or (= ?ztx ?ztw)
                  (= ?ztx ?mzs)
                  )
                (= ?ztw ?mzs)
                )
              (and (and (not (= ?ztz ?zty))
                  (not (= ?ztz ?mzs))
                  )
                (not (= ?zty ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zua Real)
      (declare-const ?zub Real)
      (declare-const ?zuc Real)
      (declare-const ?zud Real)
      (assert
        (exists ((?zpl Real) )(or (and (and (and (not (= ?zub ?zua))
                  (not (= ?zub ?zpl))
                  )
                (not (= ?zua ?zpl))
                )
              (or (or (= ?zud ?zuc)
                  (= ?zud ?zpl)
                  )
                (= ?zuc ?zpl)
                )
              )
            (and (or (or (= ?zub ?zua)
                  (= ?zub ?zpl)
                  )
                (= ?zua ?zpl)
                )
              (and (and (not (= ?zud ?zuc))
                  (not (= ?zud ?zpl))
                  )
                (not (= ?zuc ?zpl))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (= ?zrx ?zrw)
            (= ?zrx ?zrs)
            )
          (= ?zrw ?zrs)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?zue Real)
    (declare-const ?zuf Real)
    (declare-const ?zug Real)
    (push 1)
      (declare-const ?zuh Real)
      (declare-const ?zui Real)
      (declare-const ?zuj Real)
      (assert
        (or (or (= ?zuj ?zui)
            (= ?zuj ?zuh)
            )
          (= ?zui ?zuh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zuk Real)
      (declare-const ?zul Real)
      (declare-const ?zum Real)
      (declare-const ?zun Real)
      (assert
        (or (or (= ?zun ?zum)
            (= ?zun ?zul)
            )
          (= ?zum ?zul)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zuo Real)
      (declare-const ?zup Real)
      (declare-const ?zuq Real)
      (declare-const ?zur Real)
      (declare-const ?zus Real)
      (assert
        (or (or (= ?zus ?zur)
            (= ?zus ?zuq)
            )
          (= ?zur ?zuq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zut Real)
      (declare-const ?zuu Real)
      (declare-const ?zuv Real)
      (declare-const ?zuw Real)
      (declare-const ?zux Real)
      (declare-const ?zuy Real)
      (assert
        (and (and (and (not (= ?zuv ?zuu))
              (not (= ?zuv ?zut))
              )
            (not (= ?zuu ?zut))
            )
          (or (or (= ?zuy ?zux)
              (= ?zuy ?zuw)
              )
            (= ?zux ?zuw)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zuz Real)
      (declare-const ?zva Real)
      (declare-const ?zvb Real)
      (assert
        (or (or (= ?zvb ?zva)
            (= ?zvb ?zuz)
            )
          (= ?zva ?zuz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zvc Real)
      (declare-const ?zvd Real)
      (declare-const ?zve Real)
      (assert
        (or (or (= ?zve ?zvd)
            (= ?zve ?zvc)
            )
          (= ?zvd ?zvc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zvf Real)
      (declare-const ?zvg Real)
      (declare-const ?zvh Real)
      (declare-const ?zvi Real)
      (assert
        (or (or (= ?zvh ?zvg)
            (= ?zvh ?zvf)
            )
          (= ?zvg ?zvf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zvj Real)
      (declare-const ?zvk Real)
      (declare-const ?zvl Real)
      (declare-const ?zvm Real)
      (declare-const ?zvn Real)
      (assert
        (or (or (= ?zvl ?zvk)
            (= ?zvl ?zvj)
            )
          (= ?zvk ?zvj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zvo Real)
      (declare-const ?zvp Real)
      (declare-const ?zvq Real)
      (declare-const ?zvr Real)
      (declare-const ?zvs Real)
      (declare-const ?zvt Real)
      (assert
        (and (or (or (= ?zvq ?zvp)
              (= ?zvq ?zvo)
              )
            (= ?zvp ?zvo)
            )
          (and (and (not (= ?zvt ?zvs))
              (not (= ?zvt ?zvr))
              )
            (not (= ?zvs ?zvr))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zvu Real)
      (declare-const ?zvv Real)
      (declare-const ?zvw Real)
      (assert
        (or (or (= ?zvw ?zvv)
            (= ?zvw ?zvu)
            )
          (= ?zvv ?zvu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zvx Real)
      (declare-const ?zvy Real)
      (declare-const ?zvz Real)
      (declare-const ?zwa Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?zvy ?zvx))
                  (not (= ?zvy ?asi))
                  )
                (not (= ?zvx ?asi))
                )
              (or (or (= ?zwa ?zvz)
                  (= ?zwa ?asi)
                  )
                (= ?zvz ?asi)
                )
              )
            (and (or (or (= ?zvy ?zvx)
                  (= ?zvy ?asi)
                  )
                (= ?zvx ?asi)
                )
              (and (and (not (= ?zwa ?zvz))
                  (not (= ?zwa ?asi))
                  )
                (not (= ?zvz ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zwb Real)
      (declare-const ?zwc Real)
      (declare-const ?zwd Real)
      (declare-const ?zwe Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?zwc ?zwb))
                  (not (= ?zwc ?fkf))
                  )
                (not (= ?zwb ?fkf))
                )
              (or (or (= ?zwe ?zwd)
                  (= ?zwe ?fkf)
                  )
                (= ?zwd ?fkf)
                )
              )
            (and (or (or (= ?zwc ?zwb)
                  (= ?zwc ?fkf)
                  )
                (= ?zwb ?fkf)
                )
              (and (and (not (= ?zwe ?zwd))
                  (not (= ?zwe ?fkf))
                  )
                (not (= ?zwd ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zwf Real)
      (declare-const ?zwg Real)
      (declare-const ?zwh Real)
      (declare-const ?zwi Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?zwg ?zwf))
                  (not (= ?zwg ?mzs))
                  )
                (not (= ?zwf ?mzs))
                )
              (or (or (= ?zwi ?zwh)
                  (= ?zwi ?mzs)
                  )
                (= ?zwh ?mzs)
                )
              )
            (and (or (or (= ?zwg ?zwf)
                  (= ?zwg ?mzs)
                  )
                (= ?zwf ?mzs)
                )
              (and (and (not (= ?zwi ?zwh))
                  (not (= ?zwi ?mzs))
                  )
                (not (= ?zwh ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zwj Real)
      (declare-const ?zwk Real)
      (declare-const ?zwl Real)
      (declare-const ?zwm Real)
      (assert
        (exists ((?zpl Real) )(or (and (and (and (not (= ?zwk ?zwj))
                  (not (= ?zwk ?zpl))
                  )
                (not (= ?zwj ?zpl))
                )
              (or (or (= ?zwm ?zwl)
                  (= ?zwm ?zpl)
                  )
                (= ?zwl ?zpl)
                )
              )
            (and (or (or (= ?zwk ?zwj)
                  (= ?zwk ?zpl)
                  )
                (= ?zwj ?zpl)
                )
              (and (and (not (= ?zwm ?zwl))
                  (not (= ?zwm ?zpl))
                  )
                (not (= ?zwl ?zpl))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (= ?zug ?zuf)
            (= ?zug ?zue)
            )
          (= ?zuf ?zue)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?zwn Real)
    (declare-const ?zwo Real)
    (declare-const ?zwp Real)
    (declare-const ?zwq Real)
    (push 1)
      (declare-const ?zwr Real)
      (declare-const ?zws Real)
      (declare-const ?zwt Real)
      (assert
        (or (or (= ?zwt ?zws)
            (= ?zwt ?zwr)
            )
          (= ?zws ?zwr)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zwu Real)
      (declare-const ?zwv Real)
      (declare-const ?zww Real)
      (declare-const ?zwx Real)
      (assert
        (or (or (= ?zwx ?zww)
            (= ?zwx ?zwv)
            )
          (= ?zww ?zwv)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zwy Real)
      (declare-const ?zwz Real)
      (declare-const ?zxa Real)
      (declare-const ?zxb Real)
      (declare-const ?zxc Real)
      (assert
        (or (or (= ?zxc ?zxb)
            (= ?zxc ?zxa)
            )
          (= ?zxb ?zxa)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zxd Real)
      (declare-const ?zxe Real)
      (declare-const ?zxf Real)
      (declare-const ?zxg Real)
      (declare-const ?zxh Real)
      (declare-const ?zxi Real)
      (assert
        (and (and (and (not (= ?zxf ?zxe))
              (not (= ?zxf ?zxd))
              )
            (not (= ?zxe ?zxd))
            )
          (or (or (= ?zxi ?zxh)
              (= ?zxi ?zxg)
              )
            (= ?zxh ?zxg)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zxj Real)
      (declare-const ?zxk Real)
      (declare-const ?zxl Real)
      (assert
        (or (or (= ?zxl ?zxk)
            (= ?zxl ?zxj)
            )
          (= ?zxk ?zxj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zxm Real)
      (declare-const ?zxn Real)
      (declare-const ?zxo Real)
      (assert
        (or (or (= ?zxo ?zxn)
            (= ?zxo ?zxm)
            )
          (= ?zxn ?zxm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zxp Real)
      (declare-const ?zxq Real)
      (declare-const ?zxr Real)
      (declare-const ?zxs Real)
      (assert
        (or (or (= ?zxr ?zxq)
            (= ?zxr ?zxp)
            )
          (= ?zxq ?zxp)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zxt Real)
      (declare-const ?zxu Real)
      (declare-const ?zxv Real)
      (declare-const ?zxw Real)
      (declare-const ?zxx Real)
      (assert
        (or (or (= ?zxv ?zxu)
            (= ?zxv ?zxt)
            )
          (= ?zxu ?zxt)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zxy Real)
      (declare-const ?zxz Real)
      (declare-const ?zya Real)
      (declare-const ?zyb Real)
      (declare-const ?zyc Real)
      (declare-const ?zyd Real)
      (assert
        (and (or (or (= ?zya ?zxz)
              (= ?zya ?zxy)
              )
            (= ?zxz ?zxy)
            )
          (and (and (not (= ?zyd ?zyc))
              (not (= ?zyd ?zyb))
              )
            (not (= ?zyc ?zyb))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zye Real)
      (declare-const ?zyf Real)
      (declare-const ?zyg Real)
      (assert
        (or (or (= ?zyg ?zyf)
            (= ?zyg ?zye)
            )
          (= ?zyf ?zye)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zyh Real)
      (declare-const ?zyi Real)
      (declare-const ?zyj Real)
      (declare-const ?zyk Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?zyi ?zyh))
                  (not (= ?zyi ?asi))
                  )
                (not (= ?zyh ?asi))
                )
              (or (or (= ?zyk ?zyj)
                  (= ?zyk ?asi)
                  )
                (= ?zyj ?asi)
                )
              )
            (and (or (or (= ?zyi ?zyh)
                  (= ?zyi ?asi)
                  )
                (= ?zyh ?asi)
                )
              (and (and (not (= ?zyk ?zyj))
                  (not (= ?zyk ?asi))
                  )
                (not (= ?zyj ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zyl Real)
      (declare-const ?zym Real)
      (declare-const ?zyn Real)
      (declare-const ?zyo Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?zym ?zyl))
                  (not (= ?zym ?fkf))
                  )
                (not (= ?zyl ?fkf))
                )
              (or (or (= ?zyo ?zyn)
                  (= ?zyo ?fkf)
                  )
                (= ?zyn ?fkf)
                )
              )
            (and (or (or (= ?zym ?zyl)
                  (= ?zym ?fkf)
                  )
                (= ?zyl ?fkf)
                )
              (and (and (not (= ?zyo ?zyn))
                  (not (= ?zyo ?fkf))
                  )
                (not (= ?zyn ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zyp Real)
      (declare-const ?zyq Real)
      (declare-const ?zyr Real)
      (declare-const ?zys Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?zyq ?zyp))
                  (not (= ?zyq ?mzs))
                  )
                (not (= ?zyp ?mzs))
                )
              (or (or (= ?zys ?zyr)
                  (= ?zys ?mzs)
                  )
                (= ?zyr ?mzs)
                )
              )
            (and (or (or (= ?zyq ?zyp)
                  (= ?zyq ?mzs)
                  )
                (= ?zyp ?mzs)
                )
              (and (and (not (= ?zys ?zyr))
                  (not (= ?zys ?mzs))
                  )
                (not (= ?zyr ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zyt Real)
      (declare-const ?zyu Real)
      (declare-const ?zyv Real)
      (declare-const ?zyw Real)
      (assert
        (exists ((?zpl Real) )(or (and (and (and (not (= ?zyu ?zyt))
                  (not (= ?zyu ?zpl))
                  )
                (not (= ?zyt ?zpl))
                )
              (or (or (= ?zyw ?zyv)
                  (= ?zyw ?zpl)
                  )
                (= ?zyv ?zpl)
                )
              )
            (and (or (or (= ?zyu ?zyt)
                  (= ?zyu ?zpl)
                  )
                (= ?zyt ?zpl)
                )
              (and (and (not (= ?zyw ?zyv))
                  (not (= ?zyw ?zpl))
                  )
                (not (= ?zyv ?zpl))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?zyx Real)
    (declare-const ?zyy Real)
    (declare-const ?zyz Real)
    (declare-const ?zza Real)
    (declare-const ?zzb Real)
    (push 1)
      (declare-const ?zzc Real)
      (declare-const ?zzd Real)
      (declare-const ?zze Real)
      (assert
        (or (or (= ?zze ?zzd)
            (= ?zze ?zzc)
            )
          (= ?zzd ?zzc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zzf Real)
      (declare-const ?zzg Real)
      (declare-const ?zzh Real)
      (declare-const ?zzi Real)
      (assert
        (or (or (= ?zzi ?zzh)
            (= ?zzi ?zzg)
            )
          (= ?zzh ?zzg)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zzj Real)
      (declare-const ?zzk Real)
      (declare-const ?zzl Real)
      (declare-const ?zzm Real)
      (declare-const ?zzn Real)
      (assert
        (or (or (= ?zzn ?zzm)
            (= ?zzn ?zzl)
            )
          (= ?zzm ?zzl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zzo Real)
      (declare-const ?zzp Real)
      (declare-const ?zzq Real)
      (declare-const ?zzr Real)
      (declare-const ?zzs Real)
      (declare-const ?zzt Real)
      (assert
        (and (and (and (not (= ?zzq ?zzp))
              (not (= ?zzq ?zzo))
              )
            (not (= ?zzp ?zzo))
            )
          (or (or (= ?zzt ?zzs)
              (= ?zzt ?zzr)
              )
            (= ?zzs ?zzr)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zzu Real)
      (declare-const ?zzv Real)
      (declare-const ?zzw Real)
      (assert
        (or (or (= ?zzw ?zzv)
            (= ?zzw ?zzu)
            )
          (= ?zzv ?zzu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?zzx Real)
      (declare-const ?zzy Real)
      (declare-const ?zzz Real)
      (assert
        (or (or (= ?zzz ?zzy)
            (= ?zzz ?zzx)
            )
          (= ?zzy ?zzx)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaaa Real)
      (declare-const ?aaab Real)
      (declare-const ?aaac Real)
      (declare-const ?aaad Real)
      (assert
        (or (or (= ?aaac ?aaab)
            (= ?aaac ?aaaa)
            )
          (= ?aaab ?aaaa)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaae Real)
      (declare-const ?aaaf Real)
      (declare-const ?aaag Real)
      (declare-const ?aaah Real)
      (declare-const ?aaai Real)
      (assert
        (or (or (= ?aaag ?aaaf)
            (= ?aaag ?aaae)
            )
          (= ?aaaf ?aaae)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaaj Real)
      (declare-const ?aaak Real)
      (declare-const ?aaal Real)
      (declare-const ?aaam Real)
      (declare-const ?aaan Real)
      (declare-const ?aaao Real)
      (assert
        (and (or (or (= ?aaal ?aaak)
              (= ?aaal ?aaaj)
              )
            (= ?aaak ?aaaj)
            )
          (and (and (not (= ?aaao ?aaan))
              (not (= ?aaao ?aaam))
              )
            (not (= ?aaan ?aaam))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaap Real)
      (declare-const ?aaaq Real)
      (declare-const ?aaar Real)
      (assert
        (or (or (= ?aaar ?aaaq)
            (= ?aaar ?aaap)
            )
          (= ?aaaq ?aaap)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaas Real)
      (declare-const ?aaat Real)
      (declare-const ?aaau Real)
      (declare-const ?aaav Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?aaat ?aaas))
                  (not (= ?aaat ?asi))
                  )
                (not (= ?aaas ?asi))
                )
              (or (or (= ?aaav ?aaau)
                  (= ?aaav ?asi)
                  )
                (= ?aaau ?asi)
                )
              )
            (and (or (or (= ?aaat ?aaas)
                  (= ?aaat ?asi)
                  )
                (= ?aaas ?asi)
                )
              (and (and (not (= ?aaav ?aaau))
                  (not (= ?aaav ?asi))
                  )
                (not (= ?aaau ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaaw Real)
      (declare-const ?aaax Real)
      (declare-const ?aaay Real)
      (declare-const ?aaaz Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?aaax ?aaaw))
                  (not (= ?aaax ?fkf))
                  )
                (not (= ?aaaw ?fkf))
                )
              (or (or (= ?aaaz ?aaay)
                  (= ?aaaz ?fkf)
                  )
                (= ?aaay ?fkf)
                )
              )
            (and (or (or (= ?aaax ?aaaw)
                  (= ?aaax ?fkf)
                  )
                (= ?aaaw ?fkf)
                )
              (and (and (not (= ?aaaz ?aaay))
                  (not (= ?aaaz ?fkf))
                  )
                (not (= ?aaay ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaba Real)
      (declare-const ?aabb Real)
      (declare-const ?aabc Real)
      (declare-const ?aabd Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?aabb ?aaba))
                  (not (= ?aabb ?mzs))
                  )
                (not (= ?aaba ?mzs))
                )
              (or (or (= ?aabd ?aabc)
                  (= ?aabd ?mzs)
                  )
                (= ?aabc ?mzs)
                )
              )
            (and (or (or (= ?aabb ?aaba)
                  (= ?aabb ?mzs)
                  )
                (= ?aaba ?mzs)
                )
              (and (and (not (= ?aabd ?aabc))
                  (not (= ?aabd ?mzs))
                  )
                (not (= ?aabc ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aabe Real)
      (declare-const ?aabf Real)
      (declare-const ?aabg Real)
      (declare-const ?aabh Real)
      (assert
        (exists ((?zpl Real) )(or (and (and (and (not (= ?aabf ?aabe))
                  (not (= ?aabf ?zpl))
                  )
                (not (= ?aabe ?zpl))
                )
              (or (or (= ?aabh ?aabg)
                  (= ?aabh ?zpl)
                  )
                (= ?aabg ?zpl)
                )
              )
            (and (or (or (= ?aabf ?aabe)
                  (= ?aabf ?zpl)
                  )
                (= ?aabe ?zpl)
                )
              (and (and (not (= ?aabh ?aabg))
                  (not (= ?aabh ?zpl))
                  )
                (not (= ?aabg ?zpl))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?aabi Real)
    (declare-const ?aabj Real)
    (declare-const ?aabk Real)
    (declare-const ?aabl Real)
    (declare-const ?aabm Real)
    (declare-const ?aabn Real)
    (push 1)
      (declare-const ?aabo Real)
      (declare-const ?aabp Real)
      (declare-const ?aabq Real)
      (assert
        (or (or (= ?aabq ?aabp)
            (= ?aabq ?aabo)
            )
          (= ?aabp ?aabo)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aabr Real)
      (declare-const ?aabs Real)
      (declare-const ?aabt Real)
      (declare-const ?aabu Real)
      (assert
        (or (or (= ?aabu ?aabt)
            (= ?aabu ?aabs)
            )
          (= ?aabt ?aabs)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aabv Real)
      (declare-const ?aabw Real)
      (declare-const ?aabx Real)
      (declare-const ?aaby Real)
      (declare-const ?aabz Real)
      (assert
        (or (or (= ?aabz ?aaby)
            (= ?aabz ?aabx)
            )
          (= ?aaby ?aabx)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaca Real)
      (declare-const ?aacb Real)
      (declare-const ?aacc Real)
      (declare-const ?aacd Real)
      (declare-const ?aace Real)
      (declare-const ?aacf Real)
      (assert
        (and (and (and (not (= ?aacc ?aacb))
              (not (= ?aacc ?aaca))
              )
            (not (= ?aacb ?aaca))
            )
          (or (or (= ?aacf ?aace)
              (= ?aacf ?aacd)
              )
            (= ?aace ?aacd)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aacg Real)
      (declare-const ?aach Real)
      (declare-const ?aaci Real)
      (assert
        (or (or (= ?aaci ?aach)
            (= ?aaci ?aacg)
            )
          (= ?aach ?aacg)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aacj Real)
      (declare-const ?aack Real)
      (declare-const ?aacl Real)
      (assert
        (or (or (= ?aacl ?aack)
            (= ?aacl ?aacj)
            )
          (= ?aack ?aacj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aacm Real)
      (declare-const ?aacn Real)
      (declare-const ?aaco Real)
      (declare-const ?aacp Real)
      (assert
        (or (or (= ?aaco ?aacn)
            (= ?aaco ?aacm)
            )
          (= ?aacn ?aacm)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aacq Real)
      (declare-const ?aacr Real)
      (declare-const ?aacs Real)
      (declare-const ?aact Real)
      (declare-const ?aacu Real)
      (assert
        (or (or (= ?aacs ?aacr)
            (= ?aacs ?aacq)
            )
          (= ?aacr ?aacq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aacv Real)
      (declare-const ?aacw Real)
      (declare-const ?aacx Real)
      (declare-const ?aacy Real)
      (declare-const ?aacz Real)
      (declare-const ?aada Real)
      (assert
        (and (or (or (= ?aacx ?aacw)
              (= ?aacx ?aacv)
              )
            (= ?aacw ?aacv)
            )
          (and (and (not (= ?aada ?aacz))
              (not (= ?aada ?aacy))
              )
            (not (= ?aacz ?aacy))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aadb Real)
      (declare-const ?aadc Real)
      (declare-const ?aadd Real)
      (assert
        (or (or (= ?aadd ?aadc)
            (= ?aadd ?aadb)
            )
          (= ?aadc ?aadb)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aade Real)
      (declare-const ?aadf Real)
      (declare-const ?aadg Real)
      (declare-const ?aadh Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?aadf ?aade))
                  (not (= ?aadf ?asi))
                  )
                (not (= ?aade ?asi))
                )
              (or (or (= ?aadh ?aadg)
                  (= ?aadh ?asi)
                  )
                (= ?aadg ?asi)
                )
              )
            (and (or (or (= ?aadf ?aade)
                  (= ?aadf ?asi)
                  )
                (= ?aade ?asi)
                )
              (and (and (not (= ?aadh ?aadg))
                  (not (= ?aadh ?asi))
                  )
                (not (= ?aadg ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aadi Real)
      (declare-const ?aadj Real)
      (declare-const ?aadk Real)
      (declare-const ?aadl Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?aadj ?aadi))
                  (not (= ?aadj ?fkf))
                  )
                (not (= ?aadi ?fkf))
                )
              (or (or (= ?aadl ?aadk)
                  (= ?aadl ?fkf)
                  )
                (= ?aadk ?fkf)
                )
              )
            (and (or (or (= ?aadj ?aadi)
                  (= ?aadj ?fkf)
                  )
                (= ?aadi ?fkf)
                )
              (and (and (not (= ?aadl ?aadk))
                  (not (= ?aadl ?fkf))
                  )
                (not (= ?aadk ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aadm Real)
      (declare-const ?aadn Real)
      (declare-const ?aado Real)
      (declare-const ?aadp Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?aadn ?aadm))
                  (not (= ?aadn ?mzs))
                  )
                (not (= ?aadm ?mzs))
                )
              (or (or (= ?aadp ?aado)
                  (= ?aadp ?mzs)
                  )
                (= ?aado ?mzs)
                )
              )
            (and (or (or (= ?aadn ?aadm)
                  (= ?aadn ?mzs)
                  )
                (= ?aadm ?mzs)
                )
              (and (and (not (= ?aadp ?aado))
                  (not (= ?aadp ?mzs))
                  )
                (not (= ?aado ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aadq Real)
      (declare-const ?aadr Real)
      (declare-const ?aads Real)
      (declare-const ?aadt Real)
      (assert
        (exists ((?zpl Real) )(or (and (and (and (not (= ?aadr ?aadq))
                  (not (= ?aadr ?zpl))
                  )
                (not (= ?aadq ?zpl))
                )
              (or (or (= ?aadt ?aads)
                  (= ?aadt ?zpl)
                  )
                (= ?aads ?zpl)
                )
              )
            (and (or (or (= ?aadr ?aadq)
                  (= ?aadr ?zpl)
                  )
                (= ?aadq ?zpl)
                )
              (and (and (not (= ?aadt ?aads))
                  (not (= ?aadt ?zpl))
                  )
                (not (= ?aads ?zpl))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (= ?aabk ?aabj)
            (= ?aabk ?aabi)
            )
          (= ?aabj ?aabi)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?aadu Real)
    (declare-const ?aadv Real)
    (declare-const ?aadw Real)
    (declare-const ?aadx Real)
    (declare-const ?aady Real)
    (declare-const ?aadz Real)
    (push 1)
      (declare-const ?aaea Real)
      (declare-const ?aaeb Real)
      (declare-const ?aaec Real)
      (assert
        (or (or (= ?aaec ?aaeb)
            (= ?aaec ?aaea)
            )
          (= ?aaeb ?aaea)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaed Real)
      (declare-const ?aaee Real)
      (declare-const ?aaef Real)
      (declare-const ?aaeg Real)
      (assert
        (or (or (= ?aaeg ?aaef)
            (= ?aaeg ?aaee)
            )
          (= ?aaef ?aaee)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaeh Real)
      (declare-const ?aaei Real)
      (declare-const ?aaej Real)
      (declare-const ?aaek Real)
      (declare-const ?aael Real)
      (assert
        (or (or (= ?aael ?aaek)
            (= ?aael ?aaej)
            )
          (= ?aaek ?aaej)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaem Real)
      (declare-const ?aaen Real)
      (declare-const ?aaeo Real)
      (declare-const ?aaep Real)
      (declare-const ?aaeq Real)
      (declare-const ?aaer Real)
      (assert
        (and (and (and (not (= ?aaeo ?aaen))
              (not (= ?aaeo ?aaem))
              )
            (not (= ?aaen ?aaem))
            )
          (or (or (= ?aaer ?aaeq)
              (= ?aaer ?aaep)
              )
            (= ?aaeq ?aaep)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaes Real)
      (declare-const ?aaet Real)
      (declare-const ?aaeu Real)
      (assert
        (or (or (= ?aaeu ?aaet)
            (= ?aaeu ?aaes)
            )
          (= ?aaet ?aaes)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaev Real)
      (declare-const ?aaew Real)
      (declare-const ?aaex Real)
      (assert
        (or (or (= ?aaex ?aaew)
            (= ?aaex ?aaev)
            )
          (= ?aaew ?aaev)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaey Real)
      (declare-const ?aaez Real)
      (declare-const ?aafa Real)
      (declare-const ?aafb Real)
      (assert
        (or (or (= ?aafa ?aaez)
            (= ?aafa ?aaey)
            )
          (= ?aaez ?aaey)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aafc Real)
      (declare-const ?aafd Real)
      (declare-const ?aafe Real)
      (declare-const ?aaff Real)
      (declare-const ?aafg Real)
      (assert
        (or (or (= ?aafe ?aafd)
            (= ?aafe ?aafc)
            )
          (= ?aafd ?aafc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aafh Real)
      (declare-const ?aafi Real)
      (declare-const ?aafj Real)
      (declare-const ?aafk Real)
      (declare-const ?aafl Real)
      (declare-const ?aafm Real)
      (assert
        (and (or (or (= ?aafj ?aafi)
              (= ?aafj ?aafh)
              )
            (= ?aafi ?aafh)
            )
          (and (and (not (= ?aafm ?aafl))
              (not (= ?aafm ?aafk))
              )
            (not (= ?aafl ?aafk))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aafn Real)
      (declare-const ?aafo Real)
      (declare-const ?aafp Real)
      (assert
        (or (or (= ?aafp ?aafo)
            (= ?aafp ?aafn)
            )
          (= ?aafo ?aafn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aafq Real)
      (declare-const ?aafr Real)
      (declare-const ?aafs Real)
      (declare-const ?aaft Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?aafr ?aafq))
                  (not (= ?aafr ?asi))
                  )
                (not (= ?aafq ?asi))
                )
              (or (or (= ?aaft ?aafs)
                  (= ?aaft ?asi)
                  )
                (= ?aafs ?asi)
                )
              )
            (and (or (or (= ?aafr ?aafq)
                  (= ?aafr ?asi)
                  )
                (= ?aafq ?asi)
                )
              (and (and (not (= ?aaft ?aafs))
                  (not (= ?aaft ?asi))
                  )
                (not (= ?aafs ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aafu Real)
      (declare-const ?aafv Real)
      (declare-const ?aafw Real)
      (declare-const ?aafx Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?aafv ?aafu))
                  (not (= ?aafv ?fkf))
                  )
                (not (= ?aafu ?fkf))
                )
              (or (or (= ?aafx ?aafw)
                  (= ?aafx ?fkf)
                  )
                (= ?aafw ?fkf)
                )
              )
            (and (or (or (= ?aafv ?aafu)
                  (= ?aafv ?fkf)
                  )
                (= ?aafu ?fkf)
                )
              (and (and (not (= ?aafx ?aafw))
                  (not (= ?aafx ?fkf))
                  )
                (not (= ?aafw ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aafy Real)
      (declare-const ?aafz Real)
      (declare-const ?aaga Real)
      (declare-const ?aagb Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?aafz ?aafy))
                  (not (= ?aafz ?mzs))
                  )
                (not (= ?aafy ?mzs))
                )
              (or (or (= ?aagb ?aaga)
                  (= ?aagb ?mzs)
                  )
                (= ?aaga ?mzs)
                )
              )
            (and (or (or (= ?aafz ?aafy)
                  (= ?aafz ?mzs)
                  )
                (= ?aafy ?mzs)
                )
              (and (and (not (= ?aagb ?aaga))
                  (not (= ?aagb ?mzs))
                  )
                (not (= ?aaga ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aagc Real)
      (declare-const ?aagd Real)
      (declare-const ?aage Real)
      (declare-const ?aagf Real)
      (assert
        (exists ((?zpl Real) )(or (and (and (and (not (= ?aagd ?aagc))
                  (not (= ?aagd ?zpl))
                  )
                (not (= ?aagc ?zpl))
                )
              (or (or (= ?aagf ?aage)
                  (= ?aagf ?zpl)
                  )
                (= ?aage ?zpl)
                )
              )
            (and (or (or (= ?aagd ?aagc)
                  (= ?aagd ?zpl)
                  )
                (= ?aagc ?zpl)
                )
              (and (and (not (= ?aagf ?aage))
                  (not (= ?aagf ?zpl))
                  )
                (not (= ?aage ?zpl))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?aagg Real)
    (declare-const ?aagh Real)
    (declare-const ?aagi Real)
    (push 1)
      (declare-const ?aagj Real)
      (declare-const ?aagk Real)
      (declare-const ?aagl Real)
      (assert
        (or (or (= ?aagl ?aagk)
            (= ?aagl ?aagj)
            )
          (= ?aagk ?aagj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aagm Real)
      (declare-const ?aagn Real)
      (declare-const ?aago Real)
      (declare-const ?aagp Real)
      (assert
        (or (or (= ?aagp ?aago)
            (= ?aagp ?aagn)
            )
          (= ?aago ?aagn)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aagq Real)
      (declare-const ?aagr Real)
      (declare-const ?aags Real)
      (declare-const ?aagt Real)
      (declare-const ?aagu Real)
      (assert
        (or (or (= ?aagu ?aagt)
            (= ?aagu ?aags)
            )
          (= ?aagt ?aags)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aagv Real)
      (declare-const ?aagw Real)
      (declare-const ?aagx Real)
      (declare-const ?aagy Real)
      (declare-const ?aagz Real)
      (declare-const ?aaha Real)
      (assert
        (and (and (and (not (= ?aagx ?aagw))
              (not (= ?aagx ?aagv))
              )
            (not (= ?aagw ?aagv))
            )
          (or (or (= ?aaha ?aagz)
              (= ?aaha ?aagy)
              )
            (= ?aagz ?aagy)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aahb Real)
      (declare-const ?aahc Real)
      (declare-const ?aahd Real)
      (assert
        (or (or (= ?aahd ?aahc)
            (= ?aahd ?aahb)
            )
          (= ?aahc ?aahb)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aahe Real)
      (declare-const ?aahf Real)
      (declare-const ?aahg Real)
      (assert
        (or (or (= ?aahg ?aahf)
            (= ?aahg ?aahe)
            )
          (= ?aahf ?aahe)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aahh Real)
      (declare-const ?aahi Real)
      (declare-const ?aahj Real)
      (declare-const ?aahk Real)
      (assert
        (or (or (= ?aahj ?aahi)
            (= ?aahj ?aahh)
            )
          (= ?aahi ?aahh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aahl Real)
      (declare-const ?aahm Real)
      (declare-const ?aahn Real)
      (declare-const ?aaho Real)
      (declare-const ?aahp Real)
      (assert
        (or (or (= ?aahn ?aahm)
            (= ?aahn ?aahl)
            )
          (= ?aahm ?aahl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aahq Real)
      (declare-const ?aahr Real)
      (declare-const ?aahs Real)
      (declare-const ?aaht Real)
      (declare-const ?aahu Real)
      (declare-const ?aahv Real)
      (assert
        (and (or (or (= ?aahs ?aahr)
              (= ?aahs ?aahq)
              )
            (= ?aahr ?aahq)
            )
          (and (and (not (= ?aahv ?aahu))
              (not (= ?aahv ?aaht))
              )
            (not (= ?aahu ?aaht))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aahw Real)
      (declare-const ?aahx Real)
      (declare-const ?aahy Real)
      (assert
        (or (or (= ?aahy ?aahx)
            (= ?aahy ?aahw)
            )
          (= ?aahx ?aahw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aahz Real)
      (declare-const ?aaia Real)
      (declare-const ?aaib Real)
      (declare-const ?aaic Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?aaia ?aahz))
                  (not (= ?aaia ?asi))
                  )
                (not (= ?aahz ?asi))
                )
              (or (or (= ?aaic ?aaib)
                  (= ?aaic ?asi)
                  )
                (= ?aaib ?asi)
                )
              )
            (and (or (or (= ?aaia ?aahz)
                  (= ?aaia ?asi)
                  )
                (= ?aahz ?asi)
                )
              (and (and (not (= ?aaic ?aaib))
                  (not (= ?aaic ?asi))
                  )
                (not (= ?aaib ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaid Real)
      (declare-const ?aaie Real)
      (declare-const ?aaif Real)
      (declare-const ?aaig Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?aaie ?aaid))
                  (not (= ?aaie ?fkf))
                  )
                (not (= ?aaid ?fkf))
                )
              (or (or (= ?aaig ?aaif)
                  (= ?aaig ?fkf)
                  )
                (= ?aaif ?fkf)
                )
              )
            (and (or (or (= ?aaie ?aaid)
                  (= ?aaie ?fkf)
                  )
                (= ?aaid ?fkf)
                )
              (and (and (not (= ?aaig ?aaif))
                  (not (= ?aaig ?fkf))
                  )
                (not (= ?aaif ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaih Real)
      (declare-const ?aaii Real)
      (declare-const ?aaij Real)
      (declare-const ?aaik Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?aaii ?aaih))
                  (not (= ?aaii ?mzs))
                  )
                (not (= ?aaih ?mzs))
                )
              (or (or (= ?aaik ?aaij)
                  (= ?aaik ?mzs)
                  )
                (= ?aaij ?mzs)
                )
              )
            (and (or (or (= ?aaii ?aaih)
                  (= ?aaii ?mzs)
                  )
                (= ?aaih ?mzs)
                )
              (and (and (not (= ?aaik ?aaij))
                  (not (= ?aaik ?mzs))
                  )
                (not (= ?aaij ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aail Real)
      (declare-const ?aaim Real)
      (declare-const ?aain Real)
      (declare-const ?aaio Real)
      (assert
        (exists ((?zpl Real) )(or (and (and (and (not (= ?aaim ?aail))
                  (not (= ?aaim ?zpl))
                  )
                (not (= ?aail ?zpl))
                )
              (or (or (= ?aaio ?aain)
                  (= ?aaio ?zpl)
                  )
                (= ?aain ?zpl)
                )
              )
            (and (or (or (= ?aaim ?aail)
                  (= ?aaim ?zpl)
                  )
                (= ?aail ?zpl)
                )
              (and (and (not (= ?aaio ?aain))
                  (not (= ?aaio ?zpl))
                  )
                (not (= ?aain ?zpl))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?aaip Real)
    (push 1)
      (declare-const ?aaiq Real)
      (declare-const ?aair Real)
      (declare-const ?aais Real)
      (assert
        (or (or (= ?aais ?aair)
            (= ?aais ?aaiq)
            )
          (= ?aair ?aaiq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aait Real)
      (declare-const ?aaiu Real)
      (declare-const ?aaiv Real)
      (declare-const ?aaiw Real)
      (assert
        (or (or (= ?aaiw ?aaiv)
            (= ?aaiw ?aaiu)
            )
          (= ?aaiv ?aaiu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaix Real)
      (declare-const ?aaiy Real)
      (declare-const ?aaiz Real)
      (declare-const ?aaja Real)
      (declare-const ?aajb Real)
      (assert
        (or (or (= ?aajb ?aaja)
            (= ?aajb ?aaiz)
            )
          (= ?aaja ?aaiz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aajc Real)
      (declare-const ?aajd Real)
      (declare-const ?aaje Real)
      (declare-const ?aajf Real)
      (declare-const ?aajg Real)
      (declare-const ?aajh Real)
      (assert
        (and (and (and (not (= ?aaje ?aajd))
              (not (= ?aaje ?aajc))
              )
            (not (= ?aajd ?aajc))
            )
          (or (or (= ?aajh ?aajg)
              (= ?aajh ?aajf)
              )
            (= ?aajg ?aajf)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaji Real)
      (declare-const ?aajj Real)
      (declare-const ?aajk Real)
      (assert
        (or (or (= ?aajk ?aajj)
            (= ?aajk ?aaji)
            )
          (= ?aajj ?aaji)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aajl Real)
      (declare-const ?aajm Real)
      (declare-const ?aajn Real)
      (assert
        (or (or (= ?aajn ?aajm)
            (= ?aajn ?aajl)
            )
          (= ?aajm ?aajl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aajo Real)
      (declare-const ?aajp Real)
      (declare-const ?aajq Real)
      (declare-const ?aajr Real)
      (assert
        (or (or (= ?aajq ?aajp)
            (= ?aajq ?aajo)
            )
          (= ?aajp ?aajo)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aajs Real)
      (declare-const ?aajt Real)
      (declare-const ?aaju Real)
      (declare-const ?aajv Real)
      (declare-const ?aajw Real)
      (assert
        (or (or (= ?aaju ?aajt)
            (= ?aaju ?aajs)
            )
          (= ?aajt ?aajs)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aajx Real)
      (declare-const ?aajy Real)
      (declare-const ?aajz Real)
      (declare-const ?aaka Real)
      (declare-const ?aakb Real)
      (declare-const ?aakc Real)
      (assert
        (and (or (or (= ?aajz ?aajy)
              (= ?aajz ?aajx)
              )
            (= ?aajy ?aajx)
            )
          (and (and (not (= ?aakc ?aakb))
              (not (= ?aakc ?aaka))
              )
            (not (= ?aakb ?aaka))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aakd Real)
      (declare-const ?aake Real)
      (declare-const ?aakf Real)
      (assert
        (or (or (= ?aakf ?aake)
            (= ?aakf ?aakd)
            )
          (= ?aake ?aakd)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aakg Real)
      (declare-const ?aakh Real)
      (declare-const ?aaki Real)
      (declare-const ?aakj Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?aakh ?aakg))
                  (not (= ?aakh ?asi))
                  )
                (not (= ?aakg ?asi))
                )
              (or (or (= ?aakj ?aaki)
                  (= ?aakj ?asi)
                  )
                (= ?aaki ?asi)
                )
              )
            (and (or (or (= ?aakh ?aakg)
                  (= ?aakh ?asi)
                  )
                (= ?aakg ?asi)
                )
              (and (and (not (= ?aakj ?aaki))
                  (not (= ?aakj ?asi))
                  )
                (not (= ?aaki ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aakk Real)
      (declare-const ?aakl Real)
      (declare-const ?aakm Real)
      (declare-const ?aakn Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?aakl ?aakk))
                  (not (= ?aakl ?fkf))
                  )
                (not (= ?aakk ?fkf))
                )
              (or (or (= ?aakn ?aakm)
                  (= ?aakn ?fkf)
                  )
                (= ?aakm ?fkf)
                )
              )
            (and (or (or (= ?aakl ?aakk)
                  (= ?aakl ?fkf)
                  )
                (= ?aakk ?fkf)
                )
              (and (and (not (= ?aakn ?aakm))
                  (not (= ?aakn ?fkf))
                  )
                (not (= ?aakm ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aako Real)
      (declare-const ?aakp Real)
      (declare-const ?aakq Real)
      (declare-const ?aakr Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?aakp ?aako))
                  (not (= ?aakp ?mzs))
                  )
                (not (= ?aako ?mzs))
                )
              (or (or (= ?aakr ?aakq)
                  (= ?aakr ?mzs)
                  )
                (= ?aakq ?mzs)
                )
              )
            (and (or (or (= ?aakp ?aako)
                  (= ?aakp ?mzs)
                  )
                (= ?aako ?mzs)
                )
              (and (and (not (= ?aakr ?aakq))
                  (not (= ?aakr ?mzs))
                  )
                (not (= ?aakq ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaks Real)
      (declare-const ?aakt Real)
      (declare-const ?aaku Real)
      (declare-const ?aakv Real)
      (assert
        (exists ((?zpl Real) )(or (and (and (and (not (= ?aakt ?aaks))
                  (not (= ?aakt ?zpl))
                  )
                (not (= ?aaks ?zpl))
                )
              (or (or (= ?aakv ?aaku)
                  (= ?aakv ?zpl)
                  )
                (= ?aaku ?zpl)
                )
              )
            (and (or (or (= ?aakt ?aaks)
                  (= ?aakt ?zpl)
                  )
                (= ?aaks ?zpl)
                )
              (and (and (not (= ?aakv ?aaku))
                  (not (= ?aakv ?zpl))
                  )
                (not (= ?aaku ?zpl))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?aakw Real)
    (declare-const ?aakx Real)
    (push 1)
      (declare-const ?aaky Real)
      (declare-const ?aakz Real)
      (declare-const ?aala Real)
      (assert
        (or (or (= ?aala ?aakz)
            (= ?aala ?aaky)
            )
          (= ?aakz ?aaky)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aalb Real)
      (declare-const ?aalc Real)
      (declare-const ?aald Real)
      (declare-const ?aale Real)
      (assert
        (or (or (= ?aale ?aald)
            (= ?aale ?aalc)
            )
          (= ?aald ?aalc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aalf Real)
      (declare-const ?aalg Real)
      (declare-const ?aalh Real)
      (declare-const ?aali Real)
      (declare-const ?aalj Real)
      (assert
        (or (or (= ?aalj ?aali)
            (= ?aalj ?aalh)
            )
          (= ?aali ?aalh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aalk Real)
      (declare-const ?aall Real)
      (declare-const ?aalm Real)
      (declare-const ?aaln Real)
      (declare-const ?aalo Real)
      (declare-const ?aalp Real)
      (assert
        (and (and (and (not (= ?aalm ?aall))
              (not (= ?aalm ?aalk))
              )
            (not (= ?aall ?aalk))
            )
          (or (or (= ?aalp ?aalo)
              (= ?aalp ?aaln)
              )
            (= ?aalo ?aaln)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aalq Real)
      (declare-const ?aalr Real)
      (declare-const ?aals Real)
      (assert
        (or (or (= ?aals ?aalr)
            (= ?aals ?aalq)
            )
          (= ?aalr ?aalq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aalt Real)
      (declare-const ?aalu Real)
      (declare-const ?aalv Real)
      (assert
        (or (or (= ?aalv ?aalu)
            (= ?aalv ?aalt)
            )
          (= ?aalu ?aalt)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aalw Real)
      (declare-const ?aalx Real)
      (declare-const ?aaly Real)
      (declare-const ?aalz Real)
      (assert
        (or (or (= ?aaly ?aalx)
            (= ?aaly ?aalw)
            )
          (= ?aalx ?aalw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aama Real)
      (declare-const ?aamb Real)
      (declare-const ?aamc Real)
      (declare-const ?aamd Real)
      (declare-const ?aame Real)
      (assert
        (or (or (= ?aamc ?aamb)
            (= ?aamc ?aama)
            )
          (= ?aamb ?aama)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aamf Real)
      (declare-const ?aamg Real)
      (declare-const ?aamh Real)
      (declare-const ?aami Real)
      (declare-const ?aamj Real)
      (declare-const ?aamk Real)
      (assert
        (and (or (or (= ?aamh ?aamg)
              (= ?aamh ?aamf)
              )
            (= ?aamg ?aamf)
            )
          (and (and (not (= ?aamk ?aamj))
              (not (= ?aamk ?aami))
              )
            (not (= ?aamj ?aami))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaml Real)
      (declare-const ?aamm Real)
      (declare-const ?aamn Real)
      (assert
        (or (or (= ?aamn ?aamm)
            (= ?aamn ?aaml)
            )
          (= ?aamm ?aaml)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aamo Real)
      (declare-const ?aamp Real)
      (declare-const ?aamq Real)
      (declare-const ?aamr Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?aamp ?aamo))
                  (not (= ?aamp ?asi))
                  )
                (not (= ?aamo ?asi))
                )
              (or (or (= ?aamr ?aamq)
                  (= ?aamr ?asi)
                  )
                (= ?aamq ?asi)
                )
              )
            (and (or (or (= ?aamp ?aamo)
                  (= ?aamp ?asi)
                  )
                (= ?aamo ?asi)
                )
              (and (and (not (= ?aamr ?aamq))
                  (not (= ?aamr ?asi))
                  )
                (not (= ?aamq ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aams Real)
      (declare-const ?aamt Real)
      (declare-const ?aamu Real)
      (declare-const ?aamv Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?aamt ?aams))
                  (not (= ?aamt ?fkf))
                  )
                (not (= ?aams ?fkf))
                )
              (or (or (= ?aamv ?aamu)
                  (= ?aamv ?fkf)
                  )
                (= ?aamu ?fkf)
                )
              )
            (and (or (or (= ?aamt ?aams)
                  (= ?aamt ?fkf)
                  )
                (= ?aams ?fkf)
                )
              (and (and (not (= ?aamv ?aamu))
                  (not (= ?aamv ?fkf))
                  )
                (not (= ?aamu ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aamw Real)
      (declare-const ?aamx Real)
      (declare-const ?aamy Real)
      (declare-const ?aamz Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?aamx ?aamw))
                  (not (= ?aamx ?mzs))
                  )
                (not (= ?aamw ?mzs))
                )
              (or (or (= ?aamz ?aamy)
                  (= ?aamz ?mzs)
                  )
                (= ?aamy ?mzs)
                )
              )
            (and (or (or (= ?aamx ?aamw)
                  (= ?aamx ?mzs)
                  )
                (= ?aamw ?mzs)
                )
              (and (and (not (= ?aamz ?aamy))
                  (not (= ?aamz ?mzs))
                  )
                (not (= ?aamy ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aana Real)
      (declare-const ?aanb Real)
      (declare-const ?aanc Real)
      (declare-const ?aand Real)
      (assert
        (exists ((?zpl Real) )(or (and (and (and (not (= ?aanb ?aana))
                  (not (= ?aanb ?zpl))
                  )
                (not (= ?aana ?zpl))
                )
              (or (or (= ?aand ?aanc)
                  (= ?aand ?zpl)
                  )
                (= ?aanc ?zpl)
                )
              )
            (and (or (or (= ?aanb ?aana)
                  (= ?aanb ?zpl)
                  )
                (= ?aana ?zpl)
                )
              (and (and (not (= ?aand ?aanc))
                  (not (= ?aand ?zpl))
                  )
                (not (= ?aanc ?zpl))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?aane Real)
    (declare-const ?aanf Real)
    (declare-const ?aang Real)
    (push 1)
      (declare-const ?aanh Real)
      (declare-const ?aani Real)
      (declare-const ?aanj Real)
      (assert
        (or (or (= ?aanj ?aani)
            (= ?aanj ?aanh)
            )
          (= ?aani ?aanh)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aank Real)
      (declare-const ?aanl Real)
      (declare-const ?aanm Real)
      (declare-const ?aann Real)
      (assert
        (or (or (= ?aann ?aanm)
            (= ?aann ?aanl)
            )
          (= ?aanm ?aanl)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aano Real)
      (declare-const ?aanp Real)
      (declare-const ?aanq Real)
      (declare-const ?aanr Real)
      (declare-const ?aans Real)
      (assert
        (or (or (= ?aans ?aanr)
            (= ?aans ?aanq)
            )
          (= ?aanr ?aanq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aant Real)
      (declare-const ?aanu Real)
      (declare-const ?aanv Real)
      (declare-const ?aanw Real)
      (declare-const ?aanx Real)
      (declare-const ?aany Real)
      (assert
        (and (and (and (not (= ?aanv ?aanu))
              (not (= ?aanv ?aant))
              )
            (not (= ?aanu ?aant))
            )
          (or (or (= ?aany ?aanx)
              (= ?aany ?aanw)
              )
            (= ?aanx ?aanw)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aanz Real)
      (declare-const ?aaoa Real)
      (declare-const ?aaob Real)
      (assert
        (or (or (= ?aaob ?aaoa)
            (= ?aaob ?aanz)
            )
          (= ?aaoa ?aanz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaoc Real)
      (declare-const ?aaod Real)
      (declare-const ?aaoe Real)
      (assert
        (or (or (= ?aaoe ?aaod)
            (= ?aaoe ?aaoc)
            )
          (= ?aaod ?aaoc)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaof Real)
      (declare-const ?aaog Real)
      (declare-const ?aaoh Real)
      (declare-const ?aaoi Real)
      (assert
        (or (or (= ?aaoh ?aaog)
            (= ?aaoh ?aaof)
            )
          (= ?aaog ?aaof)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaoj Real)
      (declare-const ?aaok Real)
      (declare-const ?aaol Real)
      (declare-const ?aaom Real)
      (declare-const ?aaon Real)
      (assert
        (or (or (= ?aaol ?aaok)
            (= ?aaol ?aaoj)
            )
          (= ?aaok ?aaoj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaoo Real)
      (declare-const ?aaop Real)
      (declare-const ?aaoq Real)
      (declare-const ?aaor Real)
      (declare-const ?aaos Real)
      (declare-const ?aaot Real)
      (assert
        (and (or (or (= ?aaoq ?aaop)
              (= ?aaoq ?aaoo)
              )
            (= ?aaop ?aaoo)
            )
          (and (and (not (= ?aaot ?aaos))
              (not (= ?aaot ?aaor))
              )
            (not (= ?aaos ?aaor))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaou Real)
      (declare-const ?aaov Real)
      (declare-const ?aaow Real)
      (assert
        (or (or (= ?aaow ?aaov)
            (= ?aaow ?aaou)
            )
          (= ?aaov ?aaou)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaox Real)
      (declare-const ?aaoy Real)
      (declare-const ?aaoz Real)
      (declare-const ?aapa Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?aaoy ?aaox))
                  (not (= ?aaoy ?asi))
                  )
                (not (= ?aaox ?asi))
                )
              (or (or (= ?aapa ?aaoz)
                  (= ?aapa ?asi)
                  )
                (= ?aaoz ?asi)
                )
              )
            (and (or (or (= ?aaoy ?aaox)
                  (= ?aaoy ?asi)
                  )
                (= ?aaox ?asi)
                )
              (and (and (not (= ?aapa ?aaoz))
                  (not (= ?aapa ?asi))
                  )
                (not (= ?aaoz ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aapb Real)
      (declare-const ?aapc Real)
      (declare-const ?aapd Real)
      (declare-const ?aape Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?aapc ?aapb))
                  (not (= ?aapc ?fkf))
                  )
                (not (= ?aapb ?fkf))
                )
              (or (or (= ?aape ?aapd)
                  (= ?aape ?fkf)
                  )
                (= ?aapd ?fkf)
                )
              )
            (and (or (or (= ?aapc ?aapb)
                  (= ?aapc ?fkf)
                  )
                (= ?aapb ?fkf)
                )
              (and (and (not (= ?aape ?aapd))
                  (not (= ?aape ?fkf))
                  )
                (not (= ?aapd ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aapf Real)
      (declare-const ?aapg Real)
      (declare-const ?aaph Real)
      (declare-const ?aapi Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?aapg ?aapf))
                  (not (= ?aapg ?mzs))
                  )
                (not (= ?aapf ?mzs))
                )
              (or (or (= ?aapi ?aaph)
                  (= ?aapi ?mzs)
                  )
                (= ?aaph ?mzs)
                )
              )
            (and (or (or (= ?aapg ?aapf)
                  (= ?aapg ?mzs)
                  )
                (= ?aapf ?mzs)
                )
              (and (and (not (= ?aapi ?aaph))
                  (not (= ?aapi ?mzs))
                  )
                (not (= ?aaph ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aapj Real)
      (declare-const ?aapk Real)
      (declare-const ?aapl Real)
      (declare-const ?aapm Real)
      (assert
        (exists ((?zpl Real) )(or (and (and (and (not (= ?aapk ?aapj))
                  (not (= ?aapk ?zpl))
                  )
                (not (= ?aapj ?zpl))
                )
              (or (or (= ?aapm ?aapl)
                  (= ?aapm ?zpl)
                  )
                (= ?aapl ?zpl)
                )
              )
            (and (or (or (= ?aapk ?aapj)
                  (= ?aapk ?zpl)
                  )
                (= ?aapj ?zpl)
                )
              (and (and (not (= ?aapm ?aapl))
                  (not (= ?aapm ?zpl))
                  )
                (not (= ?aapl ?zpl))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (or (= ?aang ?aanf)
            (= ?aang ?aane)
            )
          (= ?aanf ?aane)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?aapn Real)
    (declare-const ?aapo Real)
    (declare-const ?aapp Real)
    (push 1)
      (declare-const ?aapq Real)
      (declare-const ?aapr Real)
      (declare-const ?aaps Real)
      (assert
        (or (or (= ?aaps ?aapr)
            (= ?aaps ?aapq)
            )
          (= ?aapr ?aapq)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aapt Real)
      (declare-const ?aapu Real)
      (declare-const ?aapv Real)
      (declare-const ?aapw Real)
      (assert
        (or (or (= ?aapw ?aapv)
            (= ?aapw ?aapu)
            )
          (= ?aapv ?aapu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aapx Real)
      (declare-const ?aapy Real)
      (declare-const ?aapz Real)
      (declare-const ?aaqa Real)
      (declare-const ?aaqb Real)
      (assert
        (or (or (= ?aaqb ?aaqa)
            (= ?aaqb ?aapz)
            )
          (= ?aaqa ?aapz)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaqc Real)
      (declare-const ?aaqd Real)
      (declare-const ?aaqe Real)
      (declare-const ?aaqf Real)
      (declare-const ?aaqg Real)
      (declare-const ?aaqh Real)
      (assert
        (and (and (and (not (= ?aaqe ?aaqd))
              (not (= ?aaqe ?aaqc))
              )
            (not (= ?aaqd ?aaqc))
            )
          (or (or (= ?aaqh ?aaqg)
              (= ?aaqh ?aaqf)
              )
            (= ?aaqg ?aaqf)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaqi Real)
      (declare-const ?aaqj Real)
      (declare-const ?aaqk Real)
      (assert
        (or (or (= ?aaqk ?aaqj)
            (= ?aaqk ?aaqi)
            )
          (= ?aaqj ?aaqi)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaql Real)
      (declare-const ?aaqm Real)
      (declare-const ?aaqn Real)
      (assert
        (or (or (= ?aaqn ?aaqm)
            (= ?aaqn ?aaql)
            )
          (= ?aaqm ?aaql)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaqo Real)
      (declare-const ?aaqp Real)
      (declare-const ?aaqq Real)
      (declare-const ?aaqr Real)
      (assert
        (or (or (= ?aaqq ?aaqp)
            (= ?aaqq ?aaqo)
            )
          (= ?aaqp ?aaqo)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaqs Real)
      (declare-const ?aaqt Real)
      (declare-const ?aaqu Real)
      (declare-const ?aaqv Real)
      (declare-const ?aaqw Real)
      (assert
        (or (or (= ?aaqu ?aaqt)
            (= ?aaqu ?aaqs)
            )
          (= ?aaqt ?aaqs)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaqx Real)
      (declare-const ?aaqy Real)
      (declare-const ?aaqz Real)
      (declare-const ?aara Real)
      (declare-const ?aarb Real)
      (declare-const ?aarc Real)
      (assert
        (and (or (or (= ?aaqz ?aaqy)
              (= ?aaqz ?aaqx)
              )
            (= ?aaqy ?aaqx)
            )
          (and (and (not (= ?aarc ?aarb))
              (not (= ?aarc ?aara))
              )
            (not (= ?aarb ?aara))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aard Real)
      (declare-const ?aare Real)
      (declare-const ?aarf Real)
      (assert
        (or (or (= ?aarf ?aare)
            (= ?aarf ?aard)
            )
          (= ?aare ?aard)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aarg Real)
      (declare-const ?aarh Real)
      (declare-const ?aari Real)
      (declare-const ?aarj Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?aarh ?aarg))
                  (not (= ?aarh ?asi))
                  )
                (not (= ?aarg ?asi))
                )
              (or (or (= ?aarj ?aari)
                  (= ?aarj ?asi)
                  )
                (= ?aari ?asi)
                )
              )
            (and (or (or (= ?aarh ?aarg)
                  (= ?aarh ?asi)
                  )
                (= ?aarg ?asi)
                )
              (and (and (not (= ?aarj ?aari))
                  (not (= ?aarj ?asi))
                  )
                (not (= ?aari ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aark Real)
      (declare-const ?aarl Real)
      (declare-const ?aarm Real)
      (declare-const ?aarn Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?aarl ?aark))
                  (not (= ?aarl ?fkf))
                  )
                (not (= ?aark ?fkf))
                )
              (or (or (= ?aarn ?aarm)
                  (= ?aarn ?fkf)
                  )
                (= ?aarm ?fkf)
                )
              )
            (and (or (or (= ?aarl ?aark)
                  (= ?aarl ?fkf)
                  )
                (= ?aark ?fkf)
                )
              (and (and (not (= ?aarn ?aarm))
                  (not (= ?aarn ?fkf))
                  )
                (not (= ?aarm ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaro Real)
      (declare-const ?aarp Real)
      (declare-const ?aarq Real)
      (declare-const ?aarr Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?aarp ?aaro))
                  (not (= ?aarp ?mzs))
                  )
                (not (= ?aaro ?mzs))
                )
              (or (or (= ?aarr ?aarq)
                  (= ?aarr ?mzs)
                  )
                (= ?aarq ?mzs)
                )
              )
            (and (or (or (= ?aarp ?aaro)
                  (= ?aarp ?mzs)
                  )
                (= ?aaro ?mzs)
                )
              (and (and (not (= ?aarr ?aarq))
                  (not (= ?aarr ?mzs))
                  )
                (not (= ?aarq ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aars Real)
      (declare-const ?aart Real)
      (declare-const ?aaru Real)
      (declare-const ?aarv Real)
      (assert
        (exists ((?zpl Real) )(or (and (and (and (not (= ?aart ?aars))
                  (not (= ?aart ?zpl))
                  )
                (not (= ?aars ?zpl))
                )
              (or (or (= ?aarv ?aaru)
                  (= ?aarv ?zpl)
                  )
                (= ?aaru ?zpl)
                )
              )
            (and (or (or (= ?aart ?aars)
                  (= ?aart ?zpl)
                  )
                (= ?aars ?zpl)
                )
              (and (and (not (= ?aarv ?aaru))
                  (not (= ?aarv ?zpl))
                  )
                (not (= ?aaru ?zpl))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?aarw Real)
      (declare-const ?aarx Real)
      (declare-const ?aary Real)
      (assert
        (or (or (= ?aary ?aarx)
            (= ?aary ?aarw)
            )
          (= ?aarx ?aarw)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aarz Real)
      (declare-const ?aasa Real)
      (declare-const ?aasb Real)
      (declare-const ?aasc Real)
      (assert
        (or (or (= ?aasc ?aasb)
            (= ?aasc ?aasa)
            )
          (= ?aasb ?aasa)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aasd Real)
      (declare-const ?aase Real)
      (declare-const ?aasf Real)
      (declare-const ?aasg Real)
      (declare-const ?aash Real)
      (assert
        (or (or (= ?aash ?aasg)
            (= ?aash ?aasf)
            )
          (= ?aasg ?aasf)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aasi Real)
      (declare-const ?aasj Real)
      (declare-const ?aask Real)
      (declare-const ?aasl Real)
      (declare-const ?aasm Real)
      (declare-const ?aasn Real)
      (assert
        (and (and (and (not (= ?aask ?aasj))
              (not (= ?aask ?aasi))
              )
            (not (= ?aasj ?aasi))
            )
          (or (or (= ?aasn ?aasm)
              (= ?aasn ?aasl)
              )
            (= ?aasm ?aasl)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaso Real)
      (declare-const ?aasp Real)
      (declare-const ?aasq Real)
      (assert
        (or (or (= ?aasq ?aasp)
            (= ?aasq ?aaso)
            )
          (= ?aasp ?aaso)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aasr Real)
      (declare-const ?aass Real)
      (declare-const ?aast Real)
      (assert
        (or (or (= ?aast ?aass)
            (= ?aast ?aasr)
            )
          (= ?aass ?aasr)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aasu Real)
      (declare-const ?aasv Real)
      (declare-const ?aasw Real)
      (declare-const ?aasx Real)
      (assert
        (or (or (= ?aasw ?aasv)
            (= ?aasw ?aasu)
            )
          (= ?aasv ?aasu)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aasy Real)
      (declare-const ?aasz Real)
      (declare-const ?aata Real)
      (declare-const ?aatb Real)
      (declare-const ?aatc Real)
      (assert
        (or (or (= ?aata ?aasz)
            (= ?aata ?aasy)
            )
          (= ?aasz ?aasy)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aatd Real)
      (declare-const ?aate Real)
      (declare-const ?aatf Real)
      (declare-const ?aatg Real)
      (declare-const ?aath Real)
      (declare-const ?aati Real)
      (assert
        (and (or (or (= ?aatf ?aate)
              (= ?aatf ?aatd)
              )
            (= ?aate ?aatd)
            )
          (and (and (not (= ?aati ?aath))
              (not (= ?aati ?aatg))
              )
            (not (= ?aath ?aatg))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aatj Real)
      (declare-const ?aatk Real)
      (declare-const ?aatl Real)
      (assert
        (or (or (= ?aatl ?aatk)
            (= ?aatl ?aatj)
            )
          (= ?aatk ?aatj)
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aatm Real)
      (declare-const ?aatn Real)
      (declare-const ?aato Real)
      (declare-const ?aatp Real)
      (assert
        (exists ((?asi Real) )(or (and (and (and (not (= ?aatn ?aatm))
                  (not (= ?aatn ?asi))
                  )
                (not (= ?aatm ?asi))
                )
              (or (or (= ?aatp ?aato)
                  (= ?aatp ?asi)
                  )
                (= ?aato ?asi)
                )
              )
            (and (or (or (= ?aatn ?aatm)
                  (= ?aatn ?asi)
                  )
                (= ?aatm ?asi)
                )
              (and (and (not (= ?aatp ?aato))
                  (not (= ?aatp ?asi))
                  )
                (not (= ?aato ?asi))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aatq Real)
      (declare-const ?aatr Real)
      (declare-const ?aats Real)
      (declare-const ?aatt Real)
      (assert
        (exists ((?fkf Real) )(or (and (and (and (not (= ?aatr ?aatq))
                  (not (= ?aatr ?fkf))
                  )
                (not (= ?aatq ?fkf))
                )
              (or (or (= ?aatt ?aats)
                  (= ?aatt ?fkf)
                  )
                (= ?aats ?fkf)
                )
              )
            (and (or (or (= ?aatr ?aatq)
                  (= ?aatr ?fkf)
                  )
                (= ?aatq ?fkf)
                )
              (and (and (not (= ?aatt ?aats))
                  (not (= ?aatt ?fkf))
                  )
                (not (= ?aats ?fkf))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aatu Real)
      (declare-const ?aatv Real)
      (declare-const ?aatw Real)
      (declare-const ?aatx Real)
      (assert
        (exists ((?mzs Real) )(or (and (and (and (not (= ?aatv ?aatu))
                  (not (= ?aatv ?mzs))
                  )
                (not (= ?aatu ?mzs))
                )
              (or (or (= ?aatx ?aatw)
                  (= ?aatx ?mzs)
                  )
                (= ?aatw ?mzs)
                )
              )
            (and (or (or (= ?aatv ?aatu)
                  (= ?aatv ?mzs)
                  )
                (= ?aatu ?mzs)
                )
              (and (and (not (= ?aatx ?aatw))
                  (not (= ?aatx ?mzs))
                  )
                (not (= ?aatw ?mzs))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aaty Real)
      (declare-const ?aatz Real)
      (declare-const ?aaua Real)
      (declare-const ?aaub Real)
      (assert
        (exists ((?zpl Real) )(or (and (and (and (not (= ?aatz ?aaty))
                  (not (= ?aatz ?zpl))
                  )
                (not (= ?aaty ?zpl))
                )
              (or (or (= ?aaub ?aaua)
                  (= ?aaub ?zpl)
                  )
                (= ?aaua ?zpl)
                )
              )
            (and (or (or (= ?aatz ?aaty)
                  (= ?aatz ?zpl)
                  )
                (= ?aaty ?zpl)
                )
              (and (and (not (= ?aaub ?aaua))
                  (not (= ?aaub ?zpl))
                  )
                (not (= ?aaua ?zpl))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aauc Real)
  (declare-const ?aaud Real)
  (declare-const ?aaue Real)
  (assert
    (or (or (= ?aaue ?aaud)
        (= ?aaue ?aauc)
        )
      (= ?aaud ?aauc)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?aauf Real)
    (declare-const ?aaug Real)
    (declare-const ?aauh Real)
    (assert
      (or (or (= ?aauh ?aaug)
          (= ?aauh ?aauf)
          )
        (= ?aaug ?aauf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aaui Real)
    (declare-const ?aauj Real)
    (declare-const ?aauk Real)
    (declare-const ?aaul Real)
    (assert
      (or (or (= ?aaul ?aauk)
          (= ?aaul ?aauj)
          )
        (= ?aauk ?aauj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aaum Real)
    (declare-const ?aaun Real)
    (declare-const ?aauo Real)
    (declare-const ?aaup Real)
    (declare-const ?aauq Real)
    (assert
      (or (or (= ?aauq ?aaup)
          (= ?aauq ?aauo)
          )
        (= ?aaup ?aauo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aaur Real)
    (declare-const ?aaus Real)
    (declare-const ?aaut Real)
    (declare-const ?aauu Real)
    (declare-const ?aauv Real)
    (declare-const ?aauw Real)
    (assert
      (and (and (and (not (= ?aaut ?aaus))
            (not (= ?aaut ?aaur))
            )
          (not (= ?aaus ?aaur))
          )
        (or (or (= ?aauw ?aauv)
            (= ?aauw ?aauu)
            )
          (= ?aauv ?aauu)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aaux Real)
    (declare-const ?aauy Real)
    (declare-const ?aauz Real)
    (assert
      (or (or (= ?aauz ?aauy)
          (= ?aauz ?aaux)
          )
        (= ?aauy ?aaux)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aava Real)
    (declare-const ?aavb Real)
    (declare-const ?aavc Real)
    (assert
      (or (or (= ?aavc ?aavb)
          (= ?aavc ?aava)
          )
        (= ?aavb ?aava)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aavd Real)
    (declare-const ?aave Real)
    (declare-const ?aavf Real)
    (declare-const ?aavg Real)
    (assert
      (or (or (= ?aavf ?aave)
          (= ?aavf ?aavd)
          )
        (= ?aave ?aavd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aavh Real)
    (declare-const ?aavi Real)
    (declare-const ?aavj Real)
    (declare-const ?aavk Real)
    (declare-const ?aavl Real)
    (assert
      (or (or (= ?aavj ?aavi)
          (= ?aavj ?aavh)
          )
        (= ?aavi ?aavh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aavm Real)
    (declare-const ?aavn Real)
    (declare-const ?aavo Real)
    (declare-const ?aavp Real)
    (declare-const ?aavq Real)
    (declare-const ?aavr Real)
    (assert
      (and (or (or (= ?aavo ?aavn)
            (= ?aavo ?aavm)
            )
          (= ?aavn ?aavm)
          )
        (and (and (not (= ?aavr ?aavq))
            (not (= ?aavr ?aavp))
            )
          (not (= ?aavq ?aavp))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aavs Real)
    (declare-const ?aavt Real)
    (declare-const ?aavu Real)
    (assert
      (or (or (= ?aavu ?aavt)
          (= ?aavu ?aavs)
          )
        (= ?aavt ?aavs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aavv Real)
    (declare-const ?aavw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aavx Real)
    (declare-const ?aavy Real)
    (declare-const ?aavz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aawa Real)
    (declare-const ?aawb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aawc Real)
    (declare-const ?aawd Real)
    (declare-const ?aawe Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aawf Real)
    (declare-const ?aawg Real)
    (declare-const ?aawh Real)
    (declare-const ?aawi Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aawg ?aawf))
                (not (= ?aawg ?asi))
                )
              (not (= ?aawf ?asi))
              )
            (or (or (= ?aawi ?aawh)
                (= ?aawi ?asi)
                )
              (= ?aawh ?asi)
              )
            )
          (and (or (or (= ?aawg ?aawf)
                (= ?aawg ?asi)
                )
              (= ?aawf ?asi)
              )
            (and (and (not (= ?aawi ?aawh))
                (not (= ?aawi ?asi))
                )
              (not (= ?aawh ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aawj Real)
    (declare-const ?aawk Real)
    (declare-const ?aawl Real)
    (declare-const ?aawm Real)
    (declare-const ?aawn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aawo Real)
    (declare-const ?aawp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aawq Real)
    (declare-const ?aawr Real)
    (declare-const ?aaws Real)
    (declare-const ?aawt Real)
    (declare-const ?aawu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aawv Real)
    (declare-const ?aaww Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aawx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aawy Real)
    (declare-const ?aawz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aaxa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aaxb Real)
    (declare-const ?aaxc Real)
    (assert
      (not (= ?aaxb ?aaxc))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aaxd Real)
    (declare-const ?aaxe Real)
    (declare-const ?aaxf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aaxg Real)
    (declare-const ?aaxh Real)
    (declare-const ?aaxi Real)
    (declare-const ?aaxj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aaxk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aaxl Real)
    (declare-const ?aaxm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aaxn Real)
    (declare-const ?aaxo Real)
    (declare-const ?aaxp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aaxq Real)
    (declare-const ?aaxr Real)
    (declare-const ?aaxs Real)
    (declare-const ?aaxt Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aaxr ?aaxq))
                (not (= ?aaxr ?fkf))
                )
              (not (= ?aaxq ?fkf))
              )
            (or (or (= ?aaxt ?aaxs)
                (= ?aaxt ?fkf)
                )
              (= ?aaxs ?fkf)
              )
            )
          (and (or (or (= ?aaxr ?aaxq)
                (= ?aaxr ?fkf)
                )
              (= ?aaxq ?fkf)
              )
            (and (and (not (= ?aaxt ?aaxs))
                (not (= ?aaxt ?fkf))
                )
              (not (= ?aaxs ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aaxu Real)
    (declare-const ?aaxv Real)
    (declare-const ?aaxw Real)
    (declare-const ?aaxx Real)
    (declare-const ?aaxy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aaxz Real)
    (declare-const ?aaya Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aayb Real)
    (declare-const ?aayc Real)
    (declare-const ?aayd Real)
    (declare-const ?aaye Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aayf Real)
    (declare-const ?aayg Real)
    (declare-const ?aayh Real)
    (declare-const ?aayi Real)
    (declare-const ?aayj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aayk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aayl Real)
    (declare-const ?aaym Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aayn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aayo Real)
    (declare-const ?aayp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aayq Real)
    (declare-const ?aayr Real)
    (declare-const ?aays Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aayt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aayu Real)
    (declare-const ?aayv Real)
    (assert
      (not (= ?aayu ?aayv))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aayw Real)
    (declare-const ?aayx Real)
    (declare-const ?aayy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aayz Real)
    (declare-const ?aaza Real)
    (declare-const ?aazb Real)
    (declare-const ?aazc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aazd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aaze Real)
    (declare-const ?aazf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aazg Real)
    (declare-const ?aazh Real)
    (declare-const ?aazi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aazj Real)
    (declare-const ?aazk Real)
    (declare-const ?aazl Real)
    (declare-const ?aazm Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aazk ?aazj))
                (not (= ?aazk ?mzs))
                )
              (not (= ?aazj ?mzs))
              )
            (or (or (= ?aazm ?aazl)
                (= ?aazm ?mzs)
                )
              (= ?aazl ?mzs)
              )
            )
          (and (or (or (= ?aazk ?aazj)
                (= ?aazk ?mzs)
                )
              (= ?aazj ?mzs)
              )
            (and (and (not (= ?aazm ?aazl))
                (not (= ?aazm ?mzs))
                )
              (not (= ?aazl ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aazn Real)
    (declare-const ?aazo Real)
    (declare-const ?aazp Real)
    (declare-const ?aazq Real)
    (declare-const ?aazr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aazs Real)
    (declare-const ?aazt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aazu Real)
    (declare-const ?aazv Real)
    (declare-const ?aazw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aazx Real)
    (declare-const ?aazy Real)
    (declare-const ?aazz Real)
    (declare-const ?abaa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abab Real)
    (declare-const ?abac Real)
    (declare-const ?abad Real)
    (declare-const ?abae Real)
    (declare-const ?abaf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abag Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abah Real)
    (declare-const ?abai Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?abaj Real)
  (declare-const ?abak Real)
  (declare-const ?abal Real)
  (declare-const ?abam Real)
  (assert
    (or (or (= ?abam ?abal)
        (= ?abam ?abak)
        )
      (= ?abal ?abak)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?aban Real)
    (declare-const ?abao Real)
    (declare-const ?abap Real)
    (assert
      (or (or (= ?abap ?abao)
          (= ?abap ?aban)
          )
        (= ?abao ?aban)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abaq Real)
    (declare-const ?abar Real)
    (declare-const ?abas Real)
    (declare-const ?abat Real)
    (assert
      (or (or (= ?abat ?abas)
          (= ?abat ?abar)
          )
        (= ?abas ?abar)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abau Real)
    (declare-const ?abav Real)
    (declare-const ?abaw Real)
    (declare-const ?abax Real)
    (declare-const ?abay Real)
    (assert
      (or (or (= ?abay ?abax)
          (= ?abay ?abaw)
          )
        (= ?abax ?abaw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abaz Real)
    (declare-const ?abba Real)
    (declare-const ?abbb Real)
    (declare-const ?abbc Real)
    (declare-const ?abbd Real)
    (declare-const ?abbe Real)
    (assert
      (and (and (and (not (= ?abbb ?abba))
            (not (= ?abbb ?abaz))
            )
          (not (= ?abba ?abaz))
          )
        (or (or (= ?abbe ?abbd)
            (= ?abbe ?abbc)
            )
          (= ?abbd ?abbc)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abbf Real)
    (declare-const ?abbg Real)
    (declare-const ?abbh Real)
    (assert
      (or (or (= ?abbh ?abbg)
          (= ?abbh ?abbf)
          )
        (= ?abbg ?abbf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abbi Real)
    (declare-const ?abbj Real)
    (declare-const ?abbk Real)
    (assert
      (or (or (= ?abbk ?abbj)
          (= ?abbk ?abbi)
          )
        (= ?abbj ?abbi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abbl Real)
    (declare-const ?abbm Real)
    (declare-const ?abbn Real)
    (declare-const ?abbo Real)
    (assert
      (or (or (= ?abbn ?abbm)
          (= ?abbn ?abbl)
          )
        (= ?abbm ?abbl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abbp Real)
    (declare-const ?abbq Real)
    (declare-const ?abbr Real)
    (declare-const ?abbs Real)
    (declare-const ?abbt Real)
    (assert
      (or (or (= ?abbr ?abbq)
          (= ?abbr ?abbp)
          )
        (= ?abbq ?abbp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abbu Real)
    (declare-const ?abbv Real)
    (declare-const ?abbw Real)
    (declare-const ?abbx Real)
    (declare-const ?abby Real)
    (declare-const ?abbz Real)
    (assert
      (and (or (or (= ?abbw ?abbv)
            (= ?abbw ?abbu)
            )
          (= ?abbv ?abbu)
          )
        (and (and (not (= ?abbz ?abby))
            (not (= ?abbz ?abbx))
            )
          (not (= ?abby ?abbx))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abca Real)
    (declare-const ?abcb Real)
    (declare-const ?abcc Real)
    (assert
      (or (or (= ?abcc ?abcb)
          (= ?abcc ?abca)
          )
        (= ?abcb ?abca)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abcd Real)
    (declare-const ?abce Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abcf Real)
    (declare-const ?abcg Real)
    (declare-const ?abch Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abci Real)
    (declare-const ?abcj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abck Real)
    (declare-const ?abcl Real)
    (declare-const ?abcm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abcn Real)
    (declare-const ?abco Real)
    (declare-const ?abcp Real)
    (declare-const ?abcq Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?abco ?abcn))
                (not (= ?abco ?asi))
                )
              (not (= ?abcn ?asi))
              )
            (or (or (= ?abcq ?abcp)
                (= ?abcq ?asi)
                )
              (= ?abcp ?asi)
              )
            )
          (and (or (or (= ?abco ?abcn)
                (= ?abco ?asi)
                )
              (= ?abcn ?asi)
              )
            (and (and (not (= ?abcq ?abcp))
                (not (= ?abcq ?asi))
                )
              (not (= ?abcp ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abcr Real)
    (declare-const ?abcs Real)
    (declare-const ?abct Real)
    (declare-const ?abcu Real)
    (declare-const ?abcv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abcw Real)
    (declare-const ?abcx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abcy Real)
    (declare-const ?abcz Real)
    (declare-const ?abda Real)
    (declare-const ?abdb Real)
    (declare-const ?abdc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abdd Real)
    (declare-const ?abde Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abdf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abdg Real)
    (declare-const ?abdh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abdi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abdj Real)
    (declare-const ?abdk Real)
    (assert
      (not (= ?abdj ?abdk))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abdl Real)
    (declare-const ?abdm Real)
    (declare-const ?abdn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abdo Real)
    (declare-const ?abdp Real)
    (declare-const ?abdq Real)
    (declare-const ?abdr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abds Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abdt Real)
    (declare-const ?abdu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abdv Real)
    (declare-const ?abdw Real)
    (declare-const ?abdx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abdy Real)
    (declare-const ?abdz Real)
    (declare-const ?abea Real)
    (declare-const ?abeb Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?abdz ?abdy))
                (not (= ?abdz ?fkf))
                )
              (not (= ?abdy ?fkf))
              )
            (or (or (= ?abeb ?abea)
                (= ?abeb ?fkf)
                )
              (= ?abea ?fkf)
              )
            )
          (and (or (or (= ?abdz ?abdy)
                (= ?abdz ?fkf)
                )
              (= ?abdy ?fkf)
              )
            (and (and (not (= ?abeb ?abea))
                (not (= ?abeb ?fkf))
                )
              (not (= ?abea ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abec Real)
    (declare-const ?abed Real)
    (declare-const ?abee Real)
    (declare-const ?abef Real)
    (declare-const ?abeg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abeh Real)
    (declare-const ?abei Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abej Real)
    (declare-const ?abek Real)
    (declare-const ?abel Real)
    (declare-const ?abem Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aben Real)
    (declare-const ?abeo Real)
    (declare-const ?abep Real)
    (declare-const ?abeq Real)
    (declare-const ?aber Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abes Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abet Real)
    (declare-const ?abeu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abev Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abew Real)
    (declare-const ?abex Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abey Real)
    (declare-const ?abez Real)
    (declare-const ?abfa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abfb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abfc Real)
    (declare-const ?abfd Real)
    (assert
      (not (= ?abfc ?abfd))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abfe Real)
    (declare-const ?abff Real)
    (declare-const ?abfg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abfh Real)
    (declare-const ?abfi Real)
    (declare-const ?abfj Real)
    (declare-const ?abfk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abfl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abfm Real)
    (declare-const ?abfn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abfo Real)
    (declare-const ?abfp Real)
    (declare-const ?abfq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abfr Real)
    (declare-const ?abfs Real)
    (declare-const ?abft Real)
    (declare-const ?abfu Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?abfs ?abfr))
                (not (= ?abfs ?mzs))
                )
              (not (= ?abfr ?mzs))
              )
            (or (or (= ?abfu ?abft)
                (= ?abfu ?mzs)
                )
              (= ?abft ?mzs)
              )
            )
          (and (or (or (= ?abfs ?abfr)
                (= ?abfs ?mzs)
                )
              (= ?abfr ?mzs)
              )
            (and (and (not (= ?abfu ?abft))
                (not (= ?abfu ?mzs))
                )
              (not (= ?abft ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abfv Real)
    (declare-const ?abfw Real)
    (declare-const ?abfx Real)
    (declare-const ?abfy Real)
    (declare-const ?abfz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abga Real)
    (declare-const ?abgb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abgc Real)
    (declare-const ?abgd Real)
    (declare-const ?abge Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abgf Real)
    (declare-const ?abgg Real)
    (declare-const ?abgh Real)
    (declare-const ?abgi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abgj Real)
    (declare-const ?abgk Real)
    (declare-const ?abgl Real)
    (declare-const ?abgm Real)
    (declare-const ?abgn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abgo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abgp Real)
    (declare-const ?abgq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?abgr Real)
  (declare-const ?abgs Real)
  (declare-const ?abgt Real)
  (declare-const ?abgu Real)
  (declare-const ?abgv Real)
  (assert
    (or (or (= ?abgv ?abgu)
        (= ?abgv ?abgt)
        )
      (= ?abgu ?abgt)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?abgw Real)
    (declare-const ?abgx Real)
    (declare-const ?abgy Real)
    (assert
      (or (or (= ?abgy ?abgx)
          (= ?abgy ?abgw)
          )
        (= ?abgx ?abgw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abgz Real)
    (declare-const ?abha Real)
    (declare-const ?abhb Real)
    (declare-const ?abhc Real)
    (assert
      (or (or (= ?abhc ?abhb)
          (= ?abhc ?abha)
          )
        (= ?abhb ?abha)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abhd Real)
    (declare-const ?abhe Real)
    (declare-const ?abhf Real)
    (declare-const ?abhg Real)
    (declare-const ?abhh Real)
    (assert
      (or (or (= ?abhh ?abhg)
          (= ?abhh ?abhf)
          )
        (= ?abhg ?abhf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abhi Real)
    (declare-const ?abhj Real)
    (declare-const ?abhk Real)
    (declare-const ?abhl Real)
    (declare-const ?abhm Real)
    (declare-const ?abhn Real)
    (assert
      (and (and (and (not (= ?abhk ?abhj))
            (not (= ?abhk ?abhi))
            )
          (not (= ?abhj ?abhi))
          )
        (or (or (= ?abhn ?abhm)
            (= ?abhn ?abhl)
            )
          (= ?abhm ?abhl)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abho Real)
    (declare-const ?abhp Real)
    (declare-const ?abhq Real)
    (assert
      (or (or (= ?abhq ?abhp)
          (= ?abhq ?abho)
          )
        (= ?abhp ?abho)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abhr Real)
    (declare-const ?abhs Real)
    (declare-const ?abht Real)
    (assert
      (or (or (= ?abht ?abhs)
          (= ?abht ?abhr)
          )
        (= ?abhs ?abhr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abhu Real)
    (declare-const ?abhv Real)
    (declare-const ?abhw Real)
    (declare-const ?abhx Real)
    (assert
      (or (or (= ?abhw ?abhv)
          (= ?abhw ?abhu)
          )
        (= ?abhv ?abhu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abhy Real)
    (declare-const ?abhz Real)
    (declare-const ?abia Real)
    (declare-const ?abib Real)
    (declare-const ?abic Real)
    (assert
      (or (or (= ?abia ?abhz)
          (= ?abia ?abhy)
          )
        (= ?abhz ?abhy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abid Real)
    (declare-const ?abie Real)
    (declare-const ?abif Real)
    (declare-const ?abig Real)
    (declare-const ?abih Real)
    (declare-const ?abii Real)
    (assert
      (and (or (or (= ?abif ?abie)
            (= ?abif ?abid)
            )
          (= ?abie ?abid)
          )
        (and (and (not (= ?abii ?abih))
            (not (= ?abii ?abig))
            )
          (not (= ?abih ?abig))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abij Real)
    (declare-const ?abik Real)
    (declare-const ?abil Real)
    (assert
      (or (or (= ?abil ?abik)
          (= ?abil ?abij)
          )
        (= ?abik ?abij)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abim Real)
    (declare-const ?abin Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abio Real)
    (declare-const ?abip Real)
    (declare-const ?abiq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abir Real)
    (declare-const ?abis Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abit Real)
    (declare-const ?abiu Real)
    (declare-const ?abiv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abiw Real)
    (declare-const ?abix Real)
    (declare-const ?abiy Real)
    (declare-const ?abiz Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?abix ?abiw))
                (not (= ?abix ?asi))
                )
              (not (= ?abiw ?asi))
              )
            (or (or (= ?abiz ?abiy)
                (= ?abiz ?asi)
                )
              (= ?abiy ?asi)
              )
            )
          (and (or (or (= ?abix ?abiw)
                (= ?abix ?asi)
                )
              (= ?abiw ?asi)
              )
            (and (and (not (= ?abiz ?abiy))
                (not (= ?abiz ?asi))
                )
              (not (= ?abiy ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abja Real)
    (declare-const ?abjb Real)
    (declare-const ?abjc Real)
    (declare-const ?abjd Real)
    (declare-const ?abje Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abjf Real)
    (declare-const ?abjg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abjh Real)
    (declare-const ?abji Real)
    (declare-const ?abjj Real)
    (declare-const ?abjk Real)
    (declare-const ?abjl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abjm Real)
    (declare-const ?abjn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abjo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abjp Real)
    (declare-const ?abjq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abjr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abjs Real)
    (declare-const ?abjt Real)
    (assert
      (not (= ?abjs ?abjt))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abju Real)
    (declare-const ?abjv Real)
    (declare-const ?abjw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abjx Real)
    (declare-const ?abjy Real)
    (declare-const ?abjz Real)
    (declare-const ?abka Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abkb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abkc Real)
    (declare-const ?abkd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abke Real)
    (declare-const ?abkf Real)
    (declare-const ?abkg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abkh Real)
    (declare-const ?abki Real)
    (declare-const ?abkj Real)
    (declare-const ?abkk Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?abki ?abkh))
                (not (= ?abki ?fkf))
                )
              (not (= ?abkh ?fkf))
              )
            (or (or (= ?abkk ?abkj)
                (= ?abkk ?fkf)
                )
              (= ?abkj ?fkf)
              )
            )
          (and (or (or (= ?abki ?abkh)
                (= ?abki ?fkf)
                )
              (= ?abkh ?fkf)
              )
            (and (and (not (= ?abkk ?abkj))
                (not (= ?abkk ?fkf))
                )
              (not (= ?abkj ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abkl Real)
    (declare-const ?abkm Real)
    (declare-const ?abkn Real)
    (declare-const ?abko Real)
    (declare-const ?abkp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abkq Real)
    (declare-const ?abkr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abks Real)
    (declare-const ?abkt Real)
    (declare-const ?abku Real)
    (declare-const ?abkv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abkw Real)
    (declare-const ?abkx Real)
    (declare-const ?abky Real)
    (declare-const ?abkz Real)
    (declare-const ?abla Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ablb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ablc Real)
    (declare-const ?abld Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?able Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ablf Real)
    (declare-const ?ablg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ablh Real)
    (declare-const ?abli Real)
    (declare-const ?ablj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ablk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abll Real)
    (declare-const ?ablm Real)
    (assert
      (not (= ?abll ?ablm))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abln Real)
    (declare-const ?ablo Real)
    (declare-const ?ablp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ablq Real)
    (declare-const ?ablr Real)
    (declare-const ?abls Real)
    (declare-const ?ablt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ablu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ablv Real)
    (declare-const ?ablw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ablx Real)
    (declare-const ?ably Real)
    (declare-const ?ablz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abma Real)
    (declare-const ?abmb Real)
    (declare-const ?abmc Real)
    (declare-const ?abmd Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?abmb ?abma))
                (not (= ?abmb ?mzs))
                )
              (not (= ?abma ?mzs))
              )
            (or (or (= ?abmd ?abmc)
                (= ?abmd ?mzs)
                )
              (= ?abmc ?mzs)
              )
            )
          (and (or (or (= ?abmb ?abma)
                (= ?abmb ?mzs)
                )
              (= ?abma ?mzs)
              )
            (and (and (not (= ?abmd ?abmc))
                (not (= ?abmd ?mzs))
                )
              (not (= ?abmc ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abme Real)
    (declare-const ?abmf Real)
    (declare-const ?abmg Real)
    (declare-const ?abmh Real)
    (declare-const ?abmi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abmj Real)
    (declare-const ?abmk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abml Real)
    (declare-const ?abmm Real)
    (declare-const ?abmn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abmo Real)
    (declare-const ?abmp Real)
    (declare-const ?abmq Real)
    (declare-const ?abmr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abms Real)
    (declare-const ?abmt Real)
    (declare-const ?abmu Real)
    (declare-const ?abmv Real)
    (declare-const ?abmw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abmx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abmy Real)
    (declare-const ?abmz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?abna Real)
  (declare-const ?abnb Real)
  (declare-const ?abnc Real)
  (declare-const ?abnd Real)
  (declare-const ?abne Real)
  (declare-const ?abnf Real)
  (assert
    (and (and (and (not (= ?abnc ?abnb))
          (not (= ?abnc ?abna))
          )
        (not (= ?abnb ?abna))
        )
      (or (or (= ?abnf ?abne)
          (= ?abnf ?abnd)
          )
        (= ?abne ?abnd)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?abng Real)
    (declare-const ?abnh Real)
    (declare-const ?abni Real)
    (assert
      (or (or (= ?abni ?abnh)
          (= ?abni ?abng)
          )
        (= ?abnh ?abng)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abnj Real)
    (declare-const ?abnk Real)
    (declare-const ?abnl Real)
    (declare-const ?abnm Real)
    (assert
      (or (or (= ?abnm ?abnl)
          (= ?abnm ?abnk)
          )
        (= ?abnl ?abnk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abnn Real)
    (declare-const ?abno Real)
    (declare-const ?abnp Real)
    (declare-const ?abnq Real)
    (declare-const ?abnr Real)
    (assert
      (or (or (= ?abnr ?abnq)
          (= ?abnr ?abnp)
          )
        (= ?abnq ?abnp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abns Real)
    (declare-const ?abnt Real)
    (declare-const ?abnu Real)
    (declare-const ?abnv Real)
    (declare-const ?abnw Real)
    (declare-const ?abnx Real)
    (assert
      (and (and (and (not (= ?abnu ?abnt))
            (not (= ?abnu ?abns))
            )
          (not (= ?abnt ?abns))
          )
        (or (or (= ?abnx ?abnw)
            (= ?abnx ?abnv)
            )
          (= ?abnw ?abnv)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abny Real)
    (declare-const ?abnz Real)
    (declare-const ?aboa Real)
    (assert
      (or (or (= ?aboa ?abnz)
          (= ?aboa ?abny)
          )
        (= ?abnz ?abny)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abob Real)
    (declare-const ?aboc Real)
    (declare-const ?abod Real)
    (assert
      (or (or (= ?abod ?aboc)
          (= ?abod ?abob)
          )
        (= ?aboc ?abob)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aboe Real)
    (declare-const ?abof Real)
    (declare-const ?abog Real)
    (declare-const ?aboh Real)
    (assert
      (or (or (= ?abog ?abof)
          (= ?abog ?aboe)
          )
        (= ?abof ?aboe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aboi Real)
    (declare-const ?aboj Real)
    (declare-const ?abok Real)
    (declare-const ?abol Real)
    (declare-const ?abom Real)
    (assert
      (or (or (= ?abok ?aboj)
          (= ?abok ?aboi)
          )
        (= ?aboj ?aboi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abon Real)
    (declare-const ?aboo Real)
    (declare-const ?abop Real)
    (declare-const ?aboq Real)
    (declare-const ?abor Real)
    (declare-const ?abos Real)
    (assert
      (and (or (or (= ?abop ?aboo)
            (= ?abop ?abon)
            )
          (= ?aboo ?abon)
          )
        (and (and (not (= ?abos ?abor))
            (not (= ?abos ?aboq))
            )
          (not (= ?abor ?aboq))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abot Real)
    (declare-const ?abou Real)
    (declare-const ?abov Real)
    (assert
      (or (or (= ?abov ?abou)
          (= ?abov ?abot)
          )
        (= ?abou ?abot)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abow Real)
    (declare-const ?abox Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aboy Real)
    (declare-const ?aboz Real)
    (declare-const ?abpa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abpb Real)
    (declare-const ?abpc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abpd Real)
    (declare-const ?abpe Real)
    (declare-const ?abpf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abpg Real)
    (declare-const ?abph Real)
    (declare-const ?abpi Real)
    (declare-const ?abpj Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?abph ?abpg))
                (not (= ?abph ?asi))
                )
              (not (= ?abpg ?asi))
              )
            (or (or (= ?abpj ?abpi)
                (= ?abpj ?asi)
                )
              (= ?abpi ?asi)
              )
            )
          (and (or (or (= ?abph ?abpg)
                (= ?abph ?asi)
                )
              (= ?abpg ?asi)
              )
            (and (and (not (= ?abpj ?abpi))
                (not (= ?abpj ?asi))
                )
              (not (= ?abpi ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abpk Real)
    (declare-const ?abpl Real)
    (declare-const ?abpm Real)
    (declare-const ?abpn Real)
    (declare-const ?abpo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abpp Real)
    (declare-const ?abpq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abpr Real)
    (declare-const ?abps Real)
    (declare-const ?abpt Real)
    (declare-const ?abpu Real)
    (declare-const ?abpv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abpw Real)
    (declare-const ?abpx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abpy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abpz Real)
    (declare-const ?abqa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abqb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abqc Real)
    (declare-const ?abqd Real)
    (assert
      (not (= ?abqc ?abqd))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abqe Real)
    (declare-const ?abqf Real)
    (declare-const ?abqg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abqh Real)
    (declare-const ?abqi Real)
    (declare-const ?abqj Real)
    (declare-const ?abqk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abql Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abqm Real)
    (declare-const ?abqn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abqo Real)
    (declare-const ?abqp Real)
    (declare-const ?abqq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abqr Real)
    (declare-const ?abqs Real)
    (declare-const ?abqt Real)
    (declare-const ?abqu Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?abqs ?abqr))
                (not (= ?abqs ?fkf))
                )
              (not (= ?abqr ?fkf))
              )
            (or (or (= ?abqu ?abqt)
                (= ?abqu ?fkf)
                )
              (= ?abqt ?fkf)
              )
            )
          (and (or (or (= ?abqs ?abqr)
                (= ?abqs ?fkf)
                )
              (= ?abqr ?fkf)
              )
            (and (and (not (= ?abqu ?abqt))
                (not (= ?abqu ?fkf))
                )
              (not (= ?abqt ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abqv Real)
    (declare-const ?abqw Real)
    (declare-const ?abqx Real)
    (declare-const ?abqy Real)
    (declare-const ?abqz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abra Real)
    (declare-const ?abrb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abrc Real)
    (declare-const ?abrd Real)
    (declare-const ?abre Real)
    (declare-const ?abrf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abrg Real)
    (declare-const ?abrh Real)
    (declare-const ?abri Real)
    (declare-const ?abrj Real)
    (declare-const ?abrk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abrl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abrm Real)
    (declare-const ?abrn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abro Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abrp Real)
    (declare-const ?abrq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abrr Real)
    (declare-const ?abrs Real)
    (declare-const ?abrt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abru Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abrv Real)
    (declare-const ?abrw Real)
    (assert
      (not (= ?abrv ?abrw))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abrx Real)
    (declare-const ?abry Real)
    (declare-const ?abrz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?absa Real)
    (declare-const ?absb Real)
    (declare-const ?absc Real)
    (declare-const ?absd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abse Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?absf Real)
    (declare-const ?absg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?absh Real)
    (declare-const ?absi Real)
    (declare-const ?absj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?absk Real)
    (declare-const ?absl Real)
    (declare-const ?absm Real)
    (declare-const ?absn Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?absl ?absk))
                (not (= ?absl ?mzs))
                )
              (not (= ?absk ?mzs))
              )
            (or (or (= ?absn ?absm)
                (= ?absn ?mzs)
                )
              (= ?absm ?mzs)
              )
            )
          (and (or (or (= ?absl ?absk)
                (= ?absl ?mzs)
                )
              (= ?absk ?mzs)
              )
            (and (and (not (= ?absn ?absm))
                (not (= ?absn ?mzs))
                )
              (not (= ?absm ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abso Real)
    (declare-const ?absp Real)
    (declare-const ?absq Real)
    (declare-const ?absr Real)
    (declare-const ?abss Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abst Real)
    (declare-const ?absu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?absv Real)
    (declare-const ?absw Real)
    (declare-const ?absx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?absy Real)
    (declare-const ?absz Real)
    (declare-const ?abta Real)
    (declare-const ?abtb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abtc Real)
    (declare-const ?abtd Real)
    (declare-const ?abte Real)
    (declare-const ?abtf Real)
    (declare-const ?abtg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abth Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abti Real)
    (declare-const ?abtj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?abtk Real)
  (declare-const ?abtl Real)
  (declare-const ?abtm Real)
  (assert
    (or (or (= ?abtm ?abtl)
        (= ?abtm ?abtk)
        )
      (= ?abtl ?abtk)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?abtn Real)
    (declare-const ?abto Real)
    (declare-const ?abtp Real)
    (assert
      (or (or (= ?abtp ?abto)
          (= ?abtp ?abtn)
          )
        (= ?abto ?abtn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abtq Real)
    (declare-const ?abtr Real)
    (declare-const ?abts Real)
    (declare-const ?abtt Real)
    (assert
      (or (or (= ?abtt ?abts)
          (= ?abtt ?abtr)
          )
        (= ?abts ?abtr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abtu Real)
    (declare-const ?abtv Real)
    (declare-const ?abtw Real)
    (declare-const ?abtx Real)
    (declare-const ?abty Real)
    (assert
      (or (or (= ?abty ?abtx)
          (= ?abty ?abtw)
          )
        (= ?abtx ?abtw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abtz Real)
    (declare-const ?abua Real)
    (declare-const ?abub Real)
    (declare-const ?abuc Real)
    (declare-const ?abud Real)
    (declare-const ?abue Real)
    (assert
      (and (and (and (not (= ?abub ?abua))
            (not (= ?abub ?abtz))
            )
          (not (= ?abua ?abtz))
          )
        (or (or (= ?abue ?abud)
            (= ?abue ?abuc)
            )
          (= ?abud ?abuc)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abuf Real)
    (declare-const ?abug Real)
    (declare-const ?abuh Real)
    (assert
      (or (or (= ?abuh ?abug)
          (= ?abuh ?abuf)
          )
        (= ?abug ?abuf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abui Real)
    (declare-const ?abuj Real)
    (declare-const ?abuk Real)
    (assert
      (or (or (= ?abuk ?abuj)
          (= ?abuk ?abui)
          )
        (= ?abuj ?abui)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abul Real)
    (declare-const ?abum Real)
    (declare-const ?abun Real)
    (declare-const ?abuo Real)
    (assert
      (or (or (= ?abun ?abum)
          (= ?abun ?abul)
          )
        (= ?abum ?abul)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abup Real)
    (declare-const ?abuq Real)
    (declare-const ?abur Real)
    (declare-const ?abus Real)
    (declare-const ?abut Real)
    (assert
      (or (or (= ?abur ?abuq)
          (= ?abur ?abup)
          )
        (= ?abuq ?abup)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abuu Real)
    (declare-const ?abuv Real)
    (declare-const ?abuw Real)
    (declare-const ?abux Real)
    (declare-const ?abuy Real)
    (declare-const ?abuz Real)
    (assert
      (and (or (or (= ?abuw ?abuv)
            (= ?abuw ?abuu)
            )
          (= ?abuv ?abuu)
          )
        (and (and (not (= ?abuz ?abuy))
            (not (= ?abuz ?abux))
            )
          (not (= ?abuy ?abux))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abva Real)
    (declare-const ?abvb Real)
    (declare-const ?abvc Real)
    (assert
      (or (or (= ?abvc ?abvb)
          (= ?abvc ?abva)
          )
        (= ?abvb ?abva)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abvd Real)
    (declare-const ?abve Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abvf Real)
    (declare-const ?abvg Real)
    (declare-const ?abvh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abvi Real)
    (declare-const ?abvj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abvk Real)
    (declare-const ?abvl Real)
    (declare-const ?abvm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abvn Real)
    (declare-const ?abvo Real)
    (declare-const ?abvp Real)
    (declare-const ?abvq Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?abvo ?abvn))
                (not (= ?abvo ?asi))
                )
              (not (= ?abvn ?asi))
              )
            (or (or (= ?abvq ?abvp)
                (= ?abvq ?asi)
                )
              (= ?abvp ?asi)
              )
            )
          (and (or (or (= ?abvo ?abvn)
                (= ?abvo ?asi)
                )
              (= ?abvn ?asi)
              )
            (and (and (not (= ?abvq ?abvp))
                (not (= ?abvq ?asi))
                )
              (not (= ?abvp ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abvr Real)
    (declare-const ?abvs Real)
    (declare-const ?abvt Real)
    (declare-const ?abvu Real)
    (declare-const ?abvv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abvw Real)
    (declare-const ?abvx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abvy Real)
    (declare-const ?abvz Real)
    (declare-const ?abwa Real)
    (declare-const ?abwb Real)
    (declare-const ?abwc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abwd Real)
    (declare-const ?abwe Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abwf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abwg Real)
    (declare-const ?abwh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abwi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abwj Real)
    (declare-const ?abwk Real)
    (assert
      (not (= ?abwj ?abwk))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abwl Real)
    (declare-const ?abwm Real)
    (declare-const ?abwn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abwo Real)
    (declare-const ?abwp Real)
    (declare-const ?abwq Real)
    (declare-const ?abwr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abws Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abwt Real)
    (declare-const ?abwu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abwv Real)
    (declare-const ?abww Real)
    (declare-const ?abwx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abwy Real)
    (declare-const ?abwz Real)
    (declare-const ?abxa Real)
    (declare-const ?abxb Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?abwz ?abwy))
                (not (= ?abwz ?fkf))
                )
              (not (= ?abwy ?fkf))
              )
            (or (or (= ?abxb ?abxa)
                (= ?abxb ?fkf)
                )
              (= ?abxa ?fkf)
              )
            )
          (and (or (or (= ?abwz ?abwy)
                (= ?abwz ?fkf)
                )
              (= ?abwy ?fkf)
              )
            (and (and (not (= ?abxb ?abxa))
                (not (= ?abxb ?fkf))
                )
              (not (= ?abxa ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abxc Real)
    (declare-const ?abxd Real)
    (declare-const ?abxe Real)
    (declare-const ?abxf Real)
    (declare-const ?abxg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abxh Real)
    (declare-const ?abxi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abxj Real)
    (declare-const ?abxk Real)
    (declare-const ?abxl Real)
    (declare-const ?abxm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abxn Real)
    (declare-const ?abxo Real)
    (declare-const ?abxp Real)
    (declare-const ?abxq Real)
    (declare-const ?abxr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abxs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abxt Real)
    (declare-const ?abxu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abxv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abxw Real)
    (declare-const ?abxx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abxy Real)
    (declare-const ?abxz Real)
    (declare-const ?abya Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abyb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abyc Real)
    (declare-const ?abyd Real)
    (assert
      (not (= ?abyc ?abyd))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abye Real)
    (declare-const ?abyf Real)
    (declare-const ?abyg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abyh Real)
    (declare-const ?abyi Real)
    (declare-const ?abyj Real)
    (declare-const ?abyk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abyl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abym Real)
    (declare-const ?abyn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abyo Real)
    (declare-const ?abyp Real)
    (declare-const ?abyq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abyr Real)
    (declare-const ?abys Real)
    (declare-const ?abyt Real)
    (declare-const ?abyu Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?abys ?abyr))
                (not (= ?abys ?mzs))
                )
              (not (= ?abyr ?mzs))
              )
            (or (or (= ?abyu ?abyt)
                (= ?abyu ?mzs)
                )
              (= ?abyt ?mzs)
              )
            )
          (and (or (or (= ?abys ?abyr)
                (= ?abys ?mzs)
                )
              (= ?abyr ?mzs)
              )
            (and (and (not (= ?abyu ?abyt))
                (not (= ?abyu ?mzs))
                )
              (not (= ?abyt ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abyv Real)
    (declare-const ?abyw Real)
    (declare-const ?abyx Real)
    (declare-const ?abyy Real)
    (declare-const ?abyz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abza Real)
    (declare-const ?abzb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abzc Real)
    (declare-const ?abzd Real)
    (declare-const ?abze Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abzf Real)
    (declare-const ?abzg Real)
    (declare-const ?abzh Real)
    (declare-const ?abzi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abzj Real)
    (declare-const ?abzk Real)
    (declare-const ?abzl Real)
    (declare-const ?abzm Real)
    (declare-const ?abzn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abzo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abzp Real)
    (declare-const ?abzq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?abzr Real)
  (declare-const ?abzs Real)
  (declare-const ?abzt Real)
  (assert
    (or (or (= ?abzt ?abzs)
        (= ?abzt ?abzr)
        )
      (= ?abzs ?abzr)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?abzu Real)
    (declare-const ?abzv Real)
    (declare-const ?abzw Real)
    (assert
      (or (or (= ?abzw ?abzv)
          (= ?abzw ?abzu)
          )
        (= ?abzv ?abzu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?abzx Real)
    (declare-const ?abzy Real)
    (declare-const ?abzz Real)
    (declare-const ?acaa Real)
    (assert
      (or (or (= ?acaa ?abzz)
          (= ?acaa ?abzy)
          )
        (= ?abzz ?abzy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acab Real)
    (declare-const ?acac Real)
    (declare-const ?acad Real)
    (declare-const ?acae Real)
    (declare-const ?acaf Real)
    (assert
      (or (or (= ?acaf ?acae)
          (= ?acaf ?acad)
          )
        (= ?acae ?acad)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acag Real)
    (declare-const ?acah Real)
    (declare-const ?acai Real)
    (declare-const ?acaj Real)
    (declare-const ?acak Real)
    (declare-const ?acal Real)
    (assert
      (and (and (and (not (= ?acai ?acah))
            (not (= ?acai ?acag))
            )
          (not (= ?acah ?acag))
          )
        (or (or (= ?acal ?acak)
            (= ?acal ?acaj)
            )
          (= ?acak ?acaj)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acam Real)
    (declare-const ?acan Real)
    (declare-const ?acao Real)
    (assert
      (or (or (= ?acao ?acan)
          (= ?acao ?acam)
          )
        (= ?acan ?acam)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acap Real)
    (declare-const ?acaq Real)
    (declare-const ?acar Real)
    (assert
      (or (or (= ?acar ?acaq)
          (= ?acar ?acap)
          )
        (= ?acaq ?acap)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acas Real)
    (declare-const ?acat Real)
    (declare-const ?acau Real)
    (declare-const ?acav Real)
    (assert
      (or (or (= ?acau ?acat)
          (= ?acau ?acas)
          )
        (= ?acat ?acas)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acaw Real)
    (declare-const ?acax Real)
    (declare-const ?acay Real)
    (declare-const ?acaz Real)
    (declare-const ?acba Real)
    (assert
      (or (or (= ?acay ?acax)
          (= ?acay ?acaw)
          )
        (= ?acax ?acaw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acbb Real)
    (declare-const ?acbc Real)
    (declare-const ?acbd Real)
    (declare-const ?acbe Real)
    (declare-const ?acbf Real)
    (declare-const ?acbg Real)
    (assert
      (and (or (or (= ?acbd ?acbc)
            (= ?acbd ?acbb)
            )
          (= ?acbc ?acbb)
          )
        (and (and (not (= ?acbg ?acbf))
            (not (= ?acbg ?acbe))
            )
          (not (= ?acbf ?acbe))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acbh Real)
    (declare-const ?acbi Real)
    (declare-const ?acbj Real)
    (assert
      (or (or (= ?acbj ?acbi)
          (= ?acbj ?acbh)
          )
        (= ?acbi ?acbh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acbk Real)
    (declare-const ?acbl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acbm Real)
    (declare-const ?acbn Real)
    (declare-const ?acbo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acbp Real)
    (declare-const ?acbq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acbr Real)
    (declare-const ?acbs Real)
    (declare-const ?acbt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acbu Real)
    (declare-const ?acbv Real)
    (declare-const ?acbw Real)
    (declare-const ?acbx Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?acbv ?acbu))
                (not (= ?acbv ?asi))
                )
              (not (= ?acbu ?asi))
              )
            (or (or (= ?acbx ?acbw)
                (= ?acbx ?asi)
                )
              (= ?acbw ?asi)
              )
            )
          (and (or (or (= ?acbv ?acbu)
                (= ?acbv ?asi)
                )
              (= ?acbu ?asi)
              )
            (and (and (not (= ?acbx ?acbw))
                (not (= ?acbx ?asi))
                )
              (not (= ?acbw ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acby Real)
    (declare-const ?acbz Real)
    (declare-const ?acca Real)
    (declare-const ?accb Real)
    (declare-const ?accc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?accd Real)
    (declare-const ?acce Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?accf Real)
    (declare-const ?accg Real)
    (declare-const ?acch Real)
    (declare-const ?acci Real)
    (declare-const ?accj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acck Real)
    (declare-const ?accl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?accm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?accn Real)
    (declare-const ?acco Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?accp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?accq Real)
    (declare-const ?accr Real)
    (assert
      (not (= ?accq ?accr))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?accs Real)
    (declare-const ?acct Real)
    (declare-const ?accu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?accv Real)
    (declare-const ?accw Real)
    (declare-const ?accx Real)
    (declare-const ?accy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?accz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acda Real)
    (declare-const ?acdb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acdc Real)
    (declare-const ?acdd Real)
    (declare-const ?acde Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acdf Real)
    (declare-const ?acdg Real)
    (declare-const ?acdh Real)
    (declare-const ?acdi Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?acdg ?acdf))
                (not (= ?acdg ?fkf))
                )
              (not (= ?acdf ?fkf))
              )
            (or (or (= ?acdi ?acdh)
                (= ?acdi ?fkf)
                )
              (= ?acdh ?fkf)
              )
            )
          (and (or (or (= ?acdg ?acdf)
                (= ?acdg ?fkf)
                )
              (= ?acdf ?fkf)
              )
            (and (and (not (= ?acdi ?acdh))
                (not (= ?acdi ?fkf))
                )
              (not (= ?acdh ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acdj Real)
    (declare-const ?acdk Real)
    (declare-const ?acdl Real)
    (declare-const ?acdm Real)
    (declare-const ?acdn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acdo Real)
    (declare-const ?acdp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acdq Real)
    (declare-const ?acdr Real)
    (declare-const ?acds Real)
    (declare-const ?acdt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acdu Real)
    (declare-const ?acdv Real)
    (declare-const ?acdw Real)
    (declare-const ?acdx Real)
    (declare-const ?acdy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acdz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acea Real)
    (declare-const ?aceb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acec Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aced Real)
    (declare-const ?acee Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acef Real)
    (declare-const ?aceg Real)
    (declare-const ?aceh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acei Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acej Real)
    (declare-const ?acek Real)
    (assert
      (not (= ?acej ?acek))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acel Real)
    (declare-const ?acem Real)
    (declare-const ?acen Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aceo Real)
    (declare-const ?acep Real)
    (declare-const ?aceq Real)
    (declare-const ?acer Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aces Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acet Real)
    (declare-const ?aceu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acev Real)
    (declare-const ?acew Real)
    (declare-const ?acex Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acey Real)
    (declare-const ?acez Real)
    (declare-const ?acfa Real)
    (declare-const ?acfb Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?acez ?acey))
                (not (= ?acez ?mzs))
                )
              (not (= ?acey ?mzs))
              )
            (or (or (= ?acfb ?acfa)
                (= ?acfb ?mzs)
                )
              (= ?acfa ?mzs)
              )
            )
          (and (or (or (= ?acez ?acey)
                (= ?acez ?mzs)
                )
              (= ?acey ?mzs)
              )
            (and (and (not (= ?acfb ?acfa))
                (not (= ?acfb ?mzs))
                )
              (not (= ?acfa ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acfc Real)
    (declare-const ?acfd Real)
    (declare-const ?acfe Real)
    (declare-const ?acff Real)
    (declare-const ?acfg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acfh Real)
    (declare-const ?acfi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acfj Real)
    (declare-const ?acfk Real)
    (declare-const ?acfl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acfm Real)
    (declare-const ?acfn Real)
    (declare-const ?acfo Real)
    (declare-const ?acfp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acfq Real)
    (declare-const ?acfr Real)
    (declare-const ?acfs Real)
    (declare-const ?acft Real)
    (declare-const ?acfu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acfv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acfw Real)
    (declare-const ?acfx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?acfy Real)
  (declare-const ?acfz Real)
  (declare-const ?acga Real)
  (declare-const ?acgb Real)
  (assert
    (or (or (= ?acga ?acfz)
        (= ?acga ?acfy)
        )
      (= ?acfz ?acfy)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?acgc Real)
    (declare-const ?acgd Real)
    (declare-const ?acge Real)
    (assert
      (or (or (= ?acge ?acgd)
          (= ?acge ?acgc)
          )
        (= ?acgd ?acgc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acgf Real)
    (declare-const ?acgg Real)
    (declare-const ?acgh Real)
    (declare-const ?acgi Real)
    (assert
      (or (or (= ?acgi ?acgh)
          (= ?acgi ?acgg)
          )
        (= ?acgh ?acgg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acgj Real)
    (declare-const ?acgk Real)
    (declare-const ?acgl Real)
    (declare-const ?acgm Real)
    (declare-const ?acgn Real)
    (assert
      (or (or (= ?acgn ?acgm)
          (= ?acgn ?acgl)
          )
        (= ?acgm ?acgl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acgo Real)
    (declare-const ?acgp Real)
    (declare-const ?acgq Real)
    (declare-const ?acgr Real)
    (declare-const ?acgs Real)
    (declare-const ?acgt Real)
    (assert
      (and (and (and (not (= ?acgq ?acgp))
            (not (= ?acgq ?acgo))
            )
          (not (= ?acgp ?acgo))
          )
        (or (or (= ?acgt ?acgs)
            (= ?acgt ?acgr)
            )
          (= ?acgs ?acgr)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acgu Real)
    (declare-const ?acgv Real)
    (declare-const ?acgw Real)
    (assert
      (or (or (= ?acgw ?acgv)
          (= ?acgw ?acgu)
          )
        (= ?acgv ?acgu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acgx Real)
    (declare-const ?acgy Real)
    (declare-const ?acgz Real)
    (assert
      (or (or (= ?acgz ?acgy)
          (= ?acgz ?acgx)
          )
        (= ?acgy ?acgx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acha Real)
    (declare-const ?achb Real)
    (declare-const ?achc Real)
    (declare-const ?achd Real)
    (assert
      (or (or (= ?achc ?achb)
          (= ?achc ?acha)
          )
        (= ?achb ?acha)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ache Real)
    (declare-const ?achf Real)
    (declare-const ?achg Real)
    (declare-const ?achh Real)
    (declare-const ?achi Real)
    (assert
      (or (or (= ?achg ?achf)
          (= ?achg ?ache)
          )
        (= ?achf ?ache)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?achj Real)
    (declare-const ?achk Real)
    (declare-const ?achl Real)
    (declare-const ?achm Real)
    (declare-const ?achn Real)
    (declare-const ?acho Real)
    (assert
      (and (or (or (= ?achl ?achk)
            (= ?achl ?achj)
            )
          (= ?achk ?achj)
          )
        (and (and (not (= ?acho ?achn))
            (not (= ?acho ?achm))
            )
          (not (= ?achn ?achm))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?achp Real)
    (declare-const ?achq Real)
    (declare-const ?achr Real)
    (assert
      (or (or (= ?achr ?achq)
          (= ?achr ?achp)
          )
        (= ?achq ?achp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?achs Real)
    (declare-const ?acht Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?achu Real)
    (declare-const ?achv Real)
    (declare-const ?achw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?achx Real)
    (declare-const ?achy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?achz Real)
    (declare-const ?acia Real)
    (declare-const ?acib Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acic Real)
    (declare-const ?acid Real)
    (declare-const ?acie Real)
    (declare-const ?acif Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?acid ?acic))
                (not (= ?acid ?asi))
                )
              (not (= ?acic ?asi))
              )
            (or (or (= ?acif ?acie)
                (= ?acif ?asi)
                )
              (= ?acie ?asi)
              )
            )
          (and (or (or (= ?acid ?acic)
                (= ?acid ?asi)
                )
              (= ?acic ?asi)
              )
            (and (and (not (= ?acif ?acie))
                (not (= ?acif ?asi))
                )
              (not (= ?acie ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acig Real)
    (declare-const ?acih Real)
    (declare-const ?acii Real)
    (declare-const ?acij Real)
    (declare-const ?acik Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acil Real)
    (declare-const ?acim Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acin Real)
    (declare-const ?acio Real)
    (declare-const ?acip Real)
    (declare-const ?aciq Real)
    (declare-const ?acir Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acis Real)
    (declare-const ?acit Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aciu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aciv Real)
    (declare-const ?aciw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acix Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aciy Real)
    (declare-const ?aciz Real)
    (assert
      (not (= ?aciy ?aciz))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acja Real)
    (declare-const ?acjb Real)
    (declare-const ?acjc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acjd Real)
    (declare-const ?acje Real)
    (declare-const ?acjf Real)
    (declare-const ?acjg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acjh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acji Real)
    (declare-const ?acjj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acjk Real)
    (declare-const ?acjl Real)
    (declare-const ?acjm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acjn Real)
    (declare-const ?acjo Real)
    (declare-const ?acjp Real)
    (declare-const ?acjq Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?acjo ?acjn))
                (not (= ?acjo ?fkf))
                )
              (not (= ?acjn ?fkf))
              )
            (or (or (= ?acjq ?acjp)
                (= ?acjq ?fkf)
                )
              (= ?acjp ?fkf)
              )
            )
          (and (or (or (= ?acjo ?acjn)
                (= ?acjo ?fkf)
                )
              (= ?acjn ?fkf)
              )
            (and (and (not (= ?acjq ?acjp))
                (not (= ?acjq ?fkf))
                )
              (not (= ?acjp ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acjr Real)
    (declare-const ?acjs Real)
    (declare-const ?acjt Real)
    (declare-const ?acju Real)
    (declare-const ?acjv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acjw Real)
    (declare-const ?acjx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acjy Real)
    (declare-const ?acjz Real)
    (declare-const ?acka Real)
    (declare-const ?ackb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ackc Real)
    (declare-const ?ackd Real)
    (declare-const ?acke Real)
    (declare-const ?ackf Real)
    (declare-const ?ackg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ackh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acki Real)
    (declare-const ?ackj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ackk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ackl Real)
    (declare-const ?ackm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ackn Real)
    (declare-const ?acko Real)
    (declare-const ?ackp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ackq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ackr Real)
    (declare-const ?acks Real)
    (assert
      (not (= ?ackr ?acks))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ackt Real)
    (declare-const ?acku Real)
    (declare-const ?ackv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ackw Real)
    (declare-const ?ackx Real)
    (declare-const ?acky Real)
    (declare-const ?ackz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acla Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aclb Real)
    (declare-const ?aclc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acld Real)
    (declare-const ?acle Real)
    (declare-const ?aclf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aclg Real)
    (declare-const ?aclh Real)
    (declare-const ?acli Real)
    (declare-const ?aclj Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aclh ?aclg))
                (not (= ?aclh ?mzs))
                )
              (not (= ?aclg ?mzs))
              )
            (or (or (= ?aclj ?acli)
                (= ?aclj ?mzs)
                )
              (= ?acli ?mzs)
              )
            )
          (and (or (or (= ?aclh ?aclg)
                (= ?aclh ?mzs)
                )
              (= ?aclg ?mzs)
              )
            (and (and (not (= ?aclj ?acli))
                (not (= ?aclj ?mzs))
                )
              (not (= ?acli ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aclk Real)
    (declare-const ?acll Real)
    (declare-const ?aclm Real)
    (declare-const ?acln Real)
    (declare-const ?aclo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aclp Real)
    (declare-const ?aclq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aclr Real)
    (declare-const ?acls Real)
    (declare-const ?aclt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aclu Real)
    (declare-const ?aclv Real)
    (declare-const ?aclw Real)
    (declare-const ?aclx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acly Real)
    (declare-const ?aclz Real)
    (declare-const ?acma Real)
    (declare-const ?acmb Real)
    (declare-const ?acmc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acmd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acme Real)
    (declare-const ?acmf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?acmg Real)
  (declare-const ?acmh Real)
  (declare-const ?acmi Real)
  (declare-const ?acmj Real)
  (declare-const ?acmk Real)
  (assert
    (or (or (= ?acmi ?acmh)
        (= ?acmi ?acmg)
        )
      (= ?acmh ?acmg)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?acml Real)
    (declare-const ?acmm Real)
    (declare-const ?acmn Real)
    (assert
      (or (or (= ?acmn ?acmm)
          (= ?acmn ?acml)
          )
        (= ?acmm ?acml)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acmo Real)
    (declare-const ?acmp Real)
    (declare-const ?acmq Real)
    (declare-const ?acmr Real)
    (assert
      (or (or (= ?acmr ?acmq)
          (= ?acmr ?acmp)
          )
        (= ?acmq ?acmp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acms Real)
    (declare-const ?acmt Real)
    (declare-const ?acmu Real)
    (declare-const ?acmv Real)
    (declare-const ?acmw Real)
    (assert
      (or (or (= ?acmw ?acmv)
          (= ?acmw ?acmu)
          )
        (= ?acmv ?acmu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acmx Real)
    (declare-const ?acmy Real)
    (declare-const ?acmz Real)
    (declare-const ?acna Real)
    (declare-const ?acnb Real)
    (declare-const ?acnc Real)
    (assert
      (and (and (and (not (= ?acmz ?acmy))
            (not (= ?acmz ?acmx))
            )
          (not (= ?acmy ?acmx))
          )
        (or (or (= ?acnc ?acnb)
            (= ?acnc ?acna)
            )
          (= ?acnb ?acna)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acnd Real)
    (declare-const ?acne Real)
    (declare-const ?acnf Real)
    (assert
      (or (or (= ?acnf ?acne)
          (= ?acnf ?acnd)
          )
        (= ?acne ?acnd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acng Real)
    (declare-const ?acnh Real)
    (declare-const ?acni Real)
    (assert
      (or (or (= ?acni ?acnh)
          (= ?acni ?acng)
          )
        (= ?acnh ?acng)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acnj Real)
    (declare-const ?acnk Real)
    (declare-const ?acnl Real)
    (declare-const ?acnm Real)
    (assert
      (or (or (= ?acnl ?acnk)
          (= ?acnl ?acnj)
          )
        (= ?acnk ?acnj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acnn Real)
    (declare-const ?acno Real)
    (declare-const ?acnp Real)
    (declare-const ?acnq Real)
    (declare-const ?acnr Real)
    (assert
      (or (or (= ?acnp ?acno)
          (= ?acnp ?acnn)
          )
        (= ?acno ?acnn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acns Real)
    (declare-const ?acnt Real)
    (declare-const ?acnu Real)
    (declare-const ?acnv Real)
    (declare-const ?acnw Real)
    (declare-const ?acnx Real)
    (assert
      (and (or (or (= ?acnu ?acnt)
            (= ?acnu ?acns)
            )
          (= ?acnt ?acns)
          )
        (and (and (not (= ?acnx ?acnw))
            (not (= ?acnx ?acnv))
            )
          (not (= ?acnw ?acnv))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acny Real)
    (declare-const ?acnz Real)
    (declare-const ?acoa Real)
    (assert
      (or (or (= ?acoa ?acnz)
          (= ?acoa ?acny)
          )
        (= ?acnz ?acny)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acob Real)
    (declare-const ?acoc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acod Real)
    (declare-const ?acoe Real)
    (declare-const ?acof Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acog Real)
    (declare-const ?acoh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acoi Real)
    (declare-const ?acoj Real)
    (declare-const ?acok Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acol Real)
    (declare-const ?acom Real)
    (declare-const ?acon Real)
    (declare-const ?acoo Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?acom ?acol))
                (not (= ?acom ?asi))
                )
              (not (= ?acol ?asi))
              )
            (or (or (= ?acoo ?acon)
                (= ?acoo ?asi)
                )
              (= ?acon ?asi)
              )
            )
          (and (or (or (= ?acom ?acol)
                (= ?acom ?asi)
                )
              (= ?acol ?asi)
              )
            (and (and (not (= ?acoo ?acon))
                (not (= ?acoo ?asi))
                )
              (not (= ?acon ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acop Real)
    (declare-const ?acoq Real)
    (declare-const ?acor Real)
    (declare-const ?acos Real)
    (declare-const ?acot Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acou Real)
    (declare-const ?acov Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acow Real)
    (declare-const ?acox Real)
    (declare-const ?acoy Real)
    (declare-const ?acoz Real)
    (declare-const ?acpa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acpb Real)
    (declare-const ?acpc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acpd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acpe Real)
    (declare-const ?acpf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acpg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acph Real)
    (declare-const ?acpi Real)
    (assert
      (not (= ?acph ?acpi))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acpj Real)
    (declare-const ?acpk Real)
    (declare-const ?acpl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acpm Real)
    (declare-const ?acpn Real)
    (declare-const ?acpo Real)
    (declare-const ?acpp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acpq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acpr Real)
    (declare-const ?acps Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acpt Real)
    (declare-const ?acpu Real)
    (declare-const ?acpv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acpw Real)
    (declare-const ?acpx Real)
    (declare-const ?acpy Real)
    (declare-const ?acpz Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?acpx ?acpw))
                (not (= ?acpx ?fkf))
                )
              (not (= ?acpw ?fkf))
              )
            (or (or (= ?acpz ?acpy)
                (= ?acpz ?fkf)
                )
              (= ?acpy ?fkf)
              )
            )
          (and (or (or (= ?acpx ?acpw)
                (= ?acpx ?fkf)
                )
              (= ?acpw ?fkf)
              )
            (and (and (not (= ?acpz ?acpy))
                (not (= ?acpz ?fkf))
                )
              (not (= ?acpy ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acqa Real)
    (declare-const ?acqb Real)
    (declare-const ?acqc Real)
    (declare-const ?acqd Real)
    (declare-const ?acqe Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acqf Real)
    (declare-const ?acqg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acqh Real)
    (declare-const ?acqi Real)
    (declare-const ?acqj Real)
    (declare-const ?acqk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acql Real)
    (declare-const ?acqm Real)
    (declare-const ?acqn Real)
    (declare-const ?acqo Real)
    (declare-const ?acqp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acqq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acqr Real)
    (declare-const ?acqs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acqt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acqu Real)
    (declare-const ?acqv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acqw Real)
    (declare-const ?acqx Real)
    (declare-const ?acqy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acqz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acra Real)
    (declare-const ?acrb Real)
    (assert
      (not (= ?acra ?acrb))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acrc Real)
    (declare-const ?acrd Real)
    (declare-const ?acre Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acrf Real)
    (declare-const ?acrg Real)
    (declare-const ?acrh Real)
    (declare-const ?acri Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acrj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acrk Real)
    (declare-const ?acrl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acrm Real)
    (declare-const ?acrn Real)
    (declare-const ?acro Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acrp Real)
    (declare-const ?acrq Real)
    (declare-const ?acrr Real)
    (declare-const ?acrs Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?acrq ?acrp))
                (not (= ?acrq ?mzs))
                )
              (not (= ?acrp ?mzs))
              )
            (or (or (= ?acrs ?acrr)
                (= ?acrs ?mzs)
                )
              (= ?acrr ?mzs)
              )
            )
          (and (or (or (= ?acrq ?acrp)
                (= ?acrq ?mzs)
                )
              (= ?acrp ?mzs)
              )
            (and (and (not (= ?acrs ?acrr))
                (not (= ?acrs ?mzs))
                )
              (not (= ?acrr ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acrt Real)
    (declare-const ?acru Real)
    (declare-const ?acrv Real)
    (declare-const ?acrw Real)
    (declare-const ?acrx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acry Real)
    (declare-const ?acrz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acsa Real)
    (declare-const ?acsb Real)
    (declare-const ?acsc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acsd Real)
    (declare-const ?acse Real)
    (declare-const ?acsf Real)
    (declare-const ?acsg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acsh Real)
    (declare-const ?acsi Real)
    (declare-const ?acsj Real)
    (declare-const ?acsk Real)
    (declare-const ?acsl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acsm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acsn Real)
    (declare-const ?acso Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?acsp Real)
  (declare-const ?acsq Real)
  (declare-const ?acsr Real)
  (declare-const ?acss Real)
  (declare-const ?acst Real)
  (declare-const ?acsu Real)
  (assert
    (and (or (or (= ?acsr ?acsq)
          (= ?acsr ?acsp)
          )
        (= ?acsq ?acsp)
        )
      (and (and (not (= ?acsu ?acst))
          (not (= ?acsu ?acss))
          )
        (not (= ?acst ?acss))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?acsv Real)
    (declare-const ?acsw Real)
    (declare-const ?acsx Real)
    (assert
      (or (or (= ?acsx ?acsw)
          (= ?acsx ?acsv)
          )
        (= ?acsw ?acsv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acsy Real)
    (declare-const ?acsz Real)
    (declare-const ?acta Real)
    (declare-const ?actb Real)
    (assert
      (or (or (= ?actb ?acta)
          (= ?actb ?acsz)
          )
        (= ?acta ?acsz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?actc Real)
    (declare-const ?actd Real)
    (declare-const ?acte Real)
    (declare-const ?actf Real)
    (declare-const ?actg Real)
    (assert
      (or (or (= ?actg ?actf)
          (= ?actg ?acte)
          )
        (= ?actf ?acte)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acth Real)
    (declare-const ?acti Real)
    (declare-const ?actj Real)
    (declare-const ?actk Real)
    (declare-const ?actl Real)
    (declare-const ?actm Real)
    (assert
      (and (and (and (not (= ?actj ?acti))
            (not (= ?actj ?acth))
            )
          (not (= ?acti ?acth))
          )
        (or (or (= ?actm ?actl)
            (= ?actm ?actk)
            )
          (= ?actl ?actk)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?actn Real)
    (declare-const ?acto Real)
    (declare-const ?actp Real)
    (assert
      (or (or (= ?actp ?acto)
          (= ?actp ?actn)
          )
        (= ?acto ?actn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?actq Real)
    (declare-const ?actr Real)
    (declare-const ?acts Real)
    (assert
      (or (or (= ?acts ?actr)
          (= ?acts ?actq)
          )
        (= ?actr ?actq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?actt Real)
    (declare-const ?actu Real)
    (declare-const ?actv Real)
    (declare-const ?actw Real)
    (assert
      (or (or (= ?actv ?actu)
          (= ?actv ?actt)
          )
        (= ?actu ?actt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?actx Real)
    (declare-const ?acty Real)
    (declare-const ?actz Real)
    (declare-const ?acua Real)
    (declare-const ?acub Real)
    (assert
      (or (or (= ?actz ?acty)
          (= ?actz ?actx)
          )
        (= ?acty ?actx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acuc Real)
    (declare-const ?acud Real)
    (declare-const ?acue Real)
    (declare-const ?acuf Real)
    (declare-const ?acug Real)
    (declare-const ?acuh Real)
    (assert
      (and (or (or (= ?acue ?acud)
            (= ?acue ?acuc)
            )
          (= ?acud ?acuc)
          )
        (and (and (not (= ?acuh ?acug))
            (not (= ?acuh ?acuf))
            )
          (not (= ?acug ?acuf))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acui Real)
    (declare-const ?acuj Real)
    (declare-const ?acuk Real)
    (assert
      (or (or (= ?acuk ?acuj)
          (= ?acuk ?acui)
          )
        (= ?acuj ?acui)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acul Real)
    (declare-const ?acum Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acun Real)
    (declare-const ?acuo Real)
    (declare-const ?acup Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acuq Real)
    (declare-const ?acur Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acus Real)
    (declare-const ?acut Real)
    (declare-const ?acuu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acuv Real)
    (declare-const ?acuw Real)
    (declare-const ?acux Real)
    (declare-const ?acuy Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?acuw ?acuv))
                (not (= ?acuw ?asi))
                )
              (not (= ?acuv ?asi))
              )
            (or (or (= ?acuy ?acux)
                (= ?acuy ?asi)
                )
              (= ?acux ?asi)
              )
            )
          (and (or (or (= ?acuw ?acuv)
                (= ?acuw ?asi)
                )
              (= ?acuv ?asi)
              )
            (and (and (not (= ?acuy ?acux))
                (not (= ?acuy ?asi))
                )
              (not (= ?acux ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acuz Real)
    (declare-const ?acva Real)
    (declare-const ?acvb Real)
    (declare-const ?acvc Real)
    (declare-const ?acvd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acve Real)
    (declare-const ?acvf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acvg Real)
    (declare-const ?acvh Real)
    (declare-const ?acvi Real)
    (declare-const ?acvj Real)
    (declare-const ?acvk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acvl Real)
    (declare-const ?acvm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acvn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acvo Real)
    (declare-const ?acvp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acvq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acvr Real)
    (declare-const ?acvs Real)
    (assert
      (not (= ?acvr ?acvs))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acvt Real)
    (declare-const ?acvu Real)
    (declare-const ?acvv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acvw Real)
    (declare-const ?acvx Real)
    (declare-const ?acvy Real)
    (declare-const ?acvz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acwa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acwb Real)
    (declare-const ?acwc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acwd Real)
    (declare-const ?acwe Real)
    (declare-const ?acwf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acwg Real)
    (declare-const ?acwh Real)
    (declare-const ?acwi Real)
    (declare-const ?acwj Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?acwh ?acwg))
                (not (= ?acwh ?fkf))
                )
              (not (= ?acwg ?fkf))
              )
            (or (or (= ?acwj ?acwi)
                (= ?acwj ?fkf)
                )
              (= ?acwi ?fkf)
              )
            )
          (and (or (or (= ?acwh ?acwg)
                (= ?acwh ?fkf)
                )
              (= ?acwg ?fkf)
              )
            (and (and (not (= ?acwj ?acwi))
                (not (= ?acwj ?fkf))
                )
              (not (= ?acwi ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acwk Real)
    (declare-const ?acwl Real)
    (declare-const ?acwm Real)
    (declare-const ?acwn Real)
    (declare-const ?acwo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acwp Real)
    (declare-const ?acwq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acwr Real)
    (declare-const ?acws Real)
    (declare-const ?acwt Real)
    (declare-const ?acwu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acwv Real)
    (declare-const ?acww Real)
    (declare-const ?acwx Real)
    (declare-const ?acwy Real)
    (declare-const ?acwz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acxa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acxb Real)
    (declare-const ?acxc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acxd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acxe Real)
    (declare-const ?acxf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acxg Real)
    (declare-const ?acxh Real)
    (declare-const ?acxi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acxj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acxk Real)
    (declare-const ?acxl Real)
    (assert
      (not (= ?acxk ?acxl))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acxm Real)
    (declare-const ?acxn Real)
    (declare-const ?acxo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acxp Real)
    (declare-const ?acxq Real)
    (declare-const ?acxr Real)
    (declare-const ?acxs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acxt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acxu Real)
    (declare-const ?acxv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acxw Real)
    (declare-const ?acxx Real)
    (declare-const ?acxy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acxz Real)
    (declare-const ?acya Real)
    (declare-const ?acyb Real)
    (declare-const ?acyc Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?acya ?acxz))
                (not (= ?acya ?mzs))
                )
              (not (= ?acxz ?mzs))
              )
            (or (or (= ?acyc ?acyb)
                (= ?acyc ?mzs)
                )
              (= ?acyb ?mzs)
              )
            )
          (and (or (or (= ?acya ?acxz)
                (= ?acya ?mzs)
                )
              (= ?acxz ?mzs)
              )
            (and (and (not (= ?acyc ?acyb))
                (not (= ?acyc ?mzs))
                )
              (not (= ?acyb ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acyd Real)
    (declare-const ?acye Real)
    (declare-const ?acyf Real)
    (declare-const ?acyg Real)
    (declare-const ?acyh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acyi Real)
    (declare-const ?acyj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acyk Real)
    (declare-const ?acyl Real)
    (declare-const ?acym Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acyn Real)
    (declare-const ?acyo Real)
    (declare-const ?acyp Real)
    (declare-const ?acyq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acyr Real)
    (declare-const ?acys Real)
    (declare-const ?acyt Real)
    (declare-const ?acyu Real)
    (declare-const ?acyv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acyw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?acyx Real)
    (declare-const ?acyy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?acyz Real)
  (declare-const ?acza Real)
  (declare-const ?aczb Real)
  (assert
    (or (or (= ?aczb ?acza)
        (= ?aczb ?acyz)
        )
      (= ?acza ?acyz)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?aczc Real)
    (declare-const ?aczd Real)
    (declare-const ?acze Real)
    (assert
      (or (or (= ?acze ?aczd)
          (= ?acze ?aczc)
          )
        (= ?aczd ?aczc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aczf Real)
    (declare-const ?aczg Real)
    (declare-const ?aczh Real)
    (declare-const ?aczi Real)
    (assert
      (or (or (= ?aczi ?aczh)
          (= ?aczi ?aczg)
          )
        (= ?aczh ?aczg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aczj Real)
    (declare-const ?aczk Real)
    (declare-const ?aczl Real)
    (declare-const ?aczm Real)
    (declare-const ?aczn Real)
    (assert
      (or (or (= ?aczn ?aczm)
          (= ?aczn ?aczl)
          )
        (= ?aczm ?aczl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aczo Real)
    (declare-const ?aczp Real)
    (declare-const ?aczq Real)
    (declare-const ?aczr Real)
    (declare-const ?aczs Real)
    (declare-const ?aczt Real)
    (assert
      (and (and (and (not (= ?aczq ?aczp))
            (not (= ?aczq ?aczo))
            )
          (not (= ?aczp ?aczo))
          )
        (or (or (= ?aczt ?aczs)
            (= ?aczt ?aczr)
            )
          (= ?aczs ?aczr)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aczu Real)
    (declare-const ?aczv Real)
    (declare-const ?aczw Real)
    (assert
      (or (or (= ?aczw ?aczv)
          (= ?aczw ?aczu)
          )
        (= ?aczv ?aczu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aczx Real)
    (declare-const ?aczy Real)
    (declare-const ?aczz Real)
    (assert
      (or (or (= ?aczz ?aczy)
          (= ?aczz ?aczx)
          )
        (= ?aczy ?aczx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adaa Real)
    (declare-const ?adab Real)
    (declare-const ?adac Real)
    (declare-const ?adad Real)
    (assert
      (or (or (= ?adac ?adab)
          (= ?adac ?adaa)
          )
        (= ?adab ?adaa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adae Real)
    (declare-const ?adaf Real)
    (declare-const ?adag Real)
    (declare-const ?adah Real)
    (declare-const ?adai Real)
    (assert
      (or (or (= ?adag ?adaf)
          (= ?adag ?adae)
          )
        (= ?adaf ?adae)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adaj Real)
    (declare-const ?adak Real)
    (declare-const ?adal Real)
    (declare-const ?adam Real)
    (declare-const ?adan Real)
    (declare-const ?adao Real)
    (assert
      (and (or (or (= ?adal ?adak)
            (= ?adal ?adaj)
            )
          (= ?adak ?adaj)
          )
        (and (and (not (= ?adao ?adan))
            (not (= ?adao ?adam))
            )
          (not (= ?adan ?adam))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adap Real)
    (declare-const ?adaq Real)
    (declare-const ?adar Real)
    (assert
      (or (or (= ?adar ?adaq)
          (= ?adar ?adap)
          )
        (= ?adaq ?adap)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adas Real)
    (declare-const ?adat Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adau Real)
    (declare-const ?adav Real)
    (declare-const ?adaw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adax Real)
    (declare-const ?aday Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adaz Real)
    (declare-const ?adba Real)
    (declare-const ?adbb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adbc Real)
    (declare-const ?adbd Real)
    (declare-const ?adbe Real)
    (declare-const ?adbf Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?adbd ?adbc))
                (not (= ?adbd ?asi))
                )
              (not (= ?adbc ?asi))
              )
            (or (or (= ?adbf ?adbe)
                (= ?adbf ?asi)
                )
              (= ?adbe ?asi)
              )
            )
          (and (or (or (= ?adbd ?adbc)
                (= ?adbd ?asi)
                )
              (= ?adbc ?asi)
              )
            (and (and (not (= ?adbf ?adbe))
                (not (= ?adbf ?asi))
                )
              (not (= ?adbe ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adbg Real)
    (declare-const ?adbh Real)
    (declare-const ?adbi Real)
    (declare-const ?adbj Real)
    (declare-const ?adbk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adbl Real)
    (declare-const ?adbm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adbn Real)
    (declare-const ?adbo Real)
    (declare-const ?adbp Real)
    (declare-const ?adbq Real)
    (declare-const ?adbr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adbs Real)
    (declare-const ?adbt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adbu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adbv Real)
    (declare-const ?adbw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adbx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adby Real)
    (declare-const ?adbz Real)
    (assert
      (not (= ?adby ?adbz))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adca Real)
    (declare-const ?adcb Real)
    (declare-const ?adcc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adcd Real)
    (declare-const ?adce Real)
    (declare-const ?adcf Real)
    (declare-const ?adcg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adch Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adci Real)
    (declare-const ?adcj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adck Real)
    (declare-const ?adcl Real)
    (declare-const ?adcm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adcn Real)
    (declare-const ?adco Real)
    (declare-const ?adcp Real)
    (declare-const ?adcq Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?adco ?adcn))
                (not (= ?adco ?fkf))
                )
              (not (= ?adcn ?fkf))
              )
            (or (or (= ?adcq ?adcp)
                (= ?adcq ?fkf)
                )
              (= ?adcp ?fkf)
              )
            )
          (and (or (or (= ?adco ?adcn)
                (= ?adco ?fkf)
                )
              (= ?adcn ?fkf)
              )
            (and (and (not (= ?adcq ?adcp))
                (not (= ?adcq ?fkf))
                )
              (not (= ?adcp ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adcr Real)
    (declare-const ?adcs Real)
    (declare-const ?adct Real)
    (declare-const ?adcu Real)
    (declare-const ?adcv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adcw Real)
    (declare-const ?adcx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adcy Real)
    (declare-const ?adcz Real)
    (declare-const ?adda Real)
    (declare-const ?addb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?addc Real)
    (declare-const ?addd Real)
    (declare-const ?adde Real)
    (declare-const ?addf Real)
    (declare-const ?addg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?addh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?addi Real)
    (declare-const ?addj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?addk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?addl Real)
    (declare-const ?addm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?addn Real)
    (declare-const ?addo Real)
    (declare-const ?addp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?addq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?addr Real)
    (declare-const ?adds Real)
    (assert
      (not (= ?addr ?adds))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?addt Real)
    (declare-const ?addu Real)
    (declare-const ?addv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?addw Real)
    (declare-const ?addx Real)
    (declare-const ?addy Real)
    (declare-const ?addz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adea Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adeb Real)
    (declare-const ?adec Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aded Real)
    (declare-const ?adee Real)
    (declare-const ?adef Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adeg Real)
    (declare-const ?adeh Real)
    (declare-const ?adei Real)
    (declare-const ?adej Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?adeh ?adeg))
                (not (= ?adeh ?mzs))
                )
              (not (= ?adeg ?mzs))
              )
            (or (or (= ?adej ?adei)
                (= ?adej ?mzs)
                )
              (= ?adei ?mzs)
              )
            )
          (and (or (or (= ?adeh ?adeg)
                (= ?adeh ?mzs)
                )
              (= ?adeg ?mzs)
              )
            (and (and (not (= ?adej ?adei))
                (not (= ?adej ?mzs))
                )
              (not (= ?adei ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adek Real)
    (declare-const ?adel Real)
    (declare-const ?adem Real)
    (declare-const ?aden Real)
    (declare-const ?adeo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adep Real)
    (declare-const ?adeq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ader Real)
    (declare-const ?ades Real)
    (declare-const ?adet Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adeu Real)
    (declare-const ?adev Real)
    (declare-const ?adew Real)
    (declare-const ?adex Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adey Real)
    (declare-const ?adez Real)
    (declare-const ?adfa Real)
    (declare-const ?adfb Real)
    (declare-const ?adfc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adfd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adfe Real)
    (declare-const ?adff Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?adfg Real)
  (declare-const ?adfh Real)
  (push 1)
    (declare-const ?adfi Real)
    (declare-const ?adfj Real)
    (declare-const ?adfk Real)
    (assert
      (or (or (= ?adfk ?adfj)
          (= ?adfk ?adfi)
          )
        (= ?adfj ?adfi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adfl Real)
    (declare-const ?adfm Real)
    (declare-const ?adfn Real)
    (declare-const ?adfo Real)
    (assert
      (or (or (= ?adfo ?adfn)
          (= ?adfo ?adfm)
          )
        (= ?adfn ?adfm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adfp Real)
    (declare-const ?adfq Real)
    (declare-const ?adfr Real)
    (declare-const ?adfs Real)
    (declare-const ?adft Real)
    (assert
      (or (or (= ?adft ?adfs)
          (= ?adft ?adfr)
          )
        (= ?adfs ?adfr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adfu Real)
    (declare-const ?adfv Real)
    (declare-const ?adfw Real)
    (declare-const ?adfx Real)
    (declare-const ?adfy Real)
    (declare-const ?adfz Real)
    (assert
      (and (and (and (not (= ?adfw ?adfv))
            (not (= ?adfw ?adfu))
            )
          (not (= ?adfv ?adfu))
          )
        (or (or (= ?adfz ?adfy)
            (= ?adfz ?adfx)
            )
          (= ?adfy ?adfx)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adga Real)
    (declare-const ?adgb Real)
    (declare-const ?adgc Real)
    (assert
      (or (or (= ?adgc ?adgb)
          (= ?adgc ?adga)
          )
        (= ?adgb ?adga)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adgd Real)
    (declare-const ?adge Real)
    (declare-const ?adgf Real)
    (assert
      (or (or (= ?adgf ?adge)
          (= ?adgf ?adgd)
          )
        (= ?adge ?adgd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adgg Real)
    (declare-const ?adgh Real)
    (declare-const ?adgi Real)
    (declare-const ?adgj Real)
    (assert
      (or (or (= ?adgi ?adgh)
          (= ?adgi ?adgg)
          )
        (= ?adgh ?adgg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adgk Real)
    (declare-const ?adgl Real)
    (declare-const ?adgm Real)
    (declare-const ?adgn Real)
    (declare-const ?adgo Real)
    (assert
      (or (or (= ?adgm ?adgl)
          (= ?adgm ?adgk)
          )
        (= ?adgl ?adgk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adgp Real)
    (declare-const ?adgq Real)
    (declare-const ?adgr Real)
    (declare-const ?adgs Real)
    (declare-const ?adgt Real)
    (declare-const ?adgu Real)
    (assert
      (and (or (or (= ?adgr ?adgq)
            (= ?adgr ?adgp)
            )
          (= ?adgq ?adgp)
          )
        (and (and (not (= ?adgu ?adgt))
            (not (= ?adgu ?adgs))
            )
          (not (= ?adgt ?adgs))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adgv Real)
    (declare-const ?adgw Real)
    (declare-const ?adgx Real)
    (assert
      (or (or (= ?adgx ?adgw)
          (= ?adgx ?adgv)
          )
        (= ?adgw ?adgv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adgy Real)
    (declare-const ?adgz Real)
    (declare-const ?adha Real)
    (declare-const ?adhb Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?adgz ?adgy))
                (not (= ?adgz ?asi))
                )
              (not (= ?adgy ?asi))
              )
            (or (or (= ?adhb ?adha)
                (= ?adhb ?asi)
                )
              (= ?adha ?asi)
              )
            )
          (and (or (or (= ?adgz ?adgy)
                (= ?adgz ?asi)
                )
              (= ?adgy ?asi)
              )
            (and (and (not (= ?adhb ?adha))
                (not (= ?adhb ?asi))
                )
              (not (= ?adha ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adhc Real)
    (declare-const ?adhd Real)
    (declare-const ?adhe Real)
    (declare-const ?adhf Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?adhd ?adhc))
                (not (= ?adhd ?fkf))
                )
              (not (= ?adhc ?fkf))
              )
            (or (or (= ?adhf ?adhe)
                (= ?adhf ?fkf)
                )
              (= ?adhe ?fkf)
              )
            )
          (and (or (or (= ?adhd ?adhc)
                (= ?adhd ?fkf)
                )
              (= ?adhc ?fkf)
              )
            (and (and (not (= ?adhf ?adhe))
                (not (= ?adhf ?fkf))
                )
              (not (= ?adhe ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adhg Real)
    (declare-const ?adhh Real)
    (declare-const ?adhi Real)
    (declare-const ?adhj Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?adhh ?adhg))
                (not (= ?adhh ?mzs))
                )
              (not (= ?adhg ?mzs))
              )
            (or (or (= ?adhj ?adhi)
                (= ?adhj ?mzs)
                )
              (= ?adhi ?mzs)
              )
            )
          (and (or (or (= ?adhh ?adhg)
                (= ?adhh ?mzs)
                )
              (= ?adhg ?mzs)
              )
            (and (and (not (= ?adhj ?adhi))
                (not (= ?adhj ?mzs))
                )
              (not (= ?adhi ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?adhk Real)
  (declare-const ?adhl Real)
  (declare-const ?adhm Real)
  (push 1)
    (declare-const ?adhn Real)
    (declare-const ?adho Real)
    (declare-const ?adhp Real)
    (assert
      (or (or (= ?adhp ?adho)
          (= ?adhp ?adhn)
          )
        (= ?adho ?adhn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adhq Real)
    (declare-const ?adhr Real)
    (declare-const ?adhs Real)
    (declare-const ?adht Real)
    (assert
      (or (or (= ?adht ?adhs)
          (= ?adht ?adhr)
          )
        (= ?adhs ?adhr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adhu Real)
    (declare-const ?adhv Real)
    (declare-const ?adhw Real)
    (declare-const ?adhx Real)
    (declare-const ?adhy Real)
    (assert
      (or (or (= ?adhy ?adhx)
          (= ?adhy ?adhw)
          )
        (= ?adhx ?adhw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adhz Real)
    (declare-const ?adia Real)
    (declare-const ?adib Real)
    (declare-const ?adic Real)
    (declare-const ?adid Real)
    (declare-const ?adie Real)
    (assert
      (and (and (and (not (= ?adib ?adia))
            (not (= ?adib ?adhz))
            )
          (not (= ?adia ?adhz))
          )
        (or (or (= ?adie ?adid)
            (= ?adie ?adic)
            )
          (= ?adid ?adic)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adif Real)
    (declare-const ?adig Real)
    (declare-const ?adih Real)
    (assert
      (or (or (= ?adih ?adig)
          (= ?adih ?adif)
          )
        (= ?adig ?adif)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adii Real)
    (declare-const ?adij Real)
    (declare-const ?adik Real)
    (assert
      (or (or (= ?adik ?adij)
          (= ?adik ?adii)
          )
        (= ?adij ?adii)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adil Real)
    (declare-const ?adim Real)
    (declare-const ?adin Real)
    (declare-const ?adio Real)
    (assert
      (or (or (= ?adin ?adim)
          (= ?adin ?adil)
          )
        (= ?adim ?adil)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adip Real)
    (declare-const ?adiq Real)
    (declare-const ?adir Real)
    (declare-const ?adis Real)
    (declare-const ?adit Real)
    (assert
      (or (or (= ?adir ?adiq)
          (= ?adir ?adip)
          )
        (= ?adiq ?adip)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adiu Real)
    (declare-const ?adiv Real)
    (declare-const ?adiw Real)
    (declare-const ?adix Real)
    (declare-const ?adiy Real)
    (declare-const ?adiz Real)
    (assert
      (and (or (or (= ?adiw ?adiv)
            (= ?adiw ?adiu)
            )
          (= ?adiv ?adiu)
          )
        (and (and (not (= ?adiz ?adiy))
            (not (= ?adiz ?adix))
            )
          (not (= ?adiy ?adix))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adja Real)
    (declare-const ?adjb Real)
    (declare-const ?adjc Real)
    (assert
      (or (or (= ?adjc ?adjb)
          (= ?adjc ?adja)
          )
        (= ?adjb ?adja)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adjd Real)
    (declare-const ?adje Real)
    (declare-const ?adjf Real)
    (declare-const ?adjg Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?adje ?adjd))
                (not (= ?adje ?asi))
                )
              (not (= ?adjd ?asi))
              )
            (or (or (= ?adjg ?adjf)
                (= ?adjg ?asi)
                )
              (= ?adjf ?asi)
              )
            )
          (and (or (or (= ?adje ?adjd)
                (= ?adje ?asi)
                )
              (= ?adjd ?asi)
              )
            (and (and (not (= ?adjg ?adjf))
                (not (= ?adjg ?asi))
                )
              (not (= ?adjf ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adjh Real)
    (declare-const ?adji Real)
    (declare-const ?adjj Real)
    (declare-const ?adjk Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?adji ?adjh))
                (not (= ?adji ?fkf))
                )
              (not (= ?adjh ?fkf))
              )
            (or (or (= ?adjk ?adjj)
                (= ?adjk ?fkf)
                )
              (= ?adjj ?fkf)
              )
            )
          (and (or (or (= ?adji ?adjh)
                (= ?adji ?fkf)
                )
              (= ?adjh ?fkf)
              )
            (and (and (not (= ?adjk ?adjj))
                (not (= ?adjk ?fkf))
                )
              (not (= ?adjj ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adjl Real)
    (declare-const ?adjm Real)
    (declare-const ?adjn Real)
    (declare-const ?adjo Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?adjm ?adjl))
                (not (= ?adjm ?mzs))
                )
              (not (= ?adjl ?mzs))
              )
            (or (or (= ?adjo ?adjn)
                (= ?adjo ?mzs)
                )
              (= ?adjn ?mzs)
              )
            )
          (and (or (or (= ?adjm ?adjl)
                (= ?adjm ?mzs)
                )
              (= ?adjl ?mzs)
              )
            (and (and (not (= ?adjo ?adjn))
                (not (= ?adjo ?mzs))
                )
              (not (= ?adjn ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?adjp Real)
  (declare-const ?adjq Real)
  (push 1)
    (declare-const ?adjr Real)
    (declare-const ?adjs Real)
    (declare-const ?adjt Real)
    (assert
      (or (or (= ?adjt ?adjs)
          (= ?adjt ?adjr)
          )
        (= ?adjs ?adjr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adju Real)
    (declare-const ?adjv Real)
    (declare-const ?adjw Real)
    (declare-const ?adjx Real)
    (assert
      (or (or (= ?adjx ?adjw)
          (= ?adjx ?adjv)
          )
        (= ?adjw ?adjv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adjy Real)
    (declare-const ?adjz Real)
    (declare-const ?adka Real)
    (declare-const ?adkb Real)
    (declare-const ?adkc Real)
    (assert
      (or (or (= ?adkc ?adkb)
          (= ?adkc ?adka)
          )
        (= ?adkb ?adka)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adkd Real)
    (declare-const ?adke Real)
    (declare-const ?adkf Real)
    (declare-const ?adkg Real)
    (declare-const ?adkh Real)
    (declare-const ?adki Real)
    (assert
      (and (and (and (not (= ?adkf ?adke))
            (not (= ?adkf ?adkd))
            )
          (not (= ?adke ?adkd))
          )
        (or (or (= ?adki ?adkh)
            (= ?adki ?adkg)
            )
          (= ?adkh ?adkg)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adkj Real)
    (declare-const ?adkk Real)
    (declare-const ?adkl Real)
    (assert
      (or (or (= ?adkl ?adkk)
          (= ?adkl ?adkj)
          )
        (= ?adkk ?adkj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adkm Real)
    (declare-const ?adkn Real)
    (declare-const ?adko Real)
    (assert
      (or (or (= ?adko ?adkn)
          (= ?adko ?adkm)
          )
        (= ?adkn ?adkm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adkp Real)
    (declare-const ?adkq Real)
    (declare-const ?adkr Real)
    (declare-const ?adks Real)
    (assert
      (or (or (= ?adkr ?adkq)
          (= ?adkr ?adkp)
          )
        (= ?adkq ?adkp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adkt Real)
    (declare-const ?adku Real)
    (declare-const ?adkv Real)
    (declare-const ?adkw Real)
    (declare-const ?adkx Real)
    (assert
      (or (or (= ?adkv ?adku)
          (= ?adkv ?adkt)
          )
        (= ?adku ?adkt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adky Real)
    (declare-const ?adkz Real)
    (declare-const ?adla Real)
    (declare-const ?adlb Real)
    (declare-const ?adlc Real)
    (declare-const ?adld Real)
    (assert
      (and (or (or (= ?adla ?adkz)
            (= ?adla ?adky)
            )
          (= ?adkz ?adky)
          )
        (and (and (not (= ?adld ?adlc))
            (not (= ?adld ?adlb))
            )
          (not (= ?adlc ?adlb))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adle Real)
    (declare-const ?adlf Real)
    (declare-const ?adlg Real)
    (assert
      (or (or (= ?adlg ?adlf)
          (= ?adlg ?adle)
          )
        (= ?adlf ?adle)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adlh Real)
    (declare-const ?adli Real)
    (declare-const ?adlj Real)
    (declare-const ?adlk Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?adli ?adlh))
                (not (= ?adli ?asi))
                )
              (not (= ?adlh ?asi))
              )
            (or (or (= ?adlk ?adlj)
                (= ?adlk ?asi)
                )
              (= ?adlj ?asi)
              )
            )
          (and (or (or (= ?adli ?adlh)
                (= ?adli ?asi)
                )
              (= ?adlh ?asi)
              )
            (and (and (not (= ?adlk ?adlj))
                (not (= ?adlk ?asi))
                )
              (not (= ?adlj ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adll Real)
    (declare-const ?adlm Real)
    (declare-const ?adln Real)
    (declare-const ?adlo Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?adlm ?adll))
                (not (= ?adlm ?fkf))
                )
              (not (= ?adll ?fkf))
              )
            (or (or (= ?adlo ?adln)
                (= ?adlo ?fkf)
                )
              (= ?adln ?fkf)
              )
            )
          (and (or (or (= ?adlm ?adll)
                (= ?adlm ?fkf)
                )
              (= ?adll ?fkf)
              )
            (and (and (not (= ?adlo ?adln))
                (not (= ?adlo ?fkf))
                )
              (not (= ?adln ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adlp Real)
    (declare-const ?adlq Real)
    (declare-const ?adlr Real)
    (declare-const ?adls Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?adlq ?adlp))
                (not (= ?adlq ?mzs))
                )
              (not (= ?adlp ?mzs))
              )
            (or (or (= ?adls ?adlr)
                (= ?adls ?mzs)
                )
              (= ?adlr ?mzs)
              )
            )
          (and (or (or (= ?adlq ?adlp)
                (= ?adlq ?mzs)
                )
              (= ?adlp ?mzs)
              )
            (and (and (not (= ?adls ?adlr))
                (not (= ?adls ?mzs))
                )
              (not (= ?adlr ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?adlt Real)
  (declare-const ?adlu Real)
  (declare-const ?adlv Real)
  (push 1)
    (declare-const ?adlw Real)
    (declare-const ?adlx Real)
    (declare-const ?adly Real)
    (assert
      (or (or (= ?adly ?adlx)
          (= ?adly ?adlw)
          )
        (= ?adlx ?adlw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adlz Real)
    (declare-const ?adma Real)
    (declare-const ?admb Real)
    (declare-const ?admc Real)
    (assert
      (or (or (= ?admc ?admb)
          (= ?admc ?adma)
          )
        (= ?admb ?adma)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?admd Real)
    (declare-const ?adme Real)
    (declare-const ?admf Real)
    (declare-const ?admg Real)
    (declare-const ?admh Real)
    (assert
      (or (or (= ?admh ?admg)
          (= ?admh ?admf)
          )
        (= ?admg ?admf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?admi Real)
    (declare-const ?admj Real)
    (declare-const ?admk Real)
    (declare-const ?adml Real)
    (declare-const ?admm Real)
    (declare-const ?admn Real)
    (assert
      (and (and (and (not (= ?admk ?admj))
            (not (= ?admk ?admi))
            )
          (not (= ?admj ?admi))
          )
        (or (or (= ?admn ?admm)
            (= ?admn ?adml)
            )
          (= ?admm ?adml)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?admo Real)
    (declare-const ?admp Real)
    (declare-const ?admq Real)
    (assert
      (or (or (= ?admq ?admp)
          (= ?admq ?admo)
          )
        (= ?admp ?admo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?admr Real)
    (declare-const ?adms Real)
    (declare-const ?admt Real)
    (assert
      (or (or (= ?admt ?adms)
          (= ?admt ?admr)
          )
        (= ?adms ?admr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?admu Real)
    (declare-const ?admv Real)
    (declare-const ?admw Real)
    (declare-const ?admx Real)
    (assert
      (or (or (= ?admw ?admv)
          (= ?admw ?admu)
          )
        (= ?admv ?admu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?admy Real)
    (declare-const ?admz Real)
    (declare-const ?adna Real)
    (declare-const ?adnb Real)
    (declare-const ?adnc Real)
    (assert
      (or (or (= ?adna ?admz)
          (= ?adna ?admy)
          )
        (= ?admz ?admy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adnd Real)
    (declare-const ?adne Real)
    (declare-const ?adnf Real)
    (declare-const ?adng Real)
    (declare-const ?adnh Real)
    (declare-const ?adni Real)
    (assert
      (and (or (or (= ?adnf ?adne)
            (= ?adnf ?adnd)
            )
          (= ?adne ?adnd)
          )
        (and (and (not (= ?adni ?adnh))
            (not (= ?adni ?adng))
            )
          (not (= ?adnh ?adng))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adnj Real)
    (declare-const ?adnk Real)
    (declare-const ?adnl Real)
    (assert
      (or (or (= ?adnl ?adnk)
          (= ?adnl ?adnj)
          )
        (= ?adnk ?adnj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adnm Real)
    (declare-const ?adnn Real)
    (declare-const ?adno Real)
    (declare-const ?adnp Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?adnn ?adnm))
                (not (= ?adnn ?asi))
                )
              (not (= ?adnm ?asi))
              )
            (or (or (= ?adnp ?adno)
                (= ?adnp ?asi)
                )
              (= ?adno ?asi)
              )
            )
          (and (or (or (= ?adnn ?adnm)
                (= ?adnn ?asi)
                )
              (= ?adnm ?asi)
              )
            (and (and (not (= ?adnp ?adno))
                (not (= ?adnp ?asi))
                )
              (not (= ?adno ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adnq Real)
    (declare-const ?adnr Real)
    (declare-const ?adns Real)
    (declare-const ?adnt Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?adnr ?adnq))
                (not (= ?adnr ?fkf))
                )
              (not (= ?adnq ?fkf))
              )
            (or (or (= ?adnt ?adns)
                (= ?adnt ?fkf)
                )
              (= ?adns ?fkf)
              )
            )
          (and (or (or (= ?adnr ?adnq)
                (= ?adnr ?fkf)
                )
              (= ?adnq ?fkf)
              )
            (and (and (not (= ?adnt ?adns))
                (not (= ?adnt ?fkf))
                )
              (not (= ?adns ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adnu Real)
    (declare-const ?adnv Real)
    (declare-const ?adnw Real)
    (declare-const ?adnx Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?adnv ?adnu))
                (not (= ?adnv ?mzs))
                )
              (not (= ?adnu ?mzs))
              )
            (or (or (= ?adnx ?adnw)
                (= ?adnx ?mzs)
                )
              (= ?adnw ?mzs)
              )
            )
          (and (or (or (= ?adnv ?adnu)
                (= ?adnv ?mzs)
                )
              (= ?adnu ?mzs)
              )
            (and (and (not (= ?adnx ?adnw))
                (not (= ?adnx ?mzs))
                )
              (not (= ?adnw ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?adny Real)
  (declare-const ?adnz Real)
  (declare-const ?adoa Real)
  (declare-const ?adob Real)
  (assert
    (exists ((?asi Real) )(or (and (and (and (not (= ?adnz ?adny))
              (not (= ?adnz ?asi))
              )
            (not (= ?adny ?asi))
            )
          (or (or (= ?adob ?adoa)
              (= ?adob ?asi)
              )
            (= ?adoa ?asi)
            )
          )
        (and (or (or (= ?adnz ?adny)
              (= ?adnz ?asi)
              )
            (= ?adny ?asi)
            )
          (and (and (not (= ?adob ?adoa))
              (not (= ?adob ?asi))
              )
            (not (= ?adoa ?asi))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?adoc Real)
    (declare-const ?adod Real)
    (declare-const ?adoe Real)
    (assert
      (or (or (= ?adoe ?adod)
          (= ?adoe ?adoc)
          )
        (= ?adod ?adoc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adof Real)
    (declare-const ?adog Real)
    (declare-const ?adoh Real)
    (declare-const ?adoi Real)
    (assert
      (or (or (= ?adoi ?adoh)
          (= ?adoi ?adog)
          )
        (= ?adoh ?adog)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adoj Real)
    (declare-const ?adok Real)
    (declare-const ?adol Real)
    (declare-const ?adom Real)
    (declare-const ?adon Real)
    (assert
      (or (or (= ?adon ?adom)
          (= ?adon ?adol)
          )
        (= ?adom ?adol)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adoo Real)
    (declare-const ?adop Real)
    (declare-const ?adoq Real)
    (declare-const ?ador Real)
    (declare-const ?ados Real)
    (declare-const ?adot Real)
    (assert
      (and (and (and (not (= ?adoq ?adop))
            (not (= ?adoq ?adoo))
            )
          (not (= ?adop ?adoo))
          )
        (or (or (= ?adot ?ados)
            (= ?adot ?ador)
            )
          (= ?ados ?ador)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adou Real)
    (declare-const ?adov Real)
    (declare-const ?adow Real)
    (assert
      (or (or (= ?adow ?adov)
          (= ?adow ?adou)
          )
        (= ?adov ?adou)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adox Real)
    (declare-const ?adoy Real)
    (declare-const ?adoz Real)
    (assert
      (or (or (= ?adoz ?adoy)
          (= ?adoz ?adox)
          )
        (= ?adoy ?adox)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adpa Real)
    (declare-const ?adpb Real)
    (declare-const ?adpc Real)
    (declare-const ?adpd Real)
    (assert
      (or (or (= ?adpc ?adpb)
          (= ?adpc ?adpa)
          )
        (= ?adpb ?adpa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adpe Real)
    (declare-const ?adpf Real)
    (declare-const ?adpg Real)
    (declare-const ?adph Real)
    (declare-const ?adpi Real)
    (assert
      (or (or (= ?adpg ?adpf)
          (= ?adpg ?adpe)
          )
        (= ?adpf ?adpe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adpj Real)
    (declare-const ?adpk Real)
    (declare-const ?adpl Real)
    (declare-const ?adpm Real)
    (declare-const ?adpn Real)
    (declare-const ?adpo Real)
    (assert
      (and (or (or (= ?adpl ?adpk)
            (= ?adpl ?adpj)
            )
          (= ?adpk ?adpj)
          )
        (and (and (not (= ?adpo ?adpn))
            (not (= ?adpo ?adpm))
            )
          (not (= ?adpn ?adpm))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adpp Real)
    (declare-const ?adpq Real)
    (declare-const ?adpr Real)
    (assert
      (or (or (= ?adpr ?adpq)
          (= ?adpr ?adpp)
          )
        (= ?adpq ?adpp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adps Real)
    (declare-const ?adpt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adpu Real)
    (declare-const ?adpv Real)
    (declare-const ?adpw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adpx Real)
    (declare-const ?adpy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adpz Real)
    (declare-const ?adqa Real)
    (declare-const ?adqb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adqc Real)
    (declare-const ?adqd Real)
    (declare-const ?adqe Real)
    (declare-const ?adqf Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?adqd ?adqc))
                (not (= ?adqd ?asi))
                )
              (not (= ?adqc ?asi))
              )
            (or (or (= ?adqf ?adqe)
                (= ?adqf ?asi)
                )
              (= ?adqe ?asi)
              )
            )
          (and (or (or (= ?adqd ?adqc)
                (= ?adqd ?asi)
                )
              (= ?adqc ?asi)
              )
            (and (and (not (= ?adqf ?adqe))
                (not (= ?adqf ?asi))
                )
              (not (= ?adqe ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adqg Real)
    (declare-const ?adqh Real)
    (declare-const ?adqi Real)
    (declare-const ?adqj Real)
    (declare-const ?adqk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adql Real)
    (declare-const ?adqm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adqn Real)
    (declare-const ?adqo Real)
    (declare-const ?adqp Real)
    (declare-const ?adqq Real)
    (declare-const ?adqr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adqs Real)
    (declare-const ?adqt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adqu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adqv Real)
    (declare-const ?adqw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adqx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adqy Real)
    (declare-const ?adqz Real)
    (assert
      (not (= ?adqy ?adqz))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adra Real)
    (declare-const ?adrb Real)
    (declare-const ?adrc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adrd Real)
    (declare-const ?adre Real)
    (declare-const ?adrf Real)
    (declare-const ?adrg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adrh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adri Real)
    (declare-const ?adrj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adrk Real)
    (declare-const ?adrl Real)
    (declare-const ?adrm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adrn Real)
    (declare-const ?adro Real)
    (declare-const ?adrp Real)
    (declare-const ?adrq Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?adro ?adrn))
                (not (= ?adro ?fkf))
                )
              (not (= ?adrn ?fkf))
              )
            (or (or (= ?adrq ?adrp)
                (= ?adrq ?fkf)
                )
              (= ?adrp ?fkf)
              )
            )
          (and (or (or (= ?adro ?adrn)
                (= ?adro ?fkf)
                )
              (= ?adrn ?fkf)
              )
            (and (and (not (= ?adrq ?adrp))
                (not (= ?adrq ?fkf))
                )
              (not (= ?adrp ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adrr Real)
    (declare-const ?adrs Real)
    (declare-const ?adrt Real)
    (declare-const ?adru Real)
    (declare-const ?adrv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adrw Real)
    (declare-const ?adrx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adry Real)
    (declare-const ?adrz Real)
    (declare-const ?adsa Real)
    (declare-const ?adsb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adsc Real)
    (declare-const ?adsd Real)
    (declare-const ?adse Real)
    (declare-const ?adsf Real)
    (declare-const ?adsg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adsh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adsi Real)
    (declare-const ?adsj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adsk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adsl Real)
    (declare-const ?adsm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adsn Real)
    (declare-const ?adso Real)
    (declare-const ?adsp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adsq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adsr Real)
    (declare-const ?adss Real)
    (assert
      (not (= ?adsr ?adss))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adst Real)
    (declare-const ?adsu Real)
    (declare-const ?adsv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adsw Real)
    (declare-const ?adsx Real)
    (declare-const ?adsy Real)
    (declare-const ?adsz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adta Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adtb Real)
    (declare-const ?adtc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adtd Real)
    (declare-const ?adte Real)
    (declare-const ?adtf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adtg Real)
    (declare-const ?adth Real)
    (declare-const ?adti Real)
    (declare-const ?adtj Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?adth ?adtg))
                (not (= ?adth ?mzs))
                )
              (not (= ?adtg ?mzs))
              )
            (or (or (= ?adtj ?adti)
                (= ?adtj ?mzs)
                )
              (= ?adti ?mzs)
              )
            )
          (and (or (or (= ?adth ?adtg)
                (= ?adth ?mzs)
                )
              (= ?adtg ?mzs)
              )
            (and (and (not (= ?adtj ?adti))
                (not (= ?adtj ?mzs))
                )
              (not (= ?adti ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adtk Real)
    (declare-const ?adtl Real)
    (declare-const ?adtm Real)
    (declare-const ?adtn Real)
    (declare-const ?adto Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adtp Real)
    (declare-const ?adtq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adtr Real)
    (declare-const ?adts Real)
    (declare-const ?adtt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adtu Real)
    (declare-const ?adtv Real)
    (declare-const ?adtw Real)
    (declare-const ?adtx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adty Real)
    (declare-const ?adtz Real)
    (declare-const ?adua Real)
    (declare-const ?adub Real)
    (declare-const ?aduc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adud Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adue Real)
    (declare-const ?aduf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?adug Real)
  (declare-const ?aduh Real)
  (declare-const ?adui Real)
  (declare-const ?aduj Real)
  (declare-const ?aduk Real)
  (push 1)
    (declare-const ?adul Real)
    (declare-const ?adum Real)
    (declare-const ?adun Real)
    (assert
      (or (or (= ?adun ?adum)
          (= ?adun ?adul)
          )
        (= ?adum ?adul)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aduo Real)
    (declare-const ?adup Real)
    (declare-const ?aduq Real)
    (declare-const ?adur Real)
    (assert
      (or (or (= ?adur ?aduq)
          (= ?adur ?adup)
          )
        (= ?aduq ?adup)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adus Real)
    (declare-const ?adut Real)
    (declare-const ?aduu Real)
    (declare-const ?aduv Real)
    (declare-const ?aduw Real)
    (assert
      (or (or (= ?aduw ?aduv)
          (= ?aduw ?aduu)
          )
        (= ?aduv ?aduu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adux Real)
    (declare-const ?aduy Real)
    (declare-const ?aduz Real)
    (declare-const ?adva Real)
    (declare-const ?advb Real)
    (declare-const ?advc Real)
    (assert
      (and (and (and (not (= ?aduz ?aduy))
            (not (= ?aduz ?adux))
            )
          (not (= ?aduy ?adux))
          )
        (or (or (= ?advc ?advb)
            (= ?advc ?adva)
            )
          (= ?advb ?adva)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?advd Real)
    (declare-const ?adve Real)
    (declare-const ?advf Real)
    (assert
      (or (or (= ?advf ?adve)
          (= ?advf ?advd)
          )
        (= ?adve ?advd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?advg Real)
    (declare-const ?advh Real)
    (declare-const ?advi Real)
    (assert
      (or (or (= ?advi ?advh)
          (= ?advi ?advg)
          )
        (= ?advh ?advg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?advj Real)
    (declare-const ?advk Real)
    (declare-const ?advl Real)
    (declare-const ?advm Real)
    (assert
      (or (or (= ?advl ?advk)
          (= ?advl ?advj)
          )
        (= ?advk ?advj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?advn Real)
    (declare-const ?advo Real)
    (declare-const ?advp Real)
    (declare-const ?advq Real)
    (declare-const ?advr Real)
    (assert
      (or (or (= ?advp ?advo)
          (= ?advp ?advn)
          )
        (= ?advo ?advn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?advs Real)
    (declare-const ?advt Real)
    (declare-const ?advu Real)
    (declare-const ?advv Real)
    (declare-const ?advw Real)
    (declare-const ?advx Real)
    (assert
      (and (or (or (= ?advu ?advt)
            (= ?advu ?advs)
            )
          (= ?advt ?advs)
          )
        (and (and (not (= ?advx ?advw))
            (not (= ?advx ?advv))
            )
          (not (= ?advw ?advv))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?advy Real)
    (declare-const ?advz Real)
    (declare-const ?adwa Real)
    (assert
      (or (or (= ?adwa ?advz)
          (= ?adwa ?advy)
          )
        (= ?advz ?advy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adwb Real)
    (declare-const ?adwc Real)
    (declare-const ?adwd Real)
    (declare-const ?adwe Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?adwc ?adwb))
                (not (= ?adwc ?asi))
                )
              (not (= ?adwb ?asi))
              )
            (or (or (= ?adwe ?adwd)
                (= ?adwe ?asi)
                )
              (= ?adwd ?asi)
              )
            )
          (and (or (or (= ?adwc ?adwb)
                (= ?adwc ?asi)
                )
              (= ?adwb ?asi)
              )
            (and (and (not (= ?adwe ?adwd))
                (not (= ?adwe ?asi))
                )
              (not (= ?adwd ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adwf Real)
    (declare-const ?adwg Real)
    (declare-const ?adwh Real)
    (declare-const ?adwi Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?adwg ?adwf))
                (not (= ?adwg ?fkf))
                )
              (not (= ?adwf ?fkf))
              )
            (or (or (= ?adwi ?adwh)
                (= ?adwi ?fkf)
                )
              (= ?adwh ?fkf)
              )
            )
          (and (or (or (= ?adwg ?adwf)
                (= ?adwg ?fkf)
                )
              (= ?adwf ?fkf)
              )
            (and (and (not (= ?adwi ?adwh))
                (not (= ?adwi ?fkf))
                )
              (not (= ?adwh ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adwj Real)
    (declare-const ?adwk Real)
    (declare-const ?adwl Real)
    (declare-const ?adwm Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?adwk ?adwj))
                (not (= ?adwk ?mzs))
                )
              (not (= ?adwj ?mzs))
              )
            (or (or (= ?adwm ?adwl)
                (= ?adwm ?mzs)
                )
              (= ?adwl ?mzs)
              )
            )
          (and (or (or (= ?adwk ?adwj)
                (= ?adwk ?mzs)
                )
              (= ?adwj ?mzs)
              )
            (and (and (not (= ?adwm ?adwl))
                (not (= ?adwm ?mzs))
                )
              (not (= ?adwl ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?adwn Real)
  (declare-const ?adwo Real)
  (push 1)
    (declare-const ?adwp Real)
    (declare-const ?adwq Real)
    (declare-const ?adwr Real)
    (assert
      (or (or (= ?adwr ?adwq)
          (= ?adwr ?adwp)
          )
        (= ?adwq ?adwp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adws Real)
    (declare-const ?adwt Real)
    (declare-const ?adwu Real)
    (declare-const ?adwv Real)
    (assert
      (or (or (= ?adwv ?adwu)
          (= ?adwv ?adwt)
          )
        (= ?adwu ?adwt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adww Real)
    (declare-const ?adwx Real)
    (declare-const ?adwy Real)
    (declare-const ?adwz Real)
    (declare-const ?adxa Real)
    (assert
      (or (or (= ?adxa ?adwz)
          (= ?adxa ?adwy)
          )
        (= ?adwz ?adwy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adxb Real)
    (declare-const ?adxc Real)
    (declare-const ?adxd Real)
    (declare-const ?adxe Real)
    (declare-const ?adxf Real)
    (declare-const ?adxg Real)
    (assert
      (and (and (and (not (= ?adxd ?adxc))
            (not (= ?adxd ?adxb))
            )
          (not (= ?adxc ?adxb))
          )
        (or (or (= ?adxg ?adxf)
            (= ?adxg ?adxe)
            )
          (= ?adxf ?adxe)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adxh Real)
    (declare-const ?adxi Real)
    (declare-const ?adxj Real)
    (assert
      (or (or (= ?adxj ?adxi)
          (= ?adxj ?adxh)
          )
        (= ?adxi ?adxh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adxk Real)
    (declare-const ?adxl Real)
    (declare-const ?adxm Real)
    (assert
      (or (or (= ?adxm ?adxl)
          (= ?adxm ?adxk)
          )
        (= ?adxl ?adxk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adxn Real)
    (declare-const ?adxo Real)
    (declare-const ?adxp Real)
    (declare-const ?adxq Real)
    (assert
      (or (or (= ?adxp ?adxo)
          (= ?adxp ?adxn)
          )
        (= ?adxo ?adxn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adxr Real)
    (declare-const ?adxs Real)
    (declare-const ?adxt Real)
    (declare-const ?adxu Real)
    (declare-const ?adxv Real)
    (assert
      (or (or (= ?adxt ?adxs)
          (= ?adxt ?adxr)
          )
        (= ?adxs ?adxr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adxw Real)
    (declare-const ?adxx Real)
    (declare-const ?adxy Real)
    (declare-const ?adxz Real)
    (declare-const ?adya Real)
    (declare-const ?adyb Real)
    (assert
      (and (or (or (= ?adxy ?adxx)
            (= ?adxy ?adxw)
            )
          (= ?adxx ?adxw)
          )
        (and (and (not (= ?adyb ?adya))
            (not (= ?adyb ?adxz))
            )
          (not (= ?adya ?adxz))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adyc Real)
    (declare-const ?adyd Real)
    (declare-const ?adye Real)
    (assert
      (or (or (= ?adye ?adyd)
          (= ?adye ?adyc)
          )
        (= ?adyd ?adyc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adyf Real)
    (declare-const ?adyg Real)
    (declare-const ?adyh Real)
    (declare-const ?adyi Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?adyg ?adyf))
                (not (= ?adyg ?asi))
                )
              (not (= ?adyf ?asi))
              )
            (or (or (= ?adyi ?adyh)
                (= ?adyi ?asi)
                )
              (= ?adyh ?asi)
              )
            )
          (and (or (or (= ?adyg ?adyf)
                (= ?adyg ?asi)
                )
              (= ?adyf ?asi)
              )
            (and (and (not (= ?adyi ?adyh))
                (not (= ?adyi ?asi))
                )
              (not (= ?adyh ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adyj Real)
    (declare-const ?adyk Real)
    (declare-const ?adyl Real)
    (declare-const ?adym Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?adyk ?adyj))
                (not (= ?adyk ?fkf))
                )
              (not (= ?adyj ?fkf))
              )
            (or (or (= ?adym ?adyl)
                (= ?adym ?fkf)
                )
              (= ?adyl ?fkf)
              )
            )
          (and (or (or (= ?adyk ?adyj)
                (= ?adyk ?fkf)
                )
              (= ?adyj ?fkf)
              )
            (and (and (not (= ?adym ?adyl))
                (not (= ?adym ?fkf))
                )
              (not (= ?adyl ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adyn Real)
    (declare-const ?adyo Real)
    (declare-const ?adyp Real)
    (declare-const ?adyq Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?adyo ?adyn))
                (not (= ?adyo ?mzs))
                )
              (not (= ?adyn ?mzs))
              )
            (or (or (= ?adyq ?adyp)
                (= ?adyq ?mzs)
                )
              (= ?adyp ?mzs)
              )
            )
          (and (or (or (= ?adyo ?adyn)
                (= ?adyo ?mzs)
                )
              (= ?adyn ?mzs)
              )
            (and (and (not (= ?adyq ?adyp))
                (not (= ?adyq ?mzs))
                )
              (not (= ?adyp ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?adyr Real)
  (declare-const ?adys Real)
  (declare-const ?adyt Real)
  (declare-const ?adyu Real)
  (declare-const ?adyv Real)
  (push 1)
    (declare-const ?adyw Real)
    (declare-const ?adyx Real)
    (declare-const ?adyy Real)
    (assert
      (or (or (= ?adyy ?adyx)
          (= ?adyy ?adyw)
          )
        (= ?adyx ?adyw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adyz Real)
    (declare-const ?adza Real)
    (declare-const ?adzb Real)
    (declare-const ?adzc Real)
    (assert
      (or (or (= ?adzc ?adzb)
          (= ?adzc ?adza)
          )
        (= ?adzb ?adza)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adzd Real)
    (declare-const ?adze Real)
    (declare-const ?adzf Real)
    (declare-const ?adzg Real)
    (declare-const ?adzh Real)
    (assert
      (or (or (= ?adzh ?adzg)
          (= ?adzh ?adzf)
          )
        (= ?adzg ?adzf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adzi Real)
    (declare-const ?adzj Real)
    (declare-const ?adzk Real)
    (declare-const ?adzl Real)
    (declare-const ?adzm Real)
    (declare-const ?adzn Real)
    (assert
      (and (and (and (not (= ?adzk ?adzj))
            (not (= ?adzk ?adzi))
            )
          (not (= ?adzj ?adzi))
          )
        (or (or (= ?adzn ?adzm)
            (= ?adzn ?adzl)
            )
          (= ?adzm ?adzl)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adzo Real)
    (declare-const ?adzp Real)
    (declare-const ?adzq Real)
    (assert
      (or (or (= ?adzq ?adzp)
          (= ?adzq ?adzo)
          )
        (= ?adzp ?adzo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adzr Real)
    (declare-const ?adzs Real)
    (declare-const ?adzt Real)
    (assert
      (or (or (= ?adzt ?adzs)
          (= ?adzt ?adzr)
          )
        (= ?adzs ?adzr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adzu Real)
    (declare-const ?adzv Real)
    (declare-const ?adzw Real)
    (declare-const ?adzx Real)
    (assert
      (or (or (= ?adzw ?adzv)
          (= ?adzw ?adzu)
          )
        (= ?adzv ?adzu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?adzy Real)
    (declare-const ?adzz Real)
    (declare-const ?aeaa Real)
    (declare-const ?aeab Real)
    (declare-const ?aeac Real)
    (assert
      (or (or (= ?aeaa ?adzz)
          (= ?aeaa ?adzy)
          )
        (= ?adzz ?adzy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aead Real)
    (declare-const ?aeae Real)
    (declare-const ?aeaf Real)
    (declare-const ?aeag Real)
    (declare-const ?aeah Real)
    (declare-const ?aeai Real)
    (assert
      (and (or (or (= ?aeaf ?aeae)
            (= ?aeaf ?aead)
            )
          (= ?aeae ?aead)
          )
        (and (and (not (= ?aeai ?aeah))
            (not (= ?aeai ?aeag))
            )
          (not (= ?aeah ?aeag))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeaj Real)
    (declare-const ?aeak Real)
    (declare-const ?aeal Real)
    (assert
      (or (or (= ?aeal ?aeak)
          (= ?aeal ?aeaj)
          )
        (= ?aeak ?aeaj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeam Real)
    (declare-const ?aean Real)
    (declare-const ?aeao Real)
    (declare-const ?aeap Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aean ?aeam))
                (not (= ?aean ?asi))
                )
              (not (= ?aeam ?asi))
              )
            (or (or (= ?aeap ?aeao)
                (= ?aeap ?asi)
                )
              (= ?aeao ?asi)
              )
            )
          (and (or (or (= ?aean ?aeam)
                (= ?aean ?asi)
                )
              (= ?aeam ?asi)
              )
            (and (and (not (= ?aeap ?aeao))
                (not (= ?aeap ?asi))
                )
              (not (= ?aeao ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeaq Real)
    (declare-const ?aear Real)
    (declare-const ?aeas Real)
    (declare-const ?aeat Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aear ?aeaq))
                (not (= ?aear ?fkf))
                )
              (not (= ?aeaq ?fkf))
              )
            (or (or (= ?aeat ?aeas)
                (= ?aeat ?fkf)
                )
              (= ?aeas ?fkf)
              )
            )
          (and (or (or (= ?aear ?aeaq)
                (= ?aear ?fkf)
                )
              (= ?aeaq ?fkf)
              )
            (and (and (not (= ?aeat ?aeas))
                (not (= ?aeat ?fkf))
                )
              (not (= ?aeas ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeau Real)
    (declare-const ?aeav Real)
    (declare-const ?aeaw Real)
    (declare-const ?aeax Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aeav ?aeau))
                (not (= ?aeav ?mzs))
                )
              (not (= ?aeau ?mzs))
              )
            (or (or (= ?aeax ?aeaw)
                (= ?aeax ?mzs)
                )
              (= ?aeaw ?mzs)
              )
            )
          (and (or (or (= ?aeav ?aeau)
                (= ?aeav ?mzs)
                )
              (= ?aeau ?mzs)
              )
            (and (and (not (= ?aeax ?aeaw))
                (not (= ?aeax ?mzs))
                )
              (not (= ?aeaw ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aeay Real)
  (declare-const ?aeaz Real)
  (push 1)
    (declare-const ?aeba Real)
    (declare-const ?aebb Real)
    (declare-const ?aebc Real)
    (assert
      (or (or (= ?aebc ?aebb)
          (= ?aebc ?aeba)
          )
        (= ?aebb ?aeba)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aebd Real)
    (declare-const ?aebe Real)
    (declare-const ?aebf Real)
    (declare-const ?aebg Real)
    (assert
      (or (or (= ?aebg ?aebf)
          (= ?aebg ?aebe)
          )
        (= ?aebf ?aebe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aebh Real)
    (declare-const ?aebi Real)
    (declare-const ?aebj Real)
    (declare-const ?aebk Real)
    (declare-const ?aebl Real)
    (assert
      (or (or (= ?aebl ?aebk)
          (= ?aebl ?aebj)
          )
        (= ?aebk ?aebj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aebm Real)
    (declare-const ?aebn Real)
    (declare-const ?aebo Real)
    (declare-const ?aebp Real)
    (declare-const ?aebq Real)
    (declare-const ?aebr Real)
    (assert
      (and (and (and (not (= ?aebo ?aebn))
            (not (= ?aebo ?aebm))
            )
          (not (= ?aebn ?aebm))
          )
        (or (or (= ?aebr ?aebq)
            (= ?aebr ?aebp)
            )
          (= ?aebq ?aebp)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aebs Real)
    (declare-const ?aebt Real)
    (declare-const ?aebu Real)
    (assert
      (or (or (= ?aebu ?aebt)
          (= ?aebu ?aebs)
          )
        (= ?aebt ?aebs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aebv Real)
    (declare-const ?aebw Real)
    (declare-const ?aebx Real)
    (assert
      (or (or (= ?aebx ?aebw)
          (= ?aebx ?aebv)
          )
        (= ?aebw ?aebv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeby Real)
    (declare-const ?aebz Real)
    (declare-const ?aeca Real)
    (declare-const ?aecb Real)
    (assert
      (or (or (= ?aeca ?aebz)
          (= ?aeca ?aeby)
          )
        (= ?aebz ?aeby)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aecc Real)
    (declare-const ?aecd Real)
    (declare-const ?aece Real)
    (declare-const ?aecf Real)
    (declare-const ?aecg Real)
    (assert
      (or (or (= ?aece ?aecd)
          (= ?aece ?aecc)
          )
        (= ?aecd ?aecc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aech Real)
    (declare-const ?aeci Real)
    (declare-const ?aecj Real)
    (declare-const ?aeck Real)
    (declare-const ?aecl Real)
    (declare-const ?aecm Real)
    (assert
      (and (or (or (= ?aecj ?aeci)
            (= ?aecj ?aech)
            )
          (= ?aeci ?aech)
          )
        (and (and (not (= ?aecm ?aecl))
            (not (= ?aecm ?aeck))
            )
          (not (= ?aecl ?aeck))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aecn Real)
    (declare-const ?aeco Real)
    (declare-const ?aecp Real)
    (assert
      (or (or (= ?aecp ?aeco)
          (= ?aecp ?aecn)
          )
        (= ?aeco ?aecn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aecq Real)
    (declare-const ?aecr Real)
    (declare-const ?aecs Real)
    (declare-const ?aect Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aecr ?aecq))
                (not (= ?aecr ?asi))
                )
              (not (= ?aecq ?asi))
              )
            (or (or (= ?aect ?aecs)
                (= ?aect ?asi)
                )
              (= ?aecs ?asi)
              )
            )
          (and (or (or (= ?aecr ?aecq)
                (= ?aecr ?asi)
                )
              (= ?aecq ?asi)
              )
            (and (and (not (= ?aect ?aecs))
                (not (= ?aect ?asi))
                )
              (not (= ?aecs ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aecu Real)
    (declare-const ?aecv Real)
    (declare-const ?aecw Real)
    (declare-const ?aecx Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aecv ?aecu))
                (not (= ?aecv ?fkf))
                )
              (not (= ?aecu ?fkf))
              )
            (or (or (= ?aecx ?aecw)
                (= ?aecx ?fkf)
                )
              (= ?aecw ?fkf)
              )
            )
          (and (or (or (= ?aecv ?aecu)
                (= ?aecv ?fkf)
                )
              (= ?aecu ?fkf)
              )
            (and (and (not (= ?aecx ?aecw))
                (not (= ?aecx ?fkf))
                )
              (not (= ?aecw ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aecy Real)
    (declare-const ?aecz Real)
    (declare-const ?aeda Real)
    (declare-const ?aedb Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aecz ?aecy))
                (not (= ?aecz ?mzs))
                )
              (not (= ?aecy ?mzs))
              )
            (or (or (= ?aedb ?aeda)
                (= ?aedb ?mzs)
                )
              (= ?aeda ?mzs)
              )
            )
          (and (or (or (= ?aecz ?aecy)
                (= ?aecz ?mzs)
                )
              (= ?aecy ?mzs)
              )
            (and (and (not (= ?aedb ?aeda))
                (not (= ?aedb ?mzs))
                )
              (not (= ?aeda ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aedc Real)
  (push 1)
    (declare-const ?aedd Real)
    (declare-const ?aede Real)
    (declare-const ?aedf Real)
    (assert
      (or (or (= ?aedf ?aede)
          (= ?aedf ?aedd)
          )
        (= ?aede ?aedd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aedg Real)
    (declare-const ?aedh Real)
    (declare-const ?aedi Real)
    (declare-const ?aedj Real)
    (assert
      (or (or (= ?aedj ?aedi)
          (= ?aedj ?aedh)
          )
        (= ?aedi ?aedh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aedk Real)
    (declare-const ?aedl Real)
    (declare-const ?aedm Real)
    (declare-const ?aedn Real)
    (declare-const ?aedo Real)
    (assert
      (or (or (= ?aedo ?aedn)
          (= ?aedo ?aedm)
          )
        (= ?aedn ?aedm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aedp Real)
    (declare-const ?aedq Real)
    (declare-const ?aedr Real)
    (declare-const ?aeds Real)
    (declare-const ?aedt Real)
    (declare-const ?aedu Real)
    (assert
      (and (and (and (not (= ?aedr ?aedq))
            (not (= ?aedr ?aedp))
            )
          (not (= ?aedq ?aedp))
          )
        (or (or (= ?aedu ?aedt)
            (= ?aedu ?aeds)
            )
          (= ?aedt ?aeds)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aedv Real)
    (declare-const ?aedw Real)
    (declare-const ?aedx Real)
    (assert
      (or (or (= ?aedx ?aedw)
          (= ?aedx ?aedv)
          )
        (= ?aedw ?aedv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aedy Real)
    (declare-const ?aedz Real)
    (declare-const ?aeea Real)
    (assert
      (or (or (= ?aeea ?aedz)
          (= ?aeea ?aedy)
          )
        (= ?aedz ?aedy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeeb Real)
    (declare-const ?aeec Real)
    (declare-const ?aeed Real)
    (declare-const ?aeee Real)
    (assert
      (or (or (= ?aeed ?aeec)
          (= ?aeed ?aeeb)
          )
        (= ?aeec ?aeeb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeef Real)
    (declare-const ?aeeg Real)
    (declare-const ?aeeh Real)
    (declare-const ?aeei Real)
    (declare-const ?aeej Real)
    (assert
      (or (or (= ?aeeh ?aeeg)
          (= ?aeeh ?aeef)
          )
        (= ?aeeg ?aeef)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeek Real)
    (declare-const ?aeel Real)
    (declare-const ?aeem Real)
    (declare-const ?aeen Real)
    (declare-const ?aeeo Real)
    (declare-const ?aeep Real)
    (assert
      (and (or (or (= ?aeem ?aeel)
            (= ?aeem ?aeek)
            )
          (= ?aeel ?aeek)
          )
        (and (and (not (= ?aeep ?aeeo))
            (not (= ?aeep ?aeen))
            )
          (not (= ?aeeo ?aeen))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeeq Real)
    (declare-const ?aeer Real)
    (declare-const ?aees Real)
    (assert
      (or (or (= ?aees ?aeer)
          (= ?aees ?aeeq)
          )
        (= ?aeer ?aeeq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeet Real)
    (declare-const ?aeeu Real)
    (declare-const ?aeev Real)
    (declare-const ?aeew Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aeeu ?aeet))
                (not (= ?aeeu ?asi))
                )
              (not (= ?aeet ?asi))
              )
            (or (or (= ?aeew ?aeev)
                (= ?aeew ?asi)
                )
              (= ?aeev ?asi)
              )
            )
          (and (or (or (= ?aeeu ?aeet)
                (= ?aeeu ?asi)
                )
              (= ?aeet ?asi)
              )
            (and (and (not (= ?aeew ?aeev))
                (not (= ?aeew ?asi))
                )
              (not (= ?aeev ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeex Real)
    (declare-const ?aeey Real)
    (declare-const ?aeez Real)
    (declare-const ?aefa Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aeey ?aeex))
                (not (= ?aeey ?fkf))
                )
              (not (= ?aeex ?fkf))
              )
            (or (or (= ?aefa ?aeez)
                (= ?aefa ?fkf)
                )
              (= ?aeez ?fkf)
              )
            )
          (and (or (or (= ?aeey ?aeex)
                (= ?aeey ?fkf)
                )
              (= ?aeex ?fkf)
              )
            (and (and (not (= ?aefa ?aeez))
                (not (= ?aefa ?fkf))
                )
              (not (= ?aeez ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aefb Real)
    (declare-const ?aefc Real)
    (declare-const ?aefd Real)
    (declare-const ?aefe Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aefc ?aefb))
                (not (= ?aefc ?mzs))
                )
              (not (= ?aefb ?mzs))
              )
            (or (or (= ?aefe ?aefd)
                (= ?aefe ?mzs)
                )
              (= ?aefd ?mzs)
              )
            )
          (and (or (or (= ?aefc ?aefb)
                (= ?aefc ?mzs)
                )
              (= ?aefb ?mzs)
              )
            (and (and (not (= ?aefe ?aefd))
                (not (= ?aefe ?mzs))
                )
              (not (= ?aefd ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aeff Real)
  (declare-const ?aefg Real)
  (push 1)
    (declare-const ?aefh Real)
    (declare-const ?aefi Real)
    (declare-const ?aefj Real)
    (assert
      (or (or (= ?aefj ?aefi)
          (= ?aefj ?aefh)
          )
        (= ?aefi ?aefh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aefk Real)
    (declare-const ?aefl Real)
    (declare-const ?aefm Real)
    (declare-const ?aefn Real)
    (assert
      (or (or (= ?aefn ?aefm)
          (= ?aefn ?aefl)
          )
        (= ?aefm ?aefl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aefo Real)
    (declare-const ?aefp Real)
    (declare-const ?aefq Real)
    (declare-const ?aefr Real)
    (declare-const ?aefs Real)
    (assert
      (or (or (= ?aefs ?aefr)
          (= ?aefs ?aefq)
          )
        (= ?aefr ?aefq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeft Real)
    (declare-const ?aefu Real)
    (declare-const ?aefv Real)
    (declare-const ?aefw Real)
    (declare-const ?aefx Real)
    (declare-const ?aefy Real)
    (assert
      (and (and (and (not (= ?aefv ?aefu))
            (not (= ?aefv ?aeft))
            )
          (not (= ?aefu ?aeft))
          )
        (or (or (= ?aefy ?aefx)
            (= ?aefy ?aefw)
            )
          (= ?aefx ?aefw)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aefz Real)
    (declare-const ?aega Real)
    (declare-const ?aegb Real)
    (assert
      (or (or (= ?aegb ?aega)
          (= ?aegb ?aefz)
          )
        (= ?aega ?aefz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aegc Real)
    (declare-const ?aegd Real)
    (declare-const ?aege Real)
    (assert
      (or (or (= ?aege ?aegd)
          (= ?aege ?aegc)
          )
        (= ?aegd ?aegc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aegf Real)
    (declare-const ?aegg Real)
    (declare-const ?aegh Real)
    (declare-const ?aegi Real)
    (assert
      (or (or (= ?aegh ?aegg)
          (= ?aegh ?aegf)
          )
        (= ?aegg ?aegf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aegj Real)
    (declare-const ?aegk Real)
    (declare-const ?aegl Real)
    (declare-const ?aegm Real)
    (declare-const ?aegn Real)
    (assert
      (or (or (= ?aegl ?aegk)
          (= ?aegl ?aegj)
          )
        (= ?aegk ?aegj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aego Real)
    (declare-const ?aegp Real)
    (declare-const ?aegq Real)
    (declare-const ?aegr Real)
    (declare-const ?aegs Real)
    (declare-const ?aegt Real)
    (assert
      (and (or (or (= ?aegq ?aegp)
            (= ?aegq ?aego)
            )
          (= ?aegp ?aego)
          )
        (and (and (not (= ?aegt ?aegs))
            (not (= ?aegt ?aegr))
            )
          (not (= ?aegs ?aegr))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aegu Real)
    (declare-const ?aegv Real)
    (declare-const ?aegw Real)
    (assert
      (or (or (= ?aegw ?aegv)
          (= ?aegw ?aegu)
          )
        (= ?aegv ?aegu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aegx Real)
    (declare-const ?aegy Real)
    (declare-const ?aegz Real)
    (declare-const ?aeha Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aegy ?aegx))
                (not (= ?aegy ?asi))
                )
              (not (= ?aegx ?asi))
              )
            (or (or (= ?aeha ?aegz)
                (= ?aeha ?asi)
                )
              (= ?aegz ?asi)
              )
            )
          (and (or (or (= ?aegy ?aegx)
                (= ?aegy ?asi)
                )
              (= ?aegx ?asi)
              )
            (and (and (not (= ?aeha ?aegz))
                (not (= ?aeha ?asi))
                )
              (not (= ?aegz ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aehb Real)
    (declare-const ?aehc Real)
    (declare-const ?aehd Real)
    (declare-const ?aehe Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aehc ?aehb))
                (not (= ?aehc ?fkf))
                )
              (not (= ?aehb ?fkf))
              )
            (or (or (= ?aehe ?aehd)
                (= ?aehe ?fkf)
                )
              (= ?aehd ?fkf)
              )
            )
          (and (or (or (= ?aehc ?aehb)
                (= ?aehc ?fkf)
                )
              (= ?aehb ?fkf)
              )
            (and (and (not (= ?aehe ?aehd))
                (not (= ?aehe ?fkf))
                )
              (not (= ?aehd ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aehf Real)
    (declare-const ?aehg Real)
    (declare-const ?aehh Real)
    (declare-const ?aehi Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aehg ?aehf))
                (not (= ?aehg ?mzs))
                )
              (not (= ?aehf ?mzs))
              )
            (or (or (= ?aehi ?aehh)
                (= ?aehi ?mzs)
                )
              (= ?aehh ?mzs)
              )
            )
          (and (or (or (= ?aehg ?aehf)
                (= ?aehg ?mzs)
                )
              (= ?aehf ?mzs)
              )
            (and (and (not (= ?aehi ?aehh))
                (not (= ?aehi ?mzs))
                )
              (not (= ?aehh ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aehj Real)
  (push 1)
    (declare-const ?aehk Real)
    (declare-const ?aehl Real)
    (declare-const ?aehm Real)
    (assert
      (or (or (= ?aehm ?aehl)
          (= ?aehm ?aehk)
          )
        (= ?aehl ?aehk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aehn Real)
    (declare-const ?aeho Real)
    (declare-const ?aehp Real)
    (declare-const ?aehq Real)
    (assert
      (or (or (= ?aehq ?aehp)
          (= ?aehq ?aeho)
          )
        (= ?aehp ?aeho)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aehr Real)
    (declare-const ?aehs Real)
    (declare-const ?aeht Real)
    (declare-const ?aehu Real)
    (declare-const ?aehv Real)
    (assert
      (or (or (= ?aehv ?aehu)
          (= ?aehv ?aeht)
          )
        (= ?aehu ?aeht)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aehw Real)
    (declare-const ?aehx Real)
    (declare-const ?aehy Real)
    (declare-const ?aehz Real)
    (declare-const ?aeia Real)
    (declare-const ?aeib Real)
    (assert
      (and (and (and (not (= ?aehy ?aehx))
            (not (= ?aehy ?aehw))
            )
          (not (= ?aehx ?aehw))
          )
        (or (or (= ?aeib ?aeia)
            (= ?aeib ?aehz)
            )
          (= ?aeia ?aehz)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeic Real)
    (declare-const ?aeid Real)
    (declare-const ?aeie Real)
    (assert
      (or (or (= ?aeie ?aeid)
          (= ?aeie ?aeic)
          )
        (= ?aeid ?aeic)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeif Real)
    (declare-const ?aeig Real)
    (declare-const ?aeih Real)
    (assert
      (or (or (= ?aeih ?aeig)
          (= ?aeih ?aeif)
          )
        (= ?aeig ?aeif)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeii Real)
    (declare-const ?aeij Real)
    (declare-const ?aeik Real)
    (declare-const ?aeil Real)
    (assert
      (or (or (= ?aeik ?aeij)
          (= ?aeik ?aeii)
          )
        (= ?aeij ?aeii)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeim Real)
    (declare-const ?aein Real)
    (declare-const ?aeio Real)
    (declare-const ?aeip Real)
    (declare-const ?aeiq Real)
    (assert
      (or (or (= ?aeio ?aein)
          (= ?aeio ?aeim)
          )
        (= ?aein ?aeim)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeir Real)
    (declare-const ?aeis Real)
    (declare-const ?aeit Real)
    (declare-const ?aeiu Real)
    (declare-const ?aeiv Real)
    (declare-const ?aeiw Real)
    (assert
      (and (or (or (= ?aeit ?aeis)
            (= ?aeit ?aeir)
            )
          (= ?aeis ?aeir)
          )
        (and (and (not (= ?aeiw ?aeiv))
            (not (= ?aeiw ?aeiu))
            )
          (not (= ?aeiv ?aeiu))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeix Real)
    (declare-const ?aeiy Real)
    (declare-const ?aeiz Real)
    (assert
      (or (or (= ?aeiz ?aeiy)
          (= ?aeiz ?aeix)
          )
        (= ?aeiy ?aeix)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeja Real)
    (declare-const ?aejb Real)
    (declare-const ?aejc Real)
    (declare-const ?aejd Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aejb ?aeja))
                (not (= ?aejb ?asi))
                )
              (not (= ?aeja ?asi))
              )
            (or (or (= ?aejd ?aejc)
                (= ?aejd ?asi)
                )
              (= ?aejc ?asi)
              )
            )
          (and (or (or (= ?aejb ?aeja)
                (= ?aejb ?asi)
                )
              (= ?aeja ?asi)
              )
            (and (and (not (= ?aejd ?aejc))
                (not (= ?aejd ?asi))
                )
              (not (= ?aejc ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeje Real)
    (declare-const ?aejf Real)
    (declare-const ?aejg Real)
    (declare-const ?aejh Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aejf ?aeje))
                (not (= ?aejf ?fkf))
                )
              (not (= ?aeje ?fkf))
              )
            (or (or (= ?aejh ?aejg)
                (= ?aejh ?fkf)
                )
              (= ?aejg ?fkf)
              )
            )
          (and (or (or (= ?aejf ?aeje)
                (= ?aejf ?fkf)
                )
              (= ?aeje ?fkf)
              )
            (and (and (not (= ?aejh ?aejg))
                (not (= ?aejh ?fkf))
                )
              (not (= ?aejg ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeji Real)
    (declare-const ?aejj Real)
    (declare-const ?aejk Real)
    (declare-const ?aejl Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aejj ?aeji))
                (not (= ?aejj ?mzs))
                )
              (not (= ?aeji ?mzs))
              )
            (or (or (= ?aejl ?aejk)
                (= ?aejl ?mzs)
                )
              (= ?aejk ?mzs)
              )
            )
          (and (or (or (= ?aejj ?aeji)
                (= ?aejj ?mzs)
                )
              (= ?aeji ?mzs)
              )
            (and (and (not (= ?aejl ?aejk))
                (not (= ?aejl ?mzs))
                )
              (not (= ?aejk ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aejm Real)
  (declare-const ?aejn Real)
  (assert
    (not (= ?aejm ?aejn))
    )
  (push 1)
    (declare-const ?aejo Real)
    (declare-const ?aejp Real)
    (declare-const ?aejq Real)
    (assert
      (or (or (= ?aejq ?aejp)
          (= ?aejq ?aejo)
          )
        (= ?aejp ?aejo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aejr Real)
    (declare-const ?aejs Real)
    (declare-const ?aejt Real)
    (declare-const ?aeju Real)
    (assert
      (or (or (= ?aeju ?aejt)
          (= ?aeju ?aejs)
          )
        (= ?aejt ?aejs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aejv Real)
    (declare-const ?aejw Real)
    (declare-const ?aejx Real)
    (declare-const ?aejy Real)
    (declare-const ?aejz Real)
    (assert
      (or (or (= ?aejz ?aejy)
          (= ?aejz ?aejx)
          )
        (= ?aejy ?aejx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeka Real)
    (declare-const ?aekb Real)
    (declare-const ?aekc Real)
    (declare-const ?aekd Real)
    (declare-const ?aeke Real)
    (declare-const ?aekf Real)
    (assert
      (and (and (and (not (= ?aekc ?aekb))
            (not (= ?aekc ?aeka))
            )
          (not (= ?aekb ?aeka))
          )
        (or (or (= ?aekf ?aeke)
            (= ?aekf ?aekd)
            )
          (= ?aeke ?aekd)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aekg Real)
    (declare-const ?aekh Real)
    (declare-const ?aeki Real)
    (assert
      (or (or (= ?aeki ?aekh)
          (= ?aeki ?aekg)
          )
        (= ?aekh ?aekg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aekj Real)
    (declare-const ?aekk Real)
    (declare-const ?aekl Real)
    (assert
      (or (or (= ?aekl ?aekk)
          (= ?aekl ?aekj)
          )
        (= ?aekk ?aekj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aekm Real)
    (declare-const ?aekn Real)
    (declare-const ?aeko Real)
    (declare-const ?aekp Real)
    (assert
      (or (or (= ?aeko ?aekn)
          (= ?aeko ?aekm)
          )
        (= ?aekn ?aekm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aekq Real)
    (declare-const ?aekr Real)
    (declare-const ?aeks Real)
    (declare-const ?aekt Real)
    (declare-const ?aeku Real)
    (assert
      (or (or (= ?aeks ?aekr)
          (= ?aeks ?aekq)
          )
        (= ?aekr ?aekq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aekv Real)
    (declare-const ?aekw Real)
    (declare-const ?aekx Real)
    (declare-const ?aeky Real)
    (declare-const ?aekz Real)
    (declare-const ?aela Real)
    (assert
      (and (or (or (= ?aekx ?aekw)
            (= ?aekx ?aekv)
            )
          (= ?aekw ?aekv)
          )
        (and (and (not (= ?aela ?aekz))
            (not (= ?aela ?aeky))
            )
          (not (= ?aekz ?aeky))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aelb Real)
    (declare-const ?aelc Real)
    (declare-const ?aeld Real)
    (assert
      (or (or (= ?aeld ?aelc)
          (= ?aeld ?aelb)
          )
        (= ?aelc ?aelb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aele Real)
    (declare-const ?aelf Real)
    (declare-const ?aelg Real)
    (declare-const ?aelh Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aelf ?aele))
                (not (= ?aelf ?asi))
                )
              (not (= ?aele ?asi))
              )
            (or (or (= ?aelh ?aelg)
                (= ?aelh ?asi)
                )
              (= ?aelg ?asi)
              )
            )
          (and (or (or (= ?aelf ?aele)
                (= ?aelf ?asi)
                )
              (= ?aele ?asi)
              )
            (and (and (not (= ?aelh ?aelg))
                (not (= ?aelh ?asi))
                )
              (not (= ?aelg ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeli Real)
    (declare-const ?aelj Real)
    (declare-const ?aelk Real)
    (declare-const ?aell Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aelj ?aeli))
                (not (= ?aelj ?fkf))
                )
              (not (= ?aeli ?fkf))
              )
            (or (or (= ?aell ?aelk)
                (= ?aell ?fkf)
                )
              (= ?aelk ?fkf)
              )
            )
          (and (or (or (= ?aelj ?aeli)
                (= ?aelj ?fkf)
                )
              (= ?aeli ?fkf)
              )
            (and (and (not (= ?aell ?aelk))
                (not (= ?aell ?fkf))
                )
              (not (= ?aelk ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aelm Real)
    (declare-const ?aeln Real)
    (declare-const ?aelo Real)
    (declare-const ?aelp Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aeln ?aelm))
                (not (= ?aeln ?mzs))
                )
              (not (= ?aelm ?mzs))
              )
            (or (or (= ?aelp ?aelo)
                (= ?aelp ?mzs)
                )
              (= ?aelo ?mzs)
              )
            )
          (and (or (or (= ?aeln ?aelm)
                (= ?aeln ?mzs)
                )
              (= ?aelm ?mzs)
              )
            (and (and (not (= ?aelp ?aelo))
                (not (= ?aelp ?mzs))
                )
              (not (= ?aelo ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aelq Real)
  (declare-const ?aelr Real)
  (declare-const ?aels Real)
  (push 1)
    (declare-const ?aelt Real)
    (declare-const ?aelu Real)
    (declare-const ?aelv Real)
    (assert
      (or (or (= ?aelv ?aelu)
          (= ?aelv ?aelt)
          )
        (= ?aelu ?aelt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aelw Real)
    (declare-const ?aelx Real)
    (declare-const ?aely Real)
    (declare-const ?aelz Real)
    (assert
      (or (or (= ?aelz ?aely)
          (= ?aelz ?aelx)
          )
        (= ?aely ?aelx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aema Real)
    (declare-const ?aemb Real)
    (declare-const ?aemc Real)
    (declare-const ?aemd Real)
    (declare-const ?aeme Real)
    (assert
      (or (or (= ?aeme ?aemd)
          (= ?aeme ?aemc)
          )
        (= ?aemd ?aemc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aemf Real)
    (declare-const ?aemg Real)
    (declare-const ?aemh Real)
    (declare-const ?aemi Real)
    (declare-const ?aemj Real)
    (declare-const ?aemk Real)
    (assert
      (and (and (and (not (= ?aemh ?aemg))
            (not (= ?aemh ?aemf))
            )
          (not (= ?aemg ?aemf))
          )
        (or (or (= ?aemk ?aemj)
            (= ?aemk ?aemi)
            )
          (= ?aemj ?aemi)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeml Real)
    (declare-const ?aemm Real)
    (declare-const ?aemn Real)
    (assert
      (or (or (= ?aemn ?aemm)
          (= ?aemn ?aeml)
          )
        (= ?aemm ?aeml)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aemo Real)
    (declare-const ?aemp Real)
    (declare-const ?aemq Real)
    (assert
      (or (or (= ?aemq ?aemp)
          (= ?aemq ?aemo)
          )
        (= ?aemp ?aemo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aemr Real)
    (declare-const ?aems Real)
    (declare-const ?aemt Real)
    (declare-const ?aemu Real)
    (assert
      (or (or (= ?aemt ?aems)
          (= ?aemt ?aemr)
          )
        (= ?aems ?aemr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aemv Real)
    (declare-const ?aemw Real)
    (declare-const ?aemx Real)
    (declare-const ?aemy Real)
    (declare-const ?aemz Real)
    (assert
      (or (or (= ?aemx ?aemw)
          (= ?aemx ?aemv)
          )
        (= ?aemw ?aemv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aena Real)
    (declare-const ?aenb Real)
    (declare-const ?aenc Real)
    (declare-const ?aend Real)
    (declare-const ?aene Real)
    (declare-const ?aenf Real)
    (assert
      (and (or (or (= ?aenc ?aenb)
            (= ?aenc ?aena)
            )
          (= ?aenb ?aena)
          )
        (and (and (not (= ?aenf ?aene))
            (not (= ?aenf ?aend))
            )
          (not (= ?aene ?aend))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeng Real)
    (declare-const ?aenh Real)
    (declare-const ?aeni Real)
    (assert
      (or (or (= ?aeni ?aenh)
          (= ?aeni ?aeng)
          )
        (= ?aenh ?aeng)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aenj Real)
    (declare-const ?aenk Real)
    (declare-const ?aenl Real)
    (declare-const ?aenm Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aenk ?aenj))
                (not (= ?aenk ?asi))
                )
              (not (= ?aenj ?asi))
              )
            (or (or (= ?aenm ?aenl)
                (= ?aenm ?asi)
                )
              (= ?aenl ?asi)
              )
            )
          (and (or (or (= ?aenk ?aenj)
                (= ?aenk ?asi)
                )
              (= ?aenj ?asi)
              )
            (and (and (not (= ?aenm ?aenl))
                (not (= ?aenm ?asi))
                )
              (not (= ?aenl ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aenn Real)
    (declare-const ?aeno Real)
    (declare-const ?aenp Real)
    (declare-const ?aenq Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aeno ?aenn))
                (not (= ?aeno ?fkf))
                )
              (not (= ?aenn ?fkf))
              )
            (or (or (= ?aenq ?aenp)
                (= ?aenq ?fkf)
                )
              (= ?aenp ?fkf)
              )
            )
          (and (or (or (= ?aeno ?aenn)
                (= ?aeno ?fkf)
                )
              (= ?aenn ?fkf)
              )
            (and (and (not (= ?aenq ?aenp))
                (not (= ?aenq ?fkf))
                )
              (not (= ?aenp ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aenr Real)
    (declare-const ?aens Real)
    (declare-const ?aent Real)
    (declare-const ?aenu Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aens ?aenr))
                (not (= ?aens ?mzs))
                )
              (not (= ?aenr ?mzs))
              )
            (or (or (= ?aenu ?aent)
                (= ?aenu ?mzs)
                )
              (= ?aent ?mzs)
              )
            )
          (and (or (or (= ?aens ?aenr)
                (= ?aens ?mzs)
                )
              (= ?aenr ?mzs)
              )
            (and (and (not (= ?aenu ?aent))
                (not (= ?aenu ?mzs))
                )
              (not (= ?aent ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aenv Real)
  (declare-const ?aenw Real)
  (declare-const ?aenx Real)
  (declare-const ?aeny Real)
  (push 1)
    (declare-const ?aenz Real)
    (declare-const ?aeoa Real)
    (declare-const ?aeob Real)
    (assert
      (or (or (= ?aeob ?aeoa)
          (= ?aeob ?aenz)
          )
        (= ?aeoa ?aenz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeoc Real)
    (declare-const ?aeod Real)
    (declare-const ?aeoe Real)
    (declare-const ?aeof Real)
    (assert
      (or (or (= ?aeof ?aeoe)
          (= ?aeof ?aeod)
          )
        (= ?aeoe ?aeod)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeog Real)
    (declare-const ?aeoh Real)
    (declare-const ?aeoi Real)
    (declare-const ?aeoj Real)
    (declare-const ?aeok Real)
    (assert
      (or (or (= ?aeok ?aeoj)
          (= ?aeok ?aeoi)
          )
        (= ?aeoj ?aeoi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeol Real)
    (declare-const ?aeom Real)
    (declare-const ?aeon Real)
    (declare-const ?aeoo Real)
    (declare-const ?aeop Real)
    (declare-const ?aeoq Real)
    (assert
      (and (and (and (not (= ?aeon ?aeom))
            (not (= ?aeon ?aeol))
            )
          (not (= ?aeom ?aeol))
          )
        (or (or (= ?aeoq ?aeop)
            (= ?aeoq ?aeoo)
            )
          (= ?aeop ?aeoo)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeor Real)
    (declare-const ?aeos Real)
    (declare-const ?aeot Real)
    (assert
      (or (or (= ?aeot ?aeos)
          (= ?aeot ?aeor)
          )
        (= ?aeos ?aeor)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeou Real)
    (declare-const ?aeov Real)
    (declare-const ?aeow Real)
    (assert
      (or (or (= ?aeow ?aeov)
          (= ?aeow ?aeou)
          )
        (= ?aeov ?aeou)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeox Real)
    (declare-const ?aeoy Real)
    (declare-const ?aeoz Real)
    (declare-const ?aepa Real)
    (assert
      (or (or (= ?aeoz ?aeoy)
          (= ?aeoz ?aeox)
          )
        (= ?aeoy ?aeox)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aepb Real)
    (declare-const ?aepc Real)
    (declare-const ?aepd Real)
    (declare-const ?aepe Real)
    (declare-const ?aepf Real)
    (assert
      (or (or (= ?aepd ?aepc)
          (= ?aepd ?aepb)
          )
        (= ?aepc ?aepb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aepg Real)
    (declare-const ?aeph Real)
    (declare-const ?aepi Real)
    (declare-const ?aepj Real)
    (declare-const ?aepk Real)
    (declare-const ?aepl Real)
    (assert
      (and (or (or (= ?aepi ?aeph)
            (= ?aepi ?aepg)
            )
          (= ?aeph ?aepg)
          )
        (and (and (not (= ?aepl ?aepk))
            (not (= ?aepl ?aepj))
            )
          (not (= ?aepk ?aepj))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aepm Real)
    (declare-const ?aepn Real)
    (declare-const ?aepo Real)
    (assert
      (or (or (= ?aepo ?aepn)
          (= ?aepo ?aepm)
          )
        (= ?aepn ?aepm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aepp Real)
    (declare-const ?aepq Real)
    (declare-const ?aepr Real)
    (declare-const ?aeps Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aepq ?aepp))
                (not (= ?aepq ?asi))
                )
              (not (= ?aepp ?asi))
              )
            (or (or (= ?aeps ?aepr)
                (= ?aeps ?asi)
                )
              (= ?aepr ?asi)
              )
            )
          (and (or (or (= ?aepq ?aepp)
                (= ?aepq ?asi)
                )
              (= ?aepp ?asi)
              )
            (and (and (not (= ?aeps ?aepr))
                (not (= ?aeps ?asi))
                )
              (not (= ?aepr ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aept Real)
    (declare-const ?aepu Real)
    (declare-const ?aepv Real)
    (declare-const ?aepw Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aepu ?aept))
                (not (= ?aepu ?fkf))
                )
              (not (= ?aept ?fkf))
              )
            (or (or (= ?aepw ?aepv)
                (= ?aepw ?fkf)
                )
              (= ?aepv ?fkf)
              )
            )
          (and (or (or (= ?aepu ?aept)
                (= ?aepu ?fkf)
                )
              (= ?aept ?fkf)
              )
            (and (and (not (= ?aepw ?aepv))
                (not (= ?aepw ?fkf))
                )
              (not (= ?aepv ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aepx Real)
    (declare-const ?aepy Real)
    (declare-const ?aepz Real)
    (declare-const ?aeqa Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aepy ?aepx))
                (not (= ?aepy ?mzs))
                )
              (not (= ?aepx ?mzs))
              )
            (or (or (= ?aeqa ?aepz)
                (= ?aeqa ?mzs)
                )
              (= ?aepz ?mzs)
              )
            )
          (and (or (or (= ?aepy ?aepx)
                (= ?aepy ?mzs)
                )
              (= ?aepx ?mzs)
              )
            (and (and (not (= ?aeqa ?aepz))
                (not (= ?aeqa ?mzs))
                )
              (not (= ?aepz ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aeqb Real)
  (push 1)
    (declare-const ?aeqc Real)
    (declare-const ?aeqd Real)
    (declare-const ?aeqe Real)
    (assert
      (or (or (= ?aeqe ?aeqd)
          (= ?aeqe ?aeqc)
          )
        (= ?aeqd ?aeqc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeqf Real)
    (declare-const ?aeqg Real)
    (declare-const ?aeqh Real)
    (declare-const ?aeqi Real)
    (assert
      (or (or (= ?aeqi ?aeqh)
          (= ?aeqi ?aeqg)
          )
        (= ?aeqh ?aeqg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeqj Real)
    (declare-const ?aeqk Real)
    (declare-const ?aeql Real)
    (declare-const ?aeqm Real)
    (declare-const ?aeqn Real)
    (assert
      (or (or (= ?aeqn ?aeqm)
          (= ?aeqn ?aeql)
          )
        (= ?aeqm ?aeql)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeqo Real)
    (declare-const ?aeqp Real)
    (declare-const ?aeqq Real)
    (declare-const ?aeqr Real)
    (declare-const ?aeqs Real)
    (declare-const ?aeqt Real)
    (assert
      (and (and (and (not (= ?aeqq ?aeqp))
            (not (= ?aeqq ?aeqo))
            )
          (not (= ?aeqp ?aeqo))
          )
        (or (or (= ?aeqt ?aeqs)
            (= ?aeqt ?aeqr)
            )
          (= ?aeqs ?aeqr)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aequ Real)
    (declare-const ?aeqv Real)
    (declare-const ?aeqw Real)
    (assert
      (or (or (= ?aeqw ?aeqv)
          (= ?aeqw ?aequ)
          )
        (= ?aeqv ?aequ)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeqx Real)
    (declare-const ?aeqy Real)
    (declare-const ?aeqz Real)
    (assert
      (or (or (= ?aeqz ?aeqy)
          (= ?aeqz ?aeqx)
          )
        (= ?aeqy ?aeqx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aera Real)
    (declare-const ?aerb Real)
    (declare-const ?aerc Real)
    (declare-const ?aerd Real)
    (assert
      (or (or (= ?aerc ?aerb)
          (= ?aerc ?aera)
          )
        (= ?aerb ?aera)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aere Real)
    (declare-const ?aerf Real)
    (declare-const ?aerg Real)
    (declare-const ?aerh Real)
    (declare-const ?aeri Real)
    (assert
      (or (or (= ?aerg ?aerf)
          (= ?aerg ?aere)
          )
        (= ?aerf ?aere)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aerj Real)
    (declare-const ?aerk Real)
    (declare-const ?aerl Real)
    (declare-const ?aerm Real)
    (declare-const ?aern Real)
    (declare-const ?aero Real)
    (assert
      (and (or (or (= ?aerl ?aerk)
            (= ?aerl ?aerj)
            )
          (= ?aerk ?aerj)
          )
        (and (and (not (= ?aero ?aern))
            (not (= ?aero ?aerm))
            )
          (not (= ?aern ?aerm))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aerp Real)
    (declare-const ?aerq Real)
    (declare-const ?aerr Real)
    (assert
      (or (or (= ?aerr ?aerq)
          (= ?aerr ?aerp)
          )
        (= ?aerq ?aerp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aers Real)
    (declare-const ?aert Real)
    (declare-const ?aeru Real)
    (declare-const ?aerv Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aert ?aers))
                (not (= ?aert ?asi))
                )
              (not (= ?aers ?asi))
              )
            (or (or (= ?aerv ?aeru)
                (= ?aerv ?asi)
                )
              (= ?aeru ?asi)
              )
            )
          (and (or (or (= ?aert ?aers)
                (= ?aert ?asi)
                )
              (= ?aers ?asi)
              )
            (and (and (not (= ?aerv ?aeru))
                (not (= ?aerv ?asi))
                )
              (not (= ?aeru ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aerw Real)
    (declare-const ?aerx Real)
    (declare-const ?aery Real)
    (declare-const ?aerz Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aerx ?aerw))
                (not (= ?aerx ?fkf))
                )
              (not (= ?aerw ?fkf))
              )
            (or (or (= ?aerz ?aery)
                (= ?aerz ?fkf)
                )
              (= ?aery ?fkf)
              )
            )
          (and (or (or (= ?aerx ?aerw)
                (= ?aerx ?fkf)
                )
              (= ?aerw ?fkf)
              )
            (and (and (not (= ?aerz ?aery))
                (not (= ?aerz ?fkf))
                )
              (not (= ?aery ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aesa Real)
    (declare-const ?aesb Real)
    (declare-const ?aesc Real)
    (declare-const ?aesd Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aesb ?aesa))
                (not (= ?aesb ?mzs))
                )
              (not (= ?aesa ?mzs))
              )
            (or (or (= ?aesd ?aesc)
                (= ?aesd ?mzs)
                )
              (= ?aesc ?mzs)
              )
            )
          (and (or (or (= ?aesb ?aesa)
                (= ?aesb ?mzs)
                )
              (= ?aesa ?mzs)
              )
            (and (and (not (= ?aesd ?aesc))
                (not (= ?aesd ?mzs))
                )
              (not (= ?aesc ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aese Real)
  (declare-const ?aesf Real)
  (push 1)
    (declare-const ?aesg Real)
    (declare-const ?aesh Real)
    (declare-const ?aesi Real)
    (assert
      (or (or (= ?aesi ?aesh)
          (= ?aesi ?aesg)
          )
        (= ?aesh ?aesg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aesj Real)
    (declare-const ?aesk Real)
    (declare-const ?aesl Real)
    (declare-const ?aesm Real)
    (assert
      (or (or (= ?aesm ?aesl)
          (= ?aesm ?aesk)
          )
        (= ?aesl ?aesk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aesn Real)
    (declare-const ?aeso Real)
    (declare-const ?aesp Real)
    (declare-const ?aesq Real)
    (declare-const ?aesr Real)
    (assert
      (or (or (= ?aesr ?aesq)
          (= ?aesr ?aesp)
          )
        (= ?aesq ?aesp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aess Real)
    (declare-const ?aest Real)
    (declare-const ?aesu Real)
    (declare-const ?aesv Real)
    (declare-const ?aesw Real)
    (declare-const ?aesx Real)
    (assert
      (and (and (and (not (= ?aesu ?aest))
            (not (= ?aesu ?aess))
            )
          (not (= ?aest ?aess))
          )
        (or (or (= ?aesx ?aesw)
            (= ?aesx ?aesv)
            )
          (= ?aesw ?aesv)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aesy Real)
    (declare-const ?aesz Real)
    (declare-const ?aeta Real)
    (assert
      (or (or (= ?aeta ?aesz)
          (= ?aeta ?aesy)
          )
        (= ?aesz ?aesy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aetb Real)
    (declare-const ?aetc Real)
    (declare-const ?aetd Real)
    (assert
      (or (or (= ?aetd ?aetc)
          (= ?aetd ?aetb)
          )
        (= ?aetc ?aetb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aete Real)
    (declare-const ?aetf Real)
    (declare-const ?aetg Real)
    (declare-const ?aeth Real)
    (assert
      (or (or (= ?aetg ?aetf)
          (= ?aetg ?aete)
          )
        (= ?aetf ?aete)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeti Real)
    (declare-const ?aetj Real)
    (declare-const ?aetk Real)
    (declare-const ?aetl Real)
    (declare-const ?aetm Real)
    (assert
      (or (or (= ?aetk ?aetj)
          (= ?aetk ?aeti)
          )
        (= ?aetj ?aeti)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aetn Real)
    (declare-const ?aeto Real)
    (declare-const ?aetp Real)
    (declare-const ?aetq Real)
    (declare-const ?aetr Real)
    (declare-const ?aets Real)
    (assert
      (and (or (or (= ?aetp ?aeto)
            (= ?aetp ?aetn)
            )
          (= ?aeto ?aetn)
          )
        (and (and (not (= ?aets ?aetr))
            (not (= ?aets ?aetq))
            )
          (not (= ?aetr ?aetq))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aett Real)
    (declare-const ?aetu Real)
    (declare-const ?aetv Real)
    (assert
      (or (or (= ?aetv ?aetu)
          (= ?aetv ?aett)
          )
        (= ?aetu ?aett)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aetw Real)
    (declare-const ?aetx Real)
    (declare-const ?aety Real)
    (declare-const ?aetz Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aetx ?aetw))
                (not (= ?aetx ?asi))
                )
              (not (= ?aetw ?asi))
              )
            (or (or (= ?aetz ?aety)
                (= ?aetz ?asi)
                )
              (= ?aety ?asi)
              )
            )
          (and (or (or (= ?aetx ?aetw)
                (= ?aetx ?asi)
                )
              (= ?aetw ?asi)
              )
            (and (and (not (= ?aetz ?aety))
                (not (= ?aetz ?asi))
                )
              (not (= ?aety ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeua Real)
    (declare-const ?aeub Real)
    (declare-const ?aeuc Real)
    (declare-const ?aeud Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aeub ?aeua))
                (not (= ?aeub ?fkf))
                )
              (not (= ?aeua ?fkf))
              )
            (or (or (= ?aeud ?aeuc)
                (= ?aeud ?fkf)
                )
              (= ?aeuc ?fkf)
              )
            )
          (and (or (or (= ?aeub ?aeua)
                (= ?aeub ?fkf)
                )
              (= ?aeua ?fkf)
              )
            (and (and (not (= ?aeud ?aeuc))
                (not (= ?aeud ?fkf))
                )
              (not (= ?aeuc ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeue Real)
    (declare-const ?aeuf Real)
    (declare-const ?aeug Real)
    (declare-const ?aeuh Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aeuf ?aeue))
                (not (= ?aeuf ?mzs))
                )
              (not (= ?aeue ?mzs))
              )
            (or (or (= ?aeuh ?aeug)
                (= ?aeuh ?mzs)
                )
              (= ?aeug ?mzs)
              )
            )
          (and (or (or (= ?aeuf ?aeue)
                (= ?aeuf ?mzs)
                )
              (= ?aeue ?mzs)
              )
            (and (and (not (= ?aeuh ?aeug))
                (not (= ?aeuh ?mzs))
                )
              (not (= ?aeug ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aeui Real)
  (declare-const ?aeuj Real)
  (declare-const ?aeuk Real)
  (push 1)
    (declare-const ?aeul Real)
    (declare-const ?aeum Real)
    (declare-const ?aeun Real)
    (assert
      (or (or (= ?aeun ?aeum)
          (= ?aeun ?aeul)
          )
        (= ?aeum ?aeul)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeuo Real)
    (declare-const ?aeup Real)
    (declare-const ?aeuq Real)
    (declare-const ?aeur Real)
    (assert
      (or (or (= ?aeur ?aeuq)
          (= ?aeur ?aeup)
          )
        (= ?aeuq ?aeup)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeus Real)
    (declare-const ?aeut Real)
    (declare-const ?aeuu Real)
    (declare-const ?aeuv Real)
    (declare-const ?aeuw Real)
    (assert
      (or (or (= ?aeuw ?aeuv)
          (= ?aeuw ?aeuu)
          )
        (= ?aeuv ?aeuu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeux Real)
    (declare-const ?aeuy Real)
    (declare-const ?aeuz Real)
    (declare-const ?aeva Real)
    (declare-const ?aevb Real)
    (declare-const ?aevc Real)
    (assert
      (and (and (and (not (= ?aeuz ?aeuy))
            (not (= ?aeuz ?aeux))
            )
          (not (= ?aeuy ?aeux))
          )
        (or (or (= ?aevc ?aevb)
            (= ?aevc ?aeva)
            )
          (= ?aevb ?aeva)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aevd Real)
    (declare-const ?aeve Real)
    (declare-const ?aevf Real)
    (assert
      (or (or (= ?aevf ?aeve)
          (= ?aevf ?aevd)
          )
        (= ?aeve ?aevd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aevg Real)
    (declare-const ?aevh Real)
    (declare-const ?aevi Real)
    (assert
      (or (or (= ?aevi ?aevh)
          (= ?aevi ?aevg)
          )
        (= ?aevh ?aevg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aevj Real)
    (declare-const ?aevk Real)
    (declare-const ?aevl Real)
    (declare-const ?aevm Real)
    (assert
      (or (or (= ?aevl ?aevk)
          (= ?aevl ?aevj)
          )
        (= ?aevk ?aevj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aevn Real)
    (declare-const ?aevo Real)
    (declare-const ?aevp Real)
    (declare-const ?aevq Real)
    (declare-const ?aevr Real)
    (assert
      (or (or (= ?aevp ?aevo)
          (= ?aevp ?aevn)
          )
        (= ?aevo ?aevn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aevs Real)
    (declare-const ?aevt Real)
    (declare-const ?aevu Real)
    (declare-const ?aevv Real)
    (declare-const ?aevw Real)
    (declare-const ?aevx Real)
    (assert
      (and (or (or (= ?aevu ?aevt)
            (= ?aevu ?aevs)
            )
          (= ?aevt ?aevs)
          )
        (and (and (not (= ?aevx ?aevw))
            (not (= ?aevx ?aevv))
            )
          (not (= ?aevw ?aevv))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aevy Real)
    (declare-const ?aevz Real)
    (declare-const ?aewa Real)
    (assert
      (or (or (= ?aewa ?aevz)
          (= ?aewa ?aevy)
          )
        (= ?aevz ?aevy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aewb Real)
    (declare-const ?aewc Real)
    (declare-const ?aewd Real)
    (declare-const ?aewe Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aewc ?aewb))
                (not (= ?aewc ?asi))
                )
              (not (= ?aewb ?asi))
              )
            (or (or (= ?aewe ?aewd)
                (= ?aewe ?asi)
                )
              (= ?aewd ?asi)
              )
            )
          (and (or (or (= ?aewc ?aewb)
                (= ?aewc ?asi)
                )
              (= ?aewb ?asi)
              )
            (and (and (not (= ?aewe ?aewd))
                (not (= ?aewe ?asi))
                )
              (not (= ?aewd ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aewf Real)
    (declare-const ?aewg Real)
    (declare-const ?aewh Real)
    (declare-const ?aewi Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aewg ?aewf))
                (not (= ?aewg ?fkf))
                )
              (not (= ?aewf ?fkf))
              )
            (or (or (= ?aewi ?aewh)
                (= ?aewi ?fkf)
                )
              (= ?aewh ?fkf)
              )
            )
          (and (or (or (= ?aewg ?aewf)
                (= ?aewg ?fkf)
                )
              (= ?aewf ?fkf)
              )
            (and (and (not (= ?aewi ?aewh))
                (not (= ?aewi ?fkf))
                )
              (not (= ?aewh ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aewj Real)
    (declare-const ?aewk Real)
    (declare-const ?aewl Real)
    (declare-const ?aewm Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aewk ?aewj))
                (not (= ?aewk ?mzs))
                )
              (not (= ?aewj ?mzs))
              )
            (or (or (= ?aewm ?aewl)
                (= ?aewm ?mzs)
                )
              (= ?aewl ?mzs)
              )
            )
          (and (or (or (= ?aewk ?aewj)
                (= ?aewk ?mzs)
                )
              (= ?aewj ?mzs)
              )
            (and (and (not (= ?aewm ?aewl))
                (not (= ?aewm ?mzs))
                )
              (not (= ?aewl ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aewn Real)
  (declare-const ?aewo Real)
  (declare-const ?aewp Real)
  (declare-const ?aewq Real)
  (assert
    (exists ((?fkf Real) )(or (and (and (and (not (= ?aewo ?aewn))
              (not (= ?aewo ?fkf))
              )
            (not (= ?aewn ?fkf))
            )
          (or (or (= ?aewq ?aewp)
              (= ?aewq ?fkf)
              )
            (= ?aewp ?fkf)
            )
          )
        (and (or (or (= ?aewo ?aewn)
              (= ?aewo ?fkf)
              )
            (= ?aewn ?fkf)
            )
          (and (and (not (= ?aewq ?aewp))
              (not (= ?aewq ?fkf))
              )
            (not (= ?aewp ?fkf))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?aewr Real)
    (declare-const ?aews Real)
    (declare-const ?aewt Real)
    (assert
      (or (or (= ?aewt ?aews)
          (= ?aewt ?aewr)
          )
        (= ?aews ?aewr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aewu Real)
    (declare-const ?aewv Real)
    (declare-const ?aeww Real)
    (declare-const ?aewx Real)
    (assert
      (or (or (= ?aewx ?aeww)
          (= ?aewx ?aewv)
          )
        (= ?aeww ?aewv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aewy Real)
    (declare-const ?aewz Real)
    (declare-const ?aexa Real)
    (declare-const ?aexb Real)
    (declare-const ?aexc Real)
    (assert
      (or (or (= ?aexc ?aexb)
          (= ?aexc ?aexa)
          )
        (= ?aexb ?aexa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aexd Real)
    (declare-const ?aexe Real)
    (declare-const ?aexf Real)
    (declare-const ?aexg Real)
    (declare-const ?aexh Real)
    (declare-const ?aexi Real)
    (assert
      (and (and (and (not (= ?aexf ?aexe))
            (not (= ?aexf ?aexd))
            )
          (not (= ?aexe ?aexd))
          )
        (or (or (= ?aexi ?aexh)
            (= ?aexi ?aexg)
            )
          (= ?aexh ?aexg)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aexj Real)
    (declare-const ?aexk Real)
    (declare-const ?aexl Real)
    (assert
      (or (or (= ?aexl ?aexk)
          (= ?aexl ?aexj)
          )
        (= ?aexk ?aexj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aexm Real)
    (declare-const ?aexn Real)
    (declare-const ?aexo Real)
    (assert
      (or (or (= ?aexo ?aexn)
          (= ?aexo ?aexm)
          )
        (= ?aexn ?aexm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aexp Real)
    (declare-const ?aexq Real)
    (declare-const ?aexr Real)
    (declare-const ?aexs Real)
    (assert
      (or (or (= ?aexr ?aexq)
          (= ?aexr ?aexp)
          )
        (= ?aexq ?aexp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aext Real)
    (declare-const ?aexu Real)
    (declare-const ?aexv Real)
    (declare-const ?aexw Real)
    (declare-const ?aexx Real)
    (assert
      (or (or (= ?aexv ?aexu)
          (= ?aexv ?aext)
          )
        (= ?aexu ?aext)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aexy Real)
    (declare-const ?aexz Real)
    (declare-const ?aeya Real)
    (declare-const ?aeyb Real)
    (declare-const ?aeyc Real)
    (declare-const ?aeyd Real)
    (assert
      (and (or (or (= ?aeya ?aexz)
            (= ?aeya ?aexy)
            )
          (= ?aexz ?aexy)
          )
        (and (and (not (= ?aeyd ?aeyc))
            (not (= ?aeyd ?aeyb))
            )
          (not (= ?aeyc ?aeyb))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeye Real)
    (declare-const ?aeyf Real)
    (declare-const ?aeyg Real)
    (assert
      (or (or (= ?aeyg ?aeyf)
          (= ?aeyg ?aeye)
          )
        (= ?aeyf ?aeye)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeyh Real)
    (declare-const ?aeyi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeyj Real)
    (declare-const ?aeyk Real)
    (declare-const ?aeyl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeym Real)
    (declare-const ?aeyn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeyo Real)
    (declare-const ?aeyp Real)
    (declare-const ?aeyq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeyr Real)
    (declare-const ?aeys Real)
    (declare-const ?aeyt Real)
    (declare-const ?aeyu Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aeys ?aeyr))
                (not (= ?aeys ?asi))
                )
              (not (= ?aeyr ?asi))
              )
            (or (or (= ?aeyu ?aeyt)
                (= ?aeyu ?asi)
                )
              (= ?aeyt ?asi)
              )
            )
          (and (or (or (= ?aeys ?aeyr)
                (= ?aeys ?asi)
                )
              (= ?aeyr ?asi)
              )
            (and (and (not (= ?aeyu ?aeyt))
                (not (= ?aeyu ?asi))
                )
              (not (= ?aeyt ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeyv Real)
    (declare-const ?aeyw Real)
    (declare-const ?aeyx Real)
    (declare-const ?aeyy Real)
    (declare-const ?aeyz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aeza Real)
    (declare-const ?aezb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aezc Real)
    (declare-const ?aezd Real)
    (declare-const ?aeze Real)
    (declare-const ?aezf Real)
    (declare-const ?aezg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aezh Real)
    (declare-const ?aezi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aezj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aezk Real)
    (declare-const ?aezl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aezm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aezn Real)
    (declare-const ?aezo Real)
    (assert
      (not (= ?aezn ?aezo))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aezp Real)
    (declare-const ?aezq Real)
    (declare-const ?aezr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aezs Real)
    (declare-const ?aezt Real)
    (declare-const ?aezu Real)
    (declare-const ?aezv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aezw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aezx Real)
    (declare-const ?aezy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aezz Real)
    (declare-const ?afaa Real)
    (declare-const ?afab Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afac Real)
    (declare-const ?afad Real)
    (declare-const ?afae Real)
    (declare-const ?afaf Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?afad ?afac))
                (not (= ?afad ?fkf))
                )
              (not (= ?afac ?fkf))
              )
            (or (or (= ?afaf ?afae)
                (= ?afaf ?fkf)
                )
              (= ?afae ?fkf)
              )
            )
          (and (or (or (= ?afad ?afac)
                (= ?afad ?fkf)
                )
              (= ?afac ?fkf)
              )
            (and (and (not (= ?afaf ?afae))
                (not (= ?afaf ?fkf))
                )
              (not (= ?afae ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afag Real)
    (declare-const ?afah Real)
    (declare-const ?afai Real)
    (declare-const ?afaj Real)
    (declare-const ?afak Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afal Real)
    (declare-const ?afam Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afan Real)
    (declare-const ?afao Real)
    (declare-const ?afap Real)
    (declare-const ?afaq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afar Real)
    (declare-const ?afas Real)
    (declare-const ?afat Real)
    (declare-const ?afau Real)
    (declare-const ?afav Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afaw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afax Real)
    (declare-const ?afay Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afaz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afba Real)
    (declare-const ?afbb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afbc Real)
    (declare-const ?afbd Real)
    (declare-const ?afbe Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afbf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afbg Real)
    (declare-const ?afbh Real)
    (assert
      (not (= ?afbg ?afbh))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afbi Real)
    (declare-const ?afbj Real)
    (declare-const ?afbk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afbl Real)
    (declare-const ?afbm Real)
    (declare-const ?afbn Real)
    (declare-const ?afbo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afbp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afbq Real)
    (declare-const ?afbr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afbs Real)
    (declare-const ?afbt Real)
    (declare-const ?afbu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afbv Real)
    (declare-const ?afbw Real)
    (declare-const ?afbx Real)
    (declare-const ?afby Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?afbw ?afbv))
                (not (= ?afbw ?mzs))
                )
              (not (= ?afbv ?mzs))
              )
            (or (or (= ?afby ?afbx)
                (= ?afby ?mzs)
                )
              (= ?afbx ?mzs)
              )
            )
          (and (or (or (= ?afbw ?afbv)
                (= ?afbw ?mzs)
                )
              (= ?afbv ?mzs)
              )
            (and (and (not (= ?afby ?afbx))
                (not (= ?afby ?mzs))
                )
              (not (= ?afbx ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afbz Real)
    (declare-const ?afca Real)
    (declare-const ?afcb Real)
    (declare-const ?afcc Real)
    (declare-const ?afcd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afce Real)
    (declare-const ?afcf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afcg Real)
    (declare-const ?afch Real)
    (declare-const ?afci Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afcj Real)
    (declare-const ?afck Real)
    (declare-const ?afcl Real)
    (declare-const ?afcm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afcn Real)
    (declare-const ?afco Real)
    (declare-const ?afcp Real)
    (declare-const ?afcq Real)
    (declare-const ?afcr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afcs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afct Real)
    (declare-const ?afcu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?afcv Real)
  (declare-const ?afcw Real)
  (declare-const ?afcx Real)
  (declare-const ?afcy Real)
  (declare-const ?afcz Real)
  (push 1)
    (declare-const ?afda Real)
    (declare-const ?afdb Real)
    (declare-const ?afdc Real)
    (assert
      (or (or (= ?afdc ?afdb)
          (= ?afdc ?afda)
          )
        (= ?afdb ?afda)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afdd Real)
    (declare-const ?afde Real)
    (declare-const ?afdf Real)
    (declare-const ?afdg Real)
    (assert
      (or (or (= ?afdg ?afdf)
          (= ?afdg ?afde)
          )
        (= ?afdf ?afde)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afdh Real)
    (declare-const ?afdi Real)
    (declare-const ?afdj Real)
    (declare-const ?afdk Real)
    (declare-const ?afdl Real)
    (assert
      (or (or (= ?afdl ?afdk)
          (= ?afdl ?afdj)
          )
        (= ?afdk ?afdj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afdm Real)
    (declare-const ?afdn Real)
    (declare-const ?afdo Real)
    (declare-const ?afdp Real)
    (declare-const ?afdq Real)
    (declare-const ?afdr Real)
    (assert
      (and (and (and (not (= ?afdo ?afdn))
            (not (= ?afdo ?afdm))
            )
          (not (= ?afdn ?afdm))
          )
        (or (or (= ?afdr ?afdq)
            (= ?afdr ?afdp)
            )
          (= ?afdq ?afdp)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afds Real)
    (declare-const ?afdt Real)
    (declare-const ?afdu Real)
    (assert
      (or (or (= ?afdu ?afdt)
          (= ?afdu ?afds)
          )
        (= ?afdt ?afds)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afdv Real)
    (declare-const ?afdw Real)
    (declare-const ?afdx Real)
    (assert
      (or (or (= ?afdx ?afdw)
          (= ?afdx ?afdv)
          )
        (= ?afdw ?afdv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afdy Real)
    (declare-const ?afdz Real)
    (declare-const ?afea Real)
    (declare-const ?afeb Real)
    (assert
      (or (or (= ?afea ?afdz)
          (= ?afea ?afdy)
          )
        (= ?afdz ?afdy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afec Real)
    (declare-const ?afed Real)
    (declare-const ?afee Real)
    (declare-const ?afef Real)
    (declare-const ?afeg Real)
    (assert
      (or (or (= ?afee ?afed)
          (= ?afee ?afec)
          )
        (= ?afed ?afec)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afeh Real)
    (declare-const ?afei Real)
    (declare-const ?afej Real)
    (declare-const ?afek Real)
    (declare-const ?afel Real)
    (declare-const ?afem Real)
    (assert
      (and (or (or (= ?afej ?afei)
            (= ?afej ?afeh)
            )
          (= ?afei ?afeh)
          )
        (and (and (not (= ?afem ?afel))
            (not (= ?afem ?afek))
            )
          (not (= ?afel ?afek))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afen Real)
    (declare-const ?afeo Real)
    (declare-const ?afep Real)
    (assert
      (or (or (= ?afep ?afeo)
          (= ?afep ?afen)
          )
        (= ?afeo ?afen)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afeq Real)
    (declare-const ?afer Real)
    (declare-const ?afes Real)
    (declare-const ?afet Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?afer ?afeq))
                (not (= ?afer ?asi))
                )
              (not (= ?afeq ?asi))
              )
            (or (or (= ?afet ?afes)
                (= ?afet ?asi)
                )
              (= ?afes ?asi)
              )
            )
          (and (or (or (= ?afer ?afeq)
                (= ?afer ?asi)
                )
              (= ?afeq ?asi)
              )
            (and (and (not (= ?afet ?afes))
                (not (= ?afet ?asi))
                )
              (not (= ?afes ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afeu Real)
    (declare-const ?afev Real)
    (declare-const ?afew Real)
    (declare-const ?afex Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?afev ?afeu))
                (not (= ?afev ?fkf))
                )
              (not (= ?afeu ?fkf))
              )
            (or (or (= ?afex ?afew)
                (= ?afex ?fkf)
                )
              (= ?afew ?fkf)
              )
            )
          (and (or (or (= ?afev ?afeu)
                (= ?afev ?fkf)
                )
              (= ?afeu ?fkf)
              )
            (and (and (not (= ?afex ?afew))
                (not (= ?afex ?fkf))
                )
              (not (= ?afew ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afey Real)
    (declare-const ?afez Real)
    (declare-const ?affa Real)
    (declare-const ?affb Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?afez ?afey))
                (not (= ?afez ?mzs))
                )
              (not (= ?afey ?mzs))
              )
            (or (or (= ?affb ?affa)
                (= ?affb ?mzs)
                )
              (= ?affa ?mzs)
              )
            )
          (and (or (or (= ?afez ?afey)
                (= ?afez ?mzs)
                )
              (= ?afey ?mzs)
              )
            (and (and (not (= ?affb ?affa))
                (not (= ?affb ?mzs))
                )
              (not (= ?affa ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?affc Real)
  (declare-const ?affd Real)
  (push 1)
    (declare-const ?affe Real)
    (declare-const ?afff Real)
    (declare-const ?affg Real)
    (assert
      (or (or (= ?affg ?afff)
          (= ?affg ?affe)
          )
        (= ?afff ?affe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?affh Real)
    (declare-const ?affi Real)
    (declare-const ?affj Real)
    (declare-const ?affk Real)
    (assert
      (or (or (= ?affk ?affj)
          (= ?affk ?affi)
          )
        (= ?affj ?affi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?affl Real)
    (declare-const ?affm Real)
    (declare-const ?affn Real)
    (declare-const ?affo Real)
    (declare-const ?affp Real)
    (assert
      (or (or (= ?affp ?affo)
          (= ?affp ?affn)
          )
        (= ?affo ?affn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?affq Real)
    (declare-const ?affr Real)
    (declare-const ?affs Real)
    (declare-const ?afft Real)
    (declare-const ?affu Real)
    (declare-const ?affv Real)
    (assert
      (and (and (and (not (= ?affs ?affr))
            (not (= ?affs ?affq))
            )
          (not (= ?affr ?affq))
          )
        (or (or (= ?affv ?affu)
            (= ?affv ?afft)
            )
          (= ?affu ?afft)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?affw Real)
    (declare-const ?affx Real)
    (declare-const ?affy Real)
    (assert
      (or (or (= ?affy ?affx)
          (= ?affy ?affw)
          )
        (= ?affx ?affw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?affz Real)
    (declare-const ?afga Real)
    (declare-const ?afgb Real)
    (assert
      (or (or (= ?afgb ?afga)
          (= ?afgb ?affz)
          )
        (= ?afga ?affz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afgc Real)
    (declare-const ?afgd Real)
    (declare-const ?afge Real)
    (declare-const ?afgf Real)
    (assert
      (or (or (= ?afge ?afgd)
          (= ?afge ?afgc)
          )
        (= ?afgd ?afgc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afgg Real)
    (declare-const ?afgh Real)
    (declare-const ?afgi Real)
    (declare-const ?afgj Real)
    (declare-const ?afgk Real)
    (assert
      (or (or (= ?afgi ?afgh)
          (= ?afgi ?afgg)
          )
        (= ?afgh ?afgg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afgl Real)
    (declare-const ?afgm Real)
    (declare-const ?afgn Real)
    (declare-const ?afgo Real)
    (declare-const ?afgp Real)
    (declare-const ?afgq Real)
    (assert
      (and (or (or (= ?afgn ?afgm)
            (= ?afgn ?afgl)
            )
          (= ?afgm ?afgl)
          )
        (and (and (not (= ?afgq ?afgp))
            (not (= ?afgq ?afgo))
            )
          (not (= ?afgp ?afgo))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afgr Real)
    (declare-const ?afgs Real)
    (declare-const ?afgt Real)
    (assert
      (or (or (= ?afgt ?afgs)
          (= ?afgt ?afgr)
          )
        (= ?afgs ?afgr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afgu Real)
    (declare-const ?afgv Real)
    (declare-const ?afgw Real)
    (declare-const ?afgx Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?afgv ?afgu))
                (not (= ?afgv ?asi))
                )
              (not (= ?afgu ?asi))
              )
            (or (or (= ?afgx ?afgw)
                (= ?afgx ?asi)
                )
              (= ?afgw ?asi)
              )
            )
          (and (or (or (= ?afgv ?afgu)
                (= ?afgv ?asi)
                )
              (= ?afgu ?asi)
              )
            (and (and (not (= ?afgx ?afgw))
                (not (= ?afgx ?asi))
                )
              (not (= ?afgw ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afgy Real)
    (declare-const ?afgz Real)
    (declare-const ?afha Real)
    (declare-const ?afhb Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?afgz ?afgy))
                (not (= ?afgz ?fkf))
                )
              (not (= ?afgy ?fkf))
              )
            (or (or (= ?afhb ?afha)
                (= ?afhb ?fkf)
                )
              (= ?afha ?fkf)
              )
            )
          (and (or (or (= ?afgz ?afgy)
                (= ?afgz ?fkf)
                )
              (= ?afgy ?fkf)
              )
            (and (and (not (= ?afhb ?afha))
                (not (= ?afhb ?fkf))
                )
              (not (= ?afha ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afhc Real)
    (declare-const ?afhd Real)
    (declare-const ?afhe Real)
    (declare-const ?afhf Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?afhd ?afhc))
                (not (= ?afhd ?mzs))
                )
              (not (= ?afhc ?mzs))
              )
            (or (or (= ?afhf ?afhe)
                (= ?afhf ?mzs)
                )
              (= ?afhe ?mzs)
              )
            )
          (and (or (or (= ?afhd ?afhc)
                (= ?afhd ?mzs)
                )
              (= ?afhc ?mzs)
              )
            (and (and (not (= ?afhf ?afhe))
                (not (= ?afhf ?mzs))
                )
              (not (= ?afhe ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?afhg Real)
  (declare-const ?afhh Real)
  (declare-const ?afhi Real)
  (declare-const ?afhj Real)
  (push 1)
    (declare-const ?afhk Real)
    (declare-const ?afhl Real)
    (declare-const ?afhm Real)
    (assert
      (or (or (= ?afhm ?afhl)
          (= ?afhm ?afhk)
          )
        (= ?afhl ?afhk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afhn Real)
    (declare-const ?afho Real)
    (declare-const ?afhp Real)
    (declare-const ?afhq Real)
    (assert
      (or (or (= ?afhq ?afhp)
          (= ?afhq ?afho)
          )
        (= ?afhp ?afho)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afhr Real)
    (declare-const ?afhs Real)
    (declare-const ?afht Real)
    (declare-const ?afhu Real)
    (declare-const ?afhv Real)
    (assert
      (or (or (= ?afhv ?afhu)
          (= ?afhv ?afht)
          )
        (= ?afhu ?afht)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afhw Real)
    (declare-const ?afhx Real)
    (declare-const ?afhy Real)
    (declare-const ?afhz Real)
    (declare-const ?afia Real)
    (declare-const ?afib Real)
    (assert
      (and (and (and (not (= ?afhy ?afhx))
            (not (= ?afhy ?afhw))
            )
          (not (= ?afhx ?afhw))
          )
        (or (or (= ?afib ?afia)
            (= ?afib ?afhz)
            )
          (= ?afia ?afhz)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afic Real)
    (declare-const ?afid Real)
    (declare-const ?afie Real)
    (assert
      (or (or (= ?afie ?afid)
          (= ?afie ?afic)
          )
        (= ?afid ?afic)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afif Real)
    (declare-const ?afig Real)
    (declare-const ?afih Real)
    (assert
      (or (or (= ?afih ?afig)
          (= ?afih ?afif)
          )
        (= ?afig ?afif)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afii Real)
    (declare-const ?afij Real)
    (declare-const ?afik Real)
    (declare-const ?afil Real)
    (assert
      (or (or (= ?afik ?afij)
          (= ?afik ?afii)
          )
        (= ?afij ?afii)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afim Real)
    (declare-const ?afin Real)
    (declare-const ?afio Real)
    (declare-const ?afip Real)
    (declare-const ?afiq Real)
    (assert
      (or (or (= ?afio ?afin)
          (= ?afio ?afim)
          )
        (= ?afin ?afim)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afir Real)
    (declare-const ?afis Real)
    (declare-const ?afit Real)
    (declare-const ?afiu Real)
    (declare-const ?afiv Real)
    (declare-const ?afiw Real)
    (assert
      (and (or (or (= ?afit ?afis)
            (= ?afit ?afir)
            )
          (= ?afis ?afir)
          )
        (and (and (not (= ?afiw ?afiv))
            (not (= ?afiw ?afiu))
            )
          (not (= ?afiv ?afiu))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afix Real)
    (declare-const ?afiy Real)
    (declare-const ?afiz Real)
    (assert
      (or (or (= ?afiz ?afiy)
          (= ?afiz ?afix)
          )
        (= ?afiy ?afix)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afja Real)
    (declare-const ?afjb Real)
    (declare-const ?afjc Real)
    (declare-const ?afjd Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?afjb ?afja))
                (not (= ?afjb ?asi))
                )
              (not (= ?afja ?asi))
              )
            (or (or (= ?afjd ?afjc)
                (= ?afjd ?asi)
                )
              (= ?afjc ?asi)
              )
            )
          (and (or (or (= ?afjb ?afja)
                (= ?afjb ?asi)
                )
              (= ?afja ?asi)
              )
            (and (and (not (= ?afjd ?afjc))
                (not (= ?afjd ?asi))
                )
              (not (= ?afjc ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afje Real)
    (declare-const ?afjf Real)
    (declare-const ?afjg Real)
    (declare-const ?afjh Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?afjf ?afje))
                (not (= ?afjf ?fkf))
                )
              (not (= ?afje ?fkf))
              )
            (or (or (= ?afjh ?afjg)
                (= ?afjh ?fkf)
                )
              (= ?afjg ?fkf)
              )
            )
          (and (or (or (= ?afjf ?afje)
                (= ?afjf ?fkf)
                )
              (= ?afje ?fkf)
              )
            (and (and (not (= ?afjh ?afjg))
                (not (= ?afjh ?fkf))
                )
              (not (= ?afjg ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afji Real)
    (declare-const ?afjj Real)
    (declare-const ?afjk Real)
    (declare-const ?afjl Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?afjj ?afji))
                (not (= ?afjj ?mzs))
                )
              (not (= ?afji ?mzs))
              )
            (or (or (= ?afjl ?afjk)
                (= ?afjl ?mzs)
                )
              (= ?afjk ?mzs)
              )
            )
          (and (or (or (= ?afjj ?afji)
                (= ?afjj ?mzs)
                )
              (= ?afji ?mzs)
              )
            (and (and (not (= ?afjl ?afjk))
                (not (= ?afjl ?mzs))
                )
              (not (= ?afjk ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?afjm Real)
  (declare-const ?afjn Real)
  (declare-const ?afjo Real)
  (declare-const ?afjp Real)
  (declare-const ?afjq Real)
  (push 1)
    (declare-const ?afjr Real)
    (declare-const ?afjs Real)
    (declare-const ?afjt Real)
    (assert
      (or (or (= ?afjt ?afjs)
          (= ?afjt ?afjr)
          )
        (= ?afjs ?afjr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afju Real)
    (declare-const ?afjv Real)
    (declare-const ?afjw Real)
    (declare-const ?afjx Real)
    (assert
      (or (or (= ?afjx ?afjw)
          (= ?afjx ?afjv)
          )
        (= ?afjw ?afjv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afjy Real)
    (declare-const ?afjz Real)
    (declare-const ?afka Real)
    (declare-const ?afkb Real)
    (declare-const ?afkc Real)
    (assert
      (or (or (= ?afkc ?afkb)
          (= ?afkc ?afka)
          )
        (= ?afkb ?afka)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afkd Real)
    (declare-const ?afke Real)
    (declare-const ?afkf Real)
    (declare-const ?afkg Real)
    (declare-const ?afkh Real)
    (declare-const ?afki Real)
    (assert
      (and (and (and (not (= ?afkf ?afke))
            (not (= ?afkf ?afkd))
            )
          (not (= ?afke ?afkd))
          )
        (or (or (= ?afki ?afkh)
            (= ?afki ?afkg)
            )
          (= ?afkh ?afkg)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afkj Real)
    (declare-const ?afkk Real)
    (declare-const ?afkl Real)
    (assert
      (or (or (= ?afkl ?afkk)
          (= ?afkl ?afkj)
          )
        (= ?afkk ?afkj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afkm Real)
    (declare-const ?afkn Real)
    (declare-const ?afko Real)
    (assert
      (or (or (= ?afko ?afkn)
          (= ?afko ?afkm)
          )
        (= ?afkn ?afkm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afkp Real)
    (declare-const ?afkq Real)
    (declare-const ?afkr Real)
    (declare-const ?afks Real)
    (assert
      (or (or (= ?afkr ?afkq)
          (= ?afkr ?afkp)
          )
        (= ?afkq ?afkp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afkt Real)
    (declare-const ?afku Real)
    (declare-const ?afkv Real)
    (declare-const ?afkw Real)
    (declare-const ?afkx Real)
    (assert
      (or (or (= ?afkv ?afku)
          (= ?afkv ?afkt)
          )
        (= ?afku ?afkt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afky Real)
    (declare-const ?afkz Real)
    (declare-const ?afla Real)
    (declare-const ?aflb Real)
    (declare-const ?aflc Real)
    (declare-const ?afld Real)
    (assert
      (and (or (or (= ?afla ?afkz)
            (= ?afla ?afky)
            )
          (= ?afkz ?afky)
          )
        (and (and (not (= ?afld ?aflc))
            (not (= ?afld ?aflb))
            )
          (not (= ?aflc ?aflb))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afle Real)
    (declare-const ?aflf Real)
    (declare-const ?aflg Real)
    (assert
      (or (or (= ?aflg ?aflf)
          (= ?aflg ?afle)
          )
        (= ?aflf ?afle)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aflh Real)
    (declare-const ?afli Real)
    (declare-const ?aflj Real)
    (declare-const ?aflk Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?afli ?aflh))
                (not (= ?afli ?asi))
                )
              (not (= ?aflh ?asi))
              )
            (or (or (= ?aflk ?aflj)
                (= ?aflk ?asi)
                )
              (= ?aflj ?asi)
              )
            )
          (and (or (or (= ?afli ?aflh)
                (= ?afli ?asi)
                )
              (= ?aflh ?asi)
              )
            (and (and (not (= ?aflk ?aflj))
                (not (= ?aflk ?asi))
                )
              (not (= ?aflj ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afll Real)
    (declare-const ?aflm Real)
    (declare-const ?afln Real)
    (declare-const ?aflo Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aflm ?afll))
                (not (= ?aflm ?fkf))
                )
              (not (= ?afll ?fkf))
              )
            (or (or (= ?aflo ?afln)
                (= ?aflo ?fkf)
                )
              (= ?afln ?fkf)
              )
            )
          (and (or (or (= ?aflm ?afll)
                (= ?aflm ?fkf)
                )
              (= ?afll ?fkf)
              )
            (and (and (not (= ?aflo ?afln))
                (not (= ?aflo ?fkf))
                )
              (not (= ?afln ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aflp Real)
    (declare-const ?aflq Real)
    (declare-const ?aflr Real)
    (declare-const ?afls Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aflq ?aflp))
                (not (= ?aflq ?mzs))
                )
              (not (= ?aflp ?mzs))
              )
            (or (or (= ?afls ?aflr)
                (= ?afls ?mzs)
                )
              (= ?aflr ?mzs)
              )
            )
          (and (or (or (= ?aflq ?aflp)
                (= ?aflq ?mzs)
                )
              (= ?aflp ?mzs)
              )
            (and (and (not (= ?afls ?aflr))
                (not (= ?afls ?mzs))
                )
              (not (= ?aflr ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aflt Real)
  (push 1)
    (declare-const ?aflu Real)
    (declare-const ?aflv Real)
    (declare-const ?aflw Real)
    (assert
      (or (or (= ?aflw ?aflv)
          (= ?aflw ?aflu)
          )
        (= ?aflv ?aflu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aflx Real)
    (declare-const ?afly Real)
    (declare-const ?aflz Real)
    (declare-const ?afma Real)
    (assert
      (or (or (= ?afma ?aflz)
          (= ?afma ?afly)
          )
        (= ?aflz ?afly)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afmb Real)
    (declare-const ?afmc Real)
    (declare-const ?afmd Real)
    (declare-const ?afme Real)
    (declare-const ?afmf Real)
    (assert
      (or (or (= ?afmf ?afme)
          (= ?afmf ?afmd)
          )
        (= ?afme ?afmd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afmg Real)
    (declare-const ?afmh Real)
    (declare-const ?afmi Real)
    (declare-const ?afmj Real)
    (declare-const ?afmk Real)
    (declare-const ?afml Real)
    (assert
      (and (and (and (not (= ?afmi ?afmh))
            (not (= ?afmi ?afmg))
            )
          (not (= ?afmh ?afmg))
          )
        (or (or (= ?afml ?afmk)
            (= ?afml ?afmj)
            )
          (= ?afmk ?afmj)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afmm Real)
    (declare-const ?afmn Real)
    (declare-const ?afmo Real)
    (assert
      (or (or (= ?afmo ?afmn)
          (= ?afmo ?afmm)
          )
        (= ?afmn ?afmm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afmp Real)
    (declare-const ?afmq Real)
    (declare-const ?afmr Real)
    (assert
      (or (or (= ?afmr ?afmq)
          (= ?afmr ?afmp)
          )
        (= ?afmq ?afmp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afms Real)
    (declare-const ?afmt Real)
    (declare-const ?afmu Real)
    (declare-const ?afmv Real)
    (assert
      (or (or (= ?afmu ?afmt)
          (= ?afmu ?afms)
          )
        (= ?afmt ?afms)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afmw Real)
    (declare-const ?afmx Real)
    (declare-const ?afmy Real)
    (declare-const ?afmz Real)
    (declare-const ?afna Real)
    (assert
      (or (or (= ?afmy ?afmx)
          (= ?afmy ?afmw)
          )
        (= ?afmx ?afmw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afnb Real)
    (declare-const ?afnc Real)
    (declare-const ?afnd Real)
    (declare-const ?afne Real)
    (declare-const ?afnf Real)
    (declare-const ?afng Real)
    (assert
      (and (or (or (= ?afnd ?afnc)
            (= ?afnd ?afnb)
            )
          (= ?afnc ?afnb)
          )
        (and (and (not (= ?afng ?afnf))
            (not (= ?afng ?afne))
            )
          (not (= ?afnf ?afne))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afnh Real)
    (declare-const ?afni Real)
    (declare-const ?afnj Real)
    (assert
      (or (or (= ?afnj ?afni)
          (= ?afnj ?afnh)
          )
        (= ?afni ?afnh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afnk Real)
    (declare-const ?afnl Real)
    (declare-const ?afnm Real)
    (declare-const ?afnn Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?afnl ?afnk))
                (not (= ?afnl ?asi))
                )
              (not (= ?afnk ?asi))
              )
            (or (or (= ?afnn ?afnm)
                (= ?afnn ?asi)
                )
              (= ?afnm ?asi)
              )
            )
          (and (or (or (= ?afnl ?afnk)
                (= ?afnl ?asi)
                )
              (= ?afnk ?asi)
              )
            (and (and (not (= ?afnn ?afnm))
                (not (= ?afnn ?asi))
                )
              (not (= ?afnm ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afno Real)
    (declare-const ?afnp Real)
    (declare-const ?afnq Real)
    (declare-const ?afnr Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?afnp ?afno))
                (not (= ?afnp ?fkf))
                )
              (not (= ?afno ?fkf))
              )
            (or (or (= ?afnr ?afnq)
                (= ?afnr ?fkf)
                )
              (= ?afnq ?fkf)
              )
            )
          (and (or (or (= ?afnp ?afno)
                (= ?afnp ?fkf)
                )
              (= ?afno ?fkf)
              )
            (and (and (not (= ?afnr ?afnq))
                (not (= ?afnr ?fkf))
                )
              (not (= ?afnq ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afns Real)
    (declare-const ?afnt Real)
    (declare-const ?afnu Real)
    (declare-const ?afnv Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?afnt ?afns))
                (not (= ?afnt ?mzs))
                )
              (not (= ?afns ?mzs))
              )
            (or (or (= ?afnv ?afnu)
                (= ?afnv ?mzs)
                )
              (= ?afnu ?mzs)
              )
            )
          (and (or (or (= ?afnt ?afns)
                (= ?afnt ?mzs)
                )
              (= ?afns ?mzs)
              )
            (and (and (not (= ?afnv ?afnu))
                (not (= ?afnv ?mzs))
                )
              (not (= ?afnu ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?afnw Real)
  (declare-const ?afnx Real)
  (push 1)
    (declare-const ?afny Real)
    (declare-const ?afnz Real)
    (declare-const ?afoa Real)
    (assert
      (or (or (= ?afoa ?afnz)
          (= ?afoa ?afny)
          )
        (= ?afnz ?afny)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afob Real)
    (declare-const ?afoc Real)
    (declare-const ?afod Real)
    (declare-const ?afoe Real)
    (assert
      (or (or (= ?afoe ?afod)
          (= ?afoe ?afoc)
          )
        (= ?afod ?afoc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afof Real)
    (declare-const ?afog Real)
    (declare-const ?afoh Real)
    (declare-const ?afoi Real)
    (declare-const ?afoj Real)
    (assert
      (or (or (= ?afoj ?afoi)
          (= ?afoj ?afoh)
          )
        (= ?afoi ?afoh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afok Real)
    (declare-const ?afol Real)
    (declare-const ?afom Real)
    (declare-const ?afon Real)
    (declare-const ?afoo Real)
    (declare-const ?afop Real)
    (assert
      (and (and (and (not (= ?afom ?afol))
            (not (= ?afom ?afok))
            )
          (not (= ?afol ?afok))
          )
        (or (or (= ?afop ?afoo)
            (= ?afop ?afon)
            )
          (= ?afoo ?afon)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afoq Real)
    (declare-const ?afor Real)
    (declare-const ?afos Real)
    (assert
      (or (or (= ?afos ?afor)
          (= ?afos ?afoq)
          )
        (= ?afor ?afoq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afot Real)
    (declare-const ?afou Real)
    (declare-const ?afov Real)
    (assert
      (or (or (= ?afov ?afou)
          (= ?afov ?afot)
          )
        (= ?afou ?afot)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afow Real)
    (declare-const ?afox Real)
    (declare-const ?afoy Real)
    (declare-const ?afoz Real)
    (assert
      (or (or (= ?afoy ?afox)
          (= ?afoy ?afow)
          )
        (= ?afox ?afow)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afpa Real)
    (declare-const ?afpb Real)
    (declare-const ?afpc Real)
    (declare-const ?afpd Real)
    (declare-const ?afpe Real)
    (assert
      (or (or (= ?afpc ?afpb)
          (= ?afpc ?afpa)
          )
        (= ?afpb ?afpa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afpf Real)
    (declare-const ?afpg Real)
    (declare-const ?afph Real)
    (declare-const ?afpi Real)
    (declare-const ?afpj Real)
    (declare-const ?afpk Real)
    (assert
      (and (or (or (= ?afph ?afpg)
            (= ?afph ?afpf)
            )
          (= ?afpg ?afpf)
          )
        (and (and (not (= ?afpk ?afpj))
            (not (= ?afpk ?afpi))
            )
          (not (= ?afpj ?afpi))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afpl Real)
    (declare-const ?afpm Real)
    (declare-const ?afpn Real)
    (assert
      (or (or (= ?afpn ?afpm)
          (= ?afpn ?afpl)
          )
        (= ?afpm ?afpl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afpo Real)
    (declare-const ?afpp Real)
    (declare-const ?afpq Real)
    (declare-const ?afpr Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?afpp ?afpo))
                (not (= ?afpp ?asi))
                )
              (not (= ?afpo ?asi))
              )
            (or (or (= ?afpr ?afpq)
                (= ?afpr ?asi)
                )
              (= ?afpq ?asi)
              )
            )
          (and (or (or (= ?afpp ?afpo)
                (= ?afpp ?asi)
                )
              (= ?afpo ?asi)
              )
            (and (and (not (= ?afpr ?afpq))
                (not (= ?afpr ?asi))
                )
              (not (= ?afpq ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afps Real)
    (declare-const ?afpt Real)
    (declare-const ?afpu Real)
    (declare-const ?afpv Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?afpt ?afps))
                (not (= ?afpt ?fkf))
                )
              (not (= ?afps ?fkf))
              )
            (or (or (= ?afpv ?afpu)
                (= ?afpv ?fkf)
                )
              (= ?afpu ?fkf)
              )
            )
          (and (or (or (= ?afpt ?afps)
                (= ?afpt ?fkf)
                )
              (= ?afps ?fkf)
              )
            (and (and (not (= ?afpv ?afpu))
                (not (= ?afpv ?fkf))
                )
              (not (= ?afpu ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afpw Real)
    (declare-const ?afpx Real)
    (declare-const ?afpy Real)
    (declare-const ?afpz Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?afpx ?afpw))
                (not (= ?afpx ?mzs))
                )
              (not (= ?afpw ?mzs))
              )
            (or (or (= ?afpz ?afpy)
                (= ?afpz ?mzs)
                )
              (= ?afpy ?mzs)
              )
            )
          (and (or (or (= ?afpx ?afpw)
                (= ?afpx ?mzs)
                )
              (= ?afpw ?mzs)
              )
            (and (and (not (= ?afpz ?afpy))
                (not (= ?afpz ?mzs))
                )
              (not (= ?afpy ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?afqa Real)
  (push 1)
    (declare-const ?afqb Real)
    (declare-const ?afqc Real)
    (declare-const ?afqd Real)
    (assert
      (or (or (= ?afqd ?afqc)
          (= ?afqd ?afqb)
          )
        (= ?afqc ?afqb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afqe Real)
    (declare-const ?afqf Real)
    (declare-const ?afqg Real)
    (declare-const ?afqh Real)
    (assert
      (or (or (= ?afqh ?afqg)
          (= ?afqh ?afqf)
          )
        (= ?afqg ?afqf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afqi Real)
    (declare-const ?afqj Real)
    (declare-const ?afqk Real)
    (declare-const ?afql Real)
    (declare-const ?afqm Real)
    (assert
      (or (or (= ?afqm ?afql)
          (= ?afqm ?afqk)
          )
        (= ?afql ?afqk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afqn Real)
    (declare-const ?afqo Real)
    (declare-const ?afqp Real)
    (declare-const ?afqq Real)
    (declare-const ?afqr Real)
    (declare-const ?afqs Real)
    (assert
      (and (and (and (not (= ?afqp ?afqo))
            (not (= ?afqp ?afqn))
            )
          (not (= ?afqo ?afqn))
          )
        (or (or (= ?afqs ?afqr)
            (= ?afqs ?afqq)
            )
          (= ?afqr ?afqq)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afqt Real)
    (declare-const ?afqu Real)
    (declare-const ?afqv Real)
    (assert
      (or (or (= ?afqv ?afqu)
          (= ?afqv ?afqt)
          )
        (= ?afqu ?afqt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afqw Real)
    (declare-const ?afqx Real)
    (declare-const ?afqy Real)
    (assert
      (or (or (= ?afqy ?afqx)
          (= ?afqy ?afqw)
          )
        (= ?afqx ?afqw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afqz Real)
    (declare-const ?afra Real)
    (declare-const ?afrb Real)
    (declare-const ?afrc Real)
    (assert
      (or (or (= ?afrb ?afra)
          (= ?afrb ?afqz)
          )
        (= ?afra ?afqz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afrd Real)
    (declare-const ?afre Real)
    (declare-const ?afrf Real)
    (declare-const ?afrg Real)
    (declare-const ?afrh Real)
    (assert
      (or (or (= ?afrf ?afre)
          (= ?afrf ?afrd)
          )
        (= ?afre ?afrd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afri Real)
    (declare-const ?afrj Real)
    (declare-const ?afrk Real)
    (declare-const ?afrl Real)
    (declare-const ?afrm Real)
    (declare-const ?afrn Real)
    (assert
      (and (or (or (= ?afrk ?afrj)
            (= ?afrk ?afri)
            )
          (= ?afrj ?afri)
          )
        (and (and (not (= ?afrn ?afrm))
            (not (= ?afrn ?afrl))
            )
          (not (= ?afrm ?afrl))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afro Real)
    (declare-const ?afrp Real)
    (declare-const ?afrq Real)
    (assert
      (or (or (= ?afrq ?afrp)
          (= ?afrq ?afro)
          )
        (= ?afrp ?afro)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afrr Real)
    (declare-const ?afrs Real)
    (declare-const ?afrt Real)
    (declare-const ?afru Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?afrs ?afrr))
                (not (= ?afrs ?asi))
                )
              (not (= ?afrr ?asi))
              )
            (or (or (= ?afru ?afrt)
                (= ?afru ?asi)
                )
              (= ?afrt ?asi)
              )
            )
          (and (or (or (= ?afrs ?afrr)
                (= ?afrs ?asi)
                )
              (= ?afrr ?asi)
              )
            (and (and (not (= ?afru ?afrt))
                (not (= ?afru ?asi))
                )
              (not (= ?afrt ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afrv Real)
    (declare-const ?afrw Real)
    (declare-const ?afrx Real)
    (declare-const ?afry Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?afrw ?afrv))
                (not (= ?afrw ?fkf))
                )
              (not (= ?afrv ?fkf))
              )
            (or (or (= ?afry ?afrx)
                (= ?afry ?fkf)
                )
              (= ?afrx ?fkf)
              )
            )
          (and (or (or (= ?afrw ?afrv)
                (= ?afrw ?fkf)
                )
              (= ?afrv ?fkf)
              )
            (and (and (not (= ?afry ?afrx))
                (not (= ?afry ?fkf))
                )
              (not (= ?afrx ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afrz Real)
    (declare-const ?afsa Real)
    (declare-const ?afsb Real)
    (declare-const ?afsc Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?afsa ?afrz))
                (not (= ?afsa ?mzs))
                )
              (not (= ?afrz ?mzs))
              )
            (or (or (= ?afsc ?afsb)
                (= ?afsc ?mzs)
                )
              (= ?afsb ?mzs)
              )
            )
          (and (or (or (= ?afsa ?afrz)
                (= ?afsa ?mzs)
                )
              (= ?afrz ?mzs)
              )
            (and (and (not (= ?afsc ?afsb))
                (not (= ?afsc ?mzs))
                )
              (not (= ?afsb ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?afsd Real)
  (declare-const ?afse Real)
  (push 1)
    (declare-const ?afsf Real)
    (declare-const ?afsg Real)
    (declare-const ?afsh Real)
    (assert
      (or (or (= ?afsh ?afsg)
          (= ?afsh ?afsf)
          )
        (= ?afsg ?afsf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afsi Real)
    (declare-const ?afsj Real)
    (declare-const ?afsk Real)
    (declare-const ?afsl Real)
    (assert
      (or (or (= ?afsl ?afsk)
          (= ?afsl ?afsj)
          )
        (= ?afsk ?afsj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afsm Real)
    (declare-const ?afsn Real)
    (declare-const ?afso Real)
    (declare-const ?afsp Real)
    (declare-const ?afsq Real)
    (assert
      (or (or (= ?afsq ?afsp)
          (= ?afsq ?afso)
          )
        (= ?afsp ?afso)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afsr Real)
    (declare-const ?afss Real)
    (declare-const ?afst Real)
    (declare-const ?afsu Real)
    (declare-const ?afsv Real)
    (declare-const ?afsw Real)
    (assert
      (and (and (and (not (= ?afst ?afss))
            (not (= ?afst ?afsr))
            )
          (not (= ?afss ?afsr))
          )
        (or (or (= ?afsw ?afsv)
            (= ?afsw ?afsu)
            )
          (= ?afsv ?afsu)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afsx Real)
    (declare-const ?afsy Real)
    (declare-const ?afsz Real)
    (assert
      (or (or (= ?afsz ?afsy)
          (= ?afsz ?afsx)
          )
        (= ?afsy ?afsx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afta Real)
    (declare-const ?aftb Real)
    (declare-const ?aftc Real)
    (assert
      (or (or (= ?aftc ?aftb)
          (= ?aftc ?afta)
          )
        (= ?aftb ?afta)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aftd Real)
    (declare-const ?afte Real)
    (declare-const ?aftf Real)
    (declare-const ?aftg Real)
    (assert
      (or (or (= ?aftf ?afte)
          (= ?aftf ?aftd)
          )
        (= ?afte ?aftd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afth Real)
    (declare-const ?afti Real)
    (declare-const ?aftj Real)
    (declare-const ?aftk Real)
    (declare-const ?aftl Real)
    (assert
      (or (or (= ?aftj ?afti)
          (= ?aftj ?afth)
          )
        (= ?afti ?afth)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aftm Real)
    (declare-const ?aftn Real)
    (declare-const ?afto Real)
    (declare-const ?aftp Real)
    (declare-const ?aftq Real)
    (declare-const ?aftr Real)
    (assert
      (and (or (or (= ?afto ?aftn)
            (= ?afto ?aftm)
            )
          (= ?aftn ?aftm)
          )
        (and (and (not (= ?aftr ?aftq))
            (not (= ?aftr ?aftp))
            )
          (not (= ?aftq ?aftp))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afts Real)
    (declare-const ?aftt Real)
    (declare-const ?aftu Real)
    (assert
      (or (or (= ?aftu ?aftt)
          (= ?aftu ?afts)
          )
        (= ?aftt ?afts)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aftv Real)
    (declare-const ?aftw Real)
    (declare-const ?aftx Real)
    (declare-const ?afty Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aftw ?aftv))
                (not (= ?aftw ?asi))
                )
              (not (= ?aftv ?asi))
              )
            (or (or (= ?afty ?aftx)
                (= ?afty ?asi)
                )
              (= ?aftx ?asi)
              )
            )
          (and (or (or (= ?aftw ?aftv)
                (= ?aftw ?asi)
                )
              (= ?aftv ?asi)
              )
            (and (and (not (= ?afty ?aftx))
                (not (= ?afty ?asi))
                )
              (not (= ?aftx ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aftz Real)
    (declare-const ?afua Real)
    (declare-const ?afub Real)
    (declare-const ?afuc Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?afua ?aftz))
                (not (= ?afua ?fkf))
                )
              (not (= ?aftz ?fkf))
              )
            (or (or (= ?afuc ?afub)
                (= ?afuc ?fkf)
                )
              (= ?afub ?fkf)
              )
            )
          (and (or (or (= ?afua ?aftz)
                (= ?afua ?fkf)
                )
              (= ?aftz ?fkf)
              )
            (and (and (not (= ?afuc ?afub))
                (not (= ?afuc ?fkf))
                )
              (not (= ?afub ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afud Real)
    (declare-const ?afue Real)
    (declare-const ?afuf Real)
    (declare-const ?afug Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?afue ?afud))
                (not (= ?afue ?mzs))
                )
              (not (= ?afud ?mzs))
              )
            (or (or (= ?afug ?afuf)
                (= ?afug ?mzs)
                )
              (= ?afuf ?mzs)
              )
            )
          (and (or (or (= ?afue ?afud)
                (= ?afue ?mzs)
                )
              (= ?afud ?mzs)
              )
            (and (and (not (= ?afug ?afuf))
                (not (= ?afug ?mzs))
                )
              (not (= ?afuf ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?afuh Real)
  (declare-const ?afui Real)
  (declare-const ?afuj Real)
  (push 1)
    (declare-const ?afuk Real)
    (declare-const ?aful Real)
    (declare-const ?afum Real)
    (assert
      (or (or (= ?afum ?aful)
          (= ?afum ?afuk)
          )
        (= ?aful ?afuk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afun Real)
    (declare-const ?afuo Real)
    (declare-const ?afup Real)
    (declare-const ?afuq Real)
    (assert
      (or (or (= ?afuq ?afup)
          (= ?afuq ?afuo)
          )
        (= ?afup ?afuo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afur Real)
    (declare-const ?afus Real)
    (declare-const ?afut Real)
    (declare-const ?afuu Real)
    (declare-const ?afuv Real)
    (assert
      (or (or (= ?afuv ?afuu)
          (= ?afuv ?afut)
          )
        (= ?afuu ?afut)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afuw Real)
    (declare-const ?afux Real)
    (declare-const ?afuy Real)
    (declare-const ?afuz Real)
    (declare-const ?afva Real)
    (declare-const ?afvb Real)
    (assert
      (and (and (and (not (= ?afuy ?afux))
            (not (= ?afuy ?afuw))
            )
          (not (= ?afux ?afuw))
          )
        (or (or (= ?afvb ?afva)
            (= ?afvb ?afuz)
            )
          (= ?afva ?afuz)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afvc Real)
    (declare-const ?afvd Real)
    (declare-const ?afve Real)
    (assert
      (or (or (= ?afve ?afvd)
          (= ?afve ?afvc)
          )
        (= ?afvd ?afvc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afvf Real)
    (declare-const ?afvg Real)
    (declare-const ?afvh Real)
    (assert
      (or (or (= ?afvh ?afvg)
          (= ?afvh ?afvf)
          )
        (= ?afvg ?afvf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afvi Real)
    (declare-const ?afvj Real)
    (declare-const ?afvk Real)
    (declare-const ?afvl Real)
    (assert
      (or (or (= ?afvk ?afvj)
          (= ?afvk ?afvi)
          )
        (= ?afvj ?afvi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afvm Real)
    (declare-const ?afvn Real)
    (declare-const ?afvo Real)
    (declare-const ?afvp Real)
    (declare-const ?afvq Real)
    (assert
      (or (or (= ?afvo ?afvn)
          (= ?afvo ?afvm)
          )
        (= ?afvn ?afvm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afvr Real)
    (declare-const ?afvs Real)
    (declare-const ?afvt Real)
    (declare-const ?afvu Real)
    (declare-const ?afvv Real)
    (declare-const ?afvw Real)
    (assert
      (and (or (or (= ?afvt ?afvs)
            (= ?afvt ?afvr)
            )
          (= ?afvs ?afvr)
          )
        (and (and (not (= ?afvw ?afvv))
            (not (= ?afvw ?afvu))
            )
          (not (= ?afvv ?afvu))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afvx Real)
    (declare-const ?afvy Real)
    (declare-const ?afvz Real)
    (assert
      (or (or (= ?afvz ?afvy)
          (= ?afvz ?afvx)
          )
        (= ?afvy ?afvx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afwa Real)
    (declare-const ?afwb Real)
    (declare-const ?afwc Real)
    (declare-const ?afwd Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?afwb ?afwa))
                (not (= ?afwb ?asi))
                )
              (not (= ?afwa ?asi))
              )
            (or (or (= ?afwd ?afwc)
                (= ?afwd ?asi)
                )
              (= ?afwc ?asi)
              )
            )
          (and (or (or (= ?afwb ?afwa)
                (= ?afwb ?asi)
                )
              (= ?afwa ?asi)
              )
            (and (and (not (= ?afwd ?afwc))
                (not (= ?afwd ?asi))
                )
              (not (= ?afwc ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afwe Real)
    (declare-const ?afwf Real)
    (declare-const ?afwg Real)
    (declare-const ?afwh Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?afwf ?afwe))
                (not (= ?afwf ?fkf))
                )
              (not (= ?afwe ?fkf))
              )
            (or (or (= ?afwh ?afwg)
                (= ?afwh ?fkf)
                )
              (= ?afwg ?fkf)
              )
            )
          (and (or (or (= ?afwf ?afwe)
                (= ?afwf ?fkf)
                )
              (= ?afwe ?fkf)
              )
            (and (and (not (= ?afwh ?afwg))
                (not (= ?afwh ?fkf))
                )
              (not (= ?afwg ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afwi Real)
    (declare-const ?afwj Real)
    (declare-const ?afwk Real)
    (declare-const ?afwl Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?afwj ?afwi))
                (not (= ?afwj ?mzs))
                )
              (not (= ?afwi ?mzs))
              )
            (or (or (= ?afwl ?afwk)
                (= ?afwl ?mzs)
                )
              (= ?afwk ?mzs)
              )
            )
          (and (or (or (= ?afwj ?afwi)
                (= ?afwj ?mzs)
                )
              (= ?afwi ?mzs)
              )
            (and (and (not (= ?afwl ?afwk))
                (not (= ?afwl ?mzs))
                )
              (not (= ?afwk ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?afwm Real)
    (declare-const ?afwn Real)
    (declare-const ?afwo Real)
    (assert
      (or (or (= ?afwo ?afwn)
          (= ?afwo ?afwm)
          )
        (= ?afwn ?afwm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afwp Real)
    (declare-const ?afwq Real)
    (declare-const ?afwr Real)
    (declare-const ?afws Real)
    (assert
      (or (or (= ?afws ?afwr)
          (= ?afws ?afwq)
          )
        (= ?afwr ?afwq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afwt Real)
    (declare-const ?afwu Real)
    (declare-const ?afwv Real)
    (declare-const ?afww Real)
    (declare-const ?afwx Real)
    (assert
      (or (or (= ?afwx ?afww)
          (= ?afwx ?afwv)
          )
        (= ?afww ?afwv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afwy Real)
    (declare-const ?afwz Real)
    (declare-const ?afxa Real)
    (declare-const ?afxb Real)
    (declare-const ?afxc Real)
    (declare-const ?afxd Real)
    (assert
      (and (and (and (not (= ?afxa ?afwz))
            (not (= ?afxa ?afwy))
            )
          (not (= ?afwz ?afwy))
          )
        (or (or (= ?afxd ?afxc)
            (= ?afxd ?afxb)
            )
          (= ?afxc ?afxb)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afxe Real)
    (declare-const ?afxf Real)
    (declare-const ?afxg Real)
    (assert
      (or (or (= ?afxg ?afxf)
          (= ?afxg ?afxe)
          )
        (= ?afxf ?afxe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afxh Real)
    (declare-const ?afxi Real)
    (declare-const ?afxj Real)
    (assert
      (or (or (= ?afxj ?afxi)
          (= ?afxj ?afxh)
          )
        (= ?afxi ?afxh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afxk Real)
    (declare-const ?afxl Real)
    (declare-const ?afxm Real)
    (declare-const ?afxn Real)
    (assert
      (or (or (= ?afxm ?afxl)
          (= ?afxm ?afxk)
          )
        (= ?afxl ?afxk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afxo Real)
    (declare-const ?afxp Real)
    (declare-const ?afxq Real)
    (declare-const ?afxr Real)
    (declare-const ?afxs Real)
    (assert
      (or (or (= ?afxq ?afxp)
          (= ?afxq ?afxo)
          )
        (= ?afxp ?afxo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afxt Real)
    (declare-const ?afxu Real)
    (declare-const ?afxv Real)
    (declare-const ?afxw Real)
    (declare-const ?afxx Real)
    (declare-const ?afxy Real)
    (assert
      (and (or (or (= ?afxv ?afxu)
            (= ?afxv ?afxt)
            )
          (= ?afxu ?afxt)
          )
        (and (and (not (= ?afxy ?afxx))
            (not (= ?afxy ?afxw))
            )
          (not (= ?afxx ?afxw))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afxz Real)
    (declare-const ?afya Real)
    (declare-const ?afyb Real)
    (assert
      (or (or (= ?afyb ?afya)
          (= ?afyb ?afxz)
          )
        (= ?afya ?afxz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afyc Real)
    (declare-const ?afyd Real)
    (declare-const ?afye Real)
    (declare-const ?afyf Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?afyd ?afyc))
                (not (= ?afyd ?asi))
                )
              (not (= ?afyc ?asi))
              )
            (or (or (= ?afyf ?afye)
                (= ?afyf ?asi)
                )
              (= ?afye ?asi)
              )
            )
          (and (or (or (= ?afyd ?afyc)
                (= ?afyd ?asi)
                )
              (= ?afyc ?asi)
              )
            (and (and (not (= ?afyf ?afye))
                (not (= ?afyf ?asi))
                )
              (not (= ?afye ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afyg Real)
    (declare-const ?afyh Real)
    (declare-const ?afyi Real)
    (declare-const ?afyj Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?afyh ?afyg))
                (not (= ?afyh ?fkf))
                )
              (not (= ?afyg ?fkf))
              )
            (or (or (= ?afyj ?afyi)
                (= ?afyj ?fkf)
                )
              (= ?afyi ?fkf)
              )
            )
          (and (or (or (= ?afyh ?afyg)
                (= ?afyh ?fkf)
                )
              (= ?afyg ?fkf)
              )
            (and (and (not (= ?afyj ?afyi))
                (not (= ?afyj ?fkf))
                )
              (not (= ?afyi ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afyk Real)
    (declare-const ?afyl Real)
    (declare-const ?afym Real)
    (declare-const ?afyn Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?afyl ?afyk))
                (not (= ?afyl ?mzs))
                )
              (not (= ?afyk ?mzs))
              )
            (or (or (= ?afyn ?afym)
                (= ?afyn ?mzs)
                )
              (= ?afym ?mzs)
              )
            )
          (and (or (or (= ?afyl ?afyk)
                (= ?afyl ?mzs)
                )
              (= ?afyk ?mzs)
              )
            (and (and (not (= ?afyn ?afym))
                (not (= ?afyn ?mzs))
                )
              (not (= ?afym ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?afyo Real)
  (push 1)
    (declare-const ?afyp Real)
    (declare-const ?afyq Real)
    (declare-const ?afyr Real)
    (assert
      (or (or (= ?afyr ?afyq)
          (= ?afyr ?afyp)
          )
        (= ?afyq ?afyp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afys Real)
    (declare-const ?afyt Real)
    (declare-const ?afyu Real)
    (declare-const ?afyv Real)
    (assert
      (or (or (= ?afyv ?afyu)
          (= ?afyv ?afyt)
          )
        (= ?afyu ?afyt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afyw Real)
    (declare-const ?afyx Real)
    (declare-const ?afyy Real)
    (declare-const ?afyz Real)
    (declare-const ?afza Real)
    (assert
      (or (or (= ?afza ?afyz)
          (= ?afza ?afyy)
          )
        (= ?afyz ?afyy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afzb Real)
    (declare-const ?afzc Real)
    (declare-const ?afzd Real)
    (declare-const ?afze Real)
    (declare-const ?afzf Real)
    (declare-const ?afzg Real)
    (assert
      (and (and (and (not (= ?afzd ?afzc))
            (not (= ?afzd ?afzb))
            )
          (not (= ?afzc ?afzb))
          )
        (or (or (= ?afzg ?afzf)
            (= ?afzg ?afze)
            )
          (= ?afzf ?afze)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afzh Real)
    (declare-const ?afzi Real)
    (declare-const ?afzj Real)
    (assert
      (or (or (= ?afzj ?afzi)
          (= ?afzj ?afzh)
          )
        (= ?afzi ?afzh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afzk Real)
    (declare-const ?afzl Real)
    (declare-const ?afzm Real)
    (assert
      (or (or (= ?afzm ?afzl)
          (= ?afzm ?afzk)
          )
        (= ?afzl ?afzk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afzn Real)
    (declare-const ?afzo Real)
    (declare-const ?afzp Real)
    (declare-const ?afzq Real)
    (assert
      (or (or (= ?afzp ?afzo)
          (= ?afzp ?afzn)
          )
        (= ?afzo ?afzn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afzr Real)
    (declare-const ?afzs Real)
    (declare-const ?afzt Real)
    (declare-const ?afzu Real)
    (declare-const ?afzv Real)
    (assert
      (or (or (= ?afzt ?afzs)
          (= ?afzt ?afzr)
          )
        (= ?afzs ?afzr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?afzw Real)
    (declare-const ?afzx Real)
    (declare-const ?afzy Real)
    (declare-const ?afzz Real)
    (declare-const ?agaa Real)
    (declare-const ?agab Real)
    (assert
      (and (or (or (= ?afzy ?afzx)
            (= ?afzy ?afzw)
            )
          (= ?afzx ?afzw)
          )
        (and (and (not (= ?agab ?agaa))
            (not (= ?agab ?afzz))
            )
          (not (= ?agaa ?afzz))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agac Real)
    (declare-const ?agad Real)
    (declare-const ?agae Real)
    (assert
      (or (or (= ?agae ?agad)
          (= ?agae ?agac)
          )
        (= ?agad ?agac)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agaf Real)
    (declare-const ?agag Real)
    (declare-const ?agah Real)
    (declare-const ?agai Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?agag ?agaf))
                (not (= ?agag ?asi))
                )
              (not (= ?agaf ?asi))
              )
            (or (or (= ?agai ?agah)
                (= ?agai ?asi)
                )
              (= ?agah ?asi)
              )
            )
          (and (or (or (= ?agag ?agaf)
                (= ?agag ?asi)
                )
              (= ?agaf ?asi)
              )
            (and (and (not (= ?agai ?agah))
                (not (= ?agai ?asi))
                )
              (not (= ?agah ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agaj Real)
    (declare-const ?agak Real)
    (declare-const ?agal Real)
    (declare-const ?agam Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?agak ?agaj))
                (not (= ?agak ?fkf))
                )
              (not (= ?agaj ?fkf))
              )
            (or (or (= ?agam ?agal)
                (= ?agam ?fkf)
                )
              (= ?agal ?fkf)
              )
            )
          (and (or (or (= ?agak ?agaj)
                (= ?agak ?fkf)
                )
              (= ?agaj ?fkf)
              )
            (and (and (not (= ?agam ?agal))
                (not (= ?agam ?fkf))
                )
              (not (= ?agal ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agan Real)
    (declare-const ?agao Real)
    (declare-const ?agap Real)
    (declare-const ?agaq Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?agao ?agan))
                (not (= ?agao ?mzs))
                )
              (not (= ?agan ?mzs))
              )
            (or (or (= ?agaq ?agap)
                (= ?agaq ?mzs)
                )
              (= ?agap ?mzs)
              )
            )
          (and (or (or (= ?agao ?agan)
                (= ?agao ?mzs)
                )
              (= ?agan ?mzs)
              )
            (and (and (not (= ?agaq ?agap))
                (not (= ?agaq ?mzs))
                )
              (not (= ?agap ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?agar Real)
  (declare-const ?agas Real)
  (assert
    (not (= ?agar ?agas))
    )
  (push 1)
    (declare-const ?agat Real)
    (declare-const ?agau Real)
    (declare-const ?agav Real)
    (assert
      (or (or (= ?agav ?agau)
          (= ?agav ?agat)
          )
        (= ?agau ?agat)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agaw Real)
    (declare-const ?agax Real)
    (declare-const ?agay Real)
    (declare-const ?agaz Real)
    (assert
      (or (or (= ?agaz ?agay)
          (= ?agaz ?agax)
          )
        (= ?agay ?agax)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agba Real)
    (declare-const ?agbb Real)
    (declare-const ?agbc Real)
    (declare-const ?agbd Real)
    (declare-const ?agbe Real)
    (assert
      (or (or (= ?agbe ?agbd)
          (= ?agbe ?agbc)
          )
        (= ?agbd ?agbc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agbf Real)
    (declare-const ?agbg Real)
    (declare-const ?agbh Real)
    (declare-const ?agbi Real)
    (declare-const ?agbj Real)
    (declare-const ?agbk Real)
    (assert
      (and (and (and (not (= ?agbh ?agbg))
            (not (= ?agbh ?agbf))
            )
          (not (= ?agbg ?agbf))
          )
        (or (or (= ?agbk ?agbj)
            (= ?agbk ?agbi)
            )
          (= ?agbj ?agbi)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agbl Real)
    (declare-const ?agbm Real)
    (declare-const ?agbn Real)
    (assert
      (or (or (= ?agbn ?agbm)
          (= ?agbn ?agbl)
          )
        (= ?agbm ?agbl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agbo Real)
    (declare-const ?agbp Real)
    (declare-const ?agbq Real)
    (assert
      (or (or (= ?agbq ?agbp)
          (= ?agbq ?agbo)
          )
        (= ?agbp ?agbo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agbr Real)
    (declare-const ?agbs Real)
    (declare-const ?agbt Real)
    (declare-const ?agbu Real)
    (assert
      (or (or (= ?agbt ?agbs)
          (= ?agbt ?agbr)
          )
        (= ?agbs ?agbr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agbv Real)
    (declare-const ?agbw Real)
    (declare-const ?agbx Real)
    (declare-const ?agby Real)
    (declare-const ?agbz Real)
    (assert
      (or (or (= ?agbx ?agbw)
          (= ?agbx ?agbv)
          )
        (= ?agbw ?agbv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agca Real)
    (declare-const ?agcb Real)
    (declare-const ?agcc Real)
    (declare-const ?agcd Real)
    (declare-const ?agce Real)
    (declare-const ?agcf Real)
    (assert
      (and (or (or (= ?agcc ?agcb)
            (= ?agcc ?agca)
            )
          (= ?agcb ?agca)
          )
        (and (and (not (= ?agcf ?agce))
            (not (= ?agcf ?agcd))
            )
          (not (= ?agce ?agcd))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agcg Real)
    (declare-const ?agch Real)
    (declare-const ?agci Real)
    (assert
      (or (or (= ?agci ?agch)
          (= ?agci ?agcg)
          )
        (= ?agch ?agcg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agcj Real)
    (declare-const ?agck Real)
    (declare-const ?agcl Real)
    (declare-const ?agcm Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?agck ?agcj))
                (not (= ?agck ?asi))
                )
              (not (= ?agcj ?asi))
              )
            (or (or (= ?agcm ?agcl)
                (= ?agcm ?asi)
                )
              (= ?agcl ?asi)
              )
            )
          (and (or (or (= ?agck ?agcj)
                (= ?agck ?asi)
                )
              (= ?agcj ?asi)
              )
            (and (and (not (= ?agcm ?agcl))
                (not (= ?agcm ?asi))
                )
              (not (= ?agcl ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agcn Real)
    (declare-const ?agco Real)
    (declare-const ?agcp Real)
    (declare-const ?agcq Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?agco ?agcn))
                (not (= ?agco ?fkf))
                )
              (not (= ?agcn ?fkf))
              )
            (or (or (= ?agcq ?agcp)
                (= ?agcq ?fkf)
                )
              (= ?agcp ?fkf)
              )
            )
          (and (or (or (= ?agco ?agcn)
                (= ?agco ?fkf)
                )
              (= ?agcn ?fkf)
              )
            (and (and (not (= ?agcq ?agcp))
                (not (= ?agcq ?fkf))
                )
              (not (= ?agcp ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agcr Real)
    (declare-const ?agcs Real)
    (declare-const ?agct Real)
    (declare-const ?agcu Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?agcs ?agcr))
                (not (= ?agcs ?mzs))
                )
              (not (= ?agcr ?mzs))
              )
            (or (or (= ?agcu ?agct)
                (= ?agcu ?mzs)
                )
              (= ?agct ?mzs)
              )
            )
          (and (or (or (= ?agcs ?agcr)
                (= ?agcs ?mzs)
                )
              (= ?agcr ?mzs)
              )
            (and (and (not (= ?agcu ?agct))
                (not (= ?agcu ?mzs))
                )
              (not (= ?agct ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?agcv Real)
  (declare-const ?agcw Real)
  (declare-const ?agcx Real)
  (push 1)
    (declare-const ?agcy Real)
    (declare-const ?agcz Real)
    (declare-const ?agda Real)
    (assert
      (or (or (= ?agda ?agcz)
          (= ?agda ?agcy)
          )
        (= ?agcz ?agcy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agdb Real)
    (declare-const ?agdc Real)
    (declare-const ?agdd Real)
    (declare-const ?agde Real)
    (assert
      (or (or (= ?agde ?agdd)
          (= ?agde ?agdc)
          )
        (= ?agdd ?agdc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agdf Real)
    (declare-const ?agdg Real)
    (declare-const ?agdh Real)
    (declare-const ?agdi Real)
    (declare-const ?agdj Real)
    (assert
      (or (or (= ?agdj ?agdi)
          (= ?agdj ?agdh)
          )
        (= ?agdi ?agdh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agdk Real)
    (declare-const ?agdl Real)
    (declare-const ?agdm Real)
    (declare-const ?agdn Real)
    (declare-const ?agdo Real)
    (declare-const ?agdp Real)
    (assert
      (and (and (and (not (= ?agdm ?agdl))
            (not (= ?agdm ?agdk))
            )
          (not (= ?agdl ?agdk))
          )
        (or (or (= ?agdp ?agdo)
            (= ?agdp ?agdn)
            )
          (= ?agdo ?agdn)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agdq Real)
    (declare-const ?agdr Real)
    (declare-const ?agds Real)
    (assert
      (or (or (= ?agds ?agdr)
          (= ?agds ?agdq)
          )
        (= ?agdr ?agdq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agdt Real)
    (declare-const ?agdu Real)
    (declare-const ?agdv Real)
    (assert
      (or (or (= ?agdv ?agdu)
          (= ?agdv ?agdt)
          )
        (= ?agdu ?agdt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agdw Real)
    (declare-const ?agdx Real)
    (declare-const ?agdy Real)
    (declare-const ?agdz Real)
    (assert
      (or (or (= ?agdy ?agdx)
          (= ?agdy ?agdw)
          )
        (= ?agdx ?agdw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agea Real)
    (declare-const ?ageb Real)
    (declare-const ?agec Real)
    (declare-const ?aged Real)
    (declare-const ?agee Real)
    (assert
      (or (or (= ?agec ?ageb)
          (= ?agec ?agea)
          )
        (= ?ageb ?agea)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agef Real)
    (declare-const ?ageg Real)
    (declare-const ?ageh Real)
    (declare-const ?agei Real)
    (declare-const ?agej Real)
    (declare-const ?agek Real)
    (assert
      (and (or (or (= ?ageh ?ageg)
            (= ?ageh ?agef)
            )
          (= ?ageg ?agef)
          )
        (and (and (not (= ?agek ?agej))
            (not (= ?agek ?agei))
            )
          (not (= ?agej ?agei))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agel Real)
    (declare-const ?agem Real)
    (declare-const ?agen Real)
    (assert
      (or (or (= ?agen ?agem)
          (= ?agen ?agel)
          )
        (= ?agem ?agel)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ageo Real)
    (declare-const ?agep Real)
    (declare-const ?ageq Real)
    (declare-const ?ager Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?agep ?ageo))
                (not (= ?agep ?asi))
                )
              (not (= ?ageo ?asi))
              )
            (or (or (= ?ager ?ageq)
                (= ?ager ?asi)
                )
              (= ?ageq ?asi)
              )
            )
          (and (or (or (= ?agep ?ageo)
                (= ?agep ?asi)
                )
              (= ?ageo ?asi)
              )
            (and (and (not (= ?ager ?ageq))
                (not (= ?ager ?asi))
                )
              (not (= ?ageq ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ages Real)
    (declare-const ?aget Real)
    (declare-const ?ageu Real)
    (declare-const ?agev Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aget ?ages))
                (not (= ?aget ?fkf))
                )
              (not (= ?ages ?fkf))
              )
            (or (or (= ?agev ?ageu)
                (= ?agev ?fkf)
                )
              (= ?ageu ?fkf)
              )
            )
          (and (or (or (= ?aget ?ages)
                (= ?aget ?fkf)
                )
              (= ?ages ?fkf)
              )
            (and (and (not (= ?agev ?ageu))
                (not (= ?agev ?fkf))
                )
              (not (= ?ageu ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agew Real)
    (declare-const ?agex Real)
    (declare-const ?agey Real)
    (declare-const ?agez Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?agex ?agew))
                (not (= ?agex ?mzs))
                )
              (not (= ?agew ?mzs))
              )
            (or (or (= ?agez ?agey)
                (= ?agez ?mzs)
                )
              (= ?agey ?mzs)
              )
            )
          (and (or (or (= ?agex ?agew)
                (= ?agex ?mzs)
                )
              (= ?agew ?mzs)
              )
            (and (and (not (= ?agez ?agey))
                (not (= ?agez ?mzs))
                )
              (not (= ?agey ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?agfa Real)
  (declare-const ?agfb Real)
  (declare-const ?agfc Real)
  (declare-const ?agfd Real)
  (push 1)
    (declare-const ?agfe Real)
    (declare-const ?agff Real)
    (declare-const ?agfg Real)
    (assert
      (or (or (= ?agfg ?agff)
          (= ?agfg ?agfe)
          )
        (= ?agff ?agfe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agfh Real)
    (declare-const ?agfi Real)
    (declare-const ?agfj Real)
    (declare-const ?agfk Real)
    (assert
      (or (or (= ?agfk ?agfj)
          (= ?agfk ?agfi)
          )
        (= ?agfj ?agfi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agfl Real)
    (declare-const ?agfm Real)
    (declare-const ?agfn Real)
    (declare-const ?agfo Real)
    (declare-const ?agfp Real)
    (assert
      (or (or (= ?agfp ?agfo)
          (= ?agfp ?agfn)
          )
        (= ?agfo ?agfn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agfq Real)
    (declare-const ?agfr Real)
    (declare-const ?agfs Real)
    (declare-const ?agft Real)
    (declare-const ?agfu Real)
    (declare-const ?agfv Real)
    (assert
      (and (and (and (not (= ?agfs ?agfr))
            (not (= ?agfs ?agfq))
            )
          (not (= ?agfr ?agfq))
          )
        (or (or (= ?agfv ?agfu)
            (= ?agfv ?agft)
            )
          (= ?agfu ?agft)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agfw Real)
    (declare-const ?agfx Real)
    (declare-const ?agfy Real)
    (assert
      (or (or (= ?agfy ?agfx)
          (= ?agfy ?agfw)
          )
        (= ?agfx ?agfw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agfz Real)
    (declare-const ?agga Real)
    (declare-const ?aggb Real)
    (assert
      (or (or (= ?aggb ?agga)
          (= ?aggb ?agfz)
          )
        (= ?agga ?agfz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aggc Real)
    (declare-const ?aggd Real)
    (declare-const ?agge Real)
    (declare-const ?aggf Real)
    (assert
      (or (or (= ?agge ?aggd)
          (= ?agge ?aggc)
          )
        (= ?aggd ?aggc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aggg Real)
    (declare-const ?aggh Real)
    (declare-const ?aggi Real)
    (declare-const ?aggj Real)
    (declare-const ?aggk Real)
    (assert
      (or (or (= ?aggi ?aggh)
          (= ?aggi ?aggg)
          )
        (= ?aggh ?aggg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aggl Real)
    (declare-const ?aggm Real)
    (declare-const ?aggn Real)
    (declare-const ?aggo Real)
    (declare-const ?aggp Real)
    (declare-const ?aggq Real)
    (assert
      (and (or (or (= ?aggn ?aggm)
            (= ?aggn ?aggl)
            )
          (= ?aggm ?aggl)
          )
        (and (and (not (= ?aggq ?aggp))
            (not (= ?aggq ?aggo))
            )
          (not (= ?aggp ?aggo))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aggr Real)
    (declare-const ?aggs Real)
    (declare-const ?aggt Real)
    (assert
      (or (or (= ?aggt ?aggs)
          (= ?aggt ?aggr)
          )
        (= ?aggs ?aggr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aggu Real)
    (declare-const ?aggv Real)
    (declare-const ?aggw Real)
    (declare-const ?aggx Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aggv ?aggu))
                (not (= ?aggv ?asi))
                )
              (not (= ?aggu ?asi))
              )
            (or (or (= ?aggx ?aggw)
                (= ?aggx ?asi)
                )
              (= ?aggw ?asi)
              )
            )
          (and (or (or (= ?aggv ?aggu)
                (= ?aggv ?asi)
                )
              (= ?aggu ?asi)
              )
            (and (and (not (= ?aggx ?aggw))
                (not (= ?aggx ?asi))
                )
              (not (= ?aggw ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aggy Real)
    (declare-const ?aggz Real)
    (declare-const ?agha Real)
    (declare-const ?aghb Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aggz ?aggy))
                (not (= ?aggz ?fkf))
                )
              (not (= ?aggy ?fkf))
              )
            (or (or (= ?aghb ?agha)
                (= ?aghb ?fkf)
                )
              (= ?agha ?fkf)
              )
            )
          (and (or (or (= ?aggz ?aggy)
                (= ?aggz ?fkf)
                )
              (= ?aggy ?fkf)
              )
            (and (and (not (= ?aghb ?agha))
                (not (= ?aghb ?fkf))
                )
              (not (= ?agha ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aghc Real)
    (declare-const ?aghd Real)
    (declare-const ?aghe Real)
    (declare-const ?aghf Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aghd ?aghc))
                (not (= ?aghd ?mzs))
                )
              (not (= ?aghc ?mzs))
              )
            (or (or (= ?aghf ?aghe)
                (= ?aghf ?mzs)
                )
              (= ?aghe ?mzs)
              )
            )
          (and (or (or (= ?aghd ?aghc)
                (= ?aghd ?mzs)
                )
              (= ?aghc ?mzs)
              )
            (and (and (not (= ?aghf ?aghe))
                (not (= ?aghf ?mzs))
                )
              (not (= ?aghe ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aghg Real)
  (push 1)
    (declare-const ?aghh Real)
    (declare-const ?aghi Real)
    (declare-const ?aghj Real)
    (assert
      (or (or (= ?aghj ?aghi)
          (= ?aghj ?aghh)
          )
        (= ?aghi ?aghh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aghk Real)
    (declare-const ?aghl Real)
    (declare-const ?aghm Real)
    (declare-const ?aghn Real)
    (assert
      (or (or (= ?aghn ?aghm)
          (= ?aghn ?aghl)
          )
        (= ?aghm ?aghl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agho Real)
    (declare-const ?aghp Real)
    (declare-const ?aghq Real)
    (declare-const ?aghr Real)
    (declare-const ?aghs Real)
    (assert
      (or (or (= ?aghs ?aghr)
          (= ?aghs ?aghq)
          )
        (= ?aghr ?aghq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aght Real)
    (declare-const ?aghu Real)
    (declare-const ?aghv Real)
    (declare-const ?aghw Real)
    (declare-const ?aghx Real)
    (declare-const ?aghy Real)
    (assert
      (and (and (and (not (= ?aghv ?aghu))
            (not (= ?aghv ?aght))
            )
          (not (= ?aghu ?aght))
          )
        (or (or (= ?aghy ?aghx)
            (= ?aghy ?aghw)
            )
          (= ?aghx ?aghw)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aghz Real)
    (declare-const ?agia Real)
    (declare-const ?agib Real)
    (assert
      (or (or (= ?agib ?agia)
          (= ?agib ?aghz)
          )
        (= ?agia ?aghz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agic Real)
    (declare-const ?agid Real)
    (declare-const ?agie Real)
    (assert
      (or (or (= ?agie ?agid)
          (= ?agie ?agic)
          )
        (= ?agid ?agic)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agif Real)
    (declare-const ?agig Real)
    (declare-const ?agih Real)
    (declare-const ?agii Real)
    (assert
      (or (or (= ?agih ?agig)
          (= ?agih ?agif)
          )
        (= ?agig ?agif)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agij Real)
    (declare-const ?agik Real)
    (declare-const ?agil Real)
    (declare-const ?agim Real)
    (declare-const ?agin Real)
    (assert
      (or (or (= ?agil ?agik)
          (= ?agil ?agij)
          )
        (= ?agik ?agij)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agio Real)
    (declare-const ?agip Real)
    (declare-const ?agiq Real)
    (declare-const ?agir Real)
    (declare-const ?agis Real)
    (declare-const ?agit Real)
    (assert
      (and (or (or (= ?agiq ?agip)
            (= ?agiq ?agio)
            )
          (= ?agip ?agio)
          )
        (and (and (not (= ?agit ?agis))
            (not (= ?agit ?agir))
            )
          (not (= ?agis ?agir))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agiu Real)
    (declare-const ?agiv Real)
    (declare-const ?agiw Real)
    (assert
      (or (or (= ?agiw ?agiv)
          (= ?agiw ?agiu)
          )
        (= ?agiv ?agiu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agix Real)
    (declare-const ?agiy Real)
    (declare-const ?agiz Real)
    (declare-const ?agja Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?agiy ?agix))
                (not (= ?agiy ?asi))
                )
              (not (= ?agix ?asi))
              )
            (or (or (= ?agja ?agiz)
                (= ?agja ?asi)
                )
              (= ?agiz ?asi)
              )
            )
          (and (or (or (= ?agiy ?agix)
                (= ?agiy ?asi)
                )
              (= ?agix ?asi)
              )
            (and (and (not (= ?agja ?agiz))
                (not (= ?agja ?asi))
                )
              (not (= ?agiz ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agjb Real)
    (declare-const ?agjc Real)
    (declare-const ?agjd Real)
    (declare-const ?agje Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?agjc ?agjb))
                (not (= ?agjc ?fkf))
                )
              (not (= ?agjb ?fkf))
              )
            (or (or (= ?agje ?agjd)
                (= ?agje ?fkf)
                )
              (= ?agjd ?fkf)
              )
            )
          (and (or (or (= ?agjc ?agjb)
                (= ?agjc ?fkf)
                )
              (= ?agjb ?fkf)
              )
            (and (and (not (= ?agje ?agjd))
                (not (= ?agje ?fkf))
                )
              (not (= ?agjd ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agjf Real)
    (declare-const ?agjg Real)
    (declare-const ?agjh Real)
    (declare-const ?agji Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?agjg ?agjf))
                (not (= ?agjg ?mzs))
                )
              (not (= ?agjf ?mzs))
              )
            (or (or (= ?agji ?agjh)
                (= ?agji ?mzs)
                )
              (= ?agjh ?mzs)
              )
            )
          (and (or (or (= ?agjg ?agjf)
                (= ?agjg ?mzs)
                )
              (= ?agjf ?mzs)
              )
            (and (and (not (= ?agji ?agjh))
                (not (= ?agji ?mzs))
                )
              (not (= ?agjh ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?agjj Real)
  (declare-const ?agjk Real)
  (push 1)
    (declare-const ?agjl Real)
    (declare-const ?agjm Real)
    (declare-const ?agjn Real)
    (assert
      (or (or (= ?agjn ?agjm)
          (= ?agjn ?agjl)
          )
        (= ?agjm ?agjl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agjo Real)
    (declare-const ?agjp Real)
    (declare-const ?agjq Real)
    (declare-const ?agjr Real)
    (assert
      (or (or (= ?agjr ?agjq)
          (= ?agjr ?agjp)
          )
        (= ?agjq ?agjp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agjs Real)
    (declare-const ?agjt Real)
    (declare-const ?agju Real)
    (declare-const ?agjv Real)
    (declare-const ?agjw Real)
    (assert
      (or (or (= ?agjw ?agjv)
          (= ?agjw ?agju)
          )
        (= ?agjv ?agju)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agjx Real)
    (declare-const ?agjy Real)
    (declare-const ?agjz Real)
    (declare-const ?agka Real)
    (declare-const ?agkb Real)
    (declare-const ?agkc Real)
    (assert
      (and (and (and (not (= ?agjz ?agjy))
            (not (= ?agjz ?agjx))
            )
          (not (= ?agjy ?agjx))
          )
        (or (or (= ?agkc ?agkb)
            (= ?agkc ?agka)
            )
          (= ?agkb ?agka)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agkd Real)
    (declare-const ?agke Real)
    (declare-const ?agkf Real)
    (assert
      (or (or (= ?agkf ?agke)
          (= ?agkf ?agkd)
          )
        (= ?agke ?agkd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agkg Real)
    (declare-const ?agkh Real)
    (declare-const ?agki Real)
    (assert
      (or (or (= ?agki ?agkh)
          (= ?agki ?agkg)
          )
        (= ?agkh ?agkg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agkj Real)
    (declare-const ?agkk Real)
    (declare-const ?agkl Real)
    (declare-const ?agkm Real)
    (assert
      (or (or (= ?agkl ?agkk)
          (= ?agkl ?agkj)
          )
        (= ?agkk ?agkj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agkn Real)
    (declare-const ?agko Real)
    (declare-const ?agkp Real)
    (declare-const ?agkq Real)
    (declare-const ?agkr Real)
    (assert
      (or (or (= ?agkp ?agko)
          (= ?agkp ?agkn)
          )
        (= ?agko ?agkn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agks Real)
    (declare-const ?agkt Real)
    (declare-const ?agku Real)
    (declare-const ?agkv Real)
    (declare-const ?agkw Real)
    (declare-const ?agkx Real)
    (assert
      (and (or (or (= ?agku ?agkt)
            (= ?agku ?agks)
            )
          (= ?agkt ?agks)
          )
        (and (and (not (= ?agkx ?agkw))
            (not (= ?agkx ?agkv))
            )
          (not (= ?agkw ?agkv))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agky Real)
    (declare-const ?agkz Real)
    (declare-const ?agla Real)
    (assert
      (or (or (= ?agla ?agkz)
          (= ?agla ?agky)
          )
        (= ?agkz ?agky)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aglb Real)
    (declare-const ?aglc Real)
    (declare-const ?agld Real)
    (declare-const ?agle Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aglc ?aglb))
                (not (= ?aglc ?asi))
                )
              (not (= ?aglb ?asi))
              )
            (or (or (= ?agle ?agld)
                (= ?agle ?asi)
                )
              (= ?agld ?asi)
              )
            )
          (and (or (or (= ?aglc ?aglb)
                (= ?aglc ?asi)
                )
              (= ?aglb ?asi)
              )
            (and (and (not (= ?agle ?agld))
                (not (= ?agle ?asi))
                )
              (not (= ?agld ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aglf Real)
    (declare-const ?aglg Real)
    (declare-const ?aglh Real)
    (declare-const ?agli Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aglg ?aglf))
                (not (= ?aglg ?fkf))
                )
              (not (= ?aglf ?fkf))
              )
            (or (or (= ?agli ?aglh)
                (= ?agli ?fkf)
                )
              (= ?aglh ?fkf)
              )
            )
          (and (or (or (= ?aglg ?aglf)
                (= ?aglg ?fkf)
                )
              (= ?aglf ?fkf)
              )
            (and (and (not (= ?agli ?aglh))
                (not (= ?agli ?fkf))
                )
              (not (= ?aglh ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aglj Real)
    (declare-const ?aglk Real)
    (declare-const ?agll Real)
    (declare-const ?aglm Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aglk ?aglj))
                (not (= ?aglk ?mzs))
                )
              (not (= ?aglj ?mzs))
              )
            (or (or (= ?aglm ?agll)
                (= ?aglm ?mzs)
                )
              (= ?agll ?mzs)
              )
            )
          (and (or (or (= ?aglk ?aglj)
                (= ?aglk ?mzs)
                )
              (= ?aglj ?mzs)
              )
            (and (and (not (= ?aglm ?agll))
                (not (= ?aglm ?mzs))
                )
              (not (= ?agll ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?agln Real)
  (declare-const ?aglo Real)
  (declare-const ?aglp Real)
  (push 1)
    (declare-const ?aglq Real)
    (declare-const ?aglr Real)
    (declare-const ?agls Real)
    (assert
      (or (or (= ?agls ?aglr)
          (= ?agls ?aglq)
          )
        (= ?aglr ?aglq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aglt Real)
    (declare-const ?aglu Real)
    (declare-const ?aglv Real)
    (declare-const ?aglw Real)
    (assert
      (or (or (= ?aglw ?aglv)
          (= ?aglw ?aglu)
          )
        (= ?aglv ?aglu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aglx Real)
    (declare-const ?agly Real)
    (declare-const ?aglz Real)
    (declare-const ?agma Real)
    (declare-const ?agmb Real)
    (assert
      (or (or (= ?agmb ?agma)
          (= ?agmb ?aglz)
          )
        (= ?agma ?aglz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agmc Real)
    (declare-const ?agmd Real)
    (declare-const ?agme Real)
    (declare-const ?agmf Real)
    (declare-const ?agmg Real)
    (declare-const ?agmh Real)
    (assert
      (and (and (and (not (= ?agme ?agmd))
            (not (= ?agme ?agmc))
            )
          (not (= ?agmd ?agmc))
          )
        (or (or (= ?agmh ?agmg)
            (= ?agmh ?agmf)
            )
          (= ?agmg ?agmf)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agmi Real)
    (declare-const ?agmj Real)
    (declare-const ?agmk Real)
    (assert
      (or (or (= ?agmk ?agmj)
          (= ?agmk ?agmi)
          )
        (= ?agmj ?agmi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agml Real)
    (declare-const ?agmm Real)
    (declare-const ?agmn Real)
    (assert
      (or (or (= ?agmn ?agmm)
          (= ?agmn ?agml)
          )
        (= ?agmm ?agml)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agmo Real)
    (declare-const ?agmp Real)
    (declare-const ?agmq Real)
    (declare-const ?agmr Real)
    (assert
      (or (or (= ?agmq ?agmp)
          (= ?agmq ?agmo)
          )
        (= ?agmp ?agmo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agms Real)
    (declare-const ?agmt Real)
    (declare-const ?agmu Real)
    (declare-const ?agmv Real)
    (declare-const ?agmw Real)
    (assert
      (or (or (= ?agmu ?agmt)
          (= ?agmu ?agms)
          )
        (= ?agmt ?agms)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agmx Real)
    (declare-const ?agmy Real)
    (declare-const ?agmz Real)
    (declare-const ?agna Real)
    (declare-const ?agnb Real)
    (declare-const ?agnc Real)
    (assert
      (and (or (or (= ?agmz ?agmy)
            (= ?agmz ?agmx)
            )
          (= ?agmy ?agmx)
          )
        (and (and (not (= ?agnc ?agnb))
            (not (= ?agnc ?agna))
            )
          (not (= ?agnb ?agna))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agnd Real)
    (declare-const ?agne Real)
    (declare-const ?agnf Real)
    (assert
      (or (or (= ?agnf ?agne)
          (= ?agnf ?agnd)
          )
        (= ?agne ?agnd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agng Real)
    (declare-const ?agnh Real)
    (declare-const ?agni Real)
    (declare-const ?agnj Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?agnh ?agng))
                (not (= ?agnh ?asi))
                )
              (not (= ?agng ?asi))
              )
            (or (or (= ?agnj ?agni)
                (= ?agnj ?asi)
                )
              (= ?agni ?asi)
              )
            )
          (and (or (or (= ?agnh ?agng)
                (= ?agnh ?asi)
                )
              (= ?agng ?asi)
              )
            (and (and (not (= ?agnj ?agni))
                (not (= ?agnj ?asi))
                )
              (not (= ?agni ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agnk Real)
    (declare-const ?agnl Real)
    (declare-const ?agnm Real)
    (declare-const ?agnn Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?agnl ?agnk))
                (not (= ?agnl ?fkf))
                )
              (not (= ?agnk ?fkf))
              )
            (or (or (= ?agnn ?agnm)
                (= ?agnn ?fkf)
                )
              (= ?agnm ?fkf)
              )
            )
          (and (or (or (= ?agnl ?agnk)
                (= ?agnl ?fkf)
                )
              (= ?agnk ?fkf)
              )
            (and (and (not (= ?agnn ?agnm))
                (not (= ?agnn ?fkf))
                )
              (not (= ?agnm ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agno Real)
    (declare-const ?agnp Real)
    (declare-const ?agnq Real)
    (declare-const ?agnr Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?agnp ?agno))
                (not (= ?agnp ?mzs))
                )
              (not (= ?agno ?mzs))
              )
            (or (or (= ?agnr ?agnq)
                (= ?agnr ?mzs)
                )
              (= ?agnq ?mzs)
              )
            )
          (and (or (or (= ?agnp ?agno)
                (= ?agnp ?mzs)
                )
              (= ?agno ?mzs)
              )
            (and (and (not (= ?agnr ?agnq))
                (not (= ?agnr ?mzs))
                )
              (not (= ?agnq ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?agns Real)
  (declare-const ?agnt Real)
  (declare-const ?agnu Real)
  (declare-const ?agnv Real)
  (assert
    (exists ((?mzs Real) )(or (and (and (and (not (= ?agnt ?agns))
              (not (= ?agnt ?mzs))
              )
            (not (= ?agns ?mzs))
            )
          (or (or (= ?agnv ?agnu)
              (= ?agnv ?mzs)
              )
            (= ?agnu ?mzs)
            )
          )
        (and (or (or (= ?agnt ?agns)
              (= ?agnt ?mzs)
              )
            (= ?agns ?mzs)
            )
          (and (and (not (= ?agnv ?agnu))
              (not (= ?agnv ?mzs))
              )
            (not (= ?agnu ?mzs))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?agnw Real)
    (declare-const ?agnx Real)
    (declare-const ?agny Real)
    (assert
      (or (or (= ?agny ?agnx)
          (= ?agny ?agnw)
          )
        (= ?agnx ?agnw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agnz Real)
    (declare-const ?agoa Real)
    (declare-const ?agob Real)
    (declare-const ?agoc Real)
    (assert
      (or (or (= ?agoc ?agob)
          (= ?agoc ?agoa)
          )
        (= ?agob ?agoa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agod Real)
    (declare-const ?agoe Real)
    (declare-const ?agof Real)
    (declare-const ?agog Real)
    (declare-const ?agoh Real)
    (assert
      (or (or (= ?agoh ?agog)
          (= ?agoh ?agof)
          )
        (= ?agog ?agof)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agoi Real)
    (declare-const ?agoj Real)
    (declare-const ?agok Real)
    (declare-const ?agol Real)
    (declare-const ?agom Real)
    (declare-const ?agon Real)
    (assert
      (and (and (and (not (= ?agok ?agoj))
            (not (= ?agok ?agoi))
            )
          (not (= ?agoj ?agoi))
          )
        (or (or (= ?agon ?agom)
            (= ?agon ?agol)
            )
          (= ?agom ?agol)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agoo Real)
    (declare-const ?agop Real)
    (declare-const ?agoq Real)
    (assert
      (or (or (= ?agoq ?agop)
          (= ?agoq ?agoo)
          )
        (= ?agop ?agoo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agor Real)
    (declare-const ?agos Real)
    (declare-const ?agot Real)
    (assert
      (or (or (= ?agot ?agos)
          (= ?agot ?agor)
          )
        (= ?agos ?agor)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agou Real)
    (declare-const ?agov Real)
    (declare-const ?agow Real)
    (declare-const ?agox Real)
    (assert
      (or (or (= ?agow ?agov)
          (= ?agow ?agou)
          )
        (= ?agov ?agou)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agoy Real)
    (declare-const ?agoz Real)
    (declare-const ?agpa Real)
    (declare-const ?agpb Real)
    (declare-const ?agpc Real)
    (assert
      (or (or (= ?agpa ?agoz)
          (= ?agpa ?agoy)
          )
        (= ?agoz ?agoy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agpd Real)
    (declare-const ?agpe Real)
    (declare-const ?agpf Real)
    (declare-const ?agpg Real)
    (declare-const ?agph Real)
    (declare-const ?agpi Real)
    (assert
      (and (or (or (= ?agpf ?agpe)
            (= ?agpf ?agpd)
            )
          (= ?agpe ?agpd)
          )
        (and (and (not (= ?agpi ?agph))
            (not (= ?agpi ?agpg))
            )
          (not (= ?agph ?agpg))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agpj Real)
    (declare-const ?agpk Real)
    (declare-const ?agpl Real)
    (assert
      (or (or (= ?agpl ?agpk)
          (= ?agpl ?agpj)
          )
        (= ?agpk ?agpj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agpm Real)
    (declare-const ?agpn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agpo Real)
    (declare-const ?agpp Real)
    (declare-const ?agpq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agpr Real)
    (declare-const ?agps Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agpt Real)
    (declare-const ?agpu Real)
    (declare-const ?agpv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agpw Real)
    (declare-const ?agpx Real)
    (declare-const ?agpy Real)
    (declare-const ?agpz Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?agpx ?agpw))
                (not (= ?agpx ?asi))
                )
              (not (= ?agpw ?asi))
              )
            (or (or (= ?agpz ?agpy)
                (= ?agpz ?asi)
                )
              (= ?agpy ?asi)
              )
            )
          (and (or (or (= ?agpx ?agpw)
                (= ?agpx ?asi)
                )
              (= ?agpw ?asi)
              )
            (and (and (not (= ?agpz ?agpy))
                (not (= ?agpz ?asi))
                )
              (not (= ?agpy ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agqa Real)
    (declare-const ?agqb Real)
    (declare-const ?agqc Real)
    (declare-const ?agqd Real)
    (declare-const ?agqe Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agqf Real)
    (declare-const ?agqg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agqh Real)
    (declare-const ?agqi Real)
    (declare-const ?agqj Real)
    (declare-const ?agqk Real)
    (declare-const ?agql Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agqm Real)
    (declare-const ?agqn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agqo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agqp Real)
    (declare-const ?agqq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agqr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agqs Real)
    (declare-const ?agqt Real)
    (assert
      (not (= ?agqs ?agqt))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agqu Real)
    (declare-const ?agqv Real)
    (declare-const ?agqw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agqx Real)
    (declare-const ?agqy Real)
    (declare-const ?agqz Real)
    (declare-const ?agra Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agrb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agrc Real)
    (declare-const ?agrd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agre Real)
    (declare-const ?agrf Real)
    (declare-const ?agrg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agrh Real)
    (declare-const ?agri Real)
    (declare-const ?agrj Real)
    (declare-const ?agrk Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?agri ?agrh))
                (not (= ?agri ?fkf))
                )
              (not (= ?agrh ?fkf))
              )
            (or (or (= ?agrk ?agrj)
                (= ?agrk ?fkf)
                )
              (= ?agrj ?fkf)
              )
            )
          (and (or (or (= ?agri ?agrh)
                (= ?agri ?fkf)
                )
              (= ?agrh ?fkf)
              )
            (and (and (not (= ?agrk ?agrj))
                (not (= ?agrk ?fkf))
                )
              (not (= ?agrj ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agrl Real)
    (declare-const ?agrm Real)
    (declare-const ?agrn Real)
    (declare-const ?agro Real)
    (declare-const ?agrp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agrq Real)
    (declare-const ?agrr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agrs Real)
    (declare-const ?agrt Real)
    (declare-const ?agru Real)
    (declare-const ?agrv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agrw Real)
    (declare-const ?agrx Real)
    (declare-const ?agry Real)
    (declare-const ?agrz Real)
    (declare-const ?agsa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agsb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agsc Real)
    (declare-const ?agsd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agse Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agsf Real)
    (declare-const ?agsg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agsh Real)
    (declare-const ?agsi Real)
    (declare-const ?agsj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agsk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agsl Real)
    (declare-const ?agsm Real)
    (assert
      (not (= ?agsl ?agsm))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agsn Real)
    (declare-const ?agso Real)
    (declare-const ?agsp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agsq Real)
    (declare-const ?agsr Real)
    (declare-const ?agss Real)
    (declare-const ?agst Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agsu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agsv Real)
    (declare-const ?agsw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agsx Real)
    (declare-const ?agsy Real)
    (declare-const ?agsz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agta Real)
    (declare-const ?agtb Real)
    (declare-const ?agtc Real)
    (declare-const ?agtd Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?agtb ?agta))
                (not (= ?agtb ?mzs))
                )
              (not (= ?agta ?mzs))
              )
            (or (or (= ?agtd ?agtc)
                (= ?agtd ?mzs)
                )
              (= ?agtc ?mzs)
              )
            )
          (and (or (or (= ?agtb ?agta)
                (= ?agtb ?mzs)
                )
              (= ?agta ?mzs)
              )
            (and (and (not (= ?agtd ?agtc))
                (not (= ?agtd ?mzs))
                )
              (not (= ?agtc ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agte Real)
    (declare-const ?agtf Real)
    (declare-const ?agtg Real)
    (declare-const ?agth Real)
    (declare-const ?agti Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agtj Real)
    (declare-const ?agtk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agtl Real)
    (declare-const ?agtm Real)
    (declare-const ?agtn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agto Real)
    (declare-const ?agtp Real)
    (declare-const ?agtq Real)
    (declare-const ?agtr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agts Real)
    (declare-const ?agtt Real)
    (declare-const ?agtu Real)
    (declare-const ?agtv Real)
    (declare-const ?agtw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agtx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agty Real)
    (declare-const ?agtz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?agua Real)
  (declare-const ?agub Real)
  (declare-const ?aguc Real)
  (declare-const ?agud Real)
  (declare-const ?ague Real)
  (push 1)
    (declare-const ?aguf Real)
    (declare-const ?agug Real)
    (declare-const ?aguh Real)
    (assert
      (or (or (= ?aguh ?agug)
          (= ?aguh ?aguf)
          )
        (= ?agug ?aguf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agui Real)
    (declare-const ?aguj Real)
    (declare-const ?aguk Real)
    (declare-const ?agul Real)
    (assert
      (or (or (= ?agul ?aguk)
          (= ?agul ?aguj)
          )
        (= ?aguk ?aguj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agum Real)
    (declare-const ?agun Real)
    (declare-const ?aguo Real)
    (declare-const ?agup Real)
    (declare-const ?aguq Real)
    (assert
      (or (or (= ?aguq ?agup)
          (= ?aguq ?aguo)
          )
        (= ?agup ?aguo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agur Real)
    (declare-const ?agus Real)
    (declare-const ?agut Real)
    (declare-const ?aguu Real)
    (declare-const ?aguv Real)
    (declare-const ?aguw Real)
    (assert
      (and (and (and (not (= ?agut ?agus))
            (not (= ?agut ?agur))
            )
          (not (= ?agus ?agur))
          )
        (or (or (= ?aguw ?aguv)
            (= ?aguw ?aguu)
            )
          (= ?aguv ?aguu)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agux Real)
    (declare-const ?aguy Real)
    (declare-const ?aguz Real)
    (assert
      (or (or (= ?aguz ?aguy)
          (= ?aguz ?agux)
          )
        (= ?aguy ?agux)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agva Real)
    (declare-const ?agvb Real)
    (declare-const ?agvc Real)
    (assert
      (or (or (= ?agvc ?agvb)
          (= ?agvc ?agva)
          )
        (= ?agvb ?agva)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agvd Real)
    (declare-const ?agve Real)
    (declare-const ?agvf Real)
    (declare-const ?agvg Real)
    (assert
      (or (or (= ?agvf ?agve)
          (= ?agvf ?agvd)
          )
        (= ?agve ?agvd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agvh Real)
    (declare-const ?agvi Real)
    (declare-const ?agvj Real)
    (declare-const ?agvk Real)
    (declare-const ?agvl Real)
    (assert
      (or (or (= ?agvj ?agvi)
          (= ?agvj ?agvh)
          )
        (= ?agvi ?agvh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agvm Real)
    (declare-const ?agvn Real)
    (declare-const ?agvo Real)
    (declare-const ?agvp Real)
    (declare-const ?agvq Real)
    (declare-const ?agvr Real)
    (assert
      (and (or (or (= ?agvo ?agvn)
            (= ?agvo ?agvm)
            )
          (= ?agvn ?agvm)
          )
        (and (and (not (= ?agvr ?agvq))
            (not (= ?agvr ?agvp))
            )
          (not (= ?agvq ?agvp))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agvs Real)
    (declare-const ?agvt Real)
    (declare-const ?agvu Real)
    (assert
      (or (or (= ?agvu ?agvt)
          (= ?agvu ?agvs)
          )
        (= ?agvt ?agvs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agvv Real)
    (declare-const ?agvw Real)
    (declare-const ?agvx Real)
    (declare-const ?agvy Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?agvw ?agvv))
                (not (= ?agvw ?asi))
                )
              (not (= ?agvv ?asi))
              )
            (or (or (= ?agvy ?agvx)
                (= ?agvy ?asi)
                )
              (= ?agvx ?asi)
              )
            )
          (and (or (or (= ?agvw ?agvv)
                (= ?agvw ?asi)
                )
              (= ?agvv ?asi)
              )
            (and (and (not (= ?agvy ?agvx))
                (not (= ?agvy ?asi))
                )
              (not (= ?agvx ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agvz Real)
    (declare-const ?agwa Real)
    (declare-const ?agwb Real)
    (declare-const ?agwc Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?agwa ?agvz))
                (not (= ?agwa ?fkf))
                )
              (not (= ?agvz ?fkf))
              )
            (or (or (= ?agwc ?agwb)
                (= ?agwc ?fkf)
                )
              (= ?agwb ?fkf)
              )
            )
          (and (or (or (= ?agwa ?agvz)
                (= ?agwa ?fkf)
                )
              (= ?agvz ?fkf)
              )
            (and (and (not (= ?agwc ?agwb))
                (not (= ?agwc ?fkf))
                )
              (not (= ?agwb ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agwd Real)
    (declare-const ?agwe Real)
    (declare-const ?agwf Real)
    (declare-const ?agwg Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?agwe ?agwd))
                (not (= ?agwe ?mzs))
                )
              (not (= ?agwd ?mzs))
              )
            (or (or (= ?agwg ?agwf)
                (= ?agwg ?mzs)
                )
              (= ?agwf ?mzs)
              )
            )
          (and (or (or (= ?agwe ?agwd)
                (= ?agwe ?mzs)
                )
              (= ?agwd ?mzs)
              )
            (and (and (not (= ?agwg ?agwf))
                (not (= ?agwg ?mzs))
                )
              (not (= ?agwf ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?agwh Real)
  (declare-const ?agwi Real)
  (push 1)
    (declare-const ?agwj Real)
    (declare-const ?agwk Real)
    (declare-const ?agwl Real)
    (assert
      (or (or (= ?agwl ?agwk)
          (= ?agwl ?agwj)
          )
        (= ?agwk ?agwj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agwm Real)
    (declare-const ?agwn Real)
    (declare-const ?agwo Real)
    (declare-const ?agwp Real)
    (assert
      (or (or (= ?agwp ?agwo)
          (= ?agwp ?agwn)
          )
        (= ?agwo ?agwn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agwq Real)
    (declare-const ?agwr Real)
    (declare-const ?agws Real)
    (declare-const ?agwt Real)
    (declare-const ?agwu Real)
    (assert
      (or (or (= ?agwu ?agwt)
          (= ?agwu ?agws)
          )
        (= ?agwt ?agws)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agwv Real)
    (declare-const ?agww Real)
    (declare-const ?agwx Real)
    (declare-const ?agwy Real)
    (declare-const ?agwz Real)
    (declare-const ?agxa Real)
    (assert
      (and (and (and (not (= ?agwx ?agww))
            (not (= ?agwx ?agwv))
            )
          (not (= ?agww ?agwv))
          )
        (or (or (= ?agxa ?agwz)
            (= ?agxa ?agwy)
            )
          (= ?agwz ?agwy)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agxb Real)
    (declare-const ?agxc Real)
    (declare-const ?agxd Real)
    (assert
      (or (or (= ?agxd ?agxc)
          (= ?agxd ?agxb)
          )
        (= ?agxc ?agxb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agxe Real)
    (declare-const ?agxf Real)
    (declare-const ?agxg Real)
    (assert
      (or (or (= ?agxg ?agxf)
          (= ?agxg ?agxe)
          )
        (= ?agxf ?agxe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agxh Real)
    (declare-const ?agxi Real)
    (declare-const ?agxj Real)
    (declare-const ?agxk Real)
    (assert
      (or (or (= ?agxj ?agxi)
          (= ?agxj ?agxh)
          )
        (= ?agxi ?agxh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agxl Real)
    (declare-const ?agxm Real)
    (declare-const ?agxn Real)
    (declare-const ?agxo Real)
    (declare-const ?agxp Real)
    (assert
      (or (or (= ?agxn ?agxm)
          (= ?agxn ?agxl)
          )
        (= ?agxm ?agxl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agxq Real)
    (declare-const ?agxr Real)
    (declare-const ?agxs Real)
    (declare-const ?agxt Real)
    (declare-const ?agxu Real)
    (declare-const ?agxv Real)
    (assert
      (and (or (or (= ?agxs ?agxr)
            (= ?agxs ?agxq)
            )
          (= ?agxr ?agxq)
          )
        (and (and (not (= ?agxv ?agxu))
            (not (= ?agxv ?agxt))
            )
          (not (= ?agxu ?agxt))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agxw Real)
    (declare-const ?agxx Real)
    (declare-const ?agxy Real)
    (assert
      (or (or (= ?agxy ?agxx)
          (= ?agxy ?agxw)
          )
        (= ?agxx ?agxw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agxz Real)
    (declare-const ?agya Real)
    (declare-const ?agyb Real)
    (declare-const ?agyc Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?agya ?agxz))
                (not (= ?agya ?asi))
                )
              (not (= ?agxz ?asi))
              )
            (or (or (= ?agyc ?agyb)
                (= ?agyc ?asi)
                )
              (= ?agyb ?asi)
              )
            )
          (and (or (or (= ?agya ?agxz)
                (= ?agya ?asi)
                )
              (= ?agxz ?asi)
              )
            (and (and (not (= ?agyc ?agyb))
                (not (= ?agyc ?asi))
                )
              (not (= ?agyb ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agyd Real)
    (declare-const ?agye Real)
    (declare-const ?agyf Real)
    (declare-const ?agyg Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?agye ?agyd))
                (not (= ?agye ?fkf))
                )
              (not (= ?agyd ?fkf))
              )
            (or (or (= ?agyg ?agyf)
                (= ?agyg ?fkf)
                )
              (= ?agyf ?fkf)
              )
            )
          (and (or (or (= ?agye ?agyd)
                (= ?agye ?fkf)
                )
              (= ?agyd ?fkf)
              )
            (and (and (not (= ?agyg ?agyf))
                (not (= ?agyg ?fkf))
                )
              (not (= ?agyf ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agyh Real)
    (declare-const ?agyi Real)
    (declare-const ?agyj Real)
    (declare-const ?agyk Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?agyi ?agyh))
                (not (= ?agyi ?mzs))
                )
              (not (= ?agyh ?mzs))
              )
            (or (or (= ?agyk ?agyj)
                (= ?agyk ?mzs)
                )
              (= ?agyj ?mzs)
              )
            )
          (and (or (or (= ?agyi ?agyh)
                (= ?agyi ?mzs)
                )
              (= ?agyh ?mzs)
              )
            (and (and (not (= ?agyk ?agyj))
                (not (= ?agyk ?mzs))
                )
              (not (= ?agyj ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?agyl Real)
  (declare-const ?agym Real)
  (declare-const ?agyn Real)
  (push 1)
    (declare-const ?agyo Real)
    (declare-const ?agyp Real)
    (declare-const ?agyq Real)
    (assert
      (or (or (= ?agyq ?agyp)
          (= ?agyq ?agyo)
          )
        (= ?agyp ?agyo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agyr Real)
    (declare-const ?agys Real)
    (declare-const ?agyt Real)
    (declare-const ?agyu Real)
    (assert
      (or (or (= ?agyu ?agyt)
          (= ?agyu ?agys)
          )
        (= ?agyt ?agys)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agyv Real)
    (declare-const ?agyw Real)
    (declare-const ?agyx Real)
    (declare-const ?agyy Real)
    (declare-const ?agyz Real)
    (assert
      (or (or (= ?agyz ?agyy)
          (= ?agyz ?agyx)
          )
        (= ?agyy ?agyx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agza Real)
    (declare-const ?agzb Real)
    (declare-const ?agzc Real)
    (declare-const ?agzd Real)
    (declare-const ?agze Real)
    (declare-const ?agzf Real)
    (assert
      (and (and (and (not (= ?agzc ?agzb))
            (not (= ?agzc ?agza))
            )
          (not (= ?agzb ?agza))
          )
        (or (or (= ?agzf ?agze)
            (= ?agzf ?agzd)
            )
          (= ?agze ?agzd)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agzg Real)
    (declare-const ?agzh Real)
    (declare-const ?agzi Real)
    (assert
      (or (or (= ?agzi ?agzh)
          (= ?agzi ?agzg)
          )
        (= ?agzh ?agzg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agzj Real)
    (declare-const ?agzk Real)
    (declare-const ?agzl Real)
    (assert
      (or (or (= ?agzl ?agzk)
          (= ?agzl ?agzj)
          )
        (= ?agzk ?agzj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agzm Real)
    (declare-const ?agzn Real)
    (declare-const ?agzo Real)
    (declare-const ?agzp Real)
    (assert
      (or (or (= ?agzo ?agzn)
          (= ?agzo ?agzm)
          )
        (= ?agzn ?agzm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agzq Real)
    (declare-const ?agzr Real)
    (declare-const ?agzs Real)
    (declare-const ?agzt Real)
    (declare-const ?agzu Real)
    (assert
      (or (or (= ?agzs ?agzr)
          (= ?agzs ?agzq)
          )
        (= ?agzr ?agzq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?agzv Real)
    (declare-const ?agzw Real)
    (declare-const ?agzx Real)
    (declare-const ?agzy Real)
    (declare-const ?agzz Real)
    (declare-const ?ahaa Real)
    (assert
      (and (or (or (= ?agzx ?agzw)
            (= ?agzx ?agzv)
            )
          (= ?agzw ?agzv)
          )
        (and (and (not (= ?ahaa ?agzz))
            (not (= ?ahaa ?agzy))
            )
          (not (= ?agzz ?agzy))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahab Real)
    (declare-const ?ahac Real)
    (declare-const ?ahad Real)
    (assert
      (or (or (= ?ahad ?ahac)
          (= ?ahad ?ahab)
          )
        (= ?ahac ?ahab)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahae Real)
    (declare-const ?ahaf Real)
    (declare-const ?ahag Real)
    (declare-const ?ahah Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ahaf ?ahae))
                (not (= ?ahaf ?asi))
                )
              (not (= ?ahae ?asi))
              )
            (or (or (= ?ahah ?ahag)
                (= ?ahah ?asi)
                )
              (= ?ahag ?asi)
              )
            )
          (and (or (or (= ?ahaf ?ahae)
                (= ?ahaf ?asi)
                )
              (= ?ahae ?asi)
              )
            (and (and (not (= ?ahah ?ahag))
                (not (= ?ahah ?asi))
                )
              (not (= ?ahag ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahai Real)
    (declare-const ?ahaj Real)
    (declare-const ?ahak Real)
    (declare-const ?ahal Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ahaj ?ahai))
                (not (= ?ahaj ?fkf))
                )
              (not (= ?ahai ?fkf))
              )
            (or (or (= ?ahal ?ahak)
                (= ?ahal ?fkf)
                )
              (= ?ahak ?fkf)
              )
            )
          (and (or (or (= ?ahaj ?ahai)
                (= ?ahaj ?fkf)
                )
              (= ?ahai ?fkf)
              )
            (and (and (not (= ?ahal ?ahak))
                (not (= ?ahal ?fkf))
                )
              (not (= ?ahak ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aham Real)
    (declare-const ?ahan Real)
    (declare-const ?ahao Real)
    (declare-const ?ahap Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ahan ?aham))
                (not (= ?ahan ?mzs))
                )
              (not (= ?aham ?mzs))
              )
            (or (or (= ?ahap ?ahao)
                (= ?ahap ?mzs)
                )
              (= ?ahao ?mzs)
              )
            )
          (and (or (or (= ?ahan ?aham)
                (= ?ahan ?mzs)
                )
              (= ?aham ?mzs)
              )
            (and (and (not (= ?ahap ?ahao))
                (not (= ?ahap ?mzs))
                )
              (not (= ?ahao ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ahaq Real)
  (declare-const ?ahar Real)
  (declare-const ?ahas Real)
  (declare-const ?ahat Real)
  (push 1)
    (declare-const ?ahau Real)
    (declare-const ?ahav Real)
    (declare-const ?ahaw Real)
    (assert
      (or (or (= ?ahaw ?ahav)
          (= ?ahaw ?ahau)
          )
        (= ?ahav ?ahau)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahax Real)
    (declare-const ?ahay Real)
    (declare-const ?ahaz Real)
    (declare-const ?ahba Real)
    (assert
      (or (or (= ?ahba ?ahaz)
          (= ?ahba ?ahay)
          )
        (= ?ahaz ?ahay)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahbb Real)
    (declare-const ?ahbc Real)
    (declare-const ?ahbd Real)
    (declare-const ?ahbe Real)
    (declare-const ?ahbf Real)
    (assert
      (or (or (= ?ahbf ?ahbe)
          (= ?ahbf ?ahbd)
          )
        (= ?ahbe ?ahbd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahbg Real)
    (declare-const ?ahbh Real)
    (declare-const ?ahbi Real)
    (declare-const ?ahbj Real)
    (declare-const ?ahbk Real)
    (declare-const ?ahbl Real)
    (assert
      (and (and (and (not (= ?ahbi ?ahbh))
            (not (= ?ahbi ?ahbg))
            )
          (not (= ?ahbh ?ahbg))
          )
        (or (or (= ?ahbl ?ahbk)
            (= ?ahbl ?ahbj)
            )
          (= ?ahbk ?ahbj)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahbm Real)
    (declare-const ?ahbn Real)
    (declare-const ?ahbo Real)
    (assert
      (or (or (= ?ahbo ?ahbn)
          (= ?ahbo ?ahbm)
          )
        (= ?ahbn ?ahbm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahbp Real)
    (declare-const ?ahbq Real)
    (declare-const ?ahbr Real)
    (assert
      (or (or (= ?ahbr ?ahbq)
          (= ?ahbr ?ahbp)
          )
        (= ?ahbq ?ahbp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahbs Real)
    (declare-const ?ahbt Real)
    (declare-const ?ahbu Real)
    (declare-const ?ahbv Real)
    (assert
      (or (or (= ?ahbu ?ahbt)
          (= ?ahbu ?ahbs)
          )
        (= ?ahbt ?ahbs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahbw Real)
    (declare-const ?ahbx Real)
    (declare-const ?ahby Real)
    (declare-const ?ahbz Real)
    (declare-const ?ahca Real)
    (assert
      (or (or (= ?ahby ?ahbx)
          (= ?ahby ?ahbw)
          )
        (= ?ahbx ?ahbw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahcb Real)
    (declare-const ?ahcc Real)
    (declare-const ?ahcd Real)
    (declare-const ?ahce Real)
    (declare-const ?ahcf Real)
    (declare-const ?ahcg Real)
    (assert
      (and (or (or (= ?ahcd ?ahcc)
            (= ?ahcd ?ahcb)
            )
          (= ?ahcc ?ahcb)
          )
        (and (and (not (= ?ahcg ?ahcf))
            (not (= ?ahcg ?ahce))
            )
          (not (= ?ahcf ?ahce))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahch Real)
    (declare-const ?ahci Real)
    (declare-const ?ahcj Real)
    (assert
      (or (or (= ?ahcj ?ahci)
          (= ?ahcj ?ahch)
          )
        (= ?ahci ?ahch)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahck Real)
    (declare-const ?ahcl Real)
    (declare-const ?ahcm Real)
    (declare-const ?ahcn Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ahcl ?ahck))
                (not (= ?ahcl ?asi))
                )
              (not (= ?ahck ?asi))
              )
            (or (or (= ?ahcn ?ahcm)
                (= ?ahcn ?asi)
                )
              (= ?ahcm ?asi)
              )
            )
          (and (or (or (= ?ahcl ?ahck)
                (= ?ahcl ?asi)
                )
              (= ?ahck ?asi)
              )
            (and (and (not (= ?ahcn ?ahcm))
                (not (= ?ahcn ?asi))
                )
              (not (= ?ahcm ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahco Real)
    (declare-const ?ahcp Real)
    (declare-const ?ahcq Real)
    (declare-const ?ahcr Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ahcp ?ahco))
                (not (= ?ahcp ?fkf))
                )
              (not (= ?ahco ?fkf))
              )
            (or (or (= ?ahcr ?ahcq)
                (= ?ahcr ?fkf)
                )
              (= ?ahcq ?fkf)
              )
            )
          (and (or (or (= ?ahcp ?ahco)
                (= ?ahcp ?fkf)
                )
              (= ?ahco ?fkf)
              )
            (and (and (not (= ?ahcr ?ahcq))
                (not (= ?ahcr ?fkf))
                )
              (not (= ?ahcq ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahcs Real)
    (declare-const ?ahct Real)
    (declare-const ?ahcu Real)
    (declare-const ?ahcv Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ahct ?ahcs))
                (not (= ?ahct ?mzs))
                )
              (not (= ?ahcs ?mzs))
              )
            (or (or (= ?ahcv ?ahcu)
                (= ?ahcv ?mzs)
                )
              (= ?ahcu ?mzs)
              )
            )
          (and (or (or (= ?ahct ?ahcs)
                (= ?ahct ?mzs)
                )
              (= ?ahcs ?mzs)
              )
            (and (and (not (= ?ahcv ?ahcu))
                (not (= ?ahcv ?mzs))
                )
              (not (= ?ahcu ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ahcw Real)
  (declare-const ?ahcx Real)
  (declare-const ?ahcy Real)
  (declare-const ?ahcz Real)
  (declare-const ?ahda Real)
  (push 1)
    (declare-const ?ahdb Real)
    (declare-const ?ahdc Real)
    (declare-const ?ahdd Real)
    (assert
      (or (or (= ?ahdd ?ahdc)
          (= ?ahdd ?ahdb)
          )
        (= ?ahdc ?ahdb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahde Real)
    (declare-const ?ahdf Real)
    (declare-const ?ahdg Real)
    (declare-const ?ahdh Real)
    (assert
      (or (or (= ?ahdh ?ahdg)
          (= ?ahdh ?ahdf)
          )
        (= ?ahdg ?ahdf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahdi Real)
    (declare-const ?ahdj Real)
    (declare-const ?ahdk Real)
    (declare-const ?ahdl Real)
    (declare-const ?ahdm Real)
    (assert
      (or (or (= ?ahdm ?ahdl)
          (= ?ahdm ?ahdk)
          )
        (= ?ahdl ?ahdk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahdn Real)
    (declare-const ?ahdo Real)
    (declare-const ?ahdp Real)
    (declare-const ?ahdq Real)
    (declare-const ?ahdr Real)
    (declare-const ?ahds Real)
    (assert
      (and (and (and (not (= ?ahdp ?ahdo))
            (not (= ?ahdp ?ahdn))
            )
          (not (= ?ahdo ?ahdn))
          )
        (or (or (= ?ahds ?ahdr)
            (= ?ahds ?ahdq)
            )
          (= ?ahdr ?ahdq)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahdt Real)
    (declare-const ?ahdu Real)
    (declare-const ?ahdv Real)
    (assert
      (or (or (= ?ahdv ?ahdu)
          (= ?ahdv ?ahdt)
          )
        (= ?ahdu ?ahdt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahdw Real)
    (declare-const ?ahdx Real)
    (declare-const ?ahdy Real)
    (assert
      (or (or (= ?ahdy ?ahdx)
          (= ?ahdy ?ahdw)
          )
        (= ?ahdx ?ahdw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahdz Real)
    (declare-const ?ahea Real)
    (declare-const ?aheb Real)
    (declare-const ?ahec Real)
    (assert
      (or (or (= ?aheb ?ahea)
          (= ?aheb ?ahdz)
          )
        (= ?ahea ?ahdz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahed Real)
    (declare-const ?ahee Real)
    (declare-const ?ahef Real)
    (declare-const ?aheg Real)
    (declare-const ?aheh Real)
    (assert
      (or (or (= ?ahef ?ahee)
          (= ?ahef ?ahed)
          )
        (= ?ahee ?ahed)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahei Real)
    (declare-const ?ahej Real)
    (declare-const ?ahek Real)
    (declare-const ?ahel Real)
    (declare-const ?ahem Real)
    (declare-const ?ahen Real)
    (assert
      (and (or (or (= ?ahek ?ahej)
            (= ?ahek ?ahei)
            )
          (= ?ahej ?ahei)
          )
        (and (and (not (= ?ahen ?ahem))
            (not (= ?ahen ?ahel))
            )
          (not (= ?ahem ?ahel))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aheo Real)
    (declare-const ?ahep Real)
    (declare-const ?aheq Real)
    (assert
      (or (or (= ?aheq ?ahep)
          (= ?aheq ?aheo)
          )
        (= ?ahep ?aheo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aher Real)
    (declare-const ?ahes Real)
    (declare-const ?ahet Real)
    (declare-const ?aheu Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ahes ?aher))
                (not (= ?ahes ?asi))
                )
              (not (= ?aher ?asi))
              )
            (or (or (= ?aheu ?ahet)
                (= ?aheu ?asi)
                )
              (= ?ahet ?asi)
              )
            )
          (and (or (or (= ?ahes ?aher)
                (= ?ahes ?asi)
                )
              (= ?aher ?asi)
              )
            (and (and (not (= ?aheu ?ahet))
                (not (= ?aheu ?asi))
                )
              (not (= ?ahet ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahev Real)
    (declare-const ?ahew Real)
    (declare-const ?ahex Real)
    (declare-const ?ahey Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ahew ?ahev))
                (not (= ?ahew ?fkf))
                )
              (not (= ?ahev ?fkf))
              )
            (or (or (= ?ahey ?ahex)
                (= ?ahey ?fkf)
                )
              (= ?ahex ?fkf)
              )
            )
          (and (or (or (= ?ahew ?ahev)
                (= ?ahew ?fkf)
                )
              (= ?ahev ?fkf)
              )
            (and (and (not (= ?ahey ?ahex))
                (not (= ?ahey ?fkf))
                )
              (not (= ?ahex ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahez Real)
    (declare-const ?ahfa Real)
    (declare-const ?ahfb Real)
    (declare-const ?ahfc Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ahfa ?ahez))
                (not (= ?ahfa ?mzs))
                )
              (not (= ?ahez ?mzs))
              )
            (or (or (= ?ahfc ?ahfb)
                (= ?ahfc ?mzs)
                )
              (= ?ahfb ?mzs)
              )
            )
          (and (or (or (= ?ahfa ?ahez)
                (= ?ahfa ?mzs)
                )
              (= ?ahez ?mzs)
              )
            (and (and (not (= ?ahfc ?ahfb))
                (not (= ?ahfc ?mzs))
                )
              (not (= ?ahfb ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?ahfd Real)
    (declare-const ?ahfe Real)
    (declare-const ?ahff Real)
    (assert
      (or (or (= ?ahff ?ahfe)
          (= ?ahff ?ahfd)
          )
        (= ?ahfe ?ahfd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahfg Real)
    (declare-const ?ahfh Real)
    (declare-const ?ahfi Real)
    (declare-const ?ahfj Real)
    (assert
      (or (or (= ?ahfj ?ahfi)
          (= ?ahfj ?ahfh)
          )
        (= ?ahfi ?ahfh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahfk Real)
    (declare-const ?ahfl Real)
    (declare-const ?ahfm Real)
    (declare-const ?ahfn Real)
    (declare-const ?ahfo Real)
    (assert
      (or (or (= ?ahfo ?ahfn)
          (= ?ahfo ?ahfm)
          )
        (= ?ahfn ?ahfm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahfp Real)
    (declare-const ?ahfq Real)
    (declare-const ?ahfr Real)
    (declare-const ?ahfs Real)
    (declare-const ?ahft Real)
    (declare-const ?ahfu Real)
    (assert
      (and (and (and (not (= ?ahfr ?ahfq))
            (not (= ?ahfr ?ahfp))
            )
          (not (= ?ahfq ?ahfp))
          )
        (or (or (= ?ahfu ?ahft)
            (= ?ahfu ?ahfs)
            )
          (= ?ahft ?ahfs)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahfv Real)
    (declare-const ?ahfw Real)
    (declare-const ?ahfx Real)
    (assert
      (or (or (= ?ahfx ?ahfw)
          (= ?ahfx ?ahfv)
          )
        (= ?ahfw ?ahfv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahfy Real)
    (declare-const ?ahfz Real)
    (declare-const ?ahga Real)
    (assert
      (or (or (= ?ahga ?ahfz)
          (= ?ahga ?ahfy)
          )
        (= ?ahfz ?ahfy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahgb Real)
    (declare-const ?ahgc Real)
    (declare-const ?ahgd Real)
    (declare-const ?ahge Real)
    (assert
      (or (or (= ?ahgd ?ahgc)
          (= ?ahgd ?ahgb)
          )
        (= ?ahgc ?ahgb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahgf Real)
    (declare-const ?ahgg Real)
    (declare-const ?ahgh Real)
    (declare-const ?ahgi Real)
    (declare-const ?ahgj Real)
    (assert
      (or (or (= ?ahgh ?ahgg)
          (= ?ahgh ?ahgf)
          )
        (= ?ahgg ?ahgf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahgk Real)
    (declare-const ?ahgl Real)
    (declare-const ?ahgm Real)
    (declare-const ?ahgn Real)
    (declare-const ?ahgo Real)
    (declare-const ?ahgp Real)
    (assert
      (and (or (or (= ?ahgm ?ahgl)
            (= ?ahgm ?ahgk)
            )
          (= ?ahgl ?ahgk)
          )
        (and (and (not (= ?ahgp ?ahgo))
            (not (= ?ahgp ?ahgn))
            )
          (not (= ?ahgo ?ahgn))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahgq Real)
    (declare-const ?ahgr Real)
    (declare-const ?ahgs Real)
    (assert
      (or (or (= ?ahgs ?ahgr)
          (= ?ahgs ?ahgq)
          )
        (= ?ahgr ?ahgq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahgt Real)
    (declare-const ?ahgu Real)
    (declare-const ?ahgv Real)
    (declare-const ?ahgw Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ahgu ?ahgt))
                (not (= ?ahgu ?asi))
                )
              (not (= ?ahgt ?asi))
              )
            (or (or (= ?ahgw ?ahgv)
                (= ?ahgw ?asi)
                )
              (= ?ahgv ?asi)
              )
            )
          (and (or (or (= ?ahgu ?ahgt)
                (= ?ahgu ?asi)
                )
              (= ?ahgt ?asi)
              )
            (and (and (not (= ?ahgw ?ahgv))
                (not (= ?ahgw ?asi))
                )
              (not (= ?ahgv ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahgx Real)
    (declare-const ?ahgy Real)
    (declare-const ?ahgz Real)
    (declare-const ?ahha Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ahgy ?ahgx))
                (not (= ?ahgy ?fkf))
                )
              (not (= ?ahgx ?fkf))
              )
            (or (or (= ?ahha ?ahgz)
                (= ?ahha ?fkf)
                )
              (= ?ahgz ?fkf)
              )
            )
          (and (or (or (= ?ahgy ?ahgx)
                (= ?ahgy ?fkf)
                )
              (= ?ahgx ?fkf)
              )
            (and (and (not (= ?ahha ?ahgz))
                (not (= ?ahha ?fkf))
                )
              (not (= ?ahgz ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahhb Real)
    (declare-const ?ahhc Real)
    (declare-const ?ahhd Real)
    (declare-const ?ahhe Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ahhc ?ahhb))
                (not (= ?ahhc ?mzs))
                )
              (not (= ?ahhb ?mzs))
              )
            (or (or (= ?ahhe ?ahhd)
                (= ?ahhe ?mzs)
                )
              (= ?ahhd ?mzs)
              )
            )
          (and (or (or (= ?ahhc ?ahhb)
                (= ?ahhc ?mzs)
                )
              (= ?ahhb ?mzs)
              )
            (and (and (not (= ?ahhe ?ahhd))
                (not (= ?ahhe ?mzs))
                )
              (not (= ?ahhd ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ahhf Real)
  (push 1)
    (declare-const ?ahhg Real)
    (declare-const ?ahhh Real)
    (declare-const ?ahhi Real)
    (assert
      (or (or (= ?ahhi ?ahhh)
          (= ?ahhi ?ahhg)
          )
        (= ?ahhh ?ahhg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahhj Real)
    (declare-const ?ahhk Real)
    (declare-const ?ahhl Real)
    (declare-const ?ahhm Real)
    (assert
      (or (or (= ?ahhm ?ahhl)
          (= ?ahhm ?ahhk)
          )
        (= ?ahhl ?ahhk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahhn Real)
    (declare-const ?ahho Real)
    (declare-const ?ahhp Real)
    (declare-const ?ahhq Real)
    (declare-const ?ahhr Real)
    (assert
      (or (or (= ?ahhr ?ahhq)
          (= ?ahhr ?ahhp)
          )
        (= ?ahhq ?ahhp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahhs Real)
    (declare-const ?ahht Real)
    (declare-const ?ahhu Real)
    (declare-const ?ahhv Real)
    (declare-const ?ahhw Real)
    (declare-const ?ahhx Real)
    (assert
      (and (and (and (not (= ?ahhu ?ahht))
            (not (= ?ahhu ?ahhs))
            )
          (not (= ?ahht ?ahhs))
          )
        (or (or (= ?ahhx ?ahhw)
            (= ?ahhx ?ahhv)
            )
          (= ?ahhw ?ahhv)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahhy Real)
    (declare-const ?ahhz Real)
    (declare-const ?ahia Real)
    (assert
      (or (or (= ?ahia ?ahhz)
          (= ?ahia ?ahhy)
          )
        (= ?ahhz ?ahhy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahib Real)
    (declare-const ?ahic Real)
    (declare-const ?ahid Real)
    (assert
      (or (or (= ?ahid ?ahic)
          (= ?ahid ?ahib)
          )
        (= ?ahic ?ahib)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahie Real)
    (declare-const ?ahif Real)
    (declare-const ?ahig Real)
    (declare-const ?ahih Real)
    (assert
      (or (or (= ?ahig ?ahif)
          (= ?ahig ?ahie)
          )
        (= ?ahif ?ahie)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahii Real)
    (declare-const ?ahij Real)
    (declare-const ?ahik Real)
    (declare-const ?ahil Real)
    (declare-const ?ahim Real)
    (assert
      (or (or (= ?ahik ?ahij)
          (= ?ahik ?ahii)
          )
        (= ?ahij ?ahii)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahin Real)
    (declare-const ?ahio Real)
    (declare-const ?ahip Real)
    (declare-const ?ahiq Real)
    (declare-const ?ahir Real)
    (declare-const ?ahis Real)
    (assert
      (and (or (or (= ?ahip ?ahio)
            (= ?ahip ?ahin)
            )
          (= ?ahio ?ahin)
          )
        (and (and (not (= ?ahis ?ahir))
            (not (= ?ahis ?ahiq))
            )
          (not (= ?ahir ?ahiq))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahit Real)
    (declare-const ?ahiu Real)
    (declare-const ?ahiv Real)
    (assert
      (or (or (= ?ahiv ?ahiu)
          (= ?ahiv ?ahit)
          )
        (= ?ahiu ?ahit)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahiw Real)
    (declare-const ?ahix Real)
    (declare-const ?ahiy Real)
    (declare-const ?ahiz Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ahix ?ahiw))
                (not (= ?ahix ?asi))
                )
              (not (= ?ahiw ?asi))
              )
            (or (or (= ?ahiz ?ahiy)
                (= ?ahiz ?asi)
                )
              (= ?ahiy ?asi)
              )
            )
          (and (or (or (= ?ahix ?ahiw)
                (= ?ahix ?asi)
                )
              (= ?ahiw ?asi)
              )
            (and (and (not (= ?ahiz ?ahiy))
                (not (= ?ahiz ?asi))
                )
              (not (= ?ahiy ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahja Real)
    (declare-const ?ahjb Real)
    (declare-const ?ahjc Real)
    (declare-const ?ahjd Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ahjb ?ahja))
                (not (= ?ahjb ?fkf))
                )
              (not (= ?ahja ?fkf))
              )
            (or (or (= ?ahjd ?ahjc)
                (= ?ahjd ?fkf)
                )
              (= ?ahjc ?fkf)
              )
            )
          (and (or (or (= ?ahjb ?ahja)
                (= ?ahjb ?fkf)
                )
              (= ?ahja ?fkf)
              )
            (and (and (not (= ?ahjd ?ahjc))
                (not (= ?ahjd ?fkf))
                )
              (not (= ?ahjc ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahje Real)
    (declare-const ?ahjf Real)
    (declare-const ?ahjg Real)
    (declare-const ?ahjh Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ahjf ?ahje))
                (not (= ?ahjf ?mzs))
                )
              (not (= ?ahje ?mzs))
              )
            (or (or (= ?ahjh ?ahjg)
                (= ?ahjh ?mzs)
                )
              (= ?ahjg ?mzs)
              )
            )
          (and (or (or (= ?ahjf ?ahje)
                (= ?ahjf ?mzs)
                )
              (= ?ahje ?mzs)
              )
            (and (and (not (= ?ahjh ?ahjg))
                (not (= ?ahjh ?mzs))
                )
              (not (= ?ahjg ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ahji Real)
  (declare-const ?ahjj Real)
  (push 1)
    (declare-const ?ahjk Real)
    (declare-const ?ahjl Real)
    (declare-const ?ahjm Real)
    (assert
      (or (or (= ?ahjm ?ahjl)
          (= ?ahjm ?ahjk)
          )
        (= ?ahjl ?ahjk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahjn Real)
    (declare-const ?ahjo Real)
    (declare-const ?ahjp Real)
    (declare-const ?ahjq Real)
    (assert
      (or (or (= ?ahjq ?ahjp)
          (= ?ahjq ?ahjo)
          )
        (= ?ahjp ?ahjo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahjr Real)
    (declare-const ?ahjs Real)
    (declare-const ?ahjt Real)
    (declare-const ?ahju Real)
    (declare-const ?ahjv Real)
    (assert
      (or (or (= ?ahjv ?ahju)
          (= ?ahjv ?ahjt)
          )
        (= ?ahju ?ahjt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahjw Real)
    (declare-const ?ahjx Real)
    (declare-const ?ahjy Real)
    (declare-const ?ahjz Real)
    (declare-const ?ahka Real)
    (declare-const ?ahkb Real)
    (assert
      (and (and (and (not (= ?ahjy ?ahjx))
            (not (= ?ahjy ?ahjw))
            )
          (not (= ?ahjx ?ahjw))
          )
        (or (or (= ?ahkb ?ahka)
            (= ?ahkb ?ahjz)
            )
          (= ?ahka ?ahjz)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahkc Real)
    (declare-const ?ahkd Real)
    (declare-const ?ahke Real)
    (assert
      (or (or (= ?ahke ?ahkd)
          (= ?ahke ?ahkc)
          )
        (= ?ahkd ?ahkc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahkf Real)
    (declare-const ?ahkg Real)
    (declare-const ?ahkh Real)
    (assert
      (or (or (= ?ahkh ?ahkg)
          (= ?ahkh ?ahkf)
          )
        (= ?ahkg ?ahkf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahki Real)
    (declare-const ?ahkj Real)
    (declare-const ?ahkk Real)
    (declare-const ?ahkl Real)
    (assert
      (or (or (= ?ahkk ?ahkj)
          (= ?ahkk ?ahki)
          )
        (= ?ahkj ?ahki)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahkm Real)
    (declare-const ?ahkn Real)
    (declare-const ?ahko Real)
    (declare-const ?ahkp Real)
    (declare-const ?ahkq Real)
    (assert
      (or (or (= ?ahko ?ahkn)
          (= ?ahko ?ahkm)
          )
        (= ?ahkn ?ahkm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahkr Real)
    (declare-const ?ahks Real)
    (declare-const ?ahkt Real)
    (declare-const ?ahku Real)
    (declare-const ?ahkv Real)
    (declare-const ?ahkw Real)
    (assert
      (and (or (or (= ?ahkt ?ahks)
            (= ?ahkt ?ahkr)
            )
          (= ?ahks ?ahkr)
          )
        (and (and (not (= ?ahkw ?ahkv))
            (not (= ?ahkw ?ahku))
            )
          (not (= ?ahkv ?ahku))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahkx Real)
    (declare-const ?ahky Real)
    (declare-const ?ahkz Real)
    (assert
      (or (or (= ?ahkz ?ahky)
          (= ?ahkz ?ahkx)
          )
        (= ?ahky ?ahkx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahla Real)
    (declare-const ?ahlb Real)
    (declare-const ?ahlc Real)
    (declare-const ?ahld Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ahlb ?ahla))
                (not (= ?ahlb ?asi))
                )
              (not (= ?ahla ?asi))
              )
            (or (or (= ?ahld ?ahlc)
                (= ?ahld ?asi)
                )
              (= ?ahlc ?asi)
              )
            )
          (and (or (or (= ?ahlb ?ahla)
                (= ?ahlb ?asi)
                )
              (= ?ahla ?asi)
              )
            (and (and (not (= ?ahld ?ahlc))
                (not (= ?ahld ?asi))
                )
              (not (= ?ahlc ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahle Real)
    (declare-const ?ahlf Real)
    (declare-const ?ahlg Real)
    (declare-const ?ahlh Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ahlf ?ahle))
                (not (= ?ahlf ?fkf))
                )
              (not (= ?ahle ?fkf))
              )
            (or (or (= ?ahlh ?ahlg)
                (= ?ahlh ?fkf)
                )
              (= ?ahlg ?fkf)
              )
            )
          (and (or (or (= ?ahlf ?ahle)
                (= ?ahlf ?fkf)
                )
              (= ?ahle ?fkf)
              )
            (and (and (not (= ?ahlh ?ahlg))
                (not (= ?ahlh ?fkf))
                )
              (not (= ?ahlg ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahli Real)
    (declare-const ?ahlj Real)
    (declare-const ?ahlk Real)
    (declare-const ?ahll Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ahlj ?ahli))
                (not (= ?ahlj ?mzs))
                )
              (not (= ?ahli ?mzs))
              )
            (or (or (= ?ahll ?ahlk)
                (= ?ahll ?mzs)
                )
              (= ?ahlk ?mzs)
              )
            )
          (and (or (or (= ?ahlj ?ahli)
                (= ?ahlj ?mzs)
                )
              (= ?ahli ?mzs)
              )
            (and (and (not (= ?ahll ?ahlk))
                (not (= ?ahll ?mzs))
                )
              (not (= ?ahlk ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ahlm Real)
  (push 1)
    (declare-const ?ahln Real)
    (declare-const ?ahlo Real)
    (declare-const ?ahlp Real)
    (assert
      (or (or (= ?ahlp ?ahlo)
          (= ?ahlp ?ahln)
          )
        (= ?ahlo ?ahln)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahlq Real)
    (declare-const ?ahlr Real)
    (declare-const ?ahls Real)
    (declare-const ?ahlt Real)
    (assert
      (or (or (= ?ahlt ?ahls)
          (= ?ahlt ?ahlr)
          )
        (= ?ahls ?ahlr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahlu Real)
    (declare-const ?ahlv Real)
    (declare-const ?ahlw Real)
    (declare-const ?ahlx Real)
    (declare-const ?ahly Real)
    (assert
      (or (or (= ?ahly ?ahlx)
          (= ?ahly ?ahlw)
          )
        (= ?ahlx ?ahlw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahlz Real)
    (declare-const ?ahma Real)
    (declare-const ?ahmb Real)
    (declare-const ?ahmc Real)
    (declare-const ?ahmd Real)
    (declare-const ?ahme Real)
    (assert
      (and (and (and (not (= ?ahmb ?ahma))
            (not (= ?ahmb ?ahlz))
            )
          (not (= ?ahma ?ahlz))
          )
        (or (or (= ?ahme ?ahmd)
            (= ?ahme ?ahmc)
            )
          (= ?ahmd ?ahmc)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahmf Real)
    (declare-const ?ahmg Real)
    (declare-const ?ahmh Real)
    (assert
      (or (or (= ?ahmh ?ahmg)
          (= ?ahmh ?ahmf)
          )
        (= ?ahmg ?ahmf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahmi Real)
    (declare-const ?ahmj Real)
    (declare-const ?ahmk Real)
    (assert
      (or (or (= ?ahmk ?ahmj)
          (= ?ahmk ?ahmi)
          )
        (= ?ahmj ?ahmi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahml Real)
    (declare-const ?ahmm Real)
    (declare-const ?ahmn Real)
    (declare-const ?ahmo Real)
    (assert
      (or (or (= ?ahmn ?ahmm)
          (= ?ahmn ?ahml)
          )
        (= ?ahmm ?ahml)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahmp Real)
    (declare-const ?ahmq Real)
    (declare-const ?ahmr Real)
    (declare-const ?ahms Real)
    (declare-const ?ahmt Real)
    (assert
      (or (or (= ?ahmr ?ahmq)
          (= ?ahmr ?ahmp)
          )
        (= ?ahmq ?ahmp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahmu Real)
    (declare-const ?ahmv Real)
    (declare-const ?ahmw Real)
    (declare-const ?ahmx Real)
    (declare-const ?ahmy Real)
    (declare-const ?ahmz Real)
    (assert
      (and (or (or (= ?ahmw ?ahmv)
            (= ?ahmw ?ahmu)
            )
          (= ?ahmv ?ahmu)
          )
        (and (and (not (= ?ahmz ?ahmy))
            (not (= ?ahmz ?ahmx))
            )
          (not (= ?ahmy ?ahmx))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahna Real)
    (declare-const ?ahnb Real)
    (declare-const ?ahnc Real)
    (assert
      (or (or (= ?ahnc ?ahnb)
          (= ?ahnc ?ahna)
          )
        (= ?ahnb ?ahna)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahnd Real)
    (declare-const ?ahne Real)
    (declare-const ?ahnf Real)
    (declare-const ?ahng Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ahne ?ahnd))
                (not (= ?ahne ?asi))
                )
              (not (= ?ahnd ?asi))
              )
            (or (or (= ?ahng ?ahnf)
                (= ?ahng ?asi)
                )
              (= ?ahnf ?asi)
              )
            )
          (and (or (or (= ?ahne ?ahnd)
                (= ?ahne ?asi)
                )
              (= ?ahnd ?asi)
              )
            (and (and (not (= ?ahng ?ahnf))
                (not (= ?ahng ?asi))
                )
              (not (= ?ahnf ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahnh Real)
    (declare-const ?ahni Real)
    (declare-const ?ahnj Real)
    (declare-const ?ahnk Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ahni ?ahnh))
                (not (= ?ahni ?fkf))
                )
              (not (= ?ahnh ?fkf))
              )
            (or (or (= ?ahnk ?ahnj)
                (= ?ahnk ?fkf)
                )
              (= ?ahnj ?fkf)
              )
            )
          (and (or (or (= ?ahni ?ahnh)
                (= ?ahni ?fkf)
                )
              (= ?ahnh ?fkf)
              )
            (and (and (not (= ?ahnk ?ahnj))
                (not (= ?ahnk ?fkf))
                )
              (not (= ?ahnj ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahnl Real)
    (declare-const ?ahnm Real)
    (declare-const ?ahnn Real)
    (declare-const ?ahno Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ahnm ?ahnl))
                (not (= ?ahnm ?mzs))
                )
              (not (= ?ahnl ?mzs))
              )
            (or (or (= ?ahno ?ahnn)
                (= ?ahno ?mzs)
                )
              (= ?ahnn ?mzs)
              )
            )
          (and (or (or (= ?ahnm ?ahnl)
                (= ?ahnm ?mzs)
                )
              (= ?ahnl ?mzs)
              )
            (and (and (not (= ?ahno ?ahnn))
                (not (= ?ahno ?mzs))
                )
              (not (= ?ahnn ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ahnp Real)
  (declare-const ?ahnq Real)
  (push 1)
    (declare-const ?ahnr Real)
    (declare-const ?ahns Real)
    (declare-const ?ahnt Real)
    (assert
      (or (or (= ?ahnt ?ahns)
          (= ?ahnt ?ahnr)
          )
        (= ?ahns ?ahnr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahnu Real)
    (declare-const ?ahnv Real)
    (declare-const ?ahnw Real)
    (declare-const ?ahnx Real)
    (assert
      (or (or (= ?ahnx ?ahnw)
          (= ?ahnx ?ahnv)
          )
        (= ?ahnw ?ahnv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahny Real)
    (declare-const ?ahnz Real)
    (declare-const ?ahoa Real)
    (declare-const ?ahob Real)
    (declare-const ?ahoc Real)
    (assert
      (or (or (= ?ahoc ?ahob)
          (= ?ahoc ?ahoa)
          )
        (= ?ahob ?ahoa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahod Real)
    (declare-const ?ahoe Real)
    (declare-const ?ahof Real)
    (declare-const ?ahog Real)
    (declare-const ?ahoh Real)
    (declare-const ?ahoi Real)
    (assert
      (and (and (and (not (= ?ahof ?ahoe))
            (not (= ?ahof ?ahod))
            )
          (not (= ?ahoe ?ahod))
          )
        (or (or (= ?ahoi ?ahoh)
            (= ?ahoi ?ahog)
            )
          (= ?ahoh ?ahog)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahoj Real)
    (declare-const ?ahok Real)
    (declare-const ?ahol Real)
    (assert
      (or (or (= ?ahol ?ahok)
          (= ?ahol ?ahoj)
          )
        (= ?ahok ?ahoj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahom Real)
    (declare-const ?ahon Real)
    (declare-const ?ahoo Real)
    (assert
      (or (or (= ?ahoo ?ahon)
          (= ?ahoo ?ahom)
          )
        (= ?ahon ?ahom)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahop Real)
    (declare-const ?ahoq Real)
    (declare-const ?ahor Real)
    (declare-const ?ahos Real)
    (assert
      (or (or (= ?ahor ?ahoq)
          (= ?ahor ?ahop)
          )
        (= ?ahoq ?ahop)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahot Real)
    (declare-const ?ahou Real)
    (declare-const ?ahov Real)
    (declare-const ?ahow Real)
    (declare-const ?ahox Real)
    (assert
      (or (or (= ?ahov ?ahou)
          (= ?ahov ?ahot)
          )
        (= ?ahou ?ahot)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahoy Real)
    (declare-const ?ahoz Real)
    (declare-const ?ahpa Real)
    (declare-const ?ahpb Real)
    (declare-const ?ahpc Real)
    (declare-const ?ahpd Real)
    (assert
      (and (or (or (= ?ahpa ?ahoz)
            (= ?ahpa ?ahoy)
            )
          (= ?ahoz ?ahoy)
          )
        (and (and (not (= ?ahpd ?ahpc))
            (not (= ?ahpd ?ahpb))
            )
          (not (= ?ahpc ?ahpb))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahpe Real)
    (declare-const ?ahpf Real)
    (declare-const ?ahpg Real)
    (assert
      (or (or (= ?ahpg ?ahpf)
          (= ?ahpg ?ahpe)
          )
        (= ?ahpf ?ahpe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahph Real)
    (declare-const ?ahpi Real)
    (declare-const ?ahpj Real)
    (declare-const ?ahpk Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ahpi ?ahph))
                (not (= ?ahpi ?asi))
                )
              (not (= ?ahph ?asi))
              )
            (or (or (= ?ahpk ?ahpj)
                (= ?ahpk ?asi)
                )
              (= ?ahpj ?asi)
              )
            )
          (and (or (or (= ?ahpi ?ahph)
                (= ?ahpi ?asi)
                )
              (= ?ahph ?asi)
              )
            (and (and (not (= ?ahpk ?ahpj))
                (not (= ?ahpk ?asi))
                )
              (not (= ?ahpj ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahpl Real)
    (declare-const ?ahpm Real)
    (declare-const ?ahpn Real)
    (declare-const ?ahpo Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ahpm ?ahpl))
                (not (= ?ahpm ?fkf))
                )
              (not (= ?ahpl ?fkf))
              )
            (or (or (= ?ahpo ?ahpn)
                (= ?ahpo ?fkf)
                )
              (= ?ahpn ?fkf)
              )
            )
          (and (or (or (= ?ahpm ?ahpl)
                (= ?ahpm ?fkf)
                )
              (= ?ahpl ?fkf)
              )
            (and (and (not (= ?ahpo ?ahpn))
                (not (= ?ahpo ?fkf))
                )
              (not (= ?ahpn ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahpp Real)
    (declare-const ?ahpq Real)
    (declare-const ?ahpr Real)
    (declare-const ?ahps Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ahpq ?ahpp))
                (not (= ?ahpq ?mzs))
                )
              (not (= ?ahpp ?mzs))
              )
            (or (or (= ?ahps ?ahpr)
                (= ?ahps ?mzs)
                )
              (= ?ahpr ?mzs)
              )
            )
          (and (or (or (= ?ahpq ?ahpp)
                (= ?ahpq ?mzs)
                )
              (= ?ahpp ?mzs)
              )
            (and (and (not (= ?ahps ?ahpr))
                (not (= ?ahps ?mzs))
                )
              (not (= ?ahpr ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ahpt Real)
  (declare-const ?ahpu Real)
  (declare-const ?ahpv Real)
  (push 1)
    (declare-const ?ahpw Real)
    (declare-const ?ahpx Real)
    (declare-const ?ahpy Real)
    (assert
      (or (or (= ?ahpy ?ahpx)
          (= ?ahpy ?ahpw)
          )
        (= ?ahpx ?ahpw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahpz Real)
    (declare-const ?ahqa Real)
    (declare-const ?ahqb Real)
    (declare-const ?ahqc Real)
    (assert
      (or (or (= ?ahqc ?ahqb)
          (= ?ahqc ?ahqa)
          )
        (= ?ahqb ?ahqa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahqd Real)
    (declare-const ?ahqe Real)
    (declare-const ?ahqf Real)
    (declare-const ?ahqg Real)
    (declare-const ?ahqh Real)
    (assert
      (or (or (= ?ahqh ?ahqg)
          (= ?ahqh ?ahqf)
          )
        (= ?ahqg ?ahqf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahqi Real)
    (declare-const ?ahqj Real)
    (declare-const ?ahqk Real)
    (declare-const ?ahql Real)
    (declare-const ?ahqm Real)
    (declare-const ?ahqn Real)
    (assert
      (and (and (and (not (= ?ahqk ?ahqj))
            (not (= ?ahqk ?ahqi))
            )
          (not (= ?ahqj ?ahqi))
          )
        (or (or (= ?ahqn ?ahqm)
            (= ?ahqn ?ahql)
            )
          (= ?ahqm ?ahql)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahqo Real)
    (declare-const ?ahqp Real)
    (declare-const ?ahqq Real)
    (assert
      (or (or (= ?ahqq ?ahqp)
          (= ?ahqq ?ahqo)
          )
        (= ?ahqp ?ahqo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahqr Real)
    (declare-const ?ahqs Real)
    (declare-const ?ahqt Real)
    (assert
      (or (or (= ?ahqt ?ahqs)
          (= ?ahqt ?ahqr)
          )
        (= ?ahqs ?ahqr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahqu Real)
    (declare-const ?ahqv Real)
    (declare-const ?ahqw Real)
    (declare-const ?ahqx Real)
    (assert
      (or (or (= ?ahqw ?ahqv)
          (= ?ahqw ?ahqu)
          )
        (= ?ahqv ?ahqu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahqy Real)
    (declare-const ?ahqz Real)
    (declare-const ?ahra Real)
    (declare-const ?ahrb Real)
    (declare-const ?ahrc Real)
    (assert
      (or (or (= ?ahra ?ahqz)
          (= ?ahra ?ahqy)
          )
        (= ?ahqz ?ahqy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahrd Real)
    (declare-const ?ahre Real)
    (declare-const ?ahrf Real)
    (declare-const ?ahrg Real)
    (declare-const ?ahrh Real)
    (declare-const ?ahri Real)
    (assert
      (and (or (or (= ?ahrf ?ahre)
            (= ?ahrf ?ahrd)
            )
          (= ?ahre ?ahrd)
          )
        (and (and (not (= ?ahri ?ahrh))
            (not (= ?ahri ?ahrg))
            )
          (not (= ?ahrh ?ahrg))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahrj Real)
    (declare-const ?ahrk Real)
    (declare-const ?ahrl Real)
    (assert
      (or (or (= ?ahrl ?ahrk)
          (= ?ahrl ?ahrj)
          )
        (= ?ahrk ?ahrj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahrm Real)
    (declare-const ?ahrn Real)
    (declare-const ?ahro Real)
    (declare-const ?ahrp Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ahrn ?ahrm))
                (not (= ?ahrn ?asi))
                )
              (not (= ?ahrm ?asi))
              )
            (or (or (= ?ahrp ?ahro)
                (= ?ahrp ?asi)
                )
              (= ?ahro ?asi)
              )
            )
          (and (or (or (= ?ahrn ?ahrm)
                (= ?ahrn ?asi)
                )
              (= ?ahrm ?asi)
              )
            (and (and (not (= ?ahrp ?ahro))
                (not (= ?ahrp ?asi))
                )
              (not (= ?ahro ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahrq Real)
    (declare-const ?ahrr Real)
    (declare-const ?ahrs Real)
    (declare-const ?ahrt Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ahrr ?ahrq))
                (not (= ?ahrr ?fkf))
                )
              (not (= ?ahrq ?fkf))
              )
            (or (or (= ?ahrt ?ahrs)
                (= ?ahrt ?fkf)
                )
              (= ?ahrs ?fkf)
              )
            )
          (and (or (or (= ?ahrr ?ahrq)
                (= ?ahrr ?fkf)
                )
              (= ?ahrq ?fkf)
              )
            (and (and (not (= ?ahrt ?ahrs))
                (not (= ?ahrt ?fkf))
                )
              (not (= ?ahrs ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahru Real)
    (declare-const ?ahrv Real)
    (declare-const ?ahrw Real)
    (declare-const ?ahrx Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ahrv ?ahru))
                (not (= ?ahrv ?mzs))
                )
              (not (= ?ahru ?mzs))
              )
            (or (or (= ?ahrx ?ahrw)
                (= ?ahrx ?mzs)
                )
              (= ?ahrw ?mzs)
              )
            )
          (and (or (or (= ?ahrv ?ahru)
                (= ?ahrv ?mzs)
                )
              (= ?ahru ?mzs)
              )
            (and (and (not (= ?ahrx ?ahrw))
                (not (= ?ahrx ?mzs))
                )
              (not (= ?ahrw ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?ahry Real)
    (declare-const ?ahrz Real)
    (declare-const ?ahsa Real)
    (assert
      (or (or (= ?ahsa ?ahrz)
          (= ?ahsa ?ahry)
          )
        (= ?ahrz ?ahry)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahsb Real)
    (declare-const ?ahsc Real)
    (declare-const ?ahsd Real)
    (declare-const ?ahse Real)
    (assert
      (or (or (= ?ahse ?ahsd)
          (= ?ahse ?ahsc)
          )
        (= ?ahsd ?ahsc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahsf Real)
    (declare-const ?ahsg Real)
    (declare-const ?ahsh Real)
    (declare-const ?ahsi Real)
    (declare-const ?ahsj Real)
    (assert
      (or (or (= ?ahsj ?ahsi)
          (= ?ahsj ?ahsh)
          )
        (= ?ahsi ?ahsh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahsk Real)
    (declare-const ?ahsl Real)
    (declare-const ?ahsm Real)
    (declare-const ?ahsn Real)
    (declare-const ?ahso Real)
    (declare-const ?ahsp Real)
    (assert
      (and (and (and (not (= ?ahsm ?ahsl))
            (not (= ?ahsm ?ahsk))
            )
          (not (= ?ahsl ?ahsk))
          )
        (or (or (= ?ahsp ?ahso)
            (= ?ahsp ?ahsn)
            )
          (= ?ahso ?ahsn)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahsq Real)
    (declare-const ?ahsr Real)
    (declare-const ?ahss Real)
    (assert
      (or (or (= ?ahss ?ahsr)
          (= ?ahss ?ahsq)
          )
        (= ?ahsr ?ahsq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahst Real)
    (declare-const ?ahsu Real)
    (declare-const ?ahsv Real)
    (assert
      (or (or (= ?ahsv ?ahsu)
          (= ?ahsv ?ahst)
          )
        (= ?ahsu ?ahst)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahsw Real)
    (declare-const ?ahsx Real)
    (declare-const ?ahsy Real)
    (declare-const ?ahsz Real)
    (assert
      (or (or (= ?ahsy ?ahsx)
          (= ?ahsy ?ahsw)
          )
        (= ?ahsx ?ahsw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahta Real)
    (declare-const ?ahtb Real)
    (declare-const ?ahtc Real)
    (declare-const ?ahtd Real)
    (declare-const ?ahte Real)
    (assert
      (or (or (= ?ahtc ?ahtb)
          (= ?ahtc ?ahta)
          )
        (= ?ahtb ?ahta)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahtf Real)
    (declare-const ?ahtg Real)
    (declare-const ?ahth Real)
    (declare-const ?ahti Real)
    (declare-const ?ahtj Real)
    (declare-const ?ahtk Real)
    (assert
      (and (or (or (= ?ahth ?ahtg)
            (= ?ahth ?ahtf)
            )
          (= ?ahtg ?ahtf)
          )
        (and (and (not (= ?ahtk ?ahtj))
            (not (= ?ahtk ?ahti))
            )
          (not (= ?ahtj ?ahti))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahtl Real)
    (declare-const ?ahtm Real)
    (declare-const ?ahtn Real)
    (assert
      (or (or (= ?ahtn ?ahtm)
          (= ?ahtn ?ahtl)
          )
        (= ?ahtm ?ahtl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahto Real)
    (declare-const ?ahtp Real)
    (declare-const ?ahtq Real)
    (declare-const ?ahtr Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ahtp ?ahto))
                (not (= ?ahtp ?asi))
                )
              (not (= ?ahto ?asi))
              )
            (or (or (= ?ahtr ?ahtq)
                (= ?ahtr ?asi)
                )
              (= ?ahtq ?asi)
              )
            )
          (and (or (or (= ?ahtp ?ahto)
                (= ?ahtp ?asi)
                )
              (= ?ahto ?asi)
              )
            (and (and (not (= ?ahtr ?ahtq))
                (not (= ?ahtr ?asi))
                )
              (not (= ?ahtq ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahts Real)
    (declare-const ?ahtt Real)
    (declare-const ?ahtu Real)
    (declare-const ?ahtv Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ahtt ?ahts))
                (not (= ?ahtt ?fkf))
                )
              (not (= ?ahts ?fkf))
              )
            (or (or (= ?ahtv ?ahtu)
                (= ?ahtv ?fkf)
                )
              (= ?ahtu ?fkf)
              )
            )
          (and (or (or (= ?ahtt ?ahts)
                (= ?ahtt ?fkf)
                )
              (= ?ahts ?fkf)
              )
            (and (and (not (= ?ahtv ?ahtu))
                (not (= ?ahtv ?fkf))
                )
              (not (= ?ahtu ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahtw Real)
    (declare-const ?ahtx Real)
    (declare-const ?ahty Real)
    (declare-const ?ahtz Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ahtx ?ahtw))
                (not (= ?ahtx ?mzs))
                )
              (not (= ?ahtw ?mzs))
              )
            (or (or (= ?ahtz ?ahty)
                (= ?ahtz ?mzs)
                )
              (= ?ahty ?mzs)
              )
            )
          (and (or (or (= ?ahtx ?ahtw)
                (= ?ahtx ?mzs)
                )
              (= ?ahtw ?mzs)
              )
            (and (and (not (= ?ahtz ?ahty))
                (not (= ?ahtz ?mzs))
                )
              (not (= ?ahty ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ahua Real)
  (push 1)
    (declare-const ?ahub Real)
    (declare-const ?ahuc Real)
    (declare-const ?ahud Real)
    (assert
      (or (or (= ?ahud ?ahuc)
          (= ?ahud ?ahub)
          )
        (= ?ahuc ?ahub)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahue Real)
    (declare-const ?ahuf Real)
    (declare-const ?ahug Real)
    (declare-const ?ahuh Real)
    (assert
      (or (or (= ?ahuh ?ahug)
          (= ?ahuh ?ahuf)
          )
        (= ?ahug ?ahuf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahui Real)
    (declare-const ?ahuj Real)
    (declare-const ?ahuk Real)
    (declare-const ?ahul Real)
    (declare-const ?ahum Real)
    (assert
      (or (or (= ?ahum ?ahul)
          (= ?ahum ?ahuk)
          )
        (= ?ahul ?ahuk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahun Real)
    (declare-const ?ahuo Real)
    (declare-const ?ahup Real)
    (declare-const ?ahuq Real)
    (declare-const ?ahur Real)
    (declare-const ?ahus Real)
    (assert
      (and (and (and (not (= ?ahup ?ahuo))
            (not (= ?ahup ?ahun))
            )
          (not (= ?ahuo ?ahun))
          )
        (or (or (= ?ahus ?ahur)
            (= ?ahus ?ahuq)
            )
          (= ?ahur ?ahuq)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahut Real)
    (declare-const ?ahuu Real)
    (declare-const ?ahuv Real)
    (assert
      (or (or (= ?ahuv ?ahuu)
          (= ?ahuv ?ahut)
          )
        (= ?ahuu ?ahut)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahuw Real)
    (declare-const ?ahux Real)
    (declare-const ?ahuy Real)
    (assert
      (or (or (= ?ahuy ?ahux)
          (= ?ahuy ?ahuw)
          )
        (= ?ahux ?ahuw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahuz Real)
    (declare-const ?ahva Real)
    (declare-const ?ahvb Real)
    (declare-const ?ahvc Real)
    (assert
      (or (or (= ?ahvb ?ahva)
          (= ?ahvb ?ahuz)
          )
        (= ?ahva ?ahuz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahvd Real)
    (declare-const ?ahve Real)
    (declare-const ?ahvf Real)
    (declare-const ?ahvg Real)
    (declare-const ?ahvh Real)
    (assert
      (or (or (= ?ahvf ?ahve)
          (= ?ahvf ?ahvd)
          )
        (= ?ahve ?ahvd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahvi Real)
    (declare-const ?ahvj Real)
    (declare-const ?ahvk Real)
    (declare-const ?ahvl Real)
    (declare-const ?ahvm Real)
    (declare-const ?ahvn Real)
    (assert
      (and (or (or (= ?ahvk ?ahvj)
            (= ?ahvk ?ahvi)
            )
          (= ?ahvj ?ahvi)
          )
        (and (and (not (= ?ahvn ?ahvm))
            (not (= ?ahvn ?ahvl))
            )
          (not (= ?ahvm ?ahvl))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahvo Real)
    (declare-const ?ahvp Real)
    (declare-const ?ahvq Real)
    (assert
      (or (or (= ?ahvq ?ahvp)
          (= ?ahvq ?ahvo)
          )
        (= ?ahvp ?ahvo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahvr Real)
    (declare-const ?ahvs Real)
    (declare-const ?ahvt Real)
    (declare-const ?ahvu Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ahvs ?ahvr))
                (not (= ?ahvs ?asi))
                )
              (not (= ?ahvr ?asi))
              )
            (or (or (= ?ahvu ?ahvt)
                (= ?ahvu ?asi)
                )
              (= ?ahvt ?asi)
              )
            )
          (and (or (or (= ?ahvs ?ahvr)
                (= ?ahvs ?asi)
                )
              (= ?ahvr ?asi)
              )
            (and (and (not (= ?ahvu ?ahvt))
                (not (= ?ahvu ?asi))
                )
              (not (= ?ahvt ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahvv Real)
    (declare-const ?ahvw Real)
    (declare-const ?ahvx Real)
    (declare-const ?ahvy Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ahvw ?ahvv))
                (not (= ?ahvw ?fkf))
                )
              (not (= ?ahvv ?fkf))
              )
            (or (or (= ?ahvy ?ahvx)
                (= ?ahvy ?fkf)
                )
              (= ?ahvx ?fkf)
              )
            )
          (and (or (or (= ?ahvw ?ahvv)
                (= ?ahvw ?fkf)
                )
              (= ?ahvv ?fkf)
              )
            (and (and (not (= ?ahvy ?ahvx))
                (not (= ?ahvy ?fkf))
                )
              (not (= ?ahvx ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahvz Real)
    (declare-const ?ahwa Real)
    (declare-const ?ahwb Real)
    (declare-const ?ahwc Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ahwa ?ahvz))
                (not (= ?ahwa ?mzs))
                )
              (not (= ?ahvz ?mzs))
              )
            (or (or (= ?ahwc ?ahwb)
                (= ?ahwc ?mzs)
                )
              (= ?ahwb ?mzs)
              )
            )
          (and (or (or (= ?ahwa ?ahvz)
                (= ?ahwa ?mzs)
                )
              (= ?ahvz ?mzs)
              )
            (and (and (not (= ?ahwc ?ahwb))
                (not (= ?ahwc ?mzs))
                )
              (not (= ?ahwb ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ahwd Real)
  (declare-const ?ahwe Real)
  (assert
    (not (= ?ahwd ?ahwe))
    )
  (push 1)
    (declare-const ?ahwf Real)
    (declare-const ?ahwg Real)
    (declare-const ?ahwh Real)
    (assert
      (or (or (= ?ahwh ?ahwg)
          (= ?ahwh ?ahwf)
          )
        (= ?ahwg ?ahwf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahwi Real)
    (declare-const ?ahwj Real)
    (declare-const ?ahwk Real)
    (declare-const ?ahwl Real)
    (assert
      (or (or (= ?ahwl ?ahwk)
          (= ?ahwl ?ahwj)
          )
        (= ?ahwk ?ahwj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahwm Real)
    (declare-const ?ahwn Real)
    (declare-const ?ahwo Real)
    (declare-const ?ahwp Real)
    (declare-const ?ahwq Real)
    (assert
      (or (or (= ?ahwq ?ahwp)
          (= ?ahwq ?ahwo)
          )
        (= ?ahwp ?ahwo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahwr Real)
    (declare-const ?ahws Real)
    (declare-const ?ahwt Real)
    (declare-const ?ahwu Real)
    (declare-const ?ahwv Real)
    (declare-const ?ahww Real)
    (assert
      (and (and (and (not (= ?ahwt ?ahws))
            (not (= ?ahwt ?ahwr))
            )
          (not (= ?ahws ?ahwr))
          )
        (or (or (= ?ahww ?ahwv)
            (= ?ahww ?ahwu)
            )
          (= ?ahwv ?ahwu)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahwx Real)
    (declare-const ?ahwy Real)
    (declare-const ?ahwz Real)
    (assert
      (or (or (= ?ahwz ?ahwy)
          (= ?ahwz ?ahwx)
          )
        (= ?ahwy ?ahwx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahxa Real)
    (declare-const ?ahxb Real)
    (declare-const ?ahxc Real)
    (assert
      (or (or (= ?ahxc ?ahxb)
          (= ?ahxc ?ahxa)
          )
        (= ?ahxb ?ahxa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahxd Real)
    (declare-const ?ahxe Real)
    (declare-const ?ahxf Real)
    (declare-const ?ahxg Real)
    (assert
      (or (or (= ?ahxf ?ahxe)
          (= ?ahxf ?ahxd)
          )
        (= ?ahxe ?ahxd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahxh Real)
    (declare-const ?ahxi Real)
    (declare-const ?ahxj Real)
    (declare-const ?ahxk Real)
    (declare-const ?ahxl Real)
    (assert
      (or (or (= ?ahxj ?ahxi)
          (= ?ahxj ?ahxh)
          )
        (= ?ahxi ?ahxh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahxm Real)
    (declare-const ?ahxn Real)
    (declare-const ?ahxo Real)
    (declare-const ?ahxp Real)
    (declare-const ?ahxq Real)
    (declare-const ?ahxr Real)
    (assert
      (and (or (or (= ?ahxo ?ahxn)
            (= ?ahxo ?ahxm)
            )
          (= ?ahxn ?ahxm)
          )
        (and (and (not (= ?ahxr ?ahxq))
            (not (= ?ahxr ?ahxp))
            )
          (not (= ?ahxq ?ahxp))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahxs Real)
    (declare-const ?ahxt Real)
    (declare-const ?ahxu Real)
    (assert
      (or (or (= ?ahxu ?ahxt)
          (= ?ahxu ?ahxs)
          )
        (= ?ahxt ?ahxs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahxv Real)
    (declare-const ?ahxw Real)
    (declare-const ?ahxx Real)
    (declare-const ?ahxy Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ahxw ?ahxv))
                (not (= ?ahxw ?asi))
                )
              (not (= ?ahxv ?asi))
              )
            (or (or (= ?ahxy ?ahxx)
                (= ?ahxy ?asi)
                )
              (= ?ahxx ?asi)
              )
            )
          (and (or (or (= ?ahxw ?ahxv)
                (= ?ahxw ?asi)
                )
              (= ?ahxv ?asi)
              )
            (and (and (not (= ?ahxy ?ahxx))
                (not (= ?ahxy ?asi))
                )
              (not (= ?ahxx ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahxz Real)
    (declare-const ?ahya Real)
    (declare-const ?ahyb Real)
    (declare-const ?ahyc Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ahya ?ahxz))
                (not (= ?ahya ?fkf))
                )
              (not (= ?ahxz ?fkf))
              )
            (or (or (= ?ahyc ?ahyb)
                (= ?ahyc ?fkf)
                )
              (= ?ahyb ?fkf)
              )
            )
          (and (or (or (= ?ahya ?ahxz)
                (= ?ahya ?fkf)
                )
              (= ?ahxz ?fkf)
              )
            (and (and (not (= ?ahyc ?ahyb))
                (not (= ?ahyc ?fkf))
                )
              (not (= ?ahyb ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahyd Real)
    (declare-const ?ahye Real)
    (declare-const ?ahyf Real)
    (declare-const ?ahyg Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ahye ?ahyd))
                (not (= ?ahye ?mzs))
                )
              (not (= ?ahyd ?mzs))
              )
            (or (or (= ?ahyg ?ahyf)
                (= ?ahyg ?mzs)
                )
              (= ?ahyf ?mzs)
              )
            )
          (and (or (or (= ?ahye ?ahyd)
                (= ?ahye ?mzs)
                )
              (= ?ahyd ?mzs)
              )
            (and (and (not (= ?ahyg ?ahyf))
                (not (= ?ahyg ?mzs))
                )
              (not (= ?ahyf ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ahyh Real)
  (declare-const ?ahyi Real)
  (declare-const ?ahyj Real)
  (push 1)
    (declare-const ?ahyk Real)
    (declare-const ?ahyl Real)
    (declare-const ?ahym Real)
    (assert
      (or (or (= ?ahym ?ahyl)
          (= ?ahym ?ahyk)
          )
        (= ?ahyl ?ahyk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahyn Real)
    (declare-const ?ahyo Real)
    (declare-const ?ahyp Real)
    (declare-const ?ahyq Real)
    (assert
      (or (or (= ?ahyq ?ahyp)
          (= ?ahyq ?ahyo)
          )
        (= ?ahyp ?ahyo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahyr Real)
    (declare-const ?ahys Real)
    (declare-const ?ahyt Real)
    (declare-const ?ahyu Real)
    (declare-const ?ahyv Real)
    (assert
      (or (or (= ?ahyv ?ahyu)
          (= ?ahyv ?ahyt)
          )
        (= ?ahyu ?ahyt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahyw Real)
    (declare-const ?ahyx Real)
    (declare-const ?ahyy Real)
    (declare-const ?ahyz Real)
    (declare-const ?ahza Real)
    (declare-const ?ahzb Real)
    (assert
      (and (and (and (not (= ?ahyy ?ahyx))
            (not (= ?ahyy ?ahyw))
            )
          (not (= ?ahyx ?ahyw))
          )
        (or (or (= ?ahzb ?ahza)
            (= ?ahzb ?ahyz)
            )
          (= ?ahza ?ahyz)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahzc Real)
    (declare-const ?ahzd Real)
    (declare-const ?ahze Real)
    (assert
      (or (or (= ?ahze ?ahzd)
          (= ?ahze ?ahzc)
          )
        (= ?ahzd ?ahzc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahzf Real)
    (declare-const ?ahzg Real)
    (declare-const ?ahzh Real)
    (assert
      (or (or (= ?ahzh ?ahzg)
          (= ?ahzh ?ahzf)
          )
        (= ?ahzg ?ahzf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahzi Real)
    (declare-const ?ahzj Real)
    (declare-const ?ahzk Real)
    (declare-const ?ahzl Real)
    (assert
      (or (or (= ?ahzk ?ahzj)
          (= ?ahzk ?ahzi)
          )
        (= ?ahzj ?ahzi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahzm Real)
    (declare-const ?ahzn Real)
    (declare-const ?ahzo Real)
    (declare-const ?ahzp Real)
    (declare-const ?ahzq Real)
    (assert
      (or (or (= ?ahzo ?ahzn)
          (= ?ahzo ?ahzm)
          )
        (= ?ahzn ?ahzm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahzr Real)
    (declare-const ?ahzs Real)
    (declare-const ?ahzt Real)
    (declare-const ?ahzu Real)
    (declare-const ?ahzv Real)
    (declare-const ?ahzw Real)
    (assert
      (and (or (or (= ?ahzt ?ahzs)
            (= ?ahzt ?ahzr)
            )
          (= ?ahzs ?ahzr)
          )
        (and (and (not (= ?ahzw ?ahzv))
            (not (= ?ahzw ?ahzu))
            )
          (not (= ?ahzv ?ahzu))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ahzx Real)
    (declare-const ?ahzy Real)
    (declare-const ?ahzz Real)
    (assert
      (or (or (= ?ahzz ?ahzy)
          (= ?ahzz ?ahzx)
          )
        (= ?ahzy ?ahzx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiaa Real)
    (declare-const ?aiab Real)
    (declare-const ?aiac Real)
    (declare-const ?aiad Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aiab ?aiaa))
                (not (= ?aiab ?asi))
                )
              (not (= ?aiaa ?asi))
              )
            (or (or (= ?aiad ?aiac)
                (= ?aiad ?asi)
                )
              (= ?aiac ?asi)
              )
            )
          (and (or (or (= ?aiab ?aiaa)
                (= ?aiab ?asi)
                )
              (= ?aiaa ?asi)
              )
            (and (and (not (= ?aiad ?aiac))
                (not (= ?aiad ?asi))
                )
              (not (= ?aiac ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiae Real)
    (declare-const ?aiaf Real)
    (declare-const ?aiag Real)
    (declare-const ?aiah Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aiaf ?aiae))
                (not (= ?aiaf ?fkf))
                )
              (not (= ?aiae ?fkf))
              )
            (or (or (= ?aiah ?aiag)
                (= ?aiah ?fkf)
                )
              (= ?aiag ?fkf)
              )
            )
          (and (or (or (= ?aiaf ?aiae)
                (= ?aiaf ?fkf)
                )
              (= ?aiae ?fkf)
              )
            (and (and (not (= ?aiah ?aiag))
                (not (= ?aiah ?fkf))
                )
              (not (= ?aiag ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiai Real)
    (declare-const ?aiaj Real)
    (declare-const ?aiak Real)
    (declare-const ?aial Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aiaj ?aiai))
                (not (= ?aiaj ?mzs))
                )
              (not (= ?aiai ?mzs))
              )
            (or (or (= ?aial ?aiak)
                (= ?aial ?mzs)
                )
              (= ?aiak ?mzs)
              )
            )
          (and (or (or (= ?aiaj ?aiai)
                (= ?aiaj ?mzs)
                )
              (= ?aiai ?mzs)
              )
            (and (and (not (= ?aial ?aiak))
                (not (= ?aial ?mzs))
                )
              (not (= ?aiak ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aiam Real)
  (declare-const ?aian Real)
  (declare-const ?aiao Real)
  (declare-const ?aiap Real)
  (push 1)
    (declare-const ?aiaq Real)
    (declare-const ?aiar Real)
    (declare-const ?aias Real)
    (assert
      (or (or (= ?aias ?aiar)
          (= ?aias ?aiaq)
          )
        (= ?aiar ?aiaq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiat Real)
    (declare-const ?aiau Real)
    (declare-const ?aiav Real)
    (declare-const ?aiaw Real)
    (assert
      (or (or (= ?aiaw ?aiav)
          (= ?aiaw ?aiau)
          )
        (= ?aiav ?aiau)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiax Real)
    (declare-const ?aiay Real)
    (declare-const ?aiaz Real)
    (declare-const ?aiba Real)
    (declare-const ?aibb Real)
    (assert
      (or (or (= ?aibb ?aiba)
          (= ?aibb ?aiaz)
          )
        (= ?aiba ?aiaz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aibc Real)
    (declare-const ?aibd Real)
    (declare-const ?aibe Real)
    (declare-const ?aibf Real)
    (declare-const ?aibg Real)
    (declare-const ?aibh Real)
    (assert
      (and (and (and (not (= ?aibe ?aibd))
            (not (= ?aibe ?aibc))
            )
          (not (= ?aibd ?aibc))
          )
        (or (or (= ?aibh ?aibg)
            (= ?aibh ?aibf)
            )
          (= ?aibg ?aibf)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aibi Real)
    (declare-const ?aibj Real)
    (declare-const ?aibk Real)
    (assert
      (or (or (= ?aibk ?aibj)
          (= ?aibk ?aibi)
          )
        (= ?aibj ?aibi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aibl Real)
    (declare-const ?aibm Real)
    (declare-const ?aibn Real)
    (assert
      (or (or (= ?aibn ?aibm)
          (= ?aibn ?aibl)
          )
        (= ?aibm ?aibl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aibo Real)
    (declare-const ?aibp Real)
    (declare-const ?aibq Real)
    (declare-const ?aibr Real)
    (assert
      (or (or (= ?aibq ?aibp)
          (= ?aibq ?aibo)
          )
        (= ?aibp ?aibo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aibs Real)
    (declare-const ?aibt Real)
    (declare-const ?aibu Real)
    (declare-const ?aibv Real)
    (declare-const ?aibw Real)
    (assert
      (or (or (= ?aibu ?aibt)
          (= ?aibu ?aibs)
          )
        (= ?aibt ?aibs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aibx Real)
    (declare-const ?aiby Real)
    (declare-const ?aibz Real)
    (declare-const ?aica Real)
    (declare-const ?aicb Real)
    (declare-const ?aicc Real)
    (assert
      (and (or (or (= ?aibz ?aiby)
            (= ?aibz ?aibx)
            )
          (= ?aiby ?aibx)
          )
        (and (and (not (= ?aicc ?aicb))
            (not (= ?aicc ?aica))
            )
          (not (= ?aicb ?aica))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aicd Real)
    (declare-const ?aice Real)
    (declare-const ?aicf Real)
    (assert
      (or (or (= ?aicf ?aice)
          (= ?aicf ?aicd)
          )
        (= ?aice ?aicd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aicg Real)
    (declare-const ?aich Real)
    (declare-const ?aici Real)
    (declare-const ?aicj Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aich ?aicg))
                (not (= ?aich ?asi))
                )
              (not (= ?aicg ?asi))
              )
            (or (or (= ?aicj ?aici)
                (= ?aicj ?asi)
                )
              (= ?aici ?asi)
              )
            )
          (and (or (or (= ?aich ?aicg)
                (= ?aich ?asi)
                )
              (= ?aicg ?asi)
              )
            (and (and (not (= ?aicj ?aici))
                (not (= ?aicj ?asi))
                )
              (not (= ?aici ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aick Real)
    (declare-const ?aicl Real)
    (declare-const ?aicm Real)
    (declare-const ?aicn Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aicl ?aick))
                (not (= ?aicl ?fkf))
                )
              (not (= ?aick ?fkf))
              )
            (or (or (= ?aicn ?aicm)
                (= ?aicn ?fkf)
                )
              (= ?aicm ?fkf)
              )
            )
          (and (or (or (= ?aicl ?aick)
                (= ?aicl ?fkf)
                )
              (= ?aick ?fkf)
              )
            (and (and (not (= ?aicn ?aicm))
                (not (= ?aicn ?fkf))
                )
              (not (= ?aicm ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aico Real)
    (declare-const ?aicp Real)
    (declare-const ?aicq Real)
    (declare-const ?aicr Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aicp ?aico))
                (not (= ?aicp ?mzs))
                )
              (not (= ?aico ?mzs))
              )
            (or (or (= ?aicr ?aicq)
                (= ?aicr ?mzs)
                )
              (= ?aicq ?mzs)
              )
            )
          (and (or (or (= ?aicp ?aico)
                (= ?aicp ?mzs)
                )
              (= ?aico ?mzs)
              )
            (and (and (not (= ?aicr ?aicq))
                (not (= ?aicr ?mzs))
                )
              (not (= ?aicq ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aics Real)
  (push 1)
    (declare-const ?aict Real)
    (declare-const ?aicu Real)
    (declare-const ?aicv Real)
    (assert
      (or (or (= ?aicv ?aicu)
          (= ?aicv ?aict)
          )
        (= ?aicu ?aict)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aicw Real)
    (declare-const ?aicx Real)
    (declare-const ?aicy Real)
    (declare-const ?aicz Real)
    (assert
      (or (or (= ?aicz ?aicy)
          (= ?aicz ?aicx)
          )
        (= ?aicy ?aicx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aida Real)
    (declare-const ?aidb Real)
    (declare-const ?aidc Real)
    (declare-const ?aidd Real)
    (declare-const ?aide Real)
    (assert
      (or (or (= ?aide ?aidd)
          (= ?aide ?aidc)
          )
        (= ?aidd ?aidc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aidf Real)
    (declare-const ?aidg Real)
    (declare-const ?aidh Real)
    (declare-const ?aidi Real)
    (declare-const ?aidj Real)
    (declare-const ?aidk Real)
    (assert
      (and (and (and (not (= ?aidh ?aidg))
            (not (= ?aidh ?aidf))
            )
          (not (= ?aidg ?aidf))
          )
        (or (or (= ?aidk ?aidj)
            (= ?aidk ?aidi)
            )
          (= ?aidj ?aidi)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aidl Real)
    (declare-const ?aidm Real)
    (declare-const ?aidn Real)
    (assert
      (or (or (= ?aidn ?aidm)
          (= ?aidn ?aidl)
          )
        (= ?aidm ?aidl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aido Real)
    (declare-const ?aidp Real)
    (declare-const ?aidq Real)
    (assert
      (or (or (= ?aidq ?aidp)
          (= ?aidq ?aido)
          )
        (= ?aidp ?aido)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aidr Real)
    (declare-const ?aids Real)
    (declare-const ?aidt Real)
    (declare-const ?aidu Real)
    (assert
      (or (or (= ?aidt ?aids)
          (= ?aidt ?aidr)
          )
        (= ?aids ?aidr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aidv Real)
    (declare-const ?aidw Real)
    (declare-const ?aidx Real)
    (declare-const ?aidy Real)
    (declare-const ?aidz Real)
    (assert
      (or (or (= ?aidx ?aidw)
          (= ?aidx ?aidv)
          )
        (= ?aidw ?aidv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiea Real)
    (declare-const ?aieb Real)
    (declare-const ?aiec Real)
    (declare-const ?aied Real)
    (declare-const ?aiee Real)
    (declare-const ?aief Real)
    (assert
      (and (or (or (= ?aiec ?aieb)
            (= ?aiec ?aiea)
            )
          (= ?aieb ?aiea)
          )
        (and (and (not (= ?aief ?aiee))
            (not (= ?aief ?aied))
            )
          (not (= ?aiee ?aied))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aieg Real)
    (declare-const ?aieh Real)
    (declare-const ?aiei Real)
    (assert
      (or (or (= ?aiei ?aieh)
          (= ?aiei ?aieg)
          )
        (= ?aieh ?aieg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiej Real)
    (declare-const ?aiek Real)
    (declare-const ?aiel Real)
    (declare-const ?aiem Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aiek ?aiej))
                (not (= ?aiek ?asi))
                )
              (not (= ?aiej ?asi))
              )
            (or (or (= ?aiem ?aiel)
                (= ?aiem ?asi)
                )
              (= ?aiel ?asi)
              )
            )
          (and (or (or (= ?aiek ?aiej)
                (= ?aiek ?asi)
                )
              (= ?aiej ?asi)
              )
            (and (and (not (= ?aiem ?aiel))
                (not (= ?aiem ?asi))
                )
              (not (= ?aiel ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aien Real)
    (declare-const ?aieo Real)
    (declare-const ?aiep Real)
    (declare-const ?aieq Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aieo ?aien))
                (not (= ?aieo ?fkf))
                )
              (not (= ?aien ?fkf))
              )
            (or (or (= ?aieq ?aiep)
                (= ?aieq ?fkf)
                )
              (= ?aiep ?fkf)
              )
            )
          (and (or (or (= ?aieo ?aien)
                (= ?aieo ?fkf)
                )
              (= ?aien ?fkf)
              )
            (and (and (not (= ?aieq ?aiep))
                (not (= ?aieq ?fkf))
                )
              (not (= ?aiep ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aier Real)
    (declare-const ?aies Real)
    (declare-const ?aiet Real)
    (declare-const ?aieu Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aies ?aier))
                (not (= ?aies ?mzs))
                )
              (not (= ?aier ?mzs))
              )
            (or (or (= ?aieu ?aiet)
                (= ?aieu ?mzs)
                )
              (= ?aiet ?mzs)
              )
            )
          (and (or (or (= ?aies ?aier)
                (= ?aies ?mzs)
                )
              (= ?aier ?mzs)
              )
            (and (and (not (= ?aieu ?aiet))
                (not (= ?aieu ?mzs))
                )
              (not (= ?aiet ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aiev Real)
  (declare-const ?aiew Real)
  (push 1)
    (declare-const ?aiex Real)
    (declare-const ?aiey Real)
    (declare-const ?aiez Real)
    (assert
      (or (or (= ?aiez ?aiey)
          (= ?aiez ?aiex)
          )
        (= ?aiey ?aiex)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aifa Real)
    (declare-const ?aifb Real)
    (declare-const ?aifc Real)
    (declare-const ?aifd Real)
    (assert
      (or (or (= ?aifd ?aifc)
          (= ?aifd ?aifb)
          )
        (= ?aifc ?aifb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aife Real)
    (declare-const ?aiff Real)
    (declare-const ?aifg Real)
    (declare-const ?aifh Real)
    (declare-const ?aifi Real)
    (assert
      (or (or (= ?aifi ?aifh)
          (= ?aifi ?aifg)
          )
        (= ?aifh ?aifg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aifj Real)
    (declare-const ?aifk Real)
    (declare-const ?aifl Real)
    (declare-const ?aifm Real)
    (declare-const ?aifn Real)
    (declare-const ?aifo Real)
    (assert
      (and (and (and (not (= ?aifl ?aifk))
            (not (= ?aifl ?aifj))
            )
          (not (= ?aifk ?aifj))
          )
        (or (or (= ?aifo ?aifn)
            (= ?aifo ?aifm)
            )
          (= ?aifn ?aifm)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aifp Real)
    (declare-const ?aifq Real)
    (declare-const ?aifr Real)
    (assert
      (or (or (= ?aifr ?aifq)
          (= ?aifr ?aifp)
          )
        (= ?aifq ?aifp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aifs Real)
    (declare-const ?aift Real)
    (declare-const ?aifu Real)
    (assert
      (or (or (= ?aifu ?aift)
          (= ?aifu ?aifs)
          )
        (= ?aift ?aifs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aifv Real)
    (declare-const ?aifw Real)
    (declare-const ?aifx Real)
    (declare-const ?aify Real)
    (assert
      (or (or (= ?aifx ?aifw)
          (= ?aifx ?aifv)
          )
        (= ?aifw ?aifv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aifz Real)
    (declare-const ?aiga Real)
    (declare-const ?aigb Real)
    (declare-const ?aigc Real)
    (declare-const ?aigd Real)
    (assert
      (or (or (= ?aigb ?aiga)
          (= ?aigb ?aifz)
          )
        (= ?aiga ?aifz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aige Real)
    (declare-const ?aigf Real)
    (declare-const ?aigg Real)
    (declare-const ?aigh Real)
    (declare-const ?aigi Real)
    (declare-const ?aigj Real)
    (assert
      (and (or (or (= ?aigg ?aigf)
            (= ?aigg ?aige)
            )
          (= ?aigf ?aige)
          )
        (and (and (not (= ?aigj ?aigi))
            (not (= ?aigj ?aigh))
            )
          (not (= ?aigi ?aigh))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aigk Real)
    (declare-const ?aigl Real)
    (declare-const ?aigm Real)
    (assert
      (or (or (= ?aigm ?aigl)
          (= ?aigm ?aigk)
          )
        (= ?aigl ?aigk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aign Real)
    (declare-const ?aigo Real)
    (declare-const ?aigp Real)
    (declare-const ?aigq Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aigo ?aign))
                (not (= ?aigo ?asi))
                )
              (not (= ?aign ?asi))
              )
            (or (or (= ?aigq ?aigp)
                (= ?aigq ?asi)
                )
              (= ?aigp ?asi)
              )
            )
          (and (or (or (= ?aigo ?aign)
                (= ?aigo ?asi)
                )
              (= ?aign ?asi)
              )
            (and (and (not (= ?aigq ?aigp))
                (not (= ?aigq ?asi))
                )
              (not (= ?aigp ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aigr Real)
    (declare-const ?aigs Real)
    (declare-const ?aigt Real)
    (declare-const ?aigu Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aigs ?aigr))
                (not (= ?aigs ?fkf))
                )
              (not (= ?aigr ?fkf))
              )
            (or (or (= ?aigu ?aigt)
                (= ?aigu ?fkf)
                )
              (= ?aigt ?fkf)
              )
            )
          (and (or (or (= ?aigs ?aigr)
                (= ?aigs ?fkf)
                )
              (= ?aigr ?fkf)
              )
            (and (and (not (= ?aigu ?aigt))
                (not (= ?aigu ?fkf))
                )
              (not (= ?aigt ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aigv Real)
    (declare-const ?aigw Real)
    (declare-const ?aigx Real)
    (declare-const ?aigy Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aigw ?aigv))
                (not (= ?aigw ?mzs))
                )
              (not (= ?aigv ?mzs))
              )
            (or (or (= ?aigy ?aigx)
                (= ?aigy ?mzs)
                )
              (= ?aigx ?mzs)
              )
            )
          (and (or (or (= ?aigw ?aigv)
                (= ?aigw ?mzs)
                )
              (= ?aigv ?mzs)
              )
            (and (and (not (= ?aigy ?aigx))
                (not (= ?aigy ?mzs))
                )
              (not (= ?aigx ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aigz Real)
  (declare-const ?aiha Real)
  (declare-const ?aihb Real)
  (push 1)
    (declare-const ?aihc Real)
    (declare-const ?aihd Real)
    (declare-const ?aihe Real)
    (assert
      (or (or (= ?aihe ?aihd)
          (= ?aihe ?aihc)
          )
        (= ?aihd ?aihc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aihf Real)
    (declare-const ?aihg Real)
    (declare-const ?aihh Real)
    (declare-const ?aihi Real)
    (assert
      (or (or (= ?aihi ?aihh)
          (= ?aihi ?aihg)
          )
        (= ?aihh ?aihg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aihj Real)
    (declare-const ?aihk Real)
    (declare-const ?aihl Real)
    (declare-const ?aihm Real)
    (declare-const ?aihn Real)
    (assert
      (or (or (= ?aihn ?aihm)
          (= ?aihn ?aihl)
          )
        (= ?aihm ?aihl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiho Real)
    (declare-const ?aihp Real)
    (declare-const ?aihq Real)
    (declare-const ?aihr Real)
    (declare-const ?aihs Real)
    (declare-const ?aiht Real)
    (assert
      (and (and (and (not (= ?aihq ?aihp))
            (not (= ?aihq ?aiho))
            )
          (not (= ?aihp ?aiho))
          )
        (or (or (= ?aiht ?aihs)
            (= ?aiht ?aihr)
            )
          (= ?aihs ?aihr)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aihu Real)
    (declare-const ?aihv Real)
    (declare-const ?aihw Real)
    (assert
      (or (or (= ?aihw ?aihv)
          (= ?aihw ?aihu)
          )
        (= ?aihv ?aihu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aihx Real)
    (declare-const ?aihy Real)
    (declare-const ?aihz Real)
    (assert
      (or (or (= ?aihz ?aihy)
          (= ?aihz ?aihx)
          )
        (= ?aihy ?aihx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiia Real)
    (declare-const ?aiib Real)
    (declare-const ?aiic Real)
    (declare-const ?aiid Real)
    (assert
      (or (or (= ?aiic ?aiib)
          (= ?aiic ?aiia)
          )
        (= ?aiib ?aiia)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiie Real)
    (declare-const ?aiif Real)
    (declare-const ?aiig Real)
    (declare-const ?aiih Real)
    (declare-const ?aiii Real)
    (assert
      (or (or (= ?aiig ?aiif)
          (= ?aiig ?aiie)
          )
        (= ?aiif ?aiie)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiij Real)
    (declare-const ?aiik Real)
    (declare-const ?aiil Real)
    (declare-const ?aiim Real)
    (declare-const ?aiin Real)
    (declare-const ?aiio Real)
    (assert
      (and (or (or (= ?aiil ?aiik)
            (= ?aiil ?aiij)
            )
          (= ?aiik ?aiij)
          )
        (and (and (not (= ?aiio ?aiin))
            (not (= ?aiio ?aiim))
            )
          (not (= ?aiin ?aiim))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiip Real)
    (declare-const ?aiiq Real)
    (declare-const ?aiir Real)
    (assert
      (or (or (= ?aiir ?aiiq)
          (= ?aiir ?aiip)
          )
        (= ?aiiq ?aiip)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiis Real)
    (declare-const ?aiit Real)
    (declare-const ?aiiu Real)
    (declare-const ?aiiv Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aiit ?aiis))
                (not (= ?aiit ?asi))
                )
              (not (= ?aiis ?asi))
              )
            (or (or (= ?aiiv ?aiiu)
                (= ?aiiv ?asi)
                )
              (= ?aiiu ?asi)
              )
            )
          (and (or (or (= ?aiit ?aiis)
                (= ?aiit ?asi)
                )
              (= ?aiis ?asi)
              )
            (and (and (not (= ?aiiv ?aiiu))
                (not (= ?aiiv ?asi))
                )
              (not (= ?aiiu ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiiw Real)
    (declare-const ?aiix Real)
    (declare-const ?aiiy Real)
    (declare-const ?aiiz Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aiix ?aiiw))
                (not (= ?aiix ?fkf))
                )
              (not (= ?aiiw ?fkf))
              )
            (or (or (= ?aiiz ?aiiy)
                (= ?aiiz ?fkf)
                )
              (= ?aiiy ?fkf)
              )
            )
          (and (or (or (= ?aiix ?aiiw)
                (= ?aiix ?fkf)
                )
              (= ?aiiw ?fkf)
              )
            (and (and (not (= ?aiiz ?aiiy))
                (not (= ?aiiz ?fkf))
                )
              (not (= ?aiiy ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aija Real)
    (declare-const ?aijb Real)
    (declare-const ?aijc Real)
    (declare-const ?aijd Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aijb ?aija))
                (not (= ?aijb ?mzs))
                )
              (not (= ?aija ?mzs))
              )
            (or (or (= ?aijd ?aijc)
                (= ?aijd ?mzs)
                )
              (= ?aijc ?mzs)
              )
            )
          (and (or (or (= ?aijb ?aija)
                (= ?aijb ?mzs)
                )
              (= ?aija ?mzs)
              )
            (and (and (not (= ?aijd ?aijc))
                (not (= ?aijd ?mzs))
                )
              (not (= ?aijc ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aije Real)
  (declare-const ?aijf Real)
  (declare-const ?aijg Real)
  (declare-const ?aijh Real)
  (assert
    (exists ((?zpl Real) )(or (and (and (and (not (= ?aijf ?aije))
              (not (= ?aijf ?zpl))
              )
            (not (= ?aije ?zpl))
            )
          (or (or (= ?aijh ?aijg)
              (= ?aijh ?zpl)
              )
            (= ?aijg ?zpl)
            )
          )
        (and (or (or (= ?aijf ?aije)
              (= ?aijf ?zpl)
              )
            (= ?aije ?zpl)
            )
          (and (and (not (= ?aijh ?aijg))
              (not (= ?aijh ?zpl))
              )
            (not (= ?aijg ?zpl))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?aiji Real)
    (declare-const ?aijj Real)
    (declare-const ?aijk Real)
    (assert
      (or (or (= ?aijk ?aijj)
          (= ?aijk ?aiji)
          )
        (= ?aijj ?aiji)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aijl Real)
    (declare-const ?aijm Real)
    (declare-const ?aijn Real)
    (declare-const ?aijo Real)
    (assert
      (or (or (= ?aijo ?aijn)
          (= ?aijo ?aijm)
          )
        (= ?aijn ?aijm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aijp Real)
    (declare-const ?aijq Real)
    (declare-const ?aijr Real)
    (declare-const ?aijs Real)
    (declare-const ?aijt Real)
    (assert
      (or (or (= ?aijt ?aijs)
          (= ?aijt ?aijr)
          )
        (= ?aijs ?aijr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiju Real)
    (declare-const ?aijv Real)
    (declare-const ?aijw Real)
    (declare-const ?aijx Real)
    (declare-const ?aijy Real)
    (declare-const ?aijz Real)
    (assert
      (and (and (and (not (= ?aijw ?aijv))
            (not (= ?aijw ?aiju))
            )
          (not (= ?aijv ?aiju))
          )
        (or (or (= ?aijz ?aijy)
            (= ?aijz ?aijx)
            )
          (= ?aijy ?aijx)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aika Real)
    (declare-const ?aikb Real)
    (declare-const ?aikc Real)
    (assert
      (or (or (= ?aikc ?aikb)
          (= ?aikc ?aika)
          )
        (= ?aikb ?aika)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aikd Real)
    (declare-const ?aike Real)
    (declare-const ?aikf Real)
    (assert
      (or (or (= ?aikf ?aike)
          (= ?aikf ?aikd)
          )
        (= ?aike ?aikd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aikg Real)
    (declare-const ?aikh Real)
    (declare-const ?aiki Real)
    (declare-const ?aikj Real)
    (assert
      (or (or (= ?aiki ?aikh)
          (= ?aiki ?aikg)
          )
        (= ?aikh ?aikg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aikk Real)
    (declare-const ?aikl Real)
    (declare-const ?aikm Real)
    (declare-const ?aikn Real)
    (declare-const ?aiko Real)
    (assert
      (or (or (= ?aikm ?aikl)
          (= ?aikm ?aikk)
          )
        (= ?aikl ?aikk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aikp Real)
    (declare-const ?aikq Real)
    (declare-const ?aikr Real)
    (declare-const ?aiks Real)
    (declare-const ?aikt Real)
    (declare-const ?aiku Real)
    (assert
      (and (or (or (= ?aikr ?aikq)
            (= ?aikr ?aikp)
            )
          (= ?aikq ?aikp)
          )
        (and (and (not (= ?aiku ?aikt))
            (not (= ?aiku ?aiks))
            )
          (not (= ?aikt ?aiks))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aikv Real)
    (declare-const ?aikw Real)
    (declare-const ?aikx Real)
    (assert
      (or (or (= ?aikx ?aikw)
          (= ?aikx ?aikv)
          )
        (= ?aikw ?aikv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiky Real)
    (declare-const ?aikz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aila Real)
    (declare-const ?ailb Real)
    (declare-const ?ailc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aild Real)
    (declare-const ?aile Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ailf Real)
    (declare-const ?ailg Real)
    (declare-const ?ailh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aili Real)
    (declare-const ?ailj Real)
    (declare-const ?ailk Real)
    (declare-const ?aill Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ailj ?aili))
                (not (= ?ailj ?asi))
                )
              (not (= ?aili ?asi))
              )
            (or (or (= ?aill ?ailk)
                (= ?aill ?asi)
                )
              (= ?ailk ?asi)
              )
            )
          (and (or (or (= ?ailj ?aili)
                (= ?ailj ?asi)
                )
              (= ?aili ?asi)
              )
            (and (and (not (= ?aill ?ailk))
                (not (= ?aill ?asi))
                )
              (not (= ?ailk ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ailm Real)
    (declare-const ?ailn Real)
    (declare-const ?ailo Real)
    (declare-const ?ailp Real)
    (declare-const ?ailq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ailr Real)
    (declare-const ?ails Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ailt Real)
    (declare-const ?ailu Real)
    (declare-const ?ailv Real)
    (declare-const ?ailw Real)
    (declare-const ?ailx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aily Real)
    (declare-const ?ailz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aima Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aimb Real)
    (declare-const ?aimc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aimd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aime Real)
    (declare-const ?aimf Real)
    (assert
      (not (= ?aime ?aimf))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aimg Real)
    (declare-const ?aimh Real)
    (declare-const ?aimi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aimj Real)
    (declare-const ?aimk Real)
    (declare-const ?aiml Real)
    (declare-const ?aimm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aimn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aimo Real)
    (declare-const ?aimp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aimq Real)
    (declare-const ?aimr Real)
    (declare-const ?aims Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aimt Real)
    (declare-const ?aimu Real)
    (declare-const ?aimv Real)
    (declare-const ?aimw Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aimu ?aimt))
                (not (= ?aimu ?fkf))
                )
              (not (= ?aimt ?fkf))
              )
            (or (or (= ?aimw ?aimv)
                (= ?aimw ?fkf)
                )
              (= ?aimv ?fkf)
              )
            )
          (and (or (or (= ?aimu ?aimt)
                (= ?aimu ?fkf)
                )
              (= ?aimt ?fkf)
              )
            (and (and (not (= ?aimw ?aimv))
                (not (= ?aimw ?fkf))
                )
              (not (= ?aimv ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aimx Real)
    (declare-const ?aimy Real)
    (declare-const ?aimz Real)
    (declare-const ?aina Real)
    (declare-const ?ainb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ainc Real)
    (declare-const ?aind Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aine Real)
    (declare-const ?ainf Real)
    (declare-const ?aing Real)
    (declare-const ?ainh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aini Real)
    (declare-const ?ainj Real)
    (declare-const ?aink Real)
    (declare-const ?ainl Real)
    (declare-const ?ainm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ainn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aino Real)
    (declare-const ?ainp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ainq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ainr Real)
    (declare-const ?ains Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aint Real)
    (declare-const ?ainu Real)
    (declare-const ?ainv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ainw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ainx Real)
    (declare-const ?ainy Real)
    (assert
      (not (= ?ainx ?ainy))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ainz Real)
    (declare-const ?aioa Real)
    (declare-const ?aiob Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aioc Real)
    (declare-const ?aiod Real)
    (declare-const ?aioe Real)
    (declare-const ?aiof Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiog Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aioh Real)
    (declare-const ?aioi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aioj Real)
    (declare-const ?aiok Real)
    (declare-const ?aiol Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiom Real)
    (declare-const ?aion Real)
    (declare-const ?aioo Real)
    (declare-const ?aiop Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aion ?aiom))
                (not (= ?aion ?mzs))
                )
              (not (= ?aiom ?mzs))
              )
            (or (or (= ?aiop ?aioo)
                (= ?aiop ?mzs)
                )
              (= ?aioo ?mzs)
              )
            )
          (and (or (or (= ?aion ?aiom)
                (= ?aion ?mzs)
                )
              (= ?aiom ?mzs)
              )
            (and (and (not (= ?aiop ?aioo))
                (not (= ?aiop ?mzs))
                )
              (not (= ?aioo ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aioq Real)
    (declare-const ?aior Real)
    (declare-const ?aios Real)
    (declare-const ?aiot Real)
    (declare-const ?aiou Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiov Real)
    (declare-const ?aiow Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiox Real)
    (declare-const ?aioy Real)
    (declare-const ?aioz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aipa Real)
    (declare-const ?aipb Real)
    (declare-const ?aipc Real)
    (declare-const ?aipd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aipe Real)
    (declare-const ?aipf Real)
    (declare-const ?aipg Real)
    (declare-const ?aiph Real)
    (declare-const ?aipi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aipj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aipk Real)
    (declare-const ?aipl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aipm Real)
  (declare-const ?aipn Real)
  (declare-const ?aipo Real)
  (declare-const ?aipp Real)
  (declare-const ?aipq Real)
  (push 1)
    (declare-const ?aipr Real)
    (declare-const ?aips Real)
    (declare-const ?aipt Real)
    (assert
      (or (or (= ?aipt ?aips)
          (= ?aipt ?aipr)
          )
        (= ?aips ?aipr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aipu Real)
    (declare-const ?aipv Real)
    (declare-const ?aipw Real)
    (declare-const ?aipx Real)
    (assert
      (or (or (= ?aipx ?aipw)
          (= ?aipx ?aipv)
          )
        (= ?aipw ?aipv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aipy Real)
    (declare-const ?aipz Real)
    (declare-const ?aiqa Real)
    (declare-const ?aiqb Real)
    (declare-const ?aiqc Real)
    (assert
      (or (or (= ?aiqc ?aiqb)
          (= ?aiqc ?aiqa)
          )
        (= ?aiqb ?aiqa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiqd Real)
    (declare-const ?aiqe Real)
    (declare-const ?aiqf Real)
    (declare-const ?aiqg Real)
    (declare-const ?aiqh Real)
    (declare-const ?aiqi Real)
    (assert
      (and (and (and (not (= ?aiqf ?aiqe))
            (not (= ?aiqf ?aiqd))
            )
          (not (= ?aiqe ?aiqd))
          )
        (or (or (= ?aiqi ?aiqh)
            (= ?aiqi ?aiqg)
            )
          (= ?aiqh ?aiqg)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiqj Real)
    (declare-const ?aiqk Real)
    (declare-const ?aiql Real)
    (assert
      (or (or (= ?aiql ?aiqk)
          (= ?aiql ?aiqj)
          )
        (= ?aiqk ?aiqj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiqm Real)
    (declare-const ?aiqn Real)
    (declare-const ?aiqo Real)
    (assert
      (or (or (= ?aiqo ?aiqn)
          (= ?aiqo ?aiqm)
          )
        (= ?aiqn ?aiqm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiqp Real)
    (declare-const ?aiqq Real)
    (declare-const ?aiqr Real)
    (declare-const ?aiqs Real)
    (assert
      (or (or (= ?aiqr ?aiqq)
          (= ?aiqr ?aiqp)
          )
        (= ?aiqq ?aiqp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiqt Real)
    (declare-const ?aiqu Real)
    (declare-const ?aiqv Real)
    (declare-const ?aiqw Real)
    (declare-const ?aiqx Real)
    (assert
      (or (or (= ?aiqv ?aiqu)
          (= ?aiqv ?aiqt)
          )
        (= ?aiqu ?aiqt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiqy Real)
    (declare-const ?aiqz Real)
    (declare-const ?aira Real)
    (declare-const ?airb Real)
    (declare-const ?airc Real)
    (declare-const ?aird Real)
    (assert
      (and (or (or (= ?aira ?aiqz)
            (= ?aira ?aiqy)
            )
          (= ?aiqz ?aiqy)
          )
        (and (and (not (= ?aird ?airc))
            (not (= ?aird ?airb))
            )
          (not (= ?airc ?airb))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aire Real)
    (declare-const ?airf Real)
    (declare-const ?airg Real)
    (assert
      (or (or (= ?airg ?airf)
          (= ?airg ?aire)
          )
        (= ?airf ?aire)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?airh Real)
    (declare-const ?airi Real)
    (declare-const ?airj Real)
    (declare-const ?airk Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?airi ?airh))
                (not (= ?airi ?asi))
                )
              (not (= ?airh ?asi))
              )
            (or (or (= ?airk ?airj)
                (= ?airk ?asi)
                )
              (= ?airj ?asi)
              )
            )
          (and (or (or (= ?airi ?airh)
                (= ?airi ?asi)
                )
              (= ?airh ?asi)
              )
            (and (and (not (= ?airk ?airj))
                (not (= ?airk ?asi))
                )
              (not (= ?airj ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?airl Real)
    (declare-const ?airm Real)
    (declare-const ?airn Real)
    (declare-const ?airo Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?airm ?airl))
                (not (= ?airm ?fkf))
                )
              (not (= ?airl ?fkf))
              )
            (or (or (= ?airo ?airn)
                (= ?airo ?fkf)
                )
              (= ?airn ?fkf)
              )
            )
          (and (or (or (= ?airm ?airl)
                (= ?airm ?fkf)
                )
              (= ?airl ?fkf)
              )
            (and (and (not (= ?airo ?airn))
                (not (= ?airo ?fkf))
                )
              (not (= ?airn ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?airp Real)
    (declare-const ?airq Real)
    (declare-const ?airr Real)
    (declare-const ?airs Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?airq ?airp))
                (not (= ?airq ?mzs))
                )
              (not (= ?airp ?mzs))
              )
            (or (or (= ?airs ?airr)
                (= ?airs ?mzs)
                )
              (= ?airr ?mzs)
              )
            )
          (and (or (or (= ?airq ?airp)
                (= ?airq ?mzs)
                )
              (= ?airp ?mzs)
              )
            (and (and (not (= ?airs ?airr))
                (not (= ?airs ?mzs))
                )
              (not (= ?airr ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?airt Real)
  (declare-const ?airu Real)
  (push 1)
    (declare-const ?airv Real)
    (declare-const ?airw Real)
    (declare-const ?airx Real)
    (assert
      (or (or (= ?airx ?airw)
          (= ?airx ?airv)
          )
        (= ?airw ?airv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?airy Real)
    (declare-const ?airz Real)
    (declare-const ?aisa Real)
    (declare-const ?aisb Real)
    (assert
      (or (or (= ?aisb ?aisa)
          (= ?aisb ?airz)
          )
        (= ?aisa ?airz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aisc Real)
    (declare-const ?aisd Real)
    (declare-const ?aise Real)
    (declare-const ?aisf Real)
    (declare-const ?aisg Real)
    (assert
      (or (or (= ?aisg ?aisf)
          (= ?aisg ?aise)
          )
        (= ?aisf ?aise)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aish Real)
    (declare-const ?aisi Real)
    (declare-const ?aisj Real)
    (declare-const ?aisk Real)
    (declare-const ?aisl Real)
    (declare-const ?aism Real)
    (assert
      (and (and (and (not (= ?aisj ?aisi))
            (not (= ?aisj ?aish))
            )
          (not (= ?aisi ?aish))
          )
        (or (or (= ?aism ?aisl)
            (= ?aism ?aisk)
            )
          (= ?aisl ?aisk)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aisn Real)
    (declare-const ?aiso Real)
    (declare-const ?aisp Real)
    (assert
      (or (or (= ?aisp ?aiso)
          (= ?aisp ?aisn)
          )
        (= ?aiso ?aisn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aisq Real)
    (declare-const ?aisr Real)
    (declare-const ?aiss Real)
    (assert
      (or (or (= ?aiss ?aisr)
          (= ?aiss ?aisq)
          )
        (= ?aisr ?aisq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aist Real)
    (declare-const ?aisu Real)
    (declare-const ?aisv Real)
    (declare-const ?aisw Real)
    (assert
      (or (or (= ?aisv ?aisu)
          (= ?aisv ?aist)
          )
        (= ?aisu ?aist)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aisx Real)
    (declare-const ?aisy Real)
    (declare-const ?aisz Real)
    (declare-const ?aita Real)
    (declare-const ?aitb Real)
    (assert
      (or (or (= ?aisz ?aisy)
          (= ?aisz ?aisx)
          )
        (= ?aisy ?aisx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aitc Real)
    (declare-const ?aitd Real)
    (declare-const ?aite Real)
    (declare-const ?aitf Real)
    (declare-const ?aitg Real)
    (declare-const ?aith Real)
    (assert
      (and (or (or (= ?aite ?aitd)
            (= ?aite ?aitc)
            )
          (= ?aitd ?aitc)
          )
        (and (and (not (= ?aith ?aitg))
            (not (= ?aith ?aitf))
            )
          (not (= ?aitg ?aitf))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiti Real)
    (declare-const ?aitj Real)
    (declare-const ?aitk Real)
    (assert
      (or (or (= ?aitk ?aitj)
          (= ?aitk ?aiti)
          )
        (= ?aitj ?aiti)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aitl Real)
    (declare-const ?aitm Real)
    (declare-const ?aitn Real)
    (declare-const ?aito Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aitm ?aitl))
                (not (= ?aitm ?asi))
                )
              (not (= ?aitl ?asi))
              )
            (or (or (= ?aito ?aitn)
                (= ?aito ?asi)
                )
              (= ?aitn ?asi)
              )
            )
          (and (or (or (= ?aitm ?aitl)
                (= ?aitm ?asi)
                )
              (= ?aitl ?asi)
              )
            (and (and (not (= ?aito ?aitn))
                (not (= ?aito ?asi))
                )
              (not (= ?aitn ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aitp Real)
    (declare-const ?aitq Real)
    (declare-const ?aitr Real)
    (declare-const ?aits Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aitq ?aitp))
                (not (= ?aitq ?fkf))
                )
              (not (= ?aitp ?fkf))
              )
            (or (or (= ?aits ?aitr)
                (= ?aits ?fkf)
                )
              (= ?aitr ?fkf)
              )
            )
          (and (or (or (= ?aitq ?aitp)
                (= ?aitq ?fkf)
                )
              (= ?aitp ?fkf)
              )
            (and (and (not (= ?aits ?aitr))
                (not (= ?aits ?fkf))
                )
              (not (= ?aitr ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aitt Real)
    (declare-const ?aitu Real)
    (declare-const ?aitv Real)
    (declare-const ?aitw Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aitu ?aitt))
                (not (= ?aitu ?mzs))
                )
              (not (= ?aitt ?mzs))
              )
            (or (or (= ?aitw ?aitv)
                (= ?aitw ?mzs)
                )
              (= ?aitv ?mzs)
              )
            )
          (and (or (or (= ?aitu ?aitt)
                (= ?aitu ?mzs)
                )
              (= ?aitt ?mzs)
              )
            (and (and (not (= ?aitw ?aitv))
                (not (= ?aitw ?mzs))
                )
              (not (= ?aitv ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aitx Real)
  (declare-const ?aity Real)
  (declare-const ?aitz Real)
  (push 1)
    (declare-const ?aiua Real)
    (declare-const ?aiub Real)
    (declare-const ?aiuc Real)
    (assert
      (or (or (= ?aiuc ?aiub)
          (= ?aiuc ?aiua)
          )
        (= ?aiub ?aiua)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiud Real)
    (declare-const ?aiue Real)
    (declare-const ?aiuf Real)
    (declare-const ?aiug Real)
    (assert
      (or (or (= ?aiug ?aiuf)
          (= ?aiug ?aiue)
          )
        (= ?aiuf ?aiue)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiuh Real)
    (declare-const ?aiui Real)
    (declare-const ?aiuj Real)
    (declare-const ?aiuk Real)
    (declare-const ?aiul Real)
    (assert
      (or (or (= ?aiul ?aiuk)
          (= ?aiul ?aiuj)
          )
        (= ?aiuk ?aiuj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aium Real)
    (declare-const ?aiun Real)
    (declare-const ?aiuo Real)
    (declare-const ?aiup Real)
    (declare-const ?aiuq Real)
    (declare-const ?aiur Real)
    (assert
      (and (and (and (not (= ?aiuo ?aiun))
            (not (= ?aiuo ?aium))
            )
          (not (= ?aiun ?aium))
          )
        (or (or (= ?aiur ?aiuq)
            (= ?aiur ?aiup)
            )
          (= ?aiuq ?aiup)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aius Real)
    (declare-const ?aiut Real)
    (declare-const ?aiuu Real)
    (assert
      (or (or (= ?aiuu ?aiut)
          (= ?aiuu ?aius)
          )
        (= ?aiut ?aius)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiuv Real)
    (declare-const ?aiuw Real)
    (declare-const ?aiux Real)
    (assert
      (or (or (= ?aiux ?aiuw)
          (= ?aiux ?aiuv)
          )
        (= ?aiuw ?aiuv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiuy Real)
    (declare-const ?aiuz Real)
    (declare-const ?aiva Real)
    (declare-const ?aivb Real)
    (assert
      (or (or (= ?aiva ?aiuz)
          (= ?aiva ?aiuy)
          )
        (= ?aiuz ?aiuy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aivc Real)
    (declare-const ?aivd Real)
    (declare-const ?aive Real)
    (declare-const ?aivf Real)
    (declare-const ?aivg Real)
    (assert
      (or (or (= ?aive ?aivd)
          (= ?aive ?aivc)
          )
        (= ?aivd ?aivc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aivh Real)
    (declare-const ?aivi Real)
    (declare-const ?aivj Real)
    (declare-const ?aivk Real)
    (declare-const ?aivl Real)
    (declare-const ?aivm Real)
    (assert
      (and (or (or (= ?aivj ?aivi)
            (= ?aivj ?aivh)
            )
          (= ?aivi ?aivh)
          )
        (and (and (not (= ?aivm ?aivl))
            (not (= ?aivm ?aivk))
            )
          (not (= ?aivl ?aivk))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aivn Real)
    (declare-const ?aivo Real)
    (declare-const ?aivp Real)
    (assert
      (or (or (= ?aivp ?aivo)
          (= ?aivp ?aivn)
          )
        (= ?aivo ?aivn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aivq Real)
    (declare-const ?aivr Real)
    (declare-const ?aivs Real)
    (declare-const ?aivt Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aivr ?aivq))
                (not (= ?aivr ?asi))
                )
              (not (= ?aivq ?asi))
              )
            (or (or (= ?aivt ?aivs)
                (= ?aivt ?asi)
                )
              (= ?aivs ?asi)
              )
            )
          (and (or (or (= ?aivr ?aivq)
                (= ?aivr ?asi)
                )
              (= ?aivq ?asi)
              )
            (and (and (not (= ?aivt ?aivs))
                (not (= ?aivt ?asi))
                )
              (not (= ?aivs ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aivu Real)
    (declare-const ?aivv Real)
    (declare-const ?aivw Real)
    (declare-const ?aivx Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aivv ?aivu))
                (not (= ?aivv ?fkf))
                )
              (not (= ?aivu ?fkf))
              )
            (or (or (= ?aivx ?aivw)
                (= ?aivx ?fkf)
                )
              (= ?aivw ?fkf)
              )
            )
          (and (or (or (= ?aivv ?aivu)
                (= ?aivv ?fkf)
                )
              (= ?aivu ?fkf)
              )
            (and (and (not (= ?aivx ?aivw))
                (not (= ?aivx ?fkf))
                )
              (not (= ?aivw ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aivy Real)
    (declare-const ?aivz Real)
    (declare-const ?aiwa Real)
    (declare-const ?aiwb Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aivz ?aivy))
                (not (= ?aivz ?mzs))
                )
              (not (= ?aivy ?mzs))
              )
            (or (or (= ?aiwb ?aiwa)
                (= ?aiwb ?mzs)
                )
              (= ?aiwa ?mzs)
              )
            )
          (and (or (or (= ?aivz ?aivy)
                (= ?aivz ?mzs)
                )
              (= ?aivy ?mzs)
              )
            (and (and (not (= ?aiwb ?aiwa))
                (not (= ?aiwb ?mzs))
                )
              (not (= ?aiwa ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aiwc Real)
  (declare-const ?aiwd Real)
  (declare-const ?aiwe Real)
  (declare-const ?aiwf Real)
  (push 1)
    (declare-const ?aiwg Real)
    (declare-const ?aiwh Real)
    (declare-const ?aiwi Real)
    (assert
      (or (or (= ?aiwi ?aiwh)
          (= ?aiwi ?aiwg)
          )
        (= ?aiwh ?aiwg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiwj Real)
    (declare-const ?aiwk Real)
    (declare-const ?aiwl Real)
    (declare-const ?aiwm Real)
    (assert
      (or (or (= ?aiwm ?aiwl)
          (= ?aiwm ?aiwk)
          )
        (= ?aiwl ?aiwk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiwn Real)
    (declare-const ?aiwo Real)
    (declare-const ?aiwp Real)
    (declare-const ?aiwq Real)
    (declare-const ?aiwr Real)
    (assert
      (or (or (= ?aiwr ?aiwq)
          (= ?aiwr ?aiwp)
          )
        (= ?aiwq ?aiwp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiws Real)
    (declare-const ?aiwt Real)
    (declare-const ?aiwu Real)
    (declare-const ?aiwv Real)
    (declare-const ?aiww Real)
    (declare-const ?aiwx Real)
    (assert
      (and (and (and (not (= ?aiwu ?aiwt))
            (not (= ?aiwu ?aiws))
            )
          (not (= ?aiwt ?aiws))
          )
        (or (or (= ?aiwx ?aiww)
            (= ?aiwx ?aiwv)
            )
          (= ?aiww ?aiwv)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiwy Real)
    (declare-const ?aiwz Real)
    (declare-const ?aixa Real)
    (assert
      (or (or (= ?aixa ?aiwz)
          (= ?aixa ?aiwy)
          )
        (= ?aiwz ?aiwy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aixb Real)
    (declare-const ?aixc Real)
    (declare-const ?aixd Real)
    (assert
      (or (or (= ?aixd ?aixc)
          (= ?aixd ?aixb)
          )
        (= ?aixc ?aixb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aixe Real)
    (declare-const ?aixf Real)
    (declare-const ?aixg Real)
    (declare-const ?aixh Real)
    (assert
      (or (or (= ?aixg ?aixf)
          (= ?aixg ?aixe)
          )
        (= ?aixf ?aixe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aixi Real)
    (declare-const ?aixj Real)
    (declare-const ?aixk Real)
    (declare-const ?aixl Real)
    (declare-const ?aixm Real)
    (assert
      (or (or (= ?aixk ?aixj)
          (= ?aixk ?aixi)
          )
        (= ?aixj ?aixi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aixn Real)
    (declare-const ?aixo Real)
    (declare-const ?aixp Real)
    (declare-const ?aixq Real)
    (declare-const ?aixr Real)
    (declare-const ?aixs Real)
    (assert
      (and (or (or (= ?aixp ?aixo)
            (= ?aixp ?aixn)
            )
          (= ?aixo ?aixn)
          )
        (and (and (not (= ?aixs ?aixr))
            (not (= ?aixs ?aixq))
            )
          (not (= ?aixr ?aixq))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aixt Real)
    (declare-const ?aixu Real)
    (declare-const ?aixv Real)
    (assert
      (or (or (= ?aixv ?aixu)
          (= ?aixv ?aixt)
          )
        (= ?aixu ?aixt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aixw Real)
    (declare-const ?aixx Real)
    (declare-const ?aixy Real)
    (declare-const ?aixz Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aixx ?aixw))
                (not (= ?aixx ?asi))
                )
              (not (= ?aixw ?asi))
              )
            (or (or (= ?aixz ?aixy)
                (= ?aixz ?asi)
                )
              (= ?aixy ?asi)
              )
            )
          (and (or (or (= ?aixx ?aixw)
                (= ?aixx ?asi)
                )
              (= ?aixw ?asi)
              )
            (and (and (not (= ?aixz ?aixy))
                (not (= ?aixz ?asi))
                )
              (not (= ?aixy ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiya Real)
    (declare-const ?aiyb Real)
    (declare-const ?aiyc Real)
    (declare-const ?aiyd Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aiyb ?aiya))
                (not (= ?aiyb ?fkf))
                )
              (not (= ?aiya ?fkf))
              )
            (or (or (= ?aiyd ?aiyc)
                (= ?aiyd ?fkf)
                )
              (= ?aiyc ?fkf)
              )
            )
          (and (or (or (= ?aiyb ?aiya)
                (= ?aiyb ?fkf)
                )
              (= ?aiya ?fkf)
              )
            (and (and (not (= ?aiyd ?aiyc))
                (not (= ?aiyd ?fkf))
                )
              (not (= ?aiyc ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiye Real)
    (declare-const ?aiyf Real)
    (declare-const ?aiyg Real)
    (declare-const ?aiyh Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aiyf ?aiye))
                (not (= ?aiyf ?mzs))
                )
              (not (= ?aiye ?mzs))
              )
            (or (or (= ?aiyh ?aiyg)
                (= ?aiyh ?mzs)
                )
              (= ?aiyg ?mzs)
              )
            )
          (and (or (or (= ?aiyf ?aiye)
                (= ?aiyf ?mzs)
                )
              (= ?aiye ?mzs)
              )
            (and (and (not (= ?aiyh ?aiyg))
                (not (= ?aiyh ?mzs))
                )
              (not (= ?aiyg ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aiyi Real)
  (declare-const ?aiyj Real)
  (declare-const ?aiyk Real)
  (declare-const ?aiyl Real)
  (declare-const ?aiym Real)
  (push 1)
    (declare-const ?aiyn Real)
    (declare-const ?aiyo Real)
    (declare-const ?aiyp Real)
    (assert
      (or (or (= ?aiyp ?aiyo)
          (= ?aiyp ?aiyn)
          )
        (= ?aiyo ?aiyn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiyq Real)
    (declare-const ?aiyr Real)
    (declare-const ?aiys Real)
    (declare-const ?aiyt Real)
    (assert
      (or (or (= ?aiyt ?aiys)
          (= ?aiyt ?aiyr)
          )
        (= ?aiys ?aiyr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiyu Real)
    (declare-const ?aiyv Real)
    (declare-const ?aiyw Real)
    (declare-const ?aiyx Real)
    (declare-const ?aiyy Real)
    (assert
      (or (or (= ?aiyy ?aiyx)
          (= ?aiyy ?aiyw)
          )
        (= ?aiyx ?aiyw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aiyz Real)
    (declare-const ?aiza Real)
    (declare-const ?aizb Real)
    (declare-const ?aizc Real)
    (declare-const ?aizd Real)
    (declare-const ?aize Real)
    (assert
      (and (and (and (not (= ?aizb ?aiza))
            (not (= ?aizb ?aiyz))
            )
          (not (= ?aiza ?aiyz))
          )
        (or (or (= ?aize ?aizd)
            (= ?aize ?aizc)
            )
          (= ?aizd ?aizc)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aizf Real)
    (declare-const ?aizg Real)
    (declare-const ?aizh Real)
    (assert
      (or (or (= ?aizh ?aizg)
          (= ?aizh ?aizf)
          )
        (= ?aizg ?aizf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aizi Real)
    (declare-const ?aizj Real)
    (declare-const ?aizk Real)
    (assert
      (or (or (= ?aizk ?aizj)
          (= ?aizk ?aizi)
          )
        (= ?aizj ?aizi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aizl Real)
    (declare-const ?aizm Real)
    (declare-const ?aizn Real)
    (declare-const ?aizo Real)
    (assert
      (or (or (= ?aizn ?aizm)
          (= ?aizn ?aizl)
          )
        (= ?aizm ?aizl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aizp Real)
    (declare-const ?aizq Real)
    (declare-const ?aizr Real)
    (declare-const ?aizs Real)
    (declare-const ?aizt Real)
    (assert
      (or (or (= ?aizr ?aizq)
          (= ?aizr ?aizp)
          )
        (= ?aizq ?aizp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aizu Real)
    (declare-const ?aizv Real)
    (declare-const ?aizw Real)
    (declare-const ?aizx Real)
    (declare-const ?aizy Real)
    (declare-const ?aizz Real)
    (assert
      (and (or (or (= ?aizw ?aizv)
            (= ?aizw ?aizu)
            )
          (= ?aizv ?aizu)
          )
        (and (and (not (= ?aizz ?aizy))
            (not (= ?aizz ?aizx))
            )
          (not (= ?aizy ?aizx))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajaa Real)
    (declare-const ?ajab Real)
    (declare-const ?ajac Real)
    (assert
      (or (or (= ?ajac ?ajab)
          (= ?ajac ?ajaa)
          )
        (= ?ajab ?ajaa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajad Real)
    (declare-const ?ajae Real)
    (declare-const ?ajaf Real)
    (declare-const ?ajag Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ajae ?ajad))
                (not (= ?ajae ?asi))
                )
              (not (= ?ajad ?asi))
              )
            (or (or (= ?ajag ?ajaf)
                (= ?ajag ?asi)
                )
              (= ?ajaf ?asi)
              )
            )
          (and (or (or (= ?ajae ?ajad)
                (= ?ajae ?asi)
                )
              (= ?ajad ?asi)
              )
            (and (and (not (= ?ajag ?ajaf))
                (not (= ?ajag ?asi))
                )
              (not (= ?ajaf ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajah Real)
    (declare-const ?ajai Real)
    (declare-const ?ajaj Real)
    (declare-const ?ajak Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ajai ?ajah))
                (not (= ?ajai ?fkf))
                )
              (not (= ?ajah ?fkf))
              )
            (or (or (= ?ajak ?ajaj)
                (= ?ajak ?fkf)
                )
              (= ?ajaj ?fkf)
              )
            )
          (and (or (or (= ?ajai ?ajah)
                (= ?ajai ?fkf)
                )
              (= ?ajah ?fkf)
              )
            (and (and (not (= ?ajak ?ajaj))
                (not (= ?ajak ?fkf))
                )
              (not (= ?ajaj ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajal Real)
    (declare-const ?ajam Real)
    (declare-const ?ajan Real)
    (declare-const ?ajao Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ajam ?ajal))
                (not (= ?ajam ?mzs))
                )
              (not (= ?ajal ?mzs))
              )
            (or (or (= ?ajao ?ajan)
                (= ?ajao ?mzs)
                )
              (= ?ajan ?mzs)
              )
            )
          (and (or (or (= ?ajam ?ajal)
                (= ?ajam ?mzs)
                )
              (= ?ajal ?mzs)
              )
            (and (and (not (= ?ajao ?ajan))
                (not (= ?ajao ?mzs))
                )
              (not (= ?ajan ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?ajap Real)
    (declare-const ?ajaq Real)
    (declare-const ?ajar Real)
    (assert
      (or (or (= ?ajar ?ajaq)
          (= ?ajar ?ajap)
          )
        (= ?ajaq ?ajap)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajas Real)
    (declare-const ?ajat Real)
    (declare-const ?ajau Real)
    (declare-const ?ajav Real)
    (assert
      (or (or (= ?ajav ?ajau)
          (= ?ajav ?ajat)
          )
        (= ?ajau ?ajat)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajaw Real)
    (declare-const ?ajax Real)
    (declare-const ?ajay Real)
    (declare-const ?ajaz Real)
    (declare-const ?ajba Real)
    (assert
      (or (or (= ?ajba ?ajaz)
          (= ?ajba ?ajay)
          )
        (= ?ajaz ?ajay)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajbb Real)
    (declare-const ?ajbc Real)
    (declare-const ?ajbd Real)
    (declare-const ?ajbe Real)
    (declare-const ?ajbf Real)
    (declare-const ?ajbg Real)
    (assert
      (and (and (and (not (= ?ajbd ?ajbc))
            (not (= ?ajbd ?ajbb))
            )
          (not (= ?ajbc ?ajbb))
          )
        (or (or (= ?ajbg ?ajbf)
            (= ?ajbg ?ajbe)
            )
          (= ?ajbf ?ajbe)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajbh Real)
    (declare-const ?ajbi Real)
    (declare-const ?ajbj Real)
    (assert
      (or (or (= ?ajbj ?ajbi)
          (= ?ajbj ?ajbh)
          )
        (= ?ajbi ?ajbh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajbk Real)
    (declare-const ?ajbl Real)
    (declare-const ?ajbm Real)
    (assert
      (or (or (= ?ajbm ?ajbl)
          (= ?ajbm ?ajbk)
          )
        (= ?ajbl ?ajbk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajbn Real)
    (declare-const ?ajbo Real)
    (declare-const ?ajbp Real)
    (declare-const ?ajbq Real)
    (assert
      (or (or (= ?ajbp ?ajbo)
          (= ?ajbp ?ajbn)
          )
        (= ?ajbo ?ajbn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajbr Real)
    (declare-const ?ajbs Real)
    (declare-const ?ajbt Real)
    (declare-const ?ajbu Real)
    (declare-const ?ajbv Real)
    (assert
      (or (or (= ?ajbt ?ajbs)
          (= ?ajbt ?ajbr)
          )
        (= ?ajbs ?ajbr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajbw Real)
    (declare-const ?ajbx Real)
    (declare-const ?ajby Real)
    (declare-const ?ajbz Real)
    (declare-const ?ajca Real)
    (declare-const ?ajcb Real)
    (assert
      (and (or (or (= ?ajby ?ajbx)
            (= ?ajby ?ajbw)
            )
          (= ?ajbx ?ajbw)
          )
        (and (and (not (= ?ajcb ?ajca))
            (not (= ?ajcb ?ajbz))
            )
          (not (= ?ajca ?ajbz))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajcc Real)
    (declare-const ?ajcd Real)
    (declare-const ?ajce Real)
    (assert
      (or (or (= ?ajce ?ajcd)
          (= ?ajce ?ajcc)
          )
        (= ?ajcd ?ajcc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajcf Real)
    (declare-const ?ajcg Real)
    (declare-const ?ajch Real)
    (declare-const ?ajci Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ajcg ?ajcf))
                (not (= ?ajcg ?asi))
                )
              (not (= ?ajcf ?asi))
              )
            (or (or (= ?ajci ?ajch)
                (= ?ajci ?asi)
                )
              (= ?ajch ?asi)
              )
            )
          (and (or (or (= ?ajcg ?ajcf)
                (= ?ajcg ?asi)
                )
              (= ?ajcf ?asi)
              )
            (and (and (not (= ?ajci ?ajch))
                (not (= ?ajci ?asi))
                )
              (not (= ?ajch ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajcj Real)
    (declare-const ?ajck Real)
    (declare-const ?ajcl Real)
    (declare-const ?ajcm Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ajck ?ajcj))
                (not (= ?ajck ?fkf))
                )
              (not (= ?ajcj ?fkf))
              )
            (or (or (= ?ajcm ?ajcl)
                (= ?ajcm ?fkf)
                )
              (= ?ajcl ?fkf)
              )
            )
          (and (or (or (= ?ajck ?ajcj)
                (= ?ajck ?fkf)
                )
              (= ?ajcj ?fkf)
              )
            (and (and (not (= ?ajcm ?ajcl))
                (not (= ?ajcm ?fkf))
                )
              (not (= ?ajcl ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajcn Real)
    (declare-const ?ajco Real)
    (declare-const ?ajcp Real)
    (declare-const ?ajcq Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ajco ?ajcn))
                (not (= ?ajco ?mzs))
                )
              (not (= ?ajcn ?mzs))
              )
            (or (or (= ?ajcq ?ajcp)
                (= ?ajcq ?mzs)
                )
              (= ?ajcp ?mzs)
              )
            )
          (and (or (or (= ?ajco ?ajcn)
                (= ?ajco ?mzs)
                )
              (= ?ajcn ?mzs)
              )
            (and (and (not (= ?ajcq ?ajcp))
                (not (= ?ajcq ?mzs))
                )
              (not (= ?ajcp ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ajcr Real)
  (push 1)
    (declare-const ?ajcs Real)
    (declare-const ?ajct Real)
    (declare-const ?ajcu Real)
    (assert
      (or (or (= ?ajcu ?ajct)
          (= ?ajcu ?ajcs)
          )
        (= ?ajct ?ajcs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajcv Real)
    (declare-const ?ajcw Real)
    (declare-const ?ajcx Real)
    (declare-const ?ajcy Real)
    (assert
      (or (or (= ?ajcy ?ajcx)
          (= ?ajcy ?ajcw)
          )
        (= ?ajcx ?ajcw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajcz Real)
    (declare-const ?ajda Real)
    (declare-const ?ajdb Real)
    (declare-const ?ajdc Real)
    (declare-const ?ajdd Real)
    (assert
      (or (or (= ?ajdd ?ajdc)
          (= ?ajdd ?ajdb)
          )
        (= ?ajdc ?ajdb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajde Real)
    (declare-const ?ajdf Real)
    (declare-const ?ajdg Real)
    (declare-const ?ajdh Real)
    (declare-const ?ajdi Real)
    (declare-const ?ajdj Real)
    (assert
      (and (and (and (not (= ?ajdg ?ajdf))
            (not (= ?ajdg ?ajde))
            )
          (not (= ?ajdf ?ajde))
          )
        (or (or (= ?ajdj ?ajdi)
            (= ?ajdj ?ajdh)
            )
          (= ?ajdi ?ajdh)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajdk Real)
    (declare-const ?ajdl Real)
    (declare-const ?ajdm Real)
    (assert
      (or (or (= ?ajdm ?ajdl)
          (= ?ajdm ?ajdk)
          )
        (= ?ajdl ?ajdk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajdn Real)
    (declare-const ?ajdo Real)
    (declare-const ?ajdp Real)
    (assert
      (or (or (= ?ajdp ?ajdo)
          (= ?ajdp ?ajdn)
          )
        (= ?ajdo ?ajdn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajdq Real)
    (declare-const ?ajdr Real)
    (declare-const ?ajds Real)
    (declare-const ?ajdt Real)
    (assert
      (or (or (= ?ajds ?ajdr)
          (= ?ajds ?ajdq)
          )
        (= ?ajdr ?ajdq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajdu Real)
    (declare-const ?ajdv Real)
    (declare-const ?ajdw Real)
    (declare-const ?ajdx Real)
    (declare-const ?ajdy Real)
    (assert
      (or (or (= ?ajdw ?ajdv)
          (= ?ajdw ?ajdu)
          )
        (= ?ajdv ?ajdu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajdz Real)
    (declare-const ?ajea Real)
    (declare-const ?ajeb Real)
    (declare-const ?ajec Real)
    (declare-const ?ajed Real)
    (declare-const ?ajee Real)
    (assert
      (and (or (or (= ?ajeb ?ajea)
            (= ?ajeb ?ajdz)
            )
          (= ?ajea ?ajdz)
          )
        (and (and (not (= ?ajee ?ajed))
            (not (= ?ajee ?ajec))
            )
          (not (= ?ajed ?ajec))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajef Real)
    (declare-const ?ajeg Real)
    (declare-const ?ajeh Real)
    (assert
      (or (or (= ?ajeh ?ajeg)
          (= ?ajeh ?ajef)
          )
        (= ?ajeg ?ajef)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajei Real)
    (declare-const ?ajej Real)
    (declare-const ?ajek Real)
    (declare-const ?ajel Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ajej ?ajei))
                (not (= ?ajej ?asi))
                )
              (not (= ?ajei ?asi))
              )
            (or (or (= ?ajel ?ajek)
                (= ?ajel ?asi)
                )
              (= ?ajek ?asi)
              )
            )
          (and (or (or (= ?ajej ?ajei)
                (= ?ajej ?asi)
                )
              (= ?ajei ?asi)
              )
            (and (and (not (= ?ajel ?ajek))
                (not (= ?ajel ?asi))
                )
              (not (= ?ajek ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajem Real)
    (declare-const ?ajen Real)
    (declare-const ?ajeo Real)
    (declare-const ?ajep Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ajen ?ajem))
                (not (= ?ajen ?fkf))
                )
              (not (= ?ajem ?fkf))
              )
            (or (or (= ?ajep ?ajeo)
                (= ?ajep ?fkf)
                )
              (= ?ajeo ?fkf)
              )
            )
          (and (or (or (= ?ajen ?ajem)
                (= ?ajen ?fkf)
                )
              (= ?ajem ?fkf)
              )
            (and (and (not (= ?ajep ?ajeo))
                (not (= ?ajep ?fkf))
                )
              (not (= ?ajeo ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajeq Real)
    (declare-const ?ajer Real)
    (declare-const ?ajes Real)
    (declare-const ?ajet Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ajer ?ajeq))
                (not (= ?ajer ?mzs))
                )
              (not (= ?ajeq ?mzs))
              )
            (or (or (= ?ajet ?ajes)
                (= ?ajet ?mzs)
                )
              (= ?ajes ?mzs)
              )
            )
          (and (or (or (= ?ajer ?ajeq)
                (= ?ajer ?mzs)
                )
              (= ?ajeq ?mzs)
              )
            (and (and (not (= ?ajet ?ajes))
                (not (= ?ajet ?mzs))
                )
              (not (= ?ajes ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ajeu Real)
  (declare-const ?ajev Real)
  (push 1)
    (declare-const ?ajew Real)
    (declare-const ?ajex Real)
    (declare-const ?ajey Real)
    (assert
      (or (or (= ?ajey ?ajex)
          (= ?ajey ?ajew)
          )
        (= ?ajex ?ajew)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajez Real)
    (declare-const ?ajfa Real)
    (declare-const ?ajfb Real)
    (declare-const ?ajfc Real)
    (assert
      (or (or (= ?ajfc ?ajfb)
          (= ?ajfc ?ajfa)
          )
        (= ?ajfb ?ajfa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajfd Real)
    (declare-const ?ajfe Real)
    (declare-const ?ajff Real)
    (declare-const ?ajfg Real)
    (declare-const ?ajfh Real)
    (assert
      (or (or (= ?ajfh ?ajfg)
          (= ?ajfh ?ajff)
          )
        (= ?ajfg ?ajff)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajfi Real)
    (declare-const ?ajfj Real)
    (declare-const ?ajfk Real)
    (declare-const ?ajfl Real)
    (declare-const ?ajfm Real)
    (declare-const ?ajfn Real)
    (assert
      (and (and (and (not (= ?ajfk ?ajfj))
            (not (= ?ajfk ?ajfi))
            )
          (not (= ?ajfj ?ajfi))
          )
        (or (or (= ?ajfn ?ajfm)
            (= ?ajfn ?ajfl)
            )
          (= ?ajfm ?ajfl)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajfo Real)
    (declare-const ?ajfp Real)
    (declare-const ?ajfq Real)
    (assert
      (or (or (= ?ajfq ?ajfp)
          (= ?ajfq ?ajfo)
          )
        (= ?ajfp ?ajfo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajfr Real)
    (declare-const ?ajfs Real)
    (declare-const ?ajft Real)
    (assert
      (or (or (= ?ajft ?ajfs)
          (= ?ajft ?ajfr)
          )
        (= ?ajfs ?ajfr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajfu Real)
    (declare-const ?ajfv Real)
    (declare-const ?ajfw Real)
    (declare-const ?ajfx Real)
    (assert
      (or (or (= ?ajfw ?ajfv)
          (= ?ajfw ?ajfu)
          )
        (= ?ajfv ?ajfu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajfy Real)
    (declare-const ?ajfz Real)
    (declare-const ?ajga Real)
    (declare-const ?ajgb Real)
    (declare-const ?ajgc Real)
    (assert
      (or (or (= ?ajga ?ajfz)
          (= ?ajga ?ajfy)
          )
        (= ?ajfz ?ajfy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajgd Real)
    (declare-const ?ajge Real)
    (declare-const ?ajgf Real)
    (declare-const ?ajgg Real)
    (declare-const ?ajgh Real)
    (declare-const ?ajgi Real)
    (assert
      (and (or (or (= ?ajgf ?ajge)
            (= ?ajgf ?ajgd)
            )
          (= ?ajge ?ajgd)
          )
        (and (and (not (= ?ajgi ?ajgh))
            (not (= ?ajgi ?ajgg))
            )
          (not (= ?ajgh ?ajgg))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajgj Real)
    (declare-const ?ajgk Real)
    (declare-const ?ajgl Real)
    (assert
      (or (or (= ?ajgl ?ajgk)
          (= ?ajgl ?ajgj)
          )
        (= ?ajgk ?ajgj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajgm Real)
    (declare-const ?ajgn Real)
    (declare-const ?ajgo Real)
    (declare-const ?ajgp Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ajgn ?ajgm))
                (not (= ?ajgn ?asi))
                )
              (not (= ?ajgm ?asi))
              )
            (or (or (= ?ajgp ?ajgo)
                (= ?ajgp ?asi)
                )
              (= ?ajgo ?asi)
              )
            )
          (and (or (or (= ?ajgn ?ajgm)
                (= ?ajgn ?asi)
                )
              (= ?ajgm ?asi)
              )
            (and (and (not (= ?ajgp ?ajgo))
                (not (= ?ajgp ?asi))
                )
              (not (= ?ajgo ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajgq Real)
    (declare-const ?ajgr Real)
    (declare-const ?ajgs Real)
    (declare-const ?ajgt Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ajgr ?ajgq))
                (not (= ?ajgr ?fkf))
                )
              (not (= ?ajgq ?fkf))
              )
            (or (or (= ?ajgt ?ajgs)
                (= ?ajgt ?fkf)
                )
              (= ?ajgs ?fkf)
              )
            )
          (and (or (or (= ?ajgr ?ajgq)
                (= ?ajgr ?fkf)
                )
              (= ?ajgq ?fkf)
              )
            (and (and (not (= ?ajgt ?ajgs))
                (not (= ?ajgt ?fkf))
                )
              (not (= ?ajgs ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajgu Real)
    (declare-const ?ajgv Real)
    (declare-const ?ajgw Real)
    (declare-const ?ajgx Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ajgv ?ajgu))
                (not (= ?ajgv ?mzs))
                )
              (not (= ?ajgu ?mzs))
              )
            (or (or (= ?ajgx ?ajgw)
                (= ?ajgx ?mzs)
                )
              (= ?ajgw ?mzs)
              )
            )
          (and (or (or (= ?ajgv ?ajgu)
                (= ?ajgv ?mzs)
                )
              (= ?ajgu ?mzs)
              )
            (and (and (not (= ?ajgx ?ajgw))
                (not (= ?ajgx ?mzs))
                )
              (not (= ?ajgw ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ajgy Real)
  (declare-const ?ajgz Real)
  (declare-const ?ajha Real)
  (assert
    (or (or (= ?ajha ?ajgz)
        (= ?ajha ?ajgy)
        )
      (= ?ajgz ?ajgy)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?ajhb Real)
    (declare-const ?ajhc Real)
    (declare-const ?ajhd Real)
    (assert
      (or (or (= ?ajhd ?ajhc)
          (= ?ajhd ?ajhb)
          )
        (= ?ajhc ?ajhb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajhe Real)
    (declare-const ?ajhf Real)
    (declare-const ?ajhg Real)
    (declare-const ?ajhh Real)
    (assert
      (or (or (= ?ajhh ?ajhg)
          (= ?ajhh ?ajhf)
          )
        (= ?ajhg ?ajhf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajhi Real)
    (declare-const ?ajhj Real)
    (declare-const ?ajhk Real)
    (declare-const ?ajhl Real)
    (declare-const ?ajhm Real)
    (assert
      (or (or (= ?ajhm ?ajhl)
          (= ?ajhm ?ajhk)
          )
        (= ?ajhl ?ajhk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajhn Real)
    (declare-const ?ajho Real)
    (declare-const ?ajhp Real)
    (declare-const ?ajhq Real)
    (declare-const ?ajhr Real)
    (declare-const ?ajhs Real)
    (assert
      (and (and (and (not (= ?ajhp ?ajho))
            (not (= ?ajhp ?ajhn))
            )
          (not (= ?ajho ?ajhn))
          )
        (or (or (= ?ajhs ?ajhr)
            (= ?ajhs ?ajhq)
            )
          (= ?ajhr ?ajhq)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajht Real)
    (declare-const ?ajhu Real)
    (declare-const ?ajhv Real)
    (assert
      (or (or (= ?ajhv ?ajhu)
          (= ?ajhv ?ajht)
          )
        (= ?ajhu ?ajht)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajhw Real)
    (declare-const ?ajhx Real)
    (declare-const ?ajhy Real)
    (assert
      (or (or (= ?ajhy ?ajhx)
          (= ?ajhy ?ajhw)
          )
        (= ?ajhx ?ajhw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajhz Real)
    (declare-const ?ajia Real)
    (declare-const ?ajib Real)
    (declare-const ?ajic Real)
    (assert
      (or (or (= ?ajib ?ajia)
          (= ?ajib ?ajhz)
          )
        (= ?ajia ?ajhz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajid Real)
    (declare-const ?ajie Real)
    (declare-const ?ajif Real)
    (declare-const ?ajig Real)
    (declare-const ?ajih Real)
    (assert
      (or (or (= ?ajif ?ajie)
          (= ?ajif ?ajid)
          )
        (= ?ajie ?ajid)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajii Real)
    (declare-const ?ajij Real)
    (declare-const ?ajik Real)
    (declare-const ?ajil Real)
    (declare-const ?ajim Real)
    (declare-const ?ajin Real)
    (assert
      (and (or (or (= ?ajik ?ajij)
            (= ?ajik ?ajii)
            )
          (= ?ajij ?ajii)
          )
        (and (and (not (= ?ajin ?ajim))
            (not (= ?ajin ?ajil))
            )
          (not (= ?ajim ?ajil))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajio Real)
    (declare-const ?ajip Real)
    (declare-const ?ajiq Real)
    (assert
      (or (or (= ?ajiq ?ajip)
          (= ?ajiq ?ajio)
          )
        (= ?ajip ?ajio)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajir Real)
    (declare-const ?ajis Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajit Real)
    (declare-const ?ajiu Real)
    (declare-const ?ajiv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajiw Real)
    (declare-const ?ajix Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajiy Real)
    (declare-const ?ajiz Real)
    (declare-const ?ajja Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajjb Real)
    (declare-const ?ajjc Real)
    (declare-const ?ajjd Real)
    (declare-const ?ajje Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ajjc ?ajjb))
                (not (= ?ajjc ?asi))
                )
              (not (= ?ajjb ?asi))
              )
            (or (or (= ?ajje ?ajjd)
                (= ?ajje ?asi)
                )
              (= ?ajjd ?asi)
              )
            )
          (and (or (or (= ?ajjc ?ajjb)
                (= ?ajjc ?asi)
                )
              (= ?ajjb ?asi)
              )
            (and (and (not (= ?ajje ?ajjd))
                (not (= ?ajje ?asi))
                )
              (not (= ?ajjd ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajjf Real)
    (declare-const ?ajjg Real)
    (declare-const ?ajjh Real)
    (declare-const ?ajji Real)
    (declare-const ?ajjj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajjk Real)
    (declare-const ?ajjl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajjm Real)
    (declare-const ?ajjn Real)
    (declare-const ?ajjo Real)
    (declare-const ?ajjp Real)
    (declare-const ?ajjq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajjr Real)
    (declare-const ?ajjs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajjt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajju Real)
    (declare-const ?ajjv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajjw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajjx Real)
    (declare-const ?ajjy Real)
    (assert
      (not (= ?ajjx ?ajjy))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajjz Real)
    (declare-const ?ajka Real)
    (declare-const ?ajkb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajkc Real)
    (declare-const ?ajkd Real)
    (declare-const ?ajke Real)
    (declare-const ?ajkf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajkg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajkh Real)
    (declare-const ?ajki Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajkj Real)
    (declare-const ?ajkk Real)
    (declare-const ?ajkl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajkm Real)
    (declare-const ?ajkn Real)
    (declare-const ?ajko Real)
    (declare-const ?ajkp Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ajkn ?ajkm))
                (not (= ?ajkn ?fkf))
                )
              (not (= ?ajkm ?fkf))
              )
            (or (or (= ?ajkp ?ajko)
                (= ?ajkp ?fkf)
                )
              (= ?ajko ?fkf)
              )
            )
          (and (or (or (= ?ajkn ?ajkm)
                (= ?ajkn ?fkf)
                )
              (= ?ajkm ?fkf)
              )
            (and (and (not (= ?ajkp ?ajko))
                (not (= ?ajkp ?fkf))
                )
              (not (= ?ajko ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajkq Real)
    (declare-const ?ajkr Real)
    (declare-const ?ajks Real)
    (declare-const ?ajkt Real)
    (declare-const ?ajku Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajkv Real)
    (declare-const ?ajkw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajkx Real)
    (declare-const ?ajky Real)
    (declare-const ?ajkz Real)
    (declare-const ?ajla Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajlb Real)
    (declare-const ?ajlc Real)
    (declare-const ?ajld Real)
    (declare-const ?ajle Real)
    (declare-const ?ajlf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajlg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajlh Real)
    (declare-const ?ajli Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajlj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajlk Real)
    (declare-const ?ajll Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajlm Real)
    (declare-const ?ajln Real)
    (declare-const ?ajlo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajlp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajlq Real)
    (declare-const ?ajlr Real)
    (assert
      (not (= ?ajlq ?ajlr))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajls Real)
    (declare-const ?ajlt Real)
    (declare-const ?ajlu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajlv Real)
    (declare-const ?ajlw Real)
    (declare-const ?ajlx Real)
    (declare-const ?ajly Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajlz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajma Real)
    (declare-const ?ajmb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajmc Real)
    (declare-const ?ajmd Real)
    (declare-const ?ajme Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajmf Real)
    (declare-const ?ajmg Real)
    (declare-const ?ajmh Real)
    (declare-const ?ajmi Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ajmg ?ajmf))
                (not (= ?ajmg ?mzs))
                )
              (not (= ?ajmf ?mzs))
              )
            (or (or (= ?ajmi ?ajmh)
                (= ?ajmi ?mzs)
                )
              (= ?ajmh ?mzs)
              )
            )
          (and (or (or (= ?ajmg ?ajmf)
                (= ?ajmg ?mzs)
                )
              (= ?ajmf ?mzs)
              )
            (and (and (not (= ?ajmi ?ajmh))
                (not (= ?ajmi ?mzs))
                )
              (not (= ?ajmh ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajmj Real)
    (declare-const ?ajmk Real)
    (declare-const ?ajml Real)
    (declare-const ?ajmm Real)
    (declare-const ?ajmn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajmo Real)
    (declare-const ?ajmp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajmq Real)
    (declare-const ?ajmr Real)
    (declare-const ?ajms Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajmt Real)
    (declare-const ?ajmu Real)
    (declare-const ?ajmv Real)
    (declare-const ?ajmw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajmx Real)
    (declare-const ?ajmy Real)
    (declare-const ?ajmz Real)
    (declare-const ?ajna Real)
    (declare-const ?ajnb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajnc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajnd Real)
    (declare-const ?ajne Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajnf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajng Real)
    (declare-const ?ajnh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajni Real)
    (declare-const ?ajnj Real)
    (declare-const ?ajnk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajnl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajnm Real)
    (declare-const ?ajnn Real)
    (assert
      (not (= ?ajnm ?ajnn))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajno Real)
    (declare-const ?ajnp Real)
    (declare-const ?ajnq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajnr Real)
    (declare-const ?ajns Real)
    (declare-const ?ajnt Real)
    (declare-const ?ajnu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajnv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajnw Real)
    (declare-const ?ajnx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajny Real)
    (declare-const ?ajnz Real)
    (declare-const ?ajoa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajob Real)
    (declare-const ?ajoc Real)
    (declare-const ?ajod Real)
    (declare-const ?ajoe Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?ajoc ?ajob))
                (not (= ?ajoc ?zpl))
                )
              (not (= ?ajob ?zpl))
              )
            (or (or (= ?ajoe ?ajod)
                (= ?ajoe ?zpl)
                )
              (= ?ajod ?zpl)
              )
            )
          (and (or (or (= ?ajoc ?ajob)
                (= ?ajoc ?zpl)
                )
              (= ?ajob ?zpl)
              )
            (and (and (not (= ?ajoe ?ajod))
                (not (= ?ajoe ?zpl))
                )
              (not (= ?ajod ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajof Real)
    (declare-const ?ajog Real)
    (declare-const ?ajoh Real)
    (declare-const ?ajoi Real)
    (declare-const ?ajoj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajok Real)
    (declare-const ?ajol Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajom Real)
    (declare-const ?ajon Real)
    (declare-const ?ajoo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajop Real)
    (declare-const ?ajoq Real)
    (declare-const ?ajor Real)
    (declare-const ?ajos Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajot Real)
    (declare-const ?ajou Real)
    (declare-const ?ajov Real)
    (declare-const ?ajow Real)
    (declare-const ?ajox Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajoy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajoz Real)
    (declare-const ?ajpa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ajpb Real)
  (declare-const ?ajpc Real)
  (declare-const ?ajpd Real)
  (declare-const ?ajpe Real)
  (assert
    (or (or (= ?ajpe ?ajpd)
        (= ?ajpe ?ajpc)
        )
      (= ?ajpd ?ajpc)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?ajpf Real)
    (declare-const ?ajpg Real)
    (declare-const ?ajph Real)
    (assert
      (or (or (= ?ajph ?ajpg)
          (= ?ajph ?ajpf)
          )
        (= ?ajpg ?ajpf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajpi Real)
    (declare-const ?ajpj Real)
    (declare-const ?ajpk Real)
    (declare-const ?ajpl Real)
    (assert
      (or (or (= ?ajpl ?ajpk)
          (= ?ajpl ?ajpj)
          )
        (= ?ajpk ?ajpj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajpm Real)
    (declare-const ?ajpn Real)
    (declare-const ?ajpo Real)
    (declare-const ?ajpp Real)
    (declare-const ?ajpq Real)
    (assert
      (or (or (= ?ajpq ?ajpp)
          (= ?ajpq ?ajpo)
          )
        (= ?ajpp ?ajpo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajpr Real)
    (declare-const ?ajps Real)
    (declare-const ?ajpt Real)
    (declare-const ?ajpu Real)
    (declare-const ?ajpv Real)
    (declare-const ?ajpw Real)
    (assert
      (and (and (and (not (= ?ajpt ?ajps))
            (not (= ?ajpt ?ajpr))
            )
          (not (= ?ajps ?ajpr))
          )
        (or (or (= ?ajpw ?ajpv)
            (= ?ajpw ?ajpu)
            )
          (= ?ajpv ?ajpu)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajpx Real)
    (declare-const ?ajpy Real)
    (declare-const ?ajpz Real)
    (assert
      (or (or (= ?ajpz ?ajpy)
          (= ?ajpz ?ajpx)
          )
        (= ?ajpy ?ajpx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajqa Real)
    (declare-const ?ajqb Real)
    (declare-const ?ajqc Real)
    (assert
      (or (or (= ?ajqc ?ajqb)
          (= ?ajqc ?ajqa)
          )
        (= ?ajqb ?ajqa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajqd Real)
    (declare-const ?ajqe Real)
    (declare-const ?ajqf Real)
    (declare-const ?ajqg Real)
    (assert
      (or (or (= ?ajqf ?ajqe)
          (= ?ajqf ?ajqd)
          )
        (= ?ajqe ?ajqd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajqh Real)
    (declare-const ?ajqi Real)
    (declare-const ?ajqj Real)
    (declare-const ?ajqk Real)
    (declare-const ?ajql Real)
    (assert
      (or (or (= ?ajqj ?ajqi)
          (= ?ajqj ?ajqh)
          )
        (= ?ajqi ?ajqh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajqm Real)
    (declare-const ?ajqn Real)
    (declare-const ?ajqo Real)
    (declare-const ?ajqp Real)
    (declare-const ?ajqq Real)
    (declare-const ?ajqr Real)
    (assert
      (and (or (or (= ?ajqo ?ajqn)
            (= ?ajqo ?ajqm)
            )
          (= ?ajqn ?ajqm)
          )
        (and (and (not (= ?ajqr ?ajqq))
            (not (= ?ajqr ?ajqp))
            )
          (not (= ?ajqq ?ajqp))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajqs Real)
    (declare-const ?ajqt Real)
    (declare-const ?ajqu Real)
    (assert
      (or (or (= ?ajqu ?ajqt)
          (= ?ajqu ?ajqs)
          )
        (= ?ajqt ?ajqs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajqv Real)
    (declare-const ?ajqw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajqx Real)
    (declare-const ?ajqy Real)
    (declare-const ?ajqz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajra Real)
    (declare-const ?ajrb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajrc Real)
    (declare-const ?ajrd Real)
    (declare-const ?ajre Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajrf Real)
    (declare-const ?ajrg Real)
    (declare-const ?ajrh Real)
    (declare-const ?ajri Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ajrg ?ajrf))
                (not (= ?ajrg ?asi))
                )
              (not (= ?ajrf ?asi))
              )
            (or (or (= ?ajri ?ajrh)
                (= ?ajri ?asi)
                )
              (= ?ajrh ?asi)
              )
            )
          (and (or (or (= ?ajrg ?ajrf)
                (= ?ajrg ?asi)
                )
              (= ?ajrf ?asi)
              )
            (and (and (not (= ?ajri ?ajrh))
                (not (= ?ajri ?asi))
                )
              (not (= ?ajrh ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajrj Real)
    (declare-const ?ajrk Real)
    (declare-const ?ajrl Real)
    (declare-const ?ajrm Real)
    (declare-const ?ajrn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajro Real)
    (declare-const ?ajrp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajrq Real)
    (declare-const ?ajrr Real)
    (declare-const ?ajrs Real)
    (declare-const ?ajrt Real)
    (declare-const ?ajru Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajrv Real)
    (declare-const ?ajrw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajrx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajry Real)
    (declare-const ?ajrz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajsa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajsb Real)
    (declare-const ?ajsc Real)
    (assert
      (not (= ?ajsb ?ajsc))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajsd Real)
    (declare-const ?ajse Real)
    (declare-const ?ajsf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajsg Real)
    (declare-const ?ajsh Real)
    (declare-const ?ajsi Real)
    (declare-const ?ajsj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajsk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajsl Real)
    (declare-const ?ajsm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajsn Real)
    (declare-const ?ajso Real)
    (declare-const ?ajsp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajsq Real)
    (declare-const ?ajsr Real)
    (declare-const ?ajss Real)
    (declare-const ?ajst Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?ajsr ?ajsq))
                (not (= ?ajsr ?fkf))
                )
              (not (= ?ajsq ?fkf))
              )
            (or (or (= ?ajst ?ajss)
                (= ?ajst ?fkf)
                )
              (= ?ajss ?fkf)
              )
            )
          (and (or (or (= ?ajsr ?ajsq)
                (= ?ajsr ?fkf)
                )
              (= ?ajsq ?fkf)
              )
            (and (and (not (= ?ajst ?ajss))
                (not (= ?ajst ?fkf))
                )
              (not (= ?ajss ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajsu Real)
    (declare-const ?ajsv Real)
    (declare-const ?ajsw Real)
    (declare-const ?ajsx Real)
    (declare-const ?ajsy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajsz Real)
    (declare-const ?ajta Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajtb Real)
    (declare-const ?ajtc Real)
    (declare-const ?ajtd Real)
    (declare-const ?ajte Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajtf Real)
    (declare-const ?ajtg Real)
    (declare-const ?ajth Real)
    (declare-const ?ajti Real)
    (declare-const ?ajtj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajtk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajtl Real)
    (declare-const ?ajtm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajtn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajto Real)
    (declare-const ?ajtp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajtq Real)
    (declare-const ?ajtr Real)
    (declare-const ?ajts Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajtt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajtu Real)
    (declare-const ?ajtv Real)
    (assert
      (not (= ?ajtu ?ajtv))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajtw Real)
    (declare-const ?ajtx Real)
    (declare-const ?ajty Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajtz Real)
    (declare-const ?ajua Real)
    (declare-const ?ajub Real)
    (declare-const ?ajuc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajud Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajue Real)
    (declare-const ?ajuf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajug Real)
    (declare-const ?ajuh Real)
    (declare-const ?ajui Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajuj Real)
    (declare-const ?ajuk Real)
    (declare-const ?ajul Real)
    (declare-const ?ajum Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ajuk ?ajuj))
                (not (= ?ajuk ?mzs))
                )
              (not (= ?ajuj ?mzs))
              )
            (or (or (= ?ajum ?ajul)
                (= ?ajum ?mzs)
                )
              (= ?ajul ?mzs)
              )
            )
          (and (or (or (= ?ajuk ?ajuj)
                (= ?ajuk ?mzs)
                )
              (= ?ajuj ?mzs)
              )
            (and (and (not (= ?ajum ?ajul))
                (not (= ?ajum ?mzs))
                )
              (not (= ?ajul ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajun Real)
    (declare-const ?ajuo Real)
    (declare-const ?ajup Real)
    (declare-const ?ajuq Real)
    (declare-const ?ajur Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajus Real)
    (declare-const ?ajut Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajuu Real)
    (declare-const ?ajuv Real)
    (declare-const ?ajuw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajux Real)
    (declare-const ?ajuy Real)
    (declare-const ?ajuz Real)
    (declare-const ?ajva Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajvb Real)
    (declare-const ?ajvc Real)
    (declare-const ?ajvd Real)
    (declare-const ?ajve Real)
    (declare-const ?ajvf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajvg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajvh Real)
    (declare-const ?ajvi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajvj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajvk Real)
    (declare-const ?ajvl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajvm Real)
    (declare-const ?ajvn Real)
    (declare-const ?ajvo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajvp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajvq Real)
    (declare-const ?ajvr Real)
    (assert
      (not (= ?ajvq ?ajvr))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajvs Real)
    (declare-const ?ajvt Real)
    (declare-const ?ajvu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajvv Real)
    (declare-const ?ajvw Real)
    (declare-const ?ajvx Real)
    (declare-const ?ajvy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajvz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajwa Real)
    (declare-const ?ajwb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajwc Real)
    (declare-const ?ajwd Real)
    (declare-const ?ajwe Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajwf Real)
    (declare-const ?ajwg Real)
    (declare-const ?ajwh Real)
    (declare-const ?ajwi Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?ajwg ?ajwf))
                (not (= ?ajwg ?zpl))
                )
              (not (= ?ajwf ?zpl))
              )
            (or (or (= ?ajwi ?ajwh)
                (= ?ajwi ?zpl)
                )
              (= ?ajwh ?zpl)
              )
            )
          (and (or (or (= ?ajwg ?ajwf)
                (= ?ajwg ?zpl)
                )
              (= ?ajwf ?zpl)
              )
            (and (and (not (= ?ajwi ?ajwh))
                (not (= ?ajwi ?zpl))
                )
              (not (= ?ajwh ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajwj Real)
    (declare-const ?ajwk Real)
    (declare-const ?ajwl Real)
    (declare-const ?ajwm Real)
    (declare-const ?ajwn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajwo Real)
    (declare-const ?ajwp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajwq Real)
    (declare-const ?ajwr Real)
    (declare-const ?ajws Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajwt Real)
    (declare-const ?ajwu Real)
    (declare-const ?ajwv Real)
    (declare-const ?ajww Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajwx Real)
    (declare-const ?ajwy Real)
    (declare-const ?ajwz Real)
    (declare-const ?ajxa Real)
    (declare-const ?ajxb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajxc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajxd Real)
    (declare-const ?ajxe Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ajxf Real)
  (declare-const ?ajxg Real)
  (declare-const ?ajxh Real)
  (declare-const ?ajxi Real)
  (declare-const ?ajxj Real)
  (assert
    (or (or (= ?ajxj ?ajxi)
        (= ?ajxj ?ajxh)
        )
      (= ?ajxi ?ajxh)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?ajxk Real)
    (declare-const ?ajxl Real)
    (declare-const ?ajxm Real)
    (assert
      (or (or (= ?ajxm ?ajxl)
          (= ?ajxm ?ajxk)
          )
        (= ?ajxl ?ajxk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajxn Real)
    (declare-const ?ajxo Real)
    (declare-const ?ajxp Real)
    (declare-const ?ajxq Real)
    (assert
      (or (or (= ?ajxq ?ajxp)
          (= ?ajxq ?ajxo)
          )
        (= ?ajxp ?ajxo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajxr Real)
    (declare-const ?ajxs Real)
    (declare-const ?ajxt Real)
    (declare-const ?ajxu Real)
    (declare-const ?ajxv Real)
    (assert
      (or (or (= ?ajxv ?ajxu)
          (= ?ajxv ?ajxt)
          )
        (= ?ajxu ?ajxt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajxw Real)
    (declare-const ?ajxx Real)
    (declare-const ?ajxy Real)
    (declare-const ?ajxz Real)
    (declare-const ?ajya Real)
    (declare-const ?ajyb Real)
    (assert
      (and (and (and (not (= ?ajxy ?ajxx))
            (not (= ?ajxy ?ajxw))
            )
          (not (= ?ajxx ?ajxw))
          )
        (or (or (= ?ajyb ?ajya)
            (= ?ajyb ?ajxz)
            )
          (= ?ajya ?ajxz)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajyc Real)
    (declare-const ?ajyd Real)
    (declare-const ?ajye Real)
    (assert
      (or (or (= ?ajye ?ajyd)
          (= ?ajye ?ajyc)
          )
        (= ?ajyd ?ajyc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajyf Real)
    (declare-const ?ajyg Real)
    (declare-const ?ajyh Real)
    (assert
      (or (or (= ?ajyh ?ajyg)
          (= ?ajyh ?ajyf)
          )
        (= ?ajyg ?ajyf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajyi Real)
    (declare-const ?ajyj Real)
    (declare-const ?ajyk Real)
    (declare-const ?ajyl Real)
    (assert
      (or (or (= ?ajyk ?ajyj)
          (= ?ajyk ?ajyi)
          )
        (= ?ajyj ?ajyi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajym Real)
    (declare-const ?ajyn Real)
    (declare-const ?ajyo Real)
    (declare-const ?ajyp Real)
    (declare-const ?ajyq Real)
    (assert
      (or (or (= ?ajyo ?ajyn)
          (= ?ajyo ?ajym)
          )
        (= ?ajyn ?ajym)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajyr Real)
    (declare-const ?ajys Real)
    (declare-const ?ajyt Real)
    (declare-const ?ajyu Real)
    (declare-const ?ajyv Real)
    (declare-const ?ajyw Real)
    (assert
      (and (or (or (= ?ajyt ?ajys)
            (= ?ajyt ?ajyr)
            )
          (= ?ajys ?ajyr)
          )
        (and (and (not (= ?ajyw ?ajyv))
            (not (= ?ajyw ?ajyu))
            )
          (not (= ?ajyv ?ajyu))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajyx Real)
    (declare-const ?ajyy Real)
    (declare-const ?ajyz Real)
    (assert
      (or (or (= ?ajyz ?ajyy)
          (= ?ajyz ?ajyx)
          )
        (= ?ajyy ?ajyx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajza Real)
    (declare-const ?ajzb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajzc Real)
    (declare-const ?ajzd Real)
    (declare-const ?ajze Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajzf Real)
    (declare-const ?ajzg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajzh Real)
    (declare-const ?ajzi Real)
    (declare-const ?ajzj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajzk Real)
    (declare-const ?ajzl Real)
    (declare-const ?ajzm Real)
    (declare-const ?ajzn Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ajzl ?ajzk))
                (not (= ?ajzl ?asi))
                )
              (not (= ?ajzk ?asi))
              )
            (or (or (= ?ajzn ?ajzm)
                (= ?ajzn ?asi)
                )
              (= ?ajzm ?asi)
              )
            )
          (and (or (or (= ?ajzl ?ajzk)
                (= ?ajzl ?asi)
                )
              (= ?ajzk ?asi)
              )
            (and (and (not (= ?ajzn ?ajzm))
                (not (= ?ajzn ?asi))
                )
              (not (= ?ajzm ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajzo Real)
    (declare-const ?ajzp Real)
    (declare-const ?ajzq Real)
    (declare-const ?ajzr Real)
    (declare-const ?ajzs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajzt Real)
    (declare-const ?ajzu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ajzv Real)
    (declare-const ?ajzw Real)
    (declare-const ?ajzx Real)
    (declare-const ?ajzy Real)
    (declare-const ?ajzz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akaa Real)
    (declare-const ?akab Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akac Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akad Real)
    (declare-const ?akae Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akaf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akag Real)
    (declare-const ?akah Real)
    (assert
      (not (= ?akag ?akah))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akai Real)
    (declare-const ?akaj Real)
    (declare-const ?akak Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akal Real)
    (declare-const ?akam Real)
    (declare-const ?akan Real)
    (declare-const ?akao Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akap Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akaq Real)
    (declare-const ?akar Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akas Real)
    (declare-const ?akat Real)
    (declare-const ?akau Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akav Real)
    (declare-const ?akaw Real)
    (declare-const ?akax Real)
    (declare-const ?akay Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?akaw ?akav))
                (not (= ?akaw ?fkf))
                )
              (not (= ?akav ?fkf))
              )
            (or (or (= ?akay ?akax)
                (= ?akay ?fkf)
                )
              (= ?akax ?fkf)
              )
            )
          (and (or (or (= ?akaw ?akav)
                (= ?akaw ?fkf)
                )
              (= ?akav ?fkf)
              )
            (and (and (not (= ?akay ?akax))
                (not (= ?akay ?fkf))
                )
              (not (= ?akax ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akaz Real)
    (declare-const ?akba Real)
    (declare-const ?akbb Real)
    (declare-const ?akbc Real)
    (declare-const ?akbd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akbe Real)
    (declare-const ?akbf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akbg Real)
    (declare-const ?akbh Real)
    (declare-const ?akbi Real)
    (declare-const ?akbj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akbk Real)
    (declare-const ?akbl Real)
    (declare-const ?akbm Real)
    (declare-const ?akbn Real)
    (declare-const ?akbo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akbp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akbq Real)
    (declare-const ?akbr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akbs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akbt Real)
    (declare-const ?akbu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akbv Real)
    (declare-const ?akbw Real)
    (declare-const ?akbx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akby Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akbz Real)
    (declare-const ?akca Real)
    (assert
      (not (= ?akbz ?akca))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akcb Real)
    (declare-const ?akcc Real)
    (declare-const ?akcd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akce Real)
    (declare-const ?akcf Real)
    (declare-const ?akcg Real)
    (declare-const ?akch Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akci Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akcj Real)
    (declare-const ?akck Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akcl Real)
    (declare-const ?akcm Real)
    (declare-const ?akcn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akco Real)
    (declare-const ?akcp Real)
    (declare-const ?akcq Real)
    (declare-const ?akcr Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?akcp ?akco))
                (not (= ?akcp ?mzs))
                )
              (not (= ?akco ?mzs))
              )
            (or (or (= ?akcr ?akcq)
                (= ?akcr ?mzs)
                )
              (= ?akcq ?mzs)
              )
            )
          (and (or (or (= ?akcp ?akco)
                (= ?akcp ?mzs)
                )
              (= ?akco ?mzs)
              )
            (and (and (not (= ?akcr ?akcq))
                (not (= ?akcr ?mzs))
                )
              (not (= ?akcq ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akcs Real)
    (declare-const ?akct Real)
    (declare-const ?akcu Real)
    (declare-const ?akcv Real)
    (declare-const ?akcw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akcx Real)
    (declare-const ?akcy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akcz Real)
    (declare-const ?akda Real)
    (declare-const ?akdb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akdc Real)
    (declare-const ?akdd Real)
    (declare-const ?akde Real)
    (declare-const ?akdf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akdg Real)
    (declare-const ?akdh Real)
    (declare-const ?akdi Real)
    (declare-const ?akdj Real)
    (declare-const ?akdk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akdl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akdm Real)
    (declare-const ?akdn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akdo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akdp Real)
    (declare-const ?akdq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akdr Real)
    (declare-const ?akds Real)
    (declare-const ?akdt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akdu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akdv Real)
    (declare-const ?akdw Real)
    (assert
      (not (= ?akdv ?akdw))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akdx Real)
    (declare-const ?akdy Real)
    (declare-const ?akdz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akea Real)
    (declare-const ?akeb Real)
    (declare-const ?akec Real)
    (declare-const ?aked Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akee Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akef Real)
    (declare-const ?akeg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akeh Real)
    (declare-const ?akei Real)
    (declare-const ?akej Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akek Real)
    (declare-const ?akel Real)
    (declare-const ?akem Real)
    (declare-const ?aken Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?akel ?akek))
                (not (= ?akel ?zpl))
                )
              (not (= ?akek ?zpl))
              )
            (or (or (= ?aken ?akem)
                (= ?aken ?zpl)
                )
              (= ?akem ?zpl)
              )
            )
          (and (or (or (= ?akel ?akek)
                (= ?akel ?zpl)
                )
              (= ?akek ?zpl)
              )
            (and (and (not (= ?aken ?akem))
                (not (= ?aken ?zpl))
                )
              (not (= ?akem ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akeo Real)
    (declare-const ?akep Real)
    (declare-const ?akeq Real)
    (declare-const ?aker Real)
    (declare-const ?akes Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aket Real)
    (declare-const ?akeu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akev Real)
    (declare-const ?akew Real)
    (declare-const ?akex Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akey Real)
    (declare-const ?akez Real)
    (declare-const ?akfa Real)
    (declare-const ?akfb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akfc Real)
    (declare-const ?akfd Real)
    (declare-const ?akfe Real)
    (declare-const ?akff Real)
    (declare-const ?akfg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akfh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akfi Real)
    (declare-const ?akfj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?akfk Real)
  (declare-const ?akfl Real)
  (declare-const ?akfm Real)
  (declare-const ?akfn Real)
  (declare-const ?akfo Real)
  (declare-const ?akfp Real)
  (assert
    (and (and (and (not (= ?akfm ?akfl))
          (not (= ?akfm ?akfk))
          )
        (not (= ?akfl ?akfk))
        )
      (or (or (= ?akfp ?akfo)
          (= ?akfp ?akfn)
          )
        (= ?akfo ?akfn)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?akfq Real)
    (declare-const ?akfr Real)
    (declare-const ?akfs Real)
    (assert
      (or (or (= ?akfs ?akfr)
          (= ?akfs ?akfq)
          )
        (= ?akfr ?akfq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akft Real)
    (declare-const ?akfu Real)
    (declare-const ?akfv Real)
    (declare-const ?akfw Real)
    (assert
      (or (or (= ?akfw ?akfv)
          (= ?akfw ?akfu)
          )
        (= ?akfv ?akfu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akfx Real)
    (declare-const ?akfy Real)
    (declare-const ?akfz Real)
    (declare-const ?akga Real)
    (declare-const ?akgb Real)
    (assert
      (or (or (= ?akgb ?akga)
          (= ?akgb ?akfz)
          )
        (= ?akga ?akfz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akgc Real)
    (declare-const ?akgd Real)
    (declare-const ?akge Real)
    (declare-const ?akgf Real)
    (declare-const ?akgg Real)
    (declare-const ?akgh Real)
    (assert
      (and (and (and (not (= ?akge ?akgd))
            (not (= ?akge ?akgc))
            )
          (not (= ?akgd ?akgc))
          )
        (or (or (= ?akgh ?akgg)
            (= ?akgh ?akgf)
            )
          (= ?akgg ?akgf)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akgi Real)
    (declare-const ?akgj Real)
    (declare-const ?akgk Real)
    (assert
      (or (or (= ?akgk ?akgj)
          (= ?akgk ?akgi)
          )
        (= ?akgj ?akgi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akgl Real)
    (declare-const ?akgm Real)
    (declare-const ?akgn Real)
    (assert
      (or (or (= ?akgn ?akgm)
          (= ?akgn ?akgl)
          )
        (= ?akgm ?akgl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akgo Real)
    (declare-const ?akgp Real)
    (declare-const ?akgq Real)
    (declare-const ?akgr Real)
    (assert
      (or (or (= ?akgq ?akgp)
          (= ?akgq ?akgo)
          )
        (= ?akgp ?akgo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akgs Real)
    (declare-const ?akgt Real)
    (declare-const ?akgu Real)
    (declare-const ?akgv Real)
    (declare-const ?akgw Real)
    (assert
      (or (or (= ?akgu ?akgt)
          (= ?akgu ?akgs)
          )
        (= ?akgt ?akgs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akgx Real)
    (declare-const ?akgy Real)
    (declare-const ?akgz Real)
    (declare-const ?akha Real)
    (declare-const ?akhb Real)
    (declare-const ?akhc Real)
    (assert
      (and (or (or (= ?akgz ?akgy)
            (= ?akgz ?akgx)
            )
          (= ?akgy ?akgx)
          )
        (and (and (not (= ?akhc ?akhb))
            (not (= ?akhc ?akha))
            )
          (not (= ?akhb ?akha))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akhd Real)
    (declare-const ?akhe Real)
    (declare-const ?akhf Real)
    (assert
      (or (or (= ?akhf ?akhe)
          (= ?akhf ?akhd)
          )
        (= ?akhe ?akhd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akhg Real)
    (declare-const ?akhh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akhi Real)
    (declare-const ?akhj Real)
    (declare-const ?akhk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akhl Real)
    (declare-const ?akhm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akhn Real)
    (declare-const ?akho Real)
    (declare-const ?akhp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akhq Real)
    (declare-const ?akhr Real)
    (declare-const ?akhs Real)
    (declare-const ?akht Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?akhr ?akhq))
                (not (= ?akhr ?asi))
                )
              (not (= ?akhq ?asi))
              )
            (or (or (= ?akht ?akhs)
                (= ?akht ?asi)
                )
              (= ?akhs ?asi)
              )
            )
          (and (or (or (= ?akhr ?akhq)
                (= ?akhr ?asi)
                )
              (= ?akhq ?asi)
              )
            (and (and (not (= ?akht ?akhs))
                (not (= ?akht ?asi))
                )
              (not (= ?akhs ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akhu Real)
    (declare-const ?akhv Real)
    (declare-const ?akhw Real)
    (declare-const ?akhx Real)
    (declare-const ?akhy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akhz Real)
    (declare-const ?akia Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akib Real)
    (declare-const ?akic Real)
    (declare-const ?akid Real)
    (declare-const ?akie Real)
    (declare-const ?akif Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akig Real)
    (declare-const ?akih Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akii Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akij Real)
    (declare-const ?akik Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akil Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akim Real)
    (declare-const ?akin Real)
    (assert
      (not (= ?akim ?akin))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akio Real)
    (declare-const ?akip Real)
    (declare-const ?akiq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akir Real)
    (declare-const ?akis Real)
    (declare-const ?akit Real)
    (declare-const ?akiu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akiv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akiw Real)
    (declare-const ?akix Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akiy Real)
    (declare-const ?akiz Real)
    (declare-const ?akja Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akjb Real)
    (declare-const ?akjc Real)
    (declare-const ?akjd Real)
    (declare-const ?akje Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?akjc ?akjb))
                (not (= ?akjc ?fkf))
                )
              (not (= ?akjb ?fkf))
              )
            (or (or (= ?akje ?akjd)
                (= ?akje ?fkf)
                )
              (= ?akjd ?fkf)
              )
            )
          (and (or (or (= ?akjc ?akjb)
                (= ?akjc ?fkf)
                )
              (= ?akjb ?fkf)
              )
            (and (and (not (= ?akje ?akjd))
                (not (= ?akje ?fkf))
                )
              (not (= ?akjd ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akjf Real)
    (declare-const ?akjg Real)
    (declare-const ?akjh Real)
    (declare-const ?akji Real)
    (declare-const ?akjj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akjk Real)
    (declare-const ?akjl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akjm Real)
    (declare-const ?akjn Real)
    (declare-const ?akjo Real)
    (declare-const ?akjp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akjq Real)
    (declare-const ?akjr Real)
    (declare-const ?akjs Real)
    (declare-const ?akjt Real)
    (declare-const ?akju Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akjv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akjw Real)
    (declare-const ?akjx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akjy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akjz Real)
    (declare-const ?akka Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akkb Real)
    (declare-const ?akkc Real)
    (declare-const ?akkd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akke Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akkf Real)
    (declare-const ?akkg Real)
    (assert
      (not (= ?akkf ?akkg))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akkh Real)
    (declare-const ?akki Real)
    (declare-const ?akkj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akkk Real)
    (declare-const ?akkl Real)
    (declare-const ?akkm Real)
    (declare-const ?akkn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akko Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akkp Real)
    (declare-const ?akkq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akkr Real)
    (declare-const ?akks Real)
    (declare-const ?akkt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akku Real)
    (declare-const ?akkv Real)
    (declare-const ?akkw Real)
    (declare-const ?akkx Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?akkv ?akku))
                (not (= ?akkv ?mzs))
                )
              (not (= ?akku ?mzs))
              )
            (or (or (= ?akkx ?akkw)
                (= ?akkx ?mzs)
                )
              (= ?akkw ?mzs)
              )
            )
          (and (or (or (= ?akkv ?akku)
                (= ?akkv ?mzs)
                )
              (= ?akku ?mzs)
              )
            (and (and (not (= ?akkx ?akkw))
                (not (= ?akkx ?mzs))
                )
              (not (= ?akkw ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akky Real)
    (declare-const ?akkz Real)
    (declare-const ?akla Real)
    (declare-const ?aklb Real)
    (declare-const ?aklc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akld Real)
    (declare-const ?akle Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aklf Real)
    (declare-const ?aklg Real)
    (declare-const ?aklh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akli Real)
    (declare-const ?aklj Real)
    (declare-const ?aklk Real)
    (declare-const ?akll Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aklm Real)
    (declare-const ?akln Real)
    (declare-const ?aklo Real)
    (declare-const ?aklp Real)
    (declare-const ?aklq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aklr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akls Real)
    (declare-const ?aklt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aklu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aklv Real)
    (declare-const ?aklw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aklx Real)
    (declare-const ?akly Real)
    (declare-const ?aklz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akma Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akmb Real)
    (declare-const ?akmc Real)
    (assert
      (not (= ?akmb ?akmc))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akmd Real)
    (declare-const ?akme Real)
    (declare-const ?akmf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akmg Real)
    (declare-const ?akmh Real)
    (declare-const ?akmi Real)
    (declare-const ?akmj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akmk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akml Real)
    (declare-const ?akmm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akmn Real)
    (declare-const ?akmo Real)
    (declare-const ?akmp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akmq Real)
    (declare-const ?akmr Real)
    (declare-const ?akms Real)
    (declare-const ?akmt Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?akmr ?akmq))
                (not (= ?akmr ?zpl))
                )
              (not (= ?akmq ?zpl))
              )
            (or (or (= ?akmt ?akms)
                (= ?akmt ?zpl)
                )
              (= ?akms ?zpl)
              )
            )
          (and (or (or (= ?akmr ?akmq)
                (= ?akmr ?zpl)
                )
              (= ?akmq ?zpl)
              )
            (and (and (not (= ?akmt ?akms))
                (not (= ?akmt ?zpl))
                )
              (not (= ?akms ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akmu Real)
    (declare-const ?akmv Real)
    (declare-const ?akmw Real)
    (declare-const ?akmx Real)
    (declare-const ?akmy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akmz Real)
    (declare-const ?akna Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aknb Real)
    (declare-const ?aknc Real)
    (declare-const ?aknd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akne Real)
    (declare-const ?aknf Real)
    (declare-const ?akng Real)
    (declare-const ?aknh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akni Real)
    (declare-const ?aknj Real)
    (declare-const ?aknk Real)
    (declare-const ?aknl Real)
    (declare-const ?aknm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aknn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akno Real)
    (declare-const ?aknp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aknq Real)
  (declare-const ?aknr Real)
  (declare-const ?akns Real)
  (assert
    (or (or (= ?akns ?aknr)
        (= ?akns ?aknq)
        )
      (= ?aknr ?aknq)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?aknt Real)
    (declare-const ?aknu Real)
    (declare-const ?aknv Real)
    (assert
      (or (or (= ?aknv ?aknu)
          (= ?aknv ?aknt)
          )
        (= ?aknu ?aknt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aknw Real)
    (declare-const ?aknx Real)
    (declare-const ?akny Real)
    (declare-const ?aknz Real)
    (assert
      (or (or (= ?aknz ?akny)
          (= ?aknz ?aknx)
          )
        (= ?akny ?aknx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akoa Real)
    (declare-const ?akob Real)
    (declare-const ?akoc Real)
    (declare-const ?akod Real)
    (declare-const ?akoe Real)
    (assert
      (or (or (= ?akoe ?akod)
          (= ?akoe ?akoc)
          )
        (= ?akod ?akoc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akof Real)
    (declare-const ?akog Real)
    (declare-const ?akoh Real)
    (declare-const ?akoi Real)
    (declare-const ?akoj Real)
    (declare-const ?akok Real)
    (assert
      (and (and (and (not (= ?akoh ?akog))
            (not (= ?akoh ?akof))
            )
          (not (= ?akog ?akof))
          )
        (or (or (= ?akok ?akoj)
            (= ?akok ?akoi)
            )
          (= ?akoj ?akoi)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akol Real)
    (declare-const ?akom Real)
    (declare-const ?akon Real)
    (assert
      (or (or (= ?akon ?akom)
          (= ?akon ?akol)
          )
        (= ?akom ?akol)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akoo Real)
    (declare-const ?akop Real)
    (declare-const ?akoq Real)
    (assert
      (or (or (= ?akoq ?akop)
          (= ?akoq ?akoo)
          )
        (= ?akop ?akoo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akor Real)
    (declare-const ?akos Real)
    (declare-const ?akot Real)
    (declare-const ?akou Real)
    (assert
      (or (or (= ?akot ?akos)
          (= ?akot ?akor)
          )
        (= ?akos ?akor)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akov Real)
    (declare-const ?akow Real)
    (declare-const ?akox Real)
    (declare-const ?akoy Real)
    (declare-const ?akoz Real)
    (assert
      (or (or (= ?akox ?akow)
          (= ?akox ?akov)
          )
        (= ?akow ?akov)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akpa Real)
    (declare-const ?akpb Real)
    (declare-const ?akpc Real)
    (declare-const ?akpd Real)
    (declare-const ?akpe Real)
    (declare-const ?akpf Real)
    (assert
      (and (or (or (= ?akpc ?akpb)
            (= ?akpc ?akpa)
            )
          (= ?akpb ?akpa)
          )
        (and (and (not (= ?akpf ?akpe))
            (not (= ?akpf ?akpd))
            )
          (not (= ?akpe ?akpd))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akpg Real)
    (declare-const ?akph Real)
    (declare-const ?akpi Real)
    (assert
      (or (or (= ?akpi ?akph)
          (= ?akpi ?akpg)
          )
        (= ?akph ?akpg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akpj Real)
    (declare-const ?akpk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akpl Real)
    (declare-const ?akpm Real)
    (declare-const ?akpn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akpo Real)
    (declare-const ?akpp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akpq Real)
    (declare-const ?akpr Real)
    (declare-const ?akps Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akpt Real)
    (declare-const ?akpu Real)
    (declare-const ?akpv Real)
    (declare-const ?akpw Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?akpu ?akpt))
                (not (= ?akpu ?asi))
                )
              (not (= ?akpt ?asi))
              )
            (or (or (= ?akpw ?akpv)
                (= ?akpw ?asi)
                )
              (= ?akpv ?asi)
              )
            )
          (and (or (or (= ?akpu ?akpt)
                (= ?akpu ?asi)
                )
              (= ?akpt ?asi)
              )
            (and (and (not (= ?akpw ?akpv))
                (not (= ?akpw ?asi))
                )
              (not (= ?akpv ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akpx Real)
    (declare-const ?akpy Real)
    (declare-const ?akpz Real)
    (declare-const ?akqa Real)
    (declare-const ?akqb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akqc Real)
    (declare-const ?akqd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akqe Real)
    (declare-const ?akqf Real)
    (declare-const ?akqg Real)
    (declare-const ?akqh Real)
    (declare-const ?akqi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akqj Real)
    (declare-const ?akqk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akql Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akqm Real)
    (declare-const ?akqn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akqo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akqp Real)
    (declare-const ?akqq Real)
    (assert
      (not (= ?akqp ?akqq))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akqr Real)
    (declare-const ?akqs Real)
    (declare-const ?akqt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akqu Real)
    (declare-const ?akqv Real)
    (declare-const ?akqw Real)
    (declare-const ?akqx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akqy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akqz Real)
    (declare-const ?akra Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akrb Real)
    (declare-const ?akrc Real)
    (declare-const ?akrd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akre Real)
    (declare-const ?akrf Real)
    (declare-const ?akrg Real)
    (declare-const ?akrh Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?akrf ?akre))
                (not (= ?akrf ?fkf))
                )
              (not (= ?akre ?fkf))
              )
            (or (or (= ?akrh ?akrg)
                (= ?akrh ?fkf)
                )
              (= ?akrg ?fkf)
              )
            )
          (and (or (or (= ?akrf ?akre)
                (= ?akrf ?fkf)
                )
              (= ?akre ?fkf)
              )
            (and (and (not (= ?akrh ?akrg))
                (not (= ?akrh ?fkf))
                )
              (not (= ?akrg ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akri Real)
    (declare-const ?akrj Real)
    (declare-const ?akrk Real)
    (declare-const ?akrl Real)
    (declare-const ?akrm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akrn Real)
    (declare-const ?akro Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akrp Real)
    (declare-const ?akrq Real)
    (declare-const ?akrr Real)
    (declare-const ?akrs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akrt Real)
    (declare-const ?akru Real)
    (declare-const ?akrv Real)
    (declare-const ?akrw Real)
    (declare-const ?akrx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akry Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akrz Real)
    (declare-const ?aksa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aksb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aksc Real)
    (declare-const ?aksd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akse Real)
    (declare-const ?aksf Real)
    (declare-const ?aksg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aksh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aksi Real)
    (declare-const ?aksj Real)
    (assert
      (not (= ?aksi ?aksj))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aksk Real)
    (declare-const ?aksl Real)
    (declare-const ?aksm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aksn Real)
    (declare-const ?akso Real)
    (declare-const ?aksp Real)
    (declare-const ?aksq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aksr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akss Real)
    (declare-const ?akst Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aksu Real)
    (declare-const ?aksv Real)
    (declare-const ?aksw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aksx Real)
    (declare-const ?aksy Real)
    (declare-const ?aksz Real)
    (declare-const ?akta Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aksy ?aksx))
                (not (= ?aksy ?mzs))
                )
              (not (= ?aksx ?mzs))
              )
            (or (or (= ?akta ?aksz)
                (= ?akta ?mzs)
                )
              (= ?aksz ?mzs)
              )
            )
          (and (or (or (= ?aksy ?aksx)
                (= ?aksy ?mzs)
                )
              (= ?aksx ?mzs)
              )
            (and (and (not (= ?akta ?aksz))
                (not (= ?akta ?mzs))
                )
              (not (= ?aksz ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aktb Real)
    (declare-const ?aktc Real)
    (declare-const ?aktd Real)
    (declare-const ?akte Real)
    (declare-const ?aktf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aktg Real)
    (declare-const ?akth Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akti Real)
    (declare-const ?aktj Real)
    (declare-const ?aktk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aktl Real)
    (declare-const ?aktm Real)
    (declare-const ?aktn Real)
    (declare-const ?akto Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aktp Real)
    (declare-const ?aktq Real)
    (declare-const ?aktr Real)
    (declare-const ?akts Real)
    (declare-const ?aktt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aktu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aktv Real)
    (declare-const ?aktw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aktx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akty Real)
    (declare-const ?aktz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akua Real)
    (declare-const ?akub Real)
    (declare-const ?akuc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akud Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akue Real)
    (declare-const ?akuf Real)
    (assert
      (not (= ?akue ?akuf))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akug Real)
    (declare-const ?akuh Real)
    (declare-const ?akui Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akuj Real)
    (declare-const ?akuk Real)
    (declare-const ?akul Real)
    (declare-const ?akum Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akun Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akuo Real)
    (declare-const ?akup Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akuq Real)
    (declare-const ?akur Real)
    (declare-const ?akus Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akut Real)
    (declare-const ?akuu Real)
    (declare-const ?akuv Real)
    (declare-const ?akuw Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?akuu ?akut))
                (not (= ?akuu ?zpl))
                )
              (not (= ?akut ?zpl))
              )
            (or (or (= ?akuw ?akuv)
                (= ?akuw ?zpl)
                )
              (= ?akuv ?zpl)
              )
            )
          (and (or (or (= ?akuu ?akut)
                (= ?akuu ?zpl)
                )
              (= ?akut ?zpl)
              )
            (and (and (not (= ?akuw ?akuv))
                (not (= ?akuw ?zpl))
                )
              (not (= ?akuv ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akux Real)
    (declare-const ?akuy Real)
    (declare-const ?akuz Real)
    (declare-const ?akva Real)
    (declare-const ?akvb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akvc Real)
    (declare-const ?akvd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akve Real)
    (declare-const ?akvf Real)
    (declare-const ?akvg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akvh Real)
    (declare-const ?akvi Real)
    (declare-const ?akvj Real)
    (declare-const ?akvk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akvl Real)
    (declare-const ?akvm Real)
    (declare-const ?akvn Real)
    (declare-const ?akvo Real)
    (declare-const ?akvp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akvq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akvr Real)
    (declare-const ?akvs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?akvt Real)
  (declare-const ?akvu Real)
  (declare-const ?akvv Real)
  (assert
    (or (or (= ?akvv ?akvu)
        (= ?akvv ?akvt)
        )
      (= ?akvu ?akvt)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?akvw Real)
    (declare-const ?akvx Real)
    (declare-const ?akvy Real)
    (assert
      (or (or (= ?akvy ?akvx)
          (= ?akvy ?akvw)
          )
        (= ?akvx ?akvw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akvz Real)
    (declare-const ?akwa Real)
    (declare-const ?akwb Real)
    (declare-const ?akwc Real)
    (assert
      (or (or (= ?akwc ?akwb)
          (= ?akwc ?akwa)
          )
        (= ?akwb ?akwa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akwd Real)
    (declare-const ?akwe Real)
    (declare-const ?akwf Real)
    (declare-const ?akwg Real)
    (declare-const ?akwh Real)
    (assert
      (or (or (= ?akwh ?akwg)
          (= ?akwh ?akwf)
          )
        (= ?akwg ?akwf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akwi Real)
    (declare-const ?akwj Real)
    (declare-const ?akwk Real)
    (declare-const ?akwl Real)
    (declare-const ?akwm Real)
    (declare-const ?akwn Real)
    (assert
      (and (and (and (not (= ?akwk ?akwj))
            (not (= ?akwk ?akwi))
            )
          (not (= ?akwj ?akwi))
          )
        (or (or (= ?akwn ?akwm)
            (= ?akwn ?akwl)
            )
          (= ?akwm ?akwl)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akwo Real)
    (declare-const ?akwp Real)
    (declare-const ?akwq Real)
    (assert
      (or (or (= ?akwq ?akwp)
          (= ?akwq ?akwo)
          )
        (= ?akwp ?akwo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akwr Real)
    (declare-const ?akws Real)
    (declare-const ?akwt Real)
    (assert
      (or (or (= ?akwt ?akws)
          (= ?akwt ?akwr)
          )
        (= ?akws ?akwr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akwu Real)
    (declare-const ?akwv Real)
    (declare-const ?akww Real)
    (declare-const ?akwx Real)
    (assert
      (or (or (= ?akww ?akwv)
          (= ?akww ?akwu)
          )
        (= ?akwv ?akwu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akwy Real)
    (declare-const ?akwz Real)
    (declare-const ?akxa Real)
    (declare-const ?akxb Real)
    (declare-const ?akxc Real)
    (assert
      (or (or (= ?akxa ?akwz)
          (= ?akxa ?akwy)
          )
        (= ?akwz ?akwy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akxd Real)
    (declare-const ?akxe Real)
    (declare-const ?akxf Real)
    (declare-const ?akxg Real)
    (declare-const ?akxh Real)
    (declare-const ?akxi Real)
    (assert
      (and (or (or (= ?akxf ?akxe)
            (= ?akxf ?akxd)
            )
          (= ?akxe ?akxd)
          )
        (and (and (not (= ?akxi ?akxh))
            (not (= ?akxi ?akxg))
            )
          (not (= ?akxh ?akxg))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akxj Real)
    (declare-const ?akxk Real)
    (declare-const ?akxl Real)
    (assert
      (or (or (= ?akxl ?akxk)
          (= ?akxl ?akxj)
          )
        (= ?akxk ?akxj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akxm Real)
    (declare-const ?akxn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akxo Real)
    (declare-const ?akxp Real)
    (declare-const ?akxq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akxr Real)
    (declare-const ?akxs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akxt Real)
    (declare-const ?akxu Real)
    (declare-const ?akxv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akxw Real)
    (declare-const ?akxx Real)
    (declare-const ?akxy Real)
    (declare-const ?akxz Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?akxx ?akxw))
                (not (= ?akxx ?asi))
                )
              (not (= ?akxw ?asi))
              )
            (or (or (= ?akxz ?akxy)
                (= ?akxz ?asi)
                )
              (= ?akxy ?asi)
              )
            )
          (and (or (or (= ?akxx ?akxw)
                (= ?akxx ?asi)
                )
              (= ?akxw ?asi)
              )
            (and (and (not (= ?akxz ?akxy))
                (not (= ?akxz ?asi))
                )
              (not (= ?akxy ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akya Real)
    (declare-const ?akyb Real)
    (declare-const ?akyc Real)
    (declare-const ?akyd Real)
    (declare-const ?akye Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akyf Real)
    (declare-const ?akyg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akyh Real)
    (declare-const ?akyi Real)
    (declare-const ?akyj Real)
    (declare-const ?akyk Real)
    (declare-const ?akyl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akym Real)
    (declare-const ?akyn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akyo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akyp Real)
    (declare-const ?akyq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akyr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akys Real)
    (declare-const ?akyt Real)
    (assert
      (not (= ?akys ?akyt))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akyu Real)
    (declare-const ?akyv Real)
    (declare-const ?akyw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akyx Real)
    (declare-const ?akyy Real)
    (declare-const ?akyz Real)
    (declare-const ?akza Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akzb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akzc Real)
    (declare-const ?akzd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akze Real)
    (declare-const ?akzf Real)
    (declare-const ?akzg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akzh Real)
    (declare-const ?akzi Real)
    (declare-const ?akzj Real)
    (declare-const ?akzk Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?akzi ?akzh))
                (not (= ?akzi ?fkf))
                )
              (not (= ?akzh ?fkf))
              )
            (or (or (= ?akzk ?akzj)
                (= ?akzk ?fkf)
                )
              (= ?akzj ?fkf)
              )
            )
          (and (or (or (= ?akzi ?akzh)
                (= ?akzi ?fkf)
                )
              (= ?akzh ?fkf)
              )
            (and (and (not (= ?akzk ?akzj))
                (not (= ?akzk ?fkf))
                )
              (not (= ?akzj ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akzl Real)
    (declare-const ?akzm Real)
    (declare-const ?akzn Real)
    (declare-const ?akzo Real)
    (declare-const ?akzp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akzq Real)
    (declare-const ?akzr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akzs Real)
    (declare-const ?akzt Real)
    (declare-const ?akzu Real)
    (declare-const ?akzv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?akzw Real)
    (declare-const ?akzx Real)
    (declare-const ?akzy Real)
    (declare-const ?akzz Real)
    (declare-const ?alaa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alab Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alac Real)
    (declare-const ?alad Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alae Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alaf Real)
    (declare-const ?alag Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alah Real)
    (declare-const ?alai Real)
    (declare-const ?alaj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alak Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alal Real)
    (declare-const ?alam Real)
    (assert
      (not (= ?alal ?alam))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alan Real)
    (declare-const ?alao Real)
    (declare-const ?alap Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alaq Real)
    (declare-const ?alar Real)
    (declare-const ?alas Real)
    (declare-const ?alat Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alau Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alav Real)
    (declare-const ?alaw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alax Real)
    (declare-const ?alay Real)
    (declare-const ?alaz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alba Real)
    (declare-const ?albb Real)
    (declare-const ?albc Real)
    (declare-const ?albd Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?albb ?alba))
                (not (= ?albb ?mzs))
                )
              (not (= ?alba ?mzs))
              )
            (or (or (= ?albd ?albc)
                (= ?albd ?mzs)
                )
              (= ?albc ?mzs)
              )
            )
          (and (or (or (= ?albb ?alba)
                (= ?albb ?mzs)
                )
              (= ?alba ?mzs)
              )
            (and (and (not (= ?albd ?albc))
                (not (= ?albd ?mzs))
                )
              (not (= ?albc ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?albe Real)
    (declare-const ?albf Real)
    (declare-const ?albg Real)
    (declare-const ?albh Real)
    (declare-const ?albi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?albj Real)
    (declare-const ?albk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?albl Real)
    (declare-const ?albm Real)
    (declare-const ?albn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?albo Real)
    (declare-const ?albp Real)
    (declare-const ?albq Real)
    (declare-const ?albr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?albs Real)
    (declare-const ?albt Real)
    (declare-const ?albu Real)
    (declare-const ?albv Real)
    (declare-const ?albw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?albx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alby Real)
    (declare-const ?albz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alca Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alcb Real)
    (declare-const ?alcc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alcd Real)
    (declare-const ?alce Real)
    (declare-const ?alcf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alcg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alch Real)
    (declare-const ?alci Real)
    (assert
      (not (= ?alch ?alci))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alcj Real)
    (declare-const ?alck Real)
    (declare-const ?alcl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alcm Real)
    (declare-const ?alcn Real)
    (declare-const ?alco Real)
    (declare-const ?alcp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alcq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alcr Real)
    (declare-const ?alcs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alct Real)
    (declare-const ?alcu Real)
    (declare-const ?alcv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alcw Real)
    (declare-const ?alcx Real)
    (declare-const ?alcy Real)
    (declare-const ?alcz Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?alcx ?alcw))
                (not (= ?alcx ?zpl))
                )
              (not (= ?alcw ?zpl))
              )
            (or (or (= ?alcz ?alcy)
                (= ?alcz ?zpl)
                )
              (= ?alcy ?zpl)
              )
            )
          (and (or (or (= ?alcx ?alcw)
                (= ?alcx ?zpl)
                )
              (= ?alcw ?zpl)
              )
            (and (and (not (= ?alcz ?alcy))
                (not (= ?alcz ?zpl))
                )
              (not (= ?alcy ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alda Real)
    (declare-const ?aldb Real)
    (declare-const ?aldc Real)
    (declare-const ?aldd Real)
    (declare-const ?alde Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aldf Real)
    (declare-const ?aldg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aldh Real)
    (declare-const ?aldi Real)
    (declare-const ?aldj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aldk Real)
    (declare-const ?aldl Real)
    (declare-const ?aldm Real)
    (declare-const ?aldn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aldo Real)
    (declare-const ?aldp Real)
    (declare-const ?aldq Real)
    (declare-const ?aldr Real)
    (declare-const ?alds Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aldt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aldu Real)
    (declare-const ?aldv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aldw Real)
  (declare-const ?aldx Real)
  (declare-const ?aldy Real)
  (declare-const ?aldz Real)
  (assert
    (or (or (= ?aldy ?aldx)
        (= ?aldy ?aldw)
        )
      (= ?aldx ?aldw)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?alea Real)
    (declare-const ?aleb Real)
    (declare-const ?alec Real)
    (assert
      (or (or (= ?alec ?aleb)
          (= ?alec ?alea)
          )
        (= ?aleb ?alea)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aled Real)
    (declare-const ?alee Real)
    (declare-const ?alef Real)
    (declare-const ?aleg Real)
    (assert
      (or (or (= ?aleg ?alef)
          (= ?aleg ?alee)
          )
        (= ?alef ?alee)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aleh Real)
    (declare-const ?alei Real)
    (declare-const ?alej Real)
    (declare-const ?alek Real)
    (declare-const ?alel Real)
    (assert
      (or (or (= ?alel ?alek)
          (= ?alel ?alej)
          )
        (= ?alek ?alej)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alem Real)
    (declare-const ?alen Real)
    (declare-const ?aleo Real)
    (declare-const ?alep Real)
    (declare-const ?aleq Real)
    (declare-const ?aler Real)
    (assert
      (and (and (and (not (= ?aleo ?alen))
            (not (= ?aleo ?alem))
            )
          (not (= ?alen ?alem))
          )
        (or (or (= ?aler ?aleq)
            (= ?aler ?alep)
            )
          (= ?aleq ?alep)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ales Real)
    (declare-const ?alet Real)
    (declare-const ?aleu Real)
    (assert
      (or (or (= ?aleu ?alet)
          (= ?aleu ?ales)
          )
        (= ?alet ?ales)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alev Real)
    (declare-const ?alew Real)
    (declare-const ?alex Real)
    (assert
      (or (or (= ?alex ?alew)
          (= ?alex ?alev)
          )
        (= ?alew ?alev)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aley Real)
    (declare-const ?alez Real)
    (declare-const ?alfa Real)
    (declare-const ?alfb Real)
    (assert
      (or (or (= ?alfa ?alez)
          (= ?alfa ?aley)
          )
        (= ?alez ?aley)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alfc Real)
    (declare-const ?alfd Real)
    (declare-const ?alfe Real)
    (declare-const ?alff Real)
    (declare-const ?alfg Real)
    (assert
      (or (or (= ?alfe ?alfd)
          (= ?alfe ?alfc)
          )
        (= ?alfd ?alfc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alfh Real)
    (declare-const ?alfi Real)
    (declare-const ?alfj Real)
    (declare-const ?alfk Real)
    (declare-const ?alfl Real)
    (declare-const ?alfm Real)
    (assert
      (and (or (or (= ?alfj ?alfi)
            (= ?alfj ?alfh)
            )
          (= ?alfi ?alfh)
          )
        (and (and (not (= ?alfm ?alfl))
            (not (= ?alfm ?alfk))
            )
          (not (= ?alfl ?alfk))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alfn Real)
    (declare-const ?alfo Real)
    (declare-const ?alfp Real)
    (assert
      (or (or (= ?alfp ?alfo)
          (= ?alfp ?alfn)
          )
        (= ?alfo ?alfn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alfq Real)
    (declare-const ?alfr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alfs Real)
    (declare-const ?alft Real)
    (declare-const ?alfu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alfv Real)
    (declare-const ?alfw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alfx Real)
    (declare-const ?alfy Real)
    (declare-const ?alfz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alga Real)
    (declare-const ?algb Real)
    (declare-const ?algc Real)
    (declare-const ?algd Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?algb ?alga))
                (not (= ?algb ?asi))
                )
              (not (= ?alga ?asi))
              )
            (or (or (= ?algd ?algc)
                (= ?algd ?asi)
                )
              (= ?algc ?asi)
              )
            )
          (and (or (or (= ?algb ?alga)
                (= ?algb ?asi)
                )
              (= ?alga ?asi)
              )
            (and (and (not (= ?algd ?algc))
                (not (= ?algd ?asi))
                )
              (not (= ?algc ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alge Real)
    (declare-const ?algf Real)
    (declare-const ?algg Real)
    (declare-const ?algh Real)
    (declare-const ?algi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?algj Real)
    (declare-const ?algk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?algl Real)
    (declare-const ?algm Real)
    (declare-const ?algn Real)
    (declare-const ?algo Real)
    (declare-const ?algp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?algq Real)
    (declare-const ?algr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?algs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?algt Real)
    (declare-const ?algu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?algv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?algw Real)
    (declare-const ?algx Real)
    (assert
      (not (= ?algw ?algx))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?algy Real)
    (declare-const ?algz Real)
    (declare-const ?alha Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alhb Real)
    (declare-const ?alhc Real)
    (declare-const ?alhd Real)
    (declare-const ?alhe Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alhf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alhg Real)
    (declare-const ?alhh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alhi Real)
    (declare-const ?alhj Real)
    (declare-const ?alhk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alhl Real)
    (declare-const ?alhm Real)
    (declare-const ?alhn Real)
    (declare-const ?alho Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?alhm ?alhl))
                (not (= ?alhm ?fkf))
                )
              (not (= ?alhl ?fkf))
              )
            (or (or (= ?alho ?alhn)
                (= ?alho ?fkf)
                )
              (= ?alhn ?fkf)
              )
            )
          (and (or (or (= ?alhm ?alhl)
                (= ?alhm ?fkf)
                )
              (= ?alhl ?fkf)
              )
            (and (and (not (= ?alho ?alhn))
                (not (= ?alho ?fkf))
                )
              (not (= ?alhn ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alhp Real)
    (declare-const ?alhq Real)
    (declare-const ?alhr Real)
    (declare-const ?alhs Real)
    (declare-const ?alht Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alhu Real)
    (declare-const ?alhv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alhw Real)
    (declare-const ?alhx Real)
    (declare-const ?alhy Real)
    (declare-const ?alhz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alia Real)
    (declare-const ?alib Real)
    (declare-const ?alic Real)
    (declare-const ?alid Real)
    (declare-const ?alie Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alif Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alig Real)
    (declare-const ?alih Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alii Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alij Real)
    (declare-const ?alik Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alil Real)
    (declare-const ?alim Real)
    (declare-const ?alin Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alio Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alip Real)
    (declare-const ?aliq Real)
    (assert
      (not (= ?alip ?aliq))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alir Real)
    (declare-const ?alis Real)
    (declare-const ?alit Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aliu Real)
    (declare-const ?aliv Real)
    (declare-const ?aliw Real)
    (declare-const ?alix Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aliy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aliz Real)
    (declare-const ?alja Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aljb Real)
    (declare-const ?aljc Real)
    (declare-const ?aljd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alje Real)
    (declare-const ?aljf Real)
    (declare-const ?aljg Real)
    (declare-const ?aljh Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aljf ?alje))
                (not (= ?aljf ?mzs))
                )
              (not (= ?alje ?mzs))
              )
            (or (or (= ?aljh ?aljg)
                (= ?aljh ?mzs)
                )
              (= ?aljg ?mzs)
              )
            )
          (and (or (or (= ?aljf ?alje)
                (= ?aljf ?mzs)
                )
              (= ?alje ?mzs)
              )
            (and (and (not (= ?aljh ?aljg))
                (not (= ?aljh ?mzs))
                )
              (not (= ?aljg ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alji Real)
    (declare-const ?aljj Real)
    (declare-const ?aljk Real)
    (declare-const ?aljl Real)
    (declare-const ?aljm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aljn Real)
    (declare-const ?aljo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aljp Real)
    (declare-const ?aljq Real)
    (declare-const ?aljr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aljs Real)
    (declare-const ?aljt Real)
    (declare-const ?alju Real)
    (declare-const ?aljv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aljw Real)
    (declare-const ?aljx Real)
    (declare-const ?aljy Real)
    (declare-const ?aljz Real)
    (declare-const ?alka Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alkb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alkc Real)
    (declare-const ?alkd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alke Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alkf Real)
    (declare-const ?alkg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alkh Real)
    (declare-const ?alki Real)
    (declare-const ?alkj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alkk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alkl Real)
    (declare-const ?alkm Real)
    (assert
      (not (= ?alkl ?alkm))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alkn Real)
    (declare-const ?alko Real)
    (declare-const ?alkp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alkq Real)
    (declare-const ?alkr Real)
    (declare-const ?alks Real)
    (declare-const ?alkt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alku Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alkv Real)
    (declare-const ?alkw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alkx Real)
    (declare-const ?alky Real)
    (declare-const ?alkz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alla Real)
    (declare-const ?allb Real)
    (declare-const ?allc Real)
    (declare-const ?alld Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?allb ?alla))
                (not (= ?allb ?zpl))
                )
              (not (= ?alla ?zpl))
              )
            (or (or (= ?alld ?allc)
                (= ?alld ?zpl)
                )
              (= ?allc ?zpl)
              )
            )
          (and (or (or (= ?allb ?alla)
                (= ?allb ?zpl)
                )
              (= ?alla ?zpl)
              )
            (and (and (not (= ?alld ?allc))
                (not (= ?alld ?zpl))
                )
              (not (= ?allc ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alle Real)
    (declare-const ?allf Real)
    (declare-const ?allg Real)
    (declare-const ?allh Real)
    (declare-const ?alli Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?allj Real)
    (declare-const ?allk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alll Real)
    (declare-const ?allm Real)
    (declare-const ?alln Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?allo Real)
    (declare-const ?allp Real)
    (declare-const ?allq Real)
    (declare-const ?allr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alls Real)
    (declare-const ?allt Real)
    (declare-const ?allu Real)
    (declare-const ?allv Real)
    (declare-const ?allw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?allx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ally Real)
    (declare-const ?allz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?alma Real)
  (declare-const ?almb Real)
  (declare-const ?almc Real)
  (declare-const ?almd Real)
  (declare-const ?alme Real)
  (assert
    (or (or (= ?almc ?almb)
        (= ?almc ?alma)
        )
      (= ?almb ?alma)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?almf Real)
    (declare-const ?almg Real)
    (declare-const ?almh Real)
    (assert
      (or (or (= ?almh ?almg)
          (= ?almh ?almf)
          )
        (= ?almg ?almf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?almi Real)
    (declare-const ?almj Real)
    (declare-const ?almk Real)
    (declare-const ?alml Real)
    (assert
      (or (or (= ?alml ?almk)
          (= ?alml ?almj)
          )
        (= ?almk ?almj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?almm Real)
    (declare-const ?almn Real)
    (declare-const ?almo Real)
    (declare-const ?almp Real)
    (declare-const ?almq Real)
    (assert
      (or (or (= ?almq ?almp)
          (= ?almq ?almo)
          )
        (= ?almp ?almo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?almr Real)
    (declare-const ?alms Real)
    (declare-const ?almt Real)
    (declare-const ?almu Real)
    (declare-const ?almv Real)
    (declare-const ?almw Real)
    (assert
      (and (and (and (not (= ?almt ?alms))
            (not (= ?almt ?almr))
            )
          (not (= ?alms ?almr))
          )
        (or (or (= ?almw ?almv)
            (= ?almw ?almu)
            )
          (= ?almv ?almu)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?almx Real)
    (declare-const ?almy Real)
    (declare-const ?almz Real)
    (assert
      (or (or (= ?almz ?almy)
          (= ?almz ?almx)
          )
        (= ?almy ?almx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alna Real)
    (declare-const ?alnb Real)
    (declare-const ?alnc Real)
    (assert
      (or (or (= ?alnc ?alnb)
          (= ?alnc ?alna)
          )
        (= ?alnb ?alna)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alnd Real)
    (declare-const ?alne Real)
    (declare-const ?alnf Real)
    (declare-const ?alng Real)
    (assert
      (or (or (= ?alnf ?alne)
          (= ?alnf ?alnd)
          )
        (= ?alne ?alnd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alnh Real)
    (declare-const ?alni Real)
    (declare-const ?alnj Real)
    (declare-const ?alnk Real)
    (declare-const ?alnl Real)
    (assert
      (or (or (= ?alnj ?alni)
          (= ?alnj ?alnh)
          )
        (= ?alni ?alnh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alnm Real)
    (declare-const ?alnn Real)
    (declare-const ?alno Real)
    (declare-const ?alnp Real)
    (declare-const ?alnq Real)
    (declare-const ?alnr Real)
    (assert
      (and (or (or (= ?alno ?alnn)
            (= ?alno ?alnm)
            )
          (= ?alnn ?alnm)
          )
        (and (and (not (= ?alnr ?alnq))
            (not (= ?alnr ?alnp))
            )
          (not (= ?alnq ?alnp))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alns Real)
    (declare-const ?alnt Real)
    (declare-const ?alnu Real)
    (assert
      (or (or (= ?alnu ?alnt)
          (= ?alnu ?alns)
          )
        (= ?alnt ?alns)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alnv Real)
    (declare-const ?alnw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alnx Real)
    (declare-const ?alny Real)
    (declare-const ?alnz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aloa Real)
    (declare-const ?alob Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aloc Real)
    (declare-const ?alod Real)
    (declare-const ?aloe Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alof Real)
    (declare-const ?alog Real)
    (declare-const ?aloh Real)
    (declare-const ?aloi Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?alog ?alof))
                (not (= ?alog ?asi))
                )
              (not (= ?alof ?asi))
              )
            (or (or (= ?aloi ?aloh)
                (= ?aloi ?asi)
                )
              (= ?aloh ?asi)
              )
            )
          (and (or (or (= ?alog ?alof)
                (= ?alog ?asi)
                )
              (= ?alof ?asi)
              )
            (and (and (not (= ?aloi ?aloh))
                (not (= ?aloi ?asi))
                )
              (not (= ?aloh ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aloj Real)
    (declare-const ?alok Real)
    (declare-const ?alol Real)
    (declare-const ?alom Real)
    (declare-const ?alon Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aloo Real)
    (declare-const ?alop Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aloq Real)
    (declare-const ?alor Real)
    (declare-const ?alos Real)
    (declare-const ?alot Real)
    (declare-const ?alou Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alov Real)
    (declare-const ?alow Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alox Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aloy Real)
    (declare-const ?aloz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alpa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alpb Real)
    (declare-const ?alpc Real)
    (assert
      (not (= ?alpb ?alpc))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alpd Real)
    (declare-const ?alpe Real)
    (declare-const ?alpf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alpg Real)
    (declare-const ?alph Real)
    (declare-const ?alpi Real)
    (declare-const ?alpj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alpk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alpl Real)
    (declare-const ?alpm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alpn Real)
    (declare-const ?alpo Real)
    (declare-const ?alpp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alpq Real)
    (declare-const ?alpr Real)
    (declare-const ?alps Real)
    (declare-const ?alpt Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?alpr ?alpq))
                (not (= ?alpr ?fkf))
                )
              (not (= ?alpq ?fkf))
              )
            (or (or (= ?alpt ?alps)
                (= ?alpt ?fkf)
                )
              (= ?alps ?fkf)
              )
            )
          (and (or (or (= ?alpr ?alpq)
                (= ?alpr ?fkf)
                )
              (= ?alpq ?fkf)
              )
            (and (and (not (= ?alpt ?alps))
                (not (= ?alpt ?fkf))
                )
              (not (= ?alps ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alpu Real)
    (declare-const ?alpv Real)
    (declare-const ?alpw Real)
    (declare-const ?alpx Real)
    (declare-const ?alpy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alpz Real)
    (declare-const ?alqa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alqb Real)
    (declare-const ?alqc Real)
    (declare-const ?alqd Real)
    (declare-const ?alqe Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alqf Real)
    (declare-const ?alqg Real)
    (declare-const ?alqh Real)
    (declare-const ?alqi Real)
    (declare-const ?alqj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alqk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alql Real)
    (declare-const ?alqm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alqn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alqo Real)
    (declare-const ?alqp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alqq Real)
    (declare-const ?alqr Real)
    (declare-const ?alqs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alqt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alqu Real)
    (declare-const ?alqv Real)
    (assert
      (not (= ?alqu ?alqv))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alqw Real)
    (declare-const ?alqx Real)
    (declare-const ?alqy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alqz Real)
    (declare-const ?alra Real)
    (declare-const ?alrb Real)
    (declare-const ?alrc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alrd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alre Real)
    (declare-const ?alrf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alrg Real)
    (declare-const ?alrh Real)
    (declare-const ?alri Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alrj Real)
    (declare-const ?alrk Real)
    (declare-const ?alrl Real)
    (declare-const ?alrm Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?alrk ?alrj))
                (not (= ?alrk ?mzs))
                )
              (not (= ?alrj ?mzs))
              )
            (or (or (= ?alrm ?alrl)
                (= ?alrm ?mzs)
                )
              (= ?alrl ?mzs)
              )
            )
          (and (or (or (= ?alrk ?alrj)
                (= ?alrk ?mzs)
                )
              (= ?alrj ?mzs)
              )
            (and (and (not (= ?alrm ?alrl))
                (not (= ?alrm ?mzs))
                )
              (not (= ?alrl ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alrn Real)
    (declare-const ?alro Real)
    (declare-const ?alrp Real)
    (declare-const ?alrq Real)
    (declare-const ?alrr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alrs Real)
    (declare-const ?alrt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alru Real)
    (declare-const ?alrv Real)
    (declare-const ?alrw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alrx Real)
    (declare-const ?alry Real)
    (declare-const ?alrz Real)
    (declare-const ?alsa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alsb Real)
    (declare-const ?alsc Real)
    (declare-const ?alsd Real)
    (declare-const ?alse Real)
    (declare-const ?alsf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alsg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alsh Real)
    (declare-const ?alsi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alsj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alsk Real)
    (declare-const ?alsl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alsm Real)
    (declare-const ?alsn Real)
    (declare-const ?also Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alsp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alsq Real)
    (declare-const ?alsr Real)
    (assert
      (not (= ?alsq ?alsr))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alss Real)
    (declare-const ?alst Real)
    (declare-const ?alsu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alsv Real)
    (declare-const ?alsw Real)
    (declare-const ?alsx Real)
    (declare-const ?alsy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alsz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alta Real)
    (declare-const ?altb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?altc Real)
    (declare-const ?altd Real)
    (declare-const ?alte Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?altf Real)
    (declare-const ?altg Real)
    (declare-const ?alth Real)
    (declare-const ?alti Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?altg ?altf))
                (not (= ?altg ?zpl))
                )
              (not (= ?altf ?zpl))
              )
            (or (or (= ?alti ?alth)
                (= ?alti ?zpl)
                )
              (= ?alth ?zpl)
              )
            )
          (and (or (or (= ?altg ?altf)
                (= ?altg ?zpl)
                )
              (= ?altf ?zpl)
              )
            (and (and (not (= ?alti ?alth))
                (not (= ?alti ?zpl))
                )
              (not (= ?alth ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?altj Real)
    (declare-const ?altk Real)
    (declare-const ?altl Real)
    (declare-const ?altm Real)
    (declare-const ?altn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alto Real)
    (declare-const ?altp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?altq Real)
    (declare-const ?altr Real)
    (declare-const ?alts Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?altt Real)
    (declare-const ?altu Real)
    (declare-const ?altv Real)
    (declare-const ?altw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?altx Real)
    (declare-const ?alty Real)
    (declare-const ?altz Real)
    (declare-const ?alua Real)
    (declare-const ?alub Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aluc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alud Real)
    (declare-const ?alue Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aluf Real)
  (declare-const ?alug Real)
  (declare-const ?aluh Real)
  (declare-const ?alui Real)
  (declare-const ?aluj Real)
  (declare-const ?aluk Real)
  (assert
    (and (or (or (= ?aluh ?alug)
          (= ?aluh ?aluf)
          )
        (= ?alug ?aluf)
        )
      (and (and (not (= ?aluk ?aluj))
          (not (= ?aluk ?alui))
          )
        (not (= ?aluj ?alui))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?alul Real)
    (declare-const ?alum Real)
    (declare-const ?alun Real)
    (assert
      (or (or (= ?alun ?alum)
          (= ?alun ?alul)
          )
        (= ?alum ?alul)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aluo Real)
    (declare-const ?alup Real)
    (declare-const ?aluq Real)
    (declare-const ?alur Real)
    (assert
      (or (or (= ?alur ?aluq)
          (= ?alur ?alup)
          )
        (= ?aluq ?alup)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alus Real)
    (declare-const ?alut Real)
    (declare-const ?aluu Real)
    (declare-const ?aluv Real)
    (declare-const ?aluw Real)
    (assert
      (or (or (= ?aluw ?aluv)
          (= ?aluw ?aluu)
          )
        (= ?aluv ?aluu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alux Real)
    (declare-const ?aluy Real)
    (declare-const ?aluz Real)
    (declare-const ?alva Real)
    (declare-const ?alvb Real)
    (declare-const ?alvc Real)
    (assert
      (and (and (and (not (= ?aluz ?aluy))
            (not (= ?aluz ?alux))
            )
          (not (= ?aluy ?alux))
          )
        (or (or (= ?alvc ?alvb)
            (= ?alvc ?alva)
            )
          (= ?alvb ?alva)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alvd Real)
    (declare-const ?alve Real)
    (declare-const ?alvf Real)
    (assert
      (or (or (= ?alvf ?alve)
          (= ?alvf ?alvd)
          )
        (= ?alve ?alvd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alvg Real)
    (declare-const ?alvh Real)
    (declare-const ?alvi Real)
    (assert
      (or (or (= ?alvi ?alvh)
          (= ?alvi ?alvg)
          )
        (= ?alvh ?alvg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alvj Real)
    (declare-const ?alvk Real)
    (declare-const ?alvl Real)
    (declare-const ?alvm Real)
    (assert
      (or (or (= ?alvl ?alvk)
          (= ?alvl ?alvj)
          )
        (= ?alvk ?alvj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alvn Real)
    (declare-const ?alvo Real)
    (declare-const ?alvp Real)
    (declare-const ?alvq Real)
    (declare-const ?alvr Real)
    (assert
      (or (or (= ?alvp ?alvo)
          (= ?alvp ?alvn)
          )
        (= ?alvo ?alvn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alvs Real)
    (declare-const ?alvt Real)
    (declare-const ?alvu Real)
    (declare-const ?alvv Real)
    (declare-const ?alvw Real)
    (declare-const ?alvx Real)
    (assert
      (and (or (or (= ?alvu ?alvt)
            (= ?alvu ?alvs)
            )
          (= ?alvt ?alvs)
          )
        (and (and (not (= ?alvx ?alvw))
            (not (= ?alvx ?alvv))
            )
          (not (= ?alvw ?alvv))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alvy Real)
    (declare-const ?alvz Real)
    (declare-const ?alwa Real)
    (assert
      (or (or (= ?alwa ?alvz)
          (= ?alwa ?alvy)
          )
        (= ?alvz ?alvy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alwb Real)
    (declare-const ?alwc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alwd Real)
    (declare-const ?alwe Real)
    (declare-const ?alwf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alwg Real)
    (declare-const ?alwh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alwi Real)
    (declare-const ?alwj Real)
    (declare-const ?alwk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alwl Real)
    (declare-const ?alwm Real)
    (declare-const ?alwn Real)
    (declare-const ?alwo Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?alwm ?alwl))
                (not (= ?alwm ?asi))
                )
              (not (= ?alwl ?asi))
              )
            (or (or (= ?alwo ?alwn)
                (= ?alwo ?asi)
                )
              (= ?alwn ?asi)
              )
            )
          (and (or (or (= ?alwm ?alwl)
                (= ?alwm ?asi)
                )
              (= ?alwl ?asi)
              )
            (and (and (not (= ?alwo ?alwn))
                (not (= ?alwo ?asi))
                )
              (not (= ?alwn ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alwp Real)
    (declare-const ?alwq Real)
    (declare-const ?alwr Real)
    (declare-const ?alws Real)
    (declare-const ?alwt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alwu Real)
    (declare-const ?alwv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alww Real)
    (declare-const ?alwx Real)
    (declare-const ?alwy Real)
    (declare-const ?alwz Real)
    (declare-const ?alxa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alxb Real)
    (declare-const ?alxc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alxd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alxe Real)
    (declare-const ?alxf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alxg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alxh Real)
    (declare-const ?alxi Real)
    (assert
      (not (= ?alxh ?alxi))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alxj Real)
    (declare-const ?alxk Real)
    (declare-const ?alxl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alxm Real)
    (declare-const ?alxn Real)
    (declare-const ?alxo Real)
    (declare-const ?alxp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alxq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alxr Real)
    (declare-const ?alxs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alxt Real)
    (declare-const ?alxu Real)
    (declare-const ?alxv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alxw Real)
    (declare-const ?alxx Real)
    (declare-const ?alxy Real)
    (declare-const ?alxz Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?alxx ?alxw))
                (not (= ?alxx ?fkf))
                )
              (not (= ?alxw ?fkf))
              )
            (or (or (= ?alxz ?alxy)
                (= ?alxz ?fkf)
                )
              (= ?alxy ?fkf)
              )
            )
          (and (or (or (= ?alxx ?alxw)
                (= ?alxx ?fkf)
                )
              (= ?alxw ?fkf)
              )
            (and (and (not (= ?alxz ?alxy))
                (not (= ?alxz ?fkf))
                )
              (not (= ?alxy ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alya Real)
    (declare-const ?alyb Real)
    (declare-const ?alyc Real)
    (declare-const ?alyd Real)
    (declare-const ?alye Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alyf Real)
    (declare-const ?alyg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alyh Real)
    (declare-const ?alyi Real)
    (declare-const ?alyj Real)
    (declare-const ?alyk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alyl Real)
    (declare-const ?alym Real)
    (declare-const ?alyn Real)
    (declare-const ?alyo Real)
    (declare-const ?alyp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alyq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alyr Real)
    (declare-const ?alys Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alyt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alyu Real)
    (declare-const ?alyv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alyw Real)
    (declare-const ?alyx Real)
    (declare-const ?alyy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alyz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alza Real)
    (declare-const ?alzb Real)
    (assert
      (not (= ?alza ?alzb))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alzc Real)
    (declare-const ?alzd Real)
    (declare-const ?alze Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alzf Real)
    (declare-const ?alzg Real)
    (declare-const ?alzh Real)
    (declare-const ?alzi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alzj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alzk Real)
    (declare-const ?alzl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alzm Real)
    (declare-const ?alzn Real)
    (declare-const ?alzo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alzp Real)
    (declare-const ?alzq Real)
    (declare-const ?alzr Real)
    (declare-const ?alzs Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?alzq ?alzp))
                (not (= ?alzq ?mzs))
                )
              (not (= ?alzp ?mzs))
              )
            (or (or (= ?alzs ?alzr)
                (= ?alzs ?mzs)
                )
              (= ?alzr ?mzs)
              )
            )
          (and (or (or (= ?alzq ?alzp)
                (= ?alzq ?mzs)
                )
              (= ?alzp ?mzs)
              )
            (and (and (not (= ?alzs ?alzr))
                (not (= ?alzs ?mzs))
                )
              (not (= ?alzr ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alzt Real)
    (declare-const ?alzu Real)
    (declare-const ?alzv Real)
    (declare-const ?alzw Real)
    (declare-const ?alzx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?alzy Real)
    (declare-const ?alzz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amaa Real)
    (declare-const ?amab Real)
    (declare-const ?amac Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amad Real)
    (declare-const ?amae Real)
    (declare-const ?amaf Real)
    (declare-const ?amag Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amah Real)
    (declare-const ?amai Real)
    (declare-const ?amaj Real)
    (declare-const ?amak Real)
    (declare-const ?amal Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amam Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aman Real)
    (declare-const ?amao Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amap Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amaq Real)
    (declare-const ?amar Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amas Real)
    (declare-const ?amat Real)
    (declare-const ?amau Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amav Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amaw Real)
    (declare-const ?amax Real)
    (assert
      (not (= ?amaw ?amax))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amay Real)
    (declare-const ?amaz Real)
    (declare-const ?amba Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ambb Real)
    (declare-const ?ambc Real)
    (declare-const ?ambd Real)
    (declare-const ?ambe Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ambf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ambg Real)
    (declare-const ?ambh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ambi Real)
    (declare-const ?ambj Real)
    (declare-const ?ambk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ambl Real)
    (declare-const ?ambm Real)
    (declare-const ?ambn Real)
    (declare-const ?ambo Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?ambm ?ambl))
                (not (= ?ambm ?zpl))
                )
              (not (= ?ambl ?zpl))
              )
            (or (or (= ?ambo ?ambn)
                (= ?ambo ?zpl)
                )
              (= ?ambn ?zpl)
              )
            )
          (and (or (or (= ?ambm ?ambl)
                (= ?ambm ?zpl)
                )
              (= ?ambl ?zpl)
              )
            (and (and (not (= ?ambo ?ambn))
                (not (= ?ambo ?zpl))
                )
              (not (= ?ambn ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ambp Real)
    (declare-const ?ambq Real)
    (declare-const ?ambr Real)
    (declare-const ?ambs Real)
    (declare-const ?ambt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ambu Real)
    (declare-const ?ambv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ambw Real)
    (declare-const ?ambx Real)
    (declare-const ?amby Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ambz Real)
    (declare-const ?amca Real)
    (declare-const ?amcb Real)
    (declare-const ?amcc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amcd Real)
    (declare-const ?amce Real)
    (declare-const ?amcf Real)
    (declare-const ?amcg Real)
    (declare-const ?amch Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amci Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amcj Real)
    (declare-const ?amck Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?amcl Real)
  (declare-const ?amcm Real)
  (declare-const ?amcn Real)
  (assert
    (or (or (= ?amcn ?amcm)
        (= ?amcn ?amcl)
        )
      (= ?amcm ?amcl)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?amco Real)
    (declare-const ?amcp Real)
    (declare-const ?amcq Real)
    (assert
      (or (or (= ?amcq ?amcp)
          (= ?amcq ?amco)
          )
        (= ?amcp ?amco)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amcr Real)
    (declare-const ?amcs Real)
    (declare-const ?amct Real)
    (declare-const ?amcu Real)
    (assert
      (or (or (= ?amcu ?amct)
          (= ?amcu ?amcs)
          )
        (= ?amct ?amcs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amcv Real)
    (declare-const ?amcw Real)
    (declare-const ?amcx Real)
    (declare-const ?amcy Real)
    (declare-const ?amcz Real)
    (assert
      (or (or (= ?amcz ?amcy)
          (= ?amcz ?amcx)
          )
        (= ?amcy ?amcx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amda Real)
    (declare-const ?amdb Real)
    (declare-const ?amdc Real)
    (declare-const ?amdd Real)
    (declare-const ?amde Real)
    (declare-const ?amdf Real)
    (assert
      (and (and (and (not (= ?amdc ?amdb))
            (not (= ?amdc ?amda))
            )
          (not (= ?amdb ?amda))
          )
        (or (or (= ?amdf ?amde)
            (= ?amdf ?amdd)
            )
          (= ?amde ?amdd)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amdg Real)
    (declare-const ?amdh Real)
    (declare-const ?amdi Real)
    (assert
      (or (or (= ?amdi ?amdh)
          (= ?amdi ?amdg)
          )
        (= ?amdh ?amdg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amdj Real)
    (declare-const ?amdk Real)
    (declare-const ?amdl Real)
    (assert
      (or (or (= ?amdl ?amdk)
          (= ?amdl ?amdj)
          )
        (= ?amdk ?amdj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amdm Real)
    (declare-const ?amdn Real)
    (declare-const ?amdo Real)
    (declare-const ?amdp Real)
    (assert
      (or (or (= ?amdo ?amdn)
          (= ?amdo ?amdm)
          )
        (= ?amdn ?amdm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amdq Real)
    (declare-const ?amdr Real)
    (declare-const ?amds Real)
    (declare-const ?amdt Real)
    (declare-const ?amdu Real)
    (assert
      (or (or (= ?amds ?amdr)
          (= ?amds ?amdq)
          )
        (= ?amdr ?amdq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amdv Real)
    (declare-const ?amdw Real)
    (declare-const ?amdx Real)
    (declare-const ?amdy Real)
    (declare-const ?amdz Real)
    (declare-const ?amea Real)
    (assert
      (and (or (or (= ?amdx ?amdw)
            (= ?amdx ?amdv)
            )
          (= ?amdw ?amdv)
          )
        (and (and (not (= ?amea ?amdz))
            (not (= ?amea ?amdy))
            )
          (not (= ?amdz ?amdy))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ameb Real)
    (declare-const ?amec Real)
    (declare-const ?amed Real)
    (assert
      (or (or (= ?amed ?amec)
          (= ?amed ?ameb)
          )
        (= ?amec ?ameb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amee Real)
    (declare-const ?amef Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ameg Real)
    (declare-const ?ameh Real)
    (declare-const ?amei Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amej Real)
    (declare-const ?amek Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amel Real)
    (declare-const ?amem Real)
    (declare-const ?amen Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ameo Real)
    (declare-const ?amep Real)
    (declare-const ?ameq Real)
    (declare-const ?amer Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?amep ?ameo))
                (not (= ?amep ?asi))
                )
              (not (= ?ameo ?asi))
              )
            (or (or (= ?amer ?ameq)
                (= ?amer ?asi)
                )
              (= ?ameq ?asi)
              )
            )
          (and (or (or (= ?amep ?ameo)
                (= ?amep ?asi)
                )
              (= ?ameo ?asi)
              )
            (and (and (not (= ?amer ?ameq))
                (not (= ?amer ?asi))
                )
              (not (= ?ameq ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ames Real)
    (declare-const ?amet Real)
    (declare-const ?ameu Real)
    (declare-const ?amev Real)
    (declare-const ?amew Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amex Real)
    (declare-const ?amey Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amez Real)
    (declare-const ?amfa Real)
    (declare-const ?amfb Real)
    (declare-const ?amfc Real)
    (declare-const ?amfd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amfe Real)
    (declare-const ?amff Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amfg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amfh Real)
    (declare-const ?amfi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amfj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amfk Real)
    (declare-const ?amfl Real)
    (assert
      (not (= ?amfk ?amfl))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amfm Real)
    (declare-const ?amfn Real)
    (declare-const ?amfo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amfp Real)
    (declare-const ?amfq Real)
    (declare-const ?amfr Real)
    (declare-const ?amfs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amft Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amfu Real)
    (declare-const ?amfv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amfw Real)
    (declare-const ?amfx Real)
    (declare-const ?amfy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amfz Real)
    (declare-const ?amga Real)
    (declare-const ?amgb Real)
    (declare-const ?amgc Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?amga ?amfz))
                (not (= ?amga ?fkf))
                )
              (not (= ?amfz ?fkf))
              )
            (or (or (= ?amgc ?amgb)
                (= ?amgc ?fkf)
                )
              (= ?amgb ?fkf)
              )
            )
          (and (or (or (= ?amga ?amfz)
                (= ?amga ?fkf)
                )
              (= ?amfz ?fkf)
              )
            (and (and (not (= ?amgc ?amgb))
                (not (= ?amgc ?fkf))
                )
              (not (= ?amgb ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amgd Real)
    (declare-const ?amge Real)
    (declare-const ?amgf Real)
    (declare-const ?amgg Real)
    (declare-const ?amgh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amgi Real)
    (declare-const ?amgj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amgk Real)
    (declare-const ?amgl Real)
    (declare-const ?amgm Real)
    (declare-const ?amgn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amgo Real)
    (declare-const ?amgp Real)
    (declare-const ?amgq Real)
    (declare-const ?amgr Real)
    (declare-const ?amgs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amgt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amgu Real)
    (declare-const ?amgv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amgw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amgx Real)
    (declare-const ?amgy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amgz Real)
    (declare-const ?amha Real)
    (declare-const ?amhb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amhc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amhd Real)
    (declare-const ?amhe Real)
    (assert
      (not (= ?amhd ?amhe))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amhf Real)
    (declare-const ?amhg Real)
    (declare-const ?amhh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amhi Real)
    (declare-const ?amhj Real)
    (declare-const ?amhk Real)
    (declare-const ?amhl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amhm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amhn Real)
    (declare-const ?amho Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amhp Real)
    (declare-const ?amhq Real)
    (declare-const ?amhr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amhs Real)
    (declare-const ?amht Real)
    (declare-const ?amhu Real)
    (declare-const ?amhv Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?amht ?amhs))
                (not (= ?amht ?mzs))
                )
              (not (= ?amhs ?mzs))
              )
            (or (or (= ?amhv ?amhu)
                (= ?amhv ?mzs)
                )
              (= ?amhu ?mzs)
              )
            )
          (and (or (or (= ?amht ?amhs)
                (= ?amht ?mzs)
                )
              (= ?amhs ?mzs)
              )
            (and (and (not (= ?amhv ?amhu))
                (not (= ?amhv ?mzs))
                )
              (not (= ?amhu ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amhw Real)
    (declare-const ?amhx Real)
    (declare-const ?amhy Real)
    (declare-const ?amhz Real)
    (declare-const ?amia Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amib Real)
    (declare-const ?amic Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amid Real)
    (declare-const ?amie Real)
    (declare-const ?amif Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amig Real)
    (declare-const ?amih Real)
    (declare-const ?amii Real)
    (declare-const ?amij Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amik Real)
    (declare-const ?amil Real)
    (declare-const ?amim Real)
    (declare-const ?amin Real)
    (declare-const ?amio Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amip Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amiq Real)
    (declare-const ?amir Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amis Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amit Real)
    (declare-const ?amiu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amiv Real)
    (declare-const ?amiw Real)
    (declare-const ?amix Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amiy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amiz Real)
    (declare-const ?amja Real)
    (assert
      (not (= ?amiz ?amja))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amjb Real)
    (declare-const ?amjc Real)
    (declare-const ?amjd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amje Real)
    (declare-const ?amjf Real)
    (declare-const ?amjg Real)
    (declare-const ?amjh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amji Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amjj Real)
    (declare-const ?amjk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amjl Real)
    (declare-const ?amjm Real)
    (declare-const ?amjn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amjo Real)
    (declare-const ?amjp Real)
    (declare-const ?amjq Real)
    (declare-const ?amjr Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?amjp ?amjo))
                (not (= ?amjp ?zpl))
                )
              (not (= ?amjo ?zpl))
              )
            (or (or (= ?amjr ?amjq)
                (= ?amjr ?zpl)
                )
              (= ?amjq ?zpl)
              )
            )
          (and (or (or (= ?amjp ?amjo)
                (= ?amjp ?zpl)
                )
              (= ?amjo ?zpl)
              )
            (and (and (not (= ?amjr ?amjq))
                (not (= ?amjr ?zpl))
                )
              (not (= ?amjq ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amjs Real)
    (declare-const ?amjt Real)
    (declare-const ?amju Real)
    (declare-const ?amjv Real)
    (declare-const ?amjw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amjx Real)
    (declare-const ?amjy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amjz Real)
    (declare-const ?amka Real)
    (declare-const ?amkb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amkc Real)
    (declare-const ?amkd Real)
    (declare-const ?amke Real)
    (declare-const ?amkf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amkg Real)
    (declare-const ?amkh Real)
    (declare-const ?amki Real)
    (declare-const ?amkj Real)
    (declare-const ?amkk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amkl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amkm Real)
    (declare-const ?amkn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?amko Real)
  (declare-const ?amkp Real)
  (push 1)
    (declare-const ?amkq Real)
    (declare-const ?amkr Real)
    (declare-const ?amks Real)
    (assert
      (or (or (= ?amks ?amkr)
          (= ?amks ?amkq)
          )
        (= ?amkr ?amkq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amkt Real)
    (declare-const ?amku Real)
    (declare-const ?amkv Real)
    (declare-const ?amkw Real)
    (assert
      (or (or (= ?amkw ?amkv)
          (= ?amkw ?amku)
          )
        (= ?amkv ?amku)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amkx Real)
    (declare-const ?amky Real)
    (declare-const ?amkz Real)
    (declare-const ?amla Real)
    (declare-const ?amlb Real)
    (assert
      (or (or (= ?amlb ?amla)
          (= ?amlb ?amkz)
          )
        (= ?amla ?amkz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amlc Real)
    (declare-const ?amld Real)
    (declare-const ?amle Real)
    (declare-const ?amlf Real)
    (declare-const ?amlg Real)
    (declare-const ?amlh Real)
    (assert
      (and (and (and (not (= ?amle ?amld))
            (not (= ?amle ?amlc))
            )
          (not (= ?amld ?amlc))
          )
        (or (or (= ?amlh ?amlg)
            (= ?amlh ?amlf)
            )
          (= ?amlg ?amlf)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amli Real)
    (declare-const ?amlj Real)
    (declare-const ?amlk Real)
    (assert
      (or (or (= ?amlk ?amlj)
          (= ?amlk ?amli)
          )
        (= ?amlj ?amli)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amll Real)
    (declare-const ?amlm Real)
    (declare-const ?amln Real)
    (assert
      (or (or (= ?amln ?amlm)
          (= ?amln ?amll)
          )
        (= ?amlm ?amll)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amlo Real)
    (declare-const ?amlp Real)
    (declare-const ?amlq Real)
    (declare-const ?amlr Real)
    (assert
      (or (or (= ?amlq ?amlp)
          (= ?amlq ?amlo)
          )
        (= ?amlp ?amlo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amls Real)
    (declare-const ?amlt Real)
    (declare-const ?amlu Real)
    (declare-const ?amlv Real)
    (declare-const ?amlw Real)
    (assert
      (or (or (= ?amlu ?amlt)
          (= ?amlu ?amls)
          )
        (= ?amlt ?amls)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amlx Real)
    (declare-const ?amly Real)
    (declare-const ?amlz Real)
    (declare-const ?amma Real)
    (declare-const ?ammb Real)
    (declare-const ?ammc Real)
    (assert
      (and (or (or (= ?amlz ?amly)
            (= ?amlz ?amlx)
            )
          (= ?amly ?amlx)
          )
        (and (and (not (= ?ammc ?ammb))
            (not (= ?ammc ?amma))
            )
          (not (= ?ammb ?amma))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ammd Real)
    (declare-const ?amme Real)
    (declare-const ?ammf Real)
    (assert
      (or (or (= ?ammf ?amme)
          (= ?ammf ?ammd)
          )
        (= ?amme ?ammd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ammg Real)
    (declare-const ?ammh Real)
    (declare-const ?ammi Real)
    (declare-const ?ammj Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ammh ?ammg))
                (not (= ?ammh ?asi))
                )
              (not (= ?ammg ?asi))
              )
            (or (or (= ?ammj ?ammi)
                (= ?ammj ?asi)
                )
              (= ?ammi ?asi)
              )
            )
          (and (or (or (= ?ammh ?ammg)
                (= ?ammh ?asi)
                )
              (= ?ammg ?asi)
              )
            (and (and (not (= ?ammj ?ammi))
                (not (= ?ammj ?asi))
                )
              (not (= ?ammi ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ammk Real)
    (declare-const ?amml Real)
    (declare-const ?ammm Real)
    (declare-const ?ammn Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?amml ?ammk))
                (not (= ?amml ?fkf))
                )
              (not (= ?ammk ?fkf))
              )
            (or (or (= ?ammn ?ammm)
                (= ?ammn ?fkf)
                )
              (= ?ammm ?fkf)
              )
            )
          (and (or (or (= ?amml ?ammk)
                (= ?amml ?fkf)
                )
              (= ?ammk ?fkf)
              )
            (and (and (not (= ?ammn ?ammm))
                (not (= ?ammn ?fkf))
                )
              (not (= ?ammm ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ammo Real)
    (declare-const ?ammp Real)
    (declare-const ?ammq Real)
    (declare-const ?ammr Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ammp ?ammo))
                (not (= ?ammp ?mzs))
                )
              (not (= ?ammo ?mzs))
              )
            (or (or (= ?ammr ?ammq)
                (= ?ammr ?mzs)
                )
              (= ?ammq ?mzs)
              )
            )
          (and (or (or (= ?ammp ?ammo)
                (= ?ammp ?mzs)
                )
              (= ?ammo ?mzs)
              )
            (and (and (not (= ?ammr ?ammq))
                (not (= ?ammr ?mzs))
                )
              (not (= ?ammq ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amms Real)
    (declare-const ?ammt Real)
    (declare-const ?ammu Real)
    (declare-const ?ammv Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?ammt ?amms))
                (not (= ?ammt ?zpl))
                )
              (not (= ?amms ?zpl))
              )
            (or (or (= ?ammv ?ammu)
                (= ?ammv ?zpl)
                )
              (= ?ammu ?zpl)
              )
            )
          (and (or (or (= ?ammt ?amms)
                (= ?ammt ?zpl)
                )
              (= ?amms ?zpl)
              )
            (and (and (not (= ?ammv ?ammu))
                (not (= ?ammv ?zpl))
                )
              (not (= ?ammu ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ammw Real)
  (declare-const ?ammx Real)
  (declare-const ?ammy Real)
  (push 1)
    (declare-const ?ammz Real)
    (declare-const ?amna Real)
    (declare-const ?amnb Real)
    (assert
      (or (or (= ?amnb ?amna)
          (= ?amnb ?ammz)
          )
        (= ?amna ?ammz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amnc Real)
    (declare-const ?amnd Real)
    (declare-const ?amne Real)
    (declare-const ?amnf Real)
    (assert
      (or (or (= ?amnf ?amne)
          (= ?amnf ?amnd)
          )
        (= ?amne ?amnd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amng Real)
    (declare-const ?amnh Real)
    (declare-const ?amni Real)
    (declare-const ?amnj Real)
    (declare-const ?amnk Real)
    (assert
      (or (or (= ?amnk ?amnj)
          (= ?amnk ?amni)
          )
        (= ?amnj ?amni)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amnl Real)
    (declare-const ?amnm Real)
    (declare-const ?amnn Real)
    (declare-const ?amno Real)
    (declare-const ?amnp Real)
    (declare-const ?amnq Real)
    (assert
      (and (and (and (not (= ?amnn ?amnm))
            (not (= ?amnn ?amnl))
            )
          (not (= ?amnm ?amnl))
          )
        (or (or (= ?amnq ?amnp)
            (= ?amnq ?amno)
            )
          (= ?amnp ?amno)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amnr Real)
    (declare-const ?amns Real)
    (declare-const ?amnt Real)
    (assert
      (or (or (= ?amnt ?amns)
          (= ?amnt ?amnr)
          )
        (= ?amns ?amnr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amnu Real)
    (declare-const ?amnv Real)
    (declare-const ?amnw Real)
    (assert
      (or (or (= ?amnw ?amnv)
          (= ?amnw ?amnu)
          )
        (= ?amnv ?amnu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amnx Real)
    (declare-const ?amny Real)
    (declare-const ?amnz Real)
    (declare-const ?amoa Real)
    (assert
      (or (or (= ?amnz ?amny)
          (= ?amnz ?amnx)
          )
        (= ?amny ?amnx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amob Real)
    (declare-const ?amoc Real)
    (declare-const ?amod Real)
    (declare-const ?amoe Real)
    (declare-const ?amof Real)
    (assert
      (or (or (= ?amod ?amoc)
          (= ?amod ?amob)
          )
        (= ?amoc ?amob)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amog Real)
    (declare-const ?amoh Real)
    (declare-const ?amoi Real)
    (declare-const ?amoj Real)
    (declare-const ?amok Real)
    (declare-const ?amol Real)
    (assert
      (and (or (or (= ?amoi ?amoh)
            (= ?amoi ?amog)
            )
          (= ?amoh ?amog)
          )
        (and (and (not (= ?amol ?amok))
            (not (= ?amol ?amoj))
            )
          (not (= ?amok ?amoj))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amom Real)
    (declare-const ?amon Real)
    (declare-const ?amoo Real)
    (assert
      (or (or (= ?amoo ?amon)
          (= ?amoo ?amom)
          )
        (= ?amon ?amom)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amop Real)
    (declare-const ?amoq Real)
    (declare-const ?amor Real)
    (declare-const ?amos Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?amoq ?amop))
                (not (= ?amoq ?asi))
                )
              (not (= ?amop ?asi))
              )
            (or (or (= ?amos ?amor)
                (= ?amos ?asi)
                )
              (= ?amor ?asi)
              )
            )
          (and (or (or (= ?amoq ?amop)
                (= ?amoq ?asi)
                )
              (= ?amop ?asi)
              )
            (and (and (not (= ?amos ?amor))
                (not (= ?amos ?asi))
                )
              (not (= ?amor ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amot Real)
    (declare-const ?amou Real)
    (declare-const ?amov Real)
    (declare-const ?amow Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?amou ?amot))
                (not (= ?amou ?fkf))
                )
              (not (= ?amot ?fkf))
              )
            (or (or (= ?amow ?amov)
                (= ?amow ?fkf)
                )
              (= ?amov ?fkf)
              )
            )
          (and (or (or (= ?amou ?amot)
                (= ?amou ?fkf)
                )
              (= ?amot ?fkf)
              )
            (and (and (not (= ?amow ?amov))
                (not (= ?amow ?fkf))
                )
              (not (= ?amov ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amox Real)
    (declare-const ?amoy Real)
    (declare-const ?amoz Real)
    (declare-const ?ampa Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?amoy ?amox))
                (not (= ?amoy ?mzs))
                )
              (not (= ?amox ?mzs))
              )
            (or (or (= ?ampa ?amoz)
                (= ?ampa ?mzs)
                )
              (= ?amoz ?mzs)
              )
            )
          (and (or (or (= ?amoy ?amox)
                (= ?amoy ?mzs)
                )
              (= ?amox ?mzs)
              )
            (and (and (not (= ?ampa ?amoz))
                (not (= ?ampa ?mzs))
                )
              (not (= ?amoz ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ampb Real)
    (declare-const ?ampc Real)
    (declare-const ?ampd Real)
    (declare-const ?ampe Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?ampc ?ampb))
                (not (= ?ampc ?zpl))
                )
              (not (= ?ampb ?zpl))
              )
            (or (or (= ?ampe ?ampd)
                (= ?ampe ?zpl)
                )
              (= ?ampd ?zpl)
              )
            )
          (and (or (or (= ?ampc ?ampb)
                (= ?ampc ?zpl)
                )
              (= ?ampb ?zpl)
              )
            (and (and (not (= ?ampe ?ampd))
                (not (= ?ampe ?zpl))
                )
              (not (= ?ampd ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ampf Real)
  (declare-const ?ampg Real)
  (push 1)
    (declare-const ?amph Real)
    (declare-const ?ampi Real)
    (declare-const ?ampj Real)
    (assert
      (or (or (= ?ampj ?ampi)
          (= ?ampj ?amph)
          )
        (= ?ampi ?amph)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ampk Real)
    (declare-const ?ampl Real)
    (declare-const ?ampm Real)
    (declare-const ?ampn Real)
    (assert
      (or (or (= ?ampn ?ampm)
          (= ?ampn ?ampl)
          )
        (= ?ampm ?ampl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ampo Real)
    (declare-const ?ampp Real)
    (declare-const ?ampq Real)
    (declare-const ?ampr Real)
    (declare-const ?amps Real)
    (assert
      (or (or (= ?amps ?ampr)
          (= ?amps ?ampq)
          )
        (= ?ampr ?ampq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ampt Real)
    (declare-const ?ampu Real)
    (declare-const ?ampv Real)
    (declare-const ?ampw Real)
    (declare-const ?ampx Real)
    (declare-const ?ampy Real)
    (assert
      (and (and (and (not (= ?ampv ?ampu))
            (not (= ?ampv ?ampt))
            )
          (not (= ?ampu ?ampt))
          )
        (or (or (= ?ampy ?ampx)
            (= ?ampy ?ampw)
            )
          (= ?ampx ?ampw)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ampz Real)
    (declare-const ?amqa Real)
    (declare-const ?amqb Real)
    (assert
      (or (or (= ?amqb ?amqa)
          (= ?amqb ?ampz)
          )
        (= ?amqa ?ampz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amqc Real)
    (declare-const ?amqd Real)
    (declare-const ?amqe Real)
    (assert
      (or (or (= ?amqe ?amqd)
          (= ?amqe ?amqc)
          )
        (= ?amqd ?amqc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amqf Real)
    (declare-const ?amqg Real)
    (declare-const ?amqh Real)
    (declare-const ?amqi Real)
    (assert
      (or (or (= ?amqh ?amqg)
          (= ?amqh ?amqf)
          )
        (= ?amqg ?amqf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amqj Real)
    (declare-const ?amqk Real)
    (declare-const ?amql Real)
    (declare-const ?amqm Real)
    (declare-const ?amqn Real)
    (assert
      (or (or (= ?amql ?amqk)
          (= ?amql ?amqj)
          )
        (= ?amqk ?amqj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amqo Real)
    (declare-const ?amqp Real)
    (declare-const ?amqq Real)
    (declare-const ?amqr Real)
    (declare-const ?amqs Real)
    (declare-const ?amqt Real)
    (assert
      (and (or (or (= ?amqq ?amqp)
            (= ?amqq ?amqo)
            )
          (= ?amqp ?amqo)
          )
        (and (and (not (= ?amqt ?amqs))
            (not (= ?amqt ?amqr))
            )
          (not (= ?amqs ?amqr))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amqu Real)
    (declare-const ?amqv Real)
    (declare-const ?amqw Real)
    (assert
      (or (or (= ?amqw ?amqv)
          (= ?amqw ?amqu)
          )
        (= ?amqv ?amqu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amqx Real)
    (declare-const ?amqy Real)
    (declare-const ?amqz Real)
    (declare-const ?amra Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?amqy ?amqx))
                (not (= ?amqy ?asi))
                )
              (not (= ?amqx ?asi))
              )
            (or (or (= ?amra ?amqz)
                (= ?amra ?asi)
                )
              (= ?amqz ?asi)
              )
            )
          (and (or (or (= ?amqy ?amqx)
                (= ?amqy ?asi)
                )
              (= ?amqx ?asi)
              )
            (and (and (not (= ?amra ?amqz))
                (not (= ?amra ?asi))
                )
              (not (= ?amqz ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amrb Real)
    (declare-const ?amrc Real)
    (declare-const ?amrd Real)
    (declare-const ?amre Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?amrc ?amrb))
                (not (= ?amrc ?fkf))
                )
              (not (= ?amrb ?fkf))
              )
            (or (or (= ?amre ?amrd)
                (= ?amre ?fkf)
                )
              (= ?amrd ?fkf)
              )
            )
          (and (or (or (= ?amrc ?amrb)
                (= ?amrc ?fkf)
                )
              (= ?amrb ?fkf)
              )
            (and (and (not (= ?amre ?amrd))
                (not (= ?amre ?fkf))
                )
              (not (= ?amrd ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amrf Real)
    (declare-const ?amrg Real)
    (declare-const ?amrh Real)
    (declare-const ?amri Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?amrg ?amrf))
                (not (= ?amrg ?mzs))
                )
              (not (= ?amrf ?mzs))
              )
            (or (or (= ?amri ?amrh)
                (= ?amri ?mzs)
                )
              (= ?amrh ?mzs)
              )
            )
          (and (or (or (= ?amrg ?amrf)
                (= ?amrg ?mzs)
                )
              (= ?amrf ?mzs)
              )
            (and (and (not (= ?amri ?amrh))
                (not (= ?amri ?mzs))
                )
              (not (= ?amrh ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amrj Real)
    (declare-const ?amrk Real)
    (declare-const ?amrl Real)
    (declare-const ?amrm Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?amrk ?amrj))
                (not (= ?amrk ?zpl))
                )
              (not (= ?amrj ?zpl))
              )
            (or (or (= ?amrm ?amrl)
                (= ?amrm ?zpl)
                )
              (= ?amrl ?zpl)
              )
            )
          (and (or (or (= ?amrk ?amrj)
                (= ?amrk ?zpl)
                )
              (= ?amrj ?zpl)
              )
            (and (and (not (= ?amrm ?amrl))
                (not (= ?amrm ?zpl))
                )
              (not (= ?amrl ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?amrn Real)
  (declare-const ?amro Real)
  (declare-const ?amrp Real)
  (push 1)
    (declare-const ?amrq Real)
    (declare-const ?amrr Real)
    (declare-const ?amrs Real)
    (assert
      (or (or (= ?amrs ?amrr)
          (= ?amrs ?amrq)
          )
        (= ?amrr ?amrq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amrt Real)
    (declare-const ?amru Real)
    (declare-const ?amrv Real)
    (declare-const ?amrw Real)
    (assert
      (or (or (= ?amrw ?amrv)
          (= ?amrw ?amru)
          )
        (= ?amrv ?amru)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amrx Real)
    (declare-const ?amry Real)
    (declare-const ?amrz Real)
    (declare-const ?amsa Real)
    (declare-const ?amsb Real)
    (assert
      (or (or (= ?amsb ?amsa)
          (= ?amsb ?amrz)
          )
        (= ?amsa ?amrz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amsc Real)
    (declare-const ?amsd Real)
    (declare-const ?amse Real)
    (declare-const ?amsf Real)
    (declare-const ?amsg Real)
    (declare-const ?amsh Real)
    (assert
      (and (and (and (not (= ?amse ?amsd))
            (not (= ?amse ?amsc))
            )
          (not (= ?amsd ?amsc))
          )
        (or (or (= ?amsh ?amsg)
            (= ?amsh ?amsf)
            )
          (= ?amsg ?amsf)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amsi Real)
    (declare-const ?amsj Real)
    (declare-const ?amsk Real)
    (assert
      (or (or (= ?amsk ?amsj)
          (= ?amsk ?amsi)
          )
        (= ?amsj ?amsi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amsl Real)
    (declare-const ?amsm Real)
    (declare-const ?amsn Real)
    (assert
      (or (or (= ?amsn ?amsm)
          (= ?amsn ?amsl)
          )
        (= ?amsm ?amsl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amso Real)
    (declare-const ?amsp Real)
    (declare-const ?amsq Real)
    (declare-const ?amsr Real)
    (assert
      (or (or (= ?amsq ?amsp)
          (= ?amsq ?amso)
          )
        (= ?amsp ?amso)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amss Real)
    (declare-const ?amst Real)
    (declare-const ?amsu Real)
    (declare-const ?amsv Real)
    (declare-const ?amsw Real)
    (assert
      (or (or (= ?amsu ?amst)
          (= ?amsu ?amss)
          )
        (= ?amst ?amss)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amsx Real)
    (declare-const ?amsy Real)
    (declare-const ?amsz Real)
    (declare-const ?amta Real)
    (declare-const ?amtb Real)
    (declare-const ?amtc Real)
    (assert
      (and (or (or (= ?amsz ?amsy)
            (= ?amsz ?amsx)
            )
          (= ?amsy ?amsx)
          )
        (and (and (not (= ?amtc ?amtb))
            (not (= ?amtc ?amta))
            )
          (not (= ?amtb ?amta))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amtd Real)
    (declare-const ?amte Real)
    (declare-const ?amtf Real)
    (assert
      (or (or (= ?amtf ?amte)
          (= ?amtf ?amtd)
          )
        (= ?amte ?amtd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amtg Real)
    (declare-const ?amth Real)
    (declare-const ?amti Real)
    (declare-const ?amtj Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?amth ?amtg))
                (not (= ?amth ?asi))
                )
              (not (= ?amtg ?asi))
              )
            (or (or (= ?amtj ?amti)
                (= ?amtj ?asi)
                )
              (= ?amti ?asi)
              )
            )
          (and (or (or (= ?amth ?amtg)
                (= ?amth ?asi)
                )
              (= ?amtg ?asi)
              )
            (and (and (not (= ?amtj ?amti))
                (not (= ?amtj ?asi))
                )
              (not (= ?amti ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amtk Real)
    (declare-const ?amtl Real)
    (declare-const ?amtm Real)
    (declare-const ?amtn Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?amtl ?amtk))
                (not (= ?amtl ?fkf))
                )
              (not (= ?amtk ?fkf))
              )
            (or (or (= ?amtn ?amtm)
                (= ?amtn ?fkf)
                )
              (= ?amtm ?fkf)
              )
            )
          (and (or (or (= ?amtl ?amtk)
                (= ?amtl ?fkf)
                )
              (= ?amtk ?fkf)
              )
            (and (and (not (= ?amtn ?amtm))
                (not (= ?amtn ?fkf))
                )
              (not (= ?amtm ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amto Real)
    (declare-const ?amtp Real)
    (declare-const ?amtq Real)
    (declare-const ?amtr Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?amtp ?amto))
                (not (= ?amtp ?mzs))
                )
              (not (= ?amto ?mzs))
              )
            (or (or (= ?amtr ?amtq)
                (= ?amtr ?mzs)
                )
              (= ?amtq ?mzs)
              )
            )
          (and (or (or (= ?amtp ?amto)
                (= ?amtp ?mzs)
                )
              (= ?amto ?mzs)
              )
            (and (and (not (= ?amtr ?amtq))
                (not (= ?amtr ?mzs))
                )
              (not (= ?amtq ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amts Real)
    (declare-const ?amtt Real)
    (declare-const ?amtu Real)
    (declare-const ?amtv Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?amtt ?amts))
                (not (= ?amtt ?zpl))
                )
              (not (= ?amts ?zpl))
              )
            (or (or (= ?amtv ?amtu)
                (= ?amtv ?zpl)
                )
              (= ?amtu ?zpl)
              )
            )
          (and (or (or (= ?amtt ?amts)
                (= ?amtt ?zpl)
                )
              (= ?amts ?zpl)
              )
            (and (and (not (= ?amtv ?amtu))
                (not (= ?amtv ?zpl))
                )
              (not (= ?amtu ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?amtw Real)
  (declare-const ?amtx Real)
  (declare-const ?amty Real)
  (declare-const ?amtz Real)
  (assert
    (exists ((?asi Real) )(or (and (and (and (not (= ?amtx ?amtw))
              (not (= ?amtx ?asi))
              )
            (not (= ?amtw ?asi))
            )
          (or (or (= ?amtz ?amty)
              (= ?amtz ?asi)
              )
            (= ?amty ?asi)
            )
          )
        (and (or (or (= ?amtx ?amtw)
              (= ?amtx ?asi)
              )
            (= ?amtw ?asi)
            )
          (and (and (not (= ?amtz ?amty))
              (not (= ?amtz ?asi))
              )
            (not (= ?amty ?asi))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?amua Real)
    (declare-const ?amub Real)
    (declare-const ?amuc Real)
    (assert
      (or (or (= ?amuc ?amub)
          (= ?amuc ?amua)
          )
        (= ?amub ?amua)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amud Real)
    (declare-const ?amue Real)
    (declare-const ?amuf Real)
    (declare-const ?amug Real)
    (assert
      (or (or (= ?amug ?amuf)
          (= ?amug ?amue)
          )
        (= ?amuf ?amue)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amuh Real)
    (declare-const ?amui Real)
    (declare-const ?amuj Real)
    (declare-const ?amuk Real)
    (declare-const ?amul Real)
    (assert
      (or (or (= ?amul ?amuk)
          (= ?amul ?amuj)
          )
        (= ?amuk ?amuj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amum Real)
    (declare-const ?amun Real)
    (declare-const ?amuo Real)
    (declare-const ?amup Real)
    (declare-const ?amuq Real)
    (declare-const ?amur Real)
    (assert
      (and (and (and (not (= ?amuo ?amun))
            (not (= ?amuo ?amum))
            )
          (not (= ?amun ?amum))
          )
        (or (or (= ?amur ?amuq)
            (= ?amur ?amup)
            )
          (= ?amuq ?amup)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amus Real)
    (declare-const ?amut Real)
    (declare-const ?amuu Real)
    (assert
      (or (or (= ?amuu ?amut)
          (= ?amuu ?amus)
          )
        (= ?amut ?amus)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amuv Real)
    (declare-const ?amuw Real)
    (declare-const ?amux Real)
    (assert
      (or (or (= ?amux ?amuw)
          (= ?amux ?amuv)
          )
        (= ?amuw ?amuv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amuy Real)
    (declare-const ?amuz Real)
    (declare-const ?amva Real)
    (declare-const ?amvb Real)
    (assert
      (or (or (= ?amva ?amuz)
          (= ?amva ?amuy)
          )
        (= ?amuz ?amuy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amvc Real)
    (declare-const ?amvd Real)
    (declare-const ?amve Real)
    (declare-const ?amvf Real)
    (declare-const ?amvg Real)
    (assert
      (or (or (= ?amve ?amvd)
          (= ?amve ?amvc)
          )
        (= ?amvd ?amvc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amvh Real)
    (declare-const ?amvi Real)
    (declare-const ?amvj Real)
    (declare-const ?amvk Real)
    (declare-const ?amvl Real)
    (declare-const ?amvm Real)
    (assert
      (and (or (or (= ?amvj ?amvi)
            (= ?amvj ?amvh)
            )
          (= ?amvi ?amvh)
          )
        (and (and (not (= ?amvm ?amvl))
            (not (= ?amvm ?amvk))
            )
          (not (= ?amvl ?amvk))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amvn Real)
    (declare-const ?amvo Real)
    (declare-const ?amvp Real)
    (assert
      (or (or (= ?amvp ?amvo)
          (= ?amvp ?amvn)
          )
        (= ?amvo ?amvn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amvq Real)
    (declare-const ?amvr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amvs Real)
    (declare-const ?amvt Real)
    (declare-const ?amvu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amvv Real)
    (declare-const ?amvw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amvx Real)
    (declare-const ?amvy Real)
    (declare-const ?amvz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amwa Real)
    (declare-const ?amwb Real)
    (declare-const ?amwc Real)
    (declare-const ?amwd Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?amwb ?amwa))
                (not (= ?amwb ?asi))
                )
              (not (= ?amwa ?asi))
              )
            (or (or (= ?amwd ?amwc)
                (= ?amwd ?asi)
                )
              (= ?amwc ?asi)
              )
            )
          (and (or (or (= ?amwb ?amwa)
                (= ?amwb ?asi)
                )
              (= ?amwa ?asi)
              )
            (and (and (not (= ?amwd ?amwc))
                (not (= ?amwd ?asi))
                )
              (not (= ?amwc ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amwe Real)
    (declare-const ?amwf Real)
    (declare-const ?amwg Real)
    (declare-const ?amwh Real)
    (declare-const ?amwi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amwj Real)
    (declare-const ?amwk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amwl Real)
    (declare-const ?amwm Real)
    (declare-const ?amwn Real)
    (declare-const ?amwo Real)
    (declare-const ?amwp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amwq Real)
    (declare-const ?amwr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amws Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amwt Real)
    (declare-const ?amwu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amwv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amww Real)
    (declare-const ?amwx Real)
    (assert
      (not (= ?amww ?amwx))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amwy Real)
    (declare-const ?amwz Real)
    (declare-const ?amxa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amxb Real)
    (declare-const ?amxc Real)
    (declare-const ?amxd Real)
    (declare-const ?amxe Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amxf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amxg Real)
    (declare-const ?amxh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amxi Real)
    (declare-const ?amxj Real)
    (declare-const ?amxk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amxl Real)
    (declare-const ?amxm Real)
    (declare-const ?amxn Real)
    (declare-const ?amxo Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?amxm ?amxl))
                (not (= ?amxm ?fkf))
                )
              (not (= ?amxl ?fkf))
              )
            (or (or (= ?amxo ?amxn)
                (= ?amxo ?fkf)
                )
              (= ?amxn ?fkf)
              )
            )
          (and (or (or (= ?amxm ?amxl)
                (= ?amxm ?fkf)
                )
              (= ?amxl ?fkf)
              )
            (and (and (not (= ?amxo ?amxn))
                (not (= ?amxo ?fkf))
                )
              (not (= ?amxn ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amxp Real)
    (declare-const ?amxq Real)
    (declare-const ?amxr Real)
    (declare-const ?amxs Real)
    (declare-const ?amxt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amxu Real)
    (declare-const ?amxv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amxw Real)
    (declare-const ?amxx Real)
    (declare-const ?amxy Real)
    (declare-const ?amxz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amya Real)
    (declare-const ?amyb Real)
    (declare-const ?amyc Real)
    (declare-const ?amyd Real)
    (declare-const ?amye Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amyf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amyg Real)
    (declare-const ?amyh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amyi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amyj Real)
    (declare-const ?amyk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amyl Real)
    (declare-const ?amym Real)
    (declare-const ?amyn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amyo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amyp Real)
    (declare-const ?amyq Real)
    (assert
      (not (= ?amyp ?amyq))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amyr Real)
    (declare-const ?amys Real)
    (declare-const ?amyt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amyu Real)
    (declare-const ?amyv Real)
    (declare-const ?amyw Real)
    (declare-const ?amyx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amyy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amyz Real)
    (declare-const ?amza Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amzb Real)
    (declare-const ?amzc Real)
    (declare-const ?amzd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amze Real)
    (declare-const ?amzf Real)
    (declare-const ?amzg Real)
    (declare-const ?amzh Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?amzf ?amze))
                (not (= ?amzf ?mzs))
                )
              (not (= ?amze ?mzs))
              )
            (or (or (= ?amzh ?amzg)
                (= ?amzh ?mzs)
                )
              (= ?amzg ?mzs)
              )
            )
          (and (or (or (= ?amzf ?amze)
                (= ?amzf ?mzs)
                )
              (= ?amze ?mzs)
              )
            (and (and (not (= ?amzh ?amzg))
                (not (= ?amzh ?mzs))
                )
              (not (= ?amzg ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amzi Real)
    (declare-const ?amzj Real)
    (declare-const ?amzk Real)
    (declare-const ?amzl Real)
    (declare-const ?amzm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amzn Real)
    (declare-const ?amzo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amzp Real)
    (declare-const ?amzq Real)
    (declare-const ?amzr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amzs Real)
    (declare-const ?amzt Real)
    (declare-const ?amzu Real)
    (declare-const ?amzv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?amzw Real)
    (declare-const ?amzx Real)
    (declare-const ?amzy Real)
    (declare-const ?amzz Real)
    (declare-const ?anaa Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anab Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anac Real)
    (declare-const ?anad Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anae Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anaf Real)
    (declare-const ?anag Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anah Real)
    (declare-const ?anai Real)
    (declare-const ?anaj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anak Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anal Real)
    (declare-const ?anam Real)
    (assert
      (not (= ?anal ?anam))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anan Real)
    (declare-const ?anao Real)
    (declare-const ?anap Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anaq Real)
    (declare-const ?anar Real)
    (declare-const ?anas Real)
    (declare-const ?anat Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anau Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anav Real)
    (declare-const ?anaw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anax Real)
    (declare-const ?anay Real)
    (declare-const ?anaz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anba Real)
    (declare-const ?anbb Real)
    (declare-const ?anbc Real)
    (declare-const ?anbd Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?anbb ?anba))
                (not (= ?anbb ?zpl))
                )
              (not (= ?anba ?zpl))
              )
            (or (or (= ?anbd ?anbc)
                (= ?anbd ?zpl)
                )
              (= ?anbc ?zpl)
              )
            )
          (and (or (or (= ?anbb ?anba)
                (= ?anbb ?zpl)
                )
              (= ?anba ?zpl)
              )
            (and (and (not (= ?anbd ?anbc))
                (not (= ?anbd ?zpl))
                )
              (not (= ?anbc ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anbe Real)
    (declare-const ?anbf Real)
    (declare-const ?anbg Real)
    (declare-const ?anbh Real)
    (declare-const ?anbi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anbj Real)
    (declare-const ?anbk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anbl Real)
    (declare-const ?anbm Real)
    (declare-const ?anbn Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anbo Real)
    (declare-const ?anbp Real)
    (declare-const ?anbq Real)
    (declare-const ?anbr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anbs Real)
    (declare-const ?anbt Real)
    (declare-const ?anbu Real)
    (declare-const ?anbv Real)
    (declare-const ?anbw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anbx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anby Real)
    (declare-const ?anbz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?anca Real)
  (declare-const ?ancb Real)
  (declare-const ?ancc Real)
  (declare-const ?ancd Real)
  (declare-const ?ance Real)
  (push 1)
    (declare-const ?ancf Real)
    (declare-const ?ancg Real)
    (declare-const ?anch Real)
    (assert
      (or (or (= ?anch ?ancg)
          (= ?anch ?ancf)
          )
        (= ?ancg ?ancf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anci Real)
    (declare-const ?ancj Real)
    (declare-const ?anck Real)
    (declare-const ?ancl Real)
    (assert
      (or (or (= ?ancl ?anck)
          (= ?ancl ?ancj)
          )
        (= ?anck ?ancj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ancm Real)
    (declare-const ?ancn Real)
    (declare-const ?anco Real)
    (declare-const ?ancp Real)
    (declare-const ?ancq Real)
    (assert
      (or (or (= ?ancq ?ancp)
          (= ?ancq ?anco)
          )
        (= ?ancp ?anco)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ancr Real)
    (declare-const ?ancs Real)
    (declare-const ?anct Real)
    (declare-const ?ancu Real)
    (declare-const ?ancv Real)
    (declare-const ?ancw Real)
    (assert
      (and (and (and (not (= ?anct ?ancs))
            (not (= ?anct ?ancr))
            )
          (not (= ?ancs ?ancr))
          )
        (or (or (= ?ancw ?ancv)
            (= ?ancw ?ancu)
            )
          (= ?ancv ?ancu)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ancx Real)
    (declare-const ?ancy Real)
    (declare-const ?ancz Real)
    (assert
      (or (or (= ?ancz ?ancy)
          (= ?ancz ?ancx)
          )
        (= ?ancy ?ancx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anda Real)
    (declare-const ?andb Real)
    (declare-const ?andc Real)
    (assert
      (or (or (= ?andc ?andb)
          (= ?andc ?anda)
          )
        (= ?andb ?anda)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?andd Real)
    (declare-const ?ande Real)
    (declare-const ?andf Real)
    (declare-const ?andg Real)
    (assert
      (or (or (= ?andf ?ande)
          (= ?andf ?andd)
          )
        (= ?ande ?andd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?andh Real)
    (declare-const ?andi Real)
    (declare-const ?andj Real)
    (declare-const ?andk Real)
    (declare-const ?andl Real)
    (assert
      (or (or (= ?andj ?andi)
          (= ?andj ?andh)
          )
        (= ?andi ?andh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?andm Real)
    (declare-const ?andn Real)
    (declare-const ?ando Real)
    (declare-const ?andp Real)
    (declare-const ?andq Real)
    (declare-const ?andr Real)
    (assert
      (and (or (or (= ?ando ?andn)
            (= ?ando ?andm)
            )
          (= ?andn ?andm)
          )
        (and (and (not (= ?andr ?andq))
            (not (= ?andr ?andp))
            )
          (not (= ?andq ?andp))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ands Real)
    (declare-const ?andt Real)
    (declare-const ?andu Real)
    (assert
      (or (or (= ?andu ?andt)
          (= ?andu ?ands)
          )
        (= ?andt ?ands)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?andv Real)
    (declare-const ?andw Real)
    (declare-const ?andx Real)
    (declare-const ?andy Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?andw ?andv))
                (not (= ?andw ?asi))
                )
              (not (= ?andv ?asi))
              )
            (or (or (= ?andy ?andx)
                (= ?andy ?asi)
                )
              (= ?andx ?asi)
              )
            )
          (and (or (or (= ?andw ?andv)
                (= ?andw ?asi)
                )
              (= ?andv ?asi)
              )
            (and (and (not (= ?andy ?andx))
                (not (= ?andy ?asi))
                )
              (not (= ?andx ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?andz Real)
    (declare-const ?anea Real)
    (declare-const ?aneb Real)
    (declare-const ?anec Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?anea ?andz))
                (not (= ?anea ?fkf))
                )
              (not (= ?andz ?fkf))
              )
            (or (or (= ?anec ?aneb)
                (= ?anec ?fkf)
                )
              (= ?aneb ?fkf)
              )
            )
          (and (or (or (= ?anea ?andz)
                (= ?anea ?fkf)
                )
              (= ?andz ?fkf)
              )
            (and (and (not (= ?anec ?aneb))
                (not (= ?anec ?fkf))
                )
              (not (= ?aneb ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aned Real)
    (declare-const ?anee Real)
    (declare-const ?anef Real)
    (declare-const ?aneg Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?anee ?aned))
                (not (= ?anee ?mzs))
                )
              (not (= ?aned ?mzs))
              )
            (or (or (= ?aneg ?anef)
                (= ?aneg ?mzs)
                )
              (= ?anef ?mzs)
              )
            )
          (and (or (or (= ?anee ?aned)
                (= ?anee ?mzs)
                )
              (= ?aned ?mzs)
              )
            (and (and (not (= ?aneg ?anef))
                (not (= ?aneg ?mzs))
                )
              (not (= ?anef ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aneh Real)
    (declare-const ?anei Real)
    (declare-const ?anej Real)
    (declare-const ?anek Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?anei ?aneh))
                (not (= ?anei ?zpl))
                )
              (not (= ?aneh ?zpl))
              )
            (or (or (= ?anek ?anej)
                (= ?anek ?zpl)
                )
              (= ?anej ?zpl)
              )
            )
          (and (or (or (= ?anei ?aneh)
                (= ?anei ?zpl)
                )
              (= ?aneh ?zpl)
              )
            (and (and (not (= ?anek ?anej))
                (not (= ?anek ?zpl))
                )
              (not (= ?anej ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?anel Real)
  (declare-const ?anem Real)
  (push 1)
    (declare-const ?anen Real)
    (declare-const ?aneo Real)
    (declare-const ?anep Real)
    (assert
      (or (or (= ?anep ?aneo)
          (= ?anep ?anen)
          )
        (= ?aneo ?anen)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aneq Real)
    (declare-const ?aner Real)
    (declare-const ?anes Real)
    (declare-const ?anet Real)
    (assert
      (or (or (= ?anet ?anes)
          (= ?anet ?aner)
          )
        (= ?anes ?aner)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aneu Real)
    (declare-const ?anev Real)
    (declare-const ?anew Real)
    (declare-const ?anex Real)
    (declare-const ?aney Real)
    (assert
      (or (or (= ?aney ?anex)
          (= ?aney ?anew)
          )
        (= ?anex ?anew)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anez Real)
    (declare-const ?anfa Real)
    (declare-const ?anfb Real)
    (declare-const ?anfc Real)
    (declare-const ?anfd Real)
    (declare-const ?anfe Real)
    (assert
      (and (and (and (not (= ?anfb ?anfa))
            (not (= ?anfb ?anez))
            )
          (not (= ?anfa ?anez))
          )
        (or (or (= ?anfe ?anfd)
            (= ?anfe ?anfc)
            )
          (= ?anfd ?anfc)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anff Real)
    (declare-const ?anfg Real)
    (declare-const ?anfh Real)
    (assert
      (or (or (= ?anfh ?anfg)
          (= ?anfh ?anff)
          )
        (= ?anfg ?anff)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anfi Real)
    (declare-const ?anfj Real)
    (declare-const ?anfk Real)
    (assert
      (or (or (= ?anfk ?anfj)
          (= ?anfk ?anfi)
          )
        (= ?anfj ?anfi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anfl Real)
    (declare-const ?anfm Real)
    (declare-const ?anfn Real)
    (declare-const ?anfo Real)
    (assert
      (or (or (= ?anfn ?anfm)
          (= ?anfn ?anfl)
          )
        (= ?anfm ?anfl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anfp Real)
    (declare-const ?anfq Real)
    (declare-const ?anfr Real)
    (declare-const ?anfs Real)
    (declare-const ?anft Real)
    (assert
      (or (or (= ?anfr ?anfq)
          (= ?anfr ?anfp)
          )
        (= ?anfq ?anfp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anfu Real)
    (declare-const ?anfv Real)
    (declare-const ?anfw Real)
    (declare-const ?anfx Real)
    (declare-const ?anfy Real)
    (declare-const ?anfz Real)
    (assert
      (and (or (or (= ?anfw ?anfv)
            (= ?anfw ?anfu)
            )
          (= ?anfv ?anfu)
          )
        (and (and (not (= ?anfz ?anfy))
            (not (= ?anfz ?anfx))
            )
          (not (= ?anfy ?anfx))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anga Real)
    (declare-const ?angb Real)
    (declare-const ?angc Real)
    (assert
      (or (or (= ?angc ?angb)
          (= ?angc ?anga)
          )
        (= ?angb ?anga)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?angd Real)
    (declare-const ?ange Real)
    (declare-const ?angf Real)
    (declare-const ?angg Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ange ?angd))
                (not (= ?ange ?asi))
                )
              (not (= ?angd ?asi))
              )
            (or (or (= ?angg ?angf)
                (= ?angg ?asi)
                )
              (= ?angf ?asi)
              )
            )
          (and (or (or (= ?ange ?angd)
                (= ?ange ?asi)
                )
              (= ?angd ?asi)
              )
            (and (and (not (= ?angg ?angf))
                (not (= ?angg ?asi))
                )
              (not (= ?angf ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?angh Real)
    (declare-const ?angi Real)
    (declare-const ?angj Real)
    (declare-const ?angk Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?angi ?angh))
                (not (= ?angi ?fkf))
                )
              (not (= ?angh ?fkf))
              )
            (or (or (= ?angk ?angj)
                (= ?angk ?fkf)
                )
              (= ?angj ?fkf)
              )
            )
          (and (or (or (= ?angi ?angh)
                (= ?angi ?fkf)
                )
              (= ?angh ?fkf)
              )
            (and (and (not (= ?angk ?angj))
                (not (= ?angk ?fkf))
                )
              (not (= ?angj ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?angl Real)
    (declare-const ?angm Real)
    (declare-const ?angn Real)
    (declare-const ?ango Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?angm ?angl))
                (not (= ?angm ?mzs))
                )
              (not (= ?angl ?mzs))
              )
            (or (or (= ?ango ?angn)
                (= ?ango ?mzs)
                )
              (= ?angn ?mzs)
              )
            )
          (and (or (or (= ?angm ?angl)
                (= ?angm ?mzs)
                )
              (= ?angl ?mzs)
              )
            (and (and (not (= ?ango ?angn))
                (not (= ?ango ?mzs))
                )
              (not (= ?angn ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?angp Real)
    (declare-const ?angq Real)
    (declare-const ?angr Real)
    (declare-const ?angs Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?angq ?angp))
                (not (= ?angq ?zpl))
                )
              (not (= ?angp ?zpl))
              )
            (or (or (= ?angs ?angr)
                (= ?angs ?zpl)
                )
              (= ?angr ?zpl)
              )
            )
          (and (or (or (= ?angq ?angp)
                (= ?angq ?zpl)
                )
              (= ?angp ?zpl)
              )
            (and (and (not (= ?angs ?angr))
                (not (= ?angs ?zpl))
                )
              (not (= ?angr ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?angt Real)
  (declare-const ?angu Real)
  (declare-const ?angv Real)
  (declare-const ?angw Real)
  (declare-const ?angx Real)
  (push 1)
    (declare-const ?angy Real)
    (declare-const ?angz Real)
    (declare-const ?anha Real)
    (assert
      (or (or (= ?anha ?angz)
          (= ?anha ?angy)
          )
        (= ?angz ?angy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anhb Real)
    (declare-const ?anhc Real)
    (declare-const ?anhd Real)
    (declare-const ?anhe Real)
    (assert
      (or (or (= ?anhe ?anhd)
          (= ?anhe ?anhc)
          )
        (= ?anhd ?anhc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anhf Real)
    (declare-const ?anhg Real)
    (declare-const ?anhh Real)
    (declare-const ?anhi Real)
    (declare-const ?anhj Real)
    (assert
      (or (or (= ?anhj ?anhi)
          (= ?anhj ?anhh)
          )
        (= ?anhi ?anhh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anhk Real)
    (declare-const ?anhl Real)
    (declare-const ?anhm Real)
    (declare-const ?anhn Real)
    (declare-const ?anho Real)
    (declare-const ?anhp Real)
    (assert
      (and (and (and (not (= ?anhm ?anhl))
            (not (= ?anhm ?anhk))
            )
          (not (= ?anhl ?anhk))
          )
        (or (or (= ?anhp ?anho)
            (= ?anhp ?anhn)
            )
          (= ?anho ?anhn)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anhq Real)
    (declare-const ?anhr Real)
    (declare-const ?anhs Real)
    (assert
      (or (or (= ?anhs ?anhr)
          (= ?anhs ?anhq)
          )
        (= ?anhr ?anhq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anht Real)
    (declare-const ?anhu Real)
    (declare-const ?anhv Real)
    (assert
      (or (or (= ?anhv ?anhu)
          (= ?anhv ?anht)
          )
        (= ?anhu ?anht)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anhw Real)
    (declare-const ?anhx Real)
    (declare-const ?anhy Real)
    (declare-const ?anhz Real)
    (assert
      (or (or (= ?anhy ?anhx)
          (= ?anhy ?anhw)
          )
        (= ?anhx ?anhw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ania Real)
    (declare-const ?anib Real)
    (declare-const ?anic Real)
    (declare-const ?anid Real)
    (declare-const ?anie Real)
    (assert
      (or (or (= ?anic ?anib)
          (= ?anic ?ania)
          )
        (= ?anib ?ania)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anif Real)
    (declare-const ?anig Real)
    (declare-const ?anih Real)
    (declare-const ?anii Real)
    (declare-const ?anij Real)
    (declare-const ?anik Real)
    (assert
      (and (or (or (= ?anih ?anig)
            (= ?anih ?anif)
            )
          (= ?anig ?anif)
          )
        (and (and (not (= ?anik ?anij))
            (not (= ?anik ?anii))
            )
          (not (= ?anij ?anii))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anil Real)
    (declare-const ?anim Real)
    (declare-const ?anin Real)
    (assert
      (or (or (= ?anin ?anim)
          (= ?anin ?anil)
          )
        (= ?anim ?anil)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anio Real)
    (declare-const ?anip Real)
    (declare-const ?aniq Real)
    (declare-const ?anir Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?anip ?anio))
                (not (= ?anip ?asi))
                )
              (not (= ?anio ?asi))
              )
            (or (or (= ?anir ?aniq)
                (= ?anir ?asi)
                )
              (= ?aniq ?asi)
              )
            )
          (and (or (or (= ?anip ?anio)
                (= ?anip ?asi)
                )
              (= ?anio ?asi)
              )
            (and (and (not (= ?anir ?aniq))
                (not (= ?anir ?asi))
                )
              (not (= ?aniq ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anis Real)
    (declare-const ?anit Real)
    (declare-const ?aniu Real)
    (declare-const ?aniv Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?anit ?anis))
                (not (= ?anit ?fkf))
                )
              (not (= ?anis ?fkf))
              )
            (or (or (= ?aniv ?aniu)
                (= ?aniv ?fkf)
                )
              (= ?aniu ?fkf)
              )
            )
          (and (or (or (= ?anit ?anis)
                (= ?anit ?fkf)
                )
              (= ?anis ?fkf)
              )
            (and (and (not (= ?aniv ?aniu))
                (not (= ?aniv ?fkf))
                )
              (not (= ?aniu ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aniw Real)
    (declare-const ?anix Real)
    (declare-const ?aniy Real)
    (declare-const ?aniz Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?anix ?aniw))
                (not (= ?anix ?mzs))
                )
              (not (= ?aniw ?mzs))
              )
            (or (or (= ?aniz ?aniy)
                (= ?aniz ?mzs)
                )
              (= ?aniy ?mzs)
              )
            )
          (and (or (or (= ?anix ?aniw)
                (= ?anix ?mzs)
                )
              (= ?aniw ?mzs)
              )
            (and (and (not (= ?aniz ?aniy))
                (not (= ?aniz ?mzs))
                )
              (not (= ?aniy ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anja Real)
    (declare-const ?anjb Real)
    (declare-const ?anjc Real)
    (declare-const ?anjd Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?anjb ?anja))
                (not (= ?anjb ?zpl))
                )
              (not (= ?anja ?zpl))
              )
            (or (or (= ?anjd ?anjc)
                (= ?anjd ?zpl)
                )
              (= ?anjc ?zpl)
              )
            )
          (and (or (or (= ?anjb ?anja)
                (= ?anjb ?zpl)
                )
              (= ?anja ?zpl)
              )
            (and (and (not (= ?anjd ?anjc))
                (not (= ?anjd ?zpl))
                )
              (not (= ?anjc ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?anje Real)
  (declare-const ?anjf Real)
  (push 1)
    (declare-const ?anjg Real)
    (declare-const ?anjh Real)
    (declare-const ?anji Real)
    (assert
      (or (or (= ?anji ?anjh)
          (= ?anji ?anjg)
          )
        (= ?anjh ?anjg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anjj Real)
    (declare-const ?anjk Real)
    (declare-const ?anjl Real)
    (declare-const ?anjm Real)
    (assert
      (or (or (= ?anjm ?anjl)
          (= ?anjm ?anjk)
          )
        (= ?anjl ?anjk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anjn Real)
    (declare-const ?anjo Real)
    (declare-const ?anjp Real)
    (declare-const ?anjq Real)
    (declare-const ?anjr Real)
    (assert
      (or (or (= ?anjr ?anjq)
          (= ?anjr ?anjp)
          )
        (= ?anjq ?anjp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anjs Real)
    (declare-const ?anjt Real)
    (declare-const ?anju Real)
    (declare-const ?anjv Real)
    (declare-const ?anjw Real)
    (declare-const ?anjx Real)
    (assert
      (and (and (and (not (= ?anju ?anjt))
            (not (= ?anju ?anjs))
            )
          (not (= ?anjt ?anjs))
          )
        (or (or (= ?anjx ?anjw)
            (= ?anjx ?anjv)
            )
          (= ?anjw ?anjv)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anjy Real)
    (declare-const ?anjz Real)
    (declare-const ?anka Real)
    (assert
      (or (or (= ?anka ?anjz)
          (= ?anka ?anjy)
          )
        (= ?anjz ?anjy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ankb Real)
    (declare-const ?ankc Real)
    (declare-const ?ankd Real)
    (assert
      (or (or (= ?ankd ?ankc)
          (= ?ankd ?ankb)
          )
        (= ?ankc ?ankb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anke Real)
    (declare-const ?ankf Real)
    (declare-const ?ankg Real)
    (declare-const ?ankh Real)
    (assert
      (or (or (= ?ankg ?ankf)
          (= ?ankg ?anke)
          )
        (= ?ankf ?anke)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anki Real)
    (declare-const ?ankj Real)
    (declare-const ?ankk Real)
    (declare-const ?ankl Real)
    (declare-const ?ankm Real)
    (assert
      (or (or (= ?ankk ?ankj)
          (= ?ankk ?anki)
          )
        (= ?ankj ?anki)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ankn Real)
    (declare-const ?anko Real)
    (declare-const ?ankp Real)
    (declare-const ?ankq Real)
    (declare-const ?ankr Real)
    (declare-const ?anks Real)
    (assert
      (and (or (or (= ?ankp ?anko)
            (= ?ankp ?ankn)
            )
          (= ?anko ?ankn)
          )
        (and (and (not (= ?anks ?ankr))
            (not (= ?anks ?ankq))
            )
          (not (= ?ankr ?ankq))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ankt Real)
    (declare-const ?anku Real)
    (declare-const ?ankv Real)
    (assert
      (or (or (= ?ankv ?anku)
          (= ?ankv ?ankt)
          )
        (= ?anku ?ankt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ankw Real)
    (declare-const ?ankx Real)
    (declare-const ?anky Real)
    (declare-const ?ankz Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ankx ?ankw))
                (not (= ?ankx ?asi))
                )
              (not (= ?ankw ?asi))
              )
            (or (or (= ?ankz ?anky)
                (= ?ankz ?asi)
                )
              (= ?anky ?asi)
              )
            )
          (and (or (or (= ?ankx ?ankw)
                (= ?ankx ?asi)
                )
              (= ?ankw ?asi)
              )
            (and (and (not (= ?ankz ?anky))
                (not (= ?ankz ?asi))
                )
              (not (= ?anky ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anla Real)
    (declare-const ?anlb Real)
    (declare-const ?anlc Real)
    (declare-const ?anld Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?anlb ?anla))
                (not (= ?anlb ?fkf))
                )
              (not (= ?anla ?fkf))
              )
            (or (or (= ?anld ?anlc)
                (= ?anld ?fkf)
                )
              (= ?anlc ?fkf)
              )
            )
          (and (or (or (= ?anlb ?anla)
                (= ?anlb ?fkf)
                )
              (= ?anla ?fkf)
              )
            (and (and (not (= ?anld ?anlc))
                (not (= ?anld ?fkf))
                )
              (not (= ?anlc ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anle Real)
    (declare-const ?anlf Real)
    (declare-const ?anlg Real)
    (declare-const ?anlh Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?anlf ?anle))
                (not (= ?anlf ?mzs))
                )
              (not (= ?anle ?mzs))
              )
            (or (or (= ?anlh ?anlg)
                (= ?anlh ?mzs)
                )
              (= ?anlg ?mzs)
              )
            )
          (and (or (or (= ?anlf ?anle)
                (= ?anlf ?mzs)
                )
              (= ?anle ?mzs)
              )
            (and (and (not (= ?anlh ?anlg))
                (not (= ?anlh ?mzs))
                )
              (not (= ?anlg ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anli Real)
    (declare-const ?anlj Real)
    (declare-const ?anlk Real)
    (declare-const ?anll Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?anlj ?anli))
                (not (= ?anlj ?zpl))
                )
              (not (= ?anli ?zpl))
              )
            (or (or (= ?anll ?anlk)
                (= ?anll ?zpl)
                )
              (= ?anlk ?zpl)
              )
            )
          (and (or (or (= ?anlj ?anli)
                (= ?anlj ?zpl)
                )
              (= ?anli ?zpl)
              )
            (and (and (not (= ?anll ?anlk))
                (not (= ?anll ?zpl))
                )
              (not (= ?anlk ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?anlm Real)
  (push 1)
    (declare-const ?anln Real)
    (declare-const ?anlo Real)
    (declare-const ?anlp Real)
    (assert
      (or (or (= ?anlp ?anlo)
          (= ?anlp ?anln)
          )
        (= ?anlo ?anln)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anlq Real)
    (declare-const ?anlr Real)
    (declare-const ?anls Real)
    (declare-const ?anlt Real)
    (assert
      (or (or (= ?anlt ?anls)
          (= ?anlt ?anlr)
          )
        (= ?anls ?anlr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anlu Real)
    (declare-const ?anlv Real)
    (declare-const ?anlw Real)
    (declare-const ?anlx Real)
    (declare-const ?anly Real)
    (assert
      (or (or (= ?anly ?anlx)
          (= ?anly ?anlw)
          )
        (= ?anlx ?anlw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anlz Real)
    (declare-const ?anma Real)
    (declare-const ?anmb Real)
    (declare-const ?anmc Real)
    (declare-const ?anmd Real)
    (declare-const ?anme Real)
    (assert
      (and (and (and (not (= ?anmb ?anma))
            (not (= ?anmb ?anlz))
            )
          (not (= ?anma ?anlz))
          )
        (or (or (= ?anme ?anmd)
            (= ?anme ?anmc)
            )
          (= ?anmd ?anmc)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anmf Real)
    (declare-const ?anmg Real)
    (declare-const ?anmh Real)
    (assert
      (or (or (= ?anmh ?anmg)
          (= ?anmh ?anmf)
          )
        (= ?anmg ?anmf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anmi Real)
    (declare-const ?anmj Real)
    (declare-const ?anmk Real)
    (assert
      (or (or (= ?anmk ?anmj)
          (= ?anmk ?anmi)
          )
        (= ?anmj ?anmi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anml Real)
    (declare-const ?anmm Real)
    (declare-const ?anmn Real)
    (declare-const ?anmo Real)
    (assert
      (or (or (= ?anmn ?anmm)
          (= ?anmn ?anml)
          )
        (= ?anmm ?anml)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anmp Real)
    (declare-const ?anmq Real)
    (declare-const ?anmr Real)
    (declare-const ?anms Real)
    (declare-const ?anmt Real)
    (assert
      (or (or (= ?anmr ?anmq)
          (= ?anmr ?anmp)
          )
        (= ?anmq ?anmp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anmu Real)
    (declare-const ?anmv Real)
    (declare-const ?anmw Real)
    (declare-const ?anmx Real)
    (declare-const ?anmy Real)
    (declare-const ?anmz Real)
    (assert
      (and (or (or (= ?anmw ?anmv)
            (= ?anmw ?anmu)
            )
          (= ?anmv ?anmu)
          )
        (and (and (not (= ?anmz ?anmy))
            (not (= ?anmz ?anmx))
            )
          (not (= ?anmy ?anmx))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anna Real)
    (declare-const ?annb Real)
    (declare-const ?annc Real)
    (assert
      (or (or (= ?annc ?annb)
          (= ?annc ?anna)
          )
        (= ?annb ?anna)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?annd Real)
    (declare-const ?anne Real)
    (declare-const ?annf Real)
    (declare-const ?anng Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?anne ?annd))
                (not (= ?anne ?asi))
                )
              (not (= ?annd ?asi))
              )
            (or (or (= ?anng ?annf)
                (= ?anng ?asi)
                )
              (= ?annf ?asi)
              )
            )
          (and (or (or (= ?anne ?annd)
                (= ?anne ?asi)
                )
              (= ?annd ?asi)
              )
            (and (and (not (= ?anng ?annf))
                (not (= ?anng ?asi))
                )
              (not (= ?annf ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?annh Real)
    (declare-const ?anni Real)
    (declare-const ?annj Real)
    (declare-const ?annk Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?anni ?annh))
                (not (= ?anni ?fkf))
                )
              (not (= ?annh ?fkf))
              )
            (or (or (= ?annk ?annj)
                (= ?annk ?fkf)
                )
              (= ?annj ?fkf)
              )
            )
          (and (or (or (= ?anni ?annh)
                (= ?anni ?fkf)
                )
              (= ?annh ?fkf)
              )
            (and (and (not (= ?annk ?annj))
                (not (= ?annk ?fkf))
                )
              (not (= ?annj ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?annl Real)
    (declare-const ?annm Real)
    (declare-const ?annn Real)
    (declare-const ?anno Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?annm ?annl))
                (not (= ?annm ?mzs))
                )
              (not (= ?annl ?mzs))
              )
            (or (or (= ?anno ?annn)
                (= ?anno ?mzs)
                )
              (= ?annn ?mzs)
              )
            )
          (and (or (or (= ?annm ?annl)
                (= ?annm ?mzs)
                )
              (= ?annl ?mzs)
              )
            (and (and (not (= ?anno ?annn))
                (not (= ?anno ?mzs))
                )
              (not (= ?annn ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?annp Real)
    (declare-const ?annq Real)
    (declare-const ?annr Real)
    (declare-const ?anns Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?annq ?annp))
                (not (= ?annq ?zpl))
                )
              (not (= ?annp ?zpl))
              )
            (or (or (= ?anns ?annr)
                (= ?anns ?zpl)
                )
              (= ?annr ?zpl)
              )
            )
          (and (or (or (= ?annq ?annp)
                (= ?annq ?zpl)
                )
              (= ?annp ?zpl)
              )
            (and (and (not (= ?anns ?annr))
                (not (= ?anns ?zpl))
                )
              (not (= ?annr ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?annt Real)
  (declare-const ?annu Real)
  (push 1)
    (declare-const ?annv Real)
    (declare-const ?annw Real)
    (declare-const ?annx Real)
    (assert
      (or (or (= ?annx ?annw)
          (= ?annx ?annv)
          )
        (= ?annw ?annv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anny Real)
    (declare-const ?annz Real)
    (declare-const ?anoa Real)
    (declare-const ?anob Real)
    (assert
      (or (or (= ?anob ?anoa)
          (= ?anob ?annz)
          )
        (= ?anoa ?annz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anoc Real)
    (declare-const ?anod Real)
    (declare-const ?anoe Real)
    (declare-const ?anof Real)
    (declare-const ?anog Real)
    (assert
      (or (or (= ?anog ?anof)
          (= ?anog ?anoe)
          )
        (= ?anof ?anoe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anoh Real)
    (declare-const ?anoi Real)
    (declare-const ?anoj Real)
    (declare-const ?anok Real)
    (declare-const ?anol Real)
    (declare-const ?anom Real)
    (assert
      (and (and (and (not (= ?anoj ?anoi))
            (not (= ?anoj ?anoh))
            )
          (not (= ?anoi ?anoh))
          )
        (or (or (= ?anom ?anol)
            (= ?anom ?anok)
            )
          (= ?anol ?anok)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anon Real)
    (declare-const ?anoo Real)
    (declare-const ?anop Real)
    (assert
      (or (or (= ?anop ?anoo)
          (= ?anop ?anon)
          )
        (= ?anoo ?anon)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anoq Real)
    (declare-const ?anor Real)
    (declare-const ?anos Real)
    (assert
      (or (or (= ?anos ?anor)
          (= ?anos ?anoq)
          )
        (= ?anor ?anoq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anot Real)
    (declare-const ?anou Real)
    (declare-const ?anov Real)
    (declare-const ?anow Real)
    (assert
      (or (or (= ?anov ?anou)
          (= ?anov ?anot)
          )
        (= ?anou ?anot)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anox Real)
    (declare-const ?anoy Real)
    (declare-const ?anoz Real)
    (declare-const ?anpa Real)
    (declare-const ?anpb Real)
    (assert
      (or (or (= ?anoz ?anoy)
          (= ?anoz ?anox)
          )
        (= ?anoy ?anox)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anpc Real)
    (declare-const ?anpd Real)
    (declare-const ?anpe Real)
    (declare-const ?anpf Real)
    (declare-const ?anpg Real)
    (declare-const ?anph Real)
    (assert
      (and (or (or (= ?anpe ?anpd)
            (= ?anpe ?anpc)
            )
          (= ?anpd ?anpc)
          )
        (and (and (not (= ?anph ?anpg))
            (not (= ?anph ?anpf))
            )
          (not (= ?anpg ?anpf))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anpi Real)
    (declare-const ?anpj Real)
    (declare-const ?anpk Real)
    (assert
      (or (or (= ?anpk ?anpj)
          (= ?anpk ?anpi)
          )
        (= ?anpj ?anpi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anpl Real)
    (declare-const ?anpm Real)
    (declare-const ?anpn Real)
    (declare-const ?anpo Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?anpm ?anpl))
                (not (= ?anpm ?asi))
                )
              (not (= ?anpl ?asi))
              )
            (or (or (= ?anpo ?anpn)
                (= ?anpo ?asi)
                )
              (= ?anpn ?asi)
              )
            )
          (and (or (or (= ?anpm ?anpl)
                (= ?anpm ?asi)
                )
              (= ?anpl ?asi)
              )
            (and (and (not (= ?anpo ?anpn))
                (not (= ?anpo ?asi))
                )
              (not (= ?anpn ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anpp Real)
    (declare-const ?anpq Real)
    (declare-const ?anpr Real)
    (declare-const ?anps Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?anpq ?anpp))
                (not (= ?anpq ?fkf))
                )
              (not (= ?anpp ?fkf))
              )
            (or (or (= ?anps ?anpr)
                (= ?anps ?fkf)
                )
              (= ?anpr ?fkf)
              )
            )
          (and (or (or (= ?anpq ?anpp)
                (= ?anpq ?fkf)
                )
              (= ?anpp ?fkf)
              )
            (and (and (not (= ?anps ?anpr))
                (not (= ?anps ?fkf))
                )
              (not (= ?anpr ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anpt Real)
    (declare-const ?anpu Real)
    (declare-const ?anpv Real)
    (declare-const ?anpw Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?anpu ?anpt))
                (not (= ?anpu ?mzs))
                )
              (not (= ?anpt ?mzs))
              )
            (or (or (= ?anpw ?anpv)
                (= ?anpw ?mzs)
                )
              (= ?anpv ?mzs)
              )
            )
          (and (or (or (= ?anpu ?anpt)
                (= ?anpu ?mzs)
                )
              (= ?anpt ?mzs)
              )
            (and (and (not (= ?anpw ?anpv))
                (not (= ?anpw ?mzs))
                )
              (not (= ?anpv ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anpx Real)
    (declare-const ?anpy Real)
    (declare-const ?anpz Real)
    (declare-const ?anqa Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?anpy ?anpx))
                (not (= ?anpy ?zpl))
                )
              (not (= ?anpx ?zpl))
              )
            (or (or (= ?anqa ?anpz)
                (= ?anqa ?zpl)
                )
              (= ?anpz ?zpl)
              )
            )
          (and (or (or (= ?anpy ?anpx)
                (= ?anpy ?zpl)
                )
              (= ?anpx ?zpl)
              )
            (and (and (not (= ?anqa ?anpz))
                (not (= ?anqa ?zpl))
                )
              (not (= ?anpz ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?anqb Real)
  (push 1)
    (declare-const ?anqc Real)
    (declare-const ?anqd Real)
    (declare-const ?anqe Real)
    (assert
      (or (or (= ?anqe ?anqd)
          (= ?anqe ?anqc)
          )
        (= ?anqd ?anqc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anqf Real)
    (declare-const ?anqg Real)
    (declare-const ?anqh Real)
    (declare-const ?anqi Real)
    (assert
      (or (or (= ?anqi ?anqh)
          (= ?anqi ?anqg)
          )
        (= ?anqh ?anqg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anqj Real)
    (declare-const ?anqk Real)
    (declare-const ?anql Real)
    (declare-const ?anqm Real)
    (declare-const ?anqn Real)
    (assert
      (or (or (= ?anqn ?anqm)
          (= ?anqn ?anql)
          )
        (= ?anqm ?anql)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anqo Real)
    (declare-const ?anqp Real)
    (declare-const ?anqq Real)
    (declare-const ?anqr Real)
    (declare-const ?anqs Real)
    (declare-const ?anqt Real)
    (assert
      (and (and (and (not (= ?anqq ?anqp))
            (not (= ?anqq ?anqo))
            )
          (not (= ?anqp ?anqo))
          )
        (or (or (= ?anqt ?anqs)
            (= ?anqt ?anqr)
            )
          (= ?anqs ?anqr)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anqu Real)
    (declare-const ?anqv Real)
    (declare-const ?anqw Real)
    (assert
      (or (or (= ?anqw ?anqv)
          (= ?anqw ?anqu)
          )
        (= ?anqv ?anqu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anqx Real)
    (declare-const ?anqy Real)
    (declare-const ?anqz Real)
    (assert
      (or (or (= ?anqz ?anqy)
          (= ?anqz ?anqx)
          )
        (= ?anqy ?anqx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anra Real)
    (declare-const ?anrb Real)
    (declare-const ?anrc Real)
    (declare-const ?anrd Real)
    (assert
      (or (or (= ?anrc ?anrb)
          (= ?anrc ?anra)
          )
        (= ?anrb ?anra)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anre Real)
    (declare-const ?anrf Real)
    (declare-const ?anrg Real)
    (declare-const ?anrh Real)
    (declare-const ?anri Real)
    (assert
      (or (or (= ?anrg ?anrf)
          (= ?anrg ?anre)
          )
        (= ?anrf ?anre)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anrj Real)
    (declare-const ?anrk Real)
    (declare-const ?anrl Real)
    (declare-const ?anrm Real)
    (declare-const ?anrn Real)
    (declare-const ?anro Real)
    (assert
      (and (or (or (= ?anrl ?anrk)
            (= ?anrl ?anrj)
            )
          (= ?anrk ?anrj)
          )
        (and (and (not (= ?anro ?anrn))
            (not (= ?anro ?anrm))
            )
          (not (= ?anrn ?anrm))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anrp Real)
    (declare-const ?anrq Real)
    (declare-const ?anrr Real)
    (assert
      (or (or (= ?anrr ?anrq)
          (= ?anrr ?anrp)
          )
        (= ?anrq ?anrp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anrs Real)
    (declare-const ?anrt Real)
    (declare-const ?anru Real)
    (declare-const ?anrv Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?anrt ?anrs))
                (not (= ?anrt ?asi))
                )
              (not (= ?anrs ?asi))
              )
            (or (or (= ?anrv ?anru)
                (= ?anrv ?asi)
                )
              (= ?anru ?asi)
              )
            )
          (and (or (or (= ?anrt ?anrs)
                (= ?anrt ?asi)
                )
              (= ?anrs ?asi)
              )
            (and (and (not (= ?anrv ?anru))
                (not (= ?anrv ?asi))
                )
              (not (= ?anru ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anrw Real)
    (declare-const ?anrx Real)
    (declare-const ?anry Real)
    (declare-const ?anrz Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?anrx ?anrw))
                (not (= ?anrx ?fkf))
                )
              (not (= ?anrw ?fkf))
              )
            (or (or (= ?anrz ?anry)
                (= ?anrz ?fkf)
                )
              (= ?anry ?fkf)
              )
            )
          (and (or (or (= ?anrx ?anrw)
                (= ?anrx ?fkf)
                )
              (= ?anrw ?fkf)
              )
            (and (and (not (= ?anrz ?anry))
                (not (= ?anrz ?fkf))
                )
              (not (= ?anry ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ansa Real)
    (declare-const ?ansb Real)
    (declare-const ?ansc Real)
    (declare-const ?ansd Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?ansb ?ansa))
                (not (= ?ansb ?mzs))
                )
              (not (= ?ansa ?mzs))
              )
            (or (or (= ?ansd ?ansc)
                (= ?ansd ?mzs)
                )
              (= ?ansc ?mzs)
              )
            )
          (and (or (or (= ?ansb ?ansa)
                (= ?ansb ?mzs)
                )
              (= ?ansa ?mzs)
              )
            (and (and (not (= ?ansd ?ansc))
                (not (= ?ansd ?mzs))
                )
              (not (= ?ansc ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anse Real)
    (declare-const ?ansf Real)
    (declare-const ?ansg Real)
    (declare-const ?ansh Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?ansf ?anse))
                (not (= ?ansf ?zpl))
                )
              (not (= ?anse ?zpl))
              )
            (or (or (= ?ansh ?ansg)
                (= ?ansh ?zpl)
                )
              (= ?ansg ?zpl)
              )
            )
          (and (or (or (= ?ansf ?anse)
                (= ?ansf ?zpl)
                )
              (= ?anse ?zpl)
              )
            (and (and (not (= ?ansh ?ansg))
                (not (= ?ansh ?zpl))
                )
              (not (= ?ansg ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?ansi Real)
  (declare-const ?ansj Real)
  (assert
    (not (= ?ansi ?ansj))
    )
  (push 1)
    (declare-const ?ansk Real)
    (declare-const ?ansl Real)
    (declare-const ?ansm Real)
    (assert
      (or (or (= ?ansm ?ansl)
          (= ?ansm ?ansk)
          )
        (= ?ansl ?ansk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ansn Real)
    (declare-const ?anso Real)
    (declare-const ?ansp Real)
    (declare-const ?ansq Real)
    (assert
      (or (or (= ?ansq ?ansp)
          (= ?ansq ?anso)
          )
        (= ?ansp ?anso)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ansr Real)
    (declare-const ?anss Real)
    (declare-const ?anst Real)
    (declare-const ?ansu Real)
    (declare-const ?ansv Real)
    (assert
      (or (or (= ?ansv ?ansu)
          (= ?ansv ?anst)
          )
        (= ?ansu ?anst)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?answ Real)
    (declare-const ?ansx Real)
    (declare-const ?ansy Real)
    (declare-const ?ansz Real)
    (declare-const ?anta Real)
    (declare-const ?antb Real)
    (assert
      (and (and (and (not (= ?ansy ?ansx))
            (not (= ?ansy ?answ))
            )
          (not (= ?ansx ?answ))
          )
        (or (or (= ?antb ?anta)
            (= ?antb ?ansz)
            )
          (= ?anta ?ansz)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?antc Real)
    (declare-const ?antd Real)
    (declare-const ?ante Real)
    (assert
      (or (or (= ?ante ?antd)
          (= ?ante ?antc)
          )
        (= ?antd ?antc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?antf Real)
    (declare-const ?antg Real)
    (declare-const ?anth Real)
    (assert
      (or (or (= ?anth ?antg)
          (= ?anth ?antf)
          )
        (= ?antg ?antf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anti Real)
    (declare-const ?antj Real)
    (declare-const ?antk Real)
    (declare-const ?antl Real)
    (assert
      (or (or (= ?antk ?antj)
          (= ?antk ?anti)
          )
        (= ?antj ?anti)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?antm Real)
    (declare-const ?antn Real)
    (declare-const ?anto Real)
    (declare-const ?antp Real)
    (declare-const ?antq Real)
    (assert
      (or (or (= ?anto ?antn)
          (= ?anto ?antm)
          )
        (= ?antn ?antm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?antr Real)
    (declare-const ?ants Real)
    (declare-const ?antt Real)
    (declare-const ?antu Real)
    (declare-const ?antv Real)
    (declare-const ?antw Real)
    (assert
      (and (or (or (= ?antt ?ants)
            (= ?antt ?antr)
            )
          (= ?ants ?antr)
          )
        (and (and (not (= ?antw ?antv))
            (not (= ?antw ?antu))
            )
          (not (= ?antv ?antu))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?antx Real)
    (declare-const ?anty Real)
    (declare-const ?antz Real)
    (assert
      (or (or (= ?antz ?anty)
          (= ?antz ?antx)
          )
        (= ?anty ?antx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anua Real)
    (declare-const ?anub Real)
    (declare-const ?anuc Real)
    (declare-const ?anud Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?anub ?anua))
                (not (= ?anub ?asi))
                )
              (not (= ?anua ?asi))
              )
            (or (or (= ?anud ?anuc)
                (= ?anud ?asi)
                )
              (= ?anuc ?asi)
              )
            )
          (and (or (or (= ?anub ?anua)
                (= ?anub ?asi)
                )
              (= ?anua ?asi)
              )
            (and (and (not (= ?anud ?anuc))
                (not (= ?anud ?asi))
                )
              (not (= ?anuc ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anue Real)
    (declare-const ?anuf Real)
    (declare-const ?anug Real)
    (declare-const ?anuh Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?anuf ?anue))
                (not (= ?anuf ?fkf))
                )
              (not (= ?anue ?fkf))
              )
            (or (or (= ?anuh ?anug)
                (= ?anuh ?fkf)
                )
              (= ?anug ?fkf)
              )
            )
          (and (or (or (= ?anuf ?anue)
                (= ?anuf ?fkf)
                )
              (= ?anue ?fkf)
              )
            (and (and (not (= ?anuh ?anug))
                (not (= ?anuh ?fkf))
                )
              (not (= ?anug ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anui Real)
    (declare-const ?anuj Real)
    (declare-const ?anuk Real)
    (declare-const ?anul Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?anuj ?anui))
                (not (= ?anuj ?mzs))
                )
              (not (= ?anui ?mzs))
              )
            (or (or (= ?anul ?anuk)
                (= ?anul ?mzs)
                )
              (= ?anuk ?mzs)
              )
            )
          (and (or (or (= ?anuj ?anui)
                (= ?anuj ?mzs)
                )
              (= ?anui ?mzs)
              )
            (and (and (not (= ?anul ?anuk))
                (not (= ?anul ?mzs))
                )
              (not (= ?anuk ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anum Real)
    (declare-const ?anun Real)
    (declare-const ?anuo Real)
    (declare-const ?anup Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?anun ?anum))
                (not (= ?anun ?zpl))
                )
              (not (= ?anum ?zpl))
              )
            (or (or (= ?anup ?anuo)
                (= ?anup ?zpl)
                )
              (= ?anuo ?zpl)
              )
            )
          (and (or (or (= ?anun ?anum)
                (= ?anun ?zpl)
                )
              (= ?anum ?zpl)
              )
            (and (and (not (= ?anup ?anuo))
                (not (= ?anup ?zpl))
                )
              (not (= ?anuo ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?anuq Real)
  (declare-const ?anur Real)
  (declare-const ?anus Real)
  (push 1)
    (declare-const ?anut Real)
    (declare-const ?anuu Real)
    (declare-const ?anuv Real)
    (assert
      (or (or (= ?anuv ?anuu)
          (= ?anuv ?anut)
          )
        (= ?anuu ?anut)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anuw Real)
    (declare-const ?anux Real)
    (declare-const ?anuy Real)
    (declare-const ?anuz Real)
    (assert
      (or (or (= ?anuz ?anuy)
          (= ?anuz ?anux)
          )
        (= ?anuy ?anux)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anva Real)
    (declare-const ?anvb Real)
    (declare-const ?anvc Real)
    (declare-const ?anvd Real)
    (declare-const ?anve Real)
    (assert
      (or (or (= ?anve ?anvd)
          (= ?anve ?anvc)
          )
        (= ?anvd ?anvc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anvf Real)
    (declare-const ?anvg Real)
    (declare-const ?anvh Real)
    (declare-const ?anvi Real)
    (declare-const ?anvj Real)
    (declare-const ?anvk Real)
    (assert
      (and (and (and (not (= ?anvh ?anvg))
            (not (= ?anvh ?anvf))
            )
          (not (= ?anvg ?anvf))
          )
        (or (or (= ?anvk ?anvj)
            (= ?anvk ?anvi)
            )
          (= ?anvj ?anvi)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anvl Real)
    (declare-const ?anvm Real)
    (declare-const ?anvn Real)
    (assert
      (or (or (= ?anvn ?anvm)
          (= ?anvn ?anvl)
          )
        (= ?anvm ?anvl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anvo Real)
    (declare-const ?anvp Real)
    (declare-const ?anvq Real)
    (assert
      (or (or (= ?anvq ?anvp)
          (= ?anvq ?anvo)
          )
        (= ?anvp ?anvo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anvr Real)
    (declare-const ?anvs Real)
    (declare-const ?anvt Real)
    (declare-const ?anvu Real)
    (assert
      (or (or (= ?anvt ?anvs)
          (= ?anvt ?anvr)
          )
        (= ?anvs ?anvr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anvv Real)
    (declare-const ?anvw Real)
    (declare-const ?anvx Real)
    (declare-const ?anvy Real)
    (declare-const ?anvz Real)
    (assert
      (or (or (= ?anvx ?anvw)
          (= ?anvx ?anvv)
          )
        (= ?anvw ?anvv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anwa Real)
    (declare-const ?anwb Real)
    (declare-const ?anwc Real)
    (declare-const ?anwd Real)
    (declare-const ?anwe Real)
    (declare-const ?anwf Real)
    (assert
      (and (or (or (= ?anwc ?anwb)
            (= ?anwc ?anwa)
            )
          (= ?anwb ?anwa)
          )
        (and (and (not (= ?anwf ?anwe))
            (not (= ?anwf ?anwd))
            )
          (not (= ?anwe ?anwd))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anwg Real)
    (declare-const ?anwh Real)
    (declare-const ?anwi Real)
    (assert
      (or (or (= ?anwi ?anwh)
          (= ?anwi ?anwg)
          )
        (= ?anwh ?anwg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anwj Real)
    (declare-const ?anwk Real)
    (declare-const ?anwl Real)
    (declare-const ?anwm Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?anwk ?anwj))
                (not (= ?anwk ?asi))
                )
              (not (= ?anwj ?asi))
              )
            (or (or (= ?anwm ?anwl)
                (= ?anwm ?asi)
                )
              (= ?anwl ?asi)
              )
            )
          (and (or (or (= ?anwk ?anwj)
                (= ?anwk ?asi)
                )
              (= ?anwj ?asi)
              )
            (and (and (not (= ?anwm ?anwl))
                (not (= ?anwm ?asi))
                )
              (not (= ?anwl ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anwn Real)
    (declare-const ?anwo Real)
    (declare-const ?anwp Real)
    (declare-const ?anwq Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?anwo ?anwn))
                (not (= ?anwo ?fkf))
                )
              (not (= ?anwn ?fkf))
              )
            (or (or (= ?anwq ?anwp)
                (= ?anwq ?fkf)
                )
              (= ?anwp ?fkf)
              )
            )
          (and (or (or (= ?anwo ?anwn)
                (= ?anwo ?fkf)
                )
              (= ?anwn ?fkf)
              )
            (and (and (not (= ?anwq ?anwp))
                (not (= ?anwq ?fkf))
                )
              (not (= ?anwp ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anwr Real)
    (declare-const ?anws Real)
    (declare-const ?anwt Real)
    (declare-const ?anwu Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?anws ?anwr))
                (not (= ?anws ?mzs))
                )
              (not (= ?anwr ?mzs))
              )
            (or (or (= ?anwu ?anwt)
                (= ?anwu ?mzs)
                )
              (= ?anwt ?mzs)
              )
            )
          (and (or (or (= ?anws ?anwr)
                (= ?anws ?mzs)
                )
              (= ?anwr ?mzs)
              )
            (and (and (not (= ?anwu ?anwt))
                (not (= ?anwu ?mzs))
                )
              (not (= ?anwt ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anwv Real)
    (declare-const ?anww Real)
    (declare-const ?anwx Real)
    (declare-const ?anwy Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?anww ?anwv))
                (not (= ?anww ?zpl))
                )
              (not (= ?anwv ?zpl))
              )
            (or (or (= ?anwy ?anwx)
                (= ?anwy ?zpl)
                )
              (= ?anwx ?zpl)
              )
            )
          (and (or (or (= ?anww ?anwv)
                (= ?anww ?zpl)
                )
              (= ?anwv ?zpl)
              )
            (and (and (not (= ?anwy ?anwx))
                (not (= ?anwy ?zpl))
                )
              (not (= ?anwx ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?anwz Real)
  (declare-const ?anxa Real)
  (declare-const ?anxb Real)
  (declare-const ?anxc Real)
  (push 1)
    (declare-const ?anxd Real)
    (declare-const ?anxe Real)
    (declare-const ?anxf Real)
    (assert
      (or (or (= ?anxf ?anxe)
          (= ?anxf ?anxd)
          )
        (= ?anxe ?anxd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anxg Real)
    (declare-const ?anxh Real)
    (declare-const ?anxi Real)
    (declare-const ?anxj Real)
    (assert
      (or (or (= ?anxj ?anxi)
          (= ?anxj ?anxh)
          )
        (= ?anxi ?anxh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anxk Real)
    (declare-const ?anxl Real)
    (declare-const ?anxm Real)
    (declare-const ?anxn Real)
    (declare-const ?anxo Real)
    (assert
      (or (or (= ?anxo ?anxn)
          (= ?anxo ?anxm)
          )
        (= ?anxn ?anxm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anxp Real)
    (declare-const ?anxq Real)
    (declare-const ?anxr Real)
    (declare-const ?anxs Real)
    (declare-const ?anxt Real)
    (declare-const ?anxu Real)
    (assert
      (and (and (and (not (= ?anxr ?anxq))
            (not (= ?anxr ?anxp))
            )
          (not (= ?anxq ?anxp))
          )
        (or (or (= ?anxu ?anxt)
            (= ?anxu ?anxs)
            )
          (= ?anxt ?anxs)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anxv Real)
    (declare-const ?anxw Real)
    (declare-const ?anxx Real)
    (assert
      (or (or (= ?anxx ?anxw)
          (= ?anxx ?anxv)
          )
        (= ?anxw ?anxv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anxy Real)
    (declare-const ?anxz Real)
    (declare-const ?anya Real)
    (assert
      (or (or (= ?anya ?anxz)
          (= ?anya ?anxy)
          )
        (= ?anxz ?anxy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anyb Real)
    (declare-const ?anyc Real)
    (declare-const ?anyd Real)
    (declare-const ?anye Real)
    (assert
      (or (or (= ?anyd ?anyc)
          (= ?anyd ?anyb)
          )
        (= ?anyc ?anyb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anyf Real)
    (declare-const ?anyg Real)
    (declare-const ?anyh Real)
    (declare-const ?anyi Real)
    (declare-const ?anyj Real)
    (assert
      (or (or (= ?anyh ?anyg)
          (= ?anyh ?anyf)
          )
        (= ?anyg ?anyf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anyk Real)
    (declare-const ?anyl Real)
    (declare-const ?anym Real)
    (declare-const ?anyn Real)
    (declare-const ?anyo Real)
    (declare-const ?anyp Real)
    (assert
      (and (or (or (= ?anym ?anyl)
            (= ?anym ?anyk)
            )
          (= ?anyl ?anyk)
          )
        (and (and (not (= ?anyp ?anyo))
            (not (= ?anyp ?anyn))
            )
          (not (= ?anyo ?anyn))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anyq Real)
    (declare-const ?anyr Real)
    (declare-const ?anys Real)
    (assert
      (or (or (= ?anys ?anyr)
          (= ?anys ?anyq)
          )
        (= ?anyr ?anyq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anyt Real)
    (declare-const ?anyu Real)
    (declare-const ?anyv Real)
    (declare-const ?anyw Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?anyu ?anyt))
                (not (= ?anyu ?asi))
                )
              (not (= ?anyt ?asi))
              )
            (or (or (= ?anyw ?anyv)
                (= ?anyw ?asi)
                )
              (= ?anyv ?asi)
              )
            )
          (and (or (or (= ?anyu ?anyt)
                (= ?anyu ?asi)
                )
              (= ?anyt ?asi)
              )
            (and (and (not (= ?anyw ?anyv))
                (not (= ?anyw ?asi))
                )
              (not (= ?anyv ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anyx Real)
    (declare-const ?anyy Real)
    (declare-const ?anyz Real)
    (declare-const ?anza Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?anyy ?anyx))
                (not (= ?anyy ?fkf))
                )
              (not (= ?anyx ?fkf))
              )
            (or (or (= ?anza ?anyz)
                (= ?anza ?fkf)
                )
              (= ?anyz ?fkf)
              )
            )
          (and (or (or (= ?anyy ?anyx)
                (= ?anyy ?fkf)
                )
              (= ?anyx ?fkf)
              )
            (and (and (not (= ?anza ?anyz))
                (not (= ?anza ?fkf))
                )
              (not (= ?anyz ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anzb Real)
    (declare-const ?anzc Real)
    (declare-const ?anzd Real)
    (declare-const ?anze Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?anzc ?anzb))
                (not (= ?anzc ?mzs))
                )
              (not (= ?anzb ?mzs))
              )
            (or (or (= ?anze ?anzd)
                (= ?anze ?mzs)
                )
              (= ?anzd ?mzs)
              )
            )
          (and (or (or (= ?anzc ?anzb)
                (= ?anzc ?mzs)
                )
              (= ?anzb ?mzs)
              )
            (and (and (not (= ?anze ?anzd))
                (not (= ?anze ?mzs))
                )
              (not (= ?anzd ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anzf Real)
    (declare-const ?anzg Real)
    (declare-const ?anzh Real)
    (declare-const ?anzi Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?anzg ?anzf))
                (not (= ?anzg ?zpl))
                )
              (not (= ?anzf ?zpl))
              )
            (or (or (= ?anzi ?anzh)
                (= ?anzi ?zpl)
                )
              (= ?anzh ?zpl)
              )
            )
          (and (or (or (= ?anzg ?anzf)
                (= ?anzg ?zpl)
                )
              (= ?anzf ?zpl)
              )
            (and (and (not (= ?anzi ?anzh))
                (not (= ?anzi ?zpl))
                )
              (not (= ?anzh ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?anzj Real)
  (push 1)
    (declare-const ?anzk Real)
    (declare-const ?anzl Real)
    (declare-const ?anzm Real)
    (assert
      (or (or (= ?anzm ?anzl)
          (= ?anzm ?anzk)
          )
        (= ?anzl ?anzk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anzn Real)
    (declare-const ?anzo Real)
    (declare-const ?anzp Real)
    (declare-const ?anzq Real)
    (assert
      (or (or (= ?anzq ?anzp)
          (= ?anzq ?anzo)
          )
        (= ?anzp ?anzo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anzr Real)
    (declare-const ?anzs Real)
    (declare-const ?anzt Real)
    (declare-const ?anzu Real)
    (declare-const ?anzv Real)
    (assert
      (or (or (= ?anzv ?anzu)
          (= ?anzv ?anzt)
          )
        (= ?anzu ?anzt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?anzw Real)
    (declare-const ?anzx Real)
    (declare-const ?anzy Real)
    (declare-const ?anzz Real)
    (declare-const ?aoaa Real)
    (declare-const ?aoab Real)
    (assert
      (and (and (and (not (= ?anzy ?anzx))
            (not (= ?anzy ?anzw))
            )
          (not (= ?anzx ?anzw))
          )
        (or (or (= ?aoab ?aoaa)
            (= ?aoab ?anzz)
            )
          (= ?aoaa ?anzz)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoac Real)
    (declare-const ?aoad Real)
    (declare-const ?aoae Real)
    (assert
      (or (or (= ?aoae ?aoad)
          (= ?aoae ?aoac)
          )
        (= ?aoad ?aoac)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoaf Real)
    (declare-const ?aoag Real)
    (declare-const ?aoah Real)
    (assert
      (or (or (= ?aoah ?aoag)
          (= ?aoah ?aoaf)
          )
        (= ?aoag ?aoaf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoai Real)
    (declare-const ?aoaj Real)
    (declare-const ?aoak Real)
    (declare-const ?aoal Real)
    (assert
      (or (or (= ?aoak ?aoaj)
          (= ?aoak ?aoai)
          )
        (= ?aoaj ?aoai)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoam Real)
    (declare-const ?aoan Real)
    (declare-const ?aoao Real)
    (declare-const ?aoap Real)
    (declare-const ?aoaq Real)
    (assert
      (or (or (= ?aoao ?aoan)
          (= ?aoao ?aoam)
          )
        (= ?aoan ?aoam)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoar Real)
    (declare-const ?aoas Real)
    (declare-const ?aoat Real)
    (declare-const ?aoau Real)
    (declare-const ?aoav Real)
    (declare-const ?aoaw Real)
    (assert
      (and (or (or (= ?aoat ?aoas)
            (= ?aoat ?aoar)
            )
          (= ?aoas ?aoar)
          )
        (and (and (not (= ?aoaw ?aoav))
            (not (= ?aoaw ?aoau))
            )
          (not (= ?aoav ?aoau))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoax Real)
    (declare-const ?aoay Real)
    (declare-const ?aoaz Real)
    (assert
      (or (or (= ?aoaz ?aoay)
          (= ?aoaz ?aoax)
          )
        (= ?aoay ?aoax)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoba Real)
    (declare-const ?aobb Real)
    (declare-const ?aobc Real)
    (declare-const ?aobd Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aobb ?aoba))
                (not (= ?aobb ?asi))
                )
              (not (= ?aoba ?asi))
              )
            (or (or (= ?aobd ?aobc)
                (= ?aobd ?asi)
                )
              (= ?aobc ?asi)
              )
            )
          (and (or (or (= ?aobb ?aoba)
                (= ?aobb ?asi)
                )
              (= ?aoba ?asi)
              )
            (and (and (not (= ?aobd ?aobc))
                (not (= ?aobd ?asi))
                )
              (not (= ?aobc ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aobe Real)
    (declare-const ?aobf Real)
    (declare-const ?aobg Real)
    (declare-const ?aobh Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aobf ?aobe))
                (not (= ?aobf ?fkf))
                )
              (not (= ?aobe ?fkf))
              )
            (or (or (= ?aobh ?aobg)
                (= ?aobh ?fkf)
                )
              (= ?aobg ?fkf)
              )
            )
          (and (or (or (= ?aobf ?aobe)
                (= ?aobf ?fkf)
                )
              (= ?aobe ?fkf)
              )
            (and (and (not (= ?aobh ?aobg))
                (not (= ?aobh ?fkf))
                )
              (not (= ?aobg ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aobi Real)
    (declare-const ?aobj Real)
    (declare-const ?aobk Real)
    (declare-const ?aobl Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aobj ?aobi))
                (not (= ?aobj ?mzs))
                )
              (not (= ?aobi ?mzs))
              )
            (or (or (= ?aobl ?aobk)
                (= ?aobl ?mzs)
                )
              (= ?aobk ?mzs)
              )
            )
          (and (or (or (= ?aobj ?aobi)
                (= ?aobj ?mzs)
                )
              (= ?aobi ?mzs)
              )
            (and (and (not (= ?aobl ?aobk))
                (not (= ?aobl ?mzs))
                )
              (not (= ?aobk ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aobm Real)
    (declare-const ?aobn Real)
    (declare-const ?aobo Real)
    (declare-const ?aobp Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?aobn ?aobm))
                (not (= ?aobn ?zpl))
                )
              (not (= ?aobm ?zpl))
              )
            (or (or (= ?aobp ?aobo)
                (= ?aobp ?zpl)
                )
              (= ?aobo ?zpl)
              )
            )
          (and (or (or (= ?aobn ?aobm)
                (= ?aobn ?zpl)
                )
              (= ?aobm ?zpl)
              )
            (and (and (not (= ?aobp ?aobo))
                (not (= ?aobp ?zpl))
                )
              (not (= ?aobo ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aobq Real)
  (declare-const ?aobr Real)
  (push 1)
    (declare-const ?aobs Real)
    (declare-const ?aobt Real)
    (declare-const ?aobu Real)
    (assert
      (or (or (= ?aobu ?aobt)
          (= ?aobu ?aobs)
          )
        (= ?aobt ?aobs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aobv Real)
    (declare-const ?aobw Real)
    (declare-const ?aobx Real)
    (declare-const ?aoby Real)
    (assert
      (or (or (= ?aoby ?aobx)
          (= ?aoby ?aobw)
          )
        (= ?aobx ?aobw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aobz Real)
    (declare-const ?aoca Real)
    (declare-const ?aocb Real)
    (declare-const ?aocc Real)
    (declare-const ?aocd Real)
    (assert
      (or (or (= ?aocd ?aocc)
          (= ?aocd ?aocb)
          )
        (= ?aocc ?aocb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoce Real)
    (declare-const ?aocf Real)
    (declare-const ?aocg Real)
    (declare-const ?aoch Real)
    (declare-const ?aoci Real)
    (declare-const ?aocj Real)
    (assert
      (and (and (and (not (= ?aocg ?aocf))
            (not (= ?aocg ?aoce))
            )
          (not (= ?aocf ?aoce))
          )
        (or (or (= ?aocj ?aoci)
            (= ?aocj ?aoch)
            )
          (= ?aoci ?aoch)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aock Real)
    (declare-const ?aocl Real)
    (declare-const ?aocm Real)
    (assert
      (or (or (= ?aocm ?aocl)
          (= ?aocm ?aock)
          )
        (= ?aocl ?aock)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aocn Real)
    (declare-const ?aoco Real)
    (declare-const ?aocp Real)
    (assert
      (or (or (= ?aocp ?aoco)
          (= ?aocp ?aocn)
          )
        (= ?aoco ?aocn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aocq Real)
    (declare-const ?aocr Real)
    (declare-const ?aocs Real)
    (declare-const ?aoct Real)
    (assert
      (or (or (= ?aocs ?aocr)
          (= ?aocs ?aocq)
          )
        (= ?aocr ?aocq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aocu Real)
    (declare-const ?aocv Real)
    (declare-const ?aocw Real)
    (declare-const ?aocx Real)
    (declare-const ?aocy Real)
    (assert
      (or (or (= ?aocw ?aocv)
          (= ?aocw ?aocu)
          )
        (= ?aocv ?aocu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aocz Real)
    (declare-const ?aoda Real)
    (declare-const ?aodb Real)
    (declare-const ?aodc Real)
    (declare-const ?aodd Real)
    (declare-const ?aode Real)
    (assert
      (and (or (or (= ?aodb ?aoda)
            (= ?aodb ?aocz)
            )
          (= ?aoda ?aocz)
          )
        (and (and (not (= ?aode ?aodd))
            (not (= ?aode ?aodc))
            )
          (not (= ?aodd ?aodc))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aodf Real)
    (declare-const ?aodg Real)
    (declare-const ?aodh Real)
    (assert
      (or (or (= ?aodh ?aodg)
          (= ?aodh ?aodf)
          )
        (= ?aodg ?aodf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aodi Real)
    (declare-const ?aodj Real)
    (declare-const ?aodk Real)
    (declare-const ?aodl Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aodj ?aodi))
                (not (= ?aodj ?asi))
                )
              (not (= ?aodi ?asi))
              )
            (or (or (= ?aodl ?aodk)
                (= ?aodl ?asi)
                )
              (= ?aodk ?asi)
              )
            )
          (and (or (or (= ?aodj ?aodi)
                (= ?aodj ?asi)
                )
              (= ?aodi ?asi)
              )
            (and (and (not (= ?aodl ?aodk))
                (not (= ?aodl ?asi))
                )
              (not (= ?aodk ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aodm Real)
    (declare-const ?aodn Real)
    (declare-const ?aodo Real)
    (declare-const ?aodp Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aodn ?aodm))
                (not (= ?aodn ?fkf))
                )
              (not (= ?aodm ?fkf))
              )
            (or (or (= ?aodp ?aodo)
                (= ?aodp ?fkf)
                )
              (= ?aodo ?fkf)
              )
            )
          (and (or (or (= ?aodn ?aodm)
                (= ?aodn ?fkf)
                )
              (= ?aodm ?fkf)
              )
            (and (and (not (= ?aodp ?aodo))
                (not (= ?aodp ?fkf))
                )
              (not (= ?aodo ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aodq Real)
    (declare-const ?aodr Real)
    (declare-const ?aods Real)
    (declare-const ?aodt Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aodr ?aodq))
                (not (= ?aodr ?mzs))
                )
              (not (= ?aodq ?mzs))
              )
            (or (or (= ?aodt ?aods)
                (= ?aodt ?mzs)
                )
              (= ?aods ?mzs)
              )
            )
          (and (or (or (= ?aodr ?aodq)
                (= ?aodr ?mzs)
                )
              (= ?aodq ?mzs)
              )
            (and (and (not (= ?aodt ?aods))
                (not (= ?aodt ?mzs))
                )
              (not (= ?aods ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aodu Real)
    (declare-const ?aodv Real)
    (declare-const ?aodw Real)
    (declare-const ?aodx Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?aodv ?aodu))
                (not (= ?aodv ?zpl))
                )
              (not (= ?aodu ?zpl))
              )
            (or (or (= ?aodx ?aodw)
                (= ?aodx ?zpl)
                )
              (= ?aodw ?zpl)
              )
            )
          (and (or (or (= ?aodv ?aodu)
                (= ?aodv ?zpl)
                )
              (= ?aodu ?zpl)
              )
            (and (and (not (= ?aodx ?aodw))
                (not (= ?aodx ?zpl))
                )
              (not (= ?aodw ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aody Real)
  (declare-const ?aodz Real)
  (declare-const ?aoea Real)
  (push 1)
    (declare-const ?aoeb Real)
    (declare-const ?aoec Real)
    (declare-const ?aoed Real)
    (assert
      (or (or (= ?aoed ?aoec)
          (= ?aoed ?aoeb)
          )
        (= ?aoec ?aoeb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoee Real)
    (declare-const ?aoef Real)
    (declare-const ?aoeg Real)
    (declare-const ?aoeh Real)
    (assert
      (or (or (= ?aoeh ?aoeg)
          (= ?aoeh ?aoef)
          )
        (= ?aoeg ?aoef)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoei Real)
    (declare-const ?aoej Real)
    (declare-const ?aoek Real)
    (declare-const ?aoel Real)
    (declare-const ?aoem Real)
    (assert
      (or (or (= ?aoem ?aoel)
          (= ?aoem ?aoek)
          )
        (= ?aoel ?aoek)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoen Real)
    (declare-const ?aoeo Real)
    (declare-const ?aoep Real)
    (declare-const ?aoeq Real)
    (declare-const ?aoer Real)
    (declare-const ?aoes Real)
    (assert
      (and (and (and (not (= ?aoep ?aoeo))
            (not (= ?aoep ?aoen))
            )
          (not (= ?aoeo ?aoen))
          )
        (or (or (= ?aoes ?aoer)
            (= ?aoes ?aoeq)
            )
          (= ?aoer ?aoeq)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoet Real)
    (declare-const ?aoeu Real)
    (declare-const ?aoev Real)
    (assert
      (or (or (= ?aoev ?aoeu)
          (= ?aoev ?aoet)
          )
        (= ?aoeu ?aoet)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoew Real)
    (declare-const ?aoex Real)
    (declare-const ?aoey Real)
    (assert
      (or (or (= ?aoey ?aoex)
          (= ?aoey ?aoew)
          )
        (= ?aoex ?aoew)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoez Real)
    (declare-const ?aofa Real)
    (declare-const ?aofb Real)
    (declare-const ?aofc Real)
    (assert
      (or (or (= ?aofb ?aofa)
          (= ?aofb ?aoez)
          )
        (= ?aofa ?aoez)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aofd Real)
    (declare-const ?aofe Real)
    (declare-const ?aoff Real)
    (declare-const ?aofg Real)
    (declare-const ?aofh Real)
    (assert
      (or (or (= ?aoff ?aofe)
          (= ?aoff ?aofd)
          )
        (= ?aofe ?aofd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aofi Real)
    (declare-const ?aofj Real)
    (declare-const ?aofk Real)
    (declare-const ?aofl Real)
    (declare-const ?aofm Real)
    (declare-const ?aofn Real)
    (assert
      (and (or (or (= ?aofk ?aofj)
            (= ?aofk ?aofi)
            )
          (= ?aofj ?aofi)
          )
        (and (and (not (= ?aofn ?aofm))
            (not (= ?aofn ?aofl))
            )
          (not (= ?aofm ?aofl))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aofo Real)
    (declare-const ?aofp Real)
    (declare-const ?aofq Real)
    (assert
      (or (or (= ?aofq ?aofp)
          (= ?aofq ?aofo)
          )
        (= ?aofp ?aofo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aofr Real)
    (declare-const ?aofs Real)
    (declare-const ?aoft Real)
    (declare-const ?aofu Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aofs ?aofr))
                (not (= ?aofs ?asi))
                )
              (not (= ?aofr ?asi))
              )
            (or (or (= ?aofu ?aoft)
                (= ?aofu ?asi)
                )
              (= ?aoft ?asi)
              )
            )
          (and (or (or (= ?aofs ?aofr)
                (= ?aofs ?asi)
                )
              (= ?aofr ?asi)
              )
            (and (and (not (= ?aofu ?aoft))
                (not (= ?aofu ?asi))
                )
              (not (= ?aoft ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aofv Real)
    (declare-const ?aofw Real)
    (declare-const ?aofx Real)
    (declare-const ?aofy Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aofw ?aofv))
                (not (= ?aofw ?fkf))
                )
              (not (= ?aofv ?fkf))
              )
            (or (or (= ?aofy ?aofx)
                (= ?aofy ?fkf)
                )
              (= ?aofx ?fkf)
              )
            )
          (and (or (or (= ?aofw ?aofv)
                (= ?aofw ?fkf)
                )
              (= ?aofv ?fkf)
              )
            (and (and (not (= ?aofy ?aofx))
                (not (= ?aofy ?fkf))
                )
              (not (= ?aofx ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aofz Real)
    (declare-const ?aoga Real)
    (declare-const ?aogb Real)
    (declare-const ?aogc Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aoga ?aofz))
                (not (= ?aoga ?mzs))
                )
              (not (= ?aofz ?mzs))
              )
            (or (or (= ?aogc ?aogb)
                (= ?aogc ?mzs)
                )
              (= ?aogb ?mzs)
              )
            )
          (and (or (or (= ?aoga ?aofz)
                (= ?aoga ?mzs)
                )
              (= ?aofz ?mzs)
              )
            (and (and (not (= ?aogc ?aogb))
                (not (= ?aogc ?mzs))
                )
              (not (= ?aogb ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aogd Real)
    (declare-const ?aoge Real)
    (declare-const ?aogf Real)
    (declare-const ?aogg Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?aoge ?aogd))
                (not (= ?aoge ?zpl))
                )
              (not (= ?aogd ?zpl))
              )
            (or (or (= ?aogg ?aogf)
                (= ?aogg ?zpl)
                )
              (= ?aogf ?zpl)
              )
            )
          (and (or (or (= ?aoge ?aogd)
                (= ?aoge ?zpl)
                )
              (= ?aogd ?zpl)
              )
            (and (and (not (= ?aogg ?aogf))
                (not (= ?aogg ?zpl))
                )
              (not (= ?aogf ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aogh Real)
  (declare-const ?aogi Real)
  (declare-const ?aogj Real)
  (declare-const ?aogk Real)
  (assert
    (exists ((?fkf Real) )(or (and (and (and (not (= ?aogi ?aogh))
              (not (= ?aogi ?fkf))
              )
            (not (= ?aogh ?fkf))
            )
          (or (or (= ?aogk ?aogj)
              (= ?aogk ?fkf)
              )
            (= ?aogj ?fkf)
            )
          )
        (and (or (or (= ?aogi ?aogh)
              (= ?aogi ?fkf)
              )
            (= ?aogh ?fkf)
            )
          (and (and (not (= ?aogk ?aogj))
              (not (= ?aogk ?fkf))
              )
            (not (= ?aogj ?fkf))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?aogl Real)
    (declare-const ?aogm Real)
    (declare-const ?aogn Real)
    (assert
      (or (or (= ?aogn ?aogm)
          (= ?aogn ?aogl)
          )
        (= ?aogm ?aogl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aogo Real)
    (declare-const ?aogp Real)
    (declare-const ?aogq Real)
    (declare-const ?aogr Real)
    (assert
      (or (or (= ?aogr ?aogq)
          (= ?aogr ?aogp)
          )
        (= ?aogq ?aogp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aogs Real)
    (declare-const ?aogt Real)
    (declare-const ?aogu Real)
    (declare-const ?aogv Real)
    (declare-const ?aogw Real)
    (assert
      (or (or (= ?aogw ?aogv)
          (= ?aogw ?aogu)
          )
        (= ?aogv ?aogu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aogx Real)
    (declare-const ?aogy Real)
    (declare-const ?aogz Real)
    (declare-const ?aoha Real)
    (declare-const ?aohb Real)
    (declare-const ?aohc Real)
    (assert
      (and (and (and (not (= ?aogz ?aogy))
            (not (= ?aogz ?aogx))
            )
          (not (= ?aogy ?aogx))
          )
        (or (or (= ?aohc ?aohb)
            (= ?aohc ?aoha)
            )
          (= ?aohb ?aoha)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aohd Real)
    (declare-const ?aohe Real)
    (declare-const ?aohf Real)
    (assert
      (or (or (= ?aohf ?aohe)
          (= ?aohf ?aohd)
          )
        (= ?aohe ?aohd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aohg Real)
    (declare-const ?aohh Real)
    (declare-const ?aohi Real)
    (assert
      (or (or (= ?aohi ?aohh)
          (= ?aohi ?aohg)
          )
        (= ?aohh ?aohg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aohj Real)
    (declare-const ?aohk Real)
    (declare-const ?aohl Real)
    (declare-const ?aohm Real)
    (assert
      (or (or (= ?aohl ?aohk)
          (= ?aohl ?aohj)
          )
        (= ?aohk ?aohj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aohn Real)
    (declare-const ?aoho Real)
    (declare-const ?aohp Real)
    (declare-const ?aohq Real)
    (declare-const ?aohr Real)
    (assert
      (or (or (= ?aohp ?aoho)
          (= ?aohp ?aohn)
          )
        (= ?aoho ?aohn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aohs Real)
    (declare-const ?aoht Real)
    (declare-const ?aohu Real)
    (declare-const ?aohv Real)
    (declare-const ?aohw Real)
    (declare-const ?aohx Real)
    (assert
      (and (or (or (= ?aohu ?aoht)
            (= ?aohu ?aohs)
            )
          (= ?aoht ?aohs)
          )
        (and (and (not (= ?aohx ?aohw))
            (not (= ?aohx ?aohv))
            )
          (not (= ?aohw ?aohv))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aohy Real)
    (declare-const ?aohz Real)
    (declare-const ?aoia Real)
    (assert
      (or (or (= ?aoia ?aohz)
          (= ?aoia ?aohy)
          )
        (= ?aohz ?aohy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoib Real)
    (declare-const ?aoic Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoid Real)
    (declare-const ?aoie Real)
    (declare-const ?aoif Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoig Real)
    (declare-const ?aoih Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoii Real)
    (declare-const ?aoij Real)
    (declare-const ?aoik Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoil Real)
    (declare-const ?aoim Real)
    (declare-const ?aoin Real)
    (declare-const ?aoio Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aoim ?aoil))
                (not (= ?aoim ?asi))
                )
              (not (= ?aoil ?asi))
              )
            (or (or (= ?aoio ?aoin)
                (= ?aoio ?asi)
                )
              (= ?aoin ?asi)
              )
            )
          (and (or (or (= ?aoim ?aoil)
                (= ?aoim ?asi)
                )
              (= ?aoil ?asi)
              )
            (and (and (not (= ?aoio ?aoin))
                (not (= ?aoio ?asi))
                )
              (not (= ?aoin ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoip Real)
    (declare-const ?aoiq Real)
    (declare-const ?aoir Real)
    (declare-const ?aois Real)
    (declare-const ?aoit Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoiu Real)
    (declare-const ?aoiv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoiw Real)
    (declare-const ?aoix Real)
    (declare-const ?aoiy Real)
    (declare-const ?aoiz Real)
    (declare-const ?aoja Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aojb Real)
    (declare-const ?aojc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aojd Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoje Real)
    (declare-const ?aojf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aojg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aojh Real)
    (declare-const ?aoji Real)
    (assert
      (not (= ?aojh ?aoji))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aojj Real)
    (declare-const ?aojk Real)
    (declare-const ?aojl Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aojm Real)
    (declare-const ?aojn Real)
    (declare-const ?aojo Real)
    (declare-const ?aojp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aojq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aojr Real)
    (declare-const ?aojs Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aojt Real)
    (declare-const ?aoju Real)
    (declare-const ?aojv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aojw Real)
    (declare-const ?aojx Real)
    (declare-const ?aojy Real)
    (declare-const ?aojz Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aojx ?aojw))
                (not (= ?aojx ?fkf))
                )
              (not (= ?aojw ?fkf))
              )
            (or (or (= ?aojz ?aojy)
                (= ?aojz ?fkf)
                )
              (= ?aojy ?fkf)
              )
            )
          (and (or (or (= ?aojx ?aojw)
                (= ?aojx ?fkf)
                )
              (= ?aojw ?fkf)
              )
            (and (and (not (= ?aojz ?aojy))
                (not (= ?aojz ?fkf))
                )
              (not (= ?aojy ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoka Real)
    (declare-const ?aokb Real)
    (declare-const ?aokc Real)
    (declare-const ?aokd Real)
    (declare-const ?aoke Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aokf Real)
    (declare-const ?aokg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aokh Real)
    (declare-const ?aoki Real)
    (declare-const ?aokj Real)
    (declare-const ?aokk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aokl Real)
    (declare-const ?aokm Real)
    (declare-const ?aokn Real)
    (declare-const ?aoko Real)
    (declare-const ?aokp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aokq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aokr Real)
    (declare-const ?aoks Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aokt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoku Real)
    (declare-const ?aokv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aokw Real)
    (declare-const ?aokx Real)
    (declare-const ?aoky Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aokz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aola Real)
    (declare-const ?aolb Real)
    (assert
      (not (= ?aola ?aolb))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aolc Real)
    (declare-const ?aold Real)
    (declare-const ?aole Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aolf Real)
    (declare-const ?aolg Real)
    (declare-const ?aolh Real)
    (declare-const ?aoli Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aolj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aolk Real)
    (declare-const ?aoll Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aolm Real)
    (declare-const ?aoln Real)
    (declare-const ?aolo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aolp Real)
    (declare-const ?aolq Real)
    (declare-const ?aolr Real)
    (declare-const ?aols Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aolq ?aolp))
                (not (= ?aolq ?mzs))
                )
              (not (= ?aolp ?mzs))
              )
            (or (or (= ?aols ?aolr)
                (= ?aols ?mzs)
                )
              (= ?aolr ?mzs)
              )
            )
          (and (or (or (= ?aolq ?aolp)
                (= ?aolq ?mzs)
                )
              (= ?aolp ?mzs)
              )
            (and (and (not (= ?aols ?aolr))
                (not (= ?aols ?mzs))
                )
              (not (= ?aolr ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aolt Real)
    (declare-const ?aolu Real)
    (declare-const ?aolv Real)
    (declare-const ?aolw Real)
    (declare-const ?aolx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoly Real)
    (declare-const ?aolz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoma Real)
    (declare-const ?aomb Real)
    (declare-const ?aomc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aomd Real)
    (declare-const ?aome Real)
    (declare-const ?aomf Real)
    (declare-const ?aomg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aomh Real)
    (declare-const ?aomi Real)
    (declare-const ?aomj Real)
    (declare-const ?aomk Real)
    (declare-const ?aoml Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aomm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aomn Real)
    (declare-const ?aomo Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aomp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aomq Real)
    (declare-const ?aomr Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoms Real)
    (declare-const ?aomt Real)
    (declare-const ?aomu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aomv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aomw Real)
    (declare-const ?aomx Real)
    (assert
      (not (= ?aomw ?aomx))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aomy Real)
    (declare-const ?aomz Real)
    (declare-const ?aona Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aonb Real)
    (declare-const ?aonc Real)
    (declare-const ?aond Real)
    (declare-const ?aone Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aonf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aong Real)
    (declare-const ?aonh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoni Real)
    (declare-const ?aonj Real)
    (declare-const ?aonk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aonl Real)
    (declare-const ?aonm Real)
    (declare-const ?aonn Real)
    (declare-const ?aono Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?aonm ?aonl))
                (not (= ?aonm ?zpl))
                )
              (not (= ?aonl ?zpl))
              )
            (or (or (= ?aono ?aonn)
                (= ?aono ?zpl)
                )
              (= ?aonn ?zpl)
              )
            )
          (and (or (or (= ?aonm ?aonl)
                (= ?aonm ?zpl)
                )
              (= ?aonl ?zpl)
              )
            (and (and (not (= ?aono ?aonn))
                (not (= ?aono ?zpl))
                )
              (not (= ?aonn ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aonp Real)
    (declare-const ?aonq Real)
    (declare-const ?aonr Real)
    (declare-const ?aons Real)
    (declare-const ?aont Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aonu Real)
    (declare-const ?aonv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aonw Real)
    (declare-const ?aonx Real)
    (declare-const ?aony Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aonz Real)
    (declare-const ?aooa Real)
    (declare-const ?aoob Real)
    (declare-const ?aooc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aood Real)
    (declare-const ?aooe Real)
    (declare-const ?aoof Real)
    (declare-const ?aoog Real)
    (declare-const ?aooh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aooi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aooj Real)
    (declare-const ?aook Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aool Real)
  (declare-const ?aoom Real)
  (declare-const ?aoon Real)
  (declare-const ?aooo Real)
  (declare-const ?aoop Real)
  (push 1)
    (declare-const ?aooq Real)
    (declare-const ?aoor Real)
    (declare-const ?aoos Real)
    (assert
      (or (or (= ?aoos ?aoor)
          (= ?aoos ?aooq)
          )
        (= ?aoor ?aooq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoot Real)
    (declare-const ?aoou Real)
    (declare-const ?aoov Real)
    (declare-const ?aoow Real)
    (assert
      (or (or (= ?aoow ?aoov)
          (= ?aoow ?aoou)
          )
        (= ?aoov ?aoou)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoox Real)
    (declare-const ?aooy Real)
    (declare-const ?aooz Real)
    (declare-const ?aopa Real)
    (declare-const ?aopb Real)
    (assert
      (or (or (= ?aopb ?aopa)
          (= ?aopb ?aooz)
          )
        (= ?aopa ?aooz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aopc Real)
    (declare-const ?aopd Real)
    (declare-const ?aope Real)
    (declare-const ?aopf Real)
    (declare-const ?aopg Real)
    (declare-const ?aoph Real)
    (assert
      (and (and (and (not (= ?aope ?aopd))
            (not (= ?aope ?aopc))
            )
          (not (= ?aopd ?aopc))
          )
        (or (or (= ?aoph ?aopg)
            (= ?aoph ?aopf)
            )
          (= ?aopg ?aopf)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aopi Real)
    (declare-const ?aopj Real)
    (declare-const ?aopk Real)
    (assert
      (or (or (= ?aopk ?aopj)
          (= ?aopk ?aopi)
          )
        (= ?aopj ?aopi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aopl Real)
    (declare-const ?aopm Real)
    (declare-const ?aopn Real)
    (assert
      (or (or (= ?aopn ?aopm)
          (= ?aopn ?aopl)
          )
        (= ?aopm ?aopl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aopo Real)
    (declare-const ?aopp Real)
    (declare-const ?aopq Real)
    (declare-const ?aopr Real)
    (assert
      (or (or (= ?aopq ?aopp)
          (= ?aopq ?aopo)
          )
        (= ?aopp ?aopo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aops Real)
    (declare-const ?aopt Real)
    (declare-const ?aopu Real)
    (declare-const ?aopv Real)
    (declare-const ?aopw Real)
    (assert
      (or (or (= ?aopu ?aopt)
          (= ?aopu ?aops)
          )
        (= ?aopt ?aops)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aopx Real)
    (declare-const ?aopy Real)
    (declare-const ?aopz Real)
    (declare-const ?aoqa Real)
    (declare-const ?aoqb Real)
    (declare-const ?aoqc Real)
    (assert
      (and (or (or (= ?aopz ?aopy)
            (= ?aopz ?aopx)
            )
          (= ?aopy ?aopx)
          )
        (and (and (not (= ?aoqc ?aoqb))
            (not (= ?aoqc ?aoqa))
            )
          (not (= ?aoqb ?aoqa))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoqd Real)
    (declare-const ?aoqe Real)
    (declare-const ?aoqf Real)
    (assert
      (or (or (= ?aoqf ?aoqe)
          (= ?aoqf ?aoqd)
          )
        (= ?aoqe ?aoqd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoqg Real)
    (declare-const ?aoqh Real)
    (declare-const ?aoqi Real)
    (declare-const ?aoqj Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aoqh ?aoqg))
                (not (= ?aoqh ?asi))
                )
              (not (= ?aoqg ?asi))
              )
            (or (or (= ?aoqj ?aoqi)
                (= ?aoqj ?asi)
                )
              (= ?aoqi ?asi)
              )
            )
          (and (or (or (= ?aoqh ?aoqg)
                (= ?aoqh ?asi)
                )
              (= ?aoqg ?asi)
              )
            (and (and (not (= ?aoqj ?aoqi))
                (not (= ?aoqj ?asi))
                )
              (not (= ?aoqi ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoqk Real)
    (declare-const ?aoql Real)
    (declare-const ?aoqm Real)
    (declare-const ?aoqn Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aoql ?aoqk))
                (not (= ?aoql ?fkf))
                )
              (not (= ?aoqk ?fkf))
              )
            (or (or (= ?aoqn ?aoqm)
                (= ?aoqn ?fkf)
                )
              (= ?aoqm ?fkf)
              )
            )
          (and (or (or (= ?aoql ?aoqk)
                (= ?aoql ?fkf)
                )
              (= ?aoqk ?fkf)
              )
            (and (and (not (= ?aoqn ?aoqm))
                (not (= ?aoqn ?fkf))
                )
              (not (= ?aoqm ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoqo Real)
    (declare-const ?aoqp Real)
    (declare-const ?aoqq Real)
    (declare-const ?aoqr Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aoqp ?aoqo))
                (not (= ?aoqp ?mzs))
                )
              (not (= ?aoqo ?mzs))
              )
            (or (or (= ?aoqr ?aoqq)
                (= ?aoqr ?mzs)
                )
              (= ?aoqq ?mzs)
              )
            )
          (and (or (or (= ?aoqp ?aoqo)
                (= ?aoqp ?mzs)
                )
              (= ?aoqo ?mzs)
              )
            (and (and (not (= ?aoqr ?aoqq))
                (not (= ?aoqr ?mzs))
                )
              (not (= ?aoqq ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoqs Real)
    (declare-const ?aoqt Real)
    (declare-const ?aoqu Real)
    (declare-const ?aoqv Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?aoqt ?aoqs))
                (not (= ?aoqt ?zpl))
                )
              (not (= ?aoqs ?zpl))
              )
            (or (or (= ?aoqv ?aoqu)
                (= ?aoqv ?zpl)
                )
              (= ?aoqu ?zpl)
              )
            )
          (and (or (or (= ?aoqt ?aoqs)
                (= ?aoqt ?zpl)
                )
              (= ?aoqs ?zpl)
              )
            (and (and (not (= ?aoqv ?aoqu))
                (not (= ?aoqv ?zpl))
                )
              (not (= ?aoqu ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aoqw Real)
  (declare-const ?aoqx Real)
  (push 1)
    (declare-const ?aoqy Real)
    (declare-const ?aoqz Real)
    (declare-const ?aora Real)
    (assert
      (or (or (= ?aora ?aoqz)
          (= ?aora ?aoqy)
          )
        (= ?aoqz ?aoqy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aorb Real)
    (declare-const ?aorc Real)
    (declare-const ?aord Real)
    (declare-const ?aore Real)
    (assert
      (or (or (= ?aore ?aord)
          (= ?aore ?aorc)
          )
        (= ?aord ?aorc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aorf Real)
    (declare-const ?aorg Real)
    (declare-const ?aorh Real)
    (declare-const ?aori Real)
    (declare-const ?aorj Real)
    (assert
      (or (or (= ?aorj ?aori)
          (= ?aorj ?aorh)
          )
        (= ?aori ?aorh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aork Real)
    (declare-const ?aorl Real)
    (declare-const ?aorm Real)
    (declare-const ?aorn Real)
    (declare-const ?aoro Real)
    (declare-const ?aorp Real)
    (assert
      (and (and (and (not (= ?aorm ?aorl))
            (not (= ?aorm ?aork))
            )
          (not (= ?aorl ?aork))
          )
        (or (or (= ?aorp ?aoro)
            (= ?aorp ?aorn)
            )
          (= ?aoro ?aorn)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aorq Real)
    (declare-const ?aorr Real)
    (declare-const ?aors Real)
    (assert
      (or (or (= ?aors ?aorr)
          (= ?aors ?aorq)
          )
        (= ?aorr ?aorq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aort Real)
    (declare-const ?aoru Real)
    (declare-const ?aorv Real)
    (assert
      (or (or (= ?aorv ?aoru)
          (= ?aorv ?aort)
          )
        (= ?aoru ?aort)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aorw Real)
    (declare-const ?aorx Real)
    (declare-const ?aory Real)
    (declare-const ?aorz Real)
    (assert
      (or (or (= ?aory ?aorx)
          (= ?aory ?aorw)
          )
        (= ?aorx ?aorw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aosa Real)
    (declare-const ?aosb Real)
    (declare-const ?aosc Real)
    (declare-const ?aosd Real)
    (declare-const ?aose Real)
    (assert
      (or (or (= ?aosc ?aosb)
          (= ?aosc ?aosa)
          )
        (= ?aosb ?aosa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aosf Real)
    (declare-const ?aosg Real)
    (declare-const ?aosh Real)
    (declare-const ?aosi Real)
    (declare-const ?aosj Real)
    (declare-const ?aosk Real)
    (assert
      (and (or (or (= ?aosh ?aosg)
            (= ?aosh ?aosf)
            )
          (= ?aosg ?aosf)
          )
        (and (and (not (= ?aosk ?aosj))
            (not (= ?aosk ?aosi))
            )
          (not (= ?aosj ?aosi))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aosl Real)
    (declare-const ?aosm Real)
    (declare-const ?aosn Real)
    (assert
      (or (or (= ?aosn ?aosm)
          (= ?aosn ?aosl)
          )
        (= ?aosm ?aosl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoso Real)
    (declare-const ?aosp Real)
    (declare-const ?aosq Real)
    (declare-const ?aosr Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aosp ?aoso))
                (not (= ?aosp ?asi))
                )
              (not (= ?aoso ?asi))
              )
            (or (or (= ?aosr ?aosq)
                (= ?aosr ?asi)
                )
              (= ?aosq ?asi)
              )
            )
          (and (or (or (= ?aosp ?aoso)
                (= ?aosp ?asi)
                )
              (= ?aoso ?asi)
              )
            (and (and (not (= ?aosr ?aosq))
                (not (= ?aosr ?asi))
                )
              (not (= ?aosq ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoss Real)
    (declare-const ?aost Real)
    (declare-const ?aosu Real)
    (declare-const ?aosv Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aost ?aoss))
                (not (= ?aost ?fkf))
                )
              (not (= ?aoss ?fkf))
              )
            (or (or (= ?aosv ?aosu)
                (= ?aosv ?fkf)
                )
              (= ?aosu ?fkf)
              )
            )
          (and (or (or (= ?aost ?aoss)
                (= ?aost ?fkf)
                )
              (= ?aoss ?fkf)
              )
            (and (and (not (= ?aosv ?aosu))
                (not (= ?aosv ?fkf))
                )
              (not (= ?aosu ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aosw Real)
    (declare-const ?aosx Real)
    (declare-const ?aosy Real)
    (declare-const ?aosz Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aosx ?aosw))
                (not (= ?aosx ?mzs))
                )
              (not (= ?aosw ?mzs))
              )
            (or (or (= ?aosz ?aosy)
                (= ?aosz ?mzs)
                )
              (= ?aosy ?mzs)
              )
            )
          (and (or (or (= ?aosx ?aosw)
                (= ?aosx ?mzs)
                )
              (= ?aosw ?mzs)
              )
            (and (and (not (= ?aosz ?aosy))
                (not (= ?aosz ?mzs))
                )
              (not (= ?aosy ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aota Real)
    (declare-const ?aotb Real)
    (declare-const ?aotc Real)
    (declare-const ?aotd Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?aotb ?aota))
                (not (= ?aotb ?zpl))
                )
              (not (= ?aota ?zpl))
              )
            (or (or (= ?aotd ?aotc)
                (= ?aotd ?zpl)
                )
              (= ?aotc ?zpl)
              )
            )
          (and (or (or (= ?aotb ?aota)
                (= ?aotb ?zpl)
                )
              (= ?aota ?zpl)
              )
            (and (and (not (= ?aotd ?aotc))
                (not (= ?aotd ?zpl))
                )
              (not (= ?aotc ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aote Real)
  (declare-const ?aotf Real)
  (declare-const ?aotg Real)
  (declare-const ?aoth Real)
  (push 1)
    (declare-const ?aoti Real)
    (declare-const ?aotj Real)
    (declare-const ?aotk Real)
    (assert
      (or (or (= ?aotk ?aotj)
          (= ?aotk ?aoti)
          )
        (= ?aotj ?aoti)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aotl Real)
    (declare-const ?aotm Real)
    (declare-const ?aotn Real)
    (declare-const ?aoto Real)
    (assert
      (or (or (= ?aoto ?aotn)
          (= ?aoto ?aotm)
          )
        (= ?aotn ?aotm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aotp Real)
    (declare-const ?aotq Real)
    (declare-const ?aotr Real)
    (declare-const ?aots Real)
    (declare-const ?aott Real)
    (assert
      (or (or (= ?aott ?aots)
          (= ?aott ?aotr)
          )
        (= ?aots ?aotr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aotu Real)
    (declare-const ?aotv Real)
    (declare-const ?aotw Real)
    (declare-const ?aotx Real)
    (declare-const ?aoty Real)
    (declare-const ?aotz Real)
    (assert
      (and (and (and (not (= ?aotw ?aotv))
            (not (= ?aotw ?aotu))
            )
          (not (= ?aotv ?aotu))
          )
        (or (or (= ?aotz ?aoty)
            (= ?aotz ?aotx)
            )
          (= ?aoty ?aotx)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoua Real)
    (declare-const ?aoub Real)
    (declare-const ?aouc Real)
    (assert
      (or (or (= ?aouc ?aoub)
          (= ?aouc ?aoua)
          )
        (= ?aoub ?aoua)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoud Real)
    (declare-const ?aoue Real)
    (declare-const ?aouf Real)
    (assert
      (or (or (= ?aouf ?aoue)
          (= ?aouf ?aoud)
          )
        (= ?aoue ?aoud)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoug Real)
    (declare-const ?aouh Real)
    (declare-const ?aoui Real)
    (declare-const ?aouj Real)
    (assert
      (or (or (= ?aoui ?aouh)
          (= ?aoui ?aoug)
          )
        (= ?aouh ?aoug)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aouk Real)
    (declare-const ?aoul Real)
    (declare-const ?aoum Real)
    (declare-const ?aoun Real)
    (declare-const ?aouo Real)
    (assert
      (or (or (= ?aoum ?aoul)
          (= ?aoum ?aouk)
          )
        (= ?aoul ?aouk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoup Real)
    (declare-const ?aouq Real)
    (declare-const ?aour Real)
    (declare-const ?aous Real)
    (declare-const ?aout Real)
    (declare-const ?aouu Real)
    (assert
      (and (or (or (= ?aour ?aouq)
            (= ?aour ?aoup)
            )
          (= ?aouq ?aoup)
          )
        (and (and (not (= ?aouu ?aout))
            (not (= ?aouu ?aous))
            )
          (not (= ?aout ?aous))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aouv Real)
    (declare-const ?aouw Real)
    (declare-const ?aoux Real)
    (assert
      (or (or (= ?aoux ?aouw)
          (= ?aoux ?aouv)
          )
        (= ?aouw ?aouv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aouy Real)
    (declare-const ?aouz Real)
    (declare-const ?aova Real)
    (declare-const ?aovb Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aouz ?aouy))
                (not (= ?aouz ?asi))
                )
              (not (= ?aouy ?asi))
              )
            (or (or (= ?aovb ?aova)
                (= ?aovb ?asi)
                )
              (= ?aova ?asi)
              )
            )
          (and (or (or (= ?aouz ?aouy)
                (= ?aouz ?asi)
                )
              (= ?aouy ?asi)
              )
            (and (and (not (= ?aovb ?aova))
                (not (= ?aovb ?asi))
                )
              (not (= ?aova ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aovc Real)
    (declare-const ?aovd Real)
    (declare-const ?aove Real)
    (declare-const ?aovf Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aovd ?aovc))
                (not (= ?aovd ?fkf))
                )
              (not (= ?aovc ?fkf))
              )
            (or (or (= ?aovf ?aove)
                (= ?aovf ?fkf)
                )
              (= ?aove ?fkf)
              )
            )
          (and (or (or (= ?aovd ?aovc)
                (= ?aovd ?fkf)
                )
              (= ?aovc ?fkf)
              )
            (and (and (not (= ?aovf ?aove))
                (not (= ?aovf ?fkf))
                )
              (not (= ?aove ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aovg Real)
    (declare-const ?aovh Real)
    (declare-const ?aovi Real)
    (declare-const ?aovj Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aovh ?aovg))
                (not (= ?aovh ?mzs))
                )
              (not (= ?aovg ?mzs))
              )
            (or (or (= ?aovj ?aovi)
                (= ?aovj ?mzs)
                )
              (= ?aovi ?mzs)
              )
            )
          (and (or (or (= ?aovh ?aovg)
                (= ?aovh ?mzs)
                )
              (= ?aovg ?mzs)
              )
            (and (and (not (= ?aovj ?aovi))
                (not (= ?aovj ?mzs))
                )
              (not (= ?aovi ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aovk Real)
    (declare-const ?aovl Real)
    (declare-const ?aovm Real)
    (declare-const ?aovn Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?aovl ?aovk))
                (not (= ?aovl ?zpl))
                )
              (not (= ?aovk ?zpl))
              )
            (or (or (= ?aovn ?aovm)
                (= ?aovn ?zpl)
                )
              (= ?aovm ?zpl)
              )
            )
          (and (or (or (= ?aovl ?aovk)
                (= ?aovl ?zpl)
                )
              (= ?aovk ?zpl)
              )
            (and (and (not (= ?aovn ?aovm))
                (not (= ?aovn ?zpl))
                )
              (not (= ?aovm ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aovo Real)
  (declare-const ?aovp Real)
  (declare-const ?aovq Real)
  (declare-const ?aovr Real)
  (declare-const ?aovs Real)
  (push 1)
    (declare-const ?aovt Real)
    (declare-const ?aovu Real)
    (declare-const ?aovv Real)
    (assert
      (or (or (= ?aovv ?aovu)
          (= ?aovv ?aovt)
          )
        (= ?aovu ?aovt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aovw Real)
    (declare-const ?aovx Real)
    (declare-const ?aovy Real)
    (declare-const ?aovz Real)
    (assert
      (or (or (= ?aovz ?aovy)
          (= ?aovz ?aovx)
          )
        (= ?aovy ?aovx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aowa Real)
    (declare-const ?aowb Real)
    (declare-const ?aowc Real)
    (declare-const ?aowd Real)
    (declare-const ?aowe Real)
    (assert
      (or (or (= ?aowe ?aowd)
          (= ?aowe ?aowc)
          )
        (= ?aowd ?aowc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aowf Real)
    (declare-const ?aowg Real)
    (declare-const ?aowh Real)
    (declare-const ?aowi Real)
    (declare-const ?aowj Real)
    (declare-const ?aowk Real)
    (assert
      (and (and (and (not (= ?aowh ?aowg))
            (not (= ?aowh ?aowf))
            )
          (not (= ?aowg ?aowf))
          )
        (or (or (= ?aowk ?aowj)
            (= ?aowk ?aowi)
            )
          (= ?aowj ?aowi)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aowl Real)
    (declare-const ?aowm Real)
    (declare-const ?aown Real)
    (assert
      (or (or (= ?aown ?aowm)
          (= ?aown ?aowl)
          )
        (= ?aowm ?aowl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aowo Real)
    (declare-const ?aowp Real)
    (declare-const ?aowq Real)
    (assert
      (or (or (= ?aowq ?aowp)
          (= ?aowq ?aowo)
          )
        (= ?aowp ?aowo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aowr Real)
    (declare-const ?aows Real)
    (declare-const ?aowt Real)
    (declare-const ?aowu Real)
    (assert
      (or (or (= ?aowt ?aows)
          (= ?aowt ?aowr)
          )
        (= ?aows ?aowr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aowv Real)
    (declare-const ?aoww Real)
    (declare-const ?aowx Real)
    (declare-const ?aowy Real)
    (declare-const ?aowz Real)
    (assert
      (or (or (= ?aowx ?aoww)
          (= ?aowx ?aowv)
          )
        (= ?aoww ?aowv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoxa Real)
    (declare-const ?aoxb Real)
    (declare-const ?aoxc Real)
    (declare-const ?aoxd Real)
    (declare-const ?aoxe Real)
    (declare-const ?aoxf Real)
    (assert
      (and (or (or (= ?aoxc ?aoxb)
            (= ?aoxc ?aoxa)
            )
          (= ?aoxb ?aoxa)
          )
        (and (and (not (= ?aoxf ?aoxe))
            (not (= ?aoxf ?aoxd))
            )
          (not (= ?aoxe ?aoxd))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoxg Real)
    (declare-const ?aoxh Real)
    (declare-const ?aoxi Real)
    (assert
      (or (or (= ?aoxi ?aoxh)
          (= ?aoxi ?aoxg)
          )
        (= ?aoxh ?aoxg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoxj Real)
    (declare-const ?aoxk Real)
    (declare-const ?aoxl Real)
    (declare-const ?aoxm Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aoxk ?aoxj))
                (not (= ?aoxk ?asi))
                )
              (not (= ?aoxj ?asi))
              )
            (or (or (= ?aoxm ?aoxl)
                (= ?aoxm ?asi)
                )
              (= ?aoxl ?asi)
              )
            )
          (and (or (or (= ?aoxk ?aoxj)
                (= ?aoxk ?asi)
                )
              (= ?aoxj ?asi)
              )
            (and (and (not (= ?aoxm ?aoxl))
                (not (= ?aoxm ?asi))
                )
              (not (= ?aoxl ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoxn Real)
    (declare-const ?aoxo Real)
    (declare-const ?aoxp Real)
    (declare-const ?aoxq Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aoxo ?aoxn))
                (not (= ?aoxo ?fkf))
                )
              (not (= ?aoxn ?fkf))
              )
            (or (or (= ?aoxq ?aoxp)
                (= ?aoxq ?fkf)
                )
              (= ?aoxp ?fkf)
              )
            )
          (and (or (or (= ?aoxo ?aoxn)
                (= ?aoxo ?fkf)
                )
              (= ?aoxn ?fkf)
              )
            (and (and (not (= ?aoxq ?aoxp))
                (not (= ?aoxq ?fkf))
                )
              (not (= ?aoxp ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoxr Real)
    (declare-const ?aoxs Real)
    (declare-const ?aoxt Real)
    (declare-const ?aoxu Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aoxs ?aoxr))
                (not (= ?aoxs ?mzs))
                )
              (not (= ?aoxr ?mzs))
              )
            (or (or (= ?aoxu ?aoxt)
                (= ?aoxu ?mzs)
                )
              (= ?aoxt ?mzs)
              )
            )
          (and (or (or (= ?aoxs ?aoxr)
                (= ?aoxs ?mzs)
                )
              (= ?aoxr ?mzs)
              )
            (and (and (not (= ?aoxu ?aoxt))
                (not (= ?aoxu ?mzs))
                )
              (not (= ?aoxt ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoxv Real)
    (declare-const ?aoxw Real)
    (declare-const ?aoxx Real)
    (declare-const ?aoxy Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?aoxw ?aoxv))
                (not (= ?aoxw ?zpl))
                )
              (not (= ?aoxv ?zpl))
              )
            (or (or (= ?aoxy ?aoxx)
                (= ?aoxy ?zpl)
                )
              (= ?aoxx ?zpl)
              )
            )
          (and (or (or (= ?aoxw ?aoxv)
                (= ?aoxw ?zpl)
                )
              (= ?aoxv ?zpl)
              )
            (and (and (not (= ?aoxy ?aoxx))
                (not (= ?aoxy ?zpl))
                )
              (not (= ?aoxx ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aoxz Real)
  (push 1)
    (declare-const ?aoya Real)
    (declare-const ?aoyb Real)
    (declare-const ?aoyc Real)
    (assert
      (or (or (= ?aoyc ?aoyb)
          (= ?aoyc ?aoya)
          )
        (= ?aoyb ?aoya)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoyd Real)
    (declare-const ?aoye Real)
    (declare-const ?aoyf Real)
    (declare-const ?aoyg Real)
    (assert
      (or (or (= ?aoyg ?aoyf)
          (= ?aoyg ?aoye)
          )
        (= ?aoyf ?aoye)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoyh Real)
    (declare-const ?aoyi Real)
    (declare-const ?aoyj Real)
    (declare-const ?aoyk Real)
    (declare-const ?aoyl Real)
    (assert
      (or (or (= ?aoyl ?aoyk)
          (= ?aoyl ?aoyj)
          )
        (= ?aoyk ?aoyj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoym Real)
    (declare-const ?aoyn Real)
    (declare-const ?aoyo Real)
    (declare-const ?aoyp Real)
    (declare-const ?aoyq Real)
    (declare-const ?aoyr Real)
    (assert
      (and (and (and (not (= ?aoyo ?aoyn))
            (not (= ?aoyo ?aoym))
            )
          (not (= ?aoyn ?aoym))
          )
        (or (or (= ?aoyr ?aoyq)
            (= ?aoyr ?aoyp)
            )
          (= ?aoyq ?aoyp)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoys Real)
    (declare-const ?aoyt Real)
    (declare-const ?aoyu Real)
    (assert
      (or (or (= ?aoyu ?aoyt)
          (= ?aoyu ?aoys)
          )
        (= ?aoyt ?aoys)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoyv Real)
    (declare-const ?aoyw Real)
    (declare-const ?aoyx Real)
    (assert
      (or (or (= ?aoyx ?aoyw)
          (= ?aoyx ?aoyv)
          )
        (= ?aoyw ?aoyv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aoyy Real)
    (declare-const ?aoyz Real)
    (declare-const ?aoza Real)
    (declare-const ?aozb Real)
    (assert
      (or (or (= ?aoza ?aoyz)
          (= ?aoza ?aoyy)
          )
        (= ?aoyz ?aoyy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aozc Real)
    (declare-const ?aozd Real)
    (declare-const ?aoze Real)
    (declare-const ?aozf Real)
    (declare-const ?aozg Real)
    (assert
      (or (or (= ?aoze ?aozd)
          (= ?aoze ?aozc)
          )
        (= ?aozd ?aozc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aozh Real)
    (declare-const ?aozi Real)
    (declare-const ?aozj Real)
    (declare-const ?aozk Real)
    (declare-const ?aozl Real)
    (declare-const ?aozm Real)
    (assert
      (and (or (or (= ?aozj ?aozi)
            (= ?aozj ?aozh)
            )
          (= ?aozi ?aozh)
          )
        (and (and (not (= ?aozm ?aozl))
            (not (= ?aozm ?aozk))
            )
          (not (= ?aozl ?aozk))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aozn Real)
    (declare-const ?aozo Real)
    (declare-const ?aozp Real)
    (assert
      (or (or (= ?aozp ?aozo)
          (= ?aozp ?aozn)
          )
        (= ?aozo ?aozn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aozq Real)
    (declare-const ?aozr Real)
    (declare-const ?aozs Real)
    (declare-const ?aozt Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aozr ?aozq))
                (not (= ?aozr ?asi))
                )
              (not (= ?aozq ?asi))
              )
            (or (or (= ?aozt ?aozs)
                (= ?aozt ?asi)
                )
              (= ?aozs ?asi)
              )
            )
          (and (or (or (= ?aozr ?aozq)
                (= ?aozr ?asi)
                )
              (= ?aozq ?asi)
              )
            (and (and (not (= ?aozt ?aozs))
                (not (= ?aozt ?asi))
                )
              (not (= ?aozs ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aozu Real)
    (declare-const ?aozv Real)
    (declare-const ?aozw Real)
    (declare-const ?aozx Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aozv ?aozu))
                (not (= ?aozv ?fkf))
                )
              (not (= ?aozu ?fkf))
              )
            (or (or (= ?aozx ?aozw)
                (= ?aozx ?fkf)
                )
              (= ?aozw ?fkf)
              )
            )
          (and (or (or (= ?aozv ?aozu)
                (= ?aozv ?fkf)
                )
              (= ?aozu ?fkf)
              )
            (and (and (not (= ?aozx ?aozw))
                (not (= ?aozx ?fkf))
                )
              (not (= ?aozw ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aozy Real)
    (declare-const ?aozz Real)
    (declare-const ?apaa Real)
    (declare-const ?apab Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aozz ?aozy))
                (not (= ?aozz ?mzs))
                )
              (not (= ?aozy ?mzs))
              )
            (or (or (= ?apab ?apaa)
                (= ?apab ?mzs)
                )
              (= ?apaa ?mzs)
              )
            )
          (and (or (or (= ?aozz ?aozy)
                (= ?aozz ?mzs)
                )
              (= ?aozy ?mzs)
              )
            (and (and (not (= ?apab ?apaa))
                (not (= ?apab ?mzs))
                )
              (not (= ?apaa ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apac Real)
    (declare-const ?apad Real)
    (declare-const ?apae Real)
    (declare-const ?apaf Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?apad ?apac))
                (not (= ?apad ?zpl))
                )
              (not (= ?apac ?zpl))
              )
            (or (or (= ?apaf ?apae)
                (= ?apaf ?zpl)
                )
              (= ?apae ?zpl)
              )
            )
          (and (or (or (= ?apad ?apac)
                (= ?apad ?zpl)
                )
              (= ?apac ?zpl)
              )
            (and (and (not (= ?apaf ?apae))
                (not (= ?apaf ?zpl))
                )
              (not (= ?apae ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?apag Real)
  (declare-const ?apah Real)
  (push 1)
    (declare-const ?apai Real)
    (declare-const ?apaj Real)
    (declare-const ?apak Real)
    (assert
      (or (or (= ?apak ?apaj)
          (= ?apak ?apai)
          )
        (= ?apaj ?apai)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apal Real)
    (declare-const ?apam Real)
    (declare-const ?apan Real)
    (declare-const ?apao Real)
    (assert
      (or (or (= ?apao ?apan)
          (= ?apao ?apam)
          )
        (= ?apan ?apam)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apap Real)
    (declare-const ?apaq Real)
    (declare-const ?apar Real)
    (declare-const ?apas Real)
    (declare-const ?apat Real)
    (assert
      (or (or (= ?apat ?apas)
          (= ?apat ?apar)
          )
        (= ?apas ?apar)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apau Real)
    (declare-const ?apav Real)
    (declare-const ?apaw Real)
    (declare-const ?apax Real)
    (declare-const ?apay Real)
    (declare-const ?apaz Real)
    (assert
      (and (and (and (not (= ?apaw ?apav))
            (not (= ?apaw ?apau))
            )
          (not (= ?apav ?apau))
          )
        (or (or (= ?apaz ?apay)
            (= ?apaz ?apax)
            )
          (= ?apay ?apax)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apba Real)
    (declare-const ?apbb Real)
    (declare-const ?apbc Real)
    (assert
      (or (or (= ?apbc ?apbb)
          (= ?apbc ?apba)
          )
        (= ?apbb ?apba)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apbd Real)
    (declare-const ?apbe Real)
    (declare-const ?apbf Real)
    (assert
      (or (or (= ?apbf ?apbe)
          (= ?apbf ?apbd)
          )
        (= ?apbe ?apbd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apbg Real)
    (declare-const ?apbh Real)
    (declare-const ?apbi Real)
    (declare-const ?apbj Real)
    (assert
      (or (or (= ?apbi ?apbh)
          (= ?apbi ?apbg)
          )
        (= ?apbh ?apbg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apbk Real)
    (declare-const ?apbl Real)
    (declare-const ?apbm Real)
    (declare-const ?apbn Real)
    (declare-const ?apbo Real)
    (assert
      (or (or (= ?apbm ?apbl)
          (= ?apbm ?apbk)
          )
        (= ?apbl ?apbk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apbp Real)
    (declare-const ?apbq Real)
    (declare-const ?apbr Real)
    (declare-const ?apbs Real)
    (declare-const ?apbt Real)
    (declare-const ?apbu Real)
    (assert
      (and (or (or (= ?apbr ?apbq)
            (= ?apbr ?apbp)
            )
          (= ?apbq ?apbp)
          )
        (and (and (not (= ?apbu ?apbt))
            (not (= ?apbu ?apbs))
            )
          (not (= ?apbt ?apbs))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apbv Real)
    (declare-const ?apbw Real)
    (declare-const ?apbx Real)
    (assert
      (or (or (= ?apbx ?apbw)
          (= ?apbx ?apbv)
          )
        (= ?apbw ?apbv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apby Real)
    (declare-const ?apbz Real)
    (declare-const ?apca Real)
    (declare-const ?apcb Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?apbz ?apby))
                (not (= ?apbz ?asi))
                )
              (not (= ?apby ?asi))
              )
            (or (or (= ?apcb ?apca)
                (= ?apcb ?asi)
                )
              (= ?apca ?asi)
              )
            )
          (and (or (or (= ?apbz ?apby)
                (= ?apbz ?asi)
                )
              (= ?apby ?asi)
              )
            (and (and (not (= ?apcb ?apca))
                (not (= ?apcb ?asi))
                )
              (not (= ?apca ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apcc Real)
    (declare-const ?apcd Real)
    (declare-const ?apce Real)
    (declare-const ?apcf Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?apcd ?apcc))
                (not (= ?apcd ?fkf))
                )
              (not (= ?apcc ?fkf))
              )
            (or (or (= ?apcf ?apce)
                (= ?apcf ?fkf)
                )
              (= ?apce ?fkf)
              )
            )
          (and (or (or (= ?apcd ?apcc)
                (= ?apcd ?fkf)
                )
              (= ?apcc ?fkf)
              )
            (and (and (not (= ?apcf ?apce))
                (not (= ?apcf ?fkf))
                )
              (not (= ?apce ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apcg Real)
    (declare-const ?apch Real)
    (declare-const ?apci Real)
    (declare-const ?apcj Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?apch ?apcg))
                (not (= ?apch ?mzs))
                )
              (not (= ?apcg ?mzs))
              )
            (or (or (= ?apcj ?apci)
                (= ?apcj ?mzs)
                )
              (= ?apci ?mzs)
              )
            )
          (and (or (or (= ?apch ?apcg)
                (= ?apch ?mzs)
                )
              (= ?apcg ?mzs)
              )
            (and (and (not (= ?apcj ?apci))
                (not (= ?apcj ?mzs))
                )
              (not (= ?apci ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apck Real)
    (declare-const ?apcl Real)
    (declare-const ?apcm Real)
    (declare-const ?apcn Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?apcl ?apck))
                (not (= ?apcl ?zpl))
                )
              (not (= ?apck ?zpl))
              )
            (or (or (= ?apcn ?apcm)
                (= ?apcn ?zpl)
                )
              (= ?apcm ?zpl)
              )
            )
          (and (or (or (= ?apcl ?apck)
                (= ?apcl ?zpl)
                )
              (= ?apck ?zpl)
              )
            (and (and (not (= ?apcn ?apcm))
                (not (= ?apcn ?zpl))
                )
              (not (= ?apcm ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?apco Real)
  (push 1)
    (declare-const ?apcp Real)
    (declare-const ?apcq Real)
    (declare-const ?apcr Real)
    (assert
      (or (or (= ?apcr ?apcq)
          (= ?apcr ?apcp)
          )
        (= ?apcq ?apcp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apcs Real)
    (declare-const ?apct Real)
    (declare-const ?apcu Real)
    (declare-const ?apcv Real)
    (assert
      (or (or (= ?apcv ?apcu)
          (= ?apcv ?apct)
          )
        (= ?apcu ?apct)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apcw Real)
    (declare-const ?apcx Real)
    (declare-const ?apcy Real)
    (declare-const ?apcz Real)
    (declare-const ?apda Real)
    (assert
      (or (or (= ?apda ?apcz)
          (= ?apda ?apcy)
          )
        (= ?apcz ?apcy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apdb Real)
    (declare-const ?apdc Real)
    (declare-const ?apdd Real)
    (declare-const ?apde Real)
    (declare-const ?apdf Real)
    (declare-const ?apdg Real)
    (assert
      (and (and (and (not (= ?apdd ?apdc))
            (not (= ?apdd ?apdb))
            )
          (not (= ?apdc ?apdb))
          )
        (or (or (= ?apdg ?apdf)
            (= ?apdg ?apde)
            )
          (= ?apdf ?apde)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apdh Real)
    (declare-const ?apdi Real)
    (declare-const ?apdj Real)
    (assert
      (or (or (= ?apdj ?apdi)
          (= ?apdj ?apdh)
          )
        (= ?apdi ?apdh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apdk Real)
    (declare-const ?apdl Real)
    (declare-const ?apdm Real)
    (assert
      (or (or (= ?apdm ?apdl)
          (= ?apdm ?apdk)
          )
        (= ?apdl ?apdk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apdn Real)
    (declare-const ?apdo Real)
    (declare-const ?apdp Real)
    (declare-const ?apdq Real)
    (assert
      (or (or (= ?apdp ?apdo)
          (= ?apdp ?apdn)
          )
        (= ?apdo ?apdn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apdr Real)
    (declare-const ?apds Real)
    (declare-const ?apdt Real)
    (declare-const ?apdu Real)
    (declare-const ?apdv Real)
    (assert
      (or (or (= ?apdt ?apds)
          (= ?apdt ?apdr)
          )
        (= ?apds ?apdr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apdw Real)
    (declare-const ?apdx Real)
    (declare-const ?apdy Real)
    (declare-const ?apdz Real)
    (declare-const ?apea Real)
    (declare-const ?apeb Real)
    (assert
      (and (or (or (= ?apdy ?apdx)
            (= ?apdy ?apdw)
            )
          (= ?apdx ?apdw)
          )
        (and (and (not (= ?apeb ?apea))
            (not (= ?apeb ?apdz))
            )
          (not (= ?apea ?apdz))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apec Real)
    (declare-const ?aped Real)
    (declare-const ?apee Real)
    (assert
      (or (or (= ?apee ?aped)
          (= ?apee ?apec)
          )
        (= ?aped ?apec)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apef Real)
    (declare-const ?apeg Real)
    (declare-const ?apeh Real)
    (declare-const ?apei Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?apeg ?apef))
                (not (= ?apeg ?asi))
                )
              (not (= ?apef ?asi))
              )
            (or (or (= ?apei ?apeh)
                (= ?apei ?asi)
                )
              (= ?apeh ?asi)
              )
            )
          (and (or (or (= ?apeg ?apef)
                (= ?apeg ?asi)
                )
              (= ?apef ?asi)
              )
            (and (and (not (= ?apei ?apeh))
                (not (= ?apei ?asi))
                )
              (not (= ?apeh ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apej Real)
    (declare-const ?apek Real)
    (declare-const ?apel Real)
    (declare-const ?apem Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?apek ?apej))
                (not (= ?apek ?fkf))
                )
              (not (= ?apej ?fkf))
              )
            (or (or (= ?apem ?apel)
                (= ?apem ?fkf)
                )
              (= ?apel ?fkf)
              )
            )
          (and (or (or (= ?apek ?apej)
                (= ?apek ?fkf)
                )
              (= ?apej ?fkf)
              )
            (and (and (not (= ?apem ?apel))
                (not (= ?apem ?fkf))
                )
              (not (= ?apel ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apen Real)
    (declare-const ?apeo Real)
    (declare-const ?apep Real)
    (declare-const ?apeq Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?apeo ?apen))
                (not (= ?apeo ?mzs))
                )
              (not (= ?apen ?mzs))
              )
            (or (or (= ?apeq ?apep)
                (= ?apeq ?mzs)
                )
              (= ?apep ?mzs)
              )
            )
          (and (or (or (= ?apeo ?apen)
                (= ?apeo ?mzs)
                )
              (= ?apen ?mzs)
              )
            (and (and (not (= ?apeq ?apep))
                (not (= ?apeq ?mzs))
                )
              (not (= ?apep ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aper Real)
    (declare-const ?apes Real)
    (declare-const ?apet Real)
    (declare-const ?apeu Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?apes ?aper))
                (not (= ?apes ?zpl))
                )
              (not (= ?aper ?zpl))
              )
            (or (or (= ?apeu ?apet)
                (= ?apeu ?zpl)
                )
              (= ?apet ?zpl)
              )
            )
          (and (or (or (= ?apes ?aper)
                (= ?apes ?zpl)
                )
              (= ?aper ?zpl)
              )
            (and (and (not (= ?apeu ?apet))
                (not (= ?apeu ?zpl))
                )
              (not (= ?apet ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?apev Real)
  (declare-const ?apew Real)
  (push 1)
    (declare-const ?apex Real)
    (declare-const ?apey Real)
    (declare-const ?apez Real)
    (assert
      (or (or (= ?apez ?apey)
          (= ?apez ?apex)
          )
        (= ?apey ?apex)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apfa Real)
    (declare-const ?apfb Real)
    (declare-const ?apfc Real)
    (declare-const ?apfd Real)
    (assert
      (or (or (= ?apfd ?apfc)
          (= ?apfd ?apfb)
          )
        (= ?apfc ?apfb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apfe Real)
    (declare-const ?apff Real)
    (declare-const ?apfg Real)
    (declare-const ?apfh Real)
    (declare-const ?apfi Real)
    (assert
      (or (or (= ?apfi ?apfh)
          (= ?apfi ?apfg)
          )
        (= ?apfh ?apfg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apfj Real)
    (declare-const ?apfk Real)
    (declare-const ?apfl Real)
    (declare-const ?apfm Real)
    (declare-const ?apfn Real)
    (declare-const ?apfo Real)
    (assert
      (and (and (and (not (= ?apfl ?apfk))
            (not (= ?apfl ?apfj))
            )
          (not (= ?apfk ?apfj))
          )
        (or (or (= ?apfo ?apfn)
            (= ?apfo ?apfm)
            )
          (= ?apfn ?apfm)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apfp Real)
    (declare-const ?apfq Real)
    (declare-const ?apfr Real)
    (assert
      (or (or (= ?apfr ?apfq)
          (= ?apfr ?apfp)
          )
        (= ?apfq ?apfp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apfs Real)
    (declare-const ?apft Real)
    (declare-const ?apfu Real)
    (assert
      (or (or (= ?apfu ?apft)
          (= ?apfu ?apfs)
          )
        (= ?apft ?apfs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apfv Real)
    (declare-const ?apfw Real)
    (declare-const ?apfx Real)
    (declare-const ?apfy Real)
    (assert
      (or (or (= ?apfx ?apfw)
          (= ?apfx ?apfv)
          )
        (= ?apfw ?apfv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apfz Real)
    (declare-const ?apga Real)
    (declare-const ?apgb Real)
    (declare-const ?apgc Real)
    (declare-const ?apgd Real)
    (assert
      (or (or (= ?apgb ?apga)
          (= ?apgb ?apfz)
          )
        (= ?apga ?apfz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apge Real)
    (declare-const ?apgf Real)
    (declare-const ?apgg Real)
    (declare-const ?apgh Real)
    (declare-const ?apgi Real)
    (declare-const ?apgj Real)
    (assert
      (and (or (or (= ?apgg ?apgf)
            (= ?apgg ?apge)
            )
          (= ?apgf ?apge)
          )
        (and (and (not (= ?apgj ?apgi))
            (not (= ?apgj ?apgh))
            )
          (not (= ?apgi ?apgh))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apgk Real)
    (declare-const ?apgl Real)
    (declare-const ?apgm Real)
    (assert
      (or (or (= ?apgm ?apgl)
          (= ?apgm ?apgk)
          )
        (= ?apgl ?apgk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apgn Real)
    (declare-const ?apgo Real)
    (declare-const ?apgp Real)
    (declare-const ?apgq Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?apgo ?apgn))
                (not (= ?apgo ?asi))
                )
              (not (= ?apgn ?asi))
              )
            (or (or (= ?apgq ?apgp)
                (= ?apgq ?asi)
                )
              (= ?apgp ?asi)
              )
            )
          (and (or (or (= ?apgo ?apgn)
                (= ?apgo ?asi)
                )
              (= ?apgn ?asi)
              )
            (and (and (not (= ?apgq ?apgp))
                (not (= ?apgq ?asi))
                )
              (not (= ?apgp ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apgr Real)
    (declare-const ?apgs Real)
    (declare-const ?apgt Real)
    (declare-const ?apgu Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?apgs ?apgr))
                (not (= ?apgs ?fkf))
                )
              (not (= ?apgr ?fkf))
              )
            (or (or (= ?apgu ?apgt)
                (= ?apgu ?fkf)
                )
              (= ?apgt ?fkf)
              )
            )
          (and (or (or (= ?apgs ?apgr)
                (= ?apgs ?fkf)
                )
              (= ?apgr ?fkf)
              )
            (and (and (not (= ?apgu ?apgt))
                (not (= ?apgu ?fkf))
                )
              (not (= ?apgt ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apgv Real)
    (declare-const ?apgw Real)
    (declare-const ?apgx Real)
    (declare-const ?apgy Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?apgw ?apgv))
                (not (= ?apgw ?mzs))
                )
              (not (= ?apgv ?mzs))
              )
            (or (or (= ?apgy ?apgx)
                (= ?apgy ?mzs)
                )
              (= ?apgx ?mzs)
              )
            )
          (and (or (or (= ?apgw ?apgv)
                (= ?apgw ?mzs)
                )
              (= ?apgv ?mzs)
              )
            (and (and (not (= ?apgy ?apgx))
                (not (= ?apgy ?mzs))
                )
              (not (= ?apgx ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apgz Real)
    (declare-const ?apha Real)
    (declare-const ?aphb Real)
    (declare-const ?aphc Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?apha ?apgz))
                (not (= ?apha ?zpl))
                )
              (not (= ?apgz ?zpl))
              )
            (or (or (= ?aphc ?aphb)
                (= ?aphc ?zpl)
                )
              (= ?aphb ?zpl)
              )
            )
          (and (or (or (= ?apha ?apgz)
                (= ?apha ?zpl)
                )
              (= ?apgz ?zpl)
              )
            (and (and (not (= ?aphc ?aphb))
                (not (= ?aphc ?zpl))
                )
              (not (= ?aphb ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aphd Real)
  (declare-const ?aphe Real)
  (declare-const ?aphf Real)
  (push 1)
    (declare-const ?aphg Real)
    (declare-const ?aphh Real)
    (declare-const ?aphi Real)
    (assert
      (or (or (= ?aphi ?aphh)
          (= ?aphi ?aphg)
          )
        (= ?aphh ?aphg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aphj Real)
    (declare-const ?aphk Real)
    (declare-const ?aphl Real)
    (declare-const ?aphm Real)
    (assert
      (or (or (= ?aphm ?aphl)
          (= ?aphm ?aphk)
          )
        (= ?aphl ?aphk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aphn Real)
    (declare-const ?apho Real)
    (declare-const ?aphp Real)
    (declare-const ?aphq Real)
    (declare-const ?aphr Real)
    (assert
      (or (or (= ?aphr ?aphq)
          (= ?aphr ?aphp)
          )
        (= ?aphq ?aphp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aphs Real)
    (declare-const ?apht Real)
    (declare-const ?aphu Real)
    (declare-const ?aphv Real)
    (declare-const ?aphw Real)
    (declare-const ?aphx Real)
    (assert
      (and (and (and (not (= ?aphu ?apht))
            (not (= ?aphu ?aphs))
            )
          (not (= ?apht ?aphs))
          )
        (or (or (= ?aphx ?aphw)
            (= ?aphx ?aphv)
            )
          (= ?aphw ?aphv)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aphy Real)
    (declare-const ?aphz Real)
    (declare-const ?apia Real)
    (assert
      (or (or (= ?apia ?aphz)
          (= ?apia ?aphy)
          )
        (= ?aphz ?aphy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apib Real)
    (declare-const ?apic Real)
    (declare-const ?apid Real)
    (assert
      (or (or (= ?apid ?apic)
          (= ?apid ?apib)
          )
        (= ?apic ?apib)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apie Real)
    (declare-const ?apif Real)
    (declare-const ?apig Real)
    (declare-const ?apih Real)
    (assert
      (or (or (= ?apig ?apif)
          (= ?apig ?apie)
          )
        (= ?apif ?apie)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apii Real)
    (declare-const ?apij Real)
    (declare-const ?apik Real)
    (declare-const ?apil Real)
    (declare-const ?apim Real)
    (assert
      (or (or (= ?apik ?apij)
          (= ?apik ?apii)
          )
        (= ?apij ?apii)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apin Real)
    (declare-const ?apio Real)
    (declare-const ?apip Real)
    (declare-const ?apiq Real)
    (declare-const ?apir Real)
    (declare-const ?apis Real)
    (assert
      (and (or (or (= ?apip ?apio)
            (= ?apip ?apin)
            )
          (= ?apio ?apin)
          )
        (and (and (not (= ?apis ?apir))
            (not (= ?apis ?apiq))
            )
          (not (= ?apir ?apiq))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apit Real)
    (declare-const ?apiu Real)
    (declare-const ?apiv Real)
    (assert
      (or (or (= ?apiv ?apiu)
          (= ?apiv ?apit)
          )
        (= ?apiu ?apit)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apiw Real)
    (declare-const ?apix Real)
    (declare-const ?apiy Real)
    (declare-const ?apiz Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?apix ?apiw))
                (not (= ?apix ?asi))
                )
              (not (= ?apiw ?asi))
              )
            (or (or (= ?apiz ?apiy)
                (= ?apiz ?asi)
                )
              (= ?apiy ?asi)
              )
            )
          (and (or (or (= ?apix ?apiw)
                (= ?apix ?asi)
                )
              (= ?apiw ?asi)
              )
            (and (and (not (= ?apiz ?apiy))
                (not (= ?apiz ?asi))
                )
              (not (= ?apiy ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apja Real)
    (declare-const ?apjb Real)
    (declare-const ?apjc Real)
    (declare-const ?apjd Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?apjb ?apja))
                (not (= ?apjb ?fkf))
                )
              (not (= ?apja ?fkf))
              )
            (or (or (= ?apjd ?apjc)
                (= ?apjd ?fkf)
                )
              (= ?apjc ?fkf)
              )
            )
          (and (or (or (= ?apjb ?apja)
                (= ?apjb ?fkf)
                )
              (= ?apja ?fkf)
              )
            (and (and (not (= ?apjd ?apjc))
                (not (= ?apjd ?fkf))
                )
              (not (= ?apjc ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apje Real)
    (declare-const ?apjf Real)
    (declare-const ?apjg Real)
    (declare-const ?apjh Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?apjf ?apje))
                (not (= ?apjf ?mzs))
                )
              (not (= ?apje ?mzs))
              )
            (or (or (= ?apjh ?apjg)
                (= ?apjh ?mzs)
                )
              (= ?apjg ?mzs)
              )
            )
          (and (or (or (= ?apjf ?apje)
                (= ?apjf ?mzs)
                )
              (= ?apje ?mzs)
              )
            (and (and (not (= ?apjh ?apjg))
                (not (= ?apjh ?mzs))
                )
              (not (= ?apjg ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apji Real)
    (declare-const ?apjj Real)
    (declare-const ?apjk Real)
    (declare-const ?apjl Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?apjj ?apji))
                (not (= ?apjj ?zpl))
                )
              (not (= ?apji ?zpl))
              )
            (or (or (= ?apjl ?apjk)
                (= ?apjl ?zpl)
                )
              (= ?apjk ?zpl)
              )
            )
          (and (or (or (= ?apjj ?apji)
                (= ?apjj ?zpl)
                )
              (= ?apji ?zpl)
              )
            (and (and (not (= ?apjl ?apjk))
                (not (= ?apjl ?zpl))
                )
              (not (= ?apjk ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?apjm Real)
    (declare-const ?apjn Real)
    (declare-const ?apjo Real)
    (assert
      (or (or (= ?apjo ?apjn)
          (= ?apjo ?apjm)
          )
        (= ?apjn ?apjm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apjp Real)
    (declare-const ?apjq Real)
    (declare-const ?apjr Real)
    (declare-const ?apjs Real)
    (assert
      (or (or (= ?apjs ?apjr)
          (= ?apjs ?apjq)
          )
        (= ?apjr ?apjq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apjt Real)
    (declare-const ?apju Real)
    (declare-const ?apjv Real)
    (declare-const ?apjw Real)
    (declare-const ?apjx Real)
    (assert
      (or (or (= ?apjx ?apjw)
          (= ?apjx ?apjv)
          )
        (= ?apjw ?apjv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apjy Real)
    (declare-const ?apjz Real)
    (declare-const ?apka Real)
    (declare-const ?apkb Real)
    (declare-const ?apkc Real)
    (declare-const ?apkd Real)
    (assert
      (and (and (and (not (= ?apka ?apjz))
            (not (= ?apka ?apjy))
            )
          (not (= ?apjz ?apjy))
          )
        (or (or (= ?apkd ?apkc)
            (= ?apkd ?apkb)
            )
          (= ?apkc ?apkb)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apke Real)
    (declare-const ?apkf Real)
    (declare-const ?apkg Real)
    (assert
      (or (or (= ?apkg ?apkf)
          (= ?apkg ?apke)
          )
        (= ?apkf ?apke)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apkh Real)
    (declare-const ?apki Real)
    (declare-const ?apkj Real)
    (assert
      (or (or (= ?apkj ?apki)
          (= ?apkj ?apkh)
          )
        (= ?apki ?apkh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apkk Real)
    (declare-const ?apkl Real)
    (declare-const ?apkm Real)
    (declare-const ?apkn Real)
    (assert
      (or (or (= ?apkm ?apkl)
          (= ?apkm ?apkk)
          )
        (= ?apkl ?apkk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apko Real)
    (declare-const ?apkp Real)
    (declare-const ?apkq Real)
    (declare-const ?apkr Real)
    (declare-const ?apks Real)
    (assert
      (or (or (= ?apkq ?apkp)
          (= ?apkq ?apko)
          )
        (= ?apkp ?apko)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apkt Real)
    (declare-const ?apku Real)
    (declare-const ?apkv Real)
    (declare-const ?apkw Real)
    (declare-const ?apkx Real)
    (declare-const ?apky Real)
    (assert
      (and (or (or (= ?apkv ?apku)
            (= ?apkv ?apkt)
            )
          (= ?apku ?apkt)
          )
        (and (and (not (= ?apky ?apkx))
            (not (= ?apky ?apkw))
            )
          (not (= ?apkx ?apkw))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apkz Real)
    (declare-const ?apla Real)
    (declare-const ?aplb Real)
    (assert
      (or (or (= ?aplb ?apla)
          (= ?aplb ?apkz)
          )
        (= ?apla ?apkz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aplc Real)
    (declare-const ?apld Real)
    (declare-const ?aple Real)
    (declare-const ?aplf Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?apld ?aplc))
                (not (= ?apld ?asi))
                )
              (not (= ?aplc ?asi))
              )
            (or (or (= ?aplf ?aple)
                (= ?aplf ?asi)
                )
              (= ?aple ?asi)
              )
            )
          (and (or (or (= ?apld ?aplc)
                (= ?apld ?asi)
                )
              (= ?aplc ?asi)
              )
            (and (and (not (= ?aplf ?aple))
                (not (= ?aplf ?asi))
                )
              (not (= ?aple ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aplg Real)
    (declare-const ?aplh Real)
    (declare-const ?apli Real)
    (declare-const ?aplj Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aplh ?aplg))
                (not (= ?aplh ?fkf))
                )
              (not (= ?aplg ?fkf))
              )
            (or (or (= ?aplj ?apli)
                (= ?aplj ?fkf)
                )
              (= ?apli ?fkf)
              )
            )
          (and (or (or (= ?aplh ?aplg)
                (= ?aplh ?fkf)
                )
              (= ?aplg ?fkf)
              )
            (and (and (not (= ?aplj ?apli))
                (not (= ?aplj ?fkf))
                )
              (not (= ?apli ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aplk Real)
    (declare-const ?apll Real)
    (declare-const ?aplm Real)
    (declare-const ?apln Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?apll ?aplk))
                (not (= ?apll ?mzs))
                )
              (not (= ?aplk ?mzs))
              )
            (or (or (= ?apln ?aplm)
                (= ?apln ?mzs)
                )
              (= ?aplm ?mzs)
              )
            )
          (and (or (or (= ?apll ?aplk)
                (= ?apll ?mzs)
                )
              (= ?aplk ?mzs)
              )
            (and (and (not (= ?apln ?aplm))
                (not (= ?apln ?mzs))
                )
              (not (= ?aplm ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aplo Real)
    (declare-const ?aplp Real)
    (declare-const ?aplq Real)
    (declare-const ?aplr Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?aplp ?aplo))
                (not (= ?aplp ?zpl))
                )
              (not (= ?aplo ?zpl))
              )
            (or (or (= ?aplr ?aplq)
                (= ?aplr ?zpl)
                )
              (= ?aplq ?zpl)
              )
            )
          (and (or (or (= ?aplp ?aplo)
                (= ?aplp ?zpl)
                )
              (= ?aplo ?zpl)
              )
            (and (and (not (= ?aplr ?aplq))
                (not (= ?aplr ?zpl))
                )
              (not (= ?aplq ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?apls Real)
  (push 1)
    (declare-const ?aplt Real)
    (declare-const ?aplu Real)
    (declare-const ?aplv Real)
    (assert
      (or (or (= ?aplv ?aplu)
          (= ?aplv ?aplt)
          )
        (= ?aplu ?aplt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aplw Real)
    (declare-const ?aplx Real)
    (declare-const ?aply Real)
    (declare-const ?aplz Real)
    (assert
      (or (or (= ?aplz ?aply)
          (= ?aplz ?aplx)
          )
        (= ?aply ?aplx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apma Real)
    (declare-const ?apmb Real)
    (declare-const ?apmc Real)
    (declare-const ?apmd Real)
    (declare-const ?apme Real)
    (assert
      (or (or (= ?apme ?apmd)
          (= ?apme ?apmc)
          )
        (= ?apmd ?apmc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apmf Real)
    (declare-const ?apmg Real)
    (declare-const ?apmh Real)
    (declare-const ?apmi Real)
    (declare-const ?apmj Real)
    (declare-const ?apmk Real)
    (assert
      (and (and (and (not (= ?apmh ?apmg))
            (not (= ?apmh ?apmf))
            )
          (not (= ?apmg ?apmf))
          )
        (or (or (= ?apmk ?apmj)
            (= ?apmk ?apmi)
            )
          (= ?apmj ?apmi)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apml Real)
    (declare-const ?apmm Real)
    (declare-const ?apmn Real)
    (assert
      (or (or (= ?apmn ?apmm)
          (= ?apmn ?apml)
          )
        (= ?apmm ?apml)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apmo Real)
    (declare-const ?apmp Real)
    (declare-const ?apmq Real)
    (assert
      (or (or (= ?apmq ?apmp)
          (= ?apmq ?apmo)
          )
        (= ?apmp ?apmo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apmr Real)
    (declare-const ?apms Real)
    (declare-const ?apmt Real)
    (declare-const ?apmu Real)
    (assert
      (or (or (= ?apmt ?apms)
          (= ?apmt ?apmr)
          )
        (= ?apms ?apmr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apmv Real)
    (declare-const ?apmw Real)
    (declare-const ?apmx Real)
    (declare-const ?apmy Real)
    (declare-const ?apmz Real)
    (assert
      (or (or (= ?apmx ?apmw)
          (= ?apmx ?apmv)
          )
        (= ?apmw ?apmv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apna Real)
    (declare-const ?apnb Real)
    (declare-const ?apnc Real)
    (declare-const ?apnd Real)
    (declare-const ?apne Real)
    (declare-const ?apnf Real)
    (assert
      (and (or (or (= ?apnc ?apnb)
            (= ?apnc ?apna)
            )
          (= ?apnb ?apna)
          )
        (and (and (not (= ?apnf ?apne))
            (not (= ?apnf ?apnd))
            )
          (not (= ?apne ?apnd))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apng Real)
    (declare-const ?apnh Real)
    (declare-const ?apni Real)
    (assert
      (or (or (= ?apni ?apnh)
          (= ?apni ?apng)
          )
        (= ?apnh ?apng)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apnj Real)
    (declare-const ?apnk Real)
    (declare-const ?apnl Real)
    (declare-const ?apnm Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?apnk ?apnj))
                (not (= ?apnk ?asi))
                )
              (not (= ?apnj ?asi))
              )
            (or (or (= ?apnm ?apnl)
                (= ?apnm ?asi)
                )
              (= ?apnl ?asi)
              )
            )
          (and (or (or (= ?apnk ?apnj)
                (= ?apnk ?asi)
                )
              (= ?apnj ?asi)
              )
            (and (and (not (= ?apnm ?apnl))
                (not (= ?apnm ?asi))
                )
              (not (= ?apnl ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apnn Real)
    (declare-const ?apno Real)
    (declare-const ?apnp Real)
    (declare-const ?apnq Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?apno ?apnn))
                (not (= ?apno ?fkf))
                )
              (not (= ?apnn ?fkf))
              )
            (or (or (= ?apnq ?apnp)
                (= ?apnq ?fkf)
                )
              (= ?apnp ?fkf)
              )
            )
          (and (or (or (= ?apno ?apnn)
                (= ?apno ?fkf)
                )
              (= ?apnn ?fkf)
              )
            (and (and (not (= ?apnq ?apnp))
                (not (= ?apnq ?fkf))
                )
              (not (= ?apnp ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apnr Real)
    (declare-const ?apns Real)
    (declare-const ?apnt Real)
    (declare-const ?apnu Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?apns ?apnr))
                (not (= ?apns ?mzs))
                )
              (not (= ?apnr ?mzs))
              )
            (or (or (= ?apnu ?apnt)
                (= ?apnu ?mzs)
                )
              (= ?apnt ?mzs)
              )
            )
          (and (or (or (= ?apns ?apnr)
                (= ?apns ?mzs)
                )
              (= ?apnr ?mzs)
              )
            (and (and (not (= ?apnu ?apnt))
                (not (= ?apnu ?mzs))
                )
              (not (= ?apnt ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apnv Real)
    (declare-const ?apnw Real)
    (declare-const ?apnx Real)
    (declare-const ?apny Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?apnw ?apnv))
                (not (= ?apnw ?zpl))
                )
              (not (= ?apnv ?zpl))
              )
            (or (or (= ?apny ?apnx)
                (= ?apny ?zpl)
                )
              (= ?apnx ?zpl)
              )
            )
          (and (or (or (= ?apnw ?apnv)
                (= ?apnw ?zpl)
                )
              (= ?apnv ?zpl)
              )
            (and (and (not (= ?apny ?apnx))
                (not (= ?apny ?zpl))
                )
              (not (= ?apnx ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?apnz Real)
  (declare-const ?apoa Real)
  (assert
    (not (= ?apnz ?apoa))
    )
  (push 1)
    (declare-const ?apob Real)
    (declare-const ?apoc Real)
    (declare-const ?apod Real)
    (assert
      (or (or (= ?apod ?apoc)
          (= ?apod ?apob)
          )
        (= ?apoc ?apob)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apoe Real)
    (declare-const ?apof Real)
    (declare-const ?apog Real)
    (declare-const ?apoh Real)
    (assert
      (or (or (= ?apoh ?apog)
          (= ?apoh ?apof)
          )
        (= ?apog ?apof)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apoi Real)
    (declare-const ?apoj Real)
    (declare-const ?apok Real)
    (declare-const ?apol Real)
    (declare-const ?apom Real)
    (assert
      (or (or (= ?apom ?apol)
          (= ?apom ?apok)
          )
        (= ?apol ?apok)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apon Real)
    (declare-const ?apoo Real)
    (declare-const ?apop Real)
    (declare-const ?apoq Real)
    (declare-const ?apor Real)
    (declare-const ?apos Real)
    (assert
      (and (and (and (not (= ?apop ?apoo))
            (not (= ?apop ?apon))
            )
          (not (= ?apoo ?apon))
          )
        (or (or (= ?apos ?apor)
            (= ?apos ?apoq)
            )
          (= ?apor ?apoq)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apot Real)
    (declare-const ?apou Real)
    (declare-const ?apov Real)
    (assert
      (or (or (= ?apov ?apou)
          (= ?apov ?apot)
          )
        (= ?apou ?apot)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apow Real)
    (declare-const ?apox Real)
    (declare-const ?apoy Real)
    (assert
      (or (or (= ?apoy ?apox)
          (= ?apoy ?apow)
          )
        (= ?apox ?apow)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apoz Real)
    (declare-const ?appa Real)
    (declare-const ?appb Real)
    (declare-const ?appc Real)
    (assert
      (or (or (= ?appb ?appa)
          (= ?appb ?apoz)
          )
        (= ?appa ?apoz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?appd Real)
    (declare-const ?appe Real)
    (declare-const ?appf Real)
    (declare-const ?appg Real)
    (declare-const ?apph Real)
    (assert
      (or (or (= ?appf ?appe)
          (= ?appf ?appd)
          )
        (= ?appe ?appd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?appi Real)
    (declare-const ?appj Real)
    (declare-const ?appk Real)
    (declare-const ?appl Real)
    (declare-const ?appm Real)
    (declare-const ?appn Real)
    (assert
      (and (or (or (= ?appk ?appj)
            (= ?appk ?appi)
            )
          (= ?appj ?appi)
          )
        (and (and (not (= ?appn ?appm))
            (not (= ?appn ?appl))
            )
          (not (= ?appm ?appl))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?appo Real)
    (declare-const ?appp Real)
    (declare-const ?appq Real)
    (assert
      (or (or (= ?appq ?appp)
          (= ?appq ?appo)
          )
        (= ?appp ?appo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?appr Real)
    (declare-const ?apps Real)
    (declare-const ?appt Real)
    (declare-const ?appu Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?apps ?appr))
                (not (= ?apps ?asi))
                )
              (not (= ?appr ?asi))
              )
            (or (or (= ?appu ?appt)
                (= ?appu ?asi)
                )
              (= ?appt ?asi)
              )
            )
          (and (or (or (= ?apps ?appr)
                (= ?apps ?asi)
                )
              (= ?appr ?asi)
              )
            (and (and (not (= ?appu ?appt))
                (not (= ?appu ?asi))
                )
              (not (= ?appt ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?appv Real)
    (declare-const ?appw Real)
    (declare-const ?appx Real)
    (declare-const ?appy Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?appw ?appv))
                (not (= ?appw ?fkf))
                )
              (not (= ?appv ?fkf))
              )
            (or (or (= ?appy ?appx)
                (= ?appy ?fkf)
                )
              (= ?appx ?fkf)
              )
            )
          (and (or (or (= ?appw ?appv)
                (= ?appw ?fkf)
                )
              (= ?appv ?fkf)
              )
            (and (and (not (= ?appy ?appx))
                (not (= ?appy ?fkf))
                )
              (not (= ?appx ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?appz Real)
    (declare-const ?apqa Real)
    (declare-const ?apqb Real)
    (declare-const ?apqc Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?apqa ?appz))
                (not (= ?apqa ?mzs))
                )
              (not (= ?appz ?mzs))
              )
            (or (or (= ?apqc ?apqb)
                (= ?apqc ?mzs)
                )
              (= ?apqb ?mzs)
              )
            )
          (and (or (or (= ?apqa ?appz)
                (= ?apqa ?mzs)
                )
              (= ?appz ?mzs)
              )
            (and (and (not (= ?apqc ?apqb))
                (not (= ?apqc ?mzs))
                )
              (not (= ?apqb ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apqd Real)
    (declare-const ?apqe Real)
    (declare-const ?apqf Real)
    (declare-const ?apqg Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?apqe ?apqd))
                (not (= ?apqe ?zpl))
                )
              (not (= ?apqd ?zpl))
              )
            (or (or (= ?apqg ?apqf)
                (= ?apqg ?zpl)
                )
              (= ?apqf ?zpl)
              )
            )
          (and (or (or (= ?apqe ?apqd)
                (= ?apqe ?zpl)
                )
              (= ?apqd ?zpl)
              )
            (and (and (not (= ?apqg ?apqf))
                (not (= ?apqg ?zpl))
                )
              (not (= ?apqf ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?apqh Real)
  (declare-const ?apqi Real)
  (declare-const ?apqj Real)
  (push 1)
    (declare-const ?apqk Real)
    (declare-const ?apql Real)
    (declare-const ?apqm Real)
    (assert
      (or (or (= ?apqm ?apql)
          (= ?apqm ?apqk)
          )
        (= ?apql ?apqk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apqn Real)
    (declare-const ?apqo Real)
    (declare-const ?apqp Real)
    (declare-const ?apqq Real)
    (assert
      (or (or (= ?apqq ?apqp)
          (= ?apqq ?apqo)
          )
        (= ?apqp ?apqo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apqr Real)
    (declare-const ?apqs Real)
    (declare-const ?apqt Real)
    (declare-const ?apqu Real)
    (declare-const ?apqv Real)
    (assert
      (or (or (= ?apqv ?apqu)
          (= ?apqv ?apqt)
          )
        (= ?apqu ?apqt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apqw Real)
    (declare-const ?apqx Real)
    (declare-const ?apqy Real)
    (declare-const ?apqz Real)
    (declare-const ?apra Real)
    (declare-const ?aprb Real)
    (assert
      (and (and (and (not (= ?apqy ?apqx))
            (not (= ?apqy ?apqw))
            )
          (not (= ?apqx ?apqw))
          )
        (or (or (= ?aprb ?apra)
            (= ?aprb ?apqz)
            )
          (= ?apra ?apqz)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aprc Real)
    (declare-const ?aprd Real)
    (declare-const ?apre Real)
    (assert
      (or (or (= ?apre ?aprd)
          (= ?apre ?aprc)
          )
        (= ?aprd ?aprc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aprf Real)
    (declare-const ?aprg Real)
    (declare-const ?aprh Real)
    (assert
      (or (or (= ?aprh ?aprg)
          (= ?aprh ?aprf)
          )
        (= ?aprg ?aprf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apri Real)
    (declare-const ?aprj Real)
    (declare-const ?aprk Real)
    (declare-const ?aprl Real)
    (assert
      (or (or (= ?aprk ?aprj)
          (= ?aprk ?apri)
          )
        (= ?aprj ?apri)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aprm Real)
    (declare-const ?aprn Real)
    (declare-const ?apro Real)
    (declare-const ?aprp Real)
    (declare-const ?aprq Real)
    (assert
      (or (or (= ?apro ?aprn)
          (= ?apro ?aprm)
          )
        (= ?aprn ?aprm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aprr Real)
    (declare-const ?aprs Real)
    (declare-const ?aprt Real)
    (declare-const ?apru Real)
    (declare-const ?aprv Real)
    (declare-const ?aprw Real)
    (assert
      (and (or (or (= ?aprt ?aprs)
            (= ?aprt ?aprr)
            )
          (= ?aprs ?aprr)
          )
        (and (and (not (= ?aprw ?aprv))
            (not (= ?aprw ?apru))
            )
          (not (= ?aprv ?apru))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aprx Real)
    (declare-const ?apry Real)
    (declare-const ?aprz Real)
    (assert
      (or (or (= ?aprz ?apry)
          (= ?aprz ?aprx)
          )
        (= ?apry ?aprx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apsa Real)
    (declare-const ?apsb Real)
    (declare-const ?apsc Real)
    (declare-const ?apsd Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?apsb ?apsa))
                (not (= ?apsb ?asi))
                )
              (not (= ?apsa ?asi))
              )
            (or (or (= ?apsd ?apsc)
                (= ?apsd ?asi)
                )
              (= ?apsc ?asi)
              )
            )
          (and (or (or (= ?apsb ?apsa)
                (= ?apsb ?asi)
                )
              (= ?apsa ?asi)
              )
            (and (and (not (= ?apsd ?apsc))
                (not (= ?apsd ?asi))
                )
              (not (= ?apsc ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apse Real)
    (declare-const ?apsf Real)
    (declare-const ?apsg Real)
    (declare-const ?apsh Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?apsf ?apse))
                (not (= ?apsf ?fkf))
                )
              (not (= ?apse ?fkf))
              )
            (or (or (= ?apsh ?apsg)
                (= ?apsh ?fkf)
                )
              (= ?apsg ?fkf)
              )
            )
          (and (or (or (= ?apsf ?apse)
                (= ?apsf ?fkf)
                )
              (= ?apse ?fkf)
              )
            (and (and (not (= ?apsh ?apsg))
                (not (= ?apsh ?fkf))
                )
              (not (= ?apsg ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apsi Real)
    (declare-const ?apsj Real)
    (declare-const ?apsk Real)
    (declare-const ?apsl Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?apsj ?apsi))
                (not (= ?apsj ?mzs))
                )
              (not (= ?apsi ?mzs))
              )
            (or (or (= ?apsl ?apsk)
                (= ?apsl ?mzs)
                )
              (= ?apsk ?mzs)
              )
            )
          (and (or (or (= ?apsj ?apsi)
                (= ?apsj ?mzs)
                )
              (= ?apsi ?mzs)
              )
            (and (and (not (= ?apsl ?apsk))
                (not (= ?apsl ?mzs))
                )
              (not (= ?apsk ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apsm Real)
    (declare-const ?apsn Real)
    (declare-const ?apso Real)
    (declare-const ?apsp Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?apsn ?apsm))
                (not (= ?apsn ?zpl))
                )
              (not (= ?apsm ?zpl))
              )
            (or (or (= ?apsp ?apso)
                (= ?apsp ?zpl)
                )
              (= ?apso ?zpl)
              )
            )
          (and (or (or (= ?apsn ?apsm)
                (= ?apsn ?zpl)
                )
              (= ?apsm ?zpl)
              )
            (and (and (not (= ?apsp ?apso))
                (not (= ?apsp ?zpl))
                )
              (not (= ?apso ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?apsq Real)
  (declare-const ?apsr Real)
  (declare-const ?apss Real)
  (declare-const ?apst Real)
  (push 1)
    (declare-const ?apsu Real)
    (declare-const ?apsv Real)
    (declare-const ?apsw Real)
    (assert
      (or (or (= ?apsw ?apsv)
          (= ?apsw ?apsu)
          )
        (= ?apsv ?apsu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apsx Real)
    (declare-const ?apsy Real)
    (declare-const ?apsz Real)
    (declare-const ?apta Real)
    (assert
      (or (or (= ?apta ?apsz)
          (= ?apta ?apsy)
          )
        (= ?apsz ?apsy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aptb Real)
    (declare-const ?aptc Real)
    (declare-const ?aptd Real)
    (declare-const ?apte Real)
    (declare-const ?aptf Real)
    (assert
      (or (or (= ?aptf ?apte)
          (= ?aptf ?aptd)
          )
        (= ?apte ?aptd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aptg Real)
    (declare-const ?apth Real)
    (declare-const ?apti Real)
    (declare-const ?aptj Real)
    (declare-const ?aptk Real)
    (declare-const ?aptl Real)
    (assert
      (and (and (and (not (= ?apti ?apth))
            (not (= ?apti ?aptg))
            )
          (not (= ?apth ?aptg))
          )
        (or (or (= ?aptl ?aptk)
            (= ?aptl ?aptj)
            )
          (= ?aptk ?aptj)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aptm Real)
    (declare-const ?aptn Real)
    (declare-const ?apto Real)
    (assert
      (or (or (= ?apto ?aptn)
          (= ?apto ?aptm)
          )
        (= ?aptn ?aptm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aptp Real)
    (declare-const ?aptq Real)
    (declare-const ?aptr Real)
    (assert
      (or (or (= ?aptr ?aptq)
          (= ?aptr ?aptp)
          )
        (= ?aptq ?aptp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apts Real)
    (declare-const ?aptt Real)
    (declare-const ?aptu Real)
    (declare-const ?aptv Real)
    (assert
      (or (or (= ?aptu ?aptt)
          (= ?aptu ?apts)
          )
        (= ?aptt ?apts)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aptw Real)
    (declare-const ?aptx Real)
    (declare-const ?apty Real)
    (declare-const ?aptz Real)
    (declare-const ?apua Real)
    (assert
      (or (or (= ?apty ?aptx)
          (= ?apty ?aptw)
          )
        (= ?aptx ?aptw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apub Real)
    (declare-const ?apuc Real)
    (declare-const ?apud Real)
    (declare-const ?apue Real)
    (declare-const ?apuf Real)
    (declare-const ?apug Real)
    (assert
      (and (or (or (= ?apud ?apuc)
            (= ?apud ?apub)
            )
          (= ?apuc ?apub)
          )
        (and (and (not (= ?apug ?apuf))
            (not (= ?apug ?apue))
            )
          (not (= ?apuf ?apue))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apuh Real)
    (declare-const ?apui Real)
    (declare-const ?apuj Real)
    (assert
      (or (or (= ?apuj ?apui)
          (= ?apuj ?apuh)
          )
        (= ?apui ?apuh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apuk Real)
    (declare-const ?apul Real)
    (declare-const ?apum Real)
    (declare-const ?apun Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?apul ?apuk))
                (not (= ?apul ?asi))
                )
              (not (= ?apuk ?asi))
              )
            (or (or (= ?apun ?apum)
                (= ?apun ?asi)
                )
              (= ?apum ?asi)
              )
            )
          (and (or (or (= ?apul ?apuk)
                (= ?apul ?asi)
                )
              (= ?apuk ?asi)
              )
            (and (and (not (= ?apun ?apum))
                (not (= ?apun ?asi))
                )
              (not (= ?apum ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apuo Real)
    (declare-const ?apup Real)
    (declare-const ?apuq Real)
    (declare-const ?apur Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?apup ?apuo))
                (not (= ?apup ?fkf))
                )
              (not (= ?apuo ?fkf))
              )
            (or (or (= ?apur ?apuq)
                (= ?apur ?fkf)
                )
              (= ?apuq ?fkf)
              )
            )
          (and (or (or (= ?apup ?apuo)
                (= ?apup ?fkf)
                )
              (= ?apuo ?fkf)
              )
            (and (and (not (= ?apur ?apuq))
                (not (= ?apur ?fkf))
                )
              (not (= ?apuq ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apus Real)
    (declare-const ?aput Real)
    (declare-const ?apuu Real)
    (declare-const ?apuv Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aput ?apus))
                (not (= ?aput ?mzs))
                )
              (not (= ?apus ?mzs))
              )
            (or (or (= ?apuv ?apuu)
                (= ?apuv ?mzs)
                )
              (= ?apuu ?mzs)
              )
            )
          (and (or (or (= ?aput ?apus)
                (= ?aput ?mzs)
                )
              (= ?apus ?mzs)
              )
            (and (and (not (= ?apuv ?apuu))
                (not (= ?apuv ?mzs))
                )
              (not (= ?apuu ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apuw Real)
    (declare-const ?apux Real)
    (declare-const ?apuy Real)
    (declare-const ?apuz Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?apux ?apuw))
                (not (= ?apux ?zpl))
                )
              (not (= ?apuw ?zpl))
              )
            (or (or (= ?apuz ?apuy)
                (= ?apuz ?zpl)
                )
              (= ?apuy ?zpl)
              )
            )
          (and (or (or (= ?apux ?apuw)
                (= ?apux ?zpl)
                )
              (= ?apuw ?zpl)
              )
            (and (and (not (= ?apuz ?apuy))
                (not (= ?apuz ?zpl))
                )
              (not (= ?apuy ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?apva Real)
  (push 1)
    (declare-const ?apvb Real)
    (declare-const ?apvc Real)
    (declare-const ?apvd Real)
    (assert
      (or (or (= ?apvd ?apvc)
          (= ?apvd ?apvb)
          )
        (= ?apvc ?apvb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apve Real)
    (declare-const ?apvf Real)
    (declare-const ?apvg Real)
    (declare-const ?apvh Real)
    (assert
      (or (or (= ?apvh ?apvg)
          (= ?apvh ?apvf)
          )
        (= ?apvg ?apvf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apvi Real)
    (declare-const ?apvj Real)
    (declare-const ?apvk Real)
    (declare-const ?apvl Real)
    (declare-const ?apvm Real)
    (assert
      (or (or (= ?apvm ?apvl)
          (= ?apvm ?apvk)
          )
        (= ?apvl ?apvk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apvn Real)
    (declare-const ?apvo Real)
    (declare-const ?apvp Real)
    (declare-const ?apvq Real)
    (declare-const ?apvr Real)
    (declare-const ?apvs Real)
    (assert
      (and (and (and (not (= ?apvp ?apvo))
            (not (= ?apvp ?apvn))
            )
          (not (= ?apvo ?apvn))
          )
        (or (or (= ?apvs ?apvr)
            (= ?apvs ?apvq)
            )
          (= ?apvr ?apvq)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apvt Real)
    (declare-const ?apvu Real)
    (declare-const ?apvv Real)
    (assert
      (or (or (= ?apvv ?apvu)
          (= ?apvv ?apvt)
          )
        (= ?apvu ?apvt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apvw Real)
    (declare-const ?apvx Real)
    (declare-const ?apvy Real)
    (assert
      (or (or (= ?apvy ?apvx)
          (= ?apvy ?apvw)
          )
        (= ?apvx ?apvw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apvz Real)
    (declare-const ?apwa Real)
    (declare-const ?apwb Real)
    (declare-const ?apwc Real)
    (assert
      (or (or (= ?apwb ?apwa)
          (= ?apwb ?apvz)
          )
        (= ?apwa ?apvz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apwd Real)
    (declare-const ?apwe Real)
    (declare-const ?apwf Real)
    (declare-const ?apwg Real)
    (declare-const ?apwh Real)
    (assert
      (or (or (= ?apwf ?apwe)
          (= ?apwf ?apwd)
          )
        (= ?apwe ?apwd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apwi Real)
    (declare-const ?apwj Real)
    (declare-const ?apwk Real)
    (declare-const ?apwl Real)
    (declare-const ?apwm Real)
    (declare-const ?apwn Real)
    (assert
      (and (or (or (= ?apwk ?apwj)
            (= ?apwk ?apwi)
            )
          (= ?apwj ?apwi)
          )
        (and (and (not (= ?apwn ?apwm))
            (not (= ?apwn ?apwl))
            )
          (not (= ?apwm ?apwl))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apwo Real)
    (declare-const ?apwp Real)
    (declare-const ?apwq Real)
    (assert
      (or (or (= ?apwq ?apwp)
          (= ?apwq ?apwo)
          )
        (= ?apwp ?apwo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apwr Real)
    (declare-const ?apws Real)
    (declare-const ?apwt Real)
    (declare-const ?apwu Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?apws ?apwr))
                (not (= ?apws ?asi))
                )
              (not (= ?apwr ?asi))
              )
            (or (or (= ?apwu ?apwt)
                (= ?apwu ?asi)
                )
              (= ?apwt ?asi)
              )
            )
          (and (or (or (= ?apws ?apwr)
                (= ?apws ?asi)
                )
              (= ?apwr ?asi)
              )
            (and (and (not (= ?apwu ?apwt))
                (not (= ?apwu ?asi))
                )
              (not (= ?apwt ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apwv Real)
    (declare-const ?apww Real)
    (declare-const ?apwx Real)
    (declare-const ?apwy Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?apww ?apwv))
                (not (= ?apww ?fkf))
                )
              (not (= ?apwv ?fkf))
              )
            (or (or (= ?apwy ?apwx)
                (= ?apwy ?fkf)
                )
              (= ?apwx ?fkf)
              )
            )
          (and (or (or (= ?apww ?apwv)
                (= ?apww ?fkf)
                )
              (= ?apwv ?fkf)
              )
            (and (and (not (= ?apwy ?apwx))
                (not (= ?apwy ?fkf))
                )
              (not (= ?apwx ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apwz Real)
    (declare-const ?apxa Real)
    (declare-const ?apxb Real)
    (declare-const ?apxc Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?apxa ?apwz))
                (not (= ?apxa ?mzs))
                )
              (not (= ?apwz ?mzs))
              )
            (or (or (= ?apxc ?apxb)
                (= ?apxc ?mzs)
                )
              (= ?apxb ?mzs)
              )
            )
          (and (or (or (= ?apxa ?apwz)
                (= ?apxa ?mzs)
                )
              (= ?apwz ?mzs)
              )
            (and (and (not (= ?apxc ?apxb))
                (not (= ?apxc ?mzs))
                )
              (not (= ?apxb ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apxd Real)
    (declare-const ?apxe Real)
    (declare-const ?apxf Real)
    (declare-const ?apxg Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?apxe ?apxd))
                (not (= ?apxe ?zpl))
                )
              (not (= ?apxd ?zpl))
              )
            (or (or (= ?apxg ?apxf)
                (= ?apxg ?zpl)
                )
              (= ?apxf ?zpl)
              )
            )
          (and (or (or (= ?apxe ?apxd)
                (= ?apxe ?zpl)
                )
              (= ?apxd ?zpl)
              )
            (and (and (not (= ?apxg ?apxf))
                (not (= ?apxg ?zpl))
                )
              (not (= ?apxf ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?apxh Real)
  (declare-const ?apxi Real)
  (push 1)
    (declare-const ?apxj Real)
    (declare-const ?apxk Real)
    (declare-const ?apxl Real)
    (assert
      (or (or (= ?apxl ?apxk)
          (= ?apxl ?apxj)
          )
        (= ?apxk ?apxj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apxm Real)
    (declare-const ?apxn Real)
    (declare-const ?apxo Real)
    (declare-const ?apxp Real)
    (assert
      (or (or (= ?apxp ?apxo)
          (= ?apxp ?apxn)
          )
        (= ?apxo ?apxn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apxq Real)
    (declare-const ?apxr Real)
    (declare-const ?apxs Real)
    (declare-const ?apxt Real)
    (declare-const ?apxu Real)
    (assert
      (or (or (= ?apxu ?apxt)
          (= ?apxu ?apxs)
          )
        (= ?apxt ?apxs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apxv Real)
    (declare-const ?apxw Real)
    (declare-const ?apxx Real)
    (declare-const ?apxy Real)
    (declare-const ?apxz Real)
    (declare-const ?apya Real)
    (assert
      (and (and (and (not (= ?apxx ?apxw))
            (not (= ?apxx ?apxv))
            )
          (not (= ?apxw ?apxv))
          )
        (or (or (= ?apya ?apxz)
            (= ?apya ?apxy)
            )
          (= ?apxz ?apxy)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apyb Real)
    (declare-const ?apyc Real)
    (declare-const ?apyd Real)
    (assert
      (or (or (= ?apyd ?apyc)
          (= ?apyd ?apyb)
          )
        (= ?apyc ?apyb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apye Real)
    (declare-const ?apyf Real)
    (declare-const ?apyg Real)
    (assert
      (or (or (= ?apyg ?apyf)
          (= ?apyg ?apye)
          )
        (= ?apyf ?apye)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apyh Real)
    (declare-const ?apyi Real)
    (declare-const ?apyj Real)
    (declare-const ?apyk Real)
    (assert
      (or (or (= ?apyj ?apyi)
          (= ?apyj ?apyh)
          )
        (= ?apyi ?apyh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apyl Real)
    (declare-const ?apym Real)
    (declare-const ?apyn Real)
    (declare-const ?apyo Real)
    (declare-const ?apyp Real)
    (assert
      (or (or (= ?apyn ?apym)
          (= ?apyn ?apyl)
          )
        (= ?apym ?apyl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apyq Real)
    (declare-const ?apyr Real)
    (declare-const ?apys Real)
    (declare-const ?apyt Real)
    (declare-const ?apyu Real)
    (declare-const ?apyv Real)
    (assert
      (and (or (or (= ?apys ?apyr)
            (= ?apys ?apyq)
            )
          (= ?apyr ?apyq)
          )
        (and (and (not (= ?apyv ?apyu))
            (not (= ?apyv ?apyt))
            )
          (not (= ?apyu ?apyt))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apyw Real)
    (declare-const ?apyx Real)
    (declare-const ?apyy Real)
    (assert
      (or (or (= ?apyy ?apyx)
          (= ?apyy ?apyw)
          )
        (= ?apyx ?apyw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apyz Real)
    (declare-const ?apza Real)
    (declare-const ?apzb Real)
    (declare-const ?apzc Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?apza ?apyz))
                (not (= ?apza ?asi))
                )
              (not (= ?apyz ?asi))
              )
            (or (or (= ?apzc ?apzb)
                (= ?apzc ?asi)
                )
              (= ?apzb ?asi)
              )
            )
          (and (or (or (= ?apza ?apyz)
                (= ?apza ?asi)
                )
              (= ?apyz ?asi)
              )
            (and (and (not (= ?apzc ?apzb))
                (not (= ?apzc ?asi))
                )
              (not (= ?apzb ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apzd Real)
    (declare-const ?apze Real)
    (declare-const ?apzf Real)
    (declare-const ?apzg Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?apze ?apzd))
                (not (= ?apze ?fkf))
                )
              (not (= ?apzd ?fkf))
              )
            (or (or (= ?apzg ?apzf)
                (= ?apzg ?fkf)
                )
              (= ?apzf ?fkf)
              )
            )
          (and (or (or (= ?apze ?apzd)
                (= ?apze ?fkf)
                )
              (= ?apzd ?fkf)
              )
            (and (and (not (= ?apzg ?apzf))
                (not (= ?apzg ?fkf))
                )
              (not (= ?apzf ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apzh Real)
    (declare-const ?apzi Real)
    (declare-const ?apzj Real)
    (declare-const ?apzk Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?apzi ?apzh))
                (not (= ?apzi ?mzs))
                )
              (not (= ?apzh ?mzs))
              )
            (or (or (= ?apzk ?apzj)
                (= ?apzk ?mzs)
                )
              (= ?apzj ?mzs)
              )
            )
          (and (or (or (= ?apzi ?apzh)
                (= ?apzi ?mzs)
                )
              (= ?apzh ?mzs)
              )
            (and (and (not (= ?apzk ?apzj))
                (not (= ?apzk ?mzs))
                )
              (not (= ?apzj ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apzl Real)
    (declare-const ?apzm Real)
    (declare-const ?apzn Real)
    (declare-const ?apzo Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?apzm ?apzl))
                (not (= ?apzm ?zpl))
                )
              (not (= ?apzl ?zpl))
              )
            (or (or (= ?apzo ?apzn)
                (= ?apzo ?zpl)
                )
              (= ?apzn ?zpl)
              )
            )
          (and (or (or (= ?apzm ?apzl)
                (= ?apzm ?zpl)
                )
              (= ?apzl ?zpl)
              )
            (and (and (not (= ?apzo ?apzn))
                (not (= ?apzo ?zpl))
                )
              (not (= ?apzn ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?apzp Real)
  (declare-const ?apzq Real)
  (declare-const ?apzr Real)
  (push 1)
    (declare-const ?apzs Real)
    (declare-const ?apzt Real)
    (declare-const ?apzu Real)
    (assert
      (or (or (= ?apzu ?apzt)
          (= ?apzu ?apzs)
          )
        (= ?apzt ?apzs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apzv Real)
    (declare-const ?apzw Real)
    (declare-const ?apzx Real)
    (declare-const ?apzy Real)
    (assert
      (or (or (= ?apzy ?apzx)
          (= ?apzy ?apzw)
          )
        (= ?apzx ?apzw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?apzz Real)
    (declare-const ?aqaa Real)
    (declare-const ?aqab Real)
    (declare-const ?aqac Real)
    (declare-const ?aqad Real)
    (assert
      (or (or (= ?aqad ?aqac)
          (= ?aqad ?aqab)
          )
        (= ?aqac ?aqab)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqae Real)
    (declare-const ?aqaf Real)
    (declare-const ?aqag Real)
    (declare-const ?aqah Real)
    (declare-const ?aqai Real)
    (declare-const ?aqaj Real)
    (assert
      (and (and (and (not (= ?aqag ?aqaf))
            (not (= ?aqag ?aqae))
            )
          (not (= ?aqaf ?aqae))
          )
        (or (or (= ?aqaj ?aqai)
            (= ?aqaj ?aqah)
            )
          (= ?aqai ?aqah)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqak Real)
    (declare-const ?aqal Real)
    (declare-const ?aqam Real)
    (assert
      (or (or (= ?aqam ?aqal)
          (= ?aqam ?aqak)
          )
        (= ?aqal ?aqak)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqan Real)
    (declare-const ?aqao Real)
    (declare-const ?aqap Real)
    (assert
      (or (or (= ?aqap ?aqao)
          (= ?aqap ?aqan)
          )
        (= ?aqao ?aqan)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqaq Real)
    (declare-const ?aqar Real)
    (declare-const ?aqas Real)
    (declare-const ?aqat Real)
    (assert
      (or (or (= ?aqas ?aqar)
          (= ?aqas ?aqaq)
          )
        (= ?aqar ?aqaq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqau Real)
    (declare-const ?aqav Real)
    (declare-const ?aqaw Real)
    (declare-const ?aqax Real)
    (declare-const ?aqay Real)
    (assert
      (or (or (= ?aqaw ?aqav)
          (= ?aqaw ?aqau)
          )
        (= ?aqav ?aqau)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqaz Real)
    (declare-const ?aqba Real)
    (declare-const ?aqbb Real)
    (declare-const ?aqbc Real)
    (declare-const ?aqbd Real)
    (declare-const ?aqbe Real)
    (assert
      (and (or (or (= ?aqbb ?aqba)
            (= ?aqbb ?aqaz)
            )
          (= ?aqba ?aqaz)
          )
        (and (and (not (= ?aqbe ?aqbd))
            (not (= ?aqbe ?aqbc))
            )
          (not (= ?aqbd ?aqbc))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqbf Real)
    (declare-const ?aqbg Real)
    (declare-const ?aqbh Real)
    (assert
      (or (or (= ?aqbh ?aqbg)
          (= ?aqbh ?aqbf)
          )
        (= ?aqbg ?aqbf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqbi Real)
    (declare-const ?aqbj Real)
    (declare-const ?aqbk Real)
    (declare-const ?aqbl Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aqbj ?aqbi))
                (not (= ?aqbj ?asi))
                )
              (not (= ?aqbi ?asi))
              )
            (or (or (= ?aqbl ?aqbk)
                (= ?aqbl ?asi)
                )
              (= ?aqbk ?asi)
              )
            )
          (and (or (or (= ?aqbj ?aqbi)
                (= ?aqbj ?asi)
                )
              (= ?aqbi ?asi)
              )
            (and (and (not (= ?aqbl ?aqbk))
                (not (= ?aqbl ?asi))
                )
              (not (= ?aqbk ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqbm Real)
    (declare-const ?aqbn Real)
    (declare-const ?aqbo Real)
    (declare-const ?aqbp Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aqbn ?aqbm))
                (not (= ?aqbn ?fkf))
                )
              (not (= ?aqbm ?fkf))
              )
            (or (or (= ?aqbp ?aqbo)
                (= ?aqbp ?fkf)
                )
              (= ?aqbo ?fkf)
              )
            )
          (and (or (or (= ?aqbn ?aqbm)
                (= ?aqbn ?fkf)
                )
              (= ?aqbm ?fkf)
              )
            (and (and (not (= ?aqbp ?aqbo))
                (not (= ?aqbp ?fkf))
                )
              (not (= ?aqbo ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqbq Real)
    (declare-const ?aqbr Real)
    (declare-const ?aqbs Real)
    (declare-const ?aqbt Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aqbr ?aqbq))
                (not (= ?aqbr ?mzs))
                )
              (not (= ?aqbq ?mzs))
              )
            (or (or (= ?aqbt ?aqbs)
                (= ?aqbt ?mzs)
                )
              (= ?aqbs ?mzs)
              )
            )
          (and (or (or (= ?aqbr ?aqbq)
                (= ?aqbr ?mzs)
                )
              (= ?aqbq ?mzs)
              )
            (and (and (not (= ?aqbt ?aqbs))
                (not (= ?aqbt ?mzs))
                )
              (not (= ?aqbs ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqbu Real)
    (declare-const ?aqbv Real)
    (declare-const ?aqbw Real)
    (declare-const ?aqbx Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?aqbv ?aqbu))
                (not (= ?aqbv ?zpl))
                )
              (not (= ?aqbu ?zpl))
              )
            (or (or (= ?aqbx ?aqbw)
                (= ?aqbx ?zpl)
                )
              (= ?aqbw ?zpl)
              )
            )
          (and (or (or (= ?aqbv ?aqbu)
                (= ?aqbv ?zpl)
                )
              (= ?aqbu ?zpl)
              )
            (and (and (not (= ?aqbx ?aqbw))
                (not (= ?aqbx ?zpl))
                )
              (not (= ?aqbw ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aqby Real)
  (declare-const ?aqbz Real)
  (declare-const ?aqca Real)
  (declare-const ?aqcb Real)
  (assert
    (exists ((?mzs Real) )(or (and (and (and (not (= ?aqbz ?aqby))
              (not (= ?aqbz ?mzs))
              )
            (not (= ?aqby ?mzs))
            )
          (or (or (= ?aqcb ?aqca)
              (= ?aqcb ?mzs)
              )
            (= ?aqca ?mzs)
            )
          )
        (and (or (or (= ?aqbz ?aqby)
              (= ?aqbz ?mzs)
              )
            (= ?aqby ?mzs)
            )
          (and (and (not (= ?aqcb ?aqca))
              (not (= ?aqcb ?mzs))
              )
            (not (= ?aqca ?mzs))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?aqcc Real)
    (declare-const ?aqcd Real)
    (declare-const ?aqce Real)
    (assert
      (or (or (= ?aqce ?aqcd)
          (= ?aqce ?aqcc)
          )
        (= ?aqcd ?aqcc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqcf Real)
    (declare-const ?aqcg Real)
    (declare-const ?aqch Real)
    (declare-const ?aqci Real)
    (assert
      (or (or (= ?aqci ?aqch)
          (= ?aqci ?aqcg)
          )
        (= ?aqch ?aqcg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqcj Real)
    (declare-const ?aqck Real)
    (declare-const ?aqcl Real)
    (declare-const ?aqcm Real)
    (declare-const ?aqcn Real)
    (assert
      (or (or (= ?aqcn ?aqcm)
          (= ?aqcn ?aqcl)
          )
        (= ?aqcm ?aqcl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqco Real)
    (declare-const ?aqcp Real)
    (declare-const ?aqcq Real)
    (declare-const ?aqcr Real)
    (declare-const ?aqcs Real)
    (declare-const ?aqct Real)
    (assert
      (and (and (and (not (= ?aqcq ?aqcp))
            (not (= ?aqcq ?aqco))
            )
          (not (= ?aqcp ?aqco))
          )
        (or (or (= ?aqct ?aqcs)
            (= ?aqct ?aqcr)
            )
          (= ?aqcs ?aqcr)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqcu Real)
    (declare-const ?aqcv Real)
    (declare-const ?aqcw Real)
    (assert
      (or (or (= ?aqcw ?aqcv)
          (= ?aqcw ?aqcu)
          )
        (= ?aqcv ?aqcu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqcx Real)
    (declare-const ?aqcy Real)
    (declare-const ?aqcz Real)
    (assert
      (or (or (= ?aqcz ?aqcy)
          (= ?aqcz ?aqcx)
          )
        (= ?aqcy ?aqcx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqda Real)
    (declare-const ?aqdb Real)
    (declare-const ?aqdc Real)
    (declare-const ?aqdd Real)
    (assert
      (or (or (= ?aqdc ?aqdb)
          (= ?aqdc ?aqda)
          )
        (= ?aqdb ?aqda)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqde Real)
    (declare-const ?aqdf Real)
    (declare-const ?aqdg Real)
    (declare-const ?aqdh Real)
    (declare-const ?aqdi Real)
    (assert
      (or (or (= ?aqdg ?aqdf)
          (= ?aqdg ?aqde)
          )
        (= ?aqdf ?aqde)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqdj Real)
    (declare-const ?aqdk Real)
    (declare-const ?aqdl Real)
    (declare-const ?aqdm Real)
    (declare-const ?aqdn Real)
    (declare-const ?aqdo Real)
    (assert
      (and (or (or (= ?aqdl ?aqdk)
            (= ?aqdl ?aqdj)
            )
          (= ?aqdk ?aqdj)
          )
        (and (and (not (= ?aqdo ?aqdn))
            (not (= ?aqdo ?aqdm))
            )
          (not (= ?aqdn ?aqdm))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqdp Real)
    (declare-const ?aqdq Real)
    (declare-const ?aqdr Real)
    (assert
      (or (or (= ?aqdr ?aqdq)
          (= ?aqdr ?aqdp)
          )
        (= ?aqdq ?aqdp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqds Real)
    (declare-const ?aqdt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqdu Real)
    (declare-const ?aqdv Real)
    (declare-const ?aqdw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqdx Real)
    (declare-const ?aqdy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqdz Real)
    (declare-const ?aqea Real)
    (declare-const ?aqeb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqec Real)
    (declare-const ?aqed Real)
    (declare-const ?aqee Real)
    (declare-const ?aqef Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aqed ?aqec))
                (not (= ?aqed ?asi))
                )
              (not (= ?aqec ?asi))
              )
            (or (or (= ?aqef ?aqee)
                (= ?aqef ?asi)
                )
              (= ?aqee ?asi)
              )
            )
          (and (or (or (= ?aqed ?aqec)
                (= ?aqed ?asi)
                )
              (= ?aqec ?asi)
              )
            (and (and (not (= ?aqef ?aqee))
                (not (= ?aqef ?asi))
                )
              (not (= ?aqee ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqeg Real)
    (declare-const ?aqeh Real)
    (declare-const ?aqei Real)
    (declare-const ?aqej Real)
    (declare-const ?aqek Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqel Real)
    (declare-const ?aqem Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqen Real)
    (declare-const ?aqeo Real)
    (declare-const ?aqep Real)
    (declare-const ?aqeq Real)
    (declare-const ?aqer Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqes Real)
    (declare-const ?aqet Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqeu Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqev Real)
    (declare-const ?aqew Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqex Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqey Real)
    (declare-const ?aqez Real)
    (assert
      (not (= ?aqey ?aqez))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqfa Real)
    (declare-const ?aqfb Real)
    (declare-const ?aqfc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqfd Real)
    (declare-const ?aqfe Real)
    (declare-const ?aqff Real)
    (declare-const ?aqfg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqfh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqfi Real)
    (declare-const ?aqfj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqfk Real)
    (declare-const ?aqfl Real)
    (declare-const ?aqfm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqfn Real)
    (declare-const ?aqfo Real)
    (declare-const ?aqfp Real)
    (declare-const ?aqfq Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aqfo ?aqfn))
                (not (= ?aqfo ?fkf))
                )
              (not (= ?aqfn ?fkf))
              )
            (or (or (= ?aqfq ?aqfp)
                (= ?aqfq ?fkf)
                )
              (= ?aqfp ?fkf)
              )
            )
          (and (or (or (= ?aqfo ?aqfn)
                (= ?aqfo ?fkf)
                )
              (= ?aqfn ?fkf)
              )
            (and (and (not (= ?aqfq ?aqfp))
                (not (= ?aqfq ?fkf))
                )
              (not (= ?aqfp ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqfr Real)
    (declare-const ?aqfs Real)
    (declare-const ?aqft Real)
    (declare-const ?aqfu Real)
    (declare-const ?aqfv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqfw Real)
    (declare-const ?aqfx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqfy Real)
    (declare-const ?aqfz Real)
    (declare-const ?aqga Real)
    (declare-const ?aqgb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqgc Real)
    (declare-const ?aqgd Real)
    (declare-const ?aqge Real)
    (declare-const ?aqgf Real)
    (declare-const ?aqgg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqgh Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqgi Real)
    (declare-const ?aqgj Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqgk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqgl Real)
    (declare-const ?aqgm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqgn Real)
    (declare-const ?aqgo Real)
    (declare-const ?aqgp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqgq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqgr Real)
    (declare-const ?aqgs Real)
    (assert
      (not (= ?aqgr ?aqgs))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqgt Real)
    (declare-const ?aqgu Real)
    (declare-const ?aqgv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqgw Real)
    (declare-const ?aqgx Real)
    (declare-const ?aqgy Real)
    (declare-const ?aqgz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqha Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqhb Real)
    (declare-const ?aqhc Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqhd Real)
    (declare-const ?aqhe Real)
    (declare-const ?aqhf Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqhg Real)
    (declare-const ?aqhh Real)
    (declare-const ?aqhi Real)
    (declare-const ?aqhj Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aqhh ?aqhg))
                (not (= ?aqhh ?mzs))
                )
              (not (= ?aqhg ?mzs))
              )
            (or (or (= ?aqhj ?aqhi)
                (= ?aqhj ?mzs)
                )
              (= ?aqhi ?mzs)
              )
            )
          (and (or (or (= ?aqhh ?aqhg)
                (= ?aqhh ?mzs)
                )
              (= ?aqhg ?mzs)
              )
            (and (and (not (= ?aqhj ?aqhi))
                (not (= ?aqhj ?mzs))
                )
              (not (= ?aqhi ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqhk Real)
    (declare-const ?aqhl Real)
    (declare-const ?aqhm Real)
    (declare-const ?aqhn Real)
    (declare-const ?aqho Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqhp Real)
    (declare-const ?aqhq Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqhr Real)
    (declare-const ?aqhs Real)
    (declare-const ?aqht Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqhu Real)
    (declare-const ?aqhv Real)
    (declare-const ?aqhw Real)
    (declare-const ?aqhx Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqhy Real)
    (declare-const ?aqhz Real)
    (declare-const ?aqia Real)
    (declare-const ?aqib Real)
    (declare-const ?aqic Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqid Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqie Real)
    (declare-const ?aqif Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqig Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqih Real)
    (declare-const ?aqii Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqij Real)
    (declare-const ?aqik Real)
    (declare-const ?aqil Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqim Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqin Real)
    (declare-const ?aqio Real)
    (assert
      (not (= ?aqin ?aqio))
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqip Real)
    (declare-const ?aqiq Real)
    (declare-const ?aqir Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqis Real)
    (declare-const ?aqit Real)
    (declare-const ?aqiu Real)
    (declare-const ?aqiv Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqiw Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqix Real)
    (declare-const ?aqiy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqiz Real)
    (declare-const ?aqja Real)
    (declare-const ?aqjb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqjc Real)
    (declare-const ?aqjd Real)
    (declare-const ?aqje Real)
    (declare-const ?aqjf Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?aqjd ?aqjc))
                (not (= ?aqjd ?zpl))
                )
              (not (= ?aqjc ?zpl))
              )
            (or (or (= ?aqjf ?aqje)
                (= ?aqjf ?zpl)
                )
              (= ?aqje ?zpl)
              )
            )
          (and (or (or (= ?aqjd ?aqjc)
                (= ?aqjd ?zpl)
                )
              (= ?aqjc ?zpl)
              )
            (and (and (not (= ?aqjf ?aqje))
                (not (= ?aqjf ?zpl))
                )
              (not (= ?aqje ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqjg Real)
    (declare-const ?aqjh Real)
    (declare-const ?aqji Real)
    (declare-const ?aqjj Real)
    (declare-const ?aqjk Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqjl Real)
    (declare-const ?aqjm Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqjn Real)
    (declare-const ?aqjo Real)
    (declare-const ?aqjp Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqjq Real)
    (declare-const ?aqjr Real)
    (declare-const ?aqjs Real)
    (declare-const ?aqjt Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqju Real)
    (declare-const ?aqjv Real)
    (declare-const ?aqjw Real)
    (declare-const ?aqjx Real)
    (declare-const ?aqjy Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqjz Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqka Real)
    (declare-const ?aqkb Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aqkc Real)
  (declare-const ?aqkd Real)
  (declare-const ?aqke Real)
  (declare-const ?aqkf Real)
  (declare-const ?aqkg Real)
  (push 1)
    (declare-const ?aqkh Real)
    (declare-const ?aqki Real)
    (declare-const ?aqkj Real)
    (assert
      (or (or (= ?aqkj ?aqki)
          (= ?aqkj ?aqkh)
          )
        (= ?aqki ?aqkh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqkk Real)
    (declare-const ?aqkl Real)
    (declare-const ?aqkm Real)
    (declare-const ?aqkn Real)
    (assert
      (or (or (= ?aqkn ?aqkm)
          (= ?aqkn ?aqkl)
          )
        (= ?aqkm ?aqkl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqko Real)
    (declare-const ?aqkp Real)
    (declare-const ?aqkq Real)
    (declare-const ?aqkr Real)
    (declare-const ?aqks Real)
    (assert
      (or (or (= ?aqks ?aqkr)
          (= ?aqks ?aqkq)
          )
        (= ?aqkr ?aqkq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqkt Real)
    (declare-const ?aqku Real)
    (declare-const ?aqkv Real)
    (declare-const ?aqkw Real)
    (declare-const ?aqkx Real)
    (declare-const ?aqky Real)
    (assert
      (and (and (and (not (= ?aqkv ?aqku))
            (not (= ?aqkv ?aqkt))
            )
          (not (= ?aqku ?aqkt))
          )
        (or (or (= ?aqky ?aqkx)
            (= ?aqky ?aqkw)
            )
          (= ?aqkx ?aqkw)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqkz Real)
    (declare-const ?aqla Real)
    (declare-const ?aqlb Real)
    (assert
      (or (or (= ?aqlb ?aqla)
          (= ?aqlb ?aqkz)
          )
        (= ?aqla ?aqkz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqlc Real)
    (declare-const ?aqld Real)
    (declare-const ?aqle Real)
    (assert
      (or (or (= ?aqle ?aqld)
          (= ?aqle ?aqlc)
          )
        (= ?aqld ?aqlc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqlf Real)
    (declare-const ?aqlg Real)
    (declare-const ?aqlh Real)
    (declare-const ?aqli Real)
    (assert
      (or (or (= ?aqlh ?aqlg)
          (= ?aqlh ?aqlf)
          )
        (= ?aqlg ?aqlf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqlj Real)
    (declare-const ?aqlk Real)
    (declare-const ?aqll Real)
    (declare-const ?aqlm Real)
    (declare-const ?aqln Real)
    (assert
      (or (or (= ?aqll ?aqlk)
          (= ?aqll ?aqlj)
          )
        (= ?aqlk ?aqlj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqlo Real)
    (declare-const ?aqlp Real)
    (declare-const ?aqlq Real)
    (declare-const ?aqlr Real)
    (declare-const ?aqls Real)
    (declare-const ?aqlt Real)
    (assert
      (and (or (or (= ?aqlq ?aqlp)
            (= ?aqlq ?aqlo)
            )
          (= ?aqlp ?aqlo)
          )
        (and (and (not (= ?aqlt ?aqls))
            (not (= ?aqlt ?aqlr))
            )
          (not (= ?aqls ?aqlr))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqlu Real)
    (declare-const ?aqlv Real)
    (declare-const ?aqlw Real)
    (assert
      (or (or (= ?aqlw ?aqlv)
          (= ?aqlw ?aqlu)
          )
        (= ?aqlv ?aqlu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqlx Real)
    (declare-const ?aqly Real)
    (declare-const ?aqlz Real)
    (declare-const ?aqma Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aqly ?aqlx))
                (not (= ?aqly ?asi))
                )
              (not (= ?aqlx ?asi))
              )
            (or (or (= ?aqma ?aqlz)
                (= ?aqma ?asi)
                )
              (= ?aqlz ?asi)
              )
            )
          (and (or (or (= ?aqly ?aqlx)
                (= ?aqly ?asi)
                )
              (= ?aqlx ?asi)
              )
            (and (and (not (= ?aqma ?aqlz))
                (not (= ?aqma ?asi))
                )
              (not (= ?aqlz ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqmb Real)
    (declare-const ?aqmc Real)
    (declare-const ?aqmd Real)
    (declare-const ?aqme Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aqmc ?aqmb))
                (not (= ?aqmc ?fkf))
                )
              (not (= ?aqmb ?fkf))
              )
            (or (or (= ?aqme ?aqmd)
                (= ?aqme ?fkf)
                )
              (= ?aqmd ?fkf)
              )
            )
          (and (or (or (= ?aqmc ?aqmb)
                (= ?aqmc ?fkf)
                )
              (= ?aqmb ?fkf)
              )
            (and (and (not (= ?aqme ?aqmd))
                (not (= ?aqme ?fkf))
                )
              (not (= ?aqmd ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqmf Real)
    (declare-const ?aqmg Real)
    (declare-const ?aqmh Real)
    (declare-const ?aqmi Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aqmg ?aqmf))
                (not (= ?aqmg ?mzs))
                )
              (not (= ?aqmf ?mzs))
              )
            (or (or (= ?aqmi ?aqmh)
                (= ?aqmi ?mzs)
                )
              (= ?aqmh ?mzs)
              )
            )
          (and (or (or (= ?aqmg ?aqmf)
                (= ?aqmg ?mzs)
                )
              (= ?aqmf ?mzs)
              )
            (and (and (not (= ?aqmi ?aqmh))
                (not (= ?aqmi ?mzs))
                )
              (not (= ?aqmh ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqmj Real)
    (declare-const ?aqmk Real)
    (declare-const ?aqml Real)
    (declare-const ?aqmm Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?aqmk ?aqmj))
                (not (= ?aqmk ?zpl))
                )
              (not (= ?aqmj ?zpl))
              )
            (or (or (= ?aqmm ?aqml)
                (= ?aqmm ?zpl)
                )
              (= ?aqml ?zpl)
              )
            )
          (and (or (or (= ?aqmk ?aqmj)
                (= ?aqmk ?zpl)
                )
              (= ?aqmj ?zpl)
              )
            (and (and (not (= ?aqmm ?aqml))
                (not (= ?aqmm ?zpl))
                )
              (not (= ?aqml ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aqmn Real)
  (declare-const ?aqmo Real)
  (push 1)
    (declare-const ?aqmp Real)
    (declare-const ?aqmq Real)
    (declare-const ?aqmr Real)
    (assert
      (or (or (= ?aqmr ?aqmq)
          (= ?aqmr ?aqmp)
          )
        (= ?aqmq ?aqmp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqms Real)
    (declare-const ?aqmt Real)
    (declare-const ?aqmu Real)
    (declare-const ?aqmv Real)
    (assert
      (or (or (= ?aqmv ?aqmu)
          (= ?aqmv ?aqmt)
          )
        (= ?aqmu ?aqmt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqmw Real)
    (declare-const ?aqmx Real)
    (declare-const ?aqmy Real)
    (declare-const ?aqmz Real)
    (declare-const ?aqna Real)
    (assert
      (or (or (= ?aqna ?aqmz)
          (= ?aqna ?aqmy)
          )
        (= ?aqmz ?aqmy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqnb Real)
    (declare-const ?aqnc Real)
    (declare-const ?aqnd Real)
    (declare-const ?aqne Real)
    (declare-const ?aqnf Real)
    (declare-const ?aqng Real)
    (assert
      (and (and (and (not (= ?aqnd ?aqnc))
            (not (= ?aqnd ?aqnb))
            )
          (not (= ?aqnc ?aqnb))
          )
        (or (or (= ?aqng ?aqnf)
            (= ?aqng ?aqne)
            )
          (= ?aqnf ?aqne)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqnh Real)
    (declare-const ?aqni Real)
    (declare-const ?aqnj Real)
    (assert
      (or (or (= ?aqnj ?aqni)
          (= ?aqnj ?aqnh)
          )
        (= ?aqni ?aqnh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqnk Real)
    (declare-const ?aqnl Real)
    (declare-const ?aqnm Real)
    (assert
      (or (or (= ?aqnm ?aqnl)
          (= ?aqnm ?aqnk)
          )
        (= ?aqnl ?aqnk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqnn Real)
    (declare-const ?aqno Real)
    (declare-const ?aqnp Real)
    (declare-const ?aqnq Real)
    (assert
      (or (or (= ?aqnp ?aqno)
          (= ?aqnp ?aqnn)
          )
        (= ?aqno ?aqnn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqnr Real)
    (declare-const ?aqns Real)
    (declare-const ?aqnt Real)
    (declare-const ?aqnu Real)
    (declare-const ?aqnv Real)
    (assert
      (or (or (= ?aqnt ?aqns)
          (= ?aqnt ?aqnr)
          )
        (= ?aqns ?aqnr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqnw Real)
    (declare-const ?aqnx Real)
    (declare-const ?aqny Real)
    (declare-const ?aqnz Real)
    (declare-const ?aqoa Real)
    (declare-const ?aqob Real)
    (assert
      (and (or (or (= ?aqny ?aqnx)
            (= ?aqny ?aqnw)
            )
          (= ?aqnx ?aqnw)
          )
        (and (and (not (= ?aqob ?aqoa))
            (not (= ?aqob ?aqnz))
            )
          (not (= ?aqoa ?aqnz))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqoc Real)
    (declare-const ?aqod Real)
    (declare-const ?aqoe Real)
    (assert
      (or (or (= ?aqoe ?aqod)
          (= ?aqoe ?aqoc)
          )
        (= ?aqod ?aqoc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqof Real)
    (declare-const ?aqog Real)
    (declare-const ?aqoh Real)
    (declare-const ?aqoi Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aqog ?aqof))
                (not (= ?aqog ?asi))
                )
              (not (= ?aqof ?asi))
              )
            (or (or (= ?aqoi ?aqoh)
                (= ?aqoi ?asi)
                )
              (= ?aqoh ?asi)
              )
            )
          (and (or (or (= ?aqog ?aqof)
                (= ?aqog ?asi)
                )
              (= ?aqof ?asi)
              )
            (and (and (not (= ?aqoi ?aqoh))
                (not (= ?aqoi ?asi))
                )
              (not (= ?aqoh ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqoj Real)
    (declare-const ?aqok Real)
    (declare-const ?aqol Real)
    (declare-const ?aqom Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aqok ?aqoj))
                (not (= ?aqok ?fkf))
                )
              (not (= ?aqoj ?fkf))
              )
            (or (or (= ?aqom ?aqol)
                (= ?aqom ?fkf)
                )
              (= ?aqol ?fkf)
              )
            )
          (and (or (or (= ?aqok ?aqoj)
                (= ?aqok ?fkf)
                )
              (= ?aqoj ?fkf)
              )
            (and (and (not (= ?aqom ?aqol))
                (not (= ?aqom ?fkf))
                )
              (not (= ?aqol ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqon Real)
    (declare-const ?aqoo Real)
    (declare-const ?aqop Real)
    (declare-const ?aqoq Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aqoo ?aqon))
                (not (= ?aqoo ?mzs))
                )
              (not (= ?aqon ?mzs))
              )
            (or (or (= ?aqoq ?aqop)
                (= ?aqoq ?mzs)
                )
              (= ?aqop ?mzs)
              )
            )
          (and (or (or (= ?aqoo ?aqon)
                (= ?aqoo ?mzs)
                )
              (= ?aqon ?mzs)
              )
            (and (and (not (= ?aqoq ?aqop))
                (not (= ?aqoq ?mzs))
                )
              (not (= ?aqop ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqor Real)
    (declare-const ?aqos Real)
    (declare-const ?aqot Real)
    (declare-const ?aqou Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?aqos ?aqor))
                (not (= ?aqos ?zpl))
                )
              (not (= ?aqor ?zpl))
              )
            (or (or (= ?aqou ?aqot)
                (= ?aqou ?zpl)
                )
              (= ?aqot ?zpl)
              )
            )
          (and (or (or (= ?aqos ?aqor)
                (= ?aqos ?zpl)
                )
              (= ?aqor ?zpl)
              )
            (and (and (not (= ?aqou ?aqot))
                (not (= ?aqou ?zpl))
                )
              (not (= ?aqot ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aqov Real)
  (declare-const ?aqow Real)
  (declare-const ?aqox Real)
  (push 1)
    (declare-const ?aqoy Real)
    (declare-const ?aqoz Real)
    (declare-const ?aqpa Real)
    (assert
      (or (or (= ?aqpa ?aqoz)
          (= ?aqpa ?aqoy)
          )
        (= ?aqoz ?aqoy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqpb Real)
    (declare-const ?aqpc Real)
    (declare-const ?aqpd Real)
    (declare-const ?aqpe Real)
    (assert
      (or (or (= ?aqpe ?aqpd)
          (= ?aqpe ?aqpc)
          )
        (= ?aqpd ?aqpc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqpf Real)
    (declare-const ?aqpg Real)
    (declare-const ?aqph Real)
    (declare-const ?aqpi Real)
    (declare-const ?aqpj Real)
    (assert
      (or (or (= ?aqpj ?aqpi)
          (= ?aqpj ?aqph)
          )
        (= ?aqpi ?aqph)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqpk Real)
    (declare-const ?aqpl Real)
    (declare-const ?aqpm Real)
    (declare-const ?aqpn Real)
    (declare-const ?aqpo Real)
    (declare-const ?aqpp Real)
    (assert
      (and (and (and (not (= ?aqpm ?aqpl))
            (not (= ?aqpm ?aqpk))
            )
          (not (= ?aqpl ?aqpk))
          )
        (or (or (= ?aqpp ?aqpo)
            (= ?aqpp ?aqpn)
            )
          (= ?aqpo ?aqpn)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqpq Real)
    (declare-const ?aqpr Real)
    (declare-const ?aqps Real)
    (assert
      (or (or (= ?aqps ?aqpr)
          (= ?aqps ?aqpq)
          )
        (= ?aqpr ?aqpq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqpt Real)
    (declare-const ?aqpu Real)
    (declare-const ?aqpv Real)
    (assert
      (or (or (= ?aqpv ?aqpu)
          (= ?aqpv ?aqpt)
          )
        (= ?aqpu ?aqpt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqpw Real)
    (declare-const ?aqpx Real)
    (declare-const ?aqpy Real)
    (declare-const ?aqpz Real)
    (assert
      (or (or (= ?aqpy ?aqpx)
          (= ?aqpy ?aqpw)
          )
        (= ?aqpx ?aqpw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqqa Real)
    (declare-const ?aqqb Real)
    (declare-const ?aqqc Real)
    (declare-const ?aqqd Real)
    (declare-const ?aqqe Real)
    (assert
      (or (or (= ?aqqc ?aqqb)
          (= ?aqqc ?aqqa)
          )
        (= ?aqqb ?aqqa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqqf Real)
    (declare-const ?aqqg Real)
    (declare-const ?aqqh Real)
    (declare-const ?aqqi Real)
    (declare-const ?aqqj Real)
    (declare-const ?aqqk Real)
    (assert
      (and (or (or (= ?aqqh ?aqqg)
            (= ?aqqh ?aqqf)
            )
          (= ?aqqg ?aqqf)
          )
        (and (and (not (= ?aqqk ?aqqj))
            (not (= ?aqqk ?aqqi))
            )
          (not (= ?aqqj ?aqqi))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqql Real)
    (declare-const ?aqqm Real)
    (declare-const ?aqqn Real)
    (assert
      (or (or (= ?aqqn ?aqqm)
          (= ?aqqn ?aqql)
          )
        (= ?aqqm ?aqql)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqqo Real)
    (declare-const ?aqqp Real)
    (declare-const ?aqqq Real)
    (declare-const ?aqqr Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aqqp ?aqqo))
                (not (= ?aqqp ?asi))
                )
              (not (= ?aqqo ?asi))
              )
            (or (or (= ?aqqr ?aqqq)
                (= ?aqqr ?asi)
                )
              (= ?aqqq ?asi)
              )
            )
          (and (or (or (= ?aqqp ?aqqo)
                (= ?aqqp ?asi)
                )
              (= ?aqqo ?asi)
              )
            (and (and (not (= ?aqqr ?aqqq))
                (not (= ?aqqr ?asi))
                )
              (not (= ?aqqq ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqqs Real)
    (declare-const ?aqqt Real)
    (declare-const ?aqqu Real)
    (declare-const ?aqqv Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aqqt ?aqqs))
                (not (= ?aqqt ?fkf))
                )
              (not (= ?aqqs ?fkf))
              )
            (or (or (= ?aqqv ?aqqu)
                (= ?aqqv ?fkf)
                )
              (= ?aqqu ?fkf)
              )
            )
          (and (or (or (= ?aqqt ?aqqs)
                (= ?aqqt ?fkf)
                )
              (= ?aqqs ?fkf)
              )
            (and (and (not (= ?aqqv ?aqqu))
                (not (= ?aqqv ?fkf))
                )
              (not (= ?aqqu ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqqw Real)
    (declare-const ?aqqx Real)
    (declare-const ?aqqy Real)
    (declare-const ?aqqz Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aqqx ?aqqw))
                (not (= ?aqqx ?mzs))
                )
              (not (= ?aqqw ?mzs))
              )
            (or (or (= ?aqqz ?aqqy)
                (= ?aqqz ?mzs)
                )
              (= ?aqqy ?mzs)
              )
            )
          (and (or (or (= ?aqqx ?aqqw)
                (= ?aqqx ?mzs)
                )
              (= ?aqqw ?mzs)
              )
            (and (and (not (= ?aqqz ?aqqy))
                (not (= ?aqqz ?mzs))
                )
              (not (= ?aqqy ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqra Real)
    (declare-const ?aqrb Real)
    (declare-const ?aqrc Real)
    (declare-const ?aqrd Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?aqrb ?aqra))
                (not (= ?aqrb ?zpl))
                )
              (not (= ?aqra ?zpl))
              )
            (or (or (= ?aqrd ?aqrc)
                (= ?aqrd ?zpl)
                )
              (= ?aqrc ?zpl)
              )
            )
          (and (or (or (= ?aqrb ?aqra)
                (= ?aqrb ?zpl)
                )
              (= ?aqra ?zpl)
              )
            (and (and (not (= ?aqrd ?aqrc))
                (not (= ?aqrd ?zpl))
                )
              (not (= ?aqrc ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aqre Real)
  (declare-const ?aqrf Real)
  (declare-const ?aqrg Real)
  (declare-const ?aqrh Real)
  (push 1)
    (declare-const ?aqri Real)
    (declare-const ?aqrj Real)
    (declare-const ?aqrk Real)
    (assert
      (or (or (= ?aqrk ?aqrj)
          (= ?aqrk ?aqri)
          )
        (= ?aqrj ?aqri)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqrl Real)
    (declare-const ?aqrm Real)
    (declare-const ?aqrn Real)
    (declare-const ?aqro Real)
    (assert
      (or (or (= ?aqro ?aqrn)
          (= ?aqro ?aqrm)
          )
        (= ?aqrn ?aqrm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqrp Real)
    (declare-const ?aqrq Real)
    (declare-const ?aqrr Real)
    (declare-const ?aqrs Real)
    (declare-const ?aqrt Real)
    (assert
      (or (or (= ?aqrt ?aqrs)
          (= ?aqrt ?aqrr)
          )
        (= ?aqrs ?aqrr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqru Real)
    (declare-const ?aqrv Real)
    (declare-const ?aqrw Real)
    (declare-const ?aqrx Real)
    (declare-const ?aqry Real)
    (declare-const ?aqrz Real)
    (assert
      (and (and (and (not (= ?aqrw ?aqrv))
            (not (= ?aqrw ?aqru))
            )
          (not (= ?aqrv ?aqru))
          )
        (or (or (= ?aqrz ?aqry)
            (= ?aqrz ?aqrx)
            )
          (= ?aqry ?aqrx)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqsa Real)
    (declare-const ?aqsb Real)
    (declare-const ?aqsc Real)
    (assert
      (or (or (= ?aqsc ?aqsb)
          (= ?aqsc ?aqsa)
          )
        (= ?aqsb ?aqsa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqsd Real)
    (declare-const ?aqse Real)
    (declare-const ?aqsf Real)
    (assert
      (or (or (= ?aqsf ?aqse)
          (= ?aqsf ?aqsd)
          )
        (= ?aqse ?aqsd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqsg Real)
    (declare-const ?aqsh Real)
    (declare-const ?aqsi Real)
    (declare-const ?aqsj Real)
    (assert
      (or (or (= ?aqsi ?aqsh)
          (= ?aqsi ?aqsg)
          )
        (= ?aqsh ?aqsg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqsk Real)
    (declare-const ?aqsl Real)
    (declare-const ?aqsm Real)
    (declare-const ?aqsn Real)
    (declare-const ?aqso Real)
    (assert
      (or (or (= ?aqsm ?aqsl)
          (= ?aqsm ?aqsk)
          )
        (= ?aqsl ?aqsk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqsp Real)
    (declare-const ?aqsq Real)
    (declare-const ?aqsr Real)
    (declare-const ?aqss Real)
    (declare-const ?aqst Real)
    (declare-const ?aqsu Real)
    (assert
      (and (or (or (= ?aqsr ?aqsq)
            (= ?aqsr ?aqsp)
            )
          (= ?aqsq ?aqsp)
          )
        (and (and (not (= ?aqsu ?aqst))
            (not (= ?aqsu ?aqss))
            )
          (not (= ?aqst ?aqss))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqsv Real)
    (declare-const ?aqsw Real)
    (declare-const ?aqsx Real)
    (assert
      (or (or (= ?aqsx ?aqsw)
          (= ?aqsx ?aqsv)
          )
        (= ?aqsw ?aqsv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqsy Real)
    (declare-const ?aqsz Real)
    (declare-const ?aqta Real)
    (declare-const ?aqtb Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aqsz ?aqsy))
                (not (= ?aqsz ?asi))
                )
              (not (= ?aqsy ?asi))
              )
            (or (or (= ?aqtb ?aqta)
                (= ?aqtb ?asi)
                )
              (= ?aqta ?asi)
              )
            )
          (and (or (or (= ?aqsz ?aqsy)
                (= ?aqsz ?asi)
                )
              (= ?aqsy ?asi)
              )
            (and (and (not (= ?aqtb ?aqta))
                (not (= ?aqtb ?asi))
                )
              (not (= ?aqta ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqtc Real)
    (declare-const ?aqtd Real)
    (declare-const ?aqte Real)
    (declare-const ?aqtf Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aqtd ?aqtc))
                (not (= ?aqtd ?fkf))
                )
              (not (= ?aqtc ?fkf))
              )
            (or (or (= ?aqtf ?aqte)
                (= ?aqtf ?fkf)
                )
              (= ?aqte ?fkf)
              )
            )
          (and (or (or (= ?aqtd ?aqtc)
                (= ?aqtd ?fkf)
                )
              (= ?aqtc ?fkf)
              )
            (and (and (not (= ?aqtf ?aqte))
                (not (= ?aqtf ?fkf))
                )
              (not (= ?aqte ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqtg Real)
    (declare-const ?aqth Real)
    (declare-const ?aqti Real)
    (declare-const ?aqtj Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aqth ?aqtg))
                (not (= ?aqth ?mzs))
                )
              (not (= ?aqtg ?mzs))
              )
            (or (or (= ?aqtj ?aqti)
                (= ?aqtj ?mzs)
                )
              (= ?aqti ?mzs)
              )
            )
          (and (or (or (= ?aqth ?aqtg)
                (= ?aqth ?mzs)
                )
              (= ?aqtg ?mzs)
              )
            (and (and (not (= ?aqtj ?aqti))
                (not (= ?aqtj ?mzs))
                )
              (not (= ?aqti ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqtk Real)
    (declare-const ?aqtl Real)
    (declare-const ?aqtm Real)
    (declare-const ?aqtn Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?aqtl ?aqtk))
                (not (= ?aqtl ?zpl))
                )
              (not (= ?aqtk ?zpl))
              )
            (or (or (= ?aqtn ?aqtm)
                (= ?aqtn ?zpl)
                )
              (= ?aqtm ?zpl)
              )
            )
          (and (or (or (= ?aqtl ?aqtk)
                (= ?aqtl ?zpl)
                )
              (= ?aqtk ?zpl)
              )
            (and (and (not (= ?aqtn ?aqtm))
                (not (= ?aqtn ?zpl))
                )
              (not (= ?aqtm ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aqto Real)
  (declare-const ?aqtp Real)
  (declare-const ?aqtq Real)
  (declare-const ?aqtr Real)
  (declare-const ?aqts Real)
  (push 1)
    (declare-const ?aqtt Real)
    (declare-const ?aqtu Real)
    (declare-const ?aqtv Real)
    (assert
      (or (or (= ?aqtv ?aqtu)
          (= ?aqtv ?aqtt)
          )
        (= ?aqtu ?aqtt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqtw Real)
    (declare-const ?aqtx Real)
    (declare-const ?aqty Real)
    (declare-const ?aqtz Real)
    (assert
      (or (or (= ?aqtz ?aqty)
          (= ?aqtz ?aqtx)
          )
        (= ?aqty ?aqtx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqua Real)
    (declare-const ?aqub Real)
    (declare-const ?aquc Real)
    (declare-const ?aqud Real)
    (declare-const ?aque Real)
    (assert
      (or (or (= ?aque ?aqud)
          (= ?aque ?aquc)
          )
        (= ?aqud ?aquc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aquf Real)
    (declare-const ?aqug Real)
    (declare-const ?aquh Real)
    (declare-const ?aqui Real)
    (declare-const ?aquj Real)
    (declare-const ?aquk Real)
    (assert
      (and (and (and (not (= ?aquh ?aqug))
            (not (= ?aquh ?aquf))
            )
          (not (= ?aqug ?aquf))
          )
        (or (or (= ?aquk ?aquj)
            (= ?aquk ?aqui)
            )
          (= ?aquj ?aqui)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqul Real)
    (declare-const ?aqum Real)
    (declare-const ?aqun Real)
    (assert
      (or (or (= ?aqun ?aqum)
          (= ?aqun ?aqul)
          )
        (= ?aqum ?aqul)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aquo Real)
    (declare-const ?aqup Real)
    (declare-const ?aquq Real)
    (assert
      (or (or (= ?aquq ?aqup)
          (= ?aquq ?aquo)
          )
        (= ?aqup ?aquo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqur Real)
    (declare-const ?aqus Real)
    (declare-const ?aqut Real)
    (declare-const ?aquu Real)
    (assert
      (or (or (= ?aqut ?aqus)
          (= ?aqut ?aqur)
          )
        (= ?aqus ?aqur)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aquv Real)
    (declare-const ?aquw Real)
    (declare-const ?aqux Real)
    (declare-const ?aquy Real)
    (declare-const ?aquz Real)
    (assert
      (or (or (= ?aqux ?aquw)
          (= ?aqux ?aquv)
          )
        (= ?aquw ?aquv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqva Real)
    (declare-const ?aqvb Real)
    (declare-const ?aqvc Real)
    (declare-const ?aqvd Real)
    (declare-const ?aqve Real)
    (declare-const ?aqvf Real)
    (assert
      (and (or (or (= ?aqvc ?aqvb)
            (= ?aqvc ?aqva)
            )
          (= ?aqvb ?aqva)
          )
        (and (and (not (= ?aqvf ?aqve))
            (not (= ?aqvf ?aqvd))
            )
          (not (= ?aqve ?aqvd))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqvg Real)
    (declare-const ?aqvh Real)
    (declare-const ?aqvi Real)
    (assert
      (or (or (= ?aqvi ?aqvh)
          (= ?aqvi ?aqvg)
          )
        (= ?aqvh ?aqvg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqvj Real)
    (declare-const ?aqvk Real)
    (declare-const ?aqvl Real)
    (declare-const ?aqvm Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aqvk ?aqvj))
                (not (= ?aqvk ?asi))
                )
              (not (= ?aqvj ?asi))
              )
            (or (or (= ?aqvm ?aqvl)
                (= ?aqvm ?asi)
                )
              (= ?aqvl ?asi)
              )
            )
          (and (or (or (= ?aqvk ?aqvj)
                (= ?aqvk ?asi)
                )
              (= ?aqvj ?asi)
              )
            (and (and (not (= ?aqvm ?aqvl))
                (not (= ?aqvm ?asi))
                )
              (not (= ?aqvl ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqvn Real)
    (declare-const ?aqvo Real)
    (declare-const ?aqvp Real)
    (declare-const ?aqvq Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aqvo ?aqvn))
                (not (= ?aqvo ?fkf))
                )
              (not (= ?aqvn ?fkf))
              )
            (or (or (= ?aqvq ?aqvp)
                (= ?aqvq ?fkf)
                )
              (= ?aqvp ?fkf)
              )
            )
          (and (or (or (= ?aqvo ?aqvn)
                (= ?aqvo ?fkf)
                )
              (= ?aqvn ?fkf)
              )
            (and (and (not (= ?aqvq ?aqvp))
                (not (= ?aqvq ?fkf))
                )
              (not (= ?aqvp ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqvr Real)
    (declare-const ?aqvs Real)
    (declare-const ?aqvt Real)
    (declare-const ?aqvu Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aqvs ?aqvr))
                (not (= ?aqvs ?mzs))
                )
              (not (= ?aqvr ?mzs))
              )
            (or (or (= ?aqvu ?aqvt)
                (= ?aqvu ?mzs)
                )
              (= ?aqvt ?mzs)
              )
            )
          (and (or (or (= ?aqvs ?aqvr)
                (= ?aqvs ?mzs)
                )
              (= ?aqvr ?mzs)
              )
            (and (and (not (= ?aqvu ?aqvt))
                (not (= ?aqvu ?mzs))
                )
              (not (= ?aqvt ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqvv Real)
    (declare-const ?aqvw Real)
    (declare-const ?aqvx Real)
    (declare-const ?aqvy Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?aqvw ?aqvv))
                (not (= ?aqvw ?zpl))
                )
              (not (= ?aqvv ?zpl))
              )
            (or (or (= ?aqvy ?aqvx)
                (= ?aqvy ?zpl)
                )
              (= ?aqvx ?zpl)
              )
            )
          (and (or (or (= ?aqvw ?aqvv)
                (= ?aqvw ?zpl)
                )
              (= ?aqvv ?zpl)
              )
            (and (and (not (= ?aqvy ?aqvx))
                (not (= ?aqvy ?zpl))
                )
              (not (= ?aqvx ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?aqvz Real)
    (declare-const ?aqwa Real)
    (declare-const ?aqwb Real)
    (assert
      (or (or (= ?aqwb ?aqwa)
          (= ?aqwb ?aqvz)
          )
        (= ?aqwa ?aqvz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqwc Real)
    (declare-const ?aqwd Real)
    (declare-const ?aqwe Real)
    (declare-const ?aqwf Real)
    (assert
      (or (or (= ?aqwf ?aqwe)
          (= ?aqwf ?aqwd)
          )
        (= ?aqwe ?aqwd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqwg Real)
    (declare-const ?aqwh Real)
    (declare-const ?aqwi Real)
    (declare-const ?aqwj Real)
    (declare-const ?aqwk Real)
    (assert
      (or (or (= ?aqwk ?aqwj)
          (= ?aqwk ?aqwi)
          )
        (= ?aqwj ?aqwi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqwl Real)
    (declare-const ?aqwm Real)
    (declare-const ?aqwn Real)
    (declare-const ?aqwo Real)
    (declare-const ?aqwp Real)
    (declare-const ?aqwq Real)
    (assert
      (and (and (and (not (= ?aqwn ?aqwm))
            (not (= ?aqwn ?aqwl))
            )
          (not (= ?aqwm ?aqwl))
          )
        (or (or (= ?aqwq ?aqwp)
            (= ?aqwq ?aqwo)
            )
          (= ?aqwp ?aqwo)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqwr Real)
    (declare-const ?aqws Real)
    (declare-const ?aqwt Real)
    (assert
      (or (or (= ?aqwt ?aqws)
          (= ?aqwt ?aqwr)
          )
        (= ?aqws ?aqwr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqwu Real)
    (declare-const ?aqwv Real)
    (declare-const ?aqww Real)
    (assert
      (or (or (= ?aqww ?aqwv)
          (= ?aqww ?aqwu)
          )
        (= ?aqwv ?aqwu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqwx Real)
    (declare-const ?aqwy Real)
    (declare-const ?aqwz Real)
    (declare-const ?aqxa Real)
    (assert
      (or (or (= ?aqwz ?aqwy)
          (= ?aqwz ?aqwx)
          )
        (= ?aqwy ?aqwx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqxb Real)
    (declare-const ?aqxc Real)
    (declare-const ?aqxd Real)
    (declare-const ?aqxe Real)
    (declare-const ?aqxf Real)
    (assert
      (or (or (= ?aqxd ?aqxc)
          (= ?aqxd ?aqxb)
          )
        (= ?aqxc ?aqxb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqxg Real)
    (declare-const ?aqxh Real)
    (declare-const ?aqxi Real)
    (declare-const ?aqxj Real)
    (declare-const ?aqxk Real)
    (declare-const ?aqxl Real)
    (assert
      (and (or (or (= ?aqxi ?aqxh)
            (= ?aqxi ?aqxg)
            )
          (= ?aqxh ?aqxg)
          )
        (and (and (not (= ?aqxl ?aqxk))
            (not (= ?aqxl ?aqxj))
            )
          (not (= ?aqxk ?aqxj))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqxm Real)
    (declare-const ?aqxn Real)
    (declare-const ?aqxo Real)
    (assert
      (or (or (= ?aqxo ?aqxn)
          (= ?aqxo ?aqxm)
          )
        (= ?aqxn ?aqxm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqxp Real)
    (declare-const ?aqxq Real)
    (declare-const ?aqxr Real)
    (declare-const ?aqxs Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aqxq ?aqxp))
                (not (= ?aqxq ?asi))
                )
              (not (= ?aqxp ?asi))
              )
            (or (or (= ?aqxs ?aqxr)
                (= ?aqxs ?asi)
                )
              (= ?aqxr ?asi)
              )
            )
          (and (or (or (= ?aqxq ?aqxp)
                (= ?aqxq ?asi)
                )
              (= ?aqxp ?asi)
              )
            (and (and (not (= ?aqxs ?aqxr))
                (not (= ?aqxs ?asi))
                )
              (not (= ?aqxr ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqxt Real)
    (declare-const ?aqxu Real)
    (declare-const ?aqxv Real)
    (declare-const ?aqxw Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aqxu ?aqxt))
                (not (= ?aqxu ?fkf))
                )
              (not (= ?aqxt ?fkf))
              )
            (or (or (= ?aqxw ?aqxv)
                (= ?aqxw ?fkf)
                )
              (= ?aqxv ?fkf)
              )
            )
          (and (or (or (= ?aqxu ?aqxt)
                (= ?aqxu ?fkf)
                )
              (= ?aqxt ?fkf)
              )
            (and (and (not (= ?aqxw ?aqxv))
                (not (= ?aqxw ?fkf))
                )
              (not (= ?aqxv ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqxx Real)
    (declare-const ?aqxy Real)
    (declare-const ?aqxz Real)
    (declare-const ?aqya Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aqxy ?aqxx))
                (not (= ?aqxy ?mzs))
                )
              (not (= ?aqxx ?mzs))
              )
            (or (or (= ?aqya ?aqxz)
                (= ?aqya ?mzs)
                )
              (= ?aqxz ?mzs)
              )
            )
          (and (or (or (= ?aqxy ?aqxx)
                (= ?aqxy ?mzs)
                )
              (= ?aqxx ?mzs)
              )
            (and (and (not (= ?aqya ?aqxz))
                (not (= ?aqya ?mzs))
                )
              (not (= ?aqxz ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqyb Real)
    (declare-const ?aqyc Real)
    (declare-const ?aqyd Real)
    (declare-const ?aqye Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?aqyc ?aqyb))
                (not (= ?aqyc ?zpl))
                )
              (not (= ?aqyb ?zpl))
              )
            (or (or (= ?aqye ?aqyd)
                (= ?aqye ?zpl)
                )
              (= ?aqyd ?zpl)
              )
            )
          (and (or (or (= ?aqyc ?aqyb)
                (= ?aqyc ?zpl)
                )
              (= ?aqyb ?zpl)
              )
            (and (and (not (= ?aqye ?aqyd))
                (not (= ?aqye ?zpl))
                )
              (not (= ?aqyd ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aqyf Real)
  (push 1)
    (declare-const ?aqyg Real)
    (declare-const ?aqyh Real)
    (declare-const ?aqyi Real)
    (assert
      (or (or (= ?aqyi ?aqyh)
          (= ?aqyi ?aqyg)
          )
        (= ?aqyh ?aqyg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqyj Real)
    (declare-const ?aqyk Real)
    (declare-const ?aqyl Real)
    (declare-const ?aqym Real)
    (assert
      (or (or (= ?aqym ?aqyl)
          (= ?aqym ?aqyk)
          )
        (= ?aqyl ?aqyk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqyn Real)
    (declare-const ?aqyo Real)
    (declare-const ?aqyp Real)
    (declare-const ?aqyq Real)
    (declare-const ?aqyr Real)
    (assert
      (or (or (= ?aqyr ?aqyq)
          (= ?aqyr ?aqyp)
          )
        (= ?aqyq ?aqyp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqys Real)
    (declare-const ?aqyt Real)
    (declare-const ?aqyu Real)
    (declare-const ?aqyv Real)
    (declare-const ?aqyw Real)
    (declare-const ?aqyx Real)
    (assert
      (and (and (and (not (= ?aqyu ?aqyt))
            (not (= ?aqyu ?aqys))
            )
          (not (= ?aqyt ?aqys))
          )
        (or (or (= ?aqyx ?aqyw)
            (= ?aqyx ?aqyv)
            )
          (= ?aqyw ?aqyv)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqyy Real)
    (declare-const ?aqyz Real)
    (declare-const ?aqza Real)
    (assert
      (or (or (= ?aqza ?aqyz)
          (= ?aqza ?aqyy)
          )
        (= ?aqyz ?aqyy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqzb Real)
    (declare-const ?aqzc Real)
    (declare-const ?aqzd Real)
    (assert
      (or (or (= ?aqzd ?aqzc)
          (= ?aqzd ?aqzb)
          )
        (= ?aqzc ?aqzb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqze Real)
    (declare-const ?aqzf Real)
    (declare-const ?aqzg Real)
    (declare-const ?aqzh Real)
    (assert
      (or (or (= ?aqzg ?aqzf)
          (= ?aqzg ?aqze)
          )
        (= ?aqzf ?aqze)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqzi Real)
    (declare-const ?aqzj Real)
    (declare-const ?aqzk Real)
    (declare-const ?aqzl Real)
    (declare-const ?aqzm Real)
    (assert
      (or (or (= ?aqzk ?aqzj)
          (= ?aqzk ?aqzi)
          )
        (= ?aqzj ?aqzi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqzn Real)
    (declare-const ?aqzo Real)
    (declare-const ?aqzp Real)
    (declare-const ?aqzq Real)
    (declare-const ?aqzr Real)
    (declare-const ?aqzs Real)
    (assert
      (and (or (or (= ?aqzp ?aqzo)
            (= ?aqzp ?aqzn)
            )
          (= ?aqzo ?aqzn)
          )
        (and (and (not (= ?aqzs ?aqzr))
            (not (= ?aqzs ?aqzq))
            )
          (not (= ?aqzr ?aqzq))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqzt Real)
    (declare-const ?aqzu Real)
    (declare-const ?aqzv Real)
    (assert
      (or (or (= ?aqzv ?aqzu)
          (= ?aqzv ?aqzt)
          )
        (= ?aqzu ?aqzt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aqzw Real)
    (declare-const ?aqzx Real)
    (declare-const ?aqzy Real)
    (declare-const ?aqzz Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aqzx ?aqzw))
                (not (= ?aqzx ?asi))
                )
              (not (= ?aqzw ?asi))
              )
            (or (or (= ?aqzz ?aqzy)
                (= ?aqzz ?asi)
                )
              (= ?aqzy ?asi)
              )
            )
          (and (or (or (= ?aqzx ?aqzw)
                (= ?aqzx ?asi)
                )
              (= ?aqzw ?asi)
              )
            (and (and (not (= ?aqzz ?aqzy))
                (not (= ?aqzz ?asi))
                )
              (not (= ?aqzy ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?araa Real)
    (declare-const ?arab Real)
    (declare-const ?arac Real)
    (declare-const ?arad Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?arab ?araa))
                (not (= ?arab ?fkf))
                )
              (not (= ?araa ?fkf))
              )
            (or (or (= ?arad ?arac)
                (= ?arad ?fkf)
                )
              (= ?arac ?fkf)
              )
            )
          (and (or (or (= ?arab ?araa)
                (= ?arab ?fkf)
                )
              (= ?araa ?fkf)
              )
            (and (and (not (= ?arad ?arac))
                (not (= ?arad ?fkf))
                )
              (not (= ?arac ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arae Real)
    (declare-const ?araf Real)
    (declare-const ?arag Real)
    (declare-const ?arah Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?araf ?arae))
                (not (= ?araf ?mzs))
                )
              (not (= ?arae ?mzs))
              )
            (or (or (= ?arah ?arag)
                (= ?arah ?mzs)
                )
              (= ?arag ?mzs)
              )
            )
          (and (or (or (= ?araf ?arae)
                (= ?araf ?mzs)
                )
              (= ?arae ?mzs)
              )
            (and (and (not (= ?arah ?arag))
                (not (= ?arah ?mzs))
                )
              (not (= ?arag ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arai Real)
    (declare-const ?araj Real)
    (declare-const ?arak Real)
    (declare-const ?aral Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?araj ?arai))
                (not (= ?araj ?zpl))
                )
              (not (= ?arai ?zpl))
              )
            (or (or (= ?aral ?arak)
                (= ?aral ?zpl)
                )
              (= ?arak ?zpl)
              )
            )
          (and (or (or (= ?araj ?arai)
                (= ?araj ?zpl)
                )
              (= ?arai ?zpl)
              )
            (and (and (not (= ?aral ?arak))
                (not (= ?aral ?zpl))
                )
              (not (= ?arak ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aram Real)
  (declare-const ?aran Real)
  (push 1)
    (declare-const ?arao Real)
    (declare-const ?arap Real)
    (declare-const ?araq Real)
    (assert
      (or (or (= ?araq ?arap)
          (= ?araq ?arao)
          )
        (= ?arap ?arao)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arar Real)
    (declare-const ?aras Real)
    (declare-const ?arat Real)
    (declare-const ?arau Real)
    (assert
      (or (or (= ?arau ?arat)
          (= ?arau ?aras)
          )
        (= ?arat ?aras)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arav Real)
    (declare-const ?araw Real)
    (declare-const ?arax Real)
    (declare-const ?aray Real)
    (declare-const ?araz Real)
    (assert
      (or (or (= ?araz ?aray)
          (= ?araz ?arax)
          )
        (= ?aray ?arax)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arba Real)
    (declare-const ?arbb Real)
    (declare-const ?arbc Real)
    (declare-const ?arbd Real)
    (declare-const ?arbe Real)
    (declare-const ?arbf Real)
    (assert
      (and (and (and (not (= ?arbc ?arbb))
            (not (= ?arbc ?arba))
            )
          (not (= ?arbb ?arba))
          )
        (or (or (= ?arbf ?arbe)
            (= ?arbf ?arbd)
            )
          (= ?arbe ?arbd)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arbg Real)
    (declare-const ?arbh Real)
    (declare-const ?arbi Real)
    (assert
      (or (or (= ?arbi ?arbh)
          (= ?arbi ?arbg)
          )
        (= ?arbh ?arbg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arbj Real)
    (declare-const ?arbk Real)
    (declare-const ?arbl Real)
    (assert
      (or (or (= ?arbl ?arbk)
          (= ?arbl ?arbj)
          )
        (= ?arbk ?arbj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arbm Real)
    (declare-const ?arbn Real)
    (declare-const ?arbo Real)
    (declare-const ?arbp Real)
    (assert
      (or (or (= ?arbo ?arbn)
          (= ?arbo ?arbm)
          )
        (= ?arbn ?arbm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arbq Real)
    (declare-const ?arbr Real)
    (declare-const ?arbs Real)
    (declare-const ?arbt Real)
    (declare-const ?arbu Real)
    (assert
      (or (or (= ?arbs ?arbr)
          (= ?arbs ?arbq)
          )
        (= ?arbr ?arbq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arbv Real)
    (declare-const ?arbw Real)
    (declare-const ?arbx Real)
    (declare-const ?arby Real)
    (declare-const ?arbz Real)
    (declare-const ?arca Real)
    (assert
      (and (or (or (= ?arbx ?arbw)
            (= ?arbx ?arbv)
            )
          (= ?arbw ?arbv)
          )
        (and (and (not (= ?arca ?arbz))
            (not (= ?arca ?arby))
            )
          (not (= ?arbz ?arby))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arcb Real)
    (declare-const ?arcc Real)
    (declare-const ?arcd Real)
    (assert
      (or (or (= ?arcd ?arcc)
          (= ?arcd ?arcb)
          )
        (= ?arcc ?arcb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arce Real)
    (declare-const ?arcf Real)
    (declare-const ?arcg Real)
    (declare-const ?arch Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?arcf ?arce))
                (not (= ?arcf ?asi))
                )
              (not (= ?arce ?asi))
              )
            (or (or (= ?arch ?arcg)
                (= ?arch ?asi)
                )
              (= ?arcg ?asi)
              )
            )
          (and (or (or (= ?arcf ?arce)
                (= ?arcf ?asi)
                )
              (= ?arce ?asi)
              )
            (and (and (not (= ?arch ?arcg))
                (not (= ?arch ?asi))
                )
              (not (= ?arcg ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arci Real)
    (declare-const ?arcj Real)
    (declare-const ?arck Real)
    (declare-const ?arcl Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?arcj ?arci))
                (not (= ?arcj ?fkf))
                )
              (not (= ?arci ?fkf))
              )
            (or (or (= ?arcl ?arck)
                (= ?arcl ?fkf)
                )
              (= ?arck ?fkf)
              )
            )
          (and (or (or (= ?arcj ?arci)
                (= ?arcj ?fkf)
                )
              (= ?arci ?fkf)
              )
            (and (and (not (= ?arcl ?arck))
                (not (= ?arcl ?fkf))
                )
              (not (= ?arck ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arcm Real)
    (declare-const ?arcn Real)
    (declare-const ?arco Real)
    (declare-const ?arcp Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?arcn ?arcm))
                (not (= ?arcn ?mzs))
                )
              (not (= ?arcm ?mzs))
              )
            (or (or (= ?arcp ?arco)
                (= ?arcp ?mzs)
                )
              (= ?arco ?mzs)
              )
            )
          (and (or (or (= ?arcn ?arcm)
                (= ?arcn ?mzs)
                )
              (= ?arcm ?mzs)
              )
            (and (and (not (= ?arcp ?arco))
                (not (= ?arcp ?mzs))
                )
              (not (= ?arco ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arcq Real)
    (declare-const ?arcr Real)
    (declare-const ?arcs Real)
    (declare-const ?arct Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?arcr ?arcq))
                (not (= ?arcr ?zpl))
                )
              (not (= ?arcq ?zpl))
              )
            (or (or (= ?arct ?arcs)
                (= ?arct ?zpl)
                )
              (= ?arcs ?zpl)
              )
            )
          (and (or (or (= ?arcr ?arcq)
                (= ?arcr ?zpl)
                )
              (= ?arcq ?zpl)
              )
            (and (and (not (= ?arct ?arcs))
                (not (= ?arct ?zpl))
                )
              (not (= ?arcs ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (assert
    (or (or (or (or (or (or (or (exists ((?akfl Real) (?akfk Real) )(and (not (= ?akfl ?akfk))
                      (exists ((?akfm Real) )(and (not (= ?akfm ?akfl))
                          (and (not (= ?akfm ?akfk))
                            (exists ((?akfp Real) (?akfo Real) (?akfn Real) )(and (or (or (= ?akfp ?akfo)
                                    (= ?akfp ?akfn)
                                    )
                                  (= ?akfo ?akfn)
                                  )
                                (and (or (or (or (= ?akfm ?akfl)
                                        (= ?akfm ?akfk)
                                        )
                                      (= ?akfl ?akfk)
                                      )
                                    (and (and (not (= ?akfp ?akfo))
                                        (not (= ?akfp ?akfn))
                                        )
                                      (not (= ?akfo ?akfn))
                                      )
                                    )
                                  (or (and (and (not (= ?akfm ?akfl))
                                        (not (= ?akfm ?akfk))
                                        )
                                      (not (= ?akfl ?akfk))
                                      )
                                    (or (or (= ?akfp ?akfo)
                                        (= ?akfp ?akfn)
                                        )
                                      (= ?akfo ?akfn)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?aknr Real) (?aknq Real) )(and (not (= ?aknr ?aknq))
                      (exists ((?akns Real) )(and (or (or (= ?akns ?aknr)
                              (= ?akns ?aknq)
                              )
                            (= ?aknr ?aknq)
                            )
                          (and (not (= ?akns ?aknr))
                            (not (= ?akns ?aknq))
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?aluh Real) (?alug Real) (?aluf Real) )(and (or (or (= ?aluh ?alug)
                        (= ?aluh ?aluf)
                        )
                      (= ?alug ?aluf)
                      )
                    (exists ((?aluj Real) (?alui Real) )(and (not (= ?aluj ?alui))
                        (exists ((?aluk Real) )(and (not (= ?aluk ?aluj))
                            (and (not (= ?aluk ?alui))
                              (and (or (or (or (= ?aluh ?alug)
                                      (= ?aluh ?aluf)
                                      )
                                    (= ?alug ?aluf)
                                    )
                                  (and (and (not (= ?aluk ?aluj))
                                      (not (= ?aluk ?alui))
                                      )
                                    (not (= ?aluj ?alui))
                                    )
                                  )
                                (or (and (and (not (= ?aluh ?alug))
                                      (not (= ?aluh ?aluf))
                                      )
                                    (not (= ?alug ?aluf))
                                    )
                                  (or (or (= ?aluk ?aluj)
                                      (= ?aluk ?alui)
                                      )
                                    (= ?aluj ?alui)
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (exists ((?amcm Real) (?amcl Real) )(and (not (= ?amcm ?amcl))
                  (exists ((?amcn Real) )(and (or (or (= ?amcn ?amcm)
                          (= ?amcn ?amcl)
                          )
                        (= ?amcm ?amcl)
                        )
                      (and (not (= ?amcn ?amcm))
                        (not (= ?amcn ?amcl))
                        )
                      )
                    )
                  )
                )
              )
            (exists ((?amtw Real) (?amtx Real) (?amty Real) (?amtz Real) )(and (exists ((?asi Real) )(or (and (and (and (not (= ?amtx ?amtw))
                          (not (= ?amtx ?asi))
                          )
                        (not (= ?amtw ?asi))
                        )
                      (or (or (= ?amtz ?amty)
                          (= ?amtz ?asi)
                          )
                        (= ?amty ?asi)
                        )
                      )
                    (and (or (or (= ?amtx ?amtw)
                          (= ?amtx ?asi)
                          )
                        (= ?amtw ?asi)
                        )
                      (and (and (not (= ?amtz ?amty))
                          (not (= ?amtz ?asi))
                          )
                        (not (= ?amty ?asi))
                        )
                      )
                    )
                  )
                (and (and (and (forall ((?asi Real) )(and (or (or (or (= ?amtx ?amtw)
                                (= ?amtx ?asi)
                                )
                              (= ?amtw ?asi)
                              )
                            (and (and (not (= ?amtz ?amty))
                                (not (= ?amtz ?asi))
                                )
                              (not (= ?amty ?asi))
                              )
                            )
                          (or (and (and (not (= ?amtx ?amtw))
                                (not (= ?amtx ?asi))
                                )
                              (not (= ?amtw ?asi))
                              )
                            (or (or (= ?amtz ?amty)
                                (= ?amtz ?asi)
                                )
                              (= ?amty ?asi)
                              )
                            )
                          )
                        )
                      (forall ((?fkf Real) )(and (or (or (or (= ?amtx ?amtw)
                                (= ?amtx ?fkf)
                                )
                              (= ?amtw ?fkf)
                              )
                            (and (and (not (= ?amtz ?amty))
                                (not (= ?amtz ?fkf))
                                )
                              (not (= ?amty ?fkf))
                              )
                            )
                          (or (and (and (not (= ?amtx ?amtw))
                                (not (= ?amtx ?fkf))
                                )
                              (not (= ?amtw ?fkf))
                              )
                            (or (or (= ?amtz ?amty)
                                (= ?amtz ?fkf)
                                )
                              (= ?amty ?fkf)
                              )
                            )
                          )
                        )
                      )
                    (forall ((?mzs Real) )(and (or (or (or (= ?amtx ?amtw)
                              (= ?amtx ?mzs)
                              )
                            (= ?amtw ?mzs)
                            )
                          (and (and (not (= ?amtz ?amty))
                              (not (= ?amtz ?mzs))
                              )
                            (not (= ?amty ?mzs))
                            )
                          )
                        (or (and (and (not (= ?amtx ?amtw))
                              (not (= ?amtx ?mzs))
                              )
                            (not (= ?amtw ?mzs))
                            )
                          (or (or (= ?amtz ?amty)
                              (= ?amtz ?mzs)
                              )
                            (= ?amty ?mzs)
                            )
                          )
                        )
                      )
                    )
                  (forall ((?zpl Real) )(and (or (or (or (= ?amtx ?amtw)
                            (= ?amtx ?zpl)
                            )
                          (= ?amtw ?zpl)
                          )
                        (and (and (not (= ?amtz ?amty))
                            (not (= ?amtz ?zpl))
                            )
                          (not (= ?amty ?zpl))
                          )
                        )
                      (or (and (and (not (= ?amtx ?amtw))
                            (not (= ?amtx ?zpl))
                            )
                          (not (= ?amtw ?zpl))
                          )
                        (or (or (= ?amtz ?amty)
                            (= ?amtz ?zpl)
                            )
                          (= ?amty ?zpl)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (exists ((?aogh Real) (?aogi Real) (?aogj Real) (?aogk Real) )(and (exists ((?fkf Real) )(or (and (and (and (not (= ?aogi ?aogh))
                        (not (= ?aogi ?fkf))
                        )
                      (not (= ?aogh ?fkf))
                      )
                    (or (or (= ?aogk ?aogj)
                        (= ?aogk ?fkf)
                        )
                      (= ?aogj ?fkf)
                      )
                    )
                  (and (or (or (= ?aogi ?aogh)
                        (= ?aogi ?fkf)
                        )
                      (= ?aogh ?fkf)
                      )
                    (and (and (not (= ?aogk ?aogj))
                        (not (= ?aogk ?fkf))
                        )
                      (not (= ?aogj ?fkf))
                      )
                    )
                  )
                )
              (and (and (and (forall ((?asi Real) )(and (or (or (or (= ?aogi ?aogh)
                              (= ?aogi ?asi)
                              )
                            (= ?aogh ?asi)
                            )
                          (and (and (not (= ?aogk ?aogj))
                              (not (= ?aogk ?asi))
                              )
                            (not (= ?aogj ?asi))
                            )
                          )
                        (or (and (and (not (= ?aogi ?aogh))
                              (not (= ?aogi ?asi))
                              )
                            (not (= ?aogh ?asi))
                            )
                          (or (or (= ?aogk ?aogj)
                              (= ?aogk ?asi)
                              )
                            (= ?aogj ?asi)
                            )
                          )
                        )
                      )
                    (forall ((?fkf Real) )(and (or (or (or (= ?aogi ?aogh)
                              (= ?aogi ?fkf)
                              )
                            (= ?aogh ?fkf)
                            )
                          (and (and (not (= ?aogk ?aogj))
                              (not (= ?aogk ?fkf))
                              )
                            (not (= ?aogj ?fkf))
                            )
                          )
                        (or (and (and (not (= ?aogi ?aogh))
                              (not (= ?aogi ?fkf))
                              )
                            (not (= ?aogh ?fkf))
                            )
                          (or (or (= ?aogk ?aogj)
                              (= ?aogk ?fkf)
                              )
                            (= ?aogj ?fkf)
                            )
                          )
                        )
                      )
                    )
                  (forall ((?mzs Real) )(and (or (or (or (= ?aogi ?aogh)
                            (= ?aogi ?mzs)
                            )
                          (= ?aogh ?mzs)
                          )
                        (and (and (not (= ?aogk ?aogj))
                            (not (= ?aogk ?mzs))
                            )
                          (not (= ?aogj ?mzs))
                          )
                        )
                      (or (and (and (not (= ?aogi ?aogh))
                            (not (= ?aogi ?mzs))
                            )
                          (not (= ?aogh ?mzs))
                          )
                        (or (or (= ?aogk ?aogj)
                            (= ?aogk ?mzs)
                            )
                          (= ?aogj ?mzs)
                          )
                        )
                      )
                    )
                  )
                (forall ((?zpl Real) )(and (or (or (or (= ?aogi ?aogh)
                          (= ?aogi ?zpl)
                          )
                        (= ?aogh ?zpl)
                        )
                      (and (and (not (= ?aogk ?aogj))
                          (not (= ?aogk ?zpl))
                          )
                        (not (= ?aogj ?zpl))
                        )
                      )
                    (or (and (and (not (= ?aogi ?aogh))
                          (not (= ?aogi ?zpl))
                          )
                        (not (= ?aogh ?zpl))
                        )
                      (or (or (= ?aogk ?aogj)
                          (= ?aogk ?zpl)
                          )
                        (= ?aogj ?zpl)
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (exists ((?aqby Real) (?aqbz Real) (?aqca Real) (?aqcb Real) )(and (exists ((?mzs Real) )(or (and (and (and (not (= ?aqbz ?aqby))
                      (not (= ?aqbz ?mzs))
                      )
                    (not (= ?aqby ?mzs))
                    )
                  (or (or (= ?aqcb ?aqca)
                      (= ?aqcb ?mzs)
                      )
                    (= ?aqca ?mzs)
                    )
                  )
                (and (or (or (= ?aqbz ?aqby)
                      (= ?aqbz ?mzs)
                      )
                    (= ?aqby ?mzs)
                    )
                  (and (and (not (= ?aqcb ?aqca))
                      (not (= ?aqcb ?mzs))
                      )
                    (not (= ?aqca ?mzs))
                    )
                  )
                )
              )
            (and (and (and (forall ((?asi Real) )(and (or (or (or (= ?aqbz ?aqby)
                            (= ?aqbz ?asi)
                            )
                          (= ?aqby ?asi)
                          )
                        (and (and (not (= ?aqcb ?aqca))
                            (not (= ?aqcb ?asi))
                            )
                          (not (= ?aqca ?asi))
                          )
                        )
                      (or (and (and (not (= ?aqbz ?aqby))
                            (not (= ?aqbz ?asi))
                            )
                          (not (= ?aqby ?asi))
                          )
                        (or (or (= ?aqcb ?aqca)
                            (= ?aqcb ?asi)
                            )
                          (= ?aqca ?asi)
                          )
                        )
                      )
                    )
                  (forall ((?fkf Real) )(and (or (or (or (= ?aqbz ?aqby)
                            (= ?aqbz ?fkf)
                            )
                          (= ?aqby ?fkf)
                          )
                        (and (and (not (= ?aqcb ?aqca))
                            (not (= ?aqcb ?fkf))
                            )
                          (not (= ?aqca ?fkf))
                          )
                        )
                      (or (and (and (not (= ?aqbz ?aqby))
                            (not (= ?aqbz ?fkf))
                            )
                          (not (= ?aqby ?fkf))
                          )
                        (or (or (= ?aqcb ?aqca)
                            (= ?aqcb ?fkf)
                            )
                          (= ?aqca ?fkf)
                          )
                        )
                      )
                    )
                  )
                (forall ((?mzs Real) )(and (or (or (or (= ?aqbz ?aqby)
                          (= ?aqbz ?mzs)
                          )
                        (= ?aqby ?mzs)
                        )
                      (and (and (not (= ?aqcb ?aqca))
                          (not (= ?aqcb ?mzs))
                          )
                        (not (= ?aqca ?mzs))
                        )
                      )
                    (or (and (and (not (= ?aqbz ?aqby))
                          (not (= ?aqbz ?mzs))
                          )
                        (not (= ?aqby ?mzs))
                        )
                      (or (or (= ?aqcb ?aqca)
                          (= ?aqcb ?mzs)
                          )
                        (= ?aqca ?mzs)
                        )
                      )
                    )
                  )
                )
              (forall ((?zpl Real) )(and (or (or (or (= ?aqbz ?aqby)
                        (= ?aqbz ?zpl)
                        )
                      (= ?aqby ?zpl)
                      )
                    (and (and (not (= ?aqcb ?aqca))
                        (not (= ?aqcb ?zpl))
                        )
                      (not (= ?aqca ?zpl))
                      )
                    )
                  (or (and (and (not (= ?aqbz ?aqby))
                        (not (= ?aqbz ?zpl))
                        )
                      (not (= ?aqby ?zpl))
                      )
                    (or (or (= ?aqcb ?aqca)
                        (= ?aqcb ?zpl)
                        )
                      (= ?aqca ?zpl)
                      )
                    )
                  )
                )
              )
            )
          )
        )
      (or (or (or (or (or (or (or (exists ((?abnb Real) (?abna Real) )(and (not (= ?abnb ?abna))
                        (exists ((?abnc Real) )(and (not (= ?abnc ?abnb))
                            (and (not (= ?abnc ?abna))
                              (exists ((?abnf Real) (?abne Real) (?abnd Real) )(and (or (or (= ?abnf ?abne)
                                      (= ?abnf ?abnd)
                                      )
                                    (= ?abne ?abnd)
                                    )
                                  (and (or (or (or (= ?abnc ?abnb)
                                          (= ?abnc ?abna)
                                          )
                                        (= ?abnb ?abna)
                                        )
                                      (and (and (not (= ?abnf ?abne))
                                          (not (= ?abnf ?abnd))
                                          )
                                        (not (= ?abne ?abnd))
                                        )
                                      )
                                    (or (and (and (not (= ?abnc ?abnb))
                                          (not (= ?abnc ?abna))
                                          )
                                        (not (= ?abnb ?abna))
                                        )
                                      (or (or (= ?abnf ?abne)
                                          (= ?abnf ?abnd)
                                          )
                                        (= ?abne ?abnd)
                                        )
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    (exists ((?abtl Real) (?abtk Real) )(and (not (= ?abtl ?abtk))
                        (exists ((?abtm Real) )(and (or (or (= ?abtm ?abtl)
                                (= ?abtm ?abtk)
                                )
                              (= ?abtl ?abtk)
                              )
                            (and (not (= ?abtm ?abtl))
                              (not (= ?abtm ?abtk))
                              )
                            )
                          )
                        )
                      )
                    )
                  (exists ((?acsr Real) (?acsq Real) (?acsp Real) )(and (or (or (= ?acsr ?acsq)
                          (= ?acsr ?acsp)
                          )
                        (= ?acsq ?acsp)
                        )
                      (exists ((?acst Real) (?acss Real) )(and (not (= ?acst ?acss))
                          (exists ((?acsu Real) )(and (not (= ?acsu ?acst))
                              (and (not (= ?acsu ?acss))
                                (and (or (or (or (= ?acsr ?acsq)
                                        (= ?acsr ?acsp)
                                        )
                                      (= ?acsq ?acsp)
                                      )
                                    (and (and (not (= ?acsu ?acst))
                                        (not (= ?acsu ?acss))
                                        )
                                      (not (= ?acst ?acss))
                                      )
                                    )
                                  (or (and (and (not (= ?acsr ?acsq))
                                        (not (= ?acsr ?acsp))
                                        )
                                      (not (= ?acsq ?acsp))
                                      )
                                    (or (or (= ?acsu ?acst)
                                        (= ?acsu ?acss)
                                        )
                                      (= ?acst ?acss)
                                      )
                                    )
                                  )
                                )
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                (exists ((?acza Real) (?acyz Real) )(and (not (= ?acza ?acyz))
                    (exists ((?aczb Real) )(and (or (or (= ?aczb ?acza)
                            (= ?aczb ?acyz)
                            )
                          (= ?acza ?acyz)
                          )
                        (and (not (= ?aczb ?acza))
                          (not (= ?aczb ?acyz))
                          )
                        )
                      )
                    )
                  )
                )
              (exists ((?adny Real) (?adnz Real) (?adoa Real) (?adob Real) )(and (exists ((?asi Real) )(or (and (and (and (not (= ?adnz ?adny))
                            (not (= ?adnz ?asi))
                            )
                          (not (= ?adny ?asi))
                          )
                        (or (or (= ?adob ?adoa)
                            (= ?adob ?asi)
                            )
                          (= ?adoa ?asi)
                          )
                        )
                      (and (or (or (= ?adnz ?adny)
                            (= ?adnz ?asi)
                            )
                          (= ?adny ?asi)
                          )
                        (and (and (not (= ?adob ?adoa))
                            (not (= ?adob ?asi))
                            )
                          (not (= ?adoa ?asi))
                          )
                        )
                      )
                    )
                  (and (and (forall ((?asi Real) )(and (or (or (or (= ?adnz ?adny)
                                (= ?adnz ?asi)
                                )
                              (= ?adny ?asi)
                              )
                            (and (and (not (= ?adob ?adoa))
                                (not (= ?adob ?asi))
                                )
                              (not (= ?adoa ?asi))
                              )
                            )
                          (or (and (and (not (= ?adnz ?adny))
                                (not (= ?adnz ?asi))
                                )
                              (not (= ?adny ?asi))
                              )
                            (or (or (= ?adob ?adoa)
                                (= ?adob ?asi)
                                )
                              (= ?adoa ?asi)
                              )
                            )
                          )
                        )
                      (forall ((?fkf Real) )(and (or (or (or (= ?adnz ?adny)
                                (= ?adnz ?fkf)
                                )
                              (= ?adny ?fkf)
                              )
                            (and (and (not (= ?adob ?adoa))
                                (not (= ?adob ?fkf))
                                )
                              (not (= ?adoa ?fkf))
                              )
                            )
                          (or (and (and (not (= ?adnz ?adny))
                                (not (= ?adnz ?fkf))
                                )
                              (not (= ?adny ?fkf))
                              )
                            (or (or (= ?adob ?adoa)
                                (= ?adob ?fkf)
                                )
                              (= ?adoa ?fkf)
                              )
                            )
                          )
                        )
                      )
                    (forall ((?mzs Real) )(and (or (or (or (= ?adnz ?adny)
                              (= ?adnz ?mzs)
                              )
                            (= ?adny ?mzs)
                            )
                          (and (and (not (= ?adob ?adoa))
                              (not (= ?adob ?mzs))
                              )
                            (not (= ?adoa ?mzs))
                            )
                          )
                        (or (and (and (not (= ?adnz ?adny))
                              (not (= ?adnz ?mzs))
                              )
                            (not (= ?adny ?mzs))
                            )
                          (or (or (= ?adob ?adoa)
                              (= ?adob ?mzs)
                              )
                            (= ?adoa ?mzs)
                            )
                          )
                        )
                      )
                    )
                  )
                )
              )
            (exists ((?aewn Real) (?aewo Real) (?aewp Real) (?aewq Real) )(and (exists ((?fkf Real) )(or (and (and (and (not (= ?aewo ?aewn))
                          (not (= ?aewo ?fkf))
                          )
                        (not (= ?aewn ?fkf))
                        )
                      (or (or (= ?aewq ?aewp)
                          (= ?aewq ?fkf)
                          )
                        (= ?aewp ?fkf)
                        )
                      )
                    (and (or (or (= ?aewo ?aewn)
                          (= ?aewo ?fkf)
                          )
                        (= ?aewn ?fkf)
                        )
                      (and (and (not (= ?aewq ?aewp))
                          (not (= ?aewq ?fkf))
                          )
                        (not (= ?aewp ?fkf))
                        )
                      )
                    )
                  )
                (and (and (forall ((?asi Real) )(and (or (or (or (= ?aewo ?aewn)
                              (= ?aewo ?asi)
                              )
                            (= ?aewn ?asi)
                            )
                          (and (and (not (= ?aewq ?aewp))
                              (not (= ?aewq ?asi))
                              )
                            (not (= ?aewp ?asi))
                            )
                          )
                        (or (and (and (not (= ?aewo ?aewn))
                              (not (= ?aewo ?asi))
                              )
                            (not (= ?aewn ?asi))
                            )
                          (or (or (= ?aewq ?aewp)
                              (= ?aewq ?asi)
                              )
                            (= ?aewp ?asi)
                            )
                          )
                        )
                      )
                    (forall ((?fkf Real) )(and (or (or (or (= ?aewo ?aewn)
                              (= ?aewo ?fkf)
                              )
                            (= ?aewn ?fkf)
                            )
                          (and (and (not (= ?aewq ?aewp))
                              (not (= ?aewq ?fkf))
                              )
                            (not (= ?aewp ?fkf))
                            )
                          )
                        (or (and (and (not (= ?aewo ?aewn))
                              (not (= ?aewo ?fkf))
                              )
                            (not (= ?aewn ?fkf))
                            )
                          (or (or (= ?aewq ?aewp)
                              (= ?aewq ?fkf)
                              )
                            (= ?aewp ?fkf)
                            )
                          )
                        )
                      )
                    )
                  (forall ((?mzs Real) )(and (or (or (or (= ?aewo ?aewn)
                            (= ?aewo ?mzs)
                            )
                          (= ?aewn ?mzs)
                          )
                        (and (and (not (= ?aewq ?aewp))
                            (not (= ?aewq ?mzs))
                            )
                          (not (= ?aewp ?mzs))
                          )
                        )
                      (or (and (and (not (= ?aewo ?aewn))
                            (not (= ?aewo ?mzs))
                            )
                          (not (= ?aewn ?mzs))
                          )
                        (or (or (= ?aewq ?aewp)
                            (= ?aewq ?mzs)
                            )
                          (= ?aewp ?mzs)
                          )
                        )
                      )
                    )
                  )
                )
              )
            )
          (exists ((?agns Real) (?agnt Real) (?agnu Real) (?agnv Real) )(and (exists ((?mzs Real) )(or (and (and (and (not (= ?agnt ?agns))
                        (not (= ?agnt ?mzs))
                        )
                      (not (= ?agns ?mzs))
                      )
                    (or (or (= ?agnv ?agnu)
                        (= ?agnv ?mzs)
                        )
                      (= ?agnu ?mzs)
                      )
                    )
                  (and (or (or (= ?agnt ?agns)
                        (= ?agnt ?mzs)
                        )
                      (= ?agns ?mzs)
                      )
                    (and (and (not (= ?agnv ?agnu))
                        (not (= ?agnv ?mzs))
                        )
                      (not (= ?agnu ?mzs))
                      )
                    )
                  )
                )
              (and (and (forall ((?asi Real) )(and (or (or (or (= ?agnt ?agns)
                            (= ?agnt ?asi)
                            )
                          (= ?agns ?asi)
                          )
                        (and (and (not (= ?agnv ?agnu))
                            (not (= ?agnv ?asi))
                            )
                          (not (= ?agnu ?asi))
                          )
                        )
                      (or (and (and (not (= ?agnt ?agns))
                            (not (= ?agnt ?asi))
                            )
                          (not (= ?agns ?asi))
                          )
                        (or (or (= ?agnv ?agnu)
                            (= ?agnv ?asi)
                            )
                          (= ?agnu ?asi)
                          )
                        )
                      )
                    )
                  (forall ((?fkf Real) )(and (or (or (or (= ?agnt ?agns)
                            (= ?agnt ?fkf)
                            )
                          (= ?agns ?fkf)
                          )
                        (and (and (not (= ?agnv ?agnu))
                            (not (= ?agnv ?fkf))
                            )
                          (not (= ?agnu ?fkf))
                          )
                        )
                      (or (and (and (not (= ?agnt ?agns))
                            (not (= ?agnt ?fkf))
                            )
                          (not (= ?agns ?fkf))
                          )
                        (or (or (= ?agnv ?agnu)
                            (= ?agnv ?fkf)
                            )
                          (= ?agnu ?fkf)
                          )
                        )
                      )
                    )
                  )
                (forall ((?mzs Real) )(and (or (or (or (= ?agnt ?agns)
                          (= ?agnt ?mzs)
                          )
                        (= ?agns ?mzs)
                        )
                      (and (and (not (= ?agnv ?agnu))
                          (not (= ?agnv ?mzs))
                          )
                        (not (= ?agnu ?mzs))
                        )
                      )
                    (or (and (and (not (= ?agnt ?agns))
                          (not (= ?agnt ?mzs))
                          )
                        (not (= ?agns ?mzs))
                        )
                      (or (or (= ?agnv ?agnu)
                          (= ?agnv ?mzs)
                          )
                        (= ?agnu ?mzs)
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        (exists ((?aije Real) (?aijf Real) (?aijg Real) (?aijh Real) )(and (exists ((?zpl Real) )(or (and (and (and (not (= ?aijf ?aije))
                      (not (= ?aijf ?zpl))
                      )
                    (not (= ?aije ?zpl))
                    )
                  (or (or (= ?aijh ?aijg)
                      (= ?aijh ?zpl)
                      )
                    (= ?aijg ?zpl)
                    )
                  )
                (and (or (or (= ?aijf ?aije)
                      (= ?aijf ?zpl)
                      )
                    (= ?aije ?zpl)
                    )
                  (and (and (not (= ?aijh ?aijg))
                      (not (= ?aijh ?zpl))
                      )
                    (not (= ?aijg ?zpl))
                    )
                  )
                )
              )
            (and (and (forall ((?asi Real) )(and (or (or (or (= ?aijf ?aije)
                          (= ?aijf ?asi)
                          )
                        (= ?aije ?asi)
                        )
                      (and (and (not (= ?aijh ?aijg))
                          (not (= ?aijh ?asi))
                          )
                        (not (= ?aijg ?asi))
                        )
                      )
                    (or (and (and (not (= ?aijf ?aije))
                          (not (= ?aijf ?asi))
                          )
                        (not (= ?aije ?asi))
                        )
                      (or (or (= ?aijh ?aijg)
                          (= ?aijh ?asi)
                          )
                        (= ?aijg ?asi)
                        )
                      )
                    )
                  )
                (forall ((?fkf Real) )(and (or (or (or (= ?aijf ?aije)
                          (= ?aijf ?fkf)
                          )
                        (= ?aije ?fkf)
                        )
                      (and (and (not (= ?aijh ?aijg))
                          (not (= ?aijh ?fkf))
                          )
                        (not (= ?aijg ?fkf))
                        )
                      )
                    (or (and (and (not (= ?aijf ?aije))
                          (not (= ?aijf ?fkf))
                          )
                        (not (= ?aije ?fkf))
                        )
                      (or (or (= ?aijh ?aijg)
                          (= ?aijh ?fkf)
                          )
                        (= ?aijg ?fkf)
                        )
                      )
                    )
                  )
                )
              (forall ((?mzs Real) )(and (or (or (or (= ?aijf ?aije)
                        (= ?aijf ?mzs)
                        )
                      (= ?aije ?mzs)
                      )
                    (and (and (not (= ?aijh ?aijg))
                        (not (= ?aijh ?mzs))
                        )
                      (not (= ?aijg ?mzs))
                      )
                    )
                  (or (and (and (not (= ?aijf ?aije))
                        (not (= ?aijf ?mzs))
                        )
                      (not (= ?aije ?mzs))
                      )
                    (or (or (= ?aijh ?aijg)
                        (= ?aijh ?mzs)
                        )
                      (= ?aijg ?mzs)
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?arcu Real)
  (declare-const ?arcv Real)
  (declare-const ?arcw Real)
  (assert
    (or (or (= ?arcw ?arcv)
        (= ?arcw ?arcu)
        )
      (= ?arcv ?arcu)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?arcx Real)
  (declare-const ?arcy Real)
  (declare-const ?arcz Real)
  (declare-const ?arda Real)
  (assert
    (or (or (= ?arda ?arcz)
        (= ?arda ?arcy)
        )
      (= ?arcz ?arcy)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?ardb Real)
  (declare-const ?ardc Real)
  (declare-const ?ardd Real)
  (declare-const ?arde Real)
  (declare-const ?ardf Real)
  (assert
    (or (or (= ?ardf ?arde)
        (= ?ardf ?ardd)
        )
      (= ?arde ?ardd)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?ardg Real)
  (declare-const ?ardh Real)
  (declare-const ?ardi Real)
  (declare-const ?ardj Real)
  (declare-const ?ardk Real)
  (declare-const ?ardl Real)
  (assert
    (and (and (and (not (= ?ardi ?ardh))
          (not (= ?ardi ?ardg))
          )
        (not (= ?ardh ?ardg))
        )
      (or (or (= ?ardl ?ardk)
          (= ?ardl ?ardj)
          )
        (= ?ardk ?ardj)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?ardm Real)
  (declare-const ?ardn Real)
  (declare-const ?ardo Real)
  (assert
    (or (or (= ?ardo ?ardn)
        (= ?ardo ?ardm)
        )
      (= ?ardn ?ardm)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?ardp Real)
  (declare-const ?ardq Real)
  (declare-const ?ardr Real)
  (assert
    (or (or (= ?ardr ?ardq)
        (= ?ardr ?ardp)
        )
      (= ?ardq ?ardp)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?ards Real)
  (declare-const ?ardt Real)
  (declare-const ?ardu Real)
  (declare-const ?ardv Real)
  (assert
    (or (or (= ?ardu ?ardt)
        (= ?ardu ?ards)
        )
      (= ?ardt ?ards)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?ardw Real)
  (declare-const ?ardx Real)
  (declare-const ?ardy Real)
  (declare-const ?ardz Real)
  (declare-const ?area Real)
  (assert
    (or (or (= ?ardy ?ardx)
        (= ?ardy ?ardw)
        )
      (= ?ardx ?ardw)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?areb Real)
  (declare-const ?arec Real)
  (declare-const ?ared Real)
  (declare-const ?aree Real)
  (declare-const ?aref Real)
  (declare-const ?areg Real)
  (assert
    (and (or (or (= ?ared ?arec)
          (= ?ared ?areb)
          )
        (= ?arec ?areb)
        )
      (and (and (not (= ?areg ?aref))
          (not (= ?areg ?aree))
          )
        (not (= ?aref ?aree))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?areh Real)
  (declare-const ?arei Real)
  (declare-const ?arej Real)
  (assert
    (or (or (= ?arej ?arei)
        (= ?arej ?areh)
        )
      (= ?arei ?areh)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?arek Real)
  (declare-const ?arel Real)
  (declare-const ?arem Real)
  (declare-const ?aren Real)
  (assert
    (exists ((?asi Real) )(or (and (and (and (not (= ?arel ?arek))
              (not (= ?arel ?asi))
              )
            (not (= ?arek ?asi))
            )
          (or (or (= ?aren ?arem)
              (= ?aren ?asi)
              )
            (= ?arem ?asi)
            )
          )
        (and (or (or (= ?arel ?arek)
              (= ?arel ?asi)
              )
            (= ?arek ?asi)
            )
          (and (and (not (= ?aren ?arem))
              (not (= ?aren ?asi))
              )
            (not (= ?arem ?asi))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?areo Real)
  (declare-const ?arep Real)
  (declare-const ?areq Real)
  (declare-const ?arer Real)
  (assert
    (exists ((?fkf Real) )(or (and (and (and (not (= ?arep ?areo))
              (not (= ?arep ?fkf))
              )
            (not (= ?areo ?fkf))
            )
          (or (or (= ?arer ?areq)
              (= ?arer ?fkf)
              )
            (= ?areq ?fkf)
            )
          )
        (and (or (or (= ?arep ?areo)
              (= ?arep ?fkf)
              )
            (= ?areo ?fkf)
            )
          (and (and (not (= ?arer ?areq))
              (not (= ?arer ?fkf))
              )
            (not (= ?areq ?fkf))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?ares Real)
  (declare-const ?aret Real)
  (declare-const ?areu Real)
  (declare-const ?arev Real)
  (assert
    (exists ((?mzs Real) )(or (and (and (and (not (= ?aret ?ares))
              (not (= ?aret ?mzs))
              )
            (not (= ?ares ?mzs))
            )
          (or (or (= ?arev ?areu)
              (= ?arev ?mzs)
              )
            (= ?areu ?mzs)
            )
          )
        (and (or (or (= ?aret ?ares)
              (= ?aret ?mzs)
              )
            (= ?ares ?mzs)
            )
          (and (and (not (= ?arev ?areu))
              (not (= ?arev ?mzs))
              )
            (not (= ?areu ?mzs))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?arew Real)
  (declare-const ?arex Real)
  (declare-const ?arey Real)
  (declare-const ?arez Real)
  (assert
    (exists ((?zpl Real) )(or (and (and (and (not (= ?arex ?arew))
              (not (= ?arex ?zpl))
              )
            (not (= ?arew ?zpl))
            )
          (or (or (= ?arez ?arey)
              (= ?arez ?zpl)
              )
            (= ?arey ?zpl)
            )
          )
        (and (or (or (= ?arex ?arew)
              (= ?arex ?zpl)
              )
            (= ?arew ?zpl)
            )
          (and (and (not (= ?arez ?arey))
              (not (= ?arez ?zpl))
              )
            (not (= ?arey ?zpl))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?arfa Real)
    (declare-const ?arfb Real)
    (declare-const ?arfc Real)
    (assert
      (or (or (= ?arfc ?arfb)
          (= ?arfc ?arfa)
          )
        (= ?arfb ?arfa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arfd Real)
    (declare-const ?arfe Real)
    (declare-const ?arff Real)
    (declare-const ?arfg Real)
    (assert
      (or (or (= ?arfg ?arff)
          (= ?arfg ?arfe)
          )
        (= ?arff ?arfe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arfh Real)
    (declare-const ?arfi Real)
    (declare-const ?arfj Real)
    (declare-const ?arfk Real)
    (declare-const ?arfl Real)
    (assert
      (or (or (= ?arfl ?arfk)
          (= ?arfl ?arfj)
          )
        (= ?arfk ?arfj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arfm Real)
    (declare-const ?arfn Real)
    (declare-const ?arfo Real)
    (declare-const ?arfp Real)
    (declare-const ?arfq Real)
    (declare-const ?arfr Real)
    (assert
      (and (and (and (not (= ?arfo ?arfn))
            (not (= ?arfo ?arfm))
            )
          (not (= ?arfn ?arfm))
          )
        (or (or (= ?arfr ?arfq)
            (= ?arfr ?arfp)
            )
          (= ?arfq ?arfp)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arfs Real)
    (declare-const ?arft Real)
    (declare-const ?arfu Real)
    (assert
      (or (or (= ?arfu ?arft)
          (= ?arfu ?arfs)
          )
        (= ?arft ?arfs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arfv Real)
    (declare-const ?arfw Real)
    (declare-const ?arfx Real)
    (assert
      (or (or (= ?arfx ?arfw)
          (= ?arfx ?arfv)
          )
        (= ?arfw ?arfv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arfy Real)
    (declare-const ?arfz Real)
    (declare-const ?arga Real)
    (declare-const ?argb Real)
    (assert
      (or (or (= ?arga ?arfz)
          (= ?arga ?arfy)
          )
        (= ?arfz ?arfy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?argc Real)
    (declare-const ?argd Real)
    (declare-const ?arge Real)
    (declare-const ?argf Real)
    (declare-const ?argg Real)
    (assert
      (or (or (= ?arge ?argd)
          (= ?arge ?argc)
          )
        (= ?argd ?argc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?argh Real)
    (declare-const ?argi Real)
    (declare-const ?argj Real)
    (declare-const ?argk Real)
    (declare-const ?argl Real)
    (declare-const ?argm Real)
    (assert
      (and (or (or (= ?argj ?argi)
            (= ?argj ?argh)
            )
          (= ?argi ?argh)
          )
        (and (and (not (= ?argm ?argl))
            (not (= ?argm ?argk))
            )
          (not (= ?argl ?argk))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?argn Real)
    (declare-const ?argo Real)
    (declare-const ?argp Real)
    (assert
      (or (or (= ?argp ?argo)
          (= ?argp ?argn)
          )
        (= ?argo ?argn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?argq Real)
    (declare-const ?argr Real)
    (declare-const ?args Real)
    (declare-const ?argt Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?argr ?argq))
                (not (= ?argr ?asi))
                )
              (not (= ?argq ?asi))
              )
            (or (or (= ?argt ?args)
                (= ?argt ?asi)
                )
              (= ?args ?asi)
              )
            )
          (and (or (or (= ?argr ?argq)
                (= ?argr ?asi)
                )
              (= ?argq ?asi)
              )
            (and (and (not (= ?argt ?args))
                (not (= ?argt ?asi))
                )
              (not (= ?args ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?argu Real)
    (declare-const ?argv Real)
    (declare-const ?argw Real)
    (declare-const ?argx Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?argv ?argu))
                (not (= ?argv ?fkf))
                )
              (not (= ?argu ?fkf))
              )
            (or (or (= ?argx ?argw)
                (= ?argx ?fkf)
                )
              (= ?argw ?fkf)
              )
            )
          (and (or (or (= ?argv ?argu)
                (= ?argv ?fkf)
                )
              (= ?argu ?fkf)
              )
            (and (and (not (= ?argx ?argw))
                (not (= ?argx ?fkf))
                )
              (not (= ?argw ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?argy Real)
    (declare-const ?argz Real)
    (declare-const ?arha Real)
    (declare-const ?arhb Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?argz ?argy))
                (not (= ?argz ?mzs))
                )
              (not (= ?argy ?mzs))
              )
            (or (or (= ?arhb ?arha)
                (= ?arhb ?mzs)
                )
              (= ?arha ?mzs)
              )
            )
          (and (or (or (= ?argz ?argy)
                (= ?argz ?mzs)
                )
              (= ?argy ?mzs)
              )
            (and (and (not (= ?arhb ?arha))
                (not (= ?arhb ?mzs))
                )
              (not (= ?arha ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arhc Real)
    (declare-const ?arhd Real)
    (declare-const ?arhe Real)
    (declare-const ?arhf Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?arhd ?arhc))
                (not (= ?arhd ?zpl))
                )
              (not (= ?arhc ?zpl))
              )
            (or (or (= ?arhf ?arhe)
                (= ?arhf ?zpl)
                )
              (= ?arhe ?zpl)
              )
            )
          (and (or (or (= ?arhd ?arhc)
                (= ?arhd ?zpl)
                )
              (= ?arhc ?zpl)
              )
            (and (and (not (= ?arhf ?arhe))
                (not (= ?arhf ?zpl))
                )
              (not (= ?arhe ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?arhg Real)
  (push 1)
    (declare-const ?arhh Real)
    (declare-const ?arhi Real)
    (declare-const ?arhj Real)
    (assert
      (or (or (= ?arhj ?arhi)
          (= ?arhj ?arhh)
          )
        (= ?arhi ?arhh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arhk Real)
    (declare-const ?arhl Real)
    (declare-const ?arhm Real)
    (declare-const ?arhn Real)
    (assert
      (or (or (= ?arhn ?arhm)
          (= ?arhn ?arhl)
          )
        (= ?arhm ?arhl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arho Real)
    (declare-const ?arhp Real)
    (declare-const ?arhq Real)
    (declare-const ?arhr Real)
    (declare-const ?arhs Real)
    (assert
      (or (or (= ?arhs ?arhr)
          (= ?arhs ?arhq)
          )
        (= ?arhr ?arhq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arht Real)
    (declare-const ?arhu Real)
    (declare-const ?arhv Real)
    (declare-const ?arhw Real)
    (declare-const ?arhx Real)
    (declare-const ?arhy Real)
    (assert
      (and (and (and (not (= ?arhv ?arhu))
            (not (= ?arhv ?arht))
            )
          (not (= ?arhu ?arht))
          )
        (or (or (= ?arhy ?arhx)
            (= ?arhy ?arhw)
            )
          (= ?arhx ?arhw)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arhz Real)
    (declare-const ?aria Real)
    (declare-const ?arib Real)
    (assert
      (or (or (= ?arib ?aria)
          (= ?arib ?arhz)
          )
        (= ?aria ?arhz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aric Real)
    (declare-const ?arid Real)
    (declare-const ?arie Real)
    (assert
      (or (or (= ?arie ?arid)
          (= ?arie ?aric)
          )
        (= ?arid ?aric)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arif Real)
    (declare-const ?arig Real)
    (declare-const ?arih Real)
    (declare-const ?arii Real)
    (assert
      (or (or (= ?arih ?arig)
          (= ?arih ?arif)
          )
        (= ?arig ?arif)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arij Real)
    (declare-const ?arik Real)
    (declare-const ?aril Real)
    (declare-const ?arim Real)
    (declare-const ?arin Real)
    (assert
      (or (or (= ?aril ?arik)
          (= ?aril ?arij)
          )
        (= ?arik ?arij)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ario Real)
    (declare-const ?arip Real)
    (declare-const ?ariq Real)
    (declare-const ?arir Real)
    (declare-const ?aris Real)
    (declare-const ?arit Real)
    (assert
      (and (or (or (= ?ariq ?arip)
            (= ?ariq ?ario)
            )
          (= ?arip ?ario)
          )
        (and (and (not (= ?arit ?aris))
            (not (= ?arit ?arir))
            )
          (not (= ?aris ?arir))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ariu Real)
    (declare-const ?ariv Real)
    (declare-const ?ariw Real)
    (assert
      (or (or (= ?ariw ?ariv)
          (= ?ariw ?ariu)
          )
        (= ?ariv ?ariu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arix Real)
    (declare-const ?ariy Real)
    (declare-const ?ariz Real)
    (declare-const ?arja Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?ariy ?arix))
                (not (= ?ariy ?asi))
                )
              (not (= ?arix ?asi))
              )
            (or (or (= ?arja ?ariz)
                (= ?arja ?asi)
                )
              (= ?ariz ?asi)
              )
            )
          (and (or (or (= ?ariy ?arix)
                (= ?ariy ?asi)
                )
              (= ?arix ?asi)
              )
            (and (and (not (= ?arja ?ariz))
                (not (= ?arja ?asi))
                )
              (not (= ?ariz ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arjb Real)
    (declare-const ?arjc Real)
    (declare-const ?arjd Real)
    (declare-const ?arje Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?arjc ?arjb))
                (not (= ?arjc ?fkf))
                )
              (not (= ?arjb ?fkf))
              )
            (or (or (= ?arje ?arjd)
                (= ?arje ?fkf)
                )
              (= ?arjd ?fkf)
              )
            )
          (and (or (or (= ?arjc ?arjb)
                (= ?arjc ?fkf)
                )
              (= ?arjb ?fkf)
              )
            (and (and (not (= ?arje ?arjd))
                (not (= ?arje ?fkf))
                )
              (not (= ?arjd ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arjf Real)
    (declare-const ?arjg Real)
    (declare-const ?arjh Real)
    (declare-const ?arji Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?arjg ?arjf))
                (not (= ?arjg ?mzs))
                )
              (not (= ?arjf ?mzs))
              )
            (or (or (= ?arji ?arjh)
                (= ?arji ?mzs)
                )
              (= ?arjh ?mzs)
              )
            )
          (and (or (or (= ?arjg ?arjf)
                (= ?arjg ?mzs)
                )
              (= ?arjf ?mzs)
              )
            (and (and (not (= ?arji ?arjh))
                (not (= ?arji ?mzs))
                )
              (not (= ?arjh ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arjj Real)
    (declare-const ?arjk Real)
    (declare-const ?arjl Real)
    (declare-const ?arjm Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?arjk ?arjj))
                (not (= ?arjk ?zpl))
                )
              (not (= ?arjj ?zpl))
              )
            (or (or (= ?arjm ?arjl)
                (= ?arjm ?zpl)
                )
              (= ?arjl ?zpl)
              )
            )
          (and (or (or (= ?arjk ?arjj)
                (= ?arjk ?zpl)
                )
              (= ?arjj ?zpl)
              )
            (and (and (not (= ?arjm ?arjl))
                (not (= ?arjm ?zpl))
                )
              (not (= ?arjl ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?arjn Real)
  (declare-const ?arjo Real)
  (push 1)
    (declare-const ?arjp Real)
    (declare-const ?arjq Real)
    (declare-const ?arjr Real)
    (assert
      (or (or (= ?arjr ?arjq)
          (= ?arjr ?arjp)
          )
        (= ?arjq ?arjp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arjs Real)
    (declare-const ?arjt Real)
    (declare-const ?arju Real)
    (declare-const ?arjv Real)
    (assert
      (or (or (= ?arjv ?arju)
          (= ?arjv ?arjt)
          )
        (= ?arju ?arjt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arjw Real)
    (declare-const ?arjx Real)
    (declare-const ?arjy Real)
    (declare-const ?arjz Real)
    (declare-const ?arka Real)
    (assert
      (or (or (= ?arka ?arjz)
          (= ?arka ?arjy)
          )
        (= ?arjz ?arjy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arkb Real)
    (declare-const ?arkc Real)
    (declare-const ?arkd Real)
    (declare-const ?arke Real)
    (declare-const ?arkf Real)
    (declare-const ?arkg Real)
    (assert
      (and (and (and (not (= ?arkd ?arkc))
            (not (= ?arkd ?arkb))
            )
          (not (= ?arkc ?arkb))
          )
        (or (or (= ?arkg ?arkf)
            (= ?arkg ?arke)
            )
          (= ?arkf ?arke)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arkh Real)
    (declare-const ?arki Real)
    (declare-const ?arkj Real)
    (assert
      (or (or (= ?arkj ?arki)
          (= ?arkj ?arkh)
          )
        (= ?arki ?arkh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arkk Real)
    (declare-const ?arkl Real)
    (declare-const ?arkm Real)
    (assert
      (or (or (= ?arkm ?arkl)
          (= ?arkm ?arkk)
          )
        (= ?arkl ?arkk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arkn Real)
    (declare-const ?arko Real)
    (declare-const ?arkp Real)
    (declare-const ?arkq Real)
    (assert
      (or (or (= ?arkp ?arko)
          (= ?arkp ?arkn)
          )
        (= ?arko ?arkn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arkr Real)
    (declare-const ?arks Real)
    (declare-const ?arkt Real)
    (declare-const ?arku Real)
    (declare-const ?arkv Real)
    (assert
      (or (or (= ?arkt ?arks)
          (= ?arkt ?arkr)
          )
        (= ?arks ?arkr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arkw Real)
    (declare-const ?arkx Real)
    (declare-const ?arky Real)
    (declare-const ?arkz Real)
    (declare-const ?arla Real)
    (declare-const ?arlb Real)
    (assert
      (and (or (or (= ?arky ?arkx)
            (= ?arky ?arkw)
            )
          (= ?arkx ?arkw)
          )
        (and (and (not (= ?arlb ?arla))
            (not (= ?arlb ?arkz))
            )
          (not (= ?arla ?arkz))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arlc Real)
    (declare-const ?arld Real)
    (declare-const ?arle Real)
    (assert
      (or (or (= ?arle ?arld)
          (= ?arle ?arlc)
          )
        (= ?arld ?arlc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arlf Real)
    (declare-const ?arlg Real)
    (declare-const ?arlh Real)
    (declare-const ?arli Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?arlg ?arlf))
                (not (= ?arlg ?asi))
                )
              (not (= ?arlf ?asi))
              )
            (or (or (= ?arli ?arlh)
                (= ?arli ?asi)
                )
              (= ?arlh ?asi)
              )
            )
          (and (or (or (= ?arlg ?arlf)
                (= ?arlg ?asi)
                )
              (= ?arlf ?asi)
              )
            (and (and (not (= ?arli ?arlh))
                (not (= ?arli ?asi))
                )
              (not (= ?arlh ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arlj Real)
    (declare-const ?arlk Real)
    (declare-const ?arll Real)
    (declare-const ?arlm Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?arlk ?arlj))
                (not (= ?arlk ?fkf))
                )
              (not (= ?arlj ?fkf))
              )
            (or (or (= ?arlm ?arll)
                (= ?arlm ?fkf)
                )
              (= ?arll ?fkf)
              )
            )
          (and (or (or (= ?arlk ?arlj)
                (= ?arlk ?fkf)
                )
              (= ?arlj ?fkf)
              )
            (and (and (not (= ?arlm ?arll))
                (not (= ?arlm ?fkf))
                )
              (not (= ?arll ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arln Real)
    (declare-const ?arlo Real)
    (declare-const ?arlp Real)
    (declare-const ?arlq Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?arlo ?arln))
                (not (= ?arlo ?mzs))
                )
              (not (= ?arln ?mzs))
              )
            (or (or (= ?arlq ?arlp)
                (= ?arlq ?mzs)
                )
              (= ?arlp ?mzs)
              )
            )
          (and (or (or (= ?arlo ?arln)
                (= ?arlo ?mzs)
                )
              (= ?arln ?mzs)
              )
            (and (and (not (= ?arlq ?arlp))
                (not (= ?arlq ?mzs))
                )
              (not (= ?arlp ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arlr Real)
    (declare-const ?arls Real)
    (declare-const ?arlt Real)
    (declare-const ?arlu Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?arls ?arlr))
                (not (= ?arls ?zpl))
                )
              (not (= ?arlr ?zpl))
              )
            (or (or (= ?arlu ?arlt)
                (= ?arlu ?zpl)
                )
              (= ?arlt ?zpl)
              )
            )
          (and (or (or (= ?arls ?arlr)
                (= ?arls ?zpl)
                )
              (= ?arlr ?zpl)
              )
            (and (and (not (= ?arlu ?arlt))
                (not (= ?arlu ?zpl))
                )
              (not (= ?arlt ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?arlv Real)
  (declare-const ?arlw Real)
  (declare-const ?arlx Real)
  (push 1)
    (declare-const ?arly Real)
    (declare-const ?arlz Real)
    (declare-const ?arma Real)
    (assert
      (or (or (= ?arma ?arlz)
          (= ?arma ?arly)
          )
        (= ?arlz ?arly)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?armb Real)
    (declare-const ?armc Real)
    (declare-const ?armd Real)
    (declare-const ?arme Real)
    (assert
      (or (or (= ?arme ?armd)
          (= ?arme ?armc)
          )
        (= ?armd ?armc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?armf Real)
    (declare-const ?armg Real)
    (declare-const ?armh Real)
    (declare-const ?armi Real)
    (declare-const ?armj Real)
    (assert
      (or (or (= ?armj ?armi)
          (= ?armj ?armh)
          )
        (= ?armi ?armh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?armk Real)
    (declare-const ?arml Real)
    (declare-const ?armm Real)
    (declare-const ?armn Real)
    (declare-const ?armo Real)
    (declare-const ?armp Real)
    (assert
      (and (and (and (not (= ?armm ?arml))
            (not (= ?armm ?armk))
            )
          (not (= ?arml ?armk))
          )
        (or (or (= ?armp ?armo)
            (= ?armp ?armn)
            )
          (= ?armo ?armn)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?armq Real)
    (declare-const ?armr Real)
    (declare-const ?arms Real)
    (assert
      (or (or (= ?arms ?armr)
          (= ?arms ?armq)
          )
        (= ?armr ?armq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?armt Real)
    (declare-const ?armu Real)
    (declare-const ?armv Real)
    (assert
      (or (or (= ?armv ?armu)
          (= ?armv ?armt)
          )
        (= ?armu ?armt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?armw Real)
    (declare-const ?armx Real)
    (declare-const ?army Real)
    (declare-const ?armz Real)
    (assert
      (or (or (= ?army ?armx)
          (= ?army ?armw)
          )
        (= ?armx ?armw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arna Real)
    (declare-const ?arnb Real)
    (declare-const ?arnc Real)
    (declare-const ?arnd Real)
    (declare-const ?arne Real)
    (assert
      (or (or (= ?arnc ?arnb)
          (= ?arnc ?arna)
          )
        (= ?arnb ?arna)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arnf Real)
    (declare-const ?arng Real)
    (declare-const ?arnh Real)
    (declare-const ?arni Real)
    (declare-const ?arnj Real)
    (declare-const ?arnk Real)
    (assert
      (and (or (or (= ?arnh ?arng)
            (= ?arnh ?arnf)
            )
          (= ?arng ?arnf)
          )
        (and (and (not (= ?arnk ?arnj))
            (not (= ?arnk ?arni))
            )
          (not (= ?arnj ?arni))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arnl Real)
    (declare-const ?arnm Real)
    (declare-const ?arnn Real)
    (assert
      (or (or (= ?arnn ?arnm)
          (= ?arnn ?arnl)
          )
        (= ?arnm ?arnl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arno Real)
    (declare-const ?arnp Real)
    (declare-const ?arnq Real)
    (declare-const ?arnr Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?arnp ?arno))
                (not (= ?arnp ?asi))
                )
              (not (= ?arno ?asi))
              )
            (or (or (= ?arnr ?arnq)
                (= ?arnr ?asi)
                )
              (= ?arnq ?asi)
              )
            )
          (and (or (or (= ?arnp ?arno)
                (= ?arnp ?asi)
                )
              (= ?arno ?asi)
              )
            (and (and (not (= ?arnr ?arnq))
                (not (= ?arnr ?asi))
                )
              (not (= ?arnq ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arns Real)
    (declare-const ?arnt Real)
    (declare-const ?arnu Real)
    (declare-const ?arnv Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?arnt ?arns))
                (not (= ?arnt ?fkf))
                )
              (not (= ?arns ?fkf))
              )
            (or (or (= ?arnv ?arnu)
                (= ?arnv ?fkf)
                )
              (= ?arnu ?fkf)
              )
            )
          (and (or (or (= ?arnt ?arns)
                (= ?arnt ?fkf)
                )
              (= ?arns ?fkf)
              )
            (and (and (not (= ?arnv ?arnu))
                (not (= ?arnv ?fkf))
                )
              (not (= ?arnu ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arnw Real)
    (declare-const ?arnx Real)
    (declare-const ?arny Real)
    (declare-const ?arnz Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?arnx ?arnw))
                (not (= ?arnx ?mzs))
                )
              (not (= ?arnw ?mzs))
              )
            (or (or (= ?arnz ?arny)
                (= ?arnz ?mzs)
                )
              (= ?arny ?mzs)
              )
            )
          (and (or (or (= ?arnx ?arnw)
                (= ?arnx ?mzs)
                )
              (= ?arnw ?mzs)
              )
            (and (and (not (= ?arnz ?arny))
                (not (= ?arnz ?mzs))
                )
              (not (= ?arny ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aroa Real)
    (declare-const ?arob Real)
    (declare-const ?aroc Real)
    (declare-const ?arod Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?arob ?aroa))
                (not (= ?arob ?zpl))
                )
              (not (= ?aroa ?zpl))
              )
            (or (or (= ?arod ?aroc)
                (= ?arod ?zpl)
                )
              (= ?aroc ?zpl)
              )
            )
          (and (or (or (= ?arob ?aroa)
                (= ?arob ?zpl)
                )
              (= ?aroa ?zpl)
              )
            (and (and (not (= ?arod ?aroc))
                (not (= ?arod ?zpl))
                )
              (not (= ?aroc ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?aroe Real)
    (declare-const ?arof Real)
    (declare-const ?arog Real)
    (assert
      (or (or (= ?arog ?arof)
          (= ?arog ?aroe)
          )
        (= ?arof ?aroe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aroh Real)
    (declare-const ?aroi Real)
    (declare-const ?aroj Real)
    (declare-const ?arok Real)
    (assert
      (or (or (= ?arok ?aroj)
          (= ?arok ?aroi)
          )
        (= ?aroj ?aroi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arol Real)
    (declare-const ?arom Real)
    (declare-const ?aron Real)
    (declare-const ?aroo Real)
    (declare-const ?arop Real)
    (assert
      (or (or (= ?arop ?aroo)
          (= ?arop ?aron)
          )
        (= ?aroo ?aron)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aroq Real)
    (declare-const ?aror Real)
    (declare-const ?aros Real)
    (declare-const ?arot Real)
    (declare-const ?arou Real)
    (declare-const ?arov Real)
    (assert
      (and (and (and (not (= ?aros ?aror))
            (not (= ?aros ?aroq))
            )
          (not (= ?aror ?aroq))
          )
        (or (or (= ?arov ?arou)
            (= ?arov ?arot)
            )
          (= ?arou ?arot)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arow Real)
    (declare-const ?arox Real)
    (declare-const ?aroy Real)
    (assert
      (or (or (= ?aroy ?arox)
          (= ?aroy ?arow)
          )
        (= ?arox ?arow)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aroz Real)
    (declare-const ?arpa Real)
    (declare-const ?arpb Real)
    (assert
      (or (or (= ?arpb ?arpa)
          (= ?arpb ?aroz)
          )
        (= ?arpa ?aroz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arpc Real)
    (declare-const ?arpd Real)
    (declare-const ?arpe Real)
    (declare-const ?arpf Real)
    (assert
      (or (or (= ?arpe ?arpd)
          (= ?arpe ?arpc)
          )
        (= ?arpd ?arpc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arpg Real)
    (declare-const ?arph Real)
    (declare-const ?arpi Real)
    (declare-const ?arpj Real)
    (declare-const ?arpk Real)
    (assert
      (or (or (= ?arpi ?arph)
          (= ?arpi ?arpg)
          )
        (= ?arph ?arpg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arpl Real)
    (declare-const ?arpm Real)
    (declare-const ?arpn Real)
    (declare-const ?arpo Real)
    (declare-const ?arpp Real)
    (declare-const ?arpq Real)
    (assert
      (and (or (or (= ?arpn ?arpm)
            (= ?arpn ?arpl)
            )
          (= ?arpm ?arpl)
          )
        (and (and (not (= ?arpq ?arpp))
            (not (= ?arpq ?arpo))
            )
          (not (= ?arpp ?arpo))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arpr Real)
    (declare-const ?arps Real)
    (declare-const ?arpt Real)
    (assert
      (or (or (= ?arpt ?arps)
          (= ?arpt ?arpr)
          )
        (= ?arps ?arpr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arpu Real)
    (declare-const ?arpv Real)
    (declare-const ?arpw Real)
    (declare-const ?arpx Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?arpv ?arpu))
                (not (= ?arpv ?asi))
                )
              (not (= ?arpu ?asi))
              )
            (or (or (= ?arpx ?arpw)
                (= ?arpx ?asi)
                )
              (= ?arpw ?asi)
              )
            )
          (and (or (or (= ?arpv ?arpu)
                (= ?arpv ?asi)
                )
              (= ?arpu ?asi)
              )
            (and (and (not (= ?arpx ?arpw))
                (not (= ?arpx ?asi))
                )
              (not (= ?arpw ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arpy Real)
    (declare-const ?arpz Real)
    (declare-const ?arqa Real)
    (declare-const ?arqb Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?arpz ?arpy))
                (not (= ?arpz ?fkf))
                )
              (not (= ?arpy ?fkf))
              )
            (or (or (= ?arqb ?arqa)
                (= ?arqb ?fkf)
                )
              (= ?arqa ?fkf)
              )
            )
          (and (or (or (= ?arpz ?arpy)
                (= ?arpz ?fkf)
                )
              (= ?arpy ?fkf)
              )
            (and (and (not (= ?arqb ?arqa))
                (not (= ?arqb ?fkf))
                )
              (not (= ?arqa ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arqc Real)
    (declare-const ?arqd Real)
    (declare-const ?arqe Real)
    (declare-const ?arqf Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?arqd ?arqc))
                (not (= ?arqd ?mzs))
                )
              (not (= ?arqc ?mzs))
              )
            (or (or (= ?arqf ?arqe)
                (= ?arqf ?mzs)
                )
              (= ?arqe ?mzs)
              )
            )
          (and (or (or (= ?arqd ?arqc)
                (= ?arqd ?mzs)
                )
              (= ?arqc ?mzs)
              )
            (and (and (not (= ?arqf ?arqe))
                (not (= ?arqf ?mzs))
                )
              (not (= ?arqe ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arqg Real)
    (declare-const ?arqh Real)
    (declare-const ?arqi Real)
    (declare-const ?arqj Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?arqh ?arqg))
                (not (= ?arqh ?zpl))
                )
              (not (= ?arqg ?zpl))
              )
            (or (or (= ?arqj ?arqi)
                (= ?arqj ?zpl)
                )
              (= ?arqi ?zpl)
              )
            )
          (and (or (or (= ?arqh ?arqg)
                (= ?arqh ?zpl)
                )
              (= ?arqg ?zpl)
              )
            (and (and (not (= ?arqj ?arqi))
                (not (= ?arqj ?zpl))
                )
              (not (= ?arqi ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?arqk Real)
  (push 1)
    (declare-const ?arql Real)
    (declare-const ?arqm Real)
    (declare-const ?arqn Real)
    (assert
      (or (or (= ?arqn ?arqm)
          (= ?arqn ?arql)
          )
        (= ?arqm ?arql)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arqo Real)
    (declare-const ?arqp Real)
    (declare-const ?arqq Real)
    (declare-const ?arqr Real)
    (assert
      (or (or (= ?arqr ?arqq)
          (= ?arqr ?arqp)
          )
        (= ?arqq ?arqp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arqs Real)
    (declare-const ?arqt Real)
    (declare-const ?arqu Real)
    (declare-const ?arqv Real)
    (declare-const ?arqw Real)
    (assert
      (or (or (= ?arqw ?arqv)
          (= ?arqw ?arqu)
          )
        (= ?arqv ?arqu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arqx Real)
    (declare-const ?arqy Real)
    (declare-const ?arqz Real)
    (declare-const ?arra Real)
    (declare-const ?arrb Real)
    (declare-const ?arrc Real)
    (assert
      (and (and (and (not (= ?arqz ?arqy))
            (not (= ?arqz ?arqx))
            )
          (not (= ?arqy ?arqx))
          )
        (or (or (= ?arrc ?arrb)
            (= ?arrc ?arra)
            )
          (= ?arrb ?arra)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arrd Real)
    (declare-const ?arre Real)
    (declare-const ?arrf Real)
    (assert
      (or (or (= ?arrf ?arre)
          (= ?arrf ?arrd)
          )
        (= ?arre ?arrd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arrg Real)
    (declare-const ?arrh Real)
    (declare-const ?arri Real)
    (assert
      (or (or (= ?arri ?arrh)
          (= ?arri ?arrg)
          )
        (= ?arrh ?arrg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arrj Real)
    (declare-const ?arrk Real)
    (declare-const ?arrl Real)
    (declare-const ?arrm Real)
    (assert
      (or (or (= ?arrl ?arrk)
          (= ?arrl ?arrj)
          )
        (= ?arrk ?arrj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arrn Real)
    (declare-const ?arro Real)
    (declare-const ?arrp Real)
    (declare-const ?arrq Real)
    (declare-const ?arrr Real)
    (assert
      (or (or (= ?arrp ?arro)
          (= ?arrp ?arrn)
          )
        (= ?arro ?arrn)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arrs Real)
    (declare-const ?arrt Real)
    (declare-const ?arru Real)
    (declare-const ?arrv Real)
    (declare-const ?arrw Real)
    (declare-const ?arrx Real)
    (assert
      (and (or (or (= ?arru ?arrt)
            (= ?arru ?arrs)
            )
          (= ?arrt ?arrs)
          )
        (and (and (not (= ?arrx ?arrw))
            (not (= ?arrx ?arrv))
            )
          (not (= ?arrw ?arrv))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arry Real)
    (declare-const ?arrz Real)
    (declare-const ?arsa Real)
    (assert
      (or (or (= ?arsa ?arrz)
          (= ?arsa ?arry)
          )
        (= ?arrz ?arry)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arsb Real)
    (declare-const ?arsc Real)
    (declare-const ?arsd Real)
    (declare-const ?arse Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?arsc ?arsb))
                (not (= ?arsc ?asi))
                )
              (not (= ?arsb ?asi))
              )
            (or (or (= ?arse ?arsd)
                (= ?arse ?asi)
                )
              (= ?arsd ?asi)
              )
            )
          (and (or (or (= ?arsc ?arsb)
                (= ?arsc ?asi)
                )
              (= ?arsb ?asi)
              )
            (and (and (not (= ?arse ?arsd))
                (not (= ?arse ?asi))
                )
              (not (= ?arsd ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arsf Real)
    (declare-const ?arsg Real)
    (declare-const ?arsh Real)
    (declare-const ?arsi Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?arsg ?arsf))
                (not (= ?arsg ?fkf))
                )
              (not (= ?arsf ?fkf))
              )
            (or (or (= ?arsi ?arsh)
                (= ?arsi ?fkf)
                )
              (= ?arsh ?fkf)
              )
            )
          (and (or (or (= ?arsg ?arsf)
                (= ?arsg ?fkf)
                )
              (= ?arsf ?fkf)
              )
            (and (and (not (= ?arsi ?arsh))
                (not (= ?arsi ?fkf))
                )
              (not (= ?arsh ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arsj Real)
    (declare-const ?arsk Real)
    (declare-const ?arsl Real)
    (declare-const ?arsm Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?arsk ?arsj))
                (not (= ?arsk ?mzs))
                )
              (not (= ?arsj ?mzs))
              )
            (or (or (= ?arsm ?arsl)
                (= ?arsm ?mzs)
                )
              (= ?arsl ?mzs)
              )
            )
          (and (or (or (= ?arsk ?arsj)
                (= ?arsk ?mzs)
                )
              (= ?arsj ?mzs)
              )
            (and (and (not (= ?arsm ?arsl))
                (not (= ?arsm ?mzs))
                )
              (not (= ?arsl ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arsn Real)
    (declare-const ?arso Real)
    (declare-const ?arsp Real)
    (declare-const ?arsq Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?arso ?arsn))
                (not (= ?arso ?zpl))
                )
              (not (= ?arsn ?zpl))
              )
            (or (or (= ?arsq ?arsp)
                (= ?arsq ?zpl)
                )
              (= ?arsp ?zpl)
              )
            )
          (and (or (or (= ?arso ?arsn)
                (= ?arso ?zpl)
                )
              (= ?arsn ?zpl)
              )
            (and (and (not (= ?arsq ?arsp))
                (not (= ?arsq ?zpl))
                )
              (not (= ?arsp ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?arsr Real)
  (declare-const ?arss Real)
  (push 1)
    (declare-const ?arst Real)
    (declare-const ?arsu Real)
    (declare-const ?arsv Real)
    (assert
      (or (or (= ?arsv ?arsu)
          (= ?arsv ?arst)
          )
        (= ?arsu ?arst)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arsw Real)
    (declare-const ?arsx Real)
    (declare-const ?arsy Real)
    (declare-const ?arsz Real)
    (assert
      (or (or (= ?arsz ?arsy)
          (= ?arsz ?arsx)
          )
        (= ?arsy ?arsx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arta Real)
    (declare-const ?artb Real)
    (declare-const ?artc Real)
    (declare-const ?artd Real)
    (declare-const ?arte Real)
    (assert
      (or (or (= ?arte ?artd)
          (= ?arte ?artc)
          )
        (= ?artd ?artc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?artf Real)
    (declare-const ?artg Real)
    (declare-const ?arth Real)
    (declare-const ?arti Real)
    (declare-const ?artj Real)
    (declare-const ?artk Real)
    (assert
      (and (and (and (not (= ?arth ?artg))
            (not (= ?arth ?artf))
            )
          (not (= ?artg ?artf))
          )
        (or (or (= ?artk ?artj)
            (= ?artk ?arti)
            )
          (= ?artj ?arti)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?artl Real)
    (declare-const ?artm Real)
    (declare-const ?artn Real)
    (assert
      (or (or (= ?artn ?artm)
          (= ?artn ?artl)
          )
        (= ?artm ?artl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arto Real)
    (declare-const ?artp Real)
    (declare-const ?artq Real)
    (assert
      (or (or (= ?artq ?artp)
          (= ?artq ?arto)
          )
        (= ?artp ?arto)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?artr Real)
    (declare-const ?arts Real)
    (declare-const ?artt Real)
    (declare-const ?artu Real)
    (assert
      (or (or (= ?artt ?arts)
          (= ?artt ?artr)
          )
        (= ?arts ?artr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?artv Real)
    (declare-const ?artw Real)
    (declare-const ?artx Real)
    (declare-const ?arty Real)
    (declare-const ?artz Real)
    (assert
      (or (or (= ?artx ?artw)
          (= ?artx ?artv)
          )
        (= ?artw ?artv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arua Real)
    (declare-const ?arub Real)
    (declare-const ?aruc Real)
    (declare-const ?arud Real)
    (declare-const ?arue Real)
    (declare-const ?aruf Real)
    (assert
      (and (or (or (= ?aruc ?arub)
            (= ?aruc ?arua)
            )
          (= ?arub ?arua)
          )
        (and (and (not (= ?aruf ?arue))
            (not (= ?aruf ?arud))
            )
          (not (= ?arue ?arud))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arug Real)
    (declare-const ?aruh Real)
    (declare-const ?arui Real)
    (assert
      (or (or (= ?arui ?aruh)
          (= ?arui ?arug)
          )
        (= ?aruh ?arug)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aruj Real)
    (declare-const ?aruk Real)
    (declare-const ?arul Real)
    (declare-const ?arum Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aruk ?aruj))
                (not (= ?aruk ?asi))
                )
              (not (= ?aruj ?asi))
              )
            (or (or (= ?arum ?arul)
                (= ?arum ?asi)
                )
              (= ?arul ?asi)
              )
            )
          (and (or (or (= ?aruk ?aruj)
                (= ?aruk ?asi)
                )
              (= ?aruj ?asi)
              )
            (and (and (not (= ?arum ?arul))
                (not (= ?arum ?asi))
                )
              (not (= ?arul ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arun Real)
    (declare-const ?aruo Real)
    (declare-const ?arup Real)
    (declare-const ?aruq Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aruo ?arun))
                (not (= ?aruo ?fkf))
                )
              (not (= ?arun ?fkf))
              )
            (or (or (= ?aruq ?arup)
                (= ?aruq ?fkf)
                )
              (= ?arup ?fkf)
              )
            )
          (and (or (or (= ?aruo ?arun)
                (= ?aruo ?fkf)
                )
              (= ?arun ?fkf)
              )
            (and (and (not (= ?aruq ?arup))
                (not (= ?aruq ?fkf))
                )
              (not (= ?arup ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arur Real)
    (declare-const ?arus Real)
    (declare-const ?arut Real)
    (declare-const ?aruu Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?arus ?arur))
                (not (= ?arus ?mzs))
                )
              (not (= ?arur ?mzs))
              )
            (or (or (= ?aruu ?arut)
                (= ?aruu ?mzs)
                )
              (= ?arut ?mzs)
              )
            )
          (and (or (or (= ?arus ?arur)
                (= ?arus ?mzs)
                )
              (= ?arur ?mzs)
              )
            (and (and (not (= ?aruu ?arut))
                (not (= ?aruu ?mzs))
                )
              (not (= ?arut ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aruv Real)
    (declare-const ?aruw Real)
    (declare-const ?arux Real)
    (declare-const ?aruy Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?aruw ?aruv))
                (not (= ?aruw ?zpl))
                )
              (not (= ?aruv ?zpl))
              )
            (or (or (= ?aruy ?arux)
                (= ?aruy ?zpl)
                )
              (= ?arux ?zpl)
              )
            )
          (and (or (or (= ?aruw ?aruv)
                (= ?aruw ?zpl)
                )
              (= ?aruv ?zpl)
              )
            (and (and (not (= ?aruy ?arux))
                (not (= ?aruy ?zpl))
                )
              (not (= ?arux ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aruz Real)
  (declare-const ?arva Real)
  (declare-const ?arvb Real)
  (push 1)
    (declare-const ?arvc Real)
    (declare-const ?arvd Real)
    (declare-const ?arve Real)
    (assert
      (or (or (= ?arve ?arvd)
          (= ?arve ?arvc)
          )
        (= ?arvd ?arvc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arvf Real)
    (declare-const ?arvg Real)
    (declare-const ?arvh Real)
    (declare-const ?arvi Real)
    (assert
      (or (or (= ?arvi ?arvh)
          (= ?arvi ?arvg)
          )
        (= ?arvh ?arvg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arvj Real)
    (declare-const ?arvk Real)
    (declare-const ?arvl Real)
    (declare-const ?arvm Real)
    (declare-const ?arvn Real)
    (assert
      (or (or (= ?arvn ?arvm)
          (= ?arvn ?arvl)
          )
        (= ?arvm ?arvl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arvo Real)
    (declare-const ?arvp Real)
    (declare-const ?arvq Real)
    (declare-const ?arvr Real)
    (declare-const ?arvs Real)
    (declare-const ?arvt Real)
    (assert
      (and (and (and (not (= ?arvq ?arvp))
            (not (= ?arvq ?arvo))
            )
          (not (= ?arvp ?arvo))
          )
        (or (or (= ?arvt ?arvs)
            (= ?arvt ?arvr)
            )
          (= ?arvs ?arvr)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arvu Real)
    (declare-const ?arvv Real)
    (declare-const ?arvw Real)
    (assert
      (or (or (= ?arvw ?arvv)
          (= ?arvw ?arvu)
          )
        (= ?arvv ?arvu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arvx Real)
    (declare-const ?arvy Real)
    (declare-const ?arvz Real)
    (assert
      (or (or (= ?arvz ?arvy)
          (= ?arvz ?arvx)
          )
        (= ?arvy ?arvx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arwa Real)
    (declare-const ?arwb Real)
    (declare-const ?arwc Real)
    (declare-const ?arwd Real)
    (assert
      (or (or (= ?arwc ?arwb)
          (= ?arwc ?arwa)
          )
        (= ?arwb ?arwa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arwe Real)
    (declare-const ?arwf Real)
    (declare-const ?arwg Real)
    (declare-const ?arwh Real)
    (declare-const ?arwi Real)
    (assert
      (or (or (= ?arwg ?arwf)
          (= ?arwg ?arwe)
          )
        (= ?arwf ?arwe)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arwj Real)
    (declare-const ?arwk Real)
    (declare-const ?arwl Real)
    (declare-const ?arwm Real)
    (declare-const ?arwn Real)
    (declare-const ?arwo Real)
    (assert
      (and (or (or (= ?arwl ?arwk)
            (= ?arwl ?arwj)
            )
          (= ?arwk ?arwj)
          )
        (and (and (not (= ?arwo ?arwn))
            (not (= ?arwo ?arwm))
            )
          (not (= ?arwn ?arwm))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arwp Real)
    (declare-const ?arwq Real)
    (declare-const ?arwr Real)
    (assert
      (or (or (= ?arwr ?arwq)
          (= ?arwr ?arwp)
          )
        (= ?arwq ?arwp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arws Real)
    (declare-const ?arwt Real)
    (declare-const ?arwu Real)
    (declare-const ?arwv Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?arwt ?arws))
                (not (= ?arwt ?asi))
                )
              (not (= ?arws ?asi))
              )
            (or (or (= ?arwv ?arwu)
                (= ?arwv ?asi)
                )
              (= ?arwu ?asi)
              )
            )
          (and (or (or (= ?arwt ?arws)
                (= ?arwt ?asi)
                )
              (= ?arws ?asi)
              )
            (and (and (not (= ?arwv ?arwu))
                (not (= ?arwv ?asi))
                )
              (not (= ?arwu ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arww Real)
    (declare-const ?arwx Real)
    (declare-const ?arwy Real)
    (declare-const ?arwz Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?arwx ?arww))
                (not (= ?arwx ?fkf))
                )
              (not (= ?arww ?fkf))
              )
            (or (or (= ?arwz ?arwy)
                (= ?arwz ?fkf)
                )
              (= ?arwy ?fkf)
              )
            )
          (and (or (or (= ?arwx ?arww)
                (= ?arwx ?fkf)
                )
              (= ?arww ?fkf)
              )
            (and (and (not (= ?arwz ?arwy))
                (not (= ?arwz ?fkf))
                )
              (not (= ?arwy ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arxa Real)
    (declare-const ?arxb Real)
    (declare-const ?arxc Real)
    (declare-const ?arxd Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?arxb ?arxa))
                (not (= ?arxb ?mzs))
                )
              (not (= ?arxa ?mzs))
              )
            (or (or (= ?arxd ?arxc)
                (= ?arxd ?mzs)
                )
              (= ?arxc ?mzs)
              )
            )
          (and (or (or (= ?arxb ?arxa)
                (= ?arxb ?mzs)
                )
              (= ?arxa ?mzs)
              )
            (and (and (not (= ?arxd ?arxc))
                (not (= ?arxd ?mzs))
                )
              (not (= ?arxc ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arxe Real)
    (declare-const ?arxf Real)
    (declare-const ?arxg Real)
    (declare-const ?arxh Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?arxf ?arxe))
                (not (= ?arxf ?zpl))
                )
              (not (= ?arxe ?zpl))
              )
            (or (or (= ?arxh ?arxg)
                (= ?arxh ?zpl)
                )
              (= ?arxg ?zpl)
              )
            )
          (and (or (or (= ?arxf ?arxe)
                (= ?arxf ?zpl)
                )
              (= ?arxe ?zpl)
              )
            (and (and (not (= ?arxh ?arxg))
                (not (= ?arxh ?zpl))
                )
              (not (= ?arxg ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?arxi Real)
  (declare-const ?arxj Real)
  (declare-const ?arxk Real)
  (declare-const ?arxl Real)
  (push 1)
    (declare-const ?arxm Real)
    (declare-const ?arxn Real)
    (declare-const ?arxo Real)
    (assert
      (or (or (= ?arxo ?arxn)
          (= ?arxo ?arxm)
          )
        (= ?arxn ?arxm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arxp Real)
    (declare-const ?arxq Real)
    (declare-const ?arxr Real)
    (declare-const ?arxs Real)
    (assert
      (or (or (= ?arxs ?arxr)
          (= ?arxs ?arxq)
          )
        (= ?arxr ?arxq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arxt Real)
    (declare-const ?arxu Real)
    (declare-const ?arxv Real)
    (declare-const ?arxw Real)
    (declare-const ?arxx Real)
    (assert
      (or (or (= ?arxx ?arxw)
          (= ?arxx ?arxv)
          )
        (= ?arxw ?arxv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arxy Real)
    (declare-const ?arxz Real)
    (declare-const ?arya Real)
    (declare-const ?aryb Real)
    (declare-const ?aryc Real)
    (declare-const ?aryd Real)
    (assert
      (and (and (and (not (= ?arya ?arxz))
            (not (= ?arya ?arxy))
            )
          (not (= ?arxz ?arxy))
          )
        (or (or (= ?aryd ?aryc)
            (= ?aryd ?aryb)
            )
          (= ?aryc ?aryb)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arye Real)
    (declare-const ?aryf Real)
    (declare-const ?aryg Real)
    (assert
      (or (or (= ?aryg ?aryf)
          (= ?aryg ?arye)
          )
        (= ?aryf ?arye)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aryh Real)
    (declare-const ?aryi Real)
    (declare-const ?aryj Real)
    (assert
      (or (or (= ?aryj ?aryi)
          (= ?aryj ?aryh)
          )
        (= ?aryi ?aryh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aryk Real)
    (declare-const ?aryl Real)
    (declare-const ?arym Real)
    (declare-const ?aryn Real)
    (assert
      (or (or (= ?arym ?aryl)
          (= ?arym ?aryk)
          )
        (= ?aryl ?aryk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aryo Real)
    (declare-const ?aryp Real)
    (declare-const ?aryq Real)
    (declare-const ?aryr Real)
    (declare-const ?arys Real)
    (assert
      (or (or (= ?aryq ?aryp)
          (= ?aryq ?aryo)
          )
        (= ?aryp ?aryo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aryt Real)
    (declare-const ?aryu Real)
    (declare-const ?aryv Real)
    (declare-const ?aryw Real)
    (declare-const ?aryx Real)
    (declare-const ?aryy Real)
    (assert
      (and (or (or (= ?aryv ?aryu)
            (= ?aryv ?aryt)
            )
          (= ?aryu ?aryt)
          )
        (and (and (not (= ?aryy ?aryx))
            (not (= ?aryy ?aryw))
            )
          (not (= ?aryx ?aryw))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aryz Real)
    (declare-const ?arza Real)
    (declare-const ?arzb Real)
    (assert
      (or (or (= ?arzb ?arza)
          (= ?arzb ?aryz)
          )
        (= ?arza ?aryz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arzc Real)
    (declare-const ?arzd Real)
    (declare-const ?arze Real)
    (declare-const ?arzf Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?arzd ?arzc))
                (not (= ?arzd ?asi))
                )
              (not (= ?arzc ?asi))
              )
            (or (or (= ?arzf ?arze)
                (= ?arzf ?asi)
                )
              (= ?arze ?asi)
              )
            )
          (and (or (or (= ?arzd ?arzc)
                (= ?arzd ?asi)
                )
              (= ?arzc ?asi)
              )
            (and (and (not (= ?arzf ?arze))
                (not (= ?arzf ?asi))
                )
              (not (= ?arze ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arzg Real)
    (declare-const ?arzh Real)
    (declare-const ?arzi Real)
    (declare-const ?arzj Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?arzh ?arzg))
                (not (= ?arzh ?fkf))
                )
              (not (= ?arzg ?fkf))
              )
            (or (or (= ?arzj ?arzi)
                (= ?arzj ?fkf)
                )
              (= ?arzi ?fkf)
              )
            )
          (and (or (or (= ?arzh ?arzg)
                (= ?arzh ?fkf)
                )
              (= ?arzg ?fkf)
              )
            (and (and (not (= ?arzj ?arzi))
                (not (= ?arzj ?fkf))
                )
              (not (= ?arzi ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arzk Real)
    (declare-const ?arzl Real)
    (declare-const ?arzm Real)
    (declare-const ?arzn Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?arzl ?arzk))
                (not (= ?arzl ?mzs))
                )
              (not (= ?arzk ?mzs))
              )
            (or (or (= ?arzn ?arzm)
                (= ?arzn ?mzs)
                )
              (= ?arzm ?mzs)
              )
            )
          (and (or (or (= ?arzl ?arzk)
                (= ?arzl ?mzs)
                )
              (= ?arzk ?mzs)
              )
            (and (and (not (= ?arzn ?arzm))
                (not (= ?arzn ?mzs))
                )
              (not (= ?arzm ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arzo Real)
    (declare-const ?arzp Real)
    (declare-const ?arzq Real)
    (declare-const ?arzr Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?arzp ?arzo))
                (not (= ?arzp ?zpl))
                )
              (not (= ?arzo ?zpl))
              )
            (or (or (= ?arzr ?arzq)
                (= ?arzr ?zpl)
                )
              (= ?arzq ?zpl)
              )
            )
          (and (or (or (= ?arzp ?arzo)
                (= ?arzp ?zpl)
                )
              (= ?arzo ?zpl)
              )
            (and (and (not (= ?arzr ?arzq))
                (not (= ?arzr ?zpl))
                )
              (not (= ?arzq ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?arzs Real)
  (push 1)
    (declare-const ?arzt Real)
    (declare-const ?arzu Real)
    (declare-const ?arzv Real)
    (assert
      (or (or (= ?arzv ?arzu)
          (= ?arzv ?arzt)
          )
        (= ?arzu ?arzt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?arzw Real)
    (declare-const ?arzx Real)
    (declare-const ?arzy Real)
    (declare-const ?arzz Real)
    (assert
      (or (or (= ?arzz ?arzy)
          (= ?arzz ?arzx)
          )
        (= ?arzy ?arzx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asaa Real)
    (declare-const ?asab Real)
    (declare-const ?asac Real)
    (declare-const ?asad Real)
    (declare-const ?asae Real)
    (assert
      (or (or (= ?asae ?asad)
          (= ?asae ?asac)
          )
        (= ?asad ?asac)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asaf Real)
    (declare-const ?asag Real)
    (declare-const ?asah Real)
    (declare-const ?asai Real)
    (declare-const ?asaj Real)
    (declare-const ?asak Real)
    (assert
      (and (and (and (not (= ?asah ?asag))
            (not (= ?asah ?asaf))
            )
          (not (= ?asag ?asaf))
          )
        (or (or (= ?asak ?asaj)
            (= ?asak ?asai)
            )
          (= ?asaj ?asai)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asal Real)
    (declare-const ?asam Real)
    (declare-const ?asan Real)
    (assert
      (or (or (= ?asan ?asam)
          (= ?asan ?asal)
          )
        (= ?asam ?asal)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asao Real)
    (declare-const ?asap Real)
    (declare-const ?asaq Real)
    (assert
      (or (or (= ?asaq ?asap)
          (= ?asaq ?asao)
          )
        (= ?asap ?asao)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asar Real)
    (declare-const ?asas Real)
    (declare-const ?asat Real)
    (declare-const ?asau Real)
    (assert
      (or (or (= ?asat ?asas)
          (= ?asat ?asar)
          )
        (= ?asas ?asar)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asav Real)
    (declare-const ?asaw Real)
    (declare-const ?asax Real)
    (declare-const ?asay Real)
    (declare-const ?asaz Real)
    (assert
      (or (or (= ?asax ?asaw)
          (= ?asax ?asav)
          )
        (= ?asaw ?asav)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asba Real)
    (declare-const ?asbb Real)
    (declare-const ?asbc Real)
    (declare-const ?asbd Real)
    (declare-const ?asbe Real)
    (declare-const ?asbf Real)
    (assert
      (and (or (or (= ?asbc ?asbb)
            (= ?asbc ?asba)
            )
          (= ?asbb ?asba)
          )
        (and (and (not (= ?asbf ?asbe))
            (not (= ?asbf ?asbd))
            )
          (not (= ?asbe ?asbd))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asbg Real)
    (declare-const ?asbh Real)
    (declare-const ?asbi Real)
    (assert
      (or (or (= ?asbi ?asbh)
          (= ?asbi ?asbg)
          )
        (= ?asbh ?asbg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asbj Real)
    (declare-const ?asbk Real)
    (declare-const ?asbl Real)
    (declare-const ?asbm Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?asbk ?asbj))
                (not (= ?asbk ?asi))
                )
              (not (= ?asbj ?asi))
              )
            (or (or (= ?asbm ?asbl)
                (= ?asbm ?asi)
                )
              (= ?asbl ?asi)
              )
            )
          (and (or (or (= ?asbk ?asbj)
                (= ?asbk ?asi)
                )
              (= ?asbj ?asi)
              )
            (and (and (not (= ?asbm ?asbl))
                (not (= ?asbm ?asi))
                )
              (not (= ?asbl ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asbn Real)
    (declare-const ?asbo Real)
    (declare-const ?asbp Real)
    (declare-const ?asbq Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?asbo ?asbn))
                (not (= ?asbo ?fkf))
                )
              (not (= ?asbn ?fkf))
              )
            (or (or (= ?asbq ?asbp)
                (= ?asbq ?fkf)
                )
              (= ?asbp ?fkf)
              )
            )
          (and (or (or (= ?asbo ?asbn)
                (= ?asbo ?fkf)
                )
              (= ?asbn ?fkf)
              )
            (and (and (not (= ?asbq ?asbp))
                (not (= ?asbq ?fkf))
                )
              (not (= ?asbp ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asbr Real)
    (declare-const ?asbs Real)
    (declare-const ?asbt Real)
    (declare-const ?asbu Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?asbs ?asbr))
                (not (= ?asbs ?mzs))
                )
              (not (= ?asbr ?mzs))
              )
            (or (or (= ?asbu ?asbt)
                (= ?asbu ?mzs)
                )
              (= ?asbt ?mzs)
              )
            )
          (and (or (or (= ?asbs ?asbr)
                (= ?asbs ?mzs)
                )
              (= ?asbr ?mzs)
              )
            (and (and (not (= ?asbu ?asbt))
                (not (= ?asbu ?mzs))
                )
              (not (= ?asbt ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asbv Real)
    (declare-const ?asbw Real)
    (declare-const ?asbx Real)
    (declare-const ?asby Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?asbw ?asbv))
                (not (= ?asbw ?zpl))
                )
              (not (= ?asbv ?zpl))
              )
            (or (or (= ?asby ?asbx)
                (= ?asby ?zpl)
                )
              (= ?asbx ?zpl)
              )
            )
          (and (or (or (= ?asbw ?asbv)
                (= ?asbw ?zpl)
                )
              (= ?asbv ?zpl)
              )
            (and (and (not (= ?asby ?asbx))
                (not (= ?asby ?zpl))
                )
              (not (= ?asbx ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?asbz Real)
  (declare-const ?asca Real)
  (push 1)
    (declare-const ?ascb Real)
    (declare-const ?ascc Real)
    (declare-const ?ascd Real)
    (assert
      (or (or (= ?ascd ?ascc)
          (= ?ascd ?ascb)
          )
        (= ?ascc ?ascb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asce Real)
    (declare-const ?ascf Real)
    (declare-const ?ascg Real)
    (declare-const ?asch Real)
    (assert
      (or (or (= ?asch ?ascg)
          (= ?asch ?ascf)
          )
        (= ?ascg ?ascf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asci Real)
    (declare-const ?ascj Real)
    (declare-const ?asck Real)
    (declare-const ?ascl Real)
    (declare-const ?ascm Real)
    (assert
      (or (or (= ?ascm ?ascl)
          (= ?ascm ?asck)
          )
        (= ?ascl ?asck)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ascn Real)
    (declare-const ?asco Real)
    (declare-const ?ascp Real)
    (declare-const ?ascq Real)
    (declare-const ?ascr Real)
    (declare-const ?ascs Real)
    (assert
      (and (and (and (not (= ?ascp ?asco))
            (not (= ?ascp ?ascn))
            )
          (not (= ?asco ?ascn))
          )
        (or (or (= ?ascs ?ascr)
            (= ?ascs ?ascq)
            )
          (= ?ascr ?ascq)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asct Real)
    (declare-const ?ascu Real)
    (declare-const ?ascv Real)
    (assert
      (or (or (= ?ascv ?ascu)
          (= ?ascv ?asct)
          )
        (= ?ascu ?asct)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ascw Real)
    (declare-const ?ascx Real)
    (declare-const ?ascy Real)
    (assert
      (or (or (= ?ascy ?ascx)
          (= ?ascy ?ascw)
          )
        (= ?ascx ?ascw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ascz Real)
    (declare-const ?asda Real)
    (declare-const ?asdb Real)
    (declare-const ?asdc Real)
    (assert
      (or (or (= ?asdb ?asda)
          (= ?asdb ?ascz)
          )
        (= ?asda ?ascz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asdd Real)
    (declare-const ?asde Real)
    (declare-const ?asdf Real)
    (declare-const ?asdg Real)
    (declare-const ?asdh Real)
    (assert
      (or (or (= ?asdf ?asde)
          (= ?asdf ?asdd)
          )
        (= ?asde ?asdd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asdi Real)
    (declare-const ?asdj Real)
    (declare-const ?asdk Real)
    (declare-const ?asdl Real)
    (declare-const ?asdm Real)
    (declare-const ?asdn Real)
    (assert
      (and (or (or (= ?asdk ?asdj)
            (= ?asdk ?asdi)
            )
          (= ?asdj ?asdi)
          )
        (and (and (not (= ?asdn ?asdm))
            (not (= ?asdn ?asdl))
            )
          (not (= ?asdm ?asdl))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asdo Real)
    (declare-const ?asdp Real)
    (declare-const ?asdq Real)
    (assert
      (or (or (= ?asdq ?asdp)
          (= ?asdq ?asdo)
          )
        (= ?asdp ?asdo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asdr Real)
    (declare-const ?asds Real)
    (declare-const ?asdt Real)
    (declare-const ?asdu Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?asds ?asdr))
                (not (= ?asds ?asi))
                )
              (not (= ?asdr ?asi))
              )
            (or (or (= ?asdu ?asdt)
                (= ?asdu ?asi)
                )
              (= ?asdt ?asi)
              )
            )
          (and (or (or (= ?asds ?asdr)
                (= ?asds ?asi)
                )
              (= ?asdr ?asi)
              )
            (and (and (not (= ?asdu ?asdt))
                (not (= ?asdu ?asi))
                )
              (not (= ?asdt ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asdv Real)
    (declare-const ?asdw Real)
    (declare-const ?asdx Real)
    (declare-const ?asdy Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?asdw ?asdv))
                (not (= ?asdw ?fkf))
                )
              (not (= ?asdv ?fkf))
              )
            (or (or (= ?asdy ?asdx)
                (= ?asdy ?fkf)
                )
              (= ?asdx ?fkf)
              )
            )
          (and (or (or (= ?asdw ?asdv)
                (= ?asdw ?fkf)
                )
              (= ?asdv ?fkf)
              )
            (and (and (not (= ?asdy ?asdx))
                (not (= ?asdy ?fkf))
                )
              (not (= ?asdx ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asdz Real)
    (declare-const ?asea Real)
    (declare-const ?aseb Real)
    (declare-const ?asec Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?asea ?asdz))
                (not (= ?asea ?mzs))
                )
              (not (= ?asdz ?mzs))
              )
            (or (or (= ?asec ?aseb)
                (= ?asec ?mzs)
                )
              (= ?aseb ?mzs)
              )
            )
          (and (or (or (= ?asea ?asdz)
                (= ?asea ?mzs)
                )
              (= ?asdz ?mzs)
              )
            (and (and (not (= ?asec ?aseb))
                (not (= ?asec ?mzs))
                )
              (not (= ?aseb ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ased Real)
    (declare-const ?asee Real)
    (declare-const ?asef Real)
    (declare-const ?aseg Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?asee ?ased))
                (not (= ?asee ?zpl))
                )
              (not (= ?ased ?zpl))
              )
            (or (or (= ?aseg ?asef)
                (= ?aseg ?zpl)
                )
              (= ?asef ?zpl)
              )
            )
          (and (or (or (= ?asee ?ased)
                (= ?asee ?zpl)
                )
              (= ?ased ?zpl)
              )
            (and (and (not (= ?aseg ?asef))
                (not (= ?aseg ?zpl))
                )
              (not (= ?asef ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aseh Real)
  (declare-const ?asei Real)
  (declare-const ?asej Real)
  (push 1)
    (declare-const ?asek Real)
    (declare-const ?asel Real)
    (declare-const ?asem Real)
    (assert
      (or (or (= ?asem ?asel)
          (= ?asem ?asek)
          )
        (= ?asel ?asek)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asen Real)
    (declare-const ?aseo Real)
    (declare-const ?asep Real)
    (declare-const ?aseq Real)
    (assert
      (or (or (= ?aseq ?asep)
          (= ?aseq ?aseo)
          )
        (= ?asep ?aseo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aser Real)
    (declare-const ?ases Real)
    (declare-const ?aset Real)
    (declare-const ?aseu Real)
    (declare-const ?asev Real)
    (assert
      (or (or (= ?asev ?aseu)
          (= ?asev ?aset)
          )
        (= ?aseu ?aset)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asew Real)
    (declare-const ?asex Real)
    (declare-const ?asey Real)
    (declare-const ?asez Real)
    (declare-const ?asfa Real)
    (declare-const ?asfb Real)
    (assert
      (and (and (and (not (= ?asey ?asex))
            (not (= ?asey ?asew))
            )
          (not (= ?asex ?asew))
          )
        (or (or (= ?asfb ?asfa)
            (= ?asfb ?asez)
            )
          (= ?asfa ?asez)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asfc Real)
    (declare-const ?asfd Real)
    (declare-const ?asfe Real)
    (assert
      (or (or (= ?asfe ?asfd)
          (= ?asfe ?asfc)
          )
        (= ?asfd ?asfc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asff Real)
    (declare-const ?asfg Real)
    (declare-const ?asfh Real)
    (assert
      (or (or (= ?asfh ?asfg)
          (= ?asfh ?asff)
          )
        (= ?asfg ?asff)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asfi Real)
    (declare-const ?asfj Real)
    (declare-const ?asfk Real)
    (declare-const ?asfl Real)
    (assert
      (or (or (= ?asfk ?asfj)
          (= ?asfk ?asfi)
          )
        (= ?asfj ?asfi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asfm Real)
    (declare-const ?asfn Real)
    (declare-const ?asfo Real)
    (declare-const ?asfp Real)
    (declare-const ?asfq Real)
    (assert
      (or (or (= ?asfo ?asfn)
          (= ?asfo ?asfm)
          )
        (= ?asfn ?asfm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asfr Real)
    (declare-const ?asfs Real)
    (declare-const ?asft Real)
    (declare-const ?asfu Real)
    (declare-const ?asfv Real)
    (declare-const ?asfw Real)
    (assert
      (and (or (or (= ?asft ?asfs)
            (= ?asft ?asfr)
            )
          (= ?asfs ?asfr)
          )
        (and (and (not (= ?asfw ?asfv))
            (not (= ?asfw ?asfu))
            )
          (not (= ?asfv ?asfu))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asfx Real)
    (declare-const ?asfy Real)
    (declare-const ?asfz Real)
    (assert
      (or (or (= ?asfz ?asfy)
          (= ?asfz ?asfx)
          )
        (= ?asfy ?asfx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asga Real)
    (declare-const ?asgb Real)
    (declare-const ?asgc Real)
    (declare-const ?asgd Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?asgb ?asga))
                (not (= ?asgb ?asi))
                )
              (not (= ?asga ?asi))
              )
            (or (or (= ?asgd ?asgc)
                (= ?asgd ?asi)
                )
              (= ?asgc ?asi)
              )
            )
          (and (or (or (= ?asgb ?asga)
                (= ?asgb ?asi)
                )
              (= ?asga ?asi)
              )
            (and (and (not (= ?asgd ?asgc))
                (not (= ?asgd ?asi))
                )
              (not (= ?asgc ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asge Real)
    (declare-const ?asgf Real)
    (declare-const ?asgg Real)
    (declare-const ?asgh Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?asgf ?asge))
                (not (= ?asgf ?fkf))
                )
              (not (= ?asge ?fkf))
              )
            (or (or (= ?asgh ?asgg)
                (= ?asgh ?fkf)
                )
              (= ?asgg ?fkf)
              )
            )
          (and (or (or (= ?asgf ?asge)
                (= ?asgf ?fkf)
                )
              (= ?asge ?fkf)
              )
            (and (and (not (= ?asgh ?asgg))
                (not (= ?asgh ?fkf))
                )
              (not (= ?asgg ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asgi Real)
    (declare-const ?asgj Real)
    (declare-const ?asgk Real)
    (declare-const ?asgl Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?asgj ?asgi))
                (not (= ?asgj ?mzs))
                )
              (not (= ?asgi ?mzs))
              )
            (or (or (= ?asgl ?asgk)
                (= ?asgl ?mzs)
                )
              (= ?asgk ?mzs)
              )
            )
          (and (or (or (= ?asgj ?asgi)
                (= ?asgj ?mzs)
                )
              (= ?asgi ?mzs)
              )
            (and (and (not (= ?asgl ?asgk))
                (not (= ?asgl ?mzs))
                )
              (not (= ?asgk ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asgm Real)
    (declare-const ?asgn Real)
    (declare-const ?asgo Real)
    (declare-const ?asgp Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?asgn ?asgm))
                (not (= ?asgn ?zpl))
                )
              (not (= ?asgm ?zpl))
              )
            (or (or (= ?asgp ?asgo)
                (= ?asgp ?zpl)
                )
              (= ?asgo ?zpl)
              )
            )
          (and (or (or (= ?asgn ?asgm)
                (= ?asgn ?zpl)
                )
              (= ?asgm ?zpl)
              )
            (and (and (not (= ?asgp ?asgo))
                (not (= ?asgp ?zpl))
                )
              (not (= ?asgo ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?asgq Real)
  (declare-const ?asgr Real)
  (declare-const ?asgs Real)
  (declare-const ?asgt Real)
  (push 1)
    (declare-const ?asgu Real)
    (declare-const ?asgv Real)
    (declare-const ?asgw Real)
    (assert
      (or (or (= ?asgw ?asgv)
          (= ?asgw ?asgu)
          )
        (= ?asgv ?asgu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asgx Real)
    (declare-const ?asgy Real)
    (declare-const ?asgz Real)
    (declare-const ?asha Real)
    (assert
      (or (or (= ?asha ?asgz)
          (= ?asha ?asgy)
          )
        (= ?asgz ?asgy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ashb Real)
    (declare-const ?ashc Real)
    (declare-const ?ashd Real)
    (declare-const ?ashe Real)
    (declare-const ?ashf Real)
    (assert
      (or (or (= ?ashf ?ashe)
          (= ?ashf ?ashd)
          )
        (= ?ashe ?ashd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ashg Real)
    (declare-const ?ashh Real)
    (declare-const ?ashi Real)
    (declare-const ?ashj Real)
    (declare-const ?ashk Real)
    (declare-const ?ashl Real)
    (assert
      (and (and (and (not (= ?ashi ?ashh))
            (not (= ?ashi ?ashg))
            )
          (not (= ?ashh ?ashg))
          )
        (or (or (= ?ashl ?ashk)
            (= ?ashl ?ashj)
            )
          (= ?ashk ?ashj)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ashm Real)
    (declare-const ?ashn Real)
    (declare-const ?asho Real)
    (assert
      (or (or (= ?asho ?ashn)
          (= ?asho ?ashm)
          )
        (= ?ashn ?ashm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ashp Real)
    (declare-const ?ashq Real)
    (declare-const ?ashr Real)
    (assert
      (or (or (= ?ashr ?ashq)
          (= ?ashr ?ashp)
          )
        (= ?ashq ?ashp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ashs Real)
    (declare-const ?asht Real)
    (declare-const ?ashu Real)
    (declare-const ?ashv Real)
    (assert
      (or (or (= ?ashu ?asht)
          (= ?ashu ?ashs)
          )
        (= ?asht ?ashs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ashw Real)
    (declare-const ?ashx Real)
    (declare-const ?ashy Real)
    (declare-const ?ashz Real)
    (declare-const ?asia Real)
    (assert
      (or (or (= ?ashy ?ashx)
          (= ?ashy ?ashw)
          )
        (= ?ashx ?ashw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asib Real)
    (declare-const ?asic Real)
    (declare-const ?asid Real)
    (declare-const ?asie Real)
    (declare-const ?asif Real)
    (declare-const ?asig Real)
    (assert
      (and (or (or (= ?asid ?asic)
            (= ?asid ?asib)
            )
          (= ?asic ?asib)
          )
        (and (and (not (= ?asig ?asif))
            (not (= ?asig ?asie))
            )
          (not (= ?asif ?asie))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asih Real)
    (declare-const ?asii Real)
    (declare-const ?asij Real)
    (assert
      (or (or (= ?asij ?asii)
          (= ?asij ?asih)
          )
        (= ?asii ?asih)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asik Real)
    (declare-const ?asil Real)
    (declare-const ?asim Real)
    (declare-const ?asin Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?asil ?asik))
                (not (= ?asil ?asi))
                )
              (not (= ?asik ?asi))
              )
            (or (or (= ?asin ?asim)
                (= ?asin ?asi)
                )
              (= ?asim ?asi)
              )
            )
          (and (or (or (= ?asil ?asik)
                (= ?asil ?asi)
                )
              (= ?asik ?asi)
              )
            (and (and (not (= ?asin ?asim))
                (not (= ?asin ?asi))
                )
              (not (= ?asim ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asio Real)
    (declare-const ?asip Real)
    (declare-const ?asiq Real)
    (declare-const ?asir Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?asip ?asio))
                (not (= ?asip ?fkf))
                )
              (not (= ?asio ?fkf))
              )
            (or (or (= ?asir ?asiq)
                (= ?asir ?fkf)
                )
              (= ?asiq ?fkf)
              )
            )
          (and (or (or (= ?asip ?asio)
                (= ?asip ?fkf)
                )
              (= ?asio ?fkf)
              )
            (and (and (not (= ?asir ?asiq))
                (not (= ?asir ?fkf))
                )
              (not (= ?asiq ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asis Real)
    (declare-const ?asit Real)
    (declare-const ?asiu Real)
    (declare-const ?asiv Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?asit ?asis))
                (not (= ?asit ?mzs))
                )
              (not (= ?asis ?mzs))
              )
            (or (or (= ?asiv ?asiu)
                (= ?asiv ?mzs)
                )
              (= ?asiu ?mzs)
              )
            )
          (and (or (or (= ?asit ?asis)
                (= ?asit ?mzs)
                )
              (= ?asis ?mzs)
              )
            (and (and (not (= ?asiv ?asiu))
                (not (= ?asiv ?mzs))
                )
              (not (= ?asiu ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asiw Real)
    (declare-const ?asix Real)
    (declare-const ?asiy Real)
    (declare-const ?asiz Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?asix ?asiw))
                (not (= ?asix ?zpl))
                )
              (not (= ?asiw ?zpl))
              )
            (or (or (= ?asiz ?asiy)
                (= ?asiz ?zpl)
                )
              (= ?asiy ?zpl)
              )
            )
          (and (or (or (= ?asix ?asiw)
                (= ?asix ?zpl)
                )
              (= ?asiw ?zpl)
              )
            (and (and (not (= ?asiz ?asiy))
                (not (= ?asiz ?zpl))
                )
              (not (= ?asiy ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (assert
      (and (and (and (forall ((?asi Real) )(and (or (or (or (= ?asgr ?asgq)
                      (= ?asgr ?asi)
                      )
                    (= ?asgq ?asi)
                    )
                  (and (and (not (= ?asgt ?asgs))
                      (not (= ?asgt ?asi))
                      )
                    (not (= ?asgs ?asi))
                    )
                  )
                (or (and (and (not (= ?asgr ?asgq))
                      (not (= ?asgr ?asi))
                      )
                    (not (= ?asgq ?asi))
                    )
                  (or (or (= ?asgt ?asgs)
                      (= ?asgt ?asi)
                      )
                    (= ?asgs ?asi)
                    )
                  )
                )
              )
            (forall ((?fkf Real) )(and (or (or (or (= ?asgr ?asgq)
                      (= ?asgr ?fkf)
                      )
                    (= ?asgq ?fkf)
                    )
                  (and (and (not (= ?asgt ?asgs))
                      (not (= ?asgt ?fkf))
                      )
                    (not (= ?asgs ?fkf))
                    )
                  )
                (or (and (and (not (= ?asgr ?asgq))
                      (not (= ?asgr ?fkf))
                      )
                    (not (= ?asgq ?fkf))
                    )
                  (or (or (= ?asgt ?asgs)
                      (= ?asgt ?fkf)
                      )
                    (= ?asgs ?fkf)
                    )
                  )
                )
              )
            )
          (forall ((?mzs Real) )(and (or (or (or (= ?asgr ?asgq)
                    (= ?asgr ?mzs)
                    )
                  (= ?asgq ?mzs)
                  )
                (and (and (not (= ?asgt ?asgs))
                    (not (= ?asgt ?mzs))
                    )
                  (not (= ?asgs ?mzs))
                  )
                )
              (or (and (and (not (= ?asgr ?asgq))
                    (not (= ?asgr ?mzs))
                    )
                  (not (= ?asgq ?mzs))
                  )
                (or (or (= ?asgt ?asgs)
                    (= ?asgt ?mzs)
                    )
                  (= ?asgs ?mzs)
                  )
                )
              )
            )
          )
        (forall ((?zpl Real) )(and (or (or (or (= ?asgr ?asgq)
                  (= ?asgr ?zpl)
                  )
                (= ?asgq ?zpl)
                )
              (and (and (not (= ?asgt ?asgs))
                  (not (= ?asgt ?zpl))
                  )
                (not (= ?asgs ?zpl))
                )
              )
            (or (and (and (not (= ?asgr ?asgq))
                  (not (= ?asgr ?zpl))
                  )
                (not (= ?asgq ?zpl))
                )
              (or (or (= ?asgt ?asgs)
                  (= ?asgt ?zpl)
                  )
                (= ?asgs ?zpl)
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?asja Real)
  (declare-const ?asjb Real)
  (declare-const ?asjc Real)
  (declare-const ?asjd Real)
  (declare-const ?asje Real)
  (push 1)
    (declare-const ?asjf Real)
    (declare-const ?asjg Real)
    (declare-const ?asjh Real)
    (assert
      (or (or (= ?asjh ?asjg)
          (= ?asjh ?asjf)
          )
        (= ?asjg ?asjf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asji Real)
    (declare-const ?asjj Real)
    (declare-const ?asjk Real)
    (declare-const ?asjl Real)
    (assert
      (or (or (= ?asjl ?asjk)
          (= ?asjl ?asjj)
          )
        (= ?asjk ?asjj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asjm Real)
    (declare-const ?asjn Real)
    (declare-const ?asjo Real)
    (declare-const ?asjp Real)
    (declare-const ?asjq Real)
    (assert
      (or (or (= ?asjq ?asjp)
          (= ?asjq ?asjo)
          )
        (= ?asjp ?asjo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asjr Real)
    (declare-const ?asjs Real)
    (declare-const ?asjt Real)
    (declare-const ?asju Real)
    (declare-const ?asjv Real)
    (declare-const ?asjw Real)
    (assert
      (and (and (and (not (= ?asjt ?asjs))
            (not (= ?asjt ?asjr))
            )
          (not (= ?asjs ?asjr))
          )
        (or (or (= ?asjw ?asjv)
            (= ?asjw ?asju)
            )
          (= ?asjv ?asju)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asjx Real)
    (declare-const ?asjy Real)
    (declare-const ?asjz Real)
    (assert
      (or (or (= ?asjz ?asjy)
          (= ?asjz ?asjx)
          )
        (= ?asjy ?asjx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aska Real)
    (declare-const ?askb Real)
    (declare-const ?askc Real)
    (assert
      (or (or (= ?askc ?askb)
          (= ?askc ?aska)
          )
        (= ?askb ?aska)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?askd Real)
    (declare-const ?aske Real)
    (declare-const ?askf Real)
    (declare-const ?askg Real)
    (assert
      (or (or (= ?askf ?aske)
          (= ?askf ?askd)
          )
        (= ?aske ?askd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?askh Real)
    (declare-const ?aski Real)
    (declare-const ?askj Real)
    (declare-const ?askk Real)
    (declare-const ?askl Real)
    (assert
      (or (or (= ?askj ?aski)
          (= ?askj ?askh)
          )
        (= ?aski ?askh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?askm Real)
    (declare-const ?askn Real)
    (declare-const ?asko Real)
    (declare-const ?askp Real)
    (declare-const ?askq Real)
    (declare-const ?askr Real)
    (assert
      (and (or (or (= ?asko ?askn)
            (= ?asko ?askm)
            )
          (= ?askn ?askm)
          )
        (and (and (not (= ?askr ?askq))
            (not (= ?askr ?askp))
            )
          (not (= ?askq ?askp))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asks Real)
    (declare-const ?askt Real)
    (declare-const ?asku Real)
    (assert
      (or (or (= ?asku ?askt)
          (= ?asku ?asks)
          )
        (= ?askt ?asks)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?askv Real)
    (declare-const ?askw Real)
    (declare-const ?askx Real)
    (declare-const ?asky Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?askw ?askv))
                (not (= ?askw ?asi))
                )
              (not (= ?askv ?asi))
              )
            (or (or (= ?asky ?askx)
                (= ?asky ?asi)
                )
              (= ?askx ?asi)
              )
            )
          (and (or (or (= ?askw ?askv)
                (= ?askw ?asi)
                )
              (= ?askv ?asi)
              )
            (and (and (not (= ?asky ?askx))
                (not (= ?asky ?asi))
                )
              (not (= ?askx ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?askz Real)
    (declare-const ?asla Real)
    (declare-const ?aslb Real)
    (declare-const ?aslc Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?asla ?askz))
                (not (= ?asla ?fkf))
                )
              (not (= ?askz ?fkf))
              )
            (or (or (= ?aslc ?aslb)
                (= ?aslc ?fkf)
                )
              (= ?aslb ?fkf)
              )
            )
          (and (or (or (= ?asla ?askz)
                (= ?asla ?fkf)
                )
              (= ?askz ?fkf)
              )
            (and (and (not (= ?aslc ?aslb))
                (not (= ?aslc ?fkf))
                )
              (not (= ?aslb ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asld Real)
    (declare-const ?asle Real)
    (declare-const ?aslf Real)
    (declare-const ?aslg Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?asle ?asld))
                (not (= ?asle ?mzs))
                )
              (not (= ?asld ?mzs))
              )
            (or (or (= ?aslg ?aslf)
                (= ?aslg ?mzs)
                )
              (= ?aslf ?mzs)
              )
            )
          (and (or (or (= ?asle ?asld)
                (= ?asle ?mzs)
                )
              (= ?asld ?mzs)
              )
            (and (and (not (= ?aslg ?aslf))
                (not (= ?aslg ?mzs))
                )
              (not (= ?aslf ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aslh Real)
    (declare-const ?asli Real)
    (declare-const ?aslj Real)
    (declare-const ?aslk Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?asli ?aslh))
                (not (= ?asli ?zpl))
                )
              (not (= ?aslh ?zpl))
              )
            (or (or (= ?aslk ?aslj)
                (= ?aslk ?zpl)
                )
              (= ?aslj ?zpl)
              )
            )
          (and (or (or (= ?asli ?aslh)
                (= ?asli ?zpl)
                )
              (= ?aslh ?zpl)
              )
            (and (and (not (= ?aslk ?aslj))
                (not (= ?aslk ?zpl))
                )
              (not (= ?aslj ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?asll Real)
  (declare-const ?aslm Real)
  (push 1)
    (declare-const ?asln Real)
    (declare-const ?aslo Real)
    (declare-const ?aslp Real)
    (assert
      (or (or (= ?aslp ?aslo)
          (= ?aslp ?asln)
          )
        (= ?aslo ?asln)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aslq Real)
    (declare-const ?aslr Real)
    (declare-const ?asls Real)
    (declare-const ?aslt Real)
    (assert
      (or (or (= ?aslt ?asls)
          (= ?aslt ?aslr)
          )
        (= ?asls ?aslr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aslu Real)
    (declare-const ?aslv Real)
    (declare-const ?aslw Real)
    (declare-const ?aslx Real)
    (declare-const ?asly Real)
    (assert
      (or (or (= ?asly ?aslx)
          (= ?asly ?aslw)
          )
        (= ?aslx ?aslw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aslz Real)
    (declare-const ?asma Real)
    (declare-const ?asmb Real)
    (declare-const ?asmc Real)
    (declare-const ?asmd Real)
    (declare-const ?asme Real)
    (assert
      (and (and (and (not (= ?asmb ?asma))
            (not (= ?asmb ?aslz))
            )
          (not (= ?asma ?aslz))
          )
        (or (or (= ?asme ?asmd)
            (= ?asme ?asmc)
            )
          (= ?asmd ?asmc)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asmf Real)
    (declare-const ?asmg Real)
    (declare-const ?asmh Real)
    (assert
      (or (or (= ?asmh ?asmg)
          (= ?asmh ?asmf)
          )
        (= ?asmg ?asmf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asmi Real)
    (declare-const ?asmj Real)
    (declare-const ?asmk Real)
    (assert
      (or (or (= ?asmk ?asmj)
          (= ?asmk ?asmi)
          )
        (= ?asmj ?asmi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asml Real)
    (declare-const ?asmm Real)
    (declare-const ?asmn Real)
    (declare-const ?asmo Real)
    (assert
      (or (or (= ?asmn ?asmm)
          (= ?asmn ?asml)
          )
        (= ?asmm ?asml)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asmp Real)
    (declare-const ?asmq Real)
    (declare-const ?asmr Real)
    (declare-const ?asms Real)
    (declare-const ?asmt Real)
    (assert
      (or (or (= ?asmr ?asmq)
          (= ?asmr ?asmp)
          )
        (= ?asmq ?asmp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asmu Real)
    (declare-const ?asmv Real)
    (declare-const ?asmw Real)
    (declare-const ?asmx Real)
    (declare-const ?asmy Real)
    (declare-const ?asmz Real)
    (assert
      (and (or (or (= ?asmw ?asmv)
            (= ?asmw ?asmu)
            )
          (= ?asmv ?asmu)
          )
        (and (and (not (= ?asmz ?asmy))
            (not (= ?asmz ?asmx))
            )
          (not (= ?asmy ?asmx))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asna Real)
    (declare-const ?asnb Real)
    (declare-const ?asnc Real)
    (assert
      (or (or (= ?asnc ?asnb)
          (= ?asnc ?asna)
          )
        (= ?asnb ?asna)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asnd Real)
    (declare-const ?asne Real)
    (declare-const ?asnf Real)
    (declare-const ?asng Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?asne ?asnd))
                (not (= ?asne ?asi))
                )
              (not (= ?asnd ?asi))
              )
            (or (or (= ?asng ?asnf)
                (= ?asng ?asi)
                )
              (= ?asnf ?asi)
              )
            )
          (and (or (or (= ?asne ?asnd)
                (= ?asne ?asi)
                )
              (= ?asnd ?asi)
              )
            (and (and (not (= ?asng ?asnf))
                (not (= ?asng ?asi))
                )
              (not (= ?asnf ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asnh Real)
    (declare-const ?asni Real)
    (declare-const ?asnj Real)
    (declare-const ?asnk Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?asni ?asnh))
                (not (= ?asni ?fkf))
                )
              (not (= ?asnh ?fkf))
              )
            (or (or (= ?asnk ?asnj)
                (= ?asnk ?fkf)
                )
              (= ?asnj ?fkf)
              )
            )
          (and (or (or (= ?asni ?asnh)
                (= ?asni ?fkf)
                )
              (= ?asnh ?fkf)
              )
            (and (and (not (= ?asnk ?asnj))
                (not (= ?asnk ?fkf))
                )
              (not (= ?asnj ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asnl Real)
    (declare-const ?asnm Real)
    (declare-const ?asnn Real)
    (declare-const ?asno Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?asnm ?asnl))
                (not (= ?asnm ?mzs))
                )
              (not (= ?asnl ?mzs))
              )
            (or (or (= ?asno ?asnn)
                (= ?asno ?mzs)
                )
              (= ?asnn ?mzs)
              )
            )
          (and (or (or (= ?asnm ?asnl)
                (= ?asnm ?mzs)
                )
              (= ?asnl ?mzs)
              )
            (and (and (not (= ?asno ?asnn))
                (not (= ?asno ?mzs))
                )
              (not (= ?asnn ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asnp Real)
    (declare-const ?asnq Real)
    (declare-const ?asnr Real)
    (declare-const ?asns Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?asnq ?asnp))
                (not (= ?asnq ?zpl))
                )
              (not (= ?asnp ?zpl))
              )
            (or (or (= ?asns ?asnr)
                (= ?asns ?zpl)
                )
              (= ?asnr ?zpl)
              )
            )
          (and (or (or (= ?asnq ?asnp)
                (= ?asnq ?zpl)
                )
              (= ?asnp ?zpl)
              )
            (and (and (not (= ?asns ?asnr))
                (not (= ?asns ?zpl))
                )
              (not (= ?asnr ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?asnt Real)
  (declare-const ?asnu Real)
  (declare-const ?asnv Real)
  (push 1)
    (declare-const ?asnw Real)
    (declare-const ?asnx Real)
    (declare-const ?asny Real)
    (assert
      (or (or (= ?asny ?asnx)
          (= ?asny ?asnw)
          )
        (= ?asnx ?asnw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asnz Real)
    (declare-const ?asoa Real)
    (declare-const ?asob Real)
    (declare-const ?asoc Real)
    (assert
      (or (or (= ?asoc ?asob)
          (= ?asoc ?asoa)
          )
        (= ?asob ?asoa)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asod Real)
    (declare-const ?asoe Real)
    (declare-const ?asof Real)
    (declare-const ?asog Real)
    (declare-const ?asoh Real)
    (assert
      (or (or (= ?asoh ?asog)
          (= ?asoh ?asof)
          )
        (= ?asog ?asof)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asoi Real)
    (declare-const ?asoj Real)
    (declare-const ?asok Real)
    (declare-const ?asol Real)
    (declare-const ?asom Real)
    (declare-const ?ason Real)
    (assert
      (and (and (and (not (= ?asok ?asoj))
            (not (= ?asok ?asoi))
            )
          (not (= ?asoj ?asoi))
          )
        (or (or (= ?ason ?asom)
            (= ?ason ?asol)
            )
          (= ?asom ?asol)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asoo Real)
    (declare-const ?asop Real)
    (declare-const ?asoq Real)
    (assert
      (or (or (= ?asoq ?asop)
          (= ?asoq ?asoo)
          )
        (= ?asop ?asoo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asor Real)
    (declare-const ?asos Real)
    (declare-const ?asot Real)
    (assert
      (or (or (= ?asot ?asos)
          (= ?asot ?asor)
          )
        (= ?asos ?asor)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asou Real)
    (declare-const ?asov Real)
    (declare-const ?asow Real)
    (declare-const ?asox Real)
    (assert
      (or (or (= ?asow ?asov)
          (= ?asow ?asou)
          )
        (= ?asov ?asou)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asoy Real)
    (declare-const ?asoz Real)
    (declare-const ?aspa Real)
    (declare-const ?aspb Real)
    (declare-const ?aspc Real)
    (assert
      (or (or (= ?aspa ?asoz)
          (= ?aspa ?asoy)
          )
        (= ?asoz ?asoy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aspd Real)
    (declare-const ?aspe Real)
    (declare-const ?aspf Real)
    (declare-const ?aspg Real)
    (declare-const ?asph Real)
    (declare-const ?aspi Real)
    (assert
      (and (or (or (= ?aspf ?aspe)
            (= ?aspf ?aspd)
            )
          (= ?aspe ?aspd)
          )
        (and (and (not (= ?aspi ?asph))
            (not (= ?aspi ?aspg))
            )
          (not (= ?asph ?aspg))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aspj Real)
    (declare-const ?aspk Real)
    (declare-const ?aspl Real)
    (assert
      (or (or (= ?aspl ?aspk)
          (= ?aspl ?aspj)
          )
        (= ?aspk ?aspj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aspm Real)
    (declare-const ?aspn Real)
    (declare-const ?aspo Real)
    (declare-const ?aspp Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aspn ?aspm))
                (not (= ?aspn ?asi))
                )
              (not (= ?aspm ?asi))
              )
            (or (or (= ?aspp ?aspo)
                (= ?aspp ?asi)
                )
              (= ?aspo ?asi)
              )
            )
          (and (or (or (= ?aspn ?aspm)
                (= ?aspn ?asi)
                )
              (= ?aspm ?asi)
              )
            (and (and (not (= ?aspp ?aspo))
                (not (= ?aspp ?asi))
                )
              (not (= ?aspo ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aspq Real)
    (declare-const ?aspr Real)
    (declare-const ?asps Real)
    (declare-const ?aspt Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aspr ?aspq))
                (not (= ?aspr ?fkf))
                )
              (not (= ?aspq ?fkf))
              )
            (or (or (= ?aspt ?asps)
                (= ?aspt ?fkf)
                )
              (= ?asps ?fkf)
              )
            )
          (and (or (or (= ?aspr ?aspq)
                (= ?aspr ?fkf)
                )
              (= ?aspq ?fkf)
              )
            (and (and (not (= ?aspt ?asps))
                (not (= ?aspt ?fkf))
                )
              (not (= ?asps ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aspu Real)
    (declare-const ?aspv Real)
    (declare-const ?aspw Real)
    (declare-const ?aspx Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aspv ?aspu))
                (not (= ?aspv ?mzs))
                )
              (not (= ?aspu ?mzs))
              )
            (or (or (= ?aspx ?aspw)
                (= ?aspx ?mzs)
                )
              (= ?aspw ?mzs)
              )
            )
          (and (or (or (= ?aspv ?aspu)
                (= ?aspv ?mzs)
                )
              (= ?aspu ?mzs)
              )
            (and (and (not (= ?aspx ?aspw))
                (not (= ?aspx ?mzs))
                )
              (not (= ?aspw ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aspy Real)
    (declare-const ?aspz Real)
    (declare-const ?asqa Real)
    (declare-const ?asqb Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?aspz ?aspy))
                (not (= ?aspz ?zpl))
                )
              (not (= ?aspy ?zpl))
              )
            (or (or (= ?asqb ?asqa)
                (= ?asqb ?zpl)
                )
              (= ?asqa ?zpl)
              )
            )
          (and (or (or (= ?aspz ?aspy)
                (= ?aspz ?zpl)
                )
              (= ?aspy ?zpl)
              )
            (and (and (not (= ?asqb ?asqa))
                (not (= ?asqb ?zpl))
                )
              (not (= ?asqa ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?asqc Real)
  (declare-const ?asqd Real)
  (declare-const ?asqe Real)
  (declare-const ?asqf Real)
  (push 1)
    (declare-const ?asqg Real)
    (declare-const ?asqh Real)
    (declare-const ?asqi Real)
    (assert
      (or (or (= ?asqi ?asqh)
          (= ?asqi ?asqg)
          )
        (= ?asqh ?asqg)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asqj Real)
    (declare-const ?asqk Real)
    (declare-const ?asql Real)
    (declare-const ?asqm Real)
    (assert
      (or (or (= ?asqm ?asql)
          (= ?asqm ?asqk)
          )
        (= ?asql ?asqk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asqn Real)
    (declare-const ?asqo Real)
    (declare-const ?asqp Real)
    (declare-const ?asqq Real)
    (declare-const ?asqr Real)
    (assert
      (or (or (= ?asqr ?asqq)
          (= ?asqr ?asqp)
          )
        (= ?asqq ?asqp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asqs Real)
    (declare-const ?asqt Real)
    (declare-const ?asqu Real)
    (declare-const ?asqv Real)
    (declare-const ?asqw Real)
    (declare-const ?asqx Real)
    (assert
      (and (and (and (not (= ?asqu ?asqt))
            (not (= ?asqu ?asqs))
            )
          (not (= ?asqt ?asqs))
          )
        (or (or (= ?asqx ?asqw)
            (= ?asqx ?asqv)
            )
          (= ?asqw ?asqv)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asqy Real)
    (declare-const ?asqz Real)
    (declare-const ?asra Real)
    (assert
      (or (or (= ?asra ?asqz)
          (= ?asra ?asqy)
          )
        (= ?asqz ?asqy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asrb Real)
    (declare-const ?asrc Real)
    (declare-const ?asrd Real)
    (assert
      (or (or (= ?asrd ?asrc)
          (= ?asrd ?asrb)
          )
        (= ?asrc ?asrb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asre Real)
    (declare-const ?asrf Real)
    (declare-const ?asrg Real)
    (declare-const ?asrh Real)
    (assert
      (or (or (= ?asrg ?asrf)
          (= ?asrg ?asre)
          )
        (= ?asrf ?asre)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asri Real)
    (declare-const ?asrj Real)
    (declare-const ?asrk Real)
    (declare-const ?asrl Real)
    (declare-const ?asrm Real)
    (assert
      (or (or (= ?asrk ?asrj)
          (= ?asrk ?asri)
          )
        (= ?asrj ?asri)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asrn Real)
    (declare-const ?asro Real)
    (declare-const ?asrp Real)
    (declare-const ?asrq Real)
    (declare-const ?asrr Real)
    (declare-const ?asrs Real)
    (assert
      (and (or (or (= ?asrp ?asro)
            (= ?asrp ?asrn)
            )
          (= ?asro ?asrn)
          )
        (and (and (not (= ?asrs ?asrr))
            (not (= ?asrs ?asrq))
            )
          (not (= ?asrr ?asrq))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asrt Real)
    (declare-const ?asru Real)
    (declare-const ?asrv Real)
    (assert
      (or (or (= ?asrv ?asru)
          (= ?asrv ?asrt)
          )
        (= ?asru ?asrt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asrw Real)
    (declare-const ?asrx Real)
    (declare-const ?asry Real)
    (declare-const ?asrz Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?asrx ?asrw))
                (not (= ?asrx ?asi))
                )
              (not (= ?asrw ?asi))
              )
            (or (or (= ?asrz ?asry)
                (= ?asrz ?asi)
                )
              (= ?asry ?asi)
              )
            )
          (and (or (or (= ?asrx ?asrw)
                (= ?asrx ?asi)
                )
              (= ?asrw ?asi)
              )
            (and (and (not (= ?asrz ?asry))
                (not (= ?asrz ?asi))
                )
              (not (= ?asry ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?assa Real)
    (declare-const ?assb Real)
    (declare-const ?assc Real)
    (declare-const ?assd Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?assb ?assa))
                (not (= ?assb ?fkf))
                )
              (not (= ?assa ?fkf))
              )
            (or (or (= ?assd ?assc)
                (= ?assd ?fkf)
                )
              (= ?assc ?fkf)
              )
            )
          (and (or (or (= ?assb ?assa)
                (= ?assb ?fkf)
                )
              (= ?assa ?fkf)
              )
            (and (and (not (= ?assd ?assc))
                (not (= ?assd ?fkf))
                )
              (not (= ?assc ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asse Real)
    (declare-const ?assf Real)
    (declare-const ?assg Real)
    (declare-const ?assh Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?assf ?asse))
                (not (= ?assf ?mzs))
                )
              (not (= ?asse ?mzs))
              )
            (or (or (= ?assh ?assg)
                (= ?assh ?mzs)
                )
              (= ?assg ?mzs)
              )
            )
          (and (or (or (= ?assf ?asse)
                (= ?assf ?mzs)
                )
              (= ?asse ?mzs)
              )
            (and (and (not (= ?assh ?assg))
                (not (= ?assh ?mzs))
                )
              (not (= ?assg ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?assi Real)
    (declare-const ?assj Real)
    (declare-const ?assk Real)
    (declare-const ?assl Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?assj ?assi))
                (not (= ?assj ?zpl))
                )
              (not (= ?assi ?zpl))
              )
            (or (or (= ?assl ?assk)
                (= ?assl ?zpl)
                )
              (= ?assk ?zpl)
              )
            )
          (and (or (or (= ?assj ?assi)
                (= ?assj ?zpl)
                )
              (= ?assi ?zpl)
              )
            (and (and (not (= ?assl ?assk))
                (not (= ?assl ?zpl))
                )
              (not (= ?assk ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?assm Real)
  (declare-const ?assn Real)
  (declare-const ?asso Real)
  (declare-const ?assp Real)
  (declare-const ?assq Real)
  (push 1)
    (declare-const ?assr Real)
    (declare-const ?asss Real)
    (declare-const ?asst Real)
    (assert
      (or (or (= ?asst ?asss)
          (= ?asst ?assr)
          )
        (= ?asss ?assr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?assu Real)
    (declare-const ?assv Real)
    (declare-const ?assw Real)
    (declare-const ?assx Real)
    (assert
      (or (or (= ?assx ?assw)
          (= ?assx ?assv)
          )
        (= ?assw ?assv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?assy Real)
    (declare-const ?assz Real)
    (declare-const ?asta Real)
    (declare-const ?astb Real)
    (declare-const ?astc Real)
    (assert
      (or (or (= ?astc ?astb)
          (= ?astc ?asta)
          )
        (= ?astb ?asta)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?astd Real)
    (declare-const ?aste Real)
    (declare-const ?astf Real)
    (declare-const ?astg Real)
    (declare-const ?asth Real)
    (declare-const ?asti Real)
    (assert
      (and (and (and (not (= ?astf ?aste))
            (not (= ?astf ?astd))
            )
          (not (= ?aste ?astd))
          )
        (or (or (= ?asti ?asth)
            (= ?asti ?astg)
            )
          (= ?asth ?astg)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?astj Real)
    (declare-const ?astk Real)
    (declare-const ?astl Real)
    (assert
      (or (or (= ?astl ?astk)
          (= ?astl ?astj)
          )
        (= ?astk ?astj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?astm Real)
    (declare-const ?astn Real)
    (declare-const ?asto Real)
    (assert
      (or (or (= ?asto ?astn)
          (= ?asto ?astm)
          )
        (= ?astn ?astm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?astp Real)
    (declare-const ?astq Real)
    (declare-const ?astr Real)
    (declare-const ?asts Real)
    (assert
      (or (or (= ?astr ?astq)
          (= ?astr ?astp)
          )
        (= ?astq ?astp)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?astt Real)
    (declare-const ?astu Real)
    (declare-const ?astv Real)
    (declare-const ?astw Real)
    (declare-const ?astx Real)
    (assert
      (or (or (= ?astv ?astu)
          (= ?astv ?astt)
          )
        (= ?astu ?astt)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asty Real)
    (declare-const ?astz Real)
    (declare-const ?asua Real)
    (declare-const ?asub Real)
    (declare-const ?asuc Real)
    (declare-const ?asud Real)
    (assert
      (and (or (or (= ?asua ?astz)
            (= ?asua ?asty)
            )
          (= ?astz ?asty)
          )
        (and (and (not (= ?asud ?asuc))
            (not (= ?asud ?asub))
            )
          (not (= ?asuc ?asub))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asue Real)
    (declare-const ?asuf Real)
    (declare-const ?asug Real)
    (assert
      (or (or (= ?asug ?asuf)
          (= ?asug ?asue)
          )
        (= ?asuf ?asue)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asuh Real)
    (declare-const ?asui Real)
    (declare-const ?asuj Real)
    (declare-const ?asuk Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?asui ?asuh))
                (not (= ?asui ?asi))
                )
              (not (= ?asuh ?asi))
              )
            (or (or (= ?asuk ?asuj)
                (= ?asuk ?asi)
                )
              (= ?asuj ?asi)
              )
            )
          (and (or (or (= ?asui ?asuh)
                (= ?asui ?asi)
                )
              (= ?asuh ?asi)
              )
            (and (and (not (= ?asuk ?asuj))
                (not (= ?asuk ?asi))
                )
              (not (= ?asuj ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asul Real)
    (declare-const ?asum Real)
    (declare-const ?asun Real)
    (declare-const ?asuo Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?asum ?asul))
                (not (= ?asum ?fkf))
                )
              (not (= ?asul ?fkf))
              )
            (or (or (= ?asuo ?asun)
                (= ?asuo ?fkf)
                )
              (= ?asun ?fkf)
              )
            )
          (and (or (or (= ?asum ?asul)
                (= ?asum ?fkf)
                )
              (= ?asul ?fkf)
              )
            (and (and (not (= ?asuo ?asun))
                (not (= ?asuo ?fkf))
                )
              (not (= ?asun ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asup Real)
    (declare-const ?asuq Real)
    (declare-const ?asur Real)
    (declare-const ?asus Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?asuq ?asup))
                (not (= ?asuq ?mzs))
                )
              (not (= ?asup ?mzs))
              )
            (or (or (= ?asus ?asur)
                (= ?asus ?mzs)
                )
              (= ?asur ?mzs)
              )
            )
          (and (or (or (= ?asuq ?asup)
                (= ?asuq ?mzs)
                )
              (= ?asup ?mzs)
              )
            (and (and (not (= ?asus ?asur))
                (not (= ?asus ?mzs))
                )
              (not (= ?asur ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asut Real)
    (declare-const ?asuu Real)
    (declare-const ?asuv Real)
    (declare-const ?asuw Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?asuu ?asut))
                (not (= ?asuu ?zpl))
                )
              (not (= ?asut ?zpl))
              )
            (or (or (= ?asuw ?asuv)
                (= ?asuw ?zpl)
                )
              (= ?asuv ?zpl)
              )
            )
          (and (or (or (= ?asuu ?asut)
                (= ?asuu ?zpl)
                )
              (= ?asut ?zpl)
              )
            (and (and (not (= ?asuw ?asuv))
                (not (= ?asuw ?zpl))
                )
              (not (= ?asuv ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?asux Real)
  (declare-const ?asuy Real)
  (declare-const ?asuz Real)
  (declare-const ?asva Real)
  (declare-const ?asvb Real)
  (declare-const ?asvc Real)
  (push 1)
    (declare-const ?asvd Real)
    (declare-const ?asve Real)
    (declare-const ?asvf Real)
    (assert
      (or (or (= ?asvf ?asve)
          (= ?asvf ?asvd)
          )
        (= ?asve ?asvd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asvg Real)
    (declare-const ?asvh Real)
    (declare-const ?asvi Real)
    (declare-const ?asvj Real)
    (assert
      (or (or (= ?asvj ?asvi)
          (= ?asvj ?asvh)
          )
        (= ?asvi ?asvh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asvk Real)
    (declare-const ?asvl Real)
    (declare-const ?asvm Real)
    (declare-const ?asvn Real)
    (declare-const ?asvo Real)
    (assert
      (or (or (= ?asvo ?asvn)
          (= ?asvo ?asvm)
          )
        (= ?asvn ?asvm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asvp Real)
    (declare-const ?asvq Real)
    (declare-const ?asvr Real)
    (declare-const ?asvs Real)
    (declare-const ?asvt Real)
    (declare-const ?asvu Real)
    (assert
      (and (and (and (not (= ?asvr ?asvq))
            (not (= ?asvr ?asvp))
            )
          (not (= ?asvq ?asvp))
          )
        (or (or (= ?asvu ?asvt)
            (= ?asvu ?asvs)
            )
          (= ?asvt ?asvs)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asvv Real)
    (declare-const ?asvw Real)
    (declare-const ?asvx Real)
    (assert
      (or (or (= ?asvx ?asvw)
          (= ?asvx ?asvv)
          )
        (= ?asvw ?asvv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asvy Real)
    (declare-const ?asvz Real)
    (declare-const ?aswa Real)
    (assert
      (or (or (= ?aswa ?asvz)
          (= ?aswa ?asvy)
          )
        (= ?asvz ?asvy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aswb Real)
    (declare-const ?aswc Real)
    (declare-const ?aswd Real)
    (declare-const ?aswe Real)
    (assert
      (or (or (= ?aswd ?aswc)
          (= ?aswd ?aswb)
          )
        (= ?aswc ?aswb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aswf Real)
    (declare-const ?aswg Real)
    (declare-const ?aswh Real)
    (declare-const ?aswi Real)
    (declare-const ?aswj Real)
    (assert
      (or (or (= ?aswh ?aswg)
          (= ?aswh ?aswf)
          )
        (= ?aswg ?aswf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aswk Real)
    (declare-const ?aswl Real)
    (declare-const ?aswm Real)
    (declare-const ?aswn Real)
    (declare-const ?aswo Real)
    (declare-const ?aswp Real)
    (assert
      (and (or (or (= ?aswm ?aswl)
            (= ?aswm ?aswk)
            )
          (= ?aswl ?aswk)
          )
        (and (and (not (= ?aswp ?aswo))
            (not (= ?aswp ?aswn))
            )
          (not (= ?aswo ?aswn))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aswq Real)
    (declare-const ?aswr Real)
    (declare-const ?asws Real)
    (assert
      (or (or (= ?asws ?aswr)
          (= ?asws ?aswq)
          )
        (= ?aswr ?aswq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aswt Real)
    (declare-const ?aswu Real)
    (declare-const ?aswv Real)
    (declare-const ?asww Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aswu ?aswt))
                (not (= ?aswu ?asi))
                )
              (not (= ?aswt ?asi))
              )
            (or (or (= ?asww ?aswv)
                (= ?asww ?asi)
                )
              (= ?aswv ?asi)
              )
            )
          (and (or (or (= ?aswu ?aswt)
                (= ?aswu ?asi)
                )
              (= ?aswt ?asi)
              )
            (and (and (not (= ?asww ?aswv))
                (not (= ?asww ?asi))
                )
              (not (= ?aswv ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aswx Real)
    (declare-const ?aswy Real)
    (declare-const ?aswz Real)
    (declare-const ?asxa Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aswy ?aswx))
                (not (= ?aswy ?fkf))
                )
              (not (= ?aswx ?fkf))
              )
            (or (or (= ?asxa ?aswz)
                (= ?asxa ?fkf)
                )
              (= ?aswz ?fkf)
              )
            )
          (and (or (or (= ?aswy ?aswx)
                (= ?aswy ?fkf)
                )
              (= ?aswx ?fkf)
              )
            (and (and (not (= ?asxa ?aswz))
                (not (= ?asxa ?fkf))
                )
              (not (= ?aswz ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asxb Real)
    (declare-const ?asxc Real)
    (declare-const ?asxd Real)
    (declare-const ?asxe Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?asxc ?asxb))
                (not (= ?asxc ?mzs))
                )
              (not (= ?asxb ?mzs))
              )
            (or (or (= ?asxe ?asxd)
                (= ?asxe ?mzs)
                )
              (= ?asxd ?mzs)
              )
            )
          (and (or (or (= ?asxc ?asxb)
                (= ?asxc ?mzs)
                )
              (= ?asxb ?mzs)
              )
            (and (and (not (= ?asxe ?asxd))
                (not (= ?asxe ?mzs))
                )
              (not (= ?asxd ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asxf Real)
    (declare-const ?asxg Real)
    (declare-const ?asxh Real)
    (declare-const ?asxi Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?asxg ?asxf))
                (not (= ?asxg ?zpl))
                )
              (not (= ?asxf ?zpl))
              )
            (or (or (= ?asxi ?asxh)
                (= ?asxi ?zpl)
                )
              (= ?asxh ?zpl)
              )
            )
          (and (or (or (= ?asxg ?asxf)
                (= ?asxg ?zpl)
                )
              (= ?asxf ?zpl)
              )
            (and (and (not (= ?asxi ?asxh))
                (not (= ?asxi ?zpl))
                )
              (not (= ?asxh ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (assert
      (and (or (or (or (= ?asuz ?asuy)
              (= ?asuz ?asux)
              )
            (= ?asuy ?asux)
            )
          (and (and (not (= ?asvc ?asvb))
              (not (= ?asvc ?asva))
              )
            (not (= ?asvb ?asva))
            )
          )
        (or (and (and (not (= ?asuz ?asuy))
              (not (= ?asuz ?asux))
              )
            (not (= ?asuy ?asux))
            )
          (or (or (= ?asvc ?asvb)
              (= ?asvc ?asva)
              )
            (= ?asvb ?asva)
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?asxj Real)
  (declare-const ?asxk Real)
  (declare-const ?asxl Real)
  (push 1)
    (declare-const ?asxm Real)
    (declare-const ?asxn Real)
    (declare-const ?asxo Real)
    (assert
      (or (or (= ?asxo ?asxn)
          (= ?asxo ?asxm)
          )
        (= ?asxn ?asxm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asxp Real)
    (declare-const ?asxq Real)
    (declare-const ?asxr Real)
    (declare-const ?asxs Real)
    (assert
      (or (or (= ?asxs ?asxr)
          (= ?asxs ?asxq)
          )
        (= ?asxr ?asxq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asxt Real)
    (declare-const ?asxu Real)
    (declare-const ?asxv Real)
    (declare-const ?asxw Real)
    (declare-const ?asxx Real)
    (assert
      (or (or (= ?asxx ?asxw)
          (= ?asxx ?asxv)
          )
        (= ?asxw ?asxv)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asxy Real)
    (declare-const ?asxz Real)
    (declare-const ?asya Real)
    (declare-const ?asyb Real)
    (declare-const ?asyc Real)
    (declare-const ?asyd Real)
    (assert
      (and (and (and (not (= ?asya ?asxz))
            (not (= ?asya ?asxy))
            )
          (not (= ?asxz ?asxy))
          )
        (or (or (= ?asyd ?asyc)
            (= ?asyd ?asyb)
            )
          (= ?asyc ?asyb)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asye Real)
    (declare-const ?asyf Real)
    (declare-const ?asyg Real)
    (assert
      (or (or (= ?asyg ?asyf)
          (= ?asyg ?asye)
          )
        (= ?asyf ?asye)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asyh Real)
    (declare-const ?asyi Real)
    (declare-const ?asyj Real)
    (assert
      (or (or (= ?asyj ?asyi)
          (= ?asyj ?asyh)
          )
        (= ?asyi ?asyh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asyk Real)
    (declare-const ?asyl Real)
    (declare-const ?asym Real)
    (declare-const ?asyn Real)
    (assert
      (or (or (= ?asym ?asyl)
          (= ?asym ?asyk)
          )
        (= ?asyl ?asyk)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asyo Real)
    (declare-const ?asyp Real)
    (declare-const ?asyq Real)
    (declare-const ?asyr Real)
    (declare-const ?asys Real)
    (assert
      (or (or (= ?asyq ?asyp)
          (= ?asyq ?asyo)
          )
        (= ?asyp ?asyo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asyt Real)
    (declare-const ?asyu Real)
    (declare-const ?asyv Real)
    (declare-const ?asyw Real)
    (declare-const ?asyx Real)
    (declare-const ?asyy Real)
    (assert
      (and (or (or (= ?asyv ?asyu)
            (= ?asyv ?asyt)
            )
          (= ?asyu ?asyt)
          )
        (and (and (not (= ?asyy ?asyx))
            (not (= ?asyy ?asyw))
            )
          (not (= ?asyx ?asyw))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?asyz Real)
    (declare-const ?asza Real)
    (declare-const ?aszb Real)
    (assert
      (or (or (= ?aszb ?asza)
          (= ?aszb ?asyz)
          )
        (= ?asza ?asyz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aszc Real)
    (declare-const ?aszd Real)
    (declare-const ?asze Real)
    (declare-const ?aszf Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?aszd ?aszc))
                (not (= ?aszd ?asi))
                )
              (not (= ?aszc ?asi))
              )
            (or (or (= ?aszf ?asze)
                (= ?aszf ?asi)
                )
              (= ?asze ?asi)
              )
            )
          (and (or (or (= ?aszd ?aszc)
                (= ?aszd ?asi)
                )
              (= ?aszc ?asi)
              )
            (and (and (not (= ?aszf ?asze))
                (not (= ?aszf ?asi))
                )
              (not (= ?asze ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aszg Real)
    (declare-const ?aszh Real)
    (declare-const ?aszi Real)
    (declare-const ?aszj Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?aszh ?aszg))
                (not (= ?aszh ?fkf))
                )
              (not (= ?aszg ?fkf))
              )
            (or (or (= ?aszj ?aszi)
                (= ?aszj ?fkf)
                )
              (= ?aszi ?fkf)
              )
            )
          (and (or (or (= ?aszh ?aszg)
                (= ?aszh ?fkf)
                )
              (= ?aszg ?fkf)
              )
            (and (and (not (= ?aszj ?aszi))
                (not (= ?aszj ?fkf))
                )
              (not (= ?aszi ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aszk Real)
    (declare-const ?aszl Real)
    (declare-const ?aszm Real)
    (declare-const ?aszn Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?aszl ?aszk))
                (not (= ?aszl ?mzs))
                )
              (not (= ?aszk ?mzs))
              )
            (or (or (= ?aszn ?aszm)
                (= ?aszn ?mzs)
                )
              (= ?aszm ?mzs)
              )
            )
          (and (or (or (= ?aszl ?aszk)
                (= ?aszl ?mzs)
                )
              (= ?aszk ?mzs)
              )
            (and (and (not (= ?aszn ?aszm))
                (not (= ?aszn ?mzs))
                )
              (not (= ?aszm ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aszo Real)
    (declare-const ?aszp Real)
    (declare-const ?aszq Real)
    (declare-const ?aszr Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?aszp ?aszo))
                (not (= ?aszp ?zpl))
                )
              (not (= ?aszo ?zpl))
              )
            (or (or (= ?aszr ?aszq)
                (= ?aszr ?zpl)
                )
              (= ?aszq ?zpl)
              )
            )
          (and (or (or (= ?aszp ?aszo)
                (= ?aszp ?zpl)
                )
              (= ?aszo ?zpl)
              )
            (and (and (not (= ?aszr ?aszq))
                (not (= ?aszr ?zpl))
                )
              (not (= ?aszq ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (assert
      (and (and (not (= ?asxl ?asxk))
          (not (= ?asxl ?asxj))
          )
        (not (= ?asxk ?asxj))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?aszs Real)
    (declare-const ?aszt Real)
    (declare-const ?aszu Real)
    (assert
      (or (or (= ?aszu ?aszt)
          (= ?aszu ?aszs)
          )
        (= ?aszt ?aszs)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aszv Real)
    (declare-const ?aszw Real)
    (declare-const ?aszx Real)
    (declare-const ?aszy Real)
    (assert
      (or (or (= ?aszy ?aszx)
          (= ?aszy ?aszw)
          )
        (= ?aszx ?aszw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aszz Real)
    (declare-const ?ataa Real)
    (declare-const ?atab Real)
    (declare-const ?atac Real)
    (declare-const ?atad Real)
    (assert
      (or (or (= ?atad ?atac)
          (= ?atad ?atab)
          )
        (= ?atac ?atab)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atae Real)
    (declare-const ?ataf Real)
    (declare-const ?atag Real)
    (declare-const ?atah Real)
    (declare-const ?atai Real)
    (declare-const ?ataj Real)
    (assert
      (and (and (and (not (= ?atag ?ataf))
            (not (= ?atag ?atae))
            )
          (not (= ?ataf ?atae))
          )
        (or (or (= ?ataj ?atai)
            (= ?ataj ?atah)
            )
          (= ?atai ?atah)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atak Real)
    (declare-const ?atal Real)
    (declare-const ?atam Real)
    (assert
      (or (or (= ?atam ?atal)
          (= ?atam ?atak)
          )
        (= ?atal ?atak)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atan Real)
    (declare-const ?atao Real)
    (declare-const ?atap Real)
    (assert
      (or (or (= ?atap ?atao)
          (= ?atap ?atan)
          )
        (= ?atao ?atan)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ataq Real)
    (declare-const ?atar Real)
    (declare-const ?atas Real)
    (declare-const ?atat Real)
    (assert
      (or (or (= ?atas ?atar)
          (= ?atas ?ataq)
          )
        (= ?atar ?ataq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atau Real)
    (declare-const ?atav Real)
    (declare-const ?ataw Real)
    (declare-const ?atax Real)
    (declare-const ?atay Real)
    (assert
      (or (or (= ?ataw ?atav)
          (= ?ataw ?atau)
          )
        (= ?atav ?atau)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ataz Real)
    (declare-const ?atba Real)
    (declare-const ?atbb Real)
    (declare-const ?atbc Real)
    (declare-const ?atbd Real)
    (declare-const ?atbe Real)
    (assert
      (and (or (or (= ?atbb ?atba)
            (= ?atbb ?ataz)
            )
          (= ?atba ?ataz)
          )
        (and (and (not (= ?atbe ?atbd))
            (not (= ?atbe ?atbc))
            )
          (not (= ?atbd ?atbc))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atbf Real)
    (declare-const ?atbg Real)
    (declare-const ?atbh Real)
    (assert
      (or (or (= ?atbh ?atbg)
          (= ?atbh ?atbf)
          )
        (= ?atbg ?atbf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atbi Real)
    (declare-const ?atbj Real)
    (declare-const ?atbk Real)
    (declare-const ?atbl Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?atbj ?atbi))
                (not (= ?atbj ?asi))
                )
              (not (= ?atbi ?asi))
              )
            (or (or (= ?atbl ?atbk)
                (= ?atbl ?asi)
                )
              (= ?atbk ?asi)
              )
            )
          (and (or (or (= ?atbj ?atbi)
                (= ?atbj ?asi)
                )
              (= ?atbi ?asi)
              )
            (and (and (not (= ?atbl ?atbk))
                (not (= ?atbl ?asi))
                )
              (not (= ?atbk ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atbm Real)
    (declare-const ?atbn Real)
    (declare-const ?atbo Real)
    (declare-const ?atbp Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?atbn ?atbm))
                (not (= ?atbn ?fkf))
                )
              (not (= ?atbm ?fkf))
              )
            (or (or (= ?atbp ?atbo)
                (= ?atbp ?fkf)
                )
              (= ?atbo ?fkf)
              )
            )
          (and (or (or (= ?atbn ?atbm)
                (= ?atbn ?fkf)
                )
              (= ?atbm ?fkf)
              )
            (and (and (not (= ?atbp ?atbo))
                (not (= ?atbp ?fkf))
                )
              (not (= ?atbo ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atbq Real)
    (declare-const ?atbr Real)
    (declare-const ?atbs Real)
    (declare-const ?atbt Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?atbr ?atbq))
                (not (= ?atbr ?mzs))
                )
              (not (= ?atbq ?mzs))
              )
            (or (or (= ?atbt ?atbs)
                (= ?atbt ?mzs)
                )
              (= ?atbs ?mzs)
              )
            )
          (and (or (or (= ?atbr ?atbq)
                (= ?atbr ?mzs)
                )
              (= ?atbq ?mzs)
              )
            (and (and (not (= ?atbt ?atbs))
                (not (= ?atbt ?mzs))
                )
              (not (= ?atbs ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atbu Real)
    (declare-const ?atbv Real)
    (declare-const ?atbw Real)
    (declare-const ?atbx Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?atbv ?atbu))
                (not (= ?atbv ?zpl))
                )
              (not (= ?atbu ?zpl))
              )
            (or (or (= ?atbx ?atbw)
                (= ?atbx ?zpl)
                )
              (= ?atbw ?zpl)
              )
            )
          (and (or (or (= ?atbv ?atbu)
                (= ?atbv ?zpl)
                )
              (= ?atbu ?zpl)
              )
            (and (and (not (= ?atbx ?atbw))
                (not (= ?atbx ?zpl))
                )
              (not (= ?atbw ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?atby Real)
  (push 1)
    (declare-const ?atbz Real)
    (declare-const ?atca Real)
    (declare-const ?atcb Real)
    (assert
      (or (or (= ?atcb ?atca)
          (= ?atcb ?atbz)
          )
        (= ?atca ?atbz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atcc Real)
    (declare-const ?atcd Real)
    (declare-const ?atce Real)
    (declare-const ?atcf Real)
    (assert
      (or (or (= ?atcf ?atce)
          (= ?atcf ?atcd)
          )
        (= ?atce ?atcd)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atcg Real)
    (declare-const ?atch Real)
    (declare-const ?atci Real)
    (declare-const ?atcj Real)
    (declare-const ?atck Real)
    (assert
      (or (or (= ?atck ?atcj)
          (= ?atck ?atci)
          )
        (= ?atcj ?atci)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atcl Real)
    (declare-const ?atcm Real)
    (declare-const ?atcn Real)
    (declare-const ?atco Real)
    (declare-const ?atcp Real)
    (declare-const ?atcq Real)
    (assert
      (and (and (and (not (= ?atcn ?atcm))
            (not (= ?atcn ?atcl))
            )
          (not (= ?atcm ?atcl))
          )
        (or (or (= ?atcq ?atcp)
            (= ?atcq ?atco)
            )
          (= ?atcp ?atco)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atcr Real)
    (declare-const ?atcs Real)
    (declare-const ?atct Real)
    (assert
      (or (or (= ?atct ?atcs)
          (= ?atct ?atcr)
          )
        (= ?atcs ?atcr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atcu Real)
    (declare-const ?atcv Real)
    (declare-const ?atcw Real)
    (assert
      (or (or (= ?atcw ?atcv)
          (= ?atcw ?atcu)
          )
        (= ?atcv ?atcu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atcx Real)
    (declare-const ?atcy Real)
    (declare-const ?atcz Real)
    (declare-const ?atda Real)
    (assert
      (or (or (= ?atcz ?atcy)
          (= ?atcz ?atcx)
          )
        (= ?atcy ?atcx)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atdb Real)
    (declare-const ?atdc Real)
    (declare-const ?atdd Real)
    (declare-const ?atde Real)
    (declare-const ?atdf Real)
    (assert
      (or (or (= ?atdd ?atdc)
          (= ?atdd ?atdb)
          )
        (= ?atdc ?atdb)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atdg Real)
    (declare-const ?atdh Real)
    (declare-const ?atdi Real)
    (declare-const ?atdj Real)
    (declare-const ?atdk Real)
    (declare-const ?atdl Real)
    (assert
      (and (or (or (= ?atdi ?atdh)
            (= ?atdi ?atdg)
            )
          (= ?atdh ?atdg)
          )
        (and (and (not (= ?atdl ?atdk))
            (not (= ?atdl ?atdj))
            )
          (not (= ?atdk ?atdj))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atdm Real)
    (declare-const ?atdn Real)
    (declare-const ?atdo Real)
    (assert
      (or (or (= ?atdo ?atdn)
          (= ?atdo ?atdm)
          )
        (= ?atdn ?atdm)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atdp Real)
    (declare-const ?atdq Real)
    (declare-const ?atdr Real)
    (declare-const ?atds Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?atdq ?atdp))
                (not (= ?atdq ?asi))
                )
              (not (= ?atdp ?asi))
              )
            (or (or (= ?atds ?atdr)
                (= ?atds ?asi)
                )
              (= ?atdr ?asi)
              )
            )
          (and (or (or (= ?atdq ?atdp)
                (= ?atdq ?asi)
                )
              (= ?atdp ?asi)
              )
            (and (and (not (= ?atds ?atdr))
                (not (= ?atds ?asi))
                )
              (not (= ?atdr ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atdt Real)
    (declare-const ?atdu Real)
    (declare-const ?atdv Real)
    (declare-const ?atdw Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?atdu ?atdt))
                (not (= ?atdu ?fkf))
                )
              (not (= ?atdt ?fkf))
              )
            (or (or (= ?atdw ?atdv)
                (= ?atdw ?fkf)
                )
              (= ?atdv ?fkf)
              )
            )
          (and (or (or (= ?atdu ?atdt)
                (= ?atdu ?fkf)
                )
              (= ?atdt ?fkf)
              )
            (and (and (not (= ?atdw ?atdv))
                (not (= ?atdw ?fkf))
                )
              (not (= ?atdv ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atdx Real)
    (declare-const ?atdy Real)
    (declare-const ?atdz Real)
    (declare-const ?atea Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?atdy ?atdx))
                (not (= ?atdy ?mzs))
                )
              (not (= ?atdx ?mzs))
              )
            (or (or (= ?atea ?atdz)
                (= ?atea ?mzs)
                )
              (= ?atdz ?mzs)
              )
            )
          (and (or (or (= ?atdy ?atdx)
                (= ?atdy ?mzs)
                )
              (= ?atdx ?mzs)
              )
            (and (and (not (= ?atea ?atdz))
                (not (= ?atea ?mzs))
                )
              (not (= ?atdz ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ateb Real)
    (declare-const ?atec Real)
    (declare-const ?ated Real)
    (declare-const ?atee Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?atec ?ateb))
                (not (= ?atec ?zpl))
                )
              (not (= ?ateb ?zpl))
              )
            (or (or (= ?atee ?ated)
                (= ?atee ?zpl)
                )
              (= ?ated ?zpl)
              )
            )
          (and (or (or (= ?atec ?ateb)
                (= ?atec ?zpl)
                )
              (= ?ateb ?zpl)
              )
            (and (and (not (= ?atee ?ated))
                (not (= ?atee ?zpl))
                )
              (not (= ?ated ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?atef Real)
  (declare-const ?ateg Real)
  (push 1)
    (declare-const ?ateh Real)
    (declare-const ?atei Real)
    (declare-const ?atej Real)
    (assert
      (or (or (= ?atej ?atei)
          (= ?atej ?ateh)
          )
        (= ?atei ?ateh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atek Real)
    (declare-const ?atel Real)
    (declare-const ?atem Real)
    (declare-const ?aten Real)
    (assert
      (or (or (= ?aten ?atem)
          (= ?aten ?atel)
          )
        (= ?atem ?atel)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?ateo Real)
    (declare-const ?atep Real)
    (declare-const ?ateq Real)
    (declare-const ?ater Real)
    (declare-const ?ates Real)
    (assert
      (or (or (= ?ates ?ater)
          (= ?ates ?ateq)
          )
        (= ?ater ?ateq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atet Real)
    (declare-const ?ateu Real)
    (declare-const ?atev Real)
    (declare-const ?atew Real)
    (declare-const ?atex Real)
    (declare-const ?atey Real)
    (assert
      (and (and (and (not (= ?atev ?ateu))
            (not (= ?atev ?atet))
            )
          (not (= ?ateu ?atet))
          )
        (or (or (= ?atey ?atex)
            (= ?atey ?atew)
            )
          (= ?atex ?atew)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atez Real)
    (declare-const ?atfa Real)
    (declare-const ?atfb Real)
    (assert
      (or (or (= ?atfb ?atfa)
          (= ?atfb ?atez)
          )
        (= ?atfa ?atez)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atfc Real)
    (declare-const ?atfd Real)
    (declare-const ?atfe Real)
    (assert
      (or (or (= ?atfe ?atfd)
          (= ?atfe ?atfc)
          )
        (= ?atfd ?atfc)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atff Real)
    (declare-const ?atfg Real)
    (declare-const ?atfh Real)
    (declare-const ?atfi Real)
    (assert
      (or (or (= ?atfh ?atfg)
          (= ?atfh ?atff)
          )
        (= ?atfg ?atff)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atfj Real)
    (declare-const ?atfk Real)
    (declare-const ?atfl Real)
    (declare-const ?atfm Real)
    (declare-const ?atfn Real)
    (assert
      (or (or (= ?atfl ?atfk)
          (= ?atfl ?atfj)
          )
        (= ?atfk ?atfj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atfo Real)
    (declare-const ?atfp Real)
    (declare-const ?atfq Real)
    (declare-const ?atfr Real)
    (declare-const ?atfs Real)
    (declare-const ?atft Real)
    (assert
      (and (or (or (= ?atfq ?atfp)
            (= ?atfq ?atfo)
            )
          (= ?atfp ?atfo)
          )
        (and (and (not (= ?atft ?atfs))
            (not (= ?atft ?atfr))
            )
          (not (= ?atfs ?atfr))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atfu Real)
    (declare-const ?atfv Real)
    (declare-const ?atfw Real)
    (assert
      (or (or (= ?atfw ?atfv)
          (= ?atfw ?atfu)
          )
        (= ?atfv ?atfu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atfx Real)
    (declare-const ?atfy Real)
    (declare-const ?atfz Real)
    (declare-const ?atga Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?atfy ?atfx))
                (not (= ?atfy ?asi))
                )
              (not (= ?atfx ?asi))
              )
            (or (or (= ?atga ?atfz)
                (= ?atga ?asi)
                )
              (= ?atfz ?asi)
              )
            )
          (and (or (or (= ?atfy ?atfx)
                (= ?atfy ?asi)
                )
              (= ?atfx ?asi)
              )
            (and (and (not (= ?atga ?atfz))
                (not (= ?atga ?asi))
                )
              (not (= ?atfz ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atgb Real)
    (declare-const ?atgc Real)
    (declare-const ?atgd Real)
    (declare-const ?atge Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?atgc ?atgb))
                (not (= ?atgc ?fkf))
                )
              (not (= ?atgb ?fkf))
              )
            (or (or (= ?atge ?atgd)
                (= ?atge ?fkf)
                )
              (= ?atgd ?fkf)
              )
            )
          (and (or (or (= ?atgc ?atgb)
                (= ?atgc ?fkf)
                )
              (= ?atgb ?fkf)
              )
            (and (and (not (= ?atge ?atgd))
                (not (= ?atge ?fkf))
                )
              (not (= ?atgd ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atgf Real)
    (declare-const ?atgg Real)
    (declare-const ?atgh Real)
    (declare-const ?atgi Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?atgg ?atgf))
                (not (= ?atgg ?mzs))
                )
              (not (= ?atgf ?mzs))
              )
            (or (or (= ?atgi ?atgh)
                (= ?atgi ?mzs)
                )
              (= ?atgh ?mzs)
              )
            )
          (and (or (or (= ?atgg ?atgf)
                (= ?atgg ?mzs)
                )
              (= ?atgf ?mzs)
              )
            (and (and (not (= ?atgi ?atgh))
                (not (= ?atgi ?mzs))
                )
              (not (= ?atgh ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atgj Real)
    (declare-const ?atgk Real)
    (declare-const ?atgl Real)
    (declare-const ?atgm Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?atgk ?atgj))
                (not (= ?atgk ?zpl))
                )
              (not (= ?atgj ?zpl))
              )
            (or (or (= ?atgm ?atgl)
                (= ?atgm ?zpl)
                )
              (= ?atgl ?zpl)
              )
            )
          (and (or (or (= ?atgk ?atgj)
                (= ?atgk ?zpl)
                )
              (= ?atgj ?zpl)
              )
            (and (and (not (= ?atgm ?atgl))
                (not (= ?atgm ?zpl))
                )
              (not (= ?atgl ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?atgn Real)
  (declare-const ?atgo Real)
  (declare-const ?atgp Real)
  (push 1)
    (declare-const ?atgq Real)
    (declare-const ?atgr Real)
    (declare-const ?atgs Real)
    (assert
      (or (or (= ?atgs ?atgr)
          (= ?atgs ?atgq)
          )
        (= ?atgr ?atgq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atgt Real)
    (declare-const ?atgu Real)
    (declare-const ?atgv Real)
    (declare-const ?atgw Real)
    (assert
      (or (or (= ?atgw ?atgv)
          (= ?atgw ?atgu)
          )
        (= ?atgv ?atgu)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atgx Real)
    (declare-const ?atgy Real)
    (declare-const ?atgz Real)
    (declare-const ?atha Real)
    (declare-const ?athb Real)
    (assert
      (or (or (= ?athb ?atha)
          (= ?athb ?atgz)
          )
        (= ?atha ?atgz)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?athc Real)
    (declare-const ?athd Real)
    (declare-const ?athe Real)
    (declare-const ?athf Real)
    (declare-const ?athg Real)
    (declare-const ?athh Real)
    (assert
      (and (and (and (not (= ?athe ?athd))
            (not (= ?athe ?athc))
            )
          (not (= ?athd ?athc))
          )
        (or (or (= ?athh ?athg)
            (= ?athh ?athf)
            )
          (= ?athg ?athf)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?athi Real)
    (declare-const ?athj Real)
    (declare-const ?athk Real)
    (assert
      (or (or (= ?athk ?athj)
          (= ?athk ?athi)
          )
        (= ?athj ?athi)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?athl Real)
    (declare-const ?athm Real)
    (declare-const ?athn Real)
    (assert
      (or (or (= ?athn ?athm)
          (= ?athn ?athl)
          )
        (= ?athm ?athl)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atho Real)
    (declare-const ?athp Real)
    (declare-const ?athq Real)
    (declare-const ?athr Real)
    (assert
      (or (or (= ?athq ?athp)
          (= ?athq ?atho)
          )
        (= ?athp ?atho)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?aths Real)
    (declare-const ?atht Real)
    (declare-const ?athu Real)
    (declare-const ?athv Real)
    (declare-const ?athw Real)
    (assert
      (or (or (= ?athu ?atht)
          (= ?athu ?aths)
          )
        (= ?atht ?aths)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?athx Real)
    (declare-const ?athy Real)
    (declare-const ?athz Real)
    (declare-const ?atia Real)
    (declare-const ?atib Real)
    (declare-const ?atic Real)
    (assert
      (and (or (or (= ?athz ?athy)
            (= ?athz ?athx)
            )
          (= ?athy ?athx)
          )
        (and (and (not (= ?atic ?atib))
            (not (= ?atic ?atia))
            )
          (not (= ?atib ?atia))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atid Real)
    (declare-const ?atie Real)
    (declare-const ?atif Real)
    (assert
      (or (or (= ?atif ?atie)
          (= ?atif ?atid)
          )
        (= ?atie ?atid)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atig Real)
    (declare-const ?atih Real)
    (declare-const ?atii Real)
    (declare-const ?atij Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?atih ?atig))
                (not (= ?atih ?asi))
                )
              (not (= ?atig ?asi))
              )
            (or (or (= ?atij ?atii)
                (= ?atij ?asi)
                )
              (= ?atii ?asi)
              )
            )
          (and (or (or (= ?atih ?atig)
                (= ?atih ?asi)
                )
              (= ?atig ?asi)
              )
            (and (and (not (= ?atij ?atii))
                (not (= ?atij ?asi))
                )
              (not (= ?atii ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atik Real)
    (declare-const ?atil Real)
    (declare-const ?atim Real)
    (declare-const ?atin Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?atil ?atik))
                (not (= ?atil ?fkf))
                )
              (not (= ?atik ?fkf))
              )
            (or (or (= ?atin ?atim)
                (= ?atin ?fkf)
                )
              (= ?atim ?fkf)
              )
            )
          (and (or (or (= ?atil ?atik)
                (= ?atil ?fkf)
                )
              (= ?atik ?fkf)
              )
            (and (and (not (= ?atin ?atim))
                (not (= ?atin ?fkf))
                )
              (not (= ?atim ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atio Real)
    (declare-const ?atip Real)
    (declare-const ?atiq Real)
    (declare-const ?atir Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?atip ?atio))
                (not (= ?atip ?mzs))
                )
              (not (= ?atio ?mzs))
              )
            (or (or (= ?atir ?atiq)
                (= ?atir ?mzs)
                )
              (= ?atiq ?mzs)
              )
            )
          (and (or (or (= ?atip ?atio)
                (= ?atip ?mzs)
                )
              (= ?atio ?mzs)
              )
            (and (and (not (= ?atir ?atiq))
                (not (= ?atir ?mzs))
                )
              (not (= ?atiq ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atis Real)
    (declare-const ?atit Real)
    (declare-const ?atiu Real)
    (declare-const ?ativ Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?atit ?atis))
                (not (= ?atit ?zpl))
                )
              (not (= ?atis ?zpl))
              )
            (or (or (= ?ativ ?atiu)
                (= ?ativ ?zpl)
                )
              (= ?atiu ?zpl)
              )
            )
          (and (or (or (= ?atit ?atis)
                (= ?atit ?zpl)
                )
              (= ?atis ?zpl)
              )
            (and (and (not (= ?ativ ?atiu))
                (not (= ?ativ ?zpl))
                )
              (not (= ?atiu ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (assert
      (and (and (not (= ?atgp ?atgo))
          (not (= ?atgp ?atgn))
          )
        (not (= ?atgo ?atgn))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?atiw Real)
    (declare-const ?atix Real)
    (declare-const ?atiy Real)
    (assert
      (or (or (= ?atiy ?atix)
          (= ?atiy ?atiw)
          )
        (= ?atix ?atiw)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atiz Real)
    (declare-const ?atja Real)
    (declare-const ?atjb Real)
    (declare-const ?atjc Real)
    (assert
      (or (or (= ?atjc ?atjb)
          (= ?atjc ?atja)
          )
        (= ?atjb ?atja)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atjd Real)
    (declare-const ?atje Real)
    (declare-const ?atjf Real)
    (declare-const ?atjg Real)
    (declare-const ?atjh Real)
    (assert
      (or (or (= ?atjh ?atjg)
          (= ?atjh ?atjf)
          )
        (= ?atjg ?atjf)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atji Real)
    (declare-const ?atjj Real)
    (declare-const ?atjk Real)
    (declare-const ?atjl Real)
    (declare-const ?atjm Real)
    (declare-const ?atjn Real)
    (assert
      (and (and (and (not (= ?atjk ?atjj))
            (not (= ?atjk ?atji))
            )
          (not (= ?atjj ?atji))
          )
        (or (or (= ?atjn ?atjm)
            (= ?atjn ?atjl)
            )
          (= ?atjm ?atjl)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atjo Real)
    (declare-const ?atjp Real)
    (declare-const ?atjq Real)
    (assert
      (or (or (= ?atjq ?atjp)
          (= ?atjq ?atjo)
          )
        (= ?atjp ?atjo)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atjr Real)
    (declare-const ?atjs Real)
    (declare-const ?atjt Real)
    (assert
      (or (or (= ?atjt ?atjs)
          (= ?atjt ?atjr)
          )
        (= ?atjs ?atjr)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atju Real)
    (declare-const ?atjv Real)
    (declare-const ?atjw Real)
    (declare-const ?atjx Real)
    (assert
      (or (or (= ?atjw ?atjv)
          (= ?atjw ?atju)
          )
        (= ?atjv ?atju)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atjy Real)
    (declare-const ?atjz Real)
    (declare-const ?atka Real)
    (declare-const ?atkb Real)
    (declare-const ?atkc Real)
    (assert
      (or (or (= ?atka ?atjz)
          (= ?atka ?atjy)
          )
        (= ?atjz ?atjy)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atkd Real)
    (declare-const ?atke Real)
    (declare-const ?atkf Real)
    (declare-const ?atkg Real)
    (declare-const ?atkh Real)
    (declare-const ?atki Real)
    (assert
      (and (or (or (= ?atkf ?atke)
            (= ?atkf ?atkd)
            )
          (= ?atke ?atkd)
          )
        (and (and (not (= ?atki ?atkh))
            (not (= ?atki ?atkg))
            )
          (not (= ?atkh ?atkg))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atkj Real)
    (declare-const ?atkk Real)
    (declare-const ?atkl Real)
    (assert
      (or (or (= ?atkl ?atkk)
          (= ?atkl ?atkj)
          )
        (= ?atkk ?atkj)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atkm Real)
    (declare-const ?atkn Real)
    (declare-const ?atko Real)
    (declare-const ?atkp Real)
    (assert
      (exists ((?asi Real) )(or (and (and (and (not (= ?atkn ?atkm))
                (not (= ?atkn ?asi))
                )
              (not (= ?atkm ?asi))
              )
            (or (or (= ?atkp ?atko)
                (= ?atkp ?asi)
                )
              (= ?atko ?asi)
              )
            )
          (and (or (or (= ?atkn ?atkm)
                (= ?atkn ?asi)
                )
              (= ?atkm ?asi)
              )
            (and (and (not (= ?atkp ?atko))
                (not (= ?atkp ?asi))
                )
              (not (= ?atko ?asi))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atkq Real)
    (declare-const ?atkr Real)
    (declare-const ?atks Real)
    (declare-const ?atkt Real)
    (assert
      (exists ((?fkf Real) )(or (and (and (and (not (= ?atkr ?atkq))
                (not (= ?atkr ?fkf))
                )
              (not (= ?atkq ?fkf))
              )
            (or (or (= ?atkt ?atks)
                (= ?atkt ?fkf)
                )
              (= ?atks ?fkf)
              )
            )
          (and (or (or (= ?atkr ?atkq)
                (= ?atkr ?fkf)
                )
              (= ?atkq ?fkf)
              )
            (and (and (not (= ?atkt ?atks))
                (not (= ?atkt ?fkf))
                )
              (not (= ?atks ?fkf))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atku Real)
    (declare-const ?atkv Real)
    (declare-const ?atkw Real)
    (declare-const ?atkx Real)
    (assert
      (exists ((?mzs Real) )(or (and (and (and (not (= ?atkv ?atku))
                (not (= ?atkv ?mzs))
                )
              (not (= ?atku ?mzs))
              )
            (or (or (= ?atkx ?atkw)
                (= ?atkx ?mzs)
                )
              (= ?atkw ?mzs)
              )
            )
          (and (or (or (= ?atkv ?atku)
                (= ?atkv ?mzs)
                )
              (= ?atku ?mzs)
              )
            (and (and (not (= ?atkx ?atkw))
                (not (= ?atkx ?mzs))
                )
              (not (= ?atkw ?mzs))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?atky Real)
    (declare-const ?atkz Real)
    (declare-const ?atla Real)
    (declare-const ?atlb Real)
    (assert
      (exists ((?zpl Real) )(or (and (and (and (not (= ?atkz ?atky))
                (not (= ?atkz ?zpl))
                )
              (not (= ?atky ?zpl))
              )
            (or (or (= ?atlb ?atla)
                (= ?atlb ?zpl)
                )
              (= ?atla ?zpl)
              )
            )
          (and (or (or (= ?atkz ?atky)
                (= ?atkz ?zpl)
                )
              (= ?atky ?zpl)
              )
            (and (and (not (= ?atlb ?atla))
                (not (= ?atlb ?zpl))
                )
              (not (= ?atla ?zpl))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?atlc Real)
  (declare-const ?atld Real)
  (declare-const ?atle Real)
  (declare-const ?atlf Real)
  (assert
    (forall ((?asi Real) )(and (or (or (or (= ?atld ?atlc)
              (= ?atld ?asi)
              )
            (= ?atlc ?asi)
            )
          (and (and (not (= ?atlf ?atle))
              (not (= ?atlf ?asi))
              )
            (not (= ?atle ?asi))
            )
          )
        (or (and (and (not (= ?atld ?atlc))
              (not (= ?atld ?asi))
              )
            (not (= ?atlc ?asi))
            )
          (or (or (= ?atlf ?atle)
              (= ?atlf ?asi)
              )
            (= ?atle ?asi)
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?atlg Real)
  (declare-const ?atlh Real)
  (declare-const ?atli Real)
  (declare-const ?atlj Real)
  (declare-const ?atlk Real)
  (declare-const ?atll Real)
  (assert
    (and (or (or (or (= ?atli ?atlh)
            (= ?atli ?atlg)
            )
          (= ?atlh ?atlg)
          )
        (and (and (not (= ?atll ?atlk))
            (not (= ?atll ?atlj))
            )
          (not (= ?atlk ?atlj))
          )
        )
      (or (and (and (not (= ?atli ?atlh))
            (not (= ?atli ?atlg))
            )
          (not (= ?atlh ?atlg))
          )
        (or (or (= ?atll ?atlk)
            (= ?atll ?atlj)
            )
          (= ?atlk ?atlj)
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?atlm Real)
  (declare-const ?atln Real)
  (declare-const ?atlo Real)
  (assert
    (and (and (not (= ?atlo ?atln))
        (not (= ?atlo ?atlm))
        )
      (not (= ?atln ?atlm))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?atlp Real)
  (declare-const ?atlq Real)
  (declare-const ?atlr Real)
  (assert
    (and (and (not (= ?atlr ?atlq))
        (not (= ?atlr ?atlp))
        )
      (not (= ?atlq ?atlp))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?atls Real)
  (declare-const ?atlt Real)
  (declare-const ?atlu Real)
  (declare-const ?atlv Real)
  (assert
    (forall ((?asi Real) )(and (or (or (or (= ?atlt ?atls)
              (= ?atlt ?asi)
              )
            (= ?atls ?asi)
            )
          (and (and (not (= ?atlv ?atlu))
              (not (= ?atlv ?asi))
              )
            (not (= ?atlu ?asi))
            )
          )
        (or (and (and (not (= ?atlt ?atls))
              (not (= ?atlt ?asi))
              )
            (not (= ?atls ?asi))
            )
          (or (or (= ?atlv ?atlu)
              (= ?atlv ?asi)
              )
            (= ?atlu ?asi)
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?atlw Real)
  (declare-const ?atlx Real)
  (declare-const ?atly Real)
  (declare-const ?atlz Real)
  (declare-const ?atma Real)
  (declare-const ?atmb Real)
  (assert
    (and (or (or (or (= ?atly ?atlx)
            (= ?atly ?atlw)
            )
          (= ?atlx ?atlw)
          )
        (and (and (not (= ?atmb ?atma))
            (not (= ?atmb ?atlz))
            )
          (not (= ?atma ?atlz))
          )
        )
      (or (and (and (not (= ?atly ?atlx))
            (not (= ?atly ?atlw))
            )
          (not (= ?atlx ?atlw))
          )
        (or (or (= ?atmb ?atma)
            (= ?atmb ?atlz)
            )
          (= ?atma ?atlz)
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?atmc Real)
  (declare-const ?atmd Real)
  (declare-const ?atme Real)
  (assert
    (and (and (not (= ?atme ?atmd))
        (not (= ?atme ?atmc))
        )
      (not (= ?atmd ?atmc))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?atmf Real)
  (declare-const ?atmg Real)
  (declare-const ?atmh Real)
  (assert
    (and (and (not (= ?atmh ?atmg))
        (not (= ?atmh ?atmf))
        )
      (not (= ?atmg ?atmf))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (push 1)
    (push 1)
      (declare-const ?atmi Real)
      (declare-const ?atmj Real)
      (declare-const ?atmk Real)
      (declare-const ?atml Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?atmj ?atmi)
                  (= ?atmj ?asi)
                  )
                (= ?atmi ?asi)
                )
              (and (and (not (= ?atml ?atmk))
                  (not (= ?atml ?asi))
                  )
                (not (= ?atmk ?asi))
                )
              )
            (or (and (and (not (= ?atmj ?atmi))
                  (not (= ?atmj ?asi))
                  )
                (not (= ?atmi ?asi))
                )
              (or (or (= ?atml ?atmk)
                  (= ?atml ?asi)
                  )
                (= ?atmk ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atmm Real)
      (declare-const ?atmn Real)
      (declare-const ?atmo Real)
      (declare-const ?atmp Real)
      (declare-const ?atmq Real)
      (declare-const ?atmr Real)
      (assert
        (and (or (or (or (= ?atmo ?atmn)
                (= ?atmo ?atmm)
                )
              (= ?atmn ?atmm)
              )
            (and (and (not (= ?atmr ?atmq))
                (not (= ?atmr ?atmp))
                )
              (not (= ?atmq ?atmp))
              )
            )
          (or (and (and (not (= ?atmo ?atmn))
                (not (= ?atmo ?atmm))
                )
              (not (= ?atmn ?atmm))
              )
            (or (or (= ?atmr ?atmq)
                (= ?atmr ?atmp)
                )
              (= ?atmq ?atmp)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atms Real)
      (declare-const ?atmt Real)
      (declare-const ?atmu Real)
      (assert
        (and (and (not (= ?atmu ?atmt))
            (not (= ?atmu ?atms))
            )
          (not (= ?atmt ?atms))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atmv Real)
      (declare-const ?atmw Real)
      (declare-const ?atmx Real)
      (assert
        (and (and (not (= ?atmx ?atmw))
            (not (= ?atmx ?atmv))
            )
          (not (= ?atmw ?atmv))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?atmy Real)
    (push 1)
      (declare-const ?atmz Real)
      (declare-const ?atna Real)
      (declare-const ?atnb Real)
      (declare-const ?atnc Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?atna ?atmz)
                  (= ?atna ?asi)
                  )
                (= ?atmz ?asi)
                )
              (and (and (not (= ?atnc ?atnb))
                  (not (= ?atnc ?asi))
                  )
                (not (= ?atnb ?asi))
                )
              )
            (or (and (and (not (= ?atna ?atmz))
                  (not (= ?atna ?asi))
                  )
                (not (= ?atmz ?asi))
                )
              (or (or (= ?atnc ?atnb)
                  (= ?atnc ?asi)
                  )
                (= ?atnb ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atnd Real)
      (declare-const ?atne Real)
      (declare-const ?atnf Real)
      (declare-const ?atng Real)
      (declare-const ?atnh Real)
      (declare-const ?atni Real)
      (assert
        (and (or (or (or (= ?atnf ?atne)
                (= ?atnf ?atnd)
                )
              (= ?atne ?atnd)
              )
            (and (and (not (= ?atni ?atnh))
                (not (= ?atni ?atng))
                )
              (not (= ?atnh ?atng))
              )
            )
          (or (and (and (not (= ?atnf ?atne))
                (not (= ?atnf ?atnd))
                )
              (not (= ?atne ?atnd))
              )
            (or (or (= ?atni ?atnh)
                (= ?atni ?atng)
                )
              (= ?atnh ?atng)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atnj Real)
      (declare-const ?atnk Real)
      (declare-const ?atnl Real)
      (assert
        (and (and (not (= ?atnl ?atnk))
            (not (= ?atnl ?atnj))
            )
          (not (= ?atnk ?atnj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atnm Real)
      (declare-const ?atnn Real)
      (declare-const ?atno Real)
      (assert
        (and (and (not (= ?atno ?atnn))
            (not (= ?atno ?atnm))
            )
          (not (= ?atnn ?atnm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?atnp Real)
    (declare-const ?atnq Real)
    (push 1)
      (declare-const ?atnr Real)
      (declare-const ?atns Real)
      (declare-const ?atnt Real)
      (declare-const ?atnu Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?atns ?atnr)
                  (= ?atns ?asi)
                  )
                (= ?atnr ?asi)
                )
              (and (and (not (= ?atnu ?atnt))
                  (not (= ?atnu ?asi))
                  )
                (not (= ?atnt ?asi))
                )
              )
            (or (and (and (not (= ?atns ?atnr))
                  (not (= ?atns ?asi))
                  )
                (not (= ?atnr ?asi))
                )
              (or (or (= ?atnu ?atnt)
                  (= ?atnu ?asi)
                  )
                (= ?atnt ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atnv Real)
      (declare-const ?atnw Real)
      (declare-const ?atnx Real)
      (declare-const ?atny Real)
      (declare-const ?atnz Real)
      (declare-const ?atoa Real)
      (assert
        (and (or (or (or (= ?atnx ?atnw)
                (= ?atnx ?atnv)
                )
              (= ?atnw ?atnv)
              )
            (and (and (not (= ?atoa ?atnz))
                (not (= ?atoa ?atny))
                )
              (not (= ?atnz ?atny))
              )
            )
          (or (and (and (not (= ?atnx ?atnw))
                (not (= ?atnx ?atnv))
                )
              (not (= ?atnw ?atnv))
              )
            (or (or (= ?atoa ?atnz)
                (= ?atoa ?atny)
                )
              (= ?atnz ?atny)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atob Real)
      (declare-const ?atoc Real)
      (declare-const ?atod Real)
      (assert
        (and (and (not (= ?atod ?atoc))
            (not (= ?atod ?atob))
            )
          (not (= ?atoc ?atob))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atoe Real)
      (declare-const ?atof Real)
      (declare-const ?atog Real)
      (assert
        (and (and (not (= ?atog ?atof))
            (not (= ?atog ?atoe))
            )
          (not (= ?atof ?atoe))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?atoh Real)
    (declare-const ?atoi Real)
    (declare-const ?atoj Real)
    (push 1)
      (declare-const ?atok Real)
      (declare-const ?atol Real)
      (declare-const ?atom Real)
      (declare-const ?aton Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?atol ?atok)
                  (= ?atol ?asi)
                  )
                (= ?atok ?asi)
                )
              (and (and (not (= ?aton ?atom))
                  (not (= ?aton ?asi))
                  )
                (not (= ?atom ?asi))
                )
              )
            (or (and (and (not (= ?atol ?atok))
                  (not (= ?atol ?asi))
                  )
                (not (= ?atok ?asi))
                )
              (or (or (= ?aton ?atom)
                  (= ?aton ?asi)
                  )
                (= ?atom ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atoo Real)
      (declare-const ?atop Real)
      (declare-const ?atoq Real)
      (declare-const ?ator Real)
      (declare-const ?atos Real)
      (declare-const ?atot Real)
      (assert
        (and (or (or (or (= ?atoq ?atop)
                (= ?atoq ?atoo)
                )
              (= ?atop ?atoo)
              )
            (and (and (not (= ?atot ?atos))
                (not (= ?atot ?ator))
                )
              (not (= ?atos ?ator))
              )
            )
          (or (and (and (not (= ?atoq ?atop))
                (not (= ?atoq ?atoo))
                )
              (not (= ?atop ?atoo))
              )
            (or (or (= ?atot ?atos)
                (= ?atot ?ator)
                )
              (= ?atos ?ator)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atou Real)
      (declare-const ?atov Real)
      (declare-const ?atow Real)
      (assert
        (and (and (not (= ?atow ?atov))
            (not (= ?atow ?atou))
            )
          (not (= ?atov ?atou))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atox Real)
      (declare-const ?atoy Real)
      (declare-const ?atoz Real)
      (assert
        (and (and (not (= ?atoz ?atoy))
            (not (= ?atoz ?atox))
            )
          (not (= ?atoy ?atox))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?atpa Real)
      (declare-const ?atpb Real)
      (declare-const ?atpc Real)
      (declare-const ?atpd Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?atpb ?atpa)
                  (= ?atpb ?asi)
                  )
                (= ?atpa ?asi)
                )
              (and (and (not (= ?atpd ?atpc))
                  (not (= ?atpd ?asi))
                  )
                (not (= ?atpc ?asi))
                )
              )
            (or (and (and (not (= ?atpb ?atpa))
                  (not (= ?atpb ?asi))
                  )
                (not (= ?atpa ?asi))
                )
              (or (or (= ?atpd ?atpc)
                  (= ?atpd ?asi)
                  )
                (= ?atpc ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atpe Real)
      (declare-const ?atpf Real)
      (declare-const ?atpg Real)
      (declare-const ?atph Real)
      (declare-const ?atpi Real)
      (declare-const ?atpj Real)
      (assert
        (and (or (or (or (= ?atpg ?atpf)
                (= ?atpg ?atpe)
                )
              (= ?atpf ?atpe)
              )
            (and (and (not (= ?atpj ?atpi))
                (not (= ?atpj ?atph))
                )
              (not (= ?atpi ?atph))
              )
            )
          (or (and (and (not (= ?atpg ?atpf))
                (not (= ?atpg ?atpe))
                )
              (not (= ?atpf ?atpe))
              )
            (or (or (= ?atpj ?atpi)
                (= ?atpj ?atph)
                )
              (= ?atpi ?atph)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atpk Real)
      (declare-const ?atpl Real)
      (declare-const ?atpm Real)
      (assert
        (and (and (not (= ?atpm ?atpl))
            (not (= ?atpm ?atpk))
            )
          (not (= ?atpl ?atpk))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atpn Real)
      (declare-const ?atpo Real)
      (declare-const ?atpp Real)
      (assert
        (and (and (not (= ?atpp ?atpo))
            (not (= ?atpp ?atpn))
            )
          (not (= ?atpo ?atpn))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?atpq Real)
  (push 1)
    (push 1)
      (declare-const ?atpr Real)
      (declare-const ?atps Real)
      (declare-const ?atpt Real)
      (declare-const ?atpu Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?atps ?atpr)
                  (= ?atps ?asi)
                  )
                (= ?atpr ?asi)
                )
              (and (and (not (= ?atpu ?atpt))
                  (not (= ?atpu ?asi))
                  )
                (not (= ?atpt ?asi))
                )
              )
            (or (and (and (not (= ?atps ?atpr))
                  (not (= ?atps ?asi))
                  )
                (not (= ?atpr ?asi))
                )
              (or (or (= ?atpu ?atpt)
                  (= ?atpu ?asi)
                  )
                (= ?atpt ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atpv Real)
      (declare-const ?atpw Real)
      (declare-const ?atpx Real)
      (declare-const ?atpy Real)
      (declare-const ?atpz Real)
      (declare-const ?atqa Real)
      (assert
        (and (or (or (or (= ?atpx ?atpw)
                (= ?atpx ?atpv)
                )
              (= ?atpw ?atpv)
              )
            (and (and (not (= ?atqa ?atpz))
                (not (= ?atqa ?atpy))
                )
              (not (= ?atpz ?atpy))
              )
            )
          (or (and (and (not (= ?atpx ?atpw))
                (not (= ?atpx ?atpv))
                )
              (not (= ?atpw ?atpv))
              )
            (or (or (= ?atqa ?atpz)
                (= ?atqa ?atpy)
                )
              (= ?atpz ?atpy)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atqb Real)
      (declare-const ?atqc Real)
      (declare-const ?atqd Real)
      (assert
        (and (and (not (= ?atqd ?atqc))
            (not (= ?atqd ?atqb))
            )
          (not (= ?atqc ?atqb))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atqe Real)
      (declare-const ?atqf Real)
      (declare-const ?atqg Real)
      (assert
        (and (and (not (= ?atqg ?atqf))
            (not (= ?atqg ?atqe))
            )
          (not (= ?atqf ?atqe))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?atqh Real)
    (push 1)
      (declare-const ?atqi Real)
      (declare-const ?atqj Real)
      (declare-const ?atqk Real)
      (declare-const ?atql Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?atqj ?atqi)
                  (= ?atqj ?asi)
                  )
                (= ?atqi ?asi)
                )
              (and (and (not (= ?atql ?atqk))
                  (not (= ?atql ?asi))
                  )
                (not (= ?atqk ?asi))
                )
              )
            (or (and (and (not (= ?atqj ?atqi))
                  (not (= ?atqj ?asi))
                  )
                (not (= ?atqi ?asi))
                )
              (or (or (= ?atql ?atqk)
                  (= ?atql ?asi)
                  )
                (= ?atqk ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atqm Real)
      (declare-const ?atqn Real)
      (declare-const ?atqo Real)
      (declare-const ?atqp Real)
      (declare-const ?atqq Real)
      (declare-const ?atqr Real)
      (assert
        (and (or (or (or (= ?atqo ?atqn)
                (= ?atqo ?atqm)
                )
              (= ?atqn ?atqm)
              )
            (and (and (not (= ?atqr ?atqq))
                (not (= ?atqr ?atqp))
                )
              (not (= ?atqq ?atqp))
              )
            )
          (or (and (and (not (= ?atqo ?atqn))
                (not (= ?atqo ?atqm))
                )
              (not (= ?atqn ?atqm))
              )
            (or (or (= ?atqr ?atqq)
                (= ?atqr ?atqp)
                )
              (= ?atqq ?atqp)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atqs Real)
      (declare-const ?atqt Real)
      (declare-const ?atqu Real)
      (assert
        (and (and (not (= ?atqu ?atqt))
            (not (= ?atqu ?atqs))
            )
          (not (= ?atqt ?atqs))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atqv Real)
      (declare-const ?atqw Real)
      (declare-const ?atqx Real)
      (assert
        (and (and (not (= ?atqx ?atqw))
            (not (= ?atqx ?atqv))
            )
          (not (= ?atqw ?atqv))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?atqy Real)
    (declare-const ?atqz Real)
    (push 1)
      (declare-const ?atra Real)
      (declare-const ?atrb Real)
      (declare-const ?atrc Real)
      (declare-const ?atrd Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?atrb ?atra)
                  (= ?atrb ?asi)
                  )
                (= ?atra ?asi)
                )
              (and (and (not (= ?atrd ?atrc))
                  (not (= ?atrd ?asi))
                  )
                (not (= ?atrc ?asi))
                )
              )
            (or (and (and (not (= ?atrb ?atra))
                  (not (= ?atrb ?asi))
                  )
                (not (= ?atra ?asi))
                )
              (or (or (= ?atrd ?atrc)
                  (= ?atrd ?asi)
                  )
                (= ?atrc ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atre Real)
      (declare-const ?atrf Real)
      (declare-const ?atrg Real)
      (declare-const ?atrh Real)
      (declare-const ?atri Real)
      (declare-const ?atrj Real)
      (assert
        (and (or (or (or (= ?atrg ?atrf)
                (= ?atrg ?atre)
                )
              (= ?atrf ?atre)
              )
            (and (and (not (= ?atrj ?atri))
                (not (= ?atrj ?atrh))
                )
              (not (= ?atri ?atrh))
              )
            )
          (or (and (and (not (= ?atrg ?atrf))
                (not (= ?atrg ?atre))
                )
              (not (= ?atrf ?atre))
              )
            (or (or (= ?atrj ?atri)
                (= ?atrj ?atrh)
                )
              (= ?atri ?atrh)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atrk Real)
      (declare-const ?atrl Real)
      (declare-const ?atrm Real)
      (assert
        (and (and (not (= ?atrm ?atrl))
            (not (= ?atrm ?atrk))
            )
          (not (= ?atrl ?atrk))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atrn Real)
      (declare-const ?atro Real)
      (declare-const ?atrp Real)
      (assert
        (and (and (not (= ?atrp ?atro))
            (not (= ?atrp ?atrn))
            )
          (not (= ?atro ?atrn))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?atrq Real)
    (declare-const ?atrr Real)
    (declare-const ?atrs Real)
    (push 1)
      (declare-const ?atrt Real)
      (declare-const ?atru Real)
      (declare-const ?atrv Real)
      (declare-const ?atrw Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?atru ?atrt)
                  (= ?atru ?asi)
                  )
                (= ?atrt ?asi)
                )
              (and (and (not (= ?atrw ?atrv))
                  (not (= ?atrw ?asi))
                  )
                (not (= ?atrv ?asi))
                )
              )
            (or (and (and (not (= ?atru ?atrt))
                  (not (= ?atru ?asi))
                  )
                (not (= ?atrt ?asi))
                )
              (or (or (= ?atrw ?atrv)
                  (= ?atrw ?asi)
                  )
                (= ?atrv ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atrx Real)
      (declare-const ?atry Real)
      (declare-const ?atrz Real)
      (declare-const ?atsa Real)
      (declare-const ?atsb Real)
      (declare-const ?atsc Real)
      (assert
        (and (or (or (or (= ?atrz ?atry)
                (= ?atrz ?atrx)
                )
              (= ?atry ?atrx)
              )
            (and (and (not (= ?atsc ?atsb))
                (not (= ?atsc ?atsa))
                )
              (not (= ?atsb ?atsa))
              )
            )
          (or (and (and (not (= ?atrz ?atry))
                (not (= ?atrz ?atrx))
                )
              (not (= ?atry ?atrx))
              )
            (or (or (= ?atsc ?atsb)
                (= ?atsc ?atsa)
                )
              (= ?atsb ?atsa)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atsd Real)
      (declare-const ?atse Real)
      (declare-const ?atsf Real)
      (assert
        (and (and (not (= ?atsf ?atse))
            (not (= ?atsf ?atsd))
            )
          (not (= ?atse ?atsd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atsg Real)
      (declare-const ?atsh Real)
      (declare-const ?atsi Real)
      (assert
        (and (and (not (= ?atsi ?atsh))
            (not (= ?atsi ?atsg))
            )
          (not (= ?atsh ?atsg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?atsj Real)
      (declare-const ?atsk Real)
      (declare-const ?atsl Real)
      (declare-const ?atsm Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?atsk ?atsj)
                  (= ?atsk ?asi)
                  )
                (= ?atsj ?asi)
                )
              (and (and (not (= ?atsm ?atsl))
                  (not (= ?atsm ?asi))
                  )
                (not (= ?atsl ?asi))
                )
              )
            (or (and (and (not (= ?atsk ?atsj))
                  (not (= ?atsk ?asi))
                  )
                (not (= ?atsj ?asi))
                )
              (or (or (= ?atsm ?atsl)
                  (= ?atsm ?asi)
                  )
                (= ?atsl ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atsn Real)
      (declare-const ?atso Real)
      (declare-const ?atsp Real)
      (declare-const ?atsq Real)
      (declare-const ?atsr Real)
      (declare-const ?atss Real)
      (assert
        (and (or (or (or (= ?atsp ?atso)
                (= ?atsp ?atsn)
                )
              (= ?atso ?atsn)
              )
            (and (and (not (= ?atss ?atsr))
                (not (= ?atss ?atsq))
                )
              (not (= ?atsr ?atsq))
              )
            )
          (or (and (and (not (= ?atsp ?atso))
                (not (= ?atsp ?atsn))
                )
              (not (= ?atso ?atsn))
              )
            (or (or (= ?atss ?atsr)
                (= ?atss ?atsq)
                )
              (= ?atsr ?atsq)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atst Real)
      (declare-const ?atsu Real)
      (declare-const ?atsv Real)
      (assert
        (and (and (not (= ?atsv ?atsu))
            (not (= ?atsv ?atst))
            )
          (not (= ?atsu ?atst))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atsw Real)
      (declare-const ?atsx Real)
      (declare-const ?atsy Real)
      (assert
        (and (and (not (= ?atsy ?atsx))
            (not (= ?atsy ?atsw))
            )
          (not (= ?atsx ?atsw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?atsz Real)
  (declare-const ?atta Real)
  (push 1)
    (push 1)
      (declare-const ?attb Real)
      (declare-const ?attc Real)
      (declare-const ?attd Real)
      (declare-const ?atte Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?attc ?attb)
                  (= ?attc ?asi)
                  )
                (= ?attb ?asi)
                )
              (and (and (not (= ?atte ?attd))
                  (not (= ?atte ?asi))
                  )
                (not (= ?attd ?asi))
                )
              )
            (or (and (and (not (= ?attc ?attb))
                  (not (= ?attc ?asi))
                  )
                (not (= ?attb ?asi))
                )
              (or (or (= ?atte ?attd)
                  (= ?atte ?asi)
                  )
                (= ?attd ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?attf Real)
      (declare-const ?attg Real)
      (declare-const ?atth Real)
      (declare-const ?atti Real)
      (declare-const ?attj Real)
      (declare-const ?attk Real)
      (assert
        (and (or (or (or (= ?atth ?attg)
                (= ?atth ?attf)
                )
              (= ?attg ?attf)
              )
            (and (and (not (= ?attk ?attj))
                (not (= ?attk ?atti))
                )
              (not (= ?attj ?atti))
              )
            )
          (or (and (and (not (= ?atth ?attg))
                (not (= ?atth ?attf))
                )
              (not (= ?attg ?attf))
              )
            (or (or (= ?attk ?attj)
                (= ?attk ?atti)
                )
              (= ?attj ?atti)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?attl Real)
      (declare-const ?attm Real)
      (declare-const ?attn Real)
      (assert
        (and (and (not (= ?attn ?attm))
            (not (= ?attn ?attl))
            )
          (not (= ?attm ?attl))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atto Real)
      (declare-const ?attp Real)
      (declare-const ?attq Real)
      (assert
        (and (and (not (= ?attq ?attp))
            (not (= ?attq ?atto))
            )
          (not (= ?attp ?atto))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?attr Real)
    (push 1)
      (declare-const ?atts Real)
      (declare-const ?attt Real)
      (declare-const ?attu Real)
      (declare-const ?attv Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?attt ?atts)
                  (= ?attt ?asi)
                  )
                (= ?atts ?asi)
                )
              (and (and (not (= ?attv ?attu))
                  (not (= ?attv ?asi))
                  )
                (not (= ?attu ?asi))
                )
              )
            (or (and (and (not (= ?attt ?atts))
                  (not (= ?attt ?asi))
                  )
                (not (= ?atts ?asi))
                )
              (or (or (= ?attv ?attu)
                  (= ?attv ?asi)
                  )
                (= ?attu ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?attw Real)
      (declare-const ?attx Real)
      (declare-const ?atty Real)
      (declare-const ?attz Real)
      (declare-const ?atua Real)
      (declare-const ?atub Real)
      (assert
        (and (or (or (or (= ?atty ?attx)
                (= ?atty ?attw)
                )
              (= ?attx ?attw)
              )
            (and (and (not (= ?atub ?atua))
                (not (= ?atub ?attz))
                )
              (not (= ?atua ?attz))
              )
            )
          (or (and (and (not (= ?atty ?attx))
                (not (= ?atty ?attw))
                )
              (not (= ?attx ?attw))
              )
            (or (or (= ?atub ?atua)
                (= ?atub ?attz)
                )
              (= ?atua ?attz)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atuc Real)
      (declare-const ?atud Real)
      (declare-const ?atue Real)
      (assert
        (and (and (not (= ?atue ?atud))
            (not (= ?atue ?atuc))
            )
          (not (= ?atud ?atuc))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atuf Real)
      (declare-const ?atug Real)
      (declare-const ?atuh Real)
      (assert
        (and (and (not (= ?atuh ?atug))
            (not (= ?atuh ?atuf))
            )
          (not (= ?atug ?atuf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?atui Real)
    (declare-const ?atuj Real)
    (push 1)
      (declare-const ?atuk Real)
      (declare-const ?atul Real)
      (declare-const ?atum Real)
      (declare-const ?atun Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?atul ?atuk)
                  (= ?atul ?asi)
                  )
                (= ?atuk ?asi)
                )
              (and (and (not (= ?atun ?atum))
                  (not (= ?atun ?asi))
                  )
                (not (= ?atum ?asi))
                )
              )
            (or (and (and (not (= ?atul ?atuk))
                  (not (= ?atul ?asi))
                  )
                (not (= ?atuk ?asi))
                )
              (or (or (= ?atun ?atum)
                  (= ?atun ?asi)
                  )
                (= ?atum ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atuo Real)
      (declare-const ?atup Real)
      (declare-const ?atuq Real)
      (declare-const ?atur Real)
      (declare-const ?atus Real)
      (declare-const ?atut Real)
      (assert
        (and (or (or (or (= ?atuq ?atup)
                (= ?atuq ?atuo)
                )
              (= ?atup ?atuo)
              )
            (and (and (not (= ?atut ?atus))
                (not (= ?atut ?atur))
                )
              (not (= ?atus ?atur))
              )
            )
          (or (and (and (not (= ?atuq ?atup))
                (not (= ?atuq ?atuo))
                )
              (not (= ?atup ?atuo))
              )
            (or (or (= ?atut ?atus)
                (= ?atut ?atur)
                )
              (= ?atus ?atur)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atuu Real)
      (declare-const ?atuv Real)
      (declare-const ?atuw Real)
      (assert
        (and (and (not (= ?atuw ?atuv))
            (not (= ?atuw ?atuu))
            )
          (not (= ?atuv ?atuu))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atux Real)
      (declare-const ?atuy Real)
      (declare-const ?atuz Real)
      (assert
        (and (and (not (= ?atuz ?atuy))
            (not (= ?atuz ?atux))
            )
          (not (= ?atuy ?atux))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?atta ?atsz)
                  (= ?atta ?asi)
                  )
                (= ?atsz ?asi)
                )
              (and (and (not (= ?atuj ?atui))
                  (not (= ?atuj ?asi))
                  )
                (not (= ?atui ?asi))
                )
              )
            (or (and (and (not (= ?atta ?atsz))
                  (not (= ?atta ?asi))
                  )
                (not (= ?atsz ?asi))
                )
              (or (or (= ?atuj ?atui)
                  (= ?atuj ?asi)
                  )
                (= ?atui ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?atva Real)
    (declare-const ?atvb Real)
    (declare-const ?atvc Real)
    (push 1)
      (declare-const ?atvd Real)
      (declare-const ?atve Real)
      (declare-const ?atvf Real)
      (declare-const ?atvg Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?atve ?atvd)
                  (= ?atve ?asi)
                  )
                (= ?atvd ?asi)
                )
              (and (and (not (= ?atvg ?atvf))
                  (not (= ?atvg ?asi))
                  )
                (not (= ?atvf ?asi))
                )
              )
            (or (and (and (not (= ?atve ?atvd))
                  (not (= ?atve ?asi))
                  )
                (not (= ?atvd ?asi))
                )
              (or (or (= ?atvg ?atvf)
                  (= ?atvg ?asi)
                  )
                (= ?atvf ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atvh Real)
      (declare-const ?atvi Real)
      (declare-const ?atvj Real)
      (declare-const ?atvk Real)
      (declare-const ?atvl Real)
      (declare-const ?atvm Real)
      (assert
        (and (or (or (or (= ?atvj ?atvi)
                (= ?atvj ?atvh)
                )
              (= ?atvi ?atvh)
              )
            (and (and (not (= ?atvm ?atvl))
                (not (= ?atvm ?atvk))
                )
              (not (= ?atvl ?atvk))
              )
            )
          (or (and (and (not (= ?atvj ?atvi))
                (not (= ?atvj ?atvh))
                )
              (not (= ?atvi ?atvh))
              )
            (or (or (= ?atvm ?atvl)
                (= ?atvm ?atvk)
                )
              (= ?atvl ?atvk)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atvn Real)
      (declare-const ?atvo Real)
      (declare-const ?atvp Real)
      (assert
        (and (and (not (= ?atvp ?atvo))
            (not (= ?atvp ?atvn))
            )
          (not (= ?atvo ?atvn))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atvq Real)
      (declare-const ?atvr Real)
      (declare-const ?atvs Real)
      (assert
        (and (and (not (= ?atvs ?atvr))
            (not (= ?atvs ?atvq))
            )
          (not (= ?atvr ?atvq))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?atvt Real)
      (declare-const ?atvu Real)
      (declare-const ?atvv Real)
      (declare-const ?atvw Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?atvu ?atvt)
                  (= ?atvu ?asi)
                  )
                (= ?atvt ?asi)
                )
              (and (and (not (= ?atvw ?atvv))
                  (not (= ?atvw ?asi))
                  )
                (not (= ?atvv ?asi))
                )
              )
            (or (and (and (not (= ?atvu ?atvt))
                  (not (= ?atvu ?asi))
                  )
                (not (= ?atvt ?asi))
                )
              (or (or (= ?atvw ?atvv)
                  (= ?atvw ?asi)
                  )
                (= ?atvv ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atvx Real)
      (declare-const ?atvy Real)
      (declare-const ?atvz Real)
      (declare-const ?atwa Real)
      (declare-const ?atwb Real)
      (declare-const ?atwc Real)
      (assert
        (and (or (or (or (= ?atvz ?atvy)
                (= ?atvz ?atvx)
                )
              (= ?atvy ?atvx)
              )
            (and (and (not (= ?atwc ?atwb))
                (not (= ?atwc ?atwa))
                )
              (not (= ?atwb ?atwa))
              )
            )
          (or (and (and (not (= ?atvz ?atvy))
                (not (= ?atvz ?atvx))
                )
              (not (= ?atvy ?atvx))
              )
            (or (or (= ?atwc ?atwb)
                (= ?atwc ?atwa)
                )
              (= ?atwb ?atwa)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atwd Real)
      (declare-const ?atwe Real)
      (declare-const ?atwf Real)
      (assert
        (and (and (not (= ?atwf ?atwe))
            (not (= ?atwf ?atwd))
            )
          (not (= ?atwe ?atwd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atwg Real)
      (declare-const ?atwh Real)
      (declare-const ?atwi Real)
      (assert
        (and (and (not (= ?atwi ?atwh))
            (not (= ?atwi ?atwg))
            )
          (not (= ?atwh ?atwg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?atwj Real)
    (declare-const ?atwk Real)
    (assert
      (forall ((?asi Real) )(and (or (or (or (= ?atta ?atsz)
                (= ?atta ?asi)
                )
              (= ?atsz ?asi)
              )
            (not (= ?atwk ?atwj))
            )
          (or (and (and (not (= ?atta ?atsz))
                (not (= ?atta ?asi))
                )
              (not (= ?atsz ?asi))
              )
            (or (or (= ?atwk ?atwj)
                (= ?atwk ?asi)
                )
              (= ?atwj ?asi)
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?atwl Real)
  (declare-const ?atwm Real)
  (declare-const ?atwn Real)
  (push 1)
    (push 1)
      (declare-const ?atwo Real)
      (declare-const ?atwp Real)
      (declare-const ?atwq Real)
      (declare-const ?atwr Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?atwp ?atwo)
                  (= ?atwp ?asi)
                  )
                (= ?atwo ?asi)
                )
              (and (and (not (= ?atwr ?atwq))
                  (not (= ?atwr ?asi))
                  )
                (not (= ?atwq ?asi))
                )
              )
            (or (and (and (not (= ?atwp ?atwo))
                  (not (= ?atwp ?asi))
                  )
                (not (= ?atwo ?asi))
                )
              (or (or (= ?atwr ?atwq)
                  (= ?atwr ?asi)
                  )
                (= ?atwq ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atws Real)
      (declare-const ?atwt Real)
      (declare-const ?atwu Real)
      (declare-const ?atwv Real)
      (declare-const ?atww Real)
      (declare-const ?atwx Real)
      (assert
        (and (or (or (or (= ?atwu ?atwt)
                (= ?atwu ?atws)
                )
              (= ?atwt ?atws)
              )
            (and (and (not (= ?atwx ?atww))
                (not (= ?atwx ?atwv))
                )
              (not (= ?atww ?atwv))
              )
            )
          (or (and (and (not (= ?atwu ?atwt))
                (not (= ?atwu ?atws))
                )
              (not (= ?atwt ?atws))
              )
            (or (or (= ?atwx ?atww)
                (= ?atwx ?atwv)
                )
              (= ?atww ?atwv)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atwy Real)
      (declare-const ?atwz Real)
      (declare-const ?atxa Real)
      (assert
        (and (and (not (= ?atxa ?atwz))
            (not (= ?atxa ?atwy))
            )
          (not (= ?atwz ?atwy))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atxb Real)
      (declare-const ?atxc Real)
      (declare-const ?atxd Real)
      (assert
        (and (and (not (= ?atxd ?atxc))
            (not (= ?atxd ?atxb))
            )
          (not (= ?atxc ?atxb))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?atxe Real)
    (push 1)
      (declare-const ?atxf Real)
      (declare-const ?atxg Real)
      (declare-const ?atxh Real)
      (declare-const ?atxi Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?atxg ?atxf)
                  (= ?atxg ?asi)
                  )
                (= ?atxf ?asi)
                )
              (and (and (not (= ?atxi ?atxh))
                  (not (= ?atxi ?asi))
                  )
                (not (= ?atxh ?asi))
                )
              )
            (or (and (and (not (= ?atxg ?atxf))
                  (not (= ?atxg ?asi))
                  )
                (not (= ?atxf ?asi))
                )
              (or (or (= ?atxi ?atxh)
                  (= ?atxi ?asi)
                  )
                (= ?atxh ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atxj Real)
      (declare-const ?atxk Real)
      (declare-const ?atxl Real)
      (declare-const ?atxm Real)
      (declare-const ?atxn Real)
      (declare-const ?atxo Real)
      (assert
        (and (or (or (or (= ?atxl ?atxk)
                (= ?atxl ?atxj)
                )
              (= ?atxk ?atxj)
              )
            (and (and (not (= ?atxo ?atxn))
                (not (= ?atxo ?atxm))
                )
              (not (= ?atxn ?atxm))
              )
            )
          (or (and (and (not (= ?atxl ?atxk))
                (not (= ?atxl ?atxj))
                )
              (not (= ?atxk ?atxj))
              )
            (or (or (= ?atxo ?atxn)
                (= ?atxo ?atxm)
                )
              (= ?atxn ?atxm)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atxp Real)
      (declare-const ?atxq Real)
      (declare-const ?atxr Real)
      (assert
        (and (and (not (= ?atxr ?atxq))
            (not (= ?atxr ?atxp))
            )
          (not (= ?atxq ?atxp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atxs Real)
      (declare-const ?atxt Real)
      (declare-const ?atxu Real)
      (assert
        (and (and (not (= ?atxu ?atxt))
            (not (= ?atxu ?atxs))
            )
          (not (= ?atxt ?atxs))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?atxv Real)
    (declare-const ?atxw Real)
    (push 1)
      (declare-const ?atxx Real)
      (declare-const ?atxy Real)
      (declare-const ?atxz Real)
      (declare-const ?atya Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?atxy ?atxx)
                  (= ?atxy ?asi)
                  )
                (= ?atxx ?asi)
                )
              (and (and (not (= ?atya ?atxz))
                  (not (= ?atya ?asi))
                  )
                (not (= ?atxz ?asi))
                )
              )
            (or (and (and (not (= ?atxy ?atxx))
                  (not (= ?atxy ?asi))
                  )
                (not (= ?atxx ?asi))
                )
              (or (or (= ?atya ?atxz)
                  (= ?atya ?asi)
                  )
                (= ?atxz ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atyb Real)
      (declare-const ?atyc Real)
      (declare-const ?atyd Real)
      (declare-const ?atye Real)
      (declare-const ?atyf Real)
      (declare-const ?atyg Real)
      (assert
        (and (or (or (or (= ?atyd ?atyc)
                (= ?atyd ?atyb)
                )
              (= ?atyc ?atyb)
              )
            (and (and (not (= ?atyg ?atyf))
                (not (= ?atyg ?atye))
                )
              (not (= ?atyf ?atye))
              )
            )
          (or (and (and (not (= ?atyd ?atyc))
                (not (= ?atyd ?atyb))
                )
              (not (= ?atyc ?atyb))
              )
            (or (or (= ?atyg ?atyf)
                (= ?atyg ?atye)
                )
              (= ?atyf ?atye)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atyh Real)
      (declare-const ?atyi Real)
      (declare-const ?atyj Real)
      (assert
        (and (and (not (= ?atyj ?atyi))
            (not (= ?atyj ?atyh))
            )
          (not (= ?atyi ?atyh))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atyk Real)
      (declare-const ?atyl Real)
      (declare-const ?atym Real)
      (assert
        (and (and (not (= ?atym ?atyl))
            (not (= ?atym ?atyk))
            )
          (not (= ?atyl ?atyk))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?atyn Real)
    (declare-const ?atyo Real)
    (declare-const ?atyp Real)
    (push 1)
      (declare-const ?atyq Real)
      (declare-const ?atyr Real)
      (declare-const ?atys Real)
      (declare-const ?atyt Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?atyr ?atyq)
                  (= ?atyr ?asi)
                  )
                (= ?atyq ?asi)
                )
              (and (and (not (= ?atyt ?atys))
                  (not (= ?atyt ?asi))
                  )
                (not (= ?atys ?asi))
                )
              )
            (or (and (and (not (= ?atyr ?atyq))
                  (not (= ?atyr ?asi))
                  )
                (not (= ?atyq ?asi))
                )
              (or (or (= ?atyt ?atys)
                  (= ?atyt ?asi)
                  )
                (= ?atys ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atyu Real)
      (declare-const ?atyv Real)
      (declare-const ?atyw Real)
      (declare-const ?atyx Real)
      (declare-const ?atyy Real)
      (declare-const ?atyz Real)
      (assert
        (and (or (or (or (= ?atyw ?atyv)
                (= ?atyw ?atyu)
                )
              (= ?atyv ?atyu)
              )
            (and (and (not (= ?atyz ?atyy))
                (not (= ?atyz ?atyx))
                )
              (not (= ?atyy ?atyx))
              )
            )
          (or (and (and (not (= ?atyw ?atyv))
                (not (= ?atyw ?atyu))
                )
              (not (= ?atyv ?atyu))
              )
            (or (or (= ?atyz ?atyy)
                (= ?atyz ?atyx)
                )
              (= ?atyy ?atyx)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atza Real)
      (declare-const ?atzb Real)
      (declare-const ?atzc Real)
      (assert
        (and (and (not (= ?atzc ?atzb))
            (not (= ?atzc ?atza))
            )
          (not (= ?atzb ?atza))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atzd Real)
      (declare-const ?atze Real)
      (declare-const ?atzf Real)
      (assert
        (and (and (not (= ?atzf ?atze))
            (not (= ?atzf ?atzd))
            )
          (not (= ?atze ?atzd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (and (or (or (or (= ?atwn ?atwm)
                (= ?atwn ?atwl)
                )
              (= ?atwm ?atwl)
              )
            (and (and (not (= ?atyp ?atyo))
                (not (= ?atyp ?atyn))
                )
              (not (= ?atyo ?atyn))
              )
            )
          (or (and (and (not (= ?atwn ?atwm))
                (not (= ?atwn ?atwl))
                )
              (not (= ?atwm ?atwl))
              )
            (or (or (= ?atyp ?atyo)
                (= ?atyp ?atyn)
                )
              (= ?atyo ?atyn)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?atzg Real)
      (declare-const ?atzh Real)
      (declare-const ?atzi Real)
      (declare-const ?atzj Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?atzh ?atzg)
                  (= ?atzh ?asi)
                  )
                (= ?atzg ?asi)
                )
              (and (and (not (= ?atzj ?atzi))
                  (not (= ?atzj ?asi))
                  )
                (not (= ?atzi ?asi))
                )
              )
            (or (and (and (not (= ?atzh ?atzg))
                  (not (= ?atzh ?asi))
                  )
                (not (= ?atzg ?asi))
                )
              (or (or (= ?atzj ?atzi)
                  (= ?atzj ?asi)
                  )
                (= ?atzi ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atzk Real)
      (declare-const ?atzl Real)
      (declare-const ?atzm Real)
      (declare-const ?atzn Real)
      (declare-const ?atzo Real)
      (declare-const ?atzp Real)
      (assert
        (and (or (or (or (= ?atzm ?atzl)
                (= ?atzm ?atzk)
                )
              (= ?atzl ?atzk)
              )
            (and (and (not (= ?atzp ?atzo))
                (not (= ?atzp ?atzn))
                )
              (not (= ?atzo ?atzn))
              )
            )
          (or (and (and (not (= ?atzm ?atzl))
                (not (= ?atzm ?atzk))
                )
              (not (= ?atzl ?atzk))
              )
            (or (or (= ?atzp ?atzo)
                (= ?atzp ?atzn)
                )
              (= ?atzo ?atzn)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atzq Real)
      (declare-const ?atzr Real)
      (declare-const ?atzs Real)
      (assert
        (and (and (not (= ?atzs ?atzr))
            (not (= ?atzs ?atzq))
            )
          (not (= ?atzr ?atzq))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?atzt Real)
      (declare-const ?atzu Real)
      (declare-const ?atzv Real)
      (assert
        (and (and (not (= ?atzv ?atzu))
            (not (= ?atzv ?atzt))
            )
          (not (= ?atzu ?atzt))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (and (and (not (= ?atwn ?atwm))
            (not (= ?atwn ?atwl))
            )
          (not (= ?atwm ?atwl))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?atzw Real)
    (declare-const ?atzx Real)
    (declare-const ?atzy Real)
    (assert
      (and (or (or (or (= ?atwn ?atwm)
              (= ?atwn ?atwl)
              )
            (= ?atwm ?atwl)
            )
          (and (and (not (= ?atzy ?atzx))
              (not (= ?atzy ?atzw))
              )
            (not (= ?atzx ?atzw))
            )
          )
        (or (and (and (not (= ?atwn ?atwm))
              (not (= ?atwn ?atwl))
              )
            (not (= ?atwm ?atwl))
            )
          (or (or (= ?atzy ?atzx)
              (= ?atzy ?atzw)
              )
            (= ?atzx ?atzw)
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (assert
      (and (and (not (= ?atwn ?atwm))
          (not (= ?atwn ?atwl))
          )
        (not (= ?atwm ?atwl))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (push 1)
      (declare-const ?atzz Real)
      (declare-const ?auaa Real)
      (declare-const ?auab Real)
      (declare-const ?auac Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?auaa ?atzz)
                  (= ?auaa ?asi)
                  )
                (= ?atzz ?asi)
                )
              (and (and (not (= ?auac ?auab))
                  (not (= ?auac ?asi))
                  )
                (not (= ?auab ?asi))
                )
              )
            (or (and (and (not (= ?auaa ?atzz))
                  (not (= ?auaa ?asi))
                  )
                (not (= ?atzz ?asi))
                )
              (or (or (= ?auac ?auab)
                  (= ?auac ?asi)
                  )
                (= ?auab ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?auad Real)
      (declare-const ?auae Real)
      (declare-const ?auaf Real)
      (declare-const ?auag Real)
      (declare-const ?auah Real)
      (declare-const ?auai Real)
      (assert
        (and (or (or (or (= ?auaf ?auae)
                (= ?auaf ?auad)
                )
              (= ?auae ?auad)
              )
            (and (and (not (= ?auai ?auah))
                (not (= ?auai ?auag))
                )
              (not (= ?auah ?auag))
              )
            )
          (or (and (and (not (= ?auaf ?auae))
                (not (= ?auaf ?auad))
                )
              (not (= ?auae ?auad))
              )
            (or (or (= ?auai ?auah)
                (= ?auai ?auag)
                )
              (= ?auah ?auag)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?auaj Real)
      (declare-const ?auak Real)
      (declare-const ?aual Real)
      (assert
        (and (and (not (= ?aual ?auak))
            (not (= ?aual ?auaj))
            )
          (not (= ?auak ?auaj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?auam Real)
      (declare-const ?auan Real)
      (declare-const ?auao Real)
      (assert
        (and (and (not (= ?auao ?auan))
            (not (= ?auao ?auam))
            )
          (not (= ?auan ?auam))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?auap Real)
    (push 1)
      (declare-const ?auaq Real)
      (declare-const ?auar Real)
      (declare-const ?auas Real)
      (declare-const ?auat Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?auar ?auaq)
                  (= ?auar ?asi)
                  )
                (= ?auaq ?asi)
                )
              (and (and (not (= ?auat ?auas))
                  (not (= ?auat ?asi))
                  )
                (not (= ?auas ?asi))
                )
              )
            (or (and (and (not (= ?auar ?auaq))
                  (not (= ?auar ?asi))
                  )
                (not (= ?auaq ?asi))
                )
              (or (or (= ?auat ?auas)
                  (= ?auat ?asi)
                  )
                (= ?auas ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?auau Real)
      (declare-const ?auav Real)
      (declare-const ?auaw Real)
      (declare-const ?auax Real)
      (declare-const ?auay Real)
      (declare-const ?auaz Real)
      (assert
        (and (or (or (or (= ?auaw ?auav)
                (= ?auaw ?auau)
                )
              (= ?auav ?auau)
              )
            (and (and (not (= ?auaz ?auay))
                (not (= ?auaz ?auax))
                )
              (not (= ?auay ?auax))
              )
            )
          (or (and (and (not (= ?auaw ?auav))
                (not (= ?auaw ?auau))
                )
              (not (= ?auav ?auau))
              )
            (or (or (= ?auaz ?auay)
                (= ?auaz ?auax)
                )
              (= ?auay ?auax)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?auba Real)
      (declare-const ?aubb Real)
      (declare-const ?aubc Real)
      (assert
        (and (and (not (= ?aubc ?aubb))
            (not (= ?aubc ?auba))
            )
          (not (= ?aubb ?auba))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aubd Real)
      (declare-const ?aube Real)
      (declare-const ?aubf Real)
      (assert
        (and (and (not (= ?aubf ?aube))
            (not (= ?aubf ?aubd))
            )
          (not (= ?aube ?aubd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?aubg Real)
    (declare-const ?aubh Real)
    (push 1)
      (declare-const ?aubi Real)
      (declare-const ?aubj Real)
      (declare-const ?aubk Real)
      (declare-const ?aubl Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?aubj ?aubi)
                  (= ?aubj ?asi)
                  )
                (= ?aubi ?asi)
                )
              (and (and (not (= ?aubl ?aubk))
                  (not (= ?aubl ?asi))
                  )
                (not (= ?aubk ?asi))
                )
              )
            (or (and (and (not (= ?aubj ?aubi))
                  (not (= ?aubj ?asi))
                  )
                (not (= ?aubi ?asi))
                )
              (or (or (= ?aubl ?aubk)
                  (= ?aubl ?asi)
                  )
                (= ?aubk ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aubm Real)
      (declare-const ?aubn Real)
      (declare-const ?aubo Real)
      (declare-const ?aubp Real)
      (declare-const ?aubq Real)
      (declare-const ?aubr Real)
      (assert
        (and (or (or (or (= ?aubo ?aubn)
                (= ?aubo ?aubm)
                )
              (= ?aubn ?aubm)
              )
            (and (and (not (= ?aubr ?aubq))
                (not (= ?aubr ?aubp))
                )
              (not (= ?aubq ?aubp))
              )
            )
          (or (and (and (not (= ?aubo ?aubn))
                (not (= ?aubo ?aubm))
                )
              (not (= ?aubn ?aubm))
              )
            (or (or (= ?aubr ?aubq)
                (= ?aubr ?aubp)
                )
              (= ?aubq ?aubp)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aubs Real)
      (declare-const ?aubt Real)
      (declare-const ?aubu Real)
      (assert
        (and (and (not (= ?aubu ?aubt))
            (not (= ?aubu ?aubs))
            )
          (not (= ?aubt ?aubs))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aubv Real)
      (declare-const ?aubw Real)
      (declare-const ?aubx Real)
      (assert
        (and (and (not (= ?aubx ?aubw))
            (not (= ?aubx ?aubv))
            )
          (not (= ?aubw ?aubv))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?auby Real)
    (declare-const ?aubz Real)
    (declare-const ?auca Real)
    (push 1)
      (declare-const ?aucb Real)
      (declare-const ?aucc Real)
      (declare-const ?aucd Real)
      (declare-const ?auce Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?aucc ?aucb)
                  (= ?aucc ?asi)
                  )
                (= ?aucb ?asi)
                )
              (and (and (not (= ?auce ?aucd))
                  (not (= ?auce ?asi))
                  )
                (not (= ?aucd ?asi))
                )
              )
            (or (and (and (not (= ?aucc ?aucb))
                  (not (= ?aucc ?asi))
                  )
                (not (= ?aucb ?asi))
                )
              (or (or (= ?auce ?aucd)
                  (= ?auce ?asi)
                  )
                (= ?aucd ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aucf Real)
      (declare-const ?aucg Real)
      (declare-const ?auch Real)
      (declare-const ?auci Real)
      (declare-const ?aucj Real)
      (declare-const ?auck Real)
      (assert
        (and (or (or (or (= ?auch ?aucg)
                (= ?auch ?aucf)
                )
              (= ?aucg ?aucf)
              )
            (and (and (not (= ?auck ?aucj))
                (not (= ?auck ?auci))
                )
              (not (= ?aucj ?auci))
              )
            )
          (or (and (and (not (= ?auch ?aucg))
                (not (= ?auch ?aucf))
                )
              (not (= ?aucg ?aucf))
              )
            (or (or (= ?auck ?aucj)
                (= ?auck ?auci)
                )
              (= ?aucj ?auci)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aucl Real)
      (declare-const ?aucm Real)
      (declare-const ?aucn Real)
      (assert
        (and (and (not (= ?aucn ?aucm))
            (not (= ?aucn ?aucl))
            )
          (not (= ?aucm ?aucl))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?auco Real)
      (declare-const ?aucp Real)
      (declare-const ?aucq Real)
      (assert
        (and (and (not (= ?aucq ?aucp))
            (not (= ?aucq ?auco))
            )
          (not (= ?aucp ?auco))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (and (and (not (= ?auca ?aubz))
            (not (= ?auca ?auby))
            )
          (not (= ?aubz ?auby))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?aucr Real)
      (declare-const ?aucs Real)
      (declare-const ?auct Real)
      (declare-const ?aucu Real)
      (assert
        (forall ((?asi Real) )(and (or (or (or (= ?aucs ?aucr)
                  (= ?aucs ?asi)
                  )
                (= ?aucr ?asi)
                )
              (and (and (not (= ?aucu ?auct))
                  (not (= ?aucu ?asi))
                  )
                (not (= ?auct ?asi))
                )
              )
            (or (and (and (not (= ?aucs ?aucr))
                  (not (= ?aucs ?asi))
                  )
                (not (= ?aucr ?asi))
                )
              (or (or (= ?aucu ?auct)
                  (= ?aucu ?asi)
                  )
                (= ?auct ?asi)
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aucv Real)
      (declare-const ?aucw Real)
      (declare-const ?aucx Real)
      (declare-const ?aucy Real)
      (declare-const ?aucz Real)
      (declare-const ?auda Real)
      (assert
        (and (or (or (or (= ?aucx ?aucw)
                (= ?aucx ?aucv)
                )
              (= ?aucw ?aucv)
              )
            (and (and (not (= ?auda ?aucz))
                (not (= ?auda ?aucy))
                )
              (not (= ?aucz ?aucy))
              )
            )
          (or (and (and (not (= ?aucx ?aucw))
                (not (= ?aucx ?aucv))
                )
              (not (= ?aucw ?aucv))
              )
            (or (or (= ?auda ?aucz)
                (= ?auda ?aucy)
                )
              (= ?aucz ?aucy)
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?audb Real)
      (declare-const ?audc Real)
      (declare-const ?audd Real)
      (assert
        (and (and (not (= ?audd ?audc))
            (not (= ?audd ?audb))
            )
          (not (= ?audc ?audb))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aude Real)
      (declare-const ?audf Real)
      (declare-const ?audg Real)
      (assert
        (and (and (not (= ?audg ?audf))
            (not (= ?audg ?aude))
            )
          (not (= ?audf ?aude))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?audh Real)
    (declare-const ?audi Real)
    (declare-const ?audj Real)
    (assert
      (and (and (not (= ?audj ?audi))
          (not (= ?audj ?audh))
          )
        (not (= ?audi ?audh))
        )
      )
(set-info :status unknown)
    (check-sat)
    (exit)

