(set-info :smt-lib-version 2.6)
(set-logic LRA)
(set-info :source |
Generated by: Eryk Kopczynski  erykk@mimuw.edu.pl
Generated on: 20160927
Generator: LOIS, http://www.mimuw.edu.pl/~erykk/lois/
Application: LOIS is a C++ library allowing iterating through certain infinite sets, in finite time. The resulting language has an intuitive semantics, corresponding to execution of infinitely many threads in parallel. This allows to merge the power of abstract mathematical constructions into imperative programming. Infinite sets are internally represented using first order formulas over some underlying logical structure. To effectively handle such sets, we use and implement SMT solvers for various first order theories. LOIS has applications in education, and in verification of infinite state systems. This is a technical documentation of LOIS, describing how to write programs using it. 
Target solver: CVC4, z3
Additional information: At the time when LOIS was presented at the SMT 2016 workshop, the SMT solvers we checked were much worse than the internal solver in LOIS, they failed on many queries. Today we have checked the newest nightly build of CVC4, and its performance is only slightly lower than internal. The newest Z3 from the GitHub repository is apparently still unable to solve some queries, though.
|)
(set-info :license "https://creativecommons.org/licenses/by/4.0/")
(set-info :category "industrial")
(define-fun min ((a Real) (b Real)) Real (ite (<= a b) a b))
(define-fun max ((a Real) (b Real)) Real (ite (>= a b) a b))
(push 1)
  (declare-const ?audk Real)
  (push 1)
    (declare-const ?audl Real)
    (push 1)
      (declare-const ?audm Real)
      (push 1)
        (assert
          (or (or (= ?audk ?audl)
              (= ?audk ?audm)
              )
            (= ?audl ?audm)
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?audn Real)
  (declare-const ?audo Real)
  (declare-const ?audp Real)
  (assert
    (or (or (= ?audp ?audo)
        (= ?audp ?audn)
        )
      (= ?audo ?audn)
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?aueh Real)
    (declare-const ?auei Real)
    (declare-const ?auej Real)
    (assert
      (or (or (= ?auej ?auei)
          (= ?auej ?aueh)
          )
        (= ?auei ?aueh)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?auek Real)
  (push 1)
    (declare-const ?auel Real)
    (declare-const ?auem Real)
    (declare-const ?auen Real)
    (assert
      (or (or (= ?auen ?auem)
          (= ?auen ?auel)
          )
        (= ?auem ?auel)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aueo Real)
  (declare-const ?auep Real)
  (push 1)
    (declare-const ?aueq Real)
    (declare-const ?auer Real)
    (declare-const ?aues Real)
    (assert
      (or (or (= ?aues ?auer)
          (= ?aues ?aueq)
          )
        (= ?auer ?aueq)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?auet Real)
  (declare-const ?aueu Real)
  (declare-const ?auev Real)
  (push 1)
    (declare-const ?auew Real)
    (declare-const ?auex Real)
    (declare-const ?auey Real)
    (assert
      (or (or (= ?auey ?auex)
          (= ?auey ?auew)
          )
        (= ?auex ?auew)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (assert
      (and (and (not (= ?auev ?aueu))
          (not (= ?auev ?auet))
          )
        (not (= ?aueu ?auet))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?auez Real)
    (declare-const ?aufa Real)
    (declare-const ?aufb Real)
    (assert
      (or (or (= ?aufb ?aufa)
          (= ?aufb ?auez)
          )
        (= ?aufa ?auez)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aufc Real)
  (declare-const ?aufd Real)
  (declare-const ?aufe Real)
  (assert
    (and (and (not (= ?aufe ?aufd))
        (not (= ?aufe ?aufc))
        )
      (not (= ?aufd ?aufc))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?auff Real)
  (declare-const ?aufg Real)
  (declare-const ?aufh Real)
  (assert
    (and (and (not (= ?aufh ?aufg))
        (not (= ?aufh ?auff))
        )
      (not (= ?aufg ?auff))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aufl Real)
  (declare-const ?aufm Real)
  (declare-const ?aufn Real)
  (assert
    (and (and (not (= ?aufn ?aufm))
        (not (= ?aufn ?aufl))
        )
      (not (= ?aufm ?aufl))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aufo Real)
  (declare-const ?aufp Real)
  (declare-const ?aufq Real)
  (assert
    (and (and (not (= ?aufq ?aufp))
        (not (= ?aufq ?aufo))
        )
      (not (= ?aufp ?aufo))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?aufr Real)
    (declare-const ?aufs Real)
    (declare-const ?auft Real)
    (assert
      (and (and (not (= ?auft ?aufs))
          (not (= ?auft ?aufr))
          )
        (not (= ?aufs ?aufr))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aufu Real)
  (push 1)
    (declare-const ?aufv Real)
    (declare-const ?aufw Real)
    (declare-const ?aufx Real)
    (assert
      (and (and (not (= ?aufx ?aufw))
          (not (= ?aufx ?aufv))
          )
        (not (= ?aufw ?aufv))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?aufy Real)
  (declare-const ?aufz Real)
  (push 1)
    (declare-const ?auga Real)
    (declare-const ?augb Real)
    (declare-const ?augc Real)
    (assert
      (and (and (not (= ?augc ?augb))
          (not (= ?augc ?auga))
          )
        (not (= ?augb ?auga))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?augd Real)
  (declare-const ?auge Real)
  (declare-const ?augf Real)
  (assert
    (and (and (not (= ?augf ?auge))
        (not (= ?augf ?augd))
        )
      (not (= ?auge ?augd))
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?augg Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?augh Real)
    (declare-const ?augi Real)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?augj Real)
    (declare-const ?augk Real)
    (declare-const ?augl Real)
    (assert
      (and (and (not (= ?augl ?augk))
          (not (= ?augl ?augj))
          )
        (not (= ?augk ?augj))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?augm Real)
    (declare-const ?augn Real)
    (declare-const ?augo Real)
    (assert
      (and (and (not (= ?augo ?augn))
          (not (= ?augo ?augm))
          )
        (not (= ?augn ?augm))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?augp Real)
  (declare-const ?augq Real)
  (declare-const ?augr Real)
  (assert
    (and (and (not (= ?augr ?augq))
        (not (= ?augr ?augp))
        )
      (not (= ?augq ?augp))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?augs Real)
  (declare-const ?augt Real)
  (declare-const ?augu Real)
  (declare-const ?augv Real)
  (assert
    (and (and (not (= ?augu ?augt))
        (not (= ?augu ?augs))
        )
      (not (= ?augt ?augs))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?augw Real)
  (declare-const ?augx Real)
  (declare-const ?augy Real)
  (declare-const ?augz Real)
  (declare-const ?auha Real)
  (assert
    (and (and (not (= ?augy ?augx))
        (not (= ?augy ?augw))
        )
      (not (= ?augx ?augw))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?auhb Real)
  (declare-const ?auhc Real)
  (declare-const ?auhd Real)
  (assert
    (and (and (not (= ?auhd ?auhc))
        (not (= ?auhd ?auhb))
        )
      (not (= ?auhc ?auhb))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?auhe Real)
  (declare-const ?auhf Real)
  (declare-const ?auhg Real)
  (declare-const ?auhh Real)
  (assert
    (and (and (not (= ?auhh ?auhg))
        (not (= ?auhh ?auhf))
        )
      (not (= ?auhg ?auhf))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?auhi Real)
  (declare-const ?auhj Real)
  (declare-const ?auhk Real)
  (declare-const ?auhl Real)
  (declare-const ?auhm Real)
  (assert
    (and (and (not (= ?auhm ?auhl))
        (not (= ?auhm ?auhk))
        )
      (not (= ?auhl ?auhk))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?auhn Real)
  (declare-const ?auho Real)
  (declare-const ?auhp Real)
  (declare-const ?auhq Real)
  (declare-const ?auhr Real)
  (declare-const ?auhs Real)
  (assert
    (and (and (and (not (= ?auhp ?auho))
          (not (= ?auhp ?auhn))
          )
        (not (= ?auho ?auhn))
        )
      (and (and (not (= ?auhs ?auhr))
          (not (= ?auhs ?auhq))
          )
        (not (= ?auhr ?auhq))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?auht Real)
  (declare-const ?auhu Real)
  (declare-const ?auhv Real)
  (assert
    (and (and (not (= ?auhv ?auhu))
        (not (= ?auhv ?auht))
        )
      (not (= ?auhu ?auht))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?auhw Real)
  (declare-const ?auhx Real)
  (declare-const ?auhy Real)
  (assert
    (and (and (not (= ?auhy ?auhx))
        (not (= ?auhy ?auhw))
        )
      (not (= ?auhx ?auhw))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?auhz Real)
  (declare-const ?auia Real)
  (declare-const ?auib Real)
  (assert
    (or (or (= ?auib ?auia)
        (= ?auib ?auhz)
        )
      (= ?auia ?auhz)
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
    (declare-const ?auic Real)
    (declare-const ?auid Real)
    (declare-const ?auie Real)
    (assert
      (or (or (= ?auie ?auid)
          (= ?auie ?auic)
          )
        (= ?auid ?auic)
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?auif Real)
  (declare-const ?auig Real)
  (declare-const ?auih Real)
  (declare-const ?auii Real)
  (declare-const ?auij Real)
  (declare-const ?auik Real)
  (assert
    (and (or (or (= ?auih ?auig)
          (= ?auih ?auif)
          )
        (= ?auig ?auif)
        )
      (or (or (= ?auik ?auij)
          (= ?auik ?auii)
          )
        (= ?auij ?auii)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?auil Real)
  (declare-const ?auim Real)
  (declare-const ?auin Real)
  (declare-const ?auio Real)
  (declare-const ?auip Real)
  (declare-const ?auiq Real)
  (assert
    (and (or (or (= ?auin ?auim)
          (= ?auin ?auil)
          )
        (= ?auim ?auil)
        )
      (or (or (= ?auiq ?auip)
          (= ?auiq ?auio)
          )
        (= ?auip ?auio)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?auir Real)
  (declare-const ?auis Real)
  (declare-const ?auit Real)
  (assert
    (and (and (not (= ?auit ?auis))
        (not (= ?auit ?auir))
        )
      (not (= ?auis ?auir))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?auiu Real)
  (declare-const ?auiv Real)
  (declare-const ?auiw Real)
  (declare-const ?auix Real)
  (assert
    (and (and (not (= ?auiw ?auiv))
        (not (= ?auiw ?auiu))
        )
      (not (= ?auiv ?auiu))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?auiy Real)
  (declare-const ?auiz Real)
  (declare-const ?auja Real)
  (declare-const ?aujb Real)
  (declare-const ?aujc Real)
  (assert
    (and (and (not (= ?auja ?auiz))
        (not (= ?auja ?auiy))
        )
      (not (= ?auiz ?auiy))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aujd Real)
  (declare-const ?auje Real)
  (declare-const ?aujf Real)
  (assert
    (and (and (not (= ?aujf ?auje))
        (not (= ?aujf ?aujd))
        )
      (not (= ?auje ?aujd))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aujg Real)
  (declare-const ?aujh Real)
  (declare-const ?auji Real)
  (declare-const ?aujj Real)
  (assert
    (and (and (not (= ?aujj ?auji))
        (not (= ?aujj ?aujh))
        )
      (not (= ?auji ?aujh))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aujk Real)
  (declare-const ?aujl Real)
  (declare-const ?aujm Real)
  (declare-const ?aujn Real)
  (declare-const ?aujo Real)
  (assert
    (and (and (not (= ?aujo ?aujn))
        (not (= ?aujo ?aujm))
        )
      (not (= ?aujn ?aujm))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aujp Real)
  (declare-const ?aujq Real)
  (declare-const ?aujr Real)
  (declare-const ?aujs Real)
  (declare-const ?aujt Real)
  (declare-const ?auju Real)
  (assert
    (and (and (and (not (= ?aujr ?aujq))
          (not (= ?aujr ?aujp))
          )
        (not (= ?aujq ?aujp))
        )
      (and (and (not (= ?auju ?aujt))
          (not (= ?auju ?aujs))
          )
        (not (= ?aujt ?aujs))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aujv Real)
  (declare-const ?aujw Real)
  (declare-const ?aujx Real)
  (assert
    (and (and (not (= ?aujx ?aujw))
        (not (= ?aujx ?aujv))
        )
      (not (= ?aujw ?aujv))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aujy Real)
  (declare-const ?aujz Real)
  (declare-const ?auka Real)
  (assert
    (and (and (not (= ?auka ?aujz))
        (not (= ?auka ?aujy))
        )
      (not (= ?aujz ?aujy))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aukb Real)
  (declare-const ?aukc Real)
  (declare-const ?aukd Real)
  (declare-const ?auke Real)
  (declare-const ?aukf Real)
  (declare-const ?aukg Real)
  (assert
    (and (or (or (= ?aukd ?aukc)
          (= ?aukd ?aukb)
          )
        (= ?aukc ?aukb)
        )
      (or (or (= ?aukg ?aukf)
          (= ?aukg ?auke)
          )
        (= ?aukf ?auke)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aukh Real)
  (declare-const ?auki Real)
  (declare-const ?aukj Real)
  (assert
    (and (and (not (= ?aukj ?auki))
        (not (= ?aukj ?aukh))
        )
      (not (= ?auki ?aukh))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aukk Real)
  (declare-const ?aukl Real)
  (declare-const ?aukm Real)
  (declare-const ?aukn Real)
  (assert
    (and (and (not (= ?aukm ?aukl))
        (not (= ?aukm ?aukk))
        )
      (not (= ?aukl ?aukk))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?auko Real)
  (declare-const ?aukp Real)
  (declare-const ?aukq Real)
  (declare-const ?aukr Real)
  (declare-const ?auks Real)
  (assert
    (and (and (not (= ?aukq ?aukp))
        (not (= ?aukq ?auko))
        )
      (not (= ?aukp ?auko))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aukt Real)
  (declare-const ?auku Real)
  (declare-const ?aukv Real)
  (assert
    (and (and (not (= ?aukv ?auku))
        (not (= ?aukv ?aukt))
        )
      (not (= ?auku ?aukt))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aukw Real)
  (declare-const ?aukx Real)
  (declare-const ?auky Real)
  (declare-const ?aukz Real)
  (assert
    (and (and (not (= ?aukz ?auky))
        (not (= ?aukz ?aukx))
        )
      (not (= ?auky ?aukx))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aula Real)
  (declare-const ?aulb Real)
  (declare-const ?aulc Real)
  (declare-const ?auld Real)
  (declare-const ?aule Real)
  (assert
    (and (and (not (= ?aule ?auld))
        (not (= ?aule ?aulc))
        )
      (not (= ?auld ?aulc))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aulf Real)
  (declare-const ?aulg Real)
  (declare-const ?aulh Real)
  (declare-const ?auli Real)
  (declare-const ?aulj Real)
  (declare-const ?aulk Real)
  (assert
    (and (and (and (not (= ?aulh ?aulg))
          (not (= ?aulh ?aulf))
          )
        (not (= ?aulg ?aulf))
        )
      (and (and (not (= ?aulk ?aulj))
          (not (= ?aulk ?auli))
          )
        (not (= ?aulj ?auli))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aull Real)
  (declare-const ?aulm Real)
  (declare-const ?auln Real)
  (assert
    (and (and (not (= ?auln ?aulm))
        (not (= ?auln ?aull))
        )
      (not (= ?aulm ?aull))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aulo Real)
  (declare-const ?aulp Real)
  (declare-const ?aulq Real)
  (assert
    (and (and (not (= ?aulq ?aulp))
        (not (= ?aulq ?aulo))
        )
      (not (= ?aulp ?aulo))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aulr Real)
  (declare-const ?auls Real)
  (declare-const ?ault Real)
  (declare-const ?aulu Real)
  (declare-const ?aulv Real)
  (declare-const ?aulw Real)
  (assert
    (and (or (or (= ?ault ?auls)
          (= ?ault ?aulr)
          )
        (= ?auls ?aulr)
        )
      (or (or (= ?aulw ?aulv)
          (= ?aulw ?aulu)
          )
        (= ?aulv ?aulu)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aulx Real)
  (declare-const ?auly Real)
  (declare-const ?aulz Real)
  (assert
    (and (and (not (= ?aulz ?auly))
        (not (= ?aulz ?aulx))
        )
      (not (= ?auly ?aulx))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?auma Real)
  (declare-const ?aumb Real)
  (declare-const ?aumc Real)
  (declare-const ?aumd Real)
  (assert
    (and (and (not (= ?aumc ?aumb))
        (not (= ?aumc ?auma))
        )
      (not (= ?aumb ?auma))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aume Real)
  (declare-const ?aumf Real)
  (declare-const ?aumg Real)
  (declare-const ?aumh Real)
  (declare-const ?aumi Real)
  (assert
    (and (and (not (= ?aumg ?aumf))
        (not (= ?aumg ?aume))
        )
      (not (= ?aumf ?aume))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aumj Real)
  (declare-const ?aumk Real)
  (declare-const ?auml Real)
  (assert
    (and (and (not (= ?auml ?aumk))
        (not (= ?auml ?aumj))
        )
      (not (= ?aumk ?aumj))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aumm Real)
  (declare-const ?aumn Real)
  (declare-const ?aumo Real)
  (declare-const ?aump Real)
  (assert
    (and (and (not (= ?aump ?aumo))
        (not (= ?aump ?aumn))
        )
      (not (= ?aumo ?aumn))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aumq Real)
  (declare-const ?aumr Real)
  (declare-const ?aums Real)
  (declare-const ?aumt Real)
  (declare-const ?aumu Real)
  (assert
    (and (and (not (= ?aumu ?aumt))
        (not (= ?aumu ?aums))
        )
      (not (= ?aumt ?aums))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aumv Real)
  (declare-const ?aumw Real)
  (declare-const ?aumx Real)
  (declare-const ?aumy Real)
  (declare-const ?aumz Real)
  (declare-const ?auna Real)
  (assert
    (and (and (and (not (= ?aumx ?aumw))
          (not (= ?aumx ?aumv))
          )
        (not (= ?aumw ?aumv))
        )
      (and (and (not (= ?auna ?aumz))
          (not (= ?auna ?aumy))
          )
        (not (= ?aumz ?aumy))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aunb Real)
  (declare-const ?aunc Real)
  (declare-const ?aund Real)
  (assert
    (and (and (not (= ?aund ?aunc))
        (not (= ?aund ?aunb))
        )
      (not (= ?aunc ?aunb))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (declare-const ?aune Real)
  (declare-const ?aunf Real)
  (declare-const ?aung Real)
  (assert
    (and (and (not (= ?aung ?aunf))
        (not (= ?aung ?aune))
        )
      (not (= ?aunf ?aune))
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (push 1)
    (push 1)
      (push 1)
        (declare-const ?auof Real)
        (declare-const ?auog Real)
        (declare-const ?auoh Real)
        (declare-const ?auoi Real)
        (declare-const ?auoj Real)
        (declare-const ?auok Real)
        (assert
          (and (or (or (= ?auoh ?auog)
                (= ?auoh ?auof)
                )
              (= ?auog ?auof)
              )
            (or (or (= ?auok ?auoj)
                (= ?auok ?auoi)
                )
              (= ?auoj ?auoi)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?auol Real)
        (declare-const ?auom Real)
        (declare-const ?auon Real)
        (assert
          (and (and (not (= ?auon ?auom))
              (not (= ?auon ?auol))
              )
            (not (= ?auom ?auol))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?auoo Real)
        (declare-const ?auop Real)
        (declare-const ?auoq Real)
        (declare-const ?auor Real)
        (assert
          (and (and (not (= ?auoq ?auop))
              (not (= ?auoq ?auoo))
              )
            (not (= ?auop ?auoo))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?auos Real)
        (declare-const ?auot Real)
        (declare-const ?auou Real)
        (declare-const ?auov Real)
        (declare-const ?auow Real)
        (assert
          (and (and (not (= ?auou ?auot))
              (not (= ?auou ?auos))
              )
            (not (= ?auot ?auos))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?auox Real)
        (declare-const ?auoy Real)
        (declare-const ?auoz Real)
        (assert
          (and (and (not (= ?auoz ?auoy))
              (not (= ?auoz ?auox))
              )
            (not (= ?auoy ?auox))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aupa Real)
        (declare-const ?aupb Real)
        (declare-const ?aupc Real)
        (declare-const ?aupd Real)
        (assert
          (and (and (not (= ?aupd ?aupc))
              (not (= ?aupd ?aupb))
              )
            (not (= ?aupc ?aupb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aupe Real)
        (declare-const ?aupf Real)
        (declare-const ?aupg Real)
        (declare-const ?auph Real)
        (declare-const ?aupi Real)
        (assert
          (and (and (not (= ?aupi ?auph))
              (not (= ?aupi ?aupg))
              )
            (not (= ?auph ?aupg))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aupj Real)
        (declare-const ?aupk Real)
        (declare-const ?aupl Real)
        (declare-const ?aupm Real)
        (declare-const ?aupn Real)
        (declare-const ?aupo Real)
        (assert
          (and (and (and (not (= ?aupl ?aupk))
                (not (= ?aupl ?aupj))
                )
              (not (= ?aupk ?aupj))
              )
            (and (and (not (= ?aupo ?aupn))
                (not (= ?aupo ?aupm))
                )
              (not (= ?aupn ?aupm))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aupp Real)
        (declare-const ?aupq Real)
        (declare-const ?aupr Real)
        (assert
          (and (and (not (= ?aupr ?aupq))
              (not (= ?aupr ?aupp))
              )
            (not (= ?aupq ?aupp))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aups Real)
        (declare-const ?aupt Real)
        (declare-const ?aupu Real)
        (assert
          (and (and (not (= ?aupu ?aupt))
              (not (= ?aupu ?aups))
              )
            (not (= ?aupt ?aups))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?aupv Real)
          (push 1)
            (declare-const ?aupw Real)
            (push 1)
              (declare-const ?aupx Real)
              (push 1)
                (assert
                  (and (= ?aupw ?aupv)
                    (= ?aupx ?aupv)
                    )
                  )
                (push 1)
                  (declare-const ?aupy Real)
                  (declare-const ?aupz Real)
                  (declare-const ?auqa Real)
                  (declare-const ?auqb Real)
                  (declare-const ?auqc Real)
                  (declare-const ?auqd Real)
                  (assert
                    (and (or (or (= ?auqa ?aupz)
                          (= ?auqa ?aupy)
                          )
                        (= ?aupz ?aupy)
                        )
                      (or (or (= ?auqd ?auqc)
                          (= ?auqd ?auqb)
                          )
                        (= ?auqc ?auqb)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auqe Real)
                  (declare-const ?auqf Real)
                  (declare-const ?auqg Real)
                  (assert
                    (and (and (not (= ?auqg ?auqf))
                        (not (= ?auqg ?auqe))
                        )
                      (not (= ?auqf ?auqe))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auqh Real)
                  (declare-const ?auqi Real)
                  (declare-const ?auqj Real)
                  (declare-const ?auqk Real)
                  (assert
                    (and (and (not (= ?auqj ?auqi))
                        (not (= ?auqj ?auqh))
                        )
                      (not (= ?auqi ?auqh))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auql Real)
                  (declare-const ?auqm Real)
                  (declare-const ?auqn Real)
                  (declare-const ?auqo Real)
                  (declare-const ?auqp Real)
                  (assert
                    (and (and (not (= ?auqn ?auqm))
                        (not (= ?auqn ?auql))
                        )
                      (not (= ?auqm ?auql))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auqq Real)
                  (declare-const ?auqr Real)
                  (declare-const ?auqs Real)
                  (assert
                    (and (and (not (= ?auqs ?auqr))
                        (not (= ?auqs ?auqq))
                        )
                      (not (= ?auqr ?auqq))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auqt Real)
                  (declare-const ?auqu Real)
                  (declare-const ?auqv Real)
                  (declare-const ?auqw Real)
                  (assert
                    (and (and (not (= ?auqw ?auqv))
                        (not (= ?auqw ?auqu))
                        )
                      (not (= ?auqv ?auqu))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auqx Real)
                  (declare-const ?auqy Real)
                  (declare-const ?auqz Real)
                  (declare-const ?aura Real)
                  (declare-const ?aurb Real)
                  (assert
                    (and (and (not (= ?aurb ?aura))
                        (not (= ?aurb ?auqz))
                        )
                      (not (= ?aura ?auqz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aurc Real)
                  (declare-const ?aurd Real)
                  (declare-const ?aure Real)
                  (declare-const ?aurf Real)
                  (declare-const ?aurg Real)
                  (declare-const ?aurh Real)
                  (assert
                    (and (and (and (not (= ?aure ?aurd))
                          (not (= ?aure ?aurc))
                          )
                        (not (= ?aurd ?aurc))
                        )
                      (and (and (not (= ?aurh ?aurg))
                          (not (= ?aurh ?aurf))
                          )
                        (not (= ?aurg ?aurf))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auri Real)
                  (declare-const ?aurj Real)
                  (declare-const ?aurk Real)
                  (assert
                    (and (and (not (= ?aurk ?aurj))
                        (not (= ?aurk ?auri))
                        )
                      (not (= ?aurj ?auri))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aurl Real)
                  (declare-const ?aurm Real)
                  (declare-const ?aurn Real)
                  (assert
                    (and (and (not (= ?aurn ?aurm))
                        (not (= ?aurn ?aurl))
                        )
                      (not (= ?aurm ?aurl))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?auro Real)
      (push 1)
        (declare-const ?aurp Real)
        (declare-const ?aurq Real)
        (declare-const ?aurr Real)
        (declare-const ?aurs Real)
        (declare-const ?aurt Real)
        (declare-const ?auru Real)
        (assert
          (and (or (or (= ?aurr ?aurq)
                (= ?aurr ?aurp)
                )
              (= ?aurq ?aurp)
              )
            (or (or (= ?auru ?aurt)
                (= ?auru ?aurs)
                )
              (= ?aurt ?aurs)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aurv Real)
        (declare-const ?aurw Real)
        (declare-const ?aurx Real)
        (assert
          (and (and (not (= ?aurx ?aurw))
              (not (= ?aurx ?aurv))
              )
            (not (= ?aurw ?aurv))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aury Real)
        (declare-const ?aurz Real)
        (declare-const ?ausa Real)
        (declare-const ?ausb Real)
        (assert
          (and (and (not (= ?ausa ?aurz))
              (not (= ?ausa ?aury))
              )
            (not (= ?aurz ?aury))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ausc Real)
        (declare-const ?ausd Real)
        (declare-const ?ause Real)
        (declare-const ?ausf Real)
        (declare-const ?ausg Real)
        (assert
          (and (and (not (= ?ause ?ausd))
              (not (= ?ause ?ausc))
              )
            (not (= ?ausd ?ausc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aush Real)
        (declare-const ?ausi Real)
        (declare-const ?ausj Real)
        (assert
          (and (and (not (= ?ausj ?ausi))
              (not (= ?ausj ?aush))
              )
            (not (= ?ausi ?aush))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ausk Real)
        (declare-const ?ausl Real)
        (declare-const ?ausm Real)
        (declare-const ?ausn Real)
        (assert
          (and (and (not (= ?ausn ?ausm))
              (not (= ?ausn ?ausl))
              )
            (not (= ?ausm ?ausl))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?auso Real)
        (declare-const ?ausp Real)
        (declare-const ?ausq Real)
        (declare-const ?ausr Real)
        (declare-const ?auss Real)
        (assert
          (and (and (not (= ?auss ?ausr))
              (not (= ?auss ?ausq))
              )
            (not (= ?ausr ?ausq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aust Real)
        (declare-const ?ausu Real)
        (declare-const ?ausv Real)
        (declare-const ?ausw Real)
        (declare-const ?ausx Real)
        (declare-const ?ausy Real)
        (assert
          (and (and (and (not (= ?ausv ?ausu))
                (not (= ?ausv ?aust))
                )
              (not (= ?ausu ?aust))
              )
            (and (and (not (= ?ausy ?ausx))
                (not (= ?ausy ?ausw))
                )
              (not (= ?ausx ?ausw))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ausz Real)
        (declare-const ?auta Real)
        (declare-const ?autb Real)
        (assert
          (and (and (not (= ?autb ?auta))
              (not (= ?autb ?ausz))
              )
            (not (= ?auta ?ausz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?autc Real)
        (declare-const ?autd Real)
        (declare-const ?aute Real)
        (assert
          (and (and (not (= ?aute ?autd))
              (not (= ?aute ?autc))
              )
            (not (= ?autd ?autc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?autf Real)
          (push 1)
            (declare-const ?autg Real)
            (push 1)
              (declare-const ?auth Real)
              (declare-const ?auti Real)
              (push 1)
                (assert
                  (and (and (= ?autg ?autf)
                      (= ?auth ?auro)
                      )
                    (= ?auti ?autf)
                    )
                  )
                (push 1)
                  (declare-const ?autj Real)
                  (declare-const ?autk Real)
                  (declare-const ?autl Real)
                  (declare-const ?autm Real)
                  (declare-const ?autn Real)
                  (declare-const ?auto Real)
                  (assert
                    (and (or (or (= ?autl ?autk)
                          (= ?autl ?autj)
                          )
                        (= ?autk ?autj)
                        )
                      (or (or (= ?auto ?autn)
                          (= ?auto ?autm)
                          )
                        (= ?autn ?autm)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?autp Real)
                  (declare-const ?autq Real)
                  (declare-const ?autr Real)
                  (assert
                    (and (and (not (= ?autr ?autq))
                        (not (= ?autr ?autp))
                        )
                      (not (= ?autq ?autp))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auts Real)
                  (declare-const ?autt Real)
                  (declare-const ?autu Real)
                  (declare-const ?autv Real)
                  (assert
                    (and (and (not (= ?autu ?autt))
                        (not (= ?autu ?auts))
                        )
                      (not (= ?autt ?auts))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?autw Real)
                  (declare-const ?autx Real)
                  (declare-const ?auty Real)
                  (declare-const ?autz Real)
                  (declare-const ?auua Real)
                  (assert
                    (and (and (not (= ?auty ?autx))
                        (not (= ?auty ?autw))
                        )
                      (not (= ?autx ?autw))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auub Real)
                  (declare-const ?auuc Real)
                  (declare-const ?auud Real)
                  (assert
                    (and (and (not (= ?auud ?auuc))
                        (not (= ?auud ?auub))
                        )
                      (not (= ?auuc ?auub))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auue Real)
                  (declare-const ?auuf Real)
                  (declare-const ?auug Real)
                  (declare-const ?auuh Real)
                  (assert
                    (and (and (not (= ?auuh ?auug))
                        (not (= ?auuh ?auuf))
                        )
                      (not (= ?auug ?auuf))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auui Real)
                  (declare-const ?auuj Real)
                  (declare-const ?auuk Real)
                  (declare-const ?auul Real)
                  (declare-const ?auum Real)
                  (assert
                    (and (and (not (= ?auum ?auul))
                        (not (= ?auum ?auuk))
                        )
                      (not (= ?auul ?auuk))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auun Real)
                  (declare-const ?auuo Real)
                  (declare-const ?auup Real)
                  (declare-const ?auuq Real)
                  (declare-const ?auur Real)
                  (declare-const ?auus Real)
                  (assert
                    (and (and (and (not (= ?auup ?auuo))
                          (not (= ?auup ?auun))
                          )
                        (not (= ?auuo ?auun))
                        )
                      (and (and (not (= ?auus ?auur))
                          (not (= ?auus ?auuq))
                          )
                        (not (= ?auur ?auuq))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auut Real)
                  (declare-const ?auuu Real)
                  (declare-const ?auuv Real)
                  (assert
                    (and (and (not (= ?auuv ?auuu))
                        (not (= ?auuv ?auut))
                        )
                      (not (= ?auuu ?auut))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auuw Real)
                  (declare-const ?auux Real)
                  (declare-const ?auuy Real)
                  (assert
                    (and (and (not (= ?auuy ?auux))
                        (not (= ?auuy ?auuw))
                        )
                      (not (= ?auux ?auuw))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?auuz Real)
      (declare-const ?auva Real)
      (push 1)
        (declare-const ?auvb Real)
        (declare-const ?auvc Real)
        (declare-const ?auvd Real)
        (declare-const ?auve Real)
        (declare-const ?auvf Real)
        (declare-const ?auvg Real)
        (assert
          (and (or (or (= ?auvd ?auvc)
                (= ?auvd ?auvb)
                )
              (= ?auvc ?auvb)
              )
            (or (or (= ?auvg ?auvf)
                (= ?auvg ?auve)
                )
              (= ?auvf ?auve)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?auvh Real)
        (declare-const ?auvi Real)
        (declare-const ?auvj Real)
        (assert
          (and (and (not (= ?auvj ?auvi))
              (not (= ?auvj ?auvh))
              )
            (not (= ?auvi ?auvh))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?auvk Real)
        (declare-const ?auvl Real)
        (declare-const ?auvm Real)
        (declare-const ?auvn Real)
        (assert
          (and (and (not (= ?auvm ?auvl))
              (not (= ?auvm ?auvk))
              )
            (not (= ?auvl ?auvk))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?auvo Real)
        (declare-const ?auvp Real)
        (declare-const ?auvq Real)
        (declare-const ?auvr Real)
        (declare-const ?auvs Real)
        (assert
          (and (and (not (= ?auvq ?auvp))
              (not (= ?auvq ?auvo))
              )
            (not (= ?auvp ?auvo))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?auvt Real)
        (declare-const ?auvu Real)
        (declare-const ?auvv Real)
        (assert
          (and (and (not (= ?auvv ?auvu))
              (not (= ?auvv ?auvt))
              )
            (not (= ?auvu ?auvt))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?auvw Real)
        (declare-const ?auvx Real)
        (declare-const ?auvy Real)
        (declare-const ?auvz Real)
        (assert
          (and (and (not (= ?auvz ?auvy))
              (not (= ?auvz ?auvx))
              )
            (not (= ?auvy ?auvx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?auwa Real)
        (declare-const ?auwb Real)
        (declare-const ?auwc Real)
        (declare-const ?auwd Real)
        (declare-const ?auwe Real)
        (assert
          (and (and (not (= ?auwe ?auwd))
              (not (= ?auwe ?auwc))
              )
            (not (= ?auwd ?auwc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?auwf Real)
        (declare-const ?auwg Real)
        (declare-const ?auwh Real)
        (declare-const ?auwi Real)
        (declare-const ?auwj Real)
        (declare-const ?auwk Real)
        (assert
          (and (and (and (not (= ?auwh ?auwg))
                (not (= ?auwh ?auwf))
                )
              (not (= ?auwg ?auwf))
              )
            (and (and (not (= ?auwk ?auwj))
                (not (= ?auwk ?auwi))
                )
              (not (= ?auwj ?auwi))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?auwl Real)
        (declare-const ?auwm Real)
        (declare-const ?auwn Real)
        (assert
          (and (and (not (= ?auwn ?auwm))
              (not (= ?auwn ?auwl))
              )
            (not (= ?auwm ?auwl))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?auwo Real)
        (declare-const ?auwp Real)
        (declare-const ?auwq Real)
        (assert
          (and (and (not (= ?auwq ?auwp))
              (not (= ?auwq ?auwo))
              )
            (not (= ?auwp ?auwo))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?auwr Real)
          (push 1)
            (declare-const ?auws Real)
            (push 1)
              (declare-const ?auwt Real)
              (declare-const ?auwu Real)
              (declare-const ?auwv Real)
              (push 1)
                (assert
                  (and (and (= ?auws ?auwr)
                      (and (= ?auwu ?auva)
                        (= ?auwt ?auuz)
                        )
                      )
                    (= ?auwv ?auwr)
                    )
                  )
                (push 1)
                  (declare-const ?auww Real)
                  (declare-const ?auwx Real)
                  (declare-const ?auwy Real)
                  (declare-const ?auwz Real)
                  (declare-const ?auxa Real)
                  (declare-const ?auxb Real)
                  (assert
                    (and (or (or (= ?auwy ?auwx)
                          (= ?auwy ?auww)
                          )
                        (= ?auwx ?auww)
                        )
                      (or (or (= ?auxb ?auxa)
                          (= ?auxb ?auwz)
                          )
                        (= ?auxa ?auwz)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auxc Real)
                  (declare-const ?auxd Real)
                  (declare-const ?auxe Real)
                  (assert
                    (and (and (not (= ?auxe ?auxd))
                        (not (= ?auxe ?auxc))
                        )
                      (not (= ?auxd ?auxc))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auxf Real)
                  (declare-const ?auxg Real)
                  (declare-const ?auxh Real)
                  (declare-const ?auxi Real)
                  (assert
                    (and (and (not (= ?auxh ?auxg))
                        (not (= ?auxh ?auxf))
                        )
                      (not (= ?auxg ?auxf))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auxj Real)
                  (declare-const ?auxk Real)
                  (declare-const ?auxl Real)
                  (declare-const ?auxm Real)
                  (declare-const ?auxn Real)
                  (assert
                    (and (and (not (= ?auxl ?auxk))
                        (not (= ?auxl ?auxj))
                        )
                      (not (= ?auxk ?auxj))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auxo Real)
                  (declare-const ?auxp Real)
                  (declare-const ?auxq Real)
                  (assert
                    (and (and (not (= ?auxq ?auxp))
                        (not (= ?auxq ?auxo))
                        )
                      (not (= ?auxp ?auxo))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auxr Real)
                  (declare-const ?auxs Real)
                  (declare-const ?auxt Real)
                  (declare-const ?auxu Real)
                  (assert
                    (and (and (not (= ?auxu ?auxt))
                        (not (= ?auxu ?auxs))
                        )
                      (not (= ?auxt ?auxs))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auxv Real)
                  (declare-const ?auxw Real)
                  (declare-const ?auxx Real)
                  (declare-const ?auxy Real)
                  (declare-const ?auxz Real)
                  (assert
                    (and (and (not (= ?auxz ?auxy))
                        (not (= ?auxz ?auxx))
                        )
                      (not (= ?auxy ?auxx))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auya Real)
                  (declare-const ?auyb Real)
                  (declare-const ?auyc Real)
                  (declare-const ?auyd Real)
                  (declare-const ?auye Real)
                  (declare-const ?auyf Real)
                  (assert
                    (and (and (and (not (= ?auyc ?auyb))
                          (not (= ?auyc ?auya))
                          )
                        (not (= ?auyb ?auya))
                        )
                      (and (and (not (= ?auyf ?auye))
                          (not (= ?auyf ?auyd))
                          )
                        (not (= ?auye ?auyd))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auyg Real)
                  (declare-const ?auyh Real)
                  (declare-const ?auyi Real)
                  (assert
                    (and (and (not (= ?auyi ?auyh))
                        (not (= ?auyi ?auyg))
                        )
                      (not (= ?auyh ?auyg))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?auyj Real)
                  (declare-const ?auyk Real)
                  (declare-const ?auyl Real)
                  (assert
                    (and (and (not (= ?auyl ?auyk))
                        (not (= ?auyl ?auyj))
                        )
                      (not (= ?auyk ?auyj))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (assert
                    (or (or (= ?auwu ?auwt)
                        (= ?auwu ?auwv)
                        )
                      (= ?auwt ?auwv)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (and (not (= ?auva ?auuz))
              (forall ((?auwv Real) )(and (not (= ?auva ?auwv))
                  (not (= ?auuz ?auwv))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?auym Real)
      (declare-const ?auyn Real)
      (declare-const ?auyo Real)
      (push 1)
        (declare-const ?auyp Real)
        (declare-const ?auyq Real)
        (declare-const ?auyr Real)
        (declare-const ?auys Real)
        (declare-const ?auyt Real)
        (declare-const ?auyu Real)
        (assert
          (and (or (or (= ?auyr ?auyq)
                (= ?auyr ?auyp)
                )
              (= ?auyq ?auyp)
              )
            (or (or (= ?auyu ?auyt)
                (= ?auyu ?auys)
                )
              (= ?auyt ?auys)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?auyv Real)
        (declare-const ?auyw Real)
        (declare-const ?auyx Real)
        (assert
          (and (and (not (= ?auyx ?auyw))
              (not (= ?auyx ?auyv))
              )
            (not (= ?auyw ?auyv))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?auyy Real)
        (declare-const ?auyz Real)
        (declare-const ?auza Real)
        (declare-const ?auzb Real)
        (assert
          (and (and (not (= ?auza ?auyz))
              (not (= ?auza ?auyy))
              )
            (not (= ?auyz ?auyy))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?auzc Real)
        (declare-const ?auzd Real)
        (declare-const ?auze Real)
        (declare-const ?auzf Real)
        (declare-const ?auzg Real)
        (assert
          (and (and (not (= ?auze ?auzd))
              (not (= ?auze ?auzc))
              )
            (not (= ?auzd ?auzc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?auzh Real)
        (declare-const ?auzi Real)
        (declare-const ?auzj Real)
        (assert
          (and (and (not (= ?auzj ?auzi))
              (not (= ?auzj ?auzh))
              )
            (not (= ?auzi ?auzh))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?auzk Real)
        (declare-const ?auzl Real)
        (declare-const ?auzm Real)
        (declare-const ?auzn Real)
        (assert
          (and (and (not (= ?auzn ?auzm))
              (not (= ?auzn ?auzl))
              )
            (not (= ?auzm ?auzl))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?auzo Real)
        (declare-const ?auzp Real)
        (declare-const ?auzq Real)
        (declare-const ?auzr Real)
        (declare-const ?auzs Real)
        (assert
          (and (and (not (= ?auzs ?auzr))
              (not (= ?auzs ?auzq))
              )
            (not (= ?auzr ?auzq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?auzt Real)
        (declare-const ?auzu Real)
        (declare-const ?auzv Real)
        (declare-const ?auzw Real)
        (declare-const ?auzx Real)
        (declare-const ?auzy Real)
        (assert
          (and (and (and (not (= ?auzv ?auzu))
                (not (= ?auzv ?auzt))
                )
              (not (= ?auzu ?auzt))
              )
            (and (and (not (= ?auzy ?auzx))
                (not (= ?auzy ?auzw))
                )
              (not (= ?auzx ?auzw))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?auzz Real)
        (declare-const ?avaa Real)
        (declare-const ?avab Real)
        (assert
          (and (and (not (= ?avab ?avaa))
              (not (= ?avab ?auzz))
              )
            (not (= ?avaa ?auzz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avac Real)
        (declare-const ?avad Real)
        (declare-const ?avae Real)
        (assert
          (and (and (not (= ?avae ?avad))
              (not (= ?avae ?avac))
              )
            (not (= ?avad ?avac))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?auyo ?auyn))
              (not (= ?auyo ?auym))
              )
            (not (= ?auyn ?auym))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?avaf Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?avag Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?avah Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avai Real)
              (declare-const ?avaj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avak Real)
              (declare-const ?aval Real)
              (declare-const ?avam Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avan Real)
              (declare-const ?avao Real)
              (declare-const ?avap Real)
              (declare-const ?avaq Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (= ?avag ?avaf)
                      (and (and (= ?avap ?auyo)
                          (= ?avao ?auyn)
                          )
                        (= ?avan ?auym)
                        )
                      )
                    (= ?avaq ?avaf)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?avar Real)
                  (declare-const ?avas Real)
                  (declare-const ?avat Real)
                  (declare-const ?avau Real)
                  (declare-const ?avav Real)
                  (declare-const ?avaw Real)
                  (assert
                    (and (or (or (= ?avat ?avas)
                          (= ?avat ?avar)
                          )
                        (= ?avas ?avar)
                        )
                      (or (or (= ?avaw ?avav)
                          (= ?avaw ?avau)
                          )
                        (= ?avav ?avau)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avax Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avay Real)
                  (declare-const ?avaz Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avba Real)
                  (declare-const ?avbb Real)
                  (declare-const ?avbc Real)
                  (assert
                    (and (and (not (= ?avbc ?avbb))
                        (not (= ?avbc ?avba))
                        )
                      (not (= ?avbb ?avba))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avbd Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avbe Real)
                  (declare-const ?avbf Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avbg Real)
                  (declare-const ?avbh Real)
                  (declare-const ?avbi Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avbj Real)
                  (declare-const ?avbk Real)
                  (declare-const ?avbl Real)
                  (declare-const ?avbm Real)
                  (assert
                    (and (and (not (= ?avbl ?avbk))
                        (not (= ?avbl ?avbj))
                        )
                      (not (= ?avbk ?avbj))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avbn Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avbo Real)
                  (declare-const ?avbp Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avbq Real)
                  (declare-const ?avbr Real)
                  (declare-const ?avbs Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avbt Real)
                  (declare-const ?avbu Real)
                  (declare-const ?avbv Real)
                  (declare-const ?avbw Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avbx Real)
                  (declare-const ?avby Real)
                  (declare-const ?avbz Real)
                  (declare-const ?avca Real)
                  (declare-const ?avcb Real)
                  (assert
                    (and (and (not (= ?avbz ?avby))
                        (not (= ?avbz ?avbx))
                        )
                      (not (= ?avby ?avbx))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avcc Real)
                  (declare-const ?avcd Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avce Real)
                  (declare-const ?avcf Real)
                  (declare-const ?avcg Real)
                  (assert
                    (and (and (not (= ?avcg ?avcf))
                        (not (= ?avcg ?avce))
                        )
                      (not (= ?avcf ?avce))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avch Real)
                  (declare-const ?avci Real)
                  (declare-const ?avcj Real)
                  (declare-const ?avck Real)
                  (assert
                    (and (and (not (= ?avck ?avcj))
                        (not (= ?avck ?avci))
                        )
                      (not (= ?avcj ?avci))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avcl Real)
                  (declare-const ?avcm Real)
                  (declare-const ?avcn Real)
                  (declare-const ?avco Real)
                  (declare-const ?avcp Real)
                  (assert
                    (and (and (not (= ?avcp ?avco))
                        (not (= ?avcp ?avcn))
                        )
                      (not (= ?avco ?avcn))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avcq Real)
                  (declare-const ?avcr Real)
                  (declare-const ?avcs Real)
                  (declare-const ?avct Real)
                  (declare-const ?avcu Real)
                  (declare-const ?avcv Real)
                  (assert
                    (and (and (and (not (= ?avcs ?avcr))
                          (not (= ?avcs ?avcq))
                          )
                        (not (= ?avcr ?avcq))
                        )
                      (and (and (not (= ?avcv ?avcu))
                          (not (= ?avcv ?avct))
                          )
                        (not (= ?avcu ?avct))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avcw Real)
                  (declare-const ?avcx Real)
                  (declare-const ?avcy Real)
                  (assert
                    (and (and (not (= ?avcy ?avcx))
                        (not (= ?avcy ?avcw))
                        )
                      (not (= ?avcx ?avcw))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avcz Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avda Real)
                  (declare-const ?avdb Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avdc Real)
                  (declare-const ?avdd Real)
                  (declare-const ?avde Real)
                  (assert
                    (and (and (not (= ?avde ?avdd))
                        (not (= ?avde ?avdc))
                        )
                      (not (= ?avdd ?avdc))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?avdf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?avdg Real)
            (declare-const ?avdh Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?avdi Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avdj Real)
              (declare-const ?avdk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avdl Real)
              (declare-const ?avdm Real)
              (declare-const ?avdn Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avdo Real)
              (declare-const ?avdp Real)
              (declare-const ?avdq Real)
              (declare-const ?avdr Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avds Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?avdt Real)
            (declare-const ?avdu Real)
            (declare-const ?avdv Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?avdw Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avdx Real)
              (declare-const ?avdy Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avdz Real)
              (declare-const ?avea Real)
              (declare-const ?aveb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avec Real)
              (declare-const ?aved Real)
              (declare-const ?avee Real)
              (declare-const ?avef Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aveg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?aveh Real)
            (declare-const ?avei Real)
            (declare-const ?avej Real)
            (declare-const ?avek Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?avel Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avem Real)
              (declare-const ?aven Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aveo Real)
              (declare-const ?avep Real)
              (declare-const ?aveq Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aver Real)
              (declare-const ?aves Real)
              (declare-const ?avet Real)
              (declare-const ?aveu Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avev Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?avew Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?avex Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avey Real)
              (declare-const ?avez Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avfa Real)
              (declare-const ?avfb Real)
              (declare-const ?avfc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avfd Real)
              (declare-const ?avfe Real)
              (declare-const ?avff Real)
              (declare-const ?avfg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avfh Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (declare-const ?avfi Real)
        (declare-const ?avfj Real)
        (declare-const ?avfk Real)
        (declare-const ?avfl Real)
        (declare-const ?avfm Real)
        (declare-const ?avfn Real)
        (assert
          (and (or (or (= ?avfk ?avfj)
                (= ?avfk ?avfi)
                )
              (= ?avfj ?avfi)
              )
            (or (or (= ?avfn ?avfm)
                (= ?avfn ?avfl)
                )
              (= ?avfm ?avfl)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avfo Real)
        (declare-const ?avfp Real)
        (declare-const ?avfq Real)
        (assert
          (and (and (not (= ?avfq ?avfp))
              (not (= ?avfq ?avfo))
              )
            (not (= ?avfp ?avfo))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avfr Real)
        (declare-const ?avfs Real)
        (declare-const ?avft Real)
        (declare-const ?avfu Real)
        (assert
          (and (and (not (= ?avft ?avfs))
              (not (= ?avft ?avfr))
              )
            (not (= ?avfs ?avfr))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avfv Real)
        (declare-const ?avfw Real)
        (declare-const ?avfx Real)
        (declare-const ?avfy Real)
        (declare-const ?avfz Real)
        (assert
          (and (and (not (= ?avfx ?avfw))
              (not (= ?avfx ?avfv))
              )
            (not (= ?avfw ?avfv))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avga Real)
        (declare-const ?avgb Real)
        (declare-const ?avgc Real)
        (assert
          (and (and (not (= ?avgc ?avgb))
              (not (= ?avgc ?avga))
              )
            (not (= ?avgb ?avga))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avgd Real)
        (declare-const ?avge Real)
        (declare-const ?avgf Real)
        (declare-const ?avgg Real)
        (assert
          (and (and (not (= ?avgg ?avgf))
              (not (= ?avgg ?avge))
              )
            (not (= ?avgf ?avge))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avgh Real)
        (declare-const ?avgi Real)
        (declare-const ?avgj Real)
        (declare-const ?avgk Real)
        (declare-const ?avgl Real)
        (assert
          (and (and (not (= ?avgl ?avgk))
              (not (= ?avgl ?avgj))
              )
            (not (= ?avgk ?avgj))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avgm Real)
        (declare-const ?avgn Real)
        (declare-const ?avgo Real)
        (declare-const ?avgp Real)
        (declare-const ?avgq Real)
        (declare-const ?avgr Real)
        (assert
          (and (and (and (not (= ?avgo ?avgn))
                (not (= ?avgo ?avgm))
                )
              (not (= ?avgn ?avgm))
              )
            (and (and (not (= ?avgr ?avgq))
                (not (= ?avgr ?avgp))
                )
              (not (= ?avgq ?avgp))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avgs Real)
        (declare-const ?avgt Real)
        (declare-const ?avgu Real)
        (assert
          (and (and (not (= ?avgu ?avgt))
              (not (= ?avgu ?avgs))
              )
            (not (= ?avgt ?avgs))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avgv Real)
        (declare-const ?avgw Real)
        (declare-const ?avgx Real)
        (assert
          (and (and (not (= ?avgx ?avgw))
              (not (= ?avgx ?avgv))
              )
            (not (= ?avgw ?avgv))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?avgy Real)
          (push 1)
            (declare-const ?avgz Real)
            (push 1)
              (declare-const ?avha Real)
              (push 1)
                (assert
                  (and (= ?avgz ?avgy)
                    (= ?avha ?avgy)
                    )
                  )
                (push 1)
                  (declare-const ?avhb Real)
                  (declare-const ?avhc Real)
                  (declare-const ?avhd Real)
                  (declare-const ?avhe Real)
                  (declare-const ?avhf Real)
                  (declare-const ?avhg Real)
                  (assert
                    (and (or (or (= ?avhd ?avhc)
                          (= ?avhd ?avhb)
                          )
                        (= ?avhc ?avhb)
                        )
                      (or (or (= ?avhg ?avhf)
                          (= ?avhg ?avhe)
                          )
                        (= ?avhf ?avhe)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avhh Real)
                  (declare-const ?avhi Real)
                  (declare-const ?avhj Real)
                  (assert
                    (and (and (not (= ?avhj ?avhi))
                        (not (= ?avhj ?avhh))
                        )
                      (not (= ?avhi ?avhh))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avhk Real)
                  (declare-const ?avhl Real)
                  (declare-const ?avhm Real)
                  (declare-const ?avhn Real)
                  (assert
                    (and (and (not (= ?avhm ?avhl))
                        (not (= ?avhm ?avhk))
                        )
                      (not (= ?avhl ?avhk))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avho Real)
                  (declare-const ?avhp Real)
                  (declare-const ?avhq Real)
                  (declare-const ?avhr Real)
                  (declare-const ?avhs Real)
                  (assert
                    (and (and (not (= ?avhq ?avhp))
                        (not (= ?avhq ?avho))
                        )
                      (not (= ?avhp ?avho))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avht Real)
                  (declare-const ?avhu Real)
                  (declare-const ?avhv Real)
                  (assert
                    (and (and (not (= ?avhv ?avhu))
                        (not (= ?avhv ?avht))
                        )
                      (not (= ?avhu ?avht))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avhw Real)
                  (declare-const ?avhx Real)
                  (declare-const ?avhy Real)
                  (declare-const ?avhz Real)
                  (assert
                    (and (and (not (= ?avhz ?avhy))
                        (not (= ?avhz ?avhx))
                        )
                      (not (= ?avhy ?avhx))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avia Real)
                  (declare-const ?avib Real)
                  (declare-const ?avic Real)
                  (declare-const ?avid Real)
                  (declare-const ?avie Real)
                  (assert
                    (and (and (not (= ?avie ?avid))
                        (not (= ?avie ?avic))
                        )
                      (not (= ?avid ?avic))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avif Real)
                  (declare-const ?avig Real)
                  (declare-const ?avih Real)
                  (declare-const ?avii Real)
                  (declare-const ?avij Real)
                  (declare-const ?avik Real)
                  (assert
                    (and (and (and (not (= ?avih ?avig))
                          (not (= ?avih ?avif))
                          )
                        (not (= ?avig ?avif))
                        )
                      (and (and (not (= ?avik ?avij))
                          (not (= ?avik ?avii))
                          )
                        (not (= ?avij ?avii))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avil Real)
                  (declare-const ?avim Real)
                  (declare-const ?avin Real)
                  (assert
                    (and (and (not (= ?avin ?avim))
                        (not (= ?avin ?avil))
                        )
                      (not (= ?avim ?avil))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avio Real)
                  (declare-const ?avip Real)
                  (declare-const ?aviq Real)
                  (assert
                    (and (and (not (= ?aviq ?avip))
                        (not (= ?aviq ?avio))
                        )
                      (not (= ?avip ?avio))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?avir Real)
    (push 1)
      (push 1)
        (declare-const ?avis Real)
        (declare-const ?avit Real)
        (declare-const ?aviu Real)
        (declare-const ?aviv Real)
        (declare-const ?aviw Real)
        (declare-const ?avix Real)
        (assert
          (and (or (or (= ?aviu ?avit)
                (= ?aviu ?avis)
                )
              (= ?avit ?avis)
              )
            (or (or (= ?avix ?aviw)
                (= ?avix ?aviv)
                )
              (= ?aviw ?aviv)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aviy Real)
        (declare-const ?aviz Real)
        (declare-const ?avja Real)
        (assert
          (and (and (not (= ?avja ?aviz))
              (not (= ?avja ?aviy))
              )
            (not (= ?aviz ?aviy))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avjb Real)
        (declare-const ?avjc Real)
        (declare-const ?avjd Real)
        (declare-const ?avje Real)
        (assert
          (and (and (not (= ?avjd ?avjc))
              (not (= ?avjd ?avjb))
              )
            (not (= ?avjc ?avjb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avjf Real)
        (declare-const ?avjg Real)
        (declare-const ?avjh Real)
        (declare-const ?avji Real)
        (declare-const ?avjj Real)
        (assert
          (and (and (not (= ?avjh ?avjg))
              (not (= ?avjh ?avjf))
              )
            (not (= ?avjg ?avjf))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avjk Real)
        (declare-const ?avjl Real)
        (declare-const ?avjm Real)
        (assert
          (and (and (not (= ?avjm ?avjl))
              (not (= ?avjm ?avjk))
              )
            (not (= ?avjl ?avjk))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avjn Real)
        (declare-const ?avjo Real)
        (declare-const ?avjp Real)
        (declare-const ?avjq Real)
        (assert
          (and (and (not (= ?avjq ?avjp))
              (not (= ?avjq ?avjo))
              )
            (not (= ?avjp ?avjo))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avjr Real)
        (declare-const ?avjs Real)
        (declare-const ?avjt Real)
        (declare-const ?avju Real)
        (declare-const ?avjv Real)
        (assert
          (and (and (not (= ?avjv ?avju))
              (not (= ?avjv ?avjt))
              )
            (not (= ?avju ?avjt))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avjw Real)
        (declare-const ?avjx Real)
        (declare-const ?avjy Real)
        (declare-const ?avjz Real)
        (declare-const ?avka Real)
        (declare-const ?avkb Real)
        (assert
          (and (and (and (not (= ?avjy ?avjx))
                (not (= ?avjy ?avjw))
                )
              (not (= ?avjx ?avjw))
              )
            (and (and (not (= ?avkb ?avka))
                (not (= ?avkb ?avjz))
                )
              (not (= ?avka ?avjz))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avkc Real)
        (declare-const ?avkd Real)
        (declare-const ?avke Real)
        (assert
          (and (and (not (= ?avke ?avkd))
              (not (= ?avke ?avkc))
              )
            (not (= ?avkd ?avkc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avkf Real)
        (declare-const ?avkg Real)
        (declare-const ?avkh Real)
        (assert
          (and (and (not (= ?avkh ?avkg))
              (not (= ?avkh ?avkf))
              )
            (not (= ?avkg ?avkf))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?avki Real)
          (push 1)
            (declare-const ?avkj Real)
            (declare-const ?avkk Real)
            (push 1)
              (declare-const ?avkl Real)
              (push 1)
                (assert
                  (and (and (= ?avkj ?avir)
                      (= ?avkk ?avki)
                      )
                    (= ?avkl ?avki)
                    )
                  )
                (push 1)
                  (declare-const ?avkm Real)
                  (declare-const ?avkn Real)
                  (declare-const ?avko Real)
                  (declare-const ?avkp Real)
                  (declare-const ?avkq Real)
                  (declare-const ?avkr Real)
                  (assert
                    (and (or (or (= ?avko ?avkn)
                          (= ?avko ?avkm)
                          )
                        (= ?avkn ?avkm)
                        )
                      (or (or (= ?avkr ?avkq)
                          (= ?avkr ?avkp)
                          )
                        (= ?avkq ?avkp)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avks Real)
                  (declare-const ?avkt Real)
                  (declare-const ?avku Real)
                  (assert
                    (and (and (not (= ?avku ?avkt))
                        (not (= ?avku ?avks))
                        )
                      (not (= ?avkt ?avks))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avkv Real)
                  (declare-const ?avkw Real)
                  (declare-const ?avkx Real)
                  (declare-const ?avky Real)
                  (assert
                    (and (and (not (= ?avkx ?avkw))
                        (not (= ?avkx ?avkv))
                        )
                      (not (= ?avkw ?avkv))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avkz Real)
                  (declare-const ?avla Real)
                  (declare-const ?avlb Real)
                  (declare-const ?avlc Real)
                  (declare-const ?avld Real)
                  (assert
                    (and (and (not (= ?avlb ?avla))
                        (not (= ?avlb ?avkz))
                        )
                      (not (= ?avla ?avkz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avle Real)
                  (declare-const ?avlf Real)
                  (declare-const ?avlg Real)
                  (assert
                    (and (and (not (= ?avlg ?avlf))
                        (not (= ?avlg ?avle))
                        )
                      (not (= ?avlf ?avle))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avlh Real)
                  (declare-const ?avli Real)
                  (declare-const ?avlj Real)
                  (declare-const ?avlk Real)
                  (assert
                    (and (and (not (= ?avlk ?avlj))
                        (not (= ?avlk ?avli))
                        )
                      (not (= ?avlj ?avli))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avll Real)
                  (declare-const ?avlm Real)
                  (declare-const ?avln Real)
                  (declare-const ?avlo Real)
                  (declare-const ?avlp Real)
                  (assert
                    (and (and (not (= ?avlp ?avlo))
                        (not (= ?avlp ?avln))
                        )
                      (not (= ?avlo ?avln))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avlq Real)
                  (declare-const ?avlr Real)
                  (declare-const ?avls Real)
                  (declare-const ?avlt Real)
                  (declare-const ?avlu Real)
                  (declare-const ?avlv Real)
                  (assert
                    (and (and (and (not (= ?avls ?avlr))
                          (not (= ?avls ?avlq))
                          )
                        (not (= ?avlr ?avlq))
                        )
                      (and (and (not (= ?avlv ?avlu))
                          (not (= ?avlv ?avlt))
                          )
                        (not (= ?avlu ?avlt))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avlw Real)
                  (declare-const ?avlx Real)
                  (declare-const ?avly Real)
                  (assert
                    (and (and (not (= ?avly ?avlx))
                        (not (= ?avly ?avlw))
                        )
                      (not (= ?avlx ?avlw))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avlz Real)
                  (declare-const ?avma Real)
                  (declare-const ?avmb Real)
                  (assert
                    (and (and (not (= ?avmb ?avma))
                        (not (= ?avmb ?avlz))
                        )
                      (not (= ?avma ?avlz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?avmc Real)
      (push 1)
        (declare-const ?avmd Real)
        (declare-const ?avme Real)
        (declare-const ?avmf Real)
        (declare-const ?avmg Real)
        (declare-const ?avmh Real)
        (declare-const ?avmi Real)
        (assert
          (and (or (or (= ?avmf ?avme)
                (= ?avmf ?avmd)
                )
              (= ?avme ?avmd)
              )
            (or (or (= ?avmi ?avmh)
                (= ?avmi ?avmg)
                )
              (= ?avmh ?avmg)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avmj Real)
        (declare-const ?avmk Real)
        (declare-const ?avml Real)
        (assert
          (and (and (not (= ?avml ?avmk))
              (not (= ?avml ?avmj))
              )
            (not (= ?avmk ?avmj))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avmm Real)
        (declare-const ?avmn Real)
        (declare-const ?avmo Real)
        (declare-const ?avmp Real)
        (assert
          (and (and (not (= ?avmo ?avmn))
              (not (= ?avmo ?avmm))
              )
            (not (= ?avmn ?avmm))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avmq Real)
        (declare-const ?avmr Real)
        (declare-const ?avms Real)
        (declare-const ?avmt Real)
        (declare-const ?avmu Real)
        (assert
          (and (and (not (= ?avms ?avmr))
              (not (= ?avms ?avmq))
              )
            (not (= ?avmr ?avmq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avmv Real)
        (declare-const ?avmw Real)
        (declare-const ?avmx Real)
        (assert
          (and (and (not (= ?avmx ?avmw))
              (not (= ?avmx ?avmv))
              )
            (not (= ?avmw ?avmv))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avmy Real)
        (declare-const ?avmz Real)
        (declare-const ?avna Real)
        (declare-const ?avnb Real)
        (assert
          (and (and (not (= ?avnb ?avna))
              (not (= ?avnb ?avmz))
              )
            (not (= ?avna ?avmz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avnc Real)
        (declare-const ?avnd Real)
        (declare-const ?avne Real)
        (declare-const ?avnf Real)
        (declare-const ?avng Real)
        (assert
          (and (and (not (= ?avng ?avnf))
              (not (= ?avng ?avne))
              )
            (not (= ?avnf ?avne))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avnh Real)
        (declare-const ?avni Real)
        (declare-const ?avnj Real)
        (declare-const ?avnk Real)
        (declare-const ?avnl Real)
        (declare-const ?avnm Real)
        (assert
          (and (and (and (not (= ?avnj ?avni))
                (not (= ?avnj ?avnh))
                )
              (not (= ?avni ?avnh))
              )
            (and (and (not (= ?avnm ?avnl))
                (not (= ?avnm ?avnk))
                )
              (not (= ?avnl ?avnk))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avnn Real)
        (declare-const ?avno Real)
        (declare-const ?avnp Real)
        (assert
          (and (and (not (= ?avnp ?avno))
              (not (= ?avnp ?avnn))
              )
            (not (= ?avno ?avnn))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avnq Real)
        (declare-const ?avnr Real)
        (declare-const ?avns Real)
        (assert
          (and (and (not (= ?avns ?avnr))
              (not (= ?avns ?avnq))
              )
            (not (= ?avnr ?avnq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?avnt Real)
          (push 1)
            (declare-const ?avnu Real)
            (declare-const ?avnv Real)
            (push 1)
              (declare-const ?avnw Real)
              (declare-const ?avnx Real)
              (push 1)
                (assert
                  (and (and (and (= ?avnu ?avir)
                        (= ?avnv ?avnt)
                        )
                      (= ?avnw ?avmc)
                      )
                    (= ?avnx ?avnt)
                    )
                  )
                (push 1)
                  (declare-const ?avny Real)
                  (declare-const ?avnz Real)
                  (declare-const ?avoa Real)
                  (declare-const ?avob Real)
                  (declare-const ?avoc Real)
                  (declare-const ?avod Real)
                  (assert
                    (and (or (or (= ?avoa ?avnz)
                          (= ?avoa ?avny)
                          )
                        (= ?avnz ?avny)
                        )
                      (or (or (= ?avod ?avoc)
                          (= ?avod ?avob)
                          )
                        (= ?avoc ?avob)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avoe Real)
                  (declare-const ?avof Real)
                  (declare-const ?avog Real)
                  (assert
                    (and (and (not (= ?avog ?avof))
                        (not (= ?avog ?avoe))
                        )
                      (not (= ?avof ?avoe))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avoh Real)
                  (declare-const ?avoi Real)
                  (declare-const ?avoj Real)
                  (declare-const ?avok Real)
                  (assert
                    (and (and (not (= ?avoj ?avoi))
                        (not (= ?avoj ?avoh))
                        )
                      (not (= ?avoi ?avoh))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avol Real)
                  (declare-const ?avom Real)
                  (declare-const ?avon Real)
                  (declare-const ?avoo Real)
                  (declare-const ?avop Real)
                  (assert
                    (and (and (not (= ?avon ?avom))
                        (not (= ?avon ?avol))
                        )
                      (not (= ?avom ?avol))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avoq Real)
                  (declare-const ?avor Real)
                  (declare-const ?avos Real)
                  (assert
                    (and (and (not (= ?avos ?avor))
                        (not (= ?avos ?avoq))
                        )
                      (not (= ?avor ?avoq))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avot Real)
                  (declare-const ?avou Real)
                  (declare-const ?avov Real)
                  (declare-const ?avow Real)
                  (assert
                    (and (and (not (= ?avow ?avov))
                        (not (= ?avow ?avou))
                        )
                      (not (= ?avov ?avou))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avox Real)
                  (declare-const ?avoy Real)
                  (declare-const ?avoz Real)
                  (declare-const ?avpa Real)
                  (declare-const ?avpb Real)
                  (assert
                    (and (and (not (= ?avpb ?avpa))
                        (not (= ?avpb ?avoz))
                        )
                      (not (= ?avpa ?avoz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avpc Real)
                  (declare-const ?avpd Real)
                  (declare-const ?avpe Real)
                  (declare-const ?avpf Real)
                  (declare-const ?avpg Real)
                  (declare-const ?avph Real)
                  (assert
                    (and (and (and (not (= ?avpe ?avpd))
                          (not (= ?avpe ?avpc))
                          )
                        (not (= ?avpd ?avpc))
                        )
                      (and (and (not (= ?avph ?avpg))
                          (not (= ?avph ?avpf))
                          )
                        (not (= ?avpg ?avpf))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avpi Real)
                  (declare-const ?avpj Real)
                  (declare-const ?avpk Real)
                  (assert
                    (and (and (not (= ?avpk ?avpj))
                        (not (= ?avpk ?avpi))
                        )
                      (not (= ?avpj ?avpi))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avpl Real)
                  (declare-const ?avpm Real)
                  (declare-const ?avpn Real)
                  (assert
                    (and (and (not (= ?avpn ?avpm))
                        (not (= ?avpn ?avpl))
                        )
                      (not (= ?avpm ?avpl))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?avpo Real)
      (declare-const ?avpp Real)
      (push 1)
        (declare-const ?avpq Real)
        (declare-const ?avpr Real)
        (declare-const ?avps Real)
        (declare-const ?avpt Real)
        (declare-const ?avpu Real)
        (declare-const ?avpv Real)
        (assert
          (and (or (or (= ?avps ?avpr)
                (= ?avps ?avpq)
                )
              (= ?avpr ?avpq)
              )
            (or (or (= ?avpv ?avpu)
                (= ?avpv ?avpt)
                )
              (= ?avpu ?avpt)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avpw Real)
        (declare-const ?avpx Real)
        (declare-const ?avpy Real)
        (assert
          (and (and (not (= ?avpy ?avpx))
              (not (= ?avpy ?avpw))
              )
            (not (= ?avpx ?avpw))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avpz Real)
        (declare-const ?avqa Real)
        (declare-const ?avqb Real)
        (declare-const ?avqc Real)
        (assert
          (and (and (not (= ?avqb ?avqa))
              (not (= ?avqb ?avpz))
              )
            (not (= ?avqa ?avpz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avqd Real)
        (declare-const ?avqe Real)
        (declare-const ?avqf Real)
        (declare-const ?avqg Real)
        (declare-const ?avqh Real)
        (assert
          (and (and (not (= ?avqf ?avqe))
              (not (= ?avqf ?avqd))
              )
            (not (= ?avqe ?avqd))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avqi Real)
        (declare-const ?avqj Real)
        (declare-const ?avqk Real)
        (assert
          (and (and (not (= ?avqk ?avqj))
              (not (= ?avqk ?avqi))
              )
            (not (= ?avqj ?avqi))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avql Real)
        (declare-const ?avqm Real)
        (declare-const ?avqn Real)
        (declare-const ?avqo Real)
        (assert
          (and (and (not (= ?avqo ?avqn))
              (not (= ?avqo ?avqm))
              )
            (not (= ?avqn ?avqm))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avqp Real)
        (declare-const ?avqq Real)
        (declare-const ?avqr Real)
        (declare-const ?avqs Real)
        (declare-const ?avqt Real)
        (assert
          (and (and (not (= ?avqt ?avqs))
              (not (= ?avqt ?avqr))
              )
            (not (= ?avqs ?avqr))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avqu Real)
        (declare-const ?avqv Real)
        (declare-const ?avqw Real)
        (declare-const ?avqx Real)
        (declare-const ?avqy Real)
        (declare-const ?avqz Real)
        (assert
          (and (and (and (not (= ?avqw ?avqv))
                (not (= ?avqw ?avqu))
                )
              (not (= ?avqv ?avqu))
              )
            (and (and (not (= ?avqz ?avqy))
                (not (= ?avqz ?avqx))
                )
              (not (= ?avqy ?avqx))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avra Real)
        (declare-const ?avrb Real)
        (declare-const ?avrc Real)
        (assert
          (and (and (not (= ?avrc ?avrb))
              (not (= ?avrc ?avra))
              )
            (not (= ?avrb ?avra))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avrd Real)
        (declare-const ?avre Real)
        (declare-const ?avrf Real)
        (assert
          (and (and (not (= ?avrf ?avre))
              (not (= ?avrf ?avrd))
              )
            (not (= ?avre ?avrd))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?avrg Real)
          (push 1)
            (declare-const ?avrh Real)
            (declare-const ?avri Real)
            (push 1)
              (declare-const ?avrj Real)
              (declare-const ?avrk Real)
              (declare-const ?avrl Real)
              (push 1)
                (assert
                  (and (and (and (= ?avrh ?avir)
                        (= ?avri ?avrg)
                        )
                      (and (= ?avrk ?avpp)
                        (= ?avrj ?avpo)
                        )
                      )
                    (= ?avrl ?avrg)
                    )
                  )
                (push 1)
                  (declare-const ?avrm Real)
                  (declare-const ?avrn Real)
                  (declare-const ?avro Real)
                  (declare-const ?avrp Real)
                  (declare-const ?avrq Real)
                  (declare-const ?avrr Real)
                  (assert
                    (and (or (or (= ?avro ?avrn)
                          (= ?avro ?avrm)
                          )
                        (= ?avrn ?avrm)
                        )
                      (or (or (= ?avrr ?avrq)
                          (= ?avrr ?avrp)
                          )
                        (= ?avrq ?avrp)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avrs Real)
                  (declare-const ?avrt Real)
                  (declare-const ?avru Real)
                  (assert
                    (and (and (not (= ?avru ?avrt))
                        (not (= ?avru ?avrs))
                        )
                      (not (= ?avrt ?avrs))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avrv Real)
                  (declare-const ?avrw Real)
                  (declare-const ?avrx Real)
                  (declare-const ?avry Real)
                  (assert
                    (and (and (not (= ?avrx ?avrw))
                        (not (= ?avrx ?avrv))
                        )
                      (not (= ?avrw ?avrv))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avrz Real)
                  (declare-const ?avsa Real)
                  (declare-const ?avsb Real)
                  (declare-const ?avsc Real)
                  (declare-const ?avsd Real)
                  (assert
                    (and (and (not (= ?avsb ?avsa))
                        (not (= ?avsb ?avrz))
                        )
                      (not (= ?avsa ?avrz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avse Real)
                  (declare-const ?avsf Real)
                  (declare-const ?avsg Real)
                  (assert
                    (and (and (not (= ?avsg ?avsf))
                        (not (= ?avsg ?avse))
                        )
                      (not (= ?avsf ?avse))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avsh Real)
                  (declare-const ?avsi Real)
                  (declare-const ?avsj Real)
                  (declare-const ?avsk Real)
                  (assert
                    (and (and (not (= ?avsk ?avsj))
                        (not (= ?avsk ?avsi))
                        )
                      (not (= ?avsj ?avsi))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avsl Real)
                  (declare-const ?avsm Real)
                  (declare-const ?avsn Real)
                  (declare-const ?avso Real)
                  (declare-const ?avsp Real)
                  (assert
                    (and (and (not (= ?avsp ?avso))
                        (not (= ?avsp ?avsn))
                        )
                      (not (= ?avso ?avsn))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avsq Real)
                  (declare-const ?avsr Real)
                  (declare-const ?avss Real)
                  (declare-const ?avst Real)
                  (declare-const ?avsu Real)
                  (declare-const ?avsv Real)
                  (assert
                    (and (and (and (not (= ?avss ?avsr))
                          (not (= ?avss ?avsq))
                          )
                        (not (= ?avsr ?avsq))
                        )
                      (and (and (not (= ?avsv ?avsu))
                          (not (= ?avsv ?avst))
                          )
                        (not (= ?avsu ?avst))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avsw Real)
                  (declare-const ?avsx Real)
                  (declare-const ?avsy Real)
                  (assert
                    (and (and (not (= ?avsy ?avsx))
                        (not (= ?avsy ?avsw))
                        )
                      (not (= ?avsx ?avsw))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avsz Real)
                  (declare-const ?avta Real)
                  (declare-const ?avtb Real)
                  (assert
                    (and (and (not (= ?avtb ?avta))
                        (not (= ?avtb ?avsz))
                        )
                      (not (= ?avta ?avsz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (assert
                    (or (or (= ?avrk ?avrj)
                        (= ?avrk ?avrl)
                        )
                      (= ?avrj ?avrl)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (and (not (= ?avpp ?avpo))
              (forall ((?avrl Real) )(and (not (= ?avpp ?avrl))
                  (not (= ?avpo ?avrl))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?avtc Real)
      (declare-const ?avtd Real)
      (declare-const ?avte Real)
      (push 1)
        (declare-const ?avtf Real)
        (declare-const ?avtg Real)
        (declare-const ?avth Real)
        (declare-const ?avti Real)
        (declare-const ?avtj Real)
        (declare-const ?avtk Real)
        (assert
          (and (or (or (= ?avth ?avtg)
                (= ?avth ?avtf)
                )
              (= ?avtg ?avtf)
              )
            (or (or (= ?avtk ?avtj)
                (= ?avtk ?avti)
                )
              (= ?avtj ?avti)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avtl Real)
        (declare-const ?avtm Real)
        (declare-const ?avtn Real)
        (assert
          (and (and (not (= ?avtn ?avtm))
              (not (= ?avtn ?avtl))
              )
            (not (= ?avtm ?avtl))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avto Real)
        (declare-const ?avtp Real)
        (declare-const ?avtq Real)
        (declare-const ?avtr Real)
        (assert
          (and (and (not (= ?avtq ?avtp))
              (not (= ?avtq ?avto))
              )
            (not (= ?avtp ?avto))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avts Real)
        (declare-const ?avtt Real)
        (declare-const ?avtu Real)
        (declare-const ?avtv Real)
        (declare-const ?avtw Real)
        (assert
          (and (and (not (= ?avtu ?avtt))
              (not (= ?avtu ?avts))
              )
            (not (= ?avtt ?avts))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avtx Real)
        (declare-const ?avty Real)
        (declare-const ?avtz Real)
        (assert
          (and (and (not (= ?avtz ?avty))
              (not (= ?avtz ?avtx))
              )
            (not (= ?avty ?avtx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avua Real)
        (declare-const ?avub Real)
        (declare-const ?avuc Real)
        (declare-const ?avud Real)
        (assert
          (and (and (not (= ?avud ?avuc))
              (not (= ?avud ?avub))
              )
            (not (= ?avuc ?avub))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avue Real)
        (declare-const ?avuf Real)
        (declare-const ?avug Real)
        (declare-const ?avuh Real)
        (declare-const ?avui Real)
        (assert
          (and (and (not (= ?avui ?avuh))
              (not (= ?avui ?avug))
              )
            (not (= ?avuh ?avug))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avuj Real)
        (declare-const ?avuk Real)
        (declare-const ?avul Real)
        (declare-const ?avum Real)
        (declare-const ?avun Real)
        (declare-const ?avuo Real)
        (assert
          (and (and (and (not (= ?avul ?avuk))
                (not (= ?avul ?avuj))
                )
              (not (= ?avuk ?avuj))
              )
            (and (and (not (= ?avuo ?avun))
                (not (= ?avuo ?avum))
                )
              (not (= ?avun ?avum))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avup Real)
        (declare-const ?avuq Real)
        (declare-const ?avur Real)
        (assert
          (and (and (not (= ?avur ?avuq))
              (not (= ?avur ?avup))
              )
            (not (= ?avuq ?avup))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?avus Real)
        (declare-const ?avut Real)
        (declare-const ?avuu Real)
        (assert
          (and (and (not (= ?avuu ?avut))
              (not (= ?avuu ?avus))
              )
            (not (= ?avut ?avus))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?avte ?avtd))
              (not (= ?avte ?avtc))
              )
            (not (= ?avtd ?avtc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?avuv Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?avuw Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?avux Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avuy Real)
              (declare-const ?avuz Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avva Real)
              (declare-const ?avvb Real)
              (declare-const ?avvc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avvd Real)
              (declare-const ?avve Real)
              (declare-const ?avvf Real)
              (declare-const ?avvg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avvh Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?avvi Real)
            (declare-const ?avvj Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?avvk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avvl Real)
              (declare-const ?avvm Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avvn Real)
              (declare-const ?avvo Real)
              (declare-const ?avvp Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avvq Real)
              (declare-const ?avvr Real)
              (declare-const ?avvs Real)
              (declare-const ?avvt Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (and (= ?avvi ?avir)
                        (= ?avvj ?avuv)
                        )
                      (and (and (= ?avvs ?avte)
                          (= ?avvr ?avtd)
                          )
                        (= ?avvq ?avtc)
                        )
                      )
                    (= ?avvt ?avuv)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?avvu Real)
                  (declare-const ?avvv Real)
                  (declare-const ?avvw Real)
                  (declare-const ?avvx Real)
                  (declare-const ?avvy Real)
                  (declare-const ?avvz Real)
                  (assert
                    (and (or (or (= ?avvw ?avvv)
                          (= ?avvw ?avvu)
                          )
                        (= ?avvv ?avvu)
                        )
                      (or (or (= ?avvz ?avvy)
                          (= ?avvz ?avvx)
                          )
                        (= ?avvy ?avvx)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avwa Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avwb Real)
                  (declare-const ?avwc Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avwd Real)
                  (declare-const ?avwe Real)
                  (declare-const ?avwf Real)
                  (assert
                    (and (and (not (= ?avwf ?avwe))
                        (not (= ?avwf ?avwd))
                        )
                      (not (= ?avwe ?avwd))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avwg Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avwh Real)
                  (declare-const ?avwi Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avwj Real)
                  (declare-const ?avwk Real)
                  (declare-const ?avwl Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avwm Real)
                  (declare-const ?avwn Real)
                  (declare-const ?avwo Real)
                  (declare-const ?avwp Real)
                  (assert
                    (and (and (not (= ?avwo ?avwn))
                        (not (= ?avwo ?avwm))
                        )
                      (not (= ?avwn ?avwm))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avwq Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avwr Real)
                  (declare-const ?avws Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avwt Real)
                  (declare-const ?avwu Real)
                  (declare-const ?avwv Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avww Real)
                  (declare-const ?avwx Real)
                  (declare-const ?avwy Real)
                  (declare-const ?avwz Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avxa Real)
                  (declare-const ?avxb Real)
                  (declare-const ?avxc Real)
                  (declare-const ?avxd Real)
                  (declare-const ?avxe Real)
                  (assert
                    (and (and (not (= ?avxc ?avxb))
                        (not (= ?avxc ?avxa))
                        )
                      (not (= ?avxb ?avxa))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avxf Real)
                  (declare-const ?avxg Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avxh Real)
                  (declare-const ?avxi Real)
                  (declare-const ?avxj Real)
                  (assert
                    (and (and (not (= ?avxj ?avxi))
                        (not (= ?avxj ?avxh))
                        )
                      (not (= ?avxi ?avxh))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avxk Real)
                  (declare-const ?avxl Real)
                  (declare-const ?avxm Real)
                  (declare-const ?avxn Real)
                  (assert
                    (and (and (not (= ?avxn ?avxm))
                        (not (= ?avxn ?avxl))
                        )
                      (not (= ?avxm ?avxl))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avxo Real)
                  (declare-const ?avxp Real)
                  (declare-const ?avxq Real)
                  (declare-const ?avxr Real)
                  (declare-const ?avxs Real)
                  (assert
                    (and (and (not (= ?avxs ?avxr))
                        (not (= ?avxs ?avxq))
                        )
                      (not (= ?avxr ?avxq))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avxt Real)
                  (declare-const ?avxu Real)
                  (declare-const ?avxv Real)
                  (declare-const ?avxw Real)
                  (declare-const ?avxx Real)
                  (declare-const ?avxy Real)
                  (assert
                    (and (and (and (not (= ?avxv ?avxu))
                          (not (= ?avxv ?avxt))
                          )
                        (not (= ?avxu ?avxt))
                        )
                      (and (and (not (= ?avxy ?avxx))
                          (not (= ?avxy ?avxw))
                          )
                        (not (= ?avxx ?avxw))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avxz Real)
                  (declare-const ?avya Real)
                  (declare-const ?avyb Real)
                  (assert
                    (and (and (not (= ?avyb ?avya))
                        (not (= ?avyb ?avxz))
                        )
                      (not (= ?avya ?avxz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avyc Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avyd Real)
                  (declare-const ?avye Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?avyf Real)
                  (declare-const ?avyg Real)
                  (declare-const ?avyh Real)
                  (assert
                    (and (and (not (= ?avyh ?avyg))
                        (not (= ?avyh ?avyf))
                        )
                      (not (= ?avyg ?avyf))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?avyi Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?avyj Real)
            (declare-const ?avyk Real)
            (declare-const ?avyl Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?avym Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avyn Real)
              (declare-const ?avyo Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avyp Real)
              (declare-const ?avyq Real)
              (declare-const ?avyr Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avys Real)
              (declare-const ?avyt Real)
              (declare-const ?avyu Real)
              (declare-const ?avyv Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avyw Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?avyx Real)
            (declare-const ?avyy Real)
            (declare-const ?avyz Real)
            (declare-const ?avza Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?avzb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avzc Real)
              (declare-const ?avzd Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avze Real)
              (declare-const ?avzf Real)
              (declare-const ?avzg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avzh Real)
              (declare-const ?avzi Real)
              (declare-const ?avzj Real)
              (declare-const ?avzk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avzl Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?avzm Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?avzn Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avzo Real)
              (declare-const ?avzp Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avzq Real)
              (declare-const ?avzr Real)
              (declare-const ?avzs Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avzt Real)
              (declare-const ?avzu Real)
              (declare-const ?avzv Real)
              (declare-const ?avzw Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?avzx Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (declare-const ?avzy Real)
        (declare-const ?avzz Real)
        (declare-const ?awaa Real)
        (declare-const ?awab Real)
        (declare-const ?awac Real)
        (declare-const ?awad Real)
        (assert
          (and (or (or (= ?awaa ?avzz)
                (= ?awaa ?avzy)
                )
              (= ?avzz ?avzy)
              )
            (or (or (= ?awad ?awac)
                (= ?awad ?awab)
                )
              (= ?awac ?awab)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awae Real)
        (declare-const ?awaf Real)
        (declare-const ?awag Real)
        (assert
          (and (and (not (= ?awag ?awaf))
              (not (= ?awag ?awae))
              )
            (not (= ?awaf ?awae))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awah Real)
        (declare-const ?awai Real)
        (declare-const ?awaj Real)
        (declare-const ?awak Real)
        (assert
          (and (and (not (= ?awaj ?awai))
              (not (= ?awaj ?awah))
              )
            (not (= ?awai ?awah))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awal Real)
        (declare-const ?awam Real)
        (declare-const ?awan Real)
        (declare-const ?awao Real)
        (declare-const ?awap Real)
        (assert
          (and (and (not (= ?awan ?awam))
              (not (= ?awan ?awal))
              )
            (not (= ?awam ?awal))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awaq Real)
        (declare-const ?awar Real)
        (declare-const ?awas Real)
        (assert
          (and (and (not (= ?awas ?awar))
              (not (= ?awas ?awaq))
              )
            (not (= ?awar ?awaq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awat Real)
        (declare-const ?awau Real)
        (declare-const ?awav Real)
        (declare-const ?awaw Real)
        (assert
          (and (and (not (= ?awaw ?awav))
              (not (= ?awaw ?awau))
              )
            (not (= ?awav ?awau))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awax Real)
        (declare-const ?away Real)
        (declare-const ?awaz Real)
        (declare-const ?awba Real)
        (declare-const ?awbb Real)
        (assert
          (and (and (not (= ?awbb ?awba))
              (not (= ?awbb ?awaz))
              )
            (not (= ?awba ?awaz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awbc Real)
        (declare-const ?awbd Real)
        (declare-const ?awbe Real)
        (declare-const ?awbf Real)
        (declare-const ?awbg Real)
        (declare-const ?awbh Real)
        (assert
          (and (and (and (not (= ?awbe ?awbd))
                (not (= ?awbe ?awbc))
                )
              (not (= ?awbd ?awbc))
              )
            (and (and (not (= ?awbh ?awbg))
                (not (= ?awbh ?awbf))
                )
              (not (= ?awbg ?awbf))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awbi Real)
        (declare-const ?awbj Real)
        (declare-const ?awbk Real)
        (assert
          (and (and (not (= ?awbk ?awbj))
              (not (= ?awbk ?awbi))
              )
            (not (= ?awbj ?awbi))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awbl Real)
        (declare-const ?awbm Real)
        (declare-const ?awbn Real)
        (assert
          (and (and (not (= ?awbn ?awbm))
              (not (= ?awbn ?awbl))
              )
            (not (= ?awbm ?awbl))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?awbo Real)
          (push 1)
            (declare-const ?awbp Real)
            (declare-const ?awbq Real)
            (push 1)
              (declare-const ?awbr Real)
              (push 1)
                (assert
                  (and (and (= ?awbp ?avir)
                      (= ?awbq ?awbo)
                      )
                    (= ?awbr ?awbo)
                    )
                  )
                (push 1)
                  (declare-const ?awbs Real)
                  (declare-const ?awbt Real)
                  (declare-const ?awbu Real)
                  (declare-const ?awbv Real)
                  (declare-const ?awbw Real)
                  (declare-const ?awbx Real)
                  (assert
                    (and (or (or (= ?awbu ?awbt)
                          (= ?awbu ?awbs)
                          )
                        (= ?awbt ?awbs)
                        )
                      (or (or (= ?awbx ?awbw)
                          (= ?awbx ?awbv)
                          )
                        (= ?awbw ?awbv)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awby Real)
                  (declare-const ?awbz Real)
                  (declare-const ?awca Real)
                  (assert
                    (and (and (not (= ?awca ?awbz))
                        (not (= ?awca ?awby))
                        )
                      (not (= ?awbz ?awby))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awcb Real)
                  (declare-const ?awcc Real)
                  (declare-const ?awcd Real)
                  (declare-const ?awce Real)
                  (assert
                    (and (and (not (= ?awcd ?awcc))
                        (not (= ?awcd ?awcb))
                        )
                      (not (= ?awcc ?awcb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awcf Real)
                  (declare-const ?awcg Real)
                  (declare-const ?awch Real)
                  (declare-const ?awci Real)
                  (declare-const ?awcj Real)
                  (assert
                    (and (and (not (= ?awch ?awcg))
                        (not (= ?awch ?awcf))
                        )
                      (not (= ?awcg ?awcf))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awck Real)
                  (declare-const ?awcl Real)
                  (declare-const ?awcm Real)
                  (assert
                    (and (and (not (= ?awcm ?awcl))
                        (not (= ?awcm ?awck))
                        )
                      (not (= ?awcl ?awck))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awcn Real)
                  (declare-const ?awco Real)
                  (declare-const ?awcp Real)
                  (declare-const ?awcq Real)
                  (assert
                    (and (and (not (= ?awcq ?awcp))
                        (not (= ?awcq ?awco))
                        )
                      (not (= ?awcp ?awco))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awcr Real)
                  (declare-const ?awcs Real)
                  (declare-const ?awct Real)
                  (declare-const ?awcu Real)
                  (declare-const ?awcv Real)
                  (assert
                    (and (and (not (= ?awcv ?awcu))
                        (not (= ?awcv ?awct))
                        )
                      (not (= ?awcu ?awct))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awcw Real)
                  (declare-const ?awcx Real)
                  (declare-const ?awcy Real)
                  (declare-const ?awcz Real)
                  (declare-const ?awda Real)
                  (declare-const ?awdb Real)
                  (assert
                    (and (and (and (not (= ?awcy ?awcx))
                          (not (= ?awcy ?awcw))
                          )
                        (not (= ?awcx ?awcw))
                        )
                      (and (and (not (= ?awdb ?awda))
                          (not (= ?awdb ?awcz))
                          )
                        (not (= ?awda ?awcz))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awdc Real)
                  (declare-const ?awdd Real)
                  (declare-const ?awde Real)
                  (assert
                    (and (and (not (= ?awde ?awdd))
                        (not (= ?awde ?awdc))
                        )
                      (not (= ?awdd ?awdc))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awdf Real)
                  (declare-const ?awdg Real)
                  (declare-const ?awdh Real)
                  (assert
                    (and (and (not (= ?awdh ?awdg))
                        (not (= ?awdh ?awdf))
                        )
                      (not (= ?awdg ?awdf))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?awdi Real)
    (declare-const ?awdj Real)
    (push 1)
      (push 1)
        (declare-const ?awdk Real)
        (declare-const ?awdl Real)
        (declare-const ?awdm Real)
        (declare-const ?awdn Real)
        (declare-const ?awdo Real)
        (declare-const ?awdp Real)
        (assert
          (and (or (or (= ?awdm ?awdl)
                (= ?awdm ?awdk)
                )
              (= ?awdl ?awdk)
              )
            (or (or (= ?awdp ?awdo)
                (= ?awdp ?awdn)
                )
              (= ?awdo ?awdn)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awdq Real)
        (declare-const ?awdr Real)
        (declare-const ?awds Real)
        (assert
          (and (and (not (= ?awds ?awdr))
              (not (= ?awds ?awdq))
              )
            (not (= ?awdr ?awdq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awdt Real)
        (declare-const ?awdu Real)
        (declare-const ?awdv Real)
        (declare-const ?awdw Real)
        (assert
          (and (and (not (= ?awdv ?awdu))
              (not (= ?awdv ?awdt))
              )
            (not (= ?awdu ?awdt))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awdx Real)
        (declare-const ?awdy Real)
        (declare-const ?awdz Real)
        (declare-const ?awea Real)
        (declare-const ?aweb Real)
        (assert
          (and (and (not (= ?awdz ?awdy))
              (not (= ?awdz ?awdx))
              )
            (not (= ?awdy ?awdx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awec Real)
        (declare-const ?awed Real)
        (declare-const ?awee Real)
        (assert
          (and (and (not (= ?awee ?awed))
              (not (= ?awee ?awec))
              )
            (not (= ?awed ?awec))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awef Real)
        (declare-const ?aweg Real)
        (declare-const ?aweh Real)
        (declare-const ?awei Real)
        (assert
          (and (and (not (= ?awei ?aweh))
              (not (= ?awei ?aweg))
              )
            (not (= ?aweh ?aweg))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awej Real)
        (declare-const ?awek Real)
        (declare-const ?awel Real)
        (declare-const ?awem Real)
        (declare-const ?awen Real)
        (assert
          (and (and (not (= ?awen ?awem))
              (not (= ?awen ?awel))
              )
            (not (= ?awem ?awel))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aweo Real)
        (declare-const ?awep Real)
        (declare-const ?aweq Real)
        (declare-const ?awer Real)
        (declare-const ?awes Real)
        (declare-const ?awet Real)
        (assert
          (and (and (and (not (= ?aweq ?awep))
                (not (= ?aweq ?aweo))
                )
              (not (= ?awep ?aweo))
              )
            (and (and (not (= ?awet ?awes))
                (not (= ?awet ?awer))
                )
              (not (= ?awes ?awer))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aweu Real)
        (declare-const ?awev Real)
        (declare-const ?awew Real)
        (assert
          (and (and (not (= ?awew ?awev))
              (not (= ?awew ?aweu))
              )
            (not (= ?awev ?aweu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awex Real)
        (declare-const ?awey Real)
        (declare-const ?awez Real)
        (assert
          (and (and (not (= ?awez ?awey))
              (not (= ?awez ?awex))
              )
            (not (= ?awey ?awex))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?awfa Real)
          (push 1)
            (declare-const ?awfb Real)
            (declare-const ?awfc Real)
            (declare-const ?awfd Real)
            (push 1)
              (declare-const ?awfe Real)
              (push 1)
                (assert
                  (and (and (and (= ?awfc ?awdj)
                        (= ?awfb ?awdi)
                        )
                      (= ?awfd ?awfa)
                      )
                    (= ?awfe ?awfa)
                    )
                  )
                (push 1)
                  (declare-const ?awff Real)
                  (declare-const ?awfg Real)
                  (declare-const ?awfh Real)
                  (declare-const ?awfi Real)
                  (declare-const ?awfj Real)
                  (declare-const ?awfk Real)
                  (assert
                    (and (or (or (= ?awfh ?awfg)
                          (= ?awfh ?awff)
                          )
                        (= ?awfg ?awff)
                        )
                      (or (or (= ?awfk ?awfj)
                          (= ?awfk ?awfi)
                          )
                        (= ?awfj ?awfi)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awfl Real)
                  (declare-const ?awfm Real)
                  (declare-const ?awfn Real)
                  (assert
                    (and (and (not (= ?awfn ?awfm))
                        (not (= ?awfn ?awfl))
                        )
                      (not (= ?awfm ?awfl))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awfo Real)
                  (declare-const ?awfp Real)
                  (declare-const ?awfq Real)
                  (declare-const ?awfr Real)
                  (assert
                    (and (and (not (= ?awfq ?awfp))
                        (not (= ?awfq ?awfo))
                        )
                      (not (= ?awfp ?awfo))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awfs Real)
                  (declare-const ?awft Real)
                  (declare-const ?awfu Real)
                  (declare-const ?awfv Real)
                  (declare-const ?awfw Real)
                  (assert
                    (and (and (not (= ?awfu ?awft))
                        (not (= ?awfu ?awfs))
                        )
                      (not (= ?awft ?awfs))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awfx Real)
                  (declare-const ?awfy Real)
                  (declare-const ?awfz Real)
                  (assert
                    (and (and (not (= ?awfz ?awfy))
                        (not (= ?awfz ?awfx))
                        )
                      (not (= ?awfy ?awfx))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awga Real)
                  (declare-const ?awgb Real)
                  (declare-const ?awgc Real)
                  (declare-const ?awgd Real)
                  (assert
                    (and (and (not (= ?awgd ?awgc))
                        (not (= ?awgd ?awgb))
                        )
                      (not (= ?awgc ?awgb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awge Real)
                  (declare-const ?awgf Real)
                  (declare-const ?awgg Real)
                  (declare-const ?awgh Real)
                  (declare-const ?awgi Real)
                  (assert
                    (and (and (not (= ?awgi ?awgh))
                        (not (= ?awgi ?awgg))
                        )
                      (not (= ?awgh ?awgg))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awgj Real)
                  (declare-const ?awgk Real)
                  (declare-const ?awgl Real)
                  (declare-const ?awgm Real)
                  (declare-const ?awgn Real)
                  (declare-const ?awgo Real)
                  (assert
                    (and (and (and (not (= ?awgl ?awgk))
                          (not (= ?awgl ?awgj))
                          )
                        (not (= ?awgk ?awgj))
                        )
                      (and (and (not (= ?awgo ?awgn))
                          (not (= ?awgo ?awgm))
                          )
                        (not (= ?awgn ?awgm))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awgp Real)
                  (declare-const ?awgq Real)
                  (declare-const ?awgr Real)
                  (assert
                    (and (and (not (= ?awgr ?awgq))
                        (not (= ?awgr ?awgp))
                        )
                      (not (= ?awgq ?awgp))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awgs Real)
                  (declare-const ?awgt Real)
                  (declare-const ?awgu Real)
                  (assert
                    (and (and (not (= ?awgu ?awgt))
                        (not (= ?awgu ?awgs))
                        )
                      (not (= ?awgt ?awgs))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (assert
                    (or (or (= ?awfc ?awfb)
                        (= ?awfc ?awfd)
                        )
                      (= ?awfb ?awfd)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (and (not (= ?awdj ?awdi))
              (forall ((?awfd Real) )(and (not (= ?awdj ?awfd))
                  (not (= ?awdi ?awfd))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?awgv Real)
      (push 1)
        (declare-const ?awgw Real)
        (declare-const ?awgx Real)
        (declare-const ?awgy Real)
        (declare-const ?awgz Real)
        (declare-const ?awha Real)
        (declare-const ?awhb Real)
        (assert
          (and (or (or (= ?awgy ?awgx)
                (= ?awgy ?awgw)
                )
              (= ?awgx ?awgw)
              )
            (or (or (= ?awhb ?awha)
                (= ?awhb ?awgz)
                )
              (= ?awha ?awgz)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awhc Real)
        (declare-const ?awhd Real)
        (declare-const ?awhe Real)
        (assert
          (and (and (not (= ?awhe ?awhd))
              (not (= ?awhe ?awhc))
              )
            (not (= ?awhd ?awhc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awhf Real)
        (declare-const ?awhg Real)
        (declare-const ?awhh Real)
        (declare-const ?awhi Real)
        (assert
          (and (and (not (= ?awhh ?awhg))
              (not (= ?awhh ?awhf))
              )
            (not (= ?awhg ?awhf))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awhj Real)
        (declare-const ?awhk Real)
        (declare-const ?awhl Real)
        (declare-const ?awhm Real)
        (declare-const ?awhn Real)
        (assert
          (and (and (not (= ?awhl ?awhk))
              (not (= ?awhl ?awhj))
              )
            (not (= ?awhk ?awhj))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awho Real)
        (declare-const ?awhp Real)
        (declare-const ?awhq Real)
        (assert
          (and (and (not (= ?awhq ?awhp))
              (not (= ?awhq ?awho))
              )
            (not (= ?awhp ?awho))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awhr Real)
        (declare-const ?awhs Real)
        (declare-const ?awht Real)
        (declare-const ?awhu Real)
        (assert
          (and (and (not (= ?awhu ?awht))
              (not (= ?awhu ?awhs))
              )
            (not (= ?awht ?awhs))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awhv Real)
        (declare-const ?awhw Real)
        (declare-const ?awhx Real)
        (declare-const ?awhy Real)
        (declare-const ?awhz Real)
        (assert
          (and (and (not (= ?awhz ?awhy))
              (not (= ?awhz ?awhx))
              )
            (not (= ?awhy ?awhx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awia Real)
        (declare-const ?awib Real)
        (declare-const ?awic Real)
        (declare-const ?awid Real)
        (declare-const ?awie Real)
        (declare-const ?awif Real)
        (assert
          (and (and (and (not (= ?awic ?awib))
                (not (= ?awic ?awia))
                )
              (not (= ?awib ?awia))
              )
            (and (and (not (= ?awif ?awie))
                (not (= ?awif ?awid))
                )
              (not (= ?awie ?awid))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awig Real)
        (declare-const ?awih Real)
        (declare-const ?awii Real)
        (assert
          (and (and (not (= ?awii ?awih))
              (not (= ?awii ?awig))
              )
            (not (= ?awih ?awig))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awij Real)
        (declare-const ?awik Real)
        (declare-const ?awil Real)
        (assert
          (and (and (not (= ?awil ?awik))
              (not (= ?awil ?awij))
              )
            (not (= ?awik ?awij))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?awim Real)
          (push 1)
            (declare-const ?awin Real)
            (declare-const ?awio Real)
            (declare-const ?awip Real)
            (push 1)
              (declare-const ?awiq Real)
              (declare-const ?awir Real)
              (push 1)
                (assert
                  (and (and (and (and (= ?awio ?awdj)
                          (= ?awin ?awdi)
                          )
                        (= ?awip ?awim)
                        )
                      (= ?awiq ?awgv)
                      )
                    (= ?awir ?awim)
                    )
                  )
                (push 1)
                  (declare-const ?awis Real)
                  (declare-const ?awit Real)
                  (declare-const ?awiu Real)
                  (declare-const ?awiv Real)
                  (declare-const ?awiw Real)
                  (declare-const ?awix Real)
                  (assert
                    (and (or (or (= ?awiu ?awit)
                          (= ?awiu ?awis)
                          )
                        (= ?awit ?awis)
                        )
                      (or (or (= ?awix ?awiw)
                          (= ?awix ?awiv)
                          )
                        (= ?awiw ?awiv)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awiy Real)
                  (declare-const ?awiz Real)
                  (declare-const ?awja Real)
                  (assert
                    (and (and (not (= ?awja ?awiz))
                        (not (= ?awja ?awiy))
                        )
                      (not (= ?awiz ?awiy))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awjb Real)
                  (declare-const ?awjc Real)
                  (declare-const ?awjd Real)
                  (declare-const ?awje Real)
                  (assert
                    (and (and (not (= ?awjd ?awjc))
                        (not (= ?awjd ?awjb))
                        )
                      (not (= ?awjc ?awjb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awjf Real)
                  (declare-const ?awjg Real)
                  (declare-const ?awjh Real)
                  (declare-const ?awji Real)
                  (declare-const ?awjj Real)
                  (assert
                    (and (and (not (= ?awjh ?awjg))
                        (not (= ?awjh ?awjf))
                        )
                      (not (= ?awjg ?awjf))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awjk Real)
                  (declare-const ?awjl Real)
                  (declare-const ?awjm Real)
                  (assert
                    (and (and (not (= ?awjm ?awjl))
                        (not (= ?awjm ?awjk))
                        )
                      (not (= ?awjl ?awjk))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awjn Real)
                  (declare-const ?awjo Real)
                  (declare-const ?awjp Real)
                  (declare-const ?awjq Real)
                  (assert
                    (and (and (not (= ?awjq ?awjp))
                        (not (= ?awjq ?awjo))
                        )
                      (not (= ?awjp ?awjo))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awjr Real)
                  (declare-const ?awjs Real)
                  (declare-const ?awjt Real)
                  (declare-const ?awju Real)
                  (declare-const ?awjv Real)
                  (assert
                    (and (and (not (= ?awjv ?awju))
                        (not (= ?awjv ?awjt))
                        )
                      (not (= ?awju ?awjt))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awjw Real)
                  (declare-const ?awjx Real)
                  (declare-const ?awjy Real)
                  (declare-const ?awjz Real)
                  (declare-const ?awka Real)
                  (declare-const ?awkb Real)
                  (assert
                    (and (and (and (not (= ?awjy ?awjx))
                          (not (= ?awjy ?awjw))
                          )
                        (not (= ?awjx ?awjw))
                        )
                      (and (and (not (= ?awkb ?awka))
                          (not (= ?awkb ?awjz))
                          )
                        (not (= ?awka ?awjz))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awkc Real)
                  (declare-const ?awkd Real)
                  (declare-const ?awke Real)
                  (assert
                    (and (and (not (= ?awke ?awkd))
                        (not (= ?awke ?awkc))
                        )
                      (not (= ?awkd ?awkc))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awkf Real)
                  (declare-const ?awkg Real)
                  (declare-const ?awkh Real)
                  (assert
                    (and (and (not (= ?awkh ?awkg))
                        (not (= ?awkh ?awkf))
                        )
                      (not (= ?awkg ?awkf))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (assert
                    (or (or (= ?awio ?awin)
                        (= ?awio ?awip)
                        )
                      (= ?awin ?awip)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (and (not (= ?awdj ?awdi))
              (forall ((?awir Real) )(and (not (= ?awdj ?awir))
                  (not (= ?awdi ?awir))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?awki Real)
      (declare-const ?awkj Real)
      (push 1)
        (declare-const ?awkk Real)
        (declare-const ?awkl Real)
        (declare-const ?awkm Real)
        (declare-const ?awkn Real)
        (declare-const ?awko Real)
        (declare-const ?awkp Real)
        (assert
          (and (or (or (= ?awkm ?awkl)
                (= ?awkm ?awkk)
                )
              (= ?awkl ?awkk)
              )
            (or (or (= ?awkp ?awko)
                (= ?awkp ?awkn)
                )
              (= ?awko ?awkn)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awkq Real)
        (declare-const ?awkr Real)
        (declare-const ?awks Real)
        (assert
          (and (and (not (= ?awks ?awkr))
              (not (= ?awks ?awkq))
              )
            (not (= ?awkr ?awkq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awkt Real)
        (declare-const ?awku Real)
        (declare-const ?awkv Real)
        (declare-const ?awkw Real)
        (assert
          (and (and (not (= ?awkv ?awku))
              (not (= ?awkv ?awkt))
              )
            (not (= ?awku ?awkt))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awkx Real)
        (declare-const ?awky Real)
        (declare-const ?awkz Real)
        (declare-const ?awla Real)
        (declare-const ?awlb Real)
        (assert
          (and (and (not (= ?awkz ?awky))
              (not (= ?awkz ?awkx))
              )
            (not (= ?awky ?awkx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awlc Real)
        (declare-const ?awld Real)
        (declare-const ?awle Real)
        (assert
          (and (and (not (= ?awle ?awld))
              (not (= ?awle ?awlc))
              )
            (not (= ?awld ?awlc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awlf Real)
        (declare-const ?awlg Real)
        (declare-const ?awlh Real)
        (declare-const ?awli Real)
        (assert
          (and (and (not (= ?awli ?awlh))
              (not (= ?awli ?awlg))
              )
            (not (= ?awlh ?awlg))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awlj Real)
        (declare-const ?awlk Real)
        (declare-const ?awll Real)
        (declare-const ?awlm Real)
        (declare-const ?awln Real)
        (assert
          (and (and (not (= ?awln ?awlm))
              (not (= ?awln ?awll))
              )
            (not (= ?awlm ?awll))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awlo Real)
        (declare-const ?awlp Real)
        (declare-const ?awlq Real)
        (declare-const ?awlr Real)
        (declare-const ?awls Real)
        (declare-const ?awlt Real)
        (assert
          (and (and (and (not (= ?awlq ?awlp))
                (not (= ?awlq ?awlo))
                )
              (not (= ?awlp ?awlo))
              )
            (and (and (not (= ?awlt ?awls))
                (not (= ?awlt ?awlr))
                )
              (not (= ?awls ?awlr))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awlu Real)
        (declare-const ?awlv Real)
        (declare-const ?awlw Real)
        (assert
          (and (and (not (= ?awlw ?awlv))
              (not (= ?awlw ?awlu))
              )
            (not (= ?awlv ?awlu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awlx Real)
        (declare-const ?awly Real)
        (declare-const ?awlz Real)
        (assert
          (and (and (not (= ?awlz ?awly))
              (not (= ?awlz ?awlx))
              )
            (not (= ?awly ?awlx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?awma Real)
          (push 1)
            (declare-const ?awmb Real)
            (declare-const ?awmc Real)
            (declare-const ?awmd Real)
            (push 1)
              (declare-const ?awme Real)
              (declare-const ?awmf Real)
              (declare-const ?awmg Real)
              (push 1)
                (assert
                  (and (and (and (and (= ?awmc ?awdj)
                          (= ?awmb ?awdi)
                          )
                        (= ?awmd ?awma)
                        )
                      (and (= ?awmf ?awkj)
                        (= ?awme ?awki)
                        )
                      )
                    (= ?awmg ?awma)
                    )
                  )
                (push 1)
                  (declare-const ?awmh Real)
                  (declare-const ?awmi Real)
                  (declare-const ?awmj Real)
                  (declare-const ?awmk Real)
                  (declare-const ?awml Real)
                  (declare-const ?awmm Real)
                  (assert
                    (and (or (or (= ?awmj ?awmi)
                          (= ?awmj ?awmh)
                          )
                        (= ?awmi ?awmh)
                        )
                      (or (or (= ?awmm ?awml)
                          (= ?awmm ?awmk)
                          )
                        (= ?awml ?awmk)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awmn Real)
                  (declare-const ?awmo Real)
                  (declare-const ?awmp Real)
                  (assert
                    (and (and (not (= ?awmp ?awmo))
                        (not (= ?awmp ?awmn))
                        )
                      (not (= ?awmo ?awmn))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awmq Real)
                  (declare-const ?awmr Real)
                  (declare-const ?awms Real)
                  (declare-const ?awmt Real)
                  (assert
                    (and (and (not (= ?awms ?awmr))
                        (not (= ?awms ?awmq))
                        )
                      (not (= ?awmr ?awmq))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awmu Real)
                  (declare-const ?awmv Real)
                  (declare-const ?awmw Real)
                  (declare-const ?awmx Real)
                  (declare-const ?awmy Real)
                  (assert
                    (and (and (not (= ?awmw ?awmv))
                        (not (= ?awmw ?awmu))
                        )
                      (not (= ?awmv ?awmu))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awmz Real)
                  (declare-const ?awna Real)
                  (declare-const ?awnb Real)
                  (assert
                    (and (and (not (= ?awnb ?awna))
                        (not (= ?awnb ?awmz))
                        )
                      (not (= ?awna ?awmz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awnc Real)
                  (declare-const ?awnd Real)
                  (declare-const ?awne Real)
                  (declare-const ?awnf Real)
                  (assert
                    (and (and (not (= ?awnf ?awne))
                        (not (= ?awnf ?awnd))
                        )
                      (not (= ?awne ?awnd))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awng Real)
                  (declare-const ?awnh Real)
                  (declare-const ?awni Real)
                  (declare-const ?awnj Real)
                  (declare-const ?awnk Real)
                  (assert
                    (and (and (not (= ?awnk ?awnj))
                        (not (= ?awnk ?awni))
                        )
                      (not (= ?awnj ?awni))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awnl Real)
                  (declare-const ?awnm Real)
                  (declare-const ?awnn Real)
                  (declare-const ?awno Real)
                  (declare-const ?awnp Real)
                  (declare-const ?awnq Real)
                  (assert
                    (and (and (and (not (= ?awnn ?awnm))
                          (not (= ?awnn ?awnl))
                          )
                        (not (= ?awnm ?awnl))
                        )
                      (and (and (not (= ?awnq ?awnp))
                          (not (= ?awnq ?awno))
                          )
                        (not (= ?awnp ?awno))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awnr Real)
                  (declare-const ?awns Real)
                  (declare-const ?awnt Real)
                  (assert
                    (and (and (not (= ?awnt ?awns))
                        (not (= ?awnt ?awnr))
                        )
                      (not (= ?awns ?awnr))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awnu Real)
                  (declare-const ?awnv Real)
                  (declare-const ?awnw Real)
                  (assert
                    (and (and (not (= ?awnw ?awnv))
                        (not (= ?awnw ?awnu))
                        )
                      (not (= ?awnv ?awnu))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (assert
                    (and (or (and (and (not (= ?awmf ?awme))
                            (not (= ?awmf ?awmg))
                            )
                          (not (= ?awme ?awmg))
                          )
                        (and (and (not (= ?awmc ?awmb))
                            (not (= ?awmc ?awmd))
                            )
                          (not (= ?awmb ?awmd))
                          )
                        )
                      (or (or (or (= ?awmf ?awme)
                            (= ?awmf ?awmg)
                            )
                          (= ?awme ?awmg)
                          )
                        (or (or (= ?awmc ?awmb)
                            (= ?awmc ?awmd)
                            )
                          (= ?awmb ?awmd)
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (forall ((?awmg Real) )(or (and (or (or (= ?awkj ?awki)
                      (= ?awkj ?awmg)
                      )
                    (= ?awki ?awmg)
                    )
                  (or (or (= ?awdj ?awdi)
                      (= ?awdj ?awmg)
                      )
                    (= ?awdi ?awmg)
                    )
                  )
                (and (and (and (not (= ?awkj ?awki))
                      (not (= ?awkj ?awmg))
                      )
                    (not (= ?awki ?awmg))
                    )
                  (and (and (not (= ?awdj ?awdi))
                      (not (= ?awdj ?awmg))
                      )
                    (not (= ?awdi ?awmg))
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?awnx Real)
      (declare-const ?awny Real)
      (declare-const ?awnz Real)
      (push 1)
        (declare-const ?awoa Real)
        (declare-const ?awob Real)
        (declare-const ?awoc Real)
        (declare-const ?awod Real)
        (declare-const ?awoe Real)
        (declare-const ?awof Real)
        (assert
          (and (or (or (= ?awoc ?awob)
                (= ?awoc ?awoa)
                )
              (= ?awob ?awoa)
              )
            (or (or (= ?awof ?awoe)
                (= ?awof ?awod)
                )
              (= ?awoe ?awod)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awog Real)
        (declare-const ?awoh Real)
        (declare-const ?awoi Real)
        (assert
          (and (and (not (= ?awoi ?awoh))
              (not (= ?awoi ?awog))
              )
            (not (= ?awoh ?awog))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awoj Real)
        (declare-const ?awok Real)
        (declare-const ?awol Real)
        (declare-const ?awom Real)
        (assert
          (and (and (not (= ?awol ?awok))
              (not (= ?awol ?awoj))
              )
            (not (= ?awok ?awoj))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awon Real)
        (declare-const ?awoo Real)
        (declare-const ?awop Real)
        (declare-const ?awoq Real)
        (declare-const ?awor Real)
        (assert
          (and (and (not (= ?awop ?awoo))
              (not (= ?awop ?awon))
              )
            (not (= ?awoo ?awon))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awos Real)
        (declare-const ?awot Real)
        (declare-const ?awou Real)
        (assert
          (and (and (not (= ?awou ?awot))
              (not (= ?awou ?awos))
              )
            (not (= ?awot ?awos))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awov Real)
        (declare-const ?awow Real)
        (declare-const ?awox Real)
        (declare-const ?awoy Real)
        (assert
          (and (and (not (= ?awoy ?awox))
              (not (= ?awoy ?awow))
              )
            (not (= ?awox ?awow))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awoz Real)
        (declare-const ?awpa Real)
        (declare-const ?awpb Real)
        (declare-const ?awpc Real)
        (declare-const ?awpd Real)
        (assert
          (and (and (not (= ?awpd ?awpc))
              (not (= ?awpd ?awpb))
              )
            (not (= ?awpc ?awpb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awpe Real)
        (declare-const ?awpf Real)
        (declare-const ?awpg Real)
        (declare-const ?awph Real)
        (declare-const ?awpi Real)
        (declare-const ?awpj Real)
        (assert
          (and (and (and (not (= ?awpg ?awpf))
                (not (= ?awpg ?awpe))
                )
              (not (= ?awpf ?awpe))
              )
            (and (and (not (= ?awpj ?awpi))
                (not (= ?awpj ?awph))
                )
              (not (= ?awpi ?awph))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awpk Real)
        (declare-const ?awpl Real)
        (declare-const ?awpm Real)
        (assert
          (and (and (not (= ?awpm ?awpl))
              (not (= ?awpm ?awpk))
              )
            (not (= ?awpl ?awpk))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awpn Real)
        (declare-const ?awpo Real)
        (declare-const ?awpp Real)
        (assert
          (and (and (not (= ?awpp ?awpo))
              (not (= ?awpp ?awpn))
              )
            (not (= ?awpo ?awpn))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?awnz ?awny))
              (not (= ?awnz ?awnx))
              )
            (not (= ?awny ?awnx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?awpq Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?awpr Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?awps Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?awpt Real)
              (declare-const ?awpu Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?awpv Real)
              (declare-const ?awpw Real)
              (declare-const ?awpx Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?awpy Real)
              (declare-const ?awpz Real)
              (declare-const ?awqa Real)
              (declare-const ?awqb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?awqc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?awqd Real)
            (declare-const ?awqe Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?awqf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?awqg Real)
              (declare-const ?awqh Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?awqi Real)
              (declare-const ?awqj Real)
              (declare-const ?awqk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?awql Real)
              (declare-const ?awqm Real)
              (declare-const ?awqn Real)
              (declare-const ?awqo Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?awqp Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?awqq Real)
            (declare-const ?awqr Real)
            (declare-const ?awqs Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?awqt Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?awqu Real)
              (declare-const ?awqv Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?awqw Real)
              (declare-const ?awqx Real)
              (declare-const ?awqy Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?awqz Real)
              (declare-const ?awra Real)
              (declare-const ?awrb Real)
              (declare-const ?awrc Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (and (and (= ?awqr ?awdj)
                          (= ?awqq ?awdi)
                          )
                        (= ?awqs ?awpq)
                        )
                      (and (and (= ?awrb ?awnz)
                          (= ?awra ?awny)
                          )
                        (= ?awqz ?awnx)
                        )
                      )
                    (= ?awrc ?awpq)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?awrd Real)
                  (declare-const ?awre Real)
                  (declare-const ?awrf Real)
                  (declare-const ?awrg Real)
                  (declare-const ?awrh Real)
                  (declare-const ?awri Real)
                  (assert
                    (and (or (or (= ?awrf ?awre)
                          (= ?awrf ?awrd)
                          )
                        (= ?awre ?awrd)
                        )
                      (or (or (= ?awri ?awrh)
                          (= ?awri ?awrg)
                          )
                        (= ?awrh ?awrg)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awrj Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awrk Real)
                  (declare-const ?awrl Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awrm Real)
                  (declare-const ?awrn Real)
                  (declare-const ?awro Real)
                  (assert
                    (and (and (not (= ?awro ?awrn))
                        (not (= ?awro ?awrm))
                        )
                      (not (= ?awrn ?awrm))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awrp Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awrq Real)
                  (declare-const ?awrr Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awrs Real)
                  (declare-const ?awrt Real)
                  (declare-const ?awru Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awrv Real)
                  (declare-const ?awrw Real)
                  (declare-const ?awrx Real)
                  (declare-const ?awry Real)
                  (assert
                    (and (and (not (= ?awrx ?awrw))
                        (not (= ?awrx ?awrv))
                        )
                      (not (= ?awrw ?awrv))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awrz Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awsa Real)
                  (declare-const ?awsb Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awsc Real)
                  (declare-const ?awsd Real)
                  (declare-const ?awse Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awsf Real)
                  (declare-const ?awsg Real)
                  (declare-const ?awsh Real)
                  (declare-const ?awsi Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awsj Real)
                  (declare-const ?awsk Real)
                  (declare-const ?awsl Real)
                  (declare-const ?awsm Real)
                  (declare-const ?awsn Real)
                  (assert
                    (and (and (not (= ?awsl ?awsk))
                        (not (= ?awsl ?awsj))
                        )
                      (not (= ?awsk ?awsj))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awso Real)
                  (declare-const ?awsp Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awsq Real)
                  (declare-const ?awsr Real)
                  (declare-const ?awss Real)
                  (assert
                    (and (and (not (= ?awss ?awsr))
                        (not (= ?awss ?awsq))
                        )
                      (not (= ?awsr ?awsq))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awst Real)
                  (declare-const ?awsu Real)
                  (declare-const ?awsv Real)
                  (declare-const ?awsw Real)
                  (assert
                    (and (and (not (= ?awsw ?awsv))
                        (not (= ?awsw ?awsu))
                        )
                      (not (= ?awsv ?awsu))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awsx Real)
                  (declare-const ?awsy Real)
                  (declare-const ?awsz Real)
                  (declare-const ?awta Real)
                  (declare-const ?awtb Real)
                  (assert
                    (and (and (not (= ?awtb ?awta))
                        (not (= ?awtb ?awsz))
                        )
                      (not (= ?awta ?awsz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awtc Real)
                  (declare-const ?awtd Real)
                  (declare-const ?awte Real)
                  (declare-const ?awtf Real)
                  (declare-const ?awtg Real)
                  (declare-const ?awth Real)
                  (assert
                    (and (and (and (not (= ?awte ?awtd))
                          (not (= ?awte ?awtc))
                          )
                        (not (= ?awtd ?awtc))
                        )
                      (and (and (not (= ?awth ?awtg))
                          (not (= ?awth ?awtf))
                          )
                        (not (= ?awtg ?awtf))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awti Real)
                  (declare-const ?awtj Real)
                  (declare-const ?awtk Real)
                  (assert
                    (and (and (not (= ?awtk ?awtj))
                        (not (= ?awtk ?awti))
                        )
                      (not (= ?awtj ?awti))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awtl Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awtm Real)
                  (declare-const ?awtn Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awto Real)
                  (declare-const ?awtp Real)
                  (declare-const ?awtq Real)
                  (assert
                    (and (and (not (= ?awtq ?awtp))
                        (not (= ?awtq ?awto))
                        )
                      (not (= ?awtp ?awto))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (assert
                    (or (or (= ?awqr ?awqq)
                        (= ?awqr ?awqs)
                        )
                      (= ?awqq ?awqs)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?awtr Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?awts Real)
            (declare-const ?awtt Real)
            (declare-const ?awtu Real)
            (declare-const ?awtv Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?awtw Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?awtx Real)
              (declare-const ?awty Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?awtz Real)
              (declare-const ?awua Real)
              (declare-const ?awub Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?awuc Real)
              (declare-const ?awud Real)
              (declare-const ?awue Real)
              (declare-const ?awuf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?awug Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?awuh Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?awui Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?awuj Real)
              (declare-const ?awuk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?awul Real)
              (declare-const ?awum Real)
              (declare-const ?awun Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?awuo Real)
              (declare-const ?awup Real)
              (declare-const ?awuq Real)
              (declare-const ?awur Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?awus Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (and (not (= ?awdj ?awdi))
              (forall ((?awrc Real) )(and (not (= ?awdj ?awrc))
                  (not (= ?awdi ?awrc))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (declare-const ?awut Real)
        (declare-const ?awuu Real)
        (declare-const ?awuv Real)
        (declare-const ?awuw Real)
        (declare-const ?awux Real)
        (declare-const ?awuy Real)
        (assert
          (and (or (or (= ?awuv ?awuu)
                (= ?awuv ?awut)
                )
              (= ?awuu ?awut)
              )
            (or (or (= ?awuy ?awux)
                (= ?awuy ?awuw)
                )
              (= ?awux ?awuw)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awuz Real)
        (declare-const ?awva Real)
        (declare-const ?awvb Real)
        (assert
          (and (and (not (= ?awvb ?awva))
              (not (= ?awvb ?awuz))
              )
            (not (= ?awva ?awuz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awvc Real)
        (declare-const ?awvd Real)
        (declare-const ?awve Real)
        (declare-const ?awvf Real)
        (assert
          (and (and (not (= ?awve ?awvd))
              (not (= ?awve ?awvc))
              )
            (not (= ?awvd ?awvc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awvg Real)
        (declare-const ?awvh Real)
        (declare-const ?awvi Real)
        (declare-const ?awvj Real)
        (declare-const ?awvk Real)
        (assert
          (and (and (not (= ?awvi ?awvh))
              (not (= ?awvi ?awvg))
              )
            (not (= ?awvh ?awvg))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awvl Real)
        (declare-const ?awvm Real)
        (declare-const ?awvn Real)
        (assert
          (and (and (not (= ?awvn ?awvm))
              (not (= ?awvn ?awvl))
              )
            (not (= ?awvm ?awvl))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awvo Real)
        (declare-const ?awvp Real)
        (declare-const ?awvq Real)
        (declare-const ?awvr Real)
        (assert
          (and (and (not (= ?awvr ?awvq))
              (not (= ?awvr ?awvp))
              )
            (not (= ?awvq ?awvp))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awvs Real)
        (declare-const ?awvt Real)
        (declare-const ?awvu Real)
        (declare-const ?awvv Real)
        (declare-const ?awvw Real)
        (assert
          (and (and (not (= ?awvw ?awvv))
              (not (= ?awvw ?awvu))
              )
            (not (= ?awvv ?awvu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awvx Real)
        (declare-const ?awvy Real)
        (declare-const ?awvz Real)
        (declare-const ?awwa Real)
        (declare-const ?awwb Real)
        (declare-const ?awwc Real)
        (assert
          (and (and (and (not (= ?awvz ?awvy))
                (not (= ?awvz ?awvx))
                )
              (not (= ?awvy ?awvx))
              )
            (and (and (not (= ?awwc ?awwb))
                (not (= ?awwc ?awwa))
                )
              (not (= ?awwb ?awwa))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awwd Real)
        (declare-const ?awwe Real)
        (declare-const ?awwf Real)
        (assert
          (and (and (not (= ?awwf ?awwe))
              (not (= ?awwf ?awwd))
              )
            (not (= ?awwe ?awwd))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awwg Real)
        (declare-const ?awwh Real)
        (declare-const ?awwi Real)
        (assert
          (and (and (not (= ?awwi ?awwh))
              (not (= ?awwi ?awwg))
              )
            (not (= ?awwh ?awwg))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?awwj Real)
          (push 1)
            (declare-const ?awwk Real)
            (declare-const ?awwl Real)
            (declare-const ?awwm Real)
            (push 1)
              (declare-const ?awwn Real)
              (push 1)
                (assert
                  (and (and (and (= ?awwl ?awdj)
                        (= ?awwk ?awdi)
                        )
                      (= ?awwm ?awwj)
                      )
                    (= ?awwn ?awwj)
                    )
                  )
                (push 1)
                  (declare-const ?awwo Real)
                  (declare-const ?awwp Real)
                  (declare-const ?awwq Real)
                  (declare-const ?awwr Real)
                  (declare-const ?awws Real)
                  (declare-const ?awwt Real)
                  (assert
                    (and (or (or (= ?awwq ?awwp)
                          (= ?awwq ?awwo)
                          )
                        (= ?awwp ?awwo)
                        )
                      (or (or (= ?awwt ?awws)
                          (= ?awwt ?awwr)
                          )
                        (= ?awws ?awwr)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awwu Real)
                  (declare-const ?awwv Real)
                  (declare-const ?awww Real)
                  (assert
                    (and (and (not (= ?awww ?awwv))
                        (not (= ?awww ?awwu))
                        )
                      (not (= ?awwv ?awwu))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awwx Real)
                  (declare-const ?awwy Real)
                  (declare-const ?awwz Real)
                  (declare-const ?awxa Real)
                  (assert
                    (and (and (not (= ?awwz ?awwy))
                        (not (= ?awwz ?awwx))
                        )
                      (not (= ?awwy ?awwx))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awxb Real)
                  (declare-const ?awxc Real)
                  (declare-const ?awxd Real)
                  (declare-const ?awxe Real)
                  (declare-const ?awxf Real)
                  (assert
                    (and (and (not (= ?awxd ?awxc))
                        (not (= ?awxd ?awxb))
                        )
                      (not (= ?awxc ?awxb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awxg Real)
                  (declare-const ?awxh Real)
                  (declare-const ?awxi Real)
                  (assert
                    (and (and (not (= ?awxi ?awxh))
                        (not (= ?awxi ?awxg))
                        )
                      (not (= ?awxh ?awxg))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awxj Real)
                  (declare-const ?awxk Real)
                  (declare-const ?awxl Real)
                  (declare-const ?awxm Real)
                  (assert
                    (and (and (not (= ?awxm ?awxl))
                        (not (= ?awxm ?awxk))
                        )
                      (not (= ?awxl ?awxk))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awxn Real)
                  (declare-const ?awxo Real)
                  (declare-const ?awxp Real)
                  (declare-const ?awxq Real)
                  (declare-const ?awxr Real)
                  (assert
                    (and (and (not (= ?awxr ?awxq))
                        (not (= ?awxr ?awxp))
                        )
                      (not (= ?awxq ?awxp))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awxs Real)
                  (declare-const ?awxt Real)
                  (declare-const ?awxu Real)
                  (declare-const ?awxv Real)
                  (declare-const ?awxw Real)
                  (declare-const ?awxx Real)
                  (assert
                    (and (and (and (not (= ?awxu ?awxt))
                          (not (= ?awxu ?awxs))
                          )
                        (not (= ?awxt ?awxs))
                        )
                      (and (and (not (= ?awxx ?awxw))
                          (not (= ?awxx ?awxv))
                          )
                        (not (= ?awxw ?awxv))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awxy Real)
                  (declare-const ?awxz Real)
                  (declare-const ?awya Real)
                  (assert
                    (and (and (not (= ?awya ?awxz))
                        (not (= ?awya ?awxy))
                        )
                      (not (= ?awxz ?awxy))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?awyb Real)
                  (declare-const ?awyc Real)
                  (declare-const ?awyd Real)
                  (assert
                    (and (and (not (= ?awyd ?awyc))
                        (not (= ?awyd ?awyb))
                        )
                      (not (= ?awyc ?awyb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (assert
                    (or (or (= ?awwl ?awwk)
                        (= ?awwl ?awwm)
                        )
                      (= ?awwk ?awwm)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (and (not (= ?awdj ?awdi))
              (forall ((?awwm Real) )(and (not (= ?awdj ?awwm))
                  (not (= ?awdi ?awwm))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?awye Real)
    (declare-const ?awyf Real)
    (declare-const ?awyg Real)
    (push 1)
      (push 1)
        (declare-const ?awyh Real)
        (declare-const ?awyi Real)
        (declare-const ?awyj Real)
        (declare-const ?awyk Real)
        (declare-const ?awyl Real)
        (declare-const ?awym Real)
        (assert
          (and (or (or (= ?awyj ?awyi)
                (= ?awyj ?awyh)
                )
              (= ?awyi ?awyh)
              )
            (or (or (= ?awym ?awyl)
                (= ?awym ?awyk)
                )
              (= ?awyl ?awyk)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awyn Real)
        (declare-const ?awyo Real)
        (declare-const ?awyp Real)
        (assert
          (and (and (not (= ?awyp ?awyo))
              (not (= ?awyp ?awyn))
              )
            (not (= ?awyo ?awyn))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awyq Real)
        (declare-const ?awyr Real)
        (declare-const ?awys Real)
        (declare-const ?awyt Real)
        (assert
          (and (and (not (= ?awys ?awyr))
              (not (= ?awys ?awyq))
              )
            (not (= ?awyr ?awyq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awyu Real)
        (declare-const ?awyv Real)
        (declare-const ?awyw Real)
        (declare-const ?awyx Real)
        (declare-const ?awyy Real)
        (assert
          (and (and (not (= ?awyw ?awyv))
              (not (= ?awyw ?awyu))
              )
            (not (= ?awyv ?awyu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awyz Real)
        (declare-const ?awza Real)
        (declare-const ?awzb Real)
        (assert
          (and (and (not (= ?awzb ?awza))
              (not (= ?awzb ?awyz))
              )
            (not (= ?awza ?awyz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awzc Real)
        (declare-const ?awzd Real)
        (declare-const ?awze Real)
        (declare-const ?awzf Real)
        (assert
          (and (and (not (= ?awzf ?awze))
              (not (= ?awzf ?awzd))
              )
            (not (= ?awze ?awzd))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awzg Real)
        (declare-const ?awzh Real)
        (declare-const ?awzi Real)
        (declare-const ?awzj Real)
        (declare-const ?awzk Real)
        (assert
          (and (and (not (= ?awzk ?awzj))
              (not (= ?awzk ?awzi))
              )
            (not (= ?awzj ?awzi))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awzl Real)
        (declare-const ?awzm Real)
        (declare-const ?awzn Real)
        (declare-const ?awzo Real)
        (declare-const ?awzp Real)
        (declare-const ?awzq Real)
        (assert
          (and (and (and (not (= ?awzn ?awzm))
                (not (= ?awzn ?awzl))
                )
              (not (= ?awzm ?awzl))
              )
            (and (and (not (= ?awzq ?awzp))
                (not (= ?awzq ?awzo))
                )
              (not (= ?awzp ?awzo))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awzr Real)
        (declare-const ?awzs Real)
        (declare-const ?awzt Real)
        (assert
          (and (and (not (= ?awzt ?awzs))
              (not (= ?awzt ?awzr))
              )
            (not (= ?awzs ?awzr))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?awzu Real)
        (declare-const ?awzv Real)
        (declare-const ?awzw Real)
        (assert
          (and (and (not (= ?awzw ?awzv))
              (not (= ?awzw ?awzu))
              )
            (not (= ?awzv ?awzu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?awyg ?awyf))
              (not (= ?awyg ?awye))
              )
            (not (= ?awyf ?awye))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?awzx Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?awzy Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?awzz Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axaa Real)
              (declare-const ?axab Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axac Real)
              (declare-const ?axad Real)
              (declare-const ?axae Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axaf Real)
              (declare-const ?axag Real)
              (declare-const ?axah Real)
              (declare-const ?axai Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axaj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?axak Real)
            (declare-const ?axal Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?axam Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axan Real)
              (declare-const ?axao Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axap Real)
              (declare-const ?axaq Real)
              (declare-const ?axar Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axas Real)
              (declare-const ?axat Real)
              (declare-const ?axau Real)
              (declare-const ?axav Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axaw Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?axax Real)
            (declare-const ?axay Real)
            (declare-const ?axaz Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?axba Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axbb Real)
              (declare-const ?axbc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axbd Real)
              (declare-const ?axbe Real)
              (declare-const ?axbf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axbg Real)
              (declare-const ?axbh Real)
              (declare-const ?axbi Real)
              (declare-const ?axbj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axbk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?axbl Real)
            (declare-const ?axbm Real)
            (declare-const ?axbn Real)
            (declare-const ?axbo Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?axbp Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (and (and (= ?axbn ?awyg)
                          (= ?axbm ?awyf)
                          )
                        (= ?axbl ?awye)
                        )
                      (= ?axbo ?awzx)
                      )
                    (= ?axbp ?awzx)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?axbq Real)
                  (declare-const ?axbr Real)
                  (declare-const ?axbs Real)
                  (declare-const ?axbt Real)
                  (declare-const ?axbu Real)
                  (declare-const ?axbv Real)
                  (assert
                    (and (or (or (= ?axbs ?axbr)
                          (= ?axbs ?axbq)
                          )
                        (= ?axbr ?axbq)
                        )
                      (or (or (= ?axbv ?axbu)
                          (= ?axbv ?axbt)
                          )
                        (= ?axbu ?axbt)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axbw Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axbx Real)
                  (declare-const ?axby Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axbz Real)
                  (declare-const ?axca Real)
                  (declare-const ?axcb Real)
                  (assert
                    (and (and (not (= ?axcb ?axca))
                        (not (= ?axcb ?axbz))
                        )
                      (not (= ?axca ?axbz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axcc Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axcd Real)
                  (declare-const ?axce Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axcf Real)
                  (declare-const ?axcg Real)
                  (declare-const ?axch Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axci Real)
                  (declare-const ?axcj Real)
                  (declare-const ?axck Real)
                  (declare-const ?axcl Real)
                  (assert
                    (and (and (not (= ?axck ?axcj))
                        (not (= ?axck ?axci))
                        )
                      (not (= ?axcj ?axci))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axcm Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axcn Real)
                  (declare-const ?axco Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axcp Real)
                  (declare-const ?axcq Real)
                  (declare-const ?axcr Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axcs Real)
                  (declare-const ?axct Real)
                  (declare-const ?axcu Real)
                  (declare-const ?axcv Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axcw Real)
                  (declare-const ?axcx Real)
                  (declare-const ?axcy Real)
                  (declare-const ?axcz Real)
                  (declare-const ?axda Real)
                  (assert
                    (and (and (not (= ?axcy ?axcx))
                        (not (= ?axcy ?axcw))
                        )
                      (not (= ?axcx ?axcw))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axdb Real)
                  (declare-const ?axdc Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axdd Real)
                  (declare-const ?axde Real)
                  (declare-const ?axdf Real)
                  (assert
                    (and (and (not (= ?axdf ?axde))
                        (not (= ?axdf ?axdd))
                        )
                      (not (= ?axde ?axdd))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axdg Real)
                  (declare-const ?axdh Real)
                  (declare-const ?axdi Real)
                  (declare-const ?axdj Real)
                  (assert
                    (and (and (not (= ?axdj ?axdi))
                        (not (= ?axdj ?axdh))
                        )
                      (not (= ?axdi ?axdh))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axdk Real)
                  (declare-const ?axdl Real)
                  (declare-const ?axdm Real)
                  (declare-const ?axdn Real)
                  (declare-const ?axdo Real)
                  (assert
                    (and (and (not (= ?axdo ?axdn))
                        (not (= ?axdo ?axdm))
                        )
                      (not (= ?axdn ?axdm))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axdp Real)
                  (declare-const ?axdq Real)
                  (declare-const ?axdr Real)
                  (declare-const ?axds Real)
                  (declare-const ?axdt Real)
                  (declare-const ?axdu Real)
                  (assert
                    (and (and (and (not (= ?axdr ?axdq))
                          (not (= ?axdr ?axdp))
                          )
                        (not (= ?axdq ?axdp))
                        )
                      (and (and (not (= ?axdu ?axdt))
                          (not (= ?axdu ?axds))
                          )
                        (not (= ?axdt ?axds))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axdv Real)
                  (declare-const ?axdw Real)
                  (declare-const ?axdx Real)
                  (assert
                    (and (and (not (= ?axdx ?axdw))
                        (not (= ?axdx ?axdv))
                        )
                      (not (= ?axdw ?axdv))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axdy Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axdz Real)
                  (declare-const ?axea Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axeb Real)
                  (declare-const ?axec Real)
                  (declare-const ?axed Real)
                  (assert
                    (and (and (not (= ?axed ?axec))
                        (not (= ?axed ?axeb))
                        )
                      (not (= ?axec ?axeb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?axee Real)
              (declare-const ?axef Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axeg Real)
              (declare-const ?axeh Real)
              (declare-const ?axei Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axej Real)
              (declare-const ?axek Real)
              (declare-const ?axel Real)
              (declare-const ?axem Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axen Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?axeo Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?axep Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axeq Real)
              (declare-const ?axer Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axes Real)
              (declare-const ?axet Real)
              (declare-const ?axeu Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axev Real)
              (declare-const ?axew Real)
              (declare-const ?axex Real)
              (declare-const ?axey Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axez Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?axfa Real)
      (push 1)
        (declare-const ?axfb Real)
        (declare-const ?axfc Real)
        (declare-const ?axfd Real)
        (declare-const ?axfe Real)
        (declare-const ?axff Real)
        (declare-const ?axfg Real)
        (assert
          (and (or (or (= ?axfd ?axfc)
                (= ?axfd ?axfb)
                )
              (= ?axfc ?axfb)
              )
            (or (or (= ?axfg ?axff)
                (= ?axfg ?axfe)
                )
              (= ?axff ?axfe)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axfh Real)
        (declare-const ?axfi Real)
        (declare-const ?axfj Real)
        (assert
          (and (and (not (= ?axfj ?axfi))
              (not (= ?axfj ?axfh))
              )
            (not (= ?axfi ?axfh))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axfk Real)
        (declare-const ?axfl Real)
        (declare-const ?axfm Real)
        (declare-const ?axfn Real)
        (assert
          (and (and (not (= ?axfm ?axfl))
              (not (= ?axfm ?axfk))
              )
            (not (= ?axfl ?axfk))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axfo Real)
        (declare-const ?axfp Real)
        (declare-const ?axfq Real)
        (declare-const ?axfr Real)
        (declare-const ?axfs Real)
        (assert
          (and (and (not (= ?axfq ?axfp))
              (not (= ?axfq ?axfo))
              )
            (not (= ?axfp ?axfo))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axft Real)
        (declare-const ?axfu Real)
        (declare-const ?axfv Real)
        (assert
          (and (and (not (= ?axfv ?axfu))
              (not (= ?axfv ?axft))
              )
            (not (= ?axfu ?axft))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axfw Real)
        (declare-const ?axfx Real)
        (declare-const ?axfy Real)
        (declare-const ?axfz Real)
        (assert
          (and (and (not (= ?axfz ?axfy))
              (not (= ?axfz ?axfx))
              )
            (not (= ?axfy ?axfx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axga Real)
        (declare-const ?axgb Real)
        (declare-const ?axgc Real)
        (declare-const ?axgd Real)
        (declare-const ?axge Real)
        (assert
          (and (and (not (= ?axge ?axgd))
              (not (= ?axge ?axgc))
              )
            (not (= ?axgd ?axgc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axgf Real)
        (declare-const ?axgg Real)
        (declare-const ?axgh Real)
        (declare-const ?axgi Real)
        (declare-const ?axgj Real)
        (declare-const ?axgk Real)
        (assert
          (and (and (and (not (= ?axgh ?axgg))
                (not (= ?axgh ?axgf))
                )
              (not (= ?axgg ?axgf))
              )
            (and (and (not (= ?axgk ?axgj))
                (not (= ?axgk ?axgi))
                )
              (not (= ?axgj ?axgi))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axgl Real)
        (declare-const ?axgm Real)
        (declare-const ?axgn Real)
        (assert
          (and (and (not (= ?axgn ?axgm))
              (not (= ?axgn ?axgl))
              )
            (not (= ?axgm ?axgl))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axgo Real)
        (declare-const ?axgp Real)
        (declare-const ?axgq Real)
        (assert
          (and (and (not (= ?axgq ?axgp))
              (not (= ?axgq ?axgo))
              )
            (not (= ?axgp ?axgo))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?awyg ?awyf))
              (not (= ?awyg ?awye))
              )
            (not (= ?awyf ?awye))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?axgr Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?axgs Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?axgt Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axgu Real)
              (declare-const ?axgv Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axgw Real)
              (declare-const ?axgx Real)
              (declare-const ?axgy Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axgz Real)
              (declare-const ?axha Real)
              (declare-const ?axhb Real)
              (declare-const ?axhc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axhd Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?axhe Real)
            (declare-const ?axhf Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?axhg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axhh Real)
              (declare-const ?axhi Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axhj Real)
              (declare-const ?axhk Real)
              (declare-const ?axhl Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axhm Real)
              (declare-const ?axhn Real)
              (declare-const ?axho Real)
              (declare-const ?axhp Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axhq Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?axhr Real)
            (declare-const ?axhs Real)
            (declare-const ?axht Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?axhu Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axhv Real)
              (declare-const ?axhw Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axhx Real)
              (declare-const ?axhy Real)
              (declare-const ?axhz Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axia Real)
              (declare-const ?axib Real)
              (declare-const ?axic Real)
              (declare-const ?axid Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axie Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?axif Real)
            (declare-const ?axig Real)
            (declare-const ?axih Real)
            (declare-const ?axii Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?axij Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axik Real)
              (declare-const ?axil Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (and (and (and (= ?axih ?awyg)
                            (= ?axig ?awyf)
                            )
                          (= ?axif ?awye)
                          )
                        (= ?axii ?axgr)
                        )
                      (= ?axik ?axfa)
                      )
                    (= ?axil ?axgr)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?axim Real)
                  (declare-const ?axin Real)
                  (declare-const ?axio Real)
                  (declare-const ?axip Real)
                  (declare-const ?axiq Real)
                  (declare-const ?axir Real)
                  (assert
                    (and (or (or (= ?axio ?axin)
                          (= ?axio ?axim)
                          )
                        (= ?axin ?axim)
                        )
                      (or (or (= ?axir ?axiq)
                          (= ?axir ?axip)
                          )
                        (= ?axiq ?axip)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axis Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axit Real)
                  (declare-const ?axiu Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axiv Real)
                  (declare-const ?axiw Real)
                  (declare-const ?axix Real)
                  (assert
                    (and (and (not (= ?axix ?axiw))
                        (not (= ?axix ?axiv))
                        )
                      (not (= ?axiw ?axiv))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axiy Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axiz Real)
                  (declare-const ?axja Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axjb Real)
                  (declare-const ?axjc Real)
                  (declare-const ?axjd Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axje Real)
                  (declare-const ?axjf Real)
                  (declare-const ?axjg Real)
                  (declare-const ?axjh Real)
                  (assert
                    (and (and (not (= ?axjg ?axjf))
                        (not (= ?axjg ?axje))
                        )
                      (not (= ?axjf ?axje))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axji Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axjj Real)
                  (declare-const ?axjk Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axjl Real)
                  (declare-const ?axjm Real)
                  (declare-const ?axjn Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axjo Real)
                  (declare-const ?axjp Real)
                  (declare-const ?axjq Real)
                  (declare-const ?axjr Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axjs Real)
                  (declare-const ?axjt Real)
                  (declare-const ?axju Real)
                  (declare-const ?axjv Real)
                  (declare-const ?axjw Real)
                  (assert
                    (and (and (not (= ?axju ?axjt))
                        (not (= ?axju ?axjs))
                        )
                      (not (= ?axjt ?axjs))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axjx Real)
                  (declare-const ?axjy Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axjz Real)
                  (declare-const ?axka Real)
                  (declare-const ?axkb Real)
                  (assert
                    (and (and (not (= ?axkb ?axka))
                        (not (= ?axkb ?axjz))
                        )
                      (not (= ?axka ?axjz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axkc Real)
                  (declare-const ?axkd Real)
                  (declare-const ?axke Real)
                  (declare-const ?axkf Real)
                  (assert
                    (and (and (not (= ?axkf ?axke))
                        (not (= ?axkf ?axkd))
                        )
                      (not (= ?axke ?axkd))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axkg Real)
                  (declare-const ?axkh Real)
                  (declare-const ?axki Real)
                  (declare-const ?axkj Real)
                  (declare-const ?axkk Real)
                  (assert
                    (and (and (not (= ?axkk ?axkj))
                        (not (= ?axkk ?axki))
                        )
                      (not (= ?axkj ?axki))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axkl Real)
                  (declare-const ?axkm Real)
                  (declare-const ?axkn Real)
                  (declare-const ?axko Real)
                  (declare-const ?axkp Real)
                  (declare-const ?axkq Real)
                  (assert
                    (and (and (and (not (= ?axkn ?axkm))
                          (not (= ?axkn ?axkl))
                          )
                        (not (= ?axkm ?axkl))
                        )
                      (and (and (not (= ?axkq ?axkp))
                          (not (= ?axkq ?axko))
                          )
                        (not (= ?axkp ?axko))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axkr Real)
                  (declare-const ?axks Real)
                  (declare-const ?axkt Real)
                  (assert
                    (and (and (not (= ?axkt ?axks))
                        (not (= ?axkt ?axkr))
                        )
                      (not (= ?axks ?axkr))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axku Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axkv Real)
                  (declare-const ?axkw Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axkx Real)
                  (declare-const ?axky Real)
                  (declare-const ?axkz Real)
                  (assert
                    (and (and (not (= ?axkz ?axky))
                        (not (= ?axkz ?axkx))
                        )
                      (not (= ?axky ?axkx))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?axla Real)
              (declare-const ?axlb Real)
              (declare-const ?axlc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axld Real)
              (declare-const ?axle Real)
              (declare-const ?axlf Real)
              (declare-const ?axlg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axlh Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?axli Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?axlj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axlk Real)
              (declare-const ?axll Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axlm Real)
              (declare-const ?axln Real)
              (declare-const ?axlo Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axlp Real)
              (declare-const ?axlq Real)
              (declare-const ?axlr Real)
              (declare-const ?axls Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axlt Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?axlu Real)
      (declare-const ?axlv Real)
      (push 1)
        (declare-const ?axlw Real)
        (declare-const ?axlx Real)
        (declare-const ?axly Real)
        (declare-const ?axlz Real)
        (declare-const ?axma Real)
        (declare-const ?axmb Real)
        (assert
          (and (or (or (= ?axly ?axlx)
                (= ?axly ?axlw)
                )
              (= ?axlx ?axlw)
              )
            (or (or (= ?axmb ?axma)
                (= ?axmb ?axlz)
                )
              (= ?axma ?axlz)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axmc Real)
        (declare-const ?axmd Real)
        (declare-const ?axme Real)
        (assert
          (and (and (not (= ?axme ?axmd))
              (not (= ?axme ?axmc))
              )
            (not (= ?axmd ?axmc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axmf Real)
        (declare-const ?axmg Real)
        (declare-const ?axmh Real)
        (declare-const ?axmi Real)
        (assert
          (and (and (not (= ?axmh ?axmg))
              (not (= ?axmh ?axmf))
              )
            (not (= ?axmg ?axmf))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axmj Real)
        (declare-const ?axmk Real)
        (declare-const ?axml Real)
        (declare-const ?axmm Real)
        (declare-const ?axmn Real)
        (assert
          (and (and (not (= ?axml ?axmk))
              (not (= ?axml ?axmj))
              )
            (not (= ?axmk ?axmj))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axmo Real)
        (declare-const ?axmp Real)
        (declare-const ?axmq Real)
        (assert
          (and (and (not (= ?axmq ?axmp))
              (not (= ?axmq ?axmo))
              )
            (not (= ?axmp ?axmo))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axmr Real)
        (declare-const ?axms Real)
        (declare-const ?axmt Real)
        (declare-const ?axmu Real)
        (assert
          (and (and (not (= ?axmu ?axmt))
              (not (= ?axmu ?axms))
              )
            (not (= ?axmt ?axms))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axmv Real)
        (declare-const ?axmw Real)
        (declare-const ?axmx Real)
        (declare-const ?axmy Real)
        (declare-const ?axmz Real)
        (assert
          (and (and (not (= ?axmz ?axmy))
              (not (= ?axmz ?axmx))
              )
            (not (= ?axmy ?axmx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axna Real)
        (declare-const ?axnb Real)
        (declare-const ?axnc Real)
        (declare-const ?axnd Real)
        (declare-const ?axne Real)
        (declare-const ?axnf Real)
        (assert
          (and (and (and (not (= ?axnc ?axnb))
                (not (= ?axnc ?axna))
                )
              (not (= ?axnb ?axna))
              )
            (and (and (not (= ?axnf ?axne))
                (not (= ?axnf ?axnd))
                )
              (not (= ?axne ?axnd))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axng Real)
        (declare-const ?axnh Real)
        (declare-const ?axni Real)
        (assert
          (and (and (not (= ?axni ?axnh))
              (not (= ?axni ?axng))
              )
            (not (= ?axnh ?axng))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axnj Real)
        (declare-const ?axnk Real)
        (declare-const ?axnl Real)
        (assert
          (and (and (not (= ?axnl ?axnk))
              (not (= ?axnl ?axnj))
              )
            (not (= ?axnk ?axnj))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?awyg ?awyf))
              (not (= ?awyg ?awye))
              )
            (not (= ?awyf ?awye))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?axnm Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?axnn Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?axno Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axnp Real)
              (declare-const ?axnq Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axnr Real)
              (declare-const ?axns Real)
              (declare-const ?axnt Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axnu Real)
              (declare-const ?axnv Real)
              (declare-const ?axnw Real)
              (declare-const ?axnx Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axny Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?axnz Real)
            (declare-const ?axoa Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?axob Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axoc Real)
              (declare-const ?axod Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axoe Real)
              (declare-const ?axof Real)
              (declare-const ?axog Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axoh Real)
              (declare-const ?axoi Real)
              (declare-const ?axoj Real)
              (declare-const ?axok Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axol Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?axom Real)
            (declare-const ?axon Real)
            (declare-const ?axoo Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?axop Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axoq Real)
              (declare-const ?axor Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axos Real)
              (declare-const ?axot Real)
              (declare-const ?axou Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axov Real)
              (declare-const ?axow Real)
              (declare-const ?axox Real)
              (declare-const ?axoy Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axoz Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?axpa Real)
            (declare-const ?axpb Real)
            (declare-const ?axpc Real)
            (declare-const ?axpd Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?axpe Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axpf Real)
              (declare-const ?axpg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axph Real)
              (declare-const ?axpi Real)
              (declare-const ?axpj Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (and (and (and (= ?axpc ?awyg)
                            (= ?axpb ?awyf)
                            )
                          (= ?axpa ?awye)
                          )
                        (= ?axpd ?axnm)
                        )
                      (and (= ?axpi ?axlv)
                        (= ?axph ?axlu)
                        )
                      )
                    (= ?axpj ?axnm)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?axpk Real)
                  (declare-const ?axpl Real)
                  (declare-const ?axpm Real)
                  (declare-const ?axpn Real)
                  (declare-const ?axpo Real)
                  (declare-const ?axpp Real)
                  (assert
                    (and (or (or (= ?axpm ?axpl)
                          (= ?axpm ?axpk)
                          )
                        (= ?axpl ?axpk)
                        )
                      (or (or (= ?axpp ?axpo)
                          (= ?axpp ?axpn)
                          )
                        (= ?axpo ?axpn)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axpq Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axpr Real)
                  (declare-const ?axps Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axpt Real)
                  (declare-const ?axpu Real)
                  (declare-const ?axpv Real)
                  (assert
                    (and (and (not (= ?axpv ?axpu))
                        (not (= ?axpv ?axpt))
                        )
                      (not (= ?axpu ?axpt))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axpw Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axpx Real)
                  (declare-const ?axpy Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axpz Real)
                  (declare-const ?axqa Real)
                  (declare-const ?axqb Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axqc Real)
                  (declare-const ?axqd Real)
                  (declare-const ?axqe Real)
                  (declare-const ?axqf Real)
                  (assert
                    (and (and (not (= ?axqe ?axqd))
                        (not (= ?axqe ?axqc))
                        )
                      (not (= ?axqd ?axqc))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axqg Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axqh Real)
                  (declare-const ?axqi Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axqj Real)
                  (declare-const ?axqk Real)
                  (declare-const ?axql Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axqm Real)
                  (declare-const ?axqn Real)
                  (declare-const ?axqo Real)
                  (declare-const ?axqp Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axqq Real)
                  (declare-const ?axqr Real)
                  (declare-const ?axqs Real)
                  (declare-const ?axqt Real)
                  (declare-const ?axqu Real)
                  (assert
                    (and (and (not (= ?axqs ?axqr))
                        (not (= ?axqs ?axqq))
                        )
                      (not (= ?axqr ?axqq))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axqv Real)
                  (declare-const ?axqw Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axqx Real)
                  (declare-const ?axqy Real)
                  (declare-const ?axqz Real)
                  (assert
                    (and (and (not (= ?axqz ?axqy))
                        (not (= ?axqz ?axqx))
                        )
                      (not (= ?axqy ?axqx))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axra Real)
                  (declare-const ?axrb Real)
                  (declare-const ?axrc Real)
                  (declare-const ?axrd Real)
                  (assert
                    (and (and (not (= ?axrd ?axrc))
                        (not (= ?axrd ?axrb))
                        )
                      (not (= ?axrc ?axrb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axre Real)
                  (declare-const ?axrf Real)
                  (declare-const ?axrg Real)
                  (declare-const ?axrh Real)
                  (declare-const ?axri Real)
                  (assert
                    (and (and (not (= ?axri ?axrh))
                        (not (= ?axri ?axrg))
                        )
                      (not (= ?axrh ?axrg))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axrj Real)
                  (declare-const ?axrk Real)
                  (declare-const ?axrl Real)
                  (declare-const ?axrm Real)
                  (declare-const ?axrn Real)
                  (declare-const ?axro Real)
                  (assert
                    (and (and (and (not (= ?axrl ?axrk))
                          (not (= ?axrl ?axrj))
                          )
                        (not (= ?axrk ?axrj))
                        )
                      (and (and (not (= ?axro ?axrn))
                          (not (= ?axro ?axrm))
                          )
                        (not (= ?axrn ?axrm))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axrp Real)
                  (declare-const ?axrq Real)
                  (declare-const ?axrr Real)
                  (assert
                    (and (and (not (= ?axrr ?axrq))
                        (not (= ?axrr ?axrp))
                        )
                      (not (= ?axrq ?axrp))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axrs Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axrt Real)
                  (declare-const ?axru Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axrv Real)
                  (declare-const ?axrw Real)
                  (declare-const ?axrx Real)
                  (assert
                    (and (and (not (= ?axrx ?axrw))
                        (not (= ?axrx ?axrv))
                        )
                      (not (= ?axrw ?axrv))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (assert
                    (or (or (= ?axpi ?axph)
                        (= ?axpi ?axpj)
                        )
                      (= ?axph ?axpj)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?axry Real)
              (declare-const ?axrz Real)
              (declare-const ?axsa Real)
              (declare-const ?axsb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axsc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?axsd Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?axse Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axsf Real)
              (declare-const ?axsg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axsh Real)
              (declare-const ?axsi Real)
              (declare-const ?axsj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axsk Real)
              (declare-const ?axsl Real)
              (declare-const ?axsm Real)
              (declare-const ?axsn Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axso Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (and (not (= ?axlv ?axlu))
              (forall ((?axpj Real) )(and (not (= ?axlv ?axpj))
                  (not (= ?axlu ?axpj))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?axsp Real)
      (declare-const ?axsq Real)
      (declare-const ?axsr Real)
      (push 1)
        (declare-const ?axss Real)
        (declare-const ?axst Real)
        (declare-const ?axsu Real)
        (declare-const ?axsv Real)
        (declare-const ?axsw Real)
        (declare-const ?axsx Real)
        (assert
          (and (or (or (= ?axsu ?axst)
                (= ?axsu ?axss)
                )
              (= ?axst ?axss)
              )
            (or (or (= ?axsx ?axsw)
                (= ?axsx ?axsv)
                )
              (= ?axsw ?axsv)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axsy Real)
        (declare-const ?axsz Real)
        (declare-const ?axta Real)
        (assert
          (and (and (not (= ?axta ?axsz))
              (not (= ?axta ?axsy))
              )
            (not (= ?axsz ?axsy))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axtb Real)
        (declare-const ?axtc Real)
        (declare-const ?axtd Real)
        (declare-const ?axte Real)
        (assert
          (and (and (not (= ?axtd ?axtc))
              (not (= ?axtd ?axtb))
              )
            (not (= ?axtc ?axtb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axtf Real)
        (declare-const ?axtg Real)
        (declare-const ?axth Real)
        (declare-const ?axti Real)
        (declare-const ?axtj Real)
        (assert
          (and (and (not (= ?axth ?axtg))
              (not (= ?axth ?axtf))
              )
            (not (= ?axtg ?axtf))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axtk Real)
        (declare-const ?axtl Real)
        (declare-const ?axtm Real)
        (assert
          (and (and (not (= ?axtm ?axtl))
              (not (= ?axtm ?axtk))
              )
            (not (= ?axtl ?axtk))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axtn Real)
        (declare-const ?axto Real)
        (declare-const ?axtp Real)
        (declare-const ?axtq Real)
        (assert
          (and (and (not (= ?axtq ?axtp))
              (not (= ?axtq ?axto))
              )
            (not (= ?axtp ?axto))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axtr Real)
        (declare-const ?axts Real)
        (declare-const ?axtt Real)
        (declare-const ?axtu Real)
        (declare-const ?axtv Real)
        (assert
          (and (and (not (= ?axtv ?axtu))
              (not (= ?axtv ?axtt))
              )
            (not (= ?axtu ?axtt))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axtw Real)
        (declare-const ?axtx Real)
        (declare-const ?axty Real)
        (declare-const ?axtz Real)
        (declare-const ?axua Real)
        (declare-const ?axub Real)
        (assert
          (and (and (and (not (= ?axty ?axtx))
                (not (= ?axty ?axtw))
                )
              (not (= ?axtx ?axtw))
              )
            (and (and (not (= ?axub ?axua))
                (not (= ?axub ?axtz))
                )
              (not (= ?axua ?axtz))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axuc Real)
        (declare-const ?axud Real)
        (declare-const ?axue Real)
        (assert
          (and (and (not (= ?axue ?axud))
              (not (= ?axue ?axuc))
              )
            (not (= ?axud ?axuc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axuf Real)
        (declare-const ?axug Real)
        (declare-const ?axuh Real)
        (assert
          (and (and (not (= ?axuh ?axug))
              (not (= ?axuh ?axuf))
              )
            (not (= ?axug ?axuf))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (or (and (or (or (= ?axsr ?axsq)
                  (= ?axsr ?axsp)
                  )
                (= ?axsq ?axsp)
                )
              (or (or (= ?awyg ?awyf)
                  (= ?awyg ?awye)
                  )
                (= ?awyf ?awye)
                )
              )
            (and (and (and (not (= ?axsr ?axsq))
                  (not (= ?axsr ?axsp))
                  )
                (not (= ?axsq ?axsp))
                )
              (and (and (not (= ?awyg ?awyf))
                  (not (= ?awyg ?awye))
                  )
                (not (= ?awyf ?awye))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?axui Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?axuj Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?axuk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axul Real)
              (declare-const ?axum Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axun Real)
              (declare-const ?axuo Real)
              (declare-const ?axup Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axuq Real)
              (declare-const ?axur Real)
              (declare-const ?axus Real)
              (declare-const ?axut Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axuu Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?axuv Real)
            (declare-const ?axuw Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?axux Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axuy Real)
              (declare-const ?axuz Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axva Real)
              (declare-const ?axvb Real)
              (declare-const ?axvc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axvd Real)
              (declare-const ?axve Real)
              (declare-const ?axvf Real)
              (declare-const ?axvg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axvh Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?axvi Real)
            (declare-const ?axvj Real)
            (declare-const ?axvk Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?axvl Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axvm Real)
              (declare-const ?axvn Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axvo Real)
              (declare-const ?axvp Real)
              (declare-const ?axvq Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axvr Real)
              (declare-const ?axvs Real)
              (declare-const ?axvt Real)
              (declare-const ?axvu Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axvv Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?axvw Real)
            (declare-const ?axvx Real)
            (declare-const ?axvy Real)
            (declare-const ?axvz Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?axwa Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axwb Real)
              (declare-const ?axwc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axwd Real)
              (declare-const ?axwe Real)
              (declare-const ?axwf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axwg Real)
              (declare-const ?axwh Real)
              (declare-const ?axwi Real)
              (declare-const ?axwj Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (and (and (and (= ?axvy ?awyg)
                            (= ?axvx ?awyf)
                            )
                          (= ?axvw ?awye)
                          )
                        (= ?axvz ?axui)
                        )
                      (and (and (= ?axwi ?axsr)
                          (= ?axwh ?axsq)
                          )
                        (= ?axwg ?axsp)
                        )
                      )
                    (= ?axwj ?axui)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?axwk Real)
                  (declare-const ?axwl Real)
                  (declare-const ?axwm Real)
                  (declare-const ?axwn Real)
                  (declare-const ?axwo Real)
                  (declare-const ?axwp Real)
                  (assert
                    (and (or (or (= ?axwm ?axwl)
                          (= ?axwm ?axwk)
                          )
                        (= ?axwl ?axwk)
                        )
                      (or (or (= ?axwp ?axwo)
                          (= ?axwp ?axwn)
                          )
                        (= ?axwo ?axwn)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axwq Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axwr Real)
                  (declare-const ?axws Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axwt Real)
                  (declare-const ?axwu Real)
                  (declare-const ?axwv Real)
                  (assert
                    (and (and (not (= ?axwv ?axwu))
                        (not (= ?axwv ?axwt))
                        )
                      (not (= ?axwu ?axwt))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axww Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axwx Real)
                  (declare-const ?axwy Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axwz Real)
                  (declare-const ?axxa Real)
                  (declare-const ?axxb Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axxc Real)
                  (declare-const ?axxd Real)
                  (declare-const ?axxe Real)
                  (declare-const ?axxf Real)
                  (assert
                    (and (and (not (= ?axxe ?axxd))
                        (not (= ?axxe ?axxc))
                        )
                      (not (= ?axxd ?axxc))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axxg Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axxh Real)
                  (declare-const ?axxi Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axxj Real)
                  (declare-const ?axxk Real)
                  (declare-const ?axxl Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axxm Real)
                  (declare-const ?axxn Real)
                  (declare-const ?axxo Real)
                  (declare-const ?axxp Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axxq Real)
                  (declare-const ?axxr Real)
                  (declare-const ?axxs Real)
                  (declare-const ?axxt Real)
                  (declare-const ?axxu Real)
                  (assert
                    (and (and (not (= ?axxs ?axxr))
                        (not (= ?axxs ?axxq))
                        )
                      (not (= ?axxr ?axxq))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axxv Real)
                  (declare-const ?axxw Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axxx Real)
                  (declare-const ?axxy Real)
                  (declare-const ?axxz Real)
                  (assert
                    (and (and (not (= ?axxz ?axxy))
                        (not (= ?axxz ?axxx))
                        )
                      (not (= ?axxy ?axxx))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axya Real)
                  (declare-const ?axyb Real)
                  (declare-const ?axyc Real)
                  (declare-const ?axyd Real)
                  (assert
                    (and (and (not (= ?axyd ?axyc))
                        (not (= ?axyd ?axyb))
                        )
                      (not (= ?axyc ?axyb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axye Real)
                  (declare-const ?axyf Real)
                  (declare-const ?axyg Real)
                  (declare-const ?axyh Real)
                  (declare-const ?axyi Real)
                  (assert
                    (and (and (not (= ?axyi ?axyh))
                        (not (= ?axyi ?axyg))
                        )
                      (not (= ?axyh ?axyg))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axyj Real)
                  (declare-const ?axyk Real)
                  (declare-const ?axyl Real)
                  (declare-const ?axym Real)
                  (declare-const ?axyn Real)
                  (declare-const ?axyo Real)
                  (assert
                    (and (and (and (not (= ?axyl ?axyk))
                          (not (= ?axyl ?axyj))
                          )
                        (not (= ?axyk ?axyj))
                        )
                      (and (and (not (= ?axyo ?axyn))
                          (not (= ?axyo ?axym))
                          )
                        (not (= ?axyn ?axym))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axyp Real)
                  (declare-const ?axyq Real)
                  (declare-const ?axyr Real)
                  (assert
                    (and (and (not (= ?axyr ?axyq))
                        (not (= ?axyr ?axyp))
                        )
                      (not (= ?axyq ?axyp))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axys Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axyt Real)
                  (declare-const ?axyu Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?axyv Real)
                  (declare-const ?axyw Real)
                  (declare-const ?axyx Real)
                  (assert
                    (and (and (not (= ?axyx ?axyw))
                        (not (= ?axyx ?axyv))
                        )
                      (not (= ?axyw ?axyv))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?axyy Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?axyz Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?axza Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axzb Real)
              (declare-const ?axzc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axzd Real)
              (declare-const ?axze Real)
              (declare-const ?axzf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axzg Real)
              (declare-const ?axzh Real)
              (declare-const ?axzi Real)
              (declare-const ?axzj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?axzk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (declare-const ?axzl Real)
        (declare-const ?axzm Real)
        (declare-const ?axzn Real)
        (declare-const ?axzo Real)
        (declare-const ?axzp Real)
        (declare-const ?axzq Real)
        (assert
          (and (or (or (= ?axzn ?axzm)
                (= ?axzn ?axzl)
                )
              (= ?axzm ?axzl)
              )
            (or (or (= ?axzq ?axzp)
                (= ?axzq ?axzo)
                )
              (= ?axzp ?axzo)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axzr Real)
        (declare-const ?axzs Real)
        (declare-const ?axzt Real)
        (assert
          (and (and (not (= ?axzt ?axzs))
              (not (= ?axzt ?axzr))
              )
            (not (= ?axzs ?axzr))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axzu Real)
        (declare-const ?axzv Real)
        (declare-const ?axzw Real)
        (declare-const ?axzx Real)
        (assert
          (and (and (not (= ?axzw ?axzv))
              (not (= ?axzw ?axzu))
              )
            (not (= ?axzv ?axzu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?axzy Real)
        (declare-const ?axzz Real)
        (declare-const ?ayaa Real)
        (declare-const ?ayab Real)
        (declare-const ?ayac Real)
        (assert
          (and (and (not (= ?ayaa ?axzz))
              (not (= ?ayaa ?axzy))
              )
            (not (= ?axzz ?axzy))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayad Real)
        (declare-const ?ayae Real)
        (declare-const ?ayaf Real)
        (assert
          (and (and (not (= ?ayaf ?ayae))
              (not (= ?ayaf ?ayad))
              )
            (not (= ?ayae ?ayad))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayag Real)
        (declare-const ?ayah Real)
        (declare-const ?ayai Real)
        (declare-const ?ayaj Real)
        (assert
          (and (and (not (= ?ayaj ?ayai))
              (not (= ?ayaj ?ayah))
              )
            (not (= ?ayai ?ayah))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayak Real)
        (declare-const ?ayal Real)
        (declare-const ?ayam Real)
        (declare-const ?ayan Real)
        (declare-const ?ayao Real)
        (assert
          (and (and (not (= ?ayao ?ayan))
              (not (= ?ayao ?ayam))
              )
            (not (= ?ayan ?ayam))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayap Real)
        (declare-const ?ayaq Real)
        (declare-const ?ayar Real)
        (declare-const ?ayas Real)
        (declare-const ?ayat Real)
        (declare-const ?ayau Real)
        (assert
          (and (and (and (not (= ?ayar ?ayaq))
                (not (= ?ayar ?ayap))
                )
              (not (= ?ayaq ?ayap))
              )
            (and (and (not (= ?ayau ?ayat))
                (not (= ?ayau ?ayas))
                )
              (not (= ?ayat ?ayas))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayav Real)
        (declare-const ?ayaw Real)
        (declare-const ?ayax Real)
        (assert
          (and (and (not (= ?ayax ?ayaw))
              (not (= ?ayax ?ayav))
              )
            (not (= ?ayaw ?ayav))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayay Real)
        (declare-const ?ayaz Real)
        (declare-const ?ayba Real)
        (assert
          (and (and (not (= ?ayba ?ayaz))
              (not (= ?ayba ?ayay))
              )
            (not (= ?ayaz ?ayay))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?awyg ?awyf))
              (not (= ?awyg ?awye))
              )
            (not (= ?awyf ?awye))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?aybb Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?aybc Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?aybd Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aybe Real)
              (declare-const ?aybf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aybg Real)
              (declare-const ?aybh Real)
              (declare-const ?aybi Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aybj Real)
              (declare-const ?aybk Real)
              (declare-const ?aybl Real)
              (declare-const ?aybm Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aybn Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?aybo Real)
            (declare-const ?aybp Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?aybq Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aybr Real)
              (declare-const ?aybs Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aybt Real)
              (declare-const ?aybu Real)
              (declare-const ?aybv Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aybw Real)
              (declare-const ?aybx Real)
              (declare-const ?ayby Real)
              (declare-const ?aybz Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?ayca Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?aycb Real)
            (declare-const ?aycc Real)
            (declare-const ?aycd Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?ayce Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aycf Real)
              (declare-const ?aycg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aych Real)
              (declare-const ?ayci Real)
              (declare-const ?aycj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?ayck Real)
              (declare-const ?aycl Real)
              (declare-const ?aycm Real)
              (declare-const ?aycn Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?ayco Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?aycp Real)
            (declare-const ?aycq Real)
            (declare-const ?aycr Real)
            (declare-const ?aycs Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?ayct Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aycu Real)
              (declare-const ?aycv Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aycw Real)
              (declare-const ?aycx Real)
              (declare-const ?aycy Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aycz Real)
              (declare-const ?ayda Real)
              (declare-const ?aydb Real)
              (declare-const ?aydc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aydd Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (and (and (= ?aycr ?awyg)
                          (= ?aycq ?awyf)
                          )
                        (= ?aycp ?awye)
                        )
                      (= ?aycs ?aybb)
                      )
                    (= ?aydd ?aybb)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?ayde Real)
                  (declare-const ?aydf Real)
                  (declare-const ?aydg Real)
                  (declare-const ?aydh Real)
                  (declare-const ?aydi Real)
                  (declare-const ?aydj Real)
                  (assert
                    (and (or (or (= ?aydg ?aydf)
                          (= ?aydg ?ayde)
                          )
                        (= ?aydf ?ayde)
                        )
                      (or (or (= ?aydj ?aydi)
                          (= ?aydj ?aydh)
                          )
                        (= ?aydi ?aydh)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aydk Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aydl Real)
                  (declare-const ?aydm Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aydn Real)
                  (declare-const ?aydo Real)
                  (declare-const ?aydp Real)
                  (assert
                    (and (and (not (= ?aydp ?aydo))
                        (not (= ?aydp ?aydn))
                        )
                      (not (= ?aydo ?aydn))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aydq Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aydr Real)
                  (declare-const ?ayds Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aydt Real)
                  (declare-const ?aydu Real)
                  (declare-const ?aydv Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aydw Real)
                  (declare-const ?aydx Real)
                  (declare-const ?aydy Real)
                  (declare-const ?aydz Real)
                  (assert
                    (and (and (not (= ?aydy ?aydx))
                        (not (= ?aydy ?aydw))
                        )
                      (not (= ?aydx ?aydw))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayea Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayeb Real)
                  (declare-const ?ayec Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayed Real)
                  (declare-const ?ayee Real)
                  (declare-const ?ayef Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayeg Real)
                  (declare-const ?ayeh Real)
                  (declare-const ?ayei Real)
                  (declare-const ?ayej Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayek Real)
                  (declare-const ?ayel Real)
                  (declare-const ?ayem Real)
                  (declare-const ?ayen Real)
                  (declare-const ?ayeo Real)
                  (assert
                    (and (and (not (= ?ayem ?ayel))
                        (not (= ?ayem ?ayek))
                        )
                      (not (= ?ayel ?ayek))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayep Real)
                  (declare-const ?ayeq Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayer Real)
                  (declare-const ?ayes Real)
                  (declare-const ?ayet Real)
                  (assert
                    (and (and (not (= ?ayet ?ayes))
                        (not (= ?ayet ?ayer))
                        )
                      (not (= ?ayes ?ayer))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayeu Real)
                  (declare-const ?ayev Real)
                  (declare-const ?ayew Real)
                  (declare-const ?ayex Real)
                  (assert
                    (and (and (not (= ?ayex ?ayew))
                        (not (= ?ayex ?ayev))
                        )
                      (not (= ?ayew ?ayev))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayey Real)
                  (declare-const ?ayez Real)
                  (declare-const ?ayfa Real)
                  (declare-const ?ayfb Real)
                  (declare-const ?ayfc Real)
                  (assert
                    (and (and (not (= ?ayfc ?ayfb))
                        (not (= ?ayfc ?ayfa))
                        )
                      (not (= ?ayfb ?ayfa))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayfd Real)
                  (declare-const ?ayfe Real)
                  (declare-const ?ayff Real)
                  (declare-const ?ayfg Real)
                  (declare-const ?ayfh Real)
                  (declare-const ?ayfi Real)
                  (assert
                    (and (and (and (not (= ?ayff ?ayfe))
                          (not (= ?ayff ?ayfd))
                          )
                        (not (= ?ayfe ?ayfd))
                        )
                      (and (and (not (= ?ayfi ?ayfh))
                          (not (= ?ayfi ?ayfg))
                          )
                        (not (= ?ayfh ?ayfg))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayfj Real)
                  (declare-const ?ayfk Real)
                  (declare-const ?ayfl Real)
                  (assert
                    (and (and (not (= ?ayfl ?ayfk))
                        (not (= ?ayfl ?ayfj))
                        )
                      (not (= ?ayfk ?ayfj))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayfm Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayfn Real)
                  (declare-const ?ayfo Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayfp Real)
                  (declare-const ?ayfq Real)
                  (declare-const ?ayfr Real)
                  (assert
                    (and (and (not (= ?ayfr ?ayfq))
                        (not (= ?ayfr ?ayfp))
                        )
                      (not (= ?ayfq ?ayfp))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?ayfs Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?ayft Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?ayfu Real)
              (declare-const ?ayfv Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?ayfw Real)
              (declare-const ?ayfx Real)
              (declare-const ?ayfy Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?ayfz Real)
              (declare-const ?ayga Real)
              (declare-const ?aygb Real)
              (declare-const ?aygc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aygd Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (push 1)
        (declare-const ?ayge Real)
        (declare-const ?aygf Real)
        (declare-const ?aygg Real)
        (declare-const ?aygh Real)
        (declare-const ?aygi Real)
        (declare-const ?aygj Real)
        (assert
          (and (or (or (= ?aygg ?aygf)
                (= ?aygg ?ayge)
                )
              (= ?aygf ?ayge)
              )
            (or (or (= ?aygj ?aygi)
                (= ?aygj ?aygh)
                )
              (= ?aygi ?aygh)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aygk Real)
        (declare-const ?aygl Real)
        (declare-const ?aygm Real)
        (assert
          (and (and (not (= ?aygm ?aygl))
              (not (= ?aygm ?aygk))
              )
            (not (= ?aygl ?aygk))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aygn Real)
        (declare-const ?aygo Real)
        (declare-const ?aygp Real)
        (declare-const ?aygq Real)
        (assert
          (and (and (not (= ?aygp ?aygo))
              (not (= ?aygp ?aygn))
              )
            (not (= ?aygo ?aygn))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aygr Real)
        (declare-const ?aygs Real)
        (declare-const ?aygt Real)
        (declare-const ?aygu Real)
        (declare-const ?aygv Real)
        (assert
          (and (and (not (= ?aygt ?aygs))
              (not (= ?aygt ?aygr))
              )
            (not (= ?aygs ?aygr))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aygw Real)
        (declare-const ?aygx Real)
        (declare-const ?aygy Real)
        (assert
          (and (and (not (= ?aygy ?aygx))
              (not (= ?aygy ?aygw))
              )
            (not (= ?aygx ?aygw))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aygz Real)
        (declare-const ?ayha Real)
        (declare-const ?ayhb Real)
        (declare-const ?ayhc Real)
        (assert
          (and (and (not (= ?ayhc ?ayhb))
              (not (= ?ayhc ?ayha))
              )
            (not (= ?ayhb ?ayha))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayhd Real)
        (declare-const ?ayhe Real)
        (declare-const ?ayhf Real)
        (declare-const ?ayhg Real)
        (declare-const ?ayhh Real)
        (assert
          (and (and (not (= ?ayhh ?ayhg))
              (not (= ?ayhh ?ayhf))
              )
            (not (= ?ayhg ?ayhf))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayhi Real)
        (declare-const ?ayhj Real)
        (declare-const ?ayhk Real)
        (declare-const ?ayhl Real)
        (declare-const ?ayhm Real)
        (declare-const ?ayhn Real)
        (assert
          (and (and (and (not (= ?ayhk ?ayhj))
                (not (= ?ayhk ?ayhi))
                )
              (not (= ?ayhj ?ayhi))
              )
            (and (and (not (= ?ayhn ?ayhm))
                (not (= ?ayhn ?ayhl))
                )
              (not (= ?ayhm ?ayhl))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayho Real)
        (declare-const ?ayhp Real)
        (declare-const ?ayhq Real)
        (assert
          (and (and (not (= ?ayhq ?ayhp))
              (not (= ?ayhq ?ayho))
              )
            (not (= ?ayhp ?ayho))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayhr Real)
        (declare-const ?ayhs Real)
        (declare-const ?ayht Real)
        (assert
          (and (and (not (= ?ayht ?ayhs))
              (not (= ?ayht ?ayhr))
              )
            (not (= ?ayhs ?ayhr))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?ayhu Real)
          (push 1)
            (declare-const ?ayhv Real)
            (push 1)
              (declare-const ?ayhw Real)
              (push 1)
                (assert
                  (and (= ?ayhv ?ayhu)
                    (= ?ayhw ?ayhu)
                    )
                  )
                (push 1)
                  (declare-const ?ayhx Real)
                  (declare-const ?ayhy Real)
                  (declare-const ?ayhz Real)
                  (declare-const ?ayia Real)
                  (declare-const ?ayib Real)
                  (declare-const ?ayic Real)
                  (assert
                    (and (or (or (= ?ayhz ?ayhy)
                          (= ?ayhz ?ayhx)
                          )
                        (= ?ayhy ?ayhx)
                        )
                      (or (or (= ?ayic ?ayib)
                          (= ?ayic ?ayia)
                          )
                        (= ?ayib ?ayia)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayid Real)
                  (declare-const ?ayie Real)
                  (declare-const ?ayif Real)
                  (assert
                    (and (and (not (= ?ayif ?ayie))
                        (not (= ?ayif ?ayid))
                        )
                      (not (= ?ayie ?ayid))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayig Real)
                  (declare-const ?ayih Real)
                  (declare-const ?ayii Real)
                  (declare-const ?ayij Real)
                  (assert
                    (and (and (not (= ?ayii ?ayih))
                        (not (= ?ayii ?ayig))
                        )
                      (not (= ?ayih ?ayig))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayik Real)
                  (declare-const ?ayil Real)
                  (declare-const ?ayim Real)
                  (declare-const ?ayin Real)
                  (declare-const ?ayio Real)
                  (assert
                    (and (and (not (= ?ayim ?ayil))
                        (not (= ?ayim ?ayik))
                        )
                      (not (= ?ayil ?ayik))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayip Real)
                  (declare-const ?ayiq Real)
                  (declare-const ?ayir Real)
                  (assert
                    (and (and (not (= ?ayir ?ayiq))
                        (not (= ?ayir ?ayip))
                        )
                      (not (= ?ayiq ?ayip))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayis Real)
                  (declare-const ?ayit Real)
                  (declare-const ?ayiu Real)
                  (declare-const ?ayiv Real)
                  (assert
                    (and (and (not (= ?ayiv ?ayiu))
                        (not (= ?ayiv ?ayit))
                        )
                      (not (= ?ayiu ?ayit))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayiw Real)
                  (declare-const ?ayix Real)
                  (declare-const ?ayiy Real)
                  (declare-const ?ayiz Real)
                  (declare-const ?ayja Real)
                  (assert
                    (and (and (not (= ?ayja ?ayiz))
                        (not (= ?ayja ?ayiy))
                        )
                      (not (= ?ayiz ?ayiy))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayjb Real)
                  (declare-const ?ayjc Real)
                  (declare-const ?ayjd Real)
                  (declare-const ?ayje Real)
                  (declare-const ?ayjf Real)
                  (declare-const ?ayjg Real)
                  (assert
                    (and (and (and (not (= ?ayjd ?ayjc))
                          (not (= ?ayjd ?ayjb))
                          )
                        (not (= ?ayjc ?ayjb))
                        )
                      (and (and (not (= ?ayjg ?ayjf))
                          (not (= ?ayjg ?ayje))
                          )
                        (not (= ?ayjf ?ayje))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayjh Real)
                  (declare-const ?ayji Real)
                  (declare-const ?ayjj Real)
                  (assert
                    (and (and (not (= ?ayjj ?ayji))
                        (not (= ?ayjj ?ayjh))
                        )
                      (not (= ?ayji ?ayjh))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayjk Real)
                  (declare-const ?ayjl Real)
                  (declare-const ?ayjm Real)
                  (assert
                    (and (and (not (= ?ayjm ?ayjl))
                        (not (= ?ayjm ?ayjk))
                        )
                      (not (= ?ayjl ?ayjk))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?ayjn Real)
      (push 1)
        (declare-const ?ayjo Real)
        (declare-const ?ayjp Real)
        (declare-const ?ayjq Real)
        (declare-const ?ayjr Real)
        (declare-const ?ayjs Real)
        (declare-const ?ayjt Real)
        (assert
          (and (or (or (= ?ayjq ?ayjp)
                (= ?ayjq ?ayjo)
                )
              (= ?ayjp ?ayjo)
              )
            (or (or (= ?ayjt ?ayjs)
                (= ?ayjt ?ayjr)
                )
              (= ?ayjs ?ayjr)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayju Real)
        (declare-const ?ayjv Real)
        (declare-const ?ayjw Real)
        (assert
          (and (and (not (= ?ayjw ?ayjv))
              (not (= ?ayjw ?ayju))
              )
            (not (= ?ayjv ?ayju))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayjx Real)
        (declare-const ?ayjy Real)
        (declare-const ?ayjz Real)
        (declare-const ?ayka Real)
        (assert
          (and (and (not (= ?ayjz ?ayjy))
              (not (= ?ayjz ?ayjx))
              )
            (not (= ?ayjy ?ayjx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aykb Real)
        (declare-const ?aykc Real)
        (declare-const ?aykd Real)
        (declare-const ?ayke Real)
        (declare-const ?aykf Real)
        (assert
          (and (and (not (= ?aykd ?aykc))
              (not (= ?aykd ?aykb))
              )
            (not (= ?aykc ?aykb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aykg Real)
        (declare-const ?aykh Real)
        (declare-const ?ayki Real)
        (assert
          (and (and (not (= ?ayki ?aykh))
              (not (= ?ayki ?aykg))
              )
            (not (= ?aykh ?aykg))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aykj Real)
        (declare-const ?aykk Real)
        (declare-const ?aykl Real)
        (declare-const ?aykm Real)
        (assert
          (and (and (not (= ?aykm ?aykl))
              (not (= ?aykm ?aykk))
              )
            (not (= ?aykl ?aykk))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aykn Real)
        (declare-const ?ayko Real)
        (declare-const ?aykp Real)
        (declare-const ?aykq Real)
        (declare-const ?aykr Real)
        (assert
          (and (and (not (= ?aykr ?aykq))
              (not (= ?aykr ?aykp))
              )
            (not (= ?aykq ?aykp))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayks Real)
        (declare-const ?aykt Real)
        (declare-const ?ayku Real)
        (declare-const ?aykv Real)
        (declare-const ?aykw Real)
        (declare-const ?aykx Real)
        (assert
          (and (and (and (not (= ?ayku ?aykt))
                (not (= ?ayku ?ayks))
                )
              (not (= ?aykt ?ayks))
              )
            (and (and (not (= ?aykx ?aykw))
                (not (= ?aykx ?aykv))
                )
              (not (= ?aykw ?aykv))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayky Real)
        (declare-const ?aykz Real)
        (declare-const ?ayla Real)
        (assert
          (and (and (not (= ?ayla ?aykz))
              (not (= ?ayla ?ayky))
              )
            (not (= ?aykz ?ayky))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aylb Real)
        (declare-const ?aylc Real)
        (declare-const ?ayld Real)
        (assert
          (and (and (not (= ?ayld ?aylc))
              (not (= ?ayld ?aylb))
              )
            (not (= ?aylc ?aylb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?ayle Real)
          (push 1)
            (declare-const ?aylf Real)
            (push 1)
              (declare-const ?aylg Real)
              (declare-const ?aylh Real)
              (push 1)
                (assert
                  (and (and (= ?aylf ?ayle)
                      (= ?aylg ?ayjn)
                      )
                    (= ?aylh ?ayle)
                    )
                  )
                (push 1)
                  (declare-const ?ayli Real)
                  (declare-const ?aylj Real)
                  (declare-const ?aylk Real)
                  (declare-const ?ayll Real)
                  (declare-const ?aylm Real)
                  (declare-const ?ayln Real)
                  (assert
                    (and (or (or (= ?aylk ?aylj)
                          (= ?aylk ?ayli)
                          )
                        (= ?aylj ?ayli)
                        )
                      (or (or (= ?ayln ?aylm)
                          (= ?ayln ?ayll)
                          )
                        (= ?aylm ?ayll)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aylo Real)
                  (declare-const ?aylp Real)
                  (declare-const ?aylq Real)
                  (assert
                    (and (and (not (= ?aylq ?aylp))
                        (not (= ?aylq ?aylo))
                        )
                      (not (= ?aylp ?aylo))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aylr Real)
                  (declare-const ?ayls Real)
                  (declare-const ?aylt Real)
                  (declare-const ?aylu Real)
                  (assert
                    (and (and (not (= ?aylt ?ayls))
                        (not (= ?aylt ?aylr))
                        )
                      (not (= ?ayls ?aylr))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aylv Real)
                  (declare-const ?aylw Real)
                  (declare-const ?aylx Real)
                  (declare-const ?ayly Real)
                  (declare-const ?aylz Real)
                  (assert
                    (and (and (not (= ?aylx ?aylw))
                        (not (= ?aylx ?aylv))
                        )
                      (not (= ?aylw ?aylv))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayma Real)
                  (declare-const ?aymb Real)
                  (declare-const ?aymc Real)
                  (assert
                    (and (and (not (= ?aymc ?aymb))
                        (not (= ?aymc ?ayma))
                        )
                      (not (= ?aymb ?ayma))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aymd Real)
                  (declare-const ?ayme Real)
                  (declare-const ?aymf Real)
                  (declare-const ?aymg Real)
                  (assert
                    (and (and (not (= ?aymg ?aymf))
                        (not (= ?aymg ?ayme))
                        )
                      (not (= ?aymf ?ayme))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aymh Real)
                  (declare-const ?aymi Real)
                  (declare-const ?aymj Real)
                  (declare-const ?aymk Real)
                  (declare-const ?ayml Real)
                  (assert
                    (and (and (not (= ?ayml ?aymk))
                        (not (= ?ayml ?aymj))
                        )
                      (not (= ?aymk ?aymj))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aymm Real)
                  (declare-const ?aymn Real)
                  (declare-const ?aymo Real)
                  (declare-const ?aymp Real)
                  (declare-const ?aymq Real)
                  (declare-const ?aymr Real)
                  (assert
                    (and (and (and (not (= ?aymo ?aymn))
                          (not (= ?aymo ?aymm))
                          )
                        (not (= ?aymn ?aymm))
                        )
                      (and (and (not (= ?aymr ?aymq))
                          (not (= ?aymr ?aymp))
                          )
                        (not (= ?aymq ?aymp))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayms Real)
                  (declare-const ?aymt Real)
                  (declare-const ?aymu Real)
                  (assert
                    (and (and (not (= ?aymu ?aymt))
                        (not (= ?aymu ?ayms))
                        )
                      (not (= ?aymt ?ayms))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aymv Real)
                  (declare-const ?aymw Real)
                  (declare-const ?aymx Real)
                  (assert
                    (and (and (not (= ?aymx ?aymw))
                        (not (= ?aymx ?aymv))
                        )
                      (not (= ?aymw ?aymv))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?aymy Real)
      (declare-const ?aymz Real)
      (push 1)
        (declare-const ?ayna Real)
        (declare-const ?aynb Real)
        (declare-const ?aync Real)
        (declare-const ?aynd Real)
        (declare-const ?ayne Real)
        (declare-const ?aynf Real)
        (assert
          (and (or (or (= ?aync ?aynb)
                (= ?aync ?ayna)
                )
              (= ?aynb ?ayna)
              )
            (or (or (= ?aynf ?ayne)
                (= ?aynf ?aynd)
                )
              (= ?ayne ?aynd)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayng Real)
        (declare-const ?aynh Real)
        (declare-const ?ayni Real)
        (assert
          (and (and (not (= ?ayni ?aynh))
              (not (= ?ayni ?ayng))
              )
            (not (= ?aynh ?ayng))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aynj Real)
        (declare-const ?aynk Real)
        (declare-const ?aynl Real)
        (declare-const ?aynm Real)
        (assert
          (and (and (not (= ?aynl ?aynk))
              (not (= ?aynl ?aynj))
              )
            (not (= ?aynk ?aynj))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aynn Real)
        (declare-const ?ayno Real)
        (declare-const ?aynp Real)
        (declare-const ?aynq Real)
        (declare-const ?aynr Real)
        (assert
          (and (and (not (= ?aynp ?ayno))
              (not (= ?aynp ?aynn))
              )
            (not (= ?ayno ?aynn))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayns Real)
        (declare-const ?aynt Real)
        (declare-const ?aynu Real)
        (assert
          (and (and (not (= ?aynu ?aynt))
              (not (= ?aynu ?ayns))
              )
            (not (= ?aynt ?ayns))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aynv Real)
        (declare-const ?aynw Real)
        (declare-const ?aynx Real)
        (declare-const ?ayny Real)
        (assert
          (and (and (not (= ?ayny ?aynx))
              (not (= ?ayny ?aynw))
              )
            (not (= ?aynx ?aynw))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aynz Real)
        (declare-const ?ayoa Real)
        (declare-const ?ayob Real)
        (declare-const ?ayoc Real)
        (declare-const ?ayod Real)
        (assert
          (and (and (not (= ?ayod ?ayoc))
              (not (= ?ayod ?ayob))
              )
            (not (= ?ayoc ?ayob))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayoe Real)
        (declare-const ?ayof Real)
        (declare-const ?ayog Real)
        (declare-const ?ayoh Real)
        (declare-const ?ayoi Real)
        (declare-const ?ayoj Real)
        (assert
          (and (and (and (not (= ?ayog ?ayof))
                (not (= ?ayog ?ayoe))
                )
              (not (= ?ayof ?ayoe))
              )
            (and (and (not (= ?ayoj ?ayoi))
                (not (= ?ayoj ?ayoh))
                )
              (not (= ?ayoi ?ayoh))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayok Real)
        (declare-const ?ayol Real)
        (declare-const ?ayom Real)
        (assert
          (and (and (not (= ?ayom ?ayol))
              (not (= ?ayom ?ayok))
              )
            (not (= ?ayol ?ayok))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayon Real)
        (declare-const ?ayoo Real)
        (declare-const ?ayop Real)
        (assert
          (and (and (not (= ?ayop ?ayoo))
              (not (= ?ayop ?ayon))
              )
            (not (= ?ayoo ?ayon))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?ayoq Real)
          (push 1)
            (declare-const ?ayor Real)
            (push 1)
              (declare-const ?ayos Real)
              (declare-const ?ayot Real)
              (declare-const ?ayou Real)
              (push 1)
                (assert
                  (and (and (= ?ayor ?ayoq)
                      (and (= ?ayot ?aymz)
                        (= ?ayos ?aymy)
                        )
                      )
                    (= ?ayou ?ayoq)
                    )
                  )
                (push 1)
                  (declare-const ?ayov Real)
                  (declare-const ?ayow Real)
                  (declare-const ?ayox Real)
                  (declare-const ?ayoy Real)
                  (declare-const ?ayoz Real)
                  (declare-const ?aypa Real)
                  (assert
                    (and (or (or (= ?ayox ?ayow)
                          (= ?ayox ?ayov)
                          )
                        (= ?ayow ?ayov)
                        )
                      (or (or (= ?aypa ?ayoz)
                          (= ?aypa ?ayoy)
                          )
                        (= ?ayoz ?ayoy)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aypb Real)
                  (declare-const ?aypc Real)
                  (declare-const ?aypd Real)
                  (assert
                    (and (and (not (= ?aypd ?aypc))
                        (not (= ?aypd ?aypb))
                        )
                      (not (= ?aypc ?aypb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aype Real)
                  (declare-const ?aypf Real)
                  (declare-const ?aypg Real)
                  (declare-const ?ayph Real)
                  (assert
                    (and (and (not (= ?aypg ?aypf))
                        (not (= ?aypg ?aype))
                        )
                      (not (= ?aypf ?aype))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aypi Real)
                  (declare-const ?aypj Real)
                  (declare-const ?aypk Real)
                  (declare-const ?aypl Real)
                  (declare-const ?aypm Real)
                  (assert
                    (and (and (not (= ?aypk ?aypj))
                        (not (= ?aypk ?aypi))
                        )
                      (not (= ?aypj ?aypi))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aypn Real)
                  (declare-const ?aypo Real)
                  (declare-const ?aypp Real)
                  (assert
                    (and (and (not (= ?aypp ?aypo))
                        (not (= ?aypp ?aypn))
                        )
                      (not (= ?aypo ?aypn))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aypq Real)
                  (declare-const ?aypr Real)
                  (declare-const ?ayps Real)
                  (declare-const ?aypt Real)
                  (assert
                    (and (and (not (= ?aypt ?ayps))
                        (not (= ?aypt ?aypr))
                        )
                      (not (= ?ayps ?aypr))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aypu Real)
                  (declare-const ?aypv Real)
                  (declare-const ?aypw Real)
                  (declare-const ?aypx Real)
                  (declare-const ?aypy Real)
                  (assert
                    (and (and (not (= ?aypy ?aypx))
                        (not (= ?aypy ?aypw))
                        )
                      (not (= ?aypx ?aypw))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aypz Real)
                  (declare-const ?ayqa Real)
                  (declare-const ?ayqb Real)
                  (declare-const ?ayqc Real)
                  (declare-const ?ayqd Real)
                  (declare-const ?ayqe Real)
                  (assert
                    (and (and (and (not (= ?ayqb ?ayqa))
                          (not (= ?ayqb ?aypz))
                          )
                        (not (= ?ayqa ?aypz))
                        )
                      (and (and (not (= ?ayqe ?ayqd))
                          (not (= ?ayqe ?ayqc))
                          )
                        (not (= ?ayqd ?ayqc))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayqf Real)
                  (declare-const ?ayqg Real)
                  (declare-const ?ayqh Real)
                  (assert
                    (and (and (not (= ?ayqh ?ayqg))
                        (not (= ?ayqh ?ayqf))
                        )
                      (not (= ?ayqg ?ayqf))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayqi Real)
                  (declare-const ?ayqj Real)
                  (declare-const ?ayqk Real)
                  (assert
                    (and (and (not (= ?ayqk ?ayqj))
                        (not (= ?ayqk ?ayqi))
                        )
                      (not (= ?ayqj ?ayqi))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (assert
                    (or (or (= ?ayot ?ayos)
                        (= ?ayot ?ayou)
                        )
                      (= ?ayos ?ayou)
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (and (not (= ?aymz ?aymy))
              (forall ((?ayou Real) )(and (not (= ?aymz ?ayou))
                  (not (= ?aymy ?ayou))
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?ayql Real)
      (declare-const ?ayqm Real)
      (declare-const ?ayqn Real)
      (push 1)
        (declare-const ?ayqo Real)
        (declare-const ?ayqp Real)
        (declare-const ?ayqq Real)
        (declare-const ?ayqr Real)
        (declare-const ?ayqs Real)
        (declare-const ?ayqt Real)
        (assert
          (and (or (or (= ?ayqq ?ayqp)
                (= ?ayqq ?ayqo)
                )
              (= ?ayqp ?ayqo)
              )
            (or (or (= ?ayqt ?ayqs)
                (= ?ayqt ?ayqr)
                )
              (= ?ayqs ?ayqr)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayqu Real)
        (declare-const ?ayqv Real)
        (declare-const ?ayqw Real)
        (assert
          (and (and (not (= ?ayqw ?ayqv))
              (not (= ?ayqw ?ayqu))
              )
            (not (= ?ayqv ?ayqu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayqx Real)
        (declare-const ?ayqy Real)
        (declare-const ?ayqz Real)
        (declare-const ?ayra Real)
        (assert
          (and (and (not (= ?ayqz ?ayqy))
              (not (= ?ayqz ?ayqx))
              )
            (not (= ?ayqy ?ayqx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayrb Real)
        (declare-const ?ayrc Real)
        (declare-const ?ayrd Real)
        (declare-const ?ayre Real)
        (declare-const ?ayrf Real)
        (assert
          (and (and (not (= ?ayrd ?ayrc))
              (not (= ?ayrd ?ayrb))
              )
            (not (= ?ayrc ?ayrb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayrg Real)
        (declare-const ?ayrh Real)
        (declare-const ?ayri Real)
        (assert
          (and (and (not (= ?ayri ?ayrh))
              (not (= ?ayri ?ayrg))
              )
            (not (= ?ayrh ?ayrg))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayrj Real)
        (declare-const ?ayrk Real)
        (declare-const ?ayrl Real)
        (declare-const ?ayrm Real)
        (assert
          (and (and (not (= ?ayrm ?ayrl))
              (not (= ?ayrm ?ayrk))
              )
            (not (= ?ayrl ?ayrk))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayrn Real)
        (declare-const ?ayro Real)
        (declare-const ?ayrp Real)
        (declare-const ?ayrq Real)
        (declare-const ?ayrr Real)
        (assert
          (and (and (not (= ?ayrr ?ayrq))
              (not (= ?ayrr ?ayrp))
              )
            (not (= ?ayrq ?ayrp))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayrs Real)
        (declare-const ?ayrt Real)
        (declare-const ?ayru Real)
        (declare-const ?ayrv Real)
        (declare-const ?ayrw Real)
        (declare-const ?ayrx Real)
        (assert
          (and (and (and (not (= ?ayru ?ayrt))
                (not (= ?ayru ?ayrs))
                )
              (not (= ?ayrt ?ayrs))
              )
            (and (and (not (= ?ayrx ?ayrw))
                (not (= ?ayrx ?ayrv))
                )
              (not (= ?ayrw ?ayrv))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayry Real)
        (declare-const ?ayrz Real)
        (declare-const ?aysa Real)
        (assert
          (and (and (not (= ?aysa ?ayrz))
              (not (= ?aysa ?ayry))
              )
            (not (= ?ayrz ?ayry))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?aysb Real)
        (declare-const ?aysc Real)
        (declare-const ?aysd Real)
        (assert
          (and (and (not (= ?aysd ?aysc))
              (not (= ?aysd ?aysb))
              )
            (not (= ?aysc ?aysb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?ayqn ?ayqm))
              (not (= ?ayqn ?ayql))
              )
            (not (= ?ayqm ?ayql))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?ayse Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?aysf Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?aysg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aysh Real)
              (declare-const ?aysi Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aysj Real)
              (declare-const ?aysk Real)
              (declare-const ?aysl Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aysm Real)
              (declare-const ?aysn Real)
              (declare-const ?ayso Real)
              (declare-const ?aysp Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aysq Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?aysr Real)
            (declare-const ?ayss Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?ayst Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aysu Real)
              (declare-const ?aysv Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aysw Real)
              (declare-const ?aysx Real)
              (declare-const ?aysy Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aysz Real)
              (declare-const ?ayta Real)
              (declare-const ?aytb Real)
              (declare-const ?aytc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aytd Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?ayte Real)
            (declare-const ?aytf Real)
            (declare-const ?aytg Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?ayth Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?ayti Real)
              (declare-const ?aytj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aytk Real)
              (declare-const ?aytl Real)
              (declare-const ?aytm Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aytn Real)
              (declare-const ?ayto Real)
              (declare-const ?aytp Real)
              (declare-const ?aytq Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aytr Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?ayts Real)
            (declare-const ?aytt Real)
            (declare-const ?aytu Real)
            (declare-const ?aytv Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?aytw Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aytx Real)
              (declare-const ?ayty Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?aytz Real)
              (declare-const ?ayua Real)
              (declare-const ?ayub Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?ayuc Real)
              (declare-const ?ayud Real)
              (declare-const ?ayue Real)
              (declare-const ?ayuf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?ayug Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?ayuh Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?ayui Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?ayuj Real)
              (declare-const ?ayuk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?ayul Real)
              (declare-const ?ayum Real)
              (declare-const ?ayun Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?ayuo Real)
              (declare-const ?ayup Real)
              (declare-const ?ayuq Real)
              (declare-const ?ayur Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (= ?ayuh ?ayse)
                      (and (and (= ?ayuq ?ayqn)
                          (= ?ayup ?ayqm)
                          )
                        (= ?ayuo ?ayql)
                        )
                      )
                    (= ?ayur ?ayse)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
                  (declare-const ?ayus Real)
                  (declare-const ?ayut Real)
                  (declare-const ?ayuu Real)
                  (declare-const ?ayuv Real)
                  (declare-const ?ayuw Real)
                  (declare-const ?ayux Real)
                  (assert
                    (and (or (or (= ?ayuu ?ayut)
                          (= ?ayuu ?ayus)
                          )
                        (= ?ayut ?ayus)
                        )
                      (or (or (= ?ayux ?ayuw)
                          (= ?ayux ?ayuv)
                          )
                        (= ?ayuw ?ayuv)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayuy Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayuz Real)
                  (declare-const ?ayva Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayvb Real)
                  (declare-const ?ayvc Real)
                  (declare-const ?ayvd Real)
                  (assert
                    (and (and (not (= ?ayvd ?ayvc))
                        (not (= ?ayvd ?ayvb))
                        )
                      (not (= ?ayvc ?ayvb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayve Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayvf Real)
                  (declare-const ?ayvg Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayvh Real)
                  (declare-const ?ayvi Real)
                  (declare-const ?ayvj Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayvk Real)
                  (declare-const ?ayvl Real)
                  (declare-const ?ayvm Real)
                  (declare-const ?ayvn Real)
                  (assert
                    (and (and (not (= ?ayvm ?ayvl))
                        (not (= ?ayvm ?ayvk))
                        )
                      (not (= ?ayvl ?ayvk))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayvo Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayvp Real)
                  (declare-const ?ayvq Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayvr Real)
                  (declare-const ?ayvs Real)
                  (declare-const ?ayvt Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayvu Real)
                  (declare-const ?ayvv Real)
                  (declare-const ?ayvw Real)
                  (declare-const ?ayvx Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayvy Real)
                  (declare-const ?ayvz Real)
                  (declare-const ?aywa Real)
                  (declare-const ?aywb Real)
                  (declare-const ?aywc Real)
                  (assert
                    (and (and (not (= ?aywa ?ayvz))
                        (not (= ?aywa ?ayvy))
                        )
                      (not (= ?ayvz ?ayvy))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aywd Real)
                  (declare-const ?aywe Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aywf Real)
                  (declare-const ?aywg Real)
                  (declare-const ?aywh Real)
                  (assert
                    (and (and (not (= ?aywh ?aywg))
                        (not (= ?aywh ?aywf))
                        )
                      (not (= ?aywg ?aywf))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aywi Real)
                  (declare-const ?aywj Real)
                  (declare-const ?aywk Real)
                  (declare-const ?aywl Real)
                  (assert
                    (and (and (not (= ?aywl ?aywk))
                        (not (= ?aywl ?aywj))
                        )
                      (not (= ?aywk ?aywj))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aywm Real)
                  (declare-const ?aywn Real)
                  (declare-const ?aywo Real)
                  (declare-const ?aywp Real)
                  (declare-const ?aywq Real)
                  (assert
                    (and (and (not (= ?aywq ?aywp))
                        (not (= ?aywq ?aywo))
                        )
                      (not (= ?aywp ?aywo))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aywr Real)
                  (declare-const ?ayws Real)
                  (declare-const ?aywt Real)
                  (declare-const ?aywu Real)
                  (declare-const ?aywv Real)
                  (declare-const ?ayww Real)
                  (assert
                    (and (and (and (not (= ?aywt ?ayws))
                          (not (= ?aywt ?aywr))
                          )
                        (not (= ?ayws ?aywr))
                        )
                      (and (and (not (= ?ayww ?aywv))
                          (not (= ?ayww ?aywu))
                          )
                        (not (= ?aywv ?aywu))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?aywx Real)
                  (declare-const ?aywy Real)
                  (declare-const ?aywz Real)
                  (assert
                    (and (and (not (= ?aywz ?aywy))
                        (not (= ?aywz ?aywx))
                        )
                      (not (= ?aywy ?aywx))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayxa Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayxb Real)
                  (declare-const ?ayxc Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayxd Real)
                  (declare-const ?ayxe Real)
                  (declare-const ?ayxf Real)
                  (assert
                    (and (and (not (= ?ayxf ?ayxe))
                        (not (= ?ayxf ?ayxd))
                        )
                      (not (= ?ayxe ?ayxd))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?ayxg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (declare-const ?ayxh Real)
        (declare-const ?ayxi Real)
        (declare-const ?ayxj Real)
        (declare-const ?ayxk Real)
        (declare-const ?ayxl Real)
        (declare-const ?ayxm Real)
        (assert
          (and (or (or (= ?ayxj ?ayxi)
                (= ?ayxj ?ayxh)
                )
              (= ?ayxi ?ayxh)
              )
            (or (or (= ?ayxm ?ayxl)
                (= ?ayxm ?ayxk)
                )
              (= ?ayxl ?ayxk)
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayxn Real)
        (declare-const ?ayxo Real)
        (declare-const ?ayxp Real)
        (assert
          (and (and (not (= ?ayxp ?ayxo))
              (not (= ?ayxp ?ayxn))
              )
            (not (= ?ayxo ?ayxn))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayxq Real)
        (declare-const ?ayxr Real)
        (declare-const ?ayxs Real)
        (declare-const ?ayxt Real)
        (assert
          (and (and (not (= ?ayxs ?ayxr))
              (not (= ?ayxs ?ayxq))
              )
            (not (= ?ayxr ?ayxq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayxu Real)
        (declare-const ?ayxv Real)
        (declare-const ?ayxw Real)
        (declare-const ?ayxx Real)
        (declare-const ?ayxy Real)
        (assert
          (and (and (not (= ?ayxw ?ayxv))
              (not (= ?ayxw ?ayxu))
              )
            (not (= ?ayxv ?ayxu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayxz Real)
        (declare-const ?ayya Real)
        (declare-const ?ayyb Real)
        (assert
          (and (and (not (= ?ayyb ?ayya))
              (not (= ?ayyb ?ayxz))
              )
            (not (= ?ayya ?ayxz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayyc Real)
        (declare-const ?ayyd Real)
        (declare-const ?ayye Real)
        (declare-const ?ayyf Real)
        (assert
          (and (and (not (= ?ayyf ?ayye))
              (not (= ?ayyf ?ayyd))
              )
            (not (= ?ayye ?ayyd))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayyg Real)
        (declare-const ?ayyh Real)
        (declare-const ?ayyi Real)
        (declare-const ?ayyj Real)
        (declare-const ?ayyk Real)
        (assert
          (and (and (not (= ?ayyk ?ayyj))
              (not (= ?ayyk ?ayyi))
              )
            (not (= ?ayyj ?ayyi))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayyl Real)
        (declare-const ?ayym Real)
        (declare-const ?ayyn Real)
        (declare-const ?ayyo Real)
        (declare-const ?ayyp Real)
        (declare-const ?ayyq Real)
        (assert
          (and (and (and (not (= ?ayyn ?ayym))
                (not (= ?ayyn ?ayyl))
                )
              (not (= ?ayym ?ayyl))
              )
            (and (and (not (= ?ayyq ?ayyp))
                (not (= ?ayyq ?ayyo))
                )
              (not (= ?ayyp ?ayyo))
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayyr Real)
        (declare-const ?ayys Real)
        (declare-const ?ayyt Real)
        (assert
          (and (and (not (= ?ayyt ?ayys))
              (not (= ?ayyt ?ayyr))
              )
            (not (= ?ayys ?ayyr))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?ayyu Real)
        (declare-const ?ayyv Real)
        (declare-const ?ayyw Real)
        (assert
          (and (and (not (= ?ayyw ?ayyv))
              (not (= ?ayyw ?ayyu))
              )
            (not (= ?ayyv ?ayyu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?ayyx Real)
          (push 1)
            (declare-const ?ayyy Real)
            (push 1)
              (declare-const ?ayyz Real)
              (push 1)
                (assert
                  (and (= ?ayyy ?ayyx)
                    (= ?ayyz ?ayyx)
                    )
                  )
                (push 1)
                  (declare-const ?ayza Real)
                  (declare-const ?ayzb Real)
                  (declare-const ?ayzc Real)
                  (declare-const ?ayzd Real)
                  (declare-const ?ayze Real)
                  (declare-const ?ayzf Real)
                  (assert
                    (and (or (or (= ?ayzc ?ayzb)
                          (= ?ayzc ?ayza)
                          )
                        (= ?ayzb ?ayza)
                        )
                      (or (or (= ?ayzf ?ayze)
                          (= ?ayzf ?ayzd)
                          )
                        (= ?ayze ?ayzd)
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayzg Real)
                  (declare-const ?ayzh Real)
                  (declare-const ?ayzi Real)
                  (assert
                    (and (and (not (= ?ayzi ?ayzh))
                        (not (= ?ayzi ?ayzg))
                        )
                      (not (= ?ayzh ?ayzg))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayzj Real)
                  (declare-const ?ayzk Real)
                  (declare-const ?ayzl Real)
                  (declare-const ?ayzm Real)
                  (assert
                    (and (and (not (= ?ayzl ?ayzk))
                        (not (= ?ayzl ?ayzj))
                        )
                      (not (= ?ayzk ?ayzj))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayzn Real)
                  (declare-const ?ayzo Real)
                  (declare-const ?ayzp Real)
                  (declare-const ?ayzq Real)
                  (declare-const ?ayzr Real)
                  (assert
                    (and (and (not (= ?ayzp ?ayzo))
                        (not (= ?ayzp ?ayzn))
                        )
                      (not (= ?ayzo ?ayzn))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayzs Real)
                  (declare-const ?ayzt Real)
                  (declare-const ?ayzu Real)
                  (assert
                    (and (and (not (= ?ayzu ?ayzt))
                        (not (= ?ayzu ?ayzs))
                        )
                      (not (= ?ayzt ?ayzs))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayzv Real)
                  (declare-const ?ayzw Real)
                  (declare-const ?ayzx Real)
                  (declare-const ?ayzy Real)
                  (assert
                    (and (and (not (= ?ayzy ?ayzx))
                        (not (= ?ayzy ?ayzw))
                        )
                      (not (= ?ayzx ?ayzw))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?ayzz Real)
                  (declare-const ?azaa Real)
                  (declare-const ?azab Real)
                  (declare-const ?azac Real)
                  (declare-const ?azad Real)
                  (assert
                    (and (and (not (= ?azad ?azac))
                        (not (= ?azad ?azab))
                        )
                      (not (= ?azac ?azab))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?azae Real)
                  (declare-const ?azaf Real)
                  (declare-const ?azag Real)
                  (declare-const ?azah Real)
                  (declare-const ?azai Real)
                  (declare-const ?azaj Real)
                  (assert
                    (and (and (and (not (= ?azag ?azaf))
                          (not (= ?azag ?azae))
                          )
                        (not (= ?azaf ?azae))
                        )
                      (and (and (not (= ?azaj ?azai))
                          (not (= ?azaj ?azah))
                          )
                        (not (= ?azai ?azah))
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?azak Real)
                  (declare-const ?azal Real)
                  (declare-const ?azam Real)
                  (assert
                    (and (and (not (= ?azam ?azal))
                        (not (= ?azam ?azak))
                        )
                      (not (= ?azal ?azak))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?azan Real)
                  (declare-const ?azao Real)
                  (declare-const ?azap Real)
                  (assert
                    (and (and (not (= ?azap ?azao))
                        (not (= ?azap ?azan))
                        )
                      (not (= ?azao ?azan))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?azaq Real)
      (declare-const ?azar Real)
      (declare-const ?azas Real)
      (declare-const ?azat Real)
      (declare-const ?azau Real)
      (declare-const ?azav Real)
      (assert
        (and (or (or (= ?azas ?azar)
              (= ?azas ?azaq)
              )
            (= ?azar ?azaq)
            )
          (or (or (= ?azav ?azau)
              (= ?azav ?azat)
              )
            (= ?azau ?azat)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azaw Real)
      (declare-const ?azax Real)
      (declare-const ?azay Real)
      (assert
        (and (and (not (= ?azay ?azax))
            (not (= ?azay ?azaw))
            )
          (not (= ?azax ?azaw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azaz Real)
      (declare-const ?azba Real)
      (declare-const ?azbb Real)
      (declare-const ?azbc Real)
      (assert
        (and (and (not (= ?azbb ?azba))
            (not (= ?azbb ?azaz))
            )
          (not (= ?azba ?azaz))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azbd Real)
      (declare-const ?azbe Real)
      (declare-const ?azbf Real)
      (declare-const ?azbg Real)
      (declare-const ?azbh Real)
      (assert
        (and (and (not (= ?azbf ?azbe))
            (not (= ?azbf ?azbd))
            )
          (not (= ?azbe ?azbd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azbi Real)
      (declare-const ?azbj Real)
      (declare-const ?azbk Real)
      (assert
        (and (and (not (= ?azbk ?azbj))
            (not (= ?azbk ?azbi))
            )
          (not (= ?azbj ?azbi))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azbl Real)
      (declare-const ?azbm Real)
      (declare-const ?azbn Real)
      (declare-const ?azbo Real)
      (assert
        (and (and (not (= ?azbo ?azbn))
            (not (= ?azbo ?azbm))
            )
          (not (= ?azbn ?azbm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azbp Real)
      (declare-const ?azbq Real)
      (declare-const ?azbr Real)
      (declare-const ?azbs Real)
      (declare-const ?azbt Real)
      (assert
        (and (and (not (= ?azbt ?azbs))
            (not (= ?azbt ?azbr))
            )
          (not (= ?azbs ?azbr))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azbu Real)
      (declare-const ?azbv Real)
      (declare-const ?azbw Real)
      (declare-const ?azbx Real)
      (declare-const ?azby Real)
      (declare-const ?azbz Real)
      (assert
        (and (and (and (not (= ?azbw ?azbv))
              (not (= ?azbw ?azbu))
              )
            (not (= ?azbv ?azbu))
            )
          (and (and (not (= ?azbz ?azby))
              (not (= ?azbz ?azbx))
              )
            (not (= ?azby ?azbx))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azca Real)
      (declare-const ?azcb Real)
      (declare-const ?azcc Real)
      (assert
        (and (and (not (= ?azcc ?azcb))
            (not (= ?azcc ?azca))
            )
          (not (= ?azcb ?azca))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azcd Real)
      (declare-const ?azce Real)
      (declare-const ?azcf Real)
      (assert
        (and (and (not (= ?azcf ?azce))
            (not (= ?azcf ?azcd))
            )
          (not (= ?azce ?azcd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?azcg Real)
    (push 1)
      (declare-const ?azch Real)
      (declare-const ?azci Real)
      (declare-const ?azcj Real)
      (declare-const ?azck Real)
      (declare-const ?azcl Real)
      (declare-const ?azcm Real)
      (assert
        (and (or (or (= ?azcj ?azci)
              (= ?azcj ?azch)
              )
            (= ?azci ?azch)
            )
          (or (or (= ?azcm ?azcl)
              (= ?azcm ?azck)
              )
            (= ?azcl ?azck)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azcn Real)
      (declare-const ?azco Real)
      (declare-const ?azcp Real)
      (assert
        (and (and (not (= ?azcp ?azco))
            (not (= ?azcp ?azcn))
            )
          (not (= ?azco ?azcn))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azcq Real)
      (declare-const ?azcr Real)
      (declare-const ?azcs Real)
      (declare-const ?azct Real)
      (assert
        (and (and (not (= ?azcs ?azcr))
            (not (= ?azcs ?azcq))
            )
          (not (= ?azcr ?azcq))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azcu Real)
      (declare-const ?azcv Real)
      (declare-const ?azcw Real)
      (declare-const ?azcx Real)
      (declare-const ?azcy Real)
      (assert
        (and (and (not (= ?azcw ?azcv))
            (not (= ?azcw ?azcu))
            )
          (not (= ?azcv ?azcu))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azcz Real)
      (declare-const ?azda Real)
      (declare-const ?azdb Real)
      (assert
        (and (and (not (= ?azdb ?azda))
            (not (= ?azdb ?azcz))
            )
          (not (= ?azda ?azcz))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azdc Real)
      (declare-const ?azdd Real)
      (declare-const ?azde Real)
      (declare-const ?azdf Real)
      (assert
        (and (and (not (= ?azdf ?azde))
            (not (= ?azdf ?azdd))
            )
          (not (= ?azde ?azdd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azdg Real)
      (declare-const ?azdh Real)
      (declare-const ?azdi Real)
      (declare-const ?azdj Real)
      (declare-const ?azdk Real)
      (assert
        (and (and (not (= ?azdk ?azdj))
            (not (= ?azdk ?azdi))
            )
          (not (= ?azdj ?azdi))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azdl Real)
      (declare-const ?azdm Real)
      (declare-const ?azdn Real)
      (declare-const ?azdo Real)
      (declare-const ?azdp Real)
      (declare-const ?azdq Real)
      (assert
        (and (and (and (not (= ?azdn ?azdm))
              (not (= ?azdn ?azdl))
              )
            (not (= ?azdm ?azdl))
            )
          (and (and (not (= ?azdq ?azdp))
              (not (= ?azdq ?azdo))
              )
            (not (= ?azdp ?azdo))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azdr Real)
      (declare-const ?azds Real)
      (declare-const ?azdt Real)
      (assert
        (and (and (not (= ?azdt ?azds))
            (not (= ?azdt ?azdr))
            )
          (not (= ?azds ?azdr))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azdu Real)
      (declare-const ?azdv Real)
      (declare-const ?azdw Real)
      (assert
        (and (and (not (= ?azdw ?azdv))
            (not (= ?azdw ?azdu))
            )
          (not (= ?azdv ?azdu))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?azdx Real)
    (declare-const ?azdy Real)
    (declare-const ?azdz Real)
    (assert
      (and (and (not (= ?azdz ?azdy))
          (not (= ?azdz ?azdx))
          )
        (not (= ?azdy ?azdx))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?azea Real)
      (declare-const ?azeb Real)
      (declare-const ?azec Real)
      (declare-const ?azed Real)
      (declare-const ?azee Real)
      (declare-const ?azef Real)
      (assert
        (and (or (or (= ?azec ?azeb)
              (= ?azec ?azea)
              )
            (= ?azeb ?azea)
            )
          (or (or (= ?azef ?azee)
              (= ?azef ?azed)
              )
            (= ?azee ?azed)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azeg Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azeh Real)
      (declare-const ?azei Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azej Real)
      (declare-const ?azek Real)
      (declare-const ?azel Real)
      (assert
        (and (and (not (= ?azel ?azek))
            (not (= ?azel ?azej))
            )
          (not (= ?azek ?azej))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azem Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azen Real)
      (declare-const ?azeo Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azep Real)
      (declare-const ?azeq Real)
      (declare-const ?azer Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azes Real)
      (declare-const ?azet Real)
      (declare-const ?azeu Real)
      (declare-const ?azev Real)
      (assert
        (and (and (not (= ?azeu ?azet))
            (not (= ?azeu ?azes))
            )
          (not (= ?azet ?azes))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azew Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azex Real)
      (declare-const ?azey Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azez Real)
      (declare-const ?azfa Real)
      (declare-const ?azfb Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azfc Real)
      (declare-const ?azfd Real)
      (declare-const ?azfe Real)
      (declare-const ?azff Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azfg Real)
      (declare-const ?azfh Real)
      (declare-const ?azfi Real)
      (declare-const ?azfj Real)
      (declare-const ?azfk Real)
      (assert
        (and (and (not (= ?azfi ?azfh))
            (not (= ?azfi ?azfg))
            )
          (not (= ?azfh ?azfg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azfl Real)
      (declare-const ?azfm Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azfn Real)
      (declare-const ?azfo Real)
      (declare-const ?azfp Real)
      (assert
        (and (and (not (= ?azfp ?azfo))
            (not (= ?azfp ?azfn))
            )
          (not (= ?azfo ?azfn))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azfq Real)
      (declare-const ?azfr Real)
      (declare-const ?azfs Real)
      (declare-const ?azft Real)
      (assert
        (and (and (not (= ?azft ?azfs))
            (not (= ?azft ?azfr))
            )
          (not (= ?azfs ?azfr))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azfu Real)
      (declare-const ?azfv Real)
      (declare-const ?azfw Real)
      (declare-const ?azfx Real)
      (declare-const ?azfy Real)
      (assert
        (and (and (not (= ?azfy ?azfx))
            (not (= ?azfy ?azfw))
            )
          (not (= ?azfx ?azfw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azfz Real)
      (declare-const ?azga Real)
      (declare-const ?azgb Real)
      (declare-const ?azgc Real)
      (declare-const ?azgd Real)
      (declare-const ?azge Real)
      (assert
        (and (and (and (not (= ?azgb ?azga))
              (not (= ?azgb ?azfz))
              )
            (not (= ?azga ?azfz))
            )
          (and (and (not (= ?azge ?azgd))
              (not (= ?azge ?azgc))
              )
            (not (= ?azgd ?azgc))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azgf Real)
      (declare-const ?azgg Real)
      (declare-const ?azgh Real)
      (assert
        (and (and (not (= ?azgh ?azgg))
            (not (= ?azgh ?azgf))
            )
          (not (= ?azgg ?azgf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azgi Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azgj Real)
      (declare-const ?azgk Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azgl Real)
      (declare-const ?azgm Real)
      (declare-const ?azgn Real)
      (assert
        (and (and (not (= ?azgn ?azgm))
            (not (= ?azgn ?azgl))
            )
          (not (= ?azgm ?azgl))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?azgo Real)
      (declare-const ?azgp Real)
      (declare-const ?azgq Real)
      (declare-const ?azgr Real)
      (declare-const ?azgs Real)
      (declare-const ?azgt Real)
      (assert
        (and (or (or (= ?azgq ?azgp)
              (= ?azgq ?azgo)
              )
            (= ?azgp ?azgo)
            )
          (or (or (= ?azgt ?azgs)
              (= ?azgt ?azgr)
              )
            (= ?azgs ?azgr)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azgu Real)
      (declare-const ?azgv Real)
      (declare-const ?azgw Real)
      (assert
        (and (and (not (= ?azgw ?azgv))
            (not (= ?azgw ?azgu))
            )
          (not (= ?azgv ?azgu))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azgx Real)
      (declare-const ?azgy Real)
      (declare-const ?azgz Real)
      (declare-const ?azha Real)
      (assert
        (and (and (not (= ?azgz ?azgy))
            (not (= ?azgz ?azgx))
            )
          (not (= ?azgy ?azgx))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azhb Real)
      (declare-const ?azhc Real)
      (declare-const ?azhd Real)
      (declare-const ?azhe Real)
      (declare-const ?azhf Real)
      (assert
        (and (and (not (= ?azhd ?azhc))
            (not (= ?azhd ?azhb))
            )
          (not (= ?azhc ?azhb))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azhg Real)
      (declare-const ?azhh Real)
      (declare-const ?azhi Real)
      (assert
        (and (and (not (= ?azhi ?azhh))
            (not (= ?azhi ?azhg))
            )
          (not (= ?azhh ?azhg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azhj Real)
      (declare-const ?azhk Real)
      (declare-const ?azhl Real)
      (declare-const ?azhm Real)
      (assert
        (and (and (not (= ?azhm ?azhl))
            (not (= ?azhm ?azhk))
            )
          (not (= ?azhl ?azhk))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azhn Real)
      (declare-const ?azho Real)
      (declare-const ?azhp Real)
      (declare-const ?azhq Real)
      (declare-const ?azhr Real)
      (assert
        (and (and (not (= ?azhr ?azhq))
            (not (= ?azhr ?azhp))
            )
          (not (= ?azhq ?azhp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azhs Real)
      (declare-const ?azht Real)
      (declare-const ?azhu Real)
      (declare-const ?azhv Real)
      (declare-const ?azhw Real)
      (declare-const ?azhx Real)
      (assert
        (and (and (and (not (= ?azhu ?azht))
              (not (= ?azhu ?azhs))
              )
            (not (= ?azht ?azhs))
            )
          (and (and (not (= ?azhx ?azhw))
              (not (= ?azhx ?azhv))
              )
            (not (= ?azhw ?azhv))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azhy Real)
      (declare-const ?azhz Real)
      (declare-const ?azia Real)
      (assert
        (and (and (not (= ?azia ?azhz))
            (not (= ?azia ?azhy))
            )
          (not (= ?azhz ?azhy))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azib Real)
      (declare-const ?azic Real)
      (declare-const ?azid Real)
      (assert
        (and (and (not (= ?azid ?azic))
            (not (= ?azid ?azib))
            )
          (not (= ?azic ?azib))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?azie Real)
    (push 1)
      (declare-const ?azif Real)
      (declare-const ?azig Real)
      (declare-const ?azih Real)
      (declare-const ?azii Real)
      (declare-const ?azij Real)
      (declare-const ?azik Real)
      (assert
        (and (or (or (= ?azih ?azig)
              (= ?azih ?azif)
              )
            (= ?azig ?azif)
            )
          (or (or (= ?azik ?azij)
              (= ?azik ?azii)
              )
            (= ?azij ?azii)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azil Real)
      (declare-const ?azim Real)
      (declare-const ?azin Real)
      (assert
        (and (and (not (= ?azin ?azim))
            (not (= ?azin ?azil))
            )
          (not (= ?azim ?azil))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azio Real)
      (declare-const ?azip Real)
      (declare-const ?aziq Real)
      (declare-const ?azir Real)
      (assert
        (and (and (not (= ?aziq ?azip))
            (not (= ?aziq ?azio))
            )
          (not (= ?azip ?azio))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azis Real)
      (declare-const ?azit Real)
      (declare-const ?aziu Real)
      (declare-const ?aziv Real)
      (declare-const ?aziw Real)
      (assert
        (and (and (not (= ?aziu ?azit))
            (not (= ?aziu ?azis))
            )
          (not (= ?azit ?azis))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azix Real)
      (declare-const ?aziy Real)
      (declare-const ?aziz Real)
      (assert
        (and (and (not (= ?aziz ?aziy))
            (not (= ?aziz ?azix))
            )
          (not (= ?aziy ?azix))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azja Real)
      (declare-const ?azjb Real)
      (declare-const ?azjc Real)
      (declare-const ?azjd Real)
      (assert
        (and (and (not (= ?azjd ?azjc))
            (not (= ?azjd ?azjb))
            )
          (not (= ?azjc ?azjb))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azje Real)
      (declare-const ?azjf Real)
      (declare-const ?azjg Real)
      (declare-const ?azjh Real)
      (declare-const ?azji Real)
      (assert
        (and (and (not (= ?azji ?azjh))
            (not (= ?azji ?azjg))
            )
          (not (= ?azjh ?azjg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azjj Real)
      (declare-const ?azjk Real)
      (declare-const ?azjl Real)
      (declare-const ?azjm Real)
      (declare-const ?azjn Real)
      (declare-const ?azjo Real)
      (assert
        (and (and (and (not (= ?azjl ?azjk))
              (not (= ?azjl ?azjj))
              )
            (not (= ?azjk ?azjj))
            )
          (and (and (not (= ?azjo ?azjn))
              (not (= ?azjo ?azjm))
              )
            (not (= ?azjn ?azjm))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azjp Real)
      (declare-const ?azjq Real)
      (declare-const ?azjr Real)
      (assert
        (and (and (not (= ?azjr ?azjq))
            (not (= ?azjr ?azjp))
            )
          (not (= ?azjq ?azjp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azjs Real)
      (declare-const ?azjt Real)
      (declare-const ?azju Real)
      (assert
        (and (and (not (= ?azju ?azjt))
            (not (= ?azju ?azjs))
            )
          (not (= ?azjt ?azjs))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?azjv Real)
    (declare-const ?azjw Real)
    (push 1)
      (declare-const ?azjx Real)
      (declare-const ?azjy Real)
      (declare-const ?azjz Real)
      (declare-const ?azka Real)
      (declare-const ?azkb Real)
      (declare-const ?azkc Real)
      (assert
        (and (or (or (= ?azjz ?azjy)
              (= ?azjz ?azjx)
              )
            (= ?azjy ?azjx)
            )
          (or (or (= ?azkc ?azkb)
              (= ?azkc ?azka)
              )
            (= ?azkb ?azka)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azkd Real)
      (declare-const ?azke Real)
      (declare-const ?azkf Real)
      (assert
        (and (and (not (= ?azkf ?azke))
            (not (= ?azkf ?azkd))
            )
          (not (= ?azke ?azkd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azkg Real)
      (declare-const ?azkh Real)
      (declare-const ?azki Real)
      (declare-const ?azkj Real)
      (assert
        (and (and (not (= ?azki ?azkh))
            (not (= ?azki ?azkg))
            )
          (not (= ?azkh ?azkg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azkk Real)
      (declare-const ?azkl Real)
      (declare-const ?azkm Real)
      (declare-const ?azkn Real)
      (declare-const ?azko Real)
      (assert
        (and (and (not (= ?azkm ?azkl))
            (not (= ?azkm ?azkk))
            )
          (not (= ?azkl ?azkk))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azkp Real)
      (declare-const ?azkq Real)
      (declare-const ?azkr Real)
      (assert
        (and (and (not (= ?azkr ?azkq))
            (not (= ?azkr ?azkp))
            )
          (not (= ?azkq ?azkp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azks Real)
      (declare-const ?azkt Real)
      (declare-const ?azku Real)
      (declare-const ?azkv Real)
      (assert
        (and (and (not (= ?azkv ?azku))
            (not (= ?azkv ?azkt))
            )
          (not (= ?azku ?azkt))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azkw Real)
      (declare-const ?azkx Real)
      (declare-const ?azky Real)
      (declare-const ?azkz Real)
      (declare-const ?azla Real)
      (assert
        (and (and (not (= ?azla ?azkz))
            (not (= ?azla ?azky))
            )
          (not (= ?azkz ?azky))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azlb Real)
      (declare-const ?azlc Real)
      (declare-const ?azld Real)
      (declare-const ?azle Real)
      (declare-const ?azlf Real)
      (declare-const ?azlg Real)
      (assert
        (and (and (and (not (= ?azld ?azlc))
              (not (= ?azld ?azlb))
              )
            (not (= ?azlc ?azlb))
            )
          (and (and (not (= ?azlg ?azlf))
              (not (= ?azlg ?azle))
              )
            (not (= ?azlf ?azle))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azlh Real)
      (declare-const ?azli Real)
      (declare-const ?azlj Real)
      (assert
        (and (and (not (= ?azlj ?azli))
            (not (= ?azlj ?azlh))
            )
          (not (= ?azli ?azlh))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azlk Real)
      (declare-const ?azll Real)
      (declare-const ?azlm Real)
      (assert
        (and (and (not (= ?azlm ?azll))
            (not (= ?azlm ?azlk))
            )
          (not (= ?azll ?azlk))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?azln Real)
    (declare-const ?azlo Real)
    (declare-const ?azlp Real)
    (declare-const ?azlq Real)
    (assert
      (and (and (not (= ?azlp ?azlo))
          (not (= ?azlp ?azln))
          )
        (not (= ?azlo ?azln))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?azlr Real)
      (declare-const ?azls Real)
      (declare-const ?azlt Real)
      (declare-const ?azlu Real)
      (declare-const ?azlv Real)
      (declare-const ?azlw Real)
      (assert
        (and (or (or (= ?azlt ?azls)
              (= ?azlt ?azlr)
              )
            (= ?azls ?azlr)
            )
          (or (or (= ?azlw ?azlv)
              (= ?azlw ?azlu)
              )
            (= ?azlv ?azlu)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azlx Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azly Real)
      (declare-const ?azlz Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azma Real)
      (declare-const ?azmb Real)
      (declare-const ?azmc Real)
      (assert
        (and (and (not (= ?azmc ?azmb))
            (not (= ?azmc ?azma))
            )
          (not (= ?azmb ?azma))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azmd Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azme Real)
      (declare-const ?azmf Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azmg Real)
      (declare-const ?azmh Real)
      (declare-const ?azmi Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azmj Real)
      (declare-const ?azmk Real)
      (declare-const ?azml Real)
      (declare-const ?azmm Real)
      (assert
        (and (and (not (= ?azml ?azmk))
            (not (= ?azml ?azmj))
            )
          (not (= ?azmk ?azmj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azmn Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azmo Real)
      (declare-const ?azmp Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azmq Real)
      (declare-const ?azmr Real)
      (declare-const ?azms Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azmt Real)
      (declare-const ?azmu Real)
      (declare-const ?azmv Real)
      (declare-const ?azmw Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azmx Real)
      (declare-const ?azmy Real)
      (declare-const ?azmz Real)
      (declare-const ?azna Real)
      (declare-const ?aznb Real)
      (assert
        (and (and (not (= ?azmz ?azmy))
            (not (= ?azmz ?azmx))
            )
          (not (= ?azmy ?azmx))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aznc Real)
      (declare-const ?aznd Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azne Real)
      (declare-const ?aznf Real)
      (declare-const ?azng Real)
      (assert
        (and (and (not (= ?azng ?aznf))
            (not (= ?azng ?azne))
            )
          (not (= ?aznf ?azne))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aznh Real)
      (declare-const ?azni Real)
      (declare-const ?aznj Real)
      (declare-const ?aznk Real)
      (assert
        (and (and (not (= ?aznk ?aznj))
            (not (= ?aznk ?azni))
            )
          (not (= ?aznj ?azni))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aznl Real)
      (declare-const ?aznm Real)
      (declare-const ?aznn Real)
      (declare-const ?azno Real)
      (declare-const ?aznp Real)
      (assert
        (and (and (not (= ?aznp ?azno))
            (not (= ?aznp ?aznn))
            )
          (not (= ?azno ?aznn))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aznq Real)
      (declare-const ?aznr Real)
      (declare-const ?azns Real)
      (declare-const ?aznt Real)
      (declare-const ?aznu Real)
      (declare-const ?aznv Real)
      (assert
        (and (and (and (not (= ?azns ?aznr))
              (not (= ?azns ?aznq))
              )
            (not (= ?aznr ?aznq))
            )
          (and (and (not (= ?aznv ?aznu))
              (not (= ?aznv ?aznt))
              )
            (not (= ?aznu ?aznt))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aznw Real)
      (declare-const ?aznx Real)
      (declare-const ?azny Real)
      (assert
        (and (and (not (= ?azny ?aznx))
            (not (= ?azny ?aznw))
            )
          (not (= ?aznx ?aznw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aznz Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azoa Real)
      (declare-const ?azob Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azoc Real)
      (declare-const ?azod Real)
      (declare-const ?azoe Real)
      (assert
        (and (and (not (= ?azoe ?azod))
            (not (= ?azoe ?azoc))
            )
          (not (= ?azod ?azoc))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?azof Real)
    (push 1)
      (declare-const ?azog Real)
      (declare-const ?azoh Real)
      (declare-const ?azoi Real)
      (declare-const ?azoj Real)
      (declare-const ?azok Real)
      (declare-const ?azol Real)
      (assert
        (and (or (or (= ?azoi ?azoh)
              (= ?azoi ?azog)
              )
            (= ?azoh ?azog)
            )
          (or (or (= ?azol ?azok)
              (= ?azol ?azoj)
              )
            (= ?azok ?azoj)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azom Real)
      (declare-const ?azon Real)
      (declare-const ?azoo Real)
      (assert
        (and (and (not (= ?azoo ?azon))
            (not (= ?azoo ?azom))
            )
          (not (= ?azon ?azom))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azop Real)
      (declare-const ?azoq Real)
      (declare-const ?azor Real)
      (declare-const ?azos Real)
      (assert
        (and (and (not (= ?azor ?azoq))
            (not (= ?azor ?azop))
            )
          (not (= ?azoq ?azop))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azot Real)
      (declare-const ?azou Real)
      (declare-const ?azov Real)
      (declare-const ?azow Real)
      (declare-const ?azox Real)
      (assert
        (and (and (not (= ?azov ?azou))
            (not (= ?azov ?azot))
            )
          (not (= ?azou ?azot))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azoy Real)
      (declare-const ?azoz Real)
      (declare-const ?azpa Real)
      (assert
        (and (and (not (= ?azpa ?azoz))
            (not (= ?azpa ?azoy))
            )
          (not (= ?azoz ?azoy))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azpb Real)
      (declare-const ?azpc Real)
      (declare-const ?azpd Real)
      (declare-const ?azpe Real)
      (assert
        (and (and (not (= ?azpe ?azpd))
            (not (= ?azpe ?azpc))
            )
          (not (= ?azpd ?azpc))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azpf Real)
      (declare-const ?azpg Real)
      (declare-const ?azph Real)
      (declare-const ?azpi Real)
      (declare-const ?azpj Real)
      (assert
        (and (and (not (= ?azpj ?azpi))
            (not (= ?azpj ?azph))
            )
          (not (= ?azpi ?azph))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azpk Real)
      (declare-const ?azpl Real)
      (declare-const ?azpm Real)
      (declare-const ?azpn Real)
      (declare-const ?azpo Real)
      (declare-const ?azpp Real)
      (assert
        (and (and (and (not (= ?azpm ?azpl))
              (not (= ?azpm ?azpk))
              )
            (not (= ?azpl ?azpk))
            )
          (and (and (not (= ?azpp ?azpo))
              (not (= ?azpp ?azpn))
              )
            (not (= ?azpo ?azpn))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azpq Real)
      (declare-const ?azpr Real)
      (declare-const ?azps Real)
      (assert
        (and (and (not (= ?azps ?azpr))
            (not (= ?azps ?azpq))
            )
          (not (= ?azpr ?azpq))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azpt Real)
      (declare-const ?azpu Real)
      (declare-const ?azpv Real)
      (assert
        (and (and (not (= ?azpv ?azpu))
            (not (= ?azpv ?azpt))
            )
          (not (= ?azpu ?azpt))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?azpw Real)
    (declare-const ?azpx Real)
    (declare-const ?azpy Real)
    (declare-const ?azpz Real)
    (assert
      (forall ((?awmg Real) )(or (and (or (or (= ?azpx ?azpw)
                (= ?azpx ?awmg)
                )
              (= ?azpw ?awmg)
              )
            (or (or (= ?azpz ?azpy)
                (= ?azpz ?awmg)
                )
              (= ?azpy ?awmg)
              )
            )
          (and (not (= ?azpx ?azpw))
            (and (and (not (= ?azpz ?azpy))
                (not (= ?azpz ?awmg))
                )
              (not (= ?azpy ?awmg))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?azqa Real)
      (declare-const ?azqb Real)
      (declare-const ?azqc Real)
      (declare-const ?azqd Real)
      (declare-const ?azqe Real)
      (declare-const ?azqf Real)
      (assert
        (and (or (or (= ?azqc ?azqb)
              (= ?azqc ?azqa)
              )
            (= ?azqb ?azqa)
            )
          (or (or (= ?azqf ?azqe)
              (= ?azqf ?azqd)
              )
            (= ?azqe ?azqd)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azqg Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azqh Real)
      (declare-const ?azqi Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azqj Real)
      (declare-const ?azqk Real)
      (declare-const ?azql Real)
      (assert
        (and (and (not (= ?azql ?azqk))
            (not (= ?azql ?azqj))
            )
          (not (= ?azqk ?azqj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azqm Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azqn Real)
      (declare-const ?azqo Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azqp Real)
      (declare-const ?azqq Real)
      (declare-const ?azqr Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azqs Real)
      (declare-const ?azqt Real)
      (declare-const ?azqu Real)
      (declare-const ?azqv Real)
      (assert
        (and (and (not (= ?azqu ?azqt))
            (not (= ?azqu ?azqs))
            )
          (not (= ?azqt ?azqs))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azqw Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azqx Real)
      (declare-const ?azqy Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azqz Real)
      (declare-const ?azra Real)
      (declare-const ?azrb Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azrc Real)
      (declare-const ?azrd Real)
      (declare-const ?azre Real)
      (declare-const ?azrf Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azrg Real)
      (declare-const ?azrh Real)
      (declare-const ?azri Real)
      (declare-const ?azrj Real)
      (declare-const ?azrk Real)
      (assert
        (and (and (not (= ?azri ?azrh))
            (not (= ?azri ?azrg))
            )
          (not (= ?azrh ?azrg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azrl Real)
      (declare-const ?azrm Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azrn Real)
      (declare-const ?azro Real)
      (declare-const ?azrp Real)
      (assert
        (and (and (not (= ?azrp ?azro))
            (not (= ?azrp ?azrn))
            )
          (not (= ?azro ?azrn))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azrq Real)
      (declare-const ?azrr Real)
      (declare-const ?azrs Real)
      (declare-const ?azrt Real)
      (assert
        (and (and (not (= ?azrt ?azrs))
            (not (= ?azrt ?azrr))
            )
          (not (= ?azrs ?azrr))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azru Real)
      (declare-const ?azrv Real)
      (declare-const ?azrw Real)
      (declare-const ?azrx Real)
      (declare-const ?azry Real)
      (assert
        (and (and (not (= ?azry ?azrx))
            (not (= ?azry ?azrw))
            )
          (not (= ?azrx ?azrw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azrz Real)
      (declare-const ?azsa Real)
      (declare-const ?azsb Real)
      (declare-const ?azsc Real)
      (declare-const ?azsd Real)
      (declare-const ?azse Real)
      (assert
        (and (and (and (not (= ?azsb ?azsa))
              (not (= ?azsb ?azrz))
              )
            (not (= ?azsa ?azrz))
            )
          (and (and (not (= ?azse ?azsd))
              (not (= ?azse ?azsc))
              )
            (not (= ?azsd ?azsc))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azsf Real)
      (declare-const ?azsg Real)
      (declare-const ?azsh Real)
      (assert
        (and (and (not (= ?azsh ?azsg))
            (not (= ?azsh ?azsf))
            )
          (not (= ?azsg ?azsf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azsi Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azsj Real)
      (declare-const ?azsk Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azsl Real)
      (declare-const ?azsm Real)
      (declare-const ?azsn Real)
      (assert
        (and (and (not (= ?azsn ?azsm))
            (not (= ?azsn ?azsl))
            )
          (not (= ?azsm ?azsl))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?azso Real)
    (declare-const ?azsp Real)
    (declare-const ?azsq Real)
    (assert
      (and (and (not (= ?azsq ?azsp))
          (not (= ?azsq ?azso))
          )
        (not (= ?azsp ?azso))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?azsr Real)
      (declare-const ?azss Real)
      (declare-const ?azst Real)
      (declare-const ?azsu Real)
      (declare-const ?azsv Real)
      (declare-const ?azsw Real)
      (assert
        (and (or (or (= ?azst ?azss)
              (= ?azst ?azsr)
              )
            (= ?azss ?azsr)
            )
          (or (or (= ?azsw ?azsv)
              (= ?azsw ?azsu)
              )
            (= ?azsv ?azsu)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azsx Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azsy Real)
      (declare-const ?azsz Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azta Real)
      (declare-const ?aztb Real)
      (declare-const ?aztc Real)
      (assert
        (and (and (not (= ?aztc ?aztb))
            (not (= ?aztc ?azta))
            )
          (not (= ?aztb ?azta))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aztd Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azte Real)
      (declare-const ?aztf Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aztg Real)
      (declare-const ?azth Real)
      (declare-const ?azti Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aztj Real)
      (declare-const ?aztk Real)
      (declare-const ?aztl Real)
      (declare-const ?aztm Real)
      (assert
        (and (and (not (= ?aztl ?aztk))
            (not (= ?aztl ?aztj))
            )
          (not (= ?aztk ?aztj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aztn Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azto Real)
      (declare-const ?aztp Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aztq Real)
      (declare-const ?aztr Real)
      (declare-const ?azts Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aztt Real)
      (declare-const ?aztu Real)
      (declare-const ?aztv Real)
      (declare-const ?aztw Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?aztx Real)
      (declare-const ?azty Real)
      (declare-const ?aztz Real)
      (declare-const ?azua Real)
      (declare-const ?azub Real)
      (assert
        (and (and (not (= ?aztz ?azty))
            (not (= ?aztz ?aztx))
            )
          (not (= ?azty ?aztx))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azuc Real)
      (declare-const ?azud Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azue Real)
      (declare-const ?azuf Real)
      (declare-const ?azug Real)
      (assert
        (and (and (not (= ?azug ?azuf))
            (not (= ?azug ?azue))
            )
          (not (= ?azuf ?azue))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azuh Real)
      (declare-const ?azui Real)
      (declare-const ?azuj Real)
      (declare-const ?azuk Real)
      (assert
        (and (and (not (= ?azuk ?azuj))
            (not (= ?azuk ?azui))
            )
          (not (= ?azuj ?azui))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azul Real)
      (declare-const ?azum Real)
      (declare-const ?azun Real)
      (declare-const ?azuo Real)
      (declare-const ?azup Real)
      (assert
        (and (and (not (= ?azup ?azuo))
            (not (= ?azup ?azun))
            )
          (not (= ?azuo ?azun))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azuq Real)
      (declare-const ?azur Real)
      (declare-const ?azus Real)
      (declare-const ?azut Real)
      (declare-const ?azuu Real)
      (declare-const ?azuv Real)
      (assert
        (and (and (and (not (= ?azus ?azur))
              (not (= ?azus ?azuq))
              )
            (not (= ?azur ?azuq))
            )
          (and (and (not (= ?azuv ?azuu))
              (not (= ?azuv ?azut))
              )
            (not (= ?azuu ?azut))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azuw Real)
      (declare-const ?azux Real)
      (declare-const ?azuy Real)
      (assert
        (and (and (not (= ?azuy ?azux))
            (not (= ?azuy ?azuw))
            )
          (not (= ?azux ?azuw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azuz Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azva Real)
      (declare-const ?azvb Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azvc Real)
      (declare-const ?azvd Real)
      (declare-const ?azve Real)
      (assert
        (and (and (not (= ?azve ?azvd))
            (not (= ?azve ?azvc))
            )
          (not (= ?azvd ?azvc))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?azvf Real)
    (declare-const ?azvg Real)
    (declare-const ?azvh Real)
    (declare-const ?azvi Real)
    (assert
      (and (and (not (= ?azvi ?azvh))
          (not (= ?azvi ?azvg))
          )
        (not (= ?azvh ?azvg))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?azvj Real)
      (declare-const ?azvk Real)
      (declare-const ?azvl Real)
      (declare-const ?azvm Real)
      (declare-const ?azvn Real)
      (declare-const ?azvo Real)
      (assert
        (and (or (or (= ?azvl ?azvk)
              (= ?azvl ?azvj)
              )
            (= ?azvk ?azvj)
            )
          (or (or (= ?azvo ?azvn)
              (= ?azvo ?azvm)
              )
            (= ?azvn ?azvm)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azvp Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azvq Real)
      (declare-const ?azvr Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azvs Real)
      (declare-const ?azvt Real)
      (declare-const ?azvu Real)
      (assert
        (and (and (not (= ?azvu ?azvt))
            (not (= ?azvu ?azvs))
            )
          (not (= ?azvt ?azvs))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azvv Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azvw Real)
      (declare-const ?azvx Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azvy Real)
      (declare-const ?azvz Real)
      (declare-const ?azwa Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azwb Real)
      (declare-const ?azwc Real)
      (declare-const ?azwd Real)
      (declare-const ?azwe Real)
      (assert
        (and (and (not (= ?azwd ?azwc))
            (not (= ?azwd ?azwb))
            )
          (not (= ?azwc ?azwb))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azwf Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azwg Real)
      (declare-const ?azwh Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azwi Real)
      (declare-const ?azwj Real)
      (declare-const ?azwk Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azwl Real)
      (declare-const ?azwm Real)
      (declare-const ?azwn Real)
      (declare-const ?azwo Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azwp Real)
      (declare-const ?azwq Real)
      (declare-const ?azwr Real)
      (declare-const ?azws Real)
      (declare-const ?azwt Real)
      (assert
        (and (and (not (= ?azwr ?azwq))
            (not (= ?azwr ?azwp))
            )
          (not (= ?azwq ?azwp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azwu Real)
      (declare-const ?azwv Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azww Real)
      (declare-const ?azwx Real)
      (declare-const ?azwy Real)
      (assert
        (and (and (not (= ?azwy ?azwx))
            (not (= ?azwy ?azww))
            )
          (not (= ?azwx ?azww))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azwz Real)
      (declare-const ?azxa Real)
      (declare-const ?azxb Real)
      (declare-const ?azxc Real)
      (assert
        (and (and (not (= ?azxc ?azxb))
            (not (= ?azxc ?azxa))
            )
          (not (= ?azxb ?azxa))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azxd Real)
      (declare-const ?azxe Real)
      (declare-const ?azxf Real)
      (declare-const ?azxg Real)
      (declare-const ?azxh Real)
      (assert
        (and (and (not (= ?azxh ?azxg))
            (not (= ?azxh ?azxf))
            )
          (not (= ?azxg ?azxf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azxi Real)
      (declare-const ?azxj Real)
      (declare-const ?azxk Real)
      (declare-const ?azxl Real)
      (declare-const ?azxm Real)
      (declare-const ?azxn Real)
      (assert
        (and (and (and (not (= ?azxk ?azxj))
              (not (= ?azxk ?azxi))
              )
            (not (= ?azxj ?azxi))
            )
          (and (and (not (= ?azxn ?azxm))
              (not (= ?azxn ?azxl))
              )
            (not (= ?azxm ?azxl))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azxo Real)
      (declare-const ?azxp Real)
      (declare-const ?azxq Real)
      (assert
        (and (and (not (= ?azxq ?azxp))
            (not (= ?azxq ?azxo))
            )
          (not (= ?azxp ?azxo))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azxr Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azxs Real)
      (declare-const ?azxt Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azxu Real)
      (declare-const ?azxv Real)
      (declare-const ?azxw Real)
      (assert
        (and (and (not (= ?azxw ?azxv))
            (not (= ?azxw ?azxu))
            )
          (not (= ?azxv ?azxu))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?azxx Real)
    (declare-const ?azxy Real)
    (declare-const ?azxz Real)
    (declare-const ?azya Real)
    (declare-const ?azyb Real)
    (declare-const ?azyc Real)
    (assert
      (or (and (or (or (= ?azxz ?azxy)
              (= ?azxz ?azxx)
              )
            (= ?azxy ?azxx)
            )
          (or (or (= ?azyc ?azyb)
              (= ?azyc ?azya)
              )
            (= ?azyb ?azya)
            )
          )
        (and (and (and (not (= ?azxz ?azxy))
              (not (= ?azxz ?azxx))
              )
            (not (= ?azxy ?azxx))
            )
          (and (and (not (= ?azyc ?azyb))
              (not (= ?azyc ?azya))
              )
            (not (= ?azyb ?azya))
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?azyd Real)
      (declare-const ?azye Real)
      (declare-const ?azyf Real)
      (declare-const ?azyg Real)
      (declare-const ?azyh Real)
      (declare-const ?azyi Real)
      (assert
        (and (or (or (= ?azyf ?azye)
              (= ?azyf ?azyd)
              )
            (= ?azye ?azyd)
            )
          (or (or (= ?azyi ?azyh)
              (= ?azyi ?azyg)
              )
            (= ?azyh ?azyg)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azyj Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azyk Real)
      (declare-const ?azyl Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azym Real)
      (declare-const ?azyn Real)
      (declare-const ?azyo Real)
      (assert
        (and (and (not (= ?azyo ?azyn))
            (not (= ?azyo ?azym))
            )
          (not (= ?azyn ?azym))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azyp Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azyq Real)
      (declare-const ?azyr Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azys Real)
      (declare-const ?azyt Real)
      (declare-const ?azyu Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azyv Real)
      (declare-const ?azyw Real)
      (declare-const ?azyx Real)
      (declare-const ?azyy Real)
      (assert
        (and (and (not (= ?azyx ?azyw))
            (not (= ?azyx ?azyv))
            )
          (not (= ?azyw ?azyv))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azyz Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azza Real)
      (declare-const ?azzb Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azzc Real)
      (declare-const ?azzd Real)
      (declare-const ?azze Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azzf Real)
      (declare-const ?azzg Real)
      (declare-const ?azzh Real)
      (declare-const ?azzi Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azzj Real)
      (declare-const ?azzk Real)
      (declare-const ?azzl Real)
      (declare-const ?azzm Real)
      (declare-const ?azzn Real)
      (assert
        (and (and (not (= ?azzl ?azzk))
            (not (= ?azzl ?azzj))
            )
          (not (= ?azzk ?azzj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azzo Real)
      (declare-const ?azzp Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azzq Real)
      (declare-const ?azzr Real)
      (declare-const ?azzs Real)
      (assert
        (and (and (not (= ?azzs ?azzr))
            (not (= ?azzs ?azzq))
            )
          (not (= ?azzr ?azzq))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azzt Real)
      (declare-const ?azzu Real)
      (declare-const ?azzv Real)
      (declare-const ?azzw Real)
      (assert
        (and (and (not (= ?azzw ?azzv))
            (not (= ?azzw ?azzu))
            )
          (not (= ?azzv ?azzu))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?azzx Real)
      (declare-const ?azzy Real)
      (declare-const ?azzz Real)
      (declare-const ?baaa Real)
      (declare-const ?baab Real)
      (assert
        (and (and (not (= ?baab ?baaa))
            (not (= ?baab ?azzz))
            )
          (not (= ?baaa ?azzz))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baac Real)
      (declare-const ?baad Real)
      (declare-const ?baae Real)
      (declare-const ?baaf Real)
      (declare-const ?baag Real)
      (declare-const ?baah Real)
      (assert
        (and (and (and (not (= ?baae ?baad))
              (not (= ?baae ?baac))
              )
            (not (= ?baad ?baac))
            )
          (and (and (not (= ?baah ?baag))
              (not (= ?baah ?baaf))
              )
            (not (= ?baag ?baaf))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baai Real)
      (declare-const ?baaj Real)
      (declare-const ?baak Real)
      (assert
        (and (and (not (= ?baak ?baaj))
            (not (= ?baak ?baai))
            )
          (not (= ?baaj ?baai))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baal Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baam Real)
      (declare-const ?baan Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baao Real)
      (declare-const ?baap Real)
      (declare-const ?baaq Real)
      (assert
        (and (and (not (= ?baaq ?baap))
            (not (= ?baaq ?baao))
            )
          (not (= ?baap ?baao))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?baar Real)
    (declare-const ?baas Real)
    (declare-const ?baat Real)
    (assert
      (and (and (not (= ?baat ?baas))
          (not (= ?baat ?baar))
          )
        (not (= ?baas ?baar))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?baau Real)
      (declare-const ?baav Real)
      (declare-const ?baaw Real)
      (declare-const ?baax Real)
      (declare-const ?baay Real)
      (declare-const ?baaz Real)
      (assert
        (and (or (or (= ?baaw ?baav)
              (= ?baaw ?baau)
              )
            (= ?baav ?baau)
            )
          (or (or (= ?baaz ?baay)
              (= ?baaz ?baax)
              )
            (= ?baay ?baax)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baba Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?babb Real)
      (declare-const ?babc Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?babd Real)
      (declare-const ?babe Real)
      (declare-const ?babf Real)
      (assert
        (and (and (not (= ?babf ?babe))
            (not (= ?babf ?babd))
            )
          (not (= ?babe ?babd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?babg Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?babh Real)
      (declare-const ?babi Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?babj Real)
      (declare-const ?babk Real)
      (declare-const ?babl Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?babm Real)
      (declare-const ?babn Real)
      (declare-const ?babo Real)
      (declare-const ?babp Real)
      (assert
        (and (and (not (= ?babo ?babn))
            (not (= ?babo ?babm))
            )
          (not (= ?babn ?babm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?babq Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?babr Real)
      (declare-const ?babs Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?babt Real)
      (declare-const ?babu Real)
      (declare-const ?babv Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?babw Real)
      (declare-const ?babx Real)
      (declare-const ?baby Real)
      (declare-const ?babz Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baca Real)
      (declare-const ?bacb Real)
      (declare-const ?bacc Real)
      (declare-const ?bacd Real)
      (declare-const ?bace Real)
      (assert
        (and (and (not (= ?bacc ?bacb))
            (not (= ?bacc ?baca))
            )
          (not (= ?bacb ?baca))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bacf Real)
      (declare-const ?bacg Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bach Real)
      (declare-const ?baci Real)
      (declare-const ?bacj Real)
      (assert
        (and (and (not (= ?bacj ?baci))
            (not (= ?bacj ?bach))
            )
          (not (= ?baci ?bach))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?back Real)
      (declare-const ?bacl Real)
      (declare-const ?bacm Real)
      (declare-const ?bacn Real)
      (assert
        (and (and (not (= ?bacn ?bacm))
            (not (= ?bacn ?bacl))
            )
          (not (= ?bacm ?bacl))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baco Real)
      (declare-const ?bacp Real)
      (declare-const ?bacq Real)
      (declare-const ?bacr Real)
      (declare-const ?bacs Real)
      (assert
        (and (and (not (= ?bacs ?bacr))
            (not (= ?bacs ?bacq))
            )
          (not (= ?bacr ?bacq))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bact Real)
      (declare-const ?bacu Real)
      (declare-const ?bacv Real)
      (declare-const ?bacw Real)
      (declare-const ?bacx Real)
      (declare-const ?bacy Real)
      (assert
        (and (and (and (not (= ?bacv ?bacu))
              (not (= ?bacv ?bact))
              )
            (not (= ?bacu ?bact))
            )
          (and (and (not (= ?bacy ?bacx))
              (not (= ?bacy ?bacw))
              )
            (not (= ?bacx ?bacw))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bacz Real)
      (declare-const ?bada Real)
      (declare-const ?badb Real)
      (assert
        (and (and (not (= ?badb ?bada))
            (not (= ?badb ?bacz))
            )
          (not (= ?bada ?bacz))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?badc Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?badd Real)
      (declare-const ?bade Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?badf Real)
      (declare-const ?badg Real)
      (declare-const ?badh Real)
      (assert
        (and (and (not (= ?badh ?badg))
            (not (= ?badh ?badf))
            )
          (not (= ?badg ?badf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?badi Real)
      (declare-const ?badj Real)
      (declare-const ?badk Real)
      (declare-const ?badl Real)
      (declare-const ?badm Real)
      (declare-const ?badn Real)
      (assert
        (and (or (or (= ?badk ?badj)
              (= ?badk ?badi)
              )
            (= ?badj ?badi)
            )
          (or (or (= ?badn ?badm)
              (= ?badn ?badl)
              )
            (= ?badm ?badl)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bado Real)
      (declare-const ?badp Real)
      (declare-const ?badq Real)
      (assert
        (and (and (not (= ?badq ?badp))
            (not (= ?badq ?bado))
            )
          (not (= ?badp ?bado))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?badr Real)
      (declare-const ?bads Real)
      (declare-const ?badt Real)
      (declare-const ?badu Real)
      (assert
        (and (and (not (= ?badt ?bads))
            (not (= ?badt ?badr))
            )
          (not (= ?bads ?badr))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?badv Real)
      (declare-const ?badw Real)
      (declare-const ?badx Real)
      (declare-const ?bady Real)
      (declare-const ?badz Real)
      (assert
        (and (and (not (= ?badx ?badw))
            (not (= ?badx ?badv))
            )
          (not (= ?badw ?badv))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baea Real)
      (declare-const ?baeb Real)
      (declare-const ?baec Real)
      (assert
        (and (and (not (= ?baec ?baeb))
            (not (= ?baec ?baea))
            )
          (not (= ?baeb ?baea))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baed Real)
      (declare-const ?baee Real)
      (declare-const ?baef Real)
      (declare-const ?baeg Real)
      (assert
        (and (and (not (= ?baeg ?baef))
            (not (= ?baeg ?baee))
            )
          (not (= ?baef ?baee))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baeh Real)
      (declare-const ?baei Real)
      (declare-const ?baej Real)
      (declare-const ?baek Real)
      (declare-const ?bael Real)
      (assert
        (and (and (not (= ?bael ?baek))
            (not (= ?bael ?baej))
            )
          (not (= ?baek ?baej))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baem Real)
      (declare-const ?baen Real)
      (declare-const ?baeo Real)
      (declare-const ?baep Real)
      (declare-const ?baeq Real)
      (declare-const ?baer Real)
      (assert
        (and (and (and (not (= ?baeo ?baen))
              (not (= ?baeo ?baem))
              )
            (not (= ?baen ?baem))
            )
          (and (and (not (= ?baer ?baeq))
              (not (= ?baer ?baep))
              )
            (not (= ?baeq ?baep))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baes Real)
      (declare-const ?baet Real)
      (declare-const ?baeu Real)
      (assert
        (and (and (not (= ?baeu ?baet))
            (not (= ?baeu ?baes))
            )
          (not (= ?baet ?baes))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baev Real)
      (declare-const ?baew Real)
      (declare-const ?baex Real)
      (assert
        (and (and (not (= ?baex ?baew))
            (not (= ?baex ?baev))
            )
          (not (= ?baew ?baev))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?baey Real)
    (push 1)
      (declare-const ?baez Real)
      (declare-const ?bafa Real)
      (declare-const ?bafb Real)
      (declare-const ?bafc Real)
      (declare-const ?bafd Real)
      (declare-const ?bafe Real)
      (assert
        (and (or (or (= ?bafb ?bafa)
              (= ?bafb ?baez)
              )
            (= ?bafa ?baez)
            )
          (or (or (= ?bafe ?bafd)
              (= ?bafe ?bafc)
              )
            (= ?bafd ?bafc)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baff Real)
      (declare-const ?bafg Real)
      (declare-const ?bafh Real)
      (assert
        (and (and (not (= ?bafh ?bafg))
            (not (= ?bafh ?baff))
            )
          (not (= ?bafg ?baff))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bafi Real)
      (declare-const ?bafj Real)
      (declare-const ?bafk Real)
      (declare-const ?bafl Real)
      (assert
        (and (and (not (= ?bafk ?bafj))
            (not (= ?bafk ?bafi))
            )
          (not (= ?bafj ?bafi))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bafm Real)
      (declare-const ?bafn Real)
      (declare-const ?bafo Real)
      (declare-const ?bafp Real)
      (declare-const ?bafq Real)
      (assert
        (and (and (not (= ?bafo ?bafn))
            (not (= ?bafo ?bafm))
            )
          (not (= ?bafn ?bafm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bafr Real)
      (declare-const ?bafs Real)
      (declare-const ?baft Real)
      (assert
        (and (and (not (= ?baft ?bafs))
            (not (= ?baft ?bafr))
            )
          (not (= ?bafs ?bafr))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bafu Real)
      (declare-const ?bafv Real)
      (declare-const ?bafw Real)
      (declare-const ?bafx Real)
      (assert
        (and (and (not (= ?bafx ?bafw))
            (not (= ?bafx ?bafv))
            )
          (not (= ?bafw ?bafv))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bafy Real)
      (declare-const ?bafz Real)
      (declare-const ?baga Real)
      (declare-const ?bagb Real)
      (declare-const ?bagc Real)
      (assert
        (and (and (not (= ?bagc ?bagb))
            (not (= ?bagc ?baga))
            )
          (not (= ?bagb ?baga))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bagd Real)
      (declare-const ?bage Real)
      (declare-const ?bagf Real)
      (declare-const ?bagg Real)
      (declare-const ?bagh Real)
      (declare-const ?bagi Real)
      (assert
        (and (and (and (not (= ?bagf ?bage))
              (not (= ?bagf ?bagd))
              )
            (not (= ?bage ?bagd))
            )
          (and (and (not (= ?bagi ?bagh))
              (not (= ?bagi ?bagg))
              )
            (not (= ?bagh ?bagg))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bagj Real)
      (declare-const ?bagk Real)
      (declare-const ?bagl Real)
      (assert
        (and (and (not (= ?bagl ?bagk))
            (not (= ?bagl ?bagj))
            )
          (not (= ?bagk ?bagj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bagm Real)
      (declare-const ?bagn Real)
      (declare-const ?bago Real)
      (assert
        (and (and (not (= ?bago ?bagn))
            (not (= ?bago ?bagm))
            )
          (not (= ?bagn ?bagm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bagp Real)
    (declare-const ?bagq Real)
    (declare-const ?bagr Real)
    (assert
      (and (and (not (= ?bagr ?bagq))
          (not (= ?bagr ?bagp))
          )
        (not (= ?bagq ?bagp))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
      (declare-const ?bags Real)
      (declare-const ?bagt Real)
      (declare-const ?bagu Real)
      (declare-const ?bagv Real)
      (declare-const ?bagw Real)
      (declare-const ?bagx Real)
      (assert
        (and (or (or (= ?bagu ?bagt)
              (= ?bagu ?bags)
              )
            (= ?bagt ?bags)
            )
          (or (or (= ?bagx ?bagw)
              (= ?bagx ?bagv)
              )
            (= ?bagw ?bagv)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bagy Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bagz Real)
      (declare-const ?baha Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bahb Real)
      (declare-const ?bahc Real)
      (declare-const ?bahd Real)
      (assert
        (and (and (not (= ?bahd ?bahc))
            (not (= ?bahd ?bahb))
            )
          (not (= ?bahc ?bahb))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bahe Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bahf Real)
      (declare-const ?bahg Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bahh Real)
      (declare-const ?bahi Real)
      (declare-const ?bahj Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bahk Real)
      (declare-const ?bahl Real)
      (declare-const ?bahm Real)
      (declare-const ?bahn Real)
      (assert
        (and (and (not (= ?bahm ?bahl))
            (not (= ?bahm ?bahk))
            )
          (not (= ?bahl ?bahk))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baho Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bahp Real)
      (declare-const ?bahq Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bahr Real)
      (declare-const ?bahs Real)
      (declare-const ?baht Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bahu Real)
      (declare-const ?bahv Real)
      (declare-const ?bahw Real)
      (declare-const ?bahx Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bahy Real)
      (declare-const ?bahz Real)
      (declare-const ?baia Real)
      (declare-const ?baib Real)
      (declare-const ?baic Real)
      (assert
        (and (and (not (= ?baia ?bahz))
            (not (= ?baia ?bahy))
            )
          (not (= ?bahz ?bahy))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baid Real)
      (declare-const ?baie Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baif Real)
      (declare-const ?baig Real)
      (declare-const ?baih Real)
      (assert
        (and (and (not (= ?baih ?baig))
            (not (= ?baih ?baif))
            )
          (not (= ?baig ?baif))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baii Real)
      (declare-const ?baij Real)
      (declare-const ?baik Real)
      (declare-const ?bail Real)
      (assert
        (and (and (not (= ?bail ?baik))
            (not (= ?bail ?baij))
            )
          (not (= ?baik ?baij))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baim Real)
      (declare-const ?bain Real)
      (declare-const ?baio Real)
      (declare-const ?baip Real)
      (declare-const ?baiq Real)
      (assert
        (and (and (not (= ?baiq ?baip))
            (not (= ?baiq ?baio))
            )
          (not (= ?baip ?baio))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bair Real)
      (declare-const ?bais Real)
      (declare-const ?bait Real)
      (declare-const ?baiu Real)
      (declare-const ?baiv Real)
      (declare-const ?baiw Real)
      (assert
        (and (and (and (not (= ?bait ?bais))
              (not (= ?bait ?bair))
              )
            (not (= ?bais ?bair))
            )
          (and (and (not (= ?baiw ?baiv))
              (not (= ?baiw ?baiu))
              )
            (not (= ?baiv ?baiu))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baix Real)
      (declare-const ?baiy Real)
      (declare-const ?baiz Real)
      (assert
        (and (and (not (= ?baiz ?baiy))
            (not (= ?baiz ?baix))
            )
          (not (= ?baiy ?baix))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baja Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bajb Real)
      (declare-const ?bajc Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bajd Real)
      (declare-const ?baje Real)
      (declare-const ?bajf Real)
      (assert
        (and (and (not (= ?bajf ?baje))
            (not (= ?bajf ?bajd))
            )
          (not (= ?baje ?bajd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bajg Real)
      (declare-const ?bajh Real)
      (declare-const ?baji Real)
      (declare-const ?bajj Real)
      (declare-const ?bajk Real)
      (declare-const ?bajl Real)
      (assert
        (and (or (or (= ?baji ?bajh)
              (= ?baji ?bajg)
              )
            (= ?bajh ?bajg)
            )
          (or (or (= ?bajl ?bajk)
              (= ?bajl ?bajj)
              )
            (= ?bajk ?bajj)
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bajm Real)
      (declare-const ?bajn Real)
      (declare-const ?bajo Real)
      (assert
        (and (and (not (= ?bajo ?bajn))
            (not (= ?bajo ?bajm))
            )
          (not (= ?bajn ?bajm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bajp Real)
      (declare-const ?bajq Real)
      (declare-const ?bajr Real)
      (declare-const ?bajs Real)
      (assert
        (and (and (not (= ?bajr ?bajq))
            (not (= ?bajr ?bajp))
            )
          (not (= ?bajq ?bajp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bajt Real)
      (declare-const ?baju Real)
      (declare-const ?bajv Real)
      (declare-const ?bajw Real)
      (declare-const ?bajx Real)
      (assert
        (and (and (not (= ?bajv ?baju))
            (not (= ?bajv ?bajt))
            )
          (not (= ?baju ?bajt))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bajy Real)
      (declare-const ?bajz Real)
      (declare-const ?baka Real)
      (assert
        (and (and (not (= ?baka ?bajz))
            (not (= ?baka ?bajy))
            )
          (not (= ?bajz ?bajy))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bakb Real)
      (declare-const ?bakc Real)
      (declare-const ?bakd Real)
      (declare-const ?bake Real)
      (assert
        (and (and (not (= ?bake ?bakd))
            (not (= ?bake ?bakc))
            )
          (not (= ?bakd ?bakc))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bakf Real)
      (declare-const ?bakg Real)
      (declare-const ?bakh Real)
      (declare-const ?baki Real)
      (declare-const ?bakj Real)
      (assert
        (and (and (not (= ?bakj ?baki))
            (not (= ?bakj ?bakh))
            )
          (not (= ?baki ?bakh))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bakk Real)
      (declare-const ?bakl Real)
      (declare-const ?bakm Real)
      (declare-const ?bakn Real)
      (declare-const ?bako Real)
      (declare-const ?bakp Real)
      (assert
        (and (and (and (not (= ?bakm ?bakl))
              (not (= ?bakm ?bakk))
              )
            (not (= ?bakl ?bakk))
            )
          (and (and (not (= ?bakp ?bako))
              (not (= ?bakp ?bakn))
              )
            (not (= ?bako ?bakn))
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bakq Real)
      (declare-const ?bakr Real)
      (declare-const ?baks Real)
      (assert
        (and (and (not (= ?baks ?bakr))
            (not (= ?baks ?bakq))
            )
          (not (= ?bakr ?bakq))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bakt Real)
      (declare-const ?baku Real)
      (declare-const ?bakv Real)
      (assert
        (and (and (not (= ?bakv ?baku))
            (not (= ?bakv ?bakt))
            )
          (not (= ?baku ?bakt))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bakw Real)
    (declare-const ?bakx Real)
    (declare-const ?baky Real)
    (declare-const ?bakz Real)
    (declare-const ?bala Real)
    (declare-const ?balb Real)
    (assert
      (and (or (or (= ?baky ?bakx)
            (= ?baky ?bakw)
            )
          (= ?bakx ?bakw)
          )
        (or (or (= ?balb ?bala)
            (= ?balb ?bakz)
            )
          (= ?bala ?bakz)
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?balc Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bald Real)
      (declare-const ?bale Real)
      (declare-const ?balf Real)
      (assert
        (and (and (not (= ?balf ?bale))
            (not (= ?balf ?bald))
            )
          (not (= ?bale ?bald))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?balg Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?balh Real)
      (declare-const ?bali Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?balj Real)
      (declare-const ?balk Real)
      (declare-const ?ball Real)
      (declare-const ?balm Real)
      (assert
        (and (and (not (= ?ball ?balk))
            (not (= ?ball ?balj))
            )
          (not (= ?balk ?balj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baln Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?balo Real)
      (declare-const ?balp Real)
      (declare-const ?balq Real)
      (declare-const ?balr Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?balp ?balo)
                  (= ?balp ?awmg)
                  )
                (= ?balo ?awmg)
                )
              (or (or (= ?balr ?balq)
                  (= ?balr ?awmg)
                  )
                (= ?balq ?awmg)
                )
              )
            (and (not (= ?balp ?balo))
              (and (and (not (= ?balr ?balq))
                  (not (= ?balr ?awmg))
                  )
                (not (= ?balq ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bals Real)
      (declare-const ?balt Real)
      (declare-const ?balu Real)
      (assert
        (and (and (not (= ?balu ?balt))
            (not (= ?balu ?bals))
            )
          (not (= ?balt ?bals))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?balv Real)
      (declare-const ?balw Real)
      (declare-const ?balx Real)
      (declare-const ?baly Real)
      (assert
        (and (and (not (= ?baly ?balx))
            (not (= ?baly ?balw))
            )
          (not (= ?balx ?balw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?balz Real)
      (declare-const ?bama Real)
      (declare-const ?bamb Real)
      (declare-const ?bamc Real)
      (declare-const ?bamd Real)
      (declare-const ?bame Real)
      (assert
        (or (and (or (or (= ?bamb ?bama)
                (= ?bamb ?balz)
                )
              (= ?bama ?balz)
              )
            (or (or (= ?bame ?bamd)
                (= ?bame ?bamc)
                )
              (= ?bamd ?bamc)
              )
            )
          (and (and (and (not (= ?bamb ?bama))
                (not (= ?bamb ?balz))
                )
              (not (= ?bama ?balz))
              )
            (and (and (not (= ?bame ?bamd))
                (not (= ?bame ?bamc))
                )
              (not (= ?bamd ?bamc))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bamf Real)
      (declare-const ?bamg Real)
      (declare-const ?bamh Real)
      (assert
        (and (and (not (= ?bamh ?bamg))
            (not (= ?bamh ?bamf))
            )
          (not (= ?bamg ?bamf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bami Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bamj Real)
      (declare-const ?bamk Real)
      (declare-const ?baml Real)
      (assert
        (and (and (not (= ?baml ?bamk))
            (not (= ?baml ?bamj))
            )
          (not (= ?bamk ?bamj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bamm Real)
      (declare-const ?bamn Real)
      (declare-const ?bamo Real)
      (assert
        (and (and (not (= ?bamo ?bamn))
            (not (= ?bamo ?bamm))
            )
          (not (= ?bamn ?bamm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bamp Real)
      (declare-const ?bamq Real)
      (declare-const ?bamr Real)
      (declare-const ?bams Real)
      (assert
        (and (and (not (= ?bamr ?bamq))
            (not (= ?bamr ?bamp))
            )
          (not (= ?bamq ?bamp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bamt Real)
      (declare-const ?bamu Real)
      (declare-const ?bamv Real)
      (declare-const ?bamw Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bamu ?bamt)
                  (= ?bamu ?awmg)
                  )
                (= ?bamt ?awmg)
                )
              (or (or (= ?bamw ?bamv)
                  (= ?bamw ?awmg)
                  )
                (= ?bamv ?awmg)
                )
              )
            (and (not (= ?bamu ?bamt))
              (and (and (not (= ?bamw ?bamv))
                  (not (= ?bamw ?awmg))
                  )
                (not (= ?bamv ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bamx Real)
      (declare-const ?bamy Real)
      (declare-const ?bamz Real)
      (assert
        (and (and (not (= ?bamz ?bamy))
            (not (= ?bamz ?bamx))
            )
          (not (= ?bamy ?bamx))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bana Real)
      (declare-const ?banb Real)
      (declare-const ?banc Real)
      (declare-const ?band Real)
      (assert
        (and (and (not (= ?band ?banc))
            (not (= ?band ?banb))
            )
          (not (= ?banc ?banb))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bane Real)
      (declare-const ?banf Real)
      (declare-const ?bang Real)
      (declare-const ?banh Real)
      (declare-const ?bani Real)
      (declare-const ?banj Real)
      (assert
        (or (and (or (or (= ?bang ?banf)
                (= ?bang ?bane)
                )
              (= ?banf ?bane)
              )
            (or (or (= ?banj ?bani)
                (= ?banj ?banh)
                )
              (= ?bani ?banh)
              )
            )
          (and (and (and (not (= ?bang ?banf))
                (not (= ?bang ?bane))
                )
              (not (= ?banf ?bane))
              )
            (and (and (not (= ?banj ?bani))
                (not (= ?banj ?banh))
                )
              (not (= ?bani ?banh))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bank Real)
      (declare-const ?banl Real)
      (declare-const ?banm Real)
      (assert
        (and (and (not (= ?banm ?banl))
            (not (= ?banm ?bank))
            )
          (not (= ?banl ?bank))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bann Real)
      (declare-const ?bano Real)
      (declare-const ?banp Real)
      (assert
        (and (and (not (= ?banp ?bano))
            (not (= ?banp ?bann))
            )
          (not (= ?bano ?bann))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?banq Real)
    (push 1)
      (declare-const ?banr Real)
      (declare-const ?bans Real)
      (declare-const ?bant Real)
      (assert
        (and (and (not (= ?bant ?bans))
            (not (= ?bant ?banr))
            )
          (not (= ?bans ?banr))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?banu Real)
      (declare-const ?banv Real)
      (declare-const ?banw Real)
      (declare-const ?banx Real)
      (assert
        (and (and (not (= ?banw ?banv))
            (not (= ?banw ?banu))
            )
          (not (= ?banv ?banu))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bany Real)
      (declare-const ?banz Real)
      (declare-const ?baoa Real)
      (declare-const ?baob Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?banz ?bany)
                  (= ?banz ?awmg)
                  )
                (= ?bany ?awmg)
                )
              (or (or (= ?baob ?baoa)
                  (= ?baob ?awmg)
                  )
                (= ?baoa ?awmg)
                )
              )
            (and (not (= ?banz ?bany))
              (and (and (not (= ?baob ?baoa))
                  (not (= ?baob ?awmg))
                  )
                (not (= ?baoa ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baoc Real)
      (declare-const ?baod Real)
      (declare-const ?baoe Real)
      (assert
        (and (and (not (= ?baoe ?baod))
            (not (= ?baoe ?baoc))
            )
          (not (= ?baod ?baoc))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baof Real)
      (declare-const ?baog Real)
      (declare-const ?baoh Real)
      (declare-const ?baoi Real)
      (assert
        (and (and (not (= ?baoi ?baoh))
            (not (= ?baoi ?baog))
            )
          (not (= ?baoh ?baog))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baoj Real)
      (declare-const ?baok Real)
      (declare-const ?baol Real)
      (declare-const ?baom Real)
      (declare-const ?baon Real)
      (declare-const ?baoo Real)
      (assert
        (or (and (or (or (= ?baol ?baok)
                (= ?baol ?baoj)
                )
              (= ?baok ?baoj)
              )
            (or (or (= ?baoo ?baon)
                (= ?baoo ?baom)
                )
              (= ?baon ?baom)
              )
            )
          (and (and (and (not (= ?baol ?baok))
                (not (= ?baol ?baoj))
                )
              (not (= ?baok ?baoj))
              )
            (and (and (not (= ?baoo ?baon))
                (not (= ?baoo ?baom))
                )
              (not (= ?baon ?baom))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baop Real)
      (declare-const ?baoq Real)
      (declare-const ?baor Real)
      (assert
        (and (and (not (= ?baor ?baoq))
            (not (= ?baor ?baop))
            )
          (not (= ?baoq ?baop))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baos Real)
      (declare-const ?baot Real)
      (declare-const ?baou Real)
      (assert
        (and (and (not (= ?baou ?baot))
            (not (= ?baou ?baos))
            )
          (not (= ?baot ?baos))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?baov Real)
    (declare-const ?baow Real)
    (push 1)
      (declare-const ?baox Real)
      (declare-const ?baoy Real)
      (declare-const ?baoz Real)
      (assert
        (and (and (not (= ?baoz ?baoy))
            (not (= ?baoz ?baox))
            )
          (not (= ?baoy ?baox))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bapa Real)
      (declare-const ?bapb Real)
      (declare-const ?bapc Real)
      (declare-const ?bapd Real)
      (assert
        (and (and (not (= ?bapc ?bapb))
            (not (= ?bapc ?bapa))
            )
          (not (= ?bapb ?bapa))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bape Real)
      (declare-const ?bapf Real)
      (declare-const ?bapg Real)
      (declare-const ?baph Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bapf ?bape)
                  (= ?bapf ?awmg)
                  )
                (= ?bape ?awmg)
                )
              (or (or (= ?baph ?bapg)
                  (= ?baph ?awmg)
                  )
                (= ?bapg ?awmg)
                )
              )
            (and (not (= ?bapf ?bape))
              (and (and (not (= ?baph ?bapg))
                  (not (= ?baph ?awmg))
                  )
                (not (= ?bapg ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bapi Real)
      (declare-const ?bapj Real)
      (declare-const ?bapk Real)
      (assert
        (and (and (not (= ?bapk ?bapj))
            (not (= ?bapk ?bapi))
            )
          (not (= ?bapj ?bapi))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bapl Real)
      (declare-const ?bapm Real)
      (declare-const ?bapn Real)
      (declare-const ?bapo Real)
      (assert
        (and (and (not (= ?bapo ?bapn))
            (not (= ?bapo ?bapm))
            )
          (not (= ?bapn ?bapm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bapp Real)
      (declare-const ?bapq Real)
      (declare-const ?bapr Real)
      (declare-const ?baps Real)
      (declare-const ?bapt Real)
      (declare-const ?bapu Real)
      (assert
        (or (and (or (or (= ?bapr ?bapq)
                (= ?bapr ?bapp)
                )
              (= ?bapq ?bapp)
              )
            (or (or (= ?bapu ?bapt)
                (= ?bapu ?baps)
                )
              (= ?bapt ?baps)
              )
            )
          (and (and (and (not (= ?bapr ?bapq))
                (not (= ?bapr ?bapp))
                )
              (not (= ?bapq ?bapp))
              )
            (and (and (not (= ?bapu ?bapt))
                (not (= ?bapu ?baps))
                )
              (not (= ?bapt ?baps))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bapv Real)
      (declare-const ?bapw Real)
      (declare-const ?bapx Real)
      (assert
        (and (and (not (= ?bapx ?bapw))
            (not (= ?bapx ?bapv))
            )
          (not (= ?bapw ?bapv))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bapy Real)
      (declare-const ?bapz Real)
      (declare-const ?baqa Real)
      (assert
        (and (and (not (= ?baqa ?bapz))
            (not (= ?baqa ?bapy))
            )
          (not (= ?bapz ?bapy))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?baqb Real)
    (declare-const ?baqc Real)
    (declare-const ?baqd Real)
    (assert
      (and (and (not (= ?baqd ?baqc))
          (not (= ?baqd ?baqb))
          )
        (not (= ?baqc ?baqb))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baqe Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baqf Real)
      (declare-const ?baqg Real)
      (declare-const ?baqh Real)
      (assert
        (and (and (not (= ?baqh ?baqg))
            (not (= ?baqh ?baqf))
            )
          (not (= ?baqg ?baqf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baqi Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baqj Real)
      (declare-const ?baqk Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baql Real)
      (declare-const ?baqm Real)
      (declare-const ?baqn Real)
      (declare-const ?baqo Real)
      (assert
        (and (and (not (= ?baqn ?baqm))
            (not (= ?baqn ?baql))
            )
          (not (= ?baqm ?baql))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baqp Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baqq Real)
      (declare-const ?baqr Real)
      (declare-const ?baqs Real)
      (declare-const ?baqt Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?baqr ?baqq)
                  (= ?baqr ?awmg)
                  )
                (= ?baqq ?awmg)
                )
              (or (or (= ?baqt ?baqs)
                  (= ?baqt ?awmg)
                  )
                (= ?baqs ?awmg)
                )
              )
            (and (not (= ?baqr ?baqq))
              (and (and (not (= ?baqt ?baqs))
                  (not (= ?baqt ?awmg))
                  )
                (not (= ?baqs ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baqu Real)
      (declare-const ?baqv Real)
      (declare-const ?baqw Real)
      (assert
        (and (and (not (= ?baqw ?baqv))
            (not (= ?baqw ?baqu))
            )
          (not (= ?baqv ?baqu))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baqx Real)
      (declare-const ?baqy Real)
      (declare-const ?baqz Real)
      (declare-const ?bara Real)
      (assert
        (and (and (not (= ?bara ?baqz))
            (not (= ?bara ?baqy))
            )
          (not (= ?baqz ?baqy))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?barb Real)
      (declare-const ?barc Real)
      (declare-const ?bard Real)
      (declare-const ?bare Real)
      (declare-const ?barf Real)
      (declare-const ?barg Real)
      (assert
        (or (and (or (or (= ?bard ?barc)
                (= ?bard ?barb)
                )
              (= ?barc ?barb)
              )
            (or (or (= ?barg ?barf)
                (= ?barg ?bare)
                )
              (= ?barf ?bare)
              )
            )
          (and (and (and (not (= ?bard ?barc))
                (not (= ?bard ?barb))
                )
              (not (= ?barc ?barb))
              )
            (and (and (not (= ?barg ?barf))
                (not (= ?barg ?bare))
                )
              (not (= ?barf ?bare))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?barh Real)
      (declare-const ?bari Real)
      (declare-const ?barj Real)
      (assert
        (and (and (not (= ?barj ?bari))
            (not (= ?barj ?barh))
            )
          (not (= ?bari ?barh))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bark Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?barl Real)
      (declare-const ?barm Real)
      (declare-const ?barn Real)
      (assert
        (and (and (not (= ?barn ?barm))
            (not (= ?barn ?barl))
            )
          (not (= ?barm ?barl))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?baro Real)
      (declare-const ?barp Real)
      (declare-const ?barq Real)
      (assert
        (and (and (not (= ?barq ?barp))
            (not (= ?barq ?baro))
            )
          (not (= ?barp ?baro))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?barr Real)
      (declare-const ?bars Real)
      (declare-const ?bart Real)
      (declare-const ?baru Real)
      (assert
        (and (and (not (= ?bart ?bars))
            (not (= ?bart ?barr))
            )
          (not (= ?bars ?barr))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?barv Real)
      (declare-const ?barw Real)
      (declare-const ?barx Real)
      (declare-const ?bary Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?barw ?barv)
                  (= ?barw ?awmg)
                  )
                (= ?barv ?awmg)
                )
              (or (or (= ?bary ?barx)
                  (= ?bary ?awmg)
                  )
                (= ?barx ?awmg)
                )
              )
            (and (not (= ?barw ?barv))
              (and (and (not (= ?bary ?barx))
                  (not (= ?bary ?awmg))
                  )
                (not (= ?barx ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?barz Real)
      (declare-const ?basa Real)
      (declare-const ?basb Real)
      (assert
        (and (and (not (= ?basb ?basa))
            (not (= ?basb ?barz))
            )
          (not (= ?basa ?barz))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?basc Real)
      (declare-const ?basd Real)
      (declare-const ?base Real)
      (declare-const ?basf Real)
      (assert
        (and (and (not (= ?basf ?base))
            (not (= ?basf ?basd))
            )
          (not (= ?base ?basd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?basg Real)
      (declare-const ?bash Real)
      (declare-const ?basi Real)
      (declare-const ?basj Real)
      (declare-const ?bask Real)
      (declare-const ?basl Real)
      (assert
        (or (and (or (or (= ?basi ?bash)
                (= ?basi ?basg)
                )
              (= ?bash ?basg)
              )
            (or (or (= ?basl ?bask)
                (= ?basl ?basj)
                )
              (= ?bask ?basj)
              )
            )
          (and (and (and (not (= ?basi ?bash))
                (not (= ?basi ?basg))
                )
              (not (= ?bash ?basg))
              )
            (and (and (not (= ?basl ?bask))
                (not (= ?basl ?basj))
                )
              (not (= ?bask ?basj))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?basm Real)
      (declare-const ?basn Real)
      (declare-const ?baso Real)
      (assert
        (and (and (not (= ?baso ?basn))
            (not (= ?baso ?basm))
            )
          (not (= ?basn ?basm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?basp Real)
      (declare-const ?basq Real)
      (declare-const ?basr Real)
      (assert
        (and (and (not (= ?basr ?basq))
            (not (= ?basr ?basp))
            )
          (not (= ?basq ?basp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bass Real)
    (push 1)
      (declare-const ?bast Real)
      (declare-const ?basu Real)
      (declare-const ?basv Real)
      (assert
        (and (and (not (= ?basv ?basu))
            (not (= ?basv ?bast))
            )
          (not (= ?basu ?bast))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?basw Real)
      (declare-const ?basx Real)
      (declare-const ?basy Real)
      (declare-const ?basz Real)
      (assert
        (and (and (not (= ?basy ?basx))
            (not (= ?basy ?basw))
            )
          (not (= ?basx ?basw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bata Real)
      (declare-const ?batb Real)
      (declare-const ?batc Real)
      (declare-const ?batd Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?batb ?bata)
                  (= ?batb ?awmg)
                  )
                (= ?bata ?awmg)
                )
              (or (or (= ?batd ?batc)
                  (= ?batd ?awmg)
                  )
                (= ?batc ?awmg)
                )
              )
            (and (not (= ?batb ?bata))
              (and (and (not (= ?batd ?batc))
                  (not (= ?batd ?awmg))
                  )
                (not (= ?batc ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bate Real)
      (declare-const ?batf Real)
      (declare-const ?batg Real)
      (assert
        (and (and (not (= ?batg ?batf))
            (not (= ?batg ?bate))
            )
          (not (= ?batf ?bate))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bath Real)
      (declare-const ?bati Real)
      (declare-const ?batj Real)
      (declare-const ?batk Real)
      (assert
        (and (and (not (= ?batk ?batj))
            (not (= ?batk ?bati))
            )
          (not (= ?batj ?bati))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?batl Real)
      (declare-const ?batm Real)
      (declare-const ?batn Real)
      (declare-const ?bato Real)
      (declare-const ?batp Real)
      (declare-const ?batq Real)
      (assert
        (or (and (or (or (= ?batn ?batm)
                (= ?batn ?batl)
                )
              (= ?batm ?batl)
              )
            (or (or (= ?batq ?batp)
                (= ?batq ?bato)
                )
              (= ?batp ?bato)
              )
            )
          (and (and (and (not (= ?batn ?batm))
                (not (= ?batn ?batl))
                )
              (not (= ?batm ?batl))
              )
            (and (and (not (= ?batq ?batp))
                (not (= ?batq ?bato))
                )
              (not (= ?batp ?bato))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?batr Real)
      (declare-const ?bats Real)
      (declare-const ?batt Real)
      (assert
        (and (and (not (= ?batt ?bats))
            (not (= ?batt ?batr))
            )
          (not (= ?bats ?batr))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?batu Real)
      (declare-const ?batv Real)
      (declare-const ?batw Real)
      (assert
        (and (and (not (= ?batw ?batv))
            (not (= ?batw ?batu))
            )
          (not (= ?batv ?batu))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?batx Real)
    (declare-const ?baty Real)
    (push 1)
      (declare-const ?batz Real)
      (declare-const ?baua Real)
      (declare-const ?baub Real)
      (assert
        (and (and (not (= ?baub ?baua))
            (not (= ?baub ?batz))
            )
          (not (= ?baua ?batz))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bauc Real)
      (declare-const ?baud Real)
      (declare-const ?baue Real)
      (declare-const ?bauf Real)
      (assert
        (and (and (not (= ?baue ?baud))
            (not (= ?baue ?bauc))
            )
          (not (= ?baud ?bauc))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baug Real)
      (declare-const ?bauh Real)
      (declare-const ?baui Real)
      (declare-const ?bauj Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bauh ?baug)
                  (= ?bauh ?awmg)
                  )
                (= ?baug ?awmg)
                )
              (or (or (= ?bauj ?baui)
                  (= ?bauj ?awmg)
                  )
                (= ?baui ?awmg)
                )
              )
            (and (not (= ?bauh ?baug))
              (and (and (not (= ?bauj ?baui))
                  (not (= ?bauj ?awmg))
                  )
                (not (= ?baui ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bauk Real)
      (declare-const ?baul Real)
      (declare-const ?baum Real)
      (assert
        (and (and (not (= ?baum ?baul))
            (not (= ?baum ?bauk))
            )
          (not (= ?baul ?bauk))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baun Real)
      (declare-const ?bauo Real)
      (declare-const ?baup Real)
      (declare-const ?bauq Real)
      (assert
        (and (and (not (= ?bauq ?baup))
            (not (= ?bauq ?bauo))
            )
          (not (= ?baup ?bauo))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baur Real)
      (declare-const ?baus Real)
      (declare-const ?baut Real)
      (declare-const ?bauu Real)
      (declare-const ?bauv Real)
      (declare-const ?bauw Real)
      (assert
        (or (and (or (or (= ?baut ?baus)
                (= ?baut ?baur)
                )
              (= ?baus ?baur)
              )
            (or (or (= ?bauw ?bauv)
                (= ?bauw ?bauu)
                )
              (= ?bauv ?bauu)
              )
            )
          (and (and (and (not (= ?baut ?baus))
                (not (= ?baut ?baur))
                )
              (not (= ?baus ?baur))
              )
            (and (and (not (= ?bauw ?bauv))
                (not (= ?bauw ?bauu))
                )
              (not (= ?bauv ?bauu))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baux Real)
      (declare-const ?bauy Real)
      (declare-const ?bauz Real)
      (assert
        (and (and (not (= ?bauz ?bauy))
            (not (= ?bauz ?baux))
            )
          (not (= ?bauy ?baux))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bava Real)
      (declare-const ?bavb Real)
      (declare-const ?bavc Real)
      (assert
        (and (and (not (= ?bavc ?bavb))
            (not (= ?bavc ?bava))
            )
          (not (= ?bavb ?bava))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bavd Real)
    (declare-const ?bave Real)
    (declare-const ?bavf Real)
    (push 1)
      (declare-const ?bavg Real)
      (declare-const ?bavh Real)
      (declare-const ?bavi Real)
      (assert
        (and (and (not (= ?bavi ?bavh))
            (not (= ?bavi ?bavg))
            )
          (not (= ?bavh ?bavg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bavj Real)
      (declare-const ?bavk Real)
      (declare-const ?bavl Real)
      (declare-const ?bavm Real)
      (assert
        (and (and (not (= ?bavl ?bavk))
            (not (= ?bavl ?bavj))
            )
          (not (= ?bavk ?bavj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bavn Real)
      (declare-const ?bavo Real)
      (declare-const ?bavp Real)
      (declare-const ?bavq Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bavo ?bavn)
                  (= ?bavo ?awmg)
                  )
                (= ?bavn ?awmg)
                )
              (or (or (= ?bavq ?bavp)
                  (= ?bavq ?awmg)
                  )
                (= ?bavp ?awmg)
                )
              )
            (and (not (= ?bavo ?bavn))
              (and (and (not (= ?bavq ?bavp))
                  (not (= ?bavq ?awmg))
                  )
                (not (= ?bavp ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bavr Real)
      (declare-const ?bavs Real)
      (declare-const ?bavt Real)
      (assert
        (and (and (not (= ?bavt ?bavs))
            (not (= ?bavt ?bavr))
            )
          (not (= ?bavs ?bavr))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bavu Real)
      (declare-const ?bavv Real)
      (declare-const ?bavw Real)
      (declare-const ?bavx Real)
      (assert
        (and (and (not (= ?bavx ?bavw))
            (not (= ?bavx ?bavv))
            )
          (not (= ?bavw ?bavv))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bavy Real)
      (declare-const ?bavz Real)
      (declare-const ?bawa Real)
      (declare-const ?bawb Real)
      (declare-const ?bawc Real)
      (declare-const ?bawd Real)
      (assert
        (or (and (or (or (= ?bawa ?bavz)
                (= ?bawa ?bavy)
                )
              (= ?bavz ?bavy)
              )
            (or (or (= ?bawd ?bawc)
                (= ?bawd ?bawb)
                )
              (= ?bawc ?bawb)
              )
            )
          (and (and (and (not (= ?bawa ?bavz))
                (not (= ?bawa ?bavy))
                )
              (not (= ?bavz ?bavy))
              )
            (and (and (not (= ?bawd ?bawc))
                (not (= ?bawd ?bawb))
                )
              (not (= ?bawc ?bawb))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bawe Real)
      (declare-const ?bawf Real)
      (declare-const ?bawg Real)
      (assert
        (and (and (not (= ?bawg ?bawf))
            (not (= ?bawg ?bawe))
            )
          (not (= ?bawf ?bawe))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bawh Real)
      (declare-const ?bawi Real)
      (declare-const ?bawj Real)
      (assert
        (and (and (not (= ?bawj ?bawi))
            (not (= ?bawj ?bawh))
            )
          (not (= ?bawi ?bawh))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bawk Real)
    (declare-const ?bawl Real)
    (declare-const ?bawm Real)
    (declare-const ?bawn Real)
    (assert
      (and (and (not (= ?bawm ?bawl))
          (not (= ?bawm ?bawk))
          )
        (not (= ?bawl ?bawk))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bawo Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bawp Real)
      (declare-const ?bawq Real)
      (declare-const ?bawr Real)
      (assert
        (and (and (not (= ?bawr ?bawq))
            (not (= ?bawr ?bawp))
            )
          (not (= ?bawq ?bawp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baws Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bawt Real)
      (declare-const ?bawu Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bawv Real)
      (declare-const ?baww Real)
      (declare-const ?bawx Real)
      (declare-const ?bawy Real)
      (assert
        (and (and (not (= ?bawx ?baww))
            (not (= ?bawx ?bawv))
            )
          (not (= ?baww ?bawv))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bawz Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baxa Real)
      (declare-const ?baxb Real)
      (declare-const ?baxc Real)
      (declare-const ?baxd Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?baxb ?baxa)
                  (= ?baxb ?awmg)
                  )
                (= ?baxa ?awmg)
                )
              (or (or (= ?baxd ?baxc)
                  (= ?baxd ?awmg)
                  )
                (= ?baxc ?awmg)
                )
              )
            (and (not (= ?baxb ?baxa))
              (and (and (not (= ?baxd ?baxc))
                  (not (= ?baxd ?awmg))
                  )
                (not (= ?baxc ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baxe Real)
      (declare-const ?baxf Real)
      (declare-const ?baxg Real)
      (assert
        (and (and (not (= ?baxg ?baxf))
            (not (= ?baxg ?baxe))
            )
          (not (= ?baxf ?baxe))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baxh Real)
      (declare-const ?baxi Real)
      (declare-const ?baxj Real)
      (declare-const ?baxk Real)
      (assert
        (and (and (not (= ?baxk ?baxj))
            (not (= ?baxk ?baxi))
            )
          (not (= ?baxj ?baxi))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baxl Real)
      (declare-const ?baxm Real)
      (declare-const ?baxn Real)
      (declare-const ?baxo Real)
      (declare-const ?baxp Real)
      (declare-const ?baxq Real)
      (assert
        (or (and (or (or (= ?baxn ?baxm)
                (= ?baxn ?baxl)
                )
              (= ?baxm ?baxl)
              )
            (or (or (= ?baxq ?baxp)
                (= ?baxq ?baxo)
                )
              (= ?baxp ?baxo)
              )
            )
          (and (and (and (not (= ?baxn ?baxm))
                (not (= ?baxn ?baxl))
                )
              (not (= ?baxm ?baxl))
              )
            (and (and (not (= ?baxq ?baxp))
                (not (= ?baxq ?baxo))
                )
              (not (= ?baxp ?baxo))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baxr Real)
      (declare-const ?baxs Real)
      (declare-const ?baxt Real)
      (assert
        (and (and (not (= ?baxt ?baxs))
            (not (= ?baxt ?baxr))
            )
          (not (= ?baxs ?baxr))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baxu Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baxv Real)
      (declare-const ?baxw Real)
      (declare-const ?baxx Real)
      (assert
        (and (and (not (= ?baxx ?baxw))
            (not (= ?baxx ?baxv))
            )
          (not (= ?baxw ?baxv))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?baxy Real)
    (push 1)
      (declare-const ?baxz Real)
      (declare-const ?baya Real)
      (declare-const ?bayb Real)
      (assert
        (and (and (not (= ?bayb ?baya))
            (not (= ?bayb ?baxz))
            )
          (not (= ?baya ?baxz))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bayc Real)
      (declare-const ?bayd Real)
      (declare-const ?baye Real)
      (declare-const ?bayf Real)
      (assert
        (and (and (not (= ?baye ?bayd))
            (not (= ?baye ?bayc))
            )
          (not (= ?bayd ?bayc))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bayg Real)
      (declare-const ?bayh Real)
      (declare-const ?bayi Real)
      (declare-const ?bayj Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bayh ?bayg)
                  (= ?bayh ?awmg)
                  )
                (= ?bayg ?awmg)
                )
              (or (or (= ?bayj ?bayi)
                  (= ?bayj ?awmg)
                  )
                (= ?bayi ?awmg)
                )
              )
            (and (not (= ?bayh ?bayg))
              (and (and (not (= ?bayj ?bayi))
                  (not (= ?bayj ?awmg))
                  )
                (not (= ?bayi ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bayk Real)
      (declare-const ?bayl Real)
      (declare-const ?baym Real)
      (assert
        (and (and (not (= ?baym ?bayl))
            (not (= ?baym ?bayk))
            )
          (not (= ?bayl ?bayk))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bayn Real)
      (declare-const ?bayo Real)
      (declare-const ?bayp Real)
      (declare-const ?bayq Real)
      (assert
        (and (and (not (= ?bayq ?bayp))
            (not (= ?bayq ?bayo))
            )
          (not (= ?bayp ?bayo))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bayr Real)
      (declare-const ?bays Real)
      (declare-const ?bayt Real)
      (declare-const ?bayu Real)
      (declare-const ?bayv Real)
      (declare-const ?bayw Real)
      (assert
        (or (and (or (or (= ?bayt ?bays)
                (= ?bayt ?bayr)
                )
              (= ?bays ?bayr)
              )
            (or (or (= ?bayw ?bayv)
                (= ?bayw ?bayu)
                )
              (= ?bayv ?bayu)
              )
            )
          (and (and (and (not (= ?bayt ?bays))
                (not (= ?bayt ?bayr))
                )
              (not (= ?bays ?bayr))
              )
            (and (and (not (= ?bayw ?bayv))
                (not (= ?bayw ?bayu))
                )
              (not (= ?bayv ?bayu))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bayx Real)
      (declare-const ?bayy Real)
      (declare-const ?bayz Real)
      (assert
        (and (and (not (= ?bayz ?bayy))
            (not (= ?bayz ?bayx))
            )
          (not (= ?bayy ?bayx))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?baza Real)
      (declare-const ?bazb Real)
      (declare-const ?bazc Real)
      (assert
        (and (and (not (= ?bazc ?bazb))
            (not (= ?bazc ?baza))
            )
          (not (= ?bazb ?baza))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bazd Real)
    (declare-const ?baze Real)
    (push 1)
      (declare-const ?bazf Real)
      (declare-const ?bazg Real)
      (declare-const ?bazh Real)
      (assert
        (and (and (not (= ?bazh ?bazg))
            (not (= ?bazh ?bazf))
            )
          (not (= ?bazg ?bazf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bazi Real)
      (declare-const ?bazj Real)
      (declare-const ?bazk Real)
      (declare-const ?bazl Real)
      (assert
        (and (and (not (= ?bazk ?bazj))
            (not (= ?bazk ?bazi))
            )
          (not (= ?bazj ?bazi))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bazm Real)
      (declare-const ?bazn Real)
      (declare-const ?bazo Real)
      (declare-const ?bazp Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bazn ?bazm)
                  (= ?bazn ?awmg)
                  )
                (= ?bazm ?awmg)
                )
              (or (or (= ?bazp ?bazo)
                  (= ?bazp ?awmg)
                  )
                (= ?bazo ?awmg)
                )
              )
            (and (not (= ?bazn ?bazm))
              (and (and (not (= ?bazp ?bazo))
                  (not (= ?bazp ?awmg))
                  )
                (not (= ?bazo ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bazq Real)
      (declare-const ?bazr Real)
      (declare-const ?bazs Real)
      (assert
        (and (and (not (= ?bazs ?bazr))
            (not (= ?bazs ?bazq))
            )
          (not (= ?bazr ?bazq))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bazt Real)
      (declare-const ?bazu Real)
      (declare-const ?bazv Real)
      (declare-const ?bazw Real)
      (assert
        (and (and (not (= ?bazw ?bazv))
            (not (= ?bazw ?bazu))
            )
          (not (= ?bazv ?bazu))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bazx Real)
      (declare-const ?bazy Real)
      (declare-const ?bazz Real)
      (declare-const ?bbaa Real)
      (declare-const ?bbab Real)
      (declare-const ?bbac Real)
      (assert
        (or (and (or (or (= ?bazz ?bazy)
                (= ?bazz ?bazx)
                )
              (= ?bazy ?bazx)
              )
            (or (or (= ?bbac ?bbab)
                (= ?bbac ?bbaa)
                )
              (= ?bbab ?bbaa)
              )
            )
          (and (and (and (not (= ?bazz ?bazy))
                (not (= ?bazz ?bazx))
                )
              (not (= ?bazy ?bazx))
              )
            (and (and (not (= ?bbac ?bbab))
                (not (= ?bbac ?bbaa))
                )
              (not (= ?bbab ?bbaa))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbad Real)
      (declare-const ?bbae Real)
      (declare-const ?bbaf Real)
      (assert
        (and (and (not (= ?bbaf ?bbae))
            (not (= ?bbaf ?bbad))
            )
          (not (= ?bbae ?bbad))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbag Real)
      (declare-const ?bbah Real)
      (declare-const ?bbai Real)
      (assert
        (and (and (not (= ?bbai ?bbah))
            (not (= ?bbai ?bbag))
            )
          (not (= ?bbah ?bbag))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bbaj Real)
    (declare-const ?bbak Real)
    (declare-const ?bbal Real)
    (push 1)
      (declare-const ?bbam Real)
      (declare-const ?bban Real)
      (declare-const ?bbao Real)
      (assert
        (and (and (not (= ?bbao ?bban))
            (not (= ?bbao ?bbam))
            )
          (not (= ?bban ?bbam))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbap Real)
      (declare-const ?bbaq Real)
      (declare-const ?bbar Real)
      (declare-const ?bbas Real)
      (assert
        (and (and (not (= ?bbar ?bbaq))
            (not (= ?bbar ?bbap))
            )
          (not (= ?bbaq ?bbap))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbat Real)
      (declare-const ?bbau Real)
      (declare-const ?bbav Real)
      (declare-const ?bbaw Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bbau ?bbat)
                  (= ?bbau ?awmg)
                  )
                (= ?bbat ?awmg)
                )
              (or (or (= ?bbaw ?bbav)
                  (= ?bbaw ?awmg)
                  )
                (= ?bbav ?awmg)
                )
              )
            (and (not (= ?bbau ?bbat))
              (and (and (not (= ?bbaw ?bbav))
                  (not (= ?bbaw ?awmg))
                  )
                (not (= ?bbav ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbax Real)
      (declare-const ?bbay Real)
      (declare-const ?bbaz Real)
      (assert
        (and (and (not (= ?bbaz ?bbay))
            (not (= ?bbaz ?bbax))
            )
          (not (= ?bbay ?bbax))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbba Real)
      (declare-const ?bbbb Real)
      (declare-const ?bbbc Real)
      (declare-const ?bbbd Real)
      (assert
        (and (and (not (= ?bbbd ?bbbc))
            (not (= ?bbbd ?bbbb))
            )
          (not (= ?bbbc ?bbbb))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbbe Real)
      (declare-const ?bbbf Real)
      (declare-const ?bbbg Real)
      (declare-const ?bbbh Real)
      (declare-const ?bbbi Real)
      (declare-const ?bbbj Real)
      (assert
        (or (and (or (or (= ?bbbg ?bbbf)
                (= ?bbbg ?bbbe)
                )
              (= ?bbbf ?bbbe)
              )
            (or (or (= ?bbbj ?bbbi)
                (= ?bbbj ?bbbh)
                )
              (= ?bbbi ?bbbh)
              )
            )
          (and (and (and (not (= ?bbbg ?bbbf))
                (not (= ?bbbg ?bbbe))
                )
              (not (= ?bbbf ?bbbe))
              )
            (and (and (not (= ?bbbj ?bbbi))
                (not (= ?bbbj ?bbbh))
                )
              (not (= ?bbbi ?bbbh))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbbk Real)
      (declare-const ?bbbl Real)
      (declare-const ?bbbm Real)
      (assert
        (and (and (not (= ?bbbm ?bbbl))
            (not (= ?bbbm ?bbbk))
            )
          (not (= ?bbbl ?bbbk))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbbn Real)
      (declare-const ?bbbo Real)
      (declare-const ?bbbp Real)
      (assert
        (and (and (not (= ?bbbp ?bbbo))
            (not (= ?bbbp ?bbbn))
            )
          (not (= ?bbbo ?bbbn))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bbbq Real)
    (declare-const ?bbbr Real)
    (declare-const ?bbbs Real)
    (declare-const ?bbbt Real)
    (push 1)
      (declare-const ?bbbu Real)
      (declare-const ?bbbv Real)
      (declare-const ?bbbw Real)
      (assert
        (and (and (not (= ?bbbw ?bbbv))
            (not (= ?bbbw ?bbbu))
            )
          (not (= ?bbbv ?bbbu))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbbx Real)
      (declare-const ?bbby Real)
      (declare-const ?bbbz Real)
      (declare-const ?bbca Real)
      (assert
        (and (and (not (= ?bbbz ?bbby))
            (not (= ?bbbz ?bbbx))
            )
          (not (= ?bbby ?bbbx))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbcb Real)
      (declare-const ?bbcc Real)
      (declare-const ?bbcd Real)
      (declare-const ?bbce Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bbcc ?bbcb)
                  (= ?bbcc ?awmg)
                  )
                (= ?bbcb ?awmg)
                )
              (or (or (= ?bbce ?bbcd)
                  (= ?bbce ?awmg)
                  )
                (= ?bbcd ?awmg)
                )
              )
            (and (not (= ?bbcc ?bbcb))
              (and (and (not (= ?bbce ?bbcd))
                  (not (= ?bbce ?awmg))
                  )
                (not (= ?bbcd ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbcf Real)
      (declare-const ?bbcg Real)
      (declare-const ?bbch Real)
      (assert
        (and (and (not (= ?bbch ?bbcg))
            (not (= ?bbch ?bbcf))
            )
          (not (= ?bbcg ?bbcf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbci Real)
      (declare-const ?bbcj Real)
      (declare-const ?bbck Real)
      (declare-const ?bbcl Real)
      (assert
        (and (and (not (= ?bbcl ?bbck))
            (not (= ?bbcl ?bbcj))
            )
          (not (= ?bbck ?bbcj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbcm Real)
      (declare-const ?bbcn Real)
      (declare-const ?bbco Real)
      (declare-const ?bbcp Real)
      (declare-const ?bbcq Real)
      (declare-const ?bbcr Real)
      (assert
        (or (and (or (or (= ?bbco ?bbcn)
                (= ?bbco ?bbcm)
                )
              (= ?bbcn ?bbcm)
              )
            (or (or (= ?bbcr ?bbcq)
                (= ?bbcr ?bbcp)
                )
              (= ?bbcq ?bbcp)
              )
            )
          (and (and (and (not (= ?bbco ?bbcn))
                (not (= ?bbco ?bbcm))
                )
              (not (= ?bbcn ?bbcm))
              )
            (and (and (not (= ?bbcr ?bbcq))
                (not (= ?bbcr ?bbcp))
                )
              (not (= ?bbcq ?bbcp))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbcs Real)
      (declare-const ?bbct Real)
      (declare-const ?bbcu Real)
      (assert
        (and (and (not (= ?bbcu ?bbct))
            (not (= ?bbcu ?bbcs))
            )
          (not (= ?bbct ?bbcs))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbcv Real)
      (declare-const ?bbcw Real)
      (declare-const ?bbcx Real)
      (assert
        (and (and (not (= ?bbcx ?bbcw))
            (not (= ?bbcx ?bbcv))
            )
          (not (= ?bbcw ?bbcv))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bbcy Real)
    (declare-const ?bbcz Real)
    (declare-const ?bbda Real)
    (declare-const ?bbdb Real)
    (declare-const ?bbdc Real)
    (assert
      (and (and (not (= ?bbda ?bbcz))
          (not (= ?bbda ?bbcy))
          )
        (not (= ?bbcz ?bbcy))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbdd Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbde Real)
      (declare-const ?bbdf Real)
      (declare-const ?bbdg Real)
      (assert
        (and (and (not (= ?bbdg ?bbdf))
            (not (= ?bbdg ?bbde))
            )
          (not (= ?bbdf ?bbde))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbdh Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbdi Real)
      (declare-const ?bbdj Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbdk Real)
      (declare-const ?bbdl Real)
      (declare-const ?bbdm Real)
      (declare-const ?bbdn Real)
      (assert
        (and (and (not (= ?bbdm ?bbdl))
            (not (= ?bbdm ?bbdk))
            )
          (not (= ?bbdl ?bbdk))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbdo Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbdp Real)
      (declare-const ?bbdq Real)
      (declare-const ?bbdr Real)
      (declare-const ?bbds Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bbdq ?bbdp)
                  (= ?bbdq ?awmg)
                  )
                (= ?bbdp ?awmg)
                )
              (or (or (= ?bbds ?bbdr)
                  (= ?bbds ?awmg)
                  )
                (= ?bbdr ?awmg)
                )
              )
            (and (not (= ?bbdq ?bbdp))
              (and (and (not (= ?bbds ?bbdr))
                  (not (= ?bbds ?awmg))
                  )
                (not (= ?bbdr ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbdt Real)
      (declare-const ?bbdu Real)
      (declare-const ?bbdv Real)
      (assert
        (and (and (not (= ?bbdv ?bbdu))
            (not (= ?bbdv ?bbdt))
            )
          (not (= ?bbdu ?bbdt))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbdw Real)
      (declare-const ?bbdx Real)
      (declare-const ?bbdy Real)
      (declare-const ?bbdz Real)
      (assert
        (and (and (not (= ?bbdz ?bbdy))
            (not (= ?bbdz ?bbdx))
            )
          (not (= ?bbdy ?bbdx))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbea Real)
      (declare-const ?bbeb Real)
      (declare-const ?bbec Real)
      (declare-const ?bbed Real)
      (declare-const ?bbee Real)
      (declare-const ?bbef Real)
      (assert
        (or (and (or (or (= ?bbec ?bbeb)
                (= ?bbec ?bbea)
                )
              (= ?bbeb ?bbea)
              )
            (or (or (= ?bbef ?bbee)
                (= ?bbef ?bbed)
                )
              (= ?bbee ?bbed)
              )
            )
          (and (and (and (not (= ?bbec ?bbeb))
                (not (= ?bbec ?bbea))
                )
              (not (= ?bbeb ?bbea))
              )
            (and (and (not (= ?bbef ?bbee))
                (not (= ?bbef ?bbed))
                )
              (not (= ?bbee ?bbed))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbeg Real)
      (declare-const ?bbeh Real)
      (declare-const ?bbei Real)
      (assert
        (and (and (not (= ?bbei ?bbeh))
            (not (= ?bbei ?bbeg))
            )
          (not (= ?bbeh ?bbeg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbej Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbek Real)
      (declare-const ?bbel Real)
      (declare-const ?bbem Real)
      (assert
        (and (and (not (= ?bbem ?bbel))
            (not (= ?bbem ?bbek))
            )
          (not (= ?bbel ?bbek))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bben Real)
    (declare-const ?bbeo Real)
    (push 1)
      (declare-const ?bbep Real)
      (declare-const ?bbeq Real)
      (declare-const ?bber Real)
      (assert
        (and (and (not (= ?bber ?bbeq))
            (not (= ?bber ?bbep))
            )
          (not (= ?bbeq ?bbep))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbes Real)
      (declare-const ?bbet Real)
      (declare-const ?bbeu Real)
      (declare-const ?bbev Real)
      (assert
        (and (and (not (= ?bbeu ?bbet))
            (not (= ?bbeu ?bbes))
            )
          (not (= ?bbet ?bbes))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbew Real)
      (declare-const ?bbex Real)
      (declare-const ?bbey Real)
      (declare-const ?bbez Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bbex ?bbew)
                  (= ?bbex ?awmg)
                  )
                (= ?bbew ?awmg)
                )
              (or (or (= ?bbez ?bbey)
                  (= ?bbez ?awmg)
                  )
                (= ?bbey ?awmg)
                )
              )
            (and (not (= ?bbex ?bbew))
              (and (and (not (= ?bbez ?bbey))
                  (not (= ?bbez ?awmg))
                  )
                (not (= ?bbey ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbfa Real)
      (declare-const ?bbfb Real)
      (declare-const ?bbfc Real)
      (assert
        (and (and (not (= ?bbfc ?bbfb))
            (not (= ?bbfc ?bbfa))
            )
          (not (= ?bbfb ?bbfa))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbfd Real)
      (declare-const ?bbfe Real)
      (declare-const ?bbff Real)
      (declare-const ?bbfg Real)
      (assert
        (and (and (not (= ?bbfg ?bbff))
            (not (= ?bbfg ?bbfe))
            )
          (not (= ?bbff ?bbfe))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbfh Real)
      (declare-const ?bbfi Real)
      (declare-const ?bbfj Real)
      (declare-const ?bbfk Real)
      (declare-const ?bbfl Real)
      (declare-const ?bbfm Real)
      (assert
        (or (and (or (or (= ?bbfj ?bbfi)
                (= ?bbfj ?bbfh)
                )
              (= ?bbfi ?bbfh)
              )
            (or (or (= ?bbfm ?bbfl)
                (= ?bbfm ?bbfk)
                )
              (= ?bbfl ?bbfk)
              )
            )
          (and (and (and (not (= ?bbfj ?bbfi))
                (not (= ?bbfj ?bbfh))
                )
              (not (= ?bbfi ?bbfh))
              )
            (and (and (not (= ?bbfm ?bbfl))
                (not (= ?bbfm ?bbfk))
                )
              (not (= ?bbfl ?bbfk))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbfn Real)
      (declare-const ?bbfo Real)
      (declare-const ?bbfp Real)
      (assert
        (and (and (not (= ?bbfp ?bbfo))
            (not (= ?bbfp ?bbfn))
            )
          (not (= ?bbfo ?bbfn))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbfq Real)
      (declare-const ?bbfr Real)
      (declare-const ?bbfs Real)
      (assert
        (and (and (not (= ?bbfs ?bbfr))
            (not (= ?bbfs ?bbfq))
            )
          (not (= ?bbfr ?bbfq))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bbft Real)
    (declare-const ?bbfu Real)
    (declare-const ?bbfv Real)
    (assert
      (and (and (not (= ?bbfv ?bbfu))
          (not (= ?bbfv ?bbft))
          )
        (not (= ?bbfu ?bbft))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbfw Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbfx Real)
      (declare-const ?bbfy Real)
      (declare-const ?bbfz Real)
      (assert
        (and (and (not (= ?bbfz ?bbfy))
            (not (= ?bbfz ?bbfx))
            )
          (not (= ?bbfy ?bbfx))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbga Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbgb Real)
      (declare-const ?bbgc Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbgd Real)
      (declare-const ?bbge Real)
      (declare-const ?bbgf Real)
      (declare-const ?bbgg Real)
      (assert
        (and (and (not (= ?bbgf ?bbge))
            (not (= ?bbgf ?bbgd))
            )
          (not (= ?bbge ?bbgd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbgh Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbgi Real)
      (declare-const ?bbgj Real)
      (declare-const ?bbgk Real)
      (declare-const ?bbgl Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bbgj ?bbgi)
                  (= ?bbgj ?awmg)
                  )
                (= ?bbgi ?awmg)
                )
              (or (or (= ?bbgl ?bbgk)
                  (= ?bbgl ?awmg)
                  )
                (= ?bbgk ?awmg)
                )
              )
            (and (not (= ?bbgj ?bbgi))
              (and (and (not (= ?bbgl ?bbgk))
                  (not (= ?bbgl ?awmg))
                  )
                (not (= ?bbgk ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbgm Real)
      (declare-const ?bbgn Real)
      (declare-const ?bbgo Real)
      (assert
        (and (and (not (= ?bbgo ?bbgn))
            (not (= ?bbgo ?bbgm))
            )
          (not (= ?bbgn ?bbgm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbgp Real)
      (declare-const ?bbgq Real)
      (declare-const ?bbgr Real)
      (declare-const ?bbgs Real)
      (assert
        (and (and (not (= ?bbgs ?bbgr))
            (not (= ?bbgs ?bbgq))
            )
          (not (= ?bbgr ?bbgq))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbgt Real)
      (declare-const ?bbgu Real)
      (declare-const ?bbgv Real)
      (declare-const ?bbgw Real)
      (declare-const ?bbgx Real)
      (declare-const ?bbgy Real)
      (assert
        (or (and (or (or (= ?bbgv ?bbgu)
                (= ?bbgv ?bbgt)
                )
              (= ?bbgu ?bbgt)
              )
            (or (or (= ?bbgy ?bbgx)
                (= ?bbgy ?bbgw)
                )
              (= ?bbgx ?bbgw)
              )
            )
          (and (and (and (not (= ?bbgv ?bbgu))
                (not (= ?bbgv ?bbgt))
                )
              (not (= ?bbgu ?bbgt))
              )
            (and (and (not (= ?bbgy ?bbgx))
                (not (= ?bbgy ?bbgw))
                )
              (not (= ?bbgx ?bbgw))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbgz Real)
      (declare-const ?bbha Real)
      (declare-const ?bbhb Real)
      (assert
        (and (and (not (= ?bbhb ?bbha))
            (not (= ?bbhb ?bbgz))
            )
          (not (= ?bbha ?bbgz))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbhc Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbhd Real)
      (declare-const ?bbhe Real)
      (declare-const ?bbhf Real)
      (assert
        (and (and (not (= ?bbhf ?bbhe))
            (not (= ?bbhf ?bbhd))
            )
          (not (= ?bbhe ?bbhd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bbhg Real)
    (declare-const ?bbhh Real)
    (declare-const ?bbhi Real)
    (declare-const ?bbhj Real)
    (assert
      (and (and (not (= ?bbhj ?bbhi))
          (not (= ?bbhj ?bbhh))
          )
        (not (= ?bbhi ?bbhh))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbhk Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbhl Real)
      (declare-const ?bbhm Real)
      (declare-const ?bbhn Real)
      (assert
        (and (and (not (= ?bbhn ?bbhm))
            (not (= ?bbhn ?bbhl))
            )
          (not (= ?bbhm ?bbhl))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbho Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbhp Real)
      (declare-const ?bbhq Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbhr Real)
      (declare-const ?bbhs Real)
      (declare-const ?bbht Real)
      (declare-const ?bbhu Real)
      (assert
        (and (and (not (= ?bbht ?bbhs))
            (not (= ?bbht ?bbhr))
            )
          (not (= ?bbhs ?bbhr))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbhv Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbhw Real)
      (declare-const ?bbhx Real)
      (declare-const ?bbhy Real)
      (declare-const ?bbhz Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bbhx ?bbhw)
                  (= ?bbhx ?awmg)
                  )
                (= ?bbhw ?awmg)
                )
              (or (or (= ?bbhz ?bbhy)
                  (= ?bbhz ?awmg)
                  )
                (= ?bbhy ?awmg)
                )
              )
            (and (not (= ?bbhx ?bbhw))
              (and (and (not (= ?bbhz ?bbhy))
                  (not (= ?bbhz ?awmg))
                  )
                (not (= ?bbhy ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbia Real)
      (declare-const ?bbib Real)
      (declare-const ?bbic Real)
      (assert
        (and (and (not (= ?bbic ?bbib))
            (not (= ?bbic ?bbia))
            )
          (not (= ?bbib ?bbia))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbid Real)
      (declare-const ?bbie Real)
      (declare-const ?bbif Real)
      (declare-const ?bbig Real)
      (assert
        (and (and (not (= ?bbig ?bbif))
            (not (= ?bbig ?bbie))
            )
          (not (= ?bbif ?bbie))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbih Real)
      (declare-const ?bbii Real)
      (declare-const ?bbij Real)
      (declare-const ?bbik Real)
      (declare-const ?bbil Real)
      (declare-const ?bbim Real)
      (assert
        (or (and (or (or (= ?bbij ?bbii)
                (= ?bbij ?bbih)
                )
              (= ?bbii ?bbih)
              )
            (or (or (= ?bbim ?bbil)
                (= ?bbim ?bbik)
                )
              (= ?bbil ?bbik)
              )
            )
          (and (and (and (not (= ?bbij ?bbii))
                (not (= ?bbij ?bbih))
                )
              (not (= ?bbii ?bbih))
              )
            (and (and (not (= ?bbim ?bbil))
                (not (= ?bbim ?bbik))
                )
              (not (= ?bbil ?bbik))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbin Real)
      (declare-const ?bbio Real)
      (declare-const ?bbip Real)
      (assert
        (and (and (not (= ?bbip ?bbio))
            (not (= ?bbip ?bbin))
            )
          (not (= ?bbio ?bbin))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbiq Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbir Real)
      (declare-const ?bbis Real)
      (declare-const ?bbit Real)
      (assert
        (and (and (not (= ?bbit ?bbis))
            (not (= ?bbit ?bbir))
            )
          (not (= ?bbis ?bbir))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bbiu Real)
    (declare-const ?bbiv Real)
    (declare-const ?bbiw Real)
    (declare-const ?bbix Real)
    (declare-const ?bbiy Real)
    (assert
      (and (and (not (= ?bbiy ?bbix))
          (not (= ?bbiy ?bbiw))
          )
        (not (= ?bbix ?bbiw))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbiz Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbja Real)
      (declare-const ?bbjb Real)
      (declare-const ?bbjc Real)
      (assert
        (and (and (not (= ?bbjc ?bbjb))
            (not (= ?bbjc ?bbja))
            )
          (not (= ?bbjb ?bbja))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbjd Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbje Real)
      (declare-const ?bbjf Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbjg Real)
      (declare-const ?bbjh Real)
      (declare-const ?bbji Real)
      (declare-const ?bbjj Real)
      (assert
        (and (and (not (= ?bbji ?bbjh))
            (not (= ?bbji ?bbjg))
            )
          (not (= ?bbjh ?bbjg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbjk Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbjl Real)
      (declare-const ?bbjm Real)
      (declare-const ?bbjn Real)
      (declare-const ?bbjo Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bbjm ?bbjl)
                  (= ?bbjm ?awmg)
                  )
                (= ?bbjl ?awmg)
                )
              (or (or (= ?bbjo ?bbjn)
                  (= ?bbjo ?awmg)
                  )
                (= ?bbjn ?awmg)
                )
              )
            (and (not (= ?bbjm ?bbjl))
              (and (and (not (= ?bbjo ?bbjn))
                  (not (= ?bbjo ?awmg))
                  )
                (not (= ?bbjn ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbjp Real)
      (declare-const ?bbjq Real)
      (declare-const ?bbjr Real)
      (assert
        (and (and (not (= ?bbjr ?bbjq))
            (not (= ?bbjr ?bbjp))
            )
          (not (= ?bbjq ?bbjp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbjs Real)
      (declare-const ?bbjt Real)
      (declare-const ?bbju Real)
      (declare-const ?bbjv Real)
      (assert
        (and (and (not (= ?bbjv ?bbju))
            (not (= ?bbjv ?bbjt))
            )
          (not (= ?bbju ?bbjt))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbjw Real)
      (declare-const ?bbjx Real)
      (declare-const ?bbjy Real)
      (declare-const ?bbjz Real)
      (declare-const ?bbka Real)
      (declare-const ?bbkb Real)
      (assert
        (or (and (or (or (= ?bbjy ?bbjx)
                (= ?bbjy ?bbjw)
                )
              (= ?bbjx ?bbjw)
              )
            (or (or (= ?bbkb ?bbka)
                (= ?bbkb ?bbjz)
                )
              (= ?bbka ?bbjz)
              )
            )
          (and (and (and (not (= ?bbjy ?bbjx))
                (not (= ?bbjy ?bbjw))
                )
              (not (= ?bbjx ?bbjw))
              )
            (and (and (not (= ?bbkb ?bbka))
                (not (= ?bbkb ?bbjz))
                )
              (not (= ?bbka ?bbjz))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbkc Real)
      (declare-const ?bbkd Real)
      (declare-const ?bbke Real)
      (assert
        (and (and (not (= ?bbke ?bbkd))
            (not (= ?bbke ?bbkc))
            )
          (not (= ?bbkd ?bbkc))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbkf Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbkg Real)
      (declare-const ?bbkh Real)
      (declare-const ?bbki Real)
      (assert
        (and (and (not (= ?bbki ?bbkh))
            (not (= ?bbki ?bbkg))
            )
          (not (= ?bbkh ?bbkg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bbkj Real)
    (declare-const ?bbkk Real)
    (declare-const ?bbkl Real)
    (declare-const ?bbkm Real)
    (declare-const ?bbkn Real)
    (declare-const ?bbko Real)
    (assert
      (and (and (and (not (= ?bbkl ?bbkk))
            (not (= ?bbkl ?bbkj))
            )
          (not (= ?bbkk ?bbkj))
          )
        (and (and (not (= ?bbko ?bbkn))
            (not (= ?bbko ?bbkm))
            )
          (not (= ?bbkn ?bbkm))
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbkp Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbkq Real)
      (declare-const ?bbkr Real)
      (declare-const ?bbks Real)
      (assert
        (and (and (not (= ?bbks ?bbkr))
            (not (= ?bbks ?bbkq))
            )
          (not (= ?bbkr ?bbkq))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbkt Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbku Real)
      (declare-const ?bbkv Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbkw Real)
      (declare-const ?bbkx Real)
      (declare-const ?bbky Real)
      (declare-const ?bbkz Real)
      (assert
        (and (and (not (= ?bbky ?bbkx))
            (not (= ?bbky ?bbkw))
            )
          (not (= ?bbkx ?bbkw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbla Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bblb Real)
      (declare-const ?bblc Real)
      (declare-const ?bbld Real)
      (declare-const ?bble Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bblc ?bblb)
                  (= ?bblc ?awmg)
                  )
                (= ?bblb ?awmg)
                )
              (or (or (= ?bble ?bbld)
                  (= ?bble ?awmg)
                  )
                (= ?bbld ?awmg)
                )
              )
            (and (not (= ?bblc ?bblb))
              (and (and (not (= ?bble ?bbld))
                  (not (= ?bble ?awmg))
                  )
                (not (= ?bbld ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bblf Real)
      (declare-const ?bblg Real)
      (declare-const ?bblh Real)
      (assert
        (and (and (not (= ?bblh ?bblg))
            (not (= ?bblh ?bblf))
            )
          (not (= ?bblg ?bblf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbli Real)
      (declare-const ?bblj Real)
      (declare-const ?bblk Real)
      (declare-const ?bbll Real)
      (assert
        (and (and (not (= ?bbll ?bblk))
            (not (= ?bbll ?bblj))
            )
          (not (= ?bblk ?bblj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bblm Real)
      (declare-const ?bbln Real)
      (declare-const ?bblo Real)
      (declare-const ?bblp Real)
      (declare-const ?bblq Real)
      (declare-const ?bblr Real)
      (assert
        (or (and (or (or (= ?bblo ?bbln)
                (= ?bblo ?bblm)
                )
              (= ?bbln ?bblm)
              )
            (or (or (= ?bblr ?bblq)
                (= ?bblr ?bblp)
                )
              (= ?bblq ?bblp)
              )
            )
          (and (and (and (not (= ?bblo ?bbln))
                (not (= ?bblo ?bblm))
                )
              (not (= ?bbln ?bblm))
              )
            (and (and (not (= ?bblr ?bblq))
                (not (= ?bblr ?bblp))
                )
              (not (= ?bblq ?bblp))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbls Real)
      (declare-const ?bblt Real)
      (declare-const ?bblu Real)
      (assert
        (and (and (not (= ?bblu ?bblt))
            (not (= ?bblu ?bbls))
            )
          (not (= ?bblt ?bbls))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bblv Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bblw Real)
      (declare-const ?bblx Real)
      (declare-const ?bbly Real)
      (assert
        (and (and (not (= ?bbly ?bblx))
            (not (= ?bbly ?bblw))
            )
          (not (= ?bblx ?bblw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bblz Real)
    (declare-const ?bbma Real)
    (declare-const ?bbmb Real)
    (assert
      (and (and (not (= ?bbmb ?bbma))
          (not (= ?bbmb ?bblz))
          )
        (not (= ?bbma ?bblz))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbmc Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbmd Real)
      (declare-const ?bbme Real)
      (declare-const ?bbmf Real)
      (assert
        (and (and (not (= ?bbmf ?bbme))
            (not (= ?bbmf ?bbmd))
            )
          (not (= ?bbme ?bbmd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbmg Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbmh Real)
      (declare-const ?bbmi Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbmj Real)
      (declare-const ?bbmk Real)
      (declare-const ?bbml Real)
      (declare-const ?bbmm Real)
      (assert
        (and (and (not (= ?bbml ?bbmk))
            (not (= ?bbml ?bbmj))
            )
          (not (= ?bbmk ?bbmj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbmn Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbmo Real)
      (declare-const ?bbmp Real)
      (declare-const ?bbmq Real)
      (declare-const ?bbmr Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bbmp ?bbmo)
                  (= ?bbmp ?awmg)
                  )
                (= ?bbmo ?awmg)
                )
              (or (or (= ?bbmr ?bbmq)
                  (= ?bbmr ?awmg)
                  )
                (= ?bbmq ?awmg)
                )
              )
            (and (not (= ?bbmp ?bbmo))
              (and (and (not (= ?bbmr ?bbmq))
                  (not (= ?bbmr ?awmg))
                  )
                (not (= ?bbmq ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbms Real)
      (declare-const ?bbmt Real)
      (declare-const ?bbmu Real)
      (assert
        (and (and (not (= ?bbmu ?bbmt))
            (not (= ?bbmu ?bbms))
            )
          (not (= ?bbmt ?bbms))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbmv Real)
      (declare-const ?bbmw Real)
      (declare-const ?bbmx Real)
      (declare-const ?bbmy Real)
      (assert
        (and (and (not (= ?bbmy ?bbmx))
            (not (= ?bbmy ?bbmw))
            )
          (not (= ?bbmx ?bbmw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbmz Real)
      (declare-const ?bbna Real)
      (declare-const ?bbnb Real)
      (declare-const ?bbnc Real)
      (declare-const ?bbnd Real)
      (declare-const ?bbne Real)
      (assert
        (or (and (or (or (= ?bbnb ?bbna)
                (= ?bbnb ?bbmz)
                )
              (= ?bbna ?bbmz)
              )
            (or (or (= ?bbne ?bbnd)
                (= ?bbne ?bbnc)
                )
              (= ?bbnd ?bbnc)
              )
            )
          (and (and (and (not (= ?bbnb ?bbna))
                (not (= ?bbnb ?bbmz))
                )
              (not (= ?bbna ?bbmz))
              )
            (and (and (not (= ?bbne ?bbnd))
                (not (= ?bbne ?bbnc))
                )
              (not (= ?bbnd ?bbnc))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbnf Real)
      (declare-const ?bbng Real)
      (declare-const ?bbnh Real)
      (assert
        (and (and (not (= ?bbnh ?bbng))
            (not (= ?bbnh ?bbnf))
            )
          (not (= ?bbng ?bbnf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbni Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbnj Real)
      (declare-const ?bbnk Real)
      (declare-const ?bbnl Real)
      (assert
        (and (and (not (= ?bbnl ?bbnk))
            (not (= ?bbnl ?bbnj))
            )
          (not (= ?bbnk ?bbnj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bbnm Real)
      (declare-const ?bbnn Real)
      (declare-const ?bbno Real)
      (assert
        (and (and (not (= ?bbno ?bbnn))
            (not (= ?bbno ?bbnm))
            )
          (not (= ?bbnn ?bbnm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbnp Real)
      (declare-const ?bbnq Real)
      (declare-const ?bbnr Real)
      (declare-const ?bbns Real)
      (assert
        (and (and (not (= ?bbnr ?bbnq))
            (not (= ?bbnr ?bbnp))
            )
          (not (= ?bbnq ?bbnp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbnt Real)
      (declare-const ?bbnu Real)
      (declare-const ?bbnv Real)
      (declare-const ?bbnw Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bbnu ?bbnt)
                  (= ?bbnu ?awmg)
                  )
                (= ?bbnt ?awmg)
                )
              (or (or (= ?bbnw ?bbnv)
                  (= ?bbnw ?awmg)
                  )
                (= ?bbnv ?awmg)
                )
              )
            (and (not (= ?bbnu ?bbnt))
              (and (and (not (= ?bbnw ?bbnv))
                  (not (= ?bbnw ?awmg))
                  )
                (not (= ?bbnv ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbnx Real)
      (declare-const ?bbny Real)
      (declare-const ?bbnz Real)
      (assert
        (and (and (not (= ?bbnz ?bbny))
            (not (= ?bbnz ?bbnx))
            )
          (not (= ?bbny ?bbnx))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bboa Real)
      (declare-const ?bbob Real)
      (declare-const ?bboc Real)
      (declare-const ?bbod Real)
      (assert
        (and (and (not (= ?bbod ?bboc))
            (not (= ?bbod ?bbob))
            )
          (not (= ?bboc ?bbob))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bboe Real)
      (declare-const ?bbof Real)
      (declare-const ?bbog Real)
      (declare-const ?bboh Real)
      (declare-const ?bboi Real)
      (declare-const ?bboj Real)
      (assert
        (or (and (or (or (= ?bbog ?bbof)
                (= ?bbog ?bboe)
                )
              (= ?bbof ?bboe)
              )
            (or (or (= ?bboj ?bboi)
                (= ?bboj ?bboh)
                )
              (= ?bboi ?bboh)
              )
            )
          (and (and (and (not (= ?bbog ?bbof))
                (not (= ?bbog ?bboe))
                )
              (not (= ?bbof ?bboe))
              )
            (and (and (not (= ?bboj ?bboi))
                (not (= ?bboj ?bboh))
                )
              (not (= ?bboi ?bboh))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbok Real)
      (declare-const ?bbol Real)
      (declare-const ?bbom Real)
      (assert
        (and (and (not (= ?bbom ?bbol))
            (not (= ?bbom ?bbok))
            )
          (not (= ?bbol ?bbok))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbon Real)
      (declare-const ?bboo Real)
      (declare-const ?bbop Real)
      (assert
        (and (and (not (= ?bbop ?bboo))
            (not (= ?bbop ?bbon))
            )
          (not (= ?bboo ?bbon))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bboq Real)
    (push 1)
      (declare-const ?bbor Real)
      (declare-const ?bbos Real)
      (declare-const ?bbot Real)
      (assert
        (and (and (not (= ?bbot ?bbos))
            (not (= ?bbot ?bbor))
            )
          (not (= ?bbos ?bbor))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbou Real)
      (declare-const ?bbov Real)
      (declare-const ?bbow Real)
      (declare-const ?bbox Real)
      (assert
        (and (and (not (= ?bbow ?bbov))
            (not (= ?bbow ?bbou))
            )
          (not (= ?bbov ?bbou))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bboy Real)
      (declare-const ?bboz Real)
      (declare-const ?bbpa Real)
      (declare-const ?bbpb Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bboz ?bboy)
                  (= ?bboz ?awmg)
                  )
                (= ?bboy ?awmg)
                )
              (or (or (= ?bbpb ?bbpa)
                  (= ?bbpb ?awmg)
                  )
                (= ?bbpa ?awmg)
                )
              )
            (and (not (= ?bboz ?bboy))
              (and (and (not (= ?bbpb ?bbpa))
                  (not (= ?bbpb ?awmg))
                  )
                (not (= ?bbpa ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbpc Real)
      (declare-const ?bbpd Real)
      (declare-const ?bbpe Real)
      (assert
        (and (and (not (= ?bbpe ?bbpd))
            (not (= ?bbpe ?bbpc))
            )
          (not (= ?bbpd ?bbpc))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbpf Real)
      (declare-const ?bbpg Real)
      (declare-const ?bbph Real)
      (declare-const ?bbpi Real)
      (assert
        (and (and (not (= ?bbpi ?bbph))
            (not (= ?bbpi ?bbpg))
            )
          (not (= ?bbph ?bbpg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbpj Real)
      (declare-const ?bbpk Real)
      (declare-const ?bbpl Real)
      (declare-const ?bbpm Real)
      (declare-const ?bbpn Real)
      (declare-const ?bbpo Real)
      (assert
        (or (and (or (or (= ?bbpl ?bbpk)
                (= ?bbpl ?bbpj)
                )
              (= ?bbpk ?bbpj)
              )
            (or (or (= ?bbpo ?bbpn)
                (= ?bbpo ?bbpm)
                )
              (= ?bbpn ?bbpm)
              )
            )
          (and (and (and (not (= ?bbpl ?bbpk))
                (not (= ?bbpl ?bbpj))
                )
              (not (= ?bbpk ?bbpj))
              )
            (and (and (not (= ?bbpo ?bbpn))
                (not (= ?bbpo ?bbpm))
                )
              (not (= ?bbpn ?bbpm))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbpp Real)
      (declare-const ?bbpq Real)
      (declare-const ?bbpr Real)
      (assert
        (and (and (not (= ?bbpr ?bbpq))
            (not (= ?bbpr ?bbpp))
            )
          (not (= ?bbpq ?bbpp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbps Real)
      (declare-const ?bbpt Real)
      (declare-const ?bbpu Real)
      (assert
        (and (and (not (= ?bbpu ?bbpt))
            (not (= ?bbpu ?bbps))
            )
          (not (= ?bbpt ?bbps))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bbpv Real)
    (declare-const ?bbpw Real)
    (push 1)
      (declare-const ?bbpx Real)
      (declare-const ?bbpy Real)
      (declare-const ?bbpz Real)
      (assert
        (and (and (not (= ?bbpz ?bbpy))
            (not (= ?bbpz ?bbpx))
            )
          (not (= ?bbpy ?bbpx))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbqa Real)
      (declare-const ?bbqb Real)
      (declare-const ?bbqc Real)
      (declare-const ?bbqd Real)
      (assert
        (and (and (not (= ?bbqc ?bbqb))
            (not (= ?bbqc ?bbqa))
            )
          (not (= ?bbqb ?bbqa))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbqe Real)
      (declare-const ?bbqf Real)
      (declare-const ?bbqg Real)
      (declare-const ?bbqh Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bbqf ?bbqe)
                  (= ?bbqf ?awmg)
                  )
                (= ?bbqe ?awmg)
                )
              (or (or (= ?bbqh ?bbqg)
                  (= ?bbqh ?awmg)
                  )
                (= ?bbqg ?awmg)
                )
              )
            (and (not (= ?bbqf ?bbqe))
              (and (and (not (= ?bbqh ?bbqg))
                  (not (= ?bbqh ?awmg))
                  )
                (not (= ?bbqg ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbqi Real)
      (declare-const ?bbqj Real)
      (declare-const ?bbqk Real)
      (assert
        (and (and (not (= ?bbqk ?bbqj))
            (not (= ?bbqk ?bbqi))
            )
          (not (= ?bbqj ?bbqi))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbql Real)
      (declare-const ?bbqm Real)
      (declare-const ?bbqn Real)
      (declare-const ?bbqo Real)
      (assert
        (and (and (not (= ?bbqo ?bbqn))
            (not (= ?bbqo ?bbqm))
            )
          (not (= ?bbqn ?bbqm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbqp Real)
      (declare-const ?bbqq Real)
      (declare-const ?bbqr Real)
      (declare-const ?bbqs Real)
      (declare-const ?bbqt Real)
      (declare-const ?bbqu Real)
      (assert
        (or (and (or (or (= ?bbqr ?bbqq)
                (= ?bbqr ?bbqp)
                )
              (= ?bbqq ?bbqp)
              )
            (or (or (= ?bbqu ?bbqt)
                (= ?bbqu ?bbqs)
                )
              (= ?bbqt ?bbqs)
              )
            )
          (and (and (and (not (= ?bbqr ?bbqq))
                (not (= ?bbqr ?bbqp))
                )
              (not (= ?bbqq ?bbqp))
              )
            (and (and (not (= ?bbqu ?bbqt))
                (not (= ?bbqu ?bbqs))
                )
              (not (= ?bbqt ?bbqs))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbqv Real)
      (declare-const ?bbqw Real)
      (declare-const ?bbqx Real)
      (assert
        (and (and (not (= ?bbqx ?bbqw))
            (not (= ?bbqx ?bbqv))
            )
          (not (= ?bbqw ?bbqv))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbqy Real)
      (declare-const ?bbqz Real)
      (declare-const ?bbra Real)
      (assert
        (and (and (not (= ?bbra ?bbqz))
            (not (= ?bbra ?bbqy))
            )
          (not (= ?bbqz ?bbqy))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bbrb Real)
    (declare-const ?bbrc Real)
    (declare-const ?bbrd Real)
    (assert
      (and (and (not (= ?bbrd ?bbrc))
          (not (= ?bbrd ?bbrb))
          )
        (not (= ?bbrc ?bbrb))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbre Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbrf Real)
      (declare-const ?bbrg Real)
      (declare-const ?bbrh Real)
      (assert
        (and (and (not (= ?bbrh ?bbrg))
            (not (= ?bbrh ?bbrf))
            )
          (not (= ?bbrg ?bbrf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbri Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbrj Real)
      (declare-const ?bbrk Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbrl Real)
      (declare-const ?bbrm Real)
      (declare-const ?bbrn Real)
      (declare-const ?bbro Real)
      (assert
        (and (and (not (= ?bbrn ?bbrm))
            (not (= ?bbrn ?bbrl))
            )
          (not (= ?bbrm ?bbrl))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbrp Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbrq Real)
      (declare-const ?bbrr Real)
      (declare-const ?bbrs Real)
      (declare-const ?bbrt Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bbrr ?bbrq)
                  (= ?bbrr ?awmg)
                  )
                (= ?bbrq ?awmg)
                )
              (or (or (= ?bbrt ?bbrs)
                  (= ?bbrt ?awmg)
                  )
                (= ?bbrs ?awmg)
                )
              )
            (and (not (= ?bbrr ?bbrq))
              (and (and (not (= ?bbrt ?bbrs))
                  (not (= ?bbrt ?awmg))
                  )
                (not (= ?bbrs ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbru Real)
      (declare-const ?bbrv Real)
      (declare-const ?bbrw Real)
      (assert
        (and (and (not (= ?bbrw ?bbrv))
            (not (= ?bbrw ?bbru))
            )
          (not (= ?bbrv ?bbru))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbrx Real)
      (declare-const ?bbry Real)
      (declare-const ?bbrz Real)
      (declare-const ?bbsa Real)
      (assert
        (and (and (not (= ?bbsa ?bbrz))
            (not (= ?bbsa ?bbry))
            )
          (not (= ?bbrz ?bbry))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbsb Real)
      (declare-const ?bbsc Real)
      (declare-const ?bbsd Real)
      (declare-const ?bbse Real)
      (declare-const ?bbsf Real)
      (declare-const ?bbsg Real)
      (assert
        (or (and (or (or (= ?bbsd ?bbsc)
                (= ?bbsd ?bbsb)
                )
              (= ?bbsc ?bbsb)
              )
            (or (or (= ?bbsg ?bbsf)
                (= ?bbsg ?bbse)
                )
              (= ?bbsf ?bbse)
              )
            )
          (and (and (and (not (= ?bbsd ?bbsc))
                (not (= ?bbsd ?bbsb))
                )
              (not (= ?bbsc ?bbsb))
              )
            (and (and (not (= ?bbsg ?bbsf))
                (not (= ?bbsg ?bbse))
                )
              (not (= ?bbsf ?bbse))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbsh Real)
      (declare-const ?bbsi Real)
      (declare-const ?bbsj Real)
      (assert
        (and (and (not (= ?bbsj ?bbsi))
            (not (= ?bbsj ?bbsh))
            )
          (not (= ?bbsi ?bbsh))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbsk Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbsl Real)
      (declare-const ?bbsm Real)
      (declare-const ?bbsn Real)
      (assert
        (and (and (not (= ?bbsn ?bbsm))
            (not (= ?bbsn ?bbsl))
            )
          (not (= ?bbsm ?bbsl))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bbso Real)
      (declare-const ?bbsp Real)
      (declare-const ?bbsq Real)
      (assert
        (and (and (not (= ?bbsq ?bbsp))
            (not (= ?bbsq ?bbso))
            )
          (not (= ?bbsp ?bbso))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbsr Real)
      (declare-const ?bbss Real)
      (declare-const ?bbst Real)
      (declare-const ?bbsu Real)
      (assert
        (and (and (not (= ?bbst ?bbss))
            (not (= ?bbst ?bbsr))
            )
          (not (= ?bbss ?bbsr))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbsv Real)
      (declare-const ?bbsw Real)
      (declare-const ?bbsx Real)
      (declare-const ?bbsy Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bbsw ?bbsv)
                  (= ?bbsw ?awmg)
                  )
                (= ?bbsv ?awmg)
                )
              (or (or (= ?bbsy ?bbsx)
                  (= ?bbsy ?awmg)
                  )
                (= ?bbsx ?awmg)
                )
              )
            (and (not (= ?bbsw ?bbsv))
              (and (and (not (= ?bbsy ?bbsx))
                  (not (= ?bbsy ?awmg))
                  )
                (not (= ?bbsx ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbsz Real)
      (declare-const ?bbta Real)
      (declare-const ?bbtb Real)
      (assert
        (and (and (not (= ?bbtb ?bbta))
            (not (= ?bbtb ?bbsz))
            )
          (not (= ?bbta ?bbsz))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbtc Real)
      (declare-const ?bbtd Real)
      (declare-const ?bbte Real)
      (declare-const ?bbtf Real)
      (assert
        (and (and (not (= ?bbtf ?bbte))
            (not (= ?bbtf ?bbtd))
            )
          (not (= ?bbte ?bbtd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbtg Real)
      (declare-const ?bbth Real)
      (declare-const ?bbti Real)
      (declare-const ?bbtj Real)
      (declare-const ?bbtk Real)
      (declare-const ?bbtl Real)
      (assert
        (or (and (or (or (= ?bbti ?bbth)
                (= ?bbti ?bbtg)
                )
              (= ?bbth ?bbtg)
              )
            (or (or (= ?bbtl ?bbtk)
                (= ?bbtl ?bbtj)
                )
              (= ?bbtk ?bbtj)
              )
            )
          (and (and (and (not (= ?bbti ?bbth))
                (not (= ?bbti ?bbtg))
                )
              (not (= ?bbth ?bbtg))
              )
            (and (and (not (= ?bbtl ?bbtk))
                (not (= ?bbtl ?bbtj))
                )
              (not (= ?bbtk ?bbtj))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbtm Real)
      (declare-const ?bbtn Real)
      (declare-const ?bbto Real)
      (assert
        (and (and (not (= ?bbto ?bbtn))
            (not (= ?bbto ?bbtm))
            )
          (not (= ?bbtn ?bbtm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bbtp Real)
      (declare-const ?bbtq Real)
      (declare-const ?bbtr Real)
      (assert
        (and (and (not (= ?bbtr ?bbtq))
            (not (= ?bbtr ?bbtp))
            )
          (not (= ?bbtq ?bbtp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bbts Real)
  (declare-const ?bbtt Real)
  (declare-const ?bbtu Real)
  (declare-const ?bbtv Real)
  (declare-const ?bbtw Real)
  (declare-const ?bbtx Real)
  (assert
    (and (or (or (= ?bbtu ?bbtt)
          (= ?bbtu ?bbts)
          )
        (= ?bbtt ?bbts)
        )
      (or (or (= ?bbtx ?bbtw)
          (= ?bbtx ?bbtv)
          )
        (= ?bbtw ?bbtv)
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bbty Real)
  (declare-const ?bbtz Real)
  (declare-const ?bbua Real)
  (assert
    (and (and (not (= ?bbua ?bbtz))
        (not (= ?bbua ?bbty))
        )
      (not (= ?bbtz ?bbty))
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bbub Real)
  (declare-const ?bbuc Real)
  (declare-const ?bbud Real)
  (declare-const ?bbue Real)
  (assert
    (and (and (not (= ?bbud ?bbuc))
        (not (= ?bbud ?bbub))
        )
      (not (= ?bbuc ?bbub))
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bbuf Real)
  (declare-const ?bbug Real)
  (declare-const ?bbuh Real)
  (declare-const ?bbui Real)
  (declare-const ?bbuj Real)
  (assert
    (and (and (not (= ?bbuh ?bbug))
        (not (= ?bbuh ?bbuf))
        )
      (not (= ?bbug ?bbuf))
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bbuk Real)
  (declare-const ?bbul Real)
  (declare-const ?bbum Real)
  (assert
    (and (and (not (= ?bbum ?bbul))
        (not (= ?bbum ?bbuk))
        )
      (not (= ?bbul ?bbuk))
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bbun Real)
  (declare-const ?bbuo Real)
  (declare-const ?bbup Real)
  (declare-const ?bbuq Real)
  (assert
    (and (and (not (= ?bbuq ?bbup))
        (not (= ?bbuq ?bbuo))
        )
      (not (= ?bbup ?bbuo))
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bbur Real)
  (declare-const ?bbus Real)
  (declare-const ?bbut Real)
  (declare-const ?bbuu Real)
  (declare-const ?bbuv Real)
  (assert
    (and (and (not (= ?bbuv ?bbuu))
        (not (= ?bbuv ?bbut))
        )
      (not (= ?bbuu ?bbut))
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bbuw Real)
  (declare-const ?bbux Real)
  (declare-const ?bbuy Real)
  (declare-const ?bbuz Real)
  (declare-const ?bbva Real)
  (declare-const ?bbvb Real)
  (assert
    (and (and (and (not (= ?bbuy ?bbux))
          (not (= ?bbuy ?bbuw))
          )
        (not (= ?bbux ?bbuw))
        )
      (and (and (not (= ?bbvb ?bbva))
          (not (= ?bbvb ?bbuz))
          )
        (not (= ?bbva ?bbuz))
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bbvc Real)
  (declare-const ?bbvd Real)
  (declare-const ?bbve Real)
  (assert
    (and (and (not (= ?bbve ?bbvd))
        (not (= ?bbve ?bbvc))
        )
      (not (= ?bbvd ?bbvc))
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bbvf Real)
  (declare-const ?bbvg Real)
  (declare-const ?bbvh Real)
  (assert
    (and (and (not (= ?bbvh ?bbvg))
        (not (= ?bbvh ?bbvf))
        )
      (not (= ?bbvg ?bbvf))
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?bbvi Real)
    (declare-const ?bbvj Real)
    (declare-const ?bbvk Real)
    (assert
      (and (and (not (= ?bbvk ?bbvj))
          (not (= ?bbvk ?bbvi))
          )
        (not (= ?bbvj ?bbvi))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bbvl Real)
    (declare-const ?bbvm Real)
    (declare-const ?bbvn Real)
    (declare-const ?bbvo Real)
    (assert
      (and (and (not (= ?bbvn ?bbvm))
          (not (= ?bbvn ?bbvl))
          )
        (not (= ?bbvm ?bbvl))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bbvp Real)
    (declare-const ?bbvq Real)
    (declare-const ?bbvr Real)
    (declare-const ?bbvs Real)
    (assert
      (forall ((?awmg Real) )(or (and (or (or (= ?bbvq ?bbvp)
                (= ?bbvq ?awmg)
                )
              (= ?bbvp ?awmg)
              )
            (or (or (= ?bbvs ?bbvr)
                (= ?bbvs ?awmg)
                )
              (= ?bbvr ?awmg)
              )
            )
          (and (not (= ?bbvq ?bbvp))
            (and (and (not (= ?bbvs ?bbvr))
                (not (= ?bbvs ?awmg))
                )
              (not (= ?bbvr ?awmg))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bbvt Real)
    (declare-const ?bbvu Real)
    (declare-const ?bbvv Real)
    (assert
      (and (and (not (= ?bbvv ?bbvu))
          (not (= ?bbvv ?bbvt))
          )
        (not (= ?bbvu ?bbvt))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bbvw Real)
    (declare-const ?bbvx Real)
    (declare-const ?bbvy Real)
    (declare-const ?bbvz Real)
    (assert
      (and (and (not (= ?bbvz ?bbvy))
          (not (= ?bbvz ?bbvx))
          )
        (not (= ?bbvy ?bbvx))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bbwa Real)
    (declare-const ?bbwb Real)
    (declare-const ?bbwc Real)
    (declare-const ?bbwd Real)
    (declare-const ?bbwe Real)
    (declare-const ?bbwf Real)
    (assert
      (or (and (or (or (= ?bbwc ?bbwb)
              (= ?bbwc ?bbwa)
              )
            (= ?bbwb ?bbwa)
            )
          (or (or (= ?bbwf ?bbwe)
              (= ?bbwf ?bbwd)
              )
            (= ?bbwe ?bbwd)
            )
          )
        (and (and (and (not (= ?bbwc ?bbwb))
              (not (= ?bbwc ?bbwa))
              )
            (not (= ?bbwb ?bbwa))
            )
          (and (and (not (= ?bbwf ?bbwe))
              (not (= ?bbwf ?bbwd))
              )
            (not (= ?bbwe ?bbwd))
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bbwg Real)
    (declare-const ?bbwh Real)
    (declare-const ?bbwi Real)
    (assert
      (and (and (not (= ?bbwi ?bbwh))
          (not (= ?bbwi ?bbwg))
          )
        (not (= ?bbwh ?bbwg))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bbwj Real)
    (declare-const ?bbwk Real)
    (declare-const ?bbwl Real)
    (assert
      (and (and (not (= ?bbwl ?bbwk))
          (not (= ?bbwl ?bbwj))
          )
        (not (= ?bbwk ?bbwj))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (push 1)
      (push 1)
        (declare-const ?bbws Real)
        (declare-const ?bbwt Real)
        (declare-const ?bbwu Real)
        (assert
          (and (and (not (= ?bbwu ?bbwt))
              (not (= ?bbwu ?bbws))
              )
            (not (= ?bbwt ?bbws))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bbwv Real)
        (declare-const ?bbww Real)
        (declare-const ?bbwx Real)
        (declare-const ?bbwy Real)
        (assert
          (and (and (not (= ?bbwx ?bbww))
              (not (= ?bbwx ?bbwv))
              )
            (not (= ?bbww ?bbwv))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bbwz Real)
        (declare-const ?bbxa Real)
        (declare-const ?bbxb Real)
        (declare-const ?bbxc Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bbxa ?bbwz)
                    (= ?bbxa ?awmg)
                    )
                  (= ?bbwz ?awmg)
                  )
                (or (or (= ?bbxc ?bbxb)
                    (= ?bbxc ?awmg)
                    )
                  (= ?bbxb ?awmg)
                  )
                )
              (and (not (= ?bbxa ?bbwz))
                (and (and (not (= ?bbxc ?bbxb))
                    (not (= ?bbxc ?awmg))
                    )
                  (not (= ?bbxb ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bbxd Real)
        (declare-const ?bbxe Real)
        (declare-const ?bbxf Real)
        (assert
          (and (and (not (= ?bbxf ?bbxe))
              (not (= ?bbxf ?bbxd))
              )
            (not (= ?bbxe ?bbxd))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bbxg Real)
        (declare-const ?bbxh Real)
        (declare-const ?bbxi Real)
        (declare-const ?bbxj Real)
        (assert
          (and (and (not (= ?bbxj ?bbxi))
              (not (= ?bbxj ?bbxh))
              )
            (not (= ?bbxi ?bbxh))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bbxk Real)
        (declare-const ?bbxl Real)
        (declare-const ?bbxm Real)
        (declare-const ?bbxn Real)
        (declare-const ?bbxo Real)
        (declare-const ?bbxp Real)
        (assert
          (or (and (or (or (= ?bbxm ?bbxl)
                  (= ?bbxm ?bbxk)
                  )
                (= ?bbxl ?bbxk)
                )
              (or (or (= ?bbxp ?bbxo)
                  (= ?bbxp ?bbxn)
                  )
                (= ?bbxo ?bbxn)
                )
              )
            (and (and (and (not (= ?bbxm ?bbxl))
                  (not (= ?bbxm ?bbxk))
                  )
                (not (= ?bbxl ?bbxk))
                )
              (and (and (not (= ?bbxp ?bbxo))
                  (not (= ?bbxp ?bbxn))
                  )
                (not (= ?bbxo ?bbxn))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bbxq Real)
        (declare-const ?bbxr Real)
        (declare-const ?bbxs Real)
        (assert
          (and (and (not (= ?bbxs ?bbxr))
              (not (= ?bbxs ?bbxq))
              )
            (not (= ?bbxr ?bbxq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bbxt Real)
        (declare-const ?bbxu Real)
        (declare-const ?bbxv Real)
        (assert
          (and (and (not (= ?bbxv ?bbxu))
              (not (= ?bbxv ?bbxt))
              )
            (not (= ?bbxu ?bbxt))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bbxw Real)
          (push 1)
            (declare-const ?bbxx Real)
            (push 1)
              (declare-const ?bbxy Real)
              (push 1)
                (assert
                  (and (= ?bbxx ?bbxw)
                    (= ?bbxy ?bbxw)
                    )
                  )
                (push 1)
                  (declare-const ?bbxz Real)
                  (declare-const ?bbya Real)
                  (declare-const ?bbyb Real)
                  (assert
                    (and (and (not (= ?bbyb ?bbya))
                        (not (= ?bbyb ?bbxz))
                        )
                      (not (= ?bbya ?bbxz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bbyc Real)
                  (declare-const ?bbyd Real)
                  (declare-const ?bbye Real)
                  (declare-const ?bbyf Real)
                  (assert
                    (and (and (not (= ?bbye ?bbyd))
                        (not (= ?bbye ?bbyc))
                        )
                      (not (= ?bbyd ?bbyc))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bbyg Real)
                  (declare-const ?bbyh Real)
                  (declare-const ?bbyi Real)
                  (declare-const ?bbyj Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bbyh ?bbyg)
                              (= ?bbyh ?awmg)
                              )
                            (= ?bbyg ?awmg)
                            )
                          (or (or (= ?bbyj ?bbyi)
                              (= ?bbyj ?awmg)
                              )
                            (= ?bbyi ?awmg)
                            )
                          )
                        (and (not (= ?bbyh ?bbyg))
                          (and (and (not (= ?bbyj ?bbyi))
                              (not (= ?bbyj ?awmg))
                              )
                            (not (= ?bbyi ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bbyk Real)
                  (declare-const ?bbyl Real)
                  (declare-const ?bbym Real)
                  (assert
                    (and (and (not (= ?bbym ?bbyl))
                        (not (= ?bbym ?bbyk))
                        )
                      (not (= ?bbyl ?bbyk))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bbyn Real)
                  (declare-const ?bbyo Real)
                  (declare-const ?bbyp Real)
                  (declare-const ?bbyq Real)
                  (assert
                    (and (and (not (= ?bbyq ?bbyp))
                        (not (= ?bbyq ?bbyo))
                        )
                      (not (= ?bbyp ?bbyo))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bbyr Real)
                  (declare-const ?bbys Real)
                  (declare-const ?bbyt Real)
                  (declare-const ?bbyu Real)
                  (declare-const ?bbyv Real)
                  (declare-const ?bbyw Real)
                  (assert
                    (or (and (or (or (= ?bbyt ?bbys)
                            (= ?bbyt ?bbyr)
                            )
                          (= ?bbys ?bbyr)
                          )
                        (or (or (= ?bbyw ?bbyv)
                            (= ?bbyw ?bbyu)
                            )
                          (= ?bbyv ?bbyu)
                          )
                        )
                      (and (and (and (not (= ?bbyt ?bbys))
                            (not (= ?bbyt ?bbyr))
                            )
                          (not (= ?bbys ?bbyr))
                          )
                        (and (and (not (= ?bbyw ?bbyv))
                            (not (= ?bbyw ?bbyu))
                            )
                          (not (= ?bbyv ?bbyu))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bbyx Real)
                  (declare-const ?bbyy Real)
                  (declare-const ?bbyz Real)
                  (assert
                    (and (and (not (= ?bbyz ?bbyy))
                        (not (= ?bbyz ?bbyx))
                        )
                      (not (= ?bbyy ?bbyx))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bbza Real)
                  (declare-const ?bbzb Real)
                  (declare-const ?bbzc Real)
                  (assert
                    (and (and (not (= ?bbzc ?bbzb))
                        (not (= ?bbzc ?bbza))
                        )
                      (not (= ?bbzb ?bbza))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bbzd Real)
      (push 1)
        (declare-const ?bbze Real)
        (declare-const ?bbzf Real)
        (declare-const ?bbzg Real)
        (assert
          (and (and (not (= ?bbzg ?bbzf))
              (not (= ?bbzg ?bbze))
              )
            (not (= ?bbzf ?bbze))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bbzh Real)
        (declare-const ?bbzi Real)
        (declare-const ?bbzj Real)
        (declare-const ?bbzk Real)
        (assert
          (and (and (not (= ?bbzj ?bbzi))
              (not (= ?bbzj ?bbzh))
              )
            (not (= ?bbzi ?bbzh))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bbzl Real)
        (declare-const ?bbzm Real)
        (declare-const ?bbzn Real)
        (declare-const ?bbzo Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bbzm ?bbzl)
                    (= ?bbzm ?awmg)
                    )
                  (= ?bbzl ?awmg)
                  )
                (or (or (= ?bbzo ?bbzn)
                    (= ?bbzo ?awmg)
                    )
                  (= ?bbzn ?awmg)
                  )
                )
              (and (not (= ?bbzm ?bbzl))
                (and (and (not (= ?bbzo ?bbzn))
                    (not (= ?bbzo ?awmg))
                    )
                  (not (= ?bbzn ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bbzp Real)
        (declare-const ?bbzq Real)
        (declare-const ?bbzr Real)
        (assert
          (and (and (not (= ?bbzr ?bbzq))
              (not (= ?bbzr ?bbzp))
              )
            (not (= ?bbzq ?bbzp))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bbzs Real)
        (declare-const ?bbzt Real)
        (declare-const ?bbzu Real)
        (declare-const ?bbzv Real)
        (assert
          (and (and (not (= ?bbzv ?bbzu))
              (not (= ?bbzv ?bbzt))
              )
            (not (= ?bbzu ?bbzt))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bbzw Real)
        (declare-const ?bbzx Real)
        (declare-const ?bbzy Real)
        (declare-const ?bbzz Real)
        (declare-const ?bcaa Real)
        (declare-const ?bcab Real)
        (assert
          (or (and (or (or (= ?bbzy ?bbzx)
                  (= ?bbzy ?bbzw)
                  )
                (= ?bbzx ?bbzw)
                )
              (or (or (= ?bcab ?bcaa)
                  (= ?bcab ?bbzz)
                  )
                (= ?bcaa ?bbzz)
                )
              )
            (and (and (and (not (= ?bbzy ?bbzx))
                  (not (= ?bbzy ?bbzw))
                  )
                (not (= ?bbzx ?bbzw))
                )
              (and (and (not (= ?bcab ?bcaa))
                  (not (= ?bcab ?bbzz))
                  )
                (not (= ?bcaa ?bbzz))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcac Real)
        (declare-const ?bcad Real)
        (declare-const ?bcae Real)
        (assert
          (and (and (not (= ?bcae ?bcad))
              (not (= ?bcae ?bcac))
              )
            (not (= ?bcad ?bcac))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcaf Real)
        (declare-const ?bcag Real)
        (declare-const ?bcah Real)
        (assert
          (and (and (not (= ?bcah ?bcag))
              (not (= ?bcah ?bcaf))
              )
            (not (= ?bcag ?bcaf))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bcai Real)
          (push 1)
            (declare-const ?bcaj Real)
            (push 1)
              (declare-const ?bcak Real)
              (declare-const ?bcal Real)
              (push 1)
                (assert
                  (and (and (= ?bcaj ?bcai)
                      (= ?bcak ?bbzd)
                      )
                    (= ?bcal ?bcai)
                    )
                  )
                (push 1)
                  (declare-const ?bcam Real)
                  (declare-const ?bcan Real)
                  (declare-const ?bcao Real)
                  (assert
                    (and (and (not (= ?bcao ?bcan))
                        (not (= ?bcao ?bcam))
                        )
                      (not (= ?bcan ?bcam))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcap Real)
                  (declare-const ?bcaq Real)
                  (declare-const ?bcar Real)
                  (declare-const ?bcas Real)
                  (assert
                    (and (and (not (= ?bcar ?bcaq))
                        (not (= ?bcar ?bcap))
                        )
                      (not (= ?bcaq ?bcap))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcat Real)
                  (declare-const ?bcau Real)
                  (declare-const ?bcav Real)
                  (declare-const ?bcaw Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bcau ?bcat)
                              (= ?bcau ?awmg)
                              )
                            (= ?bcat ?awmg)
                            )
                          (or (or (= ?bcaw ?bcav)
                              (= ?bcaw ?awmg)
                              )
                            (= ?bcav ?awmg)
                            )
                          )
                        (and (not (= ?bcau ?bcat))
                          (and (and (not (= ?bcaw ?bcav))
                              (not (= ?bcaw ?awmg))
                              )
                            (not (= ?bcav ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcax Real)
                  (declare-const ?bcay Real)
                  (declare-const ?bcaz Real)
                  (assert
                    (and (and (not (= ?bcaz ?bcay))
                        (not (= ?bcaz ?bcax))
                        )
                      (not (= ?bcay ?bcax))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcba Real)
                  (declare-const ?bcbb Real)
                  (declare-const ?bcbc Real)
                  (declare-const ?bcbd Real)
                  (assert
                    (and (and (not (= ?bcbd ?bcbc))
                        (not (= ?bcbd ?bcbb))
                        )
                      (not (= ?bcbc ?bcbb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcbe Real)
                  (declare-const ?bcbf Real)
                  (declare-const ?bcbg Real)
                  (declare-const ?bcbh Real)
                  (declare-const ?bcbi Real)
                  (declare-const ?bcbj Real)
                  (assert
                    (or (and (or (or (= ?bcbg ?bcbf)
                            (= ?bcbg ?bcbe)
                            )
                          (= ?bcbf ?bcbe)
                          )
                        (or (or (= ?bcbj ?bcbi)
                            (= ?bcbj ?bcbh)
                            )
                          (= ?bcbi ?bcbh)
                          )
                        )
                      (and (and (and (not (= ?bcbg ?bcbf))
                            (not (= ?bcbg ?bcbe))
                            )
                          (not (= ?bcbf ?bcbe))
                          )
                        (and (and (not (= ?bcbj ?bcbi))
                            (not (= ?bcbj ?bcbh))
                            )
                          (not (= ?bcbi ?bcbh))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcbk Real)
                  (declare-const ?bcbl Real)
                  (declare-const ?bcbm Real)
                  (assert
                    (and (and (not (= ?bcbm ?bcbl))
                        (not (= ?bcbm ?bcbk))
                        )
                      (not (= ?bcbl ?bcbk))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcbn Real)
                  (declare-const ?bcbo Real)
                  (declare-const ?bcbp Real)
                  (assert
                    (and (and (not (= ?bcbp ?bcbo))
                        (not (= ?bcbp ?bcbn))
                        )
                      (not (= ?bcbo ?bcbn))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bcbq Real)
      (declare-const ?bcbr Real)
      (push 1)
        (declare-const ?bcbs Real)
        (declare-const ?bcbt Real)
        (declare-const ?bcbu Real)
        (assert
          (and (and (not (= ?bcbu ?bcbt))
              (not (= ?bcbu ?bcbs))
              )
            (not (= ?bcbt ?bcbs))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcbv Real)
        (declare-const ?bcbw Real)
        (declare-const ?bcbx Real)
        (declare-const ?bcby Real)
        (assert
          (and (and (not (= ?bcbx ?bcbw))
              (not (= ?bcbx ?bcbv))
              )
            (not (= ?bcbw ?bcbv))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcbz Real)
        (declare-const ?bcca Real)
        (declare-const ?bccb Real)
        (declare-const ?bccc Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bcca ?bcbz)
                    (= ?bcca ?awmg)
                    )
                  (= ?bcbz ?awmg)
                  )
                (or (or (= ?bccc ?bccb)
                    (= ?bccc ?awmg)
                    )
                  (= ?bccb ?awmg)
                  )
                )
              (and (not (= ?bcca ?bcbz))
                (and (and (not (= ?bccc ?bccb))
                    (not (= ?bccc ?awmg))
                    )
                  (not (= ?bccb ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bccd Real)
        (declare-const ?bcce Real)
        (declare-const ?bccf Real)
        (assert
          (and (and (not (= ?bccf ?bcce))
              (not (= ?bccf ?bccd))
              )
            (not (= ?bcce ?bccd))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bccg Real)
        (declare-const ?bcch Real)
        (declare-const ?bcci Real)
        (declare-const ?bccj Real)
        (assert
          (and (and (not (= ?bccj ?bcci))
              (not (= ?bccj ?bcch))
              )
            (not (= ?bcci ?bcch))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcck Real)
        (declare-const ?bccl Real)
        (declare-const ?bccm Real)
        (declare-const ?bccn Real)
        (declare-const ?bcco Real)
        (declare-const ?bccp Real)
        (assert
          (or (and (or (or (= ?bccm ?bccl)
                  (= ?bccm ?bcck)
                  )
                (= ?bccl ?bcck)
                )
              (or (or (= ?bccp ?bcco)
                  (= ?bccp ?bccn)
                  )
                (= ?bcco ?bccn)
                )
              )
            (and (and (and (not (= ?bccm ?bccl))
                  (not (= ?bccm ?bcck))
                  )
                (not (= ?bccl ?bcck))
                )
              (and (and (not (= ?bccp ?bcco))
                  (not (= ?bccp ?bccn))
                  )
                (not (= ?bcco ?bccn))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bccq Real)
        (declare-const ?bccr Real)
        (declare-const ?bccs Real)
        (assert
          (and (and (not (= ?bccs ?bccr))
              (not (= ?bccs ?bccq))
              )
            (not (= ?bccr ?bccq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcct Real)
        (declare-const ?bccu Real)
        (declare-const ?bccv Real)
        (assert
          (and (and (not (= ?bccv ?bccu))
              (not (= ?bccv ?bcct))
              )
            (not (= ?bccu ?bcct))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bccw Real)
      (declare-const ?bccx Real)
      (declare-const ?bccy Real)
      (push 1)
        (declare-const ?bccz Real)
        (declare-const ?bcda Real)
        (declare-const ?bcdb Real)
        (assert
          (and (and (not (= ?bcdb ?bcda))
              (not (= ?bcdb ?bccz))
              )
            (not (= ?bcda ?bccz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcdc Real)
        (declare-const ?bcdd Real)
        (declare-const ?bcde Real)
        (declare-const ?bcdf Real)
        (assert
          (and (and (not (= ?bcde ?bcdd))
              (not (= ?bcde ?bcdc))
              )
            (not (= ?bcdd ?bcdc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcdg Real)
        (declare-const ?bcdh Real)
        (declare-const ?bcdi Real)
        (declare-const ?bcdj Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bcdh ?bcdg)
                    (= ?bcdh ?awmg)
                    )
                  (= ?bcdg ?awmg)
                  )
                (or (or (= ?bcdj ?bcdi)
                    (= ?bcdj ?awmg)
                    )
                  (= ?bcdi ?awmg)
                  )
                )
              (and (not (= ?bcdh ?bcdg))
                (and (and (not (= ?bcdj ?bcdi))
                    (not (= ?bcdj ?awmg))
                    )
                  (not (= ?bcdi ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcdk Real)
        (declare-const ?bcdl Real)
        (declare-const ?bcdm Real)
        (assert
          (and (and (not (= ?bcdm ?bcdl))
              (not (= ?bcdm ?bcdk))
              )
            (not (= ?bcdl ?bcdk))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcdn Real)
        (declare-const ?bcdo Real)
        (declare-const ?bcdp Real)
        (declare-const ?bcdq Real)
        (assert
          (and (and (not (= ?bcdq ?bcdp))
              (not (= ?bcdq ?bcdo))
              )
            (not (= ?bcdp ?bcdo))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcdr Real)
        (declare-const ?bcds Real)
        (declare-const ?bcdt Real)
        (declare-const ?bcdu Real)
        (declare-const ?bcdv Real)
        (declare-const ?bcdw Real)
        (assert
          (or (and (or (or (= ?bcdt ?bcds)
                  (= ?bcdt ?bcdr)
                  )
                (= ?bcds ?bcdr)
                )
              (or (or (= ?bcdw ?bcdv)
                  (= ?bcdw ?bcdu)
                  )
                (= ?bcdv ?bcdu)
                )
              )
            (and (and (and (not (= ?bcdt ?bcds))
                  (not (= ?bcdt ?bcdr))
                  )
                (not (= ?bcds ?bcdr))
                )
              (and (and (not (= ?bcdw ?bcdv))
                  (not (= ?bcdw ?bcdu))
                  )
                (not (= ?bcdv ?bcdu))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcdx Real)
        (declare-const ?bcdy Real)
        (declare-const ?bcdz Real)
        (assert
          (and (and (not (= ?bcdz ?bcdy))
              (not (= ?bcdz ?bcdx))
              )
            (not (= ?bcdy ?bcdx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcea Real)
        (declare-const ?bceb Real)
        (declare-const ?bcec Real)
        (assert
          (and (and (not (= ?bcec ?bceb))
              (not (= ?bcec ?bcea))
              )
            (not (= ?bceb ?bcea))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?bccy ?bccx))
              (not (= ?bccy ?bccw))
              )
            (not (= ?bccx ?bccw))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bced Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bcee Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bcef Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bceg Real)
              (declare-const ?bceh Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcei Real)
              (declare-const ?bcej Real)
              (declare-const ?bcek Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcel Real)
              (declare-const ?bcem Real)
              (declare-const ?bcen Real)
              (declare-const ?bceo Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (= ?bcee ?bced)
                      (and (and (= ?bcen ?bccy)
                          (= ?bcem ?bccx)
                          )
                        (= ?bcel ?bccw)
                        )
                      )
                    (= ?bceo ?bced)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcep Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bceq Real)
                  (declare-const ?bcer Real)
                  (declare-const ?bces Real)
                  (assert
                    (and (and (not (= ?bces ?bcer))
                        (not (= ?bces ?bceq))
                        )
                      (not (= ?bcer ?bceq))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcet Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bceu Real)
                  (declare-const ?bcev Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcew Real)
                  (declare-const ?bcex Real)
                  (declare-const ?bcey Real)
                  (declare-const ?bcez Real)
                  (assert
                    (and (and (not (= ?bcey ?bcex))
                        (not (= ?bcey ?bcew))
                        )
                      (not (= ?bcex ?bcew))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcfa Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcfb Real)
                  (declare-const ?bcfc Real)
                  (declare-const ?bcfd Real)
                  (declare-const ?bcfe Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bcfc ?bcfb)
                              (= ?bcfc ?awmg)
                              )
                            (= ?bcfb ?awmg)
                            )
                          (or (or (= ?bcfe ?bcfd)
                              (= ?bcfe ?awmg)
                              )
                            (= ?bcfd ?awmg)
                            )
                          )
                        (and (not (= ?bcfc ?bcfb))
                          (and (and (not (= ?bcfe ?bcfd))
                              (not (= ?bcfe ?awmg))
                              )
                            (not (= ?bcfd ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcff Real)
                  (declare-const ?bcfg Real)
                  (declare-const ?bcfh Real)
                  (assert
                    (and (and (not (= ?bcfh ?bcfg))
                        (not (= ?bcfh ?bcff))
                        )
                      (not (= ?bcfg ?bcff))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcfi Real)
                  (declare-const ?bcfj Real)
                  (declare-const ?bcfk Real)
                  (declare-const ?bcfl Real)
                  (assert
                    (and (and (not (= ?bcfl ?bcfk))
                        (not (= ?bcfl ?bcfj))
                        )
                      (not (= ?bcfk ?bcfj))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcfm Real)
                  (declare-const ?bcfn Real)
                  (declare-const ?bcfo Real)
                  (declare-const ?bcfp Real)
                  (declare-const ?bcfq Real)
                  (declare-const ?bcfr Real)
                  (assert
                    (or (and (or (or (= ?bcfo ?bcfn)
                            (= ?bcfo ?bcfm)
                            )
                          (= ?bcfn ?bcfm)
                          )
                        (or (or (= ?bcfr ?bcfq)
                            (= ?bcfr ?bcfp)
                            )
                          (= ?bcfq ?bcfp)
                          )
                        )
                      (and (and (and (not (= ?bcfo ?bcfn))
                            (not (= ?bcfo ?bcfm))
                            )
                          (not (= ?bcfn ?bcfm))
                          )
                        (and (and (not (= ?bcfr ?bcfq))
                            (not (= ?bcfr ?bcfp))
                            )
                          (not (= ?bcfq ?bcfp))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcfs Real)
                  (declare-const ?bcft Real)
                  (declare-const ?bcfu Real)
                  (assert
                    (and (and (not (= ?bcfu ?bcft))
                        (not (= ?bcfu ?bcfs))
                        )
                      (not (= ?bcft ?bcfs))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcfv Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcfw Real)
                  (declare-const ?bcfx Real)
                  (declare-const ?bcfy Real)
                  (assert
                    (and (and (not (= ?bcfy ?bcfx))
                        (not (= ?bcfy ?bcfw))
                        )
                      (not (= ?bcfx ?bcfw))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?bcfz Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bcga Real)
            (declare-const ?bcgb Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bcgc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcgd Real)
              (declare-const ?bcge Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcgf Real)
              (declare-const ?bcgg Real)
              (declare-const ?bcgh Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcgi Real)
              (declare-const ?bcgj Real)
              (declare-const ?bcgk Real)
              (declare-const ?bcgl Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcgm Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bcgn Real)
            (declare-const ?bcgo Real)
            (declare-const ?bcgp Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bcgq Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcgr Real)
              (declare-const ?bcgs Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcgt Real)
              (declare-const ?bcgu Real)
              (declare-const ?bcgv Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcgw Real)
              (declare-const ?bcgx Real)
              (declare-const ?bcgy Real)
              (declare-const ?bcgz Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcha Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bchb Real)
            (declare-const ?bchc Real)
            (declare-const ?bchd Real)
            (declare-const ?bche Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bchf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bchg Real)
              (declare-const ?bchh Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bchi Real)
              (declare-const ?bchj Real)
              (declare-const ?bchk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bchl Real)
              (declare-const ?bchm Real)
              (declare-const ?bchn Real)
              (declare-const ?bcho Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bchp Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bchq Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bchr Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bchs Real)
              (declare-const ?bcht Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bchu Real)
              (declare-const ?bchv Real)
              (declare-const ?bchw Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bchx Real)
              (declare-const ?bchy Real)
              (declare-const ?bchz Real)
              (declare-const ?bcia Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcib Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (declare-const ?bcic Real)
        (declare-const ?bcid Real)
        (declare-const ?bcie Real)
        (assert
          (and (and (not (= ?bcie ?bcid))
              (not (= ?bcie ?bcic))
              )
            (not (= ?bcid ?bcic))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcif Real)
        (declare-const ?bcig Real)
        (declare-const ?bcih Real)
        (declare-const ?bcii Real)
        (assert
          (and (and (not (= ?bcih ?bcig))
              (not (= ?bcih ?bcif))
              )
            (not (= ?bcig ?bcif))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcij Real)
        (declare-const ?bcik Real)
        (declare-const ?bcil Real)
        (declare-const ?bcim Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bcik ?bcij)
                    (= ?bcik ?awmg)
                    )
                  (= ?bcij ?awmg)
                  )
                (or (or (= ?bcim ?bcil)
                    (= ?bcim ?awmg)
                    )
                  (= ?bcil ?awmg)
                  )
                )
              (and (not (= ?bcik ?bcij))
                (and (and (not (= ?bcim ?bcil))
                    (not (= ?bcim ?awmg))
                    )
                  (not (= ?bcil ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcin Real)
        (declare-const ?bcio Real)
        (declare-const ?bcip Real)
        (assert
          (and (and (not (= ?bcip ?bcio))
              (not (= ?bcip ?bcin))
              )
            (not (= ?bcio ?bcin))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bciq Real)
        (declare-const ?bcir Real)
        (declare-const ?bcis Real)
        (declare-const ?bcit Real)
        (assert
          (and (and (not (= ?bcit ?bcis))
              (not (= ?bcit ?bcir))
              )
            (not (= ?bcis ?bcir))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bciu Real)
        (declare-const ?bciv Real)
        (declare-const ?bciw Real)
        (declare-const ?bcix Real)
        (declare-const ?bciy Real)
        (declare-const ?bciz Real)
        (assert
          (or (and (or (or (= ?bciw ?bciv)
                  (= ?bciw ?bciu)
                  )
                (= ?bciv ?bciu)
                )
              (or (or (= ?bciz ?bciy)
                  (= ?bciz ?bcix)
                  )
                (= ?bciy ?bcix)
                )
              )
            (and (and (and (not (= ?bciw ?bciv))
                  (not (= ?bciw ?bciu))
                  )
                (not (= ?bciv ?bciu))
                )
              (and (and (not (= ?bciz ?bciy))
                  (not (= ?bciz ?bcix))
                  )
                (not (= ?bciy ?bcix))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcja Real)
        (declare-const ?bcjb Real)
        (declare-const ?bcjc Real)
        (assert
          (and (and (not (= ?bcjc ?bcjb))
              (not (= ?bcjc ?bcja))
              )
            (not (= ?bcjb ?bcja))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcjd Real)
        (declare-const ?bcje Real)
        (declare-const ?bcjf Real)
        (assert
          (and (and (not (= ?bcjf ?bcje))
              (not (= ?bcjf ?bcjd))
              )
            (not (= ?bcje ?bcjd))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bcjg Real)
          (push 1)
            (declare-const ?bcjh Real)
            (push 1)
              (declare-const ?bcji Real)
              (push 1)
                (assert
                  (and (= ?bcjh ?bcjg)
                    (= ?bcji ?bcjg)
                    )
                  )
                (push 1)
                  (declare-const ?bcjj Real)
                  (declare-const ?bcjk Real)
                  (declare-const ?bcjl Real)
                  (assert
                    (and (and (not (= ?bcjl ?bcjk))
                        (not (= ?bcjl ?bcjj))
                        )
                      (not (= ?bcjk ?bcjj))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcjm Real)
                  (declare-const ?bcjn Real)
                  (declare-const ?bcjo Real)
                  (declare-const ?bcjp Real)
                  (assert
                    (and (and (not (= ?bcjo ?bcjn))
                        (not (= ?bcjo ?bcjm))
                        )
                      (not (= ?bcjn ?bcjm))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcjq Real)
                  (declare-const ?bcjr Real)
                  (declare-const ?bcjs Real)
                  (declare-const ?bcjt Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bcjr ?bcjq)
                              (= ?bcjr ?awmg)
                              )
                            (= ?bcjq ?awmg)
                            )
                          (or (or (= ?bcjt ?bcjs)
                              (= ?bcjt ?awmg)
                              )
                            (= ?bcjs ?awmg)
                            )
                          )
                        (and (not (= ?bcjr ?bcjq))
                          (and (and (not (= ?bcjt ?bcjs))
                              (not (= ?bcjt ?awmg))
                              )
                            (not (= ?bcjs ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcju Real)
                  (declare-const ?bcjv Real)
                  (declare-const ?bcjw Real)
                  (assert
                    (and (and (not (= ?bcjw ?bcjv))
                        (not (= ?bcjw ?bcju))
                        )
                      (not (= ?bcjv ?bcju))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcjx Real)
                  (declare-const ?bcjy Real)
                  (declare-const ?bcjz Real)
                  (declare-const ?bcka Real)
                  (assert
                    (and (and (not (= ?bcka ?bcjz))
                        (not (= ?bcka ?bcjy))
                        )
                      (not (= ?bcjz ?bcjy))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bckb Real)
                  (declare-const ?bckc Real)
                  (declare-const ?bckd Real)
                  (declare-const ?bcke Real)
                  (declare-const ?bckf Real)
                  (declare-const ?bckg Real)
                  (assert
                    (or (and (or (or (= ?bckd ?bckc)
                            (= ?bckd ?bckb)
                            )
                          (= ?bckc ?bckb)
                          )
                        (or (or (= ?bckg ?bckf)
                            (= ?bckg ?bcke)
                            )
                          (= ?bckf ?bcke)
                          )
                        )
                      (and (and (and (not (= ?bckd ?bckc))
                            (not (= ?bckd ?bckb))
                            )
                          (not (= ?bckc ?bckb))
                          )
                        (and (and (not (= ?bckg ?bckf))
                            (not (= ?bckg ?bcke))
                            )
                          (not (= ?bckf ?bcke))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bckh Real)
                  (declare-const ?bcki Real)
                  (declare-const ?bckj Real)
                  (assert
                    (and (and (not (= ?bckj ?bcki))
                        (not (= ?bckj ?bckh))
                        )
                      (not (= ?bcki ?bckh))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bckk Real)
                  (declare-const ?bckl Real)
                  (declare-const ?bckm Real)
                  (assert
                    (and (and (not (= ?bckm ?bckl))
                        (not (= ?bckm ?bckk))
                        )
                      (not (= ?bckl ?bckk))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bckn Real)
    (push 1)
      (push 1)
        (declare-const ?bcko Real)
        (declare-const ?bckp Real)
        (declare-const ?bckq Real)
        (assert
          (and (and (not (= ?bckq ?bckp))
              (not (= ?bckq ?bcko))
              )
            (not (= ?bckp ?bcko))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bckr Real)
        (declare-const ?bcks Real)
        (declare-const ?bckt Real)
        (declare-const ?bcku Real)
        (assert
          (and (and (not (= ?bckt ?bcks))
              (not (= ?bckt ?bckr))
              )
            (not (= ?bcks ?bckr))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bckv Real)
        (declare-const ?bckw Real)
        (declare-const ?bckx Real)
        (declare-const ?bcky Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bckw ?bckv)
                    (= ?bckw ?awmg)
                    )
                  (= ?bckv ?awmg)
                  )
                (or (or (= ?bcky ?bckx)
                    (= ?bcky ?awmg)
                    )
                  (= ?bckx ?awmg)
                  )
                )
              (and (not (= ?bckw ?bckv))
                (and (and (not (= ?bcky ?bckx))
                    (not (= ?bcky ?awmg))
                    )
                  (not (= ?bckx ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bckz Real)
        (declare-const ?bcla Real)
        (declare-const ?bclb Real)
        (assert
          (and (and (not (= ?bclb ?bcla))
              (not (= ?bclb ?bckz))
              )
            (not (= ?bcla ?bckz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bclc Real)
        (declare-const ?bcld Real)
        (declare-const ?bcle Real)
        (declare-const ?bclf Real)
        (assert
          (and (and (not (= ?bclf ?bcle))
              (not (= ?bclf ?bcld))
              )
            (not (= ?bcle ?bcld))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bclg Real)
        (declare-const ?bclh Real)
        (declare-const ?bcli Real)
        (declare-const ?bclj Real)
        (declare-const ?bclk Real)
        (declare-const ?bcll Real)
        (assert
          (or (and (or (or (= ?bcli ?bclh)
                  (= ?bcli ?bclg)
                  )
                (= ?bclh ?bclg)
                )
              (or (or (= ?bcll ?bclk)
                  (= ?bcll ?bclj)
                  )
                (= ?bclk ?bclj)
                )
              )
            (and (and (and (not (= ?bcli ?bclh))
                  (not (= ?bcli ?bclg))
                  )
                (not (= ?bclh ?bclg))
                )
              (and (and (not (= ?bcll ?bclk))
                  (not (= ?bcll ?bclj))
                  )
                (not (= ?bclk ?bclj))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bclm Real)
        (declare-const ?bcln Real)
        (declare-const ?bclo Real)
        (assert
          (and (and (not (= ?bclo ?bcln))
              (not (= ?bclo ?bclm))
              )
            (not (= ?bcln ?bclm))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bclp Real)
        (declare-const ?bclq Real)
        (declare-const ?bclr Real)
        (assert
          (and (and (not (= ?bclr ?bclq))
              (not (= ?bclr ?bclp))
              )
            (not (= ?bclq ?bclp))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bcls Real)
          (push 1)
            (declare-const ?bclt Real)
            (declare-const ?bclu Real)
            (push 1)
              (declare-const ?bclv Real)
              (push 1)
                (assert
                  (and (and (= ?bclt ?bckn)
                      (= ?bclu ?bcls)
                      )
                    (= ?bclv ?bcls)
                    )
                  )
                (push 1)
                  (declare-const ?bclw Real)
                  (declare-const ?bclx Real)
                  (declare-const ?bcly Real)
                  (assert
                    (and (and (not (= ?bcly ?bclx))
                        (not (= ?bcly ?bclw))
                        )
                      (not (= ?bclx ?bclw))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bclz Real)
                  (declare-const ?bcma Real)
                  (declare-const ?bcmb Real)
                  (declare-const ?bcmc Real)
                  (assert
                    (and (and (not (= ?bcmb ?bcma))
                        (not (= ?bcmb ?bclz))
                        )
                      (not (= ?bcma ?bclz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcmd Real)
                  (declare-const ?bcme Real)
                  (declare-const ?bcmf Real)
                  (declare-const ?bcmg Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bcme ?bcmd)
                              (= ?bcme ?awmg)
                              )
                            (= ?bcmd ?awmg)
                            )
                          (or (or (= ?bcmg ?bcmf)
                              (= ?bcmg ?awmg)
                              )
                            (= ?bcmf ?awmg)
                            )
                          )
                        (and (not (= ?bcme ?bcmd))
                          (and (and (not (= ?bcmg ?bcmf))
                              (not (= ?bcmg ?awmg))
                              )
                            (not (= ?bcmf ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcmh Real)
                  (declare-const ?bcmi Real)
                  (declare-const ?bcmj Real)
                  (assert
                    (and (and (not (= ?bcmj ?bcmi))
                        (not (= ?bcmj ?bcmh))
                        )
                      (not (= ?bcmi ?bcmh))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcmk Real)
                  (declare-const ?bcml Real)
                  (declare-const ?bcmm Real)
                  (declare-const ?bcmn Real)
                  (assert
                    (and (and (not (= ?bcmn ?bcmm))
                        (not (= ?bcmn ?bcml))
                        )
                      (not (= ?bcmm ?bcml))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcmo Real)
                  (declare-const ?bcmp Real)
                  (declare-const ?bcmq Real)
                  (declare-const ?bcmr Real)
                  (declare-const ?bcms Real)
                  (declare-const ?bcmt Real)
                  (assert
                    (or (and (or (or (= ?bcmq ?bcmp)
                            (= ?bcmq ?bcmo)
                            )
                          (= ?bcmp ?bcmo)
                          )
                        (or (or (= ?bcmt ?bcms)
                            (= ?bcmt ?bcmr)
                            )
                          (= ?bcms ?bcmr)
                          )
                        )
                      (and (and (and (not (= ?bcmq ?bcmp))
                            (not (= ?bcmq ?bcmo))
                            )
                          (not (= ?bcmp ?bcmo))
                          )
                        (and (and (not (= ?bcmt ?bcms))
                            (not (= ?bcmt ?bcmr))
                            )
                          (not (= ?bcms ?bcmr))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcmu Real)
                  (declare-const ?bcmv Real)
                  (declare-const ?bcmw Real)
                  (assert
                    (and (and (not (= ?bcmw ?bcmv))
                        (not (= ?bcmw ?bcmu))
                        )
                      (not (= ?bcmv ?bcmu))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcmx Real)
                  (declare-const ?bcmy Real)
                  (declare-const ?bcmz Real)
                  (assert
                    (and (and (not (= ?bcmz ?bcmy))
                        (not (= ?bcmz ?bcmx))
                        )
                      (not (= ?bcmy ?bcmx))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bcna Real)
      (push 1)
        (declare-const ?bcnb Real)
        (declare-const ?bcnc Real)
        (declare-const ?bcnd Real)
        (assert
          (and (and (not (= ?bcnd ?bcnc))
              (not (= ?bcnd ?bcnb))
              )
            (not (= ?bcnc ?bcnb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcne Real)
        (declare-const ?bcnf Real)
        (declare-const ?bcng Real)
        (declare-const ?bcnh Real)
        (assert
          (and (and (not (= ?bcng ?bcnf))
              (not (= ?bcng ?bcne))
              )
            (not (= ?bcnf ?bcne))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcni Real)
        (declare-const ?bcnj Real)
        (declare-const ?bcnk Real)
        (declare-const ?bcnl Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bcnj ?bcni)
                    (= ?bcnj ?awmg)
                    )
                  (= ?bcni ?awmg)
                  )
                (or (or (= ?bcnl ?bcnk)
                    (= ?bcnl ?awmg)
                    )
                  (= ?bcnk ?awmg)
                  )
                )
              (and (not (= ?bcnj ?bcni))
                (and (and (not (= ?bcnl ?bcnk))
                    (not (= ?bcnl ?awmg))
                    )
                  (not (= ?bcnk ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcnm Real)
        (declare-const ?bcnn Real)
        (declare-const ?bcno Real)
        (assert
          (and (and (not (= ?bcno ?bcnn))
              (not (= ?bcno ?bcnm))
              )
            (not (= ?bcnn ?bcnm))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcnp Real)
        (declare-const ?bcnq Real)
        (declare-const ?bcnr Real)
        (declare-const ?bcns Real)
        (assert
          (and (and (not (= ?bcns ?bcnr))
              (not (= ?bcns ?bcnq))
              )
            (not (= ?bcnr ?bcnq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcnt Real)
        (declare-const ?bcnu Real)
        (declare-const ?bcnv Real)
        (declare-const ?bcnw Real)
        (declare-const ?bcnx Real)
        (declare-const ?bcny Real)
        (assert
          (or (and (or (or (= ?bcnv ?bcnu)
                  (= ?bcnv ?bcnt)
                  )
                (= ?bcnu ?bcnt)
                )
              (or (or (= ?bcny ?bcnx)
                  (= ?bcny ?bcnw)
                  )
                (= ?bcnx ?bcnw)
                )
              )
            (and (and (and (not (= ?bcnv ?bcnu))
                  (not (= ?bcnv ?bcnt))
                  )
                (not (= ?bcnu ?bcnt))
                )
              (and (and (not (= ?bcny ?bcnx))
                  (not (= ?bcny ?bcnw))
                  )
                (not (= ?bcnx ?bcnw))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcnz Real)
        (declare-const ?bcoa Real)
        (declare-const ?bcob Real)
        (assert
          (and (and (not (= ?bcob ?bcoa))
              (not (= ?bcob ?bcnz))
              )
            (not (= ?bcoa ?bcnz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcoc Real)
        (declare-const ?bcod Real)
        (declare-const ?bcoe Real)
        (assert
          (and (and (not (= ?bcoe ?bcod))
              (not (= ?bcoe ?bcoc))
              )
            (not (= ?bcod ?bcoc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bcof Real)
          (push 1)
            (declare-const ?bcog Real)
            (declare-const ?bcoh Real)
            (push 1)
              (declare-const ?bcoi Real)
              (declare-const ?bcoj Real)
              (push 1)
                (assert
                  (and (and (and (= ?bcog ?bckn)
                        (= ?bcoh ?bcof)
                        )
                      (= ?bcoi ?bcna)
                      )
                    (= ?bcoj ?bcof)
                    )
                  )
                (push 1)
                  (declare-const ?bcok Real)
                  (declare-const ?bcol Real)
                  (declare-const ?bcom Real)
                  (assert
                    (and (and (not (= ?bcom ?bcol))
                        (not (= ?bcom ?bcok))
                        )
                      (not (= ?bcol ?bcok))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcon Real)
                  (declare-const ?bcoo Real)
                  (declare-const ?bcop Real)
                  (declare-const ?bcoq Real)
                  (assert
                    (and (and (not (= ?bcop ?bcoo))
                        (not (= ?bcop ?bcon))
                        )
                      (not (= ?bcoo ?bcon))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcor Real)
                  (declare-const ?bcos Real)
                  (declare-const ?bcot Real)
                  (declare-const ?bcou Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bcos ?bcor)
                              (= ?bcos ?awmg)
                              )
                            (= ?bcor ?awmg)
                            )
                          (or (or (= ?bcou ?bcot)
                              (= ?bcou ?awmg)
                              )
                            (= ?bcot ?awmg)
                            )
                          )
                        (and (not (= ?bcos ?bcor))
                          (and (and (not (= ?bcou ?bcot))
                              (not (= ?bcou ?awmg))
                              )
                            (not (= ?bcot ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcov Real)
                  (declare-const ?bcow Real)
                  (declare-const ?bcox Real)
                  (assert
                    (and (and (not (= ?bcox ?bcow))
                        (not (= ?bcox ?bcov))
                        )
                      (not (= ?bcow ?bcov))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcoy Real)
                  (declare-const ?bcoz Real)
                  (declare-const ?bcpa Real)
                  (declare-const ?bcpb Real)
                  (assert
                    (and (and (not (= ?bcpb ?bcpa))
                        (not (= ?bcpb ?bcoz))
                        )
                      (not (= ?bcpa ?bcoz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcpc Real)
                  (declare-const ?bcpd Real)
                  (declare-const ?bcpe Real)
                  (declare-const ?bcpf Real)
                  (declare-const ?bcpg Real)
                  (declare-const ?bcph Real)
                  (assert
                    (or (and (or (or (= ?bcpe ?bcpd)
                            (= ?bcpe ?bcpc)
                            )
                          (= ?bcpd ?bcpc)
                          )
                        (or (or (= ?bcph ?bcpg)
                            (= ?bcph ?bcpf)
                            )
                          (= ?bcpg ?bcpf)
                          )
                        )
                      (and (and (and (not (= ?bcpe ?bcpd))
                            (not (= ?bcpe ?bcpc))
                            )
                          (not (= ?bcpd ?bcpc))
                          )
                        (and (and (not (= ?bcph ?bcpg))
                            (not (= ?bcph ?bcpf))
                            )
                          (not (= ?bcpg ?bcpf))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcpi Real)
                  (declare-const ?bcpj Real)
                  (declare-const ?bcpk Real)
                  (assert
                    (and (and (not (= ?bcpk ?bcpj))
                        (not (= ?bcpk ?bcpi))
                        )
                      (not (= ?bcpj ?bcpi))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcpl Real)
                  (declare-const ?bcpm Real)
                  (declare-const ?bcpn Real)
                  (assert
                    (and (and (not (= ?bcpn ?bcpm))
                        (not (= ?bcpn ?bcpl))
                        )
                      (not (= ?bcpm ?bcpl))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (assert
                    (exists ((?awmg Real) )(and (or (and (and (not (= ?bcoi ?bcoj))
                              (not (= ?bcoi ?awmg))
                              )
                            (not (= ?bcoj ?awmg))
                            )
                          (and (and (not (= ?bcog ?bcoh))
                              (not (= ?bcog ?awmg))
                              )
                            (not (= ?bcoh ?awmg))
                            )
                          )
                        (or (= ?bcoi ?bcoj)
                          (or (or (= ?bcog ?bcoh)
                              (= ?bcog ?awmg)
                              )
                            (= ?bcoh ?awmg)
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
          (assert
            (forall ((?bcoj Real) )(forall ((?awmg Real) )(or (and (or (or (= ?bcna ?bcoj)
                        (= ?bcna ?awmg)
                        )
                      (= ?bcoj ?awmg)
                      )
                    (or (or (= ?bckn ?bcoj)
                        (= ?bckn ?awmg)
                        )
                      (= ?bcoj ?awmg)
                      )
                    )
                  (and (not (= ?bcna ?bcoj))
                    (and (and (not (= ?bckn ?bcoj))
                        (not (= ?bckn ?awmg))
                        )
                      (not (= ?bcoj ?awmg))
                      )
                    )
                  )
                )
              )
            )
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bcpo Real)
      (declare-const ?bcpp Real)
      (push 1)
        (declare-const ?bcpq Real)
        (declare-const ?bcpr Real)
        (declare-const ?bcps Real)
        (assert
          (and (and (not (= ?bcps ?bcpr))
              (not (= ?bcps ?bcpq))
              )
            (not (= ?bcpr ?bcpq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcpt Real)
        (declare-const ?bcpu Real)
        (declare-const ?bcpv Real)
        (declare-const ?bcpw Real)
        (assert
          (and (and (not (= ?bcpv ?bcpu))
              (not (= ?bcpv ?bcpt))
              )
            (not (= ?bcpu ?bcpt))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcpx Real)
        (declare-const ?bcpy Real)
        (declare-const ?bcpz Real)
        (declare-const ?bcqa Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bcpy ?bcpx)
                    (= ?bcpy ?awmg)
                    )
                  (= ?bcpx ?awmg)
                  )
                (or (or (= ?bcqa ?bcpz)
                    (= ?bcqa ?awmg)
                    )
                  (= ?bcpz ?awmg)
                  )
                )
              (and (not (= ?bcpy ?bcpx))
                (and (and (not (= ?bcqa ?bcpz))
                    (not (= ?bcqa ?awmg))
                    )
                  (not (= ?bcpz ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcqb Real)
        (declare-const ?bcqc Real)
        (declare-const ?bcqd Real)
        (assert
          (and (and (not (= ?bcqd ?bcqc))
              (not (= ?bcqd ?bcqb))
              )
            (not (= ?bcqc ?bcqb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcqe Real)
        (declare-const ?bcqf Real)
        (declare-const ?bcqg Real)
        (declare-const ?bcqh Real)
        (assert
          (and (and (not (= ?bcqh ?bcqg))
              (not (= ?bcqh ?bcqf))
              )
            (not (= ?bcqg ?bcqf))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcqi Real)
        (declare-const ?bcqj Real)
        (declare-const ?bcqk Real)
        (declare-const ?bcql Real)
        (declare-const ?bcqm Real)
        (declare-const ?bcqn Real)
        (assert
          (or (and (or (or (= ?bcqk ?bcqj)
                  (= ?bcqk ?bcqi)
                  )
                (= ?bcqj ?bcqi)
                )
              (or (or (= ?bcqn ?bcqm)
                  (= ?bcqn ?bcql)
                  )
                (= ?bcqm ?bcql)
                )
              )
            (and (and (and (not (= ?bcqk ?bcqj))
                  (not (= ?bcqk ?bcqi))
                  )
                (not (= ?bcqj ?bcqi))
                )
              (and (and (not (= ?bcqn ?bcqm))
                  (not (= ?bcqn ?bcql))
                  )
                (not (= ?bcqm ?bcql))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcqo Real)
        (declare-const ?bcqp Real)
        (declare-const ?bcqq Real)
        (assert
          (and (and (not (= ?bcqq ?bcqp))
              (not (= ?bcqq ?bcqo))
              )
            (not (= ?bcqp ?bcqo))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcqr Real)
        (declare-const ?bcqs Real)
        (declare-const ?bcqt Real)
        (assert
          (and (and (not (= ?bcqt ?bcqs))
              (not (= ?bcqt ?bcqr))
              )
            (not (= ?bcqs ?bcqr))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bcqu Real)
      (declare-const ?bcqv Real)
      (declare-const ?bcqw Real)
      (push 1)
        (declare-const ?bcqx Real)
        (declare-const ?bcqy Real)
        (declare-const ?bcqz Real)
        (assert
          (and (and (not (= ?bcqz ?bcqy))
              (not (= ?bcqz ?bcqx))
              )
            (not (= ?bcqy ?bcqx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcra Real)
        (declare-const ?bcrb Real)
        (declare-const ?bcrc Real)
        (declare-const ?bcrd Real)
        (assert
          (and (and (not (= ?bcrc ?bcrb))
              (not (= ?bcrc ?bcra))
              )
            (not (= ?bcrb ?bcra))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcre Real)
        (declare-const ?bcrf Real)
        (declare-const ?bcrg Real)
        (declare-const ?bcrh Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bcrf ?bcre)
                    (= ?bcrf ?awmg)
                    )
                  (= ?bcre ?awmg)
                  )
                (or (or (= ?bcrh ?bcrg)
                    (= ?bcrh ?awmg)
                    )
                  (= ?bcrg ?awmg)
                  )
                )
              (and (not (= ?bcrf ?bcre))
                (and (and (not (= ?bcrh ?bcrg))
                    (not (= ?bcrh ?awmg))
                    )
                  (not (= ?bcrg ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcri Real)
        (declare-const ?bcrj Real)
        (declare-const ?bcrk Real)
        (assert
          (and (and (not (= ?bcrk ?bcrj))
              (not (= ?bcrk ?bcri))
              )
            (not (= ?bcrj ?bcri))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcrl Real)
        (declare-const ?bcrm Real)
        (declare-const ?bcrn Real)
        (declare-const ?bcro Real)
        (assert
          (and (and (not (= ?bcro ?bcrn))
              (not (= ?bcro ?bcrm))
              )
            (not (= ?bcrn ?bcrm))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcrp Real)
        (declare-const ?bcrq Real)
        (declare-const ?bcrr Real)
        (declare-const ?bcrs Real)
        (declare-const ?bcrt Real)
        (declare-const ?bcru Real)
        (assert
          (or (and (or (or (= ?bcrr ?bcrq)
                  (= ?bcrr ?bcrp)
                  )
                (= ?bcrq ?bcrp)
                )
              (or (or (= ?bcru ?bcrt)
                  (= ?bcru ?bcrs)
                  )
                (= ?bcrt ?bcrs)
                )
              )
            (and (and (and (not (= ?bcrr ?bcrq))
                  (not (= ?bcrr ?bcrp))
                  )
                (not (= ?bcrq ?bcrp))
                )
              (and (and (not (= ?bcru ?bcrt))
                  (not (= ?bcru ?bcrs))
                  )
                (not (= ?bcrt ?bcrs))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcrv Real)
        (declare-const ?bcrw Real)
        (declare-const ?bcrx Real)
        (assert
          (and (and (not (= ?bcrx ?bcrw))
              (not (= ?bcrx ?bcrv))
              )
            (not (= ?bcrw ?bcrv))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcry Real)
        (declare-const ?bcrz Real)
        (declare-const ?bcsa Real)
        (assert
          (and (and (not (= ?bcsa ?bcrz))
              (not (= ?bcsa ?bcry))
              )
            (not (= ?bcrz ?bcry))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?bcqw ?bcqv))
              (not (= ?bcqw ?bcqu))
              )
            (not (= ?bcqv ?bcqu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bcsb Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bcsc Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bcsd Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcse Real)
              (declare-const ?bcsf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcsg Real)
              (declare-const ?bcsh Real)
              (declare-const ?bcsi Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcsj Real)
              (declare-const ?bcsk Real)
              (declare-const ?bcsl Real)
              (declare-const ?bcsm Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcsn Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bcso Real)
            (declare-const ?bcsp Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bcsq Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcsr Real)
              (declare-const ?bcss Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcst Real)
              (declare-const ?bcsu Real)
              (declare-const ?bcsv Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcsw Real)
              (declare-const ?bcsx Real)
              (declare-const ?bcsy Real)
              (declare-const ?bcsz Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (and (= ?bcso ?bckn)
                        (= ?bcsp ?bcsb)
                        )
                      (and (and (= ?bcsy ?bcqw)
                          (= ?bcsx ?bcqv)
                          )
                        (= ?bcsw ?bcqu)
                        )
                      )
                    (= ?bcsz ?bcsb)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcta Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bctb Real)
                  (declare-const ?bctc Real)
                  (declare-const ?bctd Real)
                  (assert
                    (and (and (not (= ?bctd ?bctc))
                        (not (= ?bctd ?bctb))
                        )
                      (not (= ?bctc ?bctb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcte Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bctf Real)
                  (declare-const ?bctg Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcth Real)
                  (declare-const ?bcti Real)
                  (declare-const ?bctj Real)
                  (declare-const ?bctk Real)
                  (assert
                    (and (and (not (= ?bctj ?bcti))
                        (not (= ?bctj ?bcth))
                        )
                      (not (= ?bcti ?bcth))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bctl Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bctm Real)
                  (declare-const ?bctn Real)
                  (declare-const ?bcto Real)
                  (declare-const ?bctp Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bctn ?bctm)
                              (= ?bctn ?awmg)
                              )
                            (= ?bctm ?awmg)
                            )
                          (or (or (= ?bctp ?bcto)
                              (= ?bctp ?awmg)
                              )
                            (= ?bcto ?awmg)
                            )
                          )
                        (and (not (= ?bctn ?bctm))
                          (and (and (not (= ?bctp ?bcto))
                              (not (= ?bctp ?awmg))
                              )
                            (not (= ?bcto ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bctq Real)
                  (declare-const ?bctr Real)
                  (declare-const ?bcts Real)
                  (assert
                    (and (and (not (= ?bcts ?bctr))
                        (not (= ?bcts ?bctq))
                        )
                      (not (= ?bctr ?bctq))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bctt Real)
                  (declare-const ?bctu Real)
                  (declare-const ?bctv Real)
                  (declare-const ?bctw Real)
                  (assert
                    (and (and (not (= ?bctw ?bctv))
                        (not (= ?bctw ?bctu))
                        )
                      (not (= ?bctv ?bctu))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bctx Real)
                  (declare-const ?bcty Real)
                  (declare-const ?bctz Real)
                  (declare-const ?bcua Real)
                  (declare-const ?bcub Real)
                  (declare-const ?bcuc Real)
                  (assert
                    (or (and (or (or (= ?bctz ?bcty)
                            (= ?bctz ?bctx)
                            )
                          (= ?bcty ?bctx)
                          )
                        (or (or (= ?bcuc ?bcub)
                            (= ?bcuc ?bcua)
                            )
                          (= ?bcub ?bcua)
                          )
                        )
                      (and (and (and (not (= ?bctz ?bcty))
                            (not (= ?bctz ?bctx))
                            )
                          (not (= ?bcty ?bctx))
                          )
                        (and (and (not (= ?bcuc ?bcub))
                            (not (= ?bcuc ?bcua))
                            )
                          (not (= ?bcub ?bcua))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcud Real)
                  (declare-const ?bcue Real)
                  (declare-const ?bcuf Real)
                  (assert
                    (and (and (not (= ?bcuf ?bcue))
                        (not (= ?bcuf ?bcud))
                        )
                      (not (= ?bcue ?bcud))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcug Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcuh Real)
                  (declare-const ?bcui Real)
                  (declare-const ?bcuj Real)
                  (assert
                    (and (and (not (= ?bcuj ?bcui))
                        (not (= ?bcuj ?bcuh))
                        )
                      (not (= ?bcui ?bcuh))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?bcuk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bcul Real)
            (declare-const ?bcum Real)
            (declare-const ?bcun Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bcuo Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcup Real)
              (declare-const ?bcuq Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcur Real)
              (declare-const ?bcus Real)
              (declare-const ?bcut Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcuu Real)
              (declare-const ?bcuv Real)
              (declare-const ?bcuw Real)
              (declare-const ?bcux Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcuy Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bcuz Real)
            (declare-const ?bcva Real)
            (declare-const ?bcvb Real)
            (declare-const ?bcvc Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bcvd Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcve Real)
              (declare-const ?bcvf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcvg Real)
              (declare-const ?bcvh Real)
              (declare-const ?bcvi Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcvj Real)
              (declare-const ?bcvk Real)
              (declare-const ?bcvl Real)
              (declare-const ?bcvm Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcvn Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bcvo Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bcvp Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcvq Real)
              (declare-const ?bcvr Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcvs Real)
              (declare-const ?bcvt Real)
              (declare-const ?bcvu Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcvv Real)
              (declare-const ?bcvw Real)
              (declare-const ?bcvx Real)
              (declare-const ?bcvy Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bcvz Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (declare-const ?bcwa Real)
        (declare-const ?bcwb Real)
        (declare-const ?bcwc Real)
        (assert
          (and (and (not (= ?bcwc ?bcwb))
              (not (= ?bcwc ?bcwa))
              )
            (not (= ?bcwb ?bcwa))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcwd Real)
        (declare-const ?bcwe Real)
        (declare-const ?bcwf Real)
        (declare-const ?bcwg Real)
        (assert
          (and (and (not (= ?bcwf ?bcwe))
              (not (= ?bcwf ?bcwd))
              )
            (not (= ?bcwe ?bcwd))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcwh Real)
        (declare-const ?bcwi Real)
        (declare-const ?bcwj Real)
        (declare-const ?bcwk Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bcwi ?bcwh)
                    (= ?bcwi ?awmg)
                    )
                  (= ?bcwh ?awmg)
                  )
                (or (or (= ?bcwk ?bcwj)
                    (= ?bcwk ?awmg)
                    )
                  (= ?bcwj ?awmg)
                  )
                )
              (and (not (= ?bcwi ?bcwh))
                (and (and (not (= ?bcwk ?bcwj))
                    (not (= ?bcwk ?awmg))
                    )
                  (not (= ?bcwj ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcwl Real)
        (declare-const ?bcwm Real)
        (declare-const ?bcwn Real)
        (assert
          (and (and (not (= ?bcwn ?bcwm))
              (not (= ?bcwn ?bcwl))
              )
            (not (= ?bcwm ?bcwl))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcwo Real)
        (declare-const ?bcwp Real)
        (declare-const ?bcwq Real)
        (declare-const ?bcwr Real)
        (assert
          (and (and (not (= ?bcwr ?bcwq))
              (not (= ?bcwr ?bcwp))
              )
            (not (= ?bcwq ?bcwp))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcws Real)
        (declare-const ?bcwt Real)
        (declare-const ?bcwu Real)
        (declare-const ?bcwv Real)
        (declare-const ?bcww Real)
        (declare-const ?bcwx Real)
        (assert
          (or (and (or (or (= ?bcwu ?bcwt)
                  (= ?bcwu ?bcws)
                  )
                (= ?bcwt ?bcws)
                )
              (or (or (= ?bcwx ?bcww)
                  (= ?bcwx ?bcwv)
                  )
                (= ?bcww ?bcwv)
                )
              )
            (and (and (and (not (= ?bcwu ?bcwt))
                  (not (= ?bcwu ?bcws))
                  )
                (not (= ?bcwt ?bcws))
                )
              (and (and (not (= ?bcwx ?bcww))
                  (not (= ?bcwx ?bcwv))
                  )
                (not (= ?bcww ?bcwv))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcwy Real)
        (declare-const ?bcwz Real)
        (declare-const ?bcxa Real)
        (assert
          (and (and (not (= ?bcxa ?bcwz))
              (not (= ?bcxa ?bcwy))
              )
            (not (= ?bcwz ?bcwy))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcxb Real)
        (declare-const ?bcxc Real)
        (declare-const ?bcxd Real)
        (assert
          (and (and (not (= ?bcxd ?bcxc))
              (not (= ?bcxd ?bcxb))
              )
            (not (= ?bcxc ?bcxb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bcxe Real)
          (push 1)
            (declare-const ?bcxf Real)
            (declare-const ?bcxg Real)
            (push 1)
              (declare-const ?bcxh Real)
              (push 1)
                (assert
                  (and (and (= ?bcxf ?bckn)
                      (= ?bcxg ?bcxe)
                      )
                    (= ?bcxh ?bcxe)
                    )
                  )
                (push 1)
                  (declare-const ?bcxi Real)
                  (declare-const ?bcxj Real)
                  (declare-const ?bcxk Real)
                  (assert
                    (and (and (not (= ?bcxk ?bcxj))
                        (not (= ?bcxk ?bcxi))
                        )
                      (not (= ?bcxj ?bcxi))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcxl Real)
                  (declare-const ?bcxm Real)
                  (declare-const ?bcxn Real)
                  (declare-const ?bcxo Real)
                  (assert
                    (and (and (not (= ?bcxn ?bcxm))
                        (not (= ?bcxn ?bcxl))
                        )
                      (not (= ?bcxm ?bcxl))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcxp Real)
                  (declare-const ?bcxq Real)
                  (declare-const ?bcxr Real)
                  (declare-const ?bcxs Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bcxq ?bcxp)
                              (= ?bcxq ?awmg)
                              )
                            (= ?bcxp ?awmg)
                            )
                          (or (or (= ?bcxs ?bcxr)
                              (= ?bcxs ?awmg)
                              )
                            (= ?bcxr ?awmg)
                            )
                          )
                        (and (not (= ?bcxq ?bcxp))
                          (and (and (not (= ?bcxs ?bcxr))
                              (not (= ?bcxs ?awmg))
                              )
                            (not (= ?bcxr ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcxt Real)
                  (declare-const ?bcxu Real)
                  (declare-const ?bcxv Real)
                  (assert
                    (and (and (not (= ?bcxv ?bcxu))
                        (not (= ?bcxv ?bcxt))
                        )
                      (not (= ?bcxu ?bcxt))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcxw Real)
                  (declare-const ?bcxx Real)
                  (declare-const ?bcxy Real)
                  (declare-const ?bcxz Real)
                  (assert
                    (and (and (not (= ?bcxz ?bcxy))
                        (not (= ?bcxz ?bcxx))
                        )
                      (not (= ?bcxy ?bcxx))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcya Real)
                  (declare-const ?bcyb Real)
                  (declare-const ?bcyc Real)
                  (declare-const ?bcyd Real)
                  (declare-const ?bcye Real)
                  (declare-const ?bcyf Real)
                  (assert
                    (or (and (or (or (= ?bcyc ?bcyb)
                            (= ?bcyc ?bcya)
                            )
                          (= ?bcyb ?bcya)
                          )
                        (or (or (= ?bcyf ?bcye)
                            (= ?bcyf ?bcyd)
                            )
                          (= ?bcye ?bcyd)
                          )
                        )
                      (and (and (and (not (= ?bcyc ?bcyb))
                            (not (= ?bcyc ?bcya))
                            )
                          (not (= ?bcyb ?bcya))
                          )
                        (and (and (not (= ?bcyf ?bcye))
                            (not (= ?bcyf ?bcyd))
                            )
                          (not (= ?bcye ?bcyd))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcyg Real)
                  (declare-const ?bcyh Real)
                  (declare-const ?bcyi Real)
                  (assert
                    (and (and (not (= ?bcyi ?bcyh))
                        (not (= ?bcyi ?bcyg))
                        )
                      (not (= ?bcyh ?bcyg))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bcyj Real)
                  (declare-const ?bcyk Real)
                  (declare-const ?bcyl Real)
                  (assert
                    (and (and (not (= ?bcyl ?bcyk))
                        (not (= ?bcyl ?bcyj))
                        )
                      (not (= ?bcyk ?bcyj))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bcym Real)
    (declare-const ?bcyn Real)
    (push 1)
      (push 1)
        (declare-const ?bcyo Real)
        (declare-const ?bcyp Real)
        (declare-const ?bcyq Real)
        (assert
          (and (and (not (= ?bcyq ?bcyp))
              (not (= ?bcyq ?bcyo))
              )
            (not (= ?bcyp ?bcyo))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcyr Real)
        (declare-const ?bcys Real)
        (declare-const ?bcyt Real)
        (declare-const ?bcyu Real)
        (assert
          (and (and (not (= ?bcyt ?bcys))
              (not (= ?bcyt ?bcyr))
              )
            (not (= ?bcys ?bcyr))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcyv Real)
        (declare-const ?bcyw Real)
        (declare-const ?bcyx Real)
        (declare-const ?bcyy Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bcyw ?bcyv)
                    (= ?bcyw ?awmg)
                    )
                  (= ?bcyv ?awmg)
                  )
                (or (or (= ?bcyy ?bcyx)
                    (= ?bcyy ?awmg)
                    )
                  (= ?bcyx ?awmg)
                  )
                )
              (and (not (= ?bcyw ?bcyv))
                (and (and (not (= ?bcyy ?bcyx))
                    (not (= ?bcyy ?awmg))
                    )
                  (not (= ?bcyx ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bcyz Real)
        (declare-const ?bcza Real)
        (declare-const ?bczb Real)
        (assert
          (and (and (not (= ?bczb ?bcza))
              (not (= ?bczb ?bcyz))
              )
            (not (= ?bcza ?bcyz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bczc Real)
        (declare-const ?bczd Real)
        (declare-const ?bcze Real)
        (declare-const ?bczf Real)
        (assert
          (and (and (not (= ?bczf ?bcze))
              (not (= ?bczf ?bczd))
              )
            (not (= ?bcze ?bczd))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bczg Real)
        (declare-const ?bczh Real)
        (declare-const ?bczi Real)
        (declare-const ?bczj Real)
        (declare-const ?bczk Real)
        (declare-const ?bczl Real)
        (assert
          (or (and (or (or (= ?bczi ?bczh)
                  (= ?bczi ?bczg)
                  )
                (= ?bczh ?bczg)
                )
              (or (or (= ?bczl ?bczk)
                  (= ?bczl ?bczj)
                  )
                (= ?bczk ?bczj)
                )
              )
            (and (and (and (not (= ?bczi ?bczh))
                  (not (= ?bczi ?bczg))
                  )
                (not (= ?bczh ?bczg))
                )
              (and (and (not (= ?bczl ?bczk))
                  (not (= ?bczl ?bczj))
                  )
                (not (= ?bczk ?bczj))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bczm Real)
        (declare-const ?bczn Real)
        (declare-const ?bczo Real)
        (assert
          (and (and (not (= ?bczo ?bczn))
              (not (= ?bczo ?bczm))
              )
            (not (= ?bczn ?bczm))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bczp Real)
        (declare-const ?bczq Real)
        (declare-const ?bczr Real)
        (assert
          (and (and (not (= ?bczr ?bczq))
              (not (= ?bczr ?bczp))
              )
            (not (= ?bczq ?bczp))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bczs Real)
      (push 1)
        (declare-const ?bczt Real)
        (declare-const ?bczu Real)
        (declare-const ?bczv Real)
        (assert
          (and (and (not (= ?bczv ?bczu))
              (not (= ?bczv ?bczt))
              )
            (not (= ?bczu ?bczt))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bczw Real)
        (declare-const ?bczx Real)
        (declare-const ?bczy Real)
        (declare-const ?bczz Real)
        (assert
          (and (and (not (= ?bczy ?bczx))
              (not (= ?bczy ?bczw))
              )
            (not (= ?bczx ?bczw))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdaa Real)
        (declare-const ?bdab Real)
        (declare-const ?bdac Real)
        (declare-const ?bdad Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bdab ?bdaa)
                    (= ?bdab ?awmg)
                    )
                  (= ?bdaa ?awmg)
                  )
                (or (or (= ?bdad ?bdac)
                    (= ?bdad ?awmg)
                    )
                  (= ?bdac ?awmg)
                  )
                )
              (and (not (= ?bdab ?bdaa))
                (and (and (not (= ?bdad ?bdac))
                    (not (= ?bdad ?awmg))
                    )
                  (not (= ?bdac ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdae Real)
        (declare-const ?bdaf Real)
        (declare-const ?bdag Real)
        (assert
          (and (and (not (= ?bdag ?bdaf))
              (not (= ?bdag ?bdae))
              )
            (not (= ?bdaf ?bdae))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdah Real)
        (declare-const ?bdai Real)
        (declare-const ?bdaj Real)
        (declare-const ?bdak Real)
        (assert
          (and (and (not (= ?bdak ?bdaj))
              (not (= ?bdak ?bdai))
              )
            (not (= ?bdaj ?bdai))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdal Real)
        (declare-const ?bdam Real)
        (declare-const ?bdan Real)
        (declare-const ?bdao Real)
        (declare-const ?bdap Real)
        (declare-const ?bdaq Real)
        (assert
          (or (and (or (or (= ?bdan ?bdam)
                  (= ?bdan ?bdal)
                  )
                (= ?bdam ?bdal)
                )
              (or (or (= ?bdaq ?bdap)
                  (= ?bdaq ?bdao)
                  )
                (= ?bdap ?bdao)
                )
              )
            (and (and (and (not (= ?bdan ?bdam))
                  (not (= ?bdan ?bdal))
                  )
                (not (= ?bdam ?bdal))
                )
              (and (and (not (= ?bdaq ?bdap))
                  (not (= ?bdaq ?bdao))
                  )
                (not (= ?bdap ?bdao))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdar Real)
        (declare-const ?bdas Real)
        (declare-const ?bdat Real)
        (assert
          (and (and (not (= ?bdat ?bdas))
              (not (= ?bdat ?bdar))
              )
            (not (= ?bdas ?bdar))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdau Real)
        (declare-const ?bdav Real)
        (declare-const ?bdaw Real)
        (assert
          (and (and (not (= ?bdaw ?bdav))
              (not (= ?bdaw ?bdau))
              )
            (not (= ?bdav ?bdau))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bdax Real)
      (declare-const ?bday Real)
      (push 1)
        (declare-const ?bdaz Real)
        (declare-const ?bdba Real)
        (declare-const ?bdbb Real)
        (assert
          (and (and (not (= ?bdbb ?bdba))
              (not (= ?bdbb ?bdaz))
              )
            (not (= ?bdba ?bdaz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdbc Real)
        (declare-const ?bdbd Real)
        (declare-const ?bdbe Real)
        (declare-const ?bdbf Real)
        (assert
          (and (and (not (= ?bdbe ?bdbd))
              (not (= ?bdbe ?bdbc))
              )
            (not (= ?bdbd ?bdbc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdbg Real)
        (declare-const ?bdbh Real)
        (declare-const ?bdbi Real)
        (declare-const ?bdbj Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bdbh ?bdbg)
                    (= ?bdbh ?awmg)
                    )
                  (= ?bdbg ?awmg)
                  )
                (or (or (= ?bdbj ?bdbi)
                    (= ?bdbj ?awmg)
                    )
                  (= ?bdbi ?awmg)
                  )
                )
              (and (not (= ?bdbh ?bdbg))
                (and (and (not (= ?bdbj ?bdbi))
                    (not (= ?bdbj ?awmg))
                    )
                  (not (= ?bdbi ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdbk Real)
        (declare-const ?bdbl Real)
        (declare-const ?bdbm Real)
        (assert
          (and (and (not (= ?bdbm ?bdbl))
              (not (= ?bdbm ?bdbk))
              )
            (not (= ?bdbl ?bdbk))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdbn Real)
        (declare-const ?bdbo Real)
        (declare-const ?bdbp Real)
        (declare-const ?bdbq Real)
        (assert
          (and (and (not (= ?bdbq ?bdbp))
              (not (= ?bdbq ?bdbo))
              )
            (not (= ?bdbp ?bdbo))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdbr Real)
        (declare-const ?bdbs Real)
        (declare-const ?bdbt Real)
        (declare-const ?bdbu Real)
        (declare-const ?bdbv Real)
        (declare-const ?bdbw Real)
        (assert
          (or (and (or (or (= ?bdbt ?bdbs)
                  (= ?bdbt ?bdbr)
                  )
                (= ?bdbs ?bdbr)
                )
              (or (or (= ?bdbw ?bdbv)
                  (= ?bdbw ?bdbu)
                  )
                (= ?bdbv ?bdbu)
                )
              )
            (and (and (and (not (= ?bdbt ?bdbs))
                  (not (= ?bdbt ?bdbr))
                  )
                (not (= ?bdbs ?bdbr))
                )
              (and (and (not (= ?bdbw ?bdbv))
                  (not (= ?bdbw ?bdbu))
                  )
                (not (= ?bdbv ?bdbu))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdbx Real)
        (declare-const ?bdby Real)
        (declare-const ?bdbz Real)
        (assert
          (and (and (not (= ?bdbz ?bdby))
              (not (= ?bdbz ?bdbx))
              )
            (not (= ?bdby ?bdbx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdca Real)
        (declare-const ?bdcb Real)
        (declare-const ?bdcc Real)
        (assert
          (and (and (not (= ?bdcc ?bdcb))
              (not (= ?bdcc ?bdca))
              )
            (not (= ?bdcb ?bdca))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bday ?bdax)
                    (= ?bday ?awmg)
                    )
                  (= ?bdax ?awmg)
                  )
                (or (or (= ?bcyn ?bcym)
                    (= ?bcyn ?awmg)
                    )
                  (= ?bcym ?awmg)
                  )
                )
              (and (not (= ?bday ?bdax))
                (and (and (not (= ?bcyn ?bcym))
                    (not (= ?bcyn ?awmg))
                    )
                  (not (= ?bcym ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bdcd Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bdce Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bdcf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdcg Real)
              (declare-const ?bdch Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdci Real)
              (declare-const ?bdcj Real)
              (declare-const ?bdck Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdcl Real)
              (declare-const ?bdcm Real)
              (declare-const ?bdcn Real)
              (declare-const ?bdco Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdcp Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bdcq Real)
            (declare-const ?bdcr Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bdcs Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdct Real)
              (declare-const ?bdcu Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdcv Real)
              (declare-const ?bdcw Real)
              (declare-const ?bdcx Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdcy Real)
              (declare-const ?bdcz Real)
              (declare-const ?bdda Real)
              (declare-const ?bddb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bddc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bddd Real)
            (declare-const ?bdde Real)
            (declare-const ?bddf Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bddg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bddh Real)
              (declare-const ?bddi Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bddj Real)
              (declare-const ?bddk Real)
              (declare-const ?bddl Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (and (and (= ?bdde ?bcyn)
                          (= ?bddd ?bcym)
                          )
                        (= ?bddf ?bdcd)
                        )
                      (and (= ?bddk ?bday)
                        (= ?bddj ?bdax)
                        )
                      )
                    (= ?bddl ?bdcd)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bddm Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bddn Real)
                  (declare-const ?bddo Real)
                  (declare-const ?bddp Real)
                  (assert
                    (and (and (not (= ?bddp ?bddo))
                        (not (= ?bddp ?bddn))
                        )
                      (not (= ?bddo ?bddn))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bddq Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bddr Real)
                  (declare-const ?bdds Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bddt Real)
                  (declare-const ?bddu Real)
                  (declare-const ?bddv Real)
                  (declare-const ?bddw Real)
                  (assert
                    (and (and (not (= ?bddv ?bddu))
                        (not (= ?bddv ?bddt))
                        )
                      (not (= ?bddu ?bddt))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bddx Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bddy Real)
                  (declare-const ?bddz Real)
                  (declare-const ?bdea Real)
                  (declare-const ?bdeb Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bddz ?bddy)
                              (= ?bddz ?awmg)
                              )
                            (= ?bddy ?awmg)
                            )
                          (or (or (= ?bdeb ?bdea)
                              (= ?bdeb ?awmg)
                              )
                            (= ?bdea ?awmg)
                            )
                          )
                        (and (not (= ?bddz ?bddy))
                          (and (and (not (= ?bdeb ?bdea))
                              (not (= ?bdeb ?awmg))
                              )
                            (not (= ?bdea ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdec Real)
                  (declare-const ?bded Real)
                  (declare-const ?bdee Real)
                  (assert
                    (and (and (not (= ?bdee ?bded))
                        (not (= ?bdee ?bdec))
                        )
                      (not (= ?bded ?bdec))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdef Real)
                  (declare-const ?bdeg Real)
                  (declare-const ?bdeh Real)
                  (declare-const ?bdei Real)
                  (assert
                    (and (and (not (= ?bdei ?bdeh))
                        (not (= ?bdei ?bdeg))
                        )
                      (not (= ?bdeh ?bdeg))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdej Real)
                  (declare-const ?bdek Real)
                  (declare-const ?bdel Real)
                  (declare-const ?bdem Real)
                  (declare-const ?bden Real)
                  (declare-const ?bdeo Real)
                  (assert
                    (or (and (or (or (= ?bdel ?bdek)
                            (= ?bdel ?bdej)
                            )
                          (= ?bdek ?bdej)
                          )
                        (or (or (= ?bdeo ?bden)
                            (= ?bdeo ?bdem)
                            )
                          (= ?bden ?bdem)
                          )
                        )
                      (and (and (and (not (= ?bdel ?bdek))
                            (not (= ?bdel ?bdej))
                            )
                          (not (= ?bdek ?bdej))
                          )
                        (and (and (not (= ?bdeo ?bden))
                            (not (= ?bdeo ?bdem))
                            )
                          (not (= ?bden ?bdem))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdep Real)
                  (declare-const ?bdeq Real)
                  (declare-const ?bder Real)
                  (assert
                    (and (and (not (= ?bder ?bdeq))
                        (not (= ?bder ?bdep))
                        )
                      (not (= ?bdeq ?bdep))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdes Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdet Real)
                  (declare-const ?bdeu Real)
                  (declare-const ?bdev Real)
                  (assert
                    (and (and (not (= ?bdev ?bdeu))
                        (not (= ?bdev ?bdet))
                        )
                      (not (= ?bdeu ?bdet))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (assert
                    (and (or (and (and (not (= ?bddk ?bddj))
                            (not (= ?bddk ?bddl))
                            )
                          (not (= ?bddj ?bddl))
                          )
                        (and (and (not (= ?bdde ?bddd))
                            (not (= ?bdde ?bddf))
                            )
                          (not (= ?bddd ?bddf))
                          )
                        )
                      (or (or (or (= ?bddk ?bddj)
                            (= ?bddk ?bddl)
                            )
                          (= ?bddj ?bddl)
                          )
                        (or (or (= ?bdde ?bddd)
                            (= ?bdde ?bddf)
                            )
                          (= ?bddd ?bddf)
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?bdew Real)
              (declare-const ?bdex Real)
              (declare-const ?bdey Real)
              (declare-const ?bdez Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdfa Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bdfb Real)
            (declare-const ?bdfc Real)
            (declare-const ?bdfd Real)
            (declare-const ?bdfe Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bdff Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdfg Real)
              (declare-const ?bdfh Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdfi Real)
              (declare-const ?bdfj Real)
              (declare-const ?bdfk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdfl Real)
              (declare-const ?bdfm Real)
              (declare-const ?bdfn Real)
              (declare-const ?bdfo Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdfp Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bdfq Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bdfr Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdfs Real)
              (declare-const ?bdft Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdfu Real)
              (declare-const ?bdfv Real)
              (declare-const ?bdfw Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdfx Real)
              (declare-const ?bdfy Real)
              (declare-const ?bdfz Real)
              (declare-const ?bdga Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdgb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bdgc Real)
      (declare-const ?bdgd Real)
      (declare-const ?bdge Real)
      (push 1)
        (declare-const ?bdgf Real)
        (declare-const ?bdgg Real)
        (declare-const ?bdgh Real)
        (assert
          (and (and (not (= ?bdgh ?bdgg))
              (not (= ?bdgh ?bdgf))
              )
            (not (= ?bdgg ?bdgf))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdgi Real)
        (declare-const ?bdgj Real)
        (declare-const ?bdgk Real)
        (declare-const ?bdgl Real)
        (assert
          (and (and (not (= ?bdgk ?bdgj))
              (not (= ?bdgk ?bdgi))
              )
            (not (= ?bdgj ?bdgi))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdgm Real)
        (declare-const ?bdgn Real)
        (declare-const ?bdgo Real)
        (declare-const ?bdgp Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bdgn ?bdgm)
                    (= ?bdgn ?awmg)
                    )
                  (= ?bdgm ?awmg)
                  )
                (or (or (= ?bdgp ?bdgo)
                    (= ?bdgp ?awmg)
                    )
                  (= ?bdgo ?awmg)
                  )
                )
              (and (not (= ?bdgn ?bdgm))
                (and (and (not (= ?bdgp ?bdgo))
                    (not (= ?bdgp ?awmg))
                    )
                  (not (= ?bdgo ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdgq Real)
        (declare-const ?bdgr Real)
        (declare-const ?bdgs Real)
        (assert
          (and (and (not (= ?bdgs ?bdgr))
              (not (= ?bdgs ?bdgq))
              )
            (not (= ?bdgr ?bdgq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdgt Real)
        (declare-const ?bdgu Real)
        (declare-const ?bdgv Real)
        (declare-const ?bdgw Real)
        (assert
          (and (and (not (= ?bdgw ?bdgv))
              (not (= ?bdgw ?bdgu))
              )
            (not (= ?bdgv ?bdgu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdgx Real)
        (declare-const ?bdgy Real)
        (declare-const ?bdgz Real)
        (declare-const ?bdha Real)
        (declare-const ?bdhb Real)
        (declare-const ?bdhc Real)
        (assert
          (or (and (or (or (= ?bdgz ?bdgy)
                  (= ?bdgz ?bdgx)
                  )
                (= ?bdgy ?bdgx)
                )
              (or (or (= ?bdhc ?bdhb)
                  (= ?bdhc ?bdha)
                  )
                (= ?bdhb ?bdha)
                )
              )
            (and (and (and (not (= ?bdgz ?bdgy))
                  (not (= ?bdgz ?bdgx))
                  )
                (not (= ?bdgy ?bdgx))
                )
              (and (and (not (= ?bdhc ?bdhb))
                  (not (= ?bdhc ?bdha))
                  )
                (not (= ?bdhb ?bdha))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdhd Real)
        (declare-const ?bdhe Real)
        (declare-const ?bdhf Real)
        (assert
          (and (and (not (= ?bdhf ?bdhe))
              (not (= ?bdhf ?bdhd))
              )
            (not (= ?bdhe ?bdhd))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdhg Real)
        (declare-const ?bdhh Real)
        (declare-const ?bdhi Real)
        (assert
          (and (and (not (= ?bdhi ?bdhh))
              (not (= ?bdhi ?bdhg))
              )
            (not (= ?bdhh ?bdhg))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (declare-const ?bdhj Real)
        (declare-const ?bdhk Real)
        (declare-const ?bdhl Real)
        (assert
          (and (and (not (= ?bdhl ?bdhk))
              (not (= ?bdhl ?bdhj))
              )
            (not (= ?bdhk ?bdhj))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdhm Real)
        (declare-const ?bdhn Real)
        (declare-const ?bdho Real)
        (declare-const ?bdhp Real)
        (assert
          (and (and (not (= ?bdho ?bdhn))
              (not (= ?bdho ?bdhm))
              )
            (not (= ?bdhn ?bdhm))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdhq Real)
        (declare-const ?bdhr Real)
        (declare-const ?bdhs Real)
        (declare-const ?bdht Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bdhr ?bdhq)
                    (= ?bdhr ?awmg)
                    )
                  (= ?bdhq ?awmg)
                  )
                (or (or (= ?bdht ?bdhs)
                    (= ?bdht ?awmg)
                    )
                  (= ?bdhs ?awmg)
                  )
                )
              (and (not (= ?bdhr ?bdhq))
                (and (and (not (= ?bdht ?bdhs))
                    (not (= ?bdht ?awmg))
                    )
                  (not (= ?bdhs ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdhu Real)
        (declare-const ?bdhv Real)
        (declare-const ?bdhw Real)
        (assert
          (and (and (not (= ?bdhw ?bdhv))
              (not (= ?bdhw ?bdhu))
              )
            (not (= ?bdhv ?bdhu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdhx Real)
        (declare-const ?bdhy Real)
        (declare-const ?bdhz Real)
        (declare-const ?bdia Real)
        (assert
          (and (and (not (= ?bdia ?bdhz))
              (not (= ?bdia ?bdhy))
              )
            (not (= ?bdhz ?bdhy))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdib Real)
        (declare-const ?bdic Real)
        (declare-const ?bdid Real)
        (declare-const ?bdie Real)
        (declare-const ?bdif Real)
        (declare-const ?bdig Real)
        (assert
          (or (and (or (or (= ?bdid ?bdic)
                  (= ?bdid ?bdib)
                  )
                (= ?bdic ?bdib)
                )
              (or (or (= ?bdig ?bdif)
                  (= ?bdig ?bdie)
                  )
                (= ?bdif ?bdie)
                )
              )
            (and (and (and (not (= ?bdid ?bdic))
                  (not (= ?bdid ?bdib))
                  )
                (not (= ?bdic ?bdib))
                )
              (and (and (not (= ?bdig ?bdif))
                  (not (= ?bdig ?bdie))
                  )
                (not (= ?bdif ?bdie))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdih Real)
        (declare-const ?bdii Real)
        (declare-const ?bdij Real)
        (assert
          (and (and (not (= ?bdij ?bdii))
              (not (= ?bdij ?bdih))
              )
            (not (= ?bdii ?bdih))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdik Real)
        (declare-const ?bdil Real)
        (declare-const ?bdim Real)
        (assert
          (and (and (not (= ?bdim ?bdil))
              (not (= ?bdim ?bdik))
              )
            (not (= ?bdil ?bdik))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bdin Real)
    (declare-const ?bdio Real)
    (declare-const ?bdip Real)
    (push 1)
      (push 1)
        (declare-const ?bdiq Real)
        (declare-const ?bdir Real)
        (declare-const ?bdis Real)
        (assert
          (and (and (not (= ?bdis ?bdir))
              (not (= ?bdis ?bdiq))
              )
            (not (= ?bdir ?bdiq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdit Real)
        (declare-const ?bdiu Real)
        (declare-const ?bdiv Real)
        (declare-const ?bdiw Real)
        (assert
          (and (and (not (= ?bdiv ?bdiu))
              (not (= ?bdiv ?bdit))
              )
            (not (= ?bdiu ?bdit))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdix Real)
        (declare-const ?bdiy Real)
        (declare-const ?bdiz Real)
        (declare-const ?bdja Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bdiy ?bdix)
                    (= ?bdiy ?awmg)
                    )
                  (= ?bdix ?awmg)
                  )
                (or (or (= ?bdja ?bdiz)
                    (= ?bdja ?awmg)
                    )
                  (= ?bdiz ?awmg)
                  )
                )
              (and (not (= ?bdiy ?bdix))
                (and (and (not (= ?bdja ?bdiz))
                    (not (= ?bdja ?awmg))
                    )
                  (not (= ?bdiz ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdjb Real)
        (declare-const ?bdjc Real)
        (declare-const ?bdjd Real)
        (assert
          (and (and (not (= ?bdjd ?bdjc))
              (not (= ?bdjd ?bdjb))
              )
            (not (= ?bdjc ?bdjb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdje Real)
        (declare-const ?bdjf Real)
        (declare-const ?bdjg Real)
        (declare-const ?bdjh Real)
        (assert
          (and (and (not (= ?bdjh ?bdjg))
              (not (= ?bdjh ?bdjf))
              )
            (not (= ?bdjg ?bdjf))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdji Real)
        (declare-const ?bdjj Real)
        (declare-const ?bdjk Real)
        (declare-const ?bdjl Real)
        (declare-const ?bdjm Real)
        (declare-const ?bdjn Real)
        (assert
          (or (and (or (or (= ?bdjk ?bdjj)
                  (= ?bdjk ?bdji)
                  )
                (= ?bdjj ?bdji)
                )
              (or (or (= ?bdjn ?bdjm)
                  (= ?bdjn ?bdjl)
                  )
                (= ?bdjm ?bdjl)
                )
              )
            (and (and (and (not (= ?bdjk ?bdjj))
                  (not (= ?bdjk ?bdji))
                  )
                (not (= ?bdjj ?bdji))
                )
              (and (and (not (= ?bdjn ?bdjm))
                  (not (= ?bdjn ?bdjl))
                  )
                (not (= ?bdjm ?bdjl))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdjo Real)
        (declare-const ?bdjp Real)
        (declare-const ?bdjq Real)
        (assert
          (and (and (not (= ?bdjq ?bdjp))
              (not (= ?bdjq ?bdjo))
              )
            (not (= ?bdjp ?bdjo))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdjr Real)
        (declare-const ?bdjs Real)
        (declare-const ?bdjt Real)
        (assert
          (and (and (not (= ?bdjt ?bdjs))
              (not (= ?bdjt ?bdjr))
              )
            (not (= ?bdjs ?bdjr))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?bdip ?bdio))
              (not (= ?bdip ?bdin))
              )
            (not (= ?bdio ?bdin))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bdju Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bdjv Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bdjw Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdjx Real)
              (declare-const ?bdjy Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdjz Real)
              (declare-const ?bdka Real)
              (declare-const ?bdkb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdkc Real)
              (declare-const ?bdkd Real)
              (declare-const ?bdke Real)
              (declare-const ?bdkf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdkg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bdkh Real)
            (declare-const ?bdki Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bdkj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdkk Real)
              (declare-const ?bdkl Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdkm Real)
              (declare-const ?bdkn Real)
              (declare-const ?bdko Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdkp Real)
              (declare-const ?bdkq Real)
              (declare-const ?bdkr Real)
              (declare-const ?bdks Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdkt Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bdku Real)
            (declare-const ?bdkv Real)
            (declare-const ?bdkw Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bdkx Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdky Real)
              (declare-const ?bdkz Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdla Real)
              (declare-const ?bdlb Real)
              (declare-const ?bdlc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdld Real)
              (declare-const ?bdle Real)
              (declare-const ?bdlf Real)
              (declare-const ?bdlg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdlh Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bdli Real)
            (declare-const ?bdlj Real)
            (declare-const ?bdlk Real)
            (declare-const ?bdll Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bdlm Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (and (and (= ?bdlk ?bdip)
                          (= ?bdlj ?bdio)
                          )
                        (= ?bdli ?bdin)
                        )
                      (= ?bdll ?bdju)
                      )
                    (= ?bdlm ?bdju)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdln Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdlo Real)
                  (declare-const ?bdlp Real)
                  (declare-const ?bdlq Real)
                  (assert
                    (and (and (not (= ?bdlq ?bdlp))
                        (not (= ?bdlq ?bdlo))
                        )
                      (not (= ?bdlp ?bdlo))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdlr Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdls Real)
                  (declare-const ?bdlt Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdlu Real)
                  (declare-const ?bdlv Real)
                  (declare-const ?bdlw Real)
                  (declare-const ?bdlx Real)
                  (assert
                    (and (and (not (= ?bdlw ?bdlv))
                        (not (= ?bdlw ?bdlu))
                        )
                      (not (= ?bdlv ?bdlu))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdly Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdlz Real)
                  (declare-const ?bdma Real)
                  (declare-const ?bdmb Real)
                  (declare-const ?bdmc Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bdma ?bdlz)
                              (= ?bdma ?awmg)
                              )
                            (= ?bdlz ?awmg)
                            )
                          (or (or (= ?bdmc ?bdmb)
                              (= ?bdmc ?awmg)
                              )
                            (= ?bdmb ?awmg)
                            )
                          )
                        (and (not (= ?bdma ?bdlz))
                          (and (and (not (= ?bdmc ?bdmb))
                              (not (= ?bdmc ?awmg))
                              )
                            (not (= ?bdmb ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdmd Real)
                  (declare-const ?bdme Real)
                  (declare-const ?bdmf Real)
                  (assert
                    (and (and (not (= ?bdmf ?bdme))
                        (not (= ?bdmf ?bdmd))
                        )
                      (not (= ?bdme ?bdmd))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdmg Real)
                  (declare-const ?bdmh Real)
                  (declare-const ?bdmi Real)
                  (declare-const ?bdmj Real)
                  (assert
                    (and (and (not (= ?bdmj ?bdmi))
                        (not (= ?bdmj ?bdmh))
                        )
                      (not (= ?bdmi ?bdmh))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdmk Real)
                  (declare-const ?bdml Real)
                  (declare-const ?bdmm Real)
                  (declare-const ?bdmn Real)
                  (declare-const ?bdmo Real)
                  (declare-const ?bdmp Real)
                  (assert
                    (or (and (or (or (= ?bdmm ?bdml)
                            (= ?bdmm ?bdmk)
                            )
                          (= ?bdml ?bdmk)
                          )
                        (or (or (= ?bdmp ?bdmo)
                            (= ?bdmp ?bdmn)
                            )
                          (= ?bdmo ?bdmn)
                          )
                        )
                      (and (and (and (not (= ?bdmm ?bdml))
                            (not (= ?bdmm ?bdmk))
                            )
                          (not (= ?bdml ?bdmk))
                          )
                        (and (and (not (= ?bdmp ?bdmo))
                            (not (= ?bdmp ?bdmn))
                            )
                          (not (= ?bdmo ?bdmn))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdmq Real)
                  (declare-const ?bdmr Real)
                  (declare-const ?bdms Real)
                  (assert
                    (and (and (not (= ?bdms ?bdmr))
                        (not (= ?bdms ?bdmq))
                        )
                      (not (= ?bdmr ?bdmq))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdmt Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdmu Real)
                  (declare-const ?bdmv Real)
                  (declare-const ?bdmw Real)
                  (assert
                    (and (and (not (= ?bdmw ?bdmv))
                        (not (= ?bdmw ?bdmu))
                        )
                      (not (= ?bdmv ?bdmu))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?bdmx Real)
              (declare-const ?bdmy Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdmz Real)
              (declare-const ?bdna Real)
              (declare-const ?bdnb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdnc Real)
              (declare-const ?bdnd Real)
              (declare-const ?bdne Real)
              (declare-const ?bdnf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdng Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bdnh Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bdni Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdnj Real)
              (declare-const ?bdnk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdnl Real)
              (declare-const ?bdnm Real)
              (declare-const ?bdnn Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdno Real)
              (declare-const ?bdnp Real)
              (declare-const ?bdnq Real)
              (declare-const ?bdnr Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdns Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bdnt Real)
      (push 1)
        (declare-const ?bdnu Real)
        (declare-const ?bdnv Real)
        (declare-const ?bdnw Real)
        (assert
          (and (and (not (= ?bdnw ?bdnv))
              (not (= ?bdnw ?bdnu))
              )
            (not (= ?bdnv ?bdnu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdnx Real)
        (declare-const ?bdny Real)
        (declare-const ?bdnz Real)
        (declare-const ?bdoa Real)
        (assert
          (and (and (not (= ?bdnz ?bdny))
              (not (= ?bdnz ?bdnx))
              )
            (not (= ?bdny ?bdnx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdob Real)
        (declare-const ?bdoc Real)
        (declare-const ?bdod Real)
        (declare-const ?bdoe Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bdoc ?bdob)
                    (= ?bdoc ?awmg)
                    )
                  (= ?bdob ?awmg)
                  )
                (or (or (= ?bdoe ?bdod)
                    (= ?bdoe ?awmg)
                    )
                  (= ?bdod ?awmg)
                  )
                )
              (and (not (= ?bdoc ?bdob))
                (and (and (not (= ?bdoe ?bdod))
                    (not (= ?bdoe ?awmg))
                    )
                  (not (= ?bdod ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdof Real)
        (declare-const ?bdog Real)
        (declare-const ?bdoh Real)
        (assert
          (and (and (not (= ?bdoh ?bdog))
              (not (= ?bdoh ?bdof))
              )
            (not (= ?bdog ?bdof))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdoi Real)
        (declare-const ?bdoj Real)
        (declare-const ?bdok Real)
        (declare-const ?bdol Real)
        (assert
          (and (and (not (= ?bdol ?bdok))
              (not (= ?bdol ?bdoj))
              )
            (not (= ?bdok ?bdoj))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdom Real)
        (declare-const ?bdon Real)
        (declare-const ?bdoo Real)
        (declare-const ?bdop Real)
        (declare-const ?bdoq Real)
        (declare-const ?bdor Real)
        (assert
          (or (and (or (or (= ?bdoo ?bdon)
                  (= ?bdoo ?bdom)
                  )
                (= ?bdon ?bdom)
                )
              (or (or (= ?bdor ?bdoq)
                  (= ?bdor ?bdop)
                  )
                (= ?bdoq ?bdop)
                )
              )
            (and (and (and (not (= ?bdoo ?bdon))
                  (not (= ?bdoo ?bdom))
                  )
                (not (= ?bdon ?bdom))
                )
              (and (and (not (= ?bdor ?bdoq))
                  (not (= ?bdor ?bdop))
                  )
                (not (= ?bdoq ?bdop))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdos Real)
        (declare-const ?bdot Real)
        (declare-const ?bdou Real)
        (assert
          (and (and (not (= ?bdou ?bdot))
              (not (= ?bdou ?bdos))
              )
            (not (= ?bdot ?bdos))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdov Real)
        (declare-const ?bdow Real)
        (declare-const ?bdox Real)
        (assert
          (and (and (not (= ?bdox ?bdow))
              (not (= ?bdox ?bdov))
              )
            (not (= ?bdow ?bdov))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?bdip ?bdio))
              (not (= ?bdip ?bdin))
              )
            (not (= ?bdio ?bdin))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bdoy Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bdoz Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bdpa Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdpb Real)
              (declare-const ?bdpc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdpd Real)
              (declare-const ?bdpe Real)
              (declare-const ?bdpf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdpg Real)
              (declare-const ?bdph Real)
              (declare-const ?bdpi Real)
              (declare-const ?bdpj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdpk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bdpl Real)
            (declare-const ?bdpm Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bdpn Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdpo Real)
              (declare-const ?bdpp Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdpq Real)
              (declare-const ?bdpr Real)
              (declare-const ?bdps Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdpt Real)
              (declare-const ?bdpu Real)
              (declare-const ?bdpv Real)
              (declare-const ?bdpw Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdpx Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bdpy Real)
            (declare-const ?bdpz Real)
            (declare-const ?bdqa Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bdqb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdqc Real)
              (declare-const ?bdqd Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdqe Real)
              (declare-const ?bdqf Real)
              (declare-const ?bdqg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdqh Real)
              (declare-const ?bdqi Real)
              (declare-const ?bdqj Real)
              (declare-const ?bdqk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdql Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bdqm Real)
            (declare-const ?bdqn Real)
            (declare-const ?bdqo Real)
            (declare-const ?bdqp Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bdqq Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdqr Real)
              (declare-const ?bdqs Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (and (and (and (= ?bdqo ?bdip)
                            (= ?bdqn ?bdio)
                            )
                          (= ?bdqm ?bdin)
                          )
                        (= ?bdqp ?bdoy)
                        )
                      (= ?bdqr ?bdnt)
                      )
                    (= ?bdqs ?bdoy)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdqt Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdqu Real)
                  (declare-const ?bdqv Real)
                  (declare-const ?bdqw Real)
                  (assert
                    (and (and (not (= ?bdqw ?bdqv))
                        (not (= ?bdqw ?bdqu))
                        )
                      (not (= ?bdqv ?bdqu))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdqx Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdqy Real)
                  (declare-const ?bdqz Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdra Real)
                  (declare-const ?bdrb Real)
                  (declare-const ?bdrc Real)
                  (declare-const ?bdrd Real)
                  (assert
                    (and (and (not (= ?bdrc ?bdrb))
                        (not (= ?bdrc ?bdra))
                        )
                      (not (= ?bdrb ?bdra))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdre Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdrf Real)
                  (declare-const ?bdrg Real)
                  (declare-const ?bdrh Real)
                  (declare-const ?bdri Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bdrg ?bdrf)
                              (= ?bdrg ?awmg)
                              )
                            (= ?bdrf ?awmg)
                            )
                          (or (or (= ?bdri ?bdrh)
                              (= ?bdri ?awmg)
                              )
                            (= ?bdrh ?awmg)
                            )
                          )
                        (and (not (= ?bdrg ?bdrf))
                          (and (and (not (= ?bdri ?bdrh))
                              (not (= ?bdri ?awmg))
                              )
                            (not (= ?bdrh ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdrj Real)
                  (declare-const ?bdrk Real)
                  (declare-const ?bdrl Real)
                  (assert
                    (and (and (not (= ?bdrl ?bdrk))
                        (not (= ?bdrl ?bdrj))
                        )
                      (not (= ?bdrk ?bdrj))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdrm Real)
                  (declare-const ?bdrn Real)
                  (declare-const ?bdro Real)
                  (declare-const ?bdrp Real)
                  (assert
                    (and (and (not (= ?bdrp ?bdro))
                        (not (= ?bdrp ?bdrn))
                        )
                      (not (= ?bdro ?bdrn))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdrq Real)
                  (declare-const ?bdrr Real)
                  (declare-const ?bdrs Real)
                  (declare-const ?bdrt Real)
                  (declare-const ?bdru Real)
                  (declare-const ?bdrv Real)
                  (assert
                    (or (and (or (or (= ?bdrs ?bdrr)
                            (= ?bdrs ?bdrq)
                            )
                          (= ?bdrr ?bdrq)
                          )
                        (or (or (= ?bdrv ?bdru)
                            (= ?bdrv ?bdrt)
                            )
                          (= ?bdru ?bdrt)
                          )
                        )
                      (and (and (and (not (= ?bdrs ?bdrr))
                            (not (= ?bdrs ?bdrq))
                            )
                          (not (= ?bdrr ?bdrq))
                          )
                        (and (and (not (= ?bdrv ?bdru))
                            (not (= ?bdrv ?bdrt))
                            )
                          (not (= ?bdru ?bdrt))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdrw Real)
                  (declare-const ?bdrx Real)
                  (declare-const ?bdry Real)
                  (assert
                    (and (and (not (= ?bdry ?bdrx))
                        (not (= ?bdry ?bdrw))
                        )
                      (not (= ?bdrx ?bdrw))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdrz Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdsa Real)
                  (declare-const ?bdsb Real)
                  (declare-const ?bdsc Real)
                  (assert
                    (and (and (not (= ?bdsc ?bdsb))
                        (not (= ?bdsc ?bdsa))
                        )
                      (not (= ?bdsb ?bdsa))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?bdsd Real)
              (declare-const ?bdse Real)
              (declare-const ?bdsf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdsg Real)
              (declare-const ?bdsh Real)
              (declare-const ?bdsi Real)
              (declare-const ?bdsj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdsk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bdsl Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bdsm Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdsn Real)
              (declare-const ?bdso Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdsp Real)
              (declare-const ?bdsq Real)
              (declare-const ?bdsr Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdss Real)
              (declare-const ?bdst Real)
              (declare-const ?bdsu Real)
              (declare-const ?bdsv Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdsw Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bdsx Real)
      (declare-const ?bdsy Real)
      (push 1)
        (declare-const ?bdsz Real)
        (declare-const ?bdta Real)
        (declare-const ?bdtb Real)
        (assert
          (and (and (not (= ?bdtb ?bdta))
              (not (= ?bdtb ?bdsz))
              )
            (not (= ?bdta ?bdsz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdtc Real)
        (declare-const ?bdtd Real)
        (declare-const ?bdte Real)
        (declare-const ?bdtf Real)
        (assert
          (and (and (not (= ?bdte ?bdtd))
              (not (= ?bdte ?bdtc))
              )
            (not (= ?bdtd ?bdtc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdtg Real)
        (declare-const ?bdth Real)
        (declare-const ?bdti Real)
        (declare-const ?bdtj Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bdth ?bdtg)
                    (= ?bdth ?awmg)
                    )
                  (= ?bdtg ?awmg)
                  )
                (or (or (= ?bdtj ?bdti)
                    (= ?bdtj ?awmg)
                    )
                  (= ?bdti ?awmg)
                  )
                )
              (and (not (= ?bdth ?bdtg))
                (and (and (not (= ?bdtj ?bdti))
                    (not (= ?bdtj ?awmg))
                    )
                  (not (= ?bdti ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdtk Real)
        (declare-const ?bdtl Real)
        (declare-const ?bdtm Real)
        (assert
          (and (and (not (= ?bdtm ?bdtl))
              (not (= ?bdtm ?bdtk))
              )
            (not (= ?bdtl ?bdtk))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdtn Real)
        (declare-const ?bdto Real)
        (declare-const ?bdtp Real)
        (declare-const ?bdtq Real)
        (assert
          (and (and (not (= ?bdtq ?bdtp))
              (not (= ?bdtq ?bdto))
              )
            (not (= ?bdtp ?bdto))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdtr Real)
        (declare-const ?bdts Real)
        (declare-const ?bdtt Real)
        (declare-const ?bdtu Real)
        (declare-const ?bdtv Real)
        (declare-const ?bdtw Real)
        (assert
          (or (and (or (or (= ?bdtt ?bdts)
                  (= ?bdtt ?bdtr)
                  )
                (= ?bdts ?bdtr)
                )
              (or (or (= ?bdtw ?bdtv)
                  (= ?bdtw ?bdtu)
                  )
                (= ?bdtv ?bdtu)
                )
              )
            (and (and (and (not (= ?bdtt ?bdts))
                  (not (= ?bdtt ?bdtr))
                  )
                (not (= ?bdts ?bdtr))
                )
              (and (and (not (= ?bdtw ?bdtv))
                  (not (= ?bdtw ?bdtu))
                  )
                (not (= ?bdtv ?bdtu))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdtx Real)
        (declare-const ?bdty Real)
        (declare-const ?bdtz Real)
        (assert
          (and (and (not (= ?bdtz ?bdty))
              (not (= ?bdtz ?bdtx))
              )
            (not (= ?bdty ?bdtx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdua Real)
        (declare-const ?bdub Real)
        (declare-const ?bduc Real)
        (assert
          (and (and (not (= ?bduc ?bdub))
              (not (= ?bduc ?bdua))
              )
            (not (= ?bdub ?bdua))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bdud Real)
      (declare-const ?bdue Real)
      (declare-const ?bduf Real)
      (push 1)
        (declare-const ?bdug Real)
        (declare-const ?bduh Real)
        (declare-const ?bdui Real)
        (assert
          (and (and (not (= ?bdui ?bduh))
              (not (= ?bdui ?bdug))
              )
            (not (= ?bduh ?bdug))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bduj Real)
        (declare-const ?bduk Real)
        (declare-const ?bdul Real)
        (declare-const ?bdum Real)
        (assert
          (and (and (not (= ?bdul ?bduk))
              (not (= ?bdul ?bduj))
              )
            (not (= ?bduk ?bduj))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdun Real)
        (declare-const ?bduo Real)
        (declare-const ?bdup Real)
        (declare-const ?bduq Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bduo ?bdun)
                    (= ?bduo ?awmg)
                    )
                  (= ?bdun ?awmg)
                  )
                (or (or (= ?bduq ?bdup)
                    (= ?bduq ?awmg)
                    )
                  (= ?bdup ?awmg)
                  )
                )
              (and (not (= ?bduo ?bdun))
                (and (and (not (= ?bduq ?bdup))
                    (not (= ?bduq ?awmg))
                    )
                  (not (= ?bdup ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdur Real)
        (declare-const ?bdus Real)
        (declare-const ?bdut Real)
        (assert
          (and (and (not (= ?bdut ?bdus))
              (not (= ?bdut ?bdur))
              )
            (not (= ?bdus ?bdur))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bduu Real)
        (declare-const ?bduv Real)
        (declare-const ?bduw Real)
        (declare-const ?bdux Real)
        (assert
          (and (and (not (= ?bdux ?bduw))
              (not (= ?bdux ?bduv))
              )
            (not (= ?bduw ?bduv))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bduy Real)
        (declare-const ?bduz Real)
        (declare-const ?bdva Real)
        (declare-const ?bdvb Real)
        (declare-const ?bdvc Real)
        (declare-const ?bdvd Real)
        (assert
          (or (and (or (or (= ?bdva ?bduz)
                  (= ?bdva ?bduy)
                  )
                (= ?bduz ?bduy)
                )
              (or (or (= ?bdvd ?bdvc)
                  (= ?bdvd ?bdvb)
                  )
                (= ?bdvc ?bdvb)
                )
              )
            (and (and (and (not (= ?bdva ?bduz))
                  (not (= ?bdva ?bduy))
                  )
                (not (= ?bduz ?bduy))
                )
              (and (and (not (= ?bdvd ?bdvc))
                  (not (= ?bdvd ?bdvb))
                  )
                (not (= ?bdvc ?bdvb))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdve Real)
        (declare-const ?bdvf Real)
        (declare-const ?bdvg Real)
        (assert
          (and (and (not (= ?bdvg ?bdvf))
              (not (= ?bdvg ?bdve))
              )
            (not (= ?bdvf ?bdve))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdvh Real)
        (declare-const ?bdvi Real)
        (declare-const ?bdvj Real)
        (assert
          (and (and (not (= ?bdvj ?bdvi))
              (not (= ?bdvj ?bdvh))
              )
            (not (= ?bdvi ?bdvh))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (or (and (or (or (= ?bduf ?bdue)
                  (= ?bduf ?bdud)
                  )
                (= ?bdue ?bdud)
                )
              (or (or (= ?bdip ?bdio)
                  (= ?bdip ?bdin)
                  )
                (= ?bdio ?bdin)
                )
              )
            (and (and (and (not (= ?bduf ?bdue))
                  (not (= ?bduf ?bdud))
                  )
                (not (= ?bdue ?bdud))
                )
              (and (and (not (= ?bdip ?bdio))
                  (not (= ?bdip ?bdin))
                  )
                (not (= ?bdio ?bdin))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bdvk Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bdvl Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bdvm Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdvn Real)
              (declare-const ?bdvo Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdvp Real)
              (declare-const ?bdvq Real)
              (declare-const ?bdvr Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdvs Real)
              (declare-const ?bdvt Real)
              (declare-const ?bdvu Real)
              (declare-const ?bdvv Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdvw Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bdvx Real)
            (declare-const ?bdvy Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bdvz Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdwa Real)
              (declare-const ?bdwb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdwc Real)
              (declare-const ?bdwd Real)
              (declare-const ?bdwe Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdwf Real)
              (declare-const ?bdwg Real)
              (declare-const ?bdwh Real)
              (declare-const ?bdwi Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdwj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bdwk Real)
            (declare-const ?bdwl Real)
            (declare-const ?bdwm Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bdwn Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdwo Real)
              (declare-const ?bdwp Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdwq Real)
              (declare-const ?bdwr Real)
              (declare-const ?bdws Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdwt Real)
              (declare-const ?bdwu Real)
              (declare-const ?bdwv Real)
              (declare-const ?bdww Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdwx Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bdwy Real)
            (declare-const ?bdwz Real)
            (declare-const ?bdxa Real)
            (declare-const ?bdxb Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bdxc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdxd Real)
              (declare-const ?bdxe Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdxf Real)
              (declare-const ?bdxg Real)
              (declare-const ?bdxh Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdxi Real)
              (declare-const ?bdxj Real)
              (declare-const ?bdxk Real)
              (declare-const ?bdxl Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (and (and (and (= ?bdxa ?bdip)
                            (= ?bdwz ?bdio)
                            )
                          (= ?bdwy ?bdin)
                          )
                        (= ?bdxb ?bdvk)
                        )
                      (and (and (= ?bdxk ?bduf)
                          (= ?bdxj ?bdue)
                          )
                        (= ?bdxi ?bdud)
                        )
                      )
                    (= ?bdxl ?bdvk)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdxm Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdxn Real)
                  (declare-const ?bdxo Real)
                  (declare-const ?bdxp Real)
                  (assert
                    (and (and (not (= ?bdxp ?bdxo))
                        (not (= ?bdxp ?bdxn))
                        )
                      (not (= ?bdxo ?bdxn))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdxq Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdxr Real)
                  (declare-const ?bdxs Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdxt Real)
                  (declare-const ?bdxu Real)
                  (declare-const ?bdxv Real)
                  (declare-const ?bdxw Real)
                  (assert
                    (and (and (not (= ?bdxv ?bdxu))
                        (not (= ?bdxv ?bdxt))
                        )
                      (not (= ?bdxu ?bdxt))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdxx Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdxy Real)
                  (declare-const ?bdxz Real)
                  (declare-const ?bdya Real)
                  (declare-const ?bdyb Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bdxz ?bdxy)
                              (= ?bdxz ?awmg)
                              )
                            (= ?bdxy ?awmg)
                            )
                          (or (or (= ?bdyb ?bdya)
                              (= ?bdyb ?awmg)
                              )
                            (= ?bdya ?awmg)
                            )
                          )
                        (and (not (= ?bdxz ?bdxy))
                          (and (and (not (= ?bdyb ?bdya))
                              (not (= ?bdyb ?awmg))
                              )
                            (not (= ?bdya ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdyc Real)
                  (declare-const ?bdyd Real)
                  (declare-const ?bdye Real)
                  (assert
                    (and (and (not (= ?bdye ?bdyd))
                        (not (= ?bdye ?bdyc))
                        )
                      (not (= ?bdyd ?bdyc))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdyf Real)
                  (declare-const ?bdyg Real)
                  (declare-const ?bdyh Real)
                  (declare-const ?bdyi Real)
                  (assert
                    (and (and (not (= ?bdyi ?bdyh))
                        (not (= ?bdyi ?bdyg))
                        )
                      (not (= ?bdyh ?bdyg))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdyj Real)
                  (declare-const ?bdyk Real)
                  (declare-const ?bdyl Real)
                  (declare-const ?bdym Real)
                  (declare-const ?bdyn Real)
                  (declare-const ?bdyo Real)
                  (assert
                    (or (and (or (or (= ?bdyl ?bdyk)
                            (= ?bdyl ?bdyj)
                            )
                          (= ?bdyk ?bdyj)
                          )
                        (or (or (= ?bdyo ?bdyn)
                            (= ?bdyo ?bdym)
                            )
                          (= ?bdyn ?bdym)
                          )
                        )
                      (and (and (and (not (= ?bdyl ?bdyk))
                            (not (= ?bdyl ?bdyj))
                            )
                          (not (= ?bdyk ?bdyj))
                          )
                        (and (and (not (= ?bdyo ?bdyn))
                            (not (= ?bdyo ?bdym))
                            )
                          (not (= ?bdyn ?bdym))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdyp Real)
                  (declare-const ?bdyq Real)
                  (declare-const ?bdyr Real)
                  (assert
                    (and (and (not (= ?bdyr ?bdyq))
                        (not (= ?bdyr ?bdyp))
                        )
                      (not (= ?bdyq ?bdyp))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdys Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bdyt Real)
                  (declare-const ?bdyu Real)
                  (declare-const ?bdyv Real)
                  (assert
                    (and (and (not (= ?bdyv ?bdyu))
                        (not (= ?bdyv ?bdyt))
                        )
                      (not (= ?bdyu ?bdyt))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?bdyw Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bdyx Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bdyy Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdyz Real)
              (declare-const ?bdza Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdzb Real)
              (declare-const ?bdzc Real)
              (declare-const ?bdzd Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdze Real)
              (declare-const ?bdzf Real)
              (declare-const ?bdzg Real)
              (declare-const ?bdzh Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bdzi Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (declare-const ?bdzj Real)
        (declare-const ?bdzk Real)
        (declare-const ?bdzl Real)
        (assert
          (and (and (not (= ?bdzl ?bdzk))
              (not (= ?bdzl ?bdzj))
              )
            (not (= ?bdzk ?bdzj))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdzm Real)
        (declare-const ?bdzn Real)
        (declare-const ?bdzo Real)
        (declare-const ?bdzp Real)
        (assert
          (and (and (not (= ?bdzo ?bdzn))
              (not (= ?bdzo ?bdzm))
              )
            (not (= ?bdzn ?bdzm))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdzq Real)
        (declare-const ?bdzr Real)
        (declare-const ?bdzs Real)
        (declare-const ?bdzt Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bdzr ?bdzq)
                    (= ?bdzr ?awmg)
                    )
                  (= ?bdzq ?awmg)
                  )
                (or (or (= ?bdzt ?bdzs)
                    (= ?bdzt ?awmg)
                    )
                  (= ?bdzs ?awmg)
                  )
                )
              (and (not (= ?bdzr ?bdzq))
                (and (and (not (= ?bdzt ?bdzs))
                    (not (= ?bdzt ?awmg))
                    )
                  (not (= ?bdzs ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdzu Real)
        (declare-const ?bdzv Real)
        (declare-const ?bdzw Real)
        (assert
          (and (and (not (= ?bdzw ?bdzv))
              (not (= ?bdzw ?bdzu))
              )
            (not (= ?bdzv ?bdzu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bdzx Real)
        (declare-const ?bdzy Real)
        (declare-const ?bdzz Real)
        (declare-const ?beaa Real)
        (assert
          (and (and (not (= ?beaa ?bdzz))
              (not (= ?beaa ?bdzy))
              )
            (not (= ?bdzz ?bdzy))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?beab Real)
        (declare-const ?beac Real)
        (declare-const ?bead Real)
        (declare-const ?beae Real)
        (declare-const ?beaf Real)
        (declare-const ?beag Real)
        (assert
          (or (and (or (or (= ?bead ?beac)
                  (= ?bead ?beab)
                  )
                (= ?beac ?beab)
                )
              (or (or (= ?beag ?beaf)
                  (= ?beag ?beae)
                  )
                (= ?beaf ?beae)
                )
              )
            (and (and (and (not (= ?bead ?beac))
                  (not (= ?bead ?beab))
                  )
                (not (= ?beac ?beab))
                )
              (and (and (not (= ?beag ?beaf))
                  (not (= ?beag ?beae))
                  )
                (not (= ?beaf ?beae))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?beah Real)
        (declare-const ?beai Real)
        (declare-const ?beaj Real)
        (assert
          (and (and (not (= ?beaj ?beai))
              (not (= ?beaj ?beah))
              )
            (not (= ?beai ?beah))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?beak Real)
        (declare-const ?beal Real)
        (declare-const ?beam Real)
        (assert
          (and (and (not (= ?beam ?beal))
              (not (= ?beam ?beak))
              )
            (not (= ?beal ?beak))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?bdip ?bdio))
              (not (= ?bdip ?bdin))
              )
            (not (= ?bdio ?bdin))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bean Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?beao Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?beap Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?beaq Real)
              (declare-const ?bear Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?beas Real)
              (declare-const ?beat Real)
              (declare-const ?beau Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?beav Real)
              (declare-const ?beaw Real)
              (declare-const ?beax Real)
              (declare-const ?beay Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?beaz Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?beba Real)
            (declare-const ?bebb Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bebc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bebd Real)
              (declare-const ?bebe Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bebf Real)
              (declare-const ?bebg Real)
              (declare-const ?bebh Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bebi Real)
              (declare-const ?bebj Real)
              (declare-const ?bebk Real)
              (declare-const ?bebl Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bebm Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bebn Real)
            (declare-const ?bebo Real)
            (declare-const ?bebp Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bebq Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bebr Real)
              (declare-const ?bebs Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bebt Real)
              (declare-const ?bebu Real)
              (declare-const ?bebv Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bebw Real)
              (declare-const ?bebx Real)
              (declare-const ?beby Real)
              (declare-const ?bebz Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?beca Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?becb Real)
            (declare-const ?becc Real)
            (declare-const ?becd Real)
            (declare-const ?bece Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?becf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?becg Real)
              (declare-const ?bech Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?beci Real)
              (declare-const ?becj Real)
              (declare-const ?beck Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?becl Real)
              (declare-const ?becm Real)
              (declare-const ?becn Real)
              (declare-const ?beco Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?becp Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (and (and (= ?becd ?bdip)
                          (= ?becc ?bdio)
                          )
                        (= ?becb ?bdin)
                        )
                      (= ?bece ?bean)
                      )
                    (= ?becp ?bean)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?becq Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?becr Real)
                  (declare-const ?becs Real)
                  (declare-const ?bect Real)
                  (assert
                    (and (and (not (= ?bect ?becs))
                        (not (= ?bect ?becr))
                        )
                      (not (= ?becs ?becr))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?becu Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?becv Real)
                  (declare-const ?becw Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?becx Real)
                  (declare-const ?becy Real)
                  (declare-const ?becz Real)
                  (declare-const ?beda Real)
                  (assert
                    (and (and (not (= ?becz ?becy))
                        (not (= ?becz ?becx))
                        )
                      (not (= ?becy ?becx))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bedb Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bedc Real)
                  (declare-const ?bedd Real)
                  (declare-const ?bede Real)
                  (declare-const ?bedf Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bedd ?bedc)
                              (= ?bedd ?awmg)
                              )
                            (= ?bedc ?awmg)
                            )
                          (or (or (= ?bedf ?bede)
                              (= ?bedf ?awmg)
                              )
                            (= ?bede ?awmg)
                            )
                          )
                        (and (not (= ?bedd ?bedc))
                          (and (and (not (= ?bedf ?bede))
                              (not (= ?bedf ?awmg))
                              )
                            (not (= ?bede ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bedg Real)
                  (declare-const ?bedh Real)
                  (declare-const ?bedi Real)
                  (assert
                    (and (and (not (= ?bedi ?bedh))
                        (not (= ?bedi ?bedg))
                        )
                      (not (= ?bedh ?bedg))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bedj Real)
                  (declare-const ?bedk Real)
                  (declare-const ?bedl Real)
                  (declare-const ?bedm Real)
                  (assert
                    (and (and (not (= ?bedm ?bedl))
                        (not (= ?bedm ?bedk))
                        )
                      (not (= ?bedl ?bedk))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bedn Real)
                  (declare-const ?bedo Real)
                  (declare-const ?bedp Real)
                  (declare-const ?bedq Real)
                  (declare-const ?bedr Real)
                  (declare-const ?beds Real)
                  (assert
                    (or (and (or (or (= ?bedp ?bedo)
                            (= ?bedp ?bedn)
                            )
                          (= ?bedo ?bedn)
                          )
                        (or (or (= ?beds ?bedr)
                            (= ?beds ?bedq)
                            )
                          (= ?bedr ?bedq)
                          )
                        )
                      (and (and (and (not (= ?bedp ?bedo))
                            (not (= ?bedp ?bedn))
                            )
                          (not (= ?bedo ?bedn))
                          )
                        (and (and (not (= ?beds ?bedr))
                            (not (= ?beds ?bedq))
                            )
                          (not (= ?bedr ?bedq))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bedt Real)
                  (declare-const ?bedu Real)
                  (declare-const ?bedv Real)
                  (assert
                    (and (and (not (= ?bedv ?bedu))
                        (not (= ?bedv ?bedt))
                        )
                      (not (= ?bedu ?bedt))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bedw Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bedx Real)
                  (declare-const ?bedy Real)
                  (declare-const ?bedz Real)
                  (assert
                    (and (and (not (= ?bedz ?bedy))
                        (not (= ?bedz ?bedx))
                        )
                      (not (= ?bedy ?bedx))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?beea Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?beeb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?beec Real)
              (declare-const ?beed Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?beee Real)
              (declare-const ?beef Real)
              (declare-const ?beeg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?beeh Real)
              (declare-const ?beei Real)
              (declare-const ?beej Real)
              (declare-const ?beek Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?beel Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (push 1)
        (declare-const ?beem Real)
        (declare-const ?been Real)
        (declare-const ?beeo Real)
        (assert
          (and (and (not (= ?beeo ?been))
              (not (= ?beeo ?beem))
              )
            (not (= ?been ?beem))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?beep Real)
        (declare-const ?beeq Real)
        (declare-const ?beer Real)
        (declare-const ?bees Real)
        (assert
          (and (and (not (= ?beer ?beeq))
              (not (= ?beer ?beep))
              )
            (not (= ?beeq ?beep))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?beet Real)
        (declare-const ?beeu Real)
        (declare-const ?beev Real)
        (declare-const ?beew Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?beeu ?beet)
                    (= ?beeu ?awmg)
                    )
                  (= ?beet ?awmg)
                  )
                (or (or (= ?beew ?beev)
                    (= ?beew ?awmg)
                    )
                  (= ?beev ?awmg)
                  )
                )
              (and (not (= ?beeu ?beet))
                (and (and (not (= ?beew ?beev))
                    (not (= ?beew ?awmg))
                    )
                  (not (= ?beev ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?beex Real)
        (declare-const ?beey Real)
        (declare-const ?beez Real)
        (assert
          (and (and (not (= ?beez ?beey))
              (not (= ?beez ?beex))
              )
            (not (= ?beey ?beex))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?befa Real)
        (declare-const ?befb Real)
        (declare-const ?befc Real)
        (declare-const ?befd Real)
        (assert
          (and (and (not (= ?befd ?befc))
              (not (= ?befd ?befb))
              )
            (not (= ?befc ?befb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?befe Real)
        (declare-const ?beff Real)
        (declare-const ?befg Real)
        (declare-const ?befh Real)
        (declare-const ?befi Real)
        (declare-const ?befj Real)
        (assert
          (or (and (or (or (= ?befg ?beff)
                  (= ?befg ?befe)
                  )
                (= ?beff ?befe)
                )
              (or (or (= ?befj ?befi)
                  (= ?befj ?befh)
                  )
                (= ?befi ?befh)
                )
              )
            (and (and (and (not (= ?befg ?beff))
                  (not (= ?befg ?befe))
                  )
                (not (= ?beff ?befe))
                )
              (and (and (not (= ?befj ?befi))
                  (not (= ?befj ?befh))
                  )
                (not (= ?befi ?befh))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?befk Real)
        (declare-const ?befl Real)
        (declare-const ?befm Real)
        (assert
          (and (and (not (= ?befm ?befl))
              (not (= ?befm ?befk))
              )
            (not (= ?befl ?befk))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?befn Real)
        (declare-const ?befo Real)
        (declare-const ?befp Real)
        (assert
          (and (and (not (= ?befp ?befo))
              (not (= ?befp ?befn))
              )
            (not (= ?befo ?befn))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?befq Real)
          (push 1)
            (declare-const ?befr Real)
            (push 1)
              (declare-const ?befs Real)
              (push 1)
                (assert
                  (and (= ?befr ?befq)
                    (= ?befs ?befq)
                    )
                  )
                (push 1)
                  (declare-const ?beft Real)
                  (declare-const ?befu Real)
                  (declare-const ?befv Real)
                  (assert
                    (and (and (not (= ?befv ?befu))
                        (not (= ?befv ?beft))
                        )
                      (not (= ?befu ?beft))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?befw Real)
                  (declare-const ?befx Real)
                  (declare-const ?befy Real)
                  (declare-const ?befz Real)
                  (assert
                    (and (and (not (= ?befy ?befx))
                        (not (= ?befy ?befw))
                        )
                      (not (= ?befx ?befw))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bega Real)
                  (declare-const ?begb Real)
                  (declare-const ?begc Real)
                  (declare-const ?begd Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?begb ?bega)
                              (= ?begb ?awmg)
                              )
                            (= ?bega ?awmg)
                            )
                          (or (or (= ?begd ?begc)
                              (= ?begd ?awmg)
                              )
                            (= ?begc ?awmg)
                            )
                          )
                        (and (not (= ?begb ?bega))
                          (and (and (not (= ?begd ?begc))
                              (not (= ?begd ?awmg))
                              )
                            (not (= ?begc ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bege Real)
                  (declare-const ?begf Real)
                  (declare-const ?begg Real)
                  (assert
                    (and (and (not (= ?begg ?begf))
                        (not (= ?begg ?bege))
                        )
                      (not (= ?begf ?bege))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?begh Real)
                  (declare-const ?begi Real)
                  (declare-const ?begj Real)
                  (declare-const ?begk Real)
                  (assert
                    (and (and (not (= ?begk ?begj))
                        (not (= ?begk ?begi))
                        )
                      (not (= ?begj ?begi))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?begl Real)
                  (declare-const ?begm Real)
                  (declare-const ?begn Real)
                  (declare-const ?bego Real)
                  (declare-const ?begp Real)
                  (declare-const ?begq Real)
                  (assert
                    (or (and (or (or (= ?begn ?begm)
                            (= ?begn ?begl)
                            )
                          (= ?begm ?begl)
                          )
                        (or (or (= ?begq ?begp)
                            (= ?begq ?bego)
                            )
                          (= ?begp ?bego)
                          )
                        )
                      (and (and (and (not (= ?begn ?begm))
                            (not (= ?begn ?begl))
                            )
                          (not (= ?begm ?begl))
                          )
                        (and (and (not (= ?begq ?begp))
                            (not (= ?begq ?bego))
                            )
                          (not (= ?begp ?bego))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?begr Real)
                  (declare-const ?begs Real)
                  (declare-const ?begt Real)
                  (assert
                    (and (and (not (= ?begt ?begs))
                        (not (= ?begt ?begr))
                        )
                      (not (= ?begs ?begr))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?begu Real)
                  (declare-const ?begv Real)
                  (declare-const ?begw Real)
                  (assert
                    (and (and (not (= ?begw ?begv))
                        (not (= ?begw ?begu))
                        )
                      (not (= ?begv ?begu))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?begx Real)
      (push 1)
        (declare-const ?begy Real)
        (declare-const ?begz Real)
        (declare-const ?beha Real)
        (assert
          (and (and (not (= ?beha ?begz))
              (not (= ?beha ?begy))
              )
            (not (= ?begz ?begy))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?behb Real)
        (declare-const ?behc Real)
        (declare-const ?behd Real)
        (declare-const ?behe Real)
        (assert
          (and (and (not (= ?behd ?behc))
              (not (= ?behd ?behb))
              )
            (not (= ?behc ?behb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?behf Real)
        (declare-const ?behg Real)
        (declare-const ?behh Real)
        (declare-const ?behi Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?behg ?behf)
                    (= ?behg ?awmg)
                    )
                  (= ?behf ?awmg)
                  )
                (or (or (= ?behi ?behh)
                    (= ?behi ?awmg)
                    )
                  (= ?behh ?awmg)
                  )
                )
              (and (not (= ?behg ?behf))
                (and (and (not (= ?behi ?behh))
                    (not (= ?behi ?awmg))
                    )
                  (not (= ?behh ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?behj Real)
        (declare-const ?behk Real)
        (declare-const ?behl Real)
        (assert
          (and (and (not (= ?behl ?behk))
              (not (= ?behl ?behj))
              )
            (not (= ?behk ?behj))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?behm Real)
        (declare-const ?behn Real)
        (declare-const ?beho Real)
        (declare-const ?behp Real)
        (assert
          (and (and (not (= ?behp ?beho))
              (not (= ?behp ?behn))
              )
            (not (= ?beho ?behn))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?behq Real)
        (declare-const ?behr Real)
        (declare-const ?behs Real)
        (declare-const ?beht Real)
        (declare-const ?behu Real)
        (declare-const ?behv Real)
        (assert
          (or (and (or (or (= ?behs ?behr)
                  (= ?behs ?behq)
                  )
                (= ?behr ?behq)
                )
              (or (or (= ?behv ?behu)
                  (= ?behv ?beht)
                  )
                (= ?behu ?beht)
                )
              )
            (and (and (and (not (= ?behs ?behr))
                  (not (= ?behs ?behq))
                  )
                (not (= ?behr ?behq))
                )
              (and (and (not (= ?behv ?behu))
                  (not (= ?behv ?beht))
                  )
                (not (= ?behu ?beht))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?behw Real)
        (declare-const ?behx Real)
        (declare-const ?behy Real)
        (assert
          (and (and (not (= ?behy ?behx))
              (not (= ?behy ?behw))
              )
            (not (= ?behx ?behw))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?behz Real)
        (declare-const ?beia Real)
        (declare-const ?beib Real)
        (assert
          (and (and (not (= ?beib ?beia))
              (not (= ?beib ?behz))
              )
            (not (= ?beia ?behz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?beic Real)
          (push 1)
            (declare-const ?beid Real)
            (push 1)
              (declare-const ?beie Real)
              (declare-const ?beif Real)
              (push 1)
                (assert
                  (and (and (= ?beid ?beic)
                      (= ?beie ?begx)
                      )
                    (= ?beif ?beic)
                    )
                  )
                (push 1)
                  (declare-const ?beig Real)
                  (declare-const ?beih Real)
                  (declare-const ?beii Real)
                  (assert
                    (and (and (not (= ?beii ?beih))
                        (not (= ?beii ?beig))
                        )
                      (not (= ?beih ?beig))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?beij Real)
                  (declare-const ?beik Real)
                  (declare-const ?beil Real)
                  (declare-const ?beim Real)
                  (assert
                    (and (and (not (= ?beil ?beik))
                        (not (= ?beil ?beij))
                        )
                      (not (= ?beik ?beij))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bein Real)
                  (declare-const ?beio Real)
                  (declare-const ?beip Real)
                  (declare-const ?beiq Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?beio ?bein)
                              (= ?beio ?awmg)
                              )
                            (= ?bein ?awmg)
                            )
                          (or (or (= ?beiq ?beip)
                              (= ?beiq ?awmg)
                              )
                            (= ?beip ?awmg)
                            )
                          )
                        (and (not (= ?beio ?bein))
                          (and (and (not (= ?beiq ?beip))
                              (not (= ?beiq ?awmg))
                              )
                            (not (= ?beip ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?beir Real)
                  (declare-const ?beis Real)
                  (declare-const ?beit Real)
                  (assert
                    (and (and (not (= ?beit ?beis))
                        (not (= ?beit ?beir))
                        )
                      (not (= ?beis ?beir))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?beiu Real)
                  (declare-const ?beiv Real)
                  (declare-const ?beiw Real)
                  (declare-const ?beix Real)
                  (assert
                    (and (and (not (= ?beix ?beiw))
                        (not (= ?beix ?beiv))
                        )
                      (not (= ?beiw ?beiv))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?beiy Real)
                  (declare-const ?beiz Real)
                  (declare-const ?beja Real)
                  (declare-const ?bejb Real)
                  (declare-const ?bejc Real)
                  (declare-const ?bejd Real)
                  (assert
                    (or (and (or (or (= ?beja ?beiz)
                            (= ?beja ?beiy)
                            )
                          (= ?beiz ?beiy)
                          )
                        (or (or (= ?bejd ?bejc)
                            (= ?bejd ?bejb)
                            )
                          (= ?bejc ?bejb)
                          )
                        )
                      (and (and (and (not (= ?beja ?beiz))
                            (not (= ?beja ?beiy))
                            )
                          (not (= ?beiz ?beiy))
                          )
                        (and (and (not (= ?bejd ?bejc))
                            (not (= ?bejd ?bejb))
                            )
                          (not (= ?bejc ?bejb))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?beje Real)
                  (declare-const ?bejf Real)
                  (declare-const ?bejg Real)
                  (assert
                    (and (and (not (= ?bejg ?bejf))
                        (not (= ?bejg ?beje))
                        )
                      (not (= ?bejf ?beje))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bejh Real)
                  (declare-const ?beji Real)
                  (declare-const ?bejj Real)
                  (assert
                    (and (and (not (= ?bejj ?beji))
                        (not (= ?bejj ?bejh))
                        )
                      (not (= ?beji ?bejh))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bejk Real)
      (declare-const ?bejl Real)
      (push 1)
        (declare-const ?bejm Real)
        (declare-const ?bejn Real)
        (declare-const ?bejo Real)
        (assert
          (and (and (not (= ?bejo ?bejn))
              (not (= ?bejo ?bejm))
              )
            (not (= ?bejn ?bejm))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bejp Real)
        (declare-const ?bejq Real)
        (declare-const ?bejr Real)
        (declare-const ?bejs Real)
        (assert
          (and (and (not (= ?bejr ?bejq))
              (not (= ?bejr ?bejp))
              )
            (not (= ?bejq ?bejp))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bejt Real)
        (declare-const ?beju Real)
        (declare-const ?bejv Real)
        (declare-const ?bejw Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?beju ?bejt)
                    (= ?beju ?awmg)
                    )
                  (= ?bejt ?awmg)
                  )
                (or (or (= ?bejw ?bejv)
                    (= ?bejw ?awmg)
                    )
                  (= ?bejv ?awmg)
                  )
                )
              (and (not (= ?beju ?bejt))
                (and (and (not (= ?bejw ?bejv))
                    (not (= ?bejw ?awmg))
                    )
                  (not (= ?bejv ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bejx Real)
        (declare-const ?bejy Real)
        (declare-const ?bejz Real)
        (assert
          (and (and (not (= ?bejz ?bejy))
              (not (= ?bejz ?bejx))
              )
            (not (= ?bejy ?bejx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?beka Real)
        (declare-const ?bekb Real)
        (declare-const ?bekc Real)
        (declare-const ?bekd Real)
        (assert
          (and (and (not (= ?bekd ?bekc))
              (not (= ?bekd ?bekb))
              )
            (not (= ?bekc ?bekb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?beke Real)
        (declare-const ?bekf Real)
        (declare-const ?bekg Real)
        (declare-const ?bekh Real)
        (declare-const ?beki Real)
        (declare-const ?bekj Real)
        (assert
          (or (and (or (or (= ?bekg ?bekf)
                  (= ?bekg ?beke)
                  )
                (= ?bekf ?beke)
                )
              (or (or (= ?bekj ?beki)
                  (= ?bekj ?bekh)
                  )
                (= ?beki ?bekh)
                )
              )
            (and (and (and (not (= ?bekg ?bekf))
                  (not (= ?bekg ?beke))
                  )
                (not (= ?bekf ?beke))
                )
              (and (and (not (= ?bekj ?beki))
                  (not (= ?bekj ?bekh))
                  )
                (not (= ?beki ?bekh))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bekk Real)
        (declare-const ?bekl Real)
        (declare-const ?bekm Real)
        (assert
          (and (and (not (= ?bekm ?bekl))
              (not (= ?bekm ?bekk))
              )
            (not (= ?bekl ?bekk))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bekn Real)
        (declare-const ?beko Real)
        (declare-const ?bekp Real)
        (assert
          (and (and (not (= ?bekp ?beko))
              (not (= ?bekp ?bekn))
              )
            (not (= ?beko ?bekn))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bekq Real)
      (declare-const ?bekr Real)
      (declare-const ?beks Real)
      (push 1)
        (declare-const ?bekt Real)
        (declare-const ?beku Real)
        (declare-const ?bekv Real)
        (assert
          (and (and (not (= ?bekv ?beku))
              (not (= ?bekv ?bekt))
              )
            (not (= ?beku ?bekt))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bekw Real)
        (declare-const ?bekx Real)
        (declare-const ?beky Real)
        (declare-const ?bekz Real)
        (assert
          (and (and (not (= ?beky ?bekx))
              (not (= ?beky ?bekw))
              )
            (not (= ?bekx ?bekw))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bela Real)
        (declare-const ?belb Real)
        (declare-const ?belc Real)
        (declare-const ?beld Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?belb ?bela)
                    (= ?belb ?awmg)
                    )
                  (= ?bela ?awmg)
                  )
                (or (or (= ?beld ?belc)
                    (= ?beld ?awmg)
                    )
                  (= ?belc ?awmg)
                  )
                )
              (and (not (= ?belb ?bela))
                (and (and (not (= ?beld ?belc))
                    (not (= ?beld ?awmg))
                    )
                  (not (= ?belc ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bele Real)
        (declare-const ?belf Real)
        (declare-const ?belg Real)
        (assert
          (and (and (not (= ?belg ?belf))
              (not (= ?belg ?bele))
              )
            (not (= ?belf ?bele))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?belh Real)
        (declare-const ?beli Real)
        (declare-const ?belj Real)
        (declare-const ?belk Real)
        (assert
          (and (and (not (= ?belk ?belj))
              (not (= ?belk ?beli))
              )
            (not (= ?belj ?beli))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bell Real)
        (declare-const ?belm Real)
        (declare-const ?beln Real)
        (declare-const ?belo Real)
        (declare-const ?belp Real)
        (declare-const ?belq Real)
        (assert
          (or (and (or (or (= ?beln ?belm)
                  (= ?beln ?bell)
                  )
                (= ?belm ?bell)
                )
              (or (or (= ?belq ?belp)
                  (= ?belq ?belo)
                  )
                (= ?belp ?belo)
                )
              )
            (and (and (and (not (= ?beln ?belm))
                  (not (= ?beln ?bell))
                  )
                (not (= ?belm ?bell))
                )
              (and (and (not (= ?belq ?belp))
                  (not (= ?belq ?belo))
                  )
                (not (= ?belp ?belo))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?belr Real)
        (declare-const ?bels Real)
        (declare-const ?belt Real)
        (assert
          (and (and (not (= ?belt ?bels))
              (not (= ?belt ?belr))
              )
            (not (= ?bels ?belr))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?belu Real)
        (declare-const ?belv Real)
        (declare-const ?belw Real)
        (assert
          (and (and (not (= ?belw ?belv))
              (not (= ?belw ?belu))
              )
            (not (= ?belv ?belu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?beks ?bekr))
              (not (= ?beks ?bekq))
              )
            (not (= ?bekr ?bekq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?belx Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bely Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?belz Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bema Real)
              (declare-const ?bemb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bemc Real)
              (declare-const ?bemd Real)
              (declare-const ?beme Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bemf Real)
              (declare-const ?bemg Real)
              (declare-const ?bemh Real)
              (declare-const ?bemi Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bemj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bemk Real)
            (declare-const ?beml Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bemm Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bemn Real)
              (declare-const ?bemo Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bemp Real)
              (declare-const ?bemq Real)
              (declare-const ?bemr Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bems Real)
              (declare-const ?bemt Real)
              (declare-const ?bemu Real)
              (declare-const ?bemv Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bemw Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bemx Real)
            (declare-const ?bemy Real)
            (declare-const ?bemz Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bena Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?benb Real)
              (declare-const ?benc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bend Real)
              (declare-const ?bene Real)
              (declare-const ?benf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?beng Real)
              (declare-const ?benh Real)
              (declare-const ?beni Real)
              (declare-const ?benj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?benk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?benl Real)
            (declare-const ?benm Real)
            (declare-const ?benn Real)
            (declare-const ?beno Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?benp Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?benq Real)
              (declare-const ?benr Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bens Real)
              (declare-const ?bent Real)
              (declare-const ?benu Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?benv Real)
              (declare-const ?benw Real)
              (declare-const ?benx Real)
              (declare-const ?beny Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?benz Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?beoa Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?beob Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?beoc Real)
              (declare-const ?beod Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?beoe Real)
              (declare-const ?beof Real)
              (declare-const ?beog Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?beoh Real)
              (declare-const ?beoi Real)
              (declare-const ?beoj Real)
              (declare-const ?beok Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (= ?beoa ?belx)
                      (and (and (= ?beoj ?beks)
                          (= ?beoi ?bekr)
                          )
                        (= ?beoh ?bekq)
                        )
                      )
                    (= ?beok ?belx)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?beol Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?beom Real)
                  (declare-const ?beon Real)
                  (declare-const ?beoo Real)
                  (assert
                    (and (and (not (= ?beoo ?beon))
                        (not (= ?beoo ?beom))
                        )
                      (not (= ?beon ?beom))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?beop Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?beoq Real)
                  (declare-const ?beor Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?beos Real)
                  (declare-const ?beot Real)
                  (declare-const ?beou Real)
                  (declare-const ?beov Real)
                  (assert
                    (and (and (not (= ?beou ?beot))
                        (not (= ?beou ?beos))
                        )
                      (not (= ?beot ?beos))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?beow Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?beox Real)
                  (declare-const ?beoy Real)
                  (declare-const ?beoz Real)
                  (declare-const ?bepa Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?beoy ?beox)
                              (= ?beoy ?awmg)
                              )
                            (= ?beox ?awmg)
                            )
                          (or (or (= ?bepa ?beoz)
                              (= ?bepa ?awmg)
                              )
                            (= ?beoz ?awmg)
                            )
                          )
                        (and (not (= ?beoy ?beox))
                          (and (and (not (= ?bepa ?beoz))
                              (not (= ?bepa ?awmg))
                              )
                            (not (= ?beoz ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bepb Real)
                  (declare-const ?bepc Real)
                  (declare-const ?bepd Real)
                  (assert
                    (and (and (not (= ?bepd ?bepc))
                        (not (= ?bepd ?bepb))
                        )
                      (not (= ?bepc ?bepb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bepe Real)
                  (declare-const ?bepf Real)
                  (declare-const ?bepg Real)
                  (declare-const ?beph Real)
                  (assert
                    (and (and (not (= ?beph ?bepg))
                        (not (= ?beph ?bepf))
                        )
                      (not (= ?bepg ?bepf))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bepi Real)
                  (declare-const ?bepj Real)
                  (declare-const ?bepk Real)
                  (declare-const ?bepl Real)
                  (declare-const ?bepm Real)
                  (declare-const ?bepn Real)
                  (assert
                    (or (and (or (or (= ?bepk ?bepj)
                            (= ?bepk ?bepi)
                            )
                          (= ?bepj ?bepi)
                          )
                        (or (or (= ?bepn ?bepm)
                            (= ?bepn ?bepl)
                            )
                          (= ?bepm ?bepl)
                          )
                        )
                      (and (and (and (not (= ?bepk ?bepj))
                            (not (= ?bepk ?bepi))
                            )
                          (not (= ?bepj ?bepi))
                          )
                        (and (and (not (= ?bepn ?bepm))
                            (not (= ?bepn ?bepl))
                            )
                          (not (= ?bepm ?bepl))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bepo Real)
                  (declare-const ?bepp Real)
                  (declare-const ?bepq Real)
                  (assert
                    (and (and (not (= ?bepq ?bepp))
                        (not (= ?bepq ?bepo))
                        )
                      (not (= ?bepp ?bepo))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bepr Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?beps Real)
                  (declare-const ?bept Real)
                  (declare-const ?bepu Real)
                  (assert
                    (and (and (not (= ?bepu ?bept))
                        (not (= ?bepu ?beps))
                        )
                      (not (= ?bept ?beps))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?bepv Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (declare-const ?bepw Real)
        (declare-const ?bepx Real)
        (declare-const ?bepy Real)
        (assert
          (and (and (not (= ?bepy ?bepx))
              (not (= ?bepy ?bepw))
              )
            (not (= ?bepx ?bepw))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bepz Real)
        (declare-const ?beqa Real)
        (declare-const ?beqb Real)
        (declare-const ?beqc Real)
        (assert
          (and (and (not (= ?beqb ?beqa))
              (not (= ?beqb ?bepz))
              )
            (not (= ?beqa ?bepz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?beqd Real)
        (declare-const ?beqe Real)
        (declare-const ?beqf Real)
        (declare-const ?beqg Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?beqe ?beqd)
                    (= ?beqe ?awmg)
                    )
                  (= ?beqd ?awmg)
                  )
                (or (or (= ?beqg ?beqf)
                    (= ?beqg ?awmg)
                    )
                  (= ?beqf ?awmg)
                  )
                )
              (and (not (= ?beqe ?beqd))
                (and (and (not (= ?beqg ?beqf))
                    (not (= ?beqg ?awmg))
                    )
                  (not (= ?beqf ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?beqh Real)
        (declare-const ?beqi Real)
        (declare-const ?beqj Real)
        (assert
          (and (and (not (= ?beqj ?beqi))
              (not (= ?beqj ?beqh))
              )
            (not (= ?beqi ?beqh))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?beqk Real)
        (declare-const ?beql Real)
        (declare-const ?beqm Real)
        (declare-const ?beqn Real)
        (assert
          (and (and (not (= ?beqn ?beqm))
              (not (= ?beqn ?beql))
              )
            (not (= ?beqm ?beql))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?beqo Real)
        (declare-const ?beqp Real)
        (declare-const ?beqq Real)
        (declare-const ?beqr Real)
        (declare-const ?beqs Real)
        (declare-const ?beqt Real)
        (assert
          (or (and (or (or (= ?beqq ?beqp)
                  (= ?beqq ?beqo)
                  )
                (= ?beqp ?beqo)
                )
              (or (or (= ?beqt ?beqs)
                  (= ?beqt ?beqr)
                  )
                (= ?beqs ?beqr)
                )
              )
            (and (and (and (not (= ?beqq ?beqp))
                  (not (= ?beqq ?beqo))
                  )
                (not (= ?beqp ?beqo))
                )
              (and (and (not (= ?beqt ?beqs))
                  (not (= ?beqt ?beqr))
                  )
                (not (= ?beqs ?beqr))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bequ Real)
        (declare-const ?beqv Real)
        (declare-const ?beqw Real)
        (assert
          (and (and (not (= ?beqw ?beqv))
              (not (= ?beqw ?bequ))
              )
            (not (= ?beqv ?bequ))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?beqx Real)
        (declare-const ?beqy Real)
        (declare-const ?beqz Real)
        (assert
          (and (and (not (= ?beqz ?beqy))
              (not (= ?beqz ?beqx))
              )
            (not (= ?beqy ?beqx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bera Real)
          (push 1)
            (declare-const ?berb Real)
            (push 1)
              (declare-const ?berc Real)
              (push 1)
                (assert
                  (and (= ?berb ?bera)
                    (= ?berc ?bera)
                    )
                  )
                (push 1)
                  (declare-const ?berd Real)
                  (declare-const ?bere Real)
                  (declare-const ?berf Real)
                  (assert
                    (and (and (not (= ?berf ?bere))
                        (not (= ?berf ?berd))
                        )
                      (not (= ?bere ?berd))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?berg Real)
                  (declare-const ?berh Real)
                  (declare-const ?beri Real)
                  (declare-const ?berj Real)
                  (assert
                    (and (and (not (= ?beri ?berh))
                        (not (= ?beri ?berg))
                        )
                      (not (= ?berh ?berg))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?berk Real)
                  (declare-const ?berl Real)
                  (declare-const ?berm Real)
                  (declare-const ?bern Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?berl ?berk)
                              (= ?berl ?awmg)
                              )
                            (= ?berk ?awmg)
                            )
                          (or (or (= ?bern ?berm)
                              (= ?bern ?awmg)
                              )
                            (= ?berm ?awmg)
                            )
                          )
                        (and (not (= ?berl ?berk))
                          (and (and (not (= ?bern ?berm))
                              (not (= ?bern ?awmg))
                              )
                            (not (= ?berm ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bero Real)
                  (declare-const ?berp Real)
                  (declare-const ?berq Real)
                  (assert
                    (and (and (not (= ?berq ?berp))
                        (not (= ?berq ?bero))
                        )
                      (not (= ?berp ?bero))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?berr Real)
                  (declare-const ?bers Real)
                  (declare-const ?bert Real)
                  (declare-const ?beru Real)
                  (assert
                    (and (and (not (= ?beru ?bert))
                        (not (= ?beru ?bers))
                        )
                      (not (= ?bert ?bers))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?berv Real)
                  (declare-const ?berw Real)
                  (declare-const ?berx Real)
                  (declare-const ?bery Real)
                  (declare-const ?berz Real)
                  (declare-const ?besa Real)
                  (assert
                    (or (and (or (or (= ?berx ?berw)
                            (= ?berx ?berv)
                            )
                          (= ?berw ?berv)
                          )
                        (or (or (= ?besa ?berz)
                            (= ?besa ?bery)
                            )
                          (= ?berz ?bery)
                          )
                        )
                      (and (and (and (not (= ?berx ?berw))
                            (not (= ?berx ?berv))
                            )
                          (not (= ?berw ?berv))
                          )
                        (and (and (not (= ?besa ?berz))
                            (not (= ?besa ?bery))
                            )
                          (not (= ?berz ?bery))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?besb Real)
                  (declare-const ?besc Real)
                  (declare-const ?besd Real)
                  (assert
                    (and (and (not (= ?besd ?besc))
                        (not (= ?besd ?besb))
                        )
                      (not (= ?besc ?besb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bese Real)
                  (declare-const ?besf Real)
                  (declare-const ?besg Real)
                  (assert
                    (and (and (not (= ?besg ?besf))
                        (not (= ?besg ?bese))
                        )
                      (not (= ?besf ?bese))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?besh Real)
      (declare-const ?besi Real)
      (declare-const ?besj Real)
      (assert
        (and (and (not (= ?besj ?besi))
            (not (= ?besj ?besh))
            )
          (not (= ?besi ?besh))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?besk Real)
      (declare-const ?besl Real)
      (declare-const ?besm Real)
      (declare-const ?besn Real)
      (assert
        (and (and (not (= ?besm ?besl))
            (not (= ?besm ?besk))
            )
          (not (= ?besl ?besk))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?beso Real)
      (declare-const ?besp Real)
      (declare-const ?besq Real)
      (declare-const ?besr Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?besp ?beso)
                  (= ?besp ?awmg)
                  )
                (= ?beso ?awmg)
                )
              (or (or (= ?besr ?besq)
                  (= ?besr ?awmg)
                  )
                (= ?besq ?awmg)
                )
              )
            (and (not (= ?besp ?beso))
              (and (and (not (= ?besr ?besq))
                  (not (= ?besr ?awmg))
                  )
                (not (= ?besq ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bess Real)
      (declare-const ?best Real)
      (declare-const ?besu Real)
      (assert
        (and (and (not (= ?besu ?best))
            (not (= ?besu ?bess))
            )
          (not (= ?best ?bess))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?besv Real)
      (declare-const ?besw Real)
      (declare-const ?besx Real)
      (declare-const ?besy Real)
      (assert
        (and (and (not (= ?besy ?besx))
            (not (= ?besy ?besw))
            )
          (not (= ?besx ?besw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?besz Real)
      (declare-const ?beta Real)
      (declare-const ?betb Real)
      (declare-const ?betc Real)
      (declare-const ?betd Real)
      (declare-const ?bete Real)
      (assert
        (or (and (or (or (= ?betb ?beta)
                (= ?betb ?besz)
                )
              (= ?beta ?besz)
              )
            (or (or (= ?bete ?betd)
                (= ?bete ?betc)
                )
              (= ?betd ?betc)
              )
            )
          (and (and (and (not (= ?betb ?beta))
                (not (= ?betb ?besz))
                )
              (not (= ?beta ?besz))
              )
            (and (and (not (= ?bete ?betd))
                (not (= ?bete ?betc))
                )
              (not (= ?betd ?betc))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?betf Real)
      (declare-const ?betg Real)
      (declare-const ?beth Real)
      (assert
        (and (and (not (= ?beth ?betg))
            (not (= ?beth ?betf))
            )
          (not (= ?betg ?betf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?beti Real)
      (declare-const ?betj Real)
      (declare-const ?betk Real)
      (assert
        (and (and (not (= ?betk ?betj))
            (not (= ?betk ?beti))
            )
          (not (= ?betj ?beti))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?betl Real)
    (declare-const ?betm Real)
    (declare-const ?betn Real)
    (assert
      (and (and (not (= ?betn ?betm))
          (not (= ?betn ?betl))
          )
        (not (= ?betm ?betl))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?beto Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?betp Real)
      (declare-const ?betq Real)
      (declare-const ?betr Real)
      (assert
        (and (and (not (= ?betr ?betq))
            (not (= ?betr ?betp))
            )
          (not (= ?betq ?betp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bets Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bett Real)
      (declare-const ?betu Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?betv Real)
      (declare-const ?betw Real)
      (declare-const ?betx Real)
      (declare-const ?bety Real)
      (assert
        (and (and (not (= ?betx ?betw))
            (not (= ?betx ?betv))
            )
          (not (= ?betw ?betv))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?betz Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?beua Real)
      (declare-const ?beub Real)
      (declare-const ?beuc Real)
      (declare-const ?beud Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?beub ?beua)
                  (= ?beub ?awmg)
                  )
                (= ?beua ?awmg)
                )
              (or (or (= ?beud ?beuc)
                  (= ?beud ?awmg)
                  )
                (= ?beuc ?awmg)
                )
              )
            (and (not (= ?beub ?beua))
              (and (and (not (= ?beud ?beuc))
                  (not (= ?beud ?awmg))
                  )
                (not (= ?beuc ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?beue Real)
      (declare-const ?beuf Real)
      (declare-const ?beug Real)
      (assert
        (and (and (not (= ?beug ?beuf))
            (not (= ?beug ?beue))
            )
          (not (= ?beuf ?beue))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?beuh Real)
      (declare-const ?beui Real)
      (declare-const ?beuj Real)
      (declare-const ?beuk Real)
      (assert
        (and (and (not (= ?beuk ?beuj))
            (not (= ?beuk ?beui))
            )
          (not (= ?beuj ?beui))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?beul Real)
      (declare-const ?beum Real)
      (declare-const ?beun Real)
      (declare-const ?beuo Real)
      (declare-const ?beup Real)
      (declare-const ?beuq Real)
      (assert
        (or (and (or (or (= ?beun ?beum)
                (= ?beun ?beul)
                )
              (= ?beum ?beul)
              )
            (or (or (= ?beuq ?beup)
                (= ?beuq ?beuo)
                )
              (= ?beup ?beuo)
              )
            )
          (and (and (and (not (= ?beun ?beum))
                (not (= ?beun ?beul))
                )
              (not (= ?beum ?beul))
              )
            (and (and (not (= ?beuq ?beup))
                (not (= ?beuq ?beuo))
                )
              (not (= ?beup ?beuo))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?beur Real)
      (declare-const ?beus Real)
      (declare-const ?beut Real)
      (assert
        (and (and (not (= ?beut ?beus))
            (not (= ?beut ?beur))
            )
          (not (= ?beus ?beur))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?beuu Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?beuv Real)
      (declare-const ?beuw Real)
      (declare-const ?beux Real)
      (assert
        (and (and (not (= ?beux ?beuw))
            (not (= ?beux ?beuv))
            )
          (not (= ?beuw ?beuv))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?beuy Real)
      (declare-const ?beuz Real)
      (declare-const ?beva Real)
      (assert
        (and (and (not (= ?beva ?beuz))
            (not (= ?beva ?beuy))
            )
          (not (= ?beuz ?beuy))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bevb Real)
      (declare-const ?bevc Real)
      (declare-const ?bevd Real)
      (declare-const ?beve Real)
      (assert
        (and (and (not (= ?bevd ?bevc))
            (not (= ?bevd ?bevb))
            )
          (not (= ?bevc ?bevb))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bevf Real)
      (declare-const ?bevg Real)
      (declare-const ?bevh Real)
      (declare-const ?bevi Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bevg ?bevf)
                  (= ?bevg ?awmg)
                  )
                (= ?bevf ?awmg)
                )
              (or (or (= ?bevi ?bevh)
                  (= ?bevi ?awmg)
                  )
                (= ?bevh ?awmg)
                )
              )
            (and (not (= ?bevg ?bevf))
              (and (and (not (= ?bevi ?bevh))
                  (not (= ?bevi ?awmg))
                  )
                (not (= ?bevh ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bevj Real)
      (declare-const ?bevk Real)
      (declare-const ?bevl Real)
      (assert
        (and (and (not (= ?bevl ?bevk))
            (not (= ?bevl ?bevj))
            )
          (not (= ?bevk ?bevj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bevm Real)
      (declare-const ?bevn Real)
      (declare-const ?bevo Real)
      (declare-const ?bevp Real)
      (assert
        (and (and (not (= ?bevp ?bevo))
            (not (= ?bevp ?bevn))
            )
          (not (= ?bevo ?bevn))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bevq Real)
      (declare-const ?bevr Real)
      (declare-const ?bevs Real)
      (declare-const ?bevt Real)
      (declare-const ?bevu Real)
      (declare-const ?bevv Real)
      (assert
        (or (and (or (or (= ?bevs ?bevr)
                (= ?bevs ?bevq)
                )
              (= ?bevr ?bevq)
              )
            (or (or (= ?bevv ?bevu)
                (= ?bevv ?bevt)
                )
              (= ?bevu ?bevt)
              )
            )
          (and (and (and (not (= ?bevs ?bevr))
                (not (= ?bevs ?bevq))
                )
              (not (= ?bevr ?bevq))
              )
            (and (and (not (= ?bevv ?bevu))
                (not (= ?bevv ?bevt))
                )
              (not (= ?bevu ?bevt))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bevw Real)
      (declare-const ?bevx Real)
      (declare-const ?bevy Real)
      (assert
        (and (and (not (= ?bevy ?bevx))
            (not (= ?bevy ?bevw))
            )
          (not (= ?bevx ?bevw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bevz Real)
      (declare-const ?bewa Real)
      (declare-const ?bewb Real)
      (assert
        (and (and (not (= ?bewb ?bewa))
            (not (= ?bewb ?bevz))
            )
          (not (= ?bewa ?bevz))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bewc Real)
    (push 1)
      (declare-const ?bewd Real)
      (declare-const ?bewe Real)
      (declare-const ?bewf Real)
      (assert
        (and (and (not (= ?bewf ?bewe))
            (not (= ?bewf ?bewd))
            )
          (not (= ?bewe ?bewd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bewg Real)
      (declare-const ?bewh Real)
      (declare-const ?bewi Real)
      (declare-const ?bewj Real)
      (assert
        (and (and (not (= ?bewi ?bewh))
            (not (= ?bewi ?bewg))
            )
          (not (= ?bewh ?bewg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bewk Real)
      (declare-const ?bewl Real)
      (declare-const ?bewm Real)
      (declare-const ?bewn Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bewl ?bewk)
                  (= ?bewl ?awmg)
                  )
                (= ?bewk ?awmg)
                )
              (or (or (= ?bewn ?bewm)
                  (= ?bewn ?awmg)
                  )
                (= ?bewm ?awmg)
                )
              )
            (and (not (= ?bewl ?bewk))
              (and (and (not (= ?bewn ?bewm))
                  (not (= ?bewn ?awmg))
                  )
                (not (= ?bewm ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bewo Real)
      (declare-const ?bewp Real)
      (declare-const ?bewq Real)
      (assert
        (and (and (not (= ?bewq ?bewp))
            (not (= ?bewq ?bewo))
            )
          (not (= ?bewp ?bewo))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bewr Real)
      (declare-const ?bews Real)
      (declare-const ?bewt Real)
      (declare-const ?bewu Real)
      (assert
        (and (and (not (= ?bewu ?bewt))
            (not (= ?bewu ?bews))
            )
          (not (= ?bewt ?bews))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bewv Real)
      (declare-const ?beww Real)
      (declare-const ?bewx Real)
      (declare-const ?bewy Real)
      (declare-const ?bewz Real)
      (declare-const ?bexa Real)
      (assert
        (or (and (or (or (= ?bewx ?beww)
                (= ?bewx ?bewv)
                )
              (= ?beww ?bewv)
              )
            (or (or (= ?bexa ?bewz)
                (= ?bexa ?bewy)
                )
              (= ?bewz ?bewy)
              )
            )
          (and (and (and (not (= ?bewx ?beww))
                (not (= ?bewx ?bewv))
                )
              (not (= ?beww ?bewv))
              )
            (and (and (not (= ?bexa ?bewz))
                (not (= ?bexa ?bewy))
                )
              (not (= ?bewz ?bewy))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bexb Real)
      (declare-const ?bexc Real)
      (declare-const ?bexd Real)
      (assert
        (and (and (not (= ?bexd ?bexc))
            (not (= ?bexd ?bexb))
            )
          (not (= ?bexc ?bexb))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bexe Real)
      (declare-const ?bexf Real)
      (declare-const ?bexg Real)
      (assert
        (and (and (not (= ?bexg ?bexf))
            (not (= ?bexg ?bexe))
            )
          (not (= ?bexf ?bexe))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bexh Real)
    (declare-const ?bexi Real)
    (declare-const ?bexj Real)
    (declare-const ?bexk Real)
    (assert
      (forall ((?awmg Real) )(or (and (or (or (= ?bexi ?bexh)
                (= ?bexi ?awmg)
                )
              (= ?bexh ?awmg)
              )
            (or (or (= ?bexk ?bexj)
                (= ?bexk ?awmg)
                )
              (= ?bexj ?awmg)
              )
            )
          (and (not (= ?bexi ?bexh))
            (and (and (not (= ?bexk ?bexj))
                (not (= ?bexk ?awmg))
                )
              (not (= ?bexj ?awmg))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bexl Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bexm Real)
      (declare-const ?bexn Real)
      (declare-const ?bexo Real)
      (assert
        (and (and (not (= ?bexo ?bexn))
            (not (= ?bexo ?bexm))
            )
          (not (= ?bexn ?bexm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bexp Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bexq Real)
      (declare-const ?bexr Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bexs Real)
      (declare-const ?bext Real)
      (declare-const ?bexu Real)
      (declare-const ?bexv Real)
      (assert
        (and (and (not (= ?bexu ?bext))
            (not (= ?bexu ?bexs))
            )
          (not (= ?bext ?bexs))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bexw Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bexx Real)
      (declare-const ?bexy Real)
      (declare-const ?bexz Real)
      (declare-const ?beya Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bexy ?bexx)
                  (= ?bexy ?awmg)
                  )
                (= ?bexx ?awmg)
                )
              (or (or (= ?beya ?bexz)
                  (= ?beya ?awmg)
                  )
                (= ?bexz ?awmg)
                )
              )
            (and (not (= ?bexy ?bexx))
              (and (and (not (= ?beya ?bexz))
                  (not (= ?beya ?awmg))
                  )
                (not (= ?bexz ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?beyb Real)
      (declare-const ?beyc Real)
      (declare-const ?beyd Real)
      (assert
        (and (and (not (= ?beyd ?beyc))
            (not (= ?beyd ?beyb))
            )
          (not (= ?beyc ?beyb))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?beye Real)
      (declare-const ?beyf Real)
      (declare-const ?beyg Real)
      (declare-const ?beyh Real)
      (assert
        (and (and (not (= ?beyh ?beyg))
            (not (= ?beyh ?beyf))
            )
          (not (= ?beyg ?beyf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?beyi Real)
      (declare-const ?beyj Real)
      (declare-const ?beyk Real)
      (declare-const ?beyl Real)
      (declare-const ?beym Real)
      (declare-const ?beyn Real)
      (assert
        (or (and (or (or (= ?beyk ?beyj)
                (= ?beyk ?beyi)
                )
              (= ?beyj ?beyi)
              )
            (or (or (= ?beyn ?beym)
                (= ?beyn ?beyl)
                )
              (= ?beym ?beyl)
              )
            )
          (and (and (and (not (= ?beyk ?beyj))
                (not (= ?beyk ?beyi))
                )
              (not (= ?beyj ?beyi))
              )
            (and (and (not (= ?beyn ?beym))
                (not (= ?beyn ?beyl))
                )
              (not (= ?beym ?beyl))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?beyo Real)
      (declare-const ?beyp Real)
      (declare-const ?beyq Real)
      (assert
        (and (and (not (= ?beyq ?beyp))
            (not (= ?beyq ?beyo))
            )
          (not (= ?beyp ?beyo))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?beyr Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?beys Real)
      (declare-const ?beyt Real)
      (declare-const ?beyu Real)
      (assert
        (and (and (not (= ?beyu ?beyt))
            (not (= ?beyu ?beys))
            )
          (not (= ?beyt ?beys))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?beyv Real)
    (declare-const ?beyw Real)
    (declare-const ?beyx Real)
    (assert
      (and (and (not (= ?beyx ?beyw))
          (not (= ?beyx ?beyv))
          )
        (not (= ?beyw ?beyv))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?beyy Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?beyz Real)
      (declare-const ?beza Real)
      (declare-const ?bezb Real)
      (assert
        (and (and (not (= ?bezb ?beza))
            (not (= ?bezb ?beyz))
            )
          (not (= ?beza ?beyz))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bezc Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bezd Real)
      (declare-const ?beze Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bezf Real)
      (declare-const ?bezg Real)
      (declare-const ?bezh Real)
      (declare-const ?bezi Real)
      (assert
        (and (and (not (= ?bezh ?bezg))
            (not (= ?bezh ?bezf))
            )
          (not (= ?bezg ?bezf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bezj Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bezk Real)
      (declare-const ?bezl Real)
      (declare-const ?bezm Real)
      (declare-const ?bezn Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bezl ?bezk)
                  (= ?bezl ?awmg)
                  )
                (= ?bezk ?awmg)
                )
              (or (or (= ?bezn ?bezm)
                  (= ?bezn ?awmg)
                  )
                (= ?bezm ?awmg)
                )
              )
            (and (not (= ?bezl ?bezk))
              (and (and (not (= ?bezn ?bezm))
                  (not (= ?bezn ?awmg))
                  )
                (not (= ?bezm ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bezo Real)
      (declare-const ?bezp Real)
      (declare-const ?bezq Real)
      (assert
        (and (and (not (= ?bezq ?bezp))
            (not (= ?bezq ?bezo))
            )
          (not (= ?bezp ?bezo))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bezr Real)
      (declare-const ?bezs Real)
      (declare-const ?bezt Real)
      (declare-const ?bezu Real)
      (assert
        (and (and (not (= ?bezu ?bezt))
            (not (= ?bezu ?bezs))
            )
          (not (= ?bezt ?bezs))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bezv Real)
      (declare-const ?bezw Real)
      (declare-const ?bezx Real)
      (declare-const ?bezy Real)
      (declare-const ?bezz Real)
      (declare-const ?bfaa Real)
      (assert
        (or (and (or (or (= ?bezx ?bezw)
                (= ?bezx ?bezv)
                )
              (= ?bezw ?bezv)
              )
            (or (or (= ?bfaa ?bezz)
                (= ?bfaa ?bezy)
                )
              (= ?bezz ?bezy)
              )
            )
          (and (and (and (not (= ?bezx ?bezw))
                (not (= ?bezx ?bezv))
                )
              (not (= ?bezw ?bezv))
              )
            (and (and (not (= ?bfaa ?bezz))
                (not (= ?bfaa ?bezy))
                )
              (not (= ?bezz ?bezy))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfab Real)
      (declare-const ?bfac Real)
      (declare-const ?bfad Real)
      (assert
        (and (and (not (= ?bfad ?bfac))
            (not (= ?bfad ?bfab))
            )
          (not (= ?bfac ?bfab))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfae Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfaf Real)
      (declare-const ?bfag Real)
      (declare-const ?bfah Real)
      (assert
        (and (and (not (= ?bfah ?bfag))
            (not (= ?bfah ?bfaf))
            )
          (not (= ?bfag ?bfaf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bfai Real)
    (declare-const ?bfaj Real)
    (declare-const ?bfak Real)
    (declare-const ?bfal Real)
    (declare-const ?bfam Real)
    (declare-const ?bfan Real)
    (assert
      (or (and (or (or (= ?bfak ?bfaj)
              (= ?bfak ?bfai)
              )
            (= ?bfaj ?bfai)
            )
          (or (or (= ?bfan ?bfam)
              (= ?bfan ?bfal)
              )
            (= ?bfam ?bfal)
            )
          )
        (and (and (and (not (= ?bfak ?bfaj))
              (not (= ?bfak ?bfai))
              )
            (not (= ?bfaj ?bfai))
            )
          (and (and (not (= ?bfan ?bfam))
              (not (= ?bfan ?bfal))
              )
            (not (= ?bfam ?bfal))
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfao Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfap Real)
      (declare-const ?bfaq Real)
      (declare-const ?bfar Real)
      (assert
        (and (and (not (= ?bfar ?bfaq))
            (not (= ?bfar ?bfap))
            )
          (not (= ?bfaq ?bfap))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfas Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfat Real)
      (declare-const ?bfau Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfav Real)
      (declare-const ?bfaw Real)
      (declare-const ?bfax Real)
      (declare-const ?bfay Real)
      (assert
        (and (and (not (= ?bfax ?bfaw))
            (not (= ?bfax ?bfav))
            )
          (not (= ?bfaw ?bfav))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfaz Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfba Real)
      (declare-const ?bfbb Real)
      (declare-const ?bfbc Real)
      (declare-const ?bfbd Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bfbb ?bfba)
                  (= ?bfbb ?awmg)
                  )
                (= ?bfba ?awmg)
                )
              (or (or (= ?bfbd ?bfbc)
                  (= ?bfbd ?awmg)
                  )
                (= ?bfbc ?awmg)
                )
              )
            (and (not (= ?bfbb ?bfba))
              (and (and (not (= ?bfbd ?bfbc))
                  (not (= ?bfbd ?awmg))
                  )
                (not (= ?bfbc ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfbe Real)
      (declare-const ?bfbf Real)
      (declare-const ?bfbg Real)
      (assert
        (and (and (not (= ?bfbg ?bfbf))
            (not (= ?bfbg ?bfbe))
            )
          (not (= ?bfbf ?bfbe))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfbh Real)
      (declare-const ?bfbi Real)
      (declare-const ?bfbj Real)
      (declare-const ?bfbk Real)
      (assert
        (and (and (not (= ?bfbk ?bfbj))
            (not (= ?bfbk ?bfbi))
            )
          (not (= ?bfbj ?bfbi))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfbl Real)
      (declare-const ?bfbm Real)
      (declare-const ?bfbn Real)
      (declare-const ?bfbo Real)
      (declare-const ?bfbp Real)
      (declare-const ?bfbq Real)
      (assert
        (or (and (or (or (= ?bfbn ?bfbm)
                (= ?bfbn ?bfbl)
                )
              (= ?bfbm ?bfbl)
              )
            (or (or (= ?bfbq ?bfbp)
                (= ?bfbq ?bfbo)
                )
              (= ?bfbp ?bfbo)
              )
            )
          (and (and (and (not (= ?bfbn ?bfbm))
                (not (= ?bfbn ?bfbl))
                )
              (not (= ?bfbm ?bfbl))
              )
            (and (and (not (= ?bfbq ?bfbp))
                (not (= ?bfbq ?bfbo))
                )
              (not (= ?bfbp ?bfbo))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfbr Real)
      (declare-const ?bfbs Real)
      (declare-const ?bfbt Real)
      (assert
        (and (and (not (= ?bfbt ?bfbs))
            (not (= ?bfbt ?bfbr))
            )
          (not (= ?bfbs ?bfbr))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfbu Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfbv Real)
      (declare-const ?bfbw Real)
      (declare-const ?bfbx Real)
      (assert
        (and (and (not (= ?bfbx ?bfbw))
            (not (= ?bfbx ?bfbv))
            )
          (not (= ?bfbw ?bfbv))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bfby Real)
    (declare-const ?bfbz Real)
    (declare-const ?bfca Real)
    (assert
      (and (and (not (= ?bfca ?bfbz))
          (not (= ?bfca ?bfby))
          )
        (not (= ?bfbz ?bfby))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfcb Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfcc Real)
      (declare-const ?bfcd Real)
      (declare-const ?bfce Real)
      (assert
        (and (and (not (= ?bfce ?bfcd))
            (not (= ?bfce ?bfcc))
            )
          (not (= ?bfcd ?bfcc))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfcf Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfcg Real)
      (declare-const ?bfch Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfci Real)
      (declare-const ?bfcj Real)
      (declare-const ?bfck Real)
      (declare-const ?bfcl Real)
      (assert
        (and (and (not (= ?bfck ?bfcj))
            (not (= ?bfck ?bfci))
            )
          (not (= ?bfcj ?bfci))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfcm Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfcn Real)
      (declare-const ?bfco Real)
      (declare-const ?bfcp Real)
      (declare-const ?bfcq Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bfco ?bfcn)
                  (= ?bfco ?awmg)
                  )
                (= ?bfcn ?awmg)
                )
              (or (or (= ?bfcq ?bfcp)
                  (= ?bfcq ?awmg)
                  )
                (= ?bfcp ?awmg)
                )
              )
            (and (not (= ?bfco ?bfcn))
              (and (and (not (= ?bfcq ?bfcp))
                  (not (= ?bfcq ?awmg))
                  )
                (not (= ?bfcp ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfcr Real)
      (declare-const ?bfcs Real)
      (declare-const ?bfct Real)
      (assert
        (and (and (not (= ?bfct ?bfcs))
            (not (= ?bfct ?bfcr))
            )
          (not (= ?bfcs ?bfcr))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfcu Real)
      (declare-const ?bfcv Real)
      (declare-const ?bfcw Real)
      (declare-const ?bfcx Real)
      (assert
        (and (and (not (= ?bfcx ?bfcw))
            (not (= ?bfcx ?bfcv))
            )
          (not (= ?bfcw ?bfcv))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfcy Real)
      (declare-const ?bfcz Real)
      (declare-const ?bfda Real)
      (declare-const ?bfdb Real)
      (declare-const ?bfdc Real)
      (declare-const ?bfdd Real)
      (assert
        (or (and (or (or (= ?bfda ?bfcz)
                (= ?bfda ?bfcy)
                )
              (= ?bfcz ?bfcy)
              )
            (or (or (= ?bfdd ?bfdc)
                (= ?bfdd ?bfdb)
                )
              (= ?bfdc ?bfdb)
              )
            )
          (and (and (and (not (= ?bfda ?bfcz))
                (not (= ?bfda ?bfcy))
                )
              (not (= ?bfcz ?bfcy))
              )
            (and (and (not (= ?bfdd ?bfdc))
                (not (= ?bfdd ?bfdb))
                )
              (not (= ?bfdc ?bfdb))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfde Real)
      (declare-const ?bfdf Real)
      (declare-const ?bfdg Real)
      (assert
        (and (and (not (= ?bfdg ?bfdf))
            (not (= ?bfdg ?bfde))
            )
          (not (= ?bfdf ?bfde))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfdh Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfdi Real)
      (declare-const ?bfdj Real)
      (declare-const ?bfdk Real)
      (assert
        (and (and (not (= ?bfdk ?bfdj))
            (not (= ?bfdk ?bfdi))
            )
          (not (= ?bfdj ?bfdi))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bfdl Real)
      (declare-const ?bfdm Real)
      (declare-const ?bfdn Real)
      (assert
        (and (and (not (= ?bfdn ?bfdm))
            (not (= ?bfdn ?bfdl))
            )
          (not (= ?bfdm ?bfdl))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfdo Real)
      (declare-const ?bfdp Real)
      (declare-const ?bfdq Real)
      (declare-const ?bfdr Real)
      (assert
        (and (and (not (= ?bfdq ?bfdp))
            (not (= ?bfdq ?bfdo))
            )
          (not (= ?bfdp ?bfdo))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfds Real)
      (declare-const ?bfdt Real)
      (declare-const ?bfdu Real)
      (declare-const ?bfdv Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bfdt ?bfds)
                  (= ?bfdt ?awmg)
                  )
                (= ?bfds ?awmg)
                )
              (or (or (= ?bfdv ?bfdu)
                  (= ?bfdv ?awmg)
                  )
                (= ?bfdu ?awmg)
                )
              )
            (and (not (= ?bfdt ?bfds))
              (and (and (not (= ?bfdv ?bfdu))
                  (not (= ?bfdv ?awmg))
                  )
                (not (= ?bfdu ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfdw Real)
      (declare-const ?bfdx Real)
      (declare-const ?bfdy Real)
      (assert
        (and (and (not (= ?bfdy ?bfdx))
            (not (= ?bfdy ?bfdw))
            )
          (not (= ?bfdx ?bfdw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfdz Real)
      (declare-const ?bfea Real)
      (declare-const ?bfeb Real)
      (declare-const ?bfec Real)
      (assert
        (and (and (not (= ?bfec ?bfeb))
            (not (= ?bfec ?bfea))
            )
          (not (= ?bfeb ?bfea))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfed Real)
      (declare-const ?bfee Real)
      (declare-const ?bfef Real)
      (declare-const ?bfeg Real)
      (declare-const ?bfeh Real)
      (declare-const ?bfei Real)
      (assert
        (or (and (or (or (= ?bfef ?bfee)
                (= ?bfef ?bfed)
                )
              (= ?bfee ?bfed)
              )
            (or (or (= ?bfei ?bfeh)
                (= ?bfei ?bfeg)
                )
              (= ?bfeh ?bfeg)
              )
            )
          (and (and (and (not (= ?bfef ?bfee))
                (not (= ?bfef ?bfed))
                )
              (not (= ?bfee ?bfed))
              )
            (and (and (not (= ?bfei ?bfeh))
                (not (= ?bfei ?bfeg))
                )
              (not (= ?bfeh ?bfeg))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfej Real)
      (declare-const ?bfek Real)
      (declare-const ?bfel Real)
      (assert
        (and (and (not (= ?bfel ?bfek))
            (not (= ?bfel ?bfej))
            )
          (not (= ?bfek ?bfej))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfem Real)
      (declare-const ?bfen Real)
      (declare-const ?bfeo Real)
      (assert
        (and (and (not (= ?bfeo ?bfen))
            (not (= ?bfeo ?bfem))
            )
          (not (= ?bfen ?bfem))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bfep Real)
    (declare-const ?bfeq Real)
    (declare-const ?bfer Real)
    (assert
      (and (and (not (= ?bfer ?bfeq))
          (not (= ?bfer ?bfep))
          )
        (not (= ?bfeq ?bfep))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfes Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfet Real)
      (declare-const ?bfeu Real)
      (declare-const ?bfev Real)
      (assert
        (and (and (not (= ?bfev ?bfeu))
            (not (= ?bfev ?bfet))
            )
          (not (= ?bfeu ?bfet))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfew Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfex Real)
      (declare-const ?bfey Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfez Real)
      (declare-const ?bffa Real)
      (declare-const ?bffb Real)
      (declare-const ?bffc Real)
      (assert
        (and (and (not (= ?bffb ?bffa))
            (not (= ?bffb ?bfez))
            )
          (not (= ?bffa ?bfez))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bffd Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bffe Real)
      (declare-const ?bfff Real)
      (declare-const ?bffg Real)
      (declare-const ?bffh Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bfff ?bffe)
                  (= ?bfff ?awmg)
                  )
                (= ?bffe ?awmg)
                )
              (or (or (= ?bffh ?bffg)
                  (= ?bffh ?awmg)
                  )
                (= ?bffg ?awmg)
                )
              )
            (and (not (= ?bfff ?bffe))
              (and (and (not (= ?bffh ?bffg))
                  (not (= ?bffh ?awmg))
                  )
                (not (= ?bffg ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bffi Real)
      (declare-const ?bffj Real)
      (declare-const ?bffk Real)
      (assert
        (and (and (not (= ?bffk ?bffj))
            (not (= ?bffk ?bffi))
            )
          (not (= ?bffj ?bffi))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bffl Real)
      (declare-const ?bffm Real)
      (declare-const ?bffn Real)
      (declare-const ?bffo Real)
      (assert
        (and (and (not (= ?bffo ?bffn))
            (not (= ?bffo ?bffm))
            )
          (not (= ?bffn ?bffm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bffp Real)
      (declare-const ?bffq Real)
      (declare-const ?bffr Real)
      (declare-const ?bffs Real)
      (declare-const ?bfft Real)
      (declare-const ?bffu Real)
      (assert
        (or (and (or (or (= ?bffr ?bffq)
                (= ?bffr ?bffp)
                )
              (= ?bffq ?bffp)
              )
            (or (or (= ?bffu ?bfft)
                (= ?bffu ?bffs)
                )
              (= ?bfft ?bffs)
              )
            )
          (and (and (and (not (= ?bffr ?bffq))
                (not (= ?bffr ?bffp))
                )
              (not (= ?bffq ?bffp))
              )
            (and (and (not (= ?bffu ?bfft))
                (not (= ?bffu ?bffs))
                )
              (not (= ?bfft ?bffs))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bffv Real)
      (declare-const ?bffw Real)
      (declare-const ?bffx Real)
      (assert
        (and (and (not (= ?bffx ?bffw))
            (not (= ?bffx ?bffv))
            )
          (not (= ?bffw ?bffv))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bffy Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bffz Real)
      (declare-const ?bfga Real)
      (declare-const ?bfgb Real)
      (assert
        (and (and (not (= ?bfgb ?bfga))
            (not (= ?bfgb ?bffz))
            )
          (not (= ?bfga ?bffz))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bfgc Real)
      (declare-const ?bfgd Real)
      (declare-const ?bfge Real)
      (assert
        (and (and (not (= ?bfge ?bfgd))
            (not (= ?bfge ?bfgc))
            )
          (not (= ?bfgd ?bfgc))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfgf Real)
      (declare-const ?bfgg Real)
      (declare-const ?bfgh Real)
      (declare-const ?bfgi Real)
      (assert
        (and (and (not (= ?bfgh ?bfgg))
            (not (= ?bfgh ?bfgf))
            )
          (not (= ?bfgg ?bfgf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfgj Real)
      (declare-const ?bfgk Real)
      (declare-const ?bfgl Real)
      (declare-const ?bfgm Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bfgk ?bfgj)
                  (= ?bfgk ?awmg)
                  )
                (= ?bfgj ?awmg)
                )
              (or (or (= ?bfgm ?bfgl)
                  (= ?bfgm ?awmg)
                  )
                (= ?bfgl ?awmg)
                )
              )
            (and (not (= ?bfgk ?bfgj))
              (and (and (not (= ?bfgm ?bfgl))
                  (not (= ?bfgm ?awmg))
                  )
                (not (= ?bfgl ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfgn Real)
      (declare-const ?bfgo Real)
      (declare-const ?bfgp Real)
      (assert
        (and (and (not (= ?bfgp ?bfgo))
            (not (= ?bfgp ?bfgn))
            )
          (not (= ?bfgo ?bfgn))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfgq Real)
      (declare-const ?bfgr Real)
      (declare-const ?bfgs Real)
      (declare-const ?bfgt Real)
      (assert
        (and (and (not (= ?bfgt ?bfgs))
            (not (= ?bfgt ?bfgr))
            )
          (not (= ?bfgs ?bfgr))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfgu Real)
      (declare-const ?bfgv Real)
      (declare-const ?bfgw Real)
      (declare-const ?bfgx Real)
      (declare-const ?bfgy Real)
      (declare-const ?bfgz Real)
      (assert
        (or (and (or (or (= ?bfgw ?bfgv)
                (= ?bfgw ?bfgu)
                )
              (= ?bfgv ?bfgu)
              )
            (or (or (= ?bfgz ?bfgy)
                (= ?bfgz ?bfgx)
                )
              (= ?bfgy ?bfgx)
              )
            )
          (and (and (and (not (= ?bfgw ?bfgv))
                (not (= ?bfgw ?bfgu))
                )
              (not (= ?bfgv ?bfgu))
              )
            (and (and (not (= ?bfgz ?bfgy))
                (not (= ?bfgz ?bfgx))
                )
              (not (= ?bfgy ?bfgx))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfha Real)
      (declare-const ?bfhb Real)
      (declare-const ?bfhc Real)
      (assert
        (and (and (not (= ?bfhc ?bfhb))
            (not (= ?bfhc ?bfha))
            )
          (not (= ?bfhb ?bfha))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfhd Real)
      (declare-const ?bfhe Real)
      (declare-const ?bfhf Real)
      (assert
        (and (and (not (= ?bfhf ?bfhe))
            (not (= ?bfhf ?bfhd))
            )
          (not (= ?bfhe ?bfhd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bfhg Real)
      (declare-const ?bfhh Real)
      (declare-const ?bfhi Real)
      (assert
        (and (and (not (= ?bfhi ?bfhh))
            (not (= ?bfhi ?bfhg))
            )
          (not (= ?bfhh ?bfhg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfhj Real)
      (declare-const ?bfhk Real)
      (declare-const ?bfhl Real)
      (declare-const ?bfhm Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bfhk ?bfhj)
                  (= ?bfhk ?awmg)
                  )
                (= ?bfhj ?awmg)
                )
              (or (or (= ?bfhm ?bfhl)
                  (= ?bfhm ?awmg)
                  )
                (= ?bfhl ?awmg)
                )
              )
            (and (not (= ?bfhk ?bfhj))
              (and (and (not (= ?bfhm ?bfhl))
                  (not (= ?bfhm ?awmg))
                  )
                (not (= ?bfhl ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfhn Real)
      (declare-const ?bfho Real)
      (declare-const ?bfhp Real)
      (assert
        (and (and (not (= ?bfhp ?bfho))
            (not (= ?bfhp ?bfhn))
            )
          (not (= ?bfho ?bfhn))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfhq Real)
      (declare-const ?bfhr Real)
      (declare-const ?bfhs Real)
      (declare-const ?bfht Real)
      (declare-const ?bfhu Real)
      (declare-const ?bfhv Real)
      (assert
        (or (and (or (or (= ?bfhs ?bfhr)
                (= ?bfhs ?bfhq)
                )
              (= ?bfhr ?bfhq)
              )
            (or (or (= ?bfhv ?bfhu)
                (= ?bfhv ?bfht)
                )
              (= ?bfhu ?bfht)
              )
            )
          (and (and (and (not (= ?bfhs ?bfhr))
                (not (= ?bfhs ?bfhq))
                )
              (not (= ?bfhr ?bfhq))
              )
            (and (and (not (= ?bfhv ?bfhu))
                (not (= ?bfhv ?bfht))
                )
              (not (= ?bfhu ?bfht))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfhw Real)
      (declare-const ?bfhx Real)
      (declare-const ?bfhy Real)
      (assert
        (and (and (not (= ?bfhy ?bfhx))
            (not (= ?bfhy ?bfhw))
            )
          (not (= ?bfhx ?bfhw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfhz Real)
      (declare-const ?bfia Real)
      (declare-const ?bfib Real)
      (assert
        (and (and (not (= ?bfib ?bfia))
            (not (= ?bfib ?bfhz))
            )
          (not (= ?bfia ?bfhz))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bfic Real)
    (push 1)
      (declare-const ?bfid Real)
      (declare-const ?bfie Real)
      (declare-const ?bfif Real)
      (assert
        (and (and (not (= ?bfif ?bfie))
            (not (= ?bfif ?bfid))
            )
          (not (= ?bfie ?bfid))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfig Real)
      (declare-const ?bfih Real)
      (declare-const ?bfii Real)
      (declare-const ?bfij Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bfih ?bfig)
                  (= ?bfih ?awmg)
                  )
                (= ?bfig ?awmg)
                )
              (or (or (= ?bfij ?bfii)
                  (= ?bfij ?awmg)
                  )
                (= ?bfii ?awmg)
                )
              )
            (and (not (= ?bfih ?bfig))
              (and (and (not (= ?bfij ?bfii))
                  (not (= ?bfij ?awmg))
                  )
                (not (= ?bfii ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfik Real)
      (declare-const ?bfil Real)
      (declare-const ?bfim Real)
      (assert
        (and (and (not (= ?bfim ?bfil))
            (not (= ?bfim ?bfik))
            )
          (not (= ?bfil ?bfik))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfin Real)
      (declare-const ?bfio Real)
      (declare-const ?bfip Real)
      (declare-const ?bfiq Real)
      (declare-const ?bfir Real)
      (declare-const ?bfis Real)
      (assert
        (or (and (or (or (= ?bfip ?bfio)
                (= ?bfip ?bfin)
                )
              (= ?bfio ?bfin)
              )
            (or (or (= ?bfis ?bfir)
                (= ?bfis ?bfiq)
                )
              (= ?bfir ?bfiq)
              )
            )
          (and (and (and (not (= ?bfip ?bfio))
                (not (= ?bfip ?bfin))
                )
              (not (= ?bfio ?bfin))
              )
            (and (and (not (= ?bfis ?bfir))
                (not (= ?bfis ?bfiq))
                )
              (not (= ?bfir ?bfiq))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfit Real)
      (declare-const ?bfiu Real)
      (declare-const ?bfiv Real)
      (assert
        (and (and (not (= ?bfiv ?bfiu))
            (not (= ?bfiv ?bfit))
            )
          (not (= ?bfiu ?bfit))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfiw Real)
      (declare-const ?bfix Real)
      (declare-const ?bfiy Real)
      (assert
        (and (and (not (= ?bfiy ?bfix))
            (not (= ?bfiy ?bfiw))
            )
          (not (= ?bfix ?bfiw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bfiz Real)
    (declare-const ?bfja Real)
    (declare-const ?bfjb Real)
    (assert
      (and (and (not (= ?bfjb ?bfja))
          (not (= ?bfjb ?bfiz))
          )
        (not (= ?bfja ?bfiz))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfjc Real)
      (declare-const ?bfjd Real)
      (declare-const ?bfje Real)
      (assert
        (and (and (not (= ?bfje ?bfjd))
            (not (= ?bfje ?bfjc))
            )
          (not (= ?bfjd ?bfjc))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfjf Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfjg Real)
      (declare-const ?bfjh Real)
      (declare-const ?bfji Real)
      (declare-const ?bfjj Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bfjh ?bfjg)
                  (= ?bfjh ?awmg)
                  )
                (= ?bfjg ?awmg)
                )
              (or (or (= ?bfjj ?bfji)
                  (= ?bfjj ?awmg)
                  )
                (= ?bfji ?awmg)
                )
              )
            (and (not (= ?bfjh ?bfjg))
              (and (and (not (= ?bfjj ?bfji))
                  (not (= ?bfjj ?awmg))
                  )
                (not (= ?bfji ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfjk Real)
      (declare-const ?bfjl Real)
      (declare-const ?bfjm Real)
      (assert
        (and (and (not (= ?bfjm ?bfjl))
            (not (= ?bfjm ?bfjk))
            )
          (not (= ?bfjl ?bfjk))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfjn Real)
      (declare-const ?bfjo Real)
      (declare-const ?bfjp Real)
      (declare-const ?bfjq Real)
      (declare-const ?bfjr Real)
      (declare-const ?bfjs Real)
      (assert
        (or (and (or (or (= ?bfjp ?bfjo)
                (= ?bfjp ?bfjn)
                )
              (= ?bfjo ?bfjn)
              )
            (or (or (= ?bfjs ?bfjr)
                (= ?bfjs ?bfjq)
                )
              (= ?bfjr ?bfjq)
              )
            )
          (and (and (and (not (= ?bfjp ?bfjo))
                (not (= ?bfjp ?bfjn))
                )
              (not (= ?bfjo ?bfjn))
              )
            (and (and (not (= ?bfjs ?bfjr))
                (not (= ?bfjs ?bfjq))
                )
              (not (= ?bfjr ?bfjq))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfjt Real)
      (declare-const ?bfju Real)
      (declare-const ?bfjv Real)
      (assert
        (and (and (not (= ?bfjv ?bfju))
            (not (= ?bfjv ?bfjt))
            )
          (not (= ?bfju ?bfjt))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfjw Real)
      (declare-const ?bfjx Real)
      (declare-const ?bfjy Real)
      (assert
        (and (and (not (= ?bfjy ?bfjx))
            (not (= ?bfjy ?bfjw))
            )
          (not (= ?bfjx ?bfjw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bfjz Real)
      (declare-const ?bfka Real)
      (declare-const ?bfkb Real)
      (assert
        (and (and (not (= ?bfkb ?bfka))
            (not (= ?bfkb ?bfjz))
            )
          (not (= ?bfka ?bfjz))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfkc Real)
      (declare-const ?bfkd Real)
      (declare-const ?bfke Real)
      (declare-const ?bfkf Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bfkd ?bfkc)
                  (= ?bfkd ?awmg)
                  )
                (= ?bfkc ?awmg)
                )
              (or (or (= ?bfkf ?bfke)
                  (= ?bfkf ?awmg)
                  )
                (= ?bfke ?awmg)
                )
              )
            (and (not (= ?bfkd ?bfkc))
              (and (and (not (= ?bfkf ?bfke))
                  (not (= ?bfkf ?awmg))
                  )
                (not (= ?bfke ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfkg Real)
      (declare-const ?bfkh Real)
      (declare-const ?bfki Real)
      (assert
        (and (and (not (= ?bfki ?bfkh))
            (not (= ?bfki ?bfkg))
            )
          (not (= ?bfkh ?bfkg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfkj Real)
      (declare-const ?bfkk Real)
      (declare-const ?bfkl Real)
      (declare-const ?bfkm Real)
      (declare-const ?bfkn Real)
      (declare-const ?bfko Real)
      (assert
        (or (and (or (or (= ?bfkl ?bfkk)
                (= ?bfkl ?bfkj)
                )
              (= ?bfkk ?bfkj)
              )
            (or (or (= ?bfko ?bfkn)
                (= ?bfko ?bfkm)
                )
              (= ?bfkn ?bfkm)
              )
            )
          (and (and (and (not (= ?bfkl ?bfkk))
                (not (= ?bfkl ?bfkj))
                )
              (not (= ?bfkk ?bfkj))
              )
            (and (and (not (= ?bfko ?bfkn))
                (not (= ?bfko ?bfkm))
                )
              (not (= ?bfkn ?bfkm))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfkp Real)
      (declare-const ?bfkq Real)
      (declare-const ?bfkr Real)
      (assert
        (and (and (not (= ?bfkr ?bfkq))
            (not (= ?bfkr ?bfkp))
            )
          (not (= ?bfkq ?bfkp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfks Real)
      (declare-const ?bfkt Real)
      (declare-const ?bfku Real)
      (assert
        (and (and (not (= ?bfku ?bfkt))
            (not (= ?bfku ?bfks))
            )
          (not (= ?bfkt ?bfks))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bfkv Real)
    (push 1)
      (declare-const ?bfkw Real)
      (declare-const ?bfkx Real)
      (declare-const ?bfky Real)
      (assert
        (and (and (not (= ?bfky ?bfkx))
            (not (= ?bfky ?bfkw))
            )
          (not (= ?bfkx ?bfkw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfkz Real)
      (declare-const ?bfla Real)
      (declare-const ?bflb Real)
      (declare-const ?bflc Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bfla ?bfkz)
                  (= ?bfla ?awmg)
                  )
                (= ?bfkz ?awmg)
                )
              (or (or (= ?bflc ?bflb)
                  (= ?bflc ?awmg)
                  )
                (= ?bflb ?awmg)
                )
              )
            (and (not (= ?bfla ?bfkz))
              (and (and (not (= ?bflc ?bflb))
                  (not (= ?bflc ?awmg))
                  )
                (not (= ?bflb ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfld Real)
      (declare-const ?bfle Real)
      (declare-const ?bflf Real)
      (assert
        (and (and (not (= ?bflf ?bfle))
            (not (= ?bflf ?bfld))
            )
          (not (= ?bfle ?bfld))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bflg Real)
      (declare-const ?bflh Real)
      (declare-const ?bfli Real)
      (declare-const ?bflj Real)
      (declare-const ?bflk Real)
      (declare-const ?bfll Real)
      (assert
        (or (and (or (or (= ?bfli ?bflh)
                (= ?bfli ?bflg)
                )
              (= ?bflh ?bflg)
              )
            (or (or (= ?bfll ?bflk)
                (= ?bfll ?bflj)
                )
              (= ?bflk ?bflj)
              )
            )
          (and (and (and (not (= ?bfli ?bflh))
                (not (= ?bfli ?bflg))
                )
              (not (= ?bflh ?bflg))
              )
            (and (and (not (= ?bfll ?bflk))
                (not (= ?bfll ?bflj))
                )
              (not (= ?bflk ?bflj))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bflm Real)
      (declare-const ?bfln Real)
      (declare-const ?bflo Real)
      (assert
        (and (and (not (= ?bflo ?bfln))
            (not (= ?bflo ?bflm))
            )
          (not (= ?bfln ?bflm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bflp Real)
      (declare-const ?bflq Real)
      (declare-const ?bflr Real)
      (assert
        (and (and (not (= ?bflr ?bflq))
            (not (= ?bflr ?bflp))
            )
          (not (= ?bflq ?bflp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bfls Real)
    (declare-const ?bflt Real)
    (push 1)
      (declare-const ?bflu Real)
      (declare-const ?bflv Real)
      (declare-const ?bflw Real)
      (assert
        (and (and (not (= ?bflw ?bflv))
            (not (= ?bflw ?bflu))
            )
          (not (= ?bflv ?bflu))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bflx Real)
      (declare-const ?bfly Real)
      (declare-const ?bflz Real)
      (declare-const ?bfma Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bfly ?bflx)
                  (= ?bfly ?awmg)
                  )
                (= ?bflx ?awmg)
                )
              (or (or (= ?bfma ?bflz)
                  (= ?bfma ?awmg)
                  )
                (= ?bflz ?awmg)
                )
              )
            (and (not (= ?bfly ?bflx))
              (and (and (not (= ?bfma ?bflz))
                  (not (= ?bfma ?awmg))
                  )
                (not (= ?bflz ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfmb Real)
      (declare-const ?bfmc Real)
      (declare-const ?bfmd Real)
      (assert
        (and (and (not (= ?bfmd ?bfmc))
            (not (= ?bfmd ?bfmb))
            )
          (not (= ?bfmc ?bfmb))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfme Real)
      (declare-const ?bfmf Real)
      (declare-const ?bfmg Real)
      (declare-const ?bfmh Real)
      (declare-const ?bfmi Real)
      (declare-const ?bfmj Real)
      (assert
        (or (and (or (or (= ?bfmg ?bfmf)
                (= ?bfmg ?bfme)
                )
              (= ?bfmf ?bfme)
              )
            (or (or (= ?bfmj ?bfmi)
                (= ?bfmj ?bfmh)
                )
              (= ?bfmi ?bfmh)
              )
            )
          (and (and (and (not (= ?bfmg ?bfmf))
                (not (= ?bfmg ?bfme))
                )
              (not (= ?bfmf ?bfme))
              )
            (and (and (not (= ?bfmj ?bfmi))
                (not (= ?bfmj ?bfmh))
                )
              (not (= ?bfmi ?bfmh))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfmk Real)
      (declare-const ?bfml Real)
      (declare-const ?bfmm Real)
      (assert
        (and (and (not (= ?bfmm ?bfml))
            (not (= ?bfmm ?bfmk))
            )
          (not (= ?bfml ?bfmk))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfmn Real)
      (declare-const ?bfmo Real)
      (declare-const ?bfmp Real)
      (assert
        (and (and (not (= ?bfmp ?bfmo))
            (not (= ?bfmp ?bfmn))
            )
          (not (= ?bfmo ?bfmn))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bfmq Real)
    (declare-const ?bfmr Real)
    (declare-const ?bfms Real)
    (declare-const ?bfmt Real)
    (assert
      (and (and (not (= ?bfms ?bfmr))
          (not (= ?bfms ?bfmq))
          )
        (not (= ?bfmr ?bfmq))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfmu Real)
      (declare-const ?bfmv Real)
      (declare-const ?bfmw Real)
      (assert
        (and (and (not (= ?bfmw ?bfmv))
            (not (= ?bfmw ?bfmu))
            )
          (not (= ?bfmv ?bfmu))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfmx Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfmy Real)
      (declare-const ?bfmz Real)
      (declare-const ?bfna Real)
      (declare-const ?bfnb Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bfmz ?bfmy)
                  (= ?bfmz ?awmg)
                  )
                (= ?bfmy ?awmg)
                )
              (or (or (= ?bfnb ?bfna)
                  (= ?bfnb ?awmg)
                  )
                (= ?bfna ?awmg)
                )
              )
            (and (not (= ?bfmz ?bfmy))
              (and (and (not (= ?bfnb ?bfna))
                  (not (= ?bfnb ?awmg))
                  )
                (not (= ?bfna ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfnc Real)
      (declare-const ?bfnd Real)
      (declare-const ?bfne Real)
      (assert
        (and (and (not (= ?bfne ?bfnd))
            (not (= ?bfne ?bfnc))
            )
          (not (= ?bfnd ?bfnc))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfnf Real)
      (declare-const ?bfng Real)
      (declare-const ?bfnh Real)
      (declare-const ?bfni Real)
      (declare-const ?bfnj Real)
      (declare-const ?bfnk Real)
      (assert
        (or (and (or (or (= ?bfnh ?bfng)
                (= ?bfnh ?bfnf)
                )
              (= ?bfng ?bfnf)
              )
            (or (or (= ?bfnk ?bfnj)
                (= ?bfnk ?bfni)
                )
              (= ?bfnj ?bfni)
              )
            )
          (and (and (and (not (= ?bfnh ?bfng))
                (not (= ?bfnh ?bfnf))
                )
              (not (= ?bfng ?bfnf))
              )
            (and (and (not (= ?bfnk ?bfnj))
                (not (= ?bfnk ?bfni))
                )
              (not (= ?bfnj ?bfni))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfnl Real)
      (declare-const ?bfnm Real)
      (declare-const ?bfnn Real)
      (assert
        (and (and (not (= ?bfnn ?bfnm))
            (not (= ?bfnn ?bfnl))
            )
          (not (= ?bfnm ?bfnl))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfno Real)
      (declare-const ?bfnp Real)
      (declare-const ?bfnq Real)
      (assert
        (and (and (not (= ?bfnq ?bfnp))
            (not (= ?bfnq ?bfno))
            )
          (not (= ?bfnp ?bfno))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bfnr Real)
    (push 1)
      (declare-const ?bfns Real)
      (declare-const ?bfnt Real)
      (declare-const ?bfnu Real)
      (assert
        (and (and (not (= ?bfnu ?bfnt))
            (not (= ?bfnu ?bfns))
            )
          (not (= ?bfnt ?bfns))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfnv Real)
      (declare-const ?bfnw Real)
      (declare-const ?bfnx Real)
      (declare-const ?bfny Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bfnw ?bfnv)
                  (= ?bfnw ?awmg)
                  )
                (= ?bfnv ?awmg)
                )
              (or (or (= ?bfny ?bfnx)
                  (= ?bfny ?awmg)
                  )
                (= ?bfnx ?awmg)
                )
              )
            (and (not (= ?bfnw ?bfnv))
              (and (and (not (= ?bfny ?bfnx))
                  (not (= ?bfny ?awmg))
                  )
                (not (= ?bfnx ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfnz Real)
      (declare-const ?bfoa Real)
      (declare-const ?bfob Real)
      (assert
        (and (and (not (= ?bfob ?bfoa))
            (not (= ?bfob ?bfnz))
            )
          (not (= ?bfoa ?bfnz))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfoc Real)
      (declare-const ?bfod Real)
      (declare-const ?bfoe Real)
      (declare-const ?bfof Real)
      (declare-const ?bfog Real)
      (declare-const ?bfoh Real)
      (assert
        (or (and (or (or (= ?bfoe ?bfod)
                (= ?bfoe ?bfoc)
                )
              (= ?bfod ?bfoc)
              )
            (or (or (= ?bfoh ?bfog)
                (= ?bfoh ?bfof)
                )
              (= ?bfog ?bfof)
              )
            )
          (and (and (and (not (= ?bfoe ?bfod))
                (not (= ?bfoe ?bfoc))
                )
              (not (= ?bfod ?bfoc))
              )
            (and (and (not (= ?bfoh ?bfog))
                (not (= ?bfoh ?bfof))
                )
              (not (= ?bfog ?bfof))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfoi Real)
      (declare-const ?bfoj Real)
      (declare-const ?bfok Real)
      (assert
        (and (and (not (= ?bfok ?bfoj))
            (not (= ?bfok ?bfoi))
            )
          (not (= ?bfoj ?bfoi))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfol Real)
      (declare-const ?bfom Real)
      (declare-const ?bfon Real)
      (assert
        (and (and (not (= ?bfon ?bfom))
            (not (= ?bfon ?bfol))
            )
          (not (= ?bfom ?bfol))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bfoo Real)
    (declare-const ?bfop Real)
    (declare-const ?bfoq Real)
    (declare-const ?bfor Real)
    (assert
      (forall ((?awmg Real) )(or (and (or (or (= ?bfop ?bfoo)
                (= ?bfop ?awmg)
                )
              (= ?bfoo ?awmg)
              )
            (or (or (= ?bfor ?bfoq)
                (= ?bfor ?awmg)
                )
              (= ?bfoq ?awmg)
              )
            )
          (and (not (= ?bfop ?bfoo))
            (and (and (not (= ?bfor ?bfoq))
                (not (= ?bfor ?awmg))
                )
              (not (= ?bfoq ?awmg))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfos Real)
      (declare-const ?bfot Real)
      (declare-const ?bfou Real)
      (assert
        (and (and (not (= ?bfou ?bfot))
            (not (= ?bfou ?bfos))
            )
          (not (= ?bfot ?bfos))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfov Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfow Real)
      (declare-const ?bfox Real)
      (declare-const ?bfoy Real)
      (declare-const ?bfoz Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bfox ?bfow)
                  (= ?bfox ?awmg)
                  )
                (= ?bfow ?awmg)
                )
              (or (or (= ?bfoz ?bfoy)
                  (= ?bfoz ?awmg)
                  )
                (= ?bfoy ?awmg)
                )
              )
            (and (not (= ?bfox ?bfow))
              (and (and (not (= ?bfoz ?bfoy))
                  (not (= ?bfoz ?awmg))
                  )
                (not (= ?bfoy ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfpa Real)
      (declare-const ?bfpb Real)
      (declare-const ?bfpc Real)
      (assert
        (and (and (not (= ?bfpc ?bfpb))
            (not (= ?bfpc ?bfpa))
            )
          (not (= ?bfpb ?bfpa))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfpd Real)
      (declare-const ?bfpe Real)
      (declare-const ?bfpf Real)
      (declare-const ?bfpg Real)
      (declare-const ?bfph Real)
      (declare-const ?bfpi Real)
      (assert
        (or (and (or (or (= ?bfpf ?bfpe)
                (= ?bfpf ?bfpd)
                )
              (= ?bfpe ?bfpd)
              )
            (or (or (= ?bfpi ?bfph)
                (= ?bfpi ?bfpg)
                )
              (= ?bfph ?bfpg)
              )
            )
          (and (and (and (not (= ?bfpf ?bfpe))
                (not (= ?bfpf ?bfpd))
                )
              (not (= ?bfpe ?bfpd))
              )
            (and (and (not (= ?bfpi ?bfph))
                (not (= ?bfpi ?bfpg))
                )
              (not (= ?bfph ?bfpg))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfpj Real)
      (declare-const ?bfpk Real)
      (declare-const ?bfpl Real)
      (assert
        (and (and (not (= ?bfpl ?bfpk))
            (not (= ?bfpl ?bfpj))
            )
          (not (= ?bfpk ?bfpj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfpm Real)
      (declare-const ?bfpn Real)
      (declare-const ?bfpo Real)
      (assert
        (and (and (not (= ?bfpo ?bfpn))
            (not (= ?bfpo ?bfpm))
            )
          (not (= ?bfpn ?bfpm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bfpp Real)
    (declare-const ?bfpq Real)
    (declare-const ?bfpr Real)
    (assert
      (and (and (not (= ?bfpr ?bfpq))
          (not (= ?bfpr ?bfpp))
          )
        (not (= ?bfpq ?bfpp))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfps Real)
      (declare-const ?bfpt Real)
      (declare-const ?bfpu Real)
      (assert
        (and (and (not (= ?bfpu ?bfpt))
            (not (= ?bfpu ?bfps))
            )
          (not (= ?bfpt ?bfps))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfpv Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfpw Real)
      (declare-const ?bfpx Real)
      (declare-const ?bfpy Real)
      (declare-const ?bfpz Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bfpx ?bfpw)
                  (= ?bfpx ?awmg)
                  )
                (= ?bfpw ?awmg)
                )
              (or (or (= ?bfpz ?bfpy)
                  (= ?bfpz ?awmg)
                  )
                (= ?bfpy ?awmg)
                )
              )
            (and (not (= ?bfpx ?bfpw))
              (and (and (not (= ?bfpz ?bfpy))
                  (not (= ?bfpz ?awmg))
                  )
                (not (= ?bfpy ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfqa Real)
      (declare-const ?bfqb Real)
      (declare-const ?bfqc Real)
      (assert
        (and (and (not (= ?bfqc ?bfqb))
            (not (= ?bfqc ?bfqa))
            )
          (not (= ?bfqb ?bfqa))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfqd Real)
      (declare-const ?bfqe Real)
      (declare-const ?bfqf Real)
      (declare-const ?bfqg Real)
      (declare-const ?bfqh Real)
      (declare-const ?bfqi Real)
      (assert
        (or (and (or (or (= ?bfqf ?bfqe)
                (= ?bfqf ?bfqd)
                )
              (= ?bfqe ?bfqd)
              )
            (or (or (= ?bfqi ?bfqh)
                (= ?bfqi ?bfqg)
                )
              (= ?bfqh ?bfqg)
              )
            )
          (and (and (and (not (= ?bfqf ?bfqe))
                (not (= ?bfqf ?bfqd))
                )
              (not (= ?bfqe ?bfqd))
              )
            (and (and (not (= ?bfqi ?bfqh))
                (not (= ?bfqi ?bfqg))
                )
              (not (= ?bfqh ?bfqg))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfqj Real)
      (declare-const ?bfqk Real)
      (declare-const ?bfql Real)
      (assert
        (and (and (not (= ?bfql ?bfqk))
            (not (= ?bfql ?bfqj))
            )
          (not (= ?bfqk ?bfqj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfqm Real)
      (declare-const ?bfqn Real)
      (declare-const ?bfqo Real)
      (assert
        (and (and (not (= ?bfqo ?bfqn))
            (not (= ?bfqo ?bfqm))
            )
          (not (= ?bfqn ?bfqm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bfqp Real)
    (declare-const ?bfqq Real)
    (declare-const ?bfqr Real)
    (declare-const ?bfqs Real)
    (assert
      (and (and (not (= ?bfqs ?bfqr))
          (not (= ?bfqs ?bfqq))
          )
        (not (= ?bfqr ?bfqq))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfqt Real)
      (declare-const ?bfqu Real)
      (declare-const ?bfqv Real)
      (assert
        (and (and (not (= ?bfqv ?bfqu))
            (not (= ?bfqv ?bfqt))
            )
          (not (= ?bfqu ?bfqt))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfqw Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfqx Real)
      (declare-const ?bfqy Real)
      (declare-const ?bfqz Real)
      (declare-const ?bfra Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bfqy ?bfqx)
                  (= ?bfqy ?awmg)
                  )
                (= ?bfqx ?awmg)
                )
              (or (or (= ?bfra ?bfqz)
                  (= ?bfra ?awmg)
                  )
                (= ?bfqz ?awmg)
                )
              )
            (and (not (= ?bfqy ?bfqx))
              (and (and (not (= ?bfra ?bfqz))
                  (not (= ?bfra ?awmg))
                  )
                (not (= ?bfqz ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfrb Real)
      (declare-const ?bfrc Real)
      (declare-const ?bfrd Real)
      (assert
        (and (and (not (= ?bfrd ?bfrc))
            (not (= ?bfrd ?bfrb))
            )
          (not (= ?bfrc ?bfrb))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfre Real)
      (declare-const ?bfrf Real)
      (declare-const ?bfrg Real)
      (declare-const ?bfrh Real)
      (declare-const ?bfri Real)
      (declare-const ?bfrj Real)
      (assert
        (or (and (or (or (= ?bfrg ?bfrf)
                (= ?bfrg ?bfre)
                )
              (= ?bfrf ?bfre)
              )
            (or (or (= ?bfrj ?bfri)
                (= ?bfrj ?bfrh)
                )
              (= ?bfri ?bfrh)
              )
            )
          (and (and (and (not (= ?bfrg ?bfrf))
                (not (= ?bfrg ?bfre))
                )
              (not (= ?bfrf ?bfre))
              )
            (and (and (not (= ?bfrj ?bfri))
                (not (= ?bfrj ?bfrh))
                )
              (not (= ?bfri ?bfrh))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfrk Real)
      (declare-const ?bfrl Real)
      (declare-const ?bfrm Real)
      (assert
        (and (and (not (= ?bfrm ?bfrl))
            (not (= ?bfrm ?bfrk))
            )
          (not (= ?bfrl ?bfrk))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfrn Real)
      (declare-const ?bfro Real)
      (declare-const ?bfrp Real)
      (assert
        (and (and (not (= ?bfrp ?bfro))
            (not (= ?bfrp ?bfrn))
            )
          (not (= ?bfro ?bfrn))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bfrq Real)
    (declare-const ?bfrr Real)
    (declare-const ?bfrs Real)
    (declare-const ?bfrt Real)
    (declare-const ?bfru Real)
    (declare-const ?bfrv Real)
    (assert
      (or (and (or (or (= ?bfrs ?bfrr)
              (= ?bfrs ?bfrq)
              )
            (= ?bfrr ?bfrq)
            )
          (or (or (= ?bfrv ?bfru)
              (= ?bfrv ?bfrt)
              )
            (= ?bfru ?bfrt)
            )
          )
        (and (and (and (not (= ?bfrs ?bfrr))
              (not (= ?bfrs ?bfrq))
              )
            (not (= ?bfrr ?bfrq))
            )
          (and (and (not (= ?bfrv ?bfru))
              (not (= ?bfrv ?bfrt))
              )
            (not (= ?bfru ?bfrt))
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfrw Real)
      (declare-const ?bfrx Real)
      (declare-const ?bfry Real)
      (assert
        (and (and (not (= ?bfry ?bfrx))
            (not (= ?bfry ?bfrw))
            )
          (not (= ?bfrx ?bfrw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfrz Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfsa Real)
      (declare-const ?bfsb Real)
      (declare-const ?bfsc Real)
      (declare-const ?bfsd Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bfsb ?bfsa)
                  (= ?bfsb ?awmg)
                  )
                (= ?bfsa ?awmg)
                )
              (or (or (= ?bfsd ?bfsc)
                  (= ?bfsd ?awmg)
                  )
                (= ?bfsc ?awmg)
                )
              )
            (and (not (= ?bfsb ?bfsa))
              (and (and (not (= ?bfsd ?bfsc))
                  (not (= ?bfsd ?awmg))
                  )
                (not (= ?bfsc ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfse Real)
      (declare-const ?bfsf Real)
      (declare-const ?bfsg Real)
      (assert
        (and (and (not (= ?bfsg ?bfsf))
            (not (= ?bfsg ?bfse))
            )
          (not (= ?bfsf ?bfse))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfsh Real)
      (declare-const ?bfsi Real)
      (declare-const ?bfsj Real)
      (declare-const ?bfsk Real)
      (declare-const ?bfsl Real)
      (declare-const ?bfsm Real)
      (assert
        (or (and (or (or (= ?bfsj ?bfsi)
                (= ?bfsj ?bfsh)
                )
              (= ?bfsi ?bfsh)
              )
            (or (or (= ?bfsm ?bfsl)
                (= ?bfsm ?bfsk)
                )
              (= ?bfsl ?bfsk)
              )
            )
          (and (and (and (not (= ?bfsj ?bfsi))
                (not (= ?bfsj ?bfsh))
                )
              (not (= ?bfsi ?bfsh))
              )
            (and (and (not (= ?bfsm ?bfsl))
                (not (= ?bfsm ?bfsk))
                )
              (not (= ?bfsl ?bfsk))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfsn Real)
      (declare-const ?bfso Real)
      (declare-const ?bfsp Real)
      (assert
        (and (and (not (= ?bfsp ?bfso))
            (not (= ?bfsp ?bfsn))
            )
          (not (= ?bfso ?bfsn))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfsq Real)
      (declare-const ?bfsr Real)
      (declare-const ?bfss Real)
      (assert
        (and (and (not (= ?bfss ?bfsr))
            (not (= ?bfss ?bfsq))
            )
          (not (= ?bfsr ?bfsq))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bfst Real)
    (declare-const ?bfsu Real)
    (declare-const ?bfsv Real)
    (assert
      (and (and (not (= ?bfsv ?bfsu))
          (not (= ?bfsv ?bfst))
          )
        (not (= ?bfsu ?bfst))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfsw Real)
      (declare-const ?bfsx Real)
      (declare-const ?bfsy Real)
      (assert
        (and (and (not (= ?bfsy ?bfsx))
            (not (= ?bfsy ?bfsw))
            )
          (not (= ?bfsx ?bfsw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfsz Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfta Real)
      (declare-const ?bftb Real)
      (declare-const ?bftc Real)
      (declare-const ?bftd Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bftb ?bfta)
                  (= ?bftb ?awmg)
                  )
                (= ?bfta ?awmg)
                )
              (or (or (= ?bftd ?bftc)
                  (= ?bftd ?awmg)
                  )
                (= ?bftc ?awmg)
                )
              )
            (and (not (= ?bftb ?bfta))
              (and (and (not (= ?bftd ?bftc))
                  (not (= ?bftd ?awmg))
                  )
                (not (= ?bftc ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfte Real)
      (declare-const ?bftf Real)
      (declare-const ?bftg Real)
      (assert
        (and (and (not (= ?bftg ?bftf))
            (not (= ?bftg ?bfte))
            )
          (not (= ?bftf ?bfte))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfth Real)
      (declare-const ?bfti Real)
      (declare-const ?bftj Real)
      (declare-const ?bftk Real)
      (declare-const ?bftl Real)
      (declare-const ?bftm Real)
      (assert
        (or (and (or (or (= ?bftj ?bfti)
                (= ?bftj ?bfth)
                )
              (= ?bfti ?bfth)
              )
            (or (or (= ?bftm ?bftl)
                (= ?bftm ?bftk)
                )
              (= ?bftl ?bftk)
              )
            )
          (and (and (and (not (= ?bftj ?bfti))
                (not (= ?bftj ?bfth))
                )
              (not (= ?bfti ?bfth))
              )
            (and (and (not (= ?bftm ?bftl))
                (not (= ?bftm ?bftk))
                )
              (not (= ?bftl ?bftk))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bftn Real)
      (declare-const ?bfto Real)
      (declare-const ?bftp Real)
      (assert
        (and (and (not (= ?bftp ?bfto))
            (not (= ?bftp ?bftn))
            )
          (not (= ?bfto ?bftn))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bftq Real)
      (declare-const ?bftr Real)
      (declare-const ?bfts Real)
      (assert
        (and (and (not (= ?bfts ?bftr))
            (not (= ?bfts ?bftq))
            )
          (not (= ?bftr ?bftq))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bftt Real)
      (declare-const ?bftu Real)
      (declare-const ?bftv Real)
      (assert
        (and (and (not (= ?bftv ?bftu))
            (not (= ?bftv ?bftt))
            )
          (not (= ?bftu ?bftt))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bftw Real)
      (declare-const ?bftx Real)
      (declare-const ?bfty Real)
      (declare-const ?bftz Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bftx ?bftw)
                  (= ?bftx ?awmg)
                  )
                (= ?bftw ?awmg)
                )
              (or (or (= ?bftz ?bfty)
                  (= ?bftz ?awmg)
                  )
                (= ?bfty ?awmg)
                )
              )
            (and (not (= ?bftx ?bftw))
              (and (and (not (= ?bftz ?bfty))
                  (not (= ?bftz ?awmg))
                  )
                (not (= ?bfty ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfua Real)
      (declare-const ?bfub Real)
      (declare-const ?bfuc Real)
      (assert
        (and (and (not (= ?bfuc ?bfub))
            (not (= ?bfuc ?bfua))
            )
          (not (= ?bfub ?bfua))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfud Real)
      (declare-const ?bfue Real)
      (declare-const ?bfuf Real)
      (declare-const ?bfug Real)
      (declare-const ?bfuh Real)
      (declare-const ?bfui Real)
      (assert
        (or (and (or (or (= ?bfuf ?bfue)
                (= ?bfuf ?bfud)
                )
              (= ?bfue ?bfud)
              )
            (or (or (= ?bfui ?bfuh)
                (= ?bfui ?bfug)
                )
              (= ?bfuh ?bfug)
              )
            )
          (and (and (and (not (= ?bfuf ?bfue))
                (not (= ?bfuf ?bfud))
                )
              (not (= ?bfue ?bfud))
              )
            (and (and (not (= ?bfui ?bfuh))
                (not (= ?bfui ?bfug))
                )
              (not (= ?bfuh ?bfug))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfuj Real)
      (declare-const ?bfuk Real)
      (declare-const ?bful Real)
      (assert
        (and (and (not (= ?bful ?bfuk))
            (not (= ?bful ?bfuj))
            )
          (not (= ?bfuk ?bfuj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfum Real)
      (declare-const ?bfun Real)
      (declare-const ?bfuo Real)
      (assert
        (and (and (not (= ?bfuo ?bfun))
            (not (= ?bfuo ?bfum))
            )
          (not (= ?bfun ?bfum))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bfup Real)
    (push 1)
      (declare-const ?bfuq Real)
      (declare-const ?bfur Real)
      (declare-const ?bfus Real)
      (assert
        (and (and (not (= ?bfus ?bfur))
            (not (= ?bfus ?bfuq))
            )
          (not (= ?bfur ?bfuq))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfut Real)
      (declare-const ?bfuu Real)
      (declare-const ?bfuv Real)
      (declare-const ?bfuw Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bfuu ?bfut)
                  (= ?bfuu ?awmg)
                  )
                (= ?bfut ?awmg)
                )
              (or (or (= ?bfuw ?bfuv)
                  (= ?bfuw ?awmg)
                  )
                (= ?bfuv ?awmg)
                )
              )
            (and (not (= ?bfuu ?bfut))
              (and (and (not (= ?bfuw ?bfuv))
                  (not (= ?bfuw ?awmg))
                  )
                (not (= ?bfuv ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfux Real)
      (declare-const ?bfuy Real)
      (declare-const ?bfuz Real)
      (assert
        (and (and (not (= ?bfuz ?bfuy))
            (not (= ?bfuz ?bfux))
            )
          (not (= ?bfuy ?bfux))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfva Real)
      (declare-const ?bfvb Real)
      (declare-const ?bfvc Real)
      (declare-const ?bfvd Real)
      (declare-const ?bfve Real)
      (declare-const ?bfvf Real)
      (assert
        (or (and (or (or (= ?bfvc ?bfvb)
                (= ?bfvc ?bfva)
                )
              (= ?bfvb ?bfva)
              )
            (or (or (= ?bfvf ?bfve)
                (= ?bfvf ?bfvd)
                )
              (= ?bfve ?bfvd)
              )
            )
          (and (and (and (not (= ?bfvc ?bfvb))
                (not (= ?bfvc ?bfva))
                )
              (not (= ?bfvb ?bfva))
              )
            (and (and (not (= ?bfvf ?bfve))
                (not (= ?bfvf ?bfvd))
                )
              (not (= ?bfve ?bfvd))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfvg Real)
      (declare-const ?bfvh Real)
      (declare-const ?bfvi Real)
      (assert
        (and (and (not (= ?bfvi ?bfvh))
            (not (= ?bfvi ?bfvg))
            )
          (not (= ?bfvh ?bfvg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfvj Real)
      (declare-const ?bfvk Real)
      (declare-const ?bfvl Real)
      (assert
        (and (and (not (= ?bfvl ?bfvk))
            (not (= ?bfvl ?bfvj))
            )
          (not (= ?bfvk ?bfvj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bfvm Real)
    (declare-const ?bfvn Real)
    (declare-const ?bfvo Real)
    (assert
      (and (and (not (= ?bfvo ?bfvn))
          (not (= ?bfvo ?bfvm))
          )
        (not (= ?bfvn ?bfvm))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfvp Real)
      (declare-const ?bfvq Real)
      (declare-const ?bfvr Real)
      (assert
        (and (and (not (= ?bfvr ?bfvq))
            (not (= ?bfvr ?bfvp))
            )
          (not (= ?bfvq ?bfvp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfvs Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfvt Real)
      (declare-const ?bfvu Real)
      (declare-const ?bfvv Real)
      (declare-const ?bfvw Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bfvu ?bfvt)
                  (= ?bfvu ?awmg)
                  )
                (= ?bfvt ?awmg)
                )
              (or (or (= ?bfvw ?bfvv)
                  (= ?bfvw ?awmg)
                  )
                (= ?bfvv ?awmg)
                )
              )
            (and (not (= ?bfvu ?bfvt))
              (and (and (not (= ?bfvw ?bfvv))
                  (not (= ?bfvw ?awmg))
                  )
                (not (= ?bfvv ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfvx Real)
      (declare-const ?bfvy Real)
      (declare-const ?bfvz Real)
      (assert
        (and (and (not (= ?bfvz ?bfvy))
            (not (= ?bfvz ?bfvx))
            )
          (not (= ?bfvy ?bfvx))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfwa Real)
      (declare-const ?bfwb Real)
      (declare-const ?bfwc Real)
      (declare-const ?bfwd Real)
      (declare-const ?bfwe Real)
      (declare-const ?bfwf Real)
      (assert
        (or (and (or (or (= ?bfwc ?bfwb)
                (= ?bfwc ?bfwa)
                )
              (= ?bfwb ?bfwa)
              )
            (or (or (= ?bfwf ?bfwe)
                (= ?bfwf ?bfwd)
                )
              (= ?bfwe ?bfwd)
              )
            )
          (and (and (and (not (= ?bfwc ?bfwb))
                (not (= ?bfwc ?bfwa))
                )
              (not (= ?bfwb ?bfwa))
              )
            (and (and (not (= ?bfwf ?bfwe))
                (not (= ?bfwf ?bfwd))
                )
              (not (= ?bfwe ?bfwd))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfwg Real)
      (declare-const ?bfwh Real)
      (declare-const ?bfwi Real)
      (assert
        (and (and (not (= ?bfwi ?bfwh))
            (not (= ?bfwi ?bfwg))
            )
          (not (= ?bfwh ?bfwg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfwj Real)
      (declare-const ?bfwk Real)
      (declare-const ?bfwl Real)
      (assert
        (and (and (not (= ?bfwl ?bfwk))
            (not (= ?bfwl ?bfwj))
            )
          (not (= ?bfwk ?bfwj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bfwm Real)
      (declare-const ?bfwn Real)
      (declare-const ?bfwo Real)
      (assert
        (and (and (not (= ?bfwo ?bfwn))
            (not (= ?bfwo ?bfwm))
            )
          (not (= ?bfwn ?bfwm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfwp Real)
      (declare-const ?bfwq Real)
      (declare-const ?bfwr Real)
      (declare-const ?bfws Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bfwq ?bfwp)
                  (= ?bfwq ?awmg)
                  )
                (= ?bfwp ?awmg)
                )
              (or (or (= ?bfws ?bfwr)
                  (= ?bfws ?awmg)
                  )
                (= ?bfwr ?awmg)
                )
              )
            (and (not (= ?bfwq ?bfwp))
              (and (and (not (= ?bfws ?bfwr))
                  (not (= ?bfws ?awmg))
                  )
                (not (= ?bfwr ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfwt Real)
      (declare-const ?bfwu Real)
      (declare-const ?bfwv Real)
      (assert
        (and (and (not (= ?bfwv ?bfwu))
            (not (= ?bfwv ?bfwt))
            )
          (not (= ?bfwu ?bfwt))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfww Real)
      (declare-const ?bfwx Real)
      (declare-const ?bfwy Real)
      (declare-const ?bfwz Real)
      (declare-const ?bfxa Real)
      (declare-const ?bfxb Real)
      (assert
        (or (and (or (or (= ?bfwy ?bfwx)
                (= ?bfwy ?bfww)
                )
              (= ?bfwx ?bfww)
              )
            (or (or (= ?bfxb ?bfxa)
                (= ?bfxb ?bfwz)
                )
              (= ?bfxa ?bfwz)
              )
            )
          (and (and (and (not (= ?bfwy ?bfwx))
                (not (= ?bfwy ?bfww))
                )
              (not (= ?bfwx ?bfww))
              )
            (and (and (not (= ?bfxb ?bfxa))
                (not (= ?bfxb ?bfwz))
                )
              (not (= ?bfxa ?bfwz))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfxc Real)
      (declare-const ?bfxd Real)
      (declare-const ?bfxe Real)
      (assert
        (and (and (not (= ?bfxe ?bfxd))
            (not (= ?bfxe ?bfxc))
            )
          (not (= ?bfxd ?bfxc))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bfxf Real)
      (declare-const ?bfxg Real)
      (declare-const ?bfxh Real)
      (assert
        (and (and (not (= ?bfxh ?bfxg))
            (not (= ?bfxh ?bfxf))
            )
          (not (= ?bfxg ?bfxf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bfxi Real)
  (declare-const ?bfxj Real)
  (declare-const ?bfxk Real)
  (assert
    (and (and (not (= ?bfxk ?bfxj))
        (not (= ?bfxk ?bfxi))
        )
      (not (= ?bfxj ?bfxi))
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bfxl Real)
  (declare-const ?bfxm Real)
  (declare-const ?bfxn Real)
  (declare-const ?bfxo Real)
  (assert
    (and (and (not (= ?bfxn ?bfxm))
        (not (= ?bfxn ?bfxl))
        )
      (not (= ?bfxm ?bfxl))
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bfxp Real)
  (declare-const ?bfxq Real)
  (declare-const ?bfxr Real)
  (declare-const ?bfxs Real)
  (assert
    (forall ((?awmg Real) )(or (and (or (or (= ?bfxq ?bfxp)
              (= ?bfxq ?awmg)
              )
            (= ?bfxp ?awmg)
            )
          (or (or (= ?bfxs ?bfxr)
              (= ?bfxs ?awmg)
              )
            (= ?bfxr ?awmg)
            )
          )
        (and (not (= ?bfxq ?bfxp))
          (and (and (not (= ?bfxs ?bfxr))
              (not (= ?bfxs ?awmg))
              )
            (not (= ?bfxr ?awmg))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bfxt Real)
  (declare-const ?bfxu Real)
  (declare-const ?bfxv Real)
  (assert
    (and (and (not (= ?bfxv ?bfxu))
        (not (= ?bfxv ?bfxt))
        )
      (not (= ?bfxu ?bfxt))
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bfxw Real)
  (declare-const ?bfxx Real)
  (declare-const ?bfxy Real)
  (declare-const ?bfxz Real)
  (assert
    (and (and (not (= ?bfxz ?bfxy))
        (not (= ?bfxz ?bfxx))
        )
      (not (= ?bfxy ?bfxx))
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bfya Real)
  (declare-const ?bfyb Real)
  (declare-const ?bfyc Real)
  (declare-const ?bfyd Real)
  (declare-const ?bfye Real)
  (declare-const ?bfyf Real)
  (assert
    (or (and (or (or (= ?bfyc ?bfyb)
            (= ?bfyc ?bfya)
            )
          (= ?bfyb ?bfya)
          )
        (or (or (= ?bfyf ?bfye)
            (= ?bfyf ?bfyd)
            )
          (= ?bfye ?bfyd)
          )
        )
      (and (and (and (not (= ?bfyc ?bfyb))
            (not (= ?bfyc ?bfya))
            )
          (not (= ?bfyb ?bfya))
          )
        (and (and (not (= ?bfyf ?bfye))
            (not (= ?bfyf ?bfyd))
            )
          (not (= ?bfye ?bfyd))
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bfyg Real)
  (declare-const ?bfyh Real)
  (declare-const ?bfyi Real)
  (assert
    (and (and (not (= ?bfyi ?bfyh))
        (not (= ?bfyi ?bfyg))
        )
      (not (= ?bfyh ?bfyg))
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bfyj Real)
  (declare-const ?bfyk Real)
  (declare-const ?bfyl Real)
  (assert
    (and (and (not (= ?bfyl ?bfyk))
        (not (= ?bfyl ?bfyj))
        )
      (not (= ?bfyk ?bfyj))
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?bfym Real)
    (declare-const ?bfyn Real)
    (declare-const ?bfyo Real)
    (assert
      (and (and (not (= ?bfyo ?bfyn))
          (not (= ?bfyo ?bfym))
          )
        (not (= ?bfyn ?bfym))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bfyp Real)
    (declare-const ?bfyq Real)
    (declare-const ?bfyr Real)
    (declare-const ?bfys Real)
    (assert
      (forall ((?awmg Real) )(or (and (or (or (= ?bfyq ?bfyp)
                (= ?bfyq ?awmg)
                )
              (= ?bfyp ?awmg)
              )
            (or (or (= ?bfys ?bfyr)
                (= ?bfys ?awmg)
                )
              (= ?bfyr ?awmg)
              )
            )
          (and (not (= ?bfyq ?bfyp))
            (and (and (not (= ?bfys ?bfyr))
                (not (= ?bfys ?awmg))
                )
              (not (= ?bfyr ?awmg))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bfyt Real)
    (declare-const ?bfyu Real)
    (declare-const ?bfyv Real)
    (assert
      (and (and (not (= ?bfyv ?bfyu))
          (not (= ?bfyv ?bfyt))
          )
        (not (= ?bfyu ?bfyt))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bfyw Real)
    (declare-const ?bfyx Real)
    (declare-const ?bfyy Real)
    (declare-const ?bfyz Real)
    (declare-const ?bfza Real)
    (declare-const ?bfzb Real)
    (assert
      (or (and (or (or (= ?bfyy ?bfyx)
              (= ?bfyy ?bfyw)
              )
            (= ?bfyx ?bfyw)
            )
          (or (or (= ?bfzb ?bfza)
              (= ?bfzb ?bfyz)
              )
            (= ?bfza ?bfyz)
            )
          )
        (and (and (and (not (= ?bfyy ?bfyx))
              (not (= ?bfyy ?bfyw))
              )
            (not (= ?bfyx ?bfyw))
            )
          (and (and (not (= ?bfzb ?bfza))
              (not (= ?bfzb ?bfyz))
              )
            (not (= ?bfza ?bfyz))
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bfzc Real)
    (declare-const ?bfzd Real)
    (declare-const ?bfze Real)
    (assert
      (and (and (not (= ?bfze ?bfzd))
          (not (= ?bfze ?bfzc))
          )
        (not (= ?bfzd ?bfzc))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bfzf Real)
    (declare-const ?bfzg Real)
    (declare-const ?bfzh Real)
    (assert
      (and (and (not (= ?bfzh ?bfzg))
          (not (= ?bfzh ?bfzf))
          )
        (not (= ?bfzg ?bfzf))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (push 1)
      (push 1)
        (declare-const ?bfzj Real)
        (declare-const ?bfzk Real)
        (declare-const ?bfzl Real)
        (assert
          (and (and (not (= ?bfzl ?bfzk))
              (not (= ?bfzl ?bfzj))
              )
            (not (= ?bfzk ?bfzj))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bfzm Real)
        (declare-const ?bfzn Real)
        (declare-const ?bfzo Real)
        (declare-const ?bfzp Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bfzn ?bfzm)
                    (= ?bfzn ?awmg)
                    )
                  (= ?bfzm ?awmg)
                  )
                (or (or (= ?bfzp ?bfzo)
                    (= ?bfzp ?awmg)
                    )
                  (= ?bfzo ?awmg)
                  )
                )
              (and (not (= ?bfzn ?bfzm))
                (and (and (not (= ?bfzp ?bfzo))
                    (not (= ?bfzp ?awmg))
                    )
                  (not (= ?bfzo ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bfzq Real)
        (declare-const ?bfzr Real)
        (declare-const ?bfzs Real)
        (assert
          (and (and (not (= ?bfzs ?bfzr))
              (not (= ?bfzs ?bfzq))
              )
            (not (= ?bfzr ?bfzq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bfzt Real)
        (declare-const ?bfzu Real)
        (declare-const ?bfzv Real)
        (declare-const ?bfzw Real)
        (declare-const ?bfzx Real)
        (declare-const ?bfzy Real)
        (assert
          (or (and (or (or (= ?bfzv ?bfzu)
                  (= ?bfzv ?bfzt)
                  )
                (= ?bfzu ?bfzt)
                )
              (or (or (= ?bfzy ?bfzx)
                  (= ?bfzy ?bfzw)
                  )
                (= ?bfzx ?bfzw)
                )
              )
            (and (and (and (not (= ?bfzv ?bfzu))
                  (not (= ?bfzv ?bfzt))
                  )
                (not (= ?bfzu ?bfzt))
                )
              (and (and (not (= ?bfzy ?bfzx))
                  (not (= ?bfzy ?bfzw))
                  )
                (not (= ?bfzx ?bfzw))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bfzz Real)
        (declare-const ?bgaa Real)
        (declare-const ?bgab Real)
        (assert
          (and (and (not (= ?bgab ?bgaa))
              (not (= ?bgab ?bfzz))
              )
            (not (= ?bgaa ?bfzz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgac Real)
        (declare-const ?bgad Real)
        (declare-const ?bgae Real)
        (assert
          (and (and (not (= ?bgae ?bgad))
              (not (= ?bgae ?bgac))
              )
            (not (= ?bgad ?bgac))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bgaf Real)
          (push 1)
            (declare-const ?bgag Real)
            (push 1)
              (declare-const ?bgah Real)
              (push 1)
                (assert
                  (and (= ?bgag ?bgaf)
                    (= ?bgah ?bgaf)
                    )
                  )
                (push 1)
                  (declare-const ?bgai Real)
                  (declare-const ?bgaj Real)
                  (declare-const ?bgak Real)
                  (assert
                    (and (and (not (= ?bgak ?bgaj))
                        (not (= ?bgak ?bgai))
                        )
                      (not (= ?bgaj ?bgai))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgal Real)
                  (declare-const ?bgam Real)
                  (declare-const ?bgan Real)
                  (declare-const ?bgao Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bgam ?bgal)
                              (= ?bgam ?awmg)
                              )
                            (= ?bgal ?awmg)
                            )
                          (or (or (= ?bgao ?bgan)
                              (= ?bgao ?awmg)
                              )
                            (= ?bgan ?awmg)
                            )
                          )
                        (and (not (= ?bgam ?bgal))
                          (and (and (not (= ?bgao ?bgan))
                              (not (= ?bgao ?awmg))
                              )
                            (not (= ?bgan ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgap Real)
                  (declare-const ?bgaq Real)
                  (declare-const ?bgar Real)
                  (assert
                    (and (and (not (= ?bgar ?bgaq))
                        (not (= ?bgar ?bgap))
                        )
                      (not (= ?bgaq ?bgap))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgas Real)
                  (declare-const ?bgat Real)
                  (declare-const ?bgau Real)
                  (declare-const ?bgav Real)
                  (declare-const ?bgaw Real)
                  (declare-const ?bgax Real)
                  (assert
                    (or (and (or (or (= ?bgau ?bgat)
                            (= ?bgau ?bgas)
                            )
                          (= ?bgat ?bgas)
                          )
                        (or (or (= ?bgax ?bgaw)
                            (= ?bgax ?bgav)
                            )
                          (= ?bgaw ?bgav)
                          )
                        )
                      (and (and (and (not (= ?bgau ?bgat))
                            (not (= ?bgau ?bgas))
                            )
                          (not (= ?bgat ?bgas))
                          )
                        (and (and (not (= ?bgax ?bgaw))
                            (not (= ?bgax ?bgav))
                            )
                          (not (= ?bgaw ?bgav))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgay Real)
                  (declare-const ?bgaz Real)
                  (declare-const ?bgba Real)
                  (assert
                    (and (and (not (= ?bgba ?bgaz))
                        (not (= ?bgba ?bgay))
                        )
                      (not (= ?bgaz ?bgay))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgbb Real)
                  (declare-const ?bgbc Real)
                  (declare-const ?bgbd Real)
                  (assert
                    (and (and (not (= ?bgbd ?bgbc))
                        (not (= ?bgbd ?bgbb))
                        )
                      (not (= ?bgbc ?bgbb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bgbe Real)
      (push 1)
        (declare-const ?bgbf Real)
        (declare-const ?bgbg Real)
        (declare-const ?bgbh Real)
        (assert
          (and (and (not (= ?bgbh ?bgbg))
              (not (= ?bgbh ?bgbf))
              )
            (not (= ?bgbg ?bgbf))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgbi Real)
        (declare-const ?bgbj Real)
        (declare-const ?bgbk Real)
        (declare-const ?bgbl Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bgbj ?bgbi)
                    (= ?bgbj ?awmg)
                    )
                  (= ?bgbi ?awmg)
                  )
                (or (or (= ?bgbl ?bgbk)
                    (= ?bgbl ?awmg)
                    )
                  (= ?bgbk ?awmg)
                  )
                )
              (and (not (= ?bgbj ?bgbi))
                (and (and (not (= ?bgbl ?bgbk))
                    (not (= ?bgbl ?awmg))
                    )
                  (not (= ?bgbk ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgbm Real)
        (declare-const ?bgbn Real)
        (declare-const ?bgbo Real)
        (assert
          (and (and (not (= ?bgbo ?bgbn))
              (not (= ?bgbo ?bgbm))
              )
            (not (= ?bgbn ?bgbm))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgbp Real)
        (declare-const ?bgbq Real)
        (declare-const ?bgbr Real)
        (declare-const ?bgbs Real)
        (declare-const ?bgbt Real)
        (declare-const ?bgbu Real)
        (assert
          (or (and (or (or (= ?bgbr ?bgbq)
                  (= ?bgbr ?bgbp)
                  )
                (= ?bgbq ?bgbp)
                )
              (or (or (= ?bgbu ?bgbt)
                  (= ?bgbu ?bgbs)
                  )
                (= ?bgbt ?bgbs)
                )
              )
            (and (and (and (not (= ?bgbr ?bgbq))
                  (not (= ?bgbr ?bgbp))
                  )
                (not (= ?bgbq ?bgbp))
                )
              (and (and (not (= ?bgbu ?bgbt))
                  (not (= ?bgbu ?bgbs))
                  )
                (not (= ?bgbt ?bgbs))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgbv Real)
        (declare-const ?bgbw Real)
        (declare-const ?bgbx Real)
        (assert
          (and (and (not (= ?bgbx ?bgbw))
              (not (= ?bgbx ?bgbv))
              )
            (not (= ?bgbw ?bgbv))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgby Real)
        (declare-const ?bgbz Real)
        (declare-const ?bgca Real)
        (assert
          (and (and (not (= ?bgca ?bgbz))
              (not (= ?bgca ?bgby))
              )
            (not (= ?bgbz ?bgby))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bgcb Real)
      (declare-const ?bgcc Real)
      (push 1)
        (declare-const ?bgcd Real)
        (declare-const ?bgce Real)
        (declare-const ?bgcf Real)
        (assert
          (and (and (not (= ?bgcf ?bgce))
              (not (= ?bgcf ?bgcd))
              )
            (not (= ?bgce ?bgcd))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgcg Real)
        (declare-const ?bgch Real)
        (declare-const ?bgci Real)
        (declare-const ?bgcj Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bgch ?bgcg)
                    (= ?bgch ?awmg)
                    )
                  (= ?bgcg ?awmg)
                  )
                (or (or (= ?bgcj ?bgci)
                    (= ?bgcj ?awmg)
                    )
                  (= ?bgci ?awmg)
                  )
                )
              (and (not (= ?bgch ?bgcg))
                (and (and (not (= ?bgcj ?bgci))
                    (not (= ?bgcj ?awmg))
                    )
                  (not (= ?bgci ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgck Real)
        (declare-const ?bgcl Real)
        (declare-const ?bgcm Real)
        (assert
          (and (and (not (= ?bgcm ?bgcl))
              (not (= ?bgcm ?bgck))
              )
            (not (= ?bgcl ?bgck))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgcn Real)
        (declare-const ?bgco Real)
        (declare-const ?bgcp Real)
        (declare-const ?bgcq Real)
        (declare-const ?bgcr Real)
        (declare-const ?bgcs Real)
        (assert
          (or (and (or (or (= ?bgcp ?bgco)
                  (= ?bgcp ?bgcn)
                  )
                (= ?bgco ?bgcn)
                )
              (or (or (= ?bgcs ?bgcr)
                  (= ?bgcs ?bgcq)
                  )
                (= ?bgcr ?bgcq)
                )
              )
            (and (and (and (not (= ?bgcp ?bgco))
                  (not (= ?bgcp ?bgcn))
                  )
                (not (= ?bgco ?bgcn))
                )
              (and (and (not (= ?bgcs ?bgcr))
                  (not (= ?bgcs ?bgcq))
                  )
                (not (= ?bgcr ?bgcq))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgct Real)
        (declare-const ?bgcu Real)
        (declare-const ?bgcv Real)
        (assert
          (and (and (not (= ?bgcv ?bgcu))
              (not (= ?bgcv ?bgct))
              )
            (not (= ?bgcu ?bgct))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgcw Real)
        (declare-const ?bgcx Real)
        (declare-const ?bgcy Real)
        (assert
          (and (and (not (= ?bgcy ?bgcx))
              (not (= ?bgcy ?bgcw))
              )
            (not (= ?bgcx ?bgcw))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bgcz Real)
      (declare-const ?bgda Real)
      (declare-const ?bgdb Real)
      (push 1)
        (declare-const ?bgdc Real)
        (declare-const ?bgdd Real)
        (declare-const ?bgde Real)
        (assert
          (and (and (not (= ?bgde ?bgdd))
              (not (= ?bgde ?bgdc))
              )
            (not (= ?bgdd ?bgdc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgdf Real)
        (declare-const ?bgdg Real)
        (declare-const ?bgdh Real)
        (declare-const ?bgdi Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bgdg ?bgdf)
                    (= ?bgdg ?awmg)
                    )
                  (= ?bgdf ?awmg)
                  )
                (or (or (= ?bgdi ?bgdh)
                    (= ?bgdi ?awmg)
                    )
                  (= ?bgdh ?awmg)
                  )
                )
              (and (not (= ?bgdg ?bgdf))
                (and (and (not (= ?bgdi ?bgdh))
                    (not (= ?bgdi ?awmg))
                    )
                  (not (= ?bgdh ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgdj Real)
        (declare-const ?bgdk Real)
        (declare-const ?bgdl Real)
        (assert
          (and (and (not (= ?bgdl ?bgdk))
              (not (= ?bgdl ?bgdj))
              )
            (not (= ?bgdk ?bgdj))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgdm Real)
        (declare-const ?bgdn Real)
        (declare-const ?bgdo Real)
        (declare-const ?bgdp Real)
        (declare-const ?bgdq Real)
        (declare-const ?bgdr Real)
        (assert
          (or (and (or (or (= ?bgdo ?bgdn)
                  (= ?bgdo ?bgdm)
                  )
                (= ?bgdn ?bgdm)
                )
              (or (or (= ?bgdr ?bgdq)
                  (= ?bgdr ?bgdp)
                  )
                (= ?bgdq ?bgdp)
                )
              )
            (and (and (and (not (= ?bgdo ?bgdn))
                  (not (= ?bgdo ?bgdm))
                  )
                (not (= ?bgdn ?bgdm))
                )
              (and (and (not (= ?bgdr ?bgdq))
                  (not (= ?bgdr ?bgdp))
                  )
                (not (= ?bgdq ?bgdp))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgds Real)
        (declare-const ?bgdt Real)
        (declare-const ?bgdu Real)
        (assert
          (and (and (not (= ?bgdu ?bgdt))
              (not (= ?bgdu ?bgds))
              )
            (not (= ?bgdt ?bgds))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgdv Real)
        (declare-const ?bgdw Real)
        (declare-const ?bgdx Real)
        (assert
          (and (and (not (= ?bgdx ?bgdw))
              (not (= ?bgdx ?bgdv))
              )
            (not (= ?bgdw ?bgdv))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?bgdb ?bgda))
              (not (= ?bgdb ?bgcz))
              )
            (not (= ?bgda ?bgcz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bgdy Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bgdz Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bgea Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgeb Real)
              (declare-const ?bgec Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bged Real)
              (declare-const ?bgee Real)
              (declare-const ?bgef Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgeg Real)
              (declare-const ?bgeh Real)
              (declare-const ?bgei Real)
              (declare-const ?bgej Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (= ?bgdz ?bgdy)
                      (and (and (= ?bgei ?bgdb)
                          (= ?bgeh ?bgda)
                          )
                        (= ?bgeg ?bgcz)
                        )
                      )
                    (= ?bgej ?bgdy)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgek Real)
                  (declare-const ?bgel Real)
                  (declare-const ?bgem Real)
                  (assert
                    (and (and (not (= ?bgem ?bgel))
                        (not (= ?bgem ?bgek))
                        )
                      (not (= ?bgel ?bgek))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgen Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgeo Real)
                  (declare-const ?bgep Real)
                  (declare-const ?bgeq Real)
                  (declare-const ?bger Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bgep ?bgeo)
                              (= ?bgep ?awmg)
                              )
                            (= ?bgeo ?awmg)
                            )
                          (or (or (= ?bger ?bgeq)
                              (= ?bger ?awmg)
                              )
                            (= ?bgeq ?awmg)
                            )
                          )
                        (and (not (= ?bgep ?bgeo))
                          (and (and (not (= ?bger ?bgeq))
                              (not (= ?bger ?awmg))
                              )
                            (not (= ?bgeq ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bges Real)
                  (declare-const ?bget Real)
                  (declare-const ?bgeu Real)
                  (assert
                    (and (and (not (= ?bgeu ?bget))
                        (not (= ?bgeu ?bges))
                        )
                      (not (= ?bget ?bges))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgev Real)
                  (declare-const ?bgew Real)
                  (declare-const ?bgex Real)
                  (declare-const ?bgey Real)
                  (declare-const ?bgez Real)
                  (declare-const ?bgfa Real)
                  (assert
                    (or (and (or (or (= ?bgex ?bgew)
                            (= ?bgex ?bgev)
                            )
                          (= ?bgew ?bgev)
                          )
                        (or (or (= ?bgfa ?bgez)
                            (= ?bgfa ?bgey)
                            )
                          (= ?bgez ?bgey)
                          )
                        )
                      (and (and (and (not (= ?bgex ?bgew))
                            (not (= ?bgex ?bgev))
                            )
                          (not (= ?bgew ?bgev))
                          )
                        (and (and (not (= ?bgfa ?bgez))
                            (not (= ?bgfa ?bgey))
                            )
                          (not (= ?bgez ?bgey))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgfb Real)
                  (declare-const ?bgfc Real)
                  (declare-const ?bgfd Real)
                  (assert
                    (and (and (not (= ?bgfd ?bgfc))
                        (not (= ?bgfd ?bgfb))
                        )
                      (not (= ?bgfc ?bgfb))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgfe Real)
                  (declare-const ?bgff Real)
                  (declare-const ?bgfg Real)
                  (assert
                    (and (and (not (= ?bgfg ?bgff))
                        (not (= ?bgfg ?bgfe))
                        )
                      (not (= ?bgff ?bgfe))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?bgfh Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bgfi Real)
            (declare-const ?bgfj Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bgfk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgfl Real)
              (declare-const ?bgfm Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgfn Real)
              (declare-const ?bgfo Real)
              (declare-const ?bgfp Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgfq Real)
              (declare-const ?bgfr Real)
              (declare-const ?bgfs Real)
              (declare-const ?bgft Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgfu Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bgfv Real)
            (declare-const ?bgfw Real)
            (declare-const ?bgfx Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bgfy Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgfz Real)
              (declare-const ?bgga Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bggb Real)
              (declare-const ?bggc Real)
              (declare-const ?bggd Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgge Real)
              (declare-const ?bggf Real)
              (declare-const ?bggg Real)
              (declare-const ?bggh Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bggi Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bggj Real)
            (declare-const ?bggk Real)
            (declare-const ?bggl Real)
            (declare-const ?bggm Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bggn Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bggo Real)
              (declare-const ?bggp Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bggq Real)
              (declare-const ?bggr Real)
              (declare-const ?bggs Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bggt Real)
              (declare-const ?bggu Real)
              (declare-const ?bggv Real)
              (declare-const ?bggw Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bggx Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bggy Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bggz Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgha Real)
              (declare-const ?bghb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bghc Real)
              (declare-const ?bghd Real)
              (declare-const ?bghe Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bghf Real)
              (declare-const ?bghg Real)
              (declare-const ?bghh Real)
              (declare-const ?bghi Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bghj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (declare-const ?bghk Real)
        (declare-const ?bghl Real)
        (declare-const ?bghm Real)
        (assert
          (and (and (not (= ?bghm ?bghl))
              (not (= ?bghm ?bghk))
              )
            (not (= ?bghl ?bghk))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bghn Real)
        (declare-const ?bgho Real)
        (declare-const ?bghp Real)
        (declare-const ?bghq Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bgho ?bghn)
                    (= ?bgho ?awmg)
                    )
                  (= ?bghn ?awmg)
                  )
                (or (or (= ?bghq ?bghp)
                    (= ?bghq ?awmg)
                    )
                  (= ?bghp ?awmg)
                  )
                )
              (and (not (= ?bgho ?bghn))
                (and (and (not (= ?bghq ?bghp))
                    (not (= ?bghq ?awmg))
                    )
                  (not (= ?bghp ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bghr Real)
        (declare-const ?bghs Real)
        (declare-const ?bght Real)
        (assert
          (and (and (not (= ?bght ?bghs))
              (not (= ?bght ?bghr))
              )
            (not (= ?bghs ?bghr))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bghu Real)
        (declare-const ?bghv Real)
        (declare-const ?bghw Real)
        (declare-const ?bghx Real)
        (declare-const ?bghy Real)
        (declare-const ?bghz Real)
        (assert
          (or (and (or (or (= ?bghw ?bghv)
                  (= ?bghw ?bghu)
                  )
                (= ?bghv ?bghu)
                )
              (or (or (= ?bghz ?bghy)
                  (= ?bghz ?bghx)
                  )
                (= ?bghy ?bghx)
                )
              )
            (and (and (and (not (= ?bghw ?bghv))
                  (not (= ?bghw ?bghu))
                  )
                (not (= ?bghv ?bghu))
                )
              (and (and (not (= ?bghz ?bghy))
                  (not (= ?bghz ?bghx))
                  )
                (not (= ?bghy ?bghx))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgia Real)
        (declare-const ?bgib Real)
        (declare-const ?bgic Real)
        (assert
          (and (and (not (= ?bgic ?bgib))
              (not (= ?bgic ?bgia))
              )
            (not (= ?bgib ?bgia))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgid Real)
        (declare-const ?bgie Real)
        (declare-const ?bgif Real)
        (assert
          (and (and (not (= ?bgif ?bgie))
              (not (= ?bgif ?bgid))
              )
            (not (= ?bgie ?bgid))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bgig Real)
          (push 1)
            (declare-const ?bgih Real)
            (push 1)
              (declare-const ?bgii Real)
              (push 1)
                (assert
                  (and (= ?bgih ?bgig)
                    (= ?bgii ?bgig)
                    )
                  )
                (push 1)
                  (declare-const ?bgij Real)
                  (declare-const ?bgik Real)
                  (declare-const ?bgil Real)
                  (assert
                    (and (and (not (= ?bgil ?bgik))
                        (not (= ?bgil ?bgij))
                        )
                      (not (= ?bgik ?bgij))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgim Real)
                  (declare-const ?bgin Real)
                  (declare-const ?bgio Real)
                  (declare-const ?bgip Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bgin ?bgim)
                              (= ?bgin ?awmg)
                              )
                            (= ?bgim ?awmg)
                            )
                          (or (or (= ?bgip ?bgio)
                              (= ?bgip ?awmg)
                              )
                            (= ?bgio ?awmg)
                            )
                          )
                        (and (not (= ?bgin ?bgim))
                          (and (and (not (= ?bgip ?bgio))
                              (not (= ?bgip ?awmg))
                              )
                            (not (= ?bgio ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgiq Real)
                  (declare-const ?bgir Real)
                  (declare-const ?bgis Real)
                  (assert
                    (and (and (not (= ?bgis ?bgir))
                        (not (= ?bgis ?bgiq))
                        )
                      (not (= ?bgir ?bgiq))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgit Real)
                  (declare-const ?bgiu Real)
                  (declare-const ?bgiv Real)
                  (declare-const ?bgiw Real)
                  (declare-const ?bgix Real)
                  (declare-const ?bgiy Real)
                  (assert
                    (or (and (or (or (= ?bgiv ?bgiu)
                            (= ?bgiv ?bgit)
                            )
                          (= ?bgiu ?bgit)
                          )
                        (or (or (= ?bgiy ?bgix)
                            (= ?bgiy ?bgiw)
                            )
                          (= ?bgix ?bgiw)
                          )
                        )
                      (and (and (and (not (= ?bgiv ?bgiu))
                            (not (= ?bgiv ?bgit))
                            )
                          (not (= ?bgiu ?bgit))
                          )
                        (and (and (not (= ?bgiy ?bgix))
                            (not (= ?bgiy ?bgiw))
                            )
                          (not (= ?bgix ?bgiw))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgiz Real)
                  (declare-const ?bgja Real)
                  (declare-const ?bgjb Real)
                  (assert
                    (and (and (not (= ?bgjb ?bgja))
                        (not (= ?bgjb ?bgiz))
                        )
                      (not (= ?bgja ?bgiz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgjc Real)
                  (declare-const ?bgjd Real)
                  (declare-const ?bgje Real)
                  (assert
                    (and (and (not (= ?bgje ?bgjd))
                        (not (= ?bgje ?bgjc))
                        )
                      (not (= ?bgjd ?bgjc))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bgjf Real)
    (push 1)
      (push 1)
        (declare-const ?bgjg Real)
        (declare-const ?bgjh Real)
        (declare-const ?bgji Real)
        (assert
          (and (and (not (= ?bgji ?bgjh))
              (not (= ?bgji ?bgjg))
              )
            (not (= ?bgjh ?bgjg))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgjj Real)
        (declare-const ?bgjk Real)
        (declare-const ?bgjl Real)
        (declare-const ?bgjm Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bgjk ?bgjj)
                    (= ?bgjk ?awmg)
                    )
                  (= ?bgjj ?awmg)
                  )
                (or (or (= ?bgjm ?bgjl)
                    (= ?bgjm ?awmg)
                    )
                  (= ?bgjl ?awmg)
                  )
                )
              (and (not (= ?bgjk ?bgjj))
                (and (and (not (= ?bgjm ?bgjl))
                    (not (= ?bgjm ?awmg))
                    )
                  (not (= ?bgjl ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgjn Real)
        (declare-const ?bgjo Real)
        (declare-const ?bgjp Real)
        (assert
          (and (and (not (= ?bgjp ?bgjo))
              (not (= ?bgjp ?bgjn))
              )
            (not (= ?bgjo ?bgjn))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgjq Real)
        (declare-const ?bgjr Real)
        (declare-const ?bgjs Real)
        (declare-const ?bgjt Real)
        (declare-const ?bgju Real)
        (declare-const ?bgjv Real)
        (assert
          (or (and (or (or (= ?bgjs ?bgjr)
                  (= ?bgjs ?bgjq)
                  )
                (= ?bgjr ?bgjq)
                )
              (or (or (= ?bgjv ?bgju)
                  (= ?bgjv ?bgjt)
                  )
                (= ?bgju ?bgjt)
                )
              )
            (and (and (and (not (= ?bgjs ?bgjr))
                  (not (= ?bgjs ?bgjq))
                  )
                (not (= ?bgjr ?bgjq))
                )
              (and (and (not (= ?bgjv ?bgju))
                  (not (= ?bgjv ?bgjt))
                  )
                (not (= ?bgju ?bgjt))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgjw Real)
        (declare-const ?bgjx Real)
        (declare-const ?bgjy Real)
        (assert
          (and (and (not (= ?bgjy ?bgjx))
              (not (= ?bgjy ?bgjw))
              )
            (not (= ?bgjx ?bgjw))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgjz Real)
        (declare-const ?bgka Real)
        (declare-const ?bgkb Real)
        (assert
          (and (and (not (= ?bgkb ?bgka))
              (not (= ?bgkb ?bgjz))
              )
            (not (= ?bgka ?bgjz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bgkc Real)
      (push 1)
        (declare-const ?bgkd Real)
        (declare-const ?bgke Real)
        (declare-const ?bgkf Real)
        (assert
          (and (and (not (= ?bgkf ?bgke))
              (not (= ?bgkf ?bgkd))
              )
            (not (= ?bgke ?bgkd))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgkg Real)
        (declare-const ?bgkh Real)
        (declare-const ?bgki Real)
        (declare-const ?bgkj Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bgkh ?bgkg)
                    (= ?bgkh ?awmg)
                    )
                  (= ?bgkg ?awmg)
                  )
                (or (or (= ?bgkj ?bgki)
                    (= ?bgkj ?awmg)
                    )
                  (= ?bgki ?awmg)
                  )
                )
              (and (not (= ?bgkh ?bgkg))
                (and (and (not (= ?bgkj ?bgki))
                    (not (= ?bgkj ?awmg))
                    )
                  (not (= ?bgki ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgkk Real)
        (declare-const ?bgkl Real)
        (declare-const ?bgkm Real)
        (assert
          (and (and (not (= ?bgkm ?bgkl))
              (not (= ?bgkm ?bgkk))
              )
            (not (= ?bgkl ?bgkk))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgkn Real)
        (declare-const ?bgko Real)
        (declare-const ?bgkp Real)
        (declare-const ?bgkq Real)
        (declare-const ?bgkr Real)
        (declare-const ?bgks Real)
        (assert
          (or (and (or (or (= ?bgkp ?bgko)
                  (= ?bgkp ?bgkn)
                  )
                (= ?bgko ?bgkn)
                )
              (or (or (= ?bgks ?bgkr)
                  (= ?bgks ?bgkq)
                  )
                (= ?bgkr ?bgkq)
                )
              )
            (and (and (and (not (= ?bgkp ?bgko))
                  (not (= ?bgkp ?bgkn))
                  )
                (not (= ?bgko ?bgkn))
                )
              (and (and (not (= ?bgks ?bgkr))
                  (not (= ?bgks ?bgkq))
                  )
                (not (= ?bgkr ?bgkq))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgkt Real)
        (declare-const ?bgku Real)
        (declare-const ?bgkv Real)
        (assert
          (and (and (not (= ?bgkv ?bgku))
              (not (= ?bgkv ?bgkt))
              )
            (not (= ?bgku ?bgkt))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgkw Real)
        (declare-const ?bgkx Real)
        (declare-const ?bgky Real)
        (assert
          (and (and (not (= ?bgky ?bgkx))
              (not (= ?bgky ?bgkw))
              )
            (not (= ?bgkx ?bgkw))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (= ?bgkc ?bgjf)
          )
        (push 1)
          (declare-const ?bgkz Real)
          (push 1)
            (declare-const ?bgla Real)
            (declare-const ?bglb Real)
            (push 1)
              (declare-const ?bglc Real)
              (declare-const ?bgld Real)
              (push 1)
                (assert
                  (and (and (and (= ?bgla ?bgjf)
                        (= ?bglb ?bgkz)
                        )
                      (= ?bglc ?bgkc)
                      )
                    (= ?bgld ?bgkz)
                    )
                  )
                (push 1)
                  (declare-const ?bgle Real)
                  (declare-const ?bglf Real)
                  (declare-const ?bglg Real)
                  (assert
                    (and (and (not (= ?bglg ?bglf))
                        (not (= ?bglg ?bgle))
                        )
                      (not (= ?bglf ?bgle))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bglh Real)
                  (declare-const ?bgli Real)
                  (declare-const ?bglj Real)
                  (declare-const ?bglk Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bgli ?bglh)
                              (= ?bgli ?awmg)
                              )
                            (= ?bglh ?awmg)
                            )
                          (or (or (= ?bglk ?bglj)
                              (= ?bglk ?awmg)
                              )
                            (= ?bglj ?awmg)
                            )
                          )
                        (and (not (= ?bgli ?bglh))
                          (and (and (not (= ?bglk ?bglj))
                              (not (= ?bglk ?awmg))
                              )
                            (not (= ?bglj ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgll Real)
                  (declare-const ?bglm Real)
                  (declare-const ?bgln Real)
                  (assert
                    (and (and (not (= ?bgln ?bglm))
                        (not (= ?bgln ?bgll))
                        )
                      (not (= ?bglm ?bgll))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bglo Real)
                  (declare-const ?bglp Real)
                  (declare-const ?bglq Real)
                  (declare-const ?bglr Real)
                  (declare-const ?bgls Real)
                  (declare-const ?bglt Real)
                  (assert
                    (or (and (or (or (= ?bglq ?bglp)
                            (= ?bglq ?bglo)
                            )
                          (= ?bglp ?bglo)
                          )
                        (or (or (= ?bglt ?bgls)
                            (= ?bglt ?bglr)
                            )
                          (= ?bgls ?bglr)
                          )
                        )
                      (and (and (and (not (= ?bglq ?bglp))
                            (not (= ?bglq ?bglo))
                            )
                          (not (= ?bglp ?bglo))
                          )
                        (and (and (not (= ?bglt ?bgls))
                            (not (= ?bglt ?bglr))
                            )
                          (not (= ?bgls ?bglr))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bglu Real)
                  (declare-const ?bglv Real)
                  (declare-const ?bglw Real)
                  (assert
                    (and (and (not (= ?bglw ?bglv))
                        (not (= ?bglw ?bglu))
                        )
                      (not (= ?bglv ?bglu))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bglx Real)
                  (declare-const ?bgly Real)
                  (declare-const ?bglz Real)
                  (assert
                    (and (and (not (= ?bglz ?bgly))
                        (not (= ?bglz ?bglx))
                        )
                      (not (= ?bgly ?bglx))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (assert
                    (exists ((?awmg Real) )(and (or (and (and (not (= ?bglc ?bgld))
                              (not (= ?bglc ?awmg))
                              )
                            (not (= ?bgld ?awmg))
                            )
                          (and (and (not (= ?bgla ?bglb))
                              (not (= ?bgla ?awmg))
                              )
                            (not (= ?bglb ?awmg))
                            )
                          )
                        (or (= ?bglc ?bgld)
                          (or (or (= ?bgla ?bglb)
                              (= ?bgla ?awmg)
                              )
                            (= ?bglb ?awmg)
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bgma Real)
      (declare-const ?bgmb Real)
      (push 1)
        (declare-const ?bgmc Real)
        (declare-const ?bgmd Real)
        (declare-const ?bgme Real)
        (assert
          (and (and (not (= ?bgme ?bgmd))
              (not (= ?bgme ?bgmc))
              )
            (not (= ?bgmd ?bgmc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgmf Real)
        (declare-const ?bgmg Real)
        (declare-const ?bgmh Real)
        (declare-const ?bgmi Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bgmg ?bgmf)
                    (= ?bgmg ?awmg)
                    )
                  (= ?bgmf ?awmg)
                  )
                (or (or (= ?bgmi ?bgmh)
                    (= ?bgmi ?awmg)
                    )
                  (= ?bgmh ?awmg)
                  )
                )
              (and (not (= ?bgmg ?bgmf))
                (and (and (not (= ?bgmi ?bgmh))
                    (not (= ?bgmi ?awmg))
                    )
                  (not (= ?bgmh ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgmj Real)
        (declare-const ?bgmk Real)
        (declare-const ?bgml Real)
        (assert
          (and (and (not (= ?bgml ?bgmk))
              (not (= ?bgml ?bgmj))
              )
            (not (= ?bgmk ?bgmj))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgmm Real)
        (declare-const ?bgmn Real)
        (declare-const ?bgmo Real)
        (declare-const ?bgmp Real)
        (declare-const ?bgmq Real)
        (declare-const ?bgmr Real)
        (assert
          (or (and (or (or (= ?bgmo ?bgmn)
                  (= ?bgmo ?bgmm)
                  )
                (= ?bgmn ?bgmm)
                )
              (or (or (= ?bgmr ?bgmq)
                  (= ?bgmr ?bgmp)
                  )
                (= ?bgmq ?bgmp)
                )
              )
            (and (and (and (not (= ?bgmo ?bgmn))
                  (not (= ?bgmo ?bgmm))
                  )
                (not (= ?bgmn ?bgmm))
                )
              (and (and (not (= ?bgmr ?bgmq))
                  (not (= ?bgmr ?bgmp))
                  )
                (not (= ?bgmq ?bgmp))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgms Real)
        (declare-const ?bgmt Real)
        (declare-const ?bgmu Real)
        (assert
          (and (and (not (= ?bgmu ?bgmt))
              (not (= ?bgmu ?bgms))
              )
            (not (= ?bgmt ?bgms))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgmv Real)
        (declare-const ?bgmw Real)
        (declare-const ?bgmx Real)
        (assert
          (and (and (not (= ?bgmx ?bgmw))
              (not (= ?bgmx ?bgmv))
              )
            (not (= ?bgmw ?bgmv))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bgmy Real)
      (declare-const ?bgmz Real)
      (declare-const ?bgna Real)
      (push 1)
        (declare-const ?bgnb Real)
        (declare-const ?bgnc Real)
        (declare-const ?bgnd Real)
        (assert
          (and (and (not (= ?bgnd ?bgnc))
              (not (= ?bgnd ?bgnb))
              )
            (not (= ?bgnc ?bgnb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgne Real)
        (declare-const ?bgnf Real)
        (declare-const ?bgng Real)
        (declare-const ?bgnh Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bgnf ?bgne)
                    (= ?bgnf ?awmg)
                    )
                  (= ?bgne ?awmg)
                  )
                (or (or (= ?bgnh ?bgng)
                    (= ?bgnh ?awmg)
                    )
                  (= ?bgng ?awmg)
                  )
                )
              (and (not (= ?bgnf ?bgne))
                (and (and (not (= ?bgnh ?bgng))
                    (not (= ?bgnh ?awmg))
                    )
                  (not (= ?bgng ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgni Real)
        (declare-const ?bgnj Real)
        (declare-const ?bgnk Real)
        (assert
          (and (and (not (= ?bgnk ?bgnj))
              (not (= ?bgnk ?bgni))
              )
            (not (= ?bgnj ?bgni))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgnl Real)
        (declare-const ?bgnm Real)
        (declare-const ?bgnn Real)
        (declare-const ?bgno Real)
        (declare-const ?bgnp Real)
        (declare-const ?bgnq Real)
        (assert
          (or (and (or (or (= ?bgnn ?bgnm)
                  (= ?bgnn ?bgnl)
                  )
                (= ?bgnm ?bgnl)
                )
              (or (or (= ?bgnq ?bgnp)
                  (= ?bgnq ?bgno)
                  )
                (= ?bgnp ?bgno)
                )
              )
            (and (and (and (not (= ?bgnn ?bgnm))
                  (not (= ?bgnn ?bgnl))
                  )
                (not (= ?bgnm ?bgnl))
                )
              (and (and (not (= ?bgnq ?bgnp))
                  (not (= ?bgnq ?bgno))
                  )
                (not (= ?bgnp ?bgno))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgnr Real)
        (declare-const ?bgns Real)
        (declare-const ?bgnt Real)
        (assert
          (and (and (not (= ?bgnt ?bgns))
              (not (= ?bgnt ?bgnr))
              )
            (not (= ?bgns ?bgnr))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgnu Real)
        (declare-const ?bgnv Real)
        (declare-const ?bgnw Real)
        (assert
          (and (and (not (= ?bgnw ?bgnv))
              (not (= ?bgnw ?bgnu))
              )
            (not (= ?bgnv ?bgnu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (declare-const ?bgnx Real)
        (declare-const ?bgny Real)
        (declare-const ?bgnz Real)
        (assert
          (and (and (not (= ?bgnz ?bgny))
              (not (= ?bgnz ?bgnx))
              )
            (not (= ?bgny ?bgnx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgoa Real)
        (declare-const ?bgob Real)
        (declare-const ?bgoc Real)
        (declare-const ?bgod Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bgob ?bgoa)
                    (= ?bgob ?awmg)
                    )
                  (= ?bgoa ?awmg)
                  )
                (or (or (= ?bgod ?bgoc)
                    (= ?bgod ?awmg)
                    )
                  (= ?bgoc ?awmg)
                  )
                )
              (and (not (= ?bgob ?bgoa))
                (and (and (not (= ?bgod ?bgoc))
                    (not (= ?bgod ?awmg))
                    )
                  (not (= ?bgoc ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgoe Real)
        (declare-const ?bgof Real)
        (declare-const ?bgog Real)
        (assert
          (and (and (not (= ?bgog ?bgof))
              (not (= ?bgog ?bgoe))
              )
            (not (= ?bgof ?bgoe))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgoh Real)
        (declare-const ?bgoi Real)
        (declare-const ?bgoj Real)
        (declare-const ?bgok Real)
        (declare-const ?bgol Real)
        (declare-const ?bgom Real)
        (assert
          (or (and (or (or (= ?bgoj ?bgoi)
                  (= ?bgoj ?bgoh)
                  )
                (= ?bgoi ?bgoh)
                )
              (or (or (= ?bgom ?bgol)
                  (= ?bgom ?bgok)
                  )
                (= ?bgol ?bgok)
                )
              )
            (and (and (and (not (= ?bgoj ?bgoi))
                  (not (= ?bgoj ?bgoh))
                  )
                (not (= ?bgoi ?bgoh))
                )
              (and (and (not (= ?bgom ?bgol))
                  (not (= ?bgom ?bgok))
                  )
                (not (= ?bgol ?bgok))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgon Real)
        (declare-const ?bgoo Real)
        (declare-const ?bgop Real)
        (assert
          (and (and (not (= ?bgop ?bgoo))
              (not (= ?bgop ?bgon))
              )
            (not (= ?bgoo ?bgon))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgoq Real)
        (declare-const ?bgor Real)
        (declare-const ?bgos Real)
        (assert
          (and (and (not (= ?bgos ?bgor))
              (not (= ?bgos ?bgoq))
              )
            (not (= ?bgor ?bgoq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bgot Real)
    (declare-const ?bgou Real)
    (push 1)
      (push 1)
        (declare-const ?bgov Real)
        (declare-const ?bgow Real)
        (declare-const ?bgox Real)
        (assert
          (and (and (not (= ?bgox ?bgow))
              (not (= ?bgox ?bgov))
              )
            (not (= ?bgow ?bgov))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgoy Real)
        (declare-const ?bgoz Real)
        (declare-const ?bgpa Real)
        (declare-const ?bgpb Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bgoz ?bgoy)
                    (= ?bgoz ?awmg)
                    )
                  (= ?bgoy ?awmg)
                  )
                (or (or (= ?bgpb ?bgpa)
                    (= ?bgpb ?awmg)
                    )
                  (= ?bgpa ?awmg)
                  )
                )
              (and (not (= ?bgoz ?bgoy))
                (and (and (not (= ?bgpb ?bgpa))
                    (not (= ?bgpb ?awmg))
                    )
                  (not (= ?bgpa ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgpc Real)
        (declare-const ?bgpd Real)
        (declare-const ?bgpe Real)
        (assert
          (and (and (not (= ?bgpe ?bgpd))
              (not (= ?bgpe ?bgpc))
              )
            (not (= ?bgpd ?bgpc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgpf Real)
        (declare-const ?bgpg Real)
        (declare-const ?bgph Real)
        (declare-const ?bgpi Real)
        (declare-const ?bgpj Real)
        (declare-const ?bgpk Real)
        (assert
          (or (and (or (or (= ?bgph ?bgpg)
                  (= ?bgph ?bgpf)
                  )
                (= ?bgpg ?bgpf)
                )
              (or (or (= ?bgpk ?bgpj)
                  (= ?bgpk ?bgpi)
                  )
                (= ?bgpj ?bgpi)
                )
              )
            (and (and (and (not (= ?bgph ?bgpg))
                  (not (= ?bgph ?bgpf))
                  )
                (not (= ?bgpg ?bgpf))
                )
              (and (and (not (= ?bgpk ?bgpj))
                  (not (= ?bgpk ?bgpi))
                  )
                (not (= ?bgpj ?bgpi))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgpl Real)
        (declare-const ?bgpm Real)
        (declare-const ?bgpn Real)
        (assert
          (and (and (not (= ?bgpn ?bgpm))
              (not (= ?bgpn ?bgpl))
              )
            (not (= ?bgpm ?bgpl))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgpo Real)
        (declare-const ?bgpp Real)
        (declare-const ?bgpq Real)
        (assert
          (and (and (not (= ?bgpq ?bgpp))
              (not (= ?bgpq ?bgpo))
              )
            (not (= ?bgpp ?bgpo))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bgpr Real)
      (push 1)
        (declare-const ?bgps Real)
        (declare-const ?bgpt Real)
        (declare-const ?bgpu Real)
        (assert
          (and (and (not (= ?bgpu ?bgpt))
              (not (= ?bgpu ?bgps))
              )
            (not (= ?bgpt ?bgps))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgpv Real)
        (declare-const ?bgpw Real)
        (declare-const ?bgpx Real)
        (declare-const ?bgpy Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bgpw ?bgpv)
                    (= ?bgpw ?awmg)
                    )
                  (= ?bgpv ?awmg)
                  )
                (or (or (= ?bgpy ?bgpx)
                    (= ?bgpy ?awmg)
                    )
                  (= ?bgpx ?awmg)
                  )
                )
              (and (not (= ?bgpw ?bgpv))
                (and (and (not (= ?bgpy ?bgpx))
                    (not (= ?bgpy ?awmg))
                    )
                  (not (= ?bgpx ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgpz Real)
        (declare-const ?bgqa Real)
        (declare-const ?bgqb Real)
        (assert
          (and (and (not (= ?bgqb ?bgqa))
              (not (= ?bgqb ?bgpz))
              )
            (not (= ?bgqa ?bgpz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgqc Real)
        (declare-const ?bgqd Real)
        (declare-const ?bgqe Real)
        (declare-const ?bgqf Real)
        (declare-const ?bgqg Real)
        (declare-const ?bgqh Real)
        (assert
          (or (and (or (or (= ?bgqe ?bgqd)
                  (= ?bgqe ?bgqc)
                  )
                (= ?bgqd ?bgqc)
                )
              (or (or (= ?bgqh ?bgqg)
                  (= ?bgqh ?bgqf)
                  )
                (= ?bgqg ?bgqf)
                )
              )
            (and (and (and (not (= ?bgqe ?bgqd))
                  (not (= ?bgqe ?bgqc))
                  )
                (not (= ?bgqd ?bgqc))
                )
              (and (and (not (= ?bgqh ?bgqg))
                  (not (= ?bgqh ?bgqf))
                  )
                (not (= ?bgqg ?bgqf))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgqi Real)
        (declare-const ?bgqj Real)
        (declare-const ?bgqk Real)
        (assert
          (and (and (not (= ?bgqk ?bgqj))
              (not (= ?bgqk ?bgqi))
              )
            (not (= ?bgqj ?bgqi))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgql Real)
        (declare-const ?bgqm Real)
        (declare-const ?bgqn Real)
        (assert
          (and (and (not (= ?bgqn ?bgqm))
              (not (= ?bgqn ?bgql))
              )
            (not (= ?bgqm ?bgql))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bgqo Real)
      (declare-const ?bgqp Real)
      (push 1)
        (declare-const ?bgqq Real)
        (declare-const ?bgqr Real)
        (declare-const ?bgqs Real)
        (assert
          (and (and (not (= ?bgqs ?bgqr))
              (not (= ?bgqs ?bgqq))
              )
            (not (= ?bgqr ?bgqq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgqt Real)
        (declare-const ?bgqu Real)
        (declare-const ?bgqv Real)
        (declare-const ?bgqw Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bgqu ?bgqt)
                    (= ?bgqu ?awmg)
                    )
                  (= ?bgqt ?awmg)
                  )
                (or (or (= ?bgqw ?bgqv)
                    (= ?bgqw ?awmg)
                    )
                  (= ?bgqv ?awmg)
                  )
                )
              (and (not (= ?bgqu ?bgqt))
                (and (and (not (= ?bgqw ?bgqv))
                    (not (= ?bgqw ?awmg))
                    )
                  (not (= ?bgqv ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgqx Real)
        (declare-const ?bgqy Real)
        (declare-const ?bgqz Real)
        (assert
          (and (and (not (= ?bgqz ?bgqy))
              (not (= ?bgqz ?bgqx))
              )
            (not (= ?bgqy ?bgqx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgra Real)
        (declare-const ?bgrb Real)
        (declare-const ?bgrc Real)
        (declare-const ?bgrd Real)
        (declare-const ?bgre Real)
        (declare-const ?bgrf Real)
        (assert
          (or (and (or (or (= ?bgrc ?bgrb)
                  (= ?bgrc ?bgra)
                  )
                (= ?bgrb ?bgra)
                )
              (or (or (= ?bgrf ?bgre)
                  (= ?bgrf ?bgrd)
                  )
                (= ?bgre ?bgrd)
                )
              )
            (and (and (and (not (= ?bgrc ?bgrb))
                  (not (= ?bgrc ?bgra))
                  )
                (not (= ?bgrb ?bgra))
                )
              (and (and (not (= ?bgrf ?bgre))
                  (not (= ?bgrf ?bgrd))
                  )
                (not (= ?bgre ?bgrd))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgrg Real)
        (declare-const ?bgrh Real)
        (declare-const ?bgri Real)
        (assert
          (and (and (not (= ?bgri ?bgrh))
              (not (= ?bgri ?bgrg))
              )
            (not (= ?bgrh ?bgrg))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgrj Real)
        (declare-const ?bgrk Real)
        (declare-const ?bgrl Real)
        (assert
          (and (and (not (= ?bgrl ?bgrk))
              (not (= ?bgrl ?bgrj))
              )
            (not (= ?bgrk ?bgrj))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bgqp ?bgqo)
                    (= ?bgqp ?awmg)
                    )
                  (= ?bgqo ?awmg)
                  )
                (or (or (= ?bgou ?bgot)
                    (= ?bgou ?awmg)
                    )
                  (= ?bgot ?awmg)
                  )
                )
              (and (not (= ?bgqp ?bgqo))
                (and (and (not (= ?bgou ?bgot))
                    (not (= ?bgou ?awmg))
                    )
                  (not (= ?bgot ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bgrm Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bgrn Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bgro Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgrp Real)
              (declare-const ?bgrq Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgrr Real)
              (declare-const ?bgrs Real)
              (declare-const ?bgrt Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgru Real)
              (declare-const ?bgrv Real)
              (declare-const ?bgrw Real)
              (declare-const ?bgrx Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgry Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bgrz Real)
            (declare-const ?bgsa Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bgsb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgsc Real)
              (declare-const ?bgsd Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgse Real)
              (declare-const ?bgsf Real)
              (declare-const ?bgsg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgsh Real)
              (declare-const ?bgsi Real)
              (declare-const ?bgsj Real)
              (declare-const ?bgsk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgsl Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bgsm Real)
            (declare-const ?bgsn Real)
            (declare-const ?bgso Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bgsp Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgsq Real)
              (declare-const ?bgsr Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgss Real)
              (declare-const ?bgst Real)
              (declare-const ?bgsu Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (and (and (= ?bgsn ?bgou)
                          (= ?bgsm ?bgot)
                          )
                        (= ?bgso ?bgrm)
                        )
                      (and (= ?bgst ?bgqp)
                        (= ?bgss ?bgqo)
                        )
                      )
                    (= ?bgsu ?bgrm)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgsv Real)
                  (declare-const ?bgsw Real)
                  (declare-const ?bgsx Real)
                  (assert
                    (and (and (not (= ?bgsx ?bgsw))
                        (not (= ?bgsx ?bgsv))
                        )
                      (not (= ?bgsw ?bgsv))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgsy Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgsz Real)
                  (declare-const ?bgta Real)
                  (declare-const ?bgtb Real)
                  (declare-const ?bgtc Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bgta ?bgsz)
                              (= ?bgta ?awmg)
                              )
                            (= ?bgsz ?awmg)
                            )
                          (or (or (= ?bgtc ?bgtb)
                              (= ?bgtc ?awmg)
                              )
                            (= ?bgtb ?awmg)
                            )
                          )
                        (and (not (= ?bgta ?bgsz))
                          (and (and (not (= ?bgtc ?bgtb))
                              (not (= ?bgtc ?awmg))
                              )
                            (not (= ?bgtb ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgtd Real)
                  (declare-const ?bgte Real)
                  (declare-const ?bgtf Real)
                  (assert
                    (and (and (not (= ?bgtf ?bgte))
                        (not (= ?bgtf ?bgtd))
                        )
                      (not (= ?bgte ?bgtd))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgtg Real)
                  (declare-const ?bgth Real)
                  (declare-const ?bgti Real)
                  (declare-const ?bgtj Real)
                  (declare-const ?bgtk Real)
                  (declare-const ?bgtl Real)
                  (assert
                    (or (and (or (or (= ?bgti ?bgth)
                            (= ?bgti ?bgtg)
                            )
                          (= ?bgth ?bgtg)
                          )
                        (or (or (= ?bgtl ?bgtk)
                            (= ?bgtl ?bgtj)
                            )
                          (= ?bgtk ?bgtj)
                          )
                        )
                      (and (and (and (not (= ?bgti ?bgth))
                            (not (= ?bgti ?bgtg))
                            )
                          (not (= ?bgth ?bgtg))
                          )
                        (and (and (not (= ?bgtl ?bgtk))
                            (not (= ?bgtl ?bgtj))
                            )
                          (not (= ?bgtk ?bgtj))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgtm Real)
                  (declare-const ?bgtn Real)
                  (declare-const ?bgto Real)
                  (assert
                    (and (and (not (= ?bgto ?bgtn))
                        (not (= ?bgto ?bgtm))
                        )
                      (not (= ?bgtn ?bgtm))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgtp Real)
                  (declare-const ?bgtq Real)
                  (declare-const ?bgtr Real)
                  (assert
                    (and (and (not (= ?bgtr ?bgtq))
                        (not (= ?bgtr ?bgtp))
                        )
                      (not (= ?bgtq ?bgtp))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (assert
                    (and (or (and (and (not (= ?bgst ?bgss))
                            (not (= ?bgst ?bgsu))
                            )
                          (not (= ?bgss ?bgsu))
                          )
                        (and (and (not (= ?bgsn ?bgsm))
                            (not (= ?bgsn ?bgso))
                            )
                          (not (= ?bgsm ?bgso))
                          )
                        )
                      (or (or (or (= ?bgst ?bgss)
                            (= ?bgst ?bgsu)
                            )
                          (= ?bgss ?bgsu)
                          )
                        (or (or (= ?bgsn ?bgsm)
                            (= ?bgsn ?bgso)
                            )
                          (= ?bgsm ?bgso)
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?bgts Real)
              (declare-const ?bgtt Real)
              (declare-const ?bgtu Real)
              (declare-const ?bgtv Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgtw Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bgtx Real)
            (declare-const ?bgty Real)
            (declare-const ?bgtz Real)
            (declare-const ?bgua Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bgub Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bguc Real)
              (declare-const ?bgud Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgue Real)
              (declare-const ?bguf Real)
              (declare-const ?bgug Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bguh Real)
              (declare-const ?bgui Real)
              (declare-const ?bguj Real)
              (declare-const ?bguk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgul Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bgum Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bgun Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bguo Real)
              (declare-const ?bgup Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bguq Real)
              (declare-const ?bgur Real)
              (declare-const ?bgus Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgut Real)
              (declare-const ?bguu Real)
              (declare-const ?bguv Real)
              (declare-const ?bguw Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgux Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bguy Real)
      (declare-const ?bguz Real)
      (declare-const ?bgva Real)
      (push 1)
        (declare-const ?bgvb Real)
        (declare-const ?bgvc Real)
        (declare-const ?bgvd Real)
        (assert
          (and (and (not (= ?bgvd ?bgvc))
              (not (= ?bgvd ?bgvb))
              )
            (not (= ?bgvc ?bgvb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgve Real)
        (declare-const ?bgvf Real)
        (declare-const ?bgvg Real)
        (declare-const ?bgvh Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bgvf ?bgve)
                    (= ?bgvf ?awmg)
                    )
                  (= ?bgve ?awmg)
                  )
                (or (or (= ?bgvh ?bgvg)
                    (= ?bgvh ?awmg)
                    )
                  (= ?bgvg ?awmg)
                  )
                )
              (and (not (= ?bgvf ?bgve))
                (and (and (not (= ?bgvh ?bgvg))
                    (not (= ?bgvh ?awmg))
                    )
                  (not (= ?bgvg ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgvi Real)
        (declare-const ?bgvj Real)
        (declare-const ?bgvk Real)
        (assert
          (and (and (not (= ?bgvk ?bgvj))
              (not (= ?bgvk ?bgvi))
              )
            (not (= ?bgvj ?bgvi))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgvl Real)
        (declare-const ?bgvm Real)
        (declare-const ?bgvn Real)
        (declare-const ?bgvo Real)
        (declare-const ?bgvp Real)
        (declare-const ?bgvq Real)
        (assert
          (or (and (or (or (= ?bgvn ?bgvm)
                  (= ?bgvn ?bgvl)
                  )
                (= ?bgvm ?bgvl)
                )
              (or (or (= ?bgvq ?bgvp)
                  (= ?bgvq ?bgvo)
                  )
                (= ?bgvp ?bgvo)
                )
              )
            (and (and (and (not (= ?bgvn ?bgvm))
                  (not (= ?bgvn ?bgvl))
                  )
                (not (= ?bgvm ?bgvl))
                )
              (and (and (not (= ?bgvq ?bgvp))
                  (not (= ?bgvq ?bgvo))
                  )
                (not (= ?bgvp ?bgvo))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgvr Real)
        (declare-const ?bgvs Real)
        (declare-const ?bgvt Real)
        (assert
          (and (and (not (= ?bgvt ?bgvs))
              (not (= ?bgvt ?bgvr))
              )
            (not (= ?bgvs ?bgvr))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgvu Real)
        (declare-const ?bgvv Real)
        (declare-const ?bgvw Real)
        (assert
          (and (and (not (= ?bgvw ?bgvv))
              (not (= ?bgvw ?bgvu))
              )
            (not (= ?bgvv ?bgvu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (declare-const ?bgvx Real)
        (declare-const ?bgvy Real)
        (declare-const ?bgvz Real)
        (assert
          (and (and (not (= ?bgvz ?bgvy))
              (not (= ?bgvz ?bgvx))
              )
            (not (= ?bgvy ?bgvx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgwa Real)
        (declare-const ?bgwb Real)
        (declare-const ?bgwc Real)
        (declare-const ?bgwd Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bgwb ?bgwa)
                    (= ?bgwb ?awmg)
                    )
                  (= ?bgwa ?awmg)
                  )
                (or (or (= ?bgwd ?bgwc)
                    (= ?bgwd ?awmg)
                    )
                  (= ?bgwc ?awmg)
                  )
                )
              (and (not (= ?bgwb ?bgwa))
                (and (and (not (= ?bgwd ?bgwc))
                    (not (= ?bgwd ?awmg))
                    )
                  (not (= ?bgwc ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgwe Real)
        (declare-const ?bgwf Real)
        (declare-const ?bgwg Real)
        (assert
          (and (and (not (= ?bgwg ?bgwf))
              (not (= ?bgwg ?bgwe))
              )
            (not (= ?bgwf ?bgwe))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgwh Real)
        (declare-const ?bgwi Real)
        (declare-const ?bgwj Real)
        (declare-const ?bgwk Real)
        (declare-const ?bgwl Real)
        (declare-const ?bgwm Real)
        (assert
          (or (and (or (or (= ?bgwj ?bgwi)
                  (= ?bgwj ?bgwh)
                  )
                (= ?bgwi ?bgwh)
                )
              (or (or (= ?bgwm ?bgwl)
                  (= ?bgwm ?bgwk)
                  )
                (= ?bgwl ?bgwk)
                )
              )
            (and (and (and (not (= ?bgwj ?bgwi))
                  (not (= ?bgwj ?bgwh))
                  )
                (not (= ?bgwi ?bgwh))
                )
              (and (and (not (= ?bgwm ?bgwl))
                  (not (= ?bgwm ?bgwk))
                  )
                (not (= ?bgwl ?bgwk))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgwn Real)
        (declare-const ?bgwo Real)
        (declare-const ?bgwp Real)
        (assert
          (and (and (not (= ?bgwp ?bgwo))
              (not (= ?bgwp ?bgwn))
              )
            (not (= ?bgwo ?bgwn))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgwq Real)
        (declare-const ?bgwr Real)
        (declare-const ?bgws Real)
        (assert
          (and (and (not (= ?bgws ?bgwr))
              (not (= ?bgws ?bgwq))
              )
            (not (= ?bgwr ?bgwq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bgwt Real)
    (declare-const ?bgwu Real)
    (declare-const ?bgwv Real)
    (push 1)
      (push 1)
        (declare-const ?bgww Real)
        (declare-const ?bgwx Real)
        (declare-const ?bgwy Real)
        (assert
          (and (and (not (= ?bgwy ?bgwx))
              (not (= ?bgwy ?bgww))
              )
            (not (= ?bgwx ?bgww))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgwz Real)
        (declare-const ?bgxa Real)
        (declare-const ?bgxb Real)
        (declare-const ?bgxc Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bgxa ?bgwz)
                    (= ?bgxa ?awmg)
                    )
                  (= ?bgwz ?awmg)
                  )
                (or (or (= ?bgxc ?bgxb)
                    (= ?bgxc ?awmg)
                    )
                  (= ?bgxb ?awmg)
                  )
                )
              (and (not (= ?bgxa ?bgwz))
                (and (and (not (= ?bgxc ?bgxb))
                    (not (= ?bgxc ?awmg))
                    )
                  (not (= ?bgxb ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgxd Real)
        (declare-const ?bgxe Real)
        (declare-const ?bgxf Real)
        (assert
          (and (and (not (= ?bgxf ?bgxe))
              (not (= ?bgxf ?bgxd))
              )
            (not (= ?bgxe ?bgxd))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgxg Real)
        (declare-const ?bgxh Real)
        (declare-const ?bgxi Real)
        (declare-const ?bgxj Real)
        (declare-const ?bgxk Real)
        (declare-const ?bgxl Real)
        (assert
          (or (and (or (or (= ?bgxi ?bgxh)
                  (= ?bgxi ?bgxg)
                  )
                (= ?bgxh ?bgxg)
                )
              (or (or (= ?bgxl ?bgxk)
                  (= ?bgxl ?bgxj)
                  )
                (= ?bgxk ?bgxj)
                )
              )
            (and (and (and (not (= ?bgxi ?bgxh))
                  (not (= ?bgxi ?bgxg))
                  )
                (not (= ?bgxh ?bgxg))
                )
              (and (and (not (= ?bgxl ?bgxk))
                  (not (= ?bgxl ?bgxj))
                  )
                (not (= ?bgxk ?bgxj))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgxm Real)
        (declare-const ?bgxn Real)
        (declare-const ?bgxo Real)
        (assert
          (and (and (not (= ?bgxo ?bgxn))
              (not (= ?bgxo ?bgxm))
              )
            (not (= ?bgxn ?bgxm))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bgxp Real)
        (declare-const ?bgxq Real)
        (declare-const ?bgxr Real)
        (assert
          (and (and (not (= ?bgxr ?bgxq))
              (not (= ?bgxr ?bgxp))
              )
            (not (= ?bgxq ?bgxp))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?bgwv ?bgwu))
              (not (= ?bgwv ?bgwt))
              )
            (not (= ?bgwu ?bgwt))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bgxs Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bgxt Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bgxu Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgxv Real)
              (declare-const ?bgxw Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgxx Real)
              (declare-const ?bgxy Real)
              (declare-const ?bgxz Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgya Real)
              (declare-const ?bgyb Real)
              (declare-const ?bgyc Real)
              (declare-const ?bgyd Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgye Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bgyf Real)
            (declare-const ?bgyg Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bgyh Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgyi Real)
              (declare-const ?bgyj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgyk Real)
              (declare-const ?bgyl Real)
              (declare-const ?bgym Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgyn Real)
              (declare-const ?bgyo Real)
              (declare-const ?bgyp Real)
              (declare-const ?bgyq Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgyr Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bgys Real)
            (declare-const ?bgyt Real)
            (declare-const ?bgyu Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bgyv Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgyw Real)
              (declare-const ?bgyx Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgyy Real)
              (declare-const ?bgyz Real)
              (declare-const ?bgza Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgzb Real)
              (declare-const ?bgzc Real)
              (declare-const ?bgzd Real)
              (declare-const ?bgze Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bgzf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bgzg Real)
            (declare-const ?bgzh Real)
            (declare-const ?bgzi Real)
            (declare-const ?bgzj Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bgzk Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (and (and (= ?bgzi ?bgwv)
                          (= ?bgzh ?bgwu)
                          )
                        (= ?bgzg ?bgwt)
                        )
                      (= ?bgzj ?bgxs)
                      )
                    (= ?bgzk ?bgxs)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgzl Real)
                  (declare-const ?bgzm Real)
                  (declare-const ?bgzn Real)
                  (assert
                    (and (and (not (= ?bgzn ?bgzm))
                        (not (= ?bgzn ?bgzl))
                        )
                      (not (= ?bgzm ?bgzl))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgzo Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgzp Real)
                  (declare-const ?bgzq Real)
                  (declare-const ?bgzr Real)
                  (declare-const ?bgzs Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bgzq ?bgzp)
                              (= ?bgzq ?awmg)
                              )
                            (= ?bgzp ?awmg)
                            )
                          (or (or (= ?bgzs ?bgzr)
                              (= ?bgzs ?awmg)
                              )
                            (= ?bgzr ?awmg)
                            )
                          )
                        (and (not (= ?bgzq ?bgzp))
                          (and (and (not (= ?bgzs ?bgzr))
                              (not (= ?bgzs ?awmg))
                              )
                            (not (= ?bgzr ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgzt Real)
                  (declare-const ?bgzu Real)
                  (declare-const ?bgzv Real)
                  (assert
                    (and (and (not (= ?bgzv ?bgzu))
                        (not (= ?bgzv ?bgzt))
                        )
                      (not (= ?bgzu ?bgzt))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bgzw Real)
                  (declare-const ?bgzx Real)
                  (declare-const ?bgzy Real)
                  (declare-const ?bgzz Real)
                  (declare-const ?bhaa Real)
                  (declare-const ?bhab Real)
                  (assert
                    (or (and (or (or (= ?bgzy ?bgzx)
                            (= ?bgzy ?bgzw)
                            )
                          (= ?bgzx ?bgzw)
                          )
                        (or (or (= ?bhab ?bhaa)
                            (= ?bhab ?bgzz)
                            )
                          (= ?bhaa ?bgzz)
                          )
                        )
                      (and (and (and (not (= ?bgzy ?bgzx))
                            (not (= ?bgzy ?bgzw))
                            )
                          (not (= ?bgzx ?bgzw))
                          )
                        (and (and (not (= ?bhab ?bhaa))
                            (not (= ?bhab ?bgzz))
                            )
                          (not (= ?bhaa ?bgzz))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhac Real)
                  (declare-const ?bhad Real)
                  (declare-const ?bhae Real)
                  (assert
                    (and (and (not (= ?bhae ?bhad))
                        (not (= ?bhae ?bhac))
                        )
                      (not (= ?bhad ?bhac))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhaf Real)
                  (declare-const ?bhag Real)
                  (declare-const ?bhah Real)
                  (assert
                    (and (and (not (= ?bhah ?bhag))
                        (not (= ?bhah ?bhaf))
                        )
                      (not (= ?bhag ?bhaf))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?bhai Real)
              (declare-const ?bhaj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhak Real)
              (declare-const ?bhal Real)
              (declare-const ?bham Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhan Real)
              (declare-const ?bhao Real)
              (declare-const ?bhap Real)
              (declare-const ?bhaq Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhar Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bhas Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bhat Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhau Real)
              (declare-const ?bhav Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhaw Real)
              (declare-const ?bhax Real)
              (declare-const ?bhay Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhaz Real)
              (declare-const ?bhba Real)
              (declare-const ?bhbb Real)
              (declare-const ?bhbc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhbd Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bhbe Real)
      (push 1)
        (declare-const ?bhbf Real)
        (declare-const ?bhbg Real)
        (declare-const ?bhbh Real)
        (assert
          (and (and (not (= ?bhbh ?bhbg))
              (not (= ?bhbh ?bhbf))
              )
            (not (= ?bhbg ?bhbf))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhbi Real)
        (declare-const ?bhbj Real)
        (declare-const ?bhbk Real)
        (declare-const ?bhbl Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bhbj ?bhbi)
                    (= ?bhbj ?awmg)
                    )
                  (= ?bhbi ?awmg)
                  )
                (or (or (= ?bhbl ?bhbk)
                    (= ?bhbl ?awmg)
                    )
                  (= ?bhbk ?awmg)
                  )
                )
              (and (not (= ?bhbj ?bhbi))
                (and (and (not (= ?bhbl ?bhbk))
                    (not (= ?bhbl ?awmg))
                    )
                  (not (= ?bhbk ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhbm Real)
        (declare-const ?bhbn Real)
        (declare-const ?bhbo Real)
        (assert
          (and (and (not (= ?bhbo ?bhbn))
              (not (= ?bhbo ?bhbm))
              )
            (not (= ?bhbn ?bhbm))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhbp Real)
        (declare-const ?bhbq Real)
        (declare-const ?bhbr Real)
        (declare-const ?bhbs Real)
        (declare-const ?bhbt Real)
        (declare-const ?bhbu Real)
        (assert
          (or (and (or (or (= ?bhbr ?bhbq)
                  (= ?bhbr ?bhbp)
                  )
                (= ?bhbq ?bhbp)
                )
              (or (or (= ?bhbu ?bhbt)
                  (= ?bhbu ?bhbs)
                  )
                (= ?bhbt ?bhbs)
                )
              )
            (and (and (and (not (= ?bhbr ?bhbq))
                  (not (= ?bhbr ?bhbp))
                  )
                (not (= ?bhbq ?bhbp))
                )
              (and (and (not (= ?bhbu ?bhbt))
                  (not (= ?bhbu ?bhbs))
                  )
                (not (= ?bhbt ?bhbs))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhbv Real)
        (declare-const ?bhbw Real)
        (declare-const ?bhbx Real)
        (assert
          (and (and (not (= ?bhbx ?bhbw))
              (not (= ?bhbx ?bhbv))
              )
            (not (= ?bhbw ?bhbv))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhby Real)
        (declare-const ?bhbz Real)
        (declare-const ?bhca Real)
        (assert
          (and (and (not (= ?bhca ?bhbz))
              (not (= ?bhca ?bhby))
              )
            (not (= ?bhbz ?bhby))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bhcb Real)
      (declare-const ?bhcc Real)
      (push 1)
        (declare-const ?bhcd Real)
        (declare-const ?bhce Real)
        (declare-const ?bhcf Real)
        (assert
          (and (and (not (= ?bhcf ?bhce))
              (not (= ?bhcf ?bhcd))
              )
            (not (= ?bhce ?bhcd))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhcg Real)
        (declare-const ?bhch Real)
        (declare-const ?bhci Real)
        (declare-const ?bhcj Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bhch ?bhcg)
                    (= ?bhch ?awmg)
                    )
                  (= ?bhcg ?awmg)
                  )
                (or (or (= ?bhcj ?bhci)
                    (= ?bhcj ?awmg)
                    )
                  (= ?bhci ?awmg)
                  )
                )
              (and (not (= ?bhch ?bhcg))
                (and (and (not (= ?bhcj ?bhci))
                    (not (= ?bhcj ?awmg))
                    )
                  (not (= ?bhci ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhck Real)
        (declare-const ?bhcl Real)
        (declare-const ?bhcm Real)
        (assert
          (and (and (not (= ?bhcm ?bhcl))
              (not (= ?bhcm ?bhck))
              )
            (not (= ?bhcl ?bhck))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhcn Real)
        (declare-const ?bhco Real)
        (declare-const ?bhcp Real)
        (declare-const ?bhcq Real)
        (declare-const ?bhcr Real)
        (declare-const ?bhcs Real)
        (assert
          (or (and (or (or (= ?bhcp ?bhco)
                  (= ?bhcp ?bhcn)
                  )
                (= ?bhco ?bhcn)
                )
              (or (or (= ?bhcs ?bhcr)
                  (= ?bhcs ?bhcq)
                  )
                (= ?bhcr ?bhcq)
                )
              )
            (and (and (and (not (= ?bhcp ?bhco))
                  (not (= ?bhcp ?bhcn))
                  )
                (not (= ?bhco ?bhcn))
                )
              (and (and (not (= ?bhcs ?bhcr))
                  (not (= ?bhcs ?bhcq))
                  )
                (not (= ?bhcr ?bhcq))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhct Real)
        (declare-const ?bhcu Real)
        (declare-const ?bhcv Real)
        (assert
          (and (and (not (= ?bhcv ?bhcu))
              (not (= ?bhcv ?bhct))
              )
            (not (= ?bhcu ?bhct))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhcw Real)
        (declare-const ?bhcx Real)
        (declare-const ?bhcy Real)
        (assert
          (and (and (not (= ?bhcy ?bhcx))
              (not (= ?bhcy ?bhcw))
              )
            (not (= ?bhcx ?bhcw))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bhcz Real)
      (declare-const ?bhda Real)
      (declare-const ?bhdb Real)
      (push 1)
        (declare-const ?bhdc Real)
        (declare-const ?bhdd Real)
        (declare-const ?bhde Real)
        (assert
          (and (and (not (= ?bhde ?bhdd))
              (not (= ?bhde ?bhdc))
              )
            (not (= ?bhdd ?bhdc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhdf Real)
        (declare-const ?bhdg Real)
        (declare-const ?bhdh Real)
        (declare-const ?bhdi Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bhdg ?bhdf)
                    (= ?bhdg ?awmg)
                    )
                  (= ?bhdf ?awmg)
                  )
                (or (or (= ?bhdi ?bhdh)
                    (= ?bhdi ?awmg)
                    )
                  (= ?bhdh ?awmg)
                  )
                )
              (and (not (= ?bhdg ?bhdf))
                (and (and (not (= ?bhdi ?bhdh))
                    (not (= ?bhdi ?awmg))
                    )
                  (not (= ?bhdh ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhdj Real)
        (declare-const ?bhdk Real)
        (declare-const ?bhdl Real)
        (assert
          (and (and (not (= ?bhdl ?bhdk))
              (not (= ?bhdl ?bhdj))
              )
            (not (= ?bhdk ?bhdj))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhdm Real)
        (declare-const ?bhdn Real)
        (declare-const ?bhdo Real)
        (declare-const ?bhdp Real)
        (declare-const ?bhdq Real)
        (declare-const ?bhdr Real)
        (assert
          (or (and (or (or (= ?bhdo ?bhdn)
                  (= ?bhdo ?bhdm)
                  )
                (= ?bhdn ?bhdm)
                )
              (or (or (= ?bhdr ?bhdq)
                  (= ?bhdr ?bhdp)
                  )
                (= ?bhdq ?bhdp)
                )
              )
            (and (and (and (not (= ?bhdo ?bhdn))
                  (not (= ?bhdo ?bhdm))
                  )
                (not (= ?bhdn ?bhdm))
                )
              (and (and (not (= ?bhdr ?bhdq))
                  (not (= ?bhdr ?bhdp))
                  )
                (not (= ?bhdq ?bhdp))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhds Real)
        (declare-const ?bhdt Real)
        (declare-const ?bhdu Real)
        (assert
          (and (and (not (= ?bhdu ?bhdt))
              (not (= ?bhdu ?bhds))
              )
            (not (= ?bhdt ?bhds))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhdv Real)
        (declare-const ?bhdw Real)
        (declare-const ?bhdx Real)
        (assert
          (and (and (not (= ?bhdx ?bhdw))
              (not (= ?bhdx ?bhdv))
              )
            (not (= ?bhdw ?bhdv))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (or (and (or (or (= ?bhdb ?bhda)
                  (= ?bhdb ?bhcz)
                  )
                (= ?bhda ?bhcz)
                )
              (or (or (= ?bgwv ?bgwu)
                  (= ?bgwv ?bgwt)
                  )
                (= ?bgwu ?bgwt)
                )
              )
            (and (and (and (not (= ?bhdb ?bhda))
                  (not (= ?bhdb ?bhcz))
                  )
                (not (= ?bhda ?bhcz))
                )
              (and (and (not (= ?bgwv ?bgwu))
                  (not (= ?bgwv ?bgwt))
                  )
                (not (= ?bgwu ?bgwt))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bhdy Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bhdz Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bhea Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bheb Real)
              (declare-const ?bhec Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhed Real)
              (declare-const ?bhee Real)
              (declare-const ?bhef Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bheg Real)
              (declare-const ?bheh Real)
              (declare-const ?bhei Real)
              (declare-const ?bhej Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhek Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bhel Real)
            (declare-const ?bhem Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bhen Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bheo Real)
              (declare-const ?bhep Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bheq Real)
              (declare-const ?bher Real)
              (declare-const ?bhes Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhet Real)
              (declare-const ?bheu Real)
              (declare-const ?bhev Real)
              (declare-const ?bhew Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhex Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bhey Real)
            (declare-const ?bhez Real)
            (declare-const ?bhfa Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bhfb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhfc Real)
              (declare-const ?bhfd Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhfe Real)
              (declare-const ?bhff Real)
              (declare-const ?bhfg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhfh Real)
              (declare-const ?bhfi Real)
              (declare-const ?bhfj Real)
              (declare-const ?bhfk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhfl Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bhfm Real)
            (declare-const ?bhfn Real)
            (declare-const ?bhfo Real)
            (declare-const ?bhfp Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bhfq Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhfr Real)
              (declare-const ?bhfs Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhft Real)
              (declare-const ?bhfu Real)
              (declare-const ?bhfv Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhfw Real)
              (declare-const ?bhfx Real)
              (declare-const ?bhfy Real)
              (declare-const ?bhfz Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (and (and (and (= ?bhfo ?bgwv)
                            (= ?bhfn ?bgwu)
                            )
                          (= ?bhfm ?bgwt)
                          )
                        (= ?bhfp ?bhdy)
                        )
                      (and (and (= ?bhfy ?bhdb)
                          (= ?bhfx ?bhda)
                          )
                        (= ?bhfw ?bhcz)
                        )
                      )
                    (= ?bhfz ?bhdy)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhga Real)
                  (declare-const ?bhgb Real)
                  (declare-const ?bhgc Real)
                  (assert
                    (and (and (not (= ?bhgc ?bhgb))
                        (not (= ?bhgc ?bhga))
                        )
                      (not (= ?bhgb ?bhga))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhgd Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhge Real)
                  (declare-const ?bhgf Real)
                  (declare-const ?bhgg Real)
                  (declare-const ?bhgh Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bhgf ?bhge)
                              (= ?bhgf ?awmg)
                              )
                            (= ?bhge ?awmg)
                            )
                          (or (or (= ?bhgh ?bhgg)
                              (= ?bhgh ?awmg)
                              )
                            (= ?bhgg ?awmg)
                            )
                          )
                        (and (not (= ?bhgf ?bhge))
                          (and (and (not (= ?bhgh ?bhgg))
                              (not (= ?bhgh ?awmg))
                              )
                            (not (= ?bhgg ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhgi Real)
                  (declare-const ?bhgj Real)
                  (declare-const ?bhgk Real)
                  (assert
                    (and (and (not (= ?bhgk ?bhgj))
                        (not (= ?bhgk ?bhgi))
                        )
                      (not (= ?bhgj ?bhgi))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhgl Real)
                  (declare-const ?bhgm Real)
                  (declare-const ?bhgn Real)
                  (declare-const ?bhgo Real)
                  (declare-const ?bhgp Real)
                  (declare-const ?bhgq Real)
                  (assert
                    (or (and (or (or (= ?bhgn ?bhgm)
                            (= ?bhgn ?bhgl)
                            )
                          (= ?bhgm ?bhgl)
                          )
                        (or (or (= ?bhgq ?bhgp)
                            (= ?bhgq ?bhgo)
                            )
                          (= ?bhgp ?bhgo)
                          )
                        )
                      (and (and (and (not (= ?bhgn ?bhgm))
                            (not (= ?bhgn ?bhgl))
                            )
                          (not (= ?bhgm ?bhgl))
                          )
                        (and (and (not (= ?bhgq ?bhgp))
                            (not (= ?bhgq ?bhgo))
                            )
                          (not (= ?bhgp ?bhgo))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhgr Real)
                  (declare-const ?bhgs Real)
                  (declare-const ?bhgt Real)
                  (assert
                    (and (and (not (= ?bhgt ?bhgs))
                        (not (= ?bhgt ?bhgr))
                        )
                      (not (= ?bhgs ?bhgr))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhgu Real)
                  (declare-const ?bhgv Real)
                  (declare-const ?bhgw Real)
                  (assert
                    (and (and (not (= ?bhgw ?bhgv))
                        (not (= ?bhgw ?bhgu))
                        )
                      (not (= ?bhgv ?bhgu))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?bhgx Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bhgy Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bhgz Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhha Real)
              (declare-const ?bhhb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhhc Real)
              (declare-const ?bhhd Real)
              (declare-const ?bhhe Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhhf Real)
              (declare-const ?bhhg Real)
              (declare-const ?bhhh Real)
              (declare-const ?bhhi Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhhj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (declare-const ?bhhk Real)
        (declare-const ?bhhl Real)
        (declare-const ?bhhm Real)
        (assert
          (and (and (not (= ?bhhm ?bhhl))
              (not (= ?bhhm ?bhhk))
              )
            (not (= ?bhhl ?bhhk))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhhn Real)
        (declare-const ?bhho Real)
        (declare-const ?bhhp Real)
        (declare-const ?bhhq Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bhho ?bhhn)
                    (= ?bhho ?awmg)
                    )
                  (= ?bhhn ?awmg)
                  )
                (or (or (= ?bhhq ?bhhp)
                    (= ?bhhq ?awmg)
                    )
                  (= ?bhhp ?awmg)
                  )
                )
              (and (not (= ?bhho ?bhhn))
                (and (and (not (= ?bhhq ?bhhp))
                    (not (= ?bhhq ?awmg))
                    )
                  (not (= ?bhhp ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhhr Real)
        (declare-const ?bhhs Real)
        (declare-const ?bhht Real)
        (assert
          (and (and (not (= ?bhht ?bhhs))
              (not (= ?bhht ?bhhr))
              )
            (not (= ?bhhs ?bhhr))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhhu Real)
        (declare-const ?bhhv Real)
        (declare-const ?bhhw Real)
        (declare-const ?bhhx Real)
        (declare-const ?bhhy Real)
        (declare-const ?bhhz Real)
        (assert
          (or (and (or (or (= ?bhhw ?bhhv)
                  (= ?bhhw ?bhhu)
                  )
                (= ?bhhv ?bhhu)
                )
              (or (or (= ?bhhz ?bhhy)
                  (= ?bhhz ?bhhx)
                  )
                (= ?bhhy ?bhhx)
                )
              )
            (and (and (and (not (= ?bhhw ?bhhv))
                  (not (= ?bhhw ?bhhu))
                  )
                (not (= ?bhhv ?bhhu))
                )
              (and (and (not (= ?bhhz ?bhhy))
                  (not (= ?bhhz ?bhhx))
                  )
                (not (= ?bhhy ?bhhx))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhia Real)
        (declare-const ?bhib Real)
        (declare-const ?bhic Real)
        (assert
          (and (and (not (= ?bhic ?bhib))
              (not (= ?bhic ?bhia))
              )
            (not (= ?bhib ?bhia))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhid Real)
        (declare-const ?bhie Real)
        (declare-const ?bhif Real)
        (assert
          (and (and (not (= ?bhif ?bhie))
              (not (= ?bhif ?bhid))
              )
            (not (= ?bhie ?bhid))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?bgwv ?bgwu))
              (not (= ?bgwv ?bgwt))
              )
            (not (= ?bgwu ?bgwt))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bhig Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bhih Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bhii Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhij Real)
              (declare-const ?bhik Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhil Real)
              (declare-const ?bhim Real)
              (declare-const ?bhin Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhio Real)
              (declare-const ?bhip Real)
              (declare-const ?bhiq Real)
              (declare-const ?bhir Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhis Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bhit Real)
            (declare-const ?bhiu Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bhiv Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhiw Real)
              (declare-const ?bhix Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhiy Real)
              (declare-const ?bhiz Real)
              (declare-const ?bhja Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhjb Real)
              (declare-const ?bhjc Real)
              (declare-const ?bhjd Real)
              (declare-const ?bhje Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhjf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bhjg Real)
            (declare-const ?bhjh Real)
            (declare-const ?bhji Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bhjj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhjk Real)
              (declare-const ?bhjl Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhjm Real)
              (declare-const ?bhjn Real)
              (declare-const ?bhjo Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhjp Real)
              (declare-const ?bhjq Real)
              (declare-const ?bhjr Real)
              (declare-const ?bhjs Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhjt Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bhju Real)
            (declare-const ?bhjv Real)
            (declare-const ?bhjw Real)
            (declare-const ?bhjx Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bhjy Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhjz Real)
              (declare-const ?bhka Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhkb Real)
              (declare-const ?bhkc Real)
              (declare-const ?bhkd Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhke Real)
              (declare-const ?bhkf Real)
              (declare-const ?bhkg Real)
              (declare-const ?bhkh Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhki Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (and (and (= ?bhjw ?bgwv)
                          (= ?bhjv ?bgwu)
                          )
                        (= ?bhju ?bgwt)
                        )
                      (= ?bhjx ?bhig)
                      )
                    (= ?bhki ?bhig)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhkj Real)
                  (declare-const ?bhkk Real)
                  (declare-const ?bhkl Real)
                  (assert
                    (and (and (not (= ?bhkl ?bhkk))
                        (not (= ?bhkl ?bhkj))
                        )
                      (not (= ?bhkk ?bhkj))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhkm Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhkn Real)
                  (declare-const ?bhko Real)
                  (declare-const ?bhkp Real)
                  (declare-const ?bhkq Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bhko ?bhkn)
                              (= ?bhko ?awmg)
                              )
                            (= ?bhkn ?awmg)
                            )
                          (or (or (= ?bhkq ?bhkp)
                              (= ?bhkq ?awmg)
                              )
                            (= ?bhkp ?awmg)
                            )
                          )
                        (and (not (= ?bhko ?bhkn))
                          (and (and (not (= ?bhkq ?bhkp))
                              (not (= ?bhkq ?awmg))
                              )
                            (not (= ?bhkp ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhkr Real)
                  (declare-const ?bhks Real)
                  (declare-const ?bhkt Real)
                  (assert
                    (and (and (not (= ?bhkt ?bhks))
                        (not (= ?bhkt ?bhkr))
                        )
                      (not (= ?bhks ?bhkr))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhku Real)
                  (declare-const ?bhkv Real)
                  (declare-const ?bhkw Real)
                  (declare-const ?bhkx Real)
                  (declare-const ?bhky Real)
                  (declare-const ?bhkz Real)
                  (assert
                    (or (and (or (or (= ?bhkw ?bhkv)
                            (= ?bhkw ?bhku)
                            )
                          (= ?bhkv ?bhku)
                          )
                        (or (or (= ?bhkz ?bhky)
                            (= ?bhkz ?bhkx)
                            )
                          (= ?bhky ?bhkx)
                          )
                        )
                      (and (and (and (not (= ?bhkw ?bhkv))
                            (not (= ?bhkw ?bhku))
                            )
                          (not (= ?bhkv ?bhku))
                          )
                        (and (and (not (= ?bhkz ?bhky))
                            (not (= ?bhkz ?bhkx))
                            )
                          (not (= ?bhky ?bhkx))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhla Real)
                  (declare-const ?bhlb Real)
                  (declare-const ?bhlc Real)
                  (assert
                    (and (and (not (= ?bhlc ?bhlb))
                        (not (= ?bhlc ?bhla))
                        )
                      (not (= ?bhlb ?bhla))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhld Real)
                  (declare-const ?bhle Real)
                  (declare-const ?bhlf Real)
                  (assert
                    (and (and (not (= ?bhlf ?bhle))
                        (not (= ?bhlf ?bhld))
                        )
                      (not (= ?bhle ?bhld))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bhlg Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bhlh Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhli Real)
              (declare-const ?bhlj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhlk Real)
              (declare-const ?bhll Real)
              (declare-const ?bhlm Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhln Real)
              (declare-const ?bhlo Real)
              (declare-const ?bhlp Real)
              (declare-const ?bhlq Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhlr Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (push 1)
        (declare-const ?bhls Real)
        (declare-const ?bhlt Real)
        (declare-const ?bhlu Real)
        (assert
          (and (and (not (= ?bhlu ?bhlt))
              (not (= ?bhlu ?bhls))
              )
            (not (= ?bhlt ?bhls))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhlv Real)
        (declare-const ?bhlw Real)
        (declare-const ?bhlx Real)
        (declare-const ?bhly Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bhlw ?bhlv)
                    (= ?bhlw ?awmg)
                    )
                  (= ?bhlv ?awmg)
                  )
                (or (or (= ?bhly ?bhlx)
                    (= ?bhly ?awmg)
                    )
                  (= ?bhlx ?awmg)
                  )
                )
              (and (not (= ?bhlw ?bhlv))
                (and (and (not (= ?bhly ?bhlx))
                    (not (= ?bhly ?awmg))
                    )
                  (not (= ?bhlx ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhlz Real)
        (declare-const ?bhma Real)
        (declare-const ?bhmb Real)
        (assert
          (and (and (not (= ?bhmb ?bhma))
              (not (= ?bhmb ?bhlz))
              )
            (not (= ?bhma ?bhlz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhmc Real)
        (declare-const ?bhmd Real)
        (declare-const ?bhme Real)
        (declare-const ?bhmf Real)
        (declare-const ?bhmg Real)
        (declare-const ?bhmh Real)
        (assert
          (or (and (or (or (= ?bhme ?bhmd)
                  (= ?bhme ?bhmc)
                  )
                (= ?bhmd ?bhmc)
                )
              (or (or (= ?bhmh ?bhmg)
                  (= ?bhmh ?bhmf)
                  )
                (= ?bhmg ?bhmf)
                )
              )
            (and (and (and (not (= ?bhme ?bhmd))
                  (not (= ?bhme ?bhmc))
                  )
                (not (= ?bhmd ?bhmc))
                )
              (and (and (not (= ?bhmh ?bhmg))
                  (not (= ?bhmh ?bhmf))
                  )
                (not (= ?bhmg ?bhmf))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhmi Real)
        (declare-const ?bhmj Real)
        (declare-const ?bhmk Real)
        (assert
          (and (and (not (= ?bhmk ?bhmj))
              (not (= ?bhmk ?bhmi))
              )
            (not (= ?bhmj ?bhmi))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhml Real)
        (declare-const ?bhmm Real)
        (declare-const ?bhmn Real)
        (assert
          (and (and (not (= ?bhmn ?bhmm))
              (not (= ?bhmn ?bhml))
              )
            (not (= ?bhmm ?bhml))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bhmo Real)
          (push 1)
            (declare-const ?bhmp Real)
            (push 1)
              (declare-const ?bhmq Real)
              (push 1)
                (assert
                  (and (= ?bhmp ?bhmo)
                    (= ?bhmq ?bhmo)
                    )
                  )
                (push 1)
                  (declare-const ?bhmr Real)
                  (declare-const ?bhms Real)
                  (declare-const ?bhmt Real)
                  (assert
                    (and (and (not (= ?bhmt ?bhms))
                        (not (= ?bhmt ?bhmr))
                        )
                      (not (= ?bhms ?bhmr))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhmu Real)
                  (declare-const ?bhmv Real)
                  (declare-const ?bhmw Real)
                  (declare-const ?bhmx Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bhmv ?bhmu)
                              (= ?bhmv ?awmg)
                              )
                            (= ?bhmu ?awmg)
                            )
                          (or (or (= ?bhmx ?bhmw)
                              (= ?bhmx ?awmg)
                              )
                            (= ?bhmw ?awmg)
                            )
                          )
                        (and (not (= ?bhmv ?bhmu))
                          (and (and (not (= ?bhmx ?bhmw))
                              (not (= ?bhmx ?awmg))
                              )
                            (not (= ?bhmw ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhmy Real)
                  (declare-const ?bhmz Real)
                  (declare-const ?bhna Real)
                  (assert
                    (and (and (not (= ?bhna ?bhmz))
                        (not (= ?bhna ?bhmy))
                        )
                      (not (= ?bhmz ?bhmy))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhnb Real)
                  (declare-const ?bhnc Real)
                  (declare-const ?bhnd Real)
                  (declare-const ?bhne Real)
                  (declare-const ?bhnf Real)
                  (declare-const ?bhng Real)
                  (assert
                    (or (and (or (or (= ?bhnd ?bhnc)
                            (= ?bhnd ?bhnb)
                            )
                          (= ?bhnc ?bhnb)
                          )
                        (or (or (= ?bhng ?bhnf)
                            (= ?bhng ?bhne)
                            )
                          (= ?bhnf ?bhne)
                          )
                        )
                      (and (and (and (not (= ?bhnd ?bhnc))
                            (not (= ?bhnd ?bhnb))
                            )
                          (not (= ?bhnc ?bhnb))
                          )
                        (and (and (not (= ?bhng ?bhnf))
                            (not (= ?bhng ?bhne))
                            )
                          (not (= ?bhnf ?bhne))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhnh Real)
                  (declare-const ?bhni Real)
                  (declare-const ?bhnj Real)
                  (assert
                    (and (and (not (= ?bhnj ?bhni))
                        (not (= ?bhnj ?bhnh))
                        )
                      (not (= ?bhni ?bhnh))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhnk Real)
                  (declare-const ?bhnl Real)
                  (declare-const ?bhnm Real)
                  (assert
                    (and (and (not (= ?bhnm ?bhnl))
                        (not (= ?bhnm ?bhnk))
                        )
                      (not (= ?bhnl ?bhnk))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bhnn Real)
      (push 1)
        (declare-const ?bhno Real)
        (declare-const ?bhnp Real)
        (declare-const ?bhnq Real)
        (assert
          (and (and (not (= ?bhnq ?bhnp))
              (not (= ?bhnq ?bhno))
              )
            (not (= ?bhnp ?bhno))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhnr Real)
        (declare-const ?bhns Real)
        (declare-const ?bhnt Real)
        (declare-const ?bhnu Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bhns ?bhnr)
                    (= ?bhns ?awmg)
                    )
                  (= ?bhnr ?awmg)
                  )
                (or (or (= ?bhnu ?bhnt)
                    (= ?bhnu ?awmg)
                    )
                  (= ?bhnt ?awmg)
                  )
                )
              (and (not (= ?bhns ?bhnr))
                (and (and (not (= ?bhnu ?bhnt))
                    (not (= ?bhnu ?awmg))
                    )
                  (not (= ?bhnt ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhnv Real)
        (declare-const ?bhnw Real)
        (declare-const ?bhnx Real)
        (assert
          (and (and (not (= ?bhnx ?bhnw))
              (not (= ?bhnx ?bhnv))
              )
            (not (= ?bhnw ?bhnv))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhny Real)
        (declare-const ?bhnz Real)
        (declare-const ?bhoa Real)
        (declare-const ?bhob Real)
        (declare-const ?bhoc Real)
        (declare-const ?bhod Real)
        (assert
          (or (and (or (or (= ?bhoa ?bhnz)
                  (= ?bhoa ?bhny)
                  )
                (= ?bhnz ?bhny)
                )
              (or (or (= ?bhod ?bhoc)
                  (= ?bhod ?bhob)
                  )
                (= ?bhoc ?bhob)
                )
              )
            (and (and (and (not (= ?bhoa ?bhnz))
                  (not (= ?bhoa ?bhny))
                  )
                (not (= ?bhnz ?bhny))
                )
              (and (and (not (= ?bhod ?bhoc))
                  (not (= ?bhod ?bhob))
                  )
                (not (= ?bhoc ?bhob))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhoe Real)
        (declare-const ?bhof Real)
        (declare-const ?bhog Real)
        (assert
          (and (and (not (= ?bhog ?bhof))
              (not (= ?bhog ?bhoe))
              )
            (not (= ?bhof ?bhoe))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhoh Real)
        (declare-const ?bhoi Real)
        (declare-const ?bhoj Real)
        (assert
          (and (and (not (= ?bhoj ?bhoi))
              (not (= ?bhoj ?bhoh))
              )
            (not (= ?bhoi ?bhoh))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bhok Real)
      (declare-const ?bhol Real)
      (push 1)
        (declare-const ?bhom Real)
        (declare-const ?bhon Real)
        (declare-const ?bhoo Real)
        (assert
          (and (and (not (= ?bhoo ?bhon))
              (not (= ?bhoo ?bhom))
              )
            (not (= ?bhon ?bhom))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhop Real)
        (declare-const ?bhoq Real)
        (declare-const ?bhor Real)
        (declare-const ?bhos Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bhoq ?bhop)
                    (= ?bhoq ?awmg)
                    )
                  (= ?bhop ?awmg)
                  )
                (or (or (= ?bhos ?bhor)
                    (= ?bhos ?awmg)
                    )
                  (= ?bhor ?awmg)
                  )
                )
              (and (not (= ?bhoq ?bhop))
                (and (and (not (= ?bhos ?bhor))
                    (not (= ?bhos ?awmg))
                    )
                  (not (= ?bhor ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhot Real)
        (declare-const ?bhou Real)
        (declare-const ?bhov Real)
        (assert
          (and (and (not (= ?bhov ?bhou))
              (not (= ?bhov ?bhot))
              )
            (not (= ?bhou ?bhot))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhow Real)
        (declare-const ?bhox Real)
        (declare-const ?bhoy Real)
        (declare-const ?bhoz Real)
        (declare-const ?bhpa Real)
        (declare-const ?bhpb Real)
        (assert
          (or (and (or (or (= ?bhoy ?bhox)
                  (= ?bhoy ?bhow)
                  )
                (= ?bhox ?bhow)
                )
              (or (or (= ?bhpb ?bhpa)
                  (= ?bhpb ?bhoz)
                  )
                (= ?bhpa ?bhoz)
                )
              )
            (and (and (and (not (= ?bhoy ?bhox))
                  (not (= ?bhoy ?bhow))
                  )
                (not (= ?bhox ?bhow))
                )
              (and (and (not (= ?bhpb ?bhpa))
                  (not (= ?bhpb ?bhoz))
                  )
                (not (= ?bhpa ?bhoz))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhpc Real)
        (declare-const ?bhpd Real)
        (declare-const ?bhpe Real)
        (assert
          (and (and (not (= ?bhpe ?bhpd))
              (not (= ?bhpe ?bhpc))
              )
            (not (= ?bhpd ?bhpc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhpf Real)
        (declare-const ?bhpg Real)
        (declare-const ?bhph Real)
        (assert
          (and (and (not (= ?bhph ?bhpg))
              (not (= ?bhph ?bhpf))
              )
            (not (= ?bhpg ?bhpf))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bhpi Real)
      (declare-const ?bhpj Real)
      (declare-const ?bhpk Real)
      (push 1)
        (declare-const ?bhpl Real)
        (declare-const ?bhpm Real)
        (declare-const ?bhpn Real)
        (assert
          (and (and (not (= ?bhpn ?bhpm))
              (not (= ?bhpn ?bhpl))
              )
            (not (= ?bhpm ?bhpl))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhpo Real)
        (declare-const ?bhpp Real)
        (declare-const ?bhpq Real)
        (declare-const ?bhpr Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bhpp ?bhpo)
                    (= ?bhpp ?awmg)
                    )
                  (= ?bhpo ?awmg)
                  )
                (or (or (= ?bhpr ?bhpq)
                    (= ?bhpr ?awmg)
                    )
                  (= ?bhpq ?awmg)
                  )
                )
              (and (not (= ?bhpp ?bhpo))
                (and (and (not (= ?bhpr ?bhpq))
                    (not (= ?bhpr ?awmg))
                    )
                  (not (= ?bhpq ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhps Real)
        (declare-const ?bhpt Real)
        (declare-const ?bhpu Real)
        (assert
          (and (and (not (= ?bhpu ?bhpt))
              (not (= ?bhpu ?bhps))
              )
            (not (= ?bhpt ?bhps))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhpv Real)
        (declare-const ?bhpw Real)
        (declare-const ?bhpx Real)
        (declare-const ?bhpy Real)
        (declare-const ?bhpz Real)
        (declare-const ?bhqa Real)
        (assert
          (or (and (or (or (= ?bhpx ?bhpw)
                  (= ?bhpx ?bhpv)
                  )
                (= ?bhpw ?bhpv)
                )
              (or (or (= ?bhqa ?bhpz)
                  (= ?bhqa ?bhpy)
                  )
                (= ?bhpz ?bhpy)
                )
              )
            (and (and (and (not (= ?bhpx ?bhpw))
                  (not (= ?bhpx ?bhpv))
                  )
                (not (= ?bhpw ?bhpv))
                )
              (and (and (not (= ?bhqa ?bhpz))
                  (not (= ?bhqa ?bhpy))
                  )
                (not (= ?bhpz ?bhpy))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhqb Real)
        (declare-const ?bhqc Real)
        (declare-const ?bhqd Real)
        (assert
          (and (and (not (= ?bhqd ?bhqc))
              (not (= ?bhqd ?bhqb))
              )
            (not (= ?bhqc ?bhqb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhqe Real)
        (declare-const ?bhqf Real)
        (declare-const ?bhqg Real)
        (assert
          (and (and (not (= ?bhqg ?bhqf))
              (not (= ?bhqg ?bhqe))
              )
            (not (= ?bhqf ?bhqe))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?bhpk ?bhpj))
              (not (= ?bhpk ?bhpi))
              )
            (not (= ?bhpj ?bhpi))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bhqh Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bhqi Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bhqj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhqk Real)
              (declare-const ?bhql Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhqm Real)
              (declare-const ?bhqn Real)
              (declare-const ?bhqo Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhqp Real)
              (declare-const ?bhqq Real)
              (declare-const ?bhqr Real)
              (declare-const ?bhqs Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhqt Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bhqu Real)
            (declare-const ?bhqv Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bhqw Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhqx Real)
              (declare-const ?bhqy Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhqz Real)
              (declare-const ?bhra Real)
              (declare-const ?bhrb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhrc Real)
              (declare-const ?bhrd Real)
              (declare-const ?bhre Real)
              (declare-const ?bhrf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhrg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bhrh Real)
            (declare-const ?bhri Real)
            (declare-const ?bhrj Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bhrk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhrl Real)
              (declare-const ?bhrm Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhrn Real)
              (declare-const ?bhro Real)
              (declare-const ?bhrp Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhrq Real)
              (declare-const ?bhrr Real)
              (declare-const ?bhrs Real)
              (declare-const ?bhrt Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhru Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bhrv Real)
            (declare-const ?bhrw Real)
            (declare-const ?bhrx Real)
            (declare-const ?bhry Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bhrz Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhsa Real)
              (declare-const ?bhsb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhsc Real)
              (declare-const ?bhsd Real)
              (declare-const ?bhse Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhsf Real)
              (declare-const ?bhsg Real)
              (declare-const ?bhsh Real)
              (declare-const ?bhsi Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhsj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bhsk Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bhsl Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhsm Real)
              (declare-const ?bhsn Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhso Real)
              (declare-const ?bhsp Real)
              (declare-const ?bhsq Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bhsr Real)
              (declare-const ?bhss Real)
              (declare-const ?bhst Real)
              (declare-const ?bhsu Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (= ?bhsk ?bhqh)
                      (and (and (= ?bhst ?bhpk)
                          (= ?bhss ?bhpj)
                          )
                        (= ?bhsr ?bhpi)
                        )
                      )
                    (= ?bhsu ?bhqh)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhsv Real)
                  (declare-const ?bhsw Real)
                  (declare-const ?bhsx Real)
                  (assert
                    (and (and (not (= ?bhsx ?bhsw))
                        (not (= ?bhsx ?bhsv))
                        )
                      (not (= ?bhsw ?bhsv))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhsy Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhsz Real)
                  (declare-const ?bhta Real)
                  (declare-const ?bhtb Real)
                  (declare-const ?bhtc Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bhta ?bhsz)
                              (= ?bhta ?awmg)
                              )
                            (= ?bhsz ?awmg)
                            )
                          (or (or (= ?bhtc ?bhtb)
                              (= ?bhtc ?awmg)
                              )
                            (= ?bhtb ?awmg)
                            )
                          )
                        (and (not (= ?bhta ?bhsz))
                          (and (and (not (= ?bhtc ?bhtb))
                              (not (= ?bhtc ?awmg))
                              )
                            (not (= ?bhtb ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhtd Real)
                  (declare-const ?bhte Real)
                  (declare-const ?bhtf Real)
                  (assert
                    (and (and (not (= ?bhtf ?bhte))
                        (not (= ?bhtf ?bhtd))
                        )
                      (not (= ?bhte ?bhtd))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhtg Real)
                  (declare-const ?bhth Real)
                  (declare-const ?bhti Real)
                  (declare-const ?bhtj Real)
                  (declare-const ?bhtk Real)
                  (declare-const ?bhtl Real)
                  (assert
                    (or (and (or (or (= ?bhti ?bhth)
                            (= ?bhti ?bhtg)
                            )
                          (= ?bhth ?bhtg)
                          )
                        (or (or (= ?bhtl ?bhtk)
                            (= ?bhtl ?bhtj)
                            )
                          (= ?bhtk ?bhtj)
                          )
                        )
                      (and (and (and (not (= ?bhti ?bhth))
                            (not (= ?bhti ?bhtg))
                            )
                          (not (= ?bhth ?bhtg))
                          )
                        (and (and (not (= ?bhtl ?bhtk))
                            (not (= ?bhtl ?bhtj))
                            )
                          (not (= ?bhtk ?bhtj))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhtm Real)
                  (declare-const ?bhtn Real)
                  (declare-const ?bhto Real)
                  (assert
                    (and (and (not (= ?bhto ?bhtn))
                        (not (= ?bhto ?bhtm))
                        )
                      (not (= ?bhtn ?bhtm))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhtp Real)
                  (declare-const ?bhtq Real)
                  (declare-const ?bhtr Real)
                  (assert
                    (and (and (not (= ?bhtr ?bhtq))
                        (not (= ?bhtr ?bhtp))
                        )
                      (not (= ?bhtq ?bhtp))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?bhts Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (declare-const ?bhtt Real)
        (declare-const ?bhtu Real)
        (declare-const ?bhtv Real)
        (assert
          (and (and (not (= ?bhtv ?bhtu))
              (not (= ?bhtv ?bhtt))
              )
            (not (= ?bhtu ?bhtt))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhtw Real)
        (declare-const ?bhtx Real)
        (declare-const ?bhty Real)
        (declare-const ?bhtz Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bhtx ?bhtw)
                    (= ?bhtx ?awmg)
                    )
                  (= ?bhtw ?awmg)
                  )
                (or (or (= ?bhtz ?bhty)
                    (= ?bhtz ?awmg)
                    )
                  (= ?bhty ?awmg)
                  )
                )
              (and (not (= ?bhtx ?bhtw))
                (and (and (not (= ?bhtz ?bhty))
                    (not (= ?bhtz ?awmg))
                    )
                  (not (= ?bhty ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhua Real)
        (declare-const ?bhub Real)
        (declare-const ?bhuc Real)
        (assert
          (and (and (not (= ?bhuc ?bhub))
              (not (= ?bhuc ?bhua))
              )
            (not (= ?bhub ?bhua))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhud Real)
        (declare-const ?bhue Real)
        (declare-const ?bhuf Real)
        (declare-const ?bhug Real)
        (declare-const ?bhuh Real)
        (declare-const ?bhui Real)
        (assert
          (or (and (or (or (= ?bhuf ?bhue)
                  (= ?bhuf ?bhud)
                  )
                (= ?bhue ?bhud)
                )
              (or (or (= ?bhui ?bhuh)
                  (= ?bhui ?bhug)
                  )
                (= ?bhuh ?bhug)
                )
              )
            (and (and (and (not (= ?bhuf ?bhue))
                  (not (= ?bhuf ?bhud))
                  )
                (not (= ?bhue ?bhud))
                )
              (and (and (not (= ?bhui ?bhuh))
                  (not (= ?bhui ?bhug))
                  )
                (not (= ?bhuh ?bhug))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhuj Real)
        (declare-const ?bhuk Real)
        (declare-const ?bhul Real)
        (assert
          (and (and (not (= ?bhul ?bhuk))
              (not (= ?bhul ?bhuj))
              )
            (not (= ?bhuk ?bhuj))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bhum Real)
        (declare-const ?bhun Real)
        (declare-const ?bhuo Real)
        (assert
          (and (and (not (= ?bhuo ?bhun))
              (not (= ?bhuo ?bhum))
              )
            (not (= ?bhun ?bhum))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bhup Real)
          (push 1)
            (declare-const ?bhuq Real)
            (push 1)
              (declare-const ?bhur Real)
              (push 1)
                (assert
                  (and (= ?bhuq ?bhup)
                    (= ?bhur ?bhup)
                    )
                  )
                (push 1)
                  (declare-const ?bhus Real)
                  (declare-const ?bhut Real)
                  (declare-const ?bhuu Real)
                  (assert
                    (and (and (not (= ?bhuu ?bhut))
                        (not (= ?bhuu ?bhus))
                        )
                      (not (= ?bhut ?bhus))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhuv Real)
                  (declare-const ?bhuw Real)
                  (declare-const ?bhux Real)
                  (declare-const ?bhuy Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bhuw ?bhuv)
                              (= ?bhuw ?awmg)
                              )
                            (= ?bhuv ?awmg)
                            )
                          (or (or (= ?bhuy ?bhux)
                              (= ?bhuy ?awmg)
                              )
                            (= ?bhux ?awmg)
                            )
                          )
                        (and (not (= ?bhuw ?bhuv))
                          (and (and (not (= ?bhuy ?bhux))
                              (not (= ?bhuy ?awmg))
                              )
                            (not (= ?bhux ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhuz Real)
                  (declare-const ?bhva Real)
                  (declare-const ?bhvb Real)
                  (assert
                    (and (and (not (= ?bhvb ?bhva))
                        (not (= ?bhvb ?bhuz))
                        )
                      (not (= ?bhva ?bhuz))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhvc Real)
                  (declare-const ?bhvd Real)
                  (declare-const ?bhve Real)
                  (declare-const ?bhvf Real)
                  (declare-const ?bhvg Real)
                  (declare-const ?bhvh Real)
                  (assert
                    (or (and (or (or (= ?bhve ?bhvd)
                            (= ?bhve ?bhvc)
                            )
                          (= ?bhvd ?bhvc)
                          )
                        (or (or (= ?bhvh ?bhvg)
                            (= ?bhvh ?bhvf)
                            )
                          (= ?bhvg ?bhvf)
                          )
                        )
                      (and (and (and (not (= ?bhve ?bhvd))
                            (not (= ?bhve ?bhvc))
                            )
                          (not (= ?bhvd ?bhvc))
                          )
                        (and (and (not (= ?bhvh ?bhvg))
                            (not (= ?bhvh ?bhvf))
                            )
                          (not (= ?bhvg ?bhvf))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhvi Real)
                  (declare-const ?bhvj Real)
                  (declare-const ?bhvk Real)
                  (assert
                    (and (and (not (= ?bhvk ?bhvj))
                        (not (= ?bhvk ?bhvi))
                        )
                      (not (= ?bhvj ?bhvi))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bhvl Real)
                  (declare-const ?bhvm Real)
                  (declare-const ?bhvn Real)
                  (assert
                    (and (and (not (= ?bhvn ?bhvm))
                        (not (= ?bhvn ?bhvl))
                        )
                      (not (= ?bhvm ?bhvl))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bhvo Real)
      (declare-const ?bhvp Real)
      (declare-const ?bhvq Real)
      (assert
        (and (and (not (= ?bhvq ?bhvp))
            (not (= ?bhvq ?bhvo))
            )
          (not (= ?bhvp ?bhvo))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhvr Real)
      (declare-const ?bhvs Real)
      (declare-const ?bhvt Real)
      (declare-const ?bhvu Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bhvs ?bhvr)
                  (= ?bhvs ?awmg)
                  )
                (= ?bhvr ?awmg)
                )
              (or (or (= ?bhvu ?bhvt)
                  (= ?bhvu ?awmg)
                  )
                (= ?bhvt ?awmg)
                )
              )
            (and (not (= ?bhvs ?bhvr))
              (and (and (not (= ?bhvu ?bhvt))
                  (not (= ?bhvu ?awmg))
                  )
                (not (= ?bhvt ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhvv Real)
      (declare-const ?bhvw Real)
      (declare-const ?bhvx Real)
      (assert
        (and (and (not (= ?bhvx ?bhvw))
            (not (= ?bhvx ?bhvv))
            )
          (not (= ?bhvw ?bhvv))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhvy Real)
      (declare-const ?bhvz Real)
      (declare-const ?bhwa Real)
      (declare-const ?bhwb Real)
      (declare-const ?bhwc Real)
      (declare-const ?bhwd Real)
      (assert
        (or (and (or (or (= ?bhwa ?bhvz)
                (= ?bhwa ?bhvy)
                )
              (= ?bhvz ?bhvy)
              )
            (or (or (= ?bhwd ?bhwc)
                (= ?bhwd ?bhwb)
                )
              (= ?bhwc ?bhwb)
              )
            )
          (and (and (and (not (= ?bhwa ?bhvz))
                (not (= ?bhwa ?bhvy))
                )
              (not (= ?bhvz ?bhvy))
              )
            (and (and (not (= ?bhwd ?bhwc))
                (not (= ?bhwd ?bhwb))
                )
              (not (= ?bhwc ?bhwb))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhwe Real)
      (declare-const ?bhwf Real)
      (declare-const ?bhwg Real)
      (assert
        (and (and (not (= ?bhwg ?bhwf))
            (not (= ?bhwg ?bhwe))
            )
          (not (= ?bhwf ?bhwe))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhwh Real)
      (declare-const ?bhwi Real)
      (declare-const ?bhwj Real)
      (assert
        (and (and (not (= ?bhwj ?bhwi))
            (not (= ?bhwj ?bhwh))
            )
          (not (= ?bhwi ?bhwh))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bhwk Real)
    (push 1)
      (declare-const ?bhwl Real)
      (declare-const ?bhwm Real)
      (declare-const ?bhwn Real)
      (assert
        (and (and (not (= ?bhwn ?bhwm))
            (not (= ?bhwn ?bhwl))
            )
          (not (= ?bhwm ?bhwl))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhwo Real)
      (declare-const ?bhwp Real)
      (declare-const ?bhwq Real)
      (declare-const ?bhwr Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bhwp ?bhwo)
                  (= ?bhwp ?awmg)
                  )
                (= ?bhwo ?awmg)
                )
              (or (or (= ?bhwr ?bhwq)
                  (= ?bhwr ?awmg)
                  )
                (= ?bhwq ?awmg)
                )
              )
            (and (not (= ?bhwp ?bhwo))
              (and (and (not (= ?bhwr ?bhwq))
                  (not (= ?bhwr ?awmg))
                  )
                (not (= ?bhwq ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhws Real)
      (declare-const ?bhwt Real)
      (declare-const ?bhwu Real)
      (assert
        (and (and (not (= ?bhwu ?bhwt))
            (not (= ?bhwu ?bhws))
            )
          (not (= ?bhwt ?bhws))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhwv Real)
      (declare-const ?bhww Real)
      (declare-const ?bhwx Real)
      (declare-const ?bhwy Real)
      (declare-const ?bhwz Real)
      (declare-const ?bhxa Real)
      (assert
        (or (and (or (or (= ?bhwx ?bhww)
                (= ?bhwx ?bhwv)
                )
              (= ?bhww ?bhwv)
              )
            (or (or (= ?bhxa ?bhwz)
                (= ?bhxa ?bhwy)
                )
              (= ?bhwz ?bhwy)
              )
            )
          (and (and (and (not (= ?bhwx ?bhww))
                (not (= ?bhwx ?bhwv))
                )
              (not (= ?bhww ?bhwv))
              )
            (and (and (not (= ?bhxa ?bhwz))
                (not (= ?bhxa ?bhwy))
                )
              (not (= ?bhwz ?bhwy))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhxb Real)
      (declare-const ?bhxc Real)
      (declare-const ?bhxd Real)
      (assert
        (and (and (not (= ?bhxd ?bhxc))
            (not (= ?bhxd ?bhxb))
            )
          (not (= ?bhxc ?bhxb))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhxe Real)
      (declare-const ?bhxf Real)
      (declare-const ?bhxg Real)
      (assert
        (and (and (not (= ?bhxg ?bhxf))
            (not (= ?bhxg ?bhxe))
            )
          (not (= ?bhxf ?bhxe))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bhxh Real)
    (declare-const ?bhxi Real)
    (declare-const ?bhxj Real)
    (declare-const ?bhxk Real)
    (assert
      (forall ((?awmg Real) )(or (and (or (or (= ?bhxi ?bhxh)
                (= ?bhxi ?awmg)
                )
              (= ?bhxh ?awmg)
              )
            (or (or (= ?bhxk ?bhxj)
                (= ?bhxk ?awmg)
                )
              (= ?bhxj ?awmg)
              )
            )
          (and (not (= ?bhxi ?bhxh))
            (and (and (not (= ?bhxk ?bhxj))
                (not (= ?bhxk ?awmg))
                )
              (not (= ?bhxj ?awmg))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhxl Real)
      (declare-const ?bhxm Real)
      (declare-const ?bhxn Real)
      (assert
        (and (and (not (= ?bhxn ?bhxm))
            (not (= ?bhxn ?bhxl))
            )
          (not (= ?bhxm ?bhxl))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhxo Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhxp Real)
      (declare-const ?bhxq Real)
      (declare-const ?bhxr Real)
      (declare-const ?bhxs Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bhxq ?bhxp)
                  (= ?bhxq ?awmg)
                  )
                (= ?bhxp ?awmg)
                )
              (or (or (= ?bhxs ?bhxr)
                  (= ?bhxs ?awmg)
                  )
                (= ?bhxr ?awmg)
                )
              )
            (and (not (= ?bhxq ?bhxp))
              (and (and (not (= ?bhxs ?bhxr))
                  (not (= ?bhxs ?awmg))
                  )
                (not (= ?bhxr ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhxt Real)
      (declare-const ?bhxu Real)
      (declare-const ?bhxv Real)
      (assert
        (and (and (not (= ?bhxv ?bhxu))
            (not (= ?bhxv ?bhxt))
            )
          (not (= ?bhxu ?bhxt))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhxw Real)
      (declare-const ?bhxx Real)
      (declare-const ?bhxy Real)
      (declare-const ?bhxz Real)
      (declare-const ?bhya Real)
      (declare-const ?bhyb Real)
      (assert
        (or (and (or (or (= ?bhxy ?bhxx)
                (= ?bhxy ?bhxw)
                )
              (= ?bhxx ?bhxw)
              )
            (or (or (= ?bhyb ?bhya)
                (= ?bhyb ?bhxz)
                )
              (= ?bhya ?bhxz)
              )
            )
          (and (and (and (not (= ?bhxy ?bhxx))
                (not (= ?bhxy ?bhxw))
                )
              (not (= ?bhxx ?bhxw))
              )
            (and (and (not (= ?bhyb ?bhya))
                (not (= ?bhyb ?bhxz))
                )
              (not (= ?bhya ?bhxz))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhyc Real)
      (declare-const ?bhyd Real)
      (declare-const ?bhye Real)
      (assert
        (and (and (not (= ?bhye ?bhyd))
            (not (= ?bhye ?bhyc))
            )
          (not (= ?bhyd ?bhyc))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhyf Real)
      (declare-const ?bhyg Real)
      (declare-const ?bhyh Real)
      (assert
        (and (and (not (= ?bhyh ?bhyg))
            (not (= ?bhyh ?bhyf))
            )
          (not (= ?bhyg ?bhyf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bhyi Real)
    (declare-const ?bhyj Real)
    (declare-const ?bhyk Real)
    (declare-const ?bhyl Real)
    (declare-const ?bhym Real)
    (declare-const ?bhyn Real)
    (assert
      (or (and (or (or (= ?bhyk ?bhyj)
              (= ?bhyk ?bhyi)
              )
            (= ?bhyj ?bhyi)
            )
          (or (or (= ?bhyn ?bhym)
              (= ?bhyn ?bhyl)
              )
            (= ?bhym ?bhyl)
            )
          )
        (and (and (and (not (= ?bhyk ?bhyj))
              (not (= ?bhyk ?bhyi))
              )
            (not (= ?bhyj ?bhyi))
            )
          (and (and (not (= ?bhyn ?bhym))
              (not (= ?bhyn ?bhyl))
              )
            (not (= ?bhym ?bhyl))
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhyo Real)
      (declare-const ?bhyp Real)
      (declare-const ?bhyq Real)
      (assert
        (and (and (not (= ?bhyq ?bhyp))
            (not (= ?bhyq ?bhyo))
            )
          (not (= ?bhyp ?bhyo))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhyr Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhys Real)
      (declare-const ?bhyt Real)
      (declare-const ?bhyu Real)
      (declare-const ?bhyv Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bhyt ?bhys)
                  (= ?bhyt ?awmg)
                  )
                (= ?bhys ?awmg)
                )
              (or (or (= ?bhyv ?bhyu)
                  (= ?bhyv ?awmg)
                  )
                (= ?bhyu ?awmg)
                )
              )
            (and (not (= ?bhyt ?bhys))
              (and (and (not (= ?bhyv ?bhyu))
                  (not (= ?bhyv ?awmg))
                  )
                (not (= ?bhyu ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhyw Real)
      (declare-const ?bhyx Real)
      (declare-const ?bhyy Real)
      (assert
        (and (and (not (= ?bhyy ?bhyx))
            (not (= ?bhyy ?bhyw))
            )
          (not (= ?bhyx ?bhyw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhyz Real)
      (declare-const ?bhza Real)
      (declare-const ?bhzb Real)
      (declare-const ?bhzc Real)
      (declare-const ?bhzd Real)
      (declare-const ?bhze Real)
      (assert
        (or (and (or (or (= ?bhzb ?bhza)
                (= ?bhzb ?bhyz)
                )
              (= ?bhza ?bhyz)
              )
            (or (or (= ?bhze ?bhzd)
                (= ?bhze ?bhzc)
                )
              (= ?bhzd ?bhzc)
              )
            )
          (and (and (and (not (= ?bhzb ?bhza))
                (not (= ?bhzb ?bhyz))
                )
              (not (= ?bhza ?bhyz))
              )
            (and (and (not (= ?bhze ?bhzd))
                (not (= ?bhze ?bhzc))
                )
              (not (= ?bhzd ?bhzc))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhzf Real)
      (declare-const ?bhzg Real)
      (declare-const ?bhzh Real)
      (assert
        (and (and (not (= ?bhzh ?bhzg))
            (not (= ?bhzh ?bhzf))
            )
          (not (= ?bhzg ?bhzf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhzi Real)
      (declare-const ?bhzj Real)
      (declare-const ?bhzk Real)
      (assert
        (and (and (not (= ?bhzk ?bhzj))
            (not (= ?bhzk ?bhzi))
            )
          (not (= ?bhzj ?bhzi))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bhzl Real)
    (declare-const ?bhzm Real)
    (declare-const ?bhzn Real)
    (assert
      (and (and (not (= ?bhzn ?bhzm))
          (not (= ?bhzn ?bhzl))
          )
        (not (= ?bhzm ?bhzl))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhzo Real)
      (declare-const ?bhzp Real)
      (declare-const ?bhzq Real)
      (assert
        (and (and (not (= ?bhzq ?bhzp))
            (not (= ?bhzq ?bhzo))
            )
          (not (= ?bhzp ?bhzo))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhzr Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhzs Real)
      (declare-const ?bhzt Real)
      (declare-const ?bhzu Real)
      (declare-const ?bhzv Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bhzt ?bhzs)
                  (= ?bhzt ?awmg)
                  )
                (= ?bhzs ?awmg)
                )
              (or (or (= ?bhzv ?bhzu)
                  (= ?bhzv ?awmg)
                  )
                (= ?bhzu ?awmg)
                )
              )
            (and (not (= ?bhzt ?bhzs))
              (and (and (not (= ?bhzv ?bhzu))
                  (not (= ?bhzv ?awmg))
                  )
                (not (= ?bhzu ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhzw Real)
      (declare-const ?bhzx Real)
      (declare-const ?bhzy Real)
      (assert
        (and (and (not (= ?bhzy ?bhzx))
            (not (= ?bhzy ?bhzw))
            )
          (not (= ?bhzx ?bhzw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bhzz Real)
      (declare-const ?biaa Real)
      (declare-const ?biab Real)
      (declare-const ?biac Real)
      (declare-const ?biad Real)
      (declare-const ?biae Real)
      (assert
        (or (and (or (or (= ?biab ?biaa)
                (= ?biab ?bhzz)
                )
              (= ?biaa ?bhzz)
              )
            (or (or (= ?biae ?biad)
                (= ?biae ?biac)
                )
              (= ?biad ?biac)
              )
            )
          (and (and (and (not (= ?biab ?biaa))
                (not (= ?biab ?bhzz))
                )
              (not (= ?biaa ?bhzz))
              )
            (and (and (not (= ?biae ?biad))
                (not (= ?biae ?biac))
                )
              (not (= ?biad ?biac))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?biaf Real)
      (declare-const ?biag Real)
      (declare-const ?biah Real)
      (assert
        (and (and (not (= ?biah ?biag))
            (not (= ?biah ?biaf))
            )
          (not (= ?biag ?biaf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?biai Real)
      (declare-const ?biaj Real)
      (declare-const ?biak Real)
      (assert
        (and (and (not (= ?biak ?biaj))
            (not (= ?biak ?biai))
            )
          (not (= ?biaj ?biai))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bial Real)
    (declare-const ?biam Real)
    (declare-const ?bian Real)
    (assert
      (and (and (not (= ?bian ?biam))
          (not (= ?bian ?bial))
          )
        (not (= ?biam ?bial))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?biao Real)
      (declare-const ?biap Real)
      (declare-const ?biaq Real)
      (assert
        (and (and (not (= ?biaq ?biap))
            (not (= ?biaq ?biao))
            )
          (not (= ?biap ?biao))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?biar Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bias Real)
      (declare-const ?biat Real)
      (declare-const ?biau Real)
      (declare-const ?biav Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?biat ?bias)
                  (= ?biat ?awmg)
                  )
                (= ?bias ?awmg)
                )
              (or (or (= ?biav ?biau)
                  (= ?biav ?awmg)
                  )
                (= ?biau ?awmg)
                )
              )
            (and (not (= ?biat ?bias))
              (and (and (not (= ?biav ?biau))
                  (not (= ?biav ?awmg))
                  )
                (not (= ?biau ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?biaw Real)
      (declare-const ?biax Real)
      (declare-const ?biay Real)
      (assert
        (and (and (not (= ?biay ?biax))
            (not (= ?biay ?biaw))
            )
          (not (= ?biax ?biaw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?biaz Real)
      (declare-const ?biba Real)
      (declare-const ?bibb Real)
      (declare-const ?bibc Real)
      (declare-const ?bibd Real)
      (declare-const ?bibe Real)
      (assert
        (or (and (or (or (= ?bibb ?biba)
                (= ?bibb ?biaz)
                )
              (= ?biba ?biaz)
              )
            (or (or (= ?bibe ?bibd)
                (= ?bibe ?bibc)
                )
              (= ?bibd ?bibc)
              )
            )
          (and (and (and (not (= ?bibb ?biba))
                (not (= ?bibb ?biaz))
                )
              (not (= ?biba ?biaz))
              )
            (and (and (not (= ?bibe ?bibd))
                (not (= ?bibe ?bibc))
                )
              (not (= ?bibd ?bibc))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bibf Real)
      (declare-const ?bibg Real)
      (declare-const ?bibh Real)
      (assert
        (and (and (not (= ?bibh ?bibg))
            (not (= ?bibh ?bibf))
            )
          (not (= ?bibg ?bibf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bibi Real)
      (declare-const ?bibj Real)
      (declare-const ?bibk Real)
      (assert
        (and (and (not (= ?bibk ?bibj))
            (not (= ?bibk ?bibi))
            )
          (not (= ?bibj ?bibi))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bibl Real)
      (declare-const ?bibm Real)
      (declare-const ?bibn Real)
      (assert
        (and (and (not (= ?bibn ?bibm))
            (not (= ?bibn ?bibl))
            )
          (not (= ?bibm ?bibl))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bibo Real)
      (declare-const ?bibp Real)
      (declare-const ?bibq Real)
      (declare-const ?bibr Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bibp ?bibo)
                  (= ?bibp ?awmg)
                  )
                (= ?bibo ?awmg)
                )
              (or (or (= ?bibr ?bibq)
                  (= ?bibr ?awmg)
                  )
                (= ?bibq ?awmg)
                )
              )
            (and (not (= ?bibp ?bibo))
              (and (and (not (= ?bibr ?bibq))
                  (not (= ?bibr ?awmg))
                  )
                (not (= ?bibq ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bibs Real)
      (declare-const ?bibt Real)
      (declare-const ?bibu Real)
      (assert
        (and (and (not (= ?bibu ?bibt))
            (not (= ?bibu ?bibs))
            )
          (not (= ?bibt ?bibs))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bibv Real)
      (declare-const ?bibw Real)
      (declare-const ?bibx Real)
      (declare-const ?biby Real)
      (declare-const ?bibz Real)
      (declare-const ?bica Real)
      (assert
        (or (and (or (or (= ?bibx ?bibw)
                (= ?bibx ?bibv)
                )
              (= ?bibw ?bibv)
              )
            (or (or (= ?bica ?bibz)
                (= ?bica ?biby)
                )
              (= ?bibz ?biby)
              )
            )
          (and (and (and (not (= ?bibx ?bibw))
                (not (= ?bibx ?bibv))
                )
              (not (= ?bibw ?bibv))
              )
            (and (and (not (= ?bica ?bibz))
                (not (= ?bica ?biby))
                )
              (not (= ?bibz ?biby))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bicb Real)
      (declare-const ?bicc Real)
      (declare-const ?bicd Real)
      (assert
        (and (and (not (= ?bicd ?bicc))
            (not (= ?bicd ?bicb))
            )
          (not (= ?bicc ?bicb))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bice Real)
      (declare-const ?bicf Real)
      (declare-const ?bicg Real)
      (assert
        (and (and (not (= ?bicg ?bicf))
            (not (= ?bicg ?bice))
            )
          (not (= ?bicf ?bice))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bich Real)
      (declare-const ?bici Real)
      (declare-const ?bicj Real)
      (declare-const ?bick Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bici ?bich)
                  (= ?bici ?awmg)
                  )
                (= ?bich ?awmg)
                )
              (or (or (= ?bick ?bicj)
                  (= ?bick ?awmg)
                  )
                (= ?bicj ?awmg)
                )
              )
            (and (not (= ?bici ?bich))
              (and (and (not (= ?bick ?bicj))
                  (not (= ?bick ?awmg))
                  )
                (not (= ?bicj ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bicl Real)
      (declare-const ?bicm Real)
      (declare-const ?bicn Real)
      (declare-const ?bico Real)
      (declare-const ?bicp Real)
      (declare-const ?bicq Real)
      (assert
        (or (and (or (or (= ?bicn ?bicm)
                (= ?bicn ?bicl)
                )
              (= ?bicm ?bicl)
              )
            (or (or (= ?bicq ?bicp)
                (= ?bicq ?bico)
                )
              (= ?bicp ?bico)
              )
            )
          (and (and (and (not (= ?bicn ?bicm))
                (not (= ?bicn ?bicl))
                )
              (not (= ?bicm ?bicl))
              )
            (and (and (not (= ?bicq ?bicp))
                (not (= ?bicq ?bico))
                )
              (not (= ?bicp ?bico))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bicr Real)
      (declare-const ?bics Real)
      (declare-const ?bict Real)
      (assert
        (and (and (not (= ?bict ?bics))
            (not (= ?bict ?bicr))
            )
          (not (= ?bics ?bicr))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bicu Real)
      (declare-const ?bicv Real)
      (declare-const ?bicw Real)
      (assert
        (and (and (not (= ?bicw ?bicv))
            (not (= ?bicw ?bicu))
            )
          (not (= ?bicv ?bicu))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bicx Real)
    (declare-const ?bicy Real)
    (declare-const ?bicz Real)
    (assert
      (and (and (not (= ?bicz ?bicy))
          (not (= ?bicz ?bicx))
          )
        (not (= ?bicy ?bicx))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bida Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bidb Real)
      (declare-const ?bidc Real)
      (declare-const ?bidd Real)
      (declare-const ?bide Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bidc ?bidb)
                  (= ?bidc ?awmg)
                  )
                (= ?bidb ?awmg)
                )
              (or (or (= ?bide ?bidd)
                  (= ?bide ?awmg)
                  )
                (= ?bidd ?awmg)
                )
              )
            (and (not (= ?bidc ?bidb))
              (and (and (not (= ?bide ?bidd))
                  (not (= ?bide ?awmg))
                  )
                (not (= ?bidd ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bidf Real)
      (declare-const ?bidg Real)
      (declare-const ?bidh Real)
      (declare-const ?bidi Real)
      (declare-const ?bidj Real)
      (declare-const ?bidk Real)
      (assert
        (or (and (or (or (= ?bidh ?bidg)
                (= ?bidh ?bidf)
                )
              (= ?bidg ?bidf)
              )
            (or (or (= ?bidk ?bidj)
                (= ?bidk ?bidi)
                )
              (= ?bidj ?bidi)
              )
            )
          (and (and (and (not (= ?bidh ?bidg))
                (not (= ?bidh ?bidf))
                )
              (not (= ?bidg ?bidf))
              )
            (and (and (not (= ?bidk ?bidj))
                (not (= ?bidk ?bidi))
                )
              (not (= ?bidj ?bidi))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bidl Real)
      (declare-const ?bidm Real)
      (declare-const ?bidn Real)
      (assert
        (and (and (not (= ?bidn ?bidm))
            (not (= ?bidn ?bidl))
            )
          (not (= ?bidm ?bidl))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bido Real)
      (declare-const ?bidp Real)
      (declare-const ?bidq Real)
      (assert
        (and (and (not (= ?bidq ?bidp))
            (not (= ?bidq ?bido))
            )
          (not (= ?bidp ?bido))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bidr Real)
      (declare-const ?bids Real)
      (declare-const ?bidt Real)
      (declare-const ?bidu Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bids ?bidr)
                  (= ?bids ?awmg)
                  )
                (= ?bidr ?awmg)
                )
              (or (or (= ?bidu ?bidt)
                  (= ?bidu ?awmg)
                  )
                (= ?bidt ?awmg)
                )
              )
            (and (not (= ?bids ?bidr))
              (and (and (not (= ?bidu ?bidt))
                  (not (= ?bidu ?awmg))
                  )
                (not (= ?bidt ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bidv Real)
      (declare-const ?bidw Real)
      (declare-const ?bidx Real)
      (declare-const ?bidy Real)
      (declare-const ?bidz Real)
      (declare-const ?biea Real)
      (assert
        (or (and (or (or (= ?bidx ?bidw)
                (= ?bidx ?bidv)
                )
              (= ?bidw ?bidv)
              )
            (or (or (= ?biea ?bidz)
                (= ?biea ?bidy)
                )
              (= ?bidz ?bidy)
              )
            )
          (and (and (and (not (= ?bidx ?bidw))
                (not (= ?bidx ?bidv))
                )
              (not (= ?bidw ?bidv))
              )
            (and (and (not (= ?biea ?bidz))
                (not (= ?biea ?bidy))
                )
              (not (= ?bidz ?bidy))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bieb Real)
      (declare-const ?biec Real)
      (declare-const ?bied Real)
      (assert
        (and (and (not (= ?bied ?biec))
            (not (= ?bied ?bieb))
            )
          (not (= ?biec ?bieb))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?biee Real)
      (declare-const ?bief Real)
      (declare-const ?bieg Real)
      (assert
        (and (and (not (= ?bieg ?bief))
            (not (= ?bieg ?biee))
            )
          (not (= ?bief ?biee))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bieh Real)
    (push 1)
      (declare-const ?biei Real)
      (declare-const ?biej Real)
      (declare-const ?biek Real)
      (declare-const ?biel Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?biej ?biei)
                  (= ?biej ?awmg)
                  )
                (= ?biei ?awmg)
                )
              (or (or (= ?biel ?biek)
                  (= ?biel ?awmg)
                  )
                (= ?biek ?awmg)
                )
              )
            (and (not (= ?biej ?biei))
              (and (and (not (= ?biel ?biek))
                  (not (= ?biel ?awmg))
                  )
                (not (= ?biek ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?biem Real)
      (declare-const ?bien Real)
      (declare-const ?bieo Real)
      (declare-const ?biep Real)
      (declare-const ?bieq Real)
      (declare-const ?bier Real)
      (assert
        (or (and (or (or (= ?bieo ?bien)
                (= ?bieo ?biem)
                )
              (= ?bien ?biem)
              )
            (or (or (= ?bier ?bieq)
                (= ?bier ?biep)
                )
              (= ?bieq ?biep)
              )
            )
          (and (and (and (not (= ?bieo ?bien))
                (not (= ?bieo ?biem))
                )
              (not (= ?bien ?biem))
              )
            (and (and (not (= ?bier ?bieq))
                (not (= ?bier ?biep))
                )
              (not (= ?bieq ?biep))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bies Real)
      (declare-const ?biet Real)
      (declare-const ?bieu Real)
      (assert
        (and (and (not (= ?bieu ?biet))
            (not (= ?bieu ?bies))
            )
          (not (= ?biet ?bies))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?biev Real)
      (declare-const ?biew Real)
      (declare-const ?biex Real)
      (assert
        (and (and (not (= ?biex ?biew))
            (not (= ?biex ?biev))
            )
          (not (= ?biew ?biev))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?biey Real)
    (declare-const ?biez Real)
    (declare-const ?bifa Real)
    (declare-const ?bifb Real)
    (assert
      (forall ((?awmg Real) )(or (and (or (or (= ?biez ?biey)
                (= ?biez ?awmg)
                )
              (= ?biey ?awmg)
              )
            (or (or (= ?bifb ?bifa)
                (= ?bifb ?awmg)
                )
              (= ?bifa ?awmg)
              )
            )
          (and (not (= ?biez ?biey))
            (and (and (not (= ?bifb ?bifa))
                (not (= ?bifb ?awmg))
                )
              (not (= ?bifa ?awmg))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bifc Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bifd Real)
      (declare-const ?bife Real)
      (declare-const ?biff Real)
      (declare-const ?bifg Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bife ?bifd)
                  (= ?bife ?awmg)
                  )
                (= ?bifd ?awmg)
                )
              (or (or (= ?bifg ?biff)
                  (= ?bifg ?awmg)
                  )
                (= ?biff ?awmg)
                )
              )
            (and (not (= ?bife ?bifd))
              (and (and (not (= ?bifg ?biff))
                  (not (= ?bifg ?awmg))
                  )
                (not (= ?biff ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bifh Real)
      (declare-const ?bifi Real)
      (declare-const ?bifj Real)
      (declare-const ?bifk Real)
      (declare-const ?bifl Real)
      (declare-const ?bifm Real)
      (assert
        (or (and (or (or (= ?bifj ?bifi)
                (= ?bifj ?bifh)
                )
              (= ?bifi ?bifh)
              )
            (or (or (= ?bifm ?bifl)
                (= ?bifm ?bifk)
                )
              (= ?bifl ?bifk)
              )
            )
          (and (and (and (not (= ?bifj ?bifi))
                (not (= ?bifj ?bifh))
                )
              (not (= ?bifi ?bifh))
              )
            (and (and (not (= ?bifm ?bifl))
                (not (= ?bifm ?bifk))
                )
              (not (= ?bifl ?bifk))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bifn Real)
      (declare-const ?bifo Real)
      (declare-const ?bifp Real)
      (assert
        (and (and (not (= ?bifp ?bifo))
            (not (= ?bifp ?bifn))
            )
          (not (= ?bifo ?bifn))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bifq Real)
      (declare-const ?bifr Real)
      (declare-const ?bifs Real)
      (assert
        (and (and (not (= ?bifs ?bifr))
            (not (= ?bifs ?bifq))
            )
          (not (= ?bifr ?bifq))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bift Real)
    (declare-const ?bifu Real)
    (declare-const ?bifv Real)
    (assert
      (and (and (not (= ?bifv ?bifu))
          (not (= ?bifv ?bift))
          )
        (not (= ?bifu ?bift))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bifw Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bifx Real)
      (declare-const ?bify Real)
      (declare-const ?bifz Real)
      (declare-const ?biga Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bify ?bifx)
                  (= ?bify ?awmg)
                  )
                (= ?bifx ?awmg)
                )
              (or (or (= ?biga ?bifz)
                  (= ?biga ?awmg)
                  )
                (= ?bifz ?awmg)
                )
              )
            (and (not (= ?bify ?bifx))
              (and (and (not (= ?biga ?bifz))
                  (not (= ?biga ?awmg))
                  )
                (not (= ?bifz ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bigb Real)
      (declare-const ?bigc Real)
      (declare-const ?bigd Real)
      (declare-const ?bige Real)
      (declare-const ?bigf Real)
      (declare-const ?bigg Real)
      (assert
        (or (and (or (or (= ?bigd ?bigc)
                (= ?bigd ?bigb)
                )
              (= ?bigc ?bigb)
              )
            (or (or (= ?bigg ?bigf)
                (= ?bigg ?bige)
                )
              (= ?bigf ?bige)
              )
            )
          (and (and (and (not (= ?bigd ?bigc))
                (not (= ?bigd ?bigb))
                )
              (not (= ?bigc ?bigb))
              )
            (and (and (not (= ?bigg ?bigf))
                (not (= ?bigg ?bige))
                )
              (not (= ?bigf ?bige))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bigh Real)
      (declare-const ?bigi Real)
      (declare-const ?bigj Real)
      (assert
        (and (and (not (= ?bigj ?bigi))
            (not (= ?bigj ?bigh))
            )
          (not (= ?bigi ?bigh))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bigk Real)
      (declare-const ?bigl Real)
      (declare-const ?bigm Real)
      (assert
        (and (and (not (= ?bigm ?bigl))
            (not (= ?bigm ?bigk))
            )
          (not (= ?bigl ?bigk))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bign Real)
    (declare-const ?bigo Real)
    (declare-const ?bigp Real)
    (declare-const ?bigq Real)
    (declare-const ?bigr Real)
    (declare-const ?bigs Real)
    (assert
      (or (and (or (or (= ?bigp ?bigo)
              (= ?bigp ?bign)
              )
            (= ?bigo ?bign)
            )
          (or (or (= ?bigs ?bigr)
              (= ?bigs ?bigq)
              )
            (= ?bigr ?bigq)
            )
          )
        (and (and (and (not (= ?bigp ?bigo))
              (not (= ?bigp ?bign))
              )
            (not (= ?bigo ?bign))
            )
          (and (and (not (= ?bigs ?bigr))
              (not (= ?bigs ?bigq))
              )
            (not (= ?bigr ?bigq))
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bigt Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bigu Real)
      (declare-const ?bigv Real)
      (declare-const ?bigw Real)
      (declare-const ?bigx Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bigv ?bigu)
                  (= ?bigv ?awmg)
                  )
                (= ?bigu ?awmg)
                )
              (or (or (= ?bigx ?bigw)
                  (= ?bigx ?awmg)
                  )
                (= ?bigw ?awmg)
                )
              )
            (and (not (= ?bigv ?bigu))
              (and (and (not (= ?bigx ?bigw))
                  (not (= ?bigx ?awmg))
                  )
                (not (= ?bigw ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bigy Real)
      (declare-const ?bigz Real)
      (declare-const ?biha Real)
      (declare-const ?bihb Real)
      (declare-const ?bihc Real)
      (declare-const ?bihd Real)
      (assert
        (or (and (or (or (= ?biha ?bigz)
                (= ?biha ?bigy)
                )
              (= ?bigz ?bigy)
              )
            (or (or (= ?bihd ?bihc)
                (= ?bihd ?bihb)
                )
              (= ?bihc ?bihb)
              )
            )
          (and (and (and (not (= ?biha ?bigz))
                (not (= ?biha ?bigy))
                )
              (not (= ?bigz ?bigy))
              )
            (and (and (not (= ?bihd ?bihc))
                (not (= ?bihd ?bihb))
                )
              (not (= ?bihc ?bihb))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bihe Real)
      (declare-const ?bihf Real)
      (declare-const ?bihg Real)
      (assert
        (and (and (not (= ?bihg ?bihf))
            (not (= ?bihg ?bihe))
            )
          (not (= ?bihf ?bihe))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bihh Real)
      (declare-const ?bihi Real)
      (declare-const ?bihj Real)
      (assert
        (and (and (not (= ?bihj ?bihi))
            (not (= ?bihj ?bihh))
            )
          (not (= ?bihi ?bihh))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bihk Real)
    (declare-const ?bihl Real)
    (declare-const ?bihm Real)
    (assert
      (and (and (not (= ?bihm ?bihl))
          (not (= ?bihm ?bihk))
          )
        (not (= ?bihl ?bihk))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bihn Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?biho Real)
      (declare-const ?bihp Real)
      (declare-const ?bihq Real)
      (declare-const ?bihr Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bihp ?biho)
                  (= ?bihp ?awmg)
                  )
                (= ?biho ?awmg)
                )
              (or (or (= ?bihr ?bihq)
                  (= ?bihr ?awmg)
                  )
                (= ?bihq ?awmg)
                )
              )
            (and (not (= ?bihp ?biho))
              (and (and (not (= ?bihr ?bihq))
                  (not (= ?bihr ?awmg))
                  )
                (not (= ?bihq ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bihs Real)
      (declare-const ?biht Real)
      (declare-const ?bihu Real)
      (declare-const ?bihv Real)
      (declare-const ?bihw Real)
      (declare-const ?bihx Real)
      (assert
        (or (and (or (or (= ?bihu ?biht)
                (= ?bihu ?bihs)
                )
              (= ?biht ?bihs)
              )
            (or (or (= ?bihx ?bihw)
                (= ?bihx ?bihv)
                )
              (= ?bihw ?bihv)
              )
            )
          (and (and (and (not (= ?bihu ?biht))
                (not (= ?bihu ?bihs))
                )
              (not (= ?biht ?bihs))
              )
            (and (and (not (= ?bihx ?bihw))
                (not (= ?bihx ?bihv))
                )
              (not (= ?bihw ?bihv))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bihy Real)
      (declare-const ?bihz Real)
      (declare-const ?biia Real)
      (assert
        (and (and (not (= ?biia ?bihz))
            (not (= ?biia ?bihy))
            )
          (not (= ?bihz ?bihy))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?biib Real)
      (declare-const ?biic Real)
      (declare-const ?biid Real)
      (assert
        (and (and (not (= ?biid ?biic))
            (not (= ?biid ?biib))
            )
          (not (= ?biic ?biib))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?biie Real)
      (declare-const ?biif Real)
      (declare-const ?biig Real)
      (declare-const ?biih Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?biif ?biie)
                  (= ?biif ?awmg)
                  )
                (= ?biie ?awmg)
                )
              (or (or (= ?biih ?biig)
                  (= ?biih ?awmg)
                  )
                (= ?biig ?awmg)
                )
              )
            (and (not (= ?biif ?biie))
              (and (and (not (= ?biih ?biig))
                  (not (= ?biih ?awmg))
                  )
                (not (= ?biig ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?biii Real)
      (declare-const ?biij Real)
      (declare-const ?biik Real)
      (declare-const ?biil Real)
      (declare-const ?biim Real)
      (declare-const ?biin Real)
      (assert
        (or (and (or (or (= ?biik ?biij)
                (= ?biik ?biii)
                )
              (= ?biij ?biii)
              )
            (or (or (= ?biin ?biim)
                (= ?biin ?biil)
                )
              (= ?biim ?biil)
              )
            )
          (and (and (and (not (= ?biik ?biij))
                (not (= ?biik ?biii))
                )
              (not (= ?biij ?biii))
              )
            (and (and (not (= ?biin ?biim))
                (not (= ?biin ?biil))
                )
              (not (= ?biim ?biil))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?biio Real)
      (declare-const ?biip Real)
      (declare-const ?biiq Real)
      (assert
        (and (and (not (= ?biiq ?biip))
            (not (= ?biiq ?biio))
            )
          (not (= ?biip ?biio))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?biir Real)
      (declare-const ?biis Real)
      (declare-const ?biit Real)
      (assert
        (and (and (not (= ?biit ?biis))
            (not (= ?biit ?biir))
            )
          (not (= ?biis ?biir))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?biiu Real)
    (declare-const ?biiv Real)
    (declare-const ?biiw Real)
    (assert
      (and (and (not (= ?biiw ?biiv))
          (not (= ?biiw ?biiu))
          )
        (not (= ?biiv ?biiu))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?biix Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?biiy Real)
      (declare-const ?biiz Real)
      (declare-const ?bija Real)
      (declare-const ?bijb Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?biiz ?biiy)
                  (= ?biiz ?awmg)
                  )
                (= ?biiy ?awmg)
                )
              (or (or (= ?bijb ?bija)
                  (= ?bijb ?awmg)
                  )
                (= ?bija ?awmg)
                )
              )
            (and (not (= ?biiz ?biiy))
              (and (and (not (= ?bijb ?bija))
                  (not (= ?bijb ?awmg))
                  )
                (not (= ?bija ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bijc Real)
      (declare-const ?bijd Real)
      (declare-const ?bije Real)
      (declare-const ?bijf Real)
      (declare-const ?bijg Real)
      (declare-const ?bijh Real)
      (assert
        (or (and (or (or (= ?bije ?bijd)
                (= ?bije ?bijc)
                )
              (= ?bijd ?bijc)
              )
            (or (or (= ?bijh ?bijg)
                (= ?bijh ?bijf)
                )
              (= ?bijg ?bijf)
              )
            )
          (and (and (and (not (= ?bije ?bijd))
                (not (= ?bije ?bijc))
                )
              (not (= ?bijd ?bijc))
              )
            (and (and (not (= ?bijh ?bijg))
                (not (= ?bijh ?bijf))
                )
              (not (= ?bijg ?bijf))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?biji Real)
      (declare-const ?bijj Real)
      (declare-const ?bijk Real)
      (assert
        (and (and (not (= ?bijk ?bijj))
            (not (= ?bijk ?biji))
            )
          (not (= ?bijj ?biji))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bijl Real)
      (declare-const ?bijm Real)
      (declare-const ?bijn Real)
      (assert
        (and (and (not (= ?bijn ?bijm))
            (not (= ?bijn ?bijl))
            )
          (not (= ?bijm ?bijl))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bijo Real)
      (declare-const ?bijp Real)
      (declare-const ?bijq Real)
      (declare-const ?bijr Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bijp ?bijo)
                  (= ?bijp ?awmg)
                  )
                (= ?bijo ?awmg)
                )
              (or (or (= ?bijr ?bijq)
                  (= ?bijr ?awmg)
                  )
                (= ?bijq ?awmg)
                )
              )
            (and (not (= ?bijp ?bijo))
              (and (and (not (= ?bijr ?bijq))
                  (not (= ?bijr ?awmg))
                  )
                (not (= ?bijq ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bijs Real)
      (declare-const ?bijt Real)
      (declare-const ?biju Real)
      (declare-const ?bijv Real)
      (declare-const ?bijw Real)
      (declare-const ?bijx Real)
      (assert
        (or (and (or (or (= ?biju ?bijt)
                (= ?biju ?bijs)
                )
              (= ?bijt ?bijs)
              )
            (or (or (= ?bijx ?bijw)
                (= ?bijx ?bijv)
                )
              (= ?bijw ?bijv)
              )
            )
          (and (and (and (not (= ?biju ?bijt))
                (not (= ?biju ?bijs))
                )
              (not (= ?bijt ?bijs))
              )
            (and (and (not (= ?bijx ?bijw))
                (not (= ?bijx ?bijv))
                )
              (not (= ?bijw ?bijv))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bijy Real)
      (declare-const ?bijz Real)
      (declare-const ?bika Real)
      (assert
        (and (and (not (= ?bika ?bijz))
            (not (= ?bika ?bijy))
            )
          (not (= ?bijz ?bijy))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bikb Real)
      (declare-const ?bikc Real)
      (declare-const ?bikd Real)
      (assert
        (and (and (not (= ?bikd ?bikc))
            (not (= ?bikd ?bikb))
            )
          (not (= ?bikc ?bikb))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bike Real)
  (declare-const ?bikf Real)
  (declare-const ?bikg Real)
  (assert
    (and (and (not (= ?bikg ?bikf))
        (not (= ?bikg ?bike))
        )
      (not (= ?bikf ?bike))
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bikh Real)
  (declare-const ?biki Real)
  (declare-const ?bikj Real)
  (declare-const ?bikk Real)
  (assert
    (forall ((?awmg Real) )(or (and (or (or (= ?biki ?bikh)
              (= ?biki ?awmg)
              )
            (= ?bikh ?awmg)
            )
          (or (or (= ?bikk ?bikj)
              (= ?bikk ?awmg)
              )
            (= ?bikj ?awmg)
            )
          )
        (and (not (= ?biki ?bikh))
          (and (and (not (= ?bikk ?bikj))
              (not (= ?bikk ?awmg))
              )
            (not (= ?bikj ?awmg))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bikl Real)
  (declare-const ?bikm Real)
  (declare-const ?bikn Real)
  (assert
    (and (and (not (= ?bikn ?bikm))
        (not (= ?bikn ?bikl))
        )
      (not (= ?bikm ?bikl))
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?biko Real)
  (declare-const ?bikp Real)
  (declare-const ?bikq Real)
  (declare-const ?bikr Real)
  (declare-const ?biks Real)
  (declare-const ?bikt Real)
  (assert
    (or (and (or (or (= ?bikq ?bikp)
            (= ?bikq ?biko)
            )
          (= ?bikp ?biko)
          )
        (or (or (= ?bikt ?biks)
            (= ?bikt ?bikr)
            )
          (= ?biks ?bikr)
          )
        )
      (and (and (and (not (= ?bikq ?bikp))
            (not (= ?bikq ?biko))
            )
          (not (= ?bikp ?biko))
          )
        (and (and (not (= ?bikt ?biks))
            (not (= ?bikt ?bikr))
            )
          (not (= ?biks ?bikr))
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?biku Real)
  (declare-const ?bikv Real)
  (declare-const ?bikw Real)
  (assert
    (and (and (not (= ?bikw ?bikv))
        (not (= ?bikw ?biku))
        )
      (not (= ?bikv ?biku))
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bikx Real)
  (declare-const ?biky Real)
  (declare-const ?bikz Real)
  (assert
    (and (and (not (= ?bikz ?biky))
        (not (= ?bikz ?bikx))
        )
      (not (= ?biky ?bikx))
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?bila Real)
    (declare-const ?bilb Real)
    (declare-const ?bilc Real)
    (declare-const ?bild Real)
    (assert
      (forall ((?awmg Real) )(or (and (or (or (= ?bilb ?bila)
                (= ?bilb ?awmg)
                )
              (= ?bila ?awmg)
              )
            (or (or (= ?bild ?bilc)
                (= ?bild ?awmg)
                )
              (= ?bilc ?awmg)
              )
            )
          (and (not (= ?bilb ?bila))
            (and (and (not (= ?bild ?bilc))
                (not (= ?bild ?awmg))
                )
              (not (= ?bilc ?awmg))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bile Real)
    (declare-const ?bilf Real)
    (declare-const ?bilg Real)
    (declare-const ?bilh Real)
    (declare-const ?bili Real)
    (declare-const ?bilj Real)
    (assert
      (or (and (or (or (= ?bilg ?bilf)
              (= ?bilg ?bile)
              )
            (= ?bilf ?bile)
            )
          (or (or (= ?bilj ?bili)
              (= ?bilj ?bilh)
              )
            (= ?bili ?bilh)
            )
          )
        (and (and (and (not (= ?bilg ?bilf))
              (not (= ?bilg ?bile))
              )
            (not (= ?bilf ?bile))
            )
          (and (and (not (= ?bilj ?bili))
              (not (= ?bilj ?bilh))
              )
            (not (= ?bili ?bilh))
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bilk Real)
    (declare-const ?bill Real)
    (declare-const ?bilm Real)
    (assert
      (and (and (not (= ?bilm ?bill))
          (not (= ?bilm ?bilk))
          )
        (not (= ?bill ?bilk))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?biln Real)
    (declare-const ?bilo Real)
    (declare-const ?bilp Real)
    (assert
      (and (and (not (= ?bilp ?bilo))
          (not (= ?bilp ?biln))
          )
        (not (= ?bilo ?biln))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (push 1)
      (push 1)
        (declare-const ?bilr Real)
        (declare-const ?bils Real)
        (declare-const ?bilt Real)
        (declare-const ?bilu Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bils ?bilr)
                    (= ?bils ?awmg)
                    )
                  (= ?bilr ?awmg)
                  )
                (or (or (= ?bilu ?bilt)
                    (= ?bilu ?awmg)
                    )
                  (= ?bilt ?awmg)
                  )
                )
              (and (not (= ?bils ?bilr))
                (and (and (not (= ?bilu ?bilt))
                    (not (= ?bilu ?awmg))
                    )
                  (not (= ?bilt ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bilv Real)
        (declare-const ?bilw Real)
        (declare-const ?bilx Real)
        (declare-const ?bily Real)
        (declare-const ?bilz Real)
        (declare-const ?bima Real)
        (assert
          (or (and (or (or (= ?bilx ?bilw)
                  (= ?bilx ?bilv)
                  )
                (= ?bilw ?bilv)
                )
              (or (or (= ?bima ?bilz)
                  (= ?bima ?bily)
                  )
                (= ?bilz ?bily)
                )
              )
            (and (and (and (not (= ?bilx ?bilw))
                  (not (= ?bilx ?bilv))
                  )
                (not (= ?bilw ?bilv))
                )
              (and (and (not (= ?bima ?bilz))
                  (not (= ?bima ?bily))
                  )
                (not (= ?bilz ?bily))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bimb Real)
        (declare-const ?bimc Real)
        (declare-const ?bimd Real)
        (assert
          (and (and (not (= ?bimd ?bimc))
              (not (= ?bimd ?bimb))
              )
            (not (= ?bimc ?bimb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bime Real)
        (declare-const ?bimf Real)
        (declare-const ?bimg Real)
        (assert
          (and (and (not (= ?bimg ?bimf))
              (not (= ?bimg ?bime))
              )
            (not (= ?bimf ?bime))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bimh Real)
          (push 1)
            (declare-const ?bimi Real)
            (push 1)
              (declare-const ?bimj Real)
              (push 1)
                (assert
                  (and (= ?bimi ?bimh)
                    (= ?bimj ?bimh)
                    )
                  )
                (push 1)
                  (declare-const ?bimk Real)
                  (declare-const ?biml Real)
                  (declare-const ?bimm Real)
                  (declare-const ?bimn Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?biml ?bimk)
                              (= ?biml ?awmg)
                              )
                            (= ?bimk ?awmg)
                            )
                          (or (or (= ?bimn ?bimm)
                              (= ?bimn ?awmg)
                              )
                            (= ?bimm ?awmg)
                            )
                          )
                        (and (not (= ?biml ?bimk))
                          (and (and (not (= ?bimn ?bimm))
                              (not (= ?bimn ?awmg))
                              )
                            (not (= ?bimm ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bimo Real)
                  (declare-const ?bimp Real)
                  (declare-const ?bimq Real)
                  (declare-const ?bimr Real)
                  (declare-const ?bims Real)
                  (declare-const ?bimt Real)
                  (assert
                    (or (and (or (or (= ?bimq ?bimp)
                            (= ?bimq ?bimo)
                            )
                          (= ?bimp ?bimo)
                          )
                        (or (or (= ?bimt ?bims)
                            (= ?bimt ?bimr)
                            )
                          (= ?bims ?bimr)
                          )
                        )
                      (and (and (and (not (= ?bimq ?bimp))
                            (not (= ?bimq ?bimo))
                            )
                          (not (= ?bimp ?bimo))
                          )
                        (and (and (not (= ?bimt ?bims))
                            (not (= ?bimt ?bimr))
                            )
                          (not (= ?bims ?bimr))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bimu Real)
                  (declare-const ?bimv Real)
                  (declare-const ?bimw Real)
                  (assert
                    (and (and (not (= ?bimw ?bimv))
                        (not (= ?bimw ?bimu))
                        )
                      (not (= ?bimv ?bimu))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bimx Real)
                  (declare-const ?bimy Real)
                  (declare-const ?bimz Real)
                  (assert
                    (and (and (not (= ?bimz ?bimy))
                        (not (= ?bimz ?bimx))
                        )
                      (not (= ?bimy ?bimx))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bina Real)
      (push 1)
        (declare-const ?binb Real)
        (declare-const ?binc Real)
        (declare-const ?bind Real)
        (declare-const ?bine Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?binc ?binb)
                    (= ?binc ?awmg)
                    )
                  (= ?binb ?awmg)
                  )
                (or (or (= ?bine ?bind)
                    (= ?bine ?awmg)
                    )
                  (= ?bind ?awmg)
                  )
                )
              (and (not (= ?binc ?binb))
                (and (and (not (= ?bine ?bind))
                    (not (= ?bine ?awmg))
                    )
                  (not (= ?bind ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?binf Real)
        (declare-const ?bing Real)
        (declare-const ?binh Real)
        (declare-const ?bini Real)
        (declare-const ?binj Real)
        (declare-const ?bink Real)
        (assert
          (or (and (or (or (= ?binh ?bing)
                  (= ?binh ?binf)
                  )
                (= ?bing ?binf)
                )
              (or (or (= ?bink ?binj)
                  (= ?bink ?bini)
                  )
                (= ?binj ?bini)
                )
              )
            (and (and (and (not (= ?binh ?bing))
                  (not (= ?binh ?binf))
                  )
                (not (= ?bing ?binf))
                )
              (and (and (not (= ?bink ?binj))
                  (not (= ?bink ?bini))
                  )
                (not (= ?binj ?bini))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?binl Real)
        (declare-const ?binm Real)
        (declare-const ?binn Real)
        (assert
          (and (and (not (= ?binn ?binm))
              (not (= ?binn ?binl))
              )
            (not (= ?binm ?binl))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bino Real)
        (declare-const ?binp Real)
        (declare-const ?binq Real)
        (assert
          (and (and (not (= ?binq ?binp))
              (not (= ?binq ?bino))
              )
            (not (= ?binp ?bino))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?binr Real)
      (declare-const ?bins Real)
      (push 1)
        (declare-const ?bint Real)
        (declare-const ?binu Real)
        (declare-const ?binv Real)
        (declare-const ?binw Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?binu ?bint)
                    (= ?binu ?awmg)
                    )
                  (= ?bint ?awmg)
                  )
                (or (or (= ?binw ?binv)
                    (= ?binw ?awmg)
                    )
                  (= ?binv ?awmg)
                  )
                )
              (and (not (= ?binu ?bint))
                (and (and (not (= ?binw ?binv))
                    (not (= ?binw ?awmg))
                    )
                  (not (= ?binv ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?binx Real)
        (declare-const ?biny Real)
        (declare-const ?binz Real)
        (declare-const ?bioa Real)
        (declare-const ?biob Real)
        (declare-const ?bioc Real)
        (assert
          (or (and (or (or (= ?binz ?biny)
                  (= ?binz ?binx)
                  )
                (= ?biny ?binx)
                )
              (or (or (= ?bioc ?biob)
                  (= ?bioc ?bioa)
                  )
                (= ?biob ?bioa)
                )
              )
            (and (and (and (not (= ?binz ?biny))
                  (not (= ?binz ?binx))
                  )
                (not (= ?biny ?binx))
                )
              (and (and (not (= ?bioc ?biob))
                  (not (= ?bioc ?bioa))
                  )
                (not (= ?biob ?bioa))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?biod Real)
        (declare-const ?bioe Real)
        (declare-const ?biof Real)
        (assert
          (and (and (not (= ?biof ?bioe))
              (not (= ?biof ?biod))
              )
            (not (= ?bioe ?biod))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?biog Real)
        (declare-const ?bioh Real)
        (declare-const ?bioi Real)
        (assert
          (and (and (not (= ?bioi ?bioh))
              (not (= ?bioi ?biog))
              )
            (not (= ?bioh ?biog))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bioj Real)
      (declare-const ?biok Real)
      (declare-const ?biol Real)
      (push 1)
        (declare-const ?biom Real)
        (declare-const ?bion Real)
        (declare-const ?bioo Real)
        (declare-const ?biop Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bion ?biom)
                    (= ?bion ?awmg)
                    )
                  (= ?biom ?awmg)
                  )
                (or (or (= ?biop ?bioo)
                    (= ?biop ?awmg)
                    )
                  (= ?bioo ?awmg)
                  )
                )
              (and (not (= ?bion ?biom))
                (and (and (not (= ?biop ?bioo))
                    (not (= ?biop ?awmg))
                    )
                  (not (= ?bioo ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bioq Real)
        (declare-const ?bior Real)
        (declare-const ?bios Real)
        (declare-const ?biot Real)
        (declare-const ?biou Real)
        (declare-const ?biov Real)
        (assert
          (or (and (or (or (= ?bios ?bior)
                  (= ?bios ?bioq)
                  )
                (= ?bior ?bioq)
                )
              (or (or (= ?biov ?biou)
                  (= ?biov ?biot)
                  )
                (= ?biou ?biot)
                )
              )
            (and (and (and (not (= ?bios ?bior))
                  (not (= ?bios ?bioq))
                  )
                (not (= ?bior ?bioq))
                )
              (and (and (not (= ?biov ?biou))
                  (not (= ?biov ?biot))
                  )
                (not (= ?biou ?biot))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?biow Real)
        (declare-const ?biox Real)
        (declare-const ?bioy Real)
        (assert
          (and (and (not (= ?bioy ?biox))
              (not (= ?bioy ?biow))
              )
            (not (= ?biox ?biow))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bioz Real)
        (declare-const ?bipa Real)
        (declare-const ?bipb Real)
        (assert
          (and (and (not (= ?bipb ?bipa))
              (not (= ?bipb ?bioz))
              )
            (not (= ?bipa ?bioz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (declare-const ?bipc Real)
        (declare-const ?bipd Real)
        (declare-const ?bipe Real)
        (declare-const ?bipf Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bipd ?bipc)
                    (= ?bipd ?awmg)
                    )
                  (= ?bipc ?awmg)
                  )
                (or (or (= ?bipf ?bipe)
                    (= ?bipf ?awmg)
                    )
                  (= ?bipe ?awmg)
                  )
                )
              (and (not (= ?bipd ?bipc))
                (and (and (not (= ?bipf ?bipe))
                    (not (= ?bipf ?awmg))
                    )
                  (not (= ?bipe ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bipg Real)
        (declare-const ?biph Real)
        (declare-const ?bipi Real)
        (declare-const ?bipj Real)
        (declare-const ?bipk Real)
        (declare-const ?bipl Real)
        (assert
          (or (and (or (or (= ?bipi ?biph)
                  (= ?bipi ?bipg)
                  )
                (= ?biph ?bipg)
                )
              (or (or (= ?bipl ?bipk)
                  (= ?bipl ?bipj)
                  )
                (= ?bipk ?bipj)
                )
              )
            (and (and (and (not (= ?bipi ?biph))
                  (not (= ?bipi ?bipg))
                  )
                (not (= ?biph ?bipg))
                )
              (and (and (not (= ?bipl ?bipk))
                  (not (= ?bipl ?bipj))
                  )
                (not (= ?bipk ?bipj))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bipm Real)
        (declare-const ?bipn Real)
        (declare-const ?bipo Real)
        (assert
          (and (and (not (= ?bipo ?bipn))
              (not (= ?bipo ?bipm))
              )
            (not (= ?bipn ?bipm))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bipp Real)
        (declare-const ?bipq Real)
        (declare-const ?bipr Real)
        (assert
          (and (and (not (= ?bipr ?bipq))
              (not (= ?bipr ?bipp))
              )
            (not (= ?bipq ?bipp))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bips Real)
    (push 1)
      (push 1)
        (declare-const ?bipt Real)
        (declare-const ?bipu Real)
        (declare-const ?bipv Real)
        (declare-const ?bipw Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bipu ?bipt)
                    (= ?bipu ?awmg)
                    )
                  (= ?bipt ?awmg)
                  )
                (or (or (= ?bipw ?bipv)
                    (= ?bipw ?awmg)
                    )
                  (= ?bipv ?awmg)
                  )
                )
              (and (not (= ?bipu ?bipt))
                (and (and (not (= ?bipw ?bipv))
                    (not (= ?bipw ?awmg))
                    )
                  (not (= ?bipv ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bipx Real)
        (declare-const ?bipy Real)
        (declare-const ?bipz Real)
        (declare-const ?biqa Real)
        (declare-const ?biqb Real)
        (declare-const ?biqc Real)
        (assert
          (or (and (or (or (= ?bipz ?bipy)
                  (= ?bipz ?bipx)
                  )
                (= ?bipy ?bipx)
                )
              (or (or (= ?biqc ?biqb)
                  (= ?biqc ?biqa)
                  )
                (= ?biqb ?biqa)
                )
              )
            (and (and (and (not (= ?bipz ?bipy))
                  (not (= ?bipz ?bipx))
                  )
                (not (= ?bipy ?bipx))
                )
              (and (and (not (= ?biqc ?biqb))
                  (not (= ?biqc ?biqa))
                  )
                (not (= ?biqb ?biqa))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?biqd Real)
        (declare-const ?biqe Real)
        (declare-const ?biqf Real)
        (assert
          (and (and (not (= ?biqf ?biqe))
              (not (= ?biqf ?biqd))
              )
            (not (= ?biqe ?biqd))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?biqg Real)
        (declare-const ?biqh Real)
        (declare-const ?biqi Real)
        (assert
          (and (and (not (= ?biqi ?biqh))
              (not (= ?biqi ?biqg))
              )
            (not (= ?biqh ?biqg))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?biqj Real)
      (push 1)
        (declare-const ?biqk Real)
        (declare-const ?biql Real)
        (declare-const ?biqm Real)
        (declare-const ?biqn Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?biql ?biqk)
                    (= ?biql ?awmg)
                    )
                  (= ?biqk ?awmg)
                  )
                (or (or (= ?biqn ?biqm)
                    (= ?biqn ?awmg)
                    )
                  (= ?biqm ?awmg)
                  )
                )
              (and (not (= ?biql ?biqk))
                (and (and (not (= ?biqn ?biqm))
                    (not (= ?biqn ?awmg))
                    )
                  (not (= ?biqm ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?biqo Real)
        (declare-const ?biqp Real)
        (declare-const ?biqq Real)
        (declare-const ?biqr Real)
        (declare-const ?biqs Real)
        (declare-const ?biqt Real)
        (assert
          (or (and (or (or (= ?biqq ?biqp)
                  (= ?biqq ?biqo)
                  )
                (= ?biqp ?biqo)
                )
              (or (or (= ?biqt ?biqs)
                  (= ?biqt ?biqr)
                  )
                (= ?biqs ?biqr)
                )
              )
            (and (and (and (not (= ?biqq ?biqp))
                  (not (= ?biqq ?biqo))
                  )
                (not (= ?biqp ?biqo))
                )
              (and (and (not (= ?biqt ?biqs))
                  (not (= ?biqt ?biqr))
                  )
                (not (= ?biqs ?biqr))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?biqu Real)
        (declare-const ?biqv Real)
        (declare-const ?biqw Real)
        (assert
          (and (and (not (= ?biqw ?biqv))
              (not (= ?biqw ?biqu))
              )
            (not (= ?biqv ?biqu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?biqx Real)
        (declare-const ?biqy Real)
        (declare-const ?biqz Real)
        (assert
          (and (and (not (= ?biqz ?biqy))
              (not (= ?biqz ?biqx))
              )
            (not (= ?biqy ?biqx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (= ?biqj ?bips)
          )
        (push 1)
          (declare-const ?bira Real)
          (push 1)
            (declare-const ?birb Real)
            (declare-const ?birc Real)
            (push 1)
              (declare-const ?bird Real)
              (declare-const ?bire Real)
              (push 1)
                (assert
                  (and (and (and (= ?birb ?bips)
                        (= ?birc ?bira)
                        )
                      (= ?bird ?biqj)
                      )
                    (= ?bire ?bira)
                    )
                  )
                (push 1)
                  (declare-const ?birf Real)
                  (declare-const ?birg Real)
                  (declare-const ?birh Real)
                  (declare-const ?biri Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?birg ?birf)
                              (= ?birg ?awmg)
                              )
                            (= ?birf ?awmg)
                            )
                          (or (or (= ?biri ?birh)
                              (= ?biri ?awmg)
                              )
                            (= ?birh ?awmg)
                            )
                          )
                        (and (not (= ?birg ?birf))
                          (and (and (not (= ?biri ?birh))
                              (not (= ?biri ?awmg))
                              )
                            (not (= ?birh ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?birj Real)
                  (declare-const ?birk Real)
                  (declare-const ?birl Real)
                  (declare-const ?birm Real)
                  (declare-const ?birn Real)
                  (declare-const ?biro Real)
                  (assert
                    (or (and (or (or (= ?birl ?birk)
                            (= ?birl ?birj)
                            )
                          (= ?birk ?birj)
                          )
                        (or (or (= ?biro ?birn)
                            (= ?biro ?birm)
                            )
                          (= ?birn ?birm)
                          )
                        )
                      (and (and (and (not (= ?birl ?birk))
                            (not (= ?birl ?birj))
                            )
                          (not (= ?birk ?birj))
                          )
                        (and (and (not (= ?biro ?birn))
                            (not (= ?biro ?birm))
                            )
                          (not (= ?birn ?birm))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?birp Real)
                  (declare-const ?birq Real)
                  (declare-const ?birr Real)
                  (assert
                    (and (and (not (= ?birr ?birq))
                        (not (= ?birr ?birp))
                        )
                      (not (= ?birq ?birp))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?birs Real)
                  (declare-const ?birt Real)
                  (declare-const ?biru Real)
                  (assert
                    (and (and (not (= ?biru ?birt))
                        (not (= ?biru ?birs))
                        )
                      (not (= ?birt ?birs))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (assert
                    (exists ((?awmg Real) )(and (or (and (and (not (= ?bird ?bire))
                              (not (= ?bird ?awmg))
                              )
                            (not (= ?bire ?awmg))
                            )
                          (and (and (not (= ?birb ?birc))
                              (not (= ?birb ?awmg))
                              )
                            (not (= ?birc ?awmg))
                            )
                          )
                        (or (= ?bird ?bire)
                          (or (or (= ?birb ?birc)
                              (= ?birb ?awmg)
                              )
                            (= ?birc ?awmg)
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?birv Real)
      (declare-const ?birw Real)
      (push 1)
        (declare-const ?birx Real)
        (declare-const ?biry Real)
        (declare-const ?birz Real)
        (declare-const ?bisa Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?biry ?birx)
                    (= ?biry ?awmg)
                    )
                  (= ?birx ?awmg)
                  )
                (or (or (= ?bisa ?birz)
                    (= ?bisa ?awmg)
                    )
                  (= ?birz ?awmg)
                  )
                )
              (and (not (= ?biry ?birx))
                (and (and (not (= ?bisa ?birz))
                    (not (= ?bisa ?awmg))
                    )
                  (not (= ?birz ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bisb Real)
        (declare-const ?bisc Real)
        (declare-const ?bisd Real)
        (declare-const ?bise Real)
        (declare-const ?bisf Real)
        (declare-const ?bisg Real)
        (assert
          (or (and (or (or (= ?bisd ?bisc)
                  (= ?bisd ?bisb)
                  )
                (= ?bisc ?bisb)
                )
              (or (or (= ?bisg ?bisf)
                  (= ?bisg ?bise)
                  )
                (= ?bisf ?bise)
                )
              )
            (and (and (and (not (= ?bisd ?bisc))
                  (not (= ?bisd ?bisb))
                  )
                (not (= ?bisc ?bisb))
                )
              (and (and (not (= ?bisg ?bisf))
                  (not (= ?bisg ?bise))
                  )
                (not (= ?bisf ?bise))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bish Real)
        (declare-const ?bisi Real)
        (declare-const ?bisj Real)
        (assert
          (and (and (not (= ?bisj ?bisi))
              (not (= ?bisj ?bish))
              )
            (not (= ?bisi ?bish))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bisk Real)
        (declare-const ?bisl Real)
        (declare-const ?bism Real)
        (assert
          (and (and (not (= ?bism ?bisl))
              (not (= ?bism ?bisk))
              )
            (not (= ?bisl ?bisk))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bisn Real)
      (declare-const ?biso Real)
      (declare-const ?bisp Real)
      (push 1)
        (declare-const ?bisq Real)
        (declare-const ?bisr Real)
        (declare-const ?biss Real)
        (declare-const ?bist Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bisr ?bisq)
                    (= ?bisr ?awmg)
                    )
                  (= ?bisq ?awmg)
                  )
                (or (or (= ?bist ?biss)
                    (= ?bist ?awmg)
                    )
                  (= ?biss ?awmg)
                  )
                )
              (and (not (= ?bisr ?bisq))
                (and (and (not (= ?bist ?biss))
                    (not (= ?bist ?awmg))
                    )
                  (not (= ?biss ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bisu Real)
        (declare-const ?bisv Real)
        (declare-const ?bisw Real)
        (declare-const ?bisx Real)
        (declare-const ?bisy Real)
        (declare-const ?bisz Real)
        (assert
          (or (and (or (or (= ?bisw ?bisv)
                  (= ?bisw ?bisu)
                  )
                (= ?bisv ?bisu)
                )
              (or (or (= ?bisz ?bisy)
                  (= ?bisz ?bisx)
                  )
                (= ?bisy ?bisx)
                )
              )
            (and (and (and (not (= ?bisw ?bisv))
                  (not (= ?bisw ?bisu))
                  )
                (not (= ?bisv ?bisu))
                )
              (and (and (not (= ?bisz ?bisy))
                  (not (= ?bisz ?bisx))
                  )
                (not (= ?bisy ?bisx))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bita Real)
        (declare-const ?bitb Real)
        (declare-const ?bitc Real)
        (assert
          (and (and (not (= ?bitc ?bitb))
              (not (= ?bitc ?bita))
              )
            (not (= ?bitb ?bita))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bitd Real)
        (declare-const ?bite Real)
        (declare-const ?bitf Real)
        (assert
          (and (and (not (= ?bitf ?bite))
              (not (= ?bitf ?bitd))
              )
            (not (= ?bite ?bitd))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (declare-const ?bitg Real)
        (declare-const ?bith Real)
        (declare-const ?biti Real)
        (declare-const ?bitj Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bith ?bitg)
                    (= ?bith ?awmg)
                    )
                  (= ?bitg ?awmg)
                  )
                (or (or (= ?bitj ?biti)
                    (= ?bitj ?awmg)
                    )
                  (= ?biti ?awmg)
                  )
                )
              (and (not (= ?bith ?bitg))
                (and (and (not (= ?bitj ?biti))
                    (not (= ?bitj ?awmg))
                    )
                  (not (= ?biti ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bitk Real)
        (declare-const ?bitl Real)
        (declare-const ?bitm Real)
        (declare-const ?bitn Real)
        (declare-const ?bito Real)
        (declare-const ?bitp Real)
        (assert
          (or (and (or (or (= ?bitm ?bitl)
                  (= ?bitm ?bitk)
                  )
                (= ?bitl ?bitk)
                )
              (or (or (= ?bitp ?bito)
                  (= ?bitp ?bitn)
                  )
                (= ?bito ?bitn)
                )
              )
            (and (and (and (not (= ?bitm ?bitl))
                  (not (= ?bitm ?bitk))
                  )
                (not (= ?bitl ?bitk))
                )
              (and (and (not (= ?bitp ?bito))
                  (not (= ?bitp ?bitn))
                  )
                (not (= ?bito ?bitn))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bitq Real)
        (declare-const ?bitr Real)
        (declare-const ?bits Real)
        (assert
          (and (and (not (= ?bits ?bitr))
              (not (= ?bits ?bitq))
              )
            (not (= ?bitr ?bitq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bitt Real)
        (declare-const ?bitu Real)
        (declare-const ?bitv Real)
        (assert
          (and (and (not (= ?bitv ?bitu))
              (not (= ?bitv ?bitt))
              )
            (not (= ?bitu ?bitt))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bitw Real)
    (declare-const ?bitx Real)
    (push 1)
      (push 1)
        (declare-const ?bity Real)
        (declare-const ?bitz Real)
        (declare-const ?biua Real)
        (declare-const ?biub Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bitz ?bity)
                    (= ?bitz ?awmg)
                    )
                  (= ?bity ?awmg)
                  )
                (or (or (= ?biub ?biua)
                    (= ?biub ?awmg)
                    )
                  (= ?biua ?awmg)
                  )
                )
              (and (not (= ?bitz ?bity))
                (and (and (not (= ?biub ?biua))
                    (not (= ?biub ?awmg))
                    )
                  (not (= ?biua ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?biuc Real)
        (declare-const ?biud Real)
        (declare-const ?biue Real)
        (declare-const ?biuf Real)
        (declare-const ?biug Real)
        (declare-const ?biuh Real)
        (assert
          (or (and (or (or (= ?biue ?biud)
                  (= ?biue ?biuc)
                  )
                (= ?biud ?biuc)
                )
              (or (or (= ?biuh ?biug)
                  (= ?biuh ?biuf)
                  )
                (= ?biug ?biuf)
                )
              )
            (and (and (and (not (= ?biue ?biud))
                  (not (= ?biue ?biuc))
                  )
                (not (= ?biud ?biuc))
                )
              (and (and (not (= ?biuh ?biug))
                  (not (= ?biuh ?biuf))
                  )
                (not (= ?biug ?biuf))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?biui Real)
        (declare-const ?biuj Real)
        (declare-const ?biuk Real)
        (assert
          (and (and (not (= ?biuk ?biuj))
              (not (= ?biuk ?biui))
              )
            (not (= ?biuj ?biui))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?biul Real)
        (declare-const ?bium Real)
        (declare-const ?biun Real)
        (assert
          (and (and (not (= ?biun ?bium))
              (not (= ?biun ?biul))
              )
            (not (= ?bium ?biul))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?biuo Real)
      (push 1)
        (declare-const ?biup Real)
        (declare-const ?biuq Real)
        (declare-const ?biur Real)
        (declare-const ?bius Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?biuq ?biup)
                    (= ?biuq ?awmg)
                    )
                  (= ?biup ?awmg)
                  )
                (or (or (= ?bius ?biur)
                    (= ?bius ?awmg)
                    )
                  (= ?biur ?awmg)
                  )
                )
              (and (not (= ?biuq ?biup))
                (and (and (not (= ?bius ?biur))
                    (not (= ?bius ?awmg))
                    )
                  (not (= ?biur ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?biut Real)
        (declare-const ?biuu Real)
        (declare-const ?biuv Real)
        (declare-const ?biuw Real)
        (declare-const ?biux Real)
        (declare-const ?biuy Real)
        (assert
          (or (and (or (or (= ?biuv ?biuu)
                  (= ?biuv ?biut)
                  )
                (= ?biuu ?biut)
                )
              (or (or (= ?biuy ?biux)
                  (= ?biuy ?biuw)
                  )
                (= ?biux ?biuw)
                )
              )
            (and (and (and (not (= ?biuv ?biuu))
                  (not (= ?biuv ?biut))
                  )
                (not (= ?biuu ?biut))
                )
              (and (and (not (= ?biuy ?biux))
                  (not (= ?biuy ?biuw))
                  )
                (not (= ?biux ?biuw))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?biuz Real)
        (declare-const ?biva Real)
        (declare-const ?bivb Real)
        (assert
          (and (and (not (= ?bivb ?biva))
              (not (= ?bivb ?biuz))
              )
            (not (= ?biva ?biuz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bivc Real)
        (declare-const ?bivd Real)
        (declare-const ?bive Real)
        (assert
          (and (and (not (= ?bive ?bivd))
              (not (= ?bive ?bivc))
              )
            (not (= ?bivd ?bivc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bivf Real)
      (declare-const ?bivg Real)
      (push 1)
        (declare-const ?bivh Real)
        (declare-const ?bivi Real)
        (declare-const ?bivj Real)
        (declare-const ?bivk Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bivi ?bivh)
                    (= ?bivi ?awmg)
                    )
                  (= ?bivh ?awmg)
                  )
                (or (or (= ?bivk ?bivj)
                    (= ?bivk ?awmg)
                    )
                  (= ?bivj ?awmg)
                  )
                )
              (and (not (= ?bivi ?bivh))
                (and (and (not (= ?bivk ?bivj))
                    (not (= ?bivk ?awmg))
                    )
                  (not (= ?bivj ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bivl Real)
        (declare-const ?bivm Real)
        (declare-const ?bivn Real)
        (declare-const ?bivo Real)
        (declare-const ?bivp Real)
        (declare-const ?bivq Real)
        (assert
          (or (and (or (or (= ?bivn ?bivm)
                  (= ?bivn ?bivl)
                  )
                (= ?bivm ?bivl)
                )
              (or (or (= ?bivq ?bivp)
                  (= ?bivq ?bivo)
                  )
                (= ?bivp ?bivo)
                )
              )
            (and (and (and (not (= ?bivn ?bivm))
                  (not (= ?bivn ?bivl))
                  )
                (not (= ?bivm ?bivl))
                )
              (and (and (not (= ?bivq ?bivp))
                  (not (= ?bivq ?bivo))
                  )
                (not (= ?bivp ?bivo))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bivr Real)
        (declare-const ?bivs Real)
        (declare-const ?bivt Real)
        (assert
          (and (and (not (= ?bivt ?bivs))
              (not (= ?bivt ?bivr))
              )
            (not (= ?bivs ?bivr))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bivu Real)
        (declare-const ?bivv Real)
        (declare-const ?bivw Real)
        (assert
          (and (and (not (= ?bivw ?bivv))
              (not (= ?bivw ?bivu))
              )
            (not (= ?bivv ?bivu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bivg ?bivf)
                    (= ?bivg ?awmg)
                    )
                  (= ?bivf ?awmg)
                  )
                (or (or (= ?bitx ?bitw)
                    (= ?bitx ?awmg)
                    )
                  (= ?bitw ?awmg)
                  )
                )
              (and (not (= ?bivg ?bivf))
                (and (and (not (= ?bitx ?bitw))
                    (not (= ?bitx ?awmg))
                    )
                  (not (= ?bitw ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bivx Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bivy Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bivz Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?biwa Real)
              (declare-const ?biwb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?biwc Real)
              (declare-const ?biwd Real)
              (declare-const ?biwe Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?biwf Real)
              (declare-const ?biwg Real)
              (declare-const ?biwh Real)
              (declare-const ?biwi Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?biwj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?biwk Real)
            (declare-const ?biwl Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?biwm Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?biwn Real)
              (declare-const ?biwo Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?biwp Real)
              (declare-const ?biwq Real)
              (declare-const ?biwr Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?biws Real)
              (declare-const ?biwt Real)
              (declare-const ?biwu Real)
              (declare-const ?biwv Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?biww Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?biwx Real)
            (declare-const ?biwy Real)
            (declare-const ?biwz Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bixa Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bixb Real)
              (declare-const ?bixc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bixd Real)
              (declare-const ?bixe Real)
              (declare-const ?bixf Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (and (and (= ?biwy ?bitx)
                          (= ?biwx ?bitw)
                          )
                        (= ?biwz ?bivx)
                        )
                      (and (= ?bixe ?bivg)
                        (= ?bixd ?bivf)
                        )
                      )
                    (= ?bixf ?bivx)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bixg Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bixh Real)
                  (declare-const ?bixi Real)
                  (declare-const ?bixj Real)
                  (declare-const ?bixk Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bixi ?bixh)
                              (= ?bixi ?awmg)
                              )
                            (= ?bixh ?awmg)
                            )
                          (or (or (= ?bixk ?bixj)
                              (= ?bixk ?awmg)
                              )
                            (= ?bixj ?awmg)
                            )
                          )
                        (and (not (= ?bixi ?bixh))
                          (and (and (not (= ?bixk ?bixj))
                              (not (= ?bixk ?awmg))
                              )
                            (not (= ?bixj ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bixl Real)
                  (declare-const ?bixm Real)
                  (declare-const ?bixn Real)
                  (declare-const ?bixo Real)
                  (declare-const ?bixp Real)
                  (declare-const ?bixq Real)
                  (assert
                    (or (and (or (or (= ?bixn ?bixm)
                            (= ?bixn ?bixl)
                            )
                          (= ?bixm ?bixl)
                          )
                        (or (or (= ?bixq ?bixp)
                            (= ?bixq ?bixo)
                            )
                          (= ?bixp ?bixo)
                          )
                        )
                      (and (and (and (not (= ?bixn ?bixm))
                            (not (= ?bixn ?bixl))
                            )
                          (not (= ?bixm ?bixl))
                          )
                        (and (and (not (= ?bixq ?bixp))
                            (not (= ?bixq ?bixo))
                            )
                          (not (= ?bixp ?bixo))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bixr Real)
                  (declare-const ?bixs Real)
                  (declare-const ?bixt Real)
                  (assert
                    (and (and (not (= ?bixt ?bixs))
                        (not (= ?bixt ?bixr))
                        )
                      (not (= ?bixs ?bixr))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bixu Real)
                  (declare-const ?bixv Real)
                  (declare-const ?bixw Real)
                  (assert
                    (and (and (not (= ?bixw ?bixv))
                        (not (= ?bixw ?bixu))
                        )
                      (not (= ?bixv ?bixu))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (assert
                    (and (or (and (and (not (= ?bixe ?bixd))
                            (not (= ?bixe ?bixf))
                            )
                          (not (= ?bixd ?bixf))
                          )
                        (and (and (not (= ?biwy ?biwx))
                            (not (= ?biwy ?biwz))
                            )
                          (not (= ?biwx ?biwz))
                          )
                        )
                      (or (or (or (= ?bixe ?bixd)
                            (= ?bixe ?bixf)
                            )
                          (= ?bixd ?bixf)
                          )
                        (or (or (= ?biwy ?biwx)
                            (= ?biwy ?biwz)
                            )
                          (= ?biwx ?biwz)
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?bixx Real)
              (declare-const ?bixy Real)
              (declare-const ?bixz Real)
              (declare-const ?biya Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?biyb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?biyc Real)
            (declare-const ?biyd Real)
            (declare-const ?biye Real)
            (declare-const ?biyf Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?biyg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?biyh Real)
              (declare-const ?biyi Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?biyj Real)
              (declare-const ?biyk Real)
              (declare-const ?biyl Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?biym Real)
              (declare-const ?biyn Real)
              (declare-const ?biyo Real)
              (declare-const ?biyp Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?biyq Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?biyr Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?biys Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?biyt Real)
              (declare-const ?biyu Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?biyv Real)
              (declare-const ?biyw Real)
              (declare-const ?biyx Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?biyy Real)
              (declare-const ?biyz Real)
              (declare-const ?biza Real)
              (declare-const ?bizb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bizc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bizd Real)
      (declare-const ?bize Real)
      (declare-const ?bizf Real)
      (push 1)
        (declare-const ?bizg Real)
        (declare-const ?bizh Real)
        (declare-const ?bizi Real)
        (declare-const ?bizj Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bizh ?bizg)
                    (= ?bizh ?awmg)
                    )
                  (= ?bizg ?awmg)
                  )
                (or (or (= ?bizj ?bizi)
                    (= ?bizj ?awmg)
                    )
                  (= ?bizi ?awmg)
                  )
                )
              (and (not (= ?bizh ?bizg))
                (and (and (not (= ?bizj ?bizi))
                    (not (= ?bizj ?awmg))
                    )
                  (not (= ?bizi ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bizk Real)
        (declare-const ?bizl Real)
        (declare-const ?bizm Real)
        (declare-const ?bizn Real)
        (declare-const ?bizo Real)
        (declare-const ?bizp Real)
        (assert
          (or (and (or (or (= ?bizm ?bizl)
                  (= ?bizm ?bizk)
                  )
                (= ?bizl ?bizk)
                )
              (or (or (= ?bizp ?bizo)
                  (= ?bizp ?bizn)
                  )
                (= ?bizo ?bizn)
                )
              )
            (and (and (and (not (= ?bizm ?bizl))
                  (not (= ?bizm ?bizk))
                  )
                (not (= ?bizl ?bizk))
                )
              (and (and (not (= ?bizp ?bizo))
                  (not (= ?bizp ?bizn))
                  )
                (not (= ?bizo ?bizn))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bizq Real)
        (declare-const ?bizr Real)
        (declare-const ?bizs Real)
        (assert
          (and (and (not (= ?bizs ?bizr))
              (not (= ?bizs ?bizq))
              )
            (not (= ?bizr ?bizq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bizt Real)
        (declare-const ?bizu Real)
        (declare-const ?bizv Real)
        (assert
          (and (and (not (= ?bizv ?bizu))
              (not (= ?bizv ?bizt))
              )
            (not (= ?bizu ?bizt))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (declare-const ?bizw Real)
        (declare-const ?bizx Real)
        (declare-const ?bizy Real)
        (declare-const ?bizz Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bizx ?bizw)
                    (= ?bizx ?awmg)
                    )
                  (= ?bizw ?awmg)
                  )
                (or (or (= ?bizz ?bizy)
                    (= ?bizz ?awmg)
                    )
                  (= ?bizy ?awmg)
                  )
                )
              (and (not (= ?bizx ?bizw))
                (and (and (not (= ?bizz ?bizy))
                    (not (= ?bizz ?awmg))
                    )
                  (not (= ?bizy ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjaa Real)
        (declare-const ?bjab Real)
        (declare-const ?bjac Real)
        (declare-const ?bjad Real)
        (declare-const ?bjae Real)
        (declare-const ?bjaf Real)
        (assert
          (or (and (or (or (= ?bjac ?bjab)
                  (= ?bjac ?bjaa)
                  )
                (= ?bjab ?bjaa)
                )
              (or (or (= ?bjaf ?bjae)
                  (= ?bjaf ?bjad)
                  )
                (= ?bjae ?bjad)
                )
              )
            (and (and (and (not (= ?bjac ?bjab))
                  (not (= ?bjac ?bjaa))
                  )
                (not (= ?bjab ?bjaa))
                )
              (and (and (not (= ?bjaf ?bjae))
                  (not (= ?bjaf ?bjad))
                  )
                (not (= ?bjae ?bjad))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjag Real)
        (declare-const ?bjah Real)
        (declare-const ?bjai Real)
        (assert
          (and (and (not (= ?bjai ?bjah))
              (not (= ?bjai ?bjag))
              )
            (not (= ?bjah ?bjag))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjaj Real)
        (declare-const ?bjak Real)
        (declare-const ?bjal Real)
        (assert
          (and (and (not (= ?bjal ?bjak))
              (not (= ?bjal ?bjaj))
              )
            (not (= ?bjak ?bjaj))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bjam Real)
    (declare-const ?bjan Real)
    (declare-const ?bjao Real)
    (push 1)
      (push 1)
        (declare-const ?bjap Real)
        (declare-const ?bjaq Real)
        (declare-const ?bjar Real)
        (declare-const ?bjas Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bjaq ?bjap)
                    (= ?bjaq ?awmg)
                    )
                  (= ?bjap ?awmg)
                  )
                (or (or (= ?bjas ?bjar)
                    (= ?bjas ?awmg)
                    )
                  (= ?bjar ?awmg)
                  )
                )
              (and (not (= ?bjaq ?bjap))
                (and (and (not (= ?bjas ?bjar))
                    (not (= ?bjas ?awmg))
                    )
                  (not (= ?bjar ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjat Real)
        (declare-const ?bjau Real)
        (declare-const ?bjav Real)
        (declare-const ?bjaw Real)
        (declare-const ?bjax Real)
        (declare-const ?bjay Real)
        (assert
          (or (and (or (or (= ?bjav ?bjau)
                  (= ?bjav ?bjat)
                  )
                (= ?bjau ?bjat)
                )
              (or (or (= ?bjay ?bjax)
                  (= ?bjay ?bjaw)
                  )
                (= ?bjax ?bjaw)
                )
              )
            (and (and (and (not (= ?bjav ?bjau))
                  (not (= ?bjav ?bjat))
                  )
                (not (= ?bjau ?bjat))
                )
              (and (and (not (= ?bjay ?bjax))
                  (not (= ?bjay ?bjaw))
                  )
                (not (= ?bjax ?bjaw))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjaz Real)
        (declare-const ?bjba Real)
        (declare-const ?bjbb Real)
        (assert
          (and (and (not (= ?bjbb ?bjba))
              (not (= ?bjbb ?bjaz))
              )
            (not (= ?bjba ?bjaz))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjbc Real)
        (declare-const ?bjbd Real)
        (declare-const ?bjbe Real)
        (assert
          (and (and (not (= ?bjbe ?bjbd))
              (not (= ?bjbe ?bjbc))
              )
            (not (= ?bjbd ?bjbc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bjbf Real)
      (push 1)
        (declare-const ?bjbg Real)
        (declare-const ?bjbh Real)
        (declare-const ?bjbi Real)
        (declare-const ?bjbj Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bjbh ?bjbg)
                    (= ?bjbh ?awmg)
                    )
                  (= ?bjbg ?awmg)
                  )
                (or (or (= ?bjbj ?bjbi)
                    (= ?bjbj ?awmg)
                    )
                  (= ?bjbi ?awmg)
                  )
                )
              (and (not (= ?bjbh ?bjbg))
                (and (and (not (= ?bjbj ?bjbi))
                    (not (= ?bjbj ?awmg))
                    )
                  (not (= ?bjbi ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjbk Real)
        (declare-const ?bjbl Real)
        (declare-const ?bjbm Real)
        (declare-const ?bjbn Real)
        (declare-const ?bjbo Real)
        (declare-const ?bjbp Real)
        (assert
          (or (and (or (or (= ?bjbm ?bjbl)
                  (= ?bjbm ?bjbk)
                  )
                (= ?bjbl ?bjbk)
                )
              (or (or (= ?bjbp ?bjbo)
                  (= ?bjbp ?bjbn)
                  )
                (= ?bjbo ?bjbn)
                )
              )
            (and (and (and (not (= ?bjbm ?bjbl))
                  (not (= ?bjbm ?bjbk))
                  )
                (not (= ?bjbl ?bjbk))
                )
              (and (and (not (= ?bjbp ?bjbo))
                  (not (= ?bjbp ?bjbn))
                  )
                (not (= ?bjbo ?bjbn))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjbq Real)
        (declare-const ?bjbr Real)
        (declare-const ?bjbs Real)
        (assert
          (and (and (not (= ?bjbs ?bjbr))
              (not (= ?bjbs ?bjbq))
              )
            (not (= ?bjbr ?bjbq))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjbt Real)
        (declare-const ?bjbu Real)
        (declare-const ?bjbv Real)
        (assert
          (and (and (not (= ?bjbv ?bjbu))
              (not (= ?bjbv ?bjbt))
              )
            (not (= ?bjbu ?bjbt))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bjbw Real)
      (declare-const ?bjbx Real)
      (push 1)
        (declare-const ?bjby Real)
        (declare-const ?bjbz Real)
        (declare-const ?bjca Real)
        (declare-const ?bjcb Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bjbz ?bjby)
                    (= ?bjbz ?awmg)
                    )
                  (= ?bjby ?awmg)
                  )
                (or (or (= ?bjcb ?bjca)
                    (= ?bjcb ?awmg)
                    )
                  (= ?bjca ?awmg)
                  )
                )
              (and (not (= ?bjbz ?bjby))
                (and (and (not (= ?bjcb ?bjca))
                    (not (= ?bjcb ?awmg))
                    )
                  (not (= ?bjca ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjcc Real)
        (declare-const ?bjcd Real)
        (declare-const ?bjce Real)
        (declare-const ?bjcf Real)
        (declare-const ?bjcg Real)
        (declare-const ?bjch Real)
        (assert
          (or (and (or (or (= ?bjce ?bjcd)
                  (= ?bjce ?bjcc)
                  )
                (= ?bjcd ?bjcc)
                )
              (or (or (= ?bjch ?bjcg)
                  (= ?bjch ?bjcf)
                  )
                (= ?bjcg ?bjcf)
                )
              )
            (and (and (and (not (= ?bjce ?bjcd))
                  (not (= ?bjce ?bjcc))
                  )
                (not (= ?bjcd ?bjcc))
                )
              (and (and (not (= ?bjch ?bjcg))
                  (not (= ?bjch ?bjcf))
                  )
                (not (= ?bjcg ?bjcf))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjci Real)
        (declare-const ?bjcj Real)
        (declare-const ?bjck Real)
        (assert
          (and (and (not (= ?bjck ?bjcj))
              (not (= ?bjck ?bjci))
              )
            (not (= ?bjcj ?bjci))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjcl Real)
        (declare-const ?bjcm Real)
        (declare-const ?bjcn Real)
        (assert
          (and (and (not (= ?bjcn ?bjcm))
              (not (= ?bjcn ?bjcl))
              )
            (not (= ?bjcm ?bjcl))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bjco Real)
      (declare-const ?bjcp Real)
      (declare-const ?bjcq Real)
      (push 1)
        (declare-const ?bjcr Real)
        (declare-const ?bjcs Real)
        (declare-const ?bjct Real)
        (declare-const ?bjcu Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bjcs ?bjcr)
                    (= ?bjcs ?awmg)
                    )
                  (= ?bjcr ?awmg)
                  )
                (or (or (= ?bjcu ?bjct)
                    (= ?bjcu ?awmg)
                    )
                  (= ?bjct ?awmg)
                  )
                )
              (and (not (= ?bjcs ?bjcr))
                (and (and (not (= ?bjcu ?bjct))
                    (not (= ?bjcu ?awmg))
                    )
                  (not (= ?bjct ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjcv Real)
        (declare-const ?bjcw Real)
        (declare-const ?bjcx Real)
        (declare-const ?bjcy Real)
        (declare-const ?bjcz Real)
        (declare-const ?bjda Real)
        (assert
          (or (and (or (or (= ?bjcx ?bjcw)
                  (= ?bjcx ?bjcv)
                  )
                (= ?bjcw ?bjcv)
                )
              (or (or (= ?bjda ?bjcz)
                  (= ?bjda ?bjcy)
                  )
                (= ?bjcz ?bjcy)
                )
              )
            (and (and (and (not (= ?bjcx ?bjcw))
                  (not (= ?bjcx ?bjcv))
                  )
                (not (= ?bjcw ?bjcv))
                )
              (and (and (not (= ?bjda ?bjcz))
                  (not (= ?bjda ?bjcy))
                  )
                (not (= ?bjcz ?bjcy))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjdb Real)
        (declare-const ?bjdc Real)
        (declare-const ?bjdd Real)
        (assert
          (and (and (not (= ?bjdd ?bjdc))
              (not (= ?bjdd ?bjdb))
              )
            (not (= ?bjdc ?bjdb))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjde Real)
        (declare-const ?bjdf Real)
        (declare-const ?bjdg Real)
        (assert
          (and (and (not (= ?bjdg ?bjdf))
              (not (= ?bjdg ?bjde))
              )
            (not (= ?bjdf ?bjde))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (or (and (or (or (= ?bjcq ?bjcp)
                  (= ?bjcq ?bjco)
                  )
                (= ?bjcp ?bjco)
                )
              (or (or (= ?bjao ?bjan)
                  (= ?bjao ?bjam)
                  )
                (= ?bjan ?bjam)
                )
              )
            (and (and (and (not (= ?bjcq ?bjcp))
                  (not (= ?bjcq ?bjco))
                  )
                (not (= ?bjcp ?bjco))
                )
              (and (and (not (= ?bjao ?bjan))
                  (not (= ?bjao ?bjam))
                  )
                (not (= ?bjan ?bjam))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bjdh Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bjdi Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bjdj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjdk Real)
              (declare-const ?bjdl Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjdm Real)
              (declare-const ?bjdn Real)
              (declare-const ?bjdo Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjdp Real)
              (declare-const ?bjdq Real)
              (declare-const ?bjdr Real)
              (declare-const ?bjds Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjdt Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bjdu Real)
            (declare-const ?bjdv Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bjdw Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjdx Real)
              (declare-const ?bjdy Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjdz Real)
              (declare-const ?bjea Real)
              (declare-const ?bjeb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjec Real)
              (declare-const ?bjed Real)
              (declare-const ?bjee Real)
              (declare-const ?bjef Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjeg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bjeh Real)
            (declare-const ?bjei Real)
            (declare-const ?bjej Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bjek Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjel Real)
              (declare-const ?bjem Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjen Real)
              (declare-const ?bjeo Real)
              (declare-const ?bjep Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjeq Real)
              (declare-const ?bjer Real)
              (declare-const ?bjes Real)
              (declare-const ?bjet Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjeu Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bjev Real)
            (declare-const ?bjew Real)
            (declare-const ?bjex Real)
            (declare-const ?bjey Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bjez Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjfa Real)
              (declare-const ?bjfb Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjfc Real)
              (declare-const ?bjfd Real)
              (declare-const ?bjfe Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjff Real)
              (declare-const ?bjfg Real)
              (declare-const ?bjfh Real)
              (declare-const ?bjfi Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (and (and (and (= ?bjex ?bjao)
                            (= ?bjew ?bjan)
                            )
                          (= ?bjev ?bjam)
                          )
                        (= ?bjey ?bjdh)
                        )
                      (and (and (= ?bjfh ?bjcq)
                          (= ?bjfg ?bjcp)
                          )
                        (= ?bjff ?bjco)
                        )
                      )
                    (= ?bjfi ?bjdh)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bjfj Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bjfk Real)
                  (declare-const ?bjfl Real)
                  (declare-const ?bjfm Real)
                  (declare-const ?bjfn Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bjfl ?bjfk)
                              (= ?bjfl ?awmg)
                              )
                            (= ?bjfk ?awmg)
                            )
                          (or (or (= ?bjfn ?bjfm)
                              (= ?bjfn ?awmg)
                              )
                            (= ?bjfm ?awmg)
                            )
                          )
                        (and (not (= ?bjfl ?bjfk))
                          (and (and (not (= ?bjfn ?bjfm))
                              (not (= ?bjfn ?awmg))
                              )
                            (not (= ?bjfm ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bjfo Real)
                  (declare-const ?bjfp Real)
                  (declare-const ?bjfq Real)
                  (declare-const ?bjfr Real)
                  (declare-const ?bjfs Real)
                  (declare-const ?bjft Real)
                  (assert
                    (or (and (or (or (= ?bjfq ?bjfp)
                            (= ?bjfq ?bjfo)
                            )
                          (= ?bjfp ?bjfo)
                          )
                        (or (or (= ?bjft ?bjfs)
                            (= ?bjft ?bjfr)
                            )
                          (= ?bjfs ?bjfr)
                          )
                        )
                      (and (and (and (not (= ?bjfq ?bjfp))
                            (not (= ?bjfq ?bjfo))
                            )
                          (not (= ?bjfp ?bjfo))
                          )
                        (and (and (not (= ?bjft ?bjfs))
                            (not (= ?bjft ?bjfr))
                            )
                          (not (= ?bjfs ?bjfr))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bjfu Real)
                  (declare-const ?bjfv Real)
                  (declare-const ?bjfw Real)
                  (assert
                    (and (and (not (= ?bjfw ?bjfv))
                        (not (= ?bjfw ?bjfu))
                        )
                      (not (= ?bjfv ?bjfu))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bjfx Real)
                  (declare-const ?bjfy Real)
                  (declare-const ?bjfz Real)
                  (assert
                    (and (and (not (= ?bjfz ?bjfy))
                        (not (= ?bjfz ?bjfx))
                        )
                      (not (= ?bjfy ?bjfx))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?bjga Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bjgb Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bjgc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjgd Real)
              (declare-const ?bjge Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjgf Real)
              (declare-const ?bjgg Real)
              (declare-const ?bjgh Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjgi Real)
              (declare-const ?bjgj Real)
              (declare-const ?bjgk Real)
              (declare-const ?bjgl Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjgm Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (declare-const ?bjgn Real)
        (declare-const ?bjgo Real)
        (declare-const ?bjgp Real)
        (declare-const ?bjgq Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bjgo ?bjgn)
                    (= ?bjgo ?awmg)
                    )
                  (= ?bjgn ?awmg)
                  )
                (or (or (= ?bjgq ?bjgp)
                    (= ?bjgq ?awmg)
                    )
                  (= ?bjgp ?awmg)
                  )
                )
              (and (not (= ?bjgo ?bjgn))
                (and (and (not (= ?bjgq ?bjgp))
                    (not (= ?bjgq ?awmg))
                    )
                  (not (= ?bjgp ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjgr Real)
        (declare-const ?bjgs Real)
        (declare-const ?bjgt Real)
        (declare-const ?bjgu Real)
        (declare-const ?bjgv Real)
        (declare-const ?bjgw Real)
        (assert
          (or (and (or (or (= ?bjgt ?bjgs)
                  (= ?bjgt ?bjgr)
                  )
                (= ?bjgs ?bjgr)
                )
              (or (or (= ?bjgw ?bjgv)
                  (= ?bjgw ?bjgu)
                  )
                (= ?bjgv ?bjgu)
                )
              )
            (and (and (and (not (= ?bjgt ?bjgs))
                  (not (= ?bjgt ?bjgr))
                  )
                (not (= ?bjgs ?bjgr))
                )
              (and (and (not (= ?bjgw ?bjgv))
                  (not (= ?bjgw ?bjgu))
                  )
                (not (= ?bjgv ?bjgu))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjgx Real)
        (declare-const ?bjgy Real)
        (declare-const ?bjgz Real)
        (assert
          (and (and (not (= ?bjgz ?bjgy))
              (not (= ?bjgz ?bjgx))
              )
            (not (= ?bjgy ?bjgx))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjha Real)
        (declare-const ?bjhb Real)
        (declare-const ?bjhc Real)
        (assert
          (and (and (not (= ?bjhc ?bjhb))
              (not (= ?bjhc ?bjha))
              )
            (not (= ?bjhb ?bjha))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?bjao ?bjan))
              (not (= ?bjao ?bjam))
              )
            (not (= ?bjan ?bjam))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bjhd Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bjhe Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bjhf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjhg Real)
              (declare-const ?bjhh Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjhi Real)
              (declare-const ?bjhj Real)
              (declare-const ?bjhk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjhl Real)
              (declare-const ?bjhm Real)
              (declare-const ?bjhn Real)
              (declare-const ?bjho Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjhp Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bjhq Real)
            (declare-const ?bjhr Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bjhs Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjht Real)
              (declare-const ?bjhu Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjhv Real)
              (declare-const ?bjhw Real)
              (declare-const ?bjhx Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjhy Real)
              (declare-const ?bjhz Real)
              (declare-const ?bjia Real)
              (declare-const ?bjib Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjic Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bjid Real)
            (declare-const ?bjie Real)
            (declare-const ?bjif Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bjig Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjih Real)
              (declare-const ?bjii Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjij Real)
              (declare-const ?bjik Real)
              (declare-const ?bjil Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjim Real)
              (declare-const ?bjin Real)
              (declare-const ?bjio Real)
              (declare-const ?bjip Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjiq Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bjir Real)
            (declare-const ?bjis Real)
            (declare-const ?bjit Real)
            (declare-const ?bjiu Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bjiv Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjiw Real)
              (declare-const ?bjix Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjiy Real)
              (declare-const ?bjiz Real)
              (declare-const ?bjja Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjjb Real)
              (declare-const ?bjjc Real)
              (declare-const ?bjjd Real)
              (declare-const ?bjje Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjjf Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (and (and (= ?bjit ?bjao)
                          (= ?bjis ?bjan)
                          )
                        (= ?bjir ?bjam)
                        )
                      (= ?bjiu ?bjhd)
                      )
                    (= ?bjjf ?bjhd)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bjjg Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bjjh Real)
                  (declare-const ?bjji Real)
                  (declare-const ?bjjj Real)
                  (declare-const ?bjjk Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bjji ?bjjh)
                              (= ?bjji ?awmg)
                              )
                            (= ?bjjh ?awmg)
                            )
                          (or (or (= ?bjjk ?bjjj)
                              (= ?bjjk ?awmg)
                              )
                            (= ?bjjj ?awmg)
                            )
                          )
                        (and (not (= ?bjji ?bjjh))
                          (and (and (not (= ?bjjk ?bjjj))
                              (not (= ?bjjk ?awmg))
                              )
                            (not (= ?bjjj ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bjjl Real)
                  (declare-const ?bjjm Real)
                  (declare-const ?bjjn Real)
                  (declare-const ?bjjo Real)
                  (declare-const ?bjjp Real)
                  (declare-const ?bjjq Real)
                  (assert
                    (or (and (or (or (= ?bjjn ?bjjm)
                            (= ?bjjn ?bjjl)
                            )
                          (= ?bjjm ?bjjl)
                          )
                        (or (or (= ?bjjq ?bjjp)
                            (= ?bjjq ?bjjo)
                            )
                          (= ?bjjp ?bjjo)
                          )
                        )
                      (and (and (and (not (= ?bjjn ?bjjm))
                            (not (= ?bjjn ?bjjl))
                            )
                          (not (= ?bjjm ?bjjl))
                          )
                        (and (and (not (= ?bjjq ?bjjp))
                            (not (= ?bjjq ?bjjo))
                            )
                          (not (= ?bjjp ?bjjo))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bjjr Real)
                  (declare-const ?bjjs Real)
                  (declare-const ?bjjt Real)
                  (assert
                    (and (and (not (= ?bjjt ?bjjs))
                        (not (= ?bjjt ?bjjr))
                        )
                      (not (= ?bjjs ?bjjr))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bjju Real)
                  (declare-const ?bjjv Real)
                  (declare-const ?bjjw Real)
                  (assert
                    (and (and (not (= ?bjjw ?bjjv))
                        (not (= ?bjjw ?bjju))
                        )
                      (not (= ?bjjv ?bjju))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bjjx Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bjjy Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjjz Real)
              (declare-const ?bjka Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjkb Real)
              (declare-const ?bjkc Real)
              (declare-const ?bjkd Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjke Real)
              (declare-const ?bjkf Real)
              (declare-const ?bjkg Real)
              (declare-const ?bjkh Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjki Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (push 1)
        (declare-const ?bjkj Real)
        (declare-const ?bjkk Real)
        (declare-const ?bjkl Real)
        (declare-const ?bjkm Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bjkk ?bjkj)
                    (= ?bjkk ?awmg)
                    )
                  (= ?bjkj ?awmg)
                  )
                (or (or (= ?bjkm ?bjkl)
                    (= ?bjkm ?awmg)
                    )
                  (= ?bjkl ?awmg)
                  )
                )
              (and (not (= ?bjkk ?bjkj))
                (and (and (not (= ?bjkm ?bjkl))
                    (not (= ?bjkm ?awmg))
                    )
                  (not (= ?bjkl ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjkn Real)
        (declare-const ?bjko Real)
        (declare-const ?bjkp Real)
        (declare-const ?bjkq Real)
        (declare-const ?bjkr Real)
        (declare-const ?bjks Real)
        (assert
          (or (and (or (or (= ?bjkp ?bjko)
                  (= ?bjkp ?bjkn)
                  )
                (= ?bjko ?bjkn)
                )
              (or (or (= ?bjks ?bjkr)
                  (= ?bjks ?bjkq)
                  )
                (= ?bjkr ?bjkq)
                )
              )
            (and (and (and (not (= ?bjkp ?bjko))
                  (not (= ?bjkp ?bjkn))
                  )
                (not (= ?bjko ?bjkn))
                )
              (and (and (not (= ?bjks ?bjkr))
                  (not (= ?bjks ?bjkq))
                  )
                (not (= ?bjkr ?bjkq))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjkt Real)
        (declare-const ?bjku Real)
        (declare-const ?bjkv Real)
        (assert
          (and (and (not (= ?bjkv ?bjku))
              (not (= ?bjkv ?bjkt))
              )
            (not (= ?bjku ?bjkt))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjkw Real)
        (declare-const ?bjkx Real)
        (declare-const ?bjky Real)
        (assert
          (and (and (not (= ?bjky ?bjkx))
              (not (= ?bjky ?bjkw))
              )
            (not (= ?bjkx ?bjkw))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bjkz Real)
      (push 1)
        (declare-const ?bjla Real)
        (declare-const ?bjlb Real)
        (declare-const ?bjlc Real)
        (declare-const ?bjld Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bjlb ?bjla)
                    (= ?bjlb ?awmg)
                    )
                  (= ?bjla ?awmg)
                  )
                (or (or (= ?bjld ?bjlc)
                    (= ?bjld ?awmg)
                    )
                  (= ?bjlc ?awmg)
                  )
                )
              (and (not (= ?bjlb ?bjla))
                (and (and (not (= ?bjld ?bjlc))
                    (not (= ?bjld ?awmg))
                    )
                  (not (= ?bjlc ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjle Real)
        (declare-const ?bjlf Real)
        (declare-const ?bjlg Real)
        (declare-const ?bjlh Real)
        (declare-const ?bjli Real)
        (declare-const ?bjlj Real)
        (assert
          (or (and (or (or (= ?bjlg ?bjlf)
                  (= ?bjlg ?bjle)
                  )
                (= ?bjlf ?bjle)
                )
              (or (or (= ?bjlj ?bjli)
                  (= ?bjlj ?bjlh)
                  )
                (= ?bjli ?bjlh)
                )
              )
            (and (and (and (not (= ?bjlg ?bjlf))
                  (not (= ?bjlg ?bjle))
                  )
                (not (= ?bjlf ?bjle))
                )
              (and (and (not (= ?bjlj ?bjli))
                  (not (= ?bjlj ?bjlh))
                  )
                (not (= ?bjli ?bjlh))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjlk Real)
        (declare-const ?bjll Real)
        (declare-const ?bjlm Real)
        (assert
          (and (and (not (= ?bjlm ?bjll))
              (not (= ?bjlm ?bjlk))
              )
            (not (= ?bjll ?bjlk))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjln Real)
        (declare-const ?bjlo Real)
        (declare-const ?bjlp Real)
        (assert
          (and (and (not (= ?bjlp ?bjlo))
              (not (= ?bjlp ?bjln))
              )
            (not (= ?bjlo ?bjln))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bjlq Real)
      (declare-const ?bjlr Real)
      (push 1)
        (declare-const ?bjls Real)
        (declare-const ?bjlt Real)
        (declare-const ?bjlu Real)
        (declare-const ?bjlv Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bjlt ?bjls)
                    (= ?bjlt ?awmg)
                    )
                  (= ?bjls ?awmg)
                  )
                (or (or (= ?bjlv ?bjlu)
                    (= ?bjlv ?awmg)
                    )
                  (= ?bjlu ?awmg)
                  )
                )
              (and (not (= ?bjlt ?bjls))
                (and (and (not (= ?bjlv ?bjlu))
                    (not (= ?bjlv ?awmg))
                    )
                  (not (= ?bjlu ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjlw Real)
        (declare-const ?bjlx Real)
        (declare-const ?bjly Real)
        (declare-const ?bjlz Real)
        (declare-const ?bjma Real)
        (declare-const ?bjmb Real)
        (assert
          (or (and (or (or (= ?bjly ?bjlx)
                  (= ?bjly ?bjlw)
                  )
                (= ?bjlx ?bjlw)
                )
              (or (or (= ?bjmb ?bjma)
                  (= ?bjmb ?bjlz)
                  )
                (= ?bjma ?bjlz)
                )
              )
            (and (and (and (not (= ?bjly ?bjlx))
                  (not (= ?bjly ?bjlw))
                  )
                (not (= ?bjlx ?bjlw))
                )
              (and (and (not (= ?bjmb ?bjma))
                  (not (= ?bjmb ?bjlz))
                  )
                (not (= ?bjma ?bjlz))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjmc Real)
        (declare-const ?bjmd Real)
        (declare-const ?bjme Real)
        (assert
          (and (and (not (= ?bjme ?bjmd))
              (not (= ?bjme ?bjmc))
              )
            (not (= ?bjmd ?bjmc))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjmf Real)
        (declare-const ?bjmg Real)
        (declare-const ?bjmh Real)
        (assert
          (and (and (not (= ?bjmh ?bjmg))
              (not (= ?bjmh ?bjmf))
              )
            (not (= ?bjmg ?bjmf))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bjmi Real)
      (declare-const ?bjmj Real)
      (declare-const ?bjmk Real)
      (push 1)
        (declare-const ?bjml Real)
        (declare-const ?bjmm Real)
        (declare-const ?bjmn Real)
        (declare-const ?bjmo Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bjmm ?bjml)
                    (= ?bjmm ?awmg)
                    )
                  (= ?bjml ?awmg)
                  )
                (or (or (= ?bjmo ?bjmn)
                    (= ?bjmo ?awmg)
                    )
                  (= ?bjmn ?awmg)
                  )
                )
              (and (not (= ?bjmm ?bjml))
                (and (and (not (= ?bjmo ?bjmn))
                    (not (= ?bjmo ?awmg))
                    )
                  (not (= ?bjmn ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjmp Real)
        (declare-const ?bjmq Real)
        (declare-const ?bjmr Real)
        (declare-const ?bjms Real)
        (declare-const ?bjmt Real)
        (declare-const ?bjmu Real)
        (assert
          (or (and (or (or (= ?bjmr ?bjmq)
                  (= ?bjmr ?bjmp)
                  )
                (= ?bjmq ?bjmp)
                )
              (or (or (= ?bjmu ?bjmt)
                  (= ?bjmu ?bjms)
                  )
                (= ?bjmt ?bjms)
                )
              )
            (and (and (and (not (= ?bjmr ?bjmq))
                  (not (= ?bjmr ?bjmp))
                  )
                (not (= ?bjmq ?bjmp))
                )
              (and (and (not (= ?bjmu ?bjmt))
                  (not (= ?bjmu ?bjms))
                  )
                (not (= ?bjmt ?bjms))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjmv Real)
        (declare-const ?bjmw Real)
        (declare-const ?bjmx Real)
        (assert
          (and (and (not (= ?bjmx ?bjmw))
              (not (= ?bjmx ?bjmv))
              )
            (not (= ?bjmw ?bjmv))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjmy Real)
        (declare-const ?bjmz Real)
        (declare-const ?bjna Real)
        (assert
          (and (and (not (= ?bjna ?bjmz))
              (not (= ?bjna ?bjmy))
              )
            (not (= ?bjmz ?bjmy))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?bjmk ?bjmj))
              (not (= ?bjmk ?bjmi))
              )
            (not (= ?bjmj ?bjmi))
            )
          )
(set-info :status unknown)
        (check-sat)
        (push 1)
          (declare-const ?bjnb Real)
(set-info :status unknown)
          (check-sat)
          (push 1)
            (declare-const ?bjnc Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bjnd Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjne Real)
              (declare-const ?bjnf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjng Real)
              (declare-const ?bjnh Real)
              (declare-const ?bjni Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjnj Real)
              (declare-const ?bjnk Real)
              (declare-const ?bjnl Real)
              (declare-const ?bjnm Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjnn Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bjno Real)
            (declare-const ?bjnp Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bjnq Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjnr Real)
              (declare-const ?bjns Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjnt Real)
              (declare-const ?bjnu Real)
              (declare-const ?bjnv Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjnw Real)
              (declare-const ?bjnx Real)
              (declare-const ?bjny Real)
              (declare-const ?bjnz Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjoa Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bjob Real)
            (declare-const ?bjoc Real)
            (declare-const ?bjod Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bjoe Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjof Real)
              (declare-const ?bjog Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjoh Real)
              (declare-const ?bjoi Real)
              (declare-const ?bjoj Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjok Real)
              (declare-const ?bjol Real)
              (declare-const ?bjom Real)
              (declare-const ?bjon Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjoo Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bjop Real)
            (declare-const ?bjoq Real)
            (declare-const ?bjor Real)
            (declare-const ?bjos Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bjot Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjou Real)
              (declare-const ?bjov Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjow Real)
              (declare-const ?bjox Real)
              (declare-const ?bjoy Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjoz Real)
              (declare-const ?bjpa Real)
              (declare-const ?bjpb Real)
              (declare-const ?bjpc Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjpd Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (push 1)
            (declare-const ?bjpe Real)
(set-info :status unknown)
            (check-sat)
            (push 1)
              (declare-const ?bjpf Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjpg Real)
              (declare-const ?bjph Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjpi Real)
              (declare-const ?bjpj Real)
              (declare-const ?bjpk Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (push 1)
              (declare-const ?bjpl Real)
              (declare-const ?bjpm Real)
              (declare-const ?bjpn Real)
              (declare-const ?bjpo Real)
(set-info :status unknown)
              (check-sat)
              (push 1)
                (assert
                  (and (and (= ?bjpe ?bjnb)
                      (and (and (= ?bjpn ?bjmk)
                          (= ?bjpm ?bjmj)
                          )
                        (= ?bjpl ?bjmi)
                        )
                      )
                    (= ?bjpo ?bjnb)
                    )
                  )
(set-info :status unknown)
                (check-sat)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bjpp Real)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bjpq Real)
                  (declare-const ?bjpr Real)
                  (declare-const ?bjps Real)
                  (declare-const ?bjpt Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bjpr ?bjpq)
                              (= ?bjpr ?awmg)
                              )
                            (= ?bjpq ?awmg)
                            )
                          (or (or (= ?bjpt ?bjps)
                              (= ?bjpt ?awmg)
                              )
                            (= ?bjps ?awmg)
                            )
                          )
                        (and (not (= ?bjpr ?bjpq))
                          (and (and (not (= ?bjpt ?bjps))
                              (not (= ?bjpt ?awmg))
                              )
                            (not (= ?bjps ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bjpu Real)
                  (declare-const ?bjpv Real)
                  (declare-const ?bjpw Real)
                  (declare-const ?bjpx Real)
                  (declare-const ?bjpy Real)
                  (declare-const ?bjpz Real)
                  (assert
                    (or (and (or (or (= ?bjpw ?bjpv)
                            (= ?bjpw ?bjpu)
                            )
                          (= ?bjpv ?bjpu)
                          )
                        (or (or (= ?bjpz ?bjpy)
                            (= ?bjpz ?bjpx)
                            )
                          (= ?bjpy ?bjpx)
                          )
                        )
                      (and (and (and (not (= ?bjpw ?bjpv))
                            (not (= ?bjpw ?bjpu))
                            )
                          (not (= ?bjpv ?bjpu))
                          )
                        (and (and (not (= ?bjpz ?bjpy))
                            (not (= ?bjpz ?bjpx))
                            )
                          (not (= ?bjpy ?bjpx))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bjqa Real)
                  (declare-const ?bjqb Real)
                  (declare-const ?bjqc Real)
                  (assert
                    (and (and (not (= ?bjqc ?bjqb))
                        (not (= ?bjqc ?bjqa))
                        )
                      (not (= ?bjqb ?bjqa))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bjqd Real)
                  (declare-const ?bjqe Real)
                  (declare-const ?bjqf Real)
                  (assert
                    (and (and (not (= ?bjqf ?bjqe))
                        (not (= ?bjqf ?bjqd))
                        )
                      (not (= ?bjqe ?bjqd))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (push 1)
              (declare-const ?bjqg Real)
(set-info :status unknown)
              (check-sat)
              (pop 1)
            (pop 1)
          (pop 1)
        (push 1)
(set-info :status unknown)
          (check-sat)
          (pop 1)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (declare-const ?bjqh Real)
        (declare-const ?bjqi Real)
        (declare-const ?bjqj Real)
        (declare-const ?bjqk Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bjqi ?bjqh)
                    (= ?bjqi ?awmg)
                    )
                  (= ?bjqh ?awmg)
                  )
                (or (or (= ?bjqk ?bjqj)
                    (= ?bjqk ?awmg)
                    )
                  (= ?bjqj ?awmg)
                  )
                )
              (and (not (= ?bjqi ?bjqh))
                (and (and (not (= ?bjqk ?bjqj))
                    (not (= ?bjqk ?awmg))
                    )
                  (not (= ?bjqj ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjql Real)
        (declare-const ?bjqm Real)
        (declare-const ?bjqn Real)
        (declare-const ?bjqo Real)
        (declare-const ?bjqp Real)
        (declare-const ?bjqq Real)
        (assert
          (or (and (or (or (= ?bjqn ?bjqm)
                  (= ?bjqn ?bjql)
                  )
                (= ?bjqm ?bjql)
                )
              (or (or (= ?bjqq ?bjqp)
                  (= ?bjqq ?bjqo)
                  )
                (= ?bjqp ?bjqo)
                )
              )
            (and (and (and (not (= ?bjqn ?bjqm))
                  (not (= ?bjqn ?bjql))
                  )
                (not (= ?bjqm ?bjql))
                )
              (and (and (not (= ?bjqq ?bjqp))
                  (not (= ?bjqq ?bjqo))
                  )
                (not (= ?bjqp ?bjqo))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjqr Real)
        (declare-const ?bjqs Real)
        (declare-const ?bjqt Real)
        (assert
          (and (and (not (= ?bjqt ?bjqs))
              (not (= ?bjqt ?bjqr))
              )
            (not (= ?bjqs ?bjqr))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (declare-const ?bjqu Real)
        (declare-const ?bjqv Real)
        (declare-const ?bjqw Real)
        (assert
          (and (and (not (= ?bjqw ?bjqv))
              (not (= ?bjqw ?bjqu))
              )
            (not (= ?bjqv ?bjqu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (push 1)
          (declare-const ?bjqx Real)
          (push 1)
            (declare-const ?bjqy Real)
            (push 1)
              (declare-const ?bjqz Real)
              (push 1)
                (assert
                  (and (= ?bjqy ?bjqx)
                    (= ?bjqz ?bjqx)
                    )
                  )
                (push 1)
                  (declare-const ?bjra Real)
                  (declare-const ?bjrb Real)
                  (declare-const ?bjrc Real)
                  (declare-const ?bjrd Real)
                  (assert
                    (forall ((?awmg Real) )(or (and (or (or (= ?bjrb ?bjra)
                              (= ?bjrb ?awmg)
                              )
                            (= ?bjra ?awmg)
                            )
                          (or (or (= ?bjrd ?bjrc)
                              (= ?bjrd ?awmg)
                              )
                            (= ?bjrc ?awmg)
                            )
                          )
                        (and (not (= ?bjrb ?bjra))
                          (and (and (not (= ?bjrd ?bjrc))
                              (not (= ?bjrd ?awmg))
                              )
                            (not (= ?bjrc ?awmg))
                            )
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bjre Real)
                  (declare-const ?bjrf Real)
                  (declare-const ?bjrg Real)
                  (declare-const ?bjrh Real)
                  (declare-const ?bjri Real)
                  (declare-const ?bjrj Real)
                  (assert
                    (or (and (or (or (= ?bjrg ?bjrf)
                            (= ?bjrg ?bjre)
                            )
                          (= ?bjrf ?bjre)
                          )
                        (or (or (= ?bjrj ?bjri)
                            (= ?bjrj ?bjrh)
                            )
                          (= ?bjri ?bjrh)
                          )
                        )
                      (and (and (and (not (= ?bjrg ?bjrf))
                            (not (= ?bjrg ?bjre))
                            )
                          (not (= ?bjrf ?bjre))
                          )
                        (and (and (not (= ?bjrj ?bjri))
                            (not (= ?bjrj ?bjrh))
                            )
                          (not (= ?bjri ?bjrh))
                          )
                        )
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bjrk Real)
                  (declare-const ?bjrl Real)
                  (declare-const ?bjrm Real)
                  (assert
                    (and (and (not (= ?bjrm ?bjrl))
                        (not (= ?bjrm ?bjrk))
                        )
                      (not (= ?bjrl ?bjrk))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (push 1)
                  (declare-const ?bjrn Real)
                  (declare-const ?bjro Real)
                  (declare-const ?bjrp Real)
                  (assert
                    (and (and (not (= ?bjrp ?bjro))
                        (not (= ?bjrp ?bjrn))
                        )
                      (not (= ?bjro ?bjrn))
                      )
                    )
(set-info :status unknown)
                  (check-sat)
                  (pop 1)
                (pop 1)
              (pop 1)
            (pop 1)
          (pop 1)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bjrq Real)
      (declare-const ?bjrr Real)
      (declare-const ?bjrs Real)
      (declare-const ?bjrt Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bjrr ?bjrq)
                  (= ?bjrr ?awmg)
                  )
                (= ?bjrq ?awmg)
                )
              (or (or (= ?bjrt ?bjrs)
                  (= ?bjrt ?awmg)
                  )
                (= ?bjrs ?awmg)
                )
              )
            (and (not (= ?bjrr ?bjrq))
              (and (and (not (= ?bjrt ?bjrs))
                  (not (= ?bjrt ?awmg))
                  )
                (not (= ?bjrs ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjru Real)
      (declare-const ?bjrv Real)
      (declare-const ?bjrw Real)
      (declare-const ?bjrx Real)
      (declare-const ?bjry Real)
      (declare-const ?bjrz Real)
      (assert
        (or (and (or (or (= ?bjrw ?bjrv)
                (= ?bjrw ?bjru)
                )
              (= ?bjrv ?bjru)
              )
            (or (or (= ?bjrz ?bjry)
                (= ?bjrz ?bjrx)
                )
              (= ?bjry ?bjrx)
              )
            )
          (and (and (and (not (= ?bjrw ?bjrv))
                (not (= ?bjrw ?bjru))
                )
              (not (= ?bjrv ?bjru))
              )
            (and (and (not (= ?bjrz ?bjry))
                (not (= ?bjrz ?bjrx))
                )
              (not (= ?bjry ?bjrx))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjsa Real)
      (declare-const ?bjsb Real)
      (declare-const ?bjsc Real)
      (assert
        (and (and (not (= ?bjsc ?bjsb))
            (not (= ?bjsc ?bjsa))
            )
          (not (= ?bjsb ?bjsa))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjsd Real)
      (declare-const ?bjse Real)
      (declare-const ?bjsf Real)
      (assert
        (and (and (not (= ?bjsf ?bjse))
            (not (= ?bjsf ?bjsd))
            )
          (not (= ?bjse ?bjsd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bjsg Real)
    (push 1)
      (declare-const ?bjsh Real)
      (declare-const ?bjsi Real)
      (declare-const ?bjsj Real)
      (declare-const ?bjsk Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bjsi ?bjsh)
                  (= ?bjsi ?awmg)
                  )
                (= ?bjsh ?awmg)
                )
              (or (or (= ?bjsk ?bjsj)
                  (= ?bjsk ?awmg)
                  )
                (= ?bjsj ?awmg)
                )
              )
            (and (not (= ?bjsi ?bjsh))
              (and (and (not (= ?bjsk ?bjsj))
                  (not (= ?bjsk ?awmg))
                  )
                (not (= ?bjsj ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjsl Real)
      (declare-const ?bjsm Real)
      (declare-const ?bjsn Real)
      (declare-const ?bjso Real)
      (declare-const ?bjsp Real)
      (declare-const ?bjsq Real)
      (assert
        (or (and (or (or (= ?bjsn ?bjsm)
                (= ?bjsn ?bjsl)
                )
              (= ?bjsm ?bjsl)
              )
            (or (or (= ?bjsq ?bjsp)
                (= ?bjsq ?bjso)
                )
              (= ?bjsp ?bjso)
              )
            )
          (and (and (and (not (= ?bjsn ?bjsm))
                (not (= ?bjsn ?bjsl))
                )
              (not (= ?bjsm ?bjsl))
              )
            (and (and (not (= ?bjsq ?bjsp))
                (not (= ?bjsq ?bjso))
                )
              (not (= ?bjsp ?bjso))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjsr Real)
      (declare-const ?bjss Real)
      (declare-const ?bjst Real)
      (assert
        (and (and (not (= ?bjst ?bjss))
            (not (= ?bjst ?bjsr))
            )
          (not (= ?bjss ?bjsr))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjsu Real)
      (declare-const ?bjsv Real)
      (declare-const ?bjsw Real)
      (assert
        (and (and (not (= ?bjsw ?bjsv))
            (not (= ?bjsw ?bjsu))
            )
          (not (= ?bjsv ?bjsu))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bjsx Real)
    (declare-const ?bjsy Real)
    (declare-const ?bjsz Real)
    (declare-const ?bjta Real)
    (assert
      (forall ((?awmg Real) )(or (and (or (or (= ?bjsy ?bjsx)
                (= ?bjsy ?awmg)
                )
              (= ?bjsx ?awmg)
              )
            (or (or (= ?bjta ?bjsz)
                (= ?bjta ?awmg)
                )
              (= ?bjsz ?awmg)
              )
            )
          (and (not (= ?bjsy ?bjsx))
            (and (and (not (= ?bjta ?bjsz))
                (not (= ?bjta ?awmg))
                )
              (not (= ?bjsz ?awmg))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjtb Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjtc Real)
      (declare-const ?bjtd Real)
      (declare-const ?bjte Real)
      (declare-const ?bjtf Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bjtd ?bjtc)
                  (= ?bjtd ?awmg)
                  )
                (= ?bjtc ?awmg)
                )
              (or (or (= ?bjtf ?bjte)
                  (= ?bjtf ?awmg)
                  )
                (= ?bjte ?awmg)
                )
              )
            (and (not (= ?bjtd ?bjtc))
              (and (and (not (= ?bjtf ?bjte))
                  (not (= ?bjtf ?awmg))
                  )
                (not (= ?bjte ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjtg Real)
      (declare-const ?bjth Real)
      (declare-const ?bjti Real)
      (declare-const ?bjtj Real)
      (declare-const ?bjtk Real)
      (declare-const ?bjtl Real)
      (assert
        (or (and (or (or (= ?bjti ?bjth)
                (= ?bjti ?bjtg)
                )
              (= ?bjth ?bjtg)
              )
            (or (or (= ?bjtl ?bjtk)
                (= ?bjtl ?bjtj)
                )
              (= ?bjtk ?bjtj)
              )
            )
          (and (and (and (not (= ?bjti ?bjth))
                (not (= ?bjti ?bjtg))
                )
              (not (= ?bjth ?bjtg))
              )
            (and (and (not (= ?bjtl ?bjtk))
                (not (= ?bjtl ?bjtj))
                )
              (not (= ?bjtk ?bjtj))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjtm Real)
      (declare-const ?bjtn Real)
      (declare-const ?bjto Real)
      (assert
        (and (and (not (= ?bjto ?bjtn))
            (not (= ?bjto ?bjtm))
            )
          (not (= ?bjtn ?bjtm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjtp Real)
      (declare-const ?bjtq Real)
      (declare-const ?bjtr Real)
      (assert
        (and (and (not (= ?bjtr ?bjtq))
            (not (= ?bjtr ?bjtp))
            )
          (not (= ?bjtq ?bjtp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bjts Real)
    (declare-const ?bjtt Real)
    (declare-const ?bjtu Real)
    (declare-const ?bjtv Real)
    (declare-const ?bjtw Real)
    (declare-const ?bjtx Real)
    (assert
      (or (and (or (or (= ?bjtu ?bjtt)
              (= ?bjtu ?bjts)
              )
            (= ?bjtt ?bjts)
            )
          (or (or (= ?bjtx ?bjtw)
              (= ?bjtx ?bjtv)
              )
            (= ?bjtw ?bjtv)
            )
          )
        (and (and (and (not (= ?bjtu ?bjtt))
              (not (= ?bjtu ?bjts))
              )
            (not (= ?bjtt ?bjts))
            )
          (and (and (not (= ?bjtx ?bjtw))
              (not (= ?bjtx ?bjtv))
              )
            (not (= ?bjtw ?bjtv))
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjty Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjtz Real)
      (declare-const ?bjua Real)
      (declare-const ?bjub Real)
      (declare-const ?bjuc Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bjua ?bjtz)
                  (= ?bjua ?awmg)
                  )
                (= ?bjtz ?awmg)
                )
              (or (or (= ?bjuc ?bjub)
                  (= ?bjuc ?awmg)
                  )
                (= ?bjub ?awmg)
                )
              )
            (and (not (= ?bjua ?bjtz))
              (and (and (not (= ?bjuc ?bjub))
                  (not (= ?bjuc ?awmg))
                  )
                (not (= ?bjub ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjud Real)
      (declare-const ?bjue Real)
      (declare-const ?bjuf Real)
      (declare-const ?bjug Real)
      (declare-const ?bjuh Real)
      (declare-const ?bjui Real)
      (assert
        (or (and (or (or (= ?bjuf ?bjue)
                (= ?bjuf ?bjud)
                )
              (= ?bjue ?bjud)
              )
            (or (or (= ?bjui ?bjuh)
                (= ?bjui ?bjug)
                )
              (= ?bjuh ?bjug)
              )
            )
          (and (and (and (not (= ?bjuf ?bjue))
                (not (= ?bjuf ?bjud))
                )
              (not (= ?bjue ?bjud))
              )
            (and (and (not (= ?bjui ?bjuh))
                (not (= ?bjui ?bjug))
                )
              (not (= ?bjuh ?bjug))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjuj Real)
      (declare-const ?bjuk Real)
      (declare-const ?bjul Real)
      (assert
        (and (and (not (= ?bjul ?bjuk))
            (not (= ?bjul ?bjuj))
            )
          (not (= ?bjuk ?bjuj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjum Real)
      (declare-const ?bjun Real)
      (declare-const ?bjuo Real)
      (assert
        (and (and (not (= ?bjuo ?bjun))
            (not (= ?bjuo ?bjum))
            )
          (not (= ?bjun ?bjum))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bjup Real)
    (declare-const ?bjuq Real)
    (declare-const ?bjur Real)
    (assert
      (and (and (not (= ?bjur ?bjuq))
          (not (= ?bjur ?bjup))
          )
        (not (= ?bjuq ?bjup))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjus Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjut Real)
      (declare-const ?bjuu Real)
      (declare-const ?bjuv Real)
      (declare-const ?bjuw Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bjuu ?bjut)
                  (= ?bjuu ?awmg)
                  )
                (= ?bjut ?awmg)
                )
              (or (or (= ?bjuw ?bjuv)
                  (= ?bjuw ?awmg)
                  )
                (= ?bjuv ?awmg)
                )
              )
            (and (not (= ?bjuu ?bjut))
              (and (and (not (= ?bjuw ?bjuv))
                  (not (= ?bjuw ?awmg))
                  )
                (not (= ?bjuv ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjux Real)
      (declare-const ?bjuy Real)
      (declare-const ?bjuz Real)
      (declare-const ?bjva Real)
      (declare-const ?bjvb Real)
      (declare-const ?bjvc Real)
      (assert
        (or (and (or (or (= ?bjuz ?bjuy)
                (= ?bjuz ?bjux)
                )
              (= ?bjuy ?bjux)
              )
            (or (or (= ?bjvc ?bjvb)
                (= ?bjvc ?bjva)
                )
              (= ?bjvb ?bjva)
              )
            )
          (and (and (and (not (= ?bjuz ?bjuy))
                (not (= ?bjuz ?bjux))
                )
              (not (= ?bjuy ?bjux))
              )
            (and (and (not (= ?bjvc ?bjvb))
                (not (= ?bjvc ?bjva))
                )
              (not (= ?bjvb ?bjva))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjvd Real)
      (declare-const ?bjve Real)
      (declare-const ?bjvf Real)
      (assert
        (and (and (not (= ?bjvf ?bjve))
            (not (= ?bjvf ?bjvd))
            )
          (not (= ?bjve ?bjvd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjvg Real)
      (declare-const ?bjvh Real)
      (declare-const ?bjvi Real)
      (assert
        (and (and (not (= ?bjvi ?bjvh))
            (not (= ?bjvi ?bjvg))
            )
          (not (= ?bjvh ?bjvg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bjvj Real)
    (declare-const ?bjvk Real)
    (declare-const ?bjvl Real)
    (assert
      (and (and (not (= ?bjvl ?bjvk))
          (not (= ?bjvl ?bjvj))
          )
        (not (= ?bjvk ?bjvj))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjvm Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjvn Real)
      (declare-const ?bjvo Real)
      (declare-const ?bjvp Real)
      (declare-const ?bjvq Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bjvo ?bjvn)
                  (= ?bjvo ?awmg)
                  )
                (= ?bjvn ?awmg)
                )
              (or (or (= ?bjvq ?bjvp)
                  (= ?bjvq ?awmg)
                  )
                (= ?bjvp ?awmg)
                )
              )
            (and (not (= ?bjvo ?bjvn))
              (and (and (not (= ?bjvq ?bjvp))
                  (not (= ?bjvq ?awmg))
                  )
                (not (= ?bjvp ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjvr Real)
      (declare-const ?bjvs Real)
      (declare-const ?bjvt Real)
      (declare-const ?bjvu Real)
      (declare-const ?bjvv Real)
      (declare-const ?bjvw Real)
      (assert
        (or (and (or (or (= ?bjvt ?bjvs)
                (= ?bjvt ?bjvr)
                )
              (= ?bjvs ?bjvr)
              )
            (or (or (= ?bjvw ?bjvv)
                (= ?bjvw ?bjvu)
                )
              (= ?bjvv ?bjvu)
              )
            )
          (and (and (and (not (= ?bjvt ?bjvs))
                (not (= ?bjvt ?bjvr))
                )
              (not (= ?bjvs ?bjvr))
              )
            (and (and (not (= ?bjvw ?bjvv))
                (not (= ?bjvw ?bjvu))
                )
              (not (= ?bjvv ?bjvu))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjvx Real)
      (declare-const ?bjvy Real)
      (declare-const ?bjvz Real)
      (assert
        (and (and (not (= ?bjvz ?bjvy))
            (not (= ?bjvz ?bjvx))
            )
          (not (= ?bjvy ?bjvx))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjwa Real)
      (declare-const ?bjwb Real)
      (declare-const ?bjwc Real)
      (assert
        (and (and (not (= ?bjwc ?bjwb))
            (not (= ?bjwc ?bjwa))
            )
          (not (= ?bjwb ?bjwa))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bjwd Real)
      (declare-const ?bjwe Real)
      (declare-const ?bjwf Real)
      (declare-const ?bjwg Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bjwe ?bjwd)
                  (= ?bjwe ?awmg)
                  )
                (= ?bjwd ?awmg)
                )
              (or (or (= ?bjwg ?bjwf)
                  (= ?bjwg ?awmg)
                  )
                (= ?bjwf ?awmg)
                )
              )
            (and (not (= ?bjwe ?bjwd))
              (and (and (not (= ?bjwg ?bjwf))
                  (not (= ?bjwg ?awmg))
                  )
                (not (= ?bjwf ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjwh Real)
      (declare-const ?bjwi Real)
      (declare-const ?bjwj Real)
      (declare-const ?bjwk Real)
      (declare-const ?bjwl Real)
      (declare-const ?bjwm Real)
      (assert
        (or (and (or (or (= ?bjwj ?bjwi)
                (= ?bjwj ?bjwh)
                )
              (= ?bjwi ?bjwh)
              )
            (or (or (= ?bjwm ?bjwl)
                (= ?bjwm ?bjwk)
                )
              (= ?bjwl ?bjwk)
              )
            )
          (and (and (and (not (= ?bjwj ?bjwi))
                (not (= ?bjwj ?bjwh))
                )
              (not (= ?bjwi ?bjwh))
              )
            (and (and (not (= ?bjwm ?bjwl))
                (not (= ?bjwm ?bjwk))
                )
              (not (= ?bjwl ?bjwk))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjwn Real)
      (declare-const ?bjwo Real)
      (declare-const ?bjwp Real)
      (assert
        (and (and (not (= ?bjwp ?bjwo))
            (not (= ?bjwp ?bjwn))
            )
          (not (= ?bjwo ?bjwn))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjwq Real)
      (declare-const ?bjwr Real)
      (declare-const ?bjws Real)
      (assert
        (and (and (not (= ?bjws ?bjwr))
            (not (= ?bjws ?bjwq))
            )
          (not (= ?bjwr ?bjwq))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bjwt Real)
      (declare-const ?bjwu Real)
      (declare-const ?bjwv Real)
      (declare-const ?bjww Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bjwu ?bjwt)
                  (= ?bjwu ?awmg)
                  )
                (= ?bjwt ?awmg)
                )
              (or (or (= ?bjww ?bjwv)
                  (= ?bjww ?awmg)
                  )
                (= ?bjwv ?awmg)
                )
              )
            (and (not (= ?bjwu ?bjwt))
              (and (and (not (= ?bjww ?bjwv))
                  (not (= ?bjww ?awmg))
                  )
                (not (= ?bjwv ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjwx Real)
      (declare-const ?bjwy Real)
      (declare-const ?bjwz Real)
      (declare-const ?bjxa Real)
      (declare-const ?bjxb Real)
      (declare-const ?bjxc Real)
      (assert
        (or (and (or (or (= ?bjwz ?bjwy)
                (= ?bjwz ?bjwx)
                )
              (= ?bjwy ?bjwx)
              )
            (or (or (= ?bjxc ?bjxb)
                (= ?bjxc ?bjxa)
                )
              (= ?bjxb ?bjxa)
              )
            )
          (and (and (and (not (= ?bjwz ?bjwy))
                (not (= ?bjwz ?bjwx))
                )
              (not (= ?bjwy ?bjwx))
              )
            (and (and (not (= ?bjxc ?bjxb))
                (not (= ?bjxc ?bjxa))
                )
              (not (= ?bjxb ?bjxa))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjxd Real)
      (declare-const ?bjxe Real)
      (declare-const ?bjxf Real)
      (assert
        (and (and (not (= ?bjxf ?bjxe))
            (not (= ?bjxf ?bjxd))
            )
          (not (= ?bjxe ?bjxd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjxg Real)
      (declare-const ?bjxh Real)
      (declare-const ?bjxi Real)
      (assert
        (and (and (not (= ?bjxi ?bjxh))
            (not (= ?bjxi ?bjxg))
            )
          (not (= ?bjxh ?bjxg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bjxj Real)
    (push 1)
      (declare-const ?bjxk Real)
      (declare-const ?bjxl Real)
      (declare-const ?bjxm Real)
      (declare-const ?bjxn Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bjxl ?bjxk)
                  (= ?bjxl ?awmg)
                  )
                (= ?bjxk ?awmg)
                )
              (or (or (= ?bjxn ?bjxm)
                  (= ?bjxn ?awmg)
                  )
                (= ?bjxm ?awmg)
                )
              )
            (and (not (= ?bjxl ?bjxk))
              (and (and (not (= ?bjxn ?bjxm))
                  (not (= ?bjxn ?awmg))
                  )
                (not (= ?bjxm ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjxo Real)
      (declare-const ?bjxp Real)
      (declare-const ?bjxq Real)
      (declare-const ?bjxr Real)
      (declare-const ?bjxs Real)
      (declare-const ?bjxt Real)
      (assert
        (or (and (or (or (= ?bjxq ?bjxp)
                (= ?bjxq ?bjxo)
                )
              (= ?bjxp ?bjxo)
              )
            (or (or (= ?bjxt ?bjxs)
                (= ?bjxt ?bjxr)
                )
              (= ?bjxs ?bjxr)
              )
            )
          (and (and (and (not (= ?bjxq ?bjxp))
                (not (= ?bjxq ?bjxo))
                )
              (not (= ?bjxp ?bjxo))
              )
            (and (and (not (= ?bjxt ?bjxs))
                (not (= ?bjxt ?bjxr))
                )
              (not (= ?bjxs ?bjxr))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjxu Real)
      (declare-const ?bjxv Real)
      (declare-const ?bjxw Real)
      (assert
        (and (and (not (= ?bjxw ?bjxv))
            (not (= ?bjxw ?bjxu))
            )
          (not (= ?bjxv ?bjxu))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjxx Real)
      (declare-const ?bjxy Real)
      (declare-const ?bjxz Real)
      (assert
        (and (and (not (= ?bjxz ?bjxy))
            (not (= ?bjxz ?bjxx))
            )
          (not (= ?bjxy ?bjxx))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bjya Real)
    (declare-const ?bjyb Real)
    (declare-const ?bjyc Real)
    (declare-const ?bjyd Real)
    (assert
      (forall ((?awmg Real) )(or (and (or (or (= ?bjyb ?bjya)
                (= ?bjyb ?awmg)
                )
              (= ?bjya ?awmg)
              )
            (or (or (= ?bjyd ?bjyc)
                (= ?bjyd ?awmg)
                )
              (= ?bjyc ?awmg)
              )
            )
          (and (not (= ?bjyb ?bjya))
            (and (and (not (= ?bjyd ?bjyc))
                (not (= ?bjyd ?awmg))
                )
              (not (= ?bjyc ?awmg))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjye Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjyf Real)
      (declare-const ?bjyg Real)
      (declare-const ?bjyh Real)
      (declare-const ?bjyi Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bjyg ?bjyf)
                  (= ?bjyg ?awmg)
                  )
                (= ?bjyf ?awmg)
                )
              (or (or (= ?bjyi ?bjyh)
                  (= ?bjyi ?awmg)
                  )
                (= ?bjyh ?awmg)
                )
              )
            (and (not (= ?bjyg ?bjyf))
              (and (and (not (= ?bjyi ?bjyh))
                  (not (= ?bjyi ?awmg))
                  )
                (not (= ?bjyh ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjyj Real)
      (declare-const ?bjyk Real)
      (declare-const ?bjyl Real)
      (declare-const ?bjym Real)
      (declare-const ?bjyn Real)
      (declare-const ?bjyo Real)
      (assert
        (or (and (or (or (= ?bjyl ?bjyk)
                (= ?bjyl ?bjyj)
                )
              (= ?bjyk ?bjyj)
              )
            (or (or (= ?bjyo ?bjyn)
                (= ?bjyo ?bjym)
                )
              (= ?bjyn ?bjym)
              )
            )
          (and (and (and (not (= ?bjyl ?bjyk))
                (not (= ?bjyl ?bjyj))
                )
              (not (= ?bjyk ?bjyj))
              )
            (and (and (not (= ?bjyo ?bjyn))
                (not (= ?bjyo ?bjym))
                )
              (not (= ?bjyn ?bjym))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjyp Real)
      (declare-const ?bjyq Real)
      (declare-const ?bjyr Real)
      (assert
        (and (and (not (= ?bjyr ?bjyq))
            (not (= ?bjyr ?bjyp))
            )
          (not (= ?bjyq ?bjyp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjys Real)
      (declare-const ?bjyt Real)
      (declare-const ?bjyu Real)
      (assert
        (and (and (not (= ?bjyu ?bjyt))
            (not (= ?bjyu ?bjys))
            )
          (not (= ?bjyt ?bjys))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bjyv Real)
    (declare-const ?bjyw Real)
    (declare-const ?bjyx Real)
    (declare-const ?bjyy Real)
    (declare-const ?bjyz Real)
    (declare-const ?bjza Real)
    (assert
      (or (and (or (or (= ?bjyx ?bjyw)
              (= ?bjyx ?bjyv)
              )
            (= ?bjyw ?bjyv)
            )
          (or (or (= ?bjza ?bjyz)
              (= ?bjza ?bjyy)
              )
            (= ?bjyz ?bjyy)
            )
          )
        (and (and (and (not (= ?bjyx ?bjyw))
              (not (= ?bjyx ?bjyv))
              )
            (not (= ?bjyw ?bjyv))
            )
          (and (and (not (= ?bjza ?bjyz))
              (not (= ?bjza ?bjyy))
              )
            (not (= ?bjyz ?bjyy))
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjzb Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjzc Real)
      (declare-const ?bjzd Real)
      (declare-const ?bjze Real)
      (declare-const ?bjzf Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bjzd ?bjzc)
                  (= ?bjzd ?awmg)
                  )
                (= ?bjzc ?awmg)
                )
              (or (or (= ?bjzf ?bjze)
                  (= ?bjzf ?awmg)
                  )
                (= ?bjze ?awmg)
                )
              )
            (and (not (= ?bjzd ?bjzc))
              (and (and (not (= ?bjzf ?bjze))
                  (not (= ?bjzf ?awmg))
                  )
                (not (= ?bjze ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjzg Real)
      (declare-const ?bjzh Real)
      (declare-const ?bjzi Real)
      (declare-const ?bjzj Real)
      (declare-const ?bjzk Real)
      (declare-const ?bjzl Real)
      (assert
        (or (and (or (or (= ?bjzi ?bjzh)
                (= ?bjzi ?bjzg)
                )
              (= ?bjzh ?bjzg)
              )
            (or (or (= ?bjzl ?bjzk)
                (= ?bjzl ?bjzj)
                )
              (= ?bjzk ?bjzj)
              )
            )
          (and (and (and (not (= ?bjzi ?bjzh))
                (not (= ?bjzi ?bjzg))
                )
              (not (= ?bjzh ?bjzg))
              )
            (and (and (not (= ?bjzl ?bjzk))
                (not (= ?bjzl ?bjzj))
                )
              (not (= ?bjzk ?bjzj))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjzm Real)
      (declare-const ?bjzn Real)
      (declare-const ?bjzo Real)
      (assert
        (and (and (not (= ?bjzo ?bjzn))
            (not (= ?bjzo ?bjzm))
            )
          (not (= ?bjzn ?bjzm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjzp Real)
      (declare-const ?bjzq Real)
      (declare-const ?bjzr Real)
      (assert
        (and (and (not (= ?bjzr ?bjzq))
            (not (= ?bjzr ?bjzp))
            )
          (not (= ?bjzq ?bjzp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bjzs Real)
    (declare-const ?bjzt Real)
    (declare-const ?bjzu Real)
    (assert
      (and (and (not (= ?bjzu ?bjzt))
          (not (= ?bjzu ?bjzs))
          )
        (not (= ?bjzt ?bjzs))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjzv Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bjzw Real)
      (declare-const ?bjzx Real)
      (declare-const ?bjzy Real)
      (declare-const ?bjzz Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bjzx ?bjzw)
                  (= ?bjzx ?awmg)
                  )
                (= ?bjzw ?awmg)
                )
              (or (or (= ?bjzz ?bjzy)
                  (= ?bjzz ?awmg)
                  )
                (= ?bjzy ?awmg)
                )
              )
            (and (not (= ?bjzx ?bjzw))
              (and (and (not (= ?bjzz ?bjzy))
                  (not (= ?bjzz ?awmg))
                  )
                (not (= ?bjzy ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkaa Real)
      (declare-const ?bkab Real)
      (declare-const ?bkac Real)
      (declare-const ?bkad Real)
      (declare-const ?bkae Real)
      (declare-const ?bkaf Real)
      (assert
        (or (and (or (or (= ?bkac ?bkab)
                (= ?bkac ?bkaa)
                )
              (= ?bkab ?bkaa)
              )
            (or (or (= ?bkaf ?bkae)
                (= ?bkaf ?bkad)
                )
              (= ?bkae ?bkad)
              )
            )
          (and (and (and (not (= ?bkac ?bkab))
                (not (= ?bkac ?bkaa))
                )
              (not (= ?bkab ?bkaa))
              )
            (and (and (not (= ?bkaf ?bkae))
                (not (= ?bkaf ?bkad))
                )
              (not (= ?bkae ?bkad))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkag Real)
      (declare-const ?bkah Real)
      (declare-const ?bkai Real)
      (assert
        (and (and (not (= ?bkai ?bkah))
            (not (= ?bkai ?bkag))
            )
          (not (= ?bkah ?bkag))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkaj Real)
      (declare-const ?bkak Real)
      (declare-const ?bkal Real)
      (assert
        (and (and (not (= ?bkal ?bkak))
            (not (= ?bkal ?bkaj))
            )
          (not (= ?bkak ?bkaj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bkam Real)
    (declare-const ?bkan Real)
    (declare-const ?bkao Real)
    (assert
      (and (and (not (= ?bkao ?bkan))
          (not (= ?bkao ?bkam))
          )
        (not (= ?bkan ?bkam))
        )
      )
(set-info :status unknown)
    (check-sat)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkap Real)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkaq Real)
      (declare-const ?bkar Real)
      (declare-const ?bkas Real)
      (declare-const ?bkat Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkar ?bkaq)
                  (= ?bkar ?awmg)
                  )
                (= ?bkaq ?awmg)
                )
              (or (or (= ?bkat ?bkas)
                  (= ?bkat ?awmg)
                  )
                (= ?bkas ?awmg)
                )
              )
            (and (not (= ?bkar ?bkaq))
              (and (and (not (= ?bkat ?bkas))
                  (not (= ?bkat ?awmg))
                  )
                (not (= ?bkas ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkau Real)
      (declare-const ?bkav Real)
      (declare-const ?bkaw Real)
      (declare-const ?bkax Real)
      (declare-const ?bkay Real)
      (declare-const ?bkaz Real)
      (assert
        (or (and (or (or (= ?bkaw ?bkav)
                (= ?bkaw ?bkau)
                )
              (= ?bkav ?bkau)
              )
            (or (or (= ?bkaz ?bkay)
                (= ?bkaz ?bkax)
                )
              (= ?bkay ?bkax)
              )
            )
          (and (and (and (not (= ?bkaw ?bkav))
                (not (= ?bkaw ?bkau))
                )
              (not (= ?bkav ?bkau))
              )
            (and (and (not (= ?bkaz ?bkay))
                (not (= ?bkaz ?bkax))
                )
              (not (= ?bkay ?bkax))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkba Real)
      (declare-const ?bkbb Real)
      (declare-const ?bkbc Real)
      (assert
        (and (and (not (= ?bkbc ?bkbb))
            (not (= ?bkbc ?bkba))
            )
          (not (= ?bkbb ?bkba))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkbd Real)
      (declare-const ?bkbe Real)
      (declare-const ?bkbf Real)
      (assert
        (and (and (not (= ?bkbf ?bkbe))
            (not (= ?bkbf ?bkbd))
            )
          (not (= ?bkbe ?bkbd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bkbg Real)
      (declare-const ?bkbh Real)
      (declare-const ?bkbi Real)
      (declare-const ?bkbj Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkbh ?bkbg)
                  (= ?bkbh ?awmg)
                  )
                (= ?bkbg ?awmg)
                )
              (or (or (= ?bkbj ?bkbi)
                  (= ?bkbj ?awmg)
                  )
                (= ?bkbi ?awmg)
                )
              )
            (and (not (= ?bkbh ?bkbg))
              (and (and (not (= ?bkbj ?bkbi))
                  (not (= ?bkbj ?awmg))
                  )
                (not (= ?bkbi ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkbk Real)
      (declare-const ?bkbl Real)
      (declare-const ?bkbm Real)
      (declare-const ?bkbn Real)
      (declare-const ?bkbo Real)
      (declare-const ?bkbp Real)
      (assert
        (or (and (or (or (= ?bkbm ?bkbl)
                (= ?bkbm ?bkbk)
                )
              (= ?bkbl ?bkbk)
              )
            (or (or (= ?bkbp ?bkbo)
                (= ?bkbp ?bkbn)
                )
              (= ?bkbo ?bkbn)
              )
            )
          (and (and (and (not (= ?bkbm ?bkbl))
                (not (= ?bkbm ?bkbk))
                )
              (not (= ?bkbl ?bkbk))
              )
            (and (and (not (= ?bkbp ?bkbo))
                (not (= ?bkbp ?bkbn))
                )
              (not (= ?bkbo ?bkbn))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkbq Real)
      (declare-const ?bkbr Real)
      (declare-const ?bkbs Real)
      (assert
        (and (and (not (= ?bkbs ?bkbr))
            (not (= ?bkbs ?bkbq))
            )
          (not (= ?bkbr ?bkbq))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkbt Real)
      (declare-const ?bkbu Real)
      (declare-const ?bkbv Real)
      (assert
        (and (and (not (= ?bkbv ?bkbu))
            (not (= ?bkbv ?bkbt))
            )
          (not (= ?bkbu ?bkbt))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (assert
      (and (and (and (and (forall ((?bjya Real) (?bjyb Real) (?bjyc Real) (?bjyd Real) )(or (exists ((?awmg Real) )(and (or (and (and (not (= ?bjyb ?bjya))
                            (not (= ?bjyb ?awmg))
                            )
                          (not (= ?bjya ?awmg))
                          )
                        (and (and (not (= ?bjyd ?bjyc))
                            (not (= ?bjyd ?awmg))
                            )
                          (not (= ?bjyc ?awmg))
                          )
                        )
                      (or (= ?bjyb ?bjya)
                        (or (or (= ?bjyd ?bjyc)
                            (= ?bjyd ?awmg)
                            )
                          (= ?bjyc ?awmg)
                          )
                        )
                      )
                    )
                  (forall ((?awmg Real) )(or (and (or (or (= ?bjyb ?bjya)
                            (= ?bjyb ?awmg)
                            )
                          (= ?bjya ?awmg)
                          )
                        (or (or (= ?bjyd ?bjyc)
                            (= ?bjyd ?awmg)
                            )
                          (= ?bjyc ?awmg)
                          )
                        )
                      (and (not (= ?bjyb ?bjya))
                        (and (and (not (= ?bjyd ?bjyc))
                            (not (= ?bjyd ?awmg))
                            )
                          (not (= ?bjyc ?awmg))
                          )
                        )
                      )
                    )
                  )
                )
              (forall ((?bjyv Real) (?bjyw Real) (?bjyx Real) (?bjyy Real) (?bjyz Real) (?bjza Real) )(or (and (or (and (and (not (= ?bjyx ?bjyw))
                          (not (= ?bjyx ?bjyv))
                          )
                        (not (= ?bjyw ?bjyv))
                        )
                      (and (and (not (= ?bjza ?bjyz))
                          (not (= ?bjza ?bjyy))
                          )
                        (not (= ?bjyz ?bjyy))
                        )
                      )
                    (or (or (or (= ?bjyx ?bjyw)
                          (= ?bjyx ?bjyv)
                          )
                        (= ?bjyw ?bjyv)
                        )
                      (or (or (= ?bjza ?bjyz)
                          (= ?bjza ?bjyy)
                          )
                        (= ?bjyz ?bjyy)
                        )
                      )
                    )
                  (or (and (or (or (= ?bjyx ?bjyw)
                          (= ?bjyx ?bjyv)
                          )
                        (= ?bjyw ?bjyv)
                        )
                      (or (or (= ?bjza ?bjyz)
                          (= ?bjza ?bjyy)
                          )
                        (= ?bjyz ?bjyy)
                        )
                      )
                    (and (and (and (not (= ?bjyx ?bjyw))
                          (not (= ?bjyx ?bjyv))
                          )
                        (not (= ?bjyw ?bjyv))
                        )
                      (and (and (not (= ?bjza ?bjyz))
                          (not (= ?bjza ?bjyy))
                          )
                        (not (= ?bjyz ?bjyy))
                        )
                      )
                    )
                  )
                )
              )
            (forall ((?bjzt Real) (?bjzs Real) )(or (= ?bjzt ?bjzs)
                (forall ((?bjzu Real) )(or (= ?bjzu ?bjzt)
                    (or (= ?bjzu ?bjzs)
                      (and (and (not (= ?bjzu ?bjzt))
                          (not (= ?bjzu ?bjzs))
                          )
                        (not (= ?bjzt ?bjzs))
                        )
                      )
                    )
                  )
                )
              )
            )
          (forall ((?bkan Real) (?bkam Real) )(or (= ?bkan ?bkam)
              (forall ((?bkao Real) )(or (= ?bkao ?bkan)
                  (or (= ?bkao ?bkam)
                    (and (and (not (= ?bkao ?bkan))
                        (not (= ?bkao ?bkam))
                        )
                      (not (= ?bkan ?bkam))
                      )
                    )
                  )
                )
              )
            )
          )
        (and (and (and (forall ((?bjsx Real) (?bjsy Real) (?bjsz Real) (?bjta Real) )(or (exists ((?awmg Real) )(and (or (and (and (not (= ?bjsy ?bjsx))
                            (not (= ?bjsy ?awmg))
                            )
                          (not (= ?bjsx ?awmg))
                          )
                        (and (and (not (= ?bjta ?bjsz))
                            (not (= ?bjta ?awmg))
                            )
                          (not (= ?bjsz ?awmg))
                          )
                        )
                      (or (= ?bjsy ?bjsx)
                        (or (or (= ?bjta ?bjsz)
                            (= ?bjta ?awmg)
                            )
                          (= ?bjsz ?awmg)
                          )
                        )
                      )
                    )
                  (forall ((?awmg Real) )(or (and (or (or (= ?bjsy ?bjsx)
                            (= ?bjsy ?awmg)
                            )
                          (= ?bjsx ?awmg)
                          )
                        (or (or (= ?bjta ?bjsz)
                            (= ?bjta ?awmg)
                            )
                          (= ?bjsz ?awmg)
                          )
                        )
                      (and (not (= ?bjsy ?bjsx))
                        (and (and (not (= ?bjta ?bjsz))
                            (not (= ?bjta ?awmg))
                            )
                          (not (= ?bjsz ?awmg))
                          )
                        )
                      )
                    )
                  )
                )
              (forall ((?bjts Real) (?bjtt Real) (?bjtu Real) (?bjtv Real) (?bjtw Real) (?bjtx Real) )(or (and (or (and (and (not (= ?bjtu ?bjtt))
                          (not (= ?bjtu ?bjts))
                          )
                        (not (= ?bjtt ?bjts))
                        )
                      (and (and (not (= ?bjtx ?bjtw))
                          (not (= ?bjtx ?bjtv))
                          )
                        (not (= ?bjtw ?bjtv))
                        )
                      )
                    (or (or (or (= ?bjtu ?bjtt)
                          (= ?bjtu ?bjts)
                          )
                        (= ?bjtt ?bjts)
                        )
                      (or (or (= ?bjtx ?bjtw)
                          (= ?bjtx ?bjtv)
                          )
                        (= ?bjtw ?bjtv)
                        )
                      )
                    )
                  (or (and (or (or (= ?bjtu ?bjtt)
                          (= ?bjtu ?bjts)
                          )
                        (= ?bjtt ?bjts)
                        )
                      (or (or (= ?bjtx ?bjtw)
                          (= ?bjtx ?bjtv)
                          )
                        (= ?bjtw ?bjtv)
                        )
                      )
                    (and (and (and (not (= ?bjtu ?bjtt))
                          (not (= ?bjtu ?bjts))
                          )
                        (not (= ?bjtt ?bjts))
                        )
                      (and (and (not (= ?bjtx ?bjtw))
                          (not (= ?bjtx ?bjtv))
                          )
                        (not (= ?bjtw ?bjtv))
                        )
                      )
                    )
                  )
                )
              )
            (forall ((?bjuq Real) (?bjup Real) )(or (= ?bjuq ?bjup)
                (forall ((?bjur Real) )(or (= ?bjur ?bjuq)
                    (or (= ?bjur ?bjup)
                      (and (and (not (= ?bjur ?bjuq))
                          (not (= ?bjur ?bjup))
                          )
                        (not (= ?bjuq ?bjup))
                        )
                      )
                    )
                  )
                )
              )
            )
          (forall ((?bjvk Real) (?bjvj Real) )(or (= ?bjvk ?bjvj)
              (forall ((?bjvl Real) )(or (= ?bjvl ?bjvk)
                  (or (= ?bjvl ?bjvj)
                    (and (and (not (= ?bjvl ?bjvk))
                        (not (= ?bjvl ?bjvj))
                        )
                      (not (= ?bjvk ?bjvj))
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bkbw Real)
  (declare-const ?bkbx Real)
  (declare-const ?bkby Real)
  (declare-const ?bkbz Real)
  (assert
    (forall ((?awmg Real) )(or (and (or (or (= ?bkbx ?bkbw)
              (= ?bkbx ?awmg)
              )
            (= ?bkbw ?awmg)
            )
          (or (or (= ?bkbz ?bkby)
              (= ?bkbz ?awmg)
              )
            (= ?bkby ?awmg)
            )
          )
        (and (not (= ?bkbx ?bkbw))
          (and (and (not (= ?bkbz ?bkby))
              (not (= ?bkbz ?awmg))
              )
            (not (= ?bkby ?awmg))
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bkca Real)
  (declare-const ?bkcb Real)
  (declare-const ?bkcc Real)
  (declare-const ?bkcd Real)
  (declare-const ?bkce Real)
  (declare-const ?bkcf Real)
  (assert
    (or (and (or (or (= ?bkcc ?bkcb)
            (= ?bkcc ?bkca)
            )
          (= ?bkcb ?bkca)
          )
        (or (or (= ?bkcf ?bkce)
            (= ?bkcf ?bkcd)
            )
          (= ?bkce ?bkcd)
          )
        )
      (and (and (and (not (= ?bkcc ?bkcb))
            (not (= ?bkcc ?bkca))
            )
          (not (= ?bkcb ?bkca))
          )
        (and (and (not (= ?bkcf ?bkce))
            (not (= ?bkcf ?bkcd))
            )
          (not (= ?bkce ?bkcd))
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bkcg Real)
  (declare-const ?bkch Real)
  (declare-const ?bkci Real)
  (assert
    (and (and (not (= ?bkci ?bkch))
        (not (= ?bkci ?bkcg))
        )
      (not (= ?bkch ?bkcg))
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bkcj Real)
  (declare-const ?bkck Real)
  (declare-const ?bkcl Real)
  (assert
    (and (and (not (= ?bkcl ?bkck))
        (not (= ?bkcl ?bkcj))
        )
      (not (= ?bkck ?bkcj))
      )
    )
(set-info :status unknown)
  (check-sat)
  (push 1)
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (declare-const ?bkcm Real)
    (declare-const ?bkcn Real)
    (declare-const ?bkco Real)
    (declare-const ?bkcp Real)
    (assert
      (forall ((?awmg Real) )(or (and (or (or (= ?bkcn ?bkcm)
                (= ?bkcn ?awmg)
                )
              (= ?bkcm ?awmg)
              )
            (or (or (= ?bkcp ?bkco)
                (= ?bkcp ?awmg)
                )
              (= ?bkco ?awmg)
              )
            )
          (and (not (= ?bkcn ?bkcm))
            (and (and (not (= ?bkcp ?bkco))
                (not (= ?bkcp ?awmg))
                )
              (not (= ?bkco ?awmg))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bkcq Real)
    (declare-const ?bkcr Real)
    (declare-const ?bkcs Real)
    (declare-const ?bkct Real)
    (declare-const ?bkcu Real)
    (declare-const ?bkcv Real)
    (assert
      (or (and (or (or (= ?bkcs ?bkcr)
              (= ?bkcs ?bkcq)
              )
            (= ?bkcr ?bkcq)
            )
          (or (or (= ?bkcv ?bkcu)
              (= ?bkcv ?bkct)
              )
            (= ?bkcu ?bkct)
            )
          )
        (and (and (and (not (= ?bkcs ?bkcr))
              (not (= ?bkcs ?bkcq))
              )
            (not (= ?bkcr ?bkcq))
            )
          (and (and (not (= ?bkcv ?bkcu))
              (not (= ?bkcv ?bkct))
              )
            (not (= ?bkcu ?bkct))
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bkcw Real)
    (declare-const ?bkcx Real)
    (declare-const ?bkcy Real)
    (assert
      (and (and (not (= ?bkcy ?bkcx))
          (not (= ?bkcy ?bkcw))
          )
        (not (= ?bkcx ?bkcw))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (declare-const ?bkcz Real)
    (declare-const ?bkda Real)
    (declare-const ?bkdb Real)
    (assert
      (and (and (not (= ?bkdb ?bkda))
          (not (= ?bkdb ?bkcz))
          )
        (not (= ?bkda ?bkcz))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (assert
    (or (or (or (or (exists ((?bjya Real) (?bjyb Real) (?bjyc Real) (?bjyd Real) )(and (forall ((?awmg Real) )(or (and (or (or (= ?bjyb ?bjya)
                          (= ?bjyb ?awmg)
                          )
                        (= ?bjya ?awmg)
                        )
                      (or (or (= ?bjyd ?bjyc)
                          (= ?bjyd ?awmg)
                          )
                        (= ?bjyc ?awmg)
                        )
                      )
                    (and (not (= ?bjyb ?bjya))
                      (and (and (not (= ?bjyd ?bjyc))
                          (not (= ?bjyd ?awmg))
                          )
                        (not (= ?bjyc ?awmg))
                        )
                      )
                    )
                  )
                (exists ((?awmg Real) )(and (or (and (and (not (= ?bjyb ?bjya))
                          (not (= ?bjyb ?awmg))
                          )
                        (not (= ?bjya ?awmg))
                        )
                      (and (and (not (= ?bjyd ?bjyc))
                          (not (= ?bjyd ?awmg))
                          )
                        (not (= ?bjyc ?awmg))
                        )
                      )
                    (or (= ?bjyb ?bjya)
                      (or (or (= ?bjyd ?bjyc)
                          (= ?bjyd ?awmg)
                          )
                        (= ?bjyc ?awmg)
                        )
                      )
                    )
                  )
                )
              )
            (exists ((?bjyv Real) (?bjyw Real) (?bjyx Real) (?bjyy Real) (?bjyz Real) (?bjza Real) )(and (or (and (or (or (= ?bjyx ?bjyw)
                        (= ?bjyx ?bjyv)
                        )
                      (= ?bjyw ?bjyv)
                      )
                    (or (or (= ?bjza ?bjyz)
                        (= ?bjza ?bjyy)
                        )
                      (= ?bjyz ?bjyy)
                      )
                    )
                  (and (and (and (not (= ?bjyx ?bjyw))
                        (not (= ?bjyx ?bjyv))
                        )
                      (not (= ?bjyw ?bjyv))
                      )
                    (and (and (not (= ?bjza ?bjyz))
                        (not (= ?bjza ?bjyy))
                        )
                      (not (= ?bjyz ?bjyy))
                      )
                    )
                  )
                (and (or (and (and (not (= ?bjyx ?bjyw))
                        (not (= ?bjyx ?bjyv))
                        )
                      (not (= ?bjyw ?bjyv))
                      )
                    (and (and (not (= ?bjza ?bjyz))
                        (not (= ?bjza ?bjyy))
                        )
                      (not (= ?bjyz ?bjyy))
                      )
                    )
                  (or (or (or (= ?bjyx ?bjyw)
                        (= ?bjyx ?bjyv)
                        )
                      (= ?bjyw ?bjyv)
                      )
                    (or (or (= ?bjza ?bjyz)
                        (= ?bjza ?bjyy)
                        )
                      (= ?bjyz ?bjyy)
                      )
                    )
                  )
                )
              )
            )
          (exists ((?bjzt Real) (?bjzs Real) )(and (not (= ?bjzt ?bjzs))
              (exists ((?bjzu Real) )(and (not (= ?bjzu ?bjzt))
                  (and (not (= ?bjzu ?bjzs))
                    (or (or (= ?bjzu ?bjzt)
                        (= ?bjzu ?bjzs)
                        )
                      (= ?bjzt ?bjzs)
                      )
                    )
                  )
                )
              )
            )
          )
        (exists ((?bkan Real) (?bkam Real) )(and (not (= ?bkan ?bkam))
            (exists ((?bkao Real) )(and (not (= ?bkao ?bkan))
                (and (not (= ?bkao ?bkam))
                  (or (or (= ?bkao ?bkan)
                      (= ?bkao ?bkam)
                      )
                    (= ?bkan ?bkam)
                    )
                  )
                )
              )
            )
          )
        )
      (or (or (or (exists ((?bjsx Real) (?bjsy Real) (?bjsz Real) (?bjta Real) )(and (forall ((?awmg Real) )(or (and (or (or (= ?bjsy ?bjsx)
                          (= ?bjsy ?awmg)
                          )
                        (= ?bjsx ?awmg)
                        )
                      (or (or (= ?bjta ?bjsz)
                          (= ?bjta ?awmg)
                          )
                        (= ?bjsz ?awmg)
                        )
                      )
                    (and (not (= ?bjsy ?bjsx))
                      (and (and (not (= ?bjta ?bjsz))
                          (not (= ?bjta ?awmg))
                          )
                        (not (= ?bjsz ?awmg))
                        )
                      )
                    )
                  )
                (exists ((?awmg Real) )(and (or (and (and (not (= ?bjsy ?bjsx))
                          (not (= ?bjsy ?awmg))
                          )
                        (not (= ?bjsx ?awmg))
                        )
                      (and (and (not (= ?bjta ?bjsz))
                          (not (= ?bjta ?awmg))
                          )
                        (not (= ?bjsz ?awmg))
                        )
                      )
                    (or (= ?bjsy ?bjsx)
                      (or (or (= ?bjta ?bjsz)
                          (= ?bjta ?awmg)
                          )
                        (= ?bjsz ?awmg)
                        )
                      )
                    )
                  )
                )
              )
            (exists ((?bjts Real) (?bjtt Real) (?bjtu Real) (?bjtv Real) (?bjtw Real) (?bjtx Real) )(and (or (and (or (or (= ?bjtu ?bjtt)
                        (= ?bjtu ?bjts)
                        )
                      (= ?bjtt ?bjts)
                      )
                    (or (or (= ?bjtx ?bjtw)
                        (= ?bjtx ?bjtv)
                        )
                      (= ?bjtw ?bjtv)
                      )
                    )
                  (and (and (and (not (= ?bjtu ?bjtt))
                        (not (= ?bjtu ?bjts))
                        )
                      (not (= ?bjtt ?bjts))
                      )
                    (and (and (not (= ?bjtx ?bjtw))
                        (not (= ?bjtx ?bjtv))
                        )
                      (not (= ?bjtw ?bjtv))
                      )
                    )
                  )
                (and (or (and (and (not (= ?bjtu ?bjtt))
                        (not (= ?bjtu ?bjts))
                        )
                      (not (= ?bjtt ?bjts))
                      )
                    (and (and (not (= ?bjtx ?bjtw))
                        (not (= ?bjtx ?bjtv))
                        )
                      (not (= ?bjtw ?bjtv))
                      )
                    )
                  (or (or (or (= ?bjtu ?bjtt)
                        (= ?bjtu ?bjts)
                        )
                      (= ?bjtt ?bjts)
                      )
                    (or (or (= ?bjtx ?bjtw)
                        (= ?bjtx ?bjtv)
                        )
                      (= ?bjtw ?bjtv)
                      )
                    )
                  )
                )
              )
            )
          (exists ((?bjuq Real) (?bjup Real) )(and (not (= ?bjuq ?bjup))
              (exists ((?bjur Real) )(and (not (= ?bjur ?bjuq))
                  (and (not (= ?bjur ?bjup))
                    (or (or (= ?bjur ?bjuq)
                        (= ?bjur ?bjup)
                        )
                      (= ?bjuq ?bjup)
                      )
                    )
                  )
                )
              )
            )
          )
        (exists ((?bjvk Real) (?bjvj Real) )(and (not (= ?bjvk ?bjvj))
            (exists ((?bjvl Real) )(and (not (= ?bjvl ?bjvk))
                (and (not (= ?bjvl ?bjvj))
                  (or (or (= ?bjvl ?bjvk)
                      (= ?bjvl ?bjvj)
                      )
                    (= ?bjvk ?bjvj)
                    )
                  )
                )
              )
            )
          )
        )
      )
    )
(set-info :status unknown)
  (check-sat)
  (pop 1)
(push 1)
  (push 1)
    (push 1)
      (declare-const ?bkdc Real)
      (declare-const ?bkdd Real)
      (declare-const ?bkde Real)
      (declare-const ?bkdf Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkdd ?bkdc)
                  (= ?bkdd ?awmg)
                  )
                (= ?bkdc ?awmg)
                )
              (or (or (= ?bkdf ?bkde)
                  (= ?bkdf ?awmg)
                  )
                (= ?bkde ?awmg)
                )
              )
            (and (not (= ?bkdd ?bkdc))
              (and (and (not (= ?bkdf ?bkde))
                  (not (= ?bkdf ?awmg))
                  )
                (not (= ?bkde ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkdg Real)
      (declare-const ?bkdh Real)
      (declare-const ?bkdi Real)
      (declare-const ?bkdj Real)
      (declare-const ?bkdk Real)
      (declare-const ?bkdl Real)
      (assert
        (or (and (or (or (= ?bkdi ?bkdh)
                (= ?bkdi ?bkdg)
                )
              (= ?bkdh ?bkdg)
              )
            (or (or (= ?bkdl ?bkdk)
                (= ?bkdl ?bkdj)
                )
              (= ?bkdk ?bkdj)
              )
            )
          (and (and (and (not (= ?bkdi ?bkdh))
                (not (= ?bkdi ?bkdg))
                )
              (not (= ?bkdh ?bkdg))
              )
            (and (and (not (= ?bkdl ?bkdk))
                (not (= ?bkdl ?bkdj))
                )
              (not (= ?bkdk ?bkdj))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkdm Real)
      (declare-const ?bkdn Real)
      (declare-const ?bkdo Real)
      (assert
        (and (and (not (= ?bkdo ?bkdn))
            (not (= ?bkdo ?bkdm))
            )
          (not (= ?bkdn ?bkdm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkdp Real)
      (declare-const ?bkdq Real)
      (declare-const ?bkdr Real)
      (assert
        (and (and (not (= ?bkdr ?bkdq))
            (not (= ?bkdr ?bkdp))
            )
          (not (= ?bkdq ?bkdp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bkds Real)
    (push 1)
      (declare-const ?bkdt Real)
      (declare-const ?bkdu Real)
      (declare-const ?bkdv Real)
      (declare-const ?bkdw Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkdu ?bkdt)
                  (= ?bkdu ?awmg)
                  )
                (= ?bkdt ?awmg)
                )
              (or (or (= ?bkdw ?bkdv)
                  (= ?bkdw ?awmg)
                  )
                (= ?bkdv ?awmg)
                )
              )
            (and (not (= ?bkdu ?bkdt))
              (and (and (not (= ?bkdw ?bkdv))
                  (not (= ?bkdw ?awmg))
                  )
                (not (= ?bkdv ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkdx Real)
      (declare-const ?bkdy Real)
      (declare-const ?bkdz Real)
      (declare-const ?bkea Real)
      (declare-const ?bkeb Real)
      (declare-const ?bkec Real)
      (assert
        (or (and (or (or (= ?bkdz ?bkdy)
                (= ?bkdz ?bkdx)
                )
              (= ?bkdy ?bkdx)
              )
            (or (or (= ?bkec ?bkeb)
                (= ?bkec ?bkea)
                )
              (= ?bkeb ?bkea)
              )
            )
          (and (and (and (not (= ?bkdz ?bkdy))
                (not (= ?bkdz ?bkdx))
                )
              (not (= ?bkdy ?bkdx))
              )
            (and (and (not (= ?bkec ?bkeb))
                (not (= ?bkec ?bkea))
                )
              (not (= ?bkeb ?bkea))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bked Real)
      (declare-const ?bkee Real)
      (declare-const ?bkef Real)
      (assert
        (and (and (not (= ?bkef ?bkee))
            (not (= ?bkef ?bked))
            )
          (not (= ?bkee ?bked))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkeg Real)
      (declare-const ?bkeh Real)
      (declare-const ?bkei Real)
      (assert
        (and (and (not (= ?bkei ?bkeh))
            (not (= ?bkei ?bkeg))
            )
          (not (= ?bkeh ?bkeg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bkej Real)
    (declare-const ?bkek Real)
    (push 1)
      (declare-const ?bkel Real)
      (declare-const ?bkem Real)
      (declare-const ?bken Real)
      (declare-const ?bkeo Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkem ?bkel)
                  (= ?bkem ?awmg)
                  )
                (= ?bkel ?awmg)
                )
              (or (or (= ?bkeo ?bken)
                  (= ?bkeo ?awmg)
                  )
                (= ?bken ?awmg)
                )
              )
            (and (not (= ?bkem ?bkel))
              (and (and (not (= ?bkeo ?bken))
                  (not (= ?bkeo ?awmg))
                  )
                (not (= ?bken ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkep Real)
      (declare-const ?bkeq Real)
      (declare-const ?bker Real)
      (declare-const ?bkes Real)
      (declare-const ?bket Real)
      (declare-const ?bkeu Real)
      (assert
        (or (and (or (or (= ?bker ?bkeq)
                (= ?bker ?bkep)
                )
              (= ?bkeq ?bkep)
              )
            (or (or (= ?bkeu ?bket)
                (= ?bkeu ?bkes)
                )
              (= ?bket ?bkes)
              )
            )
          (and (and (and (not (= ?bker ?bkeq))
                (not (= ?bker ?bkep))
                )
              (not (= ?bkeq ?bkep))
              )
            (and (and (not (= ?bkeu ?bket))
                (not (= ?bkeu ?bkes))
                )
              (not (= ?bket ?bkes))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkev Real)
      (declare-const ?bkew Real)
      (declare-const ?bkex Real)
      (assert
        (and (and (not (= ?bkex ?bkew))
            (not (= ?bkex ?bkev))
            )
          (not (= ?bkew ?bkev))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkey Real)
      (declare-const ?bkez Real)
      (declare-const ?bkfa Real)
      (assert
        (and (and (not (= ?bkfa ?bkez))
            (not (= ?bkfa ?bkey))
            )
          (not (= ?bkez ?bkey))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bkfb Real)
    (declare-const ?bkfc Real)
    (declare-const ?bkfd Real)
    (push 1)
      (declare-const ?bkfe Real)
      (declare-const ?bkff Real)
      (declare-const ?bkfg Real)
      (declare-const ?bkfh Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkff ?bkfe)
                  (= ?bkff ?awmg)
                  )
                (= ?bkfe ?awmg)
                )
              (or (or (= ?bkfh ?bkfg)
                  (= ?bkfh ?awmg)
                  )
                (= ?bkfg ?awmg)
                )
              )
            (and (not (= ?bkff ?bkfe))
              (and (and (not (= ?bkfh ?bkfg))
                  (not (= ?bkfh ?awmg))
                  )
                (not (= ?bkfg ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkfi Real)
      (declare-const ?bkfj Real)
      (declare-const ?bkfk Real)
      (declare-const ?bkfl Real)
      (declare-const ?bkfm Real)
      (declare-const ?bkfn Real)
      (assert
        (or (and (or (or (= ?bkfk ?bkfj)
                (= ?bkfk ?bkfi)
                )
              (= ?bkfj ?bkfi)
              )
            (or (or (= ?bkfn ?bkfm)
                (= ?bkfn ?bkfl)
                )
              (= ?bkfm ?bkfl)
              )
            )
          (and (and (and (not (= ?bkfk ?bkfj))
                (not (= ?bkfk ?bkfi))
                )
              (not (= ?bkfj ?bkfi))
              )
            (and (and (not (= ?bkfn ?bkfm))
                (not (= ?bkfn ?bkfl))
                )
              (not (= ?bkfm ?bkfl))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkfo Real)
      (declare-const ?bkfp Real)
      (declare-const ?bkfq Real)
      (assert
        (and (and (not (= ?bkfq ?bkfp))
            (not (= ?bkfq ?bkfo))
            )
          (not (= ?bkfp ?bkfo))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkfr Real)
      (declare-const ?bkfs Real)
      (declare-const ?bkft Real)
      (assert
        (and (and (not (= ?bkft ?bkfs))
            (not (= ?bkft ?bkfr))
            )
          (not (= ?bkfs ?bkfr))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bkfu Real)
      (declare-const ?bkfv Real)
      (declare-const ?bkfw Real)
      (declare-const ?bkfx Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkfv ?bkfu)
                  (= ?bkfv ?awmg)
                  )
                (= ?bkfu ?awmg)
                )
              (or (or (= ?bkfx ?bkfw)
                  (= ?bkfx ?awmg)
                  )
                (= ?bkfw ?awmg)
                )
              )
            (and (not (= ?bkfv ?bkfu))
              (and (and (not (= ?bkfx ?bkfw))
                  (not (= ?bkfx ?awmg))
                  )
                (not (= ?bkfw ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkfy Real)
      (declare-const ?bkfz Real)
      (declare-const ?bkga Real)
      (declare-const ?bkgb Real)
      (declare-const ?bkgc Real)
      (declare-const ?bkgd Real)
      (assert
        (or (and (or (or (= ?bkga ?bkfz)
                (= ?bkga ?bkfy)
                )
              (= ?bkfz ?bkfy)
              )
            (or (or (= ?bkgd ?bkgc)
                (= ?bkgd ?bkgb)
                )
              (= ?bkgc ?bkgb)
              )
            )
          (and (and (and (not (= ?bkga ?bkfz))
                (not (= ?bkga ?bkfy))
                )
              (not (= ?bkfz ?bkfy))
              )
            (and (and (not (= ?bkgd ?bkgc))
                (not (= ?bkgd ?bkgb))
                )
              (not (= ?bkgc ?bkgb))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkge Real)
      (declare-const ?bkgf Real)
      (declare-const ?bkgg Real)
      (assert
        (and (and (not (= ?bkgg ?bkgf))
            (not (= ?bkgg ?bkge))
            )
          (not (= ?bkgf ?bkge))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkgh Real)
      (declare-const ?bkgi Real)
      (declare-const ?bkgj Real)
      (assert
        (and (and (not (= ?bkgj ?bkgi))
            (not (= ?bkgj ?bkgh))
            )
          (not (= ?bkgi ?bkgh))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bkgk Real)
  (push 1)
    (push 1)
      (declare-const ?bkgl Real)
      (declare-const ?bkgm Real)
      (declare-const ?bkgn Real)
      (declare-const ?bkgo Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkgm ?bkgl)
                  (= ?bkgm ?awmg)
                  )
                (= ?bkgl ?awmg)
                )
              (or (or (= ?bkgo ?bkgn)
                  (= ?bkgo ?awmg)
                  )
                (= ?bkgn ?awmg)
                )
              )
            (and (not (= ?bkgm ?bkgl))
              (and (and (not (= ?bkgo ?bkgn))
                  (not (= ?bkgo ?awmg))
                  )
                (not (= ?bkgn ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkgp Real)
      (declare-const ?bkgq Real)
      (declare-const ?bkgr Real)
      (declare-const ?bkgs Real)
      (declare-const ?bkgt Real)
      (declare-const ?bkgu Real)
      (assert
        (or (and (or (or (= ?bkgr ?bkgq)
                (= ?bkgr ?bkgp)
                )
              (= ?bkgq ?bkgp)
              )
            (or (or (= ?bkgu ?bkgt)
                (= ?bkgu ?bkgs)
                )
              (= ?bkgt ?bkgs)
              )
            )
          (and (and (and (not (= ?bkgr ?bkgq))
                (not (= ?bkgr ?bkgp))
                )
              (not (= ?bkgq ?bkgp))
              )
            (and (and (not (= ?bkgu ?bkgt))
                (not (= ?bkgu ?bkgs))
                )
              (not (= ?bkgt ?bkgs))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkgv Real)
      (declare-const ?bkgw Real)
      (declare-const ?bkgx Real)
      (assert
        (and (and (not (= ?bkgx ?bkgw))
            (not (= ?bkgx ?bkgv))
            )
          (not (= ?bkgw ?bkgv))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkgy Real)
      (declare-const ?bkgz Real)
      (declare-const ?bkha Real)
      (assert
        (and (and (not (= ?bkha ?bkgz))
            (not (= ?bkha ?bkgy))
            )
          (not (= ?bkgz ?bkgy))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bkhb Real)
    (push 1)
      (declare-const ?bkhc Real)
      (declare-const ?bkhd Real)
      (declare-const ?bkhe Real)
      (declare-const ?bkhf Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkhd ?bkhc)
                  (= ?bkhd ?awmg)
                  )
                (= ?bkhc ?awmg)
                )
              (or (or (= ?bkhf ?bkhe)
                  (= ?bkhf ?awmg)
                  )
                (= ?bkhe ?awmg)
                )
              )
            (and (not (= ?bkhd ?bkhc))
              (and (and (not (= ?bkhf ?bkhe))
                  (not (= ?bkhf ?awmg))
                  )
                (not (= ?bkhe ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkhg Real)
      (declare-const ?bkhh Real)
      (declare-const ?bkhi Real)
      (declare-const ?bkhj Real)
      (declare-const ?bkhk Real)
      (declare-const ?bkhl Real)
      (assert
        (or (and (or (or (= ?bkhi ?bkhh)
                (= ?bkhi ?bkhg)
                )
              (= ?bkhh ?bkhg)
              )
            (or (or (= ?bkhl ?bkhk)
                (= ?bkhl ?bkhj)
                )
              (= ?bkhk ?bkhj)
              )
            )
          (and (and (and (not (= ?bkhi ?bkhh))
                (not (= ?bkhi ?bkhg))
                )
              (not (= ?bkhh ?bkhg))
              )
            (and (and (not (= ?bkhl ?bkhk))
                (not (= ?bkhl ?bkhj))
                )
              (not (= ?bkhk ?bkhj))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkhm Real)
      (declare-const ?bkhn Real)
      (declare-const ?bkho Real)
      (assert
        (and (and (not (= ?bkho ?bkhn))
            (not (= ?bkho ?bkhm))
            )
          (not (= ?bkhn ?bkhm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkhp Real)
      (declare-const ?bkhq Real)
      (declare-const ?bkhr Real)
      (assert
        (and (and (not (= ?bkhr ?bkhq))
            (not (= ?bkhr ?bkhp))
            )
          (not (= ?bkhq ?bkhp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bkhs Real)
    (declare-const ?bkht Real)
    (push 1)
      (declare-const ?bkhu Real)
      (declare-const ?bkhv Real)
      (declare-const ?bkhw Real)
      (declare-const ?bkhx Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkhv ?bkhu)
                  (= ?bkhv ?awmg)
                  )
                (= ?bkhu ?awmg)
                )
              (or (or (= ?bkhx ?bkhw)
                  (= ?bkhx ?awmg)
                  )
                (= ?bkhw ?awmg)
                )
              )
            (and (not (= ?bkhv ?bkhu))
              (and (and (not (= ?bkhx ?bkhw))
                  (not (= ?bkhx ?awmg))
                  )
                (not (= ?bkhw ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkhy Real)
      (declare-const ?bkhz Real)
      (declare-const ?bkia Real)
      (declare-const ?bkib Real)
      (declare-const ?bkic Real)
      (declare-const ?bkid Real)
      (assert
        (or (and (or (or (= ?bkia ?bkhz)
                (= ?bkia ?bkhy)
                )
              (= ?bkhz ?bkhy)
              )
            (or (or (= ?bkid ?bkic)
                (= ?bkid ?bkib)
                )
              (= ?bkic ?bkib)
              )
            )
          (and (and (and (not (= ?bkia ?bkhz))
                (not (= ?bkia ?bkhy))
                )
              (not (= ?bkhz ?bkhy))
              )
            (and (and (not (= ?bkid ?bkic))
                (not (= ?bkid ?bkib))
                )
              (not (= ?bkic ?bkib))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkie Real)
      (declare-const ?bkif Real)
      (declare-const ?bkig Real)
      (assert
        (and (and (not (= ?bkig ?bkif))
            (not (= ?bkig ?bkie))
            )
          (not (= ?bkif ?bkie))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkih Real)
      (declare-const ?bkii Real)
      (declare-const ?bkij Real)
      (assert
        (and (and (not (= ?bkij ?bkii))
            (not (= ?bkij ?bkih))
            )
          (not (= ?bkii ?bkih))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bkik Real)
    (declare-const ?bkil Real)
    (declare-const ?bkim Real)
    (push 1)
      (declare-const ?bkin Real)
      (declare-const ?bkio Real)
      (declare-const ?bkip Real)
      (declare-const ?bkiq Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkio ?bkin)
                  (= ?bkio ?awmg)
                  )
                (= ?bkin ?awmg)
                )
              (or (or (= ?bkiq ?bkip)
                  (= ?bkiq ?awmg)
                  )
                (= ?bkip ?awmg)
                )
              )
            (and (not (= ?bkio ?bkin))
              (and (and (not (= ?bkiq ?bkip))
                  (not (= ?bkiq ?awmg))
                  )
                (not (= ?bkip ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkir Real)
      (declare-const ?bkis Real)
      (declare-const ?bkit Real)
      (declare-const ?bkiu Real)
      (declare-const ?bkiv Real)
      (declare-const ?bkiw Real)
      (assert
        (or (and (or (or (= ?bkit ?bkis)
                (= ?bkit ?bkir)
                )
              (= ?bkis ?bkir)
              )
            (or (or (= ?bkiw ?bkiv)
                (= ?bkiw ?bkiu)
                )
              (= ?bkiv ?bkiu)
              )
            )
          (and (and (and (not (= ?bkit ?bkis))
                (not (= ?bkit ?bkir))
                )
              (not (= ?bkis ?bkir))
              )
            (and (and (not (= ?bkiw ?bkiv))
                (not (= ?bkiw ?bkiu))
                )
              (not (= ?bkiv ?bkiu))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkix Real)
      (declare-const ?bkiy Real)
      (declare-const ?bkiz Real)
      (assert
        (and (and (not (= ?bkiz ?bkiy))
            (not (= ?bkiz ?bkix))
            )
          (not (= ?bkiy ?bkix))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkja Real)
      (declare-const ?bkjb Real)
      (declare-const ?bkjc Real)
      (assert
        (and (and (not (= ?bkjc ?bkjb))
            (not (= ?bkjc ?bkja))
            )
          (not (= ?bkjb ?bkja))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bkjd Real)
      (declare-const ?bkje Real)
      (declare-const ?bkjf Real)
      (declare-const ?bkjg Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkje ?bkjd)
                  (= ?bkje ?awmg)
                  )
                (= ?bkjd ?awmg)
                )
              (or (or (= ?bkjg ?bkjf)
                  (= ?bkjg ?awmg)
                  )
                (= ?bkjf ?awmg)
                )
              )
            (and (not (= ?bkje ?bkjd))
              (and (and (not (= ?bkjg ?bkjf))
                  (not (= ?bkjg ?awmg))
                  )
                (not (= ?bkjf ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkjh Real)
      (declare-const ?bkji Real)
      (declare-const ?bkjj Real)
      (declare-const ?bkjk Real)
      (declare-const ?bkjl Real)
      (declare-const ?bkjm Real)
      (assert
        (or (and (or (or (= ?bkjj ?bkji)
                (= ?bkjj ?bkjh)
                )
              (= ?bkji ?bkjh)
              )
            (or (or (= ?bkjm ?bkjl)
                (= ?bkjm ?bkjk)
                )
              (= ?bkjl ?bkjk)
              )
            )
          (and (and (and (not (= ?bkjj ?bkji))
                (not (= ?bkjj ?bkjh))
                )
              (not (= ?bkji ?bkjh))
              )
            (and (and (not (= ?bkjm ?bkjl))
                (not (= ?bkjm ?bkjk))
                )
              (not (= ?bkjl ?bkjk))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkjn Real)
      (declare-const ?bkjo Real)
      (declare-const ?bkjp Real)
      (assert
        (and (and (not (= ?bkjp ?bkjo))
            (not (= ?bkjp ?bkjn))
            )
          (not (= ?bkjo ?bkjn))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkjq Real)
      (declare-const ?bkjr Real)
      (declare-const ?bkjs Real)
      (assert
        (and (and (not (= ?bkjs ?bkjr))
            (not (= ?bkjs ?bkjq))
            )
          (not (= ?bkjr ?bkjq))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bkjt Real)
  (declare-const ?bkju Real)
  (push 1)
    (push 1)
      (declare-const ?bkjv Real)
      (declare-const ?bkjw Real)
      (declare-const ?bkjx Real)
      (declare-const ?bkjy Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkjw ?bkjv)
                  (= ?bkjw ?awmg)
                  )
                (= ?bkjv ?awmg)
                )
              (or (or (= ?bkjy ?bkjx)
                  (= ?bkjy ?awmg)
                  )
                (= ?bkjx ?awmg)
                )
              )
            (and (not (= ?bkjw ?bkjv))
              (and (and (not (= ?bkjy ?bkjx))
                  (not (= ?bkjy ?awmg))
                  )
                (not (= ?bkjx ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkjz Real)
      (declare-const ?bkka Real)
      (declare-const ?bkkb Real)
      (declare-const ?bkkc Real)
      (declare-const ?bkkd Real)
      (declare-const ?bkke Real)
      (assert
        (or (and (or (or (= ?bkkb ?bkka)
                (= ?bkkb ?bkjz)
                )
              (= ?bkka ?bkjz)
              )
            (or (or (= ?bkke ?bkkd)
                (= ?bkke ?bkkc)
                )
              (= ?bkkd ?bkkc)
              )
            )
          (and (and (and (not (= ?bkkb ?bkka))
                (not (= ?bkkb ?bkjz))
                )
              (not (= ?bkka ?bkjz))
              )
            (and (and (not (= ?bkke ?bkkd))
                (not (= ?bkke ?bkkc))
                )
              (not (= ?bkkd ?bkkc))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkkf Real)
      (declare-const ?bkkg Real)
      (declare-const ?bkkh Real)
      (assert
        (and (and (not (= ?bkkh ?bkkg))
            (not (= ?bkkh ?bkkf))
            )
          (not (= ?bkkg ?bkkf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkki Real)
      (declare-const ?bkkj Real)
      (declare-const ?bkkk Real)
      (assert
        (and (and (not (= ?bkkk ?bkkj))
            (not (= ?bkkk ?bkki))
            )
          (not (= ?bkkj ?bkki))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bkkl Real)
    (push 1)
      (declare-const ?bkkm Real)
      (declare-const ?bkkn Real)
      (declare-const ?bkko Real)
      (declare-const ?bkkp Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkkn ?bkkm)
                  (= ?bkkn ?awmg)
                  )
                (= ?bkkm ?awmg)
                )
              (or (or (= ?bkkp ?bkko)
                  (= ?bkkp ?awmg)
                  )
                (= ?bkko ?awmg)
                )
              )
            (and (not (= ?bkkn ?bkkm))
              (and (and (not (= ?bkkp ?bkko))
                  (not (= ?bkkp ?awmg))
                  )
                (not (= ?bkko ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkkq Real)
      (declare-const ?bkkr Real)
      (declare-const ?bkks Real)
      (declare-const ?bkkt Real)
      (declare-const ?bkku Real)
      (declare-const ?bkkv Real)
      (assert
        (or (and (or (or (= ?bkks ?bkkr)
                (= ?bkks ?bkkq)
                )
              (= ?bkkr ?bkkq)
              )
            (or (or (= ?bkkv ?bkku)
                (= ?bkkv ?bkkt)
                )
              (= ?bkku ?bkkt)
              )
            )
          (and (and (and (not (= ?bkks ?bkkr))
                (not (= ?bkks ?bkkq))
                )
              (not (= ?bkkr ?bkkq))
              )
            (and (and (not (= ?bkkv ?bkku))
                (not (= ?bkkv ?bkkt))
                )
              (not (= ?bkku ?bkkt))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkkw Real)
      (declare-const ?bkkx Real)
      (declare-const ?bkky Real)
      (assert
        (and (and (not (= ?bkky ?bkkx))
            (not (= ?bkky ?bkkw))
            )
          (not (= ?bkkx ?bkkw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkkz Real)
      (declare-const ?bkla Real)
      (declare-const ?bklb Real)
      (assert
        (and (and (not (= ?bklb ?bkla))
            (not (= ?bklb ?bkkz))
            )
          (not (= ?bkla ?bkkz))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bklc Real)
    (declare-const ?bkld Real)
    (push 1)
      (declare-const ?bkle Real)
      (declare-const ?bklf Real)
      (declare-const ?bklg Real)
      (declare-const ?bklh Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bklf ?bkle)
                  (= ?bklf ?awmg)
                  )
                (= ?bkle ?awmg)
                )
              (or (or (= ?bklh ?bklg)
                  (= ?bklh ?awmg)
                  )
                (= ?bklg ?awmg)
                )
              )
            (and (not (= ?bklf ?bkle))
              (and (and (not (= ?bklh ?bklg))
                  (not (= ?bklh ?awmg))
                  )
                (not (= ?bklg ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkli Real)
      (declare-const ?bklj Real)
      (declare-const ?bklk Real)
      (declare-const ?bkll Real)
      (declare-const ?bklm Real)
      (declare-const ?bkln Real)
      (assert
        (or (and (or (or (= ?bklk ?bklj)
                (= ?bklk ?bkli)
                )
              (= ?bklj ?bkli)
              )
            (or (or (= ?bkln ?bklm)
                (= ?bkln ?bkll)
                )
              (= ?bklm ?bkll)
              )
            )
          (and (and (and (not (= ?bklk ?bklj))
                (not (= ?bklk ?bkli))
                )
              (not (= ?bklj ?bkli))
              )
            (and (and (not (= ?bkln ?bklm))
                (not (= ?bkln ?bkll))
                )
              (not (= ?bklm ?bkll))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bklo Real)
      (declare-const ?bklp Real)
      (declare-const ?bklq Real)
      (assert
        (and (and (not (= ?bklq ?bklp))
            (not (= ?bklq ?bklo))
            )
          (not (= ?bklp ?bklo))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bklr Real)
      (declare-const ?bkls Real)
      (declare-const ?bklt Real)
      (assert
        (and (and (not (= ?bklt ?bkls))
            (not (= ?bklt ?bklr))
            )
          (not (= ?bkls ?bklr))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkld ?bklc)
                  (= ?bkld ?awmg)
                  )
                (= ?bklc ?awmg)
                )
              (or (or (= ?bkju ?bkjt)
                  (= ?bkju ?awmg)
                  )
                (= ?bkjt ?awmg)
                )
              )
            (and (not (= ?bkld ?bklc))
              (and (and (not (= ?bkju ?bkjt))
                  (not (= ?bkju ?awmg))
                  )
                (not (= ?bkjt ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bklu Real)
    (declare-const ?bklv Real)
    (declare-const ?bklw Real)
    (push 1)
      (declare-const ?bklx Real)
      (declare-const ?bkly Real)
      (declare-const ?bklz Real)
      (declare-const ?bkma Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkly ?bklx)
                  (= ?bkly ?awmg)
                  )
                (= ?bklx ?awmg)
                )
              (or (or (= ?bkma ?bklz)
                  (= ?bkma ?awmg)
                  )
                (= ?bklz ?awmg)
                )
              )
            (and (not (= ?bkly ?bklx))
              (and (and (not (= ?bkma ?bklz))
                  (not (= ?bkma ?awmg))
                  )
                (not (= ?bklz ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkmb Real)
      (declare-const ?bkmc Real)
      (declare-const ?bkmd Real)
      (declare-const ?bkme Real)
      (declare-const ?bkmf Real)
      (declare-const ?bkmg Real)
      (assert
        (or (and (or (or (= ?bkmd ?bkmc)
                (= ?bkmd ?bkmb)
                )
              (= ?bkmc ?bkmb)
              )
            (or (or (= ?bkmg ?bkmf)
                (= ?bkmg ?bkme)
                )
              (= ?bkmf ?bkme)
              )
            )
          (and (and (and (not (= ?bkmd ?bkmc))
                (not (= ?bkmd ?bkmb))
                )
              (not (= ?bkmc ?bkmb))
              )
            (and (and (not (= ?bkmg ?bkmf))
                (not (= ?bkmg ?bkme))
                )
              (not (= ?bkmf ?bkme))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkmh Real)
      (declare-const ?bkmi Real)
      (declare-const ?bkmj Real)
      (assert
        (and (and (not (= ?bkmj ?bkmi))
            (not (= ?bkmj ?bkmh))
            )
          (not (= ?bkmi ?bkmh))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkmk Real)
      (declare-const ?bkml Real)
      (declare-const ?bkmm Real)
      (assert
        (and (and (not (= ?bkmm ?bkml))
            (not (= ?bkmm ?bkmk))
            )
          (not (= ?bkml ?bkmk))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bkmn Real)
      (declare-const ?bkmo Real)
      (declare-const ?bkmp Real)
      (declare-const ?bkmq Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkmo ?bkmn)
                  (= ?bkmo ?awmg)
                  )
                (= ?bkmn ?awmg)
                )
              (or (or (= ?bkmq ?bkmp)
                  (= ?bkmq ?awmg)
                  )
                (= ?bkmp ?awmg)
                )
              )
            (and (not (= ?bkmo ?bkmn))
              (and (and (not (= ?bkmq ?bkmp))
                  (not (= ?bkmq ?awmg))
                  )
                (not (= ?bkmp ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkmr Real)
      (declare-const ?bkms Real)
      (declare-const ?bkmt Real)
      (declare-const ?bkmu Real)
      (declare-const ?bkmv Real)
      (declare-const ?bkmw Real)
      (assert
        (or (and (or (or (= ?bkmt ?bkms)
                (= ?bkmt ?bkmr)
                )
              (= ?bkms ?bkmr)
              )
            (or (or (= ?bkmw ?bkmv)
                (= ?bkmw ?bkmu)
                )
              (= ?bkmv ?bkmu)
              )
            )
          (and (and (and (not (= ?bkmt ?bkms))
                (not (= ?bkmt ?bkmr))
                )
              (not (= ?bkms ?bkmr))
              )
            (and (and (not (= ?bkmw ?bkmv))
                (not (= ?bkmw ?bkmu))
                )
              (not (= ?bkmv ?bkmu))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkmx Real)
      (declare-const ?bkmy Real)
      (declare-const ?bkmz Real)
      (assert
        (and (and (not (= ?bkmz ?bkmy))
            (not (= ?bkmz ?bkmx))
            )
          (not (= ?bkmy ?bkmx))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkna Real)
      (declare-const ?bknb Real)
      (declare-const ?bknc Real)
      (assert
        (and (and (not (= ?bknc ?bknb))
            (not (= ?bknc ?bkna))
            )
          (not (= ?bknb ?bkna))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bknd Real)
    (declare-const ?bkne Real)
    (assert
      (forall ((?awmg Real) )(or (and (or (or (= ?bkne ?bknd)
                (= ?bkne ?awmg)
                )
              (= ?bknd ?awmg)
              )
            (or (or (= ?bkju ?bkjt)
                (= ?bkju ?awmg)
                )
              (= ?bkjt ?awmg)
              )
            )
          (and (not (= ?bkne ?bknd))
            (and (and (not (= ?bkju ?bkjt))
                (not (= ?bkju ?awmg))
                )
              (not (= ?bkjt ?awmg))
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bknf Real)
  (declare-const ?bkng Real)
  (declare-const ?bknh Real)
  (push 1)
    (push 1)
      (declare-const ?bkni Real)
      (declare-const ?bknj Real)
      (declare-const ?bknk Real)
      (declare-const ?bknl Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bknj ?bkni)
                  (= ?bknj ?awmg)
                  )
                (= ?bkni ?awmg)
                )
              (or (or (= ?bknl ?bknk)
                  (= ?bknl ?awmg)
                  )
                (= ?bknk ?awmg)
                )
              )
            (and (not (= ?bknj ?bkni))
              (and (and (not (= ?bknl ?bknk))
                  (not (= ?bknl ?awmg))
                  )
                (not (= ?bknk ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bknm Real)
      (declare-const ?bknn Real)
      (declare-const ?bkno Real)
      (declare-const ?bknp Real)
      (declare-const ?bknq Real)
      (declare-const ?bknr Real)
      (assert
        (or (and (or (or (= ?bkno ?bknn)
                (= ?bkno ?bknm)
                )
              (= ?bknn ?bknm)
              )
            (or (or (= ?bknr ?bknq)
                (= ?bknr ?bknp)
                )
              (= ?bknq ?bknp)
              )
            )
          (and (and (and (not (= ?bkno ?bknn))
                (not (= ?bkno ?bknm))
                )
              (not (= ?bknn ?bknm))
              )
            (and (and (not (= ?bknr ?bknq))
                (not (= ?bknr ?bknp))
                )
              (not (= ?bknq ?bknp))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkns Real)
      (declare-const ?bknt Real)
      (declare-const ?bknu Real)
      (assert
        (and (and (not (= ?bknu ?bknt))
            (not (= ?bknu ?bkns))
            )
          (not (= ?bknt ?bkns))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bknv Real)
      (declare-const ?bknw Real)
      (declare-const ?bknx Real)
      (assert
        (and (and (not (= ?bknx ?bknw))
            (not (= ?bknx ?bknv))
            )
          (not (= ?bknw ?bknv))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bkny Real)
    (push 1)
      (declare-const ?bknz Real)
      (declare-const ?bkoa Real)
      (declare-const ?bkob Real)
      (declare-const ?bkoc Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkoa ?bknz)
                  (= ?bkoa ?awmg)
                  )
                (= ?bknz ?awmg)
                )
              (or (or (= ?bkoc ?bkob)
                  (= ?bkoc ?awmg)
                  )
                (= ?bkob ?awmg)
                )
              )
            (and (not (= ?bkoa ?bknz))
              (and (and (not (= ?bkoc ?bkob))
                  (not (= ?bkoc ?awmg))
                  )
                (not (= ?bkob ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkod Real)
      (declare-const ?bkoe Real)
      (declare-const ?bkof Real)
      (declare-const ?bkog Real)
      (declare-const ?bkoh Real)
      (declare-const ?bkoi Real)
      (assert
        (or (and (or (or (= ?bkof ?bkoe)
                (= ?bkof ?bkod)
                )
              (= ?bkoe ?bkod)
              )
            (or (or (= ?bkoi ?bkoh)
                (= ?bkoi ?bkog)
                )
              (= ?bkoh ?bkog)
              )
            )
          (and (and (and (not (= ?bkof ?bkoe))
                (not (= ?bkof ?bkod))
                )
              (not (= ?bkoe ?bkod))
              )
            (and (and (not (= ?bkoi ?bkoh))
                (not (= ?bkoi ?bkog))
                )
              (not (= ?bkoh ?bkog))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkoj Real)
      (declare-const ?bkok Real)
      (declare-const ?bkol Real)
      (assert
        (and (and (not (= ?bkol ?bkok))
            (not (= ?bkol ?bkoj))
            )
          (not (= ?bkok ?bkoj))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkom Real)
      (declare-const ?bkon Real)
      (declare-const ?bkoo Real)
      (assert
        (and (and (not (= ?bkoo ?bkon))
            (not (= ?bkoo ?bkom))
            )
          (not (= ?bkon ?bkom))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bkop Real)
    (declare-const ?bkoq Real)
    (push 1)
      (declare-const ?bkor Real)
      (declare-const ?bkos Real)
      (declare-const ?bkot Real)
      (declare-const ?bkou Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkos ?bkor)
                  (= ?bkos ?awmg)
                  )
                (= ?bkor ?awmg)
                )
              (or (or (= ?bkou ?bkot)
                  (= ?bkou ?awmg)
                  )
                (= ?bkot ?awmg)
                )
              )
            (and (not (= ?bkos ?bkor))
              (and (and (not (= ?bkou ?bkot))
                  (not (= ?bkou ?awmg))
                  )
                (not (= ?bkot ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkov Real)
      (declare-const ?bkow Real)
      (declare-const ?bkox Real)
      (declare-const ?bkoy Real)
      (declare-const ?bkoz Real)
      (declare-const ?bkpa Real)
      (assert
        (or (and (or (or (= ?bkox ?bkow)
                (= ?bkox ?bkov)
                )
              (= ?bkow ?bkov)
              )
            (or (or (= ?bkpa ?bkoz)
                (= ?bkpa ?bkoy)
                )
              (= ?bkoz ?bkoy)
              )
            )
          (and (and (and (not (= ?bkox ?bkow))
                (not (= ?bkox ?bkov))
                )
              (not (= ?bkow ?bkov))
              )
            (and (and (not (= ?bkpa ?bkoz))
                (not (= ?bkpa ?bkoy))
                )
              (not (= ?bkoz ?bkoy))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkpb Real)
      (declare-const ?bkpc Real)
      (declare-const ?bkpd Real)
      (assert
        (and (and (not (= ?bkpd ?bkpc))
            (not (= ?bkpd ?bkpb))
            )
          (not (= ?bkpc ?bkpb))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkpe Real)
      (declare-const ?bkpf Real)
      (declare-const ?bkpg Real)
      (assert
        (and (and (not (= ?bkpg ?bkpf))
            (not (= ?bkpg ?bkpe))
            )
          (not (= ?bkpf ?bkpe))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bkph Real)
    (declare-const ?bkpi Real)
    (declare-const ?bkpj Real)
    (push 1)
      (declare-const ?bkpk Real)
      (declare-const ?bkpl Real)
      (declare-const ?bkpm Real)
      (declare-const ?bkpn Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkpl ?bkpk)
                  (= ?bkpl ?awmg)
                  )
                (= ?bkpk ?awmg)
                )
              (or (or (= ?bkpn ?bkpm)
                  (= ?bkpn ?awmg)
                  )
                (= ?bkpm ?awmg)
                )
              )
            (and (not (= ?bkpl ?bkpk))
              (and (and (not (= ?bkpn ?bkpm))
                  (not (= ?bkpn ?awmg))
                  )
                (not (= ?bkpm ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkpo Real)
      (declare-const ?bkpp Real)
      (declare-const ?bkpq Real)
      (declare-const ?bkpr Real)
      (declare-const ?bkps Real)
      (declare-const ?bkpt Real)
      (assert
        (or (and (or (or (= ?bkpq ?bkpp)
                (= ?bkpq ?bkpo)
                )
              (= ?bkpp ?bkpo)
              )
            (or (or (= ?bkpt ?bkps)
                (= ?bkpt ?bkpr)
                )
              (= ?bkps ?bkpr)
              )
            )
          (and (and (and (not (= ?bkpq ?bkpp))
                (not (= ?bkpq ?bkpo))
                )
              (not (= ?bkpp ?bkpo))
              )
            (and (and (not (= ?bkpt ?bkps))
                (not (= ?bkpt ?bkpr))
                )
              (not (= ?bkps ?bkpr))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkpu Real)
      (declare-const ?bkpv Real)
      (declare-const ?bkpw Real)
      (assert
        (and (and (not (= ?bkpw ?bkpv))
            (not (= ?bkpw ?bkpu))
            )
          (not (= ?bkpv ?bkpu))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkpx Real)
      (declare-const ?bkpy Real)
      (declare-const ?bkpz Real)
      (assert
        (and (and (not (= ?bkpz ?bkpy))
            (not (= ?bkpz ?bkpx))
            )
          (not (= ?bkpy ?bkpx))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (or (and (or (or (= ?bkpj ?bkpi)
                (= ?bkpj ?bkph)
                )
              (= ?bkpi ?bkph)
              )
            (or (or (= ?bknh ?bkng)
                (= ?bknh ?bknf)
                )
              (= ?bkng ?bknf)
              )
            )
          (and (and (and (not (= ?bkpj ?bkpi))
                (not (= ?bkpj ?bkph))
                )
              (not (= ?bkpi ?bkph))
              )
            (and (and (not (= ?bknh ?bkng))
                (not (= ?bknh ?bknf))
                )
              (not (= ?bkng ?bknf))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bkqa Real)
      (declare-const ?bkqb Real)
      (declare-const ?bkqc Real)
      (declare-const ?bkqd Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkqb ?bkqa)
                  (= ?bkqb ?awmg)
                  )
                (= ?bkqa ?awmg)
                )
              (or (or (= ?bkqd ?bkqc)
                  (= ?bkqd ?awmg)
                  )
                (= ?bkqc ?awmg)
                )
              )
            (and (not (= ?bkqb ?bkqa))
              (and (and (not (= ?bkqd ?bkqc))
                  (not (= ?bkqd ?awmg))
                  )
                (not (= ?bkqc ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkqe Real)
      (declare-const ?bkqf Real)
      (declare-const ?bkqg Real)
      (declare-const ?bkqh Real)
      (declare-const ?bkqi Real)
      (declare-const ?bkqj Real)
      (assert
        (or (and (or (or (= ?bkqg ?bkqf)
                (= ?bkqg ?bkqe)
                )
              (= ?bkqf ?bkqe)
              )
            (or (or (= ?bkqj ?bkqi)
                (= ?bkqj ?bkqh)
                )
              (= ?bkqi ?bkqh)
              )
            )
          (and (and (and (not (= ?bkqg ?bkqf))
                (not (= ?bkqg ?bkqe))
                )
              (not (= ?bkqf ?bkqe))
              )
            (and (and (not (= ?bkqj ?bkqi))
                (not (= ?bkqj ?bkqh))
                )
              (not (= ?bkqi ?bkqh))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkqk Real)
      (declare-const ?bkql Real)
      (declare-const ?bkqm Real)
      (assert
        (and (and (not (= ?bkqm ?bkql))
            (not (= ?bkqm ?bkqk))
            )
          (not (= ?bkql ?bkqk))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkqn Real)
      (declare-const ?bkqo Real)
      (declare-const ?bkqp Real)
      (assert
        (and (and (not (= ?bkqp ?bkqo))
            (not (= ?bkqp ?bkqn))
            )
          (not (= ?bkqo ?bkqn))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (and (and (not (= ?bknh ?bkng))
            (not (= ?bknh ?bknf))
            )
          (not (= ?bkng ?bknf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bkqq Real)
    (declare-const ?bkqr Real)
    (declare-const ?bkqs Real)
    (assert
      (or (and (or (or (= ?bkqs ?bkqr)
              (= ?bkqs ?bkqq)
              )
            (= ?bkqr ?bkqq)
            )
          (or (or (= ?bknh ?bkng)
              (= ?bknh ?bknf)
              )
            (= ?bkng ?bknf)
            )
          )
        (and (and (and (not (= ?bkqs ?bkqr))
              (not (= ?bkqs ?bkqq))
              )
            (not (= ?bkqr ?bkqq))
            )
          (and (and (not (= ?bknh ?bkng))
              (not (= ?bknh ?bknf))
              )
            (not (= ?bkng ?bknf))
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (push 1)
    (assert
      (and (and (not (= ?bknh ?bkng))
          (not (= ?bknh ?bknf))
          )
        (not (= ?bkng ?bknf))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (push 1)
      (declare-const ?bkqt Real)
      (declare-const ?bkqu Real)
      (declare-const ?bkqv Real)
      (declare-const ?bkqw Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkqu ?bkqt)
                  (= ?bkqu ?awmg)
                  )
                (= ?bkqt ?awmg)
                )
              (or (or (= ?bkqw ?bkqv)
                  (= ?bkqw ?awmg)
                  )
                (= ?bkqv ?awmg)
                )
              )
            (and (not (= ?bkqu ?bkqt))
              (and (and (not (= ?bkqw ?bkqv))
                  (not (= ?bkqw ?awmg))
                  )
                (not (= ?bkqv ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkqx Real)
      (declare-const ?bkqy Real)
      (declare-const ?bkqz Real)
      (declare-const ?bkra Real)
      (declare-const ?bkrb Real)
      (declare-const ?bkrc Real)
      (assert
        (or (and (or (or (= ?bkqz ?bkqy)
                (= ?bkqz ?bkqx)
                )
              (= ?bkqy ?bkqx)
              )
            (or (or (= ?bkrc ?bkrb)
                (= ?bkrc ?bkra)
                )
              (= ?bkrb ?bkra)
              )
            )
          (and (and (and (not (= ?bkqz ?bkqy))
                (not (= ?bkqz ?bkqx))
                )
              (not (= ?bkqy ?bkqx))
              )
            (and (and (not (= ?bkrc ?bkrb))
                (not (= ?bkrc ?bkra))
                )
              (not (= ?bkrb ?bkra))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkrd Real)
      (declare-const ?bkre Real)
      (declare-const ?bkrf Real)
      (assert
        (and (and (not (= ?bkrf ?bkre))
            (not (= ?bkrf ?bkrd))
            )
          (not (= ?bkre ?bkrd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkrg Real)
      (declare-const ?bkrh Real)
      (declare-const ?bkri Real)
      (assert
        (and (and (not (= ?bkri ?bkrh))
            (not (= ?bkri ?bkrg))
            )
          (not (= ?bkrh ?bkrg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bkrj Real)
    (push 1)
      (declare-const ?bkrk Real)
      (declare-const ?bkrl Real)
      (declare-const ?bkrm Real)
      (declare-const ?bkrn Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkrl ?bkrk)
                  (= ?bkrl ?awmg)
                  )
                (= ?bkrk ?awmg)
                )
              (or (or (= ?bkrn ?bkrm)
                  (= ?bkrn ?awmg)
                  )
                (= ?bkrm ?awmg)
                )
              )
            (and (not (= ?bkrl ?bkrk))
              (and (and (not (= ?bkrn ?bkrm))
                  (not (= ?bkrn ?awmg))
                  )
                (not (= ?bkrm ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkro Real)
      (declare-const ?bkrp Real)
      (declare-const ?bkrq Real)
      (declare-const ?bkrr Real)
      (declare-const ?bkrs Real)
      (declare-const ?bkrt Real)
      (assert
        (or (and (or (or (= ?bkrq ?bkrp)
                (= ?bkrq ?bkro)
                )
              (= ?bkrp ?bkro)
              )
            (or (or (= ?bkrt ?bkrs)
                (= ?bkrt ?bkrr)
                )
              (= ?bkrs ?bkrr)
              )
            )
          (and (and (and (not (= ?bkrq ?bkrp))
                (not (= ?bkrq ?bkro))
                )
              (not (= ?bkrp ?bkro))
              )
            (and (and (not (= ?bkrt ?bkrs))
                (not (= ?bkrt ?bkrr))
                )
              (not (= ?bkrs ?bkrr))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkru Real)
      (declare-const ?bkrv Real)
      (declare-const ?bkrw Real)
      (assert
        (and (and (not (= ?bkrw ?bkrv))
            (not (= ?bkrw ?bkru))
            )
          (not (= ?bkrv ?bkru))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkrx Real)
      (declare-const ?bkry Real)
      (declare-const ?bkrz Real)
      (assert
        (and (and (not (= ?bkrz ?bkry))
            (not (= ?bkrz ?bkrx))
            )
          (not (= ?bkry ?bkrx))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bksa Real)
    (declare-const ?bksb Real)
    (push 1)
      (declare-const ?bksc Real)
      (declare-const ?bksd Real)
      (declare-const ?bkse Real)
      (declare-const ?bksf Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bksd ?bksc)
                  (= ?bksd ?awmg)
                  )
                (= ?bksc ?awmg)
                )
              (or (or (= ?bksf ?bkse)
                  (= ?bksf ?awmg)
                  )
                (= ?bkse ?awmg)
                )
              )
            (and (not (= ?bksd ?bksc))
              (and (and (not (= ?bksf ?bkse))
                  (not (= ?bksf ?awmg))
                  )
                (not (= ?bkse ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bksg Real)
      (declare-const ?bksh Real)
      (declare-const ?bksi Real)
      (declare-const ?bksj Real)
      (declare-const ?bksk Real)
      (declare-const ?bksl Real)
      (assert
        (or (and (or (or (= ?bksi ?bksh)
                (= ?bksi ?bksg)
                )
              (= ?bksh ?bksg)
              )
            (or (or (= ?bksl ?bksk)
                (= ?bksl ?bksj)
                )
              (= ?bksk ?bksj)
              )
            )
          (and (and (and (not (= ?bksi ?bksh))
                (not (= ?bksi ?bksg))
                )
              (not (= ?bksh ?bksg))
              )
            (and (and (not (= ?bksl ?bksk))
                (not (= ?bksl ?bksj))
                )
              (not (= ?bksk ?bksj))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bksm Real)
      (declare-const ?bksn Real)
      (declare-const ?bkso Real)
      (assert
        (and (and (not (= ?bkso ?bksn))
            (not (= ?bkso ?bksm))
            )
          (not (= ?bksn ?bksm))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bksp Real)
      (declare-const ?bksq Real)
      (declare-const ?bksr Real)
      (assert
        (and (and (not (= ?bksr ?bksq))
            (not (= ?bksr ?bksp))
            )
          (not (= ?bksq ?bksp))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bkss Real)
    (declare-const ?bkst Real)
    (declare-const ?bksu Real)
    (push 1)
      (declare-const ?bksv Real)
      (declare-const ?bksw Real)
      (declare-const ?bksx Real)
      (declare-const ?bksy Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bksw ?bksv)
                  (= ?bksw ?awmg)
                  )
                (= ?bksv ?awmg)
                )
              (or (or (= ?bksy ?bksx)
                  (= ?bksy ?awmg)
                  )
                (= ?bksx ?awmg)
                )
              )
            (and (not (= ?bksw ?bksv))
              (and (and (not (= ?bksy ?bksx))
                  (not (= ?bksy ?awmg))
                  )
                (not (= ?bksx ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bksz Real)
      (declare-const ?bkta Real)
      (declare-const ?bktb Real)
      (declare-const ?bktc Real)
      (declare-const ?bktd Real)
      (declare-const ?bkte Real)
      (assert
        (or (and (or (or (= ?bktb ?bkta)
                (= ?bktb ?bksz)
                )
              (= ?bkta ?bksz)
              )
            (or (or (= ?bkte ?bktd)
                (= ?bkte ?bktc)
                )
              (= ?bktd ?bktc)
              )
            )
          (and (and (and (not (= ?bktb ?bkta))
                (not (= ?bktb ?bksz))
                )
              (not (= ?bkta ?bksz))
              )
            (and (and (not (= ?bkte ?bktd))
                (not (= ?bkte ?bktc))
                )
              (not (= ?bktd ?bktc))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bktf Real)
      (declare-const ?bktg Real)
      (declare-const ?bkth Real)
      (assert
        (and (and (not (= ?bkth ?bktg))
            (not (= ?bkth ?bktf))
            )
          (not (= ?bktg ?bktf))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkti Real)
      (declare-const ?bktj Real)
      (declare-const ?bktk Real)
      (assert
        (and (and (not (= ?bktk ?bktj))
            (not (= ?bktk ?bkti))
            )
          (not (= ?bktj ?bkti))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (assert
        (and (and (not (= ?bksu ?bkst))
            (not (= ?bksu ?bkss))
            )
          (not (= ?bkst ?bkss))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (push 1)
      (declare-const ?bktl Real)
      (declare-const ?bktm Real)
      (declare-const ?bktn Real)
      (declare-const ?bkto Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bktm ?bktl)
                  (= ?bktm ?awmg)
                  )
                (= ?bktl ?awmg)
                )
              (or (or (= ?bkto ?bktn)
                  (= ?bkto ?awmg)
                  )
                (= ?bktn ?awmg)
                )
              )
            (and (not (= ?bktm ?bktl))
              (and (and (not (= ?bkto ?bktn))
                  (not (= ?bkto ?awmg))
                  )
                (not (= ?bktn ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bktp Real)
      (declare-const ?bktq Real)
      (declare-const ?bktr Real)
      (declare-const ?bkts Real)
      (declare-const ?bktt Real)
      (declare-const ?bktu Real)
      (assert
        (or (and (or (or (= ?bktr ?bktq)
                (= ?bktr ?bktp)
                )
              (= ?bktq ?bktp)
              )
            (or (or (= ?bktu ?bktt)
                (= ?bktu ?bkts)
                )
              (= ?bktt ?bkts)
              )
            )
          (and (and (and (not (= ?bktr ?bktq))
                (not (= ?bktr ?bktp))
                )
              (not (= ?bktq ?bktp))
              )
            (and (and (not (= ?bktu ?bktt))
                (not (= ?bktu ?bkts))
                )
              (not (= ?bktt ?bkts))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bktv Real)
      (declare-const ?bktw Real)
      (declare-const ?bktx Real)
      (assert
        (and (and (not (= ?bktx ?bktw))
            (not (= ?bktx ?bktv))
            )
          (not (= ?bktw ?bktv))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (push 1)
      (declare-const ?bkty Real)
      (declare-const ?bktz Real)
      (declare-const ?bkua Real)
      (assert
        (and (and (not (= ?bkua ?bktz))
            (not (= ?bkua ?bkty))
            )
          (not (= ?bktz ?bkty))
          )
        )
(set-info :status unknown)
      (check-sat)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bkub Real)
    (declare-const ?bkuc Real)
    (declare-const ?bkud Real)
    (assert
      (and (and (not (= ?bkud ?bkuc))
          (not (= ?bkud ?bkub))
          )
        (not (= ?bkuc ?bkub))
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bkue Real)
  (declare-const ?bkuf Real)
  (push 1)
    (push 1)
      (push 1)
        (declare-const ?bkug Real)
        (declare-const ?bkuh Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bkuh ?bkug)
                    (= ?bkuh ?awmg)
                    )
                  (= ?bkug ?awmg)
                  )
                (or (or (= ?bkuf ?bkue)
                    (= ?bkuf ?awmg)
                    )
                  (= ?bkue ?awmg)
                  )
                )
              (and (not (= ?bkuh ?bkug))
                (and (and (not (= ?bkuf ?bkue))
                    (not (= ?bkuf ?awmg))
                    )
                  (not (= ?bkue ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bkui Real)
      (declare-const ?bkuj Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkuj ?bkui)
                  (= ?bkuj ?awmg)
                  )
                (= ?bkui ?awmg)
                )
              (or (or (= ?bkuf ?bkue)
                  (= ?bkuf ?awmg)
                  )
                (= ?bkue ?awmg)
                )
              )
            (and (not (= ?bkuj ?bkui))
              (and (and (not (= ?bkuf ?bkue))
                  (not (= ?bkuf ?awmg))
                  )
                (not (= ?bkue ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bkuk Real)
    (push 1)
      (push 1)
        (declare-const ?bkul Real)
        (declare-const ?bkum Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bkum ?bkul)
                    (= ?bkum ?awmg)
                    )
                  (= ?bkul ?awmg)
                  )
                (or (or (= ?bkuf ?bkue)
                    (= ?bkuf ?awmg)
                    )
                  (= ?bkue ?awmg)
                  )
                )
              (and (not (= ?bkum ?bkul))
                (and (and (not (= ?bkuf ?bkue))
                    (not (= ?bkuf ?awmg))
                    )
                  (not (= ?bkue ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bkun Real)
      (declare-const ?bkuo Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkuo ?bkun)
                  (= ?bkuo ?awmg)
                  )
                (= ?bkun ?awmg)
                )
              (or (or (= ?bkuf ?bkue)
                  (= ?bkuf ?awmg)
                  )
                (= ?bkue ?awmg)
                )
              )
            (and (not (= ?bkuo ?bkun))
              (and (and (not (= ?bkuf ?bkue))
                  (not (= ?bkuf ?awmg))
                  )
                (not (= ?bkue ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (pop 1)
(push 1)
  (declare-const ?bkup Real)
  (declare-const ?bkuq Real)
  (declare-const ?bkur Real)
  (push 1)
    (push 1)
      (push 1)
        (declare-const ?bkus Real)
        (declare-const ?bkut Real)
        (declare-const ?bkuu Real)
        (assert
          (or (and (or (or (= ?bkuu ?bkut)
                  (= ?bkuu ?bkus)
                  )
                (= ?bkut ?bkus)
                )
              (or (or (= ?bkur ?bkuq)
                  (= ?bkur ?bkup)
                  )
                (= ?bkuq ?bkup)
                )
              )
            (and (and (and (not (= ?bkuu ?bkut))
                  (not (= ?bkuu ?bkus))
                  )
                (not (= ?bkut ?bkus))
                )
              (and (and (not (= ?bkur ?bkuq))
                  (not (= ?bkur ?bkup))
                  )
                (not (= ?bkuq ?bkup))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?bkur ?bkuq))
              (not (= ?bkur ?bkup))
              )
            (not (= ?bkuq ?bkup))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bkuv Real)
      (declare-const ?bkuw Real)
      (declare-const ?bkux Real)
      (assert
        (or (and (or (or (= ?bkux ?bkuw)
                (= ?bkux ?bkuv)
                )
              (= ?bkuw ?bkuv)
              )
            (or (or (= ?bkur ?bkuq)
                (= ?bkur ?bkup)
                )
              (= ?bkuq ?bkup)
              )
            )
          (and (and (and (not (= ?bkux ?bkuw))
                (not (= ?bkux ?bkuv))
                )
              (not (= ?bkuw ?bkuv))
              )
            (and (and (not (= ?bkur ?bkuq))
                (not (= ?bkur ?bkup))
                )
              (not (= ?bkuq ?bkup))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (assert
        (and (and (not (= ?bkur ?bkuq))
            (not (= ?bkur ?bkup))
            )
          (not (= ?bkuq ?bkup))
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bkuy Real)
    (push 1)
      (push 1)
        (declare-const ?bkuz Real)
        (declare-const ?bkva Real)
        (declare-const ?bkvb Real)
        (assert
          (or (and (or (or (= ?bkvb ?bkva)
                  (= ?bkvb ?bkuz)
                  )
                (= ?bkva ?bkuz)
                )
              (or (or (= ?bkur ?bkuq)
                  (= ?bkur ?bkup)
                  )
                (= ?bkuq ?bkup)
                )
              )
            (and (and (and (not (= ?bkvb ?bkva))
                  (not (= ?bkvb ?bkuz))
                  )
                (not (= ?bkva ?bkuz))
                )
              (and (and (not (= ?bkur ?bkuq))
                  (not (= ?bkur ?bkup))
                  )
                (not (= ?bkuq ?bkup))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?bkur ?bkuq))
              (not (= ?bkur ?bkup))
              )
            (not (= ?bkuq ?bkup))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bkvc Real)
      (declare-const ?bkvd Real)
      (declare-const ?bkve Real)
      (assert
        (or (and (or (or (= ?bkve ?bkvd)
                (= ?bkve ?bkvc)
                )
              (= ?bkvd ?bkvc)
              )
            (or (or (= ?bkur ?bkuq)
                (= ?bkur ?bkup)
                )
              (= ?bkuq ?bkup)
              )
            )
          (and (and (and (not (= ?bkve ?bkvd))
                (not (= ?bkve ?bkvc))
                )
              (not (= ?bkvd ?bkvc))
              )
            (and (and (not (= ?bkur ?bkuq))
                (not (= ?bkur ?bkup))
                )
              (not (= ?bkuq ?bkup))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (assert
        (and (and (not (= ?bkur ?bkuq))
            (not (= ?bkur ?bkup))
            )
          (not (= ?bkuq ?bkup))
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bkvf Real)
    (declare-const ?bkvg Real)
    (push 1)
      (declare-const ?bkvh Real)
      (declare-const ?bkvi Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkvi ?bkvh)
                  (= ?bkvi ?awmg)
                  )
                (= ?bkvh ?awmg)
                )
              (or (or (= ?bkvg ?bkvf)
                  (= ?bkvg ?awmg)
                  )
                (= ?bkvf ?awmg)
                )
              )
            (and (not (= ?bkvi ?bkvh))
              (and (and (not (= ?bkvg ?bkvf))
                  (not (= ?bkvg ?awmg))
                  )
                (not (= ?bkvf ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bkvj Real)
        (declare-const ?bkvk Real)
        (declare-const ?bkvl Real)
        (assert
          (or (and (or (or (= ?bkvl ?bkvk)
                  (= ?bkvl ?bkvj)
                  )
                (= ?bkvk ?bkvj)
                )
              (or (or (= ?bkur ?bkuq)
                  (= ?bkur ?bkup)
                  )
                (= ?bkuq ?bkup)
                )
              )
            (and (and (and (not (= ?bkvl ?bkvk))
                  (not (= ?bkvl ?bkvj))
                  )
                (not (= ?bkvk ?bkvj))
                )
              (and (and (not (= ?bkur ?bkuq))
                  (not (= ?bkur ?bkup))
                  )
                (not (= ?bkuq ?bkup))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?bkur ?bkuq))
              (not (= ?bkur ?bkup))
              )
            (not (= ?bkuq ?bkup))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bkvm Real)
      (declare-const ?bkvn Real)
      (declare-const ?bkvo Real)
      (assert
        (or (and (or (or (= ?bkvo ?bkvn)
                (= ?bkvo ?bkvm)
                )
              (= ?bkvn ?bkvm)
              )
            (or (or (= ?bkur ?bkuq)
                (= ?bkur ?bkup)
                )
              (= ?bkuq ?bkup)
              )
            )
          (and (and (and (not (= ?bkvo ?bkvn))
                (not (= ?bkvo ?bkvm))
                )
              (not (= ?bkvn ?bkvm))
              )
            (and (and (not (= ?bkur ?bkuq))
                (not (= ?bkur ?bkup))
                )
              (not (= ?bkuq ?bkup))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bkvp Real)
        (declare-const ?bkvq Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bkvq ?bkvp)
                    (= ?bkvq ?awmg)
                    )
                  (= ?bkvp ?awmg)
                  )
                (or (or (= ?bkvg ?bkvf)
                    (= ?bkvg ?awmg)
                    )
                  (= ?bkvf ?awmg)
                  )
                )
              (and (not (= ?bkvq ?bkvp))
                (and (and (not (= ?bkvg ?bkvf))
                    (not (= ?bkvg ?awmg))
                    )
                  (not (= ?bkvf ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (assert
        (and (and (not (= ?bkur ?bkuq))
            (not (= ?bkur ?bkup))
            )
          (not (= ?bkuq ?bkup))
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bkvr Real)
        (declare-const ?bkvs Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bkvs ?bkvr)
                    (= ?bkvs ?awmg)
                    )
                  (= ?bkvr ?awmg)
                  )
                (or (or (= ?bkvg ?bkvf)
                    (= ?bkvg ?awmg)
                    )
                  (= ?bkvf ?awmg)
                  )
                )
              (and (not (= ?bkvs ?bkvr))
                (and (and (not (= ?bkvg ?bkvf))
                    (not (= ?bkvg ?awmg))
                    )
                  (not (= ?bkvf ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (assert
      (or (exists ((?bkvm Real) (?bkvn Real) (?bkvo Real) )(or (and (or (or (= ?bkvo ?bkvn)
                  (= ?bkvo ?bkvm)
                  )
                (= ?bkvn ?bkvm)
                )
              (or (or (= ?bkur ?bkuq)
                  (= ?bkur ?bkup)
                  )
                (= ?bkuq ?bkup)
                )
              )
            (and (and (and (not (= ?bkvo ?bkvn))
                  (not (= ?bkvo ?bkvm))
                  )
                (not (= ?bkvn ?bkvm))
                )
              (and (and (not (= ?bkur ?bkuq))
                  (not (= ?bkur ?bkup))
                  )
                (not (= ?bkuq ?bkup))
                )
              )
            )
          )
        (or (and (and (not (= ?bkur ?bkuq))
              (not (= ?bkur ?bkup))
              )
            (not (= ?bkuq ?bkup))
            )
          (forall ((?bkvg Real) (?bkvf Real) )(exists ((?bkvh Real) (?bkvi Real) )(forall ((?awmg Real) )(or (and (or (or (= ?bkvi ?bkvh)
                        (= ?bkvi ?awmg)
                        )
                      (= ?bkvh ?awmg)
                      )
                    (or (or (= ?bkvg ?bkvf)
                        (= ?bkvg ?awmg)
                        )
                      (= ?bkvf ?awmg)
                      )
                    )
                  (and (not (= ?bkvi ?bkvh))
                    (and (and (not (= ?bkvg ?bkvf))
                        (not (= ?bkvg ?awmg))
                        )
                      (not (= ?bkvf ?awmg))
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (pop 1)
  (pop 1)
(push 1)
  (push 1)
    (push 1)
      (push 1)
        (declare-const ?bkvt Real)
        (declare-const ?bkvu Real)
        (declare-const ?bkvv Real)
        (assert
          (and (and (not (= ?bkvv ?bkvu))
              (not (= ?bkvv ?bkvt))
              )
            (not (= ?bkvu ?bkvt))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bkvw Real)
      (declare-const ?bkvx Real)
      (declare-const ?bkvy Real)
      (assert
        (and (and (not (= ?bkvy ?bkvx))
            (not (= ?bkvy ?bkvw))
            )
          (not (= ?bkvx ?bkvw))
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bkvz Real)
    (push 1)
      (push 1)
        (declare-const ?bkwa Real)
        (declare-const ?bkwb Real)
        (declare-const ?bkwc Real)
        (assert
          (and (and (not (= ?bkwc ?bkwb))
              (not (= ?bkwc ?bkwa))
              )
            (not (= ?bkwb ?bkwa))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bkwd Real)
      (declare-const ?bkwe Real)
      (declare-const ?bkwf Real)
      (assert
        (and (and (not (= ?bkwf ?bkwe))
            (not (= ?bkwf ?bkwd))
            )
          (not (= ?bkwe ?bkwd))
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bkwg Real)
    (declare-const ?bkwh Real)
    (push 1)
      (declare-const ?bkwi Real)
      (declare-const ?bkwj Real)
      (assert
        (forall ((?awmg Real) )(or (and (or (or (= ?bkwj ?bkwi)
                  (= ?bkwj ?awmg)
                  )
                (= ?bkwi ?awmg)
                )
              (or (or (= ?bkwh ?bkwg)
                  (= ?bkwh ?awmg)
                  )
                (= ?bkwg ?awmg)
                )
              )
            (and (not (= ?bkwj ?bkwi))
              (and (and (not (= ?bkwh ?bkwg))
                  (not (= ?bkwh ?awmg))
                  )
                (not (= ?bkwg ?awmg))
                )
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bkwk Real)
        (declare-const ?bkwl Real)
        (declare-const ?bkwm Real)
        (assert
          (and (and (not (= ?bkwm ?bkwl))
              (not (= ?bkwm ?bkwk))
              )
            (not (= ?bkwl ?bkwk))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bkwn Real)
      (declare-const ?bkwo Real)
      (declare-const ?bkwp Real)
      (assert
        (and (and (not (= ?bkwp ?bkwo))
            (not (= ?bkwp ?bkwn))
            )
          (not (= ?bkwo ?bkwn))
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bkwq Real)
        (declare-const ?bkwr Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bkwr ?bkwq)
                    (= ?bkwr ?awmg)
                    )
                  (= ?bkwq ?awmg)
                  )
                (or (or (= ?bkwh ?bkwg)
                    (= ?bkwh ?awmg)
                    )
                  (= ?bkwg ?awmg)
                  )
                )
              (and (not (= ?bkwr ?bkwq))
                (and (and (not (= ?bkwh ?bkwg))
                    (not (= ?bkwh ?awmg))
                    )
                  (not (= ?bkwg ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (declare-const ?bkws Real)
        (declare-const ?bkwt Real)
        (assert
          (forall ((?awmg Real) )(or (and (or (or (= ?bkwt ?bkws)
                    (= ?bkwt ?awmg)
                    )
                  (= ?bkws ?awmg)
                  )
                (or (or (= ?bkwh ?bkwg)
                    (= ?bkwh ?awmg)
                    )
                  (= ?bkwg ?awmg)
                  )
                )
              (and (not (= ?bkwt ?bkws))
                (and (and (not (= ?bkwh ?bkwg))
                    (not (= ?bkwh ?awmg))
                    )
                  (not (= ?bkwg ?awmg))
                  )
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (declare-const ?bkwu Real)
    (declare-const ?bkwv Real)
    (declare-const ?bkww Real)
    (push 1)
      (declare-const ?bkwx Real)
      (declare-const ?bkwy Real)
      (declare-const ?bkwz Real)
      (assert
        (or (and (or (or (= ?bkwz ?bkwy)
                (= ?bkwz ?bkwx)
                )
              (= ?bkwy ?bkwx)
              )
            (or (or (= ?bkww ?bkwv)
                (= ?bkww ?bkwu)
                )
              (= ?bkwv ?bkwu)
              )
            )
          (and (and (and (not (= ?bkwz ?bkwy))
                (not (= ?bkwz ?bkwx))
                )
              (not (= ?bkwy ?bkwx))
              )
            (and (and (not (= ?bkww ?bkwv))
                (not (= ?bkww ?bkwu))
                )
              (not (= ?bkwv ?bkwu))
              )
            )
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bkxa Real)
        (declare-const ?bkxb Real)
        (declare-const ?bkxc Real)
        (assert
          (and (and (not (= ?bkxc ?bkxb))
              (not (= ?bkxc ?bkxa))
              )
            (not (= ?bkxb ?bkxa))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (assert
        (and (and (not (= ?bkww ?bkwv))
            (not (= ?bkww ?bkwu))
            )
          (not (= ?bkwv ?bkwu))
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bkxd Real)
        (declare-const ?bkxe Real)
        (declare-const ?bkxf Real)
        (assert
          (and (and (not (= ?bkxf ?bkxe))
              (not (= ?bkxf ?bkxd))
              )
            (not (= ?bkxe ?bkxd))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (declare-const ?bkxg Real)
      (declare-const ?bkxh Real)
      (declare-const ?bkxi Real)
      (assert
        (and (and (not (= ?bkxi ?bkxh))
            (not (= ?bkxi ?bkxg))
            )
          (not (= ?bkxh ?bkxg))
          )
        )
(set-info :status unknown)
      (check-sat)
      (push 1)
        (declare-const ?bkxj Real)
        (declare-const ?bkxk Real)
        (declare-const ?bkxl Real)
        (assert
          (or (and (or (or (= ?bkxl ?bkxk)
                  (= ?bkxl ?bkxj)
                  )
                (= ?bkxk ?bkxj)
                )
              (or (or (= ?bkww ?bkwv)
                  (= ?bkww ?bkwu)
                  )
                (= ?bkwv ?bkwu)
                )
              )
            (and (and (and (not (= ?bkxl ?bkxk))
                  (not (= ?bkxl ?bkxj))
                  )
                (not (= ?bkxk ?bkxj))
                )
              (and (and (not (= ?bkww ?bkwv))
                  (not (= ?bkww ?bkwu))
                  )
                (not (= ?bkwv ?bkwu))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?bkww ?bkwv))
              (not (= ?bkww ?bkwu))
              )
            (not (= ?bkwv ?bkwu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (push 1)
      (push 1)
        (declare-const ?bkxm Real)
        (declare-const ?bkxn Real)
        (declare-const ?bkxo Real)
        (assert
          (or (and (or (or (= ?bkxo ?bkxn)
                  (= ?bkxo ?bkxm)
                  )
                (= ?bkxn ?bkxm)
                )
              (or (or (= ?bkww ?bkwv)
                  (= ?bkww ?bkwu)
                  )
                (= ?bkwv ?bkwu)
                )
              )
            (and (and (and (not (= ?bkxo ?bkxn))
                  (not (= ?bkxo ?bkxm))
                  )
                (not (= ?bkxn ?bkxm))
                )
              (and (and (not (= ?bkww ?bkwv))
                  (not (= ?bkww ?bkwu))
                  )
                (not (= ?bkwv ?bkwu))
                )
              )
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (push 1)
        (assert
          (and (and (not (= ?bkww ?bkwv))
              (not (= ?bkww ?bkwu))
              )
            (not (= ?bkwv ?bkwu))
            )
          )
(set-info :status unknown)
        (check-sat)
        (pop 1)
      (pop 1)
    (pop 1)
  (push 1)
    (assert
      (forall ((?bkwv Real) (?bkwu Real) )(or (= ?bkwv ?bkwu)
          (forall ((?bkww Real) )(or (exists ((?bkxh Real) (?bkxg Real) )(and (not (= ?bkxh ?bkxg))
                  (exists ((?bkxi Real) )(and (not (= ?bkxi ?bkxh))
                      (and (not (= ?bkxi ?bkxg))
                        (and (or (and (and (not (= ?bkxi ?bkxh))
                                (not (= ?bkxi ?bkxg))
                                )
                              (not (= ?bkxh ?bkxg))
                              )
                            (and (and (not (= ?bkww ?bkwv))
                                (not (= ?bkww ?bkwu))
                                )
                              (not (= ?bkwv ?bkwu))
                              )
                            )
                          (or (or (or (= ?bkxi ?bkxh)
                                (= ?bkxi ?bkxg)
                                )
                              (= ?bkxh ?bkxg)
                              )
                            (or (or (= ?bkww ?bkwv)
                                (= ?bkww ?bkwu)
                                )
                              (= ?bkwv ?bkwu)
                              )
                            )
                          )
                        )
                      )
                    )
                  )
                )
              (or (= ?bkww ?bkwv)
                (or (= ?bkww ?bkwu)
                  (exists ((?bkwx Real) (?bkwy Real) (?bkwz Real) )(and (or (and (or (or (= ?bkwz ?bkwy)
                              (= ?bkwz ?bkwx)
                              )
                            (= ?bkwy ?bkwx)
                            )
                          (or (or (= ?bkww ?bkwv)
                              (= ?bkww ?bkwu)
                              )
                            (= ?bkwv ?bkwu)
                            )
                          )
                        (and (and (and (not (= ?bkwz ?bkwy))
                              (not (= ?bkwz ?bkwx))
                              )
                            (not (= ?bkwy ?bkwx))
                            )
                          (and (and (not (= ?bkww ?bkwv))
                              (not (= ?bkww ?bkwu))
                              )
                            (not (= ?bkwv ?bkwu))
                            )
                          )
                        )
                      (or (or (= ?bkwz ?bkwy)
                          (= ?bkwz ?bkwx)
                          )
                        (= ?bkwy ?bkwx)
                        )
                      )
                    )
                  )
                )
              )
            )
          )
        )
      )
(set-info :status unknown)
    (check-sat)
    (exit)

